/*
 * QEMU model of the PSMX_ERR_REG This is the database for the PSMX
 * Error Management Register Definitions.
 *
 * Copyright (c) 2022 Xilinx Inc.
 *
 * Autogenerated by xregqemu.py 2022-01-27.
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
 * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 */

#include "qemu/osdep.h"
#include "hw/sysbus.h"
#include "hw/register.h"
#include "qemu/bitops.h"
#include "qemu/log.h"
#include "migration/vmstate.h"

#ifndef XILINX_PSMX_ERR_REG_ERR_DEBUG
#define XILINX_PSMX_ERR_REG_ERR_DEBUG 0
#endif

#define TYPE_XILINX_PSMX_ERR_REG "xlnx.psmx_err_reg"

#define XILINX_PSMX_ERR_REG(obj) \
     OBJECT_CHECK(PSMX_ERR_REG, (obj), TYPE_XILINX_PSMX_ERR_REG)

REG32(PSM_ERR1_STATUS, 0x0)
    FIELD(PSM_ERR1_STATUS, SRC31, 31, 1)
    FIELD(PSM_ERR1_STATUS, SRC30, 30, 1)
    FIELD(PSM_ERR1_STATUS, SRC29, 29, 1)
    FIELD(PSM_ERR1_STATUS, SRC28, 28, 1)
    FIELD(PSM_ERR1_STATUS, SRC27, 27, 1)
    FIELD(PSM_ERR1_STATUS, SRC26, 26, 1)
    FIELD(PSM_ERR1_STATUS, SRC25, 25, 1)
    FIELD(PSM_ERR1_STATUS, SRC24, 24, 1)
    FIELD(PSM_ERR1_STATUS, SRC23, 23, 1)
    FIELD(PSM_ERR1_STATUS, SRC22, 22, 1)
    FIELD(PSM_ERR1_STATUS, SRC21, 21, 1)
    FIELD(PSM_ERR1_STATUS, SRC20, 20, 1)
    FIELD(PSM_ERR1_STATUS, SRC19, 19, 1)
    FIELD(PSM_ERR1_STATUS, SRC18, 18, 1)
    FIELD(PSM_ERR1_STATUS, SRC17, 17, 1)
    FIELD(PSM_ERR1_STATUS, SRC16, 16, 1)
    FIELD(PSM_ERR1_STATUS, SRC15, 15, 1)
    FIELD(PSM_ERR1_STATUS, SRC14, 14, 1)
    FIELD(PSM_ERR1_STATUS, SRC13, 13, 1)
    FIELD(PSM_ERR1_STATUS, SRC12, 12, 1)
    FIELD(PSM_ERR1_STATUS, SRC11, 11, 1)
    FIELD(PSM_ERR1_STATUS, SRC10, 10, 1)
    FIELD(PSM_ERR1_STATUS, SRC9, 9, 1)
    FIELD(PSM_ERR1_STATUS, SRC8, 8, 1)
    FIELD(PSM_ERR1_STATUS, SRC7, 7, 1)
    FIELD(PSM_ERR1_STATUS, SRC6, 6, 1)
    FIELD(PSM_ERR1_STATUS, SRC5, 5, 1)
    FIELD(PSM_ERR1_STATUS, SRC4, 4, 1)
    FIELD(PSM_ERR1_STATUS, SRC3, 3, 1)
    FIELD(PSM_ERR1_STATUS, SRC2, 2, 1)
    FIELD(PSM_ERR1_STATUS, SRC1, 1, 1)
    FIELD(PSM_ERR1_STATUS, SRC0, 0, 1)
REG32(PSM_ERR2_STATUS, 0x4)
    FIELD(PSM_ERR2_STATUS, SRC31, 31, 1)
    FIELD(PSM_ERR2_STATUS, SRC30, 30, 1)
    FIELD(PSM_ERR2_STATUS, SRC29, 29, 1)
    FIELD(PSM_ERR2_STATUS, SRC28, 28, 1)
    FIELD(PSM_ERR2_STATUS, SRC27, 27, 1)
    FIELD(PSM_ERR2_STATUS, SRC26, 26, 1)
    FIELD(PSM_ERR2_STATUS, SRC25, 25, 1)
    FIELD(PSM_ERR2_STATUS, SRC24, 24, 1)
    FIELD(PSM_ERR2_STATUS, SRC23, 23, 1)
    FIELD(PSM_ERR2_STATUS, SRC22, 22, 1)
    FIELD(PSM_ERR2_STATUS, SRC21, 21, 1)
    FIELD(PSM_ERR2_STATUS, SRC20, 20, 1)
    FIELD(PSM_ERR2_STATUS, SRC19, 19, 1)
    FIELD(PSM_ERR2_STATUS, SRC18, 18, 1)
    FIELD(PSM_ERR2_STATUS, SRC17, 17, 1)
    FIELD(PSM_ERR2_STATUS, SRC16, 16, 1)
    FIELD(PSM_ERR2_STATUS, SRC15, 15, 1)
    FIELD(PSM_ERR2_STATUS, SRC14, 14, 1)
    FIELD(PSM_ERR2_STATUS, SRC13, 13, 1)
    FIELD(PSM_ERR2_STATUS, SRC12, 12, 1)
    FIELD(PSM_ERR2_STATUS, SRC11, 11, 1)
    FIELD(PSM_ERR2_STATUS, SRC10, 10, 1)
    FIELD(PSM_ERR2_STATUS, SRC9, 9, 1)
    FIELD(PSM_ERR2_STATUS, SRC8, 8, 1)
    FIELD(PSM_ERR2_STATUS, SRC7, 7, 1)
    FIELD(PSM_ERR2_STATUS, SRC6, 6, 1)
    FIELD(PSM_ERR2_STATUS, SRC5, 5, 1)
    FIELD(PSM_ERR2_STATUS, SRC4, 4, 1)
    FIELD(PSM_ERR2_STATUS, SRC3, 3, 1)
    FIELD(PSM_ERR2_STATUS, SRC2, 2, 1)
    FIELD(PSM_ERR2_STATUS, SRC1, 1, 1)
    FIELD(PSM_ERR2_STATUS, SRC0, 0, 1)
REG32(PSM_ERR3_STATUS, 0x8)
    FIELD(PSM_ERR3_STATUS, SRC31, 31, 1)
    FIELD(PSM_ERR3_STATUS, SRC30, 30, 1)
    FIELD(PSM_ERR3_STATUS, SRC29, 29, 1)
    FIELD(PSM_ERR3_STATUS, SRC28, 28, 1)
    FIELD(PSM_ERR3_STATUS, SRC27, 27, 1)
    FIELD(PSM_ERR3_STATUS, SRC26, 26, 1)
    FIELD(PSM_ERR3_STATUS, SRC25, 25, 1)
    FIELD(PSM_ERR3_STATUS, SRC24, 24, 1)
    FIELD(PSM_ERR3_STATUS, SRC23, 23, 1)
    FIELD(PSM_ERR3_STATUS, SRC22, 22, 1)
    FIELD(PSM_ERR3_STATUS, SRC21, 21, 1)
    FIELD(PSM_ERR3_STATUS, SRC20, 20, 1)
    FIELD(PSM_ERR3_STATUS, SRC19, 19, 1)
    FIELD(PSM_ERR3_STATUS, SRC18, 18, 1)
    FIELD(PSM_ERR3_STATUS, SRC17, 17, 1)
    FIELD(PSM_ERR3_STATUS, SRC16, 16, 1)
    FIELD(PSM_ERR3_STATUS, SRC15, 15, 1)
    FIELD(PSM_ERR3_STATUS, SRC14, 14, 1)
    FIELD(PSM_ERR3_STATUS, SRC13, 13, 1)
    FIELD(PSM_ERR3_STATUS, SRC12, 12, 1)
    FIELD(PSM_ERR3_STATUS, SRC11, 11, 1)
    FIELD(PSM_ERR3_STATUS, SRC10, 10, 1)
    FIELD(PSM_ERR3_STATUS, SRC9, 9, 1)
    FIELD(PSM_ERR3_STATUS, SRC8, 8, 1)
    FIELD(PSM_ERR3_STATUS, SRC7, 7, 1)
    FIELD(PSM_ERR3_STATUS, SRC6, 6, 1)
    FIELD(PSM_ERR3_STATUS, SRC5, 5, 1)
    FIELD(PSM_ERR3_STATUS, SRC4, 4, 1)
    FIELD(PSM_ERR3_STATUS, SRC3, 3, 1)
    FIELD(PSM_ERR3_STATUS, SRC2, 2, 1)
    FIELD(PSM_ERR3_STATUS, SRC1, 1, 1)
    FIELD(PSM_ERR3_STATUS, SRC0, 0, 1)
REG32(PSM_ERR4_STATUS, 0xc)
    FIELD(PSM_ERR4_STATUS, SRC31, 31, 1)
    FIELD(PSM_ERR4_STATUS, SRC30, 30, 1)
    FIELD(PSM_ERR4_STATUS, SRC29, 29, 1)
    FIELD(PSM_ERR4_STATUS, SRC28, 28, 1)
    FIELD(PSM_ERR4_STATUS, SRC27, 27, 1)
    FIELD(PSM_ERR4_STATUS, SRC26, 26, 1)
    FIELD(PSM_ERR4_STATUS, SRC25, 25, 1)
    FIELD(PSM_ERR4_STATUS, SRC24, 24, 1)
    FIELD(PSM_ERR4_STATUS, SRC23, 23, 1)
    FIELD(PSM_ERR4_STATUS, SRC22, 22, 1)
    FIELD(PSM_ERR4_STATUS, SRC21, 21, 1)
    FIELD(PSM_ERR4_STATUS, SRC20, 20, 1)
    FIELD(PSM_ERR4_STATUS, SRC19, 19, 1)
    FIELD(PSM_ERR4_STATUS, SRC18, 18, 1)
    FIELD(PSM_ERR4_STATUS, SRC17, 17, 1)
    FIELD(PSM_ERR4_STATUS, SRC16, 16, 1)
    FIELD(PSM_ERR4_STATUS, SRC15, 15, 1)
    FIELD(PSM_ERR4_STATUS, SRC14, 14, 1)
    FIELD(PSM_ERR4_STATUS, SRC13, 13, 1)
    FIELD(PSM_ERR4_STATUS, SRC12, 12, 1)
    FIELD(PSM_ERR4_STATUS, SRC11, 11, 1)
    FIELD(PSM_ERR4_STATUS, SRC10, 10, 1)
    FIELD(PSM_ERR4_STATUS, SRC9, 9, 1)
    FIELD(PSM_ERR4_STATUS, SRC8, 8, 1)
    FIELD(PSM_ERR4_STATUS, SRC7, 7, 1)
    FIELD(PSM_ERR4_STATUS, SRC6, 6, 1)
    FIELD(PSM_ERR4_STATUS, SRC5, 5, 1)
    FIELD(PSM_ERR4_STATUS, SRC4, 4, 1)
    FIELD(PSM_ERR4_STATUS, SRC3, 3, 1)
    FIELD(PSM_ERR4_STATUS, SRC2, 2, 1)
    FIELD(PSM_ERR4_STATUS, SRC1, 1, 1)
    FIELD(PSM_ERR4_STATUS, SRC0, 0, 1)
REG32(PSM_ERR1_TRIG, 0x20)
    FIELD(PSM_ERR1_TRIG, SRC31, 31, 1)
    FIELD(PSM_ERR1_TRIG, SRC30, 30, 1)
    FIELD(PSM_ERR1_TRIG, SRC29, 29, 1)
    FIELD(PSM_ERR1_TRIG, SRC28, 28, 1)
    FIELD(PSM_ERR1_TRIG, SRC27, 27, 1)
    FIELD(PSM_ERR1_TRIG, SRC26, 26, 1)
    FIELD(PSM_ERR1_TRIG, SRC25, 25, 1)
    FIELD(PSM_ERR1_TRIG, SRC24, 24, 1)
    FIELD(PSM_ERR1_TRIG, SRC23, 23, 1)
    FIELD(PSM_ERR1_TRIG, SRC22, 22, 1)
    FIELD(PSM_ERR1_TRIG, SRC21, 21, 1)
    FIELD(PSM_ERR1_TRIG, SRC20, 20, 1)
    FIELD(PSM_ERR1_TRIG, SRC19, 19, 1)
    FIELD(PSM_ERR1_TRIG, SRC18, 18, 1)
    FIELD(PSM_ERR1_TRIG, SRC17, 17, 1)
    FIELD(PSM_ERR1_TRIG, SRC16, 16, 1)
    FIELD(PSM_ERR1_TRIG, SRC15, 15, 1)
    FIELD(PSM_ERR1_TRIG, SRC14, 14, 1)
    FIELD(PSM_ERR1_TRIG, SRC13, 13, 1)
    FIELD(PSM_ERR1_TRIG, SRC12, 12, 1)
    FIELD(PSM_ERR1_TRIG, SRC11, 11, 1)
    FIELD(PSM_ERR1_TRIG, SRC10, 10, 1)
    FIELD(PSM_ERR1_TRIG, SRC9, 9, 1)
    FIELD(PSM_ERR1_TRIG, SRC8, 8, 1)
    FIELD(PSM_ERR1_TRIG, SRC7, 7, 1)
    FIELD(PSM_ERR1_TRIG, SRC6, 6, 1)
    FIELD(PSM_ERR1_TRIG, SRC5, 5, 1)
    FIELD(PSM_ERR1_TRIG, SRC4, 4, 1)
    FIELD(PSM_ERR1_TRIG, SRC3, 3, 1)
    FIELD(PSM_ERR1_TRIG, SRC2, 2, 1)
    FIELD(PSM_ERR1_TRIG, SRC1, 1, 1)
    FIELD(PSM_ERR1_TRIG, SRC0, 0, 1)
REG32(PSM_ERR2_TRIG, 0x24)
    FIELD(PSM_ERR2_TRIG, SRC31, 31, 1)
    FIELD(PSM_ERR2_TRIG, SRC30, 30, 1)
    FIELD(PSM_ERR2_TRIG, SRC29, 29, 1)
    FIELD(PSM_ERR2_TRIG, SRC28, 28, 1)
    FIELD(PSM_ERR2_TRIG, SRC27, 27, 1)
    FIELD(PSM_ERR2_TRIG, SRC26, 26, 1)
    FIELD(PSM_ERR2_TRIG, SRC25, 25, 1)
    FIELD(PSM_ERR2_TRIG, SRC24, 24, 1)
    FIELD(PSM_ERR2_TRIG, SRC23, 23, 1)
    FIELD(PSM_ERR2_TRIG, SRC22, 22, 1)
    FIELD(PSM_ERR2_TRIG, SRC21, 21, 1)
    FIELD(PSM_ERR2_TRIG, SRC20, 20, 1)
    FIELD(PSM_ERR2_TRIG, SRC19, 19, 1)
    FIELD(PSM_ERR2_TRIG, SRC18, 18, 1)
    FIELD(PSM_ERR2_TRIG, SRC17, 17, 1)
    FIELD(PSM_ERR2_TRIG, SRC16, 16, 1)
    FIELD(PSM_ERR2_TRIG, SRC15, 15, 1)
    FIELD(PSM_ERR2_TRIG, SRC14, 14, 1)
    FIELD(PSM_ERR2_TRIG, SRC13, 13, 1)
    FIELD(PSM_ERR2_TRIG, SRC12, 12, 1)
    FIELD(PSM_ERR2_TRIG, SRC11, 11, 1)
    FIELD(PSM_ERR2_TRIG, SRC10, 10, 1)
    FIELD(PSM_ERR2_TRIG, SRC9, 9, 1)
    FIELD(PSM_ERR2_TRIG, SRC8, 8, 1)
    FIELD(PSM_ERR2_TRIG, SRC7, 7, 1)
    FIELD(PSM_ERR2_TRIG, SRC6, 6, 1)
    FIELD(PSM_ERR2_TRIG, SRC5, 5, 1)
    FIELD(PSM_ERR2_TRIG, SRC4, 4, 1)
    FIELD(PSM_ERR2_TRIG, SRC3, 3, 1)
    FIELD(PSM_ERR2_TRIG, SRC2, 2, 1)
    FIELD(PSM_ERR2_TRIG, SRC1, 1, 1)
    FIELD(PSM_ERR2_TRIG, SRC0, 0, 1)
REG32(PSM_ERR3_TRIG, 0x28)
    FIELD(PSM_ERR3_TRIG, SRC31, 31, 1)
    FIELD(PSM_ERR3_TRIG, SRC30, 30, 1)
    FIELD(PSM_ERR3_TRIG, SRC29, 29, 1)
    FIELD(PSM_ERR3_TRIG, SRC28, 28, 1)
    FIELD(PSM_ERR3_TRIG, SRC27, 27, 1)
    FIELD(PSM_ERR3_TRIG, SRC26, 26, 1)
    FIELD(PSM_ERR3_TRIG, SRC25, 25, 1)
    FIELD(PSM_ERR3_TRIG, SRC24, 24, 1)
    FIELD(PSM_ERR3_TRIG, SRC23, 23, 1)
    FIELD(PSM_ERR3_TRIG, SRC22, 22, 1)
    FIELD(PSM_ERR3_TRIG, SRC21, 21, 1)
    FIELD(PSM_ERR3_TRIG, SRC20, 20, 1)
    FIELD(PSM_ERR3_TRIG, SRC19, 19, 1)
    FIELD(PSM_ERR3_TRIG, SRC18, 18, 1)
    FIELD(PSM_ERR3_TRIG, SRC17, 17, 1)
    FIELD(PSM_ERR3_TRIG, SRC16, 16, 1)
    FIELD(PSM_ERR3_TRIG, SRC15, 15, 1)
    FIELD(PSM_ERR3_TRIG, SRC14, 14, 1)
    FIELD(PSM_ERR3_TRIG, SRC13, 13, 1)
    FIELD(PSM_ERR3_TRIG, SRC12, 12, 1)
    FIELD(PSM_ERR3_TRIG, SRC11, 11, 1)
    FIELD(PSM_ERR3_TRIG, SRC10, 10, 1)
    FIELD(PSM_ERR3_TRIG, SRC9, 9, 1)
    FIELD(PSM_ERR3_TRIG, SRC8, 8, 1)
    FIELD(PSM_ERR3_TRIG, SRC7, 7, 1)
    FIELD(PSM_ERR3_TRIG, SRC6, 6, 1)
    FIELD(PSM_ERR3_TRIG, SRC5, 5, 1)
    FIELD(PSM_ERR3_TRIG, SRC4, 4, 1)
    FIELD(PSM_ERR3_TRIG, SRC3, 3, 1)
    FIELD(PSM_ERR3_TRIG, SRC2, 2, 1)
    FIELD(PSM_ERR3_TRIG, SRC1, 1, 1)
    FIELD(PSM_ERR3_TRIG, SRC0, 0, 1)
REG32(PSM_ERR4_TRIG, 0x2c)
    FIELD(PSM_ERR4_TRIG, SRC31, 31, 1)
    FIELD(PSM_ERR4_TRIG, SRC30, 30, 1)
    FIELD(PSM_ERR4_TRIG, SRC29, 29, 1)
    FIELD(PSM_ERR4_TRIG, SRC28, 28, 1)
    FIELD(PSM_ERR4_TRIG, SRC27, 27, 1)
    FIELD(PSM_ERR4_TRIG, SRC26, 26, 1)
    FIELD(PSM_ERR4_TRIG, SRC25, 25, 1)
    FIELD(PSM_ERR4_TRIG, SRC24, 24, 1)
    FIELD(PSM_ERR4_TRIG, SRC23, 23, 1)
    FIELD(PSM_ERR4_TRIG, SRC22, 22, 1)
    FIELD(PSM_ERR4_TRIG, SRC21, 21, 1)
    FIELD(PSM_ERR4_TRIG, SRC20, 20, 1)
    FIELD(PSM_ERR4_TRIG, SRC19, 19, 1)
    FIELD(PSM_ERR4_TRIG, SRC18, 18, 1)
    FIELD(PSM_ERR4_TRIG, SRC17, 17, 1)
    FIELD(PSM_ERR4_TRIG, SRC16, 16, 1)
    FIELD(PSM_ERR4_TRIG, SRC15, 15, 1)
    FIELD(PSM_ERR4_TRIG, SRC14, 14, 1)
    FIELD(PSM_ERR4_TRIG, SRC13, 13, 1)
    FIELD(PSM_ERR4_TRIG, SRC12, 12, 1)
    FIELD(PSM_ERR4_TRIG, SRC11, 11, 1)
    FIELD(PSM_ERR4_TRIG, SRC10, 10, 1)
    FIELD(PSM_ERR4_TRIG, SRC9, 9, 1)
    FIELD(PSM_ERR4_TRIG, SRC8, 8, 1)
    FIELD(PSM_ERR4_TRIG, SRC7, 7, 1)
    FIELD(PSM_ERR4_TRIG, SRC6, 6, 1)
    FIELD(PSM_ERR4_TRIG, SRC5, 5, 1)
    FIELD(PSM_ERR4_TRIG, SRC4, 4, 1)
    FIELD(PSM_ERR4_TRIG, SRC3, 3, 1)
    FIELD(PSM_ERR4_TRIG, SRC2, 2, 1)
    FIELD(PSM_ERR4_TRIG, SRC1, 1, 1)
    FIELD(PSM_ERR4_TRIG, SRC0, 0, 1)
REG32(PSM_CR_ERR1_MASK, 0x40)
    FIELD(PSM_CR_ERR1_MASK, SRC31, 31, 1)
    FIELD(PSM_CR_ERR1_MASK, SRC30, 30, 1)
    FIELD(PSM_CR_ERR1_MASK, SRC29, 29, 1)
    FIELD(PSM_CR_ERR1_MASK, SRC28, 28, 1)
    FIELD(PSM_CR_ERR1_MASK, SRC27, 27, 1)
    FIELD(PSM_CR_ERR1_MASK, SRC26, 26, 1)
    FIELD(PSM_CR_ERR1_MASK, SRC25, 25, 1)
    FIELD(PSM_CR_ERR1_MASK, SRC24, 24, 1)
    FIELD(PSM_CR_ERR1_MASK, SRC23, 23, 1)
    FIELD(PSM_CR_ERR1_MASK, SRC22, 22, 1)
    FIELD(PSM_CR_ERR1_MASK, SRC21, 21, 1)
    FIELD(PSM_CR_ERR1_MASK, SRC20, 20, 1)
    FIELD(PSM_CR_ERR1_MASK, SRC19, 19, 1)
    FIELD(PSM_CR_ERR1_MASK, SRC18, 18, 1)
    FIELD(PSM_CR_ERR1_MASK, SRC17, 17, 1)
    FIELD(PSM_CR_ERR1_MASK, SRC16, 16, 1)
    FIELD(PSM_CR_ERR1_MASK, SRC15, 15, 1)
    FIELD(PSM_CR_ERR1_MASK, SRC14, 14, 1)
    FIELD(PSM_CR_ERR1_MASK, SRC13, 13, 1)
    FIELD(PSM_CR_ERR1_MASK, SRC12, 12, 1)
    FIELD(PSM_CR_ERR1_MASK, SRC11, 11, 1)
    FIELD(PSM_CR_ERR1_MASK, SRC10, 10, 1)
    FIELD(PSM_CR_ERR1_MASK, SRC9, 9, 1)
    FIELD(PSM_CR_ERR1_MASK, SRC8, 8, 1)
    FIELD(PSM_CR_ERR1_MASK, SRC7, 7, 1)
    FIELD(PSM_CR_ERR1_MASK, SRC6, 6, 1)
    FIELD(PSM_CR_ERR1_MASK, SRC5, 5, 1)
    FIELD(PSM_CR_ERR1_MASK, SRC4, 4, 1)
    FIELD(PSM_CR_ERR1_MASK, SRC3, 3, 1)
    FIELD(PSM_CR_ERR1_MASK, SRC2, 2, 1)
    FIELD(PSM_CR_ERR1_MASK, SRC1, 1, 1)
    FIELD(PSM_CR_ERR1_MASK, SRC0, 0, 1)
REG32(PSM_CR_ERR1_EN, 0x44)
    FIELD(PSM_CR_ERR1_EN, SRC31, 31, 1)
    FIELD(PSM_CR_ERR1_EN, SRC30, 30, 1)
    FIELD(PSM_CR_ERR1_EN, SRC29, 29, 1)
    FIELD(PSM_CR_ERR1_EN, SRC28, 28, 1)
    FIELD(PSM_CR_ERR1_EN, SRC27, 27, 1)
    FIELD(PSM_CR_ERR1_EN, SRC26, 26, 1)
    FIELD(PSM_CR_ERR1_EN, SRC25, 25, 1)
    FIELD(PSM_CR_ERR1_EN, SRC24, 24, 1)
    FIELD(PSM_CR_ERR1_EN, SRC23, 23, 1)
    FIELD(PSM_CR_ERR1_EN, SRC22, 22, 1)
    FIELD(PSM_CR_ERR1_EN, SRC21, 21, 1)
    FIELD(PSM_CR_ERR1_EN, SRC20, 20, 1)
    FIELD(PSM_CR_ERR1_EN, SRC19, 19, 1)
    FIELD(PSM_CR_ERR1_EN, SRC18, 18, 1)
    FIELD(PSM_CR_ERR1_EN, SRC17, 17, 1)
    FIELD(PSM_CR_ERR1_EN, SRC16, 16, 1)
    FIELD(PSM_CR_ERR1_EN, SRC15, 15, 1)
    FIELD(PSM_CR_ERR1_EN, SRC14, 14, 1)
    FIELD(PSM_CR_ERR1_EN, SRC13, 13, 1)
    FIELD(PSM_CR_ERR1_EN, SRC12, 12, 1)
    FIELD(PSM_CR_ERR1_EN, SRC11, 11, 1)
    FIELD(PSM_CR_ERR1_EN, SRC10, 10, 1)
    FIELD(PSM_CR_ERR1_EN, SRC9, 9, 1)
    FIELD(PSM_CR_ERR1_EN, SRC8, 8, 1)
    FIELD(PSM_CR_ERR1_EN, SRC7, 7, 1)
    FIELD(PSM_CR_ERR1_EN, SRC6, 6, 1)
    FIELD(PSM_CR_ERR1_EN, SRC5, 5, 1)
    FIELD(PSM_CR_ERR1_EN, SRC4, 4, 1)
    FIELD(PSM_CR_ERR1_EN, SRC3, 3, 1)
    FIELD(PSM_CR_ERR1_EN, SRC2, 2, 1)
    FIELD(PSM_CR_ERR1_EN, SRC1, 1, 1)
    FIELD(PSM_CR_ERR1_EN, SRC0, 0, 1)
REG32(PSM_CR_ERR1_DIS, 0x48)
    FIELD(PSM_CR_ERR1_DIS, SRC31, 31, 1)
    FIELD(PSM_CR_ERR1_DIS, SRC30, 30, 1)
    FIELD(PSM_CR_ERR1_DIS, SRC29, 29, 1)
    FIELD(PSM_CR_ERR1_DIS, SRC28, 28, 1)
    FIELD(PSM_CR_ERR1_DIS, SRC27, 27, 1)
    FIELD(PSM_CR_ERR1_DIS, SRC26, 26, 1)
    FIELD(PSM_CR_ERR1_DIS, SRC25, 25, 1)
    FIELD(PSM_CR_ERR1_DIS, SRC24, 24, 1)
    FIELD(PSM_CR_ERR1_DIS, SRC23, 23, 1)
    FIELD(PSM_CR_ERR1_DIS, SRC22, 22, 1)
    FIELD(PSM_CR_ERR1_DIS, SRC21, 21, 1)
    FIELD(PSM_CR_ERR1_DIS, SRC20, 20, 1)
    FIELD(PSM_CR_ERR1_DIS, SRC19, 19, 1)
    FIELD(PSM_CR_ERR1_DIS, SRC18, 18, 1)
    FIELD(PSM_CR_ERR1_DIS, SRC17, 17, 1)
    FIELD(PSM_CR_ERR1_DIS, SRC16, 16, 1)
    FIELD(PSM_CR_ERR1_DIS, SRC15, 15, 1)
    FIELD(PSM_CR_ERR1_DIS, SRC14, 14, 1)
    FIELD(PSM_CR_ERR1_DIS, SRC13, 13, 1)
    FIELD(PSM_CR_ERR1_DIS, SRC12, 12, 1)
    FIELD(PSM_CR_ERR1_DIS, SRC11, 11, 1)
    FIELD(PSM_CR_ERR1_DIS, SRC10, 10, 1)
    FIELD(PSM_CR_ERR1_DIS, SRC9, 9, 1)
    FIELD(PSM_CR_ERR1_DIS, SRC8, 8, 1)
    FIELD(PSM_CR_ERR1_DIS, SRC7, 7, 1)
    FIELD(PSM_CR_ERR1_DIS, SRC6, 6, 1)
    FIELD(PSM_CR_ERR1_DIS, SRC5, 5, 1)
    FIELD(PSM_CR_ERR1_DIS, SRC4, 4, 1)
    FIELD(PSM_CR_ERR1_DIS, SRC3, 3, 1)
    FIELD(PSM_CR_ERR1_DIS, SRC2, 2, 1)
    FIELD(PSM_CR_ERR1_DIS, SRC1, 1, 1)
    FIELD(PSM_CR_ERR1_DIS, SRC0, 0, 1)
REG32(PSM_CR_ERR2_MASK, 0x50)
    FIELD(PSM_CR_ERR2_MASK, SRC31, 31, 1)
    FIELD(PSM_CR_ERR2_MASK, SRC30, 30, 1)
    FIELD(PSM_CR_ERR2_MASK, SRC29, 29, 1)
    FIELD(PSM_CR_ERR2_MASK, SRC28, 28, 1)
    FIELD(PSM_CR_ERR2_MASK, SRC27, 27, 1)
    FIELD(PSM_CR_ERR2_MASK, SRC26, 26, 1)
    FIELD(PSM_CR_ERR2_MASK, SRC25, 25, 1)
    FIELD(PSM_CR_ERR2_MASK, SRC24, 24, 1)
    FIELD(PSM_CR_ERR2_MASK, SRC23, 23, 1)
    FIELD(PSM_CR_ERR2_MASK, SRC22, 22, 1)
    FIELD(PSM_CR_ERR2_MASK, SRC21, 21, 1)
    FIELD(PSM_CR_ERR2_MASK, SRC20, 20, 1)
    FIELD(PSM_CR_ERR2_MASK, SRC19, 19, 1)
    FIELD(PSM_CR_ERR2_MASK, SRC18, 18, 1)
    FIELD(PSM_CR_ERR2_MASK, SRC17, 17, 1)
    FIELD(PSM_CR_ERR2_MASK, SRC16, 16, 1)
    FIELD(PSM_CR_ERR2_MASK, SRC15, 15, 1)
    FIELD(PSM_CR_ERR2_MASK, SRC14, 14, 1)
    FIELD(PSM_CR_ERR2_MASK, SRC13, 13, 1)
    FIELD(PSM_CR_ERR2_MASK, SRC12, 12, 1)
    FIELD(PSM_CR_ERR2_MASK, SRC11, 11, 1)
    FIELD(PSM_CR_ERR2_MASK, SRC10, 10, 1)
    FIELD(PSM_CR_ERR2_MASK, SRC9, 9, 1)
    FIELD(PSM_CR_ERR2_MASK, SRC8, 8, 1)
    FIELD(PSM_CR_ERR2_MASK, SRC7, 7, 1)
    FIELD(PSM_CR_ERR2_MASK, SRC6, 6, 1)
    FIELD(PSM_CR_ERR2_MASK, SRC5, 5, 1)
    FIELD(PSM_CR_ERR2_MASK, SRC4, 4, 1)
    FIELD(PSM_CR_ERR2_MASK, SRC3, 3, 1)
    FIELD(PSM_CR_ERR2_MASK, SRC2, 2, 1)
    FIELD(PSM_CR_ERR2_MASK, SRC1, 1, 1)
    FIELD(PSM_CR_ERR2_MASK, SRC0, 0, 1)
REG32(PSM_CR_ERR2_EN, 0x54)
    FIELD(PSM_CR_ERR2_EN, SRC31, 31, 1)
    FIELD(PSM_CR_ERR2_EN, SRC30, 30, 1)
    FIELD(PSM_CR_ERR2_EN, SRC29, 29, 1)
    FIELD(PSM_CR_ERR2_EN, SRC28, 28, 1)
    FIELD(PSM_CR_ERR2_EN, SRC27, 27, 1)
    FIELD(PSM_CR_ERR2_EN, SRC26, 26, 1)
    FIELD(PSM_CR_ERR2_EN, SRC25, 25, 1)
    FIELD(PSM_CR_ERR2_EN, SRC24, 24, 1)
    FIELD(PSM_CR_ERR2_EN, SRC23, 23, 1)
    FIELD(PSM_CR_ERR2_EN, SRC22, 22, 1)
    FIELD(PSM_CR_ERR2_EN, SRC21, 21, 1)
    FIELD(PSM_CR_ERR2_EN, SRC20, 20, 1)
    FIELD(PSM_CR_ERR2_EN, SRC19, 19, 1)
    FIELD(PSM_CR_ERR2_EN, SRC18, 18, 1)
    FIELD(PSM_CR_ERR2_EN, SRC17, 17, 1)
    FIELD(PSM_CR_ERR2_EN, SRC16, 16, 1)
    FIELD(PSM_CR_ERR2_EN, SRC15, 15, 1)
    FIELD(PSM_CR_ERR2_EN, SRC14, 14, 1)
    FIELD(PSM_CR_ERR2_EN, SRC13, 13, 1)
    FIELD(PSM_CR_ERR2_EN, SRC12, 12, 1)
    FIELD(PSM_CR_ERR2_EN, SRC11, 11, 1)
    FIELD(PSM_CR_ERR2_EN, SRC10, 10, 1)
    FIELD(PSM_CR_ERR2_EN, SRC9, 9, 1)
    FIELD(PSM_CR_ERR2_EN, SRC8, 8, 1)
    FIELD(PSM_CR_ERR2_EN, SRC7, 7, 1)
    FIELD(PSM_CR_ERR2_EN, SRC6, 6, 1)
    FIELD(PSM_CR_ERR2_EN, SRC5, 5, 1)
    FIELD(PSM_CR_ERR2_EN, SRC4, 4, 1)
    FIELD(PSM_CR_ERR2_EN, SRC3, 3, 1)
    FIELD(PSM_CR_ERR2_EN, SRC2, 2, 1)
    FIELD(PSM_CR_ERR2_EN, SRC1, 1, 1)
    FIELD(PSM_CR_ERR2_EN, SRC0, 0, 1)
REG32(PSM_CR_ERR2_DIS, 0x58)
    FIELD(PSM_CR_ERR2_DIS, SRC31, 31, 1)
    FIELD(PSM_CR_ERR2_DIS, SRC30, 30, 1)
    FIELD(PSM_CR_ERR2_DIS, SRC29, 29, 1)
    FIELD(PSM_CR_ERR2_DIS, SRC28, 28, 1)
    FIELD(PSM_CR_ERR2_DIS, SRC27, 27, 1)
    FIELD(PSM_CR_ERR2_DIS, SRC26, 26, 1)
    FIELD(PSM_CR_ERR2_DIS, SRC25, 25, 1)
    FIELD(PSM_CR_ERR2_DIS, SRC24, 24, 1)
    FIELD(PSM_CR_ERR2_DIS, SRC23, 23, 1)
    FIELD(PSM_CR_ERR2_DIS, SRC22, 22, 1)
    FIELD(PSM_CR_ERR2_DIS, SRC21, 21, 1)
    FIELD(PSM_CR_ERR2_DIS, SRC20, 20, 1)
    FIELD(PSM_CR_ERR2_DIS, SRC19, 19, 1)
    FIELD(PSM_CR_ERR2_DIS, SRC18, 18, 1)
    FIELD(PSM_CR_ERR2_DIS, SRC17, 17, 1)
    FIELD(PSM_CR_ERR2_DIS, SRC16, 16, 1)
    FIELD(PSM_CR_ERR2_DIS, SRC15, 15, 1)
    FIELD(PSM_CR_ERR2_DIS, SRC14, 14, 1)
    FIELD(PSM_CR_ERR2_DIS, SRC13, 13, 1)
    FIELD(PSM_CR_ERR2_DIS, SRC12, 12, 1)
    FIELD(PSM_CR_ERR2_DIS, SRC11, 11, 1)
    FIELD(PSM_CR_ERR2_DIS, SRC10, 10, 1)
    FIELD(PSM_CR_ERR2_DIS, SRC9, 9, 1)
    FIELD(PSM_CR_ERR2_DIS, SRC8, 8, 1)
    FIELD(PSM_CR_ERR2_DIS, SRC7, 7, 1)
    FIELD(PSM_CR_ERR2_DIS, SRC6, 6, 1)
    FIELD(PSM_CR_ERR2_DIS, SRC5, 5, 1)
    FIELD(PSM_CR_ERR2_DIS, SRC4, 4, 1)
    FIELD(PSM_CR_ERR2_DIS, SRC3, 3, 1)
    FIELD(PSM_CR_ERR2_DIS, SRC2, 2, 1)
    FIELD(PSM_CR_ERR2_DIS, SRC1, 1, 1)
    FIELD(PSM_CR_ERR2_DIS, SRC0, 0, 1)
REG32(PSM_CR_ERR3_MASK, 0x60)
    FIELD(PSM_CR_ERR3_MASK, SRC31, 31, 1)
    FIELD(PSM_CR_ERR3_MASK, SRC30, 30, 1)
    FIELD(PSM_CR_ERR3_MASK, SRC29, 29, 1)
    FIELD(PSM_CR_ERR3_MASK, SRC28, 28, 1)
    FIELD(PSM_CR_ERR3_MASK, SRC27, 27, 1)
    FIELD(PSM_CR_ERR3_MASK, SRC26, 26, 1)
    FIELD(PSM_CR_ERR3_MASK, SRC25, 25, 1)
    FIELD(PSM_CR_ERR3_MASK, SRC24, 24, 1)
    FIELD(PSM_CR_ERR3_MASK, SRC23, 23, 1)
    FIELD(PSM_CR_ERR3_MASK, SRC22, 22, 1)
    FIELD(PSM_CR_ERR3_MASK, SRC21, 21, 1)
    FIELD(PSM_CR_ERR3_MASK, SRC20, 20, 1)
    FIELD(PSM_CR_ERR3_MASK, SRC19, 19, 1)
    FIELD(PSM_CR_ERR3_MASK, SRC18, 18, 1)
    FIELD(PSM_CR_ERR3_MASK, SRC17, 17, 1)
    FIELD(PSM_CR_ERR3_MASK, SRC16, 16, 1)
    FIELD(PSM_CR_ERR3_MASK, SRC15, 15, 1)
    FIELD(PSM_CR_ERR3_MASK, SRC14, 14, 1)
    FIELD(PSM_CR_ERR3_MASK, SRC13, 13, 1)
    FIELD(PSM_CR_ERR3_MASK, SRC12, 12, 1)
    FIELD(PSM_CR_ERR3_MASK, SRC11, 11, 1)
    FIELD(PSM_CR_ERR3_MASK, SRC10, 10, 1)
    FIELD(PSM_CR_ERR3_MASK, SRC9, 9, 1)
    FIELD(PSM_CR_ERR3_MASK, SRC8, 8, 1)
    FIELD(PSM_CR_ERR3_MASK, SRC7, 7, 1)
    FIELD(PSM_CR_ERR3_MASK, SRC6, 6, 1)
    FIELD(PSM_CR_ERR3_MASK, SRC5, 5, 1)
    FIELD(PSM_CR_ERR3_MASK, SRC4, 4, 1)
    FIELD(PSM_CR_ERR3_MASK, SRC3, 3, 1)
    FIELD(PSM_CR_ERR3_MASK, SRC2, 2, 1)
    FIELD(PSM_CR_ERR3_MASK, SRC1, 1, 1)
    FIELD(PSM_CR_ERR3_MASK, SRC0, 0, 1)
REG32(PSM_CR_ERR3_EN, 0x64)
    FIELD(PSM_CR_ERR3_EN, SRC31, 31, 1)
    FIELD(PSM_CR_ERR3_EN, SRC30, 30, 1)
    FIELD(PSM_CR_ERR3_EN, SRC29, 29, 1)
    FIELD(PSM_CR_ERR3_EN, SRC28, 28, 1)
    FIELD(PSM_CR_ERR3_EN, SRC27, 27, 1)
    FIELD(PSM_CR_ERR3_EN, SRC26, 26, 1)
    FIELD(PSM_CR_ERR3_EN, SRC25, 25, 1)
    FIELD(PSM_CR_ERR3_EN, SRC24, 24, 1)
    FIELD(PSM_CR_ERR3_EN, SRC23, 23, 1)
    FIELD(PSM_CR_ERR3_EN, SRC22, 22, 1)
    FIELD(PSM_CR_ERR3_EN, SRC21, 21, 1)
    FIELD(PSM_CR_ERR3_EN, SRC20, 20, 1)
    FIELD(PSM_CR_ERR3_EN, SRC19, 19, 1)
    FIELD(PSM_CR_ERR3_EN, SRC18, 18, 1)
    FIELD(PSM_CR_ERR3_EN, SRC17, 17, 1)
    FIELD(PSM_CR_ERR3_EN, SRC16, 16, 1)
    FIELD(PSM_CR_ERR3_EN, SRC15, 15, 1)
    FIELD(PSM_CR_ERR3_EN, SRC14, 14, 1)
    FIELD(PSM_CR_ERR3_EN, SRC13, 13, 1)
    FIELD(PSM_CR_ERR3_EN, SRC12, 12, 1)
    FIELD(PSM_CR_ERR3_EN, SRC11, 11, 1)
    FIELD(PSM_CR_ERR3_EN, SRC10, 10, 1)
    FIELD(PSM_CR_ERR3_EN, SRC9, 9, 1)
    FIELD(PSM_CR_ERR3_EN, SRC8, 8, 1)
    FIELD(PSM_CR_ERR3_EN, SRC7, 7, 1)
    FIELD(PSM_CR_ERR3_EN, SRC6, 6, 1)
    FIELD(PSM_CR_ERR3_EN, SRC5, 5, 1)
    FIELD(PSM_CR_ERR3_EN, SRC4, 4, 1)
    FIELD(PSM_CR_ERR3_EN, SRC3, 3, 1)
    FIELD(PSM_CR_ERR3_EN, SRC2, 2, 1)
    FIELD(PSM_CR_ERR3_EN, SRC1, 1, 1)
    FIELD(PSM_CR_ERR3_EN, SRC0, 0, 1)
REG32(PSM_CR_ERR3_DIS, 0x68)
    FIELD(PSM_CR_ERR3_DIS, SRC31, 31, 1)
    FIELD(PSM_CR_ERR3_DIS, SRC30, 30, 1)
    FIELD(PSM_CR_ERR3_DIS, SRC29, 29, 1)
    FIELD(PSM_CR_ERR3_DIS, SRC28, 28, 1)
    FIELD(PSM_CR_ERR3_DIS, SRC27, 27, 1)
    FIELD(PSM_CR_ERR3_DIS, SRC26, 26, 1)
    FIELD(PSM_CR_ERR3_DIS, SRC25, 25, 1)
    FIELD(PSM_CR_ERR3_DIS, SRC24, 24, 1)
    FIELD(PSM_CR_ERR3_DIS, SRC23, 23, 1)
    FIELD(PSM_CR_ERR3_DIS, SRC22, 22, 1)
    FIELD(PSM_CR_ERR3_DIS, SRC21, 21, 1)
    FIELD(PSM_CR_ERR3_DIS, SRC20, 20, 1)
    FIELD(PSM_CR_ERR3_DIS, SRC19, 19, 1)
    FIELD(PSM_CR_ERR3_DIS, SRC18, 18, 1)
    FIELD(PSM_CR_ERR3_DIS, SRC17, 17, 1)
    FIELD(PSM_CR_ERR3_DIS, SRC16, 16, 1)
    FIELD(PSM_CR_ERR3_DIS, SRC15, 15, 1)
    FIELD(PSM_CR_ERR3_DIS, SRC14, 14, 1)
    FIELD(PSM_CR_ERR3_DIS, SRC13, 13, 1)
    FIELD(PSM_CR_ERR3_DIS, SRC12, 12, 1)
    FIELD(PSM_CR_ERR3_DIS, SRC11, 11, 1)
    FIELD(PSM_CR_ERR3_DIS, SRC10, 10, 1)
    FIELD(PSM_CR_ERR3_DIS, SRC9, 9, 1)
    FIELD(PSM_CR_ERR3_DIS, SRC8, 8, 1)
    FIELD(PSM_CR_ERR3_DIS, SRC7, 7, 1)
    FIELD(PSM_CR_ERR3_DIS, SRC6, 6, 1)
    FIELD(PSM_CR_ERR3_DIS, SRC5, 5, 1)
    FIELD(PSM_CR_ERR3_DIS, SRC4, 4, 1)
    FIELD(PSM_CR_ERR3_DIS, SRC3, 3, 1)
    FIELD(PSM_CR_ERR3_DIS, SRC2, 2, 1)
    FIELD(PSM_CR_ERR3_DIS, SRC1, 1, 1)
    FIELD(PSM_CR_ERR3_DIS, SRC0, 0, 1)
REG32(PSM_CR_ERR4_MASK, 0x70)
    FIELD(PSM_CR_ERR4_MASK, SRC31, 31, 1)
    FIELD(PSM_CR_ERR4_MASK, SRC30, 30, 1)
    FIELD(PSM_CR_ERR4_MASK, SRC29, 29, 1)
    FIELD(PSM_CR_ERR4_MASK, SRC28, 28, 1)
    FIELD(PSM_CR_ERR4_MASK, SRC27, 27, 1)
    FIELD(PSM_CR_ERR4_MASK, SRC26, 26, 1)
    FIELD(PSM_CR_ERR4_MASK, SRC25, 25, 1)
    FIELD(PSM_CR_ERR4_MASK, SRC24, 24, 1)
    FIELD(PSM_CR_ERR4_MASK, SRC23, 23, 1)
    FIELD(PSM_CR_ERR4_MASK, SRC22, 22, 1)
    FIELD(PSM_CR_ERR4_MASK, SRC21, 21, 1)
    FIELD(PSM_CR_ERR4_MASK, SRC20, 20, 1)
    FIELD(PSM_CR_ERR4_MASK, SRC19, 19, 1)
    FIELD(PSM_CR_ERR4_MASK, SRC18, 18, 1)
    FIELD(PSM_CR_ERR4_MASK, SRC17, 17, 1)
    FIELD(PSM_CR_ERR4_MASK, SRC16, 16, 1)
    FIELD(PSM_CR_ERR4_MASK, SRC15, 15, 1)
    FIELD(PSM_CR_ERR4_MASK, SRC14, 14, 1)
    FIELD(PSM_CR_ERR4_MASK, SRC13, 13, 1)
    FIELD(PSM_CR_ERR4_MASK, SRC12, 12, 1)
    FIELD(PSM_CR_ERR4_MASK, SRC11, 11, 1)
    FIELD(PSM_CR_ERR4_MASK, SRC10, 10, 1)
    FIELD(PSM_CR_ERR4_MASK, SRC9, 9, 1)
    FIELD(PSM_CR_ERR4_MASK, SRC8, 8, 1)
    FIELD(PSM_CR_ERR4_MASK, SRC7, 7, 1)
    FIELD(PSM_CR_ERR4_MASK, SRC6, 6, 1)
    FIELD(PSM_CR_ERR4_MASK, SRC5, 5, 1)
    FIELD(PSM_CR_ERR4_MASK, SRC4, 4, 1)
    FIELD(PSM_CR_ERR4_MASK, SRC3, 3, 1)
    FIELD(PSM_CR_ERR4_MASK, SRC2, 2, 1)
    FIELD(PSM_CR_ERR4_MASK, SRC1, 1, 1)
    FIELD(PSM_CR_ERR4_MASK, SRC0, 0, 1)
REG32(PSM_CR_ERR4_EN, 0x74)
    FIELD(PSM_CR_ERR4_EN, SRC31, 31, 1)
    FIELD(PSM_CR_ERR4_EN, SRC30, 30, 1)
    FIELD(PSM_CR_ERR4_EN, SRC29, 29, 1)
    FIELD(PSM_CR_ERR4_EN, SRC28, 28, 1)
    FIELD(PSM_CR_ERR4_EN, SRC27, 27, 1)
    FIELD(PSM_CR_ERR4_EN, SRC26, 26, 1)
    FIELD(PSM_CR_ERR4_EN, SRC25, 25, 1)
    FIELD(PSM_CR_ERR4_EN, SRC24, 24, 1)
    FIELD(PSM_CR_ERR4_EN, SRC23, 23, 1)
    FIELD(PSM_CR_ERR4_EN, SRC22, 22, 1)
    FIELD(PSM_CR_ERR4_EN, SRC21, 21, 1)
    FIELD(PSM_CR_ERR4_EN, SRC20, 20, 1)
    FIELD(PSM_CR_ERR4_EN, SRC19, 19, 1)
    FIELD(PSM_CR_ERR4_EN, SRC18, 18, 1)
    FIELD(PSM_CR_ERR4_EN, SRC17, 17, 1)
    FIELD(PSM_CR_ERR4_EN, SRC16, 16, 1)
    FIELD(PSM_CR_ERR4_EN, SRC15, 15, 1)
    FIELD(PSM_CR_ERR4_EN, SRC14, 14, 1)
    FIELD(PSM_CR_ERR4_EN, SRC13, 13, 1)
    FIELD(PSM_CR_ERR4_EN, SRC12, 12, 1)
    FIELD(PSM_CR_ERR4_EN, SRC11, 11, 1)
    FIELD(PSM_CR_ERR4_EN, SRC10, 10, 1)
    FIELD(PSM_CR_ERR4_EN, SRC9, 9, 1)
    FIELD(PSM_CR_ERR4_EN, SRC8, 8, 1)
    FIELD(PSM_CR_ERR4_EN, SRC7, 7, 1)
    FIELD(PSM_CR_ERR4_EN, SRC6, 6, 1)
    FIELD(PSM_CR_ERR4_EN, SRC5, 5, 1)
    FIELD(PSM_CR_ERR4_EN, SRC4, 4, 1)
    FIELD(PSM_CR_ERR4_EN, SRC3, 3, 1)
    FIELD(PSM_CR_ERR4_EN, SRC2, 2, 1)
    FIELD(PSM_CR_ERR4_EN, SRC1, 1, 1)
    FIELD(PSM_CR_ERR4_EN, SRC0, 0, 1)
REG32(PSM_CR_ERR4_DIS, 0x78)
    FIELD(PSM_CR_ERR4_DIS, SRC31, 31, 1)
    FIELD(PSM_CR_ERR4_DIS, SRC30, 30, 1)
    FIELD(PSM_CR_ERR4_DIS, SRC29, 29, 1)
    FIELD(PSM_CR_ERR4_DIS, SRC28, 28, 1)
    FIELD(PSM_CR_ERR4_DIS, SRC27, 27, 1)
    FIELD(PSM_CR_ERR4_DIS, SRC26, 26, 1)
    FIELD(PSM_CR_ERR4_DIS, SRC25, 25, 1)
    FIELD(PSM_CR_ERR4_DIS, SRC24, 24, 1)
    FIELD(PSM_CR_ERR4_DIS, SRC23, 23, 1)
    FIELD(PSM_CR_ERR4_DIS, SRC22, 22, 1)
    FIELD(PSM_CR_ERR4_DIS, SRC21, 21, 1)
    FIELD(PSM_CR_ERR4_DIS, SRC20, 20, 1)
    FIELD(PSM_CR_ERR4_DIS, SRC19, 19, 1)
    FIELD(PSM_CR_ERR4_DIS, SRC18, 18, 1)
    FIELD(PSM_CR_ERR4_DIS, SRC17, 17, 1)
    FIELD(PSM_CR_ERR4_DIS, SRC16, 16, 1)
    FIELD(PSM_CR_ERR4_DIS, SRC15, 15, 1)
    FIELD(PSM_CR_ERR4_DIS, SRC14, 14, 1)
    FIELD(PSM_CR_ERR4_DIS, SRC13, 13, 1)
    FIELD(PSM_CR_ERR4_DIS, SRC12, 12, 1)
    FIELD(PSM_CR_ERR4_DIS, SRC11, 11, 1)
    FIELD(PSM_CR_ERR4_DIS, SRC10, 10, 1)
    FIELD(PSM_CR_ERR4_DIS, SRC9, 9, 1)
    FIELD(PSM_CR_ERR4_DIS, SRC8, 8, 1)
    FIELD(PSM_CR_ERR4_DIS, SRC7, 7, 1)
    FIELD(PSM_CR_ERR4_DIS, SRC6, 6, 1)
    FIELD(PSM_CR_ERR4_DIS, SRC5, 5, 1)
    FIELD(PSM_CR_ERR4_DIS, SRC4, 4, 1)
    FIELD(PSM_CR_ERR4_DIS, SRC3, 3, 1)
    FIELD(PSM_CR_ERR4_DIS, SRC2, 2, 1)
    FIELD(PSM_CR_ERR4_DIS, SRC1, 1, 1)
    FIELD(PSM_CR_ERR4_DIS, SRC0, 0, 1)
REG32(PSM_NCR_ERR1_MASK, 0x100)
    FIELD(PSM_NCR_ERR1_MASK, SRC31, 31, 1)
    FIELD(PSM_NCR_ERR1_MASK, SRC30, 30, 1)
    FIELD(PSM_NCR_ERR1_MASK, SRC29, 29, 1)
    FIELD(PSM_NCR_ERR1_MASK, SRC28, 28, 1)
    FIELD(PSM_NCR_ERR1_MASK, SRC27, 27, 1)
    FIELD(PSM_NCR_ERR1_MASK, SRC26, 26, 1)
    FIELD(PSM_NCR_ERR1_MASK, SRC25, 25, 1)
    FIELD(PSM_NCR_ERR1_MASK, SRC24, 24, 1)
    FIELD(PSM_NCR_ERR1_MASK, SRC23, 23, 1)
    FIELD(PSM_NCR_ERR1_MASK, SRC22, 22, 1)
    FIELD(PSM_NCR_ERR1_MASK, SRC21, 21, 1)
    FIELD(PSM_NCR_ERR1_MASK, SRC20, 20, 1)
    FIELD(PSM_NCR_ERR1_MASK, SRC19, 19, 1)
    FIELD(PSM_NCR_ERR1_MASK, SRC18, 18, 1)
    FIELD(PSM_NCR_ERR1_MASK, SRC17, 17, 1)
    FIELD(PSM_NCR_ERR1_MASK, SRC16, 16, 1)
    FIELD(PSM_NCR_ERR1_MASK, SRC15, 15, 1)
    FIELD(PSM_NCR_ERR1_MASK, SRC14, 14, 1)
    FIELD(PSM_NCR_ERR1_MASK, SRC13, 13, 1)
    FIELD(PSM_NCR_ERR1_MASK, SRC12, 12, 1)
    FIELD(PSM_NCR_ERR1_MASK, SRC11, 11, 1)
    FIELD(PSM_NCR_ERR1_MASK, SRC10, 10, 1)
    FIELD(PSM_NCR_ERR1_MASK, SRC9, 9, 1)
    FIELD(PSM_NCR_ERR1_MASK, SRC8, 8, 1)
    FIELD(PSM_NCR_ERR1_MASK, SRC7, 7, 1)
    FIELD(PSM_NCR_ERR1_MASK, SRC6, 6, 1)
    FIELD(PSM_NCR_ERR1_MASK, SRC5, 5, 1)
    FIELD(PSM_NCR_ERR1_MASK, SRC4, 4, 1)
    FIELD(PSM_NCR_ERR1_MASK, SRC3, 3, 1)
    FIELD(PSM_NCR_ERR1_MASK, SRC2, 2, 1)
    FIELD(PSM_NCR_ERR1_MASK, SRC1, 1, 1)
    FIELD(PSM_NCR_ERR1_MASK, SRC0, 0, 1)
REG32(PSM_NCR_ERR1_EN, 0x104)
    FIELD(PSM_NCR_ERR1_EN, SRC31, 31, 1)
    FIELD(PSM_NCR_ERR1_EN, SRC30, 30, 1)
    FIELD(PSM_NCR_ERR1_EN, SRC29, 29, 1)
    FIELD(PSM_NCR_ERR1_EN, SRC28, 28, 1)
    FIELD(PSM_NCR_ERR1_EN, SRC27, 27, 1)
    FIELD(PSM_NCR_ERR1_EN, SRC26, 26, 1)
    FIELD(PSM_NCR_ERR1_EN, SRC25, 25, 1)
    FIELD(PSM_NCR_ERR1_EN, SRC24, 24, 1)
    FIELD(PSM_NCR_ERR1_EN, SRC23, 23, 1)
    FIELD(PSM_NCR_ERR1_EN, SRC22, 22, 1)
    FIELD(PSM_NCR_ERR1_EN, SRC21, 21, 1)
    FIELD(PSM_NCR_ERR1_EN, SRC20, 20, 1)
    FIELD(PSM_NCR_ERR1_EN, SRC19, 19, 1)
    FIELD(PSM_NCR_ERR1_EN, SRC18, 18, 1)
    FIELD(PSM_NCR_ERR1_EN, SRC17, 17, 1)
    FIELD(PSM_NCR_ERR1_EN, SRC16, 16, 1)
    FIELD(PSM_NCR_ERR1_EN, SRC15, 15, 1)
    FIELD(PSM_NCR_ERR1_EN, SRC14, 14, 1)
    FIELD(PSM_NCR_ERR1_EN, SRC13, 13, 1)
    FIELD(PSM_NCR_ERR1_EN, SRC12, 12, 1)
    FIELD(PSM_NCR_ERR1_EN, SRC11, 11, 1)
    FIELD(PSM_NCR_ERR1_EN, SRC10, 10, 1)
    FIELD(PSM_NCR_ERR1_EN, SRC9, 9, 1)
    FIELD(PSM_NCR_ERR1_EN, SRC8, 8, 1)
    FIELD(PSM_NCR_ERR1_EN, SRC7, 7, 1)
    FIELD(PSM_NCR_ERR1_EN, SRC6, 6, 1)
    FIELD(PSM_NCR_ERR1_EN, SRC5, 5, 1)
    FIELD(PSM_NCR_ERR1_EN, SRC4, 4, 1)
    FIELD(PSM_NCR_ERR1_EN, SRC3, 3, 1)
    FIELD(PSM_NCR_ERR1_EN, SRC2, 2, 1)
    FIELD(PSM_NCR_ERR1_EN, SRC1, 1, 1)
    FIELD(PSM_NCR_ERR1_EN, SRC0, 0, 1)
REG32(PSM_NCR_ERR1_DIS, 0x108)
    FIELD(PSM_NCR_ERR1_DIS, SRC31, 31, 1)
    FIELD(PSM_NCR_ERR1_DIS, SRC30, 30, 1)
    FIELD(PSM_NCR_ERR1_DIS, SRC29, 29, 1)
    FIELD(PSM_NCR_ERR1_DIS, SRC28, 28, 1)
    FIELD(PSM_NCR_ERR1_DIS, SRC27, 27, 1)
    FIELD(PSM_NCR_ERR1_DIS, SRC26, 26, 1)
    FIELD(PSM_NCR_ERR1_DIS, SRC25, 25, 1)
    FIELD(PSM_NCR_ERR1_DIS, SRC24, 24, 1)
    FIELD(PSM_NCR_ERR1_DIS, SRC23, 23, 1)
    FIELD(PSM_NCR_ERR1_DIS, SRC22, 22, 1)
    FIELD(PSM_NCR_ERR1_DIS, SRC21, 21, 1)
    FIELD(PSM_NCR_ERR1_DIS, SRC20, 20, 1)
    FIELD(PSM_NCR_ERR1_DIS, SRC19, 19, 1)
    FIELD(PSM_NCR_ERR1_DIS, SRC18, 18, 1)
    FIELD(PSM_NCR_ERR1_DIS, SRC17, 17, 1)
    FIELD(PSM_NCR_ERR1_DIS, SRC16, 16, 1)
    FIELD(PSM_NCR_ERR1_DIS, SRC15, 15, 1)
    FIELD(PSM_NCR_ERR1_DIS, SRC14, 14, 1)
    FIELD(PSM_NCR_ERR1_DIS, SRC13, 13, 1)
    FIELD(PSM_NCR_ERR1_DIS, SRC12, 12, 1)
    FIELD(PSM_NCR_ERR1_DIS, SRC11, 11, 1)
    FIELD(PSM_NCR_ERR1_DIS, SRC10, 10, 1)
    FIELD(PSM_NCR_ERR1_DIS, SRC9, 9, 1)
    FIELD(PSM_NCR_ERR1_DIS, SRC8, 8, 1)
    FIELD(PSM_NCR_ERR1_DIS, SRC7, 7, 1)
    FIELD(PSM_NCR_ERR1_DIS, SRC6, 6, 1)
    FIELD(PSM_NCR_ERR1_DIS, SRC5, 5, 1)
    FIELD(PSM_NCR_ERR1_DIS, SRC4, 4, 1)
    FIELD(PSM_NCR_ERR1_DIS, SRC3, 3, 1)
    FIELD(PSM_NCR_ERR1_DIS, SRC2, 2, 1)
    FIELD(PSM_NCR_ERR1_DIS, SRC1, 1, 1)
    FIELD(PSM_NCR_ERR1_DIS, SRC0, 0, 1)
REG32(PSM_NCR_ERR2_MASK, 0x110)
    FIELD(PSM_NCR_ERR2_MASK, SRC31, 31, 1)
    FIELD(PSM_NCR_ERR2_MASK, SRC30, 30, 1)
    FIELD(PSM_NCR_ERR2_MASK, SRC29, 29, 1)
    FIELD(PSM_NCR_ERR2_MASK, SRC28, 28, 1)
    FIELD(PSM_NCR_ERR2_MASK, SRC27, 27, 1)
    FIELD(PSM_NCR_ERR2_MASK, SRC26, 26, 1)
    FIELD(PSM_NCR_ERR2_MASK, SRC25, 25, 1)
    FIELD(PSM_NCR_ERR2_MASK, SRC24, 24, 1)
    FIELD(PSM_NCR_ERR2_MASK, SRC23, 23, 1)
    FIELD(PSM_NCR_ERR2_MASK, SRC22, 22, 1)
    FIELD(PSM_NCR_ERR2_MASK, SRC21, 21, 1)
    FIELD(PSM_NCR_ERR2_MASK, SRC20, 20, 1)
    FIELD(PSM_NCR_ERR2_MASK, SRC19, 19, 1)
    FIELD(PSM_NCR_ERR2_MASK, SRC18, 18, 1)
    FIELD(PSM_NCR_ERR2_MASK, SRC17, 17, 1)
    FIELD(PSM_NCR_ERR2_MASK, SRC16, 16, 1)
    FIELD(PSM_NCR_ERR2_MASK, SRC15, 15, 1)
    FIELD(PSM_NCR_ERR2_MASK, SRC14, 14, 1)
    FIELD(PSM_NCR_ERR2_MASK, SRC13, 13, 1)
    FIELD(PSM_NCR_ERR2_MASK, SRC12, 12, 1)
    FIELD(PSM_NCR_ERR2_MASK, SRC11, 11, 1)
    FIELD(PSM_NCR_ERR2_MASK, SRC10, 10, 1)
    FIELD(PSM_NCR_ERR2_MASK, SRC9, 9, 1)
    FIELD(PSM_NCR_ERR2_MASK, SRC8, 8, 1)
    FIELD(PSM_NCR_ERR2_MASK, SRC7, 7, 1)
    FIELD(PSM_NCR_ERR2_MASK, SRC6, 6, 1)
    FIELD(PSM_NCR_ERR2_MASK, SRC5, 5, 1)
    FIELD(PSM_NCR_ERR2_MASK, SRC4, 4, 1)
    FIELD(PSM_NCR_ERR2_MASK, SRC3, 3, 1)
    FIELD(PSM_NCR_ERR2_MASK, SRC2, 2, 1)
    FIELD(PSM_NCR_ERR2_MASK, SRC1, 1, 1)
    FIELD(PSM_NCR_ERR2_MASK, SRC0, 0, 1)
REG32(PSM_NCR_ERR2_EN, 0x114)
    FIELD(PSM_NCR_ERR2_EN, SRC31, 31, 1)
    FIELD(PSM_NCR_ERR2_EN, SRC30, 30, 1)
    FIELD(PSM_NCR_ERR2_EN, SRC29, 29, 1)
    FIELD(PSM_NCR_ERR2_EN, SRC28, 28, 1)
    FIELD(PSM_NCR_ERR2_EN, SRC27, 27, 1)
    FIELD(PSM_NCR_ERR2_EN, SRC26, 26, 1)
    FIELD(PSM_NCR_ERR2_EN, SRC25, 25, 1)
    FIELD(PSM_NCR_ERR2_EN, SRC24, 24, 1)
    FIELD(PSM_NCR_ERR2_EN, SRC23, 23, 1)
    FIELD(PSM_NCR_ERR2_EN, SRC22, 22, 1)
    FIELD(PSM_NCR_ERR2_EN, SRC21, 21, 1)
    FIELD(PSM_NCR_ERR2_EN, SRC20, 20, 1)
    FIELD(PSM_NCR_ERR2_EN, SRC19, 19, 1)
    FIELD(PSM_NCR_ERR2_EN, SRC18, 18, 1)
    FIELD(PSM_NCR_ERR2_EN, SRC17, 17, 1)
    FIELD(PSM_NCR_ERR2_EN, SRC16, 16, 1)
    FIELD(PSM_NCR_ERR2_EN, SRC15, 15, 1)
    FIELD(PSM_NCR_ERR2_EN, SRC14, 14, 1)
    FIELD(PSM_NCR_ERR2_EN, SRC13, 13, 1)
    FIELD(PSM_NCR_ERR2_EN, SRC12, 12, 1)
    FIELD(PSM_NCR_ERR2_EN, SRC11, 11, 1)
    FIELD(PSM_NCR_ERR2_EN, SRC10, 10, 1)
    FIELD(PSM_NCR_ERR2_EN, SRC9, 9, 1)
    FIELD(PSM_NCR_ERR2_EN, SRC8, 8, 1)
    FIELD(PSM_NCR_ERR2_EN, SRC7, 7, 1)
    FIELD(PSM_NCR_ERR2_EN, SRC6, 6, 1)
    FIELD(PSM_NCR_ERR2_EN, SRC5, 5, 1)
    FIELD(PSM_NCR_ERR2_EN, SRC4, 4, 1)
    FIELD(PSM_NCR_ERR2_EN, SRC3, 3, 1)
    FIELD(PSM_NCR_ERR2_EN, SRC2, 2, 1)
    FIELD(PSM_NCR_ERR2_EN, SRC1, 1, 1)
    FIELD(PSM_NCR_ERR2_EN, SRC0, 0, 1)
REG32(PSM_NCR_ERR2_DIS, 0x118)
    FIELD(PSM_NCR_ERR2_DIS, SRC31, 31, 1)
    FIELD(PSM_NCR_ERR2_DIS, SRC30, 30, 1)
    FIELD(PSM_NCR_ERR2_DIS, SRC29, 29, 1)
    FIELD(PSM_NCR_ERR2_DIS, SRC28, 28, 1)
    FIELD(PSM_NCR_ERR2_DIS, SRC27, 27, 1)
    FIELD(PSM_NCR_ERR2_DIS, SRC26, 26, 1)
    FIELD(PSM_NCR_ERR2_DIS, SRC25, 25, 1)
    FIELD(PSM_NCR_ERR2_DIS, SRC24, 24, 1)
    FIELD(PSM_NCR_ERR2_DIS, SRC23, 23, 1)
    FIELD(PSM_NCR_ERR2_DIS, SRC22, 22, 1)
    FIELD(PSM_NCR_ERR2_DIS, SRC21, 21, 1)
    FIELD(PSM_NCR_ERR2_DIS, SRC20, 20, 1)
    FIELD(PSM_NCR_ERR2_DIS, SRC19, 19, 1)
    FIELD(PSM_NCR_ERR2_DIS, SRC18, 18, 1)
    FIELD(PSM_NCR_ERR2_DIS, SRC17, 17, 1)
    FIELD(PSM_NCR_ERR2_DIS, SRC16, 16, 1)
    FIELD(PSM_NCR_ERR2_DIS, SRC15, 15, 1)
    FIELD(PSM_NCR_ERR2_DIS, SRC14, 14, 1)
    FIELD(PSM_NCR_ERR2_DIS, SRC13, 13, 1)
    FIELD(PSM_NCR_ERR2_DIS, SRC12, 12, 1)
    FIELD(PSM_NCR_ERR2_DIS, SRC11, 11, 1)
    FIELD(PSM_NCR_ERR2_DIS, SRC10, 10, 1)
    FIELD(PSM_NCR_ERR2_DIS, SRC9, 9, 1)
    FIELD(PSM_NCR_ERR2_DIS, SRC8, 8, 1)
    FIELD(PSM_NCR_ERR2_DIS, SRC7, 7, 1)
    FIELD(PSM_NCR_ERR2_DIS, SRC6, 6, 1)
    FIELD(PSM_NCR_ERR2_DIS, SRC5, 5, 1)
    FIELD(PSM_NCR_ERR2_DIS, SRC4, 4, 1)
    FIELD(PSM_NCR_ERR2_DIS, SRC3, 3, 1)
    FIELD(PSM_NCR_ERR2_DIS, SRC2, 2, 1)
    FIELD(PSM_NCR_ERR2_DIS, SRC1, 1, 1)
    FIELD(PSM_NCR_ERR2_DIS, SRC0, 0, 1)
REG32(PSM_NCR_ERR3_MASK, 0x120)
    FIELD(PSM_NCR_ERR3_MASK, SRC31, 31, 1)
    FIELD(PSM_NCR_ERR3_MASK, SRC30, 30, 1)
    FIELD(PSM_NCR_ERR3_MASK, SRC29, 29, 1)
    FIELD(PSM_NCR_ERR3_MASK, SRC28, 28, 1)
    FIELD(PSM_NCR_ERR3_MASK, SRC27, 27, 1)
    FIELD(PSM_NCR_ERR3_MASK, SRC26, 26, 1)
    FIELD(PSM_NCR_ERR3_MASK, SRC25, 25, 1)
    FIELD(PSM_NCR_ERR3_MASK, SRC24, 24, 1)
    FIELD(PSM_NCR_ERR3_MASK, SRC23, 23, 1)
    FIELD(PSM_NCR_ERR3_MASK, SRC22, 22, 1)
    FIELD(PSM_NCR_ERR3_MASK, SRC21, 21, 1)
    FIELD(PSM_NCR_ERR3_MASK, SRC20, 20, 1)
    FIELD(PSM_NCR_ERR3_MASK, SRC19, 19, 1)
    FIELD(PSM_NCR_ERR3_MASK, SRC18, 18, 1)
    FIELD(PSM_NCR_ERR3_MASK, SRC17, 17, 1)
    FIELD(PSM_NCR_ERR3_MASK, SRC16, 16, 1)
    FIELD(PSM_NCR_ERR3_MASK, SRC15, 15, 1)
    FIELD(PSM_NCR_ERR3_MASK, SRC14, 14, 1)
    FIELD(PSM_NCR_ERR3_MASK, SRC13, 13, 1)
    FIELD(PSM_NCR_ERR3_MASK, SRC12, 12, 1)
    FIELD(PSM_NCR_ERR3_MASK, SRC11, 11, 1)
    FIELD(PSM_NCR_ERR3_MASK, SRC10, 10, 1)
    FIELD(PSM_NCR_ERR3_MASK, SRC9, 9, 1)
    FIELD(PSM_NCR_ERR3_MASK, SRC8, 8, 1)
    FIELD(PSM_NCR_ERR3_MASK, SRC7, 7, 1)
    FIELD(PSM_NCR_ERR3_MASK, SRC6, 6, 1)
    FIELD(PSM_NCR_ERR3_MASK, SRC5, 5, 1)
    FIELD(PSM_NCR_ERR3_MASK, SRC4, 4, 1)
    FIELD(PSM_NCR_ERR3_MASK, SRC3, 3, 1)
    FIELD(PSM_NCR_ERR3_MASK, SRC2, 2, 1)
    FIELD(PSM_NCR_ERR3_MASK, SRC1, 1, 1)
    FIELD(PSM_NCR_ERR3_MASK, SRC0, 0, 1)
REG32(PSM_NCR_ERR3_EN, 0x124)
    FIELD(PSM_NCR_ERR3_EN, SRC31, 31, 1)
    FIELD(PSM_NCR_ERR3_EN, SRC30, 30, 1)
    FIELD(PSM_NCR_ERR3_EN, SRC29, 29, 1)
    FIELD(PSM_NCR_ERR3_EN, SRC28, 28, 1)
    FIELD(PSM_NCR_ERR3_EN, SRC27, 27, 1)
    FIELD(PSM_NCR_ERR3_EN, SRC26, 26, 1)
    FIELD(PSM_NCR_ERR3_EN, SRC25, 25, 1)
    FIELD(PSM_NCR_ERR3_EN, SRC24, 24, 1)
    FIELD(PSM_NCR_ERR3_EN, SRC23, 23, 1)
    FIELD(PSM_NCR_ERR3_EN, SRC22, 22, 1)
    FIELD(PSM_NCR_ERR3_EN, SRC21, 21, 1)
    FIELD(PSM_NCR_ERR3_EN, SRC20, 20, 1)
    FIELD(PSM_NCR_ERR3_EN, SRC19, 19, 1)
    FIELD(PSM_NCR_ERR3_EN, SRC18, 18, 1)
    FIELD(PSM_NCR_ERR3_EN, SRC17, 17, 1)
    FIELD(PSM_NCR_ERR3_EN, SRC16, 16, 1)
    FIELD(PSM_NCR_ERR3_EN, SRC15, 15, 1)
    FIELD(PSM_NCR_ERR3_EN, SRC14, 14, 1)
    FIELD(PSM_NCR_ERR3_EN, SRC13, 13, 1)
    FIELD(PSM_NCR_ERR3_EN, SRC12, 12, 1)
    FIELD(PSM_NCR_ERR3_EN, SRC11, 11, 1)
    FIELD(PSM_NCR_ERR3_EN, SRC10, 10, 1)
    FIELD(PSM_NCR_ERR3_EN, SRC9, 9, 1)
    FIELD(PSM_NCR_ERR3_EN, SRC8, 8, 1)
    FIELD(PSM_NCR_ERR3_EN, SRC7, 7, 1)
    FIELD(PSM_NCR_ERR3_EN, SRC6, 6, 1)
    FIELD(PSM_NCR_ERR3_EN, SRC5, 5, 1)
    FIELD(PSM_NCR_ERR3_EN, SRC4, 4, 1)
    FIELD(PSM_NCR_ERR3_EN, SRC3, 3, 1)
    FIELD(PSM_NCR_ERR3_EN, SRC2, 2, 1)
    FIELD(PSM_NCR_ERR3_EN, SRC1, 1, 1)
    FIELD(PSM_NCR_ERR3_EN, SRC0, 0, 1)
REG32(PSM_NCR_ERR3_DIS, 0x128)
    FIELD(PSM_NCR_ERR3_DIS, SRC31, 31, 1)
    FIELD(PSM_NCR_ERR3_DIS, SRC30, 30, 1)
    FIELD(PSM_NCR_ERR3_DIS, SRC29, 29, 1)
    FIELD(PSM_NCR_ERR3_DIS, SRC28, 28, 1)
    FIELD(PSM_NCR_ERR3_DIS, SRC27, 27, 1)
    FIELD(PSM_NCR_ERR3_DIS, SRC26, 26, 1)
    FIELD(PSM_NCR_ERR3_DIS, SRC25, 25, 1)
    FIELD(PSM_NCR_ERR3_DIS, SRC24, 24, 1)
    FIELD(PSM_NCR_ERR3_DIS, SRC23, 23, 1)
    FIELD(PSM_NCR_ERR3_DIS, SRC22, 22, 1)
    FIELD(PSM_NCR_ERR3_DIS, SRC21, 21, 1)
    FIELD(PSM_NCR_ERR3_DIS, SRC20, 20, 1)
    FIELD(PSM_NCR_ERR3_DIS, SRC19, 19, 1)
    FIELD(PSM_NCR_ERR3_DIS, SRC18, 18, 1)
    FIELD(PSM_NCR_ERR3_DIS, SRC17, 17, 1)
    FIELD(PSM_NCR_ERR3_DIS, SRC16, 16, 1)
    FIELD(PSM_NCR_ERR3_DIS, SRC15, 15, 1)
    FIELD(PSM_NCR_ERR3_DIS, SRC14, 14, 1)
    FIELD(PSM_NCR_ERR3_DIS, SRC13, 13, 1)
    FIELD(PSM_NCR_ERR3_DIS, SRC12, 12, 1)
    FIELD(PSM_NCR_ERR3_DIS, SRC11, 11, 1)
    FIELD(PSM_NCR_ERR3_DIS, SRC10, 10, 1)
    FIELD(PSM_NCR_ERR3_DIS, SRC9, 9, 1)
    FIELD(PSM_NCR_ERR3_DIS, SRC8, 8, 1)
    FIELD(PSM_NCR_ERR3_DIS, SRC7, 7, 1)
    FIELD(PSM_NCR_ERR3_DIS, SRC6, 6, 1)
    FIELD(PSM_NCR_ERR3_DIS, SRC5, 5, 1)
    FIELD(PSM_NCR_ERR3_DIS, SRC4, 4, 1)
    FIELD(PSM_NCR_ERR3_DIS, SRC3, 3, 1)
    FIELD(PSM_NCR_ERR3_DIS, SRC2, 2, 1)
    FIELD(PSM_NCR_ERR3_DIS, SRC1, 1, 1)
    FIELD(PSM_NCR_ERR3_DIS, SRC0, 0, 1)
REG32(PSM_NCR_ERR4_MASK, 0x130)
    FIELD(PSM_NCR_ERR4_MASK, SRC31, 31, 1)
    FIELD(PSM_NCR_ERR4_MASK, SRC30, 30, 1)
    FIELD(PSM_NCR_ERR4_MASK, SRC29, 29, 1)
    FIELD(PSM_NCR_ERR4_MASK, SRC28, 28, 1)
    FIELD(PSM_NCR_ERR4_MASK, SRC27, 27, 1)
    FIELD(PSM_NCR_ERR4_MASK, SRC26, 26, 1)
    FIELD(PSM_NCR_ERR4_MASK, SRC25, 25, 1)
    FIELD(PSM_NCR_ERR4_MASK, SRC24, 24, 1)
    FIELD(PSM_NCR_ERR4_MASK, SRC23, 23, 1)
    FIELD(PSM_NCR_ERR4_MASK, SRC22, 22, 1)
    FIELD(PSM_NCR_ERR4_MASK, SRC21, 21, 1)
    FIELD(PSM_NCR_ERR4_MASK, SRC20, 20, 1)
    FIELD(PSM_NCR_ERR4_MASK, SRC19, 19, 1)
    FIELD(PSM_NCR_ERR4_MASK, SRC18, 18, 1)
    FIELD(PSM_NCR_ERR4_MASK, SRC17, 17, 1)
    FIELD(PSM_NCR_ERR4_MASK, SRC16, 16, 1)
    FIELD(PSM_NCR_ERR4_MASK, SRC15, 15, 1)
    FIELD(PSM_NCR_ERR4_MASK, SRC14, 14, 1)
    FIELD(PSM_NCR_ERR4_MASK, SRC13, 13, 1)
    FIELD(PSM_NCR_ERR4_MASK, SRC12, 12, 1)
    FIELD(PSM_NCR_ERR4_MASK, SRC11, 11, 1)
    FIELD(PSM_NCR_ERR4_MASK, SRC10, 10, 1)
    FIELD(PSM_NCR_ERR4_MASK, SRC9, 9, 1)
    FIELD(PSM_NCR_ERR4_MASK, SRC8, 8, 1)
    FIELD(PSM_NCR_ERR4_MASK, SRC7, 7, 1)
    FIELD(PSM_NCR_ERR4_MASK, SRC6, 6, 1)
    FIELD(PSM_NCR_ERR4_MASK, SRC5, 5, 1)
    FIELD(PSM_NCR_ERR4_MASK, SRC4, 4, 1)
    FIELD(PSM_NCR_ERR4_MASK, SRC3, 3, 1)
    FIELD(PSM_NCR_ERR4_MASK, SRC2, 2, 1)
    FIELD(PSM_NCR_ERR4_MASK, SRC1, 1, 1)
    FIELD(PSM_NCR_ERR4_MASK, SRC0, 0, 1)
REG32(PSM_NCR_ERR4_EN, 0x134)
    FIELD(PSM_NCR_ERR4_EN, SRC31, 31, 1)
    FIELD(PSM_NCR_ERR4_EN, SRC30, 30, 1)
    FIELD(PSM_NCR_ERR4_EN, SRC29, 29, 1)
    FIELD(PSM_NCR_ERR4_EN, SRC28, 28, 1)
    FIELD(PSM_NCR_ERR4_EN, SRC27, 27, 1)
    FIELD(PSM_NCR_ERR4_EN, SRC26, 26, 1)
    FIELD(PSM_NCR_ERR4_EN, SRC25, 25, 1)
    FIELD(PSM_NCR_ERR4_EN, SRC24, 24, 1)
    FIELD(PSM_NCR_ERR4_EN, SRC23, 23, 1)
    FIELD(PSM_NCR_ERR4_EN, SRC22, 22, 1)
    FIELD(PSM_NCR_ERR4_EN, SRC21, 21, 1)
    FIELD(PSM_NCR_ERR4_EN, SRC20, 20, 1)
    FIELD(PSM_NCR_ERR4_EN, SRC19, 19, 1)
    FIELD(PSM_NCR_ERR4_EN, SRC18, 18, 1)
    FIELD(PSM_NCR_ERR4_EN, SRC17, 17, 1)
    FIELD(PSM_NCR_ERR4_EN, SRC16, 16, 1)
    FIELD(PSM_NCR_ERR4_EN, SRC15, 15, 1)
    FIELD(PSM_NCR_ERR4_EN, SRC14, 14, 1)
    FIELD(PSM_NCR_ERR4_EN, SRC13, 13, 1)
    FIELD(PSM_NCR_ERR4_EN, SRC12, 12, 1)
    FIELD(PSM_NCR_ERR4_EN, SRC11, 11, 1)
    FIELD(PSM_NCR_ERR4_EN, SRC10, 10, 1)
    FIELD(PSM_NCR_ERR4_EN, SRC9, 9, 1)
    FIELD(PSM_NCR_ERR4_EN, SRC8, 8, 1)
    FIELD(PSM_NCR_ERR4_EN, SRC7, 7, 1)
    FIELD(PSM_NCR_ERR4_EN, SRC6, 6, 1)
    FIELD(PSM_NCR_ERR4_EN, SRC5, 5, 1)
    FIELD(PSM_NCR_ERR4_EN, SRC4, 4, 1)
    FIELD(PSM_NCR_ERR4_EN, SRC3, 3, 1)
    FIELD(PSM_NCR_ERR4_EN, SRC2, 2, 1)
    FIELD(PSM_NCR_ERR4_EN, SRC1, 1, 1)
    FIELD(PSM_NCR_ERR4_EN, SRC0, 0, 1)
REG32(PSM_NCR_ERR4_DIS, 0x138)
    FIELD(PSM_NCR_ERR4_DIS, SRC31, 31, 1)
    FIELD(PSM_NCR_ERR4_DIS, SRC30, 30, 1)
    FIELD(PSM_NCR_ERR4_DIS, SRC29, 29, 1)
    FIELD(PSM_NCR_ERR4_DIS, SRC28, 28, 1)
    FIELD(PSM_NCR_ERR4_DIS, SRC27, 27, 1)
    FIELD(PSM_NCR_ERR4_DIS, SRC26, 26, 1)
    FIELD(PSM_NCR_ERR4_DIS, SRC25, 25, 1)
    FIELD(PSM_NCR_ERR4_DIS, SRC24, 24, 1)
    FIELD(PSM_NCR_ERR4_DIS, SRC23, 23, 1)
    FIELD(PSM_NCR_ERR4_DIS, SRC22, 22, 1)
    FIELD(PSM_NCR_ERR4_DIS, SRC21, 21, 1)
    FIELD(PSM_NCR_ERR4_DIS, SRC20, 20, 1)
    FIELD(PSM_NCR_ERR4_DIS, SRC19, 19, 1)
    FIELD(PSM_NCR_ERR4_DIS, SRC18, 18, 1)
    FIELD(PSM_NCR_ERR4_DIS, SRC17, 17, 1)
    FIELD(PSM_NCR_ERR4_DIS, SRC16, 16, 1)
    FIELD(PSM_NCR_ERR4_DIS, SRC15, 15, 1)
    FIELD(PSM_NCR_ERR4_DIS, SRC14, 14, 1)
    FIELD(PSM_NCR_ERR4_DIS, SRC13, 13, 1)
    FIELD(PSM_NCR_ERR4_DIS, SRC12, 12, 1)
    FIELD(PSM_NCR_ERR4_DIS, SRC11, 11, 1)
    FIELD(PSM_NCR_ERR4_DIS, SRC10, 10, 1)
    FIELD(PSM_NCR_ERR4_DIS, SRC9, 9, 1)
    FIELD(PSM_NCR_ERR4_DIS, SRC8, 8, 1)
    FIELD(PSM_NCR_ERR4_DIS, SRC7, 7, 1)
    FIELD(PSM_NCR_ERR4_DIS, SRC6, 6, 1)
    FIELD(PSM_NCR_ERR4_DIS, SRC5, 5, 1)
    FIELD(PSM_NCR_ERR4_DIS, SRC4, 4, 1)
    FIELD(PSM_NCR_ERR4_DIS, SRC3, 3, 1)
    FIELD(PSM_NCR_ERR4_DIS, SRC2, 2, 1)
    FIELD(PSM_NCR_ERR4_DIS, SRC1, 1, 1)
    FIELD(PSM_NCR_ERR4_DIS, SRC0, 0, 1)
REG32(PSM_IRQ1_MASK, 0x190)
    FIELD(PSM_IRQ1_MASK, SRC31, 31, 1)
    FIELD(PSM_IRQ1_MASK, SRC30, 30, 1)
    FIELD(PSM_IRQ1_MASK, SRC29, 29, 1)
    FIELD(PSM_IRQ1_MASK, SRC28, 28, 1)
    FIELD(PSM_IRQ1_MASK, SRC27, 27, 1)
    FIELD(PSM_IRQ1_MASK, SRC26, 26, 1)
    FIELD(PSM_IRQ1_MASK, SRC25, 25, 1)
    FIELD(PSM_IRQ1_MASK, SRC24, 24, 1)
    FIELD(PSM_IRQ1_MASK, SRC23, 23, 1)
    FIELD(PSM_IRQ1_MASK, SRC22, 22, 1)
    FIELD(PSM_IRQ1_MASK, SRC21, 21, 1)
    FIELD(PSM_IRQ1_MASK, SRC20, 20, 1)
    FIELD(PSM_IRQ1_MASK, SRC19, 19, 1)
    FIELD(PSM_IRQ1_MASK, SRC18, 18, 1)
    FIELD(PSM_IRQ1_MASK, SRC17, 17, 1)
    FIELD(PSM_IRQ1_MASK, SRC16, 16, 1)
    FIELD(PSM_IRQ1_MASK, SRC15, 15, 1)
    FIELD(PSM_IRQ1_MASK, SRC14, 14, 1)
    FIELD(PSM_IRQ1_MASK, SRC13, 13, 1)
    FIELD(PSM_IRQ1_MASK, SRC12, 12, 1)
    FIELD(PSM_IRQ1_MASK, SRC11, 11, 1)
    FIELD(PSM_IRQ1_MASK, SRC10, 10, 1)
    FIELD(PSM_IRQ1_MASK, SRC9, 9, 1)
    FIELD(PSM_IRQ1_MASK, SRC8, 8, 1)
    FIELD(PSM_IRQ1_MASK, SRC7, 7, 1)
    FIELD(PSM_IRQ1_MASK, SRC6, 6, 1)
    FIELD(PSM_IRQ1_MASK, SRC5, 5, 1)
    FIELD(PSM_IRQ1_MASK, SRC4, 4, 1)
    FIELD(PSM_IRQ1_MASK, SRC3, 3, 1)
    FIELD(PSM_IRQ1_MASK, SRC2, 2, 1)
    FIELD(PSM_IRQ1_MASK, SRC1, 1, 1)
    FIELD(PSM_IRQ1_MASK, SRC0, 0, 1)
REG32(PSM_IRQ1_EN, 0x194)
    FIELD(PSM_IRQ1_EN, SRC31, 31, 1)
    FIELD(PSM_IRQ1_EN, SRC30, 30, 1)
    FIELD(PSM_IRQ1_EN, SRC29, 29, 1)
    FIELD(PSM_IRQ1_EN, SRC28, 28, 1)
    FIELD(PSM_IRQ1_EN, SRC27, 27, 1)
    FIELD(PSM_IRQ1_EN, SRC26, 26, 1)
    FIELD(PSM_IRQ1_EN, SRC25, 25, 1)
    FIELD(PSM_IRQ1_EN, SRC24, 24, 1)
    FIELD(PSM_IRQ1_EN, SRC23, 23, 1)
    FIELD(PSM_IRQ1_EN, SRC22, 22, 1)
    FIELD(PSM_IRQ1_EN, SRC21, 21, 1)
    FIELD(PSM_IRQ1_EN, SRC20, 20, 1)
    FIELD(PSM_IRQ1_EN, SRC19, 19, 1)
    FIELD(PSM_IRQ1_EN, SRC18, 18, 1)
    FIELD(PSM_IRQ1_EN, SRC17, 17, 1)
    FIELD(PSM_IRQ1_EN, SRC16, 16, 1)
    FIELD(PSM_IRQ1_EN, SRC15, 15, 1)
    FIELD(PSM_IRQ1_EN, SRC14, 14, 1)
    FIELD(PSM_IRQ1_EN, SRC13, 13, 1)
    FIELD(PSM_IRQ1_EN, SRC12, 12, 1)
    FIELD(PSM_IRQ1_EN, SRC11, 11, 1)
    FIELD(PSM_IRQ1_EN, SRC10, 10, 1)
    FIELD(PSM_IRQ1_EN, SRC9, 9, 1)
    FIELD(PSM_IRQ1_EN, SRC8, 8, 1)
    FIELD(PSM_IRQ1_EN, SRC7, 7, 1)
    FIELD(PSM_IRQ1_EN, SRC6, 6, 1)
    FIELD(PSM_IRQ1_EN, SRC5, 5, 1)
    FIELD(PSM_IRQ1_EN, SRC4, 4, 1)
    FIELD(PSM_IRQ1_EN, SRC3, 3, 1)
    FIELD(PSM_IRQ1_EN, SRC2, 2, 1)
    FIELD(PSM_IRQ1_EN, SRC1, 1, 1)
    FIELD(PSM_IRQ1_EN, SRC0, 0, 1)
REG32(PSM_IRQ1_DIS, 0x1a8)
    FIELD(PSM_IRQ1_DIS, SRC31, 31, 1)
    FIELD(PSM_IRQ1_DIS, SRC30, 30, 1)
    FIELD(PSM_IRQ1_DIS, SRC29, 29, 1)
    FIELD(PSM_IRQ1_DIS, SRC28, 28, 1)
    FIELD(PSM_IRQ1_DIS, SRC27, 27, 1)
    FIELD(PSM_IRQ1_DIS, SRC26, 26, 1)
    FIELD(PSM_IRQ1_DIS, SRC25, 25, 1)
    FIELD(PSM_IRQ1_DIS, SRC24, 24, 1)
    FIELD(PSM_IRQ1_DIS, SRC23, 23, 1)
    FIELD(PSM_IRQ1_DIS, SRC22, 22, 1)
    FIELD(PSM_IRQ1_DIS, SRC21, 21, 1)
    FIELD(PSM_IRQ1_DIS, SRC20, 20, 1)
    FIELD(PSM_IRQ1_DIS, SRC19, 19, 1)
    FIELD(PSM_IRQ1_DIS, SRC18, 18, 1)
    FIELD(PSM_IRQ1_DIS, SRC17, 17, 1)
    FIELD(PSM_IRQ1_DIS, SRC16, 16, 1)
    FIELD(PSM_IRQ1_DIS, SRC15, 15, 1)
    FIELD(PSM_IRQ1_DIS, SRC14, 14, 1)
    FIELD(PSM_IRQ1_DIS, SRC13, 13, 1)
    FIELD(PSM_IRQ1_DIS, SRC12, 12, 1)
    FIELD(PSM_IRQ1_DIS, SRC11, 11, 1)
    FIELD(PSM_IRQ1_DIS, SRC10, 10, 1)
    FIELD(PSM_IRQ1_DIS, SRC9, 9, 1)
    FIELD(PSM_IRQ1_DIS, SRC8, 8, 1)
    FIELD(PSM_IRQ1_DIS, SRC7, 7, 1)
    FIELD(PSM_IRQ1_DIS, SRC6, 6, 1)
    FIELD(PSM_IRQ1_DIS, SRC5, 5, 1)
    FIELD(PSM_IRQ1_DIS, SRC4, 4, 1)
    FIELD(PSM_IRQ1_DIS, SRC3, 3, 1)
    FIELD(PSM_IRQ1_DIS, SRC2, 2, 1)
    FIELD(PSM_IRQ1_DIS, SRC1, 1, 1)
    FIELD(PSM_IRQ1_DIS, SRC0, 0, 1)
REG32(PSM_IRQ2_MASK, 0x1b0)
    FIELD(PSM_IRQ2_MASK, SRC31, 31, 1)
    FIELD(PSM_IRQ2_MASK, SRC30, 30, 1)
    FIELD(PSM_IRQ2_MASK, SRC29, 29, 1)
    FIELD(PSM_IRQ2_MASK, SRC28, 28, 1)
    FIELD(PSM_IRQ2_MASK, SRC27, 27, 1)
    FIELD(PSM_IRQ2_MASK, SRC26, 26, 1)
    FIELD(PSM_IRQ2_MASK, SRC25, 25, 1)
    FIELD(PSM_IRQ2_MASK, SRC24, 24, 1)
    FIELD(PSM_IRQ2_MASK, SRC23, 23, 1)
    FIELD(PSM_IRQ2_MASK, SRC22, 22, 1)
    FIELD(PSM_IRQ2_MASK, SRC21, 21, 1)
    FIELD(PSM_IRQ2_MASK, SRC20, 20, 1)
    FIELD(PSM_IRQ2_MASK, SRC19, 19, 1)
    FIELD(PSM_IRQ2_MASK, SRC18, 18, 1)
    FIELD(PSM_IRQ2_MASK, SRC17, 17, 1)
    FIELD(PSM_IRQ2_MASK, SRC16, 16, 1)
    FIELD(PSM_IRQ2_MASK, SRC15, 15, 1)
    FIELD(PSM_IRQ2_MASK, SRC14, 14, 1)
    FIELD(PSM_IRQ2_MASK, SRC13, 13, 1)
    FIELD(PSM_IRQ2_MASK, SRC12, 12, 1)
    FIELD(PSM_IRQ2_MASK, SRC11, 11, 1)
    FIELD(PSM_IRQ2_MASK, SRC10, 10, 1)
    FIELD(PSM_IRQ2_MASK, SRC9, 9, 1)
    FIELD(PSM_IRQ2_MASK, SRC8, 8, 1)
    FIELD(PSM_IRQ2_MASK, SRC7, 7, 1)
    FIELD(PSM_IRQ2_MASK, SRC6, 6, 1)
    FIELD(PSM_IRQ2_MASK, SRC5, 5, 1)
    FIELD(PSM_IRQ2_MASK, SRC4, 4, 1)
    FIELD(PSM_IRQ2_MASK, SRC3, 3, 1)
    FIELD(PSM_IRQ2_MASK, SRC2, 2, 1)
    FIELD(PSM_IRQ2_MASK, SRC1, 1, 1)
    FIELD(PSM_IRQ2_MASK, SRC0, 0, 1)
REG32(PSM_IRQ2_EN, 0x1b4)
    FIELD(PSM_IRQ2_EN, SRC31, 31, 1)
    FIELD(PSM_IRQ2_EN, SRC30, 30, 1)
    FIELD(PSM_IRQ2_EN, SRC29, 29, 1)
    FIELD(PSM_IRQ2_EN, SRC28, 28, 1)
    FIELD(PSM_IRQ2_EN, SRC27, 27, 1)
    FIELD(PSM_IRQ2_EN, SRC26, 26, 1)
    FIELD(PSM_IRQ2_EN, SRC25, 25, 1)
    FIELD(PSM_IRQ2_EN, SRC24, 24, 1)
    FIELD(PSM_IRQ2_EN, SRC23, 23, 1)
    FIELD(PSM_IRQ2_EN, SRC22, 22, 1)
    FIELD(PSM_IRQ2_EN, SRC21, 21, 1)
    FIELD(PSM_IRQ2_EN, SRC20, 20, 1)
    FIELD(PSM_IRQ2_EN, SRC19, 19, 1)
    FIELD(PSM_IRQ2_EN, SRC18, 18, 1)
    FIELD(PSM_IRQ2_EN, SRC17, 17, 1)
    FIELD(PSM_IRQ2_EN, SRC16, 16, 1)
    FIELD(PSM_IRQ2_EN, SRC15, 15, 1)
    FIELD(PSM_IRQ2_EN, SRC14, 14, 1)
    FIELD(PSM_IRQ2_EN, SRC13, 13, 1)
    FIELD(PSM_IRQ2_EN, SRC12, 12, 1)
    FIELD(PSM_IRQ2_EN, SRC11, 11, 1)
    FIELD(PSM_IRQ2_EN, SRC10, 10, 1)
    FIELD(PSM_IRQ2_EN, SRC9, 9, 1)
    FIELD(PSM_IRQ2_EN, SRC8, 8, 1)
    FIELD(PSM_IRQ2_EN, SRC7, 7, 1)
    FIELD(PSM_IRQ2_EN, SRC6, 6, 1)
    FIELD(PSM_IRQ2_EN, SRC5, 5, 1)
    FIELD(PSM_IRQ2_EN, SRC4, 4, 1)
    FIELD(PSM_IRQ2_EN, SRC3, 3, 1)
    FIELD(PSM_IRQ2_EN, SRC2, 2, 1)
    FIELD(PSM_IRQ2_EN, SRC1, 1, 1)
    FIELD(PSM_IRQ2_EN, SRC0, 0, 1)
REG32(PSM_IRQ2_DIS, 0x1b8)
    FIELD(PSM_IRQ2_DIS, SRC31, 31, 1)
    FIELD(PSM_IRQ2_DIS, SRC30, 30, 1)
    FIELD(PSM_IRQ2_DIS, SRC29, 29, 1)
    FIELD(PSM_IRQ2_DIS, SRC28, 28, 1)
    FIELD(PSM_IRQ2_DIS, SRC27, 27, 1)
    FIELD(PSM_IRQ2_DIS, SRC26, 26, 1)
    FIELD(PSM_IRQ2_DIS, SRC25, 25, 1)
    FIELD(PSM_IRQ2_DIS, SRC24, 24, 1)
    FIELD(PSM_IRQ2_DIS, SRC23, 23, 1)
    FIELD(PSM_IRQ2_DIS, SRC22, 22, 1)
    FIELD(PSM_IRQ2_DIS, SRC21, 21, 1)
    FIELD(PSM_IRQ2_DIS, SRC20, 20, 1)
    FIELD(PSM_IRQ2_DIS, SRC19, 19, 1)
    FIELD(PSM_IRQ2_DIS, SRC18, 18, 1)
    FIELD(PSM_IRQ2_DIS, SRC17, 17, 1)
    FIELD(PSM_IRQ2_DIS, SRC16, 16, 1)
    FIELD(PSM_IRQ2_DIS, SRC15, 15, 1)
    FIELD(PSM_IRQ2_DIS, SRC14, 14, 1)
    FIELD(PSM_IRQ2_DIS, SRC13, 13, 1)
    FIELD(PSM_IRQ2_DIS, SRC12, 12, 1)
    FIELD(PSM_IRQ2_DIS, SRC11, 11, 1)
    FIELD(PSM_IRQ2_DIS, SRC10, 10, 1)
    FIELD(PSM_IRQ2_DIS, SRC9, 9, 1)
    FIELD(PSM_IRQ2_DIS, SRC8, 8, 1)
    FIELD(PSM_IRQ2_DIS, SRC7, 7, 1)
    FIELD(PSM_IRQ2_DIS, SRC6, 6, 1)
    FIELD(PSM_IRQ2_DIS, SRC5, 5, 1)
    FIELD(PSM_IRQ2_DIS, SRC4, 4, 1)
    FIELD(PSM_IRQ2_DIS, SRC3, 3, 1)
    FIELD(PSM_IRQ2_DIS, SRC2, 2, 1)
    FIELD(PSM_IRQ2_DIS, SRC1, 1, 1)
    FIELD(PSM_IRQ2_DIS, SRC0, 0, 1)
REG32(PSM_IRQ3_MASK, 0x1c0)
    FIELD(PSM_IRQ3_MASK, SRC31, 31, 1)
    FIELD(PSM_IRQ3_MASK, SRC30, 30, 1)
    FIELD(PSM_IRQ3_MASK, SRC29, 29, 1)
    FIELD(PSM_IRQ3_MASK, SRC28, 28, 1)
    FIELD(PSM_IRQ3_MASK, SRC27, 27, 1)
    FIELD(PSM_IRQ3_MASK, SRC26, 26, 1)
    FIELD(PSM_IRQ3_MASK, SRC25, 25, 1)
    FIELD(PSM_IRQ3_MASK, SRC24, 24, 1)
    FIELD(PSM_IRQ3_MASK, SRC23, 23, 1)
    FIELD(PSM_IRQ3_MASK, SRC22, 22, 1)
    FIELD(PSM_IRQ3_MASK, SRC21, 21, 1)
    FIELD(PSM_IRQ3_MASK, SRC20, 20, 1)
    FIELD(PSM_IRQ3_MASK, SRC19, 19, 1)
    FIELD(PSM_IRQ3_MASK, SRC18, 18, 1)
    FIELD(PSM_IRQ3_MASK, SRC17, 17, 1)
    FIELD(PSM_IRQ3_MASK, SRC16, 16, 1)
    FIELD(PSM_IRQ3_MASK, SRC15, 15, 1)
    FIELD(PSM_IRQ3_MASK, SRC14, 14, 1)
    FIELD(PSM_IRQ3_MASK, SRC13, 13, 1)
    FIELD(PSM_IRQ3_MASK, SRC12, 12, 1)
    FIELD(PSM_IRQ3_MASK, SRC11, 11, 1)
    FIELD(PSM_IRQ3_MASK, SRC10, 10, 1)
    FIELD(PSM_IRQ3_MASK, SRC9, 9, 1)
    FIELD(PSM_IRQ3_MASK, SRC8, 8, 1)
    FIELD(PSM_IRQ3_MASK, SRC7, 7, 1)
    FIELD(PSM_IRQ3_MASK, SRC6, 6, 1)
    FIELD(PSM_IRQ3_MASK, SRC5, 5, 1)
    FIELD(PSM_IRQ3_MASK, SRC4, 4, 1)
    FIELD(PSM_IRQ3_MASK, SRC3, 3, 1)
    FIELD(PSM_IRQ3_MASK, SRC2, 2, 1)
    FIELD(PSM_IRQ3_MASK, SRC1, 1, 1)
    FIELD(PSM_IRQ3_MASK, SRC0, 0, 1)
REG32(PSM_IRQ3_EN, 0x1c4)
    FIELD(PSM_IRQ3_EN, SRC31, 31, 1)
    FIELD(PSM_IRQ3_EN, SRC30, 30, 1)
    FIELD(PSM_IRQ3_EN, SRC29, 29, 1)
    FIELD(PSM_IRQ3_EN, SRC28, 28, 1)
    FIELD(PSM_IRQ3_EN, SRC27, 27, 1)
    FIELD(PSM_IRQ3_EN, SRC26, 26, 1)
    FIELD(PSM_IRQ3_EN, SRC25, 25, 1)
    FIELD(PSM_IRQ3_EN, SRC24, 24, 1)
    FIELD(PSM_IRQ3_EN, SRC23, 23, 1)
    FIELD(PSM_IRQ3_EN, SRC22, 22, 1)
    FIELD(PSM_IRQ3_EN, SRC21, 21, 1)
    FIELD(PSM_IRQ3_EN, SRC20, 20, 1)
    FIELD(PSM_IRQ3_EN, SRC19, 19, 1)
    FIELD(PSM_IRQ3_EN, SRC18, 18, 1)
    FIELD(PSM_IRQ3_EN, SRC17, 17, 1)
    FIELD(PSM_IRQ3_EN, SRC16, 16, 1)
    FIELD(PSM_IRQ3_EN, SRC15, 15, 1)
    FIELD(PSM_IRQ3_EN, SRC14, 14, 1)
    FIELD(PSM_IRQ3_EN, SRC13, 13, 1)
    FIELD(PSM_IRQ3_EN, SRC12, 12, 1)
    FIELD(PSM_IRQ3_EN, SRC11, 11, 1)
    FIELD(PSM_IRQ3_EN, SRC10, 10, 1)
    FIELD(PSM_IRQ3_EN, SRC9, 9, 1)
    FIELD(PSM_IRQ3_EN, SRC8, 8, 1)
    FIELD(PSM_IRQ3_EN, SRC7, 7, 1)
    FIELD(PSM_IRQ3_EN, SRC6, 6, 1)
    FIELD(PSM_IRQ3_EN, SRC5, 5, 1)
    FIELD(PSM_IRQ3_EN, SRC4, 4, 1)
    FIELD(PSM_IRQ3_EN, SRC3, 3, 1)
    FIELD(PSM_IRQ3_EN, SRC2, 2, 1)
    FIELD(PSM_IRQ3_EN, SRC1, 1, 1)
    FIELD(PSM_IRQ3_EN, SRC0, 0, 1)
REG32(PSM_IRQ3_DIS, 0x1c8)
    FIELD(PSM_IRQ3_DIS, SRC31, 31, 1)
    FIELD(PSM_IRQ3_DIS, SRC30, 30, 1)
    FIELD(PSM_IRQ3_DIS, SRC29, 29, 1)
    FIELD(PSM_IRQ3_DIS, SRC28, 28, 1)
    FIELD(PSM_IRQ3_DIS, SRC27, 27, 1)
    FIELD(PSM_IRQ3_DIS, SRC26, 26, 1)
    FIELD(PSM_IRQ3_DIS, SRC25, 25, 1)
    FIELD(PSM_IRQ3_DIS, SRC24, 24, 1)
    FIELD(PSM_IRQ3_DIS, SRC23, 23, 1)
    FIELD(PSM_IRQ3_DIS, SRC22, 22, 1)
    FIELD(PSM_IRQ3_DIS, SRC21, 21, 1)
    FIELD(PSM_IRQ3_DIS, SRC20, 20, 1)
    FIELD(PSM_IRQ3_DIS, SRC19, 19, 1)
    FIELD(PSM_IRQ3_DIS, SRC18, 18, 1)
    FIELD(PSM_IRQ3_DIS, SRC17, 17, 1)
    FIELD(PSM_IRQ3_DIS, SRC16, 16, 1)
    FIELD(PSM_IRQ3_DIS, SRC15, 15, 1)
    FIELD(PSM_IRQ3_DIS, SRC14, 14, 1)
    FIELD(PSM_IRQ3_DIS, SRC13, 13, 1)
    FIELD(PSM_IRQ3_DIS, SRC12, 12, 1)
    FIELD(PSM_IRQ3_DIS, SRC11, 11, 1)
    FIELD(PSM_IRQ3_DIS, SRC10, 10, 1)
    FIELD(PSM_IRQ3_DIS, SRC9, 9, 1)
    FIELD(PSM_IRQ3_DIS, SRC8, 8, 1)
    FIELD(PSM_IRQ3_DIS, SRC7, 7, 1)
    FIELD(PSM_IRQ3_DIS, SRC6, 6, 1)
    FIELD(PSM_IRQ3_DIS, SRC5, 5, 1)
    FIELD(PSM_IRQ3_DIS, SRC4, 4, 1)
    FIELD(PSM_IRQ3_DIS, SRC3, 3, 1)
    FIELD(PSM_IRQ3_DIS, SRC2, 2, 1)
    FIELD(PSM_IRQ3_DIS, SRC1, 1, 1)
    FIELD(PSM_IRQ3_DIS, SRC0, 0, 1)
REG32(PSM_IRQ4_MASK, 0x200)
    FIELD(PSM_IRQ4_MASK, SRC31, 31, 1)
    FIELD(PSM_IRQ4_MASK, SRC30, 30, 1)
    FIELD(PSM_IRQ4_MASK, SRC29, 29, 1)
    FIELD(PSM_IRQ4_MASK, SRC28, 28, 1)
    FIELD(PSM_IRQ4_MASK, SRC27, 27, 1)
    FIELD(PSM_IRQ4_MASK, SRC26, 26, 1)
    FIELD(PSM_IRQ4_MASK, SRC25, 25, 1)
    FIELD(PSM_IRQ4_MASK, SRC24, 24, 1)
    FIELD(PSM_IRQ4_MASK, SRC23, 23, 1)
    FIELD(PSM_IRQ4_MASK, SRC22, 22, 1)
    FIELD(PSM_IRQ4_MASK, SRC21, 21, 1)
    FIELD(PSM_IRQ4_MASK, SRC20, 20, 1)
    FIELD(PSM_IRQ4_MASK, SRC19, 19, 1)
    FIELD(PSM_IRQ4_MASK, SRC18, 18, 1)
    FIELD(PSM_IRQ4_MASK, SRC17, 17, 1)
    FIELD(PSM_IRQ4_MASK, SRC16, 16, 1)
    FIELD(PSM_IRQ4_MASK, SRC15, 15, 1)
    FIELD(PSM_IRQ4_MASK, SRC14, 14, 1)
    FIELD(PSM_IRQ4_MASK, SRC13, 13, 1)
    FIELD(PSM_IRQ4_MASK, SRC12, 12, 1)
    FIELD(PSM_IRQ4_MASK, SRC11, 11, 1)
    FIELD(PSM_IRQ4_MASK, SRC10, 10, 1)
    FIELD(PSM_IRQ4_MASK, SRC9, 9, 1)
    FIELD(PSM_IRQ4_MASK, SRC8, 8, 1)
    FIELD(PSM_IRQ4_MASK, SRC7, 7, 1)
    FIELD(PSM_IRQ4_MASK, SRC6, 6, 1)
    FIELD(PSM_IRQ4_MASK, SRC5, 5, 1)
    FIELD(PSM_IRQ4_MASK, SRC4, 4, 1)
    FIELD(PSM_IRQ4_MASK, SRC3, 3, 1)
    FIELD(PSM_IRQ4_MASK, SRC2, 2, 1)
    FIELD(PSM_IRQ4_MASK, SRC1, 1, 1)
    FIELD(PSM_IRQ4_MASK, SRC0, 0, 1)
REG32(PSM_IRQ4_EN, 0x204)
    FIELD(PSM_IRQ4_EN, SRC31, 31, 1)
    FIELD(PSM_IRQ4_EN, SRC30, 30, 1)
    FIELD(PSM_IRQ4_EN, SRC29, 29, 1)
    FIELD(PSM_IRQ4_EN, SRC28, 28, 1)
    FIELD(PSM_IRQ4_EN, SRC27, 27, 1)
    FIELD(PSM_IRQ4_EN, SRC26, 26, 1)
    FIELD(PSM_IRQ4_EN, SRC25, 25, 1)
    FIELD(PSM_IRQ4_EN, SRC24, 24, 1)
    FIELD(PSM_IRQ4_EN, SRC23, 23, 1)
    FIELD(PSM_IRQ4_EN, SRC22, 22, 1)
    FIELD(PSM_IRQ4_EN, SRC21, 21, 1)
    FIELD(PSM_IRQ4_EN, SRC20, 20, 1)
    FIELD(PSM_IRQ4_EN, SRC19, 19, 1)
    FIELD(PSM_IRQ4_EN, SRC18, 18, 1)
    FIELD(PSM_IRQ4_EN, SRC17, 17, 1)
    FIELD(PSM_IRQ4_EN, SRC16, 16, 1)
    FIELD(PSM_IRQ4_EN, SRC15, 15, 1)
    FIELD(PSM_IRQ4_EN, SRC14, 14, 1)
    FIELD(PSM_IRQ4_EN, SRC13, 13, 1)
    FIELD(PSM_IRQ4_EN, SRC12, 12, 1)
    FIELD(PSM_IRQ4_EN, SRC11, 11, 1)
    FIELD(PSM_IRQ4_EN, SRC10, 10, 1)
    FIELD(PSM_IRQ4_EN, SRC9, 9, 1)
    FIELD(PSM_IRQ4_EN, SRC8, 8, 1)
    FIELD(PSM_IRQ4_EN, SRC7, 7, 1)
    FIELD(PSM_IRQ4_EN, SRC6, 6, 1)
    FIELD(PSM_IRQ4_EN, SRC5, 5, 1)
    FIELD(PSM_IRQ4_EN, SRC4, 4, 1)
    FIELD(PSM_IRQ4_EN, SRC3, 3, 1)
    FIELD(PSM_IRQ4_EN, SRC2, 2, 1)
    FIELD(PSM_IRQ4_EN, SRC1, 1, 1)
    FIELD(PSM_IRQ4_EN, SRC0, 0, 1)
REG32(PSM_IRQ4_DIS, 0x208)
    FIELD(PSM_IRQ4_DIS, SRC31, 31, 1)
    FIELD(PSM_IRQ4_DIS, SRC30, 30, 1)
    FIELD(PSM_IRQ4_DIS, SRC29, 29, 1)
    FIELD(PSM_IRQ4_DIS, SRC28, 28, 1)
    FIELD(PSM_IRQ4_DIS, SRC27, 27, 1)
    FIELD(PSM_IRQ4_DIS, SRC26, 26, 1)
    FIELD(PSM_IRQ4_DIS, SRC25, 25, 1)
    FIELD(PSM_IRQ4_DIS, SRC24, 24, 1)
    FIELD(PSM_IRQ4_DIS, SRC23, 23, 1)
    FIELD(PSM_IRQ4_DIS, SRC22, 22, 1)
    FIELD(PSM_IRQ4_DIS, SRC21, 21, 1)
    FIELD(PSM_IRQ4_DIS, SRC20, 20, 1)
    FIELD(PSM_IRQ4_DIS, SRC19, 19, 1)
    FIELD(PSM_IRQ4_DIS, SRC18, 18, 1)
    FIELD(PSM_IRQ4_DIS, SRC17, 17, 1)
    FIELD(PSM_IRQ4_DIS, SRC16, 16, 1)
    FIELD(PSM_IRQ4_DIS, SRC15, 15, 1)
    FIELD(PSM_IRQ4_DIS, SRC14, 14, 1)
    FIELD(PSM_IRQ4_DIS, SRC13, 13, 1)
    FIELD(PSM_IRQ4_DIS, SRC12, 12, 1)
    FIELD(PSM_IRQ4_DIS, SRC11, 11, 1)
    FIELD(PSM_IRQ4_DIS, SRC10, 10, 1)
    FIELD(PSM_IRQ4_DIS, SRC9, 9, 1)
    FIELD(PSM_IRQ4_DIS, SRC8, 8, 1)
    FIELD(PSM_IRQ4_DIS, SRC7, 7, 1)
    FIELD(PSM_IRQ4_DIS, SRC6, 6, 1)
    FIELD(PSM_IRQ4_DIS, SRC5, 5, 1)
    FIELD(PSM_IRQ4_DIS, SRC4, 4, 1)
    FIELD(PSM_IRQ4_DIS, SRC3, 3, 1)
    FIELD(PSM_IRQ4_DIS, SRC2, 2, 1)
    FIELD(PSM_IRQ4_DIS, SRC1, 1, 1)
    FIELD(PSM_IRQ4_DIS, SRC0, 0, 1)

#define PSMX_ERR_REG_R_MAX (R_PSM_IRQ4_DIS + 1)

typedef struct PSMX_ERR_REG {
    SysBusDevice parent_obj;
    MemoryRegion iomem;

    uint32_t regs[PSMX_ERR_REG_R_MAX];
    RegisterInfo regs_info[PSMX_ERR_REG_R_MAX];
} PSMX_ERR_REG;

static void psmx_err_int_en(RegisterInfo *reg, uint64_t val)
{
    PSMX_ERR_REG *s = XILINX_PSMX_ERR_REG(reg->opaque);
    uint32_t val32 = val;

    switch (reg->access->addr) {
    case A_PSM_CR_ERR1_EN:
        s->regs[R_PSM_CR_ERR1_MASK] &= ~(val32);
        break;
    case A_PSM_CR_ERR2_EN:
        s->regs[R_PSM_CR_ERR2_MASK] &= ~(val32);
        break;
    case A_PSM_CR_ERR3_EN:
        s->regs[R_PSM_CR_ERR3_MASK] &= ~(val32);
        break;
    case A_PSM_CR_ERR4_EN:
        s->regs[R_PSM_CR_ERR4_MASK] &= ~(val32);
        break;
    case A_PSM_NCR_ERR1_EN:
        s->regs[R_PSM_NCR_ERR1_MASK] &= ~(val32);
        break;
    case A_PSM_NCR_ERR2_EN:
        s->regs[R_PSM_NCR_ERR2_MASK] &= ~(val32);
        break;
    case A_PSM_NCR_ERR3_EN:
        s->regs[R_PSM_NCR_ERR3_MASK] &= ~(val32);
        break;
    case A_PSM_NCR_ERR4_EN:
        s->regs[R_PSM_NCR_ERR4_MASK] &= ~(val32);
        break;
    case A_PSM_IRQ1_EN:
        s->regs[R_PSM_IRQ1_MASK] &= ~(val32);
        break;
    case A_PSM_IRQ2_EN:
        s->regs[R_PSM_IRQ2_MASK] &= ~(val32);
        break;
    case A_PSM_IRQ3_EN:
        s->regs[R_PSM_IRQ3_MASK] &= ~(val32);
        break;
    case A_PSM_IRQ4_EN:
        s->regs[R_PSM_IRQ4_MASK] &= ~(val32);
        break;
    };
}

static void psmx_err_int_dis(RegisterInfo *reg, uint64_t val)
{
    PSMX_ERR_REG *s = XILINX_PSMX_ERR_REG(reg->opaque);
    uint32_t val32 = val;

    switch (reg->access->addr) {
    case A_PSM_CR_ERR1_DIS:
        s->regs[R_PSM_CR_ERR1_MASK] |= val32;
        break;
    case A_PSM_CR_ERR2_DIS:
        s->regs[R_PSM_CR_ERR2_MASK] |= val32;
        break;
    case A_PSM_CR_ERR3_DIS:
        s->regs[R_PSM_CR_ERR3_MASK] |= val32;
        break;
    case A_PSM_CR_ERR4_DIS:
        s->regs[R_PSM_CR_ERR4_MASK] |= val32;
        break;
    case A_PSM_NCR_ERR1_DIS:
        s->regs[R_PSM_NCR_ERR1_MASK] |= val32;
        break;
    case A_PSM_NCR_ERR2_DIS:
        s->regs[R_PSM_NCR_ERR2_MASK] |= val32;
        break;
    case A_PSM_NCR_ERR3_DIS:
        s->regs[R_PSM_NCR_ERR3_MASK] |= val32;
        break;
    case A_PSM_NCR_ERR4_DIS:
        s->regs[R_PSM_NCR_ERR4_MASK] |= val32;
        break;
    case A_PSM_IRQ1_DIS:
        s->regs[R_PSM_IRQ1_MASK] |= val32;
        break;
    case A_PSM_IRQ2_DIS:
        s->regs[R_PSM_IRQ2_MASK] |= val32;
        break;
    case A_PSM_IRQ3_DIS:
        s->regs[R_PSM_IRQ3_MASK] |= val32;
        break;
    case A_PSM_IRQ4_DIS:
        s->regs[R_PSM_IRQ4_MASK] |= val32;
        break;
    };
}
static const RegisterAccessInfo psmx_err_reg_regs_info[] = {
    {   .name = "PSM_ERR1_STATUS",  .addr = A_PSM_ERR1_STATUS,
        .w1c = 0xffffffff,
    },{ .name = "PSM_ERR2_STATUS",  .addr = A_PSM_ERR2_STATUS,
        .w1c = 0xffffffff,
    },{ .name = "PSM_ERR3_STATUS",  .addr = A_PSM_ERR3_STATUS,
        .w1c = 0xffffffff,
    },{ .name = "PSM_ERR4_STATUS",  .addr = A_PSM_ERR4_STATUS,
        .w1c = 0xffffffff,
    },{ .name = "PSM_ERR1_TRIG",  .addr = A_PSM_ERR1_TRIG,
    },{ .name = "PSM_ERR2_TRIG",  .addr = A_PSM_ERR2_TRIG,
    },{ .name = "PSM_ERR3_TRIG",  .addr = A_PSM_ERR3_TRIG,
    },{ .name = "PSM_ERR4_TRIG",  .addr = A_PSM_ERR4_TRIG,
    },{ .name = "PSM_CR_ERR1_MASK",  .addr = A_PSM_CR_ERR1_MASK,
        .reset = 0xffffffff,
        .ro = 0xffffffff,
    },{ .name = "PSM_CR_ERR1_EN",  .addr = A_PSM_CR_ERR1_EN,
        .post_write = psmx_err_int_en,
    },{ .name = "PSM_CR_ERR1_DIS",  .addr = A_PSM_CR_ERR1_DIS,
        .post_write = psmx_err_int_dis,
    },{ .name = "PSM_CR_ERR2_MASK",  .addr = A_PSM_CR_ERR2_MASK,
        .reset = 0xffffffff,
        .ro = 0xffffffff,
    },{ .name = "PSM_CR_ERR2_EN",  .addr = A_PSM_CR_ERR2_EN,
        .post_write = psmx_err_int_en,
    },{ .name = "PSM_CR_ERR2_DIS",  .addr = A_PSM_CR_ERR2_DIS,
        .post_write = psmx_err_int_dis,
    },{ .name = "PSM_CR_ERR3_MASK",  .addr = A_PSM_CR_ERR3_MASK,
        .reset = 0xffffffff,
        .ro = 0xffffffff,
    },{ .name = "PSM_CR_ERR3_EN",  .addr = A_PSM_CR_ERR3_EN,
        .post_write = psmx_err_int_en,
    },{ .name = "PSM_CR_ERR3_DIS",  .addr = A_PSM_CR_ERR3_DIS,
        .post_write = psmx_err_int_dis,
    },{ .name = "PSM_CR_ERR4_MASK",  .addr = A_PSM_CR_ERR4_MASK,
        .reset = 0xffffffff,
        .ro = 0xffffffff,
    },{ .name = "PSM_CR_ERR4_EN",  .addr = A_PSM_CR_ERR4_EN,
        .post_write = psmx_err_int_en,
    },{ .name = "PSM_CR_ERR4_DIS",  .addr = A_PSM_CR_ERR4_DIS,
        .post_write = psmx_err_int_dis,
    },{ .name = "PSM_NCR_ERR1_MASK",  .addr = A_PSM_NCR_ERR1_MASK,
        .reset = 0xffffffff,
        .ro = 0xffffffff,
    },{ .name = "PSM_NCR_ERR1_EN",  .addr = A_PSM_NCR_ERR1_EN,
        .post_write = psmx_err_int_en,
    },{ .name = "PSM_NCR_ERR1_DIS",  .addr = A_PSM_NCR_ERR1_DIS,
        .post_write = psmx_err_int_dis,
    },{ .name = "PSM_NCR_ERR2_MASK",  .addr = A_PSM_NCR_ERR2_MASK,
        .reset = 0xffffffff,
        .ro = 0xffffffff,
    },{ .name = "PSM_NCR_ERR2_EN",  .addr = A_PSM_NCR_ERR2_EN,
        .post_write = psmx_err_int_en,
    },{ .name = "PSM_NCR_ERR2_DIS",  .addr = A_PSM_NCR_ERR2_DIS,
        .post_write = psmx_err_int_dis,
    },{ .name = "PSM_NCR_ERR3_MASK",  .addr = A_PSM_NCR_ERR3_MASK,
        .reset = 0xffffffff,
        .ro = 0xffffffff,
    },{ .name = "PSM_NCR_ERR3_EN",  .addr = A_PSM_NCR_ERR3_EN,
        .post_write = psmx_err_int_en,
    },{ .name = "PSM_NCR_ERR3_DIS",  .addr = A_PSM_NCR_ERR3_DIS,
        .post_write = psmx_err_int_dis,
    },{ .name = "PSM_NCR_ERR4_MASK",  .addr = A_PSM_NCR_ERR4_MASK,
        .reset = 0xffffffff,
        .ro = 0xffffffff,
    },{ .name = "PSM_NCR_ERR4_EN",  .addr = A_PSM_NCR_ERR4_EN,
        .post_write = psmx_err_int_en,
    },{ .name = "PSM_NCR_ERR4_DIS",  .addr = A_PSM_NCR_ERR4_DIS,
        .post_write = psmx_err_int_dis,
    },{ .name = "PSM_IRQ1_MASK",  .addr = A_PSM_IRQ1_MASK,
        .reset = 0xffffffff,
        .ro = 0xffffffff,
    },{ .name = "PSM_IRQ1_EN",  .addr = A_PSM_IRQ1_EN,
        .post_write = psmx_err_int_en,
    },{ .name = "PSM_IRQ1_DIS",  .addr = A_PSM_IRQ1_DIS,
        .post_write = psmx_err_int_dis,
    },{ .name = "PSM_IRQ2_MASK",  .addr = A_PSM_IRQ2_MASK,
        .reset = 0xffffffff,
        .ro = 0xffffffff,
    },{ .name = "PSM_IRQ2_EN",  .addr = A_PSM_IRQ2_EN,
        .post_write = psmx_err_int_en,
    },{ .name = "PSM_IRQ2_DIS",  .addr = A_PSM_IRQ2_DIS,
        .post_write = psmx_err_int_dis,
    },{ .name = "PSM_IRQ3_MASK",  .addr = A_PSM_IRQ3_MASK,
        .reset = 0xffffffff,
        .ro = 0xffffffff,
    },{ .name = "PSM_IRQ3_EN",  .addr = A_PSM_IRQ3_EN,
        .post_write = psmx_err_int_en,
    },{ .name = "PSM_IRQ3_DIS",  .addr = A_PSM_IRQ3_DIS,
        .post_write = psmx_err_int_dis,
    },{ .name = "PSM_IRQ4_MASK",  .addr = A_PSM_IRQ4_MASK,
        .reset = 0xffffffff,
        .ro = 0xffffffff,
    },{ .name = "PSM_IRQ4_EN",  .addr = A_PSM_IRQ4_EN,
        .post_write = psmx_err_int_en,
    },{ .name = "PSM_IRQ4_DIS",  .addr = A_PSM_IRQ4_DIS,
        .post_write = psmx_err_int_dis,
    }
};

static void psmx_err_reg_reset_enter(Object *obj, ResetType type)
{
    PSMX_ERR_REG *s = XILINX_PSMX_ERR_REG(obj);
    unsigned int i;

    for (i = 0; i < ARRAY_SIZE(s->regs_info); ++i) {
        register_reset(&s->regs_info[i]);
    }
}

static const MemoryRegionOps psmx_err_reg_ops = {
    .read = register_read_memory,
    .write = register_write_memory,
    .endianness = DEVICE_LITTLE_ENDIAN,
    .valid = {
        .min_access_size = 4,
        .max_access_size = 4,
    },
};

static void psmx_err_reg_init(Object *obj)
{
    PSMX_ERR_REG *s = XILINX_PSMX_ERR_REG(obj);
    SysBusDevice *sbd = SYS_BUS_DEVICE(obj);
    RegisterInfoArray *reg_array;

    memory_region_init(&s->iomem, obj, TYPE_XILINX_PSMX_ERR_REG,
                       PSMX_ERR_REG_R_MAX * 4);
    reg_array =
        register_init_block32(DEVICE(obj), psmx_err_reg_regs_info,
                              ARRAY_SIZE(psmx_err_reg_regs_info),
                              s->regs_info, s->regs,
                              &psmx_err_reg_ops,
                              XILINX_PSMX_ERR_REG_ERR_DEBUG,
                              PSMX_ERR_REG_R_MAX * 4);
    memory_region_add_subregion(&s->iomem,
                                0x0,
                                &reg_array->mem);
    sysbus_init_mmio(sbd, &s->iomem);
}

static const VMStateDescription vmstate_psmx_err_reg = {
    .name = TYPE_XILINX_PSMX_ERR_REG,
    .version_id = 1,
    .minimum_version_id = 1,
    .fields = (VMStateField[]) {
        VMSTATE_UINT32_ARRAY(regs, PSMX_ERR_REG, PSMX_ERR_REG_R_MAX),
        VMSTATE_END_OF_LIST(),
    }
};

static void psmx_err_reg_class_init(ObjectClass *klass, void *data)
{
    ResettableClass *rc = RESETTABLE_CLASS(klass);
    DeviceClass *dc = DEVICE_CLASS(klass);

    dc->vmsd = &vmstate_psmx_err_reg;
    rc->phases.enter = psmx_err_reg_reset_enter;
}

static const TypeInfo psmx_err_reg_info = {
    .name          = TYPE_XILINX_PSMX_ERR_REG,
    .parent        = TYPE_SYS_BUS_DEVICE,
    .instance_size = sizeof(PSMX_ERR_REG),
    .class_init    = psmx_err_reg_class_init,
    .instance_init = psmx_err_reg_init,
};

static void psmx_err_reg_register_types(void)
{
    type_register_static(&psmx_err_reg_info);
}

type_init(psmx_err_reg_register_types)
