/*
 * QEMU model of the CMN top level component for the CMN-600AE
 *
 * Copyright (c) 2021 Xilinx Inc.
 *
 * Partially autogenerated by xregqemu.py 2021-03-06.
 * Written by Edgar E. Iglesias
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
 * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 */

#include "qemu/osdep.h"
#include "hw/sysbus.h"
#include "hw/register.h"
#include "qemu/bitops.h"
#include "qemu/log.h"
#include "migration/vmstate.h"

#ifndef ARM_CMN_ERR_DEBUG
#define ARM_CMN_ERR_DEBUG 0
#endif

#define TYPE_ARM_CMN "arm,cmn600ae"

#define ARM_CMN(obj) \
     OBJECT_CHECK(CMN600AE, (obj), TYPE_ARM_CMN)

REG32(POR_SBSX_NODE_INFO_U_SBSX_NID0, 0x0)
    FIELD(POR_SBSX_NODE_INFO_U_SBSX_NID0, RESERVED_48, 48, 16)
    FIELD(POR_SBSX_NODE_INFO_U_SBSX_NID0, LOGICAL_ID, 32, 16)
    FIELD(POR_SBSX_NODE_INFO_U_SBSX_NID0, NODE_ID, 16, 16)
    FIELD(POR_SBSX_NODE_INFO_U_SBSX_NID0, NODE_TYPE, 0, 16)
REG32(POR_SBSX_CHILD_INFO_U_SBSX_NID0, 0x80)
    FIELD(POR_SBSX_CHILD_INFO_U_SBSX_NID0, RESERVED_32, 32, 32)
    FIELD(POR_SBSX_CHILD_INFO_U_SBSX_NID0, CHILD_PTR_OFFSET, 16, 16)
    FIELD(POR_SBSX_CHILD_INFO_U_SBSX_NID0, CHILD_COUNT, 0, 16)
REG32(POR_SBSX_UNIT_INFO_U_SBSX_NID0, 0x900)
    FIELD(POR_SBSX_UNIT_INFO_U_SBSX_NID0, RESERVED_22, 22, 42)
    FIELD(POR_SBSX_UNIT_INFO_U_SBSX_NID0, ACEL_SAFE_XFACE_DISABLE, 21, 1)
    FIELD(POR_SBSX_UNIT_INFO_U_SBSX_NID0, NUM_WR_DATA_BUF, 16, 5)
    FIELD(POR_SBSX_UNIT_INFO_U_SBSX_NID0, NUM_OUTSTANDING_READS, 8, 8)
    FIELD(POR_SBSX_UNIT_INFO_U_SBSX_NID0, AXDATA_POISON_EN, 4, 1)
    FIELD(POR_SBSX_UNIT_INFO_U_SBSX_NID0, AXDATA_WIDTH, 0, 1)
REG32(POR_SBSX_AUX_CTL_U_SBSX_NID0, 0xa08)
    FIELD(POR_SBSX_AUX_CTL_U_SBSX_NID0, CLKGATE_DISABLE, 0, 1)
REG32(POR_SBSX_PMU_EVENT_SEL_U_SBSX_NID0, 0x2000)
    FIELD(POR_SBSX_PMU_EVENT_SEL_U_SBSX_NID0, RESERVED_30, 30, 34)
    FIELD(POR_SBSX_PMU_EVENT_SEL_U_SBSX_NID0, PMU_EVENT3_ID, 24, 6)
    FIELD(POR_SBSX_PMU_EVENT_SEL_U_SBSX_NID0, RESERVED_22, 22, 2)
    FIELD(POR_SBSX_PMU_EVENT_SEL_U_SBSX_NID0, PMU_EVENT2_ID, 16, 6)
    FIELD(POR_SBSX_PMU_EVENT_SEL_U_SBSX_NID0, RESERVED_14, 14, 2)
    FIELD(POR_SBSX_PMU_EVENT_SEL_U_SBSX_NID0, PMU_EVENT1_ID, 8, 6)
    FIELD(POR_SBSX_PMU_EVENT_SEL_U_SBSX_NID0, PMU_EVENT0_ID, 0, 6)
REG32(POR_SBSX_ERRFR_U_SBSX_NID0, 0x3000)
    FIELD(POR_SBSX_ERRFR_U_SBSX_NID0, RESERVED_15, 15, 49)
    FIELD(POR_SBSX_ERRFR_U_SBSX_NID0, CEC, 12, 3)
    FIELD(POR_SBSX_ERRFR_U_SBSX_NID0, CFI, 10, 2)
    FIELD(POR_SBSX_ERRFR_U_SBSX_NID0, FI, 6, 2)
    FIELD(POR_SBSX_ERRFR_U_SBSX_NID0, UI, 4, 2)
    FIELD(POR_SBSX_ERRFR_U_SBSX_NID0, DE, 2, 2)
    FIELD(POR_SBSX_ERRFR_U_SBSX_NID0, ED, 0, 2)
REG32(POR_SBSX_ERRCTLR_U_SBSX_NID0, 0x3008)
    FIELD(POR_SBSX_ERRCTLR_U_SBSX_NID0, RESERVED_9, 9, 55)
    FIELD(POR_SBSX_ERRCTLR_U_SBSX_NID0, CFI, 8, 1)
    FIELD(POR_SBSX_ERRCTLR_U_SBSX_NID0, FI, 3, 1)
    FIELD(POR_SBSX_ERRCTLR_U_SBSX_NID0, UI, 2, 1)
    FIELD(POR_SBSX_ERRCTLR_U_SBSX_NID0, DE, 1, 1)
    FIELD(POR_SBSX_ERRCTLR_U_SBSX_NID0, ED, 0, 1)
REG32(POR_SBSX_ERRSTATUS_U_SBSX_NID0, 0x3010)
    FIELD(POR_SBSX_ERRSTATUS_U_SBSX_NID0, RESERVED_32, 32, 32)
    FIELD(POR_SBSX_ERRSTATUS_U_SBSX_NID0, AV, 31, 1)
    FIELD(POR_SBSX_ERRSTATUS_U_SBSX_NID0, V, 30, 1)
    FIELD(POR_SBSX_ERRSTATUS_U_SBSX_NID0, UE, 29, 1)
    FIELD(POR_SBSX_ERRSTATUS_U_SBSX_NID0, RESERVED_28, 28, 1)
    FIELD(POR_SBSX_ERRSTATUS_U_SBSX_NID0, OF, 27, 1)
    FIELD(POR_SBSX_ERRSTATUS_U_SBSX_NID0, MV, 26, 1)
    FIELD(POR_SBSX_ERRSTATUS_U_SBSX_NID0, RESERVED_25, 25, 1)
    FIELD(POR_SBSX_ERRSTATUS_U_SBSX_NID0, CE, 24, 1)
    FIELD(POR_SBSX_ERRSTATUS_U_SBSX_NID0, DE, 23, 1)
    FIELD(POR_SBSX_ERRSTATUS_U_SBSX_NID0, RESERVED_0, 0, 23)
REG32(POR_SBSX_ERRADDR_U_SBSX_NID0, 0x3018)
    FIELD(POR_SBSX_ERRADDR_U_SBSX_NID0, NS, 63, 1)
    FIELD(POR_SBSX_ERRADDR_U_SBSX_NID0, RESERVED_48, 48, 15)
    FIELD(POR_SBSX_ERRADDR_U_SBSX_NID0, ADDR, 0, 48)
REG32(POR_SBSX_ERRMISC_U_SBSX_NID0, 0x3020)
    FIELD(POR_SBSX_ERRMISC_U_SBSX_NID0, RESERVED_31, 31, 33)
    FIELD(POR_SBSX_ERRMISC_U_SBSX_NID0, SIZE, 28, 3)
    FIELD(POR_SBSX_ERRMISC_U_SBSX_NID0, MEMATTR, 24, 4)
    FIELD(POR_SBSX_ERRMISC_U_SBSX_NID0, RESERVED_17, 17, 7)
    FIELD(POR_SBSX_ERRMISC_U_SBSX_NID0, OPTYPE, 16, 1)
    FIELD(POR_SBSX_ERRMISC_U_SBSX_NID0, RESERVED_15, 15, 1)
    FIELD(POR_SBSX_ERRMISC_U_SBSX_NID0, SRCID, 4, 11)
    FIELD(POR_SBSX_ERRMISC_U_SBSX_NID0, RESERVED_0, 0, 4)
REG32(POR_SBSX_ERRFR_NS_U_SBSX_NID0, 0x3100)
    FIELD(POR_SBSX_ERRFR_NS_U_SBSX_NID0, RESERVED_15, 15, 49)
    FIELD(POR_SBSX_ERRFR_NS_U_SBSX_NID0, CEC, 12, 3)
    FIELD(POR_SBSX_ERRFR_NS_U_SBSX_NID0, CFI, 10, 2)
    FIELD(POR_SBSX_ERRFR_NS_U_SBSX_NID0, FI, 6, 2)
    FIELD(POR_SBSX_ERRFR_NS_U_SBSX_NID0, UI, 4, 2)
    FIELD(POR_SBSX_ERRFR_NS_U_SBSX_NID0, DE, 2, 2)
    FIELD(POR_SBSX_ERRFR_NS_U_SBSX_NID0, ED, 0, 2)
REG32(POR_SBSX_ERRCTLR_NS_U_SBSX_NID0, 0x3108)
    FIELD(POR_SBSX_ERRCTLR_NS_U_SBSX_NID0, RESERVED_9, 9, 55)
    FIELD(POR_SBSX_ERRCTLR_NS_U_SBSX_NID0, CFI, 8, 1)
    FIELD(POR_SBSX_ERRCTLR_NS_U_SBSX_NID0, FI, 3, 1)
    FIELD(POR_SBSX_ERRCTLR_NS_U_SBSX_NID0, UI, 2, 1)
    FIELD(POR_SBSX_ERRCTLR_NS_U_SBSX_NID0, DE, 1, 1)
    FIELD(POR_SBSX_ERRCTLR_NS_U_SBSX_NID0, ED, 0, 1)
REG32(POR_SBSX_ERRSTATUS_NS_U_SBSX_NID0, 0x3110)
    FIELD(POR_SBSX_ERRSTATUS_NS_U_SBSX_NID0, RESERVED_32, 32, 32)
    FIELD(POR_SBSX_ERRSTATUS_NS_U_SBSX_NID0, AV, 31, 1)
    FIELD(POR_SBSX_ERRSTATUS_NS_U_SBSX_NID0, V, 30, 1)
    FIELD(POR_SBSX_ERRSTATUS_NS_U_SBSX_NID0, UE, 29, 1)
    FIELD(POR_SBSX_ERRSTATUS_NS_U_SBSX_NID0, RESERVED_28, 28, 1)
    FIELD(POR_SBSX_ERRSTATUS_NS_U_SBSX_NID0, OF, 27, 1)
    FIELD(POR_SBSX_ERRSTATUS_NS_U_SBSX_NID0, MV, 26, 1)
    FIELD(POR_SBSX_ERRSTATUS_NS_U_SBSX_NID0, RESERVED_25, 25, 1)
    FIELD(POR_SBSX_ERRSTATUS_NS_U_SBSX_NID0, CE, 24, 1)
    FIELD(POR_SBSX_ERRSTATUS_NS_U_SBSX_NID0, DE, 23, 1)
    FIELD(POR_SBSX_ERRSTATUS_NS_U_SBSX_NID0, RESERVED_0, 0, 23)
REG32(POR_SBSX_ERRADDR_NS_U_SBSX_NID0, 0x3118)
    FIELD(POR_SBSX_ERRADDR_NS_U_SBSX_NID0, NS, 63, 1)
    FIELD(POR_SBSX_ERRADDR_NS_U_SBSX_NID0, RESERVED_48, 48, 15)
    FIELD(POR_SBSX_ERRADDR_NS_U_SBSX_NID0, ADDR, 0, 48)
REG32(POR_SBSX_ERRMISC_NS_U_SBSX_NID0, 0x3120)
    FIELD(POR_SBSX_ERRMISC_NS_U_SBSX_NID0, RESERVED_31, 31, 33)
    FIELD(POR_SBSX_ERRMISC_NS_U_SBSX_NID0, SIZE, 28, 3)
    FIELD(POR_SBSX_ERRMISC_NS_U_SBSX_NID0, MEMATTR, 24, 4)
    FIELD(POR_SBSX_ERRMISC_NS_U_SBSX_NID0, RESERVED_17, 17, 7)
    FIELD(POR_SBSX_ERRMISC_NS_U_SBSX_NID0, OPTYPE, 16, 1)
    FIELD(POR_SBSX_ERRMISC_NS_U_SBSX_NID0, RESERVED_15, 15, 1)
    FIELD(POR_SBSX_ERRMISC_NS_U_SBSX_NID0, SRCID, 4, 11)
    FIELD(POR_SBSX_ERRMISC_NS_U_SBSX_NID0, RESERVED_0, 0, 4)
REG32(POR_MXP_NODE_INFO_U_SMXP_0_0, 0x8000)
    FIELD(POR_MXP_NODE_INFO_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MXP_NODE_INFO_U_SMXP_0_0, LOGICAL_ID, 32, 16)
    FIELD(POR_MXP_NODE_INFO_U_SMXP_0_0, XY_ID, 16, 16)
    FIELD(POR_MXP_NODE_INFO_U_SMXP_0_0, NODE_TYPE, 0, 16)
REG32(POR_MXP_DEVICE_PORT_CONNECT_INFO_P0_U_SMXP_0_0, 0x8008)
    FIELD(POR_MXP_DEVICE_PORT_CONNECT_INFO_P0_U_SMXP_0_0, RESERVED_32, 32, 32)
    FIELD(POR_MXP_DEVICE_PORT_CONNECT_INFO_P0_U_SMXP_0_0, NUM_DCS_P0_D3, 28, 4)
    FIELD(POR_MXP_DEVICE_PORT_CONNECT_INFO_P0_U_SMXP_0_0, NUM_DCS_P0_D2, 24, 4)
    FIELD(POR_MXP_DEVICE_PORT_CONNECT_INFO_P0_U_SMXP_0_0, NUM_DCS_P0_D1, 20, 4)
    FIELD(POR_MXP_DEVICE_PORT_CONNECT_INFO_P0_U_SMXP_0_0, NUM_DCS_P0_D0, 16, 4)
    FIELD(POR_MXP_DEVICE_PORT_CONNECT_INFO_P0_U_SMXP_0_0, DEVICE_TYPE_P0, 0, 5)
REG32(POR_MXP_DEVICE_PORT_CONNECT_INFO_P1_U_SMXP_0_0, 0x8010)
    FIELD(POR_MXP_DEVICE_PORT_CONNECT_INFO_P1_U_SMXP_0_0, RESERVED_32, 32, 32)
    FIELD(POR_MXP_DEVICE_PORT_CONNECT_INFO_P1_U_SMXP_0_0, NUM_DCS_P1_D3, 28, 4)
    FIELD(POR_MXP_DEVICE_PORT_CONNECT_INFO_P1_U_SMXP_0_0, NUM_DCS_P1_D2, 24, 4)
    FIELD(POR_MXP_DEVICE_PORT_CONNECT_INFO_P1_U_SMXP_0_0, NUM_DCS_P1_D1, 20, 4)
    FIELD(POR_MXP_DEVICE_PORT_CONNECT_INFO_P1_U_SMXP_0_0, NUM_DCS_P1_D0, 16, 4)
    FIELD(POR_MXP_DEVICE_PORT_CONNECT_INFO_P1_U_SMXP_0_0, DEVICE_TYPE_P1, 0, 5)
REG32(POR_MXP_MESH_PORT_CONNECT_INFO_EAST_U_SMXP_0_0, 0x8018)
    FIELD(POR_MXP_MESH_PORT_CONNECT_INFO_EAST_U_SMXP_0_0, NUM_MCS_EAST, 0, 4)
REG32(POR_MXP_MESH_PORT_CONNECT_INFO_NORTH_U_SMXP_0_0, 0x8020)
    FIELD(POR_MXP_MESH_PORT_CONNECT_INFO_NORTH_U_SMXP_0_0, NUM_MCS_NORTH, 0, 4)
REG32(POR_MXP_CHILD_INFO_U_SMXP_0_0, 0x8080)
    FIELD(POR_MXP_CHILD_INFO_U_SMXP_0_0, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_INFO_U_SMXP_0_0, CHILD_PTR_OFFSET, 16, 16)
    FIELD(POR_MXP_CHILD_INFO_U_SMXP_0_0, CHILD_COUNT, 0, 16)
REG32(POR_MXP_CHILD_POINTER_0_U_SMXP_0_0, 0x8100)
    FIELD(POR_MXP_CHILD_POINTER_0_U_SMXP_0_0, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_POINTER_0_U_SMXP_0_0, RELATIVE_ADDRESS_0, 0, 32)
REG32(POR_MXP_CHILD_POINTER_1_U_SMXP_0_0, 0x8108)
    FIELD(POR_MXP_CHILD_POINTER_1_U_SMXP_0_0, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_POINTER_1_U_SMXP_0_0, RELATIVE_ADDRESS_1, 0, 32)
REG32(POR_MXP_CHILD_POINTER_2_U_SMXP_0_0, 0x8110)
    FIELD(POR_MXP_CHILD_POINTER_2_U_SMXP_0_0, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_POINTER_2_U_SMXP_0_0, RELATIVE_ADDRESS_2, 0, 32)
REG32(POR_MXP_CHILD_POINTER_3_U_SMXP_0_0, 0x8118)
    FIELD(POR_MXP_CHILD_POINTER_3_U_SMXP_0_0, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_POINTER_3_U_SMXP_0_0, RELATIVE_ADDRESS_3, 0, 32)
REG32(POR_MXP_CHILD_POINTER_4_U_SMXP_0_0, 0x8120)
    FIELD(POR_MXP_CHILD_POINTER_4_U_SMXP_0_0, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_POINTER_4_U_SMXP_0_0, RELATIVE_ADDRESS_4, 0, 32)
REG32(POR_MXP_CHILD_POINTER_5_U_SMXP_0_0, 0x8128)
    FIELD(POR_MXP_CHILD_POINTER_5_U_SMXP_0_0, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_POINTER_5_U_SMXP_0_0, RELATIVE_ADDRESS_5, 0, 32)
REG32(POR_MXP_CHILD_POINTER_6_U_SMXP_0_0, 0x8130)
    FIELD(POR_MXP_CHILD_POINTER_6_U_SMXP_0_0, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_POINTER_6_U_SMXP_0_0, RELATIVE_ADDRESS_6, 0, 32)
REG32(POR_MXP_CHILD_POINTER_7_U_SMXP_0_0, 0x8138)
    FIELD(POR_MXP_CHILD_POINTER_7_U_SMXP_0_0, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_POINTER_7_U_SMXP_0_0, RELATIVE_ADDRESS_7, 0, 32)
REG32(POR_MXP_CHILD_POINTER_8_U_SMXP_0_0, 0x8140)
    FIELD(POR_MXP_CHILD_POINTER_8_U_SMXP_0_0, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_POINTER_8_U_SMXP_0_0, RELATIVE_ADDRESS_8, 0, 32)
REG32(POR_MXP_CHILD_POINTER_9_U_SMXP_0_0, 0x8148)
    FIELD(POR_MXP_CHILD_POINTER_9_U_SMXP_0_0, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_POINTER_9_U_SMXP_0_0, RELATIVE_ADDRESS_9, 0, 32)
REG32(POR_MXP_CHILD_POINTER_10_U_SMXP_0_0, 0x8150)
    FIELD(POR_MXP_CHILD_POINTER_10_U_SMXP_0_0, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_POINTER_10_U_SMXP_0_0, RELATIVE_ADDRESS_10, 0, 32)
REG32(POR_MXP_CHILD_POINTER_11_U_SMXP_0_0, 0x8158)
    FIELD(POR_MXP_CHILD_POINTER_11_U_SMXP_0_0, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_POINTER_11_U_SMXP_0_0, RELATIVE_ADDRESS_11, 0, 32)
REG32(POR_MXP_CHILD_POINTER_12_U_SMXP_0_0, 0x8160)
    FIELD(POR_MXP_CHILD_POINTER_12_U_SMXP_0_0, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_POINTER_12_U_SMXP_0_0, RELATIVE_ADDRESS_12, 0, 32)
REG32(POR_MXP_CHILD_POINTER_13_U_SMXP_0_0, 0x8168)
    FIELD(POR_MXP_CHILD_POINTER_13_U_SMXP_0_0, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_POINTER_13_U_SMXP_0_0, RELATIVE_ADDRESS_13, 0, 32)
REG32(POR_MXP_CHILD_POINTER_14_U_SMXP_0_0, 0x8170)
    FIELD(POR_MXP_CHILD_POINTER_14_U_SMXP_0_0, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_POINTER_14_U_SMXP_0_0, RELATIVE_ADDRESS_14, 0, 32)
REG32(POR_MXP_CHILD_POINTER_15_U_SMXP_0_0, 0x8178)
    FIELD(POR_MXP_CHILD_POINTER_15_U_SMXP_0_0, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_POINTER_15_U_SMXP_0_0, RELATIVE_ADDRESS_15, 0, 32)
REG32(POR_MXP_P0_INFO_U_SMXP_0_0, 0x8900)
    FIELD(POR_MXP_P0_INFO_U_SMXP_0_0, RESERVED_26, 26, 38)
    FIELD(POR_MXP_P0_INFO_U_SMXP_0_0, A4S_SAFE_XFACE_DISABLE_P0, 25, 1)
    FIELD(POR_MXP_P0_INFO_U_SMXP_0_0, CHI_SAFE_XFACE_DISABLE_P0, 24, 1)
    FIELD(POR_MXP_P0_INFO_U_SMXP_0_0, A4S_LOGICALID_BASE_P0, 16, 8)
    FIELD(POR_MXP_P0_INFO_U_SMXP_0_0, RESERVED_14, 14, 2)
    FIELD(POR_MXP_P0_INFO_U_SMXP_0_0, A4S_NUM_P0, 11, 3)
    FIELD(POR_MXP_P0_INFO_U_SMXP_0_0, RXBUF_NUM_ENTRIES_P0, 8, 3)
    FIELD(POR_MXP_P0_INFO_U_SMXP_0_0, EXT_SAM_EN_P0, 7, 1)
    FIELD(POR_MXP_P0_INFO_U_SMXP_0_0, DATACHECK_EN_P0, 5, 1)
    FIELD(POR_MXP_P0_INFO_U_SMXP_0_0, POISON_EN_P0, 4, 1)
    FIELD(POR_MXP_P0_INFO_U_SMXP_0_0, NUM_DEV_P0, 0, 3)
REG32(POR_MXP_P1_INFO_U_SMXP_0_0, 0x8908)
    FIELD(POR_MXP_P1_INFO_U_SMXP_0_0, RESERVED_26, 26, 38)
    FIELD(POR_MXP_P1_INFO_U_SMXP_0_0, A4S_SAFE_XFACE_DISABLE_P1, 25, 1)
    FIELD(POR_MXP_P1_INFO_U_SMXP_0_0, CHI_SAFE_XFACE_DISABLE_P1, 24, 1)
    FIELD(POR_MXP_P1_INFO_U_SMXP_0_0, A4S_LOGICALID_BASE_P1, 16, 8)
    FIELD(POR_MXP_P1_INFO_U_SMXP_0_0, RESERVED_14, 14, 2)
    FIELD(POR_MXP_P1_INFO_U_SMXP_0_0, A4S_NUM_P1, 11, 3)
    FIELD(POR_MXP_P1_INFO_U_SMXP_0_0, RXBUF_NUM_ENTRIES_P1, 8, 3)
    FIELD(POR_MXP_P1_INFO_U_SMXP_0_0, EXT_SAM_EN_P1, 7, 1)
    FIELD(POR_MXP_P1_INFO_U_SMXP_0_0, DATACHECK_EN_P1, 5, 1)
    FIELD(POR_MXP_P1_INFO_U_SMXP_0_0, POISON_EN_P1, 4, 1)
    FIELD(POR_MXP_P1_INFO_U_SMXP_0_0, NUM_DEV_P1, 0, 3)
REG32(POR_MXP_SECURE_REGISTER_GROUPS_OVERRIDE_U_SMXP_0_0, 0x8980)
    FIELD(POR_MXP_SECURE_REGISTER_GROUPS_OVERRIDE_U_SMXP_0_0, SYSCOREQ_CTL, 1, 1)
    FIELD(POR_MXP_SECURE_REGISTER_GROUPS_OVERRIDE_U_SMXP_0_0, QOS, 0, 1)
REG32(POR_MXP_AUX_CTL_U_SMXP_0_0, 0x8a00)
    FIELD(POR_MXP_AUX_CTL_U_SMXP_0_0, CLKGATE_DISABLE, 0, 1)
REG32(POR_MXP_P0_QOS_CONTROL_U_SMXP_0_0, 0x8a80)
    FIELD(POR_MXP_P0_QOS_CONTROL_U_SMXP_0_0, RESERVED_20, 20, 44)
    FIELD(POR_MXP_P0_QOS_CONTROL_U_SMXP_0_0, P0_QOS_OVERRIDE, 16, 4)
    FIELD(POR_MXP_P0_QOS_CONTROL_U_SMXP_0_0, P0_PQV_MODE, 6, 1)
    FIELD(POR_MXP_P0_QOS_CONTROL_U_SMXP_0_0, P0_REG_MODE, 4, 1)
    FIELD(POR_MXP_P0_QOS_CONTROL_U_SMXP_0_0, P0_QOS_OVERRIDE_EN, 2, 1)
    FIELD(POR_MXP_P0_QOS_CONTROL_U_SMXP_0_0, P0_LAT_EN, 0, 1)
REG32(POR_MXP_P0_QOS_LAT_TGT_U_SMXP_0_0, 0x8a88)
    FIELD(POR_MXP_P0_QOS_LAT_TGT_U_SMXP_0_0, RESERVED_12, 12, 52)
    FIELD(POR_MXP_P0_QOS_LAT_TGT_U_SMXP_0_0, P0_LAT_TGT, 0, 12)
REG32(POR_MXP_P0_QOS_LAT_SCALE_U_SMXP_0_0, 0x8a90)
    FIELD(POR_MXP_P0_QOS_LAT_SCALE_U_SMXP_0_0, P0_LAT_SCALE, 0, 3)
REG32(POR_MXP_P0_QOS_LAT_RANGE_U_SMXP_0_0, 0x8a98)
    FIELD(POR_MXP_P0_QOS_LAT_RANGE_U_SMXP_0_0, RESERVED_12, 12, 52)
    FIELD(POR_MXP_P0_QOS_LAT_RANGE_U_SMXP_0_0, P0_LAT_MAX_QOS, 8, 4)
    FIELD(POR_MXP_P0_QOS_LAT_RANGE_U_SMXP_0_0, P0_LAT_MIN_QOS, 0, 4)
REG32(POR_MXP_P1_QOS_CONTROL_U_SMXP_0_0, 0x8aa0)
    FIELD(POR_MXP_P1_QOS_CONTROL_U_SMXP_0_0, RESERVED_20, 20, 44)
    FIELD(POR_MXP_P1_QOS_CONTROL_U_SMXP_0_0, P1_QOS_OVERRIDE, 16, 4)
    FIELD(POR_MXP_P1_QOS_CONTROL_U_SMXP_0_0, P1_PQV_MODE, 6, 1)
    FIELD(POR_MXP_P1_QOS_CONTROL_U_SMXP_0_0, P1_REG_MODE, 4, 1)
    FIELD(POR_MXP_P1_QOS_CONTROL_U_SMXP_0_0, P1_QOS_OVERRIDE_EN, 2, 1)
    FIELD(POR_MXP_P1_QOS_CONTROL_U_SMXP_0_0, P1_LAT_EN, 0, 1)
REG32(POR_MXP_P1_QOS_LAT_TGT_U_SMXP_0_0, 0x8aa8)
    FIELD(POR_MXP_P1_QOS_LAT_TGT_U_SMXP_0_0, RESERVED_12, 12, 52)
    FIELD(POR_MXP_P1_QOS_LAT_TGT_U_SMXP_0_0, P1_LAT_TGT, 0, 12)
REG32(POR_MXP_P1_QOS_LAT_SCALE_U_SMXP_0_0, 0x8ab0)
    FIELD(POR_MXP_P1_QOS_LAT_SCALE_U_SMXP_0_0, P1_LAT_SCALE, 0, 3)
REG32(POR_MXP_P1_QOS_LAT_RANGE_U_SMXP_0_0, 0x8ab8)
    FIELD(POR_MXP_P1_QOS_LAT_RANGE_U_SMXP_0_0, RESERVED_12, 12, 52)
    FIELD(POR_MXP_P1_QOS_LAT_RANGE_U_SMXP_0_0, P1_LAT_MAX_QOS, 8, 4)
    FIELD(POR_MXP_P1_QOS_LAT_RANGE_U_SMXP_0_0, P1_LAT_MIN_QOS, 0, 4)
REG32(POR_MXP_P0_SYSCOREQ_CTL_U_SMXP_0_0, 0x9000)
    FIELD(POR_MXP_P0_SYSCOREQ_CTL_U_SMXP_0_0, SNPDVM_REQ_P0_D3, 3, 1)
    FIELD(POR_MXP_P0_SYSCOREQ_CTL_U_SMXP_0_0, SNPDVM_REQ_P0_D2, 2, 1)
    FIELD(POR_MXP_P0_SYSCOREQ_CTL_U_SMXP_0_0, SNPDVM_REQ_P0_D1, 1, 1)
    FIELD(POR_MXP_P0_SYSCOREQ_CTL_U_SMXP_0_0, SNPDVM_REQ_P0_D0, 0, 1)
REG32(POR_MXP_P1_SYSCOREQ_CTL_U_SMXP_0_0, 0x9008)
    FIELD(POR_MXP_P1_SYSCOREQ_CTL_U_SMXP_0_0, SNPDVM_REQ_P1_D3, 3, 1)
    FIELD(POR_MXP_P1_SYSCOREQ_CTL_U_SMXP_0_0, SNPDVM_REQ_P1_D2, 2, 1)
    FIELD(POR_MXP_P1_SYSCOREQ_CTL_U_SMXP_0_0, SNPDVM_REQ_P1_D1, 1, 1)
    FIELD(POR_MXP_P1_SYSCOREQ_CTL_U_SMXP_0_0, SNPDVM_REQ_P1_D0, 0, 1)
REG32(POR_MXP_P0_SYSCOACK_STATUS_U_SMXP_0_0, 0x9010)
    FIELD(POR_MXP_P0_SYSCOACK_STATUS_U_SMXP_0_0, SNPDVM_ACK_P0_D3, 3, 1)
    FIELD(POR_MXP_P0_SYSCOACK_STATUS_U_SMXP_0_0, SNPDVM_ACK_P0_D2, 2, 1)
    FIELD(POR_MXP_P0_SYSCOACK_STATUS_U_SMXP_0_0, SNPDVM_ACK_P0_D1, 1, 1)
    FIELD(POR_MXP_P0_SYSCOACK_STATUS_U_SMXP_0_0, SNPDVM_ACK_P0_D0, 0, 1)
REG32(POR_MXP_P1_SYSCOACK_STATUS_U_SMXP_0_0, 0x9018)
    FIELD(POR_MXP_P1_SYSCOACK_STATUS_U_SMXP_0_0, SNPDVM_ACK_P1_D3, 3, 1)
    FIELD(POR_MXP_P1_SYSCOACK_STATUS_U_SMXP_0_0, SNPDVM_ACK_P1_D2, 2, 1)
    FIELD(POR_MXP_P1_SYSCOACK_STATUS_U_SMXP_0_0, SNPDVM_ACK_P1_D1, 1, 1)
    FIELD(POR_MXP_P1_SYSCOACK_STATUS_U_SMXP_0_0, SNPDVM_ACK_P1_D0, 0, 1)
REG32(POR_MXP_PMU_EVENT_SEL_U_SMXP_0_0, 0xa000)
    FIELD(POR_MXP_PMU_EVENT_SEL_U_SMXP_0_0, RESERVED_32, 32, 32)
    FIELD(POR_MXP_PMU_EVENT_SEL_U_SMXP_0_0, PMU_EVENT3_ID, 24, 8)
    FIELD(POR_MXP_PMU_EVENT_SEL_U_SMXP_0_0, PMU_EVENT2_ID, 16, 8)
    FIELD(POR_MXP_PMU_EVENT_SEL_U_SMXP_0_0, PMU_EVENT1_ID, 8, 8)
    FIELD(POR_MXP_PMU_EVENT_SEL_U_SMXP_0_0, PMU_EVENT0_ID, 0, 8)
REG32(POR_DTM_CONTROL_U_SMXP_0_0, 0xa100)
    FIELD(POR_DTM_CONTROL_U_SMXP_0_0, TRACE_NO_ATB, 3, 1)
    FIELD(POR_DTM_CONTROL_U_SMXP_0_0, SAMPLE_PROFILE_ENABLE, 2, 1)
    FIELD(POR_DTM_CONTROL_U_SMXP_0_0, TRACE_TAG_ENABLE, 1, 1)
    FIELD(POR_DTM_CONTROL_U_SMXP_0_0, DTM_ENABLE, 0, 1)
REG32(POR_DTM_FIFO_ENTRY_READY_U_SMXP_0_0, 0xa118)
    FIELD(POR_DTM_FIFO_ENTRY_READY_U_SMXP_0_0, READY, 0, 4)
REG32(POR_DTM_FIFO_ENTRY0_0_U_SMXP_0_0, 0xa120)
REG32(POR_DTM_FIFO_ENTRY0_1_U_SMXP_0_0, 0xa128)
REG32(POR_DTM_FIFO_ENTRY0_2_U_SMXP_0_0, 0xa130)
    FIELD(POR_DTM_FIFO_ENTRY0_2_U_SMXP_0_0, RESERVED_32, 32, 32)
    FIELD(POR_DTM_FIFO_ENTRY0_2_U_SMXP_0_0, FIFO_CYCLE_COUNT, 16, 16)
    FIELD(POR_DTM_FIFO_ENTRY0_2_U_SMXP_0_0, FIFO_DATA2, 0, 16)
REG32(POR_DTM_FIFO_ENTRY1_0_U_SMXP_0_0, 0xa138)
REG32(POR_DTM_FIFO_ENTRY1_1_U_SMXP_0_0, 0xa140)
REG32(POR_DTM_FIFO_ENTRY1_2_U_SMXP_0_0, 0xa148)
    FIELD(POR_DTM_FIFO_ENTRY1_2_U_SMXP_0_0, RESERVED_32, 32, 32)
    FIELD(POR_DTM_FIFO_ENTRY1_2_U_SMXP_0_0, FIFO_CYCLE_COUNT, 16, 16)
    FIELD(POR_DTM_FIFO_ENTRY1_2_U_SMXP_0_0, FIFO_DATA2, 0, 16)
REG32(POR_DTM_FIFO_ENTRY2_0_U_SMXP_0_0, 0xa150)
REG32(POR_DTM_FIFO_ENTRY2_1_U_SMXP_0_0, 0xa158)
REG32(POR_DTM_FIFO_ENTRY2_2_U_SMXP_0_0, 0xa160)
    FIELD(POR_DTM_FIFO_ENTRY2_2_U_SMXP_0_0, RESERVED_32, 32, 32)
    FIELD(POR_DTM_FIFO_ENTRY2_2_U_SMXP_0_0, FIFO_CYCLE_COUNT, 16, 16)
    FIELD(POR_DTM_FIFO_ENTRY2_2_U_SMXP_0_0, FIFO_DATA2, 0, 16)
REG32(POR_DTM_FIFO_ENTRY3_0_U_SMXP_0_0, 0xa168)
REG32(POR_DTM_FIFO_ENTRY3_1_U_SMXP_0_0, 0xa170)
REG32(POR_DTM_FIFO_ENTRY3_2_U_SMXP_0_0, 0xa178)
    FIELD(POR_DTM_FIFO_ENTRY3_2_U_SMXP_0_0, RESERVED_32, 32, 32)
    FIELD(POR_DTM_FIFO_ENTRY3_2_U_SMXP_0_0, FIFO_CYCLE_COUNT, 16, 16)
    FIELD(POR_DTM_FIFO_ENTRY3_2_U_SMXP_0_0, FIFO_DATA2, 0, 16)
REG32(POR_DTM_WP0_CONFIG_U_SMXP_0_0, 0xa1a0)
    FIELD(POR_DTM_WP0_CONFIG_U_SMXP_0_0, RESERVED_15, 15, 49)
    FIELD(POR_DTM_WP0_CONFIG_U_SMXP_0_0, WP_DBGTRIG_EN, 14, 1)
    FIELD(POR_DTM_WP0_CONFIG_U_SMXP_0_0, WP_CTRIG_EN, 13, 1)
    FIELD(POR_DTM_WP0_CONFIG_U_SMXP_0_0, WP_CC_EN, 12, 1)
    FIELD(POR_DTM_WP0_CONFIG_U_SMXP_0_0, WP_PKT_TYPE, 9, 3)
    FIELD(POR_DTM_WP0_CONFIG_U_SMXP_0_0, WP_PKT_GEN, 8, 1)
    FIELD(POR_DTM_WP0_CONFIG_U_SMXP_0_0, WP_COMBINE, 6, 1)
    FIELD(POR_DTM_WP0_CONFIG_U_SMXP_0_0, WP_EXCLUSIVE, 5, 1)
    FIELD(POR_DTM_WP0_CONFIG_U_SMXP_0_0, WP_GRP, 4, 1)
    FIELD(POR_DTM_WP0_CONFIG_U_SMXP_0_0, WP_CHN_SEL, 1, 3)
    FIELD(POR_DTM_WP0_CONFIG_U_SMXP_0_0, WP_DEV_SEL, 0, 1)
REG32(POR_DTM_WP0_VAL_U_SMXP_0_0, 0xa1a8)
REG32(POR_DTM_WP0_MASK_U_SMXP_0_0, 0xa1b0)
REG32(POR_DTM_WP1_CONFIG_U_SMXP_0_0, 0xa1b8)
    FIELD(POR_DTM_WP1_CONFIG_U_SMXP_0_0, RESERVED_15, 15, 49)
    FIELD(POR_DTM_WP1_CONFIG_U_SMXP_0_0, WP_DBGTRIG_EN, 14, 1)
    FIELD(POR_DTM_WP1_CONFIG_U_SMXP_0_0, WP_CTRIG_EN, 13, 1)
    FIELD(POR_DTM_WP1_CONFIG_U_SMXP_0_0, WP_CC_EN, 12, 1)
    FIELD(POR_DTM_WP1_CONFIG_U_SMXP_0_0, WP_PKT_TYPE, 9, 3)
    FIELD(POR_DTM_WP1_CONFIG_U_SMXP_0_0, WP_PKT_GEN, 8, 1)
    FIELD(POR_DTM_WP1_CONFIG_U_SMXP_0_0, WP_EXCLUSIVE, 5, 1)
    FIELD(POR_DTM_WP1_CONFIG_U_SMXP_0_0, WP_GRP, 4, 1)
    FIELD(POR_DTM_WP1_CONFIG_U_SMXP_0_0, WP_CHN_SEL, 1, 3)
    FIELD(POR_DTM_WP1_CONFIG_U_SMXP_0_0, WP_DEV_SEL, 0, 1)
REG32(POR_DTM_WP1_VAL_U_SMXP_0_0, 0xa1c0)
REG32(POR_DTM_WP1_MASK_U_SMXP_0_0, 0xa1c8)
REG32(POR_DTM_WP2_CONFIG_U_SMXP_0_0, 0xa1d0)
    FIELD(POR_DTM_WP2_CONFIG_U_SMXP_0_0, RESERVED_15, 15, 49)
    FIELD(POR_DTM_WP2_CONFIG_U_SMXP_0_0, WP_DBGTRIG_EN, 14, 1)
    FIELD(POR_DTM_WP2_CONFIG_U_SMXP_0_0, WP_CTRIG_EN, 13, 1)
    FIELD(POR_DTM_WP2_CONFIG_U_SMXP_0_0, WP_CC_EN, 12, 1)
    FIELD(POR_DTM_WP2_CONFIG_U_SMXP_0_0, WP_PKT_TYPE, 9, 3)
    FIELD(POR_DTM_WP2_CONFIG_U_SMXP_0_0, WP_PKT_GEN, 8, 1)
    FIELD(POR_DTM_WP2_CONFIG_U_SMXP_0_0, WP_COMBINE, 6, 1)
    FIELD(POR_DTM_WP2_CONFIG_U_SMXP_0_0, WP_EXCLUSIVE, 5, 1)
    FIELD(POR_DTM_WP2_CONFIG_U_SMXP_0_0, WP_GRP, 4, 1)
    FIELD(POR_DTM_WP2_CONFIG_U_SMXP_0_0, WP_CHN_SEL, 1, 3)
    FIELD(POR_DTM_WP2_CONFIG_U_SMXP_0_0, WP_DEV_SEL, 0, 1)
REG32(POR_DTM_WP2_VAL_U_SMXP_0_0, 0xa1d8)
REG32(POR_DTM_WP2_MASK_U_SMXP_0_0, 0xa1e0)
REG32(POR_DTM_WP3_CONFIG_U_SMXP_0_0, 0xa1e8)
    FIELD(POR_DTM_WP3_CONFIG_U_SMXP_0_0, RESERVED_15, 15, 49)
    FIELD(POR_DTM_WP3_CONFIG_U_SMXP_0_0, WP_DBGTRIG_EN, 14, 1)
    FIELD(POR_DTM_WP3_CONFIG_U_SMXP_0_0, WP_CTRIG_EN, 13, 1)
    FIELD(POR_DTM_WP3_CONFIG_U_SMXP_0_0, WP_CC_EN, 12, 1)
    FIELD(POR_DTM_WP3_CONFIG_U_SMXP_0_0, WP_PKT_TYPE, 9, 3)
    FIELD(POR_DTM_WP3_CONFIG_U_SMXP_0_0, WP_PKT_GEN, 8, 1)
    FIELD(POR_DTM_WP3_CONFIG_U_SMXP_0_0, WP_EXCLUSIVE, 5, 1)
    FIELD(POR_DTM_WP3_CONFIG_U_SMXP_0_0, WP_GRP, 4, 1)
    FIELD(POR_DTM_WP3_CONFIG_U_SMXP_0_0, WP_CHN_SEL, 1, 3)
    FIELD(POR_DTM_WP3_CONFIG_U_SMXP_0_0, WP_DEV_SEL, 0, 1)
REG32(POR_DTM_WP3_VAL_U_SMXP_0_0, 0xa1f0)
REG32(POR_DTM_WP3_MASK_U_SMXP_0_0, 0xa1f8)
REG32(POR_DTM_PMSICR_U_SMXP_0_0, 0xa200)
    FIELD(POR_DTM_PMSICR_U_SMXP_0_0, RESERVED_32, 32, 32)
    FIELD(POR_DTM_PMSICR_U_SMXP_0_0, COUNT, 0, 32)
REG32(POR_DTM_PMSIRR_U_SMXP_0_0, 0xa208)
    FIELD(POR_DTM_PMSIRR_U_SMXP_0_0, RESERVED_32, 32, 32)
    FIELD(POR_DTM_PMSIRR_U_SMXP_0_0, INTERVAL, 8, 24)
    FIELD(POR_DTM_PMSIRR_U_SMXP_0_0, RESERVED_0, 0, 8)
REG32(POR_DTM_PMU_CONFIG_U_SMXP_0_0, 0xa210)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_0_0, RESERVED_62, 62, 2)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_0_0, PMEVCNT3_INPUT_SEL, 56, 6)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_0_0, RESERVED_54, 54, 2)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_0_0, PMEVCNT2_INPUT_SEL, 48, 6)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_0_0, RESERVED_46, 46, 2)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_0_0, PMEVCNT1_INPUT_SEL, 40, 6)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_0_0, RESERVED_38, 38, 2)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_0_0, PMEVCNT0_INPUT_SEL, 32, 6)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_0_0, RESERVED_31, 31, 1)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_0_0, PMEVCNT3_GLOBAL_NUM, 28, 3)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_0_0, RESERVED_27, 27, 1)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_0_0, PMEVCNT2_GLOBAL_NUM, 24, 3)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_0_0, RESERVED_23, 23, 1)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_0_0, PMEVCNT1_GLOBAL_NUM, 20, 3)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_0_0, RESERVED_19, 19, 1)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_0_0, PMEVCNT0_GLOBAL_NUM, 16, 3)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_0_0, RESERVED_9, 9, 7)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_0_0, CNTR_RST, 8, 1)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_0_0, PMEVCNT_PAIRED, 4, 4)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_0_0, PMEVCNTALL_COMBINED, 3, 1)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_0_0, PMEVCNT23_COMBINED, 2, 1)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_0_0, PMEVCNT01_COMBINED, 1, 1)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_0_0, PMU_EN, 0, 1)
REG32(POR_DTM_PMEVCNT_U_SMXP_0_0, 0xa220)
    FIELD(POR_DTM_PMEVCNT_U_SMXP_0_0, PMEVCNT3, 48, 16)
    FIELD(POR_DTM_PMEVCNT_U_SMXP_0_0, PMEVCNT2, 32, 16)
    FIELD(POR_DTM_PMEVCNT_U_SMXP_0_0, PMEVCNT1, 16, 16)
    FIELD(POR_DTM_PMEVCNT_U_SMXP_0_0, PMEVCNT0, 0, 16)
REG32(POR_DTM_PMEVCNTSR_U_SMXP_0_0, 0xa240)
    FIELD(POR_DTM_PMEVCNTSR_U_SMXP_0_0, PMEVCNTSR3, 48, 16)
    FIELD(POR_DTM_PMEVCNTSR_U_SMXP_0_0, PMEVCNTSR2, 32, 16)
    FIELD(POR_DTM_PMEVCNTSR_U_SMXP_0_0, PMEVCNTSR1, 16, 16)
    FIELD(POR_DTM_PMEVCNTSR_U_SMXP_0_0, PMEVCNTSR0, 0, 16)
REG32(POR_MXP_ERRFR_U_SMXP_0_0, 0xb000)
    FIELD(POR_MXP_ERRFR_U_SMXP_0_0, RESERVED_15, 15, 49)
    FIELD(POR_MXP_ERRFR_U_SMXP_0_0, CEC, 12, 3)
    FIELD(POR_MXP_ERRFR_U_SMXP_0_0, CFI, 10, 2)
    FIELD(POR_MXP_ERRFR_U_SMXP_0_0, FI, 6, 2)
    FIELD(POR_MXP_ERRFR_U_SMXP_0_0, UI, 4, 2)
    FIELD(POR_MXP_ERRFR_U_SMXP_0_0, DE, 2, 2)
    FIELD(POR_MXP_ERRFR_U_SMXP_0_0, ED, 0, 2)
REG32(POR_MXP_ERRCTLR_U_SMXP_0_0, 0xb008)
    FIELD(POR_MXP_ERRCTLR_U_SMXP_0_0, RESERVED_9, 9, 55)
    FIELD(POR_MXP_ERRCTLR_U_SMXP_0_0, CFI, 8, 1)
    FIELD(POR_MXP_ERRCTLR_U_SMXP_0_0, FI, 3, 1)
    FIELD(POR_MXP_ERRCTLR_U_SMXP_0_0, UI, 2, 1)
    FIELD(POR_MXP_ERRCTLR_U_SMXP_0_0, DE, 1, 1)
    FIELD(POR_MXP_ERRCTLR_U_SMXP_0_0, ED, 0, 1)
REG32(POR_MXP_ERRSTATUS_U_SMXP_0_0, 0xb010)
    FIELD(POR_MXP_ERRSTATUS_U_SMXP_0_0, RESERVED_32, 32, 32)
    FIELD(POR_MXP_ERRSTATUS_U_SMXP_0_0, AV, 31, 1)
    FIELD(POR_MXP_ERRSTATUS_U_SMXP_0_0, V, 30, 1)
    FIELD(POR_MXP_ERRSTATUS_U_SMXP_0_0, UE, 29, 1)
    FIELD(POR_MXP_ERRSTATUS_U_SMXP_0_0, RESERVED_28, 28, 1)
    FIELD(POR_MXP_ERRSTATUS_U_SMXP_0_0, OF, 27, 1)
    FIELD(POR_MXP_ERRSTATUS_U_SMXP_0_0, MV, 26, 1)
    FIELD(POR_MXP_ERRSTATUS_U_SMXP_0_0, RESERVED_25, 25, 1)
    FIELD(POR_MXP_ERRSTATUS_U_SMXP_0_0, CE, 24, 1)
    FIELD(POR_MXP_ERRSTATUS_U_SMXP_0_0, DE, 23, 1)
    FIELD(POR_MXP_ERRSTATUS_U_SMXP_0_0, RESERVED_0, 0, 23)
REG32(POR_MXP_ERRMISC_U_SMXP_0_0, 0xb028)
    FIELD(POR_MXP_ERRMISC_U_SMXP_0_0, RESERVED_59, 59, 5)
    FIELD(POR_MXP_ERRMISC_U_SMXP_0_0, TGTID, 48, 11)
    FIELD(POR_MXP_ERRMISC_U_SMXP_0_0, RESERVED_22, 22, 26)
    FIELD(POR_MXP_ERRMISC_U_SMXP_0_0, OPCODE, 16, 6)
    FIELD(POR_MXP_ERRMISC_U_SMXP_0_0, RESERVED_15, 15, 1)
    FIELD(POR_MXP_ERRMISC_U_SMXP_0_0, SRCID, 4, 11)
    FIELD(POR_MXP_ERRMISC_U_SMXP_0_0, ERRSRC, 0, 3)
REG32(POR_MXP_P0_BYTE_PAR_ERR_INJ_U_SMXP_0_0, 0xb030)
    FIELD(POR_MXP_P0_BYTE_PAR_ERR_INJ_U_SMXP_0_0, P0_BYTE_PARITY_ERR_INJ, 0, 5)
REG32(POR_MXP_P1_BYTE_PAR_ERR_INJ_U_SMXP_0_0, 0xb038)
    FIELD(POR_MXP_P1_BYTE_PAR_ERR_INJ_U_SMXP_0_0, P1_BYTE_PARITY_ERR_INJ, 0, 5)
REG32(POR_MXP_ERRFR_NS_U_SMXP_0_0, 0xb100)
    FIELD(POR_MXP_ERRFR_NS_U_SMXP_0_0, RESERVED_15, 15, 49)
    FIELD(POR_MXP_ERRFR_NS_U_SMXP_0_0, CEC, 12, 3)
    FIELD(POR_MXP_ERRFR_NS_U_SMXP_0_0, CFI, 10, 2)
    FIELD(POR_MXP_ERRFR_NS_U_SMXP_0_0, FI, 6, 2)
    FIELD(POR_MXP_ERRFR_NS_U_SMXP_0_0, UI, 4, 2)
    FIELD(POR_MXP_ERRFR_NS_U_SMXP_0_0, DE, 2, 2)
    FIELD(POR_MXP_ERRFR_NS_U_SMXP_0_0, ED, 0, 2)
REG32(POR_MXP_ERRCTLR_NS_U_SMXP_0_0, 0xb108)
    FIELD(POR_MXP_ERRCTLR_NS_U_SMXP_0_0, RESERVED_9, 9, 55)
    FIELD(POR_MXP_ERRCTLR_NS_U_SMXP_0_0, CFI, 8, 1)
    FIELD(POR_MXP_ERRCTLR_NS_U_SMXP_0_0, FI, 3, 1)
    FIELD(POR_MXP_ERRCTLR_NS_U_SMXP_0_0, UI, 2, 1)
    FIELD(POR_MXP_ERRCTLR_NS_U_SMXP_0_0, DE, 1, 1)
    FIELD(POR_MXP_ERRCTLR_NS_U_SMXP_0_0, ED, 0, 1)
REG32(POR_MXP_ERRSTATUS_NS_U_SMXP_0_0, 0xb110)
    FIELD(POR_MXP_ERRSTATUS_NS_U_SMXP_0_0, RESERVED_32, 32, 32)
    FIELD(POR_MXP_ERRSTATUS_NS_U_SMXP_0_0, AV, 31, 1)
    FIELD(POR_MXP_ERRSTATUS_NS_U_SMXP_0_0, V, 30, 1)
    FIELD(POR_MXP_ERRSTATUS_NS_U_SMXP_0_0, UE, 29, 1)
    FIELD(POR_MXP_ERRSTATUS_NS_U_SMXP_0_0, RESERVED_28, 28, 1)
    FIELD(POR_MXP_ERRSTATUS_NS_U_SMXP_0_0, OF, 27, 1)
    FIELD(POR_MXP_ERRSTATUS_NS_U_SMXP_0_0, MV, 26, 1)
    FIELD(POR_MXP_ERRSTATUS_NS_U_SMXP_0_0, RESERVED_25, 25, 1)
    FIELD(POR_MXP_ERRSTATUS_NS_U_SMXP_0_0, CE, 24, 1)
    FIELD(POR_MXP_ERRSTATUS_NS_U_SMXP_0_0, DE, 23, 1)
    FIELD(POR_MXP_ERRSTATUS_NS_U_SMXP_0_0, RESERVED_0, 0, 23)
REG32(POR_MXP_ERRMISC_NS_U_SMXP_0_0, 0xb128)
    FIELD(POR_MXP_ERRMISC_NS_U_SMXP_0_0, RESERVED_59, 59, 5)
    FIELD(POR_MXP_ERRMISC_NS_U_SMXP_0_0, TGTID, 48, 11)
    FIELD(POR_MXP_ERRMISC_NS_U_SMXP_0_0, RESERVED_22, 22, 26)
    FIELD(POR_MXP_ERRMISC_NS_U_SMXP_0_0, OPCODE, 16, 6)
    FIELD(POR_MXP_ERRMISC_NS_U_SMXP_0_0, RESERVED_15, 15, 1)
    FIELD(POR_MXP_ERRMISC_NS_U_SMXP_0_0, SRCID, 4, 11)
    FIELD(POR_MXP_ERRMISC_NS_U_SMXP_0_0, ERRSRC, 0, 3)
REG32(POR_RNI_NODE_INFO_U_RNI_NID4, 0x14000)
    FIELD(POR_RNI_NODE_INFO_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_RNI_NODE_INFO_U_RNI_NID4, LOGICAL_ID, 32, 16)
    FIELD(POR_RNI_NODE_INFO_U_RNI_NID4, NODE_ID, 16, 16)
    FIELD(POR_RNI_NODE_INFO_U_RNI_NID4, NODE_TYPE, 0, 16)
REG32(POR_RNI_CHILD_INFO_U_RNI_NID4, 0x14080)
    FIELD(POR_RNI_CHILD_INFO_U_RNI_NID4, RESERVED_32, 32, 32)
    FIELD(POR_RNI_CHILD_INFO_U_RNI_NID4, CHILD_PTR_OFFSET, 16, 16)
    FIELD(POR_RNI_CHILD_INFO_U_RNI_NID4, CHILD_COUNT, 0, 16)
REG32(POR_RNI_UNIT_INFO_U_RNI_NID4, 0x14900)
    FIELD(POR_RNI_UNIT_INFO_U_RNI_NID4, RESERVED_46, 46, 18)
    FIELD(POR_RNI_UNIT_INFO_U_RNI_NID4, A4S_SAFE_XFACE_DISABLE, 45, 1)
    FIELD(POR_RNI_UNIT_INFO_U_RNI_NID4, ACEL_SAFE_XFACE_DISABLE, 44, 1)
    FIELD(POR_RNI_UNIT_INFO_U_RNI_NID4, A4S_LOGICALID_BASE, 36, 8)
    FIELD(POR_RNI_UNIT_INFO_U_RNI_NID4, RESERVED_34, 34, 2)
    FIELD(POR_RNI_UNIT_INFO_U_RNI_NID4, A4S_NUM, 32, 2)
    FIELD(POR_RNI_UNIT_INFO_U_RNI_NID4, RESERVED_29, 29, 3)
    FIELD(POR_RNI_UNIT_INFO_U_RNI_NID4, FORCE_RDB_PREALLOC, 28, 1)
    FIELD(POR_RNI_UNIT_INFO_U_RNI_NID4, AX_DATAPOISON_EN, 27, 1)
    FIELD(POR_RNI_UNIT_INFO_U_RNI_NID4, AX_DATA_256BIT, 26, 1)
    FIELD(POR_RNI_UNIT_INFO_U_RNI_NID4, RESERVED_24, 24, 2)
    FIELD(POR_RNI_UNIT_INFO_U_RNI_NID4, NUM_RD_BUFS, 16, 8)
    FIELD(POR_RNI_UNIT_INFO_U_RNI_NID4, NUM_RD_REQS, 8, 8)
    FIELD(POR_RNI_UNIT_INFO_U_RNI_NID4, NUM_WR_REQS, 0, 8)
REG32(POR_RNI_SECURE_REGISTER_GROUPS_OVERRIDE_U_RNI_NID4, 0x14980)
    FIELD(POR_RNI_SECURE_REGISTER_GROUPS_OVERRIDE_U_RNI_NID4, QOS_CTRL, 2, 1)
    FIELD(POR_RNI_SECURE_REGISTER_GROUPS_OVERRIDE_U_RNI_NID4, PORT_CTRL, 1, 1)
    FIELD(POR_RNI_SECURE_REGISTER_GROUPS_OVERRIDE_U_RNI_NID4, CFG_CTL, 0, 1)
REG32(POR_RNI_CFG_CTL_U_RNI_NID4, 0x14a00)
    FIELD(POR_RNI_CFG_CTL_U_RNI_NID4, RESERVED_32, 32, 32)
    FIELD(POR_RNI_CFG_CTL_U_RNI_NID4, MAX_WRT_OUTSTD_CHITXN_CNT, 24, 8)
    FIELD(POR_RNI_CFG_CTL_U_RNI_NID4, MAX_RRT_OUTSTD_CHITXN_CNT, 16, 8)
    FIELD(POR_RNI_CFG_CTL_U_RNI_NID4, RESERVED_15, 15, 1)
    FIELD(POR_RNI_CFG_CTL_U_RNI_NID4, WRT_CRDGNT_WEIGHT, 12, 3)
    FIELD(POR_RNI_CFG_CTL_U_RNI_NID4, RESERVED_11, 11, 1)
    FIELD(POR_RNI_CFG_CTL_U_RNI_NID4, RRT_CRDGNT_WEIGHT, 8, 3)
    FIELD(POR_RNI_CFG_CTL_U_RNI_NID4, DIS_NCWR_STREAM, 6, 1)
    FIELD(POR_RNI_CFG_CTL_U_RNI_NID4, PCIE_MSTR_PRESENT, 5, 1)
    FIELD(POR_RNI_CFG_CTL_U_RNI_NID4, QPC15_ENTRY_RSV_EN, 4, 1)
    FIELD(POR_RNI_CFG_CTL_U_RNI_NID4, FORCE_PREALLOC_RDB, 3, 1)
    FIELD(POR_RNI_CFG_CTL_U_RNI_NID4, DIS_WR_STREAM, 2, 1)
    FIELD(POR_RNI_CFG_CTL_U_RNI_NID4, WFC, 1, 1)
    FIELD(POR_RNI_CFG_CTL_U_RNI_NID4, QPC_EN, 0, 1)
REG32(POR_RNI_AUX_CTL_U_RNI_NID4, 0x14a08)
    FIELD(POR_RNI_AUX_CTL_U_RNI_NID4, SAMEID_WRSTASH_STREAM_EN, 5, 1)
    FIELD(POR_RNI_AUX_CTL_U_RNI_NID4, UPSTRM_DATCHECK_EN, 4, 1)
    FIELD(POR_RNI_AUX_CTL_U_RNI_NID4, DIS_NORM_RDSTREAM, 3, 1)
    FIELD(POR_RNI_AUX_CTL_U_RNI_NID4, PARK_PORT_ARB_PTR, 2, 1)
    FIELD(POR_RNI_AUX_CTL_U_RNI_NID4, AR_BYP_EN, 1, 1)
    FIELD(POR_RNI_AUX_CTL_U_RNI_NID4, CG_DISABLE, 0, 1)
REG32(POR_RNI_S0_PORT_CONTROL_U_RNI_NID4, 0x14a10)
    FIELD(POR_RNI_S0_PORT_CONTROL_U_RNI_NID4, RESERVED_11, 11, 53)
    FIELD(POR_RNI_S0_PORT_CONTROL_U_RNI_NID4, S0_LPID_MASK, 0, 11)
REG32(POR_RNI_S1_PORT_CONTROL_U_RNI_NID4, 0x14a18)
    FIELD(POR_RNI_S1_PORT_CONTROL_U_RNI_NID4, RESERVED_11, 11, 53)
    FIELD(POR_RNI_S1_PORT_CONTROL_U_RNI_NID4, S1_LPID_MASK, 0, 11)
REG32(POR_RNI_S2_PORT_CONTROL_U_RNI_NID4, 0x14a20)
    FIELD(POR_RNI_S2_PORT_CONTROL_U_RNI_NID4, RESERVED_11, 11, 53)
    FIELD(POR_RNI_S2_PORT_CONTROL_U_RNI_NID4, S2_LPID_MASK, 0, 11)
REG32(POR_RNI_S0_QOS_CONTROL_U_RNI_NID4, 0x14a80)
    FIELD(POR_RNI_S0_QOS_CONTROL_U_RNI_NID4, RESERVED_24, 24, 40)
    FIELD(POR_RNI_S0_QOS_CONTROL_U_RNI_NID4, S0_AR_QOS_OVERRIDE, 20, 4)
    FIELD(POR_RNI_S0_QOS_CONTROL_U_RNI_NID4, S0_AW_QOS_OVERRIDE, 16, 4)
    FIELD(POR_RNI_S0_QOS_CONTROL_U_RNI_NID4, S0_AR_PQV_MODE, 7, 1)
    FIELD(POR_RNI_S0_QOS_CONTROL_U_RNI_NID4, S0_AW_PQV_MODE, 6, 1)
    FIELD(POR_RNI_S0_QOS_CONTROL_U_RNI_NID4, S0_AR_REG_MODE, 5, 1)
    FIELD(POR_RNI_S0_QOS_CONTROL_U_RNI_NID4, S0_AW_REG_MODE, 4, 1)
    FIELD(POR_RNI_S0_QOS_CONTROL_U_RNI_NID4, S0_AR_QOS_OVERRIDE_EN, 3, 1)
    FIELD(POR_RNI_S0_QOS_CONTROL_U_RNI_NID4, S0_AW_QOS_OVERRIDE_EN, 2, 1)
    FIELD(POR_RNI_S0_QOS_CONTROL_U_RNI_NID4, S0_AR_LAT_EN, 1, 1)
    FIELD(POR_RNI_S0_QOS_CONTROL_U_RNI_NID4, S0_AW_LAT_EN, 0, 1)
REG32(POR_RNI_S0_QOS_LAT_TGT_U_RNI_NID4, 0x14a88)
    FIELD(POR_RNI_S0_QOS_LAT_TGT_U_RNI_NID4, RESERVED_28, 28, 36)
    FIELD(POR_RNI_S0_QOS_LAT_TGT_U_RNI_NID4, S0_AR_LAT_TGT, 16, 12)
    FIELD(POR_RNI_S0_QOS_LAT_TGT_U_RNI_NID4, RESERVED_12, 12, 4)
    FIELD(POR_RNI_S0_QOS_LAT_TGT_U_RNI_NID4, S0_AW_LAT_TGT, 0, 12)
REG32(POR_RNI_S0_QOS_LAT_SCALE_U_RNI_NID4, 0x14a90)
    FIELD(POR_RNI_S0_QOS_LAT_SCALE_U_RNI_NID4, RESERVED_11, 11, 53)
    FIELD(POR_RNI_S0_QOS_LAT_SCALE_U_RNI_NID4, S0_AR_LAT_SCALE, 8, 3)
    FIELD(POR_RNI_S0_QOS_LAT_SCALE_U_RNI_NID4, S0_AW_LAT_SCALE, 0, 3)
REG32(POR_RNI_S0_QOS_LAT_RANGE_U_RNI_NID4, 0x14a98)
    FIELD(POR_RNI_S0_QOS_LAT_RANGE_U_RNI_NID4, RESERVED_28, 28, 36)
    FIELD(POR_RNI_S0_QOS_LAT_RANGE_U_RNI_NID4, S0_AR_LAT_MAX_QOS, 24, 4)
    FIELD(POR_RNI_S0_QOS_LAT_RANGE_U_RNI_NID4, RESERVED_20, 20, 4)
    FIELD(POR_RNI_S0_QOS_LAT_RANGE_U_RNI_NID4, S0_AR_LAT_MIN_QOS, 16, 4)
    FIELD(POR_RNI_S0_QOS_LAT_RANGE_U_RNI_NID4, RESERVED_12, 12, 4)
    FIELD(POR_RNI_S0_QOS_LAT_RANGE_U_RNI_NID4, S0_AW_LAT_MAX_QOS, 8, 4)
    FIELD(POR_RNI_S0_QOS_LAT_RANGE_U_RNI_NID4, S0_AW_LAT_MIN_QOS, 0, 4)
REG32(POR_RNI_S1_QOS_CONTROL_U_RNI_NID4, 0x14aa0)
    FIELD(POR_RNI_S1_QOS_CONTROL_U_RNI_NID4, RESERVED_24, 24, 40)
    FIELD(POR_RNI_S1_QOS_CONTROL_U_RNI_NID4, S1_AR_QOS_OVERRIDE, 20, 4)
    FIELD(POR_RNI_S1_QOS_CONTROL_U_RNI_NID4, S1_AW_QOS_OVERRIDE, 16, 4)
    FIELD(POR_RNI_S1_QOS_CONTROL_U_RNI_NID4, S1_AR_PQV_MODE, 7, 1)
    FIELD(POR_RNI_S1_QOS_CONTROL_U_RNI_NID4, S1_AW_PQV_MODE, 6, 1)
    FIELD(POR_RNI_S1_QOS_CONTROL_U_RNI_NID4, S1_AR_REG_MODE, 5, 1)
    FIELD(POR_RNI_S1_QOS_CONTROL_U_RNI_NID4, S1_AW_REG_MODE, 4, 1)
    FIELD(POR_RNI_S1_QOS_CONTROL_U_RNI_NID4, S1_AR_QOS_OVERRIDE_EN, 3, 1)
    FIELD(POR_RNI_S1_QOS_CONTROL_U_RNI_NID4, S1_AW_QOS_OVERRIDE_EN, 2, 1)
    FIELD(POR_RNI_S1_QOS_CONTROL_U_RNI_NID4, S1_AR_LAT_EN, 1, 1)
    FIELD(POR_RNI_S1_QOS_CONTROL_U_RNI_NID4, S1_AW_LAT_EN, 0, 1)
REG32(POR_RNI_S1_QOS_LAT_TGT_U_RNI_NID4, 0x14aa8)
    FIELD(POR_RNI_S1_QOS_LAT_TGT_U_RNI_NID4, RESERVED_28, 28, 36)
    FIELD(POR_RNI_S1_QOS_LAT_TGT_U_RNI_NID4, S1_AR_LAT_TGT, 16, 12)
    FIELD(POR_RNI_S1_QOS_LAT_TGT_U_RNI_NID4, RESERVED_12, 12, 4)
    FIELD(POR_RNI_S1_QOS_LAT_TGT_U_RNI_NID4, S1_AW_LAT_TGT, 0, 12)
REG32(POR_RNI_S1_QOS_LAT_SCALE_U_RNI_NID4, 0x14ab0)
    FIELD(POR_RNI_S1_QOS_LAT_SCALE_U_RNI_NID4, RESERVED_11, 11, 53)
    FIELD(POR_RNI_S1_QOS_LAT_SCALE_U_RNI_NID4, S1_AR_LAT_SCALE, 8, 3)
    FIELD(POR_RNI_S1_QOS_LAT_SCALE_U_RNI_NID4, S1_AW_LAT_SCALE, 0, 3)
REG32(POR_RNI_S1_QOS_LAT_RANGE_U_RNI_NID4, 0x14ab8)
    FIELD(POR_RNI_S1_QOS_LAT_RANGE_U_RNI_NID4, RESERVED_28, 28, 36)
    FIELD(POR_RNI_S1_QOS_LAT_RANGE_U_RNI_NID4, S1_AR_LAT_MAX_QOS, 24, 4)
    FIELD(POR_RNI_S1_QOS_LAT_RANGE_U_RNI_NID4, RESERVED_20, 20, 4)
    FIELD(POR_RNI_S1_QOS_LAT_RANGE_U_RNI_NID4, S1_AR_LAT_MIN_QOS, 16, 4)
    FIELD(POR_RNI_S1_QOS_LAT_RANGE_U_RNI_NID4, RESERVED_12, 12, 4)
    FIELD(POR_RNI_S1_QOS_LAT_RANGE_U_RNI_NID4, S1_AW_LAT_MAX_QOS, 8, 4)
    FIELD(POR_RNI_S1_QOS_LAT_RANGE_U_RNI_NID4, S1_AW_LAT_MIN_QOS, 0, 4)
REG32(POR_RNI_S2_QOS_CONTROL_U_RNI_NID4, 0x14ac0)
    FIELD(POR_RNI_S2_QOS_CONTROL_U_RNI_NID4, RESERVED_24, 24, 40)
    FIELD(POR_RNI_S2_QOS_CONTROL_U_RNI_NID4, S2_AR_QOS_OVERRIDE, 20, 4)
    FIELD(POR_RNI_S2_QOS_CONTROL_U_RNI_NID4, S2_AW_QOS_OVERRIDE, 16, 4)
    FIELD(POR_RNI_S2_QOS_CONTROL_U_RNI_NID4, S2_AR_PQV_MODE, 7, 1)
    FIELD(POR_RNI_S2_QOS_CONTROL_U_RNI_NID4, S2_AW_PQV_MODE, 6, 1)
    FIELD(POR_RNI_S2_QOS_CONTROL_U_RNI_NID4, S2_AR_REG_MODE, 5, 1)
    FIELD(POR_RNI_S2_QOS_CONTROL_U_RNI_NID4, S2_AW_REG_MODE, 4, 1)
    FIELD(POR_RNI_S2_QOS_CONTROL_U_RNI_NID4, S2_AR_QOS_OVERRIDE_EN, 3, 1)
    FIELD(POR_RNI_S2_QOS_CONTROL_U_RNI_NID4, S2_AW_QOS_OVERRIDE_EN, 2, 1)
    FIELD(POR_RNI_S2_QOS_CONTROL_U_RNI_NID4, S2_AR_LAT_EN, 1, 1)
    FIELD(POR_RNI_S2_QOS_CONTROL_U_RNI_NID4, S2_AW_LAT_EN, 0, 1)
REG32(POR_RNI_S2_QOS_LAT_TGT_U_RNI_NID4, 0x14ac8)
    FIELD(POR_RNI_S2_QOS_LAT_TGT_U_RNI_NID4, RESERVED_28, 28, 36)
    FIELD(POR_RNI_S2_QOS_LAT_TGT_U_RNI_NID4, S2_AR_LAT_TGT, 16, 12)
    FIELD(POR_RNI_S2_QOS_LAT_TGT_U_RNI_NID4, RESERVED_12, 12, 4)
    FIELD(POR_RNI_S2_QOS_LAT_TGT_U_RNI_NID4, S2_AW_LAT_TGT, 0, 12)
REG32(POR_RNI_S2_QOS_LAT_SCALE_U_RNI_NID4, 0x14ad0)
    FIELD(POR_RNI_S2_QOS_LAT_SCALE_U_RNI_NID4, RESERVED_11, 11, 53)
    FIELD(POR_RNI_S2_QOS_LAT_SCALE_U_RNI_NID4, S2_AR_LAT_SCALE, 8, 3)
    FIELD(POR_RNI_S2_QOS_LAT_SCALE_U_RNI_NID4, S2_AW_LAT_SCALE, 0, 3)
REG32(POR_RNI_S2_QOS_LAT_RANGE_U_RNI_NID4, 0x14ad8)
    FIELD(POR_RNI_S2_QOS_LAT_RANGE_U_RNI_NID4, RESERVED_28, 28, 36)
    FIELD(POR_RNI_S2_QOS_LAT_RANGE_U_RNI_NID4, S2_AR_LAT_MAX_QOS, 24, 4)
    FIELD(POR_RNI_S2_QOS_LAT_RANGE_U_RNI_NID4, RESERVED_20, 20, 4)
    FIELD(POR_RNI_S2_QOS_LAT_RANGE_U_RNI_NID4, S2_AR_LAT_MIN_QOS, 16, 4)
    FIELD(POR_RNI_S2_QOS_LAT_RANGE_U_RNI_NID4, RESERVED_12, 12, 4)
    FIELD(POR_RNI_S2_QOS_LAT_RANGE_U_RNI_NID4, S2_AW_LAT_MAX_QOS, 8, 4)
    FIELD(POR_RNI_S2_QOS_LAT_RANGE_U_RNI_NID4, S2_AW_LAT_MIN_QOS, 0, 4)
REG32(POR_RNI_PMU_EVENT_SEL_U_RNI_NID4, 0x16000)
    FIELD(POR_RNI_PMU_EVENT_SEL_U_RNI_NID4, RESERVED_29, 29, 35)
    FIELD(POR_RNI_PMU_EVENT_SEL_U_RNI_NID4, PMU_EVENT3_ID, 24, 5)
    FIELD(POR_RNI_PMU_EVENT_SEL_U_RNI_NID4, RESERVED_21, 21, 3)
    FIELD(POR_RNI_PMU_EVENT_SEL_U_RNI_NID4, PMU_EVENT2_ID, 16, 5)
    FIELD(POR_RNI_PMU_EVENT_SEL_U_RNI_NID4, RESERVED_13, 13, 3)
    FIELD(POR_RNI_PMU_EVENT_SEL_U_RNI_NID4, PMU_EVENT1_ID, 8, 5)
    FIELD(POR_RNI_PMU_EVENT_SEL_U_RNI_NID4, PMU_EVENT0_ID, 0, 5)
REG32(POR_RNSAM_NODE_INFO_U_RNI_NID4, 0x24000)
    FIELD(POR_RNSAM_NODE_INFO_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_RNSAM_NODE_INFO_U_RNI_NID4, LOGICAL_ID, 32, 16)
    FIELD(POR_RNSAM_NODE_INFO_U_RNI_NID4, NODE_ID, 16, 16)
    FIELD(POR_RNSAM_NODE_INFO_U_RNI_NID4, NODE_TYPE, 0, 16)
REG32(POR_RNSAM_CHILD_INFO_U_RNI_NID4, 0x24080)
    FIELD(POR_RNSAM_CHILD_INFO_U_RNI_NID4, RESERVED_32, 32, 32)
    FIELD(POR_RNSAM_CHILD_INFO_U_RNI_NID4, CHILD_PTR_OFFSET, 16, 16)
    FIELD(POR_RNSAM_CHILD_INFO_U_RNI_NID4, CHILD_COUNT, 0, 16)
REG32(POR_RNSAM_UNIT_INFO_U_RNI_NID4, 0x24900)
    FIELD(POR_RNSAM_UNIT_INFO_U_RNI_NID4, RESERVED_37, 37, 27)
    FIELD(POR_RNSAM_UNIT_INFO_U_RNI_NID4, NUM_NON_HASH_GROUP, 32, 5)
    FIELD(POR_RNSAM_UNIT_INFO_U_RNI_NID4, RESERVED_20, 20, 12)
    FIELD(POR_RNSAM_UNIT_INFO_U_RNI_NID4, NUM_SYS_CACHE_GROUP, 16, 4)
    FIELD(POR_RNSAM_UNIT_INFO_U_RNI_NID4, NUM_HNF, 0, 8)
REG32(POR_RNSAM_SECURE_REGISTER_GROUPS_OVERRIDE_U_RNI_NID4, 0x24980)
    FIELD(POR_RNSAM_SECURE_REGISTER_GROUPS_OVERRIDE_U_RNI_NID4, MEM_RANGE, 0, 1)
REG32(RNSAM_STATUS_U_RNI_NID4, 0x24c00)
    FIELD(RNSAM_STATUS_U_RNI_NID4, NSTALL_REQ, 1, 1)
    FIELD(RNSAM_STATUS_U_RNI_NID4, USE_DEFAULT_NODE, 0, 1)
REG32(NON_HASH_MEM_REGION_REG0_U_RNI_NID4, 0x24c08)
    FIELD(NON_HASH_MEM_REGION_REG0_U_RNI_NID4, RESERVED_63, 63, 1)
    FIELD(NON_HASH_MEM_REGION_REG0_U_RNI_NID4, REGION1_BASE_ADDR, 41, 22)
    FIELD(NON_HASH_MEM_REGION_REG0_U_RNI_NID4, REGION1_SIZE, 36, 5)
    FIELD(NON_HASH_MEM_REGION_REG0_U_RNI_NID4, REGION1_TARGET_TYPE, 34, 2)
    FIELD(NON_HASH_MEM_REGION_REG0_U_RNI_NID4, RESERVED_33, 33, 1)
    FIELD(NON_HASH_MEM_REGION_REG0_U_RNI_NID4, REGION1_VALID, 32, 1)
    FIELD(NON_HASH_MEM_REGION_REG0_U_RNI_NID4, RESERVED_31, 31, 1)
    FIELD(NON_HASH_MEM_REGION_REG0_U_RNI_NID4, REGION0_BASE_ADDR, 9, 22)
    FIELD(NON_HASH_MEM_REGION_REG0_U_RNI_NID4, REGION0_SIZE, 4, 5)
    FIELD(NON_HASH_MEM_REGION_REG0_U_RNI_NID4, REGION0_TARGET_TYPE, 2, 2)
    FIELD(NON_HASH_MEM_REGION_REG0_U_RNI_NID4, REGION0_VALID, 0, 1)
REG32(NON_HASH_MEM_REGION_REG1_U_RNI_NID4, 0x24c10)
    FIELD(NON_HASH_MEM_REGION_REG1_U_RNI_NID4, RESERVED_63, 63, 1)
    FIELD(NON_HASH_MEM_REGION_REG1_U_RNI_NID4, REGION3_BASE_ADDR, 41, 22)
    FIELD(NON_HASH_MEM_REGION_REG1_U_RNI_NID4, REGION3_SIZE, 36, 5)
    FIELD(NON_HASH_MEM_REGION_REG1_U_RNI_NID4, REGION3_TARGET_TYPE, 34, 2)
    FIELD(NON_HASH_MEM_REGION_REG1_U_RNI_NID4, RESERVED_33, 33, 1)
    FIELD(NON_HASH_MEM_REGION_REG1_U_RNI_NID4, REGION3_VALID, 32, 1)
    FIELD(NON_HASH_MEM_REGION_REG1_U_RNI_NID4, RESERVED_31, 31, 1)
    FIELD(NON_HASH_MEM_REGION_REG1_U_RNI_NID4, REGION2_BASE_ADDR, 9, 22)
    FIELD(NON_HASH_MEM_REGION_REG1_U_RNI_NID4, REGION2_SIZE, 4, 5)
    FIELD(NON_HASH_MEM_REGION_REG1_U_RNI_NID4, REGION2_TARGET_TYPE, 2, 2)
    FIELD(NON_HASH_MEM_REGION_REG1_U_RNI_NID4, REGION2_VALID, 0, 1)
REG32(NON_HASH_MEM_REGION_REG2_U_RNI_NID4, 0x24c18)
    FIELD(NON_HASH_MEM_REGION_REG2_U_RNI_NID4, RESERVED_63, 63, 1)
    FIELD(NON_HASH_MEM_REGION_REG2_U_RNI_NID4, REGION5_BASE_ADDR, 41, 22)
    FIELD(NON_HASH_MEM_REGION_REG2_U_RNI_NID4, REGION5_SIZE, 36, 5)
    FIELD(NON_HASH_MEM_REGION_REG2_U_RNI_NID4, REGION5_TARGET_TYPE, 34, 2)
    FIELD(NON_HASH_MEM_REGION_REG2_U_RNI_NID4, RESERVED_33, 33, 1)
    FIELD(NON_HASH_MEM_REGION_REG2_U_RNI_NID4, REGION5_VALID, 32, 1)
    FIELD(NON_HASH_MEM_REGION_REG2_U_RNI_NID4, RESERVED_31, 31, 1)
    FIELD(NON_HASH_MEM_REGION_REG2_U_RNI_NID4, REGION4_BASE_ADDR, 9, 22)
    FIELD(NON_HASH_MEM_REGION_REG2_U_RNI_NID4, REGION4_SIZE, 4, 5)
    FIELD(NON_HASH_MEM_REGION_REG2_U_RNI_NID4, REGION4_TARGET_TYPE, 2, 2)
    FIELD(NON_HASH_MEM_REGION_REG2_U_RNI_NID4, REGION4_VALID, 0, 1)
REG32(NON_HASH_MEM_REGION_REG3_U_RNI_NID4, 0x24c20)
    FIELD(NON_HASH_MEM_REGION_REG3_U_RNI_NID4, RESERVED_63, 63, 1)
    FIELD(NON_HASH_MEM_REGION_REG3_U_RNI_NID4, REGION7_BASE_ADDR, 41, 22)
    FIELD(NON_HASH_MEM_REGION_REG3_U_RNI_NID4, REGION7_SIZE, 36, 5)
    FIELD(NON_HASH_MEM_REGION_REG3_U_RNI_NID4, REGION7_TARGET_TYPE, 34, 2)
    FIELD(NON_HASH_MEM_REGION_REG3_U_RNI_NID4, RESERVED_33, 33, 1)
    FIELD(NON_HASH_MEM_REGION_REG3_U_RNI_NID4, REGION7_VALID, 32, 1)
    FIELD(NON_HASH_MEM_REGION_REG3_U_RNI_NID4, RESERVED_31, 31, 1)
    FIELD(NON_HASH_MEM_REGION_REG3_U_RNI_NID4, REGION6_BASE_ADDR, 9, 22)
    FIELD(NON_HASH_MEM_REGION_REG3_U_RNI_NID4, REGION6_SIZE, 4, 5)
    FIELD(NON_HASH_MEM_REGION_REG3_U_RNI_NID4, REGION6_TARGET_TYPE, 2, 2)
    FIELD(NON_HASH_MEM_REGION_REG3_U_RNI_NID4, REGION6_VALID, 0, 1)
REG32(NON_HASH_TGT_NODEID0_U_RNI_NID4, 0x24c30)
    FIELD(NON_HASH_TGT_NODEID0_U_RNI_NID4, RESERVED_47, 47, 17)
    FIELD(NON_HASH_TGT_NODEID0_U_RNI_NID4, NODEID_3, 36, 11)
    FIELD(NON_HASH_TGT_NODEID0_U_RNI_NID4, RESERVED_35, 35, 1)
    FIELD(NON_HASH_TGT_NODEID0_U_RNI_NID4, NODEID_2, 24, 11)
    FIELD(NON_HASH_TGT_NODEID0_U_RNI_NID4, RESERVED_23, 23, 1)
    FIELD(NON_HASH_TGT_NODEID0_U_RNI_NID4, NODEID_1, 12, 11)
    FIELD(NON_HASH_TGT_NODEID0_U_RNI_NID4, RESERVED_11, 11, 1)
    FIELD(NON_HASH_TGT_NODEID0_U_RNI_NID4, NODEID_0, 0, 11)
REG32(NON_HASH_TGT_NODEID1_U_RNI_NID4, 0x24c38)
    FIELD(NON_HASH_TGT_NODEID1_U_RNI_NID4, RESERVED_47, 47, 17)
    FIELD(NON_HASH_TGT_NODEID1_U_RNI_NID4, NODEID_7, 36, 11)
    FIELD(NON_HASH_TGT_NODEID1_U_RNI_NID4, RESERVED_35, 35, 1)
    FIELD(NON_HASH_TGT_NODEID1_U_RNI_NID4, NODEID_6, 24, 11)
    FIELD(NON_HASH_TGT_NODEID1_U_RNI_NID4, RESERVED_23, 23, 1)
    FIELD(NON_HASH_TGT_NODEID1_U_RNI_NID4, NODEID_5, 12, 11)
    FIELD(NON_HASH_TGT_NODEID1_U_RNI_NID4, RESERVED_11, 11, 1)
    FIELD(NON_HASH_TGT_NODEID1_U_RNI_NID4, NODEID_4, 0, 11)
REG32(NON_HASH_TGT_NODEID2_U_RNI_NID4, 0x24c40)
    FIELD(NON_HASH_TGT_NODEID2_U_RNI_NID4, RESERVED_23, 23, 41)
    FIELD(NON_HASH_TGT_NODEID2_U_RNI_NID4, NODEID_9, 12, 11)
    FIELD(NON_HASH_TGT_NODEID2_U_RNI_NID4, RESERVED_11, 11, 1)
    FIELD(NON_HASH_TGT_NODEID2_U_RNI_NID4, NODEID_8, 0, 11)
REG32(SYS_CACHE_GRP_REGION0_U_RNI_NID4, 0x24c48)
    FIELD(SYS_CACHE_GRP_REGION0_U_RNI_NID4, RESERVED_63, 63, 1)
    FIELD(SYS_CACHE_GRP_REGION0_U_RNI_NID4, REGION1_BASE_ADDR, 41, 22)
    FIELD(SYS_CACHE_GRP_REGION0_U_RNI_NID4, REGION1_SIZE, 36, 5)
    FIELD(SYS_CACHE_GRP_REGION0_U_RNI_NID4, REGION1_TARGET_TYPE, 34, 2)
    FIELD(SYS_CACHE_GRP_REGION0_U_RNI_NID4, REGION1_NONHASH_REG_EN, 33, 1)
    FIELD(SYS_CACHE_GRP_REGION0_U_RNI_NID4, REGION1_VALID, 32, 1)
    FIELD(SYS_CACHE_GRP_REGION0_U_RNI_NID4, RESERVED_31, 31, 1)
    FIELD(SYS_CACHE_GRP_REGION0_U_RNI_NID4, REGION0_BASE_ADDR, 9, 22)
    FIELD(SYS_CACHE_GRP_REGION0_U_RNI_NID4, REGION0_SIZE, 4, 5)
    FIELD(SYS_CACHE_GRP_REGION0_U_RNI_NID4, REGION0_TARGET_TYPE, 2, 2)
    FIELD(SYS_CACHE_GRP_REGION0_U_RNI_NID4, REGION0_VALID, 0, 1)
REG32(SYS_CACHE_GRP_REGION1_U_RNI_NID4, 0x24c50)
    FIELD(SYS_CACHE_GRP_REGION1_U_RNI_NID4, RESERVED_63, 63, 1)
    FIELD(SYS_CACHE_GRP_REGION1_U_RNI_NID4, REGION3_BASE_ADDR, 41, 22)
    FIELD(SYS_CACHE_GRP_REGION1_U_RNI_NID4, REGION3_SIZE, 36, 5)
    FIELD(SYS_CACHE_GRP_REGION1_U_RNI_NID4, REGION3_TARGET_TYPE, 34, 2)
    FIELD(SYS_CACHE_GRP_REGION1_U_RNI_NID4, REGION3_NONHASH_REG_EN, 33, 1)
    FIELD(SYS_CACHE_GRP_REGION1_U_RNI_NID4, REGION3_VALID, 32, 1)
    FIELD(SYS_CACHE_GRP_REGION1_U_RNI_NID4, RESERVED_31, 31, 1)
    FIELD(SYS_CACHE_GRP_REGION1_U_RNI_NID4, REGION2_BASE_ADDR, 9, 22)
    FIELD(SYS_CACHE_GRP_REGION1_U_RNI_NID4, REGION2_SIZE, 4, 5)
    FIELD(SYS_CACHE_GRP_REGION1_U_RNI_NID4, REGION2_TARGET_TYPE, 2, 2)
    FIELD(SYS_CACHE_GRP_REGION1_U_RNI_NID4, REGION2_NONHASH_REG_EN, 1, 1)
    FIELD(SYS_CACHE_GRP_REGION1_U_RNI_NID4, REGION2_VALID, 0, 1)
REG32(SYS_CACHE_GRP_HN_NODEID_REG0_U_RNI_NID4, 0x24c58)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG0_U_RNI_NID4, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG0_U_RNI_NID4, NODEID_3, 36, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG0_U_RNI_NID4, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG0_U_RNI_NID4, NODEID_2, 24, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG0_U_RNI_NID4, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG0_U_RNI_NID4, NODEID_1, 12, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG0_U_RNI_NID4, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG0_U_RNI_NID4, NODEID_0, 0, 11)
REG32(SYS_CACHE_GRP_HN_NODEID_REG1_U_RNI_NID4, 0x24c60)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG1_U_RNI_NID4, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG1_U_RNI_NID4, NODEID_7, 36, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG1_U_RNI_NID4, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG1_U_RNI_NID4, NODEID_6, 24, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG1_U_RNI_NID4, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG1_U_RNI_NID4, NODEID_5, 12, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG1_U_RNI_NID4, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG1_U_RNI_NID4, NODEID_4, 0, 11)
REG32(SYS_CACHE_GRP_HN_NODEID_REG2_U_RNI_NID4, 0x24c68)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG2_U_RNI_NID4, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG2_U_RNI_NID4, NODEID_11, 36, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG2_U_RNI_NID4, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG2_U_RNI_NID4, NODEID_10, 24, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG2_U_RNI_NID4, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG2_U_RNI_NID4, NODEID_9, 12, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG2_U_RNI_NID4, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG2_U_RNI_NID4, NODEID_8, 0, 11)
REG32(SYS_CACHE_GRP_HN_NODEID_REG3_U_RNI_NID4, 0x24c70)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG3_U_RNI_NID4, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG3_U_RNI_NID4, NODEID_15, 36, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG3_U_RNI_NID4, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG3_U_RNI_NID4, NODEID_14, 24, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG3_U_RNI_NID4, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG3_U_RNI_NID4, NODEID_13, 12, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG3_U_RNI_NID4, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG3_U_RNI_NID4, NODEID_12, 0, 11)
REG32(SYS_CACHE_GRP_HN_NODEID_REG4_U_RNI_NID4, 0x24c78)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG4_U_RNI_NID4, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG4_U_RNI_NID4, NODEID_19, 36, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG4_U_RNI_NID4, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG4_U_RNI_NID4, NODEID_18, 24, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG4_U_RNI_NID4, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG4_U_RNI_NID4, NODEID_17, 12, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG4_U_RNI_NID4, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG4_U_RNI_NID4, NODEID_16, 0, 11)
REG32(SYS_CACHE_GRP_HN_NODEID_REG5_U_RNI_NID4, 0x24c80)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG5_U_RNI_NID4, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG5_U_RNI_NID4, NODEID_23, 36, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG5_U_RNI_NID4, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG5_U_RNI_NID4, NODEID_22, 24, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG5_U_RNI_NID4, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG5_U_RNI_NID4, NODEID_21, 12, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG5_U_RNI_NID4, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG5_U_RNI_NID4, NODEID_20, 0, 11)
REG32(SYS_CACHE_GRP_HN_NODEID_REG6_U_RNI_NID4, 0x24c88)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG6_U_RNI_NID4, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG6_U_RNI_NID4, NODEID_27, 36, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG6_U_RNI_NID4, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG6_U_RNI_NID4, NODEID_26, 24, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG6_U_RNI_NID4, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG6_U_RNI_NID4, NODEID_25, 12, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG6_U_RNI_NID4, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG6_U_RNI_NID4, NODEID_24, 0, 11)
REG32(SYS_CACHE_GRP_HN_NODEID_REG7_U_RNI_NID4, 0x24c90)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG7_U_RNI_NID4, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG7_U_RNI_NID4, NODEID_31, 36, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG7_U_RNI_NID4, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG7_U_RNI_NID4, NODEID_30, 24, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG7_U_RNI_NID4, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG7_U_RNI_NID4, NODEID_29, 12, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG7_U_RNI_NID4, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG7_U_RNI_NID4, NODEID_28, 0, 11)
REG32(SYS_CACHE_GRP_NONHASH_NODEID_U_RNI_NID4, 0x24c98)
    FIELD(SYS_CACHE_GRP_NONHASH_NODEID_U_RNI_NID4, RESERVED_35, 35, 29)
    FIELD(SYS_CACHE_GRP_NONHASH_NODEID_U_RNI_NID4, SCG3_NODEID, 24, 11)
    FIELD(SYS_CACHE_GRP_NONHASH_NODEID_U_RNI_NID4, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_NONHASH_NODEID_U_RNI_NID4, SCG2_NODEID, 12, 11)
    FIELD(SYS_CACHE_GRP_NONHASH_NODEID_U_RNI_NID4, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_NONHASH_NODEID_U_RNI_NID4, SCG1_NODEID, 0, 11)
REG32(SYS_CACHE_GROUP_HN_COUNT_U_RNI_NID4, 0x24d00)
    FIELD(SYS_CACHE_GROUP_HN_COUNT_U_RNI_NID4, RESERVED_31, 31, 33)
    FIELD(SYS_CACHE_GROUP_HN_COUNT_U_RNI_NID4, SCG3_NUM_HNF, 24, 7)
    FIELD(SYS_CACHE_GROUP_HN_COUNT_U_RNI_NID4, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GROUP_HN_COUNT_U_RNI_NID4, SCG2_NUM_HNF, 16, 7)
    FIELD(SYS_CACHE_GROUP_HN_COUNT_U_RNI_NID4, RESERVED_15, 15, 1)
    FIELD(SYS_CACHE_GROUP_HN_COUNT_U_RNI_NID4, SCG1_NUM_HNF, 8, 7)
    FIELD(SYS_CACHE_GROUP_HN_COUNT_U_RNI_NID4, SCG0_NUM_HNF, 0, 7)
REG32(SYS_CACHE_GRP_SN_NODEID_REG0_U_RNI_NID4, 0x24d08)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG0_U_RNI_NID4, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG0_U_RNI_NID4, SN_NODEID_3, 36, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG0_U_RNI_NID4, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG0_U_RNI_NID4, SN_NODEID_2, 24, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG0_U_RNI_NID4, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG0_U_RNI_NID4, SN_NODEID_1, 12, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG0_U_RNI_NID4, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG0_U_RNI_NID4, SN_NODEID_0, 0, 11)
REG32(SYS_CACHE_GRP_SN_NODEID_REG1_U_RNI_NID4, 0x24d10)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG1_U_RNI_NID4, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG1_U_RNI_NID4, SN_NODEID_7, 36, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG1_U_RNI_NID4, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG1_U_RNI_NID4, SN_NODEID_6, 24, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG1_U_RNI_NID4, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG1_U_RNI_NID4, SN_NODEID_5, 12, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG1_U_RNI_NID4, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG1_U_RNI_NID4, SN_NODEID_4, 0, 11)
REG32(SYS_CACHE_GRP_SN_NODEID_REG2_U_RNI_NID4, 0x24d18)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG2_U_RNI_NID4, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG2_U_RNI_NID4, SN_NODEID_11, 36, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG2_U_RNI_NID4, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG2_U_RNI_NID4, SN_NODEID_10, 24, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG2_U_RNI_NID4, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG2_U_RNI_NID4, SN_NODEID_9, 12, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG2_U_RNI_NID4, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG2_U_RNI_NID4, SN_NODEID_8, 0, 11)
REG32(SYS_CACHE_GRP_SN_NODEID_REG3_U_RNI_NID4, 0x24d20)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG3_U_RNI_NID4, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG3_U_RNI_NID4, SN_NODEID_15, 36, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG3_U_RNI_NID4, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG3_U_RNI_NID4, SN_NODEID_14, 24, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG3_U_RNI_NID4, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG3_U_RNI_NID4, SN_NODEID_13, 12, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG3_U_RNI_NID4, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG3_U_RNI_NID4, SN_NODEID_12, 0, 11)
REG32(SYS_CACHE_GRP_SN_NODEID_REG4_U_RNI_NID4, 0x24d28)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG4_U_RNI_NID4, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG4_U_RNI_NID4, SN_NODEID_19, 36, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG4_U_RNI_NID4, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG4_U_RNI_NID4, SN_NODEID_18, 24, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG4_U_RNI_NID4, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG4_U_RNI_NID4, SN_NODEID_17, 12, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG4_U_RNI_NID4, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG4_U_RNI_NID4, SN_NODEID_16, 0, 11)
REG32(SYS_CACHE_GRP_SN_NODEID_REG5_U_RNI_NID4, 0x24d30)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG5_U_RNI_NID4, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG5_U_RNI_NID4, SN_NODEID_23, 36, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG5_U_RNI_NID4, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG5_U_RNI_NID4, SN_NODEID_22, 24, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG5_U_RNI_NID4, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG5_U_RNI_NID4, SN_NODEID_21, 12, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG5_U_RNI_NID4, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG5_U_RNI_NID4, SN_NODEID_20, 0, 11)
REG32(SYS_CACHE_GRP_SN_NODEID_REG6_U_RNI_NID4, 0x24d38)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG6_U_RNI_NID4, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG6_U_RNI_NID4, SN_NODEID_27, 36, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG6_U_RNI_NID4, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG6_U_RNI_NID4, SN_NODEID_26, 24, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG6_U_RNI_NID4, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG6_U_RNI_NID4, SN_NODEID_25, 12, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG6_U_RNI_NID4, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG6_U_RNI_NID4, SN_NODEID_24, 0, 11)
REG32(SYS_CACHE_GRP_SN_NODEID_REG7_U_RNI_NID4, 0x24d40)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG7_U_RNI_NID4, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG7_U_RNI_NID4, SN_NODEID_31, 36, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG7_U_RNI_NID4, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG7_U_RNI_NID4, SN_NODEID_30, 24, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG7_U_RNI_NID4, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG7_U_RNI_NID4, SN_NODEID_29, 12, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG7_U_RNI_NID4, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG7_U_RNI_NID4, SN_NODEID_28, 0, 11)
REG32(SYS_CACHE_GRP_SN_SAM_CFG0_U_RNI_NID4, 0x24d48)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG0_U_RNI_NID4, RESERVED_46, 46, 18)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG0_U_RNI_NID4, SCG1_TOP_ADDRESS_BIT2, 40, 6)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG0_U_RNI_NID4, RESERVED_38, 38, 2)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG0_U_RNI_NID4, SCG1_TOP_ADDRESS_BIT1, 32, 6)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG0_U_RNI_NID4, RESERVED_30, 30, 2)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG0_U_RNI_NID4, SCG1_TOP_ADDRESS_BIT0, 24, 6)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG0_U_RNI_NID4, RESERVED_22, 22, 2)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG0_U_RNI_NID4, SCG0_TOP_ADDRESS_BIT2, 16, 6)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG0_U_RNI_NID4, RESERVED_14, 14, 2)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG0_U_RNI_NID4, SCG0_TOP_ADDRESS_BIT1, 8, 6)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG0_U_RNI_NID4, SCG0_TOP_ADDRESS_BIT0, 0, 6)
REG32(SYS_CACHE_GRP_SN_SAM_CFG1_U_RNI_NID4, 0x24d50)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG1_U_RNI_NID4, RESERVED_46, 46, 18)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG1_U_RNI_NID4, SCG3_TOP_ADDRESS_BIT2, 40, 6)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG1_U_RNI_NID4, RESERVED_38, 38, 2)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG1_U_RNI_NID4, SCG3_TOP_ADDRESS_BIT1, 32, 6)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG1_U_RNI_NID4, RESERVED_30, 30, 2)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG1_U_RNI_NID4, SCG3_TOP_ADDRESS_BIT0, 24, 6)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG1_U_RNI_NID4, RESERVED_22, 22, 2)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG1_U_RNI_NID4, SCG2_TOP_ADDRESS_BIT2, 16, 6)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG1_U_RNI_NID4, RESERVED_14, 14, 2)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG1_U_RNI_NID4, SCG2_TOP_ADDRESS_BIT1, 8, 6)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG1_U_RNI_NID4, SCG2_TOP_ADDRESS_BIT0, 0, 6)
REG32(GIC_MEM_REGION_REG_U_RNI_NID4, 0x24d58)
    FIELD(GIC_MEM_REGION_REG_U_RNI_NID4, RESERVED_63, 63, 1)
    FIELD(GIC_MEM_REGION_REG_U_RNI_NID4, GIC_REGION_NODEID, 52, 11)
    FIELD(GIC_MEM_REGION_REG_U_RNI_NID4, RESERVED_48, 48, 4)
    FIELD(GIC_MEM_REGION_REG_U_RNI_NID4, GIC_REGION_BASE_ADDR, 16, 32)
    FIELD(GIC_MEM_REGION_REG_U_RNI_NID4, GIC_REGION_SIZE, 4, 3)
    FIELD(GIC_MEM_REGION_REG_U_RNI_NID4, GIC_REGION_TARGET_TYPE, 2, 2)
    FIELD(GIC_MEM_REGION_REG_U_RNI_NID4, GIC_REGION_VALID, 0, 1)
REG32(SYS_CACHE_GRP_SN_ATTR_U_RNI_NID4, 0x24d60)
    FIELD(SYS_CACHE_GRP_SN_ATTR_U_RNI_NID4, RESERVED_54, 54, 10)
    FIELD(SYS_CACHE_GRP_SN_ATTR_U_RNI_NID4, SN_MODE_SYS_CACHE_GRP3, 52, 2)
    FIELD(SYS_CACHE_GRP_SN_ATTR_U_RNI_NID4, RESERVED_49, 49, 3)
    FIELD(SYS_CACHE_GRP_SN_ATTR_U_RNI_NID4, INV_TOP_ADDRESS_BIT_SYS_CACHE_GRP3, 48, 1)
    FIELD(SYS_CACHE_GRP_SN_ATTR_U_RNI_NID4, RESERVED_38, 38, 10)
    FIELD(SYS_CACHE_GRP_SN_ATTR_U_RNI_NID4, SN_MODE_SYS_CACHE_GRP2, 36, 2)
    FIELD(SYS_CACHE_GRP_SN_ATTR_U_RNI_NID4, RESERVED_33, 33, 3)
    FIELD(SYS_CACHE_GRP_SN_ATTR_U_RNI_NID4, INV_TOP_ADDRESS_BIT_SYS_CACHE_GRP2, 32, 1)
    FIELD(SYS_CACHE_GRP_SN_ATTR_U_RNI_NID4, RESERVED_22, 22, 10)
    FIELD(SYS_CACHE_GRP_SN_ATTR_U_RNI_NID4, SN_MODE_SYS_CACHE_GRP1, 20, 2)
    FIELD(SYS_CACHE_GRP_SN_ATTR_U_RNI_NID4, RESERVED_17, 17, 3)
    FIELD(SYS_CACHE_GRP_SN_ATTR_U_RNI_NID4, INV_TOP_ADDRESS_BIT_SYS_CACHE_GRP1, 16, 1)
    FIELD(SYS_CACHE_GRP_SN_ATTR_U_RNI_NID4, SN_MODE_SYS_CACHE_GRP0, 4, 2)
    FIELD(SYS_CACHE_GRP_SN_ATTR_U_RNI_NID4, INV_TOP_ADDRESS_BIT_SYS_CACHE_GRP0, 0, 1)
REG32(SYS_CACHE_GRP_HN_CPA_EN_REG_U_RNI_NID4, 0x24d68)
REG32(SYS_CACHE_GRP_HN_CPA_GRP_REG_U_RNI_NID4, 0x24d70)
    FIELD(SYS_CACHE_GRP_HN_CPA_GRP_REG_U_RNI_NID4, RESERVED_50, 50, 14)
    FIELD(SYS_CACHE_GRP_HN_CPA_GRP_REG_U_RNI_NID4, CPA_GRP_SCG3, 48, 2)
    FIELD(SYS_CACHE_GRP_HN_CPA_GRP_REG_U_RNI_NID4, RESERVED_34, 34, 14)
    FIELD(SYS_CACHE_GRP_HN_CPA_GRP_REG_U_RNI_NID4, CPA_GRP_SCG2, 32, 2)
    FIELD(SYS_CACHE_GRP_HN_CPA_GRP_REG_U_RNI_NID4, RESERVED_18, 18, 14)
    FIELD(SYS_CACHE_GRP_HN_CPA_GRP_REG_U_RNI_NID4, CPA_GRP_SCG1, 16, 2)
    FIELD(SYS_CACHE_GRP_HN_CPA_GRP_REG_U_RNI_NID4, CPA_GRP_SCG0, 0, 2)
REG32(CML_PORT_AGGR_MODE_CTRL_REG_U_RNI_NID4, 0x24e00)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNI_NID4, RESERVED_32, 32, 32)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNI_NID4, REGION7_PAG_GRPID, 30, 2)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNI_NID4, RESERVED_29, 29, 1)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNI_NID4, REGION7_PAG_EN, 28, 1)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNI_NID4, RESERVED_27, 27, 1)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNI_NID4, REGION6_PAG_GRPID, 25, 2)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNI_NID4, REGION6_PAG_EN, 24, 1)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNI_NID4, RESERVED_23, 23, 1)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNI_NID4, REGION5_PAG_GRPID, 21, 2)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNI_NID4, REGION5_PAG_EN, 20, 1)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNI_NID4, RESERVED_19, 19, 1)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNI_NID4, REGION4_PAG_GRPID, 17, 2)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNI_NID4, REGION4_PAG_EN, 16, 1)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNI_NID4, RESERVED_15, 15, 1)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNI_NID4, REGION3_PAG_GRPID, 13, 2)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNI_NID4, REGION3_PAG_EN, 12, 1)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNI_NID4, RESERVED_11, 11, 1)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNI_NID4, REGION2_PAG_GRPID, 9, 2)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNI_NID4, REGION2_PAG_EN, 8, 1)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNI_NID4, REGION1_PAG_GRPID, 5, 2)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNI_NID4, REGION1_PAG_EN, 4, 1)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNI_NID4, REGION0_PAG_GRPID, 1, 2)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNI_NID4, REGION0_PAG_EN, 0, 1)
REG32(CML_PORT_AGGR_GRP0_ADD_MASK_U_RNI_NID4, 0x24e08)
    FIELD(CML_PORT_AGGR_GRP0_ADD_MASK_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(CML_PORT_AGGR_GRP0_ADD_MASK_U_RNI_NID4, ADDR_MASK, 6, 42)
    FIELD(CML_PORT_AGGR_GRP0_ADD_MASK_U_RNI_NID4, RESERVED_0, 0, 6)
REG32(CML_PORT_AGGR_GRP1_ADD_MASK_U_RNI_NID4, 0x24e10)
    FIELD(CML_PORT_AGGR_GRP1_ADD_MASK_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(CML_PORT_AGGR_GRP1_ADD_MASK_U_RNI_NID4, ADDR_MASK, 6, 42)
    FIELD(CML_PORT_AGGR_GRP1_ADD_MASK_U_RNI_NID4, RESERVED_0, 0, 6)
REG32(CML_PORT_AGGR_GRP0_REG_U_RNI_NID4, 0x24e40)
    FIELD(CML_PORT_AGGR_GRP0_REG_U_RNI_NID4, RESERVED_50, 50, 14)
    FIELD(CML_PORT_AGGR_GRP0_REG_U_RNI_NID4, NUM_CXG_PAG0, 48, 2)
    FIELD(CML_PORT_AGGR_GRP0_REG_U_RNI_NID4, RESERVED_47, 47, 1)
    FIELD(CML_PORT_AGGR_GRP0_REG_U_RNI_NID4, PAG0_TGTID3, 36, 11)
    FIELD(CML_PORT_AGGR_GRP0_REG_U_RNI_NID4, RESERVED_35, 35, 1)
    FIELD(CML_PORT_AGGR_GRP0_REG_U_RNI_NID4, PAG0_TGTID2, 24, 11)
    FIELD(CML_PORT_AGGR_GRP0_REG_U_RNI_NID4, RESERVED_23, 23, 1)
    FIELD(CML_PORT_AGGR_GRP0_REG_U_RNI_NID4, PAG0_TGTID1, 12, 11)
    FIELD(CML_PORT_AGGR_GRP0_REG_U_RNI_NID4, RESERVED_11, 11, 1)
    FIELD(CML_PORT_AGGR_GRP0_REG_U_RNI_NID4, PAG0_TGTID0, 0, 11)
REG32(CML_PORT_AGGR_GRP1_REG_U_RNI_NID4, 0x24e48)
    FIELD(CML_PORT_AGGR_GRP1_REG_U_RNI_NID4, RESERVED_50, 50, 14)
    FIELD(CML_PORT_AGGR_GRP1_REG_U_RNI_NID4, NUM_CXG_PAG1, 48, 2)
    FIELD(CML_PORT_AGGR_GRP1_REG_U_RNI_NID4, RESERVED_47, 47, 1)
    FIELD(CML_PORT_AGGR_GRP1_REG_U_RNI_NID4, PAG1_TGTID3, 36, 11)
    FIELD(CML_PORT_AGGR_GRP1_REG_U_RNI_NID4, RESERVED_35, 35, 1)
    FIELD(CML_PORT_AGGR_GRP1_REG_U_RNI_NID4, PAG1_TGTID2, 24, 11)
    FIELD(CML_PORT_AGGR_GRP1_REG_U_RNI_NID4, RESERVED_23, 23, 1)
    FIELD(CML_PORT_AGGR_GRP1_REG_U_RNI_NID4, PAG1_TGTID1, 12, 11)
    FIELD(CML_PORT_AGGR_GRP1_REG_U_RNI_NID4, RESERVED_11, 11, 1)
    FIELD(CML_PORT_AGGR_GRP1_REG_U_RNI_NID4, PAG1_TGTID0, 0, 11)
REG32(SYS_CACHE_GRP_SECONDARY_REG0_U_RNI_NID4, 0x24f00)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG0_U_RNI_NID4, RESERVED_63, 63, 1)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG0_U_RNI_NID4, REGION1_SCNDRY_BASE_ADDR, 41, 22)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG0_U_RNI_NID4, REGION1_SCNDRY_SIZE, 36, 5)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG0_U_RNI_NID4, REGION1_SCNDRY_TARGET_TYPE, 34, 2)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG0_U_RNI_NID4, RESERVED_33, 33, 1)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG0_U_RNI_NID4, REGION1_SCNDRY_VALID, 32, 1)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG0_U_RNI_NID4, RESERVED_31, 31, 1)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG0_U_RNI_NID4, REGION0_SCNDRY_BASE_ADDR, 9, 22)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG0_U_RNI_NID4, REGION0_SCNDRY_SIZE, 4, 5)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG0_U_RNI_NID4, REGION0_SCNDRY_TARGET_TYPE, 2, 2)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG0_U_RNI_NID4, REGION0_SCNDRY_VALID, 0, 1)
REG32(SYS_CACHE_GRP_SECONDARY_REG1_U_RNI_NID4, 0x24f08)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG1_U_RNI_NID4, RESERVED_63, 63, 1)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG1_U_RNI_NID4, REGION3_SCNDRY_BASE_ADDR, 41, 22)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG1_U_RNI_NID4, REGION3_SCNDRY_SIZE, 36, 5)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG1_U_RNI_NID4, REGION3_SCNDRY_TARGET_TYPE, 34, 2)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG1_U_RNI_NID4, RESERVED_33, 33, 1)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG1_U_RNI_NID4, REGION3_SCNDRY_VALID, 32, 1)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG1_U_RNI_NID4, RESERVED_31, 31, 1)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG1_U_RNI_NID4, REGION2_SCNDRY_BASE_ADDR, 9, 22)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG1_U_RNI_NID4, REGION2_SCNDRY_SIZE, 4, 5)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG1_U_RNI_NID4, REGION2_SCNDRY_TARGET_TYPE, 2, 2)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG1_U_RNI_NID4, REGION2_SCNDRY_VALID, 0, 1)
REG32(SYS_CACHE_GRP_CAL_MODE_REG_U_RNI_NID4, 0x24f10)
    FIELD(SYS_CACHE_GRP_CAL_MODE_REG_U_RNI_NID4, RESERVED_49, 49, 15)
    FIELD(SYS_CACHE_GRP_CAL_MODE_REG_U_RNI_NID4, SCG3_HNF_CAL_MODE_EN, 48, 1)
    FIELD(SYS_CACHE_GRP_CAL_MODE_REG_U_RNI_NID4, RESERVED_33, 33, 15)
    FIELD(SYS_CACHE_GRP_CAL_MODE_REG_U_RNI_NID4, SCG2_HNF_CAL_MODE_EN, 32, 1)
    FIELD(SYS_CACHE_GRP_CAL_MODE_REG_U_RNI_NID4, RESERVED_17, 17, 15)
    FIELD(SYS_CACHE_GRP_CAL_MODE_REG_U_RNI_NID4, SCG1_HNF_CAL_MODE_EN, 16, 1)
    FIELD(SYS_CACHE_GRP_CAL_MODE_REG_U_RNI_NID4, SCG0_HNF_CAL_MODE_EN, 0, 1)
REG32(RNSAM_HASH_ADDR_MASK_REG_U_RNI_NID4, 0x24f18)
    FIELD(RNSAM_HASH_ADDR_MASK_REG_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(RNSAM_HASH_ADDR_MASK_REG_U_RNI_NID4, ADDR_MASK, 6, 42)
    FIELD(RNSAM_HASH_ADDR_MASK_REG_U_RNI_NID4, RESERVED_0, 0, 6)
REG32(RNSAM_REGION_CMP_ADDR_MASK_REG_U_RNI_NID4, 0x24f20)
    FIELD(RNSAM_REGION_CMP_ADDR_MASK_REG_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(RNSAM_REGION_CMP_ADDR_MASK_REG_U_RNI_NID4, ADDR_MASK, 16, 32)
    FIELD(RNSAM_REGION_CMP_ADDR_MASK_REG_U_RNI_NID4, RESERVED_0, 0, 16)
REG32(SYS_CACHE_GRP_HN_NODEID_REG8_U_RNI_NID4, 0x24f58)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG8_U_RNI_NID4, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG8_U_RNI_NID4, NODEID_35, 36, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG8_U_RNI_NID4, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG8_U_RNI_NID4, NODEID_34, 24, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG8_U_RNI_NID4, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG8_U_RNI_NID4, NODEID_33, 12, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG8_U_RNI_NID4, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG8_U_RNI_NID4, NODEID_32, 0, 11)
REG32(SYS_CACHE_GRP_HN_NODEID_REG9_U_RNI_NID4, 0x24f60)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG9_U_RNI_NID4, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG9_U_RNI_NID4, NODEID_39, 36, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG9_U_RNI_NID4, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG9_U_RNI_NID4, NODEID_38, 24, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG9_U_RNI_NID4, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG9_U_RNI_NID4, NODEID_37, 12, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG9_U_RNI_NID4, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG9_U_RNI_NID4, NODEID_36, 0, 11)
REG32(SYS_CACHE_GRP_HN_NODEID_REG10_U_RNI_NID4, 0x24f68)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG10_U_RNI_NID4, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG10_U_RNI_NID4, NODEID_43, 36, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG10_U_RNI_NID4, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG10_U_RNI_NID4, NODEID_42, 24, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG10_U_RNI_NID4, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG10_U_RNI_NID4, NODEID_41, 12, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG10_U_RNI_NID4, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG10_U_RNI_NID4, NODEID_40, 0, 11)
REG32(SYS_CACHE_GRP_HN_NODEID_REG11_U_RNI_NID4, 0x24f70)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG11_U_RNI_NID4, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG11_U_RNI_NID4, NODEID_47, 36, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG11_U_RNI_NID4, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG11_U_RNI_NID4, NODEID_46, 24, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG11_U_RNI_NID4, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG11_U_RNI_NID4, NODEID_45, 12, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG11_U_RNI_NID4, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG11_U_RNI_NID4, NODEID_44, 0, 11)
REG32(SYS_CACHE_GRP_HN_NODEID_REG12_U_RNI_NID4, 0x24f78)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG12_U_RNI_NID4, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG12_U_RNI_NID4, NODEID_51, 36, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG12_U_RNI_NID4, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG12_U_RNI_NID4, NODEID_50, 24, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG12_U_RNI_NID4, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG12_U_RNI_NID4, NODEID_49, 12, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG12_U_RNI_NID4, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG12_U_RNI_NID4, NODEID_48, 0, 11)
REG32(SYS_CACHE_GRP_HN_NODEID_REG13_U_RNI_NID4, 0x24f80)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG13_U_RNI_NID4, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG13_U_RNI_NID4, NODEID_55, 36, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG13_U_RNI_NID4, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG13_U_RNI_NID4, NODEID_54, 24, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG13_U_RNI_NID4, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG13_U_RNI_NID4, NODEID_53, 12, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG13_U_RNI_NID4, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG13_U_RNI_NID4, NODEID_52, 0, 11)
REG32(SYS_CACHE_GRP_HN_NODEID_REG14_U_RNI_NID4, 0x24f88)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG14_U_RNI_NID4, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG14_U_RNI_NID4, NODEID_59, 36, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG14_U_RNI_NID4, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG14_U_RNI_NID4, NODEID_58, 24, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG14_U_RNI_NID4, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG14_U_RNI_NID4, NODEID_57, 12, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG14_U_RNI_NID4, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG14_U_RNI_NID4, NODEID_56, 0, 11)
REG32(SYS_CACHE_GRP_HN_NODEID_REG15_U_RNI_NID4, 0x24f90)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG15_U_RNI_NID4, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG15_U_RNI_NID4, NODEID_63, 36, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG15_U_RNI_NID4, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG15_U_RNI_NID4, NODEID_62, 24, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG15_U_RNI_NID4, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG15_U_RNI_NID4, NODEID_61, 12, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG15_U_RNI_NID4, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG15_U_RNI_NID4, NODEID_60, 0, 11)
REG32(SYS_CACHE_GRP_SN_NODEID_REG8_U_RNI_NID4, 0x25008)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG8_U_RNI_NID4, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG8_U_RNI_NID4, SN_NODEID_35, 36, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG8_U_RNI_NID4, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG8_U_RNI_NID4, SN_NODEID_34, 24, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG8_U_RNI_NID4, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG8_U_RNI_NID4, SN_NODEID_33, 12, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG8_U_RNI_NID4, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG8_U_RNI_NID4, SN_NODEID_32, 0, 11)
REG32(SYS_CACHE_GRP_SN_NODEID_REG9_U_RNI_NID4, 0x25010)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG9_U_RNI_NID4, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG9_U_RNI_NID4, SN_NODEID_39, 36, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG9_U_RNI_NID4, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG9_U_RNI_NID4, SN_NODEID_38, 24, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG9_U_RNI_NID4, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG9_U_RNI_NID4, SN_NODEID_37, 12, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG9_U_RNI_NID4, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG9_U_RNI_NID4, SN_NODEID_36, 0, 11)
REG32(SYS_CACHE_GRP_SN_NODEID_REG10_U_RNI_NID4, 0x25018)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG10_U_RNI_NID4, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG10_U_RNI_NID4, SN_NODEID_43, 36, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG10_U_RNI_NID4, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG10_U_RNI_NID4, SN_NODEID_42, 24, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG10_U_RNI_NID4, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG10_U_RNI_NID4, SN_NODEID_41, 12, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG10_U_RNI_NID4, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG10_U_RNI_NID4, SN_NODEID_40, 0, 11)
REG32(SYS_CACHE_GRP_SN_NODEID_REG11_U_RNI_NID4, 0x25020)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG11_U_RNI_NID4, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG11_U_RNI_NID4, SN_NODEID_47, 36, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG11_U_RNI_NID4, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG11_U_RNI_NID4, SN_NODEID_46, 24, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG11_U_RNI_NID4, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG11_U_RNI_NID4, SN_NODEID_45, 12, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG11_U_RNI_NID4, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG11_U_RNI_NID4, SN_NODEID_44, 0, 11)
REG32(SYS_CACHE_GRP_SN_NODEID_REG12_U_RNI_NID4, 0x25028)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG12_U_RNI_NID4, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG12_U_RNI_NID4, SN_NODEID_51, 36, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG12_U_RNI_NID4, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG12_U_RNI_NID4, SN_NODEID_50, 24, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG12_U_RNI_NID4, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG12_U_RNI_NID4, SN_NODEID_49, 12, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG12_U_RNI_NID4, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG12_U_RNI_NID4, SN_NODEID_48, 0, 11)
REG32(SYS_CACHE_GRP_SN_NODEID_REG13_U_RNI_NID4, 0x25030)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG13_U_RNI_NID4, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG13_U_RNI_NID4, SN_NODEID_55, 36, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG13_U_RNI_NID4, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG13_U_RNI_NID4, SN_NODEID_54, 24, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG13_U_RNI_NID4, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG13_U_RNI_NID4, SN_NODEID_53, 12, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG13_U_RNI_NID4, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG13_U_RNI_NID4, SN_NODEID_52, 0, 11)
REG32(SYS_CACHE_GRP_SN_NODEID_REG14_U_RNI_NID4, 0x25038)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG14_U_RNI_NID4, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG14_U_RNI_NID4, SN_NODEID_59, 36, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG14_U_RNI_NID4, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG14_U_RNI_NID4, SN_NODEID_58, 24, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG14_U_RNI_NID4, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG14_U_RNI_NID4, SN_NODEID_57, 12, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG14_U_RNI_NID4, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG14_U_RNI_NID4, SN_NODEID_56, 0, 11)
REG32(SYS_CACHE_GRP_SN_NODEID_REG15_U_RNI_NID4, 0x25040)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG15_U_RNI_NID4, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG15_U_RNI_NID4, SN_NODEID_63, 36, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG15_U_RNI_NID4, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG15_U_RNI_NID4, SN_NODEID_62, 24, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG15_U_RNI_NID4, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG15_U_RNI_NID4, SN_NODEID_61, 12, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG15_U_RNI_NID4, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG15_U_RNI_NID4, SN_NODEID_60, 0, 11)
REG32(POR_FDC_NODE_INFO_U_SMXP_0_0, 0x2c000)
    FIELD(POR_FDC_NODE_INFO_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_FDC_NODE_INFO_U_SMXP_0_0, LOGICAL_ID, 32, 16)
    FIELD(POR_FDC_NODE_INFO_U_SMXP_0_0, NODE_ID, 16, 16)
    FIELD(POR_FDC_NODE_INFO_U_SMXP_0_0, NODE_TYPE, 0, 16)
REG32(POR_FDC_CHILD_INFO_U_SMXP_0_0, 0x2c080)
    FIELD(POR_FDC_CHILD_INFO_U_SMXP_0_0, RESERVED_32, 32, 32)
    FIELD(POR_FDC_CHILD_INFO_U_SMXP_0_0, CHILD_PTR_OFFSET, 16, 16)
    FIELD(POR_FDC_CHILD_INFO_U_SMXP_0_0, CHILD_COUNT, 0, 16)
REG32(POR_ERRFR_MXP_U_SMXP_0_0, 0x2f000)
    FIELD(POR_ERRFR_MXP_U_SMXP_0_0, FI, 6, 2)
    FIELD(POR_ERRFR_MXP_U_SMXP_0_0, UI, 4, 2)
    FIELD(POR_ERRFR_MXP_U_SMXP_0_0, ED, 0, 2)
REG32(POR_ERRCTLR_MXP_U_SMXP_0_0, 0x2f008)
    FIELD(POR_ERRCTLR_MXP_U_SMXP_0_0, RESERVED_32, 32, 32)
    FIELD(POR_ERRCTLR_MXP_U_SMXP_0_0, ERC, 14, 18)
    FIELD(POR_ERRCTLR_MXP_U_SMXP_0_0, FI, 3, 1)
    FIELD(POR_ERRCTLR_MXP_U_SMXP_0_0, UI, 2, 1)
    FIELD(POR_ERRCTLR_MXP_U_SMXP_0_0, ED, 0, 1)
REG32(POR_ERRSTATUS_MXP_U_SMXP_0_0, 0x2f010)
    FIELD(POR_ERRSTATUS_MXP_U_SMXP_0_0, RESERVED_31, 31, 33)
    FIELD(POR_ERRSTATUS_MXP_U_SMXP_0_0, V, 30, 1)
    FIELD(POR_ERRSTATUS_MXP_U_SMXP_0_0, UE, 29, 1)
    FIELD(POR_ERRSTATUS_MXP_U_SMXP_0_0, RESERVED_28, 28, 1)
    FIELD(POR_ERRSTATUS_MXP_U_SMXP_0_0, OF, 27, 1)
    FIELD(POR_ERRSTATUS_MXP_U_SMXP_0_0, RESERVED_24, 24, 3)
    FIELD(POR_ERRSTATUS_MXP_U_SMXP_0_0, DE, 23, 1)
    FIELD(POR_ERRSTATUS_MXP_U_SMXP_0_0, RESERVED_16, 16, 7)
    FIELD(POR_ERRSTATUS_MXP_U_SMXP_0_0, V_ERR_TYPE, 6, 10)
    FIELD(POR_ERRSTATUS_MXP_U_SMXP_0_0, RESERVED_0, 0, 6)
REG32(POR_FDC_AUX_CTL_MXP_U_SMXP_0_0, 0x2f018)
    FIELD(POR_FDC_AUX_CTL_MXP_U_SMXP_0_0, CLKGATE_OVERRIDE, 4, 1)
    FIELD(POR_FDC_AUX_CTL_MXP_U_SMXP_0_0, RESERVED_0, 0, 4)
REG32(POR_ERRFR_P0_D0_U_SMXP_0_0, 0x2f040)
    FIELD(POR_ERRFR_P0_D0_U_SMXP_0_0, FI, 6, 2)
    FIELD(POR_ERRFR_P0_D0_U_SMXP_0_0, UI, 4, 2)
    FIELD(POR_ERRFR_P0_D0_U_SMXP_0_0, ED, 0, 2)
REG32(POR_ERRCTLR_P0_D0_U_SMXP_0_0, 0x2f048)
    FIELD(POR_ERRCTLR_P0_D0_U_SMXP_0_0, RESERVED_32, 32, 32)
    FIELD(POR_ERRCTLR_P0_D0_U_SMXP_0_0, ERC, 14, 18)
    FIELD(POR_ERRCTLR_P0_D0_U_SMXP_0_0, FI, 3, 1)
    FIELD(POR_ERRCTLR_P0_D0_U_SMXP_0_0, UI, 2, 1)
    FIELD(POR_ERRCTLR_P0_D0_U_SMXP_0_0, ED, 0, 1)
REG32(POR_ERRSTATUS_P0_D0_U_SMXP_0_0, 0x2f050)
    FIELD(POR_ERRSTATUS_P0_D0_U_SMXP_0_0, RESERVED_31, 31, 33)
    FIELD(POR_ERRSTATUS_P0_D0_U_SMXP_0_0, V, 30, 1)
    FIELD(POR_ERRSTATUS_P0_D0_U_SMXP_0_0, UE, 29, 1)
    FIELD(POR_ERRSTATUS_P0_D0_U_SMXP_0_0, RESERVED_28, 28, 1)
    FIELD(POR_ERRSTATUS_P0_D0_U_SMXP_0_0, OF, 27, 1)
    FIELD(POR_ERRSTATUS_P0_D0_U_SMXP_0_0, RESERVED_24, 24, 3)
    FIELD(POR_ERRSTATUS_P0_D0_U_SMXP_0_0, DE, 23, 1)
    FIELD(POR_ERRSTATUS_P0_D0_U_SMXP_0_0, RESERVED_16, 16, 7)
    FIELD(POR_ERRSTATUS_P0_D0_U_SMXP_0_0, V_ERR_TYPE, 6, 10)
    FIELD(POR_ERRSTATUS_P0_D0_U_SMXP_0_0, RESERVED_0, 0, 6)
REG32(POR_FDC_AUX_CTL_P0_D0_U_SMXP_0_0, 0x2f058)
    FIELD(POR_FDC_AUX_CTL_P0_D0_U_SMXP_0_0, CLKGATE_OVERRIDE, 4, 1)
    FIELD(POR_FDC_AUX_CTL_P0_D0_U_SMXP_0_0, HANG_DET_CONFIG, 0, 4)
REG32(POR_ERRFR_P0_D1_U_SMXP_0_0, 0x2f080)
    FIELD(POR_ERRFR_P0_D1_U_SMXP_0_0, FI, 6, 2)
    FIELD(POR_ERRFR_P0_D1_U_SMXP_0_0, UI, 4, 2)
    FIELD(POR_ERRFR_P0_D1_U_SMXP_0_0, ED, 0, 2)
REG32(POR_ERRCTLR_P0_D1_U_SMXP_0_0, 0x2f088)
    FIELD(POR_ERRCTLR_P0_D1_U_SMXP_0_0, RESERVED_32, 32, 32)
    FIELD(POR_ERRCTLR_P0_D1_U_SMXP_0_0, ERC, 14, 18)
    FIELD(POR_ERRCTLR_P0_D1_U_SMXP_0_0, FI, 3, 1)
    FIELD(POR_ERRCTLR_P0_D1_U_SMXP_0_0, UI, 2, 1)
    FIELD(POR_ERRCTLR_P0_D1_U_SMXP_0_0, ED, 0, 1)
REG32(POR_ERRSTATUS_P0_D1_U_SMXP_0_0, 0x2f090)
    FIELD(POR_ERRSTATUS_P0_D1_U_SMXP_0_0, RESERVED_31, 31, 33)
    FIELD(POR_ERRSTATUS_P0_D1_U_SMXP_0_0, V, 30, 1)
    FIELD(POR_ERRSTATUS_P0_D1_U_SMXP_0_0, UE, 29, 1)
    FIELD(POR_ERRSTATUS_P0_D1_U_SMXP_0_0, RESERVED_28, 28, 1)
    FIELD(POR_ERRSTATUS_P0_D1_U_SMXP_0_0, OF, 27, 1)
    FIELD(POR_ERRSTATUS_P0_D1_U_SMXP_0_0, RESERVED_24, 24, 3)
    FIELD(POR_ERRSTATUS_P0_D1_U_SMXP_0_0, DE, 23, 1)
    FIELD(POR_ERRSTATUS_P0_D1_U_SMXP_0_0, RESERVED_16, 16, 7)
    FIELD(POR_ERRSTATUS_P0_D1_U_SMXP_0_0, V_ERR_TYPE, 6, 10)
    FIELD(POR_ERRSTATUS_P0_D1_U_SMXP_0_0, RESERVED_0, 0, 6)
REG32(POR_FDC_AUX_CTL_P0_D1_U_SMXP_0_0, 0x2f098)
    FIELD(POR_FDC_AUX_CTL_P0_D1_U_SMXP_0_0, CLKGATE_OVERRIDE, 4, 1)
    FIELD(POR_FDC_AUX_CTL_P0_D1_U_SMXP_0_0, HANG_DET_CONFIG, 0, 4)
REG32(POR_ERRFR_P0_D2_U_SMXP_0_0, 0x2f0c0)
    FIELD(POR_ERRFR_P0_D2_U_SMXP_0_0, FI, 6, 2)
    FIELD(POR_ERRFR_P0_D2_U_SMXP_0_0, UI, 4, 2)
    FIELD(POR_ERRFR_P0_D2_U_SMXP_0_0, ED, 0, 2)
REG32(POR_ERRCTLR_P0_D2_U_SMXP_0_0, 0x2f0c8)
    FIELD(POR_ERRCTLR_P0_D2_U_SMXP_0_0, RESERVED_32, 32, 32)
    FIELD(POR_ERRCTLR_P0_D2_U_SMXP_0_0, ERC, 14, 18)
    FIELD(POR_ERRCTLR_P0_D2_U_SMXP_0_0, FI, 3, 1)
    FIELD(POR_ERRCTLR_P0_D2_U_SMXP_0_0, UI, 2, 1)
    FIELD(POR_ERRCTLR_P0_D2_U_SMXP_0_0, ED, 0, 1)
REG32(POR_ERRSTATUS_P0_D2_U_SMXP_0_0, 0x2f0d0)
    FIELD(POR_ERRSTATUS_P0_D2_U_SMXP_0_0, RESERVED_31, 31, 33)
    FIELD(POR_ERRSTATUS_P0_D2_U_SMXP_0_0, V, 30, 1)
    FIELD(POR_ERRSTATUS_P0_D2_U_SMXP_0_0, UE, 29, 1)
    FIELD(POR_ERRSTATUS_P0_D2_U_SMXP_0_0, RESERVED_28, 28, 1)
    FIELD(POR_ERRSTATUS_P0_D2_U_SMXP_0_0, OF, 27, 1)
    FIELD(POR_ERRSTATUS_P0_D2_U_SMXP_0_0, RESERVED_24, 24, 3)
    FIELD(POR_ERRSTATUS_P0_D2_U_SMXP_0_0, DE, 23, 1)
    FIELD(POR_ERRSTATUS_P0_D2_U_SMXP_0_0, RESERVED_16, 16, 7)
    FIELD(POR_ERRSTATUS_P0_D2_U_SMXP_0_0, V_ERR_TYPE, 6, 10)
    FIELD(POR_ERRSTATUS_P0_D2_U_SMXP_0_0, RESERVED_0, 0, 6)
REG32(POR_FDC_AUX_CTL_P0_D2_U_SMXP_0_0, 0x2f0d8)
    FIELD(POR_FDC_AUX_CTL_P0_D2_U_SMXP_0_0, CLKGATE_OVERRIDE, 4, 1)
    FIELD(POR_FDC_AUX_CTL_P0_D2_U_SMXP_0_0, HANG_DET_CONFIG, 0, 4)
REG32(POR_ERRFR_P0_D3_U_SMXP_0_0, 0x2f100)
    FIELD(POR_ERRFR_P0_D3_U_SMXP_0_0, FI, 6, 2)
    FIELD(POR_ERRFR_P0_D3_U_SMXP_0_0, UI, 4, 2)
    FIELD(POR_ERRFR_P0_D3_U_SMXP_0_0, ED, 0, 2)
REG32(POR_ERRCTLR_P0_D3_U_SMXP_0_0, 0x2f108)
    FIELD(POR_ERRCTLR_P0_D3_U_SMXP_0_0, RESERVED_32, 32, 32)
    FIELD(POR_ERRCTLR_P0_D3_U_SMXP_0_0, ERC, 14, 18)
    FIELD(POR_ERRCTLR_P0_D3_U_SMXP_0_0, FI, 3, 1)
    FIELD(POR_ERRCTLR_P0_D3_U_SMXP_0_0, UI, 2, 1)
    FIELD(POR_ERRCTLR_P0_D3_U_SMXP_0_0, ED, 0, 1)
REG32(POR_ERRSTATUS_P0_D3_U_SMXP_0_0, 0x2f110)
    FIELD(POR_ERRSTATUS_P0_D3_U_SMXP_0_0, RESERVED_31, 31, 33)
    FIELD(POR_ERRSTATUS_P0_D3_U_SMXP_0_0, V, 30, 1)
    FIELD(POR_ERRSTATUS_P0_D3_U_SMXP_0_0, UE, 29, 1)
    FIELD(POR_ERRSTATUS_P0_D3_U_SMXP_0_0, RESERVED_28, 28, 1)
    FIELD(POR_ERRSTATUS_P0_D3_U_SMXP_0_0, OF, 27, 1)
    FIELD(POR_ERRSTATUS_P0_D3_U_SMXP_0_0, RESERVED_24, 24, 3)
    FIELD(POR_ERRSTATUS_P0_D3_U_SMXP_0_0, DE, 23, 1)
    FIELD(POR_ERRSTATUS_P0_D3_U_SMXP_0_0, RESERVED_16, 16, 7)
    FIELD(POR_ERRSTATUS_P0_D3_U_SMXP_0_0, V_ERR_TYPE, 6, 10)
    FIELD(POR_ERRSTATUS_P0_D3_U_SMXP_0_0, RESERVED_0, 0, 6)
REG32(POR_FDC_AUX_CTL_P0_D3_U_SMXP_0_0, 0x2f118)
    FIELD(POR_FDC_AUX_CTL_P0_D3_U_SMXP_0_0, CLKGATE_OVERRIDE, 4, 1)
    FIELD(POR_FDC_AUX_CTL_P0_D3_U_SMXP_0_0, HANG_DET_CONFIG, 0, 4)
REG32(POR_ERRFR_P1_D0_U_SMXP_0_0, 0x2f140)
    FIELD(POR_ERRFR_P1_D0_U_SMXP_0_0, FI, 6, 2)
    FIELD(POR_ERRFR_P1_D0_U_SMXP_0_0, UI, 4, 2)
    FIELD(POR_ERRFR_P1_D0_U_SMXP_0_0, ED, 0, 2)
REG32(POR_ERRCTLR_P1_D0_U_SMXP_0_0, 0x2f148)
    FIELD(POR_ERRCTLR_P1_D0_U_SMXP_0_0, RESERVED_32, 32, 32)
    FIELD(POR_ERRCTLR_P1_D0_U_SMXP_0_0, ERC, 14, 18)
    FIELD(POR_ERRCTLR_P1_D0_U_SMXP_0_0, FI, 3, 1)
    FIELD(POR_ERRCTLR_P1_D0_U_SMXP_0_0, UI, 2, 1)
    FIELD(POR_ERRCTLR_P1_D0_U_SMXP_0_0, ED, 0, 1)
REG32(POR_ERRSTATUS_P1_D0_U_SMXP_0_0, 0x2f150)
    FIELD(POR_ERRSTATUS_P1_D0_U_SMXP_0_0, RESERVED_31, 31, 33)
    FIELD(POR_ERRSTATUS_P1_D0_U_SMXP_0_0, V, 30, 1)
    FIELD(POR_ERRSTATUS_P1_D0_U_SMXP_0_0, UE, 29, 1)
    FIELD(POR_ERRSTATUS_P1_D0_U_SMXP_0_0, RESERVED_28, 28, 1)
    FIELD(POR_ERRSTATUS_P1_D0_U_SMXP_0_0, OF, 27, 1)
    FIELD(POR_ERRSTATUS_P1_D0_U_SMXP_0_0, RESERVED_24, 24, 3)
    FIELD(POR_ERRSTATUS_P1_D0_U_SMXP_0_0, DE, 23, 1)
    FIELD(POR_ERRSTATUS_P1_D0_U_SMXP_0_0, RESERVED_16, 16, 7)
    FIELD(POR_ERRSTATUS_P1_D0_U_SMXP_0_0, V_ERR_TYPE, 6, 10)
    FIELD(POR_ERRSTATUS_P1_D0_U_SMXP_0_0, RESERVED_0, 0, 6)
REG32(POR_FDC_AUX_CTL_P1_D0_U_SMXP_0_0, 0x2f158)
    FIELD(POR_FDC_AUX_CTL_P1_D0_U_SMXP_0_0, CLKGATE_OVERRIDE, 4, 1)
    FIELD(POR_FDC_AUX_CTL_P1_D0_U_SMXP_0_0, HANG_DET_CONFIG, 0, 4)
REG32(POR_ERRFR_P1_D1_U_SMXP_0_0, 0x2f180)
    FIELD(POR_ERRFR_P1_D1_U_SMXP_0_0, FI, 6, 2)
    FIELD(POR_ERRFR_P1_D1_U_SMXP_0_0, UI, 4, 2)
    FIELD(POR_ERRFR_P1_D1_U_SMXP_0_0, ED, 0, 2)
REG32(POR_ERRCTLR_P1_D1_U_SMXP_0_0, 0x2f188)
    FIELD(POR_ERRCTLR_P1_D1_U_SMXP_0_0, RESERVED_32, 32, 32)
    FIELD(POR_ERRCTLR_P1_D1_U_SMXP_0_0, ERC, 14, 18)
    FIELD(POR_ERRCTLR_P1_D1_U_SMXP_0_0, FI, 3, 1)
    FIELD(POR_ERRCTLR_P1_D1_U_SMXP_0_0, UI, 2, 1)
    FIELD(POR_ERRCTLR_P1_D1_U_SMXP_0_0, ED, 0, 1)
REG32(POR_ERRSTATUS_P1_D1_U_SMXP_0_0, 0x2f190)
    FIELD(POR_ERRSTATUS_P1_D1_U_SMXP_0_0, RESERVED_31, 31, 33)
    FIELD(POR_ERRSTATUS_P1_D1_U_SMXP_0_0, V, 30, 1)
    FIELD(POR_ERRSTATUS_P1_D1_U_SMXP_0_0, UE, 29, 1)
    FIELD(POR_ERRSTATUS_P1_D1_U_SMXP_0_0, RESERVED_28, 28, 1)
    FIELD(POR_ERRSTATUS_P1_D1_U_SMXP_0_0, OF, 27, 1)
    FIELD(POR_ERRSTATUS_P1_D1_U_SMXP_0_0, RESERVED_24, 24, 3)
    FIELD(POR_ERRSTATUS_P1_D1_U_SMXP_0_0, DE, 23, 1)
    FIELD(POR_ERRSTATUS_P1_D1_U_SMXP_0_0, RESERVED_16, 16, 7)
    FIELD(POR_ERRSTATUS_P1_D1_U_SMXP_0_0, V_ERR_TYPE, 6, 10)
    FIELD(POR_ERRSTATUS_P1_D1_U_SMXP_0_0, RESERVED_0, 0, 6)
REG32(POR_FDC_AUX_CTL_P1_D1_U_SMXP_0_0, 0x2f198)
    FIELD(POR_FDC_AUX_CTL_P1_D1_U_SMXP_0_0, CLKGATE_OVERRIDE, 4, 1)
    FIELD(POR_FDC_AUX_CTL_P1_D1_U_SMXP_0_0, HANG_DET_CONFIG, 0, 4)
REG32(POR_ERRFR_P1_D2_U_SMXP_0_0, 0x2f1c0)
    FIELD(POR_ERRFR_P1_D2_U_SMXP_0_0, FI, 6, 2)
    FIELD(POR_ERRFR_P1_D2_U_SMXP_0_0, UI, 4, 2)
    FIELD(POR_ERRFR_P1_D2_U_SMXP_0_0, ED, 0, 2)
REG32(POR_ERRCTLR_P1_D2_U_SMXP_0_0, 0x2f1c8)
    FIELD(POR_ERRCTLR_P1_D2_U_SMXP_0_0, RESERVED_32, 32, 32)
    FIELD(POR_ERRCTLR_P1_D2_U_SMXP_0_0, ERC, 14, 18)
    FIELD(POR_ERRCTLR_P1_D2_U_SMXP_0_0, FI, 3, 1)
    FIELD(POR_ERRCTLR_P1_D2_U_SMXP_0_0, UI, 2, 1)
    FIELD(POR_ERRCTLR_P1_D2_U_SMXP_0_0, ED, 0, 1)
REG32(POR_ERRSTATUS_P1_D2_U_SMXP_0_0, 0x2f1d0)
    FIELD(POR_ERRSTATUS_P1_D2_U_SMXP_0_0, RESERVED_31, 31, 33)
    FIELD(POR_ERRSTATUS_P1_D2_U_SMXP_0_0, V, 30, 1)
    FIELD(POR_ERRSTATUS_P1_D2_U_SMXP_0_0, UE, 29, 1)
    FIELD(POR_ERRSTATUS_P1_D2_U_SMXP_0_0, RESERVED_28, 28, 1)
    FIELD(POR_ERRSTATUS_P1_D2_U_SMXP_0_0, OF, 27, 1)
    FIELD(POR_ERRSTATUS_P1_D2_U_SMXP_0_0, RESERVED_24, 24, 3)
    FIELD(POR_ERRSTATUS_P1_D2_U_SMXP_0_0, DE, 23, 1)
    FIELD(POR_ERRSTATUS_P1_D2_U_SMXP_0_0, RESERVED_16, 16, 7)
    FIELD(POR_ERRSTATUS_P1_D2_U_SMXP_0_0, V_ERR_TYPE, 6, 10)
    FIELD(POR_ERRSTATUS_P1_D2_U_SMXP_0_0, RESERVED_0, 0, 6)
REG32(POR_FDC_AUX_CTL_P1_D2_U_SMXP_0_0, 0x2f1d8)
    FIELD(POR_FDC_AUX_CTL_P1_D2_U_SMXP_0_0, CLKGATE_OVERRIDE, 4, 1)
    FIELD(POR_FDC_AUX_CTL_P1_D2_U_SMXP_0_0, HANG_DET_CONFIG, 0, 4)
REG32(POR_ERRFR_P1_D3_U_SMXP_0_0, 0x2f200)
    FIELD(POR_ERRFR_P1_D3_U_SMXP_0_0, FI, 6, 2)
    FIELD(POR_ERRFR_P1_D3_U_SMXP_0_0, UI, 4, 2)
    FIELD(POR_ERRFR_P1_D3_U_SMXP_0_0, ED, 0, 2)
REG32(POR_ERRCTLR_P1_D3_U_SMXP_0_0, 0x2f208)
    FIELD(POR_ERRCTLR_P1_D3_U_SMXP_0_0, RESERVED_32, 32, 32)
    FIELD(POR_ERRCTLR_P1_D3_U_SMXP_0_0, ERC, 14, 18)
    FIELD(POR_ERRCTLR_P1_D3_U_SMXP_0_0, FI, 3, 1)
    FIELD(POR_ERRCTLR_P1_D3_U_SMXP_0_0, UI, 2, 1)
    FIELD(POR_ERRCTLR_P1_D3_U_SMXP_0_0, ED, 0, 1)
REG32(POR_ERRSTATUS_P1_D3_U_SMXP_0_0, 0x2f210)
    FIELD(POR_ERRSTATUS_P1_D3_U_SMXP_0_0, RESERVED_31, 31, 33)
    FIELD(POR_ERRSTATUS_P1_D3_U_SMXP_0_0, V, 30, 1)
    FIELD(POR_ERRSTATUS_P1_D3_U_SMXP_0_0, UE, 29, 1)
    FIELD(POR_ERRSTATUS_P1_D3_U_SMXP_0_0, RESERVED_28, 28, 1)
    FIELD(POR_ERRSTATUS_P1_D3_U_SMXP_0_0, OF, 27, 1)
    FIELD(POR_ERRSTATUS_P1_D3_U_SMXP_0_0, RESERVED_24, 24, 3)
    FIELD(POR_ERRSTATUS_P1_D3_U_SMXP_0_0, DE, 23, 1)
    FIELD(POR_ERRSTATUS_P1_D3_U_SMXP_0_0, RESERVED_16, 16, 7)
    FIELD(POR_ERRSTATUS_P1_D3_U_SMXP_0_0, V_ERR_TYPE, 6, 10)
    FIELD(POR_ERRSTATUS_P1_D3_U_SMXP_0_0, RESERVED_0, 0, 6)
REG32(POR_FDC_AUX_CTL_P1_D3_U_SMXP_0_0, 0x2f218)
    FIELD(POR_FDC_AUX_CTL_P1_D3_U_SMXP_0_0, CLKGATE_OVERRIDE, 4, 1)
    FIELD(POR_FDC_AUX_CTL_P1_D3_U_SMXP_0_0, HANG_DET_CONFIG, 0, 4)
REG32(POR_ERRINJECT_U_SMXP_0_0, 0x2f300)
    FIELD(POR_ERRINJECT_U_SMXP_0_0, ERR_DEV, 4, 4)
    FIELD(POR_ERRINJECT_U_SMXP_0_0, ERR_TYPE, 0, 4)
REG32(POR_FDC_KEY_U_SMXP_0_0, 0x2f308)
    FIELD(POR_FDC_KEY_U_SMXP_0_0, KEY, 0, 8)
REG32(POR_MPU_NODE_INFO_U_RNI_NID4, 0x34000)
    FIELD(POR_MPU_NODE_INFO_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_NODE_INFO_U_RNI_NID4, LOGICAL_ID, 32, 16)
    FIELD(POR_MPU_NODE_INFO_U_RNI_NID4, NODE_ID, 16, 16)
    FIELD(POR_MPU_NODE_INFO_U_RNI_NID4, NODE_TYPE, 0, 16)
REG32(POR_MPU_CHILD_INFO_U_RNI_NID4, 0x34080)
    FIELD(POR_MPU_CHILD_INFO_U_RNI_NID4, RESERVED_32, 32, 32)
    FIELD(POR_MPU_CHILD_INFO_U_RNI_NID4, CHILD_PTR_OFFSET, 16, 16)
    FIELD(POR_MPU_CHILD_INFO_U_RNI_NID4, CHILD_COUNT, 0, 16)
REG32(POR_MPU_UNIT_INFO_U_RNI_NID4, 0x34900)
    FIELD(POR_MPU_UNIT_INFO_U_RNI_NID4, RESERVED_16, 16, 48)
    FIELD(POR_MPU_UNIT_INFO_U_RNI_NID4, MASTER_7_PRESENT, 15, 1)
    FIELD(POR_MPU_UNIT_INFO_U_RNI_NID4, MASTER_6_PRESENT, 14, 1)
    FIELD(POR_MPU_UNIT_INFO_U_RNI_NID4, MASTER_5_PRESENT, 13, 1)
    FIELD(POR_MPU_UNIT_INFO_U_RNI_NID4, MASTER_4_PRESENT, 12, 1)
    FIELD(POR_MPU_UNIT_INFO_U_RNI_NID4, MASTER_3_PRESENT, 11, 1)
    FIELD(POR_MPU_UNIT_INFO_U_RNI_NID4, MASTER_2_PRESENT, 10, 1)
    FIELD(POR_MPU_UNIT_INFO_U_RNI_NID4, MASTER_1_PRESENT, 9, 1)
    FIELD(POR_MPU_UNIT_INFO_U_RNI_NID4, MASTER_0_PRESENT, 8, 1)
    FIELD(POR_MPU_UNIT_INFO_U_RNI_NID4, NUM_PROG_REGION, 0, 8)
REG32(POR_MPU_M0_CTL_U_RNI_NID4, 0x35000)
    FIELD(POR_MPU_M0_CTL_U_RNI_NID4, M0_EN, 2, 1)
    FIELD(POR_MPU_M0_CTL_U_RNI_NID4, M0_ACTION, 0, 2)
REG32(POR_MPU_M0_PRBAR0_U_RNI_NID4, 0x35010)
    FIELD(POR_MPU_M0_PRBAR0_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR0_U_RNI_NID4, REGION0_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR0_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR0_U_RNI_NID4, REGION0_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR0_U_RNI_NID4, REGION0_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR0_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR0_U_RNI_NID4, 0x35018)
    FIELD(POR_MPU_M0_PRLAR0_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR0_U_RNI_NID4, REGION0_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR0_U_RNI_NID4, REGION0_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR1_U_RNI_NID4, 0x35020)
    FIELD(POR_MPU_M0_PRBAR1_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR1_U_RNI_NID4, REGION1_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR1_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR1_U_RNI_NID4, REGION1_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR1_U_RNI_NID4, REGION1_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR1_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR1_U_RNI_NID4, 0x35028)
    FIELD(POR_MPU_M0_PRLAR1_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR1_U_RNI_NID4, REGION1_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR1_U_RNI_NID4, REGION1_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR2_U_RNI_NID4, 0x35030)
    FIELD(POR_MPU_M0_PRBAR2_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR2_U_RNI_NID4, REGION2_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR2_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR2_U_RNI_NID4, REGION2_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR2_U_RNI_NID4, REGION2_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR2_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR2_U_RNI_NID4, 0x35038)
    FIELD(POR_MPU_M0_PRLAR2_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR2_U_RNI_NID4, REGION2_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR2_U_RNI_NID4, REGION2_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR3_U_RNI_NID4, 0x35040)
    FIELD(POR_MPU_M0_PRBAR3_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR3_U_RNI_NID4, REGION3_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR3_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR3_U_RNI_NID4, REGION3_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR3_U_RNI_NID4, REGION3_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR3_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR3_U_RNI_NID4, 0x35048)
    FIELD(POR_MPU_M0_PRLAR3_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR3_U_RNI_NID4, REGION3_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR3_U_RNI_NID4, REGION3_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR4_U_RNI_NID4, 0x35050)
    FIELD(POR_MPU_M0_PRBAR4_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR4_U_RNI_NID4, REGION4_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR4_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR4_U_RNI_NID4, REGION4_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR4_U_RNI_NID4, REGION4_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR4_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR4_U_RNI_NID4, 0x35058)
    FIELD(POR_MPU_M0_PRLAR4_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR4_U_RNI_NID4, REGION4_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR4_U_RNI_NID4, REGION4_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR5_U_RNI_NID4, 0x35060)
    FIELD(POR_MPU_M0_PRBAR5_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR5_U_RNI_NID4, REGION5_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR5_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR5_U_RNI_NID4, REGION5_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR5_U_RNI_NID4, REGION5_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR5_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR5_U_RNI_NID4, 0x35068)
    FIELD(POR_MPU_M0_PRLAR5_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR5_U_RNI_NID4, REGION5_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR5_U_RNI_NID4, REGION5_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR6_U_RNI_NID4, 0x35070)
    FIELD(POR_MPU_M0_PRBAR6_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR6_U_RNI_NID4, REGION6_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR6_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR6_U_RNI_NID4, REGION6_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR6_U_RNI_NID4, REGION6_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR6_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR6_U_RNI_NID4, 0x35078)
    FIELD(POR_MPU_M0_PRLAR6_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR6_U_RNI_NID4, REGION6_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR6_U_RNI_NID4, REGION6_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR7_U_RNI_NID4, 0x35080)
    FIELD(POR_MPU_M0_PRBAR7_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR7_U_RNI_NID4, REGION7_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR7_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR7_U_RNI_NID4, REGION7_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR7_U_RNI_NID4, REGION7_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR7_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR7_U_RNI_NID4, 0x35088)
    FIELD(POR_MPU_M0_PRLAR7_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR7_U_RNI_NID4, REGION7_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR7_U_RNI_NID4, REGION7_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR8_U_RNI_NID4, 0x35090)
    FIELD(POR_MPU_M0_PRBAR8_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR8_U_RNI_NID4, REGION8_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR8_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR8_U_RNI_NID4, REGION8_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR8_U_RNI_NID4, REGION8_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR8_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR8_U_RNI_NID4, 0x35098)
    FIELD(POR_MPU_M0_PRLAR8_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR8_U_RNI_NID4, REGION8_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR8_U_RNI_NID4, REGION8_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR9_U_RNI_NID4, 0x350a0)
    FIELD(POR_MPU_M0_PRBAR9_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR9_U_RNI_NID4, REGION9_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR9_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR9_U_RNI_NID4, REGION9_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR9_U_RNI_NID4, REGION9_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR9_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR9_U_RNI_NID4, 0x350a8)
    FIELD(POR_MPU_M0_PRLAR9_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR9_U_RNI_NID4, REGION9_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR9_U_RNI_NID4, REGION9_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR10_U_RNI_NID4, 0x350b0)
    FIELD(POR_MPU_M0_PRBAR10_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR10_U_RNI_NID4, REGION10_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR10_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR10_U_RNI_NID4, REGION10_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR10_U_RNI_NID4, REGION10_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR10_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR10_U_RNI_NID4, 0x350b8)
    FIELD(POR_MPU_M0_PRLAR10_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR10_U_RNI_NID4, REGION10_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR10_U_RNI_NID4, REGION10_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR11_U_RNI_NID4, 0x350c0)
    FIELD(POR_MPU_M0_PRBAR11_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR11_U_RNI_NID4, REGION11_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR11_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR11_U_RNI_NID4, REGION11_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR11_U_RNI_NID4, REGION11_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR11_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR11_U_RNI_NID4, 0x350c8)
    FIELD(POR_MPU_M0_PRLAR11_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR11_U_RNI_NID4, REGION11_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR11_U_RNI_NID4, REGION11_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR12_U_RNI_NID4, 0x350d0)
    FIELD(POR_MPU_M0_PRBAR12_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR12_U_RNI_NID4, REGION12_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR12_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR12_U_RNI_NID4, REGION12_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR12_U_RNI_NID4, REGION12_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR12_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR12_U_RNI_NID4, 0x350d8)
    FIELD(POR_MPU_M0_PRLAR12_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR12_U_RNI_NID4, REGION12_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR12_U_RNI_NID4, REGION12_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR13_U_RNI_NID4, 0x350e0)
    FIELD(POR_MPU_M0_PRBAR13_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR13_U_RNI_NID4, REGION13_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR13_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR13_U_RNI_NID4, REGION13_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR13_U_RNI_NID4, REGION13_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR13_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR13_U_RNI_NID4, 0x350e8)
    FIELD(POR_MPU_M0_PRLAR13_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR13_U_RNI_NID4, REGION13_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR13_U_RNI_NID4, REGION13_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR14_U_RNI_NID4, 0x350f0)
    FIELD(POR_MPU_M0_PRBAR14_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR14_U_RNI_NID4, REGION14_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR14_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR14_U_RNI_NID4, REGION14_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR14_U_RNI_NID4, REGION14_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR14_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR14_U_RNI_NID4, 0x350f8)
    FIELD(POR_MPU_M0_PRLAR14_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR14_U_RNI_NID4, REGION14_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR14_U_RNI_NID4, REGION14_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR15_U_RNI_NID4, 0x35100)
    FIELD(POR_MPU_M0_PRBAR15_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR15_U_RNI_NID4, REGION15_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR15_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR15_U_RNI_NID4, REGION15_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR15_U_RNI_NID4, REGION15_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR15_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR15_U_RNI_NID4, 0x35108)
    FIELD(POR_MPU_M0_PRLAR15_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR15_U_RNI_NID4, REGION15_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR15_U_RNI_NID4, REGION15_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR16_U_RNI_NID4, 0x35110)
    FIELD(POR_MPU_M0_PRBAR16_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR16_U_RNI_NID4, REGION16_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR16_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR16_U_RNI_NID4, REGION16_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR16_U_RNI_NID4, REGION16_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR16_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR16_U_RNI_NID4, 0x35118)
    FIELD(POR_MPU_M0_PRLAR16_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR16_U_RNI_NID4, REGION16_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR16_U_RNI_NID4, REGION16_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR17_U_RNI_NID4, 0x35120)
    FIELD(POR_MPU_M0_PRBAR17_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR17_U_RNI_NID4, REGION17_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR17_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR17_U_RNI_NID4, REGION17_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR17_U_RNI_NID4, REGION17_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR17_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR17_U_RNI_NID4, 0x35128)
    FIELD(POR_MPU_M0_PRLAR17_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR17_U_RNI_NID4, REGION17_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR17_U_RNI_NID4, REGION17_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR18_U_RNI_NID4, 0x35130)
    FIELD(POR_MPU_M0_PRBAR18_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR18_U_RNI_NID4, REGION18_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR18_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR18_U_RNI_NID4, REGION18_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR18_U_RNI_NID4, REGION18_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR18_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR18_U_RNI_NID4, 0x35138)
    FIELD(POR_MPU_M0_PRLAR18_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR18_U_RNI_NID4, REGION18_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR18_U_RNI_NID4, REGION18_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR19_U_RNI_NID4, 0x35140)
    FIELD(POR_MPU_M0_PRBAR19_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR19_U_RNI_NID4, REGION19_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR19_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR19_U_RNI_NID4, REGION19_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR19_U_RNI_NID4, REGION19_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR19_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR19_U_RNI_NID4, 0x35148)
    FIELD(POR_MPU_M0_PRLAR19_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR19_U_RNI_NID4, REGION19_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR19_U_RNI_NID4, REGION19_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR20_U_RNI_NID4, 0x35150)
    FIELD(POR_MPU_M0_PRBAR20_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR20_U_RNI_NID4, REGION20_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR20_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR20_U_RNI_NID4, REGION20_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR20_U_RNI_NID4, REGION20_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR20_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR20_U_RNI_NID4, 0x35158)
    FIELD(POR_MPU_M0_PRLAR20_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR20_U_RNI_NID4, REGION20_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR20_U_RNI_NID4, REGION20_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR21_U_RNI_NID4, 0x35160)
    FIELD(POR_MPU_M0_PRBAR21_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR21_U_RNI_NID4, REGION21_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR21_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR21_U_RNI_NID4, REGION21_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR21_U_RNI_NID4, REGION21_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR21_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR21_U_RNI_NID4, 0x35168)
    FIELD(POR_MPU_M0_PRLAR21_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR21_U_RNI_NID4, REGION21_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR21_U_RNI_NID4, REGION21_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR22_U_RNI_NID4, 0x35170)
    FIELD(POR_MPU_M0_PRBAR22_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR22_U_RNI_NID4, REGION22_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR22_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR22_U_RNI_NID4, REGION22_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR22_U_RNI_NID4, REGION22_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR22_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR22_U_RNI_NID4, 0x35178)
    FIELD(POR_MPU_M0_PRLAR22_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR22_U_RNI_NID4, REGION22_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR22_U_RNI_NID4, REGION22_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR23_U_RNI_NID4, 0x35180)
    FIELD(POR_MPU_M0_PRBAR23_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR23_U_RNI_NID4, REGION23_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR23_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR23_U_RNI_NID4, REGION23_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR23_U_RNI_NID4, REGION23_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR23_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR23_U_RNI_NID4, 0x35188)
    FIELD(POR_MPU_M0_PRLAR23_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR23_U_RNI_NID4, REGION23_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR23_U_RNI_NID4, REGION23_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR24_U_RNI_NID4, 0x35190)
    FIELD(POR_MPU_M0_PRBAR24_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR24_U_RNI_NID4, REGION24_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR24_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR24_U_RNI_NID4, REGION24_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR24_U_RNI_NID4, REGION24_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR24_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR24_U_RNI_NID4, 0x35198)
    FIELD(POR_MPU_M0_PRLAR24_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR24_U_RNI_NID4, REGION24_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR24_U_RNI_NID4, REGION24_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR25_U_RNI_NID4, 0x351a0)
    FIELD(POR_MPU_M0_PRBAR25_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR25_U_RNI_NID4, REGION25_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR25_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR25_U_RNI_NID4, REGION25_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR25_U_RNI_NID4, REGION25_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR25_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR25_U_RNI_NID4, 0x351a8)
    FIELD(POR_MPU_M0_PRLAR25_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR25_U_RNI_NID4, REGION25_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR25_U_RNI_NID4, REGION25_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR26_U_RNI_NID4, 0x351b0)
    FIELD(POR_MPU_M0_PRBAR26_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR26_U_RNI_NID4, REGION26_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR26_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR26_U_RNI_NID4, REGION26_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR26_U_RNI_NID4, REGION26_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR26_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR26_U_RNI_NID4, 0x351b8)
    FIELD(POR_MPU_M0_PRLAR26_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR26_U_RNI_NID4, REGION26_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR26_U_RNI_NID4, REGION26_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR27_U_RNI_NID4, 0x351c0)
    FIELD(POR_MPU_M0_PRBAR27_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR27_U_RNI_NID4, REGION27_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR27_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR27_U_RNI_NID4, REGION27_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR27_U_RNI_NID4, REGION27_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR27_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR27_U_RNI_NID4, 0x351c8)
    FIELD(POR_MPU_M0_PRLAR27_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR27_U_RNI_NID4, REGION27_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR27_U_RNI_NID4, REGION27_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR28_U_RNI_NID4, 0x351d0)
    FIELD(POR_MPU_M0_PRBAR28_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR28_U_RNI_NID4, REGION28_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR28_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR28_U_RNI_NID4, REGION28_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR28_U_RNI_NID4, REGION28_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR28_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR28_U_RNI_NID4, 0x351d8)
    FIELD(POR_MPU_M0_PRLAR28_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR28_U_RNI_NID4, REGION28_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR28_U_RNI_NID4, REGION28_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR29_U_RNI_NID4, 0x351e0)
    FIELD(POR_MPU_M0_PRBAR29_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR29_U_RNI_NID4, REGION29_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR29_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR29_U_RNI_NID4, REGION29_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR29_U_RNI_NID4, REGION29_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR29_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR29_U_RNI_NID4, 0x351e8)
    FIELD(POR_MPU_M0_PRLAR29_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR29_U_RNI_NID4, REGION29_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR29_U_RNI_NID4, REGION29_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR30_U_RNI_NID4, 0x351f0)
    FIELD(POR_MPU_M0_PRBAR30_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR30_U_RNI_NID4, REGION30_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR30_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR30_U_RNI_NID4, REGION30_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR30_U_RNI_NID4, REGION30_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR30_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR30_U_RNI_NID4, 0x351f8)
    FIELD(POR_MPU_M0_PRLAR30_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR30_U_RNI_NID4, REGION30_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR30_U_RNI_NID4, REGION30_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR31_U_RNI_NID4, 0x35200)
    FIELD(POR_MPU_M0_PRBAR31_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR31_U_RNI_NID4, REGION31_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR31_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR31_U_RNI_NID4, REGION31_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR31_U_RNI_NID4, REGION31_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR31_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR31_U_RNI_NID4, 0x35208)
    FIELD(POR_MPU_M0_PRLAR31_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR31_U_RNI_NID4, REGION31_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR31_U_RNI_NID4, REGION31_EN, 0, 1)
REG32(POR_MPU_M1_CTL_U_RNI_NID4, 0x35400)
    FIELD(POR_MPU_M1_CTL_U_RNI_NID4, M1_EN, 2, 1)
    FIELD(POR_MPU_M1_CTL_U_RNI_NID4, M1_ACTION, 0, 2)
REG32(POR_MPU_M1_PRBAR0_U_RNI_NID4, 0x35410)
    FIELD(POR_MPU_M1_PRBAR0_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR0_U_RNI_NID4, REGION0_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR0_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR0_U_RNI_NID4, REGION0_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR0_U_RNI_NID4, REGION0_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR0_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR0_U_RNI_NID4, 0x35418)
    FIELD(POR_MPU_M1_PRLAR0_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR0_U_RNI_NID4, REGION0_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR0_U_RNI_NID4, REGION0_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR1_U_RNI_NID4, 0x35420)
    FIELD(POR_MPU_M1_PRBAR1_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR1_U_RNI_NID4, REGION1_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR1_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR1_U_RNI_NID4, REGION1_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR1_U_RNI_NID4, REGION1_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR1_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR1_U_RNI_NID4, 0x35428)
    FIELD(POR_MPU_M1_PRLAR1_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR1_U_RNI_NID4, REGION1_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR1_U_RNI_NID4, REGION1_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR2_U_RNI_NID4, 0x35430)
    FIELD(POR_MPU_M1_PRBAR2_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR2_U_RNI_NID4, REGION2_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR2_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR2_U_RNI_NID4, REGION2_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR2_U_RNI_NID4, REGION2_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR2_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR2_U_RNI_NID4, 0x35438)
    FIELD(POR_MPU_M1_PRLAR2_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR2_U_RNI_NID4, REGION2_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR2_U_RNI_NID4, REGION2_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR3_U_RNI_NID4, 0x35440)
    FIELD(POR_MPU_M1_PRBAR3_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR3_U_RNI_NID4, REGION3_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR3_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR3_U_RNI_NID4, REGION3_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR3_U_RNI_NID4, REGION3_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR3_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR3_U_RNI_NID4, 0x35448)
    FIELD(POR_MPU_M1_PRLAR3_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR3_U_RNI_NID4, REGION3_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR3_U_RNI_NID4, REGION3_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR4_U_RNI_NID4, 0x35450)
    FIELD(POR_MPU_M1_PRBAR4_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR4_U_RNI_NID4, REGION4_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR4_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR4_U_RNI_NID4, REGION4_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR4_U_RNI_NID4, REGION4_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR4_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR4_U_RNI_NID4, 0x35458)
    FIELD(POR_MPU_M1_PRLAR4_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR4_U_RNI_NID4, REGION4_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR4_U_RNI_NID4, REGION4_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR5_U_RNI_NID4, 0x35460)
    FIELD(POR_MPU_M1_PRBAR5_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR5_U_RNI_NID4, REGION5_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR5_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR5_U_RNI_NID4, REGION5_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR5_U_RNI_NID4, REGION5_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR5_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR5_U_RNI_NID4, 0x35468)
    FIELD(POR_MPU_M1_PRLAR5_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR5_U_RNI_NID4, REGION5_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR5_U_RNI_NID4, REGION5_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR6_U_RNI_NID4, 0x35470)
    FIELD(POR_MPU_M1_PRBAR6_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR6_U_RNI_NID4, REGION6_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR6_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR6_U_RNI_NID4, REGION6_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR6_U_RNI_NID4, REGION6_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR6_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR6_U_RNI_NID4, 0x35478)
    FIELD(POR_MPU_M1_PRLAR6_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR6_U_RNI_NID4, REGION6_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR6_U_RNI_NID4, REGION6_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR7_U_RNI_NID4, 0x35480)
    FIELD(POR_MPU_M1_PRBAR7_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR7_U_RNI_NID4, REGION7_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR7_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR7_U_RNI_NID4, REGION7_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR7_U_RNI_NID4, REGION7_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR7_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR7_U_RNI_NID4, 0x35488)
    FIELD(POR_MPU_M1_PRLAR7_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR7_U_RNI_NID4, REGION7_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR7_U_RNI_NID4, REGION7_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR8_U_RNI_NID4, 0x35490)
    FIELD(POR_MPU_M1_PRBAR8_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR8_U_RNI_NID4, REGION8_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR8_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR8_U_RNI_NID4, REGION8_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR8_U_RNI_NID4, REGION8_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR8_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR8_U_RNI_NID4, 0x35498)
    FIELD(POR_MPU_M1_PRLAR8_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR8_U_RNI_NID4, REGION8_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR8_U_RNI_NID4, REGION8_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR9_U_RNI_NID4, 0x354a0)
    FIELD(POR_MPU_M1_PRBAR9_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR9_U_RNI_NID4, REGION9_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR9_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR9_U_RNI_NID4, REGION9_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR9_U_RNI_NID4, REGION9_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR9_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR9_U_RNI_NID4, 0x354a8)
    FIELD(POR_MPU_M1_PRLAR9_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR9_U_RNI_NID4, REGION9_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR9_U_RNI_NID4, REGION9_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR10_U_RNI_NID4, 0x354b0)
    FIELD(POR_MPU_M1_PRBAR10_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR10_U_RNI_NID4, REGION10_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR10_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR10_U_RNI_NID4, REGION10_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR10_U_RNI_NID4, REGION10_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR10_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR10_U_RNI_NID4, 0x354b8)
    FIELD(POR_MPU_M1_PRLAR10_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR10_U_RNI_NID4, REGION10_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR10_U_RNI_NID4, REGION10_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR11_U_RNI_NID4, 0x354c0)
    FIELD(POR_MPU_M1_PRBAR11_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR11_U_RNI_NID4, REGION11_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR11_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR11_U_RNI_NID4, REGION11_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR11_U_RNI_NID4, REGION11_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR11_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR11_U_RNI_NID4, 0x354c8)
    FIELD(POR_MPU_M1_PRLAR11_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR11_U_RNI_NID4, REGION11_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR11_U_RNI_NID4, REGION11_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR12_U_RNI_NID4, 0x354d0)
    FIELD(POR_MPU_M1_PRBAR12_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR12_U_RNI_NID4, REGION12_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR12_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR12_U_RNI_NID4, REGION12_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR12_U_RNI_NID4, REGION12_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR12_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR12_U_RNI_NID4, 0x354d8)
    FIELD(POR_MPU_M1_PRLAR12_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR12_U_RNI_NID4, REGION12_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR12_U_RNI_NID4, REGION12_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR13_U_RNI_NID4, 0x354e0)
    FIELD(POR_MPU_M1_PRBAR13_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR13_U_RNI_NID4, REGION13_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR13_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR13_U_RNI_NID4, REGION13_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR13_U_RNI_NID4, REGION13_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR13_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR13_U_RNI_NID4, 0x354e8)
    FIELD(POR_MPU_M1_PRLAR13_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR13_U_RNI_NID4, REGION13_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR13_U_RNI_NID4, REGION13_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR14_U_RNI_NID4, 0x354f0)
    FIELD(POR_MPU_M1_PRBAR14_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR14_U_RNI_NID4, REGION14_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR14_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR14_U_RNI_NID4, REGION14_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR14_U_RNI_NID4, REGION14_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR14_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR14_U_RNI_NID4, 0x354f8)
    FIELD(POR_MPU_M1_PRLAR14_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR14_U_RNI_NID4, REGION14_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR14_U_RNI_NID4, REGION14_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR15_U_RNI_NID4, 0x35500)
    FIELD(POR_MPU_M1_PRBAR15_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR15_U_RNI_NID4, REGION15_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR15_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR15_U_RNI_NID4, REGION15_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR15_U_RNI_NID4, REGION15_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR15_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR15_U_RNI_NID4, 0x35508)
    FIELD(POR_MPU_M1_PRLAR15_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR15_U_RNI_NID4, REGION15_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR15_U_RNI_NID4, REGION15_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR16_U_RNI_NID4, 0x35510)
    FIELD(POR_MPU_M1_PRBAR16_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR16_U_RNI_NID4, REGION16_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR16_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR16_U_RNI_NID4, REGION16_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR16_U_RNI_NID4, REGION16_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR16_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR16_U_RNI_NID4, 0x35518)
    FIELD(POR_MPU_M1_PRLAR16_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR16_U_RNI_NID4, REGION16_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR16_U_RNI_NID4, REGION16_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR17_U_RNI_NID4, 0x35520)
    FIELD(POR_MPU_M1_PRBAR17_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR17_U_RNI_NID4, REGION17_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR17_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR17_U_RNI_NID4, REGION17_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR17_U_RNI_NID4, REGION17_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR17_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR17_U_RNI_NID4, 0x35528)
    FIELD(POR_MPU_M1_PRLAR17_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR17_U_RNI_NID4, REGION17_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR17_U_RNI_NID4, REGION17_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR18_U_RNI_NID4, 0x35530)
    FIELD(POR_MPU_M1_PRBAR18_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR18_U_RNI_NID4, REGION18_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR18_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR18_U_RNI_NID4, REGION18_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR18_U_RNI_NID4, REGION18_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR18_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR18_U_RNI_NID4, 0x35538)
    FIELD(POR_MPU_M1_PRLAR18_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR18_U_RNI_NID4, REGION18_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR18_U_RNI_NID4, REGION18_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR19_U_RNI_NID4, 0x35540)
    FIELD(POR_MPU_M1_PRBAR19_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR19_U_RNI_NID4, REGION19_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR19_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR19_U_RNI_NID4, REGION19_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR19_U_RNI_NID4, REGION19_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR19_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR19_U_RNI_NID4, 0x35548)
    FIELD(POR_MPU_M1_PRLAR19_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR19_U_RNI_NID4, REGION19_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR19_U_RNI_NID4, REGION19_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR20_U_RNI_NID4, 0x35550)
    FIELD(POR_MPU_M1_PRBAR20_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR20_U_RNI_NID4, REGION20_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR20_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR20_U_RNI_NID4, REGION20_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR20_U_RNI_NID4, REGION20_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR20_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR20_U_RNI_NID4, 0x35558)
    FIELD(POR_MPU_M1_PRLAR20_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR20_U_RNI_NID4, REGION20_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR20_U_RNI_NID4, REGION20_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR21_U_RNI_NID4, 0x35560)
    FIELD(POR_MPU_M1_PRBAR21_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR21_U_RNI_NID4, REGION21_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR21_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR21_U_RNI_NID4, REGION21_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR21_U_RNI_NID4, REGION21_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR21_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR21_U_RNI_NID4, 0x35568)
    FIELD(POR_MPU_M1_PRLAR21_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR21_U_RNI_NID4, REGION21_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR21_U_RNI_NID4, REGION21_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR22_U_RNI_NID4, 0x35570)
    FIELD(POR_MPU_M1_PRBAR22_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR22_U_RNI_NID4, REGION22_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR22_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR22_U_RNI_NID4, REGION22_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR22_U_RNI_NID4, REGION22_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR22_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR22_U_RNI_NID4, 0x35578)
    FIELD(POR_MPU_M1_PRLAR22_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR22_U_RNI_NID4, REGION22_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR22_U_RNI_NID4, REGION22_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR23_U_RNI_NID4, 0x35580)
    FIELD(POR_MPU_M1_PRBAR23_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR23_U_RNI_NID4, REGION23_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR23_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR23_U_RNI_NID4, REGION23_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR23_U_RNI_NID4, REGION23_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR23_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR23_U_RNI_NID4, 0x35588)
    FIELD(POR_MPU_M1_PRLAR23_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR23_U_RNI_NID4, REGION23_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR23_U_RNI_NID4, REGION23_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR24_U_RNI_NID4, 0x35590)
    FIELD(POR_MPU_M1_PRBAR24_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR24_U_RNI_NID4, REGION24_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR24_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR24_U_RNI_NID4, REGION24_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR24_U_RNI_NID4, REGION24_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR24_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR24_U_RNI_NID4, 0x35598)
    FIELD(POR_MPU_M1_PRLAR24_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR24_U_RNI_NID4, REGION24_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR24_U_RNI_NID4, REGION24_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR25_U_RNI_NID4, 0x355a0)
    FIELD(POR_MPU_M1_PRBAR25_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR25_U_RNI_NID4, REGION25_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR25_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR25_U_RNI_NID4, REGION25_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR25_U_RNI_NID4, REGION25_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR25_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR25_U_RNI_NID4, 0x355a8)
    FIELD(POR_MPU_M1_PRLAR25_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR25_U_RNI_NID4, REGION25_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR25_U_RNI_NID4, REGION25_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR26_U_RNI_NID4, 0x355b0)
    FIELD(POR_MPU_M1_PRBAR26_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR26_U_RNI_NID4, REGION26_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR26_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR26_U_RNI_NID4, REGION26_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR26_U_RNI_NID4, REGION26_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR26_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR26_U_RNI_NID4, 0x355b8)
    FIELD(POR_MPU_M1_PRLAR26_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR26_U_RNI_NID4, REGION26_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR26_U_RNI_NID4, REGION26_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR27_U_RNI_NID4, 0x355c0)
    FIELD(POR_MPU_M1_PRBAR27_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR27_U_RNI_NID4, REGION27_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR27_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR27_U_RNI_NID4, REGION27_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR27_U_RNI_NID4, REGION27_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR27_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR27_U_RNI_NID4, 0x355c8)
    FIELD(POR_MPU_M1_PRLAR27_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR27_U_RNI_NID4, REGION27_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR27_U_RNI_NID4, REGION27_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR28_U_RNI_NID4, 0x355d0)
    FIELD(POR_MPU_M1_PRBAR28_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR28_U_RNI_NID4, REGION28_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR28_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR28_U_RNI_NID4, REGION28_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR28_U_RNI_NID4, REGION28_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR28_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR28_U_RNI_NID4, 0x355d8)
    FIELD(POR_MPU_M1_PRLAR28_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR28_U_RNI_NID4, REGION28_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR28_U_RNI_NID4, REGION28_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR29_U_RNI_NID4, 0x355e0)
    FIELD(POR_MPU_M1_PRBAR29_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR29_U_RNI_NID4, REGION29_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR29_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR29_U_RNI_NID4, REGION29_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR29_U_RNI_NID4, REGION29_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR29_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR29_U_RNI_NID4, 0x355e8)
    FIELD(POR_MPU_M1_PRLAR29_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR29_U_RNI_NID4, REGION29_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR29_U_RNI_NID4, REGION29_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR30_U_RNI_NID4, 0x355f0)
    FIELD(POR_MPU_M1_PRBAR30_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR30_U_RNI_NID4, REGION30_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR30_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR30_U_RNI_NID4, REGION30_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR30_U_RNI_NID4, REGION30_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR30_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR30_U_RNI_NID4, 0x355f8)
    FIELD(POR_MPU_M1_PRLAR30_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR30_U_RNI_NID4, REGION30_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR30_U_RNI_NID4, REGION30_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR31_U_RNI_NID4, 0x35600)
    FIELD(POR_MPU_M1_PRBAR31_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR31_U_RNI_NID4, REGION31_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR31_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR31_U_RNI_NID4, REGION31_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR31_U_RNI_NID4, REGION31_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR31_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR31_U_RNI_NID4, 0x35608)
    FIELD(POR_MPU_M1_PRLAR31_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR31_U_RNI_NID4, REGION31_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR31_U_RNI_NID4, REGION31_EN, 0, 1)
REG32(POR_MPU_M2_CTL_U_RNI_NID4, 0x35800)
    FIELD(POR_MPU_M2_CTL_U_RNI_NID4, M2_EN, 2, 1)
    FIELD(POR_MPU_M2_CTL_U_RNI_NID4, M2_ACTION, 0, 2)
REG32(POR_MPU_M2_PRBAR0_U_RNI_NID4, 0x35810)
    FIELD(POR_MPU_M2_PRBAR0_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR0_U_RNI_NID4, REGION0_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR0_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR0_U_RNI_NID4, REGION0_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR0_U_RNI_NID4, REGION0_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR0_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR0_U_RNI_NID4, 0x35818)
    FIELD(POR_MPU_M2_PRLAR0_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR0_U_RNI_NID4, REGION0_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR0_U_RNI_NID4, REGION0_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR1_U_RNI_NID4, 0x35820)
    FIELD(POR_MPU_M2_PRBAR1_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR1_U_RNI_NID4, REGION1_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR1_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR1_U_RNI_NID4, REGION1_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR1_U_RNI_NID4, REGION1_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR1_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR1_U_RNI_NID4, 0x35828)
    FIELD(POR_MPU_M2_PRLAR1_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR1_U_RNI_NID4, REGION1_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR1_U_RNI_NID4, REGION1_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR2_U_RNI_NID4, 0x35830)
    FIELD(POR_MPU_M2_PRBAR2_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR2_U_RNI_NID4, REGION2_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR2_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR2_U_RNI_NID4, REGION2_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR2_U_RNI_NID4, REGION2_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR2_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR2_U_RNI_NID4, 0x35838)
    FIELD(POR_MPU_M2_PRLAR2_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR2_U_RNI_NID4, REGION2_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR2_U_RNI_NID4, REGION2_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR3_U_RNI_NID4, 0x35840)
    FIELD(POR_MPU_M2_PRBAR3_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR3_U_RNI_NID4, REGION3_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR3_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR3_U_RNI_NID4, REGION3_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR3_U_RNI_NID4, REGION3_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR3_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR3_U_RNI_NID4, 0x35848)
    FIELD(POR_MPU_M2_PRLAR3_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR3_U_RNI_NID4, REGION3_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR3_U_RNI_NID4, REGION3_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR4_U_RNI_NID4, 0x35850)
    FIELD(POR_MPU_M2_PRBAR4_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR4_U_RNI_NID4, REGION4_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR4_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR4_U_RNI_NID4, REGION4_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR4_U_RNI_NID4, REGION4_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR4_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR4_U_RNI_NID4, 0x35858)
    FIELD(POR_MPU_M2_PRLAR4_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR4_U_RNI_NID4, REGION4_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR4_U_RNI_NID4, REGION4_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR5_U_RNI_NID4, 0x35860)
    FIELD(POR_MPU_M2_PRBAR5_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR5_U_RNI_NID4, REGION5_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR5_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR5_U_RNI_NID4, REGION5_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR5_U_RNI_NID4, REGION5_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR5_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR5_U_RNI_NID4, 0x35868)
    FIELD(POR_MPU_M2_PRLAR5_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR5_U_RNI_NID4, REGION5_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR5_U_RNI_NID4, REGION5_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR6_U_RNI_NID4, 0x35870)
    FIELD(POR_MPU_M2_PRBAR6_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR6_U_RNI_NID4, REGION6_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR6_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR6_U_RNI_NID4, REGION6_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR6_U_RNI_NID4, REGION6_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR6_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR6_U_RNI_NID4, 0x35878)
    FIELD(POR_MPU_M2_PRLAR6_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR6_U_RNI_NID4, REGION6_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR6_U_RNI_NID4, REGION6_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR7_U_RNI_NID4, 0x35880)
    FIELD(POR_MPU_M2_PRBAR7_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR7_U_RNI_NID4, REGION7_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR7_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR7_U_RNI_NID4, REGION7_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR7_U_RNI_NID4, REGION7_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR7_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR7_U_RNI_NID4, 0x35888)
    FIELD(POR_MPU_M2_PRLAR7_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR7_U_RNI_NID4, REGION7_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR7_U_RNI_NID4, REGION7_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR8_U_RNI_NID4, 0x35890)
    FIELD(POR_MPU_M2_PRBAR8_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR8_U_RNI_NID4, REGION8_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR8_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR8_U_RNI_NID4, REGION8_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR8_U_RNI_NID4, REGION8_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR8_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR8_U_RNI_NID4, 0x35898)
    FIELD(POR_MPU_M2_PRLAR8_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR8_U_RNI_NID4, REGION8_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR8_U_RNI_NID4, REGION8_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR9_U_RNI_NID4, 0x358a0)
    FIELD(POR_MPU_M2_PRBAR9_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR9_U_RNI_NID4, REGION9_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR9_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR9_U_RNI_NID4, REGION9_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR9_U_RNI_NID4, REGION9_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR9_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR9_U_RNI_NID4, 0x358a8)
    FIELD(POR_MPU_M2_PRLAR9_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR9_U_RNI_NID4, REGION9_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR9_U_RNI_NID4, REGION9_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR10_U_RNI_NID4, 0x358b0)
    FIELD(POR_MPU_M2_PRBAR10_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR10_U_RNI_NID4, REGION10_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR10_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR10_U_RNI_NID4, REGION10_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR10_U_RNI_NID4, REGION10_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR10_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR10_U_RNI_NID4, 0x358b8)
    FIELD(POR_MPU_M2_PRLAR10_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR10_U_RNI_NID4, REGION10_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR10_U_RNI_NID4, REGION10_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR11_U_RNI_NID4, 0x358c0)
    FIELD(POR_MPU_M2_PRBAR11_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR11_U_RNI_NID4, REGION11_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR11_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR11_U_RNI_NID4, REGION11_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR11_U_RNI_NID4, REGION11_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR11_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR11_U_RNI_NID4, 0x358c8)
    FIELD(POR_MPU_M2_PRLAR11_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR11_U_RNI_NID4, REGION11_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR11_U_RNI_NID4, REGION11_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR12_U_RNI_NID4, 0x358d0)
    FIELD(POR_MPU_M2_PRBAR12_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR12_U_RNI_NID4, REGION12_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR12_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR12_U_RNI_NID4, REGION12_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR12_U_RNI_NID4, REGION12_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR12_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR12_U_RNI_NID4, 0x358d8)
    FIELD(POR_MPU_M2_PRLAR12_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR12_U_RNI_NID4, REGION12_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR12_U_RNI_NID4, REGION12_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR13_U_RNI_NID4, 0x358e0)
    FIELD(POR_MPU_M2_PRBAR13_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR13_U_RNI_NID4, REGION13_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR13_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR13_U_RNI_NID4, REGION13_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR13_U_RNI_NID4, REGION13_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR13_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR13_U_RNI_NID4, 0x358e8)
    FIELD(POR_MPU_M2_PRLAR13_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR13_U_RNI_NID4, REGION13_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR13_U_RNI_NID4, REGION13_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR14_U_RNI_NID4, 0x358f0)
    FIELD(POR_MPU_M2_PRBAR14_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR14_U_RNI_NID4, REGION14_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR14_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR14_U_RNI_NID4, REGION14_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR14_U_RNI_NID4, REGION14_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR14_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR14_U_RNI_NID4, 0x358f8)
    FIELD(POR_MPU_M2_PRLAR14_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR14_U_RNI_NID4, REGION14_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR14_U_RNI_NID4, REGION14_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR15_U_RNI_NID4, 0x35900)
    FIELD(POR_MPU_M2_PRBAR15_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR15_U_RNI_NID4, REGION15_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR15_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR15_U_RNI_NID4, REGION15_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR15_U_RNI_NID4, REGION15_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR15_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR15_U_RNI_NID4, 0x35908)
    FIELD(POR_MPU_M2_PRLAR15_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR15_U_RNI_NID4, REGION15_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR15_U_RNI_NID4, REGION15_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR16_U_RNI_NID4, 0x35910)
    FIELD(POR_MPU_M2_PRBAR16_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR16_U_RNI_NID4, REGION16_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR16_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR16_U_RNI_NID4, REGION16_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR16_U_RNI_NID4, REGION16_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR16_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR16_U_RNI_NID4, 0x35918)
    FIELD(POR_MPU_M2_PRLAR16_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR16_U_RNI_NID4, REGION16_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR16_U_RNI_NID4, REGION16_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR17_U_RNI_NID4, 0x35920)
    FIELD(POR_MPU_M2_PRBAR17_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR17_U_RNI_NID4, REGION17_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR17_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR17_U_RNI_NID4, REGION17_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR17_U_RNI_NID4, REGION17_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR17_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR17_U_RNI_NID4, 0x35928)
    FIELD(POR_MPU_M2_PRLAR17_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR17_U_RNI_NID4, REGION17_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR17_U_RNI_NID4, REGION17_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR18_U_RNI_NID4, 0x35930)
    FIELD(POR_MPU_M2_PRBAR18_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR18_U_RNI_NID4, REGION18_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR18_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR18_U_RNI_NID4, REGION18_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR18_U_RNI_NID4, REGION18_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR18_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR18_U_RNI_NID4, 0x35938)
    FIELD(POR_MPU_M2_PRLAR18_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR18_U_RNI_NID4, REGION18_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR18_U_RNI_NID4, REGION18_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR19_U_RNI_NID4, 0x35940)
    FIELD(POR_MPU_M2_PRBAR19_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR19_U_RNI_NID4, REGION19_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR19_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR19_U_RNI_NID4, REGION19_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR19_U_RNI_NID4, REGION19_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR19_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR19_U_RNI_NID4, 0x35948)
    FIELD(POR_MPU_M2_PRLAR19_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR19_U_RNI_NID4, REGION19_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR19_U_RNI_NID4, REGION19_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR20_U_RNI_NID4, 0x35950)
    FIELD(POR_MPU_M2_PRBAR20_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR20_U_RNI_NID4, REGION20_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR20_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR20_U_RNI_NID4, REGION20_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR20_U_RNI_NID4, REGION20_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR20_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR20_U_RNI_NID4, 0x35958)
    FIELD(POR_MPU_M2_PRLAR20_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR20_U_RNI_NID4, REGION20_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR20_U_RNI_NID4, REGION20_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR21_U_RNI_NID4, 0x35960)
    FIELD(POR_MPU_M2_PRBAR21_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR21_U_RNI_NID4, REGION21_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR21_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR21_U_RNI_NID4, REGION21_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR21_U_RNI_NID4, REGION21_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR21_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR21_U_RNI_NID4, 0x35968)
    FIELD(POR_MPU_M2_PRLAR21_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR21_U_RNI_NID4, REGION21_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR21_U_RNI_NID4, REGION21_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR22_U_RNI_NID4, 0x35970)
    FIELD(POR_MPU_M2_PRBAR22_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR22_U_RNI_NID4, REGION22_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR22_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR22_U_RNI_NID4, REGION22_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR22_U_RNI_NID4, REGION22_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR22_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR22_U_RNI_NID4, 0x35978)
    FIELD(POR_MPU_M2_PRLAR22_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR22_U_RNI_NID4, REGION22_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR22_U_RNI_NID4, REGION22_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR23_U_RNI_NID4, 0x35980)
    FIELD(POR_MPU_M2_PRBAR23_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR23_U_RNI_NID4, REGION23_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR23_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR23_U_RNI_NID4, REGION23_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR23_U_RNI_NID4, REGION23_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR23_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR23_U_RNI_NID4, 0x35988)
    FIELD(POR_MPU_M2_PRLAR23_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR23_U_RNI_NID4, REGION23_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR23_U_RNI_NID4, REGION23_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR24_U_RNI_NID4, 0x35990)
    FIELD(POR_MPU_M2_PRBAR24_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR24_U_RNI_NID4, REGION24_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR24_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR24_U_RNI_NID4, REGION24_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR24_U_RNI_NID4, REGION24_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR24_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR24_U_RNI_NID4, 0x35998)
    FIELD(POR_MPU_M2_PRLAR24_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR24_U_RNI_NID4, REGION24_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR24_U_RNI_NID4, REGION24_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR25_U_RNI_NID4, 0x359a0)
    FIELD(POR_MPU_M2_PRBAR25_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR25_U_RNI_NID4, REGION25_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR25_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR25_U_RNI_NID4, REGION25_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR25_U_RNI_NID4, REGION25_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR25_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR25_U_RNI_NID4, 0x359a8)
    FIELD(POR_MPU_M2_PRLAR25_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR25_U_RNI_NID4, REGION25_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR25_U_RNI_NID4, REGION25_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR26_U_RNI_NID4, 0x359b0)
    FIELD(POR_MPU_M2_PRBAR26_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR26_U_RNI_NID4, REGION26_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR26_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR26_U_RNI_NID4, REGION26_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR26_U_RNI_NID4, REGION26_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR26_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR26_U_RNI_NID4, 0x359b8)
    FIELD(POR_MPU_M2_PRLAR26_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR26_U_RNI_NID4, REGION26_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR26_U_RNI_NID4, REGION26_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR27_U_RNI_NID4, 0x359c0)
    FIELD(POR_MPU_M2_PRBAR27_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR27_U_RNI_NID4, REGION27_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR27_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR27_U_RNI_NID4, REGION27_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR27_U_RNI_NID4, REGION27_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR27_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR27_U_RNI_NID4, 0x359c8)
    FIELD(POR_MPU_M2_PRLAR27_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR27_U_RNI_NID4, REGION27_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR27_U_RNI_NID4, REGION27_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR28_U_RNI_NID4, 0x359d0)
    FIELD(POR_MPU_M2_PRBAR28_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR28_U_RNI_NID4, REGION28_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR28_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR28_U_RNI_NID4, REGION28_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR28_U_RNI_NID4, REGION28_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR28_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR28_U_RNI_NID4, 0x359d8)
    FIELD(POR_MPU_M2_PRLAR28_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR28_U_RNI_NID4, REGION28_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR28_U_RNI_NID4, REGION28_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR29_U_RNI_NID4, 0x359e0)
    FIELD(POR_MPU_M2_PRBAR29_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR29_U_RNI_NID4, REGION29_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR29_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR29_U_RNI_NID4, REGION29_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR29_U_RNI_NID4, REGION29_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR29_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR29_U_RNI_NID4, 0x359e8)
    FIELD(POR_MPU_M2_PRLAR29_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR29_U_RNI_NID4, REGION29_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR29_U_RNI_NID4, REGION29_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR30_U_RNI_NID4, 0x359f0)
    FIELD(POR_MPU_M2_PRBAR30_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR30_U_RNI_NID4, REGION30_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR30_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR30_U_RNI_NID4, REGION30_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR30_U_RNI_NID4, REGION30_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR30_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR30_U_RNI_NID4, 0x359f8)
    FIELD(POR_MPU_M2_PRLAR30_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR30_U_RNI_NID4, REGION30_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR30_U_RNI_NID4, REGION30_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR31_U_RNI_NID4, 0x35a00)
    FIELD(POR_MPU_M2_PRBAR31_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR31_U_RNI_NID4, REGION31_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR31_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR31_U_RNI_NID4, REGION31_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR31_U_RNI_NID4, REGION31_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR31_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR31_U_RNI_NID4, 0x35a08)
    FIELD(POR_MPU_M2_PRLAR31_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR31_U_RNI_NID4, REGION31_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR31_U_RNI_NID4, REGION31_EN, 0, 1)
REG32(POR_MPU_M3_CTL_U_RNI_NID4, 0x35c00)
    FIELD(POR_MPU_M3_CTL_U_RNI_NID4, M3_EN, 2, 1)
    FIELD(POR_MPU_M3_CTL_U_RNI_NID4, M3_ACTION, 0, 2)
REG32(POR_MPU_M3_PRBAR0_U_RNI_NID4, 0x35c10)
    FIELD(POR_MPU_M3_PRBAR0_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR0_U_RNI_NID4, REGION0_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR0_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR0_U_RNI_NID4, REGION0_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR0_U_RNI_NID4, REGION0_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR0_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR0_U_RNI_NID4, 0x35c18)
    FIELD(POR_MPU_M3_PRLAR0_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR0_U_RNI_NID4, REGION0_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR0_U_RNI_NID4, REGION0_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR1_U_RNI_NID4, 0x35c20)
    FIELD(POR_MPU_M3_PRBAR1_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR1_U_RNI_NID4, REGION1_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR1_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR1_U_RNI_NID4, REGION1_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR1_U_RNI_NID4, REGION1_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR1_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR1_U_RNI_NID4, 0x35c28)
    FIELD(POR_MPU_M3_PRLAR1_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR1_U_RNI_NID4, REGION1_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR1_U_RNI_NID4, REGION1_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR2_U_RNI_NID4, 0x35c30)
    FIELD(POR_MPU_M3_PRBAR2_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR2_U_RNI_NID4, REGION2_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR2_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR2_U_RNI_NID4, REGION2_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR2_U_RNI_NID4, REGION2_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR2_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR2_U_RNI_NID4, 0x35c38)
    FIELD(POR_MPU_M3_PRLAR2_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR2_U_RNI_NID4, REGION2_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR2_U_RNI_NID4, REGION2_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR3_U_RNI_NID4, 0x35c40)
    FIELD(POR_MPU_M3_PRBAR3_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR3_U_RNI_NID4, REGION3_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR3_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR3_U_RNI_NID4, REGION3_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR3_U_RNI_NID4, REGION3_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR3_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR3_U_RNI_NID4, 0x35c48)
    FIELD(POR_MPU_M3_PRLAR3_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR3_U_RNI_NID4, REGION3_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR3_U_RNI_NID4, REGION3_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR4_U_RNI_NID4, 0x35c50)
    FIELD(POR_MPU_M3_PRBAR4_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR4_U_RNI_NID4, REGION4_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR4_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR4_U_RNI_NID4, REGION4_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR4_U_RNI_NID4, REGION4_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR4_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR4_U_RNI_NID4, 0x35c58)
    FIELD(POR_MPU_M3_PRLAR4_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR4_U_RNI_NID4, REGION4_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR4_U_RNI_NID4, REGION4_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR5_U_RNI_NID4, 0x35c60)
    FIELD(POR_MPU_M3_PRBAR5_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR5_U_RNI_NID4, REGION5_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR5_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR5_U_RNI_NID4, REGION5_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR5_U_RNI_NID4, REGION5_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR5_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR5_U_RNI_NID4, 0x35c68)
    FIELD(POR_MPU_M3_PRLAR5_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR5_U_RNI_NID4, REGION5_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR5_U_RNI_NID4, REGION5_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR6_U_RNI_NID4, 0x35c70)
    FIELD(POR_MPU_M3_PRBAR6_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR6_U_RNI_NID4, REGION6_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR6_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR6_U_RNI_NID4, REGION6_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR6_U_RNI_NID4, REGION6_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR6_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR6_U_RNI_NID4, 0x35c78)
    FIELD(POR_MPU_M3_PRLAR6_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR6_U_RNI_NID4, REGION6_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR6_U_RNI_NID4, REGION6_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR7_U_RNI_NID4, 0x35c80)
    FIELD(POR_MPU_M3_PRBAR7_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR7_U_RNI_NID4, REGION7_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR7_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR7_U_RNI_NID4, REGION7_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR7_U_RNI_NID4, REGION7_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR7_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR7_U_RNI_NID4, 0x35c88)
    FIELD(POR_MPU_M3_PRLAR7_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR7_U_RNI_NID4, REGION7_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR7_U_RNI_NID4, REGION7_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR8_U_RNI_NID4, 0x35c90)
    FIELD(POR_MPU_M3_PRBAR8_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR8_U_RNI_NID4, REGION8_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR8_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR8_U_RNI_NID4, REGION8_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR8_U_RNI_NID4, REGION8_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR8_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR8_U_RNI_NID4, 0x35c98)
    FIELD(POR_MPU_M3_PRLAR8_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR8_U_RNI_NID4, REGION8_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR8_U_RNI_NID4, REGION8_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR9_U_RNI_NID4, 0x35ca0)
    FIELD(POR_MPU_M3_PRBAR9_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR9_U_RNI_NID4, REGION9_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR9_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR9_U_RNI_NID4, REGION9_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR9_U_RNI_NID4, REGION9_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR9_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR9_U_RNI_NID4, 0x35ca8)
    FIELD(POR_MPU_M3_PRLAR9_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR9_U_RNI_NID4, REGION9_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR9_U_RNI_NID4, REGION9_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR10_U_RNI_NID4, 0x35cb0)
    FIELD(POR_MPU_M3_PRBAR10_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR10_U_RNI_NID4, REGION10_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR10_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR10_U_RNI_NID4, REGION10_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR10_U_RNI_NID4, REGION10_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR10_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR10_U_RNI_NID4, 0x35cb8)
    FIELD(POR_MPU_M3_PRLAR10_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR10_U_RNI_NID4, REGION10_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR10_U_RNI_NID4, REGION10_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR11_U_RNI_NID4, 0x35cc0)
    FIELD(POR_MPU_M3_PRBAR11_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR11_U_RNI_NID4, REGION11_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR11_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR11_U_RNI_NID4, REGION11_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR11_U_RNI_NID4, REGION11_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR11_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR11_U_RNI_NID4, 0x35cc8)
    FIELD(POR_MPU_M3_PRLAR11_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR11_U_RNI_NID4, REGION11_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR11_U_RNI_NID4, REGION11_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR12_U_RNI_NID4, 0x35cd0)
    FIELD(POR_MPU_M3_PRBAR12_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR12_U_RNI_NID4, REGION12_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR12_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR12_U_RNI_NID4, REGION12_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR12_U_RNI_NID4, REGION12_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR12_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR12_U_RNI_NID4, 0x35cd8)
    FIELD(POR_MPU_M3_PRLAR12_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR12_U_RNI_NID4, REGION12_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR12_U_RNI_NID4, REGION12_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR13_U_RNI_NID4, 0x35ce0)
    FIELD(POR_MPU_M3_PRBAR13_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR13_U_RNI_NID4, REGION13_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR13_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR13_U_RNI_NID4, REGION13_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR13_U_RNI_NID4, REGION13_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR13_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR13_U_RNI_NID4, 0x35ce8)
    FIELD(POR_MPU_M3_PRLAR13_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR13_U_RNI_NID4, REGION13_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR13_U_RNI_NID4, REGION13_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR14_U_RNI_NID4, 0x35cf0)
    FIELD(POR_MPU_M3_PRBAR14_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR14_U_RNI_NID4, REGION14_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR14_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR14_U_RNI_NID4, REGION14_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR14_U_RNI_NID4, REGION14_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR14_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR14_U_RNI_NID4, 0x35cf8)
    FIELD(POR_MPU_M3_PRLAR14_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR14_U_RNI_NID4, REGION14_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR14_U_RNI_NID4, REGION14_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR15_U_RNI_NID4, 0x35d00)
    FIELD(POR_MPU_M3_PRBAR15_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR15_U_RNI_NID4, REGION15_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR15_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR15_U_RNI_NID4, REGION15_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR15_U_RNI_NID4, REGION15_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR15_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR15_U_RNI_NID4, 0x35d08)
    FIELD(POR_MPU_M3_PRLAR15_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR15_U_RNI_NID4, REGION15_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR15_U_RNI_NID4, REGION15_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR16_U_RNI_NID4, 0x35d10)
    FIELD(POR_MPU_M3_PRBAR16_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR16_U_RNI_NID4, REGION16_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR16_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR16_U_RNI_NID4, REGION16_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR16_U_RNI_NID4, REGION16_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR16_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR16_U_RNI_NID4, 0x35d18)
    FIELD(POR_MPU_M3_PRLAR16_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR16_U_RNI_NID4, REGION16_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR16_U_RNI_NID4, REGION16_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR17_U_RNI_NID4, 0x35d20)
    FIELD(POR_MPU_M3_PRBAR17_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR17_U_RNI_NID4, REGION17_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR17_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR17_U_RNI_NID4, REGION17_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR17_U_RNI_NID4, REGION17_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR17_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR17_U_RNI_NID4, 0x35d28)
    FIELD(POR_MPU_M3_PRLAR17_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR17_U_RNI_NID4, REGION17_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR17_U_RNI_NID4, REGION17_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR18_U_RNI_NID4, 0x35d30)
    FIELD(POR_MPU_M3_PRBAR18_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR18_U_RNI_NID4, REGION18_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR18_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR18_U_RNI_NID4, REGION18_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR18_U_RNI_NID4, REGION18_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR18_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR18_U_RNI_NID4, 0x35d38)
    FIELD(POR_MPU_M3_PRLAR18_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR18_U_RNI_NID4, REGION18_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR18_U_RNI_NID4, REGION18_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR19_U_RNI_NID4, 0x35d40)
    FIELD(POR_MPU_M3_PRBAR19_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR19_U_RNI_NID4, REGION19_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR19_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR19_U_RNI_NID4, REGION19_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR19_U_RNI_NID4, REGION19_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR19_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR19_U_RNI_NID4, 0x35d48)
    FIELD(POR_MPU_M3_PRLAR19_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR19_U_RNI_NID4, REGION19_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR19_U_RNI_NID4, REGION19_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR20_U_RNI_NID4, 0x35d50)
    FIELD(POR_MPU_M3_PRBAR20_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR20_U_RNI_NID4, REGION20_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR20_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR20_U_RNI_NID4, REGION20_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR20_U_RNI_NID4, REGION20_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR20_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR20_U_RNI_NID4, 0x35d58)
    FIELD(POR_MPU_M3_PRLAR20_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR20_U_RNI_NID4, REGION20_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR20_U_RNI_NID4, REGION20_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR21_U_RNI_NID4, 0x35d60)
    FIELD(POR_MPU_M3_PRBAR21_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR21_U_RNI_NID4, REGION21_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR21_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR21_U_RNI_NID4, REGION21_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR21_U_RNI_NID4, REGION21_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR21_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR21_U_RNI_NID4, 0x35d68)
    FIELD(POR_MPU_M3_PRLAR21_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR21_U_RNI_NID4, REGION21_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR21_U_RNI_NID4, REGION21_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR22_U_RNI_NID4, 0x35d70)
    FIELD(POR_MPU_M3_PRBAR22_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR22_U_RNI_NID4, REGION22_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR22_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR22_U_RNI_NID4, REGION22_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR22_U_RNI_NID4, REGION22_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR22_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR22_U_RNI_NID4, 0x35d78)
    FIELD(POR_MPU_M3_PRLAR22_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR22_U_RNI_NID4, REGION22_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR22_U_RNI_NID4, REGION22_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR23_U_RNI_NID4, 0x35d80)
    FIELD(POR_MPU_M3_PRBAR23_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR23_U_RNI_NID4, REGION23_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR23_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR23_U_RNI_NID4, REGION23_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR23_U_RNI_NID4, REGION23_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR23_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR23_U_RNI_NID4, 0x35d88)
    FIELD(POR_MPU_M3_PRLAR23_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR23_U_RNI_NID4, REGION23_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR23_U_RNI_NID4, REGION23_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR24_U_RNI_NID4, 0x35d90)
    FIELD(POR_MPU_M3_PRBAR24_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR24_U_RNI_NID4, REGION24_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR24_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR24_U_RNI_NID4, REGION24_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR24_U_RNI_NID4, REGION24_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR24_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR24_U_RNI_NID4, 0x35d98)
    FIELD(POR_MPU_M3_PRLAR24_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR24_U_RNI_NID4, REGION24_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR24_U_RNI_NID4, REGION24_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR25_U_RNI_NID4, 0x35da0)
    FIELD(POR_MPU_M3_PRBAR25_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR25_U_RNI_NID4, REGION25_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR25_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR25_U_RNI_NID4, REGION25_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR25_U_RNI_NID4, REGION25_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR25_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR25_U_RNI_NID4, 0x35da8)
    FIELD(POR_MPU_M3_PRLAR25_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR25_U_RNI_NID4, REGION25_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR25_U_RNI_NID4, REGION25_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR26_U_RNI_NID4, 0x35db0)
    FIELD(POR_MPU_M3_PRBAR26_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR26_U_RNI_NID4, REGION26_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR26_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR26_U_RNI_NID4, REGION26_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR26_U_RNI_NID4, REGION26_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR26_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR26_U_RNI_NID4, 0x35db8)
    FIELD(POR_MPU_M3_PRLAR26_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR26_U_RNI_NID4, REGION26_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR26_U_RNI_NID4, REGION26_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR27_U_RNI_NID4, 0x35dc0)
    FIELD(POR_MPU_M3_PRBAR27_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR27_U_RNI_NID4, REGION27_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR27_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR27_U_RNI_NID4, REGION27_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR27_U_RNI_NID4, REGION27_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR27_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR27_U_RNI_NID4, 0x35dc8)
    FIELD(POR_MPU_M3_PRLAR27_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR27_U_RNI_NID4, REGION27_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR27_U_RNI_NID4, REGION27_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR28_U_RNI_NID4, 0x35dd0)
    FIELD(POR_MPU_M3_PRBAR28_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR28_U_RNI_NID4, REGION28_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR28_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR28_U_RNI_NID4, REGION28_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR28_U_RNI_NID4, REGION28_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR28_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR28_U_RNI_NID4, 0x35dd8)
    FIELD(POR_MPU_M3_PRLAR28_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR28_U_RNI_NID4, REGION28_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR28_U_RNI_NID4, REGION28_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR29_U_RNI_NID4, 0x35de0)
    FIELD(POR_MPU_M3_PRBAR29_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR29_U_RNI_NID4, REGION29_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR29_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR29_U_RNI_NID4, REGION29_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR29_U_RNI_NID4, REGION29_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR29_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR29_U_RNI_NID4, 0x35de8)
    FIELD(POR_MPU_M3_PRLAR29_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR29_U_RNI_NID4, REGION29_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR29_U_RNI_NID4, REGION29_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR30_U_RNI_NID4, 0x35df0)
    FIELD(POR_MPU_M3_PRBAR30_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR30_U_RNI_NID4, REGION30_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR30_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR30_U_RNI_NID4, REGION30_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR30_U_RNI_NID4, REGION30_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR30_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR30_U_RNI_NID4, 0x35df8)
    FIELD(POR_MPU_M3_PRLAR30_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR30_U_RNI_NID4, REGION30_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR30_U_RNI_NID4, REGION30_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR31_U_RNI_NID4, 0x35e00)
    FIELD(POR_MPU_M3_PRBAR31_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR31_U_RNI_NID4, REGION31_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR31_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR31_U_RNI_NID4, REGION31_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR31_U_RNI_NID4, REGION31_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR31_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR31_U_RNI_NID4, 0x35e08)
    FIELD(POR_MPU_M3_PRLAR31_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR31_U_RNI_NID4, REGION31_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR31_U_RNI_NID4, REGION31_EN, 0, 1)
REG32(POR_MPU_M4_CTL_U_RNI_NID4, 0x36000)
    FIELD(POR_MPU_M4_CTL_U_RNI_NID4, M4_EN, 2, 1)
    FIELD(POR_MPU_M4_CTL_U_RNI_NID4, M4_ACTION, 0, 2)
REG32(POR_MPU_M4_PRBAR0_U_RNI_NID4, 0x36010)
    FIELD(POR_MPU_M4_PRBAR0_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR0_U_RNI_NID4, REGION0_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR0_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR0_U_RNI_NID4, REGION0_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR0_U_RNI_NID4, REGION0_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR0_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR0_U_RNI_NID4, 0x36018)
    FIELD(POR_MPU_M4_PRLAR0_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR0_U_RNI_NID4, REGION0_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR0_U_RNI_NID4, REGION0_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR1_U_RNI_NID4, 0x36020)
    FIELD(POR_MPU_M4_PRBAR1_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR1_U_RNI_NID4, REGION1_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR1_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR1_U_RNI_NID4, REGION1_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR1_U_RNI_NID4, REGION1_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR1_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR1_U_RNI_NID4, 0x36028)
    FIELD(POR_MPU_M4_PRLAR1_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR1_U_RNI_NID4, REGION1_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR1_U_RNI_NID4, REGION1_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR2_U_RNI_NID4, 0x36030)
    FIELD(POR_MPU_M4_PRBAR2_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR2_U_RNI_NID4, REGION2_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR2_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR2_U_RNI_NID4, REGION2_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR2_U_RNI_NID4, REGION2_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR2_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR2_U_RNI_NID4, 0x36038)
    FIELD(POR_MPU_M4_PRLAR2_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR2_U_RNI_NID4, REGION2_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR2_U_RNI_NID4, REGION2_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR3_U_RNI_NID4, 0x36040)
    FIELD(POR_MPU_M4_PRBAR3_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR3_U_RNI_NID4, REGION3_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR3_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR3_U_RNI_NID4, REGION3_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR3_U_RNI_NID4, REGION3_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR3_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR3_U_RNI_NID4, 0x36048)
    FIELD(POR_MPU_M4_PRLAR3_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR3_U_RNI_NID4, REGION3_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR3_U_RNI_NID4, REGION3_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR4_U_RNI_NID4, 0x36050)
    FIELD(POR_MPU_M4_PRBAR4_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR4_U_RNI_NID4, REGION4_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR4_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR4_U_RNI_NID4, REGION4_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR4_U_RNI_NID4, REGION4_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR4_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR4_U_RNI_NID4, 0x36058)
    FIELD(POR_MPU_M4_PRLAR4_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR4_U_RNI_NID4, REGION4_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR4_U_RNI_NID4, REGION4_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR5_U_RNI_NID4, 0x36060)
    FIELD(POR_MPU_M4_PRBAR5_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR5_U_RNI_NID4, REGION5_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR5_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR5_U_RNI_NID4, REGION5_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR5_U_RNI_NID4, REGION5_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR5_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR5_U_RNI_NID4, 0x36068)
    FIELD(POR_MPU_M4_PRLAR5_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR5_U_RNI_NID4, REGION5_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR5_U_RNI_NID4, REGION5_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR6_U_RNI_NID4, 0x36070)
    FIELD(POR_MPU_M4_PRBAR6_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR6_U_RNI_NID4, REGION6_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR6_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR6_U_RNI_NID4, REGION6_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR6_U_RNI_NID4, REGION6_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR6_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR6_U_RNI_NID4, 0x36078)
    FIELD(POR_MPU_M4_PRLAR6_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR6_U_RNI_NID4, REGION6_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR6_U_RNI_NID4, REGION6_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR7_U_RNI_NID4, 0x36080)
    FIELD(POR_MPU_M4_PRBAR7_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR7_U_RNI_NID4, REGION7_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR7_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR7_U_RNI_NID4, REGION7_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR7_U_RNI_NID4, REGION7_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR7_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR7_U_RNI_NID4, 0x36088)
    FIELD(POR_MPU_M4_PRLAR7_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR7_U_RNI_NID4, REGION7_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR7_U_RNI_NID4, REGION7_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR8_U_RNI_NID4, 0x36090)
    FIELD(POR_MPU_M4_PRBAR8_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR8_U_RNI_NID4, REGION8_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR8_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR8_U_RNI_NID4, REGION8_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR8_U_RNI_NID4, REGION8_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR8_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR8_U_RNI_NID4, 0x36098)
    FIELD(POR_MPU_M4_PRLAR8_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR8_U_RNI_NID4, REGION8_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR8_U_RNI_NID4, REGION8_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR9_U_RNI_NID4, 0x360a0)
    FIELD(POR_MPU_M4_PRBAR9_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR9_U_RNI_NID4, REGION9_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR9_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR9_U_RNI_NID4, REGION9_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR9_U_RNI_NID4, REGION9_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR9_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR9_U_RNI_NID4, 0x360a8)
    FIELD(POR_MPU_M4_PRLAR9_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR9_U_RNI_NID4, REGION9_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR9_U_RNI_NID4, REGION9_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR10_U_RNI_NID4, 0x360b0)
    FIELD(POR_MPU_M4_PRBAR10_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR10_U_RNI_NID4, REGION10_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR10_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR10_U_RNI_NID4, REGION10_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR10_U_RNI_NID4, REGION10_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR10_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR10_U_RNI_NID4, 0x360b8)
    FIELD(POR_MPU_M4_PRLAR10_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR10_U_RNI_NID4, REGION10_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR10_U_RNI_NID4, REGION10_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR11_U_RNI_NID4, 0x360c0)
    FIELD(POR_MPU_M4_PRBAR11_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR11_U_RNI_NID4, REGION11_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR11_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR11_U_RNI_NID4, REGION11_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR11_U_RNI_NID4, REGION11_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR11_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR11_U_RNI_NID4, 0x360c8)
    FIELD(POR_MPU_M4_PRLAR11_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR11_U_RNI_NID4, REGION11_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR11_U_RNI_NID4, REGION11_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR12_U_RNI_NID4, 0x360d0)
    FIELD(POR_MPU_M4_PRBAR12_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR12_U_RNI_NID4, REGION12_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR12_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR12_U_RNI_NID4, REGION12_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR12_U_RNI_NID4, REGION12_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR12_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR12_U_RNI_NID4, 0x360d8)
    FIELD(POR_MPU_M4_PRLAR12_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR12_U_RNI_NID4, REGION12_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR12_U_RNI_NID4, REGION12_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR13_U_RNI_NID4, 0x360e0)
    FIELD(POR_MPU_M4_PRBAR13_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR13_U_RNI_NID4, REGION13_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR13_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR13_U_RNI_NID4, REGION13_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR13_U_RNI_NID4, REGION13_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR13_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR13_U_RNI_NID4, 0x360e8)
    FIELD(POR_MPU_M4_PRLAR13_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR13_U_RNI_NID4, REGION13_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR13_U_RNI_NID4, REGION13_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR14_U_RNI_NID4, 0x360f0)
    FIELD(POR_MPU_M4_PRBAR14_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR14_U_RNI_NID4, REGION14_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR14_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR14_U_RNI_NID4, REGION14_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR14_U_RNI_NID4, REGION14_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR14_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR14_U_RNI_NID4, 0x360f8)
    FIELD(POR_MPU_M4_PRLAR14_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR14_U_RNI_NID4, REGION14_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR14_U_RNI_NID4, REGION14_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR15_U_RNI_NID4, 0x36100)
    FIELD(POR_MPU_M4_PRBAR15_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR15_U_RNI_NID4, REGION15_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR15_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR15_U_RNI_NID4, REGION15_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR15_U_RNI_NID4, REGION15_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR15_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR15_U_RNI_NID4, 0x36108)
    FIELD(POR_MPU_M4_PRLAR15_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR15_U_RNI_NID4, REGION15_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR15_U_RNI_NID4, REGION15_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR16_U_RNI_NID4, 0x36110)
    FIELD(POR_MPU_M4_PRBAR16_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR16_U_RNI_NID4, REGION16_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR16_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR16_U_RNI_NID4, REGION16_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR16_U_RNI_NID4, REGION16_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR16_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR16_U_RNI_NID4, 0x36118)
    FIELD(POR_MPU_M4_PRLAR16_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR16_U_RNI_NID4, REGION16_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR16_U_RNI_NID4, REGION16_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR17_U_RNI_NID4, 0x36120)
    FIELD(POR_MPU_M4_PRBAR17_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR17_U_RNI_NID4, REGION17_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR17_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR17_U_RNI_NID4, REGION17_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR17_U_RNI_NID4, REGION17_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR17_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR17_U_RNI_NID4, 0x36128)
    FIELD(POR_MPU_M4_PRLAR17_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR17_U_RNI_NID4, REGION17_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR17_U_RNI_NID4, REGION17_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR18_U_RNI_NID4, 0x36130)
    FIELD(POR_MPU_M4_PRBAR18_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR18_U_RNI_NID4, REGION18_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR18_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR18_U_RNI_NID4, REGION18_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR18_U_RNI_NID4, REGION18_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR18_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR18_U_RNI_NID4, 0x36138)
    FIELD(POR_MPU_M4_PRLAR18_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR18_U_RNI_NID4, REGION18_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR18_U_RNI_NID4, REGION18_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR19_U_RNI_NID4, 0x36140)
    FIELD(POR_MPU_M4_PRBAR19_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR19_U_RNI_NID4, REGION19_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR19_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR19_U_RNI_NID4, REGION19_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR19_U_RNI_NID4, REGION19_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR19_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR19_U_RNI_NID4, 0x36148)
    FIELD(POR_MPU_M4_PRLAR19_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR19_U_RNI_NID4, REGION19_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR19_U_RNI_NID4, REGION19_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR20_U_RNI_NID4, 0x36150)
    FIELD(POR_MPU_M4_PRBAR20_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR20_U_RNI_NID4, REGION20_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR20_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR20_U_RNI_NID4, REGION20_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR20_U_RNI_NID4, REGION20_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR20_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR20_U_RNI_NID4, 0x36158)
    FIELD(POR_MPU_M4_PRLAR20_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR20_U_RNI_NID4, REGION20_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR20_U_RNI_NID4, REGION20_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR21_U_RNI_NID4, 0x36160)
    FIELD(POR_MPU_M4_PRBAR21_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR21_U_RNI_NID4, REGION21_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR21_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR21_U_RNI_NID4, REGION21_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR21_U_RNI_NID4, REGION21_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR21_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR21_U_RNI_NID4, 0x36168)
    FIELD(POR_MPU_M4_PRLAR21_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR21_U_RNI_NID4, REGION21_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR21_U_RNI_NID4, REGION21_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR22_U_RNI_NID4, 0x36170)
    FIELD(POR_MPU_M4_PRBAR22_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR22_U_RNI_NID4, REGION22_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR22_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR22_U_RNI_NID4, REGION22_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR22_U_RNI_NID4, REGION22_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR22_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR22_U_RNI_NID4, 0x36178)
    FIELD(POR_MPU_M4_PRLAR22_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR22_U_RNI_NID4, REGION22_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR22_U_RNI_NID4, REGION22_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR23_U_RNI_NID4, 0x36180)
    FIELD(POR_MPU_M4_PRBAR23_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR23_U_RNI_NID4, REGION23_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR23_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR23_U_RNI_NID4, REGION23_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR23_U_RNI_NID4, REGION23_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR23_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR23_U_RNI_NID4, 0x36188)
    FIELD(POR_MPU_M4_PRLAR23_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR23_U_RNI_NID4, REGION23_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR23_U_RNI_NID4, REGION23_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR24_U_RNI_NID4, 0x36190)
    FIELD(POR_MPU_M4_PRBAR24_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR24_U_RNI_NID4, REGION24_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR24_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR24_U_RNI_NID4, REGION24_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR24_U_RNI_NID4, REGION24_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR24_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR24_U_RNI_NID4, 0x36198)
    FIELD(POR_MPU_M4_PRLAR24_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR24_U_RNI_NID4, REGION24_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR24_U_RNI_NID4, REGION24_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR25_U_RNI_NID4, 0x361a0)
    FIELD(POR_MPU_M4_PRBAR25_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR25_U_RNI_NID4, REGION25_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR25_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR25_U_RNI_NID4, REGION25_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR25_U_RNI_NID4, REGION25_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR25_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR25_U_RNI_NID4, 0x361a8)
    FIELD(POR_MPU_M4_PRLAR25_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR25_U_RNI_NID4, REGION25_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR25_U_RNI_NID4, REGION25_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR26_U_RNI_NID4, 0x361b0)
    FIELD(POR_MPU_M4_PRBAR26_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR26_U_RNI_NID4, REGION26_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR26_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR26_U_RNI_NID4, REGION26_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR26_U_RNI_NID4, REGION26_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR26_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR26_U_RNI_NID4, 0x361b8)
    FIELD(POR_MPU_M4_PRLAR26_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR26_U_RNI_NID4, REGION26_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR26_U_RNI_NID4, REGION26_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR27_U_RNI_NID4, 0x361c0)
    FIELD(POR_MPU_M4_PRBAR27_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR27_U_RNI_NID4, REGION27_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR27_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR27_U_RNI_NID4, REGION27_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR27_U_RNI_NID4, REGION27_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR27_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR27_U_RNI_NID4, 0x361c8)
    FIELD(POR_MPU_M4_PRLAR27_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR27_U_RNI_NID4, REGION27_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR27_U_RNI_NID4, REGION27_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR28_U_RNI_NID4, 0x361d0)
    FIELD(POR_MPU_M4_PRBAR28_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR28_U_RNI_NID4, REGION28_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR28_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR28_U_RNI_NID4, REGION28_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR28_U_RNI_NID4, REGION28_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR28_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR28_U_RNI_NID4, 0x361d8)
    FIELD(POR_MPU_M4_PRLAR28_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR28_U_RNI_NID4, REGION28_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR28_U_RNI_NID4, REGION28_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR29_U_RNI_NID4, 0x361e0)
    FIELD(POR_MPU_M4_PRBAR29_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR29_U_RNI_NID4, REGION29_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR29_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR29_U_RNI_NID4, REGION29_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR29_U_RNI_NID4, REGION29_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR29_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR29_U_RNI_NID4, 0x361e8)
    FIELD(POR_MPU_M4_PRLAR29_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR29_U_RNI_NID4, REGION29_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR29_U_RNI_NID4, REGION29_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR30_U_RNI_NID4, 0x361f0)
    FIELD(POR_MPU_M4_PRBAR30_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR30_U_RNI_NID4, REGION30_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR30_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR30_U_RNI_NID4, REGION30_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR30_U_RNI_NID4, REGION30_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR30_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR30_U_RNI_NID4, 0x361f8)
    FIELD(POR_MPU_M4_PRLAR30_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR30_U_RNI_NID4, REGION30_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR30_U_RNI_NID4, REGION30_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR31_U_RNI_NID4, 0x36200)
    FIELD(POR_MPU_M4_PRBAR31_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR31_U_RNI_NID4, REGION31_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR31_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR31_U_RNI_NID4, REGION31_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR31_U_RNI_NID4, REGION31_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR31_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR31_U_RNI_NID4, 0x36208)
    FIELD(POR_MPU_M4_PRLAR31_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR31_U_RNI_NID4, REGION31_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR31_U_RNI_NID4, REGION31_EN, 0, 1)
REG32(POR_MPU_M5_CTL_U_RNI_NID4, 0x36400)
    FIELD(POR_MPU_M5_CTL_U_RNI_NID4, M5_EN, 2, 1)
    FIELD(POR_MPU_M5_CTL_U_RNI_NID4, M5_ACTION, 0, 2)
REG32(POR_MPU_M5_PRBAR0_U_RNI_NID4, 0x36410)
    FIELD(POR_MPU_M5_PRBAR0_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR0_U_RNI_NID4, REGION0_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR0_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR0_U_RNI_NID4, REGION0_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR0_U_RNI_NID4, REGION0_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR0_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR0_U_RNI_NID4, 0x36418)
    FIELD(POR_MPU_M5_PRLAR0_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR0_U_RNI_NID4, REGION0_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR0_U_RNI_NID4, REGION0_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR1_U_RNI_NID4, 0x36420)
    FIELD(POR_MPU_M5_PRBAR1_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR1_U_RNI_NID4, REGION1_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR1_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR1_U_RNI_NID4, REGION1_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR1_U_RNI_NID4, REGION1_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR1_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR1_U_RNI_NID4, 0x36428)
    FIELD(POR_MPU_M5_PRLAR1_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR1_U_RNI_NID4, REGION1_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR1_U_RNI_NID4, REGION1_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR2_U_RNI_NID4, 0x36430)
    FIELD(POR_MPU_M5_PRBAR2_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR2_U_RNI_NID4, REGION2_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR2_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR2_U_RNI_NID4, REGION2_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR2_U_RNI_NID4, REGION2_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR2_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR2_U_RNI_NID4, 0x36438)
    FIELD(POR_MPU_M5_PRLAR2_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR2_U_RNI_NID4, REGION2_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR2_U_RNI_NID4, REGION2_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR3_U_RNI_NID4, 0x36440)
    FIELD(POR_MPU_M5_PRBAR3_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR3_U_RNI_NID4, REGION3_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR3_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR3_U_RNI_NID4, REGION3_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR3_U_RNI_NID4, REGION3_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR3_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR3_U_RNI_NID4, 0x36448)
    FIELD(POR_MPU_M5_PRLAR3_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR3_U_RNI_NID4, REGION3_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR3_U_RNI_NID4, REGION3_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR4_U_RNI_NID4, 0x36450)
    FIELD(POR_MPU_M5_PRBAR4_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR4_U_RNI_NID4, REGION4_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR4_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR4_U_RNI_NID4, REGION4_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR4_U_RNI_NID4, REGION4_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR4_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR4_U_RNI_NID4, 0x36458)
    FIELD(POR_MPU_M5_PRLAR4_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR4_U_RNI_NID4, REGION4_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR4_U_RNI_NID4, REGION4_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR5_U_RNI_NID4, 0x36460)
    FIELD(POR_MPU_M5_PRBAR5_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR5_U_RNI_NID4, REGION5_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR5_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR5_U_RNI_NID4, REGION5_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR5_U_RNI_NID4, REGION5_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR5_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR5_U_RNI_NID4, 0x36468)
    FIELD(POR_MPU_M5_PRLAR5_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR5_U_RNI_NID4, REGION5_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR5_U_RNI_NID4, REGION5_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR6_U_RNI_NID4, 0x36470)
    FIELD(POR_MPU_M5_PRBAR6_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR6_U_RNI_NID4, REGION6_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR6_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR6_U_RNI_NID4, REGION6_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR6_U_RNI_NID4, REGION6_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR6_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR6_U_RNI_NID4, 0x36478)
    FIELD(POR_MPU_M5_PRLAR6_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR6_U_RNI_NID4, REGION6_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR6_U_RNI_NID4, REGION6_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR7_U_RNI_NID4, 0x36480)
    FIELD(POR_MPU_M5_PRBAR7_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR7_U_RNI_NID4, REGION7_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR7_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR7_U_RNI_NID4, REGION7_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR7_U_RNI_NID4, REGION7_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR7_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR7_U_RNI_NID4, 0x36488)
    FIELD(POR_MPU_M5_PRLAR7_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR7_U_RNI_NID4, REGION7_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR7_U_RNI_NID4, REGION7_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR8_U_RNI_NID4, 0x36490)
    FIELD(POR_MPU_M5_PRBAR8_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR8_U_RNI_NID4, REGION8_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR8_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR8_U_RNI_NID4, REGION8_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR8_U_RNI_NID4, REGION8_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR8_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR8_U_RNI_NID4, 0x36498)
    FIELD(POR_MPU_M5_PRLAR8_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR8_U_RNI_NID4, REGION8_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR8_U_RNI_NID4, REGION8_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR9_U_RNI_NID4, 0x364a0)
    FIELD(POR_MPU_M5_PRBAR9_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR9_U_RNI_NID4, REGION9_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR9_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR9_U_RNI_NID4, REGION9_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR9_U_RNI_NID4, REGION9_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR9_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR9_U_RNI_NID4, 0x364a8)
    FIELD(POR_MPU_M5_PRLAR9_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR9_U_RNI_NID4, REGION9_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR9_U_RNI_NID4, REGION9_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR10_U_RNI_NID4, 0x364b0)
    FIELD(POR_MPU_M5_PRBAR10_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR10_U_RNI_NID4, REGION10_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR10_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR10_U_RNI_NID4, REGION10_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR10_U_RNI_NID4, REGION10_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR10_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR10_U_RNI_NID4, 0x364b8)
    FIELD(POR_MPU_M5_PRLAR10_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR10_U_RNI_NID4, REGION10_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR10_U_RNI_NID4, REGION10_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR11_U_RNI_NID4, 0x364c0)
    FIELD(POR_MPU_M5_PRBAR11_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR11_U_RNI_NID4, REGION11_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR11_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR11_U_RNI_NID4, REGION11_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR11_U_RNI_NID4, REGION11_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR11_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR11_U_RNI_NID4, 0x364c8)
    FIELD(POR_MPU_M5_PRLAR11_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR11_U_RNI_NID4, REGION11_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR11_U_RNI_NID4, REGION11_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR12_U_RNI_NID4, 0x364d0)
    FIELD(POR_MPU_M5_PRBAR12_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR12_U_RNI_NID4, REGION12_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR12_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR12_U_RNI_NID4, REGION12_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR12_U_RNI_NID4, REGION12_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR12_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR12_U_RNI_NID4, 0x364d8)
    FIELD(POR_MPU_M5_PRLAR12_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR12_U_RNI_NID4, REGION12_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR12_U_RNI_NID4, REGION12_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR13_U_RNI_NID4, 0x364e0)
    FIELD(POR_MPU_M5_PRBAR13_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR13_U_RNI_NID4, REGION13_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR13_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR13_U_RNI_NID4, REGION13_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR13_U_RNI_NID4, REGION13_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR13_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR13_U_RNI_NID4, 0x364e8)
    FIELD(POR_MPU_M5_PRLAR13_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR13_U_RNI_NID4, REGION13_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR13_U_RNI_NID4, REGION13_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR14_U_RNI_NID4, 0x364f0)
    FIELD(POR_MPU_M5_PRBAR14_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR14_U_RNI_NID4, REGION14_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR14_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR14_U_RNI_NID4, REGION14_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR14_U_RNI_NID4, REGION14_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR14_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR14_U_RNI_NID4, 0x364f8)
    FIELD(POR_MPU_M5_PRLAR14_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR14_U_RNI_NID4, REGION14_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR14_U_RNI_NID4, REGION14_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR15_U_RNI_NID4, 0x36500)
    FIELD(POR_MPU_M5_PRBAR15_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR15_U_RNI_NID4, REGION15_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR15_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR15_U_RNI_NID4, REGION15_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR15_U_RNI_NID4, REGION15_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR15_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR15_U_RNI_NID4, 0x36508)
    FIELD(POR_MPU_M5_PRLAR15_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR15_U_RNI_NID4, REGION15_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR15_U_RNI_NID4, REGION15_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR16_U_RNI_NID4, 0x36510)
    FIELD(POR_MPU_M5_PRBAR16_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR16_U_RNI_NID4, REGION16_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR16_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR16_U_RNI_NID4, REGION16_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR16_U_RNI_NID4, REGION16_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR16_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR16_U_RNI_NID4, 0x36518)
    FIELD(POR_MPU_M5_PRLAR16_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR16_U_RNI_NID4, REGION16_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR16_U_RNI_NID4, REGION16_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR17_U_RNI_NID4, 0x36520)
    FIELD(POR_MPU_M5_PRBAR17_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR17_U_RNI_NID4, REGION17_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR17_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR17_U_RNI_NID4, REGION17_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR17_U_RNI_NID4, REGION17_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR17_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR17_U_RNI_NID4, 0x36528)
    FIELD(POR_MPU_M5_PRLAR17_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR17_U_RNI_NID4, REGION17_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR17_U_RNI_NID4, REGION17_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR18_U_RNI_NID4, 0x36530)
    FIELD(POR_MPU_M5_PRBAR18_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR18_U_RNI_NID4, REGION18_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR18_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR18_U_RNI_NID4, REGION18_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR18_U_RNI_NID4, REGION18_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR18_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR18_U_RNI_NID4, 0x36538)
    FIELD(POR_MPU_M5_PRLAR18_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR18_U_RNI_NID4, REGION18_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR18_U_RNI_NID4, REGION18_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR19_U_RNI_NID4, 0x36540)
    FIELD(POR_MPU_M5_PRBAR19_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR19_U_RNI_NID4, REGION19_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR19_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR19_U_RNI_NID4, REGION19_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR19_U_RNI_NID4, REGION19_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR19_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR19_U_RNI_NID4, 0x36548)
    FIELD(POR_MPU_M5_PRLAR19_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR19_U_RNI_NID4, REGION19_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR19_U_RNI_NID4, REGION19_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR20_U_RNI_NID4, 0x36550)
    FIELD(POR_MPU_M5_PRBAR20_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR20_U_RNI_NID4, REGION20_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR20_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR20_U_RNI_NID4, REGION20_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR20_U_RNI_NID4, REGION20_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR20_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR20_U_RNI_NID4, 0x36558)
    FIELD(POR_MPU_M5_PRLAR20_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR20_U_RNI_NID4, REGION20_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR20_U_RNI_NID4, REGION20_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR21_U_RNI_NID4, 0x36560)
    FIELD(POR_MPU_M5_PRBAR21_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR21_U_RNI_NID4, REGION21_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR21_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR21_U_RNI_NID4, REGION21_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR21_U_RNI_NID4, REGION21_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR21_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR21_U_RNI_NID4, 0x36568)
    FIELD(POR_MPU_M5_PRLAR21_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR21_U_RNI_NID4, REGION21_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR21_U_RNI_NID4, REGION21_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR22_U_RNI_NID4, 0x36570)
    FIELD(POR_MPU_M5_PRBAR22_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR22_U_RNI_NID4, REGION22_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR22_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR22_U_RNI_NID4, REGION22_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR22_U_RNI_NID4, REGION22_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR22_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR22_U_RNI_NID4, 0x36578)
    FIELD(POR_MPU_M5_PRLAR22_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR22_U_RNI_NID4, REGION22_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR22_U_RNI_NID4, REGION22_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR23_U_RNI_NID4, 0x36580)
    FIELD(POR_MPU_M5_PRBAR23_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR23_U_RNI_NID4, REGION23_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR23_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR23_U_RNI_NID4, REGION23_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR23_U_RNI_NID4, REGION23_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR23_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR23_U_RNI_NID4, 0x36588)
    FIELD(POR_MPU_M5_PRLAR23_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR23_U_RNI_NID4, REGION23_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR23_U_RNI_NID4, REGION23_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR24_U_RNI_NID4, 0x36590)
    FIELD(POR_MPU_M5_PRBAR24_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR24_U_RNI_NID4, REGION24_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR24_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR24_U_RNI_NID4, REGION24_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR24_U_RNI_NID4, REGION24_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR24_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR24_U_RNI_NID4, 0x36598)
    FIELD(POR_MPU_M5_PRLAR24_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR24_U_RNI_NID4, REGION24_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR24_U_RNI_NID4, REGION24_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR25_U_RNI_NID4, 0x365a0)
    FIELD(POR_MPU_M5_PRBAR25_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR25_U_RNI_NID4, REGION25_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR25_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR25_U_RNI_NID4, REGION25_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR25_U_RNI_NID4, REGION25_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR25_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR25_U_RNI_NID4, 0x365a8)
    FIELD(POR_MPU_M5_PRLAR25_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR25_U_RNI_NID4, REGION25_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR25_U_RNI_NID4, REGION25_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR26_U_RNI_NID4, 0x365b0)
    FIELD(POR_MPU_M5_PRBAR26_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR26_U_RNI_NID4, REGION26_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR26_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR26_U_RNI_NID4, REGION26_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR26_U_RNI_NID4, REGION26_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR26_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR26_U_RNI_NID4, 0x365b8)
    FIELD(POR_MPU_M5_PRLAR26_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR26_U_RNI_NID4, REGION26_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR26_U_RNI_NID4, REGION26_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR27_U_RNI_NID4, 0x365c0)
    FIELD(POR_MPU_M5_PRBAR27_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR27_U_RNI_NID4, REGION27_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR27_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR27_U_RNI_NID4, REGION27_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR27_U_RNI_NID4, REGION27_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR27_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR27_U_RNI_NID4, 0x365c8)
    FIELD(POR_MPU_M5_PRLAR27_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR27_U_RNI_NID4, REGION27_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR27_U_RNI_NID4, REGION27_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR28_U_RNI_NID4, 0x365d0)
    FIELD(POR_MPU_M5_PRBAR28_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR28_U_RNI_NID4, REGION28_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR28_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR28_U_RNI_NID4, REGION28_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR28_U_RNI_NID4, REGION28_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR28_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR28_U_RNI_NID4, 0x365d8)
    FIELD(POR_MPU_M5_PRLAR28_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR28_U_RNI_NID4, REGION28_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR28_U_RNI_NID4, REGION28_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR29_U_RNI_NID4, 0x365e0)
    FIELD(POR_MPU_M5_PRBAR29_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR29_U_RNI_NID4, REGION29_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR29_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR29_U_RNI_NID4, REGION29_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR29_U_RNI_NID4, REGION29_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR29_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR29_U_RNI_NID4, 0x365e8)
    FIELD(POR_MPU_M5_PRLAR29_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR29_U_RNI_NID4, REGION29_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR29_U_RNI_NID4, REGION29_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR30_U_RNI_NID4, 0x365f0)
    FIELD(POR_MPU_M5_PRBAR30_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR30_U_RNI_NID4, REGION30_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR30_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR30_U_RNI_NID4, REGION30_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR30_U_RNI_NID4, REGION30_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR30_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR30_U_RNI_NID4, 0x365f8)
    FIELD(POR_MPU_M5_PRLAR30_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR30_U_RNI_NID4, REGION30_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR30_U_RNI_NID4, REGION30_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR31_U_RNI_NID4, 0x36600)
    FIELD(POR_MPU_M5_PRBAR31_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR31_U_RNI_NID4, REGION31_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR31_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR31_U_RNI_NID4, REGION31_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR31_U_RNI_NID4, REGION31_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR31_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR31_U_RNI_NID4, 0x36608)
    FIELD(POR_MPU_M5_PRLAR31_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR31_U_RNI_NID4, REGION31_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR31_U_RNI_NID4, REGION31_EN, 0, 1)
REG32(POR_MPU_M6_CTL_U_RNI_NID4, 0x36800)
    FIELD(POR_MPU_M6_CTL_U_RNI_NID4, M6_EN, 2, 1)
    FIELD(POR_MPU_M6_CTL_U_RNI_NID4, M6_ACTION, 0, 2)
REG32(POR_MPU_M6_PRBAR0_U_RNI_NID4, 0x36810)
    FIELD(POR_MPU_M6_PRBAR0_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR0_U_RNI_NID4, REGION0_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR0_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR0_U_RNI_NID4, REGION0_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR0_U_RNI_NID4, REGION0_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR0_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR0_U_RNI_NID4, 0x36818)
    FIELD(POR_MPU_M6_PRLAR0_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR0_U_RNI_NID4, REGION0_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR0_U_RNI_NID4, REGION0_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR1_U_RNI_NID4, 0x36820)
    FIELD(POR_MPU_M6_PRBAR1_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR1_U_RNI_NID4, REGION1_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR1_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR1_U_RNI_NID4, REGION1_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR1_U_RNI_NID4, REGION1_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR1_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR1_U_RNI_NID4, 0x36828)
    FIELD(POR_MPU_M6_PRLAR1_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR1_U_RNI_NID4, REGION1_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR1_U_RNI_NID4, REGION1_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR2_U_RNI_NID4, 0x36830)
    FIELD(POR_MPU_M6_PRBAR2_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR2_U_RNI_NID4, REGION2_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR2_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR2_U_RNI_NID4, REGION2_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR2_U_RNI_NID4, REGION2_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR2_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR2_U_RNI_NID4, 0x36838)
    FIELD(POR_MPU_M6_PRLAR2_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR2_U_RNI_NID4, REGION2_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR2_U_RNI_NID4, REGION2_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR3_U_RNI_NID4, 0x36840)
    FIELD(POR_MPU_M6_PRBAR3_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR3_U_RNI_NID4, REGION3_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR3_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR3_U_RNI_NID4, REGION3_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR3_U_RNI_NID4, REGION3_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR3_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR3_U_RNI_NID4, 0x36848)
    FIELD(POR_MPU_M6_PRLAR3_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR3_U_RNI_NID4, REGION3_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR3_U_RNI_NID4, REGION3_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR4_U_RNI_NID4, 0x36850)
    FIELD(POR_MPU_M6_PRBAR4_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR4_U_RNI_NID4, REGION4_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR4_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR4_U_RNI_NID4, REGION4_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR4_U_RNI_NID4, REGION4_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR4_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR4_U_RNI_NID4, 0x36858)
    FIELD(POR_MPU_M6_PRLAR4_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR4_U_RNI_NID4, REGION4_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR4_U_RNI_NID4, REGION4_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR5_U_RNI_NID4, 0x36860)
    FIELD(POR_MPU_M6_PRBAR5_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR5_U_RNI_NID4, REGION5_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR5_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR5_U_RNI_NID4, REGION5_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR5_U_RNI_NID4, REGION5_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR5_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR5_U_RNI_NID4, 0x36868)
    FIELD(POR_MPU_M6_PRLAR5_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR5_U_RNI_NID4, REGION5_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR5_U_RNI_NID4, REGION5_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR6_U_RNI_NID4, 0x36870)
    FIELD(POR_MPU_M6_PRBAR6_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR6_U_RNI_NID4, REGION6_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR6_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR6_U_RNI_NID4, REGION6_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR6_U_RNI_NID4, REGION6_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR6_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR6_U_RNI_NID4, 0x36878)
    FIELD(POR_MPU_M6_PRLAR6_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR6_U_RNI_NID4, REGION6_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR6_U_RNI_NID4, REGION6_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR7_U_RNI_NID4, 0x36880)
    FIELD(POR_MPU_M6_PRBAR7_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR7_U_RNI_NID4, REGION7_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR7_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR7_U_RNI_NID4, REGION7_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR7_U_RNI_NID4, REGION7_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR7_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR7_U_RNI_NID4, 0x36888)
    FIELD(POR_MPU_M6_PRLAR7_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR7_U_RNI_NID4, REGION7_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR7_U_RNI_NID4, REGION7_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR8_U_RNI_NID4, 0x36890)
    FIELD(POR_MPU_M6_PRBAR8_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR8_U_RNI_NID4, REGION8_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR8_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR8_U_RNI_NID4, REGION8_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR8_U_RNI_NID4, REGION8_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR8_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR8_U_RNI_NID4, 0x36898)
    FIELD(POR_MPU_M6_PRLAR8_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR8_U_RNI_NID4, REGION8_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR8_U_RNI_NID4, REGION8_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR9_U_RNI_NID4, 0x368a0)
    FIELD(POR_MPU_M6_PRBAR9_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR9_U_RNI_NID4, REGION9_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR9_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR9_U_RNI_NID4, REGION9_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR9_U_RNI_NID4, REGION9_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR9_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR9_U_RNI_NID4, 0x368a8)
    FIELD(POR_MPU_M6_PRLAR9_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR9_U_RNI_NID4, REGION9_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR9_U_RNI_NID4, REGION9_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR10_U_RNI_NID4, 0x368b0)
    FIELD(POR_MPU_M6_PRBAR10_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR10_U_RNI_NID4, REGION10_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR10_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR10_U_RNI_NID4, REGION10_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR10_U_RNI_NID4, REGION10_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR10_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR10_U_RNI_NID4, 0x368b8)
    FIELD(POR_MPU_M6_PRLAR10_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR10_U_RNI_NID4, REGION10_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR10_U_RNI_NID4, REGION10_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR11_U_RNI_NID4, 0x368c0)
    FIELD(POR_MPU_M6_PRBAR11_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR11_U_RNI_NID4, REGION11_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR11_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR11_U_RNI_NID4, REGION11_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR11_U_RNI_NID4, REGION11_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR11_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR11_U_RNI_NID4, 0x368c8)
    FIELD(POR_MPU_M6_PRLAR11_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR11_U_RNI_NID4, REGION11_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR11_U_RNI_NID4, REGION11_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR12_U_RNI_NID4, 0x368d0)
    FIELD(POR_MPU_M6_PRBAR12_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR12_U_RNI_NID4, REGION12_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR12_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR12_U_RNI_NID4, REGION12_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR12_U_RNI_NID4, REGION12_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR12_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR12_U_RNI_NID4, 0x368d8)
    FIELD(POR_MPU_M6_PRLAR12_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR12_U_RNI_NID4, REGION12_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR12_U_RNI_NID4, REGION12_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR13_U_RNI_NID4, 0x368e0)
    FIELD(POR_MPU_M6_PRBAR13_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR13_U_RNI_NID4, REGION13_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR13_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR13_U_RNI_NID4, REGION13_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR13_U_RNI_NID4, REGION13_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR13_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR13_U_RNI_NID4, 0x368e8)
    FIELD(POR_MPU_M6_PRLAR13_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR13_U_RNI_NID4, REGION13_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR13_U_RNI_NID4, REGION13_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR14_U_RNI_NID4, 0x368f0)
    FIELD(POR_MPU_M6_PRBAR14_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR14_U_RNI_NID4, REGION14_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR14_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR14_U_RNI_NID4, REGION14_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR14_U_RNI_NID4, REGION14_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR14_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR14_U_RNI_NID4, 0x368f8)
    FIELD(POR_MPU_M6_PRLAR14_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR14_U_RNI_NID4, REGION14_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR14_U_RNI_NID4, REGION14_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR15_U_RNI_NID4, 0x36900)
    FIELD(POR_MPU_M6_PRBAR15_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR15_U_RNI_NID4, REGION15_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR15_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR15_U_RNI_NID4, REGION15_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR15_U_RNI_NID4, REGION15_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR15_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR15_U_RNI_NID4, 0x36908)
    FIELD(POR_MPU_M6_PRLAR15_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR15_U_RNI_NID4, REGION15_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR15_U_RNI_NID4, REGION15_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR16_U_RNI_NID4, 0x36910)
    FIELD(POR_MPU_M6_PRBAR16_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR16_U_RNI_NID4, REGION16_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR16_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR16_U_RNI_NID4, REGION16_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR16_U_RNI_NID4, REGION16_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR16_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR16_U_RNI_NID4, 0x36918)
    FIELD(POR_MPU_M6_PRLAR16_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR16_U_RNI_NID4, REGION16_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR16_U_RNI_NID4, REGION16_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR17_U_RNI_NID4, 0x36920)
    FIELD(POR_MPU_M6_PRBAR17_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR17_U_RNI_NID4, REGION17_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR17_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR17_U_RNI_NID4, REGION17_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR17_U_RNI_NID4, REGION17_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR17_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR17_U_RNI_NID4, 0x36928)
    FIELD(POR_MPU_M6_PRLAR17_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR17_U_RNI_NID4, REGION17_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR17_U_RNI_NID4, REGION17_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR18_U_RNI_NID4, 0x36930)
    FIELD(POR_MPU_M6_PRBAR18_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR18_U_RNI_NID4, REGION18_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR18_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR18_U_RNI_NID4, REGION18_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR18_U_RNI_NID4, REGION18_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR18_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR18_U_RNI_NID4, 0x36938)
    FIELD(POR_MPU_M6_PRLAR18_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR18_U_RNI_NID4, REGION18_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR18_U_RNI_NID4, REGION18_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR19_U_RNI_NID4, 0x36940)
    FIELD(POR_MPU_M6_PRBAR19_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR19_U_RNI_NID4, REGION19_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR19_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR19_U_RNI_NID4, REGION19_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR19_U_RNI_NID4, REGION19_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR19_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR19_U_RNI_NID4, 0x36948)
    FIELD(POR_MPU_M6_PRLAR19_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR19_U_RNI_NID4, REGION19_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR19_U_RNI_NID4, REGION19_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR20_U_RNI_NID4, 0x36950)
    FIELD(POR_MPU_M6_PRBAR20_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR20_U_RNI_NID4, REGION20_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR20_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR20_U_RNI_NID4, REGION20_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR20_U_RNI_NID4, REGION20_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR20_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR20_U_RNI_NID4, 0x36958)
    FIELD(POR_MPU_M6_PRLAR20_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR20_U_RNI_NID4, REGION20_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR20_U_RNI_NID4, REGION20_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR21_U_RNI_NID4, 0x36960)
    FIELD(POR_MPU_M6_PRBAR21_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR21_U_RNI_NID4, REGION21_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR21_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR21_U_RNI_NID4, REGION21_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR21_U_RNI_NID4, REGION21_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR21_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR21_U_RNI_NID4, 0x36968)
    FIELD(POR_MPU_M6_PRLAR21_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR21_U_RNI_NID4, REGION21_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR21_U_RNI_NID4, REGION21_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR22_U_RNI_NID4, 0x36970)
    FIELD(POR_MPU_M6_PRBAR22_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR22_U_RNI_NID4, REGION22_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR22_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR22_U_RNI_NID4, REGION22_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR22_U_RNI_NID4, REGION22_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR22_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR22_U_RNI_NID4, 0x36978)
    FIELD(POR_MPU_M6_PRLAR22_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR22_U_RNI_NID4, REGION22_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR22_U_RNI_NID4, REGION22_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR23_U_RNI_NID4, 0x36980)
    FIELD(POR_MPU_M6_PRBAR23_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR23_U_RNI_NID4, REGION23_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR23_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR23_U_RNI_NID4, REGION23_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR23_U_RNI_NID4, REGION23_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR23_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR23_U_RNI_NID4, 0x36988)
    FIELD(POR_MPU_M6_PRLAR23_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR23_U_RNI_NID4, REGION23_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR23_U_RNI_NID4, REGION23_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR24_U_RNI_NID4, 0x36990)
    FIELD(POR_MPU_M6_PRBAR24_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR24_U_RNI_NID4, REGION24_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR24_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR24_U_RNI_NID4, REGION24_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR24_U_RNI_NID4, REGION24_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR24_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR24_U_RNI_NID4, 0x36998)
    FIELD(POR_MPU_M6_PRLAR24_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR24_U_RNI_NID4, REGION24_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR24_U_RNI_NID4, REGION24_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR25_U_RNI_NID4, 0x369a0)
    FIELD(POR_MPU_M6_PRBAR25_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR25_U_RNI_NID4, REGION25_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR25_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR25_U_RNI_NID4, REGION25_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR25_U_RNI_NID4, REGION25_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR25_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR25_U_RNI_NID4, 0x369a8)
    FIELD(POR_MPU_M6_PRLAR25_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR25_U_RNI_NID4, REGION25_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR25_U_RNI_NID4, REGION25_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR26_U_RNI_NID4, 0x369b0)
    FIELD(POR_MPU_M6_PRBAR26_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR26_U_RNI_NID4, REGION26_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR26_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR26_U_RNI_NID4, REGION26_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR26_U_RNI_NID4, REGION26_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR26_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR26_U_RNI_NID4, 0x369b8)
    FIELD(POR_MPU_M6_PRLAR26_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR26_U_RNI_NID4, REGION26_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR26_U_RNI_NID4, REGION26_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR27_U_RNI_NID4, 0x369c0)
    FIELD(POR_MPU_M6_PRBAR27_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR27_U_RNI_NID4, REGION27_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR27_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR27_U_RNI_NID4, REGION27_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR27_U_RNI_NID4, REGION27_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR27_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR27_U_RNI_NID4, 0x369c8)
    FIELD(POR_MPU_M6_PRLAR27_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR27_U_RNI_NID4, REGION27_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR27_U_RNI_NID4, REGION27_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR28_U_RNI_NID4, 0x369d0)
    FIELD(POR_MPU_M6_PRBAR28_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR28_U_RNI_NID4, REGION28_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR28_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR28_U_RNI_NID4, REGION28_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR28_U_RNI_NID4, REGION28_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR28_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR28_U_RNI_NID4, 0x369d8)
    FIELD(POR_MPU_M6_PRLAR28_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR28_U_RNI_NID4, REGION28_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR28_U_RNI_NID4, REGION28_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR29_U_RNI_NID4, 0x369e0)
    FIELD(POR_MPU_M6_PRBAR29_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR29_U_RNI_NID4, REGION29_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR29_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR29_U_RNI_NID4, REGION29_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR29_U_RNI_NID4, REGION29_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR29_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR29_U_RNI_NID4, 0x369e8)
    FIELD(POR_MPU_M6_PRLAR29_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR29_U_RNI_NID4, REGION29_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR29_U_RNI_NID4, REGION29_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR30_U_RNI_NID4, 0x369f0)
    FIELD(POR_MPU_M6_PRBAR30_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR30_U_RNI_NID4, REGION30_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR30_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR30_U_RNI_NID4, REGION30_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR30_U_RNI_NID4, REGION30_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR30_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR30_U_RNI_NID4, 0x369f8)
    FIELD(POR_MPU_M6_PRLAR30_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR30_U_RNI_NID4, REGION30_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR30_U_RNI_NID4, REGION30_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR31_U_RNI_NID4, 0x36a00)
    FIELD(POR_MPU_M6_PRBAR31_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR31_U_RNI_NID4, REGION31_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR31_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR31_U_RNI_NID4, REGION31_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR31_U_RNI_NID4, REGION31_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR31_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR31_U_RNI_NID4, 0x36a08)
    FIELD(POR_MPU_M6_PRLAR31_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR31_U_RNI_NID4, REGION31_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR31_U_RNI_NID4, REGION31_EN, 0, 1)
REG32(POR_MPU_M7_CTL_U_RNI_NID4, 0x36c00)
    FIELD(POR_MPU_M7_CTL_U_RNI_NID4, M7_EN, 2, 1)
    FIELD(POR_MPU_M7_CTL_U_RNI_NID4, M7_ACTION, 0, 2)
REG32(POR_MPU_M7_PRBAR0_U_RNI_NID4, 0x36c10)
    FIELD(POR_MPU_M7_PRBAR0_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR0_U_RNI_NID4, REGION0_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR0_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR0_U_RNI_NID4, REGION0_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR0_U_RNI_NID4, REGION0_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR0_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR0_U_RNI_NID4, 0x36c18)
    FIELD(POR_MPU_M7_PRLAR0_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR0_U_RNI_NID4, REGION0_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR0_U_RNI_NID4, REGION0_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR1_U_RNI_NID4, 0x36c20)
    FIELD(POR_MPU_M7_PRBAR1_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR1_U_RNI_NID4, REGION1_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR1_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR1_U_RNI_NID4, REGION1_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR1_U_RNI_NID4, REGION1_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR1_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR1_U_RNI_NID4, 0x36c28)
    FIELD(POR_MPU_M7_PRLAR1_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR1_U_RNI_NID4, REGION1_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR1_U_RNI_NID4, REGION1_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR2_U_RNI_NID4, 0x36c30)
    FIELD(POR_MPU_M7_PRBAR2_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR2_U_RNI_NID4, REGION2_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR2_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR2_U_RNI_NID4, REGION2_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR2_U_RNI_NID4, REGION2_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR2_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR2_U_RNI_NID4, 0x36c38)
    FIELD(POR_MPU_M7_PRLAR2_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR2_U_RNI_NID4, REGION2_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR2_U_RNI_NID4, REGION2_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR3_U_RNI_NID4, 0x36c40)
    FIELD(POR_MPU_M7_PRBAR3_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR3_U_RNI_NID4, REGION3_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR3_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR3_U_RNI_NID4, REGION3_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR3_U_RNI_NID4, REGION3_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR3_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR3_U_RNI_NID4, 0x36c48)
    FIELD(POR_MPU_M7_PRLAR3_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR3_U_RNI_NID4, REGION3_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR3_U_RNI_NID4, REGION3_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR4_U_RNI_NID4, 0x36c50)
    FIELD(POR_MPU_M7_PRBAR4_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR4_U_RNI_NID4, REGION4_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR4_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR4_U_RNI_NID4, REGION4_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR4_U_RNI_NID4, REGION4_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR4_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR4_U_RNI_NID4, 0x36c58)
    FIELD(POR_MPU_M7_PRLAR4_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR4_U_RNI_NID4, REGION4_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR4_U_RNI_NID4, REGION4_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR5_U_RNI_NID4, 0x36c60)
    FIELD(POR_MPU_M7_PRBAR5_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR5_U_RNI_NID4, REGION5_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR5_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR5_U_RNI_NID4, REGION5_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR5_U_RNI_NID4, REGION5_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR5_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR5_U_RNI_NID4, 0x36c68)
    FIELD(POR_MPU_M7_PRLAR5_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR5_U_RNI_NID4, REGION5_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR5_U_RNI_NID4, REGION5_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR6_U_RNI_NID4, 0x36c70)
    FIELD(POR_MPU_M7_PRBAR6_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR6_U_RNI_NID4, REGION6_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR6_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR6_U_RNI_NID4, REGION6_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR6_U_RNI_NID4, REGION6_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR6_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR6_U_RNI_NID4, 0x36c78)
    FIELD(POR_MPU_M7_PRLAR6_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR6_U_RNI_NID4, REGION6_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR6_U_RNI_NID4, REGION6_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR7_U_RNI_NID4, 0x36c80)
    FIELD(POR_MPU_M7_PRBAR7_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR7_U_RNI_NID4, REGION7_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR7_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR7_U_RNI_NID4, REGION7_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR7_U_RNI_NID4, REGION7_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR7_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR7_U_RNI_NID4, 0x36c88)
    FIELD(POR_MPU_M7_PRLAR7_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR7_U_RNI_NID4, REGION7_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR7_U_RNI_NID4, REGION7_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR8_U_RNI_NID4, 0x36c90)
    FIELD(POR_MPU_M7_PRBAR8_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR8_U_RNI_NID4, REGION8_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR8_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR8_U_RNI_NID4, REGION8_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR8_U_RNI_NID4, REGION8_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR8_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR8_U_RNI_NID4, 0x36c98)
    FIELD(POR_MPU_M7_PRLAR8_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR8_U_RNI_NID4, REGION8_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR8_U_RNI_NID4, REGION8_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR9_U_RNI_NID4, 0x36ca0)
    FIELD(POR_MPU_M7_PRBAR9_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR9_U_RNI_NID4, REGION9_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR9_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR9_U_RNI_NID4, REGION9_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR9_U_RNI_NID4, REGION9_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR9_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR9_U_RNI_NID4, 0x36ca8)
    FIELD(POR_MPU_M7_PRLAR9_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR9_U_RNI_NID4, REGION9_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR9_U_RNI_NID4, REGION9_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR10_U_RNI_NID4, 0x36cb0)
    FIELD(POR_MPU_M7_PRBAR10_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR10_U_RNI_NID4, REGION10_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR10_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR10_U_RNI_NID4, REGION10_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR10_U_RNI_NID4, REGION10_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR10_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR10_U_RNI_NID4, 0x36cb8)
    FIELD(POR_MPU_M7_PRLAR10_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR10_U_RNI_NID4, REGION10_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR10_U_RNI_NID4, REGION10_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR11_U_RNI_NID4, 0x36cc0)
    FIELD(POR_MPU_M7_PRBAR11_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR11_U_RNI_NID4, REGION11_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR11_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR11_U_RNI_NID4, REGION11_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR11_U_RNI_NID4, REGION11_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR11_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR11_U_RNI_NID4, 0x36cc8)
    FIELD(POR_MPU_M7_PRLAR11_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR11_U_RNI_NID4, REGION11_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR11_U_RNI_NID4, REGION11_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR12_U_RNI_NID4, 0x36cd0)
    FIELD(POR_MPU_M7_PRBAR12_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR12_U_RNI_NID4, REGION12_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR12_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR12_U_RNI_NID4, REGION12_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR12_U_RNI_NID4, REGION12_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR12_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR12_U_RNI_NID4, 0x36cd8)
    FIELD(POR_MPU_M7_PRLAR12_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR12_U_RNI_NID4, REGION12_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR12_U_RNI_NID4, REGION12_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR13_U_RNI_NID4, 0x36ce0)
    FIELD(POR_MPU_M7_PRBAR13_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR13_U_RNI_NID4, REGION13_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR13_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR13_U_RNI_NID4, REGION13_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR13_U_RNI_NID4, REGION13_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR13_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR13_U_RNI_NID4, 0x36ce8)
    FIELD(POR_MPU_M7_PRLAR13_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR13_U_RNI_NID4, REGION13_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR13_U_RNI_NID4, REGION13_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR14_U_RNI_NID4, 0x36cf0)
    FIELD(POR_MPU_M7_PRBAR14_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR14_U_RNI_NID4, REGION14_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR14_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR14_U_RNI_NID4, REGION14_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR14_U_RNI_NID4, REGION14_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR14_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR14_U_RNI_NID4, 0x36cf8)
    FIELD(POR_MPU_M7_PRLAR14_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR14_U_RNI_NID4, REGION14_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR14_U_RNI_NID4, REGION14_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR15_U_RNI_NID4, 0x36d00)
    FIELD(POR_MPU_M7_PRBAR15_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR15_U_RNI_NID4, REGION15_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR15_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR15_U_RNI_NID4, REGION15_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR15_U_RNI_NID4, REGION15_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR15_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR15_U_RNI_NID4, 0x36d08)
    FIELD(POR_MPU_M7_PRLAR15_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR15_U_RNI_NID4, REGION15_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR15_U_RNI_NID4, REGION15_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR16_U_RNI_NID4, 0x36d10)
    FIELD(POR_MPU_M7_PRBAR16_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR16_U_RNI_NID4, REGION16_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR16_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR16_U_RNI_NID4, REGION16_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR16_U_RNI_NID4, REGION16_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR16_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR16_U_RNI_NID4, 0x36d18)
    FIELD(POR_MPU_M7_PRLAR16_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR16_U_RNI_NID4, REGION16_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR16_U_RNI_NID4, REGION16_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR17_U_RNI_NID4, 0x36d20)
    FIELD(POR_MPU_M7_PRBAR17_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR17_U_RNI_NID4, REGION17_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR17_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR17_U_RNI_NID4, REGION17_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR17_U_RNI_NID4, REGION17_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR17_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR17_U_RNI_NID4, 0x36d28)
    FIELD(POR_MPU_M7_PRLAR17_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR17_U_RNI_NID4, REGION17_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR17_U_RNI_NID4, REGION17_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR18_U_RNI_NID4, 0x36d30)
    FIELD(POR_MPU_M7_PRBAR18_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR18_U_RNI_NID4, REGION18_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR18_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR18_U_RNI_NID4, REGION18_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR18_U_RNI_NID4, REGION18_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR18_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR18_U_RNI_NID4, 0x36d38)
    FIELD(POR_MPU_M7_PRLAR18_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR18_U_RNI_NID4, REGION18_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR18_U_RNI_NID4, REGION18_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR19_U_RNI_NID4, 0x36d40)
    FIELD(POR_MPU_M7_PRBAR19_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR19_U_RNI_NID4, REGION19_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR19_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR19_U_RNI_NID4, REGION19_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR19_U_RNI_NID4, REGION19_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR19_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR19_U_RNI_NID4, 0x36d48)
    FIELD(POR_MPU_M7_PRLAR19_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR19_U_RNI_NID4, REGION19_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR19_U_RNI_NID4, REGION19_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR20_U_RNI_NID4, 0x36d50)
    FIELD(POR_MPU_M7_PRBAR20_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR20_U_RNI_NID4, REGION20_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR20_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR20_U_RNI_NID4, REGION20_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR20_U_RNI_NID4, REGION20_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR20_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR20_U_RNI_NID4, 0x36d58)
    FIELD(POR_MPU_M7_PRLAR20_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR20_U_RNI_NID4, REGION20_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR20_U_RNI_NID4, REGION20_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR21_U_RNI_NID4, 0x36d60)
    FIELD(POR_MPU_M7_PRBAR21_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR21_U_RNI_NID4, REGION21_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR21_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR21_U_RNI_NID4, REGION21_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR21_U_RNI_NID4, REGION21_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR21_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR21_U_RNI_NID4, 0x36d68)
    FIELD(POR_MPU_M7_PRLAR21_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR21_U_RNI_NID4, REGION21_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR21_U_RNI_NID4, REGION21_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR22_U_RNI_NID4, 0x36d70)
    FIELD(POR_MPU_M7_PRBAR22_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR22_U_RNI_NID4, REGION22_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR22_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR22_U_RNI_NID4, REGION22_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR22_U_RNI_NID4, REGION22_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR22_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR22_U_RNI_NID4, 0x36d78)
    FIELD(POR_MPU_M7_PRLAR22_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR22_U_RNI_NID4, REGION22_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR22_U_RNI_NID4, REGION22_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR23_U_RNI_NID4, 0x36d80)
    FIELD(POR_MPU_M7_PRBAR23_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR23_U_RNI_NID4, REGION23_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR23_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR23_U_RNI_NID4, REGION23_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR23_U_RNI_NID4, REGION23_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR23_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR23_U_RNI_NID4, 0x36d88)
    FIELD(POR_MPU_M7_PRLAR23_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR23_U_RNI_NID4, REGION23_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR23_U_RNI_NID4, REGION23_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR24_U_RNI_NID4, 0x36d90)
    FIELD(POR_MPU_M7_PRBAR24_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR24_U_RNI_NID4, REGION24_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR24_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR24_U_RNI_NID4, REGION24_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR24_U_RNI_NID4, REGION24_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR24_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR24_U_RNI_NID4, 0x36d98)
    FIELD(POR_MPU_M7_PRLAR24_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR24_U_RNI_NID4, REGION24_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR24_U_RNI_NID4, REGION24_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR25_U_RNI_NID4, 0x36da0)
    FIELD(POR_MPU_M7_PRBAR25_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR25_U_RNI_NID4, REGION25_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR25_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR25_U_RNI_NID4, REGION25_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR25_U_RNI_NID4, REGION25_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR25_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR25_U_RNI_NID4, 0x36da8)
    FIELD(POR_MPU_M7_PRLAR25_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR25_U_RNI_NID4, REGION25_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR25_U_RNI_NID4, REGION25_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR26_U_RNI_NID4, 0x36db0)
    FIELD(POR_MPU_M7_PRBAR26_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR26_U_RNI_NID4, REGION26_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR26_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR26_U_RNI_NID4, REGION26_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR26_U_RNI_NID4, REGION26_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR26_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR26_U_RNI_NID4, 0x36db8)
    FIELD(POR_MPU_M7_PRLAR26_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR26_U_RNI_NID4, REGION26_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR26_U_RNI_NID4, REGION26_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR27_U_RNI_NID4, 0x36dc0)
    FIELD(POR_MPU_M7_PRBAR27_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR27_U_RNI_NID4, REGION27_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR27_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR27_U_RNI_NID4, REGION27_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR27_U_RNI_NID4, REGION27_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR27_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR27_U_RNI_NID4, 0x36dc8)
    FIELD(POR_MPU_M7_PRLAR27_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR27_U_RNI_NID4, REGION27_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR27_U_RNI_NID4, REGION27_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR28_U_RNI_NID4, 0x36dd0)
    FIELD(POR_MPU_M7_PRBAR28_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR28_U_RNI_NID4, REGION28_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR28_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR28_U_RNI_NID4, REGION28_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR28_U_RNI_NID4, REGION28_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR28_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR28_U_RNI_NID4, 0x36dd8)
    FIELD(POR_MPU_M7_PRLAR28_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR28_U_RNI_NID4, REGION28_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR28_U_RNI_NID4, REGION28_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR29_U_RNI_NID4, 0x36de0)
    FIELD(POR_MPU_M7_PRBAR29_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR29_U_RNI_NID4, REGION29_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR29_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR29_U_RNI_NID4, REGION29_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR29_U_RNI_NID4, REGION29_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR29_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR29_U_RNI_NID4, 0x36de8)
    FIELD(POR_MPU_M7_PRLAR29_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR29_U_RNI_NID4, REGION29_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR29_U_RNI_NID4, REGION29_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR30_U_RNI_NID4, 0x36df0)
    FIELD(POR_MPU_M7_PRBAR30_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR30_U_RNI_NID4, REGION30_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR30_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR30_U_RNI_NID4, REGION30_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR30_U_RNI_NID4, REGION30_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR30_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR30_U_RNI_NID4, 0x36df8)
    FIELD(POR_MPU_M7_PRLAR30_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR30_U_RNI_NID4, REGION30_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR30_U_RNI_NID4, REGION30_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR31_U_RNI_NID4, 0x36e00)
    FIELD(POR_MPU_M7_PRBAR31_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR31_U_RNI_NID4, REGION31_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR31_U_RNI_NID4, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR31_U_RNI_NID4, REGION31_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR31_U_RNI_NID4, REGION31_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR31_U_RNI_NID4, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR31_U_RNI_NID4, 0x36e08)
    FIELD(POR_MPU_M7_PRLAR31_U_RNI_NID4, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR31_U_RNI_NID4, REGION31_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR31_U_RNI_NID4, REGION31_EN, 0, 1)
REG32(POR_MPU_NODE_INFO_U_SMXP_0_0, 0x3c000)
    FIELD(POR_MPU_NODE_INFO_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_NODE_INFO_U_SMXP_0_0, LOGICAL_ID, 32, 16)
    FIELD(POR_MPU_NODE_INFO_U_SMXP_0_0, NODE_ID, 16, 16)
    FIELD(POR_MPU_NODE_INFO_U_SMXP_0_0, NODE_TYPE, 0, 16)
REG32(POR_MPU_CHILD_INFO_U_SMXP_0_0, 0x3c080)
    FIELD(POR_MPU_CHILD_INFO_U_SMXP_0_0, RESERVED_32, 32, 32)
    FIELD(POR_MPU_CHILD_INFO_U_SMXP_0_0, CHILD_PTR_OFFSET, 16, 16)
    FIELD(POR_MPU_CHILD_INFO_U_SMXP_0_0, CHILD_COUNT, 0, 16)
REG32(POR_MPU_UNIT_INFO_U_SMXP_0_0, 0x3c900)
    FIELD(POR_MPU_UNIT_INFO_U_SMXP_0_0, RESERVED_16, 16, 48)
    FIELD(POR_MPU_UNIT_INFO_U_SMXP_0_0, MASTER_7_PRESENT, 15, 1)
    FIELD(POR_MPU_UNIT_INFO_U_SMXP_0_0, MASTER_6_PRESENT, 14, 1)
    FIELD(POR_MPU_UNIT_INFO_U_SMXP_0_0, MASTER_5_PRESENT, 13, 1)
    FIELD(POR_MPU_UNIT_INFO_U_SMXP_0_0, MASTER_4_PRESENT, 12, 1)
    FIELD(POR_MPU_UNIT_INFO_U_SMXP_0_0, MASTER_3_PRESENT, 11, 1)
    FIELD(POR_MPU_UNIT_INFO_U_SMXP_0_0, MASTER_2_PRESENT, 10, 1)
    FIELD(POR_MPU_UNIT_INFO_U_SMXP_0_0, MASTER_1_PRESENT, 9, 1)
    FIELD(POR_MPU_UNIT_INFO_U_SMXP_0_0, MASTER_0_PRESENT, 8, 1)
    FIELD(POR_MPU_UNIT_INFO_U_SMXP_0_0, NUM_PROG_REGION, 0, 8)
REG32(POR_MPU_M0_CTL_U_SMXP_0_0, 0x3d000)
    FIELD(POR_MPU_M0_CTL_U_SMXP_0_0, M0_EN, 2, 1)
    FIELD(POR_MPU_M0_CTL_U_SMXP_0_0, M0_ACTION, 0, 2)
REG32(POR_MPU_M0_PRBAR0_U_SMXP_0_0, 0x3d010)
    FIELD(POR_MPU_M0_PRBAR0_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR0_U_SMXP_0_0, REGION0_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR0_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR0_U_SMXP_0_0, REGION0_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR0_U_SMXP_0_0, REGION0_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR0_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR0_U_SMXP_0_0, 0x3d018)
    FIELD(POR_MPU_M0_PRLAR0_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR0_U_SMXP_0_0, REGION0_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR0_U_SMXP_0_0, REGION0_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR1_U_SMXP_0_0, 0x3d020)
    FIELD(POR_MPU_M0_PRBAR1_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR1_U_SMXP_0_0, REGION1_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR1_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR1_U_SMXP_0_0, REGION1_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR1_U_SMXP_0_0, REGION1_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR1_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR1_U_SMXP_0_0, 0x3d028)
    FIELD(POR_MPU_M0_PRLAR1_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR1_U_SMXP_0_0, REGION1_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR1_U_SMXP_0_0, REGION1_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR2_U_SMXP_0_0, 0x3d030)
    FIELD(POR_MPU_M0_PRBAR2_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR2_U_SMXP_0_0, REGION2_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR2_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR2_U_SMXP_0_0, REGION2_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR2_U_SMXP_0_0, REGION2_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR2_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR2_U_SMXP_0_0, 0x3d038)
    FIELD(POR_MPU_M0_PRLAR2_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR2_U_SMXP_0_0, REGION2_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR2_U_SMXP_0_0, REGION2_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR3_U_SMXP_0_0, 0x3d040)
    FIELD(POR_MPU_M0_PRBAR3_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR3_U_SMXP_0_0, REGION3_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR3_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR3_U_SMXP_0_0, REGION3_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR3_U_SMXP_0_0, REGION3_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR3_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR3_U_SMXP_0_0, 0x3d048)
    FIELD(POR_MPU_M0_PRLAR3_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR3_U_SMXP_0_0, REGION3_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR3_U_SMXP_0_0, REGION3_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR4_U_SMXP_0_0, 0x3d050)
    FIELD(POR_MPU_M0_PRBAR4_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR4_U_SMXP_0_0, REGION4_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR4_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR4_U_SMXP_0_0, REGION4_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR4_U_SMXP_0_0, REGION4_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR4_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR4_U_SMXP_0_0, 0x3d058)
    FIELD(POR_MPU_M0_PRLAR4_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR4_U_SMXP_0_0, REGION4_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR4_U_SMXP_0_0, REGION4_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR5_U_SMXP_0_0, 0x3d060)
    FIELD(POR_MPU_M0_PRBAR5_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR5_U_SMXP_0_0, REGION5_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR5_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR5_U_SMXP_0_0, REGION5_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR5_U_SMXP_0_0, REGION5_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR5_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR5_U_SMXP_0_0, 0x3d068)
    FIELD(POR_MPU_M0_PRLAR5_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR5_U_SMXP_0_0, REGION5_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR5_U_SMXP_0_0, REGION5_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR6_U_SMXP_0_0, 0x3d070)
    FIELD(POR_MPU_M0_PRBAR6_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR6_U_SMXP_0_0, REGION6_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR6_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR6_U_SMXP_0_0, REGION6_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR6_U_SMXP_0_0, REGION6_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR6_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR6_U_SMXP_0_0, 0x3d078)
    FIELD(POR_MPU_M0_PRLAR6_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR6_U_SMXP_0_0, REGION6_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR6_U_SMXP_0_0, REGION6_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR7_U_SMXP_0_0, 0x3d080)
    FIELD(POR_MPU_M0_PRBAR7_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR7_U_SMXP_0_0, REGION7_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR7_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR7_U_SMXP_0_0, REGION7_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR7_U_SMXP_0_0, REGION7_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR7_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR7_U_SMXP_0_0, 0x3d088)
    FIELD(POR_MPU_M0_PRLAR7_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR7_U_SMXP_0_0, REGION7_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR7_U_SMXP_0_0, REGION7_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR8_U_SMXP_0_0, 0x3d090)
    FIELD(POR_MPU_M0_PRBAR8_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR8_U_SMXP_0_0, REGION8_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR8_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR8_U_SMXP_0_0, REGION8_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR8_U_SMXP_0_0, REGION8_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR8_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR8_U_SMXP_0_0, 0x3d098)
    FIELD(POR_MPU_M0_PRLAR8_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR8_U_SMXP_0_0, REGION8_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR8_U_SMXP_0_0, REGION8_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR9_U_SMXP_0_0, 0x3d0a0)
    FIELD(POR_MPU_M0_PRBAR9_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR9_U_SMXP_0_0, REGION9_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR9_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR9_U_SMXP_0_0, REGION9_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR9_U_SMXP_0_0, REGION9_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR9_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR9_U_SMXP_0_0, 0x3d0a8)
    FIELD(POR_MPU_M0_PRLAR9_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR9_U_SMXP_0_0, REGION9_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR9_U_SMXP_0_0, REGION9_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR10_U_SMXP_0_0, 0x3d0b0)
    FIELD(POR_MPU_M0_PRBAR10_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR10_U_SMXP_0_0, REGION10_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR10_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR10_U_SMXP_0_0, REGION10_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR10_U_SMXP_0_0, REGION10_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR10_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR10_U_SMXP_0_0, 0x3d0b8)
    FIELD(POR_MPU_M0_PRLAR10_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR10_U_SMXP_0_0, REGION10_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR10_U_SMXP_0_0, REGION10_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR11_U_SMXP_0_0, 0x3d0c0)
    FIELD(POR_MPU_M0_PRBAR11_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR11_U_SMXP_0_0, REGION11_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR11_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR11_U_SMXP_0_0, REGION11_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR11_U_SMXP_0_0, REGION11_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR11_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR11_U_SMXP_0_0, 0x3d0c8)
    FIELD(POR_MPU_M0_PRLAR11_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR11_U_SMXP_0_0, REGION11_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR11_U_SMXP_0_0, REGION11_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR12_U_SMXP_0_0, 0x3d0d0)
    FIELD(POR_MPU_M0_PRBAR12_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR12_U_SMXP_0_0, REGION12_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR12_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR12_U_SMXP_0_0, REGION12_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR12_U_SMXP_0_0, REGION12_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR12_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR12_U_SMXP_0_0, 0x3d0d8)
    FIELD(POR_MPU_M0_PRLAR12_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR12_U_SMXP_0_0, REGION12_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR12_U_SMXP_0_0, REGION12_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR13_U_SMXP_0_0, 0x3d0e0)
    FIELD(POR_MPU_M0_PRBAR13_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR13_U_SMXP_0_0, REGION13_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR13_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR13_U_SMXP_0_0, REGION13_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR13_U_SMXP_0_0, REGION13_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR13_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR13_U_SMXP_0_0, 0x3d0e8)
    FIELD(POR_MPU_M0_PRLAR13_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR13_U_SMXP_0_0, REGION13_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR13_U_SMXP_0_0, REGION13_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR14_U_SMXP_0_0, 0x3d0f0)
    FIELD(POR_MPU_M0_PRBAR14_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR14_U_SMXP_0_0, REGION14_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR14_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR14_U_SMXP_0_0, REGION14_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR14_U_SMXP_0_0, REGION14_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR14_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR14_U_SMXP_0_0, 0x3d0f8)
    FIELD(POR_MPU_M0_PRLAR14_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR14_U_SMXP_0_0, REGION14_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR14_U_SMXP_0_0, REGION14_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR15_U_SMXP_0_0, 0x3d100)
    FIELD(POR_MPU_M0_PRBAR15_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR15_U_SMXP_0_0, REGION15_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR15_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR15_U_SMXP_0_0, REGION15_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR15_U_SMXP_0_0, REGION15_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR15_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR15_U_SMXP_0_0, 0x3d108)
    FIELD(POR_MPU_M0_PRLAR15_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR15_U_SMXP_0_0, REGION15_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR15_U_SMXP_0_0, REGION15_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR16_U_SMXP_0_0, 0x3d110)
    FIELD(POR_MPU_M0_PRBAR16_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR16_U_SMXP_0_0, REGION16_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR16_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR16_U_SMXP_0_0, REGION16_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR16_U_SMXP_0_0, REGION16_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR16_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR16_U_SMXP_0_0, 0x3d118)
    FIELD(POR_MPU_M0_PRLAR16_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR16_U_SMXP_0_0, REGION16_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR16_U_SMXP_0_0, REGION16_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR17_U_SMXP_0_0, 0x3d120)
    FIELD(POR_MPU_M0_PRBAR17_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR17_U_SMXP_0_0, REGION17_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR17_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR17_U_SMXP_0_0, REGION17_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR17_U_SMXP_0_0, REGION17_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR17_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR17_U_SMXP_0_0, 0x3d128)
    FIELD(POR_MPU_M0_PRLAR17_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR17_U_SMXP_0_0, REGION17_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR17_U_SMXP_0_0, REGION17_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR18_U_SMXP_0_0, 0x3d130)
    FIELD(POR_MPU_M0_PRBAR18_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR18_U_SMXP_0_0, REGION18_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR18_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR18_U_SMXP_0_0, REGION18_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR18_U_SMXP_0_0, REGION18_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR18_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR18_U_SMXP_0_0, 0x3d138)
    FIELD(POR_MPU_M0_PRLAR18_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR18_U_SMXP_0_0, REGION18_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR18_U_SMXP_0_0, REGION18_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR19_U_SMXP_0_0, 0x3d140)
    FIELD(POR_MPU_M0_PRBAR19_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR19_U_SMXP_0_0, REGION19_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR19_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR19_U_SMXP_0_0, REGION19_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR19_U_SMXP_0_0, REGION19_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR19_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR19_U_SMXP_0_0, 0x3d148)
    FIELD(POR_MPU_M0_PRLAR19_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR19_U_SMXP_0_0, REGION19_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR19_U_SMXP_0_0, REGION19_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR20_U_SMXP_0_0, 0x3d150)
    FIELD(POR_MPU_M0_PRBAR20_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR20_U_SMXP_0_0, REGION20_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR20_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR20_U_SMXP_0_0, REGION20_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR20_U_SMXP_0_0, REGION20_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR20_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR20_U_SMXP_0_0, 0x3d158)
    FIELD(POR_MPU_M0_PRLAR20_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR20_U_SMXP_0_0, REGION20_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR20_U_SMXP_0_0, REGION20_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR21_U_SMXP_0_0, 0x3d160)
    FIELD(POR_MPU_M0_PRBAR21_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR21_U_SMXP_0_0, REGION21_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR21_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR21_U_SMXP_0_0, REGION21_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR21_U_SMXP_0_0, REGION21_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR21_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR21_U_SMXP_0_0, 0x3d168)
    FIELD(POR_MPU_M0_PRLAR21_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR21_U_SMXP_0_0, REGION21_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR21_U_SMXP_0_0, REGION21_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR22_U_SMXP_0_0, 0x3d170)
    FIELD(POR_MPU_M0_PRBAR22_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR22_U_SMXP_0_0, REGION22_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR22_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR22_U_SMXP_0_0, REGION22_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR22_U_SMXP_0_0, REGION22_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR22_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR22_U_SMXP_0_0, 0x3d178)
    FIELD(POR_MPU_M0_PRLAR22_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR22_U_SMXP_0_0, REGION22_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR22_U_SMXP_0_0, REGION22_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR23_U_SMXP_0_0, 0x3d180)
    FIELD(POR_MPU_M0_PRBAR23_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR23_U_SMXP_0_0, REGION23_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR23_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR23_U_SMXP_0_0, REGION23_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR23_U_SMXP_0_0, REGION23_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR23_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR23_U_SMXP_0_0, 0x3d188)
    FIELD(POR_MPU_M0_PRLAR23_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR23_U_SMXP_0_0, REGION23_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR23_U_SMXP_0_0, REGION23_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR24_U_SMXP_0_0, 0x3d190)
    FIELD(POR_MPU_M0_PRBAR24_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR24_U_SMXP_0_0, REGION24_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR24_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR24_U_SMXP_0_0, REGION24_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR24_U_SMXP_0_0, REGION24_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR24_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR24_U_SMXP_0_0, 0x3d198)
    FIELD(POR_MPU_M0_PRLAR24_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR24_U_SMXP_0_0, REGION24_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR24_U_SMXP_0_0, REGION24_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR25_U_SMXP_0_0, 0x3d1a0)
    FIELD(POR_MPU_M0_PRBAR25_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR25_U_SMXP_0_0, REGION25_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR25_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR25_U_SMXP_0_0, REGION25_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR25_U_SMXP_0_0, REGION25_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR25_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR25_U_SMXP_0_0, 0x3d1a8)
    FIELD(POR_MPU_M0_PRLAR25_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR25_U_SMXP_0_0, REGION25_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR25_U_SMXP_0_0, REGION25_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR26_U_SMXP_0_0, 0x3d1b0)
    FIELD(POR_MPU_M0_PRBAR26_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR26_U_SMXP_0_0, REGION26_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR26_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR26_U_SMXP_0_0, REGION26_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR26_U_SMXP_0_0, REGION26_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR26_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR26_U_SMXP_0_0, 0x3d1b8)
    FIELD(POR_MPU_M0_PRLAR26_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR26_U_SMXP_0_0, REGION26_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR26_U_SMXP_0_0, REGION26_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR27_U_SMXP_0_0, 0x3d1c0)
    FIELD(POR_MPU_M0_PRBAR27_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR27_U_SMXP_0_0, REGION27_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR27_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR27_U_SMXP_0_0, REGION27_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR27_U_SMXP_0_0, REGION27_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR27_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR27_U_SMXP_0_0, 0x3d1c8)
    FIELD(POR_MPU_M0_PRLAR27_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR27_U_SMXP_0_0, REGION27_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR27_U_SMXP_0_0, REGION27_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR28_U_SMXP_0_0, 0x3d1d0)
    FIELD(POR_MPU_M0_PRBAR28_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR28_U_SMXP_0_0, REGION28_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR28_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR28_U_SMXP_0_0, REGION28_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR28_U_SMXP_0_0, REGION28_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR28_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR28_U_SMXP_0_0, 0x3d1d8)
    FIELD(POR_MPU_M0_PRLAR28_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR28_U_SMXP_0_0, REGION28_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR28_U_SMXP_0_0, REGION28_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR29_U_SMXP_0_0, 0x3d1e0)
    FIELD(POR_MPU_M0_PRBAR29_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR29_U_SMXP_0_0, REGION29_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR29_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR29_U_SMXP_0_0, REGION29_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR29_U_SMXP_0_0, REGION29_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR29_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR29_U_SMXP_0_0, 0x3d1e8)
    FIELD(POR_MPU_M0_PRLAR29_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR29_U_SMXP_0_0, REGION29_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR29_U_SMXP_0_0, REGION29_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR30_U_SMXP_0_0, 0x3d1f0)
    FIELD(POR_MPU_M0_PRBAR30_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR30_U_SMXP_0_0, REGION30_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR30_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR30_U_SMXP_0_0, REGION30_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR30_U_SMXP_0_0, REGION30_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR30_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR30_U_SMXP_0_0, 0x3d1f8)
    FIELD(POR_MPU_M0_PRLAR30_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR30_U_SMXP_0_0, REGION30_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR30_U_SMXP_0_0, REGION30_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR31_U_SMXP_0_0, 0x3d200)
    FIELD(POR_MPU_M0_PRBAR31_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR31_U_SMXP_0_0, REGION31_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR31_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR31_U_SMXP_0_0, REGION31_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR31_U_SMXP_0_0, REGION31_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR31_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR31_U_SMXP_0_0, 0x3d208)
    FIELD(POR_MPU_M0_PRLAR31_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR31_U_SMXP_0_0, REGION31_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR31_U_SMXP_0_0, REGION31_EN, 0, 1)
REG32(POR_MPU_M1_CTL_U_SMXP_0_0, 0x3d400)
    FIELD(POR_MPU_M1_CTL_U_SMXP_0_0, M1_EN, 2, 1)
    FIELD(POR_MPU_M1_CTL_U_SMXP_0_0, M1_ACTION, 0, 2)
REG32(POR_MPU_M1_PRBAR0_U_SMXP_0_0, 0x3d410)
    FIELD(POR_MPU_M1_PRBAR0_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR0_U_SMXP_0_0, REGION0_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR0_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR0_U_SMXP_0_0, REGION0_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR0_U_SMXP_0_0, REGION0_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR0_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR0_U_SMXP_0_0, 0x3d418)
    FIELD(POR_MPU_M1_PRLAR0_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR0_U_SMXP_0_0, REGION0_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR0_U_SMXP_0_0, REGION0_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR1_U_SMXP_0_0, 0x3d420)
    FIELD(POR_MPU_M1_PRBAR1_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR1_U_SMXP_0_0, REGION1_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR1_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR1_U_SMXP_0_0, REGION1_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR1_U_SMXP_0_0, REGION1_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR1_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR1_U_SMXP_0_0, 0x3d428)
    FIELD(POR_MPU_M1_PRLAR1_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR1_U_SMXP_0_0, REGION1_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR1_U_SMXP_0_0, REGION1_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR2_U_SMXP_0_0, 0x3d430)
    FIELD(POR_MPU_M1_PRBAR2_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR2_U_SMXP_0_0, REGION2_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR2_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR2_U_SMXP_0_0, REGION2_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR2_U_SMXP_0_0, REGION2_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR2_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR2_U_SMXP_0_0, 0x3d438)
    FIELD(POR_MPU_M1_PRLAR2_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR2_U_SMXP_0_0, REGION2_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR2_U_SMXP_0_0, REGION2_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR3_U_SMXP_0_0, 0x3d440)
    FIELD(POR_MPU_M1_PRBAR3_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR3_U_SMXP_0_0, REGION3_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR3_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR3_U_SMXP_0_0, REGION3_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR3_U_SMXP_0_0, REGION3_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR3_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR3_U_SMXP_0_0, 0x3d448)
    FIELD(POR_MPU_M1_PRLAR3_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR3_U_SMXP_0_0, REGION3_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR3_U_SMXP_0_0, REGION3_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR4_U_SMXP_0_0, 0x3d450)
    FIELD(POR_MPU_M1_PRBAR4_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR4_U_SMXP_0_0, REGION4_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR4_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR4_U_SMXP_0_0, REGION4_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR4_U_SMXP_0_0, REGION4_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR4_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR4_U_SMXP_0_0, 0x3d458)
    FIELD(POR_MPU_M1_PRLAR4_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR4_U_SMXP_0_0, REGION4_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR4_U_SMXP_0_0, REGION4_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR5_U_SMXP_0_0, 0x3d460)
    FIELD(POR_MPU_M1_PRBAR5_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR5_U_SMXP_0_0, REGION5_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR5_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR5_U_SMXP_0_0, REGION5_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR5_U_SMXP_0_0, REGION5_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR5_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR5_U_SMXP_0_0, 0x3d468)
    FIELD(POR_MPU_M1_PRLAR5_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR5_U_SMXP_0_0, REGION5_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR5_U_SMXP_0_0, REGION5_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR6_U_SMXP_0_0, 0x3d470)
    FIELD(POR_MPU_M1_PRBAR6_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR6_U_SMXP_0_0, REGION6_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR6_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR6_U_SMXP_0_0, REGION6_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR6_U_SMXP_0_0, REGION6_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR6_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR6_U_SMXP_0_0, 0x3d478)
    FIELD(POR_MPU_M1_PRLAR6_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR6_U_SMXP_0_0, REGION6_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR6_U_SMXP_0_0, REGION6_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR7_U_SMXP_0_0, 0x3d480)
    FIELD(POR_MPU_M1_PRBAR7_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR7_U_SMXP_0_0, REGION7_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR7_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR7_U_SMXP_0_0, REGION7_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR7_U_SMXP_0_0, REGION7_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR7_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR7_U_SMXP_0_0, 0x3d488)
    FIELD(POR_MPU_M1_PRLAR7_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR7_U_SMXP_0_0, REGION7_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR7_U_SMXP_0_0, REGION7_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR8_U_SMXP_0_0, 0x3d490)
    FIELD(POR_MPU_M1_PRBAR8_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR8_U_SMXP_0_0, REGION8_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR8_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR8_U_SMXP_0_0, REGION8_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR8_U_SMXP_0_0, REGION8_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR8_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR8_U_SMXP_0_0, 0x3d498)
    FIELD(POR_MPU_M1_PRLAR8_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR8_U_SMXP_0_0, REGION8_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR8_U_SMXP_0_0, REGION8_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR9_U_SMXP_0_0, 0x3d4a0)
    FIELD(POR_MPU_M1_PRBAR9_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR9_U_SMXP_0_0, REGION9_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR9_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR9_U_SMXP_0_0, REGION9_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR9_U_SMXP_0_0, REGION9_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR9_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR9_U_SMXP_0_0, 0x3d4a8)
    FIELD(POR_MPU_M1_PRLAR9_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR9_U_SMXP_0_0, REGION9_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR9_U_SMXP_0_0, REGION9_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR10_U_SMXP_0_0, 0x3d4b0)
    FIELD(POR_MPU_M1_PRBAR10_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR10_U_SMXP_0_0, REGION10_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR10_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR10_U_SMXP_0_0, REGION10_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR10_U_SMXP_0_0, REGION10_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR10_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR10_U_SMXP_0_0, 0x3d4b8)
    FIELD(POR_MPU_M1_PRLAR10_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR10_U_SMXP_0_0, REGION10_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR10_U_SMXP_0_0, REGION10_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR11_U_SMXP_0_0, 0x3d4c0)
    FIELD(POR_MPU_M1_PRBAR11_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR11_U_SMXP_0_0, REGION11_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR11_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR11_U_SMXP_0_0, REGION11_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR11_U_SMXP_0_0, REGION11_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR11_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR11_U_SMXP_0_0, 0x3d4c8)
    FIELD(POR_MPU_M1_PRLAR11_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR11_U_SMXP_0_0, REGION11_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR11_U_SMXP_0_0, REGION11_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR12_U_SMXP_0_0, 0x3d4d0)
    FIELD(POR_MPU_M1_PRBAR12_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR12_U_SMXP_0_0, REGION12_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR12_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR12_U_SMXP_0_0, REGION12_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR12_U_SMXP_0_0, REGION12_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR12_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR12_U_SMXP_0_0, 0x3d4d8)
    FIELD(POR_MPU_M1_PRLAR12_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR12_U_SMXP_0_0, REGION12_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR12_U_SMXP_0_0, REGION12_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR13_U_SMXP_0_0, 0x3d4e0)
    FIELD(POR_MPU_M1_PRBAR13_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR13_U_SMXP_0_0, REGION13_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR13_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR13_U_SMXP_0_0, REGION13_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR13_U_SMXP_0_0, REGION13_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR13_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR13_U_SMXP_0_0, 0x3d4e8)
    FIELD(POR_MPU_M1_PRLAR13_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR13_U_SMXP_0_0, REGION13_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR13_U_SMXP_0_0, REGION13_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR14_U_SMXP_0_0, 0x3d4f0)
    FIELD(POR_MPU_M1_PRBAR14_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR14_U_SMXP_0_0, REGION14_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR14_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR14_U_SMXP_0_0, REGION14_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR14_U_SMXP_0_0, REGION14_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR14_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR14_U_SMXP_0_0, 0x3d4f8)
    FIELD(POR_MPU_M1_PRLAR14_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR14_U_SMXP_0_0, REGION14_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR14_U_SMXP_0_0, REGION14_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR15_U_SMXP_0_0, 0x3d500)
    FIELD(POR_MPU_M1_PRBAR15_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR15_U_SMXP_0_0, REGION15_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR15_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR15_U_SMXP_0_0, REGION15_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR15_U_SMXP_0_0, REGION15_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR15_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR15_U_SMXP_0_0, 0x3d508)
    FIELD(POR_MPU_M1_PRLAR15_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR15_U_SMXP_0_0, REGION15_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR15_U_SMXP_0_0, REGION15_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR16_U_SMXP_0_0, 0x3d510)
    FIELD(POR_MPU_M1_PRBAR16_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR16_U_SMXP_0_0, REGION16_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR16_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR16_U_SMXP_0_0, REGION16_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR16_U_SMXP_0_0, REGION16_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR16_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR16_U_SMXP_0_0, 0x3d518)
    FIELD(POR_MPU_M1_PRLAR16_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR16_U_SMXP_0_0, REGION16_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR16_U_SMXP_0_0, REGION16_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR17_U_SMXP_0_0, 0x3d520)
    FIELD(POR_MPU_M1_PRBAR17_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR17_U_SMXP_0_0, REGION17_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR17_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR17_U_SMXP_0_0, REGION17_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR17_U_SMXP_0_0, REGION17_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR17_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR17_U_SMXP_0_0, 0x3d528)
    FIELD(POR_MPU_M1_PRLAR17_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR17_U_SMXP_0_0, REGION17_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR17_U_SMXP_0_0, REGION17_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR18_U_SMXP_0_0, 0x3d530)
    FIELD(POR_MPU_M1_PRBAR18_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR18_U_SMXP_0_0, REGION18_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR18_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR18_U_SMXP_0_0, REGION18_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR18_U_SMXP_0_0, REGION18_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR18_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR18_U_SMXP_0_0, 0x3d538)
    FIELD(POR_MPU_M1_PRLAR18_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR18_U_SMXP_0_0, REGION18_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR18_U_SMXP_0_0, REGION18_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR19_U_SMXP_0_0, 0x3d540)
    FIELD(POR_MPU_M1_PRBAR19_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR19_U_SMXP_0_0, REGION19_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR19_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR19_U_SMXP_0_0, REGION19_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR19_U_SMXP_0_0, REGION19_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR19_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR19_U_SMXP_0_0, 0x3d548)
    FIELD(POR_MPU_M1_PRLAR19_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR19_U_SMXP_0_0, REGION19_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR19_U_SMXP_0_0, REGION19_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR20_U_SMXP_0_0, 0x3d550)
    FIELD(POR_MPU_M1_PRBAR20_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR20_U_SMXP_0_0, REGION20_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR20_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR20_U_SMXP_0_0, REGION20_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR20_U_SMXP_0_0, REGION20_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR20_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR20_U_SMXP_0_0, 0x3d558)
    FIELD(POR_MPU_M1_PRLAR20_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR20_U_SMXP_0_0, REGION20_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR20_U_SMXP_0_0, REGION20_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR21_U_SMXP_0_0, 0x3d560)
    FIELD(POR_MPU_M1_PRBAR21_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR21_U_SMXP_0_0, REGION21_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR21_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR21_U_SMXP_0_0, REGION21_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR21_U_SMXP_0_0, REGION21_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR21_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR21_U_SMXP_0_0, 0x3d568)
    FIELD(POR_MPU_M1_PRLAR21_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR21_U_SMXP_0_0, REGION21_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR21_U_SMXP_0_0, REGION21_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR22_U_SMXP_0_0, 0x3d570)
    FIELD(POR_MPU_M1_PRBAR22_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR22_U_SMXP_0_0, REGION22_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR22_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR22_U_SMXP_0_0, REGION22_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR22_U_SMXP_0_0, REGION22_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR22_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR22_U_SMXP_0_0, 0x3d578)
    FIELD(POR_MPU_M1_PRLAR22_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR22_U_SMXP_0_0, REGION22_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR22_U_SMXP_0_0, REGION22_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR23_U_SMXP_0_0, 0x3d580)
    FIELD(POR_MPU_M1_PRBAR23_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR23_U_SMXP_0_0, REGION23_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR23_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR23_U_SMXP_0_0, REGION23_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR23_U_SMXP_0_0, REGION23_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR23_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR23_U_SMXP_0_0, 0x3d588)
    FIELD(POR_MPU_M1_PRLAR23_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR23_U_SMXP_0_0, REGION23_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR23_U_SMXP_0_0, REGION23_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR24_U_SMXP_0_0, 0x3d590)
    FIELD(POR_MPU_M1_PRBAR24_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR24_U_SMXP_0_0, REGION24_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR24_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR24_U_SMXP_0_0, REGION24_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR24_U_SMXP_0_0, REGION24_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR24_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR24_U_SMXP_0_0, 0x3d598)
    FIELD(POR_MPU_M1_PRLAR24_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR24_U_SMXP_0_0, REGION24_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR24_U_SMXP_0_0, REGION24_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR25_U_SMXP_0_0, 0x3d5a0)
    FIELD(POR_MPU_M1_PRBAR25_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR25_U_SMXP_0_0, REGION25_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR25_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR25_U_SMXP_0_0, REGION25_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR25_U_SMXP_0_0, REGION25_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR25_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR25_U_SMXP_0_0, 0x3d5a8)
    FIELD(POR_MPU_M1_PRLAR25_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR25_U_SMXP_0_0, REGION25_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR25_U_SMXP_0_0, REGION25_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR26_U_SMXP_0_0, 0x3d5b0)
    FIELD(POR_MPU_M1_PRBAR26_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR26_U_SMXP_0_0, REGION26_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR26_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR26_U_SMXP_0_0, REGION26_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR26_U_SMXP_0_0, REGION26_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR26_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR26_U_SMXP_0_0, 0x3d5b8)
    FIELD(POR_MPU_M1_PRLAR26_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR26_U_SMXP_0_0, REGION26_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR26_U_SMXP_0_0, REGION26_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR27_U_SMXP_0_0, 0x3d5c0)
    FIELD(POR_MPU_M1_PRBAR27_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR27_U_SMXP_0_0, REGION27_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR27_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR27_U_SMXP_0_0, REGION27_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR27_U_SMXP_0_0, REGION27_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR27_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR27_U_SMXP_0_0, 0x3d5c8)
    FIELD(POR_MPU_M1_PRLAR27_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR27_U_SMXP_0_0, REGION27_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR27_U_SMXP_0_0, REGION27_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR28_U_SMXP_0_0, 0x3d5d0)
    FIELD(POR_MPU_M1_PRBAR28_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR28_U_SMXP_0_0, REGION28_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR28_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR28_U_SMXP_0_0, REGION28_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR28_U_SMXP_0_0, REGION28_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR28_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR28_U_SMXP_0_0, 0x3d5d8)
    FIELD(POR_MPU_M1_PRLAR28_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR28_U_SMXP_0_0, REGION28_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR28_U_SMXP_0_0, REGION28_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR29_U_SMXP_0_0, 0x3d5e0)
    FIELD(POR_MPU_M1_PRBAR29_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR29_U_SMXP_0_0, REGION29_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR29_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR29_U_SMXP_0_0, REGION29_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR29_U_SMXP_0_0, REGION29_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR29_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR29_U_SMXP_0_0, 0x3d5e8)
    FIELD(POR_MPU_M1_PRLAR29_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR29_U_SMXP_0_0, REGION29_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR29_U_SMXP_0_0, REGION29_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR30_U_SMXP_0_0, 0x3d5f0)
    FIELD(POR_MPU_M1_PRBAR30_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR30_U_SMXP_0_0, REGION30_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR30_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR30_U_SMXP_0_0, REGION30_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR30_U_SMXP_0_0, REGION30_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR30_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR30_U_SMXP_0_0, 0x3d5f8)
    FIELD(POR_MPU_M1_PRLAR30_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR30_U_SMXP_0_0, REGION30_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR30_U_SMXP_0_0, REGION30_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR31_U_SMXP_0_0, 0x3d600)
    FIELD(POR_MPU_M1_PRBAR31_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR31_U_SMXP_0_0, REGION31_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR31_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR31_U_SMXP_0_0, REGION31_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR31_U_SMXP_0_0, REGION31_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR31_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR31_U_SMXP_0_0, 0x3d608)
    FIELD(POR_MPU_M1_PRLAR31_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR31_U_SMXP_0_0, REGION31_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR31_U_SMXP_0_0, REGION31_EN, 0, 1)
REG32(POR_MPU_M2_CTL_U_SMXP_0_0, 0x3d800)
    FIELD(POR_MPU_M2_CTL_U_SMXP_0_0, M2_EN, 2, 1)
    FIELD(POR_MPU_M2_CTL_U_SMXP_0_0, M2_ACTION, 0, 2)
REG32(POR_MPU_M2_PRBAR0_U_SMXP_0_0, 0x3d810)
    FIELD(POR_MPU_M2_PRBAR0_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR0_U_SMXP_0_0, REGION0_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR0_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR0_U_SMXP_0_0, REGION0_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR0_U_SMXP_0_0, REGION0_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR0_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR0_U_SMXP_0_0, 0x3d818)
    FIELD(POR_MPU_M2_PRLAR0_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR0_U_SMXP_0_0, REGION0_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR0_U_SMXP_0_0, REGION0_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR1_U_SMXP_0_0, 0x3d820)
    FIELD(POR_MPU_M2_PRBAR1_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR1_U_SMXP_0_0, REGION1_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR1_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR1_U_SMXP_0_0, REGION1_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR1_U_SMXP_0_0, REGION1_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR1_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR1_U_SMXP_0_0, 0x3d828)
    FIELD(POR_MPU_M2_PRLAR1_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR1_U_SMXP_0_0, REGION1_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR1_U_SMXP_0_0, REGION1_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR2_U_SMXP_0_0, 0x3d830)
    FIELD(POR_MPU_M2_PRBAR2_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR2_U_SMXP_0_0, REGION2_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR2_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR2_U_SMXP_0_0, REGION2_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR2_U_SMXP_0_0, REGION2_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR2_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR2_U_SMXP_0_0, 0x3d838)
    FIELD(POR_MPU_M2_PRLAR2_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR2_U_SMXP_0_0, REGION2_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR2_U_SMXP_0_0, REGION2_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR3_U_SMXP_0_0, 0x3d840)
    FIELD(POR_MPU_M2_PRBAR3_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR3_U_SMXP_0_0, REGION3_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR3_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR3_U_SMXP_0_0, REGION3_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR3_U_SMXP_0_0, REGION3_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR3_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR3_U_SMXP_0_0, 0x3d848)
    FIELD(POR_MPU_M2_PRLAR3_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR3_U_SMXP_0_0, REGION3_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR3_U_SMXP_0_0, REGION3_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR4_U_SMXP_0_0, 0x3d850)
    FIELD(POR_MPU_M2_PRBAR4_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR4_U_SMXP_0_0, REGION4_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR4_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR4_U_SMXP_0_0, REGION4_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR4_U_SMXP_0_0, REGION4_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR4_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR4_U_SMXP_0_0, 0x3d858)
    FIELD(POR_MPU_M2_PRLAR4_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR4_U_SMXP_0_0, REGION4_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR4_U_SMXP_0_0, REGION4_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR5_U_SMXP_0_0, 0x3d860)
    FIELD(POR_MPU_M2_PRBAR5_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR5_U_SMXP_0_0, REGION5_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR5_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR5_U_SMXP_0_0, REGION5_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR5_U_SMXP_0_0, REGION5_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR5_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR5_U_SMXP_0_0, 0x3d868)
    FIELD(POR_MPU_M2_PRLAR5_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR5_U_SMXP_0_0, REGION5_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR5_U_SMXP_0_0, REGION5_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR6_U_SMXP_0_0, 0x3d870)
    FIELD(POR_MPU_M2_PRBAR6_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR6_U_SMXP_0_0, REGION6_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR6_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR6_U_SMXP_0_0, REGION6_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR6_U_SMXP_0_0, REGION6_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR6_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR6_U_SMXP_0_0, 0x3d878)
    FIELD(POR_MPU_M2_PRLAR6_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR6_U_SMXP_0_0, REGION6_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR6_U_SMXP_0_0, REGION6_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR7_U_SMXP_0_0, 0x3d880)
    FIELD(POR_MPU_M2_PRBAR7_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR7_U_SMXP_0_0, REGION7_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR7_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR7_U_SMXP_0_0, REGION7_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR7_U_SMXP_0_0, REGION7_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR7_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR7_U_SMXP_0_0, 0x3d888)
    FIELD(POR_MPU_M2_PRLAR7_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR7_U_SMXP_0_0, REGION7_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR7_U_SMXP_0_0, REGION7_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR8_U_SMXP_0_0, 0x3d890)
    FIELD(POR_MPU_M2_PRBAR8_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR8_U_SMXP_0_0, REGION8_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR8_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR8_U_SMXP_0_0, REGION8_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR8_U_SMXP_0_0, REGION8_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR8_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR8_U_SMXP_0_0, 0x3d898)
    FIELD(POR_MPU_M2_PRLAR8_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR8_U_SMXP_0_0, REGION8_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR8_U_SMXP_0_0, REGION8_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR9_U_SMXP_0_0, 0x3d8a0)
    FIELD(POR_MPU_M2_PRBAR9_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR9_U_SMXP_0_0, REGION9_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR9_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR9_U_SMXP_0_0, REGION9_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR9_U_SMXP_0_0, REGION9_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR9_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR9_U_SMXP_0_0, 0x3d8a8)
    FIELD(POR_MPU_M2_PRLAR9_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR9_U_SMXP_0_0, REGION9_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR9_U_SMXP_0_0, REGION9_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR10_U_SMXP_0_0, 0x3d8b0)
    FIELD(POR_MPU_M2_PRBAR10_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR10_U_SMXP_0_0, REGION10_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR10_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR10_U_SMXP_0_0, REGION10_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR10_U_SMXP_0_0, REGION10_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR10_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR10_U_SMXP_0_0, 0x3d8b8)
    FIELD(POR_MPU_M2_PRLAR10_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR10_U_SMXP_0_0, REGION10_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR10_U_SMXP_0_0, REGION10_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR11_U_SMXP_0_0, 0x3d8c0)
    FIELD(POR_MPU_M2_PRBAR11_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR11_U_SMXP_0_0, REGION11_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR11_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR11_U_SMXP_0_0, REGION11_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR11_U_SMXP_0_0, REGION11_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR11_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR11_U_SMXP_0_0, 0x3d8c8)
    FIELD(POR_MPU_M2_PRLAR11_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR11_U_SMXP_0_0, REGION11_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR11_U_SMXP_0_0, REGION11_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR12_U_SMXP_0_0, 0x3d8d0)
    FIELD(POR_MPU_M2_PRBAR12_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR12_U_SMXP_0_0, REGION12_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR12_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR12_U_SMXP_0_0, REGION12_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR12_U_SMXP_0_0, REGION12_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR12_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR12_U_SMXP_0_0, 0x3d8d8)
    FIELD(POR_MPU_M2_PRLAR12_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR12_U_SMXP_0_0, REGION12_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR12_U_SMXP_0_0, REGION12_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR13_U_SMXP_0_0, 0x3d8e0)
    FIELD(POR_MPU_M2_PRBAR13_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR13_U_SMXP_0_0, REGION13_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR13_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR13_U_SMXP_0_0, REGION13_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR13_U_SMXP_0_0, REGION13_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR13_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR13_U_SMXP_0_0, 0x3d8e8)
    FIELD(POR_MPU_M2_PRLAR13_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR13_U_SMXP_0_0, REGION13_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR13_U_SMXP_0_0, REGION13_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR14_U_SMXP_0_0, 0x3d8f0)
    FIELD(POR_MPU_M2_PRBAR14_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR14_U_SMXP_0_0, REGION14_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR14_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR14_U_SMXP_0_0, REGION14_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR14_U_SMXP_0_0, REGION14_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR14_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR14_U_SMXP_0_0, 0x3d8f8)
    FIELD(POR_MPU_M2_PRLAR14_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR14_U_SMXP_0_0, REGION14_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR14_U_SMXP_0_0, REGION14_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR15_U_SMXP_0_0, 0x3d900)
    FIELD(POR_MPU_M2_PRBAR15_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR15_U_SMXP_0_0, REGION15_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR15_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR15_U_SMXP_0_0, REGION15_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR15_U_SMXP_0_0, REGION15_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR15_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR15_U_SMXP_0_0, 0x3d908)
    FIELD(POR_MPU_M2_PRLAR15_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR15_U_SMXP_0_0, REGION15_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR15_U_SMXP_0_0, REGION15_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR16_U_SMXP_0_0, 0x3d910)
    FIELD(POR_MPU_M2_PRBAR16_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR16_U_SMXP_0_0, REGION16_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR16_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR16_U_SMXP_0_0, REGION16_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR16_U_SMXP_0_0, REGION16_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR16_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR16_U_SMXP_0_0, 0x3d918)
    FIELD(POR_MPU_M2_PRLAR16_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR16_U_SMXP_0_0, REGION16_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR16_U_SMXP_0_0, REGION16_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR17_U_SMXP_0_0, 0x3d920)
    FIELD(POR_MPU_M2_PRBAR17_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR17_U_SMXP_0_0, REGION17_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR17_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR17_U_SMXP_0_0, REGION17_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR17_U_SMXP_0_0, REGION17_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR17_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR17_U_SMXP_0_0, 0x3d928)
    FIELD(POR_MPU_M2_PRLAR17_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR17_U_SMXP_0_0, REGION17_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR17_U_SMXP_0_0, REGION17_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR18_U_SMXP_0_0, 0x3d930)
    FIELD(POR_MPU_M2_PRBAR18_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR18_U_SMXP_0_0, REGION18_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR18_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR18_U_SMXP_0_0, REGION18_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR18_U_SMXP_0_0, REGION18_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR18_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR18_U_SMXP_0_0, 0x3d938)
    FIELD(POR_MPU_M2_PRLAR18_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR18_U_SMXP_0_0, REGION18_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR18_U_SMXP_0_0, REGION18_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR19_U_SMXP_0_0, 0x3d940)
    FIELD(POR_MPU_M2_PRBAR19_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR19_U_SMXP_0_0, REGION19_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR19_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR19_U_SMXP_0_0, REGION19_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR19_U_SMXP_0_0, REGION19_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR19_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR19_U_SMXP_0_0, 0x3d948)
    FIELD(POR_MPU_M2_PRLAR19_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR19_U_SMXP_0_0, REGION19_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR19_U_SMXP_0_0, REGION19_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR20_U_SMXP_0_0, 0x3d950)
    FIELD(POR_MPU_M2_PRBAR20_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR20_U_SMXP_0_0, REGION20_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR20_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR20_U_SMXP_0_0, REGION20_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR20_U_SMXP_0_0, REGION20_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR20_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR20_U_SMXP_0_0, 0x3d958)
    FIELD(POR_MPU_M2_PRLAR20_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR20_U_SMXP_0_0, REGION20_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR20_U_SMXP_0_0, REGION20_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR21_U_SMXP_0_0, 0x3d960)
    FIELD(POR_MPU_M2_PRBAR21_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR21_U_SMXP_0_0, REGION21_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR21_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR21_U_SMXP_0_0, REGION21_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR21_U_SMXP_0_0, REGION21_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR21_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR21_U_SMXP_0_0, 0x3d968)
    FIELD(POR_MPU_M2_PRLAR21_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR21_U_SMXP_0_0, REGION21_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR21_U_SMXP_0_0, REGION21_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR22_U_SMXP_0_0, 0x3d970)
    FIELD(POR_MPU_M2_PRBAR22_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR22_U_SMXP_0_0, REGION22_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR22_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR22_U_SMXP_0_0, REGION22_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR22_U_SMXP_0_0, REGION22_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR22_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR22_U_SMXP_0_0, 0x3d978)
    FIELD(POR_MPU_M2_PRLAR22_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR22_U_SMXP_0_0, REGION22_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR22_U_SMXP_0_0, REGION22_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR23_U_SMXP_0_0, 0x3d980)
    FIELD(POR_MPU_M2_PRBAR23_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR23_U_SMXP_0_0, REGION23_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR23_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR23_U_SMXP_0_0, REGION23_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR23_U_SMXP_0_0, REGION23_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR23_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR23_U_SMXP_0_0, 0x3d988)
    FIELD(POR_MPU_M2_PRLAR23_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR23_U_SMXP_0_0, REGION23_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR23_U_SMXP_0_0, REGION23_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR24_U_SMXP_0_0, 0x3d990)
    FIELD(POR_MPU_M2_PRBAR24_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR24_U_SMXP_0_0, REGION24_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR24_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR24_U_SMXP_0_0, REGION24_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR24_U_SMXP_0_0, REGION24_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR24_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR24_U_SMXP_0_0, 0x3d998)
    FIELD(POR_MPU_M2_PRLAR24_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR24_U_SMXP_0_0, REGION24_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR24_U_SMXP_0_0, REGION24_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR25_U_SMXP_0_0, 0x3d9a0)
    FIELD(POR_MPU_M2_PRBAR25_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR25_U_SMXP_0_0, REGION25_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR25_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR25_U_SMXP_0_0, REGION25_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR25_U_SMXP_0_0, REGION25_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR25_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR25_U_SMXP_0_0, 0x3d9a8)
    FIELD(POR_MPU_M2_PRLAR25_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR25_U_SMXP_0_0, REGION25_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR25_U_SMXP_0_0, REGION25_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR26_U_SMXP_0_0, 0x3d9b0)
    FIELD(POR_MPU_M2_PRBAR26_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR26_U_SMXP_0_0, REGION26_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR26_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR26_U_SMXP_0_0, REGION26_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR26_U_SMXP_0_0, REGION26_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR26_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR26_U_SMXP_0_0, 0x3d9b8)
    FIELD(POR_MPU_M2_PRLAR26_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR26_U_SMXP_0_0, REGION26_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR26_U_SMXP_0_0, REGION26_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR27_U_SMXP_0_0, 0x3d9c0)
    FIELD(POR_MPU_M2_PRBAR27_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR27_U_SMXP_0_0, REGION27_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR27_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR27_U_SMXP_0_0, REGION27_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR27_U_SMXP_0_0, REGION27_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR27_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR27_U_SMXP_0_0, 0x3d9c8)
    FIELD(POR_MPU_M2_PRLAR27_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR27_U_SMXP_0_0, REGION27_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR27_U_SMXP_0_0, REGION27_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR28_U_SMXP_0_0, 0x3d9d0)
    FIELD(POR_MPU_M2_PRBAR28_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR28_U_SMXP_0_0, REGION28_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR28_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR28_U_SMXP_0_0, REGION28_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR28_U_SMXP_0_0, REGION28_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR28_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR28_U_SMXP_0_0, 0x3d9d8)
    FIELD(POR_MPU_M2_PRLAR28_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR28_U_SMXP_0_0, REGION28_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR28_U_SMXP_0_0, REGION28_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR29_U_SMXP_0_0, 0x3d9e0)
    FIELD(POR_MPU_M2_PRBAR29_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR29_U_SMXP_0_0, REGION29_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR29_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR29_U_SMXP_0_0, REGION29_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR29_U_SMXP_0_0, REGION29_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR29_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR29_U_SMXP_0_0, 0x3d9e8)
    FIELD(POR_MPU_M2_PRLAR29_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR29_U_SMXP_0_0, REGION29_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR29_U_SMXP_0_0, REGION29_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR30_U_SMXP_0_0, 0x3d9f0)
    FIELD(POR_MPU_M2_PRBAR30_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR30_U_SMXP_0_0, REGION30_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR30_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR30_U_SMXP_0_0, REGION30_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR30_U_SMXP_0_0, REGION30_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR30_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR30_U_SMXP_0_0, 0x3d9f8)
    FIELD(POR_MPU_M2_PRLAR30_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR30_U_SMXP_0_0, REGION30_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR30_U_SMXP_0_0, REGION30_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR31_U_SMXP_0_0, 0x3da00)
    FIELD(POR_MPU_M2_PRBAR31_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR31_U_SMXP_0_0, REGION31_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR31_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR31_U_SMXP_0_0, REGION31_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR31_U_SMXP_0_0, REGION31_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR31_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR31_U_SMXP_0_0, 0x3da08)
    FIELD(POR_MPU_M2_PRLAR31_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR31_U_SMXP_0_0, REGION31_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR31_U_SMXP_0_0, REGION31_EN, 0, 1)
REG32(POR_MPU_M3_CTL_U_SMXP_0_0, 0x3dc00)
    FIELD(POR_MPU_M3_CTL_U_SMXP_0_0, M3_EN, 2, 1)
    FIELD(POR_MPU_M3_CTL_U_SMXP_0_0, M3_ACTION, 0, 2)
REG32(POR_MPU_M3_PRBAR0_U_SMXP_0_0, 0x3dc10)
    FIELD(POR_MPU_M3_PRBAR0_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR0_U_SMXP_0_0, REGION0_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR0_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR0_U_SMXP_0_0, REGION0_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR0_U_SMXP_0_0, REGION0_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR0_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR0_U_SMXP_0_0, 0x3dc18)
    FIELD(POR_MPU_M3_PRLAR0_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR0_U_SMXP_0_0, REGION0_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR0_U_SMXP_0_0, REGION0_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR1_U_SMXP_0_0, 0x3dc20)
    FIELD(POR_MPU_M3_PRBAR1_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR1_U_SMXP_0_0, REGION1_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR1_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR1_U_SMXP_0_0, REGION1_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR1_U_SMXP_0_0, REGION1_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR1_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR1_U_SMXP_0_0, 0x3dc28)
    FIELD(POR_MPU_M3_PRLAR1_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR1_U_SMXP_0_0, REGION1_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR1_U_SMXP_0_0, REGION1_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR2_U_SMXP_0_0, 0x3dc30)
    FIELD(POR_MPU_M3_PRBAR2_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR2_U_SMXP_0_0, REGION2_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR2_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR2_U_SMXP_0_0, REGION2_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR2_U_SMXP_0_0, REGION2_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR2_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR2_U_SMXP_0_0, 0x3dc38)
    FIELD(POR_MPU_M3_PRLAR2_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR2_U_SMXP_0_0, REGION2_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR2_U_SMXP_0_0, REGION2_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR3_U_SMXP_0_0, 0x3dc40)
    FIELD(POR_MPU_M3_PRBAR3_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR3_U_SMXP_0_0, REGION3_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR3_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR3_U_SMXP_0_0, REGION3_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR3_U_SMXP_0_0, REGION3_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR3_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR3_U_SMXP_0_0, 0x3dc48)
    FIELD(POR_MPU_M3_PRLAR3_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR3_U_SMXP_0_0, REGION3_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR3_U_SMXP_0_0, REGION3_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR4_U_SMXP_0_0, 0x3dc50)
    FIELD(POR_MPU_M3_PRBAR4_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR4_U_SMXP_0_0, REGION4_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR4_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR4_U_SMXP_0_0, REGION4_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR4_U_SMXP_0_0, REGION4_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR4_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR4_U_SMXP_0_0, 0x3dc58)
    FIELD(POR_MPU_M3_PRLAR4_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR4_U_SMXP_0_0, REGION4_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR4_U_SMXP_0_0, REGION4_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR5_U_SMXP_0_0, 0x3dc60)
    FIELD(POR_MPU_M3_PRBAR5_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR5_U_SMXP_0_0, REGION5_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR5_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR5_U_SMXP_0_0, REGION5_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR5_U_SMXP_0_0, REGION5_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR5_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR5_U_SMXP_0_0, 0x3dc68)
    FIELD(POR_MPU_M3_PRLAR5_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR5_U_SMXP_0_0, REGION5_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR5_U_SMXP_0_0, REGION5_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR6_U_SMXP_0_0, 0x3dc70)
    FIELD(POR_MPU_M3_PRBAR6_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR6_U_SMXP_0_0, REGION6_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR6_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR6_U_SMXP_0_0, REGION6_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR6_U_SMXP_0_0, REGION6_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR6_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR6_U_SMXP_0_0, 0x3dc78)
    FIELD(POR_MPU_M3_PRLAR6_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR6_U_SMXP_0_0, REGION6_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR6_U_SMXP_0_0, REGION6_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR7_U_SMXP_0_0, 0x3dc80)
    FIELD(POR_MPU_M3_PRBAR7_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR7_U_SMXP_0_0, REGION7_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR7_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR7_U_SMXP_0_0, REGION7_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR7_U_SMXP_0_0, REGION7_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR7_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR7_U_SMXP_0_0, 0x3dc88)
    FIELD(POR_MPU_M3_PRLAR7_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR7_U_SMXP_0_0, REGION7_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR7_U_SMXP_0_0, REGION7_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR8_U_SMXP_0_0, 0x3dc90)
    FIELD(POR_MPU_M3_PRBAR8_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR8_U_SMXP_0_0, REGION8_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR8_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR8_U_SMXP_0_0, REGION8_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR8_U_SMXP_0_0, REGION8_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR8_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR8_U_SMXP_0_0, 0x3dc98)
    FIELD(POR_MPU_M3_PRLAR8_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR8_U_SMXP_0_0, REGION8_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR8_U_SMXP_0_0, REGION8_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR9_U_SMXP_0_0, 0x3dca0)
    FIELD(POR_MPU_M3_PRBAR9_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR9_U_SMXP_0_0, REGION9_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR9_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR9_U_SMXP_0_0, REGION9_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR9_U_SMXP_0_0, REGION9_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR9_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR9_U_SMXP_0_0, 0x3dca8)
    FIELD(POR_MPU_M3_PRLAR9_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR9_U_SMXP_0_0, REGION9_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR9_U_SMXP_0_0, REGION9_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR10_U_SMXP_0_0, 0x3dcb0)
    FIELD(POR_MPU_M3_PRBAR10_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR10_U_SMXP_0_0, REGION10_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR10_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR10_U_SMXP_0_0, REGION10_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR10_U_SMXP_0_0, REGION10_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR10_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR10_U_SMXP_0_0, 0x3dcb8)
    FIELD(POR_MPU_M3_PRLAR10_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR10_U_SMXP_0_0, REGION10_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR10_U_SMXP_0_0, REGION10_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR11_U_SMXP_0_0, 0x3dcc0)
    FIELD(POR_MPU_M3_PRBAR11_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR11_U_SMXP_0_0, REGION11_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR11_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR11_U_SMXP_0_0, REGION11_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR11_U_SMXP_0_0, REGION11_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR11_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR11_U_SMXP_0_0, 0x3dcc8)
    FIELD(POR_MPU_M3_PRLAR11_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR11_U_SMXP_0_0, REGION11_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR11_U_SMXP_0_0, REGION11_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR12_U_SMXP_0_0, 0x3dcd0)
    FIELD(POR_MPU_M3_PRBAR12_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR12_U_SMXP_0_0, REGION12_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR12_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR12_U_SMXP_0_0, REGION12_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR12_U_SMXP_0_0, REGION12_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR12_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR12_U_SMXP_0_0, 0x3dcd8)
    FIELD(POR_MPU_M3_PRLAR12_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR12_U_SMXP_0_0, REGION12_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR12_U_SMXP_0_0, REGION12_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR13_U_SMXP_0_0, 0x3dce0)
    FIELD(POR_MPU_M3_PRBAR13_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR13_U_SMXP_0_0, REGION13_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR13_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR13_U_SMXP_0_0, REGION13_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR13_U_SMXP_0_0, REGION13_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR13_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR13_U_SMXP_0_0, 0x3dce8)
    FIELD(POR_MPU_M3_PRLAR13_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR13_U_SMXP_0_0, REGION13_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR13_U_SMXP_0_0, REGION13_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR14_U_SMXP_0_0, 0x3dcf0)
    FIELD(POR_MPU_M3_PRBAR14_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR14_U_SMXP_0_0, REGION14_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR14_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR14_U_SMXP_0_0, REGION14_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR14_U_SMXP_0_0, REGION14_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR14_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR14_U_SMXP_0_0, 0x3dcf8)
    FIELD(POR_MPU_M3_PRLAR14_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR14_U_SMXP_0_0, REGION14_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR14_U_SMXP_0_0, REGION14_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR15_U_SMXP_0_0, 0x3dd00)
    FIELD(POR_MPU_M3_PRBAR15_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR15_U_SMXP_0_0, REGION15_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR15_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR15_U_SMXP_0_0, REGION15_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR15_U_SMXP_0_0, REGION15_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR15_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR15_U_SMXP_0_0, 0x3dd08)
    FIELD(POR_MPU_M3_PRLAR15_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR15_U_SMXP_0_0, REGION15_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR15_U_SMXP_0_0, REGION15_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR16_U_SMXP_0_0, 0x3dd10)
    FIELD(POR_MPU_M3_PRBAR16_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR16_U_SMXP_0_0, REGION16_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR16_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR16_U_SMXP_0_0, REGION16_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR16_U_SMXP_0_0, REGION16_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR16_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR16_U_SMXP_0_0, 0x3dd18)
    FIELD(POR_MPU_M3_PRLAR16_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR16_U_SMXP_0_0, REGION16_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR16_U_SMXP_0_0, REGION16_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR17_U_SMXP_0_0, 0x3dd20)
    FIELD(POR_MPU_M3_PRBAR17_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR17_U_SMXP_0_0, REGION17_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR17_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR17_U_SMXP_0_0, REGION17_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR17_U_SMXP_0_0, REGION17_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR17_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR17_U_SMXP_0_0, 0x3dd28)
    FIELD(POR_MPU_M3_PRLAR17_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR17_U_SMXP_0_0, REGION17_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR17_U_SMXP_0_0, REGION17_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR18_U_SMXP_0_0, 0x3dd30)
    FIELD(POR_MPU_M3_PRBAR18_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR18_U_SMXP_0_0, REGION18_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR18_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR18_U_SMXP_0_0, REGION18_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR18_U_SMXP_0_0, REGION18_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR18_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR18_U_SMXP_0_0, 0x3dd38)
    FIELD(POR_MPU_M3_PRLAR18_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR18_U_SMXP_0_0, REGION18_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR18_U_SMXP_0_0, REGION18_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR19_U_SMXP_0_0, 0x3dd40)
    FIELD(POR_MPU_M3_PRBAR19_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR19_U_SMXP_0_0, REGION19_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR19_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR19_U_SMXP_0_0, REGION19_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR19_U_SMXP_0_0, REGION19_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR19_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR19_U_SMXP_0_0, 0x3dd48)
    FIELD(POR_MPU_M3_PRLAR19_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR19_U_SMXP_0_0, REGION19_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR19_U_SMXP_0_0, REGION19_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR20_U_SMXP_0_0, 0x3dd50)
    FIELD(POR_MPU_M3_PRBAR20_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR20_U_SMXP_0_0, REGION20_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR20_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR20_U_SMXP_0_0, REGION20_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR20_U_SMXP_0_0, REGION20_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR20_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR20_U_SMXP_0_0, 0x3dd58)
    FIELD(POR_MPU_M3_PRLAR20_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR20_U_SMXP_0_0, REGION20_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR20_U_SMXP_0_0, REGION20_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR21_U_SMXP_0_0, 0x3dd60)
    FIELD(POR_MPU_M3_PRBAR21_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR21_U_SMXP_0_0, REGION21_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR21_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR21_U_SMXP_0_0, REGION21_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR21_U_SMXP_0_0, REGION21_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR21_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR21_U_SMXP_0_0, 0x3dd68)
    FIELD(POR_MPU_M3_PRLAR21_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR21_U_SMXP_0_0, REGION21_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR21_U_SMXP_0_0, REGION21_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR22_U_SMXP_0_0, 0x3dd70)
    FIELD(POR_MPU_M3_PRBAR22_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR22_U_SMXP_0_0, REGION22_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR22_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR22_U_SMXP_0_0, REGION22_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR22_U_SMXP_0_0, REGION22_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR22_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR22_U_SMXP_0_0, 0x3dd78)
    FIELD(POR_MPU_M3_PRLAR22_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR22_U_SMXP_0_0, REGION22_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR22_U_SMXP_0_0, REGION22_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR23_U_SMXP_0_0, 0x3dd80)
    FIELD(POR_MPU_M3_PRBAR23_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR23_U_SMXP_0_0, REGION23_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR23_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR23_U_SMXP_0_0, REGION23_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR23_U_SMXP_0_0, REGION23_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR23_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR23_U_SMXP_0_0, 0x3dd88)
    FIELD(POR_MPU_M3_PRLAR23_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR23_U_SMXP_0_0, REGION23_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR23_U_SMXP_0_0, REGION23_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR24_U_SMXP_0_0, 0x3dd90)
    FIELD(POR_MPU_M3_PRBAR24_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR24_U_SMXP_0_0, REGION24_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR24_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR24_U_SMXP_0_0, REGION24_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR24_U_SMXP_0_0, REGION24_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR24_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR24_U_SMXP_0_0, 0x3dd98)
    FIELD(POR_MPU_M3_PRLAR24_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR24_U_SMXP_0_0, REGION24_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR24_U_SMXP_0_0, REGION24_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR25_U_SMXP_0_0, 0x3dda0)
    FIELD(POR_MPU_M3_PRBAR25_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR25_U_SMXP_0_0, REGION25_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR25_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR25_U_SMXP_0_0, REGION25_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR25_U_SMXP_0_0, REGION25_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR25_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR25_U_SMXP_0_0, 0x3dda8)
    FIELD(POR_MPU_M3_PRLAR25_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR25_U_SMXP_0_0, REGION25_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR25_U_SMXP_0_0, REGION25_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR26_U_SMXP_0_0, 0x3ddb0)
    FIELD(POR_MPU_M3_PRBAR26_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR26_U_SMXP_0_0, REGION26_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR26_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR26_U_SMXP_0_0, REGION26_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR26_U_SMXP_0_0, REGION26_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR26_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR26_U_SMXP_0_0, 0x3ddb8)
    FIELD(POR_MPU_M3_PRLAR26_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR26_U_SMXP_0_0, REGION26_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR26_U_SMXP_0_0, REGION26_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR27_U_SMXP_0_0, 0x3ddc0)
    FIELD(POR_MPU_M3_PRBAR27_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR27_U_SMXP_0_0, REGION27_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR27_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR27_U_SMXP_0_0, REGION27_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR27_U_SMXP_0_0, REGION27_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR27_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR27_U_SMXP_0_0, 0x3ddc8)
    FIELD(POR_MPU_M3_PRLAR27_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR27_U_SMXP_0_0, REGION27_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR27_U_SMXP_0_0, REGION27_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR28_U_SMXP_0_0, 0x3ddd0)
    FIELD(POR_MPU_M3_PRBAR28_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR28_U_SMXP_0_0, REGION28_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR28_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR28_U_SMXP_0_0, REGION28_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR28_U_SMXP_0_0, REGION28_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR28_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR28_U_SMXP_0_0, 0x3ddd8)
    FIELD(POR_MPU_M3_PRLAR28_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR28_U_SMXP_0_0, REGION28_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR28_U_SMXP_0_0, REGION28_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR29_U_SMXP_0_0, 0x3dde0)
    FIELD(POR_MPU_M3_PRBAR29_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR29_U_SMXP_0_0, REGION29_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR29_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR29_U_SMXP_0_0, REGION29_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR29_U_SMXP_0_0, REGION29_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR29_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR29_U_SMXP_0_0, 0x3dde8)
    FIELD(POR_MPU_M3_PRLAR29_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR29_U_SMXP_0_0, REGION29_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR29_U_SMXP_0_0, REGION29_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR30_U_SMXP_0_0, 0x3ddf0)
    FIELD(POR_MPU_M3_PRBAR30_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR30_U_SMXP_0_0, REGION30_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR30_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR30_U_SMXP_0_0, REGION30_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR30_U_SMXP_0_0, REGION30_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR30_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR30_U_SMXP_0_0, 0x3ddf8)
    FIELD(POR_MPU_M3_PRLAR30_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR30_U_SMXP_0_0, REGION30_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR30_U_SMXP_0_0, REGION30_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR31_U_SMXP_0_0, 0x3de00)
    FIELD(POR_MPU_M3_PRBAR31_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR31_U_SMXP_0_0, REGION31_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR31_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR31_U_SMXP_0_0, REGION31_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR31_U_SMXP_0_0, REGION31_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR31_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR31_U_SMXP_0_0, 0x3de08)
    FIELD(POR_MPU_M3_PRLAR31_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR31_U_SMXP_0_0, REGION31_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR31_U_SMXP_0_0, REGION31_EN, 0, 1)
REG32(POR_MPU_M4_CTL_U_SMXP_0_0, 0x3e000)
    FIELD(POR_MPU_M4_CTL_U_SMXP_0_0, M4_EN, 2, 1)
    FIELD(POR_MPU_M4_CTL_U_SMXP_0_0, M4_ACTION, 0, 2)
REG32(POR_MPU_M4_PRBAR0_U_SMXP_0_0, 0x3e010)
    FIELD(POR_MPU_M4_PRBAR0_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR0_U_SMXP_0_0, REGION0_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR0_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR0_U_SMXP_0_0, REGION0_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR0_U_SMXP_0_0, REGION0_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR0_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR0_U_SMXP_0_0, 0x3e018)
    FIELD(POR_MPU_M4_PRLAR0_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR0_U_SMXP_0_0, REGION0_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR0_U_SMXP_0_0, REGION0_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR1_U_SMXP_0_0, 0x3e020)
    FIELD(POR_MPU_M4_PRBAR1_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR1_U_SMXP_0_0, REGION1_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR1_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR1_U_SMXP_0_0, REGION1_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR1_U_SMXP_0_0, REGION1_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR1_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR1_U_SMXP_0_0, 0x3e028)
    FIELD(POR_MPU_M4_PRLAR1_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR1_U_SMXP_0_0, REGION1_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR1_U_SMXP_0_0, REGION1_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR2_U_SMXP_0_0, 0x3e030)
    FIELD(POR_MPU_M4_PRBAR2_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR2_U_SMXP_0_0, REGION2_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR2_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR2_U_SMXP_0_0, REGION2_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR2_U_SMXP_0_0, REGION2_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR2_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR2_U_SMXP_0_0, 0x3e038)
    FIELD(POR_MPU_M4_PRLAR2_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR2_U_SMXP_0_0, REGION2_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR2_U_SMXP_0_0, REGION2_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR3_U_SMXP_0_0, 0x3e040)
    FIELD(POR_MPU_M4_PRBAR3_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR3_U_SMXP_0_0, REGION3_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR3_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR3_U_SMXP_0_0, REGION3_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR3_U_SMXP_0_0, REGION3_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR3_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR3_U_SMXP_0_0, 0x3e048)
    FIELD(POR_MPU_M4_PRLAR3_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR3_U_SMXP_0_0, REGION3_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR3_U_SMXP_0_0, REGION3_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR4_U_SMXP_0_0, 0x3e050)
    FIELD(POR_MPU_M4_PRBAR4_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR4_U_SMXP_0_0, REGION4_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR4_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR4_U_SMXP_0_0, REGION4_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR4_U_SMXP_0_0, REGION4_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR4_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR4_U_SMXP_0_0, 0x3e058)
    FIELD(POR_MPU_M4_PRLAR4_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR4_U_SMXP_0_0, REGION4_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR4_U_SMXP_0_0, REGION4_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR5_U_SMXP_0_0, 0x3e060)
    FIELD(POR_MPU_M4_PRBAR5_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR5_U_SMXP_0_0, REGION5_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR5_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR5_U_SMXP_0_0, REGION5_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR5_U_SMXP_0_0, REGION5_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR5_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR5_U_SMXP_0_0, 0x3e068)
    FIELD(POR_MPU_M4_PRLAR5_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR5_U_SMXP_0_0, REGION5_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR5_U_SMXP_0_0, REGION5_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR6_U_SMXP_0_0, 0x3e070)
    FIELD(POR_MPU_M4_PRBAR6_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR6_U_SMXP_0_0, REGION6_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR6_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR6_U_SMXP_0_0, REGION6_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR6_U_SMXP_0_0, REGION6_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR6_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR6_U_SMXP_0_0, 0x3e078)
    FIELD(POR_MPU_M4_PRLAR6_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR6_U_SMXP_0_0, REGION6_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR6_U_SMXP_0_0, REGION6_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR7_U_SMXP_0_0, 0x3e080)
    FIELD(POR_MPU_M4_PRBAR7_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR7_U_SMXP_0_0, REGION7_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR7_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR7_U_SMXP_0_0, REGION7_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR7_U_SMXP_0_0, REGION7_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR7_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR7_U_SMXP_0_0, 0x3e088)
    FIELD(POR_MPU_M4_PRLAR7_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR7_U_SMXP_0_0, REGION7_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR7_U_SMXP_0_0, REGION7_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR8_U_SMXP_0_0, 0x3e090)
    FIELD(POR_MPU_M4_PRBAR8_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR8_U_SMXP_0_0, REGION8_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR8_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR8_U_SMXP_0_0, REGION8_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR8_U_SMXP_0_0, REGION8_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR8_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR8_U_SMXP_0_0, 0x3e098)
    FIELD(POR_MPU_M4_PRLAR8_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR8_U_SMXP_0_0, REGION8_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR8_U_SMXP_0_0, REGION8_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR9_U_SMXP_0_0, 0x3e0a0)
    FIELD(POR_MPU_M4_PRBAR9_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR9_U_SMXP_0_0, REGION9_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR9_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR9_U_SMXP_0_0, REGION9_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR9_U_SMXP_0_0, REGION9_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR9_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR9_U_SMXP_0_0, 0x3e0a8)
    FIELD(POR_MPU_M4_PRLAR9_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR9_U_SMXP_0_0, REGION9_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR9_U_SMXP_0_0, REGION9_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR10_U_SMXP_0_0, 0x3e0b0)
    FIELD(POR_MPU_M4_PRBAR10_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR10_U_SMXP_0_0, REGION10_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR10_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR10_U_SMXP_0_0, REGION10_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR10_U_SMXP_0_0, REGION10_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR10_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR10_U_SMXP_0_0, 0x3e0b8)
    FIELD(POR_MPU_M4_PRLAR10_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR10_U_SMXP_0_0, REGION10_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR10_U_SMXP_0_0, REGION10_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR11_U_SMXP_0_0, 0x3e0c0)
    FIELD(POR_MPU_M4_PRBAR11_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR11_U_SMXP_0_0, REGION11_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR11_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR11_U_SMXP_0_0, REGION11_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR11_U_SMXP_0_0, REGION11_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR11_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR11_U_SMXP_0_0, 0x3e0c8)
    FIELD(POR_MPU_M4_PRLAR11_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR11_U_SMXP_0_0, REGION11_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR11_U_SMXP_0_0, REGION11_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR12_U_SMXP_0_0, 0x3e0d0)
    FIELD(POR_MPU_M4_PRBAR12_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR12_U_SMXP_0_0, REGION12_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR12_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR12_U_SMXP_0_0, REGION12_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR12_U_SMXP_0_0, REGION12_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR12_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR12_U_SMXP_0_0, 0x3e0d8)
    FIELD(POR_MPU_M4_PRLAR12_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR12_U_SMXP_0_0, REGION12_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR12_U_SMXP_0_0, REGION12_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR13_U_SMXP_0_0, 0x3e0e0)
    FIELD(POR_MPU_M4_PRBAR13_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR13_U_SMXP_0_0, REGION13_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR13_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR13_U_SMXP_0_0, REGION13_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR13_U_SMXP_0_0, REGION13_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR13_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR13_U_SMXP_0_0, 0x3e0e8)
    FIELD(POR_MPU_M4_PRLAR13_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR13_U_SMXP_0_0, REGION13_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR13_U_SMXP_0_0, REGION13_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR14_U_SMXP_0_0, 0x3e0f0)
    FIELD(POR_MPU_M4_PRBAR14_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR14_U_SMXP_0_0, REGION14_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR14_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR14_U_SMXP_0_0, REGION14_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR14_U_SMXP_0_0, REGION14_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR14_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR14_U_SMXP_0_0, 0x3e0f8)
    FIELD(POR_MPU_M4_PRLAR14_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR14_U_SMXP_0_0, REGION14_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR14_U_SMXP_0_0, REGION14_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR15_U_SMXP_0_0, 0x3e100)
    FIELD(POR_MPU_M4_PRBAR15_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR15_U_SMXP_0_0, REGION15_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR15_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR15_U_SMXP_0_0, REGION15_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR15_U_SMXP_0_0, REGION15_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR15_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR15_U_SMXP_0_0, 0x3e108)
    FIELD(POR_MPU_M4_PRLAR15_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR15_U_SMXP_0_0, REGION15_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR15_U_SMXP_0_0, REGION15_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR16_U_SMXP_0_0, 0x3e110)
    FIELD(POR_MPU_M4_PRBAR16_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR16_U_SMXP_0_0, REGION16_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR16_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR16_U_SMXP_0_0, REGION16_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR16_U_SMXP_0_0, REGION16_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR16_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR16_U_SMXP_0_0, 0x3e118)
    FIELD(POR_MPU_M4_PRLAR16_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR16_U_SMXP_0_0, REGION16_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR16_U_SMXP_0_0, REGION16_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR17_U_SMXP_0_0, 0x3e120)
    FIELD(POR_MPU_M4_PRBAR17_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR17_U_SMXP_0_0, REGION17_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR17_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR17_U_SMXP_0_0, REGION17_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR17_U_SMXP_0_0, REGION17_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR17_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR17_U_SMXP_0_0, 0x3e128)
    FIELD(POR_MPU_M4_PRLAR17_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR17_U_SMXP_0_0, REGION17_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR17_U_SMXP_0_0, REGION17_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR18_U_SMXP_0_0, 0x3e130)
    FIELD(POR_MPU_M4_PRBAR18_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR18_U_SMXP_0_0, REGION18_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR18_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR18_U_SMXP_0_0, REGION18_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR18_U_SMXP_0_0, REGION18_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR18_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR18_U_SMXP_0_0, 0x3e138)
    FIELD(POR_MPU_M4_PRLAR18_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR18_U_SMXP_0_0, REGION18_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR18_U_SMXP_0_0, REGION18_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR19_U_SMXP_0_0, 0x3e140)
    FIELD(POR_MPU_M4_PRBAR19_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR19_U_SMXP_0_0, REGION19_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR19_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR19_U_SMXP_0_0, REGION19_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR19_U_SMXP_0_0, REGION19_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR19_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR19_U_SMXP_0_0, 0x3e148)
    FIELD(POR_MPU_M4_PRLAR19_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR19_U_SMXP_0_0, REGION19_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR19_U_SMXP_0_0, REGION19_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR20_U_SMXP_0_0, 0x3e150)
    FIELD(POR_MPU_M4_PRBAR20_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR20_U_SMXP_0_0, REGION20_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR20_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR20_U_SMXP_0_0, REGION20_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR20_U_SMXP_0_0, REGION20_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR20_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR20_U_SMXP_0_0, 0x3e158)
    FIELD(POR_MPU_M4_PRLAR20_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR20_U_SMXP_0_0, REGION20_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR20_U_SMXP_0_0, REGION20_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR21_U_SMXP_0_0, 0x3e160)
    FIELD(POR_MPU_M4_PRBAR21_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR21_U_SMXP_0_0, REGION21_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR21_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR21_U_SMXP_0_0, REGION21_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR21_U_SMXP_0_0, REGION21_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR21_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR21_U_SMXP_0_0, 0x3e168)
    FIELD(POR_MPU_M4_PRLAR21_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR21_U_SMXP_0_0, REGION21_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR21_U_SMXP_0_0, REGION21_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR22_U_SMXP_0_0, 0x3e170)
    FIELD(POR_MPU_M4_PRBAR22_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR22_U_SMXP_0_0, REGION22_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR22_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR22_U_SMXP_0_0, REGION22_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR22_U_SMXP_0_0, REGION22_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR22_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR22_U_SMXP_0_0, 0x3e178)
    FIELD(POR_MPU_M4_PRLAR22_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR22_U_SMXP_0_0, REGION22_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR22_U_SMXP_0_0, REGION22_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR23_U_SMXP_0_0, 0x3e180)
    FIELD(POR_MPU_M4_PRBAR23_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR23_U_SMXP_0_0, REGION23_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR23_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR23_U_SMXP_0_0, REGION23_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR23_U_SMXP_0_0, REGION23_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR23_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR23_U_SMXP_0_0, 0x3e188)
    FIELD(POR_MPU_M4_PRLAR23_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR23_U_SMXP_0_0, REGION23_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR23_U_SMXP_0_0, REGION23_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR24_U_SMXP_0_0, 0x3e190)
    FIELD(POR_MPU_M4_PRBAR24_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR24_U_SMXP_0_0, REGION24_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR24_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR24_U_SMXP_0_0, REGION24_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR24_U_SMXP_0_0, REGION24_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR24_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR24_U_SMXP_0_0, 0x3e198)
    FIELD(POR_MPU_M4_PRLAR24_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR24_U_SMXP_0_0, REGION24_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR24_U_SMXP_0_0, REGION24_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR25_U_SMXP_0_0, 0x3e1a0)
    FIELD(POR_MPU_M4_PRBAR25_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR25_U_SMXP_0_0, REGION25_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR25_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR25_U_SMXP_0_0, REGION25_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR25_U_SMXP_0_0, REGION25_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR25_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR25_U_SMXP_0_0, 0x3e1a8)
    FIELD(POR_MPU_M4_PRLAR25_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR25_U_SMXP_0_0, REGION25_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR25_U_SMXP_0_0, REGION25_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR26_U_SMXP_0_0, 0x3e1b0)
    FIELD(POR_MPU_M4_PRBAR26_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR26_U_SMXP_0_0, REGION26_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR26_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR26_U_SMXP_0_0, REGION26_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR26_U_SMXP_0_0, REGION26_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR26_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR26_U_SMXP_0_0, 0x3e1b8)
    FIELD(POR_MPU_M4_PRLAR26_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR26_U_SMXP_0_0, REGION26_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR26_U_SMXP_0_0, REGION26_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR27_U_SMXP_0_0, 0x3e1c0)
    FIELD(POR_MPU_M4_PRBAR27_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR27_U_SMXP_0_0, REGION27_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR27_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR27_U_SMXP_0_0, REGION27_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR27_U_SMXP_0_0, REGION27_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR27_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR27_U_SMXP_0_0, 0x3e1c8)
    FIELD(POR_MPU_M4_PRLAR27_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR27_U_SMXP_0_0, REGION27_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR27_U_SMXP_0_0, REGION27_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR28_U_SMXP_0_0, 0x3e1d0)
    FIELD(POR_MPU_M4_PRBAR28_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR28_U_SMXP_0_0, REGION28_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR28_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR28_U_SMXP_0_0, REGION28_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR28_U_SMXP_0_0, REGION28_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR28_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR28_U_SMXP_0_0, 0x3e1d8)
    FIELD(POR_MPU_M4_PRLAR28_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR28_U_SMXP_0_0, REGION28_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR28_U_SMXP_0_0, REGION28_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR29_U_SMXP_0_0, 0x3e1e0)
    FIELD(POR_MPU_M4_PRBAR29_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR29_U_SMXP_0_0, REGION29_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR29_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR29_U_SMXP_0_0, REGION29_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR29_U_SMXP_0_0, REGION29_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR29_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR29_U_SMXP_0_0, 0x3e1e8)
    FIELD(POR_MPU_M4_PRLAR29_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR29_U_SMXP_0_0, REGION29_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR29_U_SMXP_0_0, REGION29_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR30_U_SMXP_0_0, 0x3e1f0)
    FIELD(POR_MPU_M4_PRBAR30_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR30_U_SMXP_0_0, REGION30_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR30_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR30_U_SMXP_0_0, REGION30_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR30_U_SMXP_0_0, REGION30_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR30_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR30_U_SMXP_0_0, 0x3e1f8)
    FIELD(POR_MPU_M4_PRLAR30_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR30_U_SMXP_0_0, REGION30_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR30_U_SMXP_0_0, REGION30_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR31_U_SMXP_0_0, 0x3e200)
    FIELD(POR_MPU_M4_PRBAR31_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR31_U_SMXP_0_0, REGION31_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR31_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR31_U_SMXP_0_0, REGION31_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR31_U_SMXP_0_0, REGION31_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR31_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR31_U_SMXP_0_0, 0x3e208)
    FIELD(POR_MPU_M4_PRLAR31_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR31_U_SMXP_0_0, REGION31_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR31_U_SMXP_0_0, REGION31_EN, 0, 1)
REG32(POR_MPU_M5_CTL_U_SMXP_0_0, 0x3e400)
    FIELD(POR_MPU_M5_CTL_U_SMXP_0_0, M5_EN, 2, 1)
    FIELD(POR_MPU_M5_CTL_U_SMXP_0_0, M5_ACTION, 0, 2)
REG32(POR_MPU_M5_PRBAR0_U_SMXP_0_0, 0x3e410)
    FIELD(POR_MPU_M5_PRBAR0_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR0_U_SMXP_0_0, REGION0_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR0_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR0_U_SMXP_0_0, REGION0_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR0_U_SMXP_0_0, REGION0_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR0_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR0_U_SMXP_0_0, 0x3e418)
    FIELD(POR_MPU_M5_PRLAR0_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR0_U_SMXP_0_0, REGION0_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR0_U_SMXP_0_0, REGION0_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR1_U_SMXP_0_0, 0x3e420)
    FIELD(POR_MPU_M5_PRBAR1_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR1_U_SMXP_0_0, REGION1_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR1_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR1_U_SMXP_0_0, REGION1_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR1_U_SMXP_0_0, REGION1_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR1_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR1_U_SMXP_0_0, 0x3e428)
    FIELD(POR_MPU_M5_PRLAR1_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR1_U_SMXP_0_0, REGION1_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR1_U_SMXP_0_0, REGION1_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR2_U_SMXP_0_0, 0x3e430)
    FIELD(POR_MPU_M5_PRBAR2_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR2_U_SMXP_0_0, REGION2_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR2_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR2_U_SMXP_0_0, REGION2_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR2_U_SMXP_0_0, REGION2_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR2_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR2_U_SMXP_0_0, 0x3e438)
    FIELD(POR_MPU_M5_PRLAR2_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR2_U_SMXP_0_0, REGION2_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR2_U_SMXP_0_0, REGION2_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR3_U_SMXP_0_0, 0x3e440)
    FIELD(POR_MPU_M5_PRBAR3_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR3_U_SMXP_0_0, REGION3_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR3_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR3_U_SMXP_0_0, REGION3_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR3_U_SMXP_0_0, REGION3_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR3_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR3_U_SMXP_0_0, 0x3e448)
    FIELD(POR_MPU_M5_PRLAR3_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR3_U_SMXP_0_0, REGION3_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR3_U_SMXP_0_0, REGION3_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR4_U_SMXP_0_0, 0x3e450)
    FIELD(POR_MPU_M5_PRBAR4_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR4_U_SMXP_0_0, REGION4_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR4_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR4_U_SMXP_0_0, REGION4_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR4_U_SMXP_0_0, REGION4_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR4_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR4_U_SMXP_0_0, 0x3e458)
    FIELD(POR_MPU_M5_PRLAR4_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR4_U_SMXP_0_0, REGION4_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR4_U_SMXP_0_0, REGION4_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR5_U_SMXP_0_0, 0x3e460)
    FIELD(POR_MPU_M5_PRBAR5_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR5_U_SMXP_0_0, REGION5_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR5_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR5_U_SMXP_0_0, REGION5_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR5_U_SMXP_0_0, REGION5_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR5_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR5_U_SMXP_0_0, 0x3e468)
    FIELD(POR_MPU_M5_PRLAR5_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR5_U_SMXP_0_0, REGION5_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR5_U_SMXP_0_0, REGION5_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR6_U_SMXP_0_0, 0x3e470)
    FIELD(POR_MPU_M5_PRBAR6_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR6_U_SMXP_0_0, REGION6_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR6_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR6_U_SMXP_0_0, REGION6_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR6_U_SMXP_0_0, REGION6_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR6_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR6_U_SMXP_0_0, 0x3e478)
    FIELD(POR_MPU_M5_PRLAR6_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR6_U_SMXP_0_0, REGION6_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR6_U_SMXP_0_0, REGION6_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR7_U_SMXP_0_0, 0x3e480)
    FIELD(POR_MPU_M5_PRBAR7_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR7_U_SMXP_0_0, REGION7_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR7_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR7_U_SMXP_0_0, REGION7_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR7_U_SMXP_0_0, REGION7_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR7_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR7_U_SMXP_0_0, 0x3e488)
    FIELD(POR_MPU_M5_PRLAR7_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR7_U_SMXP_0_0, REGION7_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR7_U_SMXP_0_0, REGION7_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR8_U_SMXP_0_0, 0x3e490)
    FIELD(POR_MPU_M5_PRBAR8_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR8_U_SMXP_0_0, REGION8_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR8_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR8_U_SMXP_0_0, REGION8_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR8_U_SMXP_0_0, REGION8_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR8_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR8_U_SMXP_0_0, 0x3e498)
    FIELD(POR_MPU_M5_PRLAR8_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR8_U_SMXP_0_0, REGION8_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR8_U_SMXP_0_0, REGION8_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR9_U_SMXP_0_0, 0x3e4a0)
    FIELD(POR_MPU_M5_PRBAR9_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR9_U_SMXP_0_0, REGION9_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR9_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR9_U_SMXP_0_0, REGION9_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR9_U_SMXP_0_0, REGION9_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR9_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR9_U_SMXP_0_0, 0x3e4a8)
    FIELD(POR_MPU_M5_PRLAR9_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR9_U_SMXP_0_0, REGION9_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR9_U_SMXP_0_0, REGION9_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR10_U_SMXP_0_0, 0x3e4b0)
    FIELD(POR_MPU_M5_PRBAR10_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR10_U_SMXP_0_0, REGION10_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR10_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR10_U_SMXP_0_0, REGION10_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR10_U_SMXP_0_0, REGION10_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR10_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR10_U_SMXP_0_0, 0x3e4b8)
    FIELD(POR_MPU_M5_PRLAR10_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR10_U_SMXP_0_0, REGION10_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR10_U_SMXP_0_0, REGION10_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR11_U_SMXP_0_0, 0x3e4c0)
    FIELD(POR_MPU_M5_PRBAR11_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR11_U_SMXP_0_0, REGION11_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR11_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR11_U_SMXP_0_0, REGION11_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR11_U_SMXP_0_0, REGION11_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR11_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR11_U_SMXP_0_0, 0x3e4c8)
    FIELD(POR_MPU_M5_PRLAR11_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR11_U_SMXP_0_0, REGION11_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR11_U_SMXP_0_0, REGION11_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR12_U_SMXP_0_0, 0x3e4d0)
    FIELD(POR_MPU_M5_PRBAR12_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR12_U_SMXP_0_0, REGION12_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR12_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR12_U_SMXP_0_0, REGION12_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR12_U_SMXP_0_0, REGION12_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR12_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR12_U_SMXP_0_0, 0x3e4d8)
    FIELD(POR_MPU_M5_PRLAR12_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR12_U_SMXP_0_0, REGION12_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR12_U_SMXP_0_0, REGION12_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR13_U_SMXP_0_0, 0x3e4e0)
    FIELD(POR_MPU_M5_PRBAR13_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR13_U_SMXP_0_0, REGION13_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR13_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR13_U_SMXP_0_0, REGION13_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR13_U_SMXP_0_0, REGION13_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR13_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR13_U_SMXP_0_0, 0x3e4e8)
    FIELD(POR_MPU_M5_PRLAR13_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR13_U_SMXP_0_0, REGION13_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR13_U_SMXP_0_0, REGION13_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR14_U_SMXP_0_0, 0x3e4f0)
    FIELD(POR_MPU_M5_PRBAR14_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR14_U_SMXP_0_0, REGION14_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR14_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR14_U_SMXP_0_0, REGION14_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR14_U_SMXP_0_0, REGION14_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR14_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR14_U_SMXP_0_0, 0x3e4f8)
    FIELD(POR_MPU_M5_PRLAR14_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR14_U_SMXP_0_0, REGION14_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR14_U_SMXP_0_0, REGION14_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR15_U_SMXP_0_0, 0x3e500)
    FIELD(POR_MPU_M5_PRBAR15_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR15_U_SMXP_0_0, REGION15_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR15_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR15_U_SMXP_0_0, REGION15_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR15_U_SMXP_0_0, REGION15_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR15_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR15_U_SMXP_0_0, 0x3e508)
    FIELD(POR_MPU_M5_PRLAR15_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR15_U_SMXP_0_0, REGION15_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR15_U_SMXP_0_0, REGION15_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR16_U_SMXP_0_0, 0x3e510)
    FIELD(POR_MPU_M5_PRBAR16_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR16_U_SMXP_0_0, REGION16_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR16_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR16_U_SMXP_0_0, REGION16_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR16_U_SMXP_0_0, REGION16_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR16_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR16_U_SMXP_0_0, 0x3e518)
    FIELD(POR_MPU_M5_PRLAR16_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR16_U_SMXP_0_0, REGION16_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR16_U_SMXP_0_0, REGION16_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR17_U_SMXP_0_0, 0x3e520)
    FIELD(POR_MPU_M5_PRBAR17_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR17_U_SMXP_0_0, REGION17_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR17_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR17_U_SMXP_0_0, REGION17_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR17_U_SMXP_0_0, REGION17_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR17_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR17_U_SMXP_0_0, 0x3e528)
    FIELD(POR_MPU_M5_PRLAR17_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR17_U_SMXP_0_0, REGION17_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR17_U_SMXP_0_0, REGION17_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR18_U_SMXP_0_0, 0x3e530)
    FIELD(POR_MPU_M5_PRBAR18_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR18_U_SMXP_0_0, REGION18_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR18_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR18_U_SMXP_0_0, REGION18_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR18_U_SMXP_0_0, REGION18_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR18_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR18_U_SMXP_0_0, 0x3e538)
    FIELD(POR_MPU_M5_PRLAR18_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR18_U_SMXP_0_0, REGION18_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR18_U_SMXP_0_0, REGION18_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR19_U_SMXP_0_0, 0x3e540)
    FIELD(POR_MPU_M5_PRBAR19_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR19_U_SMXP_0_0, REGION19_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR19_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR19_U_SMXP_0_0, REGION19_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR19_U_SMXP_0_0, REGION19_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR19_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR19_U_SMXP_0_0, 0x3e548)
    FIELD(POR_MPU_M5_PRLAR19_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR19_U_SMXP_0_0, REGION19_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR19_U_SMXP_0_0, REGION19_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR20_U_SMXP_0_0, 0x3e550)
    FIELD(POR_MPU_M5_PRBAR20_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR20_U_SMXP_0_0, REGION20_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR20_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR20_U_SMXP_0_0, REGION20_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR20_U_SMXP_0_0, REGION20_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR20_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR20_U_SMXP_0_0, 0x3e558)
    FIELD(POR_MPU_M5_PRLAR20_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR20_U_SMXP_0_0, REGION20_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR20_U_SMXP_0_0, REGION20_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR21_U_SMXP_0_0, 0x3e560)
    FIELD(POR_MPU_M5_PRBAR21_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR21_U_SMXP_0_0, REGION21_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR21_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR21_U_SMXP_0_0, REGION21_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR21_U_SMXP_0_0, REGION21_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR21_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR21_U_SMXP_0_0, 0x3e568)
    FIELD(POR_MPU_M5_PRLAR21_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR21_U_SMXP_0_0, REGION21_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR21_U_SMXP_0_0, REGION21_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR22_U_SMXP_0_0, 0x3e570)
    FIELD(POR_MPU_M5_PRBAR22_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR22_U_SMXP_0_0, REGION22_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR22_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR22_U_SMXP_0_0, REGION22_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR22_U_SMXP_0_0, REGION22_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR22_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR22_U_SMXP_0_0, 0x3e578)
    FIELD(POR_MPU_M5_PRLAR22_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR22_U_SMXP_0_0, REGION22_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR22_U_SMXP_0_0, REGION22_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR23_U_SMXP_0_0, 0x3e580)
    FIELD(POR_MPU_M5_PRBAR23_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR23_U_SMXP_0_0, REGION23_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR23_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR23_U_SMXP_0_0, REGION23_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR23_U_SMXP_0_0, REGION23_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR23_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR23_U_SMXP_0_0, 0x3e588)
    FIELD(POR_MPU_M5_PRLAR23_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR23_U_SMXP_0_0, REGION23_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR23_U_SMXP_0_0, REGION23_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR24_U_SMXP_0_0, 0x3e590)
    FIELD(POR_MPU_M5_PRBAR24_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR24_U_SMXP_0_0, REGION24_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR24_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR24_U_SMXP_0_0, REGION24_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR24_U_SMXP_0_0, REGION24_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR24_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR24_U_SMXP_0_0, 0x3e598)
    FIELD(POR_MPU_M5_PRLAR24_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR24_U_SMXP_0_0, REGION24_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR24_U_SMXP_0_0, REGION24_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR25_U_SMXP_0_0, 0x3e5a0)
    FIELD(POR_MPU_M5_PRBAR25_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR25_U_SMXP_0_0, REGION25_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR25_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR25_U_SMXP_0_0, REGION25_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR25_U_SMXP_0_0, REGION25_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR25_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR25_U_SMXP_0_0, 0x3e5a8)
    FIELD(POR_MPU_M5_PRLAR25_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR25_U_SMXP_0_0, REGION25_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR25_U_SMXP_0_0, REGION25_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR26_U_SMXP_0_0, 0x3e5b0)
    FIELD(POR_MPU_M5_PRBAR26_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR26_U_SMXP_0_0, REGION26_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR26_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR26_U_SMXP_0_0, REGION26_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR26_U_SMXP_0_0, REGION26_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR26_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR26_U_SMXP_0_0, 0x3e5b8)
    FIELD(POR_MPU_M5_PRLAR26_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR26_U_SMXP_0_0, REGION26_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR26_U_SMXP_0_0, REGION26_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR27_U_SMXP_0_0, 0x3e5c0)
    FIELD(POR_MPU_M5_PRBAR27_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR27_U_SMXP_0_0, REGION27_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR27_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR27_U_SMXP_0_0, REGION27_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR27_U_SMXP_0_0, REGION27_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR27_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR27_U_SMXP_0_0, 0x3e5c8)
    FIELD(POR_MPU_M5_PRLAR27_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR27_U_SMXP_0_0, REGION27_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR27_U_SMXP_0_0, REGION27_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR28_U_SMXP_0_0, 0x3e5d0)
    FIELD(POR_MPU_M5_PRBAR28_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR28_U_SMXP_0_0, REGION28_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR28_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR28_U_SMXP_0_0, REGION28_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR28_U_SMXP_0_0, REGION28_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR28_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR28_U_SMXP_0_0, 0x3e5d8)
    FIELD(POR_MPU_M5_PRLAR28_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR28_U_SMXP_0_0, REGION28_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR28_U_SMXP_0_0, REGION28_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR29_U_SMXP_0_0, 0x3e5e0)
    FIELD(POR_MPU_M5_PRBAR29_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR29_U_SMXP_0_0, REGION29_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR29_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR29_U_SMXP_0_0, REGION29_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR29_U_SMXP_0_0, REGION29_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR29_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR29_U_SMXP_0_0, 0x3e5e8)
    FIELD(POR_MPU_M5_PRLAR29_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR29_U_SMXP_0_0, REGION29_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR29_U_SMXP_0_0, REGION29_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR30_U_SMXP_0_0, 0x3e5f0)
    FIELD(POR_MPU_M5_PRBAR30_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR30_U_SMXP_0_0, REGION30_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR30_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR30_U_SMXP_0_0, REGION30_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR30_U_SMXP_0_0, REGION30_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR30_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR30_U_SMXP_0_0, 0x3e5f8)
    FIELD(POR_MPU_M5_PRLAR30_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR30_U_SMXP_0_0, REGION30_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR30_U_SMXP_0_0, REGION30_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR31_U_SMXP_0_0, 0x3e600)
    FIELD(POR_MPU_M5_PRBAR31_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR31_U_SMXP_0_0, REGION31_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR31_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR31_U_SMXP_0_0, REGION31_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR31_U_SMXP_0_0, REGION31_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR31_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR31_U_SMXP_0_0, 0x3e608)
    FIELD(POR_MPU_M5_PRLAR31_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR31_U_SMXP_0_0, REGION31_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR31_U_SMXP_0_0, REGION31_EN, 0, 1)
REG32(POR_MPU_M6_CTL_U_SMXP_0_0, 0x3e800)
    FIELD(POR_MPU_M6_CTL_U_SMXP_0_0, M6_EN, 2, 1)
    FIELD(POR_MPU_M6_CTL_U_SMXP_0_0, M6_ACTION, 0, 2)
REG32(POR_MPU_M6_PRBAR0_U_SMXP_0_0, 0x3e810)
    FIELD(POR_MPU_M6_PRBAR0_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR0_U_SMXP_0_0, REGION0_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR0_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR0_U_SMXP_0_0, REGION0_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR0_U_SMXP_0_0, REGION0_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR0_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR0_U_SMXP_0_0, 0x3e818)
    FIELD(POR_MPU_M6_PRLAR0_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR0_U_SMXP_0_0, REGION0_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR0_U_SMXP_0_0, REGION0_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR1_U_SMXP_0_0, 0x3e820)
    FIELD(POR_MPU_M6_PRBAR1_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR1_U_SMXP_0_0, REGION1_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR1_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR1_U_SMXP_0_0, REGION1_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR1_U_SMXP_0_0, REGION1_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR1_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR1_U_SMXP_0_0, 0x3e828)
    FIELD(POR_MPU_M6_PRLAR1_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR1_U_SMXP_0_0, REGION1_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR1_U_SMXP_0_0, REGION1_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR2_U_SMXP_0_0, 0x3e830)
    FIELD(POR_MPU_M6_PRBAR2_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR2_U_SMXP_0_0, REGION2_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR2_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR2_U_SMXP_0_0, REGION2_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR2_U_SMXP_0_0, REGION2_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR2_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR2_U_SMXP_0_0, 0x3e838)
    FIELD(POR_MPU_M6_PRLAR2_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR2_U_SMXP_0_0, REGION2_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR2_U_SMXP_0_0, REGION2_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR3_U_SMXP_0_0, 0x3e840)
    FIELD(POR_MPU_M6_PRBAR3_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR3_U_SMXP_0_0, REGION3_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR3_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR3_U_SMXP_0_0, REGION3_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR3_U_SMXP_0_0, REGION3_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR3_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR3_U_SMXP_0_0, 0x3e848)
    FIELD(POR_MPU_M6_PRLAR3_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR3_U_SMXP_0_0, REGION3_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR3_U_SMXP_0_0, REGION3_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR4_U_SMXP_0_0, 0x3e850)
    FIELD(POR_MPU_M6_PRBAR4_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR4_U_SMXP_0_0, REGION4_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR4_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR4_U_SMXP_0_0, REGION4_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR4_U_SMXP_0_0, REGION4_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR4_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR4_U_SMXP_0_0, 0x3e858)
    FIELD(POR_MPU_M6_PRLAR4_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR4_U_SMXP_0_0, REGION4_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR4_U_SMXP_0_0, REGION4_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR5_U_SMXP_0_0, 0x3e860)
    FIELD(POR_MPU_M6_PRBAR5_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR5_U_SMXP_0_0, REGION5_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR5_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR5_U_SMXP_0_0, REGION5_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR5_U_SMXP_0_0, REGION5_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR5_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR5_U_SMXP_0_0, 0x3e868)
    FIELD(POR_MPU_M6_PRLAR5_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR5_U_SMXP_0_0, REGION5_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR5_U_SMXP_0_0, REGION5_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR6_U_SMXP_0_0, 0x3e870)
    FIELD(POR_MPU_M6_PRBAR6_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR6_U_SMXP_0_0, REGION6_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR6_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR6_U_SMXP_0_0, REGION6_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR6_U_SMXP_0_0, REGION6_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR6_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR6_U_SMXP_0_0, 0x3e878)
    FIELD(POR_MPU_M6_PRLAR6_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR6_U_SMXP_0_0, REGION6_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR6_U_SMXP_0_0, REGION6_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR7_U_SMXP_0_0, 0x3e880)
    FIELD(POR_MPU_M6_PRBAR7_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR7_U_SMXP_0_0, REGION7_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR7_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR7_U_SMXP_0_0, REGION7_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR7_U_SMXP_0_0, REGION7_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR7_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR7_U_SMXP_0_0, 0x3e888)
    FIELD(POR_MPU_M6_PRLAR7_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR7_U_SMXP_0_0, REGION7_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR7_U_SMXP_0_0, REGION7_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR8_U_SMXP_0_0, 0x3e890)
    FIELD(POR_MPU_M6_PRBAR8_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR8_U_SMXP_0_0, REGION8_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR8_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR8_U_SMXP_0_0, REGION8_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR8_U_SMXP_0_0, REGION8_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR8_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR8_U_SMXP_0_0, 0x3e898)
    FIELD(POR_MPU_M6_PRLAR8_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR8_U_SMXP_0_0, REGION8_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR8_U_SMXP_0_0, REGION8_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR9_U_SMXP_0_0, 0x3e8a0)
    FIELD(POR_MPU_M6_PRBAR9_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR9_U_SMXP_0_0, REGION9_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR9_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR9_U_SMXP_0_0, REGION9_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR9_U_SMXP_0_0, REGION9_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR9_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR9_U_SMXP_0_0, 0x3e8a8)
    FIELD(POR_MPU_M6_PRLAR9_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR9_U_SMXP_0_0, REGION9_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR9_U_SMXP_0_0, REGION9_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR10_U_SMXP_0_0, 0x3e8b0)
    FIELD(POR_MPU_M6_PRBAR10_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR10_U_SMXP_0_0, REGION10_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR10_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR10_U_SMXP_0_0, REGION10_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR10_U_SMXP_0_0, REGION10_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR10_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR10_U_SMXP_0_0, 0x3e8b8)
    FIELD(POR_MPU_M6_PRLAR10_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR10_U_SMXP_0_0, REGION10_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR10_U_SMXP_0_0, REGION10_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR11_U_SMXP_0_0, 0x3e8c0)
    FIELD(POR_MPU_M6_PRBAR11_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR11_U_SMXP_0_0, REGION11_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR11_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR11_U_SMXP_0_0, REGION11_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR11_U_SMXP_0_0, REGION11_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR11_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR11_U_SMXP_0_0, 0x3e8c8)
    FIELD(POR_MPU_M6_PRLAR11_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR11_U_SMXP_0_0, REGION11_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR11_U_SMXP_0_0, REGION11_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR12_U_SMXP_0_0, 0x3e8d0)
    FIELD(POR_MPU_M6_PRBAR12_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR12_U_SMXP_0_0, REGION12_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR12_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR12_U_SMXP_0_0, REGION12_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR12_U_SMXP_0_0, REGION12_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR12_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR12_U_SMXP_0_0, 0x3e8d8)
    FIELD(POR_MPU_M6_PRLAR12_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR12_U_SMXP_0_0, REGION12_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR12_U_SMXP_0_0, REGION12_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR13_U_SMXP_0_0, 0x3e8e0)
    FIELD(POR_MPU_M6_PRBAR13_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR13_U_SMXP_0_0, REGION13_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR13_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR13_U_SMXP_0_0, REGION13_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR13_U_SMXP_0_0, REGION13_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR13_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR13_U_SMXP_0_0, 0x3e8e8)
    FIELD(POR_MPU_M6_PRLAR13_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR13_U_SMXP_0_0, REGION13_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR13_U_SMXP_0_0, REGION13_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR14_U_SMXP_0_0, 0x3e8f0)
    FIELD(POR_MPU_M6_PRBAR14_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR14_U_SMXP_0_0, REGION14_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR14_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR14_U_SMXP_0_0, REGION14_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR14_U_SMXP_0_0, REGION14_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR14_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR14_U_SMXP_0_0, 0x3e8f8)
    FIELD(POR_MPU_M6_PRLAR14_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR14_U_SMXP_0_0, REGION14_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR14_U_SMXP_0_0, REGION14_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR15_U_SMXP_0_0, 0x3e900)
    FIELD(POR_MPU_M6_PRBAR15_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR15_U_SMXP_0_0, REGION15_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR15_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR15_U_SMXP_0_0, REGION15_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR15_U_SMXP_0_0, REGION15_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR15_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR15_U_SMXP_0_0, 0x3e908)
    FIELD(POR_MPU_M6_PRLAR15_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR15_U_SMXP_0_0, REGION15_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR15_U_SMXP_0_0, REGION15_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR16_U_SMXP_0_0, 0x3e910)
    FIELD(POR_MPU_M6_PRBAR16_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR16_U_SMXP_0_0, REGION16_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR16_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR16_U_SMXP_0_0, REGION16_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR16_U_SMXP_0_0, REGION16_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR16_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR16_U_SMXP_0_0, 0x3e918)
    FIELD(POR_MPU_M6_PRLAR16_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR16_U_SMXP_0_0, REGION16_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR16_U_SMXP_0_0, REGION16_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR17_U_SMXP_0_0, 0x3e920)
    FIELD(POR_MPU_M6_PRBAR17_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR17_U_SMXP_0_0, REGION17_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR17_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR17_U_SMXP_0_0, REGION17_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR17_U_SMXP_0_0, REGION17_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR17_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR17_U_SMXP_0_0, 0x3e928)
    FIELD(POR_MPU_M6_PRLAR17_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR17_U_SMXP_0_0, REGION17_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR17_U_SMXP_0_0, REGION17_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR18_U_SMXP_0_0, 0x3e930)
    FIELD(POR_MPU_M6_PRBAR18_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR18_U_SMXP_0_0, REGION18_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR18_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR18_U_SMXP_0_0, REGION18_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR18_U_SMXP_0_0, REGION18_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR18_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR18_U_SMXP_0_0, 0x3e938)
    FIELD(POR_MPU_M6_PRLAR18_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR18_U_SMXP_0_0, REGION18_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR18_U_SMXP_0_0, REGION18_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR19_U_SMXP_0_0, 0x3e940)
    FIELD(POR_MPU_M6_PRBAR19_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR19_U_SMXP_0_0, REGION19_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR19_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR19_U_SMXP_0_0, REGION19_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR19_U_SMXP_0_0, REGION19_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR19_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR19_U_SMXP_0_0, 0x3e948)
    FIELD(POR_MPU_M6_PRLAR19_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR19_U_SMXP_0_0, REGION19_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR19_U_SMXP_0_0, REGION19_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR20_U_SMXP_0_0, 0x3e950)
    FIELD(POR_MPU_M6_PRBAR20_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR20_U_SMXP_0_0, REGION20_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR20_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR20_U_SMXP_0_0, REGION20_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR20_U_SMXP_0_0, REGION20_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR20_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR20_U_SMXP_0_0, 0x3e958)
    FIELD(POR_MPU_M6_PRLAR20_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR20_U_SMXP_0_0, REGION20_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR20_U_SMXP_0_0, REGION20_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR21_U_SMXP_0_0, 0x3e960)
    FIELD(POR_MPU_M6_PRBAR21_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR21_U_SMXP_0_0, REGION21_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR21_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR21_U_SMXP_0_0, REGION21_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR21_U_SMXP_0_0, REGION21_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR21_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR21_U_SMXP_0_0, 0x3e968)
    FIELD(POR_MPU_M6_PRLAR21_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR21_U_SMXP_0_0, REGION21_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR21_U_SMXP_0_0, REGION21_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR22_U_SMXP_0_0, 0x3e970)
    FIELD(POR_MPU_M6_PRBAR22_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR22_U_SMXP_0_0, REGION22_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR22_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR22_U_SMXP_0_0, REGION22_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR22_U_SMXP_0_0, REGION22_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR22_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR22_U_SMXP_0_0, 0x3e978)
    FIELD(POR_MPU_M6_PRLAR22_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR22_U_SMXP_0_0, REGION22_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR22_U_SMXP_0_0, REGION22_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR23_U_SMXP_0_0, 0x3e980)
    FIELD(POR_MPU_M6_PRBAR23_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR23_U_SMXP_0_0, REGION23_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR23_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR23_U_SMXP_0_0, REGION23_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR23_U_SMXP_0_0, REGION23_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR23_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR23_U_SMXP_0_0, 0x3e988)
    FIELD(POR_MPU_M6_PRLAR23_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR23_U_SMXP_0_0, REGION23_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR23_U_SMXP_0_0, REGION23_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR24_U_SMXP_0_0, 0x3e990)
    FIELD(POR_MPU_M6_PRBAR24_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR24_U_SMXP_0_0, REGION24_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR24_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR24_U_SMXP_0_0, REGION24_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR24_U_SMXP_0_0, REGION24_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR24_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR24_U_SMXP_0_0, 0x3e998)
    FIELD(POR_MPU_M6_PRLAR24_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR24_U_SMXP_0_0, REGION24_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR24_U_SMXP_0_0, REGION24_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR25_U_SMXP_0_0, 0x3e9a0)
    FIELD(POR_MPU_M6_PRBAR25_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR25_U_SMXP_0_0, REGION25_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR25_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR25_U_SMXP_0_0, REGION25_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR25_U_SMXP_0_0, REGION25_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR25_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR25_U_SMXP_0_0, 0x3e9a8)
    FIELD(POR_MPU_M6_PRLAR25_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR25_U_SMXP_0_0, REGION25_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR25_U_SMXP_0_0, REGION25_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR26_U_SMXP_0_0, 0x3e9b0)
    FIELD(POR_MPU_M6_PRBAR26_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR26_U_SMXP_0_0, REGION26_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR26_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR26_U_SMXP_0_0, REGION26_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR26_U_SMXP_0_0, REGION26_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR26_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR26_U_SMXP_0_0, 0x3e9b8)
    FIELD(POR_MPU_M6_PRLAR26_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR26_U_SMXP_0_0, REGION26_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR26_U_SMXP_0_0, REGION26_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR27_U_SMXP_0_0, 0x3e9c0)
    FIELD(POR_MPU_M6_PRBAR27_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR27_U_SMXP_0_0, REGION27_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR27_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR27_U_SMXP_0_0, REGION27_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR27_U_SMXP_0_0, REGION27_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR27_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR27_U_SMXP_0_0, 0x3e9c8)
    FIELD(POR_MPU_M6_PRLAR27_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR27_U_SMXP_0_0, REGION27_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR27_U_SMXP_0_0, REGION27_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR28_U_SMXP_0_0, 0x3e9d0)
    FIELD(POR_MPU_M6_PRBAR28_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR28_U_SMXP_0_0, REGION28_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR28_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR28_U_SMXP_0_0, REGION28_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR28_U_SMXP_0_0, REGION28_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR28_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR28_U_SMXP_0_0, 0x3e9d8)
    FIELD(POR_MPU_M6_PRLAR28_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR28_U_SMXP_0_0, REGION28_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR28_U_SMXP_0_0, REGION28_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR29_U_SMXP_0_0, 0x3e9e0)
    FIELD(POR_MPU_M6_PRBAR29_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR29_U_SMXP_0_0, REGION29_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR29_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR29_U_SMXP_0_0, REGION29_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR29_U_SMXP_0_0, REGION29_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR29_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR29_U_SMXP_0_0, 0x3e9e8)
    FIELD(POR_MPU_M6_PRLAR29_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR29_U_SMXP_0_0, REGION29_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR29_U_SMXP_0_0, REGION29_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR30_U_SMXP_0_0, 0x3e9f0)
    FIELD(POR_MPU_M6_PRBAR30_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR30_U_SMXP_0_0, REGION30_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR30_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR30_U_SMXP_0_0, REGION30_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR30_U_SMXP_0_0, REGION30_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR30_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR30_U_SMXP_0_0, 0x3e9f8)
    FIELD(POR_MPU_M6_PRLAR30_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR30_U_SMXP_0_0, REGION30_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR30_U_SMXP_0_0, REGION30_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR31_U_SMXP_0_0, 0x3ea00)
    FIELD(POR_MPU_M6_PRBAR31_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR31_U_SMXP_0_0, REGION31_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR31_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR31_U_SMXP_0_0, REGION31_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR31_U_SMXP_0_0, REGION31_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR31_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR31_U_SMXP_0_0, 0x3ea08)
    FIELD(POR_MPU_M6_PRLAR31_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR31_U_SMXP_0_0, REGION31_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR31_U_SMXP_0_0, REGION31_EN, 0, 1)
REG32(POR_MPU_M7_CTL_U_SMXP_0_0, 0x3ec00)
    FIELD(POR_MPU_M7_CTL_U_SMXP_0_0, M7_EN, 2, 1)
    FIELD(POR_MPU_M7_CTL_U_SMXP_0_0, M7_ACTION, 0, 2)
REG32(POR_MPU_M7_PRBAR0_U_SMXP_0_0, 0x3ec10)
    FIELD(POR_MPU_M7_PRBAR0_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR0_U_SMXP_0_0, REGION0_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR0_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR0_U_SMXP_0_0, REGION0_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR0_U_SMXP_0_0, REGION0_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR0_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR0_U_SMXP_0_0, 0x3ec18)
    FIELD(POR_MPU_M7_PRLAR0_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR0_U_SMXP_0_0, REGION0_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR0_U_SMXP_0_0, REGION0_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR1_U_SMXP_0_0, 0x3ec20)
    FIELD(POR_MPU_M7_PRBAR1_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR1_U_SMXP_0_0, REGION1_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR1_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR1_U_SMXP_0_0, REGION1_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR1_U_SMXP_0_0, REGION1_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR1_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR1_U_SMXP_0_0, 0x3ec28)
    FIELD(POR_MPU_M7_PRLAR1_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR1_U_SMXP_0_0, REGION1_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR1_U_SMXP_0_0, REGION1_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR2_U_SMXP_0_0, 0x3ec30)
    FIELD(POR_MPU_M7_PRBAR2_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR2_U_SMXP_0_0, REGION2_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR2_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR2_U_SMXP_0_0, REGION2_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR2_U_SMXP_0_0, REGION2_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR2_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR2_U_SMXP_0_0, 0x3ec38)
    FIELD(POR_MPU_M7_PRLAR2_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR2_U_SMXP_0_0, REGION2_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR2_U_SMXP_0_0, REGION2_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR3_U_SMXP_0_0, 0x3ec40)
    FIELD(POR_MPU_M7_PRBAR3_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR3_U_SMXP_0_0, REGION3_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR3_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR3_U_SMXP_0_0, REGION3_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR3_U_SMXP_0_0, REGION3_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR3_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR3_U_SMXP_0_0, 0x3ec48)
    FIELD(POR_MPU_M7_PRLAR3_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR3_U_SMXP_0_0, REGION3_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR3_U_SMXP_0_0, REGION3_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR4_U_SMXP_0_0, 0x3ec50)
    FIELD(POR_MPU_M7_PRBAR4_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR4_U_SMXP_0_0, REGION4_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR4_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR4_U_SMXP_0_0, REGION4_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR4_U_SMXP_0_0, REGION4_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR4_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR4_U_SMXP_0_0, 0x3ec58)
    FIELD(POR_MPU_M7_PRLAR4_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR4_U_SMXP_0_0, REGION4_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR4_U_SMXP_0_0, REGION4_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR5_U_SMXP_0_0, 0x3ec60)
    FIELD(POR_MPU_M7_PRBAR5_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR5_U_SMXP_0_0, REGION5_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR5_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR5_U_SMXP_0_0, REGION5_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR5_U_SMXP_0_0, REGION5_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR5_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR5_U_SMXP_0_0, 0x3ec68)
    FIELD(POR_MPU_M7_PRLAR5_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR5_U_SMXP_0_0, REGION5_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR5_U_SMXP_0_0, REGION5_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR6_U_SMXP_0_0, 0x3ec70)
    FIELD(POR_MPU_M7_PRBAR6_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR6_U_SMXP_0_0, REGION6_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR6_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR6_U_SMXP_0_0, REGION6_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR6_U_SMXP_0_0, REGION6_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR6_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR6_U_SMXP_0_0, 0x3ec78)
    FIELD(POR_MPU_M7_PRLAR6_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR6_U_SMXP_0_0, REGION6_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR6_U_SMXP_0_0, REGION6_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR7_U_SMXP_0_0, 0x3ec80)
    FIELD(POR_MPU_M7_PRBAR7_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR7_U_SMXP_0_0, REGION7_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR7_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR7_U_SMXP_0_0, REGION7_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR7_U_SMXP_0_0, REGION7_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR7_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR7_U_SMXP_0_0, 0x3ec88)
    FIELD(POR_MPU_M7_PRLAR7_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR7_U_SMXP_0_0, REGION7_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR7_U_SMXP_0_0, REGION7_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR8_U_SMXP_0_0, 0x3ec90)
    FIELD(POR_MPU_M7_PRBAR8_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR8_U_SMXP_0_0, REGION8_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR8_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR8_U_SMXP_0_0, REGION8_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR8_U_SMXP_0_0, REGION8_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR8_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR8_U_SMXP_0_0, 0x3ec98)
    FIELD(POR_MPU_M7_PRLAR8_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR8_U_SMXP_0_0, REGION8_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR8_U_SMXP_0_0, REGION8_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR9_U_SMXP_0_0, 0x3eca0)
    FIELD(POR_MPU_M7_PRBAR9_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR9_U_SMXP_0_0, REGION9_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR9_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR9_U_SMXP_0_0, REGION9_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR9_U_SMXP_0_0, REGION9_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR9_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR9_U_SMXP_0_0, 0x3eca8)
    FIELD(POR_MPU_M7_PRLAR9_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR9_U_SMXP_0_0, REGION9_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR9_U_SMXP_0_0, REGION9_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR10_U_SMXP_0_0, 0x3ecb0)
    FIELD(POR_MPU_M7_PRBAR10_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR10_U_SMXP_0_0, REGION10_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR10_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR10_U_SMXP_0_0, REGION10_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR10_U_SMXP_0_0, REGION10_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR10_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR10_U_SMXP_0_0, 0x3ecb8)
    FIELD(POR_MPU_M7_PRLAR10_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR10_U_SMXP_0_0, REGION10_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR10_U_SMXP_0_0, REGION10_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR11_U_SMXP_0_0, 0x3ecc0)
    FIELD(POR_MPU_M7_PRBAR11_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR11_U_SMXP_0_0, REGION11_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR11_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR11_U_SMXP_0_0, REGION11_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR11_U_SMXP_0_0, REGION11_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR11_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR11_U_SMXP_0_0, 0x3ecc8)
    FIELD(POR_MPU_M7_PRLAR11_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR11_U_SMXP_0_0, REGION11_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR11_U_SMXP_0_0, REGION11_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR12_U_SMXP_0_0, 0x3ecd0)
    FIELD(POR_MPU_M7_PRBAR12_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR12_U_SMXP_0_0, REGION12_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR12_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR12_U_SMXP_0_0, REGION12_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR12_U_SMXP_0_0, REGION12_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR12_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR12_U_SMXP_0_0, 0x3ecd8)
    FIELD(POR_MPU_M7_PRLAR12_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR12_U_SMXP_0_0, REGION12_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR12_U_SMXP_0_0, REGION12_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR13_U_SMXP_0_0, 0x3ece0)
    FIELD(POR_MPU_M7_PRBAR13_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR13_U_SMXP_0_0, REGION13_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR13_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR13_U_SMXP_0_0, REGION13_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR13_U_SMXP_0_0, REGION13_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR13_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR13_U_SMXP_0_0, 0x3ece8)
    FIELD(POR_MPU_M7_PRLAR13_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR13_U_SMXP_0_0, REGION13_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR13_U_SMXP_0_0, REGION13_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR14_U_SMXP_0_0, 0x3ecf0)
    FIELD(POR_MPU_M7_PRBAR14_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR14_U_SMXP_0_0, REGION14_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR14_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR14_U_SMXP_0_0, REGION14_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR14_U_SMXP_0_0, REGION14_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR14_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR14_U_SMXP_0_0, 0x3ecf8)
    FIELD(POR_MPU_M7_PRLAR14_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR14_U_SMXP_0_0, REGION14_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR14_U_SMXP_0_0, REGION14_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR15_U_SMXP_0_0, 0x3ed00)
    FIELD(POR_MPU_M7_PRBAR15_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR15_U_SMXP_0_0, REGION15_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR15_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR15_U_SMXP_0_0, REGION15_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR15_U_SMXP_0_0, REGION15_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR15_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR15_U_SMXP_0_0, 0x3ed08)
    FIELD(POR_MPU_M7_PRLAR15_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR15_U_SMXP_0_0, REGION15_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR15_U_SMXP_0_0, REGION15_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR16_U_SMXP_0_0, 0x3ed10)
    FIELD(POR_MPU_M7_PRBAR16_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR16_U_SMXP_0_0, REGION16_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR16_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR16_U_SMXP_0_0, REGION16_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR16_U_SMXP_0_0, REGION16_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR16_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR16_U_SMXP_0_0, 0x3ed18)
    FIELD(POR_MPU_M7_PRLAR16_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR16_U_SMXP_0_0, REGION16_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR16_U_SMXP_0_0, REGION16_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR17_U_SMXP_0_0, 0x3ed20)
    FIELD(POR_MPU_M7_PRBAR17_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR17_U_SMXP_0_0, REGION17_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR17_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR17_U_SMXP_0_0, REGION17_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR17_U_SMXP_0_0, REGION17_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR17_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR17_U_SMXP_0_0, 0x3ed28)
    FIELD(POR_MPU_M7_PRLAR17_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR17_U_SMXP_0_0, REGION17_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR17_U_SMXP_0_0, REGION17_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR18_U_SMXP_0_0, 0x3ed30)
    FIELD(POR_MPU_M7_PRBAR18_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR18_U_SMXP_0_0, REGION18_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR18_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR18_U_SMXP_0_0, REGION18_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR18_U_SMXP_0_0, REGION18_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR18_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR18_U_SMXP_0_0, 0x3ed38)
    FIELD(POR_MPU_M7_PRLAR18_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR18_U_SMXP_0_0, REGION18_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR18_U_SMXP_0_0, REGION18_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR19_U_SMXP_0_0, 0x3ed40)
    FIELD(POR_MPU_M7_PRBAR19_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR19_U_SMXP_0_0, REGION19_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR19_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR19_U_SMXP_0_0, REGION19_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR19_U_SMXP_0_0, REGION19_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR19_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR19_U_SMXP_0_0, 0x3ed48)
    FIELD(POR_MPU_M7_PRLAR19_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR19_U_SMXP_0_0, REGION19_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR19_U_SMXP_0_0, REGION19_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR20_U_SMXP_0_0, 0x3ed50)
    FIELD(POR_MPU_M7_PRBAR20_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR20_U_SMXP_0_0, REGION20_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR20_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR20_U_SMXP_0_0, REGION20_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR20_U_SMXP_0_0, REGION20_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR20_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR20_U_SMXP_0_0, 0x3ed58)
    FIELD(POR_MPU_M7_PRLAR20_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR20_U_SMXP_0_0, REGION20_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR20_U_SMXP_0_0, REGION20_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR21_U_SMXP_0_0, 0x3ed60)
    FIELD(POR_MPU_M7_PRBAR21_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR21_U_SMXP_0_0, REGION21_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR21_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR21_U_SMXP_0_0, REGION21_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR21_U_SMXP_0_0, REGION21_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR21_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR21_U_SMXP_0_0, 0x3ed68)
    FIELD(POR_MPU_M7_PRLAR21_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR21_U_SMXP_0_0, REGION21_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR21_U_SMXP_0_0, REGION21_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR22_U_SMXP_0_0, 0x3ed70)
    FIELD(POR_MPU_M7_PRBAR22_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR22_U_SMXP_0_0, REGION22_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR22_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR22_U_SMXP_0_0, REGION22_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR22_U_SMXP_0_0, REGION22_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR22_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR22_U_SMXP_0_0, 0x3ed78)
    FIELD(POR_MPU_M7_PRLAR22_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR22_U_SMXP_0_0, REGION22_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR22_U_SMXP_0_0, REGION22_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR23_U_SMXP_0_0, 0x3ed80)
    FIELD(POR_MPU_M7_PRBAR23_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR23_U_SMXP_0_0, REGION23_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR23_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR23_U_SMXP_0_0, REGION23_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR23_U_SMXP_0_0, REGION23_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR23_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR23_U_SMXP_0_0, 0x3ed88)
    FIELD(POR_MPU_M7_PRLAR23_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR23_U_SMXP_0_0, REGION23_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR23_U_SMXP_0_0, REGION23_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR24_U_SMXP_0_0, 0x3ed90)
    FIELD(POR_MPU_M7_PRBAR24_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR24_U_SMXP_0_0, REGION24_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR24_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR24_U_SMXP_0_0, REGION24_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR24_U_SMXP_0_0, REGION24_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR24_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR24_U_SMXP_0_0, 0x3ed98)
    FIELD(POR_MPU_M7_PRLAR24_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR24_U_SMXP_0_0, REGION24_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR24_U_SMXP_0_0, REGION24_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR25_U_SMXP_0_0, 0x3eda0)
    FIELD(POR_MPU_M7_PRBAR25_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR25_U_SMXP_0_0, REGION25_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR25_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR25_U_SMXP_0_0, REGION25_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR25_U_SMXP_0_0, REGION25_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR25_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR25_U_SMXP_0_0, 0x3eda8)
    FIELD(POR_MPU_M7_PRLAR25_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR25_U_SMXP_0_0, REGION25_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR25_U_SMXP_0_0, REGION25_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR26_U_SMXP_0_0, 0x3edb0)
    FIELD(POR_MPU_M7_PRBAR26_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR26_U_SMXP_0_0, REGION26_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR26_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR26_U_SMXP_0_0, REGION26_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR26_U_SMXP_0_0, REGION26_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR26_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR26_U_SMXP_0_0, 0x3edb8)
    FIELD(POR_MPU_M7_PRLAR26_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR26_U_SMXP_0_0, REGION26_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR26_U_SMXP_0_0, REGION26_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR27_U_SMXP_0_0, 0x3edc0)
    FIELD(POR_MPU_M7_PRBAR27_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR27_U_SMXP_0_0, REGION27_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR27_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR27_U_SMXP_0_0, REGION27_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR27_U_SMXP_0_0, REGION27_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR27_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR27_U_SMXP_0_0, 0x3edc8)
    FIELD(POR_MPU_M7_PRLAR27_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR27_U_SMXP_0_0, REGION27_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR27_U_SMXP_0_0, REGION27_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR28_U_SMXP_0_0, 0x3edd0)
    FIELD(POR_MPU_M7_PRBAR28_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR28_U_SMXP_0_0, REGION28_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR28_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR28_U_SMXP_0_0, REGION28_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR28_U_SMXP_0_0, REGION28_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR28_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR28_U_SMXP_0_0, 0x3edd8)
    FIELD(POR_MPU_M7_PRLAR28_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR28_U_SMXP_0_0, REGION28_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR28_U_SMXP_0_0, REGION28_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR29_U_SMXP_0_0, 0x3ede0)
    FIELD(POR_MPU_M7_PRBAR29_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR29_U_SMXP_0_0, REGION29_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR29_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR29_U_SMXP_0_0, REGION29_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR29_U_SMXP_0_0, REGION29_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR29_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR29_U_SMXP_0_0, 0x3ede8)
    FIELD(POR_MPU_M7_PRLAR29_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR29_U_SMXP_0_0, REGION29_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR29_U_SMXP_0_0, REGION29_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR30_U_SMXP_0_0, 0x3edf0)
    FIELD(POR_MPU_M7_PRBAR30_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR30_U_SMXP_0_0, REGION30_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR30_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR30_U_SMXP_0_0, REGION30_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR30_U_SMXP_0_0, REGION30_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR30_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR30_U_SMXP_0_0, 0x3edf8)
    FIELD(POR_MPU_M7_PRLAR30_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR30_U_SMXP_0_0, REGION30_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR30_U_SMXP_0_0, REGION30_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR31_U_SMXP_0_0, 0x3ee00)
    FIELD(POR_MPU_M7_PRBAR31_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR31_U_SMXP_0_0, REGION31_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR31_U_SMXP_0_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR31_U_SMXP_0_0, REGION31_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR31_U_SMXP_0_0, REGION31_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR31_U_SMXP_0_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR31_U_SMXP_0_0, 0x3ee08)
    FIELD(POR_MPU_M7_PRLAR31_U_SMXP_0_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR31_U_SMXP_0_0, REGION31_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR31_U_SMXP_0_0, REGION31_EN, 0, 1)
REG32(POR_HNF_NODE_INFO_U_HNF_NID8, 0x100000)
    FIELD(POR_HNF_NODE_INFO_U_HNF_NID8, RESERVED_48, 48, 16)
    FIELD(POR_HNF_NODE_INFO_U_HNF_NID8, LOGICAL_ID, 32, 16)
    FIELD(POR_HNF_NODE_INFO_U_HNF_NID8, NODE_ID, 16, 16)
    FIELD(POR_HNF_NODE_INFO_U_HNF_NID8, NODE_TYPE, 0, 16)
REG32(POR_HNF_CHILD_INFO_U_HNF_NID8, 0x100080)
    FIELD(POR_HNF_CHILD_INFO_U_HNF_NID8, RESERVED_32, 32, 32)
    FIELD(POR_HNF_CHILD_INFO_U_HNF_NID8, CHILD_PTR_OFFSET, 16, 16)
    FIELD(POR_HNF_CHILD_INFO_U_HNF_NID8, CHILD_COUNT, 0, 16)
REG32(POR_HNF_UNIT_INFO_U_HNF_NID8, 0x100900)
    FIELD(POR_HNF_UNIT_INFO_U_HNF_NID8, RESERVED_39, 39, 25)
    FIELD(POR_HNF_UNIT_INFO_U_HNF_NID8, NUM_POC_ENTRIES, 32, 7)
    FIELD(POR_HNF_UNIT_INFO_U_HNF_NID8, RESERVED_31, 31, 1)
    FIELD(POR_HNF_UNIT_INFO_U_HNF_NID8, NUM_EXCL, 24, 7)
    FIELD(POR_HNF_UNIT_INFO_U_HNF_NID8, RESERVED_23, 23, 1)
    FIELD(POR_HNF_UNIT_INFO_U_HNF_NID8, DATA_RAM_LATENCY, 20, 3)
    FIELD(POR_HNF_UNIT_INFO_U_HNF_NID8, RESERVED_19, 19, 1)
    FIELD(POR_HNF_UNIT_INFO_U_HNF_NID8, TAG_RAM_LAT, 16, 3)
    FIELD(POR_HNF_UNIT_INFO_U_HNF_NID8, RESERVED_13, 13, 3)
    FIELD(POR_HNF_UNIT_INFO_U_HNF_NID8, NUM_WAYS, 8, 5)
    FIELD(POR_HNF_UNIT_INFO_U_HNF_NID8, SF_SIZE, 4, 3)
    FIELD(POR_HNF_UNIT_INFO_U_HNF_NID8, SLC_SIZE, 0, 3)
REG32(POR_HNF_SECURE_REGISTER_GROUPS_OVERRIDE_U_HNF_NID8, 0x100980)
    FIELD(POR_HNF_SECURE_REGISTER_GROUPS_OVERRIDE_U_HNF_NID8, SLCSF_DBGRD, 5, 1)
    FIELD(POR_HNF_SECURE_REGISTER_GROUPS_OVERRIDE_U_HNF_NID8, SAM_CONTROL, 4, 1)
    FIELD(POR_HNF_SECURE_REGISTER_GROUPS_OVERRIDE_U_HNF_NID8, SLC_LOCK_WAYS, 3, 1)
    FIELD(POR_HNF_SECURE_REGISTER_GROUPS_OVERRIDE_U_HNF_NID8, PPU, 2, 1)
    FIELD(POR_HNF_SECURE_REGISTER_GROUPS_OVERRIDE_U_HNF_NID8, CFG_CTL, 1, 1)
    FIELD(POR_HNF_SECURE_REGISTER_GROUPS_OVERRIDE_U_HNF_NID8, QOS, 0, 1)
REG32(POR_HNF_CFG_CTL_U_HNF_NID8, 0x100a00)
    FIELD(POR_HNF_CFG_CTL_U_HNF_NID8, RESERVED_12, 12, 52)
    FIELD(POR_HNF_CFG_CTL_U_HNF_NID8, HNF_DMT_DISABLE, 11, 1)
    FIELD(POR_HNF_CFG_CTL_U_HNF_NID8, HNF_OCM_ALLWAYS_EN, 10, 1)
    FIELD(POR_HNF_CFG_CTL_U_HNF_NID8, HNF_OCM_EN, 9, 1)
    FIELD(POR_HNF_CFG_CTL_U_HNF_NID8, NCDEVCMO_MC_COMP, 8, 1)
    FIELD(POR_HNF_CFG_CTL_U_HNF_NID8, SF_ECC_SCRUB_DISABLE, 6, 1)
    FIELD(POR_HNF_CFG_CTL_U_HNF_NID8, SLC_TAG_ECC_SCRUB_DISABLE, 4, 1)
    FIELD(POR_HNF_CFG_CTL_U_HNF_NID8, POIS_DIS, 2, 1)
    FIELD(POR_HNF_CFG_CTL_U_HNF_NID8, ECC_DISABLE, 0, 1)
REG32(POR_HNF_AUX_CTL_U_HNF_NID8, 0x100a08)
    FIELD(POR_HNF_AUX_CTL_U_HNF_NID8, RESERVED_58, 58, 6)
    FIELD(POR_HNF_AUX_CTL_U_HNF_NID8, SLC_ECC_PIPE_MODE_DIS, 57, 1)
    FIELD(POR_HNF_AUX_CTL_U_HNF_NID8, HNF_ORD_STASH_DATAPULL_EN, 56, 1)
    FIELD(POR_HNF_AUX_CTL_U_HNF_NID8, HNF_SHARED_INTV_DISABLE, 55, 1)
    FIELD(POR_HNF_AUX_CTL_U_HNF_NID8, RESERVED_53, 53, 2)
    FIELD(POR_HNF_AUX_CTL_U_HNF_NID8, HNF_SLC_LRU_DUALMODE_INSERT_VALUE, 51, 2)
    FIELD(POR_HNF_AUX_CTL_U_HNF_NID8, HNF_SLC_LRU_STATICMODE_INSERT_VALUE, 49, 2)
    FIELD(POR_HNF_AUX_CTL_U_HNF_NID8, HNF_SLC_LRU_SLCSRC_INSERT_VALUE, 47, 2)
    FIELD(POR_HNF_AUX_CTL_U_HNF_NID8, HNF_SLC_LRU_SEL_CNT_VALUE, 45, 2)
    FIELD(POR_HNF_AUX_CTL_U_HNF_NID8, HNF_SLC_LRU_SET_GROUPS, 43, 2)
    FIELD(POR_HNF_AUX_CTL_U_HNF_NID8, HNF_SLC_LRU_VICTIM_DISABLE, 42, 1)
    FIELD(POR_HNF_AUX_CTL_U_HNF_NID8, HNF_SLC_VICTIM_QOS_HIGH, 41, 1)
    FIELD(POR_HNF_AUX_CTL_U_HNF_NID8, HNF_SF_SNP_VEC_DISABLE, 40, 1)
    FIELD(POR_HNF_AUX_CTL_U_HNF_NID8, HNF_STASH_DATAPULL_DISABLE, 39, 1)
    FIELD(POR_HNF_AUX_CTL_U_HNF_NID8, RESERVED_37, 37, 2)
    FIELD(POR_HNF_AUX_CTL_U_HNF_NID8, HNF_CU_EXCL_OPT_EN, 36, 1)
    FIELD(POR_HNF_AUX_CTL_U_HNF_NID8, RESERVED_34, 34, 2)
    FIELD(POR_HNF_AUX_CTL_U_HNF_NID8, HNF_EXCL_SNP_FWD_EN, 33, 1)
    FIELD(POR_HNF_AUX_CTL_U_HNF_NID8, HNF_RD_EXCL_OPT_EN, 32, 1)
    FIELD(POR_HNF_AUX_CTL_U_HNF_NID8, RESERVED_17, 17, 15)
    FIELD(POR_HNF_AUX_CTL_U_HNF_NID8, HNF_POISON_INTR_EN, 16, 1)
    FIELD(POR_HNF_AUX_CTL_U_HNF_NID8, HNF_DCT_DISABLE, 15, 1)
    FIELD(POR_HNF_AUX_CTL_U_HNF_NID8, WLU_ALLOC_ON_HIT, 14, 1)
    FIELD(POR_HNF_AUX_CTL_U_HNF_NID8, SF_DISABLE, 13, 1)
    FIELD(POR_HNF_AUX_CTL_U_HNF_NID8, CG_DISABLE, 12, 1)
    FIELD(POR_HNF_AUX_CTL_U_HNF_NID8, SLC_POR_INIT_DISABLE, 11, 1)
    FIELD(POR_HNF_AUX_CTL_U_HNF_NID8, FRZ_MON_ON_OVFL, 10, 1)
    FIELD(POR_HNF_AUX_CTL_U_HNF_NID8, DIS_SEQREQ_COLL, 9, 1)
    FIELD(POR_HNF_AUX_CTL_U_HNF_NID8, DIS_LIKELYSH, 8, 1)
    FIELD(POR_HNF_AUX_CTL_U_HNF_NID8, HNF_STASH_DISABLE, 7, 1)
    FIELD(POR_HNF_AUX_CTL_U_HNF_NID8, DIS_SNP_ONCE, 6, 1)
    FIELD(POR_HNF_AUX_CTL_U_HNF_NID8, NON_SH_NO_ALLOC, 5, 1)
    FIELD(POR_HNF_AUX_CTL_U_HNF_NID8, IO_READ_NO_ALLOC, 4, 1)
    FIELD(POR_HNF_AUX_CTL_U_HNF_NID8, REV_QOS_POOL_ALLOC, 3, 1)
    FIELD(POR_HNF_AUX_CTL_U_HNF_NID8, NO_WU_ALLOC, 2, 1)
    FIELD(POR_HNF_AUX_CTL_U_HNF_NID8, HNF_HONOR_EWA, 1, 1)
    FIELD(POR_HNF_AUX_CTL_U_HNF_NID8, HNF_ONLY_MODE, 0, 1)
REG32(POR_HNF_R2_AUX_CTL_U_HNF_NID8, 0x100a10)
    FIELD(POR_HNF_R2_AUX_CTL_U_HNF_NID8, HNF_SHD_RAM_LSCG_CG_DISABLE, 3, 1)
    FIELD(POR_HNF_R2_AUX_CTL_U_HNF_NID8, HNF_FORCE_FLUSH_EWA0_EN, 2, 1)
    FIELD(POR_HNF_R2_AUX_CTL_U_HNF_NID8, HNF_PCMO_TERMINATE_EN, 1, 1)
    FIELD(POR_HNF_R2_AUX_CTL_U_HNF_NID8, HNF_CHIC_RDNOSNPSEP_DIS, 0, 1)
REG32(RDF_HNF_AUX_CTL_U_HNF_NID8, 0x100a18)
    FIELD(RDF_HNF_AUX_CTL_U_HNF_NID8, RESERVED_16, 16, 48)
    FIELD(RDF_HNF_AUX_CTL_U_HNF_NID8, RDF_1CYCTAG_ECCMODE_OPT_DIS, 15, 1)
    FIELD(RDF_HNF_AUX_CTL_U_HNF_NID8, RESERVED_13, 13, 2)
    FIELD(RDF_HNF_AUX_CTL_U_HNF_NID8, RDF_ALLOW_CLN_DATA_FROM_NO_WR_AP, 12, 1)
    FIELD(RDF_HNF_AUX_CTL_U_HNF_NID8, RESERVED_10, 10, 2)
    FIELD(RDF_HNF_AUX_CTL_U_HNF_NID8, RDF_SNP_MPU_ERR_LOG_EN, 9, 1)
    FIELD(RDF_HNF_AUX_CTL_U_HNF_NID8, RDF_MPU_ERR_LOG_DIS, 8, 1)
    FIELD(RDF_HNF_AUX_CTL_U_HNF_NID8, RESERVED_0, 0, 8)
REG32(POR_HNF_QOS_BAND_U_HNF_NID8, 0x100a80)
    FIELD(POR_HNF_QOS_BAND_U_HNF_NID8, RESERVED_32, 32, 32)
    FIELD(POR_HNF_QOS_BAND_U_HNF_NID8, HIGHHIGH_MAX_QOS_VAL, 28, 4)
    FIELD(POR_HNF_QOS_BAND_U_HNF_NID8, HIGHHIGH_MIN_QOS_VAL, 24, 4)
    FIELD(POR_HNF_QOS_BAND_U_HNF_NID8, HIGH_MAX_QOS_VAL, 20, 4)
    FIELD(POR_HNF_QOS_BAND_U_HNF_NID8, HIGH_MIN_QOS_VAL, 16, 4)
    FIELD(POR_HNF_QOS_BAND_U_HNF_NID8, MED_MAX_QOS_VAL, 12, 4)
    FIELD(POR_HNF_QOS_BAND_U_HNF_NID8, MED_MIN_QOS_VAL, 8, 4)
    FIELD(POR_HNF_QOS_BAND_U_HNF_NID8, LOW_MAX_QOS_VAL, 4, 4)
    FIELD(POR_HNF_QOS_BAND_U_HNF_NID8, LOW_MIN_QOS_VAL, 0, 4)
REG32(POR_HNF_QOS_RESERVATION_U_HNF_NID8, 0x100a88)
    FIELD(POR_HNF_QOS_RESERVATION_U_HNF_NID8, RESERVED_38, 38, 26)
    FIELD(POR_HNF_QOS_RESERVATION_U_HNF_NID8, SEQ_QOS_MAX_CNT, 32, 6)
    FIELD(POR_HNF_QOS_RESERVATION_U_HNF_NID8, RESERVED_30, 30, 2)
    FIELD(POR_HNF_QOS_RESERVATION_U_HNF_NID8, HIGHHIGH_QOS_MAX_CNT, 24, 6)
    FIELD(POR_HNF_QOS_RESERVATION_U_HNF_NID8, RESERVED_22, 22, 2)
    FIELD(POR_HNF_QOS_RESERVATION_U_HNF_NID8, HIGH_QOS_MAX_CNT, 16, 6)
    FIELD(POR_HNF_QOS_RESERVATION_U_HNF_NID8, RESERVED_14, 14, 2)
    FIELD(POR_HNF_QOS_RESERVATION_U_HNF_NID8, MED_QOS_MAX_CNT, 8, 6)
    FIELD(POR_HNF_QOS_RESERVATION_U_HNF_NID8, LOW_QOS_MAX_CNT, 0, 6)
REG32(POR_HNF_RN_STARVATION_U_HNF_NID8, 0x100a90)
    FIELD(POR_HNF_RN_STARVATION_U_HNF_NID8, RESERVED_45, 45, 19)
    FIELD(POR_HNF_RN_STARVATION_U_HNF_NID8, RN_HIGH_OVER_HIGH_HIGH_MAX_CNT, 40, 5)
    FIELD(POR_HNF_RN_STARVATION_U_HNF_NID8, RESERVED_38, 38, 2)
    FIELD(POR_HNF_RN_STARVATION_U_HNF_NID8, RN_MED_OVER_HIGHHIGH_MAX_CNT, 32, 6)
    FIELD(POR_HNF_RN_STARVATION_U_HNF_NID8, RESERVED_29, 29, 3)
    FIELD(POR_HNF_RN_STARVATION_U_HNF_NID8, RN_MED_OVER_HIGH_MAX_CNT, 24, 5)
    FIELD(POR_HNF_RN_STARVATION_U_HNF_NID8, RESERVED_23, 23, 1)
    FIELD(POR_HNF_RN_STARVATION_U_HNF_NID8, RN_LOW_OVER_HIGHHIGH_MAX_CNT, 16, 7)
    FIELD(POR_HNF_RN_STARVATION_U_HNF_NID8, RESERVED_14, 14, 2)
    FIELD(POR_HNF_RN_STARVATION_U_HNF_NID8, RN_LOW_OVER_HIGH_MAX_CNT, 8, 6)
    FIELD(POR_HNF_RN_STARVATION_U_HNF_NID8, RN_LOW_OVER_MED_MAX_CNT, 0, 5)
REG32(POR_HNF_CFG_SLCSF_DBGRD_U_HNF_NID8, 0x100b80)
    FIELD(POR_HNF_CFG_SLCSF_DBGRD_U_HNF_NID8, RESERVED_26, 26, 38)
    FIELD(POR_HNF_CFG_SLCSF_DBGRD_U_HNF_NID8, SLC_ACCESS_COMPONENT, 24, 2)
    FIELD(POR_HNF_CFG_SLCSF_DBGRD_U_HNF_NID8, RESERVED_23, 23, 1)
    FIELD(POR_HNF_CFG_SLCSF_DBGRD_U_HNF_NID8, SLC_ACCESS_DW, 20, 3)
    FIELD(POR_HNF_CFG_SLCSF_DBGRD_U_HNF_NID8, SLC_ACCESS_WAY, 16, 4)
    FIELD(POR_HNF_CFG_SLCSF_DBGRD_U_HNF_NID8, RESERVED_13, 13, 3)
    FIELD(POR_HNF_CFG_SLCSF_DBGRD_U_HNF_NID8, SLC_ACCESS_SET, 0, 13)
REG32(POR_HNF_SLC_CACHE_ACCESS_SLC_TAG_U_HNF_NID8, 0x100b88)
    FIELD(POR_HNF_SLC_CACHE_ACCESS_SLC_TAG_U_HNF_NID8, RESERVED_48, 48, 16)
    FIELD(POR_HNF_SLC_CACHE_ACCESS_SLC_TAG_U_HNF_NID8, SLC_CACHE_ACCESS_SLC_TAG, 0, 48)
REG32(POR_HNF_SLC_CACHE_ACCESS_SLC_DATA_U_HNF_NID8, 0x100b90)
REG32(POR_HNF_SLC_CACHE_ACCESS_SF_TAG_U_HNF_NID8, 0x100b98)
REG32(POR_HNF_SLC_CACHE_ACCESS_SF_TAG1_U_HNF_NID8, 0x100ba0)
REG32(POR_HNF_SLC_CACHE_ACCESS_SF_TAG2_U_HNF_NID8, 0x100ba8)
REG32(POR_HNF_SLC_LOCK_WAYS_U_HNF_NID8, 0x100c00)
    FIELD(POR_HNF_SLC_LOCK_WAYS_U_HNF_NID8, RESERVED_15, 15, 49)
    FIELD(POR_HNF_SLC_LOCK_WAYS_U_HNF_NID8, NUM_HNF, 8, 7)
    FIELD(POR_HNF_SLC_LOCK_WAYS_U_HNF_NID8, WAYS, 0, 4)
REG32(POR_HNF_SLC_LOCK_BASE0_U_HNF_NID8, 0x100c08)
    FIELD(POR_HNF_SLC_LOCK_BASE0_U_HNF_NID8, BASE0_VLD, 63, 1)
    FIELD(POR_HNF_SLC_LOCK_BASE0_U_HNF_NID8, RESERVED_48, 48, 15)
    FIELD(POR_HNF_SLC_LOCK_BASE0_U_HNF_NID8, BASE0, 0, 48)
REG32(POR_HNF_SLC_LOCK_BASE1_U_HNF_NID8, 0x100c10)
    FIELD(POR_HNF_SLC_LOCK_BASE1_U_HNF_NID8, BASE1_VLD, 63, 1)
    FIELD(POR_HNF_SLC_LOCK_BASE1_U_HNF_NID8, RESERVED_48, 48, 15)
    FIELD(POR_HNF_SLC_LOCK_BASE1_U_HNF_NID8, BASE1, 0, 48)
REG32(POR_HNF_SLC_LOCK_BASE2_U_HNF_NID8, 0x100c18)
    FIELD(POR_HNF_SLC_LOCK_BASE2_U_HNF_NID8, BASE2_VLD, 63, 1)
    FIELD(POR_HNF_SLC_LOCK_BASE2_U_HNF_NID8, RESERVED_48, 48, 15)
    FIELD(POR_HNF_SLC_LOCK_BASE2_U_HNF_NID8, BASE2, 0, 48)
REG32(POR_HNF_SLC_LOCK_BASE3_U_HNF_NID8, 0x100c20)
    FIELD(POR_HNF_SLC_LOCK_BASE3_U_HNF_NID8, BASE3_VLD, 63, 1)
    FIELD(POR_HNF_SLC_LOCK_BASE3_U_HNF_NID8, RESERVED_48, 48, 15)
    FIELD(POR_HNF_SLC_LOCK_BASE3_U_HNF_NID8, BASE3, 0, 48)
REG32(POR_HNF_RNF_REGION_VEC1_U_HNF_NID8, 0x100c28)
REG32(POR_HNF_RNI_REGION_VEC_U_HNF_NID8, 0x100c30)
    FIELD(POR_HNF_RNI_REGION_VEC_U_HNF_NID8, RESERVED_32, 32, 32)
    FIELD(POR_HNF_RNI_REGION_VEC_U_HNF_NID8, RNI_REGION_VEC, 0, 32)
REG32(POR_HNF_RNF_REGION_VEC_U_HNF_NID8, 0x100c38)
REG32(POR_HNF_RND_REGION_VEC_U_HNF_NID8, 0x100c40)
    FIELD(POR_HNF_RND_REGION_VEC_U_HNF_NID8, RESERVED_32, 32, 32)
    FIELD(POR_HNF_RND_REGION_VEC_U_HNF_NID8, RND_REGION_VEC, 0, 32)
REG32(POR_HNF_SLCWAY_PARTITION0_RNF_VEC_U_HNF_NID8, 0x100c48)
REG32(POR_HNF_SLCWAY_PARTITION1_RNF_VEC_U_HNF_NID8, 0x100c50)
REG32(POR_HNF_SLCWAY_PARTITION2_RNF_VEC_U_HNF_NID8, 0x100c58)
REG32(POR_HNF_SLCWAY_PARTITION3_RNF_VEC_U_HNF_NID8, 0x100c60)
REG32(POR_HNF_SLCWAY_PARTITION0_RNI_VEC_U_HNF_NID8, 0x100c68)
    FIELD(POR_HNF_SLCWAY_PARTITION0_RNI_VEC_U_HNF_NID8, RESERVED_32, 32, 32)
    FIELD(POR_HNF_SLCWAY_PARTITION0_RNI_VEC_U_HNF_NID8, RNI_VEC0, 0, 32)
REG32(POR_HNF_SLCWAY_PARTITION1_RNI_VEC_U_HNF_NID8, 0x100c70)
    FIELD(POR_HNF_SLCWAY_PARTITION1_RNI_VEC_U_HNF_NID8, RESERVED_32, 32, 32)
    FIELD(POR_HNF_SLCWAY_PARTITION1_RNI_VEC_U_HNF_NID8, RNI_VEC1, 0, 32)
REG32(POR_HNF_SLCWAY_PARTITION2_RNI_VEC_U_HNF_NID8, 0x100c78)
    FIELD(POR_HNF_SLCWAY_PARTITION2_RNI_VEC_U_HNF_NID8, RESERVED_32, 32, 32)
    FIELD(POR_HNF_SLCWAY_PARTITION2_RNI_VEC_U_HNF_NID8, RNI_VEC2, 0, 32)
REG32(POR_HNF_SLCWAY_PARTITION3_RNI_VEC_U_HNF_NID8, 0x100c80)
    FIELD(POR_HNF_SLCWAY_PARTITION3_RNI_VEC_U_HNF_NID8, RESERVED_32, 32, 32)
    FIELD(POR_HNF_SLCWAY_PARTITION3_RNI_VEC_U_HNF_NID8, RNI_VEC3, 0, 32)
REG32(POR_HNF_SLCWAY_PARTITION0_RND_VEC_U_HNF_NID8, 0x100c88)
    FIELD(POR_HNF_SLCWAY_PARTITION0_RND_VEC_U_HNF_NID8, RESERVED_32, 32, 32)
    FIELD(POR_HNF_SLCWAY_PARTITION0_RND_VEC_U_HNF_NID8, RND_VEC0, 0, 32)
REG32(POR_HNF_SLCWAY_PARTITION1_RND_VEC_U_HNF_NID8, 0x100c90)
    FIELD(POR_HNF_SLCWAY_PARTITION1_RND_VEC_U_HNF_NID8, RESERVED_32, 32, 32)
    FIELD(POR_HNF_SLCWAY_PARTITION1_RND_VEC_U_HNF_NID8, RND_VEC1, 0, 32)
REG32(POR_HNF_SLCWAY_PARTITION2_RND_VEC_U_HNF_NID8, 0x100c98)
    FIELD(POR_HNF_SLCWAY_PARTITION2_RND_VEC_U_HNF_NID8, RESERVED_32, 32, 32)
    FIELD(POR_HNF_SLCWAY_PARTITION2_RND_VEC_U_HNF_NID8, RND_VEC2, 0, 32)
REG32(POR_HNF_SLCWAY_PARTITION3_RND_VEC_U_HNF_NID8, 0x100ca0)
    FIELD(POR_HNF_SLCWAY_PARTITION3_RND_VEC_U_HNF_NID8, RESERVED_32, 32, 32)
    FIELD(POR_HNF_SLCWAY_PARTITION3_RND_VEC_U_HNF_NID8, RND_VEC3, 0, 32)
REG32(POR_HNF_RN_REGION_LOCK_U_HNF_NID8, 0x100ca8)
    FIELD(POR_HNF_RN_REGION_LOCK_U_HNF_NID8, RN_PICK_LOCKED_WAYS_ONLY, 1, 1)
    FIELD(POR_HNF_RN_REGION_LOCK_U_HNF_NID8, RN_REGION_LOCK_EN, 0, 1)
REG32(POR_HNF_SLCWAY_PARTITION0_RNF_VEC1_U_HNF_NID8, 0x100cb0)
REG32(POR_HNF_SLCWAY_PARTITION1_RNF_VEC1_U_HNF_NID8, 0x100cb8)
REG32(POR_HNF_SLCWAY_PARTITION2_RNF_VEC1_U_HNF_NID8, 0x100cc0)
REG32(POR_HNF_SLCWAY_PARTITION3_RNF_VEC1_U_HNF_NID8, 0x100cc8)
REG32(POR_HNF_SAM_CONTROL_U_HNF_NID8, 0x100d00)
    FIELD(POR_HNF_SAM_CONTROL_U_HNF_NID8, HN_CFG_SAM_INV_TOP_ADDRESS_BIT, 63, 1)
    FIELD(POR_HNF_SAM_CONTROL_U_HNF_NID8, RESERVED_62, 62, 1)
    FIELD(POR_HNF_SAM_CONTROL_U_HNF_NID8, HN_CFG_SAM_TOP_ADDRESS_BIT2, 56, 6)
    FIELD(POR_HNF_SAM_CONTROL_U_HNF_NID8, RESERVED_54, 54, 2)
    FIELD(POR_HNF_SAM_CONTROL_U_HNF_NID8, HN_CFG_SAM_TOP_ADDRESS_BIT1, 48, 6)
    FIELD(POR_HNF_SAM_CONTROL_U_HNF_NID8, RESERVED_46, 46, 2)
    FIELD(POR_HNF_SAM_CONTROL_U_HNF_NID8, HN_CFG_SAM_TOP_ADDRESS_BIT0, 40, 6)
    FIELD(POR_HNF_SAM_CONTROL_U_HNF_NID8, RESERVED_38, 38, 2)
    FIELD(POR_HNF_SAM_CONTROL_U_HNF_NID8, HN_CFG_SIX_SN_EN, 37, 1)
    FIELD(POR_HNF_SAM_CONTROL_U_HNF_NID8, HN_CFG_THREE_SN_EN, 36, 1)
    FIELD(POR_HNF_SAM_CONTROL_U_HNF_NID8, RESERVED_35, 35, 1)
    FIELD(POR_HNF_SAM_CONTROL_U_HNF_NID8, HN_CFG_SN2_NODEID, 24, 11)
    FIELD(POR_HNF_SAM_CONTROL_U_HNF_NID8, RESERVED_23, 23, 1)
    FIELD(POR_HNF_SAM_CONTROL_U_HNF_NID8, HN_CFG_SN1_NODEID, 12, 11)
    FIELD(POR_HNF_SAM_CONTROL_U_HNF_NID8, RESERVED_11, 11, 1)
    FIELD(POR_HNF_SAM_CONTROL_U_HNF_NID8, HN_CFG_SN0_NODEID, 0, 11)
REG32(POR_HNF_SAM_MEMREGION0_U_HNF_NID8, 0x100d08)
    FIELD(POR_HNF_SAM_MEMREGION0_U_HNF_NID8, VALID, 63, 1)
    FIELD(POR_HNF_SAM_MEMREGION0_U_HNF_NID8, RESERVED_48, 48, 15)
    FIELD(POR_HNF_SAM_MEMREGION0_U_HNF_NID8, BASE_ADDR, 26, 22)
    FIELD(POR_HNF_SAM_MEMREGION0_U_HNF_NID8, RESERVED_17, 17, 9)
    FIELD(POR_HNF_SAM_MEMREGION0_U_HNF_NID8, SIZE, 12, 5)
    FIELD(POR_HNF_SAM_MEMREGION0_U_HNF_NID8, RESERVED_11, 11, 1)
    FIELD(POR_HNF_SAM_MEMREGION0_U_HNF_NID8, RANGE0_NODEID, 0, 11)
REG32(POR_HNF_SAM_MEMREGION1_U_HNF_NID8, 0x100d10)
    FIELD(POR_HNF_SAM_MEMREGION1_U_HNF_NID8, VALID, 63, 1)
    FIELD(POR_HNF_SAM_MEMREGION1_U_HNF_NID8, RESERVED_48, 48, 15)
    FIELD(POR_HNF_SAM_MEMREGION1_U_HNF_NID8, BASE_ADDR, 26, 22)
    FIELD(POR_HNF_SAM_MEMREGION1_U_HNF_NID8, RESERVED_17, 17, 9)
    FIELD(POR_HNF_SAM_MEMREGION1_U_HNF_NID8, SIZE, 12, 5)
    FIELD(POR_HNF_SAM_MEMREGION1_U_HNF_NID8, RESERVED_11, 11, 1)
    FIELD(POR_HNF_SAM_MEMREGION1_U_HNF_NID8, RANGE1_NODEID, 0, 11)
REG32(POR_HNF_SAM_SN_PROPERTIES_U_HNF_NID8, 0x100d18)
    FIELD(POR_HNF_SAM_SN_PROPERTIES_U_HNF_NID8, RESERVED_45, 45, 19)
    FIELD(POR_HNF_SAM_SN_PROPERTIES_U_HNF_NID8, RANGE1_SN_PCMO_PROP_DIS, 44, 1)
    FIELD(POR_HNF_SAM_SN_PROPERTIES_U_HNF_NID8, RANGE1_SN_CMO_PROP_EN, 43, 1)
    FIELD(POR_HNF_SAM_SN_PROPERTIES_U_HNF_NID8, RANGE1_SN_128B, 42, 1)
    FIELD(POR_HNF_SAM_SN_PROPERTIES_U_HNF_NID8, RESERVED_39, 39, 3)
    FIELD(POR_HNF_SAM_SN_PROPERTIES_U_HNF_NID8, RANGE0_SN_PCMO_PROP_DIS, 38, 1)
    FIELD(POR_HNF_SAM_SN_PROPERTIES_U_HNF_NID8, RANGE0_SN_CMO_PROP_EN, 37, 1)
    FIELD(POR_HNF_SAM_SN_PROPERTIES_U_HNF_NID8, RANGE0_SN_128B, 36, 1)
    FIELD(POR_HNF_SAM_SN_PROPERTIES_U_HNF_NID8, RESERVED_33, 33, 3)
    FIELD(POR_HNF_SAM_SN_PROPERTIES_U_HNF_NID8, SN5_PCMO_PROP_DIS, 32, 1)
    FIELD(POR_HNF_SAM_SN_PROPERTIES_U_HNF_NID8, SN5_CMO_PROP_EN, 31, 1)
    FIELD(POR_HNF_SAM_SN_PROPERTIES_U_HNF_NID8, SN5_128B, 30, 1)
    FIELD(POR_HNF_SAM_SN_PROPERTIES_U_HNF_NID8, RESERVED_27, 27, 3)
    FIELD(POR_HNF_SAM_SN_PROPERTIES_U_HNF_NID8, SN4_PCMO_PROP_DIS, 26, 1)
    FIELD(POR_HNF_SAM_SN_PROPERTIES_U_HNF_NID8, SN4_CMO_PROP_EN, 25, 1)
    FIELD(POR_HNF_SAM_SN_PROPERTIES_U_HNF_NID8, SN4_128B, 24, 1)
    FIELD(POR_HNF_SAM_SN_PROPERTIES_U_HNF_NID8, RESERVED_21, 21, 3)
    FIELD(POR_HNF_SAM_SN_PROPERTIES_U_HNF_NID8, SN3_PCMO_PROP_DIS, 20, 1)
    FIELD(POR_HNF_SAM_SN_PROPERTIES_U_HNF_NID8, SN3_CMO_PROP_EN, 19, 1)
    FIELD(POR_HNF_SAM_SN_PROPERTIES_U_HNF_NID8, SN3_128B, 18, 1)
    FIELD(POR_HNF_SAM_SN_PROPERTIES_U_HNF_NID8, RESERVED_15, 15, 3)
    FIELD(POR_HNF_SAM_SN_PROPERTIES_U_HNF_NID8, SN2_PCMO_PROP_DIS, 14, 1)
    FIELD(POR_HNF_SAM_SN_PROPERTIES_U_HNF_NID8, SN2_CMO_PROP_EN, 13, 1)
    FIELD(POR_HNF_SAM_SN_PROPERTIES_U_HNF_NID8, SN2_128B, 12, 1)
    FIELD(POR_HNF_SAM_SN_PROPERTIES_U_HNF_NID8, RESERVED_9, 9, 3)
    FIELD(POR_HNF_SAM_SN_PROPERTIES_U_HNF_NID8, SN1_PCMO_PROP_DIS, 8, 1)
    FIELD(POR_HNF_SAM_SN_PROPERTIES_U_HNF_NID8, SN1_CMO_PROP_EN, 7, 1)
    FIELD(POR_HNF_SAM_SN_PROPERTIES_U_HNF_NID8, SN1_128B, 6, 1)
    FIELD(POR_HNF_SAM_SN_PROPERTIES_U_HNF_NID8, SN0_PCMO_PROP_DIS, 2, 1)
    FIELD(POR_HNF_SAM_SN_PROPERTIES_U_HNF_NID8, SN0_CMO_PROP_EN, 1, 1)
    FIELD(POR_HNF_SAM_SN_PROPERTIES_U_HNF_NID8, SN0_128B, 0, 1)
REG32(POR_HNF_SAM_6SN_NODEID_U_HNF_NID8, 0x100d20)
    FIELD(POR_HNF_SAM_6SN_NODEID_U_HNF_NID8, RESERVED_35, 35, 29)
    FIELD(POR_HNF_SAM_6SN_NODEID_U_HNF_NID8, HN_CFG_SN5_NODEID, 24, 11)
    FIELD(POR_HNF_SAM_6SN_NODEID_U_HNF_NID8, RESERVED_23, 23, 1)
    FIELD(POR_HNF_SAM_6SN_NODEID_U_HNF_NID8, HN_CFG_SN4_NODEID, 12, 11)
    FIELD(POR_HNF_SAM_6SN_NODEID_U_HNF_NID8, RESERVED_11, 11, 1)
    FIELD(POR_HNF_SAM_6SN_NODEID_U_HNF_NID8, HN_CFG_SN3_NODEID, 0, 11)
REG32(POR_HNF_RN_PHYS_ID0_U_HNF_NID8, 0x100d28)
    FIELD(POR_HNF_RN_PHYS_ID0_U_HNF_NID8, VALID_RA1, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID0_U_HNF_NID8, CPA_EN_RA1, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID0_U_HNF_NID8, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID0_U_HNF_NID8, CPA_GRP_RA1, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID0_U_HNF_NID8, REMOTE_RA1, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID0_U_HNF_NID8, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID0_U_HNF_NID8, NODEID_RA1, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID0_U_HNF_NID8, VALID_RA0, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID0_U_HNF_NID8, CPA_EN_RA0, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID0_U_HNF_NID8, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID0_U_HNF_NID8, CPA_GRP_RA0, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID0_U_HNF_NID8, REMOTE_RA0, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID0_U_HNF_NID8, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID0_U_HNF_NID8, NODEID_RA0, 0, 11)
REG32(POR_HNF_RN_PHYS_ID1_U_HNF_NID8, 0x100d30)
    FIELD(POR_HNF_RN_PHYS_ID1_U_HNF_NID8, VALID_RA3, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID1_U_HNF_NID8, CPA_EN_RA3, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID1_U_HNF_NID8, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID1_U_HNF_NID8, CPA_GRP_RA3, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID1_U_HNF_NID8, REMOTE_RA3, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID1_U_HNF_NID8, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID1_U_HNF_NID8, NODEID_RA3, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID1_U_HNF_NID8, VALID_RA2, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID1_U_HNF_NID8, CPA_EN_RA2, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID1_U_HNF_NID8, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID1_U_HNF_NID8, CPA_GRP_RA2, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID1_U_HNF_NID8, REMOTE_RA2, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID1_U_HNF_NID8, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID1_U_HNF_NID8, NODEID_RA2, 0, 11)
REG32(POR_HNF_RN_PHYS_ID2_U_HNF_NID8, 0x100d38)
    FIELD(POR_HNF_RN_PHYS_ID2_U_HNF_NID8, VALID_RA5, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID2_U_HNF_NID8, CPA_EN_RA5, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID2_U_HNF_NID8, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID2_U_HNF_NID8, CPA_GRP_RA5, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID2_U_HNF_NID8, REMOTE_RA5, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID2_U_HNF_NID8, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID2_U_HNF_NID8, NODEID_RA5, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID2_U_HNF_NID8, VALID_RA4, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID2_U_HNF_NID8, CPA_EN_RA4, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID2_U_HNF_NID8, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID2_U_HNF_NID8, CPA_GRP_RA4, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID2_U_HNF_NID8, REMOTE_RA4, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID2_U_HNF_NID8, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID2_U_HNF_NID8, NODEID_RA4, 0, 11)
REG32(POR_HNF_RN_PHYS_ID3_U_HNF_NID8, 0x100d40)
    FIELD(POR_HNF_RN_PHYS_ID3_U_HNF_NID8, VALID_RA7, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID3_U_HNF_NID8, CPA_EN_RA7, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID3_U_HNF_NID8, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID3_U_HNF_NID8, CPA_GRP_RA7, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID3_U_HNF_NID8, REMOTE_RA7, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID3_U_HNF_NID8, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID3_U_HNF_NID8, NODEID_RA7, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID3_U_HNF_NID8, VALID_RA6, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID3_U_HNF_NID8, CPA_EN_RA6, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID3_U_HNF_NID8, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID3_U_HNF_NID8, CPA_GRP_RA6, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID3_U_HNF_NID8, REMOTE_RA6, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID3_U_HNF_NID8, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID3_U_HNF_NID8, NODEID_RA6, 0, 11)
REG32(POR_HNF_RN_PHYS_ID4_U_HNF_NID8, 0x100d48)
    FIELD(POR_HNF_RN_PHYS_ID4_U_HNF_NID8, VALID_RA9, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID4_U_HNF_NID8, CPA_EN_RA9, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID4_U_HNF_NID8, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID4_U_HNF_NID8, CPA_GRP_RA9, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID4_U_HNF_NID8, REMOTE_RA9, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID4_U_HNF_NID8, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID4_U_HNF_NID8, NODEID_RA9, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID4_U_HNF_NID8, VALID_RA8, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID4_U_HNF_NID8, CPA_EN_RA8, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID4_U_HNF_NID8, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID4_U_HNF_NID8, CPA_GRP_RA8, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID4_U_HNF_NID8, REMOTE_RA8, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID4_U_HNF_NID8, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID4_U_HNF_NID8, NODEID_RA8, 0, 11)
REG32(POR_HNF_RN_PHYS_ID5_U_HNF_NID8, 0x100d50)
    FIELD(POR_HNF_RN_PHYS_ID5_U_HNF_NID8, VALID_RA11, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID5_U_HNF_NID8, CPA_EN_RA11, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID5_U_HNF_NID8, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID5_U_HNF_NID8, CPA_GRP_RA11, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID5_U_HNF_NID8, REMOTE_RA11, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID5_U_HNF_NID8, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID5_U_HNF_NID8, NODEID_RA11, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID5_U_HNF_NID8, VALID_RA10, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID5_U_HNF_NID8, CPA_EN_RA10, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID5_U_HNF_NID8, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID5_U_HNF_NID8, CPA_GRP_RA10, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID5_U_HNF_NID8, REMOTE_RA10, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID5_U_HNF_NID8, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID5_U_HNF_NID8, NODEID_RA10, 0, 11)
REG32(POR_HNF_RN_PHYS_ID6_U_HNF_NID8, 0x100d58)
    FIELD(POR_HNF_RN_PHYS_ID6_U_HNF_NID8, VALID_RA13, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID6_U_HNF_NID8, CPA_EN_RA13, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID6_U_HNF_NID8, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID6_U_HNF_NID8, CPA_GRP_RA13, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID6_U_HNF_NID8, REMOTE_RA13, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID6_U_HNF_NID8, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID6_U_HNF_NID8, NODEID_RA13, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID6_U_HNF_NID8, VALID_RA12, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID6_U_HNF_NID8, CPA_EN_RA12, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID6_U_HNF_NID8, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID6_U_HNF_NID8, CPA_GRP_RA12, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID6_U_HNF_NID8, REMOTE_RA12, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID6_U_HNF_NID8, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID6_U_HNF_NID8, NODEID_RA12, 0, 11)
REG32(POR_HNF_RN_PHYS_ID7_U_HNF_NID8, 0x100d60)
    FIELD(POR_HNF_RN_PHYS_ID7_U_HNF_NID8, VALID_RA15, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID7_U_HNF_NID8, CPA_EN_RA15, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID7_U_HNF_NID8, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID7_U_HNF_NID8, CPA_GRP_RA15, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID7_U_HNF_NID8, REMOTE_RA15, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID7_U_HNF_NID8, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID7_U_HNF_NID8, NODEID_RA15, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID7_U_HNF_NID8, VALID_RA14, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID7_U_HNF_NID8, CPA_EN_RA14, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID7_U_HNF_NID8, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID7_U_HNF_NID8, CPA_GRP_RA14, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID7_U_HNF_NID8, REMOTE_RA14, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID7_U_HNF_NID8, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID7_U_HNF_NID8, NODEID_RA14, 0, 11)
REG32(POR_HNF_RN_PHYS_ID8_U_HNF_NID8, 0x100d68)
    FIELD(POR_HNF_RN_PHYS_ID8_U_HNF_NID8, VALID_RA17, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID8_U_HNF_NID8, CPA_EN_RA17, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID8_U_HNF_NID8, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID8_U_HNF_NID8, CPA_GRP_RA17, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID8_U_HNF_NID8, REMOTE_RA17, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID8_U_HNF_NID8, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID8_U_HNF_NID8, NODEID_RA17, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID8_U_HNF_NID8, VALID_RA16, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID8_U_HNF_NID8, CPA_EN_RA16, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID8_U_HNF_NID8, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID8_U_HNF_NID8, CPA_GRP_RA16, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID8_U_HNF_NID8, REMOTE_RA16, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID8_U_HNF_NID8, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID8_U_HNF_NID8, NODEID_RA16, 0, 11)
REG32(POR_HNF_RN_PHYS_ID9_U_HNF_NID8, 0x100d70)
    FIELD(POR_HNF_RN_PHYS_ID9_U_HNF_NID8, VALID_RA19, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID9_U_HNF_NID8, CPA_EN_RA19, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID9_U_HNF_NID8, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID9_U_HNF_NID8, CPA_GRP_RA19, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID9_U_HNF_NID8, REMOTE_RA19, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID9_U_HNF_NID8, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID9_U_HNF_NID8, NODEID_RA19, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID9_U_HNF_NID8, VALID_RA18, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID9_U_HNF_NID8, CPA_EN_RA18, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID9_U_HNF_NID8, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID9_U_HNF_NID8, CPA_GRP_RA18, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID9_U_HNF_NID8, REMOTE_RA18, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID9_U_HNF_NID8, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID9_U_HNF_NID8, NODEID_RA18, 0, 11)
REG32(POR_HNF_RN_PHYS_ID10_U_HNF_NID8, 0x100d78)
    FIELD(POR_HNF_RN_PHYS_ID10_U_HNF_NID8, VALID_RA21, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID10_U_HNF_NID8, CPA_EN_RA21, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID10_U_HNF_NID8, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID10_U_HNF_NID8, CPA_GRP_RA21, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID10_U_HNF_NID8, REMOTE_RA21, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID10_U_HNF_NID8, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID10_U_HNF_NID8, NODEID_RA21, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID10_U_HNF_NID8, VALID_RA20, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID10_U_HNF_NID8, CPA_EN_RA20, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID10_U_HNF_NID8, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID10_U_HNF_NID8, CPA_GRP_RA20, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID10_U_HNF_NID8, REMOTE_RA20, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID10_U_HNF_NID8, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID10_U_HNF_NID8, NODEID_RA20, 0, 11)
REG32(POR_HNF_RN_PHYS_ID11_U_HNF_NID8, 0x100d80)
    FIELD(POR_HNF_RN_PHYS_ID11_U_HNF_NID8, VALID_RA23, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID11_U_HNF_NID8, CPA_EN_RA23, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID11_U_HNF_NID8, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID11_U_HNF_NID8, CPA_GRP_RA23, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID11_U_HNF_NID8, REMOTE_RA23, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID11_U_HNF_NID8, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID11_U_HNF_NID8, NODEID_RA23, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID11_U_HNF_NID8, VALID_RA22, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID11_U_HNF_NID8, CPA_EN_RA22, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID11_U_HNF_NID8, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID11_U_HNF_NID8, CPA_GRP_RA22, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID11_U_HNF_NID8, REMOTE_RA22, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID11_U_HNF_NID8, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID11_U_HNF_NID8, NODEID_RA22, 0, 11)
REG32(POR_HNF_RN_PHYS_ID12_U_HNF_NID8, 0x100d88)
    FIELD(POR_HNF_RN_PHYS_ID12_U_HNF_NID8, VALID_RA25, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID12_U_HNF_NID8, CPA_EN_RA25, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID12_U_HNF_NID8, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID12_U_HNF_NID8, CPA_GRP_RA25, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID12_U_HNF_NID8, REMOTE_RA25, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID12_U_HNF_NID8, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID12_U_HNF_NID8, NODEID_RA25, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID12_U_HNF_NID8, VALID_RA24, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID12_U_HNF_NID8, CPA_EN_RA24, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID12_U_HNF_NID8, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID12_U_HNF_NID8, CPA_GRP_RA24, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID12_U_HNF_NID8, REMOTE_RA24, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID12_U_HNF_NID8, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID12_U_HNF_NID8, NODEID_RA24, 0, 11)
REG32(POR_HNF_RN_PHYS_ID13_U_HNF_NID8, 0x100d90)
    FIELD(POR_HNF_RN_PHYS_ID13_U_HNF_NID8, VALID_RA27, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID13_U_HNF_NID8, CPA_EN_RA27, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID13_U_HNF_NID8, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID13_U_HNF_NID8, CPA_GRP_RA27, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID13_U_HNF_NID8, REMOTE_RA27, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID13_U_HNF_NID8, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID13_U_HNF_NID8, NODEID_RA27, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID13_U_HNF_NID8, VALID_RA26, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID13_U_HNF_NID8, CPA_EN_RA26, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID13_U_HNF_NID8, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID13_U_HNF_NID8, CPA_GRP_RA26, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID13_U_HNF_NID8, REMOTE_RA26, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID13_U_HNF_NID8, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID13_U_HNF_NID8, NODEID_RA26, 0, 11)
REG32(POR_HNF_RN_PHYS_ID14_U_HNF_NID8, 0x100d98)
    FIELD(POR_HNF_RN_PHYS_ID14_U_HNF_NID8, VALID_RA29, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID14_U_HNF_NID8, CPA_EN_RA29, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID14_U_HNF_NID8, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID14_U_HNF_NID8, CPA_GRP_RA29, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID14_U_HNF_NID8, REMOTE_RA29, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID14_U_HNF_NID8, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID14_U_HNF_NID8, NODEID_RA29, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID14_U_HNF_NID8, VALID_RA28, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID14_U_HNF_NID8, CPA_EN_RA28, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID14_U_HNF_NID8, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID14_U_HNF_NID8, CPA_GRP_RA28, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID14_U_HNF_NID8, REMOTE_RA28, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID14_U_HNF_NID8, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID14_U_HNF_NID8, NODEID_RA28, 0, 11)
REG32(POR_HNF_RN_PHYS_ID15_U_HNF_NID8, 0x100da0)
    FIELD(POR_HNF_RN_PHYS_ID15_U_HNF_NID8, VALID_RA31, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID15_U_HNF_NID8, CPA_EN_RA31, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID15_U_HNF_NID8, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID15_U_HNF_NID8, CPA_GRP_RA31, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID15_U_HNF_NID8, REMOTE_RA31, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID15_U_HNF_NID8, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID15_U_HNF_NID8, NODEID_RA31, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID15_U_HNF_NID8, VALID_RA30, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID15_U_HNF_NID8, CPA_EN_RA30, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID15_U_HNF_NID8, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID15_U_HNF_NID8, CPA_GRP_RA30, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID15_U_HNF_NID8, REMOTE_RA30, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID15_U_HNF_NID8, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID15_U_HNF_NID8, NODEID_RA30, 0, 11)
REG32(POR_HNF_RN_PHYS_ID16_U_HNF_NID8, 0x100da8)
    FIELD(POR_HNF_RN_PHYS_ID16_U_HNF_NID8, VALID_RA33, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID16_U_HNF_NID8, CPA_EN_RA33, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID16_U_HNF_NID8, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID16_U_HNF_NID8, CPA_GRP_RA33, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID16_U_HNF_NID8, REMOTE_RA33, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID16_U_HNF_NID8, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID16_U_HNF_NID8, NODEID_RA33, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID16_U_HNF_NID8, VALID_RA32, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID16_U_HNF_NID8, CPA_EN_RA32, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID16_U_HNF_NID8, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID16_U_HNF_NID8, CPA_GRP_RA32, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID16_U_HNF_NID8, REMOTE_RA32, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID16_U_HNF_NID8, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID16_U_HNF_NID8, NODEID_RA32, 0, 11)
REG32(POR_HNF_RN_PHYS_ID17_U_HNF_NID8, 0x100db0)
    FIELD(POR_HNF_RN_PHYS_ID17_U_HNF_NID8, VALID_RA35, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID17_U_HNF_NID8, CPA_EN_RA35, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID17_U_HNF_NID8, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID17_U_HNF_NID8, CPA_GRP_RA35, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID17_U_HNF_NID8, REMOTE_RA35, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID17_U_HNF_NID8, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID17_U_HNF_NID8, NODEID_RA35, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID17_U_HNF_NID8, VALID_RA34, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID17_U_HNF_NID8, CPA_EN_RA34, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID17_U_HNF_NID8, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID17_U_HNF_NID8, CPA_GRP_RA34, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID17_U_HNF_NID8, REMOTE_RA34, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID17_U_HNF_NID8, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID17_U_HNF_NID8, NODEID_RA34, 0, 11)
REG32(POR_HNF_RN_PHYS_ID18_U_HNF_NID8, 0x100db8)
    FIELD(POR_HNF_RN_PHYS_ID18_U_HNF_NID8, VALID_RA37, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID18_U_HNF_NID8, CPA_EN_RA37, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID18_U_HNF_NID8, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID18_U_HNF_NID8, CPA_GRP_RA37, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID18_U_HNF_NID8, REMOTE_RA37, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID18_U_HNF_NID8, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID18_U_HNF_NID8, NODEID_RA37, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID18_U_HNF_NID8, VALID_RA36, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID18_U_HNF_NID8, CPA_EN_RA36, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID18_U_HNF_NID8, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID18_U_HNF_NID8, CPA_GRP_RA36, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID18_U_HNF_NID8, REMOTE_RA36, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID18_U_HNF_NID8, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID18_U_HNF_NID8, NODEID_RA36, 0, 11)
REG32(POR_HNF_RN_PHYS_ID19_U_HNF_NID8, 0x100dc0)
    FIELD(POR_HNF_RN_PHYS_ID19_U_HNF_NID8, VALID_RA39, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID19_U_HNF_NID8, CPA_EN_RA39, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID19_U_HNF_NID8, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID19_U_HNF_NID8, CPA_GRP_RA39, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID19_U_HNF_NID8, REMOTE_RA39, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID19_U_HNF_NID8, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID19_U_HNF_NID8, NODEID_RA39, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID19_U_HNF_NID8, VALID_RA38, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID19_U_HNF_NID8, CPA_EN_RA38, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID19_U_HNF_NID8, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID19_U_HNF_NID8, CPA_GRP_RA38, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID19_U_HNF_NID8, REMOTE_RA38, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID19_U_HNF_NID8, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID19_U_HNF_NID8, NODEID_RA38, 0, 11)
REG32(POR_HNF_RN_PHYS_ID20_U_HNF_NID8, 0x100dc8)
    FIELD(POR_HNF_RN_PHYS_ID20_U_HNF_NID8, VALID_RA41, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID20_U_HNF_NID8, CPA_EN_RA41, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID20_U_HNF_NID8, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID20_U_HNF_NID8, CPA_GRP_RA41, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID20_U_HNF_NID8, REMOTE_RA41, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID20_U_HNF_NID8, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID20_U_HNF_NID8, NODEID_RA41, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID20_U_HNF_NID8, VALID_RA40, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID20_U_HNF_NID8, CPA_EN_RA40, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID20_U_HNF_NID8, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID20_U_HNF_NID8, CPA_GRP_RA40, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID20_U_HNF_NID8, REMOTE_RA40, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID20_U_HNF_NID8, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID20_U_HNF_NID8, NODEID_RA40, 0, 11)
REG32(POR_HNF_RN_PHYS_ID21_U_HNF_NID8, 0x100dd0)
    FIELD(POR_HNF_RN_PHYS_ID21_U_HNF_NID8, VALID_RA43, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID21_U_HNF_NID8, CPA_EN_RA43, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID21_U_HNF_NID8, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID21_U_HNF_NID8, CPA_GRP_RA43, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID21_U_HNF_NID8, REMOTE_RA43, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID21_U_HNF_NID8, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID21_U_HNF_NID8, NODEID_RA43, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID21_U_HNF_NID8, VALID_RA42, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID21_U_HNF_NID8, CPA_EN_RA42, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID21_U_HNF_NID8, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID21_U_HNF_NID8, CPA_GRP_RA42, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID21_U_HNF_NID8, REMOTE_RA42, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID21_U_HNF_NID8, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID21_U_HNF_NID8, NODEID_RA42, 0, 11)
REG32(POR_HNF_RN_PHYS_ID22_U_HNF_NID8, 0x100dd8)
    FIELD(POR_HNF_RN_PHYS_ID22_U_HNF_NID8, VALID_RA45, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID22_U_HNF_NID8, CPA_EN_RA45, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID22_U_HNF_NID8, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID22_U_HNF_NID8, CPA_GRP_RA45, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID22_U_HNF_NID8, REMOTE_RA45, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID22_U_HNF_NID8, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID22_U_HNF_NID8, NODEID_RA45, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID22_U_HNF_NID8, VALID_RA44, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID22_U_HNF_NID8, CPA_EN_RA44, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID22_U_HNF_NID8, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID22_U_HNF_NID8, CPA_GRP_RA44, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID22_U_HNF_NID8, REMOTE_RA44, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID22_U_HNF_NID8, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID22_U_HNF_NID8, NODEID_RA44, 0, 11)
REG32(POR_HNF_RN_PHYS_ID23_U_HNF_NID8, 0x100de0)
    FIELD(POR_HNF_RN_PHYS_ID23_U_HNF_NID8, VALID_RA47, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID23_U_HNF_NID8, CPA_EN_RA47, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID23_U_HNF_NID8, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID23_U_HNF_NID8, CPA_GRP_RA47, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID23_U_HNF_NID8, REMOTE_RA47, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID23_U_HNF_NID8, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID23_U_HNF_NID8, NODEID_RA47, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID23_U_HNF_NID8, VALID_RA46, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID23_U_HNF_NID8, CPA_EN_RA46, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID23_U_HNF_NID8, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID23_U_HNF_NID8, CPA_GRP_RA46, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID23_U_HNF_NID8, REMOTE_RA46, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID23_U_HNF_NID8, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID23_U_HNF_NID8, NODEID_RA46, 0, 11)
REG32(POR_HNF_RN_PHYS_ID24_U_HNF_NID8, 0x100de8)
    FIELD(POR_HNF_RN_PHYS_ID24_U_HNF_NID8, VALID_RA49, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID24_U_HNF_NID8, CPA_EN_RA49, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID24_U_HNF_NID8, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID24_U_HNF_NID8, CPA_GRP_RA49, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID24_U_HNF_NID8, REMOTE_RA49, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID24_U_HNF_NID8, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID24_U_HNF_NID8, NODEID_RA49, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID24_U_HNF_NID8, VALID_RA48, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID24_U_HNF_NID8, CPA_EN_RA48, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID24_U_HNF_NID8, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID24_U_HNF_NID8, CPA_GRP_RA48, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID24_U_HNF_NID8, REMOTE_RA48, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID24_U_HNF_NID8, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID24_U_HNF_NID8, NODEID_RA48, 0, 11)
REG32(POR_HNF_RN_PHYS_ID25_U_HNF_NID8, 0x100df0)
    FIELD(POR_HNF_RN_PHYS_ID25_U_HNF_NID8, VALID_RA51, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID25_U_HNF_NID8, CPA_EN_RA51, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID25_U_HNF_NID8, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID25_U_HNF_NID8, CPA_GRP_RA51, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID25_U_HNF_NID8, REMOTE_RA51, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID25_U_HNF_NID8, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID25_U_HNF_NID8, NODEID_RA51, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID25_U_HNF_NID8, VALID_RA50, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID25_U_HNF_NID8, CPA_EN_RA50, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID25_U_HNF_NID8, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID25_U_HNF_NID8, CPA_GRP_RA50, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID25_U_HNF_NID8, REMOTE_RA50, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID25_U_HNF_NID8, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID25_U_HNF_NID8, NODEID_RA50, 0, 11)
REG32(POR_HNF_RN_PHYS_ID26_U_HNF_NID8, 0x100df8)
    FIELD(POR_HNF_RN_PHYS_ID26_U_HNF_NID8, VALID_RA53, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID26_U_HNF_NID8, CPA_EN_RA53, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID26_U_HNF_NID8, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID26_U_HNF_NID8, CPA_GRP_RA53, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID26_U_HNF_NID8, REMOTE_RA53, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID26_U_HNF_NID8, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID26_U_HNF_NID8, NODEID_RA53, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID26_U_HNF_NID8, VALID_RA52, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID26_U_HNF_NID8, CPA_EN_RA52, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID26_U_HNF_NID8, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID26_U_HNF_NID8, CPA_GRP_RA52, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID26_U_HNF_NID8, REMOTE_RA52, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID26_U_HNF_NID8, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID26_U_HNF_NID8, NODEID_RA52, 0, 11)
REG32(POR_HNF_RN_PHYS_ID27_U_HNF_NID8, 0x100e00)
    FIELD(POR_HNF_RN_PHYS_ID27_U_HNF_NID8, VALID_RA55, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID27_U_HNF_NID8, CPA_EN_RA55, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID27_U_HNF_NID8, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID27_U_HNF_NID8, CPA_GRP_RA55, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID27_U_HNF_NID8, REMOTE_RA55, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID27_U_HNF_NID8, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID27_U_HNF_NID8, NODEID_RA55, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID27_U_HNF_NID8, VALID_RA54, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID27_U_HNF_NID8, CPA_EN_RA54, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID27_U_HNF_NID8, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID27_U_HNF_NID8, CPA_GRP_RA54, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID27_U_HNF_NID8, REMOTE_RA54, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID27_U_HNF_NID8, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID27_U_HNF_NID8, NODEID_RA54, 0, 11)
REG32(POR_HNF_RN_PHYS_ID28_U_HNF_NID8, 0x100e08)
    FIELD(POR_HNF_RN_PHYS_ID28_U_HNF_NID8, VALID_RA57, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID28_U_HNF_NID8, CPA_EN_RA57, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID28_U_HNF_NID8, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID28_U_HNF_NID8, CPA_GRP_RA57, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID28_U_HNF_NID8, REMOTE_RA57, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID28_U_HNF_NID8, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID28_U_HNF_NID8, NODEID_RA57, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID28_U_HNF_NID8, VALID_RA56, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID28_U_HNF_NID8, CPA_EN_RA56, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID28_U_HNF_NID8, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID28_U_HNF_NID8, CPA_GRP_RA56, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID28_U_HNF_NID8, REMOTE_RA56, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID28_U_HNF_NID8, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID28_U_HNF_NID8, NODEID_RA56, 0, 11)
REG32(POR_HNF_RN_PHYS_ID29_U_HNF_NID8, 0x100e10)
    FIELD(POR_HNF_RN_PHYS_ID29_U_HNF_NID8, VALID_RA59, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID29_U_HNF_NID8, CPA_EN_RA59, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID29_U_HNF_NID8, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID29_U_HNF_NID8, CPA_GRP_RA59, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID29_U_HNF_NID8, REMOTE_RA59, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID29_U_HNF_NID8, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID29_U_HNF_NID8, NODEID_RA59, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID29_U_HNF_NID8, VALID_RA58, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID29_U_HNF_NID8, CPA_EN_RA58, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID29_U_HNF_NID8, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID29_U_HNF_NID8, CPA_GRP_RA58, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID29_U_HNF_NID8, REMOTE_RA58, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID29_U_HNF_NID8, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID29_U_HNF_NID8, NODEID_RA58, 0, 11)
REG32(POR_HNF_RN_PHYS_ID30_U_HNF_NID8, 0x100e18)
    FIELD(POR_HNF_RN_PHYS_ID30_U_HNF_NID8, VALID_RA61, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID30_U_HNF_NID8, CPA_EN_RA61, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID30_U_HNF_NID8, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID30_U_HNF_NID8, CPA_GRP_RA61, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID30_U_HNF_NID8, REMOTE_RA61, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID30_U_HNF_NID8, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID30_U_HNF_NID8, NODEID_RA61, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID30_U_HNF_NID8, VALID_RA60, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID30_U_HNF_NID8, CPA_EN_RA60, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID30_U_HNF_NID8, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID30_U_HNF_NID8, CPA_GRP_RA60, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID30_U_HNF_NID8, REMOTE_RA60, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID30_U_HNF_NID8, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID30_U_HNF_NID8, NODEID_RA60, 0, 11)
REG32(POR_HNF_RN_PHYS_ID31_U_HNF_NID8, 0x100e20)
    FIELD(POR_HNF_RN_PHYS_ID31_U_HNF_NID8, VALID_RA63, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID31_U_HNF_NID8, CPA_EN_RA63, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID31_U_HNF_NID8, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID31_U_HNF_NID8, CPA_GRP_RA63, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID31_U_HNF_NID8, REMOTE_RA63, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID31_U_HNF_NID8, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID31_U_HNF_NID8, NODEID_RA63, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID31_U_HNF_NID8, VALID_RA62, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID31_U_HNF_NID8, CPA_EN_RA62, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID31_U_HNF_NID8, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID31_U_HNF_NID8, CPA_GRP_RA62, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID31_U_HNF_NID8, REMOTE_RA62, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID31_U_HNF_NID8, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID31_U_HNF_NID8, NODEID_RA62, 0, 11)
REG32(POR_HNF_RN_PHYS_ID32_U_HNF_NID8, 0x100e28)
    FIELD(POR_HNF_RN_PHYS_ID32_U_HNF_NID8, VALID_RA65, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID32_U_HNF_NID8, CPA_EN_RA65, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID32_U_HNF_NID8, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID32_U_HNF_NID8, CPA_GRP_RA65, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID32_U_HNF_NID8, REMOTE_RA65, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID32_U_HNF_NID8, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID32_U_HNF_NID8, NODEID_RA65, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID32_U_HNF_NID8, VALID_RA64, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID32_U_HNF_NID8, CPA_EN_RA64, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID32_U_HNF_NID8, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID32_U_HNF_NID8, CPA_GRP_RA64, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID32_U_HNF_NID8, REMOTE_RA64, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID32_U_HNF_NID8, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID32_U_HNF_NID8, NODEID_RA64, 0, 11)
REG32(POR_HNF_RN_PHYS_ID33_U_HNF_NID8, 0x100e30)
    FIELD(POR_HNF_RN_PHYS_ID33_U_HNF_NID8, VALID_RA67, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID33_U_HNF_NID8, CPA_EN_RA67, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID33_U_HNF_NID8, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID33_U_HNF_NID8, CPA_GRP_RA67, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID33_U_HNF_NID8, REMOTE_RA67, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID33_U_HNF_NID8, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID33_U_HNF_NID8, NODEID_RA67, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID33_U_HNF_NID8, VALID_RA66, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID33_U_HNF_NID8, CPA_EN_RA66, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID33_U_HNF_NID8, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID33_U_HNF_NID8, CPA_GRP_RA66, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID33_U_HNF_NID8, REMOTE_RA66, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID33_U_HNF_NID8, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID33_U_HNF_NID8, NODEID_RA66, 0, 11)
REG32(POR_HNF_RN_PHYS_ID34_U_HNF_NID8, 0x100e38)
    FIELD(POR_HNF_RN_PHYS_ID34_U_HNF_NID8, VALID_RA69, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID34_U_HNF_NID8, CPA_EN_RA69, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID34_U_HNF_NID8, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID34_U_HNF_NID8, CPA_GRP_RA69, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID34_U_HNF_NID8, REMOTE_RA69, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID34_U_HNF_NID8, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID34_U_HNF_NID8, NODEID_RA69, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID34_U_HNF_NID8, VALID_RA68, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID34_U_HNF_NID8, CPA_EN_RA68, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID34_U_HNF_NID8, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID34_U_HNF_NID8, CPA_GRP_RA68, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID34_U_HNF_NID8, REMOTE_RA68, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID34_U_HNF_NID8, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID34_U_HNF_NID8, NODEID_RA68, 0, 11)
REG32(POR_HNF_RN_PHYS_ID35_U_HNF_NID8, 0x100e40)
    FIELD(POR_HNF_RN_PHYS_ID35_U_HNF_NID8, VALID_RA71, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID35_U_HNF_NID8, CPA_EN_RA71, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID35_U_HNF_NID8, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID35_U_HNF_NID8, CPA_GRP_RA71, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID35_U_HNF_NID8, REMOTE_RA71, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID35_U_HNF_NID8, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID35_U_HNF_NID8, NODEID_RA71, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID35_U_HNF_NID8, VALID_RA70, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID35_U_HNF_NID8, CPA_EN_RA70, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID35_U_HNF_NID8, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID35_U_HNF_NID8, CPA_GRP_RA70, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID35_U_HNF_NID8, REMOTE_RA70, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID35_U_HNF_NID8, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID35_U_HNF_NID8, NODEID_RA70, 0, 11)
REG32(POR_HNF_RN_PHYS_ID36_U_HNF_NID8, 0x100e48)
    FIELD(POR_HNF_RN_PHYS_ID36_U_HNF_NID8, VALID_RA73, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID36_U_HNF_NID8, CPA_EN_RA73, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID36_U_HNF_NID8, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID36_U_HNF_NID8, CPA_GRP_RA73, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID36_U_HNF_NID8, REMOTE_RA73, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID36_U_HNF_NID8, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID36_U_HNF_NID8, NODEID_RA73, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID36_U_HNF_NID8, VALID_RA72, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID36_U_HNF_NID8, CPA_EN_RA72, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID36_U_HNF_NID8, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID36_U_HNF_NID8, CPA_GRP_RA72, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID36_U_HNF_NID8, REMOTE_RA72, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID36_U_HNF_NID8, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID36_U_HNF_NID8, NODEID_RA72, 0, 11)
REG32(POR_HNF_RN_PHYS_ID37_U_HNF_NID8, 0x100e50)
    FIELD(POR_HNF_RN_PHYS_ID37_U_HNF_NID8, VALID_RA75, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID37_U_HNF_NID8, CPA_EN_RA75, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID37_U_HNF_NID8, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID37_U_HNF_NID8, CPA_GRP_RA75, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID37_U_HNF_NID8, REMOTE_RA75, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID37_U_HNF_NID8, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID37_U_HNF_NID8, NODEID_RA75, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID37_U_HNF_NID8, VALID_RA74, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID37_U_HNF_NID8, CPA_EN_RA74, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID37_U_HNF_NID8, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID37_U_HNF_NID8, CPA_GRP_RA74, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID37_U_HNF_NID8, REMOTE_RA74, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID37_U_HNF_NID8, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID37_U_HNF_NID8, NODEID_RA74, 0, 11)
REG32(POR_HNF_RN_PHYS_ID38_U_HNF_NID8, 0x100e58)
    FIELD(POR_HNF_RN_PHYS_ID38_U_HNF_NID8, VALID_RA77, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID38_U_HNF_NID8, CPA_EN_RA77, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID38_U_HNF_NID8, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID38_U_HNF_NID8, CPA_GRP_RA77, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID38_U_HNF_NID8, REMOTE_RA77, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID38_U_HNF_NID8, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID38_U_HNF_NID8, NODEID_RA77, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID38_U_HNF_NID8, VALID_RA76, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID38_U_HNF_NID8, CPA_EN_RA76, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID38_U_HNF_NID8, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID38_U_HNF_NID8, CPA_GRP_RA76, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID38_U_HNF_NID8, REMOTE_RA76, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID38_U_HNF_NID8, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID38_U_HNF_NID8, NODEID_RA76, 0, 11)
REG32(POR_HNF_RN_PHYS_ID39_U_HNF_NID8, 0x100e60)
    FIELD(POR_HNF_RN_PHYS_ID39_U_HNF_NID8, VALID_RA79, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID39_U_HNF_NID8, CPA_EN_RA79, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID39_U_HNF_NID8, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID39_U_HNF_NID8, CPA_GRP_RA79, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID39_U_HNF_NID8, REMOTE_RA79, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID39_U_HNF_NID8, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID39_U_HNF_NID8, NODEID_RA79, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID39_U_HNF_NID8, VALID_RA78, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID39_U_HNF_NID8, CPA_EN_RA78, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID39_U_HNF_NID8, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID39_U_HNF_NID8, CPA_GRP_RA78, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID39_U_HNF_NID8, REMOTE_RA78, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID39_U_HNF_NID8, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID39_U_HNF_NID8, NODEID_RA78, 0, 11)
REG32(POR_HNF_RN_PHYS_ID40_U_HNF_NID8, 0x100e68)
    FIELD(POR_HNF_RN_PHYS_ID40_U_HNF_NID8, VALID_RA81, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID40_U_HNF_NID8, CPA_EN_RA81, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID40_U_HNF_NID8, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID40_U_HNF_NID8, CPA_GRP_RA81, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID40_U_HNF_NID8, REMOTE_RA81, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID40_U_HNF_NID8, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID40_U_HNF_NID8, NODEID_RA81, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID40_U_HNF_NID8, VALID_RA80, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID40_U_HNF_NID8, CPA_EN_RA80, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID40_U_HNF_NID8, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID40_U_HNF_NID8, CPA_GRP_RA80, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID40_U_HNF_NID8, REMOTE_RA80, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID40_U_HNF_NID8, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID40_U_HNF_NID8, NODEID_RA80, 0, 11)
REG32(POR_HNF_RN_PHYS_ID41_U_HNF_NID8, 0x100e70)
    FIELD(POR_HNF_RN_PHYS_ID41_U_HNF_NID8, VALID_RA83, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID41_U_HNF_NID8, CPA_EN_RA83, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID41_U_HNF_NID8, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID41_U_HNF_NID8, CPA_GRP_RA83, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID41_U_HNF_NID8, REMOTE_RA83, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID41_U_HNF_NID8, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID41_U_HNF_NID8, NODEID_RA83, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID41_U_HNF_NID8, VALID_RA82, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID41_U_HNF_NID8, CPA_EN_RA82, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID41_U_HNF_NID8, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID41_U_HNF_NID8, CPA_GRP_RA82, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID41_U_HNF_NID8, REMOTE_RA82, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID41_U_HNF_NID8, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID41_U_HNF_NID8, NODEID_RA82, 0, 11)
REG32(POR_HNF_RN_PHYS_ID42_U_HNF_NID8, 0x100e78)
    FIELD(POR_HNF_RN_PHYS_ID42_U_HNF_NID8, VALID_RA85, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID42_U_HNF_NID8, CPA_EN_RA85, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID42_U_HNF_NID8, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID42_U_HNF_NID8, CPA_GRP_RA85, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID42_U_HNF_NID8, REMOTE_RA85, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID42_U_HNF_NID8, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID42_U_HNF_NID8, NODEID_RA85, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID42_U_HNF_NID8, VALID_RA84, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID42_U_HNF_NID8, CPA_EN_RA84, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID42_U_HNF_NID8, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID42_U_HNF_NID8, CPA_GRP_RA84, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID42_U_HNF_NID8, REMOTE_RA84, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID42_U_HNF_NID8, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID42_U_HNF_NID8, NODEID_RA84, 0, 11)
REG32(POR_HNF_RN_PHYS_ID43_U_HNF_NID8, 0x100e80)
    FIELD(POR_HNF_RN_PHYS_ID43_U_HNF_NID8, VALID_RA87, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID43_U_HNF_NID8, CPA_EN_RA87, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID43_U_HNF_NID8, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID43_U_HNF_NID8, CPA_GRP_RA87, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID43_U_HNF_NID8, REMOTE_RA87, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID43_U_HNF_NID8, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID43_U_HNF_NID8, NODEID_RA87, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID43_U_HNF_NID8, VALID_RA86, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID43_U_HNF_NID8, CPA_EN_RA86, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID43_U_HNF_NID8, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID43_U_HNF_NID8, CPA_GRP_RA86, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID43_U_HNF_NID8, REMOTE_RA86, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID43_U_HNF_NID8, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID43_U_HNF_NID8, NODEID_RA86, 0, 11)
REG32(POR_HNF_RN_PHYS_ID44_U_HNF_NID8, 0x100e88)
    FIELD(POR_HNF_RN_PHYS_ID44_U_HNF_NID8, VALID_RA89, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID44_U_HNF_NID8, CPA_EN_RA89, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID44_U_HNF_NID8, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID44_U_HNF_NID8, CPA_GRP_RA89, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID44_U_HNF_NID8, REMOTE_RA89, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID44_U_HNF_NID8, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID44_U_HNF_NID8, NODEID_RA89, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID44_U_HNF_NID8, VALID_RA88, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID44_U_HNF_NID8, CPA_EN_RA88, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID44_U_HNF_NID8, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID44_U_HNF_NID8, CPA_GRP_RA88, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID44_U_HNF_NID8, REMOTE_RA88, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID44_U_HNF_NID8, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID44_U_HNF_NID8, NODEID_RA88, 0, 11)
REG32(POR_HNF_RN_PHYS_ID45_U_HNF_NID8, 0x100e90)
    FIELD(POR_HNF_RN_PHYS_ID45_U_HNF_NID8, VALID_RA91, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID45_U_HNF_NID8, CPA_EN_RA91, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID45_U_HNF_NID8, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID45_U_HNF_NID8, CPA_GRP_RA91, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID45_U_HNF_NID8, REMOTE_RA91, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID45_U_HNF_NID8, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID45_U_HNF_NID8, NODEID_RA91, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID45_U_HNF_NID8, VALID_RA90, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID45_U_HNF_NID8, CPA_EN_RA90, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID45_U_HNF_NID8, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID45_U_HNF_NID8, CPA_GRP_RA90, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID45_U_HNF_NID8, REMOTE_RA90, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID45_U_HNF_NID8, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID45_U_HNF_NID8, NODEID_RA90, 0, 11)
REG32(POR_HNF_RN_PHYS_ID46_U_HNF_NID8, 0x100e98)
    FIELD(POR_HNF_RN_PHYS_ID46_U_HNF_NID8, VALID_RA93, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID46_U_HNF_NID8, CPA_EN_RA93, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID46_U_HNF_NID8, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID46_U_HNF_NID8, CPA_GRP_RA93, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID46_U_HNF_NID8, REMOTE_RA93, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID46_U_HNF_NID8, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID46_U_HNF_NID8, NODEID_RA93, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID46_U_HNF_NID8, VALID_RA92, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID46_U_HNF_NID8, CPA_EN_RA92, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID46_U_HNF_NID8, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID46_U_HNF_NID8, CPA_GRP_RA92, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID46_U_HNF_NID8, REMOTE_RA92, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID46_U_HNF_NID8, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID46_U_HNF_NID8, NODEID_RA92, 0, 11)
REG32(POR_HNF_RN_PHYS_ID47_U_HNF_NID8, 0x100ea0)
    FIELD(POR_HNF_RN_PHYS_ID47_U_HNF_NID8, VALID_RA95, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID47_U_HNF_NID8, CPA_EN_RA95, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID47_U_HNF_NID8, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID47_U_HNF_NID8, CPA_GRP_RA95, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID47_U_HNF_NID8, REMOTE_RA95, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID47_U_HNF_NID8, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID47_U_HNF_NID8, NODEID_RA95, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID47_U_HNF_NID8, VALID_RA94, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID47_U_HNF_NID8, CPA_EN_RA94, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID47_U_HNF_NID8, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID47_U_HNF_NID8, CPA_GRP_RA94, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID47_U_HNF_NID8, REMOTE_RA94, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID47_U_HNF_NID8, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID47_U_HNF_NID8, NODEID_RA94, 0, 11)
REG32(POR_HNF_RN_PHYS_ID48_U_HNF_NID8, 0x100ea8)
    FIELD(POR_HNF_RN_PHYS_ID48_U_HNF_NID8, VALID_RA97, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID48_U_HNF_NID8, CPA_EN_RA97, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID48_U_HNF_NID8, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID48_U_HNF_NID8, CPA_GRP_RA97, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID48_U_HNF_NID8, REMOTE_RA97, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID48_U_HNF_NID8, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID48_U_HNF_NID8, NODEID_RA97, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID48_U_HNF_NID8, VALID_RA96, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID48_U_HNF_NID8, CPA_EN_RA96, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID48_U_HNF_NID8, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID48_U_HNF_NID8, CPA_GRP_RA96, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID48_U_HNF_NID8, REMOTE_RA96, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID48_U_HNF_NID8, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID48_U_HNF_NID8, NODEID_RA96, 0, 11)
REG32(POR_HNF_RN_PHYS_ID49_U_HNF_NID8, 0x100eb0)
    FIELD(POR_HNF_RN_PHYS_ID49_U_HNF_NID8, VALID_RA99, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID49_U_HNF_NID8, CPA_EN_RA99, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID49_U_HNF_NID8, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID49_U_HNF_NID8, CPA_GRP_RA99, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID49_U_HNF_NID8, REMOTE_RA99, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID49_U_HNF_NID8, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID49_U_HNF_NID8, NODEID_RA99, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID49_U_HNF_NID8, VALID_RA98, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID49_U_HNF_NID8, CPA_EN_RA98, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID49_U_HNF_NID8, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID49_U_HNF_NID8, CPA_GRP_RA98, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID49_U_HNF_NID8, REMOTE_RA98, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID49_U_HNF_NID8, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID49_U_HNF_NID8, NODEID_RA98, 0, 11)
REG32(POR_HNF_RN_PHYS_ID50_U_HNF_NID8, 0x100eb8)
    FIELD(POR_HNF_RN_PHYS_ID50_U_HNF_NID8, VALID_RA101, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID50_U_HNF_NID8, CPA_EN_RA101, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID50_U_HNF_NID8, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID50_U_HNF_NID8, CPA_GRP_RA101, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID50_U_HNF_NID8, REMOTE_RA101, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID50_U_HNF_NID8, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID50_U_HNF_NID8, NODEID_RA101, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID50_U_HNF_NID8, VALID_RA100, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID50_U_HNF_NID8, CPA_EN_RA100, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID50_U_HNF_NID8, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID50_U_HNF_NID8, CPA_GRP_RA100, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID50_U_HNF_NID8, REMOTE_RA100, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID50_U_HNF_NID8, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID50_U_HNF_NID8, NODEID_RA100, 0, 11)
REG32(POR_HNF_RN_PHYS_ID51_U_HNF_NID8, 0x100ec0)
    FIELD(POR_HNF_RN_PHYS_ID51_U_HNF_NID8, VALID_RA103, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID51_U_HNF_NID8, CPA_EN_RA103, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID51_U_HNF_NID8, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID51_U_HNF_NID8, CPA_GRP_RA103, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID51_U_HNF_NID8, REMOTE_RA103, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID51_U_HNF_NID8, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID51_U_HNF_NID8, NODEID_RA103, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID51_U_HNF_NID8, VALID_RA102, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID51_U_HNF_NID8, CPA_EN_RA102, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID51_U_HNF_NID8, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID51_U_HNF_NID8, CPA_GRP_RA102, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID51_U_HNF_NID8, REMOTE_RA102, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID51_U_HNF_NID8, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID51_U_HNF_NID8, NODEID_RA102, 0, 11)
REG32(POR_HNF_RN_PHYS_ID52_U_HNF_NID8, 0x100ec8)
    FIELD(POR_HNF_RN_PHYS_ID52_U_HNF_NID8, VALID_RA105, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID52_U_HNF_NID8, CPA_EN_RA105, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID52_U_HNF_NID8, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID52_U_HNF_NID8, CPA_GRP_RA105, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID52_U_HNF_NID8, REMOTE_RA105, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID52_U_HNF_NID8, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID52_U_HNF_NID8, NODEID_RA105, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID52_U_HNF_NID8, VALID_RA104, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID52_U_HNF_NID8, CPA_EN_RA104, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID52_U_HNF_NID8, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID52_U_HNF_NID8, CPA_GRP_RA104, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID52_U_HNF_NID8, REMOTE_RA104, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID52_U_HNF_NID8, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID52_U_HNF_NID8, NODEID_RA104, 0, 11)
REG32(POR_HNF_RN_PHYS_ID53_U_HNF_NID8, 0x100ed0)
    FIELD(POR_HNF_RN_PHYS_ID53_U_HNF_NID8, VALID_RA107, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID53_U_HNF_NID8, CPA_EN_RA107, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID53_U_HNF_NID8, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID53_U_HNF_NID8, CPA_GRP_RA107, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID53_U_HNF_NID8, REMOTE_RA107, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID53_U_HNF_NID8, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID53_U_HNF_NID8, NODEID_RA107, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID53_U_HNF_NID8, VALID_RA106, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID53_U_HNF_NID8, CPA_EN_RA106, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID53_U_HNF_NID8, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID53_U_HNF_NID8, CPA_GRP_RA106, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID53_U_HNF_NID8, REMOTE_RA106, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID53_U_HNF_NID8, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID53_U_HNF_NID8, NODEID_RA106, 0, 11)
REG32(POR_HNF_RN_PHYS_ID54_U_HNF_NID8, 0x100ed8)
    FIELD(POR_HNF_RN_PHYS_ID54_U_HNF_NID8, VALID_RA109, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID54_U_HNF_NID8, CPA_EN_RA109, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID54_U_HNF_NID8, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID54_U_HNF_NID8, CPA_GRP_RA109, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID54_U_HNF_NID8, REMOTE_RA109, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID54_U_HNF_NID8, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID54_U_HNF_NID8, NODEID_RA109, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID54_U_HNF_NID8, VALID_RA108, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID54_U_HNF_NID8, CPA_EN_RA108, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID54_U_HNF_NID8, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID54_U_HNF_NID8, CPA_GRP_RA108, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID54_U_HNF_NID8, REMOTE_RA108, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID54_U_HNF_NID8, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID54_U_HNF_NID8, NODEID_RA108, 0, 11)
REG32(POR_HNF_RN_PHYS_ID55_U_HNF_NID8, 0x100ee0)
    FIELD(POR_HNF_RN_PHYS_ID55_U_HNF_NID8, VALID_RA111, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID55_U_HNF_NID8, CPA_EN_RA111, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID55_U_HNF_NID8, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID55_U_HNF_NID8, CPA_GRP_RA111, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID55_U_HNF_NID8, REMOTE_RA111, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID55_U_HNF_NID8, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID55_U_HNF_NID8, NODEID_RA111, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID55_U_HNF_NID8, VALID_RA110, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID55_U_HNF_NID8, CPA_EN_RA110, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID55_U_HNF_NID8, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID55_U_HNF_NID8, CPA_GRP_RA110, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID55_U_HNF_NID8, REMOTE_RA110, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID55_U_HNF_NID8, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID55_U_HNF_NID8, NODEID_RA110, 0, 11)
REG32(POR_HNF_RN_PHYS_ID56_U_HNF_NID8, 0x100ee8)
    FIELD(POR_HNF_RN_PHYS_ID56_U_HNF_NID8, VALID_RA113, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID56_U_HNF_NID8, CPA_EN_RA113, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID56_U_HNF_NID8, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID56_U_HNF_NID8, CPA_GRP_RA113, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID56_U_HNF_NID8, REMOTE_RA113, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID56_U_HNF_NID8, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID56_U_HNF_NID8, NODEID_RA113, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID56_U_HNF_NID8, VALID_RA112, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID56_U_HNF_NID8, CPA_EN_RA112, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID56_U_HNF_NID8, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID56_U_HNF_NID8, CPA_GRP_RA112, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID56_U_HNF_NID8, REMOTE_RA112, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID56_U_HNF_NID8, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID56_U_HNF_NID8, NODEID_RA112, 0, 11)
REG32(POR_HNF_RN_PHYS_ID57_U_HNF_NID8, 0x100ef0)
    FIELD(POR_HNF_RN_PHYS_ID57_U_HNF_NID8, VALID_RA115, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID57_U_HNF_NID8, CPA_EN_RA115, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID57_U_HNF_NID8, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID57_U_HNF_NID8, CPA_GRP_RA115, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID57_U_HNF_NID8, REMOTE_RA115, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID57_U_HNF_NID8, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID57_U_HNF_NID8, NODEID_RA115, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID57_U_HNF_NID8, VALID_RA114, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID57_U_HNF_NID8, CPA_EN_RA114, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID57_U_HNF_NID8, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID57_U_HNF_NID8, CPA_GRP_RA114, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID57_U_HNF_NID8, REMOTE_RA114, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID57_U_HNF_NID8, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID57_U_HNF_NID8, NODEID_RA114, 0, 11)
REG32(POR_HNF_RN_PHYS_ID58_U_HNF_NID8, 0x100ef8)
    FIELD(POR_HNF_RN_PHYS_ID58_U_HNF_NID8, VALID_RA117, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID58_U_HNF_NID8, CPA_EN_RA117, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID58_U_HNF_NID8, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID58_U_HNF_NID8, CPA_GRP_RA117, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID58_U_HNF_NID8, REMOTE_RA117, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID58_U_HNF_NID8, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID58_U_HNF_NID8, NODEID_RA117, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID58_U_HNF_NID8, VALID_RA116, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID58_U_HNF_NID8, CPA_EN_RA116, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID58_U_HNF_NID8, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID58_U_HNF_NID8, CPA_GRP_RA116, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID58_U_HNF_NID8, REMOTE_RA116, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID58_U_HNF_NID8, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID58_U_HNF_NID8, NODEID_RA116, 0, 11)
REG32(POR_HNF_SF_CXG_BLOCKED_WAYS_U_HNF_NID8, 0x100f00)
    FIELD(POR_HNF_SF_CXG_BLOCKED_WAYS_U_HNF_NID8, SF_BLOCKED_WAYS, 0, 2)
REG32(POR_HNF_CML_PORT_AGGR_GRP0_ADD_MASK_U_HNF_NID8, 0x100f10)
    FIELD(POR_HNF_CML_PORT_AGGR_GRP0_ADD_MASK_U_HNF_NID8, RESERVED_48, 48, 16)
    FIELD(POR_HNF_CML_PORT_AGGR_GRP0_ADD_MASK_U_HNF_NID8, ADDR_MASK, 6, 42)
    FIELD(POR_HNF_CML_PORT_AGGR_GRP0_ADD_MASK_U_HNF_NID8, RESERVED_0, 0, 6)
REG32(POR_HNF_CML_PORT_AGGR_GRP1_ADD_MASK_U_HNF_NID8, 0x100f18)
    FIELD(POR_HNF_CML_PORT_AGGR_GRP1_ADD_MASK_U_HNF_NID8, RESERVED_48, 48, 16)
    FIELD(POR_HNF_CML_PORT_AGGR_GRP1_ADD_MASK_U_HNF_NID8, ADDR_MASK, 6, 42)
    FIELD(POR_HNF_CML_PORT_AGGR_GRP1_ADD_MASK_U_HNF_NID8, RESERVED_0, 0, 6)
REG32(POR_HNF_CML_PORT_AGGR_GRP0_REG_U_HNF_NID8, 0x100f28)
    FIELD(POR_HNF_CML_PORT_AGGR_GRP0_REG_U_HNF_NID8, RESERVED_50, 50, 14)
    FIELD(POR_HNF_CML_PORT_AGGR_GRP0_REG_U_HNF_NID8, NUM_CXG_PAG0, 48, 2)
    FIELD(POR_HNF_CML_PORT_AGGR_GRP0_REG_U_HNF_NID8, RESERVED_47, 47, 1)
    FIELD(POR_HNF_CML_PORT_AGGR_GRP0_REG_U_HNF_NID8, PAG0_TGTID3, 36, 11)
    FIELD(POR_HNF_CML_PORT_AGGR_GRP0_REG_U_HNF_NID8, RESERVED_35, 35, 1)
    FIELD(POR_HNF_CML_PORT_AGGR_GRP0_REG_U_HNF_NID8, PAG0_TGTID2, 24, 11)
    FIELD(POR_HNF_CML_PORT_AGGR_GRP0_REG_U_HNF_NID8, RESERVED_23, 23, 1)
    FIELD(POR_HNF_CML_PORT_AGGR_GRP0_REG_U_HNF_NID8, PAG0_TGTID1, 12, 11)
    FIELD(POR_HNF_CML_PORT_AGGR_GRP0_REG_U_HNF_NID8, RESERVED_11, 11, 1)
    FIELD(POR_HNF_CML_PORT_AGGR_GRP0_REG_U_HNF_NID8, PAG0_TGTID0, 0, 11)
REG32(POR_HNF_CML_PORT_AGGR_GRP1_REG_U_HNF_NID8, 0x100f30)
    FIELD(POR_HNF_CML_PORT_AGGR_GRP1_REG_U_HNF_NID8, RESERVED_50, 50, 14)
    FIELD(POR_HNF_CML_PORT_AGGR_GRP1_REG_U_HNF_NID8, NUM_CXG_PAG1, 48, 2)
    FIELD(POR_HNF_CML_PORT_AGGR_GRP1_REG_U_HNF_NID8, RESERVED_47, 47, 1)
    FIELD(POR_HNF_CML_PORT_AGGR_GRP1_REG_U_HNF_NID8, PAG1_TGTID3, 36, 11)
    FIELD(POR_HNF_CML_PORT_AGGR_GRP1_REG_U_HNF_NID8, RESERVED_35, 35, 1)
    FIELD(POR_HNF_CML_PORT_AGGR_GRP1_REG_U_HNF_NID8, PAG1_TGTID2, 24, 11)
    FIELD(POR_HNF_CML_PORT_AGGR_GRP1_REG_U_HNF_NID8, RESERVED_23, 23, 1)
    FIELD(POR_HNF_CML_PORT_AGGR_GRP1_REG_U_HNF_NID8, PAG1_TGTID1, 12, 11)
    FIELD(POR_HNF_CML_PORT_AGGR_GRP1_REG_U_HNF_NID8, RESERVED_11, 11, 1)
    FIELD(POR_HNF_CML_PORT_AGGR_GRP1_REG_U_HNF_NID8, PAG1_TGTID0, 0, 11)
REG32(HN_SAM_HASH_ADDR_MASK_REG_U_HNF_NID8, 0x100f40)
    FIELD(HN_SAM_HASH_ADDR_MASK_REG_U_HNF_NID8, RESERVED_48, 48, 16)
    FIELD(HN_SAM_HASH_ADDR_MASK_REG_U_HNF_NID8, ADDR_MASK, 6, 42)
    FIELD(HN_SAM_HASH_ADDR_MASK_REG_U_HNF_NID8, RESERVED_0, 0, 6)
REG32(HN_SAM_REGION_CMP_ADDR_MASK_REG_U_HNF_NID8, 0x100f48)
    FIELD(HN_SAM_REGION_CMP_ADDR_MASK_REG_U_HNF_NID8, RESERVED_48, 48, 16)
    FIELD(HN_SAM_REGION_CMP_ADDR_MASK_REG_U_HNF_NID8, ADDR_MASK, 26, 22)
    FIELD(HN_SAM_REGION_CMP_ADDR_MASK_REG_U_HNF_NID8, RESERVED_0, 0, 26)
REG32(POR_HNF_ABF_LO_ADDR_U_HNF_NID8, 0x100f50)
    FIELD(POR_HNF_ABF_LO_ADDR_U_HNF_NID8, RESERVED_48, 48, 16)
    FIELD(POR_HNF_ABF_LO_ADDR_U_HNF_NID8, ABF_LO_ADDR, 0, 48)
REG32(POR_HNF_ABF_HI_ADDR_U_HNF_NID8, 0x100f58)
    FIELD(POR_HNF_ABF_HI_ADDR_U_HNF_NID8, RESERVED_48, 48, 16)
    FIELD(POR_HNF_ABF_HI_ADDR_U_HNF_NID8, ABF_HI_ADDR, 0, 48)
REG32(POR_HNF_ABF_PR_U_HNF_NID8, 0x100f60)
    FIELD(POR_HNF_ABF_PR_U_HNF_NID8, ABF_MODE, 1, 2)
    FIELD(POR_HNF_ABF_PR_U_HNF_NID8, ABF_ENABLE, 0, 1)
REG32(POR_HNF_ABF_SR_U_HNF_NID8, 0x100f68)
    FIELD(POR_HNF_ABF_SR_U_HNF_NID8, ABF_SF_DISABLE_ABORT, 3, 1)
    FIELD(POR_HNF_ABF_SR_U_HNF_NID8, ABF_SF_PM_TRANSITION_ABORT, 2, 1)
    FIELD(POR_HNF_ABF_SR_U_HNF_NID8, ABF_INVALID_REQ_ABORT, 1, 1)
    FIELD(POR_HNF_ABF_SR_U_HNF_NID8, ABF_COMPLETE, 0, 1)
REG32(POR_HNF_RN_PHYS_ID59_U_HNF_NID8, 0x100f70)
    FIELD(POR_HNF_RN_PHYS_ID59_U_HNF_NID8, VALID_RA119, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID59_U_HNF_NID8, CPA_EN_RA119, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID59_U_HNF_NID8, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID59_U_HNF_NID8, CPA_GRP_RA119, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID59_U_HNF_NID8, REMOTE_RA119, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID59_U_HNF_NID8, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID59_U_HNF_NID8, NODEID_RA119, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID59_U_HNF_NID8, VALID_RA118, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID59_U_HNF_NID8, CPA_EN_RA118, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID59_U_HNF_NID8, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID59_U_HNF_NID8, CPA_GRP_RA118, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID59_U_HNF_NID8, REMOTE_RA118, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID59_U_HNF_NID8, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID59_U_HNF_NID8, NODEID_RA118, 0, 11)
REG32(POR_HNF_RN_PHYS_ID60_U_HNF_NID8, 0x100f78)
    FIELD(POR_HNF_RN_PHYS_ID60_U_HNF_NID8, VALID_RA121, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID60_U_HNF_NID8, CPA_EN_RA121, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID60_U_HNF_NID8, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID60_U_HNF_NID8, CPA_GRP_RA121, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID60_U_HNF_NID8, REMOTE_RA121, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID60_U_HNF_NID8, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID60_U_HNF_NID8, NODEID_RA121, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID60_U_HNF_NID8, VALID_RA120, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID60_U_HNF_NID8, CPA_EN_RA120, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID60_U_HNF_NID8, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID60_U_HNF_NID8, CPA_GRP_RA120, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID60_U_HNF_NID8, REMOTE_RA120, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID60_U_HNF_NID8, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID60_U_HNF_NID8, NODEID_RA120, 0, 11)
REG32(POR_HNF_RN_PHYS_ID61_U_HNF_NID8, 0x100f80)
    FIELD(POR_HNF_RN_PHYS_ID61_U_HNF_NID8, VALID_RA123, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID61_U_HNF_NID8, CPA_EN_RA123, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID61_U_HNF_NID8, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID61_U_HNF_NID8, CPA_GRP_RA123, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID61_U_HNF_NID8, REMOTE_RA123, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID61_U_HNF_NID8, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID61_U_HNF_NID8, NODEID_RA123, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID61_U_HNF_NID8, VALID_RA122, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID61_U_HNF_NID8, CPA_EN_RA122, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID61_U_HNF_NID8, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID61_U_HNF_NID8, CPA_GRP_RA122, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID61_U_HNF_NID8, REMOTE_RA122, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID61_U_HNF_NID8, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID61_U_HNF_NID8, NODEID_RA122, 0, 11)
REG32(POR_HNF_RN_PHYS_ID62_U_HNF_NID8, 0x100f88)
    FIELD(POR_HNF_RN_PHYS_ID62_U_HNF_NID8, VALID_RA125, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID62_U_HNF_NID8, CPA_EN_RA125, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID62_U_HNF_NID8, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID62_U_HNF_NID8, CPA_GRP_RA125, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID62_U_HNF_NID8, REMOTE_RA125, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID62_U_HNF_NID8, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID62_U_HNF_NID8, NODEID_RA125, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID62_U_HNF_NID8, VALID_RA124, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID62_U_HNF_NID8, CPA_EN_RA124, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID62_U_HNF_NID8, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID62_U_HNF_NID8, CPA_GRP_RA124, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID62_U_HNF_NID8, REMOTE_RA124, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID62_U_HNF_NID8, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID62_U_HNF_NID8, NODEID_RA124, 0, 11)
REG32(POR_HNF_RN_PHYS_ID63_U_HNF_NID8, 0x100f90)
    FIELD(POR_HNF_RN_PHYS_ID63_U_HNF_NID8, VALID_RA127, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID63_U_HNF_NID8, CPA_EN_RA127, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID63_U_HNF_NID8, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID63_U_HNF_NID8, CPA_GRP_RA127, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID63_U_HNF_NID8, REMOTE_RA127, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID63_U_HNF_NID8, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID63_U_HNF_NID8, NODEID_RA127, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID63_U_HNF_NID8, VALID_RA126, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID63_U_HNF_NID8, CPA_EN_RA126, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID63_U_HNF_NID8, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID63_U_HNF_NID8, CPA_GRP_RA126, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID63_U_HNF_NID8, REMOTE_RA126, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID63_U_HNF_NID8, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID63_U_HNF_NID8, NODEID_RA126, 0, 11)
REG32(POR_HNF_LDID_MAP_TABLE_REG0_U_HNF_NID8, 0x100f98)
    FIELD(POR_HNF_LDID_MAP_TABLE_REG0_U_HNF_NID8, VALID_CXHA1, 63, 1)
    FIELD(POR_HNF_LDID_MAP_TABLE_REG0_U_HNF_NID8, RESERVED_55, 55, 8)
    FIELD(POR_HNF_LDID_MAP_TABLE_REG0_U_HNF_NID8, STARTING_LDID_CXHA1, 48, 7)
    FIELD(POR_HNF_LDID_MAP_TABLE_REG0_U_HNF_NID8, RESERVED_43, 43, 5)
    FIELD(POR_HNF_LDID_MAP_TABLE_REG0_U_HNF_NID8, SRCID_CXHA1, 32, 11)
    FIELD(POR_HNF_LDID_MAP_TABLE_REG0_U_HNF_NID8, VALID_CXHA0, 31, 1)
    FIELD(POR_HNF_LDID_MAP_TABLE_REG0_U_HNF_NID8, RESERVED_23, 23, 8)
    FIELD(POR_HNF_LDID_MAP_TABLE_REG0_U_HNF_NID8, STARTING_LDID_CXHA0, 16, 7)
    FIELD(POR_HNF_LDID_MAP_TABLE_REG0_U_HNF_NID8, RESERVED_11, 11, 5)
    FIELD(POR_HNF_LDID_MAP_TABLE_REG0_U_HNF_NID8, SRCID_CXHA0, 0, 11)
REG32(POR_HNF_LDID_MAP_TABLE_REG1_U_HNF_NID8, 0x100fa0)
    FIELD(POR_HNF_LDID_MAP_TABLE_REG1_U_HNF_NID8, VALID_CXHA3, 63, 1)
    FIELD(POR_HNF_LDID_MAP_TABLE_REG1_U_HNF_NID8, RESERVED_55, 55, 8)
    FIELD(POR_HNF_LDID_MAP_TABLE_REG1_U_HNF_NID8, STARTING_LDID_CXHA3, 48, 7)
    FIELD(POR_HNF_LDID_MAP_TABLE_REG1_U_HNF_NID8, RESERVED_43, 43, 5)
    FIELD(POR_HNF_LDID_MAP_TABLE_REG1_U_HNF_NID8, SRCID_CXHA3, 32, 11)
    FIELD(POR_HNF_LDID_MAP_TABLE_REG1_U_HNF_NID8, VALID_CXHA2, 31, 1)
    FIELD(POR_HNF_LDID_MAP_TABLE_REG1_U_HNF_NID8, RESERVED_23, 23, 8)
    FIELD(POR_HNF_LDID_MAP_TABLE_REG1_U_HNF_NID8, STARTING_LDID_CXHA2, 16, 7)
    FIELD(POR_HNF_LDID_MAP_TABLE_REG1_U_HNF_NID8, RESERVED_11, 11, 5)
    FIELD(POR_HNF_LDID_MAP_TABLE_REG1_U_HNF_NID8, SRCID_CXHA2, 0, 11)
REG32(POR_HNF_LDID_MAP_TABLE_REG2_U_HNF_NID8, 0x100fa8)
    FIELD(POR_HNF_LDID_MAP_TABLE_REG2_U_HNF_NID8, VALID_CXHA5, 63, 1)
    FIELD(POR_HNF_LDID_MAP_TABLE_REG2_U_HNF_NID8, RESERVED_55, 55, 8)
    FIELD(POR_HNF_LDID_MAP_TABLE_REG2_U_HNF_NID8, STARTING_LDID_CXHA5, 48, 7)
    FIELD(POR_HNF_LDID_MAP_TABLE_REG2_U_HNF_NID8, RESERVED_43, 43, 5)
    FIELD(POR_HNF_LDID_MAP_TABLE_REG2_U_HNF_NID8, SRCID_CXHA5, 32, 11)
    FIELD(POR_HNF_LDID_MAP_TABLE_REG2_U_HNF_NID8, VALID_CXHA4, 31, 1)
    FIELD(POR_HNF_LDID_MAP_TABLE_REG2_U_HNF_NID8, RESERVED_23, 23, 8)
    FIELD(POR_HNF_LDID_MAP_TABLE_REG2_U_HNF_NID8, STARTING_LDID_CXHA4, 16, 7)
    FIELD(POR_HNF_LDID_MAP_TABLE_REG2_U_HNF_NID8, RESERVED_11, 11, 5)
    FIELD(POR_HNF_LDID_MAP_TABLE_REG2_U_HNF_NID8, SRCID_CXHA4, 0, 11)
REG32(POR_HNF_LDID_MAP_TABLE_REG3_U_HNF_NID8, 0x100fb0)
    FIELD(POR_HNF_LDID_MAP_TABLE_REG3_U_HNF_NID8, VALID_CXHA7, 63, 1)
    FIELD(POR_HNF_LDID_MAP_TABLE_REG3_U_HNF_NID8, RESERVED_55, 55, 8)
    FIELD(POR_HNF_LDID_MAP_TABLE_REG3_U_HNF_NID8, STARTING_LDID_CXHA7, 48, 7)
    FIELD(POR_HNF_LDID_MAP_TABLE_REG3_U_HNF_NID8, RESERVED_43, 43, 5)
    FIELD(POR_HNF_LDID_MAP_TABLE_REG3_U_HNF_NID8, SRCID_CXHA7, 32, 11)
    FIELD(POR_HNF_LDID_MAP_TABLE_REG3_U_HNF_NID8, VALID_CXHA6, 31, 1)
    FIELD(POR_HNF_LDID_MAP_TABLE_REG3_U_HNF_NID8, RESERVED_23, 23, 8)
    FIELD(POR_HNF_LDID_MAP_TABLE_REG3_U_HNF_NID8, STARTING_LDID_CXHA6, 16, 7)
    FIELD(POR_HNF_LDID_MAP_TABLE_REG3_U_HNF_NID8, RESERVED_11, 11, 5)
    FIELD(POR_HNF_LDID_MAP_TABLE_REG3_U_HNF_NID8, SRCID_CXHA6, 0, 11)
REG32(POR_HNF_PPU_PWPR_U_HNF_NID8, 0x101000)
    FIELD(POR_HNF_PPU_PWPR_U_HNF_NID8, RESERVED_9, 9, 23)
    FIELD(POR_HNF_PPU_PWPR_U_HNF_NID8, DYN_EN, 8, 1)
    FIELD(POR_HNF_PPU_PWPR_U_HNF_NID8, OP_MODE, 4, 4)
    FIELD(POR_HNF_PPU_PWPR_U_HNF_NID8, POLICY, 0, 4)
REG32(POR_HNF_PPU_PWSR_U_HNF_NID8, 0x101008)
    FIELD(POR_HNF_PPU_PWSR_U_HNF_NID8, RESERVED_9, 9, 23)
    FIELD(POR_HNF_PPU_PWSR_U_HNF_NID8, DYN_EN_STATUS, 8, 1)
    FIELD(POR_HNF_PPU_PWSR_U_HNF_NID8, OP_MODE_STATUS, 4, 4)
    FIELD(POR_HNF_PPU_PWSR_U_HNF_NID8, POW_STATUS, 0, 4)
REG32(POR_HNF_PPU_MISR_U_HNF_NID8, 0x101014)
    FIELD(POR_HNF_PPU_MISR_U_HNF_NID8, PCSMACCEPT_STATUS, 0, 1)
REG32(POR_HNF_PPU_DYN_RET_THRESHOLD_U_HNF_NID8, 0x101100)
    FIELD(POR_HNF_PPU_DYN_RET_THRESHOLD_U_HNF_NID8, RESERVED_12, 12, 52)
    FIELD(POR_HNF_PPU_DYN_RET_THRESHOLD_U_HNF_NID8, DYN_RET_THRESHOLD, 0, 12)
REG32(POR_HNF_PPU_IDR0_U_HNF_NID8, 0x101fb0)
    FIELD(POR_HNF_PPU_IDR0_U_HNF_NID8, RESERVED_30, 30, 2)
    FIELD(POR_HNF_PPU_IDR0_U_HNF_NID8, DYN_WRM_RST_SPT, 29, 1)
    FIELD(POR_HNF_PPU_IDR0_U_HNF_NID8, DYN_ALL_ON_SPT, 28, 1)
    FIELD(POR_HNF_PPU_IDR0_U_HNF_NID8, DYN_FNC_RET_SPT, 27, 1)
    FIELD(POR_HNF_PPU_IDR0_U_HNF_NID8, DYN_FULL_RET_SPT, 26, 1)
    FIELD(POR_HNF_PPU_IDR0_U_HNF_NID8, DYN_MEM_OFF_SPT, 25, 1)
    FIELD(POR_HNF_PPU_IDR0_U_HNF_NID8, DYN_LGC_RET_SPT, 24, 1)
    FIELD(POR_HNF_PPU_IDR0_U_HNF_NID8, DYN_MEM_RET_EMU_SPT, 23, 1)
    FIELD(POR_HNF_PPU_IDR0_U_HNF_NID8, DYN_MEM_RET_SPT, 22, 1)
    FIELD(POR_HNF_PPU_IDR0_U_HNF_NID8, DYN_OFF_EMU_SPT, 21, 1)
    FIELD(POR_HNF_PPU_IDR0_U_HNF_NID8, DYN_ALL_OFF_SPT, 20, 1)
    FIELD(POR_HNF_PPU_IDR0_U_HNF_NID8, RESERVED_19, 19, 1)
    FIELD(POR_HNF_PPU_IDR0_U_HNF_NID8, STA_DBG_RECOV_SPT, 18, 1)
    FIELD(POR_HNF_PPU_IDR0_U_HNF_NID8, STA_WRM_RST_SPT, 17, 1)
    FIELD(POR_HNF_PPU_IDR0_U_HNF_NID8, STA_ALL_ON_SPT, 16, 1)
    FIELD(POR_HNF_PPU_IDR0_U_HNF_NID8, STA_FNC_RET_SPT, 15, 1)
    FIELD(POR_HNF_PPU_IDR0_U_HNF_NID8, STA_FULL_RET_SPT, 14, 1)
    FIELD(POR_HNF_PPU_IDR0_U_HNF_NID8, STA_MEM_OFF_SPT, 13, 1)
    FIELD(POR_HNF_PPU_IDR0_U_HNF_NID8, STA_LGC_RET_SPT, 12, 1)
    FIELD(POR_HNF_PPU_IDR0_U_HNF_NID8, STA_MEM_RET_EMU_SPT, 11, 1)
    FIELD(POR_HNF_PPU_IDR0_U_HNF_NID8, STA_MEM_RET_SPT, 10, 1)
    FIELD(POR_HNF_PPU_IDR0_U_HNF_NID8, STA_OFF_EMU_SPT, 9, 1)
    FIELD(POR_HNF_PPU_IDR0_U_HNF_NID8, STA_ALL_OFF_SPT, 8, 1)
    FIELD(POR_HNF_PPU_IDR0_U_HNF_NID8, NUM_OPMODES, 4, 4)
    FIELD(POR_HNF_PPU_IDR0_U_HNF_NID8, DEVCHAN, 0, 4)
REG32(POR_HNF_PPU_IDR1_U_HNF_NID8, 0x101fb4)
    FIELD(POR_HNF_PPU_IDR1_U_HNF_NID8, DYN_POLICY_MIN_IRQ_SPT, 3, 1)
    FIELD(POR_HNF_PPU_IDR1_U_HNF_NID8, OFF_LOCK_SPT, 2, 1)
    FIELD(POR_HNF_PPU_IDR1_U_HNF_NID8, SW_DEV_DEL_CONFIG_SPT, 1, 1)
    FIELD(POR_HNF_PPU_IDR1_U_HNF_NID8, PWR_MODE_ENTRY_DEL_SPT, 0, 1)
REG32(POR_HNF_PPU_IIDR_U_HNF_NID8, 0x101fc8)
    FIELD(POR_HNF_PPU_IIDR_U_HNF_NID8, PRODUCT_ID, 20, 12)
    FIELD(POR_HNF_PPU_IIDR_U_HNF_NID8, VARIANT, 16, 4)
    FIELD(POR_HNF_PPU_IIDR_U_HNF_NID8, REVISION, 12, 4)
    FIELD(POR_HNF_PPU_IIDR_U_HNF_NID8, IMPLEMENTER, 0, 12)
REG32(POR_HNF_PPU_AIDR_U_HNF_NID8, 0x101fcc)
    FIELD(POR_HNF_PPU_AIDR_U_HNF_NID8, ARCH_REV_MAJOR, 4, 4)
    FIELD(POR_HNF_PPU_AIDR_U_HNF_NID8, ARCH_REV_MINOR, 0, 4)
REG32(POR_HNF_PMU_EVENT_SEL_U_HNF_NID8, 0x102000)
    FIELD(POR_HNF_PMU_EVENT_SEL_U_HNF_NID8, RESERVED_35, 35, 29)
    FIELD(POR_HNF_PMU_EVENT_SEL_U_HNF_NID8, PMU_OCCUP1_ID, 32, 3)
    FIELD(POR_HNF_PMU_EVENT_SEL_U_HNF_NID8, RESERVED_29, 29, 3)
    FIELD(POR_HNF_PMU_EVENT_SEL_U_HNF_NID8, PMU_EVENT3_ID, 24, 5)
    FIELD(POR_HNF_PMU_EVENT_SEL_U_HNF_NID8, RESERVED_21, 21, 3)
    FIELD(POR_HNF_PMU_EVENT_SEL_U_HNF_NID8, PMU_EVENT2_ID, 16, 5)
    FIELD(POR_HNF_PMU_EVENT_SEL_U_HNF_NID8, RESERVED_13, 13, 3)
    FIELD(POR_HNF_PMU_EVENT_SEL_U_HNF_NID8, PMU_EVENT1_ID, 8, 5)
    FIELD(POR_HNF_PMU_EVENT_SEL_U_HNF_NID8, PMU_EVENT0_ID, 0, 5)
REG32(POR_HNF_ERRFR_U_HNF_NID8, 0x103000)
    FIELD(POR_HNF_ERRFR_U_HNF_NID8, RESERVED_15, 15, 49)
    FIELD(POR_HNF_ERRFR_U_HNF_NID8, CEC, 12, 3)
    FIELD(POR_HNF_ERRFR_U_HNF_NID8, CFI, 10, 2)
    FIELD(POR_HNF_ERRFR_U_HNF_NID8, FI, 6, 2)
    FIELD(POR_HNF_ERRFR_U_HNF_NID8, UI, 4, 2)
    FIELD(POR_HNF_ERRFR_U_HNF_NID8, DE, 2, 2)
    FIELD(POR_HNF_ERRFR_U_HNF_NID8, ED, 0, 2)
REG32(POR_HNF_ERRCTLR_U_HNF_NID8, 0x103008)
    FIELD(POR_HNF_ERRCTLR_U_HNF_NID8, RESERVED_9, 9, 55)
    FIELD(POR_HNF_ERRCTLR_U_HNF_NID8, CFI, 8, 1)
    FIELD(POR_HNF_ERRCTLR_U_HNF_NID8, FI, 3, 1)
    FIELD(POR_HNF_ERRCTLR_U_HNF_NID8, UI, 2, 1)
    FIELD(POR_HNF_ERRCTLR_U_HNF_NID8, DE, 1, 1)
    FIELD(POR_HNF_ERRCTLR_U_HNF_NID8, ED, 0, 1)
REG32(POR_HNF_ERRSTATUS_U_HNF_NID8, 0x103010)
    FIELD(POR_HNF_ERRSTATUS_U_HNF_NID8, RESERVED_32, 32, 32)
    FIELD(POR_HNF_ERRSTATUS_U_HNF_NID8, AV, 31, 1)
    FIELD(POR_HNF_ERRSTATUS_U_HNF_NID8, V, 30, 1)
    FIELD(POR_HNF_ERRSTATUS_U_HNF_NID8, UE, 29, 1)
    FIELD(POR_HNF_ERRSTATUS_U_HNF_NID8, RESERVED_28, 28, 1)
    FIELD(POR_HNF_ERRSTATUS_U_HNF_NID8, OF, 27, 1)
    FIELD(POR_HNF_ERRSTATUS_U_HNF_NID8, MV, 26, 1)
    FIELD(POR_HNF_ERRSTATUS_U_HNF_NID8, RESERVED_25, 25, 1)
    FIELD(POR_HNF_ERRSTATUS_U_HNF_NID8, CE, 24, 1)
    FIELD(POR_HNF_ERRSTATUS_U_HNF_NID8, DE, 23, 1)
    FIELD(POR_HNF_ERRSTATUS_U_HNF_NID8, RESERVED_0, 0, 23)
REG32(POR_HNF_ERRADDR_U_HNF_NID8, 0x103018)
    FIELD(POR_HNF_ERRADDR_U_HNF_NID8, NS, 63, 1)
    FIELD(POR_HNF_ERRADDR_U_HNF_NID8, RESERVED_48, 48, 15)
    FIELD(POR_HNF_ERRADDR_U_HNF_NID8, ADDR, 0, 48)
REG32(POR_HNF_ERRMISC_U_HNF_NID8, 0x103020)
    FIELD(POR_HNF_ERRMISC_U_HNF_NID8, CECOF, 63, 1)
    FIELD(POR_HNF_ERRMISC_U_HNF_NID8, SETMATCH, 62, 1)
    FIELD(POR_HNF_ERRMISC_U_HNF_NID8, RESERVED_61, 61, 1)
    FIELD(POR_HNF_ERRMISC_U_HNF_NID8, ERRSET, 48, 13)
    FIELD(POR_HNF_ERRMISC_U_HNF_NID8, CEC, 32, 16)
    FIELD(POR_HNF_ERRMISC_U_HNF_NID8, RESERVED_18, 18, 14)
    FIELD(POR_HNF_ERRMISC_U_HNF_NID8, OPTYPE, 16, 2)
    FIELD(POR_HNF_ERRMISC_U_HNF_NID8, RESERVED_15, 15, 1)
    FIELD(POR_HNF_ERRMISC_U_HNF_NID8, SRCID, 4, 11)
    FIELD(POR_HNF_ERRMISC_U_HNF_NID8, ERRSRC, 0, 4)
REG32(POR_HNF_ERR_INJ_U_HNF_NID8, 0x103030)
    FIELD(POR_HNF_ERR_INJ_U_HNF_NID8, RESERVED_27, 27, 37)
    FIELD(POR_HNF_ERR_INJ_U_HNF_NID8, HNF_ERR_INJ_SRCID, 16, 11)
    FIELD(POR_HNF_ERR_INJ_U_HNF_NID8, RESERVED_9, 9, 7)
    FIELD(POR_HNF_ERR_INJ_U_HNF_NID8, HNF_ERR_INJ_LPID, 4, 5)
    FIELD(POR_HNF_ERR_INJ_U_HNF_NID8, HNF_ERR_INJ_EN, 0, 1)
REG32(POR_HNF_BYTE_PAR_ERR_INJ_U_HNF_NID8, 0x103038)
    FIELD(POR_HNF_BYTE_PAR_ERR_INJ_U_HNF_NID8, HNF_BYTE_PAR_ERR_INJ, 0, 5)
REG32(POR_HNF_ERRFR_NS_U_HNF_NID8, 0x103100)
    FIELD(POR_HNF_ERRFR_NS_U_HNF_NID8, RESERVED_15, 15, 49)
    FIELD(POR_HNF_ERRFR_NS_U_HNF_NID8, CEC, 12, 3)
    FIELD(POR_HNF_ERRFR_NS_U_HNF_NID8, CFI, 10, 2)
    FIELD(POR_HNF_ERRFR_NS_U_HNF_NID8, FI, 6, 2)
    FIELD(POR_HNF_ERRFR_NS_U_HNF_NID8, UI, 4, 2)
    FIELD(POR_HNF_ERRFR_NS_U_HNF_NID8, DE, 2, 2)
    FIELD(POR_HNF_ERRFR_NS_U_HNF_NID8, ED, 0, 2)
REG32(POR_HNF_ERRCTLR_NS_U_HNF_NID8, 0x103108)
    FIELD(POR_HNF_ERRCTLR_NS_U_HNF_NID8, RESERVED_9, 9, 55)
    FIELD(POR_HNF_ERRCTLR_NS_U_HNF_NID8, CFI, 8, 1)
    FIELD(POR_HNF_ERRCTLR_NS_U_HNF_NID8, FI, 3, 1)
    FIELD(POR_HNF_ERRCTLR_NS_U_HNF_NID8, UI, 2, 1)
    FIELD(POR_HNF_ERRCTLR_NS_U_HNF_NID8, DE, 1, 1)
    FIELD(POR_HNF_ERRCTLR_NS_U_HNF_NID8, ED, 0, 1)
REG32(POR_HNF_ERRSTATUS_NS_U_HNF_NID8, 0x103110)
    FIELD(POR_HNF_ERRSTATUS_NS_U_HNF_NID8, RESERVED_32, 32, 32)
    FIELD(POR_HNF_ERRSTATUS_NS_U_HNF_NID8, AV, 31, 1)
    FIELD(POR_HNF_ERRSTATUS_NS_U_HNF_NID8, V, 30, 1)
    FIELD(POR_HNF_ERRSTATUS_NS_U_HNF_NID8, UE, 29, 1)
    FIELD(POR_HNF_ERRSTATUS_NS_U_HNF_NID8, RESERVED_28, 28, 1)
    FIELD(POR_HNF_ERRSTATUS_NS_U_HNF_NID8, OF, 27, 1)
    FIELD(POR_HNF_ERRSTATUS_NS_U_HNF_NID8, MV, 26, 1)
    FIELD(POR_HNF_ERRSTATUS_NS_U_HNF_NID8, RESERVED_25, 25, 1)
    FIELD(POR_HNF_ERRSTATUS_NS_U_HNF_NID8, CE, 24, 1)
    FIELD(POR_HNF_ERRSTATUS_NS_U_HNF_NID8, DE, 23, 1)
    FIELD(POR_HNF_ERRSTATUS_NS_U_HNF_NID8, RESERVED_0, 0, 23)
REG32(POR_HNF_ERRADDR_NS_U_HNF_NID8, 0x103118)
    FIELD(POR_HNF_ERRADDR_NS_U_HNF_NID8, NS, 63, 1)
    FIELD(POR_HNF_ERRADDR_NS_U_HNF_NID8, RESERVED_48, 48, 15)
    FIELD(POR_HNF_ERRADDR_NS_U_HNF_NID8, ADDR, 0, 48)
REG32(POR_HNF_ERRMISC_NS_U_HNF_NID8, 0x103120)
    FIELD(POR_HNF_ERRMISC_NS_U_HNF_NID8, CECOF, 63, 1)
    FIELD(POR_HNF_ERRMISC_NS_U_HNF_NID8, SETMATCH, 62, 1)
    FIELD(POR_HNF_ERRMISC_NS_U_HNF_NID8, RESERVED_61, 61, 1)
    FIELD(POR_HNF_ERRMISC_NS_U_HNF_NID8, ERRSET, 48, 13)
    FIELD(POR_HNF_ERRMISC_NS_U_HNF_NID8, CEC, 32, 16)
    FIELD(POR_HNF_ERRMISC_NS_U_HNF_NID8, RESERVED_18, 18, 14)
    FIELD(POR_HNF_ERRMISC_NS_U_HNF_NID8, OPTYPE, 16, 2)
    FIELD(POR_HNF_ERRMISC_NS_U_HNF_NID8, RESERVED_15, 15, 1)
    FIELD(POR_HNF_ERRMISC_NS_U_HNF_NID8, SRCID, 4, 11)
    FIELD(POR_HNF_ERRMISC_NS_U_HNF_NID8, ERRSRC, 0, 4)
REG32(POR_MXP_NODE_INFO_U_SMXP_0_1, 0x108000)
    FIELD(POR_MXP_NODE_INFO_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MXP_NODE_INFO_U_SMXP_0_1, LOGICAL_ID, 32, 16)
    FIELD(POR_MXP_NODE_INFO_U_SMXP_0_1, XY_ID, 16, 16)
    FIELD(POR_MXP_NODE_INFO_U_SMXP_0_1, NODE_TYPE, 0, 16)
REG32(POR_MXP_DEVICE_PORT_CONNECT_INFO_P0_U_SMXP_0_1, 0x108008)
    FIELD(POR_MXP_DEVICE_PORT_CONNECT_INFO_P0_U_SMXP_0_1, RESERVED_32, 32, 32)
    FIELD(POR_MXP_DEVICE_PORT_CONNECT_INFO_P0_U_SMXP_0_1, NUM_DCS_P0_D3, 28, 4)
    FIELD(POR_MXP_DEVICE_PORT_CONNECT_INFO_P0_U_SMXP_0_1, NUM_DCS_P0_D2, 24, 4)
    FIELD(POR_MXP_DEVICE_PORT_CONNECT_INFO_P0_U_SMXP_0_1, NUM_DCS_P0_D1, 20, 4)
    FIELD(POR_MXP_DEVICE_PORT_CONNECT_INFO_P0_U_SMXP_0_1, NUM_DCS_P0_D0, 16, 4)
    FIELD(POR_MXP_DEVICE_PORT_CONNECT_INFO_P0_U_SMXP_0_1, DEVICE_TYPE_P0, 0, 5)
REG32(POR_MXP_DEVICE_PORT_CONNECT_INFO_P1_U_SMXP_0_1, 0x108010)
    FIELD(POR_MXP_DEVICE_PORT_CONNECT_INFO_P1_U_SMXP_0_1, RESERVED_32, 32, 32)
    FIELD(POR_MXP_DEVICE_PORT_CONNECT_INFO_P1_U_SMXP_0_1, NUM_DCS_P1_D3, 28, 4)
    FIELD(POR_MXP_DEVICE_PORT_CONNECT_INFO_P1_U_SMXP_0_1, NUM_DCS_P1_D2, 24, 4)
    FIELD(POR_MXP_DEVICE_PORT_CONNECT_INFO_P1_U_SMXP_0_1, NUM_DCS_P1_D1, 20, 4)
    FIELD(POR_MXP_DEVICE_PORT_CONNECT_INFO_P1_U_SMXP_0_1, NUM_DCS_P1_D0, 16, 4)
    FIELD(POR_MXP_DEVICE_PORT_CONNECT_INFO_P1_U_SMXP_0_1, DEVICE_TYPE_P1, 0, 5)
REG32(POR_MXP_MESH_PORT_CONNECT_INFO_EAST_U_SMXP_0_1, 0x108018)
    FIELD(POR_MXP_MESH_PORT_CONNECT_INFO_EAST_U_SMXP_0_1, NUM_MCS_EAST, 0, 4)
REG32(POR_MXP_MESH_PORT_CONNECT_INFO_NORTH_U_SMXP_0_1, 0x108020)
    FIELD(POR_MXP_MESH_PORT_CONNECT_INFO_NORTH_U_SMXP_0_1, NUM_MCS_NORTH, 0, 4)
REG32(POR_MXP_CHILD_INFO_U_SMXP_0_1, 0x108080)
    FIELD(POR_MXP_CHILD_INFO_U_SMXP_0_1, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_INFO_U_SMXP_0_1, CHILD_PTR_OFFSET, 16, 16)
    FIELD(POR_MXP_CHILD_INFO_U_SMXP_0_1, CHILD_COUNT, 0, 16)
REG32(POR_MXP_CHILD_POINTER_0_U_SMXP_0_1, 0x108100)
    FIELD(POR_MXP_CHILD_POINTER_0_U_SMXP_0_1, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_POINTER_0_U_SMXP_0_1, RELATIVE_ADDRESS_0, 0, 32)
REG32(POR_MXP_CHILD_POINTER_1_U_SMXP_0_1, 0x108108)
    FIELD(POR_MXP_CHILD_POINTER_1_U_SMXP_0_1, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_POINTER_1_U_SMXP_0_1, RELATIVE_ADDRESS_1, 0, 32)
REG32(POR_MXP_CHILD_POINTER_2_U_SMXP_0_1, 0x108110)
    FIELD(POR_MXP_CHILD_POINTER_2_U_SMXP_0_1, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_POINTER_2_U_SMXP_0_1, RELATIVE_ADDRESS_2, 0, 32)
REG32(POR_MXP_CHILD_POINTER_3_U_SMXP_0_1, 0x108118)
    FIELD(POR_MXP_CHILD_POINTER_3_U_SMXP_0_1, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_POINTER_3_U_SMXP_0_1, RELATIVE_ADDRESS_3, 0, 32)
REG32(POR_MXP_CHILD_POINTER_4_U_SMXP_0_1, 0x108120)
    FIELD(POR_MXP_CHILD_POINTER_4_U_SMXP_0_1, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_POINTER_4_U_SMXP_0_1, RELATIVE_ADDRESS_4, 0, 32)
REG32(POR_MXP_CHILD_POINTER_5_U_SMXP_0_1, 0x108128)
    FIELD(POR_MXP_CHILD_POINTER_5_U_SMXP_0_1, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_POINTER_5_U_SMXP_0_1, RELATIVE_ADDRESS_5, 0, 32)
REG32(POR_MXP_CHILD_POINTER_6_U_SMXP_0_1, 0x108130)
    FIELD(POR_MXP_CHILD_POINTER_6_U_SMXP_0_1, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_POINTER_6_U_SMXP_0_1, RELATIVE_ADDRESS_6, 0, 32)
REG32(POR_MXP_CHILD_POINTER_7_U_SMXP_0_1, 0x108138)
    FIELD(POR_MXP_CHILD_POINTER_7_U_SMXP_0_1, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_POINTER_7_U_SMXP_0_1, RELATIVE_ADDRESS_7, 0, 32)
REG32(POR_MXP_CHILD_POINTER_8_U_SMXP_0_1, 0x108140)
    FIELD(POR_MXP_CHILD_POINTER_8_U_SMXP_0_1, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_POINTER_8_U_SMXP_0_1, RELATIVE_ADDRESS_8, 0, 32)
REG32(POR_MXP_CHILD_POINTER_9_U_SMXP_0_1, 0x108148)
    FIELD(POR_MXP_CHILD_POINTER_9_U_SMXP_0_1, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_POINTER_9_U_SMXP_0_1, RELATIVE_ADDRESS_9, 0, 32)
REG32(POR_MXP_CHILD_POINTER_10_U_SMXP_0_1, 0x108150)
    FIELD(POR_MXP_CHILD_POINTER_10_U_SMXP_0_1, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_POINTER_10_U_SMXP_0_1, RELATIVE_ADDRESS_10, 0, 32)
REG32(POR_MXP_CHILD_POINTER_11_U_SMXP_0_1, 0x108158)
    FIELD(POR_MXP_CHILD_POINTER_11_U_SMXP_0_1, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_POINTER_11_U_SMXP_0_1, RELATIVE_ADDRESS_11, 0, 32)
REG32(POR_MXP_CHILD_POINTER_12_U_SMXP_0_1, 0x108160)
    FIELD(POR_MXP_CHILD_POINTER_12_U_SMXP_0_1, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_POINTER_12_U_SMXP_0_1, RELATIVE_ADDRESS_12, 0, 32)
REG32(POR_MXP_CHILD_POINTER_13_U_SMXP_0_1, 0x108168)
    FIELD(POR_MXP_CHILD_POINTER_13_U_SMXP_0_1, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_POINTER_13_U_SMXP_0_1, RELATIVE_ADDRESS_13, 0, 32)
REG32(POR_MXP_CHILD_POINTER_14_U_SMXP_0_1, 0x108170)
    FIELD(POR_MXP_CHILD_POINTER_14_U_SMXP_0_1, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_POINTER_14_U_SMXP_0_1, RELATIVE_ADDRESS_14, 0, 32)
REG32(POR_MXP_CHILD_POINTER_15_U_SMXP_0_1, 0x108178)
    FIELD(POR_MXP_CHILD_POINTER_15_U_SMXP_0_1, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_POINTER_15_U_SMXP_0_1, RELATIVE_ADDRESS_15, 0, 32)
REG32(POR_MXP_P0_INFO_U_SMXP_0_1, 0x108900)
    FIELD(POR_MXP_P0_INFO_U_SMXP_0_1, RESERVED_26, 26, 38)
    FIELD(POR_MXP_P0_INFO_U_SMXP_0_1, A4S_SAFE_XFACE_DISABLE_P0, 25, 1)
    FIELD(POR_MXP_P0_INFO_U_SMXP_0_1, CHI_SAFE_XFACE_DISABLE_P0, 24, 1)
    FIELD(POR_MXP_P0_INFO_U_SMXP_0_1, A4S_LOGICALID_BASE_P0, 16, 8)
    FIELD(POR_MXP_P0_INFO_U_SMXP_0_1, RESERVED_14, 14, 2)
    FIELD(POR_MXP_P0_INFO_U_SMXP_0_1, A4S_NUM_P0, 11, 3)
    FIELD(POR_MXP_P0_INFO_U_SMXP_0_1, RXBUF_NUM_ENTRIES_P0, 8, 3)
    FIELD(POR_MXP_P0_INFO_U_SMXP_0_1, EXT_SAM_EN_P0, 7, 1)
    FIELD(POR_MXP_P0_INFO_U_SMXP_0_1, DATACHECK_EN_P0, 5, 1)
    FIELD(POR_MXP_P0_INFO_U_SMXP_0_1, POISON_EN_P0, 4, 1)
    FIELD(POR_MXP_P0_INFO_U_SMXP_0_1, NUM_DEV_P0, 0, 3)
REG32(POR_MXP_P1_INFO_U_SMXP_0_1, 0x108908)
    FIELD(POR_MXP_P1_INFO_U_SMXP_0_1, RESERVED_26, 26, 38)
    FIELD(POR_MXP_P1_INFO_U_SMXP_0_1, A4S_SAFE_XFACE_DISABLE_P1, 25, 1)
    FIELD(POR_MXP_P1_INFO_U_SMXP_0_1, CHI_SAFE_XFACE_DISABLE_P1, 24, 1)
    FIELD(POR_MXP_P1_INFO_U_SMXP_0_1, A4S_LOGICALID_BASE_P1, 16, 8)
    FIELD(POR_MXP_P1_INFO_U_SMXP_0_1, RESERVED_14, 14, 2)
    FIELD(POR_MXP_P1_INFO_U_SMXP_0_1, A4S_NUM_P1, 11, 3)
    FIELD(POR_MXP_P1_INFO_U_SMXP_0_1, RXBUF_NUM_ENTRIES_P1, 8, 3)
    FIELD(POR_MXP_P1_INFO_U_SMXP_0_1, EXT_SAM_EN_P1, 7, 1)
    FIELD(POR_MXP_P1_INFO_U_SMXP_0_1, DATACHECK_EN_P1, 5, 1)
    FIELD(POR_MXP_P1_INFO_U_SMXP_0_1, POISON_EN_P1, 4, 1)
    FIELD(POR_MXP_P1_INFO_U_SMXP_0_1, NUM_DEV_P1, 0, 3)
REG32(POR_MXP_SECURE_REGISTER_GROUPS_OVERRIDE_U_SMXP_0_1, 0x108980)
    FIELD(POR_MXP_SECURE_REGISTER_GROUPS_OVERRIDE_U_SMXP_0_1, SYSCOREQ_CTL, 1, 1)
    FIELD(POR_MXP_SECURE_REGISTER_GROUPS_OVERRIDE_U_SMXP_0_1, QOS, 0, 1)
REG32(POR_MXP_AUX_CTL_U_SMXP_0_1, 0x108a00)
    FIELD(POR_MXP_AUX_CTL_U_SMXP_0_1, CLKGATE_DISABLE, 0, 1)
REG32(POR_MXP_P0_QOS_CONTROL_U_SMXP_0_1, 0x108a80)
    FIELD(POR_MXP_P0_QOS_CONTROL_U_SMXP_0_1, RESERVED_20, 20, 44)
    FIELD(POR_MXP_P0_QOS_CONTROL_U_SMXP_0_1, P0_QOS_OVERRIDE, 16, 4)
    FIELD(POR_MXP_P0_QOS_CONTROL_U_SMXP_0_1, P0_PQV_MODE, 6, 1)
    FIELD(POR_MXP_P0_QOS_CONTROL_U_SMXP_0_1, P0_REG_MODE, 4, 1)
    FIELD(POR_MXP_P0_QOS_CONTROL_U_SMXP_0_1, P0_QOS_OVERRIDE_EN, 2, 1)
    FIELD(POR_MXP_P0_QOS_CONTROL_U_SMXP_0_1, P0_LAT_EN, 0, 1)
REG32(POR_MXP_P0_QOS_LAT_TGT_U_SMXP_0_1, 0x108a88)
    FIELD(POR_MXP_P0_QOS_LAT_TGT_U_SMXP_0_1, RESERVED_12, 12, 52)
    FIELD(POR_MXP_P0_QOS_LAT_TGT_U_SMXP_0_1, P0_LAT_TGT, 0, 12)
REG32(POR_MXP_P0_QOS_LAT_SCALE_U_SMXP_0_1, 0x108a90)
    FIELD(POR_MXP_P0_QOS_LAT_SCALE_U_SMXP_0_1, P0_LAT_SCALE, 0, 3)
REG32(POR_MXP_P0_QOS_LAT_RANGE_U_SMXP_0_1, 0x108a98)
    FIELD(POR_MXP_P0_QOS_LAT_RANGE_U_SMXP_0_1, RESERVED_12, 12, 52)
    FIELD(POR_MXP_P0_QOS_LAT_RANGE_U_SMXP_0_1, P0_LAT_MAX_QOS, 8, 4)
    FIELD(POR_MXP_P0_QOS_LAT_RANGE_U_SMXP_0_1, P0_LAT_MIN_QOS, 0, 4)
REG32(POR_MXP_P1_QOS_CONTROL_U_SMXP_0_1, 0x108aa0)
    FIELD(POR_MXP_P1_QOS_CONTROL_U_SMXP_0_1, RESERVED_20, 20, 44)
    FIELD(POR_MXP_P1_QOS_CONTROL_U_SMXP_0_1, P1_QOS_OVERRIDE, 16, 4)
    FIELD(POR_MXP_P1_QOS_CONTROL_U_SMXP_0_1, P1_PQV_MODE, 6, 1)
    FIELD(POR_MXP_P1_QOS_CONTROL_U_SMXP_0_1, P1_REG_MODE, 4, 1)
    FIELD(POR_MXP_P1_QOS_CONTROL_U_SMXP_0_1, P1_QOS_OVERRIDE_EN, 2, 1)
    FIELD(POR_MXP_P1_QOS_CONTROL_U_SMXP_0_1, P1_LAT_EN, 0, 1)
REG32(POR_MXP_P1_QOS_LAT_TGT_U_SMXP_0_1, 0x108aa8)
    FIELD(POR_MXP_P1_QOS_LAT_TGT_U_SMXP_0_1, RESERVED_12, 12, 52)
    FIELD(POR_MXP_P1_QOS_LAT_TGT_U_SMXP_0_1, P1_LAT_TGT, 0, 12)
REG32(POR_MXP_P1_QOS_LAT_SCALE_U_SMXP_0_1, 0x108ab0)
    FIELD(POR_MXP_P1_QOS_LAT_SCALE_U_SMXP_0_1, P1_LAT_SCALE, 0, 3)
REG32(POR_MXP_P1_QOS_LAT_RANGE_U_SMXP_0_1, 0x108ab8)
    FIELD(POR_MXP_P1_QOS_LAT_RANGE_U_SMXP_0_1, RESERVED_12, 12, 52)
    FIELD(POR_MXP_P1_QOS_LAT_RANGE_U_SMXP_0_1, P1_LAT_MAX_QOS, 8, 4)
    FIELD(POR_MXP_P1_QOS_LAT_RANGE_U_SMXP_0_1, P1_LAT_MIN_QOS, 0, 4)
REG32(POR_MXP_P0_SYSCOREQ_CTL_U_SMXP_0_1, 0x109000)
    FIELD(POR_MXP_P0_SYSCOREQ_CTL_U_SMXP_0_1, SNPDVM_REQ_P0_D3, 3, 1)
    FIELD(POR_MXP_P0_SYSCOREQ_CTL_U_SMXP_0_1, SNPDVM_REQ_P0_D2, 2, 1)
    FIELD(POR_MXP_P0_SYSCOREQ_CTL_U_SMXP_0_1, SNPDVM_REQ_P0_D1, 1, 1)
    FIELD(POR_MXP_P0_SYSCOREQ_CTL_U_SMXP_0_1, SNPDVM_REQ_P0_D0, 0, 1)
REG32(POR_MXP_P1_SYSCOREQ_CTL_U_SMXP_0_1, 0x109008)
    FIELD(POR_MXP_P1_SYSCOREQ_CTL_U_SMXP_0_1, SNPDVM_REQ_P1_D3, 3, 1)
    FIELD(POR_MXP_P1_SYSCOREQ_CTL_U_SMXP_0_1, SNPDVM_REQ_P1_D2, 2, 1)
    FIELD(POR_MXP_P1_SYSCOREQ_CTL_U_SMXP_0_1, SNPDVM_REQ_P1_D1, 1, 1)
    FIELD(POR_MXP_P1_SYSCOREQ_CTL_U_SMXP_0_1, SNPDVM_REQ_P1_D0, 0, 1)
REG32(POR_MXP_P0_SYSCOACK_STATUS_U_SMXP_0_1, 0x109010)
    FIELD(POR_MXP_P0_SYSCOACK_STATUS_U_SMXP_0_1, SNPDVM_ACK_P0_D3, 3, 1)
    FIELD(POR_MXP_P0_SYSCOACK_STATUS_U_SMXP_0_1, SNPDVM_ACK_P0_D2, 2, 1)
    FIELD(POR_MXP_P0_SYSCOACK_STATUS_U_SMXP_0_1, SNPDVM_ACK_P0_D1, 1, 1)
    FIELD(POR_MXP_P0_SYSCOACK_STATUS_U_SMXP_0_1, SNPDVM_ACK_P0_D0, 0, 1)
REG32(POR_MXP_P1_SYSCOACK_STATUS_U_SMXP_0_1, 0x109018)
    FIELD(POR_MXP_P1_SYSCOACK_STATUS_U_SMXP_0_1, SNPDVM_ACK_P1_D3, 3, 1)
    FIELD(POR_MXP_P1_SYSCOACK_STATUS_U_SMXP_0_1, SNPDVM_ACK_P1_D2, 2, 1)
    FIELD(POR_MXP_P1_SYSCOACK_STATUS_U_SMXP_0_1, SNPDVM_ACK_P1_D1, 1, 1)
    FIELD(POR_MXP_P1_SYSCOACK_STATUS_U_SMXP_0_1, SNPDVM_ACK_P1_D0, 0, 1)
REG32(POR_MXP_PMU_EVENT_SEL_U_SMXP_0_1, 0x10a000)
    FIELD(POR_MXP_PMU_EVENT_SEL_U_SMXP_0_1, RESERVED_32, 32, 32)
    FIELD(POR_MXP_PMU_EVENT_SEL_U_SMXP_0_1, PMU_EVENT3_ID, 24, 8)
    FIELD(POR_MXP_PMU_EVENT_SEL_U_SMXP_0_1, PMU_EVENT2_ID, 16, 8)
    FIELD(POR_MXP_PMU_EVENT_SEL_U_SMXP_0_1, PMU_EVENT1_ID, 8, 8)
    FIELD(POR_MXP_PMU_EVENT_SEL_U_SMXP_0_1, PMU_EVENT0_ID, 0, 8)
REG32(POR_DTM_CONTROL_U_SMXP_0_1, 0x10a100)
    FIELD(POR_DTM_CONTROL_U_SMXP_0_1, TRACE_NO_ATB, 3, 1)
    FIELD(POR_DTM_CONTROL_U_SMXP_0_1, SAMPLE_PROFILE_ENABLE, 2, 1)
    FIELD(POR_DTM_CONTROL_U_SMXP_0_1, TRACE_TAG_ENABLE, 1, 1)
    FIELD(POR_DTM_CONTROL_U_SMXP_0_1, DTM_ENABLE, 0, 1)
REG32(POR_DTM_FIFO_ENTRY_READY_U_SMXP_0_1, 0x10a118)
    FIELD(POR_DTM_FIFO_ENTRY_READY_U_SMXP_0_1, READY, 0, 4)
REG32(POR_DTM_FIFO_ENTRY0_0_U_SMXP_0_1, 0x10a120)
REG32(POR_DTM_FIFO_ENTRY0_1_U_SMXP_0_1, 0x10a128)
REG32(POR_DTM_FIFO_ENTRY0_2_U_SMXP_0_1, 0x10a130)
    FIELD(POR_DTM_FIFO_ENTRY0_2_U_SMXP_0_1, RESERVED_32, 32, 32)
    FIELD(POR_DTM_FIFO_ENTRY0_2_U_SMXP_0_1, FIFO_CYCLE_COUNT, 16, 16)
    FIELD(POR_DTM_FIFO_ENTRY0_2_U_SMXP_0_1, FIFO_DATA2, 0, 16)
REG32(POR_DTM_FIFO_ENTRY1_0_U_SMXP_0_1, 0x10a138)
REG32(POR_DTM_FIFO_ENTRY1_1_U_SMXP_0_1, 0x10a140)
REG32(POR_DTM_FIFO_ENTRY1_2_U_SMXP_0_1, 0x10a148)
    FIELD(POR_DTM_FIFO_ENTRY1_2_U_SMXP_0_1, RESERVED_32, 32, 32)
    FIELD(POR_DTM_FIFO_ENTRY1_2_U_SMXP_0_1, FIFO_CYCLE_COUNT, 16, 16)
    FIELD(POR_DTM_FIFO_ENTRY1_2_U_SMXP_0_1, FIFO_DATA2, 0, 16)
REG32(POR_DTM_FIFO_ENTRY2_0_U_SMXP_0_1, 0x10a150)
REG32(POR_DTM_FIFO_ENTRY2_1_U_SMXP_0_1, 0x10a158)
REG32(POR_DTM_FIFO_ENTRY2_2_U_SMXP_0_1, 0x10a160)
    FIELD(POR_DTM_FIFO_ENTRY2_2_U_SMXP_0_1, RESERVED_32, 32, 32)
    FIELD(POR_DTM_FIFO_ENTRY2_2_U_SMXP_0_1, FIFO_CYCLE_COUNT, 16, 16)
    FIELD(POR_DTM_FIFO_ENTRY2_2_U_SMXP_0_1, FIFO_DATA2, 0, 16)
REG32(POR_DTM_FIFO_ENTRY3_0_U_SMXP_0_1, 0x10a168)
REG32(POR_DTM_FIFO_ENTRY3_1_U_SMXP_0_1, 0x10a170)
REG32(POR_DTM_FIFO_ENTRY3_2_U_SMXP_0_1, 0x10a178)
    FIELD(POR_DTM_FIFO_ENTRY3_2_U_SMXP_0_1, RESERVED_32, 32, 32)
    FIELD(POR_DTM_FIFO_ENTRY3_2_U_SMXP_0_1, FIFO_CYCLE_COUNT, 16, 16)
    FIELD(POR_DTM_FIFO_ENTRY3_2_U_SMXP_0_1, FIFO_DATA2, 0, 16)
REG32(POR_DTM_WP0_CONFIG_U_SMXP_0_1, 0x10a1a0)
    FIELD(POR_DTM_WP0_CONFIG_U_SMXP_0_1, RESERVED_15, 15, 49)
    FIELD(POR_DTM_WP0_CONFIG_U_SMXP_0_1, WP_DBGTRIG_EN, 14, 1)
    FIELD(POR_DTM_WP0_CONFIG_U_SMXP_0_1, WP_CTRIG_EN, 13, 1)
    FIELD(POR_DTM_WP0_CONFIG_U_SMXP_0_1, WP_CC_EN, 12, 1)
    FIELD(POR_DTM_WP0_CONFIG_U_SMXP_0_1, WP_PKT_TYPE, 9, 3)
    FIELD(POR_DTM_WP0_CONFIG_U_SMXP_0_1, WP_PKT_GEN, 8, 1)
    FIELD(POR_DTM_WP0_CONFIG_U_SMXP_0_1, WP_COMBINE, 6, 1)
    FIELD(POR_DTM_WP0_CONFIG_U_SMXP_0_1, WP_EXCLUSIVE, 5, 1)
    FIELD(POR_DTM_WP0_CONFIG_U_SMXP_0_1, WP_GRP, 4, 1)
    FIELD(POR_DTM_WP0_CONFIG_U_SMXP_0_1, WP_CHN_SEL, 1, 3)
    FIELD(POR_DTM_WP0_CONFIG_U_SMXP_0_1, WP_DEV_SEL, 0, 1)
REG32(POR_DTM_WP0_VAL_U_SMXP_0_1, 0x10a1a8)
REG32(POR_DTM_WP0_MASK_U_SMXP_0_1, 0x10a1b0)
REG32(POR_DTM_WP1_CONFIG_U_SMXP_0_1, 0x10a1b8)
    FIELD(POR_DTM_WP1_CONFIG_U_SMXP_0_1, RESERVED_15, 15, 49)
    FIELD(POR_DTM_WP1_CONFIG_U_SMXP_0_1, WP_DBGTRIG_EN, 14, 1)
    FIELD(POR_DTM_WP1_CONFIG_U_SMXP_0_1, WP_CTRIG_EN, 13, 1)
    FIELD(POR_DTM_WP1_CONFIG_U_SMXP_0_1, WP_CC_EN, 12, 1)
    FIELD(POR_DTM_WP1_CONFIG_U_SMXP_0_1, WP_PKT_TYPE, 9, 3)
    FIELD(POR_DTM_WP1_CONFIG_U_SMXP_0_1, WP_PKT_GEN, 8, 1)
    FIELD(POR_DTM_WP1_CONFIG_U_SMXP_0_1, WP_EXCLUSIVE, 5, 1)
    FIELD(POR_DTM_WP1_CONFIG_U_SMXP_0_1, WP_GRP, 4, 1)
    FIELD(POR_DTM_WP1_CONFIG_U_SMXP_0_1, WP_CHN_SEL, 1, 3)
    FIELD(POR_DTM_WP1_CONFIG_U_SMXP_0_1, WP_DEV_SEL, 0, 1)
REG32(POR_DTM_WP1_VAL_U_SMXP_0_1, 0x10a1c0)
REG32(POR_DTM_WP1_MASK_U_SMXP_0_1, 0x10a1c8)
REG32(POR_DTM_WP2_CONFIG_U_SMXP_0_1, 0x10a1d0)
    FIELD(POR_DTM_WP2_CONFIG_U_SMXP_0_1, RESERVED_15, 15, 49)
    FIELD(POR_DTM_WP2_CONFIG_U_SMXP_0_1, WP_DBGTRIG_EN, 14, 1)
    FIELD(POR_DTM_WP2_CONFIG_U_SMXP_0_1, WP_CTRIG_EN, 13, 1)
    FIELD(POR_DTM_WP2_CONFIG_U_SMXP_0_1, WP_CC_EN, 12, 1)
    FIELD(POR_DTM_WP2_CONFIG_U_SMXP_0_1, WP_PKT_TYPE, 9, 3)
    FIELD(POR_DTM_WP2_CONFIG_U_SMXP_0_1, WP_PKT_GEN, 8, 1)
    FIELD(POR_DTM_WP2_CONFIG_U_SMXP_0_1, WP_COMBINE, 6, 1)
    FIELD(POR_DTM_WP2_CONFIG_U_SMXP_0_1, WP_EXCLUSIVE, 5, 1)
    FIELD(POR_DTM_WP2_CONFIG_U_SMXP_0_1, WP_GRP, 4, 1)
    FIELD(POR_DTM_WP2_CONFIG_U_SMXP_0_1, WP_CHN_SEL, 1, 3)
    FIELD(POR_DTM_WP2_CONFIG_U_SMXP_0_1, WP_DEV_SEL, 0, 1)
REG32(POR_DTM_WP2_VAL_U_SMXP_0_1, 0x10a1d8)
REG32(POR_DTM_WP2_MASK_U_SMXP_0_1, 0x10a1e0)
REG32(POR_DTM_WP3_CONFIG_U_SMXP_0_1, 0x10a1e8)
    FIELD(POR_DTM_WP3_CONFIG_U_SMXP_0_1, RESERVED_15, 15, 49)
    FIELD(POR_DTM_WP3_CONFIG_U_SMXP_0_1, WP_DBGTRIG_EN, 14, 1)
    FIELD(POR_DTM_WP3_CONFIG_U_SMXP_0_1, WP_CTRIG_EN, 13, 1)
    FIELD(POR_DTM_WP3_CONFIG_U_SMXP_0_1, WP_CC_EN, 12, 1)
    FIELD(POR_DTM_WP3_CONFIG_U_SMXP_0_1, WP_PKT_TYPE, 9, 3)
    FIELD(POR_DTM_WP3_CONFIG_U_SMXP_0_1, WP_PKT_GEN, 8, 1)
    FIELD(POR_DTM_WP3_CONFIG_U_SMXP_0_1, WP_EXCLUSIVE, 5, 1)
    FIELD(POR_DTM_WP3_CONFIG_U_SMXP_0_1, WP_GRP, 4, 1)
    FIELD(POR_DTM_WP3_CONFIG_U_SMXP_0_1, WP_CHN_SEL, 1, 3)
    FIELD(POR_DTM_WP3_CONFIG_U_SMXP_0_1, WP_DEV_SEL, 0, 1)
REG32(POR_DTM_WP3_VAL_U_SMXP_0_1, 0x10a1f0)
REG32(POR_DTM_WP3_MASK_U_SMXP_0_1, 0x10a1f8)
REG32(POR_DTM_PMSICR_U_SMXP_0_1, 0x10a200)
    FIELD(POR_DTM_PMSICR_U_SMXP_0_1, RESERVED_32, 32, 32)
    FIELD(POR_DTM_PMSICR_U_SMXP_0_1, COUNT, 0, 32)
REG32(POR_DTM_PMSIRR_U_SMXP_0_1, 0x10a208)
    FIELD(POR_DTM_PMSIRR_U_SMXP_0_1, RESERVED_32, 32, 32)
    FIELD(POR_DTM_PMSIRR_U_SMXP_0_1, INTERVAL, 8, 24)
    FIELD(POR_DTM_PMSIRR_U_SMXP_0_1, RESERVED_0, 0, 8)
REG32(POR_DTM_PMU_CONFIG_U_SMXP_0_1, 0x10a210)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_0_1, RESERVED_62, 62, 2)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_0_1, PMEVCNT3_INPUT_SEL, 56, 6)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_0_1, RESERVED_54, 54, 2)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_0_1, PMEVCNT2_INPUT_SEL, 48, 6)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_0_1, RESERVED_46, 46, 2)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_0_1, PMEVCNT1_INPUT_SEL, 40, 6)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_0_1, RESERVED_38, 38, 2)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_0_1, PMEVCNT0_INPUT_SEL, 32, 6)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_0_1, RESERVED_31, 31, 1)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_0_1, PMEVCNT3_GLOBAL_NUM, 28, 3)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_0_1, RESERVED_27, 27, 1)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_0_1, PMEVCNT2_GLOBAL_NUM, 24, 3)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_0_1, RESERVED_23, 23, 1)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_0_1, PMEVCNT1_GLOBAL_NUM, 20, 3)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_0_1, RESERVED_19, 19, 1)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_0_1, PMEVCNT0_GLOBAL_NUM, 16, 3)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_0_1, RESERVED_9, 9, 7)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_0_1, CNTR_RST, 8, 1)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_0_1, PMEVCNT_PAIRED, 4, 4)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_0_1, PMEVCNTALL_COMBINED, 3, 1)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_0_1, PMEVCNT23_COMBINED, 2, 1)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_0_1, PMEVCNT01_COMBINED, 1, 1)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_0_1, PMU_EN, 0, 1)
REG32(POR_DTM_PMEVCNT_U_SMXP_0_1, 0x10a220)
    FIELD(POR_DTM_PMEVCNT_U_SMXP_0_1, PMEVCNT3, 48, 16)
    FIELD(POR_DTM_PMEVCNT_U_SMXP_0_1, PMEVCNT2, 32, 16)
    FIELD(POR_DTM_PMEVCNT_U_SMXP_0_1, PMEVCNT1, 16, 16)
    FIELD(POR_DTM_PMEVCNT_U_SMXP_0_1, PMEVCNT0, 0, 16)
REG32(POR_DTM_PMEVCNTSR_U_SMXP_0_1, 0x10a240)
    FIELD(POR_DTM_PMEVCNTSR_U_SMXP_0_1, PMEVCNTSR3, 48, 16)
    FIELD(POR_DTM_PMEVCNTSR_U_SMXP_0_1, PMEVCNTSR2, 32, 16)
    FIELD(POR_DTM_PMEVCNTSR_U_SMXP_0_1, PMEVCNTSR1, 16, 16)
    FIELD(POR_DTM_PMEVCNTSR_U_SMXP_0_1, PMEVCNTSR0, 0, 16)
REG32(POR_MXP_ERRFR_U_SMXP_0_1, 0x10b000)
    FIELD(POR_MXP_ERRFR_U_SMXP_0_1, RESERVED_15, 15, 49)
    FIELD(POR_MXP_ERRFR_U_SMXP_0_1, CEC, 12, 3)
    FIELD(POR_MXP_ERRFR_U_SMXP_0_1, CFI, 10, 2)
    FIELD(POR_MXP_ERRFR_U_SMXP_0_1, FI, 6, 2)
    FIELD(POR_MXP_ERRFR_U_SMXP_0_1, UI, 4, 2)
    FIELD(POR_MXP_ERRFR_U_SMXP_0_1, DE, 2, 2)
    FIELD(POR_MXP_ERRFR_U_SMXP_0_1, ED, 0, 2)
REG32(POR_MXP_ERRCTLR_U_SMXP_0_1, 0x10b008)
    FIELD(POR_MXP_ERRCTLR_U_SMXP_0_1, RESERVED_9, 9, 55)
    FIELD(POR_MXP_ERRCTLR_U_SMXP_0_1, CFI, 8, 1)
    FIELD(POR_MXP_ERRCTLR_U_SMXP_0_1, FI, 3, 1)
    FIELD(POR_MXP_ERRCTLR_U_SMXP_0_1, UI, 2, 1)
    FIELD(POR_MXP_ERRCTLR_U_SMXP_0_1, DE, 1, 1)
    FIELD(POR_MXP_ERRCTLR_U_SMXP_0_1, ED, 0, 1)
REG32(POR_MXP_ERRSTATUS_U_SMXP_0_1, 0x10b010)
    FIELD(POR_MXP_ERRSTATUS_U_SMXP_0_1, RESERVED_32, 32, 32)
    FIELD(POR_MXP_ERRSTATUS_U_SMXP_0_1, AV, 31, 1)
    FIELD(POR_MXP_ERRSTATUS_U_SMXP_0_1, V, 30, 1)
    FIELD(POR_MXP_ERRSTATUS_U_SMXP_0_1, UE, 29, 1)
    FIELD(POR_MXP_ERRSTATUS_U_SMXP_0_1, RESERVED_28, 28, 1)
    FIELD(POR_MXP_ERRSTATUS_U_SMXP_0_1, OF, 27, 1)
    FIELD(POR_MXP_ERRSTATUS_U_SMXP_0_1, MV, 26, 1)
    FIELD(POR_MXP_ERRSTATUS_U_SMXP_0_1, RESERVED_25, 25, 1)
    FIELD(POR_MXP_ERRSTATUS_U_SMXP_0_1, CE, 24, 1)
    FIELD(POR_MXP_ERRSTATUS_U_SMXP_0_1, DE, 23, 1)
    FIELD(POR_MXP_ERRSTATUS_U_SMXP_0_1, RESERVED_0, 0, 23)
REG32(POR_MXP_ERRMISC_U_SMXP_0_1, 0x10b028)
    FIELD(POR_MXP_ERRMISC_U_SMXP_0_1, RESERVED_59, 59, 5)
    FIELD(POR_MXP_ERRMISC_U_SMXP_0_1, TGTID, 48, 11)
    FIELD(POR_MXP_ERRMISC_U_SMXP_0_1, RESERVED_22, 22, 26)
    FIELD(POR_MXP_ERRMISC_U_SMXP_0_1, OPCODE, 16, 6)
    FIELD(POR_MXP_ERRMISC_U_SMXP_0_1, RESERVED_15, 15, 1)
    FIELD(POR_MXP_ERRMISC_U_SMXP_0_1, SRCID, 4, 11)
    FIELD(POR_MXP_ERRMISC_U_SMXP_0_1, ERRSRC, 0, 3)
REG32(POR_MXP_P0_BYTE_PAR_ERR_INJ_U_SMXP_0_1, 0x10b030)
    FIELD(POR_MXP_P0_BYTE_PAR_ERR_INJ_U_SMXP_0_1, P0_BYTE_PARITY_ERR_INJ, 0, 5)
REG32(POR_MXP_P1_BYTE_PAR_ERR_INJ_U_SMXP_0_1, 0x10b038)
    FIELD(POR_MXP_P1_BYTE_PAR_ERR_INJ_U_SMXP_0_1, P1_BYTE_PARITY_ERR_INJ, 0, 5)
REG32(POR_MXP_ERRFR_NS_U_SMXP_0_1, 0x10b100)
    FIELD(POR_MXP_ERRFR_NS_U_SMXP_0_1, RESERVED_15, 15, 49)
    FIELD(POR_MXP_ERRFR_NS_U_SMXP_0_1, CEC, 12, 3)
    FIELD(POR_MXP_ERRFR_NS_U_SMXP_0_1, CFI, 10, 2)
    FIELD(POR_MXP_ERRFR_NS_U_SMXP_0_1, FI, 6, 2)
    FIELD(POR_MXP_ERRFR_NS_U_SMXP_0_1, UI, 4, 2)
    FIELD(POR_MXP_ERRFR_NS_U_SMXP_0_1, DE, 2, 2)
    FIELD(POR_MXP_ERRFR_NS_U_SMXP_0_1, ED, 0, 2)
REG32(POR_MXP_ERRCTLR_NS_U_SMXP_0_1, 0x10b108)
    FIELD(POR_MXP_ERRCTLR_NS_U_SMXP_0_1, RESERVED_9, 9, 55)
    FIELD(POR_MXP_ERRCTLR_NS_U_SMXP_0_1, CFI, 8, 1)
    FIELD(POR_MXP_ERRCTLR_NS_U_SMXP_0_1, FI, 3, 1)
    FIELD(POR_MXP_ERRCTLR_NS_U_SMXP_0_1, UI, 2, 1)
    FIELD(POR_MXP_ERRCTLR_NS_U_SMXP_0_1, DE, 1, 1)
    FIELD(POR_MXP_ERRCTLR_NS_U_SMXP_0_1, ED, 0, 1)
REG32(POR_MXP_ERRSTATUS_NS_U_SMXP_0_1, 0x10b110)
    FIELD(POR_MXP_ERRSTATUS_NS_U_SMXP_0_1, RESERVED_32, 32, 32)
    FIELD(POR_MXP_ERRSTATUS_NS_U_SMXP_0_1, AV, 31, 1)
    FIELD(POR_MXP_ERRSTATUS_NS_U_SMXP_0_1, V, 30, 1)
    FIELD(POR_MXP_ERRSTATUS_NS_U_SMXP_0_1, UE, 29, 1)
    FIELD(POR_MXP_ERRSTATUS_NS_U_SMXP_0_1, RESERVED_28, 28, 1)
    FIELD(POR_MXP_ERRSTATUS_NS_U_SMXP_0_1, OF, 27, 1)
    FIELD(POR_MXP_ERRSTATUS_NS_U_SMXP_0_1, MV, 26, 1)
    FIELD(POR_MXP_ERRSTATUS_NS_U_SMXP_0_1, RESERVED_25, 25, 1)
    FIELD(POR_MXP_ERRSTATUS_NS_U_SMXP_0_1, CE, 24, 1)
    FIELD(POR_MXP_ERRSTATUS_NS_U_SMXP_0_1, DE, 23, 1)
    FIELD(POR_MXP_ERRSTATUS_NS_U_SMXP_0_1, RESERVED_0, 0, 23)
REG32(POR_MXP_ERRMISC_NS_U_SMXP_0_1, 0x10b128)
    FIELD(POR_MXP_ERRMISC_NS_U_SMXP_0_1, RESERVED_59, 59, 5)
    FIELD(POR_MXP_ERRMISC_NS_U_SMXP_0_1, TGTID, 48, 11)
    FIELD(POR_MXP_ERRMISC_NS_U_SMXP_0_1, RESERVED_22, 22, 26)
    FIELD(POR_MXP_ERRMISC_NS_U_SMXP_0_1, OPCODE, 16, 6)
    FIELD(POR_MXP_ERRMISC_NS_U_SMXP_0_1, RESERVED_15, 15, 1)
    FIELD(POR_MXP_ERRMISC_NS_U_SMXP_0_1, SRCID, 4, 11)
    FIELD(POR_MXP_ERRMISC_NS_U_SMXP_0_1, ERRSRC, 0, 3)
REG32(POR_FDC_NODE_INFO_U_SMXP_0_1, 0x12c000)
    FIELD(POR_FDC_NODE_INFO_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_FDC_NODE_INFO_U_SMXP_0_1, LOGICAL_ID, 32, 16)
    FIELD(POR_FDC_NODE_INFO_U_SMXP_0_1, NODE_ID, 16, 16)
    FIELD(POR_FDC_NODE_INFO_U_SMXP_0_1, NODE_TYPE, 0, 16)
REG32(POR_FDC_CHILD_INFO_U_SMXP_0_1, 0x12c080)
    FIELD(POR_FDC_CHILD_INFO_U_SMXP_0_1, RESERVED_32, 32, 32)
    FIELD(POR_FDC_CHILD_INFO_U_SMXP_0_1, CHILD_PTR_OFFSET, 16, 16)
    FIELD(POR_FDC_CHILD_INFO_U_SMXP_0_1, CHILD_COUNT, 0, 16)
REG32(POR_ERRFR_MXP_U_SMXP_0_1, 0x12f000)
    FIELD(POR_ERRFR_MXP_U_SMXP_0_1, FI, 6, 2)
    FIELD(POR_ERRFR_MXP_U_SMXP_0_1, UI, 4, 2)
    FIELD(POR_ERRFR_MXP_U_SMXP_0_1, ED, 0, 2)
REG32(POR_ERRCTLR_MXP_U_SMXP_0_1, 0x12f008)
    FIELD(POR_ERRCTLR_MXP_U_SMXP_0_1, RESERVED_32, 32, 32)
    FIELD(POR_ERRCTLR_MXP_U_SMXP_0_1, ERC, 14, 18)
    FIELD(POR_ERRCTLR_MXP_U_SMXP_0_1, FI, 3, 1)
    FIELD(POR_ERRCTLR_MXP_U_SMXP_0_1, UI, 2, 1)
    FIELD(POR_ERRCTLR_MXP_U_SMXP_0_1, ED, 0, 1)
REG32(POR_ERRSTATUS_MXP_U_SMXP_0_1, 0x12f010)
    FIELD(POR_ERRSTATUS_MXP_U_SMXP_0_1, RESERVED_31, 31, 33)
    FIELD(POR_ERRSTATUS_MXP_U_SMXP_0_1, V, 30, 1)
    FIELD(POR_ERRSTATUS_MXP_U_SMXP_0_1, UE, 29, 1)
    FIELD(POR_ERRSTATUS_MXP_U_SMXP_0_1, RESERVED_28, 28, 1)
    FIELD(POR_ERRSTATUS_MXP_U_SMXP_0_1, OF, 27, 1)
    FIELD(POR_ERRSTATUS_MXP_U_SMXP_0_1, RESERVED_24, 24, 3)
    FIELD(POR_ERRSTATUS_MXP_U_SMXP_0_1, DE, 23, 1)
    FIELD(POR_ERRSTATUS_MXP_U_SMXP_0_1, RESERVED_16, 16, 7)
    FIELD(POR_ERRSTATUS_MXP_U_SMXP_0_1, V_ERR_TYPE, 6, 10)
    FIELD(POR_ERRSTATUS_MXP_U_SMXP_0_1, RESERVED_0, 0, 6)
REG32(POR_FDC_AUX_CTL_MXP_U_SMXP_0_1, 0x12f018)
    FIELD(POR_FDC_AUX_CTL_MXP_U_SMXP_0_1, CLKGATE_OVERRIDE, 4, 1)
    FIELD(POR_FDC_AUX_CTL_MXP_U_SMXP_0_1, RESERVED_0, 0, 4)
REG32(POR_ERRFR_P0_D0_U_SMXP_0_1, 0x12f040)
    FIELD(POR_ERRFR_P0_D0_U_SMXP_0_1, FI, 6, 2)
    FIELD(POR_ERRFR_P0_D0_U_SMXP_0_1, UI, 4, 2)
    FIELD(POR_ERRFR_P0_D0_U_SMXP_0_1, ED, 0, 2)
REG32(POR_ERRCTLR_P0_D0_U_SMXP_0_1, 0x12f048)
    FIELD(POR_ERRCTLR_P0_D0_U_SMXP_0_1, RESERVED_32, 32, 32)
    FIELD(POR_ERRCTLR_P0_D0_U_SMXP_0_1, ERC, 14, 18)
    FIELD(POR_ERRCTLR_P0_D0_U_SMXP_0_1, FI, 3, 1)
    FIELD(POR_ERRCTLR_P0_D0_U_SMXP_0_1, UI, 2, 1)
    FIELD(POR_ERRCTLR_P0_D0_U_SMXP_0_1, ED, 0, 1)
REG32(POR_ERRSTATUS_P0_D0_U_SMXP_0_1, 0x12f050)
    FIELD(POR_ERRSTATUS_P0_D0_U_SMXP_0_1, RESERVED_31, 31, 33)
    FIELD(POR_ERRSTATUS_P0_D0_U_SMXP_0_1, V, 30, 1)
    FIELD(POR_ERRSTATUS_P0_D0_U_SMXP_0_1, UE, 29, 1)
    FIELD(POR_ERRSTATUS_P0_D0_U_SMXP_0_1, RESERVED_28, 28, 1)
    FIELD(POR_ERRSTATUS_P0_D0_U_SMXP_0_1, OF, 27, 1)
    FIELD(POR_ERRSTATUS_P0_D0_U_SMXP_0_1, RESERVED_24, 24, 3)
    FIELD(POR_ERRSTATUS_P0_D0_U_SMXP_0_1, DE, 23, 1)
    FIELD(POR_ERRSTATUS_P0_D0_U_SMXP_0_1, RESERVED_16, 16, 7)
    FIELD(POR_ERRSTATUS_P0_D0_U_SMXP_0_1, V_ERR_TYPE, 6, 10)
    FIELD(POR_ERRSTATUS_P0_D0_U_SMXP_0_1, RESERVED_0, 0, 6)
REG32(POR_FDC_AUX_CTL_P0_D0_U_SMXP_0_1, 0x12f058)
    FIELD(POR_FDC_AUX_CTL_P0_D0_U_SMXP_0_1, CLKGATE_OVERRIDE, 4, 1)
    FIELD(POR_FDC_AUX_CTL_P0_D0_U_SMXP_0_1, HANG_DET_CONFIG, 0, 4)
REG32(POR_ERRFR_P0_D1_U_SMXP_0_1, 0x12f080)
    FIELD(POR_ERRFR_P0_D1_U_SMXP_0_1, FI, 6, 2)
    FIELD(POR_ERRFR_P0_D1_U_SMXP_0_1, UI, 4, 2)
    FIELD(POR_ERRFR_P0_D1_U_SMXP_0_1, ED, 0, 2)
REG32(POR_ERRCTLR_P0_D1_U_SMXP_0_1, 0x12f088)
    FIELD(POR_ERRCTLR_P0_D1_U_SMXP_0_1, RESERVED_32, 32, 32)
    FIELD(POR_ERRCTLR_P0_D1_U_SMXP_0_1, ERC, 14, 18)
    FIELD(POR_ERRCTLR_P0_D1_U_SMXP_0_1, FI, 3, 1)
    FIELD(POR_ERRCTLR_P0_D1_U_SMXP_0_1, UI, 2, 1)
    FIELD(POR_ERRCTLR_P0_D1_U_SMXP_0_1, ED, 0, 1)
REG32(POR_ERRSTATUS_P0_D1_U_SMXP_0_1, 0x12f090)
    FIELD(POR_ERRSTATUS_P0_D1_U_SMXP_0_1, RESERVED_31, 31, 33)
    FIELD(POR_ERRSTATUS_P0_D1_U_SMXP_0_1, V, 30, 1)
    FIELD(POR_ERRSTATUS_P0_D1_U_SMXP_0_1, UE, 29, 1)
    FIELD(POR_ERRSTATUS_P0_D1_U_SMXP_0_1, RESERVED_28, 28, 1)
    FIELD(POR_ERRSTATUS_P0_D1_U_SMXP_0_1, OF, 27, 1)
    FIELD(POR_ERRSTATUS_P0_D1_U_SMXP_0_1, RESERVED_24, 24, 3)
    FIELD(POR_ERRSTATUS_P0_D1_U_SMXP_0_1, DE, 23, 1)
    FIELD(POR_ERRSTATUS_P0_D1_U_SMXP_0_1, RESERVED_16, 16, 7)
    FIELD(POR_ERRSTATUS_P0_D1_U_SMXP_0_1, V_ERR_TYPE, 6, 10)
    FIELD(POR_ERRSTATUS_P0_D1_U_SMXP_0_1, RESERVED_0, 0, 6)
REG32(POR_FDC_AUX_CTL_P0_D1_U_SMXP_0_1, 0x12f098)
    FIELD(POR_FDC_AUX_CTL_P0_D1_U_SMXP_0_1, CLKGATE_OVERRIDE, 4, 1)
    FIELD(POR_FDC_AUX_CTL_P0_D1_U_SMXP_0_1, HANG_DET_CONFIG, 0, 4)
REG32(POR_ERRFR_P0_D2_U_SMXP_0_1, 0x12f0c0)
    FIELD(POR_ERRFR_P0_D2_U_SMXP_0_1, FI, 6, 2)
    FIELD(POR_ERRFR_P0_D2_U_SMXP_0_1, UI, 4, 2)
    FIELD(POR_ERRFR_P0_D2_U_SMXP_0_1, ED, 0, 2)
REG32(POR_ERRCTLR_P0_D2_U_SMXP_0_1, 0x12f0c8)
    FIELD(POR_ERRCTLR_P0_D2_U_SMXP_0_1, RESERVED_32, 32, 32)
    FIELD(POR_ERRCTLR_P0_D2_U_SMXP_0_1, ERC, 14, 18)
    FIELD(POR_ERRCTLR_P0_D2_U_SMXP_0_1, FI, 3, 1)
    FIELD(POR_ERRCTLR_P0_D2_U_SMXP_0_1, UI, 2, 1)
    FIELD(POR_ERRCTLR_P0_D2_U_SMXP_0_1, ED, 0, 1)
REG32(POR_ERRSTATUS_P0_D2_U_SMXP_0_1, 0x12f0d0)
    FIELD(POR_ERRSTATUS_P0_D2_U_SMXP_0_1, RESERVED_31, 31, 33)
    FIELD(POR_ERRSTATUS_P0_D2_U_SMXP_0_1, V, 30, 1)
    FIELD(POR_ERRSTATUS_P0_D2_U_SMXP_0_1, UE, 29, 1)
    FIELD(POR_ERRSTATUS_P0_D2_U_SMXP_0_1, RESERVED_28, 28, 1)
    FIELD(POR_ERRSTATUS_P0_D2_U_SMXP_0_1, OF, 27, 1)
    FIELD(POR_ERRSTATUS_P0_D2_U_SMXP_0_1, RESERVED_24, 24, 3)
    FIELD(POR_ERRSTATUS_P0_D2_U_SMXP_0_1, DE, 23, 1)
    FIELD(POR_ERRSTATUS_P0_D2_U_SMXP_0_1, RESERVED_16, 16, 7)
    FIELD(POR_ERRSTATUS_P0_D2_U_SMXP_0_1, V_ERR_TYPE, 6, 10)
    FIELD(POR_ERRSTATUS_P0_D2_U_SMXP_0_1, RESERVED_0, 0, 6)
REG32(POR_FDC_AUX_CTL_P0_D2_U_SMXP_0_1, 0x12f0d8)
    FIELD(POR_FDC_AUX_CTL_P0_D2_U_SMXP_0_1, CLKGATE_OVERRIDE, 4, 1)
    FIELD(POR_FDC_AUX_CTL_P0_D2_U_SMXP_0_1, HANG_DET_CONFIG, 0, 4)
REG32(POR_ERRFR_P0_D3_U_SMXP_0_1, 0x12f100)
    FIELD(POR_ERRFR_P0_D3_U_SMXP_0_1, FI, 6, 2)
    FIELD(POR_ERRFR_P0_D3_U_SMXP_0_1, UI, 4, 2)
    FIELD(POR_ERRFR_P0_D3_U_SMXP_0_1, ED, 0, 2)
REG32(POR_ERRCTLR_P0_D3_U_SMXP_0_1, 0x12f108)
    FIELD(POR_ERRCTLR_P0_D3_U_SMXP_0_1, RESERVED_32, 32, 32)
    FIELD(POR_ERRCTLR_P0_D3_U_SMXP_0_1, ERC, 14, 18)
    FIELD(POR_ERRCTLR_P0_D3_U_SMXP_0_1, FI, 3, 1)
    FIELD(POR_ERRCTLR_P0_D3_U_SMXP_0_1, UI, 2, 1)
    FIELD(POR_ERRCTLR_P0_D3_U_SMXP_0_1, ED, 0, 1)
REG32(POR_ERRSTATUS_P0_D3_U_SMXP_0_1, 0x12f110)
    FIELD(POR_ERRSTATUS_P0_D3_U_SMXP_0_1, RESERVED_31, 31, 33)
    FIELD(POR_ERRSTATUS_P0_D3_U_SMXP_0_1, V, 30, 1)
    FIELD(POR_ERRSTATUS_P0_D3_U_SMXP_0_1, UE, 29, 1)
    FIELD(POR_ERRSTATUS_P0_D3_U_SMXP_0_1, RESERVED_28, 28, 1)
    FIELD(POR_ERRSTATUS_P0_D3_U_SMXP_0_1, OF, 27, 1)
    FIELD(POR_ERRSTATUS_P0_D3_U_SMXP_0_1, RESERVED_24, 24, 3)
    FIELD(POR_ERRSTATUS_P0_D3_U_SMXP_0_1, DE, 23, 1)
    FIELD(POR_ERRSTATUS_P0_D3_U_SMXP_0_1, RESERVED_16, 16, 7)
    FIELD(POR_ERRSTATUS_P0_D3_U_SMXP_0_1, V_ERR_TYPE, 6, 10)
    FIELD(POR_ERRSTATUS_P0_D3_U_SMXP_0_1, RESERVED_0, 0, 6)
REG32(POR_FDC_AUX_CTL_P0_D3_U_SMXP_0_1, 0x12f118)
    FIELD(POR_FDC_AUX_CTL_P0_D3_U_SMXP_0_1, CLKGATE_OVERRIDE, 4, 1)
    FIELD(POR_FDC_AUX_CTL_P0_D3_U_SMXP_0_1, HANG_DET_CONFIG, 0, 4)
REG32(POR_ERRFR_P1_D0_U_SMXP_0_1, 0x12f140)
    FIELD(POR_ERRFR_P1_D0_U_SMXP_0_1, FI, 6, 2)
    FIELD(POR_ERRFR_P1_D0_U_SMXP_0_1, UI, 4, 2)
    FIELD(POR_ERRFR_P1_D0_U_SMXP_0_1, ED, 0, 2)
REG32(POR_ERRCTLR_P1_D0_U_SMXP_0_1, 0x12f148)
    FIELD(POR_ERRCTLR_P1_D0_U_SMXP_0_1, RESERVED_32, 32, 32)
    FIELD(POR_ERRCTLR_P1_D0_U_SMXP_0_1, ERC, 14, 18)
    FIELD(POR_ERRCTLR_P1_D0_U_SMXP_0_1, FI, 3, 1)
    FIELD(POR_ERRCTLR_P1_D0_U_SMXP_0_1, UI, 2, 1)
    FIELD(POR_ERRCTLR_P1_D0_U_SMXP_0_1, ED, 0, 1)
REG32(POR_ERRSTATUS_P1_D0_U_SMXP_0_1, 0x12f150)
    FIELD(POR_ERRSTATUS_P1_D0_U_SMXP_0_1, RESERVED_31, 31, 33)
    FIELD(POR_ERRSTATUS_P1_D0_U_SMXP_0_1, V, 30, 1)
    FIELD(POR_ERRSTATUS_P1_D0_U_SMXP_0_1, UE, 29, 1)
    FIELD(POR_ERRSTATUS_P1_D0_U_SMXP_0_1, RESERVED_28, 28, 1)
    FIELD(POR_ERRSTATUS_P1_D0_U_SMXP_0_1, OF, 27, 1)
    FIELD(POR_ERRSTATUS_P1_D0_U_SMXP_0_1, RESERVED_24, 24, 3)
    FIELD(POR_ERRSTATUS_P1_D0_U_SMXP_0_1, DE, 23, 1)
    FIELD(POR_ERRSTATUS_P1_D0_U_SMXP_0_1, RESERVED_16, 16, 7)
    FIELD(POR_ERRSTATUS_P1_D0_U_SMXP_0_1, V_ERR_TYPE, 6, 10)
    FIELD(POR_ERRSTATUS_P1_D0_U_SMXP_0_1, RESERVED_0, 0, 6)
REG32(POR_FDC_AUX_CTL_P1_D0_U_SMXP_0_1, 0x12f158)
    FIELD(POR_FDC_AUX_CTL_P1_D0_U_SMXP_0_1, CLKGATE_OVERRIDE, 4, 1)
    FIELD(POR_FDC_AUX_CTL_P1_D0_U_SMXP_0_1, HANG_DET_CONFIG, 0, 4)
REG32(POR_ERRFR_P1_D1_U_SMXP_0_1, 0x12f180)
    FIELD(POR_ERRFR_P1_D1_U_SMXP_0_1, FI, 6, 2)
    FIELD(POR_ERRFR_P1_D1_U_SMXP_0_1, UI, 4, 2)
    FIELD(POR_ERRFR_P1_D1_U_SMXP_0_1, ED, 0, 2)
REG32(POR_ERRCTLR_P1_D1_U_SMXP_0_1, 0x12f188)
    FIELD(POR_ERRCTLR_P1_D1_U_SMXP_0_1, RESERVED_32, 32, 32)
    FIELD(POR_ERRCTLR_P1_D1_U_SMXP_0_1, ERC, 14, 18)
    FIELD(POR_ERRCTLR_P1_D1_U_SMXP_0_1, FI, 3, 1)
    FIELD(POR_ERRCTLR_P1_D1_U_SMXP_0_1, UI, 2, 1)
    FIELD(POR_ERRCTLR_P1_D1_U_SMXP_0_1, ED, 0, 1)
REG32(POR_ERRSTATUS_P1_D1_U_SMXP_0_1, 0x12f190)
    FIELD(POR_ERRSTATUS_P1_D1_U_SMXP_0_1, RESERVED_31, 31, 33)
    FIELD(POR_ERRSTATUS_P1_D1_U_SMXP_0_1, V, 30, 1)
    FIELD(POR_ERRSTATUS_P1_D1_U_SMXP_0_1, UE, 29, 1)
    FIELD(POR_ERRSTATUS_P1_D1_U_SMXP_0_1, RESERVED_28, 28, 1)
    FIELD(POR_ERRSTATUS_P1_D1_U_SMXP_0_1, OF, 27, 1)
    FIELD(POR_ERRSTATUS_P1_D1_U_SMXP_0_1, RESERVED_24, 24, 3)
    FIELD(POR_ERRSTATUS_P1_D1_U_SMXP_0_1, DE, 23, 1)
    FIELD(POR_ERRSTATUS_P1_D1_U_SMXP_0_1, RESERVED_16, 16, 7)
    FIELD(POR_ERRSTATUS_P1_D1_U_SMXP_0_1, V_ERR_TYPE, 6, 10)
    FIELD(POR_ERRSTATUS_P1_D1_U_SMXP_0_1, RESERVED_0, 0, 6)
REG32(POR_FDC_AUX_CTL_P1_D1_U_SMXP_0_1, 0x12f198)
    FIELD(POR_FDC_AUX_CTL_P1_D1_U_SMXP_0_1, CLKGATE_OVERRIDE, 4, 1)
    FIELD(POR_FDC_AUX_CTL_P1_D1_U_SMXP_0_1, HANG_DET_CONFIG, 0, 4)
REG32(POR_ERRFR_P1_D2_U_SMXP_0_1, 0x12f1c0)
    FIELD(POR_ERRFR_P1_D2_U_SMXP_0_1, FI, 6, 2)
    FIELD(POR_ERRFR_P1_D2_U_SMXP_0_1, UI, 4, 2)
    FIELD(POR_ERRFR_P1_D2_U_SMXP_0_1, ED, 0, 2)
REG32(POR_ERRCTLR_P1_D2_U_SMXP_0_1, 0x12f1c8)
    FIELD(POR_ERRCTLR_P1_D2_U_SMXP_0_1, RESERVED_32, 32, 32)
    FIELD(POR_ERRCTLR_P1_D2_U_SMXP_0_1, ERC, 14, 18)
    FIELD(POR_ERRCTLR_P1_D2_U_SMXP_0_1, FI, 3, 1)
    FIELD(POR_ERRCTLR_P1_D2_U_SMXP_0_1, UI, 2, 1)
    FIELD(POR_ERRCTLR_P1_D2_U_SMXP_0_1, ED, 0, 1)
REG32(POR_ERRSTATUS_P1_D2_U_SMXP_0_1, 0x12f1d0)
    FIELD(POR_ERRSTATUS_P1_D2_U_SMXP_0_1, RESERVED_31, 31, 33)
    FIELD(POR_ERRSTATUS_P1_D2_U_SMXP_0_1, V, 30, 1)
    FIELD(POR_ERRSTATUS_P1_D2_U_SMXP_0_1, UE, 29, 1)
    FIELD(POR_ERRSTATUS_P1_D2_U_SMXP_0_1, RESERVED_28, 28, 1)
    FIELD(POR_ERRSTATUS_P1_D2_U_SMXP_0_1, OF, 27, 1)
    FIELD(POR_ERRSTATUS_P1_D2_U_SMXP_0_1, RESERVED_24, 24, 3)
    FIELD(POR_ERRSTATUS_P1_D2_U_SMXP_0_1, DE, 23, 1)
    FIELD(POR_ERRSTATUS_P1_D2_U_SMXP_0_1, RESERVED_16, 16, 7)
    FIELD(POR_ERRSTATUS_P1_D2_U_SMXP_0_1, V_ERR_TYPE, 6, 10)
    FIELD(POR_ERRSTATUS_P1_D2_U_SMXP_0_1, RESERVED_0, 0, 6)
REG32(POR_FDC_AUX_CTL_P1_D2_U_SMXP_0_1, 0x12f1d8)
    FIELD(POR_FDC_AUX_CTL_P1_D2_U_SMXP_0_1, CLKGATE_OVERRIDE, 4, 1)
    FIELD(POR_FDC_AUX_CTL_P1_D2_U_SMXP_0_1, HANG_DET_CONFIG, 0, 4)
REG32(POR_ERRFR_P1_D3_U_SMXP_0_1, 0x12f200)
    FIELD(POR_ERRFR_P1_D3_U_SMXP_0_1, FI, 6, 2)
    FIELD(POR_ERRFR_P1_D3_U_SMXP_0_1, UI, 4, 2)
    FIELD(POR_ERRFR_P1_D3_U_SMXP_0_1, ED, 0, 2)
REG32(POR_ERRCTLR_P1_D3_U_SMXP_0_1, 0x12f208)
    FIELD(POR_ERRCTLR_P1_D3_U_SMXP_0_1, RESERVED_32, 32, 32)
    FIELD(POR_ERRCTLR_P1_D3_U_SMXP_0_1, ERC, 14, 18)
    FIELD(POR_ERRCTLR_P1_D3_U_SMXP_0_1, FI, 3, 1)
    FIELD(POR_ERRCTLR_P1_D3_U_SMXP_0_1, UI, 2, 1)
    FIELD(POR_ERRCTLR_P1_D3_U_SMXP_0_1, ED, 0, 1)
REG32(POR_ERRSTATUS_P1_D3_U_SMXP_0_1, 0x12f210)
    FIELD(POR_ERRSTATUS_P1_D3_U_SMXP_0_1, RESERVED_31, 31, 33)
    FIELD(POR_ERRSTATUS_P1_D3_U_SMXP_0_1, V, 30, 1)
    FIELD(POR_ERRSTATUS_P1_D3_U_SMXP_0_1, UE, 29, 1)
    FIELD(POR_ERRSTATUS_P1_D3_U_SMXP_0_1, RESERVED_28, 28, 1)
    FIELD(POR_ERRSTATUS_P1_D3_U_SMXP_0_1, OF, 27, 1)
    FIELD(POR_ERRSTATUS_P1_D3_U_SMXP_0_1, RESERVED_24, 24, 3)
    FIELD(POR_ERRSTATUS_P1_D3_U_SMXP_0_1, DE, 23, 1)
    FIELD(POR_ERRSTATUS_P1_D3_U_SMXP_0_1, RESERVED_16, 16, 7)
    FIELD(POR_ERRSTATUS_P1_D3_U_SMXP_0_1, V_ERR_TYPE, 6, 10)
    FIELD(POR_ERRSTATUS_P1_D3_U_SMXP_0_1, RESERVED_0, 0, 6)
REG32(POR_FDC_AUX_CTL_P1_D3_U_SMXP_0_1, 0x12f218)
    FIELD(POR_FDC_AUX_CTL_P1_D3_U_SMXP_0_1, CLKGATE_OVERRIDE, 4, 1)
    FIELD(POR_FDC_AUX_CTL_P1_D3_U_SMXP_0_1, HANG_DET_CONFIG, 0, 4)
REG32(POR_ERRINJECT_U_SMXP_0_1, 0x12f300)
    FIELD(POR_ERRINJECT_U_SMXP_0_1, ERR_DEV, 4, 4)
    FIELD(POR_ERRINJECT_U_SMXP_0_1, ERR_TYPE, 0, 4)
REG32(POR_FDC_KEY_U_SMXP_0_1, 0x12f308)
    FIELD(POR_FDC_KEY_U_SMXP_0_1, KEY, 0, 8)
REG32(POR_MPU_NODE_INFO_U_SMXP_0_1, 0x13c000)
    FIELD(POR_MPU_NODE_INFO_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_NODE_INFO_U_SMXP_0_1, LOGICAL_ID, 32, 16)
    FIELD(POR_MPU_NODE_INFO_U_SMXP_0_1, NODE_ID, 16, 16)
    FIELD(POR_MPU_NODE_INFO_U_SMXP_0_1, NODE_TYPE, 0, 16)
REG32(POR_MPU_CHILD_INFO_U_SMXP_0_1, 0x13c080)
    FIELD(POR_MPU_CHILD_INFO_U_SMXP_0_1, RESERVED_32, 32, 32)
    FIELD(POR_MPU_CHILD_INFO_U_SMXP_0_1, CHILD_PTR_OFFSET, 16, 16)
    FIELD(POR_MPU_CHILD_INFO_U_SMXP_0_1, CHILD_COUNT, 0, 16)
REG32(POR_MPU_UNIT_INFO_U_SMXP_0_1, 0x13c900)
    FIELD(POR_MPU_UNIT_INFO_U_SMXP_0_1, RESERVED_16, 16, 48)
    FIELD(POR_MPU_UNIT_INFO_U_SMXP_0_1, MASTER_7_PRESENT, 15, 1)
    FIELD(POR_MPU_UNIT_INFO_U_SMXP_0_1, MASTER_6_PRESENT, 14, 1)
    FIELD(POR_MPU_UNIT_INFO_U_SMXP_0_1, MASTER_5_PRESENT, 13, 1)
    FIELD(POR_MPU_UNIT_INFO_U_SMXP_0_1, MASTER_4_PRESENT, 12, 1)
    FIELD(POR_MPU_UNIT_INFO_U_SMXP_0_1, MASTER_3_PRESENT, 11, 1)
    FIELD(POR_MPU_UNIT_INFO_U_SMXP_0_1, MASTER_2_PRESENT, 10, 1)
    FIELD(POR_MPU_UNIT_INFO_U_SMXP_0_1, MASTER_1_PRESENT, 9, 1)
    FIELD(POR_MPU_UNIT_INFO_U_SMXP_0_1, MASTER_0_PRESENT, 8, 1)
    FIELD(POR_MPU_UNIT_INFO_U_SMXP_0_1, NUM_PROG_REGION, 0, 8)
REG32(POR_MPU_M0_CTL_U_SMXP_0_1, 0x13d000)
    FIELD(POR_MPU_M0_CTL_U_SMXP_0_1, M0_EN, 2, 1)
    FIELD(POR_MPU_M0_CTL_U_SMXP_0_1, M0_ACTION, 0, 2)
REG32(POR_MPU_M0_PRBAR0_U_SMXP_0_1, 0x13d010)
    FIELD(POR_MPU_M0_PRBAR0_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR0_U_SMXP_0_1, REGION0_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR0_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR0_U_SMXP_0_1, REGION0_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR0_U_SMXP_0_1, REGION0_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR0_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR0_U_SMXP_0_1, 0x13d018)
    FIELD(POR_MPU_M0_PRLAR0_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR0_U_SMXP_0_1, REGION0_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR0_U_SMXP_0_1, REGION0_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR1_U_SMXP_0_1, 0x13d020)
    FIELD(POR_MPU_M0_PRBAR1_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR1_U_SMXP_0_1, REGION1_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR1_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR1_U_SMXP_0_1, REGION1_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR1_U_SMXP_0_1, REGION1_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR1_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR1_U_SMXP_0_1, 0x13d028)
    FIELD(POR_MPU_M0_PRLAR1_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR1_U_SMXP_0_1, REGION1_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR1_U_SMXP_0_1, REGION1_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR2_U_SMXP_0_1, 0x13d030)
    FIELD(POR_MPU_M0_PRBAR2_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR2_U_SMXP_0_1, REGION2_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR2_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR2_U_SMXP_0_1, REGION2_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR2_U_SMXP_0_1, REGION2_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR2_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR2_U_SMXP_0_1, 0x13d038)
    FIELD(POR_MPU_M0_PRLAR2_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR2_U_SMXP_0_1, REGION2_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR2_U_SMXP_0_1, REGION2_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR3_U_SMXP_0_1, 0x13d040)
    FIELD(POR_MPU_M0_PRBAR3_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR3_U_SMXP_0_1, REGION3_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR3_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR3_U_SMXP_0_1, REGION3_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR3_U_SMXP_0_1, REGION3_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR3_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR3_U_SMXP_0_1, 0x13d048)
    FIELD(POR_MPU_M0_PRLAR3_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR3_U_SMXP_0_1, REGION3_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR3_U_SMXP_0_1, REGION3_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR4_U_SMXP_0_1, 0x13d050)
    FIELD(POR_MPU_M0_PRBAR4_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR4_U_SMXP_0_1, REGION4_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR4_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR4_U_SMXP_0_1, REGION4_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR4_U_SMXP_0_1, REGION4_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR4_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR4_U_SMXP_0_1, 0x13d058)
    FIELD(POR_MPU_M0_PRLAR4_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR4_U_SMXP_0_1, REGION4_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR4_U_SMXP_0_1, REGION4_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR5_U_SMXP_0_1, 0x13d060)
    FIELD(POR_MPU_M0_PRBAR5_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR5_U_SMXP_0_1, REGION5_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR5_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR5_U_SMXP_0_1, REGION5_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR5_U_SMXP_0_1, REGION5_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR5_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR5_U_SMXP_0_1, 0x13d068)
    FIELD(POR_MPU_M0_PRLAR5_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR5_U_SMXP_0_1, REGION5_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR5_U_SMXP_0_1, REGION5_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR6_U_SMXP_0_1, 0x13d070)
    FIELD(POR_MPU_M0_PRBAR6_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR6_U_SMXP_0_1, REGION6_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR6_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR6_U_SMXP_0_1, REGION6_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR6_U_SMXP_0_1, REGION6_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR6_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR6_U_SMXP_0_1, 0x13d078)
    FIELD(POR_MPU_M0_PRLAR6_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR6_U_SMXP_0_1, REGION6_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR6_U_SMXP_0_1, REGION6_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR7_U_SMXP_0_1, 0x13d080)
    FIELD(POR_MPU_M0_PRBAR7_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR7_U_SMXP_0_1, REGION7_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR7_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR7_U_SMXP_0_1, REGION7_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR7_U_SMXP_0_1, REGION7_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR7_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR7_U_SMXP_0_1, 0x13d088)
    FIELD(POR_MPU_M0_PRLAR7_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR7_U_SMXP_0_1, REGION7_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR7_U_SMXP_0_1, REGION7_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR8_U_SMXP_0_1, 0x13d090)
    FIELD(POR_MPU_M0_PRBAR8_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR8_U_SMXP_0_1, REGION8_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR8_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR8_U_SMXP_0_1, REGION8_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR8_U_SMXP_0_1, REGION8_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR8_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR8_U_SMXP_0_1, 0x13d098)
    FIELD(POR_MPU_M0_PRLAR8_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR8_U_SMXP_0_1, REGION8_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR8_U_SMXP_0_1, REGION8_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR9_U_SMXP_0_1, 0x13d0a0)
    FIELD(POR_MPU_M0_PRBAR9_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR9_U_SMXP_0_1, REGION9_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR9_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR9_U_SMXP_0_1, REGION9_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR9_U_SMXP_0_1, REGION9_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR9_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR9_U_SMXP_0_1, 0x13d0a8)
    FIELD(POR_MPU_M0_PRLAR9_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR9_U_SMXP_0_1, REGION9_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR9_U_SMXP_0_1, REGION9_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR10_U_SMXP_0_1, 0x13d0b0)
    FIELD(POR_MPU_M0_PRBAR10_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR10_U_SMXP_0_1, REGION10_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR10_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR10_U_SMXP_0_1, REGION10_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR10_U_SMXP_0_1, REGION10_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR10_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR10_U_SMXP_0_1, 0x13d0b8)
    FIELD(POR_MPU_M0_PRLAR10_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR10_U_SMXP_0_1, REGION10_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR10_U_SMXP_0_1, REGION10_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR11_U_SMXP_0_1, 0x13d0c0)
    FIELD(POR_MPU_M0_PRBAR11_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR11_U_SMXP_0_1, REGION11_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR11_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR11_U_SMXP_0_1, REGION11_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR11_U_SMXP_0_1, REGION11_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR11_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR11_U_SMXP_0_1, 0x13d0c8)
    FIELD(POR_MPU_M0_PRLAR11_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR11_U_SMXP_0_1, REGION11_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR11_U_SMXP_0_1, REGION11_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR12_U_SMXP_0_1, 0x13d0d0)
    FIELD(POR_MPU_M0_PRBAR12_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR12_U_SMXP_0_1, REGION12_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR12_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR12_U_SMXP_0_1, REGION12_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR12_U_SMXP_0_1, REGION12_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR12_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR12_U_SMXP_0_1, 0x13d0d8)
    FIELD(POR_MPU_M0_PRLAR12_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR12_U_SMXP_0_1, REGION12_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR12_U_SMXP_0_1, REGION12_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR13_U_SMXP_0_1, 0x13d0e0)
    FIELD(POR_MPU_M0_PRBAR13_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR13_U_SMXP_0_1, REGION13_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR13_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR13_U_SMXP_0_1, REGION13_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR13_U_SMXP_0_1, REGION13_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR13_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR13_U_SMXP_0_1, 0x13d0e8)
    FIELD(POR_MPU_M0_PRLAR13_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR13_U_SMXP_0_1, REGION13_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR13_U_SMXP_0_1, REGION13_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR14_U_SMXP_0_1, 0x13d0f0)
    FIELD(POR_MPU_M0_PRBAR14_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR14_U_SMXP_0_1, REGION14_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR14_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR14_U_SMXP_0_1, REGION14_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR14_U_SMXP_0_1, REGION14_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR14_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR14_U_SMXP_0_1, 0x13d0f8)
    FIELD(POR_MPU_M0_PRLAR14_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR14_U_SMXP_0_1, REGION14_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR14_U_SMXP_0_1, REGION14_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR15_U_SMXP_0_1, 0x13d100)
    FIELD(POR_MPU_M0_PRBAR15_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR15_U_SMXP_0_1, REGION15_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR15_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR15_U_SMXP_0_1, REGION15_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR15_U_SMXP_0_1, REGION15_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR15_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR15_U_SMXP_0_1, 0x13d108)
    FIELD(POR_MPU_M0_PRLAR15_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR15_U_SMXP_0_1, REGION15_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR15_U_SMXP_0_1, REGION15_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR16_U_SMXP_0_1, 0x13d110)
    FIELD(POR_MPU_M0_PRBAR16_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR16_U_SMXP_0_1, REGION16_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR16_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR16_U_SMXP_0_1, REGION16_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR16_U_SMXP_0_1, REGION16_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR16_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR16_U_SMXP_0_1, 0x13d118)
    FIELD(POR_MPU_M0_PRLAR16_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR16_U_SMXP_0_1, REGION16_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR16_U_SMXP_0_1, REGION16_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR17_U_SMXP_0_1, 0x13d120)
    FIELD(POR_MPU_M0_PRBAR17_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR17_U_SMXP_0_1, REGION17_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR17_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR17_U_SMXP_0_1, REGION17_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR17_U_SMXP_0_1, REGION17_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR17_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR17_U_SMXP_0_1, 0x13d128)
    FIELD(POR_MPU_M0_PRLAR17_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR17_U_SMXP_0_1, REGION17_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR17_U_SMXP_0_1, REGION17_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR18_U_SMXP_0_1, 0x13d130)
    FIELD(POR_MPU_M0_PRBAR18_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR18_U_SMXP_0_1, REGION18_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR18_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR18_U_SMXP_0_1, REGION18_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR18_U_SMXP_0_1, REGION18_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR18_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR18_U_SMXP_0_1, 0x13d138)
    FIELD(POR_MPU_M0_PRLAR18_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR18_U_SMXP_0_1, REGION18_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR18_U_SMXP_0_1, REGION18_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR19_U_SMXP_0_1, 0x13d140)
    FIELD(POR_MPU_M0_PRBAR19_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR19_U_SMXP_0_1, REGION19_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR19_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR19_U_SMXP_0_1, REGION19_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR19_U_SMXP_0_1, REGION19_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR19_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR19_U_SMXP_0_1, 0x13d148)
    FIELD(POR_MPU_M0_PRLAR19_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR19_U_SMXP_0_1, REGION19_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR19_U_SMXP_0_1, REGION19_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR20_U_SMXP_0_1, 0x13d150)
    FIELD(POR_MPU_M0_PRBAR20_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR20_U_SMXP_0_1, REGION20_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR20_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR20_U_SMXP_0_1, REGION20_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR20_U_SMXP_0_1, REGION20_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR20_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR20_U_SMXP_0_1, 0x13d158)
    FIELD(POR_MPU_M0_PRLAR20_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR20_U_SMXP_0_1, REGION20_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR20_U_SMXP_0_1, REGION20_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR21_U_SMXP_0_1, 0x13d160)
    FIELD(POR_MPU_M0_PRBAR21_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR21_U_SMXP_0_1, REGION21_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR21_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR21_U_SMXP_0_1, REGION21_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR21_U_SMXP_0_1, REGION21_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR21_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR21_U_SMXP_0_1, 0x13d168)
    FIELD(POR_MPU_M0_PRLAR21_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR21_U_SMXP_0_1, REGION21_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR21_U_SMXP_0_1, REGION21_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR22_U_SMXP_0_1, 0x13d170)
    FIELD(POR_MPU_M0_PRBAR22_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR22_U_SMXP_0_1, REGION22_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR22_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR22_U_SMXP_0_1, REGION22_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR22_U_SMXP_0_1, REGION22_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR22_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR22_U_SMXP_0_1, 0x13d178)
    FIELD(POR_MPU_M0_PRLAR22_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR22_U_SMXP_0_1, REGION22_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR22_U_SMXP_0_1, REGION22_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR23_U_SMXP_0_1, 0x13d180)
    FIELD(POR_MPU_M0_PRBAR23_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR23_U_SMXP_0_1, REGION23_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR23_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR23_U_SMXP_0_1, REGION23_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR23_U_SMXP_0_1, REGION23_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR23_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR23_U_SMXP_0_1, 0x13d188)
    FIELD(POR_MPU_M0_PRLAR23_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR23_U_SMXP_0_1, REGION23_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR23_U_SMXP_0_1, REGION23_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR24_U_SMXP_0_1, 0x13d190)
    FIELD(POR_MPU_M0_PRBAR24_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR24_U_SMXP_0_1, REGION24_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR24_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR24_U_SMXP_0_1, REGION24_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR24_U_SMXP_0_1, REGION24_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR24_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR24_U_SMXP_0_1, 0x13d198)
    FIELD(POR_MPU_M0_PRLAR24_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR24_U_SMXP_0_1, REGION24_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR24_U_SMXP_0_1, REGION24_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR25_U_SMXP_0_1, 0x13d1a0)
    FIELD(POR_MPU_M0_PRBAR25_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR25_U_SMXP_0_1, REGION25_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR25_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR25_U_SMXP_0_1, REGION25_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR25_U_SMXP_0_1, REGION25_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR25_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR25_U_SMXP_0_1, 0x13d1a8)
    FIELD(POR_MPU_M0_PRLAR25_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR25_U_SMXP_0_1, REGION25_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR25_U_SMXP_0_1, REGION25_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR26_U_SMXP_0_1, 0x13d1b0)
    FIELD(POR_MPU_M0_PRBAR26_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR26_U_SMXP_0_1, REGION26_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR26_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR26_U_SMXP_0_1, REGION26_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR26_U_SMXP_0_1, REGION26_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR26_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR26_U_SMXP_0_1, 0x13d1b8)
    FIELD(POR_MPU_M0_PRLAR26_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR26_U_SMXP_0_1, REGION26_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR26_U_SMXP_0_1, REGION26_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR27_U_SMXP_0_1, 0x13d1c0)
    FIELD(POR_MPU_M0_PRBAR27_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR27_U_SMXP_0_1, REGION27_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR27_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR27_U_SMXP_0_1, REGION27_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR27_U_SMXP_0_1, REGION27_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR27_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR27_U_SMXP_0_1, 0x13d1c8)
    FIELD(POR_MPU_M0_PRLAR27_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR27_U_SMXP_0_1, REGION27_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR27_U_SMXP_0_1, REGION27_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR28_U_SMXP_0_1, 0x13d1d0)
    FIELD(POR_MPU_M0_PRBAR28_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR28_U_SMXP_0_1, REGION28_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR28_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR28_U_SMXP_0_1, REGION28_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR28_U_SMXP_0_1, REGION28_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR28_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR28_U_SMXP_0_1, 0x13d1d8)
    FIELD(POR_MPU_M0_PRLAR28_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR28_U_SMXP_0_1, REGION28_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR28_U_SMXP_0_1, REGION28_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR29_U_SMXP_0_1, 0x13d1e0)
    FIELD(POR_MPU_M0_PRBAR29_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR29_U_SMXP_0_1, REGION29_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR29_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR29_U_SMXP_0_1, REGION29_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR29_U_SMXP_0_1, REGION29_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR29_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR29_U_SMXP_0_1, 0x13d1e8)
    FIELD(POR_MPU_M0_PRLAR29_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR29_U_SMXP_0_1, REGION29_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR29_U_SMXP_0_1, REGION29_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR30_U_SMXP_0_1, 0x13d1f0)
    FIELD(POR_MPU_M0_PRBAR30_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR30_U_SMXP_0_1, REGION30_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR30_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR30_U_SMXP_0_1, REGION30_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR30_U_SMXP_0_1, REGION30_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR30_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR30_U_SMXP_0_1, 0x13d1f8)
    FIELD(POR_MPU_M0_PRLAR30_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR30_U_SMXP_0_1, REGION30_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR30_U_SMXP_0_1, REGION30_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR31_U_SMXP_0_1, 0x13d200)
    FIELD(POR_MPU_M0_PRBAR31_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR31_U_SMXP_0_1, REGION31_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR31_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR31_U_SMXP_0_1, REGION31_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR31_U_SMXP_0_1, REGION31_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR31_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR31_U_SMXP_0_1, 0x13d208)
    FIELD(POR_MPU_M0_PRLAR31_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR31_U_SMXP_0_1, REGION31_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR31_U_SMXP_0_1, REGION31_EN, 0, 1)
REG32(POR_MPU_M1_CTL_U_SMXP_0_1, 0x13d400)
    FIELD(POR_MPU_M1_CTL_U_SMXP_0_1, M1_EN, 2, 1)
    FIELD(POR_MPU_M1_CTL_U_SMXP_0_1, M1_ACTION, 0, 2)
REG32(POR_MPU_M1_PRBAR0_U_SMXP_0_1, 0x13d410)
    FIELD(POR_MPU_M1_PRBAR0_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR0_U_SMXP_0_1, REGION0_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR0_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR0_U_SMXP_0_1, REGION0_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR0_U_SMXP_0_1, REGION0_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR0_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR0_U_SMXP_0_1, 0x13d418)
    FIELD(POR_MPU_M1_PRLAR0_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR0_U_SMXP_0_1, REGION0_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR0_U_SMXP_0_1, REGION0_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR1_U_SMXP_0_1, 0x13d420)
    FIELD(POR_MPU_M1_PRBAR1_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR1_U_SMXP_0_1, REGION1_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR1_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR1_U_SMXP_0_1, REGION1_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR1_U_SMXP_0_1, REGION1_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR1_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR1_U_SMXP_0_1, 0x13d428)
    FIELD(POR_MPU_M1_PRLAR1_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR1_U_SMXP_0_1, REGION1_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR1_U_SMXP_0_1, REGION1_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR2_U_SMXP_0_1, 0x13d430)
    FIELD(POR_MPU_M1_PRBAR2_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR2_U_SMXP_0_1, REGION2_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR2_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR2_U_SMXP_0_1, REGION2_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR2_U_SMXP_0_1, REGION2_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR2_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR2_U_SMXP_0_1, 0x13d438)
    FIELD(POR_MPU_M1_PRLAR2_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR2_U_SMXP_0_1, REGION2_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR2_U_SMXP_0_1, REGION2_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR3_U_SMXP_0_1, 0x13d440)
    FIELD(POR_MPU_M1_PRBAR3_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR3_U_SMXP_0_1, REGION3_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR3_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR3_U_SMXP_0_1, REGION3_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR3_U_SMXP_0_1, REGION3_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR3_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR3_U_SMXP_0_1, 0x13d448)
    FIELD(POR_MPU_M1_PRLAR3_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR3_U_SMXP_0_1, REGION3_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR3_U_SMXP_0_1, REGION3_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR4_U_SMXP_0_1, 0x13d450)
    FIELD(POR_MPU_M1_PRBAR4_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR4_U_SMXP_0_1, REGION4_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR4_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR4_U_SMXP_0_1, REGION4_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR4_U_SMXP_0_1, REGION4_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR4_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR4_U_SMXP_0_1, 0x13d458)
    FIELD(POR_MPU_M1_PRLAR4_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR4_U_SMXP_0_1, REGION4_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR4_U_SMXP_0_1, REGION4_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR5_U_SMXP_0_1, 0x13d460)
    FIELD(POR_MPU_M1_PRBAR5_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR5_U_SMXP_0_1, REGION5_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR5_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR5_U_SMXP_0_1, REGION5_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR5_U_SMXP_0_1, REGION5_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR5_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR5_U_SMXP_0_1, 0x13d468)
    FIELD(POR_MPU_M1_PRLAR5_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR5_U_SMXP_0_1, REGION5_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR5_U_SMXP_0_1, REGION5_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR6_U_SMXP_0_1, 0x13d470)
    FIELD(POR_MPU_M1_PRBAR6_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR6_U_SMXP_0_1, REGION6_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR6_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR6_U_SMXP_0_1, REGION6_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR6_U_SMXP_0_1, REGION6_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR6_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR6_U_SMXP_0_1, 0x13d478)
    FIELD(POR_MPU_M1_PRLAR6_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR6_U_SMXP_0_1, REGION6_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR6_U_SMXP_0_1, REGION6_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR7_U_SMXP_0_1, 0x13d480)
    FIELD(POR_MPU_M1_PRBAR7_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR7_U_SMXP_0_1, REGION7_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR7_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR7_U_SMXP_0_1, REGION7_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR7_U_SMXP_0_1, REGION7_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR7_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR7_U_SMXP_0_1, 0x13d488)
    FIELD(POR_MPU_M1_PRLAR7_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR7_U_SMXP_0_1, REGION7_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR7_U_SMXP_0_1, REGION7_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR8_U_SMXP_0_1, 0x13d490)
    FIELD(POR_MPU_M1_PRBAR8_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR8_U_SMXP_0_1, REGION8_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR8_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR8_U_SMXP_0_1, REGION8_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR8_U_SMXP_0_1, REGION8_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR8_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR8_U_SMXP_0_1, 0x13d498)
    FIELD(POR_MPU_M1_PRLAR8_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR8_U_SMXP_0_1, REGION8_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR8_U_SMXP_0_1, REGION8_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR9_U_SMXP_0_1, 0x13d4a0)
    FIELD(POR_MPU_M1_PRBAR9_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR9_U_SMXP_0_1, REGION9_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR9_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR9_U_SMXP_0_1, REGION9_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR9_U_SMXP_0_1, REGION9_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR9_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR9_U_SMXP_0_1, 0x13d4a8)
    FIELD(POR_MPU_M1_PRLAR9_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR9_U_SMXP_0_1, REGION9_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR9_U_SMXP_0_1, REGION9_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR10_U_SMXP_0_1, 0x13d4b0)
    FIELD(POR_MPU_M1_PRBAR10_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR10_U_SMXP_0_1, REGION10_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR10_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR10_U_SMXP_0_1, REGION10_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR10_U_SMXP_0_1, REGION10_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR10_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR10_U_SMXP_0_1, 0x13d4b8)
    FIELD(POR_MPU_M1_PRLAR10_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR10_U_SMXP_0_1, REGION10_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR10_U_SMXP_0_1, REGION10_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR11_U_SMXP_0_1, 0x13d4c0)
    FIELD(POR_MPU_M1_PRBAR11_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR11_U_SMXP_0_1, REGION11_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR11_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR11_U_SMXP_0_1, REGION11_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR11_U_SMXP_0_1, REGION11_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR11_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR11_U_SMXP_0_1, 0x13d4c8)
    FIELD(POR_MPU_M1_PRLAR11_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR11_U_SMXP_0_1, REGION11_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR11_U_SMXP_0_1, REGION11_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR12_U_SMXP_0_1, 0x13d4d0)
    FIELD(POR_MPU_M1_PRBAR12_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR12_U_SMXP_0_1, REGION12_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR12_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR12_U_SMXP_0_1, REGION12_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR12_U_SMXP_0_1, REGION12_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR12_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR12_U_SMXP_0_1, 0x13d4d8)
    FIELD(POR_MPU_M1_PRLAR12_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR12_U_SMXP_0_1, REGION12_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR12_U_SMXP_0_1, REGION12_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR13_U_SMXP_0_1, 0x13d4e0)
    FIELD(POR_MPU_M1_PRBAR13_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR13_U_SMXP_0_1, REGION13_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR13_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR13_U_SMXP_0_1, REGION13_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR13_U_SMXP_0_1, REGION13_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR13_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR13_U_SMXP_0_1, 0x13d4e8)
    FIELD(POR_MPU_M1_PRLAR13_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR13_U_SMXP_0_1, REGION13_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR13_U_SMXP_0_1, REGION13_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR14_U_SMXP_0_1, 0x13d4f0)
    FIELD(POR_MPU_M1_PRBAR14_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR14_U_SMXP_0_1, REGION14_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR14_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR14_U_SMXP_0_1, REGION14_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR14_U_SMXP_0_1, REGION14_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR14_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR14_U_SMXP_0_1, 0x13d4f8)
    FIELD(POR_MPU_M1_PRLAR14_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR14_U_SMXP_0_1, REGION14_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR14_U_SMXP_0_1, REGION14_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR15_U_SMXP_0_1, 0x13d500)
    FIELD(POR_MPU_M1_PRBAR15_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR15_U_SMXP_0_1, REGION15_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR15_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR15_U_SMXP_0_1, REGION15_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR15_U_SMXP_0_1, REGION15_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR15_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR15_U_SMXP_0_1, 0x13d508)
    FIELD(POR_MPU_M1_PRLAR15_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR15_U_SMXP_0_1, REGION15_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR15_U_SMXP_0_1, REGION15_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR16_U_SMXP_0_1, 0x13d510)
    FIELD(POR_MPU_M1_PRBAR16_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR16_U_SMXP_0_1, REGION16_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR16_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR16_U_SMXP_0_1, REGION16_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR16_U_SMXP_0_1, REGION16_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR16_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR16_U_SMXP_0_1, 0x13d518)
    FIELD(POR_MPU_M1_PRLAR16_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR16_U_SMXP_0_1, REGION16_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR16_U_SMXP_0_1, REGION16_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR17_U_SMXP_0_1, 0x13d520)
    FIELD(POR_MPU_M1_PRBAR17_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR17_U_SMXP_0_1, REGION17_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR17_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR17_U_SMXP_0_1, REGION17_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR17_U_SMXP_0_1, REGION17_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR17_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR17_U_SMXP_0_1, 0x13d528)
    FIELD(POR_MPU_M1_PRLAR17_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR17_U_SMXP_0_1, REGION17_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR17_U_SMXP_0_1, REGION17_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR18_U_SMXP_0_1, 0x13d530)
    FIELD(POR_MPU_M1_PRBAR18_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR18_U_SMXP_0_1, REGION18_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR18_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR18_U_SMXP_0_1, REGION18_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR18_U_SMXP_0_1, REGION18_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR18_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR18_U_SMXP_0_1, 0x13d538)
    FIELD(POR_MPU_M1_PRLAR18_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR18_U_SMXP_0_1, REGION18_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR18_U_SMXP_0_1, REGION18_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR19_U_SMXP_0_1, 0x13d540)
    FIELD(POR_MPU_M1_PRBAR19_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR19_U_SMXP_0_1, REGION19_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR19_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR19_U_SMXP_0_1, REGION19_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR19_U_SMXP_0_1, REGION19_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR19_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR19_U_SMXP_0_1, 0x13d548)
    FIELD(POR_MPU_M1_PRLAR19_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR19_U_SMXP_0_1, REGION19_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR19_U_SMXP_0_1, REGION19_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR20_U_SMXP_0_1, 0x13d550)
    FIELD(POR_MPU_M1_PRBAR20_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR20_U_SMXP_0_1, REGION20_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR20_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR20_U_SMXP_0_1, REGION20_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR20_U_SMXP_0_1, REGION20_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR20_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR20_U_SMXP_0_1, 0x13d558)
    FIELD(POR_MPU_M1_PRLAR20_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR20_U_SMXP_0_1, REGION20_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR20_U_SMXP_0_1, REGION20_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR21_U_SMXP_0_1, 0x13d560)
    FIELD(POR_MPU_M1_PRBAR21_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR21_U_SMXP_0_1, REGION21_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR21_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR21_U_SMXP_0_1, REGION21_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR21_U_SMXP_0_1, REGION21_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR21_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR21_U_SMXP_0_1, 0x13d568)
    FIELD(POR_MPU_M1_PRLAR21_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR21_U_SMXP_0_1, REGION21_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR21_U_SMXP_0_1, REGION21_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR22_U_SMXP_0_1, 0x13d570)
    FIELD(POR_MPU_M1_PRBAR22_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR22_U_SMXP_0_1, REGION22_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR22_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR22_U_SMXP_0_1, REGION22_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR22_U_SMXP_0_1, REGION22_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR22_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR22_U_SMXP_0_1, 0x13d578)
    FIELD(POR_MPU_M1_PRLAR22_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR22_U_SMXP_0_1, REGION22_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR22_U_SMXP_0_1, REGION22_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR23_U_SMXP_0_1, 0x13d580)
    FIELD(POR_MPU_M1_PRBAR23_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR23_U_SMXP_0_1, REGION23_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR23_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR23_U_SMXP_0_1, REGION23_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR23_U_SMXP_0_1, REGION23_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR23_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR23_U_SMXP_0_1, 0x13d588)
    FIELD(POR_MPU_M1_PRLAR23_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR23_U_SMXP_0_1, REGION23_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR23_U_SMXP_0_1, REGION23_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR24_U_SMXP_0_1, 0x13d590)
    FIELD(POR_MPU_M1_PRBAR24_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR24_U_SMXP_0_1, REGION24_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR24_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR24_U_SMXP_0_1, REGION24_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR24_U_SMXP_0_1, REGION24_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR24_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR24_U_SMXP_0_1, 0x13d598)
    FIELD(POR_MPU_M1_PRLAR24_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR24_U_SMXP_0_1, REGION24_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR24_U_SMXP_0_1, REGION24_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR25_U_SMXP_0_1, 0x13d5a0)
    FIELD(POR_MPU_M1_PRBAR25_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR25_U_SMXP_0_1, REGION25_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR25_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR25_U_SMXP_0_1, REGION25_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR25_U_SMXP_0_1, REGION25_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR25_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR25_U_SMXP_0_1, 0x13d5a8)
    FIELD(POR_MPU_M1_PRLAR25_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR25_U_SMXP_0_1, REGION25_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR25_U_SMXP_0_1, REGION25_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR26_U_SMXP_0_1, 0x13d5b0)
    FIELD(POR_MPU_M1_PRBAR26_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR26_U_SMXP_0_1, REGION26_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR26_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR26_U_SMXP_0_1, REGION26_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR26_U_SMXP_0_1, REGION26_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR26_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR26_U_SMXP_0_1, 0x13d5b8)
    FIELD(POR_MPU_M1_PRLAR26_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR26_U_SMXP_0_1, REGION26_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR26_U_SMXP_0_1, REGION26_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR27_U_SMXP_0_1, 0x13d5c0)
    FIELD(POR_MPU_M1_PRBAR27_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR27_U_SMXP_0_1, REGION27_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR27_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR27_U_SMXP_0_1, REGION27_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR27_U_SMXP_0_1, REGION27_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR27_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR27_U_SMXP_0_1, 0x13d5c8)
    FIELD(POR_MPU_M1_PRLAR27_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR27_U_SMXP_0_1, REGION27_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR27_U_SMXP_0_1, REGION27_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR28_U_SMXP_0_1, 0x13d5d0)
    FIELD(POR_MPU_M1_PRBAR28_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR28_U_SMXP_0_1, REGION28_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR28_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR28_U_SMXP_0_1, REGION28_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR28_U_SMXP_0_1, REGION28_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR28_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR28_U_SMXP_0_1, 0x13d5d8)
    FIELD(POR_MPU_M1_PRLAR28_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR28_U_SMXP_0_1, REGION28_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR28_U_SMXP_0_1, REGION28_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR29_U_SMXP_0_1, 0x13d5e0)
    FIELD(POR_MPU_M1_PRBAR29_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR29_U_SMXP_0_1, REGION29_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR29_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR29_U_SMXP_0_1, REGION29_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR29_U_SMXP_0_1, REGION29_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR29_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR29_U_SMXP_0_1, 0x13d5e8)
    FIELD(POR_MPU_M1_PRLAR29_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR29_U_SMXP_0_1, REGION29_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR29_U_SMXP_0_1, REGION29_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR30_U_SMXP_0_1, 0x13d5f0)
    FIELD(POR_MPU_M1_PRBAR30_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR30_U_SMXP_0_1, REGION30_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR30_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR30_U_SMXP_0_1, REGION30_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR30_U_SMXP_0_1, REGION30_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR30_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR30_U_SMXP_0_1, 0x13d5f8)
    FIELD(POR_MPU_M1_PRLAR30_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR30_U_SMXP_0_1, REGION30_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR30_U_SMXP_0_1, REGION30_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR31_U_SMXP_0_1, 0x13d600)
    FIELD(POR_MPU_M1_PRBAR31_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR31_U_SMXP_0_1, REGION31_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR31_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR31_U_SMXP_0_1, REGION31_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR31_U_SMXP_0_1, REGION31_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR31_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR31_U_SMXP_0_1, 0x13d608)
    FIELD(POR_MPU_M1_PRLAR31_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR31_U_SMXP_0_1, REGION31_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR31_U_SMXP_0_1, REGION31_EN, 0, 1)
REG32(POR_MPU_M2_CTL_U_SMXP_0_1, 0x13d800)
    FIELD(POR_MPU_M2_CTL_U_SMXP_0_1, M2_EN, 2, 1)
    FIELD(POR_MPU_M2_CTL_U_SMXP_0_1, M2_ACTION, 0, 2)
REG32(POR_MPU_M2_PRBAR0_U_SMXP_0_1, 0x13d810)
    FIELD(POR_MPU_M2_PRBAR0_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR0_U_SMXP_0_1, REGION0_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR0_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR0_U_SMXP_0_1, REGION0_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR0_U_SMXP_0_1, REGION0_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR0_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR0_U_SMXP_0_1, 0x13d818)
    FIELD(POR_MPU_M2_PRLAR0_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR0_U_SMXP_0_1, REGION0_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR0_U_SMXP_0_1, REGION0_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR1_U_SMXP_0_1, 0x13d820)
    FIELD(POR_MPU_M2_PRBAR1_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR1_U_SMXP_0_1, REGION1_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR1_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR1_U_SMXP_0_1, REGION1_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR1_U_SMXP_0_1, REGION1_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR1_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR1_U_SMXP_0_1, 0x13d828)
    FIELD(POR_MPU_M2_PRLAR1_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR1_U_SMXP_0_1, REGION1_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR1_U_SMXP_0_1, REGION1_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR2_U_SMXP_0_1, 0x13d830)
    FIELD(POR_MPU_M2_PRBAR2_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR2_U_SMXP_0_1, REGION2_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR2_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR2_U_SMXP_0_1, REGION2_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR2_U_SMXP_0_1, REGION2_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR2_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR2_U_SMXP_0_1, 0x13d838)
    FIELD(POR_MPU_M2_PRLAR2_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR2_U_SMXP_0_1, REGION2_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR2_U_SMXP_0_1, REGION2_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR3_U_SMXP_0_1, 0x13d840)
    FIELD(POR_MPU_M2_PRBAR3_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR3_U_SMXP_0_1, REGION3_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR3_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR3_U_SMXP_0_1, REGION3_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR3_U_SMXP_0_1, REGION3_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR3_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR3_U_SMXP_0_1, 0x13d848)
    FIELD(POR_MPU_M2_PRLAR3_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR3_U_SMXP_0_1, REGION3_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR3_U_SMXP_0_1, REGION3_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR4_U_SMXP_0_1, 0x13d850)
    FIELD(POR_MPU_M2_PRBAR4_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR4_U_SMXP_0_1, REGION4_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR4_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR4_U_SMXP_0_1, REGION4_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR4_U_SMXP_0_1, REGION4_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR4_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR4_U_SMXP_0_1, 0x13d858)
    FIELD(POR_MPU_M2_PRLAR4_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR4_U_SMXP_0_1, REGION4_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR4_U_SMXP_0_1, REGION4_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR5_U_SMXP_0_1, 0x13d860)
    FIELD(POR_MPU_M2_PRBAR5_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR5_U_SMXP_0_1, REGION5_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR5_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR5_U_SMXP_0_1, REGION5_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR5_U_SMXP_0_1, REGION5_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR5_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR5_U_SMXP_0_1, 0x13d868)
    FIELD(POR_MPU_M2_PRLAR5_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR5_U_SMXP_0_1, REGION5_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR5_U_SMXP_0_1, REGION5_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR6_U_SMXP_0_1, 0x13d870)
    FIELD(POR_MPU_M2_PRBAR6_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR6_U_SMXP_0_1, REGION6_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR6_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR6_U_SMXP_0_1, REGION6_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR6_U_SMXP_0_1, REGION6_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR6_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR6_U_SMXP_0_1, 0x13d878)
    FIELD(POR_MPU_M2_PRLAR6_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR6_U_SMXP_0_1, REGION6_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR6_U_SMXP_0_1, REGION6_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR7_U_SMXP_0_1, 0x13d880)
    FIELD(POR_MPU_M2_PRBAR7_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR7_U_SMXP_0_1, REGION7_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR7_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR7_U_SMXP_0_1, REGION7_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR7_U_SMXP_0_1, REGION7_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR7_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR7_U_SMXP_0_1, 0x13d888)
    FIELD(POR_MPU_M2_PRLAR7_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR7_U_SMXP_0_1, REGION7_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR7_U_SMXP_0_1, REGION7_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR8_U_SMXP_0_1, 0x13d890)
    FIELD(POR_MPU_M2_PRBAR8_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR8_U_SMXP_0_1, REGION8_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR8_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR8_U_SMXP_0_1, REGION8_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR8_U_SMXP_0_1, REGION8_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR8_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR8_U_SMXP_0_1, 0x13d898)
    FIELD(POR_MPU_M2_PRLAR8_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR8_U_SMXP_0_1, REGION8_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR8_U_SMXP_0_1, REGION8_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR9_U_SMXP_0_1, 0x13d8a0)
    FIELD(POR_MPU_M2_PRBAR9_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR9_U_SMXP_0_1, REGION9_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR9_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR9_U_SMXP_0_1, REGION9_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR9_U_SMXP_0_1, REGION9_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR9_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR9_U_SMXP_0_1, 0x13d8a8)
    FIELD(POR_MPU_M2_PRLAR9_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR9_U_SMXP_0_1, REGION9_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR9_U_SMXP_0_1, REGION9_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR10_U_SMXP_0_1, 0x13d8b0)
    FIELD(POR_MPU_M2_PRBAR10_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR10_U_SMXP_0_1, REGION10_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR10_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR10_U_SMXP_0_1, REGION10_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR10_U_SMXP_0_1, REGION10_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR10_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR10_U_SMXP_0_1, 0x13d8b8)
    FIELD(POR_MPU_M2_PRLAR10_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR10_U_SMXP_0_1, REGION10_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR10_U_SMXP_0_1, REGION10_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR11_U_SMXP_0_1, 0x13d8c0)
    FIELD(POR_MPU_M2_PRBAR11_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR11_U_SMXP_0_1, REGION11_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR11_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR11_U_SMXP_0_1, REGION11_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR11_U_SMXP_0_1, REGION11_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR11_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR11_U_SMXP_0_1, 0x13d8c8)
    FIELD(POR_MPU_M2_PRLAR11_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR11_U_SMXP_0_1, REGION11_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR11_U_SMXP_0_1, REGION11_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR12_U_SMXP_0_1, 0x13d8d0)
    FIELD(POR_MPU_M2_PRBAR12_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR12_U_SMXP_0_1, REGION12_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR12_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR12_U_SMXP_0_1, REGION12_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR12_U_SMXP_0_1, REGION12_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR12_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR12_U_SMXP_0_1, 0x13d8d8)
    FIELD(POR_MPU_M2_PRLAR12_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR12_U_SMXP_0_1, REGION12_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR12_U_SMXP_0_1, REGION12_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR13_U_SMXP_0_1, 0x13d8e0)
    FIELD(POR_MPU_M2_PRBAR13_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR13_U_SMXP_0_1, REGION13_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR13_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR13_U_SMXP_0_1, REGION13_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR13_U_SMXP_0_1, REGION13_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR13_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR13_U_SMXP_0_1, 0x13d8e8)
    FIELD(POR_MPU_M2_PRLAR13_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR13_U_SMXP_0_1, REGION13_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR13_U_SMXP_0_1, REGION13_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR14_U_SMXP_0_1, 0x13d8f0)
    FIELD(POR_MPU_M2_PRBAR14_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR14_U_SMXP_0_1, REGION14_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR14_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR14_U_SMXP_0_1, REGION14_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR14_U_SMXP_0_1, REGION14_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR14_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR14_U_SMXP_0_1, 0x13d8f8)
    FIELD(POR_MPU_M2_PRLAR14_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR14_U_SMXP_0_1, REGION14_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR14_U_SMXP_0_1, REGION14_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR15_U_SMXP_0_1, 0x13d900)
    FIELD(POR_MPU_M2_PRBAR15_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR15_U_SMXP_0_1, REGION15_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR15_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR15_U_SMXP_0_1, REGION15_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR15_U_SMXP_0_1, REGION15_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR15_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR15_U_SMXP_0_1, 0x13d908)
    FIELD(POR_MPU_M2_PRLAR15_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR15_U_SMXP_0_1, REGION15_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR15_U_SMXP_0_1, REGION15_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR16_U_SMXP_0_1, 0x13d910)
    FIELD(POR_MPU_M2_PRBAR16_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR16_U_SMXP_0_1, REGION16_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR16_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR16_U_SMXP_0_1, REGION16_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR16_U_SMXP_0_1, REGION16_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR16_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR16_U_SMXP_0_1, 0x13d918)
    FIELD(POR_MPU_M2_PRLAR16_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR16_U_SMXP_0_1, REGION16_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR16_U_SMXP_0_1, REGION16_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR17_U_SMXP_0_1, 0x13d920)
    FIELD(POR_MPU_M2_PRBAR17_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR17_U_SMXP_0_1, REGION17_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR17_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR17_U_SMXP_0_1, REGION17_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR17_U_SMXP_0_1, REGION17_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR17_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR17_U_SMXP_0_1, 0x13d928)
    FIELD(POR_MPU_M2_PRLAR17_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR17_U_SMXP_0_1, REGION17_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR17_U_SMXP_0_1, REGION17_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR18_U_SMXP_0_1, 0x13d930)
    FIELD(POR_MPU_M2_PRBAR18_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR18_U_SMXP_0_1, REGION18_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR18_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR18_U_SMXP_0_1, REGION18_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR18_U_SMXP_0_1, REGION18_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR18_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR18_U_SMXP_0_1, 0x13d938)
    FIELD(POR_MPU_M2_PRLAR18_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR18_U_SMXP_0_1, REGION18_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR18_U_SMXP_0_1, REGION18_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR19_U_SMXP_0_1, 0x13d940)
    FIELD(POR_MPU_M2_PRBAR19_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR19_U_SMXP_0_1, REGION19_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR19_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR19_U_SMXP_0_1, REGION19_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR19_U_SMXP_0_1, REGION19_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR19_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR19_U_SMXP_0_1, 0x13d948)
    FIELD(POR_MPU_M2_PRLAR19_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR19_U_SMXP_0_1, REGION19_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR19_U_SMXP_0_1, REGION19_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR20_U_SMXP_0_1, 0x13d950)
    FIELD(POR_MPU_M2_PRBAR20_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR20_U_SMXP_0_1, REGION20_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR20_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR20_U_SMXP_0_1, REGION20_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR20_U_SMXP_0_1, REGION20_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR20_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR20_U_SMXP_0_1, 0x13d958)
    FIELD(POR_MPU_M2_PRLAR20_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR20_U_SMXP_0_1, REGION20_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR20_U_SMXP_0_1, REGION20_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR21_U_SMXP_0_1, 0x13d960)
    FIELD(POR_MPU_M2_PRBAR21_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR21_U_SMXP_0_1, REGION21_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR21_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR21_U_SMXP_0_1, REGION21_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR21_U_SMXP_0_1, REGION21_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR21_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR21_U_SMXP_0_1, 0x13d968)
    FIELD(POR_MPU_M2_PRLAR21_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR21_U_SMXP_0_1, REGION21_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR21_U_SMXP_0_1, REGION21_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR22_U_SMXP_0_1, 0x13d970)
    FIELD(POR_MPU_M2_PRBAR22_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR22_U_SMXP_0_1, REGION22_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR22_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR22_U_SMXP_0_1, REGION22_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR22_U_SMXP_0_1, REGION22_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR22_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR22_U_SMXP_0_1, 0x13d978)
    FIELD(POR_MPU_M2_PRLAR22_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR22_U_SMXP_0_1, REGION22_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR22_U_SMXP_0_1, REGION22_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR23_U_SMXP_0_1, 0x13d980)
    FIELD(POR_MPU_M2_PRBAR23_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR23_U_SMXP_0_1, REGION23_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR23_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR23_U_SMXP_0_1, REGION23_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR23_U_SMXP_0_1, REGION23_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR23_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR23_U_SMXP_0_1, 0x13d988)
    FIELD(POR_MPU_M2_PRLAR23_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR23_U_SMXP_0_1, REGION23_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR23_U_SMXP_0_1, REGION23_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR24_U_SMXP_0_1, 0x13d990)
    FIELD(POR_MPU_M2_PRBAR24_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR24_U_SMXP_0_1, REGION24_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR24_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR24_U_SMXP_0_1, REGION24_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR24_U_SMXP_0_1, REGION24_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR24_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR24_U_SMXP_0_1, 0x13d998)
    FIELD(POR_MPU_M2_PRLAR24_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR24_U_SMXP_0_1, REGION24_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR24_U_SMXP_0_1, REGION24_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR25_U_SMXP_0_1, 0x13d9a0)
    FIELD(POR_MPU_M2_PRBAR25_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR25_U_SMXP_0_1, REGION25_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR25_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR25_U_SMXP_0_1, REGION25_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR25_U_SMXP_0_1, REGION25_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR25_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR25_U_SMXP_0_1, 0x13d9a8)
    FIELD(POR_MPU_M2_PRLAR25_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR25_U_SMXP_0_1, REGION25_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR25_U_SMXP_0_1, REGION25_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR26_U_SMXP_0_1, 0x13d9b0)
    FIELD(POR_MPU_M2_PRBAR26_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR26_U_SMXP_0_1, REGION26_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR26_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR26_U_SMXP_0_1, REGION26_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR26_U_SMXP_0_1, REGION26_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR26_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR26_U_SMXP_0_1, 0x13d9b8)
    FIELD(POR_MPU_M2_PRLAR26_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR26_U_SMXP_0_1, REGION26_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR26_U_SMXP_0_1, REGION26_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR27_U_SMXP_0_1, 0x13d9c0)
    FIELD(POR_MPU_M2_PRBAR27_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR27_U_SMXP_0_1, REGION27_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR27_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR27_U_SMXP_0_1, REGION27_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR27_U_SMXP_0_1, REGION27_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR27_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR27_U_SMXP_0_1, 0x13d9c8)
    FIELD(POR_MPU_M2_PRLAR27_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR27_U_SMXP_0_1, REGION27_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR27_U_SMXP_0_1, REGION27_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR28_U_SMXP_0_1, 0x13d9d0)
    FIELD(POR_MPU_M2_PRBAR28_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR28_U_SMXP_0_1, REGION28_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR28_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR28_U_SMXP_0_1, REGION28_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR28_U_SMXP_0_1, REGION28_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR28_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR28_U_SMXP_0_1, 0x13d9d8)
    FIELD(POR_MPU_M2_PRLAR28_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR28_U_SMXP_0_1, REGION28_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR28_U_SMXP_0_1, REGION28_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR29_U_SMXP_0_1, 0x13d9e0)
    FIELD(POR_MPU_M2_PRBAR29_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR29_U_SMXP_0_1, REGION29_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR29_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR29_U_SMXP_0_1, REGION29_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR29_U_SMXP_0_1, REGION29_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR29_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR29_U_SMXP_0_1, 0x13d9e8)
    FIELD(POR_MPU_M2_PRLAR29_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR29_U_SMXP_0_1, REGION29_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR29_U_SMXP_0_1, REGION29_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR30_U_SMXP_0_1, 0x13d9f0)
    FIELD(POR_MPU_M2_PRBAR30_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR30_U_SMXP_0_1, REGION30_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR30_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR30_U_SMXP_0_1, REGION30_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR30_U_SMXP_0_1, REGION30_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR30_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR30_U_SMXP_0_1, 0x13d9f8)
    FIELD(POR_MPU_M2_PRLAR30_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR30_U_SMXP_0_1, REGION30_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR30_U_SMXP_0_1, REGION30_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR31_U_SMXP_0_1, 0x13da00)
    FIELD(POR_MPU_M2_PRBAR31_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR31_U_SMXP_0_1, REGION31_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR31_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR31_U_SMXP_0_1, REGION31_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR31_U_SMXP_0_1, REGION31_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR31_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR31_U_SMXP_0_1, 0x13da08)
    FIELD(POR_MPU_M2_PRLAR31_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR31_U_SMXP_0_1, REGION31_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR31_U_SMXP_0_1, REGION31_EN, 0, 1)
REG32(POR_MPU_M3_CTL_U_SMXP_0_1, 0x13dc00)
    FIELD(POR_MPU_M3_CTL_U_SMXP_0_1, M3_EN, 2, 1)
    FIELD(POR_MPU_M3_CTL_U_SMXP_0_1, M3_ACTION, 0, 2)
REG32(POR_MPU_M3_PRBAR0_U_SMXP_0_1, 0x13dc10)
    FIELD(POR_MPU_M3_PRBAR0_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR0_U_SMXP_0_1, REGION0_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR0_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR0_U_SMXP_0_1, REGION0_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR0_U_SMXP_0_1, REGION0_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR0_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR0_U_SMXP_0_1, 0x13dc18)
    FIELD(POR_MPU_M3_PRLAR0_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR0_U_SMXP_0_1, REGION0_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR0_U_SMXP_0_1, REGION0_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR1_U_SMXP_0_1, 0x13dc20)
    FIELD(POR_MPU_M3_PRBAR1_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR1_U_SMXP_0_1, REGION1_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR1_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR1_U_SMXP_0_1, REGION1_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR1_U_SMXP_0_1, REGION1_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR1_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR1_U_SMXP_0_1, 0x13dc28)
    FIELD(POR_MPU_M3_PRLAR1_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR1_U_SMXP_0_1, REGION1_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR1_U_SMXP_0_1, REGION1_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR2_U_SMXP_0_1, 0x13dc30)
    FIELD(POR_MPU_M3_PRBAR2_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR2_U_SMXP_0_1, REGION2_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR2_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR2_U_SMXP_0_1, REGION2_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR2_U_SMXP_0_1, REGION2_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR2_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR2_U_SMXP_0_1, 0x13dc38)
    FIELD(POR_MPU_M3_PRLAR2_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR2_U_SMXP_0_1, REGION2_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR2_U_SMXP_0_1, REGION2_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR3_U_SMXP_0_1, 0x13dc40)
    FIELD(POR_MPU_M3_PRBAR3_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR3_U_SMXP_0_1, REGION3_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR3_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR3_U_SMXP_0_1, REGION3_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR3_U_SMXP_0_1, REGION3_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR3_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR3_U_SMXP_0_1, 0x13dc48)
    FIELD(POR_MPU_M3_PRLAR3_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR3_U_SMXP_0_1, REGION3_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR3_U_SMXP_0_1, REGION3_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR4_U_SMXP_0_1, 0x13dc50)
    FIELD(POR_MPU_M3_PRBAR4_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR4_U_SMXP_0_1, REGION4_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR4_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR4_U_SMXP_0_1, REGION4_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR4_U_SMXP_0_1, REGION4_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR4_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR4_U_SMXP_0_1, 0x13dc58)
    FIELD(POR_MPU_M3_PRLAR4_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR4_U_SMXP_0_1, REGION4_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR4_U_SMXP_0_1, REGION4_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR5_U_SMXP_0_1, 0x13dc60)
    FIELD(POR_MPU_M3_PRBAR5_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR5_U_SMXP_0_1, REGION5_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR5_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR5_U_SMXP_0_1, REGION5_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR5_U_SMXP_0_1, REGION5_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR5_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR5_U_SMXP_0_1, 0x13dc68)
    FIELD(POR_MPU_M3_PRLAR5_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR5_U_SMXP_0_1, REGION5_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR5_U_SMXP_0_1, REGION5_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR6_U_SMXP_0_1, 0x13dc70)
    FIELD(POR_MPU_M3_PRBAR6_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR6_U_SMXP_0_1, REGION6_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR6_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR6_U_SMXP_0_1, REGION6_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR6_U_SMXP_0_1, REGION6_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR6_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR6_U_SMXP_0_1, 0x13dc78)
    FIELD(POR_MPU_M3_PRLAR6_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR6_U_SMXP_0_1, REGION6_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR6_U_SMXP_0_1, REGION6_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR7_U_SMXP_0_1, 0x13dc80)
    FIELD(POR_MPU_M3_PRBAR7_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR7_U_SMXP_0_1, REGION7_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR7_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR7_U_SMXP_0_1, REGION7_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR7_U_SMXP_0_1, REGION7_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR7_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR7_U_SMXP_0_1, 0x13dc88)
    FIELD(POR_MPU_M3_PRLAR7_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR7_U_SMXP_0_1, REGION7_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR7_U_SMXP_0_1, REGION7_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR8_U_SMXP_0_1, 0x13dc90)
    FIELD(POR_MPU_M3_PRBAR8_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR8_U_SMXP_0_1, REGION8_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR8_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR8_U_SMXP_0_1, REGION8_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR8_U_SMXP_0_1, REGION8_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR8_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR8_U_SMXP_0_1, 0x13dc98)
    FIELD(POR_MPU_M3_PRLAR8_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR8_U_SMXP_0_1, REGION8_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR8_U_SMXP_0_1, REGION8_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR9_U_SMXP_0_1, 0x13dca0)
    FIELD(POR_MPU_M3_PRBAR9_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR9_U_SMXP_0_1, REGION9_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR9_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR9_U_SMXP_0_1, REGION9_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR9_U_SMXP_0_1, REGION9_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR9_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR9_U_SMXP_0_1, 0x13dca8)
    FIELD(POR_MPU_M3_PRLAR9_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR9_U_SMXP_0_1, REGION9_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR9_U_SMXP_0_1, REGION9_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR10_U_SMXP_0_1, 0x13dcb0)
    FIELD(POR_MPU_M3_PRBAR10_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR10_U_SMXP_0_1, REGION10_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR10_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR10_U_SMXP_0_1, REGION10_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR10_U_SMXP_0_1, REGION10_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR10_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR10_U_SMXP_0_1, 0x13dcb8)
    FIELD(POR_MPU_M3_PRLAR10_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR10_U_SMXP_0_1, REGION10_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR10_U_SMXP_0_1, REGION10_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR11_U_SMXP_0_1, 0x13dcc0)
    FIELD(POR_MPU_M3_PRBAR11_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR11_U_SMXP_0_1, REGION11_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR11_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR11_U_SMXP_0_1, REGION11_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR11_U_SMXP_0_1, REGION11_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR11_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR11_U_SMXP_0_1, 0x13dcc8)
    FIELD(POR_MPU_M3_PRLAR11_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR11_U_SMXP_0_1, REGION11_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR11_U_SMXP_0_1, REGION11_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR12_U_SMXP_0_1, 0x13dcd0)
    FIELD(POR_MPU_M3_PRBAR12_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR12_U_SMXP_0_1, REGION12_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR12_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR12_U_SMXP_0_1, REGION12_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR12_U_SMXP_0_1, REGION12_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR12_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR12_U_SMXP_0_1, 0x13dcd8)
    FIELD(POR_MPU_M3_PRLAR12_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR12_U_SMXP_0_1, REGION12_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR12_U_SMXP_0_1, REGION12_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR13_U_SMXP_0_1, 0x13dce0)
    FIELD(POR_MPU_M3_PRBAR13_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR13_U_SMXP_0_1, REGION13_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR13_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR13_U_SMXP_0_1, REGION13_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR13_U_SMXP_0_1, REGION13_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR13_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR13_U_SMXP_0_1, 0x13dce8)
    FIELD(POR_MPU_M3_PRLAR13_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR13_U_SMXP_0_1, REGION13_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR13_U_SMXP_0_1, REGION13_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR14_U_SMXP_0_1, 0x13dcf0)
    FIELD(POR_MPU_M3_PRBAR14_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR14_U_SMXP_0_1, REGION14_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR14_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR14_U_SMXP_0_1, REGION14_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR14_U_SMXP_0_1, REGION14_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR14_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR14_U_SMXP_0_1, 0x13dcf8)
    FIELD(POR_MPU_M3_PRLAR14_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR14_U_SMXP_0_1, REGION14_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR14_U_SMXP_0_1, REGION14_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR15_U_SMXP_0_1, 0x13dd00)
    FIELD(POR_MPU_M3_PRBAR15_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR15_U_SMXP_0_1, REGION15_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR15_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR15_U_SMXP_0_1, REGION15_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR15_U_SMXP_0_1, REGION15_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR15_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR15_U_SMXP_0_1, 0x13dd08)
    FIELD(POR_MPU_M3_PRLAR15_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR15_U_SMXP_0_1, REGION15_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR15_U_SMXP_0_1, REGION15_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR16_U_SMXP_0_1, 0x13dd10)
    FIELD(POR_MPU_M3_PRBAR16_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR16_U_SMXP_0_1, REGION16_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR16_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR16_U_SMXP_0_1, REGION16_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR16_U_SMXP_0_1, REGION16_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR16_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR16_U_SMXP_0_1, 0x13dd18)
    FIELD(POR_MPU_M3_PRLAR16_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR16_U_SMXP_0_1, REGION16_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR16_U_SMXP_0_1, REGION16_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR17_U_SMXP_0_1, 0x13dd20)
    FIELD(POR_MPU_M3_PRBAR17_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR17_U_SMXP_0_1, REGION17_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR17_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR17_U_SMXP_0_1, REGION17_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR17_U_SMXP_0_1, REGION17_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR17_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR17_U_SMXP_0_1, 0x13dd28)
    FIELD(POR_MPU_M3_PRLAR17_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR17_U_SMXP_0_1, REGION17_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR17_U_SMXP_0_1, REGION17_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR18_U_SMXP_0_1, 0x13dd30)
    FIELD(POR_MPU_M3_PRBAR18_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR18_U_SMXP_0_1, REGION18_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR18_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR18_U_SMXP_0_1, REGION18_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR18_U_SMXP_0_1, REGION18_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR18_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR18_U_SMXP_0_1, 0x13dd38)
    FIELD(POR_MPU_M3_PRLAR18_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR18_U_SMXP_0_1, REGION18_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR18_U_SMXP_0_1, REGION18_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR19_U_SMXP_0_1, 0x13dd40)
    FIELD(POR_MPU_M3_PRBAR19_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR19_U_SMXP_0_1, REGION19_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR19_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR19_U_SMXP_0_1, REGION19_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR19_U_SMXP_0_1, REGION19_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR19_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR19_U_SMXP_0_1, 0x13dd48)
    FIELD(POR_MPU_M3_PRLAR19_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR19_U_SMXP_0_1, REGION19_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR19_U_SMXP_0_1, REGION19_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR20_U_SMXP_0_1, 0x13dd50)
    FIELD(POR_MPU_M3_PRBAR20_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR20_U_SMXP_0_1, REGION20_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR20_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR20_U_SMXP_0_1, REGION20_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR20_U_SMXP_0_1, REGION20_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR20_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR20_U_SMXP_0_1, 0x13dd58)
    FIELD(POR_MPU_M3_PRLAR20_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR20_U_SMXP_0_1, REGION20_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR20_U_SMXP_0_1, REGION20_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR21_U_SMXP_0_1, 0x13dd60)
    FIELD(POR_MPU_M3_PRBAR21_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR21_U_SMXP_0_1, REGION21_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR21_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR21_U_SMXP_0_1, REGION21_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR21_U_SMXP_0_1, REGION21_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR21_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR21_U_SMXP_0_1, 0x13dd68)
    FIELD(POR_MPU_M3_PRLAR21_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR21_U_SMXP_0_1, REGION21_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR21_U_SMXP_0_1, REGION21_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR22_U_SMXP_0_1, 0x13dd70)
    FIELD(POR_MPU_M3_PRBAR22_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR22_U_SMXP_0_1, REGION22_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR22_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR22_U_SMXP_0_1, REGION22_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR22_U_SMXP_0_1, REGION22_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR22_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR22_U_SMXP_0_1, 0x13dd78)
    FIELD(POR_MPU_M3_PRLAR22_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR22_U_SMXP_0_1, REGION22_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR22_U_SMXP_0_1, REGION22_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR23_U_SMXP_0_1, 0x13dd80)
    FIELD(POR_MPU_M3_PRBAR23_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR23_U_SMXP_0_1, REGION23_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR23_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR23_U_SMXP_0_1, REGION23_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR23_U_SMXP_0_1, REGION23_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR23_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR23_U_SMXP_0_1, 0x13dd88)
    FIELD(POR_MPU_M3_PRLAR23_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR23_U_SMXP_0_1, REGION23_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR23_U_SMXP_0_1, REGION23_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR24_U_SMXP_0_1, 0x13dd90)
    FIELD(POR_MPU_M3_PRBAR24_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR24_U_SMXP_0_1, REGION24_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR24_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR24_U_SMXP_0_1, REGION24_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR24_U_SMXP_0_1, REGION24_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR24_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR24_U_SMXP_0_1, 0x13dd98)
    FIELD(POR_MPU_M3_PRLAR24_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR24_U_SMXP_0_1, REGION24_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR24_U_SMXP_0_1, REGION24_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR25_U_SMXP_0_1, 0x13dda0)
    FIELD(POR_MPU_M3_PRBAR25_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR25_U_SMXP_0_1, REGION25_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR25_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR25_U_SMXP_0_1, REGION25_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR25_U_SMXP_0_1, REGION25_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR25_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR25_U_SMXP_0_1, 0x13dda8)
    FIELD(POR_MPU_M3_PRLAR25_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR25_U_SMXP_0_1, REGION25_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR25_U_SMXP_0_1, REGION25_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR26_U_SMXP_0_1, 0x13ddb0)
    FIELD(POR_MPU_M3_PRBAR26_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR26_U_SMXP_0_1, REGION26_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR26_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR26_U_SMXP_0_1, REGION26_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR26_U_SMXP_0_1, REGION26_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR26_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR26_U_SMXP_0_1, 0x13ddb8)
    FIELD(POR_MPU_M3_PRLAR26_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR26_U_SMXP_0_1, REGION26_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR26_U_SMXP_0_1, REGION26_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR27_U_SMXP_0_1, 0x13ddc0)
    FIELD(POR_MPU_M3_PRBAR27_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR27_U_SMXP_0_1, REGION27_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR27_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR27_U_SMXP_0_1, REGION27_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR27_U_SMXP_0_1, REGION27_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR27_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR27_U_SMXP_0_1, 0x13ddc8)
    FIELD(POR_MPU_M3_PRLAR27_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR27_U_SMXP_0_1, REGION27_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR27_U_SMXP_0_1, REGION27_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR28_U_SMXP_0_1, 0x13ddd0)
    FIELD(POR_MPU_M3_PRBAR28_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR28_U_SMXP_0_1, REGION28_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR28_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR28_U_SMXP_0_1, REGION28_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR28_U_SMXP_0_1, REGION28_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR28_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR28_U_SMXP_0_1, 0x13ddd8)
    FIELD(POR_MPU_M3_PRLAR28_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR28_U_SMXP_0_1, REGION28_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR28_U_SMXP_0_1, REGION28_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR29_U_SMXP_0_1, 0x13dde0)
    FIELD(POR_MPU_M3_PRBAR29_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR29_U_SMXP_0_1, REGION29_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR29_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR29_U_SMXP_0_1, REGION29_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR29_U_SMXP_0_1, REGION29_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR29_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR29_U_SMXP_0_1, 0x13dde8)
    FIELD(POR_MPU_M3_PRLAR29_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR29_U_SMXP_0_1, REGION29_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR29_U_SMXP_0_1, REGION29_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR30_U_SMXP_0_1, 0x13ddf0)
    FIELD(POR_MPU_M3_PRBAR30_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR30_U_SMXP_0_1, REGION30_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR30_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR30_U_SMXP_0_1, REGION30_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR30_U_SMXP_0_1, REGION30_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR30_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR30_U_SMXP_0_1, 0x13ddf8)
    FIELD(POR_MPU_M3_PRLAR30_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR30_U_SMXP_0_1, REGION30_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR30_U_SMXP_0_1, REGION30_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR31_U_SMXP_0_1, 0x13de00)
    FIELD(POR_MPU_M3_PRBAR31_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR31_U_SMXP_0_1, REGION31_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR31_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR31_U_SMXP_0_1, REGION31_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR31_U_SMXP_0_1, REGION31_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR31_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR31_U_SMXP_0_1, 0x13de08)
    FIELD(POR_MPU_M3_PRLAR31_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR31_U_SMXP_0_1, REGION31_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR31_U_SMXP_0_1, REGION31_EN, 0, 1)
REG32(POR_MPU_M4_CTL_U_SMXP_0_1, 0x13e000)
    FIELD(POR_MPU_M4_CTL_U_SMXP_0_1, M4_EN, 2, 1)
    FIELD(POR_MPU_M4_CTL_U_SMXP_0_1, M4_ACTION, 0, 2)
REG32(POR_MPU_M4_PRBAR0_U_SMXP_0_1, 0x13e010)
    FIELD(POR_MPU_M4_PRBAR0_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR0_U_SMXP_0_1, REGION0_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR0_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR0_U_SMXP_0_1, REGION0_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR0_U_SMXP_0_1, REGION0_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR0_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR0_U_SMXP_0_1, 0x13e018)
    FIELD(POR_MPU_M4_PRLAR0_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR0_U_SMXP_0_1, REGION0_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR0_U_SMXP_0_1, REGION0_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR1_U_SMXP_0_1, 0x13e020)
    FIELD(POR_MPU_M4_PRBAR1_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR1_U_SMXP_0_1, REGION1_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR1_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR1_U_SMXP_0_1, REGION1_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR1_U_SMXP_0_1, REGION1_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR1_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR1_U_SMXP_0_1, 0x13e028)
    FIELD(POR_MPU_M4_PRLAR1_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR1_U_SMXP_0_1, REGION1_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR1_U_SMXP_0_1, REGION1_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR2_U_SMXP_0_1, 0x13e030)
    FIELD(POR_MPU_M4_PRBAR2_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR2_U_SMXP_0_1, REGION2_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR2_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR2_U_SMXP_0_1, REGION2_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR2_U_SMXP_0_1, REGION2_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR2_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR2_U_SMXP_0_1, 0x13e038)
    FIELD(POR_MPU_M4_PRLAR2_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR2_U_SMXP_0_1, REGION2_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR2_U_SMXP_0_1, REGION2_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR3_U_SMXP_0_1, 0x13e040)
    FIELD(POR_MPU_M4_PRBAR3_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR3_U_SMXP_0_1, REGION3_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR3_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR3_U_SMXP_0_1, REGION3_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR3_U_SMXP_0_1, REGION3_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR3_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR3_U_SMXP_0_1, 0x13e048)
    FIELD(POR_MPU_M4_PRLAR3_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR3_U_SMXP_0_1, REGION3_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR3_U_SMXP_0_1, REGION3_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR4_U_SMXP_0_1, 0x13e050)
    FIELD(POR_MPU_M4_PRBAR4_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR4_U_SMXP_0_1, REGION4_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR4_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR4_U_SMXP_0_1, REGION4_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR4_U_SMXP_0_1, REGION4_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR4_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR4_U_SMXP_0_1, 0x13e058)
    FIELD(POR_MPU_M4_PRLAR4_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR4_U_SMXP_0_1, REGION4_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR4_U_SMXP_0_1, REGION4_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR5_U_SMXP_0_1, 0x13e060)
    FIELD(POR_MPU_M4_PRBAR5_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR5_U_SMXP_0_1, REGION5_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR5_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR5_U_SMXP_0_1, REGION5_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR5_U_SMXP_0_1, REGION5_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR5_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR5_U_SMXP_0_1, 0x13e068)
    FIELD(POR_MPU_M4_PRLAR5_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR5_U_SMXP_0_1, REGION5_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR5_U_SMXP_0_1, REGION5_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR6_U_SMXP_0_1, 0x13e070)
    FIELD(POR_MPU_M4_PRBAR6_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR6_U_SMXP_0_1, REGION6_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR6_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR6_U_SMXP_0_1, REGION6_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR6_U_SMXP_0_1, REGION6_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR6_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR6_U_SMXP_0_1, 0x13e078)
    FIELD(POR_MPU_M4_PRLAR6_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR6_U_SMXP_0_1, REGION6_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR6_U_SMXP_0_1, REGION6_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR7_U_SMXP_0_1, 0x13e080)
    FIELD(POR_MPU_M4_PRBAR7_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR7_U_SMXP_0_1, REGION7_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR7_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR7_U_SMXP_0_1, REGION7_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR7_U_SMXP_0_1, REGION7_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR7_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR7_U_SMXP_0_1, 0x13e088)
    FIELD(POR_MPU_M4_PRLAR7_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR7_U_SMXP_0_1, REGION7_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR7_U_SMXP_0_1, REGION7_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR8_U_SMXP_0_1, 0x13e090)
    FIELD(POR_MPU_M4_PRBAR8_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR8_U_SMXP_0_1, REGION8_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR8_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR8_U_SMXP_0_1, REGION8_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR8_U_SMXP_0_1, REGION8_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR8_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR8_U_SMXP_0_1, 0x13e098)
    FIELD(POR_MPU_M4_PRLAR8_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR8_U_SMXP_0_1, REGION8_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR8_U_SMXP_0_1, REGION8_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR9_U_SMXP_0_1, 0x13e0a0)
    FIELD(POR_MPU_M4_PRBAR9_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR9_U_SMXP_0_1, REGION9_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR9_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR9_U_SMXP_0_1, REGION9_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR9_U_SMXP_0_1, REGION9_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR9_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR9_U_SMXP_0_1, 0x13e0a8)
    FIELD(POR_MPU_M4_PRLAR9_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR9_U_SMXP_0_1, REGION9_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR9_U_SMXP_0_1, REGION9_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR10_U_SMXP_0_1, 0x13e0b0)
    FIELD(POR_MPU_M4_PRBAR10_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR10_U_SMXP_0_1, REGION10_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR10_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR10_U_SMXP_0_1, REGION10_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR10_U_SMXP_0_1, REGION10_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR10_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR10_U_SMXP_0_1, 0x13e0b8)
    FIELD(POR_MPU_M4_PRLAR10_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR10_U_SMXP_0_1, REGION10_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR10_U_SMXP_0_1, REGION10_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR11_U_SMXP_0_1, 0x13e0c0)
    FIELD(POR_MPU_M4_PRBAR11_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR11_U_SMXP_0_1, REGION11_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR11_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR11_U_SMXP_0_1, REGION11_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR11_U_SMXP_0_1, REGION11_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR11_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR11_U_SMXP_0_1, 0x13e0c8)
    FIELD(POR_MPU_M4_PRLAR11_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR11_U_SMXP_0_1, REGION11_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR11_U_SMXP_0_1, REGION11_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR12_U_SMXP_0_1, 0x13e0d0)
    FIELD(POR_MPU_M4_PRBAR12_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR12_U_SMXP_0_1, REGION12_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR12_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR12_U_SMXP_0_1, REGION12_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR12_U_SMXP_0_1, REGION12_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR12_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR12_U_SMXP_0_1, 0x13e0d8)
    FIELD(POR_MPU_M4_PRLAR12_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR12_U_SMXP_0_1, REGION12_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR12_U_SMXP_0_1, REGION12_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR13_U_SMXP_0_1, 0x13e0e0)
    FIELD(POR_MPU_M4_PRBAR13_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR13_U_SMXP_0_1, REGION13_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR13_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR13_U_SMXP_0_1, REGION13_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR13_U_SMXP_0_1, REGION13_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR13_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR13_U_SMXP_0_1, 0x13e0e8)
    FIELD(POR_MPU_M4_PRLAR13_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR13_U_SMXP_0_1, REGION13_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR13_U_SMXP_0_1, REGION13_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR14_U_SMXP_0_1, 0x13e0f0)
    FIELD(POR_MPU_M4_PRBAR14_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR14_U_SMXP_0_1, REGION14_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR14_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR14_U_SMXP_0_1, REGION14_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR14_U_SMXP_0_1, REGION14_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR14_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR14_U_SMXP_0_1, 0x13e0f8)
    FIELD(POR_MPU_M4_PRLAR14_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR14_U_SMXP_0_1, REGION14_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR14_U_SMXP_0_1, REGION14_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR15_U_SMXP_0_1, 0x13e100)
    FIELD(POR_MPU_M4_PRBAR15_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR15_U_SMXP_0_1, REGION15_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR15_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR15_U_SMXP_0_1, REGION15_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR15_U_SMXP_0_1, REGION15_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR15_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR15_U_SMXP_0_1, 0x13e108)
    FIELD(POR_MPU_M4_PRLAR15_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR15_U_SMXP_0_1, REGION15_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR15_U_SMXP_0_1, REGION15_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR16_U_SMXP_0_1, 0x13e110)
    FIELD(POR_MPU_M4_PRBAR16_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR16_U_SMXP_0_1, REGION16_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR16_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR16_U_SMXP_0_1, REGION16_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR16_U_SMXP_0_1, REGION16_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR16_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR16_U_SMXP_0_1, 0x13e118)
    FIELD(POR_MPU_M4_PRLAR16_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR16_U_SMXP_0_1, REGION16_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR16_U_SMXP_0_1, REGION16_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR17_U_SMXP_0_1, 0x13e120)
    FIELD(POR_MPU_M4_PRBAR17_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR17_U_SMXP_0_1, REGION17_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR17_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR17_U_SMXP_0_1, REGION17_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR17_U_SMXP_0_1, REGION17_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR17_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR17_U_SMXP_0_1, 0x13e128)
    FIELD(POR_MPU_M4_PRLAR17_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR17_U_SMXP_0_1, REGION17_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR17_U_SMXP_0_1, REGION17_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR18_U_SMXP_0_1, 0x13e130)
    FIELD(POR_MPU_M4_PRBAR18_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR18_U_SMXP_0_1, REGION18_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR18_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR18_U_SMXP_0_1, REGION18_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR18_U_SMXP_0_1, REGION18_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR18_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR18_U_SMXP_0_1, 0x13e138)
    FIELD(POR_MPU_M4_PRLAR18_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR18_U_SMXP_0_1, REGION18_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR18_U_SMXP_0_1, REGION18_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR19_U_SMXP_0_1, 0x13e140)
    FIELD(POR_MPU_M4_PRBAR19_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR19_U_SMXP_0_1, REGION19_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR19_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR19_U_SMXP_0_1, REGION19_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR19_U_SMXP_0_1, REGION19_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR19_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR19_U_SMXP_0_1, 0x13e148)
    FIELD(POR_MPU_M4_PRLAR19_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR19_U_SMXP_0_1, REGION19_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR19_U_SMXP_0_1, REGION19_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR20_U_SMXP_0_1, 0x13e150)
    FIELD(POR_MPU_M4_PRBAR20_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR20_U_SMXP_0_1, REGION20_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR20_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR20_U_SMXP_0_1, REGION20_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR20_U_SMXP_0_1, REGION20_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR20_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR20_U_SMXP_0_1, 0x13e158)
    FIELD(POR_MPU_M4_PRLAR20_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR20_U_SMXP_0_1, REGION20_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR20_U_SMXP_0_1, REGION20_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR21_U_SMXP_0_1, 0x13e160)
    FIELD(POR_MPU_M4_PRBAR21_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR21_U_SMXP_0_1, REGION21_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR21_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR21_U_SMXP_0_1, REGION21_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR21_U_SMXP_0_1, REGION21_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR21_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR21_U_SMXP_0_1, 0x13e168)
    FIELD(POR_MPU_M4_PRLAR21_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR21_U_SMXP_0_1, REGION21_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR21_U_SMXP_0_1, REGION21_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR22_U_SMXP_0_1, 0x13e170)
    FIELD(POR_MPU_M4_PRBAR22_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR22_U_SMXP_0_1, REGION22_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR22_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR22_U_SMXP_0_1, REGION22_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR22_U_SMXP_0_1, REGION22_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR22_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR22_U_SMXP_0_1, 0x13e178)
    FIELD(POR_MPU_M4_PRLAR22_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR22_U_SMXP_0_1, REGION22_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR22_U_SMXP_0_1, REGION22_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR23_U_SMXP_0_1, 0x13e180)
    FIELD(POR_MPU_M4_PRBAR23_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR23_U_SMXP_0_1, REGION23_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR23_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR23_U_SMXP_0_1, REGION23_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR23_U_SMXP_0_1, REGION23_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR23_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR23_U_SMXP_0_1, 0x13e188)
    FIELD(POR_MPU_M4_PRLAR23_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR23_U_SMXP_0_1, REGION23_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR23_U_SMXP_0_1, REGION23_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR24_U_SMXP_0_1, 0x13e190)
    FIELD(POR_MPU_M4_PRBAR24_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR24_U_SMXP_0_1, REGION24_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR24_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR24_U_SMXP_0_1, REGION24_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR24_U_SMXP_0_1, REGION24_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR24_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR24_U_SMXP_0_1, 0x13e198)
    FIELD(POR_MPU_M4_PRLAR24_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR24_U_SMXP_0_1, REGION24_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR24_U_SMXP_0_1, REGION24_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR25_U_SMXP_0_1, 0x13e1a0)
    FIELD(POR_MPU_M4_PRBAR25_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR25_U_SMXP_0_1, REGION25_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR25_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR25_U_SMXP_0_1, REGION25_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR25_U_SMXP_0_1, REGION25_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR25_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR25_U_SMXP_0_1, 0x13e1a8)
    FIELD(POR_MPU_M4_PRLAR25_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR25_U_SMXP_0_1, REGION25_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR25_U_SMXP_0_1, REGION25_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR26_U_SMXP_0_1, 0x13e1b0)
    FIELD(POR_MPU_M4_PRBAR26_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR26_U_SMXP_0_1, REGION26_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR26_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR26_U_SMXP_0_1, REGION26_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR26_U_SMXP_0_1, REGION26_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR26_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR26_U_SMXP_0_1, 0x13e1b8)
    FIELD(POR_MPU_M4_PRLAR26_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR26_U_SMXP_0_1, REGION26_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR26_U_SMXP_0_1, REGION26_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR27_U_SMXP_0_1, 0x13e1c0)
    FIELD(POR_MPU_M4_PRBAR27_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR27_U_SMXP_0_1, REGION27_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR27_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR27_U_SMXP_0_1, REGION27_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR27_U_SMXP_0_1, REGION27_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR27_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR27_U_SMXP_0_1, 0x13e1c8)
    FIELD(POR_MPU_M4_PRLAR27_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR27_U_SMXP_0_1, REGION27_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR27_U_SMXP_0_1, REGION27_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR28_U_SMXP_0_1, 0x13e1d0)
    FIELD(POR_MPU_M4_PRBAR28_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR28_U_SMXP_0_1, REGION28_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR28_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR28_U_SMXP_0_1, REGION28_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR28_U_SMXP_0_1, REGION28_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR28_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR28_U_SMXP_0_1, 0x13e1d8)
    FIELD(POR_MPU_M4_PRLAR28_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR28_U_SMXP_0_1, REGION28_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR28_U_SMXP_0_1, REGION28_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR29_U_SMXP_0_1, 0x13e1e0)
    FIELD(POR_MPU_M4_PRBAR29_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR29_U_SMXP_0_1, REGION29_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR29_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR29_U_SMXP_0_1, REGION29_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR29_U_SMXP_0_1, REGION29_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR29_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR29_U_SMXP_0_1, 0x13e1e8)
    FIELD(POR_MPU_M4_PRLAR29_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR29_U_SMXP_0_1, REGION29_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR29_U_SMXP_0_1, REGION29_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR30_U_SMXP_0_1, 0x13e1f0)
    FIELD(POR_MPU_M4_PRBAR30_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR30_U_SMXP_0_1, REGION30_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR30_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR30_U_SMXP_0_1, REGION30_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR30_U_SMXP_0_1, REGION30_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR30_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR30_U_SMXP_0_1, 0x13e1f8)
    FIELD(POR_MPU_M4_PRLAR30_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR30_U_SMXP_0_1, REGION30_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR30_U_SMXP_0_1, REGION30_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR31_U_SMXP_0_1, 0x13e200)
    FIELD(POR_MPU_M4_PRBAR31_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR31_U_SMXP_0_1, REGION31_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR31_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR31_U_SMXP_0_1, REGION31_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR31_U_SMXP_0_1, REGION31_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR31_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR31_U_SMXP_0_1, 0x13e208)
    FIELD(POR_MPU_M4_PRLAR31_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR31_U_SMXP_0_1, REGION31_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR31_U_SMXP_0_1, REGION31_EN, 0, 1)
REG32(POR_MPU_M5_CTL_U_SMXP_0_1, 0x13e400)
    FIELD(POR_MPU_M5_CTL_U_SMXP_0_1, M5_EN, 2, 1)
    FIELD(POR_MPU_M5_CTL_U_SMXP_0_1, M5_ACTION, 0, 2)
REG32(POR_MPU_M5_PRBAR0_U_SMXP_0_1, 0x13e410)
    FIELD(POR_MPU_M5_PRBAR0_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR0_U_SMXP_0_1, REGION0_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR0_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR0_U_SMXP_0_1, REGION0_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR0_U_SMXP_0_1, REGION0_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR0_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR0_U_SMXP_0_1, 0x13e418)
    FIELD(POR_MPU_M5_PRLAR0_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR0_U_SMXP_0_1, REGION0_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR0_U_SMXP_0_1, REGION0_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR1_U_SMXP_0_1, 0x13e420)
    FIELD(POR_MPU_M5_PRBAR1_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR1_U_SMXP_0_1, REGION1_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR1_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR1_U_SMXP_0_1, REGION1_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR1_U_SMXP_0_1, REGION1_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR1_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR1_U_SMXP_0_1, 0x13e428)
    FIELD(POR_MPU_M5_PRLAR1_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR1_U_SMXP_0_1, REGION1_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR1_U_SMXP_0_1, REGION1_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR2_U_SMXP_0_1, 0x13e430)
    FIELD(POR_MPU_M5_PRBAR2_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR2_U_SMXP_0_1, REGION2_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR2_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR2_U_SMXP_0_1, REGION2_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR2_U_SMXP_0_1, REGION2_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR2_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR2_U_SMXP_0_1, 0x13e438)
    FIELD(POR_MPU_M5_PRLAR2_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR2_U_SMXP_0_1, REGION2_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR2_U_SMXP_0_1, REGION2_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR3_U_SMXP_0_1, 0x13e440)
    FIELD(POR_MPU_M5_PRBAR3_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR3_U_SMXP_0_1, REGION3_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR3_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR3_U_SMXP_0_1, REGION3_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR3_U_SMXP_0_1, REGION3_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR3_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR3_U_SMXP_0_1, 0x13e448)
    FIELD(POR_MPU_M5_PRLAR3_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR3_U_SMXP_0_1, REGION3_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR3_U_SMXP_0_1, REGION3_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR4_U_SMXP_0_1, 0x13e450)
    FIELD(POR_MPU_M5_PRBAR4_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR4_U_SMXP_0_1, REGION4_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR4_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR4_U_SMXP_0_1, REGION4_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR4_U_SMXP_0_1, REGION4_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR4_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR4_U_SMXP_0_1, 0x13e458)
    FIELD(POR_MPU_M5_PRLAR4_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR4_U_SMXP_0_1, REGION4_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR4_U_SMXP_0_1, REGION4_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR5_U_SMXP_0_1, 0x13e460)
    FIELD(POR_MPU_M5_PRBAR5_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR5_U_SMXP_0_1, REGION5_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR5_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR5_U_SMXP_0_1, REGION5_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR5_U_SMXP_0_1, REGION5_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR5_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR5_U_SMXP_0_1, 0x13e468)
    FIELD(POR_MPU_M5_PRLAR5_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR5_U_SMXP_0_1, REGION5_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR5_U_SMXP_0_1, REGION5_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR6_U_SMXP_0_1, 0x13e470)
    FIELD(POR_MPU_M5_PRBAR6_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR6_U_SMXP_0_1, REGION6_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR6_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR6_U_SMXP_0_1, REGION6_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR6_U_SMXP_0_1, REGION6_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR6_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR6_U_SMXP_0_1, 0x13e478)
    FIELD(POR_MPU_M5_PRLAR6_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR6_U_SMXP_0_1, REGION6_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR6_U_SMXP_0_1, REGION6_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR7_U_SMXP_0_1, 0x13e480)
    FIELD(POR_MPU_M5_PRBAR7_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR7_U_SMXP_0_1, REGION7_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR7_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR7_U_SMXP_0_1, REGION7_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR7_U_SMXP_0_1, REGION7_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR7_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR7_U_SMXP_0_1, 0x13e488)
    FIELD(POR_MPU_M5_PRLAR7_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR7_U_SMXP_0_1, REGION7_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR7_U_SMXP_0_1, REGION7_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR8_U_SMXP_0_1, 0x13e490)
    FIELD(POR_MPU_M5_PRBAR8_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR8_U_SMXP_0_1, REGION8_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR8_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR8_U_SMXP_0_1, REGION8_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR8_U_SMXP_0_1, REGION8_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR8_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR8_U_SMXP_0_1, 0x13e498)
    FIELD(POR_MPU_M5_PRLAR8_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR8_U_SMXP_0_1, REGION8_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR8_U_SMXP_0_1, REGION8_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR9_U_SMXP_0_1, 0x13e4a0)
    FIELD(POR_MPU_M5_PRBAR9_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR9_U_SMXP_0_1, REGION9_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR9_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR9_U_SMXP_0_1, REGION9_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR9_U_SMXP_0_1, REGION9_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR9_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR9_U_SMXP_0_1, 0x13e4a8)
    FIELD(POR_MPU_M5_PRLAR9_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR9_U_SMXP_0_1, REGION9_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR9_U_SMXP_0_1, REGION9_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR10_U_SMXP_0_1, 0x13e4b0)
    FIELD(POR_MPU_M5_PRBAR10_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR10_U_SMXP_0_1, REGION10_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR10_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR10_U_SMXP_0_1, REGION10_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR10_U_SMXP_0_1, REGION10_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR10_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR10_U_SMXP_0_1, 0x13e4b8)
    FIELD(POR_MPU_M5_PRLAR10_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR10_U_SMXP_0_1, REGION10_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR10_U_SMXP_0_1, REGION10_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR11_U_SMXP_0_1, 0x13e4c0)
    FIELD(POR_MPU_M5_PRBAR11_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR11_U_SMXP_0_1, REGION11_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR11_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR11_U_SMXP_0_1, REGION11_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR11_U_SMXP_0_1, REGION11_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR11_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR11_U_SMXP_0_1, 0x13e4c8)
    FIELD(POR_MPU_M5_PRLAR11_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR11_U_SMXP_0_1, REGION11_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR11_U_SMXP_0_1, REGION11_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR12_U_SMXP_0_1, 0x13e4d0)
    FIELD(POR_MPU_M5_PRBAR12_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR12_U_SMXP_0_1, REGION12_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR12_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR12_U_SMXP_0_1, REGION12_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR12_U_SMXP_0_1, REGION12_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR12_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR12_U_SMXP_0_1, 0x13e4d8)
    FIELD(POR_MPU_M5_PRLAR12_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR12_U_SMXP_0_1, REGION12_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR12_U_SMXP_0_1, REGION12_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR13_U_SMXP_0_1, 0x13e4e0)
    FIELD(POR_MPU_M5_PRBAR13_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR13_U_SMXP_0_1, REGION13_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR13_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR13_U_SMXP_0_1, REGION13_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR13_U_SMXP_0_1, REGION13_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR13_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR13_U_SMXP_0_1, 0x13e4e8)
    FIELD(POR_MPU_M5_PRLAR13_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR13_U_SMXP_0_1, REGION13_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR13_U_SMXP_0_1, REGION13_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR14_U_SMXP_0_1, 0x13e4f0)
    FIELD(POR_MPU_M5_PRBAR14_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR14_U_SMXP_0_1, REGION14_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR14_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR14_U_SMXP_0_1, REGION14_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR14_U_SMXP_0_1, REGION14_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR14_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR14_U_SMXP_0_1, 0x13e4f8)
    FIELD(POR_MPU_M5_PRLAR14_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR14_U_SMXP_0_1, REGION14_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR14_U_SMXP_0_1, REGION14_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR15_U_SMXP_0_1, 0x13e500)
    FIELD(POR_MPU_M5_PRBAR15_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR15_U_SMXP_0_1, REGION15_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR15_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR15_U_SMXP_0_1, REGION15_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR15_U_SMXP_0_1, REGION15_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR15_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR15_U_SMXP_0_1, 0x13e508)
    FIELD(POR_MPU_M5_PRLAR15_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR15_U_SMXP_0_1, REGION15_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR15_U_SMXP_0_1, REGION15_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR16_U_SMXP_0_1, 0x13e510)
    FIELD(POR_MPU_M5_PRBAR16_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR16_U_SMXP_0_1, REGION16_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR16_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR16_U_SMXP_0_1, REGION16_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR16_U_SMXP_0_1, REGION16_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR16_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR16_U_SMXP_0_1, 0x13e518)
    FIELD(POR_MPU_M5_PRLAR16_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR16_U_SMXP_0_1, REGION16_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR16_U_SMXP_0_1, REGION16_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR17_U_SMXP_0_1, 0x13e520)
    FIELD(POR_MPU_M5_PRBAR17_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR17_U_SMXP_0_1, REGION17_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR17_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR17_U_SMXP_0_1, REGION17_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR17_U_SMXP_0_1, REGION17_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR17_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR17_U_SMXP_0_1, 0x13e528)
    FIELD(POR_MPU_M5_PRLAR17_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR17_U_SMXP_0_1, REGION17_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR17_U_SMXP_0_1, REGION17_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR18_U_SMXP_0_1, 0x13e530)
    FIELD(POR_MPU_M5_PRBAR18_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR18_U_SMXP_0_1, REGION18_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR18_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR18_U_SMXP_0_1, REGION18_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR18_U_SMXP_0_1, REGION18_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR18_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR18_U_SMXP_0_1, 0x13e538)
    FIELD(POR_MPU_M5_PRLAR18_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR18_U_SMXP_0_1, REGION18_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR18_U_SMXP_0_1, REGION18_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR19_U_SMXP_0_1, 0x13e540)
    FIELD(POR_MPU_M5_PRBAR19_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR19_U_SMXP_0_1, REGION19_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR19_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR19_U_SMXP_0_1, REGION19_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR19_U_SMXP_0_1, REGION19_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR19_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR19_U_SMXP_0_1, 0x13e548)
    FIELD(POR_MPU_M5_PRLAR19_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR19_U_SMXP_0_1, REGION19_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR19_U_SMXP_0_1, REGION19_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR20_U_SMXP_0_1, 0x13e550)
    FIELD(POR_MPU_M5_PRBAR20_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR20_U_SMXP_0_1, REGION20_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR20_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR20_U_SMXP_0_1, REGION20_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR20_U_SMXP_0_1, REGION20_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR20_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR20_U_SMXP_0_1, 0x13e558)
    FIELD(POR_MPU_M5_PRLAR20_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR20_U_SMXP_0_1, REGION20_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR20_U_SMXP_0_1, REGION20_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR21_U_SMXP_0_1, 0x13e560)
    FIELD(POR_MPU_M5_PRBAR21_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR21_U_SMXP_0_1, REGION21_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR21_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR21_U_SMXP_0_1, REGION21_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR21_U_SMXP_0_1, REGION21_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR21_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR21_U_SMXP_0_1, 0x13e568)
    FIELD(POR_MPU_M5_PRLAR21_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR21_U_SMXP_0_1, REGION21_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR21_U_SMXP_0_1, REGION21_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR22_U_SMXP_0_1, 0x13e570)
    FIELD(POR_MPU_M5_PRBAR22_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR22_U_SMXP_0_1, REGION22_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR22_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR22_U_SMXP_0_1, REGION22_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR22_U_SMXP_0_1, REGION22_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR22_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR22_U_SMXP_0_1, 0x13e578)
    FIELD(POR_MPU_M5_PRLAR22_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR22_U_SMXP_0_1, REGION22_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR22_U_SMXP_0_1, REGION22_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR23_U_SMXP_0_1, 0x13e580)
    FIELD(POR_MPU_M5_PRBAR23_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR23_U_SMXP_0_1, REGION23_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR23_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR23_U_SMXP_0_1, REGION23_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR23_U_SMXP_0_1, REGION23_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR23_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR23_U_SMXP_0_1, 0x13e588)
    FIELD(POR_MPU_M5_PRLAR23_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR23_U_SMXP_0_1, REGION23_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR23_U_SMXP_0_1, REGION23_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR24_U_SMXP_0_1, 0x13e590)
    FIELD(POR_MPU_M5_PRBAR24_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR24_U_SMXP_0_1, REGION24_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR24_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR24_U_SMXP_0_1, REGION24_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR24_U_SMXP_0_1, REGION24_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR24_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR24_U_SMXP_0_1, 0x13e598)
    FIELD(POR_MPU_M5_PRLAR24_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR24_U_SMXP_0_1, REGION24_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR24_U_SMXP_0_1, REGION24_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR25_U_SMXP_0_1, 0x13e5a0)
    FIELD(POR_MPU_M5_PRBAR25_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR25_U_SMXP_0_1, REGION25_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR25_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR25_U_SMXP_0_1, REGION25_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR25_U_SMXP_0_1, REGION25_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR25_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR25_U_SMXP_0_1, 0x13e5a8)
    FIELD(POR_MPU_M5_PRLAR25_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR25_U_SMXP_0_1, REGION25_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR25_U_SMXP_0_1, REGION25_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR26_U_SMXP_0_1, 0x13e5b0)
    FIELD(POR_MPU_M5_PRBAR26_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR26_U_SMXP_0_1, REGION26_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR26_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR26_U_SMXP_0_1, REGION26_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR26_U_SMXP_0_1, REGION26_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR26_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR26_U_SMXP_0_1, 0x13e5b8)
    FIELD(POR_MPU_M5_PRLAR26_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR26_U_SMXP_0_1, REGION26_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR26_U_SMXP_0_1, REGION26_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR27_U_SMXP_0_1, 0x13e5c0)
    FIELD(POR_MPU_M5_PRBAR27_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR27_U_SMXP_0_1, REGION27_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR27_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR27_U_SMXP_0_1, REGION27_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR27_U_SMXP_0_1, REGION27_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR27_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR27_U_SMXP_0_1, 0x13e5c8)
    FIELD(POR_MPU_M5_PRLAR27_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR27_U_SMXP_0_1, REGION27_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR27_U_SMXP_0_1, REGION27_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR28_U_SMXP_0_1, 0x13e5d0)
    FIELD(POR_MPU_M5_PRBAR28_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR28_U_SMXP_0_1, REGION28_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR28_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR28_U_SMXP_0_1, REGION28_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR28_U_SMXP_0_1, REGION28_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR28_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR28_U_SMXP_0_1, 0x13e5d8)
    FIELD(POR_MPU_M5_PRLAR28_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR28_U_SMXP_0_1, REGION28_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR28_U_SMXP_0_1, REGION28_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR29_U_SMXP_0_1, 0x13e5e0)
    FIELD(POR_MPU_M5_PRBAR29_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR29_U_SMXP_0_1, REGION29_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR29_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR29_U_SMXP_0_1, REGION29_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR29_U_SMXP_0_1, REGION29_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR29_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR29_U_SMXP_0_1, 0x13e5e8)
    FIELD(POR_MPU_M5_PRLAR29_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR29_U_SMXP_0_1, REGION29_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR29_U_SMXP_0_1, REGION29_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR30_U_SMXP_0_1, 0x13e5f0)
    FIELD(POR_MPU_M5_PRBAR30_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR30_U_SMXP_0_1, REGION30_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR30_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR30_U_SMXP_0_1, REGION30_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR30_U_SMXP_0_1, REGION30_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR30_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR30_U_SMXP_0_1, 0x13e5f8)
    FIELD(POR_MPU_M5_PRLAR30_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR30_U_SMXP_0_1, REGION30_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR30_U_SMXP_0_1, REGION30_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR31_U_SMXP_0_1, 0x13e600)
    FIELD(POR_MPU_M5_PRBAR31_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR31_U_SMXP_0_1, REGION31_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR31_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR31_U_SMXP_0_1, REGION31_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR31_U_SMXP_0_1, REGION31_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR31_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR31_U_SMXP_0_1, 0x13e608)
    FIELD(POR_MPU_M5_PRLAR31_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR31_U_SMXP_0_1, REGION31_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR31_U_SMXP_0_1, REGION31_EN, 0, 1)
REG32(POR_MPU_M6_CTL_U_SMXP_0_1, 0x13e800)
    FIELD(POR_MPU_M6_CTL_U_SMXP_0_1, M6_EN, 2, 1)
    FIELD(POR_MPU_M6_CTL_U_SMXP_0_1, M6_ACTION, 0, 2)
REG32(POR_MPU_M6_PRBAR0_U_SMXP_0_1, 0x13e810)
    FIELD(POR_MPU_M6_PRBAR0_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR0_U_SMXP_0_1, REGION0_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR0_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR0_U_SMXP_0_1, REGION0_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR0_U_SMXP_0_1, REGION0_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR0_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR0_U_SMXP_0_1, 0x13e818)
    FIELD(POR_MPU_M6_PRLAR0_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR0_U_SMXP_0_1, REGION0_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR0_U_SMXP_0_1, REGION0_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR1_U_SMXP_0_1, 0x13e820)
    FIELD(POR_MPU_M6_PRBAR1_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR1_U_SMXP_0_1, REGION1_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR1_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR1_U_SMXP_0_1, REGION1_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR1_U_SMXP_0_1, REGION1_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR1_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR1_U_SMXP_0_1, 0x13e828)
    FIELD(POR_MPU_M6_PRLAR1_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR1_U_SMXP_0_1, REGION1_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR1_U_SMXP_0_1, REGION1_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR2_U_SMXP_0_1, 0x13e830)
    FIELD(POR_MPU_M6_PRBAR2_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR2_U_SMXP_0_1, REGION2_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR2_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR2_U_SMXP_0_1, REGION2_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR2_U_SMXP_0_1, REGION2_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR2_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR2_U_SMXP_0_1, 0x13e838)
    FIELD(POR_MPU_M6_PRLAR2_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR2_U_SMXP_0_1, REGION2_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR2_U_SMXP_0_1, REGION2_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR3_U_SMXP_0_1, 0x13e840)
    FIELD(POR_MPU_M6_PRBAR3_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR3_U_SMXP_0_1, REGION3_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR3_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR3_U_SMXP_0_1, REGION3_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR3_U_SMXP_0_1, REGION3_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR3_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR3_U_SMXP_0_1, 0x13e848)
    FIELD(POR_MPU_M6_PRLAR3_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR3_U_SMXP_0_1, REGION3_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR3_U_SMXP_0_1, REGION3_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR4_U_SMXP_0_1, 0x13e850)
    FIELD(POR_MPU_M6_PRBAR4_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR4_U_SMXP_0_1, REGION4_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR4_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR4_U_SMXP_0_1, REGION4_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR4_U_SMXP_0_1, REGION4_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR4_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR4_U_SMXP_0_1, 0x13e858)
    FIELD(POR_MPU_M6_PRLAR4_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR4_U_SMXP_0_1, REGION4_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR4_U_SMXP_0_1, REGION4_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR5_U_SMXP_0_1, 0x13e860)
    FIELD(POR_MPU_M6_PRBAR5_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR5_U_SMXP_0_1, REGION5_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR5_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR5_U_SMXP_0_1, REGION5_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR5_U_SMXP_0_1, REGION5_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR5_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR5_U_SMXP_0_1, 0x13e868)
    FIELD(POR_MPU_M6_PRLAR5_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR5_U_SMXP_0_1, REGION5_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR5_U_SMXP_0_1, REGION5_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR6_U_SMXP_0_1, 0x13e870)
    FIELD(POR_MPU_M6_PRBAR6_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR6_U_SMXP_0_1, REGION6_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR6_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR6_U_SMXP_0_1, REGION6_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR6_U_SMXP_0_1, REGION6_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR6_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR6_U_SMXP_0_1, 0x13e878)
    FIELD(POR_MPU_M6_PRLAR6_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR6_U_SMXP_0_1, REGION6_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR6_U_SMXP_0_1, REGION6_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR7_U_SMXP_0_1, 0x13e880)
    FIELD(POR_MPU_M6_PRBAR7_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR7_U_SMXP_0_1, REGION7_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR7_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR7_U_SMXP_0_1, REGION7_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR7_U_SMXP_0_1, REGION7_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR7_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR7_U_SMXP_0_1, 0x13e888)
    FIELD(POR_MPU_M6_PRLAR7_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR7_U_SMXP_0_1, REGION7_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR7_U_SMXP_0_1, REGION7_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR8_U_SMXP_0_1, 0x13e890)
    FIELD(POR_MPU_M6_PRBAR8_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR8_U_SMXP_0_1, REGION8_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR8_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR8_U_SMXP_0_1, REGION8_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR8_U_SMXP_0_1, REGION8_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR8_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR8_U_SMXP_0_1, 0x13e898)
    FIELD(POR_MPU_M6_PRLAR8_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR8_U_SMXP_0_1, REGION8_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR8_U_SMXP_0_1, REGION8_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR9_U_SMXP_0_1, 0x13e8a0)
    FIELD(POR_MPU_M6_PRBAR9_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR9_U_SMXP_0_1, REGION9_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR9_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR9_U_SMXP_0_1, REGION9_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR9_U_SMXP_0_1, REGION9_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR9_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR9_U_SMXP_0_1, 0x13e8a8)
    FIELD(POR_MPU_M6_PRLAR9_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR9_U_SMXP_0_1, REGION9_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR9_U_SMXP_0_1, REGION9_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR10_U_SMXP_0_1, 0x13e8b0)
    FIELD(POR_MPU_M6_PRBAR10_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR10_U_SMXP_0_1, REGION10_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR10_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR10_U_SMXP_0_1, REGION10_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR10_U_SMXP_0_1, REGION10_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR10_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR10_U_SMXP_0_1, 0x13e8b8)
    FIELD(POR_MPU_M6_PRLAR10_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR10_U_SMXP_0_1, REGION10_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR10_U_SMXP_0_1, REGION10_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR11_U_SMXP_0_1, 0x13e8c0)
    FIELD(POR_MPU_M6_PRBAR11_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR11_U_SMXP_0_1, REGION11_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR11_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR11_U_SMXP_0_1, REGION11_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR11_U_SMXP_0_1, REGION11_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR11_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR11_U_SMXP_0_1, 0x13e8c8)
    FIELD(POR_MPU_M6_PRLAR11_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR11_U_SMXP_0_1, REGION11_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR11_U_SMXP_0_1, REGION11_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR12_U_SMXP_0_1, 0x13e8d0)
    FIELD(POR_MPU_M6_PRBAR12_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR12_U_SMXP_0_1, REGION12_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR12_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR12_U_SMXP_0_1, REGION12_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR12_U_SMXP_0_1, REGION12_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR12_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR12_U_SMXP_0_1, 0x13e8d8)
    FIELD(POR_MPU_M6_PRLAR12_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR12_U_SMXP_0_1, REGION12_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR12_U_SMXP_0_1, REGION12_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR13_U_SMXP_0_1, 0x13e8e0)
    FIELD(POR_MPU_M6_PRBAR13_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR13_U_SMXP_0_1, REGION13_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR13_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR13_U_SMXP_0_1, REGION13_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR13_U_SMXP_0_1, REGION13_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR13_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR13_U_SMXP_0_1, 0x13e8e8)
    FIELD(POR_MPU_M6_PRLAR13_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR13_U_SMXP_0_1, REGION13_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR13_U_SMXP_0_1, REGION13_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR14_U_SMXP_0_1, 0x13e8f0)
    FIELD(POR_MPU_M6_PRBAR14_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR14_U_SMXP_0_1, REGION14_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR14_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR14_U_SMXP_0_1, REGION14_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR14_U_SMXP_0_1, REGION14_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR14_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR14_U_SMXP_0_1, 0x13e8f8)
    FIELD(POR_MPU_M6_PRLAR14_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR14_U_SMXP_0_1, REGION14_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR14_U_SMXP_0_1, REGION14_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR15_U_SMXP_0_1, 0x13e900)
    FIELD(POR_MPU_M6_PRBAR15_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR15_U_SMXP_0_1, REGION15_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR15_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR15_U_SMXP_0_1, REGION15_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR15_U_SMXP_0_1, REGION15_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR15_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR15_U_SMXP_0_1, 0x13e908)
    FIELD(POR_MPU_M6_PRLAR15_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR15_U_SMXP_0_1, REGION15_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR15_U_SMXP_0_1, REGION15_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR16_U_SMXP_0_1, 0x13e910)
    FIELD(POR_MPU_M6_PRBAR16_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR16_U_SMXP_0_1, REGION16_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR16_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR16_U_SMXP_0_1, REGION16_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR16_U_SMXP_0_1, REGION16_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR16_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR16_U_SMXP_0_1, 0x13e918)
    FIELD(POR_MPU_M6_PRLAR16_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR16_U_SMXP_0_1, REGION16_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR16_U_SMXP_0_1, REGION16_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR17_U_SMXP_0_1, 0x13e920)
    FIELD(POR_MPU_M6_PRBAR17_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR17_U_SMXP_0_1, REGION17_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR17_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR17_U_SMXP_0_1, REGION17_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR17_U_SMXP_0_1, REGION17_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR17_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR17_U_SMXP_0_1, 0x13e928)
    FIELD(POR_MPU_M6_PRLAR17_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR17_U_SMXP_0_1, REGION17_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR17_U_SMXP_0_1, REGION17_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR18_U_SMXP_0_1, 0x13e930)
    FIELD(POR_MPU_M6_PRBAR18_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR18_U_SMXP_0_1, REGION18_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR18_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR18_U_SMXP_0_1, REGION18_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR18_U_SMXP_0_1, REGION18_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR18_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR18_U_SMXP_0_1, 0x13e938)
    FIELD(POR_MPU_M6_PRLAR18_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR18_U_SMXP_0_1, REGION18_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR18_U_SMXP_0_1, REGION18_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR19_U_SMXP_0_1, 0x13e940)
    FIELD(POR_MPU_M6_PRBAR19_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR19_U_SMXP_0_1, REGION19_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR19_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR19_U_SMXP_0_1, REGION19_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR19_U_SMXP_0_1, REGION19_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR19_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR19_U_SMXP_0_1, 0x13e948)
    FIELD(POR_MPU_M6_PRLAR19_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR19_U_SMXP_0_1, REGION19_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR19_U_SMXP_0_1, REGION19_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR20_U_SMXP_0_1, 0x13e950)
    FIELD(POR_MPU_M6_PRBAR20_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR20_U_SMXP_0_1, REGION20_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR20_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR20_U_SMXP_0_1, REGION20_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR20_U_SMXP_0_1, REGION20_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR20_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR20_U_SMXP_0_1, 0x13e958)
    FIELD(POR_MPU_M6_PRLAR20_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR20_U_SMXP_0_1, REGION20_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR20_U_SMXP_0_1, REGION20_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR21_U_SMXP_0_1, 0x13e960)
    FIELD(POR_MPU_M6_PRBAR21_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR21_U_SMXP_0_1, REGION21_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR21_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR21_U_SMXP_0_1, REGION21_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR21_U_SMXP_0_1, REGION21_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR21_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR21_U_SMXP_0_1, 0x13e968)
    FIELD(POR_MPU_M6_PRLAR21_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR21_U_SMXP_0_1, REGION21_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR21_U_SMXP_0_1, REGION21_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR22_U_SMXP_0_1, 0x13e970)
    FIELD(POR_MPU_M6_PRBAR22_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR22_U_SMXP_0_1, REGION22_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR22_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR22_U_SMXP_0_1, REGION22_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR22_U_SMXP_0_1, REGION22_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR22_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR22_U_SMXP_0_1, 0x13e978)
    FIELD(POR_MPU_M6_PRLAR22_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR22_U_SMXP_0_1, REGION22_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR22_U_SMXP_0_1, REGION22_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR23_U_SMXP_0_1, 0x13e980)
    FIELD(POR_MPU_M6_PRBAR23_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR23_U_SMXP_0_1, REGION23_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR23_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR23_U_SMXP_0_1, REGION23_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR23_U_SMXP_0_1, REGION23_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR23_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR23_U_SMXP_0_1, 0x13e988)
    FIELD(POR_MPU_M6_PRLAR23_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR23_U_SMXP_0_1, REGION23_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR23_U_SMXP_0_1, REGION23_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR24_U_SMXP_0_1, 0x13e990)
    FIELD(POR_MPU_M6_PRBAR24_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR24_U_SMXP_0_1, REGION24_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR24_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR24_U_SMXP_0_1, REGION24_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR24_U_SMXP_0_1, REGION24_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR24_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR24_U_SMXP_0_1, 0x13e998)
    FIELD(POR_MPU_M6_PRLAR24_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR24_U_SMXP_0_1, REGION24_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR24_U_SMXP_0_1, REGION24_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR25_U_SMXP_0_1, 0x13e9a0)
    FIELD(POR_MPU_M6_PRBAR25_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR25_U_SMXP_0_1, REGION25_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR25_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR25_U_SMXP_0_1, REGION25_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR25_U_SMXP_0_1, REGION25_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR25_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR25_U_SMXP_0_1, 0x13e9a8)
    FIELD(POR_MPU_M6_PRLAR25_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR25_U_SMXP_0_1, REGION25_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR25_U_SMXP_0_1, REGION25_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR26_U_SMXP_0_1, 0x13e9b0)
    FIELD(POR_MPU_M6_PRBAR26_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR26_U_SMXP_0_1, REGION26_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR26_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR26_U_SMXP_0_1, REGION26_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR26_U_SMXP_0_1, REGION26_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR26_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR26_U_SMXP_0_1, 0x13e9b8)
    FIELD(POR_MPU_M6_PRLAR26_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR26_U_SMXP_0_1, REGION26_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR26_U_SMXP_0_1, REGION26_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR27_U_SMXP_0_1, 0x13e9c0)
    FIELD(POR_MPU_M6_PRBAR27_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR27_U_SMXP_0_1, REGION27_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR27_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR27_U_SMXP_0_1, REGION27_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR27_U_SMXP_0_1, REGION27_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR27_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR27_U_SMXP_0_1, 0x13e9c8)
    FIELD(POR_MPU_M6_PRLAR27_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR27_U_SMXP_0_1, REGION27_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR27_U_SMXP_0_1, REGION27_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR28_U_SMXP_0_1, 0x13e9d0)
    FIELD(POR_MPU_M6_PRBAR28_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR28_U_SMXP_0_1, REGION28_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR28_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR28_U_SMXP_0_1, REGION28_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR28_U_SMXP_0_1, REGION28_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR28_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR28_U_SMXP_0_1, 0x13e9d8)
    FIELD(POR_MPU_M6_PRLAR28_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR28_U_SMXP_0_1, REGION28_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR28_U_SMXP_0_1, REGION28_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR29_U_SMXP_0_1, 0x13e9e0)
    FIELD(POR_MPU_M6_PRBAR29_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR29_U_SMXP_0_1, REGION29_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR29_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR29_U_SMXP_0_1, REGION29_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR29_U_SMXP_0_1, REGION29_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR29_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR29_U_SMXP_0_1, 0x13e9e8)
    FIELD(POR_MPU_M6_PRLAR29_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR29_U_SMXP_0_1, REGION29_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR29_U_SMXP_0_1, REGION29_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR30_U_SMXP_0_1, 0x13e9f0)
    FIELD(POR_MPU_M6_PRBAR30_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR30_U_SMXP_0_1, REGION30_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR30_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR30_U_SMXP_0_1, REGION30_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR30_U_SMXP_0_1, REGION30_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR30_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR30_U_SMXP_0_1, 0x13e9f8)
    FIELD(POR_MPU_M6_PRLAR30_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR30_U_SMXP_0_1, REGION30_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR30_U_SMXP_0_1, REGION30_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR31_U_SMXP_0_1, 0x13ea00)
    FIELD(POR_MPU_M6_PRBAR31_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR31_U_SMXP_0_1, REGION31_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR31_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR31_U_SMXP_0_1, REGION31_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR31_U_SMXP_0_1, REGION31_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR31_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR31_U_SMXP_0_1, 0x13ea08)
    FIELD(POR_MPU_M6_PRLAR31_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR31_U_SMXP_0_1, REGION31_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR31_U_SMXP_0_1, REGION31_EN, 0, 1)
REG32(POR_MPU_M7_CTL_U_SMXP_0_1, 0x13ec00)
    FIELD(POR_MPU_M7_CTL_U_SMXP_0_1, M7_EN, 2, 1)
    FIELD(POR_MPU_M7_CTL_U_SMXP_0_1, M7_ACTION, 0, 2)
REG32(POR_MPU_M7_PRBAR0_U_SMXP_0_1, 0x13ec10)
    FIELD(POR_MPU_M7_PRBAR0_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR0_U_SMXP_0_1, REGION0_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR0_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR0_U_SMXP_0_1, REGION0_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR0_U_SMXP_0_1, REGION0_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR0_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR0_U_SMXP_0_1, 0x13ec18)
    FIELD(POR_MPU_M7_PRLAR0_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR0_U_SMXP_0_1, REGION0_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR0_U_SMXP_0_1, REGION0_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR1_U_SMXP_0_1, 0x13ec20)
    FIELD(POR_MPU_M7_PRBAR1_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR1_U_SMXP_0_1, REGION1_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR1_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR1_U_SMXP_0_1, REGION1_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR1_U_SMXP_0_1, REGION1_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR1_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR1_U_SMXP_0_1, 0x13ec28)
    FIELD(POR_MPU_M7_PRLAR1_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR1_U_SMXP_0_1, REGION1_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR1_U_SMXP_0_1, REGION1_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR2_U_SMXP_0_1, 0x13ec30)
    FIELD(POR_MPU_M7_PRBAR2_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR2_U_SMXP_0_1, REGION2_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR2_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR2_U_SMXP_0_1, REGION2_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR2_U_SMXP_0_1, REGION2_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR2_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR2_U_SMXP_0_1, 0x13ec38)
    FIELD(POR_MPU_M7_PRLAR2_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR2_U_SMXP_0_1, REGION2_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR2_U_SMXP_0_1, REGION2_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR3_U_SMXP_0_1, 0x13ec40)
    FIELD(POR_MPU_M7_PRBAR3_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR3_U_SMXP_0_1, REGION3_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR3_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR3_U_SMXP_0_1, REGION3_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR3_U_SMXP_0_1, REGION3_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR3_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR3_U_SMXP_0_1, 0x13ec48)
    FIELD(POR_MPU_M7_PRLAR3_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR3_U_SMXP_0_1, REGION3_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR3_U_SMXP_0_1, REGION3_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR4_U_SMXP_0_1, 0x13ec50)
    FIELD(POR_MPU_M7_PRBAR4_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR4_U_SMXP_0_1, REGION4_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR4_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR4_U_SMXP_0_1, REGION4_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR4_U_SMXP_0_1, REGION4_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR4_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR4_U_SMXP_0_1, 0x13ec58)
    FIELD(POR_MPU_M7_PRLAR4_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR4_U_SMXP_0_1, REGION4_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR4_U_SMXP_0_1, REGION4_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR5_U_SMXP_0_1, 0x13ec60)
    FIELD(POR_MPU_M7_PRBAR5_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR5_U_SMXP_0_1, REGION5_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR5_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR5_U_SMXP_0_1, REGION5_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR5_U_SMXP_0_1, REGION5_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR5_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR5_U_SMXP_0_1, 0x13ec68)
    FIELD(POR_MPU_M7_PRLAR5_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR5_U_SMXP_0_1, REGION5_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR5_U_SMXP_0_1, REGION5_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR6_U_SMXP_0_1, 0x13ec70)
    FIELD(POR_MPU_M7_PRBAR6_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR6_U_SMXP_0_1, REGION6_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR6_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR6_U_SMXP_0_1, REGION6_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR6_U_SMXP_0_1, REGION6_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR6_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR6_U_SMXP_0_1, 0x13ec78)
    FIELD(POR_MPU_M7_PRLAR6_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR6_U_SMXP_0_1, REGION6_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR6_U_SMXP_0_1, REGION6_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR7_U_SMXP_0_1, 0x13ec80)
    FIELD(POR_MPU_M7_PRBAR7_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR7_U_SMXP_0_1, REGION7_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR7_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR7_U_SMXP_0_1, REGION7_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR7_U_SMXP_0_1, REGION7_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR7_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR7_U_SMXP_0_1, 0x13ec88)
    FIELD(POR_MPU_M7_PRLAR7_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR7_U_SMXP_0_1, REGION7_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR7_U_SMXP_0_1, REGION7_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR8_U_SMXP_0_1, 0x13ec90)
    FIELD(POR_MPU_M7_PRBAR8_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR8_U_SMXP_0_1, REGION8_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR8_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR8_U_SMXP_0_1, REGION8_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR8_U_SMXP_0_1, REGION8_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR8_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR8_U_SMXP_0_1, 0x13ec98)
    FIELD(POR_MPU_M7_PRLAR8_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR8_U_SMXP_0_1, REGION8_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR8_U_SMXP_0_1, REGION8_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR9_U_SMXP_0_1, 0x13eca0)
    FIELD(POR_MPU_M7_PRBAR9_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR9_U_SMXP_0_1, REGION9_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR9_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR9_U_SMXP_0_1, REGION9_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR9_U_SMXP_0_1, REGION9_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR9_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR9_U_SMXP_0_1, 0x13eca8)
    FIELD(POR_MPU_M7_PRLAR9_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR9_U_SMXP_0_1, REGION9_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR9_U_SMXP_0_1, REGION9_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR10_U_SMXP_0_1, 0x13ecb0)
    FIELD(POR_MPU_M7_PRBAR10_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR10_U_SMXP_0_1, REGION10_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR10_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR10_U_SMXP_0_1, REGION10_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR10_U_SMXP_0_1, REGION10_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR10_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR10_U_SMXP_0_1, 0x13ecb8)
    FIELD(POR_MPU_M7_PRLAR10_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR10_U_SMXP_0_1, REGION10_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR10_U_SMXP_0_1, REGION10_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR11_U_SMXP_0_1, 0x13ecc0)
    FIELD(POR_MPU_M7_PRBAR11_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR11_U_SMXP_0_1, REGION11_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR11_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR11_U_SMXP_0_1, REGION11_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR11_U_SMXP_0_1, REGION11_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR11_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR11_U_SMXP_0_1, 0x13ecc8)
    FIELD(POR_MPU_M7_PRLAR11_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR11_U_SMXP_0_1, REGION11_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR11_U_SMXP_0_1, REGION11_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR12_U_SMXP_0_1, 0x13ecd0)
    FIELD(POR_MPU_M7_PRBAR12_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR12_U_SMXP_0_1, REGION12_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR12_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR12_U_SMXP_0_1, REGION12_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR12_U_SMXP_0_1, REGION12_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR12_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR12_U_SMXP_0_1, 0x13ecd8)
    FIELD(POR_MPU_M7_PRLAR12_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR12_U_SMXP_0_1, REGION12_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR12_U_SMXP_0_1, REGION12_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR13_U_SMXP_0_1, 0x13ece0)
    FIELD(POR_MPU_M7_PRBAR13_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR13_U_SMXP_0_1, REGION13_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR13_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR13_U_SMXP_0_1, REGION13_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR13_U_SMXP_0_1, REGION13_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR13_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR13_U_SMXP_0_1, 0x13ece8)
    FIELD(POR_MPU_M7_PRLAR13_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR13_U_SMXP_0_1, REGION13_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR13_U_SMXP_0_1, REGION13_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR14_U_SMXP_0_1, 0x13ecf0)
    FIELD(POR_MPU_M7_PRBAR14_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR14_U_SMXP_0_1, REGION14_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR14_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR14_U_SMXP_0_1, REGION14_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR14_U_SMXP_0_1, REGION14_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR14_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR14_U_SMXP_0_1, 0x13ecf8)
    FIELD(POR_MPU_M7_PRLAR14_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR14_U_SMXP_0_1, REGION14_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR14_U_SMXP_0_1, REGION14_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR15_U_SMXP_0_1, 0x13ed00)
    FIELD(POR_MPU_M7_PRBAR15_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR15_U_SMXP_0_1, REGION15_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR15_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR15_U_SMXP_0_1, REGION15_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR15_U_SMXP_0_1, REGION15_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR15_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR15_U_SMXP_0_1, 0x13ed08)
    FIELD(POR_MPU_M7_PRLAR15_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR15_U_SMXP_0_1, REGION15_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR15_U_SMXP_0_1, REGION15_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR16_U_SMXP_0_1, 0x13ed10)
    FIELD(POR_MPU_M7_PRBAR16_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR16_U_SMXP_0_1, REGION16_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR16_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR16_U_SMXP_0_1, REGION16_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR16_U_SMXP_0_1, REGION16_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR16_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR16_U_SMXP_0_1, 0x13ed18)
    FIELD(POR_MPU_M7_PRLAR16_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR16_U_SMXP_0_1, REGION16_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR16_U_SMXP_0_1, REGION16_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR17_U_SMXP_0_1, 0x13ed20)
    FIELD(POR_MPU_M7_PRBAR17_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR17_U_SMXP_0_1, REGION17_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR17_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR17_U_SMXP_0_1, REGION17_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR17_U_SMXP_0_1, REGION17_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR17_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR17_U_SMXP_0_1, 0x13ed28)
    FIELD(POR_MPU_M7_PRLAR17_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR17_U_SMXP_0_1, REGION17_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR17_U_SMXP_0_1, REGION17_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR18_U_SMXP_0_1, 0x13ed30)
    FIELD(POR_MPU_M7_PRBAR18_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR18_U_SMXP_0_1, REGION18_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR18_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR18_U_SMXP_0_1, REGION18_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR18_U_SMXP_0_1, REGION18_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR18_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR18_U_SMXP_0_1, 0x13ed38)
    FIELD(POR_MPU_M7_PRLAR18_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR18_U_SMXP_0_1, REGION18_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR18_U_SMXP_0_1, REGION18_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR19_U_SMXP_0_1, 0x13ed40)
    FIELD(POR_MPU_M7_PRBAR19_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR19_U_SMXP_0_1, REGION19_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR19_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR19_U_SMXP_0_1, REGION19_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR19_U_SMXP_0_1, REGION19_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR19_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR19_U_SMXP_0_1, 0x13ed48)
    FIELD(POR_MPU_M7_PRLAR19_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR19_U_SMXP_0_1, REGION19_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR19_U_SMXP_0_1, REGION19_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR20_U_SMXP_0_1, 0x13ed50)
    FIELD(POR_MPU_M7_PRBAR20_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR20_U_SMXP_0_1, REGION20_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR20_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR20_U_SMXP_0_1, REGION20_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR20_U_SMXP_0_1, REGION20_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR20_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR20_U_SMXP_0_1, 0x13ed58)
    FIELD(POR_MPU_M7_PRLAR20_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR20_U_SMXP_0_1, REGION20_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR20_U_SMXP_0_1, REGION20_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR21_U_SMXP_0_1, 0x13ed60)
    FIELD(POR_MPU_M7_PRBAR21_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR21_U_SMXP_0_1, REGION21_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR21_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR21_U_SMXP_0_1, REGION21_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR21_U_SMXP_0_1, REGION21_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR21_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR21_U_SMXP_0_1, 0x13ed68)
    FIELD(POR_MPU_M7_PRLAR21_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR21_U_SMXP_0_1, REGION21_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR21_U_SMXP_0_1, REGION21_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR22_U_SMXP_0_1, 0x13ed70)
    FIELD(POR_MPU_M7_PRBAR22_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR22_U_SMXP_0_1, REGION22_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR22_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR22_U_SMXP_0_1, REGION22_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR22_U_SMXP_0_1, REGION22_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR22_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR22_U_SMXP_0_1, 0x13ed78)
    FIELD(POR_MPU_M7_PRLAR22_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR22_U_SMXP_0_1, REGION22_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR22_U_SMXP_0_1, REGION22_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR23_U_SMXP_0_1, 0x13ed80)
    FIELD(POR_MPU_M7_PRBAR23_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR23_U_SMXP_0_1, REGION23_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR23_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR23_U_SMXP_0_1, REGION23_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR23_U_SMXP_0_1, REGION23_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR23_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR23_U_SMXP_0_1, 0x13ed88)
    FIELD(POR_MPU_M7_PRLAR23_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR23_U_SMXP_0_1, REGION23_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR23_U_SMXP_0_1, REGION23_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR24_U_SMXP_0_1, 0x13ed90)
    FIELD(POR_MPU_M7_PRBAR24_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR24_U_SMXP_0_1, REGION24_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR24_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR24_U_SMXP_0_1, REGION24_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR24_U_SMXP_0_1, REGION24_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR24_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR24_U_SMXP_0_1, 0x13ed98)
    FIELD(POR_MPU_M7_PRLAR24_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR24_U_SMXP_0_1, REGION24_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR24_U_SMXP_0_1, REGION24_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR25_U_SMXP_0_1, 0x13eda0)
    FIELD(POR_MPU_M7_PRBAR25_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR25_U_SMXP_0_1, REGION25_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR25_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR25_U_SMXP_0_1, REGION25_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR25_U_SMXP_0_1, REGION25_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR25_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR25_U_SMXP_0_1, 0x13eda8)
    FIELD(POR_MPU_M7_PRLAR25_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR25_U_SMXP_0_1, REGION25_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR25_U_SMXP_0_1, REGION25_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR26_U_SMXP_0_1, 0x13edb0)
    FIELD(POR_MPU_M7_PRBAR26_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR26_U_SMXP_0_1, REGION26_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR26_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR26_U_SMXP_0_1, REGION26_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR26_U_SMXP_0_1, REGION26_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR26_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR26_U_SMXP_0_1, 0x13edb8)
    FIELD(POR_MPU_M7_PRLAR26_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR26_U_SMXP_0_1, REGION26_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR26_U_SMXP_0_1, REGION26_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR27_U_SMXP_0_1, 0x13edc0)
    FIELD(POR_MPU_M7_PRBAR27_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR27_U_SMXP_0_1, REGION27_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR27_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR27_U_SMXP_0_1, REGION27_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR27_U_SMXP_0_1, REGION27_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR27_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR27_U_SMXP_0_1, 0x13edc8)
    FIELD(POR_MPU_M7_PRLAR27_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR27_U_SMXP_0_1, REGION27_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR27_U_SMXP_0_1, REGION27_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR28_U_SMXP_0_1, 0x13edd0)
    FIELD(POR_MPU_M7_PRBAR28_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR28_U_SMXP_0_1, REGION28_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR28_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR28_U_SMXP_0_1, REGION28_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR28_U_SMXP_0_1, REGION28_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR28_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR28_U_SMXP_0_1, 0x13edd8)
    FIELD(POR_MPU_M7_PRLAR28_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR28_U_SMXP_0_1, REGION28_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR28_U_SMXP_0_1, REGION28_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR29_U_SMXP_0_1, 0x13ede0)
    FIELD(POR_MPU_M7_PRBAR29_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR29_U_SMXP_0_1, REGION29_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR29_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR29_U_SMXP_0_1, REGION29_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR29_U_SMXP_0_1, REGION29_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR29_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR29_U_SMXP_0_1, 0x13ede8)
    FIELD(POR_MPU_M7_PRLAR29_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR29_U_SMXP_0_1, REGION29_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR29_U_SMXP_0_1, REGION29_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR30_U_SMXP_0_1, 0x13edf0)
    FIELD(POR_MPU_M7_PRBAR30_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR30_U_SMXP_0_1, REGION30_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR30_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR30_U_SMXP_0_1, REGION30_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR30_U_SMXP_0_1, REGION30_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR30_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR30_U_SMXP_0_1, 0x13edf8)
    FIELD(POR_MPU_M7_PRLAR30_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR30_U_SMXP_0_1, REGION30_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR30_U_SMXP_0_1, REGION30_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR31_U_SMXP_0_1, 0x13ee00)
    FIELD(POR_MPU_M7_PRBAR31_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR31_U_SMXP_0_1, REGION31_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR31_U_SMXP_0_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR31_U_SMXP_0_1, REGION31_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR31_U_SMXP_0_1, REGION31_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR31_U_SMXP_0_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR31_U_SMXP_0_1, 0x13ee08)
    FIELD(POR_MPU_M7_PRLAR31_U_SMXP_0_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR31_U_SMXP_0_1, REGION31_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR31_U_SMXP_0_1, REGION31_EN, 0, 1)
REG32(POR_RNSAM_NODE_INFO_U_RNFBESAM_NID12, 0x168000)
    FIELD(POR_RNSAM_NODE_INFO_U_RNFBESAM_NID12, RESERVED_48, 48, 16)
    FIELD(POR_RNSAM_NODE_INFO_U_RNFBESAM_NID12, LOGICAL_ID, 32, 16)
    FIELD(POR_RNSAM_NODE_INFO_U_RNFBESAM_NID12, NODE_ID, 16, 16)
    FIELD(POR_RNSAM_NODE_INFO_U_RNFBESAM_NID12, NODE_TYPE, 0, 16)
REG32(POR_RNSAM_CHILD_INFO_U_RNFBESAM_NID12, 0x168080)
    FIELD(POR_RNSAM_CHILD_INFO_U_RNFBESAM_NID12, RESERVED_32, 32, 32)
    FIELD(POR_RNSAM_CHILD_INFO_U_RNFBESAM_NID12, CHILD_PTR_OFFSET, 16, 16)
    FIELD(POR_RNSAM_CHILD_INFO_U_RNFBESAM_NID12, CHILD_COUNT, 0, 16)
REG32(POR_RNSAM_UNIT_INFO_U_RNFBESAM_NID12, 0x168900)
    FIELD(POR_RNSAM_UNIT_INFO_U_RNFBESAM_NID12, RESERVED_37, 37, 27)
    FIELD(POR_RNSAM_UNIT_INFO_U_RNFBESAM_NID12, NUM_NON_HASH_GROUP, 32, 5)
    FIELD(POR_RNSAM_UNIT_INFO_U_RNFBESAM_NID12, RESERVED_20, 20, 12)
    FIELD(POR_RNSAM_UNIT_INFO_U_RNFBESAM_NID12, NUM_SYS_CACHE_GROUP, 16, 4)
    FIELD(POR_RNSAM_UNIT_INFO_U_RNFBESAM_NID12, NUM_HNF, 0, 8)
REG32(POR_RNSAM_SECURE_REGISTER_GROUPS_OVERRIDE_U_RNFBESAM_NID12, 0x168980)
    FIELD(POR_RNSAM_SECURE_REGISTER_GROUPS_OVERRIDE_U_RNFBESAM_NID12, MEM_RANGE, 0, 1)
REG32(RNSAM_STATUS_U_RNFBESAM_NID12, 0x168c00)
    FIELD(RNSAM_STATUS_U_RNFBESAM_NID12, NSTALL_REQ, 1, 1)
    FIELD(RNSAM_STATUS_U_RNFBESAM_NID12, USE_DEFAULT_NODE, 0, 1)
REG32(NON_HASH_MEM_REGION_REG0_U_RNFBESAM_NID12, 0x168c08)
    FIELD(NON_HASH_MEM_REGION_REG0_U_RNFBESAM_NID12, RESERVED_63, 63, 1)
    FIELD(NON_HASH_MEM_REGION_REG0_U_RNFBESAM_NID12, REGION1_BASE_ADDR, 41, 22)
    FIELD(NON_HASH_MEM_REGION_REG0_U_RNFBESAM_NID12, REGION1_SIZE, 36, 5)
    FIELD(NON_HASH_MEM_REGION_REG0_U_RNFBESAM_NID12, REGION1_TARGET_TYPE, 34, 2)
    FIELD(NON_HASH_MEM_REGION_REG0_U_RNFBESAM_NID12, RESERVED_33, 33, 1)
    FIELD(NON_HASH_MEM_REGION_REG0_U_RNFBESAM_NID12, REGION1_VALID, 32, 1)
    FIELD(NON_HASH_MEM_REGION_REG0_U_RNFBESAM_NID12, RESERVED_31, 31, 1)
    FIELD(NON_HASH_MEM_REGION_REG0_U_RNFBESAM_NID12, REGION0_BASE_ADDR, 9, 22)
    FIELD(NON_HASH_MEM_REGION_REG0_U_RNFBESAM_NID12, REGION0_SIZE, 4, 5)
    FIELD(NON_HASH_MEM_REGION_REG0_U_RNFBESAM_NID12, REGION0_TARGET_TYPE, 2, 2)
    FIELD(NON_HASH_MEM_REGION_REG0_U_RNFBESAM_NID12, REGION0_VALID, 0, 1)
REG32(NON_HASH_MEM_REGION_REG1_U_RNFBESAM_NID12, 0x168c10)
    FIELD(NON_HASH_MEM_REGION_REG1_U_RNFBESAM_NID12, RESERVED_63, 63, 1)
    FIELD(NON_HASH_MEM_REGION_REG1_U_RNFBESAM_NID12, REGION3_BASE_ADDR, 41, 22)
    FIELD(NON_HASH_MEM_REGION_REG1_U_RNFBESAM_NID12, REGION3_SIZE, 36, 5)
    FIELD(NON_HASH_MEM_REGION_REG1_U_RNFBESAM_NID12, REGION3_TARGET_TYPE, 34, 2)
    FIELD(NON_HASH_MEM_REGION_REG1_U_RNFBESAM_NID12, RESERVED_33, 33, 1)
    FIELD(NON_HASH_MEM_REGION_REG1_U_RNFBESAM_NID12, REGION3_VALID, 32, 1)
    FIELD(NON_HASH_MEM_REGION_REG1_U_RNFBESAM_NID12, RESERVED_31, 31, 1)
    FIELD(NON_HASH_MEM_REGION_REG1_U_RNFBESAM_NID12, REGION2_BASE_ADDR, 9, 22)
    FIELD(NON_HASH_MEM_REGION_REG1_U_RNFBESAM_NID12, REGION2_SIZE, 4, 5)
    FIELD(NON_HASH_MEM_REGION_REG1_U_RNFBESAM_NID12, REGION2_TARGET_TYPE, 2, 2)
    FIELD(NON_HASH_MEM_REGION_REG1_U_RNFBESAM_NID12, REGION2_VALID, 0, 1)
REG32(NON_HASH_MEM_REGION_REG2_U_RNFBESAM_NID12, 0x168c18)
    FIELD(NON_HASH_MEM_REGION_REG2_U_RNFBESAM_NID12, RESERVED_63, 63, 1)
    FIELD(NON_HASH_MEM_REGION_REG2_U_RNFBESAM_NID12, REGION5_BASE_ADDR, 41, 22)
    FIELD(NON_HASH_MEM_REGION_REG2_U_RNFBESAM_NID12, REGION5_SIZE, 36, 5)
    FIELD(NON_HASH_MEM_REGION_REG2_U_RNFBESAM_NID12, REGION5_TARGET_TYPE, 34, 2)
    FIELD(NON_HASH_MEM_REGION_REG2_U_RNFBESAM_NID12, RESERVED_33, 33, 1)
    FIELD(NON_HASH_MEM_REGION_REG2_U_RNFBESAM_NID12, REGION5_VALID, 32, 1)
    FIELD(NON_HASH_MEM_REGION_REG2_U_RNFBESAM_NID12, RESERVED_31, 31, 1)
    FIELD(NON_HASH_MEM_REGION_REG2_U_RNFBESAM_NID12, REGION4_BASE_ADDR, 9, 22)
    FIELD(NON_HASH_MEM_REGION_REG2_U_RNFBESAM_NID12, REGION4_SIZE, 4, 5)
    FIELD(NON_HASH_MEM_REGION_REG2_U_RNFBESAM_NID12, REGION4_TARGET_TYPE, 2, 2)
    FIELD(NON_HASH_MEM_REGION_REG2_U_RNFBESAM_NID12, REGION4_VALID, 0, 1)
REG32(NON_HASH_MEM_REGION_REG3_U_RNFBESAM_NID12, 0x168c20)
    FIELD(NON_HASH_MEM_REGION_REG3_U_RNFBESAM_NID12, RESERVED_63, 63, 1)
    FIELD(NON_HASH_MEM_REGION_REG3_U_RNFBESAM_NID12, REGION7_BASE_ADDR, 41, 22)
    FIELD(NON_HASH_MEM_REGION_REG3_U_RNFBESAM_NID12, REGION7_SIZE, 36, 5)
    FIELD(NON_HASH_MEM_REGION_REG3_U_RNFBESAM_NID12, REGION7_TARGET_TYPE, 34, 2)
    FIELD(NON_HASH_MEM_REGION_REG3_U_RNFBESAM_NID12, RESERVED_33, 33, 1)
    FIELD(NON_HASH_MEM_REGION_REG3_U_RNFBESAM_NID12, REGION7_VALID, 32, 1)
    FIELD(NON_HASH_MEM_REGION_REG3_U_RNFBESAM_NID12, RESERVED_31, 31, 1)
    FIELD(NON_HASH_MEM_REGION_REG3_U_RNFBESAM_NID12, REGION6_BASE_ADDR, 9, 22)
    FIELD(NON_HASH_MEM_REGION_REG3_U_RNFBESAM_NID12, REGION6_SIZE, 4, 5)
    FIELD(NON_HASH_MEM_REGION_REG3_U_RNFBESAM_NID12, REGION6_TARGET_TYPE, 2, 2)
    FIELD(NON_HASH_MEM_REGION_REG3_U_RNFBESAM_NID12, REGION6_VALID, 0, 1)
REG32(NON_HASH_TGT_NODEID0_U_RNFBESAM_NID12, 0x168c30)
    FIELD(NON_HASH_TGT_NODEID0_U_RNFBESAM_NID12, RESERVED_47, 47, 17)
    FIELD(NON_HASH_TGT_NODEID0_U_RNFBESAM_NID12, NODEID_3, 36, 11)
    FIELD(NON_HASH_TGT_NODEID0_U_RNFBESAM_NID12, RESERVED_35, 35, 1)
    FIELD(NON_HASH_TGT_NODEID0_U_RNFBESAM_NID12, NODEID_2, 24, 11)
    FIELD(NON_HASH_TGT_NODEID0_U_RNFBESAM_NID12, RESERVED_23, 23, 1)
    FIELD(NON_HASH_TGT_NODEID0_U_RNFBESAM_NID12, NODEID_1, 12, 11)
    FIELD(NON_HASH_TGT_NODEID0_U_RNFBESAM_NID12, RESERVED_11, 11, 1)
    FIELD(NON_HASH_TGT_NODEID0_U_RNFBESAM_NID12, NODEID_0, 0, 11)
REG32(NON_HASH_TGT_NODEID1_U_RNFBESAM_NID12, 0x168c38)
    FIELD(NON_HASH_TGT_NODEID1_U_RNFBESAM_NID12, RESERVED_47, 47, 17)
    FIELD(NON_HASH_TGT_NODEID1_U_RNFBESAM_NID12, NODEID_7, 36, 11)
    FIELD(NON_HASH_TGT_NODEID1_U_RNFBESAM_NID12, RESERVED_35, 35, 1)
    FIELD(NON_HASH_TGT_NODEID1_U_RNFBESAM_NID12, NODEID_6, 24, 11)
    FIELD(NON_HASH_TGT_NODEID1_U_RNFBESAM_NID12, RESERVED_23, 23, 1)
    FIELD(NON_HASH_TGT_NODEID1_U_RNFBESAM_NID12, NODEID_5, 12, 11)
    FIELD(NON_HASH_TGT_NODEID1_U_RNFBESAM_NID12, RESERVED_11, 11, 1)
    FIELD(NON_HASH_TGT_NODEID1_U_RNFBESAM_NID12, NODEID_4, 0, 11)
REG32(NON_HASH_TGT_NODEID2_U_RNFBESAM_NID12, 0x168c40)
    FIELD(NON_HASH_TGT_NODEID2_U_RNFBESAM_NID12, RESERVED_23, 23, 41)
    FIELD(NON_HASH_TGT_NODEID2_U_RNFBESAM_NID12, NODEID_9, 12, 11)
    FIELD(NON_HASH_TGT_NODEID2_U_RNFBESAM_NID12, RESERVED_11, 11, 1)
    FIELD(NON_HASH_TGT_NODEID2_U_RNFBESAM_NID12, NODEID_8, 0, 11)
REG32(SYS_CACHE_GRP_REGION0_U_RNFBESAM_NID12, 0x168c48)
    FIELD(SYS_CACHE_GRP_REGION0_U_RNFBESAM_NID12, RESERVED_63, 63, 1)
    FIELD(SYS_CACHE_GRP_REGION0_U_RNFBESAM_NID12, REGION1_BASE_ADDR, 41, 22)
    FIELD(SYS_CACHE_GRP_REGION0_U_RNFBESAM_NID12, REGION1_SIZE, 36, 5)
    FIELD(SYS_CACHE_GRP_REGION0_U_RNFBESAM_NID12, REGION1_TARGET_TYPE, 34, 2)
    FIELD(SYS_CACHE_GRP_REGION0_U_RNFBESAM_NID12, REGION1_NONHASH_REG_EN, 33, 1)
    FIELD(SYS_CACHE_GRP_REGION0_U_RNFBESAM_NID12, REGION1_VALID, 32, 1)
    FIELD(SYS_CACHE_GRP_REGION0_U_RNFBESAM_NID12, RESERVED_31, 31, 1)
    FIELD(SYS_CACHE_GRP_REGION0_U_RNFBESAM_NID12, REGION0_BASE_ADDR, 9, 22)
    FIELD(SYS_CACHE_GRP_REGION0_U_RNFBESAM_NID12, REGION0_SIZE, 4, 5)
    FIELD(SYS_CACHE_GRP_REGION0_U_RNFBESAM_NID12, REGION0_TARGET_TYPE, 2, 2)
    FIELD(SYS_CACHE_GRP_REGION0_U_RNFBESAM_NID12, REGION0_VALID, 0, 1)
REG32(SYS_CACHE_GRP_REGION1_U_RNFBESAM_NID12, 0x168c50)
    FIELD(SYS_CACHE_GRP_REGION1_U_RNFBESAM_NID12, RESERVED_63, 63, 1)
    FIELD(SYS_CACHE_GRP_REGION1_U_RNFBESAM_NID12, REGION3_BASE_ADDR, 41, 22)
    FIELD(SYS_CACHE_GRP_REGION1_U_RNFBESAM_NID12, REGION3_SIZE, 36, 5)
    FIELD(SYS_CACHE_GRP_REGION1_U_RNFBESAM_NID12, REGION3_TARGET_TYPE, 34, 2)
    FIELD(SYS_CACHE_GRP_REGION1_U_RNFBESAM_NID12, REGION3_NONHASH_REG_EN, 33, 1)
    FIELD(SYS_CACHE_GRP_REGION1_U_RNFBESAM_NID12, REGION3_VALID, 32, 1)
    FIELD(SYS_CACHE_GRP_REGION1_U_RNFBESAM_NID12, RESERVED_31, 31, 1)
    FIELD(SYS_CACHE_GRP_REGION1_U_RNFBESAM_NID12, REGION2_BASE_ADDR, 9, 22)
    FIELD(SYS_CACHE_GRP_REGION1_U_RNFBESAM_NID12, REGION2_SIZE, 4, 5)
    FIELD(SYS_CACHE_GRP_REGION1_U_RNFBESAM_NID12, REGION2_TARGET_TYPE, 2, 2)
    FIELD(SYS_CACHE_GRP_REGION1_U_RNFBESAM_NID12, REGION2_NONHASH_REG_EN, 1, 1)
    FIELD(SYS_CACHE_GRP_REGION1_U_RNFBESAM_NID12, REGION2_VALID, 0, 1)
REG32(SYS_CACHE_GRP_HN_NODEID_REG0_U_RNFBESAM_NID12, 0x168c58)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG0_U_RNFBESAM_NID12, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG0_U_RNFBESAM_NID12, NODEID_3, 36, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG0_U_RNFBESAM_NID12, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG0_U_RNFBESAM_NID12, NODEID_2, 24, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG0_U_RNFBESAM_NID12, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG0_U_RNFBESAM_NID12, NODEID_1, 12, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG0_U_RNFBESAM_NID12, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG0_U_RNFBESAM_NID12, NODEID_0, 0, 11)
REG32(SYS_CACHE_GRP_HN_NODEID_REG1_U_RNFBESAM_NID12, 0x168c60)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG1_U_RNFBESAM_NID12, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG1_U_RNFBESAM_NID12, NODEID_7, 36, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG1_U_RNFBESAM_NID12, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG1_U_RNFBESAM_NID12, NODEID_6, 24, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG1_U_RNFBESAM_NID12, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG1_U_RNFBESAM_NID12, NODEID_5, 12, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG1_U_RNFBESAM_NID12, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG1_U_RNFBESAM_NID12, NODEID_4, 0, 11)
REG32(SYS_CACHE_GRP_HN_NODEID_REG2_U_RNFBESAM_NID12, 0x168c68)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG2_U_RNFBESAM_NID12, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG2_U_RNFBESAM_NID12, NODEID_11, 36, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG2_U_RNFBESAM_NID12, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG2_U_RNFBESAM_NID12, NODEID_10, 24, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG2_U_RNFBESAM_NID12, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG2_U_RNFBESAM_NID12, NODEID_9, 12, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG2_U_RNFBESAM_NID12, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG2_U_RNFBESAM_NID12, NODEID_8, 0, 11)
REG32(SYS_CACHE_GRP_HN_NODEID_REG3_U_RNFBESAM_NID12, 0x168c70)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG3_U_RNFBESAM_NID12, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG3_U_RNFBESAM_NID12, NODEID_15, 36, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG3_U_RNFBESAM_NID12, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG3_U_RNFBESAM_NID12, NODEID_14, 24, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG3_U_RNFBESAM_NID12, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG3_U_RNFBESAM_NID12, NODEID_13, 12, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG3_U_RNFBESAM_NID12, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG3_U_RNFBESAM_NID12, NODEID_12, 0, 11)
REG32(SYS_CACHE_GRP_HN_NODEID_REG4_U_RNFBESAM_NID12, 0x168c78)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG4_U_RNFBESAM_NID12, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG4_U_RNFBESAM_NID12, NODEID_19, 36, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG4_U_RNFBESAM_NID12, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG4_U_RNFBESAM_NID12, NODEID_18, 24, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG4_U_RNFBESAM_NID12, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG4_U_RNFBESAM_NID12, NODEID_17, 12, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG4_U_RNFBESAM_NID12, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG4_U_RNFBESAM_NID12, NODEID_16, 0, 11)
REG32(SYS_CACHE_GRP_HN_NODEID_REG5_U_RNFBESAM_NID12, 0x168c80)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG5_U_RNFBESAM_NID12, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG5_U_RNFBESAM_NID12, NODEID_23, 36, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG5_U_RNFBESAM_NID12, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG5_U_RNFBESAM_NID12, NODEID_22, 24, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG5_U_RNFBESAM_NID12, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG5_U_RNFBESAM_NID12, NODEID_21, 12, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG5_U_RNFBESAM_NID12, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG5_U_RNFBESAM_NID12, NODEID_20, 0, 11)
REG32(SYS_CACHE_GRP_HN_NODEID_REG6_U_RNFBESAM_NID12, 0x168c88)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG6_U_RNFBESAM_NID12, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG6_U_RNFBESAM_NID12, NODEID_27, 36, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG6_U_RNFBESAM_NID12, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG6_U_RNFBESAM_NID12, NODEID_26, 24, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG6_U_RNFBESAM_NID12, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG6_U_RNFBESAM_NID12, NODEID_25, 12, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG6_U_RNFBESAM_NID12, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG6_U_RNFBESAM_NID12, NODEID_24, 0, 11)
REG32(SYS_CACHE_GRP_HN_NODEID_REG7_U_RNFBESAM_NID12, 0x168c90)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG7_U_RNFBESAM_NID12, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG7_U_RNFBESAM_NID12, NODEID_31, 36, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG7_U_RNFBESAM_NID12, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG7_U_RNFBESAM_NID12, NODEID_30, 24, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG7_U_RNFBESAM_NID12, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG7_U_RNFBESAM_NID12, NODEID_29, 12, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG7_U_RNFBESAM_NID12, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG7_U_RNFBESAM_NID12, NODEID_28, 0, 11)
REG32(SYS_CACHE_GRP_NONHASH_NODEID_U_RNFBESAM_NID12, 0x168c98)
    FIELD(SYS_CACHE_GRP_NONHASH_NODEID_U_RNFBESAM_NID12, RESERVED_35, 35, 29)
    FIELD(SYS_CACHE_GRP_NONHASH_NODEID_U_RNFBESAM_NID12, SCG3_NODEID, 24, 11)
    FIELD(SYS_CACHE_GRP_NONHASH_NODEID_U_RNFBESAM_NID12, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_NONHASH_NODEID_U_RNFBESAM_NID12, SCG2_NODEID, 12, 11)
    FIELD(SYS_CACHE_GRP_NONHASH_NODEID_U_RNFBESAM_NID12, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_NONHASH_NODEID_U_RNFBESAM_NID12, SCG1_NODEID, 0, 11)
REG32(SYS_CACHE_GROUP_HN_COUNT_U_RNFBESAM_NID12, 0x168d00)
    FIELD(SYS_CACHE_GROUP_HN_COUNT_U_RNFBESAM_NID12, RESERVED_31, 31, 33)
    FIELD(SYS_CACHE_GROUP_HN_COUNT_U_RNFBESAM_NID12, SCG3_NUM_HNF, 24, 7)
    FIELD(SYS_CACHE_GROUP_HN_COUNT_U_RNFBESAM_NID12, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GROUP_HN_COUNT_U_RNFBESAM_NID12, SCG2_NUM_HNF, 16, 7)
    FIELD(SYS_CACHE_GROUP_HN_COUNT_U_RNFBESAM_NID12, RESERVED_15, 15, 1)
    FIELD(SYS_CACHE_GROUP_HN_COUNT_U_RNFBESAM_NID12, SCG1_NUM_HNF, 8, 7)
    FIELD(SYS_CACHE_GROUP_HN_COUNT_U_RNFBESAM_NID12, SCG0_NUM_HNF, 0, 7)
REG32(SYS_CACHE_GRP_SN_NODEID_REG0_U_RNFBESAM_NID12, 0x168d08)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG0_U_RNFBESAM_NID12, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG0_U_RNFBESAM_NID12, SN_NODEID_3, 36, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG0_U_RNFBESAM_NID12, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG0_U_RNFBESAM_NID12, SN_NODEID_2, 24, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG0_U_RNFBESAM_NID12, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG0_U_RNFBESAM_NID12, SN_NODEID_1, 12, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG0_U_RNFBESAM_NID12, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG0_U_RNFBESAM_NID12, SN_NODEID_0, 0, 11)
REG32(SYS_CACHE_GRP_SN_NODEID_REG1_U_RNFBESAM_NID12, 0x168d10)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG1_U_RNFBESAM_NID12, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG1_U_RNFBESAM_NID12, SN_NODEID_7, 36, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG1_U_RNFBESAM_NID12, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG1_U_RNFBESAM_NID12, SN_NODEID_6, 24, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG1_U_RNFBESAM_NID12, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG1_U_RNFBESAM_NID12, SN_NODEID_5, 12, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG1_U_RNFBESAM_NID12, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG1_U_RNFBESAM_NID12, SN_NODEID_4, 0, 11)
REG32(SYS_CACHE_GRP_SN_NODEID_REG2_U_RNFBESAM_NID12, 0x168d18)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG2_U_RNFBESAM_NID12, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG2_U_RNFBESAM_NID12, SN_NODEID_11, 36, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG2_U_RNFBESAM_NID12, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG2_U_RNFBESAM_NID12, SN_NODEID_10, 24, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG2_U_RNFBESAM_NID12, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG2_U_RNFBESAM_NID12, SN_NODEID_9, 12, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG2_U_RNFBESAM_NID12, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG2_U_RNFBESAM_NID12, SN_NODEID_8, 0, 11)
REG32(SYS_CACHE_GRP_SN_NODEID_REG3_U_RNFBESAM_NID12, 0x168d20)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG3_U_RNFBESAM_NID12, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG3_U_RNFBESAM_NID12, SN_NODEID_15, 36, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG3_U_RNFBESAM_NID12, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG3_U_RNFBESAM_NID12, SN_NODEID_14, 24, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG3_U_RNFBESAM_NID12, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG3_U_RNFBESAM_NID12, SN_NODEID_13, 12, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG3_U_RNFBESAM_NID12, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG3_U_RNFBESAM_NID12, SN_NODEID_12, 0, 11)
REG32(SYS_CACHE_GRP_SN_NODEID_REG4_U_RNFBESAM_NID12, 0x168d28)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG4_U_RNFBESAM_NID12, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG4_U_RNFBESAM_NID12, SN_NODEID_19, 36, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG4_U_RNFBESAM_NID12, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG4_U_RNFBESAM_NID12, SN_NODEID_18, 24, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG4_U_RNFBESAM_NID12, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG4_U_RNFBESAM_NID12, SN_NODEID_17, 12, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG4_U_RNFBESAM_NID12, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG4_U_RNFBESAM_NID12, SN_NODEID_16, 0, 11)
REG32(SYS_CACHE_GRP_SN_NODEID_REG5_U_RNFBESAM_NID12, 0x168d30)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG5_U_RNFBESAM_NID12, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG5_U_RNFBESAM_NID12, SN_NODEID_23, 36, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG5_U_RNFBESAM_NID12, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG5_U_RNFBESAM_NID12, SN_NODEID_22, 24, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG5_U_RNFBESAM_NID12, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG5_U_RNFBESAM_NID12, SN_NODEID_21, 12, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG5_U_RNFBESAM_NID12, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG5_U_RNFBESAM_NID12, SN_NODEID_20, 0, 11)
REG32(SYS_CACHE_GRP_SN_NODEID_REG6_U_RNFBESAM_NID12, 0x168d38)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG6_U_RNFBESAM_NID12, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG6_U_RNFBESAM_NID12, SN_NODEID_27, 36, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG6_U_RNFBESAM_NID12, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG6_U_RNFBESAM_NID12, SN_NODEID_26, 24, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG6_U_RNFBESAM_NID12, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG6_U_RNFBESAM_NID12, SN_NODEID_25, 12, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG6_U_RNFBESAM_NID12, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG6_U_RNFBESAM_NID12, SN_NODEID_24, 0, 11)
REG32(SYS_CACHE_GRP_SN_NODEID_REG7_U_RNFBESAM_NID12, 0x168d40)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG7_U_RNFBESAM_NID12, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG7_U_RNFBESAM_NID12, SN_NODEID_31, 36, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG7_U_RNFBESAM_NID12, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG7_U_RNFBESAM_NID12, SN_NODEID_30, 24, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG7_U_RNFBESAM_NID12, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG7_U_RNFBESAM_NID12, SN_NODEID_29, 12, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG7_U_RNFBESAM_NID12, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG7_U_RNFBESAM_NID12, SN_NODEID_28, 0, 11)
REG32(SYS_CACHE_GRP_SN_SAM_CFG0_U_RNFBESAM_NID12, 0x168d48)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG0_U_RNFBESAM_NID12, RESERVED_46, 46, 18)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG0_U_RNFBESAM_NID12, SCG1_TOP_ADDRESS_BIT2, 40, 6)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG0_U_RNFBESAM_NID12, RESERVED_38, 38, 2)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG0_U_RNFBESAM_NID12, SCG1_TOP_ADDRESS_BIT1, 32, 6)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG0_U_RNFBESAM_NID12, RESERVED_30, 30, 2)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG0_U_RNFBESAM_NID12, SCG1_TOP_ADDRESS_BIT0, 24, 6)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG0_U_RNFBESAM_NID12, RESERVED_22, 22, 2)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG0_U_RNFBESAM_NID12, SCG0_TOP_ADDRESS_BIT2, 16, 6)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG0_U_RNFBESAM_NID12, RESERVED_14, 14, 2)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG0_U_RNFBESAM_NID12, SCG0_TOP_ADDRESS_BIT1, 8, 6)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG0_U_RNFBESAM_NID12, SCG0_TOP_ADDRESS_BIT0, 0, 6)
REG32(SYS_CACHE_GRP_SN_SAM_CFG1_U_RNFBESAM_NID12, 0x168d50)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG1_U_RNFBESAM_NID12, RESERVED_46, 46, 18)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG1_U_RNFBESAM_NID12, SCG3_TOP_ADDRESS_BIT2, 40, 6)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG1_U_RNFBESAM_NID12, RESERVED_38, 38, 2)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG1_U_RNFBESAM_NID12, SCG3_TOP_ADDRESS_BIT1, 32, 6)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG1_U_RNFBESAM_NID12, RESERVED_30, 30, 2)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG1_U_RNFBESAM_NID12, SCG3_TOP_ADDRESS_BIT0, 24, 6)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG1_U_RNFBESAM_NID12, RESERVED_22, 22, 2)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG1_U_RNFBESAM_NID12, SCG2_TOP_ADDRESS_BIT2, 16, 6)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG1_U_RNFBESAM_NID12, RESERVED_14, 14, 2)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG1_U_RNFBESAM_NID12, SCG2_TOP_ADDRESS_BIT1, 8, 6)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG1_U_RNFBESAM_NID12, SCG2_TOP_ADDRESS_BIT0, 0, 6)
REG32(GIC_MEM_REGION_REG_U_RNFBESAM_NID12, 0x168d58)
    FIELD(GIC_MEM_REGION_REG_U_RNFBESAM_NID12, RESERVED_63, 63, 1)
    FIELD(GIC_MEM_REGION_REG_U_RNFBESAM_NID12, GIC_REGION_NODEID, 52, 11)
    FIELD(GIC_MEM_REGION_REG_U_RNFBESAM_NID12, RESERVED_48, 48, 4)
    FIELD(GIC_MEM_REGION_REG_U_RNFBESAM_NID12, GIC_REGION_BASE_ADDR, 16, 32)
    FIELD(GIC_MEM_REGION_REG_U_RNFBESAM_NID12, GIC_REGION_SIZE, 4, 3)
    FIELD(GIC_MEM_REGION_REG_U_RNFBESAM_NID12, GIC_REGION_TARGET_TYPE, 2, 2)
    FIELD(GIC_MEM_REGION_REG_U_RNFBESAM_NID12, GIC_REGION_VALID, 0, 1)
REG32(SYS_CACHE_GRP_SN_ATTR_U_RNFBESAM_NID12, 0x168d60)
    FIELD(SYS_CACHE_GRP_SN_ATTR_U_RNFBESAM_NID12, RESERVED_54, 54, 10)
    FIELD(SYS_CACHE_GRP_SN_ATTR_U_RNFBESAM_NID12, SN_MODE_SYS_CACHE_GRP3, 52, 2)
    FIELD(SYS_CACHE_GRP_SN_ATTR_U_RNFBESAM_NID12, RESERVED_49, 49, 3)
    FIELD(SYS_CACHE_GRP_SN_ATTR_U_RNFBESAM_NID12, INV_TOP_ADDRESS_BIT_SYS_CACHE_GRP3, 48, 1)
    FIELD(SYS_CACHE_GRP_SN_ATTR_U_RNFBESAM_NID12, RESERVED_38, 38, 10)
    FIELD(SYS_CACHE_GRP_SN_ATTR_U_RNFBESAM_NID12, SN_MODE_SYS_CACHE_GRP2, 36, 2)
    FIELD(SYS_CACHE_GRP_SN_ATTR_U_RNFBESAM_NID12, RESERVED_33, 33, 3)
    FIELD(SYS_CACHE_GRP_SN_ATTR_U_RNFBESAM_NID12, INV_TOP_ADDRESS_BIT_SYS_CACHE_GRP2, 32, 1)
    FIELD(SYS_CACHE_GRP_SN_ATTR_U_RNFBESAM_NID12, RESERVED_22, 22, 10)
    FIELD(SYS_CACHE_GRP_SN_ATTR_U_RNFBESAM_NID12, SN_MODE_SYS_CACHE_GRP1, 20, 2)
    FIELD(SYS_CACHE_GRP_SN_ATTR_U_RNFBESAM_NID12, RESERVED_17, 17, 3)
    FIELD(SYS_CACHE_GRP_SN_ATTR_U_RNFBESAM_NID12, INV_TOP_ADDRESS_BIT_SYS_CACHE_GRP1, 16, 1)
    FIELD(SYS_CACHE_GRP_SN_ATTR_U_RNFBESAM_NID12, SN_MODE_SYS_CACHE_GRP0, 4, 2)
    FIELD(SYS_CACHE_GRP_SN_ATTR_U_RNFBESAM_NID12, INV_TOP_ADDRESS_BIT_SYS_CACHE_GRP0, 0, 1)
REG32(SYS_CACHE_GRP_HN_CPA_EN_REG_U_RNFBESAM_NID12, 0x168d68)
REG32(SYS_CACHE_GRP_HN_CPA_GRP_REG_U_RNFBESAM_NID12, 0x168d70)
    FIELD(SYS_CACHE_GRP_HN_CPA_GRP_REG_U_RNFBESAM_NID12, RESERVED_50, 50, 14)
    FIELD(SYS_CACHE_GRP_HN_CPA_GRP_REG_U_RNFBESAM_NID12, CPA_GRP_SCG3, 48, 2)
    FIELD(SYS_CACHE_GRP_HN_CPA_GRP_REG_U_RNFBESAM_NID12, RESERVED_34, 34, 14)
    FIELD(SYS_CACHE_GRP_HN_CPA_GRP_REG_U_RNFBESAM_NID12, CPA_GRP_SCG2, 32, 2)
    FIELD(SYS_CACHE_GRP_HN_CPA_GRP_REG_U_RNFBESAM_NID12, RESERVED_18, 18, 14)
    FIELD(SYS_CACHE_GRP_HN_CPA_GRP_REG_U_RNFBESAM_NID12, CPA_GRP_SCG1, 16, 2)
    FIELD(SYS_CACHE_GRP_HN_CPA_GRP_REG_U_RNFBESAM_NID12, CPA_GRP_SCG0, 0, 2)
REG32(CML_PORT_AGGR_MODE_CTRL_REG_U_RNFBESAM_NID12, 0x168e00)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNFBESAM_NID12, RESERVED_32, 32, 32)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNFBESAM_NID12, REGION7_PAG_GRPID, 30, 2)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNFBESAM_NID12, RESERVED_29, 29, 1)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNFBESAM_NID12, REGION7_PAG_EN, 28, 1)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNFBESAM_NID12, RESERVED_27, 27, 1)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNFBESAM_NID12, REGION6_PAG_GRPID, 25, 2)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNFBESAM_NID12, REGION6_PAG_EN, 24, 1)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNFBESAM_NID12, RESERVED_23, 23, 1)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNFBESAM_NID12, REGION5_PAG_GRPID, 21, 2)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNFBESAM_NID12, REGION5_PAG_EN, 20, 1)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNFBESAM_NID12, RESERVED_19, 19, 1)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNFBESAM_NID12, REGION4_PAG_GRPID, 17, 2)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNFBESAM_NID12, REGION4_PAG_EN, 16, 1)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNFBESAM_NID12, RESERVED_15, 15, 1)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNFBESAM_NID12, REGION3_PAG_GRPID, 13, 2)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNFBESAM_NID12, REGION3_PAG_EN, 12, 1)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNFBESAM_NID12, RESERVED_11, 11, 1)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNFBESAM_NID12, REGION2_PAG_GRPID, 9, 2)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNFBESAM_NID12, REGION2_PAG_EN, 8, 1)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNFBESAM_NID12, REGION1_PAG_GRPID, 5, 2)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNFBESAM_NID12, REGION1_PAG_EN, 4, 1)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNFBESAM_NID12, REGION0_PAG_GRPID, 1, 2)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNFBESAM_NID12, REGION0_PAG_EN, 0, 1)
REG32(CML_PORT_AGGR_GRP0_ADD_MASK_U_RNFBESAM_NID12, 0x168e08)
    FIELD(CML_PORT_AGGR_GRP0_ADD_MASK_U_RNFBESAM_NID12, RESERVED_48, 48, 16)
    FIELD(CML_PORT_AGGR_GRP0_ADD_MASK_U_RNFBESAM_NID12, ADDR_MASK, 6, 42)
    FIELD(CML_PORT_AGGR_GRP0_ADD_MASK_U_RNFBESAM_NID12, RESERVED_0, 0, 6)
REG32(CML_PORT_AGGR_GRP1_ADD_MASK_U_RNFBESAM_NID12, 0x168e10)
    FIELD(CML_PORT_AGGR_GRP1_ADD_MASK_U_RNFBESAM_NID12, RESERVED_48, 48, 16)
    FIELD(CML_PORT_AGGR_GRP1_ADD_MASK_U_RNFBESAM_NID12, ADDR_MASK, 6, 42)
    FIELD(CML_PORT_AGGR_GRP1_ADD_MASK_U_RNFBESAM_NID12, RESERVED_0, 0, 6)
REG32(CML_PORT_AGGR_GRP0_REG_U_RNFBESAM_NID12, 0x168e40)
    FIELD(CML_PORT_AGGR_GRP0_REG_U_RNFBESAM_NID12, RESERVED_50, 50, 14)
    FIELD(CML_PORT_AGGR_GRP0_REG_U_RNFBESAM_NID12, NUM_CXG_PAG0, 48, 2)
    FIELD(CML_PORT_AGGR_GRP0_REG_U_RNFBESAM_NID12, RESERVED_47, 47, 1)
    FIELD(CML_PORT_AGGR_GRP0_REG_U_RNFBESAM_NID12, PAG0_TGTID3, 36, 11)
    FIELD(CML_PORT_AGGR_GRP0_REG_U_RNFBESAM_NID12, RESERVED_35, 35, 1)
    FIELD(CML_PORT_AGGR_GRP0_REG_U_RNFBESAM_NID12, PAG0_TGTID2, 24, 11)
    FIELD(CML_PORT_AGGR_GRP0_REG_U_RNFBESAM_NID12, RESERVED_23, 23, 1)
    FIELD(CML_PORT_AGGR_GRP0_REG_U_RNFBESAM_NID12, PAG0_TGTID1, 12, 11)
    FIELD(CML_PORT_AGGR_GRP0_REG_U_RNFBESAM_NID12, RESERVED_11, 11, 1)
    FIELD(CML_PORT_AGGR_GRP0_REG_U_RNFBESAM_NID12, PAG0_TGTID0, 0, 11)
REG32(CML_PORT_AGGR_GRP1_REG_U_RNFBESAM_NID12, 0x168e48)
    FIELD(CML_PORT_AGGR_GRP1_REG_U_RNFBESAM_NID12, RESERVED_50, 50, 14)
    FIELD(CML_PORT_AGGR_GRP1_REG_U_RNFBESAM_NID12, NUM_CXG_PAG1, 48, 2)
    FIELD(CML_PORT_AGGR_GRP1_REG_U_RNFBESAM_NID12, RESERVED_47, 47, 1)
    FIELD(CML_PORT_AGGR_GRP1_REG_U_RNFBESAM_NID12, PAG1_TGTID3, 36, 11)
    FIELD(CML_PORT_AGGR_GRP1_REG_U_RNFBESAM_NID12, RESERVED_35, 35, 1)
    FIELD(CML_PORT_AGGR_GRP1_REG_U_RNFBESAM_NID12, PAG1_TGTID2, 24, 11)
    FIELD(CML_PORT_AGGR_GRP1_REG_U_RNFBESAM_NID12, RESERVED_23, 23, 1)
    FIELD(CML_PORT_AGGR_GRP1_REG_U_RNFBESAM_NID12, PAG1_TGTID1, 12, 11)
    FIELD(CML_PORT_AGGR_GRP1_REG_U_RNFBESAM_NID12, RESERVED_11, 11, 1)
    FIELD(CML_PORT_AGGR_GRP1_REG_U_RNFBESAM_NID12, PAG1_TGTID0, 0, 11)
REG32(SYS_CACHE_GRP_SECONDARY_REG0_U_RNFBESAM_NID12, 0x168f00)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG0_U_RNFBESAM_NID12, RESERVED_63, 63, 1)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG0_U_RNFBESAM_NID12, REGION1_SCNDRY_BASE_ADDR, 41, 22)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG0_U_RNFBESAM_NID12, REGION1_SCNDRY_SIZE, 36, 5)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG0_U_RNFBESAM_NID12, REGION1_SCNDRY_TARGET_TYPE, 34, 2)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG0_U_RNFBESAM_NID12, RESERVED_33, 33, 1)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG0_U_RNFBESAM_NID12, REGION1_SCNDRY_VALID, 32, 1)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG0_U_RNFBESAM_NID12, RESERVED_31, 31, 1)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG0_U_RNFBESAM_NID12, REGION0_SCNDRY_BASE_ADDR, 9, 22)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG0_U_RNFBESAM_NID12, REGION0_SCNDRY_SIZE, 4, 5)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG0_U_RNFBESAM_NID12, REGION0_SCNDRY_TARGET_TYPE, 2, 2)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG0_U_RNFBESAM_NID12, REGION0_SCNDRY_VALID, 0, 1)
REG32(SYS_CACHE_GRP_SECONDARY_REG1_U_RNFBESAM_NID12, 0x168f08)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG1_U_RNFBESAM_NID12, RESERVED_63, 63, 1)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG1_U_RNFBESAM_NID12, REGION3_SCNDRY_BASE_ADDR, 41, 22)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG1_U_RNFBESAM_NID12, REGION3_SCNDRY_SIZE, 36, 5)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG1_U_RNFBESAM_NID12, REGION3_SCNDRY_TARGET_TYPE, 34, 2)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG1_U_RNFBESAM_NID12, RESERVED_33, 33, 1)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG1_U_RNFBESAM_NID12, REGION3_SCNDRY_VALID, 32, 1)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG1_U_RNFBESAM_NID12, RESERVED_31, 31, 1)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG1_U_RNFBESAM_NID12, REGION2_SCNDRY_BASE_ADDR, 9, 22)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG1_U_RNFBESAM_NID12, REGION2_SCNDRY_SIZE, 4, 5)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG1_U_RNFBESAM_NID12, REGION2_SCNDRY_TARGET_TYPE, 2, 2)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG1_U_RNFBESAM_NID12, REGION2_SCNDRY_VALID, 0, 1)
REG32(SYS_CACHE_GRP_CAL_MODE_REG_U_RNFBESAM_NID12, 0x168f10)
    FIELD(SYS_CACHE_GRP_CAL_MODE_REG_U_RNFBESAM_NID12, RESERVED_49, 49, 15)
    FIELD(SYS_CACHE_GRP_CAL_MODE_REG_U_RNFBESAM_NID12, SCG3_HNF_CAL_MODE_EN, 48, 1)
    FIELD(SYS_CACHE_GRP_CAL_MODE_REG_U_RNFBESAM_NID12, RESERVED_33, 33, 15)
    FIELD(SYS_CACHE_GRP_CAL_MODE_REG_U_RNFBESAM_NID12, SCG2_HNF_CAL_MODE_EN, 32, 1)
    FIELD(SYS_CACHE_GRP_CAL_MODE_REG_U_RNFBESAM_NID12, RESERVED_17, 17, 15)
    FIELD(SYS_CACHE_GRP_CAL_MODE_REG_U_RNFBESAM_NID12, SCG1_HNF_CAL_MODE_EN, 16, 1)
    FIELD(SYS_CACHE_GRP_CAL_MODE_REG_U_RNFBESAM_NID12, SCG0_HNF_CAL_MODE_EN, 0, 1)
REG32(RNSAM_HASH_ADDR_MASK_REG_U_RNFBESAM_NID12, 0x168f18)
    FIELD(RNSAM_HASH_ADDR_MASK_REG_U_RNFBESAM_NID12, RESERVED_48, 48, 16)
    FIELD(RNSAM_HASH_ADDR_MASK_REG_U_RNFBESAM_NID12, ADDR_MASK, 6, 42)
    FIELD(RNSAM_HASH_ADDR_MASK_REG_U_RNFBESAM_NID12, RESERVED_0, 0, 6)
REG32(RNSAM_REGION_CMP_ADDR_MASK_REG_U_RNFBESAM_NID12, 0x168f20)
    FIELD(RNSAM_REGION_CMP_ADDR_MASK_REG_U_RNFBESAM_NID12, RESERVED_48, 48, 16)
    FIELD(RNSAM_REGION_CMP_ADDR_MASK_REG_U_RNFBESAM_NID12, ADDR_MASK, 16, 32)
    FIELD(RNSAM_REGION_CMP_ADDR_MASK_REG_U_RNFBESAM_NID12, RESERVED_0, 0, 16)
REG32(SYS_CACHE_GRP_HN_NODEID_REG8_U_RNFBESAM_NID12, 0x168f58)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG8_U_RNFBESAM_NID12, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG8_U_RNFBESAM_NID12, NODEID_35, 36, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG8_U_RNFBESAM_NID12, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG8_U_RNFBESAM_NID12, NODEID_34, 24, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG8_U_RNFBESAM_NID12, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG8_U_RNFBESAM_NID12, NODEID_33, 12, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG8_U_RNFBESAM_NID12, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG8_U_RNFBESAM_NID12, NODEID_32, 0, 11)
REG32(SYS_CACHE_GRP_HN_NODEID_REG9_U_RNFBESAM_NID12, 0x168f60)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG9_U_RNFBESAM_NID12, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG9_U_RNFBESAM_NID12, NODEID_39, 36, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG9_U_RNFBESAM_NID12, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG9_U_RNFBESAM_NID12, NODEID_38, 24, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG9_U_RNFBESAM_NID12, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG9_U_RNFBESAM_NID12, NODEID_37, 12, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG9_U_RNFBESAM_NID12, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG9_U_RNFBESAM_NID12, NODEID_36, 0, 11)
REG32(SYS_CACHE_GRP_HN_NODEID_REG10_U_RNFBESAM_NID12, 0x168f68)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG10_U_RNFBESAM_NID12, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG10_U_RNFBESAM_NID12, NODEID_43, 36, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG10_U_RNFBESAM_NID12, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG10_U_RNFBESAM_NID12, NODEID_42, 24, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG10_U_RNFBESAM_NID12, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG10_U_RNFBESAM_NID12, NODEID_41, 12, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG10_U_RNFBESAM_NID12, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG10_U_RNFBESAM_NID12, NODEID_40, 0, 11)
REG32(SYS_CACHE_GRP_HN_NODEID_REG11_U_RNFBESAM_NID12, 0x168f70)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG11_U_RNFBESAM_NID12, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG11_U_RNFBESAM_NID12, NODEID_47, 36, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG11_U_RNFBESAM_NID12, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG11_U_RNFBESAM_NID12, NODEID_46, 24, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG11_U_RNFBESAM_NID12, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG11_U_RNFBESAM_NID12, NODEID_45, 12, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG11_U_RNFBESAM_NID12, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG11_U_RNFBESAM_NID12, NODEID_44, 0, 11)
REG32(SYS_CACHE_GRP_HN_NODEID_REG12_U_RNFBESAM_NID12, 0x168f78)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG12_U_RNFBESAM_NID12, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG12_U_RNFBESAM_NID12, NODEID_51, 36, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG12_U_RNFBESAM_NID12, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG12_U_RNFBESAM_NID12, NODEID_50, 24, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG12_U_RNFBESAM_NID12, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG12_U_RNFBESAM_NID12, NODEID_49, 12, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG12_U_RNFBESAM_NID12, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG12_U_RNFBESAM_NID12, NODEID_48, 0, 11)
REG32(SYS_CACHE_GRP_HN_NODEID_REG13_U_RNFBESAM_NID12, 0x168f80)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG13_U_RNFBESAM_NID12, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG13_U_RNFBESAM_NID12, NODEID_55, 36, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG13_U_RNFBESAM_NID12, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG13_U_RNFBESAM_NID12, NODEID_54, 24, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG13_U_RNFBESAM_NID12, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG13_U_RNFBESAM_NID12, NODEID_53, 12, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG13_U_RNFBESAM_NID12, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG13_U_RNFBESAM_NID12, NODEID_52, 0, 11)
REG32(SYS_CACHE_GRP_HN_NODEID_REG14_U_RNFBESAM_NID12, 0x168f88)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG14_U_RNFBESAM_NID12, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG14_U_RNFBESAM_NID12, NODEID_59, 36, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG14_U_RNFBESAM_NID12, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG14_U_RNFBESAM_NID12, NODEID_58, 24, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG14_U_RNFBESAM_NID12, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG14_U_RNFBESAM_NID12, NODEID_57, 12, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG14_U_RNFBESAM_NID12, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG14_U_RNFBESAM_NID12, NODEID_56, 0, 11)
REG32(SYS_CACHE_GRP_HN_NODEID_REG15_U_RNFBESAM_NID12, 0x168f90)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG15_U_RNFBESAM_NID12, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG15_U_RNFBESAM_NID12, NODEID_63, 36, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG15_U_RNFBESAM_NID12, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG15_U_RNFBESAM_NID12, NODEID_62, 24, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG15_U_RNFBESAM_NID12, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG15_U_RNFBESAM_NID12, NODEID_61, 12, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG15_U_RNFBESAM_NID12, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG15_U_RNFBESAM_NID12, NODEID_60, 0, 11)
REG32(SYS_CACHE_GRP_SN_NODEID_REG8_U_RNFBESAM_NID12, 0x169008)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG8_U_RNFBESAM_NID12, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG8_U_RNFBESAM_NID12, SN_NODEID_35, 36, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG8_U_RNFBESAM_NID12, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG8_U_RNFBESAM_NID12, SN_NODEID_34, 24, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG8_U_RNFBESAM_NID12, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG8_U_RNFBESAM_NID12, SN_NODEID_33, 12, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG8_U_RNFBESAM_NID12, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG8_U_RNFBESAM_NID12, SN_NODEID_32, 0, 11)
REG32(SYS_CACHE_GRP_SN_NODEID_REG9_U_RNFBESAM_NID12, 0x169010)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG9_U_RNFBESAM_NID12, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG9_U_RNFBESAM_NID12, SN_NODEID_39, 36, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG9_U_RNFBESAM_NID12, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG9_U_RNFBESAM_NID12, SN_NODEID_38, 24, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG9_U_RNFBESAM_NID12, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG9_U_RNFBESAM_NID12, SN_NODEID_37, 12, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG9_U_RNFBESAM_NID12, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG9_U_RNFBESAM_NID12, SN_NODEID_36, 0, 11)
REG32(SYS_CACHE_GRP_SN_NODEID_REG10_U_RNFBESAM_NID12, 0x169018)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG10_U_RNFBESAM_NID12, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG10_U_RNFBESAM_NID12, SN_NODEID_43, 36, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG10_U_RNFBESAM_NID12, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG10_U_RNFBESAM_NID12, SN_NODEID_42, 24, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG10_U_RNFBESAM_NID12, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG10_U_RNFBESAM_NID12, SN_NODEID_41, 12, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG10_U_RNFBESAM_NID12, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG10_U_RNFBESAM_NID12, SN_NODEID_40, 0, 11)
REG32(SYS_CACHE_GRP_SN_NODEID_REG11_U_RNFBESAM_NID12, 0x169020)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG11_U_RNFBESAM_NID12, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG11_U_RNFBESAM_NID12, SN_NODEID_47, 36, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG11_U_RNFBESAM_NID12, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG11_U_RNFBESAM_NID12, SN_NODEID_46, 24, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG11_U_RNFBESAM_NID12, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG11_U_RNFBESAM_NID12, SN_NODEID_45, 12, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG11_U_RNFBESAM_NID12, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG11_U_RNFBESAM_NID12, SN_NODEID_44, 0, 11)
REG32(SYS_CACHE_GRP_SN_NODEID_REG12_U_RNFBESAM_NID12, 0x169028)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG12_U_RNFBESAM_NID12, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG12_U_RNFBESAM_NID12, SN_NODEID_51, 36, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG12_U_RNFBESAM_NID12, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG12_U_RNFBESAM_NID12, SN_NODEID_50, 24, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG12_U_RNFBESAM_NID12, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG12_U_RNFBESAM_NID12, SN_NODEID_49, 12, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG12_U_RNFBESAM_NID12, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG12_U_RNFBESAM_NID12, SN_NODEID_48, 0, 11)
REG32(SYS_CACHE_GRP_SN_NODEID_REG13_U_RNFBESAM_NID12, 0x169030)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG13_U_RNFBESAM_NID12, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG13_U_RNFBESAM_NID12, SN_NODEID_55, 36, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG13_U_RNFBESAM_NID12, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG13_U_RNFBESAM_NID12, SN_NODEID_54, 24, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG13_U_RNFBESAM_NID12, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG13_U_RNFBESAM_NID12, SN_NODEID_53, 12, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG13_U_RNFBESAM_NID12, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG13_U_RNFBESAM_NID12, SN_NODEID_52, 0, 11)
REG32(SYS_CACHE_GRP_SN_NODEID_REG14_U_RNFBESAM_NID12, 0x169038)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG14_U_RNFBESAM_NID12, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG14_U_RNFBESAM_NID12, SN_NODEID_59, 36, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG14_U_RNFBESAM_NID12, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG14_U_RNFBESAM_NID12, SN_NODEID_58, 24, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG14_U_RNFBESAM_NID12, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG14_U_RNFBESAM_NID12, SN_NODEID_57, 12, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG14_U_RNFBESAM_NID12, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG14_U_RNFBESAM_NID12, SN_NODEID_56, 0, 11)
REG32(SYS_CACHE_GRP_SN_NODEID_REG15_U_RNFBESAM_NID12, 0x169040)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG15_U_RNFBESAM_NID12, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG15_U_RNFBESAM_NID12, SN_NODEID_63, 36, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG15_U_RNFBESAM_NID12, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG15_U_RNFBESAM_NID12, SN_NODEID_62, 24, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG15_U_RNFBESAM_NID12, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG15_U_RNFBESAM_NID12, SN_NODEID_61, 12, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG15_U_RNFBESAM_NID12, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG15_U_RNFBESAM_NID12, SN_NODEID_60, 0, 11)
REG32(POR_SBSX_NODE_INFO_U_SBSX_NID64, 0x800000)
    FIELD(POR_SBSX_NODE_INFO_U_SBSX_NID64, RESERVED_48, 48, 16)
    FIELD(POR_SBSX_NODE_INFO_U_SBSX_NID64, LOGICAL_ID, 32, 16)
    FIELD(POR_SBSX_NODE_INFO_U_SBSX_NID64, NODE_ID, 16, 16)
    FIELD(POR_SBSX_NODE_INFO_U_SBSX_NID64, NODE_TYPE, 0, 16)
REG32(POR_SBSX_CHILD_INFO_U_SBSX_NID64, 0x800080)
    FIELD(POR_SBSX_CHILD_INFO_U_SBSX_NID64, RESERVED_32, 32, 32)
    FIELD(POR_SBSX_CHILD_INFO_U_SBSX_NID64, CHILD_PTR_OFFSET, 16, 16)
    FIELD(POR_SBSX_CHILD_INFO_U_SBSX_NID64, CHILD_COUNT, 0, 16)
REG32(POR_SBSX_UNIT_INFO_U_SBSX_NID64, 0x800900)
    FIELD(POR_SBSX_UNIT_INFO_U_SBSX_NID64, RESERVED_22, 22, 42)
    FIELD(POR_SBSX_UNIT_INFO_U_SBSX_NID64, ACEL_SAFE_XFACE_DISABLE, 21, 1)
    FIELD(POR_SBSX_UNIT_INFO_U_SBSX_NID64, NUM_WR_DATA_BUF, 16, 5)
    FIELD(POR_SBSX_UNIT_INFO_U_SBSX_NID64, NUM_OUTSTANDING_READS, 8, 8)
    FIELD(POR_SBSX_UNIT_INFO_U_SBSX_NID64, AXDATA_POISON_EN, 4, 1)
    FIELD(POR_SBSX_UNIT_INFO_U_SBSX_NID64, AXDATA_WIDTH, 0, 1)
REG32(POR_SBSX_AUX_CTL_U_SBSX_NID64, 0x800a08)
    FIELD(POR_SBSX_AUX_CTL_U_SBSX_NID64, CLKGATE_DISABLE, 0, 1)
REG32(POR_SBSX_PMU_EVENT_SEL_U_SBSX_NID64, 0x802000)
    FIELD(POR_SBSX_PMU_EVENT_SEL_U_SBSX_NID64, RESERVED_30, 30, 34)
    FIELD(POR_SBSX_PMU_EVENT_SEL_U_SBSX_NID64, PMU_EVENT3_ID, 24, 6)
    FIELD(POR_SBSX_PMU_EVENT_SEL_U_SBSX_NID64, RESERVED_22, 22, 2)
    FIELD(POR_SBSX_PMU_EVENT_SEL_U_SBSX_NID64, PMU_EVENT2_ID, 16, 6)
    FIELD(POR_SBSX_PMU_EVENT_SEL_U_SBSX_NID64, RESERVED_14, 14, 2)
    FIELD(POR_SBSX_PMU_EVENT_SEL_U_SBSX_NID64, PMU_EVENT1_ID, 8, 6)
    FIELD(POR_SBSX_PMU_EVENT_SEL_U_SBSX_NID64, PMU_EVENT0_ID, 0, 6)
REG32(POR_SBSX_ERRFR_U_SBSX_NID64, 0x803000)
    FIELD(POR_SBSX_ERRFR_U_SBSX_NID64, RESERVED_15, 15, 49)
    FIELD(POR_SBSX_ERRFR_U_SBSX_NID64, CEC, 12, 3)
    FIELD(POR_SBSX_ERRFR_U_SBSX_NID64, CFI, 10, 2)
    FIELD(POR_SBSX_ERRFR_U_SBSX_NID64, FI, 6, 2)
    FIELD(POR_SBSX_ERRFR_U_SBSX_NID64, UI, 4, 2)
    FIELD(POR_SBSX_ERRFR_U_SBSX_NID64, DE, 2, 2)
    FIELD(POR_SBSX_ERRFR_U_SBSX_NID64, ED, 0, 2)
REG32(POR_SBSX_ERRCTLR_U_SBSX_NID64, 0x803008)
    FIELD(POR_SBSX_ERRCTLR_U_SBSX_NID64, RESERVED_9, 9, 55)
    FIELD(POR_SBSX_ERRCTLR_U_SBSX_NID64, CFI, 8, 1)
    FIELD(POR_SBSX_ERRCTLR_U_SBSX_NID64, FI, 3, 1)
    FIELD(POR_SBSX_ERRCTLR_U_SBSX_NID64, UI, 2, 1)
    FIELD(POR_SBSX_ERRCTLR_U_SBSX_NID64, DE, 1, 1)
    FIELD(POR_SBSX_ERRCTLR_U_SBSX_NID64, ED, 0, 1)
REG32(POR_SBSX_ERRSTATUS_U_SBSX_NID64, 0x803010)
    FIELD(POR_SBSX_ERRSTATUS_U_SBSX_NID64, RESERVED_32, 32, 32)
    FIELD(POR_SBSX_ERRSTATUS_U_SBSX_NID64, AV, 31, 1)
    FIELD(POR_SBSX_ERRSTATUS_U_SBSX_NID64, V, 30, 1)
    FIELD(POR_SBSX_ERRSTATUS_U_SBSX_NID64, UE, 29, 1)
    FIELD(POR_SBSX_ERRSTATUS_U_SBSX_NID64, RESERVED_28, 28, 1)
    FIELD(POR_SBSX_ERRSTATUS_U_SBSX_NID64, OF, 27, 1)
    FIELD(POR_SBSX_ERRSTATUS_U_SBSX_NID64, MV, 26, 1)
    FIELD(POR_SBSX_ERRSTATUS_U_SBSX_NID64, RESERVED_25, 25, 1)
    FIELD(POR_SBSX_ERRSTATUS_U_SBSX_NID64, CE, 24, 1)
    FIELD(POR_SBSX_ERRSTATUS_U_SBSX_NID64, DE, 23, 1)
    FIELD(POR_SBSX_ERRSTATUS_U_SBSX_NID64, RESERVED_0, 0, 23)
REG32(POR_SBSX_ERRADDR_U_SBSX_NID64, 0x803018)
    FIELD(POR_SBSX_ERRADDR_U_SBSX_NID64, NS, 63, 1)
    FIELD(POR_SBSX_ERRADDR_U_SBSX_NID64, RESERVED_48, 48, 15)
    FIELD(POR_SBSX_ERRADDR_U_SBSX_NID64, ADDR, 0, 48)
REG32(POR_SBSX_ERRMISC_U_SBSX_NID64, 0x803020)
    FIELD(POR_SBSX_ERRMISC_U_SBSX_NID64, RESERVED_31, 31, 33)
    FIELD(POR_SBSX_ERRMISC_U_SBSX_NID64, SIZE, 28, 3)
    FIELD(POR_SBSX_ERRMISC_U_SBSX_NID64, MEMATTR, 24, 4)
    FIELD(POR_SBSX_ERRMISC_U_SBSX_NID64, RESERVED_17, 17, 7)
    FIELD(POR_SBSX_ERRMISC_U_SBSX_NID64, OPTYPE, 16, 1)
    FIELD(POR_SBSX_ERRMISC_U_SBSX_NID64, RESERVED_15, 15, 1)
    FIELD(POR_SBSX_ERRMISC_U_SBSX_NID64, SRCID, 4, 11)
    FIELD(POR_SBSX_ERRMISC_U_SBSX_NID64, RESERVED_0, 0, 4)
REG32(POR_SBSX_ERRFR_NS_U_SBSX_NID64, 0x803100)
    FIELD(POR_SBSX_ERRFR_NS_U_SBSX_NID64, RESERVED_15, 15, 49)
    FIELD(POR_SBSX_ERRFR_NS_U_SBSX_NID64, CEC, 12, 3)
    FIELD(POR_SBSX_ERRFR_NS_U_SBSX_NID64, CFI, 10, 2)
    FIELD(POR_SBSX_ERRFR_NS_U_SBSX_NID64, FI, 6, 2)
    FIELD(POR_SBSX_ERRFR_NS_U_SBSX_NID64, UI, 4, 2)
    FIELD(POR_SBSX_ERRFR_NS_U_SBSX_NID64, DE, 2, 2)
    FIELD(POR_SBSX_ERRFR_NS_U_SBSX_NID64, ED, 0, 2)
REG32(POR_SBSX_ERRCTLR_NS_U_SBSX_NID64, 0x803108)
    FIELD(POR_SBSX_ERRCTLR_NS_U_SBSX_NID64, RESERVED_9, 9, 55)
    FIELD(POR_SBSX_ERRCTLR_NS_U_SBSX_NID64, CFI, 8, 1)
    FIELD(POR_SBSX_ERRCTLR_NS_U_SBSX_NID64, FI, 3, 1)
    FIELD(POR_SBSX_ERRCTLR_NS_U_SBSX_NID64, UI, 2, 1)
    FIELD(POR_SBSX_ERRCTLR_NS_U_SBSX_NID64, DE, 1, 1)
    FIELD(POR_SBSX_ERRCTLR_NS_U_SBSX_NID64, ED, 0, 1)
REG32(POR_SBSX_ERRSTATUS_NS_U_SBSX_NID64, 0x803110)
    FIELD(POR_SBSX_ERRSTATUS_NS_U_SBSX_NID64, RESERVED_32, 32, 32)
    FIELD(POR_SBSX_ERRSTATUS_NS_U_SBSX_NID64, AV, 31, 1)
    FIELD(POR_SBSX_ERRSTATUS_NS_U_SBSX_NID64, V, 30, 1)
    FIELD(POR_SBSX_ERRSTATUS_NS_U_SBSX_NID64, UE, 29, 1)
    FIELD(POR_SBSX_ERRSTATUS_NS_U_SBSX_NID64, RESERVED_28, 28, 1)
    FIELD(POR_SBSX_ERRSTATUS_NS_U_SBSX_NID64, OF, 27, 1)
    FIELD(POR_SBSX_ERRSTATUS_NS_U_SBSX_NID64, MV, 26, 1)
    FIELD(POR_SBSX_ERRSTATUS_NS_U_SBSX_NID64, RESERVED_25, 25, 1)
    FIELD(POR_SBSX_ERRSTATUS_NS_U_SBSX_NID64, CE, 24, 1)
    FIELD(POR_SBSX_ERRSTATUS_NS_U_SBSX_NID64, DE, 23, 1)
    FIELD(POR_SBSX_ERRSTATUS_NS_U_SBSX_NID64, RESERVED_0, 0, 23)
REG32(POR_SBSX_ERRADDR_NS_U_SBSX_NID64, 0x803118)
    FIELD(POR_SBSX_ERRADDR_NS_U_SBSX_NID64, NS, 63, 1)
    FIELD(POR_SBSX_ERRADDR_NS_U_SBSX_NID64, RESERVED_48, 48, 15)
    FIELD(POR_SBSX_ERRADDR_NS_U_SBSX_NID64, ADDR, 0, 48)
REG32(POR_SBSX_ERRMISC_NS_U_SBSX_NID64, 0x803120)
    FIELD(POR_SBSX_ERRMISC_NS_U_SBSX_NID64, RESERVED_31, 31, 33)
    FIELD(POR_SBSX_ERRMISC_NS_U_SBSX_NID64, SIZE, 28, 3)
    FIELD(POR_SBSX_ERRMISC_NS_U_SBSX_NID64, MEMATTR, 24, 4)
    FIELD(POR_SBSX_ERRMISC_NS_U_SBSX_NID64, RESERVED_17, 17, 7)
    FIELD(POR_SBSX_ERRMISC_NS_U_SBSX_NID64, OPTYPE, 16, 1)
    FIELD(POR_SBSX_ERRMISC_NS_U_SBSX_NID64, RESERVED_15, 15, 1)
    FIELD(POR_SBSX_ERRMISC_NS_U_SBSX_NID64, SRCID, 4, 11)
    FIELD(POR_SBSX_ERRMISC_NS_U_SBSX_NID64, RESERVED_0, 0, 4)
REG32(POR_MXP_NODE_INFO_U_SMXP_1_0, 0x808000)
    FIELD(POR_MXP_NODE_INFO_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MXP_NODE_INFO_U_SMXP_1_0, LOGICAL_ID, 32, 16)
    FIELD(POR_MXP_NODE_INFO_U_SMXP_1_0, XY_ID, 16, 16)
    FIELD(POR_MXP_NODE_INFO_U_SMXP_1_0, NODE_TYPE, 0, 16)
REG32(POR_MXP_DEVICE_PORT_CONNECT_INFO_P0_U_SMXP_1_0, 0x808008)
    FIELD(POR_MXP_DEVICE_PORT_CONNECT_INFO_P0_U_SMXP_1_0, RESERVED_32, 32, 32)
    FIELD(POR_MXP_DEVICE_PORT_CONNECT_INFO_P0_U_SMXP_1_0, NUM_DCS_P0_D3, 28, 4)
    FIELD(POR_MXP_DEVICE_PORT_CONNECT_INFO_P0_U_SMXP_1_0, NUM_DCS_P0_D2, 24, 4)
    FIELD(POR_MXP_DEVICE_PORT_CONNECT_INFO_P0_U_SMXP_1_0, NUM_DCS_P0_D1, 20, 4)
    FIELD(POR_MXP_DEVICE_PORT_CONNECT_INFO_P0_U_SMXP_1_0, NUM_DCS_P0_D0, 16, 4)
    FIELD(POR_MXP_DEVICE_PORT_CONNECT_INFO_P0_U_SMXP_1_0, DEVICE_TYPE_P0, 0, 5)
REG32(POR_MXP_DEVICE_PORT_CONNECT_INFO_P1_U_SMXP_1_0, 0x808010)
    FIELD(POR_MXP_DEVICE_PORT_CONNECT_INFO_P1_U_SMXP_1_0, RESERVED_32, 32, 32)
    FIELD(POR_MXP_DEVICE_PORT_CONNECT_INFO_P1_U_SMXP_1_0, NUM_DCS_P1_D3, 28, 4)
    FIELD(POR_MXP_DEVICE_PORT_CONNECT_INFO_P1_U_SMXP_1_0, NUM_DCS_P1_D2, 24, 4)
    FIELD(POR_MXP_DEVICE_PORT_CONNECT_INFO_P1_U_SMXP_1_0, NUM_DCS_P1_D1, 20, 4)
    FIELD(POR_MXP_DEVICE_PORT_CONNECT_INFO_P1_U_SMXP_1_0, NUM_DCS_P1_D0, 16, 4)
    FIELD(POR_MXP_DEVICE_PORT_CONNECT_INFO_P1_U_SMXP_1_0, DEVICE_TYPE_P1, 0, 5)
REG32(POR_MXP_MESH_PORT_CONNECT_INFO_EAST_U_SMXP_1_0, 0x808018)
    FIELD(POR_MXP_MESH_PORT_CONNECT_INFO_EAST_U_SMXP_1_0, NUM_MCS_EAST, 0, 4)
REG32(POR_MXP_MESH_PORT_CONNECT_INFO_NORTH_U_SMXP_1_0, 0x808020)
    FIELD(POR_MXP_MESH_PORT_CONNECT_INFO_NORTH_U_SMXP_1_0, NUM_MCS_NORTH, 0, 4)
REG32(POR_MXP_CHILD_INFO_U_SMXP_1_0, 0x808080)
    FIELD(POR_MXP_CHILD_INFO_U_SMXP_1_0, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_INFO_U_SMXP_1_0, CHILD_PTR_OFFSET, 16, 16)
    FIELD(POR_MXP_CHILD_INFO_U_SMXP_1_0, CHILD_COUNT, 0, 16)
REG32(POR_MXP_CHILD_POINTER_0_U_SMXP_1_0, 0x808100)
    FIELD(POR_MXP_CHILD_POINTER_0_U_SMXP_1_0, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_POINTER_0_U_SMXP_1_0, RELATIVE_ADDRESS_0, 0, 32)
REG32(POR_MXP_CHILD_POINTER_1_U_SMXP_1_0, 0x808108)
    FIELD(POR_MXP_CHILD_POINTER_1_U_SMXP_1_0, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_POINTER_1_U_SMXP_1_0, RELATIVE_ADDRESS_1, 0, 32)
REG32(POR_MXP_CHILD_POINTER_2_U_SMXP_1_0, 0x808110)
    FIELD(POR_MXP_CHILD_POINTER_2_U_SMXP_1_0, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_POINTER_2_U_SMXP_1_0, RELATIVE_ADDRESS_2, 0, 32)
REG32(POR_MXP_CHILD_POINTER_3_U_SMXP_1_0, 0x808118)
    FIELD(POR_MXP_CHILD_POINTER_3_U_SMXP_1_0, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_POINTER_3_U_SMXP_1_0, RELATIVE_ADDRESS_3, 0, 32)
REG32(POR_MXP_CHILD_POINTER_4_U_SMXP_1_0, 0x808120)
    FIELD(POR_MXP_CHILD_POINTER_4_U_SMXP_1_0, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_POINTER_4_U_SMXP_1_0, RELATIVE_ADDRESS_4, 0, 32)
REG32(POR_MXP_CHILD_POINTER_5_U_SMXP_1_0, 0x808128)
    FIELD(POR_MXP_CHILD_POINTER_5_U_SMXP_1_0, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_POINTER_5_U_SMXP_1_0, RELATIVE_ADDRESS_5, 0, 32)
REG32(POR_MXP_CHILD_POINTER_6_U_SMXP_1_0, 0x808130)
    FIELD(POR_MXP_CHILD_POINTER_6_U_SMXP_1_0, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_POINTER_6_U_SMXP_1_0, RELATIVE_ADDRESS_6, 0, 32)
REG32(POR_MXP_CHILD_POINTER_7_U_SMXP_1_0, 0x808138)
    FIELD(POR_MXP_CHILD_POINTER_7_U_SMXP_1_0, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_POINTER_7_U_SMXP_1_0, RELATIVE_ADDRESS_7, 0, 32)
REG32(POR_MXP_CHILD_POINTER_8_U_SMXP_1_0, 0x808140)
    FIELD(POR_MXP_CHILD_POINTER_8_U_SMXP_1_0, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_POINTER_8_U_SMXP_1_0, RELATIVE_ADDRESS_8, 0, 32)
REG32(POR_MXP_CHILD_POINTER_9_U_SMXP_1_0, 0x808148)
    FIELD(POR_MXP_CHILD_POINTER_9_U_SMXP_1_0, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_POINTER_9_U_SMXP_1_0, RELATIVE_ADDRESS_9, 0, 32)
REG32(POR_MXP_CHILD_POINTER_10_U_SMXP_1_0, 0x808150)
    FIELD(POR_MXP_CHILD_POINTER_10_U_SMXP_1_0, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_POINTER_10_U_SMXP_1_0, RELATIVE_ADDRESS_10, 0, 32)
REG32(POR_MXP_CHILD_POINTER_11_U_SMXP_1_0, 0x808158)
    FIELD(POR_MXP_CHILD_POINTER_11_U_SMXP_1_0, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_POINTER_11_U_SMXP_1_0, RELATIVE_ADDRESS_11, 0, 32)
REG32(POR_MXP_CHILD_POINTER_12_U_SMXP_1_0, 0x808160)
    FIELD(POR_MXP_CHILD_POINTER_12_U_SMXP_1_0, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_POINTER_12_U_SMXP_1_0, RELATIVE_ADDRESS_12, 0, 32)
REG32(POR_MXP_CHILD_POINTER_13_U_SMXP_1_0, 0x808168)
    FIELD(POR_MXP_CHILD_POINTER_13_U_SMXP_1_0, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_POINTER_13_U_SMXP_1_0, RELATIVE_ADDRESS_13, 0, 32)
REG32(POR_MXP_CHILD_POINTER_14_U_SMXP_1_0, 0x808170)
    FIELD(POR_MXP_CHILD_POINTER_14_U_SMXP_1_0, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_POINTER_14_U_SMXP_1_0, RELATIVE_ADDRESS_14, 0, 32)
REG32(POR_MXP_CHILD_POINTER_15_U_SMXP_1_0, 0x808178)
    FIELD(POR_MXP_CHILD_POINTER_15_U_SMXP_1_0, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_POINTER_15_U_SMXP_1_0, RELATIVE_ADDRESS_15, 0, 32)
REG32(POR_MXP_P0_INFO_U_SMXP_1_0, 0x808900)
    FIELD(POR_MXP_P0_INFO_U_SMXP_1_0, RESERVED_26, 26, 38)
    FIELD(POR_MXP_P0_INFO_U_SMXP_1_0, A4S_SAFE_XFACE_DISABLE_P0, 25, 1)
    FIELD(POR_MXP_P0_INFO_U_SMXP_1_0, CHI_SAFE_XFACE_DISABLE_P0, 24, 1)
    FIELD(POR_MXP_P0_INFO_U_SMXP_1_0, A4S_LOGICALID_BASE_P0, 16, 8)
    FIELD(POR_MXP_P0_INFO_U_SMXP_1_0, RESERVED_14, 14, 2)
    FIELD(POR_MXP_P0_INFO_U_SMXP_1_0, A4S_NUM_P0, 11, 3)
    FIELD(POR_MXP_P0_INFO_U_SMXP_1_0, RXBUF_NUM_ENTRIES_P0, 8, 3)
    FIELD(POR_MXP_P0_INFO_U_SMXP_1_0, EXT_SAM_EN_P0, 7, 1)
    FIELD(POR_MXP_P0_INFO_U_SMXP_1_0, DATACHECK_EN_P0, 5, 1)
    FIELD(POR_MXP_P0_INFO_U_SMXP_1_0, POISON_EN_P0, 4, 1)
    FIELD(POR_MXP_P0_INFO_U_SMXP_1_0, NUM_DEV_P0, 0, 3)
REG32(POR_MXP_P1_INFO_U_SMXP_1_0, 0x808908)
    FIELD(POR_MXP_P1_INFO_U_SMXP_1_0, RESERVED_26, 26, 38)
    FIELD(POR_MXP_P1_INFO_U_SMXP_1_0, A4S_SAFE_XFACE_DISABLE_P1, 25, 1)
    FIELD(POR_MXP_P1_INFO_U_SMXP_1_0, CHI_SAFE_XFACE_DISABLE_P1, 24, 1)
    FIELD(POR_MXP_P1_INFO_U_SMXP_1_0, A4S_LOGICALID_BASE_P1, 16, 8)
    FIELD(POR_MXP_P1_INFO_U_SMXP_1_0, RESERVED_14, 14, 2)
    FIELD(POR_MXP_P1_INFO_U_SMXP_1_0, A4S_NUM_P1, 11, 3)
    FIELD(POR_MXP_P1_INFO_U_SMXP_1_0, RXBUF_NUM_ENTRIES_P1, 8, 3)
    FIELD(POR_MXP_P1_INFO_U_SMXP_1_0, EXT_SAM_EN_P1, 7, 1)
    FIELD(POR_MXP_P1_INFO_U_SMXP_1_0, DATACHECK_EN_P1, 5, 1)
    FIELD(POR_MXP_P1_INFO_U_SMXP_1_0, POISON_EN_P1, 4, 1)
    FIELD(POR_MXP_P1_INFO_U_SMXP_1_0, NUM_DEV_P1, 0, 3)
REG32(POR_MXP_SECURE_REGISTER_GROUPS_OVERRIDE_U_SMXP_1_0, 0x808980)
    FIELD(POR_MXP_SECURE_REGISTER_GROUPS_OVERRIDE_U_SMXP_1_0, SYSCOREQ_CTL, 1, 1)
    FIELD(POR_MXP_SECURE_REGISTER_GROUPS_OVERRIDE_U_SMXP_1_0, QOS, 0, 1)
REG32(POR_MXP_AUX_CTL_U_SMXP_1_0, 0x808a00)
    FIELD(POR_MXP_AUX_CTL_U_SMXP_1_0, CLKGATE_DISABLE, 0, 1)
REG32(POR_MXP_P0_QOS_CONTROL_U_SMXP_1_0, 0x808a80)
    FIELD(POR_MXP_P0_QOS_CONTROL_U_SMXP_1_0, RESERVED_20, 20, 44)
    FIELD(POR_MXP_P0_QOS_CONTROL_U_SMXP_1_0, P0_QOS_OVERRIDE, 16, 4)
    FIELD(POR_MXP_P0_QOS_CONTROL_U_SMXP_1_0, P0_PQV_MODE, 6, 1)
    FIELD(POR_MXP_P0_QOS_CONTROL_U_SMXP_1_0, P0_REG_MODE, 4, 1)
    FIELD(POR_MXP_P0_QOS_CONTROL_U_SMXP_1_0, P0_QOS_OVERRIDE_EN, 2, 1)
    FIELD(POR_MXP_P0_QOS_CONTROL_U_SMXP_1_0, P0_LAT_EN, 0, 1)
REG32(POR_MXP_P0_QOS_LAT_TGT_U_SMXP_1_0, 0x808a88)
    FIELD(POR_MXP_P0_QOS_LAT_TGT_U_SMXP_1_0, RESERVED_12, 12, 52)
    FIELD(POR_MXP_P0_QOS_LAT_TGT_U_SMXP_1_0, P0_LAT_TGT, 0, 12)
REG32(POR_MXP_P0_QOS_LAT_SCALE_U_SMXP_1_0, 0x808a90)
    FIELD(POR_MXP_P0_QOS_LAT_SCALE_U_SMXP_1_0, P0_LAT_SCALE, 0, 3)
REG32(POR_MXP_P0_QOS_LAT_RANGE_U_SMXP_1_0, 0x808a98)
    FIELD(POR_MXP_P0_QOS_LAT_RANGE_U_SMXP_1_0, RESERVED_12, 12, 52)
    FIELD(POR_MXP_P0_QOS_LAT_RANGE_U_SMXP_1_0, P0_LAT_MAX_QOS, 8, 4)
    FIELD(POR_MXP_P0_QOS_LAT_RANGE_U_SMXP_1_0, P0_LAT_MIN_QOS, 0, 4)
REG32(POR_MXP_P1_QOS_CONTROL_U_SMXP_1_0, 0x808aa0)
    FIELD(POR_MXP_P1_QOS_CONTROL_U_SMXP_1_0, RESERVED_20, 20, 44)
    FIELD(POR_MXP_P1_QOS_CONTROL_U_SMXP_1_0, P1_QOS_OVERRIDE, 16, 4)
    FIELD(POR_MXP_P1_QOS_CONTROL_U_SMXP_1_0, P1_PQV_MODE, 6, 1)
    FIELD(POR_MXP_P1_QOS_CONTROL_U_SMXP_1_0, P1_REG_MODE, 4, 1)
    FIELD(POR_MXP_P1_QOS_CONTROL_U_SMXP_1_0, P1_QOS_OVERRIDE_EN, 2, 1)
    FIELD(POR_MXP_P1_QOS_CONTROL_U_SMXP_1_0, P1_LAT_EN, 0, 1)
REG32(POR_MXP_P1_QOS_LAT_TGT_U_SMXP_1_0, 0x808aa8)
    FIELD(POR_MXP_P1_QOS_LAT_TGT_U_SMXP_1_0, RESERVED_12, 12, 52)
    FIELD(POR_MXP_P1_QOS_LAT_TGT_U_SMXP_1_0, P1_LAT_TGT, 0, 12)
REG32(POR_MXP_P1_QOS_LAT_SCALE_U_SMXP_1_0, 0x808ab0)
    FIELD(POR_MXP_P1_QOS_LAT_SCALE_U_SMXP_1_0, P1_LAT_SCALE, 0, 3)
REG32(POR_MXP_P1_QOS_LAT_RANGE_U_SMXP_1_0, 0x808ab8)
    FIELD(POR_MXP_P1_QOS_LAT_RANGE_U_SMXP_1_0, RESERVED_12, 12, 52)
    FIELD(POR_MXP_P1_QOS_LAT_RANGE_U_SMXP_1_0, P1_LAT_MAX_QOS, 8, 4)
    FIELD(POR_MXP_P1_QOS_LAT_RANGE_U_SMXP_1_0, P1_LAT_MIN_QOS, 0, 4)
REG32(POR_MXP_P0_SYSCOREQ_CTL_U_SMXP_1_0, 0x809000)
    FIELD(POR_MXP_P0_SYSCOREQ_CTL_U_SMXP_1_0, SNPDVM_REQ_P0_D3, 3, 1)
    FIELD(POR_MXP_P0_SYSCOREQ_CTL_U_SMXP_1_0, SNPDVM_REQ_P0_D2, 2, 1)
    FIELD(POR_MXP_P0_SYSCOREQ_CTL_U_SMXP_1_0, SNPDVM_REQ_P0_D1, 1, 1)
    FIELD(POR_MXP_P0_SYSCOREQ_CTL_U_SMXP_1_0, SNPDVM_REQ_P0_D0, 0, 1)
REG32(POR_MXP_P1_SYSCOREQ_CTL_U_SMXP_1_0, 0x809008)
    FIELD(POR_MXP_P1_SYSCOREQ_CTL_U_SMXP_1_0, SNPDVM_REQ_P1_D3, 3, 1)
    FIELD(POR_MXP_P1_SYSCOREQ_CTL_U_SMXP_1_0, SNPDVM_REQ_P1_D2, 2, 1)
    FIELD(POR_MXP_P1_SYSCOREQ_CTL_U_SMXP_1_0, SNPDVM_REQ_P1_D1, 1, 1)
    FIELD(POR_MXP_P1_SYSCOREQ_CTL_U_SMXP_1_0, SNPDVM_REQ_P1_D0, 0, 1)
REG32(POR_MXP_P0_SYSCOACK_STATUS_U_SMXP_1_0, 0x809010)
    FIELD(POR_MXP_P0_SYSCOACK_STATUS_U_SMXP_1_0, SNPDVM_ACK_P0_D3, 3, 1)
    FIELD(POR_MXP_P0_SYSCOACK_STATUS_U_SMXP_1_0, SNPDVM_ACK_P0_D2, 2, 1)
    FIELD(POR_MXP_P0_SYSCOACK_STATUS_U_SMXP_1_0, SNPDVM_ACK_P0_D1, 1, 1)
    FIELD(POR_MXP_P0_SYSCOACK_STATUS_U_SMXP_1_0, SNPDVM_ACK_P0_D0, 0, 1)
REG32(POR_MXP_P1_SYSCOACK_STATUS_U_SMXP_1_0, 0x809018)
    FIELD(POR_MXP_P1_SYSCOACK_STATUS_U_SMXP_1_0, SNPDVM_ACK_P1_D3, 3, 1)
    FIELD(POR_MXP_P1_SYSCOACK_STATUS_U_SMXP_1_0, SNPDVM_ACK_P1_D2, 2, 1)
    FIELD(POR_MXP_P1_SYSCOACK_STATUS_U_SMXP_1_0, SNPDVM_ACK_P1_D1, 1, 1)
    FIELD(POR_MXP_P1_SYSCOACK_STATUS_U_SMXP_1_0, SNPDVM_ACK_P1_D0, 0, 1)
REG32(POR_MXP_PMU_EVENT_SEL_U_SMXP_1_0, 0x80a000)
    FIELD(POR_MXP_PMU_EVENT_SEL_U_SMXP_1_0, RESERVED_32, 32, 32)
    FIELD(POR_MXP_PMU_EVENT_SEL_U_SMXP_1_0, PMU_EVENT3_ID, 24, 8)
    FIELD(POR_MXP_PMU_EVENT_SEL_U_SMXP_1_0, PMU_EVENT2_ID, 16, 8)
    FIELD(POR_MXP_PMU_EVENT_SEL_U_SMXP_1_0, PMU_EVENT1_ID, 8, 8)
    FIELD(POR_MXP_PMU_EVENT_SEL_U_SMXP_1_0, PMU_EVENT0_ID, 0, 8)
REG32(POR_DTM_CONTROL_U_SMXP_1_0, 0x80a100)
    FIELD(POR_DTM_CONTROL_U_SMXP_1_0, TRACE_NO_ATB, 3, 1)
    FIELD(POR_DTM_CONTROL_U_SMXP_1_0, SAMPLE_PROFILE_ENABLE, 2, 1)
    FIELD(POR_DTM_CONTROL_U_SMXP_1_0, TRACE_TAG_ENABLE, 1, 1)
    FIELD(POR_DTM_CONTROL_U_SMXP_1_0, DTM_ENABLE, 0, 1)
REG32(POR_DTM_FIFO_ENTRY_READY_U_SMXP_1_0, 0x80a118)
    FIELD(POR_DTM_FIFO_ENTRY_READY_U_SMXP_1_0, READY, 0, 4)
REG32(POR_DTM_FIFO_ENTRY0_0_U_SMXP_1_0, 0x80a120)
REG32(POR_DTM_FIFO_ENTRY0_1_U_SMXP_1_0, 0x80a128)
REG32(POR_DTM_FIFO_ENTRY0_2_U_SMXP_1_0, 0x80a130)
    FIELD(POR_DTM_FIFO_ENTRY0_2_U_SMXP_1_0, RESERVED_32, 32, 32)
    FIELD(POR_DTM_FIFO_ENTRY0_2_U_SMXP_1_0, FIFO_CYCLE_COUNT, 16, 16)
    FIELD(POR_DTM_FIFO_ENTRY0_2_U_SMXP_1_0, FIFO_DATA2, 0, 16)
REG32(POR_DTM_FIFO_ENTRY1_0_U_SMXP_1_0, 0x80a138)
REG32(POR_DTM_FIFO_ENTRY1_1_U_SMXP_1_0, 0x80a140)
REG32(POR_DTM_FIFO_ENTRY1_2_U_SMXP_1_0, 0x80a148)
    FIELD(POR_DTM_FIFO_ENTRY1_2_U_SMXP_1_0, RESERVED_32, 32, 32)
    FIELD(POR_DTM_FIFO_ENTRY1_2_U_SMXP_1_0, FIFO_CYCLE_COUNT, 16, 16)
    FIELD(POR_DTM_FIFO_ENTRY1_2_U_SMXP_1_0, FIFO_DATA2, 0, 16)
REG32(POR_DTM_FIFO_ENTRY2_0_U_SMXP_1_0, 0x80a150)
REG32(POR_DTM_FIFO_ENTRY2_1_U_SMXP_1_0, 0x80a158)
REG32(POR_DTM_FIFO_ENTRY2_2_U_SMXP_1_0, 0x80a160)
    FIELD(POR_DTM_FIFO_ENTRY2_2_U_SMXP_1_0, RESERVED_32, 32, 32)
    FIELD(POR_DTM_FIFO_ENTRY2_2_U_SMXP_1_0, FIFO_CYCLE_COUNT, 16, 16)
    FIELD(POR_DTM_FIFO_ENTRY2_2_U_SMXP_1_0, FIFO_DATA2, 0, 16)
REG32(POR_DTM_FIFO_ENTRY3_0_U_SMXP_1_0, 0x80a168)
REG32(POR_DTM_FIFO_ENTRY3_1_U_SMXP_1_0, 0x80a170)
REG32(POR_DTM_FIFO_ENTRY3_2_U_SMXP_1_0, 0x80a178)
    FIELD(POR_DTM_FIFO_ENTRY3_2_U_SMXP_1_0, RESERVED_32, 32, 32)
    FIELD(POR_DTM_FIFO_ENTRY3_2_U_SMXP_1_0, FIFO_CYCLE_COUNT, 16, 16)
    FIELD(POR_DTM_FIFO_ENTRY3_2_U_SMXP_1_0, FIFO_DATA2, 0, 16)
REG32(POR_DTM_WP0_CONFIG_U_SMXP_1_0, 0x80a1a0)
    FIELD(POR_DTM_WP0_CONFIG_U_SMXP_1_0, RESERVED_15, 15, 49)
    FIELD(POR_DTM_WP0_CONFIG_U_SMXP_1_0, WP_DBGTRIG_EN, 14, 1)
    FIELD(POR_DTM_WP0_CONFIG_U_SMXP_1_0, WP_CTRIG_EN, 13, 1)
    FIELD(POR_DTM_WP0_CONFIG_U_SMXP_1_0, WP_CC_EN, 12, 1)
    FIELD(POR_DTM_WP0_CONFIG_U_SMXP_1_0, WP_PKT_TYPE, 9, 3)
    FIELD(POR_DTM_WP0_CONFIG_U_SMXP_1_0, WP_PKT_GEN, 8, 1)
    FIELD(POR_DTM_WP0_CONFIG_U_SMXP_1_0, WP_COMBINE, 6, 1)
    FIELD(POR_DTM_WP0_CONFIG_U_SMXP_1_0, WP_EXCLUSIVE, 5, 1)
    FIELD(POR_DTM_WP0_CONFIG_U_SMXP_1_0, WP_GRP, 4, 1)
    FIELD(POR_DTM_WP0_CONFIG_U_SMXP_1_0, WP_CHN_SEL, 1, 3)
    FIELD(POR_DTM_WP0_CONFIG_U_SMXP_1_0, WP_DEV_SEL, 0, 1)
REG32(POR_DTM_WP0_VAL_U_SMXP_1_0, 0x80a1a8)
REG32(POR_DTM_WP0_MASK_U_SMXP_1_0, 0x80a1b0)
REG32(POR_DTM_WP1_CONFIG_U_SMXP_1_0, 0x80a1b8)
    FIELD(POR_DTM_WP1_CONFIG_U_SMXP_1_0, RESERVED_15, 15, 49)
    FIELD(POR_DTM_WP1_CONFIG_U_SMXP_1_0, WP_DBGTRIG_EN, 14, 1)
    FIELD(POR_DTM_WP1_CONFIG_U_SMXP_1_0, WP_CTRIG_EN, 13, 1)
    FIELD(POR_DTM_WP1_CONFIG_U_SMXP_1_0, WP_CC_EN, 12, 1)
    FIELD(POR_DTM_WP1_CONFIG_U_SMXP_1_0, WP_PKT_TYPE, 9, 3)
    FIELD(POR_DTM_WP1_CONFIG_U_SMXP_1_0, WP_PKT_GEN, 8, 1)
    FIELD(POR_DTM_WP1_CONFIG_U_SMXP_1_0, WP_EXCLUSIVE, 5, 1)
    FIELD(POR_DTM_WP1_CONFIG_U_SMXP_1_0, WP_GRP, 4, 1)
    FIELD(POR_DTM_WP1_CONFIG_U_SMXP_1_0, WP_CHN_SEL, 1, 3)
    FIELD(POR_DTM_WP1_CONFIG_U_SMXP_1_0, WP_DEV_SEL, 0, 1)
REG32(POR_DTM_WP1_VAL_U_SMXP_1_0, 0x80a1c0)
REG32(POR_DTM_WP1_MASK_U_SMXP_1_0, 0x80a1c8)
REG32(POR_DTM_WP2_CONFIG_U_SMXP_1_0, 0x80a1d0)
    FIELD(POR_DTM_WP2_CONFIG_U_SMXP_1_0, RESERVED_15, 15, 49)
    FIELD(POR_DTM_WP2_CONFIG_U_SMXP_1_0, WP_DBGTRIG_EN, 14, 1)
    FIELD(POR_DTM_WP2_CONFIG_U_SMXP_1_0, WP_CTRIG_EN, 13, 1)
    FIELD(POR_DTM_WP2_CONFIG_U_SMXP_1_0, WP_CC_EN, 12, 1)
    FIELD(POR_DTM_WP2_CONFIG_U_SMXP_1_0, WP_PKT_TYPE, 9, 3)
    FIELD(POR_DTM_WP2_CONFIG_U_SMXP_1_0, WP_PKT_GEN, 8, 1)
    FIELD(POR_DTM_WP2_CONFIG_U_SMXP_1_0, WP_COMBINE, 6, 1)
    FIELD(POR_DTM_WP2_CONFIG_U_SMXP_1_0, WP_EXCLUSIVE, 5, 1)
    FIELD(POR_DTM_WP2_CONFIG_U_SMXP_1_0, WP_GRP, 4, 1)
    FIELD(POR_DTM_WP2_CONFIG_U_SMXP_1_0, WP_CHN_SEL, 1, 3)
    FIELD(POR_DTM_WP2_CONFIG_U_SMXP_1_0, WP_DEV_SEL, 0, 1)
REG32(POR_DTM_WP2_VAL_U_SMXP_1_0, 0x80a1d8)
REG32(POR_DTM_WP2_MASK_U_SMXP_1_0, 0x80a1e0)
REG32(POR_DTM_WP3_CONFIG_U_SMXP_1_0, 0x80a1e8)
    FIELD(POR_DTM_WP3_CONFIG_U_SMXP_1_0, RESERVED_15, 15, 49)
    FIELD(POR_DTM_WP3_CONFIG_U_SMXP_1_0, WP_DBGTRIG_EN, 14, 1)
    FIELD(POR_DTM_WP3_CONFIG_U_SMXP_1_0, WP_CTRIG_EN, 13, 1)
    FIELD(POR_DTM_WP3_CONFIG_U_SMXP_1_0, WP_CC_EN, 12, 1)
    FIELD(POR_DTM_WP3_CONFIG_U_SMXP_1_0, WP_PKT_TYPE, 9, 3)
    FIELD(POR_DTM_WP3_CONFIG_U_SMXP_1_0, WP_PKT_GEN, 8, 1)
    FIELD(POR_DTM_WP3_CONFIG_U_SMXP_1_0, WP_EXCLUSIVE, 5, 1)
    FIELD(POR_DTM_WP3_CONFIG_U_SMXP_1_0, WP_GRP, 4, 1)
    FIELD(POR_DTM_WP3_CONFIG_U_SMXP_1_0, WP_CHN_SEL, 1, 3)
    FIELD(POR_DTM_WP3_CONFIG_U_SMXP_1_0, WP_DEV_SEL, 0, 1)
REG32(POR_DTM_WP3_VAL_U_SMXP_1_0, 0x80a1f0)
REG32(POR_DTM_WP3_MASK_U_SMXP_1_0, 0x80a1f8)
REG32(POR_DTM_PMSICR_U_SMXP_1_0, 0x80a200)
    FIELD(POR_DTM_PMSICR_U_SMXP_1_0, RESERVED_32, 32, 32)
    FIELD(POR_DTM_PMSICR_U_SMXP_1_0, COUNT, 0, 32)
REG32(POR_DTM_PMSIRR_U_SMXP_1_0, 0x80a208)
    FIELD(POR_DTM_PMSIRR_U_SMXP_1_0, RESERVED_32, 32, 32)
    FIELD(POR_DTM_PMSIRR_U_SMXP_1_0, INTERVAL, 8, 24)
    FIELD(POR_DTM_PMSIRR_U_SMXP_1_0, RESERVED_0, 0, 8)
REG32(POR_DTM_PMU_CONFIG_U_SMXP_1_0, 0x80a210)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_1_0, RESERVED_62, 62, 2)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_1_0, PMEVCNT3_INPUT_SEL, 56, 6)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_1_0, RESERVED_54, 54, 2)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_1_0, PMEVCNT2_INPUT_SEL, 48, 6)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_1_0, RESERVED_46, 46, 2)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_1_0, PMEVCNT1_INPUT_SEL, 40, 6)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_1_0, RESERVED_38, 38, 2)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_1_0, PMEVCNT0_INPUT_SEL, 32, 6)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_1_0, RESERVED_31, 31, 1)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_1_0, PMEVCNT3_GLOBAL_NUM, 28, 3)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_1_0, RESERVED_27, 27, 1)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_1_0, PMEVCNT2_GLOBAL_NUM, 24, 3)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_1_0, RESERVED_23, 23, 1)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_1_0, PMEVCNT1_GLOBAL_NUM, 20, 3)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_1_0, RESERVED_19, 19, 1)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_1_0, PMEVCNT0_GLOBAL_NUM, 16, 3)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_1_0, RESERVED_9, 9, 7)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_1_0, CNTR_RST, 8, 1)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_1_0, PMEVCNT_PAIRED, 4, 4)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_1_0, PMEVCNTALL_COMBINED, 3, 1)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_1_0, PMEVCNT23_COMBINED, 2, 1)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_1_0, PMEVCNT01_COMBINED, 1, 1)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_1_0, PMU_EN, 0, 1)
REG32(POR_DTM_PMEVCNT_U_SMXP_1_0, 0x80a220)
    FIELD(POR_DTM_PMEVCNT_U_SMXP_1_0, PMEVCNT3, 48, 16)
    FIELD(POR_DTM_PMEVCNT_U_SMXP_1_0, PMEVCNT2, 32, 16)
    FIELD(POR_DTM_PMEVCNT_U_SMXP_1_0, PMEVCNT1, 16, 16)
    FIELD(POR_DTM_PMEVCNT_U_SMXP_1_0, PMEVCNT0, 0, 16)
REG32(POR_DTM_PMEVCNTSR_U_SMXP_1_0, 0x80a240)
    FIELD(POR_DTM_PMEVCNTSR_U_SMXP_1_0, PMEVCNTSR3, 48, 16)
    FIELD(POR_DTM_PMEVCNTSR_U_SMXP_1_0, PMEVCNTSR2, 32, 16)
    FIELD(POR_DTM_PMEVCNTSR_U_SMXP_1_0, PMEVCNTSR1, 16, 16)
    FIELD(POR_DTM_PMEVCNTSR_U_SMXP_1_0, PMEVCNTSR0, 0, 16)
REG32(POR_MXP_ERRFR_U_SMXP_1_0, 0x80b000)
    FIELD(POR_MXP_ERRFR_U_SMXP_1_0, RESERVED_15, 15, 49)
    FIELD(POR_MXP_ERRFR_U_SMXP_1_0, CEC, 12, 3)
    FIELD(POR_MXP_ERRFR_U_SMXP_1_0, CFI, 10, 2)
    FIELD(POR_MXP_ERRFR_U_SMXP_1_0, FI, 6, 2)
    FIELD(POR_MXP_ERRFR_U_SMXP_1_0, UI, 4, 2)
    FIELD(POR_MXP_ERRFR_U_SMXP_1_0, DE, 2, 2)
    FIELD(POR_MXP_ERRFR_U_SMXP_1_0, ED, 0, 2)
REG32(POR_MXP_ERRCTLR_U_SMXP_1_0, 0x80b008)
    FIELD(POR_MXP_ERRCTLR_U_SMXP_1_0, RESERVED_9, 9, 55)
    FIELD(POR_MXP_ERRCTLR_U_SMXP_1_0, CFI, 8, 1)
    FIELD(POR_MXP_ERRCTLR_U_SMXP_1_0, FI, 3, 1)
    FIELD(POR_MXP_ERRCTLR_U_SMXP_1_0, UI, 2, 1)
    FIELD(POR_MXP_ERRCTLR_U_SMXP_1_0, DE, 1, 1)
    FIELD(POR_MXP_ERRCTLR_U_SMXP_1_0, ED, 0, 1)
REG32(POR_MXP_ERRSTATUS_U_SMXP_1_0, 0x80b010)
    FIELD(POR_MXP_ERRSTATUS_U_SMXP_1_0, RESERVED_32, 32, 32)
    FIELD(POR_MXP_ERRSTATUS_U_SMXP_1_0, AV, 31, 1)
    FIELD(POR_MXP_ERRSTATUS_U_SMXP_1_0, V, 30, 1)
    FIELD(POR_MXP_ERRSTATUS_U_SMXP_1_0, UE, 29, 1)
    FIELD(POR_MXP_ERRSTATUS_U_SMXP_1_0, RESERVED_28, 28, 1)
    FIELD(POR_MXP_ERRSTATUS_U_SMXP_1_0, OF, 27, 1)
    FIELD(POR_MXP_ERRSTATUS_U_SMXP_1_0, MV, 26, 1)
    FIELD(POR_MXP_ERRSTATUS_U_SMXP_1_0, RESERVED_25, 25, 1)
    FIELD(POR_MXP_ERRSTATUS_U_SMXP_1_0, CE, 24, 1)
    FIELD(POR_MXP_ERRSTATUS_U_SMXP_1_0, DE, 23, 1)
    FIELD(POR_MXP_ERRSTATUS_U_SMXP_1_0, RESERVED_0, 0, 23)
REG32(POR_MXP_ERRMISC_U_SMXP_1_0, 0x80b028)
    FIELD(POR_MXP_ERRMISC_U_SMXP_1_0, RESERVED_59, 59, 5)
    FIELD(POR_MXP_ERRMISC_U_SMXP_1_0, TGTID, 48, 11)
    FIELD(POR_MXP_ERRMISC_U_SMXP_1_0, RESERVED_22, 22, 26)
    FIELD(POR_MXP_ERRMISC_U_SMXP_1_0, OPCODE, 16, 6)
    FIELD(POR_MXP_ERRMISC_U_SMXP_1_0, RESERVED_15, 15, 1)
    FIELD(POR_MXP_ERRMISC_U_SMXP_1_0, SRCID, 4, 11)
    FIELD(POR_MXP_ERRMISC_U_SMXP_1_0, ERRSRC, 0, 3)
REG32(POR_MXP_P0_BYTE_PAR_ERR_INJ_U_SMXP_1_0, 0x80b030)
    FIELD(POR_MXP_P0_BYTE_PAR_ERR_INJ_U_SMXP_1_0, P0_BYTE_PARITY_ERR_INJ, 0, 5)
REG32(POR_MXP_P1_BYTE_PAR_ERR_INJ_U_SMXP_1_0, 0x80b038)
    FIELD(POR_MXP_P1_BYTE_PAR_ERR_INJ_U_SMXP_1_0, P1_BYTE_PARITY_ERR_INJ, 0, 5)
REG32(POR_MXP_ERRFR_NS_U_SMXP_1_0, 0x80b100)
    FIELD(POR_MXP_ERRFR_NS_U_SMXP_1_0, RESERVED_15, 15, 49)
    FIELD(POR_MXP_ERRFR_NS_U_SMXP_1_0, CEC, 12, 3)
    FIELD(POR_MXP_ERRFR_NS_U_SMXP_1_0, CFI, 10, 2)
    FIELD(POR_MXP_ERRFR_NS_U_SMXP_1_0, FI, 6, 2)
    FIELD(POR_MXP_ERRFR_NS_U_SMXP_1_0, UI, 4, 2)
    FIELD(POR_MXP_ERRFR_NS_U_SMXP_1_0, DE, 2, 2)
    FIELD(POR_MXP_ERRFR_NS_U_SMXP_1_0, ED, 0, 2)
REG32(POR_MXP_ERRCTLR_NS_U_SMXP_1_0, 0x80b108)
    FIELD(POR_MXP_ERRCTLR_NS_U_SMXP_1_0, RESERVED_9, 9, 55)
    FIELD(POR_MXP_ERRCTLR_NS_U_SMXP_1_0, CFI, 8, 1)
    FIELD(POR_MXP_ERRCTLR_NS_U_SMXP_1_0, FI, 3, 1)
    FIELD(POR_MXP_ERRCTLR_NS_U_SMXP_1_0, UI, 2, 1)
    FIELD(POR_MXP_ERRCTLR_NS_U_SMXP_1_0, DE, 1, 1)
    FIELD(POR_MXP_ERRCTLR_NS_U_SMXP_1_0, ED, 0, 1)
REG32(POR_MXP_ERRSTATUS_NS_U_SMXP_1_0, 0x80b110)
    FIELD(POR_MXP_ERRSTATUS_NS_U_SMXP_1_0, RESERVED_32, 32, 32)
    FIELD(POR_MXP_ERRSTATUS_NS_U_SMXP_1_0, AV, 31, 1)
    FIELD(POR_MXP_ERRSTATUS_NS_U_SMXP_1_0, V, 30, 1)
    FIELD(POR_MXP_ERRSTATUS_NS_U_SMXP_1_0, UE, 29, 1)
    FIELD(POR_MXP_ERRSTATUS_NS_U_SMXP_1_0, RESERVED_28, 28, 1)
    FIELD(POR_MXP_ERRSTATUS_NS_U_SMXP_1_0, OF, 27, 1)
    FIELD(POR_MXP_ERRSTATUS_NS_U_SMXP_1_0, MV, 26, 1)
    FIELD(POR_MXP_ERRSTATUS_NS_U_SMXP_1_0, RESERVED_25, 25, 1)
    FIELD(POR_MXP_ERRSTATUS_NS_U_SMXP_1_0, CE, 24, 1)
    FIELD(POR_MXP_ERRSTATUS_NS_U_SMXP_1_0, DE, 23, 1)
    FIELD(POR_MXP_ERRSTATUS_NS_U_SMXP_1_0, RESERVED_0, 0, 23)
REG32(POR_MXP_ERRMISC_NS_U_SMXP_1_0, 0x80b128)
    FIELD(POR_MXP_ERRMISC_NS_U_SMXP_1_0, RESERVED_59, 59, 5)
    FIELD(POR_MXP_ERRMISC_NS_U_SMXP_1_0, TGTID, 48, 11)
    FIELD(POR_MXP_ERRMISC_NS_U_SMXP_1_0, RESERVED_22, 22, 26)
    FIELD(POR_MXP_ERRMISC_NS_U_SMXP_1_0, OPCODE, 16, 6)
    FIELD(POR_MXP_ERRMISC_NS_U_SMXP_1_0, RESERVED_15, 15, 1)
    FIELD(POR_MXP_ERRMISC_NS_U_SMXP_1_0, SRCID, 4, 11)
    FIELD(POR_MXP_ERRMISC_NS_U_SMXP_1_0, ERRSRC, 0, 3)
REG32(POR_RND_NODE_INFO_U_RND_NID68, 0x814000)
    FIELD(POR_RND_NODE_INFO_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_RND_NODE_INFO_U_RND_NID68, LOGICAL_ID, 32, 16)
    FIELD(POR_RND_NODE_INFO_U_RND_NID68, NODE_ID, 16, 16)
    FIELD(POR_RND_NODE_INFO_U_RND_NID68, NODE_TYPE, 0, 16)
REG32(POR_RND_CHILD_INFO_U_RND_NID68, 0x814080)
    FIELD(POR_RND_CHILD_INFO_U_RND_NID68, RESERVED_32, 32, 32)
    FIELD(POR_RND_CHILD_INFO_U_RND_NID68, CHILD_PTR_OFFSET, 16, 16)
    FIELD(POR_RND_CHILD_INFO_U_RND_NID68, CHILD_COUNT, 0, 16)
REG32(POR_RND_UNIT_INFO_U_RND_NID68, 0x814900)
    FIELD(POR_RND_UNIT_INFO_U_RND_NID68, RESERVED_46, 46, 18)
    FIELD(POR_RND_UNIT_INFO_U_RND_NID68, A4S_SAFE_XFACE_DISABLE, 45, 1)
    FIELD(POR_RND_UNIT_INFO_U_RND_NID68, ACEL_SAFE_XFACE_DISABLE, 44, 1)
    FIELD(POR_RND_UNIT_INFO_U_RND_NID68, A4S_LOGICALID_BASE, 36, 8)
    FIELD(POR_RND_UNIT_INFO_U_RND_NID68, RESERVED_34, 34, 2)
    FIELD(POR_RND_UNIT_INFO_U_RND_NID68, A4S_NUM, 32, 2)
    FIELD(POR_RND_UNIT_INFO_U_RND_NID68, RESERVED_29, 29, 3)
    FIELD(POR_RND_UNIT_INFO_U_RND_NID68, FORCE_RDB_PREALLOC, 28, 1)
    FIELD(POR_RND_UNIT_INFO_U_RND_NID68, AX_DATAPOISON_EN, 27, 1)
    FIELD(POR_RND_UNIT_INFO_U_RND_NID68, AX_DATA_256BIT, 26, 1)
    FIELD(POR_RND_UNIT_INFO_U_RND_NID68, RESERVED_24, 24, 2)
    FIELD(POR_RND_UNIT_INFO_U_RND_NID68, NUM_RD_BUFS, 16, 8)
    FIELD(POR_RND_UNIT_INFO_U_RND_NID68, NUM_RD_REQS, 8, 8)
    FIELD(POR_RND_UNIT_INFO_U_RND_NID68, NUM_WR_REQS, 0, 8)
REG32(POR_RND_SECURE_REGISTER_GROUPS_OVERRIDE_U_RND_NID68, 0x814980)
    FIELD(POR_RND_SECURE_REGISTER_GROUPS_OVERRIDE_U_RND_NID68, QOS_CTRL, 2, 1)
    FIELD(POR_RND_SECURE_REGISTER_GROUPS_OVERRIDE_U_RND_NID68, PORT_CTRL, 1, 1)
    FIELD(POR_RND_SECURE_REGISTER_GROUPS_OVERRIDE_U_RND_NID68, CFG_CTL, 0, 1)
REG32(POR_RND_CFG_CTL_U_RND_NID68, 0x814a00)
    FIELD(POR_RND_CFG_CTL_U_RND_NID68, RESERVED_32, 32, 32)
    FIELD(POR_RND_CFG_CTL_U_RND_NID68, MAX_WRT_OUTSTD_CHITXN_CNT, 24, 8)
    FIELD(POR_RND_CFG_CTL_U_RND_NID68, MAX_RRT_OUTSTD_CHITXN_CNT, 16, 8)
    FIELD(POR_RND_CFG_CTL_U_RND_NID68, RESERVED_15, 15, 1)
    FIELD(POR_RND_CFG_CTL_U_RND_NID68, WRT_CRDGNT_WEIGHT, 12, 3)
    FIELD(POR_RND_CFG_CTL_U_RND_NID68, RESERVED_11, 11, 1)
    FIELD(POR_RND_CFG_CTL_U_RND_NID68, RRT_CRDGNT_WEIGHT, 8, 3)
    FIELD(POR_RND_CFG_CTL_U_RND_NID68, DIS_NCWR_STREAM, 6, 1)
    FIELD(POR_RND_CFG_CTL_U_RND_NID68, PCIE_MSTR_PRESENT, 5, 1)
    FIELD(POR_RND_CFG_CTL_U_RND_NID68, QPC15_ENTRY_RSV_EN, 4, 1)
    FIELD(POR_RND_CFG_CTL_U_RND_NID68, FORCE_PREALLOC_RDB, 3, 1)
    FIELD(POR_RND_CFG_CTL_U_RND_NID68, DIS_WR_STREAM, 2, 1)
    FIELD(POR_RND_CFG_CTL_U_RND_NID68, WFC, 1, 1)
    FIELD(POR_RND_CFG_CTL_U_RND_NID68, QPC_EN, 0, 1)
REG32(POR_RND_AUX_CTL_U_RND_NID68, 0x814a08)
    FIELD(POR_RND_AUX_CTL_U_RND_NID68, SAMEID_WRSTASH_STREAM_EN, 5, 1)
    FIELD(POR_RND_AUX_CTL_U_RND_NID68, UPSTRM_DATCHECK_EN, 4, 1)
    FIELD(POR_RND_AUX_CTL_U_RND_NID68, DIS_NORM_RDSTREAM, 3, 1)
    FIELD(POR_RND_AUX_CTL_U_RND_NID68, PARK_PORT_ARB_PTR, 2, 1)
    FIELD(POR_RND_AUX_CTL_U_RND_NID68, AR_BYP_EN, 1, 1)
    FIELD(POR_RND_AUX_CTL_U_RND_NID68, CG_DISABLE, 0, 1)
REG32(POR_RND_S0_PORT_CONTROL_U_RND_NID68, 0x814a10)
    FIELD(POR_RND_S0_PORT_CONTROL_U_RND_NID68, RESERVED_11, 11, 53)
    FIELD(POR_RND_S0_PORT_CONTROL_U_RND_NID68, S0_LPID_MASK, 0, 11)
REG32(POR_RND_S1_PORT_CONTROL_U_RND_NID68, 0x814a18)
    FIELD(POR_RND_S1_PORT_CONTROL_U_RND_NID68, RESERVED_11, 11, 53)
    FIELD(POR_RND_S1_PORT_CONTROL_U_RND_NID68, S1_LPID_MASK, 0, 11)
REG32(POR_RND_S2_PORT_CONTROL_U_RND_NID68, 0x814a20)
    FIELD(POR_RND_S2_PORT_CONTROL_U_RND_NID68, RESERVED_11, 11, 53)
    FIELD(POR_RND_S2_PORT_CONTROL_U_RND_NID68, S2_LPID_MASK, 0, 11)
REG32(POR_RND_S0_QOS_CONTROL_U_RND_NID68, 0x814a80)
    FIELD(POR_RND_S0_QOS_CONTROL_U_RND_NID68, RESERVED_24, 24, 40)
    FIELD(POR_RND_S0_QOS_CONTROL_U_RND_NID68, S0_AR_QOS_OVERRIDE, 20, 4)
    FIELD(POR_RND_S0_QOS_CONTROL_U_RND_NID68, S0_AW_QOS_OVERRIDE, 16, 4)
    FIELD(POR_RND_S0_QOS_CONTROL_U_RND_NID68, S0_AR_PQV_MODE, 7, 1)
    FIELD(POR_RND_S0_QOS_CONTROL_U_RND_NID68, S0_AW_PQV_MODE, 6, 1)
    FIELD(POR_RND_S0_QOS_CONTROL_U_RND_NID68, S0_AR_REG_MODE, 5, 1)
    FIELD(POR_RND_S0_QOS_CONTROL_U_RND_NID68, S0_AW_REG_MODE, 4, 1)
    FIELD(POR_RND_S0_QOS_CONTROL_U_RND_NID68, S0_AR_QOS_OVERRIDE_EN, 3, 1)
    FIELD(POR_RND_S0_QOS_CONTROL_U_RND_NID68, S0_AW_QOS_OVERRIDE_EN, 2, 1)
    FIELD(POR_RND_S0_QOS_CONTROL_U_RND_NID68, S0_AR_LAT_EN, 1, 1)
    FIELD(POR_RND_S0_QOS_CONTROL_U_RND_NID68, S0_AW_LAT_EN, 0, 1)
REG32(POR_RND_S0_QOS_LAT_TGT_U_RND_NID68, 0x814a88)
    FIELD(POR_RND_S0_QOS_LAT_TGT_U_RND_NID68, RESERVED_28, 28, 36)
    FIELD(POR_RND_S0_QOS_LAT_TGT_U_RND_NID68, S0_AR_LAT_TGT, 16, 12)
    FIELD(POR_RND_S0_QOS_LAT_TGT_U_RND_NID68, RESERVED_12, 12, 4)
    FIELD(POR_RND_S0_QOS_LAT_TGT_U_RND_NID68, S0_AW_LAT_TGT, 0, 12)
REG32(POR_RND_S0_QOS_LAT_SCALE_U_RND_NID68, 0x814a90)
    FIELD(POR_RND_S0_QOS_LAT_SCALE_U_RND_NID68, RESERVED_11, 11, 53)
    FIELD(POR_RND_S0_QOS_LAT_SCALE_U_RND_NID68, S0_AR_LAT_SCALE, 8, 3)
    FIELD(POR_RND_S0_QOS_LAT_SCALE_U_RND_NID68, S0_AW_LAT_SCALE, 0, 3)
REG32(POR_RND_S0_QOS_LAT_RANGE_U_RND_NID68, 0x814a98)
    FIELD(POR_RND_S0_QOS_LAT_RANGE_U_RND_NID68, RESERVED_28, 28, 36)
    FIELD(POR_RND_S0_QOS_LAT_RANGE_U_RND_NID68, S0_AR_LAT_MAX_QOS, 24, 4)
    FIELD(POR_RND_S0_QOS_LAT_RANGE_U_RND_NID68, RESERVED_20, 20, 4)
    FIELD(POR_RND_S0_QOS_LAT_RANGE_U_RND_NID68, S0_AR_LAT_MIN_QOS, 16, 4)
    FIELD(POR_RND_S0_QOS_LAT_RANGE_U_RND_NID68, RESERVED_12, 12, 4)
    FIELD(POR_RND_S0_QOS_LAT_RANGE_U_RND_NID68, S0_AW_LAT_MAX_QOS, 8, 4)
    FIELD(POR_RND_S0_QOS_LAT_RANGE_U_RND_NID68, S0_AW_LAT_MIN_QOS, 0, 4)
REG32(POR_RND_S1_QOS_CONTROL_U_RND_NID68, 0x814aa0)
    FIELD(POR_RND_S1_QOS_CONTROL_U_RND_NID68, RESERVED_24, 24, 40)
    FIELD(POR_RND_S1_QOS_CONTROL_U_RND_NID68, S1_AR_QOS_OVERRIDE, 20, 4)
    FIELD(POR_RND_S1_QOS_CONTROL_U_RND_NID68, S1_AW_QOS_OVERRIDE, 16, 4)
    FIELD(POR_RND_S1_QOS_CONTROL_U_RND_NID68, S1_AR_PQV_MODE, 7, 1)
    FIELD(POR_RND_S1_QOS_CONTROL_U_RND_NID68, S1_AW_PQV_MODE, 6, 1)
    FIELD(POR_RND_S1_QOS_CONTROL_U_RND_NID68, S1_AR_REG_MODE, 5, 1)
    FIELD(POR_RND_S1_QOS_CONTROL_U_RND_NID68, S1_AW_REG_MODE, 4, 1)
    FIELD(POR_RND_S1_QOS_CONTROL_U_RND_NID68, S1_AR_QOS_OVERRIDE_EN, 3, 1)
    FIELD(POR_RND_S1_QOS_CONTROL_U_RND_NID68, S1_AW_QOS_OVERRIDE_EN, 2, 1)
    FIELD(POR_RND_S1_QOS_CONTROL_U_RND_NID68, S1_AR_LAT_EN, 1, 1)
    FIELD(POR_RND_S1_QOS_CONTROL_U_RND_NID68, S1_AW_LAT_EN, 0, 1)
REG32(POR_RND_S1_QOS_LAT_TGT_U_RND_NID68, 0x814aa8)
    FIELD(POR_RND_S1_QOS_LAT_TGT_U_RND_NID68, RESERVED_28, 28, 36)
    FIELD(POR_RND_S1_QOS_LAT_TGT_U_RND_NID68, S1_AR_LAT_TGT, 16, 12)
    FIELD(POR_RND_S1_QOS_LAT_TGT_U_RND_NID68, RESERVED_12, 12, 4)
    FIELD(POR_RND_S1_QOS_LAT_TGT_U_RND_NID68, S1_AW_LAT_TGT, 0, 12)
REG32(POR_RND_S1_QOS_LAT_SCALE_U_RND_NID68, 0x814ab0)
    FIELD(POR_RND_S1_QOS_LAT_SCALE_U_RND_NID68, RESERVED_11, 11, 53)
    FIELD(POR_RND_S1_QOS_LAT_SCALE_U_RND_NID68, S1_AR_LAT_SCALE, 8, 3)
    FIELD(POR_RND_S1_QOS_LAT_SCALE_U_RND_NID68, S1_AW_LAT_SCALE, 0, 3)
REG32(POR_RND_S1_QOS_LAT_RANGE_U_RND_NID68, 0x814ab8)
    FIELD(POR_RND_S1_QOS_LAT_RANGE_U_RND_NID68, RESERVED_28, 28, 36)
    FIELD(POR_RND_S1_QOS_LAT_RANGE_U_RND_NID68, S1_AR_LAT_MAX_QOS, 24, 4)
    FIELD(POR_RND_S1_QOS_LAT_RANGE_U_RND_NID68, RESERVED_20, 20, 4)
    FIELD(POR_RND_S1_QOS_LAT_RANGE_U_RND_NID68, S1_AR_LAT_MIN_QOS, 16, 4)
    FIELD(POR_RND_S1_QOS_LAT_RANGE_U_RND_NID68, RESERVED_12, 12, 4)
    FIELD(POR_RND_S1_QOS_LAT_RANGE_U_RND_NID68, S1_AW_LAT_MAX_QOS, 8, 4)
    FIELD(POR_RND_S1_QOS_LAT_RANGE_U_RND_NID68, S1_AW_LAT_MIN_QOS, 0, 4)
REG32(POR_RND_S2_QOS_CONTROL_U_RND_NID68, 0x814ac0)
    FIELD(POR_RND_S2_QOS_CONTROL_U_RND_NID68, RESERVED_24, 24, 40)
    FIELD(POR_RND_S2_QOS_CONTROL_U_RND_NID68, S2_AR_QOS_OVERRIDE, 20, 4)
    FIELD(POR_RND_S2_QOS_CONTROL_U_RND_NID68, S2_AW_QOS_OVERRIDE, 16, 4)
    FIELD(POR_RND_S2_QOS_CONTROL_U_RND_NID68, S2_AR_PQV_MODE, 7, 1)
    FIELD(POR_RND_S2_QOS_CONTROL_U_RND_NID68, S2_AW_PQV_MODE, 6, 1)
    FIELD(POR_RND_S2_QOS_CONTROL_U_RND_NID68, S2_AR_REG_MODE, 5, 1)
    FIELD(POR_RND_S2_QOS_CONTROL_U_RND_NID68, S2_AW_REG_MODE, 4, 1)
    FIELD(POR_RND_S2_QOS_CONTROL_U_RND_NID68, S2_AR_QOS_OVERRIDE_EN, 3, 1)
    FIELD(POR_RND_S2_QOS_CONTROL_U_RND_NID68, S2_AW_QOS_OVERRIDE_EN, 2, 1)
    FIELD(POR_RND_S2_QOS_CONTROL_U_RND_NID68, S2_AR_LAT_EN, 1, 1)
    FIELD(POR_RND_S2_QOS_CONTROL_U_RND_NID68, S2_AW_LAT_EN, 0, 1)
REG32(POR_RND_S2_QOS_LAT_TGT_U_RND_NID68, 0x814ac8)
    FIELD(POR_RND_S2_QOS_LAT_TGT_U_RND_NID68, RESERVED_28, 28, 36)
    FIELD(POR_RND_S2_QOS_LAT_TGT_U_RND_NID68, S2_AR_LAT_TGT, 16, 12)
    FIELD(POR_RND_S2_QOS_LAT_TGT_U_RND_NID68, RESERVED_12, 12, 4)
    FIELD(POR_RND_S2_QOS_LAT_TGT_U_RND_NID68, S2_AW_LAT_TGT, 0, 12)
REG32(POR_RND_S2_QOS_LAT_SCALE_U_RND_NID68, 0x814ad0)
    FIELD(POR_RND_S2_QOS_LAT_SCALE_U_RND_NID68, RESERVED_11, 11, 53)
    FIELD(POR_RND_S2_QOS_LAT_SCALE_U_RND_NID68, S2_AR_LAT_SCALE, 8, 3)
    FIELD(POR_RND_S2_QOS_LAT_SCALE_U_RND_NID68, S2_AW_LAT_SCALE, 0, 3)
REG32(POR_RND_S2_QOS_LAT_RANGE_U_RND_NID68, 0x814ad8)
    FIELD(POR_RND_S2_QOS_LAT_RANGE_U_RND_NID68, RESERVED_28, 28, 36)
    FIELD(POR_RND_S2_QOS_LAT_RANGE_U_RND_NID68, S2_AR_LAT_MAX_QOS, 24, 4)
    FIELD(POR_RND_S2_QOS_LAT_RANGE_U_RND_NID68, RESERVED_20, 20, 4)
    FIELD(POR_RND_S2_QOS_LAT_RANGE_U_RND_NID68, S2_AR_LAT_MIN_QOS, 16, 4)
    FIELD(POR_RND_S2_QOS_LAT_RANGE_U_RND_NID68, RESERVED_12, 12, 4)
    FIELD(POR_RND_S2_QOS_LAT_RANGE_U_RND_NID68, S2_AW_LAT_MAX_QOS, 8, 4)
    FIELD(POR_RND_S2_QOS_LAT_RANGE_U_RND_NID68, S2_AW_LAT_MIN_QOS, 0, 4)
REG32(POR_RND_SYSCOREQ_CTL_U_RND_NID68, 0x815000)
    FIELD(POR_RND_SYSCOREQ_CTL_U_RND_NID68, S2_DVMDOMAIN_REQ, 2, 1)
    FIELD(POR_RND_SYSCOREQ_CTL_U_RND_NID68, S1_DVMDOMAIN_REQ, 1, 1)
    FIELD(POR_RND_SYSCOREQ_CTL_U_RND_NID68, S0_DVMDOMAIN_REQ, 0, 1)
REG32(POR_RND_SYSCOACK_STATUS_U_RND_NID68, 0x815008)
    FIELD(POR_RND_SYSCOACK_STATUS_U_RND_NID68, S2_DVMDOMAIN_ACK, 2, 1)
    FIELD(POR_RND_SYSCOACK_STATUS_U_RND_NID68, S1_DVMDOMAIN_ACK, 1, 1)
    FIELD(POR_RND_SYSCOACK_STATUS_U_RND_NID68, S0_DVMDOMAIN_ACK, 0, 1)
REG32(POR_RND_PMU_EVENT_SEL_U_RND_NID68, 0x816000)
    FIELD(POR_RND_PMU_EVENT_SEL_U_RND_NID68, RESERVED_29, 29, 35)
    FIELD(POR_RND_PMU_EVENT_SEL_U_RND_NID68, PMU_EVENT3_ID, 24, 5)
    FIELD(POR_RND_PMU_EVENT_SEL_U_RND_NID68, RESERVED_21, 21, 3)
    FIELD(POR_RND_PMU_EVENT_SEL_U_RND_NID68, PMU_EVENT2_ID, 16, 5)
    FIELD(POR_RND_PMU_EVENT_SEL_U_RND_NID68, RESERVED_13, 13, 3)
    FIELD(POR_RND_PMU_EVENT_SEL_U_RND_NID68, PMU_EVENT1_ID, 8, 5)
    FIELD(POR_RND_PMU_EVENT_SEL_U_RND_NID68, PMU_EVENT0_ID, 0, 5)
REG32(POR_RNSAM_NODE_INFO_U_RND_NID68, 0x824000)
    FIELD(POR_RNSAM_NODE_INFO_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_RNSAM_NODE_INFO_U_RND_NID68, LOGICAL_ID, 32, 16)
    FIELD(POR_RNSAM_NODE_INFO_U_RND_NID68, NODE_ID, 16, 16)
    FIELD(POR_RNSAM_NODE_INFO_U_RND_NID68, NODE_TYPE, 0, 16)
REG32(POR_RNSAM_CHILD_INFO_U_RND_NID68, 0x824080)
    FIELD(POR_RNSAM_CHILD_INFO_U_RND_NID68, RESERVED_32, 32, 32)
    FIELD(POR_RNSAM_CHILD_INFO_U_RND_NID68, CHILD_PTR_OFFSET, 16, 16)
    FIELD(POR_RNSAM_CHILD_INFO_U_RND_NID68, CHILD_COUNT, 0, 16)
REG32(POR_RNSAM_UNIT_INFO_U_RND_NID68, 0x824900)
    FIELD(POR_RNSAM_UNIT_INFO_U_RND_NID68, RESERVED_37, 37, 27)
    FIELD(POR_RNSAM_UNIT_INFO_U_RND_NID68, NUM_NON_HASH_GROUP, 32, 5)
    FIELD(POR_RNSAM_UNIT_INFO_U_RND_NID68, RESERVED_20, 20, 12)
    FIELD(POR_RNSAM_UNIT_INFO_U_RND_NID68, NUM_SYS_CACHE_GROUP, 16, 4)
    FIELD(POR_RNSAM_UNIT_INFO_U_RND_NID68, NUM_HNF, 0, 8)
REG32(POR_RNSAM_SECURE_REGISTER_GROUPS_OVERRIDE_U_RND_NID68, 0x824980)
    FIELD(POR_RNSAM_SECURE_REGISTER_GROUPS_OVERRIDE_U_RND_NID68, MEM_RANGE, 0, 1)
REG32(RNSAM_STATUS_U_RND_NID68, 0x824c00)
    FIELD(RNSAM_STATUS_U_RND_NID68, NSTALL_REQ, 1, 1)
    FIELD(RNSAM_STATUS_U_RND_NID68, USE_DEFAULT_NODE, 0, 1)
REG32(NON_HASH_MEM_REGION_REG0_U_RND_NID68, 0x824c08)
    FIELD(NON_HASH_MEM_REGION_REG0_U_RND_NID68, RESERVED_63, 63, 1)
    FIELD(NON_HASH_MEM_REGION_REG0_U_RND_NID68, REGION1_BASE_ADDR, 41, 22)
    FIELD(NON_HASH_MEM_REGION_REG0_U_RND_NID68, REGION1_SIZE, 36, 5)
    FIELD(NON_HASH_MEM_REGION_REG0_U_RND_NID68, REGION1_TARGET_TYPE, 34, 2)
    FIELD(NON_HASH_MEM_REGION_REG0_U_RND_NID68, RESERVED_33, 33, 1)
    FIELD(NON_HASH_MEM_REGION_REG0_U_RND_NID68, REGION1_VALID, 32, 1)
    FIELD(NON_HASH_MEM_REGION_REG0_U_RND_NID68, RESERVED_31, 31, 1)
    FIELD(NON_HASH_MEM_REGION_REG0_U_RND_NID68, REGION0_BASE_ADDR, 9, 22)
    FIELD(NON_HASH_MEM_REGION_REG0_U_RND_NID68, REGION0_SIZE, 4, 5)
    FIELD(NON_HASH_MEM_REGION_REG0_U_RND_NID68, REGION0_TARGET_TYPE, 2, 2)
    FIELD(NON_HASH_MEM_REGION_REG0_U_RND_NID68, REGION0_VALID, 0, 1)
REG32(NON_HASH_MEM_REGION_REG1_U_RND_NID68, 0x824c10)
    FIELD(NON_HASH_MEM_REGION_REG1_U_RND_NID68, RESERVED_63, 63, 1)
    FIELD(NON_HASH_MEM_REGION_REG1_U_RND_NID68, REGION3_BASE_ADDR, 41, 22)
    FIELD(NON_HASH_MEM_REGION_REG1_U_RND_NID68, REGION3_SIZE, 36, 5)
    FIELD(NON_HASH_MEM_REGION_REG1_U_RND_NID68, REGION3_TARGET_TYPE, 34, 2)
    FIELD(NON_HASH_MEM_REGION_REG1_U_RND_NID68, RESERVED_33, 33, 1)
    FIELD(NON_HASH_MEM_REGION_REG1_U_RND_NID68, REGION3_VALID, 32, 1)
    FIELD(NON_HASH_MEM_REGION_REG1_U_RND_NID68, RESERVED_31, 31, 1)
    FIELD(NON_HASH_MEM_REGION_REG1_U_RND_NID68, REGION2_BASE_ADDR, 9, 22)
    FIELD(NON_HASH_MEM_REGION_REG1_U_RND_NID68, REGION2_SIZE, 4, 5)
    FIELD(NON_HASH_MEM_REGION_REG1_U_RND_NID68, REGION2_TARGET_TYPE, 2, 2)
    FIELD(NON_HASH_MEM_REGION_REG1_U_RND_NID68, REGION2_VALID, 0, 1)
REG32(NON_HASH_MEM_REGION_REG2_U_RND_NID68, 0x824c18)
    FIELD(NON_HASH_MEM_REGION_REG2_U_RND_NID68, RESERVED_63, 63, 1)
    FIELD(NON_HASH_MEM_REGION_REG2_U_RND_NID68, REGION5_BASE_ADDR, 41, 22)
    FIELD(NON_HASH_MEM_REGION_REG2_U_RND_NID68, REGION5_SIZE, 36, 5)
    FIELD(NON_HASH_MEM_REGION_REG2_U_RND_NID68, REGION5_TARGET_TYPE, 34, 2)
    FIELD(NON_HASH_MEM_REGION_REG2_U_RND_NID68, RESERVED_33, 33, 1)
    FIELD(NON_HASH_MEM_REGION_REG2_U_RND_NID68, REGION5_VALID, 32, 1)
    FIELD(NON_HASH_MEM_REGION_REG2_U_RND_NID68, RESERVED_31, 31, 1)
    FIELD(NON_HASH_MEM_REGION_REG2_U_RND_NID68, REGION4_BASE_ADDR, 9, 22)
    FIELD(NON_HASH_MEM_REGION_REG2_U_RND_NID68, REGION4_SIZE, 4, 5)
    FIELD(NON_HASH_MEM_REGION_REG2_U_RND_NID68, REGION4_TARGET_TYPE, 2, 2)
    FIELD(NON_HASH_MEM_REGION_REG2_U_RND_NID68, REGION4_VALID, 0, 1)
REG32(NON_HASH_MEM_REGION_REG3_U_RND_NID68, 0x824c20)
    FIELD(NON_HASH_MEM_REGION_REG3_U_RND_NID68, RESERVED_63, 63, 1)
    FIELD(NON_HASH_MEM_REGION_REG3_U_RND_NID68, REGION7_BASE_ADDR, 41, 22)
    FIELD(NON_HASH_MEM_REGION_REG3_U_RND_NID68, REGION7_SIZE, 36, 5)
    FIELD(NON_HASH_MEM_REGION_REG3_U_RND_NID68, REGION7_TARGET_TYPE, 34, 2)
    FIELD(NON_HASH_MEM_REGION_REG3_U_RND_NID68, RESERVED_33, 33, 1)
    FIELD(NON_HASH_MEM_REGION_REG3_U_RND_NID68, REGION7_VALID, 32, 1)
    FIELD(NON_HASH_MEM_REGION_REG3_U_RND_NID68, RESERVED_31, 31, 1)
    FIELD(NON_HASH_MEM_REGION_REG3_U_RND_NID68, REGION6_BASE_ADDR, 9, 22)
    FIELD(NON_HASH_MEM_REGION_REG3_U_RND_NID68, REGION6_SIZE, 4, 5)
    FIELD(NON_HASH_MEM_REGION_REG3_U_RND_NID68, REGION6_TARGET_TYPE, 2, 2)
    FIELD(NON_HASH_MEM_REGION_REG3_U_RND_NID68, REGION6_VALID, 0, 1)
REG32(NON_HASH_TGT_NODEID0_U_RND_NID68, 0x824c30)
    FIELD(NON_HASH_TGT_NODEID0_U_RND_NID68, RESERVED_47, 47, 17)
    FIELD(NON_HASH_TGT_NODEID0_U_RND_NID68, NODEID_3, 36, 11)
    FIELD(NON_HASH_TGT_NODEID0_U_RND_NID68, RESERVED_35, 35, 1)
    FIELD(NON_HASH_TGT_NODEID0_U_RND_NID68, NODEID_2, 24, 11)
    FIELD(NON_HASH_TGT_NODEID0_U_RND_NID68, RESERVED_23, 23, 1)
    FIELD(NON_HASH_TGT_NODEID0_U_RND_NID68, NODEID_1, 12, 11)
    FIELD(NON_HASH_TGT_NODEID0_U_RND_NID68, RESERVED_11, 11, 1)
    FIELD(NON_HASH_TGT_NODEID0_U_RND_NID68, NODEID_0, 0, 11)
REG32(NON_HASH_TGT_NODEID1_U_RND_NID68, 0x824c38)
    FIELD(NON_HASH_TGT_NODEID1_U_RND_NID68, RESERVED_47, 47, 17)
    FIELD(NON_HASH_TGT_NODEID1_U_RND_NID68, NODEID_7, 36, 11)
    FIELD(NON_HASH_TGT_NODEID1_U_RND_NID68, RESERVED_35, 35, 1)
    FIELD(NON_HASH_TGT_NODEID1_U_RND_NID68, NODEID_6, 24, 11)
    FIELD(NON_HASH_TGT_NODEID1_U_RND_NID68, RESERVED_23, 23, 1)
    FIELD(NON_HASH_TGT_NODEID1_U_RND_NID68, NODEID_5, 12, 11)
    FIELD(NON_HASH_TGT_NODEID1_U_RND_NID68, RESERVED_11, 11, 1)
    FIELD(NON_HASH_TGT_NODEID1_U_RND_NID68, NODEID_4, 0, 11)
REG32(NON_HASH_TGT_NODEID2_U_RND_NID68, 0x824c40)
    FIELD(NON_HASH_TGT_NODEID2_U_RND_NID68, RESERVED_23, 23, 41)
    FIELD(NON_HASH_TGT_NODEID2_U_RND_NID68, NODEID_9, 12, 11)
    FIELD(NON_HASH_TGT_NODEID2_U_RND_NID68, RESERVED_11, 11, 1)
    FIELD(NON_HASH_TGT_NODEID2_U_RND_NID68, NODEID_8, 0, 11)
REG32(SYS_CACHE_GRP_REGION0_U_RND_NID68, 0x824c48)
    FIELD(SYS_CACHE_GRP_REGION0_U_RND_NID68, RESERVED_63, 63, 1)
    FIELD(SYS_CACHE_GRP_REGION0_U_RND_NID68, REGION1_BASE_ADDR, 41, 22)
    FIELD(SYS_CACHE_GRP_REGION0_U_RND_NID68, REGION1_SIZE, 36, 5)
    FIELD(SYS_CACHE_GRP_REGION0_U_RND_NID68, REGION1_TARGET_TYPE, 34, 2)
    FIELD(SYS_CACHE_GRP_REGION0_U_RND_NID68, REGION1_NONHASH_REG_EN, 33, 1)
    FIELD(SYS_CACHE_GRP_REGION0_U_RND_NID68, REGION1_VALID, 32, 1)
    FIELD(SYS_CACHE_GRP_REGION0_U_RND_NID68, RESERVED_31, 31, 1)
    FIELD(SYS_CACHE_GRP_REGION0_U_RND_NID68, REGION0_BASE_ADDR, 9, 22)
    FIELD(SYS_CACHE_GRP_REGION0_U_RND_NID68, REGION0_SIZE, 4, 5)
    FIELD(SYS_CACHE_GRP_REGION0_U_RND_NID68, REGION0_TARGET_TYPE, 2, 2)
    FIELD(SYS_CACHE_GRP_REGION0_U_RND_NID68, REGION0_VALID, 0, 1)
REG32(SYS_CACHE_GRP_REGION1_U_RND_NID68, 0x824c50)
    FIELD(SYS_CACHE_GRP_REGION1_U_RND_NID68, RESERVED_63, 63, 1)
    FIELD(SYS_CACHE_GRP_REGION1_U_RND_NID68, REGION3_BASE_ADDR, 41, 22)
    FIELD(SYS_CACHE_GRP_REGION1_U_RND_NID68, REGION3_SIZE, 36, 5)
    FIELD(SYS_CACHE_GRP_REGION1_U_RND_NID68, REGION3_TARGET_TYPE, 34, 2)
    FIELD(SYS_CACHE_GRP_REGION1_U_RND_NID68, REGION3_NONHASH_REG_EN, 33, 1)
    FIELD(SYS_CACHE_GRP_REGION1_U_RND_NID68, REGION3_VALID, 32, 1)
    FIELD(SYS_CACHE_GRP_REGION1_U_RND_NID68, RESERVED_31, 31, 1)
    FIELD(SYS_CACHE_GRP_REGION1_U_RND_NID68, REGION2_BASE_ADDR, 9, 22)
    FIELD(SYS_CACHE_GRP_REGION1_U_RND_NID68, REGION2_SIZE, 4, 5)
    FIELD(SYS_CACHE_GRP_REGION1_U_RND_NID68, REGION2_TARGET_TYPE, 2, 2)
    FIELD(SYS_CACHE_GRP_REGION1_U_RND_NID68, REGION2_NONHASH_REG_EN, 1, 1)
    FIELD(SYS_CACHE_GRP_REGION1_U_RND_NID68, REGION2_VALID, 0, 1)
REG32(SYS_CACHE_GRP_HN_NODEID_REG0_U_RND_NID68, 0x824c58)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG0_U_RND_NID68, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG0_U_RND_NID68, NODEID_3, 36, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG0_U_RND_NID68, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG0_U_RND_NID68, NODEID_2, 24, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG0_U_RND_NID68, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG0_U_RND_NID68, NODEID_1, 12, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG0_U_RND_NID68, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG0_U_RND_NID68, NODEID_0, 0, 11)
REG32(SYS_CACHE_GRP_HN_NODEID_REG1_U_RND_NID68, 0x824c60)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG1_U_RND_NID68, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG1_U_RND_NID68, NODEID_7, 36, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG1_U_RND_NID68, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG1_U_RND_NID68, NODEID_6, 24, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG1_U_RND_NID68, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG1_U_RND_NID68, NODEID_5, 12, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG1_U_RND_NID68, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG1_U_RND_NID68, NODEID_4, 0, 11)
REG32(SYS_CACHE_GRP_HN_NODEID_REG2_U_RND_NID68, 0x824c68)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG2_U_RND_NID68, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG2_U_RND_NID68, NODEID_11, 36, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG2_U_RND_NID68, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG2_U_RND_NID68, NODEID_10, 24, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG2_U_RND_NID68, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG2_U_RND_NID68, NODEID_9, 12, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG2_U_RND_NID68, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG2_U_RND_NID68, NODEID_8, 0, 11)
REG32(SYS_CACHE_GRP_HN_NODEID_REG3_U_RND_NID68, 0x824c70)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG3_U_RND_NID68, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG3_U_RND_NID68, NODEID_15, 36, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG3_U_RND_NID68, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG3_U_RND_NID68, NODEID_14, 24, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG3_U_RND_NID68, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG3_U_RND_NID68, NODEID_13, 12, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG3_U_RND_NID68, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG3_U_RND_NID68, NODEID_12, 0, 11)
REG32(SYS_CACHE_GRP_HN_NODEID_REG4_U_RND_NID68, 0x824c78)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG4_U_RND_NID68, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG4_U_RND_NID68, NODEID_19, 36, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG4_U_RND_NID68, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG4_U_RND_NID68, NODEID_18, 24, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG4_U_RND_NID68, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG4_U_RND_NID68, NODEID_17, 12, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG4_U_RND_NID68, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG4_U_RND_NID68, NODEID_16, 0, 11)
REG32(SYS_CACHE_GRP_HN_NODEID_REG5_U_RND_NID68, 0x824c80)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG5_U_RND_NID68, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG5_U_RND_NID68, NODEID_23, 36, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG5_U_RND_NID68, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG5_U_RND_NID68, NODEID_22, 24, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG5_U_RND_NID68, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG5_U_RND_NID68, NODEID_21, 12, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG5_U_RND_NID68, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG5_U_RND_NID68, NODEID_20, 0, 11)
REG32(SYS_CACHE_GRP_HN_NODEID_REG6_U_RND_NID68, 0x824c88)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG6_U_RND_NID68, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG6_U_RND_NID68, NODEID_27, 36, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG6_U_RND_NID68, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG6_U_RND_NID68, NODEID_26, 24, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG6_U_RND_NID68, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG6_U_RND_NID68, NODEID_25, 12, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG6_U_RND_NID68, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG6_U_RND_NID68, NODEID_24, 0, 11)
REG32(SYS_CACHE_GRP_HN_NODEID_REG7_U_RND_NID68, 0x824c90)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG7_U_RND_NID68, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG7_U_RND_NID68, NODEID_31, 36, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG7_U_RND_NID68, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG7_U_RND_NID68, NODEID_30, 24, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG7_U_RND_NID68, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG7_U_RND_NID68, NODEID_29, 12, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG7_U_RND_NID68, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG7_U_RND_NID68, NODEID_28, 0, 11)
REG32(SYS_CACHE_GRP_NONHASH_NODEID_U_RND_NID68, 0x824c98)
    FIELD(SYS_CACHE_GRP_NONHASH_NODEID_U_RND_NID68, RESERVED_35, 35, 29)
    FIELD(SYS_CACHE_GRP_NONHASH_NODEID_U_RND_NID68, SCG3_NODEID, 24, 11)
    FIELD(SYS_CACHE_GRP_NONHASH_NODEID_U_RND_NID68, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_NONHASH_NODEID_U_RND_NID68, SCG2_NODEID, 12, 11)
    FIELD(SYS_CACHE_GRP_NONHASH_NODEID_U_RND_NID68, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_NONHASH_NODEID_U_RND_NID68, SCG1_NODEID, 0, 11)
REG32(SYS_CACHE_GROUP_HN_COUNT_U_RND_NID68, 0x824d00)
    FIELD(SYS_CACHE_GROUP_HN_COUNT_U_RND_NID68, RESERVED_31, 31, 33)
    FIELD(SYS_CACHE_GROUP_HN_COUNT_U_RND_NID68, SCG3_NUM_HNF, 24, 7)
    FIELD(SYS_CACHE_GROUP_HN_COUNT_U_RND_NID68, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GROUP_HN_COUNT_U_RND_NID68, SCG2_NUM_HNF, 16, 7)
    FIELD(SYS_CACHE_GROUP_HN_COUNT_U_RND_NID68, RESERVED_15, 15, 1)
    FIELD(SYS_CACHE_GROUP_HN_COUNT_U_RND_NID68, SCG1_NUM_HNF, 8, 7)
    FIELD(SYS_CACHE_GROUP_HN_COUNT_U_RND_NID68, SCG0_NUM_HNF, 0, 7)
REG32(SYS_CACHE_GRP_SN_NODEID_REG0_U_RND_NID68, 0x824d08)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG0_U_RND_NID68, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG0_U_RND_NID68, SN_NODEID_3, 36, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG0_U_RND_NID68, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG0_U_RND_NID68, SN_NODEID_2, 24, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG0_U_RND_NID68, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG0_U_RND_NID68, SN_NODEID_1, 12, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG0_U_RND_NID68, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG0_U_RND_NID68, SN_NODEID_0, 0, 11)
REG32(SYS_CACHE_GRP_SN_NODEID_REG1_U_RND_NID68, 0x824d10)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG1_U_RND_NID68, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG1_U_RND_NID68, SN_NODEID_7, 36, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG1_U_RND_NID68, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG1_U_RND_NID68, SN_NODEID_6, 24, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG1_U_RND_NID68, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG1_U_RND_NID68, SN_NODEID_5, 12, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG1_U_RND_NID68, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG1_U_RND_NID68, SN_NODEID_4, 0, 11)
REG32(SYS_CACHE_GRP_SN_NODEID_REG2_U_RND_NID68, 0x824d18)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG2_U_RND_NID68, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG2_U_RND_NID68, SN_NODEID_11, 36, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG2_U_RND_NID68, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG2_U_RND_NID68, SN_NODEID_10, 24, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG2_U_RND_NID68, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG2_U_RND_NID68, SN_NODEID_9, 12, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG2_U_RND_NID68, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG2_U_RND_NID68, SN_NODEID_8, 0, 11)
REG32(SYS_CACHE_GRP_SN_NODEID_REG3_U_RND_NID68, 0x824d20)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG3_U_RND_NID68, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG3_U_RND_NID68, SN_NODEID_15, 36, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG3_U_RND_NID68, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG3_U_RND_NID68, SN_NODEID_14, 24, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG3_U_RND_NID68, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG3_U_RND_NID68, SN_NODEID_13, 12, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG3_U_RND_NID68, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG3_U_RND_NID68, SN_NODEID_12, 0, 11)
REG32(SYS_CACHE_GRP_SN_NODEID_REG4_U_RND_NID68, 0x824d28)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG4_U_RND_NID68, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG4_U_RND_NID68, SN_NODEID_19, 36, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG4_U_RND_NID68, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG4_U_RND_NID68, SN_NODEID_18, 24, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG4_U_RND_NID68, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG4_U_RND_NID68, SN_NODEID_17, 12, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG4_U_RND_NID68, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG4_U_RND_NID68, SN_NODEID_16, 0, 11)
REG32(SYS_CACHE_GRP_SN_NODEID_REG5_U_RND_NID68, 0x824d30)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG5_U_RND_NID68, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG5_U_RND_NID68, SN_NODEID_23, 36, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG5_U_RND_NID68, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG5_U_RND_NID68, SN_NODEID_22, 24, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG5_U_RND_NID68, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG5_U_RND_NID68, SN_NODEID_21, 12, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG5_U_RND_NID68, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG5_U_RND_NID68, SN_NODEID_20, 0, 11)
REG32(SYS_CACHE_GRP_SN_NODEID_REG6_U_RND_NID68, 0x824d38)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG6_U_RND_NID68, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG6_U_RND_NID68, SN_NODEID_27, 36, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG6_U_RND_NID68, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG6_U_RND_NID68, SN_NODEID_26, 24, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG6_U_RND_NID68, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG6_U_RND_NID68, SN_NODEID_25, 12, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG6_U_RND_NID68, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG6_U_RND_NID68, SN_NODEID_24, 0, 11)
REG32(SYS_CACHE_GRP_SN_NODEID_REG7_U_RND_NID68, 0x824d40)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG7_U_RND_NID68, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG7_U_RND_NID68, SN_NODEID_31, 36, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG7_U_RND_NID68, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG7_U_RND_NID68, SN_NODEID_30, 24, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG7_U_RND_NID68, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG7_U_RND_NID68, SN_NODEID_29, 12, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG7_U_RND_NID68, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG7_U_RND_NID68, SN_NODEID_28, 0, 11)
REG32(SYS_CACHE_GRP_SN_SAM_CFG0_U_RND_NID68, 0x824d48)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG0_U_RND_NID68, RESERVED_46, 46, 18)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG0_U_RND_NID68, SCG1_TOP_ADDRESS_BIT2, 40, 6)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG0_U_RND_NID68, RESERVED_38, 38, 2)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG0_U_RND_NID68, SCG1_TOP_ADDRESS_BIT1, 32, 6)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG0_U_RND_NID68, RESERVED_30, 30, 2)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG0_U_RND_NID68, SCG1_TOP_ADDRESS_BIT0, 24, 6)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG0_U_RND_NID68, RESERVED_22, 22, 2)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG0_U_RND_NID68, SCG0_TOP_ADDRESS_BIT2, 16, 6)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG0_U_RND_NID68, RESERVED_14, 14, 2)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG0_U_RND_NID68, SCG0_TOP_ADDRESS_BIT1, 8, 6)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG0_U_RND_NID68, SCG0_TOP_ADDRESS_BIT0, 0, 6)
REG32(SYS_CACHE_GRP_SN_SAM_CFG1_U_RND_NID68, 0x824d50)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG1_U_RND_NID68, RESERVED_46, 46, 18)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG1_U_RND_NID68, SCG3_TOP_ADDRESS_BIT2, 40, 6)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG1_U_RND_NID68, RESERVED_38, 38, 2)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG1_U_RND_NID68, SCG3_TOP_ADDRESS_BIT1, 32, 6)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG1_U_RND_NID68, RESERVED_30, 30, 2)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG1_U_RND_NID68, SCG3_TOP_ADDRESS_BIT0, 24, 6)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG1_U_RND_NID68, RESERVED_22, 22, 2)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG1_U_RND_NID68, SCG2_TOP_ADDRESS_BIT2, 16, 6)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG1_U_RND_NID68, RESERVED_14, 14, 2)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG1_U_RND_NID68, SCG2_TOP_ADDRESS_BIT1, 8, 6)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG1_U_RND_NID68, SCG2_TOP_ADDRESS_BIT0, 0, 6)
REG32(GIC_MEM_REGION_REG_U_RND_NID68, 0x824d58)
    FIELD(GIC_MEM_REGION_REG_U_RND_NID68, RESERVED_63, 63, 1)
    FIELD(GIC_MEM_REGION_REG_U_RND_NID68, GIC_REGION_NODEID, 52, 11)
    FIELD(GIC_MEM_REGION_REG_U_RND_NID68, RESERVED_48, 48, 4)
    FIELD(GIC_MEM_REGION_REG_U_RND_NID68, GIC_REGION_BASE_ADDR, 16, 32)
    FIELD(GIC_MEM_REGION_REG_U_RND_NID68, GIC_REGION_SIZE, 4, 3)
    FIELD(GIC_MEM_REGION_REG_U_RND_NID68, GIC_REGION_TARGET_TYPE, 2, 2)
    FIELD(GIC_MEM_REGION_REG_U_RND_NID68, GIC_REGION_VALID, 0, 1)
REG32(SYS_CACHE_GRP_SN_ATTR_U_RND_NID68, 0x824d60)
    FIELD(SYS_CACHE_GRP_SN_ATTR_U_RND_NID68, RESERVED_54, 54, 10)
    FIELD(SYS_CACHE_GRP_SN_ATTR_U_RND_NID68, SN_MODE_SYS_CACHE_GRP3, 52, 2)
    FIELD(SYS_CACHE_GRP_SN_ATTR_U_RND_NID68, RESERVED_49, 49, 3)
    FIELD(SYS_CACHE_GRP_SN_ATTR_U_RND_NID68, INV_TOP_ADDRESS_BIT_SYS_CACHE_GRP3, 48, 1)
    FIELD(SYS_CACHE_GRP_SN_ATTR_U_RND_NID68, RESERVED_38, 38, 10)
    FIELD(SYS_CACHE_GRP_SN_ATTR_U_RND_NID68, SN_MODE_SYS_CACHE_GRP2, 36, 2)
    FIELD(SYS_CACHE_GRP_SN_ATTR_U_RND_NID68, RESERVED_33, 33, 3)
    FIELD(SYS_CACHE_GRP_SN_ATTR_U_RND_NID68, INV_TOP_ADDRESS_BIT_SYS_CACHE_GRP2, 32, 1)
    FIELD(SYS_CACHE_GRP_SN_ATTR_U_RND_NID68, RESERVED_22, 22, 10)
    FIELD(SYS_CACHE_GRP_SN_ATTR_U_RND_NID68, SN_MODE_SYS_CACHE_GRP1, 20, 2)
    FIELD(SYS_CACHE_GRP_SN_ATTR_U_RND_NID68, RESERVED_17, 17, 3)
    FIELD(SYS_CACHE_GRP_SN_ATTR_U_RND_NID68, INV_TOP_ADDRESS_BIT_SYS_CACHE_GRP1, 16, 1)
    FIELD(SYS_CACHE_GRP_SN_ATTR_U_RND_NID68, SN_MODE_SYS_CACHE_GRP0, 4, 2)
    FIELD(SYS_CACHE_GRP_SN_ATTR_U_RND_NID68, INV_TOP_ADDRESS_BIT_SYS_CACHE_GRP0, 0, 1)
REG32(SYS_CACHE_GRP_HN_CPA_EN_REG_U_RND_NID68, 0x824d68)
REG32(SYS_CACHE_GRP_HN_CPA_GRP_REG_U_RND_NID68, 0x824d70)
    FIELD(SYS_CACHE_GRP_HN_CPA_GRP_REG_U_RND_NID68, RESERVED_50, 50, 14)
    FIELD(SYS_CACHE_GRP_HN_CPA_GRP_REG_U_RND_NID68, CPA_GRP_SCG3, 48, 2)
    FIELD(SYS_CACHE_GRP_HN_CPA_GRP_REG_U_RND_NID68, RESERVED_34, 34, 14)
    FIELD(SYS_CACHE_GRP_HN_CPA_GRP_REG_U_RND_NID68, CPA_GRP_SCG2, 32, 2)
    FIELD(SYS_CACHE_GRP_HN_CPA_GRP_REG_U_RND_NID68, RESERVED_18, 18, 14)
    FIELD(SYS_CACHE_GRP_HN_CPA_GRP_REG_U_RND_NID68, CPA_GRP_SCG1, 16, 2)
    FIELD(SYS_CACHE_GRP_HN_CPA_GRP_REG_U_RND_NID68, CPA_GRP_SCG0, 0, 2)
REG32(CML_PORT_AGGR_MODE_CTRL_REG_U_RND_NID68, 0x824e00)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RND_NID68, RESERVED_32, 32, 32)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RND_NID68, REGION7_PAG_GRPID, 30, 2)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RND_NID68, RESERVED_29, 29, 1)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RND_NID68, REGION7_PAG_EN, 28, 1)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RND_NID68, RESERVED_27, 27, 1)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RND_NID68, REGION6_PAG_GRPID, 25, 2)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RND_NID68, REGION6_PAG_EN, 24, 1)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RND_NID68, RESERVED_23, 23, 1)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RND_NID68, REGION5_PAG_GRPID, 21, 2)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RND_NID68, REGION5_PAG_EN, 20, 1)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RND_NID68, RESERVED_19, 19, 1)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RND_NID68, REGION4_PAG_GRPID, 17, 2)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RND_NID68, REGION4_PAG_EN, 16, 1)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RND_NID68, RESERVED_15, 15, 1)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RND_NID68, REGION3_PAG_GRPID, 13, 2)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RND_NID68, REGION3_PAG_EN, 12, 1)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RND_NID68, RESERVED_11, 11, 1)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RND_NID68, REGION2_PAG_GRPID, 9, 2)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RND_NID68, REGION2_PAG_EN, 8, 1)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RND_NID68, REGION1_PAG_GRPID, 5, 2)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RND_NID68, REGION1_PAG_EN, 4, 1)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RND_NID68, REGION0_PAG_GRPID, 1, 2)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RND_NID68, REGION0_PAG_EN, 0, 1)
REG32(CML_PORT_AGGR_GRP0_ADD_MASK_U_RND_NID68, 0x824e08)
    FIELD(CML_PORT_AGGR_GRP0_ADD_MASK_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(CML_PORT_AGGR_GRP0_ADD_MASK_U_RND_NID68, ADDR_MASK, 6, 42)
    FIELD(CML_PORT_AGGR_GRP0_ADD_MASK_U_RND_NID68, RESERVED_0, 0, 6)
REG32(CML_PORT_AGGR_GRP1_ADD_MASK_U_RND_NID68, 0x824e10)
    FIELD(CML_PORT_AGGR_GRP1_ADD_MASK_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(CML_PORT_AGGR_GRP1_ADD_MASK_U_RND_NID68, ADDR_MASK, 6, 42)
    FIELD(CML_PORT_AGGR_GRP1_ADD_MASK_U_RND_NID68, RESERVED_0, 0, 6)
REG32(CML_PORT_AGGR_GRP0_REG_U_RND_NID68, 0x824e40)
    FIELD(CML_PORT_AGGR_GRP0_REG_U_RND_NID68, RESERVED_50, 50, 14)
    FIELD(CML_PORT_AGGR_GRP0_REG_U_RND_NID68, NUM_CXG_PAG0, 48, 2)
    FIELD(CML_PORT_AGGR_GRP0_REG_U_RND_NID68, RESERVED_47, 47, 1)
    FIELD(CML_PORT_AGGR_GRP0_REG_U_RND_NID68, PAG0_TGTID3, 36, 11)
    FIELD(CML_PORT_AGGR_GRP0_REG_U_RND_NID68, RESERVED_35, 35, 1)
    FIELD(CML_PORT_AGGR_GRP0_REG_U_RND_NID68, PAG0_TGTID2, 24, 11)
    FIELD(CML_PORT_AGGR_GRP0_REG_U_RND_NID68, RESERVED_23, 23, 1)
    FIELD(CML_PORT_AGGR_GRP0_REG_U_RND_NID68, PAG0_TGTID1, 12, 11)
    FIELD(CML_PORT_AGGR_GRP0_REG_U_RND_NID68, RESERVED_11, 11, 1)
    FIELD(CML_PORT_AGGR_GRP0_REG_U_RND_NID68, PAG0_TGTID0, 0, 11)
REG32(CML_PORT_AGGR_GRP1_REG_U_RND_NID68, 0x824e48)
    FIELD(CML_PORT_AGGR_GRP1_REG_U_RND_NID68, RESERVED_50, 50, 14)
    FIELD(CML_PORT_AGGR_GRP1_REG_U_RND_NID68, NUM_CXG_PAG1, 48, 2)
    FIELD(CML_PORT_AGGR_GRP1_REG_U_RND_NID68, RESERVED_47, 47, 1)
    FIELD(CML_PORT_AGGR_GRP1_REG_U_RND_NID68, PAG1_TGTID3, 36, 11)
    FIELD(CML_PORT_AGGR_GRP1_REG_U_RND_NID68, RESERVED_35, 35, 1)
    FIELD(CML_PORT_AGGR_GRP1_REG_U_RND_NID68, PAG1_TGTID2, 24, 11)
    FIELD(CML_PORT_AGGR_GRP1_REG_U_RND_NID68, RESERVED_23, 23, 1)
    FIELD(CML_PORT_AGGR_GRP1_REG_U_RND_NID68, PAG1_TGTID1, 12, 11)
    FIELD(CML_PORT_AGGR_GRP1_REG_U_RND_NID68, RESERVED_11, 11, 1)
    FIELD(CML_PORT_AGGR_GRP1_REG_U_RND_NID68, PAG1_TGTID0, 0, 11)
REG32(SYS_CACHE_GRP_SECONDARY_REG0_U_RND_NID68, 0x824f00)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG0_U_RND_NID68, RESERVED_63, 63, 1)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG0_U_RND_NID68, REGION1_SCNDRY_BASE_ADDR, 41, 22)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG0_U_RND_NID68, REGION1_SCNDRY_SIZE, 36, 5)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG0_U_RND_NID68, REGION1_SCNDRY_TARGET_TYPE, 34, 2)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG0_U_RND_NID68, RESERVED_33, 33, 1)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG0_U_RND_NID68, REGION1_SCNDRY_VALID, 32, 1)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG0_U_RND_NID68, RESERVED_31, 31, 1)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG0_U_RND_NID68, REGION0_SCNDRY_BASE_ADDR, 9, 22)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG0_U_RND_NID68, REGION0_SCNDRY_SIZE, 4, 5)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG0_U_RND_NID68, REGION0_SCNDRY_TARGET_TYPE, 2, 2)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG0_U_RND_NID68, REGION0_SCNDRY_VALID, 0, 1)
REG32(SYS_CACHE_GRP_SECONDARY_REG1_U_RND_NID68, 0x824f08)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG1_U_RND_NID68, RESERVED_63, 63, 1)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG1_U_RND_NID68, REGION3_SCNDRY_BASE_ADDR, 41, 22)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG1_U_RND_NID68, REGION3_SCNDRY_SIZE, 36, 5)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG1_U_RND_NID68, REGION3_SCNDRY_TARGET_TYPE, 34, 2)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG1_U_RND_NID68, RESERVED_33, 33, 1)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG1_U_RND_NID68, REGION3_SCNDRY_VALID, 32, 1)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG1_U_RND_NID68, RESERVED_31, 31, 1)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG1_U_RND_NID68, REGION2_SCNDRY_BASE_ADDR, 9, 22)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG1_U_RND_NID68, REGION2_SCNDRY_SIZE, 4, 5)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG1_U_RND_NID68, REGION2_SCNDRY_TARGET_TYPE, 2, 2)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG1_U_RND_NID68, REGION2_SCNDRY_VALID, 0, 1)
REG32(SYS_CACHE_GRP_CAL_MODE_REG_U_RND_NID68, 0x824f10)
    FIELD(SYS_CACHE_GRP_CAL_MODE_REG_U_RND_NID68, RESERVED_49, 49, 15)
    FIELD(SYS_CACHE_GRP_CAL_MODE_REG_U_RND_NID68, SCG3_HNF_CAL_MODE_EN, 48, 1)
    FIELD(SYS_CACHE_GRP_CAL_MODE_REG_U_RND_NID68, RESERVED_33, 33, 15)
    FIELD(SYS_CACHE_GRP_CAL_MODE_REG_U_RND_NID68, SCG2_HNF_CAL_MODE_EN, 32, 1)
    FIELD(SYS_CACHE_GRP_CAL_MODE_REG_U_RND_NID68, RESERVED_17, 17, 15)
    FIELD(SYS_CACHE_GRP_CAL_MODE_REG_U_RND_NID68, SCG1_HNF_CAL_MODE_EN, 16, 1)
    FIELD(SYS_CACHE_GRP_CAL_MODE_REG_U_RND_NID68, SCG0_HNF_CAL_MODE_EN, 0, 1)
REG32(RNSAM_HASH_ADDR_MASK_REG_U_RND_NID68, 0x824f18)
    FIELD(RNSAM_HASH_ADDR_MASK_REG_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(RNSAM_HASH_ADDR_MASK_REG_U_RND_NID68, ADDR_MASK, 6, 42)
    FIELD(RNSAM_HASH_ADDR_MASK_REG_U_RND_NID68, RESERVED_0, 0, 6)
REG32(RNSAM_REGION_CMP_ADDR_MASK_REG_U_RND_NID68, 0x824f20)
    FIELD(RNSAM_REGION_CMP_ADDR_MASK_REG_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(RNSAM_REGION_CMP_ADDR_MASK_REG_U_RND_NID68, ADDR_MASK, 16, 32)
    FIELD(RNSAM_REGION_CMP_ADDR_MASK_REG_U_RND_NID68, RESERVED_0, 0, 16)
REG32(SYS_CACHE_GRP_HN_NODEID_REG8_U_RND_NID68, 0x824f58)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG8_U_RND_NID68, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG8_U_RND_NID68, NODEID_35, 36, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG8_U_RND_NID68, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG8_U_RND_NID68, NODEID_34, 24, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG8_U_RND_NID68, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG8_U_RND_NID68, NODEID_33, 12, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG8_U_RND_NID68, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG8_U_RND_NID68, NODEID_32, 0, 11)
REG32(SYS_CACHE_GRP_HN_NODEID_REG9_U_RND_NID68, 0x824f60)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG9_U_RND_NID68, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG9_U_RND_NID68, NODEID_39, 36, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG9_U_RND_NID68, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG9_U_RND_NID68, NODEID_38, 24, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG9_U_RND_NID68, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG9_U_RND_NID68, NODEID_37, 12, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG9_U_RND_NID68, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG9_U_RND_NID68, NODEID_36, 0, 11)
REG32(SYS_CACHE_GRP_HN_NODEID_REG10_U_RND_NID68, 0x824f68)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG10_U_RND_NID68, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG10_U_RND_NID68, NODEID_43, 36, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG10_U_RND_NID68, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG10_U_RND_NID68, NODEID_42, 24, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG10_U_RND_NID68, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG10_U_RND_NID68, NODEID_41, 12, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG10_U_RND_NID68, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG10_U_RND_NID68, NODEID_40, 0, 11)
REG32(SYS_CACHE_GRP_HN_NODEID_REG11_U_RND_NID68, 0x824f70)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG11_U_RND_NID68, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG11_U_RND_NID68, NODEID_47, 36, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG11_U_RND_NID68, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG11_U_RND_NID68, NODEID_46, 24, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG11_U_RND_NID68, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG11_U_RND_NID68, NODEID_45, 12, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG11_U_RND_NID68, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG11_U_RND_NID68, NODEID_44, 0, 11)
REG32(SYS_CACHE_GRP_HN_NODEID_REG12_U_RND_NID68, 0x824f78)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG12_U_RND_NID68, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG12_U_RND_NID68, NODEID_51, 36, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG12_U_RND_NID68, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG12_U_RND_NID68, NODEID_50, 24, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG12_U_RND_NID68, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG12_U_RND_NID68, NODEID_49, 12, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG12_U_RND_NID68, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG12_U_RND_NID68, NODEID_48, 0, 11)
REG32(SYS_CACHE_GRP_HN_NODEID_REG13_U_RND_NID68, 0x824f80)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG13_U_RND_NID68, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG13_U_RND_NID68, NODEID_55, 36, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG13_U_RND_NID68, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG13_U_RND_NID68, NODEID_54, 24, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG13_U_RND_NID68, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG13_U_RND_NID68, NODEID_53, 12, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG13_U_RND_NID68, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG13_U_RND_NID68, NODEID_52, 0, 11)
REG32(SYS_CACHE_GRP_HN_NODEID_REG14_U_RND_NID68, 0x824f88)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG14_U_RND_NID68, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG14_U_RND_NID68, NODEID_59, 36, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG14_U_RND_NID68, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG14_U_RND_NID68, NODEID_58, 24, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG14_U_RND_NID68, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG14_U_RND_NID68, NODEID_57, 12, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG14_U_RND_NID68, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG14_U_RND_NID68, NODEID_56, 0, 11)
REG32(SYS_CACHE_GRP_HN_NODEID_REG15_U_RND_NID68, 0x824f90)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG15_U_RND_NID68, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG15_U_RND_NID68, NODEID_63, 36, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG15_U_RND_NID68, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG15_U_RND_NID68, NODEID_62, 24, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG15_U_RND_NID68, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG15_U_RND_NID68, NODEID_61, 12, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG15_U_RND_NID68, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG15_U_RND_NID68, NODEID_60, 0, 11)
REG32(SYS_CACHE_GRP_SN_NODEID_REG8_U_RND_NID68, 0x825008)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG8_U_RND_NID68, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG8_U_RND_NID68, SN_NODEID_35, 36, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG8_U_RND_NID68, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG8_U_RND_NID68, SN_NODEID_34, 24, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG8_U_RND_NID68, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG8_U_RND_NID68, SN_NODEID_33, 12, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG8_U_RND_NID68, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG8_U_RND_NID68, SN_NODEID_32, 0, 11)
REG32(SYS_CACHE_GRP_SN_NODEID_REG9_U_RND_NID68, 0x825010)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG9_U_RND_NID68, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG9_U_RND_NID68, SN_NODEID_39, 36, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG9_U_RND_NID68, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG9_U_RND_NID68, SN_NODEID_38, 24, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG9_U_RND_NID68, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG9_U_RND_NID68, SN_NODEID_37, 12, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG9_U_RND_NID68, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG9_U_RND_NID68, SN_NODEID_36, 0, 11)
REG32(SYS_CACHE_GRP_SN_NODEID_REG10_U_RND_NID68, 0x825018)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG10_U_RND_NID68, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG10_U_RND_NID68, SN_NODEID_43, 36, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG10_U_RND_NID68, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG10_U_RND_NID68, SN_NODEID_42, 24, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG10_U_RND_NID68, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG10_U_RND_NID68, SN_NODEID_41, 12, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG10_U_RND_NID68, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG10_U_RND_NID68, SN_NODEID_40, 0, 11)
REG32(SYS_CACHE_GRP_SN_NODEID_REG11_U_RND_NID68, 0x825020)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG11_U_RND_NID68, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG11_U_RND_NID68, SN_NODEID_47, 36, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG11_U_RND_NID68, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG11_U_RND_NID68, SN_NODEID_46, 24, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG11_U_RND_NID68, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG11_U_RND_NID68, SN_NODEID_45, 12, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG11_U_RND_NID68, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG11_U_RND_NID68, SN_NODEID_44, 0, 11)
REG32(SYS_CACHE_GRP_SN_NODEID_REG12_U_RND_NID68, 0x825028)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG12_U_RND_NID68, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG12_U_RND_NID68, SN_NODEID_51, 36, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG12_U_RND_NID68, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG12_U_RND_NID68, SN_NODEID_50, 24, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG12_U_RND_NID68, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG12_U_RND_NID68, SN_NODEID_49, 12, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG12_U_RND_NID68, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG12_U_RND_NID68, SN_NODEID_48, 0, 11)
REG32(SYS_CACHE_GRP_SN_NODEID_REG13_U_RND_NID68, 0x825030)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG13_U_RND_NID68, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG13_U_RND_NID68, SN_NODEID_55, 36, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG13_U_RND_NID68, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG13_U_RND_NID68, SN_NODEID_54, 24, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG13_U_RND_NID68, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG13_U_RND_NID68, SN_NODEID_53, 12, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG13_U_RND_NID68, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG13_U_RND_NID68, SN_NODEID_52, 0, 11)
REG32(SYS_CACHE_GRP_SN_NODEID_REG14_U_RND_NID68, 0x825038)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG14_U_RND_NID68, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG14_U_RND_NID68, SN_NODEID_59, 36, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG14_U_RND_NID68, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG14_U_RND_NID68, SN_NODEID_58, 24, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG14_U_RND_NID68, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG14_U_RND_NID68, SN_NODEID_57, 12, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG14_U_RND_NID68, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG14_U_RND_NID68, SN_NODEID_56, 0, 11)
REG32(SYS_CACHE_GRP_SN_NODEID_REG15_U_RND_NID68, 0x825040)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG15_U_RND_NID68, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG15_U_RND_NID68, SN_NODEID_63, 36, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG15_U_RND_NID68, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG15_U_RND_NID68, SN_NODEID_62, 24, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG15_U_RND_NID68, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG15_U_RND_NID68, SN_NODEID_61, 12, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG15_U_RND_NID68, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG15_U_RND_NID68, SN_NODEID_60, 0, 11)
REG32(POR_FDC_NODE_INFO_U_SMXP_1_0, 0x82c000)
    FIELD(POR_FDC_NODE_INFO_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_FDC_NODE_INFO_U_SMXP_1_0, LOGICAL_ID, 32, 16)
    FIELD(POR_FDC_NODE_INFO_U_SMXP_1_0, NODE_ID, 16, 16)
    FIELD(POR_FDC_NODE_INFO_U_SMXP_1_0, NODE_TYPE, 0, 16)
REG32(POR_FDC_CHILD_INFO_U_SMXP_1_0, 0x82c080)
    FIELD(POR_FDC_CHILD_INFO_U_SMXP_1_0, RESERVED_32, 32, 32)
    FIELD(POR_FDC_CHILD_INFO_U_SMXP_1_0, CHILD_PTR_OFFSET, 16, 16)
    FIELD(POR_FDC_CHILD_INFO_U_SMXP_1_0, CHILD_COUNT, 0, 16)
REG32(POR_ERRFR_MXP_U_SMXP_1_0, 0x82f000)
    FIELD(POR_ERRFR_MXP_U_SMXP_1_0, FI, 6, 2)
    FIELD(POR_ERRFR_MXP_U_SMXP_1_0, UI, 4, 2)
    FIELD(POR_ERRFR_MXP_U_SMXP_1_0, ED, 0, 2)
REG32(POR_ERRCTLR_MXP_U_SMXP_1_0, 0x82f008)
    FIELD(POR_ERRCTLR_MXP_U_SMXP_1_0, RESERVED_32, 32, 32)
    FIELD(POR_ERRCTLR_MXP_U_SMXP_1_0, ERC, 14, 18)
    FIELD(POR_ERRCTLR_MXP_U_SMXP_1_0, FI, 3, 1)
    FIELD(POR_ERRCTLR_MXP_U_SMXP_1_0, UI, 2, 1)
    FIELD(POR_ERRCTLR_MXP_U_SMXP_1_0, ED, 0, 1)
REG32(POR_ERRSTATUS_MXP_U_SMXP_1_0, 0x82f010)
    FIELD(POR_ERRSTATUS_MXP_U_SMXP_1_0, RESERVED_31, 31, 33)
    FIELD(POR_ERRSTATUS_MXP_U_SMXP_1_0, V, 30, 1)
    FIELD(POR_ERRSTATUS_MXP_U_SMXP_1_0, UE, 29, 1)
    FIELD(POR_ERRSTATUS_MXP_U_SMXP_1_0, RESERVED_28, 28, 1)
    FIELD(POR_ERRSTATUS_MXP_U_SMXP_1_0, OF, 27, 1)
    FIELD(POR_ERRSTATUS_MXP_U_SMXP_1_0, RESERVED_24, 24, 3)
    FIELD(POR_ERRSTATUS_MXP_U_SMXP_1_0, DE, 23, 1)
    FIELD(POR_ERRSTATUS_MXP_U_SMXP_1_0, RESERVED_16, 16, 7)
    FIELD(POR_ERRSTATUS_MXP_U_SMXP_1_0, V_ERR_TYPE, 6, 10)
    FIELD(POR_ERRSTATUS_MXP_U_SMXP_1_0, RESERVED_0, 0, 6)
REG32(POR_FDC_AUX_CTL_MXP_U_SMXP_1_0, 0x82f018)
    FIELD(POR_FDC_AUX_CTL_MXP_U_SMXP_1_0, CLKGATE_OVERRIDE, 4, 1)
    FIELD(POR_FDC_AUX_CTL_MXP_U_SMXP_1_0, RESERVED_0, 0, 4)
REG32(POR_ERRFR_P0_D0_U_SMXP_1_0, 0x82f040)
    FIELD(POR_ERRFR_P0_D0_U_SMXP_1_0, FI, 6, 2)
    FIELD(POR_ERRFR_P0_D0_U_SMXP_1_0, UI, 4, 2)
    FIELD(POR_ERRFR_P0_D0_U_SMXP_1_0, ED, 0, 2)
REG32(POR_ERRCTLR_P0_D0_U_SMXP_1_0, 0x82f048)
    FIELD(POR_ERRCTLR_P0_D0_U_SMXP_1_0, RESERVED_32, 32, 32)
    FIELD(POR_ERRCTLR_P0_D0_U_SMXP_1_0, ERC, 14, 18)
    FIELD(POR_ERRCTLR_P0_D0_U_SMXP_1_0, FI, 3, 1)
    FIELD(POR_ERRCTLR_P0_D0_U_SMXP_1_0, UI, 2, 1)
    FIELD(POR_ERRCTLR_P0_D0_U_SMXP_1_0, ED, 0, 1)
REG32(POR_ERRSTATUS_P0_D0_U_SMXP_1_0, 0x82f050)
    FIELD(POR_ERRSTATUS_P0_D0_U_SMXP_1_0, RESERVED_31, 31, 33)
    FIELD(POR_ERRSTATUS_P0_D0_U_SMXP_1_0, V, 30, 1)
    FIELD(POR_ERRSTATUS_P0_D0_U_SMXP_1_0, UE, 29, 1)
    FIELD(POR_ERRSTATUS_P0_D0_U_SMXP_1_0, RESERVED_28, 28, 1)
    FIELD(POR_ERRSTATUS_P0_D0_U_SMXP_1_0, OF, 27, 1)
    FIELD(POR_ERRSTATUS_P0_D0_U_SMXP_1_0, RESERVED_24, 24, 3)
    FIELD(POR_ERRSTATUS_P0_D0_U_SMXP_1_0, DE, 23, 1)
    FIELD(POR_ERRSTATUS_P0_D0_U_SMXP_1_0, RESERVED_16, 16, 7)
    FIELD(POR_ERRSTATUS_P0_D0_U_SMXP_1_0, V_ERR_TYPE, 6, 10)
    FIELD(POR_ERRSTATUS_P0_D0_U_SMXP_1_0, RESERVED_0, 0, 6)
REG32(POR_FDC_AUX_CTL_P0_D0_U_SMXP_1_0, 0x82f058)
    FIELD(POR_FDC_AUX_CTL_P0_D0_U_SMXP_1_0, CLKGATE_OVERRIDE, 4, 1)
    FIELD(POR_FDC_AUX_CTL_P0_D0_U_SMXP_1_0, HANG_DET_CONFIG, 0, 4)
REG32(POR_ERRFR_P0_D1_U_SMXP_1_0, 0x82f080)
    FIELD(POR_ERRFR_P0_D1_U_SMXP_1_0, FI, 6, 2)
    FIELD(POR_ERRFR_P0_D1_U_SMXP_1_0, UI, 4, 2)
    FIELD(POR_ERRFR_P0_D1_U_SMXP_1_0, ED, 0, 2)
REG32(POR_ERRCTLR_P0_D1_U_SMXP_1_0, 0x82f088)
    FIELD(POR_ERRCTLR_P0_D1_U_SMXP_1_0, RESERVED_32, 32, 32)
    FIELD(POR_ERRCTLR_P0_D1_U_SMXP_1_0, ERC, 14, 18)
    FIELD(POR_ERRCTLR_P0_D1_U_SMXP_1_0, FI, 3, 1)
    FIELD(POR_ERRCTLR_P0_D1_U_SMXP_1_0, UI, 2, 1)
    FIELD(POR_ERRCTLR_P0_D1_U_SMXP_1_0, ED, 0, 1)
REG32(POR_ERRSTATUS_P0_D1_U_SMXP_1_0, 0x82f090)
    FIELD(POR_ERRSTATUS_P0_D1_U_SMXP_1_0, RESERVED_31, 31, 33)
    FIELD(POR_ERRSTATUS_P0_D1_U_SMXP_1_0, V, 30, 1)
    FIELD(POR_ERRSTATUS_P0_D1_U_SMXP_1_0, UE, 29, 1)
    FIELD(POR_ERRSTATUS_P0_D1_U_SMXP_1_0, RESERVED_28, 28, 1)
    FIELD(POR_ERRSTATUS_P0_D1_U_SMXP_1_0, OF, 27, 1)
    FIELD(POR_ERRSTATUS_P0_D1_U_SMXP_1_0, RESERVED_24, 24, 3)
    FIELD(POR_ERRSTATUS_P0_D1_U_SMXP_1_0, DE, 23, 1)
    FIELD(POR_ERRSTATUS_P0_D1_U_SMXP_1_0, RESERVED_16, 16, 7)
    FIELD(POR_ERRSTATUS_P0_D1_U_SMXP_1_0, V_ERR_TYPE, 6, 10)
    FIELD(POR_ERRSTATUS_P0_D1_U_SMXP_1_0, RESERVED_0, 0, 6)
REG32(POR_FDC_AUX_CTL_P0_D1_U_SMXP_1_0, 0x82f098)
    FIELD(POR_FDC_AUX_CTL_P0_D1_U_SMXP_1_0, CLKGATE_OVERRIDE, 4, 1)
    FIELD(POR_FDC_AUX_CTL_P0_D1_U_SMXP_1_0, HANG_DET_CONFIG, 0, 4)
REG32(POR_ERRFR_P0_D2_U_SMXP_1_0, 0x82f0c0)
    FIELD(POR_ERRFR_P0_D2_U_SMXP_1_0, FI, 6, 2)
    FIELD(POR_ERRFR_P0_D2_U_SMXP_1_0, UI, 4, 2)
    FIELD(POR_ERRFR_P0_D2_U_SMXP_1_0, ED, 0, 2)
REG32(POR_ERRCTLR_P0_D2_U_SMXP_1_0, 0x82f0c8)
    FIELD(POR_ERRCTLR_P0_D2_U_SMXP_1_0, RESERVED_32, 32, 32)
    FIELD(POR_ERRCTLR_P0_D2_U_SMXP_1_0, ERC, 14, 18)
    FIELD(POR_ERRCTLR_P0_D2_U_SMXP_1_0, FI, 3, 1)
    FIELD(POR_ERRCTLR_P0_D2_U_SMXP_1_0, UI, 2, 1)
    FIELD(POR_ERRCTLR_P0_D2_U_SMXP_1_0, ED, 0, 1)
REG32(POR_ERRSTATUS_P0_D2_U_SMXP_1_0, 0x82f0d0)
    FIELD(POR_ERRSTATUS_P0_D2_U_SMXP_1_0, RESERVED_31, 31, 33)
    FIELD(POR_ERRSTATUS_P0_D2_U_SMXP_1_0, V, 30, 1)
    FIELD(POR_ERRSTATUS_P0_D2_U_SMXP_1_0, UE, 29, 1)
    FIELD(POR_ERRSTATUS_P0_D2_U_SMXP_1_0, RESERVED_28, 28, 1)
    FIELD(POR_ERRSTATUS_P0_D2_U_SMXP_1_0, OF, 27, 1)
    FIELD(POR_ERRSTATUS_P0_D2_U_SMXP_1_0, RESERVED_24, 24, 3)
    FIELD(POR_ERRSTATUS_P0_D2_U_SMXP_1_0, DE, 23, 1)
    FIELD(POR_ERRSTATUS_P0_D2_U_SMXP_1_0, RESERVED_16, 16, 7)
    FIELD(POR_ERRSTATUS_P0_D2_U_SMXP_1_0, V_ERR_TYPE, 6, 10)
    FIELD(POR_ERRSTATUS_P0_D2_U_SMXP_1_0, RESERVED_0, 0, 6)
REG32(POR_FDC_AUX_CTL_P0_D2_U_SMXP_1_0, 0x82f0d8)
    FIELD(POR_FDC_AUX_CTL_P0_D2_U_SMXP_1_0, CLKGATE_OVERRIDE, 4, 1)
    FIELD(POR_FDC_AUX_CTL_P0_D2_U_SMXP_1_0, HANG_DET_CONFIG, 0, 4)
REG32(POR_ERRFR_P0_D3_U_SMXP_1_0, 0x82f100)
    FIELD(POR_ERRFR_P0_D3_U_SMXP_1_0, FI, 6, 2)
    FIELD(POR_ERRFR_P0_D3_U_SMXP_1_0, UI, 4, 2)
    FIELD(POR_ERRFR_P0_D3_U_SMXP_1_0, ED, 0, 2)
REG32(POR_ERRCTLR_P0_D3_U_SMXP_1_0, 0x82f108)
    FIELD(POR_ERRCTLR_P0_D3_U_SMXP_1_0, RESERVED_32, 32, 32)
    FIELD(POR_ERRCTLR_P0_D3_U_SMXP_1_0, ERC, 14, 18)
    FIELD(POR_ERRCTLR_P0_D3_U_SMXP_1_0, FI, 3, 1)
    FIELD(POR_ERRCTLR_P0_D3_U_SMXP_1_0, UI, 2, 1)
    FIELD(POR_ERRCTLR_P0_D3_U_SMXP_1_0, ED, 0, 1)
REG32(POR_ERRSTATUS_P0_D3_U_SMXP_1_0, 0x82f110)
    FIELD(POR_ERRSTATUS_P0_D3_U_SMXP_1_0, RESERVED_31, 31, 33)
    FIELD(POR_ERRSTATUS_P0_D3_U_SMXP_1_0, V, 30, 1)
    FIELD(POR_ERRSTATUS_P0_D3_U_SMXP_1_0, UE, 29, 1)
    FIELD(POR_ERRSTATUS_P0_D3_U_SMXP_1_0, RESERVED_28, 28, 1)
    FIELD(POR_ERRSTATUS_P0_D3_U_SMXP_1_0, OF, 27, 1)
    FIELD(POR_ERRSTATUS_P0_D3_U_SMXP_1_0, RESERVED_24, 24, 3)
    FIELD(POR_ERRSTATUS_P0_D3_U_SMXP_1_0, DE, 23, 1)
    FIELD(POR_ERRSTATUS_P0_D3_U_SMXP_1_0, RESERVED_16, 16, 7)
    FIELD(POR_ERRSTATUS_P0_D3_U_SMXP_1_0, V_ERR_TYPE, 6, 10)
    FIELD(POR_ERRSTATUS_P0_D3_U_SMXP_1_0, RESERVED_0, 0, 6)
REG32(POR_FDC_AUX_CTL_P0_D3_U_SMXP_1_0, 0x82f118)
    FIELD(POR_FDC_AUX_CTL_P0_D3_U_SMXP_1_0, CLKGATE_OVERRIDE, 4, 1)
    FIELD(POR_FDC_AUX_CTL_P0_D3_U_SMXP_1_0, HANG_DET_CONFIG, 0, 4)
REG32(POR_ERRFR_P1_D0_U_SMXP_1_0, 0x82f140)
    FIELD(POR_ERRFR_P1_D0_U_SMXP_1_0, FI, 6, 2)
    FIELD(POR_ERRFR_P1_D0_U_SMXP_1_0, UI, 4, 2)
    FIELD(POR_ERRFR_P1_D0_U_SMXP_1_0, ED, 0, 2)
REG32(POR_ERRCTLR_P1_D0_U_SMXP_1_0, 0x82f148)
    FIELD(POR_ERRCTLR_P1_D0_U_SMXP_1_0, RESERVED_32, 32, 32)
    FIELD(POR_ERRCTLR_P1_D0_U_SMXP_1_0, ERC, 14, 18)
    FIELD(POR_ERRCTLR_P1_D0_U_SMXP_1_0, FI, 3, 1)
    FIELD(POR_ERRCTLR_P1_D0_U_SMXP_1_0, UI, 2, 1)
    FIELD(POR_ERRCTLR_P1_D0_U_SMXP_1_0, ED, 0, 1)
REG32(POR_ERRSTATUS_P1_D0_U_SMXP_1_0, 0x82f150)
    FIELD(POR_ERRSTATUS_P1_D0_U_SMXP_1_0, RESERVED_31, 31, 33)
    FIELD(POR_ERRSTATUS_P1_D0_U_SMXP_1_0, V, 30, 1)
    FIELD(POR_ERRSTATUS_P1_D0_U_SMXP_1_0, UE, 29, 1)
    FIELD(POR_ERRSTATUS_P1_D0_U_SMXP_1_0, RESERVED_28, 28, 1)
    FIELD(POR_ERRSTATUS_P1_D0_U_SMXP_1_0, OF, 27, 1)
    FIELD(POR_ERRSTATUS_P1_D0_U_SMXP_1_0, RESERVED_24, 24, 3)
    FIELD(POR_ERRSTATUS_P1_D0_U_SMXP_1_0, DE, 23, 1)
    FIELD(POR_ERRSTATUS_P1_D0_U_SMXP_1_0, RESERVED_16, 16, 7)
    FIELD(POR_ERRSTATUS_P1_D0_U_SMXP_1_0, V_ERR_TYPE, 6, 10)
    FIELD(POR_ERRSTATUS_P1_D0_U_SMXP_1_0, RESERVED_0, 0, 6)
REG32(POR_FDC_AUX_CTL_P1_D0_U_SMXP_1_0, 0x82f158)
    FIELD(POR_FDC_AUX_CTL_P1_D0_U_SMXP_1_0, CLKGATE_OVERRIDE, 4, 1)
    FIELD(POR_FDC_AUX_CTL_P1_D0_U_SMXP_1_0, HANG_DET_CONFIG, 0, 4)
REG32(POR_ERRFR_P1_D1_U_SMXP_1_0, 0x82f180)
    FIELD(POR_ERRFR_P1_D1_U_SMXP_1_0, FI, 6, 2)
    FIELD(POR_ERRFR_P1_D1_U_SMXP_1_0, UI, 4, 2)
    FIELD(POR_ERRFR_P1_D1_U_SMXP_1_0, ED, 0, 2)
REG32(POR_ERRCTLR_P1_D1_U_SMXP_1_0, 0x82f188)
    FIELD(POR_ERRCTLR_P1_D1_U_SMXP_1_0, RESERVED_32, 32, 32)
    FIELD(POR_ERRCTLR_P1_D1_U_SMXP_1_0, ERC, 14, 18)
    FIELD(POR_ERRCTLR_P1_D1_U_SMXP_1_0, FI, 3, 1)
    FIELD(POR_ERRCTLR_P1_D1_U_SMXP_1_0, UI, 2, 1)
    FIELD(POR_ERRCTLR_P1_D1_U_SMXP_1_0, ED, 0, 1)
REG32(POR_ERRSTATUS_P1_D1_U_SMXP_1_0, 0x82f190)
    FIELD(POR_ERRSTATUS_P1_D1_U_SMXP_1_0, RESERVED_31, 31, 33)
    FIELD(POR_ERRSTATUS_P1_D1_U_SMXP_1_0, V, 30, 1)
    FIELD(POR_ERRSTATUS_P1_D1_U_SMXP_1_0, UE, 29, 1)
    FIELD(POR_ERRSTATUS_P1_D1_U_SMXP_1_0, RESERVED_28, 28, 1)
    FIELD(POR_ERRSTATUS_P1_D1_U_SMXP_1_0, OF, 27, 1)
    FIELD(POR_ERRSTATUS_P1_D1_U_SMXP_1_0, RESERVED_24, 24, 3)
    FIELD(POR_ERRSTATUS_P1_D1_U_SMXP_1_0, DE, 23, 1)
    FIELD(POR_ERRSTATUS_P1_D1_U_SMXP_1_0, RESERVED_16, 16, 7)
    FIELD(POR_ERRSTATUS_P1_D1_U_SMXP_1_0, V_ERR_TYPE, 6, 10)
    FIELD(POR_ERRSTATUS_P1_D1_U_SMXP_1_0, RESERVED_0, 0, 6)
REG32(POR_FDC_AUX_CTL_P1_D1_U_SMXP_1_0, 0x82f198)
    FIELD(POR_FDC_AUX_CTL_P1_D1_U_SMXP_1_0, CLKGATE_OVERRIDE, 4, 1)
    FIELD(POR_FDC_AUX_CTL_P1_D1_U_SMXP_1_0, HANG_DET_CONFIG, 0, 4)
REG32(POR_ERRFR_P1_D2_U_SMXP_1_0, 0x82f1c0)
    FIELD(POR_ERRFR_P1_D2_U_SMXP_1_0, FI, 6, 2)
    FIELD(POR_ERRFR_P1_D2_U_SMXP_1_0, UI, 4, 2)
    FIELD(POR_ERRFR_P1_D2_U_SMXP_1_0, ED, 0, 2)
REG32(POR_ERRCTLR_P1_D2_U_SMXP_1_0, 0x82f1c8)
    FIELD(POR_ERRCTLR_P1_D2_U_SMXP_1_0, RESERVED_32, 32, 32)
    FIELD(POR_ERRCTLR_P1_D2_U_SMXP_1_0, ERC, 14, 18)
    FIELD(POR_ERRCTLR_P1_D2_U_SMXP_1_0, FI, 3, 1)
    FIELD(POR_ERRCTLR_P1_D2_U_SMXP_1_0, UI, 2, 1)
    FIELD(POR_ERRCTLR_P1_D2_U_SMXP_1_0, ED, 0, 1)
REG32(POR_ERRSTATUS_P1_D2_U_SMXP_1_0, 0x82f1d0)
    FIELD(POR_ERRSTATUS_P1_D2_U_SMXP_1_0, RESERVED_31, 31, 33)
    FIELD(POR_ERRSTATUS_P1_D2_U_SMXP_1_0, V, 30, 1)
    FIELD(POR_ERRSTATUS_P1_D2_U_SMXP_1_0, UE, 29, 1)
    FIELD(POR_ERRSTATUS_P1_D2_U_SMXP_1_0, RESERVED_28, 28, 1)
    FIELD(POR_ERRSTATUS_P1_D2_U_SMXP_1_0, OF, 27, 1)
    FIELD(POR_ERRSTATUS_P1_D2_U_SMXP_1_0, RESERVED_24, 24, 3)
    FIELD(POR_ERRSTATUS_P1_D2_U_SMXP_1_0, DE, 23, 1)
    FIELD(POR_ERRSTATUS_P1_D2_U_SMXP_1_0, RESERVED_16, 16, 7)
    FIELD(POR_ERRSTATUS_P1_D2_U_SMXP_1_0, V_ERR_TYPE, 6, 10)
    FIELD(POR_ERRSTATUS_P1_D2_U_SMXP_1_0, RESERVED_0, 0, 6)
REG32(POR_FDC_AUX_CTL_P1_D2_U_SMXP_1_0, 0x82f1d8)
    FIELD(POR_FDC_AUX_CTL_P1_D2_U_SMXP_1_0, CLKGATE_OVERRIDE, 4, 1)
    FIELD(POR_FDC_AUX_CTL_P1_D2_U_SMXP_1_0, HANG_DET_CONFIG, 0, 4)
REG32(POR_ERRFR_P1_D3_U_SMXP_1_0, 0x82f200)
    FIELD(POR_ERRFR_P1_D3_U_SMXP_1_0, FI, 6, 2)
    FIELD(POR_ERRFR_P1_D3_U_SMXP_1_0, UI, 4, 2)
    FIELD(POR_ERRFR_P1_D3_U_SMXP_1_0, ED, 0, 2)
REG32(POR_ERRCTLR_P1_D3_U_SMXP_1_0, 0x82f208)
    FIELD(POR_ERRCTLR_P1_D3_U_SMXP_1_0, RESERVED_32, 32, 32)
    FIELD(POR_ERRCTLR_P1_D3_U_SMXP_1_0, ERC, 14, 18)
    FIELD(POR_ERRCTLR_P1_D3_U_SMXP_1_0, FI, 3, 1)
    FIELD(POR_ERRCTLR_P1_D3_U_SMXP_1_0, UI, 2, 1)
    FIELD(POR_ERRCTLR_P1_D3_U_SMXP_1_0, ED, 0, 1)
REG32(POR_ERRSTATUS_P1_D3_U_SMXP_1_0, 0x82f210)
    FIELD(POR_ERRSTATUS_P1_D3_U_SMXP_1_0, RESERVED_31, 31, 33)
    FIELD(POR_ERRSTATUS_P1_D3_U_SMXP_1_0, V, 30, 1)
    FIELD(POR_ERRSTATUS_P1_D3_U_SMXP_1_0, UE, 29, 1)
    FIELD(POR_ERRSTATUS_P1_D3_U_SMXP_1_0, RESERVED_28, 28, 1)
    FIELD(POR_ERRSTATUS_P1_D3_U_SMXP_1_0, OF, 27, 1)
    FIELD(POR_ERRSTATUS_P1_D3_U_SMXP_1_0, RESERVED_24, 24, 3)
    FIELD(POR_ERRSTATUS_P1_D3_U_SMXP_1_0, DE, 23, 1)
    FIELD(POR_ERRSTATUS_P1_D3_U_SMXP_1_0, RESERVED_16, 16, 7)
    FIELD(POR_ERRSTATUS_P1_D3_U_SMXP_1_0, V_ERR_TYPE, 6, 10)
    FIELD(POR_ERRSTATUS_P1_D3_U_SMXP_1_0, RESERVED_0, 0, 6)
REG32(POR_FDC_AUX_CTL_P1_D3_U_SMXP_1_0, 0x82f218)
    FIELD(POR_FDC_AUX_CTL_P1_D3_U_SMXP_1_0, CLKGATE_OVERRIDE, 4, 1)
    FIELD(POR_FDC_AUX_CTL_P1_D3_U_SMXP_1_0, HANG_DET_CONFIG, 0, 4)
REG32(POR_ERRINJECT_U_SMXP_1_0, 0x82f300)
    FIELD(POR_ERRINJECT_U_SMXP_1_0, ERR_DEV, 4, 4)
    FIELD(POR_ERRINJECT_U_SMXP_1_0, ERR_TYPE, 0, 4)
REG32(POR_FDC_KEY_U_SMXP_1_0, 0x82f308)
    FIELD(POR_FDC_KEY_U_SMXP_1_0, KEY, 0, 8)
REG32(POR_MPU_NODE_INFO_U_RND_NID68, 0x834000)
    FIELD(POR_MPU_NODE_INFO_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_NODE_INFO_U_RND_NID68, LOGICAL_ID, 32, 16)
    FIELD(POR_MPU_NODE_INFO_U_RND_NID68, NODE_ID, 16, 16)
    FIELD(POR_MPU_NODE_INFO_U_RND_NID68, NODE_TYPE, 0, 16)
REG32(POR_MPU_CHILD_INFO_U_RND_NID68, 0x834080)
    FIELD(POR_MPU_CHILD_INFO_U_RND_NID68, RESERVED_32, 32, 32)
    FIELD(POR_MPU_CHILD_INFO_U_RND_NID68, CHILD_PTR_OFFSET, 16, 16)
    FIELD(POR_MPU_CHILD_INFO_U_RND_NID68, CHILD_COUNT, 0, 16)
REG32(POR_MPU_UNIT_INFO_U_RND_NID68, 0x834900)
    FIELD(POR_MPU_UNIT_INFO_U_RND_NID68, RESERVED_16, 16, 48)
    FIELD(POR_MPU_UNIT_INFO_U_RND_NID68, MASTER_7_PRESENT, 15, 1)
    FIELD(POR_MPU_UNIT_INFO_U_RND_NID68, MASTER_6_PRESENT, 14, 1)
    FIELD(POR_MPU_UNIT_INFO_U_RND_NID68, MASTER_5_PRESENT, 13, 1)
    FIELD(POR_MPU_UNIT_INFO_U_RND_NID68, MASTER_4_PRESENT, 12, 1)
    FIELD(POR_MPU_UNIT_INFO_U_RND_NID68, MASTER_3_PRESENT, 11, 1)
    FIELD(POR_MPU_UNIT_INFO_U_RND_NID68, MASTER_2_PRESENT, 10, 1)
    FIELD(POR_MPU_UNIT_INFO_U_RND_NID68, MASTER_1_PRESENT, 9, 1)
    FIELD(POR_MPU_UNIT_INFO_U_RND_NID68, MASTER_0_PRESENT, 8, 1)
    FIELD(POR_MPU_UNIT_INFO_U_RND_NID68, NUM_PROG_REGION, 0, 8)
REG32(POR_MPU_M0_CTL_U_RND_NID68, 0x835000)
    FIELD(POR_MPU_M0_CTL_U_RND_NID68, M0_EN, 2, 1)
    FIELD(POR_MPU_M0_CTL_U_RND_NID68, M0_ACTION, 0, 2)
REG32(POR_MPU_M0_PRBAR0_U_RND_NID68, 0x835010)
    FIELD(POR_MPU_M0_PRBAR0_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR0_U_RND_NID68, REGION0_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR0_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR0_U_RND_NID68, REGION0_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR0_U_RND_NID68, REGION0_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR0_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR0_U_RND_NID68, 0x835018)
    FIELD(POR_MPU_M0_PRLAR0_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR0_U_RND_NID68, REGION0_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR0_U_RND_NID68, REGION0_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR1_U_RND_NID68, 0x835020)
    FIELD(POR_MPU_M0_PRBAR1_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR1_U_RND_NID68, REGION1_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR1_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR1_U_RND_NID68, REGION1_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR1_U_RND_NID68, REGION1_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR1_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR1_U_RND_NID68, 0x835028)
    FIELD(POR_MPU_M0_PRLAR1_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR1_U_RND_NID68, REGION1_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR1_U_RND_NID68, REGION1_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR2_U_RND_NID68, 0x835030)
    FIELD(POR_MPU_M0_PRBAR2_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR2_U_RND_NID68, REGION2_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR2_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR2_U_RND_NID68, REGION2_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR2_U_RND_NID68, REGION2_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR2_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR2_U_RND_NID68, 0x835038)
    FIELD(POR_MPU_M0_PRLAR2_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR2_U_RND_NID68, REGION2_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR2_U_RND_NID68, REGION2_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR3_U_RND_NID68, 0x835040)
    FIELD(POR_MPU_M0_PRBAR3_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR3_U_RND_NID68, REGION3_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR3_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR3_U_RND_NID68, REGION3_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR3_U_RND_NID68, REGION3_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR3_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR3_U_RND_NID68, 0x835048)
    FIELD(POR_MPU_M0_PRLAR3_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR3_U_RND_NID68, REGION3_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR3_U_RND_NID68, REGION3_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR4_U_RND_NID68, 0x835050)
    FIELD(POR_MPU_M0_PRBAR4_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR4_U_RND_NID68, REGION4_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR4_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR4_U_RND_NID68, REGION4_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR4_U_RND_NID68, REGION4_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR4_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR4_U_RND_NID68, 0x835058)
    FIELD(POR_MPU_M0_PRLAR4_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR4_U_RND_NID68, REGION4_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR4_U_RND_NID68, REGION4_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR5_U_RND_NID68, 0x835060)
    FIELD(POR_MPU_M0_PRBAR5_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR5_U_RND_NID68, REGION5_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR5_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR5_U_RND_NID68, REGION5_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR5_U_RND_NID68, REGION5_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR5_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR5_U_RND_NID68, 0x835068)
    FIELD(POR_MPU_M0_PRLAR5_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR5_U_RND_NID68, REGION5_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR5_U_RND_NID68, REGION5_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR6_U_RND_NID68, 0x835070)
    FIELD(POR_MPU_M0_PRBAR6_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR6_U_RND_NID68, REGION6_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR6_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR6_U_RND_NID68, REGION6_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR6_U_RND_NID68, REGION6_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR6_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR6_U_RND_NID68, 0x835078)
    FIELD(POR_MPU_M0_PRLAR6_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR6_U_RND_NID68, REGION6_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR6_U_RND_NID68, REGION6_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR7_U_RND_NID68, 0x835080)
    FIELD(POR_MPU_M0_PRBAR7_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR7_U_RND_NID68, REGION7_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR7_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR7_U_RND_NID68, REGION7_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR7_U_RND_NID68, REGION7_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR7_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR7_U_RND_NID68, 0x835088)
    FIELD(POR_MPU_M0_PRLAR7_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR7_U_RND_NID68, REGION7_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR7_U_RND_NID68, REGION7_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR8_U_RND_NID68, 0x835090)
    FIELD(POR_MPU_M0_PRBAR8_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR8_U_RND_NID68, REGION8_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR8_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR8_U_RND_NID68, REGION8_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR8_U_RND_NID68, REGION8_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR8_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR8_U_RND_NID68, 0x835098)
    FIELD(POR_MPU_M0_PRLAR8_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR8_U_RND_NID68, REGION8_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR8_U_RND_NID68, REGION8_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR9_U_RND_NID68, 0x8350a0)
    FIELD(POR_MPU_M0_PRBAR9_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR9_U_RND_NID68, REGION9_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR9_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR9_U_RND_NID68, REGION9_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR9_U_RND_NID68, REGION9_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR9_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR9_U_RND_NID68, 0x8350a8)
    FIELD(POR_MPU_M0_PRLAR9_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR9_U_RND_NID68, REGION9_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR9_U_RND_NID68, REGION9_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR10_U_RND_NID68, 0x8350b0)
    FIELD(POR_MPU_M0_PRBAR10_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR10_U_RND_NID68, REGION10_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR10_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR10_U_RND_NID68, REGION10_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR10_U_RND_NID68, REGION10_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR10_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR10_U_RND_NID68, 0x8350b8)
    FIELD(POR_MPU_M0_PRLAR10_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR10_U_RND_NID68, REGION10_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR10_U_RND_NID68, REGION10_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR11_U_RND_NID68, 0x8350c0)
    FIELD(POR_MPU_M0_PRBAR11_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR11_U_RND_NID68, REGION11_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR11_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR11_U_RND_NID68, REGION11_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR11_U_RND_NID68, REGION11_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR11_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR11_U_RND_NID68, 0x8350c8)
    FIELD(POR_MPU_M0_PRLAR11_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR11_U_RND_NID68, REGION11_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR11_U_RND_NID68, REGION11_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR12_U_RND_NID68, 0x8350d0)
    FIELD(POR_MPU_M0_PRBAR12_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR12_U_RND_NID68, REGION12_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR12_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR12_U_RND_NID68, REGION12_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR12_U_RND_NID68, REGION12_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR12_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR12_U_RND_NID68, 0x8350d8)
    FIELD(POR_MPU_M0_PRLAR12_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR12_U_RND_NID68, REGION12_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR12_U_RND_NID68, REGION12_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR13_U_RND_NID68, 0x8350e0)
    FIELD(POR_MPU_M0_PRBAR13_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR13_U_RND_NID68, REGION13_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR13_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR13_U_RND_NID68, REGION13_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR13_U_RND_NID68, REGION13_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR13_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR13_U_RND_NID68, 0x8350e8)
    FIELD(POR_MPU_M0_PRLAR13_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR13_U_RND_NID68, REGION13_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR13_U_RND_NID68, REGION13_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR14_U_RND_NID68, 0x8350f0)
    FIELD(POR_MPU_M0_PRBAR14_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR14_U_RND_NID68, REGION14_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR14_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR14_U_RND_NID68, REGION14_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR14_U_RND_NID68, REGION14_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR14_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR14_U_RND_NID68, 0x8350f8)
    FIELD(POR_MPU_M0_PRLAR14_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR14_U_RND_NID68, REGION14_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR14_U_RND_NID68, REGION14_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR15_U_RND_NID68, 0x835100)
    FIELD(POR_MPU_M0_PRBAR15_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR15_U_RND_NID68, REGION15_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR15_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR15_U_RND_NID68, REGION15_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR15_U_RND_NID68, REGION15_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR15_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR15_U_RND_NID68, 0x835108)
    FIELD(POR_MPU_M0_PRLAR15_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR15_U_RND_NID68, REGION15_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR15_U_RND_NID68, REGION15_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR16_U_RND_NID68, 0x835110)
    FIELD(POR_MPU_M0_PRBAR16_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR16_U_RND_NID68, REGION16_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR16_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR16_U_RND_NID68, REGION16_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR16_U_RND_NID68, REGION16_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR16_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR16_U_RND_NID68, 0x835118)
    FIELD(POR_MPU_M0_PRLAR16_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR16_U_RND_NID68, REGION16_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR16_U_RND_NID68, REGION16_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR17_U_RND_NID68, 0x835120)
    FIELD(POR_MPU_M0_PRBAR17_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR17_U_RND_NID68, REGION17_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR17_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR17_U_RND_NID68, REGION17_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR17_U_RND_NID68, REGION17_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR17_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR17_U_RND_NID68, 0x835128)
    FIELD(POR_MPU_M0_PRLAR17_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR17_U_RND_NID68, REGION17_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR17_U_RND_NID68, REGION17_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR18_U_RND_NID68, 0x835130)
    FIELD(POR_MPU_M0_PRBAR18_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR18_U_RND_NID68, REGION18_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR18_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR18_U_RND_NID68, REGION18_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR18_U_RND_NID68, REGION18_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR18_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR18_U_RND_NID68, 0x835138)
    FIELD(POR_MPU_M0_PRLAR18_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR18_U_RND_NID68, REGION18_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR18_U_RND_NID68, REGION18_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR19_U_RND_NID68, 0x835140)
    FIELD(POR_MPU_M0_PRBAR19_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR19_U_RND_NID68, REGION19_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR19_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR19_U_RND_NID68, REGION19_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR19_U_RND_NID68, REGION19_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR19_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR19_U_RND_NID68, 0x835148)
    FIELD(POR_MPU_M0_PRLAR19_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR19_U_RND_NID68, REGION19_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR19_U_RND_NID68, REGION19_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR20_U_RND_NID68, 0x835150)
    FIELD(POR_MPU_M0_PRBAR20_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR20_U_RND_NID68, REGION20_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR20_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR20_U_RND_NID68, REGION20_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR20_U_RND_NID68, REGION20_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR20_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR20_U_RND_NID68, 0x835158)
    FIELD(POR_MPU_M0_PRLAR20_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR20_U_RND_NID68, REGION20_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR20_U_RND_NID68, REGION20_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR21_U_RND_NID68, 0x835160)
    FIELD(POR_MPU_M0_PRBAR21_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR21_U_RND_NID68, REGION21_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR21_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR21_U_RND_NID68, REGION21_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR21_U_RND_NID68, REGION21_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR21_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR21_U_RND_NID68, 0x835168)
    FIELD(POR_MPU_M0_PRLAR21_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR21_U_RND_NID68, REGION21_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR21_U_RND_NID68, REGION21_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR22_U_RND_NID68, 0x835170)
    FIELD(POR_MPU_M0_PRBAR22_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR22_U_RND_NID68, REGION22_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR22_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR22_U_RND_NID68, REGION22_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR22_U_RND_NID68, REGION22_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR22_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR22_U_RND_NID68, 0x835178)
    FIELD(POR_MPU_M0_PRLAR22_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR22_U_RND_NID68, REGION22_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR22_U_RND_NID68, REGION22_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR23_U_RND_NID68, 0x835180)
    FIELD(POR_MPU_M0_PRBAR23_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR23_U_RND_NID68, REGION23_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR23_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR23_U_RND_NID68, REGION23_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR23_U_RND_NID68, REGION23_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR23_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR23_U_RND_NID68, 0x835188)
    FIELD(POR_MPU_M0_PRLAR23_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR23_U_RND_NID68, REGION23_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR23_U_RND_NID68, REGION23_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR24_U_RND_NID68, 0x835190)
    FIELD(POR_MPU_M0_PRBAR24_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR24_U_RND_NID68, REGION24_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR24_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR24_U_RND_NID68, REGION24_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR24_U_RND_NID68, REGION24_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR24_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR24_U_RND_NID68, 0x835198)
    FIELD(POR_MPU_M0_PRLAR24_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR24_U_RND_NID68, REGION24_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR24_U_RND_NID68, REGION24_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR25_U_RND_NID68, 0x8351a0)
    FIELD(POR_MPU_M0_PRBAR25_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR25_U_RND_NID68, REGION25_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR25_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR25_U_RND_NID68, REGION25_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR25_U_RND_NID68, REGION25_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR25_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR25_U_RND_NID68, 0x8351a8)
    FIELD(POR_MPU_M0_PRLAR25_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR25_U_RND_NID68, REGION25_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR25_U_RND_NID68, REGION25_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR26_U_RND_NID68, 0x8351b0)
    FIELD(POR_MPU_M0_PRBAR26_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR26_U_RND_NID68, REGION26_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR26_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR26_U_RND_NID68, REGION26_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR26_U_RND_NID68, REGION26_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR26_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR26_U_RND_NID68, 0x8351b8)
    FIELD(POR_MPU_M0_PRLAR26_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR26_U_RND_NID68, REGION26_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR26_U_RND_NID68, REGION26_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR27_U_RND_NID68, 0x8351c0)
    FIELD(POR_MPU_M0_PRBAR27_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR27_U_RND_NID68, REGION27_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR27_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR27_U_RND_NID68, REGION27_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR27_U_RND_NID68, REGION27_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR27_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR27_U_RND_NID68, 0x8351c8)
    FIELD(POR_MPU_M0_PRLAR27_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR27_U_RND_NID68, REGION27_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR27_U_RND_NID68, REGION27_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR28_U_RND_NID68, 0x8351d0)
    FIELD(POR_MPU_M0_PRBAR28_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR28_U_RND_NID68, REGION28_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR28_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR28_U_RND_NID68, REGION28_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR28_U_RND_NID68, REGION28_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR28_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR28_U_RND_NID68, 0x8351d8)
    FIELD(POR_MPU_M0_PRLAR28_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR28_U_RND_NID68, REGION28_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR28_U_RND_NID68, REGION28_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR29_U_RND_NID68, 0x8351e0)
    FIELD(POR_MPU_M0_PRBAR29_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR29_U_RND_NID68, REGION29_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR29_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR29_U_RND_NID68, REGION29_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR29_U_RND_NID68, REGION29_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR29_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR29_U_RND_NID68, 0x8351e8)
    FIELD(POR_MPU_M0_PRLAR29_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR29_U_RND_NID68, REGION29_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR29_U_RND_NID68, REGION29_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR30_U_RND_NID68, 0x8351f0)
    FIELD(POR_MPU_M0_PRBAR30_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR30_U_RND_NID68, REGION30_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR30_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR30_U_RND_NID68, REGION30_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR30_U_RND_NID68, REGION30_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR30_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR30_U_RND_NID68, 0x8351f8)
    FIELD(POR_MPU_M0_PRLAR30_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR30_U_RND_NID68, REGION30_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR30_U_RND_NID68, REGION30_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR31_U_RND_NID68, 0x835200)
    FIELD(POR_MPU_M0_PRBAR31_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR31_U_RND_NID68, REGION31_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR31_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR31_U_RND_NID68, REGION31_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR31_U_RND_NID68, REGION31_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR31_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR31_U_RND_NID68, 0x835208)
    FIELD(POR_MPU_M0_PRLAR31_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR31_U_RND_NID68, REGION31_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR31_U_RND_NID68, REGION31_EN, 0, 1)
REG32(POR_MPU_M1_CTL_U_RND_NID68, 0x835400)
    FIELD(POR_MPU_M1_CTL_U_RND_NID68, M1_EN, 2, 1)
    FIELD(POR_MPU_M1_CTL_U_RND_NID68, M1_ACTION, 0, 2)
REG32(POR_MPU_M1_PRBAR0_U_RND_NID68, 0x835410)
    FIELD(POR_MPU_M1_PRBAR0_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR0_U_RND_NID68, REGION0_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR0_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR0_U_RND_NID68, REGION0_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR0_U_RND_NID68, REGION0_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR0_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR0_U_RND_NID68, 0x835418)
    FIELD(POR_MPU_M1_PRLAR0_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR0_U_RND_NID68, REGION0_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR0_U_RND_NID68, REGION0_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR1_U_RND_NID68, 0x835420)
    FIELD(POR_MPU_M1_PRBAR1_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR1_U_RND_NID68, REGION1_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR1_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR1_U_RND_NID68, REGION1_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR1_U_RND_NID68, REGION1_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR1_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR1_U_RND_NID68, 0x835428)
    FIELD(POR_MPU_M1_PRLAR1_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR1_U_RND_NID68, REGION1_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR1_U_RND_NID68, REGION1_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR2_U_RND_NID68, 0x835430)
    FIELD(POR_MPU_M1_PRBAR2_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR2_U_RND_NID68, REGION2_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR2_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR2_U_RND_NID68, REGION2_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR2_U_RND_NID68, REGION2_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR2_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR2_U_RND_NID68, 0x835438)
    FIELD(POR_MPU_M1_PRLAR2_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR2_U_RND_NID68, REGION2_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR2_U_RND_NID68, REGION2_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR3_U_RND_NID68, 0x835440)
    FIELD(POR_MPU_M1_PRBAR3_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR3_U_RND_NID68, REGION3_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR3_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR3_U_RND_NID68, REGION3_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR3_U_RND_NID68, REGION3_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR3_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR3_U_RND_NID68, 0x835448)
    FIELD(POR_MPU_M1_PRLAR3_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR3_U_RND_NID68, REGION3_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR3_U_RND_NID68, REGION3_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR4_U_RND_NID68, 0x835450)
    FIELD(POR_MPU_M1_PRBAR4_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR4_U_RND_NID68, REGION4_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR4_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR4_U_RND_NID68, REGION4_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR4_U_RND_NID68, REGION4_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR4_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR4_U_RND_NID68, 0x835458)
    FIELD(POR_MPU_M1_PRLAR4_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR4_U_RND_NID68, REGION4_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR4_U_RND_NID68, REGION4_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR5_U_RND_NID68, 0x835460)
    FIELD(POR_MPU_M1_PRBAR5_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR5_U_RND_NID68, REGION5_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR5_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR5_U_RND_NID68, REGION5_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR5_U_RND_NID68, REGION5_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR5_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR5_U_RND_NID68, 0x835468)
    FIELD(POR_MPU_M1_PRLAR5_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR5_U_RND_NID68, REGION5_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR5_U_RND_NID68, REGION5_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR6_U_RND_NID68, 0x835470)
    FIELD(POR_MPU_M1_PRBAR6_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR6_U_RND_NID68, REGION6_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR6_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR6_U_RND_NID68, REGION6_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR6_U_RND_NID68, REGION6_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR6_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR6_U_RND_NID68, 0x835478)
    FIELD(POR_MPU_M1_PRLAR6_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR6_U_RND_NID68, REGION6_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR6_U_RND_NID68, REGION6_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR7_U_RND_NID68, 0x835480)
    FIELD(POR_MPU_M1_PRBAR7_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR7_U_RND_NID68, REGION7_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR7_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR7_U_RND_NID68, REGION7_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR7_U_RND_NID68, REGION7_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR7_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR7_U_RND_NID68, 0x835488)
    FIELD(POR_MPU_M1_PRLAR7_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR7_U_RND_NID68, REGION7_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR7_U_RND_NID68, REGION7_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR8_U_RND_NID68, 0x835490)
    FIELD(POR_MPU_M1_PRBAR8_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR8_U_RND_NID68, REGION8_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR8_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR8_U_RND_NID68, REGION8_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR8_U_RND_NID68, REGION8_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR8_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR8_U_RND_NID68, 0x835498)
    FIELD(POR_MPU_M1_PRLAR8_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR8_U_RND_NID68, REGION8_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR8_U_RND_NID68, REGION8_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR9_U_RND_NID68, 0x8354a0)
    FIELD(POR_MPU_M1_PRBAR9_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR9_U_RND_NID68, REGION9_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR9_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR9_U_RND_NID68, REGION9_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR9_U_RND_NID68, REGION9_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR9_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR9_U_RND_NID68, 0x8354a8)
    FIELD(POR_MPU_M1_PRLAR9_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR9_U_RND_NID68, REGION9_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR9_U_RND_NID68, REGION9_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR10_U_RND_NID68, 0x8354b0)
    FIELD(POR_MPU_M1_PRBAR10_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR10_U_RND_NID68, REGION10_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR10_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR10_U_RND_NID68, REGION10_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR10_U_RND_NID68, REGION10_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR10_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR10_U_RND_NID68, 0x8354b8)
    FIELD(POR_MPU_M1_PRLAR10_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR10_U_RND_NID68, REGION10_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR10_U_RND_NID68, REGION10_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR11_U_RND_NID68, 0x8354c0)
    FIELD(POR_MPU_M1_PRBAR11_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR11_U_RND_NID68, REGION11_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR11_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR11_U_RND_NID68, REGION11_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR11_U_RND_NID68, REGION11_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR11_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR11_U_RND_NID68, 0x8354c8)
    FIELD(POR_MPU_M1_PRLAR11_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR11_U_RND_NID68, REGION11_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR11_U_RND_NID68, REGION11_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR12_U_RND_NID68, 0x8354d0)
    FIELD(POR_MPU_M1_PRBAR12_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR12_U_RND_NID68, REGION12_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR12_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR12_U_RND_NID68, REGION12_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR12_U_RND_NID68, REGION12_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR12_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR12_U_RND_NID68, 0x8354d8)
    FIELD(POR_MPU_M1_PRLAR12_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR12_U_RND_NID68, REGION12_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR12_U_RND_NID68, REGION12_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR13_U_RND_NID68, 0x8354e0)
    FIELD(POR_MPU_M1_PRBAR13_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR13_U_RND_NID68, REGION13_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR13_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR13_U_RND_NID68, REGION13_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR13_U_RND_NID68, REGION13_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR13_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR13_U_RND_NID68, 0x8354e8)
    FIELD(POR_MPU_M1_PRLAR13_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR13_U_RND_NID68, REGION13_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR13_U_RND_NID68, REGION13_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR14_U_RND_NID68, 0x8354f0)
    FIELD(POR_MPU_M1_PRBAR14_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR14_U_RND_NID68, REGION14_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR14_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR14_U_RND_NID68, REGION14_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR14_U_RND_NID68, REGION14_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR14_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR14_U_RND_NID68, 0x8354f8)
    FIELD(POR_MPU_M1_PRLAR14_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR14_U_RND_NID68, REGION14_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR14_U_RND_NID68, REGION14_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR15_U_RND_NID68, 0x835500)
    FIELD(POR_MPU_M1_PRBAR15_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR15_U_RND_NID68, REGION15_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR15_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR15_U_RND_NID68, REGION15_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR15_U_RND_NID68, REGION15_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR15_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR15_U_RND_NID68, 0x835508)
    FIELD(POR_MPU_M1_PRLAR15_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR15_U_RND_NID68, REGION15_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR15_U_RND_NID68, REGION15_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR16_U_RND_NID68, 0x835510)
    FIELD(POR_MPU_M1_PRBAR16_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR16_U_RND_NID68, REGION16_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR16_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR16_U_RND_NID68, REGION16_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR16_U_RND_NID68, REGION16_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR16_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR16_U_RND_NID68, 0x835518)
    FIELD(POR_MPU_M1_PRLAR16_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR16_U_RND_NID68, REGION16_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR16_U_RND_NID68, REGION16_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR17_U_RND_NID68, 0x835520)
    FIELD(POR_MPU_M1_PRBAR17_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR17_U_RND_NID68, REGION17_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR17_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR17_U_RND_NID68, REGION17_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR17_U_RND_NID68, REGION17_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR17_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR17_U_RND_NID68, 0x835528)
    FIELD(POR_MPU_M1_PRLAR17_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR17_U_RND_NID68, REGION17_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR17_U_RND_NID68, REGION17_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR18_U_RND_NID68, 0x835530)
    FIELD(POR_MPU_M1_PRBAR18_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR18_U_RND_NID68, REGION18_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR18_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR18_U_RND_NID68, REGION18_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR18_U_RND_NID68, REGION18_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR18_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR18_U_RND_NID68, 0x835538)
    FIELD(POR_MPU_M1_PRLAR18_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR18_U_RND_NID68, REGION18_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR18_U_RND_NID68, REGION18_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR19_U_RND_NID68, 0x835540)
    FIELD(POR_MPU_M1_PRBAR19_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR19_U_RND_NID68, REGION19_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR19_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR19_U_RND_NID68, REGION19_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR19_U_RND_NID68, REGION19_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR19_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR19_U_RND_NID68, 0x835548)
    FIELD(POR_MPU_M1_PRLAR19_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR19_U_RND_NID68, REGION19_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR19_U_RND_NID68, REGION19_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR20_U_RND_NID68, 0x835550)
    FIELD(POR_MPU_M1_PRBAR20_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR20_U_RND_NID68, REGION20_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR20_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR20_U_RND_NID68, REGION20_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR20_U_RND_NID68, REGION20_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR20_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR20_U_RND_NID68, 0x835558)
    FIELD(POR_MPU_M1_PRLAR20_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR20_U_RND_NID68, REGION20_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR20_U_RND_NID68, REGION20_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR21_U_RND_NID68, 0x835560)
    FIELD(POR_MPU_M1_PRBAR21_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR21_U_RND_NID68, REGION21_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR21_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR21_U_RND_NID68, REGION21_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR21_U_RND_NID68, REGION21_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR21_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR21_U_RND_NID68, 0x835568)
    FIELD(POR_MPU_M1_PRLAR21_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR21_U_RND_NID68, REGION21_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR21_U_RND_NID68, REGION21_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR22_U_RND_NID68, 0x835570)
    FIELD(POR_MPU_M1_PRBAR22_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR22_U_RND_NID68, REGION22_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR22_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR22_U_RND_NID68, REGION22_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR22_U_RND_NID68, REGION22_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR22_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR22_U_RND_NID68, 0x835578)
    FIELD(POR_MPU_M1_PRLAR22_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR22_U_RND_NID68, REGION22_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR22_U_RND_NID68, REGION22_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR23_U_RND_NID68, 0x835580)
    FIELD(POR_MPU_M1_PRBAR23_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR23_U_RND_NID68, REGION23_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR23_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR23_U_RND_NID68, REGION23_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR23_U_RND_NID68, REGION23_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR23_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR23_U_RND_NID68, 0x835588)
    FIELD(POR_MPU_M1_PRLAR23_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR23_U_RND_NID68, REGION23_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR23_U_RND_NID68, REGION23_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR24_U_RND_NID68, 0x835590)
    FIELD(POR_MPU_M1_PRBAR24_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR24_U_RND_NID68, REGION24_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR24_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR24_U_RND_NID68, REGION24_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR24_U_RND_NID68, REGION24_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR24_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR24_U_RND_NID68, 0x835598)
    FIELD(POR_MPU_M1_PRLAR24_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR24_U_RND_NID68, REGION24_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR24_U_RND_NID68, REGION24_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR25_U_RND_NID68, 0x8355a0)
    FIELD(POR_MPU_M1_PRBAR25_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR25_U_RND_NID68, REGION25_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR25_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR25_U_RND_NID68, REGION25_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR25_U_RND_NID68, REGION25_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR25_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR25_U_RND_NID68, 0x8355a8)
    FIELD(POR_MPU_M1_PRLAR25_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR25_U_RND_NID68, REGION25_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR25_U_RND_NID68, REGION25_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR26_U_RND_NID68, 0x8355b0)
    FIELD(POR_MPU_M1_PRBAR26_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR26_U_RND_NID68, REGION26_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR26_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR26_U_RND_NID68, REGION26_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR26_U_RND_NID68, REGION26_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR26_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR26_U_RND_NID68, 0x8355b8)
    FIELD(POR_MPU_M1_PRLAR26_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR26_U_RND_NID68, REGION26_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR26_U_RND_NID68, REGION26_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR27_U_RND_NID68, 0x8355c0)
    FIELD(POR_MPU_M1_PRBAR27_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR27_U_RND_NID68, REGION27_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR27_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR27_U_RND_NID68, REGION27_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR27_U_RND_NID68, REGION27_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR27_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR27_U_RND_NID68, 0x8355c8)
    FIELD(POR_MPU_M1_PRLAR27_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR27_U_RND_NID68, REGION27_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR27_U_RND_NID68, REGION27_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR28_U_RND_NID68, 0x8355d0)
    FIELD(POR_MPU_M1_PRBAR28_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR28_U_RND_NID68, REGION28_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR28_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR28_U_RND_NID68, REGION28_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR28_U_RND_NID68, REGION28_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR28_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR28_U_RND_NID68, 0x8355d8)
    FIELD(POR_MPU_M1_PRLAR28_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR28_U_RND_NID68, REGION28_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR28_U_RND_NID68, REGION28_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR29_U_RND_NID68, 0x8355e0)
    FIELD(POR_MPU_M1_PRBAR29_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR29_U_RND_NID68, REGION29_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR29_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR29_U_RND_NID68, REGION29_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR29_U_RND_NID68, REGION29_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR29_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR29_U_RND_NID68, 0x8355e8)
    FIELD(POR_MPU_M1_PRLAR29_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR29_U_RND_NID68, REGION29_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR29_U_RND_NID68, REGION29_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR30_U_RND_NID68, 0x8355f0)
    FIELD(POR_MPU_M1_PRBAR30_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR30_U_RND_NID68, REGION30_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR30_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR30_U_RND_NID68, REGION30_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR30_U_RND_NID68, REGION30_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR30_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR30_U_RND_NID68, 0x8355f8)
    FIELD(POR_MPU_M1_PRLAR30_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR30_U_RND_NID68, REGION30_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR30_U_RND_NID68, REGION30_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR31_U_RND_NID68, 0x835600)
    FIELD(POR_MPU_M1_PRBAR31_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR31_U_RND_NID68, REGION31_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR31_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR31_U_RND_NID68, REGION31_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR31_U_RND_NID68, REGION31_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR31_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR31_U_RND_NID68, 0x835608)
    FIELD(POR_MPU_M1_PRLAR31_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR31_U_RND_NID68, REGION31_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR31_U_RND_NID68, REGION31_EN, 0, 1)
REG32(POR_MPU_M2_CTL_U_RND_NID68, 0x835800)
    FIELD(POR_MPU_M2_CTL_U_RND_NID68, M2_EN, 2, 1)
    FIELD(POR_MPU_M2_CTL_U_RND_NID68, M2_ACTION, 0, 2)
REG32(POR_MPU_M2_PRBAR0_U_RND_NID68, 0x835810)
    FIELD(POR_MPU_M2_PRBAR0_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR0_U_RND_NID68, REGION0_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR0_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR0_U_RND_NID68, REGION0_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR0_U_RND_NID68, REGION0_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR0_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR0_U_RND_NID68, 0x835818)
    FIELD(POR_MPU_M2_PRLAR0_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR0_U_RND_NID68, REGION0_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR0_U_RND_NID68, REGION0_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR1_U_RND_NID68, 0x835820)
    FIELD(POR_MPU_M2_PRBAR1_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR1_U_RND_NID68, REGION1_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR1_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR1_U_RND_NID68, REGION1_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR1_U_RND_NID68, REGION1_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR1_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR1_U_RND_NID68, 0x835828)
    FIELD(POR_MPU_M2_PRLAR1_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR1_U_RND_NID68, REGION1_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR1_U_RND_NID68, REGION1_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR2_U_RND_NID68, 0x835830)
    FIELD(POR_MPU_M2_PRBAR2_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR2_U_RND_NID68, REGION2_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR2_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR2_U_RND_NID68, REGION2_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR2_U_RND_NID68, REGION2_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR2_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR2_U_RND_NID68, 0x835838)
    FIELD(POR_MPU_M2_PRLAR2_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR2_U_RND_NID68, REGION2_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR2_U_RND_NID68, REGION2_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR3_U_RND_NID68, 0x835840)
    FIELD(POR_MPU_M2_PRBAR3_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR3_U_RND_NID68, REGION3_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR3_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR3_U_RND_NID68, REGION3_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR3_U_RND_NID68, REGION3_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR3_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR3_U_RND_NID68, 0x835848)
    FIELD(POR_MPU_M2_PRLAR3_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR3_U_RND_NID68, REGION3_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR3_U_RND_NID68, REGION3_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR4_U_RND_NID68, 0x835850)
    FIELD(POR_MPU_M2_PRBAR4_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR4_U_RND_NID68, REGION4_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR4_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR4_U_RND_NID68, REGION4_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR4_U_RND_NID68, REGION4_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR4_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR4_U_RND_NID68, 0x835858)
    FIELD(POR_MPU_M2_PRLAR4_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR4_U_RND_NID68, REGION4_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR4_U_RND_NID68, REGION4_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR5_U_RND_NID68, 0x835860)
    FIELD(POR_MPU_M2_PRBAR5_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR5_U_RND_NID68, REGION5_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR5_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR5_U_RND_NID68, REGION5_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR5_U_RND_NID68, REGION5_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR5_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR5_U_RND_NID68, 0x835868)
    FIELD(POR_MPU_M2_PRLAR5_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR5_U_RND_NID68, REGION5_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR5_U_RND_NID68, REGION5_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR6_U_RND_NID68, 0x835870)
    FIELD(POR_MPU_M2_PRBAR6_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR6_U_RND_NID68, REGION6_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR6_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR6_U_RND_NID68, REGION6_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR6_U_RND_NID68, REGION6_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR6_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR6_U_RND_NID68, 0x835878)
    FIELD(POR_MPU_M2_PRLAR6_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR6_U_RND_NID68, REGION6_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR6_U_RND_NID68, REGION6_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR7_U_RND_NID68, 0x835880)
    FIELD(POR_MPU_M2_PRBAR7_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR7_U_RND_NID68, REGION7_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR7_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR7_U_RND_NID68, REGION7_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR7_U_RND_NID68, REGION7_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR7_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR7_U_RND_NID68, 0x835888)
    FIELD(POR_MPU_M2_PRLAR7_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR7_U_RND_NID68, REGION7_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR7_U_RND_NID68, REGION7_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR8_U_RND_NID68, 0x835890)
    FIELD(POR_MPU_M2_PRBAR8_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR8_U_RND_NID68, REGION8_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR8_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR8_U_RND_NID68, REGION8_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR8_U_RND_NID68, REGION8_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR8_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR8_U_RND_NID68, 0x835898)
    FIELD(POR_MPU_M2_PRLAR8_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR8_U_RND_NID68, REGION8_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR8_U_RND_NID68, REGION8_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR9_U_RND_NID68, 0x8358a0)
    FIELD(POR_MPU_M2_PRBAR9_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR9_U_RND_NID68, REGION9_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR9_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR9_U_RND_NID68, REGION9_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR9_U_RND_NID68, REGION9_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR9_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR9_U_RND_NID68, 0x8358a8)
    FIELD(POR_MPU_M2_PRLAR9_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR9_U_RND_NID68, REGION9_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR9_U_RND_NID68, REGION9_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR10_U_RND_NID68, 0x8358b0)
    FIELD(POR_MPU_M2_PRBAR10_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR10_U_RND_NID68, REGION10_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR10_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR10_U_RND_NID68, REGION10_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR10_U_RND_NID68, REGION10_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR10_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR10_U_RND_NID68, 0x8358b8)
    FIELD(POR_MPU_M2_PRLAR10_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR10_U_RND_NID68, REGION10_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR10_U_RND_NID68, REGION10_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR11_U_RND_NID68, 0x8358c0)
    FIELD(POR_MPU_M2_PRBAR11_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR11_U_RND_NID68, REGION11_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR11_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR11_U_RND_NID68, REGION11_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR11_U_RND_NID68, REGION11_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR11_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR11_U_RND_NID68, 0x8358c8)
    FIELD(POR_MPU_M2_PRLAR11_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR11_U_RND_NID68, REGION11_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR11_U_RND_NID68, REGION11_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR12_U_RND_NID68, 0x8358d0)
    FIELD(POR_MPU_M2_PRBAR12_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR12_U_RND_NID68, REGION12_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR12_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR12_U_RND_NID68, REGION12_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR12_U_RND_NID68, REGION12_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR12_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR12_U_RND_NID68, 0x8358d8)
    FIELD(POR_MPU_M2_PRLAR12_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR12_U_RND_NID68, REGION12_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR12_U_RND_NID68, REGION12_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR13_U_RND_NID68, 0x8358e0)
    FIELD(POR_MPU_M2_PRBAR13_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR13_U_RND_NID68, REGION13_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR13_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR13_U_RND_NID68, REGION13_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR13_U_RND_NID68, REGION13_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR13_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR13_U_RND_NID68, 0x8358e8)
    FIELD(POR_MPU_M2_PRLAR13_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR13_U_RND_NID68, REGION13_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR13_U_RND_NID68, REGION13_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR14_U_RND_NID68, 0x8358f0)
    FIELD(POR_MPU_M2_PRBAR14_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR14_U_RND_NID68, REGION14_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR14_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR14_U_RND_NID68, REGION14_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR14_U_RND_NID68, REGION14_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR14_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR14_U_RND_NID68, 0x8358f8)
    FIELD(POR_MPU_M2_PRLAR14_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR14_U_RND_NID68, REGION14_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR14_U_RND_NID68, REGION14_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR15_U_RND_NID68, 0x835900)
    FIELD(POR_MPU_M2_PRBAR15_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR15_U_RND_NID68, REGION15_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR15_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR15_U_RND_NID68, REGION15_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR15_U_RND_NID68, REGION15_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR15_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR15_U_RND_NID68, 0x835908)
    FIELD(POR_MPU_M2_PRLAR15_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR15_U_RND_NID68, REGION15_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR15_U_RND_NID68, REGION15_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR16_U_RND_NID68, 0x835910)
    FIELD(POR_MPU_M2_PRBAR16_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR16_U_RND_NID68, REGION16_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR16_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR16_U_RND_NID68, REGION16_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR16_U_RND_NID68, REGION16_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR16_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR16_U_RND_NID68, 0x835918)
    FIELD(POR_MPU_M2_PRLAR16_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR16_U_RND_NID68, REGION16_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR16_U_RND_NID68, REGION16_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR17_U_RND_NID68, 0x835920)
    FIELD(POR_MPU_M2_PRBAR17_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR17_U_RND_NID68, REGION17_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR17_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR17_U_RND_NID68, REGION17_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR17_U_RND_NID68, REGION17_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR17_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR17_U_RND_NID68, 0x835928)
    FIELD(POR_MPU_M2_PRLAR17_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR17_U_RND_NID68, REGION17_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR17_U_RND_NID68, REGION17_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR18_U_RND_NID68, 0x835930)
    FIELD(POR_MPU_M2_PRBAR18_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR18_U_RND_NID68, REGION18_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR18_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR18_U_RND_NID68, REGION18_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR18_U_RND_NID68, REGION18_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR18_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR18_U_RND_NID68, 0x835938)
    FIELD(POR_MPU_M2_PRLAR18_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR18_U_RND_NID68, REGION18_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR18_U_RND_NID68, REGION18_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR19_U_RND_NID68, 0x835940)
    FIELD(POR_MPU_M2_PRBAR19_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR19_U_RND_NID68, REGION19_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR19_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR19_U_RND_NID68, REGION19_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR19_U_RND_NID68, REGION19_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR19_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR19_U_RND_NID68, 0x835948)
    FIELD(POR_MPU_M2_PRLAR19_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR19_U_RND_NID68, REGION19_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR19_U_RND_NID68, REGION19_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR20_U_RND_NID68, 0x835950)
    FIELD(POR_MPU_M2_PRBAR20_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR20_U_RND_NID68, REGION20_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR20_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR20_U_RND_NID68, REGION20_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR20_U_RND_NID68, REGION20_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR20_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR20_U_RND_NID68, 0x835958)
    FIELD(POR_MPU_M2_PRLAR20_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR20_U_RND_NID68, REGION20_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR20_U_RND_NID68, REGION20_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR21_U_RND_NID68, 0x835960)
    FIELD(POR_MPU_M2_PRBAR21_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR21_U_RND_NID68, REGION21_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR21_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR21_U_RND_NID68, REGION21_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR21_U_RND_NID68, REGION21_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR21_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR21_U_RND_NID68, 0x835968)
    FIELD(POR_MPU_M2_PRLAR21_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR21_U_RND_NID68, REGION21_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR21_U_RND_NID68, REGION21_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR22_U_RND_NID68, 0x835970)
    FIELD(POR_MPU_M2_PRBAR22_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR22_U_RND_NID68, REGION22_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR22_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR22_U_RND_NID68, REGION22_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR22_U_RND_NID68, REGION22_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR22_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR22_U_RND_NID68, 0x835978)
    FIELD(POR_MPU_M2_PRLAR22_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR22_U_RND_NID68, REGION22_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR22_U_RND_NID68, REGION22_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR23_U_RND_NID68, 0x835980)
    FIELD(POR_MPU_M2_PRBAR23_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR23_U_RND_NID68, REGION23_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR23_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR23_U_RND_NID68, REGION23_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR23_U_RND_NID68, REGION23_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR23_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR23_U_RND_NID68, 0x835988)
    FIELD(POR_MPU_M2_PRLAR23_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR23_U_RND_NID68, REGION23_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR23_U_RND_NID68, REGION23_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR24_U_RND_NID68, 0x835990)
    FIELD(POR_MPU_M2_PRBAR24_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR24_U_RND_NID68, REGION24_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR24_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR24_U_RND_NID68, REGION24_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR24_U_RND_NID68, REGION24_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR24_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR24_U_RND_NID68, 0x835998)
    FIELD(POR_MPU_M2_PRLAR24_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR24_U_RND_NID68, REGION24_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR24_U_RND_NID68, REGION24_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR25_U_RND_NID68, 0x8359a0)
    FIELD(POR_MPU_M2_PRBAR25_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR25_U_RND_NID68, REGION25_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR25_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR25_U_RND_NID68, REGION25_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR25_U_RND_NID68, REGION25_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR25_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR25_U_RND_NID68, 0x8359a8)
    FIELD(POR_MPU_M2_PRLAR25_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR25_U_RND_NID68, REGION25_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR25_U_RND_NID68, REGION25_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR26_U_RND_NID68, 0x8359b0)
    FIELD(POR_MPU_M2_PRBAR26_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR26_U_RND_NID68, REGION26_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR26_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR26_U_RND_NID68, REGION26_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR26_U_RND_NID68, REGION26_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR26_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR26_U_RND_NID68, 0x8359b8)
    FIELD(POR_MPU_M2_PRLAR26_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR26_U_RND_NID68, REGION26_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR26_U_RND_NID68, REGION26_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR27_U_RND_NID68, 0x8359c0)
    FIELD(POR_MPU_M2_PRBAR27_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR27_U_RND_NID68, REGION27_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR27_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR27_U_RND_NID68, REGION27_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR27_U_RND_NID68, REGION27_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR27_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR27_U_RND_NID68, 0x8359c8)
    FIELD(POR_MPU_M2_PRLAR27_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR27_U_RND_NID68, REGION27_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR27_U_RND_NID68, REGION27_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR28_U_RND_NID68, 0x8359d0)
    FIELD(POR_MPU_M2_PRBAR28_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR28_U_RND_NID68, REGION28_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR28_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR28_U_RND_NID68, REGION28_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR28_U_RND_NID68, REGION28_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR28_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR28_U_RND_NID68, 0x8359d8)
    FIELD(POR_MPU_M2_PRLAR28_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR28_U_RND_NID68, REGION28_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR28_U_RND_NID68, REGION28_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR29_U_RND_NID68, 0x8359e0)
    FIELD(POR_MPU_M2_PRBAR29_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR29_U_RND_NID68, REGION29_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR29_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR29_U_RND_NID68, REGION29_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR29_U_RND_NID68, REGION29_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR29_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR29_U_RND_NID68, 0x8359e8)
    FIELD(POR_MPU_M2_PRLAR29_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR29_U_RND_NID68, REGION29_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR29_U_RND_NID68, REGION29_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR30_U_RND_NID68, 0x8359f0)
    FIELD(POR_MPU_M2_PRBAR30_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR30_U_RND_NID68, REGION30_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR30_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR30_U_RND_NID68, REGION30_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR30_U_RND_NID68, REGION30_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR30_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR30_U_RND_NID68, 0x8359f8)
    FIELD(POR_MPU_M2_PRLAR30_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR30_U_RND_NID68, REGION30_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR30_U_RND_NID68, REGION30_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR31_U_RND_NID68, 0x835a00)
    FIELD(POR_MPU_M2_PRBAR31_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR31_U_RND_NID68, REGION31_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR31_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR31_U_RND_NID68, REGION31_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR31_U_RND_NID68, REGION31_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR31_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR31_U_RND_NID68, 0x835a08)
    FIELD(POR_MPU_M2_PRLAR31_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR31_U_RND_NID68, REGION31_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR31_U_RND_NID68, REGION31_EN, 0, 1)
REG32(POR_MPU_M3_CTL_U_RND_NID68, 0x835c00)
    FIELD(POR_MPU_M3_CTL_U_RND_NID68, M3_EN, 2, 1)
    FIELD(POR_MPU_M3_CTL_U_RND_NID68, M3_ACTION, 0, 2)
REG32(POR_MPU_M3_PRBAR0_U_RND_NID68, 0x835c10)
    FIELD(POR_MPU_M3_PRBAR0_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR0_U_RND_NID68, REGION0_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR0_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR0_U_RND_NID68, REGION0_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR0_U_RND_NID68, REGION0_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR0_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR0_U_RND_NID68, 0x835c18)
    FIELD(POR_MPU_M3_PRLAR0_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR0_U_RND_NID68, REGION0_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR0_U_RND_NID68, REGION0_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR1_U_RND_NID68, 0x835c20)
    FIELD(POR_MPU_M3_PRBAR1_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR1_U_RND_NID68, REGION1_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR1_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR1_U_RND_NID68, REGION1_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR1_U_RND_NID68, REGION1_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR1_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR1_U_RND_NID68, 0x835c28)
    FIELD(POR_MPU_M3_PRLAR1_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR1_U_RND_NID68, REGION1_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR1_U_RND_NID68, REGION1_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR2_U_RND_NID68, 0x835c30)
    FIELD(POR_MPU_M3_PRBAR2_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR2_U_RND_NID68, REGION2_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR2_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR2_U_RND_NID68, REGION2_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR2_U_RND_NID68, REGION2_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR2_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR2_U_RND_NID68, 0x835c38)
    FIELD(POR_MPU_M3_PRLAR2_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR2_U_RND_NID68, REGION2_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR2_U_RND_NID68, REGION2_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR3_U_RND_NID68, 0x835c40)
    FIELD(POR_MPU_M3_PRBAR3_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR3_U_RND_NID68, REGION3_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR3_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR3_U_RND_NID68, REGION3_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR3_U_RND_NID68, REGION3_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR3_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR3_U_RND_NID68, 0x835c48)
    FIELD(POR_MPU_M3_PRLAR3_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR3_U_RND_NID68, REGION3_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR3_U_RND_NID68, REGION3_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR4_U_RND_NID68, 0x835c50)
    FIELD(POR_MPU_M3_PRBAR4_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR4_U_RND_NID68, REGION4_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR4_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR4_U_RND_NID68, REGION4_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR4_U_RND_NID68, REGION4_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR4_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR4_U_RND_NID68, 0x835c58)
    FIELD(POR_MPU_M3_PRLAR4_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR4_U_RND_NID68, REGION4_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR4_U_RND_NID68, REGION4_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR5_U_RND_NID68, 0x835c60)
    FIELD(POR_MPU_M3_PRBAR5_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR5_U_RND_NID68, REGION5_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR5_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR5_U_RND_NID68, REGION5_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR5_U_RND_NID68, REGION5_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR5_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR5_U_RND_NID68, 0x835c68)
    FIELD(POR_MPU_M3_PRLAR5_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR5_U_RND_NID68, REGION5_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR5_U_RND_NID68, REGION5_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR6_U_RND_NID68, 0x835c70)
    FIELD(POR_MPU_M3_PRBAR6_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR6_U_RND_NID68, REGION6_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR6_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR6_U_RND_NID68, REGION6_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR6_U_RND_NID68, REGION6_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR6_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR6_U_RND_NID68, 0x835c78)
    FIELD(POR_MPU_M3_PRLAR6_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR6_U_RND_NID68, REGION6_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR6_U_RND_NID68, REGION6_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR7_U_RND_NID68, 0x835c80)
    FIELD(POR_MPU_M3_PRBAR7_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR7_U_RND_NID68, REGION7_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR7_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR7_U_RND_NID68, REGION7_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR7_U_RND_NID68, REGION7_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR7_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR7_U_RND_NID68, 0x835c88)
    FIELD(POR_MPU_M3_PRLAR7_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR7_U_RND_NID68, REGION7_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR7_U_RND_NID68, REGION7_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR8_U_RND_NID68, 0x835c90)
    FIELD(POR_MPU_M3_PRBAR8_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR8_U_RND_NID68, REGION8_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR8_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR8_U_RND_NID68, REGION8_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR8_U_RND_NID68, REGION8_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR8_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR8_U_RND_NID68, 0x835c98)
    FIELD(POR_MPU_M3_PRLAR8_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR8_U_RND_NID68, REGION8_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR8_U_RND_NID68, REGION8_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR9_U_RND_NID68, 0x835ca0)
    FIELD(POR_MPU_M3_PRBAR9_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR9_U_RND_NID68, REGION9_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR9_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR9_U_RND_NID68, REGION9_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR9_U_RND_NID68, REGION9_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR9_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR9_U_RND_NID68, 0x835ca8)
    FIELD(POR_MPU_M3_PRLAR9_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR9_U_RND_NID68, REGION9_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR9_U_RND_NID68, REGION9_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR10_U_RND_NID68, 0x835cb0)
    FIELD(POR_MPU_M3_PRBAR10_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR10_U_RND_NID68, REGION10_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR10_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR10_U_RND_NID68, REGION10_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR10_U_RND_NID68, REGION10_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR10_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR10_U_RND_NID68, 0x835cb8)
    FIELD(POR_MPU_M3_PRLAR10_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR10_U_RND_NID68, REGION10_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR10_U_RND_NID68, REGION10_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR11_U_RND_NID68, 0x835cc0)
    FIELD(POR_MPU_M3_PRBAR11_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR11_U_RND_NID68, REGION11_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR11_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR11_U_RND_NID68, REGION11_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR11_U_RND_NID68, REGION11_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR11_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR11_U_RND_NID68, 0x835cc8)
    FIELD(POR_MPU_M3_PRLAR11_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR11_U_RND_NID68, REGION11_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR11_U_RND_NID68, REGION11_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR12_U_RND_NID68, 0x835cd0)
    FIELD(POR_MPU_M3_PRBAR12_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR12_U_RND_NID68, REGION12_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR12_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR12_U_RND_NID68, REGION12_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR12_U_RND_NID68, REGION12_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR12_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR12_U_RND_NID68, 0x835cd8)
    FIELD(POR_MPU_M3_PRLAR12_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR12_U_RND_NID68, REGION12_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR12_U_RND_NID68, REGION12_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR13_U_RND_NID68, 0x835ce0)
    FIELD(POR_MPU_M3_PRBAR13_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR13_U_RND_NID68, REGION13_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR13_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR13_U_RND_NID68, REGION13_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR13_U_RND_NID68, REGION13_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR13_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR13_U_RND_NID68, 0x835ce8)
    FIELD(POR_MPU_M3_PRLAR13_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR13_U_RND_NID68, REGION13_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR13_U_RND_NID68, REGION13_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR14_U_RND_NID68, 0x835cf0)
    FIELD(POR_MPU_M3_PRBAR14_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR14_U_RND_NID68, REGION14_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR14_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR14_U_RND_NID68, REGION14_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR14_U_RND_NID68, REGION14_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR14_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR14_U_RND_NID68, 0x835cf8)
    FIELD(POR_MPU_M3_PRLAR14_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR14_U_RND_NID68, REGION14_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR14_U_RND_NID68, REGION14_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR15_U_RND_NID68, 0x835d00)
    FIELD(POR_MPU_M3_PRBAR15_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR15_U_RND_NID68, REGION15_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR15_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR15_U_RND_NID68, REGION15_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR15_U_RND_NID68, REGION15_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR15_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR15_U_RND_NID68, 0x835d08)
    FIELD(POR_MPU_M3_PRLAR15_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR15_U_RND_NID68, REGION15_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR15_U_RND_NID68, REGION15_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR16_U_RND_NID68, 0x835d10)
    FIELD(POR_MPU_M3_PRBAR16_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR16_U_RND_NID68, REGION16_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR16_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR16_U_RND_NID68, REGION16_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR16_U_RND_NID68, REGION16_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR16_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR16_U_RND_NID68, 0x835d18)
    FIELD(POR_MPU_M3_PRLAR16_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR16_U_RND_NID68, REGION16_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR16_U_RND_NID68, REGION16_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR17_U_RND_NID68, 0x835d20)
    FIELD(POR_MPU_M3_PRBAR17_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR17_U_RND_NID68, REGION17_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR17_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR17_U_RND_NID68, REGION17_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR17_U_RND_NID68, REGION17_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR17_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR17_U_RND_NID68, 0x835d28)
    FIELD(POR_MPU_M3_PRLAR17_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR17_U_RND_NID68, REGION17_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR17_U_RND_NID68, REGION17_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR18_U_RND_NID68, 0x835d30)
    FIELD(POR_MPU_M3_PRBAR18_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR18_U_RND_NID68, REGION18_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR18_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR18_U_RND_NID68, REGION18_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR18_U_RND_NID68, REGION18_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR18_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR18_U_RND_NID68, 0x835d38)
    FIELD(POR_MPU_M3_PRLAR18_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR18_U_RND_NID68, REGION18_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR18_U_RND_NID68, REGION18_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR19_U_RND_NID68, 0x835d40)
    FIELD(POR_MPU_M3_PRBAR19_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR19_U_RND_NID68, REGION19_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR19_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR19_U_RND_NID68, REGION19_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR19_U_RND_NID68, REGION19_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR19_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR19_U_RND_NID68, 0x835d48)
    FIELD(POR_MPU_M3_PRLAR19_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR19_U_RND_NID68, REGION19_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR19_U_RND_NID68, REGION19_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR20_U_RND_NID68, 0x835d50)
    FIELD(POR_MPU_M3_PRBAR20_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR20_U_RND_NID68, REGION20_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR20_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR20_U_RND_NID68, REGION20_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR20_U_RND_NID68, REGION20_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR20_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR20_U_RND_NID68, 0x835d58)
    FIELD(POR_MPU_M3_PRLAR20_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR20_U_RND_NID68, REGION20_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR20_U_RND_NID68, REGION20_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR21_U_RND_NID68, 0x835d60)
    FIELD(POR_MPU_M3_PRBAR21_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR21_U_RND_NID68, REGION21_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR21_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR21_U_RND_NID68, REGION21_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR21_U_RND_NID68, REGION21_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR21_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR21_U_RND_NID68, 0x835d68)
    FIELD(POR_MPU_M3_PRLAR21_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR21_U_RND_NID68, REGION21_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR21_U_RND_NID68, REGION21_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR22_U_RND_NID68, 0x835d70)
    FIELD(POR_MPU_M3_PRBAR22_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR22_U_RND_NID68, REGION22_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR22_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR22_U_RND_NID68, REGION22_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR22_U_RND_NID68, REGION22_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR22_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR22_U_RND_NID68, 0x835d78)
    FIELD(POR_MPU_M3_PRLAR22_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR22_U_RND_NID68, REGION22_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR22_U_RND_NID68, REGION22_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR23_U_RND_NID68, 0x835d80)
    FIELD(POR_MPU_M3_PRBAR23_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR23_U_RND_NID68, REGION23_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR23_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR23_U_RND_NID68, REGION23_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR23_U_RND_NID68, REGION23_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR23_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR23_U_RND_NID68, 0x835d88)
    FIELD(POR_MPU_M3_PRLAR23_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR23_U_RND_NID68, REGION23_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR23_U_RND_NID68, REGION23_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR24_U_RND_NID68, 0x835d90)
    FIELD(POR_MPU_M3_PRBAR24_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR24_U_RND_NID68, REGION24_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR24_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR24_U_RND_NID68, REGION24_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR24_U_RND_NID68, REGION24_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR24_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR24_U_RND_NID68, 0x835d98)
    FIELD(POR_MPU_M3_PRLAR24_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR24_U_RND_NID68, REGION24_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR24_U_RND_NID68, REGION24_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR25_U_RND_NID68, 0x835da0)
    FIELD(POR_MPU_M3_PRBAR25_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR25_U_RND_NID68, REGION25_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR25_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR25_U_RND_NID68, REGION25_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR25_U_RND_NID68, REGION25_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR25_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR25_U_RND_NID68, 0x835da8)
    FIELD(POR_MPU_M3_PRLAR25_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR25_U_RND_NID68, REGION25_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR25_U_RND_NID68, REGION25_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR26_U_RND_NID68, 0x835db0)
    FIELD(POR_MPU_M3_PRBAR26_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR26_U_RND_NID68, REGION26_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR26_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR26_U_RND_NID68, REGION26_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR26_U_RND_NID68, REGION26_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR26_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR26_U_RND_NID68, 0x835db8)
    FIELD(POR_MPU_M3_PRLAR26_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR26_U_RND_NID68, REGION26_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR26_U_RND_NID68, REGION26_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR27_U_RND_NID68, 0x835dc0)
    FIELD(POR_MPU_M3_PRBAR27_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR27_U_RND_NID68, REGION27_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR27_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR27_U_RND_NID68, REGION27_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR27_U_RND_NID68, REGION27_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR27_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR27_U_RND_NID68, 0x835dc8)
    FIELD(POR_MPU_M3_PRLAR27_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR27_U_RND_NID68, REGION27_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR27_U_RND_NID68, REGION27_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR28_U_RND_NID68, 0x835dd0)
    FIELD(POR_MPU_M3_PRBAR28_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR28_U_RND_NID68, REGION28_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR28_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR28_U_RND_NID68, REGION28_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR28_U_RND_NID68, REGION28_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR28_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR28_U_RND_NID68, 0x835dd8)
    FIELD(POR_MPU_M3_PRLAR28_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR28_U_RND_NID68, REGION28_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR28_U_RND_NID68, REGION28_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR29_U_RND_NID68, 0x835de0)
    FIELD(POR_MPU_M3_PRBAR29_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR29_U_RND_NID68, REGION29_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR29_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR29_U_RND_NID68, REGION29_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR29_U_RND_NID68, REGION29_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR29_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR29_U_RND_NID68, 0x835de8)
    FIELD(POR_MPU_M3_PRLAR29_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR29_U_RND_NID68, REGION29_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR29_U_RND_NID68, REGION29_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR30_U_RND_NID68, 0x835df0)
    FIELD(POR_MPU_M3_PRBAR30_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR30_U_RND_NID68, REGION30_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR30_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR30_U_RND_NID68, REGION30_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR30_U_RND_NID68, REGION30_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR30_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR30_U_RND_NID68, 0x835df8)
    FIELD(POR_MPU_M3_PRLAR30_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR30_U_RND_NID68, REGION30_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR30_U_RND_NID68, REGION30_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR31_U_RND_NID68, 0x835e00)
    FIELD(POR_MPU_M3_PRBAR31_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR31_U_RND_NID68, REGION31_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR31_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR31_U_RND_NID68, REGION31_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR31_U_RND_NID68, REGION31_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR31_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR31_U_RND_NID68, 0x835e08)
    FIELD(POR_MPU_M3_PRLAR31_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR31_U_RND_NID68, REGION31_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR31_U_RND_NID68, REGION31_EN, 0, 1)
REG32(POR_MPU_M4_CTL_U_RND_NID68, 0x836000)
    FIELD(POR_MPU_M4_CTL_U_RND_NID68, M4_EN, 2, 1)
    FIELD(POR_MPU_M4_CTL_U_RND_NID68, M4_ACTION, 0, 2)
REG32(POR_MPU_M4_PRBAR0_U_RND_NID68, 0x836010)
    FIELD(POR_MPU_M4_PRBAR0_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR0_U_RND_NID68, REGION0_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR0_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR0_U_RND_NID68, REGION0_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR0_U_RND_NID68, REGION0_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR0_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR0_U_RND_NID68, 0x836018)
    FIELD(POR_MPU_M4_PRLAR0_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR0_U_RND_NID68, REGION0_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR0_U_RND_NID68, REGION0_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR1_U_RND_NID68, 0x836020)
    FIELD(POR_MPU_M4_PRBAR1_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR1_U_RND_NID68, REGION1_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR1_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR1_U_RND_NID68, REGION1_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR1_U_RND_NID68, REGION1_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR1_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR1_U_RND_NID68, 0x836028)
    FIELD(POR_MPU_M4_PRLAR1_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR1_U_RND_NID68, REGION1_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR1_U_RND_NID68, REGION1_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR2_U_RND_NID68, 0x836030)
    FIELD(POR_MPU_M4_PRBAR2_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR2_U_RND_NID68, REGION2_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR2_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR2_U_RND_NID68, REGION2_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR2_U_RND_NID68, REGION2_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR2_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR2_U_RND_NID68, 0x836038)
    FIELD(POR_MPU_M4_PRLAR2_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR2_U_RND_NID68, REGION2_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR2_U_RND_NID68, REGION2_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR3_U_RND_NID68, 0x836040)
    FIELD(POR_MPU_M4_PRBAR3_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR3_U_RND_NID68, REGION3_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR3_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR3_U_RND_NID68, REGION3_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR3_U_RND_NID68, REGION3_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR3_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR3_U_RND_NID68, 0x836048)
    FIELD(POR_MPU_M4_PRLAR3_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR3_U_RND_NID68, REGION3_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR3_U_RND_NID68, REGION3_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR4_U_RND_NID68, 0x836050)
    FIELD(POR_MPU_M4_PRBAR4_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR4_U_RND_NID68, REGION4_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR4_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR4_U_RND_NID68, REGION4_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR4_U_RND_NID68, REGION4_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR4_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR4_U_RND_NID68, 0x836058)
    FIELD(POR_MPU_M4_PRLAR4_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR4_U_RND_NID68, REGION4_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR4_U_RND_NID68, REGION4_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR5_U_RND_NID68, 0x836060)
    FIELD(POR_MPU_M4_PRBAR5_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR5_U_RND_NID68, REGION5_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR5_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR5_U_RND_NID68, REGION5_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR5_U_RND_NID68, REGION5_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR5_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR5_U_RND_NID68, 0x836068)
    FIELD(POR_MPU_M4_PRLAR5_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR5_U_RND_NID68, REGION5_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR5_U_RND_NID68, REGION5_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR6_U_RND_NID68, 0x836070)
    FIELD(POR_MPU_M4_PRBAR6_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR6_U_RND_NID68, REGION6_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR6_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR6_U_RND_NID68, REGION6_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR6_U_RND_NID68, REGION6_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR6_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR6_U_RND_NID68, 0x836078)
    FIELD(POR_MPU_M4_PRLAR6_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR6_U_RND_NID68, REGION6_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR6_U_RND_NID68, REGION6_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR7_U_RND_NID68, 0x836080)
    FIELD(POR_MPU_M4_PRBAR7_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR7_U_RND_NID68, REGION7_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR7_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR7_U_RND_NID68, REGION7_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR7_U_RND_NID68, REGION7_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR7_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR7_U_RND_NID68, 0x836088)
    FIELD(POR_MPU_M4_PRLAR7_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR7_U_RND_NID68, REGION7_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR7_U_RND_NID68, REGION7_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR8_U_RND_NID68, 0x836090)
    FIELD(POR_MPU_M4_PRBAR8_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR8_U_RND_NID68, REGION8_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR8_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR8_U_RND_NID68, REGION8_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR8_U_RND_NID68, REGION8_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR8_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR8_U_RND_NID68, 0x836098)
    FIELD(POR_MPU_M4_PRLAR8_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR8_U_RND_NID68, REGION8_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR8_U_RND_NID68, REGION8_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR9_U_RND_NID68, 0x8360a0)
    FIELD(POR_MPU_M4_PRBAR9_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR9_U_RND_NID68, REGION9_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR9_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR9_U_RND_NID68, REGION9_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR9_U_RND_NID68, REGION9_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR9_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR9_U_RND_NID68, 0x8360a8)
    FIELD(POR_MPU_M4_PRLAR9_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR9_U_RND_NID68, REGION9_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR9_U_RND_NID68, REGION9_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR10_U_RND_NID68, 0x8360b0)
    FIELD(POR_MPU_M4_PRBAR10_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR10_U_RND_NID68, REGION10_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR10_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR10_U_RND_NID68, REGION10_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR10_U_RND_NID68, REGION10_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR10_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR10_U_RND_NID68, 0x8360b8)
    FIELD(POR_MPU_M4_PRLAR10_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR10_U_RND_NID68, REGION10_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR10_U_RND_NID68, REGION10_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR11_U_RND_NID68, 0x8360c0)
    FIELD(POR_MPU_M4_PRBAR11_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR11_U_RND_NID68, REGION11_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR11_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR11_U_RND_NID68, REGION11_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR11_U_RND_NID68, REGION11_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR11_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR11_U_RND_NID68, 0x8360c8)
    FIELD(POR_MPU_M4_PRLAR11_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR11_U_RND_NID68, REGION11_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR11_U_RND_NID68, REGION11_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR12_U_RND_NID68, 0x8360d0)
    FIELD(POR_MPU_M4_PRBAR12_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR12_U_RND_NID68, REGION12_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR12_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR12_U_RND_NID68, REGION12_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR12_U_RND_NID68, REGION12_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR12_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR12_U_RND_NID68, 0x8360d8)
    FIELD(POR_MPU_M4_PRLAR12_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR12_U_RND_NID68, REGION12_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR12_U_RND_NID68, REGION12_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR13_U_RND_NID68, 0x8360e0)
    FIELD(POR_MPU_M4_PRBAR13_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR13_U_RND_NID68, REGION13_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR13_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR13_U_RND_NID68, REGION13_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR13_U_RND_NID68, REGION13_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR13_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR13_U_RND_NID68, 0x8360e8)
    FIELD(POR_MPU_M4_PRLAR13_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR13_U_RND_NID68, REGION13_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR13_U_RND_NID68, REGION13_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR14_U_RND_NID68, 0x8360f0)
    FIELD(POR_MPU_M4_PRBAR14_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR14_U_RND_NID68, REGION14_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR14_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR14_U_RND_NID68, REGION14_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR14_U_RND_NID68, REGION14_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR14_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR14_U_RND_NID68, 0x8360f8)
    FIELD(POR_MPU_M4_PRLAR14_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR14_U_RND_NID68, REGION14_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR14_U_RND_NID68, REGION14_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR15_U_RND_NID68, 0x836100)
    FIELD(POR_MPU_M4_PRBAR15_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR15_U_RND_NID68, REGION15_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR15_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR15_U_RND_NID68, REGION15_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR15_U_RND_NID68, REGION15_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR15_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR15_U_RND_NID68, 0x836108)
    FIELD(POR_MPU_M4_PRLAR15_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR15_U_RND_NID68, REGION15_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR15_U_RND_NID68, REGION15_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR16_U_RND_NID68, 0x836110)
    FIELD(POR_MPU_M4_PRBAR16_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR16_U_RND_NID68, REGION16_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR16_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR16_U_RND_NID68, REGION16_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR16_U_RND_NID68, REGION16_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR16_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR16_U_RND_NID68, 0x836118)
    FIELD(POR_MPU_M4_PRLAR16_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR16_U_RND_NID68, REGION16_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR16_U_RND_NID68, REGION16_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR17_U_RND_NID68, 0x836120)
    FIELD(POR_MPU_M4_PRBAR17_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR17_U_RND_NID68, REGION17_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR17_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR17_U_RND_NID68, REGION17_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR17_U_RND_NID68, REGION17_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR17_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR17_U_RND_NID68, 0x836128)
    FIELD(POR_MPU_M4_PRLAR17_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR17_U_RND_NID68, REGION17_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR17_U_RND_NID68, REGION17_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR18_U_RND_NID68, 0x836130)
    FIELD(POR_MPU_M4_PRBAR18_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR18_U_RND_NID68, REGION18_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR18_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR18_U_RND_NID68, REGION18_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR18_U_RND_NID68, REGION18_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR18_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR18_U_RND_NID68, 0x836138)
    FIELD(POR_MPU_M4_PRLAR18_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR18_U_RND_NID68, REGION18_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR18_U_RND_NID68, REGION18_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR19_U_RND_NID68, 0x836140)
    FIELD(POR_MPU_M4_PRBAR19_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR19_U_RND_NID68, REGION19_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR19_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR19_U_RND_NID68, REGION19_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR19_U_RND_NID68, REGION19_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR19_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR19_U_RND_NID68, 0x836148)
    FIELD(POR_MPU_M4_PRLAR19_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR19_U_RND_NID68, REGION19_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR19_U_RND_NID68, REGION19_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR20_U_RND_NID68, 0x836150)
    FIELD(POR_MPU_M4_PRBAR20_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR20_U_RND_NID68, REGION20_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR20_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR20_U_RND_NID68, REGION20_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR20_U_RND_NID68, REGION20_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR20_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR20_U_RND_NID68, 0x836158)
    FIELD(POR_MPU_M4_PRLAR20_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR20_U_RND_NID68, REGION20_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR20_U_RND_NID68, REGION20_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR21_U_RND_NID68, 0x836160)
    FIELD(POR_MPU_M4_PRBAR21_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR21_U_RND_NID68, REGION21_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR21_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR21_U_RND_NID68, REGION21_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR21_U_RND_NID68, REGION21_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR21_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR21_U_RND_NID68, 0x836168)
    FIELD(POR_MPU_M4_PRLAR21_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR21_U_RND_NID68, REGION21_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR21_U_RND_NID68, REGION21_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR22_U_RND_NID68, 0x836170)
    FIELD(POR_MPU_M4_PRBAR22_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR22_U_RND_NID68, REGION22_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR22_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR22_U_RND_NID68, REGION22_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR22_U_RND_NID68, REGION22_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR22_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR22_U_RND_NID68, 0x836178)
    FIELD(POR_MPU_M4_PRLAR22_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR22_U_RND_NID68, REGION22_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR22_U_RND_NID68, REGION22_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR23_U_RND_NID68, 0x836180)
    FIELD(POR_MPU_M4_PRBAR23_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR23_U_RND_NID68, REGION23_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR23_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR23_U_RND_NID68, REGION23_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR23_U_RND_NID68, REGION23_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR23_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR23_U_RND_NID68, 0x836188)
    FIELD(POR_MPU_M4_PRLAR23_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR23_U_RND_NID68, REGION23_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR23_U_RND_NID68, REGION23_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR24_U_RND_NID68, 0x836190)
    FIELD(POR_MPU_M4_PRBAR24_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR24_U_RND_NID68, REGION24_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR24_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR24_U_RND_NID68, REGION24_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR24_U_RND_NID68, REGION24_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR24_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR24_U_RND_NID68, 0x836198)
    FIELD(POR_MPU_M4_PRLAR24_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR24_U_RND_NID68, REGION24_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR24_U_RND_NID68, REGION24_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR25_U_RND_NID68, 0x8361a0)
    FIELD(POR_MPU_M4_PRBAR25_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR25_U_RND_NID68, REGION25_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR25_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR25_U_RND_NID68, REGION25_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR25_U_RND_NID68, REGION25_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR25_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR25_U_RND_NID68, 0x8361a8)
    FIELD(POR_MPU_M4_PRLAR25_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR25_U_RND_NID68, REGION25_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR25_U_RND_NID68, REGION25_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR26_U_RND_NID68, 0x8361b0)
    FIELD(POR_MPU_M4_PRBAR26_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR26_U_RND_NID68, REGION26_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR26_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR26_U_RND_NID68, REGION26_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR26_U_RND_NID68, REGION26_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR26_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR26_U_RND_NID68, 0x8361b8)
    FIELD(POR_MPU_M4_PRLAR26_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR26_U_RND_NID68, REGION26_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR26_U_RND_NID68, REGION26_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR27_U_RND_NID68, 0x8361c0)
    FIELD(POR_MPU_M4_PRBAR27_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR27_U_RND_NID68, REGION27_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR27_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR27_U_RND_NID68, REGION27_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR27_U_RND_NID68, REGION27_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR27_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR27_U_RND_NID68, 0x8361c8)
    FIELD(POR_MPU_M4_PRLAR27_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR27_U_RND_NID68, REGION27_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR27_U_RND_NID68, REGION27_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR28_U_RND_NID68, 0x8361d0)
    FIELD(POR_MPU_M4_PRBAR28_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR28_U_RND_NID68, REGION28_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR28_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR28_U_RND_NID68, REGION28_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR28_U_RND_NID68, REGION28_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR28_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR28_U_RND_NID68, 0x8361d8)
    FIELD(POR_MPU_M4_PRLAR28_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR28_U_RND_NID68, REGION28_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR28_U_RND_NID68, REGION28_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR29_U_RND_NID68, 0x8361e0)
    FIELD(POR_MPU_M4_PRBAR29_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR29_U_RND_NID68, REGION29_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR29_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR29_U_RND_NID68, REGION29_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR29_U_RND_NID68, REGION29_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR29_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR29_U_RND_NID68, 0x8361e8)
    FIELD(POR_MPU_M4_PRLAR29_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR29_U_RND_NID68, REGION29_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR29_U_RND_NID68, REGION29_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR30_U_RND_NID68, 0x8361f0)
    FIELD(POR_MPU_M4_PRBAR30_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR30_U_RND_NID68, REGION30_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR30_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR30_U_RND_NID68, REGION30_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR30_U_RND_NID68, REGION30_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR30_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR30_U_RND_NID68, 0x8361f8)
    FIELD(POR_MPU_M4_PRLAR30_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR30_U_RND_NID68, REGION30_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR30_U_RND_NID68, REGION30_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR31_U_RND_NID68, 0x836200)
    FIELD(POR_MPU_M4_PRBAR31_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR31_U_RND_NID68, REGION31_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR31_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR31_U_RND_NID68, REGION31_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR31_U_RND_NID68, REGION31_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR31_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR31_U_RND_NID68, 0x836208)
    FIELD(POR_MPU_M4_PRLAR31_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR31_U_RND_NID68, REGION31_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR31_U_RND_NID68, REGION31_EN, 0, 1)
REG32(POR_MPU_M5_CTL_U_RND_NID68, 0x836400)
    FIELD(POR_MPU_M5_CTL_U_RND_NID68, M5_EN, 2, 1)
    FIELD(POR_MPU_M5_CTL_U_RND_NID68, M5_ACTION, 0, 2)
REG32(POR_MPU_M5_PRBAR0_U_RND_NID68, 0x836410)
    FIELD(POR_MPU_M5_PRBAR0_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR0_U_RND_NID68, REGION0_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR0_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR0_U_RND_NID68, REGION0_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR0_U_RND_NID68, REGION0_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR0_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR0_U_RND_NID68, 0x836418)
    FIELD(POR_MPU_M5_PRLAR0_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR0_U_RND_NID68, REGION0_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR0_U_RND_NID68, REGION0_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR1_U_RND_NID68, 0x836420)
    FIELD(POR_MPU_M5_PRBAR1_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR1_U_RND_NID68, REGION1_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR1_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR1_U_RND_NID68, REGION1_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR1_U_RND_NID68, REGION1_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR1_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR1_U_RND_NID68, 0x836428)
    FIELD(POR_MPU_M5_PRLAR1_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR1_U_RND_NID68, REGION1_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR1_U_RND_NID68, REGION1_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR2_U_RND_NID68, 0x836430)
    FIELD(POR_MPU_M5_PRBAR2_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR2_U_RND_NID68, REGION2_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR2_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR2_U_RND_NID68, REGION2_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR2_U_RND_NID68, REGION2_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR2_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR2_U_RND_NID68, 0x836438)
    FIELD(POR_MPU_M5_PRLAR2_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR2_U_RND_NID68, REGION2_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR2_U_RND_NID68, REGION2_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR3_U_RND_NID68, 0x836440)
    FIELD(POR_MPU_M5_PRBAR3_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR3_U_RND_NID68, REGION3_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR3_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR3_U_RND_NID68, REGION3_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR3_U_RND_NID68, REGION3_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR3_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR3_U_RND_NID68, 0x836448)
    FIELD(POR_MPU_M5_PRLAR3_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR3_U_RND_NID68, REGION3_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR3_U_RND_NID68, REGION3_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR4_U_RND_NID68, 0x836450)
    FIELD(POR_MPU_M5_PRBAR4_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR4_U_RND_NID68, REGION4_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR4_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR4_U_RND_NID68, REGION4_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR4_U_RND_NID68, REGION4_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR4_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR4_U_RND_NID68, 0x836458)
    FIELD(POR_MPU_M5_PRLAR4_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR4_U_RND_NID68, REGION4_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR4_U_RND_NID68, REGION4_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR5_U_RND_NID68, 0x836460)
    FIELD(POR_MPU_M5_PRBAR5_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR5_U_RND_NID68, REGION5_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR5_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR5_U_RND_NID68, REGION5_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR5_U_RND_NID68, REGION5_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR5_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR5_U_RND_NID68, 0x836468)
    FIELD(POR_MPU_M5_PRLAR5_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR5_U_RND_NID68, REGION5_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR5_U_RND_NID68, REGION5_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR6_U_RND_NID68, 0x836470)
    FIELD(POR_MPU_M5_PRBAR6_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR6_U_RND_NID68, REGION6_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR6_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR6_U_RND_NID68, REGION6_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR6_U_RND_NID68, REGION6_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR6_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR6_U_RND_NID68, 0x836478)
    FIELD(POR_MPU_M5_PRLAR6_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR6_U_RND_NID68, REGION6_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR6_U_RND_NID68, REGION6_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR7_U_RND_NID68, 0x836480)
    FIELD(POR_MPU_M5_PRBAR7_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR7_U_RND_NID68, REGION7_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR7_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR7_U_RND_NID68, REGION7_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR7_U_RND_NID68, REGION7_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR7_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR7_U_RND_NID68, 0x836488)
    FIELD(POR_MPU_M5_PRLAR7_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR7_U_RND_NID68, REGION7_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR7_U_RND_NID68, REGION7_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR8_U_RND_NID68, 0x836490)
    FIELD(POR_MPU_M5_PRBAR8_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR8_U_RND_NID68, REGION8_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR8_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR8_U_RND_NID68, REGION8_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR8_U_RND_NID68, REGION8_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR8_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR8_U_RND_NID68, 0x836498)
    FIELD(POR_MPU_M5_PRLAR8_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR8_U_RND_NID68, REGION8_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR8_U_RND_NID68, REGION8_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR9_U_RND_NID68, 0x8364a0)
    FIELD(POR_MPU_M5_PRBAR9_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR9_U_RND_NID68, REGION9_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR9_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR9_U_RND_NID68, REGION9_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR9_U_RND_NID68, REGION9_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR9_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR9_U_RND_NID68, 0x8364a8)
    FIELD(POR_MPU_M5_PRLAR9_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR9_U_RND_NID68, REGION9_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR9_U_RND_NID68, REGION9_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR10_U_RND_NID68, 0x8364b0)
    FIELD(POR_MPU_M5_PRBAR10_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR10_U_RND_NID68, REGION10_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR10_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR10_U_RND_NID68, REGION10_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR10_U_RND_NID68, REGION10_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR10_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR10_U_RND_NID68, 0x8364b8)
    FIELD(POR_MPU_M5_PRLAR10_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR10_U_RND_NID68, REGION10_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR10_U_RND_NID68, REGION10_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR11_U_RND_NID68, 0x8364c0)
    FIELD(POR_MPU_M5_PRBAR11_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR11_U_RND_NID68, REGION11_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR11_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR11_U_RND_NID68, REGION11_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR11_U_RND_NID68, REGION11_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR11_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR11_U_RND_NID68, 0x8364c8)
    FIELD(POR_MPU_M5_PRLAR11_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR11_U_RND_NID68, REGION11_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR11_U_RND_NID68, REGION11_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR12_U_RND_NID68, 0x8364d0)
    FIELD(POR_MPU_M5_PRBAR12_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR12_U_RND_NID68, REGION12_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR12_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR12_U_RND_NID68, REGION12_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR12_U_RND_NID68, REGION12_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR12_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR12_U_RND_NID68, 0x8364d8)
    FIELD(POR_MPU_M5_PRLAR12_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR12_U_RND_NID68, REGION12_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR12_U_RND_NID68, REGION12_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR13_U_RND_NID68, 0x8364e0)
    FIELD(POR_MPU_M5_PRBAR13_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR13_U_RND_NID68, REGION13_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR13_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR13_U_RND_NID68, REGION13_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR13_U_RND_NID68, REGION13_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR13_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR13_U_RND_NID68, 0x8364e8)
    FIELD(POR_MPU_M5_PRLAR13_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR13_U_RND_NID68, REGION13_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR13_U_RND_NID68, REGION13_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR14_U_RND_NID68, 0x8364f0)
    FIELD(POR_MPU_M5_PRBAR14_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR14_U_RND_NID68, REGION14_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR14_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR14_U_RND_NID68, REGION14_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR14_U_RND_NID68, REGION14_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR14_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR14_U_RND_NID68, 0x8364f8)
    FIELD(POR_MPU_M5_PRLAR14_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR14_U_RND_NID68, REGION14_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR14_U_RND_NID68, REGION14_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR15_U_RND_NID68, 0x836500)
    FIELD(POR_MPU_M5_PRBAR15_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR15_U_RND_NID68, REGION15_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR15_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR15_U_RND_NID68, REGION15_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR15_U_RND_NID68, REGION15_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR15_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR15_U_RND_NID68, 0x836508)
    FIELD(POR_MPU_M5_PRLAR15_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR15_U_RND_NID68, REGION15_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR15_U_RND_NID68, REGION15_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR16_U_RND_NID68, 0x836510)
    FIELD(POR_MPU_M5_PRBAR16_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR16_U_RND_NID68, REGION16_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR16_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR16_U_RND_NID68, REGION16_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR16_U_RND_NID68, REGION16_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR16_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR16_U_RND_NID68, 0x836518)
    FIELD(POR_MPU_M5_PRLAR16_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR16_U_RND_NID68, REGION16_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR16_U_RND_NID68, REGION16_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR17_U_RND_NID68, 0x836520)
    FIELD(POR_MPU_M5_PRBAR17_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR17_U_RND_NID68, REGION17_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR17_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR17_U_RND_NID68, REGION17_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR17_U_RND_NID68, REGION17_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR17_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR17_U_RND_NID68, 0x836528)
    FIELD(POR_MPU_M5_PRLAR17_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR17_U_RND_NID68, REGION17_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR17_U_RND_NID68, REGION17_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR18_U_RND_NID68, 0x836530)
    FIELD(POR_MPU_M5_PRBAR18_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR18_U_RND_NID68, REGION18_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR18_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR18_U_RND_NID68, REGION18_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR18_U_RND_NID68, REGION18_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR18_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR18_U_RND_NID68, 0x836538)
    FIELD(POR_MPU_M5_PRLAR18_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR18_U_RND_NID68, REGION18_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR18_U_RND_NID68, REGION18_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR19_U_RND_NID68, 0x836540)
    FIELD(POR_MPU_M5_PRBAR19_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR19_U_RND_NID68, REGION19_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR19_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR19_U_RND_NID68, REGION19_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR19_U_RND_NID68, REGION19_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR19_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR19_U_RND_NID68, 0x836548)
    FIELD(POR_MPU_M5_PRLAR19_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR19_U_RND_NID68, REGION19_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR19_U_RND_NID68, REGION19_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR20_U_RND_NID68, 0x836550)
    FIELD(POR_MPU_M5_PRBAR20_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR20_U_RND_NID68, REGION20_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR20_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR20_U_RND_NID68, REGION20_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR20_U_RND_NID68, REGION20_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR20_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR20_U_RND_NID68, 0x836558)
    FIELD(POR_MPU_M5_PRLAR20_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR20_U_RND_NID68, REGION20_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR20_U_RND_NID68, REGION20_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR21_U_RND_NID68, 0x836560)
    FIELD(POR_MPU_M5_PRBAR21_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR21_U_RND_NID68, REGION21_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR21_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR21_U_RND_NID68, REGION21_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR21_U_RND_NID68, REGION21_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR21_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR21_U_RND_NID68, 0x836568)
    FIELD(POR_MPU_M5_PRLAR21_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR21_U_RND_NID68, REGION21_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR21_U_RND_NID68, REGION21_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR22_U_RND_NID68, 0x836570)
    FIELD(POR_MPU_M5_PRBAR22_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR22_U_RND_NID68, REGION22_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR22_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR22_U_RND_NID68, REGION22_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR22_U_RND_NID68, REGION22_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR22_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR22_U_RND_NID68, 0x836578)
    FIELD(POR_MPU_M5_PRLAR22_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR22_U_RND_NID68, REGION22_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR22_U_RND_NID68, REGION22_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR23_U_RND_NID68, 0x836580)
    FIELD(POR_MPU_M5_PRBAR23_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR23_U_RND_NID68, REGION23_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR23_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR23_U_RND_NID68, REGION23_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR23_U_RND_NID68, REGION23_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR23_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR23_U_RND_NID68, 0x836588)
    FIELD(POR_MPU_M5_PRLAR23_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR23_U_RND_NID68, REGION23_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR23_U_RND_NID68, REGION23_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR24_U_RND_NID68, 0x836590)
    FIELD(POR_MPU_M5_PRBAR24_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR24_U_RND_NID68, REGION24_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR24_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR24_U_RND_NID68, REGION24_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR24_U_RND_NID68, REGION24_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR24_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR24_U_RND_NID68, 0x836598)
    FIELD(POR_MPU_M5_PRLAR24_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR24_U_RND_NID68, REGION24_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR24_U_RND_NID68, REGION24_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR25_U_RND_NID68, 0x8365a0)
    FIELD(POR_MPU_M5_PRBAR25_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR25_U_RND_NID68, REGION25_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR25_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR25_U_RND_NID68, REGION25_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR25_U_RND_NID68, REGION25_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR25_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR25_U_RND_NID68, 0x8365a8)
    FIELD(POR_MPU_M5_PRLAR25_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR25_U_RND_NID68, REGION25_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR25_U_RND_NID68, REGION25_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR26_U_RND_NID68, 0x8365b0)
    FIELD(POR_MPU_M5_PRBAR26_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR26_U_RND_NID68, REGION26_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR26_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR26_U_RND_NID68, REGION26_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR26_U_RND_NID68, REGION26_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR26_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR26_U_RND_NID68, 0x8365b8)
    FIELD(POR_MPU_M5_PRLAR26_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR26_U_RND_NID68, REGION26_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR26_U_RND_NID68, REGION26_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR27_U_RND_NID68, 0x8365c0)
    FIELD(POR_MPU_M5_PRBAR27_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR27_U_RND_NID68, REGION27_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR27_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR27_U_RND_NID68, REGION27_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR27_U_RND_NID68, REGION27_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR27_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR27_U_RND_NID68, 0x8365c8)
    FIELD(POR_MPU_M5_PRLAR27_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR27_U_RND_NID68, REGION27_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR27_U_RND_NID68, REGION27_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR28_U_RND_NID68, 0x8365d0)
    FIELD(POR_MPU_M5_PRBAR28_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR28_U_RND_NID68, REGION28_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR28_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR28_U_RND_NID68, REGION28_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR28_U_RND_NID68, REGION28_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR28_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR28_U_RND_NID68, 0x8365d8)
    FIELD(POR_MPU_M5_PRLAR28_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR28_U_RND_NID68, REGION28_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR28_U_RND_NID68, REGION28_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR29_U_RND_NID68, 0x8365e0)
    FIELD(POR_MPU_M5_PRBAR29_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR29_U_RND_NID68, REGION29_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR29_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR29_U_RND_NID68, REGION29_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR29_U_RND_NID68, REGION29_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR29_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR29_U_RND_NID68, 0x8365e8)
    FIELD(POR_MPU_M5_PRLAR29_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR29_U_RND_NID68, REGION29_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR29_U_RND_NID68, REGION29_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR30_U_RND_NID68, 0x8365f0)
    FIELD(POR_MPU_M5_PRBAR30_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR30_U_RND_NID68, REGION30_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR30_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR30_U_RND_NID68, REGION30_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR30_U_RND_NID68, REGION30_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR30_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR30_U_RND_NID68, 0x8365f8)
    FIELD(POR_MPU_M5_PRLAR30_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR30_U_RND_NID68, REGION30_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR30_U_RND_NID68, REGION30_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR31_U_RND_NID68, 0x836600)
    FIELD(POR_MPU_M5_PRBAR31_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR31_U_RND_NID68, REGION31_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR31_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR31_U_RND_NID68, REGION31_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR31_U_RND_NID68, REGION31_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR31_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR31_U_RND_NID68, 0x836608)
    FIELD(POR_MPU_M5_PRLAR31_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR31_U_RND_NID68, REGION31_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR31_U_RND_NID68, REGION31_EN, 0, 1)
REG32(POR_MPU_M6_CTL_U_RND_NID68, 0x836800)
    FIELD(POR_MPU_M6_CTL_U_RND_NID68, M6_EN, 2, 1)
    FIELD(POR_MPU_M6_CTL_U_RND_NID68, M6_ACTION, 0, 2)
REG32(POR_MPU_M6_PRBAR0_U_RND_NID68, 0x836810)
    FIELD(POR_MPU_M6_PRBAR0_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR0_U_RND_NID68, REGION0_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR0_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR0_U_RND_NID68, REGION0_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR0_U_RND_NID68, REGION0_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR0_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR0_U_RND_NID68, 0x836818)
    FIELD(POR_MPU_M6_PRLAR0_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR0_U_RND_NID68, REGION0_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR0_U_RND_NID68, REGION0_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR1_U_RND_NID68, 0x836820)
    FIELD(POR_MPU_M6_PRBAR1_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR1_U_RND_NID68, REGION1_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR1_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR1_U_RND_NID68, REGION1_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR1_U_RND_NID68, REGION1_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR1_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR1_U_RND_NID68, 0x836828)
    FIELD(POR_MPU_M6_PRLAR1_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR1_U_RND_NID68, REGION1_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR1_U_RND_NID68, REGION1_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR2_U_RND_NID68, 0x836830)
    FIELD(POR_MPU_M6_PRBAR2_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR2_U_RND_NID68, REGION2_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR2_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR2_U_RND_NID68, REGION2_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR2_U_RND_NID68, REGION2_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR2_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR2_U_RND_NID68, 0x836838)
    FIELD(POR_MPU_M6_PRLAR2_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR2_U_RND_NID68, REGION2_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR2_U_RND_NID68, REGION2_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR3_U_RND_NID68, 0x836840)
    FIELD(POR_MPU_M6_PRBAR3_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR3_U_RND_NID68, REGION3_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR3_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR3_U_RND_NID68, REGION3_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR3_U_RND_NID68, REGION3_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR3_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR3_U_RND_NID68, 0x836848)
    FIELD(POR_MPU_M6_PRLAR3_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR3_U_RND_NID68, REGION3_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR3_U_RND_NID68, REGION3_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR4_U_RND_NID68, 0x836850)
    FIELD(POR_MPU_M6_PRBAR4_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR4_U_RND_NID68, REGION4_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR4_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR4_U_RND_NID68, REGION4_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR4_U_RND_NID68, REGION4_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR4_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR4_U_RND_NID68, 0x836858)
    FIELD(POR_MPU_M6_PRLAR4_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR4_U_RND_NID68, REGION4_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR4_U_RND_NID68, REGION4_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR5_U_RND_NID68, 0x836860)
    FIELD(POR_MPU_M6_PRBAR5_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR5_U_RND_NID68, REGION5_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR5_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR5_U_RND_NID68, REGION5_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR5_U_RND_NID68, REGION5_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR5_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR5_U_RND_NID68, 0x836868)
    FIELD(POR_MPU_M6_PRLAR5_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR5_U_RND_NID68, REGION5_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR5_U_RND_NID68, REGION5_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR6_U_RND_NID68, 0x836870)
    FIELD(POR_MPU_M6_PRBAR6_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR6_U_RND_NID68, REGION6_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR6_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR6_U_RND_NID68, REGION6_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR6_U_RND_NID68, REGION6_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR6_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR6_U_RND_NID68, 0x836878)
    FIELD(POR_MPU_M6_PRLAR6_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR6_U_RND_NID68, REGION6_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR6_U_RND_NID68, REGION6_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR7_U_RND_NID68, 0x836880)
    FIELD(POR_MPU_M6_PRBAR7_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR7_U_RND_NID68, REGION7_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR7_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR7_U_RND_NID68, REGION7_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR7_U_RND_NID68, REGION7_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR7_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR7_U_RND_NID68, 0x836888)
    FIELD(POR_MPU_M6_PRLAR7_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR7_U_RND_NID68, REGION7_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR7_U_RND_NID68, REGION7_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR8_U_RND_NID68, 0x836890)
    FIELD(POR_MPU_M6_PRBAR8_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR8_U_RND_NID68, REGION8_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR8_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR8_U_RND_NID68, REGION8_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR8_U_RND_NID68, REGION8_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR8_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR8_U_RND_NID68, 0x836898)
    FIELD(POR_MPU_M6_PRLAR8_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR8_U_RND_NID68, REGION8_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR8_U_RND_NID68, REGION8_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR9_U_RND_NID68, 0x8368a0)
    FIELD(POR_MPU_M6_PRBAR9_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR9_U_RND_NID68, REGION9_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR9_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR9_U_RND_NID68, REGION9_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR9_U_RND_NID68, REGION9_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR9_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR9_U_RND_NID68, 0x8368a8)
    FIELD(POR_MPU_M6_PRLAR9_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR9_U_RND_NID68, REGION9_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR9_U_RND_NID68, REGION9_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR10_U_RND_NID68, 0x8368b0)
    FIELD(POR_MPU_M6_PRBAR10_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR10_U_RND_NID68, REGION10_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR10_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR10_U_RND_NID68, REGION10_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR10_U_RND_NID68, REGION10_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR10_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR10_U_RND_NID68, 0x8368b8)
    FIELD(POR_MPU_M6_PRLAR10_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR10_U_RND_NID68, REGION10_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR10_U_RND_NID68, REGION10_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR11_U_RND_NID68, 0x8368c0)
    FIELD(POR_MPU_M6_PRBAR11_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR11_U_RND_NID68, REGION11_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR11_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR11_U_RND_NID68, REGION11_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR11_U_RND_NID68, REGION11_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR11_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR11_U_RND_NID68, 0x8368c8)
    FIELD(POR_MPU_M6_PRLAR11_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR11_U_RND_NID68, REGION11_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR11_U_RND_NID68, REGION11_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR12_U_RND_NID68, 0x8368d0)
    FIELD(POR_MPU_M6_PRBAR12_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR12_U_RND_NID68, REGION12_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR12_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR12_U_RND_NID68, REGION12_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR12_U_RND_NID68, REGION12_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR12_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR12_U_RND_NID68, 0x8368d8)
    FIELD(POR_MPU_M6_PRLAR12_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR12_U_RND_NID68, REGION12_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR12_U_RND_NID68, REGION12_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR13_U_RND_NID68, 0x8368e0)
    FIELD(POR_MPU_M6_PRBAR13_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR13_U_RND_NID68, REGION13_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR13_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR13_U_RND_NID68, REGION13_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR13_U_RND_NID68, REGION13_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR13_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR13_U_RND_NID68, 0x8368e8)
    FIELD(POR_MPU_M6_PRLAR13_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR13_U_RND_NID68, REGION13_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR13_U_RND_NID68, REGION13_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR14_U_RND_NID68, 0x8368f0)
    FIELD(POR_MPU_M6_PRBAR14_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR14_U_RND_NID68, REGION14_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR14_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR14_U_RND_NID68, REGION14_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR14_U_RND_NID68, REGION14_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR14_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR14_U_RND_NID68, 0x8368f8)
    FIELD(POR_MPU_M6_PRLAR14_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR14_U_RND_NID68, REGION14_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR14_U_RND_NID68, REGION14_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR15_U_RND_NID68, 0x836900)
    FIELD(POR_MPU_M6_PRBAR15_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR15_U_RND_NID68, REGION15_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR15_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR15_U_RND_NID68, REGION15_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR15_U_RND_NID68, REGION15_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR15_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR15_U_RND_NID68, 0x836908)
    FIELD(POR_MPU_M6_PRLAR15_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR15_U_RND_NID68, REGION15_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR15_U_RND_NID68, REGION15_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR16_U_RND_NID68, 0x836910)
    FIELD(POR_MPU_M6_PRBAR16_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR16_U_RND_NID68, REGION16_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR16_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR16_U_RND_NID68, REGION16_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR16_U_RND_NID68, REGION16_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR16_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR16_U_RND_NID68, 0x836918)
    FIELD(POR_MPU_M6_PRLAR16_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR16_U_RND_NID68, REGION16_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR16_U_RND_NID68, REGION16_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR17_U_RND_NID68, 0x836920)
    FIELD(POR_MPU_M6_PRBAR17_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR17_U_RND_NID68, REGION17_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR17_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR17_U_RND_NID68, REGION17_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR17_U_RND_NID68, REGION17_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR17_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR17_U_RND_NID68, 0x836928)
    FIELD(POR_MPU_M6_PRLAR17_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR17_U_RND_NID68, REGION17_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR17_U_RND_NID68, REGION17_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR18_U_RND_NID68, 0x836930)
    FIELD(POR_MPU_M6_PRBAR18_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR18_U_RND_NID68, REGION18_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR18_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR18_U_RND_NID68, REGION18_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR18_U_RND_NID68, REGION18_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR18_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR18_U_RND_NID68, 0x836938)
    FIELD(POR_MPU_M6_PRLAR18_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR18_U_RND_NID68, REGION18_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR18_U_RND_NID68, REGION18_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR19_U_RND_NID68, 0x836940)
    FIELD(POR_MPU_M6_PRBAR19_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR19_U_RND_NID68, REGION19_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR19_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR19_U_RND_NID68, REGION19_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR19_U_RND_NID68, REGION19_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR19_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR19_U_RND_NID68, 0x836948)
    FIELD(POR_MPU_M6_PRLAR19_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR19_U_RND_NID68, REGION19_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR19_U_RND_NID68, REGION19_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR20_U_RND_NID68, 0x836950)
    FIELD(POR_MPU_M6_PRBAR20_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR20_U_RND_NID68, REGION20_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR20_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR20_U_RND_NID68, REGION20_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR20_U_RND_NID68, REGION20_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR20_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR20_U_RND_NID68, 0x836958)
    FIELD(POR_MPU_M6_PRLAR20_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR20_U_RND_NID68, REGION20_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR20_U_RND_NID68, REGION20_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR21_U_RND_NID68, 0x836960)
    FIELD(POR_MPU_M6_PRBAR21_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR21_U_RND_NID68, REGION21_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR21_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR21_U_RND_NID68, REGION21_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR21_U_RND_NID68, REGION21_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR21_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR21_U_RND_NID68, 0x836968)
    FIELD(POR_MPU_M6_PRLAR21_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR21_U_RND_NID68, REGION21_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR21_U_RND_NID68, REGION21_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR22_U_RND_NID68, 0x836970)
    FIELD(POR_MPU_M6_PRBAR22_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR22_U_RND_NID68, REGION22_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR22_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR22_U_RND_NID68, REGION22_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR22_U_RND_NID68, REGION22_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR22_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR22_U_RND_NID68, 0x836978)
    FIELD(POR_MPU_M6_PRLAR22_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR22_U_RND_NID68, REGION22_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR22_U_RND_NID68, REGION22_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR23_U_RND_NID68, 0x836980)
    FIELD(POR_MPU_M6_PRBAR23_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR23_U_RND_NID68, REGION23_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR23_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR23_U_RND_NID68, REGION23_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR23_U_RND_NID68, REGION23_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR23_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR23_U_RND_NID68, 0x836988)
    FIELD(POR_MPU_M6_PRLAR23_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR23_U_RND_NID68, REGION23_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR23_U_RND_NID68, REGION23_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR24_U_RND_NID68, 0x836990)
    FIELD(POR_MPU_M6_PRBAR24_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR24_U_RND_NID68, REGION24_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR24_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR24_U_RND_NID68, REGION24_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR24_U_RND_NID68, REGION24_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR24_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR24_U_RND_NID68, 0x836998)
    FIELD(POR_MPU_M6_PRLAR24_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR24_U_RND_NID68, REGION24_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR24_U_RND_NID68, REGION24_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR25_U_RND_NID68, 0x8369a0)
    FIELD(POR_MPU_M6_PRBAR25_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR25_U_RND_NID68, REGION25_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR25_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR25_U_RND_NID68, REGION25_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR25_U_RND_NID68, REGION25_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR25_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR25_U_RND_NID68, 0x8369a8)
    FIELD(POR_MPU_M6_PRLAR25_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR25_U_RND_NID68, REGION25_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR25_U_RND_NID68, REGION25_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR26_U_RND_NID68, 0x8369b0)
    FIELD(POR_MPU_M6_PRBAR26_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR26_U_RND_NID68, REGION26_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR26_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR26_U_RND_NID68, REGION26_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR26_U_RND_NID68, REGION26_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR26_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR26_U_RND_NID68, 0x8369b8)
    FIELD(POR_MPU_M6_PRLAR26_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR26_U_RND_NID68, REGION26_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR26_U_RND_NID68, REGION26_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR27_U_RND_NID68, 0x8369c0)
    FIELD(POR_MPU_M6_PRBAR27_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR27_U_RND_NID68, REGION27_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR27_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR27_U_RND_NID68, REGION27_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR27_U_RND_NID68, REGION27_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR27_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR27_U_RND_NID68, 0x8369c8)
    FIELD(POR_MPU_M6_PRLAR27_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR27_U_RND_NID68, REGION27_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR27_U_RND_NID68, REGION27_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR28_U_RND_NID68, 0x8369d0)
    FIELD(POR_MPU_M6_PRBAR28_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR28_U_RND_NID68, REGION28_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR28_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR28_U_RND_NID68, REGION28_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR28_U_RND_NID68, REGION28_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR28_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR28_U_RND_NID68, 0x8369d8)
    FIELD(POR_MPU_M6_PRLAR28_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR28_U_RND_NID68, REGION28_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR28_U_RND_NID68, REGION28_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR29_U_RND_NID68, 0x8369e0)
    FIELD(POR_MPU_M6_PRBAR29_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR29_U_RND_NID68, REGION29_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR29_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR29_U_RND_NID68, REGION29_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR29_U_RND_NID68, REGION29_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR29_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR29_U_RND_NID68, 0x8369e8)
    FIELD(POR_MPU_M6_PRLAR29_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR29_U_RND_NID68, REGION29_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR29_U_RND_NID68, REGION29_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR30_U_RND_NID68, 0x8369f0)
    FIELD(POR_MPU_M6_PRBAR30_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR30_U_RND_NID68, REGION30_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR30_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR30_U_RND_NID68, REGION30_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR30_U_RND_NID68, REGION30_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR30_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR30_U_RND_NID68, 0x8369f8)
    FIELD(POR_MPU_M6_PRLAR30_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR30_U_RND_NID68, REGION30_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR30_U_RND_NID68, REGION30_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR31_U_RND_NID68, 0x836a00)
    FIELD(POR_MPU_M6_PRBAR31_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR31_U_RND_NID68, REGION31_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR31_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR31_U_RND_NID68, REGION31_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR31_U_RND_NID68, REGION31_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR31_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR31_U_RND_NID68, 0x836a08)
    FIELD(POR_MPU_M6_PRLAR31_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR31_U_RND_NID68, REGION31_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR31_U_RND_NID68, REGION31_EN, 0, 1)
REG32(POR_MPU_M7_CTL_U_RND_NID68, 0x836c00)
    FIELD(POR_MPU_M7_CTL_U_RND_NID68, M7_EN, 2, 1)
    FIELD(POR_MPU_M7_CTL_U_RND_NID68, M7_ACTION, 0, 2)
REG32(POR_MPU_M7_PRBAR0_U_RND_NID68, 0x836c10)
    FIELD(POR_MPU_M7_PRBAR0_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR0_U_RND_NID68, REGION0_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR0_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR0_U_RND_NID68, REGION0_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR0_U_RND_NID68, REGION0_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR0_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR0_U_RND_NID68, 0x836c18)
    FIELD(POR_MPU_M7_PRLAR0_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR0_U_RND_NID68, REGION0_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR0_U_RND_NID68, REGION0_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR1_U_RND_NID68, 0x836c20)
    FIELD(POR_MPU_M7_PRBAR1_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR1_U_RND_NID68, REGION1_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR1_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR1_U_RND_NID68, REGION1_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR1_U_RND_NID68, REGION1_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR1_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR1_U_RND_NID68, 0x836c28)
    FIELD(POR_MPU_M7_PRLAR1_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR1_U_RND_NID68, REGION1_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR1_U_RND_NID68, REGION1_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR2_U_RND_NID68, 0x836c30)
    FIELD(POR_MPU_M7_PRBAR2_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR2_U_RND_NID68, REGION2_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR2_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR2_U_RND_NID68, REGION2_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR2_U_RND_NID68, REGION2_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR2_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR2_U_RND_NID68, 0x836c38)
    FIELD(POR_MPU_M7_PRLAR2_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR2_U_RND_NID68, REGION2_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR2_U_RND_NID68, REGION2_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR3_U_RND_NID68, 0x836c40)
    FIELD(POR_MPU_M7_PRBAR3_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR3_U_RND_NID68, REGION3_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR3_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR3_U_RND_NID68, REGION3_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR3_U_RND_NID68, REGION3_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR3_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR3_U_RND_NID68, 0x836c48)
    FIELD(POR_MPU_M7_PRLAR3_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR3_U_RND_NID68, REGION3_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR3_U_RND_NID68, REGION3_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR4_U_RND_NID68, 0x836c50)
    FIELD(POR_MPU_M7_PRBAR4_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR4_U_RND_NID68, REGION4_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR4_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR4_U_RND_NID68, REGION4_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR4_U_RND_NID68, REGION4_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR4_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR4_U_RND_NID68, 0x836c58)
    FIELD(POR_MPU_M7_PRLAR4_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR4_U_RND_NID68, REGION4_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR4_U_RND_NID68, REGION4_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR5_U_RND_NID68, 0x836c60)
    FIELD(POR_MPU_M7_PRBAR5_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR5_U_RND_NID68, REGION5_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR5_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR5_U_RND_NID68, REGION5_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR5_U_RND_NID68, REGION5_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR5_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR5_U_RND_NID68, 0x836c68)
    FIELD(POR_MPU_M7_PRLAR5_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR5_U_RND_NID68, REGION5_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR5_U_RND_NID68, REGION5_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR6_U_RND_NID68, 0x836c70)
    FIELD(POR_MPU_M7_PRBAR6_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR6_U_RND_NID68, REGION6_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR6_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR6_U_RND_NID68, REGION6_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR6_U_RND_NID68, REGION6_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR6_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR6_U_RND_NID68, 0x836c78)
    FIELD(POR_MPU_M7_PRLAR6_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR6_U_RND_NID68, REGION6_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR6_U_RND_NID68, REGION6_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR7_U_RND_NID68, 0x836c80)
    FIELD(POR_MPU_M7_PRBAR7_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR7_U_RND_NID68, REGION7_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR7_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR7_U_RND_NID68, REGION7_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR7_U_RND_NID68, REGION7_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR7_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR7_U_RND_NID68, 0x836c88)
    FIELD(POR_MPU_M7_PRLAR7_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR7_U_RND_NID68, REGION7_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR7_U_RND_NID68, REGION7_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR8_U_RND_NID68, 0x836c90)
    FIELD(POR_MPU_M7_PRBAR8_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR8_U_RND_NID68, REGION8_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR8_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR8_U_RND_NID68, REGION8_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR8_U_RND_NID68, REGION8_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR8_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR8_U_RND_NID68, 0x836c98)
    FIELD(POR_MPU_M7_PRLAR8_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR8_U_RND_NID68, REGION8_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR8_U_RND_NID68, REGION8_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR9_U_RND_NID68, 0x836ca0)
    FIELD(POR_MPU_M7_PRBAR9_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR9_U_RND_NID68, REGION9_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR9_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR9_U_RND_NID68, REGION9_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR9_U_RND_NID68, REGION9_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR9_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR9_U_RND_NID68, 0x836ca8)
    FIELD(POR_MPU_M7_PRLAR9_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR9_U_RND_NID68, REGION9_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR9_U_RND_NID68, REGION9_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR10_U_RND_NID68, 0x836cb0)
    FIELD(POR_MPU_M7_PRBAR10_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR10_U_RND_NID68, REGION10_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR10_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR10_U_RND_NID68, REGION10_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR10_U_RND_NID68, REGION10_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR10_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR10_U_RND_NID68, 0x836cb8)
    FIELD(POR_MPU_M7_PRLAR10_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR10_U_RND_NID68, REGION10_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR10_U_RND_NID68, REGION10_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR11_U_RND_NID68, 0x836cc0)
    FIELD(POR_MPU_M7_PRBAR11_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR11_U_RND_NID68, REGION11_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR11_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR11_U_RND_NID68, REGION11_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR11_U_RND_NID68, REGION11_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR11_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR11_U_RND_NID68, 0x836cc8)
    FIELD(POR_MPU_M7_PRLAR11_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR11_U_RND_NID68, REGION11_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR11_U_RND_NID68, REGION11_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR12_U_RND_NID68, 0x836cd0)
    FIELD(POR_MPU_M7_PRBAR12_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR12_U_RND_NID68, REGION12_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR12_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR12_U_RND_NID68, REGION12_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR12_U_RND_NID68, REGION12_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR12_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR12_U_RND_NID68, 0x836cd8)
    FIELD(POR_MPU_M7_PRLAR12_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR12_U_RND_NID68, REGION12_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR12_U_RND_NID68, REGION12_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR13_U_RND_NID68, 0x836ce0)
    FIELD(POR_MPU_M7_PRBAR13_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR13_U_RND_NID68, REGION13_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR13_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR13_U_RND_NID68, REGION13_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR13_U_RND_NID68, REGION13_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR13_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR13_U_RND_NID68, 0x836ce8)
    FIELD(POR_MPU_M7_PRLAR13_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR13_U_RND_NID68, REGION13_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR13_U_RND_NID68, REGION13_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR14_U_RND_NID68, 0x836cf0)
    FIELD(POR_MPU_M7_PRBAR14_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR14_U_RND_NID68, REGION14_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR14_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR14_U_RND_NID68, REGION14_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR14_U_RND_NID68, REGION14_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR14_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR14_U_RND_NID68, 0x836cf8)
    FIELD(POR_MPU_M7_PRLAR14_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR14_U_RND_NID68, REGION14_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR14_U_RND_NID68, REGION14_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR15_U_RND_NID68, 0x836d00)
    FIELD(POR_MPU_M7_PRBAR15_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR15_U_RND_NID68, REGION15_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR15_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR15_U_RND_NID68, REGION15_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR15_U_RND_NID68, REGION15_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR15_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR15_U_RND_NID68, 0x836d08)
    FIELD(POR_MPU_M7_PRLAR15_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR15_U_RND_NID68, REGION15_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR15_U_RND_NID68, REGION15_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR16_U_RND_NID68, 0x836d10)
    FIELD(POR_MPU_M7_PRBAR16_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR16_U_RND_NID68, REGION16_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR16_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR16_U_RND_NID68, REGION16_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR16_U_RND_NID68, REGION16_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR16_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR16_U_RND_NID68, 0x836d18)
    FIELD(POR_MPU_M7_PRLAR16_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR16_U_RND_NID68, REGION16_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR16_U_RND_NID68, REGION16_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR17_U_RND_NID68, 0x836d20)
    FIELD(POR_MPU_M7_PRBAR17_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR17_U_RND_NID68, REGION17_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR17_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR17_U_RND_NID68, REGION17_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR17_U_RND_NID68, REGION17_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR17_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR17_U_RND_NID68, 0x836d28)
    FIELD(POR_MPU_M7_PRLAR17_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR17_U_RND_NID68, REGION17_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR17_U_RND_NID68, REGION17_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR18_U_RND_NID68, 0x836d30)
    FIELD(POR_MPU_M7_PRBAR18_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR18_U_RND_NID68, REGION18_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR18_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR18_U_RND_NID68, REGION18_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR18_U_RND_NID68, REGION18_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR18_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR18_U_RND_NID68, 0x836d38)
    FIELD(POR_MPU_M7_PRLAR18_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR18_U_RND_NID68, REGION18_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR18_U_RND_NID68, REGION18_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR19_U_RND_NID68, 0x836d40)
    FIELD(POR_MPU_M7_PRBAR19_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR19_U_RND_NID68, REGION19_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR19_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR19_U_RND_NID68, REGION19_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR19_U_RND_NID68, REGION19_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR19_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR19_U_RND_NID68, 0x836d48)
    FIELD(POR_MPU_M7_PRLAR19_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR19_U_RND_NID68, REGION19_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR19_U_RND_NID68, REGION19_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR20_U_RND_NID68, 0x836d50)
    FIELD(POR_MPU_M7_PRBAR20_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR20_U_RND_NID68, REGION20_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR20_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR20_U_RND_NID68, REGION20_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR20_U_RND_NID68, REGION20_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR20_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR20_U_RND_NID68, 0x836d58)
    FIELD(POR_MPU_M7_PRLAR20_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR20_U_RND_NID68, REGION20_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR20_U_RND_NID68, REGION20_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR21_U_RND_NID68, 0x836d60)
    FIELD(POR_MPU_M7_PRBAR21_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR21_U_RND_NID68, REGION21_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR21_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR21_U_RND_NID68, REGION21_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR21_U_RND_NID68, REGION21_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR21_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR21_U_RND_NID68, 0x836d68)
    FIELD(POR_MPU_M7_PRLAR21_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR21_U_RND_NID68, REGION21_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR21_U_RND_NID68, REGION21_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR22_U_RND_NID68, 0x836d70)
    FIELD(POR_MPU_M7_PRBAR22_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR22_U_RND_NID68, REGION22_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR22_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR22_U_RND_NID68, REGION22_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR22_U_RND_NID68, REGION22_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR22_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR22_U_RND_NID68, 0x836d78)
    FIELD(POR_MPU_M7_PRLAR22_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR22_U_RND_NID68, REGION22_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR22_U_RND_NID68, REGION22_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR23_U_RND_NID68, 0x836d80)
    FIELD(POR_MPU_M7_PRBAR23_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR23_U_RND_NID68, REGION23_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR23_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR23_U_RND_NID68, REGION23_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR23_U_RND_NID68, REGION23_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR23_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR23_U_RND_NID68, 0x836d88)
    FIELD(POR_MPU_M7_PRLAR23_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR23_U_RND_NID68, REGION23_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR23_U_RND_NID68, REGION23_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR24_U_RND_NID68, 0x836d90)
    FIELD(POR_MPU_M7_PRBAR24_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR24_U_RND_NID68, REGION24_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR24_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR24_U_RND_NID68, REGION24_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR24_U_RND_NID68, REGION24_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR24_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR24_U_RND_NID68, 0x836d98)
    FIELD(POR_MPU_M7_PRLAR24_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR24_U_RND_NID68, REGION24_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR24_U_RND_NID68, REGION24_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR25_U_RND_NID68, 0x836da0)
    FIELD(POR_MPU_M7_PRBAR25_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR25_U_RND_NID68, REGION25_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR25_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR25_U_RND_NID68, REGION25_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR25_U_RND_NID68, REGION25_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR25_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR25_U_RND_NID68, 0x836da8)
    FIELD(POR_MPU_M7_PRLAR25_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR25_U_RND_NID68, REGION25_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR25_U_RND_NID68, REGION25_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR26_U_RND_NID68, 0x836db0)
    FIELD(POR_MPU_M7_PRBAR26_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR26_U_RND_NID68, REGION26_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR26_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR26_U_RND_NID68, REGION26_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR26_U_RND_NID68, REGION26_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR26_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR26_U_RND_NID68, 0x836db8)
    FIELD(POR_MPU_M7_PRLAR26_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR26_U_RND_NID68, REGION26_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR26_U_RND_NID68, REGION26_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR27_U_RND_NID68, 0x836dc0)
    FIELD(POR_MPU_M7_PRBAR27_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR27_U_RND_NID68, REGION27_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR27_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR27_U_RND_NID68, REGION27_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR27_U_RND_NID68, REGION27_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR27_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR27_U_RND_NID68, 0x836dc8)
    FIELD(POR_MPU_M7_PRLAR27_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR27_U_RND_NID68, REGION27_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR27_U_RND_NID68, REGION27_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR28_U_RND_NID68, 0x836dd0)
    FIELD(POR_MPU_M7_PRBAR28_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR28_U_RND_NID68, REGION28_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR28_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR28_U_RND_NID68, REGION28_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR28_U_RND_NID68, REGION28_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR28_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR28_U_RND_NID68, 0x836dd8)
    FIELD(POR_MPU_M7_PRLAR28_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR28_U_RND_NID68, REGION28_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR28_U_RND_NID68, REGION28_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR29_U_RND_NID68, 0x836de0)
    FIELD(POR_MPU_M7_PRBAR29_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR29_U_RND_NID68, REGION29_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR29_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR29_U_RND_NID68, REGION29_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR29_U_RND_NID68, REGION29_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR29_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR29_U_RND_NID68, 0x836de8)
    FIELD(POR_MPU_M7_PRLAR29_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR29_U_RND_NID68, REGION29_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR29_U_RND_NID68, REGION29_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR30_U_RND_NID68, 0x836df0)
    FIELD(POR_MPU_M7_PRBAR30_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR30_U_RND_NID68, REGION30_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR30_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR30_U_RND_NID68, REGION30_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR30_U_RND_NID68, REGION30_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR30_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR30_U_RND_NID68, 0x836df8)
    FIELD(POR_MPU_M7_PRLAR30_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR30_U_RND_NID68, REGION30_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR30_U_RND_NID68, REGION30_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR31_U_RND_NID68, 0x836e00)
    FIELD(POR_MPU_M7_PRBAR31_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR31_U_RND_NID68, REGION31_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR31_U_RND_NID68, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR31_U_RND_NID68, REGION31_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR31_U_RND_NID68, REGION31_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR31_U_RND_NID68, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR31_U_RND_NID68, 0x836e08)
    FIELD(POR_MPU_M7_PRLAR31_U_RND_NID68, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR31_U_RND_NID68, REGION31_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR31_U_RND_NID68, REGION31_EN, 0, 1)
REG32(POR_MPU_NODE_INFO_U_SMXP_1_0, 0x83c000)
    FIELD(POR_MPU_NODE_INFO_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_NODE_INFO_U_SMXP_1_0, LOGICAL_ID, 32, 16)
    FIELD(POR_MPU_NODE_INFO_U_SMXP_1_0, NODE_ID, 16, 16)
    FIELD(POR_MPU_NODE_INFO_U_SMXP_1_0, NODE_TYPE, 0, 16)
REG32(POR_MPU_CHILD_INFO_U_SMXP_1_0, 0x83c080)
    FIELD(POR_MPU_CHILD_INFO_U_SMXP_1_0, RESERVED_32, 32, 32)
    FIELD(POR_MPU_CHILD_INFO_U_SMXP_1_0, CHILD_PTR_OFFSET, 16, 16)
    FIELD(POR_MPU_CHILD_INFO_U_SMXP_1_0, CHILD_COUNT, 0, 16)
REG32(POR_MPU_UNIT_INFO_U_SMXP_1_0, 0x83c900)
    FIELD(POR_MPU_UNIT_INFO_U_SMXP_1_0, RESERVED_16, 16, 48)
    FIELD(POR_MPU_UNIT_INFO_U_SMXP_1_0, MASTER_7_PRESENT, 15, 1)
    FIELD(POR_MPU_UNIT_INFO_U_SMXP_1_0, MASTER_6_PRESENT, 14, 1)
    FIELD(POR_MPU_UNIT_INFO_U_SMXP_1_0, MASTER_5_PRESENT, 13, 1)
    FIELD(POR_MPU_UNIT_INFO_U_SMXP_1_0, MASTER_4_PRESENT, 12, 1)
    FIELD(POR_MPU_UNIT_INFO_U_SMXP_1_0, MASTER_3_PRESENT, 11, 1)
    FIELD(POR_MPU_UNIT_INFO_U_SMXP_1_0, MASTER_2_PRESENT, 10, 1)
    FIELD(POR_MPU_UNIT_INFO_U_SMXP_1_0, MASTER_1_PRESENT, 9, 1)
    FIELD(POR_MPU_UNIT_INFO_U_SMXP_1_0, MASTER_0_PRESENT, 8, 1)
    FIELD(POR_MPU_UNIT_INFO_U_SMXP_1_0, NUM_PROG_REGION, 0, 8)
REG32(POR_MPU_M0_CTL_U_SMXP_1_0, 0x83d000)
    FIELD(POR_MPU_M0_CTL_U_SMXP_1_0, M0_EN, 2, 1)
    FIELD(POR_MPU_M0_CTL_U_SMXP_1_0, M0_ACTION, 0, 2)
REG32(POR_MPU_M0_PRBAR0_U_SMXP_1_0, 0x83d010)
    FIELD(POR_MPU_M0_PRBAR0_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR0_U_SMXP_1_0, REGION0_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR0_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR0_U_SMXP_1_0, REGION0_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR0_U_SMXP_1_0, REGION0_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR0_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR0_U_SMXP_1_0, 0x83d018)
    FIELD(POR_MPU_M0_PRLAR0_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR0_U_SMXP_1_0, REGION0_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR0_U_SMXP_1_0, REGION0_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR1_U_SMXP_1_0, 0x83d020)
    FIELD(POR_MPU_M0_PRBAR1_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR1_U_SMXP_1_0, REGION1_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR1_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR1_U_SMXP_1_0, REGION1_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR1_U_SMXP_1_0, REGION1_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR1_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR1_U_SMXP_1_0, 0x83d028)
    FIELD(POR_MPU_M0_PRLAR1_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR1_U_SMXP_1_0, REGION1_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR1_U_SMXP_1_0, REGION1_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR2_U_SMXP_1_0, 0x83d030)
    FIELD(POR_MPU_M0_PRBAR2_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR2_U_SMXP_1_0, REGION2_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR2_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR2_U_SMXP_1_0, REGION2_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR2_U_SMXP_1_0, REGION2_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR2_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR2_U_SMXP_1_0, 0x83d038)
    FIELD(POR_MPU_M0_PRLAR2_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR2_U_SMXP_1_0, REGION2_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR2_U_SMXP_1_0, REGION2_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR3_U_SMXP_1_0, 0x83d040)
    FIELD(POR_MPU_M0_PRBAR3_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR3_U_SMXP_1_0, REGION3_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR3_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR3_U_SMXP_1_0, REGION3_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR3_U_SMXP_1_0, REGION3_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR3_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR3_U_SMXP_1_0, 0x83d048)
    FIELD(POR_MPU_M0_PRLAR3_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR3_U_SMXP_1_0, REGION3_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR3_U_SMXP_1_0, REGION3_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR4_U_SMXP_1_0, 0x83d050)
    FIELD(POR_MPU_M0_PRBAR4_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR4_U_SMXP_1_0, REGION4_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR4_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR4_U_SMXP_1_0, REGION4_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR4_U_SMXP_1_0, REGION4_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR4_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR4_U_SMXP_1_0, 0x83d058)
    FIELD(POR_MPU_M0_PRLAR4_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR4_U_SMXP_1_0, REGION4_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR4_U_SMXP_1_0, REGION4_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR5_U_SMXP_1_0, 0x83d060)
    FIELD(POR_MPU_M0_PRBAR5_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR5_U_SMXP_1_0, REGION5_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR5_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR5_U_SMXP_1_0, REGION5_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR5_U_SMXP_1_0, REGION5_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR5_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR5_U_SMXP_1_0, 0x83d068)
    FIELD(POR_MPU_M0_PRLAR5_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR5_U_SMXP_1_0, REGION5_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR5_U_SMXP_1_0, REGION5_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR6_U_SMXP_1_0, 0x83d070)
    FIELD(POR_MPU_M0_PRBAR6_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR6_U_SMXP_1_0, REGION6_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR6_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR6_U_SMXP_1_0, REGION6_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR6_U_SMXP_1_0, REGION6_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR6_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR6_U_SMXP_1_0, 0x83d078)
    FIELD(POR_MPU_M0_PRLAR6_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR6_U_SMXP_1_0, REGION6_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR6_U_SMXP_1_0, REGION6_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR7_U_SMXP_1_0, 0x83d080)
    FIELD(POR_MPU_M0_PRBAR7_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR7_U_SMXP_1_0, REGION7_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR7_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR7_U_SMXP_1_0, REGION7_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR7_U_SMXP_1_0, REGION7_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR7_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR7_U_SMXP_1_0, 0x83d088)
    FIELD(POR_MPU_M0_PRLAR7_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR7_U_SMXP_1_0, REGION7_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR7_U_SMXP_1_0, REGION7_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR8_U_SMXP_1_0, 0x83d090)
    FIELD(POR_MPU_M0_PRBAR8_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR8_U_SMXP_1_0, REGION8_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR8_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR8_U_SMXP_1_0, REGION8_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR8_U_SMXP_1_0, REGION8_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR8_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR8_U_SMXP_1_0, 0x83d098)
    FIELD(POR_MPU_M0_PRLAR8_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR8_U_SMXP_1_0, REGION8_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR8_U_SMXP_1_0, REGION8_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR9_U_SMXP_1_0, 0x83d0a0)
    FIELD(POR_MPU_M0_PRBAR9_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR9_U_SMXP_1_0, REGION9_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR9_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR9_U_SMXP_1_0, REGION9_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR9_U_SMXP_1_0, REGION9_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR9_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR9_U_SMXP_1_0, 0x83d0a8)
    FIELD(POR_MPU_M0_PRLAR9_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR9_U_SMXP_1_0, REGION9_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR9_U_SMXP_1_0, REGION9_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR10_U_SMXP_1_0, 0x83d0b0)
    FIELD(POR_MPU_M0_PRBAR10_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR10_U_SMXP_1_0, REGION10_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR10_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR10_U_SMXP_1_0, REGION10_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR10_U_SMXP_1_0, REGION10_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR10_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR10_U_SMXP_1_0, 0x83d0b8)
    FIELD(POR_MPU_M0_PRLAR10_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR10_U_SMXP_1_0, REGION10_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR10_U_SMXP_1_0, REGION10_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR11_U_SMXP_1_0, 0x83d0c0)
    FIELD(POR_MPU_M0_PRBAR11_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR11_U_SMXP_1_0, REGION11_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR11_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR11_U_SMXP_1_0, REGION11_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR11_U_SMXP_1_0, REGION11_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR11_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR11_U_SMXP_1_0, 0x83d0c8)
    FIELD(POR_MPU_M0_PRLAR11_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR11_U_SMXP_1_0, REGION11_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR11_U_SMXP_1_0, REGION11_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR12_U_SMXP_1_0, 0x83d0d0)
    FIELD(POR_MPU_M0_PRBAR12_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR12_U_SMXP_1_0, REGION12_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR12_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR12_U_SMXP_1_0, REGION12_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR12_U_SMXP_1_0, REGION12_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR12_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR12_U_SMXP_1_0, 0x83d0d8)
    FIELD(POR_MPU_M0_PRLAR12_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR12_U_SMXP_1_0, REGION12_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR12_U_SMXP_1_0, REGION12_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR13_U_SMXP_1_0, 0x83d0e0)
    FIELD(POR_MPU_M0_PRBAR13_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR13_U_SMXP_1_0, REGION13_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR13_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR13_U_SMXP_1_0, REGION13_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR13_U_SMXP_1_0, REGION13_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR13_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR13_U_SMXP_1_0, 0x83d0e8)
    FIELD(POR_MPU_M0_PRLAR13_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR13_U_SMXP_1_0, REGION13_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR13_U_SMXP_1_0, REGION13_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR14_U_SMXP_1_0, 0x83d0f0)
    FIELD(POR_MPU_M0_PRBAR14_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR14_U_SMXP_1_0, REGION14_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR14_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR14_U_SMXP_1_0, REGION14_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR14_U_SMXP_1_0, REGION14_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR14_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR14_U_SMXP_1_0, 0x83d0f8)
    FIELD(POR_MPU_M0_PRLAR14_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR14_U_SMXP_1_0, REGION14_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR14_U_SMXP_1_0, REGION14_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR15_U_SMXP_1_0, 0x83d100)
    FIELD(POR_MPU_M0_PRBAR15_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR15_U_SMXP_1_0, REGION15_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR15_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR15_U_SMXP_1_0, REGION15_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR15_U_SMXP_1_0, REGION15_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR15_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR15_U_SMXP_1_0, 0x83d108)
    FIELD(POR_MPU_M0_PRLAR15_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR15_U_SMXP_1_0, REGION15_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR15_U_SMXP_1_0, REGION15_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR16_U_SMXP_1_0, 0x83d110)
    FIELD(POR_MPU_M0_PRBAR16_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR16_U_SMXP_1_0, REGION16_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR16_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR16_U_SMXP_1_0, REGION16_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR16_U_SMXP_1_0, REGION16_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR16_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR16_U_SMXP_1_0, 0x83d118)
    FIELD(POR_MPU_M0_PRLAR16_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR16_U_SMXP_1_0, REGION16_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR16_U_SMXP_1_0, REGION16_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR17_U_SMXP_1_0, 0x83d120)
    FIELD(POR_MPU_M0_PRBAR17_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR17_U_SMXP_1_0, REGION17_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR17_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR17_U_SMXP_1_0, REGION17_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR17_U_SMXP_1_0, REGION17_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR17_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR17_U_SMXP_1_0, 0x83d128)
    FIELD(POR_MPU_M0_PRLAR17_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR17_U_SMXP_1_0, REGION17_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR17_U_SMXP_1_0, REGION17_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR18_U_SMXP_1_0, 0x83d130)
    FIELD(POR_MPU_M0_PRBAR18_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR18_U_SMXP_1_0, REGION18_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR18_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR18_U_SMXP_1_0, REGION18_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR18_U_SMXP_1_0, REGION18_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR18_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR18_U_SMXP_1_0, 0x83d138)
    FIELD(POR_MPU_M0_PRLAR18_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR18_U_SMXP_1_0, REGION18_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR18_U_SMXP_1_0, REGION18_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR19_U_SMXP_1_0, 0x83d140)
    FIELD(POR_MPU_M0_PRBAR19_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR19_U_SMXP_1_0, REGION19_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR19_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR19_U_SMXP_1_0, REGION19_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR19_U_SMXP_1_0, REGION19_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR19_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR19_U_SMXP_1_0, 0x83d148)
    FIELD(POR_MPU_M0_PRLAR19_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR19_U_SMXP_1_0, REGION19_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR19_U_SMXP_1_0, REGION19_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR20_U_SMXP_1_0, 0x83d150)
    FIELD(POR_MPU_M0_PRBAR20_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR20_U_SMXP_1_0, REGION20_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR20_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR20_U_SMXP_1_0, REGION20_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR20_U_SMXP_1_0, REGION20_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR20_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR20_U_SMXP_1_0, 0x83d158)
    FIELD(POR_MPU_M0_PRLAR20_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR20_U_SMXP_1_0, REGION20_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR20_U_SMXP_1_0, REGION20_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR21_U_SMXP_1_0, 0x83d160)
    FIELD(POR_MPU_M0_PRBAR21_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR21_U_SMXP_1_0, REGION21_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR21_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR21_U_SMXP_1_0, REGION21_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR21_U_SMXP_1_0, REGION21_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR21_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR21_U_SMXP_1_0, 0x83d168)
    FIELD(POR_MPU_M0_PRLAR21_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR21_U_SMXP_1_0, REGION21_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR21_U_SMXP_1_0, REGION21_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR22_U_SMXP_1_0, 0x83d170)
    FIELD(POR_MPU_M0_PRBAR22_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR22_U_SMXP_1_0, REGION22_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR22_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR22_U_SMXP_1_0, REGION22_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR22_U_SMXP_1_0, REGION22_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR22_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR22_U_SMXP_1_0, 0x83d178)
    FIELD(POR_MPU_M0_PRLAR22_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR22_U_SMXP_1_0, REGION22_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR22_U_SMXP_1_0, REGION22_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR23_U_SMXP_1_0, 0x83d180)
    FIELD(POR_MPU_M0_PRBAR23_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR23_U_SMXP_1_0, REGION23_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR23_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR23_U_SMXP_1_0, REGION23_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR23_U_SMXP_1_0, REGION23_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR23_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR23_U_SMXP_1_0, 0x83d188)
    FIELD(POR_MPU_M0_PRLAR23_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR23_U_SMXP_1_0, REGION23_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR23_U_SMXP_1_0, REGION23_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR24_U_SMXP_1_0, 0x83d190)
    FIELD(POR_MPU_M0_PRBAR24_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR24_U_SMXP_1_0, REGION24_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR24_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR24_U_SMXP_1_0, REGION24_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR24_U_SMXP_1_0, REGION24_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR24_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR24_U_SMXP_1_0, 0x83d198)
    FIELD(POR_MPU_M0_PRLAR24_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR24_U_SMXP_1_0, REGION24_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR24_U_SMXP_1_0, REGION24_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR25_U_SMXP_1_0, 0x83d1a0)
    FIELD(POR_MPU_M0_PRBAR25_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR25_U_SMXP_1_0, REGION25_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR25_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR25_U_SMXP_1_0, REGION25_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR25_U_SMXP_1_0, REGION25_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR25_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR25_U_SMXP_1_0, 0x83d1a8)
    FIELD(POR_MPU_M0_PRLAR25_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR25_U_SMXP_1_0, REGION25_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR25_U_SMXP_1_0, REGION25_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR26_U_SMXP_1_0, 0x83d1b0)
    FIELD(POR_MPU_M0_PRBAR26_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR26_U_SMXP_1_0, REGION26_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR26_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR26_U_SMXP_1_0, REGION26_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR26_U_SMXP_1_0, REGION26_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR26_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR26_U_SMXP_1_0, 0x83d1b8)
    FIELD(POR_MPU_M0_PRLAR26_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR26_U_SMXP_1_0, REGION26_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR26_U_SMXP_1_0, REGION26_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR27_U_SMXP_1_0, 0x83d1c0)
    FIELD(POR_MPU_M0_PRBAR27_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR27_U_SMXP_1_0, REGION27_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR27_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR27_U_SMXP_1_0, REGION27_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR27_U_SMXP_1_0, REGION27_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR27_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR27_U_SMXP_1_0, 0x83d1c8)
    FIELD(POR_MPU_M0_PRLAR27_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR27_U_SMXP_1_0, REGION27_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR27_U_SMXP_1_0, REGION27_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR28_U_SMXP_1_0, 0x83d1d0)
    FIELD(POR_MPU_M0_PRBAR28_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR28_U_SMXP_1_0, REGION28_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR28_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR28_U_SMXP_1_0, REGION28_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR28_U_SMXP_1_0, REGION28_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR28_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR28_U_SMXP_1_0, 0x83d1d8)
    FIELD(POR_MPU_M0_PRLAR28_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR28_U_SMXP_1_0, REGION28_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR28_U_SMXP_1_0, REGION28_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR29_U_SMXP_1_0, 0x83d1e0)
    FIELD(POR_MPU_M0_PRBAR29_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR29_U_SMXP_1_0, REGION29_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR29_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR29_U_SMXP_1_0, REGION29_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR29_U_SMXP_1_0, REGION29_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR29_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR29_U_SMXP_1_0, 0x83d1e8)
    FIELD(POR_MPU_M0_PRLAR29_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR29_U_SMXP_1_0, REGION29_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR29_U_SMXP_1_0, REGION29_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR30_U_SMXP_1_0, 0x83d1f0)
    FIELD(POR_MPU_M0_PRBAR30_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR30_U_SMXP_1_0, REGION30_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR30_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR30_U_SMXP_1_0, REGION30_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR30_U_SMXP_1_0, REGION30_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR30_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR30_U_SMXP_1_0, 0x83d1f8)
    FIELD(POR_MPU_M0_PRLAR30_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR30_U_SMXP_1_0, REGION30_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR30_U_SMXP_1_0, REGION30_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR31_U_SMXP_1_0, 0x83d200)
    FIELD(POR_MPU_M0_PRBAR31_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR31_U_SMXP_1_0, REGION31_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR31_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR31_U_SMXP_1_0, REGION31_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR31_U_SMXP_1_0, REGION31_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR31_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR31_U_SMXP_1_0, 0x83d208)
    FIELD(POR_MPU_M0_PRLAR31_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR31_U_SMXP_1_0, REGION31_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR31_U_SMXP_1_0, REGION31_EN, 0, 1)
REG32(POR_MPU_M1_CTL_U_SMXP_1_0, 0x83d400)
    FIELD(POR_MPU_M1_CTL_U_SMXP_1_0, M1_EN, 2, 1)
    FIELD(POR_MPU_M1_CTL_U_SMXP_1_0, M1_ACTION, 0, 2)
REG32(POR_MPU_M1_PRBAR0_U_SMXP_1_0, 0x83d410)
    FIELD(POR_MPU_M1_PRBAR0_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR0_U_SMXP_1_0, REGION0_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR0_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR0_U_SMXP_1_0, REGION0_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR0_U_SMXP_1_0, REGION0_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR0_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR0_U_SMXP_1_0, 0x83d418)
    FIELD(POR_MPU_M1_PRLAR0_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR0_U_SMXP_1_0, REGION0_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR0_U_SMXP_1_0, REGION0_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR1_U_SMXP_1_0, 0x83d420)
    FIELD(POR_MPU_M1_PRBAR1_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR1_U_SMXP_1_0, REGION1_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR1_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR1_U_SMXP_1_0, REGION1_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR1_U_SMXP_1_0, REGION1_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR1_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR1_U_SMXP_1_0, 0x83d428)
    FIELD(POR_MPU_M1_PRLAR1_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR1_U_SMXP_1_0, REGION1_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR1_U_SMXP_1_0, REGION1_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR2_U_SMXP_1_0, 0x83d430)
    FIELD(POR_MPU_M1_PRBAR2_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR2_U_SMXP_1_0, REGION2_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR2_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR2_U_SMXP_1_0, REGION2_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR2_U_SMXP_1_0, REGION2_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR2_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR2_U_SMXP_1_0, 0x83d438)
    FIELD(POR_MPU_M1_PRLAR2_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR2_U_SMXP_1_0, REGION2_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR2_U_SMXP_1_0, REGION2_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR3_U_SMXP_1_0, 0x83d440)
    FIELD(POR_MPU_M1_PRBAR3_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR3_U_SMXP_1_0, REGION3_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR3_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR3_U_SMXP_1_0, REGION3_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR3_U_SMXP_1_0, REGION3_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR3_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR3_U_SMXP_1_0, 0x83d448)
    FIELD(POR_MPU_M1_PRLAR3_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR3_U_SMXP_1_0, REGION3_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR3_U_SMXP_1_0, REGION3_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR4_U_SMXP_1_0, 0x83d450)
    FIELD(POR_MPU_M1_PRBAR4_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR4_U_SMXP_1_0, REGION4_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR4_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR4_U_SMXP_1_0, REGION4_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR4_U_SMXP_1_0, REGION4_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR4_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR4_U_SMXP_1_0, 0x83d458)
    FIELD(POR_MPU_M1_PRLAR4_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR4_U_SMXP_1_0, REGION4_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR4_U_SMXP_1_0, REGION4_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR5_U_SMXP_1_0, 0x83d460)
    FIELD(POR_MPU_M1_PRBAR5_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR5_U_SMXP_1_0, REGION5_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR5_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR5_U_SMXP_1_0, REGION5_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR5_U_SMXP_1_0, REGION5_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR5_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR5_U_SMXP_1_0, 0x83d468)
    FIELD(POR_MPU_M1_PRLAR5_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR5_U_SMXP_1_0, REGION5_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR5_U_SMXP_1_0, REGION5_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR6_U_SMXP_1_0, 0x83d470)
    FIELD(POR_MPU_M1_PRBAR6_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR6_U_SMXP_1_0, REGION6_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR6_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR6_U_SMXP_1_0, REGION6_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR6_U_SMXP_1_0, REGION6_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR6_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR6_U_SMXP_1_0, 0x83d478)
    FIELD(POR_MPU_M1_PRLAR6_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR6_U_SMXP_1_0, REGION6_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR6_U_SMXP_1_0, REGION6_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR7_U_SMXP_1_0, 0x83d480)
    FIELD(POR_MPU_M1_PRBAR7_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR7_U_SMXP_1_0, REGION7_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR7_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR7_U_SMXP_1_0, REGION7_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR7_U_SMXP_1_0, REGION7_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR7_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR7_U_SMXP_1_0, 0x83d488)
    FIELD(POR_MPU_M1_PRLAR7_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR7_U_SMXP_1_0, REGION7_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR7_U_SMXP_1_0, REGION7_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR8_U_SMXP_1_0, 0x83d490)
    FIELD(POR_MPU_M1_PRBAR8_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR8_U_SMXP_1_0, REGION8_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR8_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR8_U_SMXP_1_0, REGION8_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR8_U_SMXP_1_0, REGION8_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR8_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR8_U_SMXP_1_0, 0x83d498)
    FIELD(POR_MPU_M1_PRLAR8_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR8_U_SMXP_1_0, REGION8_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR8_U_SMXP_1_0, REGION8_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR9_U_SMXP_1_0, 0x83d4a0)
    FIELD(POR_MPU_M1_PRBAR9_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR9_U_SMXP_1_0, REGION9_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR9_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR9_U_SMXP_1_0, REGION9_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR9_U_SMXP_1_0, REGION9_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR9_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR9_U_SMXP_1_0, 0x83d4a8)
    FIELD(POR_MPU_M1_PRLAR9_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR9_U_SMXP_1_0, REGION9_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR9_U_SMXP_1_0, REGION9_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR10_U_SMXP_1_0, 0x83d4b0)
    FIELD(POR_MPU_M1_PRBAR10_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR10_U_SMXP_1_0, REGION10_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR10_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR10_U_SMXP_1_0, REGION10_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR10_U_SMXP_1_0, REGION10_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR10_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR10_U_SMXP_1_0, 0x83d4b8)
    FIELD(POR_MPU_M1_PRLAR10_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR10_U_SMXP_1_0, REGION10_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR10_U_SMXP_1_0, REGION10_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR11_U_SMXP_1_0, 0x83d4c0)
    FIELD(POR_MPU_M1_PRBAR11_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR11_U_SMXP_1_0, REGION11_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR11_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR11_U_SMXP_1_0, REGION11_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR11_U_SMXP_1_0, REGION11_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR11_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR11_U_SMXP_1_0, 0x83d4c8)
    FIELD(POR_MPU_M1_PRLAR11_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR11_U_SMXP_1_0, REGION11_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR11_U_SMXP_1_0, REGION11_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR12_U_SMXP_1_0, 0x83d4d0)
    FIELD(POR_MPU_M1_PRBAR12_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR12_U_SMXP_1_0, REGION12_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR12_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR12_U_SMXP_1_0, REGION12_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR12_U_SMXP_1_0, REGION12_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR12_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR12_U_SMXP_1_0, 0x83d4d8)
    FIELD(POR_MPU_M1_PRLAR12_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR12_U_SMXP_1_0, REGION12_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR12_U_SMXP_1_0, REGION12_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR13_U_SMXP_1_0, 0x83d4e0)
    FIELD(POR_MPU_M1_PRBAR13_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR13_U_SMXP_1_0, REGION13_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR13_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR13_U_SMXP_1_0, REGION13_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR13_U_SMXP_1_0, REGION13_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR13_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR13_U_SMXP_1_0, 0x83d4e8)
    FIELD(POR_MPU_M1_PRLAR13_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR13_U_SMXP_1_0, REGION13_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR13_U_SMXP_1_0, REGION13_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR14_U_SMXP_1_0, 0x83d4f0)
    FIELD(POR_MPU_M1_PRBAR14_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR14_U_SMXP_1_0, REGION14_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR14_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR14_U_SMXP_1_0, REGION14_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR14_U_SMXP_1_0, REGION14_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR14_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR14_U_SMXP_1_0, 0x83d4f8)
    FIELD(POR_MPU_M1_PRLAR14_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR14_U_SMXP_1_0, REGION14_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR14_U_SMXP_1_0, REGION14_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR15_U_SMXP_1_0, 0x83d500)
    FIELD(POR_MPU_M1_PRBAR15_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR15_U_SMXP_1_0, REGION15_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR15_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR15_U_SMXP_1_0, REGION15_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR15_U_SMXP_1_0, REGION15_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR15_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR15_U_SMXP_1_0, 0x83d508)
    FIELD(POR_MPU_M1_PRLAR15_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR15_U_SMXP_1_0, REGION15_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR15_U_SMXP_1_0, REGION15_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR16_U_SMXP_1_0, 0x83d510)
    FIELD(POR_MPU_M1_PRBAR16_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR16_U_SMXP_1_0, REGION16_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR16_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR16_U_SMXP_1_0, REGION16_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR16_U_SMXP_1_0, REGION16_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR16_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR16_U_SMXP_1_0, 0x83d518)
    FIELD(POR_MPU_M1_PRLAR16_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR16_U_SMXP_1_0, REGION16_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR16_U_SMXP_1_0, REGION16_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR17_U_SMXP_1_0, 0x83d520)
    FIELD(POR_MPU_M1_PRBAR17_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR17_U_SMXP_1_0, REGION17_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR17_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR17_U_SMXP_1_0, REGION17_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR17_U_SMXP_1_0, REGION17_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR17_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR17_U_SMXP_1_0, 0x83d528)
    FIELD(POR_MPU_M1_PRLAR17_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR17_U_SMXP_1_0, REGION17_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR17_U_SMXP_1_0, REGION17_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR18_U_SMXP_1_0, 0x83d530)
    FIELD(POR_MPU_M1_PRBAR18_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR18_U_SMXP_1_0, REGION18_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR18_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR18_U_SMXP_1_0, REGION18_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR18_U_SMXP_1_0, REGION18_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR18_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR18_U_SMXP_1_0, 0x83d538)
    FIELD(POR_MPU_M1_PRLAR18_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR18_U_SMXP_1_0, REGION18_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR18_U_SMXP_1_0, REGION18_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR19_U_SMXP_1_0, 0x83d540)
    FIELD(POR_MPU_M1_PRBAR19_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR19_U_SMXP_1_0, REGION19_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR19_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR19_U_SMXP_1_0, REGION19_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR19_U_SMXP_1_0, REGION19_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR19_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR19_U_SMXP_1_0, 0x83d548)
    FIELD(POR_MPU_M1_PRLAR19_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR19_U_SMXP_1_0, REGION19_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR19_U_SMXP_1_0, REGION19_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR20_U_SMXP_1_0, 0x83d550)
    FIELD(POR_MPU_M1_PRBAR20_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR20_U_SMXP_1_0, REGION20_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR20_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR20_U_SMXP_1_0, REGION20_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR20_U_SMXP_1_0, REGION20_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR20_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR20_U_SMXP_1_0, 0x83d558)
    FIELD(POR_MPU_M1_PRLAR20_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR20_U_SMXP_1_0, REGION20_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR20_U_SMXP_1_0, REGION20_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR21_U_SMXP_1_0, 0x83d560)
    FIELD(POR_MPU_M1_PRBAR21_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR21_U_SMXP_1_0, REGION21_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR21_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR21_U_SMXP_1_0, REGION21_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR21_U_SMXP_1_0, REGION21_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR21_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR21_U_SMXP_1_0, 0x83d568)
    FIELD(POR_MPU_M1_PRLAR21_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR21_U_SMXP_1_0, REGION21_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR21_U_SMXP_1_0, REGION21_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR22_U_SMXP_1_0, 0x83d570)
    FIELD(POR_MPU_M1_PRBAR22_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR22_U_SMXP_1_0, REGION22_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR22_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR22_U_SMXP_1_0, REGION22_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR22_U_SMXP_1_0, REGION22_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR22_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR22_U_SMXP_1_0, 0x83d578)
    FIELD(POR_MPU_M1_PRLAR22_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR22_U_SMXP_1_0, REGION22_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR22_U_SMXP_1_0, REGION22_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR23_U_SMXP_1_0, 0x83d580)
    FIELD(POR_MPU_M1_PRBAR23_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR23_U_SMXP_1_0, REGION23_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR23_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR23_U_SMXP_1_0, REGION23_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR23_U_SMXP_1_0, REGION23_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR23_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR23_U_SMXP_1_0, 0x83d588)
    FIELD(POR_MPU_M1_PRLAR23_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR23_U_SMXP_1_0, REGION23_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR23_U_SMXP_1_0, REGION23_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR24_U_SMXP_1_0, 0x83d590)
    FIELD(POR_MPU_M1_PRBAR24_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR24_U_SMXP_1_0, REGION24_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR24_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR24_U_SMXP_1_0, REGION24_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR24_U_SMXP_1_0, REGION24_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR24_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR24_U_SMXP_1_0, 0x83d598)
    FIELD(POR_MPU_M1_PRLAR24_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR24_U_SMXP_1_0, REGION24_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR24_U_SMXP_1_0, REGION24_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR25_U_SMXP_1_0, 0x83d5a0)
    FIELD(POR_MPU_M1_PRBAR25_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR25_U_SMXP_1_0, REGION25_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR25_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR25_U_SMXP_1_0, REGION25_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR25_U_SMXP_1_0, REGION25_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR25_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR25_U_SMXP_1_0, 0x83d5a8)
    FIELD(POR_MPU_M1_PRLAR25_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR25_U_SMXP_1_0, REGION25_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR25_U_SMXP_1_0, REGION25_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR26_U_SMXP_1_0, 0x83d5b0)
    FIELD(POR_MPU_M1_PRBAR26_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR26_U_SMXP_1_0, REGION26_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR26_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR26_U_SMXP_1_0, REGION26_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR26_U_SMXP_1_0, REGION26_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR26_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR26_U_SMXP_1_0, 0x83d5b8)
    FIELD(POR_MPU_M1_PRLAR26_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR26_U_SMXP_1_0, REGION26_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR26_U_SMXP_1_0, REGION26_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR27_U_SMXP_1_0, 0x83d5c0)
    FIELD(POR_MPU_M1_PRBAR27_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR27_U_SMXP_1_0, REGION27_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR27_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR27_U_SMXP_1_0, REGION27_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR27_U_SMXP_1_0, REGION27_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR27_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR27_U_SMXP_1_0, 0x83d5c8)
    FIELD(POR_MPU_M1_PRLAR27_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR27_U_SMXP_1_0, REGION27_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR27_U_SMXP_1_0, REGION27_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR28_U_SMXP_1_0, 0x83d5d0)
    FIELD(POR_MPU_M1_PRBAR28_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR28_U_SMXP_1_0, REGION28_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR28_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR28_U_SMXP_1_0, REGION28_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR28_U_SMXP_1_0, REGION28_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR28_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR28_U_SMXP_1_0, 0x83d5d8)
    FIELD(POR_MPU_M1_PRLAR28_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR28_U_SMXP_1_0, REGION28_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR28_U_SMXP_1_0, REGION28_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR29_U_SMXP_1_0, 0x83d5e0)
    FIELD(POR_MPU_M1_PRBAR29_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR29_U_SMXP_1_0, REGION29_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR29_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR29_U_SMXP_1_0, REGION29_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR29_U_SMXP_1_0, REGION29_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR29_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR29_U_SMXP_1_0, 0x83d5e8)
    FIELD(POR_MPU_M1_PRLAR29_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR29_U_SMXP_1_0, REGION29_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR29_U_SMXP_1_0, REGION29_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR30_U_SMXP_1_0, 0x83d5f0)
    FIELD(POR_MPU_M1_PRBAR30_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR30_U_SMXP_1_0, REGION30_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR30_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR30_U_SMXP_1_0, REGION30_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR30_U_SMXP_1_0, REGION30_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR30_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR30_U_SMXP_1_0, 0x83d5f8)
    FIELD(POR_MPU_M1_PRLAR30_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR30_U_SMXP_1_0, REGION30_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR30_U_SMXP_1_0, REGION30_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR31_U_SMXP_1_0, 0x83d600)
    FIELD(POR_MPU_M1_PRBAR31_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR31_U_SMXP_1_0, REGION31_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR31_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR31_U_SMXP_1_0, REGION31_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR31_U_SMXP_1_0, REGION31_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR31_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR31_U_SMXP_1_0, 0x83d608)
    FIELD(POR_MPU_M1_PRLAR31_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR31_U_SMXP_1_0, REGION31_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR31_U_SMXP_1_0, REGION31_EN, 0, 1)
REG32(POR_MPU_M2_CTL_U_SMXP_1_0, 0x83d800)
    FIELD(POR_MPU_M2_CTL_U_SMXP_1_0, M2_EN, 2, 1)
    FIELD(POR_MPU_M2_CTL_U_SMXP_1_0, M2_ACTION, 0, 2)
REG32(POR_MPU_M2_PRBAR0_U_SMXP_1_0, 0x83d810)
    FIELD(POR_MPU_M2_PRBAR0_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR0_U_SMXP_1_0, REGION0_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR0_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR0_U_SMXP_1_0, REGION0_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR0_U_SMXP_1_0, REGION0_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR0_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR0_U_SMXP_1_0, 0x83d818)
    FIELD(POR_MPU_M2_PRLAR0_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR0_U_SMXP_1_0, REGION0_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR0_U_SMXP_1_0, REGION0_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR1_U_SMXP_1_0, 0x83d820)
    FIELD(POR_MPU_M2_PRBAR1_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR1_U_SMXP_1_0, REGION1_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR1_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR1_U_SMXP_1_0, REGION1_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR1_U_SMXP_1_0, REGION1_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR1_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR1_U_SMXP_1_0, 0x83d828)
    FIELD(POR_MPU_M2_PRLAR1_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR1_U_SMXP_1_0, REGION1_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR1_U_SMXP_1_0, REGION1_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR2_U_SMXP_1_0, 0x83d830)
    FIELD(POR_MPU_M2_PRBAR2_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR2_U_SMXP_1_0, REGION2_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR2_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR2_U_SMXP_1_0, REGION2_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR2_U_SMXP_1_0, REGION2_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR2_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR2_U_SMXP_1_0, 0x83d838)
    FIELD(POR_MPU_M2_PRLAR2_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR2_U_SMXP_1_0, REGION2_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR2_U_SMXP_1_0, REGION2_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR3_U_SMXP_1_0, 0x83d840)
    FIELD(POR_MPU_M2_PRBAR3_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR3_U_SMXP_1_0, REGION3_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR3_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR3_U_SMXP_1_0, REGION3_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR3_U_SMXP_1_0, REGION3_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR3_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR3_U_SMXP_1_0, 0x83d848)
    FIELD(POR_MPU_M2_PRLAR3_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR3_U_SMXP_1_0, REGION3_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR3_U_SMXP_1_0, REGION3_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR4_U_SMXP_1_0, 0x83d850)
    FIELD(POR_MPU_M2_PRBAR4_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR4_U_SMXP_1_0, REGION4_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR4_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR4_U_SMXP_1_0, REGION4_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR4_U_SMXP_1_0, REGION4_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR4_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR4_U_SMXP_1_0, 0x83d858)
    FIELD(POR_MPU_M2_PRLAR4_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR4_U_SMXP_1_0, REGION4_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR4_U_SMXP_1_0, REGION4_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR5_U_SMXP_1_0, 0x83d860)
    FIELD(POR_MPU_M2_PRBAR5_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR5_U_SMXP_1_0, REGION5_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR5_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR5_U_SMXP_1_0, REGION5_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR5_U_SMXP_1_0, REGION5_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR5_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR5_U_SMXP_1_0, 0x83d868)
    FIELD(POR_MPU_M2_PRLAR5_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR5_U_SMXP_1_0, REGION5_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR5_U_SMXP_1_0, REGION5_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR6_U_SMXP_1_0, 0x83d870)
    FIELD(POR_MPU_M2_PRBAR6_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR6_U_SMXP_1_0, REGION6_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR6_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR6_U_SMXP_1_0, REGION6_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR6_U_SMXP_1_0, REGION6_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR6_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR6_U_SMXP_1_0, 0x83d878)
    FIELD(POR_MPU_M2_PRLAR6_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR6_U_SMXP_1_0, REGION6_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR6_U_SMXP_1_0, REGION6_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR7_U_SMXP_1_0, 0x83d880)
    FIELD(POR_MPU_M2_PRBAR7_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR7_U_SMXP_1_0, REGION7_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR7_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR7_U_SMXP_1_0, REGION7_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR7_U_SMXP_1_0, REGION7_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR7_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR7_U_SMXP_1_0, 0x83d888)
    FIELD(POR_MPU_M2_PRLAR7_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR7_U_SMXP_1_0, REGION7_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR7_U_SMXP_1_0, REGION7_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR8_U_SMXP_1_0, 0x83d890)
    FIELD(POR_MPU_M2_PRBAR8_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR8_U_SMXP_1_0, REGION8_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR8_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR8_U_SMXP_1_0, REGION8_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR8_U_SMXP_1_0, REGION8_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR8_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR8_U_SMXP_1_0, 0x83d898)
    FIELD(POR_MPU_M2_PRLAR8_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR8_U_SMXP_1_0, REGION8_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR8_U_SMXP_1_0, REGION8_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR9_U_SMXP_1_0, 0x83d8a0)
    FIELD(POR_MPU_M2_PRBAR9_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR9_U_SMXP_1_0, REGION9_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR9_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR9_U_SMXP_1_0, REGION9_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR9_U_SMXP_1_0, REGION9_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR9_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR9_U_SMXP_1_0, 0x83d8a8)
    FIELD(POR_MPU_M2_PRLAR9_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR9_U_SMXP_1_0, REGION9_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR9_U_SMXP_1_0, REGION9_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR10_U_SMXP_1_0, 0x83d8b0)
    FIELD(POR_MPU_M2_PRBAR10_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR10_U_SMXP_1_0, REGION10_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR10_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR10_U_SMXP_1_0, REGION10_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR10_U_SMXP_1_0, REGION10_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR10_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR10_U_SMXP_1_0, 0x83d8b8)
    FIELD(POR_MPU_M2_PRLAR10_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR10_U_SMXP_1_0, REGION10_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR10_U_SMXP_1_0, REGION10_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR11_U_SMXP_1_0, 0x83d8c0)
    FIELD(POR_MPU_M2_PRBAR11_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR11_U_SMXP_1_0, REGION11_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR11_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR11_U_SMXP_1_0, REGION11_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR11_U_SMXP_1_0, REGION11_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR11_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR11_U_SMXP_1_0, 0x83d8c8)
    FIELD(POR_MPU_M2_PRLAR11_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR11_U_SMXP_1_0, REGION11_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR11_U_SMXP_1_0, REGION11_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR12_U_SMXP_1_0, 0x83d8d0)
    FIELD(POR_MPU_M2_PRBAR12_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR12_U_SMXP_1_0, REGION12_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR12_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR12_U_SMXP_1_0, REGION12_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR12_U_SMXP_1_0, REGION12_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR12_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR12_U_SMXP_1_0, 0x83d8d8)
    FIELD(POR_MPU_M2_PRLAR12_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR12_U_SMXP_1_0, REGION12_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR12_U_SMXP_1_0, REGION12_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR13_U_SMXP_1_0, 0x83d8e0)
    FIELD(POR_MPU_M2_PRBAR13_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR13_U_SMXP_1_0, REGION13_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR13_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR13_U_SMXP_1_0, REGION13_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR13_U_SMXP_1_0, REGION13_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR13_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR13_U_SMXP_1_0, 0x83d8e8)
    FIELD(POR_MPU_M2_PRLAR13_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR13_U_SMXP_1_0, REGION13_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR13_U_SMXP_1_0, REGION13_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR14_U_SMXP_1_0, 0x83d8f0)
    FIELD(POR_MPU_M2_PRBAR14_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR14_U_SMXP_1_0, REGION14_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR14_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR14_U_SMXP_1_0, REGION14_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR14_U_SMXP_1_0, REGION14_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR14_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR14_U_SMXP_1_0, 0x83d8f8)
    FIELD(POR_MPU_M2_PRLAR14_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR14_U_SMXP_1_0, REGION14_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR14_U_SMXP_1_0, REGION14_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR15_U_SMXP_1_0, 0x83d900)
    FIELD(POR_MPU_M2_PRBAR15_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR15_U_SMXP_1_0, REGION15_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR15_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR15_U_SMXP_1_0, REGION15_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR15_U_SMXP_1_0, REGION15_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR15_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR15_U_SMXP_1_0, 0x83d908)
    FIELD(POR_MPU_M2_PRLAR15_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR15_U_SMXP_1_0, REGION15_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR15_U_SMXP_1_0, REGION15_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR16_U_SMXP_1_0, 0x83d910)
    FIELD(POR_MPU_M2_PRBAR16_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR16_U_SMXP_1_0, REGION16_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR16_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR16_U_SMXP_1_0, REGION16_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR16_U_SMXP_1_0, REGION16_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR16_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR16_U_SMXP_1_0, 0x83d918)
    FIELD(POR_MPU_M2_PRLAR16_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR16_U_SMXP_1_0, REGION16_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR16_U_SMXP_1_0, REGION16_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR17_U_SMXP_1_0, 0x83d920)
    FIELD(POR_MPU_M2_PRBAR17_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR17_U_SMXP_1_0, REGION17_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR17_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR17_U_SMXP_1_0, REGION17_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR17_U_SMXP_1_0, REGION17_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR17_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR17_U_SMXP_1_0, 0x83d928)
    FIELD(POR_MPU_M2_PRLAR17_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR17_U_SMXP_1_0, REGION17_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR17_U_SMXP_1_0, REGION17_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR18_U_SMXP_1_0, 0x83d930)
    FIELD(POR_MPU_M2_PRBAR18_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR18_U_SMXP_1_0, REGION18_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR18_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR18_U_SMXP_1_0, REGION18_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR18_U_SMXP_1_0, REGION18_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR18_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR18_U_SMXP_1_0, 0x83d938)
    FIELD(POR_MPU_M2_PRLAR18_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR18_U_SMXP_1_0, REGION18_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR18_U_SMXP_1_0, REGION18_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR19_U_SMXP_1_0, 0x83d940)
    FIELD(POR_MPU_M2_PRBAR19_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR19_U_SMXP_1_0, REGION19_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR19_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR19_U_SMXP_1_0, REGION19_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR19_U_SMXP_1_0, REGION19_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR19_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR19_U_SMXP_1_0, 0x83d948)
    FIELD(POR_MPU_M2_PRLAR19_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR19_U_SMXP_1_0, REGION19_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR19_U_SMXP_1_0, REGION19_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR20_U_SMXP_1_0, 0x83d950)
    FIELD(POR_MPU_M2_PRBAR20_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR20_U_SMXP_1_0, REGION20_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR20_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR20_U_SMXP_1_0, REGION20_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR20_U_SMXP_1_0, REGION20_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR20_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR20_U_SMXP_1_0, 0x83d958)
    FIELD(POR_MPU_M2_PRLAR20_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR20_U_SMXP_1_0, REGION20_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR20_U_SMXP_1_0, REGION20_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR21_U_SMXP_1_0, 0x83d960)
    FIELD(POR_MPU_M2_PRBAR21_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR21_U_SMXP_1_0, REGION21_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR21_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR21_U_SMXP_1_0, REGION21_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR21_U_SMXP_1_0, REGION21_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR21_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR21_U_SMXP_1_0, 0x83d968)
    FIELD(POR_MPU_M2_PRLAR21_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR21_U_SMXP_1_0, REGION21_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR21_U_SMXP_1_0, REGION21_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR22_U_SMXP_1_0, 0x83d970)
    FIELD(POR_MPU_M2_PRBAR22_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR22_U_SMXP_1_0, REGION22_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR22_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR22_U_SMXP_1_0, REGION22_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR22_U_SMXP_1_0, REGION22_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR22_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR22_U_SMXP_1_0, 0x83d978)
    FIELD(POR_MPU_M2_PRLAR22_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR22_U_SMXP_1_0, REGION22_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR22_U_SMXP_1_0, REGION22_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR23_U_SMXP_1_0, 0x83d980)
    FIELD(POR_MPU_M2_PRBAR23_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR23_U_SMXP_1_0, REGION23_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR23_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR23_U_SMXP_1_0, REGION23_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR23_U_SMXP_1_0, REGION23_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR23_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR23_U_SMXP_1_0, 0x83d988)
    FIELD(POR_MPU_M2_PRLAR23_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR23_U_SMXP_1_0, REGION23_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR23_U_SMXP_1_0, REGION23_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR24_U_SMXP_1_0, 0x83d990)
    FIELD(POR_MPU_M2_PRBAR24_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR24_U_SMXP_1_0, REGION24_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR24_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR24_U_SMXP_1_0, REGION24_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR24_U_SMXP_1_0, REGION24_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR24_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR24_U_SMXP_1_0, 0x83d998)
    FIELD(POR_MPU_M2_PRLAR24_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR24_U_SMXP_1_0, REGION24_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR24_U_SMXP_1_0, REGION24_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR25_U_SMXP_1_0, 0x83d9a0)
    FIELD(POR_MPU_M2_PRBAR25_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR25_U_SMXP_1_0, REGION25_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR25_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR25_U_SMXP_1_0, REGION25_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR25_U_SMXP_1_0, REGION25_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR25_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR25_U_SMXP_1_0, 0x83d9a8)
    FIELD(POR_MPU_M2_PRLAR25_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR25_U_SMXP_1_0, REGION25_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR25_U_SMXP_1_0, REGION25_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR26_U_SMXP_1_0, 0x83d9b0)
    FIELD(POR_MPU_M2_PRBAR26_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR26_U_SMXP_1_0, REGION26_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR26_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR26_U_SMXP_1_0, REGION26_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR26_U_SMXP_1_0, REGION26_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR26_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR26_U_SMXP_1_0, 0x83d9b8)
    FIELD(POR_MPU_M2_PRLAR26_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR26_U_SMXP_1_0, REGION26_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR26_U_SMXP_1_0, REGION26_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR27_U_SMXP_1_0, 0x83d9c0)
    FIELD(POR_MPU_M2_PRBAR27_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR27_U_SMXP_1_0, REGION27_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR27_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR27_U_SMXP_1_0, REGION27_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR27_U_SMXP_1_0, REGION27_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR27_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR27_U_SMXP_1_0, 0x83d9c8)
    FIELD(POR_MPU_M2_PRLAR27_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR27_U_SMXP_1_0, REGION27_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR27_U_SMXP_1_0, REGION27_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR28_U_SMXP_1_0, 0x83d9d0)
    FIELD(POR_MPU_M2_PRBAR28_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR28_U_SMXP_1_0, REGION28_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR28_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR28_U_SMXP_1_0, REGION28_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR28_U_SMXP_1_0, REGION28_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR28_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR28_U_SMXP_1_0, 0x83d9d8)
    FIELD(POR_MPU_M2_PRLAR28_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR28_U_SMXP_1_0, REGION28_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR28_U_SMXP_1_0, REGION28_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR29_U_SMXP_1_0, 0x83d9e0)
    FIELD(POR_MPU_M2_PRBAR29_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR29_U_SMXP_1_0, REGION29_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR29_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR29_U_SMXP_1_0, REGION29_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR29_U_SMXP_1_0, REGION29_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR29_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR29_U_SMXP_1_0, 0x83d9e8)
    FIELD(POR_MPU_M2_PRLAR29_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR29_U_SMXP_1_0, REGION29_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR29_U_SMXP_1_0, REGION29_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR30_U_SMXP_1_0, 0x83d9f0)
    FIELD(POR_MPU_M2_PRBAR30_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR30_U_SMXP_1_0, REGION30_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR30_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR30_U_SMXP_1_0, REGION30_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR30_U_SMXP_1_0, REGION30_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR30_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR30_U_SMXP_1_0, 0x83d9f8)
    FIELD(POR_MPU_M2_PRLAR30_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR30_U_SMXP_1_0, REGION30_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR30_U_SMXP_1_0, REGION30_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR31_U_SMXP_1_0, 0x83da00)
    FIELD(POR_MPU_M2_PRBAR31_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR31_U_SMXP_1_0, REGION31_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR31_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR31_U_SMXP_1_0, REGION31_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR31_U_SMXP_1_0, REGION31_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR31_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR31_U_SMXP_1_0, 0x83da08)
    FIELD(POR_MPU_M2_PRLAR31_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR31_U_SMXP_1_0, REGION31_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR31_U_SMXP_1_0, REGION31_EN, 0, 1)
REG32(POR_MPU_M3_CTL_U_SMXP_1_0, 0x83dc00)
    FIELD(POR_MPU_M3_CTL_U_SMXP_1_0, M3_EN, 2, 1)
    FIELD(POR_MPU_M3_CTL_U_SMXP_1_0, M3_ACTION, 0, 2)
REG32(POR_MPU_M3_PRBAR0_U_SMXP_1_0, 0x83dc10)
    FIELD(POR_MPU_M3_PRBAR0_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR0_U_SMXP_1_0, REGION0_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR0_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR0_U_SMXP_1_0, REGION0_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR0_U_SMXP_1_0, REGION0_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR0_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR0_U_SMXP_1_0, 0x83dc18)
    FIELD(POR_MPU_M3_PRLAR0_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR0_U_SMXP_1_0, REGION0_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR0_U_SMXP_1_0, REGION0_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR1_U_SMXP_1_0, 0x83dc20)
    FIELD(POR_MPU_M3_PRBAR1_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR1_U_SMXP_1_0, REGION1_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR1_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR1_U_SMXP_1_0, REGION1_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR1_U_SMXP_1_0, REGION1_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR1_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR1_U_SMXP_1_0, 0x83dc28)
    FIELD(POR_MPU_M3_PRLAR1_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR1_U_SMXP_1_0, REGION1_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR1_U_SMXP_1_0, REGION1_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR2_U_SMXP_1_0, 0x83dc30)
    FIELD(POR_MPU_M3_PRBAR2_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR2_U_SMXP_1_0, REGION2_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR2_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR2_U_SMXP_1_0, REGION2_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR2_U_SMXP_1_0, REGION2_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR2_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR2_U_SMXP_1_0, 0x83dc38)
    FIELD(POR_MPU_M3_PRLAR2_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR2_U_SMXP_1_0, REGION2_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR2_U_SMXP_1_0, REGION2_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR3_U_SMXP_1_0, 0x83dc40)
    FIELD(POR_MPU_M3_PRBAR3_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR3_U_SMXP_1_0, REGION3_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR3_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR3_U_SMXP_1_0, REGION3_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR3_U_SMXP_1_0, REGION3_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR3_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR3_U_SMXP_1_0, 0x83dc48)
    FIELD(POR_MPU_M3_PRLAR3_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR3_U_SMXP_1_0, REGION3_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR3_U_SMXP_1_0, REGION3_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR4_U_SMXP_1_0, 0x83dc50)
    FIELD(POR_MPU_M3_PRBAR4_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR4_U_SMXP_1_0, REGION4_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR4_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR4_U_SMXP_1_0, REGION4_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR4_U_SMXP_1_0, REGION4_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR4_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR4_U_SMXP_1_0, 0x83dc58)
    FIELD(POR_MPU_M3_PRLAR4_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR4_U_SMXP_1_0, REGION4_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR4_U_SMXP_1_0, REGION4_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR5_U_SMXP_1_0, 0x83dc60)
    FIELD(POR_MPU_M3_PRBAR5_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR5_U_SMXP_1_0, REGION5_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR5_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR5_U_SMXP_1_0, REGION5_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR5_U_SMXP_1_0, REGION5_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR5_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR5_U_SMXP_1_0, 0x83dc68)
    FIELD(POR_MPU_M3_PRLAR5_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR5_U_SMXP_1_0, REGION5_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR5_U_SMXP_1_0, REGION5_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR6_U_SMXP_1_0, 0x83dc70)
    FIELD(POR_MPU_M3_PRBAR6_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR6_U_SMXP_1_0, REGION6_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR6_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR6_U_SMXP_1_0, REGION6_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR6_U_SMXP_1_0, REGION6_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR6_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR6_U_SMXP_1_0, 0x83dc78)
    FIELD(POR_MPU_M3_PRLAR6_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR6_U_SMXP_1_0, REGION6_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR6_U_SMXP_1_0, REGION6_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR7_U_SMXP_1_0, 0x83dc80)
    FIELD(POR_MPU_M3_PRBAR7_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR7_U_SMXP_1_0, REGION7_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR7_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR7_U_SMXP_1_0, REGION7_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR7_U_SMXP_1_0, REGION7_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR7_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR7_U_SMXP_1_0, 0x83dc88)
    FIELD(POR_MPU_M3_PRLAR7_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR7_U_SMXP_1_0, REGION7_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR7_U_SMXP_1_0, REGION7_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR8_U_SMXP_1_0, 0x83dc90)
    FIELD(POR_MPU_M3_PRBAR8_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR8_U_SMXP_1_0, REGION8_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR8_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR8_U_SMXP_1_0, REGION8_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR8_U_SMXP_1_0, REGION8_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR8_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR8_U_SMXP_1_0, 0x83dc98)
    FIELD(POR_MPU_M3_PRLAR8_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR8_U_SMXP_1_0, REGION8_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR8_U_SMXP_1_0, REGION8_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR9_U_SMXP_1_0, 0x83dca0)
    FIELD(POR_MPU_M3_PRBAR9_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR9_U_SMXP_1_0, REGION9_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR9_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR9_U_SMXP_1_0, REGION9_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR9_U_SMXP_1_0, REGION9_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR9_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR9_U_SMXP_1_0, 0x83dca8)
    FIELD(POR_MPU_M3_PRLAR9_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR9_U_SMXP_1_0, REGION9_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR9_U_SMXP_1_0, REGION9_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR10_U_SMXP_1_0, 0x83dcb0)
    FIELD(POR_MPU_M3_PRBAR10_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR10_U_SMXP_1_0, REGION10_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR10_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR10_U_SMXP_1_0, REGION10_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR10_U_SMXP_1_0, REGION10_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR10_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR10_U_SMXP_1_0, 0x83dcb8)
    FIELD(POR_MPU_M3_PRLAR10_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR10_U_SMXP_1_0, REGION10_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR10_U_SMXP_1_0, REGION10_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR11_U_SMXP_1_0, 0x83dcc0)
    FIELD(POR_MPU_M3_PRBAR11_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR11_U_SMXP_1_0, REGION11_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR11_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR11_U_SMXP_1_0, REGION11_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR11_U_SMXP_1_0, REGION11_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR11_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR11_U_SMXP_1_0, 0x83dcc8)
    FIELD(POR_MPU_M3_PRLAR11_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR11_U_SMXP_1_0, REGION11_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR11_U_SMXP_1_0, REGION11_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR12_U_SMXP_1_0, 0x83dcd0)
    FIELD(POR_MPU_M3_PRBAR12_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR12_U_SMXP_1_0, REGION12_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR12_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR12_U_SMXP_1_0, REGION12_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR12_U_SMXP_1_0, REGION12_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR12_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR12_U_SMXP_1_0, 0x83dcd8)
    FIELD(POR_MPU_M3_PRLAR12_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR12_U_SMXP_1_0, REGION12_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR12_U_SMXP_1_0, REGION12_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR13_U_SMXP_1_0, 0x83dce0)
    FIELD(POR_MPU_M3_PRBAR13_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR13_U_SMXP_1_0, REGION13_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR13_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR13_U_SMXP_1_0, REGION13_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR13_U_SMXP_1_0, REGION13_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR13_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR13_U_SMXP_1_0, 0x83dce8)
    FIELD(POR_MPU_M3_PRLAR13_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR13_U_SMXP_1_0, REGION13_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR13_U_SMXP_1_0, REGION13_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR14_U_SMXP_1_0, 0x83dcf0)
    FIELD(POR_MPU_M3_PRBAR14_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR14_U_SMXP_1_0, REGION14_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR14_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR14_U_SMXP_1_0, REGION14_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR14_U_SMXP_1_0, REGION14_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR14_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR14_U_SMXP_1_0, 0x83dcf8)
    FIELD(POR_MPU_M3_PRLAR14_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR14_U_SMXP_1_0, REGION14_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR14_U_SMXP_1_0, REGION14_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR15_U_SMXP_1_0, 0x83dd00)
    FIELD(POR_MPU_M3_PRBAR15_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR15_U_SMXP_1_0, REGION15_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR15_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR15_U_SMXP_1_0, REGION15_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR15_U_SMXP_1_0, REGION15_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR15_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR15_U_SMXP_1_0, 0x83dd08)
    FIELD(POR_MPU_M3_PRLAR15_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR15_U_SMXP_1_0, REGION15_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR15_U_SMXP_1_0, REGION15_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR16_U_SMXP_1_0, 0x83dd10)
    FIELD(POR_MPU_M3_PRBAR16_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR16_U_SMXP_1_0, REGION16_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR16_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR16_U_SMXP_1_0, REGION16_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR16_U_SMXP_1_0, REGION16_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR16_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR16_U_SMXP_1_0, 0x83dd18)
    FIELD(POR_MPU_M3_PRLAR16_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR16_U_SMXP_1_0, REGION16_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR16_U_SMXP_1_0, REGION16_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR17_U_SMXP_1_0, 0x83dd20)
    FIELD(POR_MPU_M3_PRBAR17_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR17_U_SMXP_1_0, REGION17_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR17_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR17_U_SMXP_1_0, REGION17_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR17_U_SMXP_1_0, REGION17_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR17_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR17_U_SMXP_1_0, 0x83dd28)
    FIELD(POR_MPU_M3_PRLAR17_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR17_U_SMXP_1_0, REGION17_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR17_U_SMXP_1_0, REGION17_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR18_U_SMXP_1_0, 0x83dd30)
    FIELD(POR_MPU_M3_PRBAR18_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR18_U_SMXP_1_0, REGION18_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR18_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR18_U_SMXP_1_0, REGION18_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR18_U_SMXP_1_0, REGION18_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR18_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR18_U_SMXP_1_0, 0x83dd38)
    FIELD(POR_MPU_M3_PRLAR18_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR18_U_SMXP_1_0, REGION18_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR18_U_SMXP_1_0, REGION18_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR19_U_SMXP_1_0, 0x83dd40)
    FIELD(POR_MPU_M3_PRBAR19_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR19_U_SMXP_1_0, REGION19_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR19_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR19_U_SMXP_1_0, REGION19_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR19_U_SMXP_1_0, REGION19_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR19_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR19_U_SMXP_1_0, 0x83dd48)
    FIELD(POR_MPU_M3_PRLAR19_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR19_U_SMXP_1_0, REGION19_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR19_U_SMXP_1_0, REGION19_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR20_U_SMXP_1_0, 0x83dd50)
    FIELD(POR_MPU_M3_PRBAR20_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR20_U_SMXP_1_0, REGION20_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR20_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR20_U_SMXP_1_0, REGION20_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR20_U_SMXP_1_0, REGION20_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR20_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR20_U_SMXP_1_0, 0x83dd58)
    FIELD(POR_MPU_M3_PRLAR20_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR20_U_SMXP_1_0, REGION20_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR20_U_SMXP_1_0, REGION20_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR21_U_SMXP_1_0, 0x83dd60)
    FIELD(POR_MPU_M3_PRBAR21_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR21_U_SMXP_1_0, REGION21_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR21_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR21_U_SMXP_1_0, REGION21_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR21_U_SMXP_1_0, REGION21_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR21_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR21_U_SMXP_1_0, 0x83dd68)
    FIELD(POR_MPU_M3_PRLAR21_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR21_U_SMXP_1_0, REGION21_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR21_U_SMXP_1_0, REGION21_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR22_U_SMXP_1_0, 0x83dd70)
    FIELD(POR_MPU_M3_PRBAR22_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR22_U_SMXP_1_0, REGION22_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR22_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR22_U_SMXP_1_0, REGION22_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR22_U_SMXP_1_0, REGION22_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR22_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR22_U_SMXP_1_0, 0x83dd78)
    FIELD(POR_MPU_M3_PRLAR22_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR22_U_SMXP_1_0, REGION22_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR22_U_SMXP_1_0, REGION22_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR23_U_SMXP_1_0, 0x83dd80)
    FIELD(POR_MPU_M3_PRBAR23_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR23_U_SMXP_1_0, REGION23_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR23_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR23_U_SMXP_1_0, REGION23_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR23_U_SMXP_1_0, REGION23_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR23_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR23_U_SMXP_1_0, 0x83dd88)
    FIELD(POR_MPU_M3_PRLAR23_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR23_U_SMXP_1_0, REGION23_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR23_U_SMXP_1_0, REGION23_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR24_U_SMXP_1_0, 0x83dd90)
    FIELD(POR_MPU_M3_PRBAR24_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR24_U_SMXP_1_0, REGION24_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR24_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR24_U_SMXP_1_0, REGION24_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR24_U_SMXP_1_0, REGION24_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR24_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR24_U_SMXP_1_0, 0x83dd98)
    FIELD(POR_MPU_M3_PRLAR24_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR24_U_SMXP_1_0, REGION24_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR24_U_SMXP_1_0, REGION24_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR25_U_SMXP_1_0, 0x83dda0)
    FIELD(POR_MPU_M3_PRBAR25_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR25_U_SMXP_1_0, REGION25_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR25_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR25_U_SMXP_1_0, REGION25_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR25_U_SMXP_1_0, REGION25_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR25_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR25_U_SMXP_1_0, 0x83dda8)
    FIELD(POR_MPU_M3_PRLAR25_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR25_U_SMXP_1_0, REGION25_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR25_U_SMXP_1_0, REGION25_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR26_U_SMXP_1_0, 0x83ddb0)
    FIELD(POR_MPU_M3_PRBAR26_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR26_U_SMXP_1_0, REGION26_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR26_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR26_U_SMXP_1_0, REGION26_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR26_U_SMXP_1_0, REGION26_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR26_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR26_U_SMXP_1_0, 0x83ddb8)
    FIELD(POR_MPU_M3_PRLAR26_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR26_U_SMXP_1_0, REGION26_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR26_U_SMXP_1_0, REGION26_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR27_U_SMXP_1_0, 0x83ddc0)
    FIELD(POR_MPU_M3_PRBAR27_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR27_U_SMXP_1_0, REGION27_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR27_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR27_U_SMXP_1_0, REGION27_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR27_U_SMXP_1_0, REGION27_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR27_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR27_U_SMXP_1_0, 0x83ddc8)
    FIELD(POR_MPU_M3_PRLAR27_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR27_U_SMXP_1_0, REGION27_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR27_U_SMXP_1_0, REGION27_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR28_U_SMXP_1_0, 0x83ddd0)
    FIELD(POR_MPU_M3_PRBAR28_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR28_U_SMXP_1_0, REGION28_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR28_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR28_U_SMXP_1_0, REGION28_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR28_U_SMXP_1_0, REGION28_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR28_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR28_U_SMXP_1_0, 0x83ddd8)
    FIELD(POR_MPU_M3_PRLAR28_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR28_U_SMXP_1_0, REGION28_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR28_U_SMXP_1_0, REGION28_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR29_U_SMXP_1_0, 0x83dde0)
    FIELD(POR_MPU_M3_PRBAR29_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR29_U_SMXP_1_0, REGION29_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR29_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR29_U_SMXP_1_0, REGION29_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR29_U_SMXP_1_0, REGION29_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR29_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR29_U_SMXP_1_0, 0x83dde8)
    FIELD(POR_MPU_M3_PRLAR29_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR29_U_SMXP_1_0, REGION29_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR29_U_SMXP_1_0, REGION29_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR30_U_SMXP_1_0, 0x83ddf0)
    FIELD(POR_MPU_M3_PRBAR30_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR30_U_SMXP_1_0, REGION30_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR30_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR30_U_SMXP_1_0, REGION30_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR30_U_SMXP_1_0, REGION30_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR30_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR30_U_SMXP_1_0, 0x83ddf8)
    FIELD(POR_MPU_M3_PRLAR30_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR30_U_SMXP_1_0, REGION30_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR30_U_SMXP_1_0, REGION30_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR31_U_SMXP_1_0, 0x83de00)
    FIELD(POR_MPU_M3_PRBAR31_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR31_U_SMXP_1_0, REGION31_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR31_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR31_U_SMXP_1_0, REGION31_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR31_U_SMXP_1_0, REGION31_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR31_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR31_U_SMXP_1_0, 0x83de08)
    FIELD(POR_MPU_M3_PRLAR31_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR31_U_SMXP_1_0, REGION31_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR31_U_SMXP_1_0, REGION31_EN, 0, 1)
REG32(POR_MPU_M4_CTL_U_SMXP_1_0, 0x83e000)
    FIELD(POR_MPU_M4_CTL_U_SMXP_1_0, M4_EN, 2, 1)
    FIELD(POR_MPU_M4_CTL_U_SMXP_1_0, M4_ACTION, 0, 2)
REG32(POR_MPU_M4_PRBAR0_U_SMXP_1_0, 0x83e010)
    FIELD(POR_MPU_M4_PRBAR0_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR0_U_SMXP_1_0, REGION0_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR0_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR0_U_SMXP_1_0, REGION0_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR0_U_SMXP_1_0, REGION0_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR0_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR0_U_SMXP_1_0, 0x83e018)
    FIELD(POR_MPU_M4_PRLAR0_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR0_U_SMXP_1_0, REGION0_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR0_U_SMXP_1_0, REGION0_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR1_U_SMXP_1_0, 0x83e020)
    FIELD(POR_MPU_M4_PRBAR1_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR1_U_SMXP_1_0, REGION1_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR1_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR1_U_SMXP_1_0, REGION1_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR1_U_SMXP_1_0, REGION1_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR1_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR1_U_SMXP_1_0, 0x83e028)
    FIELD(POR_MPU_M4_PRLAR1_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR1_U_SMXP_1_0, REGION1_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR1_U_SMXP_1_0, REGION1_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR2_U_SMXP_1_0, 0x83e030)
    FIELD(POR_MPU_M4_PRBAR2_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR2_U_SMXP_1_0, REGION2_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR2_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR2_U_SMXP_1_0, REGION2_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR2_U_SMXP_1_0, REGION2_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR2_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR2_U_SMXP_1_0, 0x83e038)
    FIELD(POR_MPU_M4_PRLAR2_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR2_U_SMXP_1_0, REGION2_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR2_U_SMXP_1_0, REGION2_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR3_U_SMXP_1_0, 0x83e040)
    FIELD(POR_MPU_M4_PRBAR3_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR3_U_SMXP_1_0, REGION3_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR3_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR3_U_SMXP_1_0, REGION3_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR3_U_SMXP_1_0, REGION3_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR3_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR3_U_SMXP_1_0, 0x83e048)
    FIELD(POR_MPU_M4_PRLAR3_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR3_U_SMXP_1_0, REGION3_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR3_U_SMXP_1_0, REGION3_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR4_U_SMXP_1_0, 0x83e050)
    FIELD(POR_MPU_M4_PRBAR4_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR4_U_SMXP_1_0, REGION4_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR4_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR4_U_SMXP_1_0, REGION4_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR4_U_SMXP_1_0, REGION4_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR4_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR4_U_SMXP_1_0, 0x83e058)
    FIELD(POR_MPU_M4_PRLAR4_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR4_U_SMXP_1_0, REGION4_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR4_U_SMXP_1_0, REGION4_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR5_U_SMXP_1_0, 0x83e060)
    FIELD(POR_MPU_M4_PRBAR5_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR5_U_SMXP_1_0, REGION5_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR5_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR5_U_SMXP_1_0, REGION5_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR5_U_SMXP_1_0, REGION5_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR5_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR5_U_SMXP_1_0, 0x83e068)
    FIELD(POR_MPU_M4_PRLAR5_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR5_U_SMXP_1_0, REGION5_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR5_U_SMXP_1_0, REGION5_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR6_U_SMXP_1_0, 0x83e070)
    FIELD(POR_MPU_M4_PRBAR6_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR6_U_SMXP_1_0, REGION6_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR6_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR6_U_SMXP_1_0, REGION6_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR6_U_SMXP_1_0, REGION6_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR6_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR6_U_SMXP_1_0, 0x83e078)
    FIELD(POR_MPU_M4_PRLAR6_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR6_U_SMXP_1_0, REGION6_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR6_U_SMXP_1_0, REGION6_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR7_U_SMXP_1_0, 0x83e080)
    FIELD(POR_MPU_M4_PRBAR7_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR7_U_SMXP_1_0, REGION7_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR7_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR7_U_SMXP_1_0, REGION7_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR7_U_SMXP_1_0, REGION7_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR7_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR7_U_SMXP_1_0, 0x83e088)
    FIELD(POR_MPU_M4_PRLAR7_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR7_U_SMXP_1_0, REGION7_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR7_U_SMXP_1_0, REGION7_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR8_U_SMXP_1_0, 0x83e090)
    FIELD(POR_MPU_M4_PRBAR8_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR8_U_SMXP_1_0, REGION8_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR8_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR8_U_SMXP_1_0, REGION8_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR8_U_SMXP_1_0, REGION8_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR8_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR8_U_SMXP_1_0, 0x83e098)
    FIELD(POR_MPU_M4_PRLAR8_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR8_U_SMXP_1_0, REGION8_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR8_U_SMXP_1_0, REGION8_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR9_U_SMXP_1_0, 0x83e0a0)
    FIELD(POR_MPU_M4_PRBAR9_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR9_U_SMXP_1_0, REGION9_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR9_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR9_U_SMXP_1_0, REGION9_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR9_U_SMXP_1_0, REGION9_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR9_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR9_U_SMXP_1_0, 0x83e0a8)
    FIELD(POR_MPU_M4_PRLAR9_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR9_U_SMXP_1_0, REGION9_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR9_U_SMXP_1_0, REGION9_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR10_U_SMXP_1_0, 0x83e0b0)
    FIELD(POR_MPU_M4_PRBAR10_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR10_U_SMXP_1_0, REGION10_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR10_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR10_U_SMXP_1_0, REGION10_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR10_U_SMXP_1_0, REGION10_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR10_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR10_U_SMXP_1_0, 0x83e0b8)
    FIELD(POR_MPU_M4_PRLAR10_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR10_U_SMXP_1_0, REGION10_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR10_U_SMXP_1_0, REGION10_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR11_U_SMXP_1_0, 0x83e0c0)
    FIELD(POR_MPU_M4_PRBAR11_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR11_U_SMXP_1_0, REGION11_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR11_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR11_U_SMXP_1_0, REGION11_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR11_U_SMXP_1_0, REGION11_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR11_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR11_U_SMXP_1_0, 0x83e0c8)
    FIELD(POR_MPU_M4_PRLAR11_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR11_U_SMXP_1_0, REGION11_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR11_U_SMXP_1_0, REGION11_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR12_U_SMXP_1_0, 0x83e0d0)
    FIELD(POR_MPU_M4_PRBAR12_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR12_U_SMXP_1_0, REGION12_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR12_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR12_U_SMXP_1_0, REGION12_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR12_U_SMXP_1_0, REGION12_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR12_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR12_U_SMXP_1_0, 0x83e0d8)
    FIELD(POR_MPU_M4_PRLAR12_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR12_U_SMXP_1_0, REGION12_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR12_U_SMXP_1_0, REGION12_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR13_U_SMXP_1_0, 0x83e0e0)
    FIELD(POR_MPU_M4_PRBAR13_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR13_U_SMXP_1_0, REGION13_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR13_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR13_U_SMXP_1_0, REGION13_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR13_U_SMXP_1_0, REGION13_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR13_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR13_U_SMXP_1_0, 0x83e0e8)
    FIELD(POR_MPU_M4_PRLAR13_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR13_U_SMXP_1_0, REGION13_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR13_U_SMXP_1_0, REGION13_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR14_U_SMXP_1_0, 0x83e0f0)
    FIELD(POR_MPU_M4_PRBAR14_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR14_U_SMXP_1_0, REGION14_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR14_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR14_U_SMXP_1_0, REGION14_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR14_U_SMXP_1_0, REGION14_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR14_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR14_U_SMXP_1_0, 0x83e0f8)
    FIELD(POR_MPU_M4_PRLAR14_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR14_U_SMXP_1_0, REGION14_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR14_U_SMXP_1_0, REGION14_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR15_U_SMXP_1_0, 0x83e100)
    FIELD(POR_MPU_M4_PRBAR15_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR15_U_SMXP_1_0, REGION15_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR15_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR15_U_SMXP_1_0, REGION15_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR15_U_SMXP_1_0, REGION15_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR15_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR15_U_SMXP_1_0, 0x83e108)
    FIELD(POR_MPU_M4_PRLAR15_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR15_U_SMXP_1_0, REGION15_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR15_U_SMXP_1_0, REGION15_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR16_U_SMXP_1_0, 0x83e110)
    FIELD(POR_MPU_M4_PRBAR16_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR16_U_SMXP_1_0, REGION16_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR16_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR16_U_SMXP_1_0, REGION16_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR16_U_SMXP_1_0, REGION16_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR16_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR16_U_SMXP_1_0, 0x83e118)
    FIELD(POR_MPU_M4_PRLAR16_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR16_U_SMXP_1_0, REGION16_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR16_U_SMXP_1_0, REGION16_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR17_U_SMXP_1_0, 0x83e120)
    FIELD(POR_MPU_M4_PRBAR17_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR17_U_SMXP_1_0, REGION17_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR17_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR17_U_SMXP_1_0, REGION17_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR17_U_SMXP_1_0, REGION17_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR17_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR17_U_SMXP_1_0, 0x83e128)
    FIELD(POR_MPU_M4_PRLAR17_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR17_U_SMXP_1_0, REGION17_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR17_U_SMXP_1_0, REGION17_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR18_U_SMXP_1_0, 0x83e130)
    FIELD(POR_MPU_M4_PRBAR18_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR18_U_SMXP_1_0, REGION18_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR18_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR18_U_SMXP_1_0, REGION18_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR18_U_SMXP_1_0, REGION18_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR18_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR18_U_SMXP_1_0, 0x83e138)
    FIELD(POR_MPU_M4_PRLAR18_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR18_U_SMXP_1_0, REGION18_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR18_U_SMXP_1_0, REGION18_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR19_U_SMXP_1_0, 0x83e140)
    FIELD(POR_MPU_M4_PRBAR19_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR19_U_SMXP_1_0, REGION19_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR19_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR19_U_SMXP_1_0, REGION19_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR19_U_SMXP_1_0, REGION19_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR19_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR19_U_SMXP_1_0, 0x83e148)
    FIELD(POR_MPU_M4_PRLAR19_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR19_U_SMXP_1_0, REGION19_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR19_U_SMXP_1_0, REGION19_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR20_U_SMXP_1_0, 0x83e150)
    FIELD(POR_MPU_M4_PRBAR20_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR20_U_SMXP_1_0, REGION20_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR20_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR20_U_SMXP_1_0, REGION20_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR20_U_SMXP_1_0, REGION20_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR20_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR20_U_SMXP_1_0, 0x83e158)
    FIELD(POR_MPU_M4_PRLAR20_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR20_U_SMXP_1_0, REGION20_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR20_U_SMXP_1_0, REGION20_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR21_U_SMXP_1_0, 0x83e160)
    FIELD(POR_MPU_M4_PRBAR21_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR21_U_SMXP_1_0, REGION21_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR21_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR21_U_SMXP_1_0, REGION21_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR21_U_SMXP_1_0, REGION21_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR21_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR21_U_SMXP_1_0, 0x83e168)
    FIELD(POR_MPU_M4_PRLAR21_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR21_U_SMXP_1_0, REGION21_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR21_U_SMXP_1_0, REGION21_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR22_U_SMXP_1_0, 0x83e170)
    FIELD(POR_MPU_M4_PRBAR22_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR22_U_SMXP_1_0, REGION22_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR22_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR22_U_SMXP_1_0, REGION22_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR22_U_SMXP_1_0, REGION22_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR22_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR22_U_SMXP_1_0, 0x83e178)
    FIELD(POR_MPU_M4_PRLAR22_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR22_U_SMXP_1_0, REGION22_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR22_U_SMXP_1_0, REGION22_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR23_U_SMXP_1_0, 0x83e180)
    FIELD(POR_MPU_M4_PRBAR23_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR23_U_SMXP_1_0, REGION23_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR23_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR23_U_SMXP_1_0, REGION23_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR23_U_SMXP_1_0, REGION23_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR23_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR23_U_SMXP_1_0, 0x83e188)
    FIELD(POR_MPU_M4_PRLAR23_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR23_U_SMXP_1_0, REGION23_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR23_U_SMXP_1_0, REGION23_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR24_U_SMXP_1_0, 0x83e190)
    FIELD(POR_MPU_M4_PRBAR24_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR24_U_SMXP_1_0, REGION24_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR24_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR24_U_SMXP_1_0, REGION24_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR24_U_SMXP_1_0, REGION24_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR24_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR24_U_SMXP_1_0, 0x83e198)
    FIELD(POR_MPU_M4_PRLAR24_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR24_U_SMXP_1_0, REGION24_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR24_U_SMXP_1_0, REGION24_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR25_U_SMXP_1_0, 0x83e1a0)
    FIELD(POR_MPU_M4_PRBAR25_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR25_U_SMXP_1_0, REGION25_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR25_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR25_U_SMXP_1_0, REGION25_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR25_U_SMXP_1_0, REGION25_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR25_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR25_U_SMXP_1_0, 0x83e1a8)
    FIELD(POR_MPU_M4_PRLAR25_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR25_U_SMXP_1_0, REGION25_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR25_U_SMXP_1_0, REGION25_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR26_U_SMXP_1_0, 0x83e1b0)
    FIELD(POR_MPU_M4_PRBAR26_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR26_U_SMXP_1_0, REGION26_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR26_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR26_U_SMXP_1_0, REGION26_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR26_U_SMXP_1_0, REGION26_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR26_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR26_U_SMXP_1_0, 0x83e1b8)
    FIELD(POR_MPU_M4_PRLAR26_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR26_U_SMXP_1_0, REGION26_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR26_U_SMXP_1_0, REGION26_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR27_U_SMXP_1_0, 0x83e1c0)
    FIELD(POR_MPU_M4_PRBAR27_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR27_U_SMXP_1_0, REGION27_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR27_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR27_U_SMXP_1_0, REGION27_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR27_U_SMXP_1_0, REGION27_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR27_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR27_U_SMXP_1_0, 0x83e1c8)
    FIELD(POR_MPU_M4_PRLAR27_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR27_U_SMXP_1_0, REGION27_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR27_U_SMXP_1_0, REGION27_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR28_U_SMXP_1_0, 0x83e1d0)
    FIELD(POR_MPU_M4_PRBAR28_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR28_U_SMXP_1_0, REGION28_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR28_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR28_U_SMXP_1_0, REGION28_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR28_U_SMXP_1_0, REGION28_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR28_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR28_U_SMXP_1_0, 0x83e1d8)
    FIELD(POR_MPU_M4_PRLAR28_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR28_U_SMXP_1_0, REGION28_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR28_U_SMXP_1_0, REGION28_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR29_U_SMXP_1_0, 0x83e1e0)
    FIELD(POR_MPU_M4_PRBAR29_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR29_U_SMXP_1_0, REGION29_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR29_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR29_U_SMXP_1_0, REGION29_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR29_U_SMXP_1_0, REGION29_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR29_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR29_U_SMXP_1_0, 0x83e1e8)
    FIELD(POR_MPU_M4_PRLAR29_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR29_U_SMXP_1_0, REGION29_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR29_U_SMXP_1_0, REGION29_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR30_U_SMXP_1_0, 0x83e1f0)
    FIELD(POR_MPU_M4_PRBAR30_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR30_U_SMXP_1_0, REGION30_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR30_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR30_U_SMXP_1_0, REGION30_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR30_U_SMXP_1_0, REGION30_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR30_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR30_U_SMXP_1_0, 0x83e1f8)
    FIELD(POR_MPU_M4_PRLAR30_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR30_U_SMXP_1_0, REGION30_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR30_U_SMXP_1_0, REGION30_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR31_U_SMXP_1_0, 0x83e200)
    FIELD(POR_MPU_M4_PRBAR31_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR31_U_SMXP_1_0, REGION31_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR31_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR31_U_SMXP_1_0, REGION31_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR31_U_SMXP_1_0, REGION31_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR31_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR31_U_SMXP_1_0, 0x83e208)
    FIELD(POR_MPU_M4_PRLAR31_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR31_U_SMXP_1_0, REGION31_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR31_U_SMXP_1_0, REGION31_EN, 0, 1)
REG32(POR_MPU_M5_CTL_U_SMXP_1_0, 0x83e400)
    FIELD(POR_MPU_M5_CTL_U_SMXP_1_0, M5_EN, 2, 1)
    FIELD(POR_MPU_M5_CTL_U_SMXP_1_0, M5_ACTION, 0, 2)
REG32(POR_MPU_M5_PRBAR0_U_SMXP_1_0, 0x83e410)
    FIELD(POR_MPU_M5_PRBAR0_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR0_U_SMXP_1_0, REGION0_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR0_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR0_U_SMXP_1_0, REGION0_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR0_U_SMXP_1_0, REGION0_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR0_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR0_U_SMXP_1_0, 0x83e418)
    FIELD(POR_MPU_M5_PRLAR0_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR0_U_SMXP_1_0, REGION0_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR0_U_SMXP_1_0, REGION0_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR1_U_SMXP_1_0, 0x83e420)
    FIELD(POR_MPU_M5_PRBAR1_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR1_U_SMXP_1_0, REGION1_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR1_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR1_U_SMXP_1_0, REGION1_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR1_U_SMXP_1_0, REGION1_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR1_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR1_U_SMXP_1_0, 0x83e428)
    FIELD(POR_MPU_M5_PRLAR1_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR1_U_SMXP_1_0, REGION1_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR1_U_SMXP_1_0, REGION1_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR2_U_SMXP_1_0, 0x83e430)
    FIELD(POR_MPU_M5_PRBAR2_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR2_U_SMXP_1_0, REGION2_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR2_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR2_U_SMXP_1_0, REGION2_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR2_U_SMXP_1_0, REGION2_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR2_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR2_U_SMXP_1_0, 0x83e438)
    FIELD(POR_MPU_M5_PRLAR2_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR2_U_SMXP_1_0, REGION2_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR2_U_SMXP_1_0, REGION2_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR3_U_SMXP_1_0, 0x83e440)
    FIELD(POR_MPU_M5_PRBAR3_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR3_U_SMXP_1_0, REGION3_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR3_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR3_U_SMXP_1_0, REGION3_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR3_U_SMXP_1_0, REGION3_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR3_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR3_U_SMXP_1_0, 0x83e448)
    FIELD(POR_MPU_M5_PRLAR3_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR3_U_SMXP_1_0, REGION3_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR3_U_SMXP_1_0, REGION3_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR4_U_SMXP_1_0, 0x83e450)
    FIELD(POR_MPU_M5_PRBAR4_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR4_U_SMXP_1_0, REGION4_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR4_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR4_U_SMXP_1_0, REGION4_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR4_U_SMXP_1_0, REGION4_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR4_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR4_U_SMXP_1_0, 0x83e458)
    FIELD(POR_MPU_M5_PRLAR4_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR4_U_SMXP_1_0, REGION4_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR4_U_SMXP_1_0, REGION4_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR5_U_SMXP_1_0, 0x83e460)
    FIELD(POR_MPU_M5_PRBAR5_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR5_U_SMXP_1_0, REGION5_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR5_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR5_U_SMXP_1_0, REGION5_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR5_U_SMXP_1_0, REGION5_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR5_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR5_U_SMXP_1_0, 0x83e468)
    FIELD(POR_MPU_M5_PRLAR5_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR5_U_SMXP_1_0, REGION5_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR5_U_SMXP_1_0, REGION5_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR6_U_SMXP_1_0, 0x83e470)
    FIELD(POR_MPU_M5_PRBAR6_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR6_U_SMXP_1_0, REGION6_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR6_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR6_U_SMXP_1_0, REGION6_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR6_U_SMXP_1_0, REGION6_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR6_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR6_U_SMXP_1_0, 0x83e478)
    FIELD(POR_MPU_M5_PRLAR6_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR6_U_SMXP_1_0, REGION6_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR6_U_SMXP_1_0, REGION6_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR7_U_SMXP_1_0, 0x83e480)
    FIELD(POR_MPU_M5_PRBAR7_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR7_U_SMXP_1_0, REGION7_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR7_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR7_U_SMXP_1_0, REGION7_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR7_U_SMXP_1_0, REGION7_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR7_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR7_U_SMXP_1_0, 0x83e488)
    FIELD(POR_MPU_M5_PRLAR7_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR7_U_SMXP_1_0, REGION7_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR7_U_SMXP_1_0, REGION7_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR8_U_SMXP_1_0, 0x83e490)
    FIELD(POR_MPU_M5_PRBAR8_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR8_U_SMXP_1_0, REGION8_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR8_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR8_U_SMXP_1_0, REGION8_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR8_U_SMXP_1_0, REGION8_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR8_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR8_U_SMXP_1_0, 0x83e498)
    FIELD(POR_MPU_M5_PRLAR8_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR8_U_SMXP_1_0, REGION8_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR8_U_SMXP_1_0, REGION8_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR9_U_SMXP_1_0, 0x83e4a0)
    FIELD(POR_MPU_M5_PRBAR9_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR9_U_SMXP_1_0, REGION9_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR9_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR9_U_SMXP_1_0, REGION9_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR9_U_SMXP_1_0, REGION9_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR9_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR9_U_SMXP_1_0, 0x83e4a8)
    FIELD(POR_MPU_M5_PRLAR9_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR9_U_SMXP_1_0, REGION9_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR9_U_SMXP_1_0, REGION9_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR10_U_SMXP_1_0, 0x83e4b0)
    FIELD(POR_MPU_M5_PRBAR10_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR10_U_SMXP_1_0, REGION10_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR10_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR10_U_SMXP_1_0, REGION10_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR10_U_SMXP_1_0, REGION10_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR10_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR10_U_SMXP_1_0, 0x83e4b8)
    FIELD(POR_MPU_M5_PRLAR10_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR10_U_SMXP_1_0, REGION10_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR10_U_SMXP_1_0, REGION10_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR11_U_SMXP_1_0, 0x83e4c0)
    FIELD(POR_MPU_M5_PRBAR11_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR11_U_SMXP_1_0, REGION11_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR11_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR11_U_SMXP_1_0, REGION11_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR11_U_SMXP_1_0, REGION11_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR11_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR11_U_SMXP_1_0, 0x83e4c8)
    FIELD(POR_MPU_M5_PRLAR11_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR11_U_SMXP_1_0, REGION11_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR11_U_SMXP_1_0, REGION11_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR12_U_SMXP_1_0, 0x83e4d0)
    FIELD(POR_MPU_M5_PRBAR12_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR12_U_SMXP_1_0, REGION12_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR12_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR12_U_SMXP_1_0, REGION12_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR12_U_SMXP_1_0, REGION12_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR12_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR12_U_SMXP_1_0, 0x83e4d8)
    FIELD(POR_MPU_M5_PRLAR12_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR12_U_SMXP_1_0, REGION12_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR12_U_SMXP_1_0, REGION12_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR13_U_SMXP_1_0, 0x83e4e0)
    FIELD(POR_MPU_M5_PRBAR13_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR13_U_SMXP_1_0, REGION13_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR13_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR13_U_SMXP_1_0, REGION13_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR13_U_SMXP_1_0, REGION13_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR13_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR13_U_SMXP_1_0, 0x83e4e8)
    FIELD(POR_MPU_M5_PRLAR13_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR13_U_SMXP_1_0, REGION13_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR13_U_SMXP_1_0, REGION13_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR14_U_SMXP_1_0, 0x83e4f0)
    FIELD(POR_MPU_M5_PRBAR14_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR14_U_SMXP_1_0, REGION14_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR14_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR14_U_SMXP_1_0, REGION14_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR14_U_SMXP_1_0, REGION14_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR14_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR14_U_SMXP_1_0, 0x83e4f8)
    FIELD(POR_MPU_M5_PRLAR14_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR14_U_SMXP_1_0, REGION14_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR14_U_SMXP_1_0, REGION14_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR15_U_SMXP_1_0, 0x83e500)
    FIELD(POR_MPU_M5_PRBAR15_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR15_U_SMXP_1_0, REGION15_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR15_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR15_U_SMXP_1_0, REGION15_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR15_U_SMXP_1_0, REGION15_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR15_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR15_U_SMXP_1_0, 0x83e508)
    FIELD(POR_MPU_M5_PRLAR15_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR15_U_SMXP_1_0, REGION15_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR15_U_SMXP_1_0, REGION15_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR16_U_SMXP_1_0, 0x83e510)
    FIELD(POR_MPU_M5_PRBAR16_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR16_U_SMXP_1_0, REGION16_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR16_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR16_U_SMXP_1_0, REGION16_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR16_U_SMXP_1_0, REGION16_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR16_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR16_U_SMXP_1_0, 0x83e518)
    FIELD(POR_MPU_M5_PRLAR16_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR16_U_SMXP_1_0, REGION16_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR16_U_SMXP_1_0, REGION16_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR17_U_SMXP_1_0, 0x83e520)
    FIELD(POR_MPU_M5_PRBAR17_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR17_U_SMXP_1_0, REGION17_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR17_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR17_U_SMXP_1_0, REGION17_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR17_U_SMXP_1_0, REGION17_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR17_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR17_U_SMXP_1_0, 0x83e528)
    FIELD(POR_MPU_M5_PRLAR17_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR17_U_SMXP_1_0, REGION17_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR17_U_SMXP_1_0, REGION17_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR18_U_SMXP_1_0, 0x83e530)
    FIELD(POR_MPU_M5_PRBAR18_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR18_U_SMXP_1_0, REGION18_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR18_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR18_U_SMXP_1_0, REGION18_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR18_U_SMXP_1_0, REGION18_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR18_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR18_U_SMXP_1_0, 0x83e538)
    FIELD(POR_MPU_M5_PRLAR18_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR18_U_SMXP_1_0, REGION18_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR18_U_SMXP_1_0, REGION18_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR19_U_SMXP_1_0, 0x83e540)
    FIELD(POR_MPU_M5_PRBAR19_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR19_U_SMXP_1_0, REGION19_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR19_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR19_U_SMXP_1_0, REGION19_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR19_U_SMXP_1_0, REGION19_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR19_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR19_U_SMXP_1_0, 0x83e548)
    FIELD(POR_MPU_M5_PRLAR19_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR19_U_SMXP_1_0, REGION19_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR19_U_SMXP_1_0, REGION19_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR20_U_SMXP_1_0, 0x83e550)
    FIELD(POR_MPU_M5_PRBAR20_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR20_U_SMXP_1_0, REGION20_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR20_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR20_U_SMXP_1_0, REGION20_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR20_U_SMXP_1_0, REGION20_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR20_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR20_U_SMXP_1_0, 0x83e558)
    FIELD(POR_MPU_M5_PRLAR20_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR20_U_SMXP_1_0, REGION20_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR20_U_SMXP_1_0, REGION20_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR21_U_SMXP_1_0, 0x83e560)
    FIELD(POR_MPU_M5_PRBAR21_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR21_U_SMXP_1_0, REGION21_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR21_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR21_U_SMXP_1_0, REGION21_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR21_U_SMXP_1_0, REGION21_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR21_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR21_U_SMXP_1_0, 0x83e568)
    FIELD(POR_MPU_M5_PRLAR21_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR21_U_SMXP_1_0, REGION21_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR21_U_SMXP_1_0, REGION21_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR22_U_SMXP_1_0, 0x83e570)
    FIELD(POR_MPU_M5_PRBAR22_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR22_U_SMXP_1_0, REGION22_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR22_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR22_U_SMXP_1_0, REGION22_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR22_U_SMXP_1_0, REGION22_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR22_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR22_U_SMXP_1_0, 0x83e578)
    FIELD(POR_MPU_M5_PRLAR22_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR22_U_SMXP_1_0, REGION22_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR22_U_SMXP_1_0, REGION22_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR23_U_SMXP_1_0, 0x83e580)
    FIELD(POR_MPU_M5_PRBAR23_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR23_U_SMXP_1_0, REGION23_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR23_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR23_U_SMXP_1_0, REGION23_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR23_U_SMXP_1_0, REGION23_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR23_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR23_U_SMXP_1_0, 0x83e588)
    FIELD(POR_MPU_M5_PRLAR23_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR23_U_SMXP_1_0, REGION23_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR23_U_SMXP_1_0, REGION23_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR24_U_SMXP_1_0, 0x83e590)
    FIELD(POR_MPU_M5_PRBAR24_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR24_U_SMXP_1_0, REGION24_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR24_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR24_U_SMXP_1_0, REGION24_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR24_U_SMXP_1_0, REGION24_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR24_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR24_U_SMXP_1_0, 0x83e598)
    FIELD(POR_MPU_M5_PRLAR24_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR24_U_SMXP_1_0, REGION24_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR24_U_SMXP_1_0, REGION24_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR25_U_SMXP_1_0, 0x83e5a0)
    FIELD(POR_MPU_M5_PRBAR25_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR25_U_SMXP_1_0, REGION25_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR25_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR25_U_SMXP_1_0, REGION25_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR25_U_SMXP_1_0, REGION25_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR25_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR25_U_SMXP_1_0, 0x83e5a8)
    FIELD(POR_MPU_M5_PRLAR25_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR25_U_SMXP_1_0, REGION25_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR25_U_SMXP_1_0, REGION25_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR26_U_SMXP_1_0, 0x83e5b0)
    FIELD(POR_MPU_M5_PRBAR26_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR26_U_SMXP_1_0, REGION26_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR26_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR26_U_SMXP_1_0, REGION26_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR26_U_SMXP_1_0, REGION26_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR26_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR26_U_SMXP_1_0, 0x83e5b8)
    FIELD(POR_MPU_M5_PRLAR26_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR26_U_SMXP_1_0, REGION26_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR26_U_SMXP_1_0, REGION26_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR27_U_SMXP_1_0, 0x83e5c0)
    FIELD(POR_MPU_M5_PRBAR27_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR27_U_SMXP_1_0, REGION27_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR27_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR27_U_SMXP_1_0, REGION27_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR27_U_SMXP_1_0, REGION27_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR27_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR27_U_SMXP_1_0, 0x83e5c8)
    FIELD(POR_MPU_M5_PRLAR27_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR27_U_SMXP_1_0, REGION27_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR27_U_SMXP_1_0, REGION27_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR28_U_SMXP_1_0, 0x83e5d0)
    FIELD(POR_MPU_M5_PRBAR28_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR28_U_SMXP_1_0, REGION28_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR28_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR28_U_SMXP_1_0, REGION28_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR28_U_SMXP_1_0, REGION28_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR28_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR28_U_SMXP_1_0, 0x83e5d8)
    FIELD(POR_MPU_M5_PRLAR28_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR28_U_SMXP_1_0, REGION28_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR28_U_SMXP_1_0, REGION28_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR29_U_SMXP_1_0, 0x83e5e0)
    FIELD(POR_MPU_M5_PRBAR29_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR29_U_SMXP_1_0, REGION29_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR29_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR29_U_SMXP_1_0, REGION29_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR29_U_SMXP_1_0, REGION29_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR29_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR29_U_SMXP_1_0, 0x83e5e8)
    FIELD(POR_MPU_M5_PRLAR29_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR29_U_SMXP_1_0, REGION29_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR29_U_SMXP_1_0, REGION29_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR30_U_SMXP_1_0, 0x83e5f0)
    FIELD(POR_MPU_M5_PRBAR30_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR30_U_SMXP_1_0, REGION30_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR30_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR30_U_SMXP_1_0, REGION30_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR30_U_SMXP_1_0, REGION30_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR30_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR30_U_SMXP_1_0, 0x83e5f8)
    FIELD(POR_MPU_M5_PRLAR30_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR30_U_SMXP_1_0, REGION30_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR30_U_SMXP_1_0, REGION30_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR31_U_SMXP_1_0, 0x83e600)
    FIELD(POR_MPU_M5_PRBAR31_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR31_U_SMXP_1_0, REGION31_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR31_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR31_U_SMXP_1_0, REGION31_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR31_U_SMXP_1_0, REGION31_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR31_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR31_U_SMXP_1_0, 0x83e608)
    FIELD(POR_MPU_M5_PRLAR31_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR31_U_SMXP_1_0, REGION31_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR31_U_SMXP_1_0, REGION31_EN, 0, 1)
REG32(POR_MPU_M6_CTL_U_SMXP_1_0, 0x83e800)
    FIELD(POR_MPU_M6_CTL_U_SMXP_1_0, M6_EN, 2, 1)
    FIELD(POR_MPU_M6_CTL_U_SMXP_1_0, M6_ACTION, 0, 2)
REG32(POR_MPU_M6_PRBAR0_U_SMXP_1_0, 0x83e810)
    FIELD(POR_MPU_M6_PRBAR0_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR0_U_SMXP_1_0, REGION0_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR0_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR0_U_SMXP_1_0, REGION0_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR0_U_SMXP_1_0, REGION0_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR0_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR0_U_SMXP_1_0, 0x83e818)
    FIELD(POR_MPU_M6_PRLAR0_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR0_U_SMXP_1_0, REGION0_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR0_U_SMXP_1_0, REGION0_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR1_U_SMXP_1_0, 0x83e820)
    FIELD(POR_MPU_M6_PRBAR1_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR1_U_SMXP_1_0, REGION1_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR1_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR1_U_SMXP_1_0, REGION1_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR1_U_SMXP_1_0, REGION1_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR1_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR1_U_SMXP_1_0, 0x83e828)
    FIELD(POR_MPU_M6_PRLAR1_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR1_U_SMXP_1_0, REGION1_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR1_U_SMXP_1_0, REGION1_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR2_U_SMXP_1_0, 0x83e830)
    FIELD(POR_MPU_M6_PRBAR2_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR2_U_SMXP_1_0, REGION2_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR2_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR2_U_SMXP_1_0, REGION2_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR2_U_SMXP_1_0, REGION2_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR2_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR2_U_SMXP_1_0, 0x83e838)
    FIELD(POR_MPU_M6_PRLAR2_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR2_U_SMXP_1_0, REGION2_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR2_U_SMXP_1_0, REGION2_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR3_U_SMXP_1_0, 0x83e840)
    FIELD(POR_MPU_M6_PRBAR3_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR3_U_SMXP_1_0, REGION3_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR3_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR3_U_SMXP_1_0, REGION3_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR3_U_SMXP_1_0, REGION3_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR3_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR3_U_SMXP_1_0, 0x83e848)
    FIELD(POR_MPU_M6_PRLAR3_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR3_U_SMXP_1_0, REGION3_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR3_U_SMXP_1_0, REGION3_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR4_U_SMXP_1_0, 0x83e850)
    FIELD(POR_MPU_M6_PRBAR4_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR4_U_SMXP_1_0, REGION4_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR4_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR4_U_SMXP_1_0, REGION4_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR4_U_SMXP_1_0, REGION4_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR4_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR4_U_SMXP_1_0, 0x83e858)
    FIELD(POR_MPU_M6_PRLAR4_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR4_U_SMXP_1_0, REGION4_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR4_U_SMXP_1_0, REGION4_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR5_U_SMXP_1_0, 0x83e860)
    FIELD(POR_MPU_M6_PRBAR5_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR5_U_SMXP_1_0, REGION5_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR5_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR5_U_SMXP_1_0, REGION5_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR5_U_SMXP_1_0, REGION5_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR5_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR5_U_SMXP_1_0, 0x83e868)
    FIELD(POR_MPU_M6_PRLAR5_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR5_U_SMXP_1_0, REGION5_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR5_U_SMXP_1_0, REGION5_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR6_U_SMXP_1_0, 0x83e870)
    FIELD(POR_MPU_M6_PRBAR6_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR6_U_SMXP_1_0, REGION6_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR6_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR6_U_SMXP_1_0, REGION6_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR6_U_SMXP_1_0, REGION6_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR6_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR6_U_SMXP_1_0, 0x83e878)
    FIELD(POR_MPU_M6_PRLAR6_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR6_U_SMXP_1_0, REGION6_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR6_U_SMXP_1_0, REGION6_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR7_U_SMXP_1_0, 0x83e880)
    FIELD(POR_MPU_M6_PRBAR7_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR7_U_SMXP_1_0, REGION7_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR7_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR7_U_SMXP_1_0, REGION7_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR7_U_SMXP_1_0, REGION7_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR7_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR7_U_SMXP_1_0, 0x83e888)
    FIELD(POR_MPU_M6_PRLAR7_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR7_U_SMXP_1_0, REGION7_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR7_U_SMXP_1_0, REGION7_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR8_U_SMXP_1_0, 0x83e890)
    FIELD(POR_MPU_M6_PRBAR8_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR8_U_SMXP_1_0, REGION8_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR8_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR8_U_SMXP_1_0, REGION8_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR8_U_SMXP_1_0, REGION8_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR8_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR8_U_SMXP_1_0, 0x83e898)
    FIELD(POR_MPU_M6_PRLAR8_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR8_U_SMXP_1_0, REGION8_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR8_U_SMXP_1_0, REGION8_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR9_U_SMXP_1_0, 0x83e8a0)
    FIELD(POR_MPU_M6_PRBAR9_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR9_U_SMXP_1_0, REGION9_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR9_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR9_U_SMXP_1_0, REGION9_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR9_U_SMXP_1_0, REGION9_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR9_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR9_U_SMXP_1_0, 0x83e8a8)
    FIELD(POR_MPU_M6_PRLAR9_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR9_U_SMXP_1_0, REGION9_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR9_U_SMXP_1_0, REGION9_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR10_U_SMXP_1_0, 0x83e8b0)
    FIELD(POR_MPU_M6_PRBAR10_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR10_U_SMXP_1_0, REGION10_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR10_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR10_U_SMXP_1_0, REGION10_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR10_U_SMXP_1_0, REGION10_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR10_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR10_U_SMXP_1_0, 0x83e8b8)
    FIELD(POR_MPU_M6_PRLAR10_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR10_U_SMXP_1_0, REGION10_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR10_U_SMXP_1_0, REGION10_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR11_U_SMXP_1_0, 0x83e8c0)
    FIELD(POR_MPU_M6_PRBAR11_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR11_U_SMXP_1_0, REGION11_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR11_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR11_U_SMXP_1_0, REGION11_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR11_U_SMXP_1_0, REGION11_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR11_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR11_U_SMXP_1_0, 0x83e8c8)
    FIELD(POR_MPU_M6_PRLAR11_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR11_U_SMXP_1_0, REGION11_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR11_U_SMXP_1_0, REGION11_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR12_U_SMXP_1_0, 0x83e8d0)
    FIELD(POR_MPU_M6_PRBAR12_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR12_U_SMXP_1_0, REGION12_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR12_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR12_U_SMXP_1_0, REGION12_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR12_U_SMXP_1_0, REGION12_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR12_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR12_U_SMXP_1_0, 0x83e8d8)
    FIELD(POR_MPU_M6_PRLAR12_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR12_U_SMXP_1_0, REGION12_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR12_U_SMXP_1_0, REGION12_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR13_U_SMXP_1_0, 0x83e8e0)
    FIELD(POR_MPU_M6_PRBAR13_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR13_U_SMXP_1_0, REGION13_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR13_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR13_U_SMXP_1_0, REGION13_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR13_U_SMXP_1_0, REGION13_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR13_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR13_U_SMXP_1_0, 0x83e8e8)
    FIELD(POR_MPU_M6_PRLAR13_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR13_U_SMXP_1_0, REGION13_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR13_U_SMXP_1_0, REGION13_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR14_U_SMXP_1_0, 0x83e8f0)
    FIELD(POR_MPU_M6_PRBAR14_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR14_U_SMXP_1_0, REGION14_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR14_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR14_U_SMXP_1_0, REGION14_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR14_U_SMXP_1_0, REGION14_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR14_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR14_U_SMXP_1_0, 0x83e8f8)
    FIELD(POR_MPU_M6_PRLAR14_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR14_U_SMXP_1_0, REGION14_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR14_U_SMXP_1_0, REGION14_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR15_U_SMXP_1_0, 0x83e900)
    FIELD(POR_MPU_M6_PRBAR15_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR15_U_SMXP_1_0, REGION15_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR15_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR15_U_SMXP_1_0, REGION15_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR15_U_SMXP_1_0, REGION15_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR15_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR15_U_SMXP_1_0, 0x83e908)
    FIELD(POR_MPU_M6_PRLAR15_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR15_U_SMXP_1_0, REGION15_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR15_U_SMXP_1_0, REGION15_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR16_U_SMXP_1_0, 0x83e910)
    FIELD(POR_MPU_M6_PRBAR16_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR16_U_SMXP_1_0, REGION16_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR16_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR16_U_SMXP_1_0, REGION16_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR16_U_SMXP_1_0, REGION16_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR16_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR16_U_SMXP_1_0, 0x83e918)
    FIELD(POR_MPU_M6_PRLAR16_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR16_U_SMXP_1_0, REGION16_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR16_U_SMXP_1_0, REGION16_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR17_U_SMXP_1_0, 0x83e920)
    FIELD(POR_MPU_M6_PRBAR17_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR17_U_SMXP_1_0, REGION17_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR17_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR17_U_SMXP_1_0, REGION17_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR17_U_SMXP_1_0, REGION17_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR17_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR17_U_SMXP_1_0, 0x83e928)
    FIELD(POR_MPU_M6_PRLAR17_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR17_U_SMXP_1_0, REGION17_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR17_U_SMXP_1_0, REGION17_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR18_U_SMXP_1_0, 0x83e930)
    FIELD(POR_MPU_M6_PRBAR18_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR18_U_SMXP_1_0, REGION18_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR18_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR18_U_SMXP_1_0, REGION18_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR18_U_SMXP_1_0, REGION18_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR18_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR18_U_SMXP_1_0, 0x83e938)
    FIELD(POR_MPU_M6_PRLAR18_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR18_U_SMXP_1_0, REGION18_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR18_U_SMXP_1_0, REGION18_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR19_U_SMXP_1_0, 0x83e940)
    FIELD(POR_MPU_M6_PRBAR19_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR19_U_SMXP_1_0, REGION19_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR19_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR19_U_SMXP_1_0, REGION19_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR19_U_SMXP_1_0, REGION19_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR19_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR19_U_SMXP_1_0, 0x83e948)
    FIELD(POR_MPU_M6_PRLAR19_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR19_U_SMXP_1_0, REGION19_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR19_U_SMXP_1_0, REGION19_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR20_U_SMXP_1_0, 0x83e950)
    FIELD(POR_MPU_M6_PRBAR20_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR20_U_SMXP_1_0, REGION20_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR20_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR20_U_SMXP_1_0, REGION20_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR20_U_SMXP_1_0, REGION20_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR20_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR20_U_SMXP_1_0, 0x83e958)
    FIELD(POR_MPU_M6_PRLAR20_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR20_U_SMXP_1_0, REGION20_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR20_U_SMXP_1_0, REGION20_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR21_U_SMXP_1_0, 0x83e960)
    FIELD(POR_MPU_M6_PRBAR21_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR21_U_SMXP_1_0, REGION21_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR21_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR21_U_SMXP_1_0, REGION21_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR21_U_SMXP_1_0, REGION21_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR21_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR21_U_SMXP_1_0, 0x83e968)
    FIELD(POR_MPU_M6_PRLAR21_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR21_U_SMXP_1_0, REGION21_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR21_U_SMXP_1_0, REGION21_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR22_U_SMXP_1_0, 0x83e970)
    FIELD(POR_MPU_M6_PRBAR22_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR22_U_SMXP_1_0, REGION22_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR22_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR22_U_SMXP_1_0, REGION22_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR22_U_SMXP_1_0, REGION22_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR22_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR22_U_SMXP_1_0, 0x83e978)
    FIELD(POR_MPU_M6_PRLAR22_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR22_U_SMXP_1_0, REGION22_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR22_U_SMXP_1_0, REGION22_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR23_U_SMXP_1_0, 0x83e980)
    FIELD(POR_MPU_M6_PRBAR23_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR23_U_SMXP_1_0, REGION23_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR23_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR23_U_SMXP_1_0, REGION23_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR23_U_SMXP_1_0, REGION23_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR23_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR23_U_SMXP_1_0, 0x83e988)
    FIELD(POR_MPU_M6_PRLAR23_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR23_U_SMXP_1_0, REGION23_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR23_U_SMXP_1_0, REGION23_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR24_U_SMXP_1_0, 0x83e990)
    FIELD(POR_MPU_M6_PRBAR24_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR24_U_SMXP_1_0, REGION24_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR24_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR24_U_SMXP_1_0, REGION24_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR24_U_SMXP_1_0, REGION24_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR24_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR24_U_SMXP_1_0, 0x83e998)
    FIELD(POR_MPU_M6_PRLAR24_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR24_U_SMXP_1_0, REGION24_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR24_U_SMXP_1_0, REGION24_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR25_U_SMXP_1_0, 0x83e9a0)
    FIELD(POR_MPU_M6_PRBAR25_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR25_U_SMXP_1_0, REGION25_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR25_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR25_U_SMXP_1_0, REGION25_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR25_U_SMXP_1_0, REGION25_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR25_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR25_U_SMXP_1_0, 0x83e9a8)
    FIELD(POR_MPU_M6_PRLAR25_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR25_U_SMXP_1_0, REGION25_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR25_U_SMXP_1_0, REGION25_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR26_U_SMXP_1_0, 0x83e9b0)
    FIELD(POR_MPU_M6_PRBAR26_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR26_U_SMXP_1_0, REGION26_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR26_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR26_U_SMXP_1_0, REGION26_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR26_U_SMXP_1_0, REGION26_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR26_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR26_U_SMXP_1_0, 0x83e9b8)
    FIELD(POR_MPU_M6_PRLAR26_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR26_U_SMXP_1_0, REGION26_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR26_U_SMXP_1_0, REGION26_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR27_U_SMXP_1_0, 0x83e9c0)
    FIELD(POR_MPU_M6_PRBAR27_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR27_U_SMXP_1_0, REGION27_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR27_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR27_U_SMXP_1_0, REGION27_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR27_U_SMXP_1_0, REGION27_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR27_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR27_U_SMXP_1_0, 0x83e9c8)
    FIELD(POR_MPU_M6_PRLAR27_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR27_U_SMXP_1_0, REGION27_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR27_U_SMXP_1_0, REGION27_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR28_U_SMXP_1_0, 0x83e9d0)
    FIELD(POR_MPU_M6_PRBAR28_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR28_U_SMXP_1_0, REGION28_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR28_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR28_U_SMXP_1_0, REGION28_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR28_U_SMXP_1_0, REGION28_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR28_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR28_U_SMXP_1_0, 0x83e9d8)
    FIELD(POR_MPU_M6_PRLAR28_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR28_U_SMXP_1_0, REGION28_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR28_U_SMXP_1_0, REGION28_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR29_U_SMXP_1_0, 0x83e9e0)
    FIELD(POR_MPU_M6_PRBAR29_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR29_U_SMXP_1_0, REGION29_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR29_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR29_U_SMXP_1_0, REGION29_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR29_U_SMXP_1_0, REGION29_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR29_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR29_U_SMXP_1_0, 0x83e9e8)
    FIELD(POR_MPU_M6_PRLAR29_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR29_U_SMXP_1_0, REGION29_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR29_U_SMXP_1_0, REGION29_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR30_U_SMXP_1_0, 0x83e9f0)
    FIELD(POR_MPU_M6_PRBAR30_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR30_U_SMXP_1_0, REGION30_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR30_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR30_U_SMXP_1_0, REGION30_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR30_U_SMXP_1_0, REGION30_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR30_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR30_U_SMXP_1_0, 0x83e9f8)
    FIELD(POR_MPU_M6_PRLAR30_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR30_U_SMXP_1_0, REGION30_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR30_U_SMXP_1_0, REGION30_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR31_U_SMXP_1_0, 0x83ea00)
    FIELD(POR_MPU_M6_PRBAR31_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR31_U_SMXP_1_0, REGION31_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR31_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR31_U_SMXP_1_0, REGION31_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR31_U_SMXP_1_0, REGION31_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR31_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR31_U_SMXP_1_0, 0x83ea08)
    FIELD(POR_MPU_M6_PRLAR31_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR31_U_SMXP_1_0, REGION31_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR31_U_SMXP_1_0, REGION31_EN, 0, 1)
REG32(POR_MPU_M7_CTL_U_SMXP_1_0, 0x83ec00)
    FIELD(POR_MPU_M7_CTL_U_SMXP_1_0, M7_EN, 2, 1)
    FIELD(POR_MPU_M7_CTL_U_SMXP_1_0, M7_ACTION, 0, 2)
REG32(POR_MPU_M7_PRBAR0_U_SMXP_1_0, 0x83ec10)
    FIELD(POR_MPU_M7_PRBAR0_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR0_U_SMXP_1_0, REGION0_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR0_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR0_U_SMXP_1_0, REGION0_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR0_U_SMXP_1_0, REGION0_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR0_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR0_U_SMXP_1_0, 0x83ec18)
    FIELD(POR_MPU_M7_PRLAR0_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR0_U_SMXP_1_0, REGION0_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR0_U_SMXP_1_0, REGION0_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR1_U_SMXP_1_0, 0x83ec20)
    FIELD(POR_MPU_M7_PRBAR1_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR1_U_SMXP_1_0, REGION1_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR1_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR1_U_SMXP_1_0, REGION1_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR1_U_SMXP_1_0, REGION1_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR1_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR1_U_SMXP_1_0, 0x83ec28)
    FIELD(POR_MPU_M7_PRLAR1_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR1_U_SMXP_1_0, REGION1_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR1_U_SMXP_1_0, REGION1_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR2_U_SMXP_1_0, 0x83ec30)
    FIELD(POR_MPU_M7_PRBAR2_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR2_U_SMXP_1_0, REGION2_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR2_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR2_U_SMXP_1_0, REGION2_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR2_U_SMXP_1_0, REGION2_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR2_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR2_U_SMXP_1_0, 0x83ec38)
    FIELD(POR_MPU_M7_PRLAR2_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR2_U_SMXP_1_0, REGION2_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR2_U_SMXP_1_0, REGION2_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR3_U_SMXP_1_0, 0x83ec40)
    FIELD(POR_MPU_M7_PRBAR3_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR3_U_SMXP_1_0, REGION3_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR3_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR3_U_SMXP_1_0, REGION3_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR3_U_SMXP_1_0, REGION3_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR3_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR3_U_SMXP_1_0, 0x83ec48)
    FIELD(POR_MPU_M7_PRLAR3_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR3_U_SMXP_1_0, REGION3_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR3_U_SMXP_1_0, REGION3_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR4_U_SMXP_1_0, 0x83ec50)
    FIELD(POR_MPU_M7_PRBAR4_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR4_U_SMXP_1_0, REGION4_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR4_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR4_U_SMXP_1_0, REGION4_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR4_U_SMXP_1_0, REGION4_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR4_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR4_U_SMXP_1_0, 0x83ec58)
    FIELD(POR_MPU_M7_PRLAR4_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR4_U_SMXP_1_0, REGION4_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR4_U_SMXP_1_0, REGION4_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR5_U_SMXP_1_0, 0x83ec60)
    FIELD(POR_MPU_M7_PRBAR5_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR5_U_SMXP_1_0, REGION5_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR5_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR5_U_SMXP_1_0, REGION5_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR5_U_SMXP_1_0, REGION5_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR5_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR5_U_SMXP_1_0, 0x83ec68)
    FIELD(POR_MPU_M7_PRLAR5_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR5_U_SMXP_1_0, REGION5_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR5_U_SMXP_1_0, REGION5_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR6_U_SMXP_1_0, 0x83ec70)
    FIELD(POR_MPU_M7_PRBAR6_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR6_U_SMXP_1_0, REGION6_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR6_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR6_U_SMXP_1_0, REGION6_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR6_U_SMXP_1_0, REGION6_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR6_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR6_U_SMXP_1_0, 0x83ec78)
    FIELD(POR_MPU_M7_PRLAR6_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR6_U_SMXP_1_0, REGION6_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR6_U_SMXP_1_0, REGION6_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR7_U_SMXP_1_0, 0x83ec80)
    FIELD(POR_MPU_M7_PRBAR7_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR7_U_SMXP_1_0, REGION7_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR7_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR7_U_SMXP_1_0, REGION7_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR7_U_SMXP_1_0, REGION7_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR7_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR7_U_SMXP_1_0, 0x83ec88)
    FIELD(POR_MPU_M7_PRLAR7_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR7_U_SMXP_1_0, REGION7_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR7_U_SMXP_1_0, REGION7_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR8_U_SMXP_1_0, 0x83ec90)
    FIELD(POR_MPU_M7_PRBAR8_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR8_U_SMXP_1_0, REGION8_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR8_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR8_U_SMXP_1_0, REGION8_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR8_U_SMXP_1_0, REGION8_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR8_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR8_U_SMXP_1_0, 0x83ec98)
    FIELD(POR_MPU_M7_PRLAR8_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR8_U_SMXP_1_0, REGION8_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR8_U_SMXP_1_0, REGION8_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR9_U_SMXP_1_0, 0x83eca0)
    FIELD(POR_MPU_M7_PRBAR9_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR9_U_SMXP_1_0, REGION9_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR9_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR9_U_SMXP_1_0, REGION9_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR9_U_SMXP_1_0, REGION9_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR9_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR9_U_SMXP_1_0, 0x83eca8)
    FIELD(POR_MPU_M7_PRLAR9_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR9_U_SMXP_1_0, REGION9_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR9_U_SMXP_1_0, REGION9_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR10_U_SMXP_1_0, 0x83ecb0)
    FIELD(POR_MPU_M7_PRBAR10_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR10_U_SMXP_1_0, REGION10_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR10_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR10_U_SMXP_1_0, REGION10_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR10_U_SMXP_1_0, REGION10_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR10_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR10_U_SMXP_1_0, 0x83ecb8)
    FIELD(POR_MPU_M7_PRLAR10_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR10_U_SMXP_1_0, REGION10_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR10_U_SMXP_1_0, REGION10_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR11_U_SMXP_1_0, 0x83ecc0)
    FIELD(POR_MPU_M7_PRBAR11_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR11_U_SMXP_1_0, REGION11_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR11_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR11_U_SMXP_1_0, REGION11_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR11_U_SMXP_1_0, REGION11_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR11_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR11_U_SMXP_1_0, 0x83ecc8)
    FIELD(POR_MPU_M7_PRLAR11_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR11_U_SMXP_1_0, REGION11_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR11_U_SMXP_1_0, REGION11_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR12_U_SMXP_1_0, 0x83ecd0)
    FIELD(POR_MPU_M7_PRBAR12_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR12_U_SMXP_1_0, REGION12_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR12_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR12_U_SMXP_1_0, REGION12_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR12_U_SMXP_1_0, REGION12_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR12_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR12_U_SMXP_1_0, 0x83ecd8)
    FIELD(POR_MPU_M7_PRLAR12_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR12_U_SMXP_1_0, REGION12_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR12_U_SMXP_1_0, REGION12_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR13_U_SMXP_1_0, 0x83ece0)
    FIELD(POR_MPU_M7_PRBAR13_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR13_U_SMXP_1_0, REGION13_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR13_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR13_U_SMXP_1_0, REGION13_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR13_U_SMXP_1_0, REGION13_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR13_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR13_U_SMXP_1_0, 0x83ece8)
    FIELD(POR_MPU_M7_PRLAR13_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR13_U_SMXP_1_0, REGION13_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR13_U_SMXP_1_0, REGION13_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR14_U_SMXP_1_0, 0x83ecf0)
    FIELD(POR_MPU_M7_PRBAR14_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR14_U_SMXP_1_0, REGION14_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR14_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR14_U_SMXP_1_0, REGION14_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR14_U_SMXP_1_0, REGION14_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR14_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR14_U_SMXP_1_0, 0x83ecf8)
    FIELD(POR_MPU_M7_PRLAR14_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR14_U_SMXP_1_0, REGION14_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR14_U_SMXP_1_0, REGION14_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR15_U_SMXP_1_0, 0x83ed00)
    FIELD(POR_MPU_M7_PRBAR15_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR15_U_SMXP_1_0, REGION15_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR15_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR15_U_SMXP_1_0, REGION15_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR15_U_SMXP_1_0, REGION15_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR15_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR15_U_SMXP_1_0, 0x83ed08)
    FIELD(POR_MPU_M7_PRLAR15_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR15_U_SMXP_1_0, REGION15_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR15_U_SMXP_1_0, REGION15_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR16_U_SMXP_1_0, 0x83ed10)
    FIELD(POR_MPU_M7_PRBAR16_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR16_U_SMXP_1_0, REGION16_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR16_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR16_U_SMXP_1_0, REGION16_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR16_U_SMXP_1_0, REGION16_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR16_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR16_U_SMXP_1_0, 0x83ed18)
    FIELD(POR_MPU_M7_PRLAR16_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR16_U_SMXP_1_0, REGION16_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR16_U_SMXP_1_0, REGION16_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR17_U_SMXP_1_0, 0x83ed20)
    FIELD(POR_MPU_M7_PRBAR17_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR17_U_SMXP_1_0, REGION17_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR17_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR17_U_SMXP_1_0, REGION17_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR17_U_SMXP_1_0, REGION17_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR17_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR17_U_SMXP_1_0, 0x83ed28)
    FIELD(POR_MPU_M7_PRLAR17_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR17_U_SMXP_1_0, REGION17_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR17_U_SMXP_1_0, REGION17_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR18_U_SMXP_1_0, 0x83ed30)
    FIELD(POR_MPU_M7_PRBAR18_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR18_U_SMXP_1_0, REGION18_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR18_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR18_U_SMXP_1_0, REGION18_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR18_U_SMXP_1_0, REGION18_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR18_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR18_U_SMXP_1_0, 0x83ed38)
    FIELD(POR_MPU_M7_PRLAR18_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR18_U_SMXP_1_0, REGION18_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR18_U_SMXP_1_0, REGION18_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR19_U_SMXP_1_0, 0x83ed40)
    FIELD(POR_MPU_M7_PRBAR19_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR19_U_SMXP_1_0, REGION19_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR19_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR19_U_SMXP_1_0, REGION19_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR19_U_SMXP_1_0, REGION19_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR19_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR19_U_SMXP_1_0, 0x83ed48)
    FIELD(POR_MPU_M7_PRLAR19_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR19_U_SMXP_1_0, REGION19_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR19_U_SMXP_1_0, REGION19_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR20_U_SMXP_1_0, 0x83ed50)
    FIELD(POR_MPU_M7_PRBAR20_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR20_U_SMXP_1_0, REGION20_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR20_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR20_U_SMXP_1_0, REGION20_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR20_U_SMXP_1_0, REGION20_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR20_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR20_U_SMXP_1_0, 0x83ed58)
    FIELD(POR_MPU_M7_PRLAR20_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR20_U_SMXP_1_0, REGION20_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR20_U_SMXP_1_0, REGION20_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR21_U_SMXP_1_0, 0x83ed60)
    FIELD(POR_MPU_M7_PRBAR21_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR21_U_SMXP_1_0, REGION21_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR21_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR21_U_SMXP_1_0, REGION21_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR21_U_SMXP_1_0, REGION21_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR21_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR21_U_SMXP_1_0, 0x83ed68)
    FIELD(POR_MPU_M7_PRLAR21_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR21_U_SMXP_1_0, REGION21_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR21_U_SMXP_1_0, REGION21_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR22_U_SMXP_1_0, 0x83ed70)
    FIELD(POR_MPU_M7_PRBAR22_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR22_U_SMXP_1_0, REGION22_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR22_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR22_U_SMXP_1_0, REGION22_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR22_U_SMXP_1_0, REGION22_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR22_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR22_U_SMXP_1_0, 0x83ed78)
    FIELD(POR_MPU_M7_PRLAR22_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR22_U_SMXP_1_0, REGION22_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR22_U_SMXP_1_0, REGION22_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR23_U_SMXP_1_0, 0x83ed80)
    FIELD(POR_MPU_M7_PRBAR23_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR23_U_SMXP_1_0, REGION23_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR23_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR23_U_SMXP_1_0, REGION23_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR23_U_SMXP_1_0, REGION23_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR23_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR23_U_SMXP_1_0, 0x83ed88)
    FIELD(POR_MPU_M7_PRLAR23_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR23_U_SMXP_1_0, REGION23_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR23_U_SMXP_1_0, REGION23_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR24_U_SMXP_1_0, 0x83ed90)
    FIELD(POR_MPU_M7_PRBAR24_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR24_U_SMXP_1_0, REGION24_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR24_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR24_U_SMXP_1_0, REGION24_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR24_U_SMXP_1_0, REGION24_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR24_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR24_U_SMXP_1_0, 0x83ed98)
    FIELD(POR_MPU_M7_PRLAR24_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR24_U_SMXP_1_0, REGION24_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR24_U_SMXP_1_0, REGION24_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR25_U_SMXP_1_0, 0x83eda0)
    FIELD(POR_MPU_M7_PRBAR25_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR25_U_SMXP_1_0, REGION25_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR25_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR25_U_SMXP_1_0, REGION25_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR25_U_SMXP_1_0, REGION25_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR25_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR25_U_SMXP_1_0, 0x83eda8)
    FIELD(POR_MPU_M7_PRLAR25_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR25_U_SMXP_1_0, REGION25_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR25_U_SMXP_1_0, REGION25_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR26_U_SMXP_1_0, 0x83edb0)
    FIELD(POR_MPU_M7_PRBAR26_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR26_U_SMXP_1_0, REGION26_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR26_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR26_U_SMXP_1_0, REGION26_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR26_U_SMXP_1_0, REGION26_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR26_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR26_U_SMXP_1_0, 0x83edb8)
    FIELD(POR_MPU_M7_PRLAR26_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR26_U_SMXP_1_0, REGION26_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR26_U_SMXP_1_0, REGION26_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR27_U_SMXP_1_0, 0x83edc0)
    FIELD(POR_MPU_M7_PRBAR27_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR27_U_SMXP_1_0, REGION27_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR27_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR27_U_SMXP_1_0, REGION27_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR27_U_SMXP_1_0, REGION27_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR27_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR27_U_SMXP_1_0, 0x83edc8)
    FIELD(POR_MPU_M7_PRLAR27_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR27_U_SMXP_1_0, REGION27_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR27_U_SMXP_1_0, REGION27_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR28_U_SMXP_1_0, 0x83edd0)
    FIELD(POR_MPU_M7_PRBAR28_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR28_U_SMXP_1_0, REGION28_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR28_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR28_U_SMXP_1_0, REGION28_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR28_U_SMXP_1_0, REGION28_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR28_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR28_U_SMXP_1_0, 0x83edd8)
    FIELD(POR_MPU_M7_PRLAR28_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR28_U_SMXP_1_0, REGION28_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR28_U_SMXP_1_0, REGION28_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR29_U_SMXP_1_0, 0x83ede0)
    FIELD(POR_MPU_M7_PRBAR29_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR29_U_SMXP_1_0, REGION29_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR29_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR29_U_SMXP_1_0, REGION29_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR29_U_SMXP_1_0, REGION29_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR29_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR29_U_SMXP_1_0, 0x83ede8)
    FIELD(POR_MPU_M7_PRLAR29_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR29_U_SMXP_1_0, REGION29_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR29_U_SMXP_1_0, REGION29_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR30_U_SMXP_1_0, 0x83edf0)
    FIELD(POR_MPU_M7_PRBAR30_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR30_U_SMXP_1_0, REGION30_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR30_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR30_U_SMXP_1_0, REGION30_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR30_U_SMXP_1_0, REGION30_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR30_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR30_U_SMXP_1_0, 0x83edf8)
    FIELD(POR_MPU_M7_PRLAR30_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR30_U_SMXP_1_0, REGION30_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR30_U_SMXP_1_0, REGION30_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR31_U_SMXP_1_0, 0x83ee00)
    FIELD(POR_MPU_M7_PRBAR31_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR31_U_SMXP_1_0, REGION31_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR31_U_SMXP_1_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR31_U_SMXP_1_0, REGION31_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR31_U_SMXP_1_0, REGION31_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR31_U_SMXP_1_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR31_U_SMXP_1_0, 0x83ee08)
    FIELD(POR_MPU_M7_PRLAR31_U_SMXP_1_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR31_U_SMXP_1_0, REGION31_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR31_U_SMXP_1_0, REGION31_EN, 0, 1)
REG32(POR_HNF_NODE_INFO_U_HNF_NID72, 0x900000)
    FIELD(POR_HNF_NODE_INFO_U_HNF_NID72, RESERVED_48, 48, 16)
    FIELD(POR_HNF_NODE_INFO_U_HNF_NID72, LOGICAL_ID, 32, 16)
    FIELD(POR_HNF_NODE_INFO_U_HNF_NID72, NODE_ID, 16, 16)
    FIELD(POR_HNF_NODE_INFO_U_HNF_NID72, NODE_TYPE, 0, 16)
REG32(POR_HNF_CHILD_INFO_U_HNF_NID72, 0x900080)
    FIELD(POR_HNF_CHILD_INFO_U_HNF_NID72, RESERVED_32, 32, 32)
    FIELD(POR_HNF_CHILD_INFO_U_HNF_NID72, CHILD_PTR_OFFSET, 16, 16)
    FIELD(POR_HNF_CHILD_INFO_U_HNF_NID72, CHILD_COUNT, 0, 16)
REG32(POR_HNF_UNIT_INFO_U_HNF_NID72, 0x900900)
    FIELD(POR_HNF_UNIT_INFO_U_HNF_NID72, RESERVED_39, 39, 25)
    FIELD(POR_HNF_UNIT_INFO_U_HNF_NID72, NUM_POC_ENTRIES, 32, 7)
    FIELD(POR_HNF_UNIT_INFO_U_HNF_NID72, RESERVED_31, 31, 1)
    FIELD(POR_HNF_UNIT_INFO_U_HNF_NID72, NUM_EXCL, 24, 7)
    FIELD(POR_HNF_UNIT_INFO_U_HNF_NID72, RESERVED_23, 23, 1)
    FIELD(POR_HNF_UNIT_INFO_U_HNF_NID72, DATA_RAM_LATENCY, 20, 3)
    FIELD(POR_HNF_UNIT_INFO_U_HNF_NID72, RESERVED_19, 19, 1)
    FIELD(POR_HNF_UNIT_INFO_U_HNF_NID72, TAG_RAM_LAT, 16, 3)
    FIELD(POR_HNF_UNIT_INFO_U_HNF_NID72, RESERVED_13, 13, 3)
    FIELD(POR_HNF_UNIT_INFO_U_HNF_NID72, NUM_WAYS, 8, 5)
    FIELD(POR_HNF_UNIT_INFO_U_HNF_NID72, SF_SIZE, 4, 3)
    FIELD(POR_HNF_UNIT_INFO_U_HNF_NID72, SLC_SIZE, 0, 3)
REG32(POR_HNF_SECURE_REGISTER_GROUPS_OVERRIDE_U_HNF_NID72, 0x900980)
    FIELD(POR_HNF_SECURE_REGISTER_GROUPS_OVERRIDE_U_HNF_NID72, SLCSF_DBGRD, 5, 1)
    FIELD(POR_HNF_SECURE_REGISTER_GROUPS_OVERRIDE_U_HNF_NID72, SAM_CONTROL, 4, 1)
    FIELD(POR_HNF_SECURE_REGISTER_GROUPS_OVERRIDE_U_HNF_NID72, SLC_LOCK_WAYS, 3, 1)
    FIELD(POR_HNF_SECURE_REGISTER_GROUPS_OVERRIDE_U_HNF_NID72, PPU, 2, 1)
    FIELD(POR_HNF_SECURE_REGISTER_GROUPS_OVERRIDE_U_HNF_NID72, CFG_CTL, 1, 1)
    FIELD(POR_HNF_SECURE_REGISTER_GROUPS_OVERRIDE_U_HNF_NID72, QOS, 0, 1)
REG32(POR_HNF_CFG_CTL_U_HNF_NID72, 0x900a00)
    FIELD(POR_HNF_CFG_CTL_U_HNF_NID72, RESERVED_12, 12, 52)
    FIELD(POR_HNF_CFG_CTL_U_HNF_NID72, HNF_DMT_DISABLE, 11, 1)
    FIELD(POR_HNF_CFG_CTL_U_HNF_NID72, HNF_OCM_ALLWAYS_EN, 10, 1)
    FIELD(POR_HNF_CFG_CTL_U_HNF_NID72, HNF_OCM_EN, 9, 1)
    FIELD(POR_HNF_CFG_CTL_U_HNF_NID72, NCDEVCMO_MC_COMP, 8, 1)
    FIELD(POR_HNF_CFG_CTL_U_HNF_NID72, SF_ECC_SCRUB_DISABLE, 6, 1)
    FIELD(POR_HNF_CFG_CTL_U_HNF_NID72, SLC_TAG_ECC_SCRUB_DISABLE, 4, 1)
    FIELD(POR_HNF_CFG_CTL_U_HNF_NID72, POIS_DIS, 2, 1)
    FIELD(POR_HNF_CFG_CTL_U_HNF_NID72, ECC_DISABLE, 0, 1)
REG32(POR_HNF_AUX_CTL_U_HNF_NID72, 0x900a08)
    FIELD(POR_HNF_AUX_CTL_U_HNF_NID72, RESERVED_58, 58, 6)
    FIELD(POR_HNF_AUX_CTL_U_HNF_NID72, SLC_ECC_PIPE_MODE_DIS, 57, 1)
    FIELD(POR_HNF_AUX_CTL_U_HNF_NID72, HNF_ORD_STASH_DATAPULL_EN, 56, 1)
    FIELD(POR_HNF_AUX_CTL_U_HNF_NID72, HNF_SHARED_INTV_DISABLE, 55, 1)
    FIELD(POR_HNF_AUX_CTL_U_HNF_NID72, RESERVED_53, 53, 2)
    FIELD(POR_HNF_AUX_CTL_U_HNF_NID72, HNF_SLC_LRU_DUALMODE_INSERT_VALUE, 51, 2)
    FIELD(POR_HNF_AUX_CTL_U_HNF_NID72, HNF_SLC_LRU_STATICMODE_INSERT_VALUE, 49, 2)
    FIELD(POR_HNF_AUX_CTL_U_HNF_NID72, HNF_SLC_LRU_SLCSRC_INSERT_VALUE, 47, 2)
    FIELD(POR_HNF_AUX_CTL_U_HNF_NID72, HNF_SLC_LRU_SEL_CNT_VALUE, 45, 2)
    FIELD(POR_HNF_AUX_CTL_U_HNF_NID72, HNF_SLC_LRU_SET_GROUPS, 43, 2)
    FIELD(POR_HNF_AUX_CTL_U_HNF_NID72, HNF_SLC_LRU_VICTIM_DISABLE, 42, 1)
    FIELD(POR_HNF_AUX_CTL_U_HNF_NID72, HNF_SLC_VICTIM_QOS_HIGH, 41, 1)
    FIELD(POR_HNF_AUX_CTL_U_HNF_NID72, HNF_SF_SNP_VEC_DISABLE, 40, 1)
    FIELD(POR_HNF_AUX_CTL_U_HNF_NID72, HNF_STASH_DATAPULL_DISABLE, 39, 1)
    FIELD(POR_HNF_AUX_CTL_U_HNF_NID72, RESERVED_37, 37, 2)
    FIELD(POR_HNF_AUX_CTL_U_HNF_NID72, HNF_CU_EXCL_OPT_EN, 36, 1)
    FIELD(POR_HNF_AUX_CTL_U_HNF_NID72, RESERVED_34, 34, 2)
    FIELD(POR_HNF_AUX_CTL_U_HNF_NID72, HNF_EXCL_SNP_FWD_EN, 33, 1)
    FIELD(POR_HNF_AUX_CTL_U_HNF_NID72, HNF_RD_EXCL_OPT_EN, 32, 1)
    FIELD(POR_HNF_AUX_CTL_U_HNF_NID72, RESERVED_17, 17, 15)
    FIELD(POR_HNF_AUX_CTL_U_HNF_NID72, HNF_POISON_INTR_EN, 16, 1)
    FIELD(POR_HNF_AUX_CTL_U_HNF_NID72, HNF_DCT_DISABLE, 15, 1)
    FIELD(POR_HNF_AUX_CTL_U_HNF_NID72, WLU_ALLOC_ON_HIT, 14, 1)
    FIELD(POR_HNF_AUX_CTL_U_HNF_NID72, SF_DISABLE, 13, 1)
    FIELD(POR_HNF_AUX_CTL_U_HNF_NID72, CG_DISABLE, 12, 1)
    FIELD(POR_HNF_AUX_CTL_U_HNF_NID72, SLC_POR_INIT_DISABLE, 11, 1)
    FIELD(POR_HNF_AUX_CTL_U_HNF_NID72, FRZ_MON_ON_OVFL, 10, 1)
    FIELD(POR_HNF_AUX_CTL_U_HNF_NID72, DIS_SEQREQ_COLL, 9, 1)
    FIELD(POR_HNF_AUX_CTL_U_HNF_NID72, DIS_LIKELYSH, 8, 1)
    FIELD(POR_HNF_AUX_CTL_U_HNF_NID72, HNF_STASH_DISABLE, 7, 1)
    FIELD(POR_HNF_AUX_CTL_U_HNF_NID72, DIS_SNP_ONCE, 6, 1)
    FIELD(POR_HNF_AUX_CTL_U_HNF_NID72, NON_SH_NO_ALLOC, 5, 1)
    FIELD(POR_HNF_AUX_CTL_U_HNF_NID72, IO_READ_NO_ALLOC, 4, 1)
    FIELD(POR_HNF_AUX_CTL_U_HNF_NID72, REV_QOS_POOL_ALLOC, 3, 1)
    FIELD(POR_HNF_AUX_CTL_U_HNF_NID72, NO_WU_ALLOC, 2, 1)
    FIELD(POR_HNF_AUX_CTL_U_HNF_NID72, HNF_HONOR_EWA, 1, 1)
    FIELD(POR_HNF_AUX_CTL_U_HNF_NID72, HNF_ONLY_MODE, 0, 1)
REG32(POR_HNF_R2_AUX_CTL_U_HNF_NID72, 0x900a10)
    FIELD(POR_HNF_R2_AUX_CTL_U_HNF_NID72, HNF_SHD_RAM_LSCG_CG_DISABLE, 3, 1)
    FIELD(POR_HNF_R2_AUX_CTL_U_HNF_NID72, HNF_FORCE_FLUSH_EWA0_EN, 2, 1)
    FIELD(POR_HNF_R2_AUX_CTL_U_HNF_NID72, HNF_PCMO_TERMINATE_EN, 1, 1)
    FIELD(POR_HNF_R2_AUX_CTL_U_HNF_NID72, HNF_CHIC_RDNOSNPSEP_DIS, 0, 1)
REG32(RDF_HNF_AUX_CTL_U_HNF_NID72, 0x900a18)
    FIELD(RDF_HNF_AUX_CTL_U_HNF_NID72, RESERVED_16, 16, 48)
    FIELD(RDF_HNF_AUX_CTL_U_HNF_NID72, RDF_1CYCTAG_ECCMODE_OPT_DIS, 15, 1)
    FIELD(RDF_HNF_AUX_CTL_U_HNF_NID72, RESERVED_13, 13, 2)
    FIELD(RDF_HNF_AUX_CTL_U_HNF_NID72, RDF_ALLOW_CLN_DATA_FROM_NO_WR_AP, 12, 1)
    FIELD(RDF_HNF_AUX_CTL_U_HNF_NID72, RESERVED_10, 10, 2)
    FIELD(RDF_HNF_AUX_CTL_U_HNF_NID72, RDF_SNP_MPU_ERR_LOG_EN, 9, 1)
    FIELD(RDF_HNF_AUX_CTL_U_HNF_NID72, RDF_MPU_ERR_LOG_DIS, 8, 1)
    FIELD(RDF_HNF_AUX_CTL_U_HNF_NID72, RESERVED_0, 0, 8)
REG32(POR_HNF_QOS_BAND_U_HNF_NID72, 0x900a80)
    FIELD(POR_HNF_QOS_BAND_U_HNF_NID72, RESERVED_32, 32, 32)
    FIELD(POR_HNF_QOS_BAND_U_HNF_NID72, HIGHHIGH_MAX_QOS_VAL, 28, 4)
    FIELD(POR_HNF_QOS_BAND_U_HNF_NID72, HIGHHIGH_MIN_QOS_VAL, 24, 4)
    FIELD(POR_HNF_QOS_BAND_U_HNF_NID72, HIGH_MAX_QOS_VAL, 20, 4)
    FIELD(POR_HNF_QOS_BAND_U_HNF_NID72, HIGH_MIN_QOS_VAL, 16, 4)
    FIELD(POR_HNF_QOS_BAND_U_HNF_NID72, MED_MAX_QOS_VAL, 12, 4)
    FIELD(POR_HNF_QOS_BAND_U_HNF_NID72, MED_MIN_QOS_VAL, 8, 4)
    FIELD(POR_HNF_QOS_BAND_U_HNF_NID72, LOW_MAX_QOS_VAL, 4, 4)
    FIELD(POR_HNF_QOS_BAND_U_HNF_NID72, LOW_MIN_QOS_VAL, 0, 4)
REG32(POR_HNF_QOS_RESERVATION_U_HNF_NID72, 0x900a88)
    FIELD(POR_HNF_QOS_RESERVATION_U_HNF_NID72, RESERVED_38, 38, 26)
    FIELD(POR_HNF_QOS_RESERVATION_U_HNF_NID72, SEQ_QOS_MAX_CNT, 32, 6)
    FIELD(POR_HNF_QOS_RESERVATION_U_HNF_NID72, RESERVED_30, 30, 2)
    FIELD(POR_HNF_QOS_RESERVATION_U_HNF_NID72, HIGHHIGH_QOS_MAX_CNT, 24, 6)
    FIELD(POR_HNF_QOS_RESERVATION_U_HNF_NID72, RESERVED_22, 22, 2)
    FIELD(POR_HNF_QOS_RESERVATION_U_HNF_NID72, HIGH_QOS_MAX_CNT, 16, 6)
    FIELD(POR_HNF_QOS_RESERVATION_U_HNF_NID72, RESERVED_14, 14, 2)
    FIELD(POR_HNF_QOS_RESERVATION_U_HNF_NID72, MED_QOS_MAX_CNT, 8, 6)
    FIELD(POR_HNF_QOS_RESERVATION_U_HNF_NID72, LOW_QOS_MAX_CNT, 0, 6)
REG32(POR_HNF_RN_STARVATION_U_HNF_NID72, 0x900a90)
    FIELD(POR_HNF_RN_STARVATION_U_HNF_NID72, RESERVED_45, 45, 19)
    FIELD(POR_HNF_RN_STARVATION_U_HNF_NID72, RN_HIGH_OVER_HIGH_HIGH_MAX_CNT, 40, 5)
    FIELD(POR_HNF_RN_STARVATION_U_HNF_NID72, RESERVED_38, 38, 2)
    FIELD(POR_HNF_RN_STARVATION_U_HNF_NID72, RN_MED_OVER_HIGHHIGH_MAX_CNT, 32, 6)
    FIELD(POR_HNF_RN_STARVATION_U_HNF_NID72, RESERVED_29, 29, 3)
    FIELD(POR_HNF_RN_STARVATION_U_HNF_NID72, RN_MED_OVER_HIGH_MAX_CNT, 24, 5)
    FIELD(POR_HNF_RN_STARVATION_U_HNF_NID72, RESERVED_23, 23, 1)
    FIELD(POR_HNF_RN_STARVATION_U_HNF_NID72, RN_LOW_OVER_HIGHHIGH_MAX_CNT, 16, 7)
    FIELD(POR_HNF_RN_STARVATION_U_HNF_NID72, RESERVED_14, 14, 2)
    FIELD(POR_HNF_RN_STARVATION_U_HNF_NID72, RN_LOW_OVER_HIGH_MAX_CNT, 8, 6)
    FIELD(POR_HNF_RN_STARVATION_U_HNF_NID72, RN_LOW_OVER_MED_MAX_CNT, 0, 5)
REG32(POR_HNF_CFG_SLCSF_DBGRD_U_HNF_NID72, 0x900b80)
    FIELD(POR_HNF_CFG_SLCSF_DBGRD_U_HNF_NID72, RESERVED_26, 26, 38)
    FIELD(POR_HNF_CFG_SLCSF_DBGRD_U_HNF_NID72, SLC_ACCESS_COMPONENT, 24, 2)
    FIELD(POR_HNF_CFG_SLCSF_DBGRD_U_HNF_NID72, RESERVED_23, 23, 1)
    FIELD(POR_HNF_CFG_SLCSF_DBGRD_U_HNF_NID72, SLC_ACCESS_DW, 20, 3)
    FIELD(POR_HNF_CFG_SLCSF_DBGRD_U_HNF_NID72, SLC_ACCESS_WAY, 16, 4)
    FIELD(POR_HNF_CFG_SLCSF_DBGRD_U_HNF_NID72, RESERVED_13, 13, 3)
    FIELD(POR_HNF_CFG_SLCSF_DBGRD_U_HNF_NID72, SLC_ACCESS_SET, 0, 13)
REG32(POR_HNF_SLC_CACHE_ACCESS_SLC_TAG_U_HNF_NID72, 0x900b88)
    FIELD(POR_HNF_SLC_CACHE_ACCESS_SLC_TAG_U_HNF_NID72, RESERVED_48, 48, 16)
    FIELD(POR_HNF_SLC_CACHE_ACCESS_SLC_TAG_U_HNF_NID72, SLC_CACHE_ACCESS_SLC_TAG, 0, 48)
REG32(POR_HNF_SLC_CACHE_ACCESS_SLC_DATA_U_HNF_NID72, 0x900b90)
REG32(POR_HNF_SLC_CACHE_ACCESS_SF_TAG_U_HNF_NID72, 0x900b98)
REG32(POR_HNF_SLC_CACHE_ACCESS_SF_TAG1_U_HNF_NID72, 0x900ba0)
REG32(POR_HNF_SLC_CACHE_ACCESS_SF_TAG2_U_HNF_NID72, 0x900ba8)
REG32(POR_HNF_SLC_LOCK_WAYS_U_HNF_NID72, 0x900c00)
    FIELD(POR_HNF_SLC_LOCK_WAYS_U_HNF_NID72, RESERVED_15, 15, 49)
    FIELD(POR_HNF_SLC_LOCK_WAYS_U_HNF_NID72, NUM_HNF, 8, 7)
    FIELD(POR_HNF_SLC_LOCK_WAYS_U_HNF_NID72, WAYS, 0, 4)
REG32(POR_HNF_SLC_LOCK_BASE0_U_HNF_NID72, 0x900c08)
    FIELD(POR_HNF_SLC_LOCK_BASE0_U_HNF_NID72, BASE0_VLD, 63, 1)
    FIELD(POR_HNF_SLC_LOCK_BASE0_U_HNF_NID72, RESERVED_48, 48, 15)
    FIELD(POR_HNF_SLC_LOCK_BASE0_U_HNF_NID72, BASE0, 0, 48)
REG32(POR_HNF_SLC_LOCK_BASE1_U_HNF_NID72, 0x900c10)
    FIELD(POR_HNF_SLC_LOCK_BASE1_U_HNF_NID72, BASE1_VLD, 63, 1)
    FIELD(POR_HNF_SLC_LOCK_BASE1_U_HNF_NID72, RESERVED_48, 48, 15)
    FIELD(POR_HNF_SLC_LOCK_BASE1_U_HNF_NID72, BASE1, 0, 48)
REG32(POR_HNF_SLC_LOCK_BASE2_U_HNF_NID72, 0x900c18)
    FIELD(POR_HNF_SLC_LOCK_BASE2_U_HNF_NID72, BASE2_VLD, 63, 1)
    FIELD(POR_HNF_SLC_LOCK_BASE2_U_HNF_NID72, RESERVED_48, 48, 15)
    FIELD(POR_HNF_SLC_LOCK_BASE2_U_HNF_NID72, BASE2, 0, 48)
REG32(POR_HNF_SLC_LOCK_BASE3_U_HNF_NID72, 0x900c20)
    FIELD(POR_HNF_SLC_LOCK_BASE3_U_HNF_NID72, BASE3_VLD, 63, 1)
    FIELD(POR_HNF_SLC_LOCK_BASE3_U_HNF_NID72, RESERVED_48, 48, 15)
    FIELD(POR_HNF_SLC_LOCK_BASE3_U_HNF_NID72, BASE3, 0, 48)
REG32(POR_HNF_RNF_REGION_VEC1_U_HNF_NID72, 0x900c28)
REG32(POR_HNF_RNI_REGION_VEC_U_HNF_NID72, 0x900c30)
    FIELD(POR_HNF_RNI_REGION_VEC_U_HNF_NID72, RESERVED_32, 32, 32)
    FIELD(POR_HNF_RNI_REGION_VEC_U_HNF_NID72, RNI_REGION_VEC, 0, 32)
REG32(POR_HNF_RNF_REGION_VEC_U_HNF_NID72, 0x900c38)
REG32(POR_HNF_RND_REGION_VEC_U_HNF_NID72, 0x900c40)
    FIELD(POR_HNF_RND_REGION_VEC_U_HNF_NID72, RESERVED_32, 32, 32)
    FIELD(POR_HNF_RND_REGION_VEC_U_HNF_NID72, RND_REGION_VEC, 0, 32)
REG32(POR_HNF_SLCWAY_PARTITION0_RNF_VEC_U_HNF_NID72, 0x900c48)
REG32(POR_HNF_SLCWAY_PARTITION1_RNF_VEC_U_HNF_NID72, 0x900c50)
REG32(POR_HNF_SLCWAY_PARTITION2_RNF_VEC_U_HNF_NID72, 0x900c58)
REG32(POR_HNF_SLCWAY_PARTITION3_RNF_VEC_U_HNF_NID72, 0x900c60)
REG32(POR_HNF_SLCWAY_PARTITION0_RNI_VEC_U_HNF_NID72, 0x900c68)
    FIELD(POR_HNF_SLCWAY_PARTITION0_RNI_VEC_U_HNF_NID72, RESERVED_32, 32, 32)
    FIELD(POR_HNF_SLCWAY_PARTITION0_RNI_VEC_U_HNF_NID72, RNI_VEC0, 0, 32)
REG32(POR_HNF_SLCWAY_PARTITION1_RNI_VEC_U_HNF_NID72, 0x900c70)
    FIELD(POR_HNF_SLCWAY_PARTITION1_RNI_VEC_U_HNF_NID72, RESERVED_32, 32, 32)
    FIELD(POR_HNF_SLCWAY_PARTITION1_RNI_VEC_U_HNF_NID72, RNI_VEC1, 0, 32)
REG32(POR_HNF_SLCWAY_PARTITION2_RNI_VEC_U_HNF_NID72, 0x900c78)
    FIELD(POR_HNF_SLCWAY_PARTITION2_RNI_VEC_U_HNF_NID72, RESERVED_32, 32, 32)
    FIELD(POR_HNF_SLCWAY_PARTITION2_RNI_VEC_U_HNF_NID72, RNI_VEC2, 0, 32)
REG32(POR_HNF_SLCWAY_PARTITION3_RNI_VEC_U_HNF_NID72, 0x900c80)
    FIELD(POR_HNF_SLCWAY_PARTITION3_RNI_VEC_U_HNF_NID72, RESERVED_32, 32, 32)
    FIELD(POR_HNF_SLCWAY_PARTITION3_RNI_VEC_U_HNF_NID72, RNI_VEC3, 0, 32)
REG32(POR_HNF_SLCWAY_PARTITION0_RND_VEC_U_HNF_NID72, 0x900c88)
    FIELD(POR_HNF_SLCWAY_PARTITION0_RND_VEC_U_HNF_NID72, RESERVED_32, 32, 32)
    FIELD(POR_HNF_SLCWAY_PARTITION0_RND_VEC_U_HNF_NID72, RND_VEC0, 0, 32)
REG32(POR_HNF_SLCWAY_PARTITION1_RND_VEC_U_HNF_NID72, 0x900c90)
    FIELD(POR_HNF_SLCWAY_PARTITION1_RND_VEC_U_HNF_NID72, RESERVED_32, 32, 32)
    FIELD(POR_HNF_SLCWAY_PARTITION1_RND_VEC_U_HNF_NID72, RND_VEC1, 0, 32)
REG32(POR_HNF_SLCWAY_PARTITION2_RND_VEC_U_HNF_NID72, 0x900c98)
    FIELD(POR_HNF_SLCWAY_PARTITION2_RND_VEC_U_HNF_NID72, RESERVED_32, 32, 32)
    FIELD(POR_HNF_SLCWAY_PARTITION2_RND_VEC_U_HNF_NID72, RND_VEC2, 0, 32)
REG32(POR_HNF_SLCWAY_PARTITION3_RND_VEC_U_HNF_NID72, 0x900ca0)
    FIELD(POR_HNF_SLCWAY_PARTITION3_RND_VEC_U_HNF_NID72, RESERVED_32, 32, 32)
    FIELD(POR_HNF_SLCWAY_PARTITION3_RND_VEC_U_HNF_NID72, RND_VEC3, 0, 32)
REG32(POR_HNF_RN_REGION_LOCK_U_HNF_NID72, 0x900ca8)
    FIELD(POR_HNF_RN_REGION_LOCK_U_HNF_NID72, RN_PICK_LOCKED_WAYS_ONLY, 1, 1)
    FIELD(POR_HNF_RN_REGION_LOCK_U_HNF_NID72, RN_REGION_LOCK_EN, 0, 1)
REG32(POR_HNF_SLCWAY_PARTITION0_RNF_VEC1_U_HNF_NID72, 0x900cb0)
REG32(POR_HNF_SLCWAY_PARTITION1_RNF_VEC1_U_HNF_NID72, 0x900cb8)
REG32(POR_HNF_SLCWAY_PARTITION2_RNF_VEC1_U_HNF_NID72, 0x900cc0)
REG32(POR_HNF_SLCWAY_PARTITION3_RNF_VEC1_U_HNF_NID72, 0x900cc8)
REG32(POR_HNF_SAM_CONTROL_U_HNF_NID72, 0x900d00)
    FIELD(POR_HNF_SAM_CONTROL_U_HNF_NID72, HN_CFG_SAM_INV_TOP_ADDRESS_BIT, 63, 1)
    FIELD(POR_HNF_SAM_CONTROL_U_HNF_NID72, RESERVED_62, 62, 1)
    FIELD(POR_HNF_SAM_CONTROL_U_HNF_NID72, HN_CFG_SAM_TOP_ADDRESS_BIT2, 56, 6)
    FIELD(POR_HNF_SAM_CONTROL_U_HNF_NID72, RESERVED_54, 54, 2)
    FIELD(POR_HNF_SAM_CONTROL_U_HNF_NID72, HN_CFG_SAM_TOP_ADDRESS_BIT1, 48, 6)
    FIELD(POR_HNF_SAM_CONTROL_U_HNF_NID72, RESERVED_46, 46, 2)
    FIELD(POR_HNF_SAM_CONTROL_U_HNF_NID72, HN_CFG_SAM_TOP_ADDRESS_BIT0, 40, 6)
    FIELD(POR_HNF_SAM_CONTROL_U_HNF_NID72, RESERVED_38, 38, 2)
    FIELD(POR_HNF_SAM_CONTROL_U_HNF_NID72, HN_CFG_SIX_SN_EN, 37, 1)
    FIELD(POR_HNF_SAM_CONTROL_U_HNF_NID72, HN_CFG_THREE_SN_EN, 36, 1)
    FIELD(POR_HNF_SAM_CONTROL_U_HNF_NID72, RESERVED_35, 35, 1)
    FIELD(POR_HNF_SAM_CONTROL_U_HNF_NID72, HN_CFG_SN2_NODEID, 24, 11)
    FIELD(POR_HNF_SAM_CONTROL_U_HNF_NID72, RESERVED_23, 23, 1)
    FIELD(POR_HNF_SAM_CONTROL_U_HNF_NID72, HN_CFG_SN1_NODEID, 12, 11)
    FIELD(POR_HNF_SAM_CONTROL_U_HNF_NID72, RESERVED_11, 11, 1)
    FIELD(POR_HNF_SAM_CONTROL_U_HNF_NID72, HN_CFG_SN0_NODEID, 0, 11)
REG32(POR_HNF_SAM_MEMREGION0_U_HNF_NID72, 0x900d08)
    FIELD(POR_HNF_SAM_MEMREGION0_U_HNF_NID72, VALID, 63, 1)
    FIELD(POR_HNF_SAM_MEMREGION0_U_HNF_NID72, RESERVED_48, 48, 15)
    FIELD(POR_HNF_SAM_MEMREGION0_U_HNF_NID72, BASE_ADDR, 26, 22)
    FIELD(POR_HNF_SAM_MEMREGION0_U_HNF_NID72, RESERVED_17, 17, 9)
    FIELD(POR_HNF_SAM_MEMREGION0_U_HNF_NID72, SIZE, 12, 5)
    FIELD(POR_HNF_SAM_MEMREGION0_U_HNF_NID72, RESERVED_11, 11, 1)
    FIELD(POR_HNF_SAM_MEMREGION0_U_HNF_NID72, RANGE0_NODEID, 0, 11)
REG32(POR_HNF_SAM_MEMREGION1_U_HNF_NID72, 0x900d10)
    FIELD(POR_HNF_SAM_MEMREGION1_U_HNF_NID72, VALID, 63, 1)
    FIELD(POR_HNF_SAM_MEMREGION1_U_HNF_NID72, RESERVED_48, 48, 15)
    FIELD(POR_HNF_SAM_MEMREGION1_U_HNF_NID72, BASE_ADDR, 26, 22)
    FIELD(POR_HNF_SAM_MEMREGION1_U_HNF_NID72, RESERVED_17, 17, 9)
    FIELD(POR_HNF_SAM_MEMREGION1_U_HNF_NID72, SIZE, 12, 5)
    FIELD(POR_HNF_SAM_MEMREGION1_U_HNF_NID72, RESERVED_11, 11, 1)
    FIELD(POR_HNF_SAM_MEMREGION1_U_HNF_NID72, RANGE1_NODEID, 0, 11)
REG32(POR_HNF_SAM_SN_PROPERTIES_U_HNF_NID72, 0x900d18)
    FIELD(POR_HNF_SAM_SN_PROPERTIES_U_HNF_NID72, RESERVED_45, 45, 19)
    FIELD(POR_HNF_SAM_SN_PROPERTIES_U_HNF_NID72, RANGE1_SN_PCMO_PROP_DIS, 44, 1)
    FIELD(POR_HNF_SAM_SN_PROPERTIES_U_HNF_NID72, RANGE1_SN_CMO_PROP_EN, 43, 1)
    FIELD(POR_HNF_SAM_SN_PROPERTIES_U_HNF_NID72, RANGE1_SN_128B, 42, 1)
    FIELD(POR_HNF_SAM_SN_PROPERTIES_U_HNF_NID72, RESERVED_39, 39, 3)
    FIELD(POR_HNF_SAM_SN_PROPERTIES_U_HNF_NID72, RANGE0_SN_PCMO_PROP_DIS, 38, 1)
    FIELD(POR_HNF_SAM_SN_PROPERTIES_U_HNF_NID72, RANGE0_SN_CMO_PROP_EN, 37, 1)
    FIELD(POR_HNF_SAM_SN_PROPERTIES_U_HNF_NID72, RANGE0_SN_128B, 36, 1)
    FIELD(POR_HNF_SAM_SN_PROPERTIES_U_HNF_NID72, RESERVED_33, 33, 3)
    FIELD(POR_HNF_SAM_SN_PROPERTIES_U_HNF_NID72, SN5_PCMO_PROP_DIS, 32, 1)
    FIELD(POR_HNF_SAM_SN_PROPERTIES_U_HNF_NID72, SN5_CMO_PROP_EN, 31, 1)
    FIELD(POR_HNF_SAM_SN_PROPERTIES_U_HNF_NID72, SN5_128B, 30, 1)
    FIELD(POR_HNF_SAM_SN_PROPERTIES_U_HNF_NID72, RESERVED_27, 27, 3)
    FIELD(POR_HNF_SAM_SN_PROPERTIES_U_HNF_NID72, SN4_PCMO_PROP_DIS, 26, 1)
    FIELD(POR_HNF_SAM_SN_PROPERTIES_U_HNF_NID72, SN4_CMO_PROP_EN, 25, 1)
    FIELD(POR_HNF_SAM_SN_PROPERTIES_U_HNF_NID72, SN4_128B, 24, 1)
    FIELD(POR_HNF_SAM_SN_PROPERTIES_U_HNF_NID72, RESERVED_21, 21, 3)
    FIELD(POR_HNF_SAM_SN_PROPERTIES_U_HNF_NID72, SN3_PCMO_PROP_DIS, 20, 1)
    FIELD(POR_HNF_SAM_SN_PROPERTIES_U_HNF_NID72, SN3_CMO_PROP_EN, 19, 1)
    FIELD(POR_HNF_SAM_SN_PROPERTIES_U_HNF_NID72, SN3_128B, 18, 1)
    FIELD(POR_HNF_SAM_SN_PROPERTIES_U_HNF_NID72, RESERVED_15, 15, 3)
    FIELD(POR_HNF_SAM_SN_PROPERTIES_U_HNF_NID72, SN2_PCMO_PROP_DIS, 14, 1)
    FIELD(POR_HNF_SAM_SN_PROPERTIES_U_HNF_NID72, SN2_CMO_PROP_EN, 13, 1)
    FIELD(POR_HNF_SAM_SN_PROPERTIES_U_HNF_NID72, SN2_128B, 12, 1)
    FIELD(POR_HNF_SAM_SN_PROPERTIES_U_HNF_NID72, RESERVED_9, 9, 3)
    FIELD(POR_HNF_SAM_SN_PROPERTIES_U_HNF_NID72, SN1_PCMO_PROP_DIS, 8, 1)
    FIELD(POR_HNF_SAM_SN_PROPERTIES_U_HNF_NID72, SN1_CMO_PROP_EN, 7, 1)
    FIELD(POR_HNF_SAM_SN_PROPERTIES_U_HNF_NID72, SN1_128B, 6, 1)
    FIELD(POR_HNF_SAM_SN_PROPERTIES_U_HNF_NID72, SN0_PCMO_PROP_DIS, 2, 1)
    FIELD(POR_HNF_SAM_SN_PROPERTIES_U_HNF_NID72, SN0_CMO_PROP_EN, 1, 1)
    FIELD(POR_HNF_SAM_SN_PROPERTIES_U_HNF_NID72, SN0_128B, 0, 1)
REG32(POR_HNF_SAM_6SN_NODEID_U_HNF_NID72, 0x900d20)
    FIELD(POR_HNF_SAM_6SN_NODEID_U_HNF_NID72, RESERVED_35, 35, 29)
    FIELD(POR_HNF_SAM_6SN_NODEID_U_HNF_NID72, HN_CFG_SN5_NODEID, 24, 11)
    FIELD(POR_HNF_SAM_6SN_NODEID_U_HNF_NID72, RESERVED_23, 23, 1)
    FIELD(POR_HNF_SAM_6SN_NODEID_U_HNF_NID72, HN_CFG_SN4_NODEID, 12, 11)
    FIELD(POR_HNF_SAM_6SN_NODEID_U_HNF_NID72, RESERVED_11, 11, 1)
    FIELD(POR_HNF_SAM_6SN_NODEID_U_HNF_NID72, HN_CFG_SN3_NODEID, 0, 11)
REG32(POR_HNF_RN_PHYS_ID0_U_HNF_NID72, 0x900d28)
    FIELD(POR_HNF_RN_PHYS_ID0_U_HNF_NID72, VALID_RA1, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID0_U_HNF_NID72, CPA_EN_RA1, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID0_U_HNF_NID72, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID0_U_HNF_NID72, CPA_GRP_RA1, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID0_U_HNF_NID72, REMOTE_RA1, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID0_U_HNF_NID72, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID0_U_HNF_NID72, NODEID_RA1, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID0_U_HNF_NID72, VALID_RA0, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID0_U_HNF_NID72, CPA_EN_RA0, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID0_U_HNF_NID72, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID0_U_HNF_NID72, CPA_GRP_RA0, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID0_U_HNF_NID72, REMOTE_RA0, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID0_U_HNF_NID72, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID0_U_HNF_NID72, NODEID_RA0, 0, 11)
REG32(POR_HNF_RN_PHYS_ID1_U_HNF_NID72, 0x900d30)
    FIELD(POR_HNF_RN_PHYS_ID1_U_HNF_NID72, VALID_RA3, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID1_U_HNF_NID72, CPA_EN_RA3, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID1_U_HNF_NID72, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID1_U_HNF_NID72, CPA_GRP_RA3, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID1_U_HNF_NID72, REMOTE_RA3, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID1_U_HNF_NID72, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID1_U_HNF_NID72, NODEID_RA3, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID1_U_HNF_NID72, VALID_RA2, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID1_U_HNF_NID72, CPA_EN_RA2, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID1_U_HNF_NID72, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID1_U_HNF_NID72, CPA_GRP_RA2, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID1_U_HNF_NID72, REMOTE_RA2, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID1_U_HNF_NID72, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID1_U_HNF_NID72, NODEID_RA2, 0, 11)
REG32(POR_HNF_RN_PHYS_ID2_U_HNF_NID72, 0x900d38)
    FIELD(POR_HNF_RN_PHYS_ID2_U_HNF_NID72, VALID_RA5, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID2_U_HNF_NID72, CPA_EN_RA5, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID2_U_HNF_NID72, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID2_U_HNF_NID72, CPA_GRP_RA5, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID2_U_HNF_NID72, REMOTE_RA5, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID2_U_HNF_NID72, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID2_U_HNF_NID72, NODEID_RA5, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID2_U_HNF_NID72, VALID_RA4, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID2_U_HNF_NID72, CPA_EN_RA4, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID2_U_HNF_NID72, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID2_U_HNF_NID72, CPA_GRP_RA4, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID2_U_HNF_NID72, REMOTE_RA4, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID2_U_HNF_NID72, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID2_U_HNF_NID72, NODEID_RA4, 0, 11)
REG32(POR_HNF_RN_PHYS_ID3_U_HNF_NID72, 0x900d40)
    FIELD(POR_HNF_RN_PHYS_ID3_U_HNF_NID72, VALID_RA7, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID3_U_HNF_NID72, CPA_EN_RA7, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID3_U_HNF_NID72, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID3_U_HNF_NID72, CPA_GRP_RA7, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID3_U_HNF_NID72, REMOTE_RA7, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID3_U_HNF_NID72, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID3_U_HNF_NID72, NODEID_RA7, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID3_U_HNF_NID72, VALID_RA6, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID3_U_HNF_NID72, CPA_EN_RA6, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID3_U_HNF_NID72, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID3_U_HNF_NID72, CPA_GRP_RA6, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID3_U_HNF_NID72, REMOTE_RA6, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID3_U_HNF_NID72, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID3_U_HNF_NID72, NODEID_RA6, 0, 11)
REG32(POR_HNF_RN_PHYS_ID4_U_HNF_NID72, 0x900d48)
    FIELD(POR_HNF_RN_PHYS_ID4_U_HNF_NID72, VALID_RA9, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID4_U_HNF_NID72, CPA_EN_RA9, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID4_U_HNF_NID72, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID4_U_HNF_NID72, CPA_GRP_RA9, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID4_U_HNF_NID72, REMOTE_RA9, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID4_U_HNF_NID72, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID4_U_HNF_NID72, NODEID_RA9, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID4_U_HNF_NID72, VALID_RA8, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID4_U_HNF_NID72, CPA_EN_RA8, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID4_U_HNF_NID72, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID4_U_HNF_NID72, CPA_GRP_RA8, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID4_U_HNF_NID72, REMOTE_RA8, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID4_U_HNF_NID72, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID4_U_HNF_NID72, NODEID_RA8, 0, 11)
REG32(POR_HNF_RN_PHYS_ID5_U_HNF_NID72, 0x900d50)
    FIELD(POR_HNF_RN_PHYS_ID5_U_HNF_NID72, VALID_RA11, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID5_U_HNF_NID72, CPA_EN_RA11, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID5_U_HNF_NID72, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID5_U_HNF_NID72, CPA_GRP_RA11, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID5_U_HNF_NID72, REMOTE_RA11, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID5_U_HNF_NID72, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID5_U_HNF_NID72, NODEID_RA11, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID5_U_HNF_NID72, VALID_RA10, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID5_U_HNF_NID72, CPA_EN_RA10, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID5_U_HNF_NID72, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID5_U_HNF_NID72, CPA_GRP_RA10, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID5_U_HNF_NID72, REMOTE_RA10, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID5_U_HNF_NID72, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID5_U_HNF_NID72, NODEID_RA10, 0, 11)
REG32(POR_HNF_RN_PHYS_ID6_U_HNF_NID72, 0x900d58)
    FIELD(POR_HNF_RN_PHYS_ID6_U_HNF_NID72, VALID_RA13, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID6_U_HNF_NID72, CPA_EN_RA13, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID6_U_HNF_NID72, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID6_U_HNF_NID72, CPA_GRP_RA13, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID6_U_HNF_NID72, REMOTE_RA13, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID6_U_HNF_NID72, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID6_U_HNF_NID72, NODEID_RA13, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID6_U_HNF_NID72, VALID_RA12, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID6_U_HNF_NID72, CPA_EN_RA12, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID6_U_HNF_NID72, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID6_U_HNF_NID72, CPA_GRP_RA12, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID6_U_HNF_NID72, REMOTE_RA12, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID6_U_HNF_NID72, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID6_U_HNF_NID72, NODEID_RA12, 0, 11)
REG32(POR_HNF_RN_PHYS_ID7_U_HNF_NID72, 0x900d60)
    FIELD(POR_HNF_RN_PHYS_ID7_U_HNF_NID72, VALID_RA15, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID7_U_HNF_NID72, CPA_EN_RA15, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID7_U_HNF_NID72, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID7_U_HNF_NID72, CPA_GRP_RA15, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID7_U_HNF_NID72, REMOTE_RA15, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID7_U_HNF_NID72, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID7_U_HNF_NID72, NODEID_RA15, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID7_U_HNF_NID72, VALID_RA14, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID7_U_HNF_NID72, CPA_EN_RA14, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID7_U_HNF_NID72, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID7_U_HNF_NID72, CPA_GRP_RA14, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID7_U_HNF_NID72, REMOTE_RA14, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID7_U_HNF_NID72, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID7_U_HNF_NID72, NODEID_RA14, 0, 11)
REG32(POR_HNF_RN_PHYS_ID8_U_HNF_NID72, 0x900d68)
    FIELD(POR_HNF_RN_PHYS_ID8_U_HNF_NID72, VALID_RA17, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID8_U_HNF_NID72, CPA_EN_RA17, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID8_U_HNF_NID72, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID8_U_HNF_NID72, CPA_GRP_RA17, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID8_U_HNF_NID72, REMOTE_RA17, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID8_U_HNF_NID72, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID8_U_HNF_NID72, NODEID_RA17, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID8_U_HNF_NID72, VALID_RA16, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID8_U_HNF_NID72, CPA_EN_RA16, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID8_U_HNF_NID72, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID8_U_HNF_NID72, CPA_GRP_RA16, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID8_U_HNF_NID72, REMOTE_RA16, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID8_U_HNF_NID72, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID8_U_HNF_NID72, NODEID_RA16, 0, 11)
REG32(POR_HNF_RN_PHYS_ID9_U_HNF_NID72, 0x900d70)
    FIELD(POR_HNF_RN_PHYS_ID9_U_HNF_NID72, VALID_RA19, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID9_U_HNF_NID72, CPA_EN_RA19, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID9_U_HNF_NID72, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID9_U_HNF_NID72, CPA_GRP_RA19, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID9_U_HNF_NID72, REMOTE_RA19, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID9_U_HNF_NID72, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID9_U_HNF_NID72, NODEID_RA19, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID9_U_HNF_NID72, VALID_RA18, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID9_U_HNF_NID72, CPA_EN_RA18, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID9_U_HNF_NID72, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID9_U_HNF_NID72, CPA_GRP_RA18, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID9_U_HNF_NID72, REMOTE_RA18, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID9_U_HNF_NID72, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID9_U_HNF_NID72, NODEID_RA18, 0, 11)
REG32(POR_HNF_RN_PHYS_ID10_U_HNF_NID72, 0x900d78)
    FIELD(POR_HNF_RN_PHYS_ID10_U_HNF_NID72, VALID_RA21, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID10_U_HNF_NID72, CPA_EN_RA21, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID10_U_HNF_NID72, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID10_U_HNF_NID72, CPA_GRP_RA21, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID10_U_HNF_NID72, REMOTE_RA21, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID10_U_HNF_NID72, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID10_U_HNF_NID72, NODEID_RA21, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID10_U_HNF_NID72, VALID_RA20, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID10_U_HNF_NID72, CPA_EN_RA20, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID10_U_HNF_NID72, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID10_U_HNF_NID72, CPA_GRP_RA20, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID10_U_HNF_NID72, REMOTE_RA20, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID10_U_HNF_NID72, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID10_U_HNF_NID72, NODEID_RA20, 0, 11)
REG32(POR_HNF_RN_PHYS_ID11_U_HNF_NID72, 0x900d80)
    FIELD(POR_HNF_RN_PHYS_ID11_U_HNF_NID72, VALID_RA23, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID11_U_HNF_NID72, CPA_EN_RA23, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID11_U_HNF_NID72, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID11_U_HNF_NID72, CPA_GRP_RA23, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID11_U_HNF_NID72, REMOTE_RA23, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID11_U_HNF_NID72, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID11_U_HNF_NID72, NODEID_RA23, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID11_U_HNF_NID72, VALID_RA22, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID11_U_HNF_NID72, CPA_EN_RA22, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID11_U_HNF_NID72, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID11_U_HNF_NID72, CPA_GRP_RA22, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID11_U_HNF_NID72, REMOTE_RA22, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID11_U_HNF_NID72, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID11_U_HNF_NID72, NODEID_RA22, 0, 11)
REG32(POR_HNF_RN_PHYS_ID12_U_HNF_NID72, 0x900d88)
    FIELD(POR_HNF_RN_PHYS_ID12_U_HNF_NID72, VALID_RA25, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID12_U_HNF_NID72, CPA_EN_RA25, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID12_U_HNF_NID72, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID12_U_HNF_NID72, CPA_GRP_RA25, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID12_U_HNF_NID72, REMOTE_RA25, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID12_U_HNF_NID72, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID12_U_HNF_NID72, NODEID_RA25, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID12_U_HNF_NID72, VALID_RA24, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID12_U_HNF_NID72, CPA_EN_RA24, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID12_U_HNF_NID72, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID12_U_HNF_NID72, CPA_GRP_RA24, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID12_U_HNF_NID72, REMOTE_RA24, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID12_U_HNF_NID72, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID12_U_HNF_NID72, NODEID_RA24, 0, 11)
REG32(POR_HNF_RN_PHYS_ID13_U_HNF_NID72, 0x900d90)
    FIELD(POR_HNF_RN_PHYS_ID13_U_HNF_NID72, VALID_RA27, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID13_U_HNF_NID72, CPA_EN_RA27, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID13_U_HNF_NID72, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID13_U_HNF_NID72, CPA_GRP_RA27, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID13_U_HNF_NID72, REMOTE_RA27, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID13_U_HNF_NID72, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID13_U_HNF_NID72, NODEID_RA27, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID13_U_HNF_NID72, VALID_RA26, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID13_U_HNF_NID72, CPA_EN_RA26, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID13_U_HNF_NID72, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID13_U_HNF_NID72, CPA_GRP_RA26, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID13_U_HNF_NID72, REMOTE_RA26, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID13_U_HNF_NID72, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID13_U_HNF_NID72, NODEID_RA26, 0, 11)
REG32(POR_HNF_RN_PHYS_ID14_U_HNF_NID72, 0x900d98)
    FIELD(POR_HNF_RN_PHYS_ID14_U_HNF_NID72, VALID_RA29, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID14_U_HNF_NID72, CPA_EN_RA29, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID14_U_HNF_NID72, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID14_U_HNF_NID72, CPA_GRP_RA29, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID14_U_HNF_NID72, REMOTE_RA29, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID14_U_HNF_NID72, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID14_U_HNF_NID72, NODEID_RA29, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID14_U_HNF_NID72, VALID_RA28, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID14_U_HNF_NID72, CPA_EN_RA28, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID14_U_HNF_NID72, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID14_U_HNF_NID72, CPA_GRP_RA28, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID14_U_HNF_NID72, REMOTE_RA28, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID14_U_HNF_NID72, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID14_U_HNF_NID72, NODEID_RA28, 0, 11)
REG32(POR_HNF_RN_PHYS_ID15_U_HNF_NID72, 0x900da0)
    FIELD(POR_HNF_RN_PHYS_ID15_U_HNF_NID72, VALID_RA31, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID15_U_HNF_NID72, CPA_EN_RA31, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID15_U_HNF_NID72, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID15_U_HNF_NID72, CPA_GRP_RA31, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID15_U_HNF_NID72, REMOTE_RA31, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID15_U_HNF_NID72, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID15_U_HNF_NID72, NODEID_RA31, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID15_U_HNF_NID72, VALID_RA30, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID15_U_HNF_NID72, CPA_EN_RA30, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID15_U_HNF_NID72, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID15_U_HNF_NID72, CPA_GRP_RA30, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID15_U_HNF_NID72, REMOTE_RA30, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID15_U_HNF_NID72, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID15_U_HNF_NID72, NODEID_RA30, 0, 11)
REG32(POR_HNF_RN_PHYS_ID16_U_HNF_NID72, 0x900da8)
    FIELD(POR_HNF_RN_PHYS_ID16_U_HNF_NID72, VALID_RA33, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID16_U_HNF_NID72, CPA_EN_RA33, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID16_U_HNF_NID72, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID16_U_HNF_NID72, CPA_GRP_RA33, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID16_U_HNF_NID72, REMOTE_RA33, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID16_U_HNF_NID72, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID16_U_HNF_NID72, NODEID_RA33, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID16_U_HNF_NID72, VALID_RA32, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID16_U_HNF_NID72, CPA_EN_RA32, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID16_U_HNF_NID72, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID16_U_HNF_NID72, CPA_GRP_RA32, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID16_U_HNF_NID72, REMOTE_RA32, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID16_U_HNF_NID72, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID16_U_HNF_NID72, NODEID_RA32, 0, 11)
REG32(POR_HNF_RN_PHYS_ID17_U_HNF_NID72, 0x900db0)
    FIELD(POR_HNF_RN_PHYS_ID17_U_HNF_NID72, VALID_RA35, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID17_U_HNF_NID72, CPA_EN_RA35, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID17_U_HNF_NID72, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID17_U_HNF_NID72, CPA_GRP_RA35, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID17_U_HNF_NID72, REMOTE_RA35, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID17_U_HNF_NID72, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID17_U_HNF_NID72, NODEID_RA35, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID17_U_HNF_NID72, VALID_RA34, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID17_U_HNF_NID72, CPA_EN_RA34, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID17_U_HNF_NID72, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID17_U_HNF_NID72, CPA_GRP_RA34, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID17_U_HNF_NID72, REMOTE_RA34, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID17_U_HNF_NID72, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID17_U_HNF_NID72, NODEID_RA34, 0, 11)
REG32(POR_HNF_RN_PHYS_ID18_U_HNF_NID72, 0x900db8)
    FIELD(POR_HNF_RN_PHYS_ID18_U_HNF_NID72, VALID_RA37, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID18_U_HNF_NID72, CPA_EN_RA37, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID18_U_HNF_NID72, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID18_U_HNF_NID72, CPA_GRP_RA37, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID18_U_HNF_NID72, REMOTE_RA37, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID18_U_HNF_NID72, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID18_U_HNF_NID72, NODEID_RA37, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID18_U_HNF_NID72, VALID_RA36, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID18_U_HNF_NID72, CPA_EN_RA36, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID18_U_HNF_NID72, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID18_U_HNF_NID72, CPA_GRP_RA36, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID18_U_HNF_NID72, REMOTE_RA36, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID18_U_HNF_NID72, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID18_U_HNF_NID72, NODEID_RA36, 0, 11)
REG32(POR_HNF_RN_PHYS_ID19_U_HNF_NID72, 0x900dc0)
    FIELD(POR_HNF_RN_PHYS_ID19_U_HNF_NID72, VALID_RA39, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID19_U_HNF_NID72, CPA_EN_RA39, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID19_U_HNF_NID72, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID19_U_HNF_NID72, CPA_GRP_RA39, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID19_U_HNF_NID72, REMOTE_RA39, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID19_U_HNF_NID72, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID19_U_HNF_NID72, NODEID_RA39, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID19_U_HNF_NID72, VALID_RA38, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID19_U_HNF_NID72, CPA_EN_RA38, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID19_U_HNF_NID72, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID19_U_HNF_NID72, CPA_GRP_RA38, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID19_U_HNF_NID72, REMOTE_RA38, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID19_U_HNF_NID72, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID19_U_HNF_NID72, NODEID_RA38, 0, 11)
REG32(POR_HNF_RN_PHYS_ID20_U_HNF_NID72, 0x900dc8)
    FIELD(POR_HNF_RN_PHYS_ID20_U_HNF_NID72, VALID_RA41, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID20_U_HNF_NID72, CPA_EN_RA41, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID20_U_HNF_NID72, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID20_U_HNF_NID72, CPA_GRP_RA41, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID20_U_HNF_NID72, REMOTE_RA41, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID20_U_HNF_NID72, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID20_U_HNF_NID72, NODEID_RA41, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID20_U_HNF_NID72, VALID_RA40, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID20_U_HNF_NID72, CPA_EN_RA40, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID20_U_HNF_NID72, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID20_U_HNF_NID72, CPA_GRP_RA40, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID20_U_HNF_NID72, REMOTE_RA40, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID20_U_HNF_NID72, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID20_U_HNF_NID72, NODEID_RA40, 0, 11)
REG32(POR_HNF_RN_PHYS_ID21_U_HNF_NID72, 0x900dd0)
    FIELD(POR_HNF_RN_PHYS_ID21_U_HNF_NID72, VALID_RA43, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID21_U_HNF_NID72, CPA_EN_RA43, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID21_U_HNF_NID72, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID21_U_HNF_NID72, CPA_GRP_RA43, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID21_U_HNF_NID72, REMOTE_RA43, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID21_U_HNF_NID72, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID21_U_HNF_NID72, NODEID_RA43, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID21_U_HNF_NID72, VALID_RA42, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID21_U_HNF_NID72, CPA_EN_RA42, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID21_U_HNF_NID72, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID21_U_HNF_NID72, CPA_GRP_RA42, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID21_U_HNF_NID72, REMOTE_RA42, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID21_U_HNF_NID72, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID21_U_HNF_NID72, NODEID_RA42, 0, 11)
REG32(POR_HNF_RN_PHYS_ID22_U_HNF_NID72, 0x900dd8)
    FIELD(POR_HNF_RN_PHYS_ID22_U_HNF_NID72, VALID_RA45, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID22_U_HNF_NID72, CPA_EN_RA45, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID22_U_HNF_NID72, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID22_U_HNF_NID72, CPA_GRP_RA45, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID22_U_HNF_NID72, REMOTE_RA45, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID22_U_HNF_NID72, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID22_U_HNF_NID72, NODEID_RA45, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID22_U_HNF_NID72, VALID_RA44, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID22_U_HNF_NID72, CPA_EN_RA44, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID22_U_HNF_NID72, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID22_U_HNF_NID72, CPA_GRP_RA44, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID22_U_HNF_NID72, REMOTE_RA44, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID22_U_HNF_NID72, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID22_U_HNF_NID72, NODEID_RA44, 0, 11)
REG32(POR_HNF_RN_PHYS_ID23_U_HNF_NID72, 0x900de0)
    FIELD(POR_HNF_RN_PHYS_ID23_U_HNF_NID72, VALID_RA47, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID23_U_HNF_NID72, CPA_EN_RA47, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID23_U_HNF_NID72, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID23_U_HNF_NID72, CPA_GRP_RA47, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID23_U_HNF_NID72, REMOTE_RA47, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID23_U_HNF_NID72, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID23_U_HNF_NID72, NODEID_RA47, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID23_U_HNF_NID72, VALID_RA46, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID23_U_HNF_NID72, CPA_EN_RA46, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID23_U_HNF_NID72, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID23_U_HNF_NID72, CPA_GRP_RA46, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID23_U_HNF_NID72, REMOTE_RA46, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID23_U_HNF_NID72, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID23_U_HNF_NID72, NODEID_RA46, 0, 11)
REG32(POR_HNF_RN_PHYS_ID24_U_HNF_NID72, 0x900de8)
    FIELD(POR_HNF_RN_PHYS_ID24_U_HNF_NID72, VALID_RA49, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID24_U_HNF_NID72, CPA_EN_RA49, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID24_U_HNF_NID72, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID24_U_HNF_NID72, CPA_GRP_RA49, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID24_U_HNF_NID72, REMOTE_RA49, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID24_U_HNF_NID72, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID24_U_HNF_NID72, NODEID_RA49, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID24_U_HNF_NID72, VALID_RA48, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID24_U_HNF_NID72, CPA_EN_RA48, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID24_U_HNF_NID72, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID24_U_HNF_NID72, CPA_GRP_RA48, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID24_U_HNF_NID72, REMOTE_RA48, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID24_U_HNF_NID72, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID24_U_HNF_NID72, NODEID_RA48, 0, 11)
REG32(POR_HNF_RN_PHYS_ID25_U_HNF_NID72, 0x900df0)
    FIELD(POR_HNF_RN_PHYS_ID25_U_HNF_NID72, VALID_RA51, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID25_U_HNF_NID72, CPA_EN_RA51, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID25_U_HNF_NID72, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID25_U_HNF_NID72, CPA_GRP_RA51, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID25_U_HNF_NID72, REMOTE_RA51, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID25_U_HNF_NID72, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID25_U_HNF_NID72, NODEID_RA51, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID25_U_HNF_NID72, VALID_RA50, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID25_U_HNF_NID72, CPA_EN_RA50, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID25_U_HNF_NID72, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID25_U_HNF_NID72, CPA_GRP_RA50, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID25_U_HNF_NID72, REMOTE_RA50, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID25_U_HNF_NID72, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID25_U_HNF_NID72, NODEID_RA50, 0, 11)
REG32(POR_HNF_RN_PHYS_ID26_U_HNF_NID72, 0x900df8)
    FIELD(POR_HNF_RN_PHYS_ID26_U_HNF_NID72, VALID_RA53, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID26_U_HNF_NID72, CPA_EN_RA53, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID26_U_HNF_NID72, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID26_U_HNF_NID72, CPA_GRP_RA53, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID26_U_HNF_NID72, REMOTE_RA53, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID26_U_HNF_NID72, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID26_U_HNF_NID72, NODEID_RA53, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID26_U_HNF_NID72, VALID_RA52, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID26_U_HNF_NID72, CPA_EN_RA52, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID26_U_HNF_NID72, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID26_U_HNF_NID72, CPA_GRP_RA52, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID26_U_HNF_NID72, REMOTE_RA52, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID26_U_HNF_NID72, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID26_U_HNF_NID72, NODEID_RA52, 0, 11)
REG32(POR_HNF_RN_PHYS_ID27_U_HNF_NID72, 0x900e00)
    FIELD(POR_HNF_RN_PHYS_ID27_U_HNF_NID72, VALID_RA55, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID27_U_HNF_NID72, CPA_EN_RA55, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID27_U_HNF_NID72, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID27_U_HNF_NID72, CPA_GRP_RA55, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID27_U_HNF_NID72, REMOTE_RA55, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID27_U_HNF_NID72, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID27_U_HNF_NID72, NODEID_RA55, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID27_U_HNF_NID72, VALID_RA54, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID27_U_HNF_NID72, CPA_EN_RA54, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID27_U_HNF_NID72, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID27_U_HNF_NID72, CPA_GRP_RA54, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID27_U_HNF_NID72, REMOTE_RA54, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID27_U_HNF_NID72, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID27_U_HNF_NID72, NODEID_RA54, 0, 11)
REG32(POR_HNF_RN_PHYS_ID28_U_HNF_NID72, 0x900e08)
    FIELD(POR_HNF_RN_PHYS_ID28_U_HNF_NID72, VALID_RA57, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID28_U_HNF_NID72, CPA_EN_RA57, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID28_U_HNF_NID72, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID28_U_HNF_NID72, CPA_GRP_RA57, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID28_U_HNF_NID72, REMOTE_RA57, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID28_U_HNF_NID72, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID28_U_HNF_NID72, NODEID_RA57, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID28_U_HNF_NID72, VALID_RA56, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID28_U_HNF_NID72, CPA_EN_RA56, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID28_U_HNF_NID72, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID28_U_HNF_NID72, CPA_GRP_RA56, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID28_U_HNF_NID72, REMOTE_RA56, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID28_U_HNF_NID72, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID28_U_HNF_NID72, NODEID_RA56, 0, 11)
REG32(POR_HNF_RN_PHYS_ID29_U_HNF_NID72, 0x900e10)
    FIELD(POR_HNF_RN_PHYS_ID29_U_HNF_NID72, VALID_RA59, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID29_U_HNF_NID72, CPA_EN_RA59, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID29_U_HNF_NID72, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID29_U_HNF_NID72, CPA_GRP_RA59, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID29_U_HNF_NID72, REMOTE_RA59, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID29_U_HNF_NID72, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID29_U_HNF_NID72, NODEID_RA59, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID29_U_HNF_NID72, VALID_RA58, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID29_U_HNF_NID72, CPA_EN_RA58, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID29_U_HNF_NID72, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID29_U_HNF_NID72, CPA_GRP_RA58, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID29_U_HNF_NID72, REMOTE_RA58, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID29_U_HNF_NID72, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID29_U_HNF_NID72, NODEID_RA58, 0, 11)
REG32(POR_HNF_RN_PHYS_ID30_U_HNF_NID72, 0x900e18)
    FIELD(POR_HNF_RN_PHYS_ID30_U_HNF_NID72, VALID_RA61, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID30_U_HNF_NID72, CPA_EN_RA61, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID30_U_HNF_NID72, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID30_U_HNF_NID72, CPA_GRP_RA61, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID30_U_HNF_NID72, REMOTE_RA61, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID30_U_HNF_NID72, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID30_U_HNF_NID72, NODEID_RA61, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID30_U_HNF_NID72, VALID_RA60, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID30_U_HNF_NID72, CPA_EN_RA60, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID30_U_HNF_NID72, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID30_U_HNF_NID72, CPA_GRP_RA60, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID30_U_HNF_NID72, REMOTE_RA60, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID30_U_HNF_NID72, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID30_U_HNF_NID72, NODEID_RA60, 0, 11)
REG32(POR_HNF_RN_PHYS_ID31_U_HNF_NID72, 0x900e20)
    FIELD(POR_HNF_RN_PHYS_ID31_U_HNF_NID72, VALID_RA63, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID31_U_HNF_NID72, CPA_EN_RA63, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID31_U_HNF_NID72, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID31_U_HNF_NID72, CPA_GRP_RA63, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID31_U_HNF_NID72, REMOTE_RA63, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID31_U_HNF_NID72, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID31_U_HNF_NID72, NODEID_RA63, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID31_U_HNF_NID72, VALID_RA62, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID31_U_HNF_NID72, CPA_EN_RA62, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID31_U_HNF_NID72, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID31_U_HNF_NID72, CPA_GRP_RA62, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID31_U_HNF_NID72, REMOTE_RA62, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID31_U_HNF_NID72, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID31_U_HNF_NID72, NODEID_RA62, 0, 11)
REG32(POR_HNF_RN_PHYS_ID32_U_HNF_NID72, 0x900e28)
    FIELD(POR_HNF_RN_PHYS_ID32_U_HNF_NID72, VALID_RA65, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID32_U_HNF_NID72, CPA_EN_RA65, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID32_U_HNF_NID72, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID32_U_HNF_NID72, CPA_GRP_RA65, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID32_U_HNF_NID72, REMOTE_RA65, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID32_U_HNF_NID72, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID32_U_HNF_NID72, NODEID_RA65, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID32_U_HNF_NID72, VALID_RA64, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID32_U_HNF_NID72, CPA_EN_RA64, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID32_U_HNF_NID72, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID32_U_HNF_NID72, CPA_GRP_RA64, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID32_U_HNF_NID72, REMOTE_RA64, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID32_U_HNF_NID72, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID32_U_HNF_NID72, NODEID_RA64, 0, 11)
REG32(POR_HNF_RN_PHYS_ID33_U_HNF_NID72, 0x900e30)
    FIELD(POR_HNF_RN_PHYS_ID33_U_HNF_NID72, VALID_RA67, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID33_U_HNF_NID72, CPA_EN_RA67, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID33_U_HNF_NID72, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID33_U_HNF_NID72, CPA_GRP_RA67, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID33_U_HNF_NID72, REMOTE_RA67, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID33_U_HNF_NID72, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID33_U_HNF_NID72, NODEID_RA67, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID33_U_HNF_NID72, VALID_RA66, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID33_U_HNF_NID72, CPA_EN_RA66, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID33_U_HNF_NID72, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID33_U_HNF_NID72, CPA_GRP_RA66, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID33_U_HNF_NID72, REMOTE_RA66, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID33_U_HNF_NID72, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID33_U_HNF_NID72, NODEID_RA66, 0, 11)
REG32(POR_HNF_RN_PHYS_ID34_U_HNF_NID72, 0x900e38)
    FIELD(POR_HNF_RN_PHYS_ID34_U_HNF_NID72, VALID_RA69, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID34_U_HNF_NID72, CPA_EN_RA69, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID34_U_HNF_NID72, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID34_U_HNF_NID72, CPA_GRP_RA69, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID34_U_HNF_NID72, REMOTE_RA69, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID34_U_HNF_NID72, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID34_U_HNF_NID72, NODEID_RA69, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID34_U_HNF_NID72, VALID_RA68, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID34_U_HNF_NID72, CPA_EN_RA68, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID34_U_HNF_NID72, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID34_U_HNF_NID72, CPA_GRP_RA68, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID34_U_HNF_NID72, REMOTE_RA68, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID34_U_HNF_NID72, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID34_U_HNF_NID72, NODEID_RA68, 0, 11)
REG32(POR_HNF_RN_PHYS_ID35_U_HNF_NID72, 0x900e40)
    FIELD(POR_HNF_RN_PHYS_ID35_U_HNF_NID72, VALID_RA71, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID35_U_HNF_NID72, CPA_EN_RA71, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID35_U_HNF_NID72, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID35_U_HNF_NID72, CPA_GRP_RA71, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID35_U_HNF_NID72, REMOTE_RA71, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID35_U_HNF_NID72, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID35_U_HNF_NID72, NODEID_RA71, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID35_U_HNF_NID72, VALID_RA70, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID35_U_HNF_NID72, CPA_EN_RA70, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID35_U_HNF_NID72, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID35_U_HNF_NID72, CPA_GRP_RA70, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID35_U_HNF_NID72, REMOTE_RA70, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID35_U_HNF_NID72, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID35_U_HNF_NID72, NODEID_RA70, 0, 11)
REG32(POR_HNF_RN_PHYS_ID36_U_HNF_NID72, 0x900e48)
    FIELD(POR_HNF_RN_PHYS_ID36_U_HNF_NID72, VALID_RA73, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID36_U_HNF_NID72, CPA_EN_RA73, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID36_U_HNF_NID72, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID36_U_HNF_NID72, CPA_GRP_RA73, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID36_U_HNF_NID72, REMOTE_RA73, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID36_U_HNF_NID72, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID36_U_HNF_NID72, NODEID_RA73, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID36_U_HNF_NID72, VALID_RA72, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID36_U_HNF_NID72, CPA_EN_RA72, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID36_U_HNF_NID72, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID36_U_HNF_NID72, CPA_GRP_RA72, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID36_U_HNF_NID72, REMOTE_RA72, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID36_U_HNF_NID72, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID36_U_HNF_NID72, NODEID_RA72, 0, 11)
REG32(POR_HNF_RN_PHYS_ID37_U_HNF_NID72, 0x900e50)
    FIELD(POR_HNF_RN_PHYS_ID37_U_HNF_NID72, VALID_RA75, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID37_U_HNF_NID72, CPA_EN_RA75, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID37_U_HNF_NID72, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID37_U_HNF_NID72, CPA_GRP_RA75, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID37_U_HNF_NID72, REMOTE_RA75, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID37_U_HNF_NID72, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID37_U_HNF_NID72, NODEID_RA75, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID37_U_HNF_NID72, VALID_RA74, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID37_U_HNF_NID72, CPA_EN_RA74, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID37_U_HNF_NID72, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID37_U_HNF_NID72, CPA_GRP_RA74, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID37_U_HNF_NID72, REMOTE_RA74, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID37_U_HNF_NID72, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID37_U_HNF_NID72, NODEID_RA74, 0, 11)
REG32(POR_HNF_RN_PHYS_ID38_U_HNF_NID72, 0x900e58)
    FIELD(POR_HNF_RN_PHYS_ID38_U_HNF_NID72, VALID_RA77, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID38_U_HNF_NID72, CPA_EN_RA77, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID38_U_HNF_NID72, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID38_U_HNF_NID72, CPA_GRP_RA77, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID38_U_HNF_NID72, REMOTE_RA77, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID38_U_HNF_NID72, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID38_U_HNF_NID72, NODEID_RA77, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID38_U_HNF_NID72, VALID_RA76, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID38_U_HNF_NID72, CPA_EN_RA76, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID38_U_HNF_NID72, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID38_U_HNF_NID72, CPA_GRP_RA76, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID38_U_HNF_NID72, REMOTE_RA76, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID38_U_HNF_NID72, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID38_U_HNF_NID72, NODEID_RA76, 0, 11)
REG32(POR_HNF_RN_PHYS_ID39_U_HNF_NID72, 0x900e60)
    FIELD(POR_HNF_RN_PHYS_ID39_U_HNF_NID72, VALID_RA79, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID39_U_HNF_NID72, CPA_EN_RA79, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID39_U_HNF_NID72, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID39_U_HNF_NID72, CPA_GRP_RA79, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID39_U_HNF_NID72, REMOTE_RA79, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID39_U_HNF_NID72, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID39_U_HNF_NID72, NODEID_RA79, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID39_U_HNF_NID72, VALID_RA78, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID39_U_HNF_NID72, CPA_EN_RA78, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID39_U_HNF_NID72, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID39_U_HNF_NID72, CPA_GRP_RA78, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID39_U_HNF_NID72, REMOTE_RA78, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID39_U_HNF_NID72, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID39_U_HNF_NID72, NODEID_RA78, 0, 11)
REG32(POR_HNF_RN_PHYS_ID40_U_HNF_NID72, 0x900e68)
    FIELD(POR_HNF_RN_PHYS_ID40_U_HNF_NID72, VALID_RA81, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID40_U_HNF_NID72, CPA_EN_RA81, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID40_U_HNF_NID72, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID40_U_HNF_NID72, CPA_GRP_RA81, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID40_U_HNF_NID72, REMOTE_RA81, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID40_U_HNF_NID72, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID40_U_HNF_NID72, NODEID_RA81, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID40_U_HNF_NID72, VALID_RA80, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID40_U_HNF_NID72, CPA_EN_RA80, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID40_U_HNF_NID72, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID40_U_HNF_NID72, CPA_GRP_RA80, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID40_U_HNF_NID72, REMOTE_RA80, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID40_U_HNF_NID72, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID40_U_HNF_NID72, NODEID_RA80, 0, 11)
REG32(POR_HNF_RN_PHYS_ID41_U_HNF_NID72, 0x900e70)
    FIELD(POR_HNF_RN_PHYS_ID41_U_HNF_NID72, VALID_RA83, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID41_U_HNF_NID72, CPA_EN_RA83, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID41_U_HNF_NID72, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID41_U_HNF_NID72, CPA_GRP_RA83, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID41_U_HNF_NID72, REMOTE_RA83, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID41_U_HNF_NID72, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID41_U_HNF_NID72, NODEID_RA83, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID41_U_HNF_NID72, VALID_RA82, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID41_U_HNF_NID72, CPA_EN_RA82, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID41_U_HNF_NID72, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID41_U_HNF_NID72, CPA_GRP_RA82, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID41_U_HNF_NID72, REMOTE_RA82, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID41_U_HNF_NID72, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID41_U_HNF_NID72, NODEID_RA82, 0, 11)
REG32(POR_HNF_RN_PHYS_ID42_U_HNF_NID72, 0x900e78)
    FIELD(POR_HNF_RN_PHYS_ID42_U_HNF_NID72, VALID_RA85, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID42_U_HNF_NID72, CPA_EN_RA85, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID42_U_HNF_NID72, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID42_U_HNF_NID72, CPA_GRP_RA85, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID42_U_HNF_NID72, REMOTE_RA85, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID42_U_HNF_NID72, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID42_U_HNF_NID72, NODEID_RA85, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID42_U_HNF_NID72, VALID_RA84, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID42_U_HNF_NID72, CPA_EN_RA84, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID42_U_HNF_NID72, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID42_U_HNF_NID72, CPA_GRP_RA84, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID42_U_HNF_NID72, REMOTE_RA84, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID42_U_HNF_NID72, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID42_U_HNF_NID72, NODEID_RA84, 0, 11)
REG32(POR_HNF_RN_PHYS_ID43_U_HNF_NID72, 0x900e80)
    FIELD(POR_HNF_RN_PHYS_ID43_U_HNF_NID72, VALID_RA87, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID43_U_HNF_NID72, CPA_EN_RA87, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID43_U_HNF_NID72, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID43_U_HNF_NID72, CPA_GRP_RA87, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID43_U_HNF_NID72, REMOTE_RA87, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID43_U_HNF_NID72, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID43_U_HNF_NID72, NODEID_RA87, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID43_U_HNF_NID72, VALID_RA86, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID43_U_HNF_NID72, CPA_EN_RA86, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID43_U_HNF_NID72, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID43_U_HNF_NID72, CPA_GRP_RA86, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID43_U_HNF_NID72, REMOTE_RA86, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID43_U_HNF_NID72, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID43_U_HNF_NID72, NODEID_RA86, 0, 11)
REG32(POR_HNF_RN_PHYS_ID44_U_HNF_NID72, 0x900e88)
    FIELD(POR_HNF_RN_PHYS_ID44_U_HNF_NID72, VALID_RA89, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID44_U_HNF_NID72, CPA_EN_RA89, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID44_U_HNF_NID72, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID44_U_HNF_NID72, CPA_GRP_RA89, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID44_U_HNF_NID72, REMOTE_RA89, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID44_U_HNF_NID72, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID44_U_HNF_NID72, NODEID_RA89, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID44_U_HNF_NID72, VALID_RA88, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID44_U_HNF_NID72, CPA_EN_RA88, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID44_U_HNF_NID72, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID44_U_HNF_NID72, CPA_GRP_RA88, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID44_U_HNF_NID72, REMOTE_RA88, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID44_U_HNF_NID72, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID44_U_HNF_NID72, NODEID_RA88, 0, 11)
REG32(POR_HNF_RN_PHYS_ID45_U_HNF_NID72, 0x900e90)
    FIELD(POR_HNF_RN_PHYS_ID45_U_HNF_NID72, VALID_RA91, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID45_U_HNF_NID72, CPA_EN_RA91, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID45_U_HNF_NID72, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID45_U_HNF_NID72, CPA_GRP_RA91, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID45_U_HNF_NID72, REMOTE_RA91, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID45_U_HNF_NID72, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID45_U_HNF_NID72, NODEID_RA91, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID45_U_HNF_NID72, VALID_RA90, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID45_U_HNF_NID72, CPA_EN_RA90, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID45_U_HNF_NID72, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID45_U_HNF_NID72, CPA_GRP_RA90, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID45_U_HNF_NID72, REMOTE_RA90, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID45_U_HNF_NID72, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID45_U_HNF_NID72, NODEID_RA90, 0, 11)
REG32(POR_HNF_RN_PHYS_ID46_U_HNF_NID72, 0x900e98)
    FIELD(POR_HNF_RN_PHYS_ID46_U_HNF_NID72, VALID_RA93, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID46_U_HNF_NID72, CPA_EN_RA93, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID46_U_HNF_NID72, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID46_U_HNF_NID72, CPA_GRP_RA93, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID46_U_HNF_NID72, REMOTE_RA93, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID46_U_HNF_NID72, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID46_U_HNF_NID72, NODEID_RA93, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID46_U_HNF_NID72, VALID_RA92, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID46_U_HNF_NID72, CPA_EN_RA92, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID46_U_HNF_NID72, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID46_U_HNF_NID72, CPA_GRP_RA92, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID46_U_HNF_NID72, REMOTE_RA92, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID46_U_HNF_NID72, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID46_U_HNF_NID72, NODEID_RA92, 0, 11)
REG32(POR_HNF_RN_PHYS_ID47_U_HNF_NID72, 0x900ea0)
    FIELD(POR_HNF_RN_PHYS_ID47_U_HNF_NID72, VALID_RA95, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID47_U_HNF_NID72, CPA_EN_RA95, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID47_U_HNF_NID72, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID47_U_HNF_NID72, CPA_GRP_RA95, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID47_U_HNF_NID72, REMOTE_RA95, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID47_U_HNF_NID72, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID47_U_HNF_NID72, NODEID_RA95, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID47_U_HNF_NID72, VALID_RA94, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID47_U_HNF_NID72, CPA_EN_RA94, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID47_U_HNF_NID72, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID47_U_HNF_NID72, CPA_GRP_RA94, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID47_U_HNF_NID72, REMOTE_RA94, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID47_U_HNF_NID72, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID47_U_HNF_NID72, NODEID_RA94, 0, 11)
REG32(POR_HNF_RN_PHYS_ID48_U_HNF_NID72, 0x900ea8)
    FIELD(POR_HNF_RN_PHYS_ID48_U_HNF_NID72, VALID_RA97, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID48_U_HNF_NID72, CPA_EN_RA97, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID48_U_HNF_NID72, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID48_U_HNF_NID72, CPA_GRP_RA97, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID48_U_HNF_NID72, REMOTE_RA97, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID48_U_HNF_NID72, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID48_U_HNF_NID72, NODEID_RA97, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID48_U_HNF_NID72, VALID_RA96, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID48_U_HNF_NID72, CPA_EN_RA96, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID48_U_HNF_NID72, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID48_U_HNF_NID72, CPA_GRP_RA96, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID48_U_HNF_NID72, REMOTE_RA96, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID48_U_HNF_NID72, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID48_U_HNF_NID72, NODEID_RA96, 0, 11)
REG32(POR_HNF_RN_PHYS_ID49_U_HNF_NID72, 0x900eb0)
    FIELD(POR_HNF_RN_PHYS_ID49_U_HNF_NID72, VALID_RA99, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID49_U_HNF_NID72, CPA_EN_RA99, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID49_U_HNF_NID72, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID49_U_HNF_NID72, CPA_GRP_RA99, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID49_U_HNF_NID72, REMOTE_RA99, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID49_U_HNF_NID72, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID49_U_HNF_NID72, NODEID_RA99, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID49_U_HNF_NID72, VALID_RA98, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID49_U_HNF_NID72, CPA_EN_RA98, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID49_U_HNF_NID72, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID49_U_HNF_NID72, CPA_GRP_RA98, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID49_U_HNF_NID72, REMOTE_RA98, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID49_U_HNF_NID72, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID49_U_HNF_NID72, NODEID_RA98, 0, 11)
REG32(POR_HNF_RN_PHYS_ID50_U_HNF_NID72, 0x900eb8)
    FIELD(POR_HNF_RN_PHYS_ID50_U_HNF_NID72, VALID_RA101, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID50_U_HNF_NID72, CPA_EN_RA101, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID50_U_HNF_NID72, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID50_U_HNF_NID72, CPA_GRP_RA101, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID50_U_HNF_NID72, REMOTE_RA101, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID50_U_HNF_NID72, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID50_U_HNF_NID72, NODEID_RA101, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID50_U_HNF_NID72, VALID_RA100, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID50_U_HNF_NID72, CPA_EN_RA100, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID50_U_HNF_NID72, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID50_U_HNF_NID72, CPA_GRP_RA100, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID50_U_HNF_NID72, REMOTE_RA100, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID50_U_HNF_NID72, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID50_U_HNF_NID72, NODEID_RA100, 0, 11)
REG32(POR_HNF_RN_PHYS_ID51_U_HNF_NID72, 0x900ec0)
    FIELD(POR_HNF_RN_PHYS_ID51_U_HNF_NID72, VALID_RA103, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID51_U_HNF_NID72, CPA_EN_RA103, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID51_U_HNF_NID72, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID51_U_HNF_NID72, CPA_GRP_RA103, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID51_U_HNF_NID72, REMOTE_RA103, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID51_U_HNF_NID72, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID51_U_HNF_NID72, NODEID_RA103, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID51_U_HNF_NID72, VALID_RA102, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID51_U_HNF_NID72, CPA_EN_RA102, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID51_U_HNF_NID72, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID51_U_HNF_NID72, CPA_GRP_RA102, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID51_U_HNF_NID72, REMOTE_RA102, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID51_U_HNF_NID72, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID51_U_HNF_NID72, NODEID_RA102, 0, 11)
REG32(POR_HNF_RN_PHYS_ID52_U_HNF_NID72, 0x900ec8)
    FIELD(POR_HNF_RN_PHYS_ID52_U_HNF_NID72, VALID_RA105, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID52_U_HNF_NID72, CPA_EN_RA105, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID52_U_HNF_NID72, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID52_U_HNF_NID72, CPA_GRP_RA105, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID52_U_HNF_NID72, REMOTE_RA105, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID52_U_HNF_NID72, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID52_U_HNF_NID72, NODEID_RA105, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID52_U_HNF_NID72, VALID_RA104, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID52_U_HNF_NID72, CPA_EN_RA104, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID52_U_HNF_NID72, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID52_U_HNF_NID72, CPA_GRP_RA104, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID52_U_HNF_NID72, REMOTE_RA104, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID52_U_HNF_NID72, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID52_U_HNF_NID72, NODEID_RA104, 0, 11)
REG32(POR_HNF_RN_PHYS_ID53_U_HNF_NID72, 0x900ed0)
    FIELD(POR_HNF_RN_PHYS_ID53_U_HNF_NID72, VALID_RA107, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID53_U_HNF_NID72, CPA_EN_RA107, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID53_U_HNF_NID72, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID53_U_HNF_NID72, CPA_GRP_RA107, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID53_U_HNF_NID72, REMOTE_RA107, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID53_U_HNF_NID72, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID53_U_HNF_NID72, NODEID_RA107, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID53_U_HNF_NID72, VALID_RA106, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID53_U_HNF_NID72, CPA_EN_RA106, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID53_U_HNF_NID72, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID53_U_HNF_NID72, CPA_GRP_RA106, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID53_U_HNF_NID72, REMOTE_RA106, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID53_U_HNF_NID72, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID53_U_HNF_NID72, NODEID_RA106, 0, 11)
REG32(POR_HNF_RN_PHYS_ID54_U_HNF_NID72, 0x900ed8)
    FIELD(POR_HNF_RN_PHYS_ID54_U_HNF_NID72, VALID_RA109, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID54_U_HNF_NID72, CPA_EN_RA109, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID54_U_HNF_NID72, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID54_U_HNF_NID72, CPA_GRP_RA109, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID54_U_HNF_NID72, REMOTE_RA109, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID54_U_HNF_NID72, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID54_U_HNF_NID72, NODEID_RA109, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID54_U_HNF_NID72, VALID_RA108, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID54_U_HNF_NID72, CPA_EN_RA108, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID54_U_HNF_NID72, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID54_U_HNF_NID72, CPA_GRP_RA108, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID54_U_HNF_NID72, REMOTE_RA108, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID54_U_HNF_NID72, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID54_U_HNF_NID72, NODEID_RA108, 0, 11)
REG32(POR_HNF_RN_PHYS_ID55_U_HNF_NID72, 0x900ee0)
    FIELD(POR_HNF_RN_PHYS_ID55_U_HNF_NID72, VALID_RA111, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID55_U_HNF_NID72, CPA_EN_RA111, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID55_U_HNF_NID72, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID55_U_HNF_NID72, CPA_GRP_RA111, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID55_U_HNF_NID72, REMOTE_RA111, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID55_U_HNF_NID72, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID55_U_HNF_NID72, NODEID_RA111, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID55_U_HNF_NID72, VALID_RA110, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID55_U_HNF_NID72, CPA_EN_RA110, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID55_U_HNF_NID72, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID55_U_HNF_NID72, CPA_GRP_RA110, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID55_U_HNF_NID72, REMOTE_RA110, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID55_U_HNF_NID72, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID55_U_HNF_NID72, NODEID_RA110, 0, 11)
REG32(POR_HNF_RN_PHYS_ID56_U_HNF_NID72, 0x900ee8)
    FIELD(POR_HNF_RN_PHYS_ID56_U_HNF_NID72, VALID_RA113, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID56_U_HNF_NID72, CPA_EN_RA113, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID56_U_HNF_NID72, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID56_U_HNF_NID72, CPA_GRP_RA113, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID56_U_HNF_NID72, REMOTE_RA113, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID56_U_HNF_NID72, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID56_U_HNF_NID72, NODEID_RA113, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID56_U_HNF_NID72, VALID_RA112, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID56_U_HNF_NID72, CPA_EN_RA112, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID56_U_HNF_NID72, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID56_U_HNF_NID72, CPA_GRP_RA112, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID56_U_HNF_NID72, REMOTE_RA112, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID56_U_HNF_NID72, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID56_U_HNF_NID72, NODEID_RA112, 0, 11)
REG32(POR_HNF_RN_PHYS_ID57_U_HNF_NID72, 0x900ef0)
    FIELD(POR_HNF_RN_PHYS_ID57_U_HNF_NID72, VALID_RA115, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID57_U_HNF_NID72, CPA_EN_RA115, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID57_U_HNF_NID72, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID57_U_HNF_NID72, CPA_GRP_RA115, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID57_U_HNF_NID72, REMOTE_RA115, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID57_U_HNF_NID72, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID57_U_HNF_NID72, NODEID_RA115, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID57_U_HNF_NID72, VALID_RA114, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID57_U_HNF_NID72, CPA_EN_RA114, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID57_U_HNF_NID72, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID57_U_HNF_NID72, CPA_GRP_RA114, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID57_U_HNF_NID72, REMOTE_RA114, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID57_U_HNF_NID72, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID57_U_HNF_NID72, NODEID_RA114, 0, 11)
REG32(POR_HNF_RN_PHYS_ID58_U_HNF_NID72, 0x900ef8)
    FIELD(POR_HNF_RN_PHYS_ID58_U_HNF_NID72, VALID_RA117, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID58_U_HNF_NID72, CPA_EN_RA117, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID58_U_HNF_NID72, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID58_U_HNF_NID72, CPA_GRP_RA117, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID58_U_HNF_NID72, REMOTE_RA117, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID58_U_HNF_NID72, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID58_U_HNF_NID72, NODEID_RA117, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID58_U_HNF_NID72, VALID_RA116, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID58_U_HNF_NID72, CPA_EN_RA116, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID58_U_HNF_NID72, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID58_U_HNF_NID72, CPA_GRP_RA116, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID58_U_HNF_NID72, REMOTE_RA116, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID58_U_HNF_NID72, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID58_U_HNF_NID72, NODEID_RA116, 0, 11)
REG32(POR_HNF_SF_CXG_BLOCKED_WAYS_U_HNF_NID72, 0x900f00)
    FIELD(POR_HNF_SF_CXG_BLOCKED_WAYS_U_HNF_NID72, SF_BLOCKED_WAYS, 0, 2)
REG32(POR_HNF_CML_PORT_AGGR_GRP0_ADD_MASK_U_HNF_NID72, 0x900f10)
    FIELD(POR_HNF_CML_PORT_AGGR_GRP0_ADD_MASK_U_HNF_NID72, RESERVED_48, 48, 16)
    FIELD(POR_HNF_CML_PORT_AGGR_GRP0_ADD_MASK_U_HNF_NID72, ADDR_MASK, 6, 42)
    FIELD(POR_HNF_CML_PORT_AGGR_GRP0_ADD_MASK_U_HNF_NID72, RESERVED_0, 0, 6)
REG32(POR_HNF_CML_PORT_AGGR_GRP1_ADD_MASK_U_HNF_NID72, 0x900f18)
    FIELD(POR_HNF_CML_PORT_AGGR_GRP1_ADD_MASK_U_HNF_NID72, RESERVED_48, 48, 16)
    FIELD(POR_HNF_CML_PORT_AGGR_GRP1_ADD_MASK_U_HNF_NID72, ADDR_MASK, 6, 42)
    FIELD(POR_HNF_CML_PORT_AGGR_GRP1_ADD_MASK_U_HNF_NID72, RESERVED_0, 0, 6)
REG32(POR_HNF_CML_PORT_AGGR_GRP0_REG_U_HNF_NID72, 0x900f28)
    FIELD(POR_HNF_CML_PORT_AGGR_GRP0_REG_U_HNF_NID72, RESERVED_50, 50, 14)
    FIELD(POR_HNF_CML_PORT_AGGR_GRP0_REG_U_HNF_NID72, NUM_CXG_PAG0, 48, 2)
    FIELD(POR_HNF_CML_PORT_AGGR_GRP0_REG_U_HNF_NID72, RESERVED_47, 47, 1)
    FIELD(POR_HNF_CML_PORT_AGGR_GRP0_REG_U_HNF_NID72, PAG0_TGTID3, 36, 11)
    FIELD(POR_HNF_CML_PORT_AGGR_GRP0_REG_U_HNF_NID72, RESERVED_35, 35, 1)
    FIELD(POR_HNF_CML_PORT_AGGR_GRP0_REG_U_HNF_NID72, PAG0_TGTID2, 24, 11)
    FIELD(POR_HNF_CML_PORT_AGGR_GRP0_REG_U_HNF_NID72, RESERVED_23, 23, 1)
    FIELD(POR_HNF_CML_PORT_AGGR_GRP0_REG_U_HNF_NID72, PAG0_TGTID1, 12, 11)
    FIELD(POR_HNF_CML_PORT_AGGR_GRP0_REG_U_HNF_NID72, RESERVED_11, 11, 1)
    FIELD(POR_HNF_CML_PORT_AGGR_GRP0_REG_U_HNF_NID72, PAG0_TGTID0, 0, 11)
REG32(POR_HNF_CML_PORT_AGGR_GRP1_REG_U_HNF_NID72, 0x900f30)
    FIELD(POR_HNF_CML_PORT_AGGR_GRP1_REG_U_HNF_NID72, RESERVED_50, 50, 14)
    FIELD(POR_HNF_CML_PORT_AGGR_GRP1_REG_U_HNF_NID72, NUM_CXG_PAG1, 48, 2)
    FIELD(POR_HNF_CML_PORT_AGGR_GRP1_REG_U_HNF_NID72, RESERVED_47, 47, 1)
    FIELD(POR_HNF_CML_PORT_AGGR_GRP1_REG_U_HNF_NID72, PAG1_TGTID3, 36, 11)
    FIELD(POR_HNF_CML_PORT_AGGR_GRP1_REG_U_HNF_NID72, RESERVED_35, 35, 1)
    FIELD(POR_HNF_CML_PORT_AGGR_GRP1_REG_U_HNF_NID72, PAG1_TGTID2, 24, 11)
    FIELD(POR_HNF_CML_PORT_AGGR_GRP1_REG_U_HNF_NID72, RESERVED_23, 23, 1)
    FIELD(POR_HNF_CML_PORT_AGGR_GRP1_REG_U_HNF_NID72, PAG1_TGTID1, 12, 11)
    FIELD(POR_HNF_CML_PORT_AGGR_GRP1_REG_U_HNF_NID72, RESERVED_11, 11, 1)
    FIELD(POR_HNF_CML_PORT_AGGR_GRP1_REG_U_HNF_NID72, PAG1_TGTID0, 0, 11)
REG32(HN_SAM_HASH_ADDR_MASK_REG_U_HNF_NID72, 0x900f40)
    FIELD(HN_SAM_HASH_ADDR_MASK_REG_U_HNF_NID72, RESERVED_48, 48, 16)
    FIELD(HN_SAM_HASH_ADDR_MASK_REG_U_HNF_NID72, ADDR_MASK, 6, 42)
    FIELD(HN_SAM_HASH_ADDR_MASK_REG_U_HNF_NID72, RESERVED_0, 0, 6)
REG32(HN_SAM_REGION_CMP_ADDR_MASK_REG_U_HNF_NID72, 0x900f48)
    FIELD(HN_SAM_REGION_CMP_ADDR_MASK_REG_U_HNF_NID72, RESERVED_48, 48, 16)
    FIELD(HN_SAM_REGION_CMP_ADDR_MASK_REG_U_HNF_NID72, ADDR_MASK, 26, 22)
    FIELD(HN_SAM_REGION_CMP_ADDR_MASK_REG_U_HNF_NID72, RESERVED_0, 0, 26)
REG32(POR_HNF_ABF_LO_ADDR_U_HNF_NID72, 0x900f50)
    FIELD(POR_HNF_ABF_LO_ADDR_U_HNF_NID72, RESERVED_48, 48, 16)
    FIELD(POR_HNF_ABF_LO_ADDR_U_HNF_NID72, ABF_LO_ADDR, 0, 48)
REG32(POR_HNF_ABF_HI_ADDR_U_HNF_NID72, 0x900f58)
    FIELD(POR_HNF_ABF_HI_ADDR_U_HNF_NID72, RESERVED_48, 48, 16)
    FIELD(POR_HNF_ABF_HI_ADDR_U_HNF_NID72, ABF_HI_ADDR, 0, 48)
REG32(POR_HNF_ABF_PR_U_HNF_NID72, 0x900f60)
    FIELD(POR_HNF_ABF_PR_U_HNF_NID72, ABF_MODE, 1, 2)
    FIELD(POR_HNF_ABF_PR_U_HNF_NID72, ABF_ENABLE, 0, 1)
REG32(POR_HNF_ABF_SR_U_HNF_NID72, 0x900f68)
    FIELD(POR_HNF_ABF_SR_U_HNF_NID72, ABF_SF_DISABLE_ABORT, 3, 1)
    FIELD(POR_HNF_ABF_SR_U_HNF_NID72, ABF_SF_PM_TRANSITION_ABORT, 2, 1)
    FIELD(POR_HNF_ABF_SR_U_HNF_NID72, ABF_INVALID_REQ_ABORT, 1, 1)
    FIELD(POR_HNF_ABF_SR_U_HNF_NID72, ABF_COMPLETE, 0, 1)
REG32(POR_HNF_RN_PHYS_ID59_U_HNF_NID72, 0x900f70)
    FIELD(POR_HNF_RN_PHYS_ID59_U_HNF_NID72, VALID_RA119, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID59_U_HNF_NID72, CPA_EN_RA119, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID59_U_HNF_NID72, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID59_U_HNF_NID72, CPA_GRP_RA119, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID59_U_HNF_NID72, REMOTE_RA119, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID59_U_HNF_NID72, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID59_U_HNF_NID72, NODEID_RA119, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID59_U_HNF_NID72, VALID_RA118, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID59_U_HNF_NID72, CPA_EN_RA118, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID59_U_HNF_NID72, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID59_U_HNF_NID72, CPA_GRP_RA118, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID59_U_HNF_NID72, REMOTE_RA118, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID59_U_HNF_NID72, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID59_U_HNF_NID72, NODEID_RA118, 0, 11)
REG32(POR_HNF_RN_PHYS_ID60_U_HNF_NID72, 0x900f78)
    FIELD(POR_HNF_RN_PHYS_ID60_U_HNF_NID72, VALID_RA121, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID60_U_HNF_NID72, CPA_EN_RA121, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID60_U_HNF_NID72, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID60_U_HNF_NID72, CPA_GRP_RA121, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID60_U_HNF_NID72, REMOTE_RA121, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID60_U_HNF_NID72, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID60_U_HNF_NID72, NODEID_RA121, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID60_U_HNF_NID72, VALID_RA120, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID60_U_HNF_NID72, CPA_EN_RA120, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID60_U_HNF_NID72, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID60_U_HNF_NID72, CPA_GRP_RA120, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID60_U_HNF_NID72, REMOTE_RA120, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID60_U_HNF_NID72, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID60_U_HNF_NID72, NODEID_RA120, 0, 11)
REG32(POR_HNF_RN_PHYS_ID61_U_HNF_NID72, 0x900f80)
    FIELD(POR_HNF_RN_PHYS_ID61_U_HNF_NID72, VALID_RA123, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID61_U_HNF_NID72, CPA_EN_RA123, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID61_U_HNF_NID72, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID61_U_HNF_NID72, CPA_GRP_RA123, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID61_U_HNF_NID72, REMOTE_RA123, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID61_U_HNF_NID72, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID61_U_HNF_NID72, NODEID_RA123, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID61_U_HNF_NID72, VALID_RA122, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID61_U_HNF_NID72, CPA_EN_RA122, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID61_U_HNF_NID72, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID61_U_HNF_NID72, CPA_GRP_RA122, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID61_U_HNF_NID72, REMOTE_RA122, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID61_U_HNF_NID72, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID61_U_HNF_NID72, NODEID_RA122, 0, 11)
REG32(POR_HNF_RN_PHYS_ID62_U_HNF_NID72, 0x900f88)
    FIELD(POR_HNF_RN_PHYS_ID62_U_HNF_NID72, VALID_RA125, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID62_U_HNF_NID72, CPA_EN_RA125, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID62_U_HNF_NID72, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID62_U_HNF_NID72, CPA_GRP_RA125, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID62_U_HNF_NID72, REMOTE_RA125, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID62_U_HNF_NID72, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID62_U_HNF_NID72, NODEID_RA125, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID62_U_HNF_NID72, VALID_RA124, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID62_U_HNF_NID72, CPA_EN_RA124, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID62_U_HNF_NID72, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID62_U_HNF_NID72, CPA_GRP_RA124, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID62_U_HNF_NID72, REMOTE_RA124, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID62_U_HNF_NID72, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID62_U_HNF_NID72, NODEID_RA124, 0, 11)
REG32(POR_HNF_RN_PHYS_ID63_U_HNF_NID72, 0x900f90)
    FIELD(POR_HNF_RN_PHYS_ID63_U_HNF_NID72, VALID_RA127, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID63_U_HNF_NID72, CPA_EN_RA127, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID63_U_HNF_NID72, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID63_U_HNF_NID72, CPA_GRP_RA127, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID63_U_HNF_NID72, REMOTE_RA127, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID63_U_HNF_NID72, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID63_U_HNF_NID72, NODEID_RA127, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID63_U_HNF_NID72, VALID_RA126, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID63_U_HNF_NID72, CPA_EN_RA126, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID63_U_HNF_NID72, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID63_U_HNF_NID72, CPA_GRP_RA126, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID63_U_HNF_NID72, REMOTE_RA126, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID63_U_HNF_NID72, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID63_U_HNF_NID72, NODEID_RA126, 0, 11)
REG32(POR_HNF_LDID_MAP_TABLE_REG0_U_HNF_NID72, 0x900f98)
    FIELD(POR_HNF_LDID_MAP_TABLE_REG0_U_HNF_NID72, VALID_CXHA1, 63, 1)
    FIELD(POR_HNF_LDID_MAP_TABLE_REG0_U_HNF_NID72, RESERVED_55, 55, 8)
    FIELD(POR_HNF_LDID_MAP_TABLE_REG0_U_HNF_NID72, STARTING_LDID_CXHA1, 48, 7)
    FIELD(POR_HNF_LDID_MAP_TABLE_REG0_U_HNF_NID72, RESERVED_43, 43, 5)
    FIELD(POR_HNF_LDID_MAP_TABLE_REG0_U_HNF_NID72, SRCID_CXHA1, 32, 11)
    FIELD(POR_HNF_LDID_MAP_TABLE_REG0_U_HNF_NID72, VALID_CXHA0, 31, 1)
    FIELD(POR_HNF_LDID_MAP_TABLE_REG0_U_HNF_NID72, RESERVED_23, 23, 8)
    FIELD(POR_HNF_LDID_MAP_TABLE_REG0_U_HNF_NID72, STARTING_LDID_CXHA0, 16, 7)
    FIELD(POR_HNF_LDID_MAP_TABLE_REG0_U_HNF_NID72, RESERVED_11, 11, 5)
    FIELD(POR_HNF_LDID_MAP_TABLE_REG0_U_HNF_NID72, SRCID_CXHA0, 0, 11)
REG32(POR_HNF_LDID_MAP_TABLE_REG1_U_HNF_NID72, 0x900fa0)
    FIELD(POR_HNF_LDID_MAP_TABLE_REG1_U_HNF_NID72, VALID_CXHA3, 63, 1)
    FIELD(POR_HNF_LDID_MAP_TABLE_REG1_U_HNF_NID72, RESERVED_55, 55, 8)
    FIELD(POR_HNF_LDID_MAP_TABLE_REG1_U_HNF_NID72, STARTING_LDID_CXHA3, 48, 7)
    FIELD(POR_HNF_LDID_MAP_TABLE_REG1_U_HNF_NID72, RESERVED_43, 43, 5)
    FIELD(POR_HNF_LDID_MAP_TABLE_REG1_U_HNF_NID72, SRCID_CXHA3, 32, 11)
    FIELD(POR_HNF_LDID_MAP_TABLE_REG1_U_HNF_NID72, VALID_CXHA2, 31, 1)
    FIELD(POR_HNF_LDID_MAP_TABLE_REG1_U_HNF_NID72, RESERVED_23, 23, 8)
    FIELD(POR_HNF_LDID_MAP_TABLE_REG1_U_HNF_NID72, STARTING_LDID_CXHA2, 16, 7)
    FIELD(POR_HNF_LDID_MAP_TABLE_REG1_U_HNF_NID72, RESERVED_11, 11, 5)
    FIELD(POR_HNF_LDID_MAP_TABLE_REG1_U_HNF_NID72, SRCID_CXHA2, 0, 11)
REG32(POR_HNF_LDID_MAP_TABLE_REG2_U_HNF_NID72, 0x900fa8)
    FIELD(POR_HNF_LDID_MAP_TABLE_REG2_U_HNF_NID72, VALID_CXHA5, 63, 1)
    FIELD(POR_HNF_LDID_MAP_TABLE_REG2_U_HNF_NID72, RESERVED_55, 55, 8)
    FIELD(POR_HNF_LDID_MAP_TABLE_REG2_U_HNF_NID72, STARTING_LDID_CXHA5, 48, 7)
    FIELD(POR_HNF_LDID_MAP_TABLE_REG2_U_HNF_NID72, RESERVED_43, 43, 5)
    FIELD(POR_HNF_LDID_MAP_TABLE_REG2_U_HNF_NID72, SRCID_CXHA5, 32, 11)
    FIELD(POR_HNF_LDID_MAP_TABLE_REG2_U_HNF_NID72, VALID_CXHA4, 31, 1)
    FIELD(POR_HNF_LDID_MAP_TABLE_REG2_U_HNF_NID72, RESERVED_23, 23, 8)
    FIELD(POR_HNF_LDID_MAP_TABLE_REG2_U_HNF_NID72, STARTING_LDID_CXHA4, 16, 7)
    FIELD(POR_HNF_LDID_MAP_TABLE_REG2_U_HNF_NID72, RESERVED_11, 11, 5)
    FIELD(POR_HNF_LDID_MAP_TABLE_REG2_U_HNF_NID72, SRCID_CXHA4, 0, 11)
REG32(POR_HNF_LDID_MAP_TABLE_REG3_U_HNF_NID72, 0x900fb0)
    FIELD(POR_HNF_LDID_MAP_TABLE_REG3_U_HNF_NID72, VALID_CXHA7, 63, 1)
    FIELD(POR_HNF_LDID_MAP_TABLE_REG3_U_HNF_NID72, RESERVED_55, 55, 8)
    FIELD(POR_HNF_LDID_MAP_TABLE_REG3_U_HNF_NID72, STARTING_LDID_CXHA7, 48, 7)
    FIELD(POR_HNF_LDID_MAP_TABLE_REG3_U_HNF_NID72, RESERVED_43, 43, 5)
    FIELD(POR_HNF_LDID_MAP_TABLE_REG3_U_HNF_NID72, SRCID_CXHA7, 32, 11)
    FIELD(POR_HNF_LDID_MAP_TABLE_REG3_U_HNF_NID72, VALID_CXHA6, 31, 1)
    FIELD(POR_HNF_LDID_MAP_TABLE_REG3_U_HNF_NID72, RESERVED_23, 23, 8)
    FIELD(POR_HNF_LDID_MAP_TABLE_REG3_U_HNF_NID72, STARTING_LDID_CXHA6, 16, 7)
    FIELD(POR_HNF_LDID_MAP_TABLE_REG3_U_HNF_NID72, RESERVED_11, 11, 5)
    FIELD(POR_HNF_LDID_MAP_TABLE_REG3_U_HNF_NID72, SRCID_CXHA6, 0, 11)
REG32(POR_HNF_PPU_PWPR_U_HNF_NID72, 0x901000)
    FIELD(POR_HNF_PPU_PWPR_U_HNF_NID72, RESERVED_9, 9, 23)
    FIELD(POR_HNF_PPU_PWPR_U_HNF_NID72, DYN_EN, 8, 1)
    FIELD(POR_HNF_PPU_PWPR_U_HNF_NID72, OP_MODE, 4, 4)
    FIELD(POR_HNF_PPU_PWPR_U_HNF_NID72, POLICY, 0, 4)
REG32(POR_HNF_PPU_PWSR_U_HNF_NID72, 0x901008)
    FIELD(POR_HNF_PPU_PWSR_U_HNF_NID72, RESERVED_9, 9, 23)
    FIELD(POR_HNF_PPU_PWSR_U_HNF_NID72, DYN_EN_STATUS, 8, 1)
    FIELD(POR_HNF_PPU_PWSR_U_HNF_NID72, OP_MODE_STATUS, 4, 4)
    FIELD(POR_HNF_PPU_PWSR_U_HNF_NID72, POW_STATUS, 0, 4)
REG32(POR_HNF_PPU_MISR_U_HNF_NID72, 0x901014)
    FIELD(POR_HNF_PPU_MISR_U_HNF_NID72, PCSMACCEPT_STATUS, 0, 1)
REG32(POR_HNF_PPU_DYN_RET_THRESHOLD_U_HNF_NID72, 0x901100)
    FIELD(POR_HNF_PPU_DYN_RET_THRESHOLD_U_HNF_NID72, RESERVED_12, 12, 52)
    FIELD(POR_HNF_PPU_DYN_RET_THRESHOLD_U_HNF_NID72, DYN_RET_THRESHOLD, 0, 12)
REG32(POR_HNF_PPU_IDR0_U_HNF_NID72, 0x901fb0)
    FIELD(POR_HNF_PPU_IDR0_U_HNF_NID72, RESERVED_30, 30, 2)
    FIELD(POR_HNF_PPU_IDR0_U_HNF_NID72, DYN_WRM_RST_SPT, 29, 1)
    FIELD(POR_HNF_PPU_IDR0_U_HNF_NID72, DYN_ALL_ON_SPT, 28, 1)
    FIELD(POR_HNF_PPU_IDR0_U_HNF_NID72, DYN_FNC_RET_SPT, 27, 1)
    FIELD(POR_HNF_PPU_IDR0_U_HNF_NID72, DYN_FULL_RET_SPT, 26, 1)
    FIELD(POR_HNF_PPU_IDR0_U_HNF_NID72, DYN_MEM_OFF_SPT, 25, 1)
    FIELD(POR_HNF_PPU_IDR0_U_HNF_NID72, DYN_LGC_RET_SPT, 24, 1)
    FIELD(POR_HNF_PPU_IDR0_U_HNF_NID72, DYN_MEM_RET_EMU_SPT, 23, 1)
    FIELD(POR_HNF_PPU_IDR0_U_HNF_NID72, DYN_MEM_RET_SPT, 22, 1)
    FIELD(POR_HNF_PPU_IDR0_U_HNF_NID72, DYN_OFF_EMU_SPT, 21, 1)
    FIELD(POR_HNF_PPU_IDR0_U_HNF_NID72, DYN_ALL_OFF_SPT, 20, 1)
    FIELD(POR_HNF_PPU_IDR0_U_HNF_NID72, RESERVED_19, 19, 1)
    FIELD(POR_HNF_PPU_IDR0_U_HNF_NID72, STA_DBG_RECOV_SPT, 18, 1)
    FIELD(POR_HNF_PPU_IDR0_U_HNF_NID72, STA_WRM_RST_SPT, 17, 1)
    FIELD(POR_HNF_PPU_IDR0_U_HNF_NID72, STA_ALL_ON_SPT, 16, 1)
    FIELD(POR_HNF_PPU_IDR0_U_HNF_NID72, STA_FNC_RET_SPT, 15, 1)
    FIELD(POR_HNF_PPU_IDR0_U_HNF_NID72, STA_FULL_RET_SPT, 14, 1)
    FIELD(POR_HNF_PPU_IDR0_U_HNF_NID72, STA_MEM_OFF_SPT, 13, 1)
    FIELD(POR_HNF_PPU_IDR0_U_HNF_NID72, STA_LGC_RET_SPT, 12, 1)
    FIELD(POR_HNF_PPU_IDR0_U_HNF_NID72, STA_MEM_RET_EMU_SPT, 11, 1)
    FIELD(POR_HNF_PPU_IDR0_U_HNF_NID72, STA_MEM_RET_SPT, 10, 1)
    FIELD(POR_HNF_PPU_IDR0_U_HNF_NID72, STA_OFF_EMU_SPT, 9, 1)
    FIELD(POR_HNF_PPU_IDR0_U_HNF_NID72, STA_ALL_OFF_SPT, 8, 1)
    FIELD(POR_HNF_PPU_IDR0_U_HNF_NID72, NUM_OPMODES, 4, 4)
    FIELD(POR_HNF_PPU_IDR0_U_HNF_NID72, DEVCHAN, 0, 4)
REG32(POR_HNF_PPU_IDR1_U_HNF_NID72, 0x901fb4)
    FIELD(POR_HNF_PPU_IDR1_U_HNF_NID72, DYN_POLICY_MIN_IRQ_SPT, 3, 1)
    FIELD(POR_HNF_PPU_IDR1_U_HNF_NID72, OFF_LOCK_SPT, 2, 1)
    FIELD(POR_HNF_PPU_IDR1_U_HNF_NID72, SW_DEV_DEL_CONFIG_SPT, 1, 1)
    FIELD(POR_HNF_PPU_IDR1_U_HNF_NID72, PWR_MODE_ENTRY_DEL_SPT, 0, 1)
REG32(POR_HNF_PPU_IIDR_U_HNF_NID72, 0x901fc8)
    FIELD(POR_HNF_PPU_IIDR_U_HNF_NID72, PRODUCT_ID, 20, 12)
    FIELD(POR_HNF_PPU_IIDR_U_HNF_NID72, VARIANT, 16, 4)
    FIELD(POR_HNF_PPU_IIDR_U_HNF_NID72, REVISION, 12, 4)
    FIELD(POR_HNF_PPU_IIDR_U_HNF_NID72, IMPLEMENTER, 0, 12)
REG32(POR_HNF_PPU_AIDR_U_HNF_NID72, 0x901fcc)
    FIELD(POR_HNF_PPU_AIDR_U_HNF_NID72, ARCH_REV_MAJOR, 4, 4)
    FIELD(POR_HNF_PPU_AIDR_U_HNF_NID72, ARCH_REV_MINOR, 0, 4)
REG32(POR_HNF_PMU_EVENT_SEL_U_HNF_NID72, 0x902000)
    FIELD(POR_HNF_PMU_EVENT_SEL_U_HNF_NID72, RESERVED_35, 35, 29)
    FIELD(POR_HNF_PMU_EVENT_SEL_U_HNF_NID72, PMU_OCCUP1_ID, 32, 3)
    FIELD(POR_HNF_PMU_EVENT_SEL_U_HNF_NID72, RESERVED_29, 29, 3)
    FIELD(POR_HNF_PMU_EVENT_SEL_U_HNF_NID72, PMU_EVENT3_ID, 24, 5)
    FIELD(POR_HNF_PMU_EVENT_SEL_U_HNF_NID72, RESERVED_21, 21, 3)
    FIELD(POR_HNF_PMU_EVENT_SEL_U_HNF_NID72, PMU_EVENT2_ID, 16, 5)
    FIELD(POR_HNF_PMU_EVENT_SEL_U_HNF_NID72, RESERVED_13, 13, 3)
    FIELD(POR_HNF_PMU_EVENT_SEL_U_HNF_NID72, PMU_EVENT1_ID, 8, 5)
    FIELD(POR_HNF_PMU_EVENT_SEL_U_HNF_NID72, PMU_EVENT0_ID, 0, 5)
REG32(POR_HNF_ERRFR_U_HNF_NID72, 0x903000)
    FIELD(POR_HNF_ERRFR_U_HNF_NID72, RESERVED_15, 15, 49)
    FIELD(POR_HNF_ERRFR_U_HNF_NID72, CEC, 12, 3)
    FIELD(POR_HNF_ERRFR_U_HNF_NID72, CFI, 10, 2)
    FIELD(POR_HNF_ERRFR_U_HNF_NID72, FI, 6, 2)
    FIELD(POR_HNF_ERRFR_U_HNF_NID72, UI, 4, 2)
    FIELD(POR_HNF_ERRFR_U_HNF_NID72, DE, 2, 2)
    FIELD(POR_HNF_ERRFR_U_HNF_NID72, ED, 0, 2)
REG32(POR_HNF_ERRCTLR_U_HNF_NID72, 0x903008)
    FIELD(POR_HNF_ERRCTLR_U_HNF_NID72, RESERVED_9, 9, 55)
    FIELD(POR_HNF_ERRCTLR_U_HNF_NID72, CFI, 8, 1)
    FIELD(POR_HNF_ERRCTLR_U_HNF_NID72, FI, 3, 1)
    FIELD(POR_HNF_ERRCTLR_U_HNF_NID72, UI, 2, 1)
    FIELD(POR_HNF_ERRCTLR_U_HNF_NID72, DE, 1, 1)
    FIELD(POR_HNF_ERRCTLR_U_HNF_NID72, ED, 0, 1)
REG32(POR_HNF_ERRSTATUS_U_HNF_NID72, 0x903010)
    FIELD(POR_HNF_ERRSTATUS_U_HNF_NID72, RESERVED_32, 32, 32)
    FIELD(POR_HNF_ERRSTATUS_U_HNF_NID72, AV, 31, 1)
    FIELD(POR_HNF_ERRSTATUS_U_HNF_NID72, V, 30, 1)
    FIELD(POR_HNF_ERRSTATUS_U_HNF_NID72, UE, 29, 1)
    FIELD(POR_HNF_ERRSTATUS_U_HNF_NID72, RESERVED_28, 28, 1)
    FIELD(POR_HNF_ERRSTATUS_U_HNF_NID72, OF, 27, 1)
    FIELD(POR_HNF_ERRSTATUS_U_HNF_NID72, MV, 26, 1)
    FIELD(POR_HNF_ERRSTATUS_U_HNF_NID72, RESERVED_25, 25, 1)
    FIELD(POR_HNF_ERRSTATUS_U_HNF_NID72, CE, 24, 1)
    FIELD(POR_HNF_ERRSTATUS_U_HNF_NID72, DE, 23, 1)
    FIELD(POR_HNF_ERRSTATUS_U_HNF_NID72, RESERVED_0, 0, 23)
REG32(POR_HNF_ERRADDR_U_HNF_NID72, 0x903018)
    FIELD(POR_HNF_ERRADDR_U_HNF_NID72, NS, 63, 1)
    FIELD(POR_HNF_ERRADDR_U_HNF_NID72, RESERVED_48, 48, 15)
    FIELD(POR_HNF_ERRADDR_U_HNF_NID72, ADDR, 0, 48)
REG32(POR_HNF_ERRMISC_U_HNF_NID72, 0x903020)
    FIELD(POR_HNF_ERRMISC_U_HNF_NID72, CECOF, 63, 1)
    FIELD(POR_HNF_ERRMISC_U_HNF_NID72, SETMATCH, 62, 1)
    FIELD(POR_HNF_ERRMISC_U_HNF_NID72, RESERVED_61, 61, 1)
    FIELD(POR_HNF_ERRMISC_U_HNF_NID72, ERRSET, 48, 13)
    FIELD(POR_HNF_ERRMISC_U_HNF_NID72, CEC, 32, 16)
    FIELD(POR_HNF_ERRMISC_U_HNF_NID72, RESERVED_18, 18, 14)
    FIELD(POR_HNF_ERRMISC_U_HNF_NID72, OPTYPE, 16, 2)
    FIELD(POR_HNF_ERRMISC_U_HNF_NID72, RESERVED_15, 15, 1)
    FIELD(POR_HNF_ERRMISC_U_HNF_NID72, SRCID, 4, 11)
    FIELD(POR_HNF_ERRMISC_U_HNF_NID72, ERRSRC, 0, 4)
REG32(POR_HNF_ERR_INJ_U_HNF_NID72, 0x903030)
    FIELD(POR_HNF_ERR_INJ_U_HNF_NID72, RESERVED_27, 27, 37)
    FIELD(POR_HNF_ERR_INJ_U_HNF_NID72, HNF_ERR_INJ_SRCID, 16, 11)
    FIELD(POR_HNF_ERR_INJ_U_HNF_NID72, RESERVED_9, 9, 7)
    FIELD(POR_HNF_ERR_INJ_U_HNF_NID72, HNF_ERR_INJ_LPID, 4, 5)
    FIELD(POR_HNF_ERR_INJ_U_HNF_NID72, HNF_ERR_INJ_EN, 0, 1)
REG32(POR_HNF_BYTE_PAR_ERR_INJ_U_HNF_NID72, 0x903038)
    FIELD(POR_HNF_BYTE_PAR_ERR_INJ_U_HNF_NID72, HNF_BYTE_PAR_ERR_INJ, 0, 5)
REG32(POR_HNF_ERRFR_NS_U_HNF_NID72, 0x903100)
    FIELD(POR_HNF_ERRFR_NS_U_HNF_NID72, RESERVED_15, 15, 49)
    FIELD(POR_HNF_ERRFR_NS_U_HNF_NID72, CEC, 12, 3)
    FIELD(POR_HNF_ERRFR_NS_U_HNF_NID72, CFI, 10, 2)
    FIELD(POR_HNF_ERRFR_NS_U_HNF_NID72, FI, 6, 2)
    FIELD(POR_HNF_ERRFR_NS_U_HNF_NID72, UI, 4, 2)
    FIELD(POR_HNF_ERRFR_NS_U_HNF_NID72, DE, 2, 2)
    FIELD(POR_HNF_ERRFR_NS_U_HNF_NID72, ED, 0, 2)
REG32(POR_HNF_ERRCTLR_NS_U_HNF_NID72, 0x903108)
    FIELD(POR_HNF_ERRCTLR_NS_U_HNF_NID72, RESERVED_9, 9, 55)
    FIELD(POR_HNF_ERRCTLR_NS_U_HNF_NID72, CFI, 8, 1)
    FIELD(POR_HNF_ERRCTLR_NS_U_HNF_NID72, FI, 3, 1)
    FIELD(POR_HNF_ERRCTLR_NS_U_HNF_NID72, UI, 2, 1)
    FIELD(POR_HNF_ERRCTLR_NS_U_HNF_NID72, DE, 1, 1)
    FIELD(POR_HNF_ERRCTLR_NS_U_HNF_NID72, ED, 0, 1)
REG32(POR_HNF_ERRSTATUS_NS_U_HNF_NID72, 0x903110)
    FIELD(POR_HNF_ERRSTATUS_NS_U_HNF_NID72, RESERVED_32, 32, 32)
    FIELD(POR_HNF_ERRSTATUS_NS_U_HNF_NID72, AV, 31, 1)
    FIELD(POR_HNF_ERRSTATUS_NS_U_HNF_NID72, V, 30, 1)
    FIELD(POR_HNF_ERRSTATUS_NS_U_HNF_NID72, UE, 29, 1)
    FIELD(POR_HNF_ERRSTATUS_NS_U_HNF_NID72, RESERVED_28, 28, 1)
    FIELD(POR_HNF_ERRSTATUS_NS_U_HNF_NID72, OF, 27, 1)
    FIELD(POR_HNF_ERRSTATUS_NS_U_HNF_NID72, MV, 26, 1)
    FIELD(POR_HNF_ERRSTATUS_NS_U_HNF_NID72, RESERVED_25, 25, 1)
    FIELD(POR_HNF_ERRSTATUS_NS_U_HNF_NID72, CE, 24, 1)
    FIELD(POR_HNF_ERRSTATUS_NS_U_HNF_NID72, DE, 23, 1)
    FIELD(POR_HNF_ERRSTATUS_NS_U_HNF_NID72, RESERVED_0, 0, 23)
REG32(POR_HNF_ERRADDR_NS_U_HNF_NID72, 0x903118)
    FIELD(POR_HNF_ERRADDR_NS_U_HNF_NID72, NS, 63, 1)
    FIELD(POR_HNF_ERRADDR_NS_U_HNF_NID72, RESERVED_48, 48, 15)
    FIELD(POR_HNF_ERRADDR_NS_U_HNF_NID72, ADDR, 0, 48)
REG32(POR_HNF_ERRMISC_NS_U_HNF_NID72, 0x903120)
    FIELD(POR_HNF_ERRMISC_NS_U_HNF_NID72, CECOF, 63, 1)
    FIELD(POR_HNF_ERRMISC_NS_U_HNF_NID72, SETMATCH, 62, 1)
    FIELD(POR_HNF_ERRMISC_NS_U_HNF_NID72, RESERVED_61, 61, 1)
    FIELD(POR_HNF_ERRMISC_NS_U_HNF_NID72, ERRSET, 48, 13)
    FIELD(POR_HNF_ERRMISC_NS_U_HNF_NID72, CEC, 32, 16)
    FIELD(POR_HNF_ERRMISC_NS_U_HNF_NID72, RESERVED_18, 18, 14)
    FIELD(POR_HNF_ERRMISC_NS_U_HNF_NID72, OPTYPE, 16, 2)
    FIELD(POR_HNF_ERRMISC_NS_U_HNF_NID72, RESERVED_15, 15, 1)
    FIELD(POR_HNF_ERRMISC_NS_U_HNF_NID72, SRCID, 4, 11)
    FIELD(POR_HNF_ERRMISC_NS_U_HNF_NID72, ERRSRC, 0, 4)
REG32(POR_MXP_NODE_INFO_U_SMXP_1_1, 0x908000)
    FIELD(POR_MXP_NODE_INFO_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MXP_NODE_INFO_U_SMXP_1_1, LOGICAL_ID, 32, 16)
    FIELD(POR_MXP_NODE_INFO_U_SMXP_1_1, XY_ID, 16, 16)
    FIELD(POR_MXP_NODE_INFO_U_SMXP_1_1, NODE_TYPE, 0, 16)
REG32(POR_MXP_DEVICE_PORT_CONNECT_INFO_P0_U_SMXP_1_1, 0x908008)
    FIELD(POR_MXP_DEVICE_PORT_CONNECT_INFO_P0_U_SMXP_1_1, RESERVED_32, 32, 32)
    FIELD(POR_MXP_DEVICE_PORT_CONNECT_INFO_P0_U_SMXP_1_1, NUM_DCS_P0_D3, 28, 4)
    FIELD(POR_MXP_DEVICE_PORT_CONNECT_INFO_P0_U_SMXP_1_1, NUM_DCS_P0_D2, 24, 4)
    FIELD(POR_MXP_DEVICE_PORT_CONNECT_INFO_P0_U_SMXP_1_1, NUM_DCS_P0_D1, 20, 4)
    FIELD(POR_MXP_DEVICE_PORT_CONNECT_INFO_P0_U_SMXP_1_1, NUM_DCS_P0_D0, 16, 4)
    FIELD(POR_MXP_DEVICE_PORT_CONNECT_INFO_P0_U_SMXP_1_1, DEVICE_TYPE_P0, 0, 5)
REG32(POR_MXP_DEVICE_PORT_CONNECT_INFO_P1_U_SMXP_1_1, 0x908010)
    FIELD(POR_MXP_DEVICE_PORT_CONNECT_INFO_P1_U_SMXP_1_1, RESERVED_32, 32, 32)
    FIELD(POR_MXP_DEVICE_PORT_CONNECT_INFO_P1_U_SMXP_1_1, NUM_DCS_P1_D3, 28, 4)
    FIELD(POR_MXP_DEVICE_PORT_CONNECT_INFO_P1_U_SMXP_1_1, NUM_DCS_P1_D2, 24, 4)
    FIELD(POR_MXP_DEVICE_PORT_CONNECT_INFO_P1_U_SMXP_1_1, NUM_DCS_P1_D1, 20, 4)
    FIELD(POR_MXP_DEVICE_PORT_CONNECT_INFO_P1_U_SMXP_1_1, NUM_DCS_P1_D0, 16, 4)
    FIELD(POR_MXP_DEVICE_PORT_CONNECT_INFO_P1_U_SMXP_1_1, DEVICE_TYPE_P1, 0, 5)
REG32(POR_MXP_MESH_PORT_CONNECT_INFO_EAST_U_SMXP_1_1, 0x908018)
    FIELD(POR_MXP_MESH_PORT_CONNECT_INFO_EAST_U_SMXP_1_1, NUM_MCS_EAST, 0, 4)
REG32(POR_MXP_MESH_PORT_CONNECT_INFO_NORTH_U_SMXP_1_1, 0x908020)
    FIELD(POR_MXP_MESH_PORT_CONNECT_INFO_NORTH_U_SMXP_1_1, NUM_MCS_NORTH, 0, 4)
REG32(POR_MXP_CHILD_INFO_U_SMXP_1_1, 0x908080)
    FIELD(POR_MXP_CHILD_INFO_U_SMXP_1_1, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_INFO_U_SMXP_1_1, CHILD_PTR_OFFSET, 16, 16)
    FIELD(POR_MXP_CHILD_INFO_U_SMXP_1_1, CHILD_COUNT, 0, 16)
REG32(POR_MXP_CHILD_POINTER_0_U_SMXP_1_1, 0x908100)
    FIELD(POR_MXP_CHILD_POINTER_0_U_SMXP_1_1, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_POINTER_0_U_SMXP_1_1, RELATIVE_ADDRESS_0, 0, 32)
REG32(POR_MXP_CHILD_POINTER_1_U_SMXP_1_1, 0x908108)
    FIELD(POR_MXP_CHILD_POINTER_1_U_SMXP_1_1, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_POINTER_1_U_SMXP_1_1, RELATIVE_ADDRESS_1, 0, 32)
REG32(POR_MXP_CHILD_POINTER_2_U_SMXP_1_1, 0x908110)
    FIELD(POR_MXP_CHILD_POINTER_2_U_SMXP_1_1, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_POINTER_2_U_SMXP_1_1, RELATIVE_ADDRESS_2, 0, 32)
REG32(POR_MXP_CHILD_POINTER_3_U_SMXP_1_1, 0x908118)
    FIELD(POR_MXP_CHILD_POINTER_3_U_SMXP_1_1, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_POINTER_3_U_SMXP_1_1, RELATIVE_ADDRESS_3, 0, 32)
REG32(POR_MXP_CHILD_POINTER_4_U_SMXP_1_1, 0x908120)
    FIELD(POR_MXP_CHILD_POINTER_4_U_SMXP_1_1, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_POINTER_4_U_SMXP_1_1, RELATIVE_ADDRESS_4, 0, 32)
REG32(POR_MXP_CHILD_POINTER_5_U_SMXP_1_1, 0x908128)
    FIELD(POR_MXP_CHILD_POINTER_5_U_SMXP_1_1, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_POINTER_5_U_SMXP_1_1, RELATIVE_ADDRESS_5, 0, 32)
REG32(POR_MXP_CHILD_POINTER_6_U_SMXP_1_1, 0x908130)
    FIELD(POR_MXP_CHILD_POINTER_6_U_SMXP_1_1, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_POINTER_6_U_SMXP_1_1, RELATIVE_ADDRESS_6, 0, 32)
REG32(POR_MXP_CHILD_POINTER_7_U_SMXP_1_1, 0x908138)
    FIELD(POR_MXP_CHILD_POINTER_7_U_SMXP_1_1, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_POINTER_7_U_SMXP_1_1, RELATIVE_ADDRESS_7, 0, 32)
REG32(POR_MXP_CHILD_POINTER_8_U_SMXP_1_1, 0x908140)
    FIELD(POR_MXP_CHILD_POINTER_8_U_SMXP_1_1, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_POINTER_8_U_SMXP_1_1, RELATIVE_ADDRESS_8, 0, 32)
REG32(POR_MXP_CHILD_POINTER_9_U_SMXP_1_1, 0x908148)
    FIELD(POR_MXP_CHILD_POINTER_9_U_SMXP_1_1, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_POINTER_9_U_SMXP_1_1, RELATIVE_ADDRESS_9, 0, 32)
REG32(POR_MXP_CHILD_POINTER_10_U_SMXP_1_1, 0x908150)
    FIELD(POR_MXP_CHILD_POINTER_10_U_SMXP_1_1, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_POINTER_10_U_SMXP_1_1, RELATIVE_ADDRESS_10, 0, 32)
REG32(POR_MXP_CHILD_POINTER_11_U_SMXP_1_1, 0x908158)
    FIELD(POR_MXP_CHILD_POINTER_11_U_SMXP_1_1, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_POINTER_11_U_SMXP_1_1, RELATIVE_ADDRESS_11, 0, 32)
REG32(POR_MXP_CHILD_POINTER_12_U_SMXP_1_1, 0x908160)
    FIELD(POR_MXP_CHILD_POINTER_12_U_SMXP_1_1, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_POINTER_12_U_SMXP_1_1, RELATIVE_ADDRESS_12, 0, 32)
REG32(POR_MXP_CHILD_POINTER_13_U_SMXP_1_1, 0x908168)
    FIELD(POR_MXP_CHILD_POINTER_13_U_SMXP_1_1, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_POINTER_13_U_SMXP_1_1, RELATIVE_ADDRESS_13, 0, 32)
REG32(POR_MXP_CHILD_POINTER_14_U_SMXP_1_1, 0x908170)
    FIELD(POR_MXP_CHILD_POINTER_14_U_SMXP_1_1, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_POINTER_14_U_SMXP_1_1, RELATIVE_ADDRESS_14, 0, 32)
REG32(POR_MXP_CHILD_POINTER_15_U_SMXP_1_1, 0x908178)
    FIELD(POR_MXP_CHILD_POINTER_15_U_SMXP_1_1, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_POINTER_15_U_SMXP_1_1, RELATIVE_ADDRESS_15, 0, 32)
REG32(POR_MXP_P0_INFO_U_SMXP_1_1, 0x908900)
    FIELD(POR_MXP_P0_INFO_U_SMXP_1_1, RESERVED_26, 26, 38)
    FIELD(POR_MXP_P0_INFO_U_SMXP_1_1, A4S_SAFE_XFACE_DISABLE_P0, 25, 1)
    FIELD(POR_MXP_P0_INFO_U_SMXP_1_1, CHI_SAFE_XFACE_DISABLE_P0, 24, 1)
    FIELD(POR_MXP_P0_INFO_U_SMXP_1_1, A4S_LOGICALID_BASE_P0, 16, 8)
    FIELD(POR_MXP_P0_INFO_U_SMXP_1_1, RESERVED_14, 14, 2)
    FIELD(POR_MXP_P0_INFO_U_SMXP_1_1, A4S_NUM_P0, 11, 3)
    FIELD(POR_MXP_P0_INFO_U_SMXP_1_1, RXBUF_NUM_ENTRIES_P0, 8, 3)
    FIELD(POR_MXP_P0_INFO_U_SMXP_1_1, EXT_SAM_EN_P0, 7, 1)
    FIELD(POR_MXP_P0_INFO_U_SMXP_1_1, DATACHECK_EN_P0, 5, 1)
    FIELD(POR_MXP_P0_INFO_U_SMXP_1_1, POISON_EN_P0, 4, 1)
    FIELD(POR_MXP_P0_INFO_U_SMXP_1_1, NUM_DEV_P0, 0, 3)
REG32(POR_MXP_P1_INFO_U_SMXP_1_1, 0x908908)
    FIELD(POR_MXP_P1_INFO_U_SMXP_1_1, RESERVED_26, 26, 38)
    FIELD(POR_MXP_P1_INFO_U_SMXP_1_1, A4S_SAFE_XFACE_DISABLE_P1, 25, 1)
    FIELD(POR_MXP_P1_INFO_U_SMXP_1_1, CHI_SAFE_XFACE_DISABLE_P1, 24, 1)
    FIELD(POR_MXP_P1_INFO_U_SMXP_1_1, A4S_LOGICALID_BASE_P1, 16, 8)
    FIELD(POR_MXP_P1_INFO_U_SMXP_1_1, RESERVED_14, 14, 2)
    FIELD(POR_MXP_P1_INFO_U_SMXP_1_1, A4S_NUM_P1, 11, 3)
    FIELD(POR_MXP_P1_INFO_U_SMXP_1_1, RXBUF_NUM_ENTRIES_P1, 8, 3)
    FIELD(POR_MXP_P1_INFO_U_SMXP_1_1, EXT_SAM_EN_P1, 7, 1)
    FIELD(POR_MXP_P1_INFO_U_SMXP_1_1, DATACHECK_EN_P1, 5, 1)
    FIELD(POR_MXP_P1_INFO_U_SMXP_1_1, POISON_EN_P1, 4, 1)
    FIELD(POR_MXP_P1_INFO_U_SMXP_1_1, NUM_DEV_P1, 0, 3)
REG32(POR_MXP_SECURE_REGISTER_GROUPS_OVERRIDE_U_SMXP_1_1, 0x908980)
    FIELD(POR_MXP_SECURE_REGISTER_GROUPS_OVERRIDE_U_SMXP_1_1, SYSCOREQ_CTL, 1, 1)
    FIELD(POR_MXP_SECURE_REGISTER_GROUPS_OVERRIDE_U_SMXP_1_1, QOS, 0, 1)
REG32(POR_MXP_AUX_CTL_U_SMXP_1_1, 0x908a00)
    FIELD(POR_MXP_AUX_CTL_U_SMXP_1_1, CLKGATE_DISABLE, 0, 1)
REG32(POR_MXP_P0_QOS_CONTROL_U_SMXP_1_1, 0x908a80)
    FIELD(POR_MXP_P0_QOS_CONTROL_U_SMXP_1_1, RESERVED_20, 20, 44)
    FIELD(POR_MXP_P0_QOS_CONTROL_U_SMXP_1_1, P0_QOS_OVERRIDE, 16, 4)
    FIELD(POR_MXP_P0_QOS_CONTROL_U_SMXP_1_1, P0_PQV_MODE, 6, 1)
    FIELD(POR_MXP_P0_QOS_CONTROL_U_SMXP_1_1, P0_REG_MODE, 4, 1)
    FIELD(POR_MXP_P0_QOS_CONTROL_U_SMXP_1_1, P0_QOS_OVERRIDE_EN, 2, 1)
    FIELD(POR_MXP_P0_QOS_CONTROL_U_SMXP_1_1, P0_LAT_EN, 0, 1)
REG32(POR_MXP_P0_QOS_LAT_TGT_U_SMXP_1_1, 0x908a88)
    FIELD(POR_MXP_P0_QOS_LAT_TGT_U_SMXP_1_1, RESERVED_12, 12, 52)
    FIELD(POR_MXP_P0_QOS_LAT_TGT_U_SMXP_1_1, P0_LAT_TGT, 0, 12)
REG32(POR_MXP_P0_QOS_LAT_SCALE_U_SMXP_1_1, 0x908a90)
    FIELD(POR_MXP_P0_QOS_LAT_SCALE_U_SMXP_1_1, P0_LAT_SCALE, 0, 3)
REG32(POR_MXP_P0_QOS_LAT_RANGE_U_SMXP_1_1, 0x908a98)
    FIELD(POR_MXP_P0_QOS_LAT_RANGE_U_SMXP_1_1, RESERVED_12, 12, 52)
    FIELD(POR_MXP_P0_QOS_LAT_RANGE_U_SMXP_1_1, P0_LAT_MAX_QOS, 8, 4)
    FIELD(POR_MXP_P0_QOS_LAT_RANGE_U_SMXP_1_1, P0_LAT_MIN_QOS, 0, 4)
REG32(POR_MXP_P1_QOS_CONTROL_U_SMXP_1_1, 0x908aa0)
    FIELD(POR_MXP_P1_QOS_CONTROL_U_SMXP_1_1, RESERVED_20, 20, 44)
    FIELD(POR_MXP_P1_QOS_CONTROL_U_SMXP_1_1, P1_QOS_OVERRIDE, 16, 4)
    FIELD(POR_MXP_P1_QOS_CONTROL_U_SMXP_1_1, P1_PQV_MODE, 6, 1)
    FIELD(POR_MXP_P1_QOS_CONTROL_U_SMXP_1_1, P1_REG_MODE, 4, 1)
    FIELD(POR_MXP_P1_QOS_CONTROL_U_SMXP_1_1, P1_QOS_OVERRIDE_EN, 2, 1)
    FIELD(POR_MXP_P1_QOS_CONTROL_U_SMXP_1_1, P1_LAT_EN, 0, 1)
REG32(POR_MXP_P1_QOS_LAT_TGT_U_SMXP_1_1, 0x908aa8)
    FIELD(POR_MXP_P1_QOS_LAT_TGT_U_SMXP_1_1, RESERVED_12, 12, 52)
    FIELD(POR_MXP_P1_QOS_LAT_TGT_U_SMXP_1_1, P1_LAT_TGT, 0, 12)
REG32(POR_MXP_P1_QOS_LAT_SCALE_U_SMXP_1_1, 0x908ab0)
    FIELD(POR_MXP_P1_QOS_LAT_SCALE_U_SMXP_1_1, P1_LAT_SCALE, 0, 3)
REG32(POR_MXP_P1_QOS_LAT_RANGE_U_SMXP_1_1, 0x908ab8)
    FIELD(POR_MXP_P1_QOS_LAT_RANGE_U_SMXP_1_1, RESERVED_12, 12, 52)
    FIELD(POR_MXP_P1_QOS_LAT_RANGE_U_SMXP_1_1, P1_LAT_MAX_QOS, 8, 4)
    FIELD(POR_MXP_P1_QOS_LAT_RANGE_U_SMXP_1_1, P1_LAT_MIN_QOS, 0, 4)
REG32(POR_MXP_P0_SYSCOREQ_CTL_U_SMXP_1_1, 0x909000)
    FIELD(POR_MXP_P0_SYSCOREQ_CTL_U_SMXP_1_1, SNPDVM_REQ_P0_D3, 3, 1)
    FIELD(POR_MXP_P0_SYSCOREQ_CTL_U_SMXP_1_1, SNPDVM_REQ_P0_D2, 2, 1)
    FIELD(POR_MXP_P0_SYSCOREQ_CTL_U_SMXP_1_1, SNPDVM_REQ_P0_D1, 1, 1)
    FIELD(POR_MXP_P0_SYSCOREQ_CTL_U_SMXP_1_1, SNPDVM_REQ_P0_D0, 0, 1)
REG32(POR_MXP_P1_SYSCOREQ_CTL_U_SMXP_1_1, 0x909008)
    FIELD(POR_MXP_P1_SYSCOREQ_CTL_U_SMXP_1_1, SNPDVM_REQ_P1_D3, 3, 1)
    FIELD(POR_MXP_P1_SYSCOREQ_CTL_U_SMXP_1_1, SNPDVM_REQ_P1_D2, 2, 1)
    FIELD(POR_MXP_P1_SYSCOREQ_CTL_U_SMXP_1_1, SNPDVM_REQ_P1_D1, 1, 1)
    FIELD(POR_MXP_P1_SYSCOREQ_CTL_U_SMXP_1_1, SNPDVM_REQ_P1_D0, 0, 1)
REG32(POR_MXP_P0_SYSCOACK_STATUS_U_SMXP_1_1, 0x909010)
    FIELD(POR_MXP_P0_SYSCOACK_STATUS_U_SMXP_1_1, SNPDVM_ACK_P0_D3, 3, 1)
    FIELD(POR_MXP_P0_SYSCOACK_STATUS_U_SMXP_1_1, SNPDVM_ACK_P0_D2, 2, 1)
    FIELD(POR_MXP_P0_SYSCOACK_STATUS_U_SMXP_1_1, SNPDVM_ACK_P0_D1, 1, 1)
    FIELD(POR_MXP_P0_SYSCOACK_STATUS_U_SMXP_1_1, SNPDVM_ACK_P0_D0, 0, 1)
REG32(POR_MXP_P1_SYSCOACK_STATUS_U_SMXP_1_1, 0x909018)
    FIELD(POR_MXP_P1_SYSCOACK_STATUS_U_SMXP_1_1, SNPDVM_ACK_P1_D3, 3, 1)
    FIELD(POR_MXP_P1_SYSCOACK_STATUS_U_SMXP_1_1, SNPDVM_ACK_P1_D2, 2, 1)
    FIELD(POR_MXP_P1_SYSCOACK_STATUS_U_SMXP_1_1, SNPDVM_ACK_P1_D1, 1, 1)
    FIELD(POR_MXP_P1_SYSCOACK_STATUS_U_SMXP_1_1, SNPDVM_ACK_P1_D0, 0, 1)
REG32(POR_MXP_PMU_EVENT_SEL_U_SMXP_1_1, 0x90a000)
    FIELD(POR_MXP_PMU_EVENT_SEL_U_SMXP_1_1, RESERVED_32, 32, 32)
    FIELD(POR_MXP_PMU_EVENT_SEL_U_SMXP_1_1, PMU_EVENT3_ID, 24, 8)
    FIELD(POR_MXP_PMU_EVENT_SEL_U_SMXP_1_1, PMU_EVENT2_ID, 16, 8)
    FIELD(POR_MXP_PMU_EVENT_SEL_U_SMXP_1_1, PMU_EVENT1_ID, 8, 8)
    FIELD(POR_MXP_PMU_EVENT_SEL_U_SMXP_1_1, PMU_EVENT0_ID, 0, 8)
REG32(POR_DTM_CONTROL_U_SMXP_1_1, 0x90a100)
    FIELD(POR_DTM_CONTROL_U_SMXP_1_1, TRACE_NO_ATB, 3, 1)
    FIELD(POR_DTM_CONTROL_U_SMXP_1_1, SAMPLE_PROFILE_ENABLE, 2, 1)
    FIELD(POR_DTM_CONTROL_U_SMXP_1_1, TRACE_TAG_ENABLE, 1, 1)
    FIELD(POR_DTM_CONTROL_U_SMXP_1_1, DTM_ENABLE, 0, 1)
REG32(POR_DTM_FIFO_ENTRY_READY_U_SMXP_1_1, 0x90a118)
    FIELD(POR_DTM_FIFO_ENTRY_READY_U_SMXP_1_1, READY, 0, 4)
REG32(POR_DTM_FIFO_ENTRY0_0_U_SMXP_1_1, 0x90a120)
REG32(POR_DTM_FIFO_ENTRY0_1_U_SMXP_1_1, 0x90a128)
REG32(POR_DTM_FIFO_ENTRY0_2_U_SMXP_1_1, 0x90a130)
    FIELD(POR_DTM_FIFO_ENTRY0_2_U_SMXP_1_1, RESERVED_32, 32, 32)
    FIELD(POR_DTM_FIFO_ENTRY0_2_U_SMXP_1_1, FIFO_CYCLE_COUNT, 16, 16)
    FIELD(POR_DTM_FIFO_ENTRY0_2_U_SMXP_1_1, FIFO_DATA2, 0, 16)
REG32(POR_DTM_FIFO_ENTRY1_0_U_SMXP_1_1, 0x90a138)
REG32(POR_DTM_FIFO_ENTRY1_1_U_SMXP_1_1, 0x90a140)
REG32(POR_DTM_FIFO_ENTRY1_2_U_SMXP_1_1, 0x90a148)
    FIELD(POR_DTM_FIFO_ENTRY1_2_U_SMXP_1_1, RESERVED_32, 32, 32)
    FIELD(POR_DTM_FIFO_ENTRY1_2_U_SMXP_1_1, FIFO_CYCLE_COUNT, 16, 16)
    FIELD(POR_DTM_FIFO_ENTRY1_2_U_SMXP_1_1, FIFO_DATA2, 0, 16)
REG32(POR_DTM_FIFO_ENTRY2_0_U_SMXP_1_1, 0x90a150)
REG32(POR_DTM_FIFO_ENTRY2_1_U_SMXP_1_1, 0x90a158)
REG32(POR_DTM_FIFO_ENTRY2_2_U_SMXP_1_1, 0x90a160)
    FIELD(POR_DTM_FIFO_ENTRY2_2_U_SMXP_1_1, RESERVED_32, 32, 32)
    FIELD(POR_DTM_FIFO_ENTRY2_2_U_SMXP_1_1, FIFO_CYCLE_COUNT, 16, 16)
    FIELD(POR_DTM_FIFO_ENTRY2_2_U_SMXP_1_1, FIFO_DATA2, 0, 16)
REG32(POR_DTM_FIFO_ENTRY3_0_U_SMXP_1_1, 0x90a168)
REG32(POR_DTM_FIFO_ENTRY3_1_U_SMXP_1_1, 0x90a170)
REG32(POR_DTM_FIFO_ENTRY3_2_U_SMXP_1_1, 0x90a178)
    FIELD(POR_DTM_FIFO_ENTRY3_2_U_SMXP_1_1, RESERVED_32, 32, 32)
    FIELD(POR_DTM_FIFO_ENTRY3_2_U_SMXP_1_1, FIFO_CYCLE_COUNT, 16, 16)
    FIELD(POR_DTM_FIFO_ENTRY3_2_U_SMXP_1_1, FIFO_DATA2, 0, 16)
REG32(POR_DTM_WP0_CONFIG_U_SMXP_1_1, 0x90a1a0)
    FIELD(POR_DTM_WP0_CONFIG_U_SMXP_1_1, RESERVED_15, 15, 49)
    FIELD(POR_DTM_WP0_CONFIG_U_SMXP_1_1, WP_DBGTRIG_EN, 14, 1)
    FIELD(POR_DTM_WP0_CONFIG_U_SMXP_1_1, WP_CTRIG_EN, 13, 1)
    FIELD(POR_DTM_WP0_CONFIG_U_SMXP_1_1, WP_CC_EN, 12, 1)
    FIELD(POR_DTM_WP0_CONFIG_U_SMXP_1_1, WP_PKT_TYPE, 9, 3)
    FIELD(POR_DTM_WP0_CONFIG_U_SMXP_1_1, WP_PKT_GEN, 8, 1)
    FIELD(POR_DTM_WP0_CONFIG_U_SMXP_1_1, WP_COMBINE, 6, 1)
    FIELD(POR_DTM_WP0_CONFIG_U_SMXP_1_1, WP_EXCLUSIVE, 5, 1)
    FIELD(POR_DTM_WP0_CONFIG_U_SMXP_1_1, WP_GRP, 4, 1)
    FIELD(POR_DTM_WP0_CONFIG_U_SMXP_1_1, WP_CHN_SEL, 1, 3)
    FIELD(POR_DTM_WP0_CONFIG_U_SMXP_1_1, WP_DEV_SEL, 0, 1)
REG32(POR_DTM_WP0_VAL_U_SMXP_1_1, 0x90a1a8)
REG32(POR_DTM_WP0_MASK_U_SMXP_1_1, 0x90a1b0)
REG32(POR_DTM_WP1_CONFIG_U_SMXP_1_1, 0x90a1b8)
    FIELD(POR_DTM_WP1_CONFIG_U_SMXP_1_1, RESERVED_15, 15, 49)
    FIELD(POR_DTM_WP1_CONFIG_U_SMXP_1_1, WP_DBGTRIG_EN, 14, 1)
    FIELD(POR_DTM_WP1_CONFIG_U_SMXP_1_1, WP_CTRIG_EN, 13, 1)
    FIELD(POR_DTM_WP1_CONFIG_U_SMXP_1_1, WP_CC_EN, 12, 1)
    FIELD(POR_DTM_WP1_CONFIG_U_SMXP_1_1, WP_PKT_TYPE, 9, 3)
    FIELD(POR_DTM_WP1_CONFIG_U_SMXP_1_1, WP_PKT_GEN, 8, 1)
    FIELD(POR_DTM_WP1_CONFIG_U_SMXP_1_1, WP_EXCLUSIVE, 5, 1)
    FIELD(POR_DTM_WP1_CONFIG_U_SMXP_1_1, WP_GRP, 4, 1)
    FIELD(POR_DTM_WP1_CONFIG_U_SMXP_1_1, WP_CHN_SEL, 1, 3)
    FIELD(POR_DTM_WP1_CONFIG_U_SMXP_1_1, WP_DEV_SEL, 0, 1)
REG32(POR_DTM_WP1_VAL_U_SMXP_1_1, 0x90a1c0)
REG32(POR_DTM_WP1_MASK_U_SMXP_1_1, 0x90a1c8)
REG32(POR_DTM_WP2_CONFIG_U_SMXP_1_1, 0x90a1d0)
    FIELD(POR_DTM_WP2_CONFIG_U_SMXP_1_1, RESERVED_15, 15, 49)
    FIELD(POR_DTM_WP2_CONFIG_U_SMXP_1_1, WP_DBGTRIG_EN, 14, 1)
    FIELD(POR_DTM_WP2_CONFIG_U_SMXP_1_1, WP_CTRIG_EN, 13, 1)
    FIELD(POR_DTM_WP2_CONFIG_U_SMXP_1_1, WP_CC_EN, 12, 1)
    FIELD(POR_DTM_WP2_CONFIG_U_SMXP_1_1, WP_PKT_TYPE, 9, 3)
    FIELD(POR_DTM_WP2_CONFIG_U_SMXP_1_1, WP_PKT_GEN, 8, 1)
    FIELD(POR_DTM_WP2_CONFIG_U_SMXP_1_1, WP_COMBINE, 6, 1)
    FIELD(POR_DTM_WP2_CONFIG_U_SMXP_1_1, WP_EXCLUSIVE, 5, 1)
    FIELD(POR_DTM_WP2_CONFIG_U_SMXP_1_1, WP_GRP, 4, 1)
    FIELD(POR_DTM_WP2_CONFIG_U_SMXP_1_1, WP_CHN_SEL, 1, 3)
    FIELD(POR_DTM_WP2_CONFIG_U_SMXP_1_1, WP_DEV_SEL, 0, 1)
REG32(POR_DTM_WP2_VAL_U_SMXP_1_1, 0x90a1d8)
REG32(POR_DTM_WP2_MASK_U_SMXP_1_1, 0x90a1e0)
REG32(POR_DTM_WP3_CONFIG_U_SMXP_1_1, 0x90a1e8)
    FIELD(POR_DTM_WP3_CONFIG_U_SMXP_1_1, RESERVED_15, 15, 49)
    FIELD(POR_DTM_WP3_CONFIG_U_SMXP_1_1, WP_DBGTRIG_EN, 14, 1)
    FIELD(POR_DTM_WP3_CONFIG_U_SMXP_1_1, WP_CTRIG_EN, 13, 1)
    FIELD(POR_DTM_WP3_CONFIG_U_SMXP_1_1, WP_CC_EN, 12, 1)
    FIELD(POR_DTM_WP3_CONFIG_U_SMXP_1_1, WP_PKT_TYPE, 9, 3)
    FIELD(POR_DTM_WP3_CONFIG_U_SMXP_1_1, WP_PKT_GEN, 8, 1)
    FIELD(POR_DTM_WP3_CONFIG_U_SMXP_1_1, WP_EXCLUSIVE, 5, 1)
    FIELD(POR_DTM_WP3_CONFIG_U_SMXP_1_1, WP_GRP, 4, 1)
    FIELD(POR_DTM_WP3_CONFIG_U_SMXP_1_1, WP_CHN_SEL, 1, 3)
    FIELD(POR_DTM_WP3_CONFIG_U_SMXP_1_1, WP_DEV_SEL, 0, 1)
REG32(POR_DTM_WP3_VAL_U_SMXP_1_1, 0x90a1f0)
REG32(POR_DTM_WP3_MASK_U_SMXP_1_1, 0x90a1f8)
REG32(POR_DTM_PMSICR_U_SMXP_1_1, 0x90a200)
    FIELD(POR_DTM_PMSICR_U_SMXP_1_1, RESERVED_32, 32, 32)
    FIELD(POR_DTM_PMSICR_U_SMXP_1_1, COUNT, 0, 32)
REG32(POR_DTM_PMSIRR_U_SMXP_1_1, 0x90a208)
    FIELD(POR_DTM_PMSIRR_U_SMXP_1_1, RESERVED_32, 32, 32)
    FIELD(POR_DTM_PMSIRR_U_SMXP_1_1, INTERVAL, 8, 24)
    FIELD(POR_DTM_PMSIRR_U_SMXP_1_1, RESERVED_0, 0, 8)
REG32(POR_DTM_PMU_CONFIG_U_SMXP_1_1, 0x90a210)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_1_1, RESERVED_62, 62, 2)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_1_1, PMEVCNT3_INPUT_SEL, 56, 6)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_1_1, RESERVED_54, 54, 2)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_1_1, PMEVCNT2_INPUT_SEL, 48, 6)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_1_1, RESERVED_46, 46, 2)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_1_1, PMEVCNT1_INPUT_SEL, 40, 6)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_1_1, RESERVED_38, 38, 2)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_1_1, PMEVCNT0_INPUT_SEL, 32, 6)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_1_1, RESERVED_31, 31, 1)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_1_1, PMEVCNT3_GLOBAL_NUM, 28, 3)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_1_1, RESERVED_27, 27, 1)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_1_1, PMEVCNT2_GLOBAL_NUM, 24, 3)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_1_1, RESERVED_23, 23, 1)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_1_1, PMEVCNT1_GLOBAL_NUM, 20, 3)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_1_1, RESERVED_19, 19, 1)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_1_1, PMEVCNT0_GLOBAL_NUM, 16, 3)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_1_1, RESERVED_9, 9, 7)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_1_1, CNTR_RST, 8, 1)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_1_1, PMEVCNT_PAIRED, 4, 4)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_1_1, PMEVCNTALL_COMBINED, 3, 1)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_1_1, PMEVCNT23_COMBINED, 2, 1)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_1_1, PMEVCNT01_COMBINED, 1, 1)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_1_1, PMU_EN, 0, 1)
REG32(POR_DTM_PMEVCNT_U_SMXP_1_1, 0x90a220)
    FIELD(POR_DTM_PMEVCNT_U_SMXP_1_1, PMEVCNT3, 48, 16)
    FIELD(POR_DTM_PMEVCNT_U_SMXP_1_1, PMEVCNT2, 32, 16)
    FIELD(POR_DTM_PMEVCNT_U_SMXP_1_1, PMEVCNT1, 16, 16)
    FIELD(POR_DTM_PMEVCNT_U_SMXP_1_1, PMEVCNT0, 0, 16)
REG32(POR_DTM_PMEVCNTSR_U_SMXP_1_1, 0x90a240)
    FIELD(POR_DTM_PMEVCNTSR_U_SMXP_1_1, PMEVCNTSR3, 48, 16)
    FIELD(POR_DTM_PMEVCNTSR_U_SMXP_1_1, PMEVCNTSR2, 32, 16)
    FIELD(POR_DTM_PMEVCNTSR_U_SMXP_1_1, PMEVCNTSR1, 16, 16)
    FIELD(POR_DTM_PMEVCNTSR_U_SMXP_1_1, PMEVCNTSR0, 0, 16)
REG32(POR_MXP_ERRFR_U_SMXP_1_1, 0x90b000)
    FIELD(POR_MXP_ERRFR_U_SMXP_1_1, RESERVED_15, 15, 49)
    FIELD(POR_MXP_ERRFR_U_SMXP_1_1, CEC, 12, 3)
    FIELD(POR_MXP_ERRFR_U_SMXP_1_1, CFI, 10, 2)
    FIELD(POR_MXP_ERRFR_U_SMXP_1_1, FI, 6, 2)
    FIELD(POR_MXP_ERRFR_U_SMXP_1_1, UI, 4, 2)
    FIELD(POR_MXP_ERRFR_U_SMXP_1_1, DE, 2, 2)
    FIELD(POR_MXP_ERRFR_U_SMXP_1_1, ED, 0, 2)
REG32(POR_MXP_ERRCTLR_U_SMXP_1_1, 0x90b008)
    FIELD(POR_MXP_ERRCTLR_U_SMXP_1_1, RESERVED_9, 9, 55)
    FIELD(POR_MXP_ERRCTLR_U_SMXP_1_1, CFI, 8, 1)
    FIELD(POR_MXP_ERRCTLR_U_SMXP_1_1, FI, 3, 1)
    FIELD(POR_MXP_ERRCTLR_U_SMXP_1_1, UI, 2, 1)
    FIELD(POR_MXP_ERRCTLR_U_SMXP_1_1, DE, 1, 1)
    FIELD(POR_MXP_ERRCTLR_U_SMXP_1_1, ED, 0, 1)
REG32(POR_MXP_ERRSTATUS_U_SMXP_1_1, 0x90b010)
    FIELD(POR_MXP_ERRSTATUS_U_SMXP_1_1, RESERVED_32, 32, 32)
    FIELD(POR_MXP_ERRSTATUS_U_SMXP_1_1, AV, 31, 1)
    FIELD(POR_MXP_ERRSTATUS_U_SMXP_1_1, V, 30, 1)
    FIELD(POR_MXP_ERRSTATUS_U_SMXP_1_1, UE, 29, 1)
    FIELD(POR_MXP_ERRSTATUS_U_SMXP_1_1, RESERVED_28, 28, 1)
    FIELD(POR_MXP_ERRSTATUS_U_SMXP_1_1, OF, 27, 1)
    FIELD(POR_MXP_ERRSTATUS_U_SMXP_1_1, MV, 26, 1)
    FIELD(POR_MXP_ERRSTATUS_U_SMXP_1_1, RESERVED_25, 25, 1)
    FIELD(POR_MXP_ERRSTATUS_U_SMXP_1_1, CE, 24, 1)
    FIELD(POR_MXP_ERRSTATUS_U_SMXP_1_1, DE, 23, 1)
    FIELD(POR_MXP_ERRSTATUS_U_SMXP_1_1, RESERVED_0, 0, 23)
REG32(POR_MXP_ERRMISC_U_SMXP_1_1, 0x90b028)
    FIELD(POR_MXP_ERRMISC_U_SMXP_1_1, RESERVED_59, 59, 5)
    FIELD(POR_MXP_ERRMISC_U_SMXP_1_1, TGTID, 48, 11)
    FIELD(POR_MXP_ERRMISC_U_SMXP_1_1, RESERVED_22, 22, 26)
    FIELD(POR_MXP_ERRMISC_U_SMXP_1_1, OPCODE, 16, 6)
    FIELD(POR_MXP_ERRMISC_U_SMXP_1_1, RESERVED_15, 15, 1)
    FIELD(POR_MXP_ERRMISC_U_SMXP_1_1, SRCID, 4, 11)
    FIELD(POR_MXP_ERRMISC_U_SMXP_1_1, ERRSRC, 0, 3)
REG32(POR_MXP_P0_BYTE_PAR_ERR_INJ_U_SMXP_1_1, 0x90b030)
    FIELD(POR_MXP_P0_BYTE_PAR_ERR_INJ_U_SMXP_1_1, P0_BYTE_PARITY_ERR_INJ, 0, 5)
REG32(POR_MXP_P1_BYTE_PAR_ERR_INJ_U_SMXP_1_1, 0x90b038)
    FIELD(POR_MXP_P1_BYTE_PAR_ERR_INJ_U_SMXP_1_1, P1_BYTE_PARITY_ERR_INJ, 0, 5)
REG32(POR_MXP_ERRFR_NS_U_SMXP_1_1, 0x90b100)
    FIELD(POR_MXP_ERRFR_NS_U_SMXP_1_1, RESERVED_15, 15, 49)
    FIELD(POR_MXP_ERRFR_NS_U_SMXP_1_1, CEC, 12, 3)
    FIELD(POR_MXP_ERRFR_NS_U_SMXP_1_1, CFI, 10, 2)
    FIELD(POR_MXP_ERRFR_NS_U_SMXP_1_1, FI, 6, 2)
    FIELD(POR_MXP_ERRFR_NS_U_SMXP_1_1, UI, 4, 2)
    FIELD(POR_MXP_ERRFR_NS_U_SMXP_1_1, DE, 2, 2)
    FIELD(POR_MXP_ERRFR_NS_U_SMXP_1_1, ED, 0, 2)
REG32(POR_MXP_ERRCTLR_NS_U_SMXP_1_1, 0x90b108)
    FIELD(POR_MXP_ERRCTLR_NS_U_SMXP_1_1, RESERVED_9, 9, 55)
    FIELD(POR_MXP_ERRCTLR_NS_U_SMXP_1_1, CFI, 8, 1)
    FIELD(POR_MXP_ERRCTLR_NS_U_SMXP_1_1, FI, 3, 1)
    FIELD(POR_MXP_ERRCTLR_NS_U_SMXP_1_1, UI, 2, 1)
    FIELD(POR_MXP_ERRCTLR_NS_U_SMXP_1_1, DE, 1, 1)
    FIELD(POR_MXP_ERRCTLR_NS_U_SMXP_1_1, ED, 0, 1)
REG32(POR_MXP_ERRSTATUS_NS_U_SMXP_1_1, 0x90b110)
    FIELD(POR_MXP_ERRSTATUS_NS_U_SMXP_1_1, RESERVED_32, 32, 32)
    FIELD(POR_MXP_ERRSTATUS_NS_U_SMXP_1_1, AV, 31, 1)
    FIELD(POR_MXP_ERRSTATUS_NS_U_SMXP_1_1, V, 30, 1)
    FIELD(POR_MXP_ERRSTATUS_NS_U_SMXP_1_1, UE, 29, 1)
    FIELD(POR_MXP_ERRSTATUS_NS_U_SMXP_1_1, RESERVED_28, 28, 1)
    FIELD(POR_MXP_ERRSTATUS_NS_U_SMXP_1_1, OF, 27, 1)
    FIELD(POR_MXP_ERRSTATUS_NS_U_SMXP_1_1, MV, 26, 1)
    FIELD(POR_MXP_ERRSTATUS_NS_U_SMXP_1_1, RESERVED_25, 25, 1)
    FIELD(POR_MXP_ERRSTATUS_NS_U_SMXP_1_1, CE, 24, 1)
    FIELD(POR_MXP_ERRSTATUS_NS_U_SMXP_1_1, DE, 23, 1)
    FIELD(POR_MXP_ERRSTATUS_NS_U_SMXP_1_1, RESERVED_0, 0, 23)
REG32(POR_MXP_ERRMISC_NS_U_SMXP_1_1, 0x90b128)
    FIELD(POR_MXP_ERRMISC_NS_U_SMXP_1_1, RESERVED_59, 59, 5)
    FIELD(POR_MXP_ERRMISC_NS_U_SMXP_1_1, TGTID, 48, 11)
    FIELD(POR_MXP_ERRMISC_NS_U_SMXP_1_1, RESERVED_22, 22, 26)
    FIELD(POR_MXP_ERRMISC_NS_U_SMXP_1_1, OPCODE, 16, 6)
    FIELD(POR_MXP_ERRMISC_NS_U_SMXP_1_1, RESERVED_15, 15, 1)
    FIELD(POR_MXP_ERRMISC_NS_U_SMXP_1_1, SRCID, 4, 11)
    FIELD(POR_MXP_ERRMISC_NS_U_SMXP_1_1, ERRSRC, 0, 3)
REG32(POR_FDC_NODE_INFO_U_SMXP_1_1, 0x92c000)
    FIELD(POR_FDC_NODE_INFO_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_FDC_NODE_INFO_U_SMXP_1_1, LOGICAL_ID, 32, 16)
    FIELD(POR_FDC_NODE_INFO_U_SMXP_1_1, NODE_ID, 16, 16)
    FIELD(POR_FDC_NODE_INFO_U_SMXP_1_1, NODE_TYPE, 0, 16)
REG32(POR_FDC_CHILD_INFO_U_SMXP_1_1, 0x92c080)
    FIELD(POR_FDC_CHILD_INFO_U_SMXP_1_1, RESERVED_32, 32, 32)
    FIELD(POR_FDC_CHILD_INFO_U_SMXP_1_1, CHILD_PTR_OFFSET, 16, 16)
    FIELD(POR_FDC_CHILD_INFO_U_SMXP_1_1, CHILD_COUNT, 0, 16)
REG32(POR_ERRFR_MXP_U_SMXP_1_1, 0x92f000)
    FIELD(POR_ERRFR_MXP_U_SMXP_1_1, FI, 6, 2)
    FIELD(POR_ERRFR_MXP_U_SMXP_1_1, UI, 4, 2)
    FIELD(POR_ERRFR_MXP_U_SMXP_1_1, ED, 0, 2)
REG32(POR_ERRCTLR_MXP_U_SMXP_1_1, 0x92f008)
    FIELD(POR_ERRCTLR_MXP_U_SMXP_1_1, RESERVED_32, 32, 32)
    FIELD(POR_ERRCTLR_MXP_U_SMXP_1_1, ERC, 14, 18)
    FIELD(POR_ERRCTLR_MXP_U_SMXP_1_1, FI, 3, 1)
    FIELD(POR_ERRCTLR_MXP_U_SMXP_1_1, UI, 2, 1)
    FIELD(POR_ERRCTLR_MXP_U_SMXP_1_1, ED, 0, 1)
REG32(POR_ERRSTATUS_MXP_U_SMXP_1_1, 0x92f010)
    FIELD(POR_ERRSTATUS_MXP_U_SMXP_1_1, RESERVED_31, 31, 33)
    FIELD(POR_ERRSTATUS_MXP_U_SMXP_1_1, V, 30, 1)
    FIELD(POR_ERRSTATUS_MXP_U_SMXP_1_1, UE, 29, 1)
    FIELD(POR_ERRSTATUS_MXP_U_SMXP_1_1, RESERVED_28, 28, 1)
    FIELD(POR_ERRSTATUS_MXP_U_SMXP_1_1, OF, 27, 1)
    FIELD(POR_ERRSTATUS_MXP_U_SMXP_1_1, RESERVED_24, 24, 3)
    FIELD(POR_ERRSTATUS_MXP_U_SMXP_1_1, DE, 23, 1)
    FIELD(POR_ERRSTATUS_MXP_U_SMXP_1_1, RESERVED_16, 16, 7)
    FIELD(POR_ERRSTATUS_MXP_U_SMXP_1_1, V_ERR_TYPE, 6, 10)
    FIELD(POR_ERRSTATUS_MXP_U_SMXP_1_1, RESERVED_0, 0, 6)
REG32(POR_FDC_AUX_CTL_MXP_U_SMXP_1_1, 0x92f018)
    FIELD(POR_FDC_AUX_CTL_MXP_U_SMXP_1_1, CLKGATE_OVERRIDE, 4, 1)
    FIELD(POR_FDC_AUX_CTL_MXP_U_SMXP_1_1, RESERVED_0, 0, 4)
REG32(POR_ERRFR_P0_D0_U_SMXP_1_1, 0x92f040)
    FIELD(POR_ERRFR_P0_D0_U_SMXP_1_1, FI, 6, 2)
    FIELD(POR_ERRFR_P0_D0_U_SMXP_1_1, UI, 4, 2)
    FIELD(POR_ERRFR_P0_D0_U_SMXP_1_1, ED, 0, 2)
REG32(POR_ERRCTLR_P0_D0_U_SMXP_1_1, 0x92f048)
    FIELD(POR_ERRCTLR_P0_D0_U_SMXP_1_1, RESERVED_32, 32, 32)
    FIELD(POR_ERRCTLR_P0_D0_U_SMXP_1_1, ERC, 14, 18)
    FIELD(POR_ERRCTLR_P0_D0_U_SMXP_1_1, FI, 3, 1)
    FIELD(POR_ERRCTLR_P0_D0_U_SMXP_1_1, UI, 2, 1)
    FIELD(POR_ERRCTLR_P0_D0_U_SMXP_1_1, ED, 0, 1)
REG32(POR_ERRSTATUS_P0_D0_U_SMXP_1_1, 0x92f050)
    FIELD(POR_ERRSTATUS_P0_D0_U_SMXP_1_1, RESERVED_31, 31, 33)
    FIELD(POR_ERRSTATUS_P0_D0_U_SMXP_1_1, V, 30, 1)
    FIELD(POR_ERRSTATUS_P0_D0_U_SMXP_1_1, UE, 29, 1)
    FIELD(POR_ERRSTATUS_P0_D0_U_SMXP_1_1, RESERVED_28, 28, 1)
    FIELD(POR_ERRSTATUS_P0_D0_U_SMXP_1_1, OF, 27, 1)
    FIELD(POR_ERRSTATUS_P0_D0_U_SMXP_1_1, RESERVED_24, 24, 3)
    FIELD(POR_ERRSTATUS_P0_D0_U_SMXP_1_1, DE, 23, 1)
    FIELD(POR_ERRSTATUS_P0_D0_U_SMXP_1_1, RESERVED_16, 16, 7)
    FIELD(POR_ERRSTATUS_P0_D0_U_SMXP_1_1, V_ERR_TYPE, 6, 10)
    FIELD(POR_ERRSTATUS_P0_D0_U_SMXP_1_1, RESERVED_0, 0, 6)
REG32(POR_FDC_AUX_CTL_P0_D0_U_SMXP_1_1, 0x92f058)
    FIELD(POR_FDC_AUX_CTL_P0_D0_U_SMXP_1_1, CLKGATE_OVERRIDE, 4, 1)
    FIELD(POR_FDC_AUX_CTL_P0_D0_U_SMXP_1_1, HANG_DET_CONFIG, 0, 4)
REG32(POR_ERRFR_P0_D1_U_SMXP_1_1, 0x92f080)
    FIELD(POR_ERRFR_P0_D1_U_SMXP_1_1, FI, 6, 2)
    FIELD(POR_ERRFR_P0_D1_U_SMXP_1_1, UI, 4, 2)
    FIELD(POR_ERRFR_P0_D1_U_SMXP_1_1, ED, 0, 2)
REG32(POR_ERRCTLR_P0_D1_U_SMXP_1_1, 0x92f088)
    FIELD(POR_ERRCTLR_P0_D1_U_SMXP_1_1, RESERVED_32, 32, 32)
    FIELD(POR_ERRCTLR_P0_D1_U_SMXP_1_1, ERC, 14, 18)
    FIELD(POR_ERRCTLR_P0_D1_U_SMXP_1_1, FI, 3, 1)
    FIELD(POR_ERRCTLR_P0_D1_U_SMXP_1_1, UI, 2, 1)
    FIELD(POR_ERRCTLR_P0_D1_U_SMXP_1_1, ED, 0, 1)
REG32(POR_ERRSTATUS_P0_D1_U_SMXP_1_1, 0x92f090)
    FIELD(POR_ERRSTATUS_P0_D1_U_SMXP_1_1, RESERVED_31, 31, 33)
    FIELD(POR_ERRSTATUS_P0_D1_U_SMXP_1_1, V, 30, 1)
    FIELD(POR_ERRSTATUS_P0_D1_U_SMXP_1_1, UE, 29, 1)
    FIELD(POR_ERRSTATUS_P0_D1_U_SMXP_1_1, RESERVED_28, 28, 1)
    FIELD(POR_ERRSTATUS_P0_D1_U_SMXP_1_1, OF, 27, 1)
    FIELD(POR_ERRSTATUS_P0_D1_U_SMXP_1_1, RESERVED_24, 24, 3)
    FIELD(POR_ERRSTATUS_P0_D1_U_SMXP_1_1, DE, 23, 1)
    FIELD(POR_ERRSTATUS_P0_D1_U_SMXP_1_1, RESERVED_16, 16, 7)
    FIELD(POR_ERRSTATUS_P0_D1_U_SMXP_1_1, V_ERR_TYPE, 6, 10)
    FIELD(POR_ERRSTATUS_P0_D1_U_SMXP_1_1, RESERVED_0, 0, 6)
REG32(POR_FDC_AUX_CTL_P0_D1_U_SMXP_1_1, 0x92f098)
    FIELD(POR_FDC_AUX_CTL_P0_D1_U_SMXP_1_1, CLKGATE_OVERRIDE, 4, 1)
    FIELD(POR_FDC_AUX_CTL_P0_D1_U_SMXP_1_1, HANG_DET_CONFIG, 0, 4)
REG32(POR_ERRFR_P0_D2_U_SMXP_1_1, 0x92f0c0)
    FIELD(POR_ERRFR_P0_D2_U_SMXP_1_1, FI, 6, 2)
    FIELD(POR_ERRFR_P0_D2_U_SMXP_1_1, UI, 4, 2)
    FIELD(POR_ERRFR_P0_D2_U_SMXP_1_1, ED, 0, 2)
REG32(POR_ERRCTLR_P0_D2_U_SMXP_1_1, 0x92f0c8)
    FIELD(POR_ERRCTLR_P0_D2_U_SMXP_1_1, RESERVED_32, 32, 32)
    FIELD(POR_ERRCTLR_P0_D2_U_SMXP_1_1, ERC, 14, 18)
    FIELD(POR_ERRCTLR_P0_D2_U_SMXP_1_1, FI, 3, 1)
    FIELD(POR_ERRCTLR_P0_D2_U_SMXP_1_1, UI, 2, 1)
    FIELD(POR_ERRCTLR_P0_D2_U_SMXP_1_1, ED, 0, 1)
REG32(POR_ERRSTATUS_P0_D2_U_SMXP_1_1, 0x92f0d0)
    FIELD(POR_ERRSTATUS_P0_D2_U_SMXP_1_1, RESERVED_31, 31, 33)
    FIELD(POR_ERRSTATUS_P0_D2_U_SMXP_1_1, V, 30, 1)
    FIELD(POR_ERRSTATUS_P0_D2_U_SMXP_1_1, UE, 29, 1)
    FIELD(POR_ERRSTATUS_P0_D2_U_SMXP_1_1, RESERVED_28, 28, 1)
    FIELD(POR_ERRSTATUS_P0_D2_U_SMXP_1_1, OF, 27, 1)
    FIELD(POR_ERRSTATUS_P0_D2_U_SMXP_1_1, RESERVED_24, 24, 3)
    FIELD(POR_ERRSTATUS_P0_D2_U_SMXP_1_1, DE, 23, 1)
    FIELD(POR_ERRSTATUS_P0_D2_U_SMXP_1_1, RESERVED_16, 16, 7)
    FIELD(POR_ERRSTATUS_P0_D2_U_SMXP_1_1, V_ERR_TYPE, 6, 10)
    FIELD(POR_ERRSTATUS_P0_D2_U_SMXP_1_1, RESERVED_0, 0, 6)
REG32(POR_FDC_AUX_CTL_P0_D2_U_SMXP_1_1, 0x92f0d8)
    FIELD(POR_FDC_AUX_CTL_P0_D2_U_SMXP_1_1, CLKGATE_OVERRIDE, 4, 1)
    FIELD(POR_FDC_AUX_CTL_P0_D2_U_SMXP_1_1, HANG_DET_CONFIG, 0, 4)
REG32(POR_ERRFR_P0_D3_U_SMXP_1_1, 0x92f100)
    FIELD(POR_ERRFR_P0_D3_U_SMXP_1_1, FI, 6, 2)
    FIELD(POR_ERRFR_P0_D3_U_SMXP_1_1, UI, 4, 2)
    FIELD(POR_ERRFR_P0_D3_U_SMXP_1_1, ED, 0, 2)
REG32(POR_ERRCTLR_P0_D3_U_SMXP_1_1, 0x92f108)
    FIELD(POR_ERRCTLR_P0_D3_U_SMXP_1_1, RESERVED_32, 32, 32)
    FIELD(POR_ERRCTLR_P0_D3_U_SMXP_1_1, ERC, 14, 18)
    FIELD(POR_ERRCTLR_P0_D3_U_SMXP_1_1, FI, 3, 1)
    FIELD(POR_ERRCTLR_P0_D3_U_SMXP_1_1, UI, 2, 1)
    FIELD(POR_ERRCTLR_P0_D3_U_SMXP_1_1, ED, 0, 1)
REG32(POR_ERRSTATUS_P0_D3_U_SMXP_1_1, 0x92f110)
    FIELD(POR_ERRSTATUS_P0_D3_U_SMXP_1_1, RESERVED_31, 31, 33)
    FIELD(POR_ERRSTATUS_P0_D3_U_SMXP_1_1, V, 30, 1)
    FIELD(POR_ERRSTATUS_P0_D3_U_SMXP_1_1, UE, 29, 1)
    FIELD(POR_ERRSTATUS_P0_D3_U_SMXP_1_1, RESERVED_28, 28, 1)
    FIELD(POR_ERRSTATUS_P0_D3_U_SMXP_1_1, OF, 27, 1)
    FIELD(POR_ERRSTATUS_P0_D3_U_SMXP_1_1, RESERVED_24, 24, 3)
    FIELD(POR_ERRSTATUS_P0_D3_U_SMXP_1_1, DE, 23, 1)
    FIELD(POR_ERRSTATUS_P0_D3_U_SMXP_1_1, RESERVED_16, 16, 7)
    FIELD(POR_ERRSTATUS_P0_D3_U_SMXP_1_1, V_ERR_TYPE, 6, 10)
    FIELD(POR_ERRSTATUS_P0_D3_U_SMXP_1_1, RESERVED_0, 0, 6)
REG32(POR_FDC_AUX_CTL_P0_D3_U_SMXP_1_1, 0x92f118)
    FIELD(POR_FDC_AUX_CTL_P0_D3_U_SMXP_1_1, CLKGATE_OVERRIDE, 4, 1)
    FIELD(POR_FDC_AUX_CTL_P0_D3_U_SMXP_1_1, HANG_DET_CONFIG, 0, 4)
REG32(POR_ERRFR_P1_D0_U_SMXP_1_1, 0x92f140)
    FIELD(POR_ERRFR_P1_D0_U_SMXP_1_1, FI, 6, 2)
    FIELD(POR_ERRFR_P1_D0_U_SMXP_1_1, UI, 4, 2)
    FIELD(POR_ERRFR_P1_D0_U_SMXP_1_1, ED, 0, 2)
REG32(POR_ERRCTLR_P1_D0_U_SMXP_1_1, 0x92f148)
    FIELD(POR_ERRCTLR_P1_D0_U_SMXP_1_1, RESERVED_32, 32, 32)
    FIELD(POR_ERRCTLR_P1_D0_U_SMXP_1_1, ERC, 14, 18)
    FIELD(POR_ERRCTLR_P1_D0_U_SMXP_1_1, FI, 3, 1)
    FIELD(POR_ERRCTLR_P1_D0_U_SMXP_1_1, UI, 2, 1)
    FIELD(POR_ERRCTLR_P1_D0_U_SMXP_1_1, ED, 0, 1)
REG32(POR_ERRSTATUS_P1_D0_U_SMXP_1_1, 0x92f150)
    FIELD(POR_ERRSTATUS_P1_D0_U_SMXP_1_1, RESERVED_31, 31, 33)
    FIELD(POR_ERRSTATUS_P1_D0_U_SMXP_1_1, V, 30, 1)
    FIELD(POR_ERRSTATUS_P1_D0_U_SMXP_1_1, UE, 29, 1)
    FIELD(POR_ERRSTATUS_P1_D0_U_SMXP_1_1, RESERVED_28, 28, 1)
    FIELD(POR_ERRSTATUS_P1_D0_U_SMXP_1_1, OF, 27, 1)
    FIELD(POR_ERRSTATUS_P1_D0_U_SMXP_1_1, RESERVED_24, 24, 3)
    FIELD(POR_ERRSTATUS_P1_D0_U_SMXP_1_1, DE, 23, 1)
    FIELD(POR_ERRSTATUS_P1_D0_U_SMXP_1_1, RESERVED_16, 16, 7)
    FIELD(POR_ERRSTATUS_P1_D0_U_SMXP_1_1, V_ERR_TYPE, 6, 10)
    FIELD(POR_ERRSTATUS_P1_D0_U_SMXP_1_1, RESERVED_0, 0, 6)
REG32(POR_FDC_AUX_CTL_P1_D0_U_SMXP_1_1, 0x92f158)
    FIELD(POR_FDC_AUX_CTL_P1_D0_U_SMXP_1_1, CLKGATE_OVERRIDE, 4, 1)
    FIELD(POR_FDC_AUX_CTL_P1_D0_U_SMXP_1_1, HANG_DET_CONFIG, 0, 4)
REG32(POR_ERRFR_P1_D1_U_SMXP_1_1, 0x92f180)
    FIELD(POR_ERRFR_P1_D1_U_SMXP_1_1, FI, 6, 2)
    FIELD(POR_ERRFR_P1_D1_U_SMXP_1_1, UI, 4, 2)
    FIELD(POR_ERRFR_P1_D1_U_SMXP_1_1, ED, 0, 2)
REG32(POR_ERRCTLR_P1_D1_U_SMXP_1_1, 0x92f188)
    FIELD(POR_ERRCTLR_P1_D1_U_SMXP_1_1, RESERVED_32, 32, 32)
    FIELD(POR_ERRCTLR_P1_D1_U_SMXP_1_1, ERC, 14, 18)
    FIELD(POR_ERRCTLR_P1_D1_U_SMXP_1_1, FI, 3, 1)
    FIELD(POR_ERRCTLR_P1_D1_U_SMXP_1_1, UI, 2, 1)
    FIELD(POR_ERRCTLR_P1_D1_U_SMXP_1_1, ED, 0, 1)
REG32(POR_ERRSTATUS_P1_D1_U_SMXP_1_1, 0x92f190)
    FIELD(POR_ERRSTATUS_P1_D1_U_SMXP_1_1, RESERVED_31, 31, 33)
    FIELD(POR_ERRSTATUS_P1_D1_U_SMXP_1_1, V, 30, 1)
    FIELD(POR_ERRSTATUS_P1_D1_U_SMXP_1_1, UE, 29, 1)
    FIELD(POR_ERRSTATUS_P1_D1_U_SMXP_1_1, RESERVED_28, 28, 1)
    FIELD(POR_ERRSTATUS_P1_D1_U_SMXP_1_1, OF, 27, 1)
    FIELD(POR_ERRSTATUS_P1_D1_U_SMXP_1_1, RESERVED_24, 24, 3)
    FIELD(POR_ERRSTATUS_P1_D1_U_SMXP_1_1, DE, 23, 1)
    FIELD(POR_ERRSTATUS_P1_D1_U_SMXP_1_1, RESERVED_16, 16, 7)
    FIELD(POR_ERRSTATUS_P1_D1_U_SMXP_1_1, V_ERR_TYPE, 6, 10)
    FIELD(POR_ERRSTATUS_P1_D1_U_SMXP_1_1, RESERVED_0, 0, 6)
REG32(POR_FDC_AUX_CTL_P1_D1_U_SMXP_1_1, 0x92f198)
    FIELD(POR_FDC_AUX_CTL_P1_D1_U_SMXP_1_1, CLKGATE_OVERRIDE, 4, 1)
    FIELD(POR_FDC_AUX_CTL_P1_D1_U_SMXP_1_1, HANG_DET_CONFIG, 0, 4)
REG32(POR_ERRFR_P1_D2_U_SMXP_1_1, 0x92f1c0)
    FIELD(POR_ERRFR_P1_D2_U_SMXP_1_1, FI, 6, 2)
    FIELD(POR_ERRFR_P1_D2_U_SMXP_1_1, UI, 4, 2)
    FIELD(POR_ERRFR_P1_D2_U_SMXP_1_1, ED, 0, 2)
REG32(POR_ERRCTLR_P1_D2_U_SMXP_1_1, 0x92f1c8)
    FIELD(POR_ERRCTLR_P1_D2_U_SMXP_1_1, RESERVED_32, 32, 32)
    FIELD(POR_ERRCTLR_P1_D2_U_SMXP_1_1, ERC, 14, 18)
    FIELD(POR_ERRCTLR_P1_D2_U_SMXP_1_1, FI, 3, 1)
    FIELD(POR_ERRCTLR_P1_D2_U_SMXP_1_1, UI, 2, 1)
    FIELD(POR_ERRCTLR_P1_D2_U_SMXP_1_1, ED, 0, 1)
REG32(POR_ERRSTATUS_P1_D2_U_SMXP_1_1, 0x92f1d0)
    FIELD(POR_ERRSTATUS_P1_D2_U_SMXP_1_1, RESERVED_31, 31, 33)
    FIELD(POR_ERRSTATUS_P1_D2_U_SMXP_1_1, V, 30, 1)
    FIELD(POR_ERRSTATUS_P1_D2_U_SMXP_1_1, UE, 29, 1)
    FIELD(POR_ERRSTATUS_P1_D2_U_SMXP_1_1, RESERVED_28, 28, 1)
    FIELD(POR_ERRSTATUS_P1_D2_U_SMXP_1_1, OF, 27, 1)
    FIELD(POR_ERRSTATUS_P1_D2_U_SMXP_1_1, RESERVED_24, 24, 3)
    FIELD(POR_ERRSTATUS_P1_D2_U_SMXP_1_1, DE, 23, 1)
    FIELD(POR_ERRSTATUS_P1_D2_U_SMXP_1_1, RESERVED_16, 16, 7)
    FIELD(POR_ERRSTATUS_P1_D2_U_SMXP_1_1, V_ERR_TYPE, 6, 10)
    FIELD(POR_ERRSTATUS_P1_D2_U_SMXP_1_1, RESERVED_0, 0, 6)
REG32(POR_FDC_AUX_CTL_P1_D2_U_SMXP_1_1, 0x92f1d8)
    FIELD(POR_FDC_AUX_CTL_P1_D2_U_SMXP_1_1, CLKGATE_OVERRIDE, 4, 1)
    FIELD(POR_FDC_AUX_CTL_P1_D2_U_SMXP_1_1, HANG_DET_CONFIG, 0, 4)
REG32(POR_ERRFR_P1_D3_U_SMXP_1_1, 0x92f200)
    FIELD(POR_ERRFR_P1_D3_U_SMXP_1_1, FI, 6, 2)
    FIELD(POR_ERRFR_P1_D3_U_SMXP_1_1, UI, 4, 2)
    FIELD(POR_ERRFR_P1_D3_U_SMXP_1_1, ED, 0, 2)
REG32(POR_ERRCTLR_P1_D3_U_SMXP_1_1, 0x92f208)
    FIELD(POR_ERRCTLR_P1_D3_U_SMXP_1_1, RESERVED_32, 32, 32)
    FIELD(POR_ERRCTLR_P1_D3_U_SMXP_1_1, ERC, 14, 18)
    FIELD(POR_ERRCTLR_P1_D3_U_SMXP_1_1, FI, 3, 1)
    FIELD(POR_ERRCTLR_P1_D3_U_SMXP_1_1, UI, 2, 1)
    FIELD(POR_ERRCTLR_P1_D3_U_SMXP_1_1, ED, 0, 1)
REG32(POR_ERRSTATUS_P1_D3_U_SMXP_1_1, 0x92f210)
    FIELD(POR_ERRSTATUS_P1_D3_U_SMXP_1_1, RESERVED_31, 31, 33)
    FIELD(POR_ERRSTATUS_P1_D3_U_SMXP_1_1, V, 30, 1)
    FIELD(POR_ERRSTATUS_P1_D3_U_SMXP_1_1, UE, 29, 1)
    FIELD(POR_ERRSTATUS_P1_D3_U_SMXP_1_1, RESERVED_28, 28, 1)
    FIELD(POR_ERRSTATUS_P1_D3_U_SMXP_1_1, OF, 27, 1)
    FIELD(POR_ERRSTATUS_P1_D3_U_SMXP_1_1, RESERVED_24, 24, 3)
    FIELD(POR_ERRSTATUS_P1_D3_U_SMXP_1_1, DE, 23, 1)
    FIELD(POR_ERRSTATUS_P1_D3_U_SMXP_1_1, RESERVED_16, 16, 7)
    FIELD(POR_ERRSTATUS_P1_D3_U_SMXP_1_1, V_ERR_TYPE, 6, 10)
    FIELD(POR_ERRSTATUS_P1_D3_U_SMXP_1_1, RESERVED_0, 0, 6)
REG32(POR_FDC_AUX_CTL_P1_D3_U_SMXP_1_1, 0x92f218)
    FIELD(POR_FDC_AUX_CTL_P1_D3_U_SMXP_1_1, CLKGATE_OVERRIDE, 4, 1)
    FIELD(POR_FDC_AUX_CTL_P1_D3_U_SMXP_1_1, HANG_DET_CONFIG, 0, 4)
REG32(POR_ERRINJECT_U_SMXP_1_1, 0x92f300)
    FIELD(POR_ERRINJECT_U_SMXP_1_1, ERR_DEV, 4, 4)
    FIELD(POR_ERRINJECT_U_SMXP_1_1, ERR_TYPE, 0, 4)
REG32(POR_FDC_KEY_U_SMXP_1_1, 0x92f308)
    FIELD(POR_FDC_KEY_U_SMXP_1_1, KEY, 0, 8)
REG32(POR_MPU_NODE_INFO_U_SMXP_1_1, 0x93c000)
    FIELD(POR_MPU_NODE_INFO_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_NODE_INFO_U_SMXP_1_1, LOGICAL_ID, 32, 16)
    FIELD(POR_MPU_NODE_INFO_U_SMXP_1_1, NODE_ID, 16, 16)
    FIELD(POR_MPU_NODE_INFO_U_SMXP_1_1, NODE_TYPE, 0, 16)
REG32(POR_MPU_CHILD_INFO_U_SMXP_1_1, 0x93c080)
    FIELD(POR_MPU_CHILD_INFO_U_SMXP_1_1, RESERVED_32, 32, 32)
    FIELD(POR_MPU_CHILD_INFO_U_SMXP_1_1, CHILD_PTR_OFFSET, 16, 16)
    FIELD(POR_MPU_CHILD_INFO_U_SMXP_1_1, CHILD_COUNT, 0, 16)
REG32(POR_MPU_UNIT_INFO_U_SMXP_1_1, 0x93c900)
    FIELD(POR_MPU_UNIT_INFO_U_SMXP_1_1, RESERVED_16, 16, 48)
    FIELD(POR_MPU_UNIT_INFO_U_SMXP_1_1, MASTER_7_PRESENT, 15, 1)
    FIELD(POR_MPU_UNIT_INFO_U_SMXP_1_1, MASTER_6_PRESENT, 14, 1)
    FIELD(POR_MPU_UNIT_INFO_U_SMXP_1_1, MASTER_5_PRESENT, 13, 1)
    FIELD(POR_MPU_UNIT_INFO_U_SMXP_1_1, MASTER_4_PRESENT, 12, 1)
    FIELD(POR_MPU_UNIT_INFO_U_SMXP_1_1, MASTER_3_PRESENT, 11, 1)
    FIELD(POR_MPU_UNIT_INFO_U_SMXP_1_1, MASTER_2_PRESENT, 10, 1)
    FIELD(POR_MPU_UNIT_INFO_U_SMXP_1_1, MASTER_1_PRESENT, 9, 1)
    FIELD(POR_MPU_UNIT_INFO_U_SMXP_1_1, MASTER_0_PRESENT, 8, 1)
    FIELD(POR_MPU_UNIT_INFO_U_SMXP_1_1, NUM_PROG_REGION, 0, 8)
REG32(POR_MPU_M0_CTL_U_SMXP_1_1, 0x93d000)
    FIELD(POR_MPU_M0_CTL_U_SMXP_1_1, M0_EN, 2, 1)
    FIELD(POR_MPU_M0_CTL_U_SMXP_1_1, M0_ACTION, 0, 2)
REG32(POR_MPU_M0_PRBAR0_U_SMXP_1_1, 0x93d010)
    FIELD(POR_MPU_M0_PRBAR0_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR0_U_SMXP_1_1, REGION0_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR0_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR0_U_SMXP_1_1, REGION0_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR0_U_SMXP_1_1, REGION0_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR0_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR0_U_SMXP_1_1, 0x93d018)
    FIELD(POR_MPU_M0_PRLAR0_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR0_U_SMXP_1_1, REGION0_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR0_U_SMXP_1_1, REGION0_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR1_U_SMXP_1_1, 0x93d020)
    FIELD(POR_MPU_M0_PRBAR1_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR1_U_SMXP_1_1, REGION1_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR1_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR1_U_SMXP_1_1, REGION1_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR1_U_SMXP_1_1, REGION1_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR1_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR1_U_SMXP_1_1, 0x93d028)
    FIELD(POR_MPU_M0_PRLAR1_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR1_U_SMXP_1_1, REGION1_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR1_U_SMXP_1_1, REGION1_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR2_U_SMXP_1_1, 0x93d030)
    FIELD(POR_MPU_M0_PRBAR2_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR2_U_SMXP_1_1, REGION2_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR2_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR2_U_SMXP_1_1, REGION2_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR2_U_SMXP_1_1, REGION2_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR2_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR2_U_SMXP_1_1, 0x93d038)
    FIELD(POR_MPU_M0_PRLAR2_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR2_U_SMXP_1_1, REGION2_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR2_U_SMXP_1_1, REGION2_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR3_U_SMXP_1_1, 0x93d040)
    FIELD(POR_MPU_M0_PRBAR3_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR3_U_SMXP_1_1, REGION3_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR3_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR3_U_SMXP_1_1, REGION3_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR3_U_SMXP_1_1, REGION3_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR3_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR3_U_SMXP_1_1, 0x93d048)
    FIELD(POR_MPU_M0_PRLAR3_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR3_U_SMXP_1_1, REGION3_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR3_U_SMXP_1_1, REGION3_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR4_U_SMXP_1_1, 0x93d050)
    FIELD(POR_MPU_M0_PRBAR4_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR4_U_SMXP_1_1, REGION4_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR4_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR4_U_SMXP_1_1, REGION4_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR4_U_SMXP_1_1, REGION4_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR4_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR4_U_SMXP_1_1, 0x93d058)
    FIELD(POR_MPU_M0_PRLAR4_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR4_U_SMXP_1_1, REGION4_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR4_U_SMXP_1_1, REGION4_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR5_U_SMXP_1_1, 0x93d060)
    FIELD(POR_MPU_M0_PRBAR5_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR5_U_SMXP_1_1, REGION5_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR5_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR5_U_SMXP_1_1, REGION5_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR5_U_SMXP_1_1, REGION5_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR5_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR5_U_SMXP_1_1, 0x93d068)
    FIELD(POR_MPU_M0_PRLAR5_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR5_U_SMXP_1_1, REGION5_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR5_U_SMXP_1_1, REGION5_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR6_U_SMXP_1_1, 0x93d070)
    FIELD(POR_MPU_M0_PRBAR6_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR6_U_SMXP_1_1, REGION6_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR6_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR6_U_SMXP_1_1, REGION6_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR6_U_SMXP_1_1, REGION6_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR6_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR6_U_SMXP_1_1, 0x93d078)
    FIELD(POR_MPU_M0_PRLAR6_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR6_U_SMXP_1_1, REGION6_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR6_U_SMXP_1_1, REGION6_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR7_U_SMXP_1_1, 0x93d080)
    FIELD(POR_MPU_M0_PRBAR7_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR7_U_SMXP_1_1, REGION7_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR7_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR7_U_SMXP_1_1, REGION7_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR7_U_SMXP_1_1, REGION7_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR7_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR7_U_SMXP_1_1, 0x93d088)
    FIELD(POR_MPU_M0_PRLAR7_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR7_U_SMXP_1_1, REGION7_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR7_U_SMXP_1_1, REGION7_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR8_U_SMXP_1_1, 0x93d090)
    FIELD(POR_MPU_M0_PRBAR8_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR8_U_SMXP_1_1, REGION8_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR8_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR8_U_SMXP_1_1, REGION8_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR8_U_SMXP_1_1, REGION8_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR8_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR8_U_SMXP_1_1, 0x93d098)
    FIELD(POR_MPU_M0_PRLAR8_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR8_U_SMXP_1_1, REGION8_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR8_U_SMXP_1_1, REGION8_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR9_U_SMXP_1_1, 0x93d0a0)
    FIELD(POR_MPU_M0_PRBAR9_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR9_U_SMXP_1_1, REGION9_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR9_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR9_U_SMXP_1_1, REGION9_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR9_U_SMXP_1_1, REGION9_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR9_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR9_U_SMXP_1_1, 0x93d0a8)
    FIELD(POR_MPU_M0_PRLAR9_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR9_U_SMXP_1_1, REGION9_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR9_U_SMXP_1_1, REGION9_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR10_U_SMXP_1_1, 0x93d0b0)
    FIELD(POR_MPU_M0_PRBAR10_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR10_U_SMXP_1_1, REGION10_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR10_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR10_U_SMXP_1_1, REGION10_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR10_U_SMXP_1_1, REGION10_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR10_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR10_U_SMXP_1_1, 0x93d0b8)
    FIELD(POR_MPU_M0_PRLAR10_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR10_U_SMXP_1_1, REGION10_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR10_U_SMXP_1_1, REGION10_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR11_U_SMXP_1_1, 0x93d0c0)
    FIELD(POR_MPU_M0_PRBAR11_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR11_U_SMXP_1_1, REGION11_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR11_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR11_U_SMXP_1_1, REGION11_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR11_U_SMXP_1_1, REGION11_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR11_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR11_U_SMXP_1_1, 0x93d0c8)
    FIELD(POR_MPU_M0_PRLAR11_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR11_U_SMXP_1_1, REGION11_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR11_U_SMXP_1_1, REGION11_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR12_U_SMXP_1_1, 0x93d0d0)
    FIELD(POR_MPU_M0_PRBAR12_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR12_U_SMXP_1_1, REGION12_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR12_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR12_U_SMXP_1_1, REGION12_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR12_U_SMXP_1_1, REGION12_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR12_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR12_U_SMXP_1_1, 0x93d0d8)
    FIELD(POR_MPU_M0_PRLAR12_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR12_U_SMXP_1_1, REGION12_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR12_U_SMXP_1_1, REGION12_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR13_U_SMXP_1_1, 0x93d0e0)
    FIELD(POR_MPU_M0_PRBAR13_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR13_U_SMXP_1_1, REGION13_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR13_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR13_U_SMXP_1_1, REGION13_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR13_U_SMXP_1_1, REGION13_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR13_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR13_U_SMXP_1_1, 0x93d0e8)
    FIELD(POR_MPU_M0_PRLAR13_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR13_U_SMXP_1_1, REGION13_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR13_U_SMXP_1_1, REGION13_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR14_U_SMXP_1_1, 0x93d0f0)
    FIELD(POR_MPU_M0_PRBAR14_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR14_U_SMXP_1_1, REGION14_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR14_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR14_U_SMXP_1_1, REGION14_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR14_U_SMXP_1_1, REGION14_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR14_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR14_U_SMXP_1_1, 0x93d0f8)
    FIELD(POR_MPU_M0_PRLAR14_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR14_U_SMXP_1_1, REGION14_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR14_U_SMXP_1_1, REGION14_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR15_U_SMXP_1_1, 0x93d100)
    FIELD(POR_MPU_M0_PRBAR15_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR15_U_SMXP_1_1, REGION15_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR15_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR15_U_SMXP_1_1, REGION15_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR15_U_SMXP_1_1, REGION15_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR15_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR15_U_SMXP_1_1, 0x93d108)
    FIELD(POR_MPU_M0_PRLAR15_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR15_U_SMXP_1_1, REGION15_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR15_U_SMXP_1_1, REGION15_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR16_U_SMXP_1_1, 0x93d110)
    FIELD(POR_MPU_M0_PRBAR16_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR16_U_SMXP_1_1, REGION16_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR16_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR16_U_SMXP_1_1, REGION16_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR16_U_SMXP_1_1, REGION16_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR16_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR16_U_SMXP_1_1, 0x93d118)
    FIELD(POR_MPU_M0_PRLAR16_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR16_U_SMXP_1_1, REGION16_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR16_U_SMXP_1_1, REGION16_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR17_U_SMXP_1_1, 0x93d120)
    FIELD(POR_MPU_M0_PRBAR17_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR17_U_SMXP_1_1, REGION17_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR17_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR17_U_SMXP_1_1, REGION17_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR17_U_SMXP_1_1, REGION17_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR17_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR17_U_SMXP_1_1, 0x93d128)
    FIELD(POR_MPU_M0_PRLAR17_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR17_U_SMXP_1_1, REGION17_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR17_U_SMXP_1_1, REGION17_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR18_U_SMXP_1_1, 0x93d130)
    FIELD(POR_MPU_M0_PRBAR18_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR18_U_SMXP_1_1, REGION18_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR18_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR18_U_SMXP_1_1, REGION18_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR18_U_SMXP_1_1, REGION18_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR18_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR18_U_SMXP_1_1, 0x93d138)
    FIELD(POR_MPU_M0_PRLAR18_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR18_U_SMXP_1_1, REGION18_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR18_U_SMXP_1_1, REGION18_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR19_U_SMXP_1_1, 0x93d140)
    FIELD(POR_MPU_M0_PRBAR19_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR19_U_SMXP_1_1, REGION19_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR19_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR19_U_SMXP_1_1, REGION19_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR19_U_SMXP_1_1, REGION19_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR19_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR19_U_SMXP_1_1, 0x93d148)
    FIELD(POR_MPU_M0_PRLAR19_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR19_U_SMXP_1_1, REGION19_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR19_U_SMXP_1_1, REGION19_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR20_U_SMXP_1_1, 0x93d150)
    FIELD(POR_MPU_M0_PRBAR20_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR20_U_SMXP_1_1, REGION20_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR20_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR20_U_SMXP_1_1, REGION20_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR20_U_SMXP_1_1, REGION20_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR20_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR20_U_SMXP_1_1, 0x93d158)
    FIELD(POR_MPU_M0_PRLAR20_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR20_U_SMXP_1_1, REGION20_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR20_U_SMXP_1_1, REGION20_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR21_U_SMXP_1_1, 0x93d160)
    FIELD(POR_MPU_M0_PRBAR21_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR21_U_SMXP_1_1, REGION21_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR21_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR21_U_SMXP_1_1, REGION21_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR21_U_SMXP_1_1, REGION21_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR21_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR21_U_SMXP_1_1, 0x93d168)
    FIELD(POR_MPU_M0_PRLAR21_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR21_U_SMXP_1_1, REGION21_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR21_U_SMXP_1_1, REGION21_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR22_U_SMXP_1_1, 0x93d170)
    FIELD(POR_MPU_M0_PRBAR22_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR22_U_SMXP_1_1, REGION22_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR22_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR22_U_SMXP_1_1, REGION22_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR22_U_SMXP_1_1, REGION22_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR22_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR22_U_SMXP_1_1, 0x93d178)
    FIELD(POR_MPU_M0_PRLAR22_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR22_U_SMXP_1_1, REGION22_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR22_U_SMXP_1_1, REGION22_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR23_U_SMXP_1_1, 0x93d180)
    FIELD(POR_MPU_M0_PRBAR23_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR23_U_SMXP_1_1, REGION23_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR23_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR23_U_SMXP_1_1, REGION23_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR23_U_SMXP_1_1, REGION23_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR23_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR23_U_SMXP_1_1, 0x93d188)
    FIELD(POR_MPU_M0_PRLAR23_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR23_U_SMXP_1_1, REGION23_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR23_U_SMXP_1_1, REGION23_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR24_U_SMXP_1_1, 0x93d190)
    FIELD(POR_MPU_M0_PRBAR24_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR24_U_SMXP_1_1, REGION24_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR24_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR24_U_SMXP_1_1, REGION24_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR24_U_SMXP_1_1, REGION24_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR24_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR24_U_SMXP_1_1, 0x93d198)
    FIELD(POR_MPU_M0_PRLAR24_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR24_U_SMXP_1_1, REGION24_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR24_U_SMXP_1_1, REGION24_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR25_U_SMXP_1_1, 0x93d1a0)
    FIELD(POR_MPU_M0_PRBAR25_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR25_U_SMXP_1_1, REGION25_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR25_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR25_U_SMXP_1_1, REGION25_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR25_U_SMXP_1_1, REGION25_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR25_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR25_U_SMXP_1_1, 0x93d1a8)
    FIELD(POR_MPU_M0_PRLAR25_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR25_U_SMXP_1_1, REGION25_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR25_U_SMXP_1_1, REGION25_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR26_U_SMXP_1_1, 0x93d1b0)
    FIELD(POR_MPU_M0_PRBAR26_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR26_U_SMXP_1_1, REGION26_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR26_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR26_U_SMXP_1_1, REGION26_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR26_U_SMXP_1_1, REGION26_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR26_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR26_U_SMXP_1_1, 0x93d1b8)
    FIELD(POR_MPU_M0_PRLAR26_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR26_U_SMXP_1_1, REGION26_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR26_U_SMXP_1_1, REGION26_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR27_U_SMXP_1_1, 0x93d1c0)
    FIELD(POR_MPU_M0_PRBAR27_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR27_U_SMXP_1_1, REGION27_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR27_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR27_U_SMXP_1_1, REGION27_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR27_U_SMXP_1_1, REGION27_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR27_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR27_U_SMXP_1_1, 0x93d1c8)
    FIELD(POR_MPU_M0_PRLAR27_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR27_U_SMXP_1_1, REGION27_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR27_U_SMXP_1_1, REGION27_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR28_U_SMXP_1_1, 0x93d1d0)
    FIELD(POR_MPU_M0_PRBAR28_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR28_U_SMXP_1_1, REGION28_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR28_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR28_U_SMXP_1_1, REGION28_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR28_U_SMXP_1_1, REGION28_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR28_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR28_U_SMXP_1_1, 0x93d1d8)
    FIELD(POR_MPU_M0_PRLAR28_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR28_U_SMXP_1_1, REGION28_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR28_U_SMXP_1_1, REGION28_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR29_U_SMXP_1_1, 0x93d1e0)
    FIELD(POR_MPU_M0_PRBAR29_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR29_U_SMXP_1_1, REGION29_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR29_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR29_U_SMXP_1_1, REGION29_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR29_U_SMXP_1_1, REGION29_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR29_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR29_U_SMXP_1_1, 0x93d1e8)
    FIELD(POR_MPU_M0_PRLAR29_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR29_U_SMXP_1_1, REGION29_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR29_U_SMXP_1_1, REGION29_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR30_U_SMXP_1_1, 0x93d1f0)
    FIELD(POR_MPU_M0_PRBAR30_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR30_U_SMXP_1_1, REGION30_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR30_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR30_U_SMXP_1_1, REGION30_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR30_U_SMXP_1_1, REGION30_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR30_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR30_U_SMXP_1_1, 0x93d1f8)
    FIELD(POR_MPU_M0_PRLAR30_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR30_U_SMXP_1_1, REGION30_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR30_U_SMXP_1_1, REGION30_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR31_U_SMXP_1_1, 0x93d200)
    FIELD(POR_MPU_M0_PRBAR31_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR31_U_SMXP_1_1, REGION31_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR31_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR31_U_SMXP_1_1, REGION31_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR31_U_SMXP_1_1, REGION31_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR31_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR31_U_SMXP_1_1, 0x93d208)
    FIELD(POR_MPU_M0_PRLAR31_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR31_U_SMXP_1_1, REGION31_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR31_U_SMXP_1_1, REGION31_EN, 0, 1)
REG32(POR_MPU_M1_CTL_U_SMXP_1_1, 0x93d400)
    FIELD(POR_MPU_M1_CTL_U_SMXP_1_1, M1_EN, 2, 1)
    FIELD(POR_MPU_M1_CTL_U_SMXP_1_1, M1_ACTION, 0, 2)
REG32(POR_MPU_M1_PRBAR0_U_SMXP_1_1, 0x93d410)
    FIELD(POR_MPU_M1_PRBAR0_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR0_U_SMXP_1_1, REGION0_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR0_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR0_U_SMXP_1_1, REGION0_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR0_U_SMXP_1_1, REGION0_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR0_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR0_U_SMXP_1_1, 0x93d418)
    FIELD(POR_MPU_M1_PRLAR0_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR0_U_SMXP_1_1, REGION0_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR0_U_SMXP_1_1, REGION0_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR1_U_SMXP_1_1, 0x93d420)
    FIELD(POR_MPU_M1_PRBAR1_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR1_U_SMXP_1_1, REGION1_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR1_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR1_U_SMXP_1_1, REGION1_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR1_U_SMXP_1_1, REGION1_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR1_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR1_U_SMXP_1_1, 0x93d428)
    FIELD(POR_MPU_M1_PRLAR1_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR1_U_SMXP_1_1, REGION1_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR1_U_SMXP_1_1, REGION1_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR2_U_SMXP_1_1, 0x93d430)
    FIELD(POR_MPU_M1_PRBAR2_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR2_U_SMXP_1_1, REGION2_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR2_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR2_U_SMXP_1_1, REGION2_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR2_U_SMXP_1_1, REGION2_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR2_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR2_U_SMXP_1_1, 0x93d438)
    FIELD(POR_MPU_M1_PRLAR2_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR2_U_SMXP_1_1, REGION2_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR2_U_SMXP_1_1, REGION2_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR3_U_SMXP_1_1, 0x93d440)
    FIELD(POR_MPU_M1_PRBAR3_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR3_U_SMXP_1_1, REGION3_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR3_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR3_U_SMXP_1_1, REGION3_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR3_U_SMXP_1_1, REGION3_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR3_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR3_U_SMXP_1_1, 0x93d448)
    FIELD(POR_MPU_M1_PRLAR3_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR3_U_SMXP_1_1, REGION3_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR3_U_SMXP_1_1, REGION3_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR4_U_SMXP_1_1, 0x93d450)
    FIELD(POR_MPU_M1_PRBAR4_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR4_U_SMXP_1_1, REGION4_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR4_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR4_U_SMXP_1_1, REGION4_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR4_U_SMXP_1_1, REGION4_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR4_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR4_U_SMXP_1_1, 0x93d458)
    FIELD(POR_MPU_M1_PRLAR4_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR4_U_SMXP_1_1, REGION4_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR4_U_SMXP_1_1, REGION4_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR5_U_SMXP_1_1, 0x93d460)
    FIELD(POR_MPU_M1_PRBAR5_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR5_U_SMXP_1_1, REGION5_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR5_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR5_U_SMXP_1_1, REGION5_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR5_U_SMXP_1_1, REGION5_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR5_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR5_U_SMXP_1_1, 0x93d468)
    FIELD(POR_MPU_M1_PRLAR5_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR5_U_SMXP_1_1, REGION5_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR5_U_SMXP_1_1, REGION5_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR6_U_SMXP_1_1, 0x93d470)
    FIELD(POR_MPU_M1_PRBAR6_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR6_U_SMXP_1_1, REGION6_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR6_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR6_U_SMXP_1_1, REGION6_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR6_U_SMXP_1_1, REGION6_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR6_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR6_U_SMXP_1_1, 0x93d478)
    FIELD(POR_MPU_M1_PRLAR6_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR6_U_SMXP_1_1, REGION6_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR6_U_SMXP_1_1, REGION6_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR7_U_SMXP_1_1, 0x93d480)
    FIELD(POR_MPU_M1_PRBAR7_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR7_U_SMXP_1_1, REGION7_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR7_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR7_U_SMXP_1_1, REGION7_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR7_U_SMXP_1_1, REGION7_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR7_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR7_U_SMXP_1_1, 0x93d488)
    FIELD(POR_MPU_M1_PRLAR7_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR7_U_SMXP_1_1, REGION7_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR7_U_SMXP_1_1, REGION7_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR8_U_SMXP_1_1, 0x93d490)
    FIELD(POR_MPU_M1_PRBAR8_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR8_U_SMXP_1_1, REGION8_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR8_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR8_U_SMXP_1_1, REGION8_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR8_U_SMXP_1_1, REGION8_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR8_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR8_U_SMXP_1_1, 0x93d498)
    FIELD(POR_MPU_M1_PRLAR8_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR8_U_SMXP_1_1, REGION8_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR8_U_SMXP_1_1, REGION8_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR9_U_SMXP_1_1, 0x93d4a0)
    FIELD(POR_MPU_M1_PRBAR9_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR9_U_SMXP_1_1, REGION9_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR9_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR9_U_SMXP_1_1, REGION9_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR9_U_SMXP_1_1, REGION9_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR9_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR9_U_SMXP_1_1, 0x93d4a8)
    FIELD(POR_MPU_M1_PRLAR9_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR9_U_SMXP_1_1, REGION9_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR9_U_SMXP_1_1, REGION9_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR10_U_SMXP_1_1, 0x93d4b0)
    FIELD(POR_MPU_M1_PRBAR10_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR10_U_SMXP_1_1, REGION10_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR10_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR10_U_SMXP_1_1, REGION10_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR10_U_SMXP_1_1, REGION10_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR10_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR10_U_SMXP_1_1, 0x93d4b8)
    FIELD(POR_MPU_M1_PRLAR10_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR10_U_SMXP_1_1, REGION10_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR10_U_SMXP_1_1, REGION10_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR11_U_SMXP_1_1, 0x93d4c0)
    FIELD(POR_MPU_M1_PRBAR11_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR11_U_SMXP_1_1, REGION11_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR11_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR11_U_SMXP_1_1, REGION11_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR11_U_SMXP_1_1, REGION11_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR11_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR11_U_SMXP_1_1, 0x93d4c8)
    FIELD(POR_MPU_M1_PRLAR11_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR11_U_SMXP_1_1, REGION11_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR11_U_SMXP_1_1, REGION11_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR12_U_SMXP_1_1, 0x93d4d0)
    FIELD(POR_MPU_M1_PRBAR12_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR12_U_SMXP_1_1, REGION12_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR12_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR12_U_SMXP_1_1, REGION12_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR12_U_SMXP_1_1, REGION12_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR12_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR12_U_SMXP_1_1, 0x93d4d8)
    FIELD(POR_MPU_M1_PRLAR12_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR12_U_SMXP_1_1, REGION12_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR12_U_SMXP_1_1, REGION12_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR13_U_SMXP_1_1, 0x93d4e0)
    FIELD(POR_MPU_M1_PRBAR13_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR13_U_SMXP_1_1, REGION13_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR13_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR13_U_SMXP_1_1, REGION13_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR13_U_SMXP_1_1, REGION13_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR13_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR13_U_SMXP_1_1, 0x93d4e8)
    FIELD(POR_MPU_M1_PRLAR13_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR13_U_SMXP_1_1, REGION13_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR13_U_SMXP_1_1, REGION13_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR14_U_SMXP_1_1, 0x93d4f0)
    FIELD(POR_MPU_M1_PRBAR14_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR14_U_SMXP_1_1, REGION14_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR14_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR14_U_SMXP_1_1, REGION14_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR14_U_SMXP_1_1, REGION14_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR14_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR14_U_SMXP_1_1, 0x93d4f8)
    FIELD(POR_MPU_M1_PRLAR14_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR14_U_SMXP_1_1, REGION14_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR14_U_SMXP_1_1, REGION14_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR15_U_SMXP_1_1, 0x93d500)
    FIELD(POR_MPU_M1_PRBAR15_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR15_U_SMXP_1_1, REGION15_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR15_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR15_U_SMXP_1_1, REGION15_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR15_U_SMXP_1_1, REGION15_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR15_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR15_U_SMXP_1_1, 0x93d508)
    FIELD(POR_MPU_M1_PRLAR15_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR15_U_SMXP_1_1, REGION15_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR15_U_SMXP_1_1, REGION15_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR16_U_SMXP_1_1, 0x93d510)
    FIELD(POR_MPU_M1_PRBAR16_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR16_U_SMXP_1_1, REGION16_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR16_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR16_U_SMXP_1_1, REGION16_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR16_U_SMXP_1_1, REGION16_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR16_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR16_U_SMXP_1_1, 0x93d518)
    FIELD(POR_MPU_M1_PRLAR16_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR16_U_SMXP_1_1, REGION16_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR16_U_SMXP_1_1, REGION16_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR17_U_SMXP_1_1, 0x93d520)
    FIELD(POR_MPU_M1_PRBAR17_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR17_U_SMXP_1_1, REGION17_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR17_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR17_U_SMXP_1_1, REGION17_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR17_U_SMXP_1_1, REGION17_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR17_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR17_U_SMXP_1_1, 0x93d528)
    FIELD(POR_MPU_M1_PRLAR17_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR17_U_SMXP_1_1, REGION17_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR17_U_SMXP_1_1, REGION17_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR18_U_SMXP_1_1, 0x93d530)
    FIELD(POR_MPU_M1_PRBAR18_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR18_U_SMXP_1_1, REGION18_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR18_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR18_U_SMXP_1_1, REGION18_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR18_U_SMXP_1_1, REGION18_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR18_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR18_U_SMXP_1_1, 0x93d538)
    FIELD(POR_MPU_M1_PRLAR18_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR18_U_SMXP_1_1, REGION18_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR18_U_SMXP_1_1, REGION18_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR19_U_SMXP_1_1, 0x93d540)
    FIELD(POR_MPU_M1_PRBAR19_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR19_U_SMXP_1_1, REGION19_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR19_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR19_U_SMXP_1_1, REGION19_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR19_U_SMXP_1_1, REGION19_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR19_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR19_U_SMXP_1_1, 0x93d548)
    FIELD(POR_MPU_M1_PRLAR19_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR19_U_SMXP_1_1, REGION19_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR19_U_SMXP_1_1, REGION19_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR20_U_SMXP_1_1, 0x93d550)
    FIELD(POR_MPU_M1_PRBAR20_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR20_U_SMXP_1_1, REGION20_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR20_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR20_U_SMXP_1_1, REGION20_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR20_U_SMXP_1_1, REGION20_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR20_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR20_U_SMXP_1_1, 0x93d558)
    FIELD(POR_MPU_M1_PRLAR20_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR20_U_SMXP_1_1, REGION20_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR20_U_SMXP_1_1, REGION20_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR21_U_SMXP_1_1, 0x93d560)
    FIELD(POR_MPU_M1_PRBAR21_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR21_U_SMXP_1_1, REGION21_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR21_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR21_U_SMXP_1_1, REGION21_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR21_U_SMXP_1_1, REGION21_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR21_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR21_U_SMXP_1_1, 0x93d568)
    FIELD(POR_MPU_M1_PRLAR21_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR21_U_SMXP_1_1, REGION21_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR21_U_SMXP_1_1, REGION21_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR22_U_SMXP_1_1, 0x93d570)
    FIELD(POR_MPU_M1_PRBAR22_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR22_U_SMXP_1_1, REGION22_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR22_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR22_U_SMXP_1_1, REGION22_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR22_U_SMXP_1_1, REGION22_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR22_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR22_U_SMXP_1_1, 0x93d578)
    FIELD(POR_MPU_M1_PRLAR22_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR22_U_SMXP_1_1, REGION22_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR22_U_SMXP_1_1, REGION22_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR23_U_SMXP_1_1, 0x93d580)
    FIELD(POR_MPU_M1_PRBAR23_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR23_U_SMXP_1_1, REGION23_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR23_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR23_U_SMXP_1_1, REGION23_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR23_U_SMXP_1_1, REGION23_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR23_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR23_U_SMXP_1_1, 0x93d588)
    FIELD(POR_MPU_M1_PRLAR23_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR23_U_SMXP_1_1, REGION23_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR23_U_SMXP_1_1, REGION23_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR24_U_SMXP_1_1, 0x93d590)
    FIELD(POR_MPU_M1_PRBAR24_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR24_U_SMXP_1_1, REGION24_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR24_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR24_U_SMXP_1_1, REGION24_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR24_U_SMXP_1_1, REGION24_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR24_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR24_U_SMXP_1_1, 0x93d598)
    FIELD(POR_MPU_M1_PRLAR24_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR24_U_SMXP_1_1, REGION24_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR24_U_SMXP_1_1, REGION24_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR25_U_SMXP_1_1, 0x93d5a0)
    FIELD(POR_MPU_M1_PRBAR25_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR25_U_SMXP_1_1, REGION25_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR25_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR25_U_SMXP_1_1, REGION25_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR25_U_SMXP_1_1, REGION25_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR25_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR25_U_SMXP_1_1, 0x93d5a8)
    FIELD(POR_MPU_M1_PRLAR25_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR25_U_SMXP_1_1, REGION25_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR25_U_SMXP_1_1, REGION25_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR26_U_SMXP_1_1, 0x93d5b0)
    FIELD(POR_MPU_M1_PRBAR26_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR26_U_SMXP_1_1, REGION26_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR26_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR26_U_SMXP_1_1, REGION26_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR26_U_SMXP_1_1, REGION26_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR26_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR26_U_SMXP_1_1, 0x93d5b8)
    FIELD(POR_MPU_M1_PRLAR26_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR26_U_SMXP_1_1, REGION26_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR26_U_SMXP_1_1, REGION26_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR27_U_SMXP_1_1, 0x93d5c0)
    FIELD(POR_MPU_M1_PRBAR27_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR27_U_SMXP_1_1, REGION27_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR27_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR27_U_SMXP_1_1, REGION27_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR27_U_SMXP_1_1, REGION27_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR27_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR27_U_SMXP_1_1, 0x93d5c8)
    FIELD(POR_MPU_M1_PRLAR27_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR27_U_SMXP_1_1, REGION27_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR27_U_SMXP_1_1, REGION27_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR28_U_SMXP_1_1, 0x93d5d0)
    FIELD(POR_MPU_M1_PRBAR28_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR28_U_SMXP_1_1, REGION28_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR28_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR28_U_SMXP_1_1, REGION28_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR28_U_SMXP_1_1, REGION28_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR28_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR28_U_SMXP_1_1, 0x93d5d8)
    FIELD(POR_MPU_M1_PRLAR28_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR28_U_SMXP_1_1, REGION28_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR28_U_SMXP_1_1, REGION28_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR29_U_SMXP_1_1, 0x93d5e0)
    FIELD(POR_MPU_M1_PRBAR29_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR29_U_SMXP_1_1, REGION29_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR29_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR29_U_SMXP_1_1, REGION29_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR29_U_SMXP_1_1, REGION29_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR29_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR29_U_SMXP_1_1, 0x93d5e8)
    FIELD(POR_MPU_M1_PRLAR29_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR29_U_SMXP_1_1, REGION29_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR29_U_SMXP_1_1, REGION29_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR30_U_SMXP_1_1, 0x93d5f0)
    FIELD(POR_MPU_M1_PRBAR30_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR30_U_SMXP_1_1, REGION30_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR30_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR30_U_SMXP_1_1, REGION30_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR30_U_SMXP_1_1, REGION30_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR30_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR30_U_SMXP_1_1, 0x93d5f8)
    FIELD(POR_MPU_M1_PRLAR30_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR30_U_SMXP_1_1, REGION30_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR30_U_SMXP_1_1, REGION30_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR31_U_SMXP_1_1, 0x93d600)
    FIELD(POR_MPU_M1_PRBAR31_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR31_U_SMXP_1_1, REGION31_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR31_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR31_U_SMXP_1_1, REGION31_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR31_U_SMXP_1_1, REGION31_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR31_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR31_U_SMXP_1_1, 0x93d608)
    FIELD(POR_MPU_M1_PRLAR31_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR31_U_SMXP_1_1, REGION31_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR31_U_SMXP_1_1, REGION31_EN, 0, 1)
REG32(POR_MPU_M2_CTL_U_SMXP_1_1, 0x93d800)
    FIELD(POR_MPU_M2_CTL_U_SMXP_1_1, M2_EN, 2, 1)
    FIELD(POR_MPU_M2_CTL_U_SMXP_1_1, M2_ACTION, 0, 2)
REG32(POR_MPU_M2_PRBAR0_U_SMXP_1_1, 0x93d810)
    FIELD(POR_MPU_M2_PRBAR0_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR0_U_SMXP_1_1, REGION0_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR0_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR0_U_SMXP_1_1, REGION0_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR0_U_SMXP_1_1, REGION0_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR0_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR0_U_SMXP_1_1, 0x93d818)
    FIELD(POR_MPU_M2_PRLAR0_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR0_U_SMXP_1_1, REGION0_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR0_U_SMXP_1_1, REGION0_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR1_U_SMXP_1_1, 0x93d820)
    FIELD(POR_MPU_M2_PRBAR1_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR1_U_SMXP_1_1, REGION1_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR1_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR1_U_SMXP_1_1, REGION1_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR1_U_SMXP_1_1, REGION1_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR1_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR1_U_SMXP_1_1, 0x93d828)
    FIELD(POR_MPU_M2_PRLAR1_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR1_U_SMXP_1_1, REGION1_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR1_U_SMXP_1_1, REGION1_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR2_U_SMXP_1_1, 0x93d830)
    FIELD(POR_MPU_M2_PRBAR2_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR2_U_SMXP_1_1, REGION2_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR2_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR2_U_SMXP_1_1, REGION2_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR2_U_SMXP_1_1, REGION2_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR2_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR2_U_SMXP_1_1, 0x93d838)
    FIELD(POR_MPU_M2_PRLAR2_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR2_U_SMXP_1_1, REGION2_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR2_U_SMXP_1_1, REGION2_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR3_U_SMXP_1_1, 0x93d840)
    FIELD(POR_MPU_M2_PRBAR3_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR3_U_SMXP_1_1, REGION3_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR3_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR3_U_SMXP_1_1, REGION3_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR3_U_SMXP_1_1, REGION3_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR3_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR3_U_SMXP_1_1, 0x93d848)
    FIELD(POR_MPU_M2_PRLAR3_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR3_U_SMXP_1_1, REGION3_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR3_U_SMXP_1_1, REGION3_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR4_U_SMXP_1_1, 0x93d850)
    FIELD(POR_MPU_M2_PRBAR4_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR4_U_SMXP_1_1, REGION4_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR4_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR4_U_SMXP_1_1, REGION4_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR4_U_SMXP_1_1, REGION4_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR4_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR4_U_SMXP_1_1, 0x93d858)
    FIELD(POR_MPU_M2_PRLAR4_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR4_U_SMXP_1_1, REGION4_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR4_U_SMXP_1_1, REGION4_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR5_U_SMXP_1_1, 0x93d860)
    FIELD(POR_MPU_M2_PRBAR5_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR5_U_SMXP_1_1, REGION5_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR5_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR5_U_SMXP_1_1, REGION5_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR5_U_SMXP_1_1, REGION5_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR5_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR5_U_SMXP_1_1, 0x93d868)
    FIELD(POR_MPU_M2_PRLAR5_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR5_U_SMXP_1_1, REGION5_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR5_U_SMXP_1_1, REGION5_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR6_U_SMXP_1_1, 0x93d870)
    FIELD(POR_MPU_M2_PRBAR6_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR6_U_SMXP_1_1, REGION6_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR6_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR6_U_SMXP_1_1, REGION6_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR6_U_SMXP_1_1, REGION6_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR6_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR6_U_SMXP_1_1, 0x93d878)
    FIELD(POR_MPU_M2_PRLAR6_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR6_U_SMXP_1_1, REGION6_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR6_U_SMXP_1_1, REGION6_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR7_U_SMXP_1_1, 0x93d880)
    FIELD(POR_MPU_M2_PRBAR7_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR7_U_SMXP_1_1, REGION7_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR7_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR7_U_SMXP_1_1, REGION7_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR7_U_SMXP_1_1, REGION7_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR7_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR7_U_SMXP_1_1, 0x93d888)
    FIELD(POR_MPU_M2_PRLAR7_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR7_U_SMXP_1_1, REGION7_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR7_U_SMXP_1_1, REGION7_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR8_U_SMXP_1_1, 0x93d890)
    FIELD(POR_MPU_M2_PRBAR8_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR8_U_SMXP_1_1, REGION8_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR8_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR8_U_SMXP_1_1, REGION8_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR8_U_SMXP_1_1, REGION8_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR8_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR8_U_SMXP_1_1, 0x93d898)
    FIELD(POR_MPU_M2_PRLAR8_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR8_U_SMXP_1_1, REGION8_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR8_U_SMXP_1_1, REGION8_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR9_U_SMXP_1_1, 0x93d8a0)
    FIELD(POR_MPU_M2_PRBAR9_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR9_U_SMXP_1_1, REGION9_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR9_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR9_U_SMXP_1_1, REGION9_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR9_U_SMXP_1_1, REGION9_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR9_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR9_U_SMXP_1_1, 0x93d8a8)
    FIELD(POR_MPU_M2_PRLAR9_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR9_U_SMXP_1_1, REGION9_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR9_U_SMXP_1_1, REGION9_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR10_U_SMXP_1_1, 0x93d8b0)
    FIELD(POR_MPU_M2_PRBAR10_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR10_U_SMXP_1_1, REGION10_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR10_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR10_U_SMXP_1_1, REGION10_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR10_U_SMXP_1_1, REGION10_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR10_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR10_U_SMXP_1_1, 0x93d8b8)
    FIELD(POR_MPU_M2_PRLAR10_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR10_U_SMXP_1_1, REGION10_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR10_U_SMXP_1_1, REGION10_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR11_U_SMXP_1_1, 0x93d8c0)
    FIELD(POR_MPU_M2_PRBAR11_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR11_U_SMXP_1_1, REGION11_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR11_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR11_U_SMXP_1_1, REGION11_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR11_U_SMXP_1_1, REGION11_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR11_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR11_U_SMXP_1_1, 0x93d8c8)
    FIELD(POR_MPU_M2_PRLAR11_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR11_U_SMXP_1_1, REGION11_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR11_U_SMXP_1_1, REGION11_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR12_U_SMXP_1_1, 0x93d8d0)
    FIELD(POR_MPU_M2_PRBAR12_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR12_U_SMXP_1_1, REGION12_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR12_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR12_U_SMXP_1_1, REGION12_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR12_U_SMXP_1_1, REGION12_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR12_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR12_U_SMXP_1_1, 0x93d8d8)
    FIELD(POR_MPU_M2_PRLAR12_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR12_U_SMXP_1_1, REGION12_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR12_U_SMXP_1_1, REGION12_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR13_U_SMXP_1_1, 0x93d8e0)
    FIELD(POR_MPU_M2_PRBAR13_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR13_U_SMXP_1_1, REGION13_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR13_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR13_U_SMXP_1_1, REGION13_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR13_U_SMXP_1_1, REGION13_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR13_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR13_U_SMXP_1_1, 0x93d8e8)
    FIELD(POR_MPU_M2_PRLAR13_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR13_U_SMXP_1_1, REGION13_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR13_U_SMXP_1_1, REGION13_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR14_U_SMXP_1_1, 0x93d8f0)
    FIELD(POR_MPU_M2_PRBAR14_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR14_U_SMXP_1_1, REGION14_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR14_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR14_U_SMXP_1_1, REGION14_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR14_U_SMXP_1_1, REGION14_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR14_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR14_U_SMXP_1_1, 0x93d8f8)
    FIELD(POR_MPU_M2_PRLAR14_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR14_U_SMXP_1_1, REGION14_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR14_U_SMXP_1_1, REGION14_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR15_U_SMXP_1_1, 0x93d900)
    FIELD(POR_MPU_M2_PRBAR15_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR15_U_SMXP_1_1, REGION15_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR15_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR15_U_SMXP_1_1, REGION15_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR15_U_SMXP_1_1, REGION15_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR15_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR15_U_SMXP_1_1, 0x93d908)
    FIELD(POR_MPU_M2_PRLAR15_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR15_U_SMXP_1_1, REGION15_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR15_U_SMXP_1_1, REGION15_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR16_U_SMXP_1_1, 0x93d910)
    FIELD(POR_MPU_M2_PRBAR16_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR16_U_SMXP_1_1, REGION16_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR16_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR16_U_SMXP_1_1, REGION16_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR16_U_SMXP_1_1, REGION16_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR16_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR16_U_SMXP_1_1, 0x93d918)
    FIELD(POR_MPU_M2_PRLAR16_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR16_U_SMXP_1_1, REGION16_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR16_U_SMXP_1_1, REGION16_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR17_U_SMXP_1_1, 0x93d920)
    FIELD(POR_MPU_M2_PRBAR17_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR17_U_SMXP_1_1, REGION17_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR17_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR17_U_SMXP_1_1, REGION17_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR17_U_SMXP_1_1, REGION17_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR17_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR17_U_SMXP_1_1, 0x93d928)
    FIELD(POR_MPU_M2_PRLAR17_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR17_U_SMXP_1_1, REGION17_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR17_U_SMXP_1_1, REGION17_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR18_U_SMXP_1_1, 0x93d930)
    FIELD(POR_MPU_M2_PRBAR18_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR18_U_SMXP_1_1, REGION18_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR18_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR18_U_SMXP_1_1, REGION18_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR18_U_SMXP_1_1, REGION18_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR18_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR18_U_SMXP_1_1, 0x93d938)
    FIELD(POR_MPU_M2_PRLAR18_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR18_U_SMXP_1_1, REGION18_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR18_U_SMXP_1_1, REGION18_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR19_U_SMXP_1_1, 0x93d940)
    FIELD(POR_MPU_M2_PRBAR19_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR19_U_SMXP_1_1, REGION19_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR19_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR19_U_SMXP_1_1, REGION19_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR19_U_SMXP_1_1, REGION19_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR19_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR19_U_SMXP_1_1, 0x93d948)
    FIELD(POR_MPU_M2_PRLAR19_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR19_U_SMXP_1_1, REGION19_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR19_U_SMXP_1_1, REGION19_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR20_U_SMXP_1_1, 0x93d950)
    FIELD(POR_MPU_M2_PRBAR20_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR20_U_SMXP_1_1, REGION20_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR20_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR20_U_SMXP_1_1, REGION20_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR20_U_SMXP_1_1, REGION20_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR20_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR20_U_SMXP_1_1, 0x93d958)
    FIELD(POR_MPU_M2_PRLAR20_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR20_U_SMXP_1_1, REGION20_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR20_U_SMXP_1_1, REGION20_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR21_U_SMXP_1_1, 0x93d960)
    FIELD(POR_MPU_M2_PRBAR21_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR21_U_SMXP_1_1, REGION21_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR21_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR21_U_SMXP_1_1, REGION21_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR21_U_SMXP_1_1, REGION21_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR21_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR21_U_SMXP_1_1, 0x93d968)
    FIELD(POR_MPU_M2_PRLAR21_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR21_U_SMXP_1_1, REGION21_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR21_U_SMXP_1_1, REGION21_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR22_U_SMXP_1_1, 0x93d970)
    FIELD(POR_MPU_M2_PRBAR22_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR22_U_SMXP_1_1, REGION22_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR22_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR22_U_SMXP_1_1, REGION22_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR22_U_SMXP_1_1, REGION22_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR22_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR22_U_SMXP_1_1, 0x93d978)
    FIELD(POR_MPU_M2_PRLAR22_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR22_U_SMXP_1_1, REGION22_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR22_U_SMXP_1_1, REGION22_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR23_U_SMXP_1_1, 0x93d980)
    FIELD(POR_MPU_M2_PRBAR23_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR23_U_SMXP_1_1, REGION23_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR23_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR23_U_SMXP_1_1, REGION23_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR23_U_SMXP_1_1, REGION23_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR23_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR23_U_SMXP_1_1, 0x93d988)
    FIELD(POR_MPU_M2_PRLAR23_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR23_U_SMXP_1_1, REGION23_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR23_U_SMXP_1_1, REGION23_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR24_U_SMXP_1_1, 0x93d990)
    FIELD(POR_MPU_M2_PRBAR24_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR24_U_SMXP_1_1, REGION24_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR24_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR24_U_SMXP_1_1, REGION24_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR24_U_SMXP_1_1, REGION24_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR24_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR24_U_SMXP_1_1, 0x93d998)
    FIELD(POR_MPU_M2_PRLAR24_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR24_U_SMXP_1_1, REGION24_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR24_U_SMXP_1_1, REGION24_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR25_U_SMXP_1_1, 0x93d9a0)
    FIELD(POR_MPU_M2_PRBAR25_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR25_U_SMXP_1_1, REGION25_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR25_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR25_U_SMXP_1_1, REGION25_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR25_U_SMXP_1_1, REGION25_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR25_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR25_U_SMXP_1_1, 0x93d9a8)
    FIELD(POR_MPU_M2_PRLAR25_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR25_U_SMXP_1_1, REGION25_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR25_U_SMXP_1_1, REGION25_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR26_U_SMXP_1_1, 0x93d9b0)
    FIELD(POR_MPU_M2_PRBAR26_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR26_U_SMXP_1_1, REGION26_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR26_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR26_U_SMXP_1_1, REGION26_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR26_U_SMXP_1_1, REGION26_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR26_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR26_U_SMXP_1_1, 0x93d9b8)
    FIELD(POR_MPU_M2_PRLAR26_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR26_U_SMXP_1_1, REGION26_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR26_U_SMXP_1_1, REGION26_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR27_U_SMXP_1_1, 0x93d9c0)
    FIELD(POR_MPU_M2_PRBAR27_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR27_U_SMXP_1_1, REGION27_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR27_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR27_U_SMXP_1_1, REGION27_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR27_U_SMXP_1_1, REGION27_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR27_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR27_U_SMXP_1_1, 0x93d9c8)
    FIELD(POR_MPU_M2_PRLAR27_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR27_U_SMXP_1_1, REGION27_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR27_U_SMXP_1_1, REGION27_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR28_U_SMXP_1_1, 0x93d9d0)
    FIELD(POR_MPU_M2_PRBAR28_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR28_U_SMXP_1_1, REGION28_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR28_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR28_U_SMXP_1_1, REGION28_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR28_U_SMXP_1_1, REGION28_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR28_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR28_U_SMXP_1_1, 0x93d9d8)
    FIELD(POR_MPU_M2_PRLAR28_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR28_U_SMXP_1_1, REGION28_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR28_U_SMXP_1_1, REGION28_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR29_U_SMXP_1_1, 0x93d9e0)
    FIELD(POR_MPU_M2_PRBAR29_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR29_U_SMXP_1_1, REGION29_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR29_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR29_U_SMXP_1_1, REGION29_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR29_U_SMXP_1_1, REGION29_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR29_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR29_U_SMXP_1_1, 0x93d9e8)
    FIELD(POR_MPU_M2_PRLAR29_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR29_U_SMXP_1_1, REGION29_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR29_U_SMXP_1_1, REGION29_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR30_U_SMXP_1_1, 0x93d9f0)
    FIELD(POR_MPU_M2_PRBAR30_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR30_U_SMXP_1_1, REGION30_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR30_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR30_U_SMXP_1_1, REGION30_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR30_U_SMXP_1_1, REGION30_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR30_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR30_U_SMXP_1_1, 0x93d9f8)
    FIELD(POR_MPU_M2_PRLAR30_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR30_U_SMXP_1_1, REGION30_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR30_U_SMXP_1_1, REGION30_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR31_U_SMXP_1_1, 0x93da00)
    FIELD(POR_MPU_M2_PRBAR31_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR31_U_SMXP_1_1, REGION31_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR31_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR31_U_SMXP_1_1, REGION31_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR31_U_SMXP_1_1, REGION31_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR31_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR31_U_SMXP_1_1, 0x93da08)
    FIELD(POR_MPU_M2_PRLAR31_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR31_U_SMXP_1_1, REGION31_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR31_U_SMXP_1_1, REGION31_EN, 0, 1)
REG32(POR_MPU_M3_CTL_U_SMXP_1_1, 0x93dc00)
    FIELD(POR_MPU_M3_CTL_U_SMXP_1_1, M3_EN, 2, 1)
    FIELD(POR_MPU_M3_CTL_U_SMXP_1_1, M3_ACTION, 0, 2)
REG32(POR_MPU_M3_PRBAR0_U_SMXP_1_1, 0x93dc10)
    FIELD(POR_MPU_M3_PRBAR0_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR0_U_SMXP_1_1, REGION0_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR0_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR0_U_SMXP_1_1, REGION0_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR0_U_SMXP_1_1, REGION0_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR0_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR0_U_SMXP_1_1, 0x93dc18)
    FIELD(POR_MPU_M3_PRLAR0_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR0_U_SMXP_1_1, REGION0_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR0_U_SMXP_1_1, REGION0_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR1_U_SMXP_1_1, 0x93dc20)
    FIELD(POR_MPU_M3_PRBAR1_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR1_U_SMXP_1_1, REGION1_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR1_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR1_U_SMXP_1_1, REGION1_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR1_U_SMXP_1_1, REGION1_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR1_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR1_U_SMXP_1_1, 0x93dc28)
    FIELD(POR_MPU_M3_PRLAR1_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR1_U_SMXP_1_1, REGION1_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR1_U_SMXP_1_1, REGION1_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR2_U_SMXP_1_1, 0x93dc30)
    FIELD(POR_MPU_M3_PRBAR2_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR2_U_SMXP_1_1, REGION2_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR2_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR2_U_SMXP_1_1, REGION2_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR2_U_SMXP_1_1, REGION2_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR2_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR2_U_SMXP_1_1, 0x93dc38)
    FIELD(POR_MPU_M3_PRLAR2_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR2_U_SMXP_1_1, REGION2_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR2_U_SMXP_1_1, REGION2_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR3_U_SMXP_1_1, 0x93dc40)
    FIELD(POR_MPU_M3_PRBAR3_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR3_U_SMXP_1_1, REGION3_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR3_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR3_U_SMXP_1_1, REGION3_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR3_U_SMXP_1_1, REGION3_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR3_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR3_U_SMXP_1_1, 0x93dc48)
    FIELD(POR_MPU_M3_PRLAR3_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR3_U_SMXP_1_1, REGION3_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR3_U_SMXP_1_1, REGION3_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR4_U_SMXP_1_1, 0x93dc50)
    FIELD(POR_MPU_M3_PRBAR4_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR4_U_SMXP_1_1, REGION4_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR4_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR4_U_SMXP_1_1, REGION4_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR4_U_SMXP_1_1, REGION4_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR4_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR4_U_SMXP_1_1, 0x93dc58)
    FIELD(POR_MPU_M3_PRLAR4_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR4_U_SMXP_1_1, REGION4_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR4_U_SMXP_1_1, REGION4_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR5_U_SMXP_1_1, 0x93dc60)
    FIELD(POR_MPU_M3_PRBAR5_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR5_U_SMXP_1_1, REGION5_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR5_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR5_U_SMXP_1_1, REGION5_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR5_U_SMXP_1_1, REGION5_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR5_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR5_U_SMXP_1_1, 0x93dc68)
    FIELD(POR_MPU_M3_PRLAR5_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR5_U_SMXP_1_1, REGION5_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR5_U_SMXP_1_1, REGION5_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR6_U_SMXP_1_1, 0x93dc70)
    FIELD(POR_MPU_M3_PRBAR6_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR6_U_SMXP_1_1, REGION6_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR6_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR6_U_SMXP_1_1, REGION6_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR6_U_SMXP_1_1, REGION6_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR6_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR6_U_SMXP_1_1, 0x93dc78)
    FIELD(POR_MPU_M3_PRLAR6_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR6_U_SMXP_1_1, REGION6_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR6_U_SMXP_1_1, REGION6_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR7_U_SMXP_1_1, 0x93dc80)
    FIELD(POR_MPU_M3_PRBAR7_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR7_U_SMXP_1_1, REGION7_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR7_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR7_U_SMXP_1_1, REGION7_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR7_U_SMXP_1_1, REGION7_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR7_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR7_U_SMXP_1_1, 0x93dc88)
    FIELD(POR_MPU_M3_PRLAR7_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR7_U_SMXP_1_1, REGION7_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR7_U_SMXP_1_1, REGION7_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR8_U_SMXP_1_1, 0x93dc90)
    FIELD(POR_MPU_M3_PRBAR8_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR8_U_SMXP_1_1, REGION8_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR8_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR8_U_SMXP_1_1, REGION8_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR8_U_SMXP_1_1, REGION8_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR8_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR8_U_SMXP_1_1, 0x93dc98)
    FIELD(POR_MPU_M3_PRLAR8_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR8_U_SMXP_1_1, REGION8_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR8_U_SMXP_1_1, REGION8_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR9_U_SMXP_1_1, 0x93dca0)
    FIELD(POR_MPU_M3_PRBAR9_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR9_U_SMXP_1_1, REGION9_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR9_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR9_U_SMXP_1_1, REGION9_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR9_U_SMXP_1_1, REGION9_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR9_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR9_U_SMXP_1_1, 0x93dca8)
    FIELD(POR_MPU_M3_PRLAR9_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR9_U_SMXP_1_1, REGION9_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR9_U_SMXP_1_1, REGION9_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR10_U_SMXP_1_1, 0x93dcb0)
    FIELD(POR_MPU_M3_PRBAR10_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR10_U_SMXP_1_1, REGION10_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR10_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR10_U_SMXP_1_1, REGION10_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR10_U_SMXP_1_1, REGION10_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR10_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR10_U_SMXP_1_1, 0x93dcb8)
    FIELD(POR_MPU_M3_PRLAR10_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR10_U_SMXP_1_1, REGION10_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR10_U_SMXP_1_1, REGION10_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR11_U_SMXP_1_1, 0x93dcc0)
    FIELD(POR_MPU_M3_PRBAR11_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR11_U_SMXP_1_1, REGION11_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR11_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR11_U_SMXP_1_1, REGION11_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR11_U_SMXP_1_1, REGION11_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR11_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR11_U_SMXP_1_1, 0x93dcc8)
    FIELD(POR_MPU_M3_PRLAR11_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR11_U_SMXP_1_1, REGION11_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR11_U_SMXP_1_1, REGION11_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR12_U_SMXP_1_1, 0x93dcd0)
    FIELD(POR_MPU_M3_PRBAR12_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR12_U_SMXP_1_1, REGION12_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR12_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR12_U_SMXP_1_1, REGION12_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR12_U_SMXP_1_1, REGION12_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR12_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR12_U_SMXP_1_1, 0x93dcd8)
    FIELD(POR_MPU_M3_PRLAR12_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR12_U_SMXP_1_1, REGION12_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR12_U_SMXP_1_1, REGION12_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR13_U_SMXP_1_1, 0x93dce0)
    FIELD(POR_MPU_M3_PRBAR13_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR13_U_SMXP_1_1, REGION13_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR13_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR13_U_SMXP_1_1, REGION13_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR13_U_SMXP_1_1, REGION13_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR13_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR13_U_SMXP_1_1, 0x93dce8)
    FIELD(POR_MPU_M3_PRLAR13_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR13_U_SMXP_1_1, REGION13_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR13_U_SMXP_1_1, REGION13_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR14_U_SMXP_1_1, 0x93dcf0)
    FIELD(POR_MPU_M3_PRBAR14_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR14_U_SMXP_1_1, REGION14_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR14_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR14_U_SMXP_1_1, REGION14_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR14_U_SMXP_1_1, REGION14_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR14_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR14_U_SMXP_1_1, 0x93dcf8)
    FIELD(POR_MPU_M3_PRLAR14_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR14_U_SMXP_1_1, REGION14_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR14_U_SMXP_1_1, REGION14_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR15_U_SMXP_1_1, 0x93dd00)
    FIELD(POR_MPU_M3_PRBAR15_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR15_U_SMXP_1_1, REGION15_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR15_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR15_U_SMXP_1_1, REGION15_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR15_U_SMXP_1_1, REGION15_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR15_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR15_U_SMXP_1_1, 0x93dd08)
    FIELD(POR_MPU_M3_PRLAR15_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR15_U_SMXP_1_1, REGION15_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR15_U_SMXP_1_1, REGION15_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR16_U_SMXP_1_1, 0x93dd10)
    FIELD(POR_MPU_M3_PRBAR16_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR16_U_SMXP_1_1, REGION16_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR16_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR16_U_SMXP_1_1, REGION16_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR16_U_SMXP_1_1, REGION16_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR16_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR16_U_SMXP_1_1, 0x93dd18)
    FIELD(POR_MPU_M3_PRLAR16_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR16_U_SMXP_1_1, REGION16_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR16_U_SMXP_1_1, REGION16_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR17_U_SMXP_1_1, 0x93dd20)
    FIELD(POR_MPU_M3_PRBAR17_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR17_U_SMXP_1_1, REGION17_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR17_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR17_U_SMXP_1_1, REGION17_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR17_U_SMXP_1_1, REGION17_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR17_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR17_U_SMXP_1_1, 0x93dd28)
    FIELD(POR_MPU_M3_PRLAR17_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR17_U_SMXP_1_1, REGION17_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR17_U_SMXP_1_1, REGION17_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR18_U_SMXP_1_1, 0x93dd30)
    FIELD(POR_MPU_M3_PRBAR18_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR18_U_SMXP_1_1, REGION18_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR18_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR18_U_SMXP_1_1, REGION18_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR18_U_SMXP_1_1, REGION18_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR18_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR18_U_SMXP_1_1, 0x93dd38)
    FIELD(POR_MPU_M3_PRLAR18_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR18_U_SMXP_1_1, REGION18_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR18_U_SMXP_1_1, REGION18_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR19_U_SMXP_1_1, 0x93dd40)
    FIELD(POR_MPU_M3_PRBAR19_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR19_U_SMXP_1_1, REGION19_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR19_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR19_U_SMXP_1_1, REGION19_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR19_U_SMXP_1_1, REGION19_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR19_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR19_U_SMXP_1_1, 0x93dd48)
    FIELD(POR_MPU_M3_PRLAR19_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR19_U_SMXP_1_1, REGION19_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR19_U_SMXP_1_1, REGION19_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR20_U_SMXP_1_1, 0x93dd50)
    FIELD(POR_MPU_M3_PRBAR20_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR20_U_SMXP_1_1, REGION20_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR20_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR20_U_SMXP_1_1, REGION20_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR20_U_SMXP_1_1, REGION20_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR20_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR20_U_SMXP_1_1, 0x93dd58)
    FIELD(POR_MPU_M3_PRLAR20_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR20_U_SMXP_1_1, REGION20_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR20_U_SMXP_1_1, REGION20_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR21_U_SMXP_1_1, 0x93dd60)
    FIELD(POR_MPU_M3_PRBAR21_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR21_U_SMXP_1_1, REGION21_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR21_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR21_U_SMXP_1_1, REGION21_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR21_U_SMXP_1_1, REGION21_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR21_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR21_U_SMXP_1_1, 0x93dd68)
    FIELD(POR_MPU_M3_PRLAR21_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR21_U_SMXP_1_1, REGION21_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR21_U_SMXP_1_1, REGION21_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR22_U_SMXP_1_1, 0x93dd70)
    FIELD(POR_MPU_M3_PRBAR22_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR22_U_SMXP_1_1, REGION22_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR22_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR22_U_SMXP_1_1, REGION22_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR22_U_SMXP_1_1, REGION22_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR22_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR22_U_SMXP_1_1, 0x93dd78)
    FIELD(POR_MPU_M3_PRLAR22_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR22_U_SMXP_1_1, REGION22_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR22_U_SMXP_1_1, REGION22_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR23_U_SMXP_1_1, 0x93dd80)
    FIELD(POR_MPU_M3_PRBAR23_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR23_U_SMXP_1_1, REGION23_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR23_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR23_U_SMXP_1_1, REGION23_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR23_U_SMXP_1_1, REGION23_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR23_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR23_U_SMXP_1_1, 0x93dd88)
    FIELD(POR_MPU_M3_PRLAR23_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR23_U_SMXP_1_1, REGION23_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR23_U_SMXP_1_1, REGION23_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR24_U_SMXP_1_1, 0x93dd90)
    FIELD(POR_MPU_M3_PRBAR24_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR24_U_SMXP_1_1, REGION24_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR24_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR24_U_SMXP_1_1, REGION24_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR24_U_SMXP_1_1, REGION24_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR24_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR24_U_SMXP_1_1, 0x93dd98)
    FIELD(POR_MPU_M3_PRLAR24_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR24_U_SMXP_1_1, REGION24_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR24_U_SMXP_1_1, REGION24_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR25_U_SMXP_1_1, 0x93dda0)
    FIELD(POR_MPU_M3_PRBAR25_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR25_U_SMXP_1_1, REGION25_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR25_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR25_U_SMXP_1_1, REGION25_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR25_U_SMXP_1_1, REGION25_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR25_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR25_U_SMXP_1_1, 0x93dda8)
    FIELD(POR_MPU_M3_PRLAR25_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR25_U_SMXP_1_1, REGION25_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR25_U_SMXP_1_1, REGION25_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR26_U_SMXP_1_1, 0x93ddb0)
    FIELD(POR_MPU_M3_PRBAR26_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR26_U_SMXP_1_1, REGION26_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR26_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR26_U_SMXP_1_1, REGION26_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR26_U_SMXP_1_1, REGION26_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR26_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR26_U_SMXP_1_1, 0x93ddb8)
    FIELD(POR_MPU_M3_PRLAR26_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR26_U_SMXP_1_1, REGION26_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR26_U_SMXP_1_1, REGION26_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR27_U_SMXP_1_1, 0x93ddc0)
    FIELD(POR_MPU_M3_PRBAR27_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR27_U_SMXP_1_1, REGION27_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR27_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR27_U_SMXP_1_1, REGION27_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR27_U_SMXP_1_1, REGION27_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR27_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR27_U_SMXP_1_1, 0x93ddc8)
    FIELD(POR_MPU_M3_PRLAR27_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR27_U_SMXP_1_1, REGION27_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR27_U_SMXP_1_1, REGION27_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR28_U_SMXP_1_1, 0x93ddd0)
    FIELD(POR_MPU_M3_PRBAR28_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR28_U_SMXP_1_1, REGION28_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR28_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR28_U_SMXP_1_1, REGION28_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR28_U_SMXP_1_1, REGION28_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR28_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR28_U_SMXP_1_1, 0x93ddd8)
    FIELD(POR_MPU_M3_PRLAR28_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR28_U_SMXP_1_1, REGION28_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR28_U_SMXP_1_1, REGION28_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR29_U_SMXP_1_1, 0x93dde0)
    FIELD(POR_MPU_M3_PRBAR29_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR29_U_SMXP_1_1, REGION29_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR29_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR29_U_SMXP_1_1, REGION29_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR29_U_SMXP_1_1, REGION29_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR29_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR29_U_SMXP_1_1, 0x93dde8)
    FIELD(POR_MPU_M3_PRLAR29_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR29_U_SMXP_1_1, REGION29_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR29_U_SMXP_1_1, REGION29_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR30_U_SMXP_1_1, 0x93ddf0)
    FIELD(POR_MPU_M3_PRBAR30_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR30_U_SMXP_1_1, REGION30_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR30_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR30_U_SMXP_1_1, REGION30_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR30_U_SMXP_1_1, REGION30_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR30_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR30_U_SMXP_1_1, 0x93ddf8)
    FIELD(POR_MPU_M3_PRLAR30_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR30_U_SMXP_1_1, REGION30_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR30_U_SMXP_1_1, REGION30_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR31_U_SMXP_1_1, 0x93de00)
    FIELD(POR_MPU_M3_PRBAR31_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR31_U_SMXP_1_1, REGION31_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR31_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR31_U_SMXP_1_1, REGION31_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR31_U_SMXP_1_1, REGION31_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR31_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR31_U_SMXP_1_1, 0x93de08)
    FIELD(POR_MPU_M3_PRLAR31_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR31_U_SMXP_1_1, REGION31_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR31_U_SMXP_1_1, REGION31_EN, 0, 1)
REG32(POR_MPU_M4_CTL_U_SMXP_1_1, 0x93e000)
    FIELD(POR_MPU_M4_CTL_U_SMXP_1_1, M4_EN, 2, 1)
    FIELD(POR_MPU_M4_CTL_U_SMXP_1_1, M4_ACTION, 0, 2)
REG32(POR_MPU_M4_PRBAR0_U_SMXP_1_1, 0x93e010)
    FIELD(POR_MPU_M4_PRBAR0_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR0_U_SMXP_1_1, REGION0_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR0_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR0_U_SMXP_1_1, REGION0_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR0_U_SMXP_1_1, REGION0_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR0_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR0_U_SMXP_1_1, 0x93e018)
    FIELD(POR_MPU_M4_PRLAR0_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR0_U_SMXP_1_1, REGION0_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR0_U_SMXP_1_1, REGION0_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR1_U_SMXP_1_1, 0x93e020)
    FIELD(POR_MPU_M4_PRBAR1_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR1_U_SMXP_1_1, REGION1_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR1_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR1_U_SMXP_1_1, REGION1_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR1_U_SMXP_1_1, REGION1_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR1_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR1_U_SMXP_1_1, 0x93e028)
    FIELD(POR_MPU_M4_PRLAR1_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR1_U_SMXP_1_1, REGION1_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR1_U_SMXP_1_1, REGION1_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR2_U_SMXP_1_1, 0x93e030)
    FIELD(POR_MPU_M4_PRBAR2_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR2_U_SMXP_1_1, REGION2_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR2_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR2_U_SMXP_1_1, REGION2_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR2_U_SMXP_1_1, REGION2_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR2_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR2_U_SMXP_1_1, 0x93e038)
    FIELD(POR_MPU_M4_PRLAR2_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR2_U_SMXP_1_1, REGION2_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR2_U_SMXP_1_1, REGION2_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR3_U_SMXP_1_1, 0x93e040)
    FIELD(POR_MPU_M4_PRBAR3_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR3_U_SMXP_1_1, REGION3_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR3_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR3_U_SMXP_1_1, REGION3_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR3_U_SMXP_1_1, REGION3_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR3_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR3_U_SMXP_1_1, 0x93e048)
    FIELD(POR_MPU_M4_PRLAR3_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR3_U_SMXP_1_1, REGION3_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR3_U_SMXP_1_1, REGION3_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR4_U_SMXP_1_1, 0x93e050)
    FIELD(POR_MPU_M4_PRBAR4_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR4_U_SMXP_1_1, REGION4_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR4_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR4_U_SMXP_1_1, REGION4_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR4_U_SMXP_1_1, REGION4_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR4_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR4_U_SMXP_1_1, 0x93e058)
    FIELD(POR_MPU_M4_PRLAR4_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR4_U_SMXP_1_1, REGION4_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR4_U_SMXP_1_1, REGION4_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR5_U_SMXP_1_1, 0x93e060)
    FIELD(POR_MPU_M4_PRBAR5_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR5_U_SMXP_1_1, REGION5_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR5_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR5_U_SMXP_1_1, REGION5_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR5_U_SMXP_1_1, REGION5_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR5_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR5_U_SMXP_1_1, 0x93e068)
    FIELD(POR_MPU_M4_PRLAR5_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR5_U_SMXP_1_1, REGION5_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR5_U_SMXP_1_1, REGION5_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR6_U_SMXP_1_1, 0x93e070)
    FIELD(POR_MPU_M4_PRBAR6_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR6_U_SMXP_1_1, REGION6_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR6_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR6_U_SMXP_1_1, REGION6_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR6_U_SMXP_1_1, REGION6_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR6_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR6_U_SMXP_1_1, 0x93e078)
    FIELD(POR_MPU_M4_PRLAR6_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR6_U_SMXP_1_1, REGION6_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR6_U_SMXP_1_1, REGION6_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR7_U_SMXP_1_1, 0x93e080)
    FIELD(POR_MPU_M4_PRBAR7_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR7_U_SMXP_1_1, REGION7_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR7_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR7_U_SMXP_1_1, REGION7_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR7_U_SMXP_1_1, REGION7_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR7_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR7_U_SMXP_1_1, 0x93e088)
    FIELD(POR_MPU_M4_PRLAR7_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR7_U_SMXP_1_1, REGION7_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR7_U_SMXP_1_1, REGION7_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR8_U_SMXP_1_1, 0x93e090)
    FIELD(POR_MPU_M4_PRBAR8_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR8_U_SMXP_1_1, REGION8_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR8_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR8_U_SMXP_1_1, REGION8_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR8_U_SMXP_1_1, REGION8_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR8_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR8_U_SMXP_1_1, 0x93e098)
    FIELD(POR_MPU_M4_PRLAR8_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR8_U_SMXP_1_1, REGION8_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR8_U_SMXP_1_1, REGION8_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR9_U_SMXP_1_1, 0x93e0a0)
    FIELD(POR_MPU_M4_PRBAR9_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR9_U_SMXP_1_1, REGION9_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR9_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR9_U_SMXP_1_1, REGION9_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR9_U_SMXP_1_1, REGION9_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR9_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR9_U_SMXP_1_1, 0x93e0a8)
    FIELD(POR_MPU_M4_PRLAR9_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR9_U_SMXP_1_1, REGION9_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR9_U_SMXP_1_1, REGION9_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR10_U_SMXP_1_1, 0x93e0b0)
    FIELD(POR_MPU_M4_PRBAR10_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR10_U_SMXP_1_1, REGION10_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR10_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR10_U_SMXP_1_1, REGION10_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR10_U_SMXP_1_1, REGION10_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR10_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR10_U_SMXP_1_1, 0x93e0b8)
    FIELD(POR_MPU_M4_PRLAR10_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR10_U_SMXP_1_1, REGION10_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR10_U_SMXP_1_1, REGION10_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR11_U_SMXP_1_1, 0x93e0c0)
    FIELD(POR_MPU_M4_PRBAR11_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR11_U_SMXP_1_1, REGION11_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR11_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR11_U_SMXP_1_1, REGION11_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR11_U_SMXP_1_1, REGION11_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR11_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR11_U_SMXP_1_1, 0x93e0c8)
    FIELD(POR_MPU_M4_PRLAR11_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR11_U_SMXP_1_1, REGION11_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR11_U_SMXP_1_1, REGION11_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR12_U_SMXP_1_1, 0x93e0d0)
    FIELD(POR_MPU_M4_PRBAR12_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR12_U_SMXP_1_1, REGION12_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR12_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR12_U_SMXP_1_1, REGION12_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR12_U_SMXP_1_1, REGION12_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR12_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR12_U_SMXP_1_1, 0x93e0d8)
    FIELD(POR_MPU_M4_PRLAR12_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR12_U_SMXP_1_1, REGION12_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR12_U_SMXP_1_1, REGION12_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR13_U_SMXP_1_1, 0x93e0e0)
    FIELD(POR_MPU_M4_PRBAR13_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR13_U_SMXP_1_1, REGION13_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR13_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR13_U_SMXP_1_1, REGION13_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR13_U_SMXP_1_1, REGION13_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR13_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR13_U_SMXP_1_1, 0x93e0e8)
    FIELD(POR_MPU_M4_PRLAR13_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR13_U_SMXP_1_1, REGION13_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR13_U_SMXP_1_1, REGION13_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR14_U_SMXP_1_1, 0x93e0f0)
    FIELD(POR_MPU_M4_PRBAR14_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR14_U_SMXP_1_1, REGION14_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR14_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR14_U_SMXP_1_1, REGION14_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR14_U_SMXP_1_1, REGION14_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR14_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR14_U_SMXP_1_1, 0x93e0f8)
    FIELD(POR_MPU_M4_PRLAR14_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR14_U_SMXP_1_1, REGION14_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR14_U_SMXP_1_1, REGION14_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR15_U_SMXP_1_1, 0x93e100)
    FIELD(POR_MPU_M4_PRBAR15_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR15_U_SMXP_1_1, REGION15_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR15_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR15_U_SMXP_1_1, REGION15_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR15_U_SMXP_1_1, REGION15_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR15_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR15_U_SMXP_1_1, 0x93e108)
    FIELD(POR_MPU_M4_PRLAR15_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR15_U_SMXP_1_1, REGION15_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR15_U_SMXP_1_1, REGION15_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR16_U_SMXP_1_1, 0x93e110)
    FIELD(POR_MPU_M4_PRBAR16_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR16_U_SMXP_1_1, REGION16_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR16_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR16_U_SMXP_1_1, REGION16_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR16_U_SMXP_1_1, REGION16_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR16_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR16_U_SMXP_1_1, 0x93e118)
    FIELD(POR_MPU_M4_PRLAR16_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR16_U_SMXP_1_1, REGION16_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR16_U_SMXP_1_1, REGION16_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR17_U_SMXP_1_1, 0x93e120)
    FIELD(POR_MPU_M4_PRBAR17_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR17_U_SMXP_1_1, REGION17_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR17_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR17_U_SMXP_1_1, REGION17_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR17_U_SMXP_1_1, REGION17_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR17_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR17_U_SMXP_1_1, 0x93e128)
    FIELD(POR_MPU_M4_PRLAR17_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR17_U_SMXP_1_1, REGION17_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR17_U_SMXP_1_1, REGION17_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR18_U_SMXP_1_1, 0x93e130)
    FIELD(POR_MPU_M4_PRBAR18_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR18_U_SMXP_1_1, REGION18_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR18_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR18_U_SMXP_1_1, REGION18_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR18_U_SMXP_1_1, REGION18_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR18_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR18_U_SMXP_1_1, 0x93e138)
    FIELD(POR_MPU_M4_PRLAR18_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR18_U_SMXP_1_1, REGION18_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR18_U_SMXP_1_1, REGION18_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR19_U_SMXP_1_1, 0x93e140)
    FIELD(POR_MPU_M4_PRBAR19_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR19_U_SMXP_1_1, REGION19_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR19_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR19_U_SMXP_1_1, REGION19_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR19_U_SMXP_1_1, REGION19_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR19_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR19_U_SMXP_1_1, 0x93e148)
    FIELD(POR_MPU_M4_PRLAR19_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR19_U_SMXP_1_1, REGION19_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR19_U_SMXP_1_1, REGION19_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR20_U_SMXP_1_1, 0x93e150)
    FIELD(POR_MPU_M4_PRBAR20_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR20_U_SMXP_1_1, REGION20_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR20_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR20_U_SMXP_1_1, REGION20_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR20_U_SMXP_1_1, REGION20_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR20_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR20_U_SMXP_1_1, 0x93e158)
    FIELD(POR_MPU_M4_PRLAR20_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR20_U_SMXP_1_1, REGION20_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR20_U_SMXP_1_1, REGION20_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR21_U_SMXP_1_1, 0x93e160)
    FIELD(POR_MPU_M4_PRBAR21_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR21_U_SMXP_1_1, REGION21_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR21_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR21_U_SMXP_1_1, REGION21_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR21_U_SMXP_1_1, REGION21_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR21_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR21_U_SMXP_1_1, 0x93e168)
    FIELD(POR_MPU_M4_PRLAR21_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR21_U_SMXP_1_1, REGION21_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR21_U_SMXP_1_1, REGION21_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR22_U_SMXP_1_1, 0x93e170)
    FIELD(POR_MPU_M4_PRBAR22_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR22_U_SMXP_1_1, REGION22_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR22_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR22_U_SMXP_1_1, REGION22_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR22_U_SMXP_1_1, REGION22_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR22_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR22_U_SMXP_1_1, 0x93e178)
    FIELD(POR_MPU_M4_PRLAR22_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR22_U_SMXP_1_1, REGION22_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR22_U_SMXP_1_1, REGION22_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR23_U_SMXP_1_1, 0x93e180)
    FIELD(POR_MPU_M4_PRBAR23_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR23_U_SMXP_1_1, REGION23_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR23_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR23_U_SMXP_1_1, REGION23_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR23_U_SMXP_1_1, REGION23_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR23_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR23_U_SMXP_1_1, 0x93e188)
    FIELD(POR_MPU_M4_PRLAR23_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR23_U_SMXP_1_1, REGION23_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR23_U_SMXP_1_1, REGION23_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR24_U_SMXP_1_1, 0x93e190)
    FIELD(POR_MPU_M4_PRBAR24_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR24_U_SMXP_1_1, REGION24_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR24_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR24_U_SMXP_1_1, REGION24_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR24_U_SMXP_1_1, REGION24_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR24_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR24_U_SMXP_1_1, 0x93e198)
    FIELD(POR_MPU_M4_PRLAR24_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR24_U_SMXP_1_1, REGION24_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR24_U_SMXP_1_1, REGION24_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR25_U_SMXP_1_1, 0x93e1a0)
    FIELD(POR_MPU_M4_PRBAR25_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR25_U_SMXP_1_1, REGION25_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR25_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR25_U_SMXP_1_1, REGION25_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR25_U_SMXP_1_1, REGION25_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR25_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR25_U_SMXP_1_1, 0x93e1a8)
    FIELD(POR_MPU_M4_PRLAR25_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR25_U_SMXP_1_1, REGION25_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR25_U_SMXP_1_1, REGION25_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR26_U_SMXP_1_1, 0x93e1b0)
    FIELD(POR_MPU_M4_PRBAR26_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR26_U_SMXP_1_1, REGION26_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR26_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR26_U_SMXP_1_1, REGION26_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR26_U_SMXP_1_1, REGION26_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR26_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR26_U_SMXP_1_1, 0x93e1b8)
    FIELD(POR_MPU_M4_PRLAR26_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR26_U_SMXP_1_1, REGION26_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR26_U_SMXP_1_1, REGION26_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR27_U_SMXP_1_1, 0x93e1c0)
    FIELD(POR_MPU_M4_PRBAR27_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR27_U_SMXP_1_1, REGION27_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR27_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR27_U_SMXP_1_1, REGION27_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR27_U_SMXP_1_1, REGION27_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR27_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR27_U_SMXP_1_1, 0x93e1c8)
    FIELD(POR_MPU_M4_PRLAR27_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR27_U_SMXP_1_1, REGION27_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR27_U_SMXP_1_1, REGION27_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR28_U_SMXP_1_1, 0x93e1d0)
    FIELD(POR_MPU_M4_PRBAR28_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR28_U_SMXP_1_1, REGION28_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR28_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR28_U_SMXP_1_1, REGION28_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR28_U_SMXP_1_1, REGION28_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR28_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR28_U_SMXP_1_1, 0x93e1d8)
    FIELD(POR_MPU_M4_PRLAR28_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR28_U_SMXP_1_1, REGION28_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR28_U_SMXP_1_1, REGION28_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR29_U_SMXP_1_1, 0x93e1e0)
    FIELD(POR_MPU_M4_PRBAR29_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR29_U_SMXP_1_1, REGION29_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR29_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR29_U_SMXP_1_1, REGION29_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR29_U_SMXP_1_1, REGION29_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR29_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR29_U_SMXP_1_1, 0x93e1e8)
    FIELD(POR_MPU_M4_PRLAR29_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR29_U_SMXP_1_1, REGION29_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR29_U_SMXP_1_1, REGION29_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR30_U_SMXP_1_1, 0x93e1f0)
    FIELD(POR_MPU_M4_PRBAR30_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR30_U_SMXP_1_1, REGION30_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR30_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR30_U_SMXP_1_1, REGION30_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR30_U_SMXP_1_1, REGION30_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR30_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR30_U_SMXP_1_1, 0x93e1f8)
    FIELD(POR_MPU_M4_PRLAR30_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR30_U_SMXP_1_1, REGION30_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR30_U_SMXP_1_1, REGION30_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR31_U_SMXP_1_1, 0x93e200)
    FIELD(POR_MPU_M4_PRBAR31_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR31_U_SMXP_1_1, REGION31_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR31_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR31_U_SMXP_1_1, REGION31_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR31_U_SMXP_1_1, REGION31_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR31_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR31_U_SMXP_1_1, 0x93e208)
    FIELD(POR_MPU_M4_PRLAR31_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR31_U_SMXP_1_1, REGION31_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR31_U_SMXP_1_1, REGION31_EN, 0, 1)
REG32(POR_MPU_M5_CTL_U_SMXP_1_1, 0x93e400)
    FIELD(POR_MPU_M5_CTL_U_SMXP_1_1, M5_EN, 2, 1)
    FIELD(POR_MPU_M5_CTL_U_SMXP_1_1, M5_ACTION, 0, 2)
REG32(POR_MPU_M5_PRBAR0_U_SMXP_1_1, 0x93e410)
    FIELD(POR_MPU_M5_PRBAR0_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR0_U_SMXP_1_1, REGION0_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR0_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR0_U_SMXP_1_1, REGION0_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR0_U_SMXP_1_1, REGION0_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR0_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR0_U_SMXP_1_1, 0x93e418)
    FIELD(POR_MPU_M5_PRLAR0_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR0_U_SMXP_1_1, REGION0_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR0_U_SMXP_1_1, REGION0_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR1_U_SMXP_1_1, 0x93e420)
    FIELD(POR_MPU_M5_PRBAR1_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR1_U_SMXP_1_1, REGION1_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR1_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR1_U_SMXP_1_1, REGION1_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR1_U_SMXP_1_1, REGION1_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR1_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR1_U_SMXP_1_1, 0x93e428)
    FIELD(POR_MPU_M5_PRLAR1_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR1_U_SMXP_1_1, REGION1_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR1_U_SMXP_1_1, REGION1_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR2_U_SMXP_1_1, 0x93e430)
    FIELD(POR_MPU_M5_PRBAR2_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR2_U_SMXP_1_1, REGION2_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR2_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR2_U_SMXP_1_1, REGION2_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR2_U_SMXP_1_1, REGION2_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR2_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR2_U_SMXP_1_1, 0x93e438)
    FIELD(POR_MPU_M5_PRLAR2_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR2_U_SMXP_1_1, REGION2_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR2_U_SMXP_1_1, REGION2_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR3_U_SMXP_1_1, 0x93e440)
    FIELD(POR_MPU_M5_PRBAR3_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR3_U_SMXP_1_1, REGION3_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR3_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR3_U_SMXP_1_1, REGION3_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR3_U_SMXP_1_1, REGION3_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR3_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR3_U_SMXP_1_1, 0x93e448)
    FIELD(POR_MPU_M5_PRLAR3_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR3_U_SMXP_1_1, REGION3_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR3_U_SMXP_1_1, REGION3_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR4_U_SMXP_1_1, 0x93e450)
    FIELD(POR_MPU_M5_PRBAR4_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR4_U_SMXP_1_1, REGION4_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR4_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR4_U_SMXP_1_1, REGION4_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR4_U_SMXP_1_1, REGION4_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR4_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR4_U_SMXP_1_1, 0x93e458)
    FIELD(POR_MPU_M5_PRLAR4_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR4_U_SMXP_1_1, REGION4_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR4_U_SMXP_1_1, REGION4_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR5_U_SMXP_1_1, 0x93e460)
    FIELD(POR_MPU_M5_PRBAR5_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR5_U_SMXP_1_1, REGION5_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR5_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR5_U_SMXP_1_1, REGION5_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR5_U_SMXP_1_1, REGION5_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR5_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR5_U_SMXP_1_1, 0x93e468)
    FIELD(POR_MPU_M5_PRLAR5_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR5_U_SMXP_1_1, REGION5_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR5_U_SMXP_1_1, REGION5_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR6_U_SMXP_1_1, 0x93e470)
    FIELD(POR_MPU_M5_PRBAR6_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR6_U_SMXP_1_1, REGION6_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR6_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR6_U_SMXP_1_1, REGION6_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR6_U_SMXP_1_1, REGION6_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR6_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR6_U_SMXP_1_1, 0x93e478)
    FIELD(POR_MPU_M5_PRLAR6_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR6_U_SMXP_1_1, REGION6_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR6_U_SMXP_1_1, REGION6_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR7_U_SMXP_1_1, 0x93e480)
    FIELD(POR_MPU_M5_PRBAR7_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR7_U_SMXP_1_1, REGION7_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR7_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR7_U_SMXP_1_1, REGION7_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR7_U_SMXP_1_1, REGION7_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR7_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR7_U_SMXP_1_1, 0x93e488)
    FIELD(POR_MPU_M5_PRLAR7_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR7_U_SMXP_1_1, REGION7_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR7_U_SMXP_1_1, REGION7_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR8_U_SMXP_1_1, 0x93e490)
    FIELD(POR_MPU_M5_PRBAR8_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR8_U_SMXP_1_1, REGION8_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR8_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR8_U_SMXP_1_1, REGION8_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR8_U_SMXP_1_1, REGION8_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR8_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR8_U_SMXP_1_1, 0x93e498)
    FIELD(POR_MPU_M5_PRLAR8_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR8_U_SMXP_1_1, REGION8_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR8_U_SMXP_1_1, REGION8_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR9_U_SMXP_1_1, 0x93e4a0)
    FIELD(POR_MPU_M5_PRBAR9_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR9_U_SMXP_1_1, REGION9_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR9_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR9_U_SMXP_1_1, REGION9_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR9_U_SMXP_1_1, REGION9_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR9_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR9_U_SMXP_1_1, 0x93e4a8)
    FIELD(POR_MPU_M5_PRLAR9_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR9_U_SMXP_1_1, REGION9_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR9_U_SMXP_1_1, REGION9_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR10_U_SMXP_1_1, 0x93e4b0)
    FIELD(POR_MPU_M5_PRBAR10_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR10_U_SMXP_1_1, REGION10_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR10_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR10_U_SMXP_1_1, REGION10_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR10_U_SMXP_1_1, REGION10_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR10_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR10_U_SMXP_1_1, 0x93e4b8)
    FIELD(POR_MPU_M5_PRLAR10_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR10_U_SMXP_1_1, REGION10_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR10_U_SMXP_1_1, REGION10_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR11_U_SMXP_1_1, 0x93e4c0)
    FIELD(POR_MPU_M5_PRBAR11_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR11_U_SMXP_1_1, REGION11_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR11_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR11_U_SMXP_1_1, REGION11_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR11_U_SMXP_1_1, REGION11_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR11_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR11_U_SMXP_1_1, 0x93e4c8)
    FIELD(POR_MPU_M5_PRLAR11_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR11_U_SMXP_1_1, REGION11_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR11_U_SMXP_1_1, REGION11_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR12_U_SMXP_1_1, 0x93e4d0)
    FIELD(POR_MPU_M5_PRBAR12_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR12_U_SMXP_1_1, REGION12_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR12_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR12_U_SMXP_1_1, REGION12_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR12_U_SMXP_1_1, REGION12_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR12_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR12_U_SMXP_1_1, 0x93e4d8)
    FIELD(POR_MPU_M5_PRLAR12_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR12_U_SMXP_1_1, REGION12_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR12_U_SMXP_1_1, REGION12_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR13_U_SMXP_1_1, 0x93e4e0)
    FIELD(POR_MPU_M5_PRBAR13_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR13_U_SMXP_1_1, REGION13_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR13_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR13_U_SMXP_1_1, REGION13_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR13_U_SMXP_1_1, REGION13_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR13_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR13_U_SMXP_1_1, 0x93e4e8)
    FIELD(POR_MPU_M5_PRLAR13_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR13_U_SMXP_1_1, REGION13_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR13_U_SMXP_1_1, REGION13_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR14_U_SMXP_1_1, 0x93e4f0)
    FIELD(POR_MPU_M5_PRBAR14_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR14_U_SMXP_1_1, REGION14_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR14_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR14_U_SMXP_1_1, REGION14_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR14_U_SMXP_1_1, REGION14_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR14_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR14_U_SMXP_1_1, 0x93e4f8)
    FIELD(POR_MPU_M5_PRLAR14_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR14_U_SMXP_1_1, REGION14_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR14_U_SMXP_1_1, REGION14_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR15_U_SMXP_1_1, 0x93e500)
    FIELD(POR_MPU_M5_PRBAR15_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR15_U_SMXP_1_1, REGION15_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR15_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR15_U_SMXP_1_1, REGION15_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR15_U_SMXP_1_1, REGION15_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR15_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR15_U_SMXP_1_1, 0x93e508)
    FIELD(POR_MPU_M5_PRLAR15_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR15_U_SMXP_1_1, REGION15_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR15_U_SMXP_1_1, REGION15_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR16_U_SMXP_1_1, 0x93e510)
    FIELD(POR_MPU_M5_PRBAR16_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR16_U_SMXP_1_1, REGION16_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR16_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR16_U_SMXP_1_1, REGION16_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR16_U_SMXP_1_1, REGION16_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR16_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR16_U_SMXP_1_1, 0x93e518)
    FIELD(POR_MPU_M5_PRLAR16_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR16_U_SMXP_1_1, REGION16_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR16_U_SMXP_1_1, REGION16_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR17_U_SMXP_1_1, 0x93e520)
    FIELD(POR_MPU_M5_PRBAR17_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR17_U_SMXP_1_1, REGION17_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR17_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR17_U_SMXP_1_1, REGION17_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR17_U_SMXP_1_1, REGION17_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR17_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR17_U_SMXP_1_1, 0x93e528)
    FIELD(POR_MPU_M5_PRLAR17_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR17_U_SMXP_1_1, REGION17_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR17_U_SMXP_1_1, REGION17_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR18_U_SMXP_1_1, 0x93e530)
    FIELD(POR_MPU_M5_PRBAR18_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR18_U_SMXP_1_1, REGION18_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR18_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR18_U_SMXP_1_1, REGION18_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR18_U_SMXP_1_1, REGION18_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR18_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR18_U_SMXP_1_1, 0x93e538)
    FIELD(POR_MPU_M5_PRLAR18_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR18_U_SMXP_1_1, REGION18_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR18_U_SMXP_1_1, REGION18_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR19_U_SMXP_1_1, 0x93e540)
    FIELD(POR_MPU_M5_PRBAR19_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR19_U_SMXP_1_1, REGION19_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR19_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR19_U_SMXP_1_1, REGION19_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR19_U_SMXP_1_1, REGION19_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR19_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR19_U_SMXP_1_1, 0x93e548)
    FIELD(POR_MPU_M5_PRLAR19_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR19_U_SMXP_1_1, REGION19_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR19_U_SMXP_1_1, REGION19_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR20_U_SMXP_1_1, 0x93e550)
    FIELD(POR_MPU_M5_PRBAR20_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR20_U_SMXP_1_1, REGION20_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR20_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR20_U_SMXP_1_1, REGION20_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR20_U_SMXP_1_1, REGION20_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR20_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR20_U_SMXP_1_1, 0x93e558)
    FIELD(POR_MPU_M5_PRLAR20_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR20_U_SMXP_1_1, REGION20_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR20_U_SMXP_1_1, REGION20_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR21_U_SMXP_1_1, 0x93e560)
    FIELD(POR_MPU_M5_PRBAR21_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR21_U_SMXP_1_1, REGION21_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR21_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR21_U_SMXP_1_1, REGION21_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR21_U_SMXP_1_1, REGION21_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR21_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR21_U_SMXP_1_1, 0x93e568)
    FIELD(POR_MPU_M5_PRLAR21_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR21_U_SMXP_1_1, REGION21_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR21_U_SMXP_1_1, REGION21_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR22_U_SMXP_1_1, 0x93e570)
    FIELD(POR_MPU_M5_PRBAR22_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR22_U_SMXP_1_1, REGION22_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR22_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR22_U_SMXP_1_1, REGION22_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR22_U_SMXP_1_1, REGION22_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR22_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR22_U_SMXP_1_1, 0x93e578)
    FIELD(POR_MPU_M5_PRLAR22_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR22_U_SMXP_1_1, REGION22_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR22_U_SMXP_1_1, REGION22_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR23_U_SMXP_1_1, 0x93e580)
    FIELD(POR_MPU_M5_PRBAR23_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR23_U_SMXP_1_1, REGION23_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR23_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR23_U_SMXP_1_1, REGION23_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR23_U_SMXP_1_1, REGION23_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR23_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR23_U_SMXP_1_1, 0x93e588)
    FIELD(POR_MPU_M5_PRLAR23_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR23_U_SMXP_1_1, REGION23_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR23_U_SMXP_1_1, REGION23_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR24_U_SMXP_1_1, 0x93e590)
    FIELD(POR_MPU_M5_PRBAR24_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR24_U_SMXP_1_1, REGION24_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR24_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR24_U_SMXP_1_1, REGION24_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR24_U_SMXP_1_1, REGION24_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR24_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR24_U_SMXP_1_1, 0x93e598)
    FIELD(POR_MPU_M5_PRLAR24_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR24_U_SMXP_1_1, REGION24_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR24_U_SMXP_1_1, REGION24_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR25_U_SMXP_1_1, 0x93e5a0)
    FIELD(POR_MPU_M5_PRBAR25_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR25_U_SMXP_1_1, REGION25_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR25_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR25_U_SMXP_1_1, REGION25_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR25_U_SMXP_1_1, REGION25_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR25_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR25_U_SMXP_1_1, 0x93e5a8)
    FIELD(POR_MPU_M5_PRLAR25_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR25_U_SMXP_1_1, REGION25_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR25_U_SMXP_1_1, REGION25_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR26_U_SMXP_1_1, 0x93e5b0)
    FIELD(POR_MPU_M5_PRBAR26_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR26_U_SMXP_1_1, REGION26_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR26_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR26_U_SMXP_1_1, REGION26_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR26_U_SMXP_1_1, REGION26_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR26_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR26_U_SMXP_1_1, 0x93e5b8)
    FIELD(POR_MPU_M5_PRLAR26_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR26_U_SMXP_1_1, REGION26_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR26_U_SMXP_1_1, REGION26_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR27_U_SMXP_1_1, 0x93e5c0)
    FIELD(POR_MPU_M5_PRBAR27_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR27_U_SMXP_1_1, REGION27_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR27_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR27_U_SMXP_1_1, REGION27_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR27_U_SMXP_1_1, REGION27_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR27_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR27_U_SMXP_1_1, 0x93e5c8)
    FIELD(POR_MPU_M5_PRLAR27_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR27_U_SMXP_1_1, REGION27_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR27_U_SMXP_1_1, REGION27_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR28_U_SMXP_1_1, 0x93e5d0)
    FIELD(POR_MPU_M5_PRBAR28_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR28_U_SMXP_1_1, REGION28_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR28_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR28_U_SMXP_1_1, REGION28_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR28_U_SMXP_1_1, REGION28_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR28_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR28_U_SMXP_1_1, 0x93e5d8)
    FIELD(POR_MPU_M5_PRLAR28_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR28_U_SMXP_1_1, REGION28_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR28_U_SMXP_1_1, REGION28_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR29_U_SMXP_1_1, 0x93e5e0)
    FIELD(POR_MPU_M5_PRBAR29_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR29_U_SMXP_1_1, REGION29_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR29_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR29_U_SMXP_1_1, REGION29_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR29_U_SMXP_1_1, REGION29_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR29_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR29_U_SMXP_1_1, 0x93e5e8)
    FIELD(POR_MPU_M5_PRLAR29_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR29_U_SMXP_1_1, REGION29_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR29_U_SMXP_1_1, REGION29_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR30_U_SMXP_1_1, 0x93e5f0)
    FIELD(POR_MPU_M5_PRBAR30_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR30_U_SMXP_1_1, REGION30_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR30_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR30_U_SMXP_1_1, REGION30_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR30_U_SMXP_1_1, REGION30_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR30_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR30_U_SMXP_1_1, 0x93e5f8)
    FIELD(POR_MPU_M5_PRLAR30_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR30_U_SMXP_1_1, REGION30_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR30_U_SMXP_1_1, REGION30_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR31_U_SMXP_1_1, 0x93e600)
    FIELD(POR_MPU_M5_PRBAR31_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR31_U_SMXP_1_1, REGION31_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR31_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR31_U_SMXP_1_1, REGION31_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR31_U_SMXP_1_1, REGION31_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR31_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR31_U_SMXP_1_1, 0x93e608)
    FIELD(POR_MPU_M5_PRLAR31_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR31_U_SMXP_1_1, REGION31_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR31_U_SMXP_1_1, REGION31_EN, 0, 1)
REG32(POR_MPU_M6_CTL_U_SMXP_1_1, 0x93e800)
    FIELD(POR_MPU_M6_CTL_U_SMXP_1_1, M6_EN, 2, 1)
    FIELD(POR_MPU_M6_CTL_U_SMXP_1_1, M6_ACTION, 0, 2)
REG32(POR_MPU_M6_PRBAR0_U_SMXP_1_1, 0x93e810)
    FIELD(POR_MPU_M6_PRBAR0_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR0_U_SMXP_1_1, REGION0_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR0_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR0_U_SMXP_1_1, REGION0_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR0_U_SMXP_1_1, REGION0_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR0_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR0_U_SMXP_1_1, 0x93e818)
    FIELD(POR_MPU_M6_PRLAR0_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR0_U_SMXP_1_1, REGION0_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR0_U_SMXP_1_1, REGION0_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR1_U_SMXP_1_1, 0x93e820)
    FIELD(POR_MPU_M6_PRBAR1_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR1_U_SMXP_1_1, REGION1_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR1_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR1_U_SMXP_1_1, REGION1_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR1_U_SMXP_1_1, REGION1_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR1_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR1_U_SMXP_1_1, 0x93e828)
    FIELD(POR_MPU_M6_PRLAR1_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR1_U_SMXP_1_1, REGION1_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR1_U_SMXP_1_1, REGION1_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR2_U_SMXP_1_1, 0x93e830)
    FIELD(POR_MPU_M6_PRBAR2_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR2_U_SMXP_1_1, REGION2_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR2_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR2_U_SMXP_1_1, REGION2_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR2_U_SMXP_1_1, REGION2_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR2_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR2_U_SMXP_1_1, 0x93e838)
    FIELD(POR_MPU_M6_PRLAR2_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR2_U_SMXP_1_1, REGION2_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR2_U_SMXP_1_1, REGION2_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR3_U_SMXP_1_1, 0x93e840)
    FIELD(POR_MPU_M6_PRBAR3_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR3_U_SMXP_1_1, REGION3_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR3_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR3_U_SMXP_1_1, REGION3_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR3_U_SMXP_1_1, REGION3_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR3_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR3_U_SMXP_1_1, 0x93e848)
    FIELD(POR_MPU_M6_PRLAR3_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR3_U_SMXP_1_1, REGION3_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR3_U_SMXP_1_1, REGION3_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR4_U_SMXP_1_1, 0x93e850)
    FIELD(POR_MPU_M6_PRBAR4_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR4_U_SMXP_1_1, REGION4_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR4_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR4_U_SMXP_1_1, REGION4_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR4_U_SMXP_1_1, REGION4_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR4_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR4_U_SMXP_1_1, 0x93e858)
    FIELD(POR_MPU_M6_PRLAR4_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR4_U_SMXP_1_1, REGION4_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR4_U_SMXP_1_1, REGION4_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR5_U_SMXP_1_1, 0x93e860)
    FIELD(POR_MPU_M6_PRBAR5_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR5_U_SMXP_1_1, REGION5_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR5_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR5_U_SMXP_1_1, REGION5_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR5_U_SMXP_1_1, REGION5_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR5_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR5_U_SMXP_1_1, 0x93e868)
    FIELD(POR_MPU_M6_PRLAR5_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR5_U_SMXP_1_1, REGION5_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR5_U_SMXP_1_1, REGION5_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR6_U_SMXP_1_1, 0x93e870)
    FIELD(POR_MPU_M6_PRBAR6_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR6_U_SMXP_1_1, REGION6_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR6_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR6_U_SMXP_1_1, REGION6_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR6_U_SMXP_1_1, REGION6_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR6_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR6_U_SMXP_1_1, 0x93e878)
    FIELD(POR_MPU_M6_PRLAR6_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR6_U_SMXP_1_1, REGION6_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR6_U_SMXP_1_1, REGION6_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR7_U_SMXP_1_1, 0x93e880)
    FIELD(POR_MPU_M6_PRBAR7_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR7_U_SMXP_1_1, REGION7_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR7_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR7_U_SMXP_1_1, REGION7_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR7_U_SMXP_1_1, REGION7_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR7_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR7_U_SMXP_1_1, 0x93e888)
    FIELD(POR_MPU_M6_PRLAR7_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR7_U_SMXP_1_1, REGION7_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR7_U_SMXP_1_1, REGION7_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR8_U_SMXP_1_1, 0x93e890)
    FIELD(POR_MPU_M6_PRBAR8_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR8_U_SMXP_1_1, REGION8_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR8_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR8_U_SMXP_1_1, REGION8_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR8_U_SMXP_1_1, REGION8_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR8_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR8_U_SMXP_1_1, 0x93e898)
    FIELD(POR_MPU_M6_PRLAR8_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR8_U_SMXP_1_1, REGION8_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR8_U_SMXP_1_1, REGION8_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR9_U_SMXP_1_1, 0x93e8a0)
    FIELD(POR_MPU_M6_PRBAR9_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR9_U_SMXP_1_1, REGION9_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR9_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR9_U_SMXP_1_1, REGION9_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR9_U_SMXP_1_1, REGION9_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR9_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR9_U_SMXP_1_1, 0x93e8a8)
    FIELD(POR_MPU_M6_PRLAR9_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR9_U_SMXP_1_1, REGION9_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR9_U_SMXP_1_1, REGION9_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR10_U_SMXP_1_1, 0x93e8b0)
    FIELD(POR_MPU_M6_PRBAR10_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR10_U_SMXP_1_1, REGION10_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR10_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR10_U_SMXP_1_1, REGION10_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR10_U_SMXP_1_1, REGION10_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR10_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR10_U_SMXP_1_1, 0x93e8b8)
    FIELD(POR_MPU_M6_PRLAR10_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR10_U_SMXP_1_1, REGION10_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR10_U_SMXP_1_1, REGION10_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR11_U_SMXP_1_1, 0x93e8c0)
    FIELD(POR_MPU_M6_PRBAR11_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR11_U_SMXP_1_1, REGION11_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR11_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR11_U_SMXP_1_1, REGION11_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR11_U_SMXP_1_1, REGION11_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR11_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR11_U_SMXP_1_1, 0x93e8c8)
    FIELD(POR_MPU_M6_PRLAR11_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR11_U_SMXP_1_1, REGION11_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR11_U_SMXP_1_1, REGION11_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR12_U_SMXP_1_1, 0x93e8d0)
    FIELD(POR_MPU_M6_PRBAR12_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR12_U_SMXP_1_1, REGION12_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR12_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR12_U_SMXP_1_1, REGION12_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR12_U_SMXP_1_1, REGION12_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR12_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR12_U_SMXP_1_1, 0x93e8d8)
    FIELD(POR_MPU_M6_PRLAR12_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR12_U_SMXP_1_1, REGION12_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR12_U_SMXP_1_1, REGION12_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR13_U_SMXP_1_1, 0x93e8e0)
    FIELD(POR_MPU_M6_PRBAR13_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR13_U_SMXP_1_1, REGION13_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR13_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR13_U_SMXP_1_1, REGION13_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR13_U_SMXP_1_1, REGION13_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR13_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR13_U_SMXP_1_1, 0x93e8e8)
    FIELD(POR_MPU_M6_PRLAR13_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR13_U_SMXP_1_1, REGION13_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR13_U_SMXP_1_1, REGION13_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR14_U_SMXP_1_1, 0x93e8f0)
    FIELD(POR_MPU_M6_PRBAR14_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR14_U_SMXP_1_1, REGION14_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR14_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR14_U_SMXP_1_1, REGION14_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR14_U_SMXP_1_1, REGION14_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR14_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR14_U_SMXP_1_1, 0x93e8f8)
    FIELD(POR_MPU_M6_PRLAR14_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR14_U_SMXP_1_1, REGION14_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR14_U_SMXP_1_1, REGION14_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR15_U_SMXP_1_1, 0x93e900)
    FIELD(POR_MPU_M6_PRBAR15_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR15_U_SMXP_1_1, REGION15_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR15_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR15_U_SMXP_1_1, REGION15_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR15_U_SMXP_1_1, REGION15_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR15_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR15_U_SMXP_1_1, 0x93e908)
    FIELD(POR_MPU_M6_PRLAR15_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR15_U_SMXP_1_1, REGION15_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR15_U_SMXP_1_1, REGION15_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR16_U_SMXP_1_1, 0x93e910)
    FIELD(POR_MPU_M6_PRBAR16_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR16_U_SMXP_1_1, REGION16_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR16_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR16_U_SMXP_1_1, REGION16_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR16_U_SMXP_1_1, REGION16_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR16_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR16_U_SMXP_1_1, 0x93e918)
    FIELD(POR_MPU_M6_PRLAR16_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR16_U_SMXP_1_1, REGION16_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR16_U_SMXP_1_1, REGION16_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR17_U_SMXP_1_1, 0x93e920)
    FIELD(POR_MPU_M6_PRBAR17_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR17_U_SMXP_1_1, REGION17_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR17_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR17_U_SMXP_1_1, REGION17_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR17_U_SMXP_1_1, REGION17_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR17_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR17_U_SMXP_1_1, 0x93e928)
    FIELD(POR_MPU_M6_PRLAR17_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR17_U_SMXP_1_1, REGION17_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR17_U_SMXP_1_1, REGION17_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR18_U_SMXP_1_1, 0x93e930)
    FIELD(POR_MPU_M6_PRBAR18_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR18_U_SMXP_1_1, REGION18_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR18_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR18_U_SMXP_1_1, REGION18_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR18_U_SMXP_1_1, REGION18_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR18_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR18_U_SMXP_1_1, 0x93e938)
    FIELD(POR_MPU_M6_PRLAR18_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR18_U_SMXP_1_1, REGION18_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR18_U_SMXP_1_1, REGION18_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR19_U_SMXP_1_1, 0x93e940)
    FIELD(POR_MPU_M6_PRBAR19_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR19_U_SMXP_1_1, REGION19_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR19_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR19_U_SMXP_1_1, REGION19_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR19_U_SMXP_1_1, REGION19_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR19_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR19_U_SMXP_1_1, 0x93e948)
    FIELD(POR_MPU_M6_PRLAR19_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR19_U_SMXP_1_1, REGION19_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR19_U_SMXP_1_1, REGION19_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR20_U_SMXP_1_1, 0x93e950)
    FIELD(POR_MPU_M6_PRBAR20_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR20_U_SMXP_1_1, REGION20_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR20_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR20_U_SMXP_1_1, REGION20_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR20_U_SMXP_1_1, REGION20_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR20_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR20_U_SMXP_1_1, 0x93e958)
    FIELD(POR_MPU_M6_PRLAR20_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR20_U_SMXP_1_1, REGION20_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR20_U_SMXP_1_1, REGION20_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR21_U_SMXP_1_1, 0x93e960)
    FIELD(POR_MPU_M6_PRBAR21_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR21_U_SMXP_1_1, REGION21_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR21_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR21_U_SMXP_1_1, REGION21_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR21_U_SMXP_1_1, REGION21_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR21_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR21_U_SMXP_1_1, 0x93e968)
    FIELD(POR_MPU_M6_PRLAR21_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR21_U_SMXP_1_1, REGION21_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR21_U_SMXP_1_1, REGION21_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR22_U_SMXP_1_1, 0x93e970)
    FIELD(POR_MPU_M6_PRBAR22_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR22_U_SMXP_1_1, REGION22_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR22_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR22_U_SMXP_1_1, REGION22_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR22_U_SMXP_1_1, REGION22_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR22_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR22_U_SMXP_1_1, 0x93e978)
    FIELD(POR_MPU_M6_PRLAR22_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR22_U_SMXP_1_1, REGION22_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR22_U_SMXP_1_1, REGION22_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR23_U_SMXP_1_1, 0x93e980)
    FIELD(POR_MPU_M6_PRBAR23_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR23_U_SMXP_1_1, REGION23_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR23_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR23_U_SMXP_1_1, REGION23_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR23_U_SMXP_1_1, REGION23_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR23_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR23_U_SMXP_1_1, 0x93e988)
    FIELD(POR_MPU_M6_PRLAR23_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR23_U_SMXP_1_1, REGION23_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR23_U_SMXP_1_1, REGION23_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR24_U_SMXP_1_1, 0x93e990)
    FIELD(POR_MPU_M6_PRBAR24_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR24_U_SMXP_1_1, REGION24_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR24_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR24_U_SMXP_1_1, REGION24_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR24_U_SMXP_1_1, REGION24_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR24_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR24_U_SMXP_1_1, 0x93e998)
    FIELD(POR_MPU_M6_PRLAR24_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR24_U_SMXP_1_1, REGION24_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR24_U_SMXP_1_1, REGION24_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR25_U_SMXP_1_1, 0x93e9a0)
    FIELD(POR_MPU_M6_PRBAR25_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR25_U_SMXP_1_1, REGION25_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR25_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR25_U_SMXP_1_1, REGION25_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR25_U_SMXP_1_1, REGION25_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR25_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR25_U_SMXP_1_1, 0x93e9a8)
    FIELD(POR_MPU_M6_PRLAR25_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR25_U_SMXP_1_1, REGION25_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR25_U_SMXP_1_1, REGION25_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR26_U_SMXP_1_1, 0x93e9b0)
    FIELD(POR_MPU_M6_PRBAR26_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR26_U_SMXP_1_1, REGION26_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR26_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR26_U_SMXP_1_1, REGION26_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR26_U_SMXP_1_1, REGION26_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR26_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR26_U_SMXP_1_1, 0x93e9b8)
    FIELD(POR_MPU_M6_PRLAR26_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR26_U_SMXP_1_1, REGION26_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR26_U_SMXP_1_1, REGION26_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR27_U_SMXP_1_1, 0x93e9c0)
    FIELD(POR_MPU_M6_PRBAR27_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR27_U_SMXP_1_1, REGION27_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR27_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR27_U_SMXP_1_1, REGION27_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR27_U_SMXP_1_1, REGION27_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR27_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR27_U_SMXP_1_1, 0x93e9c8)
    FIELD(POR_MPU_M6_PRLAR27_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR27_U_SMXP_1_1, REGION27_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR27_U_SMXP_1_1, REGION27_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR28_U_SMXP_1_1, 0x93e9d0)
    FIELD(POR_MPU_M6_PRBAR28_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR28_U_SMXP_1_1, REGION28_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR28_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR28_U_SMXP_1_1, REGION28_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR28_U_SMXP_1_1, REGION28_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR28_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR28_U_SMXP_1_1, 0x93e9d8)
    FIELD(POR_MPU_M6_PRLAR28_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR28_U_SMXP_1_1, REGION28_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR28_U_SMXP_1_1, REGION28_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR29_U_SMXP_1_1, 0x93e9e0)
    FIELD(POR_MPU_M6_PRBAR29_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR29_U_SMXP_1_1, REGION29_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR29_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR29_U_SMXP_1_1, REGION29_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR29_U_SMXP_1_1, REGION29_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR29_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR29_U_SMXP_1_1, 0x93e9e8)
    FIELD(POR_MPU_M6_PRLAR29_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR29_U_SMXP_1_1, REGION29_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR29_U_SMXP_1_1, REGION29_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR30_U_SMXP_1_1, 0x93e9f0)
    FIELD(POR_MPU_M6_PRBAR30_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR30_U_SMXP_1_1, REGION30_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR30_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR30_U_SMXP_1_1, REGION30_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR30_U_SMXP_1_1, REGION30_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR30_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR30_U_SMXP_1_1, 0x93e9f8)
    FIELD(POR_MPU_M6_PRLAR30_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR30_U_SMXP_1_1, REGION30_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR30_U_SMXP_1_1, REGION30_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR31_U_SMXP_1_1, 0x93ea00)
    FIELD(POR_MPU_M6_PRBAR31_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR31_U_SMXP_1_1, REGION31_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR31_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR31_U_SMXP_1_1, REGION31_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR31_U_SMXP_1_1, REGION31_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR31_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR31_U_SMXP_1_1, 0x93ea08)
    FIELD(POR_MPU_M6_PRLAR31_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR31_U_SMXP_1_1, REGION31_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR31_U_SMXP_1_1, REGION31_EN, 0, 1)
REG32(POR_MPU_M7_CTL_U_SMXP_1_1, 0x93ec00)
    FIELD(POR_MPU_M7_CTL_U_SMXP_1_1, M7_EN, 2, 1)
    FIELD(POR_MPU_M7_CTL_U_SMXP_1_1, M7_ACTION, 0, 2)
REG32(POR_MPU_M7_PRBAR0_U_SMXP_1_1, 0x93ec10)
    FIELD(POR_MPU_M7_PRBAR0_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR0_U_SMXP_1_1, REGION0_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR0_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR0_U_SMXP_1_1, REGION0_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR0_U_SMXP_1_1, REGION0_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR0_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR0_U_SMXP_1_1, 0x93ec18)
    FIELD(POR_MPU_M7_PRLAR0_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR0_U_SMXP_1_1, REGION0_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR0_U_SMXP_1_1, REGION0_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR1_U_SMXP_1_1, 0x93ec20)
    FIELD(POR_MPU_M7_PRBAR1_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR1_U_SMXP_1_1, REGION1_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR1_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR1_U_SMXP_1_1, REGION1_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR1_U_SMXP_1_1, REGION1_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR1_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR1_U_SMXP_1_1, 0x93ec28)
    FIELD(POR_MPU_M7_PRLAR1_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR1_U_SMXP_1_1, REGION1_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR1_U_SMXP_1_1, REGION1_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR2_U_SMXP_1_1, 0x93ec30)
    FIELD(POR_MPU_M7_PRBAR2_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR2_U_SMXP_1_1, REGION2_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR2_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR2_U_SMXP_1_1, REGION2_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR2_U_SMXP_1_1, REGION2_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR2_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR2_U_SMXP_1_1, 0x93ec38)
    FIELD(POR_MPU_M7_PRLAR2_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR2_U_SMXP_1_1, REGION2_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR2_U_SMXP_1_1, REGION2_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR3_U_SMXP_1_1, 0x93ec40)
    FIELD(POR_MPU_M7_PRBAR3_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR3_U_SMXP_1_1, REGION3_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR3_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR3_U_SMXP_1_1, REGION3_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR3_U_SMXP_1_1, REGION3_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR3_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR3_U_SMXP_1_1, 0x93ec48)
    FIELD(POR_MPU_M7_PRLAR3_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR3_U_SMXP_1_1, REGION3_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR3_U_SMXP_1_1, REGION3_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR4_U_SMXP_1_1, 0x93ec50)
    FIELD(POR_MPU_M7_PRBAR4_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR4_U_SMXP_1_1, REGION4_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR4_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR4_U_SMXP_1_1, REGION4_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR4_U_SMXP_1_1, REGION4_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR4_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR4_U_SMXP_1_1, 0x93ec58)
    FIELD(POR_MPU_M7_PRLAR4_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR4_U_SMXP_1_1, REGION4_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR4_U_SMXP_1_1, REGION4_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR5_U_SMXP_1_1, 0x93ec60)
    FIELD(POR_MPU_M7_PRBAR5_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR5_U_SMXP_1_1, REGION5_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR5_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR5_U_SMXP_1_1, REGION5_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR5_U_SMXP_1_1, REGION5_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR5_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR5_U_SMXP_1_1, 0x93ec68)
    FIELD(POR_MPU_M7_PRLAR5_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR5_U_SMXP_1_1, REGION5_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR5_U_SMXP_1_1, REGION5_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR6_U_SMXP_1_1, 0x93ec70)
    FIELD(POR_MPU_M7_PRBAR6_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR6_U_SMXP_1_1, REGION6_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR6_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR6_U_SMXP_1_1, REGION6_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR6_U_SMXP_1_1, REGION6_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR6_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR6_U_SMXP_1_1, 0x93ec78)
    FIELD(POR_MPU_M7_PRLAR6_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR6_U_SMXP_1_1, REGION6_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR6_U_SMXP_1_1, REGION6_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR7_U_SMXP_1_1, 0x93ec80)
    FIELD(POR_MPU_M7_PRBAR7_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR7_U_SMXP_1_1, REGION7_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR7_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR7_U_SMXP_1_1, REGION7_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR7_U_SMXP_1_1, REGION7_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR7_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR7_U_SMXP_1_1, 0x93ec88)
    FIELD(POR_MPU_M7_PRLAR7_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR7_U_SMXP_1_1, REGION7_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR7_U_SMXP_1_1, REGION7_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR8_U_SMXP_1_1, 0x93ec90)
    FIELD(POR_MPU_M7_PRBAR8_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR8_U_SMXP_1_1, REGION8_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR8_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR8_U_SMXP_1_1, REGION8_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR8_U_SMXP_1_1, REGION8_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR8_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR8_U_SMXP_1_1, 0x93ec98)
    FIELD(POR_MPU_M7_PRLAR8_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR8_U_SMXP_1_1, REGION8_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR8_U_SMXP_1_1, REGION8_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR9_U_SMXP_1_1, 0x93eca0)
    FIELD(POR_MPU_M7_PRBAR9_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR9_U_SMXP_1_1, REGION9_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR9_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR9_U_SMXP_1_1, REGION9_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR9_U_SMXP_1_1, REGION9_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR9_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR9_U_SMXP_1_1, 0x93eca8)
    FIELD(POR_MPU_M7_PRLAR9_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR9_U_SMXP_1_1, REGION9_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR9_U_SMXP_1_1, REGION9_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR10_U_SMXP_1_1, 0x93ecb0)
    FIELD(POR_MPU_M7_PRBAR10_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR10_U_SMXP_1_1, REGION10_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR10_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR10_U_SMXP_1_1, REGION10_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR10_U_SMXP_1_1, REGION10_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR10_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR10_U_SMXP_1_1, 0x93ecb8)
    FIELD(POR_MPU_M7_PRLAR10_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR10_U_SMXP_1_1, REGION10_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR10_U_SMXP_1_1, REGION10_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR11_U_SMXP_1_1, 0x93ecc0)
    FIELD(POR_MPU_M7_PRBAR11_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR11_U_SMXP_1_1, REGION11_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR11_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR11_U_SMXP_1_1, REGION11_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR11_U_SMXP_1_1, REGION11_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR11_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR11_U_SMXP_1_1, 0x93ecc8)
    FIELD(POR_MPU_M7_PRLAR11_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR11_U_SMXP_1_1, REGION11_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR11_U_SMXP_1_1, REGION11_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR12_U_SMXP_1_1, 0x93ecd0)
    FIELD(POR_MPU_M7_PRBAR12_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR12_U_SMXP_1_1, REGION12_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR12_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR12_U_SMXP_1_1, REGION12_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR12_U_SMXP_1_1, REGION12_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR12_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR12_U_SMXP_1_1, 0x93ecd8)
    FIELD(POR_MPU_M7_PRLAR12_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR12_U_SMXP_1_1, REGION12_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR12_U_SMXP_1_1, REGION12_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR13_U_SMXP_1_1, 0x93ece0)
    FIELD(POR_MPU_M7_PRBAR13_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR13_U_SMXP_1_1, REGION13_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR13_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR13_U_SMXP_1_1, REGION13_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR13_U_SMXP_1_1, REGION13_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR13_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR13_U_SMXP_1_1, 0x93ece8)
    FIELD(POR_MPU_M7_PRLAR13_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR13_U_SMXP_1_1, REGION13_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR13_U_SMXP_1_1, REGION13_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR14_U_SMXP_1_1, 0x93ecf0)
    FIELD(POR_MPU_M7_PRBAR14_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR14_U_SMXP_1_1, REGION14_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR14_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR14_U_SMXP_1_1, REGION14_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR14_U_SMXP_1_1, REGION14_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR14_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR14_U_SMXP_1_1, 0x93ecf8)
    FIELD(POR_MPU_M7_PRLAR14_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR14_U_SMXP_1_1, REGION14_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR14_U_SMXP_1_1, REGION14_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR15_U_SMXP_1_1, 0x93ed00)
    FIELD(POR_MPU_M7_PRBAR15_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR15_U_SMXP_1_1, REGION15_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR15_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR15_U_SMXP_1_1, REGION15_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR15_U_SMXP_1_1, REGION15_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR15_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR15_U_SMXP_1_1, 0x93ed08)
    FIELD(POR_MPU_M7_PRLAR15_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR15_U_SMXP_1_1, REGION15_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR15_U_SMXP_1_1, REGION15_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR16_U_SMXP_1_1, 0x93ed10)
    FIELD(POR_MPU_M7_PRBAR16_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR16_U_SMXP_1_1, REGION16_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR16_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR16_U_SMXP_1_1, REGION16_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR16_U_SMXP_1_1, REGION16_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR16_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR16_U_SMXP_1_1, 0x93ed18)
    FIELD(POR_MPU_M7_PRLAR16_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR16_U_SMXP_1_1, REGION16_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR16_U_SMXP_1_1, REGION16_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR17_U_SMXP_1_1, 0x93ed20)
    FIELD(POR_MPU_M7_PRBAR17_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR17_U_SMXP_1_1, REGION17_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR17_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR17_U_SMXP_1_1, REGION17_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR17_U_SMXP_1_1, REGION17_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR17_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR17_U_SMXP_1_1, 0x93ed28)
    FIELD(POR_MPU_M7_PRLAR17_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR17_U_SMXP_1_1, REGION17_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR17_U_SMXP_1_1, REGION17_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR18_U_SMXP_1_1, 0x93ed30)
    FIELD(POR_MPU_M7_PRBAR18_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR18_U_SMXP_1_1, REGION18_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR18_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR18_U_SMXP_1_1, REGION18_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR18_U_SMXP_1_1, REGION18_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR18_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR18_U_SMXP_1_1, 0x93ed38)
    FIELD(POR_MPU_M7_PRLAR18_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR18_U_SMXP_1_1, REGION18_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR18_U_SMXP_1_1, REGION18_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR19_U_SMXP_1_1, 0x93ed40)
    FIELD(POR_MPU_M7_PRBAR19_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR19_U_SMXP_1_1, REGION19_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR19_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR19_U_SMXP_1_1, REGION19_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR19_U_SMXP_1_1, REGION19_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR19_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR19_U_SMXP_1_1, 0x93ed48)
    FIELD(POR_MPU_M7_PRLAR19_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR19_U_SMXP_1_1, REGION19_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR19_U_SMXP_1_1, REGION19_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR20_U_SMXP_1_1, 0x93ed50)
    FIELD(POR_MPU_M7_PRBAR20_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR20_U_SMXP_1_1, REGION20_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR20_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR20_U_SMXP_1_1, REGION20_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR20_U_SMXP_1_1, REGION20_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR20_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR20_U_SMXP_1_1, 0x93ed58)
    FIELD(POR_MPU_M7_PRLAR20_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR20_U_SMXP_1_1, REGION20_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR20_U_SMXP_1_1, REGION20_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR21_U_SMXP_1_1, 0x93ed60)
    FIELD(POR_MPU_M7_PRBAR21_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR21_U_SMXP_1_1, REGION21_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR21_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR21_U_SMXP_1_1, REGION21_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR21_U_SMXP_1_1, REGION21_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR21_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR21_U_SMXP_1_1, 0x93ed68)
    FIELD(POR_MPU_M7_PRLAR21_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR21_U_SMXP_1_1, REGION21_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR21_U_SMXP_1_1, REGION21_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR22_U_SMXP_1_1, 0x93ed70)
    FIELD(POR_MPU_M7_PRBAR22_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR22_U_SMXP_1_1, REGION22_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR22_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR22_U_SMXP_1_1, REGION22_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR22_U_SMXP_1_1, REGION22_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR22_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR22_U_SMXP_1_1, 0x93ed78)
    FIELD(POR_MPU_M7_PRLAR22_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR22_U_SMXP_1_1, REGION22_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR22_U_SMXP_1_1, REGION22_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR23_U_SMXP_1_1, 0x93ed80)
    FIELD(POR_MPU_M7_PRBAR23_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR23_U_SMXP_1_1, REGION23_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR23_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR23_U_SMXP_1_1, REGION23_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR23_U_SMXP_1_1, REGION23_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR23_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR23_U_SMXP_1_1, 0x93ed88)
    FIELD(POR_MPU_M7_PRLAR23_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR23_U_SMXP_1_1, REGION23_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR23_U_SMXP_1_1, REGION23_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR24_U_SMXP_1_1, 0x93ed90)
    FIELD(POR_MPU_M7_PRBAR24_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR24_U_SMXP_1_1, REGION24_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR24_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR24_U_SMXP_1_1, REGION24_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR24_U_SMXP_1_1, REGION24_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR24_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR24_U_SMXP_1_1, 0x93ed98)
    FIELD(POR_MPU_M7_PRLAR24_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR24_U_SMXP_1_1, REGION24_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR24_U_SMXP_1_1, REGION24_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR25_U_SMXP_1_1, 0x93eda0)
    FIELD(POR_MPU_M7_PRBAR25_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR25_U_SMXP_1_1, REGION25_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR25_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR25_U_SMXP_1_1, REGION25_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR25_U_SMXP_1_1, REGION25_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR25_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR25_U_SMXP_1_1, 0x93eda8)
    FIELD(POR_MPU_M7_PRLAR25_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR25_U_SMXP_1_1, REGION25_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR25_U_SMXP_1_1, REGION25_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR26_U_SMXP_1_1, 0x93edb0)
    FIELD(POR_MPU_M7_PRBAR26_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR26_U_SMXP_1_1, REGION26_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR26_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR26_U_SMXP_1_1, REGION26_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR26_U_SMXP_1_1, REGION26_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR26_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR26_U_SMXP_1_1, 0x93edb8)
    FIELD(POR_MPU_M7_PRLAR26_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR26_U_SMXP_1_1, REGION26_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR26_U_SMXP_1_1, REGION26_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR27_U_SMXP_1_1, 0x93edc0)
    FIELD(POR_MPU_M7_PRBAR27_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR27_U_SMXP_1_1, REGION27_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR27_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR27_U_SMXP_1_1, REGION27_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR27_U_SMXP_1_1, REGION27_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR27_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR27_U_SMXP_1_1, 0x93edc8)
    FIELD(POR_MPU_M7_PRLAR27_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR27_U_SMXP_1_1, REGION27_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR27_U_SMXP_1_1, REGION27_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR28_U_SMXP_1_1, 0x93edd0)
    FIELD(POR_MPU_M7_PRBAR28_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR28_U_SMXP_1_1, REGION28_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR28_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR28_U_SMXP_1_1, REGION28_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR28_U_SMXP_1_1, REGION28_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR28_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR28_U_SMXP_1_1, 0x93edd8)
    FIELD(POR_MPU_M7_PRLAR28_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR28_U_SMXP_1_1, REGION28_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR28_U_SMXP_1_1, REGION28_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR29_U_SMXP_1_1, 0x93ede0)
    FIELD(POR_MPU_M7_PRBAR29_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR29_U_SMXP_1_1, REGION29_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR29_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR29_U_SMXP_1_1, REGION29_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR29_U_SMXP_1_1, REGION29_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR29_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR29_U_SMXP_1_1, 0x93ede8)
    FIELD(POR_MPU_M7_PRLAR29_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR29_U_SMXP_1_1, REGION29_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR29_U_SMXP_1_1, REGION29_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR30_U_SMXP_1_1, 0x93edf0)
    FIELD(POR_MPU_M7_PRBAR30_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR30_U_SMXP_1_1, REGION30_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR30_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR30_U_SMXP_1_1, REGION30_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR30_U_SMXP_1_1, REGION30_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR30_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR30_U_SMXP_1_1, 0x93edf8)
    FIELD(POR_MPU_M7_PRLAR30_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR30_U_SMXP_1_1, REGION30_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR30_U_SMXP_1_1, REGION30_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR31_U_SMXP_1_1, 0x93ee00)
    FIELD(POR_MPU_M7_PRBAR31_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR31_U_SMXP_1_1, REGION31_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR31_U_SMXP_1_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR31_U_SMXP_1_1, REGION31_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR31_U_SMXP_1_1, REGION31_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR31_U_SMXP_1_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR31_U_SMXP_1_1, 0x93ee08)
    FIELD(POR_MPU_M7_PRLAR31_U_SMXP_1_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR31_U_SMXP_1_1, REGION31_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR31_U_SMXP_1_1, REGION31_EN, 0, 1)
REG32(POR_RNSAM_NODE_INFO_U_RNFBESAM_NID76, 0x968000)
    FIELD(POR_RNSAM_NODE_INFO_U_RNFBESAM_NID76, RESERVED_48, 48, 16)
    FIELD(POR_RNSAM_NODE_INFO_U_RNFBESAM_NID76, LOGICAL_ID, 32, 16)
    FIELD(POR_RNSAM_NODE_INFO_U_RNFBESAM_NID76, NODE_ID, 16, 16)
    FIELD(POR_RNSAM_NODE_INFO_U_RNFBESAM_NID76, NODE_TYPE, 0, 16)
REG32(POR_RNSAM_CHILD_INFO_U_RNFBESAM_NID76, 0x968080)
    FIELD(POR_RNSAM_CHILD_INFO_U_RNFBESAM_NID76, RESERVED_32, 32, 32)
    FIELD(POR_RNSAM_CHILD_INFO_U_RNFBESAM_NID76, CHILD_PTR_OFFSET, 16, 16)
    FIELD(POR_RNSAM_CHILD_INFO_U_RNFBESAM_NID76, CHILD_COUNT, 0, 16)
REG32(POR_RNSAM_UNIT_INFO_U_RNFBESAM_NID76, 0x968900)
    FIELD(POR_RNSAM_UNIT_INFO_U_RNFBESAM_NID76, RESERVED_37, 37, 27)
    FIELD(POR_RNSAM_UNIT_INFO_U_RNFBESAM_NID76, NUM_NON_HASH_GROUP, 32, 5)
    FIELD(POR_RNSAM_UNIT_INFO_U_RNFBESAM_NID76, RESERVED_20, 20, 12)
    FIELD(POR_RNSAM_UNIT_INFO_U_RNFBESAM_NID76, NUM_SYS_CACHE_GROUP, 16, 4)
    FIELD(POR_RNSAM_UNIT_INFO_U_RNFBESAM_NID76, NUM_HNF, 0, 8)
REG32(POR_RNSAM_SECURE_REGISTER_GROUPS_OVERRIDE_U_RNFBESAM_NID76, 0x968980)
    FIELD(POR_RNSAM_SECURE_REGISTER_GROUPS_OVERRIDE_U_RNFBESAM_NID76, MEM_RANGE, 0, 1)
REG32(RNSAM_STATUS_U_RNFBESAM_NID76, 0x968c00)
    FIELD(RNSAM_STATUS_U_RNFBESAM_NID76, NSTALL_REQ, 1, 1)
    FIELD(RNSAM_STATUS_U_RNFBESAM_NID76, USE_DEFAULT_NODE, 0, 1)
REG32(NON_HASH_MEM_REGION_REG0_U_RNFBESAM_NID76, 0x968c08)
    FIELD(NON_HASH_MEM_REGION_REG0_U_RNFBESAM_NID76, RESERVED_63, 63, 1)
    FIELD(NON_HASH_MEM_REGION_REG0_U_RNFBESAM_NID76, REGION1_BASE_ADDR, 41, 22)
    FIELD(NON_HASH_MEM_REGION_REG0_U_RNFBESAM_NID76, REGION1_SIZE, 36, 5)
    FIELD(NON_HASH_MEM_REGION_REG0_U_RNFBESAM_NID76, REGION1_TARGET_TYPE, 34, 2)
    FIELD(NON_HASH_MEM_REGION_REG0_U_RNFBESAM_NID76, RESERVED_33, 33, 1)
    FIELD(NON_HASH_MEM_REGION_REG0_U_RNFBESAM_NID76, REGION1_VALID, 32, 1)
    FIELD(NON_HASH_MEM_REGION_REG0_U_RNFBESAM_NID76, RESERVED_31, 31, 1)
    FIELD(NON_HASH_MEM_REGION_REG0_U_RNFBESAM_NID76, REGION0_BASE_ADDR, 9, 22)
    FIELD(NON_HASH_MEM_REGION_REG0_U_RNFBESAM_NID76, REGION0_SIZE, 4, 5)
    FIELD(NON_HASH_MEM_REGION_REG0_U_RNFBESAM_NID76, REGION0_TARGET_TYPE, 2, 2)
    FIELD(NON_HASH_MEM_REGION_REG0_U_RNFBESAM_NID76, REGION0_VALID, 0, 1)
REG32(NON_HASH_MEM_REGION_REG1_U_RNFBESAM_NID76, 0x968c10)
    FIELD(NON_HASH_MEM_REGION_REG1_U_RNFBESAM_NID76, RESERVED_63, 63, 1)
    FIELD(NON_HASH_MEM_REGION_REG1_U_RNFBESAM_NID76, REGION3_BASE_ADDR, 41, 22)
    FIELD(NON_HASH_MEM_REGION_REG1_U_RNFBESAM_NID76, REGION3_SIZE, 36, 5)
    FIELD(NON_HASH_MEM_REGION_REG1_U_RNFBESAM_NID76, REGION3_TARGET_TYPE, 34, 2)
    FIELD(NON_HASH_MEM_REGION_REG1_U_RNFBESAM_NID76, RESERVED_33, 33, 1)
    FIELD(NON_HASH_MEM_REGION_REG1_U_RNFBESAM_NID76, REGION3_VALID, 32, 1)
    FIELD(NON_HASH_MEM_REGION_REG1_U_RNFBESAM_NID76, RESERVED_31, 31, 1)
    FIELD(NON_HASH_MEM_REGION_REG1_U_RNFBESAM_NID76, REGION2_BASE_ADDR, 9, 22)
    FIELD(NON_HASH_MEM_REGION_REG1_U_RNFBESAM_NID76, REGION2_SIZE, 4, 5)
    FIELD(NON_HASH_MEM_REGION_REG1_U_RNFBESAM_NID76, REGION2_TARGET_TYPE, 2, 2)
    FIELD(NON_HASH_MEM_REGION_REG1_U_RNFBESAM_NID76, REGION2_VALID, 0, 1)
REG32(NON_HASH_MEM_REGION_REG2_U_RNFBESAM_NID76, 0x968c18)
    FIELD(NON_HASH_MEM_REGION_REG2_U_RNFBESAM_NID76, RESERVED_63, 63, 1)
    FIELD(NON_HASH_MEM_REGION_REG2_U_RNFBESAM_NID76, REGION5_BASE_ADDR, 41, 22)
    FIELD(NON_HASH_MEM_REGION_REG2_U_RNFBESAM_NID76, REGION5_SIZE, 36, 5)
    FIELD(NON_HASH_MEM_REGION_REG2_U_RNFBESAM_NID76, REGION5_TARGET_TYPE, 34, 2)
    FIELD(NON_HASH_MEM_REGION_REG2_U_RNFBESAM_NID76, RESERVED_33, 33, 1)
    FIELD(NON_HASH_MEM_REGION_REG2_U_RNFBESAM_NID76, REGION5_VALID, 32, 1)
    FIELD(NON_HASH_MEM_REGION_REG2_U_RNFBESAM_NID76, RESERVED_31, 31, 1)
    FIELD(NON_HASH_MEM_REGION_REG2_U_RNFBESAM_NID76, REGION4_BASE_ADDR, 9, 22)
    FIELD(NON_HASH_MEM_REGION_REG2_U_RNFBESAM_NID76, REGION4_SIZE, 4, 5)
    FIELD(NON_HASH_MEM_REGION_REG2_U_RNFBESAM_NID76, REGION4_TARGET_TYPE, 2, 2)
    FIELD(NON_HASH_MEM_REGION_REG2_U_RNFBESAM_NID76, REGION4_VALID, 0, 1)
REG32(NON_HASH_MEM_REGION_REG3_U_RNFBESAM_NID76, 0x968c20)
    FIELD(NON_HASH_MEM_REGION_REG3_U_RNFBESAM_NID76, RESERVED_63, 63, 1)
    FIELD(NON_HASH_MEM_REGION_REG3_U_RNFBESAM_NID76, REGION7_BASE_ADDR, 41, 22)
    FIELD(NON_HASH_MEM_REGION_REG3_U_RNFBESAM_NID76, REGION7_SIZE, 36, 5)
    FIELD(NON_HASH_MEM_REGION_REG3_U_RNFBESAM_NID76, REGION7_TARGET_TYPE, 34, 2)
    FIELD(NON_HASH_MEM_REGION_REG3_U_RNFBESAM_NID76, RESERVED_33, 33, 1)
    FIELD(NON_HASH_MEM_REGION_REG3_U_RNFBESAM_NID76, REGION7_VALID, 32, 1)
    FIELD(NON_HASH_MEM_REGION_REG3_U_RNFBESAM_NID76, RESERVED_31, 31, 1)
    FIELD(NON_HASH_MEM_REGION_REG3_U_RNFBESAM_NID76, REGION6_BASE_ADDR, 9, 22)
    FIELD(NON_HASH_MEM_REGION_REG3_U_RNFBESAM_NID76, REGION6_SIZE, 4, 5)
    FIELD(NON_HASH_MEM_REGION_REG3_U_RNFBESAM_NID76, REGION6_TARGET_TYPE, 2, 2)
    FIELD(NON_HASH_MEM_REGION_REG3_U_RNFBESAM_NID76, REGION6_VALID, 0, 1)
REG32(NON_HASH_TGT_NODEID0_U_RNFBESAM_NID76, 0x968c30)
    FIELD(NON_HASH_TGT_NODEID0_U_RNFBESAM_NID76, RESERVED_47, 47, 17)
    FIELD(NON_HASH_TGT_NODEID0_U_RNFBESAM_NID76, NODEID_3, 36, 11)
    FIELD(NON_HASH_TGT_NODEID0_U_RNFBESAM_NID76, RESERVED_35, 35, 1)
    FIELD(NON_HASH_TGT_NODEID0_U_RNFBESAM_NID76, NODEID_2, 24, 11)
    FIELD(NON_HASH_TGT_NODEID0_U_RNFBESAM_NID76, RESERVED_23, 23, 1)
    FIELD(NON_HASH_TGT_NODEID0_U_RNFBESAM_NID76, NODEID_1, 12, 11)
    FIELD(NON_HASH_TGT_NODEID0_U_RNFBESAM_NID76, RESERVED_11, 11, 1)
    FIELD(NON_HASH_TGT_NODEID0_U_RNFBESAM_NID76, NODEID_0, 0, 11)
REG32(NON_HASH_TGT_NODEID1_U_RNFBESAM_NID76, 0x968c38)
    FIELD(NON_HASH_TGT_NODEID1_U_RNFBESAM_NID76, RESERVED_47, 47, 17)
    FIELD(NON_HASH_TGT_NODEID1_U_RNFBESAM_NID76, NODEID_7, 36, 11)
    FIELD(NON_HASH_TGT_NODEID1_U_RNFBESAM_NID76, RESERVED_35, 35, 1)
    FIELD(NON_HASH_TGT_NODEID1_U_RNFBESAM_NID76, NODEID_6, 24, 11)
    FIELD(NON_HASH_TGT_NODEID1_U_RNFBESAM_NID76, RESERVED_23, 23, 1)
    FIELD(NON_HASH_TGT_NODEID1_U_RNFBESAM_NID76, NODEID_5, 12, 11)
    FIELD(NON_HASH_TGT_NODEID1_U_RNFBESAM_NID76, RESERVED_11, 11, 1)
    FIELD(NON_HASH_TGT_NODEID1_U_RNFBESAM_NID76, NODEID_4, 0, 11)
REG32(NON_HASH_TGT_NODEID2_U_RNFBESAM_NID76, 0x968c40)
    FIELD(NON_HASH_TGT_NODEID2_U_RNFBESAM_NID76, RESERVED_23, 23, 41)
    FIELD(NON_HASH_TGT_NODEID2_U_RNFBESAM_NID76, NODEID_9, 12, 11)
    FIELD(NON_HASH_TGT_NODEID2_U_RNFBESAM_NID76, RESERVED_11, 11, 1)
    FIELD(NON_HASH_TGT_NODEID2_U_RNFBESAM_NID76, NODEID_8, 0, 11)
REG32(SYS_CACHE_GRP_REGION0_U_RNFBESAM_NID76, 0x968c48)
    FIELD(SYS_CACHE_GRP_REGION0_U_RNFBESAM_NID76, RESERVED_63, 63, 1)
    FIELD(SYS_CACHE_GRP_REGION0_U_RNFBESAM_NID76, REGION1_BASE_ADDR, 41, 22)
    FIELD(SYS_CACHE_GRP_REGION0_U_RNFBESAM_NID76, REGION1_SIZE, 36, 5)
    FIELD(SYS_CACHE_GRP_REGION0_U_RNFBESAM_NID76, REGION1_TARGET_TYPE, 34, 2)
    FIELD(SYS_CACHE_GRP_REGION0_U_RNFBESAM_NID76, REGION1_NONHASH_REG_EN, 33, 1)
    FIELD(SYS_CACHE_GRP_REGION0_U_RNFBESAM_NID76, REGION1_VALID, 32, 1)
    FIELD(SYS_CACHE_GRP_REGION0_U_RNFBESAM_NID76, RESERVED_31, 31, 1)
    FIELD(SYS_CACHE_GRP_REGION0_U_RNFBESAM_NID76, REGION0_BASE_ADDR, 9, 22)
    FIELD(SYS_CACHE_GRP_REGION0_U_RNFBESAM_NID76, REGION0_SIZE, 4, 5)
    FIELD(SYS_CACHE_GRP_REGION0_U_RNFBESAM_NID76, REGION0_TARGET_TYPE, 2, 2)
    FIELD(SYS_CACHE_GRP_REGION0_U_RNFBESAM_NID76, REGION0_VALID, 0, 1)
REG32(SYS_CACHE_GRP_REGION1_U_RNFBESAM_NID76, 0x968c50)
    FIELD(SYS_CACHE_GRP_REGION1_U_RNFBESAM_NID76, RESERVED_63, 63, 1)
    FIELD(SYS_CACHE_GRP_REGION1_U_RNFBESAM_NID76, REGION3_BASE_ADDR, 41, 22)
    FIELD(SYS_CACHE_GRP_REGION1_U_RNFBESAM_NID76, REGION3_SIZE, 36, 5)
    FIELD(SYS_CACHE_GRP_REGION1_U_RNFBESAM_NID76, REGION3_TARGET_TYPE, 34, 2)
    FIELD(SYS_CACHE_GRP_REGION1_U_RNFBESAM_NID76, REGION3_NONHASH_REG_EN, 33, 1)
    FIELD(SYS_CACHE_GRP_REGION1_U_RNFBESAM_NID76, REGION3_VALID, 32, 1)
    FIELD(SYS_CACHE_GRP_REGION1_U_RNFBESAM_NID76, RESERVED_31, 31, 1)
    FIELD(SYS_CACHE_GRP_REGION1_U_RNFBESAM_NID76, REGION2_BASE_ADDR, 9, 22)
    FIELD(SYS_CACHE_GRP_REGION1_U_RNFBESAM_NID76, REGION2_SIZE, 4, 5)
    FIELD(SYS_CACHE_GRP_REGION1_U_RNFBESAM_NID76, REGION2_TARGET_TYPE, 2, 2)
    FIELD(SYS_CACHE_GRP_REGION1_U_RNFBESAM_NID76, REGION2_NONHASH_REG_EN, 1, 1)
    FIELD(SYS_CACHE_GRP_REGION1_U_RNFBESAM_NID76, REGION2_VALID, 0, 1)
REG32(SYS_CACHE_GRP_HN_NODEID_REG0_U_RNFBESAM_NID76, 0x968c58)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG0_U_RNFBESAM_NID76, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG0_U_RNFBESAM_NID76, NODEID_3, 36, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG0_U_RNFBESAM_NID76, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG0_U_RNFBESAM_NID76, NODEID_2, 24, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG0_U_RNFBESAM_NID76, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG0_U_RNFBESAM_NID76, NODEID_1, 12, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG0_U_RNFBESAM_NID76, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG0_U_RNFBESAM_NID76, NODEID_0, 0, 11)
REG32(SYS_CACHE_GRP_HN_NODEID_REG1_U_RNFBESAM_NID76, 0x968c60)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG1_U_RNFBESAM_NID76, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG1_U_RNFBESAM_NID76, NODEID_7, 36, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG1_U_RNFBESAM_NID76, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG1_U_RNFBESAM_NID76, NODEID_6, 24, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG1_U_RNFBESAM_NID76, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG1_U_RNFBESAM_NID76, NODEID_5, 12, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG1_U_RNFBESAM_NID76, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG1_U_RNFBESAM_NID76, NODEID_4, 0, 11)
REG32(SYS_CACHE_GRP_HN_NODEID_REG2_U_RNFBESAM_NID76, 0x968c68)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG2_U_RNFBESAM_NID76, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG2_U_RNFBESAM_NID76, NODEID_11, 36, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG2_U_RNFBESAM_NID76, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG2_U_RNFBESAM_NID76, NODEID_10, 24, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG2_U_RNFBESAM_NID76, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG2_U_RNFBESAM_NID76, NODEID_9, 12, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG2_U_RNFBESAM_NID76, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG2_U_RNFBESAM_NID76, NODEID_8, 0, 11)
REG32(SYS_CACHE_GRP_HN_NODEID_REG3_U_RNFBESAM_NID76, 0x968c70)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG3_U_RNFBESAM_NID76, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG3_U_RNFBESAM_NID76, NODEID_15, 36, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG3_U_RNFBESAM_NID76, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG3_U_RNFBESAM_NID76, NODEID_14, 24, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG3_U_RNFBESAM_NID76, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG3_U_RNFBESAM_NID76, NODEID_13, 12, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG3_U_RNFBESAM_NID76, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG3_U_RNFBESAM_NID76, NODEID_12, 0, 11)
REG32(SYS_CACHE_GRP_HN_NODEID_REG4_U_RNFBESAM_NID76, 0x968c78)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG4_U_RNFBESAM_NID76, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG4_U_RNFBESAM_NID76, NODEID_19, 36, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG4_U_RNFBESAM_NID76, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG4_U_RNFBESAM_NID76, NODEID_18, 24, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG4_U_RNFBESAM_NID76, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG4_U_RNFBESAM_NID76, NODEID_17, 12, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG4_U_RNFBESAM_NID76, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG4_U_RNFBESAM_NID76, NODEID_16, 0, 11)
REG32(SYS_CACHE_GRP_HN_NODEID_REG5_U_RNFBESAM_NID76, 0x968c80)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG5_U_RNFBESAM_NID76, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG5_U_RNFBESAM_NID76, NODEID_23, 36, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG5_U_RNFBESAM_NID76, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG5_U_RNFBESAM_NID76, NODEID_22, 24, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG5_U_RNFBESAM_NID76, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG5_U_RNFBESAM_NID76, NODEID_21, 12, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG5_U_RNFBESAM_NID76, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG5_U_RNFBESAM_NID76, NODEID_20, 0, 11)
REG32(SYS_CACHE_GRP_HN_NODEID_REG6_U_RNFBESAM_NID76, 0x968c88)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG6_U_RNFBESAM_NID76, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG6_U_RNFBESAM_NID76, NODEID_27, 36, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG6_U_RNFBESAM_NID76, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG6_U_RNFBESAM_NID76, NODEID_26, 24, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG6_U_RNFBESAM_NID76, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG6_U_RNFBESAM_NID76, NODEID_25, 12, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG6_U_RNFBESAM_NID76, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG6_U_RNFBESAM_NID76, NODEID_24, 0, 11)
REG32(SYS_CACHE_GRP_HN_NODEID_REG7_U_RNFBESAM_NID76, 0x968c90)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG7_U_RNFBESAM_NID76, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG7_U_RNFBESAM_NID76, NODEID_31, 36, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG7_U_RNFBESAM_NID76, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG7_U_RNFBESAM_NID76, NODEID_30, 24, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG7_U_RNFBESAM_NID76, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG7_U_RNFBESAM_NID76, NODEID_29, 12, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG7_U_RNFBESAM_NID76, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG7_U_RNFBESAM_NID76, NODEID_28, 0, 11)
REG32(SYS_CACHE_GRP_NONHASH_NODEID_U_RNFBESAM_NID76, 0x968c98)
    FIELD(SYS_CACHE_GRP_NONHASH_NODEID_U_RNFBESAM_NID76, RESERVED_35, 35, 29)
    FIELD(SYS_CACHE_GRP_NONHASH_NODEID_U_RNFBESAM_NID76, SCG3_NODEID, 24, 11)
    FIELD(SYS_CACHE_GRP_NONHASH_NODEID_U_RNFBESAM_NID76, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_NONHASH_NODEID_U_RNFBESAM_NID76, SCG2_NODEID, 12, 11)
    FIELD(SYS_CACHE_GRP_NONHASH_NODEID_U_RNFBESAM_NID76, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_NONHASH_NODEID_U_RNFBESAM_NID76, SCG1_NODEID, 0, 11)
REG32(SYS_CACHE_GROUP_HN_COUNT_U_RNFBESAM_NID76, 0x968d00)
    FIELD(SYS_CACHE_GROUP_HN_COUNT_U_RNFBESAM_NID76, RESERVED_31, 31, 33)
    FIELD(SYS_CACHE_GROUP_HN_COUNT_U_RNFBESAM_NID76, SCG3_NUM_HNF, 24, 7)
    FIELD(SYS_CACHE_GROUP_HN_COUNT_U_RNFBESAM_NID76, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GROUP_HN_COUNT_U_RNFBESAM_NID76, SCG2_NUM_HNF, 16, 7)
    FIELD(SYS_CACHE_GROUP_HN_COUNT_U_RNFBESAM_NID76, RESERVED_15, 15, 1)
    FIELD(SYS_CACHE_GROUP_HN_COUNT_U_RNFBESAM_NID76, SCG1_NUM_HNF, 8, 7)
    FIELD(SYS_CACHE_GROUP_HN_COUNT_U_RNFBESAM_NID76, SCG0_NUM_HNF, 0, 7)
REG32(SYS_CACHE_GRP_SN_NODEID_REG0_U_RNFBESAM_NID76, 0x968d08)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG0_U_RNFBESAM_NID76, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG0_U_RNFBESAM_NID76, SN_NODEID_3, 36, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG0_U_RNFBESAM_NID76, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG0_U_RNFBESAM_NID76, SN_NODEID_2, 24, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG0_U_RNFBESAM_NID76, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG0_U_RNFBESAM_NID76, SN_NODEID_1, 12, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG0_U_RNFBESAM_NID76, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG0_U_RNFBESAM_NID76, SN_NODEID_0, 0, 11)
REG32(SYS_CACHE_GRP_SN_NODEID_REG1_U_RNFBESAM_NID76, 0x968d10)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG1_U_RNFBESAM_NID76, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG1_U_RNFBESAM_NID76, SN_NODEID_7, 36, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG1_U_RNFBESAM_NID76, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG1_U_RNFBESAM_NID76, SN_NODEID_6, 24, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG1_U_RNFBESAM_NID76, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG1_U_RNFBESAM_NID76, SN_NODEID_5, 12, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG1_U_RNFBESAM_NID76, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG1_U_RNFBESAM_NID76, SN_NODEID_4, 0, 11)
REG32(SYS_CACHE_GRP_SN_NODEID_REG2_U_RNFBESAM_NID76, 0x968d18)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG2_U_RNFBESAM_NID76, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG2_U_RNFBESAM_NID76, SN_NODEID_11, 36, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG2_U_RNFBESAM_NID76, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG2_U_RNFBESAM_NID76, SN_NODEID_10, 24, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG2_U_RNFBESAM_NID76, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG2_U_RNFBESAM_NID76, SN_NODEID_9, 12, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG2_U_RNFBESAM_NID76, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG2_U_RNFBESAM_NID76, SN_NODEID_8, 0, 11)
REG32(SYS_CACHE_GRP_SN_NODEID_REG3_U_RNFBESAM_NID76, 0x968d20)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG3_U_RNFBESAM_NID76, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG3_U_RNFBESAM_NID76, SN_NODEID_15, 36, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG3_U_RNFBESAM_NID76, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG3_U_RNFBESAM_NID76, SN_NODEID_14, 24, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG3_U_RNFBESAM_NID76, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG3_U_RNFBESAM_NID76, SN_NODEID_13, 12, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG3_U_RNFBESAM_NID76, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG3_U_RNFBESAM_NID76, SN_NODEID_12, 0, 11)
REG32(SYS_CACHE_GRP_SN_NODEID_REG4_U_RNFBESAM_NID76, 0x968d28)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG4_U_RNFBESAM_NID76, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG4_U_RNFBESAM_NID76, SN_NODEID_19, 36, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG4_U_RNFBESAM_NID76, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG4_U_RNFBESAM_NID76, SN_NODEID_18, 24, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG4_U_RNFBESAM_NID76, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG4_U_RNFBESAM_NID76, SN_NODEID_17, 12, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG4_U_RNFBESAM_NID76, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG4_U_RNFBESAM_NID76, SN_NODEID_16, 0, 11)
REG32(SYS_CACHE_GRP_SN_NODEID_REG5_U_RNFBESAM_NID76, 0x968d30)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG5_U_RNFBESAM_NID76, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG5_U_RNFBESAM_NID76, SN_NODEID_23, 36, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG5_U_RNFBESAM_NID76, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG5_U_RNFBESAM_NID76, SN_NODEID_22, 24, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG5_U_RNFBESAM_NID76, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG5_U_RNFBESAM_NID76, SN_NODEID_21, 12, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG5_U_RNFBESAM_NID76, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG5_U_RNFBESAM_NID76, SN_NODEID_20, 0, 11)
REG32(SYS_CACHE_GRP_SN_NODEID_REG6_U_RNFBESAM_NID76, 0x968d38)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG6_U_RNFBESAM_NID76, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG6_U_RNFBESAM_NID76, SN_NODEID_27, 36, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG6_U_RNFBESAM_NID76, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG6_U_RNFBESAM_NID76, SN_NODEID_26, 24, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG6_U_RNFBESAM_NID76, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG6_U_RNFBESAM_NID76, SN_NODEID_25, 12, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG6_U_RNFBESAM_NID76, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG6_U_RNFBESAM_NID76, SN_NODEID_24, 0, 11)
REG32(SYS_CACHE_GRP_SN_NODEID_REG7_U_RNFBESAM_NID76, 0x968d40)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG7_U_RNFBESAM_NID76, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG7_U_RNFBESAM_NID76, SN_NODEID_31, 36, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG7_U_RNFBESAM_NID76, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG7_U_RNFBESAM_NID76, SN_NODEID_30, 24, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG7_U_RNFBESAM_NID76, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG7_U_RNFBESAM_NID76, SN_NODEID_29, 12, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG7_U_RNFBESAM_NID76, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG7_U_RNFBESAM_NID76, SN_NODEID_28, 0, 11)
REG32(SYS_CACHE_GRP_SN_SAM_CFG0_U_RNFBESAM_NID76, 0x968d48)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG0_U_RNFBESAM_NID76, RESERVED_46, 46, 18)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG0_U_RNFBESAM_NID76, SCG1_TOP_ADDRESS_BIT2, 40, 6)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG0_U_RNFBESAM_NID76, RESERVED_38, 38, 2)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG0_U_RNFBESAM_NID76, SCG1_TOP_ADDRESS_BIT1, 32, 6)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG0_U_RNFBESAM_NID76, RESERVED_30, 30, 2)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG0_U_RNFBESAM_NID76, SCG1_TOP_ADDRESS_BIT0, 24, 6)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG0_U_RNFBESAM_NID76, RESERVED_22, 22, 2)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG0_U_RNFBESAM_NID76, SCG0_TOP_ADDRESS_BIT2, 16, 6)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG0_U_RNFBESAM_NID76, RESERVED_14, 14, 2)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG0_U_RNFBESAM_NID76, SCG0_TOP_ADDRESS_BIT1, 8, 6)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG0_U_RNFBESAM_NID76, SCG0_TOP_ADDRESS_BIT0, 0, 6)
REG32(SYS_CACHE_GRP_SN_SAM_CFG1_U_RNFBESAM_NID76, 0x968d50)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG1_U_RNFBESAM_NID76, RESERVED_46, 46, 18)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG1_U_RNFBESAM_NID76, SCG3_TOP_ADDRESS_BIT2, 40, 6)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG1_U_RNFBESAM_NID76, RESERVED_38, 38, 2)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG1_U_RNFBESAM_NID76, SCG3_TOP_ADDRESS_BIT1, 32, 6)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG1_U_RNFBESAM_NID76, RESERVED_30, 30, 2)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG1_U_RNFBESAM_NID76, SCG3_TOP_ADDRESS_BIT0, 24, 6)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG1_U_RNFBESAM_NID76, RESERVED_22, 22, 2)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG1_U_RNFBESAM_NID76, SCG2_TOP_ADDRESS_BIT2, 16, 6)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG1_U_RNFBESAM_NID76, RESERVED_14, 14, 2)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG1_U_RNFBESAM_NID76, SCG2_TOP_ADDRESS_BIT1, 8, 6)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG1_U_RNFBESAM_NID76, SCG2_TOP_ADDRESS_BIT0, 0, 6)
REG32(GIC_MEM_REGION_REG_U_RNFBESAM_NID76, 0x968d58)
    FIELD(GIC_MEM_REGION_REG_U_RNFBESAM_NID76, RESERVED_63, 63, 1)
    FIELD(GIC_MEM_REGION_REG_U_RNFBESAM_NID76, GIC_REGION_NODEID, 52, 11)
    FIELD(GIC_MEM_REGION_REG_U_RNFBESAM_NID76, RESERVED_48, 48, 4)
    FIELD(GIC_MEM_REGION_REG_U_RNFBESAM_NID76, GIC_REGION_BASE_ADDR, 16, 32)
    FIELD(GIC_MEM_REGION_REG_U_RNFBESAM_NID76, GIC_REGION_SIZE, 4, 3)
    FIELD(GIC_MEM_REGION_REG_U_RNFBESAM_NID76, GIC_REGION_TARGET_TYPE, 2, 2)
    FIELD(GIC_MEM_REGION_REG_U_RNFBESAM_NID76, GIC_REGION_VALID, 0, 1)
REG32(SYS_CACHE_GRP_SN_ATTR_U_RNFBESAM_NID76, 0x968d60)
    FIELD(SYS_CACHE_GRP_SN_ATTR_U_RNFBESAM_NID76, RESERVED_54, 54, 10)
    FIELD(SYS_CACHE_GRP_SN_ATTR_U_RNFBESAM_NID76, SN_MODE_SYS_CACHE_GRP3, 52, 2)
    FIELD(SYS_CACHE_GRP_SN_ATTR_U_RNFBESAM_NID76, RESERVED_49, 49, 3)
    FIELD(SYS_CACHE_GRP_SN_ATTR_U_RNFBESAM_NID76, INV_TOP_ADDRESS_BIT_SYS_CACHE_GRP3, 48, 1)
    FIELD(SYS_CACHE_GRP_SN_ATTR_U_RNFBESAM_NID76, RESERVED_38, 38, 10)
    FIELD(SYS_CACHE_GRP_SN_ATTR_U_RNFBESAM_NID76, SN_MODE_SYS_CACHE_GRP2, 36, 2)
    FIELD(SYS_CACHE_GRP_SN_ATTR_U_RNFBESAM_NID76, RESERVED_33, 33, 3)
    FIELD(SYS_CACHE_GRP_SN_ATTR_U_RNFBESAM_NID76, INV_TOP_ADDRESS_BIT_SYS_CACHE_GRP2, 32, 1)
    FIELD(SYS_CACHE_GRP_SN_ATTR_U_RNFBESAM_NID76, RESERVED_22, 22, 10)
    FIELD(SYS_CACHE_GRP_SN_ATTR_U_RNFBESAM_NID76, SN_MODE_SYS_CACHE_GRP1, 20, 2)
    FIELD(SYS_CACHE_GRP_SN_ATTR_U_RNFBESAM_NID76, RESERVED_17, 17, 3)
    FIELD(SYS_CACHE_GRP_SN_ATTR_U_RNFBESAM_NID76, INV_TOP_ADDRESS_BIT_SYS_CACHE_GRP1, 16, 1)
    FIELD(SYS_CACHE_GRP_SN_ATTR_U_RNFBESAM_NID76, SN_MODE_SYS_CACHE_GRP0, 4, 2)
    FIELD(SYS_CACHE_GRP_SN_ATTR_U_RNFBESAM_NID76, INV_TOP_ADDRESS_BIT_SYS_CACHE_GRP0, 0, 1)
REG32(SYS_CACHE_GRP_HN_CPA_EN_REG_U_RNFBESAM_NID76, 0x968d68)
REG32(SYS_CACHE_GRP_HN_CPA_GRP_REG_U_RNFBESAM_NID76, 0x968d70)
    FIELD(SYS_CACHE_GRP_HN_CPA_GRP_REG_U_RNFBESAM_NID76, RESERVED_50, 50, 14)
    FIELD(SYS_CACHE_GRP_HN_CPA_GRP_REG_U_RNFBESAM_NID76, CPA_GRP_SCG3, 48, 2)
    FIELD(SYS_CACHE_GRP_HN_CPA_GRP_REG_U_RNFBESAM_NID76, RESERVED_34, 34, 14)
    FIELD(SYS_CACHE_GRP_HN_CPA_GRP_REG_U_RNFBESAM_NID76, CPA_GRP_SCG2, 32, 2)
    FIELD(SYS_CACHE_GRP_HN_CPA_GRP_REG_U_RNFBESAM_NID76, RESERVED_18, 18, 14)
    FIELD(SYS_CACHE_GRP_HN_CPA_GRP_REG_U_RNFBESAM_NID76, CPA_GRP_SCG1, 16, 2)
    FIELD(SYS_CACHE_GRP_HN_CPA_GRP_REG_U_RNFBESAM_NID76, CPA_GRP_SCG0, 0, 2)
REG32(CML_PORT_AGGR_MODE_CTRL_REG_U_RNFBESAM_NID76, 0x968e00)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNFBESAM_NID76, RESERVED_32, 32, 32)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNFBESAM_NID76, REGION7_PAG_GRPID, 30, 2)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNFBESAM_NID76, RESERVED_29, 29, 1)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNFBESAM_NID76, REGION7_PAG_EN, 28, 1)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNFBESAM_NID76, RESERVED_27, 27, 1)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNFBESAM_NID76, REGION6_PAG_GRPID, 25, 2)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNFBESAM_NID76, REGION6_PAG_EN, 24, 1)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNFBESAM_NID76, RESERVED_23, 23, 1)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNFBESAM_NID76, REGION5_PAG_GRPID, 21, 2)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNFBESAM_NID76, REGION5_PAG_EN, 20, 1)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNFBESAM_NID76, RESERVED_19, 19, 1)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNFBESAM_NID76, REGION4_PAG_GRPID, 17, 2)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNFBESAM_NID76, REGION4_PAG_EN, 16, 1)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNFBESAM_NID76, RESERVED_15, 15, 1)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNFBESAM_NID76, REGION3_PAG_GRPID, 13, 2)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNFBESAM_NID76, REGION3_PAG_EN, 12, 1)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNFBESAM_NID76, RESERVED_11, 11, 1)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNFBESAM_NID76, REGION2_PAG_GRPID, 9, 2)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNFBESAM_NID76, REGION2_PAG_EN, 8, 1)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNFBESAM_NID76, REGION1_PAG_GRPID, 5, 2)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNFBESAM_NID76, REGION1_PAG_EN, 4, 1)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNFBESAM_NID76, REGION0_PAG_GRPID, 1, 2)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNFBESAM_NID76, REGION0_PAG_EN, 0, 1)
REG32(CML_PORT_AGGR_GRP0_ADD_MASK_U_RNFBESAM_NID76, 0x968e08)
    FIELD(CML_PORT_AGGR_GRP0_ADD_MASK_U_RNFBESAM_NID76, RESERVED_48, 48, 16)
    FIELD(CML_PORT_AGGR_GRP0_ADD_MASK_U_RNFBESAM_NID76, ADDR_MASK, 6, 42)
    FIELD(CML_PORT_AGGR_GRP0_ADD_MASK_U_RNFBESAM_NID76, RESERVED_0, 0, 6)
REG32(CML_PORT_AGGR_GRP1_ADD_MASK_U_RNFBESAM_NID76, 0x968e10)
    FIELD(CML_PORT_AGGR_GRP1_ADD_MASK_U_RNFBESAM_NID76, RESERVED_48, 48, 16)
    FIELD(CML_PORT_AGGR_GRP1_ADD_MASK_U_RNFBESAM_NID76, ADDR_MASK, 6, 42)
    FIELD(CML_PORT_AGGR_GRP1_ADD_MASK_U_RNFBESAM_NID76, RESERVED_0, 0, 6)
REG32(CML_PORT_AGGR_GRP0_REG_U_RNFBESAM_NID76, 0x968e40)
    FIELD(CML_PORT_AGGR_GRP0_REG_U_RNFBESAM_NID76, RESERVED_50, 50, 14)
    FIELD(CML_PORT_AGGR_GRP0_REG_U_RNFBESAM_NID76, NUM_CXG_PAG0, 48, 2)
    FIELD(CML_PORT_AGGR_GRP0_REG_U_RNFBESAM_NID76, RESERVED_47, 47, 1)
    FIELD(CML_PORT_AGGR_GRP0_REG_U_RNFBESAM_NID76, PAG0_TGTID3, 36, 11)
    FIELD(CML_PORT_AGGR_GRP0_REG_U_RNFBESAM_NID76, RESERVED_35, 35, 1)
    FIELD(CML_PORT_AGGR_GRP0_REG_U_RNFBESAM_NID76, PAG0_TGTID2, 24, 11)
    FIELD(CML_PORT_AGGR_GRP0_REG_U_RNFBESAM_NID76, RESERVED_23, 23, 1)
    FIELD(CML_PORT_AGGR_GRP0_REG_U_RNFBESAM_NID76, PAG0_TGTID1, 12, 11)
    FIELD(CML_PORT_AGGR_GRP0_REG_U_RNFBESAM_NID76, RESERVED_11, 11, 1)
    FIELD(CML_PORT_AGGR_GRP0_REG_U_RNFBESAM_NID76, PAG0_TGTID0, 0, 11)
REG32(CML_PORT_AGGR_GRP1_REG_U_RNFBESAM_NID76, 0x968e48)
    FIELD(CML_PORT_AGGR_GRP1_REG_U_RNFBESAM_NID76, RESERVED_50, 50, 14)
    FIELD(CML_PORT_AGGR_GRP1_REG_U_RNFBESAM_NID76, NUM_CXG_PAG1, 48, 2)
    FIELD(CML_PORT_AGGR_GRP1_REG_U_RNFBESAM_NID76, RESERVED_47, 47, 1)
    FIELD(CML_PORT_AGGR_GRP1_REG_U_RNFBESAM_NID76, PAG1_TGTID3, 36, 11)
    FIELD(CML_PORT_AGGR_GRP1_REG_U_RNFBESAM_NID76, RESERVED_35, 35, 1)
    FIELD(CML_PORT_AGGR_GRP1_REG_U_RNFBESAM_NID76, PAG1_TGTID2, 24, 11)
    FIELD(CML_PORT_AGGR_GRP1_REG_U_RNFBESAM_NID76, RESERVED_23, 23, 1)
    FIELD(CML_PORT_AGGR_GRP1_REG_U_RNFBESAM_NID76, PAG1_TGTID1, 12, 11)
    FIELD(CML_PORT_AGGR_GRP1_REG_U_RNFBESAM_NID76, RESERVED_11, 11, 1)
    FIELD(CML_PORT_AGGR_GRP1_REG_U_RNFBESAM_NID76, PAG1_TGTID0, 0, 11)
REG32(SYS_CACHE_GRP_SECONDARY_REG0_U_RNFBESAM_NID76, 0x968f00)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG0_U_RNFBESAM_NID76, RESERVED_63, 63, 1)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG0_U_RNFBESAM_NID76, REGION1_SCNDRY_BASE_ADDR, 41, 22)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG0_U_RNFBESAM_NID76, REGION1_SCNDRY_SIZE, 36, 5)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG0_U_RNFBESAM_NID76, REGION1_SCNDRY_TARGET_TYPE, 34, 2)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG0_U_RNFBESAM_NID76, RESERVED_33, 33, 1)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG0_U_RNFBESAM_NID76, REGION1_SCNDRY_VALID, 32, 1)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG0_U_RNFBESAM_NID76, RESERVED_31, 31, 1)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG0_U_RNFBESAM_NID76, REGION0_SCNDRY_BASE_ADDR, 9, 22)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG0_U_RNFBESAM_NID76, REGION0_SCNDRY_SIZE, 4, 5)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG0_U_RNFBESAM_NID76, REGION0_SCNDRY_TARGET_TYPE, 2, 2)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG0_U_RNFBESAM_NID76, REGION0_SCNDRY_VALID, 0, 1)
REG32(SYS_CACHE_GRP_SECONDARY_REG1_U_RNFBESAM_NID76, 0x968f08)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG1_U_RNFBESAM_NID76, RESERVED_63, 63, 1)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG1_U_RNFBESAM_NID76, REGION3_SCNDRY_BASE_ADDR, 41, 22)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG1_U_RNFBESAM_NID76, REGION3_SCNDRY_SIZE, 36, 5)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG1_U_RNFBESAM_NID76, REGION3_SCNDRY_TARGET_TYPE, 34, 2)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG1_U_RNFBESAM_NID76, RESERVED_33, 33, 1)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG1_U_RNFBESAM_NID76, REGION3_SCNDRY_VALID, 32, 1)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG1_U_RNFBESAM_NID76, RESERVED_31, 31, 1)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG1_U_RNFBESAM_NID76, REGION2_SCNDRY_BASE_ADDR, 9, 22)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG1_U_RNFBESAM_NID76, REGION2_SCNDRY_SIZE, 4, 5)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG1_U_RNFBESAM_NID76, REGION2_SCNDRY_TARGET_TYPE, 2, 2)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG1_U_RNFBESAM_NID76, REGION2_SCNDRY_VALID, 0, 1)
REG32(SYS_CACHE_GRP_CAL_MODE_REG_U_RNFBESAM_NID76, 0x968f10)
    FIELD(SYS_CACHE_GRP_CAL_MODE_REG_U_RNFBESAM_NID76, RESERVED_49, 49, 15)
    FIELD(SYS_CACHE_GRP_CAL_MODE_REG_U_RNFBESAM_NID76, SCG3_HNF_CAL_MODE_EN, 48, 1)
    FIELD(SYS_CACHE_GRP_CAL_MODE_REG_U_RNFBESAM_NID76, RESERVED_33, 33, 15)
    FIELD(SYS_CACHE_GRP_CAL_MODE_REG_U_RNFBESAM_NID76, SCG2_HNF_CAL_MODE_EN, 32, 1)
    FIELD(SYS_CACHE_GRP_CAL_MODE_REG_U_RNFBESAM_NID76, RESERVED_17, 17, 15)
    FIELD(SYS_CACHE_GRP_CAL_MODE_REG_U_RNFBESAM_NID76, SCG1_HNF_CAL_MODE_EN, 16, 1)
    FIELD(SYS_CACHE_GRP_CAL_MODE_REG_U_RNFBESAM_NID76, SCG0_HNF_CAL_MODE_EN, 0, 1)
REG32(RNSAM_HASH_ADDR_MASK_REG_U_RNFBESAM_NID76, 0x968f18)
    FIELD(RNSAM_HASH_ADDR_MASK_REG_U_RNFBESAM_NID76, RESERVED_48, 48, 16)
    FIELD(RNSAM_HASH_ADDR_MASK_REG_U_RNFBESAM_NID76, ADDR_MASK, 6, 42)
    FIELD(RNSAM_HASH_ADDR_MASK_REG_U_RNFBESAM_NID76, RESERVED_0, 0, 6)
REG32(RNSAM_REGION_CMP_ADDR_MASK_REG_U_RNFBESAM_NID76, 0x968f20)
    FIELD(RNSAM_REGION_CMP_ADDR_MASK_REG_U_RNFBESAM_NID76, RESERVED_48, 48, 16)
    FIELD(RNSAM_REGION_CMP_ADDR_MASK_REG_U_RNFBESAM_NID76, ADDR_MASK, 16, 32)
    FIELD(RNSAM_REGION_CMP_ADDR_MASK_REG_U_RNFBESAM_NID76, RESERVED_0, 0, 16)
REG32(SYS_CACHE_GRP_HN_NODEID_REG8_U_RNFBESAM_NID76, 0x968f58)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG8_U_RNFBESAM_NID76, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG8_U_RNFBESAM_NID76, NODEID_35, 36, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG8_U_RNFBESAM_NID76, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG8_U_RNFBESAM_NID76, NODEID_34, 24, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG8_U_RNFBESAM_NID76, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG8_U_RNFBESAM_NID76, NODEID_33, 12, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG8_U_RNFBESAM_NID76, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG8_U_RNFBESAM_NID76, NODEID_32, 0, 11)
REG32(SYS_CACHE_GRP_HN_NODEID_REG9_U_RNFBESAM_NID76, 0x968f60)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG9_U_RNFBESAM_NID76, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG9_U_RNFBESAM_NID76, NODEID_39, 36, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG9_U_RNFBESAM_NID76, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG9_U_RNFBESAM_NID76, NODEID_38, 24, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG9_U_RNFBESAM_NID76, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG9_U_RNFBESAM_NID76, NODEID_37, 12, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG9_U_RNFBESAM_NID76, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG9_U_RNFBESAM_NID76, NODEID_36, 0, 11)
REG32(SYS_CACHE_GRP_HN_NODEID_REG10_U_RNFBESAM_NID76, 0x968f68)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG10_U_RNFBESAM_NID76, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG10_U_RNFBESAM_NID76, NODEID_43, 36, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG10_U_RNFBESAM_NID76, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG10_U_RNFBESAM_NID76, NODEID_42, 24, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG10_U_RNFBESAM_NID76, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG10_U_RNFBESAM_NID76, NODEID_41, 12, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG10_U_RNFBESAM_NID76, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG10_U_RNFBESAM_NID76, NODEID_40, 0, 11)
REG32(SYS_CACHE_GRP_HN_NODEID_REG11_U_RNFBESAM_NID76, 0x968f70)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG11_U_RNFBESAM_NID76, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG11_U_RNFBESAM_NID76, NODEID_47, 36, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG11_U_RNFBESAM_NID76, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG11_U_RNFBESAM_NID76, NODEID_46, 24, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG11_U_RNFBESAM_NID76, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG11_U_RNFBESAM_NID76, NODEID_45, 12, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG11_U_RNFBESAM_NID76, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG11_U_RNFBESAM_NID76, NODEID_44, 0, 11)
REG32(SYS_CACHE_GRP_HN_NODEID_REG12_U_RNFBESAM_NID76, 0x968f78)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG12_U_RNFBESAM_NID76, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG12_U_RNFBESAM_NID76, NODEID_51, 36, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG12_U_RNFBESAM_NID76, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG12_U_RNFBESAM_NID76, NODEID_50, 24, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG12_U_RNFBESAM_NID76, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG12_U_RNFBESAM_NID76, NODEID_49, 12, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG12_U_RNFBESAM_NID76, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG12_U_RNFBESAM_NID76, NODEID_48, 0, 11)
REG32(SYS_CACHE_GRP_HN_NODEID_REG13_U_RNFBESAM_NID76, 0x968f80)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG13_U_RNFBESAM_NID76, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG13_U_RNFBESAM_NID76, NODEID_55, 36, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG13_U_RNFBESAM_NID76, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG13_U_RNFBESAM_NID76, NODEID_54, 24, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG13_U_RNFBESAM_NID76, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG13_U_RNFBESAM_NID76, NODEID_53, 12, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG13_U_RNFBESAM_NID76, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG13_U_RNFBESAM_NID76, NODEID_52, 0, 11)
REG32(SYS_CACHE_GRP_HN_NODEID_REG14_U_RNFBESAM_NID76, 0x968f88)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG14_U_RNFBESAM_NID76, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG14_U_RNFBESAM_NID76, NODEID_59, 36, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG14_U_RNFBESAM_NID76, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG14_U_RNFBESAM_NID76, NODEID_58, 24, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG14_U_RNFBESAM_NID76, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG14_U_RNFBESAM_NID76, NODEID_57, 12, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG14_U_RNFBESAM_NID76, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG14_U_RNFBESAM_NID76, NODEID_56, 0, 11)
REG32(SYS_CACHE_GRP_HN_NODEID_REG15_U_RNFBESAM_NID76, 0x968f90)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG15_U_RNFBESAM_NID76, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG15_U_RNFBESAM_NID76, NODEID_63, 36, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG15_U_RNFBESAM_NID76, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG15_U_RNFBESAM_NID76, NODEID_62, 24, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG15_U_RNFBESAM_NID76, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG15_U_RNFBESAM_NID76, NODEID_61, 12, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG15_U_RNFBESAM_NID76, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG15_U_RNFBESAM_NID76, NODEID_60, 0, 11)
REG32(SYS_CACHE_GRP_SN_NODEID_REG8_U_RNFBESAM_NID76, 0x969008)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG8_U_RNFBESAM_NID76, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG8_U_RNFBESAM_NID76, SN_NODEID_35, 36, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG8_U_RNFBESAM_NID76, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG8_U_RNFBESAM_NID76, SN_NODEID_34, 24, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG8_U_RNFBESAM_NID76, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG8_U_RNFBESAM_NID76, SN_NODEID_33, 12, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG8_U_RNFBESAM_NID76, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG8_U_RNFBESAM_NID76, SN_NODEID_32, 0, 11)
REG32(SYS_CACHE_GRP_SN_NODEID_REG9_U_RNFBESAM_NID76, 0x969010)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG9_U_RNFBESAM_NID76, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG9_U_RNFBESAM_NID76, SN_NODEID_39, 36, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG9_U_RNFBESAM_NID76, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG9_U_RNFBESAM_NID76, SN_NODEID_38, 24, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG9_U_RNFBESAM_NID76, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG9_U_RNFBESAM_NID76, SN_NODEID_37, 12, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG9_U_RNFBESAM_NID76, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG9_U_RNFBESAM_NID76, SN_NODEID_36, 0, 11)
REG32(SYS_CACHE_GRP_SN_NODEID_REG10_U_RNFBESAM_NID76, 0x969018)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG10_U_RNFBESAM_NID76, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG10_U_RNFBESAM_NID76, SN_NODEID_43, 36, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG10_U_RNFBESAM_NID76, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG10_U_RNFBESAM_NID76, SN_NODEID_42, 24, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG10_U_RNFBESAM_NID76, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG10_U_RNFBESAM_NID76, SN_NODEID_41, 12, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG10_U_RNFBESAM_NID76, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG10_U_RNFBESAM_NID76, SN_NODEID_40, 0, 11)
REG32(SYS_CACHE_GRP_SN_NODEID_REG11_U_RNFBESAM_NID76, 0x969020)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG11_U_RNFBESAM_NID76, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG11_U_RNFBESAM_NID76, SN_NODEID_47, 36, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG11_U_RNFBESAM_NID76, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG11_U_RNFBESAM_NID76, SN_NODEID_46, 24, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG11_U_RNFBESAM_NID76, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG11_U_RNFBESAM_NID76, SN_NODEID_45, 12, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG11_U_RNFBESAM_NID76, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG11_U_RNFBESAM_NID76, SN_NODEID_44, 0, 11)
REG32(SYS_CACHE_GRP_SN_NODEID_REG12_U_RNFBESAM_NID76, 0x969028)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG12_U_RNFBESAM_NID76, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG12_U_RNFBESAM_NID76, SN_NODEID_51, 36, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG12_U_RNFBESAM_NID76, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG12_U_RNFBESAM_NID76, SN_NODEID_50, 24, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG12_U_RNFBESAM_NID76, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG12_U_RNFBESAM_NID76, SN_NODEID_49, 12, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG12_U_RNFBESAM_NID76, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG12_U_RNFBESAM_NID76, SN_NODEID_48, 0, 11)
REG32(SYS_CACHE_GRP_SN_NODEID_REG13_U_RNFBESAM_NID76, 0x969030)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG13_U_RNFBESAM_NID76, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG13_U_RNFBESAM_NID76, SN_NODEID_55, 36, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG13_U_RNFBESAM_NID76, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG13_U_RNFBESAM_NID76, SN_NODEID_54, 24, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG13_U_RNFBESAM_NID76, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG13_U_RNFBESAM_NID76, SN_NODEID_53, 12, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG13_U_RNFBESAM_NID76, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG13_U_RNFBESAM_NID76, SN_NODEID_52, 0, 11)
REG32(SYS_CACHE_GRP_SN_NODEID_REG14_U_RNFBESAM_NID76, 0x969038)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG14_U_RNFBESAM_NID76, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG14_U_RNFBESAM_NID76, SN_NODEID_59, 36, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG14_U_RNFBESAM_NID76, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG14_U_RNFBESAM_NID76, SN_NODEID_58, 24, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG14_U_RNFBESAM_NID76, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG14_U_RNFBESAM_NID76, SN_NODEID_57, 12, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG14_U_RNFBESAM_NID76, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG14_U_RNFBESAM_NID76, SN_NODEID_56, 0, 11)
REG32(SYS_CACHE_GRP_SN_NODEID_REG15_U_RNFBESAM_NID76, 0x969040)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG15_U_RNFBESAM_NID76, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG15_U_RNFBESAM_NID76, SN_NODEID_63, 36, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG15_U_RNFBESAM_NID76, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG15_U_RNFBESAM_NID76, SN_NODEID_62, 24, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG15_U_RNFBESAM_NID76, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG15_U_RNFBESAM_NID76, SN_NODEID_61, 12, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG15_U_RNFBESAM_NID76, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG15_U_RNFBESAM_NID76, SN_NODEID_60, 0, 11)
REG32(POR_SBSX_NODE_INFO_U_SBSX_NID128, 0x1000000)
    FIELD(POR_SBSX_NODE_INFO_U_SBSX_NID128, RESERVED_48, 48, 16)
    FIELD(POR_SBSX_NODE_INFO_U_SBSX_NID128, LOGICAL_ID, 32, 16)
    FIELD(POR_SBSX_NODE_INFO_U_SBSX_NID128, NODE_ID, 16, 16)
    FIELD(POR_SBSX_NODE_INFO_U_SBSX_NID128, NODE_TYPE, 0, 16)
REG32(POR_SBSX_CHILD_INFO_U_SBSX_NID128, 0x1000080)
    FIELD(POR_SBSX_CHILD_INFO_U_SBSX_NID128, RESERVED_32, 32, 32)
    FIELD(POR_SBSX_CHILD_INFO_U_SBSX_NID128, CHILD_PTR_OFFSET, 16, 16)
    FIELD(POR_SBSX_CHILD_INFO_U_SBSX_NID128, CHILD_COUNT, 0, 16)
REG32(POR_SBSX_UNIT_INFO_U_SBSX_NID128, 0x1000900)
    FIELD(POR_SBSX_UNIT_INFO_U_SBSX_NID128, RESERVED_22, 22, 42)
    FIELD(POR_SBSX_UNIT_INFO_U_SBSX_NID128, ACEL_SAFE_XFACE_DISABLE, 21, 1)
    FIELD(POR_SBSX_UNIT_INFO_U_SBSX_NID128, NUM_WR_DATA_BUF, 16, 5)
    FIELD(POR_SBSX_UNIT_INFO_U_SBSX_NID128, NUM_OUTSTANDING_READS, 8, 8)
    FIELD(POR_SBSX_UNIT_INFO_U_SBSX_NID128, AXDATA_POISON_EN, 4, 1)
    FIELD(POR_SBSX_UNIT_INFO_U_SBSX_NID128, AXDATA_WIDTH, 0, 1)
REG32(POR_SBSX_AUX_CTL_U_SBSX_NID128, 0x1000a08)
    FIELD(POR_SBSX_AUX_CTL_U_SBSX_NID128, CLKGATE_DISABLE, 0, 1)
REG32(POR_SBSX_PMU_EVENT_SEL_U_SBSX_NID128, 0x1002000)
    FIELD(POR_SBSX_PMU_EVENT_SEL_U_SBSX_NID128, RESERVED_30, 30, 34)
    FIELD(POR_SBSX_PMU_EVENT_SEL_U_SBSX_NID128, PMU_EVENT3_ID, 24, 6)
    FIELD(POR_SBSX_PMU_EVENT_SEL_U_SBSX_NID128, RESERVED_22, 22, 2)
    FIELD(POR_SBSX_PMU_EVENT_SEL_U_SBSX_NID128, PMU_EVENT2_ID, 16, 6)
    FIELD(POR_SBSX_PMU_EVENT_SEL_U_SBSX_NID128, RESERVED_14, 14, 2)
    FIELD(POR_SBSX_PMU_EVENT_SEL_U_SBSX_NID128, PMU_EVENT1_ID, 8, 6)
    FIELD(POR_SBSX_PMU_EVENT_SEL_U_SBSX_NID128, PMU_EVENT0_ID, 0, 6)
REG32(POR_SBSX_ERRFR_U_SBSX_NID128, 0x1003000)
    FIELD(POR_SBSX_ERRFR_U_SBSX_NID128, RESERVED_15, 15, 49)
    FIELD(POR_SBSX_ERRFR_U_SBSX_NID128, CEC, 12, 3)
    FIELD(POR_SBSX_ERRFR_U_SBSX_NID128, CFI, 10, 2)
    FIELD(POR_SBSX_ERRFR_U_SBSX_NID128, FI, 6, 2)
    FIELD(POR_SBSX_ERRFR_U_SBSX_NID128, UI, 4, 2)
    FIELD(POR_SBSX_ERRFR_U_SBSX_NID128, DE, 2, 2)
    FIELD(POR_SBSX_ERRFR_U_SBSX_NID128, ED, 0, 2)
REG32(POR_SBSX_ERRCTLR_U_SBSX_NID128, 0x1003008)
    FIELD(POR_SBSX_ERRCTLR_U_SBSX_NID128, RESERVED_9, 9, 55)
    FIELD(POR_SBSX_ERRCTLR_U_SBSX_NID128, CFI, 8, 1)
    FIELD(POR_SBSX_ERRCTLR_U_SBSX_NID128, FI, 3, 1)
    FIELD(POR_SBSX_ERRCTLR_U_SBSX_NID128, UI, 2, 1)
    FIELD(POR_SBSX_ERRCTLR_U_SBSX_NID128, DE, 1, 1)
    FIELD(POR_SBSX_ERRCTLR_U_SBSX_NID128, ED, 0, 1)
REG32(POR_SBSX_ERRSTATUS_U_SBSX_NID128, 0x1003010)
    FIELD(POR_SBSX_ERRSTATUS_U_SBSX_NID128, RESERVED_32, 32, 32)
    FIELD(POR_SBSX_ERRSTATUS_U_SBSX_NID128, AV, 31, 1)
    FIELD(POR_SBSX_ERRSTATUS_U_SBSX_NID128, V, 30, 1)
    FIELD(POR_SBSX_ERRSTATUS_U_SBSX_NID128, UE, 29, 1)
    FIELD(POR_SBSX_ERRSTATUS_U_SBSX_NID128, RESERVED_28, 28, 1)
    FIELD(POR_SBSX_ERRSTATUS_U_SBSX_NID128, OF, 27, 1)
    FIELD(POR_SBSX_ERRSTATUS_U_SBSX_NID128, MV, 26, 1)
    FIELD(POR_SBSX_ERRSTATUS_U_SBSX_NID128, RESERVED_25, 25, 1)
    FIELD(POR_SBSX_ERRSTATUS_U_SBSX_NID128, CE, 24, 1)
    FIELD(POR_SBSX_ERRSTATUS_U_SBSX_NID128, DE, 23, 1)
    FIELD(POR_SBSX_ERRSTATUS_U_SBSX_NID128, RESERVED_0, 0, 23)
REG32(POR_SBSX_ERRADDR_U_SBSX_NID128, 0x1003018)
    FIELD(POR_SBSX_ERRADDR_U_SBSX_NID128, NS, 63, 1)
    FIELD(POR_SBSX_ERRADDR_U_SBSX_NID128, RESERVED_48, 48, 15)
    FIELD(POR_SBSX_ERRADDR_U_SBSX_NID128, ADDR, 0, 48)
REG32(POR_SBSX_ERRMISC_U_SBSX_NID128, 0x1003020)
    FIELD(POR_SBSX_ERRMISC_U_SBSX_NID128, RESERVED_31, 31, 33)
    FIELD(POR_SBSX_ERRMISC_U_SBSX_NID128, SIZE, 28, 3)
    FIELD(POR_SBSX_ERRMISC_U_SBSX_NID128, MEMATTR, 24, 4)
    FIELD(POR_SBSX_ERRMISC_U_SBSX_NID128, RESERVED_17, 17, 7)
    FIELD(POR_SBSX_ERRMISC_U_SBSX_NID128, OPTYPE, 16, 1)
    FIELD(POR_SBSX_ERRMISC_U_SBSX_NID128, RESERVED_15, 15, 1)
    FIELD(POR_SBSX_ERRMISC_U_SBSX_NID128, SRCID, 4, 11)
    FIELD(POR_SBSX_ERRMISC_U_SBSX_NID128, RESERVED_0, 0, 4)
REG32(POR_SBSX_ERRFR_NS_U_SBSX_NID128, 0x1003100)
    FIELD(POR_SBSX_ERRFR_NS_U_SBSX_NID128, RESERVED_15, 15, 49)
    FIELD(POR_SBSX_ERRFR_NS_U_SBSX_NID128, CEC, 12, 3)
    FIELD(POR_SBSX_ERRFR_NS_U_SBSX_NID128, CFI, 10, 2)
    FIELD(POR_SBSX_ERRFR_NS_U_SBSX_NID128, FI, 6, 2)
    FIELD(POR_SBSX_ERRFR_NS_U_SBSX_NID128, UI, 4, 2)
    FIELD(POR_SBSX_ERRFR_NS_U_SBSX_NID128, DE, 2, 2)
    FIELD(POR_SBSX_ERRFR_NS_U_SBSX_NID128, ED, 0, 2)
REG32(POR_SBSX_ERRCTLR_NS_U_SBSX_NID128, 0x1003108)
    FIELD(POR_SBSX_ERRCTLR_NS_U_SBSX_NID128, RESERVED_9, 9, 55)
    FIELD(POR_SBSX_ERRCTLR_NS_U_SBSX_NID128, CFI, 8, 1)
    FIELD(POR_SBSX_ERRCTLR_NS_U_SBSX_NID128, FI, 3, 1)
    FIELD(POR_SBSX_ERRCTLR_NS_U_SBSX_NID128, UI, 2, 1)
    FIELD(POR_SBSX_ERRCTLR_NS_U_SBSX_NID128, DE, 1, 1)
    FIELD(POR_SBSX_ERRCTLR_NS_U_SBSX_NID128, ED, 0, 1)
REG32(POR_SBSX_ERRSTATUS_NS_U_SBSX_NID128, 0x1003110)
    FIELD(POR_SBSX_ERRSTATUS_NS_U_SBSX_NID128, RESERVED_32, 32, 32)
    FIELD(POR_SBSX_ERRSTATUS_NS_U_SBSX_NID128, AV, 31, 1)
    FIELD(POR_SBSX_ERRSTATUS_NS_U_SBSX_NID128, V, 30, 1)
    FIELD(POR_SBSX_ERRSTATUS_NS_U_SBSX_NID128, UE, 29, 1)
    FIELD(POR_SBSX_ERRSTATUS_NS_U_SBSX_NID128, RESERVED_28, 28, 1)
    FIELD(POR_SBSX_ERRSTATUS_NS_U_SBSX_NID128, OF, 27, 1)
    FIELD(POR_SBSX_ERRSTATUS_NS_U_SBSX_NID128, MV, 26, 1)
    FIELD(POR_SBSX_ERRSTATUS_NS_U_SBSX_NID128, RESERVED_25, 25, 1)
    FIELD(POR_SBSX_ERRSTATUS_NS_U_SBSX_NID128, CE, 24, 1)
    FIELD(POR_SBSX_ERRSTATUS_NS_U_SBSX_NID128, DE, 23, 1)
    FIELD(POR_SBSX_ERRSTATUS_NS_U_SBSX_NID128, RESERVED_0, 0, 23)
REG32(POR_SBSX_ERRADDR_NS_U_SBSX_NID128, 0x1003118)
    FIELD(POR_SBSX_ERRADDR_NS_U_SBSX_NID128, NS, 63, 1)
    FIELD(POR_SBSX_ERRADDR_NS_U_SBSX_NID128, RESERVED_48, 48, 15)
    FIELD(POR_SBSX_ERRADDR_NS_U_SBSX_NID128, ADDR, 0, 48)
REG32(POR_SBSX_ERRMISC_NS_U_SBSX_NID128, 0x1003120)
    FIELD(POR_SBSX_ERRMISC_NS_U_SBSX_NID128, RESERVED_31, 31, 33)
    FIELD(POR_SBSX_ERRMISC_NS_U_SBSX_NID128, SIZE, 28, 3)
    FIELD(POR_SBSX_ERRMISC_NS_U_SBSX_NID128, MEMATTR, 24, 4)
    FIELD(POR_SBSX_ERRMISC_NS_U_SBSX_NID128, RESERVED_17, 17, 7)
    FIELD(POR_SBSX_ERRMISC_NS_U_SBSX_NID128, OPTYPE, 16, 1)
    FIELD(POR_SBSX_ERRMISC_NS_U_SBSX_NID128, RESERVED_15, 15, 1)
    FIELD(POR_SBSX_ERRMISC_NS_U_SBSX_NID128, SRCID, 4, 11)
    FIELD(POR_SBSX_ERRMISC_NS_U_SBSX_NID128, RESERVED_0, 0, 4)
REG32(POR_MXP_NODE_INFO_U_SMXP_2_0, 0x1008000)
    FIELD(POR_MXP_NODE_INFO_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MXP_NODE_INFO_U_SMXP_2_0, LOGICAL_ID, 32, 16)
    FIELD(POR_MXP_NODE_INFO_U_SMXP_2_0, XY_ID, 16, 16)
    FIELD(POR_MXP_NODE_INFO_U_SMXP_2_0, NODE_TYPE, 0, 16)
REG32(POR_MXP_DEVICE_PORT_CONNECT_INFO_P0_U_SMXP_2_0, 0x1008008)
    FIELD(POR_MXP_DEVICE_PORT_CONNECT_INFO_P0_U_SMXP_2_0, RESERVED_32, 32, 32)
    FIELD(POR_MXP_DEVICE_PORT_CONNECT_INFO_P0_U_SMXP_2_0, NUM_DCS_P0_D3, 28, 4)
    FIELD(POR_MXP_DEVICE_PORT_CONNECT_INFO_P0_U_SMXP_2_0, NUM_DCS_P0_D2, 24, 4)
    FIELD(POR_MXP_DEVICE_PORT_CONNECT_INFO_P0_U_SMXP_2_0, NUM_DCS_P0_D1, 20, 4)
    FIELD(POR_MXP_DEVICE_PORT_CONNECT_INFO_P0_U_SMXP_2_0, NUM_DCS_P0_D0, 16, 4)
    FIELD(POR_MXP_DEVICE_PORT_CONNECT_INFO_P0_U_SMXP_2_0, DEVICE_TYPE_P0, 0, 5)
REG32(POR_MXP_DEVICE_PORT_CONNECT_INFO_P1_U_SMXP_2_0, 0x1008010)
    FIELD(POR_MXP_DEVICE_PORT_CONNECT_INFO_P1_U_SMXP_2_0, RESERVED_32, 32, 32)
    FIELD(POR_MXP_DEVICE_PORT_CONNECT_INFO_P1_U_SMXP_2_0, NUM_DCS_P1_D3, 28, 4)
    FIELD(POR_MXP_DEVICE_PORT_CONNECT_INFO_P1_U_SMXP_2_0, NUM_DCS_P1_D2, 24, 4)
    FIELD(POR_MXP_DEVICE_PORT_CONNECT_INFO_P1_U_SMXP_2_0, NUM_DCS_P1_D1, 20, 4)
    FIELD(POR_MXP_DEVICE_PORT_CONNECT_INFO_P1_U_SMXP_2_0, NUM_DCS_P1_D0, 16, 4)
    FIELD(POR_MXP_DEVICE_PORT_CONNECT_INFO_P1_U_SMXP_2_0, DEVICE_TYPE_P1, 0, 5)
REG32(POR_MXP_MESH_PORT_CONNECT_INFO_EAST_U_SMXP_2_0, 0x1008018)
    FIELD(POR_MXP_MESH_PORT_CONNECT_INFO_EAST_U_SMXP_2_0, NUM_MCS_EAST, 0, 4)
REG32(POR_MXP_MESH_PORT_CONNECT_INFO_NORTH_U_SMXP_2_0, 0x1008020)
    FIELD(POR_MXP_MESH_PORT_CONNECT_INFO_NORTH_U_SMXP_2_0, NUM_MCS_NORTH, 0, 4)
REG32(POR_MXP_CHILD_INFO_U_SMXP_2_0, 0x1008080)
    FIELD(POR_MXP_CHILD_INFO_U_SMXP_2_0, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_INFO_U_SMXP_2_0, CHILD_PTR_OFFSET, 16, 16)
    FIELD(POR_MXP_CHILD_INFO_U_SMXP_2_0, CHILD_COUNT, 0, 16)
REG32(POR_MXP_CHILD_POINTER_0_U_SMXP_2_0, 0x1008100)
    FIELD(POR_MXP_CHILD_POINTER_0_U_SMXP_2_0, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_POINTER_0_U_SMXP_2_0, RELATIVE_ADDRESS_0, 0, 32)
REG32(POR_MXP_CHILD_POINTER_1_U_SMXP_2_0, 0x1008108)
    FIELD(POR_MXP_CHILD_POINTER_1_U_SMXP_2_0, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_POINTER_1_U_SMXP_2_0, RELATIVE_ADDRESS_1, 0, 32)
REG32(POR_MXP_CHILD_POINTER_2_U_SMXP_2_0, 0x1008110)
    FIELD(POR_MXP_CHILD_POINTER_2_U_SMXP_2_0, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_POINTER_2_U_SMXP_2_0, RELATIVE_ADDRESS_2, 0, 32)
REG32(POR_MXP_CHILD_POINTER_3_U_SMXP_2_0, 0x1008118)
    FIELD(POR_MXP_CHILD_POINTER_3_U_SMXP_2_0, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_POINTER_3_U_SMXP_2_0, RELATIVE_ADDRESS_3, 0, 32)
REG32(POR_MXP_CHILD_POINTER_4_U_SMXP_2_0, 0x1008120)
    FIELD(POR_MXP_CHILD_POINTER_4_U_SMXP_2_0, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_POINTER_4_U_SMXP_2_0, RELATIVE_ADDRESS_4, 0, 32)
REG32(POR_MXP_CHILD_POINTER_5_U_SMXP_2_0, 0x1008128)
    FIELD(POR_MXP_CHILD_POINTER_5_U_SMXP_2_0, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_POINTER_5_U_SMXP_2_0, RELATIVE_ADDRESS_5, 0, 32)
REG32(POR_MXP_CHILD_POINTER_6_U_SMXP_2_0, 0x1008130)
    FIELD(POR_MXP_CHILD_POINTER_6_U_SMXP_2_0, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_POINTER_6_U_SMXP_2_0, RELATIVE_ADDRESS_6, 0, 32)
REG32(POR_MXP_CHILD_POINTER_7_U_SMXP_2_0, 0x1008138)
    FIELD(POR_MXP_CHILD_POINTER_7_U_SMXP_2_0, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_POINTER_7_U_SMXP_2_0, RELATIVE_ADDRESS_7, 0, 32)
REG32(POR_MXP_CHILD_POINTER_8_U_SMXP_2_0, 0x1008140)
    FIELD(POR_MXP_CHILD_POINTER_8_U_SMXP_2_0, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_POINTER_8_U_SMXP_2_0, RELATIVE_ADDRESS_8, 0, 32)
REG32(POR_MXP_CHILD_POINTER_9_U_SMXP_2_0, 0x1008148)
    FIELD(POR_MXP_CHILD_POINTER_9_U_SMXP_2_0, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_POINTER_9_U_SMXP_2_0, RELATIVE_ADDRESS_9, 0, 32)
REG32(POR_MXP_CHILD_POINTER_10_U_SMXP_2_0, 0x1008150)
    FIELD(POR_MXP_CHILD_POINTER_10_U_SMXP_2_0, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_POINTER_10_U_SMXP_2_0, RELATIVE_ADDRESS_10, 0, 32)
REG32(POR_MXP_CHILD_POINTER_11_U_SMXP_2_0, 0x1008158)
    FIELD(POR_MXP_CHILD_POINTER_11_U_SMXP_2_0, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_POINTER_11_U_SMXP_2_0, RELATIVE_ADDRESS_11, 0, 32)
REG32(POR_MXP_CHILD_POINTER_12_U_SMXP_2_0, 0x1008160)
    FIELD(POR_MXP_CHILD_POINTER_12_U_SMXP_2_0, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_POINTER_12_U_SMXP_2_0, RELATIVE_ADDRESS_12, 0, 32)
REG32(POR_MXP_CHILD_POINTER_13_U_SMXP_2_0, 0x1008168)
    FIELD(POR_MXP_CHILD_POINTER_13_U_SMXP_2_0, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_POINTER_13_U_SMXP_2_0, RELATIVE_ADDRESS_13, 0, 32)
REG32(POR_MXP_CHILD_POINTER_14_U_SMXP_2_0, 0x1008170)
    FIELD(POR_MXP_CHILD_POINTER_14_U_SMXP_2_0, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_POINTER_14_U_SMXP_2_0, RELATIVE_ADDRESS_14, 0, 32)
REG32(POR_MXP_CHILD_POINTER_15_U_SMXP_2_0, 0x1008178)
    FIELD(POR_MXP_CHILD_POINTER_15_U_SMXP_2_0, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_POINTER_15_U_SMXP_2_0, RELATIVE_ADDRESS_15, 0, 32)
REG32(POR_MXP_P0_INFO_U_SMXP_2_0, 0x1008900)
    FIELD(POR_MXP_P0_INFO_U_SMXP_2_0, RESERVED_26, 26, 38)
    FIELD(POR_MXP_P0_INFO_U_SMXP_2_0, A4S_SAFE_XFACE_DISABLE_P0, 25, 1)
    FIELD(POR_MXP_P0_INFO_U_SMXP_2_0, CHI_SAFE_XFACE_DISABLE_P0, 24, 1)
    FIELD(POR_MXP_P0_INFO_U_SMXP_2_0, A4S_LOGICALID_BASE_P0, 16, 8)
    FIELD(POR_MXP_P0_INFO_U_SMXP_2_0, RESERVED_14, 14, 2)
    FIELD(POR_MXP_P0_INFO_U_SMXP_2_0, A4S_NUM_P0, 11, 3)
    FIELD(POR_MXP_P0_INFO_U_SMXP_2_0, RXBUF_NUM_ENTRIES_P0, 8, 3)
    FIELD(POR_MXP_P0_INFO_U_SMXP_2_0, EXT_SAM_EN_P0, 7, 1)
    FIELD(POR_MXP_P0_INFO_U_SMXP_2_0, DATACHECK_EN_P0, 5, 1)
    FIELD(POR_MXP_P0_INFO_U_SMXP_2_0, POISON_EN_P0, 4, 1)
    FIELD(POR_MXP_P0_INFO_U_SMXP_2_0, NUM_DEV_P0, 0, 3)
REG32(POR_MXP_P1_INFO_U_SMXP_2_0, 0x1008908)
    FIELD(POR_MXP_P1_INFO_U_SMXP_2_0, RESERVED_26, 26, 38)
    FIELD(POR_MXP_P1_INFO_U_SMXP_2_0, A4S_SAFE_XFACE_DISABLE_P1, 25, 1)
    FIELD(POR_MXP_P1_INFO_U_SMXP_2_0, CHI_SAFE_XFACE_DISABLE_P1, 24, 1)
    FIELD(POR_MXP_P1_INFO_U_SMXP_2_0, A4S_LOGICALID_BASE_P1, 16, 8)
    FIELD(POR_MXP_P1_INFO_U_SMXP_2_0, RESERVED_14, 14, 2)
    FIELD(POR_MXP_P1_INFO_U_SMXP_2_0, A4S_NUM_P1, 11, 3)
    FIELD(POR_MXP_P1_INFO_U_SMXP_2_0, RXBUF_NUM_ENTRIES_P1, 8, 3)
    FIELD(POR_MXP_P1_INFO_U_SMXP_2_0, EXT_SAM_EN_P1, 7, 1)
    FIELD(POR_MXP_P1_INFO_U_SMXP_2_0, DATACHECK_EN_P1, 5, 1)
    FIELD(POR_MXP_P1_INFO_U_SMXP_2_0, POISON_EN_P1, 4, 1)
    FIELD(POR_MXP_P1_INFO_U_SMXP_2_0, NUM_DEV_P1, 0, 3)
REG32(POR_MXP_SECURE_REGISTER_GROUPS_OVERRIDE_U_SMXP_2_0, 0x1008980)
    FIELD(POR_MXP_SECURE_REGISTER_GROUPS_OVERRIDE_U_SMXP_2_0, SYSCOREQ_CTL, 1, 1)
    FIELD(POR_MXP_SECURE_REGISTER_GROUPS_OVERRIDE_U_SMXP_2_0, QOS, 0, 1)
REG32(POR_MXP_AUX_CTL_U_SMXP_2_0, 0x1008a00)
    FIELD(POR_MXP_AUX_CTL_U_SMXP_2_0, CLKGATE_DISABLE, 0, 1)
REG32(POR_MXP_P0_QOS_CONTROL_U_SMXP_2_0, 0x1008a80)
    FIELD(POR_MXP_P0_QOS_CONTROL_U_SMXP_2_0, RESERVED_20, 20, 44)
    FIELD(POR_MXP_P0_QOS_CONTROL_U_SMXP_2_0, P0_QOS_OVERRIDE, 16, 4)
    FIELD(POR_MXP_P0_QOS_CONTROL_U_SMXP_2_0, P0_PQV_MODE, 6, 1)
    FIELD(POR_MXP_P0_QOS_CONTROL_U_SMXP_2_0, P0_REG_MODE, 4, 1)
    FIELD(POR_MXP_P0_QOS_CONTROL_U_SMXP_2_0, P0_QOS_OVERRIDE_EN, 2, 1)
    FIELD(POR_MXP_P0_QOS_CONTROL_U_SMXP_2_0, P0_LAT_EN, 0, 1)
REG32(POR_MXP_P0_QOS_LAT_TGT_U_SMXP_2_0, 0x1008a88)
    FIELD(POR_MXP_P0_QOS_LAT_TGT_U_SMXP_2_0, RESERVED_12, 12, 52)
    FIELD(POR_MXP_P0_QOS_LAT_TGT_U_SMXP_2_0, P0_LAT_TGT, 0, 12)
REG32(POR_MXP_P0_QOS_LAT_SCALE_U_SMXP_2_0, 0x1008a90)
    FIELD(POR_MXP_P0_QOS_LAT_SCALE_U_SMXP_2_0, P0_LAT_SCALE, 0, 3)
REG32(POR_MXP_P0_QOS_LAT_RANGE_U_SMXP_2_0, 0x1008a98)
    FIELD(POR_MXP_P0_QOS_LAT_RANGE_U_SMXP_2_0, RESERVED_12, 12, 52)
    FIELD(POR_MXP_P0_QOS_LAT_RANGE_U_SMXP_2_0, P0_LAT_MAX_QOS, 8, 4)
    FIELD(POR_MXP_P0_QOS_LAT_RANGE_U_SMXP_2_0, P0_LAT_MIN_QOS, 0, 4)
REG32(POR_MXP_P1_QOS_CONTROL_U_SMXP_2_0, 0x1008aa0)
    FIELD(POR_MXP_P1_QOS_CONTROL_U_SMXP_2_0, RESERVED_20, 20, 44)
    FIELD(POR_MXP_P1_QOS_CONTROL_U_SMXP_2_0, P1_QOS_OVERRIDE, 16, 4)
    FIELD(POR_MXP_P1_QOS_CONTROL_U_SMXP_2_0, P1_PQV_MODE, 6, 1)
    FIELD(POR_MXP_P1_QOS_CONTROL_U_SMXP_2_0, P1_REG_MODE, 4, 1)
    FIELD(POR_MXP_P1_QOS_CONTROL_U_SMXP_2_0, P1_QOS_OVERRIDE_EN, 2, 1)
    FIELD(POR_MXP_P1_QOS_CONTROL_U_SMXP_2_0, P1_LAT_EN, 0, 1)
REG32(POR_MXP_P1_QOS_LAT_TGT_U_SMXP_2_0, 0x1008aa8)
    FIELD(POR_MXP_P1_QOS_LAT_TGT_U_SMXP_2_0, RESERVED_12, 12, 52)
    FIELD(POR_MXP_P1_QOS_LAT_TGT_U_SMXP_2_0, P1_LAT_TGT, 0, 12)
REG32(POR_MXP_P1_QOS_LAT_SCALE_U_SMXP_2_0, 0x1008ab0)
    FIELD(POR_MXP_P1_QOS_LAT_SCALE_U_SMXP_2_0, P1_LAT_SCALE, 0, 3)
REG32(POR_MXP_P1_QOS_LAT_RANGE_U_SMXP_2_0, 0x1008ab8)
    FIELD(POR_MXP_P1_QOS_LAT_RANGE_U_SMXP_2_0, RESERVED_12, 12, 52)
    FIELD(POR_MXP_P1_QOS_LAT_RANGE_U_SMXP_2_0, P1_LAT_MAX_QOS, 8, 4)
    FIELD(POR_MXP_P1_QOS_LAT_RANGE_U_SMXP_2_0, P1_LAT_MIN_QOS, 0, 4)
REG32(POR_MXP_P0_SYSCOREQ_CTL_U_SMXP_2_0, 0x1009000)
    FIELD(POR_MXP_P0_SYSCOREQ_CTL_U_SMXP_2_0, SNPDVM_REQ_P0_D3, 3, 1)
    FIELD(POR_MXP_P0_SYSCOREQ_CTL_U_SMXP_2_0, SNPDVM_REQ_P0_D2, 2, 1)
    FIELD(POR_MXP_P0_SYSCOREQ_CTL_U_SMXP_2_0, SNPDVM_REQ_P0_D1, 1, 1)
    FIELD(POR_MXP_P0_SYSCOREQ_CTL_U_SMXP_2_0, SNPDVM_REQ_P0_D0, 0, 1)
REG32(POR_MXP_P1_SYSCOREQ_CTL_U_SMXP_2_0, 0x1009008)
    FIELD(POR_MXP_P1_SYSCOREQ_CTL_U_SMXP_2_0, SNPDVM_REQ_P1_D3, 3, 1)
    FIELD(POR_MXP_P1_SYSCOREQ_CTL_U_SMXP_2_0, SNPDVM_REQ_P1_D2, 2, 1)
    FIELD(POR_MXP_P1_SYSCOREQ_CTL_U_SMXP_2_0, SNPDVM_REQ_P1_D1, 1, 1)
    FIELD(POR_MXP_P1_SYSCOREQ_CTL_U_SMXP_2_0, SNPDVM_REQ_P1_D0, 0, 1)
REG32(POR_MXP_P0_SYSCOACK_STATUS_U_SMXP_2_0, 0x1009010)
    FIELD(POR_MXP_P0_SYSCOACK_STATUS_U_SMXP_2_0, SNPDVM_ACK_P0_D3, 3, 1)
    FIELD(POR_MXP_P0_SYSCOACK_STATUS_U_SMXP_2_0, SNPDVM_ACK_P0_D2, 2, 1)
    FIELD(POR_MXP_P0_SYSCOACK_STATUS_U_SMXP_2_0, SNPDVM_ACK_P0_D1, 1, 1)
    FIELD(POR_MXP_P0_SYSCOACK_STATUS_U_SMXP_2_0, SNPDVM_ACK_P0_D0, 0, 1)
REG32(POR_MXP_P1_SYSCOACK_STATUS_U_SMXP_2_0, 0x1009018)
    FIELD(POR_MXP_P1_SYSCOACK_STATUS_U_SMXP_2_0, SNPDVM_ACK_P1_D3, 3, 1)
    FIELD(POR_MXP_P1_SYSCOACK_STATUS_U_SMXP_2_0, SNPDVM_ACK_P1_D2, 2, 1)
    FIELD(POR_MXP_P1_SYSCOACK_STATUS_U_SMXP_2_0, SNPDVM_ACK_P1_D1, 1, 1)
    FIELD(POR_MXP_P1_SYSCOACK_STATUS_U_SMXP_2_0, SNPDVM_ACK_P1_D0, 0, 1)
REG32(POR_MXP_PMU_EVENT_SEL_U_SMXP_2_0, 0x100a000)
    FIELD(POR_MXP_PMU_EVENT_SEL_U_SMXP_2_0, RESERVED_32, 32, 32)
    FIELD(POR_MXP_PMU_EVENT_SEL_U_SMXP_2_0, PMU_EVENT3_ID, 24, 8)
    FIELD(POR_MXP_PMU_EVENT_SEL_U_SMXP_2_0, PMU_EVENT2_ID, 16, 8)
    FIELD(POR_MXP_PMU_EVENT_SEL_U_SMXP_2_0, PMU_EVENT1_ID, 8, 8)
    FIELD(POR_MXP_PMU_EVENT_SEL_U_SMXP_2_0, PMU_EVENT0_ID, 0, 8)
REG32(POR_DTM_CONTROL_U_SMXP_2_0, 0x100a100)
    FIELD(POR_DTM_CONTROL_U_SMXP_2_0, TRACE_NO_ATB, 3, 1)
    FIELD(POR_DTM_CONTROL_U_SMXP_2_0, SAMPLE_PROFILE_ENABLE, 2, 1)
    FIELD(POR_DTM_CONTROL_U_SMXP_2_0, TRACE_TAG_ENABLE, 1, 1)
    FIELD(POR_DTM_CONTROL_U_SMXP_2_0, DTM_ENABLE, 0, 1)
REG32(POR_DTM_FIFO_ENTRY_READY_U_SMXP_2_0, 0x100a118)
    FIELD(POR_DTM_FIFO_ENTRY_READY_U_SMXP_2_0, READY, 0, 4)
REG32(POR_DTM_FIFO_ENTRY0_0_U_SMXP_2_0, 0x100a120)
REG32(POR_DTM_FIFO_ENTRY0_1_U_SMXP_2_0, 0x100a128)
REG32(POR_DTM_FIFO_ENTRY0_2_U_SMXP_2_0, 0x100a130)
    FIELD(POR_DTM_FIFO_ENTRY0_2_U_SMXP_2_0, RESERVED_32, 32, 32)
    FIELD(POR_DTM_FIFO_ENTRY0_2_U_SMXP_2_0, FIFO_CYCLE_COUNT, 16, 16)
    FIELD(POR_DTM_FIFO_ENTRY0_2_U_SMXP_2_0, FIFO_DATA2, 0, 16)
REG32(POR_DTM_FIFO_ENTRY1_0_U_SMXP_2_0, 0x100a138)
REG32(POR_DTM_FIFO_ENTRY1_1_U_SMXP_2_0, 0x100a140)
REG32(POR_DTM_FIFO_ENTRY1_2_U_SMXP_2_0, 0x100a148)
    FIELD(POR_DTM_FIFO_ENTRY1_2_U_SMXP_2_0, RESERVED_32, 32, 32)
    FIELD(POR_DTM_FIFO_ENTRY1_2_U_SMXP_2_0, FIFO_CYCLE_COUNT, 16, 16)
    FIELD(POR_DTM_FIFO_ENTRY1_2_U_SMXP_2_0, FIFO_DATA2, 0, 16)
REG32(POR_DTM_FIFO_ENTRY2_0_U_SMXP_2_0, 0x100a150)
REG32(POR_DTM_FIFO_ENTRY2_1_U_SMXP_2_0, 0x100a158)
REG32(POR_DTM_FIFO_ENTRY2_2_U_SMXP_2_0, 0x100a160)
    FIELD(POR_DTM_FIFO_ENTRY2_2_U_SMXP_2_0, RESERVED_32, 32, 32)
    FIELD(POR_DTM_FIFO_ENTRY2_2_U_SMXP_2_0, FIFO_CYCLE_COUNT, 16, 16)
    FIELD(POR_DTM_FIFO_ENTRY2_2_U_SMXP_2_0, FIFO_DATA2, 0, 16)
REG32(POR_DTM_FIFO_ENTRY3_0_U_SMXP_2_0, 0x100a168)
REG32(POR_DTM_FIFO_ENTRY3_1_U_SMXP_2_0, 0x100a170)
REG32(POR_DTM_FIFO_ENTRY3_2_U_SMXP_2_0, 0x100a178)
    FIELD(POR_DTM_FIFO_ENTRY3_2_U_SMXP_2_0, RESERVED_32, 32, 32)
    FIELD(POR_DTM_FIFO_ENTRY3_2_U_SMXP_2_0, FIFO_CYCLE_COUNT, 16, 16)
    FIELD(POR_DTM_FIFO_ENTRY3_2_U_SMXP_2_0, FIFO_DATA2, 0, 16)
REG32(POR_DTM_WP0_CONFIG_U_SMXP_2_0, 0x100a1a0)
    FIELD(POR_DTM_WP0_CONFIG_U_SMXP_2_0, RESERVED_15, 15, 49)
    FIELD(POR_DTM_WP0_CONFIG_U_SMXP_2_0, WP_DBGTRIG_EN, 14, 1)
    FIELD(POR_DTM_WP0_CONFIG_U_SMXP_2_0, WP_CTRIG_EN, 13, 1)
    FIELD(POR_DTM_WP0_CONFIG_U_SMXP_2_0, WP_CC_EN, 12, 1)
    FIELD(POR_DTM_WP0_CONFIG_U_SMXP_2_0, WP_PKT_TYPE, 9, 3)
    FIELD(POR_DTM_WP0_CONFIG_U_SMXP_2_0, WP_PKT_GEN, 8, 1)
    FIELD(POR_DTM_WP0_CONFIG_U_SMXP_2_0, WP_COMBINE, 6, 1)
    FIELD(POR_DTM_WP0_CONFIG_U_SMXP_2_0, WP_EXCLUSIVE, 5, 1)
    FIELD(POR_DTM_WP0_CONFIG_U_SMXP_2_0, WP_GRP, 4, 1)
    FIELD(POR_DTM_WP0_CONFIG_U_SMXP_2_0, WP_CHN_SEL, 1, 3)
    FIELD(POR_DTM_WP0_CONFIG_U_SMXP_2_0, WP_DEV_SEL, 0, 1)
REG32(POR_DTM_WP0_VAL_U_SMXP_2_0, 0x100a1a8)
REG32(POR_DTM_WP0_MASK_U_SMXP_2_0, 0x100a1b0)
REG32(POR_DTM_WP1_CONFIG_U_SMXP_2_0, 0x100a1b8)
    FIELD(POR_DTM_WP1_CONFIG_U_SMXP_2_0, RESERVED_15, 15, 49)
    FIELD(POR_DTM_WP1_CONFIG_U_SMXP_2_0, WP_DBGTRIG_EN, 14, 1)
    FIELD(POR_DTM_WP1_CONFIG_U_SMXP_2_0, WP_CTRIG_EN, 13, 1)
    FIELD(POR_DTM_WP1_CONFIG_U_SMXP_2_0, WP_CC_EN, 12, 1)
    FIELD(POR_DTM_WP1_CONFIG_U_SMXP_2_0, WP_PKT_TYPE, 9, 3)
    FIELD(POR_DTM_WP1_CONFIG_U_SMXP_2_0, WP_PKT_GEN, 8, 1)
    FIELD(POR_DTM_WP1_CONFIG_U_SMXP_2_0, WP_EXCLUSIVE, 5, 1)
    FIELD(POR_DTM_WP1_CONFIG_U_SMXP_2_0, WP_GRP, 4, 1)
    FIELD(POR_DTM_WP1_CONFIG_U_SMXP_2_0, WP_CHN_SEL, 1, 3)
    FIELD(POR_DTM_WP1_CONFIG_U_SMXP_2_0, WP_DEV_SEL, 0, 1)
REG32(POR_DTM_WP1_VAL_U_SMXP_2_0, 0x100a1c0)
REG32(POR_DTM_WP1_MASK_U_SMXP_2_0, 0x100a1c8)
REG32(POR_DTM_WP2_CONFIG_U_SMXP_2_0, 0x100a1d0)
    FIELD(POR_DTM_WP2_CONFIG_U_SMXP_2_0, RESERVED_15, 15, 49)
    FIELD(POR_DTM_WP2_CONFIG_U_SMXP_2_0, WP_DBGTRIG_EN, 14, 1)
    FIELD(POR_DTM_WP2_CONFIG_U_SMXP_2_0, WP_CTRIG_EN, 13, 1)
    FIELD(POR_DTM_WP2_CONFIG_U_SMXP_2_0, WP_CC_EN, 12, 1)
    FIELD(POR_DTM_WP2_CONFIG_U_SMXP_2_0, WP_PKT_TYPE, 9, 3)
    FIELD(POR_DTM_WP2_CONFIG_U_SMXP_2_0, WP_PKT_GEN, 8, 1)
    FIELD(POR_DTM_WP2_CONFIG_U_SMXP_2_0, WP_COMBINE, 6, 1)
    FIELD(POR_DTM_WP2_CONFIG_U_SMXP_2_0, WP_EXCLUSIVE, 5, 1)
    FIELD(POR_DTM_WP2_CONFIG_U_SMXP_2_0, WP_GRP, 4, 1)
    FIELD(POR_DTM_WP2_CONFIG_U_SMXP_2_0, WP_CHN_SEL, 1, 3)
    FIELD(POR_DTM_WP2_CONFIG_U_SMXP_2_0, WP_DEV_SEL, 0, 1)
REG32(POR_DTM_WP2_VAL_U_SMXP_2_0, 0x100a1d8)
REG32(POR_DTM_WP2_MASK_U_SMXP_2_0, 0x100a1e0)
REG32(POR_DTM_WP3_CONFIG_U_SMXP_2_0, 0x100a1e8)
    FIELD(POR_DTM_WP3_CONFIG_U_SMXP_2_0, RESERVED_15, 15, 49)
    FIELD(POR_DTM_WP3_CONFIG_U_SMXP_2_0, WP_DBGTRIG_EN, 14, 1)
    FIELD(POR_DTM_WP3_CONFIG_U_SMXP_2_0, WP_CTRIG_EN, 13, 1)
    FIELD(POR_DTM_WP3_CONFIG_U_SMXP_2_0, WP_CC_EN, 12, 1)
    FIELD(POR_DTM_WP3_CONFIG_U_SMXP_2_0, WP_PKT_TYPE, 9, 3)
    FIELD(POR_DTM_WP3_CONFIG_U_SMXP_2_0, WP_PKT_GEN, 8, 1)
    FIELD(POR_DTM_WP3_CONFIG_U_SMXP_2_0, WP_EXCLUSIVE, 5, 1)
    FIELD(POR_DTM_WP3_CONFIG_U_SMXP_2_0, WP_GRP, 4, 1)
    FIELD(POR_DTM_WP3_CONFIG_U_SMXP_2_0, WP_CHN_SEL, 1, 3)
    FIELD(POR_DTM_WP3_CONFIG_U_SMXP_2_0, WP_DEV_SEL, 0, 1)
REG32(POR_DTM_WP3_VAL_U_SMXP_2_0, 0x100a1f0)
REG32(POR_DTM_WP3_MASK_U_SMXP_2_0, 0x100a1f8)
REG32(POR_DTM_PMSICR_U_SMXP_2_0, 0x100a200)
    FIELD(POR_DTM_PMSICR_U_SMXP_2_0, RESERVED_32, 32, 32)
    FIELD(POR_DTM_PMSICR_U_SMXP_2_0, COUNT, 0, 32)
REG32(POR_DTM_PMSIRR_U_SMXP_2_0, 0x100a208)
    FIELD(POR_DTM_PMSIRR_U_SMXP_2_0, RESERVED_32, 32, 32)
    FIELD(POR_DTM_PMSIRR_U_SMXP_2_0, INTERVAL, 8, 24)
    FIELD(POR_DTM_PMSIRR_U_SMXP_2_0, RESERVED_0, 0, 8)
REG32(POR_DTM_PMU_CONFIG_U_SMXP_2_0, 0x100a210)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_2_0, RESERVED_62, 62, 2)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_2_0, PMEVCNT3_INPUT_SEL, 56, 6)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_2_0, RESERVED_54, 54, 2)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_2_0, PMEVCNT2_INPUT_SEL, 48, 6)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_2_0, RESERVED_46, 46, 2)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_2_0, PMEVCNT1_INPUT_SEL, 40, 6)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_2_0, RESERVED_38, 38, 2)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_2_0, PMEVCNT0_INPUT_SEL, 32, 6)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_2_0, RESERVED_31, 31, 1)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_2_0, PMEVCNT3_GLOBAL_NUM, 28, 3)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_2_0, RESERVED_27, 27, 1)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_2_0, PMEVCNT2_GLOBAL_NUM, 24, 3)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_2_0, RESERVED_23, 23, 1)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_2_0, PMEVCNT1_GLOBAL_NUM, 20, 3)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_2_0, RESERVED_19, 19, 1)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_2_0, PMEVCNT0_GLOBAL_NUM, 16, 3)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_2_0, RESERVED_9, 9, 7)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_2_0, CNTR_RST, 8, 1)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_2_0, PMEVCNT_PAIRED, 4, 4)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_2_0, PMEVCNTALL_COMBINED, 3, 1)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_2_0, PMEVCNT23_COMBINED, 2, 1)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_2_0, PMEVCNT01_COMBINED, 1, 1)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_2_0, PMU_EN, 0, 1)
REG32(POR_DTM_PMEVCNT_U_SMXP_2_0, 0x100a220)
    FIELD(POR_DTM_PMEVCNT_U_SMXP_2_0, PMEVCNT3, 48, 16)
    FIELD(POR_DTM_PMEVCNT_U_SMXP_2_0, PMEVCNT2, 32, 16)
    FIELD(POR_DTM_PMEVCNT_U_SMXP_2_0, PMEVCNT1, 16, 16)
    FIELD(POR_DTM_PMEVCNT_U_SMXP_2_0, PMEVCNT0, 0, 16)
REG32(POR_DTM_PMEVCNTSR_U_SMXP_2_0, 0x100a240)
    FIELD(POR_DTM_PMEVCNTSR_U_SMXP_2_0, PMEVCNTSR3, 48, 16)
    FIELD(POR_DTM_PMEVCNTSR_U_SMXP_2_0, PMEVCNTSR2, 32, 16)
    FIELD(POR_DTM_PMEVCNTSR_U_SMXP_2_0, PMEVCNTSR1, 16, 16)
    FIELD(POR_DTM_PMEVCNTSR_U_SMXP_2_0, PMEVCNTSR0, 0, 16)
REG32(POR_MXP_ERRFR_U_SMXP_2_0, 0x100b000)
    FIELD(POR_MXP_ERRFR_U_SMXP_2_0, RESERVED_15, 15, 49)
    FIELD(POR_MXP_ERRFR_U_SMXP_2_0, CEC, 12, 3)
    FIELD(POR_MXP_ERRFR_U_SMXP_2_0, CFI, 10, 2)
    FIELD(POR_MXP_ERRFR_U_SMXP_2_0, FI, 6, 2)
    FIELD(POR_MXP_ERRFR_U_SMXP_2_0, UI, 4, 2)
    FIELD(POR_MXP_ERRFR_U_SMXP_2_0, DE, 2, 2)
    FIELD(POR_MXP_ERRFR_U_SMXP_2_0, ED, 0, 2)
REG32(POR_MXP_ERRCTLR_U_SMXP_2_0, 0x100b008)
    FIELD(POR_MXP_ERRCTLR_U_SMXP_2_0, RESERVED_9, 9, 55)
    FIELD(POR_MXP_ERRCTLR_U_SMXP_2_0, CFI, 8, 1)
    FIELD(POR_MXP_ERRCTLR_U_SMXP_2_0, FI, 3, 1)
    FIELD(POR_MXP_ERRCTLR_U_SMXP_2_0, UI, 2, 1)
    FIELD(POR_MXP_ERRCTLR_U_SMXP_2_0, DE, 1, 1)
    FIELD(POR_MXP_ERRCTLR_U_SMXP_2_0, ED, 0, 1)
REG32(POR_MXP_ERRSTATUS_U_SMXP_2_0, 0x100b010)
    FIELD(POR_MXP_ERRSTATUS_U_SMXP_2_0, RESERVED_32, 32, 32)
    FIELD(POR_MXP_ERRSTATUS_U_SMXP_2_0, AV, 31, 1)
    FIELD(POR_MXP_ERRSTATUS_U_SMXP_2_0, V, 30, 1)
    FIELD(POR_MXP_ERRSTATUS_U_SMXP_2_0, UE, 29, 1)
    FIELD(POR_MXP_ERRSTATUS_U_SMXP_2_0, RESERVED_28, 28, 1)
    FIELD(POR_MXP_ERRSTATUS_U_SMXP_2_0, OF, 27, 1)
    FIELD(POR_MXP_ERRSTATUS_U_SMXP_2_0, MV, 26, 1)
    FIELD(POR_MXP_ERRSTATUS_U_SMXP_2_0, RESERVED_25, 25, 1)
    FIELD(POR_MXP_ERRSTATUS_U_SMXP_2_0, CE, 24, 1)
    FIELD(POR_MXP_ERRSTATUS_U_SMXP_2_0, DE, 23, 1)
    FIELD(POR_MXP_ERRSTATUS_U_SMXP_2_0, RESERVED_0, 0, 23)
REG32(POR_MXP_ERRMISC_U_SMXP_2_0, 0x100b028)
    FIELD(POR_MXP_ERRMISC_U_SMXP_2_0, RESERVED_59, 59, 5)
    FIELD(POR_MXP_ERRMISC_U_SMXP_2_0, TGTID, 48, 11)
    FIELD(POR_MXP_ERRMISC_U_SMXP_2_0, RESERVED_22, 22, 26)
    FIELD(POR_MXP_ERRMISC_U_SMXP_2_0, OPCODE, 16, 6)
    FIELD(POR_MXP_ERRMISC_U_SMXP_2_0, RESERVED_15, 15, 1)
    FIELD(POR_MXP_ERRMISC_U_SMXP_2_0, SRCID, 4, 11)
    FIELD(POR_MXP_ERRMISC_U_SMXP_2_0, ERRSRC, 0, 3)
REG32(POR_MXP_P0_BYTE_PAR_ERR_INJ_U_SMXP_2_0, 0x100b030)
    FIELD(POR_MXP_P0_BYTE_PAR_ERR_INJ_U_SMXP_2_0, P0_BYTE_PARITY_ERR_INJ, 0, 5)
REG32(POR_MXP_P1_BYTE_PAR_ERR_INJ_U_SMXP_2_0, 0x100b038)
    FIELD(POR_MXP_P1_BYTE_PAR_ERR_INJ_U_SMXP_2_0, P1_BYTE_PARITY_ERR_INJ, 0, 5)
REG32(POR_MXP_ERRFR_NS_U_SMXP_2_0, 0x100b100)
    FIELD(POR_MXP_ERRFR_NS_U_SMXP_2_0, RESERVED_15, 15, 49)
    FIELD(POR_MXP_ERRFR_NS_U_SMXP_2_0, CEC, 12, 3)
    FIELD(POR_MXP_ERRFR_NS_U_SMXP_2_0, CFI, 10, 2)
    FIELD(POR_MXP_ERRFR_NS_U_SMXP_2_0, FI, 6, 2)
    FIELD(POR_MXP_ERRFR_NS_U_SMXP_2_0, UI, 4, 2)
    FIELD(POR_MXP_ERRFR_NS_U_SMXP_2_0, DE, 2, 2)
    FIELD(POR_MXP_ERRFR_NS_U_SMXP_2_0, ED, 0, 2)
REG32(POR_MXP_ERRCTLR_NS_U_SMXP_2_0, 0x100b108)
    FIELD(POR_MXP_ERRCTLR_NS_U_SMXP_2_0, RESERVED_9, 9, 55)
    FIELD(POR_MXP_ERRCTLR_NS_U_SMXP_2_0, CFI, 8, 1)
    FIELD(POR_MXP_ERRCTLR_NS_U_SMXP_2_0, FI, 3, 1)
    FIELD(POR_MXP_ERRCTLR_NS_U_SMXP_2_0, UI, 2, 1)
    FIELD(POR_MXP_ERRCTLR_NS_U_SMXP_2_0, DE, 1, 1)
    FIELD(POR_MXP_ERRCTLR_NS_U_SMXP_2_0, ED, 0, 1)
REG32(POR_MXP_ERRSTATUS_NS_U_SMXP_2_0, 0x100b110)
    FIELD(POR_MXP_ERRSTATUS_NS_U_SMXP_2_0, RESERVED_32, 32, 32)
    FIELD(POR_MXP_ERRSTATUS_NS_U_SMXP_2_0, AV, 31, 1)
    FIELD(POR_MXP_ERRSTATUS_NS_U_SMXP_2_0, V, 30, 1)
    FIELD(POR_MXP_ERRSTATUS_NS_U_SMXP_2_0, UE, 29, 1)
    FIELD(POR_MXP_ERRSTATUS_NS_U_SMXP_2_0, RESERVED_28, 28, 1)
    FIELD(POR_MXP_ERRSTATUS_NS_U_SMXP_2_0, OF, 27, 1)
    FIELD(POR_MXP_ERRSTATUS_NS_U_SMXP_2_0, MV, 26, 1)
    FIELD(POR_MXP_ERRSTATUS_NS_U_SMXP_2_0, RESERVED_25, 25, 1)
    FIELD(POR_MXP_ERRSTATUS_NS_U_SMXP_2_0, CE, 24, 1)
    FIELD(POR_MXP_ERRSTATUS_NS_U_SMXP_2_0, DE, 23, 1)
    FIELD(POR_MXP_ERRSTATUS_NS_U_SMXP_2_0, RESERVED_0, 0, 23)
REG32(POR_MXP_ERRMISC_NS_U_SMXP_2_0, 0x100b128)
    FIELD(POR_MXP_ERRMISC_NS_U_SMXP_2_0, RESERVED_59, 59, 5)
    FIELD(POR_MXP_ERRMISC_NS_U_SMXP_2_0, TGTID, 48, 11)
    FIELD(POR_MXP_ERRMISC_NS_U_SMXP_2_0, RESERVED_22, 22, 26)
    FIELD(POR_MXP_ERRMISC_NS_U_SMXP_2_0, OPCODE, 16, 6)
    FIELD(POR_MXP_ERRMISC_NS_U_SMXP_2_0, RESERVED_15, 15, 1)
    FIELD(POR_MXP_ERRMISC_NS_U_SMXP_2_0, SRCID, 4, 11)
    FIELD(POR_MXP_ERRMISC_NS_U_SMXP_2_0, ERRSRC, 0, 3)
REG32(POR_RNI_NODE_INFO_U_RNI_NID132, 0x1014000)
    FIELD(POR_RNI_NODE_INFO_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_RNI_NODE_INFO_U_RNI_NID132, LOGICAL_ID, 32, 16)
    FIELD(POR_RNI_NODE_INFO_U_RNI_NID132, NODE_ID, 16, 16)
    FIELD(POR_RNI_NODE_INFO_U_RNI_NID132, NODE_TYPE, 0, 16)
REG32(POR_RNI_CHILD_INFO_U_RNI_NID132, 0x1014080)
    FIELD(POR_RNI_CHILD_INFO_U_RNI_NID132, RESERVED_32, 32, 32)
    FIELD(POR_RNI_CHILD_INFO_U_RNI_NID132, CHILD_PTR_OFFSET, 16, 16)
    FIELD(POR_RNI_CHILD_INFO_U_RNI_NID132, CHILD_COUNT, 0, 16)
REG32(POR_RNI_UNIT_INFO_U_RNI_NID132, 0x1014900)
    FIELD(POR_RNI_UNIT_INFO_U_RNI_NID132, RESERVED_46, 46, 18)
    FIELD(POR_RNI_UNIT_INFO_U_RNI_NID132, A4S_SAFE_XFACE_DISABLE, 45, 1)
    FIELD(POR_RNI_UNIT_INFO_U_RNI_NID132, ACEL_SAFE_XFACE_DISABLE, 44, 1)
    FIELD(POR_RNI_UNIT_INFO_U_RNI_NID132, A4S_LOGICALID_BASE, 36, 8)
    FIELD(POR_RNI_UNIT_INFO_U_RNI_NID132, RESERVED_34, 34, 2)
    FIELD(POR_RNI_UNIT_INFO_U_RNI_NID132, A4S_NUM, 32, 2)
    FIELD(POR_RNI_UNIT_INFO_U_RNI_NID132, RESERVED_29, 29, 3)
    FIELD(POR_RNI_UNIT_INFO_U_RNI_NID132, FORCE_RDB_PREALLOC, 28, 1)
    FIELD(POR_RNI_UNIT_INFO_U_RNI_NID132, AX_DATAPOISON_EN, 27, 1)
    FIELD(POR_RNI_UNIT_INFO_U_RNI_NID132, AX_DATA_256BIT, 26, 1)
    FIELD(POR_RNI_UNIT_INFO_U_RNI_NID132, RESERVED_24, 24, 2)
    FIELD(POR_RNI_UNIT_INFO_U_RNI_NID132, NUM_RD_BUFS, 16, 8)
    FIELD(POR_RNI_UNIT_INFO_U_RNI_NID132, NUM_RD_REQS, 8, 8)
    FIELD(POR_RNI_UNIT_INFO_U_RNI_NID132, NUM_WR_REQS, 0, 8)
REG32(POR_RNI_SECURE_REGISTER_GROUPS_OVERRIDE_U_RNI_NID132, 0x1014980)
    FIELD(POR_RNI_SECURE_REGISTER_GROUPS_OVERRIDE_U_RNI_NID132, QOS_CTRL, 2, 1)
    FIELD(POR_RNI_SECURE_REGISTER_GROUPS_OVERRIDE_U_RNI_NID132, PORT_CTRL, 1, 1)
    FIELD(POR_RNI_SECURE_REGISTER_GROUPS_OVERRIDE_U_RNI_NID132, CFG_CTL, 0, 1)
REG32(POR_RNI_CFG_CTL_U_RNI_NID132, 0x1014a00)
    FIELD(POR_RNI_CFG_CTL_U_RNI_NID132, RESERVED_32, 32, 32)
    FIELD(POR_RNI_CFG_CTL_U_RNI_NID132, MAX_WRT_OUTSTD_CHITXN_CNT, 24, 8)
    FIELD(POR_RNI_CFG_CTL_U_RNI_NID132, MAX_RRT_OUTSTD_CHITXN_CNT, 16, 8)
    FIELD(POR_RNI_CFG_CTL_U_RNI_NID132, RESERVED_15, 15, 1)
    FIELD(POR_RNI_CFG_CTL_U_RNI_NID132, WRT_CRDGNT_WEIGHT, 12, 3)
    FIELD(POR_RNI_CFG_CTL_U_RNI_NID132, RESERVED_11, 11, 1)
    FIELD(POR_RNI_CFG_CTL_U_RNI_NID132, RRT_CRDGNT_WEIGHT, 8, 3)
    FIELD(POR_RNI_CFG_CTL_U_RNI_NID132, DIS_NCWR_STREAM, 6, 1)
    FIELD(POR_RNI_CFG_CTL_U_RNI_NID132, PCIE_MSTR_PRESENT, 5, 1)
    FIELD(POR_RNI_CFG_CTL_U_RNI_NID132, QPC15_ENTRY_RSV_EN, 4, 1)
    FIELD(POR_RNI_CFG_CTL_U_RNI_NID132, FORCE_PREALLOC_RDB, 3, 1)
    FIELD(POR_RNI_CFG_CTL_U_RNI_NID132, DIS_WR_STREAM, 2, 1)
    FIELD(POR_RNI_CFG_CTL_U_RNI_NID132, WFC, 1, 1)
    FIELD(POR_RNI_CFG_CTL_U_RNI_NID132, QPC_EN, 0, 1)
REG32(POR_RNI_AUX_CTL_U_RNI_NID132, 0x1014a08)
    FIELD(POR_RNI_AUX_CTL_U_RNI_NID132, SAMEID_WRSTASH_STREAM_EN, 5, 1)
    FIELD(POR_RNI_AUX_CTL_U_RNI_NID132, UPSTRM_DATCHECK_EN, 4, 1)
    FIELD(POR_RNI_AUX_CTL_U_RNI_NID132, DIS_NORM_RDSTREAM, 3, 1)
    FIELD(POR_RNI_AUX_CTL_U_RNI_NID132, PARK_PORT_ARB_PTR, 2, 1)
    FIELD(POR_RNI_AUX_CTL_U_RNI_NID132, AR_BYP_EN, 1, 1)
    FIELD(POR_RNI_AUX_CTL_U_RNI_NID132, CG_DISABLE, 0, 1)
REG32(POR_RNI_S0_PORT_CONTROL_U_RNI_NID132, 0x1014a10)
    FIELD(POR_RNI_S0_PORT_CONTROL_U_RNI_NID132, RESERVED_11, 11, 53)
    FIELD(POR_RNI_S0_PORT_CONTROL_U_RNI_NID132, S0_LPID_MASK, 0, 11)
REG32(POR_RNI_S1_PORT_CONTROL_U_RNI_NID132, 0x1014a18)
    FIELD(POR_RNI_S1_PORT_CONTROL_U_RNI_NID132, RESERVED_11, 11, 53)
    FIELD(POR_RNI_S1_PORT_CONTROL_U_RNI_NID132, S1_LPID_MASK, 0, 11)
REG32(POR_RNI_S2_PORT_CONTROL_U_RNI_NID132, 0x1014a20)
    FIELD(POR_RNI_S2_PORT_CONTROL_U_RNI_NID132, RESERVED_11, 11, 53)
    FIELD(POR_RNI_S2_PORT_CONTROL_U_RNI_NID132, S2_LPID_MASK, 0, 11)
REG32(POR_RNI_S0_QOS_CONTROL_U_RNI_NID132, 0x1014a80)
    FIELD(POR_RNI_S0_QOS_CONTROL_U_RNI_NID132, RESERVED_24, 24, 40)
    FIELD(POR_RNI_S0_QOS_CONTROL_U_RNI_NID132, S0_AR_QOS_OVERRIDE, 20, 4)
    FIELD(POR_RNI_S0_QOS_CONTROL_U_RNI_NID132, S0_AW_QOS_OVERRIDE, 16, 4)
    FIELD(POR_RNI_S0_QOS_CONTROL_U_RNI_NID132, S0_AR_PQV_MODE, 7, 1)
    FIELD(POR_RNI_S0_QOS_CONTROL_U_RNI_NID132, S0_AW_PQV_MODE, 6, 1)
    FIELD(POR_RNI_S0_QOS_CONTROL_U_RNI_NID132, S0_AR_REG_MODE, 5, 1)
    FIELD(POR_RNI_S0_QOS_CONTROL_U_RNI_NID132, S0_AW_REG_MODE, 4, 1)
    FIELD(POR_RNI_S0_QOS_CONTROL_U_RNI_NID132, S0_AR_QOS_OVERRIDE_EN, 3, 1)
    FIELD(POR_RNI_S0_QOS_CONTROL_U_RNI_NID132, S0_AW_QOS_OVERRIDE_EN, 2, 1)
    FIELD(POR_RNI_S0_QOS_CONTROL_U_RNI_NID132, S0_AR_LAT_EN, 1, 1)
    FIELD(POR_RNI_S0_QOS_CONTROL_U_RNI_NID132, S0_AW_LAT_EN, 0, 1)
REG32(POR_RNI_S0_QOS_LAT_TGT_U_RNI_NID132, 0x1014a88)
    FIELD(POR_RNI_S0_QOS_LAT_TGT_U_RNI_NID132, RESERVED_28, 28, 36)
    FIELD(POR_RNI_S0_QOS_LAT_TGT_U_RNI_NID132, S0_AR_LAT_TGT, 16, 12)
    FIELD(POR_RNI_S0_QOS_LAT_TGT_U_RNI_NID132, RESERVED_12, 12, 4)
    FIELD(POR_RNI_S0_QOS_LAT_TGT_U_RNI_NID132, S0_AW_LAT_TGT, 0, 12)
REG32(POR_RNI_S0_QOS_LAT_SCALE_U_RNI_NID132, 0x1014a90)
    FIELD(POR_RNI_S0_QOS_LAT_SCALE_U_RNI_NID132, RESERVED_11, 11, 53)
    FIELD(POR_RNI_S0_QOS_LAT_SCALE_U_RNI_NID132, S0_AR_LAT_SCALE, 8, 3)
    FIELD(POR_RNI_S0_QOS_LAT_SCALE_U_RNI_NID132, S0_AW_LAT_SCALE, 0, 3)
REG32(POR_RNI_S0_QOS_LAT_RANGE_U_RNI_NID132, 0x1014a98)
    FIELD(POR_RNI_S0_QOS_LAT_RANGE_U_RNI_NID132, RESERVED_28, 28, 36)
    FIELD(POR_RNI_S0_QOS_LAT_RANGE_U_RNI_NID132, S0_AR_LAT_MAX_QOS, 24, 4)
    FIELD(POR_RNI_S0_QOS_LAT_RANGE_U_RNI_NID132, RESERVED_20, 20, 4)
    FIELD(POR_RNI_S0_QOS_LAT_RANGE_U_RNI_NID132, S0_AR_LAT_MIN_QOS, 16, 4)
    FIELD(POR_RNI_S0_QOS_LAT_RANGE_U_RNI_NID132, RESERVED_12, 12, 4)
    FIELD(POR_RNI_S0_QOS_LAT_RANGE_U_RNI_NID132, S0_AW_LAT_MAX_QOS, 8, 4)
    FIELD(POR_RNI_S0_QOS_LAT_RANGE_U_RNI_NID132, S0_AW_LAT_MIN_QOS, 0, 4)
REG32(POR_RNI_S1_QOS_CONTROL_U_RNI_NID132, 0x1014aa0)
    FIELD(POR_RNI_S1_QOS_CONTROL_U_RNI_NID132, RESERVED_24, 24, 40)
    FIELD(POR_RNI_S1_QOS_CONTROL_U_RNI_NID132, S1_AR_QOS_OVERRIDE, 20, 4)
    FIELD(POR_RNI_S1_QOS_CONTROL_U_RNI_NID132, S1_AW_QOS_OVERRIDE, 16, 4)
    FIELD(POR_RNI_S1_QOS_CONTROL_U_RNI_NID132, S1_AR_PQV_MODE, 7, 1)
    FIELD(POR_RNI_S1_QOS_CONTROL_U_RNI_NID132, S1_AW_PQV_MODE, 6, 1)
    FIELD(POR_RNI_S1_QOS_CONTROL_U_RNI_NID132, S1_AR_REG_MODE, 5, 1)
    FIELD(POR_RNI_S1_QOS_CONTROL_U_RNI_NID132, S1_AW_REG_MODE, 4, 1)
    FIELD(POR_RNI_S1_QOS_CONTROL_U_RNI_NID132, S1_AR_QOS_OVERRIDE_EN, 3, 1)
    FIELD(POR_RNI_S1_QOS_CONTROL_U_RNI_NID132, S1_AW_QOS_OVERRIDE_EN, 2, 1)
    FIELD(POR_RNI_S1_QOS_CONTROL_U_RNI_NID132, S1_AR_LAT_EN, 1, 1)
    FIELD(POR_RNI_S1_QOS_CONTROL_U_RNI_NID132, S1_AW_LAT_EN, 0, 1)
REG32(POR_RNI_S1_QOS_LAT_TGT_U_RNI_NID132, 0x1014aa8)
    FIELD(POR_RNI_S1_QOS_LAT_TGT_U_RNI_NID132, RESERVED_28, 28, 36)
    FIELD(POR_RNI_S1_QOS_LAT_TGT_U_RNI_NID132, S1_AR_LAT_TGT, 16, 12)
    FIELD(POR_RNI_S1_QOS_LAT_TGT_U_RNI_NID132, RESERVED_12, 12, 4)
    FIELD(POR_RNI_S1_QOS_LAT_TGT_U_RNI_NID132, S1_AW_LAT_TGT, 0, 12)
REG32(POR_RNI_S1_QOS_LAT_SCALE_U_RNI_NID132, 0x1014ab0)
    FIELD(POR_RNI_S1_QOS_LAT_SCALE_U_RNI_NID132, RESERVED_11, 11, 53)
    FIELD(POR_RNI_S1_QOS_LAT_SCALE_U_RNI_NID132, S1_AR_LAT_SCALE, 8, 3)
    FIELD(POR_RNI_S1_QOS_LAT_SCALE_U_RNI_NID132, S1_AW_LAT_SCALE, 0, 3)
REG32(POR_RNI_S1_QOS_LAT_RANGE_U_RNI_NID132, 0x1014ab8)
    FIELD(POR_RNI_S1_QOS_LAT_RANGE_U_RNI_NID132, RESERVED_28, 28, 36)
    FIELD(POR_RNI_S1_QOS_LAT_RANGE_U_RNI_NID132, S1_AR_LAT_MAX_QOS, 24, 4)
    FIELD(POR_RNI_S1_QOS_LAT_RANGE_U_RNI_NID132, RESERVED_20, 20, 4)
    FIELD(POR_RNI_S1_QOS_LAT_RANGE_U_RNI_NID132, S1_AR_LAT_MIN_QOS, 16, 4)
    FIELD(POR_RNI_S1_QOS_LAT_RANGE_U_RNI_NID132, RESERVED_12, 12, 4)
    FIELD(POR_RNI_S1_QOS_LAT_RANGE_U_RNI_NID132, S1_AW_LAT_MAX_QOS, 8, 4)
    FIELD(POR_RNI_S1_QOS_LAT_RANGE_U_RNI_NID132, S1_AW_LAT_MIN_QOS, 0, 4)
REG32(POR_RNI_S2_QOS_CONTROL_U_RNI_NID132, 0x1014ac0)
    FIELD(POR_RNI_S2_QOS_CONTROL_U_RNI_NID132, RESERVED_24, 24, 40)
    FIELD(POR_RNI_S2_QOS_CONTROL_U_RNI_NID132, S2_AR_QOS_OVERRIDE, 20, 4)
    FIELD(POR_RNI_S2_QOS_CONTROL_U_RNI_NID132, S2_AW_QOS_OVERRIDE, 16, 4)
    FIELD(POR_RNI_S2_QOS_CONTROL_U_RNI_NID132, S2_AR_PQV_MODE, 7, 1)
    FIELD(POR_RNI_S2_QOS_CONTROL_U_RNI_NID132, S2_AW_PQV_MODE, 6, 1)
    FIELD(POR_RNI_S2_QOS_CONTROL_U_RNI_NID132, S2_AR_REG_MODE, 5, 1)
    FIELD(POR_RNI_S2_QOS_CONTROL_U_RNI_NID132, S2_AW_REG_MODE, 4, 1)
    FIELD(POR_RNI_S2_QOS_CONTROL_U_RNI_NID132, S2_AR_QOS_OVERRIDE_EN, 3, 1)
    FIELD(POR_RNI_S2_QOS_CONTROL_U_RNI_NID132, S2_AW_QOS_OVERRIDE_EN, 2, 1)
    FIELD(POR_RNI_S2_QOS_CONTROL_U_RNI_NID132, S2_AR_LAT_EN, 1, 1)
    FIELD(POR_RNI_S2_QOS_CONTROL_U_RNI_NID132, S2_AW_LAT_EN, 0, 1)
REG32(POR_RNI_S2_QOS_LAT_TGT_U_RNI_NID132, 0x1014ac8)
    FIELD(POR_RNI_S2_QOS_LAT_TGT_U_RNI_NID132, RESERVED_28, 28, 36)
    FIELD(POR_RNI_S2_QOS_LAT_TGT_U_RNI_NID132, S2_AR_LAT_TGT, 16, 12)
    FIELD(POR_RNI_S2_QOS_LAT_TGT_U_RNI_NID132, RESERVED_12, 12, 4)
    FIELD(POR_RNI_S2_QOS_LAT_TGT_U_RNI_NID132, S2_AW_LAT_TGT, 0, 12)
REG32(POR_RNI_S2_QOS_LAT_SCALE_U_RNI_NID132, 0x1014ad0)
    FIELD(POR_RNI_S2_QOS_LAT_SCALE_U_RNI_NID132, RESERVED_11, 11, 53)
    FIELD(POR_RNI_S2_QOS_LAT_SCALE_U_RNI_NID132, S2_AR_LAT_SCALE, 8, 3)
    FIELD(POR_RNI_S2_QOS_LAT_SCALE_U_RNI_NID132, S2_AW_LAT_SCALE, 0, 3)
REG32(POR_RNI_S2_QOS_LAT_RANGE_U_RNI_NID132, 0x1014ad8)
    FIELD(POR_RNI_S2_QOS_LAT_RANGE_U_RNI_NID132, RESERVED_28, 28, 36)
    FIELD(POR_RNI_S2_QOS_LAT_RANGE_U_RNI_NID132, S2_AR_LAT_MAX_QOS, 24, 4)
    FIELD(POR_RNI_S2_QOS_LAT_RANGE_U_RNI_NID132, RESERVED_20, 20, 4)
    FIELD(POR_RNI_S2_QOS_LAT_RANGE_U_RNI_NID132, S2_AR_LAT_MIN_QOS, 16, 4)
    FIELD(POR_RNI_S2_QOS_LAT_RANGE_U_RNI_NID132, RESERVED_12, 12, 4)
    FIELD(POR_RNI_S2_QOS_LAT_RANGE_U_RNI_NID132, S2_AW_LAT_MAX_QOS, 8, 4)
    FIELD(POR_RNI_S2_QOS_LAT_RANGE_U_RNI_NID132, S2_AW_LAT_MIN_QOS, 0, 4)
REG32(POR_RNI_PMU_EVENT_SEL_U_RNI_NID132, 0x1016000)
    FIELD(POR_RNI_PMU_EVENT_SEL_U_RNI_NID132, RESERVED_29, 29, 35)
    FIELD(POR_RNI_PMU_EVENT_SEL_U_RNI_NID132, PMU_EVENT3_ID, 24, 5)
    FIELD(POR_RNI_PMU_EVENT_SEL_U_RNI_NID132, RESERVED_21, 21, 3)
    FIELD(POR_RNI_PMU_EVENT_SEL_U_RNI_NID132, PMU_EVENT2_ID, 16, 5)
    FIELD(POR_RNI_PMU_EVENT_SEL_U_RNI_NID132, RESERVED_13, 13, 3)
    FIELD(POR_RNI_PMU_EVENT_SEL_U_RNI_NID132, PMU_EVENT1_ID, 8, 5)
    FIELD(POR_RNI_PMU_EVENT_SEL_U_RNI_NID132, PMU_EVENT0_ID, 0, 5)
REG32(POR_RNSAM_NODE_INFO_U_RNI_NID132, 0x1024000)
    FIELD(POR_RNSAM_NODE_INFO_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_RNSAM_NODE_INFO_U_RNI_NID132, LOGICAL_ID, 32, 16)
    FIELD(POR_RNSAM_NODE_INFO_U_RNI_NID132, NODE_ID, 16, 16)
    FIELD(POR_RNSAM_NODE_INFO_U_RNI_NID132, NODE_TYPE, 0, 16)
REG32(POR_RNSAM_CHILD_INFO_U_RNI_NID132, 0x1024080)
    FIELD(POR_RNSAM_CHILD_INFO_U_RNI_NID132, RESERVED_32, 32, 32)
    FIELD(POR_RNSAM_CHILD_INFO_U_RNI_NID132, CHILD_PTR_OFFSET, 16, 16)
    FIELD(POR_RNSAM_CHILD_INFO_U_RNI_NID132, CHILD_COUNT, 0, 16)
REG32(POR_RNSAM_UNIT_INFO_U_RNI_NID132, 0x1024900)
    FIELD(POR_RNSAM_UNIT_INFO_U_RNI_NID132, RESERVED_37, 37, 27)
    FIELD(POR_RNSAM_UNIT_INFO_U_RNI_NID132, NUM_NON_HASH_GROUP, 32, 5)
    FIELD(POR_RNSAM_UNIT_INFO_U_RNI_NID132, RESERVED_20, 20, 12)
    FIELD(POR_RNSAM_UNIT_INFO_U_RNI_NID132, NUM_SYS_CACHE_GROUP, 16, 4)
    FIELD(POR_RNSAM_UNIT_INFO_U_RNI_NID132, NUM_HNF, 0, 8)
REG32(POR_RNSAM_SECURE_REGISTER_GROUPS_OVERRIDE_U_RNI_NID132, 0x1024980)
    FIELD(POR_RNSAM_SECURE_REGISTER_GROUPS_OVERRIDE_U_RNI_NID132, MEM_RANGE, 0, 1)
REG32(RNSAM_STATUS_U_RNI_NID132, 0x1024c00)
    FIELD(RNSAM_STATUS_U_RNI_NID132, NSTALL_REQ, 1, 1)
    FIELD(RNSAM_STATUS_U_RNI_NID132, USE_DEFAULT_NODE, 0, 1)
REG32(NON_HASH_MEM_REGION_REG0_U_RNI_NID132, 0x1024c08)
    FIELD(NON_HASH_MEM_REGION_REG0_U_RNI_NID132, RESERVED_63, 63, 1)
    FIELD(NON_HASH_MEM_REGION_REG0_U_RNI_NID132, REGION1_BASE_ADDR, 41, 22)
    FIELD(NON_HASH_MEM_REGION_REG0_U_RNI_NID132, REGION1_SIZE, 36, 5)
    FIELD(NON_HASH_MEM_REGION_REG0_U_RNI_NID132, REGION1_TARGET_TYPE, 34, 2)
    FIELD(NON_HASH_MEM_REGION_REG0_U_RNI_NID132, RESERVED_33, 33, 1)
    FIELD(NON_HASH_MEM_REGION_REG0_U_RNI_NID132, REGION1_VALID, 32, 1)
    FIELD(NON_HASH_MEM_REGION_REG0_U_RNI_NID132, RESERVED_31, 31, 1)
    FIELD(NON_HASH_MEM_REGION_REG0_U_RNI_NID132, REGION0_BASE_ADDR, 9, 22)
    FIELD(NON_HASH_MEM_REGION_REG0_U_RNI_NID132, REGION0_SIZE, 4, 5)
    FIELD(NON_HASH_MEM_REGION_REG0_U_RNI_NID132, REGION0_TARGET_TYPE, 2, 2)
    FIELD(NON_HASH_MEM_REGION_REG0_U_RNI_NID132, REGION0_VALID, 0, 1)
REG32(NON_HASH_MEM_REGION_REG1_U_RNI_NID132, 0x1024c10)
    FIELD(NON_HASH_MEM_REGION_REG1_U_RNI_NID132, RESERVED_63, 63, 1)
    FIELD(NON_HASH_MEM_REGION_REG1_U_RNI_NID132, REGION3_BASE_ADDR, 41, 22)
    FIELD(NON_HASH_MEM_REGION_REG1_U_RNI_NID132, REGION3_SIZE, 36, 5)
    FIELD(NON_HASH_MEM_REGION_REG1_U_RNI_NID132, REGION3_TARGET_TYPE, 34, 2)
    FIELD(NON_HASH_MEM_REGION_REG1_U_RNI_NID132, RESERVED_33, 33, 1)
    FIELD(NON_HASH_MEM_REGION_REG1_U_RNI_NID132, REGION3_VALID, 32, 1)
    FIELD(NON_HASH_MEM_REGION_REG1_U_RNI_NID132, RESERVED_31, 31, 1)
    FIELD(NON_HASH_MEM_REGION_REG1_U_RNI_NID132, REGION2_BASE_ADDR, 9, 22)
    FIELD(NON_HASH_MEM_REGION_REG1_U_RNI_NID132, REGION2_SIZE, 4, 5)
    FIELD(NON_HASH_MEM_REGION_REG1_U_RNI_NID132, REGION2_TARGET_TYPE, 2, 2)
    FIELD(NON_HASH_MEM_REGION_REG1_U_RNI_NID132, REGION2_VALID, 0, 1)
REG32(NON_HASH_MEM_REGION_REG2_U_RNI_NID132, 0x1024c18)
    FIELD(NON_HASH_MEM_REGION_REG2_U_RNI_NID132, RESERVED_63, 63, 1)
    FIELD(NON_HASH_MEM_REGION_REG2_U_RNI_NID132, REGION5_BASE_ADDR, 41, 22)
    FIELD(NON_HASH_MEM_REGION_REG2_U_RNI_NID132, REGION5_SIZE, 36, 5)
    FIELD(NON_HASH_MEM_REGION_REG2_U_RNI_NID132, REGION5_TARGET_TYPE, 34, 2)
    FIELD(NON_HASH_MEM_REGION_REG2_U_RNI_NID132, RESERVED_33, 33, 1)
    FIELD(NON_HASH_MEM_REGION_REG2_U_RNI_NID132, REGION5_VALID, 32, 1)
    FIELD(NON_HASH_MEM_REGION_REG2_U_RNI_NID132, RESERVED_31, 31, 1)
    FIELD(NON_HASH_MEM_REGION_REG2_U_RNI_NID132, REGION4_BASE_ADDR, 9, 22)
    FIELD(NON_HASH_MEM_REGION_REG2_U_RNI_NID132, REGION4_SIZE, 4, 5)
    FIELD(NON_HASH_MEM_REGION_REG2_U_RNI_NID132, REGION4_TARGET_TYPE, 2, 2)
    FIELD(NON_HASH_MEM_REGION_REG2_U_RNI_NID132, REGION4_VALID, 0, 1)
REG32(NON_HASH_MEM_REGION_REG3_U_RNI_NID132, 0x1024c20)
    FIELD(NON_HASH_MEM_REGION_REG3_U_RNI_NID132, RESERVED_63, 63, 1)
    FIELD(NON_HASH_MEM_REGION_REG3_U_RNI_NID132, REGION7_BASE_ADDR, 41, 22)
    FIELD(NON_HASH_MEM_REGION_REG3_U_RNI_NID132, REGION7_SIZE, 36, 5)
    FIELD(NON_HASH_MEM_REGION_REG3_U_RNI_NID132, REGION7_TARGET_TYPE, 34, 2)
    FIELD(NON_HASH_MEM_REGION_REG3_U_RNI_NID132, RESERVED_33, 33, 1)
    FIELD(NON_HASH_MEM_REGION_REG3_U_RNI_NID132, REGION7_VALID, 32, 1)
    FIELD(NON_HASH_MEM_REGION_REG3_U_RNI_NID132, RESERVED_31, 31, 1)
    FIELD(NON_HASH_MEM_REGION_REG3_U_RNI_NID132, REGION6_BASE_ADDR, 9, 22)
    FIELD(NON_HASH_MEM_REGION_REG3_U_RNI_NID132, REGION6_SIZE, 4, 5)
    FIELD(NON_HASH_MEM_REGION_REG3_U_RNI_NID132, REGION6_TARGET_TYPE, 2, 2)
    FIELD(NON_HASH_MEM_REGION_REG3_U_RNI_NID132, REGION6_VALID, 0, 1)
REG32(NON_HASH_TGT_NODEID0_U_RNI_NID132, 0x1024c30)
    FIELD(NON_HASH_TGT_NODEID0_U_RNI_NID132, RESERVED_47, 47, 17)
    FIELD(NON_HASH_TGT_NODEID0_U_RNI_NID132, NODEID_3, 36, 11)
    FIELD(NON_HASH_TGT_NODEID0_U_RNI_NID132, RESERVED_35, 35, 1)
    FIELD(NON_HASH_TGT_NODEID0_U_RNI_NID132, NODEID_2, 24, 11)
    FIELD(NON_HASH_TGT_NODEID0_U_RNI_NID132, RESERVED_23, 23, 1)
    FIELD(NON_HASH_TGT_NODEID0_U_RNI_NID132, NODEID_1, 12, 11)
    FIELD(NON_HASH_TGT_NODEID0_U_RNI_NID132, RESERVED_11, 11, 1)
    FIELD(NON_HASH_TGT_NODEID0_U_RNI_NID132, NODEID_0, 0, 11)
REG32(NON_HASH_TGT_NODEID1_U_RNI_NID132, 0x1024c38)
    FIELD(NON_HASH_TGT_NODEID1_U_RNI_NID132, RESERVED_47, 47, 17)
    FIELD(NON_HASH_TGT_NODEID1_U_RNI_NID132, NODEID_7, 36, 11)
    FIELD(NON_HASH_TGT_NODEID1_U_RNI_NID132, RESERVED_35, 35, 1)
    FIELD(NON_HASH_TGT_NODEID1_U_RNI_NID132, NODEID_6, 24, 11)
    FIELD(NON_HASH_TGT_NODEID1_U_RNI_NID132, RESERVED_23, 23, 1)
    FIELD(NON_HASH_TGT_NODEID1_U_RNI_NID132, NODEID_5, 12, 11)
    FIELD(NON_HASH_TGT_NODEID1_U_RNI_NID132, RESERVED_11, 11, 1)
    FIELD(NON_HASH_TGT_NODEID1_U_RNI_NID132, NODEID_4, 0, 11)
REG32(NON_HASH_TGT_NODEID2_U_RNI_NID132, 0x1024c40)
    FIELD(NON_HASH_TGT_NODEID2_U_RNI_NID132, RESERVED_23, 23, 41)
    FIELD(NON_HASH_TGT_NODEID2_U_RNI_NID132, NODEID_9, 12, 11)
    FIELD(NON_HASH_TGT_NODEID2_U_RNI_NID132, RESERVED_11, 11, 1)
    FIELD(NON_HASH_TGT_NODEID2_U_RNI_NID132, NODEID_8, 0, 11)
REG32(SYS_CACHE_GRP_REGION0_U_RNI_NID132, 0x1024c48)
    FIELD(SYS_CACHE_GRP_REGION0_U_RNI_NID132, RESERVED_63, 63, 1)
    FIELD(SYS_CACHE_GRP_REGION0_U_RNI_NID132, REGION1_BASE_ADDR, 41, 22)
    FIELD(SYS_CACHE_GRP_REGION0_U_RNI_NID132, REGION1_SIZE, 36, 5)
    FIELD(SYS_CACHE_GRP_REGION0_U_RNI_NID132, REGION1_TARGET_TYPE, 34, 2)
    FIELD(SYS_CACHE_GRP_REGION0_U_RNI_NID132, REGION1_NONHASH_REG_EN, 33, 1)
    FIELD(SYS_CACHE_GRP_REGION0_U_RNI_NID132, REGION1_VALID, 32, 1)
    FIELD(SYS_CACHE_GRP_REGION0_U_RNI_NID132, RESERVED_31, 31, 1)
    FIELD(SYS_CACHE_GRP_REGION0_U_RNI_NID132, REGION0_BASE_ADDR, 9, 22)
    FIELD(SYS_CACHE_GRP_REGION0_U_RNI_NID132, REGION0_SIZE, 4, 5)
    FIELD(SYS_CACHE_GRP_REGION0_U_RNI_NID132, REGION0_TARGET_TYPE, 2, 2)
    FIELD(SYS_CACHE_GRP_REGION0_U_RNI_NID132, REGION0_VALID, 0, 1)
REG32(SYS_CACHE_GRP_REGION1_U_RNI_NID132, 0x1024c50)
    FIELD(SYS_CACHE_GRP_REGION1_U_RNI_NID132, RESERVED_63, 63, 1)
    FIELD(SYS_CACHE_GRP_REGION1_U_RNI_NID132, REGION3_BASE_ADDR, 41, 22)
    FIELD(SYS_CACHE_GRP_REGION1_U_RNI_NID132, REGION3_SIZE, 36, 5)
    FIELD(SYS_CACHE_GRP_REGION1_U_RNI_NID132, REGION3_TARGET_TYPE, 34, 2)
    FIELD(SYS_CACHE_GRP_REGION1_U_RNI_NID132, REGION3_NONHASH_REG_EN, 33, 1)
    FIELD(SYS_CACHE_GRP_REGION1_U_RNI_NID132, REGION3_VALID, 32, 1)
    FIELD(SYS_CACHE_GRP_REGION1_U_RNI_NID132, RESERVED_31, 31, 1)
    FIELD(SYS_CACHE_GRP_REGION1_U_RNI_NID132, REGION2_BASE_ADDR, 9, 22)
    FIELD(SYS_CACHE_GRP_REGION1_U_RNI_NID132, REGION2_SIZE, 4, 5)
    FIELD(SYS_CACHE_GRP_REGION1_U_RNI_NID132, REGION2_TARGET_TYPE, 2, 2)
    FIELD(SYS_CACHE_GRP_REGION1_U_RNI_NID132, REGION2_NONHASH_REG_EN, 1, 1)
    FIELD(SYS_CACHE_GRP_REGION1_U_RNI_NID132, REGION2_VALID, 0, 1)
REG32(SYS_CACHE_GRP_HN_NODEID_REG0_U_RNI_NID132, 0x1024c58)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG0_U_RNI_NID132, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG0_U_RNI_NID132, NODEID_3, 36, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG0_U_RNI_NID132, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG0_U_RNI_NID132, NODEID_2, 24, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG0_U_RNI_NID132, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG0_U_RNI_NID132, NODEID_1, 12, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG0_U_RNI_NID132, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG0_U_RNI_NID132, NODEID_0, 0, 11)
REG32(SYS_CACHE_GRP_HN_NODEID_REG1_U_RNI_NID132, 0x1024c60)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG1_U_RNI_NID132, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG1_U_RNI_NID132, NODEID_7, 36, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG1_U_RNI_NID132, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG1_U_RNI_NID132, NODEID_6, 24, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG1_U_RNI_NID132, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG1_U_RNI_NID132, NODEID_5, 12, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG1_U_RNI_NID132, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG1_U_RNI_NID132, NODEID_4, 0, 11)
REG32(SYS_CACHE_GRP_HN_NODEID_REG2_U_RNI_NID132, 0x1024c68)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG2_U_RNI_NID132, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG2_U_RNI_NID132, NODEID_11, 36, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG2_U_RNI_NID132, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG2_U_RNI_NID132, NODEID_10, 24, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG2_U_RNI_NID132, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG2_U_RNI_NID132, NODEID_9, 12, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG2_U_RNI_NID132, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG2_U_RNI_NID132, NODEID_8, 0, 11)
REG32(SYS_CACHE_GRP_HN_NODEID_REG3_U_RNI_NID132, 0x1024c70)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG3_U_RNI_NID132, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG3_U_RNI_NID132, NODEID_15, 36, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG3_U_RNI_NID132, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG3_U_RNI_NID132, NODEID_14, 24, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG3_U_RNI_NID132, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG3_U_RNI_NID132, NODEID_13, 12, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG3_U_RNI_NID132, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG3_U_RNI_NID132, NODEID_12, 0, 11)
REG32(SYS_CACHE_GRP_HN_NODEID_REG4_U_RNI_NID132, 0x1024c78)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG4_U_RNI_NID132, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG4_U_RNI_NID132, NODEID_19, 36, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG4_U_RNI_NID132, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG4_U_RNI_NID132, NODEID_18, 24, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG4_U_RNI_NID132, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG4_U_RNI_NID132, NODEID_17, 12, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG4_U_RNI_NID132, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG4_U_RNI_NID132, NODEID_16, 0, 11)
REG32(SYS_CACHE_GRP_HN_NODEID_REG5_U_RNI_NID132, 0x1024c80)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG5_U_RNI_NID132, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG5_U_RNI_NID132, NODEID_23, 36, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG5_U_RNI_NID132, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG5_U_RNI_NID132, NODEID_22, 24, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG5_U_RNI_NID132, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG5_U_RNI_NID132, NODEID_21, 12, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG5_U_RNI_NID132, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG5_U_RNI_NID132, NODEID_20, 0, 11)
REG32(SYS_CACHE_GRP_HN_NODEID_REG6_U_RNI_NID132, 0x1024c88)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG6_U_RNI_NID132, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG6_U_RNI_NID132, NODEID_27, 36, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG6_U_RNI_NID132, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG6_U_RNI_NID132, NODEID_26, 24, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG6_U_RNI_NID132, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG6_U_RNI_NID132, NODEID_25, 12, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG6_U_RNI_NID132, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG6_U_RNI_NID132, NODEID_24, 0, 11)
REG32(SYS_CACHE_GRP_HN_NODEID_REG7_U_RNI_NID132, 0x1024c90)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG7_U_RNI_NID132, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG7_U_RNI_NID132, NODEID_31, 36, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG7_U_RNI_NID132, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG7_U_RNI_NID132, NODEID_30, 24, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG7_U_RNI_NID132, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG7_U_RNI_NID132, NODEID_29, 12, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG7_U_RNI_NID132, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG7_U_RNI_NID132, NODEID_28, 0, 11)
REG32(SYS_CACHE_GRP_NONHASH_NODEID_U_RNI_NID132, 0x1024c98)
    FIELD(SYS_CACHE_GRP_NONHASH_NODEID_U_RNI_NID132, RESERVED_35, 35, 29)
    FIELD(SYS_CACHE_GRP_NONHASH_NODEID_U_RNI_NID132, SCG3_NODEID, 24, 11)
    FIELD(SYS_CACHE_GRP_NONHASH_NODEID_U_RNI_NID132, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_NONHASH_NODEID_U_RNI_NID132, SCG2_NODEID, 12, 11)
    FIELD(SYS_CACHE_GRP_NONHASH_NODEID_U_RNI_NID132, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_NONHASH_NODEID_U_RNI_NID132, SCG1_NODEID, 0, 11)
REG32(SYS_CACHE_GROUP_HN_COUNT_U_RNI_NID132, 0x1024d00)
    FIELD(SYS_CACHE_GROUP_HN_COUNT_U_RNI_NID132, RESERVED_31, 31, 33)
    FIELD(SYS_CACHE_GROUP_HN_COUNT_U_RNI_NID132, SCG3_NUM_HNF, 24, 7)
    FIELD(SYS_CACHE_GROUP_HN_COUNT_U_RNI_NID132, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GROUP_HN_COUNT_U_RNI_NID132, SCG2_NUM_HNF, 16, 7)
    FIELD(SYS_CACHE_GROUP_HN_COUNT_U_RNI_NID132, RESERVED_15, 15, 1)
    FIELD(SYS_CACHE_GROUP_HN_COUNT_U_RNI_NID132, SCG1_NUM_HNF, 8, 7)
    FIELD(SYS_CACHE_GROUP_HN_COUNT_U_RNI_NID132, SCG0_NUM_HNF, 0, 7)
REG32(SYS_CACHE_GRP_SN_NODEID_REG0_U_RNI_NID132, 0x1024d08)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG0_U_RNI_NID132, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG0_U_RNI_NID132, SN_NODEID_3, 36, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG0_U_RNI_NID132, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG0_U_RNI_NID132, SN_NODEID_2, 24, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG0_U_RNI_NID132, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG0_U_RNI_NID132, SN_NODEID_1, 12, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG0_U_RNI_NID132, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG0_U_RNI_NID132, SN_NODEID_0, 0, 11)
REG32(SYS_CACHE_GRP_SN_NODEID_REG1_U_RNI_NID132, 0x1024d10)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG1_U_RNI_NID132, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG1_U_RNI_NID132, SN_NODEID_7, 36, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG1_U_RNI_NID132, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG1_U_RNI_NID132, SN_NODEID_6, 24, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG1_U_RNI_NID132, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG1_U_RNI_NID132, SN_NODEID_5, 12, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG1_U_RNI_NID132, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG1_U_RNI_NID132, SN_NODEID_4, 0, 11)
REG32(SYS_CACHE_GRP_SN_NODEID_REG2_U_RNI_NID132, 0x1024d18)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG2_U_RNI_NID132, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG2_U_RNI_NID132, SN_NODEID_11, 36, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG2_U_RNI_NID132, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG2_U_RNI_NID132, SN_NODEID_10, 24, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG2_U_RNI_NID132, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG2_U_RNI_NID132, SN_NODEID_9, 12, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG2_U_RNI_NID132, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG2_U_RNI_NID132, SN_NODEID_8, 0, 11)
REG32(SYS_CACHE_GRP_SN_NODEID_REG3_U_RNI_NID132, 0x1024d20)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG3_U_RNI_NID132, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG3_U_RNI_NID132, SN_NODEID_15, 36, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG3_U_RNI_NID132, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG3_U_RNI_NID132, SN_NODEID_14, 24, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG3_U_RNI_NID132, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG3_U_RNI_NID132, SN_NODEID_13, 12, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG3_U_RNI_NID132, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG3_U_RNI_NID132, SN_NODEID_12, 0, 11)
REG32(SYS_CACHE_GRP_SN_NODEID_REG4_U_RNI_NID132, 0x1024d28)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG4_U_RNI_NID132, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG4_U_RNI_NID132, SN_NODEID_19, 36, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG4_U_RNI_NID132, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG4_U_RNI_NID132, SN_NODEID_18, 24, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG4_U_RNI_NID132, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG4_U_RNI_NID132, SN_NODEID_17, 12, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG4_U_RNI_NID132, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG4_U_RNI_NID132, SN_NODEID_16, 0, 11)
REG32(SYS_CACHE_GRP_SN_NODEID_REG5_U_RNI_NID132, 0x1024d30)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG5_U_RNI_NID132, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG5_U_RNI_NID132, SN_NODEID_23, 36, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG5_U_RNI_NID132, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG5_U_RNI_NID132, SN_NODEID_22, 24, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG5_U_RNI_NID132, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG5_U_RNI_NID132, SN_NODEID_21, 12, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG5_U_RNI_NID132, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG5_U_RNI_NID132, SN_NODEID_20, 0, 11)
REG32(SYS_CACHE_GRP_SN_NODEID_REG6_U_RNI_NID132, 0x1024d38)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG6_U_RNI_NID132, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG6_U_RNI_NID132, SN_NODEID_27, 36, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG6_U_RNI_NID132, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG6_U_RNI_NID132, SN_NODEID_26, 24, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG6_U_RNI_NID132, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG6_U_RNI_NID132, SN_NODEID_25, 12, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG6_U_RNI_NID132, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG6_U_RNI_NID132, SN_NODEID_24, 0, 11)
REG32(SYS_CACHE_GRP_SN_NODEID_REG7_U_RNI_NID132, 0x1024d40)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG7_U_RNI_NID132, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG7_U_RNI_NID132, SN_NODEID_31, 36, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG7_U_RNI_NID132, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG7_U_RNI_NID132, SN_NODEID_30, 24, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG7_U_RNI_NID132, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG7_U_RNI_NID132, SN_NODEID_29, 12, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG7_U_RNI_NID132, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG7_U_RNI_NID132, SN_NODEID_28, 0, 11)
REG32(SYS_CACHE_GRP_SN_SAM_CFG0_U_RNI_NID132, 0x1024d48)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG0_U_RNI_NID132, RESERVED_46, 46, 18)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG0_U_RNI_NID132, SCG1_TOP_ADDRESS_BIT2, 40, 6)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG0_U_RNI_NID132, RESERVED_38, 38, 2)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG0_U_RNI_NID132, SCG1_TOP_ADDRESS_BIT1, 32, 6)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG0_U_RNI_NID132, RESERVED_30, 30, 2)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG0_U_RNI_NID132, SCG1_TOP_ADDRESS_BIT0, 24, 6)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG0_U_RNI_NID132, RESERVED_22, 22, 2)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG0_U_RNI_NID132, SCG0_TOP_ADDRESS_BIT2, 16, 6)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG0_U_RNI_NID132, RESERVED_14, 14, 2)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG0_U_RNI_NID132, SCG0_TOP_ADDRESS_BIT1, 8, 6)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG0_U_RNI_NID132, SCG0_TOP_ADDRESS_BIT0, 0, 6)
REG32(SYS_CACHE_GRP_SN_SAM_CFG1_U_RNI_NID132, 0x1024d50)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG1_U_RNI_NID132, RESERVED_46, 46, 18)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG1_U_RNI_NID132, SCG3_TOP_ADDRESS_BIT2, 40, 6)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG1_U_RNI_NID132, RESERVED_38, 38, 2)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG1_U_RNI_NID132, SCG3_TOP_ADDRESS_BIT1, 32, 6)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG1_U_RNI_NID132, RESERVED_30, 30, 2)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG1_U_RNI_NID132, SCG3_TOP_ADDRESS_BIT0, 24, 6)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG1_U_RNI_NID132, RESERVED_22, 22, 2)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG1_U_RNI_NID132, SCG2_TOP_ADDRESS_BIT2, 16, 6)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG1_U_RNI_NID132, RESERVED_14, 14, 2)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG1_U_RNI_NID132, SCG2_TOP_ADDRESS_BIT1, 8, 6)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG1_U_RNI_NID132, SCG2_TOP_ADDRESS_BIT0, 0, 6)
REG32(GIC_MEM_REGION_REG_U_RNI_NID132, 0x1024d58)
    FIELD(GIC_MEM_REGION_REG_U_RNI_NID132, RESERVED_63, 63, 1)
    FIELD(GIC_MEM_REGION_REG_U_RNI_NID132, GIC_REGION_NODEID, 52, 11)
    FIELD(GIC_MEM_REGION_REG_U_RNI_NID132, RESERVED_48, 48, 4)
    FIELD(GIC_MEM_REGION_REG_U_RNI_NID132, GIC_REGION_BASE_ADDR, 16, 32)
    FIELD(GIC_MEM_REGION_REG_U_RNI_NID132, GIC_REGION_SIZE, 4, 3)
    FIELD(GIC_MEM_REGION_REG_U_RNI_NID132, GIC_REGION_TARGET_TYPE, 2, 2)
    FIELD(GIC_MEM_REGION_REG_U_RNI_NID132, GIC_REGION_VALID, 0, 1)
REG32(SYS_CACHE_GRP_SN_ATTR_U_RNI_NID132, 0x1024d60)
    FIELD(SYS_CACHE_GRP_SN_ATTR_U_RNI_NID132, RESERVED_54, 54, 10)
    FIELD(SYS_CACHE_GRP_SN_ATTR_U_RNI_NID132, SN_MODE_SYS_CACHE_GRP3, 52, 2)
    FIELD(SYS_CACHE_GRP_SN_ATTR_U_RNI_NID132, RESERVED_49, 49, 3)
    FIELD(SYS_CACHE_GRP_SN_ATTR_U_RNI_NID132, INV_TOP_ADDRESS_BIT_SYS_CACHE_GRP3, 48, 1)
    FIELD(SYS_CACHE_GRP_SN_ATTR_U_RNI_NID132, RESERVED_38, 38, 10)
    FIELD(SYS_CACHE_GRP_SN_ATTR_U_RNI_NID132, SN_MODE_SYS_CACHE_GRP2, 36, 2)
    FIELD(SYS_CACHE_GRP_SN_ATTR_U_RNI_NID132, RESERVED_33, 33, 3)
    FIELD(SYS_CACHE_GRP_SN_ATTR_U_RNI_NID132, INV_TOP_ADDRESS_BIT_SYS_CACHE_GRP2, 32, 1)
    FIELD(SYS_CACHE_GRP_SN_ATTR_U_RNI_NID132, RESERVED_22, 22, 10)
    FIELD(SYS_CACHE_GRP_SN_ATTR_U_RNI_NID132, SN_MODE_SYS_CACHE_GRP1, 20, 2)
    FIELD(SYS_CACHE_GRP_SN_ATTR_U_RNI_NID132, RESERVED_17, 17, 3)
    FIELD(SYS_CACHE_GRP_SN_ATTR_U_RNI_NID132, INV_TOP_ADDRESS_BIT_SYS_CACHE_GRP1, 16, 1)
    FIELD(SYS_CACHE_GRP_SN_ATTR_U_RNI_NID132, SN_MODE_SYS_CACHE_GRP0, 4, 2)
    FIELD(SYS_CACHE_GRP_SN_ATTR_U_RNI_NID132, INV_TOP_ADDRESS_BIT_SYS_CACHE_GRP0, 0, 1)
REG32(SYS_CACHE_GRP_HN_CPA_EN_REG_U_RNI_NID132, 0x1024d68)
REG32(SYS_CACHE_GRP_HN_CPA_GRP_REG_U_RNI_NID132, 0x1024d70)
    FIELD(SYS_CACHE_GRP_HN_CPA_GRP_REG_U_RNI_NID132, RESERVED_50, 50, 14)
    FIELD(SYS_CACHE_GRP_HN_CPA_GRP_REG_U_RNI_NID132, CPA_GRP_SCG3, 48, 2)
    FIELD(SYS_CACHE_GRP_HN_CPA_GRP_REG_U_RNI_NID132, RESERVED_34, 34, 14)
    FIELD(SYS_CACHE_GRP_HN_CPA_GRP_REG_U_RNI_NID132, CPA_GRP_SCG2, 32, 2)
    FIELD(SYS_CACHE_GRP_HN_CPA_GRP_REG_U_RNI_NID132, RESERVED_18, 18, 14)
    FIELD(SYS_CACHE_GRP_HN_CPA_GRP_REG_U_RNI_NID132, CPA_GRP_SCG1, 16, 2)
    FIELD(SYS_CACHE_GRP_HN_CPA_GRP_REG_U_RNI_NID132, CPA_GRP_SCG0, 0, 2)
REG32(CML_PORT_AGGR_MODE_CTRL_REG_U_RNI_NID132, 0x1024e00)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNI_NID132, RESERVED_32, 32, 32)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNI_NID132, REGION7_PAG_GRPID, 30, 2)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNI_NID132, RESERVED_29, 29, 1)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNI_NID132, REGION7_PAG_EN, 28, 1)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNI_NID132, RESERVED_27, 27, 1)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNI_NID132, REGION6_PAG_GRPID, 25, 2)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNI_NID132, REGION6_PAG_EN, 24, 1)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNI_NID132, RESERVED_23, 23, 1)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNI_NID132, REGION5_PAG_GRPID, 21, 2)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNI_NID132, REGION5_PAG_EN, 20, 1)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNI_NID132, RESERVED_19, 19, 1)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNI_NID132, REGION4_PAG_GRPID, 17, 2)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNI_NID132, REGION4_PAG_EN, 16, 1)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNI_NID132, RESERVED_15, 15, 1)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNI_NID132, REGION3_PAG_GRPID, 13, 2)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNI_NID132, REGION3_PAG_EN, 12, 1)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNI_NID132, RESERVED_11, 11, 1)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNI_NID132, REGION2_PAG_GRPID, 9, 2)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNI_NID132, REGION2_PAG_EN, 8, 1)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNI_NID132, REGION1_PAG_GRPID, 5, 2)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNI_NID132, REGION1_PAG_EN, 4, 1)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNI_NID132, REGION0_PAG_GRPID, 1, 2)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNI_NID132, REGION0_PAG_EN, 0, 1)
REG32(CML_PORT_AGGR_GRP0_ADD_MASK_U_RNI_NID132, 0x1024e08)
    FIELD(CML_PORT_AGGR_GRP0_ADD_MASK_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(CML_PORT_AGGR_GRP0_ADD_MASK_U_RNI_NID132, ADDR_MASK, 6, 42)
    FIELD(CML_PORT_AGGR_GRP0_ADD_MASK_U_RNI_NID132, RESERVED_0, 0, 6)
REG32(CML_PORT_AGGR_GRP1_ADD_MASK_U_RNI_NID132, 0x1024e10)
    FIELD(CML_PORT_AGGR_GRP1_ADD_MASK_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(CML_PORT_AGGR_GRP1_ADD_MASK_U_RNI_NID132, ADDR_MASK, 6, 42)
    FIELD(CML_PORT_AGGR_GRP1_ADD_MASK_U_RNI_NID132, RESERVED_0, 0, 6)
REG32(CML_PORT_AGGR_GRP0_REG_U_RNI_NID132, 0x1024e40)
    FIELD(CML_PORT_AGGR_GRP0_REG_U_RNI_NID132, RESERVED_50, 50, 14)
    FIELD(CML_PORT_AGGR_GRP0_REG_U_RNI_NID132, NUM_CXG_PAG0, 48, 2)
    FIELD(CML_PORT_AGGR_GRP0_REG_U_RNI_NID132, RESERVED_47, 47, 1)
    FIELD(CML_PORT_AGGR_GRP0_REG_U_RNI_NID132, PAG0_TGTID3, 36, 11)
    FIELD(CML_PORT_AGGR_GRP0_REG_U_RNI_NID132, RESERVED_35, 35, 1)
    FIELD(CML_PORT_AGGR_GRP0_REG_U_RNI_NID132, PAG0_TGTID2, 24, 11)
    FIELD(CML_PORT_AGGR_GRP0_REG_U_RNI_NID132, RESERVED_23, 23, 1)
    FIELD(CML_PORT_AGGR_GRP0_REG_U_RNI_NID132, PAG0_TGTID1, 12, 11)
    FIELD(CML_PORT_AGGR_GRP0_REG_U_RNI_NID132, RESERVED_11, 11, 1)
    FIELD(CML_PORT_AGGR_GRP0_REG_U_RNI_NID132, PAG0_TGTID0, 0, 11)
REG32(CML_PORT_AGGR_GRP1_REG_U_RNI_NID132, 0x1024e48)
    FIELD(CML_PORT_AGGR_GRP1_REG_U_RNI_NID132, RESERVED_50, 50, 14)
    FIELD(CML_PORT_AGGR_GRP1_REG_U_RNI_NID132, NUM_CXG_PAG1, 48, 2)
    FIELD(CML_PORT_AGGR_GRP1_REG_U_RNI_NID132, RESERVED_47, 47, 1)
    FIELD(CML_PORT_AGGR_GRP1_REG_U_RNI_NID132, PAG1_TGTID3, 36, 11)
    FIELD(CML_PORT_AGGR_GRP1_REG_U_RNI_NID132, RESERVED_35, 35, 1)
    FIELD(CML_PORT_AGGR_GRP1_REG_U_RNI_NID132, PAG1_TGTID2, 24, 11)
    FIELD(CML_PORT_AGGR_GRP1_REG_U_RNI_NID132, RESERVED_23, 23, 1)
    FIELD(CML_PORT_AGGR_GRP1_REG_U_RNI_NID132, PAG1_TGTID1, 12, 11)
    FIELD(CML_PORT_AGGR_GRP1_REG_U_RNI_NID132, RESERVED_11, 11, 1)
    FIELD(CML_PORT_AGGR_GRP1_REG_U_RNI_NID132, PAG1_TGTID0, 0, 11)
REG32(SYS_CACHE_GRP_SECONDARY_REG0_U_RNI_NID132, 0x1024f00)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG0_U_RNI_NID132, RESERVED_63, 63, 1)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG0_U_RNI_NID132, REGION1_SCNDRY_BASE_ADDR, 41, 22)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG0_U_RNI_NID132, REGION1_SCNDRY_SIZE, 36, 5)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG0_U_RNI_NID132, REGION1_SCNDRY_TARGET_TYPE, 34, 2)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG0_U_RNI_NID132, RESERVED_33, 33, 1)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG0_U_RNI_NID132, REGION1_SCNDRY_VALID, 32, 1)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG0_U_RNI_NID132, RESERVED_31, 31, 1)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG0_U_RNI_NID132, REGION0_SCNDRY_BASE_ADDR, 9, 22)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG0_U_RNI_NID132, REGION0_SCNDRY_SIZE, 4, 5)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG0_U_RNI_NID132, REGION0_SCNDRY_TARGET_TYPE, 2, 2)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG0_U_RNI_NID132, REGION0_SCNDRY_VALID, 0, 1)
REG32(SYS_CACHE_GRP_SECONDARY_REG1_U_RNI_NID132, 0x1024f08)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG1_U_RNI_NID132, RESERVED_63, 63, 1)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG1_U_RNI_NID132, REGION3_SCNDRY_BASE_ADDR, 41, 22)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG1_U_RNI_NID132, REGION3_SCNDRY_SIZE, 36, 5)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG1_U_RNI_NID132, REGION3_SCNDRY_TARGET_TYPE, 34, 2)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG1_U_RNI_NID132, RESERVED_33, 33, 1)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG1_U_RNI_NID132, REGION3_SCNDRY_VALID, 32, 1)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG1_U_RNI_NID132, RESERVED_31, 31, 1)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG1_U_RNI_NID132, REGION2_SCNDRY_BASE_ADDR, 9, 22)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG1_U_RNI_NID132, REGION2_SCNDRY_SIZE, 4, 5)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG1_U_RNI_NID132, REGION2_SCNDRY_TARGET_TYPE, 2, 2)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG1_U_RNI_NID132, REGION2_SCNDRY_VALID, 0, 1)
REG32(SYS_CACHE_GRP_CAL_MODE_REG_U_RNI_NID132, 0x1024f10)
    FIELD(SYS_CACHE_GRP_CAL_MODE_REG_U_RNI_NID132, RESERVED_49, 49, 15)
    FIELD(SYS_CACHE_GRP_CAL_MODE_REG_U_RNI_NID132, SCG3_HNF_CAL_MODE_EN, 48, 1)
    FIELD(SYS_CACHE_GRP_CAL_MODE_REG_U_RNI_NID132, RESERVED_33, 33, 15)
    FIELD(SYS_CACHE_GRP_CAL_MODE_REG_U_RNI_NID132, SCG2_HNF_CAL_MODE_EN, 32, 1)
    FIELD(SYS_CACHE_GRP_CAL_MODE_REG_U_RNI_NID132, RESERVED_17, 17, 15)
    FIELD(SYS_CACHE_GRP_CAL_MODE_REG_U_RNI_NID132, SCG1_HNF_CAL_MODE_EN, 16, 1)
    FIELD(SYS_CACHE_GRP_CAL_MODE_REG_U_RNI_NID132, SCG0_HNF_CAL_MODE_EN, 0, 1)
REG32(RNSAM_HASH_ADDR_MASK_REG_U_RNI_NID132, 0x1024f18)
    FIELD(RNSAM_HASH_ADDR_MASK_REG_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(RNSAM_HASH_ADDR_MASK_REG_U_RNI_NID132, ADDR_MASK, 6, 42)
    FIELD(RNSAM_HASH_ADDR_MASK_REG_U_RNI_NID132, RESERVED_0, 0, 6)
REG32(RNSAM_REGION_CMP_ADDR_MASK_REG_U_RNI_NID132, 0x1024f20)
    FIELD(RNSAM_REGION_CMP_ADDR_MASK_REG_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(RNSAM_REGION_CMP_ADDR_MASK_REG_U_RNI_NID132, ADDR_MASK, 16, 32)
    FIELD(RNSAM_REGION_CMP_ADDR_MASK_REG_U_RNI_NID132, RESERVED_0, 0, 16)
REG32(SYS_CACHE_GRP_HN_NODEID_REG8_U_RNI_NID132, 0x1024f58)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG8_U_RNI_NID132, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG8_U_RNI_NID132, NODEID_35, 36, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG8_U_RNI_NID132, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG8_U_RNI_NID132, NODEID_34, 24, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG8_U_RNI_NID132, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG8_U_RNI_NID132, NODEID_33, 12, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG8_U_RNI_NID132, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG8_U_RNI_NID132, NODEID_32, 0, 11)
REG32(SYS_CACHE_GRP_HN_NODEID_REG9_U_RNI_NID132, 0x1024f60)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG9_U_RNI_NID132, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG9_U_RNI_NID132, NODEID_39, 36, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG9_U_RNI_NID132, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG9_U_RNI_NID132, NODEID_38, 24, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG9_U_RNI_NID132, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG9_U_RNI_NID132, NODEID_37, 12, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG9_U_RNI_NID132, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG9_U_RNI_NID132, NODEID_36, 0, 11)
REG32(SYS_CACHE_GRP_HN_NODEID_REG10_U_RNI_NID132, 0x1024f68)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG10_U_RNI_NID132, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG10_U_RNI_NID132, NODEID_43, 36, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG10_U_RNI_NID132, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG10_U_RNI_NID132, NODEID_42, 24, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG10_U_RNI_NID132, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG10_U_RNI_NID132, NODEID_41, 12, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG10_U_RNI_NID132, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG10_U_RNI_NID132, NODEID_40, 0, 11)
REG32(SYS_CACHE_GRP_HN_NODEID_REG11_U_RNI_NID132, 0x1024f70)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG11_U_RNI_NID132, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG11_U_RNI_NID132, NODEID_47, 36, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG11_U_RNI_NID132, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG11_U_RNI_NID132, NODEID_46, 24, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG11_U_RNI_NID132, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG11_U_RNI_NID132, NODEID_45, 12, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG11_U_RNI_NID132, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG11_U_RNI_NID132, NODEID_44, 0, 11)
REG32(SYS_CACHE_GRP_HN_NODEID_REG12_U_RNI_NID132, 0x1024f78)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG12_U_RNI_NID132, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG12_U_RNI_NID132, NODEID_51, 36, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG12_U_RNI_NID132, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG12_U_RNI_NID132, NODEID_50, 24, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG12_U_RNI_NID132, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG12_U_RNI_NID132, NODEID_49, 12, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG12_U_RNI_NID132, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG12_U_RNI_NID132, NODEID_48, 0, 11)
REG32(SYS_CACHE_GRP_HN_NODEID_REG13_U_RNI_NID132, 0x1024f80)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG13_U_RNI_NID132, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG13_U_RNI_NID132, NODEID_55, 36, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG13_U_RNI_NID132, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG13_U_RNI_NID132, NODEID_54, 24, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG13_U_RNI_NID132, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG13_U_RNI_NID132, NODEID_53, 12, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG13_U_RNI_NID132, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG13_U_RNI_NID132, NODEID_52, 0, 11)
REG32(SYS_CACHE_GRP_HN_NODEID_REG14_U_RNI_NID132, 0x1024f88)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG14_U_RNI_NID132, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG14_U_RNI_NID132, NODEID_59, 36, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG14_U_RNI_NID132, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG14_U_RNI_NID132, NODEID_58, 24, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG14_U_RNI_NID132, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG14_U_RNI_NID132, NODEID_57, 12, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG14_U_RNI_NID132, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG14_U_RNI_NID132, NODEID_56, 0, 11)
REG32(SYS_CACHE_GRP_HN_NODEID_REG15_U_RNI_NID132, 0x1024f90)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG15_U_RNI_NID132, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG15_U_RNI_NID132, NODEID_63, 36, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG15_U_RNI_NID132, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG15_U_RNI_NID132, NODEID_62, 24, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG15_U_RNI_NID132, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG15_U_RNI_NID132, NODEID_61, 12, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG15_U_RNI_NID132, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG15_U_RNI_NID132, NODEID_60, 0, 11)
REG32(SYS_CACHE_GRP_SN_NODEID_REG8_U_RNI_NID132, 0x1025008)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG8_U_RNI_NID132, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG8_U_RNI_NID132, SN_NODEID_35, 36, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG8_U_RNI_NID132, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG8_U_RNI_NID132, SN_NODEID_34, 24, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG8_U_RNI_NID132, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG8_U_RNI_NID132, SN_NODEID_33, 12, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG8_U_RNI_NID132, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG8_U_RNI_NID132, SN_NODEID_32, 0, 11)
REG32(SYS_CACHE_GRP_SN_NODEID_REG9_U_RNI_NID132, 0x1025010)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG9_U_RNI_NID132, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG9_U_RNI_NID132, SN_NODEID_39, 36, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG9_U_RNI_NID132, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG9_U_RNI_NID132, SN_NODEID_38, 24, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG9_U_RNI_NID132, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG9_U_RNI_NID132, SN_NODEID_37, 12, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG9_U_RNI_NID132, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG9_U_RNI_NID132, SN_NODEID_36, 0, 11)
REG32(SYS_CACHE_GRP_SN_NODEID_REG10_U_RNI_NID132, 0x1025018)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG10_U_RNI_NID132, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG10_U_RNI_NID132, SN_NODEID_43, 36, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG10_U_RNI_NID132, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG10_U_RNI_NID132, SN_NODEID_42, 24, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG10_U_RNI_NID132, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG10_U_RNI_NID132, SN_NODEID_41, 12, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG10_U_RNI_NID132, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG10_U_RNI_NID132, SN_NODEID_40, 0, 11)
REG32(SYS_CACHE_GRP_SN_NODEID_REG11_U_RNI_NID132, 0x1025020)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG11_U_RNI_NID132, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG11_U_RNI_NID132, SN_NODEID_47, 36, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG11_U_RNI_NID132, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG11_U_RNI_NID132, SN_NODEID_46, 24, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG11_U_RNI_NID132, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG11_U_RNI_NID132, SN_NODEID_45, 12, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG11_U_RNI_NID132, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG11_U_RNI_NID132, SN_NODEID_44, 0, 11)
REG32(SYS_CACHE_GRP_SN_NODEID_REG12_U_RNI_NID132, 0x1025028)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG12_U_RNI_NID132, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG12_U_RNI_NID132, SN_NODEID_51, 36, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG12_U_RNI_NID132, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG12_U_RNI_NID132, SN_NODEID_50, 24, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG12_U_RNI_NID132, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG12_U_RNI_NID132, SN_NODEID_49, 12, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG12_U_RNI_NID132, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG12_U_RNI_NID132, SN_NODEID_48, 0, 11)
REG32(SYS_CACHE_GRP_SN_NODEID_REG13_U_RNI_NID132, 0x1025030)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG13_U_RNI_NID132, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG13_U_RNI_NID132, SN_NODEID_55, 36, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG13_U_RNI_NID132, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG13_U_RNI_NID132, SN_NODEID_54, 24, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG13_U_RNI_NID132, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG13_U_RNI_NID132, SN_NODEID_53, 12, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG13_U_RNI_NID132, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG13_U_RNI_NID132, SN_NODEID_52, 0, 11)
REG32(SYS_CACHE_GRP_SN_NODEID_REG14_U_RNI_NID132, 0x1025038)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG14_U_RNI_NID132, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG14_U_RNI_NID132, SN_NODEID_59, 36, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG14_U_RNI_NID132, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG14_U_RNI_NID132, SN_NODEID_58, 24, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG14_U_RNI_NID132, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG14_U_RNI_NID132, SN_NODEID_57, 12, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG14_U_RNI_NID132, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG14_U_RNI_NID132, SN_NODEID_56, 0, 11)
REG32(SYS_CACHE_GRP_SN_NODEID_REG15_U_RNI_NID132, 0x1025040)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG15_U_RNI_NID132, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG15_U_RNI_NID132, SN_NODEID_63, 36, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG15_U_RNI_NID132, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG15_U_RNI_NID132, SN_NODEID_62, 24, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG15_U_RNI_NID132, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG15_U_RNI_NID132, SN_NODEID_61, 12, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG15_U_RNI_NID132, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG15_U_RNI_NID132, SN_NODEID_60, 0, 11)
REG32(POR_FDC_NODE_INFO_U_SMXP_2_0, 0x102c000)
    FIELD(POR_FDC_NODE_INFO_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_FDC_NODE_INFO_U_SMXP_2_0, LOGICAL_ID, 32, 16)
    FIELD(POR_FDC_NODE_INFO_U_SMXP_2_0, NODE_ID, 16, 16)
    FIELD(POR_FDC_NODE_INFO_U_SMXP_2_0, NODE_TYPE, 0, 16)
REG32(POR_FDC_CHILD_INFO_U_SMXP_2_0, 0x102c080)
    FIELD(POR_FDC_CHILD_INFO_U_SMXP_2_0, RESERVED_32, 32, 32)
    FIELD(POR_FDC_CHILD_INFO_U_SMXP_2_0, CHILD_PTR_OFFSET, 16, 16)
    FIELD(POR_FDC_CHILD_INFO_U_SMXP_2_0, CHILD_COUNT, 0, 16)
REG32(POR_ERRFR_MXP_U_SMXP_2_0, 0x102f000)
    FIELD(POR_ERRFR_MXP_U_SMXP_2_0, FI, 6, 2)
    FIELD(POR_ERRFR_MXP_U_SMXP_2_0, UI, 4, 2)
    FIELD(POR_ERRFR_MXP_U_SMXP_2_0, ED, 0, 2)
REG32(POR_ERRCTLR_MXP_U_SMXP_2_0, 0x102f008)
    FIELD(POR_ERRCTLR_MXP_U_SMXP_2_0, RESERVED_32, 32, 32)
    FIELD(POR_ERRCTLR_MXP_U_SMXP_2_0, ERC, 14, 18)
    FIELD(POR_ERRCTLR_MXP_U_SMXP_2_0, FI, 3, 1)
    FIELD(POR_ERRCTLR_MXP_U_SMXP_2_0, UI, 2, 1)
    FIELD(POR_ERRCTLR_MXP_U_SMXP_2_0, ED, 0, 1)
REG32(POR_ERRSTATUS_MXP_U_SMXP_2_0, 0x102f010)
    FIELD(POR_ERRSTATUS_MXP_U_SMXP_2_0, RESERVED_31, 31, 33)
    FIELD(POR_ERRSTATUS_MXP_U_SMXP_2_0, V, 30, 1)
    FIELD(POR_ERRSTATUS_MXP_U_SMXP_2_0, UE, 29, 1)
    FIELD(POR_ERRSTATUS_MXP_U_SMXP_2_0, RESERVED_28, 28, 1)
    FIELD(POR_ERRSTATUS_MXP_U_SMXP_2_0, OF, 27, 1)
    FIELD(POR_ERRSTATUS_MXP_U_SMXP_2_0, RESERVED_24, 24, 3)
    FIELD(POR_ERRSTATUS_MXP_U_SMXP_2_0, DE, 23, 1)
    FIELD(POR_ERRSTATUS_MXP_U_SMXP_2_0, RESERVED_16, 16, 7)
    FIELD(POR_ERRSTATUS_MXP_U_SMXP_2_0, V_ERR_TYPE, 6, 10)
    FIELD(POR_ERRSTATUS_MXP_U_SMXP_2_0, RESERVED_0, 0, 6)
REG32(POR_FDC_AUX_CTL_MXP_U_SMXP_2_0, 0x102f018)
    FIELD(POR_FDC_AUX_CTL_MXP_U_SMXP_2_0, CLKGATE_OVERRIDE, 4, 1)
    FIELD(POR_FDC_AUX_CTL_MXP_U_SMXP_2_0, RESERVED_0, 0, 4)
REG32(POR_ERRFR_P0_D0_U_SMXP_2_0, 0x102f040)
    FIELD(POR_ERRFR_P0_D0_U_SMXP_2_0, FI, 6, 2)
    FIELD(POR_ERRFR_P0_D0_U_SMXP_2_0, UI, 4, 2)
    FIELD(POR_ERRFR_P0_D0_U_SMXP_2_0, ED, 0, 2)
REG32(POR_ERRCTLR_P0_D0_U_SMXP_2_0, 0x102f048)
    FIELD(POR_ERRCTLR_P0_D0_U_SMXP_2_0, RESERVED_32, 32, 32)
    FIELD(POR_ERRCTLR_P0_D0_U_SMXP_2_0, ERC, 14, 18)
    FIELD(POR_ERRCTLR_P0_D0_U_SMXP_2_0, FI, 3, 1)
    FIELD(POR_ERRCTLR_P0_D0_U_SMXP_2_0, UI, 2, 1)
    FIELD(POR_ERRCTLR_P0_D0_U_SMXP_2_0, ED, 0, 1)
REG32(POR_ERRSTATUS_P0_D0_U_SMXP_2_0, 0x102f050)
    FIELD(POR_ERRSTATUS_P0_D0_U_SMXP_2_0, RESERVED_31, 31, 33)
    FIELD(POR_ERRSTATUS_P0_D0_U_SMXP_2_0, V, 30, 1)
    FIELD(POR_ERRSTATUS_P0_D0_U_SMXP_2_0, UE, 29, 1)
    FIELD(POR_ERRSTATUS_P0_D0_U_SMXP_2_0, RESERVED_28, 28, 1)
    FIELD(POR_ERRSTATUS_P0_D0_U_SMXP_2_0, OF, 27, 1)
    FIELD(POR_ERRSTATUS_P0_D0_U_SMXP_2_0, RESERVED_24, 24, 3)
    FIELD(POR_ERRSTATUS_P0_D0_U_SMXP_2_0, DE, 23, 1)
    FIELD(POR_ERRSTATUS_P0_D0_U_SMXP_2_0, RESERVED_16, 16, 7)
    FIELD(POR_ERRSTATUS_P0_D0_U_SMXP_2_0, V_ERR_TYPE, 6, 10)
    FIELD(POR_ERRSTATUS_P0_D0_U_SMXP_2_0, RESERVED_0, 0, 6)
REG32(POR_FDC_AUX_CTL_P0_D0_U_SMXP_2_0, 0x102f058)
    FIELD(POR_FDC_AUX_CTL_P0_D0_U_SMXP_2_0, CLKGATE_OVERRIDE, 4, 1)
    FIELD(POR_FDC_AUX_CTL_P0_D0_U_SMXP_2_0, HANG_DET_CONFIG, 0, 4)
REG32(POR_ERRFR_P0_D1_U_SMXP_2_0, 0x102f080)
    FIELD(POR_ERRFR_P0_D1_U_SMXP_2_0, FI, 6, 2)
    FIELD(POR_ERRFR_P0_D1_U_SMXP_2_0, UI, 4, 2)
    FIELD(POR_ERRFR_P0_D1_U_SMXP_2_0, ED, 0, 2)
REG32(POR_ERRCTLR_P0_D1_U_SMXP_2_0, 0x102f088)
    FIELD(POR_ERRCTLR_P0_D1_U_SMXP_2_0, RESERVED_32, 32, 32)
    FIELD(POR_ERRCTLR_P0_D1_U_SMXP_2_0, ERC, 14, 18)
    FIELD(POR_ERRCTLR_P0_D1_U_SMXP_2_0, FI, 3, 1)
    FIELD(POR_ERRCTLR_P0_D1_U_SMXP_2_0, UI, 2, 1)
    FIELD(POR_ERRCTLR_P0_D1_U_SMXP_2_0, ED, 0, 1)
REG32(POR_ERRSTATUS_P0_D1_U_SMXP_2_0, 0x102f090)
    FIELD(POR_ERRSTATUS_P0_D1_U_SMXP_2_0, RESERVED_31, 31, 33)
    FIELD(POR_ERRSTATUS_P0_D1_U_SMXP_2_0, V, 30, 1)
    FIELD(POR_ERRSTATUS_P0_D1_U_SMXP_2_0, UE, 29, 1)
    FIELD(POR_ERRSTATUS_P0_D1_U_SMXP_2_0, RESERVED_28, 28, 1)
    FIELD(POR_ERRSTATUS_P0_D1_U_SMXP_2_0, OF, 27, 1)
    FIELD(POR_ERRSTATUS_P0_D1_U_SMXP_2_0, RESERVED_24, 24, 3)
    FIELD(POR_ERRSTATUS_P0_D1_U_SMXP_2_0, DE, 23, 1)
    FIELD(POR_ERRSTATUS_P0_D1_U_SMXP_2_0, RESERVED_16, 16, 7)
    FIELD(POR_ERRSTATUS_P0_D1_U_SMXP_2_0, V_ERR_TYPE, 6, 10)
    FIELD(POR_ERRSTATUS_P0_D1_U_SMXP_2_0, RESERVED_0, 0, 6)
REG32(POR_FDC_AUX_CTL_P0_D1_U_SMXP_2_0, 0x102f098)
    FIELD(POR_FDC_AUX_CTL_P0_D1_U_SMXP_2_0, CLKGATE_OVERRIDE, 4, 1)
    FIELD(POR_FDC_AUX_CTL_P0_D1_U_SMXP_2_0, HANG_DET_CONFIG, 0, 4)
REG32(POR_ERRFR_P0_D2_U_SMXP_2_0, 0x102f0c0)
    FIELD(POR_ERRFR_P0_D2_U_SMXP_2_0, FI, 6, 2)
    FIELD(POR_ERRFR_P0_D2_U_SMXP_2_0, UI, 4, 2)
    FIELD(POR_ERRFR_P0_D2_U_SMXP_2_0, ED, 0, 2)
REG32(POR_ERRCTLR_P0_D2_U_SMXP_2_0, 0x102f0c8)
    FIELD(POR_ERRCTLR_P0_D2_U_SMXP_2_0, RESERVED_32, 32, 32)
    FIELD(POR_ERRCTLR_P0_D2_U_SMXP_2_0, ERC, 14, 18)
    FIELD(POR_ERRCTLR_P0_D2_U_SMXP_2_0, FI, 3, 1)
    FIELD(POR_ERRCTLR_P0_D2_U_SMXP_2_0, UI, 2, 1)
    FIELD(POR_ERRCTLR_P0_D2_U_SMXP_2_0, ED, 0, 1)
REG32(POR_ERRSTATUS_P0_D2_U_SMXP_2_0, 0x102f0d0)
    FIELD(POR_ERRSTATUS_P0_D2_U_SMXP_2_0, RESERVED_31, 31, 33)
    FIELD(POR_ERRSTATUS_P0_D2_U_SMXP_2_0, V, 30, 1)
    FIELD(POR_ERRSTATUS_P0_D2_U_SMXP_2_0, UE, 29, 1)
    FIELD(POR_ERRSTATUS_P0_D2_U_SMXP_2_0, RESERVED_28, 28, 1)
    FIELD(POR_ERRSTATUS_P0_D2_U_SMXP_2_0, OF, 27, 1)
    FIELD(POR_ERRSTATUS_P0_D2_U_SMXP_2_0, RESERVED_24, 24, 3)
    FIELD(POR_ERRSTATUS_P0_D2_U_SMXP_2_0, DE, 23, 1)
    FIELD(POR_ERRSTATUS_P0_D2_U_SMXP_2_0, RESERVED_16, 16, 7)
    FIELD(POR_ERRSTATUS_P0_D2_U_SMXP_2_0, V_ERR_TYPE, 6, 10)
    FIELD(POR_ERRSTATUS_P0_D2_U_SMXP_2_0, RESERVED_0, 0, 6)
REG32(POR_FDC_AUX_CTL_P0_D2_U_SMXP_2_0, 0x102f0d8)
    FIELD(POR_FDC_AUX_CTL_P0_D2_U_SMXP_2_0, CLKGATE_OVERRIDE, 4, 1)
    FIELD(POR_FDC_AUX_CTL_P0_D2_U_SMXP_2_0, HANG_DET_CONFIG, 0, 4)
REG32(POR_ERRFR_P0_D3_U_SMXP_2_0, 0x102f100)
    FIELD(POR_ERRFR_P0_D3_U_SMXP_2_0, FI, 6, 2)
    FIELD(POR_ERRFR_P0_D3_U_SMXP_2_0, UI, 4, 2)
    FIELD(POR_ERRFR_P0_D3_U_SMXP_2_0, ED, 0, 2)
REG32(POR_ERRCTLR_P0_D3_U_SMXP_2_0, 0x102f108)
    FIELD(POR_ERRCTLR_P0_D3_U_SMXP_2_0, RESERVED_32, 32, 32)
    FIELD(POR_ERRCTLR_P0_D3_U_SMXP_2_0, ERC, 14, 18)
    FIELD(POR_ERRCTLR_P0_D3_U_SMXP_2_0, FI, 3, 1)
    FIELD(POR_ERRCTLR_P0_D3_U_SMXP_2_0, UI, 2, 1)
    FIELD(POR_ERRCTLR_P0_D3_U_SMXP_2_0, ED, 0, 1)
REG32(POR_ERRSTATUS_P0_D3_U_SMXP_2_0, 0x102f110)
    FIELD(POR_ERRSTATUS_P0_D3_U_SMXP_2_0, RESERVED_31, 31, 33)
    FIELD(POR_ERRSTATUS_P0_D3_U_SMXP_2_0, V, 30, 1)
    FIELD(POR_ERRSTATUS_P0_D3_U_SMXP_2_0, UE, 29, 1)
    FIELD(POR_ERRSTATUS_P0_D3_U_SMXP_2_0, RESERVED_28, 28, 1)
    FIELD(POR_ERRSTATUS_P0_D3_U_SMXP_2_0, OF, 27, 1)
    FIELD(POR_ERRSTATUS_P0_D3_U_SMXP_2_0, RESERVED_24, 24, 3)
    FIELD(POR_ERRSTATUS_P0_D3_U_SMXP_2_0, DE, 23, 1)
    FIELD(POR_ERRSTATUS_P0_D3_U_SMXP_2_0, RESERVED_16, 16, 7)
    FIELD(POR_ERRSTATUS_P0_D3_U_SMXP_2_0, V_ERR_TYPE, 6, 10)
    FIELD(POR_ERRSTATUS_P0_D3_U_SMXP_2_0, RESERVED_0, 0, 6)
REG32(POR_FDC_AUX_CTL_P0_D3_U_SMXP_2_0, 0x102f118)
    FIELD(POR_FDC_AUX_CTL_P0_D3_U_SMXP_2_0, CLKGATE_OVERRIDE, 4, 1)
    FIELD(POR_FDC_AUX_CTL_P0_D3_U_SMXP_2_0, HANG_DET_CONFIG, 0, 4)
REG32(POR_ERRFR_P1_D0_U_SMXP_2_0, 0x102f140)
    FIELD(POR_ERRFR_P1_D0_U_SMXP_2_0, FI, 6, 2)
    FIELD(POR_ERRFR_P1_D0_U_SMXP_2_0, UI, 4, 2)
    FIELD(POR_ERRFR_P1_D0_U_SMXP_2_0, ED, 0, 2)
REG32(POR_ERRCTLR_P1_D0_U_SMXP_2_0, 0x102f148)
    FIELD(POR_ERRCTLR_P1_D0_U_SMXP_2_0, RESERVED_32, 32, 32)
    FIELD(POR_ERRCTLR_P1_D0_U_SMXP_2_0, ERC, 14, 18)
    FIELD(POR_ERRCTLR_P1_D0_U_SMXP_2_0, FI, 3, 1)
    FIELD(POR_ERRCTLR_P1_D0_U_SMXP_2_0, UI, 2, 1)
    FIELD(POR_ERRCTLR_P1_D0_U_SMXP_2_0, ED, 0, 1)
REG32(POR_ERRSTATUS_P1_D0_U_SMXP_2_0, 0x102f150)
    FIELD(POR_ERRSTATUS_P1_D0_U_SMXP_2_0, RESERVED_31, 31, 33)
    FIELD(POR_ERRSTATUS_P1_D0_U_SMXP_2_0, V, 30, 1)
    FIELD(POR_ERRSTATUS_P1_D0_U_SMXP_2_0, UE, 29, 1)
    FIELD(POR_ERRSTATUS_P1_D0_U_SMXP_2_0, RESERVED_28, 28, 1)
    FIELD(POR_ERRSTATUS_P1_D0_U_SMXP_2_0, OF, 27, 1)
    FIELD(POR_ERRSTATUS_P1_D0_U_SMXP_2_0, RESERVED_24, 24, 3)
    FIELD(POR_ERRSTATUS_P1_D0_U_SMXP_2_0, DE, 23, 1)
    FIELD(POR_ERRSTATUS_P1_D0_U_SMXP_2_0, RESERVED_16, 16, 7)
    FIELD(POR_ERRSTATUS_P1_D0_U_SMXP_2_0, V_ERR_TYPE, 6, 10)
    FIELD(POR_ERRSTATUS_P1_D0_U_SMXP_2_0, RESERVED_0, 0, 6)
REG32(POR_FDC_AUX_CTL_P1_D0_U_SMXP_2_0, 0x102f158)
    FIELD(POR_FDC_AUX_CTL_P1_D0_U_SMXP_2_0, CLKGATE_OVERRIDE, 4, 1)
    FIELD(POR_FDC_AUX_CTL_P1_D0_U_SMXP_2_0, HANG_DET_CONFIG, 0, 4)
REG32(POR_ERRFR_P1_D1_U_SMXP_2_0, 0x102f180)
    FIELD(POR_ERRFR_P1_D1_U_SMXP_2_0, FI, 6, 2)
    FIELD(POR_ERRFR_P1_D1_U_SMXP_2_0, UI, 4, 2)
    FIELD(POR_ERRFR_P1_D1_U_SMXP_2_0, ED, 0, 2)
REG32(POR_ERRCTLR_P1_D1_U_SMXP_2_0, 0x102f188)
    FIELD(POR_ERRCTLR_P1_D1_U_SMXP_2_0, RESERVED_32, 32, 32)
    FIELD(POR_ERRCTLR_P1_D1_U_SMXP_2_0, ERC, 14, 18)
    FIELD(POR_ERRCTLR_P1_D1_U_SMXP_2_0, FI, 3, 1)
    FIELD(POR_ERRCTLR_P1_D1_U_SMXP_2_0, UI, 2, 1)
    FIELD(POR_ERRCTLR_P1_D1_U_SMXP_2_0, ED, 0, 1)
REG32(POR_ERRSTATUS_P1_D1_U_SMXP_2_0, 0x102f190)
    FIELD(POR_ERRSTATUS_P1_D1_U_SMXP_2_0, RESERVED_31, 31, 33)
    FIELD(POR_ERRSTATUS_P1_D1_U_SMXP_2_0, V, 30, 1)
    FIELD(POR_ERRSTATUS_P1_D1_U_SMXP_2_0, UE, 29, 1)
    FIELD(POR_ERRSTATUS_P1_D1_U_SMXP_2_0, RESERVED_28, 28, 1)
    FIELD(POR_ERRSTATUS_P1_D1_U_SMXP_2_0, OF, 27, 1)
    FIELD(POR_ERRSTATUS_P1_D1_U_SMXP_2_0, RESERVED_24, 24, 3)
    FIELD(POR_ERRSTATUS_P1_D1_U_SMXP_2_0, DE, 23, 1)
    FIELD(POR_ERRSTATUS_P1_D1_U_SMXP_2_0, RESERVED_16, 16, 7)
    FIELD(POR_ERRSTATUS_P1_D1_U_SMXP_2_0, V_ERR_TYPE, 6, 10)
    FIELD(POR_ERRSTATUS_P1_D1_U_SMXP_2_0, RESERVED_0, 0, 6)
REG32(POR_FDC_AUX_CTL_P1_D1_U_SMXP_2_0, 0x102f198)
    FIELD(POR_FDC_AUX_CTL_P1_D1_U_SMXP_2_0, CLKGATE_OVERRIDE, 4, 1)
    FIELD(POR_FDC_AUX_CTL_P1_D1_U_SMXP_2_0, HANG_DET_CONFIG, 0, 4)
REG32(POR_ERRFR_P1_D2_U_SMXP_2_0, 0x102f1c0)
    FIELD(POR_ERRFR_P1_D2_U_SMXP_2_0, FI, 6, 2)
    FIELD(POR_ERRFR_P1_D2_U_SMXP_2_0, UI, 4, 2)
    FIELD(POR_ERRFR_P1_D2_U_SMXP_2_0, ED, 0, 2)
REG32(POR_ERRCTLR_P1_D2_U_SMXP_2_0, 0x102f1c8)
    FIELD(POR_ERRCTLR_P1_D2_U_SMXP_2_0, RESERVED_32, 32, 32)
    FIELD(POR_ERRCTLR_P1_D2_U_SMXP_2_0, ERC, 14, 18)
    FIELD(POR_ERRCTLR_P1_D2_U_SMXP_2_0, FI, 3, 1)
    FIELD(POR_ERRCTLR_P1_D2_U_SMXP_2_0, UI, 2, 1)
    FIELD(POR_ERRCTLR_P1_D2_U_SMXP_2_0, ED, 0, 1)
REG32(POR_ERRSTATUS_P1_D2_U_SMXP_2_0, 0x102f1d0)
    FIELD(POR_ERRSTATUS_P1_D2_U_SMXP_2_0, RESERVED_31, 31, 33)
    FIELD(POR_ERRSTATUS_P1_D2_U_SMXP_2_0, V, 30, 1)
    FIELD(POR_ERRSTATUS_P1_D2_U_SMXP_2_0, UE, 29, 1)
    FIELD(POR_ERRSTATUS_P1_D2_U_SMXP_2_0, RESERVED_28, 28, 1)
    FIELD(POR_ERRSTATUS_P1_D2_U_SMXP_2_0, OF, 27, 1)
    FIELD(POR_ERRSTATUS_P1_D2_U_SMXP_2_0, RESERVED_24, 24, 3)
    FIELD(POR_ERRSTATUS_P1_D2_U_SMXP_2_0, DE, 23, 1)
    FIELD(POR_ERRSTATUS_P1_D2_U_SMXP_2_0, RESERVED_16, 16, 7)
    FIELD(POR_ERRSTATUS_P1_D2_U_SMXP_2_0, V_ERR_TYPE, 6, 10)
    FIELD(POR_ERRSTATUS_P1_D2_U_SMXP_2_0, RESERVED_0, 0, 6)
REG32(POR_FDC_AUX_CTL_P1_D2_U_SMXP_2_0, 0x102f1d8)
    FIELD(POR_FDC_AUX_CTL_P1_D2_U_SMXP_2_0, CLKGATE_OVERRIDE, 4, 1)
    FIELD(POR_FDC_AUX_CTL_P1_D2_U_SMXP_2_0, HANG_DET_CONFIG, 0, 4)
REG32(POR_ERRFR_P1_D3_U_SMXP_2_0, 0x102f200)
    FIELD(POR_ERRFR_P1_D3_U_SMXP_2_0, FI, 6, 2)
    FIELD(POR_ERRFR_P1_D3_U_SMXP_2_0, UI, 4, 2)
    FIELD(POR_ERRFR_P1_D3_U_SMXP_2_0, ED, 0, 2)
REG32(POR_ERRCTLR_P1_D3_U_SMXP_2_0, 0x102f208)
    FIELD(POR_ERRCTLR_P1_D3_U_SMXP_2_0, RESERVED_32, 32, 32)
    FIELD(POR_ERRCTLR_P1_D3_U_SMXP_2_0, ERC, 14, 18)
    FIELD(POR_ERRCTLR_P1_D3_U_SMXP_2_0, FI, 3, 1)
    FIELD(POR_ERRCTLR_P1_D3_U_SMXP_2_0, UI, 2, 1)
    FIELD(POR_ERRCTLR_P1_D3_U_SMXP_2_0, ED, 0, 1)
REG32(POR_ERRSTATUS_P1_D3_U_SMXP_2_0, 0x102f210)
    FIELD(POR_ERRSTATUS_P1_D3_U_SMXP_2_0, RESERVED_31, 31, 33)
    FIELD(POR_ERRSTATUS_P1_D3_U_SMXP_2_0, V, 30, 1)
    FIELD(POR_ERRSTATUS_P1_D3_U_SMXP_2_0, UE, 29, 1)
    FIELD(POR_ERRSTATUS_P1_D3_U_SMXP_2_0, RESERVED_28, 28, 1)
    FIELD(POR_ERRSTATUS_P1_D3_U_SMXP_2_0, OF, 27, 1)
    FIELD(POR_ERRSTATUS_P1_D3_U_SMXP_2_0, RESERVED_24, 24, 3)
    FIELD(POR_ERRSTATUS_P1_D3_U_SMXP_2_0, DE, 23, 1)
    FIELD(POR_ERRSTATUS_P1_D3_U_SMXP_2_0, RESERVED_16, 16, 7)
    FIELD(POR_ERRSTATUS_P1_D3_U_SMXP_2_0, V_ERR_TYPE, 6, 10)
    FIELD(POR_ERRSTATUS_P1_D3_U_SMXP_2_0, RESERVED_0, 0, 6)
REG32(POR_FDC_AUX_CTL_P1_D3_U_SMXP_2_0, 0x102f218)
    FIELD(POR_FDC_AUX_CTL_P1_D3_U_SMXP_2_0, CLKGATE_OVERRIDE, 4, 1)
    FIELD(POR_FDC_AUX_CTL_P1_D3_U_SMXP_2_0, HANG_DET_CONFIG, 0, 4)
REG32(POR_ERRINJECT_U_SMXP_2_0, 0x102f300)
    FIELD(POR_ERRINJECT_U_SMXP_2_0, ERR_DEV, 4, 4)
    FIELD(POR_ERRINJECT_U_SMXP_2_0, ERR_TYPE, 0, 4)
REG32(POR_FDC_KEY_U_SMXP_2_0, 0x102f308)
    FIELD(POR_FDC_KEY_U_SMXP_2_0, KEY, 0, 8)
REG32(POR_MPU_NODE_INFO_U_RNI_NID132, 0x1034000)
    FIELD(POR_MPU_NODE_INFO_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_NODE_INFO_U_RNI_NID132, LOGICAL_ID, 32, 16)
    FIELD(POR_MPU_NODE_INFO_U_RNI_NID132, NODE_ID, 16, 16)
    FIELD(POR_MPU_NODE_INFO_U_RNI_NID132, NODE_TYPE, 0, 16)
REG32(POR_MPU_CHILD_INFO_U_RNI_NID132, 0x1034080)
    FIELD(POR_MPU_CHILD_INFO_U_RNI_NID132, RESERVED_32, 32, 32)
    FIELD(POR_MPU_CHILD_INFO_U_RNI_NID132, CHILD_PTR_OFFSET, 16, 16)
    FIELD(POR_MPU_CHILD_INFO_U_RNI_NID132, CHILD_COUNT, 0, 16)
REG32(POR_MPU_UNIT_INFO_U_RNI_NID132, 0x1034900)
    FIELD(POR_MPU_UNIT_INFO_U_RNI_NID132, RESERVED_16, 16, 48)
    FIELD(POR_MPU_UNIT_INFO_U_RNI_NID132, MASTER_7_PRESENT, 15, 1)
    FIELD(POR_MPU_UNIT_INFO_U_RNI_NID132, MASTER_6_PRESENT, 14, 1)
    FIELD(POR_MPU_UNIT_INFO_U_RNI_NID132, MASTER_5_PRESENT, 13, 1)
    FIELD(POR_MPU_UNIT_INFO_U_RNI_NID132, MASTER_4_PRESENT, 12, 1)
    FIELD(POR_MPU_UNIT_INFO_U_RNI_NID132, MASTER_3_PRESENT, 11, 1)
    FIELD(POR_MPU_UNIT_INFO_U_RNI_NID132, MASTER_2_PRESENT, 10, 1)
    FIELD(POR_MPU_UNIT_INFO_U_RNI_NID132, MASTER_1_PRESENT, 9, 1)
    FIELD(POR_MPU_UNIT_INFO_U_RNI_NID132, MASTER_0_PRESENT, 8, 1)
    FIELD(POR_MPU_UNIT_INFO_U_RNI_NID132, NUM_PROG_REGION, 0, 8)
REG32(POR_MPU_M0_CTL_U_RNI_NID132, 0x1035000)
    FIELD(POR_MPU_M0_CTL_U_RNI_NID132, M0_EN, 2, 1)
    FIELD(POR_MPU_M0_CTL_U_RNI_NID132, M0_ACTION, 0, 2)
REG32(POR_MPU_M0_PRBAR0_U_RNI_NID132, 0x1035010)
    FIELD(POR_MPU_M0_PRBAR0_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR0_U_RNI_NID132, REGION0_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR0_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR0_U_RNI_NID132, REGION0_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR0_U_RNI_NID132, REGION0_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR0_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR0_U_RNI_NID132, 0x1035018)
    FIELD(POR_MPU_M0_PRLAR0_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR0_U_RNI_NID132, REGION0_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR0_U_RNI_NID132, REGION0_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR1_U_RNI_NID132, 0x1035020)
    FIELD(POR_MPU_M0_PRBAR1_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR1_U_RNI_NID132, REGION1_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR1_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR1_U_RNI_NID132, REGION1_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR1_U_RNI_NID132, REGION1_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR1_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR1_U_RNI_NID132, 0x1035028)
    FIELD(POR_MPU_M0_PRLAR1_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR1_U_RNI_NID132, REGION1_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR1_U_RNI_NID132, REGION1_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR2_U_RNI_NID132, 0x1035030)
    FIELD(POR_MPU_M0_PRBAR2_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR2_U_RNI_NID132, REGION2_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR2_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR2_U_RNI_NID132, REGION2_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR2_U_RNI_NID132, REGION2_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR2_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR2_U_RNI_NID132, 0x1035038)
    FIELD(POR_MPU_M0_PRLAR2_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR2_U_RNI_NID132, REGION2_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR2_U_RNI_NID132, REGION2_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR3_U_RNI_NID132, 0x1035040)
    FIELD(POR_MPU_M0_PRBAR3_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR3_U_RNI_NID132, REGION3_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR3_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR3_U_RNI_NID132, REGION3_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR3_U_RNI_NID132, REGION3_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR3_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR3_U_RNI_NID132, 0x1035048)
    FIELD(POR_MPU_M0_PRLAR3_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR3_U_RNI_NID132, REGION3_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR3_U_RNI_NID132, REGION3_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR4_U_RNI_NID132, 0x1035050)
    FIELD(POR_MPU_M0_PRBAR4_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR4_U_RNI_NID132, REGION4_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR4_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR4_U_RNI_NID132, REGION4_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR4_U_RNI_NID132, REGION4_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR4_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR4_U_RNI_NID132, 0x1035058)
    FIELD(POR_MPU_M0_PRLAR4_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR4_U_RNI_NID132, REGION4_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR4_U_RNI_NID132, REGION4_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR5_U_RNI_NID132, 0x1035060)
    FIELD(POR_MPU_M0_PRBAR5_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR5_U_RNI_NID132, REGION5_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR5_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR5_U_RNI_NID132, REGION5_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR5_U_RNI_NID132, REGION5_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR5_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR5_U_RNI_NID132, 0x1035068)
    FIELD(POR_MPU_M0_PRLAR5_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR5_U_RNI_NID132, REGION5_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR5_U_RNI_NID132, REGION5_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR6_U_RNI_NID132, 0x1035070)
    FIELD(POR_MPU_M0_PRBAR6_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR6_U_RNI_NID132, REGION6_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR6_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR6_U_RNI_NID132, REGION6_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR6_U_RNI_NID132, REGION6_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR6_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR6_U_RNI_NID132, 0x1035078)
    FIELD(POR_MPU_M0_PRLAR6_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR6_U_RNI_NID132, REGION6_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR6_U_RNI_NID132, REGION6_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR7_U_RNI_NID132, 0x1035080)
    FIELD(POR_MPU_M0_PRBAR7_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR7_U_RNI_NID132, REGION7_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR7_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR7_U_RNI_NID132, REGION7_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR7_U_RNI_NID132, REGION7_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR7_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR7_U_RNI_NID132, 0x1035088)
    FIELD(POR_MPU_M0_PRLAR7_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR7_U_RNI_NID132, REGION7_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR7_U_RNI_NID132, REGION7_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR8_U_RNI_NID132, 0x1035090)
    FIELD(POR_MPU_M0_PRBAR8_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR8_U_RNI_NID132, REGION8_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR8_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR8_U_RNI_NID132, REGION8_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR8_U_RNI_NID132, REGION8_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR8_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR8_U_RNI_NID132, 0x1035098)
    FIELD(POR_MPU_M0_PRLAR8_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR8_U_RNI_NID132, REGION8_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR8_U_RNI_NID132, REGION8_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR9_U_RNI_NID132, 0x10350a0)
    FIELD(POR_MPU_M0_PRBAR9_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR9_U_RNI_NID132, REGION9_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR9_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR9_U_RNI_NID132, REGION9_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR9_U_RNI_NID132, REGION9_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR9_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR9_U_RNI_NID132, 0x10350a8)
    FIELD(POR_MPU_M0_PRLAR9_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR9_U_RNI_NID132, REGION9_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR9_U_RNI_NID132, REGION9_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR10_U_RNI_NID132, 0x10350b0)
    FIELD(POR_MPU_M0_PRBAR10_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR10_U_RNI_NID132, REGION10_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR10_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR10_U_RNI_NID132, REGION10_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR10_U_RNI_NID132, REGION10_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR10_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR10_U_RNI_NID132, 0x10350b8)
    FIELD(POR_MPU_M0_PRLAR10_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR10_U_RNI_NID132, REGION10_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR10_U_RNI_NID132, REGION10_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR11_U_RNI_NID132, 0x10350c0)
    FIELD(POR_MPU_M0_PRBAR11_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR11_U_RNI_NID132, REGION11_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR11_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR11_U_RNI_NID132, REGION11_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR11_U_RNI_NID132, REGION11_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR11_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR11_U_RNI_NID132, 0x10350c8)
    FIELD(POR_MPU_M0_PRLAR11_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR11_U_RNI_NID132, REGION11_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR11_U_RNI_NID132, REGION11_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR12_U_RNI_NID132, 0x10350d0)
    FIELD(POR_MPU_M0_PRBAR12_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR12_U_RNI_NID132, REGION12_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR12_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR12_U_RNI_NID132, REGION12_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR12_U_RNI_NID132, REGION12_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR12_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR12_U_RNI_NID132, 0x10350d8)
    FIELD(POR_MPU_M0_PRLAR12_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR12_U_RNI_NID132, REGION12_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR12_U_RNI_NID132, REGION12_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR13_U_RNI_NID132, 0x10350e0)
    FIELD(POR_MPU_M0_PRBAR13_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR13_U_RNI_NID132, REGION13_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR13_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR13_U_RNI_NID132, REGION13_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR13_U_RNI_NID132, REGION13_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR13_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR13_U_RNI_NID132, 0x10350e8)
    FIELD(POR_MPU_M0_PRLAR13_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR13_U_RNI_NID132, REGION13_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR13_U_RNI_NID132, REGION13_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR14_U_RNI_NID132, 0x10350f0)
    FIELD(POR_MPU_M0_PRBAR14_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR14_U_RNI_NID132, REGION14_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR14_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR14_U_RNI_NID132, REGION14_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR14_U_RNI_NID132, REGION14_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR14_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR14_U_RNI_NID132, 0x10350f8)
    FIELD(POR_MPU_M0_PRLAR14_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR14_U_RNI_NID132, REGION14_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR14_U_RNI_NID132, REGION14_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR15_U_RNI_NID132, 0x1035100)
    FIELD(POR_MPU_M0_PRBAR15_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR15_U_RNI_NID132, REGION15_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR15_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR15_U_RNI_NID132, REGION15_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR15_U_RNI_NID132, REGION15_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR15_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR15_U_RNI_NID132, 0x1035108)
    FIELD(POR_MPU_M0_PRLAR15_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR15_U_RNI_NID132, REGION15_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR15_U_RNI_NID132, REGION15_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR16_U_RNI_NID132, 0x1035110)
    FIELD(POR_MPU_M0_PRBAR16_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR16_U_RNI_NID132, REGION16_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR16_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR16_U_RNI_NID132, REGION16_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR16_U_RNI_NID132, REGION16_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR16_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR16_U_RNI_NID132, 0x1035118)
    FIELD(POR_MPU_M0_PRLAR16_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR16_U_RNI_NID132, REGION16_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR16_U_RNI_NID132, REGION16_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR17_U_RNI_NID132, 0x1035120)
    FIELD(POR_MPU_M0_PRBAR17_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR17_U_RNI_NID132, REGION17_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR17_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR17_U_RNI_NID132, REGION17_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR17_U_RNI_NID132, REGION17_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR17_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR17_U_RNI_NID132, 0x1035128)
    FIELD(POR_MPU_M0_PRLAR17_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR17_U_RNI_NID132, REGION17_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR17_U_RNI_NID132, REGION17_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR18_U_RNI_NID132, 0x1035130)
    FIELD(POR_MPU_M0_PRBAR18_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR18_U_RNI_NID132, REGION18_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR18_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR18_U_RNI_NID132, REGION18_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR18_U_RNI_NID132, REGION18_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR18_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR18_U_RNI_NID132, 0x1035138)
    FIELD(POR_MPU_M0_PRLAR18_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR18_U_RNI_NID132, REGION18_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR18_U_RNI_NID132, REGION18_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR19_U_RNI_NID132, 0x1035140)
    FIELD(POR_MPU_M0_PRBAR19_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR19_U_RNI_NID132, REGION19_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR19_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR19_U_RNI_NID132, REGION19_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR19_U_RNI_NID132, REGION19_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR19_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR19_U_RNI_NID132, 0x1035148)
    FIELD(POR_MPU_M0_PRLAR19_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR19_U_RNI_NID132, REGION19_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR19_U_RNI_NID132, REGION19_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR20_U_RNI_NID132, 0x1035150)
    FIELD(POR_MPU_M0_PRBAR20_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR20_U_RNI_NID132, REGION20_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR20_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR20_U_RNI_NID132, REGION20_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR20_U_RNI_NID132, REGION20_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR20_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR20_U_RNI_NID132, 0x1035158)
    FIELD(POR_MPU_M0_PRLAR20_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR20_U_RNI_NID132, REGION20_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR20_U_RNI_NID132, REGION20_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR21_U_RNI_NID132, 0x1035160)
    FIELD(POR_MPU_M0_PRBAR21_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR21_U_RNI_NID132, REGION21_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR21_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR21_U_RNI_NID132, REGION21_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR21_U_RNI_NID132, REGION21_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR21_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR21_U_RNI_NID132, 0x1035168)
    FIELD(POR_MPU_M0_PRLAR21_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR21_U_RNI_NID132, REGION21_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR21_U_RNI_NID132, REGION21_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR22_U_RNI_NID132, 0x1035170)
    FIELD(POR_MPU_M0_PRBAR22_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR22_U_RNI_NID132, REGION22_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR22_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR22_U_RNI_NID132, REGION22_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR22_U_RNI_NID132, REGION22_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR22_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR22_U_RNI_NID132, 0x1035178)
    FIELD(POR_MPU_M0_PRLAR22_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR22_U_RNI_NID132, REGION22_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR22_U_RNI_NID132, REGION22_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR23_U_RNI_NID132, 0x1035180)
    FIELD(POR_MPU_M0_PRBAR23_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR23_U_RNI_NID132, REGION23_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR23_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR23_U_RNI_NID132, REGION23_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR23_U_RNI_NID132, REGION23_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR23_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR23_U_RNI_NID132, 0x1035188)
    FIELD(POR_MPU_M0_PRLAR23_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR23_U_RNI_NID132, REGION23_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR23_U_RNI_NID132, REGION23_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR24_U_RNI_NID132, 0x1035190)
    FIELD(POR_MPU_M0_PRBAR24_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR24_U_RNI_NID132, REGION24_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR24_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR24_U_RNI_NID132, REGION24_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR24_U_RNI_NID132, REGION24_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR24_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR24_U_RNI_NID132, 0x1035198)
    FIELD(POR_MPU_M0_PRLAR24_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR24_U_RNI_NID132, REGION24_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR24_U_RNI_NID132, REGION24_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR25_U_RNI_NID132, 0x10351a0)
    FIELD(POR_MPU_M0_PRBAR25_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR25_U_RNI_NID132, REGION25_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR25_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR25_U_RNI_NID132, REGION25_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR25_U_RNI_NID132, REGION25_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR25_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR25_U_RNI_NID132, 0x10351a8)
    FIELD(POR_MPU_M0_PRLAR25_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR25_U_RNI_NID132, REGION25_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR25_U_RNI_NID132, REGION25_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR26_U_RNI_NID132, 0x10351b0)
    FIELD(POR_MPU_M0_PRBAR26_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR26_U_RNI_NID132, REGION26_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR26_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR26_U_RNI_NID132, REGION26_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR26_U_RNI_NID132, REGION26_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR26_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR26_U_RNI_NID132, 0x10351b8)
    FIELD(POR_MPU_M0_PRLAR26_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR26_U_RNI_NID132, REGION26_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR26_U_RNI_NID132, REGION26_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR27_U_RNI_NID132, 0x10351c0)
    FIELD(POR_MPU_M0_PRBAR27_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR27_U_RNI_NID132, REGION27_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR27_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR27_U_RNI_NID132, REGION27_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR27_U_RNI_NID132, REGION27_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR27_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR27_U_RNI_NID132, 0x10351c8)
    FIELD(POR_MPU_M0_PRLAR27_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR27_U_RNI_NID132, REGION27_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR27_U_RNI_NID132, REGION27_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR28_U_RNI_NID132, 0x10351d0)
    FIELD(POR_MPU_M0_PRBAR28_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR28_U_RNI_NID132, REGION28_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR28_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR28_U_RNI_NID132, REGION28_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR28_U_RNI_NID132, REGION28_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR28_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR28_U_RNI_NID132, 0x10351d8)
    FIELD(POR_MPU_M0_PRLAR28_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR28_U_RNI_NID132, REGION28_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR28_U_RNI_NID132, REGION28_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR29_U_RNI_NID132, 0x10351e0)
    FIELD(POR_MPU_M0_PRBAR29_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR29_U_RNI_NID132, REGION29_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR29_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR29_U_RNI_NID132, REGION29_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR29_U_RNI_NID132, REGION29_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR29_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR29_U_RNI_NID132, 0x10351e8)
    FIELD(POR_MPU_M0_PRLAR29_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR29_U_RNI_NID132, REGION29_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR29_U_RNI_NID132, REGION29_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR30_U_RNI_NID132, 0x10351f0)
    FIELD(POR_MPU_M0_PRBAR30_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR30_U_RNI_NID132, REGION30_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR30_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR30_U_RNI_NID132, REGION30_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR30_U_RNI_NID132, REGION30_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR30_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR30_U_RNI_NID132, 0x10351f8)
    FIELD(POR_MPU_M0_PRLAR30_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR30_U_RNI_NID132, REGION30_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR30_U_RNI_NID132, REGION30_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR31_U_RNI_NID132, 0x1035200)
    FIELD(POR_MPU_M0_PRBAR31_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR31_U_RNI_NID132, REGION31_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR31_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR31_U_RNI_NID132, REGION31_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR31_U_RNI_NID132, REGION31_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR31_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR31_U_RNI_NID132, 0x1035208)
    FIELD(POR_MPU_M0_PRLAR31_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR31_U_RNI_NID132, REGION31_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR31_U_RNI_NID132, REGION31_EN, 0, 1)
REG32(POR_MPU_M1_CTL_U_RNI_NID132, 0x1035400)
    FIELD(POR_MPU_M1_CTL_U_RNI_NID132, M1_EN, 2, 1)
    FIELD(POR_MPU_M1_CTL_U_RNI_NID132, M1_ACTION, 0, 2)
REG32(POR_MPU_M1_PRBAR0_U_RNI_NID132, 0x1035410)
    FIELD(POR_MPU_M1_PRBAR0_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR0_U_RNI_NID132, REGION0_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR0_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR0_U_RNI_NID132, REGION0_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR0_U_RNI_NID132, REGION0_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR0_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR0_U_RNI_NID132, 0x1035418)
    FIELD(POR_MPU_M1_PRLAR0_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR0_U_RNI_NID132, REGION0_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR0_U_RNI_NID132, REGION0_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR1_U_RNI_NID132, 0x1035420)
    FIELD(POR_MPU_M1_PRBAR1_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR1_U_RNI_NID132, REGION1_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR1_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR1_U_RNI_NID132, REGION1_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR1_U_RNI_NID132, REGION1_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR1_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR1_U_RNI_NID132, 0x1035428)
    FIELD(POR_MPU_M1_PRLAR1_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR1_U_RNI_NID132, REGION1_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR1_U_RNI_NID132, REGION1_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR2_U_RNI_NID132, 0x1035430)
    FIELD(POR_MPU_M1_PRBAR2_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR2_U_RNI_NID132, REGION2_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR2_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR2_U_RNI_NID132, REGION2_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR2_U_RNI_NID132, REGION2_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR2_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR2_U_RNI_NID132, 0x1035438)
    FIELD(POR_MPU_M1_PRLAR2_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR2_U_RNI_NID132, REGION2_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR2_U_RNI_NID132, REGION2_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR3_U_RNI_NID132, 0x1035440)
    FIELD(POR_MPU_M1_PRBAR3_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR3_U_RNI_NID132, REGION3_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR3_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR3_U_RNI_NID132, REGION3_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR3_U_RNI_NID132, REGION3_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR3_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR3_U_RNI_NID132, 0x1035448)
    FIELD(POR_MPU_M1_PRLAR3_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR3_U_RNI_NID132, REGION3_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR3_U_RNI_NID132, REGION3_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR4_U_RNI_NID132, 0x1035450)
    FIELD(POR_MPU_M1_PRBAR4_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR4_U_RNI_NID132, REGION4_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR4_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR4_U_RNI_NID132, REGION4_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR4_U_RNI_NID132, REGION4_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR4_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR4_U_RNI_NID132, 0x1035458)
    FIELD(POR_MPU_M1_PRLAR4_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR4_U_RNI_NID132, REGION4_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR4_U_RNI_NID132, REGION4_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR5_U_RNI_NID132, 0x1035460)
    FIELD(POR_MPU_M1_PRBAR5_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR5_U_RNI_NID132, REGION5_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR5_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR5_U_RNI_NID132, REGION5_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR5_U_RNI_NID132, REGION5_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR5_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR5_U_RNI_NID132, 0x1035468)
    FIELD(POR_MPU_M1_PRLAR5_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR5_U_RNI_NID132, REGION5_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR5_U_RNI_NID132, REGION5_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR6_U_RNI_NID132, 0x1035470)
    FIELD(POR_MPU_M1_PRBAR6_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR6_U_RNI_NID132, REGION6_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR6_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR6_U_RNI_NID132, REGION6_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR6_U_RNI_NID132, REGION6_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR6_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR6_U_RNI_NID132, 0x1035478)
    FIELD(POR_MPU_M1_PRLAR6_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR6_U_RNI_NID132, REGION6_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR6_U_RNI_NID132, REGION6_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR7_U_RNI_NID132, 0x1035480)
    FIELD(POR_MPU_M1_PRBAR7_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR7_U_RNI_NID132, REGION7_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR7_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR7_U_RNI_NID132, REGION7_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR7_U_RNI_NID132, REGION7_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR7_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR7_U_RNI_NID132, 0x1035488)
    FIELD(POR_MPU_M1_PRLAR7_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR7_U_RNI_NID132, REGION7_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR7_U_RNI_NID132, REGION7_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR8_U_RNI_NID132, 0x1035490)
    FIELD(POR_MPU_M1_PRBAR8_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR8_U_RNI_NID132, REGION8_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR8_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR8_U_RNI_NID132, REGION8_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR8_U_RNI_NID132, REGION8_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR8_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR8_U_RNI_NID132, 0x1035498)
    FIELD(POR_MPU_M1_PRLAR8_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR8_U_RNI_NID132, REGION8_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR8_U_RNI_NID132, REGION8_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR9_U_RNI_NID132, 0x10354a0)
    FIELD(POR_MPU_M1_PRBAR9_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR9_U_RNI_NID132, REGION9_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR9_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR9_U_RNI_NID132, REGION9_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR9_U_RNI_NID132, REGION9_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR9_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR9_U_RNI_NID132, 0x10354a8)
    FIELD(POR_MPU_M1_PRLAR9_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR9_U_RNI_NID132, REGION9_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR9_U_RNI_NID132, REGION9_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR10_U_RNI_NID132, 0x10354b0)
    FIELD(POR_MPU_M1_PRBAR10_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR10_U_RNI_NID132, REGION10_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR10_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR10_U_RNI_NID132, REGION10_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR10_U_RNI_NID132, REGION10_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR10_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR10_U_RNI_NID132, 0x10354b8)
    FIELD(POR_MPU_M1_PRLAR10_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR10_U_RNI_NID132, REGION10_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR10_U_RNI_NID132, REGION10_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR11_U_RNI_NID132, 0x10354c0)
    FIELD(POR_MPU_M1_PRBAR11_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR11_U_RNI_NID132, REGION11_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR11_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR11_U_RNI_NID132, REGION11_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR11_U_RNI_NID132, REGION11_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR11_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR11_U_RNI_NID132, 0x10354c8)
    FIELD(POR_MPU_M1_PRLAR11_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR11_U_RNI_NID132, REGION11_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR11_U_RNI_NID132, REGION11_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR12_U_RNI_NID132, 0x10354d0)
    FIELD(POR_MPU_M1_PRBAR12_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR12_U_RNI_NID132, REGION12_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR12_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR12_U_RNI_NID132, REGION12_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR12_U_RNI_NID132, REGION12_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR12_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR12_U_RNI_NID132, 0x10354d8)
    FIELD(POR_MPU_M1_PRLAR12_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR12_U_RNI_NID132, REGION12_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR12_U_RNI_NID132, REGION12_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR13_U_RNI_NID132, 0x10354e0)
    FIELD(POR_MPU_M1_PRBAR13_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR13_U_RNI_NID132, REGION13_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR13_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR13_U_RNI_NID132, REGION13_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR13_U_RNI_NID132, REGION13_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR13_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR13_U_RNI_NID132, 0x10354e8)
    FIELD(POR_MPU_M1_PRLAR13_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR13_U_RNI_NID132, REGION13_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR13_U_RNI_NID132, REGION13_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR14_U_RNI_NID132, 0x10354f0)
    FIELD(POR_MPU_M1_PRBAR14_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR14_U_RNI_NID132, REGION14_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR14_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR14_U_RNI_NID132, REGION14_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR14_U_RNI_NID132, REGION14_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR14_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR14_U_RNI_NID132, 0x10354f8)
    FIELD(POR_MPU_M1_PRLAR14_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR14_U_RNI_NID132, REGION14_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR14_U_RNI_NID132, REGION14_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR15_U_RNI_NID132, 0x1035500)
    FIELD(POR_MPU_M1_PRBAR15_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR15_U_RNI_NID132, REGION15_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR15_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR15_U_RNI_NID132, REGION15_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR15_U_RNI_NID132, REGION15_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR15_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR15_U_RNI_NID132, 0x1035508)
    FIELD(POR_MPU_M1_PRLAR15_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR15_U_RNI_NID132, REGION15_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR15_U_RNI_NID132, REGION15_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR16_U_RNI_NID132, 0x1035510)
    FIELD(POR_MPU_M1_PRBAR16_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR16_U_RNI_NID132, REGION16_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR16_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR16_U_RNI_NID132, REGION16_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR16_U_RNI_NID132, REGION16_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR16_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR16_U_RNI_NID132, 0x1035518)
    FIELD(POR_MPU_M1_PRLAR16_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR16_U_RNI_NID132, REGION16_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR16_U_RNI_NID132, REGION16_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR17_U_RNI_NID132, 0x1035520)
    FIELD(POR_MPU_M1_PRBAR17_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR17_U_RNI_NID132, REGION17_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR17_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR17_U_RNI_NID132, REGION17_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR17_U_RNI_NID132, REGION17_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR17_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR17_U_RNI_NID132, 0x1035528)
    FIELD(POR_MPU_M1_PRLAR17_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR17_U_RNI_NID132, REGION17_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR17_U_RNI_NID132, REGION17_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR18_U_RNI_NID132, 0x1035530)
    FIELD(POR_MPU_M1_PRBAR18_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR18_U_RNI_NID132, REGION18_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR18_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR18_U_RNI_NID132, REGION18_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR18_U_RNI_NID132, REGION18_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR18_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR18_U_RNI_NID132, 0x1035538)
    FIELD(POR_MPU_M1_PRLAR18_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR18_U_RNI_NID132, REGION18_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR18_U_RNI_NID132, REGION18_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR19_U_RNI_NID132, 0x1035540)
    FIELD(POR_MPU_M1_PRBAR19_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR19_U_RNI_NID132, REGION19_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR19_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR19_U_RNI_NID132, REGION19_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR19_U_RNI_NID132, REGION19_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR19_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR19_U_RNI_NID132, 0x1035548)
    FIELD(POR_MPU_M1_PRLAR19_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR19_U_RNI_NID132, REGION19_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR19_U_RNI_NID132, REGION19_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR20_U_RNI_NID132, 0x1035550)
    FIELD(POR_MPU_M1_PRBAR20_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR20_U_RNI_NID132, REGION20_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR20_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR20_U_RNI_NID132, REGION20_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR20_U_RNI_NID132, REGION20_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR20_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR20_U_RNI_NID132, 0x1035558)
    FIELD(POR_MPU_M1_PRLAR20_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR20_U_RNI_NID132, REGION20_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR20_U_RNI_NID132, REGION20_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR21_U_RNI_NID132, 0x1035560)
    FIELD(POR_MPU_M1_PRBAR21_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR21_U_RNI_NID132, REGION21_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR21_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR21_U_RNI_NID132, REGION21_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR21_U_RNI_NID132, REGION21_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR21_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR21_U_RNI_NID132, 0x1035568)
    FIELD(POR_MPU_M1_PRLAR21_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR21_U_RNI_NID132, REGION21_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR21_U_RNI_NID132, REGION21_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR22_U_RNI_NID132, 0x1035570)
    FIELD(POR_MPU_M1_PRBAR22_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR22_U_RNI_NID132, REGION22_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR22_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR22_U_RNI_NID132, REGION22_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR22_U_RNI_NID132, REGION22_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR22_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR22_U_RNI_NID132, 0x1035578)
    FIELD(POR_MPU_M1_PRLAR22_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR22_U_RNI_NID132, REGION22_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR22_U_RNI_NID132, REGION22_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR23_U_RNI_NID132, 0x1035580)
    FIELD(POR_MPU_M1_PRBAR23_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR23_U_RNI_NID132, REGION23_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR23_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR23_U_RNI_NID132, REGION23_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR23_U_RNI_NID132, REGION23_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR23_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR23_U_RNI_NID132, 0x1035588)
    FIELD(POR_MPU_M1_PRLAR23_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR23_U_RNI_NID132, REGION23_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR23_U_RNI_NID132, REGION23_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR24_U_RNI_NID132, 0x1035590)
    FIELD(POR_MPU_M1_PRBAR24_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR24_U_RNI_NID132, REGION24_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR24_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR24_U_RNI_NID132, REGION24_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR24_U_RNI_NID132, REGION24_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR24_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR24_U_RNI_NID132, 0x1035598)
    FIELD(POR_MPU_M1_PRLAR24_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR24_U_RNI_NID132, REGION24_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR24_U_RNI_NID132, REGION24_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR25_U_RNI_NID132, 0x10355a0)
    FIELD(POR_MPU_M1_PRBAR25_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR25_U_RNI_NID132, REGION25_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR25_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR25_U_RNI_NID132, REGION25_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR25_U_RNI_NID132, REGION25_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR25_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR25_U_RNI_NID132, 0x10355a8)
    FIELD(POR_MPU_M1_PRLAR25_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR25_U_RNI_NID132, REGION25_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR25_U_RNI_NID132, REGION25_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR26_U_RNI_NID132, 0x10355b0)
    FIELD(POR_MPU_M1_PRBAR26_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR26_U_RNI_NID132, REGION26_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR26_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR26_U_RNI_NID132, REGION26_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR26_U_RNI_NID132, REGION26_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR26_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR26_U_RNI_NID132, 0x10355b8)
    FIELD(POR_MPU_M1_PRLAR26_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR26_U_RNI_NID132, REGION26_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR26_U_RNI_NID132, REGION26_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR27_U_RNI_NID132, 0x10355c0)
    FIELD(POR_MPU_M1_PRBAR27_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR27_U_RNI_NID132, REGION27_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR27_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR27_U_RNI_NID132, REGION27_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR27_U_RNI_NID132, REGION27_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR27_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR27_U_RNI_NID132, 0x10355c8)
    FIELD(POR_MPU_M1_PRLAR27_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR27_U_RNI_NID132, REGION27_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR27_U_RNI_NID132, REGION27_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR28_U_RNI_NID132, 0x10355d0)
    FIELD(POR_MPU_M1_PRBAR28_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR28_U_RNI_NID132, REGION28_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR28_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR28_U_RNI_NID132, REGION28_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR28_U_RNI_NID132, REGION28_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR28_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR28_U_RNI_NID132, 0x10355d8)
    FIELD(POR_MPU_M1_PRLAR28_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR28_U_RNI_NID132, REGION28_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR28_U_RNI_NID132, REGION28_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR29_U_RNI_NID132, 0x10355e0)
    FIELD(POR_MPU_M1_PRBAR29_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR29_U_RNI_NID132, REGION29_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR29_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR29_U_RNI_NID132, REGION29_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR29_U_RNI_NID132, REGION29_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR29_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR29_U_RNI_NID132, 0x10355e8)
    FIELD(POR_MPU_M1_PRLAR29_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR29_U_RNI_NID132, REGION29_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR29_U_RNI_NID132, REGION29_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR30_U_RNI_NID132, 0x10355f0)
    FIELD(POR_MPU_M1_PRBAR30_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR30_U_RNI_NID132, REGION30_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR30_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR30_U_RNI_NID132, REGION30_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR30_U_RNI_NID132, REGION30_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR30_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR30_U_RNI_NID132, 0x10355f8)
    FIELD(POR_MPU_M1_PRLAR30_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR30_U_RNI_NID132, REGION30_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR30_U_RNI_NID132, REGION30_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR31_U_RNI_NID132, 0x1035600)
    FIELD(POR_MPU_M1_PRBAR31_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR31_U_RNI_NID132, REGION31_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR31_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR31_U_RNI_NID132, REGION31_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR31_U_RNI_NID132, REGION31_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR31_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR31_U_RNI_NID132, 0x1035608)
    FIELD(POR_MPU_M1_PRLAR31_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR31_U_RNI_NID132, REGION31_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR31_U_RNI_NID132, REGION31_EN, 0, 1)
REG32(POR_MPU_M2_CTL_U_RNI_NID132, 0x1035800)
    FIELD(POR_MPU_M2_CTL_U_RNI_NID132, M2_EN, 2, 1)
    FIELD(POR_MPU_M2_CTL_U_RNI_NID132, M2_ACTION, 0, 2)
REG32(POR_MPU_M2_PRBAR0_U_RNI_NID132, 0x1035810)
    FIELD(POR_MPU_M2_PRBAR0_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR0_U_RNI_NID132, REGION0_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR0_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR0_U_RNI_NID132, REGION0_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR0_U_RNI_NID132, REGION0_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR0_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR0_U_RNI_NID132, 0x1035818)
    FIELD(POR_MPU_M2_PRLAR0_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR0_U_RNI_NID132, REGION0_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR0_U_RNI_NID132, REGION0_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR1_U_RNI_NID132, 0x1035820)
    FIELD(POR_MPU_M2_PRBAR1_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR1_U_RNI_NID132, REGION1_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR1_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR1_U_RNI_NID132, REGION1_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR1_U_RNI_NID132, REGION1_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR1_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR1_U_RNI_NID132, 0x1035828)
    FIELD(POR_MPU_M2_PRLAR1_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR1_U_RNI_NID132, REGION1_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR1_U_RNI_NID132, REGION1_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR2_U_RNI_NID132, 0x1035830)
    FIELD(POR_MPU_M2_PRBAR2_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR2_U_RNI_NID132, REGION2_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR2_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR2_U_RNI_NID132, REGION2_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR2_U_RNI_NID132, REGION2_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR2_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR2_U_RNI_NID132, 0x1035838)
    FIELD(POR_MPU_M2_PRLAR2_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR2_U_RNI_NID132, REGION2_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR2_U_RNI_NID132, REGION2_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR3_U_RNI_NID132, 0x1035840)
    FIELD(POR_MPU_M2_PRBAR3_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR3_U_RNI_NID132, REGION3_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR3_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR3_U_RNI_NID132, REGION3_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR3_U_RNI_NID132, REGION3_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR3_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR3_U_RNI_NID132, 0x1035848)
    FIELD(POR_MPU_M2_PRLAR3_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR3_U_RNI_NID132, REGION3_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR3_U_RNI_NID132, REGION3_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR4_U_RNI_NID132, 0x1035850)
    FIELD(POR_MPU_M2_PRBAR4_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR4_U_RNI_NID132, REGION4_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR4_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR4_U_RNI_NID132, REGION4_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR4_U_RNI_NID132, REGION4_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR4_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR4_U_RNI_NID132, 0x1035858)
    FIELD(POR_MPU_M2_PRLAR4_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR4_U_RNI_NID132, REGION4_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR4_U_RNI_NID132, REGION4_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR5_U_RNI_NID132, 0x1035860)
    FIELD(POR_MPU_M2_PRBAR5_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR5_U_RNI_NID132, REGION5_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR5_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR5_U_RNI_NID132, REGION5_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR5_U_RNI_NID132, REGION5_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR5_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR5_U_RNI_NID132, 0x1035868)
    FIELD(POR_MPU_M2_PRLAR5_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR5_U_RNI_NID132, REGION5_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR5_U_RNI_NID132, REGION5_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR6_U_RNI_NID132, 0x1035870)
    FIELD(POR_MPU_M2_PRBAR6_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR6_U_RNI_NID132, REGION6_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR6_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR6_U_RNI_NID132, REGION6_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR6_U_RNI_NID132, REGION6_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR6_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR6_U_RNI_NID132, 0x1035878)
    FIELD(POR_MPU_M2_PRLAR6_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR6_U_RNI_NID132, REGION6_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR6_U_RNI_NID132, REGION6_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR7_U_RNI_NID132, 0x1035880)
    FIELD(POR_MPU_M2_PRBAR7_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR7_U_RNI_NID132, REGION7_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR7_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR7_U_RNI_NID132, REGION7_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR7_U_RNI_NID132, REGION7_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR7_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR7_U_RNI_NID132, 0x1035888)
    FIELD(POR_MPU_M2_PRLAR7_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR7_U_RNI_NID132, REGION7_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR7_U_RNI_NID132, REGION7_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR8_U_RNI_NID132, 0x1035890)
    FIELD(POR_MPU_M2_PRBAR8_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR8_U_RNI_NID132, REGION8_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR8_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR8_U_RNI_NID132, REGION8_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR8_U_RNI_NID132, REGION8_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR8_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR8_U_RNI_NID132, 0x1035898)
    FIELD(POR_MPU_M2_PRLAR8_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR8_U_RNI_NID132, REGION8_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR8_U_RNI_NID132, REGION8_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR9_U_RNI_NID132, 0x10358a0)
    FIELD(POR_MPU_M2_PRBAR9_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR9_U_RNI_NID132, REGION9_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR9_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR9_U_RNI_NID132, REGION9_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR9_U_RNI_NID132, REGION9_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR9_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR9_U_RNI_NID132, 0x10358a8)
    FIELD(POR_MPU_M2_PRLAR9_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR9_U_RNI_NID132, REGION9_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR9_U_RNI_NID132, REGION9_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR10_U_RNI_NID132, 0x10358b0)
    FIELD(POR_MPU_M2_PRBAR10_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR10_U_RNI_NID132, REGION10_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR10_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR10_U_RNI_NID132, REGION10_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR10_U_RNI_NID132, REGION10_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR10_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR10_U_RNI_NID132, 0x10358b8)
    FIELD(POR_MPU_M2_PRLAR10_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR10_U_RNI_NID132, REGION10_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR10_U_RNI_NID132, REGION10_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR11_U_RNI_NID132, 0x10358c0)
    FIELD(POR_MPU_M2_PRBAR11_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR11_U_RNI_NID132, REGION11_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR11_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR11_U_RNI_NID132, REGION11_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR11_U_RNI_NID132, REGION11_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR11_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR11_U_RNI_NID132, 0x10358c8)
    FIELD(POR_MPU_M2_PRLAR11_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR11_U_RNI_NID132, REGION11_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR11_U_RNI_NID132, REGION11_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR12_U_RNI_NID132, 0x10358d0)
    FIELD(POR_MPU_M2_PRBAR12_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR12_U_RNI_NID132, REGION12_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR12_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR12_U_RNI_NID132, REGION12_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR12_U_RNI_NID132, REGION12_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR12_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR12_U_RNI_NID132, 0x10358d8)
    FIELD(POR_MPU_M2_PRLAR12_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR12_U_RNI_NID132, REGION12_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR12_U_RNI_NID132, REGION12_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR13_U_RNI_NID132, 0x10358e0)
    FIELD(POR_MPU_M2_PRBAR13_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR13_U_RNI_NID132, REGION13_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR13_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR13_U_RNI_NID132, REGION13_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR13_U_RNI_NID132, REGION13_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR13_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR13_U_RNI_NID132, 0x10358e8)
    FIELD(POR_MPU_M2_PRLAR13_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR13_U_RNI_NID132, REGION13_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR13_U_RNI_NID132, REGION13_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR14_U_RNI_NID132, 0x10358f0)
    FIELD(POR_MPU_M2_PRBAR14_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR14_U_RNI_NID132, REGION14_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR14_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR14_U_RNI_NID132, REGION14_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR14_U_RNI_NID132, REGION14_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR14_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR14_U_RNI_NID132, 0x10358f8)
    FIELD(POR_MPU_M2_PRLAR14_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR14_U_RNI_NID132, REGION14_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR14_U_RNI_NID132, REGION14_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR15_U_RNI_NID132, 0x1035900)
    FIELD(POR_MPU_M2_PRBAR15_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR15_U_RNI_NID132, REGION15_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR15_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR15_U_RNI_NID132, REGION15_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR15_U_RNI_NID132, REGION15_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR15_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR15_U_RNI_NID132, 0x1035908)
    FIELD(POR_MPU_M2_PRLAR15_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR15_U_RNI_NID132, REGION15_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR15_U_RNI_NID132, REGION15_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR16_U_RNI_NID132, 0x1035910)
    FIELD(POR_MPU_M2_PRBAR16_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR16_U_RNI_NID132, REGION16_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR16_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR16_U_RNI_NID132, REGION16_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR16_U_RNI_NID132, REGION16_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR16_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR16_U_RNI_NID132, 0x1035918)
    FIELD(POR_MPU_M2_PRLAR16_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR16_U_RNI_NID132, REGION16_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR16_U_RNI_NID132, REGION16_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR17_U_RNI_NID132, 0x1035920)
    FIELD(POR_MPU_M2_PRBAR17_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR17_U_RNI_NID132, REGION17_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR17_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR17_U_RNI_NID132, REGION17_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR17_U_RNI_NID132, REGION17_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR17_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR17_U_RNI_NID132, 0x1035928)
    FIELD(POR_MPU_M2_PRLAR17_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR17_U_RNI_NID132, REGION17_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR17_U_RNI_NID132, REGION17_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR18_U_RNI_NID132, 0x1035930)
    FIELD(POR_MPU_M2_PRBAR18_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR18_U_RNI_NID132, REGION18_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR18_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR18_U_RNI_NID132, REGION18_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR18_U_RNI_NID132, REGION18_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR18_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR18_U_RNI_NID132, 0x1035938)
    FIELD(POR_MPU_M2_PRLAR18_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR18_U_RNI_NID132, REGION18_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR18_U_RNI_NID132, REGION18_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR19_U_RNI_NID132, 0x1035940)
    FIELD(POR_MPU_M2_PRBAR19_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR19_U_RNI_NID132, REGION19_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR19_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR19_U_RNI_NID132, REGION19_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR19_U_RNI_NID132, REGION19_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR19_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR19_U_RNI_NID132, 0x1035948)
    FIELD(POR_MPU_M2_PRLAR19_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR19_U_RNI_NID132, REGION19_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR19_U_RNI_NID132, REGION19_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR20_U_RNI_NID132, 0x1035950)
    FIELD(POR_MPU_M2_PRBAR20_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR20_U_RNI_NID132, REGION20_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR20_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR20_U_RNI_NID132, REGION20_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR20_U_RNI_NID132, REGION20_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR20_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR20_U_RNI_NID132, 0x1035958)
    FIELD(POR_MPU_M2_PRLAR20_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR20_U_RNI_NID132, REGION20_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR20_U_RNI_NID132, REGION20_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR21_U_RNI_NID132, 0x1035960)
    FIELD(POR_MPU_M2_PRBAR21_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR21_U_RNI_NID132, REGION21_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR21_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR21_U_RNI_NID132, REGION21_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR21_U_RNI_NID132, REGION21_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR21_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR21_U_RNI_NID132, 0x1035968)
    FIELD(POR_MPU_M2_PRLAR21_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR21_U_RNI_NID132, REGION21_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR21_U_RNI_NID132, REGION21_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR22_U_RNI_NID132, 0x1035970)
    FIELD(POR_MPU_M2_PRBAR22_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR22_U_RNI_NID132, REGION22_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR22_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR22_U_RNI_NID132, REGION22_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR22_U_RNI_NID132, REGION22_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR22_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR22_U_RNI_NID132, 0x1035978)
    FIELD(POR_MPU_M2_PRLAR22_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR22_U_RNI_NID132, REGION22_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR22_U_RNI_NID132, REGION22_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR23_U_RNI_NID132, 0x1035980)
    FIELD(POR_MPU_M2_PRBAR23_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR23_U_RNI_NID132, REGION23_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR23_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR23_U_RNI_NID132, REGION23_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR23_U_RNI_NID132, REGION23_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR23_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR23_U_RNI_NID132, 0x1035988)
    FIELD(POR_MPU_M2_PRLAR23_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR23_U_RNI_NID132, REGION23_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR23_U_RNI_NID132, REGION23_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR24_U_RNI_NID132, 0x1035990)
    FIELD(POR_MPU_M2_PRBAR24_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR24_U_RNI_NID132, REGION24_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR24_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR24_U_RNI_NID132, REGION24_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR24_U_RNI_NID132, REGION24_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR24_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR24_U_RNI_NID132, 0x1035998)
    FIELD(POR_MPU_M2_PRLAR24_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR24_U_RNI_NID132, REGION24_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR24_U_RNI_NID132, REGION24_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR25_U_RNI_NID132, 0x10359a0)
    FIELD(POR_MPU_M2_PRBAR25_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR25_U_RNI_NID132, REGION25_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR25_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR25_U_RNI_NID132, REGION25_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR25_U_RNI_NID132, REGION25_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR25_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR25_U_RNI_NID132, 0x10359a8)
    FIELD(POR_MPU_M2_PRLAR25_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR25_U_RNI_NID132, REGION25_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR25_U_RNI_NID132, REGION25_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR26_U_RNI_NID132, 0x10359b0)
    FIELD(POR_MPU_M2_PRBAR26_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR26_U_RNI_NID132, REGION26_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR26_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR26_U_RNI_NID132, REGION26_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR26_U_RNI_NID132, REGION26_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR26_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR26_U_RNI_NID132, 0x10359b8)
    FIELD(POR_MPU_M2_PRLAR26_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR26_U_RNI_NID132, REGION26_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR26_U_RNI_NID132, REGION26_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR27_U_RNI_NID132, 0x10359c0)
    FIELD(POR_MPU_M2_PRBAR27_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR27_U_RNI_NID132, REGION27_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR27_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR27_U_RNI_NID132, REGION27_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR27_U_RNI_NID132, REGION27_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR27_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR27_U_RNI_NID132, 0x10359c8)
    FIELD(POR_MPU_M2_PRLAR27_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR27_U_RNI_NID132, REGION27_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR27_U_RNI_NID132, REGION27_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR28_U_RNI_NID132, 0x10359d0)
    FIELD(POR_MPU_M2_PRBAR28_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR28_U_RNI_NID132, REGION28_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR28_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR28_U_RNI_NID132, REGION28_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR28_U_RNI_NID132, REGION28_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR28_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR28_U_RNI_NID132, 0x10359d8)
    FIELD(POR_MPU_M2_PRLAR28_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR28_U_RNI_NID132, REGION28_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR28_U_RNI_NID132, REGION28_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR29_U_RNI_NID132, 0x10359e0)
    FIELD(POR_MPU_M2_PRBAR29_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR29_U_RNI_NID132, REGION29_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR29_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR29_U_RNI_NID132, REGION29_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR29_U_RNI_NID132, REGION29_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR29_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR29_U_RNI_NID132, 0x10359e8)
    FIELD(POR_MPU_M2_PRLAR29_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR29_U_RNI_NID132, REGION29_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR29_U_RNI_NID132, REGION29_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR30_U_RNI_NID132, 0x10359f0)
    FIELD(POR_MPU_M2_PRBAR30_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR30_U_RNI_NID132, REGION30_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR30_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR30_U_RNI_NID132, REGION30_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR30_U_RNI_NID132, REGION30_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR30_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR30_U_RNI_NID132, 0x10359f8)
    FIELD(POR_MPU_M2_PRLAR30_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR30_U_RNI_NID132, REGION30_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR30_U_RNI_NID132, REGION30_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR31_U_RNI_NID132, 0x1035a00)
    FIELD(POR_MPU_M2_PRBAR31_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR31_U_RNI_NID132, REGION31_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR31_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR31_U_RNI_NID132, REGION31_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR31_U_RNI_NID132, REGION31_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR31_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR31_U_RNI_NID132, 0x1035a08)
    FIELD(POR_MPU_M2_PRLAR31_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR31_U_RNI_NID132, REGION31_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR31_U_RNI_NID132, REGION31_EN, 0, 1)
REG32(POR_MPU_M3_CTL_U_RNI_NID132, 0x1035c00)
    FIELD(POR_MPU_M3_CTL_U_RNI_NID132, M3_EN, 2, 1)
    FIELD(POR_MPU_M3_CTL_U_RNI_NID132, M3_ACTION, 0, 2)
REG32(POR_MPU_M3_PRBAR0_U_RNI_NID132, 0x1035c10)
    FIELD(POR_MPU_M3_PRBAR0_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR0_U_RNI_NID132, REGION0_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR0_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR0_U_RNI_NID132, REGION0_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR0_U_RNI_NID132, REGION0_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR0_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR0_U_RNI_NID132, 0x1035c18)
    FIELD(POR_MPU_M3_PRLAR0_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR0_U_RNI_NID132, REGION0_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR0_U_RNI_NID132, REGION0_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR1_U_RNI_NID132, 0x1035c20)
    FIELD(POR_MPU_M3_PRBAR1_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR1_U_RNI_NID132, REGION1_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR1_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR1_U_RNI_NID132, REGION1_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR1_U_RNI_NID132, REGION1_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR1_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR1_U_RNI_NID132, 0x1035c28)
    FIELD(POR_MPU_M3_PRLAR1_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR1_U_RNI_NID132, REGION1_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR1_U_RNI_NID132, REGION1_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR2_U_RNI_NID132, 0x1035c30)
    FIELD(POR_MPU_M3_PRBAR2_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR2_U_RNI_NID132, REGION2_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR2_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR2_U_RNI_NID132, REGION2_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR2_U_RNI_NID132, REGION2_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR2_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR2_U_RNI_NID132, 0x1035c38)
    FIELD(POR_MPU_M3_PRLAR2_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR2_U_RNI_NID132, REGION2_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR2_U_RNI_NID132, REGION2_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR3_U_RNI_NID132, 0x1035c40)
    FIELD(POR_MPU_M3_PRBAR3_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR3_U_RNI_NID132, REGION3_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR3_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR3_U_RNI_NID132, REGION3_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR3_U_RNI_NID132, REGION3_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR3_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR3_U_RNI_NID132, 0x1035c48)
    FIELD(POR_MPU_M3_PRLAR3_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR3_U_RNI_NID132, REGION3_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR3_U_RNI_NID132, REGION3_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR4_U_RNI_NID132, 0x1035c50)
    FIELD(POR_MPU_M3_PRBAR4_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR4_U_RNI_NID132, REGION4_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR4_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR4_U_RNI_NID132, REGION4_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR4_U_RNI_NID132, REGION4_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR4_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR4_U_RNI_NID132, 0x1035c58)
    FIELD(POR_MPU_M3_PRLAR4_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR4_U_RNI_NID132, REGION4_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR4_U_RNI_NID132, REGION4_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR5_U_RNI_NID132, 0x1035c60)
    FIELD(POR_MPU_M3_PRBAR5_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR5_U_RNI_NID132, REGION5_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR5_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR5_U_RNI_NID132, REGION5_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR5_U_RNI_NID132, REGION5_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR5_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR5_U_RNI_NID132, 0x1035c68)
    FIELD(POR_MPU_M3_PRLAR5_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR5_U_RNI_NID132, REGION5_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR5_U_RNI_NID132, REGION5_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR6_U_RNI_NID132, 0x1035c70)
    FIELD(POR_MPU_M3_PRBAR6_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR6_U_RNI_NID132, REGION6_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR6_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR6_U_RNI_NID132, REGION6_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR6_U_RNI_NID132, REGION6_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR6_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR6_U_RNI_NID132, 0x1035c78)
    FIELD(POR_MPU_M3_PRLAR6_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR6_U_RNI_NID132, REGION6_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR6_U_RNI_NID132, REGION6_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR7_U_RNI_NID132, 0x1035c80)
    FIELD(POR_MPU_M3_PRBAR7_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR7_U_RNI_NID132, REGION7_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR7_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR7_U_RNI_NID132, REGION7_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR7_U_RNI_NID132, REGION7_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR7_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR7_U_RNI_NID132, 0x1035c88)
    FIELD(POR_MPU_M3_PRLAR7_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR7_U_RNI_NID132, REGION7_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR7_U_RNI_NID132, REGION7_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR8_U_RNI_NID132, 0x1035c90)
    FIELD(POR_MPU_M3_PRBAR8_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR8_U_RNI_NID132, REGION8_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR8_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR8_U_RNI_NID132, REGION8_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR8_U_RNI_NID132, REGION8_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR8_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR8_U_RNI_NID132, 0x1035c98)
    FIELD(POR_MPU_M3_PRLAR8_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR8_U_RNI_NID132, REGION8_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR8_U_RNI_NID132, REGION8_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR9_U_RNI_NID132, 0x1035ca0)
    FIELD(POR_MPU_M3_PRBAR9_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR9_U_RNI_NID132, REGION9_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR9_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR9_U_RNI_NID132, REGION9_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR9_U_RNI_NID132, REGION9_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR9_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR9_U_RNI_NID132, 0x1035ca8)
    FIELD(POR_MPU_M3_PRLAR9_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR9_U_RNI_NID132, REGION9_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR9_U_RNI_NID132, REGION9_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR10_U_RNI_NID132, 0x1035cb0)
    FIELD(POR_MPU_M3_PRBAR10_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR10_U_RNI_NID132, REGION10_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR10_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR10_U_RNI_NID132, REGION10_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR10_U_RNI_NID132, REGION10_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR10_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR10_U_RNI_NID132, 0x1035cb8)
    FIELD(POR_MPU_M3_PRLAR10_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR10_U_RNI_NID132, REGION10_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR10_U_RNI_NID132, REGION10_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR11_U_RNI_NID132, 0x1035cc0)
    FIELD(POR_MPU_M3_PRBAR11_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR11_U_RNI_NID132, REGION11_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR11_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR11_U_RNI_NID132, REGION11_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR11_U_RNI_NID132, REGION11_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR11_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR11_U_RNI_NID132, 0x1035cc8)
    FIELD(POR_MPU_M3_PRLAR11_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR11_U_RNI_NID132, REGION11_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR11_U_RNI_NID132, REGION11_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR12_U_RNI_NID132, 0x1035cd0)
    FIELD(POR_MPU_M3_PRBAR12_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR12_U_RNI_NID132, REGION12_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR12_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR12_U_RNI_NID132, REGION12_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR12_U_RNI_NID132, REGION12_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR12_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR12_U_RNI_NID132, 0x1035cd8)
    FIELD(POR_MPU_M3_PRLAR12_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR12_U_RNI_NID132, REGION12_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR12_U_RNI_NID132, REGION12_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR13_U_RNI_NID132, 0x1035ce0)
    FIELD(POR_MPU_M3_PRBAR13_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR13_U_RNI_NID132, REGION13_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR13_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR13_U_RNI_NID132, REGION13_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR13_U_RNI_NID132, REGION13_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR13_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR13_U_RNI_NID132, 0x1035ce8)
    FIELD(POR_MPU_M3_PRLAR13_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR13_U_RNI_NID132, REGION13_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR13_U_RNI_NID132, REGION13_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR14_U_RNI_NID132, 0x1035cf0)
    FIELD(POR_MPU_M3_PRBAR14_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR14_U_RNI_NID132, REGION14_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR14_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR14_U_RNI_NID132, REGION14_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR14_U_RNI_NID132, REGION14_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR14_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR14_U_RNI_NID132, 0x1035cf8)
    FIELD(POR_MPU_M3_PRLAR14_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR14_U_RNI_NID132, REGION14_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR14_U_RNI_NID132, REGION14_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR15_U_RNI_NID132, 0x1035d00)
    FIELD(POR_MPU_M3_PRBAR15_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR15_U_RNI_NID132, REGION15_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR15_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR15_U_RNI_NID132, REGION15_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR15_U_RNI_NID132, REGION15_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR15_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR15_U_RNI_NID132, 0x1035d08)
    FIELD(POR_MPU_M3_PRLAR15_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR15_U_RNI_NID132, REGION15_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR15_U_RNI_NID132, REGION15_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR16_U_RNI_NID132, 0x1035d10)
    FIELD(POR_MPU_M3_PRBAR16_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR16_U_RNI_NID132, REGION16_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR16_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR16_U_RNI_NID132, REGION16_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR16_U_RNI_NID132, REGION16_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR16_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR16_U_RNI_NID132, 0x1035d18)
    FIELD(POR_MPU_M3_PRLAR16_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR16_U_RNI_NID132, REGION16_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR16_U_RNI_NID132, REGION16_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR17_U_RNI_NID132, 0x1035d20)
    FIELD(POR_MPU_M3_PRBAR17_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR17_U_RNI_NID132, REGION17_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR17_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR17_U_RNI_NID132, REGION17_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR17_U_RNI_NID132, REGION17_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR17_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR17_U_RNI_NID132, 0x1035d28)
    FIELD(POR_MPU_M3_PRLAR17_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR17_U_RNI_NID132, REGION17_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR17_U_RNI_NID132, REGION17_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR18_U_RNI_NID132, 0x1035d30)
    FIELD(POR_MPU_M3_PRBAR18_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR18_U_RNI_NID132, REGION18_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR18_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR18_U_RNI_NID132, REGION18_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR18_U_RNI_NID132, REGION18_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR18_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR18_U_RNI_NID132, 0x1035d38)
    FIELD(POR_MPU_M3_PRLAR18_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR18_U_RNI_NID132, REGION18_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR18_U_RNI_NID132, REGION18_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR19_U_RNI_NID132, 0x1035d40)
    FIELD(POR_MPU_M3_PRBAR19_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR19_U_RNI_NID132, REGION19_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR19_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR19_U_RNI_NID132, REGION19_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR19_U_RNI_NID132, REGION19_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR19_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR19_U_RNI_NID132, 0x1035d48)
    FIELD(POR_MPU_M3_PRLAR19_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR19_U_RNI_NID132, REGION19_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR19_U_RNI_NID132, REGION19_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR20_U_RNI_NID132, 0x1035d50)
    FIELD(POR_MPU_M3_PRBAR20_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR20_U_RNI_NID132, REGION20_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR20_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR20_U_RNI_NID132, REGION20_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR20_U_RNI_NID132, REGION20_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR20_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR20_U_RNI_NID132, 0x1035d58)
    FIELD(POR_MPU_M3_PRLAR20_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR20_U_RNI_NID132, REGION20_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR20_U_RNI_NID132, REGION20_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR21_U_RNI_NID132, 0x1035d60)
    FIELD(POR_MPU_M3_PRBAR21_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR21_U_RNI_NID132, REGION21_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR21_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR21_U_RNI_NID132, REGION21_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR21_U_RNI_NID132, REGION21_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR21_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR21_U_RNI_NID132, 0x1035d68)
    FIELD(POR_MPU_M3_PRLAR21_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR21_U_RNI_NID132, REGION21_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR21_U_RNI_NID132, REGION21_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR22_U_RNI_NID132, 0x1035d70)
    FIELD(POR_MPU_M3_PRBAR22_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR22_U_RNI_NID132, REGION22_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR22_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR22_U_RNI_NID132, REGION22_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR22_U_RNI_NID132, REGION22_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR22_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR22_U_RNI_NID132, 0x1035d78)
    FIELD(POR_MPU_M3_PRLAR22_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR22_U_RNI_NID132, REGION22_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR22_U_RNI_NID132, REGION22_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR23_U_RNI_NID132, 0x1035d80)
    FIELD(POR_MPU_M3_PRBAR23_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR23_U_RNI_NID132, REGION23_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR23_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR23_U_RNI_NID132, REGION23_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR23_U_RNI_NID132, REGION23_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR23_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR23_U_RNI_NID132, 0x1035d88)
    FIELD(POR_MPU_M3_PRLAR23_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR23_U_RNI_NID132, REGION23_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR23_U_RNI_NID132, REGION23_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR24_U_RNI_NID132, 0x1035d90)
    FIELD(POR_MPU_M3_PRBAR24_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR24_U_RNI_NID132, REGION24_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR24_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR24_U_RNI_NID132, REGION24_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR24_U_RNI_NID132, REGION24_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR24_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR24_U_RNI_NID132, 0x1035d98)
    FIELD(POR_MPU_M3_PRLAR24_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR24_U_RNI_NID132, REGION24_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR24_U_RNI_NID132, REGION24_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR25_U_RNI_NID132, 0x1035da0)
    FIELD(POR_MPU_M3_PRBAR25_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR25_U_RNI_NID132, REGION25_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR25_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR25_U_RNI_NID132, REGION25_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR25_U_RNI_NID132, REGION25_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR25_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR25_U_RNI_NID132, 0x1035da8)
    FIELD(POR_MPU_M3_PRLAR25_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR25_U_RNI_NID132, REGION25_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR25_U_RNI_NID132, REGION25_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR26_U_RNI_NID132, 0x1035db0)
    FIELD(POR_MPU_M3_PRBAR26_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR26_U_RNI_NID132, REGION26_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR26_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR26_U_RNI_NID132, REGION26_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR26_U_RNI_NID132, REGION26_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR26_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR26_U_RNI_NID132, 0x1035db8)
    FIELD(POR_MPU_M3_PRLAR26_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR26_U_RNI_NID132, REGION26_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR26_U_RNI_NID132, REGION26_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR27_U_RNI_NID132, 0x1035dc0)
    FIELD(POR_MPU_M3_PRBAR27_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR27_U_RNI_NID132, REGION27_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR27_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR27_U_RNI_NID132, REGION27_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR27_U_RNI_NID132, REGION27_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR27_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR27_U_RNI_NID132, 0x1035dc8)
    FIELD(POR_MPU_M3_PRLAR27_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR27_U_RNI_NID132, REGION27_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR27_U_RNI_NID132, REGION27_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR28_U_RNI_NID132, 0x1035dd0)
    FIELD(POR_MPU_M3_PRBAR28_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR28_U_RNI_NID132, REGION28_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR28_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR28_U_RNI_NID132, REGION28_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR28_U_RNI_NID132, REGION28_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR28_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR28_U_RNI_NID132, 0x1035dd8)
    FIELD(POR_MPU_M3_PRLAR28_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR28_U_RNI_NID132, REGION28_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR28_U_RNI_NID132, REGION28_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR29_U_RNI_NID132, 0x1035de0)
    FIELD(POR_MPU_M3_PRBAR29_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR29_U_RNI_NID132, REGION29_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR29_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR29_U_RNI_NID132, REGION29_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR29_U_RNI_NID132, REGION29_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR29_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR29_U_RNI_NID132, 0x1035de8)
    FIELD(POR_MPU_M3_PRLAR29_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR29_U_RNI_NID132, REGION29_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR29_U_RNI_NID132, REGION29_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR30_U_RNI_NID132, 0x1035df0)
    FIELD(POR_MPU_M3_PRBAR30_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR30_U_RNI_NID132, REGION30_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR30_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR30_U_RNI_NID132, REGION30_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR30_U_RNI_NID132, REGION30_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR30_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR30_U_RNI_NID132, 0x1035df8)
    FIELD(POR_MPU_M3_PRLAR30_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR30_U_RNI_NID132, REGION30_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR30_U_RNI_NID132, REGION30_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR31_U_RNI_NID132, 0x1035e00)
    FIELD(POR_MPU_M3_PRBAR31_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR31_U_RNI_NID132, REGION31_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR31_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR31_U_RNI_NID132, REGION31_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR31_U_RNI_NID132, REGION31_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR31_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR31_U_RNI_NID132, 0x1035e08)
    FIELD(POR_MPU_M3_PRLAR31_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR31_U_RNI_NID132, REGION31_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR31_U_RNI_NID132, REGION31_EN, 0, 1)
REG32(POR_MPU_M4_CTL_U_RNI_NID132, 0x1036000)
    FIELD(POR_MPU_M4_CTL_U_RNI_NID132, M4_EN, 2, 1)
    FIELD(POR_MPU_M4_CTL_U_RNI_NID132, M4_ACTION, 0, 2)
REG32(POR_MPU_M4_PRBAR0_U_RNI_NID132, 0x1036010)
    FIELD(POR_MPU_M4_PRBAR0_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR0_U_RNI_NID132, REGION0_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR0_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR0_U_RNI_NID132, REGION0_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR0_U_RNI_NID132, REGION0_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR0_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR0_U_RNI_NID132, 0x1036018)
    FIELD(POR_MPU_M4_PRLAR0_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR0_U_RNI_NID132, REGION0_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR0_U_RNI_NID132, REGION0_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR1_U_RNI_NID132, 0x1036020)
    FIELD(POR_MPU_M4_PRBAR1_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR1_U_RNI_NID132, REGION1_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR1_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR1_U_RNI_NID132, REGION1_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR1_U_RNI_NID132, REGION1_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR1_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR1_U_RNI_NID132, 0x1036028)
    FIELD(POR_MPU_M4_PRLAR1_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR1_U_RNI_NID132, REGION1_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR1_U_RNI_NID132, REGION1_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR2_U_RNI_NID132, 0x1036030)
    FIELD(POR_MPU_M4_PRBAR2_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR2_U_RNI_NID132, REGION2_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR2_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR2_U_RNI_NID132, REGION2_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR2_U_RNI_NID132, REGION2_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR2_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR2_U_RNI_NID132, 0x1036038)
    FIELD(POR_MPU_M4_PRLAR2_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR2_U_RNI_NID132, REGION2_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR2_U_RNI_NID132, REGION2_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR3_U_RNI_NID132, 0x1036040)
    FIELD(POR_MPU_M4_PRBAR3_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR3_U_RNI_NID132, REGION3_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR3_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR3_U_RNI_NID132, REGION3_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR3_U_RNI_NID132, REGION3_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR3_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR3_U_RNI_NID132, 0x1036048)
    FIELD(POR_MPU_M4_PRLAR3_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR3_U_RNI_NID132, REGION3_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR3_U_RNI_NID132, REGION3_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR4_U_RNI_NID132, 0x1036050)
    FIELD(POR_MPU_M4_PRBAR4_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR4_U_RNI_NID132, REGION4_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR4_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR4_U_RNI_NID132, REGION4_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR4_U_RNI_NID132, REGION4_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR4_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR4_U_RNI_NID132, 0x1036058)
    FIELD(POR_MPU_M4_PRLAR4_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR4_U_RNI_NID132, REGION4_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR4_U_RNI_NID132, REGION4_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR5_U_RNI_NID132, 0x1036060)
    FIELD(POR_MPU_M4_PRBAR5_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR5_U_RNI_NID132, REGION5_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR5_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR5_U_RNI_NID132, REGION5_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR5_U_RNI_NID132, REGION5_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR5_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR5_U_RNI_NID132, 0x1036068)
    FIELD(POR_MPU_M4_PRLAR5_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR5_U_RNI_NID132, REGION5_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR5_U_RNI_NID132, REGION5_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR6_U_RNI_NID132, 0x1036070)
    FIELD(POR_MPU_M4_PRBAR6_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR6_U_RNI_NID132, REGION6_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR6_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR6_U_RNI_NID132, REGION6_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR6_U_RNI_NID132, REGION6_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR6_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR6_U_RNI_NID132, 0x1036078)
    FIELD(POR_MPU_M4_PRLAR6_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR6_U_RNI_NID132, REGION6_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR6_U_RNI_NID132, REGION6_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR7_U_RNI_NID132, 0x1036080)
    FIELD(POR_MPU_M4_PRBAR7_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR7_U_RNI_NID132, REGION7_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR7_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR7_U_RNI_NID132, REGION7_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR7_U_RNI_NID132, REGION7_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR7_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR7_U_RNI_NID132, 0x1036088)
    FIELD(POR_MPU_M4_PRLAR7_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR7_U_RNI_NID132, REGION7_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR7_U_RNI_NID132, REGION7_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR8_U_RNI_NID132, 0x1036090)
    FIELD(POR_MPU_M4_PRBAR8_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR8_U_RNI_NID132, REGION8_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR8_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR8_U_RNI_NID132, REGION8_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR8_U_RNI_NID132, REGION8_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR8_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR8_U_RNI_NID132, 0x1036098)
    FIELD(POR_MPU_M4_PRLAR8_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR8_U_RNI_NID132, REGION8_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR8_U_RNI_NID132, REGION8_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR9_U_RNI_NID132, 0x10360a0)
    FIELD(POR_MPU_M4_PRBAR9_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR9_U_RNI_NID132, REGION9_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR9_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR9_U_RNI_NID132, REGION9_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR9_U_RNI_NID132, REGION9_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR9_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR9_U_RNI_NID132, 0x10360a8)
    FIELD(POR_MPU_M4_PRLAR9_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR9_U_RNI_NID132, REGION9_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR9_U_RNI_NID132, REGION9_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR10_U_RNI_NID132, 0x10360b0)
    FIELD(POR_MPU_M4_PRBAR10_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR10_U_RNI_NID132, REGION10_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR10_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR10_U_RNI_NID132, REGION10_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR10_U_RNI_NID132, REGION10_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR10_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR10_U_RNI_NID132, 0x10360b8)
    FIELD(POR_MPU_M4_PRLAR10_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR10_U_RNI_NID132, REGION10_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR10_U_RNI_NID132, REGION10_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR11_U_RNI_NID132, 0x10360c0)
    FIELD(POR_MPU_M4_PRBAR11_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR11_U_RNI_NID132, REGION11_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR11_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR11_U_RNI_NID132, REGION11_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR11_U_RNI_NID132, REGION11_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR11_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR11_U_RNI_NID132, 0x10360c8)
    FIELD(POR_MPU_M4_PRLAR11_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR11_U_RNI_NID132, REGION11_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR11_U_RNI_NID132, REGION11_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR12_U_RNI_NID132, 0x10360d0)
    FIELD(POR_MPU_M4_PRBAR12_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR12_U_RNI_NID132, REGION12_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR12_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR12_U_RNI_NID132, REGION12_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR12_U_RNI_NID132, REGION12_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR12_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR12_U_RNI_NID132, 0x10360d8)
    FIELD(POR_MPU_M4_PRLAR12_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR12_U_RNI_NID132, REGION12_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR12_U_RNI_NID132, REGION12_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR13_U_RNI_NID132, 0x10360e0)
    FIELD(POR_MPU_M4_PRBAR13_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR13_U_RNI_NID132, REGION13_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR13_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR13_U_RNI_NID132, REGION13_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR13_U_RNI_NID132, REGION13_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR13_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR13_U_RNI_NID132, 0x10360e8)
    FIELD(POR_MPU_M4_PRLAR13_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR13_U_RNI_NID132, REGION13_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR13_U_RNI_NID132, REGION13_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR14_U_RNI_NID132, 0x10360f0)
    FIELD(POR_MPU_M4_PRBAR14_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR14_U_RNI_NID132, REGION14_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR14_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR14_U_RNI_NID132, REGION14_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR14_U_RNI_NID132, REGION14_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR14_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR14_U_RNI_NID132, 0x10360f8)
    FIELD(POR_MPU_M4_PRLAR14_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR14_U_RNI_NID132, REGION14_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR14_U_RNI_NID132, REGION14_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR15_U_RNI_NID132, 0x1036100)
    FIELD(POR_MPU_M4_PRBAR15_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR15_U_RNI_NID132, REGION15_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR15_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR15_U_RNI_NID132, REGION15_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR15_U_RNI_NID132, REGION15_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR15_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR15_U_RNI_NID132, 0x1036108)
    FIELD(POR_MPU_M4_PRLAR15_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR15_U_RNI_NID132, REGION15_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR15_U_RNI_NID132, REGION15_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR16_U_RNI_NID132, 0x1036110)
    FIELD(POR_MPU_M4_PRBAR16_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR16_U_RNI_NID132, REGION16_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR16_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR16_U_RNI_NID132, REGION16_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR16_U_RNI_NID132, REGION16_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR16_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR16_U_RNI_NID132, 0x1036118)
    FIELD(POR_MPU_M4_PRLAR16_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR16_U_RNI_NID132, REGION16_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR16_U_RNI_NID132, REGION16_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR17_U_RNI_NID132, 0x1036120)
    FIELD(POR_MPU_M4_PRBAR17_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR17_U_RNI_NID132, REGION17_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR17_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR17_U_RNI_NID132, REGION17_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR17_U_RNI_NID132, REGION17_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR17_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR17_U_RNI_NID132, 0x1036128)
    FIELD(POR_MPU_M4_PRLAR17_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR17_U_RNI_NID132, REGION17_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR17_U_RNI_NID132, REGION17_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR18_U_RNI_NID132, 0x1036130)
    FIELD(POR_MPU_M4_PRBAR18_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR18_U_RNI_NID132, REGION18_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR18_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR18_U_RNI_NID132, REGION18_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR18_U_RNI_NID132, REGION18_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR18_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR18_U_RNI_NID132, 0x1036138)
    FIELD(POR_MPU_M4_PRLAR18_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR18_U_RNI_NID132, REGION18_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR18_U_RNI_NID132, REGION18_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR19_U_RNI_NID132, 0x1036140)
    FIELD(POR_MPU_M4_PRBAR19_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR19_U_RNI_NID132, REGION19_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR19_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR19_U_RNI_NID132, REGION19_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR19_U_RNI_NID132, REGION19_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR19_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR19_U_RNI_NID132, 0x1036148)
    FIELD(POR_MPU_M4_PRLAR19_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR19_U_RNI_NID132, REGION19_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR19_U_RNI_NID132, REGION19_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR20_U_RNI_NID132, 0x1036150)
    FIELD(POR_MPU_M4_PRBAR20_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR20_U_RNI_NID132, REGION20_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR20_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR20_U_RNI_NID132, REGION20_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR20_U_RNI_NID132, REGION20_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR20_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR20_U_RNI_NID132, 0x1036158)
    FIELD(POR_MPU_M4_PRLAR20_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR20_U_RNI_NID132, REGION20_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR20_U_RNI_NID132, REGION20_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR21_U_RNI_NID132, 0x1036160)
    FIELD(POR_MPU_M4_PRBAR21_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR21_U_RNI_NID132, REGION21_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR21_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR21_U_RNI_NID132, REGION21_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR21_U_RNI_NID132, REGION21_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR21_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR21_U_RNI_NID132, 0x1036168)
    FIELD(POR_MPU_M4_PRLAR21_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR21_U_RNI_NID132, REGION21_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR21_U_RNI_NID132, REGION21_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR22_U_RNI_NID132, 0x1036170)
    FIELD(POR_MPU_M4_PRBAR22_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR22_U_RNI_NID132, REGION22_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR22_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR22_U_RNI_NID132, REGION22_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR22_U_RNI_NID132, REGION22_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR22_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR22_U_RNI_NID132, 0x1036178)
    FIELD(POR_MPU_M4_PRLAR22_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR22_U_RNI_NID132, REGION22_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR22_U_RNI_NID132, REGION22_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR23_U_RNI_NID132, 0x1036180)
    FIELD(POR_MPU_M4_PRBAR23_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR23_U_RNI_NID132, REGION23_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR23_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR23_U_RNI_NID132, REGION23_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR23_U_RNI_NID132, REGION23_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR23_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR23_U_RNI_NID132, 0x1036188)
    FIELD(POR_MPU_M4_PRLAR23_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR23_U_RNI_NID132, REGION23_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR23_U_RNI_NID132, REGION23_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR24_U_RNI_NID132, 0x1036190)
    FIELD(POR_MPU_M4_PRBAR24_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR24_U_RNI_NID132, REGION24_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR24_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR24_U_RNI_NID132, REGION24_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR24_U_RNI_NID132, REGION24_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR24_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR24_U_RNI_NID132, 0x1036198)
    FIELD(POR_MPU_M4_PRLAR24_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR24_U_RNI_NID132, REGION24_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR24_U_RNI_NID132, REGION24_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR25_U_RNI_NID132, 0x10361a0)
    FIELD(POR_MPU_M4_PRBAR25_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR25_U_RNI_NID132, REGION25_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR25_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR25_U_RNI_NID132, REGION25_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR25_U_RNI_NID132, REGION25_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR25_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR25_U_RNI_NID132, 0x10361a8)
    FIELD(POR_MPU_M4_PRLAR25_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR25_U_RNI_NID132, REGION25_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR25_U_RNI_NID132, REGION25_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR26_U_RNI_NID132, 0x10361b0)
    FIELD(POR_MPU_M4_PRBAR26_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR26_U_RNI_NID132, REGION26_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR26_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR26_U_RNI_NID132, REGION26_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR26_U_RNI_NID132, REGION26_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR26_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR26_U_RNI_NID132, 0x10361b8)
    FIELD(POR_MPU_M4_PRLAR26_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR26_U_RNI_NID132, REGION26_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR26_U_RNI_NID132, REGION26_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR27_U_RNI_NID132, 0x10361c0)
    FIELD(POR_MPU_M4_PRBAR27_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR27_U_RNI_NID132, REGION27_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR27_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR27_U_RNI_NID132, REGION27_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR27_U_RNI_NID132, REGION27_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR27_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR27_U_RNI_NID132, 0x10361c8)
    FIELD(POR_MPU_M4_PRLAR27_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR27_U_RNI_NID132, REGION27_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR27_U_RNI_NID132, REGION27_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR28_U_RNI_NID132, 0x10361d0)
    FIELD(POR_MPU_M4_PRBAR28_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR28_U_RNI_NID132, REGION28_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR28_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR28_U_RNI_NID132, REGION28_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR28_U_RNI_NID132, REGION28_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR28_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR28_U_RNI_NID132, 0x10361d8)
    FIELD(POR_MPU_M4_PRLAR28_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR28_U_RNI_NID132, REGION28_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR28_U_RNI_NID132, REGION28_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR29_U_RNI_NID132, 0x10361e0)
    FIELD(POR_MPU_M4_PRBAR29_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR29_U_RNI_NID132, REGION29_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR29_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR29_U_RNI_NID132, REGION29_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR29_U_RNI_NID132, REGION29_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR29_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR29_U_RNI_NID132, 0x10361e8)
    FIELD(POR_MPU_M4_PRLAR29_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR29_U_RNI_NID132, REGION29_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR29_U_RNI_NID132, REGION29_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR30_U_RNI_NID132, 0x10361f0)
    FIELD(POR_MPU_M4_PRBAR30_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR30_U_RNI_NID132, REGION30_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR30_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR30_U_RNI_NID132, REGION30_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR30_U_RNI_NID132, REGION30_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR30_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR30_U_RNI_NID132, 0x10361f8)
    FIELD(POR_MPU_M4_PRLAR30_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR30_U_RNI_NID132, REGION30_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR30_U_RNI_NID132, REGION30_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR31_U_RNI_NID132, 0x1036200)
    FIELD(POR_MPU_M4_PRBAR31_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR31_U_RNI_NID132, REGION31_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR31_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR31_U_RNI_NID132, REGION31_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR31_U_RNI_NID132, REGION31_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR31_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR31_U_RNI_NID132, 0x1036208)
    FIELD(POR_MPU_M4_PRLAR31_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR31_U_RNI_NID132, REGION31_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR31_U_RNI_NID132, REGION31_EN, 0, 1)
REG32(POR_MPU_M5_CTL_U_RNI_NID132, 0x1036400)
    FIELD(POR_MPU_M5_CTL_U_RNI_NID132, M5_EN, 2, 1)
    FIELD(POR_MPU_M5_CTL_U_RNI_NID132, M5_ACTION, 0, 2)
REG32(POR_MPU_M5_PRBAR0_U_RNI_NID132, 0x1036410)
    FIELD(POR_MPU_M5_PRBAR0_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR0_U_RNI_NID132, REGION0_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR0_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR0_U_RNI_NID132, REGION0_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR0_U_RNI_NID132, REGION0_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR0_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR0_U_RNI_NID132, 0x1036418)
    FIELD(POR_MPU_M5_PRLAR0_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR0_U_RNI_NID132, REGION0_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR0_U_RNI_NID132, REGION0_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR1_U_RNI_NID132, 0x1036420)
    FIELD(POR_MPU_M5_PRBAR1_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR1_U_RNI_NID132, REGION1_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR1_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR1_U_RNI_NID132, REGION1_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR1_U_RNI_NID132, REGION1_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR1_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR1_U_RNI_NID132, 0x1036428)
    FIELD(POR_MPU_M5_PRLAR1_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR1_U_RNI_NID132, REGION1_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR1_U_RNI_NID132, REGION1_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR2_U_RNI_NID132, 0x1036430)
    FIELD(POR_MPU_M5_PRBAR2_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR2_U_RNI_NID132, REGION2_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR2_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR2_U_RNI_NID132, REGION2_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR2_U_RNI_NID132, REGION2_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR2_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR2_U_RNI_NID132, 0x1036438)
    FIELD(POR_MPU_M5_PRLAR2_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR2_U_RNI_NID132, REGION2_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR2_U_RNI_NID132, REGION2_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR3_U_RNI_NID132, 0x1036440)
    FIELD(POR_MPU_M5_PRBAR3_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR3_U_RNI_NID132, REGION3_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR3_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR3_U_RNI_NID132, REGION3_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR3_U_RNI_NID132, REGION3_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR3_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR3_U_RNI_NID132, 0x1036448)
    FIELD(POR_MPU_M5_PRLAR3_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR3_U_RNI_NID132, REGION3_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR3_U_RNI_NID132, REGION3_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR4_U_RNI_NID132, 0x1036450)
    FIELD(POR_MPU_M5_PRBAR4_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR4_U_RNI_NID132, REGION4_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR4_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR4_U_RNI_NID132, REGION4_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR4_U_RNI_NID132, REGION4_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR4_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR4_U_RNI_NID132, 0x1036458)
    FIELD(POR_MPU_M5_PRLAR4_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR4_U_RNI_NID132, REGION4_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR4_U_RNI_NID132, REGION4_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR5_U_RNI_NID132, 0x1036460)
    FIELD(POR_MPU_M5_PRBAR5_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR5_U_RNI_NID132, REGION5_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR5_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR5_U_RNI_NID132, REGION5_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR5_U_RNI_NID132, REGION5_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR5_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR5_U_RNI_NID132, 0x1036468)
    FIELD(POR_MPU_M5_PRLAR5_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR5_U_RNI_NID132, REGION5_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR5_U_RNI_NID132, REGION5_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR6_U_RNI_NID132, 0x1036470)
    FIELD(POR_MPU_M5_PRBAR6_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR6_U_RNI_NID132, REGION6_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR6_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR6_U_RNI_NID132, REGION6_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR6_U_RNI_NID132, REGION6_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR6_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR6_U_RNI_NID132, 0x1036478)
    FIELD(POR_MPU_M5_PRLAR6_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR6_U_RNI_NID132, REGION6_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR6_U_RNI_NID132, REGION6_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR7_U_RNI_NID132, 0x1036480)
    FIELD(POR_MPU_M5_PRBAR7_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR7_U_RNI_NID132, REGION7_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR7_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR7_U_RNI_NID132, REGION7_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR7_U_RNI_NID132, REGION7_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR7_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR7_U_RNI_NID132, 0x1036488)
    FIELD(POR_MPU_M5_PRLAR7_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR7_U_RNI_NID132, REGION7_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR7_U_RNI_NID132, REGION7_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR8_U_RNI_NID132, 0x1036490)
    FIELD(POR_MPU_M5_PRBAR8_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR8_U_RNI_NID132, REGION8_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR8_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR8_U_RNI_NID132, REGION8_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR8_U_RNI_NID132, REGION8_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR8_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR8_U_RNI_NID132, 0x1036498)
    FIELD(POR_MPU_M5_PRLAR8_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR8_U_RNI_NID132, REGION8_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR8_U_RNI_NID132, REGION8_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR9_U_RNI_NID132, 0x10364a0)
    FIELD(POR_MPU_M5_PRBAR9_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR9_U_RNI_NID132, REGION9_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR9_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR9_U_RNI_NID132, REGION9_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR9_U_RNI_NID132, REGION9_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR9_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR9_U_RNI_NID132, 0x10364a8)
    FIELD(POR_MPU_M5_PRLAR9_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR9_U_RNI_NID132, REGION9_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR9_U_RNI_NID132, REGION9_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR10_U_RNI_NID132, 0x10364b0)
    FIELD(POR_MPU_M5_PRBAR10_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR10_U_RNI_NID132, REGION10_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR10_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR10_U_RNI_NID132, REGION10_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR10_U_RNI_NID132, REGION10_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR10_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR10_U_RNI_NID132, 0x10364b8)
    FIELD(POR_MPU_M5_PRLAR10_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR10_U_RNI_NID132, REGION10_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR10_U_RNI_NID132, REGION10_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR11_U_RNI_NID132, 0x10364c0)
    FIELD(POR_MPU_M5_PRBAR11_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR11_U_RNI_NID132, REGION11_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR11_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR11_U_RNI_NID132, REGION11_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR11_U_RNI_NID132, REGION11_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR11_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR11_U_RNI_NID132, 0x10364c8)
    FIELD(POR_MPU_M5_PRLAR11_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR11_U_RNI_NID132, REGION11_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR11_U_RNI_NID132, REGION11_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR12_U_RNI_NID132, 0x10364d0)
    FIELD(POR_MPU_M5_PRBAR12_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR12_U_RNI_NID132, REGION12_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR12_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR12_U_RNI_NID132, REGION12_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR12_U_RNI_NID132, REGION12_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR12_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR12_U_RNI_NID132, 0x10364d8)
    FIELD(POR_MPU_M5_PRLAR12_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR12_U_RNI_NID132, REGION12_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR12_U_RNI_NID132, REGION12_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR13_U_RNI_NID132, 0x10364e0)
    FIELD(POR_MPU_M5_PRBAR13_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR13_U_RNI_NID132, REGION13_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR13_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR13_U_RNI_NID132, REGION13_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR13_U_RNI_NID132, REGION13_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR13_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR13_U_RNI_NID132, 0x10364e8)
    FIELD(POR_MPU_M5_PRLAR13_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR13_U_RNI_NID132, REGION13_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR13_U_RNI_NID132, REGION13_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR14_U_RNI_NID132, 0x10364f0)
    FIELD(POR_MPU_M5_PRBAR14_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR14_U_RNI_NID132, REGION14_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR14_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR14_U_RNI_NID132, REGION14_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR14_U_RNI_NID132, REGION14_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR14_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR14_U_RNI_NID132, 0x10364f8)
    FIELD(POR_MPU_M5_PRLAR14_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR14_U_RNI_NID132, REGION14_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR14_U_RNI_NID132, REGION14_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR15_U_RNI_NID132, 0x1036500)
    FIELD(POR_MPU_M5_PRBAR15_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR15_U_RNI_NID132, REGION15_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR15_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR15_U_RNI_NID132, REGION15_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR15_U_RNI_NID132, REGION15_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR15_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR15_U_RNI_NID132, 0x1036508)
    FIELD(POR_MPU_M5_PRLAR15_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR15_U_RNI_NID132, REGION15_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR15_U_RNI_NID132, REGION15_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR16_U_RNI_NID132, 0x1036510)
    FIELD(POR_MPU_M5_PRBAR16_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR16_U_RNI_NID132, REGION16_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR16_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR16_U_RNI_NID132, REGION16_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR16_U_RNI_NID132, REGION16_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR16_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR16_U_RNI_NID132, 0x1036518)
    FIELD(POR_MPU_M5_PRLAR16_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR16_U_RNI_NID132, REGION16_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR16_U_RNI_NID132, REGION16_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR17_U_RNI_NID132, 0x1036520)
    FIELD(POR_MPU_M5_PRBAR17_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR17_U_RNI_NID132, REGION17_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR17_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR17_U_RNI_NID132, REGION17_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR17_U_RNI_NID132, REGION17_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR17_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR17_U_RNI_NID132, 0x1036528)
    FIELD(POR_MPU_M5_PRLAR17_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR17_U_RNI_NID132, REGION17_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR17_U_RNI_NID132, REGION17_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR18_U_RNI_NID132, 0x1036530)
    FIELD(POR_MPU_M5_PRBAR18_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR18_U_RNI_NID132, REGION18_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR18_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR18_U_RNI_NID132, REGION18_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR18_U_RNI_NID132, REGION18_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR18_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR18_U_RNI_NID132, 0x1036538)
    FIELD(POR_MPU_M5_PRLAR18_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR18_U_RNI_NID132, REGION18_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR18_U_RNI_NID132, REGION18_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR19_U_RNI_NID132, 0x1036540)
    FIELD(POR_MPU_M5_PRBAR19_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR19_U_RNI_NID132, REGION19_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR19_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR19_U_RNI_NID132, REGION19_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR19_U_RNI_NID132, REGION19_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR19_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR19_U_RNI_NID132, 0x1036548)
    FIELD(POR_MPU_M5_PRLAR19_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR19_U_RNI_NID132, REGION19_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR19_U_RNI_NID132, REGION19_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR20_U_RNI_NID132, 0x1036550)
    FIELD(POR_MPU_M5_PRBAR20_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR20_U_RNI_NID132, REGION20_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR20_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR20_U_RNI_NID132, REGION20_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR20_U_RNI_NID132, REGION20_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR20_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR20_U_RNI_NID132, 0x1036558)
    FIELD(POR_MPU_M5_PRLAR20_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR20_U_RNI_NID132, REGION20_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR20_U_RNI_NID132, REGION20_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR21_U_RNI_NID132, 0x1036560)
    FIELD(POR_MPU_M5_PRBAR21_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR21_U_RNI_NID132, REGION21_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR21_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR21_U_RNI_NID132, REGION21_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR21_U_RNI_NID132, REGION21_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR21_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR21_U_RNI_NID132, 0x1036568)
    FIELD(POR_MPU_M5_PRLAR21_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR21_U_RNI_NID132, REGION21_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR21_U_RNI_NID132, REGION21_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR22_U_RNI_NID132, 0x1036570)
    FIELD(POR_MPU_M5_PRBAR22_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR22_U_RNI_NID132, REGION22_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR22_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR22_U_RNI_NID132, REGION22_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR22_U_RNI_NID132, REGION22_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR22_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR22_U_RNI_NID132, 0x1036578)
    FIELD(POR_MPU_M5_PRLAR22_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR22_U_RNI_NID132, REGION22_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR22_U_RNI_NID132, REGION22_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR23_U_RNI_NID132, 0x1036580)
    FIELD(POR_MPU_M5_PRBAR23_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR23_U_RNI_NID132, REGION23_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR23_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR23_U_RNI_NID132, REGION23_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR23_U_RNI_NID132, REGION23_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR23_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR23_U_RNI_NID132, 0x1036588)
    FIELD(POR_MPU_M5_PRLAR23_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR23_U_RNI_NID132, REGION23_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR23_U_RNI_NID132, REGION23_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR24_U_RNI_NID132, 0x1036590)
    FIELD(POR_MPU_M5_PRBAR24_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR24_U_RNI_NID132, REGION24_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR24_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR24_U_RNI_NID132, REGION24_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR24_U_RNI_NID132, REGION24_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR24_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR24_U_RNI_NID132, 0x1036598)
    FIELD(POR_MPU_M5_PRLAR24_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR24_U_RNI_NID132, REGION24_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR24_U_RNI_NID132, REGION24_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR25_U_RNI_NID132, 0x10365a0)
    FIELD(POR_MPU_M5_PRBAR25_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR25_U_RNI_NID132, REGION25_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR25_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR25_U_RNI_NID132, REGION25_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR25_U_RNI_NID132, REGION25_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR25_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR25_U_RNI_NID132, 0x10365a8)
    FIELD(POR_MPU_M5_PRLAR25_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR25_U_RNI_NID132, REGION25_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR25_U_RNI_NID132, REGION25_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR26_U_RNI_NID132, 0x10365b0)
    FIELD(POR_MPU_M5_PRBAR26_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR26_U_RNI_NID132, REGION26_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR26_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR26_U_RNI_NID132, REGION26_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR26_U_RNI_NID132, REGION26_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR26_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR26_U_RNI_NID132, 0x10365b8)
    FIELD(POR_MPU_M5_PRLAR26_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR26_U_RNI_NID132, REGION26_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR26_U_RNI_NID132, REGION26_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR27_U_RNI_NID132, 0x10365c0)
    FIELD(POR_MPU_M5_PRBAR27_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR27_U_RNI_NID132, REGION27_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR27_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR27_U_RNI_NID132, REGION27_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR27_U_RNI_NID132, REGION27_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR27_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR27_U_RNI_NID132, 0x10365c8)
    FIELD(POR_MPU_M5_PRLAR27_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR27_U_RNI_NID132, REGION27_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR27_U_RNI_NID132, REGION27_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR28_U_RNI_NID132, 0x10365d0)
    FIELD(POR_MPU_M5_PRBAR28_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR28_U_RNI_NID132, REGION28_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR28_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR28_U_RNI_NID132, REGION28_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR28_U_RNI_NID132, REGION28_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR28_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR28_U_RNI_NID132, 0x10365d8)
    FIELD(POR_MPU_M5_PRLAR28_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR28_U_RNI_NID132, REGION28_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR28_U_RNI_NID132, REGION28_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR29_U_RNI_NID132, 0x10365e0)
    FIELD(POR_MPU_M5_PRBAR29_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR29_U_RNI_NID132, REGION29_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR29_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR29_U_RNI_NID132, REGION29_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR29_U_RNI_NID132, REGION29_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR29_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR29_U_RNI_NID132, 0x10365e8)
    FIELD(POR_MPU_M5_PRLAR29_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR29_U_RNI_NID132, REGION29_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR29_U_RNI_NID132, REGION29_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR30_U_RNI_NID132, 0x10365f0)
    FIELD(POR_MPU_M5_PRBAR30_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR30_U_RNI_NID132, REGION30_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR30_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR30_U_RNI_NID132, REGION30_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR30_U_RNI_NID132, REGION30_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR30_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR30_U_RNI_NID132, 0x10365f8)
    FIELD(POR_MPU_M5_PRLAR30_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR30_U_RNI_NID132, REGION30_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR30_U_RNI_NID132, REGION30_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR31_U_RNI_NID132, 0x1036600)
    FIELD(POR_MPU_M5_PRBAR31_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR31_U_RNI_NID132, REGION31_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR31_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR31_U_RNI_NID132, REGION31_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR31_U_RNI_NID132, REGION31_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR31_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR31_U_RNI_NID132, 0x1036608)
    FIELD(POR_MPU_M5_PRLAR31_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR31_U_RNI_NID132, REGION31_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR31_U_RNI_NID132, REGION31_EN, 0, 1)
REG32(POR_MPU_M6_CTL_U_RNI_NID132, 0x1036800)
    FIELD(POR_MPU_M6_CTL_U_RNI_NID132, M6_EN, 2, 1)
    FIELD(POR_MPU_M6_CTL_U_RNI_NID132, M6_ACTION, 0, 2)
REG32(POR_MPU_M6_PRBAR0_U_RNI_NID132, 0x1036810)
    FIELD(POR_MPU_M6_PRBAR0_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR0_U_RNI_NID132, REGION0_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR0_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR0_U_RNI_NID132, REGION0_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR0_U_RNI_NID132, REGION0_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR0_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR0_U_RNI_NID132, 0x1036818)
    FIELD(POR_MPU_M6_PRLAR0_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR0_U_RNI_NID132, REGION0_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR0_U_RNI_NID132, REGION0_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR1_U_RNI_NID132, 0x1036820)
    FIELD(POR_MPU_M6_PRBAR1_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR1_U_RNI_NID132, REGION1_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR1_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR1_U_RNI_NID132, REGION1_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR1_U_RNI_NID132, REGION1_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR1_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR1_U_RNI_NID132, 0x1036828)
    FIELD(POR_MPU_M6_PRLAR1_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR1_U_RNI_NID132, REGION1_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR1_U_RNI_NID132, REGION1_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR2_U_RNI_NID132, 0x1036830)
    FIELD(POR_MPU_M6_PRBAR2_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR2_U_RNI_NID132, REGION2_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR2_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR2_U_RNI_NID132, REGION2_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR2_U_RNI_NID132, REGION2_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR2_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR2_U_RNI_NID132, 0x1036838)
    FIELD(POR_MPU_M6_PRLAR2_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR2_U_RNI_NID132, REGION2_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR2_U_RNI_NID132, REGION2_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR3_U_RNI_NID132, 0x1036840)
    FIELD(POR_MPU_M6_PRBAR3_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR3_U_RNI_NID132, REGION3_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR3_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR3_U_RNI_NID132, REGION3_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR3_U_RNI_NID132, REGION3_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR3_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR3_U_RNI_NID132, 0x1036848)
    FIELD(POR_MPU_M6_PRLAR3_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR3_U_RNI_NID132, REGION3_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR3_U_RNI_NID132, REGION3_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR4_U_RNI_NID132, 0x1036850)
    FIELD(POR_MPU_M6_PRBAR4_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR4_U_RNI_NID132, REGION4_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR4_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR4_U_RNI_NID132, REGION4_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR4_U_RNI_NID132, REGION4_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR4_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR4_U_RNI_NID132, 0x1036858)
    FIELD(POR_MPU_M6_PRLAR4_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR4_U_RNI_NID132, REGION4_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR4_U_RNI_NID132, REGION4_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR5_U_RNI_NID132, 0x1036860)
    FIELD(POR_MPU_M6_PRBAR5_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR5_U_RNI_NID132, REGION5_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR5_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR5_U_RNI_NID132, REGION5_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR5_U_RNI_NID132, REGION5_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR5_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR5_U_RNI_NID132, 0x1036868)
    FIELD(POR_MPU_M6_PRLAR5_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR5_U_RNI_NID132, REGION5_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR5_U_RNI_NID132, REGION5_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR6_U_RNI_NID132, 0x1036870)
    FIELD(POR_MPU_M6_PRBAR6_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR6_U_RNI_NID132, REGION6_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR6_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR6_U_RNI_NID132, REGION6_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR6_U_RNI_NID132, REGION6_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR6_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR6_U_RNI_NID132, 0x1036878)
    FIELD(POR_MPU_M6_PRLAR6_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR6_U_RNI_NID132, REGION6_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR6_U_RNI_NID132, REGION6_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR7_U_RNI_NID132, 0x1036880)
    FIELD(POR_MPU_M6_PRBAR7_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR7_U_RNI_NID132, REGION7_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR7_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR7_U_RNI_NID132, REGION7_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR7_U_RNI_NID132, REGION7_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR7_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR7_U_RNI_NID132, 0x1036888)
    FIELD(POR_MPU_M6_PRLAR7_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR7_U_RNI_NID132, REGION7_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR7_U_RNI_NID132, REGION7_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR8_U_RNI_NID132, 0x1036890)
    FIELD(POR_MPU_M6_PRBAR8_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR8_U_RNI_NID132, REGION8_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR8_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR8_U_RNI_NID132, REGION8_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR8_U_RNI_NID132, REGION8_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR8_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR8_U_RNI_NID132, 0x1036898)
    FIELD(POR_MPU_M6_PRLAR8_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR8_U_RNI_NID132, REGION8_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR8_U_RNI_NID132, REGION8_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR9_U_RNI_NID132, 0x10368a0)
    FIELD(POR_MPU_M6_PRBAR9_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR9_U_RNI_NID132, REGION9_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR9_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR9_U_RNI_NID132, REGION9_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR9_U_RNI_NID132, REGION9_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR9_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR9_U_RNI_NID132, 0x10368a8)
    FIELD(POR_MPU_M6_PRLAR9_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR9_U_RNI_NID132, REGION9_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR9_U_RNI_NID132, REGION9_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR10_U_RNI_NID132, 0x10368b0)
    FIELD(POR_MPU_M6_PRBAR10_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR10_U_RNI_NID132, REGION10_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR10_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR10_U_RNI_NID132, REGION10_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR10_U_RNI_NID132, REGION10_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR10_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR10_U_RNI_NID132, 0x10368b8)
    FIELD(POR_MPU_M6_PRLAR10_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR10_U_RNI_NID132, REGION10_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR10_U_RNI_NID132, REGION10_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR11_U_RNI_NID132, 0x10368c0)
    FIELD(POR_MPU_M6_PRBAR11_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR11_U_RNI_NID132, REGION11_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR11_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR11_U_RNI_NID132, REGION11_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR11_U_RNI_NID132, REGION11_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR11_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR11_U_RNI_NID132, 0x10368c8)
    FIELD(POR_MPU_M6_PRLAR11_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR11_U_RNI_NID132, REGION11_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR11_U_RNI_NID132, REGION11_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR12_U_RNI_NID132, 0x10368d0)
    FIELD(POR_MPU_M6_PRBAR12_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR12_U_RNI_NID132, REGION12_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR12_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR12_U_RNI_NID132, REGION12_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR12_U_RNI_NID132, REGION12_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR12_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR12_U_RNI_NID132, 0x10368d8)
    FIELD(POR_MPU_M6_PRLAR12_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR12_U_RNI_NID132, REGION12_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR12_U_RNI_NID132, REGION12_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR13_U_RNI_NID132, 0x10368e0)
    FIELD(POR_MPU_M6_PRBAR13_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR13_U_RNI_NID132, REGION13_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR13_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR13_U_RNI_NID132, REGION13_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR13_U_RNI_NID132, REGION13_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR13_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR13_U_RNI_NID132, 0x10368e8)
    FIELD(POR_MPU_M6_PRLAR13_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR13_U_RNI_NID132, REGION13_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR13_U_RNI_NID132, REGION13_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR14_U_RNI_NID132, 0x10368f0)
    FIELD(POR_MPU_M6_PRBAR14_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR14_U_RNI_NID132, REGION14_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR14_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR14_U_RNI_NID132, REGION14_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR14_U_RNI_NID132, REGION14_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR14_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR14_U_RNI_NID132, 0x10368f8)
    FIELD(POR_MPU_M6_PRLAR14_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR14_U_RNI_NID132, REGION14_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR14_U_RNI_NID132, REGION14_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR15_U_RNI_NID132, 0x1036900)
    FIELD(POR_MPU_M6_PRBAR15_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR15_U_RNI_NID132, REGION15_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR15_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR15_U_RNI_NID132, REGION15_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR15_U_RNI_NID132, REGION15_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR15_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR15_U_RNI_NID132, 0x1036908)
    FIELD(POR_MPU_M6_PRLAR15_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR15_U_RNI_NID132, REGION15_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR15_U_RNI_NID132, REGION15_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR16_U_RNI_NID132, 0x1036910)
    FIELD(POR_MPU_M6_PRBAR16_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR16_U_RNI_NID132, REGION16_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR16_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR16_U_RNI_NID132, REGION16_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR16_U_RNI_NID132, REGION16_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR16_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR16_U_RNI_NID132, 0x1036918)
    FIELD(POR_MPU_M6_PRLAR16_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR16_U_RNI_NID132, REGION16_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR16_U_RNI_NID132, REGION16_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR17_U_RNI_NID132, 0x1036920)
    FIELD(POR_MPU_M6_PRBAR17_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR17_U_RNI_NID132, REGION17_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR17_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR17_U_RNI_NID132, REGION17_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR17_U_RNI_NID132, REGION17_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR17_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR17_U_RNI_NID132, 0x1036928)
    FIELD(POR_MPU_M6_PRLAR17_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR17_U_RNI_NID132, REGION17_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR17_U_RNI_NID132, REGION17_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR18_U_RNI_NID132, 0x1036930)
    FIELD(POR_MPU_M6_PRBAR18_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR18_U_RNI_NID132, REGION18_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR18_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR18_U_RNI_NID132, REGION18_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR18_U_RNI_NID132, REGION18_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR18_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR18_U_RNI_NID132, 0x1036938)
    FIELD(POR_MPU_M6_PRLAR18_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR18_U_RNI_NID132, REGION18_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR18_U_RNI_NID132, REGION18_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR19_U_RNI_NID132, 0x1036940)
    FIELD(POR_MPU_M6_PRBAR19_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR19_U_RNI_NID132, REGION19_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR19_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR19_U_RNI_NID132, REGION19_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR19_U_RNI_NID132, REGION19_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR19_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR19_U_RNI_NID132, 0x1036948)
    FIELD(POR_MPU_M6_PRLAR19_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR19_U_RNI_NID132, REGION19_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR19_U_RNI_NID132, REGION19_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR20_U_RNI_NID132, 0x1036950)
    FIELD(POR_MPU_M6_PRBAR20_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR20_U_RNI_NID132, REGION20_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR20_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR20_U_RNI_NID132, REGION20_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR20_U_RNI_NID132, REGION20_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR20_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR20_U_RNI_NID132, 0x1036958)
    FIELD(POR_MPU_M6_PRLAR20_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR20_U_RNI_NID132, REGION20_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR20_U_RNI_NID132, REGION20_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR21_U_RNI_NID132, 0x1036960)
    FIELD(POR_MPU_M6_PRBAR21_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR21_U_RNI_NID132, REGION21_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR21_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR21_U_RNI_NID132, REGION21_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR21_U_RNI_NID132, REGION21_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR21_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR21_U_RNI_NID132, 0x1036968)
    FIELD(POR_MPU_M6_PRLAR21_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR21_U_RNI_NID132, REGION21_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR21_U_RNI_NID132, REGION21_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR22_U_RNI_NID132, 0x1036970)
    FIELD(POR_MPU_M6_PRBAR22_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR22_U_RNI_NID132, REGION22_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR22_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR22_U_RNI_NID132, REGION22_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR22_U_RNI_NID132, REGION22_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR22_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR22_U_RNI_NID132, 0x1036978)
    FIELD(POR_MPU_M6_PRLAR22_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR22_U_RNI_NID132, REGION22_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR22_U_RNI_NID132, REGION22_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR23_U_RNI_NID132, 0x1036980)
    FIELD(POR_MPU_M6_PRBAR23_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR23_U_RNI_NID132, REGION23_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR23_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR23_U_RNI_NID132, REGION23_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR23_U_RNI_NID132, REGION23_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR23_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR23_U_RNI_NID132, 0x1036988)
    FIELD(POR_MPU_M6_PRLAR23_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR23_U_RNI_NID132, REGION23_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR23_U_RNI_NID132, REGION23_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR24_U_RNI_NID132, 0x1036990)
    FIELD(POR_MPU_M6_PRBAR24_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR24_U_RNI_NID132, REGION24_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR24_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR24_U_RNI_NID132, REGION24_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR24_U_RNI_NID132, REGION24_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR24_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR24_U_RNI_NID132, 0x1036998)
    FIELD(POR_MPU_M6_PRLAR24_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR24_U_RNI_NID132, REGION24_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR24_U_RNI_NID132, REGION24_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR25_U_RNI_NID132, 0x10369a0)
    FIELD(POR_MPU_M6_PRBAR25_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR25_U_RNI_NID132, REGION25_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR25_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR25_U_RNI_NID132, REGION25_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR25_U_RNI_NID132, REGION25_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR25_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR25_U_RNI_NID132, 0x10369a8)
    FIELD(POR_MPU_M6_PRLAR25_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR25_U_RNI_NID132, REGION25_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR25_U_RNI_NID132, REGION25_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR26_U_RNI_NID132, 0x10369b0)
    FIELD(POR_MPU_M6_PRBAR26_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR26_U_RNI_NID132, REGION26_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR26_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR26_U_RNI_NID132, REGION26_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR26_U_RNI_NID132, REGION26_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR26_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR26_U_RNI_NID132, 0x10369b8)
    FIELD(POR_MPU_M6_PRLAR26_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR26_U_RNI_NID132, REGION26_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR26_U_RNI_NID132, REGION26_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR27_U_RNI_NID132, 0x10369c0)
    FIELD(POR_MPU_M6_PRBAR27_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR27_U_RNI_NID132, REGION27_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR27_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR27_U_RNI_NID132, REGION27_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR27_U_RNI_NID132, REGION27_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR27_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR27_U_RNI_NID132, 0x10369c8)
    FIELD(POR_MPU_M6_PRLAR27_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR27_U_RNI_NID132, REGION27_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR27_U_RNI_NID132, REGION27_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR28_U_RNI_NID132, 0x10369d0)
    FIELD(POR_MPU_M6_PRBAR28_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR28_U_RNI_NID132, REGION28_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR28_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR28_U_RNI_NID132, REGION28_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR28_U_RNI_NID132, REGION28_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR28_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR28_U_RNI_NID132, 0x10369d8)
    FIELD(POR_MPU_M6_PRLAR28_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR28_U_RNI_NID132, REGION28_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR28_U_RNI_NID132, REGION28_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR29_U_RNI_NID132, 0x10369e0)
    FIELD(POR_MPU_M6_PRBAR29_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR29_U_RNI_NID132, REGION29_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR29_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR29_U_RNI_NID132, REGION29_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR29_U_RNI_NID132, REGION29_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR29_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR29_U_RNI_NID132, 0x10369e8)
    FIELD(POR_MPU_M6_PRLAR29_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR29_U_RNI_NID132, REGION29_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR29_U_RNI_NID132, REGION29_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR30_U_RNI_NID132, 0x10369f0)
    FIELD(POR_MPU_M6_PRBAR30_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR30_U_RNI_NID132, REGION30_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR30_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR30_U_RNI_NID132, REGION30_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR30_U_RNI_NID132, REGION30_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR30_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR30_U_RNI_NID132, 0x10369f8)
    FIELD(POR_MPU_M6_PRLAR30_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR30_U_RNI_NID132, REGION30_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR30_U_RNI_NID132, REGION30_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR31_U_RNI_NID132, 0x1036a00)
    FIELD(POR_MPU_M6_PRBAR31_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR31_U_RNI_NID132, REGION31_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR31_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR31_U_RNI_NID132, REGION31_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR31_U_RNI_NID132, REGION31_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR31_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR31_U_RNI_NID132, 0x1036a08)
    FIELD(POR_MPU_M6_PRLAR31_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR31_U_RNI_NID132, REGION31_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR31_U_RNI_NID132, REGION31_EN, 0, 1)
REG32(POR_MPU_M7_CTL_U_RNI_NID132, 0x1036c00)
    FIELD(POR_MPU_M7_CTL_U_RNI_NID132, M7_EN, 2, 1)
    FIELD(POR_MPU_M7_CTL_U_RNI_NID132, M7_ACTION, 0, 2)
REG32(POR_MPU_M7_PRBAR0_U_RNI_NID132, 0x1036c10)
    FIELD(POR_MPU_M7_PRBAR0_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR0_U_RNI_NID132, REGION0_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR0_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR0_U_RNI_NID132, REGION0_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR0_U_RNI_NID132, REGION0_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR0_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR0_U_RNI_NID132, 0x1036c18)
    FIELD(POR_MPU_M7_PRLAR0_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR0_U_RNI_NID132, REGION0_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR0_U_RNI_NID132, REGION0_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR1_U_RNI_NID132, 0x1036c20)
    FIELD(POR_MPU_M7_PRBAR1_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR1_U_RNI_NID132, REGION1_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR1_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR1_U_RNI_NID132, REGION1_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR1_U_RNI_NID132, REGION1_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR1_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR1_U_RNI_NID132, 0x1036c28)
    FIELD(POR_MPU_M7_PRLAR1_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR1_U_RNI_NID132, REGION1_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR1_U_RNI_NID132, REGION1_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR2_U_RNI_NID132, 0x1036c30)
    FIELD(POR_MPU_M7_PRBAR2_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR2_U_RNI_NID132, REGION2_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR2_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR2_U_RNI_NID132, REGION2_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR2_U_RNI_NID132, REGION2_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR2_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR2_U_RNI_NID132, 0x1036c38)
    FIELD(POR_MPU_M7_PRLAR2_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR2_U_RNI_NID132, REGION2_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR2_U_RNI_NID132, REGION2_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR3_U_RNI_NID132, 0x1036c40)
    FIELD(POR_MPU_M7_PRBAR3_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR3_U_RNI_NID132, REGION3_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR3_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR3_U_RNI_NID132, REGION3_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR3_U_RNI_NID132, REGION3_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR3_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR3_U_RNI_NID132, 0x1036c48)
    FIELD(POR_MPU_M7_PRLAR3_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR3_U_RNI_NID132, REGION3_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR3_U_RNI_NID132, REGION3_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR4_U_RNI_NID132, 0x1036c50)
    FIELD(POR_MPU_M7_PRBAR4_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR4_U_RNI_NID132, REGION4_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR4_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR4_U_RNI_NID132, REGION4_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR4_U_RNI_NID132, REGION4_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR4_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR4_U_RNI_NID132, 0x1036c58)
    FIELD(POR_MPU_M7_PRLAR4_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR4_U_RNI_NID132, REGION4_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR4_U_RNI_NID132, REGION4_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR5_U_RNI_NID132, 0x1036c60)
    FIELD(POR_MPU_M7_PRBAR5_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR5_U_RNI_NID132, REGION5_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR5_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR5_U_RNI_NID132, REGION5_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR5_U_RNI_NID132, REGION5_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR5_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR5_U_RNI_NID132, 0x1036c68)
    FIELD(POR_MPU_M7_PRLAR5_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR5_U_RNI_NID132, REGION5_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR5_U_RNI_NID132, REGION5_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR6_U_RNI_NID132, 0x1036c70)
    FIELD(POR_MPU_M7_PRBAR6_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR6_U_RNI_NID132, REGION6_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR6_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR6_U_RNI_NID132, REGION6_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR6_U_RNI_NID132, REGION6_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR6_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR6_U_RNI_NID132, 0x1036c78)
    FIELD(POR_MPU_M7_PRLAR6_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR6_U_RNI_NID132, REGION6_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR6_U_RNI_NID132, REGION6_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR7_U_RNI_NID132, 0x1036c80)
    FIELD(POR_MPU_M7_PRBAR7_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR7_U_RNI_NID132, REGION7_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR7_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR7_U_RNI_NID132, REGION7_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR7_U_RNI_NID132, REGION7_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR7_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR7_U_RNI_NID132, 0x1036c88)
    FIELD(POR_MPU_M7_PRLAR7_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR7_U_RNI_NID132, REGION7_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR7_U_RNI_NID132, REGION7_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR8_U_RNI_NID132, 0x1036c90)
    FIELD(POR_MPU_M7_PRBAR8_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR8_U_RNI_NID132, REGION8_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR8_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR8_U_RNI_NID132, REGION8_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR8_U_RNI_NID132, REGION8_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR8_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR8_U_RNI_NID132, 0x1036c98)
    FIELD(POR_MPU_M7_PRLAR8_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR8_U_RNI_NID132, REGION8_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR8_U_RNI_NID132, REGION8_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR9_U_RNI_NID132, 0x1036ca0)
    FIELD(POR_MPU_M7_PRBAR9_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR9_U_RNI_NID132, REGION9_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR9_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR9_U_RNI_NID132, REGION9_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR9_U_RNI_NID132, REGION9_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR9_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR9_U_RNI_NID132, 0x1036ca8)
    FIELD(POR_MPU_M7_PRLAR9_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR9_U_RNI_NID132, REGION9_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR9_U_RNI_NID132, REGION9_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR10_U_RNI_NID132, 0x1036cb0)
    FIELD(POR_MPU_M7_PRBAR10_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR10_U_RNI_NID132, REGION10_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR10_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR10_U_RNI_NID132, REGION10_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR10_U_RNI_NID132, REGION10_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR10_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR10_U_RNI_NID132, 0x1036cb8)
    FIELD(POR_MPU_M7_PRLAR10_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR10_U_RNI_NID132, REGION10_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR10_U_RNI_NID132, REGION10_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR11_U_RNI_NID132, 0x1036cc0)
    FIELD(POR_MPU_M7_PRBAR11_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR11_U_RNI_NID132, REGION11_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR11_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR11_U_RNI_NID132, REGION11_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR11_U_RNI_NID132, REGION11_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR11_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR11_U_RNI_NID132, 0x1036cc8)
    FIELD(POR_MPU_M7_PRLAR11_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR11_U_RNI_NID132, REGION11_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR11_U_RNI_NID132, REGION11_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR12_U_RNI_NID132, 0x1036cd0)
    FIELD(POR_MPU_M7_PRBAR12_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR12_U_RNI_NID132, REGION12_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR12_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR12_U_RNI_NID132, REGION12_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR12_U_RNI_NID132, REGION12_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR12_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR12_U_RNI_NID132, 0x1036cd8)
    FIELD(POR_MPU_M7_PRLAR12_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR12_U_RNI_NID132, REGION12_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR12_U_RNI_NID132, REGION12_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR13_U_RNI_NID132, 0x1036ce0)
    FIELD(POR_MPU_M7_PRBAR13_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR13_U_RNI_NID132, REGION13_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR13_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR13_U_RNI_NID132, REGION13_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR13_U_RNI_NID132, REGION13_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR13_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR13_U_RNI_NID132, 0x1036ce8)
    FIELD(POR_MPU_M7_PRLAR13_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR13_U_RNI_NID132, REGION13_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR13_U_RNI_NID132, REGION13_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR14_U_RNI_NID132, 0x1036cf0)
    FIELD(POR_MPU_M7_PRBAR14_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR14_U_RNI_NID132, REGION14_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR14_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR14_U_RNI_NID132, REGION14_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR14_U_RNI_NID132, REGION14_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR14_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR14_U_RNI_NID132, 0x1036cf8)
    FIELD(POR_MPU_M7_PRLAR14_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR14_U_RNI_NID132, REGION14_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR14_U_RNI_NID132, REGION14_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR15_U_RNI_NID132, 0x1036d00)
    FIELD(POR_MPU_M7_PRBAR15_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR15_U_RNI_NID132, REGION15_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR15_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR15_U_RNI_NID132, REGION15_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR15_U_RNI_NID132, REGION15_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR15_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR15_U_RNI_NID132, 0x1036d08)
    FIELD(POR_MPU_M7_PRLAR15_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR15_U_RNI_NID132, REGION15_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR15_U_RNI_NID132, REGION15_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR16_U_RNI_NID132, 0x1036d10)
    FIELD(POR_MPU_M7_PRBAR16_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR16_U_RNI_NID132, REGION16_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR16_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR16_U_RNI_NID132, REGION16_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR16_U_RNI_NID132, REGION16_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR16_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR16_U_RNI_NID132, 0x1036d18)
    FIELD(POR_MPU_M7_PRLAR16_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR16_U_RNI_NID132, REGION16_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR16_U_RNI_NID132, REGION16_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR17_U_RNI_NID132, 0x1036d20)
    FIELD(POR_MPU_M7_PRBAR17_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR17_U_RNI_NID132, REGION17_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR17_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR17_U_RNI_NID132, REGION17_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR17_U_RNI_NID132, REGION17_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR17_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR17_U_RNI_NID132, 0x1036d28)
    FIELD(POR_MPU_M7_PRLAR17_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR17_U_RNI_NID132, REGION17_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR17_U_RNI_NID132, REGION17_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR18_U_RNI_NID132, 0x1036d30)
    FIELD(POR_MPU_M7_PRBAR18_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR18_U_RNI_NID132, REGION18_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR18_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR18_U_RNI_NID132, REGION18_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR18_U_RNI_NID132, REGION18_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR18_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR18_U_RNI_NID132, 0x1036d38)
    FIELD(POR_MPU_M7_PRLAR18_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR18_U_RNI_NID132, REGION18_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR18_U_RNI_NID132, REGION18_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR19_U_RNI_NID132, 0x1036d40)
    FIELD(POR_MPU_M7_PRBAR19_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR19_U_RNI_NID132, REGION19_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR19_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR19_U_RNI_NID132, REGION19_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR19_U_RNI_NID132, REGION19_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR19_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR19_U_RNI_NID132, 0x1036d48)
    FIELD(POR_MPU_M7_PRLAR19_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR19_U_RNI_NID132, REGION19_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR19_U_RNI_NID132, REGION19_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR20_U_RNI_NID132, 0x1036d50)
    FIELD(POR_MPU_M7_PRBAR20_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR20_U_RNI_NID132, REGION20_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR20_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR20_U_RNI_NID132, REGION20_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR20_U_RNI_NID132, REGION20_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR20_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR20_U_RNI_NID132, 0x1036d58)
    FIELD(POR_MPU_M7_PRLAR20_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR20_U_RNI_NID132, REGION20_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR20_U_RNI_NID132, REGION20_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR21_U_RNI_NID132, 0x1036d60)
    FIELD(POR_MPU_M7_PRBAR21_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR21_U_RNI_NID132, REGION21_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR21_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR21_U_RNI_NID132, REGION21_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR21_U_RNI_NID132, REGION21_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR21_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR21_U_RNI_NID132, 0x1036d68)
    FIELD(POR_MPU_M7_PRLAR21_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR21_U_RNI_NID132, REGION21_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR21_U_RNI_NID132, REGION21_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR22_U_RNI_NID132, 0x1036d70)
    FIELD(POR_MPU_M7_PRBAR22_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR22_U_RNI_NID132, REGION22_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR22_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR22_U_RNI_NID132, REGION22_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR22_U_RNI_NID132, REGION22_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR22_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR22_U_RNI_NID132, 0x1036d78)
    FIELD(POR_MPU_M7_PRLAR22_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR22_U_RNI_NID132, REGION22_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR22_U_RNI_NID132, REGION22_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR23_U_RNI_NID132, 0x1036d80)
    FIELD(POR_MPU_M7_PRBAR23_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR23_U_RNI_NID132, REGION23_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR23_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR23_U_RNI_NID132, REGION23_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR23_U_RNI_NID132, REGION23_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR23_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR23_U_RNI_NID132, 0x1036d88)
    FIELD(POR_MPU_M7_PRLAR23_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR23_U_RNI_NID132, REGION23_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR23_U_RNI_NID132, REGION23_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR24_U_RNI_NID132, 0x1036d90)
    FIELD(POR_MPU_M7_PRBAR24_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR24_U_RNI_NID132, REGION24_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR24_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR24_U_RNI_NID132, REGION24_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR24_U_RNI_NID132, REGION24_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR24_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR24_U_RNI_NID132, 0x1036d98)
    FIELD(POR_MPU_M7_PRLAR24_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR24_U_RNI_NID132, REGION24_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR24_U_RNI_NID132, REGION24_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR25_U_RNI_NID132, 0x1036da0)
    FIELD(POR_MPU_M7_PRBAR25_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR25_U_RNI_NID132, REGION25_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR25_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR25_U_RNI_NID132, REGION25_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR25_U_RNI_NID132, REGION25_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR25_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR25_U_RNI_NID132, 0x1036da8)
    FIELD(POR_MPU_M7_PRLAR25_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR25_U_RNI_NID132, REGION25_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR25_U_RNI_NID132, REGION25_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR26_U_RNI_NID132, 0x1036db0)
    FIELD(POR_MPU_M7_PRBAR26_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR26_U_RNI_NID132, REGION26_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR26_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR26_U_RNI_NID132, REGION26_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR26_U_RNI_NID132, REGION26_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR26_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR26_U_RNI_NID132, 0x1036db8)
    FIELD(POR_MPU_M7_PRLAR26_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR26_U_RNI_NID132, REGION26_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR26_U_RNI_NID132, REGION26_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR27_U_RNI_NID132, 0x1036dc0)
    FIELD(POR_MPU_M7_PRBAR27_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR27_U_RNI_NID132, REGION27_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR27_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR27_U_RNI_NID132, REGION27_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR27_U_RNI_NID132, REGION27_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR27_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR27_U_RNI_NID132, 0x1036dc8)
    FIELD(POR_MPU_M7_PRLAR27_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR27_U_RNI_NID132, REGION27_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR27_U_RNI_NID132, REGION27_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR28_U_RNI_NID132, 0x1036dd0)
    FIELD(POR_MPU_M7_PRBAR28_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR28_U_RNI_NID132, REGION28_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR28_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR28_U_RNI_NID132, REGION28_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR28_U_RNI_NID132, REGION28_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR28_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR28_U_RNI_NID132, 0x1036dd8)
    FIELD(POR_MPU_M7_PRLAR28_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR28_U_RNI_NID132, REGION28_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR28_U_RNI_NID132, REGION28_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR29_U_RNI_NID132, 0x1036de0)
    FIELD(POR_MPU_M7_PRBAR29_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR29_U_RNI_NID132, REGION29_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR29_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR29_U_RNI_NID132, REGION29_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR29_U_RNI_NID132, REGION29_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR29_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR29_U_RNI_NID132, 0x1036de8)
    FIELD(POR_MPU_M7_PRLAR29_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR29_U_RNI_NID132, REGION29_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR29_U_RNI_NID132, REGION29_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR30_U_RNI_NID132, 0x1036df0)
    FIELD(POR_MPU_M7_PRBAR30_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR30_U_RNI_NID132, REGION30_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR30_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR30_U_RNI_NID132, REGION30_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR30_U_RNI_NID132, REGION30_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR30_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR30_U_RNI_NID132, 0x1036df8)
    FIELD(POR_MPU_M7_PRLAR30_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR30_U_RNI_NID132, REGION30_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR30_U_RNI_NID132, REGION30_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR31_U_RNI_NID132, 0x1036e00)
    FIELD(POR_MPU_M7_PRBAR31_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR31_U_RNI_NID132, REGION31_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR31_U_RNI_NID132, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR31_U_RNI_NID132, REGION31_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR31_U_RNI_NID132, REGION31_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR31_U_RNI_NID132, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR31_U_RNI_NID132, 0x1036e08)
    FIELD(POR_MPU_M7_PRLAR31_U_RNI_NID132, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR31_U_RNI_NID132, REGION31_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR31_U_RNI_NID132, REGION31_EN, 0, 1)
REG32(POR_MPU_NODE_INFO_U_SMXP_2_0, 0x103c000)
    FIELD(POR_MPU_NODE_INFO_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_NODE_INFO_U_SMXP_2_0, LOGICAL_ID, 32, 16)
    FIELD(POR_MPU_NODE_INFO_U_SMXP_2_0, NODE_ID, 16, 16)
    FIELD(POR_MPU_NODE_INFO_U_SMXP_2_0, NODE_TYPE, 0, 16)
REG32(POR_MPU_CHILD_INFO_U_SMXP_2_0, 0x103c080)
    FIELD(POR_MPU_CHILD_INFO_U_SMXP_2_0, RESERVED_32, 32, 32)
    FIELD(POR_MPU_CHILD_INFO_U_SMXP_2_0, CHILD_PTR_OFFSET, 16, 16)
    FIELD(POR_MPU_CHILD_INFO_U_SMXP_2_0, CHILD_COUNT, 0, 16)
REG32(POR_MPU_UNIT_INFO_U_SMXP_2_0, 0x103c900)
    FIELD(POR_MPU_UNIT_INFO_U_SMXP_2_0, RESERVED_16, 16, 48)
    FIELD(POR_MPU_UNIT_INFO_U_SMXP_2_0, MASTER_7_PRESENT, 15, 1)
    FIELD(POR_MPU_UNIT_INFO_U_SMXP_2_0, MASTER_6_PRESENT, 14, 1)
    FIELD(POR_MPU_UNIT_INFO_U_SMXP_2_0, MASTER_5_PRESENT, 13, 1)
    FIELD(POR_MPU_UNIT_INFO_U_SMXP_2_0, MASTER_4_PRESENT, 12, 1)
    FIELD(POR_MPU_UNIT_INFO_U_SMXP_2_0, MASTER_3_PRESENT, 11, 1)
    FIELD(POR_MPU_UNIT_INFO_U_SMXP_2_0, MASTER_2_PRESENT, 10, 1)
    FIELD(POR_MPU_UNIT_INFO_U_SMXP_2_0, MASTER_1_PRESENT, 9, 1)
    FIELD(POR_MPU_UNIT_INFO_U_SMXP_2_0, MASTER_0_PRESENT, 8, 1)
    FIELD(POR_MPU_UNIT_INFO_U_SMXP_2_0, NUM_PROG_REGION, 0, 8)
REG32(POR_MPU_M0_CTL_U_SMXP_2_0, 0x103d000)
    FIELD(POR_MPU_M0_CTL_U_SMXP_2_0, M0_EN, 2, 1)
    FIELD(POR_MPU_M0_CTL_U_SMXP_2_0, M0_ACTION, 0, 2)
REG32(POR_MPU_M0_PRBAR0_U_SMXP_2_0, 0x103d010)
    FIELD(POR_MPU_M0_PRBAR0_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR0_U_SMXP_2_0, REGION0_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR0_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR0_U_SMXP_2_0, REGION0_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR0_U_SMXP_2_0, REGION0_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR0_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR0_U_SMXP_2_0, 0x103d018)
    FIELD(POR_MPU_M0_PRLAR0_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR0_U_SMXP_2_0, REGION0_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR0_U_SMXP_2_0, REGION0_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR1_U_SMXP_2_0, 0x103d020)
    FIELD(POR_MPU_M0_PRBAR1_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR1_U_SMXP_2_0, REGION1_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR1_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR1_U_SMXP_2_0, REGION1_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR1_U_SMXP_2_0, REGION1_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR1_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR1_U_SMXP_2_0, 0x103d028)
    FIELD(POR_MPU_M0_PRLAR1_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR1_U_SMXP_2_0, REGION1_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR1_U_SMXP_2_0, REGION1_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR2_U_SMXP_2_0, 0x103d030)
    FIELD(POR_MPU_M0_PRBAR2_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR2_U_SMXP_2_0, REGION2_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR2_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR2_U_SMXP_2_0, REGION2_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR2_U_SMXP_2_0, REGION2_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR2_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR2_U_SMXP_2_0, 0x103d038)
    FIELD(POR_MPU_M0_PRLAR2_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR2_U_SMXP_2_0, REGION2_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR2_U_SMXP_2_0, REGION2_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR3_U_SMXP_2_0, 0x103d040)
    FIELD(POR_MPU_M0_PRBAR3_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR3_U_SMXP_2_0, REGION3_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR3_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR3_U_SMXP_2_0, REGION3_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR3_U_SMXP_2_0, REGION3_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR3_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR3_U_SMXP_2_0, 0x103d048)
    FIELD(POR_MPU_M0_PRLAR3_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR3_U_SMXP_2_0, REGION3_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR3_U_SMXP_2_0, REGION3_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR4_U_SMXP_2_0, 0x103d050)
    FIELD(POR_MPU_M0_PRBAR4_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR4_U_SMXP_2_0, REGION4_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR4_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR4_U_SMXP_2_0, REGION4_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR4_U_SMXP_2_0, REGION4_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR4_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR4_U_SMXP_2_0, 0x103d058)
    FIELD(POR_MPU_M0_PRLAR4_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR4_U_SMXP_2_0, REGION4_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR4_U_SMXP_2_0, REGION4_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR5_U_SMXP_2_0, 0x103d060)
    FIELD(POR_MPU_M0_PRBAR5_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR5_U_SMXP_2_0, REGION5_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR5_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR5_U_SMXP_2_0, REGION5_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR5_U_SMXP_2_0, REGION5_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR5_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR5_U_SMXP_2_0, 0x103d068)
    FIELD(POR_MPU_M0_PRLAR5_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR5_U_SMXP_2_0, REGION5_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR5_U_SMXP_2_0, REGION5_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR6_U_SMXP_2_0, 0x103d070)
    FIELD(POR_MPU_M0_PRBAR6_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR6_U_SMXP_2_0, REGION6_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR6_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR6_U_SMXP_2_0, REGION6_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR6_U_SMXP_2_0, REGION6_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR6_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR6_U_SMXP_2_0, 0x103d078)
    FIELD(POR_MPU_M0_PRLAR6_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR6_U_SMXP_2_0, REGION6_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR6_U_SMXP_2_0, REGION6_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR7_U_SMXP_2_0, 0x103d080)
    FIELD(POR_MPU_M0_PRBAR7_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR7_U_SMXP_2_0, REGION7_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR7_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR7_U_SMXP_2_0, REGION7_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR7_U_SMXP_2_0, REGION7_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR7_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR7_U_SMXP_2_0, 0x103d088)
    FIELD(POR_MPU_M0_PRLAR7_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR7_U_SMXP_2_0, REGION7_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR7_U_SMXP_2_0, REGION7_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR8_U_SMXP_2_0, 0x103d090)
    FIELD(POR_MPU_M0_PRBAR8_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR8_U_SMXP_2_0, REGION8_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR8_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR8_U_SMXP_2_0, REGION8_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR8_U_SMXP_2_0, REGION8_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR8_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR8_U_SMXP_2_0, 0x103d098)
    FIELD(POR_MPU_M0_PRLAR8_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR8_U_SMXP_2_0, REGION8_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR8_U_SMXP_2_0, REGION8_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR9_U_SMXP_2_0, 0x103d0a0)
    FIELD(POR_MPU_M0_PRBAR9_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR9_U_SMXP_2_0, REGION9_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR9_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR9_U_SMXP_2_0, REGION9_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR9_U_SMXP_2_0, REGION9_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR9_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR9_U_SMXP_2_0, 0x103d0a8)
    FIELD(POR_MPU_M0_PRLAR9_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR9_U_SMXP_2_0, REGION9_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR9_U_SMXP_2_0, REGION9_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR10_U_SMXP_2_0, 0x103d0b0)
    FIELD(POR_MPU_M0_PRBAR10_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR10_U_SMXP_2_0, REGION10_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR10_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR10_U_SMXP_2_0, REGION10_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR10_U_SMXP_2_0, REGION10_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR10_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR10_U_SMXP_2_0, 0x103d0b8)
    FIELD(POR_MPU_M0_PRLAR10_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR10_U_SMXP_2_0, REGION10_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR10_U_SMXP_2_0, REGION10_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR11_U_SMXP_2_0, 0x103d0c0)
    FIELD(POR_MPU_M0_PRBAR11_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR11_U_SMXP_2_0, REGION11_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR11_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR11_U_SMXP_2_0, REGION11_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR11_U_SMXP_2_0, REGION11_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR11_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR11_U_SMXP_2_0, 0x103d0c8)
    FIELD(POR_MPU_M0_PRLAR11_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR11_U_SMXP_2_0, REGION11_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR11_U_SMXP_2_0, REGION11_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR12_U_SMXP_2_0, 0x103d0d0)
    FIELD(POR_MPU_M0_PRBAR12_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR12_U_SMXP_2_0, REGION12_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR12_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR12_U_SMXP_2_0, REGION12_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR12_U_SMXP_2_0, REGION12_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR12_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR12_U_SMXP_2_0, 0x103d0d8)
    FIELD(POR_MPU_M0_PRLAR12_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR12_U_SMXP_2_0, REGION12_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR12_U_SMXP_2_0, REGION12_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR13_U_SMXP_2_0, 0x103d0e0)
    FIELD(POR_MPU_M0_PRBAR13_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR13_U_SMXP_2_0, REGION13_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR13_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR13_U_SMXP_2_0, REGION13_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR13_U_SMXP_2_0, REGION13_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR13_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR13_U_SMXP_2_0, 0x103d0e8)
    FIELD(POR_MPU_M0_PRLAR13_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR13_U_SMXP_2_0, REGION13_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR13_U_SMXP_2_0, REGION13_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR14_U_SMXP_2_0, 0x103d0f0)
    FIELD(POR_MPU_M0_PRBAR14_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR14_U_SMXP_2_0, REGION14_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR14_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR14_U_SMXP_2_0, REGION14_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR14_U_SMXP_2_0, REGION14_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR14_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR14_U_SMXP_2_0, 0x103d0f8)
    FIELD(POR_MPU_M0_PRLAR14_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR14_U_SMXP_2_0, REGION14_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR14_U_SMXP_2_0, REGION14_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR15_U_SMXP_2_0, 0x103d100)
    FIELD(POR_MPU_M0_PRBAR15_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR15_U_SMXP_2_0, REGION15_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR15_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR15_U_SMXP_2_0, REGION15_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR15_U_SMXP_2_0, REGION15_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR15_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR15_U_SMXP_2_0, 0x103d108)
    FIELD(POR_MPU_M0_PRLAR15_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR15_U_SMXP_2_0, REGION15_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR15_U_SMXP_2_0, REGION15_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR16_U_SMXP_2_0, 0x103d110)
    FIELD(POR_MPU_M0_PRBAR16_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR16_U_SMXP_2_0, REGION16_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR16_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR16_U_SMXP_2_0, REGION16_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR16_U_SMXP_2_0, REGION16_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR16_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR16_U_SMXP_2_0, 0x103d118)
    FIELD(POR_MPU_M0_PRLAR16_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR16_U_SMXP_2_0, REGION16_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR16_U_SMXP_2_0, REGION16_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR17_U_SMXP_2_0, 0x103d120)
    FIELD(POR_MPU_M0_PRBAR17_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR17_U_SMXP_2_0, REGION17_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR17_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR17_U_SMXP_2_0, REGION17_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR17_U_SMXP_2_0, REGION17_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR17_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR17_U_SMXP_2_0, 0x103d128)
    FIELD(POR_MPU_M0_PRLAR17_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR17_U_SMXP_2_0, REGION17_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR17_U_SMXP_2_0, REGION17_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR18_U_SMXP_2_0, 0x103d130)
    FIELD(POR_MPU_M0_PRBAR18_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR18_U_SMXP_2_0, REGION18_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR18_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR18_U_SMXP_2_0, REGION18_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR18_U_SMXP_2_0, REGION18_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR18_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR18_U_SMXP_2_0, 0x103d138)
    FIELD(POR_MPU_M0_PRLAR18_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR18_U_SMXP_2_0, REGION18_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR18_U_SMXP_2_0, REGION18_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR19_U_SMXP_2_0, 0x103d140)
    FIELD(POR_MPU_M0_PRBAR19_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR19_U_SMXP_2_0, REGION19_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR19_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR19_U_SMXP_2_0, REGION19_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR19_U_SMXP_2_0, REGION19_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR19_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR19_U_SMXP_2_0, 0x103d148)
    FIELD(POR_MPU_M0_PRLAR19_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR19_U_SMXP_2_0, REGION19_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR19_U_SMXP_2_0, REGION19_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR20_U_SMXP_2_0, 0x103d150)
    FIELD(POR_MPU_M0_PRBAR20_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR20_U_SMXP_2_0, REGION20_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR20_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR20_U_SMXP_2_0, REGION20_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR20_U_SMXP_2_0, REGION20_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR20_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR20_U_SMXP_2_0, 0x103d158)
    FIELD(POR_MPU_M0_PRLAR20_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR20_U_SMXP_2_0, REGION20_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR20_U_SMXP_2_0, REGION20_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR21_U_SMXP_2_0, 0x103d160)
    FIELD(POR_MPU_M0_PRBAR21_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR21_U_SMXP_2_0, REGION21_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR21_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR21_U_SMXP_2_0, REGION21_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR21_U_SMXP_2_0, REGION21_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR21_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR21_U_SMXP_2_0, 0x103d168)
    FIELD(POR_MPU_M0_PRLAR21_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR21_U_SMXP_2_0, REGION21_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR21_U_SMXP_2_0, REGION21_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR22_U_SMXP_2_0, 0x103d170)
    FIELD(POR_MPU_M0_PRBAR22_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR22_U_SMXP_2_0, REGION22_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR22_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR22_U_SMXP_2_0, REGION22_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR22_U_SMXP_2_0, REGION22_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR22_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR22_U_SMXP_2_0, 0x103d178)
    FIELD(POR_MPU_M0_PRLAR22_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR22_U_SMXP_2_0, REGION22_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR22_U_SMXP_2_0, REGION22_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR23_U_SMXP_2_0, 0x103d180)
    FIELD(POR_MPU_M0_PRBAR23_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR23_U_SMXP_2_0, REGION23_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR23_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR23_U_SMXP_2_0, REGION23_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR23_U_SMXP_2_0, REGION23_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR23_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR23_U_SMXP_2_0, 0x103d188)
    FIELD(POR_MPU_M0_PRLAR23_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR23_U_SMXP_2_0, REGION23_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR23_U_SMXP_2_0, REGION23_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR24_U_SMXP_2_0, 0x103d190)
    FIELD(POR_MPU_M0_PRBAR24_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR24_U_SMXP_2_0, REGION24_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR24_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR24_U_SMXP_2_0, REGION24_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR24_U_SMXP_2_0, REGION24_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR24_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR24_U_SMXP_2_0, 0x103d198)
    FIELD(POR_MPU_M0_PRLAR24_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR24_U_SMXP_2_0, REGION24_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR24_U_SMXP_2_0, REGION24_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR25_U_SMXP_2_0, 0x103d1a0)
    FIELD(POR_MPU_M0_PRBAR25_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR25_U_SMXP_2_0, REGION25_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR25_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR25_U_SMXP_2_0, REGION25_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR25_U_SMXP_2_0, REGION25_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR25_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR25_U_SMXP_2_0, 0x103d1a8)
    FIELD(POR_MPU_M0_PRLAR25_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR25_U_SMXP_2_0, REGION25_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR25_U_SMXP_2_0, REGION25_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR26_U_SMXP_2_0, 0x103d1b0)
    FIELD(POR_MPU_M0_PRBAR26_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR26_U_SMXP_2_0, REGION26_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR26_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR26_U_SMXP_2_0, REGION26_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR26_U_SMXP_2_0, REGION26_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR26_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR26_U_SMXP_2_0, 0x103d1b8)
    FIELD(POR_MPU_M0_PRLAR26_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR26_U_SMXP_2_0, REGION26_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR26_U_SMXP_2_0, REGION26_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR27_U_SMXP_2_0, 0x103d1c0)
    FIELD(POR_MPU_M0_PRBAR27_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR27_U_SMXP_2_0, REGION27_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR27_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR27_U_SMXP_2_0, REGION27_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR27_U_SMXP_2_0, REGION27_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR27_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR27_U_SMXP_2_0, 0x103d1c8)
    FIELD(POR_MPU_M0_PRLAR27_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR27_U_SMXP_2_0, REGION27_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR27_U_SMXP_2_0, REGION27_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR28_U_SMXP_2_0, 0x103d1d0)
    FIELD(POR_MPU_M0_PRBAR28_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR28_U_SMXP_2_0, REGION28_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR28_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR28_U_SMXP_2_0, REGION28_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR28_U_SMXP_2_0, REGION28_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR28_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR28_U_SMXP_2_0, 0x103d1d8)
    FIELD(POR_MPU_M0_PRLAR28_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR28_U_SMXP_2_0, REGION28_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR28_U_SMXP_2_0, REGION28_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR29_U_SMXP_2_0, 0x103d1e0)
    FIELD(POR_MPU_M0_PRBAR29_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR29_U_SMXP_2_0, REGION29_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR29_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR29_U_SMXP_2_0, REGION29_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR29_U_SMXP_2_0, REGION29_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR29_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR29_U_SMXP_2_0, 0x103d1e8)
    FIELD(POR_MPU_M0_PRLAR29_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR29_U_SMXP_2_0, REGION29_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR29_U_SMXP_2_0, REGION29_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR30_U_SMXP_2_0, 0x103d1f0)
    FIELD(POR_MPU_M0_PRBAR30_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR30_U_SMXP_2_0, REGION30_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR30_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR30_U_SMXP_2_0, REGION30_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR30_U_SMXP_2_0, REGION30_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR30_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR30_U_SMXP_2_0, 0x103d1f8)
    FIELD(POR_MPU_M0_PRLAR30_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR30_U_SMXP_2_0, REGION30_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR30_U_SMXP_2_0, REGION30_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR31_U_SMXP_2_0, 0x103d200)
    FIELD(POR_MPU_M0_PRBAR31_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR31_U_SMXP_2_0, REGION31_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR31_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR31_U_SMXP_2_0, REGION31_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR31_U_SMXP_2_0, REGION31_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR31_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR31_U_SMXP_2_0, 0x103d208)
    FIELD(POR_MPU_M0_PRLAR31_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR31_U_SMXP_2_0, REGION31_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR31_U_SMXP_2_0, REGION31_EN, 0, 1)
REG32(POR_MPU_M1_CTL_U_SMXP_2_0, 0x103d400)
    FIELD(POR_MPU_M1_CTL_U_SMXP_2_0, M1_EN, 2, 1)
    FIELD(POR_MPU_M1_CTL_U_SMXP_2_0, M1_ACTION, 0, 2)
REG32(POR_MPU_M1_PRBAR0_U_SMXP_2_0, 0x103d410)
    FIELD(POR_MPU_M1_PRBAR0_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR0_U_SMXP_2_0, REGION0_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR0_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR0_U_SMXP_2_0, REGION0_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR0_U_SMXP_2_0, REGION0_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR0_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR0_U_SMXP_2_0, 0x103d418)
    FIELD(POR_MPU_M1_PRLAR0_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR0_U_SMXP_2_0, REGION0_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR0_U_SMXP_2_0, REGION0_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR1_U_SMXP_2_0, 0x103d420)
    FIELD(POR_MPU_M1_PRBAR1_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR1_U_SMXP_2_0, REGION1_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR1_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR1_U_SMXP_2_0, REGION1_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR1_U_SMXP_2_0, REGION1_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR1_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR1_U_SMXP_2_0, 0x103d428)
    FIELD(POR_MPU_M1_PRLAR1_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR1_U_SMXP_2_0, REGION1_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR1_U_SMXP_2_0, REGION1_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR2_U_SMXP_2_0, 0x103d430)
    FIELD(POR_MPU_M1_PRBAR2_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR2_U_SMXP_2_0, REGION2_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR2_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR2_U_SMXP_2_0, REGION2_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR2_U_SMXP_2_0, REGION2_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR2_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR2_U_SMXP_2_0, 0x103d438)
    FIELD(POR_MPU_M1_PRLAR2_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR2_U_SMXP_2_0, REGION2_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR2_U_SMXP_2_0, REGION2_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR3_U_SMXP_2_0, 0x103d440)
    FIELD(POR_MPU_M1_PRBAR3_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR3_U_SMXP_2_0, REGION3_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR3_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR3_U_SMXP_2_0, REGION3_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR3_U_SMXP_2_0, REGION3_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR3_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR3_U_SMXP_2_0, 0x103d448)
    FIELD(POR_MPU_M1_PRLAR3_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR3_U_SMXP_2_0, REGION3_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR3_U_SMXP_2_0, REGION3_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR4_U_SMXP_2_0, 0x103d450)
    FIELD(POR_MPU_M1_PRBAR4_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR4_U_SMXP_2_0, REGION4_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR4_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR4_U_SMXP_2_0, REGION4_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR4_U_SMXP_2_0, REGION4_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR4_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR4_U_SMXP_2_0, 0x103d458)
    FIELD(POR_MPU_M1_PRLAR4_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR4_U_SMXP_2_0, REGION4_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR4_U_SMXP_2_0, REGION4_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR5_U_SMXP_2_0, 0x103d460)
    FIELD(POR_MPU_M1_PRBAR5_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR5_U_SMXP_2_0, REGION5_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR5_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR5_U_SMXP_2_0, REGION5_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR5_U_SMXP_2_0, REGION5_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR5_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR5_U_SMXP_2_0, 0x103d468)
    FIELD(POR_MPU_M1_PRLAR5_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR5_U_SMXP_2_0, REGION5_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR5_U_SMXP_2_0, REGION5_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR6_U_SMXP_2_0, 0x103d470)
    FIELD(POR_MPU_M1_PRBAR6_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR6_U_SMXP_2_0, REGION6_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR6_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR6_U_SMXP_2_0, REGION6_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR6_U_SMXP_2_0, REGION6_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR6_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR6_U_SMXP_2_0, 0x103d478)
    FIELD(POR_MPU_M1_PRLAR6_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR6_U_SMXP_2_0, REGION6_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR6_U_SMXP_2_0, REGION6_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR7_U_SMXP_2_0, 0x103d480)
    FIELD(POR_MPU_M1_PRBAR7_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR7_U_SMXP_2_0, REGION7_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR7_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR7_U_SMXP_2_0, REGION7_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR7_U_SMXP_2_0, REGION7_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR7_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR7_U_SMXP_2_0, 0x103d488)
    FIELD(POR_MPU_M1_PRLAR7_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR7_U_SMXP_2_0, REGION7_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR7_U_SMXP_2_0, REGION7_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR8_U_SMXP_2_0, 0x103d490)
    FIELD(POR_MPU_M1_PRBAR8_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR8_U_SMXP_2_0, REGION8_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR8_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR8_U_SMXP_2_0, REGION8_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR8_U_SMXP_2_0, REGION8_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR8_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR8_U_SMXP_2_0, 0x103d498)
    FIELD(POR_MPU_M1_PRLAR8_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR8_U_SMXP_2_0, REGION8_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR8_U_SMXP_2_0, REGION8_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR9_U_SMXP_2_0, 0x103d4a0)
    FIELD(POR_MPU_M1_PRBAR9_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR9_U_SMXP_2_0, REGION9_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR9_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR9_U_SMXP_2_0, REGION9_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR9_U_SMXP_2_0, REGION9_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR9_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR9_U_SMXP_2_0, 0x103d4a8)
    FIELD(POR_MPU_M1_PRLAR9_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR9_U_SMXP_2_0, REGION9_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR9_U_SMXP_2_0, REGION9_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR10_U_SMXP_2_0, 0x103d4b0)
    FIELD(POR_MPU_M1_PRBAR10_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR10_U_SMXP_2_0, REGION10_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR10_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR10_U_SMXP_2_0, REGION10_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR10_U_SMXP_2_0, REGION10_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR10_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR10_U_SMXP_2_0, 0x103d4b8)
    FIELD(POR_MPU_M1_PRLAR10_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR10_U_SMXP_2_0, REGION10_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR10_U_SMXP_2_0, REGION10_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR11_U_SMXP_2_0, 0x103d4c0)
    FIELD(POR_MPU_M1_PRBAR11_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR11_U_SMXP_2_0, REGION11_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR11_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR11_U_SMXP_2_0, REGION11_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR11_U_SMXP_2_0, REGION11_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR11_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR11_U_SMXP_2_0, 0x103d4c8)
    FIELD(POR_MPU_M1_PRLAR11_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR11_U_SMXP_2_0, REGION11_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR11_U_SMXP_2_0, REGION11_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR12_U_SMXP_2_0, 0x103d4d0)
    FIELD(POR_MPU_M1_PRBAR12_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR12_U_SMXP_2_0, REGION12_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR12_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR12_U_SMXP_2_0, REGION12_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR12_U_SMXP_2_0, REGION12_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR12_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR12_U_SMXP_2_0, 0x103d4d8)
    FIELD(POR_MPU_M1_PRLAR12_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR12_U_SMXP_2_0, REGION12_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR12_U_SMXP_2_0, REGION12_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR13_U_SMXP_2_0, 0x103d4e0)
    FIELD(POR_MPU_M1_PRBAR13_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR13_U_SMXP_2_0, REGION13_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR13_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR13_U_SMXP_2_0, REGION13_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR13_U_SMXP_2_0, REGION13_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR13_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR13_U_SMXP_2_0, 0x103d4e8)
    FIELD(POR_MPU_M1_PRLAR13_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR13_U_SMXP_2_0, REGION13_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR13_U_SMXP_2_0, REGION13_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR14_U_SMXP_2_0, 0x103d4f0)
    FIELD(POR_MPU_M1_PRBAR14_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR14_U_SMXP_2_0, REGION14_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR14_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR14_U_SMXP_2_0, REGION14_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR14_U_SMXP_2_0, REGION14_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR14_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR14_U_SMXP_2_0, 0x103d4f8)
    FIELD(POR_MPU_M1_PRLAR14_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR14_U_SMXP_2_0, REGION14_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR14_U_SMXP_2_0, REGION14_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR15_U_SMXP_2_0, 0x103d500)
    FIELD(POR_MPU_M1_PRBAR15_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR15_U_SMXP_2_0, REGION15_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR15_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR15_U_SMXP_2_0, REGION15_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR15_U_SMXP_2_0, REGION15_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR15_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR15_U_SMXP_2_0, 0x103d508)
    FIELD(POR_MPU_M1_PRLAR15_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR15_U_SMXP_2_0, REGION15_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR15_U_SMXP_2_0, REGION15_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR16_U_SMXP_2_0, 0x103d510)
    FIELD(POR_MPU_M1_PRBAR16_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR16_U_SMXP_2_0, REGION16_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR16_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR16_U_SMXP_2_0, REGION16_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR16_U_SMXP_2_0, REGION16_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR16_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR16_U_SMXP_2_0, 0x103d518)
    FIELD(POR_MPU_M1_PRLAR16_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR16_U_SMXP_2_0, REGION16_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR16_U_SMXP_2_0, REGION16_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR17_U_SMXP_2_0, 0x103d520)
    FIELD(POR_MPU_M1_PRBAR17_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR17_U_SMXP_2_0, REGION17_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR17_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR17_U_SMXP_2_0, REGION17_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR17_U_SMXP_2_0, REGION17_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR17_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR17_U_SMXP_2_0, 0x103d528)
    FIELD(POR_MPU_M1_PRLAR17_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR17_U_SMXP_2_0, REGION17_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR17_U_SMXP_2_0, REGION17_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR18_U_SMXP_2_0, 0x103d530)
    FIELD(POR_MPU_M1_PRBAR18_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR18_U_SMXP_2_0, REGION18_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR18_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR18_U_SMXP_2_0, REGION18_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR18_U_SMXP_2_0, REGION18_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR18_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR18_U_SMXP_2_0, 0x103d538)
    FIELD(POR_MPU_M1_PRLAR18_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR18_U_SMXP_2_0, REGION18_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR18_U_SMXP_2_0, REGION18_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR19_U_SMXP_2_0, 0x103d540)
    FIELD(POR_MPU_M1_PRBAR19_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR19_U_SMXP_2_0, REGION19_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR19_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR19_U_SMXP_2_0, REGION19_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR19_U_SMXP_2_0, REGION19_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR19_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR19_U_SMXP_2_0, 0x103d548)
    FIELD(POR_MPU_M1_PRLAR19_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR19_U_SMXP_2_0, REGION19_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR19_U_SMXP_2_0, REGION19_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR20_U_SMXP_2_0, 0x103d550)
    FIELD(POR_MPU_M1_PRBAR20_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR20_U_SMXP_2_0, REGION20_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR20_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR20_U_SMXP_2_0, REGION20_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR20_U_SMXP_2_0, REGION20_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR20_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR20_U_SMXP_2_0, 0x103d558)
    FIELD(POR_MPU_M1_PRLAR20_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR20_U_SMXP_2_0, REGION20_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR20_U_SMXP_2_0, REGION20_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR21_U_SMXP_2_0, 0x103d560)
    FIELD(POR_MPU_M1_PRBAR21_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR21_U_SMXP_2_0, REGION21_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR21_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR21_U_SMXP_2_0, REGION21_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR21_U_SMXP_2_0, REGION21_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR21_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR21_U_SMXP_2_0, 0x103d568)
    FIELD(POR_MPU_M1_PRLAR21_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR21_U_SMXP_2_0, REGION21_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR21_U_SMXP_2_0, REGION21_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR22_U_SMXP_2_0, 0x103d570)
    FIELD(POR_MPU_M1_PRBAR22_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR22_U_SMXP_2_0, REGION22_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR22_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR22_U_SMXP_2_0, REGION22_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR22_U_SMXP_2_0, REGION22_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR22_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR22_U_SMXP_2_0, 0x103d578)
    FIELD(POR_MPU_M1_PRLAR22_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR22_U_SMXP_2_0, REGION22_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR22_U_SMXP_2_0, REGION22_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR23_U_SMXP_2_0, 0x103d580)
    FIELD(POR_MPU_M1_PRBAR23_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR23_U_SMXP_2_0, REGION23_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR23_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR23_U_SMXP_2_0, REGION23_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR23_U_SMXP_2_0, REGION23_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR23_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR23_U_SMXP_2_0, 0x103d588)
    FIELD(POR_MPU_M1_PRLAR23_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR23_U_SMXP_2_0, REGION23_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR23_U_SMXP_2_0, REGION23_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR24_U_SMXP_2_0, 0x103d590)
    FIELD(POR_MPU_M1_PRBAR24_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR24_U_SMXP_2_0, REGION24_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR24_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR24_U_SMXP_2_0, REGION24_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR24_U_SMXP_2_0, REGION24_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR24_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR24_U_SMXP_2_0, 0x103d598)
    FIELD(POR_MPU_M1_PRLAR24_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR24_U_SMXP_2_0, REGION24_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR24_U_SMXP_2_0, REGION24_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR25_U_SMXP_2_0, 0x103d5a0)
    FIELD(POR_MPU_M1_PRBAR25_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR25_U_SMXP_2_0, REGION25_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR25_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR25_U_SMXP_2_0, REGION25_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR25_U_SMXP_2_0, REGION25_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR25_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR25_U_SMXP_2_0, 0x103d5a8)
    FIELD(POR_MPU_M1_PRLAR25_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR25_U_SMXP_2_0, REGION25_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR25_U_SMXP_2_0, REGION25_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR26_U_SMXP_2_0, 0x103d5b0)
    FIELD(POR_MPU_M1_PRBAR26_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR26_U_SMXP_2_0, REGION26_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR26_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR26_U_SMXP_2_0, REGION26_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR26_U_SMXP_2_0, REGION26_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR26_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR26_U_SMXP_2_0, 0x103d5b8)
    FIELD(POR_MPU_M1_PRLAR26_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR26_U_SMXP_2_0, REGION26_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR26_U_SMXP_2_0, REGION26_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR27_U_SMXP_2_0, 0x103d5c0)
    FIELD(POR_MPU_M1_PRBAR27_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR27_U_SMXP_2_0, REGION27_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR27_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR27_U_SMXP_2_0, REGION27_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR27_U_SMXP_2_0, REGION27_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR27_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR27_U_SMXP_2_0, 0x103d5c8)
    FIELD(POR_MPU_M1_PRLAR27_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR27_U_SMXP_2_0, REGION27_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR27_U_SMXP_2_0, REGION27_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR28_U_SMXP_2_0, 0x103d5d0)
    FIELD(POR_MPU_M1_PRBAR28_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR28_U_SMXP_2_0, REGION28_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR28_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR28_U_SMXP_2_0, REGION28_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR28_U_SMXP_2_0, REGION28_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR28_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR28_U_SMXP_2_0, 0x103d5d8)
    FIELD(POR_MPU_M1_PRLAR28_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR28_U_SMXP_2_0, REGION28_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR28_U_SMXP_2_0, REGION28_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR29_U_SMXP_2_0, 0x103d5e0)
    FIELD(POR_MPU_M1_PRBAR29_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR29_U_SMXP_2_0, REGION29_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR29_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR29_U_SMXP_2_0, REGION29_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR29_U_SMXP_2_0, REGION29_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR29_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR29_U_SMXP_2_0, 0x103d5e8)
    FIELD(POR_MPU_M1_PRLAR29_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR29_U_SMXP_2_0, REGION29_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR29_U_SMXP_2_0, REGION29_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR30_U_SMXP_2_0, 0x103d5f0)
    FIELD(POR_MPU_M1_PRBAR30_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR30_U_SMXP_2_0, REGION30_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR30_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR30_U_SMXP_2_0, REGION30_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR30_U_SMXP_2_0, REGION30_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR30_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR30_U_SMXP_2_0, 0x103d5f8)
    FIELD(POR_MPU_M1_PRLAR30_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR30_U_SMXP_2_0, REGION30_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR30_U_SMXP_2_0, REGION30_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR31_U_SMXP_2_0, 0x103d600)
    FIELD(POR_MPU_M1_PRBAR31_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR31_U_SMXP_2_0, REGION31_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR31_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR31_U_SMXP_2_0, REGION31_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR31_U_SMXP_2_0, REGION31_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR31_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR31_U_SMXP_2_0, 0x103d608)
    FIELD(POR_MPU_M1_PRLAR31_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR31_U_SMXP_2_0, REGION31_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR31_U_SMXP_2_0, REGION31_EN, 0, 1)
REG32(POR_MPU_M2_CTL_U_SMXP_2_0, 0x103d800)
    FIELD(POR_MPU_M2_CTL_U_SMXP_2_0, M2_EN, 2, 1)
    FIELD(POR_MPU_M2_CTL_U_SMXP_2_0, M2_ACTION, 0, 2)
REG32(POR_MPU_M2_PRBAR0_U_SMXP_2_0, 0x103d810)
    FIELD(POR_MPU_M2_PRBAR0_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR0_U_SMXP_2_0, REGION0_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR0_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR0_U_SMXP_2_0, REGION0_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR0_U_SMXP_2_0, REGION0_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR0_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR0_U_SMXP_2_0, 0x103d818)
    FIELD(POR_MPU_M2_PRLAR0_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR0_U_SMXP_2_0, REGION0_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR0_U_SMXP_2_0, REGION0_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR1_U_SMXP_2_0, 0x103d820)
    FIELD(POR_MPU_M2_PRBAR1_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR1_U_SMXP_2_0, REGION1_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR1_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR1_U_SMXP_2_0, REGION1_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR1_U_SMXP_2_0, REGION1_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR1_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR1_U_SMXP_2_0, 0x103d828)
    FIELD(POR_MPU_M2_PRLAR1_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR1_U_SMXP_2_0, REGION1_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR1_U_SMXP_2_0, REGION1_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR2_U_SMXP_2_0, 0x103d830)
    FIELD(POR_MPU_M2_PRBAR2_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR2_U_SMXP_2_0, REGION2_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR2_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR2_U_SMXP_2_0, REGION2_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR2_U_SMXP_2_0, REGION2_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR2_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR2_U_SMXP_2_0, 0x103d838)
    FIELD(POR_MPU_M2_PRLAR2_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR2_U_SMXP_2_0, REGION2_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR2_U_SMXP_2_0, REGION2_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR3_U_SMXP_2_0, 0x103d840)
    FIELD(POR_MPU_M2_PRBAR3_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR3_U_SMXP_2_0, REGION3_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR3_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR3_U_SMXP_2_0, REGION3_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR3_U_SMXP_2_0, REGION3_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR3_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR3_U_SMXP_2_0, 0x103d848)
    FIELD(POR_MPU_M2_PRLAR3_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR3_U_SMXP_2_0, REGION3_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR3_U_SMXP_2_0, REGION3_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR4_U_SMXP_2_0, 0x103d850)
    FIELD(POR_MPU_M2_PRBAR4_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR4_U_SMXP_2_0, REGION4_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR4_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR4_U_SMXP_2_0, REGION4_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR4_U_SMXP_2_0, REGION4_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR4_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR4_U_SMXP_2_0, 0x103d858)
    FIELD(POR_MPU_M2_PRLAR4_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR4_U_SMXP_2_0, REGION4_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR4_U_SMXP_2_0, REGION4_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR5_U_SMXP_2_0, 0x103d860)
    FIELD(POR_MPU_M2_PRBAR5_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR5_U_SMXP_2_0, REGION5_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR5_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR5_U_SMXP_2_0, REGION5_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR5_U_SMXP_2_0, REGION5_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR5_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR5_U_SMXP_2_0, 0x103d868)
    FIELD(POR_MPU_M2_PRLAR5_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR5_U_SMXP_2_0, REGION5_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR5_U_SMXP_2_0, REGION5_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR6_U_SMXP_2_0, 0x103d870)
    FIELD(POR_MPU_M2_PRBAR6_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR6_U_SMXP_2_0, REGION6_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR6_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR6_U_SMXP_2_0, REGION6_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR6_U_SMXP_2_0, REGION6_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR6_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR6_U_SMXP_2_0, 0x103d878)
    FIELD(POR_MPU_M2_PRLAR6_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR6_U_SMXP_2_0, REGION6_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR6_U_SMXP_2_0, REGION6_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR7_U_SMXP_2_0, 0x103d880)
    FIELD(POR_MPU_M2_PRBAR7_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR7_U_SMXP_2_0, REGION7_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR7_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR7_U_SMXP_2_0, REGION7_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR7_U_SMXP_2_0, REGION7_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR7_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR7_U_SMXP_2_0, 0x103d888)
    FIELD(POR_MPU_M2_PRLAR7_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR7_U_SMXP_2_0, REGION7_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR7_U_SMXP_2_0, REGION7_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR8_U_SMXP_2_0, 0x103d890)
    FIELD(POR_MPU_M2_PRBAR8_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR8_U_SMXP_2_0, REGION8_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR8_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR8_U_SMXP_2_0, REGION8_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR8_U_SMXP_2_0, REGION8_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR8_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR8_U_SMXP_2_0, 0x103d898)
    FIELD(POR_MPU_M2_PRLAR8_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR8_U_SMXP_2_0, REGION8_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR8_U_SMXP_2_0, REGION8_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR9_U_SMXP_2_0, 0x103d8a0)
    FIELD(POR_MPU_M2_PRBAR9_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR9_U_SMXP_2_0, REGION9_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR9_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR9_U_SMXP_2_0, REGION9_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR9_U_SMXP_2_0, REGION9_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR9_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR9_U_SMXP_2_0, 0x103d8a8)
    FIELD(POR_MPU_M2_PRLAR9_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR9_U_SMXP_2_0, REGION9_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR9_U_SMXP_2_0, REGION9_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR10_U_SMXP_2_0, 0x103d8b0)
    FIELD(POR_MPU_M2_PRBAR10_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR10_U_SMXP_2_0, REGION10_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR10_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR10_U_SMXP_2_0, REGION10_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR10_U_SMXP_2_0, REGION10_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR10_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR10_U_SMXP_2_0, 0x103d8b8)
    FIELD(POR_MPU_M2_PRLAR10_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR10_U_SMXP_2_0, REGION10_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR10_U_SMXP_2_0, REGION10_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR11_U_SMXP_2_0, 0x103d8c0)
    FIELD(POR_MPU_M2_PRBAR11_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR11_U_SMXP_2_0, REGION11_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR11_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR11_U_SMXP_2_0, REGION11_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR11_U_SMXP_2_0, REGION11_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR11_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR11_U_SMXP_2_0, 0x103d8c8)
    FIELD(POR_MPU_M2_PRLAR11_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR11_U_SMXP_2_0, REGION11_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR11_U_SMXP_2_0, REGION11_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR12_U_SMXP_2_0, 0x103d8d0)
    FIELD(POR_MPU_M2_PRBAR12_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR12_U_SMXP_2_0, REGION12_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR12_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR12_U_SMXP_2_0, REGION12_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR12_U_SMXP_2_0, REGION12_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR12_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR12_U_SMXP_2_0, 0x103d8d8)
    FIELD(POR_MPU_M2_PRLAR12_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR12_U_SMXP_2_0, REGION12_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR12_U_SMXP_2_0, REGION12_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR13_U_SMXP_2_0, 0x103d8e0)
    FIELD(POR_MPU_M2_PRBAR13_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR13_U_SMXP_2_0, REGION13_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR13_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR13_U_SMXP_2_0, REGION13_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR13_U_SMXP_2_0, REGION13_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR13_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR13_U_SMXP_2_0, 0x103d8e8)
    FIELD(POR_MPU_M2_PRLAR13_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR13_U_SMXP_2_0, REGION13_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR13_U_SMXP_2_0, REGION13_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR14_U_SMXP_2_0, 0x103d8f0)
    FIELD(POR_MPU_M2_PRBAR14_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR14_U_SMXP_2_0, REGION14_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR14_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR14_U_SMXP_2_0, REGION14_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR14_U_SMXP_2_0, REGION14_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR14_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR14_U_SMXP_2_0, 0x103d8f8)
    FIELD(POR_MPU_M2_PRLAR14_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR14_U_SMXP_2_0, REGION14_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR14_U_SMXP_2_0, REGION14_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR15_U_SMXP_2_0, 0x103d900)
    FIELD(POR_MPU_M2_PRBAR15_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR15_U_SMXP_2_0, REGION15_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR15_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR15_U_SMXP_2_0, REGION15_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR15_U_SMXP_2_0, REGION15_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR15_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR15_U_SMXP_2_0, 0x103d908)
    FIELD(POR_MPU_M2_PRLAR15_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR15_U_SMXP_2_0, REGION15_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR15_U_SMXP_2_0, REGION15_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR16_U_SMXP_2_0, 0x103d910)
    FIELD(POR_MPU_M2_PRBAR16_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR16_U_SMXP_2_0, REGION16_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR16_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR16_U_SMXP_2_0, REGION16_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR16_U_SMXP_2_0, REGION16_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR16_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR16_U_SMXP_2_0, 0x103d918)
    FIELD(POR_MPU_M2_PRLAR16_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR16_U_SMXP_2_0, REGION16_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR16_U_SMXP_2_0, REGION16_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR17_U_SMXP_2_0, 0x103d920)
    FIELD(POR_MPU_M2_PRBAR17_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR17_U_SMXP_2_0, REGION17_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR17_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR17_U_SMXP_2_0, REGION17_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR17_U_SMXP_2_0, REGION17_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR17_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR17_U_SMXP_2_0, 0x103d928)
    FIELD(POR_MPU_M2_PRLAR17_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR17_U_SMXP_2_0, REGION17_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR17_U_SMXP_2_0, REGION17_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR18_U_SMXP_2_0, 0x103d930)
    FIELD(POR_MPU_M2_PRBAR18_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR18_U_SMXP_2_0, REGION18_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR18_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR18_U_SMXP_2_0, REGION18_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR18_U_SMXP_2_0, REGION18_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR18_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR18_U_SMXP_2_0, 0x103d938)
    FIELD(POR_MPU_M2_PRLAR18_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR18_U_SMXP_2_0, REGION18_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR18_U_SMXP_2_0, REGION18_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR19_U_SMXP_2_0, 0x103d940)
    FIELD(POR_MPU_M2_PRBAR19_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR19_U_SMXP_2_0, REGION19_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR19_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR19_U_SMXP_2_0, REGION19_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR19_U_SMXP_2_0, REGION19_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR19_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR19_U_SMXP_2_0, 0x103d948)
    FIELD(POR_MPU_M2_PRLAR19_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR19_U_SMXP_2_0, REGION19_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR19_U_SMXP_2_0, REGION19_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR20_U_SMXP_2_0, 0x103d950)
    FIELD(POR_MPU_M2_PRBAR20_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR20_U_SMXP_2_0, REGION20_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR20_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR20_U_SMXP_2_0, REGION20_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR20_U_SMXP_2_0, REGION20_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR20_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR20_U_SMXP_2_0, 0x103d958)
    FIELD(POR_MPU_M2_PRLAR20_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR20_U_SMXP_2_0, REGION20_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR20_U_SMXP_2_0, REGION20_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR21_U_SMXP_2_0, 0x103d960)
    FIELD(POR_MPU_M2_PRBAR21_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR21_U_SMXP_2_0, REGION21_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR21_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR21_U_SMXP_2_0, REGION21_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR21_U_SMXP_2_0, REGION21_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR21_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR21_U_SMXP_2_0, 0x103d968)
    FIELD(POR_MPU_M2_PRLAR21_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR21_U_SMXP_2_0, REGION21_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR21_U_SMXP_2_0, REGION21_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR22_U_SMXP_2_0, 0x103d970)
    FIELD(POR_MPU_M2_PRBAR22_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR22_U_SMXP_2_0, REGION22_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR22_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR22_U_SMXP_2_0, REGION22_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR22_U_SMXP_2_0, REGION22_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR22_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR22_U_SMXP_2_0, 0x103d978)
    FIELD(POR_MPU_M2_PRLAR22_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR22_U_SMXP_2_0, REGION22_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR22_U_SMXP_2_0, REGION22_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR23_U_SMXP_2_0, 0x103d980)
    FIELD(POR_MPU_M2_PRBAR23_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR23_U_SMXP_2_0, REGION23_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR23_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR23_U_SMXP_2_0, REGION23_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR23_U_SMXP_2_0, REGION23_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR23_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR23_U_SMXP_2_0, 0x103d988)
    FIELD(POR_MPU_M2_PRLAR23_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR23_U_SMXP_2_0, REGION23_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR23_U_SMXP_2_0, REGION23_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR24_U_SMXP_2_0, 0x103d990)
    FIELD(POR_MPU_M2_PRBAR24_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR24_U_SMXP_2_0, REGION24_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR24_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR24_U_SMXP_2_0, REGION24_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR24_U_SMXP_2_0, REGION24_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR24_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR24_U_SMXP_2_0, 0x103d998)
    FIELD(POR_MPU_M2_PRLAR24_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR24_U_SMXP_2_0, REGION24_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR24_U_SMXP_2_0, REGION24_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR25_U_SMXP_2_0, 0x103d9a0)
    FIELD(POR_MPU_M2_PRBAR25_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR25_U_SMXP_2_0, REGION25_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR25_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR25_U_SMXP_2_0, REGION25_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR25_U_SMXP_2_0, REGION25_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR25_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR25_U_SMXP_2_0, 0x103d9a8)
    FIELD(POR_MPU_M2_PRLAR25_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR25_U_SMXP_2_0, REGION25_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR25_U_SMXP_2_0, REGION25_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR26_U_SMXP_2_0, 0x103d9b0)
    FIELD(POR_MPU_M2_PRBAR26_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR26_U_SMXP_2_0, REGION26_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR26_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR26_U_SMXP_2_0, REGION26_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR26_U_SMXP_2_0, REGION26_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR26_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR26_U_SMXP_2_0, 0x103d9b8)
    FIELD(POR_MPU_M2_PRLAR26_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR26_U_SMXP_2_0, REGION26_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR26_U_SMXP_2_0, REGION26_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR27_U_SMXP_2_0, 0x103d9c0)
    FIELD(POR_MPU_M2_PRBAR27_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR27_U_SMXP_2_0, REGION27_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR27_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR27_U_SMXP_2_0, REGION27_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR27_U_SMXP_2_0, REGION27_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR27_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR27_U_SMXP_2_0, 0x103d9c8)
    FIELD(POR_MPU_M2_PRLAR27_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR27_U_SMXP_2_0, REGION27_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR27_U_SMXP_2_0, REGION27_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR28_U_SMXP_2_0, 0x103d9d0)
    FIELD(POR_MPU_M2_PRBAR28_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR28_U_SMXP_2_0, REGION28_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR28_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR28_U_SMXP_2_0, REGION28_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR28_U_SMXP_2_0, REGION28_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR28_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR28_U_SMXP_2_0, 0x103d9d8)
    FIELD(POR_MPU_M2_PRLAR28_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR28_U_SMXP_2_0, REGION28_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR28_U_SMXP_2_0, REGION28_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR29_U_SMXP_2_0, 0x103d9e0)
    FIELD(POR_MPU_M2_PRBAR29_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR29_U_SMXP_2_0, REGION29_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR29_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR29_U_SMXP_2_0, REGION29_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR29_U_SMXP_2_0, REGION29_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR29_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR29_U_SMXP_2_0, 0x103d9e8)
    FIELD(POR_MPU_M2_PRLAR29_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR29_U_SMXP_2_0, REGION29_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR29_U_SMXP_2_0, REGION29_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR30_U_SMXP_2_0, 0x103d9f0)
    FIELD(POR_MPU_M2_PRBAR30_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR30_U_SMXP_2_0, REGION30_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR30_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR30_U_SMXP_2_0, REGION30_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR30_U_SMXP_2_0, REGION30_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR30_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR30_U_SMXP_2_0, 0x103d9f8)
    FIELD(POR_MPU_M2_PRLAR30_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR30_U_SMXP_2_0, REGION30_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR30_U_SMXP_2_0, REGION30_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR31_U_SMXP_2_0, 0x103da00)
    FIELD(POR_MPU_M2_PRBAR31_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR31_U_SMXP_2_0, REGION31_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR31_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR31_U_SMXP_2_0, REGION31_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR31_U_SMXP_2_0, REGION31_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR31_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR31_U_SMXP_2_0, 0x103da08)
    FIELD(POR_MPU_M2_PRLAR31_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR31_U_SMXP_2_0, REGION31_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR31_U_SMXP_2_0, REGION31_EN, 0, 1)
REG32(POR_MPU_M3_CTL_U_SMXP_2_0, 0x103dc00)
    FIELD(POR_MPU_M3_CTL_U_SMXP_2_0, M3_EN, 2, 1)
    FIELD(POR_MPU_M3_CTL_U_SMXP_2_0, M3_ACTION, 0, 2)
REG32(POR_MPU_M3_PRBAR0_U_SMXP_2_0, 0x103dc10)
    FIELD(POR_MPU_M3_PRBAR0_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR0_U_SMXP_2_0, REGION0_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR0_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR0_U_SMXP_2_0, REGION0_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR0_U_SMXP_2_0, REGION0_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR0_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR0_U_SMXP_2_0, 0x103dc18)
    FIELD(POR_MPU_M3_PRLAR0_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR0_U_SMXP_2_0, REGION0_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR0_U_SMXP_2_0, REGION0_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR1_U_SMXP_2_0, 0x103dc20)
    FIELD(POR_MPU_M3_PRBAR1_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR1_U_SMXP_2_0, REGION1_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR1_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR1_U_SMXP_2_0, REGION1_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR1_U_SMXP_2_0, REGION1_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR1_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR1_U_SMXP_2_0, 0x103dc28)
    FIELD(POR_MPU_M3_PRLAR1_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR1_U_SMXP_2_0, REGION1_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR1_U_SMXP_2_0, REGION1_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR2_U_SMXP_2_0, 0x103dc30)
    FIELD(POR_MPU_M3_PRBAR2_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR2_U_SMXP_2_0, REGION2_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR2_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR2_U_SMXP_2_0, REGION2_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR2_U_SMXP_2_0, REGION2_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR2_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR2_U_SMXP_2_0, 0x103dc38)
    FIELD(POR_MPU_M3_PRLAR2_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR2_U_SMXP_2_0, REGION2_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR2_U_SMXP_2_0, REGION2_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR3_U_SMXP_2_0, 0x103dc40)
    FIELD(POR_MPU_M3_PRBAR3_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR3_U_SMXP_2_0, REGION3_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR3_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR3_U_SMXP_2_0, REGION3_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR3_U_SMXP_2_0, REGION3_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR3_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR3_U_SMXP_2_0, 0x103dc48)
    FIELD(POR_MPU_M3_PRLAR3_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR3_U_SMXP_2_0, REGION3_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR3_U_SMXP_2_0, REGION3_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR4_U_SMXP_2_0, 0x103dc50)
    FIELD(POR_MPU_M3_PRBAR4_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR4_U_SMXP_2_0, REGION4_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR4_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR4_U_SMXP_2_0, REGION4_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR4_U_SMXP_2_0, REGION4_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR4_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR4_U_SMXP_2_0, 0x103dc58)
    FIELD(POR_MPU_M3_PRLAR4_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR4_U_SMXP_2_0, REGION4_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR4_U_SMXP_2_0, REGION4_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR5_U_SMXP_2_0, 0x103dc60)
    FIELD(POR_MPU_M3_PRBAR5_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR5_U_SMXP_2_0, REGION5_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR5_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR5_U_SMXP_2_0, REGION5_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR5_U_SMXP_2_0, REGION5_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR5_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR5_U_SMXP_2_0, 0x103dc68)
    FIELD(POR_MPU_M3_PRLAR5_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR5_U_SMXP_2_0, REGION5_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR5_U_SMXP_2_0, REGION5_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR6_U_SMXP_2_0, 0x103dc70)
    FIELD(POR_MPU_M3_PRBAR6_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR6_U_SMXP_2_0, REGION6_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR6_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR6_U_SMXP_2_0, REGION6_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR6_U_SMXP_2_0, REGION6_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR6_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR6_U_SMXP_2_0, 0x103dc78)
    FIELD(POR_MPU_M3_PRLAR6_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR6_U_SMXP_2_0, REGION6_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR6_U_SMXP_2_0, REGION6_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR7_U_SMXP_2_0, 0x103dc80)
    FIELD(POR_MPU_M3_PRBAR7_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR7_U_SMXP_2_0, REGION7_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR7_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR7_U_SMXP_2_0, REGION7_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR7_U_SMXP_2_0, REGION7_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR7_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR7_U_SMXP_2_0, 0x103dc88)
    FIELD(POR_MPU_M3_PRLAR7_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR7_U_SMXP_2_0, REGION7_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR7_U_SMXP_2_0, REGION7_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR8_U_SMXP_2_0, 0x103dc90)
    FIELD(POR_MPU_M3_PRBAR8_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR8_U_SMXP_2_0, REGION8_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR8_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR8_U_SMXP_2_0, REGION8_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR8_U_SMXP_2_0, REGION8_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR8_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR8_U_SMXP_2_0, 0x103dc98)
    FIELD(POR_MPU_M3_PRLAR8_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR8_U_SMXP_2_0, REGION8_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR8_U_SMXP_2_0, REGION8_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR9_U_SMXP_2_0, 0x103dca0)
    FIELD(POR_MPU_M3_PRBAR9_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR9_U_SMXP_2_0, REGION9_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR9_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR9_U_SMXP_2_0, REGION9_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR9_U_SMXP_2_0, REGION9_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR9_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR9_U_SMXP_2_0, 0x103dca8)
    FIELD(POR_MPU_M3_PRLAR9_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR9_U_SMXP_2_0, REGION9_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR9_U_SMXP_2_0, REGION9_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR10_U_SMXP_2_0, 0x103dcb0)
    FIELD(POR_MPU_M3_PRBAR10_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR10_U_SMXP_2_0, REGION10_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR10_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR10_U_SMXP_2_0, REGION10_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR10_U_SMXP_2_0, REGION10_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR10_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR10_U_SMXP_2_0, 0x103dcb8)
    FIELD(POR_MPU_M3_PRLAR10_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR10_U_SMXP_2_0, REGION10_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR10_U_SMXP_2_0, REGION10_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR11_U_SMXP_2_0, 0x103dcc0)
    FIELD(POR_MPU_M3_PRBAR11_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR11_U_SMXP_2_0, REGION11_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR11_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR11_U_SMXP_2_0, REGION11_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR11_U_SMXP_2_0, REGION11_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR11_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR11_U_SMXP_2_0, 0x103dcc8)
    FIELD(POR_MPU_M3_PRLAR11_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR11_U_SMXP_2_0, REGION11_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR11_U_SMXP_2_0, REGION11_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR12_U_SMXP_2_0, 0x103dcd0)
    FIELD(POR_MPU_M3_PRBAR12_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR12_U_SMXP_2_0, REGION12_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR12_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR12_U_SMXP_2_0, REGION12_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR12_U_SMXP_2_0, REGION12_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR12_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR12_U_SMXP_2_0, 0x103dcd8)
    FIELD(POR_MPU_M3_PRLAR12_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR12_U_SMXP_2_0, REGION12_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR12_U_SMXP_2_0, REGION12_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR13_U_SMXP_2_0, 0x103dce0)
    FIELD(POR_MPU_M3_PRBAR13_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR13_U_SMXP_2_0, REGION13_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR13_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR13_U_SMXP_2_0, REGION13_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR13_U_SMXP_2_0, REGION13_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR13_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR13_U_SMXP_2_0, 0x103dce8)
    FIELD(POR_MPU_M3_PRLAR13_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR13_U_SMXP_2_0, REGION13_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR13_U_SMXP_2_0, REGION13_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR14_U_SMXP_2_0, 0x103dcf0)
    FIELD(POR_MPU_M3_PRBAR14_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR14_U_SMXP_2_0, REGION14_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR14_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR14_U_SMXP_2_0, REGION14_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR14_U_SMXP_2_0, REGION14_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR14_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR14_U_SMXP_2_0, 0x103dcf8)
    FIELD(POR_MPU_M3_PRLAR14_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR14_U_SMXP_2_0, REGION14_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR14_U_SMXP_2_0, REGION14_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR15_U_SMXP_2_0, 0x103dd00)
    FIELD(POR_MPU_M3_PRBAR15_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR15_U_SMXP_2_0, REGION15_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR15_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR15_U_SMXP_2_0, REGION15_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR15_U_SMXP_2_0, REGION15_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR15_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR15_U_SMXP_2_0, 0x103dd08)
    FIELD(POR_MPU_M3_PRLAR15_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR15_U_SMXP_2_0, REGION15_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR15_U_SMXP_2_0, REGION15_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR16_U_SMXP_2_0, 0x103dd10)
    FIELD(POR_MPU_M3_PRBAR16_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR16_U_SMXP_2_0, REGION16_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR16_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR16_U_SMXP_2_0, REGION16_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR16_U_SMXP_2_0, REGION16_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR16_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR16_U_SMXP_2_0, 0x103dd18)
    FIELD(POR_MPU_M3_PRLAR16_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR16_U_SMXP_2_0, REGION16_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR16_U_SMXP_2_0, REGION16_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR17_U_SMXP_2_0, 0x103dd20)
    FIELD(POR_MPU_M3_PRBAR17_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR17_U_SMXP_2_0, REGION17_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR17_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR17_U_SMXP_2_0, REGION17_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR17_U_SMXP_2_0, REGION17_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR17_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR17_U_SMXP_2_0, 0x103dd28)
    FIELD(POR_MPU_M3_PRLAR17_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR17_U_SMXP_2_0, REGION17_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR17_U_SMXP_2_0, REGION17_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR18_U_SMXP_2_0, 0x103dd30)
    FIELD(POR_MPU_M3_PRBAR18_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR18_U_SMXP_2_0, REGION18_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR18_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR18_U_SMXP_2_0, REGION18_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR18_U_SMXP_2_0, REGION18_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR18_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR18_U_SMXP_2_0, 0x103dd38)
    FIELD(POR_MPU_M3_PRLAR18_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR18_U_SMXP_2_0, REGION18_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR18_U_SMXP_2_0, REGION18_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR19_U_SMXP_2_0, 0x103dd40)
    FIELD(POR_MPU_M3_PRBAR19_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR19_U_SMXP_2_0, REGION19_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR19_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR19_U_SMXP_2_0, REGION19_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR19_U_SMXP_2_0, REGION19_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR19_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR19_U_SMXP_2_0, 0x103dd48)
    FIELD(POR_MPU_M3_PRLAR19_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR19_U_SMXP_2_0, REGION19_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR19_U_SMXP_2_0, REGION19_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR20_U_SMXP_2_0, 0x103dd50)
    FIELD(POR_MPU_M3_PRBAR20_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR20_U_SMXP_2_0, REGION20_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR20_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR20_U_SMXP_2_0, REGION20_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR20_U_SMXP_2_0, REGION20_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR20_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR20_U_SMXP_2_0, 0x103dd58)
    FIELD(POR_MPU_M3_PRLAR20_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR20_U_SMXP_2_0, REGION20_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR20_U_SMXP_2_0, REGION20_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR21_U_SMXP_2_0, 0x103dd60)
    FIELD(POR_MPU_M3_PRBAR21_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR21_U_SMXP_2_0, REGION21_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR21_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR21_U_SMXP_2_0, REGION21_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR21_U_SMXP_2_0, REGION21_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR21_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR21_U_SMXP_2_0, 0x103dd68)
    FIELD(POR_MPU_M3_PRLAR21_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR21_U_SMXP_2_0, REGION21_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR21_U_SMXP_2_0, REGION21_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR22_U_SMXP_2_0, 0x103dd70)
    FIELD(POR_MPU_M3_PRBAR22_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR22_U_SMXP_2_0, REGION22_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR22_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR22_U_SMXP_2_0, REGION22_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR22_U_SMXP_2_0, REGION22_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR22_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR22_U_SMXP_2_0, 0x103dd78)
    FIELD(POR_MPU_M3_PRLAR22_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR22_U_SMXP_2_0, REGION22_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR22_U_SMXP_2_0, REGION22_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR23_U_SMXP_2_0, 0x103dd80)
    FIELD(POR_MPU_M3_PRBAR23_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR23_U_SMXP_2_0, REGION23_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR23_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR23_U_SMXP_2_0, REGION23_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR23_U_SMXP_2_0, REGION23_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR23_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR23_U_SMXP_2_0, 0x103dd88)
    FIELD(POR_MPU_M3_PRLAR23_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR23_U_SMXP_2_0, REGION23_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR23_U_SMXP_2_0, REGION23_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR24_U_SMXP_2_0, 0x103dd90)
    FIELD(POR_MPU_M3_PRBAR24_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR24_U_SMXP_2_0, REGION24_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR24_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR24_U_SMXP_2_0, REGION24_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR24_U_SMXP_2_0, REGION24_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR24_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR24_U_SMXP_2_0, 0x103dd98)
    FIELD(POR_MPU_M3_PRLAR24_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR24_U_SMXP_2_0, REGION24_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR24_U_SMXP_2_0, REGION24_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR25_U_SMXP_2_0, 0x103dda0)
    FIELD(POR_MPU_M3_PRBAR25_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR25_U_SMXP_2_0, REGION25_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR25_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR25_U_SMXP_2_0, REGION25_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR25_U_SMXP_2_0, REGION25_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR25_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR25_U_SMXP_2_0, 0x103dda8)
    FIELD(POR_MPU_M3_PRLAR25_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR25_U_SMXP_2_0, REGION25_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR25_U_SMXP_2_0, REGION25_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR26_U_SMXP_2_0, 0x103ddb0)
    FIELD(POR_MPU_M3_PRBAR26_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR26_U_SMXP_2_0, REGION26_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR26_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR26_U_SMXP_2_0, REGION26_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR26_U_SMXP_2_0, REGION26_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR26_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR26_U_SMXP_2_0, 0x103ddb8)
    FIELD(POR_MPU_M3_PRLAR26_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR26_U_SMXP_2_0, REGION26_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR26_U_SMXP_2_0, REGION26_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR27_U_SMXP_2_0, 0x103ddc0)
    FIELD(POR_MPU_M3_PRBAR27_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR27_U_SMXP_2_0, REGION27_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR27_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR27_U_SMXP_2_0, REGION27_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR27_U_SMXP_2_0, REGION27_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR27_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR27_U_SMXP_2_0, 0x103ddc8)
    FIELD(POR_MPU_M3_PRLAR27_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR27_U_SMXP_2_0, REGION27_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR27_U_SMXP_2_0, REGION27_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR28_U_SMXP_2_0, 0x103ddd0)
    FIELD(POR_MPU_M3_PRBAR28_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR28_U_SMXP_2_0, REGION28_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR28_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR28_U_SMXP_2_0, REGION28_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR28_U_SMXP_2_0, REGION28_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR28_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR28_U_SMXP_2_0, 0x103ddd8)
    FIELD(POR_MPU_M3_PRLAR28_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR28_U_SMXP_2_0, REGION28_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR28_U_SMXP_2_0, REGION28_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR29_U_SMXP_2_0, 0x103dde0)
    FIELD(POR_MPU_M3_PRBAR29_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR29_U_SMXP_2_0, REGION29_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR29_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR29_U_SMXP_2_0, REGION29_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR29_U_SMXP_2_0, REGION29_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR29_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR29_U_SMXP_2_0, 0x103dde8)
    FIELD(POR_MPU_M3_PRLAR29_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR29_U_SMXP_2_0, REGION29_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR29_U_SMXP_2_0, REGION29_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR30_U_SMXP_2_0, 0x103ddf0)
    FIELD(POR_MPU_M3_PRBAR30_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR30_U_SMXP_2_0, REGION30_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR30_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR30_U_SMXP_2_0, REGION30_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR30_U_SMXP_2_0, REGION30_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR30_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR30_U_SMXP_2_0, 0x103ddf8)
    FIELD(POR_MPU_M3_PRLAR30_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR30_U_SMXP_2_0, REGION30_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR30_U_SMXP_2_0, REGION30_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR31_U_SMXP_2_0, 0x103de00)
    FIELD(POR_MPU_M3_PRBAR31_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR31_U_SMXP_2_0, REGION31_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR31_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR31_U_SMXP_2_0, REGION31_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR31_U_SMXP_2_0, REGION31_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR31_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR31_U_SMXP_2_0, 0x103de08)
    FIELD(POR_MPU_M3_PRLAR31_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR31_U_SMXP_2_0, REGION31_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR31_U_SMXP_2_0, REGION31_EN, 0, 1)
REG32(POR_MPU_M4_CTL_U_SMXP_2_0, 0x103e000)
    FIELD(POR_MPU_M4_CTL_U_SMXP_2_0, M4_EN, 2, 1)
    FIELD(POR_MPU_M4_CTL_U_SMXP_2_0, M4_ACTION, 0, 2)
REG32(POR_MPU_M4_PRBAR0_U_SMXP_2_0, 0x103e010)
    FIELD(POR_MPU_M4_PRBAR0_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR0_U_SMXP_2_0, REGION0_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR0_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR0_U_SMXP_2_0, REGION0_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR0_U_SMXP_2_0, REGION0_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR0_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR0_U_SMXP_2_0, 0x103e018)
    FIELD(POR_MPU_M4_PRLAR0_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR0_U_SMXP_2_0, REGION0_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR0_U_SMXP_2_0, REGION0_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR1_U_SMXP_2_0, 0x103e020)
    FIELD(POR_MPU_M4_PRBAR1_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR1_U_SMXP_2_0, REGION1_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR1_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR1_U_SMXP_2_0, REGION1_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR1_U_SMXP_2_0, REGION1_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR1_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR1_U_SMXP_2_0, 0x103e028)
    FIELD(POR_MPU_M4_PRLAR1_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR1_U_SMXP_2_0, REGION1_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR1_U_SMXP_2_0, REGION1_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR2_U_SMXP_2_0, 0x103e030)
    FIELD(POR_MPU_M4_PRBAR2_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR2_U_SMXP_2_0, REGION2_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR2_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR2_U_SMXP_2_0, REGION2_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR2_U_SMXP_2_0, REGION2_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR2_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR2_U_SMXP_2_0, 0x103e038)
    FIELD(POR_MPU_M4_PRLAR2_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR2_U_SMXP_2_0, REGION2_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR2_U_SMXP_2_0, REGION2_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR3_U_SMXP_2_0, 0x103e040)
    FIELD(POR_MPU_M4_PRBAR3_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR3_U_SMXP_2_0, REGION3_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR3_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR3_U_SMXP_2_0, REGION3_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR3_U_SMXP_2_0, REGION3_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR3_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR3_U_SMXP_2_0, 0x103e048)
    FIELD(POR_MPU_M4_PRLAR3_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR3_U_SMXP_2_0, REGION3_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR3_U_SMXP_2_0, REGION3_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR4_U_SMXP_2_0, 0x103e050)
    FIELD(POR_MPU_M4_PRBAR4_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR4_U_SMXP_2_0, REGION4_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR4_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR4_U_SMXP_2_0, REGION4_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR4_U_SMXP_2_0, REGION4_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR4_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR4_U_SMXP_2_0, 0x103e058)
    FIELD(POR_MPU_M4_PRLAR4_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR4_U_SMXP_2_0, REGION4_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR4_U_SMXP_2_0, REGION4_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR5_U_SMXP_2_0, 0x103e060)
    FIELD(POR_MPU_M4_PRBAR5_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR5_U_SMXP_2_0, REGION5_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR5_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR5_U_SMXP_2_0, REGION5_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR5_U_SMXP_2_0, REGION5_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR5_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR5_U_SMXP_2_0, 0x103e068)
    FIELD(POR_MPU_M4_PRLAR5_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR5_U_SMXP_2_0, REGION5_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR5_U_SMXP_2_0, REGION5_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR6_U_SMXP_2_0, 0x103e070)
    FIELD(POR_MPU_M4_PRBAR6_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR6_U_SMXP_2_0, REGION6_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR6_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR6_U_SMXP_2_0, REGION6_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR6_U_SMXP_2_0, REGION6_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR6_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR6_U_SMXP_2_0, 0x103e078)
    FIELD(POR_MPU_M4_PRLAR6_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR6_U_SMXP_2_0, REGION6_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR6_U_SMXP_2_0, REGION6_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR7_U_SMXP_2_0, 0x103e080)
    FIELD(POR_MPU_M4_PRBAR7_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR7_U_SMXP_2_0, REGION7_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR7_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR7_U_SMXP_2_0, REGION7_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR7_U_SMXP_2_0, REGION7_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR7_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR7_U_SMXP_2_0, 0x103e088)
    FIELD(POR_MPU_M4_PRLAR7_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR7_U_SMXP_2_0, REGION7_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR7_U_SMXP_2_0, REGION7_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR8_U_SMXP_2_0, 0x103e090)
    FIELD(POR_MPU_M4_PRBAR8_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR8_U_SMXP_2_0, REGION8_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR8_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR8_U_SMXP_2_0, REGION8_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR8_U_SMXP_2_0, REGION8_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR8_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR8_U_SMXP_2_0, 0x103e098)
    FIELD(POR_MPU_M4_PRLAR8_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR8_U_SMXP_2_0, REGION8_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR8_U_SMXP_2_0, REGION8_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR9_U_SMXP_2_0, 0x103e0a0)
    FIELD(POR_MPU_M4_PRBAR9_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR9_U_SMXP_2_0, REGION9_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR9_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR9_U_SMXP_2_0, REGION9_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR9_U_SMXP_2_0, REGION9_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR9_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR9_U_SMXP_2_0, 0x103e0a8)
    FIELD(POR_MPU_M4_PRLAR9_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR9_U_SMXP_2_0, REGION9_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR9_U_SMXP_2_0, REGION9_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR10_U_SMXP_2_0, 0x103e0b0)
    FIELD(POR_MPU_M4_PRBAR10_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR10_U_SMXP_2_0, REGION10_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR10_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR10_U_SMXP_2_0, REGION10_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR10_U_SMXP_2_0, REGION10_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR10_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR10_U_SMXP_2_0, 0x103e0b8)
    FIELD(POR_MPU_M4_PRLAR10_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR10_U_SMXP_2_0, REGION10_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR10_U_SMXP_2_0, REGION10_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR11_U_SMXP_2_0, 0x103e0c0)
    FIELD(POR_MPU_M4_PRBAR11_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR11_U_SMXP_2_0, REGION11_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR11_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR11_U_SMXP_2_0, REGION11_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR11_U_SMXP_2_0, REGION11_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR11_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR11_U_SMXP_2_0, 0x103e0c8)
    FIELD(POR_MPU_M4_PRLAR11_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR11_U_SMXP_2_0, REGION11_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR11_U_SMXP_2_0, REGION11_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR12_U_SMXP_2_0, 0x103e0d0)
    FIELD(POR_MPU_M4_PRBAR12_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR12_U_SMXP_2_0, REGION12_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR12_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR12_U_SMXP_2_0, REGION12_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR12_U_SMXP_2_0, REGION12_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR12_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR12_U_SMXP_2_0, 0x103e0d8)
    FIELD(POR_MPU_M4_PRLAR12_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR12_U_SMXP_2_0, REGION12_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR12_U_SMXP_2_0, REGION12_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR13_U_SMXP_2_0, 0x103e0e0)
    FIELD(POR_MPU_M4_PRBAR13_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR13_U_SMXP_2_0, REGION13_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR13_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR13_U_SMXP_2_0, REGION13_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR13_U_SMXP_2_0, REGION13_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR13_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR13_U_SMXP_2_0, 0x103e0e8)
    FIELD(POR_MPU_M4_PRLAR13_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR13_U_SMXP_2_0, REGION13_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR13_U_SMXP_2_0, REGION13_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR14_U_SMXP_2_0, 0x103e0f0)
    FIELD(POR_MPU_M4_PRBAR14_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR14_U_SMXP_2_0, REGION14_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR14_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR14_U_SMXP_2_0, REGION14_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR14_U_SMXP_2_0, REGION14_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR14_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR14_U_SMXP_2_0, 0x103e0f8)
    FIELD(POR_MPU_M4_PRLAR14_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR14_U_SMXP_2_0, REGION14_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR14_U_SMXP_2_0, REGION14_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR15_U_SMXP_2_0, 0x103e100)
    FIELD(POR_MPU_M4_PRBAR15_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR15_U_SMXP_2_0, REGION15_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR15_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR15_U_SMXP_2_0, REGION15_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR15_U_SMXP_2_0, REGION15_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR15_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR15_U_SMXP_2_0, 0x103e108)
    FIELD(POR_MPU_M4_PRLAR15_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR15_U_SMXP_2_0, REGION15_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR15_U_SMXP_2_0, REGION15_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR16_U_SMXP_2_0, 0x103e110)
    FIELD(POR_MPU_M4_PRBAR16_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR16_U_SMXP_2_0, REGION16_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR16_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR16_U_SMXP_2_0, REGION16_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR16_U_SMXP_2_0, REGION16_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR16_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR16_U_SMXP_2_0, 0x103e118)
    FIELD(POR_MPU_M4_PRLAR16_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR16_U_SMXP_2_0, REGION16_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR16_U_SMXP_2_0, REGION16_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR17_U_SMXP_2_0, 0x103e120)
    FIELD(POR_MPU_M4_PRBAR17_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR17_U_SMXP_2_0, REGION17_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR17_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR17_U_SMXP_2_0, REGION17_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR17_U_SMXP_2_0, REGION17_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR17_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR17_U_SMXP_2_0, 0x103e128)
    FIELD(POR_MPU_M4_PRLAR17_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR17_U_SMXP_2_0, REGION17_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR17_U_SMXP_2_0, REGION17_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR18_U_SMXP_2_0, 0x103e130)
    FIELD(POR_MPU_M4_PRBAR18_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR18_U_SMXP_2_0, REGION18_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR18_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR18_U_SMXP_2_0, REGION18_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR18_U_SMXP_2_0, REGION18_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR18_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR18_U_SMXP_2_0, 0x103e138)
    FIELD(POR_MPU_M4_PRLAR18_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR18_U_SMXP_2_0, REGION18_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR18_U_SMXP_2_0, REGION18_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR19_U_SMXP_2_0, 0x103e140)
    FIELD(POR_MPU_M4_PRBAR19_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR19_U_SMXP_2_0, REGION19_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR19_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR19_U_SMXP_2_0, REGION19_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR19_U_SMXP_2_0, REGION19_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR19_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR19_U_SMXP_2_0, 0x103e148)
    FIELD(POR_MPU_M4_PRLAR19_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR19_U_SMXP_2_0, REGION19_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR19_U_SMXP_2_0, REGION19_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR20_U_SMXP_2_0, 0x103e150)
    FIELD(POR_MPU_M4_PRBAR20_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR20_U_SMXP_2_0, REGION20_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR20_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR20_U_SMXP_2_0, REGION20_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR20_U_SMXP_2_0, REGION20_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR20_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR20_U_SMXP_2_0, 0x103e158)
    FIELD(POR_MPU_M4_PRLAR20_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR20_U_SMXP_2_0, REGION20_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR20_U_SMXP_2_0, REGION20_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR21_U_SMXP_2_0, 0x103e160)
    FIELD(POR_MPU_M4_PRBAR21_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR21_U_SMXP_2_0, REGION21_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR21_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR21_U_SMXP_2_0, REGION21_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR21_U_SMXP_2_0, REGION21_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR21_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR21_U_SMXP_2_0, 0x103e168)
    FIELD(POR_MPU_M4_PRLAR21_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR21_U_SMXP_2_0, REGION21_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR21_U_SMXP_2_0, REGION21_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR22_U_SMXP_2_0, 0x103e170)
    FIELD(POR_MPU_M4_PRBAR22_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR22_U_SMXP_2_0, REGION22_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR22_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR22_U_SMXP_2_0, REGION22_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR22_U_SMXP_2_0, REGION22_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR22_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR22_U_SMXP_2_0, 0x103e178)
    FIELD(POR_MPU_M4_PRLAR22_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR22_U_SMXP_2_0, REGION22_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR22_U_SMXP_2_0, REGION22_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR23_U_SMXP_2_0, 0x103e180)
    FIELD(POR_MPU_M4_PRBAR23_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR23_U_SMXP_2_0, REGION23_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR23_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR23_U_SMXP_2_0, REGION23_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR23_U_SMXP_2_0, REGION23_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR23_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR23_U_SMXP_2_0, 0x103e188)
    FIELD(POR_MPU_M4_PRLAR23_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR23_U_SMXP_2_0, REGION23_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR23_U_SMXP_2_0, REGION23_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR24_U_SMXP_2_0, 0x103e190)
    FIELD(POR_MPU_M4_PRBAR24_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR24_U_SMXP_2_0, REGION24_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR24_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR24_U_SMXP_2_0, REGION24_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR24_U_SMXP_2_0, REGION24_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR24_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR24_U_SMXP_2_0, 0x103e198)
    FIELD(POR_MPU_M4_PRLAR24_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR24_U_SMXP_2_0, REGION24_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR24_U_SMXP_2_0, REGION24_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR25_U_SMXP_2_0, 0x103e1a0)
    FIELD(POR_MPU_M4_PRBAR25_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR25_U_SMXP_2_0, REGION25_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR25_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR25_U_SMXP_2_0, REGION25_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR25_U_SMXP_2_0, REGION25_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR25_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR25_U_SMXP_2_0, 0x103e1a8)
    FIELD(POR_MPU_M4_PRLAR25_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR25_U_SMXP_2_0, REGION25_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR25_U_SMXP_2_0, REGION25_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR26_U_SMXP_2_0, 0x103e1b0)
    FIELD(POR_MPU_M4_PRBAR26_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR26_U_SMXP_2_0, REGION26_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR26_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR26_U_SMXP_2_0, REGION26_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR26_U_SMXP_2_0, REGION26_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR26_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR26_U_SMXP_2_0, 0x103e1b8)
    FIELD(POR_MPU_M4_PRLAR26_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR26_U_SMXP_2_0, REGION26_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR26_U_SMXP_2_0, REGION26_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR27_U_SMXP_2_0, 0x103e1c0)
    FIELD(POR_MPU_M4_PRBAR27_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR27_U_SMXP_2_0, REGION27_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR27_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR27_U_SMXP_2_0, REGION27_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR27_U_SMXP_2_0, REGION27_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR27_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR27_U_SMXP_2_0, 0x103e1c8)
    FIELD(POR_MPU_M4_PRLAR27_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR27_U_SMXP_2_0, REGION27_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR27_U_SMXP_2_0, REGION27_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR28_U_SMXP_2_0, 0x103e1d0)
    FIELD(POR_MPU_M4_PRBAR28_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR28_U_SMXP_2_0, REGION28_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR28_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR28_U_SMXP_2_0, REGION28_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR28_U_SMXP_2_0, REGION28_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR28_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR28_U_SMXP_2_0, 0x103e1d8)
    FIELD(POR_MPU_M4_PRLAR28_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR28_U_SMXP_2_0, REGION28_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR28_U_SMXP_2_0, REGION28_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR29_U_SMXP_2_0, 0x103e1e0)
    FIELD(POR_MPU_M4_PRBAR29_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR29_U_SMXP_2_0, REGION29_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR29_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR29_U_SMXP_2_0, REGION29_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR29_U_SMXP_2_0, REGION29_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR29_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR29_U_SMXP_2_0, 0x103e1e8)
    FIELD(POR_MPU_M4_PRLAR29_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR29_U_SMXP_2_0, REGION29_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR29_U_SMXP_2_0, REGION29_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR30_U_SMXP_2_0, 0x103e1f0)
    FIELD(POR_MPU_M4_PRBAR30_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR30_U_SMXP_2_0, REGION30_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR30_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR30_U_SMXP_2_0, REGION30_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR30_U_SMXP_2_0, REGION30_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR30_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR30_U_SMXP_2_0, 0x103e1f8)
    FIELD(POR_MPU_M4_PRLAR30_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR30_U_SMXP_2_0, REGION30_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR30_U_SMXP_2_0, REGION30_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR31_U_SMXP_2_0, 0x103e200)
    FIELD(POR_MPU_M4_PRBAR31_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR31_U_SMXP_2_0, REGION31_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR31_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR31_U_SMXP_2_0, REGION31_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR31_U_SMXP_2_0, REGION31_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR31_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR31_U_SMXP_2_0, 0x103e208)
    FIELD(POR_MPU_M4_PRLAR31_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR31_U_SMXP_2_0, REGION31_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR31_U_SMXP_2_0, REGION31_EN, 0, 1)
REG32(POR_MPU_M5_CTL_U_SMXP_2_0, 0x103e400)
    FIELD(POR_MPU_M5_CTL_U_SMXP_2_0, M5_EN, 2, 1)
    FIELD(POR_MPU_M5_CTL_U_SMXP_2_0, M5_ACTION, 0, 2)
REG32(POR_MPU_M5_PRBAR0_U_SMXP_2_0, 0x103e410)
    FIELD(POR_MPU_M5_PRBAR0_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR0_U_SMXP_2_0, REGION0_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR0_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR0_U_SMXP_2_0, REGION0_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR0_U_SMXP_2_0, REGION0_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR0_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR0_U_SMXP_2_0, 0x103e418)
    FIELD(POR_MPU_M5_PRLAR0_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR0_U_SMXP_2_0, REGION0_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR0_U_SMXP_2_0, REGION0_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR1_U_SMXP_2_0, 0x103e420)
    FIELD(POR_MPU_M5_PRBAR1_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR1_U_SMXP_2_0, REGION1_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR1_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR1_U_SMXP_2_0, REGION1_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR1_U_SMXP_2_0, REGION1_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR1_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR1_U_SMXP_2_0, 0x103e428)
    FIELD(POR_MPU_M5_PRLAR1_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR1_U_SMXP_2_0, REGION1_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR1_U_SMXP_2_0, REGION1_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR2_U_SMXP_2_0, 0x103e430)
    FIELD(POR_MPU_M5_PRBAR2_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR2_U_SMXP_2_0, REGION2_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR2_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR2_U_SMXP_2_0, REGION2_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR2_U_SMXP_2_0, REGION2_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR2_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR2_U_SMXP_2_0, 0x103e438)
    FIELD(POR_MPU_M5_PRLAR2_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR2_U_SMXP_2_0, REGION2_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR2_U_SMXP_2_0, REGION2_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR3_U_SMXP_2_0, 0x103e440)
    FIELD(POR_MPU_M5_PRBAR3_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR3_U_SMXP_2_0, REGION3_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR3_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR3_U_SMXP_2_0, REGION3_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR3_U_SMXP_2_0, REGION3_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR3_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR3_U_SMXP_2_0, 0x103e448)
    FIELD(POR_MPU_M5_PRLAR3_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR3_U_SMXP_2_0, REGION3_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR3_U_SMXP_2_0, REGION3_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR4_U_SMXP_2_0, 0x103e450)
    FIELD(POR_MPU_M5_PRBAR4_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR4_U_SMXP_2_0, REGION4_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR4_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR4_U_SMXP_2_0, REGION4_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR4_U_SMXP_2_0, REGION4_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR4_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR4_U_SMXP_2_0, 0x103e458)
    FIELD(POR_MPU_M5_PRLAR4_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR4_U_SMXP_2_0, REGION4_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR4_U_SMXP_2_0, REGION4_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR5_U_SMXP_2_0, 0x103e460)
    FIELD(POR_MPU_M5_PRBAR5_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR5_U_SMXP_2_0, REGION5_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR5_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR5_U_SMXP_2_0, REGION5_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR5_U_SMXP_2_0, REGION5_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR5_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR5_U_SMXP_2_0, 0x103e468)
    FIELD(POR_MPU_M5_PRLAR5_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR5_U_SMXP_2_0, REGION5_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR5_U_SMXP_2_0, REGION5_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR6_U_SMXP_2_0, 0x103e470)
    FIELD(POR_MPU_M5_PRBAR6_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR6_U_SMXP_2_0, REGION6_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR6_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR6_U_SMXP_2_0, REGION6_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR6_U_SMXP_2_0, REGION6_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR6_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR6_U_SMXP_2_0, 0x103e478)
    FIELD(POR_MPU_M5_PRLAR6_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR6_U_SMXP_2_0, REGION6_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR6_U_SMXP_2_0, REGION6_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR7_U_SMXP_2_0, 0x103e480)
    FIELD(POR_MPU_M5_PRBAR7_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR7_U_SMXP_2_0, REGION7_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR7_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR7_U_SMXP_2_0, REGION7_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR7_U_SMXP_2_0, REGION7_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR7_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR7_U_SMXP_2_0, 0x103e488)
    FIELD(POR_MPU_M5_PRLAR7_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR7_U_SMXP_2_0, REGION7_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR7_U_SMXP_2_0, REGION7_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR8_U_SMXP_2_0, 0x103e490)
    FIELD(POR_MPU_M5_PRBAR8_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR8_U_SMXP_2_0, REGION8_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR8_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR8_U_SMXP_2_0, REGION8_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR8_U_SMXP_2_0, REGION8_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR8_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR8_U_SMXP_2_0, 0x103e498)
    FIELD(POR_MPU_M5_PRLAR8_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR8_U_SMXP_2_0, REGION8_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR8_U_SMXP_2_0, REGION8_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR9_U_SMXP_2_0, 0x103e4a0)
    FIELD(POR_MPU_M5_PRBAR9_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR9_U_SMXP_2_0, REGION9_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR9_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR9_U_SMXP_2_0, REGION9_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR9_U_SMXP_2_0, REGION9_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR9_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR9_U_SMXP_2_0, 0x103e4a8)
    FIELD(POR_MPU_M5_PRLAR9_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR9_U_SMXP_2_0, REGION9_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR9_U_SMXP_2_0, REGION9_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR10_U_SMXP_2_0, 0x103e4b0)
    FIELD(POR_MPU_M5_PRBAR10_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR10_U_SMXP_2_0, REGION10_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR10_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR10_U_SMXP_2_0, REGION10_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR10_U_SMXP_2_0, REGION10_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR10_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR10_U_SMXP_2_0, 0x103e4b8)
    FIELD(POR_MPU_M5_PRLAR10_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR10_U_SMXP_2_0, REGION10_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR10_U_SMXP_2_0, REGION10_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR11_U_SMXP_2_0, 0x103e4c0)
    FIELD(POR_MPU_M5_PRBAR11_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR11_U_SMXP_2_0, REGION11_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR11_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR11_U_SMXP_2_0, REGION11_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR11_U_SMXP_2_0, REGION11_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR11_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR11_U_SMXP_2_0, 0x103e4c8)
    FIELD(POR_MPU_M5_PRLAR11_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR11_U_SMXP_2_0, REGION11_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR11_U_SMXP_2_0, REGION11_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR12_U_SMXP_2_0, 0x103e4d0)
    FIELD(POR_MPU_M5_PRBAR12_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR12_U_SMXP_2_0, REGION12_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR12_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR12_U_SMXP_2_0, REGION12_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR12_U_SMXP_2_0, REGION12_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR12_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR12_U_SMXP_2_0, 0x103e4d8)
    FIELD(POR_MPU_M5_PRLAR12_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR12_U_SMXP_2_0, REGION12_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR12_U_SMXP_2_0, REGION12_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR13_U_SMXP_2_0, 0x103e4e0)
    FIELD(POR_MPU_M5_PRBAR13_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR13_U_SMXP_2_0, REGION13_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR13_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR13_U_SMXP_2_0, REGION13_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR13_U_SMXP_2_0, REGION13_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR13_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR13_U_SMXP_2_0, 0x103e4e8)
    FIELD(POR_MPU_M5_PRLAR13_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR13_U_SMXP_2_0, REGION13_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR13_U_SMXP_2_0, REGION13_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR14_U_SMXP_2_0, 0x103e4f0)
    FIELD(POR_MPU_M5_PRBAR14_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR14_U_SMXP_2_0, REGION14_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR14_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR14_U_SMXP_2_0, REGION14_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR14_U_SMXP_2_0, REGION14_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR14_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR14_U_SMXP_2_0, 0x103e4f8)
    FIELD(POR_MPU_M5_PRLAR14_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR14_U_SMXP_2_0, REGION14_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR14_U_SMXP_2_0, REGION14_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR15_U_SMXP_2_0, 0x103e500)
    FIELD(POR_MPU_M5_PRBAR15_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR15_U_SMXP_2_0, REGION15_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR15_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR15_U_SMXP_2_0, REGION15_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR15_U_SMXP_2_0, REGION15_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR15_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR15_U_SMXP_2_0, 0x103e508)
    FIELD(POR_MPU_M5_PRLAR15_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR15_U_SMXP_2_0, REGION15_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR15_U_SMXP_2_0, REGION15_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR16_U_SMXP_2_0, 0x103e510)
    FIELD(POR_MPU_M5_PRBAR16_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR16_U_SMXP_2_0, REGION16_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR16_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR16_U_SMXP_2_0, REGION16_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR16_U_SMXP_2_0, REGION16_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR16_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR16_U_SMXP_2_0, 0x103e518)
    FIELD(POR_MPU_M5_PRLAR16_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR16_U_SMXP_2_0, REGION16_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR16_U_SMXP_2_0, REGION16_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR17_U_SMXP_2_0, 0x103e520)
    FIELD(POR_MPU_M5_PRBAR17_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR17_U_SMXP_2_0, REGION17_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR17_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR17_U_SMXP_2_0, REGION17_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR17_U_SMXP_2_0, REGION17_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR17_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR17_U_SMXP_2_0, 0x103e528)
    FIELD(POR_MPU_M5_PRLAR17_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR17_U_SMXP_2_0, REGION17_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR17_U_SMXP_2_0, REGION17_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR18_U_SMXP_2_0, 0x103e530)
    FIELD(POR_MPU_M5_PRBAR18_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR18_U_SMXP_2_0, REGION18_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR18_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR18_U_SMXP_2_0, REGION18_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR18_U_SMXP_2_0, REGION18_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR18_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR18_U_SMXP_2_0, 0x103e538)
    FIELD(POR_MPU_M5_PRLAR18_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR18_U_SMXP_2_0, REGION18_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR18_U_SMXP_2_0, REGION18_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR19_U_SMXP_2_0, 0x103e540)
    FIELD(POR_MPU_M5_PRBAR19_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR19_U_SMXP_2_0, REGION19_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR19_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR19_U_SMXP_2_0, REGION19_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR19_U_SMXP_2_0, REGION19_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR19_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR19_U_SMXP_2_0, 0x103e548)
    FIELD(POR_MPU_M5_PRLAR19_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR19_U_SMXP_2_0, REGION19_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR19_U_SMXP_2_0, REGION19_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR20_U_SMXP_2_0, 0x103e550)
    FIELD(POR_MPU_M5_PRBAR20_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR20_U_SMXP_2_0, REGION20_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR20_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR20_U_SMXP_2_0, REGION20_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR20_U_SMXP_2_0, REGION20_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR20_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR20_U_SMXP_2_0, 0x103e558)
    FIELD(POR_MPU_M5_PRLAR20_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR20_U_SMXP_2_0, REGION20_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR20_U_SMXP_2_0, REGION20_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR21_U_SMXP_2_0, 0x103e560)
    FIELD(POR_MPU_M5_PRBAR21_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR21_U_SMXP_2_0, REGION21_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR21_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR21_U_SMXP_2_0, REGION21_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR21_U_SMXP_2_0, REGION21_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR21_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR21_U_SMXP_2_0, 0x103e568)
    FIELD(POR_MPU_M5_PRLAR21_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR21_U_SMXP_2_0, REGION21_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR21_U_SMXP_2_0, REGION21_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR22_U_SMXP_2_0, 0x103e570)
    FIELD(POR_MPU_M5_PRBAR22_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR22_U_SMXP_2_0, REGION22_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR22_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR22_U_SMXP_2_0, REGION22_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR22_U_SMXP_2_0, REGION22_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR22_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR22_U_SMXP_2_0, 0x103e578)
    FIELD(POR_MPU_M5_PRLAR22_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR22_U_SMXP_2_0, REGION22_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR22_U_SMXP_2_0, REGION22_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR23_U_SMXP_2_0, 0x103e580)
    FIELD(POR_MPU_M5_PRBAR23_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR23_U_SMXP_2_0, REGION23_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR23_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR23_U_SMXP_2_0, REGION23_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR23_U_SMXP_2_0, REGION23_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR23_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR23_U_SMXP_2_0, 0x103e588)
    FIELD(POR_MPU_M5_PRLAR23_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR23_U_SMXP_2_0, REGION23_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR23_U_SMXP_2_0, REGION23_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR24_U_SMXP_2_0, 0x103e590)
    FIELD(POR_MPU_M5_PRBAR24_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR24_U_SMXP_2_0, REGION24_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR24_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR24_U_SMXP_2_0, REGION24_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR24_U_SMXP_2_0, REGION24_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR24_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR24_U_SMXP_2_0, 0x103e598)
    FIELD(POR_MPU_M5_PRLAR24_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR24_U_SMXP_2_0, REGION24_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR24_U_SMXP_2_0, REGION24_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR25_U_SMXP_2_0, 0x103e5a0)
    FIELD(POR_MPU_M5_PRBAR25_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR25_U_SMXP_2_0, REGION25_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR25_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR25_U_SMXP_2_0, REGION25_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR25_U_SMXP_2_0, REGION25_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR25_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR25_U_SMXP_2_0, 0x103e5a8)
    FIELD(POR_MPU_M5_PRLAR25_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR25_U_SMXP_2_0, REGION25_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR25_U_SMXP_2_0, REGION25_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR26_U_SMXP_2_0, 0x103e5b0)
    FIELD(POR_MPU_M5_PRBAR26_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR26_U_SMXP_2_0, REGION26_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR26_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR26_U_SMXP_2_0, REGION26_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR26_U_SMXP_2_0, REGION26_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR26_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR26_U_SMXP_2_0, 0x103e5b8)
    FIELD(POR_MPU_M5_PRLAR26_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR26_U_SMXP_2_0, REGION26_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR26_U_SMXP_2_0, REGION26_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR27_U_SMXP_2_0, 0x103e5c0)
    FIELD(POR_MPU_M5_PRBAR27_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR27_U_SMXP_2_0, REGION27_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR27_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR27_U_SMXP_2_0, REGION27_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR27_U_SMXP_2_0, REGION27_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR27_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR27_U_SMXP_2_0, 0x103e5c8)
    FIELD(POR_MPU_M5_PRLAR27_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR27_U_SMXP_2_0, REGION27_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR27_U_SMXP_2_0, REGION27_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR28_U_SMXP_2_0, 0x103e5d0)
    FIELD(POR_MPU_M5_PRBAR28_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR28_U_SMXP_2_0, REGION28_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR28_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR28_U_SMXP_2_0, REGION28_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR28_U_SMXP_2_0, REGION28_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR28_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR28_U_SMXP_2_0, 0x103e5d8)
    FIELD(POR_MPU_M5_PRLAR28_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR28_U_SMXP_2_0, REGION28_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR28_U_SMXP_2_0, REGION28_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR29_U_SMXP_2_0, 0x103e5e0)
    FIELD(POR_MPU_M5_PRBAR29_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR29_U_SMXP_2_0, REGION29_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR29_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR29_U_SMXP_2_0, REGION29_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR29_U_SMXP_2_0, REGION29_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR29_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR29_U_SMXP_2_0, 0x103e5e8)
    FIELD(POR_MPU_M5_PRLAR29_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR29_U_SMXP_2_0, REGION29_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR29_U_SMXP_2_0, REGION29_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR30_U_SMXP_2_0, 0x103e5f0)
    FIELD(POR_MPU_M5_PRBAR30_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR30_U_SMXP_2_0, REGION30_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR30_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR30_U_SMXP_2_0, REGION30_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR30_U_SMXP_2_0, REGION30_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR30_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR30_U_SMXP_2_0, 0x103e5f8)
    FIELD(POR_MPU_M5_PRLAR30_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR30_U_SMXP_2_0, REGION30_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR30_U_SMXP_2_0, REGION30_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR31_U_SMXP_2_0, 0x103e600)
    FIELD(POR_MPU_M5_PRBAR31_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR31_U_SMXP_2_0, REGION31_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR31_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR31_U_SMXP_2_0, REGION31_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR31_U_SMXP_2_0, REGION31_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR31_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR31_U_SMXP_2_0, 0x103e608)
    FIELD(POR_MPU_M5_PRLAR31_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR31_U_SMXP_2_0, REGION31_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR31_U_SMXP_2_0, REGION31_EN, 0, 1)
REG32(POR_MPU_M6_CTL_U_SMXP_2_0, 0x103e800)
    FIELD(POR_MPU_M6_CTL_U_SMXP_2_0, M6_EN, 2, 1)
    FIELD(POR_MPU_M6_CTL_U_SMXP_2_0, M6_ACTION, 0, 2)
REG32(POR_MPU_M6_PRBAR0_U_SMXP_2_0, 0x103e810)
    FIELD(POR_MPU_M6_PRBAR0_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR0_U_SMXP_2_0, REGION0_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR0_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR0_U_SMXP_2_0, REGION0_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR0_U_SMXP_2_0, REGION0_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR0_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR0_U_SMXP_2_0, 0x103e818)
    FIELD(POR_MPU_M6_PRLAR0_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR0_U_SMXP_2_0, REGION0_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR0_U_SMXP_2_0, REGION0_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR1_U_SMXP_2_0, 0x103e820)
    FIELD(POR_MPU_M6_PRBAR1_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR1_U_SMXP_2_0, REGION1_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR1_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR1_U_SMXP_2_0, REGION1_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR1_U_SMXP_2_0, REGION1_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR1_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR1_U_SMXP_2_0, 0x103e828)
    FIELD(POR_MPU_M6_PRLAR1_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR1_U_SMXP_2_0, REGION1_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR1_U_SMXP_2_0, REGION1_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR2_U_SMXP_2_0, 0x103e830)
    FIELD(POR_MPU_M6_PRBAR2_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR2_U_SMXP_2_0, REGION2_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR2_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR2_U_SMXP_2_0, REGION2_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR2_U_SMXP_2_0, REGION2_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR2_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR2_U_SMXP_2_0, 0x103e838)
    FIELD(POR_MPU_M6_PRLAR2_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR2_U_SMXP_2_0, REGION2_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR2_U_SMXP_2_0, REGION2_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR3_U_SMXP_2_0, 0x103e840)
    FIELD(POR_MPU_M6_PRBAR3_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR3_U_SMXP_2_0, REGION3_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR3_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR3_U_SMXP_2_0, REGION3_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR3_U_SMXP_2_0, REGION3_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR3_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR3_U_SMXP_2_0, 0x103e848)
    FIELD(POR_MPU_M6_PRLAR3_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR3_U_SMXP_2_0, REGION3_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR3_U_SMXP_2_0, REGION3_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR4_U_SMXP_2_0, 0x103e850)
    FIELD(POR_MPU_M6_PRBAR4_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR4_U_SMXP_2_0, REGION4_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR4_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR4_U_SMXP_2_0, REGION4_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR4_U_SMXP_2_0, REGION4_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR4_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR4_U_SMXP_2_0, 0x103e858)
    FIELD(POR_MPU_M6_PRLAR4_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR4_U_SMXP_2_0, REGION4_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR4_U_SMXP_2_0, REGION4_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR5_U_SMXP_2_0, 0x103e860)
    FIELD(POR_MPU_M6_PRBAR5_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR5_U_SMXP_2_0, REGION5_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR5_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR5_U_SMXP_2_0, REGION5_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR5_U_SMXP_2_0, REGION5_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR5_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR5_U_SMXP_2_0, 0x103e868)
    FIELD(POR_MPU_M6_PRLAR5_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR5_U_SMXP_2_0, REGION5_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR5_U_SMXP_2_0, REGION5_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR6_U_SMXP_2_0, 0x103e870)
    FIELD(POR_MPU_M6_PRBAR6_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR6_U_SMXP_2_0, REGION6_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR6_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR6_U_SMXP_2_0, REGION6_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR6_U_SMXP_2_0, REGION6_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR6_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR6_U_SMXP_2_0, 0x103e878)
    FIELD(POR_MPU_M6_PRLAR6_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR6_U_SMXP_2_0, REGION6_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR6_U_SMXP_2_0, REGION6_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR7_U_SMXP_2_0, 0x103e880)
    FIELD(POR_MPU_M6_PRBAR7_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR7_U_SMXP_2_0, REGION7_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR7_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR7_U_SMXP_2_0, REGION7_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR7_U_SMXP_2_0, REGION7_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR7_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR7_U_SMXP_2_0, 0x103e888)
    FIELD(POR_MPU_M6_PRLAR7_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR7_U_SMXP_2_0, REGION7_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR7_U_SMXP_2_0, REGION7_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR8_U_SMXP_2_0, 0x103e890)
    FIELD(POR_MPU_M6_PRBAR8_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR8_U_SMXP_2_0, REGION8_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR8_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR8_U_SMXP_2_0, REGION8_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR8_U_SMXP_2_0, REGION8_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR8_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR8_U_SMXP_2_0, 0x103e898)
    FIELD(POR_MPU_M6_PRLAR8_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR8_U_SMXP_2_0, REGION8_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR8_U_SMXP_2_0, REGION8_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR9_U_SMXP_2_0, 0x103e8a0)
    FIELD(POR_MPU_M6_PRBAR9_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR9_U_SMXP_2_0, REGION9_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR9_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR9_U_SMXP_2_0, REGION9_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR9_U_SMXP_2_0, REGION9_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR9_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR9_U_SMXP_2_0, 0x103e8a8)
    FIELD(POR_MPU_M6_PRLAR9_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR9_U_SMXP_2_0, REGION9_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR9_U_SMXP_2_0, REGION9_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR10_U_SMXP_2_0, 0x103e8b0)
    FIELD(POR_MPU_M6_PRBAR10_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR10_U_SMXP_2_0, REGION10_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR10_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR10_U_SMXP_2_0, REGION10_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR10_U_SMXP_2_0, REGION10_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR10_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR10_U_SMXP_2_0, 0x103e8b8)
    FIELD(POR_MPU_M6_PRLAR10_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR10_U_SMXP_2_0, REGION10_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR10_U_SMXP_2_0, REGION10_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR11_U_SMXP_2_0, 0x103e8c0)
    FIELD(POR_MPU_M6_PRBAR11_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR11_U_SMXP_2_0, REGION11_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR11_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR11_U_SMXP_2_0, REGION11_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR11_U_SMXP_2_0, REGION11_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR11_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR11_U_SMXP_2_0, 0x103e8c8)
    FIELD(POR_MPU_M6_PRLAR11_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR11_U_SMXP_2_0, REGION11_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR11_U_SMXP_2_0, REGION11_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR12_U_SMXP_2_0, 0x103e8d0)
    FIELD(POR_MPU_M6_PRBAR12_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR12_U_SMXP_2_0, REGION12_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR12_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR12_U_SMXP_2_0, REGION12_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR12_U_SMXP_2_0, REGION12_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR12_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR12_U_SMXP_2_0, 0x103e8d8)
    FIELD(POR_MPU_M6_PRLAR12_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR12_U_SMXP_2_0, REGION12_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR12_U_SMXP_2_0, REGION12_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR13_U_SMXP_2_0, 0x103e8e0)
    FIELD(POR_MPU_M6_PRBAR13_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR13_U_SMXP_2_0, REGION13_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR13_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR13_U_SMXP_2_0, REGION13_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR13_U_SMXP_2_0, REGION13_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR13_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR13_U_SMXP_2_0, 0x103e8e8)
    FIELD(POR_MPU_M6_PRLAR13_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR13_U_SMXP_2_0, REGION13_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR13_U_SMXP_2_0, REGION13_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR14_U_SMXP_2_0, 0x103e8f0)
    FIELD(POR_MPU_M6_PRBAR14_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR14_U_SMXP_2_0, REGION14_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR14_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR14_U_SMXP_2_0, REGION14_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR14_U_SMXP_2_0, REGION14_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR14_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR14_U_SMXP_2_0, 0x103e8f8)
    FIELD(POR_MPU_M6_PRLAR14_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR14_U_SMXP_2_0, REGION14_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR14_U_SMXP_2_0, REGION14_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR15_U_SMXP_2_0, 0x103e900)
    FIELD(POR_MPU_M6_PRBAR15_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR15_U_SMXP_2_0, REGION15_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR15_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR15_U_SMXP_2_0, REGION15_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR15_U_SMXP_2_0, REGION15_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR15_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR15_U_SMXP_2_0, 0x103e908)
    FIELD(POR_MPU_M6_PRLAR15_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR15_U_SMXP_2_0, REGION15_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR15_U_SMXP_2_0, REGION15_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR16_U_SMXP_2_0, 0x103e910)
    FIELD(POR_MPU_M6_PRBAR16_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR16_U_SMXP_2_0, REGION16_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR16_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR16_U_SMXP_2_0, REGION16_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR16_U_SMXP_2_0, REGION16_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR16_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR16_U_SMXP_2_0, 0x103e918)
    FIELD(POR_MPU_M6_PRLAR16_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR16_U_SMXP_2_0, REGION16_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR16_U_SMXP_2_0, REGION16_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR17_U_SMXP_2_0, 0x103e920)
    FIELD(POR_MPU_M6_PRBAR17_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR17_U_SMXP_2_0, REGION17_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR17_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR17_U_SMXP_2_0, REGION17_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR17_U_SMXP_2_0, REGION17_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR17_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR17_U_SMXP_2_0, 0x103e928)
    FIELD(POR_MPU_M6_PRLAR17_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR17_U_SMXP_2_0, REGION17_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR17_U_SMXP_2_0, REGION17_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR18_U_SMXP_2_0, 0x103e930)
    FIELD(POR_MPU_M6_PRBAR18_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR18_U_SMXP_2_0, REGION18_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR18_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR18_U_SMXP_2_0, REGION18_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR18_U_SMXP_2_0, REGION18_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR18_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR18_U_SMXP_2_0, 0x103e938)
    FIELD(POR_MPU_M6_PRLAR18_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR18_U_SMXP_2_0, REGION18_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR18_U_SMXP_2_0, REGION18_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR19_U_SMXP_2_0, 0x103e940)
    FIELD(POR_MPU_M6_PRBAR19_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR19_U_SMXP_2_0, REGION19_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR19_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR19_U_SMXP_2_0, REGION19_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR19_U_SMXP_2_0, REGION19_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR19_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR19_U_SMXP_2_0, 0x103e948)
    FIELD(POR_MPU_M6_PRLAR19_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR19_U_SMXP_2_0, REGION19_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR19_U_SMXP_2_0, REGION19_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR20_U_SMXP_2_0, 0x103e950)
    FIELD(POR_MPU_M6_PRBAR20_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR20_U_SMXP_2_0, REGION20_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR20_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR20_U_SMXP_2_0, REGION20_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR20_U_SMXP_2_0, REGION20_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR20_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR20_U_SMXP_2_0, 0x103e958)
    FIELD(POR_MPU_M6_PRLAR20_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR20_U_SMXP_2_0, REGION20_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR20_U_SMXP_2_0, REGION20_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR21_U_SMXP_2_0, 0x103e960)
    FIELD(POR_MPU_M6_PRBAR21_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR21_U_SMXP_2_0, REGION21_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR21_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR21_U_SMXP_2_0, REGION21_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR21_U_SMXP_2_0, REGION21_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR21_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR21_U_SMXP_2_0, 0x103e968)
    FIELD(POR_MPU_M6_PRLAR21_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR21_U_SMXP_2_0, REGION21_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR21_U_SMXP_2_0, REGION21_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR22_U_SMXP_2_0, 0x103e970)
    FIELD(POR_MPU_M6_PRBAR22_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR22_U_SMXP_2_0, REGION22_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR22_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR22_U_SMXP_2_0, REGION22_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR22_U_SMXP_2_0, REGION22_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR22_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR22_U_SMXP_2_0, 0x103e978)
    FIELD(POR_MPU_M6_PRLAR22_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR22_U_SMXP_2_0, REGION22_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR22_U_SMXP_2_0, REGION22_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR23_U_SMXP_2_0, 0x103e980)
    FIELD(POR_MPU_M6_PRBAR23_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR23_U_SMXP_2_0, REGION23_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR23_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR23_U_SMXP_2_0, REGION23_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR23_U_SMXP_2_0, REGION23_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR23_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR23_U_SMXP_2_0, 0x103e988)
    FIELD(POR_MPU_M6_PRLAR23_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR23_U_SMXP_2_0, REGION23_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR23_U_SMXP_2_0, REGION23_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR24_U_SMXP_2_0, 0x103e990)
    FIELD(POR_MPU_M6_PRBAR24_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR24_U_SMXP_2_0, REGION24_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR24_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR24_U_SMXP_2_0, REGION24_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR24_U_SMXP_2_0, REGION24_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR24_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR24_U_SMXP_2_0, 0x103e998)
    FIELD(POR_MPU_M6_PRLAR24_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR24_U_SMXP_2_0, REGION24_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR24_U_SMXP_2_0, REGION24_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR25_U_SMXP_2_0, 0x103e9a0)
    FIELD(POR_MPU_M6_PRBAR25_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR25_U_SMXP_2_0, REGION25_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR25_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR25_U_SMXP_2_0, REGION25_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR25_U_SMXP_2_0, REGION25_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR25_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR25_U_SMXP_2_0, 0x103e9a8)
    FIELD(POR_MPU_M6_PRLAR25_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR25_U_SMXP_2_0, REGION25_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR25_U_SMXP_2_0, REGION25_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR26_U_SMXP_2_0, 0x103e9b0)
    FIELD(POR_MPU_M6_PRBAR26_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR26_U_SMXP_2_0, REGION26_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR26_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR26_U_SMXP_2_0, REGION26_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR26_U_SMXP_2_0, REGION26_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR26_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR26_U_SMXP_2_0, 0x103e9b8)
    FIELD(POR_MPU_M6_PRLAR26_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR26_U_SMXP_2_0, REGION26_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR26_U_SMXP_2_0, REGION26_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR27_U_SMXP_2_0, 0x103e9c0)
    FIELD(POR_MPU_M6_PRBAR27_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR27_U_SMXP_2_0, REGION27_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR27_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR27_U_SMXP_2_0, REGION27_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR27_U_SMXP_2_0, REGION27_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR27_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR27_U_SMXP_2_0, 0x103e9c8)
    FIELD(POR_MPU_M6_PRLAR27_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR27_U_SMXP_2_0, REGION27_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR27_U_SMXP_2_0, REGION27_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR28_U_SMXP_2_0, 0x103e9d0)
    FIELD(POR_MPU_M6_PRBAR28_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR28_U_SMXP_2_0, REGION28_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR28_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR28_U_SMXP_2_0, REGION28_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR28_U_SMXP_2_0, REGION28_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR28_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR28_U_SMXP_2_0, 0x103e9d8)
    FIELD(POR_MPU_M6_PRLAR28_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR28_U_SMXP_2_0, REGION28_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR28_U_SMXP_2_0, REGION28_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR29_U_SMXP_2_0, 0x103e9e0)
    FIELD(POR_MPU_M6_PRBAR29_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR29_U_SMXP_2_0, REGION29_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR29_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR29_U_SMXP_2_0, REGION29_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR29_U_SMXP_2_0, REGION29_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR29_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR29_U_SMXP_2_0, 0x103e9e8)
    FIELD(POR_MPU_M6_PRLAR29_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR29_U_SMXP_2_0, REGION29_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR29_U_SMXP_2_0, REGION29_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR30_U_SMXP_2_0, 0x103e9f0)
    FIELD(POR_MPU_M6_PRBAR30_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR30_U_SMXP_2_0, REGION30_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR30_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR30_U_SMXP_2_0, REGION30_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR30_U_SMXP_2_0, REGION30_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR30_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR30_U_SMXP_2_0, 0x103e9f8)
    FIELD(POR_MPU_M6_PRLAR30_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR30_U_SMXP_2_0, REGION30_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR30_U_SMXP_2_0, REGION30_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR31_U_SMXP_2_0, 0x103ea00)
    FIELD(POR_MPU_M6_PRBAR31_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR31_U_SMXP_2_0, REGION31_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR31_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR31_U_SMXP_2_0, REGION31_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR31_U_SMXP_2_0, REGION31_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR31_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR31_U_SMXP_2_0, 0x103ea08)
    FIELD(POR_MPU_M6_PRLAR31_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR31_U_SMXP_2_0, REGION31_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR31_U_SMXP_2_0, REGION31_EN, 0, 1)
REG32(POR_MPU_M7_CTL_U_SMXP_2_0, 0x103ec00)
    FIELD(POR_MPU_M7_CTL_U_SMXP_2_0, M7_EN, 2, 1)
    FIELD(POR_MPU_M7_CTL_U_SMXP_2_0, M7_ACTION, 0, 2)
REG32(POR_MPU_M7_PRBAR0_U_SMXP_2_0, 0x103ec10)
    FIELD(POR_MPU_M7_PRBAR0_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR0_U_SMXP_2_0, REGION0_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR0_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR0_U_SMXP_2_0, REGION0_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR0_U_SMXP_2_0, REGION0_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR0_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR0_U_SMXP_2_0, 0x103ec18)
    FIELD(POR_MPU_M7_PRLAR0_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR0_U_SMXP_2_0, REGION0_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR0_U_SMXP_2_0, REGION0_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR1_U_SMXP_2_0, 0x103ec20)
    FIELD(POR_MPU_M7_PRBAR1_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR1_U_SMXP_2_0, REGION1_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR1_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR1_U_SMXP_2_0, REGION1_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR1_U_SMXP_2_0, REGION1_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR1_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR1_U_SMXP_2_0, 0x103ec28)
    FIELD(POR_MPU_M7_PRLAR1_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR1_U_SMXP_2_0, REGION1_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR1_U_SMXP_2_0, REGION1_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR2_U_SMXP_2_0, 0x103ec30)
    FIELD(POR_MPU_M7_PRBAR2_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR2_U_SMXP_2_0, REGION2_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR2_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR2_U_SMXP_2_0, REGION2_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR2_U_SMXP_2_0, REGION2_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR2_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR2_U_SMXP_2_0, 0x103ec38)
    FIELD(POR_MPU_M7_PRLAR2_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR2_U_SMXP_2_0, REGION2_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR2_U_SMXP_2_0, REGION2_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR3_U_SMXP_2_0, 0x103ec40)
    FIELD(POR_MPU_M7_PRBAR3_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR3_U_SMXP_2_0, REGION3_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR3_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR3_U_SMXP_2_0, REGION3_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR3_U_SMXP_2_0, REGION3_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR3_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR3_U_SMXP_2_0, 0x103ec48)
    FIELD(POR_MPU_M7_PRLAR3_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR3_U_SMXP_2_0, REGION3_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR3_U_SMXP_2_0, REGION3_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR4_U_SMXP_2_0, 0x103ec50)
    FIELD(POR_MPU_M7_PRBAR4_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR4_U_SMXP_2_0, REGION4_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR4_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR4_U_SMXP_2_0, REGION4_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR4_U_SMXP_2_0, REGION4_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR4_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR4_U_SMXP_2_0, 0x103ec58)
    FIELD(POR_MPU_M7_PRLAR4_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR4_U_SMXP_2_0, REGION4_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR4_U_SMXP_2_0, REGION4_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR5_U_SMXP_2_0, 0x103ec60)
    FIELD(POR_MPU_M7_PRBAR5_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR5_U_SMXP_2_0, REGION5_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR5_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR5_U_SMXP_2_0, REGION5_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR5_U_SMXP_2_0, REGION5_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR5_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR5_U_SMXP_2_0, 0x103ec68)
    FIELD(POR_MPU_M7_PRLAR5_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR5_U_SMXP_2_0, REGION5_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR5_U_SMXP_2_0, REGION5_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR6_U_SMXP_2_0, 0x103ec70)
    FIELD(POR_MPU_M7_PRBAR6_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR6_U_SMXP_2_0, REGION6_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR6_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR6_U_SMXP_2_0, REGION6_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR6_U_SMXP_2_0, REGION6_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR6_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR6_U_SMXP_2_0, 0x103ec78)
    FIELD(POR_MPU_M7_PRLAR6_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR6_U_SMXP_2_0, REGION6_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR6_U_SMXP_2_0, REGION6_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR7_U_SMXP_2_0, 0x103ec80)
    FIELD(POR_MPU_M7_PRBAR7_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR7_U_SMXP_2_0, REGION7_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR7_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR7_U_SMXP_2_0, REGION7_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR7_U_SMXP_2_0, REGION7_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR7_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR7_U_SMXP_2_0, 0x103ec88)
    FIELD(POR_MPU_M7_PRLAR7_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR7_U_SMXP_2_0, REGION7_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR7_U_SMXP_2_0, REGION7_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR8_U_SMXP_2_0, 0x103ec90)
    FIELD(POR_MPU_M7_PRBAR8_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR8_U_SMXP_2_0, REGION8_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR8_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR8_U_SMXP_2_0, REGION8_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR8_U_SMXP_2_0, REGION8_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR8_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR8_U_SMXP_2_0, 0x103ec98)
    FIELD(POR_MPU_M7_PRLAR8_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR8_U_SMXP_2_0, REGION8_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR8_U_SMXP_2_0, REGION8_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR9_U_SMXP_2_0, 0x103eca0)
    FIELD(POR_MPU_M7_PRBAR9_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR9_U_SMXP_2_0, REGION9_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR9_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR9_U_SMXP_2_0, REGION9_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR9_U_SMXP_2_0, REGION9_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR9_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR9_U_SMXP_2_0, 0x103eca8)
    FIELD(POR_MPU_M7_PRLAR9_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR9_U_SMXP_2_0, REGION9_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR9_U_SMXP_2_0, REGION9_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR10_U_SMXP_2_0, 0x103ecb0)
    FIELD(POR_MPU_M7_PRBAR10_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR10_U_SMXP_2_0, REGION10_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR10_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR10_U_SMXP_2_0, REGION10_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR10_U_SMXP_2_0, REGION10_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR10_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR10_U_SMXP_2_0, 0x103ecb8)
    FIELD(POR_MPU_M7_PRLAR10_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR10_U_SMXP_2_0, REGION10_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR10_U_SMXP_2_0, REGION10_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR11_U_SMXP_2_0, 0x103ecc0)
    FIELD(POR_MPU_M7_PRBAR11_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR11_U_SMXP_2_0, REGION11_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR11_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR11_U_SMXP_2_0, REGION11_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR11_U_SMXP_2_0, REGION11_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR11_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR11_U_SMXP_2_0, 0x103ecc8)
    FIELD(POR_MPU_M7_PRLAR11_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR11_U_SMXP_2_0, REGION11_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR11_U_SMXP_2_0, REGION11_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR12_U_SMXP_2_0, 0x103ecd0)
    FIELD(POR_MPU_M7_PRBAR12_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR12_U_SMXP_2_0, REGION12_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR12_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR12_U_SMXP_2_0, REGION12_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR12_U_SMXP_2_0, REGION12_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR12_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR12_U_SMXP_2_0, 0x103ecd8)
    FIELD(POR_MPU_M7_PRLAR12_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR12_U_SMXP_2_0, REGION12_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR12_U_SMXP_2_0, REGION12_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR13_U_SMXP_2_0, 0x103ece0)
    FIELD(POR_MPU_M7_PRBAR13_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR13_U_SMXP_2_0, REGION13_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR13_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR13_U_SMXP_2_0, REGION13_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR13_U_SMXP_2_0, REGION13_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR13_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR13_U_SMXP_2_0, 0x103ece8)
    FIELD(POR_MPU_M7_PRLAR13_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR13_U_SMXP_2_0, REGION13_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR13_U_SMXP_2_0, REGION13_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR14_U_SMXP_2_0, 0x103ecf0)
    FIELD(POR_MPU_M7_PRBAR14_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR14_U_SMXP_2_0, REGION14_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR14_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR14_U_SMXP_2_0, REGION14_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR14_U_SMXP_2_0, REGION14_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR14_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR14_U_SMXP_2_0, 0x103ecf8)
    FIELD(POR_MPU_M7_PRLAR14_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR14_U_SMXP_2_0, REGION14_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR14_U_SMXP_2_0, REGION14_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR15_U_SMXP_2_0, 0x103ed00)
    FIELD(POR_MPU_M7_PRBAR15_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR15_U_SMXP_2_0, REGION15_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR15_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR15_U_SMXP_2_0, REGION15_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR15_U_SMXP_2_0, REGION15_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR15_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR15_U_SMXP_2_0, 0x103ed08)
    FIELD(POR_MPU_M7_PRLAR15_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR15_U_SMXP_2_0, REGION15_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR15_U_SMXP_2_0, REGION15_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR16_U_SMXP_2_0, 0x103ed10)
    FIELD(POR_MPU_M7_PRBAR16_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR16_U_SMXP_2_0, REGION16_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR16_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR16_U_SMXP_2_0, REGION16_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR16_U_SMXP_2_0, REGION16_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR16_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR16_U_SMXP_2_0, 0x103ed18)
    FIELD(POR_MPU_M7_PRLAR16_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR16_U_SMXP_2_0, REGION16_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR16_U_SMXP_2_0, REGION16_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR17_U_SMXP_2_0, 0x103ed20)
    FIELD(POR_MPU_M7_PRBAR17_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR17_U_SMXP_2_0, REGION17_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR17_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR17_U_SMXP_2_0, REGION17_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR17_U_SMXP_2_0, REGION17_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR17_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR17_U_SMXP_2_0, 0x103ed28)
    FIELD(POR_MPU_M7_PRLAR17_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR17_U_SMXP_2_0, REGION17_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR17_U_SMXP_2_0, REGION17_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR18_U_SMXP_2_0, 0x103ed30)
    FIELD(POR_MPU_M7_PRBAR18_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR18_U_SMXP_2_0, REGION18_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR18_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR18_U_SMXP_2_0, REGION18_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR18_U_SMXP_2_0, REGION18_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR18_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR18_U_SMXP_2_0, 0x103ed38)
    FIELD(POR_MPU_M7_PRLAR18_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR18_U_SMXP_2_0, REGION18_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR18_U_SMXP_2_0, REGION18_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR19_U_SMXP_2_0, 0x103ed40)
    FIELD(POR_MPU_M7_PRBAR19_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR19_U_SMXP_2_0, REGION19_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR19_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR19_U_SMXP_2_0, REGION19_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR19_U_SMXP_2_0, REGION19_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR19_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR19_U_SMXP_2_0, 0x103ed48)
    FIELD(POR_MPU_M7_PRLAR19_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR19_U_SMXP_2_0, REGION19_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR19_U_SMXP_2_0, REGION19_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR20_U_SMXP_2_0, 0x103ed50)
    FIELD(POR_MPU_M7_PRBAR20_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR20_U_SMXP_2_0, REGION20_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR20_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR20_U_SMXP_2_0, REGION20_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR20_U_SMXP_2_0, REGION20_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR20_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR20_U_SMXP_2_0, 0x103ed58)
    FIELD(POR_MPU_M7_PRLAR20_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR20_U_SMXP_2_0, REGION20_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR20_U_SMXP_2_0, REGION20_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR21_U_SMXP_2_0, 0x103ed60)
    FIELD(POR_MPU_M7_PRBAR21_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR21_U_SMXP_2_0, REGION21_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR21_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR21_U_SMXP_2_0, REGION21_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR21_U_SMXP_2_0, REGION21_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR21_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR21_U_SMXP_2_0, 0x103ed68)
    FIELD(POR_MPU_M7_PRLAR21_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR21_U_SMXP_2_0, REGION21_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR21_U_SMXP_2_0, REGION21_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR22_U_SMXP_2_0, 0x103ed70)
    FIELD(POR_MPU_M7_PRBAR22_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR22_U_SMXP_2_0, REGION22_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR22_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR22_U_SMXP_2_0, REGION22_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR22_U_SMXP_2_0, REGION22_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR22_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR22_U_SMXP_2_0, 0x103ed78)
    FIELD(POR_MPU_M7_PRLAR22_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR22_U_SMXP_2_0, REGION22_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR22_U_SMXP_2_0, REGION22_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR23_U_SMXP_2_0, 0x103ed80)
    FIELD(POR_MPU_M7_PRBAR23_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR23_U_SMXP_2_0, REGION23_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR23_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR23_U_SMXP_2_0, REGION23_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR23_U_SMXP_2_0, REGION23_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR23_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR23_U_SMXP_2_0, 0x103ed88)
    FIELD(POR_MPU_M7_PRLAR23_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR23_U_SMXP_2_0, REGION23_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR23_U_SMXP_2_0, REGION23_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR24_U_SMXP_2_0, 0x103ed90)
    FIELD(POR_MPU_M7_PRBAR24_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR24_U_SMXP_2_0, REGION24_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR24_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR24_U_SMXP_2_0, REGION24_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR24_U_SMXP_2_0, REGION24_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR24_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR24_U_SMXP_2_0, 0x103ed98)
    FIELD(POR_MPU_M7_PRLAR24_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR24_U_SMXP_2_0, REGION24_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR24_U_SMXP_2_0, REGION24_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR25_U_SMXP_2_0, 0x103eda0)
    FIELD(POR_MPU_M7_PRBAR25_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR25_U_SMXP_2_0, REGION25_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR25_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR25_U_SMXP_2_0, REGION25_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR25_U_SMXP_2_0, REGION25_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR25_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR25_U_SMXP_2_0, 0x103eda8)
    FIELD(POR_MPU_M7_PRLAR25_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR25_U_SMXP_2_0, REGION25_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR25_U_SMXP_2_0, REGION25_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR26_U_SMXP_2_0, 0x103edb0)
    FIELD(POR_MPU_M7_PRBAR26_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR26_U_SMXP_2_0, REGION26_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR26_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR26_U_SMXP_2_0, REGION26_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR26_U_SMXP_2_0, REGION26_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR26_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR26_U_SMXP_2_0, 0x103edb8)
    FIELD(POR_MPU_M7_PRLAR26_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR26_U_SMXP_2_0, REGION26_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR26_U_SMXP_2_0, REGION26_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR27_U_SMXP_2_0, 0x103edc0)
    FIELD(POR_MPU_M7_PRBAR27_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR27_U_SMXP_2_0, REGION27_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR27_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR27_U_SMXP_2_0, REGION27_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR27_U_SMXP_2_0, REGION27_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR27_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR27_U_SMXP_2_0, 0x103edc8)
    FIELD(POR_MPU_M7_PRLAR27_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR27_U_SMXP_2_0, REGION27_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR27_U_SMXP_2_0, REGION27_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR28_U_SMXP_2_0, 0x103edd0)
    FIELD(POR_MPU_M7_PRBAR28_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR28_U_SMXP_2_0, REGION28_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR28_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR28_U_SMXP_2_0, REGION28_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR28_U_SMXP_2_0, REGION28_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR28_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR28_U_SMXP_2_0, 0x103edd8)
    FIELD(POR_MPU_M7_PRLAR28_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR28_U_SMXP_2_0, REGION28_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR28_U_SMXP_2_0, REGION28_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR29_U_SMXP_2_0, 0x103ede0)
    FIELD(POR_MPU_M7_PRBAR29_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR29_U_SMXP_2_0, REGION29_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR29_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR29_U_SMXP_2_0, REGION29_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR29_U_SMXP_2_0, REGION29_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR29_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR29_U_SMXP_2_0, 0x103ede8)
    FIELD(POR_MPU_M7_PRLAR29_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR29_U_SMXP_2_0, REGION29_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR29_U_SMXP_2_0, REGION29_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR30_U_SMXP_2_0, 0x103edf0)
    FIELD(POR_MPU_M7_PRBAR30_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR30_U_SMXP_2_0, REGION30_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR30_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR30_U_SMXP_2_0, REGION30_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR30_U_SMXP_2_0, REGION30_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR30_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR30_U_SMXP_2_0, 0x103edf8)
    FIELD(POR_MPU_M7_PRLAR30_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR30_U_SMXP_2_0, REGION30_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR30_U_SMXP_2_0, REGION30_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR31_U_SMXP_2_0, 0x103ee00)
    FIELD(POR_MPU_M7_PRBAR31_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR31_U_SMXP_2_0, REGION31_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR31_U_SMXP_2_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR31_U_SMXP_2_0, REGION31_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR31_U_SMXP_2_0, REGION31_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR31_U_SMXP_2_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR31_U_SMXP_2_0, 0x103ee08)
    FIELD(POR_MPU_M7_PRLAR31_U_SMXP_2_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR31_U_SMXP_2_0, REGION31_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR31_U_SMXP_2_0, REGION31_EN, 0, 1)
REG32(POR_HNF_NODE_INFO_U_HNF_NID136, 0x1100000)
    FIELD(POR_HNF_NODE_INFO_U_HNF_NID136, RESERVED_48, 48, 16)
    FIELD(POR_HNF_NODE_INFO_U_HNF_NID136, LOGICAL_ID, 32, 16)
    FIELD(POR_HNF_NODE_INFO_U_HNF_NID136, NODE_ID, 16, 16)
    FIELD(POR_HNF_NODE_INFO_U_HNF_NID136, NODE_TYPE, 0, 16)
REG32(POR_HNF_CHILD_INFO_U_HNF_NID136, 0x1100080)
    FIELD(POR_HNF_CHILD_INFO_U_HNF_NID136, RESERVED_32, 32, 32)
    FIELD(POR_HNF_CHILD_INFO_U_HNF_NID136, CHILD_PTR_OFFSET, 16, 16)
    FIELD(POR_HNF_CHILD_INFO_U_HNF_NID136, CHILD_COUNT, 0, 16)
REG32(POR_HNF_UNIT_INFO_U_HNF_NID136, 0x1100900)
    FIELD(POR_HNF_UNIT_INFO_U_HNF_NID136, RESERVED_39, 39, 25)
    FIELD(POR_HNF_UNIT_INFO_U_HNF_NID136, NUM_POC_ENTRIES, 32, 7)
    FIELD(POR_HNF_UNIT_INFO_U_HNF_NID136, RESERVED_31, 31, 1)
    FIELD(POR_HNF_UNIT_INFO_U_HNF_NID136, NUM_EXCL, 24, 7)
    FIELD(POR_HNF_UNIT_INFO_U_HNF_NID136, RESERVED_23, 23, 1)
    FIELD(POR_HNF_UNIT_INFO_U_HNF_NID136, DATA_RAM_LATENCY, 20, 3)
    FIELD(POR_HNF_UNIT_INFO_U_HNF_NID136, RESERVED_19, 19, 1)
    FIELD(POR_HNF_UNIT_INFO_U_HNF_NID136, TAG_RAM_LAT, 16, 3)
    FIELD(POR_HNF_UNIT_INFO_U_HNF_NID136, RESERVED_13, 13, 3)
    FIELD(POR_HNF_UNIT_INFO_U_HNF_NID136, NUM_WAYS, 8, 5)
    FIELD(POR_HNF_UNIT_INFO_U_HNF_NID136, SF_SIZE, 4, 3)
    FIELD(POR_HNF_UNIT_INFO_U_HNF_NID136, SLC_SIZE, 0, 3)
REG32(POR_HNF_SECURE_REGISTER_GROUPS_OVERRIDE_U_HNF_NID136, 0x1100980)
    FIELD(POR_HNF_SECURE_REGISTER_GROUPS_OVERRIDE_U_HNF_NID136, SLCSF_DBGRD, 5, 1)
    FIELD(POR_HNF_SECURE_REGISTER_GROUPS_OVERRIDE_U_HNF_NID136, SAM_CONTROL, 4, 1)
    FIELD(POR_HNF_SECURE_REGISTER_GROUPS_OVERRIDE_U_HNF_NID136, SLC_LOCK_WAYS, 3, 1)
    FIELD(POR_HNF_SECURE_REGISTER_GROUPS_OVERRIDE_U_HNF_NID136, PPU, 2, 1)
    FIELD(POR_HNF_SECURE_REGISTER_GROUPS_OVERRIDE_U_HNF_NID136, CFG_CTL, 1, 1)
    FIELD(POR_HNF_SECURE_REGISTER_GROUPS_OVERRIDE_U_HNF_NID136, QOS, 0, 1)
REG32(POR_HNF_CFG_CTL_U_HNF_NID136, 0x1100a00)
    FIELD(POR_HNF_CFG_CTL_U_HNF_NID136, RESERVED_12, 12, 52)
    FIELD(POR_HNF_CFG_CTL_U_HNF_NID136, HNF_DMT_DISABLE, 11, 1)
    FIELD(POR_HNF_CFG_CTL_U_HNF_NID136, HNF_OCM_ALLWAYS_EN, 10, 1)
    FIELD(POR_HNF_CFG_CTL_U_HNF_NID136, HNF_OCM_EN, 9, 1)
    FIELD(POR_HNF_CFG_CTL_U_HNF_NID136, NCDEVCMO_MC_COMP, 8, 1)
    FIELD(POR_HNF_CFG_CTL_U_HNF_NID136, SF_ECC_SCRUB_DISABLE, 6, 1)
    FIELD(POR_HNF_CFG_CTL_U_HNF_NID136, SLC_TAG_ECC_SCRUB_DISABLE, 4, 1)
    FIELD(POR_HNF_CFG_CTL_U_HNF_NID136, POIS_DIS, 2, 1)
    FIELD(POR_HNF_CFG_CTL_U_HNF_NID136, ECC_DISABLE, 0, 1)
REG32(POR_HNF_AUX_CTL_U_HNF_NID136, 0x1100a08)
    FIELD(POR_HNF_AUX_CTL_U_HNF_NID136, RESERVED_58, 58, 6)
    FIELD(POR_HNF_AUX_CTL_U_HNF_NID136, SLC_ECC_PIPE_MODE_DIS, 57, 1)
    FIELD(POR_HNF_AUX_CTL_U_HNF_NID136, HNF_ORD_STASH_DATAPULL_EN, 56, 1)
    FIELD(POR_HNF_AUX_CTL_U_HNF_NID136, HNF_SHARED_INTV_DISABLE, 55, 1)
    FIELD(POR_HNF_AUX_CTL_U_HNF_NID136, RESERVED_53, 53, 2)
    FIELD(POR_HNF_AUX_CTL_U_HNF_NID136, HNF_SLC_LRU_DUALMODE_INSERT_VALUE, 51, 2)
    FIELD(POR_HNF_AUX_CTL_U_HNF_NID136, HNF_SLC_LRU_STATICMODE_INSERT_VALUE, 49, 2)
    FIELD(POR_HNF_AUX_CTL_U_HNF_NID136, HNF_SLC_LRU_SLCSRC_INSERT_VALUE, 47, 2)
    FIELD(POR_HNF_AUX_CTL_U_HNF_NID136, HNF_SLC_LRU_SEL_CNT_VALUE, 45, 2)
    FIELD(POR_HNF_AUX_CTL_U_HNF_NID136, HNF_SLC_LRU_SET_GROUPS, 43, 2)
    FIELD(POR_HNF_AUX_CTL_U_HNF_NID136, HNF_SLC_LRU_VICTIM_DISABLE, 42, 1)
    FIELD(POR_HNF_AUX_CTL_U_HNF_NID136, HNF_SLC_VICTIM_QOS_HIGH, 41, 1)
    FIELD(POR_HNF_AUX_CTL_U_HNF_NID136, HNF_SF_SNP_VEC_DISABLE, 40, 1)
    FIELD(POR_HNF_AUX_CTL_U_HNF_NID136, HNF_STASH_DATAPULL_DISABLE, 39, 1)
    FIELD(POR_HNF_AUX_CTL_U_HNF_NID136, RESERVED_37, 37, 2)
    FIELD(POR_HNF_AUX_CTL_U_HNF_NID136, HNF_CU_EXCL_OPT_EN, 36, 1)
    FIELD(POR_HNF_AUX_CTL_U_HNF_NID136, RESERVED_34, 34, 2)
    FIELD(POR_HNF_AUX_CTL_U_HNF_NID136, HNF_EXCL_SNP_FWD_EN, 33, 1)
    FIELD(POR_HNF_AUX_CTL_U_HNF_NID136, HNF_RD_EXCL_OPT_EN, 32, 1)
    FIELD(POR_HNF_AUX_CTL_U_HNF_NID136, RESERVED_17, 17, 15)
    FIELD(POR_HNF_AUX_CTL_U_HNF_NID136, HNF_POISON_INTR_EN, 16, 1)
    FIELD(POR_HNF_AUX_CTL_U_HNF_NID136, HNF_DCT_DISABLE, 15, 1)
    FIELD(POR_HNF_AUX_CTL_U_HNF_NID136, WLU_ALLOC_ON_HIT, 14, 1)
    FIELD(POR_HNF_AUX_CTL_U_HNF_NID136, SF_DISABLE, 13, 1)
    FIELD(POR_HNF_AUX_CTL_U_HNF_NID136, CG_DISABLE, 12, 1)
    FIELD(POR_HNF_AUX_CTL_U_HNF_NID136, SLC_POR_INIT_DISABLE, 11, 1)
    FIELD(POR_HNF_AUX_CTL_U_HNF_NID136, FRZ_MON_ON_OVFL, 10, 1)
    FIELD(POR_HNF_AUX_CTL_U_HNF_NID136, DIS_SEQREQ_COLL, 9, 1)
    FIELD(POR_HNF_AUX_CTL_U_HNF_NID136, DIS_LIKELYSH, 8, 1)
    FIELD(POR_HNF_AUX_CTL_U_HNF_NID136, HNF_STASH_DISABLE, 7, 1)
    FIELD(POR_HNF_AUX_CTL_U_HNF_NID136, DIS_SNP_ONCE, 6, 1)
    FIELD(POR_HNF_AUX_CTL_U_HNF_NID136, NON_SH_NO_ALLOC, 5, 1)
    FIELD(POR_HNF_AUX_CTL_U_HNF_NID136, IO_READ_NO_ALLOC, 4, 1)
    FIELD(POR_HNF_AUX_CTL_U_HNF_NID136, REV_QOS_POOL_ALLOC, 3, 1)
    FIELD(POR_HNF_AUX_CTL_U_HNF_NID136, NO_WU_ALLOC, 2, 1)
    FIELD(POR_HNF_AUX_CTL_U_HNF_NID136, HNF_HONOR_EWA, 1, 1)
    FIELD(POR_HNF_AUX_CTL_U_HNF_NID136, HNF_ONLY_MODE, 0, 1)
REG32(POR_HNF_R2_AUX_CTL_U_HNF_NID136, 0x1100a10)
    FIELD(POR_HNF_R2_AUX_CTL_U_HNF_NID136, HNF_SHD_RAM_LSCG_CG_DISABLE, 3, 1)
    FIELD(POR_HNF_R2_AUX_CTL_U_HNF_NID136, HNF_FORCE_FLUSH_EWA0_EN, 2, 1)
    FIELD(POR_HNF_R2_AUX_CTL_U_HNF_NID136, HNF_PCMO_TERMINATE_EN, 1, 1)
    FIELD(POR_HNF_R2_AUX_CTL_U_HNF_NID136, HNF_CHIC_RDNOSNPSEP_DIS, 0, 1)
REG32(RDF_HNF_AUX_CTL_U_HNF_NID136, 0x1100a18)
    FIELD(RDF_HNF_AUX_CTL_U_HNF_NID136, RESERVED_16, 16, 48)
    FIELD(RDF_HNF_AUX_CTL_U_HNF_NID136, RDF_1CYCTAG_ECCMODE_OPT_DIS, 15, 1)
    FIELD(RDF_HNF_AUX_CTL_U_HNF_NID136, RESERVED_13, 13, 2)
    FIELD(RDF_HNF_AUX_CTL_U_HNF_NID136, RDF_ALLOW_CLN_DATA_FROM_NO_WR_AP, 12, 1)
    FIELD(RDF_HNF_AUX_CTL_U_HNF_NID136, RESERVED_10, 10, 2)
    FIELD(RDF_HNF_AUX_CTL_U_HNF_NID136, RDF_SNP_MPU_ERR_LOG_EN, 9, 1)
    FIELD(RDF_HNF_AUX_CTL_U_HNF_NID136, RDF_MPU_ERR_LOG_DIS, 8, 1)
    FIELD(RDF_HNF_AUX_CTL_U_HNF_NID136, RESERVED_0, 0, 8)
REG32(POR_HNF_QOS_BAND_U_HNF_NID136, 0x1100a80)
    FIELD(POR_HNF_QOS_BAND_U_HNF_NID136, RESERVED_32, 32, 32)
    FIELD(POR_HNF_QOS_BAND_U_HNF_NID136, HIGHHIGH_MAX_QOS_VAL, 28, 4)
    FIELD(POR_HNF_QOS_BAND_U_HNF_NID136, HIGHHIGH_MIN_QOS_VAL, 24, 4)
    FIELD(POR_HNF_QOS_BAND_U_HNF_NID136, HIGH_MAX_QOS_VAL, 20, 4)
    FIELD(POR_HNF_QOS_BAND_U_HNF_NID136, HIGH_MIN_QOS_VAL, 16, 4)
    FIELD(POR_HNF_QOS_BAND_U_HNF_NID136, MED_MAX_QOS_VAL, 12, 4)
    FIELD(POR_HNF_QOS_BAND_U_HNF_NID136, MED_MIN_QOS_VAL, 8, 4)
    FIELD(POR_HNF_QOS_BAND_U_HNF_NID136, LOW_MAX_QOS_VAL, 4, 4)
    FIELD(POR_HNF_QOS_BAND_U_HNF_NID136, LOW_MIN_QOS_VAL, 0, 4)
REG32(POR_HNF_QOS_RESERVATION_U_HNF_NID136, 0x1100a88)
    FIELD(POR_HNF_QOS_RESERVATION_U_HNF_NID136, RESERVED_38, 38, 26)
    FIELD(POR_HNF_QOS_RESERVATION_U_HNF_NID136, SEQ_QOS_MAX_CNT, 32, 6)
    FIELD(POR_HNF_QOS_RESERVATION_U_HNF_NID136, RESERVED_30, 30, 2)
    FIELD(POR_HNF_QOS_RESERVATION_U_HNF_NID136, HIGHHIGH_QOS_MAX_CNT, 24, 6)
    FIELD(POR_HNF_QOS_RESERVATION_U_HNF_NID136, RESERVED_22, 22, 2)
    FIELD(POR_HNF_QOS_RESERVATION_U_HNF_NID136, HIGH_QOS_MAX_CNT, 16, 6)
    FIELD(POR_HNF_QOS_RESERVATION_U_HNF_NID136, RESERVED_14, 14, 2)
    FIELD(POR_HNF_QOS_RESERVATION_U_HNF_NID136, MED_QOS_MAX_CNT, 8, 6)
    FIELD(POR_HNF_QOS_RESERVATION_U_HNF_NID136, LOW_QOS_MAX_CNT, 0, 6)
REG32(POR_HNF_RN_STARVATION_U_HNF_NID136, 0x1100a90)
    FIELD(POR_HNF_RN_STARVATION_U_HNF_NID136, RESERVED_45, 45, 19)
    FIELD(POR_HNF_RN_STARVATION_U_HNF_NID136, RN_HIGH_OVER_HIGH_HIGH_MAX_CNT, 40, 5)
    FIELD(POR_HNF_RN_STARVATION_U_HNF_NID136, RESERVED_38, 38, 2)
    FIELD(POR_HNF_RN_STARVATION_U_HNF_NID136, RN_MED_OVER_HIGHHIGH_MAX_CNT, 32, 6)
    FIELD(POR_HNF_RN_STARVATION_U_HNF_NID136, RESERVED_29, 29, 3)
    FIELD(POR_HNF_RN_STARVATION_U_HNF_NID136, RN_MED_OVER_HIGH_MAX_CNT, 24, 5)
    FIELD(POR_HNF_RN_STARVATION_U_HNF_NID136, RESERVED_23, 23, 1)
    FIELD(POR_HNF_RN_STARVATION_U_HNF_NID136, RN_LOW_OVER_HIGHHIGH_MAX_CNT, 16, 7)
    FIELD(POR_HNF_RN_STARVATION_U_HNF_NID136, RESERVED_14, 14, 2)
    FIELD(POR_HNF_RN_STARVATION_U_HNF_NID136, RN_LOW_OVER_HIGH_MAX_CNT, 8, 6)
    FIELD(POR_HNF_RN_STARVATION_U_HNF_NID136, RN_LOW_OVER_MED_MAX_CNT, 0, 5)
REG32(POR_HNF_CFG_SLCSF_DBGRD_U_HNF_NID136, 0x1100b80)
    FIELD(POR_HNF_CFG_SLCSF_DBGRD_U_HNF_NID136, RESERVED_26, 26, 38)
    FIELD(POR_HNF_CFG_SLCSF_DBGRD_U_HNF_NID136, SLC_ACCESS_COMPONENT, 24, 2)
    FIELD(POR_HNF_CFG_SLCSF_DBGRD_U_HNF_NID136, RESERVED_23, 23, 1)
    FIELD(POR_HNF_CFG_SLCSF_DBGRD_U_HNF_NID136, SLC_ACCESS_DW, 20, 3)
    FIELD(POR_HNF_CFG_SLCSF_DBGRD_U_HNF_NID136, SLC_ACCESS_WAY, 16, 4)
    FIELD(POR_HNF_CFG_SLCSF_DBGRD_U_HNF_NID136, RESERVED_13, 13, 3)
    FIELD(POR_HNF_CFG_SLCSF_DBGRD_U_HNF_NID136, SLC_ACCESS_SET, 0, 13)
REG32(POR_HNF_SLC_CACHE_ACCESS_SLC_TAG_U_HNF_NID136, 0x1100b88)
    FIELD(POR_HNF_SLC_CACHE_ACCESS_SLC_TAG_U_HNF_NID136, RESERVED_48, 48, 16)
    FIELD(POR_HNF_SLC_CACHE_ACCESS_SLC_TAG_U_HNF_NID136, SLC_CACHE_ACCESS_SLC_TAG, 0, 48)
REG32(POR_HNF_SLC_CACHE_ACCESS_SLC_DATA_U_HNF_NID136, 0x1100b90)
REG32(POR_HNF_SLC_CACHE_ACCESS_SF_TAG_U_HNF_NID136, 0x1100b98)
REG32(POR_HNF_SLC_CACHE_ACCESS_SF_TAG1_U_HNF_NID136, 0x1100ba0)
REG32(POR_HNF_SLC_CACHE_ACCESS_SF_TAG2_U_HNF_NID136, 0x1100ba8)
REG32(POR_HNF_SLC_LOCK_WAYS_U_HNF_NID136, 0x1100c00)
    FIELD(POR_HNF_SLC_LOCK_WAYS_U_HNF_NID136, RESERVED_15, 15, 49)
    FIELD(POR_HNF_SLC_LOCK_WAYS_U_HNF_NID136, NUM_HNF, 8, 7)
    FIELD(POR_HNF_SLC_LOCK_WAYS_U_HNF_NID136, WAYS, 0, 4)
REG32(POR_HNF_SLC_LOCK_BASE0_U_HNF_NID136, 0x1100c08)
    FIELD(POR_HNF_SLC_LOCK_BASE0_U_HNF_NID136, BASE0_VLD, 63, 1)
    FIELD(POR_HNF_SLC_LOCK_BASE0_U_HNF_NID136, RESERVED_48, 48, 15)
    FIELD(POR_HNF_SLC_LOCK_BASE0_U_HNF_NID136, BASE0, 0, 48)
REG32(POR_HNF_SLC_LOCK_BASE1_U_HNF_NID136, 0x1100c10)
    FIELD(POR_HNF_SLC_LOCK_BASE1_U_HNF_NID136, BASE1_VLD, 63, 1)
    FIELD(POR_HNF_SLC_LOCK_BASE1_U_HNF_NID136, RESERVED_48, 48, 15)
    FIELD(POR_HNF_SLC_LOCK_BASE1_U_HNF_NID136, BASE1, 0, 48)
REG32(POR_HNF_SLC_LOCK_BASE2_U_HNF_NID136, 0x1100c18)
    FIELD(POR_HNF_SLC_LOCK_BASE2_U_HNF_NID136, BASE2_VLD, 63, 1)
    FIELD(POR_HNF_SLC_LOCK_BASE2_U_HNF_NID136, RESERVED_48, 48, 15)
    FIELD(POR_HNF_SLC_LOCK_BASE2_U_HNF_NID136, BASE2, 0, 48)
REG32(POR_HNF_SLC_LOCK_BASE3_U_HNF_NID136, 0x1100c20)
    FIELD(POR_HNF_SLC_LOCK_BASE3_U_HNF_NID136, BASE3_VLD, 63, 1)
    FIELD(POR_HNF_SLC_LOCK_BASE3_U_HNF_NID136, RESERVED_48, 48, 15)
    FIELD(POR_HNF_SLC_LOCK_BASE3_U_HNF_NID136, BASE3, 0, 48)
REG32(POR_HNF_RNF_REGION_VEC1_U_HNF_NID136, 0x1100c28)
REG32(POR_HNF_RNI_REGION_VEC_U_HNF_NID136, 0x1100c30)
    FIELD(POR_HNF_RNI_REGION_VEC_U_HNF_NID136, RESERVED_32, 32, 32)
    FIELD(POR_HNF_RNI_REGION_VEC_U_HNF_NID136, RNI_REGION_VEC, 0, 32)
REG32(POR_HNF_RNF_REGION_VEC_U_HNF_NID136, 0x1100c38)
REG32(POR_HNF_RND_REGION_VEC_U_HNF_NID136, 0x1100c40)
    FIELD(POR_HNF_RND_REGION_VEC_U_HNF_NID136, RESERVED_32, 32, 32)
    FIELD(POR_HNF_RND_REGION_VEC_U_HNF_NID136, RND_REGION_VEC, 0, 32)
REG32(POR_HNF_SLCWAY_PARTITION0_RNF_VEC_U_HNF_NID136, 0x1100c48)
REG32(POR_HNF_SLCWAY_PARTITION1_RNF_VEC_U_HNF_NID136, 0x1100c50)
REG32(POR_HNF_SLCWAY_PARTITION2_RNF_VEC_U_HNF_NID136, 0x1100c58)
REG32(POR_HNF_SLCWAY_PARTITION3_RNF_VEC_U_HNF_NID136, 0x1100c60)
REG32(POR_HNF_SLCWAY_PARTITION0_RNI_VEC_U_HNF_NID136, 0x1100c68)
    FIELD(POR_HNF_SLCWAY_PARTITION0_RNI_VEC_U_HNF_NID136, RESERVED_32, 32, 32)
    FIELD(POR_HNF_SLCWAY_PARTITION0_RNI_VEC_U_HNF_NID136, RNI_VEC0, 0, 32)
REG32(POR_HNF_SLCWAY_PARTITION1_RNI_VEC_U_HNF_NID136, 0x1100c70)
    FIELD(POR_HNF_SLCWAY_PARTITION1_RNI_VEC_U_HNF_NID136, RESERVED_32, 32, 32)
    FIELD(POR_HNF_SLCWAY_PARTITION1_RNI_VEC_U_HNF_NID136, RNI_VEC1, 0, 32)
REG32(POR_HNF_SLCWAY_PARTITION2_RNI_VEC_U_HNF_NID136, 0x1100c78)
    FIELD(POR_HNF_SLCWAY_PARTITION2_RNI_VEC_U_HNF_NID136, RESERVED_32, 32, 32)
    FIELD(POR_HNF_SLCWAY_PARTITION2_RNI_VEC_U_HNF_NID136, RNI_VEC2, 0, 32)
REG32(POR_HNF_SLCWAY_PARTITION3_RNI_VEC_U_HNF_NID136, 0x1100c80)
    FIELD(POR_HNF_SLCWAY_PARTITION3_RNI_VEC_U_HNF_NID136, RESERVED_32, 32, 32)
    FIELD(POR_HNF_SLCWAY_PARTITION3_RNI_VEC_U_HNF_NID136, RNI_VEC3, 0, 32)
REG32(POR_HNF_SLCWAY_PARTITION0_RND_VEC_U_HNF_NID136, 0x1100c88)
    FIELD(POR_HNF_SLCWAY_PARTITION0_RND_VEC_U_HNF_NID136, RESERVED_32, 32, 32)
    FIELD(POR_HNF_SLCWAY_PARTITION0_RND_VEC_U_HNF_NID136, RND_VEC0, 0, 32)
REG32(POR_HNF_SLCWAY_PARTITION1_RND_VEC_U_HNF_NID136, 0x1100c90)
    FIELD(POR_HNF_SLCWAY_PARTITION1_RND_VEC_U_HNF_NID136, RESERVED_32, 32, 32)
    FIELD(POR_HNF_SLCWAY_PARTITION1_RND_VEC_U_HNF_NID136, RND_VEC1, 0, 32)
REG32(POR_HNF_SLCWAY_PARTITION2_RND_VEC_U_HNF_NID136, 0x1100c98)
    FIELD(POR_HNF_SLCWAY_PARTITION2_RND_VEC_U_HNF_NID136, RESERVED_32, 32, 32)
    FIELD(POR_HNF_SLCWAY_PARTITION2_RND_VEC_U_HNF_NID136, RND_VEC2, 0, 32)
REG32(POR_HNF_SLCWAY_PARTITION3_RND_VEC_U_HNF_NID136, 0x1100ca0)
    FIELD(POR_HNF_SLCWAY_PARTITION3_RND_VEC_U_HNF_NID136, RESERVED_32, 32, 32)
    FIELD(POR_HNF_SLCWAY_PARTITION3_RND_VEC_U_HNF_NID136, RND_VEC3, 0, 32)
REG32(POR_HNF_RN_REGION_LOCK_U_HNF_NID136, 0x1100ca8)
    FIELD(POR_HNF_RN_REGION_LOCK_U_HNF_NID136, RN_PICK_LOCKED_WAYS_ONLY, 1, 1)
    FIELD(POR_HNF_RN_REGION_LOCK_U_HNF_NID136, RN_REGION_LOCK_EN, 0, 1)
REG32(POR_HNF_SLCWAY_PARTITION0_RNF_VEC1_U_HNF_NID136, 0x1100cb0)
REG32(POR_HNF_SLCWAY_PARTITION1_RNF_VEC1_U_HNF_NID136, 0x1100cb8)
REG32(POR_HNF_SLCWAY_PARTITION2_RNF_VEC1_U_HNF_NID136, 0x1100cc0)
REG32(POR_HNF_SLCWAY_PARTITION3_RNF_VEC1_U_HNF_NID136, 0x1100cc8)
REG32(POR_HNF_SAM_CONTROL_U_HNF_NID136, 0x1100d00)
    FIELD(POR_HNF_SAM_CONTROL_U_HNF_NID136, HN_CFG_SAM_INV_TOP_ADDRESS_BIT, 63, 1)
    FIELD(POR_HNF_SAM_CONTROL_U_HNF_NID136, RESERVED_62, 62, 1)
    FIELD(POR_HNF_SAM_CONTROL_U_HNF_NID136, HN_CFG_SAM_TOP_ADDRESS_BIT2, 56, 6)
    FIELD(POR_HNF_SAM_CONTROL_U_HNF_NID136, RESERVED_54, 54, 2)
    FIELD(POR_HNF_SAM_CONTROL_U_HNF_NID136, HN_CFG_SAM_TOP_ADDRESS_BIT1, 48, 6)
    FIELD(POR_HNF_SAM_CONTROL_U_HNF_NID136, RESERVED_46, 46, 2)
    FIELD(POR_HNF_SAM_CONTROL_U_HNF_NID136, HN_CFG_SAM_TOP_ADDRESS_BIT0, 40, 6)
    FIELD(POR_HNF_SAM_CONTROL_U_HNF_NID136, RESERVED_38, 38, 2)
    FIELD(POR_HNF_SAM_CONTROL_U_HNF_NID136, HN_CFG_SIX_SN_EN, 37, 1)
    FIELD(POR_HNF_SAM_CONTROL_U_HNF_NID136, HN_CFG_THREE_SN_EN, 36, 1)
    FIELD(POR_HNF_SAM_CONTROL_U_HNF_NID136, RESERVED_35, 35, 1)
    FIELD(POR_HNF_SAM_CONTROL_U_HNF_NID136, HN_CFG_SN2_NODEID, 24, 11)
    FIELD(POR_HNF_SAM_CONTROL_U_HNF_NID136, RESERVED_23, 23, 1)
    FIELD(POR_HNF_SAM_CONTROL_U_HNF_NID136, HN_CFG_SN1_NODEID, 12, 11)
    FIELD(POR_HNF_SAM_CONTROL_U_HNF_NID136, RESERVED_11, 11, 1)
    FIELD(POR_HNF_SAM_CONTROL_U_HNF_NID136, HN_CFG_SN0_NODEID, 0, 11)
REG32(POR_HNF_SAM_MEMREGION0_U_HNF_NID136, 0x1100d08)
    FIELD(POR_HNF_SAM_MEMREGION0_U_HNF_NID136, VALID, 63, 1)
    FIELD(POR_HNF_SAM_MEMREGION0_U_HNF_NID136, RESERVED_48, 48, 15)
    FIELD(POR_HNF_SAM_MEMREGION0_U_HNF_NID136, BASE_ADDR, 26, 22)
    FIELD(POR_HNF_SAM_MEMREGION0_U_HNF_NID136, RESERVED_17, 17, 9)
    FIELD(POR_HNF_SAM_MEMREGION0_U_HNF_NID136, SIZE, 12, 5)
    FIELD(POR_HNF_SAM_MEMREGION0_U_HNF_NID136, RESERVED_11, 11, 1)
    FIELD(POR_HNF_SAM_MEMREGION0_U_HNF_NID136, RANGE0_NODEID, 0, 11)
REG32(POR_HNF_SAM_MEMREGION1_U_HNF_NID136, 0x1100d10)
    FIELD(POR_HNF_SAM_MEMREGION1_U_HNF_NID136, VALID, 63, 1)
    FIELD(POR_HNF_SAM_MEMREGION1_U_HNF_NID136, RESERVED_48, 48, 15)
    FIELD(POR_HNF_SAM_MEMREGION1_U_HNF_NID136, BASE_ADDR, 26, 22)
    FIELD(POR_HNF_SAM_MEMREGION1_U_HNF_NID136, RESERVED_17, 17, 9)
    FIELD(POR_HNF_SAM_MEMREGION1_U_HNF_NID136, SIZE, 12, 5)
    FIELD(POR_HNF_SAM_MEMREGION1_U_HNF_NID136, RESERVED_11, 11, 1)
    FIELD(POR_HNF_SAM_MEMREGION1_U_HNF_NID136, RANGE1_NODEID, 0, 11)
REG32(POR_HNF_SAM_SN_PROPERTIES_U_HNF_NID136, 0x1100d18)
    FIELD(POR_HNF_SAM_SN_PROPERTIES_U_HNF_NID136, RESERVED_45, 45, 19)
    FIELD(POR_HNF_SAM_SN_PROPERTIES_U_HNF_NID136, RANGE1_SN_PCMO_PROP_DIS, 44, 1)
    FIELD(POR_HNF_SAM_SN_PROPERTIES_U_HNF_NID136, RANGE1_SN_CMO_PROP_EN, 43, 1)
    FIELD(POR_HNF_SAM_SN_PROPERTIES_U_HNF_NID136, RANGE1_SN_128B, 42, 1)
    FIELD(POR_HNF_SAM_SN_PROPERTIES_U_HNF_NID136, RESERVED_39, 39, 3)
    FIELD(POR_HNF_SAM_SN_PROPERTIES_U_HNF_NID136, RANGE0_SN_PCMO_PROP_DIS, 38, 1)
    FIELD(POR_HNF_SAM_SN_PROPERTIES_U_HNF_NID136, RANGE0_SN_CMO_PROP_EN, 37, 1)
    FIELD(POR_HNF_SAM_SN_PROPERTIES_U_HNF_NID136, RANGE0_SN_128B, 36, 1)
    FIELD(POR_HNF_SAM_SN_PROPERTIES_U_HNF_NID136, RESERVED_33, 33, 3)
    FIELD(POR_HNF_SAM_SN_PROPERTIES_U_HNF_NID136, SN5_PCMO_PROP_DIS, 32, 1)
    FIELD(POR_HNF_SAM_SN_PROPERTIES_U_HNF_NID136, SN5_CMO_PROP_EN, 31, 1)
    FIELD(POR_HNF_SAM_SN_PROPERTIES_U_HNF_NID136, SN5_128B, 30, 1)
    FIELD(POR_HNF_SAM_SN_PROPERTIES_U_HNF_NID136, RESERVED_27, 27, 3)
    FIELD(POR_HNF_SAM_SN_PROPERTIES_U_HNF_NID136, SN4_PCMO_PROP_DIS, 26, 1)
    FIELD(POR_HNF_SAM_SN_PROPERTIES_U_HNF_NID136, SN4_CMO_PROP_EN, 25, 1)
    FIELD(POR_HNF_SAM_SN_PROPERTIES_U_HNF_NID136, SN4_128B, 24, 1)
    FIELD(POR_HNF_SAM_SN_PROPERTIES_U_HNF_NID136, RESERVED_21, 21, 3)
    FIELD(POR_HNF_SAM_SN_PROPERTIES_U_HNF_NID136, SN3_PCMO_PROP_DIS, 20, 1)
    FIELD(POR_HNF_SAM_SN_PROPERTIES_U_HNF_NID136, SN3_CMO_PROP_EN, 19, 1)
    FIELD(POR_HNF_SAM_SN_PROPERTIES_U_HNF_NID136, SN3_128B, 18, 1)
    FIELD(POR_HNF_SAM_SN_PROPERTIES_U_HNF_NID136, RESERVED_15, 15, 3)
    FIELD(POR_HNF_SAM_SN_PROPERTIES_U_HNF_NID136, SN2_PCMO_PROP_DIS, 14, 1)
    FIELD(POR_HNF_SAM_SN_PROPERTIES_U_HNF_NID136, SN2_CMO_PROP_EN, 13, 1)
    FIELD(POR_HNF_SAM_SN_PROPERTIES_U_HNF_NID136, SN2_128B, 12, 1)
    FIELD(POR_HNF_SAM_SN_PROPERTIES_U_HNF_NID136, RESERVED_9, 9, 3)
    FIELD(POR_HNF_SAM_SN_PROPERTIES_U_HNF_NID136, SN1_PCMO_PROP_DIS, 8, 1)
    FIELD(POR_HNF_SAM_SN_PROPERTIES_U_HNF_NID136, SN1_CMO_PROP_EN, 7, 1)
    FIELD(POR_HNF_SAM_SN_PROPERTIES_U_HNF_NID136, SN1_128B, 6, 1)
    FIELD(POR_HNF_SAM_SN_PROPERTIES_U_HNF_NID136, SN0_PCMO_PROP_DIS, 2, 1)
    FIELD(POR_HNF_SAM_SN_PROPERTIES_U_HNF_NID136, SN0_CMO_PROP_EN, 1, 1)
    FIELD(POR_HNF_SAM_SN_PROPERTIES_U_HNF_NID136, SN0_128B, 0, 1)
REG32(POR_HNF_SAM_6SN_NODEID_U_HNF_NID136, 0x1100d20)
    FIELD(POR_HNF_SAM_6SN_NODEID_U_HNF_NID136, RESERVED_35, 35, 29)
    FIELD(POR_HNF_SAM_6SN_NODEID_U_HNF_NID136, HN_CFG_SN5_NODEID, 24, 11)
    FIELD(POR_HNF_SAM_6SN_NODEID_U_HNF_NID136, RESERVED_23, 23, 1)
    FIELD(POR_HNF_SAM_6SN_NODEID_U_HNF_NID136, HN_CFG_SN4_NODEID, 12, 11)
    FIELD(POR_HNF_SAM_6SN_NODEID_U_HNF_NID136, RESERVED_11, 11, 1)
    FIELD(POR_HNF_SAM_6SN_NODEID_U_HNF_NID136, HN_CFG_SN3_NODEID, 0, 11)
REG32(POR_HNF_RN_PHYS_ID0_U_HNF_NID136, 0x1100d28)
    FIELD(POR_HNF_RN_PHYS_ID0_U_HNF_NID136, VALID_RA1, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID0_U_HNF_NID136, CPA_EN_RA1, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID0_U_HNF_NID136, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID0_U_HNF_NID136, CPA_GRP_RA1, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID0_U_HNF_NID136, REMOTE_RA1, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID0_U_HNF_NID136, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID0_U_HNF_NID136, NODEID_RA1, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID0_U_HNF_NID136, VALID_RA0, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID0_U_HNF_NID136, CPA_EN_RA0, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID0_U_HNF_NID136, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID0_U_HNF_NID136, CPA_GRP_RA0, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID0_U_HNF_NID136, REMOTE_RA0, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID0_U_HNF_NID136, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID0_U_HNF_NID136, NODEID_RA0, 0, 11)
REG32(POR_HNF_RN_PHYS_ID1_U_HNF_NID136, 0x1100d30)
    FIELD(POR_HNF_RN_PHYS_ID1_U_HNF_NID136, VALID_RA3, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID1_U_HNF_NID136, CPA_EN_RA3, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID1_U_HNF_NID136, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID1_U_HNF_NID136, CPA_GRP_RA3, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID1_U_HNF_NID136, REMOTE_RA3, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID1_U_HNF_NID136, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID1_U_HNF_NID136, NODEID_RA3, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID1_U_HNF_NID136, VALID_RA2, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID1_U_HNF_NID136, CPA_EN_RA2, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID1_U_HNF_NID136, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID1_U_HNF_NID136, CPA_GRP_RA2, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID1_U_HNF_NID136, REMOTE_RA2, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID1_U_HNF_NID136, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID1_U_HNF_NID136, NODEID_RA2, 0, 11)
REG32(POR_HNF_RN_PHYS_ID2_U_HNF_NID136, 0x1100d38)
    FIELD(POR_HNF_RN_PHYS_ID2_U_HNF_NID136, VALID_RA5, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID2_U_HNF_NID136, CPA_EN_RA5, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID2_U_HNF_NID136, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID2_U_HNF_NID136, CPA_GRP_RA5, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID2_U_HNF_NID136, REMOTE_RA5, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID2_U_HNF_NID136, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID2_U_HNF_NID136, NODEID_RA5, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID2_U_HNF_NID136, VALID_RA4, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID2_U_HNF_NID136, CPA_EN_RA4, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID2_U_HNF_NID136, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID2_U_HNF_NID136, CPA_GRP_RA4, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID2_U_HNF_NID136, REMOTE_RA4, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID2_U_HNF_NID136, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID2_U_HNF_NID136, NODEID_RA4, 0, 11)
REG32(POR_HNF_RN_PHYS_ID3_U_HNF_NID136, 0x1100d40)
    FIELD(POR_HNF_RN_PHYS_ID3_U_HNF_NID136, VALID_RA7, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID3_U_HNF_NID136, CPA_EN_RA7, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID3_U_HNF_NID136, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID3_U_HNF_NID136, CPA_GRP_RA7, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID3_U_HNF_NID136, REMOTE_RA7, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID3_U_HNF_NID136, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID3_U_HNF_NID136, NODEID_RA7, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID3_U_HNF_NID136, VALID_RA6, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID3_U_HNF_NID136, CPA_EN_RA6, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID3_U_HNF_NID136, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID3_U_HNF_NID136, CPA_GRP_RA6, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID3_U_HNF_NID136, REMOTE_RA6, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID3_U_HNF_NID136, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID3_U_HNF_NID136, NODEID_RA6, 0, 11)
REG32(POR_HNF_RN_PHYS_ID4_U_HNF_NID136, 0x1100d48)
    FIELD(POR_HNF_RN_PHYS_ID4_U_HNF_NID136, VALID_RA9, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID4_U_HNF_NID136, CPA_EN_RA9, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID4_U_HNF_NID136, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID4_U_HNF_NID136, CPA_GRP_RA9, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID4_U_HNF_NID136, REMOTE_RA9, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID4_U_HNF_NID136, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID4_U_HNF_NID136, NODEID_RA9, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID4_U_HNF_NID136, VALID_RA8, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID4_U_HNF_NID136, CPA_EN_RA8, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID4_U_HNF_NID136, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID4_U_HNF_NID136, CPA_GRP_RA8, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID4_U_HNF_NID136, REMOTE_RA8, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID4_U_HNF_NID136, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID4_U_HNF_NID136, NODEID_RA8, 0, 11)
REG32(POR_HNF_RN_PHYS_ID5_U_HNF_NID136, 0x1100d50)
    FIELD(POR_HNF_RN_PHYS_ID5_U_HNF_NID136, VALID_RA11, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID5_U_HNF_NID136, CPA_EN_RA11, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID5_U_HNF_NID136, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID5_U_HNF_NID136, CPA_GRP_RA11, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID5_U_HNF_NID136, REMOTE_RA11, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID5_U_HNF_NID136, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID5_U_HNF_NID136, NODEID_RA11, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID5_U_HNF_NID136, VALID_RA10, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID5_U_HNF_NID136, CPA_EN_RA10, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID5_U_HNF_NID136, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID5_U_HNF_NID136, CPA_GRP_RA10, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID5_U_HNF_NID136, REMOTE_RA10, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID5_U_HNF_NID136, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID5_U_HNF_NID136, NODEID_RA10, 0, 11)
REG32(POR_HNF_RN_PHYS_ID6_U_HNF_NID136, 0x1100d58)
    FIELD(POR_HNF_RN_PHYS_ID6_U_HNF_NID136, VALID_RA13, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID6_U_HNF_NID136, CPA_EN_RA13, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID6_U_HNF_NID136, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID6_U_HNF_NID136, CPA_GRP_RA13, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID6_U_HNF_NID136, REMOTE_RA13, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID6_U_HNF_NID136, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID6_U_HNF_NID136, NODEID_RA13, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID6_U_HNF_NID136, VALID_RA12, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID6_U_HNF_NID136, CPA_EN_RA12, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID6_U_HNF_NID136, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID6_U_HNF_NID136, CPA_GRP_RA12, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID6_U_HNF_NID136, REMOTE_RA12, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID6_U_HNF_NID136, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID6_U_HNF_NID136, NODEID_RA12, 0, 11)
REG32(POR_HNF_RN_PHYS_ID7_U_HNF_NID136, 0x1100d60)
    FIELD(POR_HNF_RN_PHYS_ID7_U_HNF_NID136, VALID_RA15, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID7_U_HNF_NID136, CPA_EN_RA15, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID7_U_HNF_NID136, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID7_U_HNF_NID136, CPA_GRP_RA15, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID7_U_HNF_NID136, REMOTE_RA15, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID7_U_HNF_NID136, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID7_U_HNF_NID136, NODEID_RA15, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID7_U_HNF_NID136, VALID_RA14, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID7_U_HNF_NID136, CPA_EN_RA14, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID7_U_HNF_NID136, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID7_U_HNF_NID136, CPA_GRP_RA14, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID7_U_HNF_NID136, REMOTE_RA14, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID7_U_HNF_NID136, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID7_U_HNF_NID136, NODEID_RA14, 0, 11)
REG32(POR_HNF_RN_PHYS_ID8_U_HNF_NID136, 0x1100d68)
    FIELD(POR_HNF_RN_PHYS_ID8_U_HNF_NID136, VALID_RA17, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID8_U_HNF_NID136, CPA_EN_RA17, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID8_U_HNF_NID136, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID8_U_HNF_NID136, CPA_GRP_RA17, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID8_U_HNF_NID136, REMOTE_RA17, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID8_U_HNF_NID136, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID8_U_HNF_NID136, NODEID_RA17, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID8_U_HNF_NID136, VALID_RA16, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID8_U_HNF_NID136, CPA_EN_RA16, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID8_U_HNF_NID136, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID8_U_HNF_NID136, CPA_GRP_RA16, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID8_U_HNF_NID136, REMOTE_RA16, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID8_U_HNF_NID136, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID8_U_HNF_NID136, NODEID_RA16, 0, 11)
REG32(POR_HNF_RN_PHYS_ID9_U_HNF_NID136, 0x1100d70)
    FIELD(POR_HNF_RN_PHYS_ID9_U_HNF_NID136, VALID_RA19, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID9_U_HNF_NID136, CPA_EN_RA19, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID9_U_HNF_NID136, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID9_U_HNF_NID136, CPA_GRP_RA19, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID9_U_HNF_NID136, REMOTE_RA19, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID9_U_HNF_NID136, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID9_U_HNF_NID136, NODEID_RA19, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID9_U_HNF_NID136, VALID_RA18, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID9_U_HNF_NID136, CPA_EN_RA18, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID9_U_HNF_NID136, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID9_U_HNF_NID136, CPA_GRP_RA18, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID9_U_HNF_NID136, REMOTE_RA18, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID9_U_HNF_NID136, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID9_U_HNF_NID136, NODEID_RA18, 0, 11)
REG32(POR_HNF_RN_PHYS_ID10_U_HNF_NID136, 0x1100d78)
    FIELD(POR_HNF_RN_PHYS_ID10_U_HNF_NID136, VALID_RA21, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID10_U_HNF_NID136, CPA_EN_RA21, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID10_U_HNF_NID136, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID10_U_HNF_NID136, CPA_GRP_RA21, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID10_U_HNF_NID136, REMOTE_RA21, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID10_U_HNF_NID136, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID10_U_HNF_NID136, NODEID_RA21, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID10_U_HNF_NID136, VALID_RA20, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID10_U_HNF_NID136, CPA_EN_RA20, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID10_U_HNF_NID136, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID10_U_HNF_NID136, CPA_GRP_RA20, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID10_U_HNF_NID136, REMOTE_RA20, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID10_U_HNF_NID136, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID10_U_HNF_NID136, NODEID_RA20, 0, 11)
REG32(POR_HNF_RN_PHYS_ID11_U_HNF_NID136, 0x1100d80)
    FIELD(POR_HNF_RN_PHYS_ID11_U_HNF_NID136, VALID_RA23, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID11_U_HNF_NID136, CPA_EN_RA23, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID11_U_HNF_NID136, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID11_U_HNF_NID136, CPA_GRP_RA23, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID11_U_HNF_NID136, REMOTE_RA23, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID11_U_HNF_NID136, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID11_U_HNF_NID136, NODEID_RA23, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID11_U_HNF_NID136, VALID_RA22, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID11_U_HNF_NID136, CPA_EN_RA22, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID11_U_HNF_NID136, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID11_U_HNF_NID136, CPA_GRP_RA22, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID11_U_HNF_NID136, REMOTE_RA22, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID11_U_HNF_NID136, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID11_U_HNF_NID136, NODEID_RA22, 0, 11)
REG32(POR_HNF_RN_PHYS_ID12_U_HNF_NID136, 0x1100d88)
    FIELD(POR_HNF_RN_PHYS_ID12_U_HNF_NID136, VALID_RA25, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID12_U_HNF_NID136, CPA_EN_RA25, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID12_U_HNF_NID136, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID12_U_HNF_NID136, CPA_GRP_RA25, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID12_U_HNF_NID136, REMOTE_RA25, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID12_U_HNF_NID136, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID12_U_HNF_NID136, NODEID_RA25, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID12_U_HNF_NID136, VALID_RA24, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID12_U_HNF_NID136, CPA_EN_RA24, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID12_U_HNF_NID136, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID12_U_HNF_NID136, CPA_GRP_RA24, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID12_U_HNF_NID136, REMOTE_RA24, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID12_U_HNF_NID136, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID12_U_HNF_NID136, NODEID_RA24, 0, 11)
REG32(POR_HNF_RN_PHYS_ID13_U_HNF_NID136, 0x1100d90)
    FIELD(POR_HNF_RN_PHYS_ID13_U_HNF_NID136, VALID_RA27, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID13_U_HNF_NID136, CPA_EN_RA27, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID13_U_HNF_NID136, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID13_U_HNF_NID136, CPA_GRP_RA27, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID13_U_HNF_NID136, REMOTE_RA27, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID13_U_HNF_NID136, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID13_U_HNF_NID136, NODEID_RA27, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID13_U_HNF_NID136, VALID_RA26, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID13_U_HNF_NID136, CPA_EN_RA26, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID13_U_HNF_NID136, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID13_U_HNF_NID136, CPA_GRP_RA26, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID13_U_HNF_NID136, REMOTE_RA26, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID13_U_HNF_NID136, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID13_U_HNF_NID136, NODEID_RA26, 0, 11)
REG32(POR_HNF_RN_PHYS_ID14_U_HNF_NID136, 0x1100d98)
    FIELD(POR_HNF_RN_PHYS_ID14_U_HNF_NID136, VALID_RA29, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID14_U_HNF_NID136, CPA_EN_RA29, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID14_U_HNF_NID136, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID14_U_HNF_NID136, CPA_GRP_RA29, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID14_U_HNF_NID136, REMOTE_RA29, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID14_U_HNF_NID136, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID14_U_HNF_NID136, NODEID_RA29, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID14_U_HNF_NID136, VALID_RA28, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID14_U_HNF_NID136, CPA_EN_RA28, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID14_U_HNF_NID136, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID14_U_HNF_NID136, CPA_GRP_RA28, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID14_U_HNF_NID136, REMOTE_RA28, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID14_U_HNF_NID136, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID14_U_HNF_NID136, NODEID_RA28, 0, 11)
REG32(POR_HNF_RN_PHYS_ID15_U_HNF_NID136, 0x1100da0)
    FIELD(POR_HNF_RN_PHYS_ID15_U_HNF_NID136, VALID_RA31, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID15_U_HNF_NID136, CPA_EN_RA31, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID15_U_HNF_NID136, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID15_U_HNF_NID136, CPA_GRP_RA31, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID15_U_HNF_NID136, REMOTE_RA31, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID15_U_HNF_NID136, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID15_U_HNF_NID136, NODEID_RA31, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID15_U_HNF_NID136, VALID_RA30, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID15_U_HNF_NID136, CPA_EN_RA30, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID15_U_HNF_NID136, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID15_U_HNF_NID136, CPA_GRP_RA30, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID15_U_HNF_NID136, REMOTE_RA30, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID15_U_HNF_NID136, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID15_U_HNF_NID136, NODEID_RA30, 0, 11)
REG32(POR_HNF_RN_PHYS_ID16_U_HNF_NID136, 0x1100da8)
    FIELD(POR_HNF_RN_PHYS_ID16_U_HNF_NID136, VALID_RA33, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID16_U_HNF_NID136, CPA_EN_RA33, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID16_U_HNF_NID136, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID16_U_HNF_NID136, CPA_GRP_RA33, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID16_U_HNF_NID136, REMOTE_RA33, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID16_U_HNF_NID136, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID16_U_HNF_NID136, NODEID_RA33, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID16_U_HNF_NID136, VALID_RA32, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID16_U_HNF_NID136, CPA_EN_RA32, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID16_U_HNF_NID136, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID16_U_HNF_NID136, CPA_GRP_RA32, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID16_U_HNF_NID136, REMOTE_RA32, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID16_U_HNF_NID136, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID16_U_HNF_NID136, NODEID_RA32, 0, 11)
REG32(POR_HNF_RN_PHYS_ID17_U_HNF_NID136, 0x1100db0)
    FIELD(POR_HNF_RN_PHYS_ID17_U_HNF_NID136, VALID_RA35, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID17_U_HNF_NID136, CPA_EN_RA35, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID17_U_HNF_NID136, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID17_U_HNF_NID136, CPA_GRP_RA35, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID17_U_HNF_NID136, REMOTE_RA35, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID17_U_HNF_NID136, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID17_U_HNF_NID136, NODEID_RA35, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID17_U_HNF_NID136, VALID_RA34, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID17_U_HNF_NID136, CPA_EN_RA34, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID17_U_HNF_NID136, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID17_U_HNF_NID136, CPA_GRP_RA34, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID17_U_HNF_NID136, REMOTE_RA34, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID17_U_HNF_NID136, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID17_U_HNF_NID136, NODEID_RA34, 0, 11)
REG32(POR_HNF_RN_PHYS_ID18_U_HNF_NID136, 0x1100db8)
    FIELD(POR_HNF_RN_PHYS_ID18_U_HNF_NID136, VALID_RA37, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID18_U_HNF_NID136, CPA_EN_RA37, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID18_U_HNF_NID136, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID18_U_HNF_NID136, CPA_GRP_RA37, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID18_U_HNF_NID136, REMOTE_RA37, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID18_U_HNF_NID136, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID18_U_HNF_NID136, NODEID_RA37, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID18_U_HNF_NID136, VALID_RA36, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID18_U_HNF_NID136, CPA_EN_RA36, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID18_U_HNF_NID136, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID18_U_HNF_NID136, CPA_GRP_RA36, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID18_U_HNF_NID136, REMOTE_RA36, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID18_U_HNF_NID136, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID18_U_HNF_NID136, NODEID_RA36, 0, 11)
REG32(POR_HNF_RN_PHYS_ID19_U_HNF_NID136, 0x1100dc0)
    FIELD(POR_HNF_RN_PHYS_ID19_U_HNF_NID136, VALID_RA39, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID19_U_HNF_NID136, CPA_EN_RA39, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID19_U_HNF_NID136, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID19_U_HNF_NID136, CPA_GRP_RA39, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID19_U_HNF_NID136, REMOTE_RA39, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID19_U_HNF_NID136, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID19_U_HNF_NID136, NODEID_RA39, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID19_U_HNF_NID136, VALID_RA38, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID19_U_HNF_NID136, CPA_EN_RA38, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID19_U_HNF_NID136, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID19_U_HNF_NID136, CPA_GRP_RA38, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID19_U_HNF_NID136, REMOTE_RA38, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID19_U_HNF_NID136, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID19_U_HNF_NID136, NODEID_RA38, 0, 11)
REG32(POR_HNF_RN_PHYS_ID20_U_HNF_NID136, 0x1100dc8)
    FIELD(POR_HNF_RN_PHYS_ID20_U_HNF_NID136, VALID_RA41, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID20_U_HNF_NID136, CPA_EN_RA41, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID20_U_HNF_NID136, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID20_U_HNF_NID136, CPA_GRP_RA41, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID20_U_HNF_NID136, REMOTE_RA41, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID20_U_HNF_NID136, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID20_U_HNF_NID136, NODEID_RA41, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID20_U_HNF_NID136, VALID_RA40, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID20_U_HNF_NID136, CPA_EN_RA40, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID20_U_HNF_NID136, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID20_U_HNF_NID136, CPA_GRP_RA40, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID20_U_HNF_NID136, REMOTE_RA40, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID20_U_HNF_NID136, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID20_U_HNF_NID136, NODEID_RA40, 0, 11)
REG32(POR_HNF_RN_PHYS_ID21_U_HNF_NID136, 0x1100dd0)
    FIELD(POR_HNF_RN_PHYS_ID21_U_HNF_NID136, VALID_RA43, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID21_U_HNF_NID136, CPA_EN_RA43, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID21_U_HNF_NID136, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID21_U_HNF_NID136, CPA_GRP_RA43, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID21_U_HNF_NID136, REMOTE_RA43, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID21_U_HNF_NID136, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID21_U_HNF_NID136, NODEID_RA43, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID21_U_HNF_NID136, VALID_RA42, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID21_U_HNF_NID136, CPA_EN_RA42, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID21_U_HNF_NID136, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID21_U_HNF_NID136, CPA_GRP_RA42, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID21_U_HNF_NID136, REMOTE_RA42, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID21_U_HNF_NID136, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID21_U_HNF_NID136, NODEID_RA42, 0, 11)
REG32(POR_HNF_RN_PHYS_ID22_U_HNF_NID136, 0x1100dd8)
    FIELD(POR_HNF_RN_PHYS_ID22_U_HNF_NID136, VALID_RA45, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID22_U_HNF_NID136, CPA_EN_RA45, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID22_U_HNF_NID136, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID22_U_HNF_NID136, CPA_GRP_RA45, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID22_U_HNF_NID136, REMOTE_RA45, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID22_U_HNF_NID136, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID22_U_HNF_NID136, NODEID_RA45, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID22_U_HNF_NID136, VALID_RA44, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID22_U_HNF_NID136, CPA_EN_RA44, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID22_U_HNF_NID136, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID22_U_HNF_NID136, CPA_GRP_RA44, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID22_U_HNF_NID136, REMOTE_RA44, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID22_U_HNF_NID136, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID22_U_HNF_NID136, NODEID_RA44, 0, 11)
REG32(POR_HNF_RN_PHYS_ID23_U_HNF_NID136, 0x1100de0)
    FIELD(POR_HNF_RN_PHYS_ID23_U_HNF_NID136, VALID_RA47, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID23_U_HNF_NID136, CPA_EN_RA47, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID23_U_HNF_NID136, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID23_U_HNF_NID136, CPA_GRP_RA47, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID23_U_HNF_NID136, REMOTE_RA47, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID23_U_HNF_NID136, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID23_U_HNF_NID136, NODEID_RA47, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID23_U_HNF_NID136, VALID_RA46, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID23_U_HNF_NID136, CPA_EN_RA46, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID23_U_HNF_NID136, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID23_U_HNF_NID136, CPA_GRP_RA46, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID23_U_HNF_NID136, REMOTE_RA46, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID23_U_HNF_NID136, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID23_U_HNF_NID136, NODEID_RA46, 0, 11)
REG32(POR_HNF_RN_PHYS_ID24_U_HNF_NID136, 0x1100de8)
    FIELD(POR_HNF_RN_PHYS_ID24_U_HNF_NID136, VALID_RA49, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID24_U_HNF_NID136, CPA_EN_RA49, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID24_U_HNF_NID136, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID24_U_HNF_NID136, CPA_GRP_RA49, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID24_U_HNF_NID136, REMOTE_RA49, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID24_U_HNF_NID136, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID24_U_HNF_NID136, NODEID_RA49, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID24_U_HNF_NID136, VALID_RA48, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID24_U_HNF_NID136, CPA_EN_RA48, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID24_U_HNF_NID136, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID24_U_HNF_NID136, CPA_GRP_RA48, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID24_U_HNF_NID136, REMOTE_RA48, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID24_U_HNF_NID136, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID24_U_HNF_NID136, NODEID_RA48, 0, 11)
REG32(POR_HNF_RN_PHYS_ID25_U_HNF_NID136, 0x1100df0)
    FIELD(POR_HNF_RN_PHYS_ID25_U_HNF_NID136, VALID_RA51, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID25_U_HNF_NID136, CPA_EN_RA51, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID25_U_HNF_NID136, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID25_U_HNF_NID136, CPA_GRP_RA51, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID25_U_HNF_NID136, REMOTE_RA51, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID25_U_HNF_NID136, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID25_U_HNF_NID136, NODEID_RA51, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID25_U_HNF_NID136, VALID_RA50, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID25_U_HNF_NID136, CPA_EN_RA50, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID25_U_HNF_NID136, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID25_U_HNF_NID136, CPA_GRP_RA50, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID25_U_HNF_NID136, REMOTE_RA50, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID25_U_HNF_NID136, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID25_U_HNF_NID136, NODEID_RA50, 0, 11)
REG32(POR_HNF_RN_PHYS_ID26_U_HNF_NID136, 0x1100df8)
    FIELD(POR_HNF_RN_PHYS_ID26_U_HNF_NID136, VALID_RA53, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID26_U_HNF_NID136, CPA_EN_RA53, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID26_U_HNF_NID136, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID26_U_HNF_NID136, CPA_GRP_RA53, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID26_U_HNF_NID136, REMOTE_RA53, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID26_U_HNF_NID136, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID26_U_HNF_NID136, NODEID_RA53, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID26_U_HNF_NID136, VALID_RA52, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID26_U_HNF_NID136, CPA_EN_RA52, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID26_U_HNF_NID136, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID26_U_HNF_NID136, CPA_GRP_RA52, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID26_U_HNF_NID136, REMOTE_RA52, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID26_U_HNF_NID136, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID26_U_HNF_NID136, NODEID_RA52, 0, 11)
REG32(POR_HNF_RN_PHYS_ID27_U_HNF_NID136, 0x1100e00)
    FIELD(POR_HNF_RN_PHYS_ID27_U_HNF_NID136, VALID_RA55, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID27_U_HNF_NID136, CPA_EN_RA55, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID27_U_HNF_NID136, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID27_U_HNF_NID136, CPA_GRP_RA55, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID27_U_HNF_NID136, REMOTE_RA55, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID27_U_HNF_NID136, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID27_U_HNF_NID136, NODEID_RA55, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID27_U_HNF_NID136, VALID_RA54, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID27_U_HNF_NID136, CPA_EN_RA54, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID27_U_HNF_NID136, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID27_U_HNF_NID136, CPA_GRP_RA54, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID27_U_HNF_NID136, REMOTE_RA54, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID27_U_HNF_NID136, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID27_U_HNF_NID136, NODEID_RA54, 0, 11)
REG32(POR_HNF_RN_PHYS_ID28_U_HNF_NID136, 0x1100e08)
    FIELD(POR_HNF_RN_PHYS_ID28_U_HNF_NID136, VALID_RA57, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID28_U_HNF_NID136, CPA_EN_RA57, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID28_U_HNF_NID136, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID28_U_HNF_NID136, CPA_GRP_RA57, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID28_U_HNF_NID136, REMOTE_RA57, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID28_U_HNF_NID136, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID28_U_HNF_NID136, NODEID_RA57, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID28_U_HNF_NID136, VALID_RA56, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID28_U_HNF_NID136, CPA_EN_RA56, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID28_U_HNF_NID136, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID28_U_HNF_NID136, CPA_GRP_RA56, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID28_U_HNF_NID136, REMOTE_RA56, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID28_U_HNF_NID136, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID28_U_HNF_NID136, NODEID_RA56, 0, 11)
REG32(POR_HNF_RN_PHYS_ID29_U_HNF_NID136, 0x1100e10)
    FIELD(POR_HNF_RN_PHYS_ID29_U_HNF_NID136, VALID_RA59, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID29_U_HNF_NID136, CPA_EN_RA59, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID29_U_HNF_NID136, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID29_U_HNF_NID136, CPA_GRP_RA59, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID29_U_HNF_NID136, REMOTE_RA59, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID29_U_HNF_NID136, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID29_U_HNF_NID136, NODEID_RA59, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID29_U_HNF_NID136, VALID_RA58, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID29_U_HNF_NID136, CPA_EN_RA58, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID29_U_HNF_NID136, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID29_U_HNF_NID136, CPA_GRP_RA58, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID29_U_HNF_NID136, REMOTE_RA58, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID29_U_HNF_NID136, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID29_U_HNF_NID136, NODEID_RA58, 0, 11)
REG32(POR_HNF_RN_PHYS_ID30_U_HNF_NID136, 0x1100e18)
    FIELD(POR_HNF_RN_PHYS_ID30_U_HNF_NID136, VALID_RA61, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID30_U_HNF_NID136, CPA_EN_RA61, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID30_U_HNF_NID136, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID30_U_HNF_NID136, CPA_GRP_RA61, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID30_U_HNF_NID136, REMOTE_RA61, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID30_U_HNF_NID136, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID30_U_HNF_NID136, NODEID_RA61, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID30_U_HNF_NID136, VALID_RA60, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID30_U_HNF_NID136, CPA_EN_RA60, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID30_U_HNF_NID136, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID30_U_HNF_NID136, CPA_GRP_RA60, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID30_U_HNF_NID136, REMOTE_RA60, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID30_U_HNF_NID136, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID30_U_HNF_NID136, NODEID_RA60, 0, 11)
REG32(POR_HNF_RN_PHYS_ID31_U_HNF_NID136, 0x1100e20)
    FIELD(POR_HNF_RN_PHYS_ID31_U_HNF_NID136, VALID_RA63, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID31_U_HNF_NID136, CPA_EN_RA63, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID31_U_HNF_NID136, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID31_U_HNF_NID136, CPA_GRP_RA63, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID31_U_HNF_NID136, REMOTE_RA63, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID31_U_HNF_NID136, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID31_U_HNF_NID136, NODEID_RA63, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID31_U_HNF_NID136, VALID_RA62, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID31_U_HNF_NID136, CPA_EN_RA62, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID31_U_HNF_NID136, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID31_U_HNF_NID136, CPA_GRP_RA62, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID31_U_HNF_NID136, REMOTE_RA62, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID31_U_HNF_NID136, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID31_U_HNF_NID136, NODEID_RA62, 0, 11)
REG32(POR_HNF_RN_PHYS_ID32_U_HNF_NID136, 0x1100e28)
    FIELD(POR_HNF_RN_PHYS_ID32_U_HNF_NID136, VALID_RA65, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID32_U_HNF_NID136, CPA_EN_RA65, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID32_U_HNF_NID136, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID32_U_HNF_NID136, CPA_GRP_RA65, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID32_U_HNF_NID136, REMOTE_RA65, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID32_U_HNF_NID136, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID32_U_HNF_NID136, NODEID_RA65, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID32_U_HNF_NID136, VALID_RA64, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID32_U_HNF_NID136, CPA_EN_RA64, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID32_U_HNF_NID136, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID32_U_HNF_NID136, CPA_GRP_RA64, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID32_U_HNF_NID136, REMOTE_RA64, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID32_U_HNF_NID136, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID32_U_HNF_NID136, NODEID_RA64, 0, 11)
REG32(POR_HNF_RN_PHYS_ID33_U_HNF_NID136, 0x1100e30)
    FIELD(POR_HNF_RN_PHYS_ID33_U_HNF_NID136, VALID_RA67, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID33_U_HNF_NID136, CPA_EN_RA67, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID33_U_HNF_NID136, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID33_U_HNF_NID136, CPA_GRP_RA67, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID33_U_HNF_NID136, REMOTE_RA67, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID33_U_HNF_NID136, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID33_U_HNF_NID136, NODEID_RA67, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID33_U_HNF_NID136, VALID_RA66, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID33_U_HNF_NID136, CPA_EN_RA66, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID33_U_HNF_NID136, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID33_U_HNF_NID136, CPA_GRP_RA66, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID33_U_HNF_NID136, REMOTE_RA66, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID33_U_HNF_NID136, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID33_U_HNF_NID136, NODEID_RA66, 0, 11)
REG32(POR_HNF_RN_PHYS_ID34_U_HNF_NID136, 0x1100e38)
    FIELD(POR_HNF_RN_PHYS_ID34_U_HNF_NID136, VALID_RA69, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID34_U_HNF_NID136, CPA_EN_RA69, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID34_U_HNF_NID136, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID34_U_HNF_NID136, CPA_GRP_RA69, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID34_U_HNF_NID136, REMOTE_RA69, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID34_U_HNF_NID136, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID34_U_HNF_NID136, NODEID_RA69, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID34_U_HNF_NID136, VALID_RA68, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID34_U_HNF_NID136, CPA_EN_RA68, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID34_U_HNF_NID136, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID34_U_HNF_NID136, CPA_GRP_RA68, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID34_U_HNF_NID136, REMOTE_RA68, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID34_U_HNF_NID136, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID34_U_HNF_NID136, NODEID_RA68, 0, 11)
REG32(POR_HNF_RN_PHYS_ID35_U_HNF_NID136, 0x1100e40)
    FIELD(POR_HNF_RN_PHYS_ID35_U_HNF_NID136, VALID_RA71, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID35_U_HNF_NID136, CPA_EN_RA71, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID35_U_HNF_NID136, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID35_U_HNF_NID136, CPA_GRP_RA71, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID35_U_HNF_NID136, REMOTE_RA71, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID35_U_HNF_NID136, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID35_U_HNF_NID136, NODEID_RA71, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID35_U_HNF_NID136, VALID_RA70, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID35_U_HNF_NID136, CPA_EN_RA70, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID35_U_HNF_NID136, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID35_U_HNF_NID136, CPA_GRP_RA70, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID35_U_HNF_NID136, REMOTE_RA70, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID35_U_HNF_NID136, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID35_U_HNF_NID136, NODEID_RA70, 0, 11)
REG32(POR_HNF_RN_PHYS_ID36_U_HNF_NID136, 0x1100e48)
    FIELD(POR_HNF_RN_PHYS_ID36_U_HNF_NID136, VALID_RA73, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID36_U_HNF_NID136, CPA_EN_RA73, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID36_U_HNF_NID136, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID36_U_HNF_NID136, CPA_GRP_RA73, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID36_U_HNF_NID136, REMOTE_RA73, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID36_U_HNF_NID136, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID36_U_HNF_NID136, NODEID_RA73, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID36_U_HNF_NID136, VALID_RA72, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID36_U_HNF_NID136, CPA_EN_RA72, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID36_U_HNF_NID136, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID36_U_HNF_NID136, CPA_GRP_RA72, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID36_U_HNF_NID136, REMOTE_RA72, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID36_U_HNF_NID136, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID36_U_HNF_NID136, NODEID_RA72, 0, 11)
REG32(POR_HNF_RN_PHYS_ID37_U_HNF_NID136, 0x1100e50)
    FIELD(POR_HNF_RN_PHYS_ID37_U_HNF_NID136, VALID_RA75, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID37_U_HNF_NID136, CPA_EN_RA75, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID37_U_HNF_NID136, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID37_U_HNF_NID136, CPA_GRP_RA75, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID37_U_HNF_NID136, REMOTE_RA75, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID37_U_HNF_NID136, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID37_U_HNF_NID136, NODEID_RA75, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID37_U_HNF_NID136, VALID_RA74, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID37_U_HNF_NID136, CPA_EN_RA74, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID37_U_HNF_NID136, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID37_U_HNF_NID136, CPA_GRP_RA74, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID37_U_HNF_NID136, REMOTE_RA74, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID37_U_HNF_NID136, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID37_U_HNF_NID136, NODEID_RA74, 0, 11)
REG32(POR_HNF_RN_PHYS_ID38_U_HNF_NID136, 0x1100e58)
    FIELD(POR_HNF_RN_PHYS_ID38_U_HNF_NID136, VALID_RA77, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID38_U_HNF_NID136, CPA_EN_RA77, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID38_U_HNF_NID136, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID38_U_HNF_NID136, CPA_GRP_RA77, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID38_U_HNF_NID136, REMOTE_RA77, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID38_U_HNF_NID136, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID38_U_HNF_NID136, NODEID_RA77, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID38_U_HNF_NID136, VALID_RA76, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID38_U_HNF_NID136, CPA_EN_RA76, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID38_U_HNF_NID136, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID38_U_HNF_NID136, CPA_GRP_RA76, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID38_U_HNF_NID136, REMOTE_RA76, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID38_U_HNF_NID136, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID38_U_HNF_NID136, NODEID_RA76, 0, 11)
REG32(POR_HNF_RN_PHYS_ID39_U_HNF_NID136, 0x1100e60)
    FIELD(POR_HNF_RN_PHYS_ID39_U_HNF_NID136, VALID_RA79, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID39_U_HNF_NID136, CPA_EN_RA79, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID39_U_HNF_NID136, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID39_U_HNF_NID136, CPA_GRP_RA79, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID39_U_HNF_NID136, REMOTE_RA79, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID39_U_HNF_NID136, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID39_U_HNF_NID136, NODEID_RA79, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID39_U_HNF_NID136, VALID_RA78, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID39_U_HNF_NID136, CPA_EN_RA78, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID39_U_HNF_NID136, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID39_U_HNF_NID136, CPA_GRP_RA78, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID39_U_HNF_NID136, REMOTE_RA78, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID39_U_HNF_NID136, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID39_U_HNF_NID136, NODEID_RA78, 0, 11)
REG32(POR_HNF_RN_PHYS_ID40_U_HNF_NID136, 0x1100e68)
    FIELD(POR_HNF_RN_PHYS_ID40_U_HNF_NID136, VALID_RA81, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID40_U_HNF_NID136, CPA_EN_RA81, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID40_U_HNF_NID136, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID40_U_HNF_NID136, CPA_GRP_RA81, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID40_U_HNF_NID136, REMOTE_RA81, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID40_U_HNF_NID136, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID40_U_HNF_NID136, NODEID_RA81, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID40_U_HNF_NID136, VALID_RA80, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID40_U_HNF_NID136, CPA_EN_RA80, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID40_U_HNF_NID136, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID40_U_HNF_NID136, CPA_GRP_RA80, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID40_U_HNF_NID136, REMOTE_RA80, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID40_U_HNF_NID136, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID40_U_HNF_NID136, NODEID_RA80, 0, 11)
REG32(POR_HNF_RN_PHYS_ID41_U_HNF_NID136, 0x1100e70)
    FIELD(POR_HNF_RN_PHYS_ID41_U_HNF_NID136, VALID_RA83, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID41_U_HNF_NID136, CPA_EN_RA83, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID41_U_HNF_NID136, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID41_U_HNF_NID136, CPA_GRP_RA83, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID41_U_HNF_NID136, REMOTE_RA83, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID41_U_HNF_NID136, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID41_U_HNF_NID136, NODEID_RA83, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID41_U_HNF_NID136, VALID_RA82, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID41_U_HNF_NID136, CPA_EN_RA82, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID41_U_HNF_NID136, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID41_U_HNF_NID136, CPA_GRP_RA82, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID41_U_HNF_NID136, REMOTE_RA82, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID41_U_HNF_NID136, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID41_U_HNF_NID136, NODEID_RA82, 0, 11)
REG32(POR_HNF_RN_PHYS_ID42_U_HNF_NID136, 0x1100e78)
    FIELD(POR_HNF_RN_PHYS_ID42_U_HNF_NID136, VALID_RA85, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID42_U_HNF_NID136, CPA_EN_RA85, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID42_U_HNF_NID136, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID42_U_HNF_NID136, CPA_GRP_RA85, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID42_U_HNF_NID136, REMOTE_RA85, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID42_U_HNF_NID136, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID42_U_HNF_NID136, NODEID_RA85, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID42_U_HNF_NID136, VALID_RA84, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID42_U_HNF_NID136, CPA_EN_RA84, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID42_U_HNF_NID136, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID42_U_HNF_NID136, CPA_GRP_RA84, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID42_U_HNF_NID136, REMOTE_RA84, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID42_U_HNF_NID136, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID42_U_HNF_NID136, NODEID_RA84, 0, 11)
REG32(POR_HNF_RN_PHYS_ID43_U_HNF_NID136, 0x1100e80)
    FIELD(POR_HNF_RN_PHYS_ID43_U_HNF_NID136, VALID_RA87, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID43_U_HNF_NID136, CPA_EN_RA87, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID43_U_HNF_NID136, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID43_U_HNF_NID136, CPA_GRP_RA87, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID43_U_HNF_NID136, REMOTE_RA87, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID43_U_HNF_NID136, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID43_U_HNF_NID136, NODEID_RA87, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID43_U_HNF_NID136, VALID_RA86, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID43_U_HNF_NID136, CPA_EN_RA86, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID43_U_HNF_NID136, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID43_U_HNF_NID136, CPA_GRP_RA86, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID43_U_HNF_NID136, REMOTE_RA86, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID43_U_HNF_NID136, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID43_U_HNF_NID136, NODEID_RA86, 0, 11)
REG32(POR_HNF_RN_PHYS_ID44_U_HNF_NID136, 0x1100e88)
    FIELD(POR_HNF_RN_PHYS_ID44_U_HNF_NID136, VALID_RA89, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID44_U_HNF_NID136, CPA_EN_RA89, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID44_U_HNF_NID136, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID44_U_HNF_NID136, CPA_GRP_RA89, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID44_U_HNF_NID136, REMOTE_RA89, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID44_U_HNF_NID136, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID44_U_HNF_NID136, NODEID_RA89, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID44_U_HNF_NID136, VALID_RA88, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID44_U_HNF_NID136, CPA_EN_RA88, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID44_U_HNF_NID136, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID44_U_HNF_NID136, CPA_GRP_RA88, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID44_U_HNF_NID136, REMOTE_RA88, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID44_U_HNF_NID136, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID44_U_HNF_NID136, NODEID_RA88, 0, 11)
REG32(POR_HNF_RN_PHYS_ID45_U_HNF_NID136, 0x1100e90)
    FIELD(POR_HNF_RN_PHYS_ID45_U_HNF_NID136, VALID_RA91, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID45_U_HNF_NID136, CPA_EN_RA91, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID45_U_HNF_NID136, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID45_U_HNF_NID136, CPA_GRP_RA91, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID45_U_HNF_NID136, REMOTE_RA91, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID45_U_HNF_NID136, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID45_U_HNF_NID136, NODEID_RA91, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID45_U_HNF_NID136, VALID_RA90, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID45_U_HNF_NID136, CPA_EN_RA90, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID45_U_HNF_NID136, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID45_U_HNF_NID136, CPA_GRP_RA90, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID45_U_HNF_NID136, REMOTE_RA90, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID45_U_HNF_NID136, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID45_U_HNF_NID136, NODEID_RA90, 0, 11)
REG32(POR_HNF_RN_PHYS_ID46_U_HNF_NID136, 0x1100e98)
    FIELD(POR_HNF_RN_PHYS_ID46_U_HNF_NID136, VALID_RA93, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID46_U_HNF_NID136, CPA_EN_RA93, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID46_U_HNF_NID136, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID46_U_HNF_NID136, CPA_GRP_RA93, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID46_U_HNF_NID136, REMOTE_RA93, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID46_U_HNF_NID136, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID46_U_HNF_NID136, NODEID_RA93, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID46_U_HNF_NID136, VALID_RA92, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID46_U_HNF_NID136, CPA_EN_RA92, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID46_U_HNF_NID136, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID46_U_HNF_NID136, CPA_GRP_RA92, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID46_U_HNF_NID136, REMOTE_RA92, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID46_U_HNF_NID136, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID46_U_HNF_NID136, NODEID_RA92, 0, 11)
REG32(POR_HNF_RN_PHYS_ID47_U_HNF_NID136, 0x1100ea0)
    FIELD(POR_HNF_RN_PHYS_ID47_U_HNF_NID136, VALID_RA95, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID47_U_HNF_NID136, CPA_EN_RA95, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID47_U_HNF_NID136, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID47_U_HNF_NID136, CPA_GRP_RA95, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID47_U_HNF_NID136, REMOTE_RA95, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID47_U_HNF_NID136, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID47_U_HNF_NID136, NODEID_RA95, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID47_U_HNF_NID136, VALID_RA94, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID47_U_HNF_NID136, CPA_EN_RA94, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID47_U_HNF_NID136, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID47_U_HNF_NID136, CPA_GRP_RA94, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID47_U_HNF_NID136, REMOTE_RA94, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID47_U_HNF_NID136, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID47_U_HNF_NID136, NODEID_RA94, 0, 11)
REG32(POR_HNF_RN_PHYS_ID48_U_HNF_NID136, 0x1100ea8)
    FIELD(POR_HNF_RN_PHYS_ID48_U_HNF_NID136, VALID_RA97, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID48_U_HNF_NID136, CPA_EN_RA97, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID48_U_HNF_NID136, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID48_U_HNF_NID136, CPA_GRP_RA97, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID48_U_HNF_NID136, REMOTE_RA97, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID48_U_HNF_NID136, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID48_U_HNF_NID136, NODEID_RA97, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID48_U_HNF_NID136, VALID_RA96, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID48_U_HNF_NID136, CPA_EN_RA96, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID48_U_HNF_NID136, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID48_U_HNF_NID136, CPA_GRP_RA96, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID48_U_HNF_NID136, REMOTE_RA96, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID48_U_HNF_NID136, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID48_U_HNF_NID136, NODEID_RA96, 0, 11)
REG32(POR_HNF_RN_PHYS_ID49_U_HNF_NID136, 0x1100eb0)
    FIELD(POR_HNF_RN_PHYS_ID49_U_HNF_NID136, VALID_RA99, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID49_U_HNF_NID136, CPA_EN_RA99, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID49_U_HNF_NID136, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID49_U_HNF_NID136, CPA_GRP_RA99, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID49_U_HNF_NID136, REMOTE_RA99, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID49_U_HNF_NID136, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID49_U_HNF_NID136, NODEID_RA99, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID49_U_HNF_NID136, VALID_RA98, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID49_U_HNF_NID136, CPA_EN_RA98, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID49_U_HNF_NID136, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID49_U_HNF_NID136, CPA_GRP_RA98, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID49_U_HNF_NID136, REMOTE_RA98, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID49_U_HNF_NID136, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID49_U_HNF_NID136, NODEID_RA98, 0, 11)
REG32(POR_HNF_RN_PHYS_ID50_U_HNF_NID136, 0x1100eb8)
    FIELD(POR_HNF_RN_PHYS_ID50_U_HNF_NID136, VALID_RA101, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID50_U_HNF_NID136, CPA_EN_RA101, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID50_U_HNF_NID136, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID50_U_HNF_NID136, CPA_GRP_RA101, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID50_U_HNF_NID136, REMOTE_RA101, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID50_U_HNF_NID136, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID50_U_HNF_NID136, NODEID_RA101, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID50_U_HNF_NID136, VALID_RA100, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID50_U_HNF_NID136, CPA_EN_RA100, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID50_U_HNF_NID136, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID50_U_HNF_NID136, CPA_GRP_RA100, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID50_U_HNF_NID136, REMOTE_RA100, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID50_U_HNF_NID136, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID50_U_HNF_NID136, NODEID_RA100, 0, 11)
REG32(POR_HNF_RN_PHYS_ID51_U_HNF_NID136, 0x1100ec0)
    FIELD(POR_HNF_RN_PHYS_ID51_U_HNF_NID136, VALID_RA103, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID51_U_HNF_NID136, CPA_EN_RA103, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID51_U_HNF_NID136, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID51_U_HNF_NID136, CPA_GRP_RA103, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID51_U_HNF_NID136, REMOTE_RA103, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID51_U_HNF_NID136, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID51_U_HNF_NID136, NODEID_RA103, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID51_U_HNF_NID136, VALID_RA102, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID51_U_HNF_NID136, CPA_EN_RA102, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID51_U_HNF_NID136, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID51_U_HNF_NID136, CPA_GRP_RA102, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID51_U_HNF_NID136, REMOTE_RA102, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID51_U_HNF_NID136, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID51_U_HNF_NID136, NODEID_RA102, 0, 11)
REG32(POR_HNF_RN_PHYS_ID52_U_HNF_NID136, 0x1100ec8)
    FIELD(POR_HNF_RN_PHYS_ID52_U_HNF_NID136, VALID_RA105, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID52_U_HNF_NID136, CPA_EN_RA105, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID52_U_HNF_NID136, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID52_U_HNF_NID136, CPA_GRP_RA105, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID52_U_HNF_NID136, REMOTE_RA105, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID52_U_HNF_NID136, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID52_U_HNF_NID136, NODEID_RA105, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID52_U_HNF_NID136, VALID_RA104, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID52_U_HNF_NID136, CPA_EN_RA104, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID52_U_HNF_NID136, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID52_U_HNF_NID136, CPA_GRP_RA104, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID52_U_HNF_NID136, REMOTE_RA104, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID52_U_HNF_NID136, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID52_U_HNF_NID136, NODEID_RA104, 0, 11)
REG32(POR_HNF_RN_PHYS_ID53_U_HNF_NID136, 0x1100ed0)
    FIELD(POR_HNF_RN_PHYS_ID53_U_HNF_NID136, VALID_RA107, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID53_U_HNF_NID136, CPA_EN_RA107, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID53_U_HNF_NID136, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID53_U_HNF_NID136, CPA_GRP_RA107, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID53_U_HNF_NID136, REMOTE_RA107, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID53_U_HNF_NID136, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID53_U_HNF_NID136, NODEID_RA107, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID53_U_HNF_NID136, VALID_RA106, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID53_U_HNF_NID136, CPA_EN_RA106, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID53_U_HNF_NID136, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID53_U_HNF_NID136, CPA_GRP_RA106, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID53_U_HNF_NID136, REMOTE_RA106, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID53_U_HNF_NID136, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID53_U_HNF_NID136, NODEID_RA106, 0, 11)
REG32(POR_HNF_RN_PHYS_ID54_U_HNF_NID136, 0x1100ed8)
    FIELD(POR_HNF_RN_PHYS_ID54_U_HNF_NID136, VALID_RA109, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID54_U_HNF_NID136, CPA_EN_RA109, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID54_U_HNF_NID136, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID54_U_HNF_NID136, CPA_GRP_RA109, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID54_U_HNF_NID136, REMOTE_RA109, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID54_U_HNF_NID136, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID54_U_HNF_NID136, NODEID_RA109, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID54_U_HNF_NID136, VALID_RA108, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID54_U_HNF_NID136, CPA_EN_RA108, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID54_U_HNF_NID136, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID54_U_HNF_NID136, CPA_GRP_RA108, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID54_U_HNF_NID136, REMOTE_RA108, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID54_U_HNF_NID136, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID54_U_HNF_NID136, NODEID_RA108, 0, 11)
REG32(POR_HNF_RN_PHYS_ID55_U_HNF_NID136, 0x1100ee0)
    FIELD(POR_HNF_RN_PHYS_ID55_U_HNF_NID136, VALID_RA111, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID55_U_HNF_NID136, CPA_EN_RA111, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID55_U_HNF_NID136, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID55_U_HNF_NID136, CPA_GRP_RA111, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID55_U_HNF_NID136, REMOTE_RA111, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID55_U_HNF_NID136, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID55_U_HNF_NID136, NODEID_RA111, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID55_U_HNF_NID136, VALID_RA110, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID55_U_HNF_NID136, CPA_EN_RA110, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID55_U_HNF_NID136, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID55_U_HNF_NID136, CPA_GRP_RA110, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID55_U_HNF_NID136, REMOTE_RA110, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID55_U_HNF_NID136, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID55_U_HNF_NID136, NODEID_RA110, 0, 11)
REG32(POR_HNF_RN_PHYS_ID56_U_HNF_NID136, 0x1100ee8)
    FIELD(POR_HNF_RN_PHYS_ID56_U_HNF_NID136, VALID_RA113, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID56_U_HNF_NID136, CPA_EN_RA113, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID56_U_HNF_NID136, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID56_U_HNF_NID136, CPA_GRP_RA113, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID56_U_HNF_NID136, REMOTE_RA113, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID56_U_HNF_NID136, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID56_U_HNF_NID136, NODEID_RA113, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID56_U_HNF_NID136, VALID_RA112, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID56_U_HNF_NID136, CPA_EN_RA112, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID56_U_HNF_NID136, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID56_U_HNF_NID136, CPA_GRP_RA112, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID56_U_HNF_NID136, REMOTE_RA112, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID56_U_HNF_NID136, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID56_U_HNF_NID136, NODEID_RA112, 0, 11)
REG32(POR_HNF_RN_PHYS_ID57_U_HNF_NID136, 0x1100ef0)
    FIELD(POR_HNF_RN_PHYS_ID57_U_HNF_NID136, VALID_RA115, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID57_U_HNF_NID136, CPA_EN_RA115, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID57_U_HNF_NID136, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID57_U_HNF_NID136, CPA_GRP_RA115, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID57_U_HNF_NID136, REMOTE_RA115, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID57_U_HNF_NID136, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID57_U_HNF_NID136, NODEID_RA115, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID57_U_HNF_NID136, VALID_RA114, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID57_U_HNF_NID136, CPA_EN_RA114, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID57_U_HNF_NID136, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID57_U_HNF_NID136, CPA_GRP_RA114, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID57_U_HNF_NID136, REMOTE_RA114, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID57_U_HNF_NID136, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID57_U_HNF_NID136, NODEID_RA114, 0, 11)
REG32(POR_HNF_RN_PHYS_ID58_U_HNF_NID136, 0x1100ef8)
    FIELD(POR_HNF_RN_PHYS_ID58_U_HNF_NID136, VALID_RA117, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID58_U_HNF_NID136, CPA_EN_RA117, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID58_U_HNF_NID136, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID58_U_HNF_NID136, CPA_GRP_RA117, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID58_U_HNF_NID136, REMOTE_RA117, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID58_U_HNF_NID136, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID58_U_HNF_NID136, NODEID_RA117, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID58_U_HNF_NID136, VALID_RA116, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID58_U_HNF_NID136, CPA_EN_RA116, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID58_U_HNF_NID136, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID58_U_HNF_NID136, CPA_GRP_RA116, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID58_U_HNF_NID136, REMOTE_RA116, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID58_U_HNF_NID136, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID58_U_HNF_NID136, NODEID_RA116, 0, 11)
REG32(POR_HNF_SF_CXG_BLOCKED_WAYS_U_HNF_NID136, 0x1100f00)
    FIELD(POR_HNF_SF_CXG_BLOCKED_WAYS_U_HNF_NID136, SF_BLOCKED_WAYS, 0, 2)
REG32(POR_HNF_CML_PORT_AGGR_GRP0_ADD_MASK_U_HNF_NID136, 0x1100f10)
    FIELD(POR_HNF_CML_PORT_AGGR_GRP0_ADD_MASK_U_HNF_NID136, RESERVED_48, 48, 16)
    FIELD(POR_HNF_CML_PORT_AGGR_GRP0_ADD_MASK_U_HNF_NID136, ADDR_MASK, 6, 42)
    FIELD(POR_HNF_CML_PORT_AGGR_GRP0_ADD_MASK_U_HNF_NID136, RESERVED_0, 0, 6)
REG32(POR_HNF_CML_PORT_AGGR_GRP1_ADD_MASK_U_HNF_NID136, 0x1100f18)
    FIELD(POR_HNF_CML_PORT_AGGR_GRP1_ADD_MASK_U_HNF_NID136, RESERVED_48, 48, 16)
    FIELD(POR_HNF_CML_PORT_AGGR_GRP1_ADD_MASK_U_HNF_NID136, ADDR_MASK, 6, 42)
    FIELD(POR_HNF_CML_PORT_AGGR_GRP1_ADD_MASK_U_HNF_NID136, RESERVED_0, 0, 6)
REG32(POR_HNF_CML_PORT_AGGR_GRP0_REG_U_HNF_NID136, 0x1100f28)
    FIELD(POR_HNF_CML_PORT_AGGR_GRP0_REG_U_HNF_NID136, RESERVED_50, 50, 14)
    FIELD(POR_HNF_CML_PORT_AGGR_GRP0_REG_U_HNF_NID136, NUM_CXG_PAG0, 48, 2)
    FIELD(POR_HNF_CML_PORT_AGGR_GRP0_REG_U_HNF_NID136, RESERVED_47, 47, 1)
    FIELD(POR_HNF_CML_PORT_AGGR_GRP0_REG_U_HNF_NID136, PAG0_TGTID3, 36, 11)
    FIELD(POR_HNF_CML_PORT_AGGR_GRP0_REG_U_HNF_NID136, RESERVED_35, 35, 1)
    FIELD(POR_HNF_CML_PORT_AGGR_GRP0_REG_U_HNF_NID136, PAG0_TGTID2, 24, 11)
    FIELD(POR_HNF_CML_PORT_AGGR_GRP0_REG_U_HNF_NID136, RESERVED_23, 23, 1)
    FIELD(POR_HNF_CML_PORT_AGGR_GRP0_REG_U_HNF_NID136, PAG0_TGTID1, 12, 11)
    FIELD(POR_HNF_CML_PORT_AGGR_GRP0_REG_U_HNF_NID136, RESERVED_11, 11, 1)
    FIELD(POR_HNF_CML_PORT_AGGR_GRP0_REG_U_HNF_NID136, PAG0_TGTID0, 0, 11)
REG32(POR_HNF_CML_PORT_AGGR_GRP1_REG_U_HNF_NID136, 0x1100f30)
    FIELD(POR_HNF_CML_PORT_AGGR_GRP1_REG_U_HNF_NID136, RESERVED_50, 50, 14)
    FIELD(POR_HNF_CML_PORT_AGGR_GRP1_REG_U_HNF_NID136, NUM_CXG_PAG1, 48, 2)
    FIELD(POR_HNF_CML_PORT_AGGR_GRP1_REG_U_HNF_NID136, RESERVED_47, 47, 1)
    FIELD(POR_HNF_CML_PORT_AGGR_GRP1_REG_U_HNF_NID136, PAG1_TGTID3, 36, 11)
    FIELD(POR_HNF_CML_PORT_AGGR_GRP1_REG_U_HNF_NID136, RESERVED_35, 35, 1)
    FIELD(POR_HNF_CML_PORT_AGGR_GRP1_REG_U_HNF_NID136, PAG1_TGTID2, 24, 11)
    FIELD(POR_HNF_CML_PORT_AGGR_GRP1_REG_U_HNF_NID136, RESERVED_23, 23, 1)
    FIELD(POR_HNF_CML_PORT_AGGR_GRP1_REG_U_HNF_NID136, PAG1_TGTID1, 12, 11)
    FIELD(POR_HNF_CML_PORT_AGGR_GRP1_REG_U_HNF_NID136, RESERVED_11, 11, 1)
    FIELD(POR_HNF_CML_PORT_AGGR_GRP1_REG_U_HNF_NID136, PAG1_TGTID0, 0, 11)
REG32(HN_SAM_HASH_ADDR_MASK_REG_U_HNF_NID136, 0x1100f40)
    FIELD(HN_SAM_HASH_ADDR_MASK_REG_U_HNF_NID136, RESERVED_48, 48, 16)
    FIELD(HN_SAM_HASH_ADDR_MASK_REG_U_HNF_NID136, ADDR_MASK, 6, 42)
    FIELD(HN_SAM_HASH_ADDR_MASK_REG_U_HNF_NID136, RESERVED_0, 0, 6)
REG32(HN_SAM_REGION_CMP_ADDR_MASK_REG_U_HNF_NID136, 0x1100f48)
    FIELD(HN_SAM_REGION_CMP_ADDR_MASK_REG_U_HNF_NID136, RESERVED_48, 48, 16)
    FIELD(HN_SAM_REGION_CMP_ADDR_MASK_REG_U_HNF_NID136, ADDR_MASK, 26, 22)
    FIELD(HN_SAM_REGION_CMP_ADDR_MASK_REG_U_HNF_NID136, RESERVED_0, 0, 26)
REG32(POR_HNF_ABF_LO_ADDR_U_HNF_NID136, 0x1100f50)
    FIELD(POR_HNF_ABF_LO_ADDR_U_HNF_NID136, RESERVED_48, 48, 16)
    FIELD(POR_HNF_ABF_LO_ADDR_U_HNF_NID136, ABF_LO_ADDR, 0, 48)
REG32(POR_HNF_ABF_HI_ADDR_U_HNF_NID136, 0x1100f58)
    FIELD(POR_HNF_ABF_HI_ADDR_U_HNF_NID136, RESERVED_48, 48, 16)
    FIELD(POR_HNF_ABF_HI_ADDR_U_HNF_NID136, ABF_HI_ADDR, 0, 48)
REG32(POR_HNF_ABF_PR_U_HNF_NID136, 0x1100f60)
    FIELD(POR_HNF_ABF_PR_U_HNF_NID136, ABF_MODE, 1, 2)
    FIELD(POR_HNF_ABF_PR_U_HNF_NID136, ABF_ENABLE, 0, 1)
REG32(POR_HNF_ABF_SR_U_HNF_NID136, 0x1100f68)
    FIELD(POR_HNF_ABF_SR_U_HNF_NID136, ABF_SF_DISABLE_ABORT, 3, 1)
    FIELD(POR_HNF_ABF_SR_U_HNF_NID136, ABF_SF_PM_TRANSITION_ABORT, 2, 1)
    FIELD(POR_HNF_ABF_SR_U_HNF_NID136, ABF_INVALID_REQ_ABORT, 1, 1)
    FIELD(POR_HNF_ABF_SR_U_HNF_NID136, ABF_COMPLETE, 0, 1)
REG32(POR_HNF_RN_PHYS_ID59_U_HNF_NID136, 0x1100f70)
    FIELD(POR_HNF_RN_PHYS_ID59_U_HNF_NID136, VALID_RA119, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID59_U_HNF_NID136, CPA_EN_RA119, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID59_U_HNF_NID136, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID59_U_HNF_NID136, CPA_GRP_RA119, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID59_U_HNF_NID136, REMOTE_RA119, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID59_U_HNF_NID136, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID59_U_HNF_NID136, NODEID_RA119, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID59_U_HNF_NID136, VALID_RA118, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID59_U_HNF_NID136, CPA_EN_RA118, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID59_U_HNF_NID136, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID59_U_HNF_NID136, CPA_GRP_RA118, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID59_U_HNF_NID136, REMOTE_RA118, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID59_U_HNF_NID136, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID59_U_HNF_NID136, NODEID_RA118, 0, 11)
REG32(POR_HNF_RN_PHYS_ID60_U_HNF_NID136, 0x1100f78)
    FIELD(POR_HNF_RN_PHYS_ID60_U_HNF_NID136, VALID_RA121, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID60_U_HNF_NID136, CPA_EN_RA121, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID60_U_HNF_NID136, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID60_U_HNF_NID136, CPA_GRP_RA121, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID60_U_HNF_NID136, REMOTE_RA121, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID60_U_HNF_NID136, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID60_U_HNF_NID136, NODEID_RA121, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID60_U_HNF_NID136, VALID_RA120, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID60_U_HNF_NID136, CPA_EN_RA120, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID60_U_HNF_NID136, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID60_U_HNF_NID136, CPA_GRP_RA120, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID60_U_HNF_NID136, REMOTE_RA120, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID60_U_HNF_NID136, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID60_U_HNF_NID136, NODEID_RA120, 0, 11)
REG32(POR_HNF_RN_PHYS_ID61_U_HNF_NID136, 0x1100f80)
    FIELD(POR_HNF_RN_PHYS_ID61_U_HNF_NID136, VALID_RA123, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID61_U_HNF_NID136, CPA_EN_RA123, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID61_U_HNF_NID136, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID61_U_HNF_NID136, CPA_GRP_RA123, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID61_U_HNF_NID136, REMOTE_RA123, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID61_U_HNF_NID136, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID61_U_HNF_NID136, NODEID_RA123, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID61_U_HNF_NID136, VALID_RA122, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID61_U_HNF_NID136, CPA_EN_RA122, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID61_U_HNF_NID136, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID61_U_HNF_NID136, CPA_GRP_RA122, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID61_U_HNF_NID136, REMOTE_RA122, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID61_U_HNF_NID136, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID61_U_HNF_NID136, NODEID_RA122, 0, 11)
REG32(POR_HNF_RN_PHYS_ID62_U_HNF_NID136, 0x1100f88)
    FIELD(POR_HNF_RN_PHYS_ID62_U_HNF_NID136, VALID_RA125, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID62_U_HNF_NID136, CPA_EN_RA125, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID62_U_HNF_NID136, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID62_U_HNF_NID136, CPA_GRP_RA125, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID62_U_HNF_NID136, REMOTE_RA125, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID62_U_HNF_NID136, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID62_U_HNF_NID136, NODEID_RA125, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID62_U_HNF_NID136, VALID_RA124, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID62_U_HNF_NID136, CPA_EN_RA124, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID62_U_HNF_NID136, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID62_U_HNF_NID136, CPA_GRP_RA124, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID62_U_HNF_NID136, REMOTE_RA124, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID62_U_HNF_NID136, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID62_U_HNF_NID136, NODEID_RA124, 0, 11)
REG32(POR_HNF_RN_PHYS_ID63_U_HNF_NID136, 0x1100f90)
    FIELD(POR_HNF_RN_PHYS_ID63_U_HNF_NID136, VALID_RA127, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID63_U_HNF_NID136, CPA_EN_RA127, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID63_U_HNF_NID136, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID63_U_HNF_NID136, CPA_GRP_RA127, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID63_U_HNF_NID136, REMOTE_RA127, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID63_U_HNF_NID136, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID63_U_HNF_NID136, NODEID_RA127, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID63_U_HNF_NID136, VALID_RA126, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID63_U_HNF_NID136, CPA_EN_RA126, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID63_U_HNF_NID136, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID63_U_HNF_NID136, CPA_GRP_RA126, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID63_U_HNF_NID136, REMOTE_RA126, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID63_U_HNF_NID136, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID63_U_HNF_NID136, NODEID_RA126, 0, 11)
REG32(POR_HNF_LDID_MAP_TABLE_REG0_U_HNF_NID136, 0x1100f98)
    FIELD(POR_HNF_LDID_MAP_TABLE_REG0_U_HNF_NID136, VALID_CXHA1, 63, 1)
    FIELD(POR_HNF_LDID_MAP_TABLE_REG0_U_HNF_NID136, RESERVED_55, 55, 8)
    FIELD(POR_HNF_LDID_MAP_TABLE_REG0_U_HNF_NID136, STARTING_LDID_CXHA1, 48, 7)
    FIELD(POR_HNF_LDID_MAP_TABLE_REG0_U_HNF_NID136, RESERVED_43, 43, 5)
    FIELD(POR_HNF_LDID_MAP_TABLE_REG0_U_HNF_NID136, SRCID_CXHA1, 32, 11)
    FIELD(POR_HNF_LDID_MAP_TABLE_REG0_U_HNF_NID136, VALID_CXHA0, 31, 1)
    FIELD(POR_HNF_LDID_MAP_TABLE_REG0_U_HNF_NID136, RESERVED_23, 23, 8)
    FIELD(POR_HNF_LDID_MAP_TABLE_REG0_U_HNF_NID136, STARTING_LDID_CXHA0, 16, 7)
    FIELD(POR_HNF_LDID_MAP_TABLE_REG0_U_HNF_NID136, RESERVED_11, 11, 5)
    FIELD(POR_HNF_LDID_MAP_TABLE_REG0_U_HNF_NID136, SRCID_CXHA0, 0, 11)
REG32(POR_HNF_LDID_MAP_TABLE_REG1_U_HNF_NID136, 0x1100fa0)
    FIELD(POR_HNF_LDID_MAP_TABLE_REG1_U_HNF_NID136, VALID_CXHA3, 63, 1)
    FIELD(POR_HNF_LDID_MAP_TABLE_REG1_U_HNF_NID136, RESERVED_55, 55, 8)
    FIELD(POR_HNF_LDID_MAP_TABLE_REG1_U_HNF_NID136, STARTING_LDID_CXHA3, 48, 7)
    FIELD(POR_HNF_LDID_MAP_TABLE_REG1_U_HNF_NID136, RESERVED_43, 43, 5)
    FIELD(POR_HNF_LDID_MAP_TABLE_REG1_U_HNF_NID136, SRCID_CXHA3, 32, 11)
    FIELD(POR_HNF_LDID_MAP_TABLE_REG1_U_HNF_NID136, VALID_CXHA2, 31, 1)
    FIELD(POR_HNF_LDID_MAP_TABLE_REG1_U_HNF_NID136, RESERVED_23, 23, 8)
    FIELD(POR_HNF_LDID_MAP_TABLE_REG1_U_HNF_NID136, STARTING_LDID_CXHA2, 16, 7)
    FIELD(POR_HNF_LDID_MAP_TABLE_REG1_U_HNF_NID136, RESERVED_11, 11, 5)
    FIELD(POR_HNF_LDID_MAP_TABLE_REG1_U_HNF_NID136, SRCID_CXHA2, 0, 11)
REG32(POR_HNF_LDID_MAP_TABLE_REG2_U_HNF_NID136, 0x1100fa8)
    FIELD(POR_HNF_LDID_MAP_TABLE_REG2_U_HNF_NID136, VALID_CXHA5, 63, 1)
    FIELD(POR_HNF_LDID_MAP_TABLE_REG2_U_HNF_NID136, RESERVED_55, 55, 8)
    FIELD(POR_HNF_LDID_MAP_TABLE_REG2_U_HNF_NID136, STARTING_LDID_CXHA5, 48, 7)
    FIELD(POR_HNF_LDID_MAP_TABLE_REG2_U_HNF_NID136, RESERVED_43, 43, 5)
    FIELD(POR_HNF_LDID_MAP_TABLE_REG2_U_HNF_NID136, SRCID_CXHA5, 32, 11)
    FIELD(POR_HNF_LDID_MAP_TABLE_REG2_U_HNF_NID136, VALID_CXHA4, 31, 1)
    FIELD(POR_HNF_LDID_MAP_TABLE_REG2_U_HNF_NID136, RESERVED_23, 23, 8)
    FIELD(POR_HNF_LDID_MAP_TABLE_REG2_U_HNF_NID136, STARTING_LDID_CXHA4, 16, 7)
    FIELD(POR_HNF_LDID_MAP_TABLE_REG2_U_HNF_NID136, RESERVED_11, 11, 5)
    FIELD(POR_HNF_LDID_MAP_TABLE_REG2_U_HNF_NID136, SRCID_CXHA4, 0, 11)
REG32(POR_HNF_LDID_MAP_TABLE_REG3_U_HNF_NID136, 0x1100fb0)
    FIELD(POR_HNF_LDID_MAP_TABLE_REG3_U_HNF_NID136, VALID_CXHA7, 63, 1)
    FIELD(POR_HNF_LDID_MAP_TABLE_REG3_U_HNF_NID136, RESERVED_55, 55, 8)
    FIELD(POR_HNF_LDID_MAP_TABLE_REG3_U_HNF_NID136, STARTING_LDID_CXHA7, 48, 7)
    FIELD(POR_HNF_LDID_MAP_TABLE_REG3_U_HNF_NID136, RESERVED_43, 43, 5)
    FIELD(POR_HNF_LDID_MAP_TABLE_REG3_U_HNF_NID136, SRCID_CXHA7, 32, 11)
    FIELD(POR_HNF_LDID_MAP_TABLE_REG3_U_HNF_NID136, VALID_CXHA6, 31, 1)
    FIELD(POR_HNF_LDID_MAP_TABLE_REG3_U_HNF_NID136, RESERVED_23, 23, 8)
    FIELD(POR_HNF_LDID_MAP_TABLE_REG3_U_HNF_NID136, STARTING_LDID_CXHA6, 16, 7)
    FIELD(POR_HNF_LDID_MAP_TABLE_REG3_U_HNF_NID136, RESERVED_11, 11, 5)
    FIELD(POR_HNF_LDID_MAP_TABLE_REG3_U_HNF_NID136, SRCID_CXHA6, 0, 11)
REG32(POR_HNF_PPU_PWPR_U_HNF_NID136, 0x1101000)
    FIELD(POR_HNF_PPU_PWPR_U_HNF_NID136, RESERVED_9, 9, 23)
    FIELD(POR_HNF_PPU_PWPR_U_HNF_NID136, DYN_EN, 8, 1)
    FIELD(POR_HNF_PPU_PWPR_U_HNF_NID136, OP_MODE, 4, 4)
    FIELD(POR_HNF_PPU_PWPR_U_HNF_NID136, POLICY, 0, 4)
REG32(POR_HNF_PPU_PWSR_U_HNF_NID136, 0x1101008)
    FIELD(POR_HNF_PPU_PWSR_U_HNF_NID136, RESERVED_9, 9, 23)
    FIELD(POR_HNF_PPU_PWSR_U_HNF_NID136, DYN_EN_STATUS, 8, 1)
    FIELD(POR_HNF_PPU_PWSR_U_HNF_NID136, OP_MODE_STATUS, 4, 4)
    FIELD(POR_HNF_PPU_PWSR_U_HNF_NID136, POW_STATUS, 0, 4)
REG32(POR_HNF_PPU_MISR_U_HNF_NID136, 0x1101014)
    FIELD(POR_HNF_PPU_MISR_U_HNF_NID136, PCSMACCEPT_STATUS, 0, 1)
REG32(POR_HNF_PPU_DYN_RET_THRESHOLD_U_HNF_NID136, 0x1101100)
    FIELD(POR_HNF_PPU_DYN_RET_THRESHOLD_U_HNF_NID136, RESERVED_12, 12, 52)
    FIELD(POR_HNF_PPU_DYN_RET_THRESHOLD_U_HNF_NID136, DYN_RET_THRESHOLD, 0, 12)
REG32(POR_HNF_PPU_IDR0_U_HNF_NID136, 0x1101fb0)
    FIELD(POR_HNF_PPU_IDR0_U_HNF_NID136, RESERVED_30, 30, 2)
    FIELD(POR_HNF_PPU_IDR0_U_HNF_NID136, DYN_WRM_RST_SPT, 29, 1)
    FIELD(POR_HNF_PPU_IDR0_U_HNF_NID136, DYN_ALL_ON_SPT, 28, 1)
    FIELD(POR_HNF_PPU_IDR0_U_HNF_NID136, DYN_FNC_RET_SPT, 27, 1)
    FIELD(POR_HNF_PPU_IDR0_U_HNF_NID136, DYN_FULL_RET_SPT, 26, 1)
    FIELD(POR_HNF_PPU_IDR0_U_HNF_NID136, DYN_MEM_OFF_SPT, 25, 1)
    FIELD(POR_HNF_PPU_IDR0_U_HNF_NID136, DYN_LGC_RET_SPT, 24, 1)
    FIELD(POR_HNF_PPU_IDR0_U_HNF_NID136, DYN_MEM_RET_EMU_SPT, 23, 1)
    FIELD(POR_HNF_PPU_IDR0_U_HNF_NID136, DYN_MEM_RET_SPT, 22, 1)
    FIELD(POR_HNF_PPU_IDR0_U_HNF_NID136, DYN_OFF_EMU_SPT, 21, 1)
    FIELD(POR_HNF_PPU_IDR0_U_HNF_NID136, DYN_ALL_OFF_SPT, 20, 1)
    FIELD(POR_HNF_PPU_IDR0_U_HNF_NID136, RESERVED_19, 19, 1)
    FIELD(POR_HNF_PPU_IDR0_U_HNF_NID136, STA_DBG_RECOV_SPT, 18, 1)
    FIELD(POR_HNF_PPU_IDR0_U_HNF_NID136, STA_WRM_RST_SPT, 17, 1)
    FIELD(POR_HNF_PPU_IDR0_U_HNF_NID136, STA_ALL_ON_SPT, 16, 1)
    FIELD(POR_HNF_PPU_IDR0_U_HNF_NID136, STA_FNC_RET_SPT, 15, 1)
    FIELD(POR_HNF_PPU_IDR0_U_HNF_NID136, STA_FULL_RET_SPT, 14, 1)
    FIELD(POR_HNF_PPU_IDR0_U_HNF_NID136, STA_MEM_OFF_SPT, 13, 1)
    FIELD(POR_HNF_PPU_IDR0_U_HNF_NID136, STA_LGC_RET_SPT, 12, 1)
    FIELD(POR_HNF_PPU_IDR0_U_HNF_NID136, STA_MEM_RET_EMU_SPT, 11, 1)
    FIELD(POR_HNF_PPU_IDR0_U_HNF_NID136, STA_MEM_RET_SPT, 10, 1)
    FIELD(POR_HNF_PPU_IDR0_U_HNF_NID136, STA_OFF_EMU_SPT, 9, 1)
    FIELD(POR_HNF_PPU_IDR0_U_HNF_NID136, STA_ALL_OFF_SPT, 8, 1)
    FIELD(POR_HNF_PPU_IDR0_U_HNF_NID136, NUM_OPMODES, 4, 4)
    FIELD(POR_HNF_PPU_IDR0_U_HNF_NID136, DEVCHAN, 0, 4)
REG32(POR_HNF_PPU_IDR1_U_HNF_NID136, 0x1101fb4)
    FIELD(POR_HNF_PPU_IDR1_U_HNF_NID136, DYN_POLICY_MIN_IRQ_SPT, 3, 1)
    FIELD(POR_HNF_PPU_IDR1_U_HNF_NID136, OFF_LOCK_SPT, 2, 1)
    FIELD(POR_HNF_PPU_IDR1_U_HNF_NID136, SW_DEV_DEL_CONFIG_SPT, 1, 1)
    FIELD(POR_HNF_PPU_IDR1_U_HNF_NID136, PWR_MODE_ENTRY_DEL_SPT, 0, 1)
REG32(POR_HNF_PPU_IIDR_U_HNF_NID136, 0x1101fc8)
    FIELD(POR_HNF_PPU_IIDR_U_HNF_NID136, PRODUCT_ID, 20, 12)
    FIELD(POR_HNF_PPU_IIDR_U_HNF_NID136, VARIANT, 16, 4)
    FIELD(POR_HNF_PPU_IIDR_U_HNF_NID136, REVISION, 12, 4)
    FIELD(POR_HNF_PPU_IIDR_U_HNF_NID136, IMPLEMENTER, 0, 12)
REG32(POR_HNF_PPU_AIDR_U_HNF_NID136, 0x1101fcc)
    FIELD(POR_HNF_PPU_AIDR_U_HNF_NID136, ARCH_REV_MAJOR, 4, 4)
    FIELD(POR_HNF_PPU_AIDR_U_HNF_NID136, ARCH_REV_MINOR, 0, 4)
REG32(POR_HNF_PMU_EVENT_SEL_U_HNF_NID136, 0x1102000)
    FIELD(POR_HNF_PMU_EVENT_SEL_U_HNF_NID136, RESERVED_35, 35, 29)
    FIELD(POR_HNF_PMU_EVENT_SEL_U_HNF_NID136, PMU_OCCUP1_ID, 32, 3)
    FIELD(POR_HNF_PMU_EVENT_SEL_U_HNF_NID136, RESERVED_29, 29, 3)
    FIELD(POR_HNF_PMU_EVENT_SEL_U_HNF_NID136, PMU_EVENT3_ID, 24, 5)
    FIELD(POR_HNF_PMU_EVENT_SEL_U_HNF_NID136, RESERVED_21, 21, 3)
    FIELD(POR_HNF_PMU_EVENT_SEL_U_HNF_NID136, PMU_EVENT2_ID, 16, 5)
    FIELD(POR_HNF_PMU_EVENT_SEL_U_HNF_NID136, RESERVED_13, 13, 3)
    FIELD(POR_HNF_PMU_EVENT_SEL_U_HNF_NID136, PMU_EVENT1_ID, 8, 5)
    FIELD(POR_HNF_PMU_EVENT_SEL_U_HNF_NID136, PMU_EVENT0_ID, 0, 5)
REG32(POR_HNF_ERRFR_U_HNF_NID136, 0x1103000)
    FIELD(POR_HNF_ERRFR_U_HNF_NID136, RESERVED_15, 15, 49)
    FIELD(POR_HNF_ERRFR_U_HNF_NID136, CEC, 12, 3)
    FIELD(POR_HNF_ERRFR_U_HNF_NID136, CFI, 10, 2)
    FIELD(POR_HNF_ERRFR_U_HNF_NID136, FI, 6, 2)
    FIELD(POR_HNF_ERRFR_U_HNF_NID136, UI, 4, 2)
    FIELD(POR_HNF_ERRFR_U_HNF_NID136, DE, 2, 2)
    FIELD(POR_HNF_ERRFR_U_HNF_NID136, ED, 0, 2)
REG32(POR_HNF_ERRCTLR_U_HNF_NID136, 0x1103008)
    FIELD(POR_HNF_ERRCTLR_U_HNF_NID136, RESERVED_9, 9, 55)
    FIELD(POR_HNF_ERRCTLR_U_HNF_NID136, CFI, 8, 1)
    FIELD(POR_HNF_ERRCTLR_U_HNF_NID136, FI, 3, 1)
    FIELD(POR_HNF_ERRCTLR_U_HNF_NID136, UI, 2, 1)
    FIELD(POR_HNF_ERRCTLR_U_HNF_NID136, DE, 1, 1)
    FIELD(POR_HNF_ERRCTLR_U_HNF_NID136, ED, 0, 1)
REG32(POR_HNF_ERRSTATUS_U_HNF_NID136, 0x1103010)
    FIELD(POR_HNF_ERRSTATUS_U_HNF_NID136, RESERVED_32, 32, 32)
    FIELD(POR_HNF_ERRSTATUS_U_HNF_NID136, AV, 31, 1)
    FIELD(POR_HNF_ERRSTATUS_U_HNF_NID136, V, 30, 1)
    FIELD(POR_HNF_ERRSTATUS_U_HNF_NID136, UE, 29, 1)
    FIELD(POR_HNF_ERRSTATUS_U_HNF_NID136, RESERVED_28, 28, 1)
    FIELD(POR_HNF_ERRSTATUS_U_HNF_NID136, OF, 27, 1)
    FIELD(POR_HNF_ERRSTATUS_U_HNF_NID136, MV, 26, 1)
    FIELD(POR_HNF_ERRSTATUS_U_HNF_NID136, RESERVED_25, 25, 1)
    FIELD(POR_HNF_ERRSTATUS_U_HNF_NID136, CE, 24, 1)
    FIELD(POR_HNF_ERRSTATUS_U_HNF_NID136, DE, 23, 1)
    FIELD(POR_HNF_ERRSTATUS_U_HNF_NID136, RESERVED_0, 0, 23)
REG32(POR_HNF_ERRADDR_U_HNF_NID136, 0x1103018)
    FIELD(POR_HNF_ERRADDR_U_HNF_NID136, NS, 63, 1)
    FIELD(POR_HNF_ERRADDR_U_HNF_NID136, RESERVED_48, 48, 15)
    FIELD(POR_HNF_ERRADDR_U_HNF_NID136, ADDR, 0, 48)
REG32(POR_HNF_ERRMISC_U_HNF_NID136, 0x1103020)
    FIELD(POR_HNF_ERRMISC_U_HNF_NID136, CECOF, 63, 1)
    FIELD(POR_HNF_ERRMISC_U_HNF_NID136, SETMATCH, 62, 1)
    FIELD(POR_HNF_ERRMISC_U_HNF_NID136, RESERVED_61, 61, 1)
    FIELD(POR_HNF_ERRMISC_U_HNF_NID136, ERRSET, 48, 13)
    FIELD(POR_HNF_ERRMISC_U_HNF_NID136, CEC, 32, 16)
    FIELD(POR_HNF_ERRMISC_U_HNF_NID136, RESERVED_18, 18, 14)
    FIELD(POR_HNF_ERRMISC_U_HNF_NID136, OPTYPE, 16, 2)
    FIELD(POR_HNF_ERRMISC_U_HNF_NID136, RESERVED_15, 15, 1)
    FIELD(POR_HNF_ERRMISC_U_HNF_NID136, SRCID, 4, 11)
    FIELD(POR_HNF_ERRMISC_U_HNF_NID136, ERRSRC, 0, 4)
REG32(POR_HNF_ERR_INJ_U_HNF_NID136, 0x1103030)
    FIELD(POR_HNF_ERR_INJ_U_HNF_NID136, RESERVED_27, 27, 37)
    FIELD(POR_HNF_ERR_INJ_U_HNF_NID136, HNF_ERR_INJ_SRCID, 16, 11)
    FIELD(POR_HNF_ERR_INJ_U_HNF_NID136, RESERVED_9, 9, 7)
    FIELD(POR_HNF_ERR_INJ_U_HNF_NID136, HNF_ERR_INJ_LPID, 4, 5)
    FIELD(POR_HNF_ERR_INJ_U_HNF_NID136, HNF_ERR_INJ_EN, 0, 1)
REG32(POR_HNF_BYTE_PAR_ERR_INJ_U_HNF_NID136, 0x1103038)
    FIELD(POR_HNF_BYTE_PAR_ERR_INJ_U_HNF_NID136, HNF_BYTE_PAR_ERR_INJ, 0, 5)
REG32(POR_HNF_ERRFR_NS_U_HNF_NID136, 0x1103100)
    FIELD(POR_HNF_ERRFR_NS_U_HNF_NID136, RESERVED_15, 15, 49)
    FIELD(POR_HNF_ERRFR_NS_U_HNF_NID136, CEC, 12, 3)
    FIELD(POR_HNF_ERRFR_NS_U_HNF_NID136, CFI, 10, 2)
    FIELD(POR_HNF_ERRFR_NS_U_HNF_NID136, FI, 6, 2)
    FIELD(POR_HNF_ERRFR_NS_U_HNF_NID136, UI, 4, 2)
    FIELD(POR_HNF_ERRFR_NS_U_HNF_NID136, DE, 2, 2)
    FIELD(POR_HNF_ERRFR_NS_U_HNF_NID136, ED, 0, 2)
REG32(POR_HNF_ERRCTLR_NS_U_HNF_NID136, 0x1103108)
    FIELD(POR_HNF_ERRCTLR_NS_U_HNF_NID136, RESERVED_9, 9, 55)
    FIELD(POR_HNF_ERRCTLR_NS_U_HNF_NID136, CFI, 8, 1)
    FIELD(POR_HNF_ERRCTLR_NS_U_HNF_NID136, FI, 3, 1)
    FIELD(POR_HNF_ERRCTLR_NS_U_HNF_NID136, UI, 2, 1)
    FIELD(POR_HNF_ERRCTLR_NS_U_HNF_NID136, DE, 1, 1)
    FIELD(POR_HNF_ERRCTLR_NS_U_HNF_NID136, ED, 0, 1)
REG32(POR_HNF_ERRSTATUS_NS_U_HNF_NID136, 0x1103110)
    FIELD(POR_HNF_ERRSTATUS_NS_U_HNF_NID136, RESERVED_32, 32, 32)
    FIELD(POR_HNF_ERRSTATUS_NS_U_HNF_NID136, AV, 31, 1)
    FIELD(POR_HNF_ERRSTATUS_NS_U_HNF_NID136, V, 30, 1)
    FIELD(POR_HNF_ERRSTATUS_NS_U_HNF_NID136, UE, 29, 1)
    FIELD(POR_HNF_ERRSTATUS_NS_U_HNF_NID136, RESERVED_28, 28, 1)
    FIELD(POR_HNF_ERRSTATUS_NS_U_HNF_NID136, OF, 27, 1)
    FIELD(POR_HNF_ERRSTATUS_NS_U_HNF_NID136, MV, 26, 1)
    FIELD(POR_HNF_ERRSTATUS_NS_U_HNF_NID136, RESERVED_25, 25, 1)
    FIELD(POR_HNF_ERRSTATUS_NS_U_HNF_NID136, CE, 24, 1)
    FIELD(POR_HNF_ERRSTATUS_NS_U_HNF_NID136, DE, 23, 1)
    FIELD(POR_HNF_ERRSTATUS_NS_U_HNF_NID136, RESERVED_0, 0, 23)
REG32(POR_HNF_ERRADDR_NS_U_HNF_NID136, 0x1103118)
    FIELD(POR_HNF_ERRADDR_NS_U_HNF_NID136, NS, 63, 1)
    FIELD(POR_HNF_ERRADDR_NS_U_HNF_NID136, RESERVED_48, 48, 15)
    FIELD(POR_HNF_ERRADDR_NS_U_HNF_NID136, ADDR, 0, 48)
REG32(POR_HNF_ERRMISC_NS_U_HNF_NID136, 0x1103120)
    FIELD(POR_HNF_ERRMISC_NS_U_HNF_NID136, CECOF, 63, 1)
    FIELD(POR_HNF_ERRMISC_NS_U_HNF_NID136, SETMATCH, 62, 1)
    FIELD(POR_HNF_ERRMISC_NS_U_HNF_NID136, RESERVED_61, 61, 1)
    FIELD(POR_HNF_ERRMISC_NS_U_HNF_NID136, ERRSET, 48, 13)
    FIELD(POR_HNF_ERRMISC_NS_U_HNF_NID136, CEC, 32, 16)
    FIELD(POR_HNF_ERRMISC_NS_U_HNF_NID136, RESERVED_18, 18, 14)
    FIELD(POR_HNF_ERRMISC_NS_U_HNF_NID136, OPTYPE, 16, 2)
    FIELD(POR_HNF_ERRMISC_NS_U_HNF_NID136, RESERVED_15, 15, 1)
    FIELD(POR_HNF_ERRMISC_NS_U_HNF_NID136, SRCID, 4, 11)
    FIELD(POR_HNF_ERRMISC_NS_U_HNF_NID136, ERRSRC, 0, 4)
REG32(POR_MXP_NODE_INFO_U_SMXP_2_1, 0x1108000)
    FIELD(POR_MXP_NODE_INFO_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MXP_NODE_INFO_U_SMXP_2_1, LOGICAL_ID, 32, 16)
    FIELD(POR_MXP_NODE_INFO_U_SMXP_2_1, XY_ID, 16, 16)
    FIELD(POR_MXP_NODE_INFO_U_SMXP_2_1, NODE_TYPE, 0, 16)
REG32(POR_MXP_DEVICE_PORT_CONNECT_INFO_P0_U_SMXP_2_1, 0x1108008)
    FIELD(POR_MXP_DEVICE_PORT_CONNECT_INFO_P0_U_SMXP_2_1, RESERVED_32, 32, 32)
    FIELD(POR_MXP_DEVICE_PORT_CONNECT_INFO_P0_U_SMXP_2_1, NUM_DCS_P0_D3, 28, 4)
    FIELD(POR_MXP_DEVICE_PORT_CONNECT_INFO_P0_U_SMXP_2_1, NUM_DCS_P0_D2, 24, 4)
    FIELD(POR_MXP_DEVICE_PORT_CONNECT_INFO_P0_U_SMXP_2_1, NUM_DCS_P0_D1, 20, 4)
    FIELD(POR_MXP_DEVICE_PORT_CONNECT_INFO_P0_U_SMXP_2_1, NUM_DCS_P0_D0, 16, 4)
    FIELD(POR_MXP_DEVICE_PORT_CONNECT_INFO_P0_U_SMXP_2_1, DEVICE_TYPE_P0, 0, 5)
REG32(POR_MXP_DEVICE_PORT_CONNECT_INFO_P1_U_SMXP_2_1, 0x1108010)
    FIELD(POR_MXP_DEVICE_PORT_CONNECT_INFO_P1_U_SMXP_2_1, RESERVED_32, 32, 32)
    FIELD(POR_MXP_DEVICE_PORT_CONNECT_INFO_P1_U_SMXP_2_1, NUM_DCS_P1_D3, 28, 4)
    FIELD(POR_MXP_DEVICE_PORT_CONNECT_INFO_P1_U_SMXP_2_1, NUM_DCS_P1_D2, 24, 4)
    FIELD(POR_MXP_DEVICE_PORT_CONNECT_INFO_P1_U_SMXP_2_1, NUM_DCS_P1_D1, 20, 4)
    FIELD(POR_MXP_DEVICE_PORT_CONNECT_INFO_P1_U_SMXP_2_1, NUM_DCS_P1_D0, 16, 4)
    FIELD(POR_MXP_DEVICE_PORT_CONNECT_INFO_P1_U_SMXP_2_1, DEVICE_TYPE_P1, 0, 5)
REG32(POR_MXP_MESH_PORT_CONNECT_INFO_EAST_U_SMXP_2_1, 0x1108018)
    FIELD(POR_MXP_MESH_PORT_CONNECT_INFO_EAST_U_SMXP_2_1, NUM_MCS_EAST, 0, 4)
REG32(POR_MXP_MESH_PORT_CONNECT_INFO_NORTH_U_SMXP_2_1, 0x1108020)
    FIELD(POR_MXP_MESH_PORT_CONNECT_INFO_NORTH_U_SMXP_2_1, NUM_MCS_NORTH, 0, 4)
REG32(POR_MXP_CHILD_INFO_U_SMXP_2_1, 0x1108080)
    FIELD(POR_MXP_CHILD_INFO_U_SMXP_2_1, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_INFO_U_SMXP_2_1, CHILD_PTR_OFFSET, 16, 16)
    FIELD(POR_MXP_CHILD_INFO_U_SMXP_2_1, CHILD_COUNT, 0, 16)
REG32(POR_MXP_CHILD_POINTER_0_U_SMXP_2_1, 0x1108100)
    FIELD(POR_MXP_CHILD_POINTER_0_U_SMXP_2_1, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_POINTER_0_U_SMXP_2_1, RELATIVE_ADDRESS_0, 0, 32)
REG32(POR_MXP_CHILD_POINTER_1_U_SMXP_2_1, 0x1108108)
    FIELD(POR_MXP_CHILD_POINTER_1_U_SMXP_2_1, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_POINTER_1_U_SMXP_2_1, RELATIVE_ADDRESS_1, 0, 32)
REG32(POR_MXP_CHILD_POINTER_2_U_SMXP_2_1, 0x1108110)
    FIELD(POR_MXP_CHILD_POINTER_2_U_SMXP_2_1, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_POINTER_2_U_SMXP_2_1, RELATIVE_ADDRESS_2, 0, 32)
REG32(POR_MXP_CHILD_POINTER_3_U_SMXP_2_1, 0x1108118)
    FIELD(POR_MXP_CHILD_POINTER_3_U_SMXP_2_1, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_POINTER_3_U_SMXP_2_1, RELATIVE_ADDRESS_3, 0, 32)
REG32(POR_MXP_CHILD_POINTER_4_U_SMXP_2_1, 0x1108120)
    FIELD(POR_MXP_CHILD_POINTER_4_U_SMXP_2_1, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_POINTER_4_U_SMXP_2_1, RELATIVE_ADDRESS_4, 0, 32)
REG32(POR_MXP_CHILD_POINTER_5_U_SMXP_2_1, 0x1108128)
    FIELD(POR_MXP_CHILD_POINTER_5_U_SMXP_2_1, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_POINTER_5_U_SMXP_2_1, RELATIVE_ADDRESS_5, 0, 32)
REG32(POR_MXP_CHILD_POINTER_6_U_SMXP_2_1, 0x1108130)
    FIELD(POR_MXP_CHILD_POINTER_6_U_SMXP_2_1, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_POINTER_6_U_SMXP_2_1, RELATIVE_ADDRESS_6, 0, 32)
REG32(POR_MXP_CHILD_POINTER_7_U_SMXP_2_1, 0x1108138)
    FIELD(POR_MXP_CHILD_POINTER_7_U_SMXP_2_1, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_POINTER_7_U_SMXP_2_1, RELATIVE_ADDRESS_7, 0, 32)
REG32(POR_MXP_CHILD_POINTER_8_U_SMXP_2_1, 0x1108140)
    FIELD(POR_MXP_CHILD_POINTER_8_U_SMXP_2_1, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_POINTER_8_U_SMXP_2_1, RELATIVE_ADDRESS_8, 0, 32)
REG32(POR_MXP_CHILD_POINTER_9_U_SMXP_2_1, 0x1108148)
    FIELD(POR_MXP_CHILD_POINTER_9_U_SMXP_2_1, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_POINTER_9_U_SMXP_2_1, RELATIVE_ADDRESS_9, 0, 32)
REG32(POR_MXP_CHILD_POINTER_10_U_SMXP_2_1, 0x1108150)
    FIELD(POR_MXP_CHILD_POINTER_10_U_SMXP_2_1, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_POINTER_10_U_SMXP_2_1, RELATIVE_ADDRESS_10, 0, 32)
REG32(POR_MXP_CHILD_POINTER_11_U_SMXP_2_1, 0x1108158)
    FIELD(POR_MXP_CHILD_POINTER_11_U_SMXP_2_1, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_POINTER_11_U_SMXP_2_1, RELATIVE_ADDRESS_11, 0, 32)
REG32(POR_MXP_CHILD_POINTER_12_U_SMXP_2_1, 0x1108160)
    FIELD(POR_MXP_CHILD_POINTER_12_U_SMXP_2_1, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_POINTER_12_U_SMXP_2_1, RELATIVE_ADDRESS_12, 0, 32)
REG32(POR_MXP_CHILD_POINTER_13_U_SMXP_2_1, 0x1108168)
    FIELD(POR_MXP_CHILD_POINTER_13_U_SMXP_2_1, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_POINTER_13_U_SMXP_2_1, RELATIVE_ADDRESS_13, 0, 32)
REG32(POR_MXP_CHILD_POINTER_14_U_SMXP_2_1, 0x1108170)
    FIELD(POR_MXP_CHILD_POINTER_14_U_SMXP_2_1, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_POINTER_14_U_SMXP_2_1, RELATIVE_ADDRESS_14, 0, 32)
REG32(POR_MXP_CHILD_POINTER_15_U_SMXP_2_1, 0x1108178)
    FIELD(POR_MXP_CHILD_POINTER_15_U_SMXP_2_1, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_POINTER_15_U_SMXP_2_1, RELATIVE_ADDRESS_15, 0, 32)
REG32(POR_MXP_P0_INFO_U_SMXP_2_1, 0x1108900)
    FIELD(POR_MXP_P0_INFO_U_SMXP_2_1, RESERVED_26, 26, 38)
    FIELD(POR_MXP_P0_INFO_U_SMXP_2_1, A4S_SAFE_XFACE_DISABLE_P0, 25, 1)
    FIELD(POR_MXP_P0_INFO_U_SMXP_2_1, CHI_SAFE_XFACE_DISABLE_P0, 24, 1)
    FIELD(POR_MXP_P0_INFO_U_SMXP_2_1, A4S_LOGICALID_BASE_P0, 16, 8)
    FIELD(POR_MXP_P0_INFO_U_SMXP_2_1, RESERVED_14, 14, 2)
    FIELD(POR_MXP_P0_INFO_U_SMXP_2_1, A4S_NUM_P0, 11, 3)
    FIELD(POR_MXP_P0_INFO_U_SMXP_2_1, RXBUF_NUM_ENTRIES_P0, 8, 3)
    FIELD(POR_MXP_P0_INFO_U_SMXP_2_1, EXT_SAM_EN_P0, 7, 1)
    FIELD(POR_MXP_P0_INFO_U_SMXP_2_1, DATACHECK_EN_P0, 5, 1)
    FIELD(POR_MXP_P0_INFO_U_SMXP_2_1, POISON_EN_P0, 4, 1)
    FIELD(POR_MXP_P0_INFO_U_SMXP_2_1, NUM_DEV_P0, 0, 3)
REG32(POR_MXP_P1_INFO_U_SMXP_2_1, 0x1108908)
    FIELD(POR_MXP_P1_INFO_U_SMXP_2_1, RESERVED_26, 26, 38)
    FIELD(POR_MXP_P1_INFO_U_SMXP_2_1, A4S_SAFE_XFACE_DISABLE_P1, 25, 1)
    FIELD(POR_MXP_P1_INFO_U_SMXP_2_1, CHI_SAFE_XFACE_DISABLE_P1, 24, 1)
    FIELD(POR_MXP_P1_INFO_U_SMXP_2_1, A4S_LOGICALID_BASE_P1, 16, 8)
    FIELD(POR_MXP_P1_INFO_U_SMXP_2_1, RESERVED_14, 14, 2)
    FIELD(POR_MXP_P1_INFO_U_SMXP_2_1, A4S_NUM_P1, 11, 3)
    FIELD(POR_MXP_P1_INFO_U_SMXP_2_1, RXBUF_NUM_ENTRIES_P1, 8, 3)
    FIELD(POR_MXP_P1_INFO_U_SMXP_2_1, EXT_SAM_EN_P1, 7, 1)
    FIELD(POR_MXP_P1_INFO_U_SMXP_2_1, DATACHECK_EN_P1, 5, 1)
    FIELD(POR_MXP_P1_INFO_U_SMXP_2_1, POISON_EN_P1, 4, 1)
    FIELD(POR_MXP_P1_INFO_U_SMXP_2_1, NUM_DEV_P1, 0, 3)
REG32(POR_MXP_SECURE_REGISTER_GROUPS_OVERRIDE_U_SMXP_2_1, 0x1108980)
    FIELD(POR_MXP_SECURE_REGISTER_GROUPS_OVERRIDE_U_SMXP_2_1, SYSCOREQ_CTL, 1, 1)
    FIELD(POR_MXP_SECURE_REGISTER_GROUPS_OVERRIDE_U_SMXP_2_1, QOS, 0, 1)
REG32(POR_MXP_AUX_CTL_U_SMXP_2_1, 0x1108a00)
    FIELD(POR_MXP_AUX_CTL_U_SMXP_2_1, CLKGATE_DISABLE, 0, 1)
REG32(POR_MXP_P0_QOS_CONTROL_U_SMXP_2_1, 0x1108a80)
    FIELD(POR_MXP_P0_QOS_CONTROL_U_SMXP_2_1, RESERVED_20, 20, 44)
    FIELD(POR_MXP_P0_QOS_CONTROL_U_SMXP_2_1, P0_QOS_OVERRIDE, 16, 4)
    FIELD(POR_MXP_P0_QOS_CONTROL_U_SMXP_2_1, P0_PQV_MODE, 6, 1)
    FIELD(POR_MXP_P0_QOS_CONTROL_U_SMXP_2_1, P0_REG_MODE, 4, 1)
    FIELD(POR_MXP_P0_QOS_CONTROL_U_SMXP_2_1, P0_QOS_OVERRIDE_EN, 2, 1)
    FIELD(POR_MXP_P0_QOS_CONTROL_U_SMXP_2_1, P0_LAT_EN, 0, 1)
REG32(POR_MXP_P0_QOS_LAT_TGT_U_SMXP_2_1, 0x1108a88)
    FIELD(POR_MXP_P0_QOS_LAT_TGT_U_SMXP_2_1, RESERVED_12, 12, 52)
    FIELD(POR_MXP_P0_QOS_LAT_TGT_U_SMXP_2_1, P0_LAT_TGT, 0, 12)
REG32(POR_MXP_P0_QOS_LAT_SCALE_U_SMXP_2_1, 0x1108a90)
    FIELD(POR_MXP_P0_QOS_LAT_SCALE_U_SMXP_2_1, P0_LAT_SCALE, 0, 3)
REG32(POR_MXP_P0_QOS_LAT_RANGE_U_SMXP_2_1, 0x1108a98)
    FIELD(POR_MXP_P0_QOS_LAT_RANGE_U_SMXP_2_1, RESERVED_12, 12, 52)
    FIELD(POR_MXP_P0_QOS_LAT_RANGE_U_SMXP_2_1, P0_LAT_MAX_QOS, 8, 4)
    FIELD(POR_MXP_P0_QOS_LAT_RANGE_U_SMXP_2_1, P0_LAT_MIN_QOS, 0, 4)
REG32(POR_MXP_P1_QOS_CONTROL_U_SMXP_2_1, 0x1108aa0)
    FIELD(POR_MXP_P1_QOS_CONTROL_U_SMXP_2_1, RESERVED_20, 20, 44)
    FIELD(POR_MXP_P1_QOS_CONTROL_U_SMXP_2_1, P1_QOS_OVERRIDE, 16, 4)
    FIELD(POR_MXP_P1_QOS_CONTROL_U_SMXP_2_1, P1_PQV_MODE, 6, 1)
    FIELD(POR_MXP_P1_QOS_CONTROL_U_SMXP_2_1, P1_REG_MODE, 4, 1)
    FIELD(POR_MXP_P1_QOS_CONTROL_U_SMXP_2_1, P1_QOS_OVERRIDE_EN, 2, 1)
    FIELD(POR_MXP_P1_QOS_CONTROL_U_SMXP_2_1, P1_LAT_EN, 0, 1)
REG32(POR_MXP_P1_QOS_LAT_TGT_U_SMXP_2_1, 0x1108aa8)
    FIELD(POR_MXP_P1_QOS_LAT_TGT_U_SMXP_2_1, RESERVED_12, 12, 52)
    FIELD(POR_MXP_P1_QOS_LAT_TGT_U_SMXP_2_1, P1_LAT_TGT, 0, 12)
REG32(POR_MXP_P1_QOS_LAT_SCALE_U_SMXP_2_1, 0x1108ab0)
    FIELD(POR_MXP_P1_QOS_LAT_SCALE_U_SMXP_2_1, P1_LAT_SCALE, 0, 3)
REG32(POR_MXP_P1_QOS_LAT_RANGE_U_SMXP_2_1, 0x1108ab8)
    FIELD(POR_MXP_P1_QOS_LAT_RANGE_U_SMXP_2_1, RESERVED_12, 12, 52)
    FIELD(POR_MXP_P1_QOS_LAT_RANGE_U_SMXP_2_1, P1_LAT_MAX_QOS, 8, 4)
    FIELD(POR_MXP_P1_QOS_LAT_RANGE_U_SMXP_2_1, P1_LAT_MIN_QOS, 0, 4)
REG32(POR_MXP_P0_SYSCOREQ_CTL_U_SMXP_2_1, 0x1109000)
    FIELD(POR_MXP_P0_SYSCOREQ_CTL_U_SMXP_2_1, SNPDVM_REQ_P0_D3, 3, 1)
    FIELD(POR_MXP_P0_SYSCOREQ_CTL_U_SMXP_2_1, SNPDVM_REQ_P0_D2, 2, 1)
    FIELD(POR_MXP_P0_SYSCOREQ_CTL_U_SMXP_2_1, SNPDVM_REQ_P0_D1, 1, 1)
    FIELD(POR_MXP_P0_SYSCOREQ_CTL_U_SMXP_2_1, SNPDVM_REQ_P0_D0, 0, 1)
REG32(POR_MXP_P1_SYSCOREQ_CTL_U_SMXP_2_1, 0x1109008)
    FIELD(POR_MXP_P1_SYSCOREQ_CTL_U_SMXP_2_1, SNPDVM_REQ_P1_D3, 3, 1)
    FIELD(POR_MXP_P1_SYSCOREQ_CTL_U_SMXP_2_1, SNPDVM_REQ_P1_D2, 2, 1)
    FIELD(POR_MXP_P1_SYSCOREQ_CTL_U_SMXP_2_1, SNPDVM_REQ_P1_D1, 1, 1)
    FIELD(POR_MXP_P1_SYSCOREQ_CTL_U_SMXP_2_1, SNPDVM_REQ_P1_D0, 0, 1)
REG32(POR_MXP_P0_SYSCOACK_STATUS_U_SMXP_2_1, 0x1109010)
    FIELD(POR_MXP_P0_SYSCOACK_STATUS_U_SMXP_2_1, SNPDVM_ACK_P0_D3, 3, 1)
    FIELD(POR_MXP_P0_SYSCOACK_STATUS_U_SMXP_2_1, SNPDVM_ACK_P0_D2, 2, 1)
    FIELD(POR_MXP_P0_SYSCOACK_STATUS_U_SMXP_2_1, SNPDVM_ACK_P0_D1, 1, 1)
    FIELD(POR_MXP_P0_SYSCOACK_STATUS_U_SMXP_2_1, SNPDVM_ACK_P0_D0, 0, 1)
REG32(POR_MXP_P1_SYSCOACK_STATUS_U_SMXP_2_1, 0x1109018)
    FIELD(POR_MXP_P1_SYSCOACK_STATUS_U_SMXP_2_1, SNPDVM_ACK_P1_D3, 3, 1)
    FIELD(POR_MXP_P1_SYSCOACK_STATUS_U_SMXP_2_1, SNPDVM_ACK_P1_D2, 2, 1)
    FIELD(POR_MXP_P1_SYSCOACK_STATUS_U_SMXP_2_1, SNPDVM_ACK_P1_D1, 1, 1)
    FIELD(POR_MXP_P1_SYSCOACK_STATUS_U_SMXP_2_1, SNPDVM_ACK_P1_D0, 0, 1)
REG32(POR_MXP_PMU_EVENT_SEL_U_SMXP_2_1, 0x110a000)
    FIELD(POR_MXP_PMU_EVENT_SEL_U_SMXP_2_1, RESERVED_32, 32, 32)
    FIELD(POR_MXP_PMU_EVENT_SEL_U_SMXP_2_1, PMU_EVENT3_ID, 24, 8)
    FIELD(POR_MXP_PMU_EVENT_SEL_U_SMXP_2_1, PMU_EVENT2_ID, 16, 8)
    FIELD(POR_MXP_PMU_EVENT_SEL_U_SMXP_2_1, PMU_EVENT1_ID, 8, 8)
    FIELD(POR_MXP_PMU_EVENT_SEL_U_SMXP_2_1, PMU_EVENT0_ID, 0, 8)
REG32(POR_DTM_CONTROL_U_SMXP_2_1, 0x110a100)
    FIELD(POR_DTM_CONTROL_U_SMXP_2_1, TRACE_NO_ATB, 3, 1)
    FIELD(POR_DTM_CONTROL_U_SMXP_2_1, SAMPLE_PROFILE_ENABLE, 2, 1)
    FIELD(POR_DTM_CONTROL_U_SMXP_2_1, TRACE_TAG_ENABLE, 1, 1)
    FIELD(POR_DTM_CONTROL_U_SMXP_2_1, DTM_ENABLE, 0, 1)
REG32(POR_DTM_FIFO_ENTRY_READY_U_SMXP_2_1, 0x110a118)
    FIELD(POR_DTM_FIFO_ENTRY_READY_U_SMXP_2_1, READY, 0, 4)
REG32(POR_DTM_FIFO_ENTRY0_0_U_SMXP_2_1, 0x110a120)
REG32(POR_DTM_FIFO_ENTRY0_1_U_SMXP_2_1, 0x110a128)
REG32(POR_DTM_FIFO_ENTRY0_2_U_SMXP_2_1, 0x110a130)
    FIELD(POR_DTM_FIFO_ENTRY0_2_U_SMXP_2_1, RESERVED_32, 32, 32)
    FIELD(POR_DTM_FIFO_ENTRY0_2_U_SMXP_2_1, FIFO_CYCLE_COUNT, 16, 16)
    FIELD(POR_DTM_FIFO_ENTRY0_2_U_SMXP_2_1, FIFO_DATA2, 0, 16)
REG32(POR_DTM_FIFO_ENTRY1_0_U_SMXP_2_1, 0x110a138)
REG32(POR_DTM_FIFO_ENTRY1_1_U_SMXP_2_1, 0x110a140)
REG32(POR_DTM_FIFO_ENTRY1_2_U_SMXP_2_1, 0x110a148)
    FIELD(POR_DTM_FIFO_ENTRY1_2_U_SMXP_2_1, RESERVED_32, 32, 32)
    FIELD(POR_DTM_FIFO_ENTRY1_2_U_SMXP_2_1, FIFO_CYCLE_COUNT, 16, 16)
    FIELD(POR_DTM_FIFO_ENTRY1_2_U_SMXP_2_1, FIFO_DATA2, 0, 16)
REG32(POR_DTM_FIFO_ENTRY2_0_U_SMXP_2_1, 0x110a150)
REG32(POR_DTM_FIFO_ENTRY2_1_U_SMXP_2_1, 0x110a158)
REG32(POR_DTM_FIFO_ENTRY2_2_U_SMXP_2_1, 0x110a160)
    FIELD(POR_DTM_FIFO_ENTRY2_2_U_SMXP_2_1, RESERVED_32, 32, 32)
    FIELD(POR_DTM_FIFO_ENTRY2_2_U_SMXP_2_1, FIFO_CYCLE_COUNT, 16, 16)
    FIELD(POR_DTM_FIFO_ENTRY2_2_U_SMXP_2_1, FIFO_DATA2, 0, 16)
REG32(POR_DTM_FIFO_ENTRY3_0_U_SMXP_2_1, 0x110a168)
REG32(POR_DTM_FIFO_ENTRY3_1_U_SMXP_2_1, 0x110a170)
REG32(POR_DTM_FIFO_ENTRY3_2_U_SMXP_2_1, 0x110a178)
    FIELD(POR_DTM_FIFO_ENTRY3_2_U_SMXP_2_1, RESERVED_32, 32, 32)
    FIELD(POR_DTM_FIFO_ENTRY3_2_U_SMXP_2_1, FIFO_CYCLE_COUNT, 16, 16)
    FIELD(POR_DTM_FIFO_ENTRY3_2_U_SMXP_2_1, FIFO_DATA2, 0, 16)
REG32(POR_DTM_WP0_CONFIG_U_SMXP_2_1, 0x110a1a0)
    FIELD(POR_DTM_WP0_CONFIG_U_SMXP_2_1, RESERVED_15, 15, 49)
    FIELD(POR_DTM_WP0_CONFIG_U_SMXP_2_1, WP_DBGTRIG_EN, 14, 1)
    FIELD(POR_DTM_WP0_CONFIG_U_SMXP_2_1, WP_CTRIG_EN, 13, 1)
    FIELD(POR_DTM_WP0_CONFIG_U_SMXP_2_1, WP_CC_EN, 12, 1)
    FIELD(POR_DTM_WP0_CONFIG_U_SMXP_2_1, WP_PKT_TYPE, 9, 3)
    FIELD(POR_DTM_WP0_CONFIG_U_SMXP_2_1, WP_PKT_GEN, 8, 1)
    FIELD(POR_DTM_WP0_CONFIG_U_SMXP_2_1, WP_COMBINE, 6, 1)
    FIELD(POR_DTM_WP0_CONFIG_U_SMXP_2_1, WP_EXCLUSIVE, 5, 1)
    FIELD(POR_DTM_WP0_CONFIG_U_SMXP_2_1, WP_GRP, 4, 1)
    FIELD(POR_DTM_WP0_CONFIG_U_SMXP_2_1, WP_CHN_SEL, 1, 3)
    FIELD(POR_DTM_WP0_CONFIG_U_SMXP_2_1, WP_DEV_SEL, 0, 1)
REG32(POR_DTM_WP0_VAL_U_SMXP_2_1, 0x110a1a8)
REG32(POR_DTM_WP0_MASK_U_SMXP_2_1, 0x110a1b0)
REG32(POR_DTM_WP1_CONFIG_U_SMXP_2_1, 0x110a1b8)
    FIELD(POR_DTM_WP1_CONFIG_U_SMXP_2_1, RESERVED_15, 15, 49)
    FIELD(POR_DTM_WP1_CONFIG_U_SMXP_2_1, WP_DBGTRIG_EN, 14, 1)
    FIELD(POR_DTM_WP1_CONFIG_U_SMXP_2_1, WP_CTRIG_EN, 13, 1)
    FIELD(POR_DTM_WP1_CONFIG_U_SMXP_2_1, WP_CC_EN, 12, 1)
    FIELD(POR_DTM_WP1_CONFIG_U_SMXP_2_1, WP_PKT_TYPE, 9, 3)
    FIELD(POR_DTM_WP1_CONFIG_U_SMXP_2_1, WP_PKT_GEN, 8, 1)
    FIELD(POR_DTM_WP1_CONFIG_U_SMXP_2_1, WP_EXCLUSIVE, 5, 1)
    FIELD(POR_DTM_WP1_CONFIG_U_SMXP_2_1, WP_GRP, 4, 1)
    FIELD(POR_DTM_WP1_CONFIG_U_SMXP_2_1, WP_CHN_SEL, 1, 3)
    FIELD(POR_DTM_WP1_CONFIG_U_SMXP_2_1, WP_DEV_SEL, 0, 1)
REG32(POR_DTM_WP1_VAL_U_SMXP_2_1, 0x110a1c0)
REG32(POR_DTM_WP1_MASK_U_SMXP_2_1, 0x110a1c8)
REG32(POR_DTM_WP2_CONFIG_U_SMXP_2_1, 0x110a1d0)
    FIELD(POR_DTM_WP2_CONFIG_U_SMXP_2_1, RESERVED_15, 15, 49)
    FIELD(POR_DTM_WP2_CONFIG_U_SMXP_2_1, WP_DBGTRIG_EN, 14, 1)
    FIELD(POR_DTM_WP2_CONFIG_U_SMXP_2_1, WP_CTRIG_EN, 13, 1)
    FIELD(POR_DTM_WP2_CONFIG_U_SMXP_2_1, WP_CC_EN, 12, 1)
    FIELD(POR_DTM_WP2_CONFIG_U_SMXP_2_1, WP_PKT_TYPE, 9, 3)
    FIELD(POR_DTM_WP2_CONFIG_U_SMXP_2_1, WP_PKT_GEN, 8, 1)
    FIELD(POR_DTM_WP2_CONFIG_U_SMXP_2_1, WP_COMBINE, 6, 1)
    FIELD(POR_DTM_WP2_CONFIG_U_SMXP_2_1, WP_EXCLUSIVE, 5, 1)
    FIELD(POR_DTM_WP2_CONFIG_U_SMXP_2_1, WP_GRP, 4, 1)
    FIELD(POR_DTM_WP2_CONFIG_U_SMXP_2_1, WP_CHN_SEL, 1, 3)
    FIELD(POR_DTM_WP2_CONFIG_U_SMXP_2_1, WP_DEV_SEL, 0, 1)
REG32(POR_DTM_WP2_VAL_U_SMXP_2_1, 0x110a1d8)
REG32(POR_DTM_WP2_MASK_U_SMXP_2_1, 0x110a1e0)
REG32(POR_DTM_WP3_CONFIG_U_SMXP_2_1, 0x110a1e8)
    FIELD(POR_DTM_WP3_CONFIG_U_SMXP_2_1, RESERVED_15, 15, 49)
    FIELD(POR_DTM_WP3_CONFIG_U_SMXP_2_1, WP_DBGTRIG_EN, 14, 1)
    FIELD(POR_DTM_WP3_CONFIG_U_SMXP_2_1, WP_CTRIG_EN, 13, 1)
    FIELD(POR_DTM_WP3_CONFIG_U_SMXP_2_1, WP_CC_EN, 12, 1)
    FIELD(POR_DTM_WP3_CONFIG_U_SMXP_2_1, WP_PKT_TYPE, 9, 3)
    FIELD(POR_DTM_WP3_CONFIG_U_SMXP_2_1, WP_PKT_GEN, 8, 1)
    FIELD(POR_DTM_WP3_CONFIG_U_SMXP_2_1, WP_EXCLUSIVE, 5, 1)
    FIELD(POR_DTM_WP3_CONFIG_U_SMXP_2_1, WP_GRP, 4, 1)
    FIELD(POR_DTM_WP3_CONFIG_U_SMXP_2_1, WP_CHN_SEL, 1, 3)
    FIELD(POR_DTM_WP3_CONFIG_U_SMXP_2_1, WP_DEV_SEL, 0, 1)
REG32(POR_DTM_WP3_VAL_U_SMXP_2_1, 0x110a1f0)
REG32(POR_DTM_WP3_MASK_U_SMXP_2_1, 0x110a1f8)
REG32(POR_DTM_PMSICR_U_SMXP_2_1, 0x110a200)
    FIELD(POR_DTM_PMSICR_U_SMXP_2_1, RESERVED_32, 32, 32)
    FIELD(POR_DTM_PMSICR_U_SMXP_2_1, COUNT, 0, 32)
REG32(POR_DTM_PMSIRR_U_SMXP_2_1, 0x110a208)
    FIELD(POR_DTM_PMSIRR_U_SMXP_2_1, RESERVED_32, 32, 32)
    FIELD(POR_DTM_PMSIRR_U_SMXP_2_1, INTERVAL, 8, 24)
    FIELD(POR_DTM_PMSIRR_U_SMXP_2_1, RESERVED_0, 0, 8)
REG32(POR_DTM_PMU_CONFIG_U_SMXP_2_1, 0x110a210)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_2_1, RESERVED_62, 62, 2)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_2_1, PMEVCNT3_INPUT_SEL, 56, 6)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_2_1, RESERVED_54, 54, 2)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_2_1, PMEVCNT2_INPUT_SEL, 48, 6)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_2_1, RESERVED_46, 46, 2)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_2_1, PMEVCNT1_INPUT_SEL, 40, 6)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_2_1, RESERVED_38, 38, 2)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_2_1, PMEVCNT0_INPUT_SEL, 32, 6)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_2_1, RESERVED_31, 31, 1)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_2_1, PMEVCNT3_GLOBAL_NUM, 28, 3)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_2_1, RESERVED_27, 27, 1)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_2_1, PMEVCNT2_GLOBAL_NUM, 24, 3)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_2_1, RESERVED_23, 23, 1)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_2_1, PMEVCNT1_GLOBAL_NUM, 20, 3)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_2_1, RESERVED_19, 19, 1)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_2_1, PMEVCNT0_GLOBAL_NUM, 16, 3)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_2_1, RESERVED_9, 9, 7)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_2_1, CNTR_RST, 8, 1)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_2_1, PMEVCNT_PAIRED, 4, 4)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_2_1, PMEVCNTALL_COMBINED, 3, 1)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_2_1, PMEVCNT23_COMBINED, 2, 1)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_2_1, PMEVCNT01_COMBINED, 1, 1)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_2_1, PMU_EN, 0, 1)
REG32(POR_DTM_PMEVCNT_U_SMXP_2_1, 0x110a220)
    FIELD(POR_DTM_PMEVCNT_U_SMXP_2_1, PMEVCNT3, 48, 16)
    FIELD(POR_DTM_PMEVCNT_U_SMXP_2_1, PMEVCNT2, 32, 16)
    FIELD(POR_DTM_PMEVCNT_U_SMXP_2_1, PMEVCNT1, 16, 16)
    FIELD(POR_DTM_PMEVCNT_U_SMXP_2_1, PMEVCNT0, 0, 16)
REG32(POR_DTM_PMEVCNTSR_U_SMXP_2_1, 0x110a240)
    FIELD(POR_DTM_PMEVCNTSR_U_SMXP_2_1, PMEVCNTSR3, 48, 16)
    FIELD(POR_DTM_PMEVCNTSR_U_SMXP_2_1, PMEVCNTSR2, 32, 16)
    FIELD(POR_DTM_PMEVCNTSR_U_SMXP_2_1, PMEVCNTSR1, 16, 16)
    FIELD(POR_DTM_PMEVCNTSR_U_SMXP_2_1, PMEVCNTSR0, 0, 16)
REG32(POR_MXP_ERRFR_U_SMXP_2_1, 0x110b000)
    FIELD(POR_MXP_ERRFR_U_SMXP_2_1, RESERVED_15, 15, 49)
    FIELD(POR_MXP_ERRFR_U_SMXP_2_1, CEC, 12, 3)
    FIELD(POR_MXP_ERRFR_U_SMXP_2_1, CFI, 10, 2)
    FIELD(POR_MXP_ERRFR_U_SMXP_2_1, FI, 6, 2)
    FIELD(POR_MXP_ERRFR_U_SMXP_2_1, UI, 4, 2)
    FIELD(POR_MXP_ERRFR_U_SMXP_2_1, DE, 2, 2)
    FIELD(POR_MXP_ERRFR_U_SMXP_2_1, ED, 0, 2)
REG32(POR_MXP_ERRCTLR_U_SMXP_2_1, 0x110b008)
    FIELD(POR_MXP_ERRCTLR_U_SMXP_2_1, RESERVED_9, 9, 55)
    FIELD(POR_MXP_ERRCTLR_U_SMXP_2_1, CFI, 8, 1)
    FIELD(POR_MXP_ERRCTLR_U_SMXP_2_1, FI, 3, 1)
    FIELD(POR_MXP_ERRCTLR_U_SMXP_2_1, UI, 2, 1)
    FIELD(POR_MXP_ERRCTLR_U_SMXP_2_1, DE, 1, 1)
    FIELD(POR_MXP_ERRCTLR_U_SMXP_2_1, ED, 0, 1)
REG32(POR_MXP_ERRSTATUS_U_SMXP_2_1, 0x110b010)
    FIELD(POR_MXP_ERRSTATUS_U_SMXP_2_1, RESERVED_32, 32, 32)
    FIELD(POR_MXP_ERRSTATUS_U_SMXP_2_1, AV, 31, 1)
    FIELD(POR_MXP_ERRSTATUS_U_SMXP_2_1, V, 30, 1)
    FIELD(POR_MXP_ERRSTATUS_U_SMXP_2_1, UE, 29, 1)
    FIELD(POR_MXP_ERRSTATUS_U_SMXP_2_1, RESERVED_28, 28, 1)
    FIELD(POR_MXP_ERRSTATUS_U_SMXP_2_1, OF, 27, 1)
    FIELD(POR_MXP_ERRSTATUS_U_SMXP_2_1, MV, 26, 1)
    FIELD(POR_MXP_ERRSTATUS_U_SMXP_2_1, RESERVED_25, 25, 1)
    FIELD(POR_MXP_ERRSTATUS_U_SMXP_2_1, CE, 24, 1)
    FIELD(POR_MXP_ERRSTATUS_U_SMXP_2_1, DE, 23, 1)
    FIELD(POR_MXP_ERRSTATUS_U_SMXP_2_1, RESERVED_0, 0, 23)
REG32(POR_MXP_ERRMISC_U_SMXP_2_1, 0x110b028)
    FIELD(POR_MXP_ERRMISC_U_SMXP_2_1, RESERVED_59, 59, 5)
    FIELD(POR_MXP_ERRMISC_U_SMXP_2_1, TGTID, 48, 11)
    FIELD(POR_MXP_ERRMISC_U_SMXP_2_1, RESERVED_22, 22, 26)
    FIELD(POR_MXP_ERRMISC_U_SMXP_2_1, OPCODE, 16, 6)
    FIELD(POR_MXP_ERRMISC_U_SMXP_2_1, RESERVED_15, 15, 1)
    FIELD(POR_MXP_ERRMISC_U_SMXP_2_1, SRCID, 4, 11)
    FIELD(POR_MXP_ERRMISC_U_SMXP_2_1, ERRSRC, 0, 3)
REG32(POR_MXP_P0_BYTE_PAR_ERR_INJ_U_SMXP_2_1, 0x110b030)
    FIELD(POR_MXP_P0_BYTE_PAR_ERR_INJ_U_SMXP_2_1, P0_BYTE_PARITY_ERR_INJ, 0, 5)
REG32(POR_MXP_P1_BYTE_PAR_ERR_INJ_U_SMXP_2_1, 0x110b038)
    FIELD(POR_MXP_P1_BYTE_PAR_ERR_INJ_U_SMXP_2_1, P1_BYTE_PARITY_ERR_INJ, 0, 5)
REG32(POR_MXP_ERRFR_NS_U_SMXP_2_1, 0x110b100)
    FIELD(POR_MXP_ERRFR_NS_U_SMXP_2_1, RESERVED_15, 15, 49)
    FIELD(POR_MXP_ERRFR_NS_U_SMXP_2_1, CEC, 12, 3)
    FIELD(POR_MXP_ERRFR_NS_U_SMXP_2_1, CFI, 10, 2)
    FIELD(POR_MXP_ERRFR_NS_U_SMXP_2_1, FI, 6, 2)
    FIELD(POR_MXP_ERRFR_NS_U_SMXP_2_1, UI, 4, 2)
    FIELD(POR_MXP_ERRFR_NS_U_SMXP_2_1, DE, 2, 2)
    FIELD(POR_MXP_ERRFR_NS_U_SMXP_2_1, ED, 0, 2)
REG32(POR_MXP_ERRCTLR_NS_U_SMXP_2_1, 0x110b108)
    FIELD(POR_MXP_ERRCTLR_NS_U_SMXP_2_1, RESERVED_9, 9, 55)
    FIELD(POR_MXP_ERRCTLR_NS_U_SMXP_2_1, CFI, 8, 1)
    FIELD(POR_MXP_ERRCTLR_NS_U_SMXP_2_1, FI, 3, 1)
    FIELD(POR_MXP_ERRCTLR_NS_U_SMXP_2_1, UI, 2, 1)
    FIELD(POR_MXP_ERRCTLR_NS_U_SMXP_2_1, DE, 1, 1)
    FIELD(POR_MXP_ERRCTLR_NS_U_SMXP_2_1, ED, 0, 1)
REG32(POR_MXP_ERRSTATUS_NS_U_SMXP_2_1, 0x110b110)
    FIELD(POR_MXP_ERRSTATUS_NS_U_SMXP_2_1, RESERVED_32, 32, 32)
    FIELD(POR_MXP_ERRSTATUS_NS_U_SMXP_2_1, AV, 31, 1)
    FIELD(POR_MXP_ERRSTATUS_NS_U_SMXP_2_1, V, 30, 1)
    FIELD(POR_MXP_ERRSTATUS_NS_U_SMXP_2_1, UE, 29, 1)
    FIELD(POR_MXP_ERRSTATUS_NS_U_SMXP_2_1, RESERVED_28, 28, 1)
    FIELD(POR_MXP_ERRSTATUS_NS_U_SMXP_2_1, OF, 27, 1)
    FIELD(POR_MXP_ERRSTATUS_NS_U_SMXP_2_1, MV, 26, 1)
    FIELD(POR_MXP_ERRSTATUS_NS_U_SMXP_2_1, RESERVED_25, 25, 1)
    FIELD(POR_MXP_ERRSTATUS_NS_U_SMXP_2_1, CE, 24, 1)
    FIELD(POR_MXP_ERRSTATUS_NS_U_SMXP_2_1, DE, 23, 1)
    FIELD(POR_MXP_ERRSTATUS_NS_U_SMXP_2_1, RESERVED_0, 0, 23)
REG32(POR_MXP_ERRMISC_NS_U_SMXP_2_1, 0x110b128)
    FIELD(POR_MXP_ERRMISC_NS_U_SMXP_2_1, RESERVED_59, 59, 5)
    FIELD(POR_MXP_ERRMISC_NS_U_SMXP_2_1, TGTID, 48, 11)
    FIELD(POR_MXP_ERRMISC_NS_U_SMXP_2_1, RESERVED_22, 22, 26)
    FIELD(POR_MXP_ERRMISC_NS_U_SMXP_2_1, OPCODE, 16, 6)
    FIELD(POR_MXP_ERRMISC_NS_U_SMXP_2_1, RESERVED_15, 15, 1)
    FIELD(POR_MXP_ERRMISC_NS_U_SMXP_2_1, SRCID, 4, 11)
    FIELD(POR_MXP_ERRMISC_NS_U_SMXP_2_1, ERRSRC, 0, 3)
REG32(POR_FDC_NODE_INFO_U_SMXP_2_1, 0x112c000)
    FIELD(POR_FDC_NODE_INFO_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_FDC_NODE_INFO_U_SMXP_2_1, LOGICAL_ID, 32, 16)
    FIELD(POR_FDC_NODE_INFO_U_SMXP_2_1, NODE_ID, 16, 16)
    FIELD(POR_FDC_NODE_INFO_U_SMXP_2_1, NODE_TYPE, 0, 16)
REG32(POR_FDC_CHILD_INFO_U_SMXP_2_1, 0x112c080)
    FIELD(POR_FDC_CHILD_INFO_U_SMXP_2_1, RESERVED_32, 32, 32)
    FIELD(POR_FDC_CHILD_INFO_U_SMXP_2_1, CHILD_PTR_OFFSET, 16, 16)
    FIELD(POR_FDC_CHILD_INFO_U_SMXP_2_1, CHILD_COUNT, 0, 16)
REG32(POR_ERRFR_MXP_U_SMXP_2_1, 0x112f000)
    FIELD(POR_ERRFR_MXP_U_SMXP_2_1, FI, 6, 2)
    FIELD(POR_ERRFR_MXP_U_SMXP_2_1, UI, 4, 2)
    FIELD(POR_ERRFR_MXP_U_SMXP_2_1, ED, 0, 2)
REG32(POR_ERRCTLR_MXP_U_SMXP_2_1, 0x112f008)
    FIELD(POR_ERRCTLR_MXP_U_SMXP_2_1, RESERVED_32, 32, 32)
    FIELD(POR_ERRCTLR_MXP_U_SMXP_2_1, ERC, 14, 18)
    FIELD(POR_ERRCTLR_MXP_U_SMXP_2_1, FI, 3, 1)
    FIELD(POR_ERRCTLR_MXP_U_SMXP_2_1, UI, 2, 1)
    FIELD(POR_ERRCTLR_MXP_U_SMXP_2_1, ED, 0, 1)
REG32(POR_ERRSTATUS_MXP_U_SMXP_2_1, 0x112f010)
    FIELD(POR_ERRSTATUS_MXP_U_SMXP_2_1, RESERVED_31, 31, 33)
    FIELD(POR_ERRSTATUS_MXP_U_SMXP_2_1, V, 30, 1)
    FIELD(POR_ERRSTATUS_MXP_U_SMXP_2_1, UE, 29, 1)
    FIELD(POR_ERRSTATUS_MXP_U_SMXP_2_1, RESERVED_28, 28, 1)
    FIELD(POR_ERRSTATUS_MXP_U_SMXP_2_1, OF, 27, 1)
    FIELD(POR_ERRSTATUS_MXP_U_SMXP_2_1, RESERVED_24, 24, 3)
    FIELD(POR_ERRSTATUS_MXP_U_SMXP_2_1, DE, 23, 1)
    FIELD(POR_ERRSTATUS_MXP_U_SMXP_2_1, RESERVED_16, 16, 7)
    FIELD(POR_ERRSTATUS_MXP_U_SMXP_2_1, V_ERR_TYPE, 6, 10)
    FIELD(POR_ERRSTATUS_MXP_U_SMXP_2_1, RESERVED_0, 0, 6)
REG32(POR_FDC_AUX_CTL_MXP_U_SMXP_2_1, 0x112f018)
    FIELD(POR_FDC_AUX_CTL_MXP_U_SMXP_2_1, CLKGATE_OVERRIDE, 4, 1)
    FIELD(POR_FDC_AUX_CTL_MXP_U_SMXP_2_1, RESERVED_0, 0, 4)
REG32(POR_ERRFR_P0_D0_U_SMXP_2_1, 0x112f040)
    FIELD(POR_ERRFR_P0_D0_U_SMXP_2_1, FI, 6, 2)
    FIELD(POR_ERRFR_P0_D0_U_SMXP_2_1, UI, 4, 2)
    FIELD(POR_ERRFR_P0_D0_U_SMXP_2_1, ED, 0, 2)
REG32(POR_ERRCTLR_P0_D0_U_SMXP_2_1, 0x112f048)
    FIELD(POR_ERRCTLR_P0_D0_U_SMXP_2_1, RESERVED_32, 32, 32)
    FIELD(POR_ERRCTLR_P0_D0_U_SMXP_2_1, ERC, 14, 18)
    FIELD(POR_ERRCTLR_P0_D0_U_SMXP_2_1, FI, 3, 1)
    FIELD(POR_ERRCTLR_P0_D0_U_SMXP_2_1, UI, 2, 1)
    FIELD(POR_ERRCTLR_P0_D0_U_SMXP_2_1, ED, 0, 1)
REG32(POR_ERRSTATUS_P0_D0_U_SMXP_2_1, 0x112f050)
    FIELD(POR_ERRSTATUS_P0_D0_U_SMXP_2_1, RESERVED_31, 31, 33)
    FIELD(POR_ERRSTATUS_P0_D0_U_SMXP_2_1, V, 30, 1)
    FIELD(POR_ERRSTATUS_P0_D0_U_SMXP_2_1, UE, 29, 1)
    FIELD(POR_ERRSTATUS_P0_D0_U_SMXP_2_1, RESERVED_28, 28, 1)
    FIELD(POR_ERRSTATUS_P0_D0_U_SMXP_2_1, OF, 27, 1)
    FIELD(POR_ERRSTATUS_P0_D0_U_SMXP_2_1, RESERVED_24, 24, 3)
    FIELD(POR_ERRSTATUS_P0_D0_U_SMXP_2_1, DE, 23, 1)
    FIELD(POR_ERRSTATUS_P0_D0_U_SMXP_2_1, RESERVED_16, 16, 7)
    FIELD(POR_ERRSTATUS_P0_D0_U_SMXP_2_1, V_ERR_TYPE, 6, 10)
    FIELD(POR_ERRSTATUS_P0_D0_U_SMXP_2_1, RESERVED_0, 0, 6)
REG32(POR_FDC_AUX_CTL_P0_D0_U_SMXP_2_1, 0x112f058)
    FIELD(POR_FDC_AUX_CTL_P0_D0_U_SMXP_2_1, CLKGATE_OVERRIDE, 4, 1)
    FIELD(POR_FDC_AUX_CTL_P0_D0_U_SMXP_2_1, HANG_DET_CONFIG, 0, 4)
REG32(POR_ERRFR_P0_D1_U_SMXP_2_1, 0x112f080)
    FIELD(POR_ERRFR_P0_D1_U_SMXP_2_1, FI, 6, 2)
    FIELD(POR_ERRFR_P0_D1_U_SMXP_2_1, UI, 4, 2)
    FIELD(POR_ERRFR_P0_D1_U_SMXP_2_1, ED, 0, 2)
REG32(POR_ERRCTLR_P0_D1_U_SMXP_2_1, 0x112f088)
    FIELD(POR_ERRCTLR_P0_D1_U_SMXP_2_1, RESERVED_32, 32, 32)
    FIELD(POR_ERRCTLR_P0_D1_U_SMXP_2_1, ERC, 14, 18)
    FIELD(POR_ERRCTLR_P0_D1_U_SMXP_2_1, FI, 3, 1)
    FIELD(POR_ERRCTLR_P0_D1_U_SMXP_2_1, UI, 2, 1)
    FIELD(POR_ERRCTLR_P0_D1_U_SMXP_2_1, ED, 0, 1)
REG32(POR_ERRSTATUS_P0_D1_U_SMXP_2_1, 0x112f090)
    FIELD(POR_ERRSTATUS_P0_D1_U_SMXP_2_1, RESERVED_31, 31, 33)
    FIELD(POR_ERRSTATUS_P0_D1_U_SMXP_2_1, V, 30, 1)
    FIELD(POR_ERRSTATUS_P0_D1_U_SMXP_2_1, UE, 29, 1)
    FIELD(POR_ERRSTATUS_P0_D1_U_SMXP_2_1, RESERVED_28, 28, 1)
    FIELD(POR_ERRSTATUS_P0_D1_U_SMXP_2_1, OF, 27, 1)
    FIELD(POR_ERRSTATUS_P0_D1_U_SMXP_2_1, RESERVED_24, 24, 3)
    FIELD(POR_ERRSTATUS_P0_D1_U_SMXP_2_1, DE, 23, 1)
    FIELD(POR_ERRSTATUS_P0_D1_U_SMXP_2_1, RESERVED_16, 16, 7)
    FIELD(POR_ERRSTATUS_P0_D1_U_SMXP_2_1, V_ERR_TYPE, 6, 10)
    FIELD(POR_ERRSTATUS_P0_D1_U_SMXP_2_1, RESERVED_0, 0, 6)
REG32(POR_FDC_AUX_CTL_P0_D1_U_SMXP_2_1, 0x112f098)
    FIELD(POR_FDC_AUX_CTL_P0_D1_U_SMXP_2_1, CLKGATE_OVERRIDE, 4, 1)
    FIELD(POR_FDC_AUX_CTL_P0_D1_U_SMXP_2_1, HANG_DET_CONFIG, 0, 4)
REG32(POR_ERRFR_P0_D2_U_SMXP_2_1, 0x112f0c0)
    FIELD(POR_ERRFR_P0_D2_U_SMXP_2_1, FI, 6, 2)
    FIELD(POR_ERRFR_P0_D2_U_SMXP_2_1, UI, 4, 2)
    FIELD(POR_ERRFR_P0_D2_U_SMXP_2_1, ED, 0, 2)
REG32(POR_ERRCTLR_P0_D2_U_SMXP_2_1, 0x112f0c8)
    FIELD(POR_ERRCTLR_P0_D2_U_SMXP_2_1, RESERVED_32, 32, 32)
    FIELD(POR_ERRCTLR_P0_D2_U_SMXP_2_1, ERC, 14, 18)
    FIELD(POR_ERRCTLR_P0_D2_U_SMXP_2_1, FI, 3, 1)
    FIELD(POR_ERRCTLR_P0_D2_U_SMXP_2_1, UI, 2, 1)
    FIELD(POR_ERRCTLR_P0_D2_U_SMXP_2_1, ED, 0, 1)
REG32(POR_ERRSTATUS_P0_D2_U_SMXP_2_1, 0x112f0d0)
    FIELD(POR_ERRSTATUS_P0_D2_U_SMXP_2_1, RESERVED_31, 31, 33)
    FIELD(POR_ERRSTATUS_P0_D2_U_SMXP_2_1, V, 30, 1)
    FIELD(POR_ERRSTATUS_P0_D2_U_SMXP_2_1, UE, 29, 1)
    FIELD(POR_ERRSTATUS_P0_D2_U_SMXP_2_1, RESERVED_28, 28, 1)
    FIELD(POR_ERRSTATUS_P0_D2_U_SMXP_2_1, OF, 27, 1)
    FIELD(POR_ERRSTATUS_P0_D2_U_SMXP_2_1, RESERVED_24, 24, 3)
    FIELD(POR_ERRSTATUS_P0_D2_U_SMXP_2_1, DE, 23, 1)
    FIELD(POR_ERRSTATUS_P0_D2_U_SMXP_2_1, RESERVED_16, 16, 7)
    FIELD(POR_ERRSTATUS_P0_D2_U_SMXP_2_1, V_ERR_TYPE, 6, 10)
    FIELD(POR_ERRSTATUS_P0_D2_U_SMXP_2_1, RESERVED_0, 0, 6)
REG32(POR_FDC_AUX_CTL_P0_D2_U_SMXP_2_1, 0x112f0d8)
    FIELD(POR_FDC_AUX_CTL_P0_D2_U_SMXP_2_1, CLKGATE_OVERRIDE, 4, 1)
    FIELD(POR_FDC_AUX_CTL_P0_D2_U_SMXP_2_1, HANG_DET_CONFIG, 0, 4)
REG32(POR_ERRFR_P0_D3_U_SMXP_2_1, 0x112f100)
    FIELD(POR_ERRFR_P0_D3_U_SMXP_2_1, FI, 6, 2)
    FIELD(POR_ERRFR_P0_D3_U_SMXP_2_1, UI, 4, 2)
    FIELD(POR_ERRFR_P0_D3_U_SMXP_2_1, ED, 0, 2)
REG32(POR_ERRCTLR_P0_D3_U_SMXP_2_1, 0x112f108)
    FIELD(POR_ERRCTLR_P0_D3_U_SMXP_2_1, RESERVED_32, 32, 32)
    FIELD(POR_ERRCTLR_P0_D3_U_SMXP_2_1, ERC, 14, 18)
    FIELD(POR_ERRCTLR_P0_D3_U_SMXP_2_1, FI, 3, 1)
    FIELD(POR_ERRCTLR_P0_D3_U_SMXP_2_1, UI, 2, 1)
    FIELD(POR_ERRCTLR_P0_D3_U_SMXP_2_1, ED, 0, 1)
REG32(POR_ERRSTATUS_P0_D3_U_SMXP_2_1, 0x112f110)
    FIELD(POR_ERRSTATUS_P0_D3_U_SMXP_2_1, RESERVED_31, 31, 33)
    FIELD(POR_ERRSTATUS_P0_D3_U_SMXP_2_1, V, 30, 1)
    FIELD(POR_ERRSTATUS_P0_D3_U_SMXP_2_1, UE, 29, 1)
    FIELD(POR_ERRSTATUS_P0_D3_U_SMXP_2_1, RESERVED_28, 28, 1)
    FIELD(POR_ERRSTATUS_P0_D3_U_SMXP_2_1, OF, 27, 1)
    FIELD(POR_ERRSTATUS_P0_D3_U_SMXP_2_1, RESERVED_24, 24, 3)
    FIELD(POR_ERRSTATUS_P0_D3_U_SMXP_2_1, DE, 23, 1)
    FIELD(POR_ERRSTATUS_P0_D3_U_SMXP_2_1, RESERVED_16, 16, 7)
    FIELD(POR_ERRSTATUS_P0_D3_U_SMXP_2_1, V_ERR_TYPE, 6, 10)
    FIELD(POR_ERRSTATUS_P0_D3_U_SMXP_2_1, RESERVED_0, 0, 6)
REG32(POR_FDC_AUX_CTL_P0_D3_U_SMXP_2_1, 0x112f118)
    FIELD(POR_FDC_AUX_CTL_P0_D3_U_SMXP_2_1, CLKGATE_OVERRIDE, 4, 1)
    FIELD(POR_FDC_AUX_CTL_P0_D3_U_SMXP_2_1, HANG_DET_CONFIG, 0, 4)
REG32(POR_ERRFR_P1_D0_U_SMXP_2_1, 0x112f140)
    FIELD(POR_ERRFR_P1_D0_U_SMXP_2_1, FI, 6, 2)
    FIELD(POR_ERRFR_P1_D0_U_SMXP_2_1, UI, 4, 2)
    FIELD(POR_ERRFR_P1_D0_U_SMXP_2_1, ED, 0, 2)
REG32(POR_ERRCTLR_P1_D0_U_SMXP_2_1, 0x112f148)
    FIELD(POR_ERRCTLR_P1_D0_U_SMXP_2_1, RESERVED_32, 32, 32)
    FIELD(POR_ERRCTLR_P1_D0_U_SMXP_2_1, ERC, 14, 18)
    FIELD(POR_ERRCTLR_P1_D0_U_SMXP_2_1, FI, 3, 1)
    FIELD(POR_ERRCTLR_P1_D0_U_SMXP_2_1, UI, 2, 1)
    FIELD(POR_ERRCTLR_P1_D0_U_SMXP_2_1, ED, 0, 1)
REG32(POR_ERRSTATUS_P1_D0_U_SMXP_2_1, 0x112f150)
    FIELD(POR_ERRSTATUS_P1_D0_U_SMXP_2_1, RESERVED_31, 31, 33)
    FIELD(POR_ERRSTATUS_P1_D0_U_SMXP_2_1, V, 30, 1)
    FIELD(POR_ERRSTATUS_P1_D0_U_SMXP_2_1, UE, 29, 1)
    FIELD(POR_ERRSTATUS_P1_D0_U_SMXP_2_1, RESERVED_28, 28, 1)
    FIELD(POR_ERRSTATUS_P1_D0_U_SMXP_2_1, OF, 27, 1)
    FIELD(POR_ERRSTATUS_P1_D0_U_SMXP_2_1, RESERVED_24, 24, 3)
    FIELD(POR_ERRSTATUS_P1_D0_U_SMXP_2_1, DE, 23, 1)
    FIELD(POR_ERRSTATUS_P1_D0_U_SMXP_2_1, RESERVED_16, 16, 7)
    FIELD(POR_ERRSTATUS_P1_D0_U_SMXP_2_1, V_ERR_TYPE, 6, 10)
    FIELD(POR_ERRSTATUS_P1_D0_U_SMXP_2_1, RESERVED_0, 0, 6)
REG32(POR_FDC_AUX_CTL_P1_D0_U_SMXP_2_1, 0x112f158)
    FIELD(POR_FDC_AUX_CTL_P1_D0_U_SMXP_2_1, CLKGATE_OVERRIDE, 4, 1)
    FIELD(POR_FDC_AUX_CTL_P1_D0_U_SMXP_2_1, HANG_DET_CONFIG, 0, 4)
REG32(POR_ERRFR_P1_D1_U_SMXP_2_1, 0x112f180)
    FIELD(POR_ERRFR_P1_D1_U_SMXP_2_1, FI, 6, 2)
    FIELD(POR_ERRFR_P1_D1_U_SMXP_2_1, UI, 4, 2)
    FIELD(POR_ERRFR_P1_D1_U_SMXP_2_1, ED, 0, 2)
REG32(POR_ERRCTLR_P1_D1_U_SMXP_2_1, 0x112f188)
    FIELD(POR_ERRCTLR_P1_D1_U_SMXP_2_1, RESERVED_32, 32, 32)
    FIELD(POR_ERRCTLR_P1_D1_U_SMXP_2_1, ERC, 14, 18)
    FIELD(POR_ERRCTLR_P1_D1_U_SMXP_2_1, FI, 3, 1)
    FIELD(POR_ERRCTLR_P1_D1_U_SMXP_2_1, UI, 2, 1)
    FIELD(POR_ERRCTLR_P1_D1_U_SMXP_2_1, ED, 0, 1)
REG32(POR_ERRSTATUS_P1_D1_U_SMXP_2_1, 0x112f190)
    FIELD(POR_ERRSTATUS_P1_D1_U_SMXP_2_1, RESERVED_31, 31, 33)
    FIELD(POR_ERRSTATUS_P1_D1_U_SMXP_2_1, V, 30, 1)
    FIELD(POR_ERRSTATUS_P1_D1_U_SMXP_2_1, UE, 29, 1)
    FIELD(POR_ERRSTATUS_P1_D1_U_SMXP_2_1, RESERVED_28, 28, 1)
    FIELD(POR_ERRSTATUS_P1_D1_U_SMXP_2_1, OF, 27, 1)
    FIELD(POR_ERRSTATUS_P1_D1_U_SMXP_2_1, RESERVED_24, 24, 3)
    FIELD(POR_ERRSTATUS_P1_D1_U_SMXP_2_1, DE, 23, 1)
    FIELD(POR_ERRSTATUS_P1_D1_U_SMXP_2_1, RESERVED_16, 16, 7)
    FIELD(POR_ERRSTATUS_P1_D1_U_SMXP_2_1, V_ERR_TYPE, 6, 10)
    FIELD(POR_ERRSTATUS_P1_D1_U_SMXP_2_1, RESERVED_0, 0, 6)
REG32(POR_FDC_AUX_CTL_P1_D1_U_SMXP_2_1, 0x112f198)
    FIELD(POR_FDC_AUX_CTL_P1_D1_U_SMXP_2_1, CLKGATE_OVERRIDE, 4, 1)
    FIELD(POR_FDC_AUX_CTL_P1_D1_U_SMXP_2_1, HANG_DET_CONFIG, 0, 4)
REG32(POR_ERRFR_P1_D2_U_SMXP_2_1, 0x112f1c0)
    FIELD(POR_ERRFR_P1_D2_U_SMXP_2_1, FI, 6, 2)
    FIELD(POR_ERRFR_P1_D2_U_SMXP_2_1, UI, 4, 2)
    FIELD(POR_ERRFR_P1_D2_U_SMXP_2_1, ED, 0, 2)
REG32(POR_ERRCTLR_P1_D2_U_SMXP_2_1, 0x112f1c8)
    FIELD(POR_ERRCTLR_P1_D2_U_SMXP_2_1, RESERVED_32, 32, 32)
    FIELD(POR_ERRCTLR_P1_D2_U_SMXP_2_1, ERC, 14, 18)
    FIELD(POR_ERRCTLR_P1_D2_U_SMXP_2_1, FI, 3, 1)
    FIELD(POR_ERRCTLR_P1_D2_U_SMXP_2_1, UI, 2, 1)
    FIELD(POR_ERRCTLR_P1_D2_U_SMXP_2_1, ED, 0, 1)
REG32(POR_ERRSTATUS_P1_D2_U_SMXP_2_1, 0x112f1d0)
    FIELD(POR_ERRSTATUS_P1_D2_U_SMXP_2_1, RESERVED_31, 31, 33)
    FIELD(POR_ERRSTATUS_P1_D2_U_SMXP_2_1, V, 30, 1)
    FIELD(POR_ERRSTATUS_P1_D2_U_SMXP_2_1, UE, 29, 1)
    FIELD(POR_ERRSTATUS_P1_D2_U_SMXP_2_1, RESERVED_28, 28, 1)
    FIELD(POR_ERRSTATUS_P1_D2_U_SMXP_2_1, OF, 27, 1)
    FIELD(POR_ERRSTATUS_P1_D2_U_SMXP_2_1, RESERVED_24, 24, 3)
    FIELD(POR_ERRSTATUS_P1_D2_U_SMXP_2_1, DE, 23, 1)
    FIELD(POR_ERRSTATUS_P1_D2_U_SMXP_2_1, RESERVED_16, 16, 7)
    FIELD(POR_ERRSTATUS_P1_D2_U_SMXP_2_1, V_ERR_TYPE, 6, 10)
    FIELD(POR_ERRSTATUS_P1_D2_U_SMXP_2_1, RESERVED_0, 0, 6)
REG32(POR_FDC_AUX_CTL_P1_D2_U_SMXP_2_1, 0x112f1d8)
    FIELD(POR_FDC_AUX_CTL_P1_D2_U_SMXP_2_1, CLKGATE_OVERRIDE, 4, 1)
    FIELD(POR_FDC_AUX_CTL_P1_D2_U_SMXP_2_1, HANG_DET_CONFIG, 0, 4)
REG32(POR_ERRFR_P1_D3_U_SMXP_2_1, 0x112f200)
    FIELD(POR_ERRFR_P1_D3_U_SMXP_2_1, FI, 6, 2)
    FIELD(POR_ERRFR_P1_D3_U_SMXP_2_1, UI, 4, 2)
    FIELD(POR_ERRFR_P1_D3_U_SMXP_2_1, ED, 0, 2)
REG32(POR_ERRCTLR_P1_D3_U_SMXP_2_1, 0x112f208)
    FIELD(POR_ERRCTLR_P1_D3_U_SMXP_2_1, RESERVED_32, 32, 32)
    FIELD(POR_ERRCTLR_P1_D3_U_SMXP_2_1, ERC, 14, 18)
    FIELD(POR_ERRCTLR_P1_D3_U_SMXP_2_1, FI, 3, 1)
    FIELD(POR_ERRCTLR_P1_D3_U_SMXP_2_1, UI, 2, 1)
    FIELD(POR_ERRCTLR_P1_D3_U_SMXP_2_1, ED, 0, 1)
REG32(POR_ERRSTATUS_P1_D3_U_SMXP_2_1, 0x112f210)
    FIELD(POR_ERRSTATUS_P1_D3_U_SMXP_2_1, RESERVED_31, 31, 33)
    FIELD(POR_ERRSTATUS_P1_D3_U_SMXP_2_1, V, 30, 1)
    FIELD(POR_ERRSTATUS_P1_D3_U_SMXP_2_1, UE, 29, 1)
    FIELD(POR_ERRSTATUS_P1_D3_U_SMXP_2_1, RESERVED_28, 28, 1)
    FIELD(POR_ERRSTATUS_P1_D3_U_SMXP_2_1, OF, 27, 1)
    FIELD(POR_ERRSTATUS_P1_D3_U_SMXP_2_1, RESERVED_24, 24, 3)
    FIELD(POR_ERRSTATUS_P1_D3_U_SMXP_2_1, DE, 23, 1)
    FIELD(POR_ERRSTATUS_P1_D3_U_SMXP_2_1, RESERVED_16, 16, 7)
    FIELD(POR_ERRSTATUS_P1_D3_U_SMXP_2_1, V_ERR_TYPE, 6, 10)
    FIELD(POR_ERRSTATUS_P1_D3_U_SMXP_2_1, RESERVED_0, 0, 6)
REG32(POR_FDC_AUX_CTL_P1_D3_U_SMXP_2_1, 0x112f218)
    FIELD(POR_FDC_AUX_CTL_P1_D3_U_SMXP_2_1, CLKGATE_OVERRIDE, 4, 1)
    FIELD(POR_FDC_AUX_CTL_P1_D3_U_SMXP_2_1, HANG_DET_CONFIG, 0, 4)
REG32(POR_ERRINJECT_U_SMXP_2_1, 0x112f300)
    FIELD(POR_ERRINJECT_U_SMXP_2_1, ERR_DEV, 4, 4)
    FIELD(POR_ERRINJECT_U_SMXP_2_1, ERR_TYPE, 0, 4)
REG32(POR_FDC_KEY_U_SMXP_2_1, 0x112f308)
    FIELD(POR_FDC_KEY_U_SMXP_2_1, KEY, 0, 8)
REG32(POR_MPU_NODE_INFO_U_SMXP_2_1, 0x113c000)
    FIELD(POR_MPU_NODE_INFO_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_NODE_INFO_U_SMXP_2_1, LOGICAL_ID, 32, 16)
    FIELD(POR_MPU_NODE_INFO_U_SMXP_2_1, NODE_ID, 16, 16)
    FIELD(POR_MPU_NODE_INFO_U_SMXP_2_1, NODE_TYPE, 0, 16)
REG32(POR_MPU_CHILD_INFO_U_SMXP_2_1, 0x113c080)
    FIELD(POR_MPU_CHILD_INFO_U_SMXP_2_1, RESERVED_32, 32, 32)
    FIELD(POR_MPU_CHILD_INFO_U_SMXP_2_1, CHILD_PTR_OFFSET, 16, 16)
    FIELD(POR_MPU_CHILD_INFO_U_SMXP_2_1, CHILD_COUNT, 0, 16)
REG32(POR_MPU_UNIT_INFO_U_SMXP_2_1, 0x113c900)
    FIELD(POR_MPU_UNIT_INFO_U_SMXP_2_1, RESERVED_16, 16, 48)
    FIELD(POR_MPU_UNIT_INFO_U_SMXP_2_1, MASTER_7_PRESENT, 15, 1)
    FIELD(POR_MPU_UNIT_INFO_U_SMXP_2_1, MASTER_6_PRESENT, 14, 1)
    FIELD(POR_MPU_UNIT_INFO_U_SMXP_2_1, MASTER_5_PRESENT, 13, 1)
    FIELD(POR_MPU_UNIT_INFO_U_SMXP_2_1, MASTER_4_PRESENT, 12, 1)
    FIELD(POR_MPU_UNIT_INFO_U_SMXP_2_1, MASTER_3_PRESENT, 11, 1)
    FIELD(POR_MPU_UNIT_INFO_U_SMXP_2_1, MASTER_2_PRESENT, 10, 1)
    FIELD(POR_MPU_UNIT_INFO_U_SMXP_2_1, MASTER_1_PRESENT, 9, 1)
    FIELD(POR_MPU_UNIT_INFO_U_SMXP_2_1, MASTER_0_PRESENT, 8, 1)
    FIELD(POR_MPU_UNIT_INFO_U_SMXP_2_1, NUM_PROG_REGION, 0, 8)
REG32(POR_MPU_M0_CTL_U_SMXP_2_1, 0x113d000)
    FIELD(POR_MPU_M0_CTL_U_SMXP_2_1, M0_EN, 2, 1)
    FIELD(POR_MPU_M0_CTL_U_SMXP_2_1, M0_ACTION, 0, 2)
REG32(POR_MPU_M0_PRBAR0_U_SMXP_2_1, 0x113d010)
    FIELD(POR_MPU_M0_PRBAR0_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR0_U_SMXP_2_1, REGION0_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR0_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR0_U_SMXP_2_1, REGION0_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR0_U_SMXP_2_1, REGION0_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR0_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR0_U_SMXP_2_1, 0x113d018)
    FIELD(POR_MPU_M0_PRLAR0_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR0_U_SMXP_2_1, REGION0_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR0_U_SMXP_2_1, REGION0_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR1_U_SMXP_2_1, 0x113d020)
    FIELD(POR_MPU_M0_PRBAR1_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR1_U_SMXP_2_1, REGION1_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR1_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR1_U_SMXP_2_1, REGION1_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR1_U_SMXP_2_1, REGION1_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR1_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR1_U_SMXP_2_1, 0x113d028)
    FIELD(POR_MPU_M0_PRLAR1_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR1_U_SMXP_2_1, REGION1_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR1_U_SMXP_2_1, REGION1_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR2_U_SMXP_2_1, 0x113d030)
    FIELD(POR_MPU_M0_PRBAR2_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR2_U_SMXP_2_1, REGION2_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR2_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR2_U_SMXP_2_1, REGION2_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR2_U_SMXP_2_1, REGION2_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR2_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR2_U_SMXP_2_1, 0x113d038)
    FIELD(POR_MPU_M0_PRLAR2_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR2_U_SMXP_2_1, REGION2_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR2_U_SMXP_2_1, REGION2_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR3_U_SMXP_2_1, 0x113d040)
    FIELD(POR_MPU_M0_PRBAR3_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR3_U_SMXP_2_1, REGION3_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR3_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR3_U_SMXP_2_1, REGION3_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR3_U_SMXP_2_1, REGION3_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR3_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR3_U_SMXP_2_1, 0x113d048)
    FIELD(POR_MPU_M0_PRLAR3_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR3_U_SMXP_2_1, REGION3_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR3_U_SMXP_2_1, REGION3_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR4_U_SMXP_2_1, 0x113d050)
    FIELD(POR_MPU_M0_PRBAR4_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR4_U_SMXP_2_1, REGION4_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR4_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR4_U_SMXP_2_1, REGION4_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR4_U_SMXP_2_1, REGION4_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR4_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR4_U_SMXP_2_1, 0x113d058)
    FIELD(POR_MPU_M0_PRLAR4_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR4_U_SMXP_2_1, REGION4_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR4_U_SMXP_2_1, REGION4_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR5_U_SMXP_2_1, 0x113d060)
    FIELD(POR_MPU_M0_PRBAR5_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR5_U_SMXP_2_1, REGION5_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR5_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR5_U_SMXP_2_1, REGION5_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR5_U_SMXP_2_1, REGION5_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR5_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR5_U_SMXP_2_1, 0x113d068)
    FIELD(POR_MPU_M0_PRLAR5_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR5_U_SMXP_2_1, REGION5_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR5_U_SMXP_2_1, REGION5_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR6_U_SMXP_2_1, 0x113d070)
    FIELD(POR_MPU_M0_PRBAR6_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR6_U_SMXP_2_1, REGION6_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR6_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR6_U_SMXP_2_1, REGION6_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR6_U_SMXP_2_1, REGION6_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR6_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR6_U_SMXP_2_1, 0x113d078)
    FIELD(POR_MPU_M0_PRLAR6_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR6_U_SMXP_2_1, REGION6_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR6_U_SMXP_2_1, REGION6_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR7_U_SMXP_2_1, 0x113d080)
    FIELD(POR_MPU_M0_PRBAR7_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR7_U_SMXP_2_1, REGION7_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR7_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR7_U_SMXP_2_1, REGION7_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR7_U_SMXP_2_1, REGION7_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR7_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR7_U_SMXP_2_1, 0x113d088)
    FIELD(POR_MPU_M0_PRLAR7_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR7_U_SMXP_2_1, REGION7_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR7_U_SMXP_2_1, REGION7_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR8_U_SMXP_2_1, 0x113d090)
    FIELD(POR_MPU_M0_PRBAR8_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR8_U_SMXP_2_1, REGION8_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR8_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR8_U_SMXP_2_1, REGION8_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR8_U_SMXP_2_1, REGION8_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR8_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR8_U_SMXP_2_1, 0x113d098)
    FIELD(POR_MPU_M0_PRLAR8_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR8_U_SMXP_2_1, REGION8_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR8_U_SMXP_2_1, REGION8_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR9_U_SMXP_2_1, 0x113d0a0)
    FIELD(POR_MPU_M0_PRBAR9_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR9_U_SMXP_2_1, REGION9_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR9_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR9_U_SMXP_2_1, REGION9_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR9_U_SMXP_2_1, REGION9_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR9_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR9_U_SMXP_2_1, 0x113d0a8)
    FIELD(POR_MPU_M0_PRLAR9_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR9_U_SMXP_2_1, REGION9_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR9_U_SMXP_2_1, REGION9_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR10_U_SMXP_2_1, 0x113d0b0)
    FIELD(POR_MPU_M0_PRBAR10_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR10_U_SMXP_2_1, REGION10_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR10_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR10_U_SMXP_2_1, REGION10_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR10_U_SMXP_2_1, REGION10_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR10_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR10_U_SMXP_2_1, 0x113d0b8)
    FIELD(POR_MPU_M0_PRLAR10_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR10_U_SMXP_2_1, REGION10_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR10_U_SMXP_2_1, REGION10_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR11_U_SMXP_2_1, 0x113d0c0)
    FIELD(POR_MPU_M0_PRBAR11_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR11_U_SMXP_2_1, REGION11_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR11_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR11_U_SMXP_2_1, REGION11_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR11_U_SMXP_2_1, REGION11_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR11_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR11_U_SMXP_2_1, 0x113d0c8)
    FIELD(POR_MPU_M0_PRLAR11_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR11_U_SMXP_2_1, REGION11_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR11_U_SMXP_2_1, REGION11_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR12_U_SMXP_2_1, 0x113d0d0)
    FIELD(POR_MPU_M0_PRBAR12_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR12_U_SMXP_2_1, REGION12_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR12_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR12_U_SMXP_2_1, REGION12_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR12_U_SMXP_2_1, REGION12_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR12_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR12_U_SMXP_2_1, 0x113d0d8)
    FIELD(POR_MPU_M0_PRLAR12_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR12_U_SMXP_2_1, REGION12_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR12_U_SMXP_2_1, REGION12_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR13_U_SMXP_2_1, 0x113d0e0)
    FIELD(POR_MPU_M0_PRBAR13_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR13_U_SMXP_2_1, REGION13_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR13_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR13_U_SMXP_2_1, REGION13_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR13_U_SMXP_2_1, REGION13_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR13_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR13_U_SMXP_2_1, 0x113d0e8)
    FIELD(POR_MPU_M0_PRLAR13_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR13_U_SMXP_2_1, REGION13_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR13_U_SMXP_2_1, REGION13_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR14_U_SMXP_2_1, 0x113d0f0)
    FIELD(POR_MPU_M0_PRBAR14_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR14_U_SMXP_2_1, REGION14_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR14_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR14_U_SMXP_2_1, REGION14_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR14_U_SMXP_2_1, REGION14_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR14_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR14_U_SMXP_2_1, 0x113d0f8)
    FIELD(POR_MPU_M0_PRLAR14_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR14_U_SMXP_2_1, REGION14_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR14_U_SMXP_2_1, REGION14_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR15_U_SMXP_2_1, 0x113d100)
    FIELD(POR_MPU_M0_PRBAR15_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR15_U_SMXP_2_1, REGION15_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR15_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR15_U_SMXP_2_1, REGION15_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR15_U_SMXP_2_1, REGION15_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR15_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR15_U_SMXP_2_1, 0x113d108)
    FIELD(POR_MPU_M0_PRLAR15_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR15_U_SMXP_2_1, REGION15_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR15_U_SMXP_2_1, REGION15_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR16_U_SMXP_2_1, 0x113d110)
    FIELD(POR_MPU_M0_PRBAR16_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR16_U_SMXP_2_1, REGION16_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR16_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR16_U_SMXP_2_1, REGION16_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR16_U_SMXP_2_1, REGION16_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR16_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR16_U_SMXP_2_1, 0x113d118)
    FIELD(POR_MPU_M0_PRLAR16_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR16_U_SMXP_2_1, REGION16_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR16_U_SMXP_2_1, REGION16_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR17_U_SMXP_2_1, 0x113d120)
    FIELD(POR_MPU_M0_PRBAR17_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR17_U_SMXP_2_1, REGION17_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR17_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR17_U_SMXP_2_1, REGION17_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR17_U_SMXP_2_1, REGION17_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR17_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR17_U_SMXP_2_1, 0x113d128)
    FIELD(POR_MPU_M0_PRLAR17_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR17_U_SMXP_2_1, REGION17_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR17_U_SMXP_2_1, REGION17_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR18_U_SMXP_2_1, 0x113d130)
    FIELD(POR_MPU_M0_PRBAR18_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR18_U_SMXP_2_1, REGION18_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR18_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR18_U_SMXP_2_1, REGION18_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR18_U_SMXP_2_1, REGION18_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR18_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR18_U_SMXP_2_1, 0x113d138)
    FIELD(POR_MPU_M0_PRLAR18_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR18_U_SMXP_2_1, REGION18_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR18_U_SMXP_2_1, REGION18_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR19_U_SMXP_2_1, 0x113d140)
    FIELD(POR_MPU_M0_PRBAR19_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR19_U_SMXP_2_1, REGION19_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR19_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR19_U_SMXP_2_1, REGION19_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR19_U_SMXP_2_1, REGION19_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR19_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR19_U_SMXP_2_1, 0x113d148)
    FIELD(POR_MPU_M0_PRLAR19_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR19_U_SMXP_2_1, REGION19_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR19_U_SMXP_2_1, REGION19_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR20_U_SMXP_2_1, 0x113d150)
    FIELD(POR_MPU_M0_PRBAR20_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR20_U_SMXP_2_1, REGION20_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR20_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR20_U_SMXP_2_1, REGION20_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR20_U_SMXP_2_1, REGION20_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR20_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR20_U_SMXP_2_1, 0x113d158)
    FIELD(POR_MPU_M0_PRLAR20_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR20_U_SMXP_2_1, REGION20_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR20_U_SMXP_2_1, REGION20_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR21_U_SMXP_2_1, 0x113d160)
    FIELD(POR_MPU_M0_PRBAR21_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR21_U_SMXP_2_1, REGION21_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR21_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR21_U_SMXP_2_1, REGION21_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR21_U_SMXP_2_1, REGION21_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR21_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR21_U_SMXP_2_1, 0x113d168)
    FIELD(POR_MPU_M0_PRLAR21_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR21_U_SMXP_2_1, REGION21_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR21_U_SMXP_2_1, REGION21_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR22_U_SMXP_2_1, 0x113d170)
    FIELD(POR_MPU_M0_PRBAR22_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR22_U_SMXP_2_1, REGION22_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR22_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR22_U_SMXP_2_1, REGION22_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR22_U_SMXP_2_1, REGION22_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR22_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR22_U_SMXP_2_1, 0x113d178)
    FIELD(POR_MPU_M0_PRLAR22_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR22_U_SMXP_2_1, REGION22_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR22_U_SMXP_2_1, REGION22_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR23_U_SMXP_2_1, 0x113d180)
    FIELD(POR_MPU_M0_PRBAR23_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR23_U_SMXP_2_1, REGION23_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR23_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR23_U_SMXP_2_1, REGION23_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR23_U_SMXP_2_1, REGION23_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR23_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR23_U_SMXP_2_1, 0x113d188)
    FIELD(POR_MPU_M0_PRLAR23_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR23_U_SMXP_2_1, REGION23_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR23_U_SMXP_2_1, REGION23_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR24_U_SMXP_2_1, 0x113d190)
    FIELD(POR_MPU_M0_PRBAR24_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR24_U_SMXP_2_1, REGION24_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR24_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR24_U_SMXP_2_1, REGION24_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR24_U_SMXP_2_1, REGION24_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR24_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR24_U_SMXP_2_1, 0x113d198)
    FIELD(POR_MPU_M0_PRLAR24_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR24_U_SMXP_2_1, REGION24_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR24_U_SMXP_2_1, REGION24_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR25_U_SMXP_2_1, 0x113d1a0)
    FIELD(POR_MPU_M0_PRBAR25_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR25_U_SMXP_2_1, REGION25_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR25_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR25_U_SMXP_2_1, REGION25_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR25_U_SMXP_2_1, REGION25_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR25_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR25_U_SMXP_2_1, 0x113d1a8)
    FIELD(POR_MPU_M0_PRLAR25_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR25_U_SMXP_2_1, REGION25_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR25_U_SMXP_2_1, REGION25_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR26_U_SMXP_2_1, 0x113d1b0)
    FIELD(POR_MPU_M0_PRBAR26_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR26_U_SMXP_2_1, REGION26_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR26_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR26_U_SMXP_2_1, REGION26_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR26_U_SMXP_2_1, REGION26_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR26_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR26_U_SMXP_2_1, 0x113d1b8)
    FIELD(POR_MPU_M0_PRLAR26_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR26_U_SMXP_2_1, REGION26_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR26_U_SMXP_2_1, REGION26_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR27_U_SMXP_2_1, 0x113d1c0)
    FIELD(POR_MPU_M0_PRBAR27_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR27_U_SMXP_2_1, REGION27_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR27_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR27_U_SMXP_2_1, REGION27_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR27_U_SMXP_2_1, REGION27_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR27_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR27_U_SMXP_2_1, 0x113d1c8)
    FIELD(POR_MPU_M0_PRLAR27_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR27_U_SMXP_2_1, REGION27_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR27_U_SMXP_2_1, REGION27_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR28_U_SMXP_2_1, 0x113d1d0)
    FIELD(POR_MPU_M0_PRBAR28_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR28_U_SMXP_2_1, REGION28_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR28_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR28_U_SMXP_2_1, REGION28_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR28_U_SMXP_2_1, REGION28_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR28_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR28_U_SMXP_2_1, 0x113d1d8)
    FIELD(POR_MPU_M0_PRLAR28_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR28_U_SMXP_2_1, REGION28_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR28_U_SMXP_2_1, REGION28_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR29_U_SMXP_2_1, 0x113d1e0)
    FIELD(POR_MPU_M0_PRBAR29_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR29_U_SMXP_2_1, REGION29_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR29_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR29_U_SMXP_2_1, REGION29_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR29_U_SMXP_2_1, REGION29_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR29_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR29_U_SMXP_2_1, 0x113d1e8)
    FIELD(POR_MPU_M0_PRLAR29_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR29_U_SMXP_2_1, REGION29_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR29_U_SMXP_2_1, REGION29_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR30_U_SMXP_2_1, 0x113d1f0)
    FIELD(POR_MPU_M0_PRBAR30_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR30_U_SMXP_2_1, REGION30_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR30_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR30_U_SMXP_2_1, REGION30_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR30_U_SMXP_2_1, REGION30_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR30_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR30_U_SMXP_2_1, 0x113d1f8)
    FIELD(POR_MPU_M0_PRLAR30_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR30_U_SMXP_2_1, REGION30_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR30_U_SMXP_2_1, REGION30_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR31_U_SMXP_2_1, 0x113d200)
    FIELD(POR_MPU_M0_PRBAR31_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR31_U_SMXP_2_1, REGION31_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR31_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR31_U_SMXP_2_1, REGION31_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR31_U_SMXP_2_1, REGION31_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR31_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR31_U_SMXP_2_1, 0x113d208)
    FIELD(POR_MPU_M0_PRLAR31_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR31_U_SMXP_2_1, REGION31_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR31_U_SMXP_2_1, REGION31_EN, 0, 1)
REG32(POR_MPU_M1_CTL_U_SMXP_2_1, 0x113d400)
    FIELD(POR_MPU_M1_CTL_U_SMXP_2_1, M1_EN, 2, 1)
    FIELD(POR_MPU_M1_CTL_U_SMXP_2_1, M1_ACTION, 0, 2)
REG32(POR_MPU_M1_PRBAR0_U_SMXP_2_1, 0x113d410)
    FIELD(POR_MPU_M1_PRBAR0_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR0_U_SMXP_2_1, REGION0_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR0_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR0_U_SMXP_2_1, REGION0_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR0_U_SMXP_2_1, REGION0_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR0_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR0_U_SMXP_2_1, 0x113d418)
    FIELD(POR_MPU_M1_PRLAR0_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR0_U_SMXP_2_1, REGION0_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR0_U_SMXP_2_1, REGION0_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR1_U_SMXP_2_1, 0x113d420)
    FIELD(POR_MPU_M1_PRBAR1_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR1_U_SMXP_2_1, REGION1_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR1_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR1_U_SMXP_2_1, REGION1_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR1_U_SMXP_2_1, REGION1_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR1_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR1_U_SMXP_2_1, 0x113d428)
    FIELD(POR_MPU_M1_PRLAR1_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR1_U_SMXP_2_1, REGION1_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR1_U_SMXP_2_1, REGION1_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR2_U_SMXP_2_1, 0x113d430)
    FIELD(POR_MPU_M1_PRBAR2_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR2_U_SMXP_2_1, REGION2_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR2_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR2_U_SMXP_2_1, REGION2_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR2_U_SMXP_2_1, REGION2_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR2_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR2_U_SMXP_2_1, 0x113d438)
    FIELD(POR_MPU_M1_PRLAR2_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR2_U_SMXP_2_1, REGION2_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR2_U_SMXP_2_1, REGION2_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR3_U_SMXP_2_1, 0x113d440)
    FIELD(POR_MPU_M1_PRBAR3_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR3_U_SMXP_2_1, REGION3_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR3_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR3_U_SMXP_2_1, REGION3_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR3_U_SMXP_2_1, REGION3_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR3_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR3_U_SMXP_2_1, 0x113d448)
    FIELD(POR_MPU_M1_PRLAR3_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR3_U_SMXP_2_1, REGION3_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR3_U_SMXP_2_1, REGION3_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR4_U_SMXP_2_1, 0x113d450)
    FIELD(POR_MPU_M1_PRBAR4_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR4_U_SMXP_2_1, REGION4_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR4_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR4_U_SMXP_2_1, REGION4_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR4_U_SMXP_2_1, REGION4_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR4_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR4_U_SMXP_2_1, 0x113d458)
    FIELD(POR_MPU_M1_PRLAR4_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR4_U_SMXP_2_1, REGION4_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR4_U_SMXP_2_1, REGION4_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR5_U_SMXP_2_1, 0x113d460)
    FIELD(POR_MPU_M1_PRBAR5_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR5_U_SMXP_2_1, REGION5_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR5_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR5_U_SMXP_2_1, REGION5_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR5_U_SMXP_2_1, REGION5_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR5_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR5_U_SMXP_2_1, 0x113d468)
    FIELD(POR_MPU_M1_PRLAR5_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR5_U_SMXP_2_1, REGION5_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR5_U_SMXP_2_1, REGION5_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR6_U_SMXP_2_1, 0x113d470)
    FIELD(POR_MPU_M1_PRBAR6_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR6_U_SMXP_2_1, REGION6_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR6_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR6_U_SMXP_2_1, REGION6_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR6_U_SMXP_2_1, REGION6_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR6_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR6_U_SMXP_2_1, 0x113d478)
    FIELD(POR_MPU_M1_PRLAR6_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR6_U_SMXP_2_1, REGION6_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR6_U_SMXP_2_1, REGION6_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR7_U_SMXP_2_1, 0x113d480)
    FIELD(POR_MPU_M1_PRBAR7_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR7_U_SMXP_2_1, REGION7_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR7_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR7_U_SMXP_2_1, REGION7_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR7_U_SMXP_2_1, REGION7_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR7_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR7_U_SMXP_2_1, 0x113d488)
    FIELD(POR_MPU_M1_PRLAR7_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR7_U_SMXP_2_1, REGION7_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR7_U_SMXP_2_1, REGION7_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR8_U_SMXP_2_1, 0x113d490)
    FIELD(POR_MPU_M1_PRBAR8_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR8_U_SMXP_2_1, REGION8_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR8_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR8_U_SMXP_2_1, REGION8_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR8_U_SMXP_2_1, REGION8_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR8_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR8_U_SMXP_2_1, 0x113d498)
    FIELD(POR_MPU_M1_PRLAR8_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR8_U_SMXP_2_1, REGION8_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR8_U_SMXP_2_1, REGION8_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR9_U_SMXP_2_1, 0x113d4a0)
    FIELD(POR_MPU_M1_PRBAR9_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR9_U_SMXP_2_1, REGION9_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR9_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR9_U_SMXP_2_1, REGION9_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR9_U_SMXP_2_1, REGION9_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR9_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR9_U_SMXP_2_1, 0x113d4a8)
    FIELD(POR_MPU_M1_PRLAR9_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR9_U_SMXP_2_1, REGION9_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR9_U_SMXP_2_1, REGION9_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR10_U_SMXP_2_1, 0x113d4b0)
    FIELD(POR_MPU_M1_PRBAR10_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR10_U_SMXP_2_1, REGION10_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR10_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR10_U_SMXP_2_1, REGION10_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR10_U_SMXP_2_1, REGION10_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR10_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR10_U_SMXP_2_1, 0x113d4b8)
    FIELD(POR_MPU_M1_PRLAR10_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR10_U_SMXP_2_1, REGION10_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR10_U_SMXP_2_1, REGION10_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR11_U_SMXP_2_1, 0x113d4c0)
    FIELD(POR_MPU_M1_PRBAR11_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR11_U_SMXP_2_1, REGION11_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR11_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR11_U_SMXP_2_1, REGION11_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR11_U_SMXP_2_1, REGION11_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR11_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR11_U_SMXP_2_1, 0x113d4c8)
    FIELD(POR_MPU_M1_PRLAR11_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR11_U_SMXP_2_1, REGION11_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR11_U_SMXP_2_1, REGION11_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR12_U_SMXP_2_1, 0x113d4d0)
    FIELD(POR_MPU_M1_PRBAR12_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR12_U_SMXP_2_1, REGION12_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR12_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR12_U_SMXP_2_1, REGION12_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR12_U_SMXP_2_1, REGION12_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR12_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR12_U_SMXP_2_1, 0x113d4d8)
    FIELD(POR_MPU_M1_PRLAR12_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR12_U_SMXP_2_1, REGION12_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR12_U_SMXP_2_1, REGION12_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR13_U_SMXP_2_1, 0x113d4e0)
    FIELD(POR_MPU_M1_PRBAR13_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR13_U_SMXP_2_1, REGION13_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR13_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR13_U_SMXP_2_1, REGION13_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR13_U_SMXP_2_1, REGION13_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR13_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR13_U_SMXP_2_1, 0x113d4e8)
    FIELD(POR_MPU_M1_PRLAR13_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR13_U_SMXP_2_1, REGION13_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR13_U_SMXP_2_1, REGION13_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR14_U_SMXP_2_1, 0x113d4f0)
    FIELD(POR_MPU_M1_PRBAR14_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR14_U_SMXP_2_1, REGION14_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR14_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR14_U_SMXP_2_1, REGION14_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR14_U_SMXP_2_1, REGION14_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR14_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR14_U_SMXP_2_1, 0x113d4f8)
    FIELD(POR_MPU_M1_PRLAR14_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR14_U_SMXP_2_1, REGION14_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR14_U_SMXP_2_1, REGION14_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR15_U_SMXP_2_1, 0x113d500)
    FIELD(POR_MPU_M1_PRBAR15_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR15_U_SMXP_2_1, REGION15_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR15_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR15_U_SMXP_2_1, REGION15_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR15_U_SMXP_2_1, REGION15_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR15_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR15_U_SMXP_2_1, 0x113d508)
    FIELD(POR_MPU_M1_PRLAR15_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR15_U_SMXP_2_1, REGION15_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR15_U_SMXP_2_1, REGION15_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR16_U_SMXP_2_1, 0x113d510)
    FIELD(POR_MPU_M1_PRBAR16_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR16_U_SMXP_2_1, REGION16_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR16_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR16_U_SMXP_2_1, REGION16_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR16_U_SMXP_2_1, REGION16_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR16_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR16_U_SMXP_2_1, 0x113d518)
    FIELD(POR_MPU_M1_PRLAR16_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR16_U_SMXP_2_1, REGION16_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR16_U_SMXP_2_1, REGION16_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR17_U_SMXP_2_1, 0x113d520)
    FIELD(POR_MPU_M1_PRBAR17_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR17_U_SMXP_2_1, REGION17_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR17_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR17_U_SMXP_2_1, REGION17_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR17_U_SMXP_2_1, REGION17_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR17_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR17_U_SMXP_2_1, 0x113d528)
    FIELD(POR_MPU_M1_PRLAR17_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR17_U_SMXP_2_1, REGION17_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR17_U_SMXP_2_1, REGION17_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR18_U_SMXP_2_1, 0x113d530)
    FIELD(POR_MPU_M1_PRBAR18_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR18_U_SMXP_2_1, REGION18_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR18_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR18_U_SMXP_2_1, REGION18_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR18_U_SMXP_2_1, REGION18_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR18_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR18_U_SMXP_2_1, 0x113d538)
    FIELD(POR_MPU_M1_PRLAR18_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR18_U_SMXP_2_1, REGION18_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR18_U_SMXP_2_1, REGION18_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR19_U_SMXP_2_1, 0x113d540)
    FIELD(POR_MPU_M1_PRBAR19_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR19_U_SMXP_2_1, REGION19_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR19_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR19_U_SMXP_2_1, REGION19_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR19_U_SMXP_2_1, REGION19_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR19_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR19_U_SMXP_2_1, 0x113d548)
    FIELD(POR_MPU_M1_PRLAR19_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR19_U_SMXP_2_1, REGION19_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR19_U_SMXP_2_1, REGION19_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR20_U_SMXP_2_1, 0x113d550)
    FIELD(POR_MPU_M1_PRBAR20_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR20_U_SMXP_2_1, REGION20_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR20_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR20_U_SMXP_2_1, REGION20_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR20_U_SMXP_2_1, REGION20_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR20_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR20_U_SMXP_2_1, 0x113d558)
    FIELD(POR_MPU_M1_PRLAR20_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR20_U_SMXP_2_1, REGION20_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR20_U_SMXP_2_1, REGION20_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR21_U_SMXP_2_1, 0x113d560)
    FIELD(POR_MPU_M1_PRBAR21_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR21_U_SMXP_2_1, REGION21_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR21_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR21_U_SMXP_2_1, REGION21_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR21_U_SMXP_2_1, REGION21_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR21_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR21_U_SMXP_2_1, 0x113d568)
    FIELD(POR_MPU_M1_PRLAR21_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR21_U_SMXP_2_1, REGION21_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR21_U_SMXP_2_1, REGION21_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR22_U_SMXP_2_1, 0x113d570)
    FIELD(POR_MPU_M1_PRBAR22_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR22_U_SMXP_2_1, REGION22_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR22_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR22_U_SMXP_2_1, REGION22_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR22_U_SMXP_2_1, REGION22_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR22_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR22_U_SMXP_2_1, 0x113d578)
    FIELD(POR_MPU_M1_PRLAR22_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR22_U_SMXP_2_1, REGION22_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR22_U_SMXP_2_1, REGION22_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR23_U_SMXP_2_1, 0x113d580)
    FIELD(POR_MPU_M1_PRBAR23_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR23_U_SMXP_2_1, REGION23_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR23_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR23_U_SMXP_2_1, REGION23_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR23_U_SMXP_2_1, REGION23_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR23_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR23_U_SMXP_2_1, 0x113d588)
    FIELD(POR_MPU_M1_PRLAR23_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR23_U_SMXP_2_1, REGION23_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR23_U_SMXP_2_1, REGION23_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR24_U_SMXP_2_1, 0x113d590)
    FIELD(POR_MPU_M1_PRBAR24_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR24_U_SMXP_2_1, REGION24_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR24_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR24_U_SMXP_2_1, REGION24_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR24_U_SMXP_2_1, REGION24_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR24_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR24_U_SMXP_2_1, 0x113d598)
    FIELD(POR_MPU_M1_PRLAR24_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR24_U_SMXP_2_1, REGION24_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR24_U_SMXP_2_1, REGION24_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR25_U_SMXP_2_1, 0x113d5a0)
    FIELD(POR_MPU_M1_PRBAR25_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR25_U_SMXP_2_1, REGION25_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR25_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR25_U_SMXP_2_1, REGION25_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR25_U_SMXP_2_1, REGION25_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR25_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR25_U_SMXP_2_1, 0x113d5a8)
    FIELD(POR_MPU_M1_PRLAR25_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR25_U_SMXP_2_1, REGION25_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR25_U_SMXP_2_1, REGION25_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR26_U_SMXP_2_1, 0x113d5b0)
    FIELD(POR_MPU_M1_PRBAR26_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR26_U_SMXP_2_1, REGION26_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR26_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR26_U_SMXP_2_1, REGION26_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR26_U_SMXP_2_1, REGION26_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR26_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR26_U_SMXP_2_1, 0x113d5b8)
    FIELD(POR_MPU_M1_PRLAR26_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR26_U_SMXP_2_1, REGION26_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR26_U_SMXP_2_1, REGION26_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR27_U_SMXP_2_1, 0x113d5c0)
    FIELD(POR_MPU_M1_PRBAR27_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR27_U_SMXP_2_1, REGION27_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR27_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR27_U_SMXP_2_1, REGION27_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR27_U_SMXP_2_1, REGION27_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR27_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR27_U_SMXP_2_1, 0x113d5c8)
    FIELD(POR_MPU_M1_PRLAR27_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR27_U_SMXP_2_1, REGION27_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR27_U_SMXP_2_1, REGION27_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR28_U_SMXP_2_1, 0x113d5d0)
    FIELD(POR_MPU_M1_PRBAR28_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR28_U_SMXP_2_1, REGION28_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR28_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR28_U_SMXP_2_1, REGION28_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR28_U_SMXP_2_1, REGION28_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR28_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR28_U_SMXP_2_1, 0x113d5d8)
    FIELD(POR_MPU_M1_PRLAR28_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR28_U_SMXP_2_1, REGION28_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR28_U_SMXP_2_1, REGION28_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR29_U_SMXP_2_1, 0x113d5e0)
    FIELD(POR_MPU_M1_PRBAR29_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR29_U_SMXP_2_1, REGION29_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR29_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR29_U_SMXP_2_1, REGION29_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR29_U_SMXP_2_1, REGION29_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR29_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR29_U_SMXP_2_1, 0x113d5e8)
    FIELD(POR_MPU_M1_PRLAR29_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR29_U_SMXP_2_1, REGION29_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR29_U_SMXP_2_1, REGION29_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR30_U_SMXP_2_1, 0x113d5f0)
    FIELD(POR_MPU_M1_PRBAR30_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR30_U_SMXP_2_1, REGION30_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR30_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR30_U_SMXP_2_1, REGION30_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR30_U_SMXP_2_1, REGION30_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR30_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR30_U_SMXP_2_1, 0x113d5f8)
    FIELD(POR_MPU_M1_PRLAR30_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR30_U_SMXP_2_1, REGION30_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR30_U_SMXP_2_1, REGION30_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR31_U_SMXP_2_1, 0x113d600)
    FIELD(POR_MPU_M1_PRBAR31_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR31_U_SMXP_2_1, REGION31_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR31_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR31_U_SMXP_2_1, REGION31_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR31_U_SMXP_2_1, REGION31_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR31_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR31_U_SMXP_2_1, 0x113d608)
    FIELD(POR_MPU_M1_PRLAR31_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR31_U_SMXP_2_1, REGION31_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR31_U_SMXP_2_1, REGION31_EN, 0, 1)
REG32(POR_MPU_M2_CTL_U_SMXP_2_1, 0x113d800)
    FIELD(POR_MPU_M2_CTL_U_SMXP_2_1, M2_EN, 2, 1)
    FIELD(POR_MPU_M2_CTL_U_SMXP_2_1, M2_ACTION, 0, 2)
REG32(POR_MPU_M2_PRBAR0_U_SMXP_2_1, 0x113d810)
    FIELD(POR_MPU_M2_PRBAR0_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR0_U_SMXP_2_1, REGION0_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR0_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR0_U_SMXP_2_1, REGION0_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR0_U_SMXP_2_1, REGION0_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR0_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR0_U_SMXP_2_1, 0x113d818)
    FIELD(POR_MPU_M2_PRLAR0_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR0_U_SMXP_2_1, REGION0_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR0_U_SMXP_2_1, REGION0_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR1_U_SMXP_2_1, 0x113d820)
    FIELD(POR_MPU_M2_PRBAR1_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR1_U_SMXP_2_1, REGION1_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR1_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR1_U_SMXP_2_1, REGION1_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR1_U_SMXP_2_1, REGION1_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR1_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR1_U_SMXP_2_1, 0x113d828)
    FIELD(POR_MPU_M2_PRLAR1_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR1_U_SMXP_2_1, REGION1_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR1_U_SMXP_2_1, REGION1_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR2_U_SMXP_2_1, 0x113d830)
    FIELD(POR_MPU_M2_PRBAR2_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR2_U_SMXP_2_1, REGION2_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR2_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR2_U_SMXP_2_1, REGION2_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR2_U_SMXP_2_1, REGION2_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR2_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR2_U_SMXP_2_1, 0x113d838)
    FIELD(POR_MPU_M2_PRLAR2_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR2_U_SMXP_2_1, REGION2_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR2_U_SMXP_2_1, REGION2_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR3_U_SMXP_2_1, 0x113d840)
    FIELD(POR_MPU_M2_PRBAR3_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR3_U_SMXP_2_1, REGION3_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR3_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR3_U_SMXP_2_1, REGION3_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR3_U_SMXP_2_1, REGION3_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR3_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR3_U_SMXP_2_1, 0x113d848)
    FIELD(POR_MPU_M2_PRLAR3_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR3_U_SMXP_2_1, REGION3_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR3_U_SMXP_2_1, REGION3_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR4_U_SMXP_2_1, 0x113d850)
    FIELD(POR_MPU_M2_PRBAR4_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR4_U_SMXP_2_1, REGION4_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR4_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR4_U_SMXP_2_1, REGION4_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR4_U_SMXP_2_1, REGION4_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR4_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR4_U_SMXP_2_1, 0x113d858)
    FIELD(POR_MPU_M2_PRLAR4_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR4_U_SMXP_2_1, REGION4_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR4_U_SMXP_2_1, REGION4_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR5_U_SMXP_2_1, 0x113d860)
    FIELD(POR_MPU_M2_PRBAR5_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR5_U_SMXP_2_1, REGION5_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR5_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR5_U_SMXP_2_1, REGION5_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR5_U_SMXP_2_1, REGION5_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR5_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR5_U_SMXP_2_1, 0x113d868)
    FIELD(POR_MPU_M2_PRLAR5_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR5_U_SMXP_2_1, REGION5_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR5_U_SMXP_2_1, REGION5_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR6_U_SMXP_2_1, 0x113d870)
    FIELD(POR_MPU_M2_PRBAR6_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR6_U_SMXP_2_1, REGION6_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR6_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR6_U_SMXP_2_1, REGION6_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR6_U_SMXP_2_1, REGION6_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR6_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR6_U_SMXP_2_1, 0x113d878)
    FIELD(POR_MPU_M2_PRLAR6_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR6_U_SMXP_2_1, REGION6_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR6_U_SMXP_2_1, REGION6_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR7_U_SMXP_2_1, 0x113d880)
    FIELD(POR_MPU_M2_PRBAR7_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR7_U_SMXP_2_1, REGION7_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR7_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR7_U_SMXP_2_1, REGION7_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR7_U_SMXP_2_1, REGION7_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR7_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR7_U_SMXP_2_1, 0x113d888)
    FIELD(POR_MPU_M2_PRLAR7_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR7_U_SMXP_2_1, REGION7_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR7_U_SMXP_2_1, REGION7_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR8_U_SMXP_2_1, 0x113d890)
    FIELD(POR_MPU_M2_PRBAR8_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR8_U_SMXP_2_1, REGION8_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR8_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR8_U_SMXP_2_1, REGION8_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR8_U_SMXP_2_1, REGION8_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR8_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR8_U_SMXP_2_1, 0x113d898)
    FIELD(POR_MPU_M2_PRLAR8_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR8_U_SMXP_2_1, REGION8_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR8_U_SMXP_2_1, REGION8_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR9_U_SMXP_2_1, 0x113d8a0)
    FIELD(POR_MPU_M2_PRBAR9_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR9_U_SMXP_2_1, REGION9_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR9_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR9_U_SMXP_2_1, REGION9_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR9_U_SMXP_2_1, REGION9_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR9_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR9_U_SMXP_2_1, 0x113d8a8)
    FIELD(POR_MPU_M2_PRLAR9_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR9_U_SMXP_2_1, REGION9_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR9_U_SMXP_2_1, REGION9_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR10_U_SMXP_2_1, 0x113d8b0)
    FIELD(POR_MPU_M2_PRBAR10_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR10_U_SMXP_2_1, REGION10_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR10_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR10_U_SMXP_2_1, REGION10_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR10_U_SMXP_2_1, REGION10_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR10_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR10_U_SMXP_2_1, 0x113d8b8)
    FIELD(POR_MPU_M2_PRLAR10_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR10_U_SMXP_2_1, REGION10_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR10_U_SMXP_2_1, REGION10_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR11_U_SMXP_2_1, 0x113d8c0)
    FIELD(POR_MPU_M2_PRBAR11_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR11_U_SMXP_2_1, REGION11_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR11_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR11_U_SMXP_2_1, REGION11_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR11_U_SMXP_2_1, REGION11_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR11_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR11_U_SMXP_2_1, 0x113d8c8)
    FIELD(POR_MPU_M2_PRLAR11_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR11_U_SMXP_2_1, REGION11_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR11_U_SMXP_2_1, REGION11_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR12_U_SMXP_2_1, 0x113d8d0)
    FIELD(POR_MPU_M2_PRBAR12_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR12_U_SMXP_2_1, REGION12_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR12_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR12_U_SMXP_2_1, REGION12_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR12_U_SMXP_2_1, REGION12_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR12_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR12_U_SMXP_2_1, 0x113d8d8)
    FIELD(POR_MPU_M2_PRLAR12_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR12_U_SMXP_2_1, REGION12_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR12_U_SMXP_2_1, REGION12_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR13_U_SMXP_2_1, 0x113d8e0)
    FIELD(POR_MPU_M2_PRBAR13_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR13_U_SMXP_2_1, REGION13_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR13_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR13_U_SMXP_2_1, REGION13_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR13_U_SMXP_2_1, REGION13_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR13_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR13_U_SMXP_2_1, 0x113d8e8)
    FIELD(POR_MPU_M2_PRLAR13_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR13_U_SMXP_2_1, REGION13_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR13_U_SMXP_2_1, REGION13_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR14_U_SMXP_2_1, 0x113d8f0)
    FIELD(POR_MPU_M2_PRBAR14_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR14_U_SMXP_2_1, REGION14_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR14_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR14_U_SMXP_2_1, REGION14_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR14_U_SMXP_2_1, REGION14_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR14_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR14_U_SMXP_2_1, 0x113d8f8)
    FIELD(POR_MPU_M2_PRLAR14_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR14_U_SMXP_2_1, REGION14_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR14_U_SMXP_2_1, REGION14_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR15_U_SMXP_2_1, 0x113d900)
    FIELD(POR_MPU_M2_PRBAR15_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR15_U_SMXP_2_1, REGION15_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR15_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR15_U_SMXP_2_1, REGION15_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR15_U_SMXP_2_1, REGION15_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR15_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR15_U_SMXP_2_1, 0x113d908)
    FIELD(POR_MPU_M2_PRLAR15_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR15_U_SMXP_2_1, REGION15_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR15_U_SMXP_2_1, REGION15_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR16_U_SMXP_2_1, 0x113d910)
    FIELD(POR_MPU_M2_PRBAR16_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR16_U_SMXP_2_1, REGION16_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR16_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR16_U_SMXP_2_1, REGION16_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR16_U_SMXP_2_1, REGION16_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR16_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR16_U_SMXP_2_1, 0x113d918)
    FIELD(POR_MPU_M2_PRLAR16_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR16_U_SMXP_2_1, REGION16_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR16_U_SMXP_2_1, REGION16_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR17_U_SMXP_2_1, 0x113d920)
    FIELD(POR_MPU_M2_PRBAR17_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR17_U_SMXP_2_1, REGION17_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR17_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR17_U_SMXP_2_1, REGION17_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR17_U_SMXP_2_1, REGION17_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR17_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR17_U_SMXP_2_1, 0x113d928)
    FIELD(POR_MPU_M2_PRLAR17_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR17_U_SMXP_2_1, REGION17_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR17_U_SMXP_2_1, REGION17_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR18_U_SMXP_2_1, 0x113d930)
    FIELD(POR_MPU_M2_PRBAR18_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR18_U_SMXP_2_1, REGION18_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR18_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR18_U_SMXP_2_1, REGION18_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR18_U_SMXP_2_1, REGION18_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR18_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR18_U_SMXP_2_1, 0x113d938)
    FIELD(POR_MPU_M2_PRLAR18_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR18_U_SMXP_2_1, REGION18_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR18_U_SMXP_2_1, REGION18_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR19_U_SMXP_2_1, 0x113d940)
    FIELD(POR_MPU_M2_PRBAR19_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR19_U_SMXP_2_1, REGION19_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR19_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR19_U_SMXP_2_1, REGION19_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR19_U_SMXP_2_1, REGION19_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR19_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR19_U_SMXP_2_1, 0x113d948)
    FIELD(POR_MPU_M2_PRLAR19_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR19_U_SMXP_2_1, REGION19_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR19_U_SMXP_2_1, REGION19_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR20_U_SMXP_2_1, 0x113d950)
    FIELD(POR_MPU_M2_PRBAR20_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR20_U_SMXP_2_1, REGION20_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR20_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR20_U_SMXP_2_1, REGION20_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR20_U_SMXP_2_1, REGION20_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR20_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR20_U_SMXP_2_1, 0x113d958)
    FIELD(POR_MPU_M2_PRLAR20_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR20_U_SMXP_2_1, REGION20_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR20_U_SMXP_2_1, REGION20_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR21_U_SMXP_2_1, 0x113d960)
    FIELD(POR_MPU_M2_PRBAR21_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR21_U_SMXP_2_1, REGION21_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR21_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR21_U_SMXP_2_1, REGION21_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR21_U_SMXP_2_1, REGION21_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR21_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR21_U_SMXP_2_1, 0x113d968)
    FIELD(POR_MPU_M2_PRLAR21_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR21_U_SMXP_2_1, REGION21_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR21_U_SMXP_2_1, REGION21_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR22_U_SMXP_2_1, 0x113d970)
    FIELD(POR_MPU_M2_PRBAR22_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR22_U_SMXP_2_1, REGION22_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR22_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR22_U_SMXP_2_1, REGION22_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR22_U_SMXP_2_1, REGION22_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR22_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR22_U_SMXP_2_1, 0x113d978)
    FIELD(POR_MPU_M2_PRLAR22_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR22_U_SMXP_2_1, REGION22_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR22_U_SMXP_2_1, REGION22_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR23_U_SMXP_2_1, 0x113d980)
    FIELD(POR_MPU_M2_PRBAR23_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR23_U_SMXP_2_1, REGION23_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR23_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR23_U_SMXP_2_1, REGION23_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR23_U_SMXP_2_1, REGION23_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR23_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR23_U_SMXP_2_1, 0x113d988)
    FIELD(POR_MPU_M2_PRLAR23_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR23_U_SMXP_2_1, REGION23_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR23_U_SMXP_2_1, REGION23_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR24_U_SMXP_2_1, 0x113d990)
    FIELD(POR_MPU_M2_PRBAR24_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR24_U_SMXP_2_1, REGION24_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR24_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR24_U_SMXP_2_1, REGION24_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR24_U_SMXP_2_1, REGION24_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR24_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR24_U_SMXP_2_1, 0x113d998)
    FIELD(POR_MPU_M2_PRLAR24_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR24_U_SMXP_2_1, REGION24_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR24_U_SMXP_2_1, REGION24_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR25_U_SMXP_2_1, 0x113d9a0)
    FIELD(POR_MPU_M2_PRBAR25_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR25_U_SMXP_2_1, REGION25_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR25_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR25_U_SMXP_2_1, REGION25_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR25_U_SMXP_2_1, REGION25_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR25_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR25_U_SMXP_2_1, 0x113d9a8)
    FIELD(POR_MPU_M2_PRLAR25_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR25_U_SMXP_2_1, REGION25_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR25_U_SMXP_2_1, REGION25_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR26_U_SMXP_2_1, 0x113d9b0)
    FIELD(POR_MPU_M2_PRBAR26_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR26_U_SMXP_2_1, REGION26_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR26_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR26_U_SMXP_2_1, REGION26_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR26_U_SMXP_2_1, REGION26_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR26_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR26_U_SMXP_2_1, 0x113d9b8)
    FIELD(POR_MPU_M2_PRLAR26_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR26_U_SMXP_2_1, REGION26_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR26_U_SMXP_2_1, REGION26_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR27_U_SMXP_2_1, 0x113d9c0)
    FIELD(POR_MPU_M2_PRBAR27_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR27_U_SMXP_2_1, REGION27_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR27_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR27_U_SMXP_2_1, REGION27_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR27_U_SMXP_2_1, REGION27_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR27_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR27_U_SMXP_2_1, 0x113d9c8)
    FIELD(POR_MPU_M2_PRLAR27_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR27_U_SMXP_2_1, REGION27_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR27_U_SMXP_2_1, REGION27_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR28_U_SMXP_2_1, 0x113d9d0)
    FIELD(POR_MPU_M2_PRBAR28_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR28_U_SMXP_2_1, REGION28_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR28_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR28_U_SMXP_2_1, REGION28_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR28_U_SMXP_2_1, REGION28_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR28_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR28_U_SMXP_2_1, 0x113d9d8)
    FIELD(POR_MPU_M2_PRLAR28_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR28_U_SMXP_2_1, REGION28_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR28_U_SMXP_2_1, REGION28_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR29_U_SMXP_2_1, 0x113d9e0)
    FIELD(POR_MPU_M2_PRBAR29_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR29_U_SMXP_2_1, REGION29_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR29_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR29_U_SMXP_2_1, REGION29_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR29_U_SMXP_2_1, REGION29_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR29_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR29_U_SMXP_2_1, 0x113d9e8)
    FIELD(POR_MPU_M2_PRLAR29_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR29_U_SMXP_2_1, REGION29_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR29_U_SMXP_2_1, REGION29_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR30_U_SMXP_2_1, 0x113d9f0)
    FIELD(POR_MPU_M2_PRBAR30_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR30_U_SMXP_2_1, REGION30_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR30_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR30_U_SMXP_2_1, REGION30_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR30_U_SMXP_2_1, REGION30_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR30_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR30_U_SMXP_2_1, 0x113d9f8)
    FIELD(POR_MPU_M2_PRLAR30_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR30_U_SMXP_2_1, REGION30_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR30_U_SMXP_2_1, REGION30_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR31_U_SMXP_2_1, 0x113da00)
    FIELD(POR_MPU_M2_PRBAR31_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR31_U_SMXP_2_1, REGION31_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR31_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR31_U_SMXP_2_1, REGION31_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR31_U_SMXP_2_1, REGION31_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR31_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR31_U_SMXP_2_1, 0x113da08)
    FIELD(POR_MPU_M2_PRLAR31_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR31_U_SMXP_2_1, REGION31_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR31_U_SMXP_2_1, REGION31_EN, 0, 1)
REG32(POR_MPU_M3_CTL_U_SMXP_2_1, 0x113dc00)
    FIELD(POR_MPU_M3_CTL_U_SMXP_2_1, M3_EN, 2, 1)
    FIELD(POR_MPU_M3_CTL_U_SMXP_2_1, M3_ACTION, 0, 2)
REG32(POR_MPU_M3_PRBAR0_U_SMXP_2_1, 0x113dc10)
    FIELD(POR_MPU_M3_PRBAR0_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR0_U_SMXP_2_1, REGION0_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR0_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR0_U_SMXP_2_1, REGION0_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR0_U_SMXP_2_1, REGION0_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR0_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR0_U_SMXP_2_1, 0x113dc18)
    FIELD(POR_MPU_M3_PRLAR0_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR0_U_SMXP_2_1, REGION0_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR0_U_SMXP_2_1, REGION0_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR1_U_SMXP_2_1, 0x113dc20)
    FIELD(POR_MPU_M3_PRBAR1_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR1_U_SMXP_2_1, REGION1_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR1_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR1_U_SMXP_2_1, REGION1_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR1_U_SMXP_2_1, REGION1_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR1_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR1_U_SMXP_2_1, 0x113dc28)
    FIELD(POR_MPU_M3_PRLAR1_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR1_U_SMXP_2_1, REGION1_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR1_U_SMXP_2_1, REGION1_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR2_U_SMXP_2_1, 0x113dc30)
    FIELD(POR_MPU_M3_PRBAR2_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR2_U_SMXP_2_1, REGION2_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR2_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR2_U_SMXP_2_1, REGION2_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR2_U_SMXP_2_1, REGION2_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR2_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR2_U_SMXP_2_1, 0x113dc38)
    FIELD(POR_MPU_M3_PRLAR2_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR2_U_SMXP_2_1, REGION2_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR2_U_SMXP_2_1, REGION2_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR3_U_SMXP_2_1, 0x113dc40)
    FIELD(POR_MPU_M3_PRBAR3_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR3_U_SMXP_2_1, REGION3_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR3_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR3_U_SMXP_2_1, REGION3_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR3_U_SMXP_2_1, REGION3_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR3_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR3_U_SMXP_2_1, 0x113dc48)
    FIELD(POR_MPU_M3_PRLAR3_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR3_U_SMXP_2_1, REGION3_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR3_U_SMXP_2_1, REGION3_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR4_U_SMXP_2_1, 0x113dc50)
    FIELD(POR_MPU_M3_PRBAR4_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR4_U_SMXP_2_1, REGION4_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR4_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR4_U_SMXP_2_1, REGION4_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR4_U_SMXP_2_1, REGION4_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR4_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR4_U_SMXP_2_1, 0x113dc58)
    FIELD(POR_MPU_M3_PRLAR4_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR4_U_SMXP_2_1, REGION4_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR4_U_SMXP_2_1, REGION4_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR5_U_SMXP_2_1, 0x113dc60)
    FIELD(POR_MPU_M3_PRBAR5_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR5_U_SMXP_2_1, REGION5_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR5_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR5_U_SMXP_2_1, REGION5_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR5_U_SMXP_2_1, REGION5_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR5_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR5_U_SMXP_2_1, 0x113dc68)
    FIELD(POR_MPU_M3_PRLAR5_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR5_U_SMXP_2_1, REGION5_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR5_U_SMXP_2_1, REGION5_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR6_U_SMXP_2_1, 0x113dc70)
    FIELD(POR_MPU_M3_PRBAR6_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR6_U_SMXP_2_1, REGION6_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR6_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR6_U_SMXP_2_1, REGION6_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR6_U_SMXP_2_1, REGION6_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR6_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR6_U_SMXP_2_1, 0x113dc78)
    FIELD(POR_MPU_M3_PRLAR6_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR6_U_SMXP_2_1, REGION6_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR6_U_SMXP_2_1, REGION6_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR7_U_SMXP_2_1, 0x113dc80)
    FIELD(POR_MPU_M3_PRBAR7_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR7_U_SMXP_2_1, REGION7_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR7_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR7_U_SMXP_2_1, REGION7_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR7_U_SMXP_2_1, REGION7_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR7_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR7_U_SMXP_2_1, 0x113dc88)
    FIELD(POR_MPU_M3_PRLAR7_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR7_U_SMXP_2_1, REGION7_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR7_U_SMXP_2_1, REGION7_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR8_U_SMXP_2_1, 0x113dc90)
    FIELD(POR_MPU_M3_PRBAR8_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR8_U_SMXP_2_1, REGION8_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR8_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR8_U_SMXP_2_1, REGION8_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR8_U_SMXP_2_1, REGION8_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR8_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR8_U_SMXP_2_1, 0x113dc98)
    FIELD(POR_MPU_M3_PRLAR8_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR8_U_SMXP_2_1, REGION8_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR8_U_SMXP_2_1, REGION8_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR9_U_SMXP_2_1, 0x113dca0)
    FIELD(POR_MPU_M3_PRBAR9_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR9_U_SMXP_2_1, REGION9_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR9_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR9_U_SMXP_2_1, REGION9_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR9_U_SMXP_2_1, REGION9_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR9_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR9_U_SMXP_2_1, 0x113dca8)
    FIELD(POR_MPU_M3_PRLAR9_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR9_U_SMXP_2_1, REGION9_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR9_U_SMXP_2_1, REGION9_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR10_U_SMXP_2_1, 0x113dcb0)
    FIELD(POR_MPU_M3_PRBAR10_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR10_U_SMXP_2_1, REGION10_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR10_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR10_U_SMXP_2_1, REGION10_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR10_U_SMXP_2_1, REGION10_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR10_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR10_U_SMXP_2_1, 0x113dcb8)
    FIELD(POR_MPU_M3_PRLAR10_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR10_U_SMXP_2_1, REGION10_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR10_U_SMXP_2_1, REGION10_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR11_U_SMXP_2_1, 0x113dcc0)
    FIELD(POR_MPU_M3_PRBAR11_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR11_U_SMXP_2_1, REGION11_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR11_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR11_U_SMXP_2_1, REGION11_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR11_U_SMXP_2_1, REGION11_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR11_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR11_U_SMXP_2_1, 0x113dcc8)
    FIELD(POR_MPU_M3_PRLAR11_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR11_U_SMXP_2_1, REGION11_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR11_U_SMXP_2_1, REGION11_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR12_U_SMXP_2_1, 0x113dcd0)
    FIELD(POR_MPU_M3_PRBAR12_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR12_U_SMXP_2_1, REGION12_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR12_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR12_U_SMXP_2_1, REGION12_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR12_U_SMXP_2_1, REGION12_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR12_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR12_U_SMXP_2_1, 0x113dcd8)
    FIELD(POR_MPU_M3_PRLAR12_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR12_U_SMXP_2_1, REGION12_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR12_U_SMXP_2_1, REGION12_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR13_U_SMXP_2_1, 0x113dce0)
    FIELD(POR_MPU_M3_PRBAR13_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR13_U_SMXP_2_1, REGION13_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR13_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR13_U_SMXP_2_1, REGION13_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR13_U_SMXP_2_1, REGION13_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR13_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR13_U_SMXP_2_1, 0x113dce8)
    FIELD(POR_MPU_M3_PRLAR13_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR13_U_SMXP_2_1, REGION13_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR13_U_SMXP_2_1, REGION13_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR14_U_SMXP_2_1, 0x113dcf0)
    FIELD(POR_MPU_M3_PRBAR14_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR14_U_SMXP_2_1, REGION14_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR14_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR14_U_SMXP_2_1, REGION14_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR14_U_SMXP_2_1, REGION14_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR14_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR14_U_SMXP_2_1, 0x113dcf8)
    FIELD(POR_MPU_M3_PRLAR14_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR14_U_SMXP_2_1, REGION14_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR14_U_SMXP_2_1, REGION14_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR15_U_SMXP_2_1, 0x113dd00)
    FIELD(POR_MPU_M3_PRBAR15_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR15_U_SMXP_2_1, REGION15_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR15_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR15_U_SMXP_2_1, REGION15_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR15_U_SMXP_2_1, REGION15_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR15_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR15_U_SMXP_2_1, 0x113dd08)
    FIELD(POR_MPU_M3_PRLAR15_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR15_U_SMXP_2_1, REGION15_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR15_U_SMXP_2_1, REGION15_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR16_U_SMXP_2_1, 0x113dd10)
    FIELD(POR_MPU_M3_PRBAR16_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR16_U_SMXP_2_1, REGION16_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR16_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR16_U_SMXP_2_1, REGION16_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR16_U_SMXP_2_1, REGION16_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR16_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR16_U_SMXP_2_1, 0x113dd18)
    FIELD(POR_MPU_M3_PRLAR16_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR16_U_SMXP_2_1, REGION16_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR16_U_SMXP_2_1, REGION16_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR17_U_SMXP_2_1, 0x113dd20)
    FIELD(POR_MPU_M3_PRBAR17_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR17_U_SMXP_2_1, REGION17_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR17_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR17_U_SMXP_2_1, REGION17_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR17_U_SMXP_2_1, REGION17_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR17_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR17_U_SMXP_2_1, 0x113dd28)
    FIELD(POR_MPU_M3_PRLAR17_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR17_U_SMXP_2_1, REGION17_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR17_U_SMXP_2_1, REGION17_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR18_U_SMXP_2_1, 0x113dd30)
    FIELD(POR_MPU_M3_PRBAR18_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR18_U_SMXP_2_1, REGION18_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR18_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR18_U_SMXP_2_1, REGION18_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR18_U_SMXP_2_1, REGION18_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR18_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR18_U_SMXP_2_1, 0x113dd38)
    FIELD(POR_MPU_M3_PRLAR18_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR18_U_SMXP_2_1, REGION18_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR18_U_SMXP_2_1, REGION18_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR19_U_SMXP_2_1, 0x113dd40)
    FIELD(POR_MPU_M3_PRBAR19_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR19_U_SMXP_2_1, REGION19_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR19_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR19_U_SMXP_2_1, REGION19_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR19_U_SMXP_2_1, REGION19_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR19_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR19_U_SMXP_2_1, 0x113dd48)
    FIELD(POR_MPU_M3_PRLAR19_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR19_U_SMXP_2_1, REGION19_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR19_U_SMXP_2_1, REGION19_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR20_U_SMXP_2_1, 0x113dd50)
    FIELD(POR_MPU_M3_PRBAR20_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR20_U_SMXP_2_1, REGION20_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR20_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR20_U_SMXP_2_1, REGION20_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR20_U_SMXP_2_1, REGION20_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR20_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR20_U_SMXP_2_1, 0x113dd58)
    FIELD(POR_MPU_M3_PRLAR20_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR20_U_SMXP_2_1, REGION20_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR20_U_SMXP_2_1, REGION20_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR21_U_SMXP_2_1, 0x113dd60)
    FIELD(POR_MPU_M3_PRBAR21_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR21_U_SMXP_2_1, REGION21_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR21_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR21_U_SMXP_2_1, REGION21_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR21_U_SMXP_2_1, REGION21_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR21_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR21_U_SMXP_2_1, 0x113dd68)
    FIELD(POR_MPU_M3_PRLAR21_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR21_U_SMXP_2_1, REGION21_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR21_U_SMXP_2_1, REGION21_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR22_U_SMXP_2_1, 0x113dd70)
    FIELD(POR_MPU_M3_PRBAR22_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR22_U_SMXP_2_1, REGION22_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR22_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR22_U_SMXP_2_1, REGION22_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR22_U_SMXP_2_1, REGION22_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR22_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR22_U_SMXP_2_1, 0x113dd78)
    FIELD(POR_MPU_M3_PRLAR22_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR22_U_SMXP_2_1, REGION22_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR22_U_SMXP_2_1, REGION22_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR23_U_SMXP_2_1, 0x113dd80)
    FIELD(POR_MPU_M3_PRBAR23_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR23_U_SMXP_2_1, REGION23_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR23_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR23_U_SMXP_2_1, REGION23_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR23_U_SMXP_2_1, REGION23_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR23_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR23_U_SMXP_2_1, 0x113dd88)
    FIELD(POR_MPU_M3_PRLAR23_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR23_U_SMXP_2_1, REGION23_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR23_U_SMXP_2_1, REGION23_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR24_U_SMXP_2_1, 0x113dd90)
    FIELD(POR_MPU_M3_PRBAR24_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR24_U_SMXP_2_1, REGION24_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR24_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR24_U_SMXP_2_1, REGION24_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR24_U_SMXP_2_1, REGION24_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR24_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR24_U_SMXP_2_1, 0x113dd98)
    FIELD(POR_MPU_M3_PRLAR24_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR24_U_SMXP_2_1, REGION24_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR24_U_SMXP_2_1, REGION24_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR25_U_SMXP_2_1, 0x113dda0)
    FIELD(POR_MPU_M3_PRBAR25_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR25_U_SMXP_2_1, REGION25_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR25_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR25_U_SMXP_2_1, REGION25_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR25_U_SMXP_2_1, REGION25_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR25_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR25_U_SMXP_2_1, 0x113dda8)
    FIELD(POR_MPU_M3_PRLAR25_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR25_U_SMXP_2_1, REGION25_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR25_U_SMXP_2_1, REGION25_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR26_U_SMXP_2_1, 0x113ddb0)
    FIELD(POR_MPU_M3_PRBAR26_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR26_U_SMXP_2_1, REGION26_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR26_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR26_U_SMXP_2_1, REGION26_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR26_U_SMXP_2_1, REGION26_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR26_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR26_U_SMXP_2_1, 0x113ddb8)
    FIELD(POR_MPU_M3_PRLAR26_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR26_U_SMXP_2_1, REGION26_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR26_U_SMXP_2_1, REGION26_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR27_U_SMXP_2_1, 0x113ddc0)
    FIELD(POR_MPU_M3_PRBAR27_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR27_U_SMXP_2_1, REGION27_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR27_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR27_U_SMXP_2_1, REGION27_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR27_U_SMXP_2_1, REGION27_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR27_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR27_U_SMXP_2_1, 0x113ddc8)
    FIELD(POR_MPU_M3_PRLAR27_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR27_U_SMXP_2_1, REGION27_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR27_U_SMXP_2_1, REGION27_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR28_U_SMXP_2_1, 0x113ddd0)
    FIELD(POR_MPU_M3_PRBAR28_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR28_U_SMXP_2_1, REGION28_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR28_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR28_U_SMXP_2_1, REGION28_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR28_U_SMXP_2_1, REGION28_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR28_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR28_U_SMXP_2_1, 0x113ddd8)
    FIELD(POR_MPU_M3_PRLAR28_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR28_U_SMXP_2_1, REGION28_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR28_U_SMXP_2_1, REGION28_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR29_U_SMXP_2_1, 0x113dde0)
    FIELD(POR_MPU_M3_PRBAR29_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR29_U_SMXP_2_1, REGION29_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR29_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR29_U_SMXP_2_1, REGION29_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR29_U_SMXP_2_1, REGION29_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR29_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR29_U_SMXP_2_1, 0x113dde8)
    FIELD(POR_MPU_M3_PRLAR29_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR29_U_SMXP_2_1, REGION29_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR29_U_SMXP_2_1, REGION29_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR30_U_SMXP_2_1, 0x113ddf0)
    FIELD(POR_MPU_M3_PRBAR30_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR30_U_SMXP_2_1, REGION30_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR30_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR30_U_SMXP_2_1, REGION30_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR30_U_SMXP_2_1, REGION30_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR30_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR30_U_SMXP_2_1, 0x113ddf8)
    FIELD(POR_MPU_M3_PRLAR30_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR30_U_SMXP_2_1, REGION30_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR30_U_SMXP_2_1, REGION30_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR31_U_SMXP_2_1, 0x113de00)
    FIELD(POR_MPU_M3_PRBAR31_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR31_U_SMXP_2_1, REGION31_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR31_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR31_U_SMXP_2_1, REGION31_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR31_U_SMXP_2_1, REGION31_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR31_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR31_U_SMXP_2_1, 0x113de08)
    FIELD(POR_MPU_M3_PRLAR31_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR31_U_SMXP_2_1, REGION31_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR31_U_SMXP_2_1, REGION31_EN, 0, 1)
REG32(POR_MPU_M4_CTL_U_SMXP_2_1, 0x113e000)
    FIELD(POR_MPU_M4_CTL_U_SMXP_2_1, M4_EN, 2, 1)
    FIELD(POR_MPU_M4_CTL_U_SMXP_2_1, M4_ACTION, 0, 2)
REG32(POR_MPU_M4_PRBAR0_U_SMXP_2_1, 0x113e010)
    FIELD(POR_MPU_M4_PRBAR0_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR0_U_SMXP_2_1, REGION0_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR0_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR0_U_SMXP_2_1, REGION0_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR0_U_SMXP_2_1, REGION0_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR0_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR0_U_SMXP_2_1, 0x113e018)
    FIELD(POR_MPU_M4_PRLAR0_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR0_U_SMXP_2_1, REGION0_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR0_U_SMXP_2_1, REGION0_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR1_U_SMXP_2_1, 0x113e020)
    FIELD(POR_MPU_M4_PRBAR1_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR1_U_SMXP_2_1, REGION1_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR1_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR1_U_SMXP_2_1, REGION1_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR1_U_SMXP_2_1, REGION1_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR1_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR1_U_SMXP_2_1, 0x113e028)
    FIELD(POR_MPU_M4_PRLAR1_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR1_U_SMXP_2_1, REGION1_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR1_U_SMXP_2_1, REGION1_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR2_U_SMXP_2_1, 0x113e030)
    FIELD(POR_MPU_M4_PRBAR2_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR2_U_SMXP_2_1, REGION2_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR2_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR2_U_SMXP_2_1, REGION2_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR2_U_SMXP_2_1, REGION2_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR2_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR2_U_SMXP_2_1, 0x113e038)
    FIELD(POR_MPU_M4_PRLAR2_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR2_U_SMXP_2_1, REGION2_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR2_U_SMXP_2_1, REGION2_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR3_U_SMXP_2_1, 0x113e040)
    FIELD(POR_MPU_M4_PRBAR3_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR3_U_SMXP_2_1, REGION3_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR3_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR3_U_SMXP_2_1, REGION3_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR3_U_SMXP_2_1, REGION3_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR3_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR3_U_SMXP_2_1, 0x113e048)
    FIELD(POR_MPU_M4_PRLAR3_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR3_U_SMXP_2_1, REGION3_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR3_U_SMXP_2_1, REGION3_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR4_U_SMXP_2_1, 0x113e050)
    FIELD(POR_MPU_M4_PRBAR4_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR4_U_SMXP_2_1, REGION4_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR4_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR4_U_SMXP_2_1, REGION4_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR4_U_SMXP_2_1, REGION4_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR4_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR4_U_SMXP_2_1, 0x113e058)
    FIELD(POR_MPU_M4_PRLAR4_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR4_U_SMXP_2_1, REGION4_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR4_U_SMXP_2_1, REGION4_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR5_U_SMXP_2_1, 0x113e060)
    FIELD(POR_MPU_M4_PRBAR5_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR5_U_SMXP_2_1, REGION5_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR5_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR5_U_SMXP_2_1, REGION5_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR5_U_SMXP_2_1, REGION5_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR5_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR5_U_SMXP_2_1, 0x113e068)
    FIELD(POR_MPU_M4_PRLAR5_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR5_U_SMXP_2_1, REGION5_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR5_U_SMXP_2_1, REGION5_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR6_U_SMXP_2_1, 0x113e070)
    FIELD(POR_MPU_M4_PRBAR6_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR6_U_SMXP_2_1, REGION6_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR6_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR6_U_SMXP_2_1, REGION6_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR6_U_SMXP_2_1, REGION6_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR6_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR6_U_SMXP_2_1, 0x113e078)
    FIELD(POR_MPU_M4_PRLAR6_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR6_U_SMXP_2_1, REGION6_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR6_U_SMXP_2_1, REGION6_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR7_U_SMXP_2_1, 0x113e080)
    FIELD(POR_MPU_M4_PRBAR7_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR7_U_SMXP_2_1, REGION7_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR7_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR7_U_SMXP_2_1, REGION7_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR7_U_SMXP_2_1, REGION7_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR7_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR7_U_SMXP_2_1, 0x113e088)
    FIELD(POR_MPU_M4_PRLAR7_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR7_U_SMXP_2_1, REGION7_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR7_U_SMXP_2_1, REGION7_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR8_U_SMXP_2_1, 0x113e090)
    FIELD(POR_MPU_M4_PRBAR8_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR8_U_SMXP_2_1, REGION8_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR8_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR8_U_SMXP_2_1, REGION8_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR8_U_SMXP_2_1, REGION8_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR8_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR8_U_SMXP_2_1, 0x113e098)
    FIELD(POR_MPU_M4_PRLAR8_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR8_U_SMXP_2_1, REGION8_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR8_U_SMXP_2_1, REGION8_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR9_U_SMXP_2_1, 0x113e0a0)
    FIELD(POR_MPU_M4_PRBAR9_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR9_U_SMXP_2_1, REGION9_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR9_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR9_U_SMXP_2_1, REGION9_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR9_U_SMXP_2_1, REGION9_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR9_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR9_U_SMXP_2_1, 0x113e0a8)
    FIELD(POR_MPU_M4_PRLAR9_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR9_U_SMXP_2_1, REGION9_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR9_U_SMXP_2_1, REGION9_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR10_U_SMXP_2_1, 0x113e0b0)
    FIELD(POR_MPU_M4_PRBAR10_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR10_U_SMXP_2_1, REGION10_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR10_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR10_U_SMXP_2_1, REGION10_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR10_U_SMXP_2_1, REGION10_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR10_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR10_U_SMXP_2_1, 0x113e0b8)
    FIELD(POR_MPU_M4_PRLAR10_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR10_U_SMXP_2_1, REGION10_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR10_U_SMXP_2_1, REGION10_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR11_U_SMXP_2_1, 0x113e0c0)
    FIELD(POR_MPU_M4_PRBAR11_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR11_U_SMXP_2_1, REGION11_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR11_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR11_U_SMXP_2_1, REGION11_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR11_U_SMXP_2_1, REGION11_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR11_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR11_U_SMXP_2_1, 0x113e0c8)
    FIELD(POR_MPU_M4_PRLAR11_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR11_U_SMXP_2_1, REGION11_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR11_U_SMXP_2_1, REGION11_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR12_U_SMXP_2_1, 0x113e0d0)
    FIELD(POR_MPU_M4_PRBAR12_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR12_U_SMXP_2_1, REGION12_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR12_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR12_U_SMXP_2_1, REGION12_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR12_U_SMXP_2_1, REGION12_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR12_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR12_U_SMXP_2_1, 0x113e0d8)
    FIELD(POR_MPU_M4_PRLAR12_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR12_U_SMXP_2_1, REGION12_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR12_U_SMXP_2_1, REGION12_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR13_U_SMXP_2_1, 0x113e0e0)
    FIELD(POR_MPU_M4_PRBAR13_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR13_U_SMXP_2_1, REGION13_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR13_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR13_U_SMXP_2_1, REGION13_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR13_U_SMXP_2_1, REGION13_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR13_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR13_U_SMXP_2_1, 0x113e0e8)
    FIELD(POR_MPU_M4_PRLAR13_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR13_U_SMXP_2_1, REGION13_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR13_U_SMXP_2_1, REGION13_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR14_U_SMXP_2_1, 0x113e0f0)
    FIELD(POR_MPU_M4_PRBAR14_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR14_U_SMXP_2_1, REGION14_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR14_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR14_U_SMXP_2_1, REGION14_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR14_U_SMXP_2_1, REGION14_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR14_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR14_U_SMXP_2_1, 0x113e0f8)
    FIELD(POR_MPU_M4_PRLAR14_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR14_U_SMXP_2_1, REGION14_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR14_U_SMXP_2_1, REGION14_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR15_U_SMXP_2_1, 0x113e100)
    FIELD(POR_MPU_M4_PRBAR15_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR15_U_SMXP_2_1, REGION15_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR15_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR15_U_SMXP_2_1, REGION15_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR15_U_SMXP_2_1, REGION15_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR15_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR15_U_SMXP_2_1, 0x113e108)
    FIELD(POR_MPU_M4_PRLAR15_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR15_U_SMXP_2_1, REGION15_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR15_U_SMXP_2_1, REGION15_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR16_U_SMXP_2_1, 0x113e110)
    FIELD(POR_MPU_M4_PRBAR16_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR16_U_SMXP_2_1, REGION16_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR16_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR16_U_SMXP_2_1, REGION16_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR16_U_SMXP_2_1, REGION16_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR16_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR16_U_SMXP_2_1, 0x113e118)
    FIELD(POR_MPU_M4_PRLAR16_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR16_U_SMXP_2_1, REGION16_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR16_U_SMXP_2_1, REGION16_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR17_U_SMXP_2_1, 0x113e120)
    FIELD(POR_MPU_M4_PRBAR17_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR17_U_SMXP_2_1, REGION17_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR17_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR17_U_SMXP_2_1, REGION17_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR17_U_SMXP_2_1, REGION17_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR17_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR17_U_SMXP_2_1, 0x113e128)
    FIELD(POR_MPU_M4_PRLAR17_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR17_U_SMXP_2_1, REGION17_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR17_U_SMXP_2_1, REGION17_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR18_U_SMXP_2_1, 0x113e130)
    FIELD(POR_MPU_M4_PRBAR18_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR18_U_SMXP_2_1, REGION18_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR18_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR18_U_SMXP_2_1, REGION18_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR18_U_SMXP_2_1, REGION18_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR18_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR18_U_SMXP_2_1, 0x113e138)
    FIELD(POR_MPU_M4_PRLAR18_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR18_U_SMXP_2_1, REGION18_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR18_U_SMXP_2_1, REGION18_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR19_U_SMXP_2_1, 0x113e140)
    FIELD(POR_MPU_M4_PRBAR19_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR19_U_SMXP_2_1, REGION19_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR19_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR19_U_SMXP_2_1, REGION19_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR19_U_SMXP_2_1, REGION19_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR19_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR19_U_SMXP_2_1, 0x113e148)
    FIELD(POR_MPU_M4_PRLAR19_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR19_U_SMXP_2_1, REGION19_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR19_U_SMXP_2_1, REGION19_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR20_U_SMXP_2_1, 0x113e150)
    FIELD(POR_MPU_M4_PRBAR20_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR20_U_SMXP_2_1, REGION20_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR20_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR20_U_SMXP_2_1, REGION20_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR20_U_SMXP_2_1, REGION20_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR20_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR20_U_SMXP_2_1, 0x113e158)
    FIELD(POR_MPU_M4_PRLAR20_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR20_U_SMXP_2_1, REGION20_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR20_U_SMXP_2_1, REGION20_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR21_U_SMXP_2_1, 0x113e160)
    FIELD(POR_MPU_M4_PRBAR21_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR21_U_SMXP_2_1, REGION21_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR21_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR21_U_SMXP_2_1, REGION21_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR21_U_SMXP_2_1, REGION21_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR21_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR21_U_SMXP_2_1, 0x113e168)
    FIELD(POR_MPU_M4_PRLAR21_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR21_U_SMXP_2_1, REGION21_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR21_U_SMXP_2_1, REGION21_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR22_U_SMXP_2_1, 0x113e170)
    FIELD(POR_MPU_M4_PRBAR22_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR22_U_SMXP_2_1, REGION22_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR22_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR22_U_SMXP_2_1, REGION22_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR22_U_SMXP_2_1, REGION22_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR22_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR22_U_SMXP_2_1, 0x113e178)
    FIELD(POR_MPU_M4_PRLAR22_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR22_U_SMXP_2_1, REGION22_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR22_U_SMXP_2_1, REGION22_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR23_U_SMXP_2_1, 0x113e180)
    FIELD(POR_MPU_M4_PRBAR23_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR23_U_SMXP_2_1, REGION23_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR23_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR23_U_SMXP_2_1, REGION23_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR23_U_SMXP_2_1, REGION23_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR23_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR23_U_SMXP_2_1, 0x113e188)
    FIELD(POR_MPU_M4_PRLAR23_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR23_U_SMXP_2_1, REGION23_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR23_U_SMXP_2_1, REGION23_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR24_U_SMXP_2_1, 0x113e190)
    FIELD(POR_MPU_M4_PRBAR24_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR24_U_SMXP_2_1, REGION24_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR24_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR24_U_SMXP_2_1, REGION24_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR24_U_SMXP_2_1, REGION24_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR24_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR24_U_SMXP_2_1, 0x113e198)
    FIELD(POR_MPU_M4_PRLAR24_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR24_U_SMXP_2_1, REGION24_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR24_U_SMXP_2_1, REGION24_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR25_U_SMXP_2_1, 0x113e1a0)
    FIELD(POR_MPU_M4_PRBAR25_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR25_U_SMXP_2_1, REGION25_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR25_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR25_U_SMXP_2_1, REGION25_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR25_U_SMXP_2_1, REGION25_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR25_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR25_U_SMXP_2_1, 0x113e1a8)
    FIELD(POR_MPU_M4_PRLAR25_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR25_U_SMXP_2_1, REGION25_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR25_U_SMXP_2_1, REGION25_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR26_U_SMXP_2_1, 0x113e1b0)
    FIELD(POR_MPU_M4_PRBAR26_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR26_U_SMXP_2_1, REGION26_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR26_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR26_U_SMXP_2_1, REGION26_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR26_U_SMXP_2_1, REGION26_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR26_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR26_U_SMXP_2_1, 0x113e1b8)
    FIELD(POR_MPU_M4_PRLAR26_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR26_U_SMXP_2_1, REGION26_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR26_U_SMXP_2_1, REGION26_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR27_U_SMXP_2_1, 0x113e1c0)
    FIELD(POR_MPU_M4_PRBAR27_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR27_U_SMXP_2_1, REGION27_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR27_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR27_U_SMXP_2_1, REGION27_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR27_U_SMXP_2_1, REGION27_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR27_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR27_U_SMXP_2_1, 0x113e1c8)
    FIELD(POR_MPU_M4_PRLAR27_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR27_U_SMXP_2_1, REGION27_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR27_U_SMXP_2_1, REGION27_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR28_U_SMXP_2_1, 0x113e1d0)
    FIELD(POR_MPU_M4_PRBAR28_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR28_U_SMXP_2_1, REGION28_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR28_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR28_U_SMXP_2_1, REGION28_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR28_U_SMXP_2_1, REGION28_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR28_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR28_U_SMXP_2_1, 0x113e1d8)
    FIELD(POR_MPU_M4_PRLAR28_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR28_U_SMXP_2_1, REGION28_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR28_U_SMXP_2_1, REGION28_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR29_U_SMXP_2_1, 0x113e1e0)
    FIELD(POR_MPU_M4_PRBAR29_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR29_U_SMXP_2_1, REGION29_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR29_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR29_U_SMXP_2_1, REGION29_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR29_U_SMXP_2_1, REGION29_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR29_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR29_U_SMXP_2_1, 0x113e1e8)
    FIELD(POR_MPU_M4_PRLAR29_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR29_U_SMXP_2_1, REGION29_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR29_U_SMXP_2_1, REGION29_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR30_U_SMXP_2_1, 0x113e1f0)
    FIELD(POR_MPU_M4_PRBAR30_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR30_U_SMXP_2_1, REGION30_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR30_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR30_U_SMXP_2_1, REGION30_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR30_U_SMXP_2_1, REGION30_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR30_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR30_U_SMXP_2_1, 0x113e1f8)
    FIELD(POR_MPU_M4_PRLAR30_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR30_U_SMXP_2_1, REGION30_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR30_U_SMXP_2_1, REGION30_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR31_U_SMXP_2_1, 0x113e200)
    FIELD(POR_MPU_M4_PRBAR31_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR31_U_SMXP_2_1, REGION31_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR31_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR31_U_SMXP_2_1, REGION31_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR31_U_SMXP_2_1, REGION31_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR31_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR31_U_SMXP_2_1, 0x113e208)
    FIELD(POR_MPU_M4_PRLAR31_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR31_U_SMXP_2_1, REGION31_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR31_U_SMXP_2_1, REGION31_EN, 0, 1)
REG32(POR_MPU_M5_CTL_U_SMXP_2_1, 0x113e400)
    FIELD(POR_MPU_M5_CTL_U_SMXP_2_1, M5_EN, 2, 1)
    FIELD(POR_MPU_M5_CTL_U_SMXP_2_1, M5_ACTION, 0, 2)
REG32(POR_MPU_M5_PRBAR0_U_SMXP_2_1, 0x113e410)
    FIELD(POR_MPU_M5_PRBAR0_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR0_U_SMXP_2_1, REGION0_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR0_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR0_U_SMXP_2_1, REGION0_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR0_U_SMXP_2_1, REGION0_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR0_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR0_U_SMXP_2_1, 0x113e418)
    FIELD(POR_MPU_M5_PRLAR0_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR0_U_SMXP_2_1, REGION0_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR0_U_SMXP_2_1, REGION0_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR1_U_SMXP_2_1, 0x113e420)
    FIELD(POR_MPU_M5_PRBAR1_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR1_U_SMXP_2_1, REGION1_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR1_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR1_U_SMXP_2_1, REGION1_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR1_U_SMXP_2_1, REGION1_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR1_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR1_U_SMXP_2_1, 0x113e428)
    FIELD(POR_MPU_M5_PRLAR1_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR1_U_SMXP_2_1, REGION1_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR1_U_SMXP_2_1, REGION1_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR2_U_SMXP_2_1, 0x113e430)
    FIELD(POR_MPU_M5_PRBAR2_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR2_U_SMXP_2_1, REGION2_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR2_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR2_U_SMXP_2_1, REGION2_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR2_U_SMXP_2_1, REGION2_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR2_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR2_U_SMXP_2_1, 0x113e438)
    FIELD(POR_MPU_M5_PRLAR2_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR2_U_SMXP_2_1, REGION2_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR2_U_SMXP_2_1, REGION2_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR3_U_SMXP_2_1, 0x113e440)
    FIELD(POR_MPU_M5_PRBAR3_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR3_U_SMXP_2_1, REGION3_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR3_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR3_U_SMXP_2_1, REGION3_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR3_U_SMXP_2_1, REGION3_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR3_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR3_U_SMXP_2_1, 0x113e448)
    FIELD(POR_MPU_M5_PRLAR3_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR3_U_SMXP_2_1, REGION3_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR3_U_SMXP_2_1, REGION3_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR4_U_SMXP_2_1, 0x113e450)
    FIELD(POR_MPU_M5_PRBAR4_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR4_U_SMXP_2_1, REGION4_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR4_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR4_U_SMXP_2_1, REGION4_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR4_U_SMXP_2_1, REGION4_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR4_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR4_U_SMXP_2_1, 0x113e458)
    FIELD(POR_MPU_M5_PRLAR4_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR4_U_SMXP_2_1, REGION4_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR4_U_SMXP_2_1, REGION4_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR5_U_SMXP_2_1, 0x113e460)
    FIELD(POR_MPU_M5_PRBAR5_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR5_U_SMXP_2_1, REGION5_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR5_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR5_U_SMXP_2_1, REGION5_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR5_U_SMXP_2_1, REGION5_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR5_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR5_U_SMXP_2_1, 0x113e468)
    FIELD(POR_MPU_M5_PRLAR5_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR5_U_SMXP_2_1, REGION5_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR5_U_SMXP_2_1, REGION5_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR6_U_SMXP_2_1, 0x113e470)
    FIELD(POR_MPU_M5_PRBAR6_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR6_U_SMXP_2_1, REGION6_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR6_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR6_U_SMXP_2_1, REGION6_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR6_U_SMXP_2_1, REGION6_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR6_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR6_U_SMXP_2_1, 0x113e478)
    FIELD(POR_MPU_M5_PRLAR6_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR6_U_SMXP_2_1, REGION6_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR6_U_SMXP_2_1, REGION6_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR7_U_SMXP_2_1, 0x113e480)
    FIELD(POR_MPU_M5_PRBAR7_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR7_U_SMXP_2_1, REGION7_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR7_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR7_U_SMXP_2_1, REGION7_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR7_U_SMXP_2_1, REGION7_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR7_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR7_U_SMXP_2_1, 0x113e488)
    FIELD(POR_MPU_M5_PRLAR7_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR7_U_SMXP_2_1, REGION7_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR7_U_SMXP_2_1, REGION7_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR8_U_SMXP_2_1, 0x113e490)
    FIELD(POR_MPU_M5_PRBAR8_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR8_U_SMXP_2_1, REGION8_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR8_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR8_U_SMXP_2_1, REGION8_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR8_U_SMXP_2_1, REGION8_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR8_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR8_U_SMXP_2_1, 0x113e498)
    FIELD(POR_MPU_M5_PRLAR8_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR8_U_SMXP_2_1, REGION8_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR8_U_SMXP_2_1, REGION8_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR9_U_SMXP_2_1, 0x113e4a0)
    FIELD(POR_MPU_M5_PRBAR9_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR9_U_SMXP_2_1, REGION9_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR9_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR9_U_SMXP_2_1, REGION9_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR9_U_SMXP_2_1, REGION9_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR9_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR9_U_SMXP_2_1, 0x113e4a8)
    FIELD(POR_MPU_M5_PRLAR9_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR9_U_SMXP_2_1, REGION9_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR9_U_SMXP_2_1, REGION9_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR10_U_SMXP_2_1, 0x113e4b0)
    FIELD(POR_MPU_M5_PRBAR10_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR10_U_SMXP_2_1, REGION10_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR10_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR10_U_SMXP_2_1, REGION10_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR10_U_SMXP_2_1, REGION10_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR10_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR10_U_SMXP_2_1, 0x113e4b8)
    FIELD(POR_MPU_M5_PRLAR10_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR10_U_SMXP_2_1, REGION10_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR10_U_SMXP_2_1, REGION10_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR11_U_SMXP_2_1, 0x113e4c0)
    FIELD(POR_MPU_M5_PRBAR11_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR11_U_SMXP_2_1, REGION11_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR11_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR11_U_SMXP_2_1, REGION11_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR11_U_SMXP_2_1, REGION11_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR11_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR11_U_SMXP_2_1, 0x113e4c8)
    FIELD(POR_MPU_M5_PRLAR11_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR11_U_SMXP_2_1, REGION11_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR11_U_SMXP_2_1, REGION11_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR12_U_SMXP_2_1, 0x113e4d0)
    FIELD(POR_MPU_M5_PRBAR12_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR12_U_SMXP_2_1, REGION12_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR12_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR12_U_SMXP_2_1, REGION12_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR12_U_SMXP_2_1, REGION12_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR12_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR12_U_SMXP_2_1, 0x113e4d8)
    FIELD(POR_MPU_M5_PRLAR12_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR12_U_SMXP_2_1, REGION12_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR12_U_SMXP_2_1, REGION12_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR13_U_SMXP_2_1, 0x113e4e0)
    FIELD(POR_MPU_M5_PRBAR13_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR13_U_SMXP_2_1, REGION13_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR13_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR13_U_SMXP_2_1, REGION13_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR13_U_SMXP_2_1, REGION13_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR13_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR13_U_SMXP_2_1, 0x113e4e8)
    FIELD(POR_MPU_M5_PRLAR13_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR13_U_SMXP_2_1, REGION13_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR13_U_SMXP_2_1, REGION13_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR14_U_SMXP_2_1, 0x113e4f0)
    FIELD(POR_MPU_M5_PRBAR14_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR14_U_SMXP_2_1, REGION14_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR14_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR14_U_SMXP_2_1, REGION14_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR14_U_SMXP_2_1, REGION14_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR14_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR14_U_SMXP_2_1, 0x113e4f8)
    FIELD(POR_MPU_M5_PRLAR14_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR14_U_SMXP_2_1, REGION14_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR14_U_SMXP_2_1, REGION14_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR15_U_SMXP_2_1, 0x113e500)
    FIELD(POR_MPU_M5_PRBAR15_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR15_U_SMXP_2_1, REGION15_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR15_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR15_U_SMXP_2_1, REGION15_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR15_U_SMXP_2_1, REGION15_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR15_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR15_U_SMXP_2_1, 0x113e508)
    FIELD(POR_MPU_M5_PRLAR15_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR15_U_SMXP_2_1, REGION15_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR15_U_SMXP_2_1, REGION15_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR16_U_SMXP_2_1, 0x113e510)
    FIELD(POR_MPU_M5_PRBAR16_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR16_U_SMXP_2_1, REGION16_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR16_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR16_U_SMXP_2_1, REGION16_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR16_U_SMXP_2_1, REGION16_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR16_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR16_U_SMXP_2_1, 0x113e518)
    FIELD(POR_MPU_M5_PRLAR16_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR16_U_SMXP_2_1, REGION16_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR16_U_SMXP_2_1, REGION16_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR17_U_SMXP_2_1, 0x113e520)
    FIELD(POR_MPU_M5_PRBAR17_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR17_U_SMXP_2_1, REGION17_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR17_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR17_U_SMXP_2_1, REGION17_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR17_U_SMXP_2_1, REGION17_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR17_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR17_U_SMXP_2_1, 0x113e528)
    FIELD(POR_MPU_M5_PRLAR17_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR17_U_SMXP_2_1, REGION17_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR17_U_SMXP_2_1, REGION17_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR18_U_SMXP_2_1, 0x113e530)
    FIELD(POR_MPU_M5_PRBAR18_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR18_U_SMXP_2_1, REGION18_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR18_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR18_U_SMXP_2_1, REGION18_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR18_U_SMXP_2_1, REGION18_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR18_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR18_U_SMXP_2_1, 0x113e538)
    FIELD(POR_MPU_M5_PRLAR18_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR18_U_SMXP_2_1, REGION18_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR18_U_SMXP_2_1, REGION18_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR19_U_SMXP_2_1, 0x113e540)
    FIELD(POR_MPU_M5_PRBAR19_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR19_U_SMXP_2_1, REGION19_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR19_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR19_U_SMXP_2_1, REGION19_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR19_U_SMXP_2_1, REGION19_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR19_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR19_U_SMXP_2_1, 0x113e548)
    FIELD(POR_MPU_M5_PRLAR19_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR19_U_SMXP_2_1, REGION19_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR19_U_SMXP_2_1, REGION19_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR20_U_SMXP_2_1, 0x113e550)
    FIELD(POR_MPU_M5_PRBAR20_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR20_U_SMXP_2_1, REGION20_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR20_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR20_U_SMXP_2_1, REGION20_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR20_U_SMXP_2_1, REGION20_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR20_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR20_U_SMXP_2_1, 0x113e558)
    FIELD(POR_MPU_M5_PRLAR20_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR20_U_SMXP_2_1, REGION20_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR20_U_SMXP_2_1, REGION20_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR21_U_SMXP_2_1, 0x113e560)
    FIELD(POR_MPU_M5_PRBAR21_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR21_U_SMXP_2_1, REGION21_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR21_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR21_U_SMXP_2_1, REGION21_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR21_U_SMXP_2_1, REGION21_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR21_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR21_U_SMXP_2_1, 0x113e568)
    FIELD(POR_MPU_M5_PRLAR21_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR21_U_SMXP_2_1, REGION21_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR21_U_SMXP_2_1, REGION21_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR22_U_SMXP_2_1, 0x113e570)
    FIELD(POR_MPU_M5_PRBAR22_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR22_U_SMXP_2_1, REGION22_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR22_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR22_U_SMXP_2_1, REGION22_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR22_U_SMXP_2_1, REGION22_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR22_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR22_U_SMXP_2_1, 0x113e578)
    FIELD(POR_MPU_M5_PRLAR22_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR22_U_SMXP_2_1, REGION22_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR22_U_SMXP_2_1, REGION22_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR23_U_SMXP_2_1, 0x113e580)
    FIELD(POR_MPU_M5_PRBAR23_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR23_U_SMXP_2_1, REGION23_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR23_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR23_U_SMXP_2_1, REGION23_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR23_U_SMXP_2_1, REGION23_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR23_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR23_U_SMXP_2_1, 0x113e588)
    FIELD(POR_MPU_M5_PRLAR23_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR23_U_SMXP_2_1, REGION23_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR23_U_SMXP_2_1, REGION23_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR24_U_SMXP_2_1, 0x113e590)
    FIELD(POR_MPU_M5_PRBAR24_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR24_U_SMXP_2_1, REGION24_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR24_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR24_U_SMXP_2_1, REGION24_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR24_U_SMXP_2_1, REGION24_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR24_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR24_U_SMXP_2_1, 0x113e598)
    FIELD(POR_MPU_M5_PRLAR24_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR24_U_SMXP_2_1, REGION24_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR24_U_SMXP_2_1, REGION24_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR25_U_SMXP_2_1, 0x113e5a0)
    FIELD(POR_MPU_M5_PRBAR25_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR25_U_SMXP_2_1, REGION25_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR25_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR25_U_SMXP_2_1, REGION25_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR25_U_SMXP_2_1, REGION25_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR25_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR25_U_SMXP_2_1, 0x113e5a8)
    FIELD(POR_MPU_M5_PRLAR25_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR25_U_SMXP_2_1, REGION25_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR25_U_SMXP_2_1, REGION25_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR26_U_SMXP_2_1, 0x113e5b0)
    FIELD(POR_MPU_M5_PRBAR26_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR26_U_SMXP_2_1, REGION26_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR26_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR26_U_SMXP_2_1, REGION26_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR26_U_SMXP_2_1, REGION26_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR26_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR26_U_SMXP_2_1, 0x113e5b8)
    FIELD(POR_MPU_M5_PRLAR26_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR26_U_SMXP_2_1, REGION26_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR26_U_SMXP_2_1, REGION26_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR27_U_SMXP_2_1, 0x113e5c0)
    FIELD(POR_MPU_M5_PRBAR27_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR27_U_SMXP_2_1, REGION27_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR27_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR27_U_SMXP_2_1, REGION27_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR27_U_SMXP_2_1, REGION27_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR27_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR27_U_SMXP_2_1, 0x113e5c8)
    FIELD(POR_MPU_M5_PRLAR27_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR27_U_SMXP_2_1, REGION27_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR27_U_SMXP_2_1, REGION27_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR28_U_SMXP_2_1, 0x113e5d0)
    FIELD(POR_MPU_M5_PRBAR28_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR28_U_SMXP_2_1, REGION28_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR28_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR28_U_SMXP_2_1, REGION28_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR28_U_SMXP_2_1, REGION28_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR28_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR28_U_SMXP_2_1, 0x113e5d8)
    FIELD(POR_MPU_M5_PRLAR28_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR28_U_SMXP_2_1, REGION28_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR28_U_SMXP_2_1, REGION28_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR29_U_SMXP_2_1, 0x113e5e0)
    FIELD(POR_MPU_M5_PRBAR29_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR29_U_SMXP_2_1, REGION29_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR29_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR29_U_SMXP_2_1, REGION29_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR29_U_SMXP_2_1, REGION29_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR29_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR29_U_SMXP_2_1, 0x113e5e8)
    FIELD(POR_MPU_M5_PRLAR29_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR29_U_SMXP_2_1, REGION29_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR29_U_SMXP_2_1, REGION29_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR30_U_SMXP_2_1, 0x113e5f0)
    FIELD(POR_MPU_M5_PRBAR30_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR30_U_SMXP_2_1, REGION30_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR30_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR30_U_SMXP_2_1, REGION30_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR30_U_SMXP_2_1, REGION30_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR30_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR30_U_SMXP_2_1, 0x113e5f8)
    FIELD(POR_MPU_M5_PRLAR30_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR30_U_SMXP_2_1, REGION30_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR30_U_SMXP_2_1, REGION30_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR31_U_SMXP_2_1, 0x113e600)
    FIELD(POR_MPU_M5_PRBAR31_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR31_U_SMXP_2_1, REGION31_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR31_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR31_U_SMXP_2_1, REGION31_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR31_U_SMXP_2_1, REGION31_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR31_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR31_U_SMXP_2_1, 0x113e608)
    FIELD(POR_MPU_M5_PRLAR31_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR31_U_SMXP_2_1, REGION31_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR31_U_SMXP_2_1, REGION31_EN, 0, 1)
REG32(POR_MPU_M6_CTL_U_SMXP_2_1, 0x113e800)
    FIELD(POR_MPU_M6_CTL_U_SMXP_2_1, M6_EN, 2, 1)
    FIELD(POR_MPU_M6_CTL_U_SMXP_2_1, M6_ACTION, 0, 2)
REG32(POR_MPU_M6_PRBAR0_U_SMXP_2_1, 0x113e810)
    FIELD(POR_MPU_M6_PRBAR0_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR0_U_SMXP_2_1, REGION0_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR0_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR0_U_SMXP_2_1, REGION0_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR0_U_SMXP_2_1, REGION0_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR0_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR0_U_SMXP_2_1, 0x113e818)
    FIELD(POR_MPU_M6_PRLAR0_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR0_U_SMXP_2_1, REGION0_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR0_U_SMXP_2_1, REGION0_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR1_U_SMXP_2_1, 0x113e820)
    FIELD(POR_MPU_M6_PRBAR1_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR1_U_SMXP_2_1, REGION1_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR1_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR1_U_SMXP_2_1, REGION1_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR1_U_SMXP_2_1, REGION1_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR1_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR1_U_SMXP_2_1, 0x113e828)
    FIELD(POR_MPU_M6_PRLAR1_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR1_U_SMXP_2_1, REGION1_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR1_U_SMXP_2_1, REGION1_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR2_U_SMXP_2_1, 0x113e830)
    FIELD(POR_MPU_M6_PRBAR2_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR2_U_SMXP_2_1, REGION2_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR2_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR2_U_SMXP_2_1, REGION2_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR2_U_SMXP_2_1, REGION2_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR2_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR2_U_SMXP_2_1, 0x113e838)
    FIELD(POR_MPU_M6_PRLAR2_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR2_U_SMXP_2_1, REGION2_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR2_U_SMXP_2_1, REGION2_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR3_U_SMXP_2_1, 0x113e840)
    FIELD(POR_MPU_M6_PRBAR3_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR3_U_SMXP_2_1, REGION3_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR3_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR3_U_SMXP_2_1, REGION3_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR3_U_SMXP_2_1, REGION3_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR3_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR3_U_SMXP_2_1, 0x113e848)
    FIELD(POR_MPU_M6_PRLAR3_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR3_U_SMXP_2_1, REGION3_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR3_U_SMXP_2_1, REGION3_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR4_U_SMXP_2_1, 0x113e850)
    FIELD(POR_MPU_M6_PRBAR4_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR4_U_SMXP_2_1, REGION4_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR4_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR4_U_SMXP_2_1, REGION4_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR4_U_SMXP_2_1, REGION4_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR4_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR4_U_SMXP_2_1, 0x113e858)
    FIELD(POR_MPU_M6_PRLAR4_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR4_U_SMXP_2_1, REGION4_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR4_U_SMXP_2_1, REGION4_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR5_U_SMXP_2_1, 0x113e860)
    FIELD(POR_MPU_M6_PRBAR5_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR5_U_SMXP_2_1, REGION5_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR5_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR5_U_SMXP_2_1, REGION5_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR5_U_SMXP_2_1, REGION5_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR5_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR5_U_SMXP_2_1, 0x113e868)
    FIELD(POR_MPU_M6_PRLAR5_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR5_U_SMXP_2_1, REGION5_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR5_U_SMXP_2_1, REGION5_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR6_U_SMXP_2_1, 0x113e870)
    FIELD(POR_MPU_M6_PRBAR6_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR6_U_SMXP_2_1, REGION6_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR6_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR6_U_SMXP_2_1, REGION6_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR6_U_SMXP_2_1, REGION6_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR6_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR6_U_SMXP_2_1, 0x113e878)
    FIELD(POR_MPU_M6_PRLAR6_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR6_U_SMXP_2_1, REGION6_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR6_U_SMXP_2_1, REGION6_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR7_U_SMXP_2_1, 0x113e880)
    FIELD(POR_MPU_M6_PRBAR7_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR7_U_SMXP_2_1, REGION7_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR7_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR7_U_SMXP_2_1, REGION7_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR7_U_SMXP_2_1, REGION7_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR7_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR7_U_SMXP_2_1, 0x113e888)
    FIELD(POR_MPU_M6_PRLAR7_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR7_U_SMXP_2_1, REGION7_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR7_U_SMXP_2_1, REGION7_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR8_U_SMXP_2_1, 0x113e890)
    FIELD(POR_MPU_M6_PRBAR8_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR8_U_SMXP_2_1, REGION8_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR8_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR8_U_SMXP_2_1, REGION8_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR8_U_SMXP_2_1, REGION8_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR8_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR8_U_SMXP_2_1, 0x113e898)
    FIELD(POR_MPU_M6_PRLAR8_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR8_U_SMXP_2_1, REGION8_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR8_U_SMXP_2_1, REGION8_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR9_U_SMXP_2_1, 0x113e8a0)
    FIELD(POR_MPU_M6_PRBAR9_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR9_U_SMXP_2_1, REGION9_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR9_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR9_U_SMXP_2_1, REGION9_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR9_U_SMXP_2_1, REGION9_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR9_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR9_U_SMXP_2_1, 0x113e8a8)
    FIELD(POR_MPU_M6_PRLAR9_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR9_U_SMXP_2_1, REGION9_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR9_U_SMXP_2_1, REGION9_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR10_U_SMXP_2_1, 0x113e8b0)
    FIELD(POR_MPU_M6_PRBAR10_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR10_U_SMXP_2_1, REGION10_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR10_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR10_U_SMXP_2_1, REGION10_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR10_U_SMXP_2_1, REGION10_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR10_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR10_U_SMXP_2_1, 0x113e8b8)
    FIELD(POR_MPU_M6_PRLAR10_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR10_U_SMXP_2_1, REGION10_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR10_U_SMXP_2_1, REGION10_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR11_U_SMXP_2_1, 0x113e8c0)
    FIELD(POR_MPU_M6_PRBAR11_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR11_U_SMXP_2_1, REGION11_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR11_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR11_U_SMXP_2_1, REGION11_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR11_U_SMXP_2_1, REGION11_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR11_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR11_U_SMXP_2_1, 0x113e8c8)
    FIELD(POR_MPU_M6_PRLAR11_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR11_U_SMXP_2_1, REGION11_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR11_U_SMXP_2_1, REGION11_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR12_U_SMXP_2_1, 0x113e8d0)
    FIELD(POR_MPU_M6_PRBAR12_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR12_U_SMXP_2_1, REGION12_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR12_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR12_U_SMXP_2_1, REGION12_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR12_U_SMXP_2_1, REGION12_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR12_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR12_U_SMXP_2_1, 0x113e8d8)
    FIELD(POR_MPU_M6_PRLAR12_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR12_U_SMXP_2_1, REGION12_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR12_U_SMXP_2_1, REGION12_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR13_U_SMXP_2_1, 0x113e8e0)
    FIELD(POR_MPU_M6_PRBAR13_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR13_U_SMXP_2_1, REGION13_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR13_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR13_U_SMXP_2_1, REGION13_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR13_U_SMXP_2_1, REGION13_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR13_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR13_U_SMXP_2_1, 0x113e8e8)
    FIELD(POR_MPU_M6_PRLAR13_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR13_U_SMXP_2_1, REGION13_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR13_U_SMXP_2_1, REGION13_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR14_U_SMXP_2_1, 0x113e8f0)
    FIELD(POR_MPU_M6_PRBAR14_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR14_U_SMXP_2_1, REGION14_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR14_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR14_U_SMXP_2_1, REGION14_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR14_U_SMXP_2_1, REGION14_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR14_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR14_U_SMXP_2_1, 0x113e8f8)
    FIELD(POR_MPU_M6_PRLAR14_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR14_U_SMXP_2_1, REGION14_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR14_U_SMXP_2_1, REGION14_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR15_U_SMXP_2_1, 0x113e900)
    FIELD(POR_MPU_M6_PRBAR15_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR15_U_SMXP_2_1, REGION15_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR15_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR15_U_SMXP_2_1, REGION15_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR15_U_SMXP_2_1, REGION15_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR15_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR15_U_SMXP_2_1, 0x113e908)
    FIELD(POR_MPU_M6_PRLAR15_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR15_U_SMXP_2_1, REGION15_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR15_U_SMXP_2_1, REGION15_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR16_U_SMXP_2_1, 0x113e910)
    FIELD(POR_MPU_M6_PRBAR16_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR16_U_SMXP_2_1, REGION16_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR16_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR16_U_SMXP_2_1, REGION16_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR16_U_SMXP_2_1, REGION16_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR16_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR16_U_SMXP_2_1, 0x113e918)
    FIELD(POR_MPU_M6_PRLAR16_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR16_U_SMXP_2_1, REGION16_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR16_U_SMXP_2_1, REGION16_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR17_U_SMXP_2_1, 0x113e920)
    FIELD(POR_MPU_M6_PRBAR17_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR17_U_SMXP_2_1, REGION17_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR17_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR17_U_SMXP_2_1, REGION17_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR17_U_SMXP_2_1, REGION17_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR17_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR17_U_SMXP_2_1, 0x113e928)
    FIELD(POR_MPU_M6_PRLAR17_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR17_U_SMXP_2_1, REGION17_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR17_U_SMXP_2_1, REGION17_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR18_U_SMXP_2_1, 0x113e930)
    FIELD(POR_MPU_M6_PRBAR18_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR18_U_SMXP_2_1, REGION18_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR18_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR18_U_SMXP_2_1, REGION18_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR18_U_SMXP_2_1, REGION18_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR18_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR18_U_SMXP_2_1, 0x113e938)
    FIELD(POR_MPU_M6_PRLAR18_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR18_U_SMXP_2_1, REGION18_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR18_U_SMXP_2_1, REGION18_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR19_U_SMXP_2_1, 0x113e940)
    FIELD(POR_MPU_M6_PRBAR19_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR19_U_SMXP_2_1, REGION19_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR19_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR19_U_SMXP_2_1, REGION19_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR19_U_SMXP_2_1, REGION19_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR19_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR19_U_SMXP_2_1, 0x113e948)
    FIELD(POR_MPU_M6_PRLAR19_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR19_U_SMXP_2_1, REGION19_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR19_U_SMXP_2_1, REGION19_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR20_U_SMXP_2_1, 0x113e950)
    FIELD(POR_MPU_M6_PRBAR20_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR20_U_SMXP_2_1, REGION20_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR20_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR20_U_SMXP_2_1, REGION20_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR20_U_SMXP_2_1, REGION20_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR20_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR20_U_SMXP_2_1, 0x113e958)
    FIELD(POR_MPU_M6_PRLAR20_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR20_U_SMXP_2_1, REGION20_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR20_U_SMXP_2_1, REGION20_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR21_U_SMXP_2_1, 0x113e960)
    FIELD(POR_MPU_M6_PRBAR21_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR21_U_SMXP_2_1, REGION21_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR21_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR21_U_SMXP_2_1, REGION21_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR21_U_SMXP_2_1, REGION21_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR21_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR21_U_SMXP_2_1, 0x113e968)
    FIELD(POR_MPU_M6_PRLAR21_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR21_U_SMXP_2_1, REGION21_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR21_U_SMXP_2_1, REGION21_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR22_U_SMXP_2_1, 0x113e970)
    FIELD(POR_MPU_M6_PRBAR22_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR22_U_SMXP_2_1, REGION22_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR22_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR22_U_SMXP_2_1, REGION22_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR22_U_SMXP_2_1, REGION22_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR22_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR22_U_SMXP_2_1, 0x113e978)
    FIELD(POR_MPU_M6_PRLAR22_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR22_U_SMXP_2_1, REGION22_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR22_U_SMXP_2_1, REGION22_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR23_U_SMXP_2_1, 0x113e980)
    FIELD(POR_MPU_M6_PRBAR23_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR23_U_SMXP_2_1, REGION23_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR23_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR23_U_SMXP_2_1, REGION23_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR23_U_SMXP_2_1, REGION23_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR23_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR23_U_SMXP_2_1, 0x113e988)
    FIELD(POR_MPU_M6_PRLAR23_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR23_U_SMXP_2_1, REGION23_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR23_U_SMXP_2_1, REGION23_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR24_U_SMXP_2_1, 0x113e990)
    FIELD(POR_MPU_M6_PRBAR24_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR24_U_SMXP_2_1, REGION24_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR24_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR24_U_SMXP_2_1, REGION24_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR24_U_SMXP_2_1, REGION24_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR24_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR24_U_SMXP_2_1, 0x113e998)
    FIELD(POR_MPU_M6_PRLAR24_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR24_U_SMXP_2_1, REGION24_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR24_U_SMXP_2_1, REGION24_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR25_U_SMXP_2_1, 0x113e9a0)
    FIELD(POR_MPU_M6_PRBAR25_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR25_U_SMXP_2_1, REGION25_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR25_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR25_U_SMXP_2_1, REGION25_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR25_U_SMXP_2_1, REGION25_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR25_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR25_U_SMXP_2_1, 0x113e9a8)
    FIELD(POR_MPU_M6_PRLAR25_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR25_U_SMXP_2_1, REGION25_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR25_U_SMXP_2_1, REGION25_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR26_U_SMXP_2_1, 0x113e9b0)
    FIELD(POR_MPU_M6_PRBAR26_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR26_U_SMXP_2_1, REGION26_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR26_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR26_U_SMXP_2_1, REGION26_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR26_U_SMXP_2_1, REGION26_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR26_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR26_U_SMXP_2_1, 0x113e9b8)
    FIELD(POR_MPU_M6_PRLAR26_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR26_U_SMXP_2_1, REGION26_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR26_U_SMXP_2_1, REGION26_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR27_U_SMXP_2_1, 0x113e9c0)
    FIELD(POR_MPU_M6_PRBAR27_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR27_U_SMXP_2_1, REGION27_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR27_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR27_U_SMXP_2_1, REGION27_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR27_U_SMXP_2_1, REGION27_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR27_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR27_U_SMXP_2_1, 0x113e9c8)
    FIELD(POR_MPU_M6_PRLAR27_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR27_U_SMXP_2_1, REGION27_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR27_U_SMXP_2_1, REGION27_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR28_U_SMXP_2_1, 0x113e9d0)
    FIELD(POR_MPU_M6_PRBAR28_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR28_U_SMXP_2_1, REGION28_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR28_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR28_U_SMXP_2_1, REGION28_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR28_U_SMXP_2_1, REGION28_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR28_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR28_U_SMXP_2_1, 0x113e9d8)
    FIELD(POR_MPU_M6_PRLAR28_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR28_U_SMXP_2_1, REGION28_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR28_U_SMXP_2_1, REGION28_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR29_U_SMXP_2_1, 0x113e9e0)
    FIELD(POR_MPU_M6_PRBAR29_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR29_U_SMXP_2_1, REGION29_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR29_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR29_U_SMXP_2_1, REGION29_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR29_U_SMXP_2_1, REGION29_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR29_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR29_U_SMXP_2_1, 0x113e9e8)
    FIELD(POR_MPU_M6_PRLAR29_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR29_U_SMXP_2_1, REGION29_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR29_U_SMXP_2_1, REGION29_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR30_U_SMXP_2_1, 0x113e9f0)
    FIELD(POR_MPU_M6_PRBAR30_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR30_U_SMXP_2_1, REGION30_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR30_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR30_U_SMXP_2_1, REGION30_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR30_U_SMXP_2_1, REGION30_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR30_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR30_U_SMXP_2_1, 0x113e9f8)
    FIELD(POR_MPU_M6_PRLAR30_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR30_U_SMXP_2_1, REGION30_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR30_U_SMXP_2_1, REGION30_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR31_U_SMXP_2_1, 0x113ea00)
    FIELD(POR_MPU_M6_PRBAR31_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR31_U_SMXP_2_1, REGION31_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR31_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR31_U_SMXP_2_1, REGION31_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR31_U_SMXP_2_1, REGION31_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR31_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR31_U_SMXP_2_1, 0x113ea08)
    FIELD(POR_MPU_M6_PRLAR31_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR31_U_SMXP_2_1, REGION31_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR31_U_SMXP_2_1, REGION31_EN, 0, 1)
REG32(POR_MPU_M7_CTL_U_SMXP_2_1, 0x113ec00)
    FIELD(POR_MPU_M7_CTL_U_SMXP_2_1, M7_EN, 2, 1)
    FIELD(POR_MPU_M7_CTL_U_SMXP_2_1, M7_ACTION, 0, 2)
REG32(POR_MPU_M7_PRBAR0_U_SMXP_2_1, 0x113ec10)
    FIELD(POR_MPU_M7_PRBAR0_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR0_U_SMXP_2_1, REGION0_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR0_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR0_U_SMXP_2_1, REGION0_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR0_U_SMXP_2_1, REGION0_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR0_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR0_U_SMXP_2_1, 0x113ec18)
    FIELD(POR_MPU_M7_PRLAR0_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR0_U_SMXP_2_1, REGION0_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR0_U_SMXP_2_1, REGION0_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR1_U_SMXP_2_1, 0x113ec20)
    FIELD(POR_MPU_M7_PRBAR1_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR1_U_SMXP_2_1, REGION1_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR1_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR1_U_SMXP_2_1, REGION1_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR1_U_SMXP_2_1, REGION1_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR1_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR1_U_SMXP_2_1, 0x113ec28)
    FIELD(POR_MPU_M7_PRLAR1_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR1_U_SMXP_2_1, REGION1_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR1_U_SMXP_2_1, REGION1_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR2_U_SMXP_2_1, 0x113ec30)
    FIELD(POR_MPU_M7_PRBAR2_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR2_U_SMXP_2_1, REGION2_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR2_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR2_U_SMXP_2_1, REGION2_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR2_U_SMXP_2_1, REGION2_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR2_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR2_U_SMXP_2_1, 0x113ec38)
    FIELD(POR_MPU_M7_PRLAR2_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR2_U_SMXP_2_1, REGION2_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR2_U_SMXP_2_1, REGION2_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR3_U_SMXP_2_1, 0x113ec40)
    FIELD(POR_MPU_M7_PRBAR3_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR3_U_SMXP_2_1, REGION3_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR3_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR3_U_SMXP_2_1, REGION3_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR3_U_SMXP_2_1, REGION3_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR3_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR3_U_SMXP_2_1, 0x113ec48)
    FIELD(POR_MPU_M7_PRLAR3_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR3_U_SMXP_2_1, REGION3_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR3_U_SMXP_2_1, REGION3_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR4_U_SMXP_2_1, 0x113ec50)
    FIELD(POR_MPU_M7_PRBAR4_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR4_U_SMXP_2_1, REGION4_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR4_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR4_U_SMXP_2_1, REGION4_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR4_U_SMXP_2_1, REGION4_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR4_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR4_U_SMXP_2_1, 0x113ec58)
    FIELD(POR_MPU_M7_PRLAR4_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR4_U_SMXP_2_1, REGION4_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR4_U_SMXP_2_1, REGION4_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR5_U_SMXP_2_1, 0x113ec60)
    FIELD(POR_MPU_M7_PRBAR5_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR5_U_SMXP_2_1, REGION5_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR5_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR5_U_SMXP_2_1, REGION5_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR5_U_SMXP_2_1, REGION5_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR5_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR5_U_SMXP_2_1, 0x113ec68)
    FIELD(POR_MPU_M7_PRLAR5_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR5_U_SMXP_2_1, REGION5_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR5_U_SMXP_2_1, REGION5_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR6_U_SMXP_2_1, 0x113ec70)
    FIELD(POR_MPU_M7_PRBAR6_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR6_U_SMXP_2_1, REGION6_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR6_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR6_U_SMXP_2_1, REGION6_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR6_U_SMXP_2_1, REGION6_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR6_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR6_U_SMXP_2_1, 0x113ec78)
    FIELD(POR_MPU_M7_PRLAR6_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR6_U_SMXP_2_1, REGION6_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR6_U_SMXP_2_1, REGION6_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR7_U_SMXP_2_1, 0x113ec80)
    FIELD(POR_MPU_M7_PRBAR7_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR7_U_SMXP_2_1, REGION7_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR7_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR7_U_SMXP_2_1, REGION7_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR7_U_SMXP_2_1, REGION7_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR7_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR7_U_SMXP_2_1, 0x113ec88)
    FIELD(POR_MPU_M7_PRLAR7_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR7_U_SMXP_2_1, REGION7_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR7_U_SMXP_2_1, REGION7_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR8_U_SMXP_2_1, 0x113ec90)
    FIELD(POR_MPU_M7_PRBAR8_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR8_U_SMXP_2_1, REGION8_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR8_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR8_U_SMXP_2_1, REGION8_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR8_U_SMXP_2_1, REGION8_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR8_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR8_U_SMXP_2_1, 0x113ec98)
    FIELD(POR_MPU_M7_PRLAR8_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR8_U_SMXP_2_1, REGION8_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR8_U_SMXP_2_1, REGION8_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR9_U_SMXP_2_1, 0x113eca0)
    FIELD(POR_MPU_M7_PRBAR9_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR9_U_SMXP_2_1, REGION9_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR9_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR9_U_SMXP_2_1, REGION9_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR9_U_SMXP_2_1, REGION9_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR9_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR9_U_SMXP_2_1, 0x113eca8)
    FIELD(POR_MPU_M7_PRLAR9_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR9_U_SMXP_2_1, REGION9_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR9_U_SMXP_2_1, REGION9_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR10_U_SMXP_2_1, 0x113ecb0)
    FIELD(POR_MPU_M7_PRBAR10_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR10_U_SMXP_2_1, REGION10_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR10_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR10_U_SMXP_2_1, REGION10_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR10_U_SMXP_2_1, REGION10_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR10_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR10_U_SMXP_2_1, 0x113ecb8)
    FIELD(POR_MPU_M7_PRLAR10_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR10_U_SMXP_2_1, REGION10_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR10_U_SMXP_2_1, REGION10_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR11_U_SMXP_2_1, 0x113ecc0)
    FIELD(POR_MPU_M7_PRBAR11_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR11_U_SMXP_2_1, REGION11_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR11_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR11_U_SMXP_2_1, REGION11_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR11_U_SMXP_2_1, REGION11_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR11_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR11_U_SMXP_2_1, 0x113ecc8)
    FIELD(POR_MPU_M7_PRLAR11_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR11_U_SMXP_2_1, REGION11_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR11_U_SMXP_2_1, REGION11_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR12_U_SMXP_2_1, 0x113ecd0)
    FIELD(POR_MPU_M7_PRBAR12_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR12_U_SMXP_2_1, REGION12_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR12_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR12_U_SMXP_2_1, REGION12_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR12_U_SMXP_2_1, REGION12_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR12_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR12_U_SMXP_2_1, 0x113ecd8)
    FIELD(POR_MPU_M7_PRLAR12_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR12_U_SMXP_2_1, REGION12_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR12_U_SMXP_2_1, REGION12_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR13_U_SMXP_2_1, 0x113ece0)
    FIELD(POR_MPU_M7_PRBAR13_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR13_U_SMXP_2_1, REGION13_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR13_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR13_U_SMXP_2_1, REGION13_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR13_U_SMXP_2_1, REGION13_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR13_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR13_U_SMXP_2_1, 0x113ece8)
    FIELD(POR_MPU_M7_PRLAR13_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR13_U_SMXP_2_1, REGION13_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR13_U_SMXP_2_1, REGION13_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR14_U_SMXP_2_1, 0x113ecf0)
    FIELD(POR_MPU_M7_PRBAR14_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR14_U_SMXP_2_1, REGION14_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR14_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR14_U_SMXP_2_1, REGION14_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR14_U_SMXP_2_1, REGION14_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR14_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR14_U_SMXP_2_1, 0x113ecf8)
    FIELD(POR_MPU_M7_PRLAR14_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR14_U_SMXP_2_1, REGION14_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR14_U_SMXP_2_1, REGION14_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR15_U_SMXP_2_1, 0x113ed00)
    FIELD(POR_MPU_M7_PRBAR15_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR15_U_SMXP_2_1, REGION15_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR15_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR15_U_SMXP_2_1, REGION15_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR15_U_SMXP_2_1, REGION15_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR15_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR15_U_SMXP_2_1, 0x113ed08)
    FIELD(POR_MPU_M7_PRLAR15_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR15_U_SMXP_2_1, REGION15_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR15_U_SMXP_2_1, REGION15_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR16_U_SMXP_2_1, 0x113ed10)
    FIELD(POR_MPU_M7_PRBAR16_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR16_U_SMXP_2_1, REGION16_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR16_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR16_U_SMXP_2_1, REGION16_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR16_U_SMXP_2_1, REGION16_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR16_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR16_U_SMXP_2_1, 0x113ed18)
    FIELD(POR_MPU_M7_PRLAR16_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR16_U_SMXP_2_1, REGION16_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR16_U_SMXP_2_1, REGION16_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR17_U_SMXP_2_1, 0x113ed20)
    FIELD(POR_MPU_M7_PRBAR17_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR17_U_SMXP_2_1, REGION17_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR17_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR17_U_SMXP_2_1, REGION17_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR17_U_SMXP_2_1, REGION17_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR17_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR17_U_SMXP_2_1, 0x113ed28)
    FIELD(POR_MPU_M7_PRLAR17_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR17_U_SMXP_2_1, REGION17_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR17_U_SMXP_2_1, REGION17_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR18_U_SMXP_2_1, 0x113ed30)
    FIELD(POR_MPU_M7_PRBAR18_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR18_U_SMXP_2_1, REGION18_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR18_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR18_U_SMXP_2_1, REGION18_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR18_U_SMXP_2_1, REGION18_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR18_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR18_U_SMXP_2_1, 0x113ed38)
    FIELD(POR_MPU_M7_PRLAR18_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR18_U_SMXP_2_1, REGION18_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR18_U_SMXP_2_1, REGION18_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR19_U_SMXP_2_1, 0x113ed40)
    FIELD(POR_MPU_M7_PRBAR19_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR19_U_SMXP_2_1, REGION19_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR19_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR19_U_SMXP_2_1, REGION19_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR19_U_SMXP_2_1, REGION19_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR19_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR19_U_SMXP_2_1, 0x113ed48)
    FIELD(POR_MPU_M7_PRLAR19_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR19_U_SMXP_2_1, REGION19_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR19_U_SMXP_2_1, REGION19_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR20_U_SMXP_2_1, 0x113ed50)
    FIELD(POR_MPU_M7_PRBAR20_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR20_U_SMXP_2_1, REGION20_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR20_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR20_U_SMXP_2_1, REGION20_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR20_U_SMXP_2_1, REGION20_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR20_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR20_U_SMXP_2_1, 0x113ed58)
    FIELD(POR_MPU_M7_PRLAR20_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR20_U_SMXP_2_1, REGION20_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR20_U_SMXP_2_1, REGION20_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR21_U_SMXP_2_1, 0x113ed60)
    FIELD(POR_MPU_M7_PRBAR21_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR21_U_SMXP_2_1, REGION21_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR21_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR21_U_SMXP_2_1, REGION21_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR21_U_SMXP_2_1, REGION21_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR21_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR21_U_SMXP_2_1, 0x113ed68)
    FIELD(POR_MPU_M7_PRLAR21_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR21_U_SMXP_2_1, REGION21_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR21_U_SMXP_2_1, REGION21_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR22_U_SMXP_2_1, 0x113ed70)
    FIELD(POR_MPU_M7_PRBAR22_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR22_U_SMXP_2_1, REGION22_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR22_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR22_U_SMXP_2_1, REGION22_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR22_U_SMXP_2_1, REGION22_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR22_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR22_U_SMXP_2_1, 0x113ed78)
    FIELD(POR_MPU_M7_PRLAR22_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR22_U_SMXP_2_1, REGION22_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR22_U_SMXP_2_1, REGION22_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR23_U_SMXP_2_1, 0x113ed80)
    FIELD(POR_MPU_M7_PRBAR23_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR23_U_SMXP_2_1, REGION23_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR23_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR23_U_SMXP_2_1, REGION23_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR23_U_SMXP_2_1, REGION23_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR23_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR23_U_SMXP_2_1, 0x113ed88)
    FIELD(POR_MPU_M7_PRLAR23_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR23_U_SMXP_2_1, REGION23_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR23_U_SMXP_2_1, REGION23_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR24_U_SMXP_2_1, 0x113ed90)
    FIELD(POR_MPU_M7_PRBAR24_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR24_U_SMXP_2_1, REGION24_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR24_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR24_U_SMXP_2_1, REGION24_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR24_U_SMXP_2_1, REGION24_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR24_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR24_U_SMXP_2_1, 0x113ed98)
    FIELD(POR_MPU_M7_PRLAR24_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR24_U_SMXP_2_1, REGION24_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR24_U_SMXP_2_1, REGION24_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR25_U_SMXP_2_1, 0x113eda0)
    FIELD(POR_MPU_M7_PRBAR25_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR25_U_SMXP_2_1, REGION25_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR25_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR25_U_SMXP_2_1, REGION25_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR25_U_SMXP_2_1, REGION25_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR25_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR25_U_SMXP_2_1, 0x113eda8)
    FIELD(POR_MPU_M7_PRLAR25_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR25_U_SMXP_2_1, REGION25_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR25_U_SMXP_2_1, REGION25_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR26_U_SMXP_2_1, 0x113edb0)
    FIELD(POR_MPU_M7_PRBAR26_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR26_U_SMXP_2_1, REGION26_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR26_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR26_U_SMXP_2_1, REGION26_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR26_U_SMXP_2_1, REGION26_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR26_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR26_U_SMXP_2_1, 0x113edb8)
    FIELD(POR_MPU_M7_PRLAR26_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR26_U_SMXP_2_1, REGION26_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR26_U_SMXP_2_1, REGION26_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR27_U_SMXP_2_1, 0x113edc0)
    FIELD(POR_MPU_M7_PRBAR27_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR27_U_SMXP_2_1, REGION27_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR27_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR27_U_SMXP_2_1, REGION27_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR27_U_SMXP_2_1, REGION27_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR27_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR27_U_SMXP_2_1, 0x113edc8)
    FIELD(POR_MPU_M7_PRLAR27_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR27_U_SMXP_2_1, REGION27_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR27_U_SMXP_2_1, REGION27_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR28_U_SMXP_2_1, 0x113edd0)
    FIELD(POR_MPU_M7_PRBAR28_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR28_U_SMXP_2_1, REGION28_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR28_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR28_U_SMXP_2_1, REGION28_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR28_U_SMXP_2_1, REGION28_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR28_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR28_U_SMXP_2_1, 0x113edd8)
    FIELD(POR_MPU_M7_PRLAR28_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR28_U_SMXP_2_1, REGION28_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR28_U_SMXP_2_1, REGION28_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR29_U_SMXP_2_1, 0x113ede0)
    FIELD(POR_MPU_M7_PRBAR29_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR29_U_SMXP_2_1, REGION29_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR29_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR29_U_SMXP_2_1, REGION29_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR29_U_SMXP_2_1, REGION29_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR29_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR29_U_SMXP_2_1, 0x113ede8)
    FIELD(POR_MPU_M7_PRLAR29_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR29_U_SMXP_2_1, REGION29_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR29_U_SMXP_2_1, REGION29_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR30_U_SMXP_2_1, 0x113edf0)
    FIELD(POR_MPU_M7_PRBAR30_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR30_U_SMXP_2_1, REGION30_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR30_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR30_U_SMXP_2_1, REGION30_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR30_U_SMXP_2_1, REGION30_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR30_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR30_U_SMXP_2_1, 0x113edf8)
    FIELD(POR_MPU_M7_PRLAR30_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR30_U_SMXP_2_1, REGION30_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR30_U_SMXP_2_1, REGION30_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR31_U_SMXP_2_1, 0x113ee00)
    FIELD(POR_MPU_M7_PRBAR31_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR31_U_SMXP_2_1, REGION31_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR31_U_SMXP_2_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR31_U_SMXP_2_1, REGION31_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR31_U_SMXP_2_1, REGION31_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR31_U_SMXP_2_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR31_U_SMXP_2_1, 0x113ee08)
    FIELD(POR_MPU_M7_PRLAR31_U_SMXP_2_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR31_U_SMXP_2_1, REGION31_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR31_U_SMXP_2_1, REGION31_EN, 0, 1)
REG32(POR_RNSAM_NODE_INFO_U_RNFBESAM_NID140, 0x1168000)
    FIELD(POR_RNSAM_NODE_INFO_U_RNFBESAM_NID140, RESERVED_48, 48, 16)
    FIELD(POR_RNSAM_NODE_INFO_U_RNFBESAM_NID140, LOGICAL_ID, 32, 16)
    FIELD(POR_RNSAM_NODE_INFO_U_RNFBESAM_NID140, NODE_ID, 16, 16)
    FIELD(POR_RNSAM_NODE_INFO_U_RNFBESAM_NID140, NODE_TYPE, 0, 16)
REG32(POR_RNSAM_CHILD_INFO_U_RNFBESAM_NID140, 0x1168080)
    FIELD(POR_RNSAM_CHILD_INFO_U_RNFBESAM_NID140, RESERVED_32, 32, 32)
    FIELD(POR_RNSAM_CHILD_INFO_U_RNFBESAM_NID140, CHILD_PTR_OFFSET, 16, 16)
    FIELD(POR_RNSAM_CHILD_INFO_U_RNFBESAM_NID140, CHILD_COUNT, 0, 16)
REG32(POR_RNSAM_UNIT_INFO_U_RNFBESAM_NID140, 0x1168900)
    FIELD(POR_RNSAM_UNIT_INFO_U_RNFBESAM_NID140, RESERVED_37, 37, 27)
    FIELD(POR_RNSAM_UNIT_INFO_U_RNFBESAM_NID140, NUM_NON_HASH_GROUP, 32, 5)
    FIELD(POR_RNSAM_UNIT_INFO_U_RNFBESAM_NID140, RESERVED_20, 20, 12)
    FIELD(POR_RNSAM_UNIT_INFO_U_RNFBESAM_NID140, NUM_SYS_CACHE_GROUP, 16, 4)
    FIELD(POR_RNSAM_UNIT_INFO_U_RNFBESAM_NID140, NUM_HNF, 0, 8)
REG32(POR_RNSAM_SECURE_REGISTER_GROUPS_OVERRIDE_U_RNFBESAM_NID140, 0x1168980)
    FIELD(POR_RNSAM_SECURE_REGISTER_GROUPS_OVERRIDE_U_RNFBESAM_NID140, MEM_RANGE, 0, 1)
REG32(RNSAM_STATUS_U_RNFBESAM_NID140, 0x1168c00)
    FIELD(RNSAM_STATUS_U_RNFBESAM_NID140, NSTALL_REQ, 1, 1)
    FIELD(RNSAM_STATUS_U_RNFBESAM_NID140, USE_DEFAULT_NODE, 0, 1)
REG32(NON_HASH_MEM_REGION_REG0_U_RNFBESAM_NID140, 0x1168c08)
    FIELD(NON_HASH_MEM_REGION_REG0_U_RNFBESAM_NID140, RESERVED_63, 63, 1)
    FIELD(NON_HASH_MEM_REGION_REG0_U_RNFBESAM_NID140, REGION1_BASE_ADDR, 41, 22)
    FIELD(NON_HASH_MEM_REGION_REG0_U_RNFBESAM_NID140, REGION1_SIZE, 36, 5)
    FIELD(NON_HASH_MEM_REGION_REG0_U_RNFBESAM_NID140, REGION1_TARGET_TYPE, 34, 2)
    FIELD(NON_HASH_MEM_REGION_REG0_U_RNFBESAM_NID140, RESERVED_33, 33, 1)
    FIELD(NON_HASH_MEM_REGION_REG0_U_RNFBESAM_NID140, REGION1_VALID, 32, 1)
    FIELD(NON_HASH_MEM_REGION_REG0_U_RNFBESAM_NID140, RESERVED_31, 31, 1)
    FIELD(NON_HASH_MEM_REGION_REG0_U_RNFBESAM_NID140, REGION0_BASE_ADDR, 9, 22)
    FIELD(NON_HASH_MEM_REGION_REG0_U_RNFBESAM_NID140, REGION0_SIZE, 4, 5)
    FIELD(NON_HASH_MEM_REGION_REG0_U_RNFBESAM_NID140, REGION0_TARGET_TYPE, 2, 2)
    FIELD(NON_HASH_MEM_REGION_REG0_U_RNFBESAM_NID140, REGION0_VALID, 0, 1)
REG32(NON_HASH_MEM_REGION_REG1_U_RNFBESAM_NID140, 0x1168c10)
    FIELD(NON_HASH_MEM_REGION_REG1_U_RNFBESAM_NID140, RESERVED_63, 63, 1)
    FIELD(NON_HASH_MEM_REGION_REG1_U_RNFBESAM_NID140, REGION3_BASE_ADDR, 41, 22)
    FIELD(NON_HASH_MEM_REGION_REG1_U_RNFBESAM_NID140, REGION3_SIZE, 36, 5)
    FIELD(NON_HASH_MEM_REGION_REG1_U_RNFBESAM_NID140, REGION3_TARGET_TYPE, 34, 2)
    FIELD(NON_HASH_MEM_REGION_REG1_U_RNFBESAM_NID140, RESERVED_33, 33, 1)
    FIELD(NON_HASH_MEM_REGION_REG1_U_RNFBESAM_NID140, REGION3_VALID, 32, 1)
    FIELD(NON_HASH_MEM_REGION_REG1_U_RNFBESAM_NID140, RESERVED_31, 31, 1)
    FIELD(NON_HASH_MEM_REGION_REG1_U_RNFBESAM_NID140, REGION2_BASE_ADDR, 9, 22)
    FIELD(NON_HASH_MEM_REGION_REG1_U_RNFBESAM_NID140, REGION2_SIZE, 4, 5)
    FIELD(NON_HASH_MEM_REGION_REG1_U_RNFBESAM_NID140, REGION2_TARGET_TYPE, 2, 2)
    FIELD(NON_HASH_MEM_REGION_REG1_U_RNFBESAM_NID140, REGION2_VALID, 0, 1)
REG32(NON_HASH_MEM_REGION_REG2_U_RNFBESAM_NID140, 0x1168c18)
    FIELD(NON_HASH_MEM_REGION_REG2_U_RNFBESAM_NID140, RESERVED_63, 63, 1)
    FIELD(NON_HASH_MEM_REGION_REG2_U_RNFBESAM_NID140, REGION5_BASE_ADDR, 41, 22)
    FIELD(NON_HASH_MEM_REGION_REG2_U_RNFBESAM_NID140, REGION5_SIZE, 36, 5)
    FIELD(NON_HASH_MEM_REGION_REG2_U_RNFBESAM_NID140, REGION5_TARGET_TYPE, 34, 2)
    FIELD(NON_HASH_MEM_REGION_REG2_U_RNFBESAM_NID140, RESERVED_33, 33, 1)
    FIELD(NON_HASH_MEM_REGION_REG2_U_RNFBESAM_NID140, REGION5_VALID, 32, 1)
    FIELD(NON_HASH_MEM_REGION_REG2_U_RNFBESAM_NID140, RESERVED_31, 31, 1)
    FIELD(NON_HASH_MEM_REGION_REG2_U_RNFBESAM_NID140, REGION4_BASE_ADDR, 9, 22)
    FIELD(NON_HASH_MEM_REGION_REG2_U_RNFBESAM_NID140, REGION4_SIZE, 4, 5)
    FIELD(NON_HASH_MEM_REGION_REG2_U_RNFBESAM_NID140, REGION4_TARGET_TYPE, 2, 2)
    FIELD(NON_HASH_MEM_REGION_REG2_U_RNFBESAM_NID140, REGION4_VALID, 0, 1)
REG32(NON_HASH_MEM_REGION_REG3_U_RNFBESAM_NID140, 0x1168c20)
    FIELD(NON_HASH_MEM_REGION_REG3_U_RNFBESAM_NID140, RESERVED_63, 63, 1)
    FIELD(NON_HASH_MEM_REGION_REG3_U_RNFBESAM_NID140, REGION7_BASE_ADDR, 41, 22)
    FIELD(NON_HASH_MEM_REGION_REG3_U_RNFBESAM_NID140, REGION7_SIZE, 36, 5)
    FIELD(NON_HASH_MEM_REGION_REG3_U_RNFBESAM_NID140, REGION7_TARGET_TYPE, 34, 2)
    FIELD(NON_HASH_MEM_REGION_REG3_U_RNFBESAM_NID140, RESERVED_33, 33, 1)
    FIELD(NON_HASH_MEM_REGION_REG3_U_RNFBESAM_NID140, REGION7_VALID, 32, 1)
    FIELD(NON_HASH_MEM_REGION_REG3_U_RNFBESAM_NID140, RESERVED_31, 31, 1)
    FIELD(NON_HASH_MEM_REGION_REG3_U_RNFBESAM_NID140, REGION6_BASE_ADDR, 9, 22)
    FIELD(NON_HASH_MEM_REGION_REG3_U_RNFBESAM_NID140, REGION6_SIZE, 4, 5)
    FIELD(NON_HASH_MEM_REGION_REG3_U_RNFBESAM_NID140, REGION6_TARGET_TYPE, 2, 2)
    FIELD(NON_HASH_MEM_REGION_REG3_U_RNFBESAM_NID140, REGION6_VALID, 0, 1)
REG32(NON_HASH_TGT_NODEID0_U_RNFBESAM_NID140, 0x1168c30)
    FIELD(NON_HASH_TGT_NODEID0_U_RNFBESAM_NID140, RESERVED_47, 47, 17)
    FIELD(NON_HASH_TGT_NODEID0_U_RNFBESAM_NID140, NODEID_3, 36, 11)
    FIELD(NON_HASH_TGT_NODEID0_U_RNFBESAM_NID140, RESERVED_35, 35, 1)
    FIELD(NON_HASH_TGT_NODEID0_U_RNFBESAM_NID140, NODEID_2, 24, 11)
    FIELD(NON_HASH_TGT_NODEID0_U_RNFBESAM_NID140, RESERVED_23, 23, 1)
    FIELD(NON_HASH_TGT_NODEID0_U_RNFBESAM_NID140, NODEID_1, 12, 11)
    FIELD(NON_HASH_TGT_NODEID0_U_RNFBESAM_NID140, RESERVED_11, 11, 1)
    FIELD(NON_HASH_TGT_NODEID0_U_RNFBESAM_NID140, NODEID_0, 0, 11)
REG32(NON_HASH_TGT_NODEID1_U_RNFBESAM_NID140, 0x1168c38)
    FIELD(NON_HASH_TGT_NODEID1_U_RNFBESAM_NID140, RESERVED_47, 47, 17)
    FIELD(NON_HASH_TGT_NODEID1_U_RNFBESAM_NID140, NODEID_7, 36, 11)
    FIELD(NON_HASH_TGT_NODEID1_U_RNFBESAM_NID140, RESERVED_35, 35, 1)
    FIELD(NON_HASH_TGT_NODEID1_U_RNFBESAM_NID140, NODEID_6, 24, 11)
    FIELD(NON_HASH_TGT_NODEID1_U_RNFBESAM_NID140, RESERVED_23, 23, 1)
    FIELD(NON_HASH_TGT_NODEID1_U_RNFBESAM_NID140, NODEID_5, 12, 11)
    FIELD(NON_HASH_TGT_NODEID1_U_RNFBESAM_NID140, RESERVED_11, 11, 1)
    FIELD(NON_HASH_TGT_NODEID1_U_RNFBESAM_NID140, NODEID_4, 0, 11)
REG32(NON_HASH_TGT_NODEID2_U_RNFBESAM_NID140, 0x1168c40)
    FIELD(NON_HASH_TGT_NODEID2_U_RNFBESAM_NID140, RESERVED_23, 23, 41)
    FIELD(NON_HASH_TGT_NODEID2_U_RNFBESAM_NID140, NODEID_9, 12, 11)
    FIELD(NON_HASH_TGT_NODEID2_U_RNFBESAM_NID140, RESERVED_11, 11, 1)
    FIELD(NON_HASH_TGT_NODEID2_U_RNFBESAM_NID140, NODEID_8, 0, 11)
REG32(SYS_CACHE_GRP_REGION0_U_RNFBESAM_NID140, 0x1168c48)
    FIELD(SYS_CACHE_GRP_REGION0_U_RNFBESAM_NID140, RESERVED_63, 63, 1)
    FIELD(SYS_CACHE_GRP_REGION0_U_RNFBESAM_NID140, REGION1_BASE_ADDR, 41, 22)
    FIELD(SYS_CACHE_GRP_REGION0_U_RNFBESAM_NID140, REGION1_SIZE, 36, 5)
    FIELD(SYS_CACHE_GRP_REGION0_U_RNFBESAM_NID140, REGION1_TARGET_TYPE, 34, 2)
    FIELD(SYS_CACHE_GRP_REGION0_U_RNFBESAM_NID140, REGION1_NONHASH_REG_EN, 33, 1)
    FIELD(SYS_CACHE_GRP_REGION0_U_RNFBESAM_NID140, REGION1_VALID, 32, 1)
    FIELD(SYS_CACHE_GRP_REGION0_U_RNFBESAM_NID140, RESERVED_31, 31, 1)
    FIELD(SYS_CACHE_GRP_REGION0_U_RNFBESAM_NID140, REGION0_BASE_ADDR, 9, 22)
    FIELD(SYS_CACHE_GRP_REGION0_U_RNFBESAM_NID140, REGION0_SIZE, 4, 5)
    FIELD(SYS_CACHE_GRP_REGION0_U_RNFBESAM_NID140, REGION0_TARGET_TYPE, 2, 2)
    FIELD(SYS_CACHE_GRP_REGION0_U_RNFBESAM_NID140, REGION0_VALID, 0, 1)
REG32(SYS_CACHE_GRP_REGION1_U_RNFBESAM_NID140, 0x1168c50)
    FIELD(SYS_CACHE_GRP_REGION1_U_RNFBESAM_NID140, RESERVED_63, 63, 1)
    FIELD(SYS_CACHE_GRP_REGION1_U_RNFBESAM_NID140, REGION3_BASE_ADDR, 41, 22)
    FIELD(SYS_CACHE_GRP_REGION1_U_RNFBESAM_NID140, REGION3_SIZE, 36, 5)
    FIELD(SYS_CACHE_GRP_REGION1_U_RNFBESAM_NID140, REGION3_TARGET_TYPE, 34, 2)
    FIELD(SYS_CACHE_GRP_REGION1_U_RNFBESAM_NID140, REGION3_NONHASH_REG_EN, 33, 1)
    FIELD(SYS_CACHE_GRP_REGION1_U_RNFBESAM_NID140, REGION3_VALID, 32, 1)
    FIELD(SYS_CACHE_GRP_REGION1_U_RNFBESAM_NID140, RESERVED_31, 31, 1)
    FIELD(SYS_CACHE_GRP_REGION1_U_RNFBESAM_NID140, REGION2_BASE_ADDR, 9, 22)
    FIELD(SYS_CACHE_GRP_REGION1_U_RNFBESAM_NID140, REGION2_SIZE, 4, 5)
    FIELD(SYS_CACHE_GRP_REGION1_U_RNFBESAM_NID140, REGION2_TARGET_TYPE, 2, 2)
    FIELD(SYS_CACHE_GRP_REGION1_U_RNFBESAM_NID140, REGION2_NONHASH_REG_EN, 1, 1)
    FIELD(SYS_CACHE_GRP_REGION1_U_RNFBESAM_NID140, REGION2_VALID, 0, 1)
REG32(SYS_CACHE_GRP_HN_NODEID_REG0_U_RNFBESAM_NID140, 0x1168c58)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG0_U_RNFBESAM_NID140, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG0_U_RNFBESAM_NID140, NODEID_3, 36, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG0_U_RNFBESAM_NID140, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG0_U_RNFBESAM_NID140, NODEID_2, 24, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG0_U_RNFBESAM_NID140, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG0_U_RNFBESAM_NID140, NODEID_1, 12, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG0_U_RNFBESAM_NID140, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG0_U_RNFBESAM_NID140, NODEID_0, 0, 11)
REG32(SYS_CACHE_GRP_HN_NODEID_REG1_U_RNFBESAM_NID140, 0x1168c60)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG1_U_RNFBESAM_NID140, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG1_U_RNFBESAM_NID140, NODEID_7, 36, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG1_U_RNFBESAM_NID140, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG1_U_RNFBESAM_NID140, NODEID_6, 24, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG1_U_RNFBESAM_NID140, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG1_U_RNFBESAM_NID140, NODEID_5, 12, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG1_U_RNFBESAM_NID140, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG1_U_RNFBESAM_NID140, NODEID_4, 0, 11)
REG32(SYS_CACHE_GRP_HN_NODEID_REG2_U_RNFBESAM_NID140, 0x1168c68)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG2_U_RNFBESAM_NID140, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG2_U_RNFBESAM_NID140, NODEID_11, 36, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG2_U_RNFBESAM_NID140, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG2_U_RNFBESAM_NID140, NODEID_10, 24, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG2_U_RNFBESAM_NID140, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG2_U_RNFBESAM_NID140, NODEID_9, 12, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG2_U_RNFBESAM_NID140, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG2_U_RNFBESAM_NID140, NODEID_8, 0, 11)
REG32(SYS_CACHE_GRP_HN_NODEID_REG3_U_RNFBESAM_NID140, 0x1168c70)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG3_U_RNFBESAM_NID140, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG3_U_RNFBESAM_NID140, NODEID_15, 36, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG3_U_RNFBESAM_NID140, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG3_U_RNFBESAM_NID140, NODEID_14, 24, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG3_U_RNFBESAM_NID140, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG3_U_RNFBESAM_NID140, NODEID_13, 12, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG3_U_RNFBESAM_NID140, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG3_U_RNFBESAM_NID140, NODEID_12, 0, 11)
REG32(SYS_CACHE_GRP_HN_NODEID_REG4_U_RNFBESAM_NID140, 0x1168c78)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG4_U_RNFBESAM_NID140, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG4_U_RNFBESAM_NID140, NODEID_19, 36, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG4_U_RNFBESAM_NID140, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG4_U_RNFBESAM_NID140, NODEID_18, 24, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG4_U_RNFBESAM_NID140, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG4_U_RNFBESAM_NID140, NODEID_17, 12, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG4_U_RNFBESAM_NID140, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG4_U_RNFBESAM_NID140, NODEID_16, 0, 11)
REG32(SYS_CACHE_GRP_HN_NODEID_REG5_U_RNFBESAM_NID140, 0x1168c80)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG5_U_RNFBESAM_NID140, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG5_U_RNFBESAM_NID140, NODEID_23, 36, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG5_U_RNFBESAM_NID140, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG5_U_RNFBESAM_NID140, NODEID_22, 24, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG5_U_RNFBESAM_NID140, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG5_U_RNFBESAM_NID140, NODEID_21, 12, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG5_U_RNFBESAM_NID140, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG5_U_RNFBESAM_NID140, NODEID_20, 0, 11)
REG32(SYS_CACHE_GRP_HN_NODEID_REG6_U_RNFBESAM_NID140, 0x1168c88)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG6_U_RNFBESAM_NID140, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG6_U_RNFBESAM_NID140, NODEID_27, 36, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG6_U_RNFBESAM_NID140, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG6_U_RNFBESAM_NID140, NODEID_26, 24, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG6_U_RNFBESAM_NID140, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG6_U_RNFBESAM_NID140, NODEID_25, 12, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG6_U_RNFBESAM_NID140, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG6_U_RNFBESAM_NID140, NODEID_24, 0, 11)
REG32(SYS_CACHE_GRP_HN_NODEID_REG7_U_RNFBESAM_NID140, 0x1168c90)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG7_U_RNFBESAM_NID140, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG7_U_RNFBESAM_NID140, NODEID_31, 36, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG7_U_RNFBESAM_NID140, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG7_U_RNFBESAM_NID140, NODEID_30, 24, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG7_U_RNFBESAM_NID140, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG7_U_RNFBESAM_NID140, NODEID_29, 12, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG7_U_RNFBESAM_NID140, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG7_U_RNFBESAM_NID140, NODEID_28, 0, 11)
REG32(SYS_CACHE_GRP_NONHASH_NODEID_U_RNFBESAM_NID140, 0x1168c98)
    FIELD(SYS_CACHE_GRP_NONHASH_NODEID_U_RNFBESAM_NID140, RESERVED_35, 35, 29)
    FIELD(SYS_CACHE_GRP_NONHASH_NODEID_U_RNFBESAM_NID140, SCG3_NODEID, 24, 11)
    FIELD(SYS_CACHE_GRP_NONHASH_NODEID_U_RNFBESAM_NID140, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_NONHASH_NODEID_U_RNFBESAM_NID140, SCG2_NODEID, 12, 11)
    FIELD(SYS_CACHE_GRP_NONHASH_NODEID_U_RNFBESAM_NID140, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_NONHASH_NODEID_U_RNFBESAM_NID140, SCG1_NODEID, 0, 11)
REG32(SYS_CACHE_GROUP_HN_COUNT_U_RNFBESAM_NID140, 0x1168d00)
    FIELD(SYS_CACHE_GROUP_HN_COUNT_U_RNFBESAM_NID140, RESERVED_31, 31, 33)
    FIELD(SYS_CACHE_GROUP_HN_COUNT_U_RNFBESAM_NID140, SCG3_NUM_HNF, 24, 7)
    FIELD(SYS_CACHE_GROUP_HN_COUNT_U_RNFBESAM_NID140, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GROUP_HN_COUNT_U_RNFBESAM_NID140, SCG2_NUM_HNF, 16, 7)
    FIELD(SYS_CACHE_GROUP_HN_COUNT_U_RNFBESAM_NID140, RESERVED_15, 15, 1)
    FIELD(SYS_CACHE_GROUP_HN_COUNT_U_RNFBESAM_NID140, SCG1_NUM_HNF, 8, 7)
    FIELD(SYS_CACHE_GROUP_HN_COUNT_U_RNFBESAM_NID140, SCG0_NUM_HNF, 0, 7)
REG32(SYS_CACHE_GRP_SN_NODEID_REG0_U_RNFBESAM_NID140, 0x1168d08)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG0_U_RNFBESAM_NID140, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG0_U_RNFBESAM_NID140, SN_NODEID_3, 36, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG0_U_RNFBESAM_NID140, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG0_U_RNFBESAM_NID140, SN_NODEID_2, 24, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG0_U_RNFBESAM_NID140, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG0_U_RNFBESAM_NID140, SN_NODEID_1, 12, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG0_U_RNFBESAM_NID140, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG0_U_RNFBESAM_NID140, SN_NODEID_0, 0, 11)
REG32(SYS_CACHE_GRP_SN_NODEID_REG1_U_RNFBESAM_NID140, 0x1168d10)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG1_U_RNFBESAM_NID140, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG1_U_RNFBESAM_NID140, SN_NODEID_7, 36, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG1_U_RNFBESAM_NID140, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG1_U_RNFBESAM_NID140, SN_NODEID_6, 24, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG1_U_RNFBESAM_NID140, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG1_U_RNFBESAM_NID140, SN_NODEID_5, 12, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG1_U_RNFBESAM_NID140, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG1_U_RNFBESAM_NID140, SN_NODEID_4, 0, 11)
REG32(SYS_CACHE_GRP_SN_NODEID_REG2_U_RNFBESAM_NID140, 0x1168d18)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG2_U_RNFBESAM_NID140, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG2_U_RNFBESAM_NID140, SN_NODEID_11, 36, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG2_U_RNFBESAM_NID140, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG2_U_RNFBESAM_NID140, SN_NODEID_10, 24, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG2_U_RNFBESAM_NID140, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG2_U_RNFBESAM_NID140, SN_NODEID_9, 12, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG2_U_RNFBESAM_NID140, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG2_U_RNFBESAM_NID140, SN_NODEID_8, 0, 11)
REG32(SYS_CACHE_GRP_SN_NODEID_REG3_U_RNFBESAM_NID140, 0x1168d20)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG3_U_RNFBESAM_NID140, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG3_U_RNFBESAM_NID140, SN_NODEID_15, 36, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG3_U_RNFBESAM_NID140, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG3_U_RNFBESAM_NID140, SN_NODEID_14, 24, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG3_U_RNFBESAM_NID140, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG3_U_RNFBESAM_NID140, SN_NODEID_13, 12, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG3_U_RNFBESAM_NID140, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG3_U_RNFBESAM_NID140, SN_NODEID_12, 0, 11)
REG32(SYS_CACHE_GRP_SN_NODEID_REG4_U_RNFBESAM_NID140, 0x1168d28)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG4_U_RNFBESAM_NID140, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG4_U_RNFBESAM_NID140, SN_NODEID_19, 36, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG4_U_RNFBESAM_NID140, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG4_U_RNFBESAM_NID140, SN_NODEID_18, 24, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG4_U_RNFBESAM_NID140, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG4_U_RNFBESAM_NID140, SN_NODEID_17, 12, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG4_U_RNFBESAM_NID140, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG4_U_RNFBESAM_NID140, SN_NODEID_16, 0, 11)
REG32(SYS_CACHE_GRP_SN_NODEID_REG5_U_RNFBESAM_NID140, 0x1168d30)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG5_U_RNFBESAM_NID140, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG5_U_RNFBESAM_NID140, SN_NODEID_23, 36, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG5_U_RNFBESAM_NID140, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG5_U_RNFBESAM_NID140, SN_NODEID_22, 24, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG5_U_RNFBESAM_NID140, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG5_U_RNFBESAM_NID140, SN_NODEID_21, 12, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG5_U_RNFBESAM_NID140, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG5_U_RNFBESAM_NID140, SN_NODEID_20, 0, 11)
REG32(SYS_CACHE_GRP_SN_NODEID_REG6_U_RNFBESAM_NID140, 0x1168d38)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG6_U_RNFBESAM_NID140, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG6_U_RNFBESAM_NID140, SN_NODEID_27, 36, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG6_U_RNFBESAM_NID140, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG6_U_RNFBESAM_NID140, SN_NODEID_26, 24, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG6_U_RNFBESAM_NID140, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG6_U_RNFBESAM_NID140, SN_NODEID_25, 12, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG6_U_RNFBESAM_NID140, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG6_U_RNFBESAM_NID140, SN_NODEID_24, 0, 11)
REG32(SYS_CACHE_GRP_SN_NODEID_REG7_U_RNFBESAM_NID140, 0x1168d40)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG7_U_RNFBESAM_NID140, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG7_U_RNFBESAM_NID140, SN_NODEID_31, 36, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG7_U_RNFBESAM_NID140, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG7_U_RNFBESAM_NID140, SN_NODEID_30, 24, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG7_U_RNFBESAM_NID140, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG7_U_RNFBESAM_NID140, SN_NODEID_29, 12, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG7_U_RNFBESAM_NID140, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG7_U_RNFBESAM_NID140, SN_NODEID_28, 0, 11)
REG32(SYS_CACHE_GRP_SN_SAM_CFG0_U_RNFBESAM_NID140, 0x1168d48)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG0_U_RNFBESAM_NID140, RESERVED_46, 46, 18)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG0_U_RNFBESAM_NID140, SCG1_TOP_ADDRESS_BIT2, 40, 6)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG0_U_RNFBESAM_NID140, RESERVED_38, 38, 2)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG0_U_RNFBESAM_NID140, SCG1_TOP_ADDRESS_BIT1, 32, 6)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG0_U_RNFBESAM_NID140, RESERVED_30, 30, 2)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG0_U_RNFBESAM_NID140, SCG1_TOP_ADDRESS_BIT0, 24, 6)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG0_U_RNFBESAM_NID140, RESERVED_22, 22, 2)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG0_U_RNFBESAM_NID140, SCG0_TOP_ADDRESS_BIT2, 16, 6)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG0_U_RNFBESAM_NID140, RESERVED_14, 14, 2)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG0_U_RNFBESAM_NID140, SCG0_TOP_ADDRESS_BIT1, 8, 6)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG0_U_RNFBESAM_NID140, SCG0_TOP_ADDRESS_BIT0, 0, 6)
REG32(SYS_CACHE_GRP_SN_SAM_CFG1_U_RNFBESAM_NID140, 0x1168d50)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG1_U_RNFBESAM_NID140, RESERVED_46, 46, 18)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG1_U_RNFBESAM_NID140, SCG3_TOP_ADDRESS_BIT2, 40, 6)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG1_U_RNFBESAM_NID140, RESERVED_38, 38, 2)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG1_U_RNFBESAM_NID140, SCG3_TOP_ADDRESS_BIT1, 32, 6)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG1_U_RNFBESAM_NID140, RESERVED_30, 30, 2)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG1_U_RNFBESAM_NID140, SCG3_TOP_ADDRESS_BIT0, 24, 6)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG1_U_RNFBESAM_NID140, RESERVED_22, 22, 2)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG1_U_RNFBESAM_NID140, SCG2_TOP_ADDRESS_BIT2, 16, 6)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG1_U_RNFBESAM_NID140, RESERVED_14, 14, 2)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG1_U_RNFBESAM_NID140, SCG2_TOP_ADDRESS_BIT1, 8, 6)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG1_U_RNFBESAM_NID140, SCG2_TOP_ADDRESS_BIT0, 0, 6)
REG32(GIC_MEM_REGION_REG_U_RNFBESAM_NID140, 0x1168d58)
    FIELD(GIC_MEM_REGION_REG_U_RNFBESAM_NID140, RESERVED_63, 63, 1)
    FIELD(GIC_MEM_REGION_REG_U_RNFBESAM_NID140, GIC_REGION_NODEID, 52, 11)
    FIELD(GIC_MEM_REGION_REG_U_RNFBESAM_NID140, RESERVED_48, 48, 4)
    FIELD(GIC_MEM_REGION_REG_U_RNFBESAM_NID140, GIC_REGION_BASE_ADDR, 16, 32)
    FIELD(GIC_MEM_REGION_REG_U_RNFBESAM_NID140, GIC_REGION_SIZE, 4, 3)
    FIELD(GIC_MEM_REGION_REG_U_RNFBESAM_NID140, GIC_REGION_TARGET_TYPE, 2, 2)
    FIELD(GIC_MEM_REGION_REG_U_RNFBESAM_NID140, GIC_REGION_VALID, 0, 1)
REG32(SYS_CACHE_GRP_SN_ATTR_U_RNFBESAM_NID140, 0x1168d60)
    FIELD(SYS_CACHE_GRP_SN_ATTR_U_RNFBESAM_NID140, RESERVED_54, 54, 10)
    FIELD(SYS_CACHE_GRP_SN_ATTR_U_RNFBESAM_NID140, SN_MODE_SYS_CACHE_GRP3, 52, 2)
    FIELD(SYS_CACHE_GRP_SN_ATTR_U_RNFBESAM_NID140, RESERVED_49, 49, 3)
    FIELD(SYS_CACHE_GRP_SN_ATTR_U_RNFBESAM_NID140, INV_TOP_ADDRESS_BIT_SYS_CACHE_GRP3, 48, 1)
    FIELD(SYS_CACHE_GRP_SN_ATTR_U_RNFBESAM_NID140, RESERVED_38, 38, 10)
    FIELD(SYS_CACHE_GRP_SN_ATTR_U_RNFBESAM_NID140, SN_MODE_SYS_CACHE_GRP2, 36, 2)
    FIELD(SYS_CACHE_GRP_SN_ATTR_U_RNFBESAM_NID140, RESERVED_33, 33, 3)
    FIELD(SYS_CACHE_GRP_SN_ATTR_U_RNFBESAM_NID140, INV_TOP_ADDRESS_BIT_SYS_CACHE_GRP2, 32, 1)
    FIELD(SYS_CACHE_GRP_SN_ATTR_U_RNFBESAM_NID140, RESERVED_22, 22, 10)
    FIELD(SYS_CACHE_GRP_SN_ATTR_U_RNFBESAM_NID140, SN_MODE_SYS_CACHE_GRP1, 20, 2)
    FIELD(SYS_CACHE_GRP_SN_ATTR_U_RNFBESAM_NID140, RESERVED_17, 17, 3)
    FIELD(SYS_CACHE_GRP_SN_ATTR_U_RNFBESAM_NID140, INV_TOP_ADDRESS_BIT_SYS_CACHE_GRP1, 16, 1)
    FIELD(SYS_CACHE_GRP_SN_ATTR_U_RNFBESAM_NID140, SN_MODE_SYS_CACHE_GRP0, 4, 2)
    FIELD(SYS_CACHE_GRP_SN_ATTR_U_RNFBESAM_NID140, INV_TOP_ADDRESS_BIT_SYS_CACHE_GRP0, 0, 1)
REG32(SYS_CACHE_GRP_HN_CPA_EN_REG_U_RNFBESAM_NID140, 0x1168d68)
REG32(SYS_CACHE_GRP_HN_CPA_GRP_REG_U_RNFBESAM_NID140, 0x1168d70)
    FIELD(SYS_CACHE_GRP_HN_CPA_GRP_REG_U_RNFBESAM_NID140, RESERVED_50, 50, 14)
    FIELD(SYS_CACHE_GRP_HN_CPA_GRP_REG_U_RNFBESAM_NID140, CPA_GRP_SCG3, 48, 2)
    FIELD(SYS_CACHE_GRP_HN_CPA_GRP_REG_U_RNFBESAM_NID140, RESERVED_34, 34, 14)
    FIELD(SYS_CACHE_GRP_HN_CPA_GRP_REG_U_RNFBESAM_NID140, CPA_GRP_SCG2, 32, 2)
    FIELD(SYS_CACHE_GRP_HN_CPA_GRP_REG_U_RNFBESAM_NID140, RESERVED_18, 18, 14)
    FIELD(SYS_CACHE_GRP_HN_CPA_GRP_REG_U_RNFBESAM_NID140, CPA_GRP_SCG1, 16, 2)
    FIELD(SYS_CACHE_GRP_HN_CPA_GRP_REG_U_RNFBESAM_NID140, CPA_GRP_SCG0, 0, 2)
REG32(CML_PORT_AGGR_MODE_CTRL_REG_U_RNFBESAM_NID140, 0x1168e00)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNFBESAM_NID140, RESERVED_32, 32, 32)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNFBESAM_NID140, REGION7_PAG_GRPID, 30, 2)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNFBESAM_NID140, RESERVED_29, 29, 1)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNFBESAM_NID140, REGION7_PAG_EN, 28, 1)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNFBESAM_NID140, RESERVED_27, 27, 1)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNFBESAM_NID140, REGION6_PAG_GRPID, 25, 2)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNFBESAM_NID140, REGION6_PAG_EN, 24, 1)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNFBESAM_NID140, RESERVED_23, 23, 1)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNFBESAM_NID140, REGION5_PAG_GRPID, 21, 2)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNFBESAM_NID140, REGION5_PAG_EN, 20, 1)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNFBESAM_NID140, RESERVED_19, 19, 1)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNFBESAM_NID140, REGION4_PAG_GRPID, 17, 2)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNFBESAM_NID140, REGION4_PAG_EN, 16, 1)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNFBESAM_NID140, RESERVED_15, 15, 1)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNFBESAM_NID140, REGION3_PAG_GRPID, 13, 2)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNFBESAM_NID140, REGION3_PAG_EN, 12, 1)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNFBESAM_NID140, RESERVED_11, 11, 1)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNFBESAM_NID140, REGION2_PAG_GRPID, 9, 2)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNFBESAM_NID140, REGION2_PAG_EN, 8, 1)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNFBESAM_NID140, REGION1_PAG_GRPID, 5, 2)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNFBESAM_NID140, REGION1_PAG_EN, 4, 1)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNFBESAM_NID140, REGION0_PAG_GRPID, 1, 2)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNFBESAM_NID140, REGION0_PAG_EN, 0, 1)
REG32(CML_PORT_AGGR_GRP0_ADD_MASK_U_RNFBESAM_NID140, 0x1168e08)
    FIELD(CML_PORT_AGGR_GRP0_ADD_MASK_U_RNFBESAM_NID140, RESERVED_48, 48, 16)
    FIELD(CML_PORT_AGGR_GRP0_ADD_MASK_U_RNFBESAM_NID140, ADDR_MASK, 6, 42)
    FIELD(CML_PORT_AGGR_GRP0_ADD_MASK_U_RNFBESAM_NID140, RESERVED_0, 0, 6)
REG32(CML_PORT_AGGR_GRP1_ADD_MASK_U_RNFBESAM_NID140, 0x1168e10)
    FIELD(CML_PORT_AGGR_GRP1_ADD_MASK_U_RNFBESAM_NID140, RESERVED_48, 48, 16)
    FIELD(CML_PORT_AGGR_GRP1_ADD_MASK_U_RNFBESAM_NID140, ADDR_MASK, 6, 42)
    FIELD(CML_PORT_AGGR_GRP1_ADD_MASK_U_RNFBESAM_NID140, RESERVED_0, 0, 6)
REG32(CML_PORT_AGGR_GRP0_REG_U_RNFBESAM_NID140, 0x1168e40)
    FIELD(CML_PORT_AGGR_GRP0_REG_U_RNFBESAM_NID140, RESERVED_50, 50, 14)
    FIELD(CML_PORT_AGGR_GRP0_REG_U_RNFBESAM_NID140, NUM_CXG_PAG0, 48, 2)
    FIELD(CML_PORT_AGGR_GRP0_REG_U_RNFBESAM_NID140, RESERVED_47, 47, 1)
    FIELD(CML_PORT_AGGR_GRP0_REG_U_RNFBESAM_NID140, PAG0_TGTID3, 36, 11)
    FIELD(CML_PORT_AGGR_GRP0_REG_U_RNFBESAM_NID140, RESERVED_35, 35, 1)
    FIELD(CML_PORT_AGGR_GRP0_REG_U_RNFBESAM_NID140, PAG0_TGTID2, 24, 11)
    FIELD(CML_PORT_AGGR_GRP0_REG_U_RNFBESAM_NID140, RESERVED_23, 23, 1)
    FIELD(CML_PORT_AGGR_GRP0_REG_U_RNFBESAM_NID140, PAG0_TGTID1, 12, 11)
    FIELD(CML_PORT_AGGR_GRP0_REG_U_RNFBESAM_NID140, RESERVED_11, 11, 1)
    FIELD(CML_PORT_AGGR_GRP0_REG_U_RNFBESAM_NID140, PAG0_TGTID0, 0, 11)
REG32(CML_PORT_AGGR_GRP1_REG_U_RNFBESAM_NID140, 0x1168e48)
    FIELD(CML_PORT_AGGR_GRP1_REG_U_RNFBESAM_NID140, RESERVED_50, 50, 14)
    FIELD(CML_PORT_AGGR_GRP1_REG_U_RNFBESAM_NID140, NUM_CXG_PAG1, 48, 2)
    FIELD(CML_PORT_AGGR_GRP1_REG_U_RNFBESAM_NID140, RESERVED_47, 47, 1)
    FIELD(CML_PORT_AGGR_GRP1_REG_U_RNFBESAM_NID140, PAG1_TGTID3, 36, 11)
    FIELD(CML_PORT_AGGR_GRP1_REG_U_RNFBESAM_NID140, RESERVED_35, 35, 1)
    FIELD(CML_PORT_AGGR_GRP1_REG_U_RNFBESAM_NID140, PAG1_TGTID2, 24, 11)
    FIELD(CML_PORT_AGGR_GRP1_REG_U_RNFBESAM_NID140, RESERVED_23, 23, 1)
    FIELD(CML_PORT_AGGR_GRP1_REG_U_RNFBESAM_NID140, PAG1_TGTID1, 12, 11)
    FIELD(CML_PORT_AGGR_GRP1_REG_U_RNFBESAM_NID140, RESERVED_11, 11, 1)
    FIELD(CML_PORT_AGGR_GRP1_REG_U_RNFBESAM_NID140, PAG1_TGTID0, 0, 11)
REG32(SYS_CACHE_GRP_SECONDARY_REG0_U_RNFBESAM_NID140, 0x1168f00)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG0_U_RNFBESAM_NID140, RESERVED_63, 63, 1)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG0_U_RNFBESAM_NID140, REGION1_SCNDRY_BASE_ADDR, 41, 22)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG0_U_RNFBESAM_NID140, REGION1_SCNDRY_SIZE, 36, 5)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG0_U_RNFBESAM_NID140, REGION1_SCNDRY_TARGET_TYPE, 34, 2)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG0_U_RNFBESAM_NID140, RESERVED_33, 33, 1)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG0_U_RNFBESAM_NID140, REGION1_SCNDRY_VALID, 32, 1)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG0_U_RNFBESAM_NID140, RESERVED_31, 31, 1)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG0_U_RNFBESAM_NID140, REGION0_SCNDRY_BASE_ADDR, 9, 22)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG0_U_RNFBESAM_NID140, REGION0_SCNDRY_SIZE, 4, 5)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG0_U_RNFBESAM_NID140, REGION0_SCNDRY_TARGET_TYPE, 2, 2)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG0_U_RNFBESAM_NID140, REGION0_SCNDRY_VALID, 0, 1)
REG32(SYS_CACHE_GRP_SECONDARY_REG1_U_RNFBESAM_NID140, 0x1168f08)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG1_U_RNFBESAM_NID140, RESERVED_63, 63, 1)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG1_U_RNFBESAM_NID140, REGION3_SCNDRY_BASE_ADDR, 41, 22)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG1_U_RNFBESAM_NID140, REGION3_SCNDRY_SIZE, 36, 5)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG1_U_RNFBESAM_NID140, REGION3_SCNDRY_TARGET_TYPE, 34, 2)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG1_U_RNFBESAM_NID140, RESERVED_33, 33, 1)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG1_U_RNFBESAM_NID140, REGION3_SCNDRY_VALID, 32, 1)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG1_U_RNFBESAM_NID140, RESERVED_31, 31, 1)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG1_U_RNFBESAM_NID140, REGION2_SCNDRY_BASE_ADDR, 9, 22)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG1_U_RNFBESAM_NID140, REGION2_SCNDRY_SIZE, 4, 5)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG1_U_RNFBESAM_NID140, REGION2_SCNDRY_TARGET_TYPE, 2, 2)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG1_U_RNFBESAM_NID140, REGION2_SCNDRY_VALID, 0, 1)
REG32(SYS_CACHE_GRP_CAL_MODE_REG_U_RNFBESAM_NID140, 0x1168f10)
    FIELD(SYS_CACHE_GRP_CAL_MODE_REG_U_RNFBESAM_NID140, RESERVED_49, 49, 15)
    FIELD(SYS_CACHE_GRP_CAL_MODE_REG_U_RNFBESAM_NID140, SCG3_HNF_CAL_MODE_EN, 48, 1)
    FIELD(SYS_CACHE_GRP_CAL_MODE_REG_U_RNFBESAM_NID140, RESERVED_33, 33, 15)
    FIELD(SYS_CACHE_GRP_CAL_MODE_REG_U_RNFBESAM_NID140, SCG2_HNF_CAL_MODE_EN, 32, 1)
    FIELD(SYS_CACHE_GRP_CAL_MODE_REG_U_RNFBESAM_NID140, RESERVED_17, 17, 15)
    FIELD(SYS_CACHE_GRP_CAL_MODE_REG_U_RNFBESAM_NID140, SCG1_HNF_CAL_MODE_EN, 16, 1)
    FIELD(SYS_CACHE_GRP_CAL_MODE_REG_U_RNFBESAM_NID140, SCG0_HNF_CAL_MODE_EN, 0, 1)
REG32(RNSAM_HASH_ADDR_MASK_REG_U_RNFBESAM_NID140, 0x1168f18)
    FIELD(RNSAM_HASH_ADDR_MASK_REG_U_RNFBESAM_NID140, RESERVED_48, 48, 16)
    FIELD(RNSAM_HASH_ADDR_MASK_REG_U_RNFBESAM_NID140, ADDR_MASK, 6, 42)
    FIELD(RNSAM_HASH_ADDR_MASK_REG_U_RNFBESAM_NID140, RESERVED_0, 0, 6)
REG32(RNSAM_REGION_CMP_ADDR_MASK_REG_U_RNFBESAM_NID140, 0x1168f20)
    FIELD(RNSAM_REGION_CMP_ADDR_MASK_REG_U_RNFBESAM_NID140, RESERVED_48, 48, 16)
    FIELD(RNSAM_REGION_CMP_ADDR_MASK_REG_U_RNFBESAM_NID140, ADDR_MASK, 16, 32)
    FIELD(RNSAM_REGION_CMP_ADDR_MASK_REG_U_RNFBESAM_NID140, RESERVED_0, 0, 16)
REG32(SYS_CACHE_GRP_HN_NODEID_REG8_U_RNFBESAM_NID140, 0x1168f58)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG8_U_RNFBESAM_NID140, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG8_U_RNFBESAM_NID140, NODEID_35, 36, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG8_U_RNFBESAM_NID140, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG8_U_RNFBESAM_NID140, NODEID_34, 24, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG8_U_RNFBESAM_NID140, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG8_U_RNFBESAM_NID140, NODEID_33, 12, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG8_U_RNFBESAM_NID140, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG8_U_RNFBESAM_NID140, NODEID_32, 0, 11)
REG32(SYS_CACHE_GRP_HN_NODEID_REG9_U_RNFBESAM_NID140, 0x1168f60)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG9_U_RNFBESAM_NID140, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG9_U_RNFBESAM_NID140, NODEID_39, 36, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG9_U_RNFBESAM_NID140, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG9_U_RNFBESAM_NID140, NODEID_38, 24, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG9_U_RNFBESAM_NID140, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG9_U_RNFBESAM_NID140, NODEID_37, 12, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG9_U_RNFBESAM_NID140, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG9_U_RNFBESAM_NID140, NODEID_36, 0, 11)
REG32(SYS_CACHE_GRP_HN_NODEID_REG10_U_RNFBESAM_NID140, 0x1168f68)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG10_U_RNFBESAM_NID140, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG10_U_RNFBESAM_NID140, NODEID_43, 36, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG10_U_RNFBESAM_NID140, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG10_U_RNFBESAM_NID140, NODEID_42, 24, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG10_U_RNFBESAM_NID140, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG10_U_RNFBESAM_NID140, NODEID_41, 12, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG10_U_RNFBESAM_NID140, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG10_U_RNFBESAM_NID140, NODEID_40, 0, 11)
REG32(SYS_CACHE_GRP_HN_NODEID_REG11_U_RNFBESAM_NID140, 0x1168f70)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG11_U_RNFBESAM_NID140, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG11_U_RNFBESAM_NID140, NODEID_47, 36, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG11_U_RNFBESAM_NID140, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG11_U_RNFBESAM_NID140, NODEID_46, 24, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG11_U_RNFBESAM_NID140, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG11_U_RNFBESAM_NID140, NODEID_45, 12, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG11_U_RNFBESAM_NID140, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG11_U_RNFBESAM_NID140, NODEID_44, 0, 11)
REG32(SYS_CACHE_GRP_HN_NODEID_REG12_U_RNFBESAM_NID140, 0x1168f78)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG12_U_RNFBESAM_NID140, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG12_U_RNFBESAM_NID140, NODEID_51, 36, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG12_U_RNFBESAM_NID140, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG12_U_RNFBESAM_NID140, NODEID_50, 24, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG12_U_RNFBESAM_NID140, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG12_U_RNFBESAM_NID140, NODEID_49, 12, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG12_U_RNFBESAM_NID140, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG12_U_RNFBESAM_NID140, NODEID_48, 0, 11)
REG32(SYS_CACHE_GRP_HN_NODEID_REG13_U_RNFBESAM_NID140, 0x1168f80)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG13_U_RNFBESAM_NID140, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG13_U_RNFBESAM_NID140, NODEID_55, 36, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG13_U_RNFBESAM_NID140, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG13_U_RNFBESAM_NID140, NODEID_54, 24, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG13_U_RNFBESAM_NID140, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG13_U_RNFBESAM_NID140, NODEID_53, 12, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG13_U_RNFBESAM_NID140, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG13_U_RNFBESAM_NID140, NODEID_52, 0, 11)
REG32(SYS_CACHE_GRP_HN_NODEID_REG14_U_RNFBESAM_NID140, 0x1168f88)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG14_U_RNFBESAM_NID140, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG14_U_RNFBESAM_NID140, NODEID_59, 36, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG14_U_RNFBESAM_NID140, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG14_U_RNFBESAM_NID140, NODEID_58, 24, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG14_U_RNFBESAM_NID140, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG14_U_RNFBESAM_NID140, NODEID_57, 12, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG14_U_RNFBESAM_NID140, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG14_U_RNFBESAM_NID140, NODEID_56, 0, 11)
REG32(SYS_CACHE_GRP_HN_NODEID_REG15_U_RNFBESAM_NID140, 0x1168f90)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG15_U_RNFBESAM_NID140, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG15_U_RNFBESAM_NID140, NODEID_63, 36, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG15_U_RNFBESAM_NID140, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG15_U_RNFBESAM_NID140, NODEID_62, 24, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG15_U_RNFBESAM_NID140, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG15_U_RNFBESAM_NID140, NODEID_61, 12, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG15_U_RNFBESAM_NID140, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG15_U_RNFBESAM_NID140, NODEID_60, 0, 11)
REG32(SYS_CACHE_GRP_SN_NODEID_REG8_U_RNFBESAM_NID140, 0x1169008)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG8_U_RNFBESAM_NID140, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG8_U_RNFBESAM_NID140, SN_NODEID_35, 36, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG8_U_RNFBESAM_NID140, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG8_U_RNFBESAM_NID140, SN_NODEID_34, 24, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG8_U_RNFBESAM_NID140, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG8_U_RNFBESAM_NID140, SN_NODEID_33, 12, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG8_U_RNFBESAM_NID140, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG8_U_RNFBESAM_NID140, SN_NODEID_32, 0, 11)
REG32(SYS_CACHE_GRP_SN_NODEID_REG9_U_RNFBESAM_NID140, 0x1169010)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG9_U_RNFBESAM_NID140, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG9_U_RNFBESAM_NID140, SN_NODEID_39, 36, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG9_U_RNFBESAM_NID140, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG9_U_RNFBESAM_NID140, SN_NODEID_38, 24, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG9_U_RNFBESAM_NID140, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG9_U_RNFBESAM_NID140, SN_NODEID_37, 12, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG9_U_RNFBESAM_NID140, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG9_U_RNFBESAM_NID140, SN_NODEID_36, 0, 11)
REG32(SYS_CACHE_GRP_SN_NODEID_REG10_U_RNFBESAM_NID140, 0x1169018)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG10_U_RNFBESAM_NID140, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG10_U_RNFBESAM_NID140, SN_NODEID_43, 36, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG10_U_RNFBESAM_NID140, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG10_U_RNFBESAM_NID140, SN_NODEID_42, 24, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG10_U_RNFBESAM_NID140, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG10_U_RNFBESAM_NID140, SN_NODEID_41, 12, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG10_U_RNFBESAM_NID140, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG10_U_RNFBESAM_NID140, SN_NODEID_40, 0, 11)
REG32(SYS_CACHE_GRP_SN_NODEID_REG11_U_RNFBESAM_NID140, 0x1169020)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG11_U_RNFBESAM_NID140, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG11_U_RNFBESAM_NID140, SN_NODEID_47, 36, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG11_U_RNFBESAM_NID140, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG11_U_RNFBESAM_NID140, SN_NODEID_46, 24, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG11_U_RNFBESAM_NID140, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG11_U_RNFBESAM_NID140, SN_NODEID_45, 12, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG11_U_RNFBESAM_NID140, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG11_U_RNFBESAM_NID140, SN_NODEID_44, 0, 11)
REG32(SYS_CACHE_GRP_SN_NODEID_REG12_U_RNFBESAM_NID140, 0x1169028)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG12_U_RNFBESAM_NID140, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG12_U_RNFBESAM_NID140, SN_NODEID_51, 36, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG12_U_RNFBESAM_NID140, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG12_U_RNFBESAM_NID140, SN_NODEID_50, 24, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG12_U_RNFBESAM_NID140, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG12_U_RNFBESAM_NID140, SN_NODEID_49, 12, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG12_U_RNFBESAM_NID140, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG12_U_RNFBESAM_NID140, SN_NODEID_48, 0, 11)
REG32(SYS_CACHE_GRP_SN_NODEID_REG13_U_RNFBESAM_NID140, 0x1169030)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG13_U_RNFBESAM_NID140, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG13_U_RNFBESAM_NID140, SN_NODEID_55, 36, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG13_U_RNFBESAM_NID140, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG13_U_RNFBESAM_NID140, SN_NODEID_54, 24, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG13_U_RNFBESAM_NID140, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG13_U_RNFBESAM_NID140, SN_NODEID_53, 12, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG13_U_RNFBESAM_NID140, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG13_U_RNFBESAM_NID140, SN_NODEID_52, 0, 11)
REG32(SYS_CACHE_GRP_SN_NODEID_REG14_U_RNFBESAM_NID140, 0x1169038)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG14_U_RNFBESAM_NID140, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG14_U_RNFBESAM_NID140, SN_NODEID_59, 36, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG14_U_RNFBESAM_NID140, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG14_U_RNFBESAM_NID140, SN_NODEID_58, 24, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG14_U_RNFBESAM_NID140, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG14_U_RNFBESAM_NID140, SN_NODEID_57, 12, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG14_U_RNFBESAM_NID140, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG14_U_RNFBESAM_NID140, SN_NODEID_56, 0, 11)
REG32(SYS_CACHE_GRP_SN_NODEID_REG15_U_RNFBESAM_NID140, 0x1169040)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG15_U_RNFBESAM_NID140, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG15_U_RNFBESAM_NID140, SN_NODEID_63, 36, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG15_U_RNFBESAM_NID140, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG15_U_RNFBESAM_NID140, SN_NODEID_62, 24, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG15_U_RNFBESAM_NID140, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG15_U_RNFBESAM_NID140, SN_NODEID_61, 12, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG15_U_RNFBESAM_NID140, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG15_U_RNFBESAM_NID140, SN_NODEID_60, 0, 11)
REG32(POR_SBSX_NODE_INFO_U_SBSX_NID192, 0x1800000)
    FIELD(POR_SBSX_NODE_INFO_U_SBSX_NID192, RESERVED_48, 48, 16)
    FIELD(POR_SBSX_NODE_INFO_U_SBSX_NID192, LOGICAL_ID, 32, 16)
    FIELD(POR_SBSX_NODE_INFO_U_SBSX_NID192, NODE_ID, 16, 16)
    FIELD(POR_SBSX_NODE_INFO_U_SBSX_NID192, NODE_TYPE, 0, 16)
REG32(POR_SBSX_CHILD_INFO_U_SBSX_NID192, 0x1800080)
    FIELD(POR_SBSX_CHILD_INFO_U_SBSX_NID192, RESERVED_32, 32, 32)
    FIELD(POR_SBSX_CHILD_INFO_U_SBSX_NID192, CHILD_PTR_OFFSET, 16, 16)
    FIELD(POR_SBSX_CHILD_INFO_U_SBSX_NID192, CHILD_COUNT, 0, 16)
REG32(POR_SBSX_UNIT_INFO_U_SBSX_NID192, 0x1800900)
    FIELD(POR_SBSX_UNIT_INFO_U_SBSX_NID192, RESERVED_22, 22, 42)
    FIELD(POR_SBSX_UNIT_INFO_U_SBSX_NID192, ACEL_SAFE_XFACE_DISABLE, 21, 1)
    FIELD(POR_SBSX_UNIT_INFO_U_SBSX_NID192, NUM_WR_DATA_BUF, 16, 5)
    FIELD(POR_SBSX_UNIT_INFO_U_SBSX_NID192, NUM_OUTSTANDING_READS, 8, 8)
    FIELD(POR_SBSX_UNIT_INFO_U_SBSX_NID192, AXDATA_POISON_EN, 4, 1)
    FIELD(POR_SBSX_UNIT_INFO_U_SBSX_NID192, AXDATA_WIDTH, 0, 1)
REG32(POR_SBSX_AUX_CTL_U_SBSX_NID192, 0x1800a08)
    FIELD(POR_SBSX_AUX_CTL_U_SBSX_NID192, CLKGATE_DISABLE, 0, 1)
REG32(POR_SBSX_PMU_EVENT_SEL_U_SBSX_NID192, 0x1802000)
    FIELD(POR_SBSX_PMU_EVENT_SEL_U_SBSX_NID192, RESERVED_30, 30, 34)
    FIELD(POR_SBSX_PMU_EVENT_SEL_U_SBSX_NID192, PMU_EVENT3_ID, 24, 6)
    FIELD(POR_SBSX_PMU_EVENT_SEL_U_SBSX_NID192, RESERVED_22, 22, 2)
    FIELD(POR_SBSX_PMU_EVENT_SEL_U_SBSX_NID192, PMU_EVENT2_ID, 16, 6)
    FIELD(POR_SBSX_PMU_EVENT_SEL_U_SBSX_NID192, RESERVED_14, 14, 2)
    FIELD(POR_SBSX_PMU_EVENT_SEL_U_SBSX_NID192, PMU_EVENT1_ID, 8, 6)
    FIELD(POR_SBSX_PMU_EVENT_SEL_U_SBSX_NID192, PMU_EVENT0_ID, 0, 6)
REG32(POR_SBSX_ERRFR_U_SBSX_NID192, 0x1803000)
    FIELD(POR_SBSX_ERRFR_U_SBSX_NID192, RESERVED_15, 15, 49)
    FIELD(POR_SBSX_ERRFR_U_SBSX_NID192, CEC, 12, 3)
    FIELD(POR_SBSX_ERRFR_U_SBSX_NID192, CFI, 10, 2)
    FIELD(POR_SBSX_ERRFR_U_SBSX_NID192, FI, 6, 2)
    FIELD(POR_SBSX_ERRFR_U_SBSX_NID192, UI, 4, 2)
    FIELD(POR_SBSX_ERRFR_U_SBSX_NID192, DE, 2, 2)
    FIELD(POR_SBSX_ERRFR_U_SBSX_NID192, ED, 0, 2)
REG32(POR_SBSX_ERRCTLR_U_SBSX_NID192, 0x1803008)
    FIELD(POR_SBSX_ERRCTLR_U_SBSX_NID192, RESERVED_9, 9, 55)
    FIELD(POR_SBSX_ERRCTLR_U_SBSX_NID192, CFI, 8, 1)
    FIELD(POR_SBSX_ERRCTLR_U_SBSX_NID192, FI, 3, 1)
    FIELD(POR_SBSX_ERRCTLR_U_SBSX_NID192, UI, 2, 1)
    FIELD(POR_SBSX_ERRCTLR_U_SBSX_NID192, DE, 1, 1)
    FIELD(POR_SBSX_ERRCTLR_U_SBSX_NID192, ED, 0, 1)
REG32(POR_SBSX_ERRSTATUS_U_SBSX_NID192, 0x1803010)
    FIELD(POR_SBSX_ERRSTATUS_U_SBSX_NID192, RESERVED_32, 32, 32)
    FIELD(POR_SBSX_ERRSTATUS_U_SBSX_NID192, AV, 31, 1)
    FIELD(POR_SBSX_ERRSTATUS_U_SBSX_NID192, V, 30, 1)
    FIELD(POR_SBSX_ERRSTATUS_U_SBSX_NID192, UE, 29, 1)
    FIELD(POR_SBSX_ERRSTATUS_U_SBSX_NID192, RESERVED_28, 28, 1)
    FIELD(POR_SBSX_ERRSTATUS_U_SBSX_NID192, OF, 27, 1)
    FIELD(POR_SBSX_ERRSTATUS_U_SBSX_NID192, MV, 26, 1)
    FIELD(POR_SBSX_ERRSTATUS_U_SBSX_NID192, RESERVED_25, 25, 1)
    FIELD(POR_SBSX_ERRSTATUS_U_SBSX_NID192, CE, 24, 1)
    FIELD(POR_SBSX_ERRSTATUS_U_SBSX_NID192, DE, 23, 1)
    FIELD(POR_SBSX_ERRSTATUS_U_SBSX_NID192, RESERVED_0, 0, 23)
REG32(POR_SBSX_ERRADDR_U_SBSX_NID192, 0x1803018)
    FIELD(POR_SBSX_ERRADDR_U_SBSX_NID192, NS, 63, 1)
    FIELD(POR_SBSX_ERRADDR_U_SBSX_NID192, RESERVED_48, 48, 15)
    FIELD(POR_SBSX_ERRADDR_U_SBSX_NID192, ADDR, 0, 48)
REG32(POR_SBSX_ERRMISC_U_SBSX_NID192, 0x1803020)
    FIELD(POR_SBSX_ERRMISC_U_SBSX_NID192, RESERVED_31, 31, 33)
    FIELD(POR_SBSX_ERRMISC_U_SBSX_NID192, SIZE, 28, 3)
    FIELD(POR_SBSX_ERRMISC_U_SBSX_NID192, MEMATTR, 24, 4)
    FIELD(POR_SBSX_ERRMISC_U_SBSX_NID192, RESERVED_17, 17, 7)
    FIELD(POR_SBSX_ERRMISC_U_SBSX_NID192, OPTYPE, 16, 1)
    FIELD(POR_SBSX_ERRMISC_U_SBSX_NID192, RESERVED_15, 15, 1)
    FIELD(POR_SBSX_ERRMISC_U_SBSX_NID192, SRCID, 4, 11)
    FIELD(POR_SBSX_ERRMISC_U_SBSX_NID192, RESERVED_0, 0, 4)
REG32(POR_SBSX_ERRFR_NS_U_SBSX_NID192, 0x1803100)
    FIELD(POR_SBSX_ERRFR_NS_U_SBSX_NID192, RESERVED_15, 15, 49)
    FIELD(POR_SBSX_ERRFR_NS_U_SBSX_NID192, CEC, 12, 3)
    FIELD(POR_SBSX_ERRFR_NS_U_SBSX_NID192, CFI, 10, 2)
    FIELD(POR_SBSX_ERRFR_NS_U_SBSX_NID192, FI, 6, 2)
    FIELD(POR_SBSX_ERRFR_NS_U_SBSX_NID192, UI, 4, 2)
    FIELD(POR_SBSX_ERRFR_NS_U_SBSX_NID192, DE, 2, 2)
    FIELD(POR_SBSX_ERRFR_NS_U_SBSX_NID192, ED, 0, 2)
REG32(POR_SBSX_ERRCTLR_NS_U_SBSX_NID192, 0x1803108)
    FIELD(POR_SBSX_ERRCTLR_NS_U_SBSX_NID192, RESERVED_9, 9, 55)
    FIELD(POR_SBSX_ERRCTLR_NS_U_SBSX_NID192, CFI, 8, 1)
    FIELD(POR_SBSX_ERRCTLR_NS_U_SBSX_NID192, FI, 3, 1)
    FIELD(POR_SBSX_ERRCTLR_NS_U_SBSX_NID192, UI, 2, 1)
    FIELD(POR_SBSX_ERRCTLR_NS_U_SBSX_NID192, DE, 1, 1)
    FIELD(POR_SBSX_ERRCTLR_NS_U_SBSX_NID192, ED, 0, 1)
REG32(POR_SBSX_ERRSTATUS_NS_U_SBSX_NID192, 0x1803110)
    FIELD(POR_SBSX_ERRSTATUS_NS_U_SBSX_NID192, RESERVED_32, 32, 32)
    FIELD(POR_SBSX_ERRSTATUS_NS_U_SBSX_NID192, AV, 31, 1)
    FIELD(POR_SBSX_ERRSTATUS_NS_U_SBSX_NID192, V, 30, 1)
    FIELD(POR_SBSX_ERRSTATUS_NS_U_SBSX_NID192, UE, 29, 1)
    FIELD(POR_SBSX_ERRSTATUS_NS_U_SBSX_NID192, RESERVED_28, 28, 1)
    FIELD(POR_SBSX_ERRSTATUS_NS_U_SBSX_NID192, OF, 27, 1)
    FIELD(POR_SBSX_ERRSTATUS_NS_U_SBSX_NID192, MV, 26, 1)
    FIELD(POR_SBSX_ERRSTATUS_NS_U_SBSX_NID192, RESERVED_25, 25, 1)
    FIELD(POR_SBSX_ERRSTATUS_NS_U_SBSX_NID192, CE, 24, 1)
    FIELD(POR_SBSX_ERRSTATUS_NS_U_SBSX_NID192, DE, 23, 1)
    FIELD(POR_SBSX_ERRSTATUS_NS_U_SBSX_NID192, RESERVED_0, 0, 23)
REG32(POR_SBSX_ERRADDR_NS_U_SBSX_NID192, 0x1803118)
    FIELD(POR_SBSX_ERRADDR_NS_U_SBSX_NID192, NS, 63, 1)
    FIELD(POR_SBSX_ERRADDR_NS_U_SBSX_NID192, RESERVED_48, 48, 15)
    FIELD(POR_SBSX_ERRADDR_NS_U_SBSX_NID192, ADDR, 0, 48)
REG32(POR_SBSX_ERRMISC_NS_U_SBSX_NID192, 0x1803120)
    FIELD(POR_SBSX_ERRMISC_NS_U_SBSX_NID192, RESERVED_31, 31, 33)
    FIELD(POR_SBSX_ERRMISC_NS_U_SBSX_NID192, SIZE, 28, 3)
    FIELD(POR_SBSX_ERRMISC_NS_U_SBSX_NID192, MEMATTR, 24, 4)
    FIELD(POR_SBSX_ERRMISC_NS_U_SBSX_NID192, RESERVED_17, 17, 7)
    FIELD(POR_SBSX_ERRMISC_NS_U_SBSX_NID192, OPTYPE, 16, 1)
    FIELD(POR_SBSX_ERRMISC_NS_U_SBSX_NID192, RESERVED_15, 15, 1)
    FIELD(POR_SBSX_ERRMISC_NS_U_SBSX_NID192, SRCID, 4, 11)
    FIELD(POR_SBSX_ERRMISC_NS_U_SBSX_NID192, RESERVED_0, 0, 4)
REG32(POR_MXP_NODE_INFO_U_SMXP_3_0, 0x1808000)
    FIELD(POR_MXP_NODE_INFO_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MXP_NODE_INFO_U_SMXP_3_0, LOGICAL_ID, 32, 16)
    FIELD(POR_MXP_NODE_INFO_U_SMXP_3_0, XY_ID, 16, 16)
    FIELD(POR_MXP_NODE_INFO_U_SMXP_3_0, NODE_TYPE, 0, 16)
REG32(POR_MXP_DEVICE_PORT_CONNECT_INFO_P0_U_SMXP_3_0, 0x1808008)
    FIELD(POR_MXP_DEVICE_PORT_CONNECT_INFO_P0_U_SMXP_3_0, RESERVED_32, 32, 32)
    FIELD(POR_MXP_DEVICE_PORT_CONNECT_INFO_P0_U_SMXP_3_0, NUM_DCS_P0_D3, 28, 4)
    FIELD(POR_MXP_DEVICE_PORT_CONNECT_INFO_P0_U_SMXP_3_0, NUM_DCS_P0_D2, 24, 4)
    FIELD(POR_MXP_DEVICE_PORT_CONNECT_INFO_P0_U_SMXP_3_0, NUM_DCS_P0_D1, 20, 4)
    FIELD(POR_MXP_DEVICE_PORT_CONNECT_INFO_P0_U_SMXP_3_0, NUM_DCS_P0_D0, 16, 4)
    FIELD(POR_MXP_DEVICE_PORT_CONNECT_INFO_P0_U_SMXP_3_0, DEVICE_TYPE_P0, 0, 5)
REG32(POR_MXP_DEVICE_PORT_CONNECT_INFO_P1_U_SMXP_3_0, 0x1808010)
    FIELD(POR_MXP_DEVICE_PORT_CONNECT_INFO_P1_U_SMXP_3_0, RESERVED_32, 32, 32)
    FIELD(POR_MXP_DEVICE_PORT_CONNECT_INFO_P1_U_SMXP_3_0, NUM_DCS_P1_D3, 28, 4)
    FIELD(POR_MXP_DEVICE_PORT_CONNECT_INFO_P1_U_SMXP_3_0, NUM_DCS_P1_D2, 24, 4)
    FIELD(POR_MXP_DEVICE_PORT_CONNECT_INFO_P1_U_SMXP_3_0, NUM_DCS_P1_D1, 20, 4)
    FIELD(POR_MXP_DEVICE_PORT_CONNECT_INFO_P1_U_SMXP_3_0, NUM_DCS_P1_D0, 16, 4)
    FIELD(POR_MXP_DEVICE_PORT_CONNECT_INFO_P1_U_SMXP_3_0, DEVICE_TYPE_P1, 0, 5)
REG32(POR_MXP_MESH_PORT_CONNECT_INFO_EAST_U_SMXP_3_0, 0x1808018)
    FIELD(POR_MXP_MESH_PORT_CONNECT_INFO_EAST_U_SMXP_3_0, NUM_MCS_EAST, 0, 4)
REG32(POR_MXP_MESH_PORT_CONNECT_INFO_NORTH_U_SMXP_3_0, 0x1808020)
    FIELD(POR_MXP_MESH_PORT_CONNECT_INFO_NORTH_U_SMXP_3_0, NUM_MCS_NORTH, 0, 4)
REG32(POR_MXP_CHILD_INFO_U_SMXP_3_0, 0x1808080)
    FIELD(POR_MXP_CHILD_INFO_U_SMXP_3_0, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_INFO_U_SMXP_3_0, CHILD_PTR_OFFSET, 16, 16)
    FIELD(POR_MXP_CHILD_INFO_U_SMXP_3_0, CHILD_COUNT, 0, 16)
REG32(POR_MXP_CHILD_POINTER_0_U_SMXP_3_0, 0x1808100)
    FIELD(POR_MXP_CHILD_POINTER_0_U_SMXP_3_0, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_POINTER_0_U_SMXP_3_0, RELATIVE_ADDRESS_0, 0, 32)
REG32(POR_MXP_CHILD_POINTER_1_U_SMXP_3_0, 0x1808108)
    FIELD(POR_MXP_CHILD_POINTER_1_U_SMXP_3_0, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_POINTER_1_U_SMXP_3_0, RELATIVE_ADDRESS_1, 0, 32)
REG32(POR_MXP_CHILD_POINTER_2_U_SMXP_3_0, 0x1808110)
    FIELD(POR_MXP_CHILD_POINTER_2_U_SMXP_3_0, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_POINTER_2_U_SMXP_3_0, RELATIVE_ADDRESS_2, 0, 32)
REG32(POR_MXP_CHILD_POINTER_3_U_SMXP_3_0, 0x1808118)
    FIELD(POR_MXP_CHILD_POINTER_3_U_SMXP_3_0, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_POINTER_3_U_SMXP_3_0, RELATIVE_ADDRESS_3, 0, 32)
REG32(POR_MXP_CHILD_POINTER_4_U_SMXP_3_0, 0x1808120)
    FIELD(POR_MXP_CHILD_POINTER_4_U_SMXP_3_0, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_POINTER_4_U_SMXP_3_0, RELATIVE_ADDRESS_4, 0, 32)
REG32(POR_MXP_CHILD_POINTER_5_U_SMXP_3_0, 0x1808128)
    FIELD(POR_MXP_CHILD_POINTER_5_U_SMXP_3_0, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_POINTER_5_U_SMXP_3_0, RELATIVE_ADDRESS_5, 0, 32)
REG32(POR_MXP_CHILD_POINTER_6_U_SMXP_3_0, 0x1808130)
    FIELD(POR_MXP_CHILD_POINTER_6_U_SMXP_3_0, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_POINTER_6_U_SMXP_3_0, RELATIVE_ADDRESS_6, 0, 32)
REG32(POR_MXP_CHILD_POINTER_7_U_SMXP_3_0, 0x1808138)
    FIELD(POR_MXP_CHILD_POINTER_7_U_SMXP_3_0, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_POINTER_7_U_SMXP_3_0, RELATIVE_ADDRESS_7, 0, 32)
REG32(POR_MXP_CHILD_POINTER_8_U_SMXP_3_0, 0x1808140)
    FIELD(POR_MXP_CHILD_POINTER_8_U_SMXP_3_0, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_POINTER_8_U_SMXP_3_0, RELATIVE_ADDRESS_8, 0, 32)
REG32(POR_MXP_CHILD_POINTER_9_U_SMXP_3_0, 0x1808148)
    FIELD(POR_MXP_CHILD_POINTER_9_U_SMXP_3_0, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_POINTER_9_U_SMXP_3_0, RELATIVE_ADDRESS_9, 0, 32)
REG32(POR_MXP_CHILD_POINTER_10_U_SMXP_3_0, 0x1808150)
    FIELD(POR_MXP_CHILD_POINTER_10_U_SMXP_3_0, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_POINTER_10_U_SMXP_3_0, RELATIVE_ADDRESS_10, 0, 32)
REG32(POR_MXP_CHILD_POINTER_11_U_SMXP_3_0, 0x1808158)
    FIELD(POR_MXP_CHILD_POINTER_11_U_SMXP_3_0, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_POINTER_11_U_SMXP_3_0, RELATIVE_ADDRESS_11, 0, 32)
REG32(POR_MXP_CHILD_POINTER_12_U_SMXP_3_0, 0x1808160)
    FIELD(POR_MXP_CHILD_POINTER_12_U_SMXP_3_0, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_POINTER_12_U_SMXP_3_0, RELATIVE_ADDRESS_12, 0, 32)
REG32(POR_MXP_CHILD_POINTER_13_U_SMXP_3_0, 0x1808168)
    FIELD(POR_MXP_CHILD_POINTER_13_U_SMXP_3_0, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_POINTER_13_U_SMXP_3_0, RELATIVE_ADDRESS_13, 0, 32)
REG32(POR_MXP_CHILD_POINTER_14_U_SMXP_3_0, 0x1808170)
    FIELD(POR_MXP_CHILD_POINTER_14_U_SMXP_3_0, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_POINTER_14_U_SMXP_3_0, RELATIVE_ADDRESS_14, 0, 32)
REG32(POR_MXP_CHILD_POINTER_15_U_SMXP_3_0, 0x1808178)
    FIELD(POR_MXP_CHILD_POINTER_15_U_SMXP_3_0, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_POINTER_15_U_SMXP_3_0, RELATIVE_ADDRESS_15, 0, 32)
REG32(POR_MXP_P0_INFO_U_SMXP_3_0, 0x1808900)
    FIELD(POR_MXP_P0_INFO_U_SMXP_3_0, RESERVED_26, 26, 38)
    FIELD(POR_MXP_P0_INFO_U_SMXP_3_0, A4S_SAFE_XFACE_DISABLE_P0, 25, 1)
    FIELD(POR_MXP_P0_INFO_U_SMXP_3_0, CHI_SAFE_XFACE_DISABLE_P0, 24, 1)
    FIELD(POR_MXP_P0_INFO_U_SMXP_3_0, A4S_LOGICALID_BASE_P0, 16, 8)
    FIELD(POR_MXP_P0_INFO_U_SMXP_3_0, RESERVED_14, 14, 2)
    FIELD(POR_MXP_P0_INFO_U_SMXP_3_0, A4S_NUM_P0, 11, 3)
    FIELD(POR_MXP_P0_INFO_U_SMXP_3_0, RXBUF_NUM_ENTRIES_P0, 8, 3)
    FIELD(POR_MXP_P0_INFO_U_SMXP_3_0, EXT_SAM_EN_P0, 7, 1)
    FIELD(POR_MXP_P0_INFO_U_SMXP_3_0, DATACHECK_EN_P0, 5, 1)
    FIELD(POR_MXP_P0_INFO_U_SMXP_3_0, POISON_EN_P0, 4, 1)
    FIELD(POR_MXP_P0_INFO_U_SMXP_3_0, NUM_DEV_P0, 0, 3)
REG32(POR_MXP_P1_INFO_U_SMXP_3_0, 0x1808908)
    FIELD(POR_MXP_P1_INFO_U_SMXP_3_0, RESERVED_26, 26, 38)
    FIELD(POR_MXP_P1_INFO_U_SMXP_3_0, A4S_SAFE_XFACE_DISABLE_P1, 25, 1)
    FIELD(POR_MXP_P1_INFO_U_SMXP_3_0, CHI_SAFE_XFACE_DISABLE_P1, 24, 1)
    FIELD(POR_MXP_P1_INFO_U_SMXP_3_0, A4S_LOGICALID_BASE_P1, 16, 8)
    FIELD(POR_MXP_P1_INFO_U_SMXP_3_0, RESERVED_14, 14, 2)
    FIELD(POR_MXP_P1_INFO_U_SMXP_3_0, A4S_NUM_P1, 11, 3)
    FIELD(POR_MXP_P1_INFO_U_SMXP_3_0, RXBUF_NUM_ENTRIES_P1, 8, 3)
    FIELD(POR_MXP_P1_INFO_U_SMXP_3_0, EXT_SAM_EN_P1, 7, 1)
    FIELD(POR_MXP_P1_INFO_U_SMXP_3_0, DATACHECK_EN_P1, 5, 1)
    FIELD(POR_MXP_P1_INFO_U_SMXP_3_0, POISON_EN_P1, 4, 1)
    FIELD(POR_MXP_P1_INFO_U_SMXP_3_0, NUM_DEV_P1, 0, 3)
REG32(POR_MXP_SECURE_REGISTER_GROUPS_OVERRIDE_U_SMXP_3_0, 0x1808980)
    FIELD(POR_MXP_SECURE_REGISTER_GROUPS_OVERRIDE_U_SMXP_3_0, SYSCOREQ_CTL, 1, 1)
    FIELD(POR_MXP_SECURE_REGISTER_GROUPS_OVERRIDE_U_SMXP_3_0, QOS, 0, 1)
REG32(POR_MXP_AUX_CTL_U_SMXP_3_0, 0x1808a00)
    FIELD(POR_MXP_AUX_CTL_U_SMXP_3_0, CLKGATE_DISABLE, 0, 1)
REG32(POR_MXP_P0_QOS_CONTROL_U_SMXP_3_0, 0x1808a80)
    FIELD(POR_MXP_P0_QOS_CONTROL_U_SMXP_3_0, RESERVED_20, 20, 44)
    FIELD(POR_MXP_P0_QOS_CONTROL_U_SMXP_3_0, P0_QOS_OVERRIDE, 16, 4)
    FIELD(POR_MXP_P0_QOS_CONTROL_U_SMXP_3_0, P0_PQV_MODE, 6, 1)
    FIELD(POR_MXP_P0_QOS_CONTROL_U_SMXP_3_0, P0_REG_MODE, 4, 1)
    FIELD(POR_MXP_P0_QOS_CONTROL_U_SMXP_3_0, P0_QOS_OVERRIDE_EN, 2, 1)
    FIELD(POR_MXP_P0_QOS_CONTROL_U_SMXP_3_0, P0_LAT_EN, 0, 1)
REG32(POR_MXP_P0_QOS_LAT_TGT_U_SMXP_3_0, 0x1808a88)
    FIELD(POR_MXP_P0_QOS_LAT_TGT_U_SMXP_3_0, RESERVED_12, 12, 52)
    FIELD(POR_MXP_P0_QOS_LAT_TGT_U_SMXP_3_0, P0_LAT_TGT, 0, 12)
REG32(POR_MXP_P0_QOS_LAT_SCALE_U_SMXP_3_0, 0x1808a90)
    FIELD(POR_MXP_P0_QOS_LAT_SCALE_U_SMXP_3_0, P0_LAT_SCALE, 0, 3)
REG32(POR_MXP_P0_QOS_LAT_RANGE_U_SMXP_3_0, 0x1808a98)
    FIELD(POR_MXP_P0_QOS_LAT_RANGE_U_SMXP_3_0, RESERVED_12, 12, 52)
    FIELD(POR_MXP_P0_QOS_LAT_RANGE_U_SMXP_3_0, P0_LAT_MAX_QOS, 8, 4)
    FIELD(POR_MXP_P0_QOS_LAT_RANGE_U_SMXP_3_0, P0_LAT_MIN_QOS, 0, 4)
REG32(POR_MXP_P1_QOS_CONTROL_U_SMXP_3_0, 0x1808aa0)
    FIELD(POR_MXP_P1_QOS_CONTROL_U_SMXP_3_0, RESERVED_20, 20, 44)
    FIELD(POR_MXP_P1_QOS_CONTROL_U_SMXP_3_0, P1_QOS_OVERRIDE, 16, 4)
    FIELD(POR_MXP_P1_QOS_CONTROL_U_SMXP_3_0, P1_PQV_MODE, 6, 1)
    FIELD(POR_MXP_P1_QOS_CONTROL_U_SMXP_3_0, P1_REG_MODE, 4, 1)
    FIELD(POR_MXP_P1_QOS_CONTROL_U_SMXP_3_0, P1_QOS_OVERRIDE_EN, 2, 1)
    FIELD(POR_MXP_P1_QOS_CONTROL_U_SMXP_3_0, P1_LAT_EN, 0, 1)
REG32(POR_MXP_P1_QOS_LAT_TGT_U_SMXP_3_0, 0x1808aa8)
    FIELD(POR_MXP_P1_QOS_LAT_TGT_U_SMXP_3_0, RESERVED_12, 12, 52)
    FIELD(POR_MXP_P1_QOS_LAT_TGT_U_SMXP_3_0, P1_LAT_TGT, 0, 12)
REG32(POR_MXP_P1_QOS_LAT_SCALE_U_SMXP_3_0, 0x1808ab0)
    FIELD(POR_MXP_P1_QOS_LAT_SCALE_U_SMXP_3_0, P1_LAT_SCALE, 0, 3)
REG32(POR_MXP_P1_QOS_LAT_RANGE_U_SMXP_3_0, 0x1808ab8)
    FIELD(POR_MXP_P1_QOS_LAT_RANGE_U_SMXP_3_0, RESERVED_12, 12, 52)
    FIELD(POR_MXP_P1_QOS_LAT_RANGE_U_SMXP_3_0, P1_LAT_MAX_QOS, 8, 4)
    FIELD(POR_MXP_P1_QOS_LAT_RANGE_U_SMXP_3_0, P1_LAT_MIN_QOS, 0, 4)
REG32(POR_MXP_P0_SYSCOREQ_CTL_U_SMXP_3_0, 0x1809000)
    FIELD(POR_MXP_P0_SYSCOREQ_CTL_U_SMXP_3_0, SNPDVM_REQ_P0_D3, 3, 1)
    FIELD(POR_MXP_P0_SYSCOREQ_CTL_U_SMXP_3_0, SNPDVM_REQ_P0_D2, 2, 1)
    FIELD(POR_MXP_P0_SYSCOREQ_CTL_U_SMXP_3_0, SNPDVM_REQ_P0_D1, 1, 1)
    FIELD(POR_MXP_P0_SYSCOREQ_CTL_U_SMXP_3_0, SNPDVM_REQ_P0_D0, 0, 1)
REG32(POR_MXP_P1_SYSCOREQ_CTL_U_SMXP_3_0, 0x1809008)
    FIELD(POR_MXP_P1_SYSCOREQ_CTL_U_SMXP_3_0, SNPDVM_REQ_P1_D3, 3, 1)
    FIELD(POR_MXP_P1_SYSCOREQ_CTL_U_SMXP_3_0, SNPDVM_REQ_P1_D2, 2, 1)
    FIELD(POR_MXP_P1_SYSCOREQ_CTL_U_SMXP_3_0, SNPDVM_REQ_P1_D1, 1, 1)
    FIELD(POR_MXP_P1_SYSCOREQ_CTL_U_SMXP_3_0, SNPDVM_REQ_P1_D0, 0, 1)
REG32(POR_MXP_P0_SYSCOACK_STATUS_U_SMXP_3_0, 0x1809010)
    FIELD(POR_MXP_P0_SYSCOACK_STATUS_U_SMXP_3_0, SNPDVM_ACK_P0_D3, 3, 1)
    FIELD(POR_MXP_P0_SYSCOACK_STATUS_U_SMXP_3_0, SNPDVM_ACK_P0_D2, 2, 1)
    FIELD(POR_MXP_P0_SYSCOACK_STATUS_U_SMXP_3_0, SNPDVM_ACK_P0_D1, 1, 1)
    FIELD(POR_MXP_P0_SYSCOACK_STATUS_U_SMXP_3_0, SNPDVM_ACK_P0_D0, 0, 1)
REG32(POR_MXP_P1_SYSCOACK_STATUS_U_SMXP_3_0, 0x1809018)
    FIELD(POR_MXP_P1_SYSCOACK_STATUS_U_SMXP_3_0, SNPDVM_ACK_P1_D3, 3, 1)
    FIELD(POR_MXP_P1_SYSCOACK_STATUS_U_SMXP_3_0, SNPDVM_ACK_P1_D2, 2, 1)
    FIELD(POR_MXP_P1_SYSCOACK_STATUS_U_SMXP_3_0, SNPDVM_ACK_P1_D1, 1, 1)
    FIELD(POR_MXP_P1_SYSCOACK_STATUS_U_SMXP_3_0, SNPDVM_ACK_P1_D0, 0, 1)
REG32(POR_MXP_PMU_EVENT_SEL_U_SMXP_3_0, 0x180a000)
    FIELD(POR_MXP_PMU_EVENT_SEL_U_SMXP_3_0, RESERVED_32, 32, 32)
    FIELD(POR_MXP_PMU_EVENT_SEL_U_SMXP_3_0, PMU_EVENT3_ID, 24, 8)
    FIELD(POR_MXP_PMU_EVENT_SEL_U_SMXP_3_0, PMU_EVENT2_ID, 16, 8)
    FIELD(POR_MXP_PMU_EVENT_SEL_U_SMXP_3_0, PMU_EVENT1_ID, 8, 8)
    FIELD(POR_MXP_PMU_EVENT_SEL_U_SMXP_3_0, PMU_EVENT0_ID, 0, 8)
REG32(POR_DTM_CONTROL_U_SMXP_3_0, 0x180a100)
    FIELD(POR_DTM_CONTROL_U_SMXP_3_0, TRACE_NO_ATB, 3, 1)
    FIELD(POR_DTM_CONTROL_U_SMXP_3_0, SAMPLE_PROFILE_ENABLE, 2, 1)
    FIELD(POR_DTM_CONTROL_U_SMXP_3_0, TRACE_TAG_ENABLE, 1, 1)
    FIELD(POR_DTM_CONTROL_U_SMXP_3_0, DTM_ENABLE, 0, 1)
REG32(POR_DTM_FIFO_ENTRY_READY_U_SMXP_3_0, 0x180a118)
    FIELD(POR_DTM_FIFO_ENTRY_READY_U_SMXP_3_0, READY, 0, 4)
REG32(POR_DTM_FIFO_ENTRY0_0_U_SMXP_3_0, 0x180a120)
REG32(POR_DTM_FIFO_ENTRY0_1_U_SMXP_3_0, 0x180a128)
REG32(POR_DTM_FIFO_ENTRY0_2_U_SMXP_3_0, 0x180a130)
    FIELD(POR_DTM_FIFO_ENTRY0_2_U_SMXP_3_0, RESERVED_32, 32, 32)
    FIELD(POR_DTM_FIFO_ENTRY0_2_U_SMXP_3_0, FIFO_CYCLE_COUNT, 16, 16)
    FIELD(POR_DTM_FIFO_ENTRY0_2_U_SMXP_3_0, FIFO_DATA2, 0, 16)
REG32(POR_DTM_FIFO_ENTRY1_0_U_SMXP_3_0, 0x180a138)
REG32(POR_DTM_FIFO_ENTRY1_1_U_SMXP_3_0, 0x180a140)
REG32(POR_DTM_FIFO_ENTRY1_2_U_SMXP_3_0, 0x180a148)
    FIELD(POR_DTM_FIFO_ENTRY1_2_U_SMXP_3_0, RESERVED_32, 32, 32)
    FIELD(POR_DTM_FIFO_ENTRY1_2_U_SMXP_3_0, FIFO_CYCLE_COUNT, 16, 16)
    FIELD(POR_DTM_FIFO_ENTRY1_2_U_SMXP_3_0, FIFO_DATA2, 0, 16)
REG32(POR_DTM_FIFO_ENTRY2_0_U_SMXP_3_0, 0x180a150)
REG32(POR_DTM_FIFO_ENTRY2_1_U_SMXP_3_0, 0x180a158)
REG32(POR_DTM_FIFO_ENTRY2_2_U_SMXP_3_0, 0x180a160)
    FIELD(POR_DTM_FIFO_ENTRY2_2_U_SMXP_3_0, RESERVED_32, 32, 32)
    FIELD(POR_DTM_FIFO_ENTRY2_2_U_SMXP_3_0, FIFO_CYCLE_COUNT, 16, 16)
    FIELD(POR_DTM_FIFO_ENTRY2_2_U_SMXP_3_0, FIFO_DATA2, 0, 16)
REG32(POR_DTM_FIFO_ENTRY3_0_U_SMXP_3_0, 0x180a168)
REG32(POR_DTM_FIFO_ENTRY3_1_U_SMXP_3_0, 0x180a170)
REG32(POR_DTM_FIFO_ENTRY3_2_U_SMXP_3_0, 0x180a178)
    FIELD(POR_DTM_FIFO_ENTRY3_2_U_SMXP_3_0, RESERVED_32, 32, 32)
    FIELD(POR_DTM_FIFO_ENTRY3_2_U_SMXP_3_0, FIFO_CYCLE_COUNT, 16, 16)
    FIELD(POR_DTM_FIFO_ENTRY3_2_U_SMXP_3_0, FIFO_DATA2, 0, 16)
REG32(POR_DTM_WP0_CONFIG_U_SMXP_3_0, 0x180a1a0)
    FIELD(POR_DTM_WP0_CONFIG_U_SMXP_3_0, RESERVED_15, 15, 49)
    FIELD(POR_DTM_WP0_CONFIG_U_SMXP_3_0, WP_DBGTRIG_EN, 14, 1)
    FIELD(POR_DTM_WP0_CONFIG_U_SMXP_3_0, WP_CTRIG_EN, 13, 1)
    FIELD(POR_DTM_WP0_CONFIG_U_SMXP_3_0, WP_CC_EN, 12, 1)
    FIELD(POR_DTM_WP0_CONFIG_U_SMXP_3_0, WP_PKT_TYPE, 9, 3)
    FIELD(POR_DTM_WP0_CONFIG_U_SMXP_3_0, WP_PKT_GEN, 8, 1)
    FIELD(POR_DTM_WP0_CONFIG_U_SMXP_3_0, WP_COMBINE, 6, 1)
    FIELD(POR_DTM_WP0_CONFIG_U_SMXP_3_0, WP_EXCLUSIVE, 5, 1)
    FIELD(POR_DTM_WP0_CONFIG_U_SMXP_3_0, WP_GRP, 4, 1)
    FIELD(POR_DTM_WP0_CONFIG_U_SMXP_3_0, WP_CHN_SEL, 1, 3)
    FIELD(POR_DTM_WP0_CONFIG_U_SMXP_3_0, WP_DEV_SEL, 0, 1)
REG32(POR_DTM_WP0_VAL_U_SMXP_3_0, 0x180a1a8)
REG32(POR_DTM_WP0_MASK_U_SMXP_3_0, 0x180a1b0)
REG32(POR_DTM_WP1_CONFIG_U_SMXP_3_0, 0x180a1b8)
    FIELD(POR_DTM_WP1_CONFIG_U_SMXP_3_0, RESERVED_15, 15, 49)
    FIELD(POR_DTM_WP1_CONFIG_U_SMXP_3_0, WP_DBGTRIG_EN, 14, 1)
    FIELD(POR_DTM_WP1_CONFIG_U_SMXP_3_0, WP_CTRIG_EN, 13, 1)
    FIELD(POR_DTM_WP1_CONFIG_U_SMXP_3_0, WP_CC_EN, 12, 1)
    FIELD(POR_DTM_WP1_CONFIG_U_SMXP_3_0, WP_PKT_TYPE, 9, 3)
    FIELD(POR_DTM_WP1_CONFIG_U_SMXP_3_0, WP_PKT_GEN, 8, 1)
    FIELD(POR_DTM_WP1_CONFIG_U_SMXP_3_0, WP_EXCLUSIVE, 5, 1)
    FIELD(POR_DTM_WP1_CONFIG_U_SMXP_3_0, WP_GRP, 4, 1)
    FIELD(POR_DTM_WP1_CONFIG_U_SMXP_3_0, WP_CHN_SEL, 1, 3)
    FIELD(POR_DTM_WP1_CONFIG_U_SMXP_3_0, WP_DEV_SEL, 0, 1)
REG32(POR_DTM_WP1_VAL_U_SMXP_3_0, 0x180a1c0)
REG32(POR_DTM_WP1_MASK_U_SMXP_3_0, 0x180a1c8)
REG32(POR_DTM_WP2_CONFIG_U_SMXP_3_0, 0x180a1d0)
    FIELD(POR_DTM_WP2_CONFIG_U_SMXP_3_0, RESERVED_15, 15, 49)
    FIELD(POR_DTM_WP2_CONFIG_U_SMXP_3_0, WP_DBGTRIG_EN, 14, 1)
    FIELD(POR_DTM_WP2_CONFIG_U_SMXP_3_0, WP_CTRIG_EN, 13, 1)
    FIELD(POR_DTM_WP2_CONFIG_U_SMXP_3_0, WP_CC_EN, 12, 1)
    FIELD(POR_DTM_WP2_CONFIG_U_SMXP_3_0, WP_PKT_TYPE, 9, 3)
    FIELD(POR_DTM_WP2_CONFIG_U_SMXP_3_0, WP_PKT_GEN, 8, 1)
    FIELD(POR_DTM_WP2_CONFIG_U_SMXP_3_0, WP_COMBINE, 6, 1)
    FIELD(POR_DTM_WP2_CONFIG_U_SMXP_3_0, WP_EXCLUSIVE, 5, 1)
    FIELD(POR_DTM_WP2_CONFIG_U_SMXP_3_0, WP_GRP, 4, 1)
    FIELD(POR_DTM_WP2_CONFIG_U_SMXP_3_0, WP_CHN_SEL, 1, 3)
    FIELD(POR_DTM_WP2_CONFIG_U_SMXP_3_0, WP_DEV_SEL, 0, 1)
REG32(POR_DTM_WP2_VAL_U_SMXP_3_0, 0x180a1d8)
REG32(POR_DTM_WP2_MASK_U_SMXP_3_0, 0x180a1e0)
REG32(POR_DTM_WP3_CONFIG_U_SMXP_3_0, 0x180a1e8)
    FIELD(POR_DTM_WP3_CONFIG_U_SMXP_3_0, RESERVED_15, 15, 49)
    FIELD(POR_DTM_WP3_CONFIG_U_SMXP_3_0, WP_DBGTRIG_EN, 14, 1)
    FIELD(POR_DTM_WP3_CONFIG_U_SMXP_3_0, WP_CTRIG_EN, 13, 1)
    FIELD(POR_DTM_WP3_CONFIG_U_SMXP_3_0, WP_CC_EN, 12, 1)
    FIELD(POR_DTM_WP3_CONFIG_U_SMXP_3_0, WP_PKT_TYPE, 9, 3)
    FIELD(POR_DTM_WP3_CONFIG_U_SMXP_3_0, WP_PKT_GEN, 8, 1)
    FIELD(POR_DTM_WP3_CONFIG_U_SMXP_3_0, WP_EXCLUSIVE, 5, 1)
    FIELD(POR_DTM_WP3_CONFIG_U_SMXP_3_0, WP_GRP, 4, 1)
    FIELD(POR_DTM_WP3_CONFIG_U_SMXP_3_0, WP_CHN_SEL, 1, 3)
    FIELD(POR_DTM_WP3_CONFIG_U_SMXP_3_0, WP_DEV_SEL, 0, 1)
REG32(POR_DTM_WP3_VAL_U_SMXP_3_0, 0x180a1f0)
REG32(POR_DTM_WP3_MASK_U_SMXP_3_0, 0x180a1f8)
REG32(POR_DTM_PMSICR_U_SMXP_3_0, 0x180a200)
    FIELD(POR_DTM_PMSICR_U_SMXP_3_0, RESERVED_32, 32, 32)
    FIELD(POR_DTM_PMSICR_U_SMXP_3_0, COUNT, 0, 32)
REG32(POR_DTM_PMSIRR_U_SMXP_3_0, 0x180a208)
    FIELD(POR_DTM_PMSIRR_U_SMXP_3_0, RESERVED_32, 32, 32)
    FIELD(POR_DTM_PMSIRR_U_SMXP_3_0, INTERVAL, 8, 24)
    FIELD(POR_DTM_PMSIRR_U_SMXP_3_0, RESERVED_0, 0, 8)
REG32(POR_DTM_PMU_CONFIG_U_SMXP_3_0, 0x180a210)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_3_0, RESERVED_62, 62, 2)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_3_0, PMEVCNT3_INPUT_SEL, 56, 6)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_3_0, RESERVED_54, 54, 2)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_3_0, PMEVCNT2_INPUT_SEL, 48, 6)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_3_0, RESERVED_46, 46, 2)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_3_0, PMEVCNT1_INPUT_SEL, 40, 6)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_3_0, RESERVED_38, 38, 2)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_3_0, PMEVCNT0_INPUT_SEL, 32, 6)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_3_0, RESERVED_31, 31, 1)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_3_0, PMEVCNT3_GLOBAL_NUM, 28, 3)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_3_0, RESERVED_27, 27, 1)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_3_0, PMEVCNT2_GLOBAL_NUM, 24, 3)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_3_0, RESERVED_23, 23, 1)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_3_0, PMEVCNT1_GLOBAL_NUM, 20, 3)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_3_0, RESERVED_19, 19, 1)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_3_0, PMEVCNT0_GLOBAL_NUM, 16, 3)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_3_0, RESERVED_9, 9, 7)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_3_0, CNTR_RST, 8, 1)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_3_0, PMEVCNT_PAIRED, 4, 4)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_3_0, PMEVCNTALL_COMBINED, 3, 1)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_3_0, PMEVCNT23_COMBINED, 2, 1)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_3_0, PMEVCNT01_COMBINED, 1, 1)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_3_0, PMU_EN, 0, 1)
REG32(POR_DTM_PMEVCNT_U_SMXP_3_0, 0x180a220)
    FIELD(POR_DTM_PMEVCNT_U_SMXP_3_0, PMEVCNT3, 48, 16)
    FIELD(POR_DTM_PMEVCNT_U_SMXP_3_0, PMEVCNT2, 32, 16)
    FIELD(POR_DTM_PMEVCNT_U_SMXP_3_0, PMEVCNT1, 16, 16)
    FIELD(POR_DTM_PMEVCNT_U_SMXP_3_0, PMEVCNT0, 0, 16)
REG32(POR_DTM_PMEVCNTSR_U_SMXP_3_0, 0x180a240)
    FIELD(POR_DTM_PMEVCNTSR_U_SMXP_3_0, PMEVCNTSR3, 48, 16)
    FIELD(POR_DTM_PMEVCNTSR_U_SMXP_3_0, PMEVCNTSR2, 32, 16)
    FIELD(POR_DTM_PMEVCNTSR_U_SMXP_3_0, PMEVCNTSR1, 16, 16)
    FIELD(POR_DTM_PMEVCNTSR_U_SMXP_3_0, PMEVCNTSR0, 0, 16)
REG32(POR_MXP_ERRFR_U_SMXP_3_0, 0x180b000)
    FIELD(POR_MXP_ERRFR_U_SMXP_3_0, RESERVED_15, 15, 49)
    FIELD(POR_MXP_ERRFR_U_SMXP_3_0, CEC, 12, 3)
    FIELD(POR_MXP_ERRFR_U_SMXP_3_0, CFI, 10, 2)
    FIELD(POR_MXP_ERRFR_U_SMXP_3_0, FI, 6, 2)
    FIELD(POR_MXP_ERRFR_U_SMXP_3_0, UI, 4, 2)
    FIELD(POR_MXP_ERRFR_U_SMXP_3_0, DE, 2, 2)
    FIELD(POR_MXP_ERRFR_U_SMXP_3_0, ED, 0, 2)
REG32(POR_MXP_ERRCTLR_U_SMXP_3_0, 0x180b008)
    FIELD(POR_MXP_ERRCTLR_U_SMXP_3_0, RESERVED_9, 9, 55)
    FIELD(POR_MXP_ERRCTLR_U_SMXP_3_0, CFI, 8, 1)
    FIELD(POR_MXP_ERRCTLR_U_SMXP_3_0, FI, 3, 1)
    FIELD(POR_MXP_ERRCTLR_U_SMXP_3_0, UI, 2, 1)
    FIELD(POR_MXP_ERRCTLR_U_SMXP_3_0, DE, 1, 1)
    FIELD(POR_MXP_ERRCTLR_U_SMXP_3_0, ED, 0, 1)
REG32(POR_MXP_ERRSTATUS_U_SMXP_3_0, 0x180b010)
    FIELD(POR_MXP_ERRSTATUS_U_SMXP_3_0, RESERVED_32, 32, 32)
    FIELD(POR_MXP_ERRSTATUS_U_SMXP_3_0, AV, 31, 1)
    FIELD(POR_MXP_ERRSTATUS_U_SMXP_3_0, V, 30, 1)
    FIELD(POR_MXP_ERRSTATUS_U_SMXP_3_0, UE, 29, 1)
    FIELD(POR_MXP_ERRSTATUS_U_SMXP_3_0, RESERVED_28, 28, 1)
    FIELD(POR_MXP_ERRSTATUS_U_SMXP_3_0, OF, 27, 1)
    FIELD(POR_MXP_ERRSTATUS_U_SMXP_3_0, MV, 26, 1)
    FIELD(POR_MXP_ERRSTATUS_U_SMXP_3_0, RESERVED_25, 25, 1)
    FIELD(POR_MXP_ERRSTATUS_U_SMXP_3_0, CE, 24, 1)
    FIELD(POR_MXP_ERRSTATUS_U_SMXP_3_0, DE, 23, 1)
    FIELD(POR_MXP_ERRSTATUS_U_SMXP_3_0, RESERVED_0, 0, 23)
REG32(POR_MXP_ERRMISC_U_SMXP_3_0, 0x180b028)
    FIELD(POR_MXP_ERRMISC_U_SMXP_3_0, RESERVED_59, 59, 5)
    FIELD(POR_MXP_ERRMISC_U_SMXP_3_0, TGTID, 48, 11)
    FIELD(POR_MXP_ERRMISC_U_SMXP_3_0, RESERVED_22, 22, 26)
    FIELD(POR_MXP_ERRMISC_U_SMXP_3_0, OPCODE, 16, 6)
    FIELD(POR_MXP_ERRMISC_U_SMXP_3_0, RESERVED_15, 15, 1)
    FIELD(POR_MXP_ERRMISC_U_SMXP_3_0, SRCID, 4, 11)
    FIELD(POR_MXP_ERRMISC_U_SMXP_3_0, ERRSRC, 0, 3)
REG32(POR_MXP_P0_BYTE_PAR_ERR_INJ_U_SMXP_3_0, 0x180b030)
    FIELD(POR_MXP_P0_BYTE_PAR_ERR_INJ_U_SMXP_3_0, P0_BYTE_PARITY_ERR_INJ, 0, 5)
REG32(POR_MXP_P1_BYTE_PAR_ERR_INJ_U_SMXP_3_0, 0x180b038)
    FIELD(POR_MXP_P1_BYTE_PAR_ERR_INJ_U_SMXP_3_0, P1_BYTE_PARITY_ERR_INJ, 0, 5)
REG32(POR_MXP_ERRFR_NS_U_SMXP_3_0, 0x180b100)
    FIELD(POR_MXP_ERRFR_NS_U_SMXP_3_0, RESERVED_15, 15, 49)
    FIELD(POR_MXP_ERRFR_NS_U_SMXP_3_0, CEC, 12, 3)
    FIELD(POR_MXP_ERRFR_NS_U_SMXP_3_0, CFI, 10, 2)
    FIELD(POR_MXP_ERRFR_NS_U_SMXP_3_0, FI, 6, 2)
    FIELD(POR_MXP_ERRFR_NS_U_SMXP_3_0, UI, 4, 2)
    FIELD(POR_MXP_ERRFR_NS_U_SMXP_3_0, DE, 2, 2)
    FIELD(POR_MXP_ERRFR_NS_U_SMXP_3_0, ED, 0, 2)
REG32(POR_MXP_ERRCTLR_NS_U_SMXP_3_0, 0x180b108)
    FIELD(POR_MXP_ERRCTLR_NS_U_SMXP_3_0, RESERVED_9, 9, 55)
    FIELD(POR_MXP_ERRCTLR_NS_U_SMXP_3_0, CFI, 8, 1)
    FIELD(POR_MXP_ERRCTLR_NS_U_SMXP_3_0, FI, 3, 1)
    FIELD(POR_MXP_ERRCTLR_NS_U_SMXP_3_0, UI, 2, 1)
    FIELD(POR_MXP_ERRCTLR_NS_U_SMXP_3_0, DE, 1, 1)
    FIELD(POR_MXP_ERRCTLR_NS_U_SMXP_3_0, ED, 0, 1)
REG32(POR_MXP_ERRSTATUS_NS_U_SMXP_3_0, 0x180b110)
    FIELD(POR_MXP_ERRSTATUS_NS_U_SMXP_3_0, RESERVED_32, 32, 32)
    FIELD(POR_MXP_ERRSTATUS_NS_U_SMXP_3_0, AV, 31, 1)
    FIELD(POR_MXP_ERRSTATUS_NS_U_SMXP_3_0, V, 30, 1)
    FIELD(POR_MXP_ERRSTATUS_NS_U_SMXP_3_0, UE, 29, 1)
    FIELD(POR_MXP_ERRSTATUS_NS_U_SMXP_3_0, RESERVED_28, 28, 1)
    FIELD(POR_MXP_ERRSTATUS_NS_U_SMXP_3_0, OF, 27, 1)
    FIELD(POR_MXP_ERRSTATUS_NS_U_SMXP_3_0, MV, 26, 1)
    FIELD(POR_MXP_ERRSTATUS_NS_U_SMXP_3_0, RESERVED_25, 25, 1)
    FIELD(POR_MXP_ERRSTATUS_NS_U_SMXP_3_0, CE, 24, 1)
    FIELD(POR_MXP_ERRSTATUS_NS_U_SMXP_3_0, DE, 23, 1)
    FIELD(POR_MXP_ERRSTATUS_NS_U_SMXP_3_0, RESERVED_0, 0, 23)
REG32(POR_MXP_ERRMISC_NS_U_SMXP_3_0, 0x180b128)
    FIELD(POR_MXP_ERRMISC_NS_U_SMXP_3_0, RESERVED_59, 59, 5)
    FIELD(POR_MXP_ERRMISC_NS_U_SMXP_3_0, TGTID, 48, 11)
    FIELD(POR_MXP_ERRMISC_NS_U_SMXP_3_0, RESERVED_22, 22, 26)
    FIELD(POR_MXP_ERRMISC_NS_U_SMXP_3_0, OPCODE, 16, 6)
    FIELD(POR_MXP_ERRMISC_NS_U_SMXP_3_0, RESERVED_15, 15, 1)
    FIELD(POR_MXP_ERRMISC_NS_U_SMXP_3_0, SRCID, 4, 11)
    FIELD(POR_MXP_ERRMISC_NS_U_SMXP_3_0, ERRSRC, 0, 3)
REG32(POR_HNI_NODE_INFO_U_HNI_NID196, 0x1814000)
    FIELD(POR_HNI_NODE_INFO_U_HNI_NID196, RESERVED_48, 48, 16)
    FIELD(POR_HNI_NODE_INFO_U_HNI_NID196, LOGICAL_ID, 32, 16)
    FIELD(POR_HNI_NODE_INFO_U_HNI_NID196, NODE_ID, 16, 16)
    FIELD(POR_HNI_NODE_INFO_U_HNI_NID196, NODE_TYPE, 0, 16)
REG32(POR_HNI_CHILD_INFO_U_HNI_NID196, 0x1814080)
    FIELD(POR_HNI_CHILD_INFO_U_HNI_NID196, RESERVED_32, 32, 32)
    FIELD(POR_HNI_CHILD_INFO_U_HNI_NID196, CHILD_PTR_OFFSET, 16, 16)
    FIELD(POR_HNI_CHILD_INFO_U_HNI_NID196, CHILD_COUNT, 0, 16)
REG32(POR_HNI_UNIT_INFO_U_HNI_NID196, 0x1814900)
    FIELD(POR_HNI_UNIT_INFO_U_HNI_NID196, RESERVED_30, 30, 34)
    FIELD(POR_HNI_UNIT_INFO_U_HNI_NID196, APB_SAFE_XFACE_DISABLE, 29, 1)
    FIELD(POR_HNI_UNIT_INFO_U_HNI_NID196, ACEL_SAFE_XFACE_DISABLE, 28, 1)
    FIELD(POR_HNI_UNIT_INFO_U_HNI_NID196, AXDATA_POISON_EN, 27, 1)
    FIELD(POR_HNI_UNIT_INFO_U_HNI_NID196, A4S_NUM, 25, 2)
    FIELD(POR_HNI_UNIT_INFO_U_HNI_NID196, AXDATA_WIDTH, 24, 1)
    FIELD(POR_HNI_UNIT_INFO_U_HNI_NID196, RESERVED_21, 21, 3)
    FIELD(POR_HNI_UNIT_INFO_U_HNI_NID196, NUM_WR_DATA_BUF, 16, 5)
    FIELD(POR_HNI_UNIT_INFO_U_HNI_NID196, NUM_AX_REQS, 8, 8)
    FIELD(POR_HNI_UNIT_INFO_U_HNI_NID196, NUM_EXCL, 0, 8)
REG32(POR_HNI_SECURE_REGISTER_GROUPS_OVERRIDE_U_HNI_NID196, 0x1814980)
    FIELD(POR_HNI_SECURE_REGISTER_GROUPS_OVERRIDE_U_HNI_NID196, SAM, 1, 1)
    FIELD(POR_HNI_SECURE_REGISTER_GROUPS_OVERRIDE_U_HNI_NID196, CFG_CTL, 0, 1)
REG32(POR_HNI_CFG_CTL_U_HNI_NID196, 0x1814a00)
    FIELD(POR_HNI_CFG_CTL_U_HNI_NID196, REQERR_COHREQ_EN, 0, 1)
REG32(POR_HNI_AUX_CTL_U_HNI_NID196, 0x1814a08)
    FIELD(POR_HNI_AUX_CTL_U_HNI_NID196, DISABLE_MPU_ERR_LOGGING, 5, 1)
    FIELD(POR_HNI_AUX_CTL_U_HNI_NID196, SIDE_READER_FOR_PHYMEM_PRESENT, 4, 1)
    FIELD(POR_HNI_AUX_CTL_U_HNI_NID196, CG_DISABLE, 0, 1)
REG32(POR_HNI_SAM_ADDRREGION0_CFG_U_HNI_NID196, 0x1814c00)
    FIELD(POR_HNI_SAM_ADDRREGION0_CFG_U_HNI_NID196, RESERVED_63, 63, 1)
    FIELD(POR_HNI_SAM_ADDRREGION0_CFG_U_HNI_NID196, POS_EARLY_WR_COMP_EN, 62, 1)
    FIELD(POR_HNI_SAM_ADDRREGION0_CFG_U_HNI_NID196, POS_EARLY_RDACK_EN, 61, 1)
    FIELD(POR_HNI_SAM_ADDRREGION0_CFG_U_HNI_NID196, SER_DEVNE_WR, 60, 1)
    FIELD(POR_HNI_SAM_ADDRREGION0_CFG_U_HNI_NID196, SER_ALL_WR, 59, 1)
    FIELD(POR_HNI_SAM_ADDRREGION0_CFG_U_HNI_NID196, PHYSICAL_MEM_EN, 58, 1)
    FIELD(POR_HNI_SAM_ADDRREGION0_CFG_U_HNI_NID196, ORDER_REGION_SIZE, 0, 6)
REG32(POR_HNI_SAM_ADDRREGION1_CFG_U_HNI_NID196, 0x1814c08)
    FIELD(POR_HNI_SAM_ADDRREGION1_CFG_U_HNI_NID196, VALID, 63, 1)
    FIELD(POR_HNI_SAM_ADDRREGION1_CFG_U_HNI_NID196, POS_EARLY_WR_COMP_EN, 62, 1)
    FIELD(POR_HNI_SAM_ADDRREGION1_CFG_U_HNI_NID196, POS_EARLY_RDACK_EN, 61, 1)
    FIELD(POR_HNI_SAM_ADDRREGION1_CFG_U_HNI_NID196, SER_DEVNE_WR, 60, 1)
    FIELD(POR_HNI_SAM_ADDRREGION1_CFG_U_HNI_NID196, SER_ALL_WR, 59, 1)
    FIELD(POR_HNI_SAM_ADDRREGION1_CFG_U_HNI_NID196, PHYSICAL_MEM_EN, 58, 1)
    FIELD(POR_HNI_SAM_ADDRREGION1_CFG_U_HNI_NID196, RESERVED_56, 56, 2)
    FIELD(POR_HNI_SAM_ADDRREGION1_CFG_U_HNI_NID196, BASE_ADDR, 20, 36)
    FIELD(POR_HNI_SAM_ADDRREGION1_CFG_U_HNI_NID196, RESERVED_16, 16, 4)
    FIELD(POR_HNI_SAM_ADDRREGION1_CFG_U_HNI_NID196, ADDR_REGION_SIZE, 10, 6)
    FIELD(POR_HNI_SAM_ADDRREGION1_CFG_U_HNI_NID196, ORDER_REGION_SIZE, 0, 6)
REG32(POR_HNI_SAM_ADDRREGION2_CFG_U_HNI_NID196, 0x1814c10)
    FIELD(POR_HNI_SAM_ADDRREGION2_CFG_U_HNI_NID196, VALID, 63, 1)
    FIELD(POR_HNI_SAM_ADDRREGION2_CFG_U_HNI_NID196, POS_EARLY_WR_COMP_EN, 62, 1)
    FIELD(POR_HNI_SAM_ADDRREGION2_CFG_U_HNI_NID196, POS_EARLY_RDACK_EN, 61, 1)
    FIELD(POR_HNI_SAM_ADDRREGION2_CFG_U_HNI_NID196, SER_DEVNE_WR, 60, 1)
    FIELD(POR_HNI_SAM_ADDRREGION2_CFG_U_HNI_NID196, SER_ALL_WR, 59, 1)
    FIELD(POR_HNI_SAM_ADDRREGION2_CFG_U_HNI_NID196, PHYSICAL_MEM_EN, 58, 1)
    FIELD(POR_HNI_SAM_ADDRREGION2_CFG_U_HNI_NID196, RESERVED_56, 56, 2)
    FIELD(POR_HNI_SAM_ADDRREGION2_CFG_U_HNI_NID196, BASE_ADDR, 20, 36)
    FIELD(POR_HNI_SAM_ADDRREGION2_CFG_U_HNI_NID196, RESERVED_16, 16, 4)
    FIELD(POR_HNI_SAM_ADDRREGION2_CFG_U_HNI_NID196, ADDR_REGION_SIZE, 10, 6)
    FIELD(POR_HNI_SAM_ADDRREGION2_CFG_U_HNI_NID196, ORDER_REGION_SIZE, 0, 6)
REG32(POR_HNI_SAM_ADDRREGION3_CFG_U_HNI_NID196, 0x1814c18)
    FIELD(POR_HNI_SAM_ADDRREGION3_CFG_U_HNI_NID196, VALID, 63, 1)
    FIELD(POR_HNI_SAM_ADDRREGION3_CFG_U_HNI_NID196, POS_EARLY_WR_COMP_EN, 62, 1)
    FIELD(POR_HNI_SAM_ADDRREGION3_CFG_U_HNI_NID196, POS_EARLY_RDACK_EN, 61, 1)
    FIELD(POR_HNI_SAM_ADDRREGION3_CFG_U_HNI_NID196, SER_DEVNE_WR, 60, 1)
    FIELD(POR_HNI_SAM_ADDRREGION3_CFG_U_HNI_NID196, SER_ALL_WR, 59, 1)
    FIELD(POR_HNI_SAM_ADDRREGION3_CFG_U_HNI_NID196, PHYSICAL_MEM_EN, 58, 1)
    FIELD(POR_HNI_SAM_ADDRREGION3_CFG_U_HNI_NID196, RESERVED_56, 56, 2)
    FIELD(POR_HNI_SAM_ADDRREGION3_CFG_U_HNI_NID196, BASE_ADDR, 20, 36)
    FIELD(POR_HNI_SAM_ADDRREGION3_CFG_U_HNI_NID196, RESERVED_16, 16, 4)
    FIELD(POR_HNI_SAM_ADDRREGION3_CFG_U_HNI_NID196, ADDR_REGION_SIZE, 10, 6)
    FIELD(POR_HNI_SAM_ADDRREGION3_CFG_U_HNI_NID196, ORDER_REGION_SIZE, 0, 6)
REG32(POR_HNI_PMU_EVENT_SEL_U_HNI_NID196, 0x1816000)
    FIELD(POR_HNI_PMU_EVENT_SEL_U_HNI_NID196, RESERVED_30, 30, 34)
    FIELD(POR_HNI_PMU_EVENT_SEL_U_HNI_NID196, PMU_EVENT3_ID, 24, 6)
    FIELD(POR_HNI_PMU_EVENT_SEL_U_HNI_NID196, RESERVED_22, 22, 2)
    FIELD(POR_HNI_PMU_EVENT_SEL_U_HNI_NID196, PMU_EVENT2_ID, 16, 6)
    FIELD(POR_HNI_PMU_EVENT_SEL_U_HNI_NID196, RESERVED_14, 14, 2)
    FIELD(POR_HNI_PMU_EVENT_SEL_U_HNI_NID196, PMU_EVENT1_ID, 8, 6)
    FIELD(POR_HNI_PMU_EVENT_SEL_U_HNI_NID196, PMU_EVENT0_ID, 0, 6)
REG32(POR_HNI_ERRFR_U_HNI_NID196, 0x1817000)
    FIELD(POR_HNI_ERRFR_U_HNI_NID196, RESERVED_15, 15, 49)
    FIELD(POR_HNI_ERRFR_U_HNI_NID196, CEC, 12, 3)
    FIELD(POR_HNI_ERRFR_U_HNI_NID196, CFI, 10, 2)
    FIELD(POR_HNI_ERRFR_U_HNI_NID196, FI, 6, 2)
    FIELD(POR_HNI_ERRFR_U_HNI_NID196, UI, 4, 2)
    FIELD(POR_HNI_ERRFR_U_HNI_NID196, DE, 2, 2)
    FIELD(POR_HNI_ERRFR_U_HNI_NID196, ED, 0, 2)
REG32(POR_HNI_ERRCTLR_U_HNI_NID196, 0x1817008)
    FIELD(POR_HNI_ERRCTLR_U_HNI_NID196, RESERVED_9, 9, 55)
    FIELD(POR_HNI_ERRCTLR_U_HNI_NID196, CFI, 8, 1)
    FIELD(POR_HNI_ERRCTLR_U_HNI_NID196, FI, 3, 1)
    FIELD(POR_HNI_ERRCTLR_U_HNI_NID196, UI, 2, 1)
    FIELD(POR_HNI_ERRCTLR_U_HNI_NID196, DE, 1, 1)
    FIELD(POR_HNI_ERRCTLR_U_HNI_NID196, ED, 0, 1)
REG32(POR_HNI_ERRSTATUS_U_HNI_NID196, 0x1817010)
    FIELD(POR_HNI_ERRSTATUS_U_HNI_NID196, RESERVED_32, 32, 32)
    FIELD(POR_HNI_ERRSTATUS_U_HNI_NID196, AV, 31, 1)
    FIELD(POR_HNI_ERRSTATUS_U_HNI_NID196, V, 30, 1)
    FIELD(POR_HNI_ERRSTATUS_U_HNI_NID196, UE, 29, 1)
    FIELD(POR_HNI_ERRSTATUS_U_HNI_NID196, RESERVED_28, 28, 1)
    FIELD(POR_HNI_ERRSTATUS_U_HNI_NID196, OF, 27, 1)
    FIELD(POR_HNI_ERRSTATUS_U_HNI_NID196, MV, 26, 1)
    FIELD(POR_HNI_ERRSTATUS_U_HNI_NID196, RESERVED_25, 25, 1)
    FIELD(POR_HNI_ERRSTATUS_U_HNI_NID196, CE, 24, 1)
    FIELD(POR_HNI_ERRSTATUS_U_HNI_NID196, DE, 23, 1)
    FIELD(POR_HNI_ERRSTATUS_U_HNI_NID196, RESERVED_0, 0, 23)
REG32(POR_HNI_ERRADDR_U_HNI_NID196, 0x1817018)
    FIELD(POR_HNI_ERRADDR_U_HNI_NID196, NS, 63, 1)
    FIELD(POR_HNI_ERRADDR_U_HNI_NID196, RESERVED_48, 48, 15)
    FIELD(POR_HNI_ERRADDR_U_HNI_NID196, ADDR, 0, 48)
REG32(POR_HNI_ERRMISC_U_HNI_NID196, 0x1817020)
    FIELD(POR_HNI_ERRMISC_U_HNI_NID196, RESERVED_57, 57, 7)
    FIELD(POR_HNI_ERRMISC_U_HNI_NID196, LPID, 52, 5)
    FIELD(POR_HNI_ERRMISC_U_HNI_NID196, RESERVED_50, 50, 2)
    FIELD(POR_HNI_ERRMISC_U_HNI_NID196, ORDER, 48, 2)
    FIELD(POR_HNI_ERRMISC_U_HNI_NID196, RESERVED_31, 31, 17)
    FIELD(POR_HNI_ERRMISC_U_HNI_NID196, SIZE, 28, 3)
    FIELD(POR_HNI_ERRMISC_U_HNI_NID196, MEMATTR, 24, 4)
    FIELD(POR_HNI_ERRMISC_U_HNI_NID196, RESERVED_22, 22, 2)
    FIELD(POR_HNI_ERRMISC_U_HNI_NID196, OPCODE, 16, 6)
    FIELD(POR_HNI_ERRMISC_U_HNI_NID196, RESERVED_15, 15, 1)
    FIELD(POR_HNI_ERRMISC_U_HNI_NID196, SRCID, 4, 11)
    FIELD(POR_HNI_ERRMISC_U_HNI_NID196, ERRSRC, 0, 4)
REG32(POR_HNI_ERRFR_NS_U_HNI_NID196, 0x1817100)
    FIELD(POR_HNI_ERRFR_NS_U_HNI_NID196, RESERVED_15, 15, 49)
    FIELD(POR_HNI_ERRFR_NS_U_HNI_NID196, CEC, 12, 3)
    FIELD(POR_HNI_ERRFR_NS_U_HNI_NID196, CFI, 10, 2)
    FIELD(POR_HNI_ERRFR_NS_U_HNI_NID196, FI, 6, 2)
    FIELD(POR_HNI_ERRFR_NS_U_HNI_NID196, UI, 4, 2)
    FIELD(POR_HNI_ERRFR_NS_U_HNI_NID196, DE, 2, 2)
    FIELD(POR_HNI_ERRFR_NS_U_HNI_NID196, ED, 0, 2)
REG32(POR_HNI_ERRCTLR_NS_U_HNI_NID196, 0x1817108)
    FIELD(POR_HNI_ERRCTLR_NS_U_HNI_NID196, RESERVED_9, 9, 55)
    FIELD(POR_HNI_ERRCTLR_NS_U_HNI_NID196, CFI, 8, 1)
    FIELD(POR_HNI_ERRCTLR_NS_U_HNI_NID196, FI, 3, 1)
    FIELD(POR_HNI_ERRCTLR_NS_U_HNI_NID196, UI, 2, 1)
    FIELD(POR_HNI_ERRCTLR_NS_U_HNI_NID196, DE, 1, 1)
    FIELD(POR_HNI_ERRCTLR_NS_U_HNI_NID196, ED, 0, 1)
REG32(POR_HNI_ERRSTATUS_NS_U_HNI_NID196, 0x1817110)
    FIELD(POR_HNI_ERRSTATUS_NS_U_HNI_NID196, RESERVED_32, 32, 32)
    FIELD(POR_HNI_ERRSTATUS_NS_U_HNI_NID196, AV, 31, 1)
    FIELD(POR_HNI_ERRSTATUS_NS_U_HNI_NID196, V, 30, 1)
    FIELD(POR_HNI_ERRSTATUS_NS_U_HNI_NID196, UE, 29, 1)
    FIELD(POR_HNI_ERRSTATUS_NS_U_HNI_NID196, RESERVED_28, 28, 1)
    FIELD(POR_HNI_ERRSTATUS_NS_U_HNI_NID196, OF, 27, 1)
    FIELD(POR_HNI_ERRSTATUS_NS_U_HNI_NID196, MV, 26, 1)
    FIELD(POR_HNI_ERRSTATUS_NS_U_HNI_NID196, RESERVED_25, 25, 1)
    FIELD(POR_HNI_ERRSTATUS_NS_U_HNI_NID196, CE, 24, 1)
    FIELD(POR_HNI_ERRSTATUS_NS_U_HNI_NID196, DE, 23, 1)
    FIELD(POR_HNI_ERRSTATUS_NS_U_HNI_NID196, RESERVED_0, 0, 23)
REG32(POR_HNI_ERRADDR_NS_U_HNI_NID196, 0x1817118)
    FIELD(POR_HNI_ERRADDR_NS_U_HNI_NID196, NS, 63, 1)
    FIELD(POR_HNI_ERRADDR_NS_U_HNI_NID196, RESERVED_48, 48, 15)
    FIELD(POR_HNI_ERRADDR_NS_U_HNI_NID196, ADDR, 0, 48)
REG32(POR_HNI_ERRMISC_NS_U_HNI_NID196, 0x1817120)
    FIELD(POR_HNI_ERRMISC_NS_U_HNI_NID196, RESERVED_57, 57, 7)
    FIELD(POR_HNI_ERRMISC_NS_U_HNI_NID196, LPID, 52, 5)
    FIELD(POR_HNI_ERRMISC_NS_U_HNI_NID196, RESERVED_50, 50, 2)
    FIELD(POR_HNI_ERRMISC_NS_U_HNI_NID196, ORDER, 48, 2)
    FIELD(POR_HNI_ERRMISC_NS_U_HNI_NID196, RESERVED_31, 31, 17)
    FIELD(POR_HNI_ERRMISC_NS_U_HNI_NID196, SIZE, 28, 3)
    FIELD(POR_HNI_ERRMISC_NS_U_HNI_NID196, MEMATTR, 24, 4)
    FIELD(POR_HNI_ERRMISC_NS_U_HNI_NID196, RESERVED_22, 22, 2)
    FIELD(POR_HNI_ERRMISC_NS_U_HNI_NID196, OPCODE, 16, 6)
    FIELD(POR_HNI_ERRMISC_NS_U_HNI_NID196, RESERVED_15, 15, 1)
    FIELD(POR_HNI_ERRMISC_NS_U_HNI_NID196, SRCID, 4, 11)
    FIELD(POR_HNI_ERRMISC_NS_U_HNI_NID196, ERRSRC, 0, 4)
REG32(POR_FDC_NODE_INFO_U_SMXP_3_0, 0x182c000)
    FIELD(POR_FDC_NODE_INFO_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_FDC_NODE_INFO_U_SMXP_3_0, LOGICAL_ID, 32, 16)
    FIELD(POR_FDC_NODE_INFO_U_SMXP_3_0, NODE_ID, 16, 16)
    FIELD(POR_FDC_NODE_INFO_U_SMXP_3_0, NODE_TYPE, 0, 16)
REG32(POR_FDC_CHILD_INFO_U_SMXP_3_0, 0x182c080)
    FIELD(POR_FDC_CHILD_INFO_U_SMXP_3_0, RESERVED_32, 32, 32)
    FIELD(POR_FDC_CHILD_INFO_U_SMXP_3_0, CHILD_PTR_OFFSET, 16, 16)
    FIELD(POR_FDC_CHILD_INFO_U_SMXP_3_0, CHILD_COUNT, 0, 16)
REG32(POR_ERRFR_MXP_U_SMXP_3_0, 0x182f000)
    FIELD(POR_ERRFR_MXP_U_SMXP_3_0, FI, 6, 2)
    FIELD(POR_ERRFR_MXP_U_SMXP_3_0, UI, 4, 2)
    FIELD(POR_ERRFR_MXP_U_SMXP_3_0, ED, 0, 2)
REG32(POR_ERRCTLR_MXP_U_SMXP_3_0, 0x182f008)
    FIELD(POR_ERRCTLR_MXP_U_SMXP_3_0, RESERVED_32, 32, 32)
    FIELD(POR_ERRCTLR_MXP_U_SMXP_3_0, ERC, 14, 18)
    FIELD(POR_ERRCTLR_MXP_U_SMXP_3_0, FI, 3, 1)
    FIELD(POR_ERRCTLR_MXP_U_SMXP_3_0, UI, 2, 1)
    FIELD(POR_ERRCTLR_MXP_U_SMXP_3_0, ED, 0, 1)
REG32(POR_ERRSTATUS_MXP_U_SMXP_3_0, 0x182f010)
    FIELD(POR_ERRSTATUS_MXP_U_SMXP_3_0, RESERVED_31, 31, 33)
    FIELD(POR_ERRSTATUS_MXP_U_SMXP_3_0, V, 30, 1)
    FIELD(POR_ERRSTATUS_MXP_U_SMXP_3_0, UE, 29, 1)
    FIELD(POR_ERRSTATUS_MXP_U_SMXP_3_0, RESERVED_28, 28, 1)
    FIELD(POR_ERRSTATUS_MXP_U_SMXP_3_0, OF, 27, 1)
    FIELD(POR_ERRSTATUS_MXP_U_SMXP_3_0, RESERVED_24, 24, 3)
    FIELD(POR_ERRSTATUS_MXP_U_SMXP_3_0, DE, 23, 1)
    FIELD(POR_ERRSTATUS_MXP_U_SMXP_3_0, RESERVED_16, 16, 7)
    FIELD(POR_ERRSTATUS_MXP_U_SMXP_3_0, V_ERR_TYPE, 6, 10)
    FIELD(POR_ERRSTATUS_MXP_U_SMXP_3_0, RESERVED_0, 0, 6)
REG32(POR_FDC_AUX_CTL_MXP_U_SMXP_3_0, 0x182f018)
    FIELD(POR_FDC_AUX_CTL_MXP_U_SMXP_3_0, CLKGATE_OVERRIDE, 4, 1)
    FIELD(POR_FDC_AUX_CTL_MXP_U_SMXP_3_0, RESERVED_0, 0, 4)
REG32(POR_ERRFR_P0_D0_U_SMXP_3_0, 0x182f040)
    FIELD(POR_ERRFR_P0_D0_U_SMXP_3_0, FI, 6, 2)
    FIELD(POR_ERRFR_P0_D0_U_SMXP_3_0, UI, 4, 2)
    FIELD(POR_ERRFR_P0_D0_U_SMXP_3_0, ED, 0, 2)
REG32(POR_ERRCTLR_P0_D0_U_SMXP_3_0, 0x182f048)
    FIELD(POR_ERRCTLR_P0_D0_U_SMXP_3_0, RESERVED_32, 32, 32)
    FIELD(POR_ERRCTLR_P0_D0_U_SMXP_3_0, ERC, 14, 18)
    FIELD(POR_ERRCTLR_P0_D0_U_SMXP_3_0, FI, 3, 1)
    FIELD(POR_ERRCTLR_P0_D0_U_SMXP_3_0, UI, 2, 1)
    FIELD(POR_ERRCTLR_P0_D0_U_SMXP_3_0, ED, 0, 1)
REG32(POR_ERRSTATUS_P0_D0_U_SMXP_3_0, 0x182f050)
    FIELD(POR_ERRSTATUS_P0_D0_U_SMXP_3_0, RESERVED_31, 31, 33)
    FIELD(POR_ERRSTATUS_P0_D0_U_SMXP_3_0, V, 30, 1)
    FIELD(POR_ERRSTATUS_P0_D0_U_SMXP_3_0, UE, 29, 1)
    FIELD(POR_ERRSTATUS_P0_D0_U_SMXP_3_0, RESERVED_28, 28, 1)
    FIELD(POR_ERRSTATUS_P0_D0_U_SMXP_3_0, OF, 27, 1)
    FIELD(POR_ERRSTATUS_P0_D0_U_SMXP_3_0, RESERVED_24, 24, 3)
    FIELD(POR_ERRSTATUS_P0_D0_U_SMXP_3_0, DE, 23, 1)
    FIELD(POR_ERRSTATUS_P0_D0_U_SMXP_3_0, RESERVED_16, 16, 7)
    FIELD(POR_ERRSTATUS_P0_D0_U_SMXP_3_0, V_ERR_TYPE, 6, 10)
    FIELD(POR_ERRSTATUS_P0_D0_U_SMXP_3_0, RESERVED_0, 0, 6)
REG32(POR_FDC_AUX_CTL_P0_D0_U_SMXP_3_0, 0x182f058)
    FIELD(POR_FDC_AUX_CTL_P0_D0_U_SMXP_3_0, CLKGATE_OVERRIDE, 4, 1)
    FIELD(POR_FDC_AUX_CTL_P0_D0_U_SMXP_3_0, HANG_DET_CONFIG, 0, 4)
REG32(POR_ERRFR_P0_D1_U_SMXP_3_0, 0x182f080)
    FIELD(POR_ERRFR_P0_D1_U_SMXP_3_0, FI, 6, 2)
    FIELD(POR_ERRFR_P0_D1_U_SMXP_3_0, UI, 4, 2)
    FIELD(POR_ERRFR_P0_D1_U_SMXP_3_0, ED, 0, 2)
REG32(POR_ERRCTLR_P0_D1_U_SMXP_3_0, 0x182f088)
    FIELD(POR_ERRCTLR_P0_D1_U_SMXP_3_0, RESERVED_32, 32, 32)
    FIELD(POR_ERRCTLR_P0_D1_U_SMXP_3_0, ERC, 14, 18)
    FIELD(POR_ERRCTLR_P0_D1_U_SMXP_3_0, FI, 3, 1)
    FIELD(POR_ERRCTLR_P0_D1_U_SMXP_3_0, UI, 2, 1)
    FIELD(POR_ERRCTLR_P0_D1_U_SMXP_3_0, ED, 0, 1)
REG32(POR_ERRSTATUS_P0_D1_U_SMXP_3_0, 0x182f090)
    FIELD(POR_ERRSTATUS_P0_D1_U_SMXP_3_0, RESERVED_31, 31, 33)
    FIELD(POR_ERRSTATUS_P0_D1_U_SMXP_3_0, V, 30, 1)
    FIELD(POR_ERRSTATUS_P0_D1_U_SMXP_3_0, UE, 29, 1)
    FIELD(POR_ERRSTATUS_P0_D1_U_SMXP_3_0, RESERVED_28, 28, 1)
    FIELD(POR_ERRSTATUS_P0_D1_U_SMXP_3_0, OF, 27, 1)
    FIELD(POR_ERRSTATUS_P0_D1_U_SMXP_3_0, RESERVED_24, 24, 3)
    FIELD(POR_ERRSTATUS_P0_D1_U_SMXP_3_0, DE, 23, 1)
    FIELD(POR_ERRSTATUS_P0_D1_U_SMXP_3_0, RESERVED_16, 16, 7)
    FIELD(POR_ERRSTATUS_P0_D1_U_SMXP_3_0, V_ERR_TYPE, 6, 10)
    FIELD(POR_ERRSTATUS_P0_D1_U_SMXP_3_0, RESERVED_0, 0, 6)
REG32(POR_FDC_AUX_CTL_P0_D1_U_SMXP_3_0, 0x182f098)
    FIELD(POR_FDC_AUX_CTL_P0_D1_U_SMXP_3_0, CLKGATE_OVERRIDE, 4, 1)
    FIELD(POR_FDC_AUX_CTL_P0_D1_U_SMXP_3_0, HANG_DET_CONFIG, 0, 4)
REG32(POR_ERRFR_P0_D2_U_SMXP_3_0, 0x182f0c0)
    FIELD(POR_ERRFR_P0_D2_U_SMXP_3_0, FI, 6, 2)
    FIELD(POR_ERRFR_P0_D2_U_SMXP_3_0, UI, 4, 2)
    FIELD(POR_ERRFR_P0_D2_U_SMXP_3_0, ED, 0, 2)
REG32(POR_ERRCTLR_P0_D2_U_SMXP_3_0, 0x182f0c8)
    FIELD(POR_ERRCTLR_P0_D2_U_SMXP_3_0, RESERVED_32, 32, 32)
    FIELD(POR_ERRCTLR_P0_D2_U_SMXP_3_0, ERC, 14, 18)
    FIELD(POR_ERRCTLR_P0_D2_U_SMXP_3_0, FI, 3, 1)
    FIELD(POR_ERRCTLR_P0_D2_U_SMXP_3_0, UI, 2, 1)
    FIELD(POR_ERRCTLR_P0_D2_U_SMXP_3_0, ED, 0, 1)
REG32(POR_ERRSTATUS_P0_D2_U_SMXP_3_0, 0x182f0d0)
    FIELD(POR_ERRSTATUS_P0_D2_U_SMXP_3_0, RESERVED_31, 31, 33)
    FIELD(POR_ERRSTATUS_P0_D2_U_SMXP_3_0, V, 30, 1)
    FIELD(POR_ERRSTATUS_P0_D2_U_SMXP_3_0, UE, 29, 1)
    FIELD(POR_ERRSTATUS_P0_D2_U_SMXP_3_0, RESERVED_28, 28, 1)
    FIELD(POR_ERRSTATUS_P0_D2_U_SMXP_3_0, OF, 27, 1)
    FIELD(POR_ERRSTATUS_P0_D2_U_SMXP_3_0, RESERVED_24, 24, 3)
    FIELD(POR_ERRSTATUS_P0_D2_U_SMXP_3_0, DE, 23, 1)
    FIELD(POR_ERRSTATUS_P0_D2_U_SMXP_3_0, RESERVED_16, 16, 7)
    FIELD(POR_ERRSTATUS_P0_D2_U_SMXP_3_0, V_ERR_TYPE, 6, 10)
    FIELD(POR_ERRSTATUS_P0_D2_U_SMXP_3_0, RESERVED_0, 0, 6)
REG32(POR_FDC_AUX_CTL_P0_D2_U_SMXP_3_0, 0x182f0d8)
    FIELD(POR_FDC_AUX_CTL_P0_D2_U_SMXP_3_0, CLKGATE_OVERRIDE, 4, 1)
    FIELD(POR_FDC_AUX_CTL_P0_D2_U_SMXP_3_0, HANG_DET_CONFIG, 0, 4)
REG32(POR_ERRFR_P0_D3_U_SMXP_3_0, 0x182f100)
    FIELD(POR_ERRFR_P0_D3_U_SMXP_3_0, FI, 6, 2)
    FIELD(POR_ERRFR_P0_D3_U_SMXP_3_0, UI, 4, 2)
    FIELD(POR_ERRFR_P0_D3_U_SMXP_3_0, ED, 0, 2)
REG32(POR_ERRCTLR_P0_D3_U_SMXP_3_0, 0x182f108)
    FIELD(POR_ERRCTLR_P0_D3_U_SMXP_3_0, RESERVED_32, 32, 32)
    FIELD(POR_ERRCTLR_P0_D3_U_SMXP_3_0, ERC, 14, 18)
    FIELD(POR_ERRCTLR_P0_D3_U_SMXP_3_0, FI, 3, 1)
    FIELD(POR_ERRCTLR_P0_D3_U_SMXP_3_0, UI, 2, 1)
    FIELD(POR_ERRCTLR_P0_D3_U_SMXP_3_0, ED, 0, 1)
REG32(POR_ERRSTATUS_P0_D3_U_SMXP_3_0, 0x182f110)
    FIELD(POR_ERRSTATUS_P0_D3_U_SMXP_3_0, RESERVED_31, 31, 33)
    FIELD(POR_ERRSTATUS_P0_D3_U_SMXP_3_0, V, 30, 1)
    FIELD(POR_ERRSTATUS_P0_D3_U_SMXP_3_0, UE, 29, 1)
    FIELD(POR_ERRSTATUS_P0_D3_U_SMXP_3_0, RESERVED_28, 28, 1)
    FIELD(POR_ERRSTATUS_P0_D3_U_SMXP_3_0, OF, 27, 1)
    FIELD(POR_ERRSTATUS_P0_D3_U_SMXP_3_0, RESERVED_24, 24, 3)
    FIELD(POR_ERRSTATUS_P0_D3_U_SMXP_3_0, DE, 23, 1)
    FIELD(POR_ERRSTATUS_P0_D3_U_SMXP_3_0, RESERVED_16, 16, 7)
    FIELD(POR_ERRSTATUS_P0_D3_U_SMXP_3_0, V_ERR_TYPE, 6, 10)
    FIELD(POR_ERRSTATUS_P0_D3_U_SMXP_3_0, RESERVED_0, 0, 6)
REG32(POR_FDC_AUX_CTL_P0_D3_U_SMXP_3_0, 0x182f118)
    FIELD(POR_FDC_AUX_CTL_P0_D3_U_SMXP_3_0, CLKGATE_OVERRIDE, 4, 1)
    FIELD(POR_FDC_AUX_CTL_P0_D3_U_SMXP_3_0, HANG_DET_CONFIG, 0, 4)
REG32(POR_ERRFR_P1_D0_U_SMXP_3_0, 0x182f140)
    FIELD(POR_ERRFR_P1_D0_U_SMXP_3_0, FI, 6, 2)
    FIELD(POR_ERRFR_P1_D0_U_SMXP_3_0, UI, 4, 2)
    FIELD(POR_ERRFR_P1_D0_U_SMXP_3_0, ED, 0, 2)
REG32(POR_ERRCTLR_P1_D0_U_SMXP_3_0, 0x182f148)
    FIELD(POR_ERRCTLR_P1_D0_U_SMXP_3_0, RESERVED_32, 32, 32)
    FIELD(POR_ERRCTLR_P1_D0_U_SMXP_3_0, ERC, 14, 18)
    FIELD(POR_ERRCTLR_P1_D0_U_SMXP_3_0, FI, 3, 1)
    FIELD(POR_ERRCTLR_P1_D0_U_SMXP_3_0, UI, 2, 1)
    FIELD(POR_ERRCTLR_P1_D0_U_SMXP_3_0, ED, 0, 1)
REG32(POR_ERRSTATUS_P1_D0_U_SMXP_3_0, 0x182f150)
    FIELD(POR_ERRSTATUS_P1_D0_U_SMXP_3_0, RESERVED_31, 31, 33)
    FIELD(POR_ERRSTATUS_P1_D0_U_SMXP_3_0, V, 30, 1)
    FIELD(POR_ERRSTATUS_P1_D0_U_SMXP_3_0, UE, 29, 1)
    FIELD(POR_ERRSTATUS_P1_D0_U_SMXP_3_0, RESERVED_28, 28, 1)
    FIELD(POR_ERRSTATUS_P1_D0_U_SMXP_3_0, OF, 27, 1)
    FIELD(POR_ERRSTATUS_P1_D0_U_SMXP_3_0, RESERVED_24, 24, 3)
    FIELD(POR_ERRSTATUS_P1_D0_U_SMXP_3_0, DE, 23, 1)
    FIELD(POR_ERRSTATUS_P1_D0_U_SMXP_3_0, RESERVED_16, 16, 7)
    FIELD(POR_ERRSTATUS_P1_D0_U_SMXP_3_0, V_ERR_TYPE, 6, 10)
    FIELD(POR_ERRSTATUS_P1_D0_U_SMXP_3_0, RESERVED_0, 0, 6)
REG32(POR_FDC_AUX_CTL_P1_D0_U_SMXP_3_0, 0x182f158)
    FIELD(POR_FDC_AUX_CTL_P1_D0_U_SMXP_3_0, CLKGATE_OVERRIDE, 4, 1)
    FIELD(POR_FDC_AUX_CTL_P1_D0_U_SMXP_3_0, HANG_DET_CONFIG, 0, 4)
REG32(POR_ERRFR_P1_D1_U_SMXP_3_0, 0x182f180)
    FIELD(POR_ERRFR_P1_D1_U_SMXP_3_0, FI, 6, 2)
    FIELD(POR_ERRFR_P1_D1_U_SMXP_3_0, UI, 4, 2)
    FIELD(POR_ERRFR_P1_D1_U_SMXP_3_0, ED, 0, 2)
REG32(POR_ERRCTLR_P1_D1_U_SMXP_3_0, 0x182f188)
    FIELD(POR_ERRCTLR_P1_D1_U_SMXP_3_0, RESERVED_32, 32, 32)
    FIELD(POR_ERRCTLR_P1_D1_U_SMXP_3_0, ERC, 14, 18)
    FIELD(POR_ERRCTLR_P1_D1_U_SMXP_3_0, FI, 3, 1)
    FIELD(POR_ERRCTLR_P1_D1_U_SMXP_3_0, UI, 2, 1)
    FIELD(POR_ERRCTLR_P1_D1_U_SMXP_3_0, ED, 0, 1)
REG32(POR_ERRSTATUS_P1_D1_U_SMXP_3_0, 0x182f190)
    FIELD(POR_ERRSTATUS_P1_D1_U_SMXP_3_0, RESERVED_31, 31, 33)
    FIELD(POR_ERRSTATUS_P1_D1_U_SMXP_3_0, V, 30, 1)
    FIELD(POR_ERRSTATUS_P1_D1_U_SMXP_3_0, UE, 29, 1)
    FIELD(POR_ERRSTATUS_P1_D1_U_SMXP_3_0, RESERVED_28, 28, 1)
    FIELD(POR_ERRSTATUS_P1_D1_U_SMXP_3_0, OF, 27, 1)
    FIELD(POR_ERRSTATUS_P1_D1_U_SMXP_3_0, RESERVED_24, 24, 3)
    FIELD(POR_ERRSTATUS_P1_D1_U_SMXP_3_0, DE, 23, 1)
    FIELD(POR_ERRSTATUS_P1_D1_U_SMXP_3_0, RESERVED_16, 16, 7)
    FIELD(POR_ERRSTATUS_P1_D1_U_SMXP_3_0, V_ERR_TYPE, 6, 10)
    FIELD(POR_ERRSTATUS_P1_D1_U_SMXP_3_0, RESERVED_0, 0, 6)
REG32(POR_FDC_AUX_CTL_P1_D1_U_SMXP_3_0, 0x182f198)
    FIELD(POR_FDC_AUX_CTL_P1_D1_U_SMXP_3_0, CLKGATE_OVERRIDE, 4, 1)
    FIELD(POR_FDC_AUX_CTL_P1_D1_U_SMXP_3_0, HANG_DET_CONFIG, 0, 4)
REG32(POR_ERRFR_P1_D2_U_SMXP_3_0, 0x182f1c0)
    FIELD(POR_ERRFR_P1_D2_U_SMXP_3_0, FI, 6, 2)
    FIELD(POR_ERRFR_P1_D2_U_SMXP_3_0, UI, 4, 2)
    FIELD(POR_ERRFR_P1_D2_U_SMXP_3_0, ED, 0, 2)
REG32(POR_ERRCTLR_P1_D2_U_SMXP_3_0, 0x182f1c8)
    FIELD(POR_ERRCTLR_P1_D2_U_SMXP_3_0, RESERVED_32, 32, 32)
    FIELD(POR_ERRCTLR_P1_D2_U_SMXP_3_0, ERC, 14, 18)
    FIELD(POR_ERRCTLR_P1_D2_U_SMXP_3_0, FI, 3, 1)
    FIELD(POR_ERRCTLR_P1_D2_U_SMXP_3_0, UI, 2, 1)
    FIELD(POR_ERRCTLR_P1_D2_U_SMXP_3_0, ED, 0, 1)
REG32(POR_ERRSTATUS_P1_D2_U_SMXP_3_0, 0x182f1d0)
    FIELD(POR_ERRSTATUS_P1_D2_U_SMXP_3_0, RESERVED_31, 31, 33)
    FIELD(POR_ERRSTATUS_P1_D2_U_SMXP_3_0, V, 30, 1)
    FIELD(POR_ERRSTATUS_P1_D2_U_SMXP_3_0, UE, 29, 1)
    FIELD(POR_ERRSTATUS_P1_D2_U_SMXP_3_0, RESERVED_28, 28, 1)
    FIELD(POR_ERRSTATUS_P1_D2_U_SMXP_3_0, OF, 27, 1)
    FIELD(POR_ERRSTATUS_P1_D2_U_SMXP_3_0, RESERVED_24, 24, 3)
    FIELD(POR_ERRSTATUS_P1_D2_U_SMXP_3_0, DE, 23, 1)
    FIELD(POR_ERRSTATUS_P1_D2_U_SMXP_3_0, RESERVED_16, 16, 7)
    FIELD(POR_ERRSTATUS_P1_D2_U_SMXP_3_0, V_ERR_TYPE, 6, 10)
    FIELD(POR_ERRSTATUS_P1_D2_U_SMXP_3_0, RESERVED_0, 0, 6)
REG32(POR_FDC_AUX_CTL_P1_D2_U_SMXP_3_0, 0x182f1d8)
    FIELD(POR_FDC_AUX_CTL_P1_D2_U_SMXP_3_0, CLKGATE_OVERRIDE, 4, 1)
    FIELD(POR_FDC_AUX_CTL_P1_D2_U_SMXP_3_0, HANG_DET_CONFIG, 0, 4)
REG32(POR_ERRFR_P1_D3_U_SMXP_3_0, 0x182f200)
    FIELD(POR_ERRFR_P1_D3_U_SMXP_3_0, FI, 6, 2)
    FIELD(POR_ERRFR_P1_D3_U_SMXP_3_0, UI, 4, 2)
    FIELD(POR_ERRFR_P1_D3_U_SMXP_3_0, ED, 0, 2)
REG32(POR_ERRCTLR_P1_D3_U_SMXP_3_0, 0x182f208)
    FIELD(POR_ERRCTLR_P1_D3_U_SMXP_3_0, RESERVED_32, 32, 32)
    FIELD(POR_ERRCTLR_P1_D3_U_SMXP_3_0, ERC, 14, 18)
    FIELD(POR_ERRCTLR_P1_D3_U_SMXP_3_0, FI, 3, 1)
    FIELD(POR_ERRCTLR_P1_D3_U_SMXP_3_0, UI, 2, 1)
    FIELD(POR_ERRCTLR_P1_D3_U_SMXP_3_0, ED, 0, 1)
REG32(POR_ERRSTATUS_P1_D3_U_SMXP_3_0, 0x182f210)
    FIELD(POR_ERRSTATUS_P1_D3_U_SMXP_3_0, RESERVED_31, 31, 33)
    FIELD(POR_ERRSTATUS_P1_D3_U_SMXP_3_0, V, 30, 1)
    FIELD(POR_ERRSTATUS_P1_D3_U_SMXP_3_0, UE, 29, 1)
    FIELD(POR_ERRSTATUS_P1_D3_U_SMXP_3_0, RESERVED_28, 28, 1)
    FIELD(POR_ERRSTATUS_P1_D3_U_SMXP_3_0, OF, 27, 1)
    FIELD(POR_ERRSTATUS_P1_D3_U_SMXP_3_0, RESERVED_24, 24, 3)
    FIELD(POR_ERRSTATUS_P1_D3_U_SMXP_3_0, DE, 23, 1)
    FIELD(POR_ERRSTATUS_P1_D3_U_SMXP_3_0, RESERVED_16, 16, 7)
    FIELD(POR_ERRSTATUS_P1_D3_U_SMXP_3_0, V_ERR_TYPE, 6, 10)
    FIELD(POR_ERRSTATUS_P1_D3_U_SMXP_3_0, RESERVED_0, 0, 6)
REG32(POR_FDC_AUX_CTL_P1_D3_U_SMXP_3_0, 0x182f218)
    FIELD(POR_FDC_AUX_CTL_P1_D3_U_SMXP_3_0, CLKGATE_OVERRIDE, 4, 1)
    FIELD(POR_FDC_AUX_CTL_P1_D3_U_SMXP_3_0, HANG_DET_CONFIG, 0, 4)
REG32(POR_ERRINJECT_U_SMXP_3_0, 0x182f300)
    FIELD(POR_ERRINJECT_U_SMXP_3_0, ERR_DEV, 4, 4)
    FIELD(POR_ERRINJECT_U_SMXP_3_0, ERR_TYPE, 0, 4)
REG32(POR_FDC_KEY_U_SMXP_3_0, 0x182f308)
    FIELD(POR_FDC_KEY_U_SMXP_3_0, KEY, 0, 8)
REG32(POR_MPU_NODE_INFO_U_SMXP_3_0, 0x183c000)
    FIELD(POR_MPU_NODE_INFO_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_NODE_INFO_U_SMXP_3_0, LOGICAL_ID, 32, 16)
    FIELD(POR_MPU_NODE_INFO_U_SMXP_3_0, NODE_ID, 16, 16)
    FIELD(POR_MPU_NODE_INFO_U_SMXP_3_0, NODE_TYPE, 0, 16)
REG32(POR_MPU_CHILD_INFO_U_SMXP_3_0, 0x183c080)
    FIELD(POR_MPU_CHILD_INFO_U_SMXP_3_0, RESERVED_32, 32, 32)
    FIELD(POR_MPU_CHILD_INFO_U_SMXP_3_0, CHILD_PTR_OFFSET, 16, 16)
    FIELD(POR_MPU_CHILD_INFO_U_SMXP_3_0, CHILD_COUNT, 0, 16)
REG32(POR_MPU_UNIT_INFO_U_SMXP_3_0, 0x183c900)
    FIELD(POR_MPU_UNIT_INFO_U_SMXP_3_0, RESERVED_16, 16, 48)
    FIELD(POR_MPU_UNIT_INFO_U_SMXP_3_0, MASTER_7_PRESENT, 15, 1)
    FIELD(POR_MPU_UNIT_INFO_U_SMXP_3_0, MASTER_6_PRESENT, 14, 1)
    FIELD(POR_MPU_UNIT_INFO_U_SMXP_3_0, MASTER_5_PRESENT, 13, 1)
    FIELD(POR_MPU_UNIT_INFO_U_SMXP_3_0, MASTER_4_PRESENT, 12, 1)
    FIELD(POR_MPU_UNIT_INFO_U_SMXP_3_0, MASTER_3_PRESENT, 11, 1)
    FIELD(POR_MPU_UNIT_INFO_U_SMXP_3_0, MASTER_2_PRESENT, 10, 1)
    FIELD(POR_MPU_UNIT_INFO_U_SMXP_3_0, MASTER_1_PRESENT, 9, 1)
    FIELD(POR_MPU_UNIT_INFO_U_SMXP_3_0, MASTER_0_PRESENT, 8, 1)
    FIELD(POR_MPU_UNIT_INFO_U_SMXP_3_0, NUM_PROG_REGION, 0, 8)
REG32(POR_MPU_M0_CTL_U_SMXP_3_0, 0x183d000)
    FIELD(POR_MPU_M0_CTL_U_SMXP_3_0, M0_EN, 2, 1)
    FIELD(POR_MPU_M0_CTL_U_SMXP_3_0, M0_ACTION, 0, 2)
REG32(POR_MPU_M0_PRBAR0_U_SMXP_3_0, 0x183d010)
    FIELD(POR_MPU_M0_PRBAR0_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR0_U_SMXP_3_0, REGION0_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR0_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR0_U_SMXP_3_0, REGION0_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR0_U_SMXP_3_0, REGION0_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR0_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR0_U_SMXP_3_0, 0x183d018)
    FIELD(POR_MPU_M0_PRLAR0_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR0_U_SMXP_3_0, REGION0_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR0_U_SMXP_3_0, REGION0_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR1_U_SMXP_3_0, 0x183d020)
    FIELD(POR_MPU_M0_PRBAR1_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR1_U_SMXP_3_0, REGION1_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR1_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR1_U_SMXP_3_0, REGION1_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR1_U_SMXP_3_0, REGION1_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR1_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR1_U_SMXP_3_0, 0x183d028)
    FIELD(POR_MPU_M0_PRLAR1_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR1_U_SMXP_3_0, REGION1_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR1_U_SMXP_3_0, REGION1_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR2_U_SMXP_3_0, 0x183d030)
    FIELD(POR_MPU_M0_PRBAR2_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR2_U_SMXP_3_0, REGION2_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR2_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR2_U_SMXP_3_0, REGION2_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR2_U_SMXP_3_0, REGION2_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR2_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR2_U_SMXP_3_0, 0x183d038)
    FIELD(POR_MPU_M0_PRLAR2_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR2_U_SMXP_3_0, REGION2_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR2_U_SMXP_3_0, REGION2_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR3_U_SMXP_3_0, 0x183d040)
    FIELD(POR_MPU_M0_PRBAR3_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR3_U_SMXP_3_0, REGION3_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR3_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR3_U_SMXP_3_0, REGION3_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR3_U_SMXP_3_0, REGION3_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR3_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR3_U_SMXP_3_0, 0x183d048)
    FIELD(POR_MPU_M0_PRLAR3_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR3_U_SMXP_3_0, REGION3_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR3_U_SMXP_3_0, REGION3_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR4_U_SMXP_3_0, 0x183d050)
    FIELD(POR_MPU_M0_PRBAR4_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR4_U_SMXP_3_0, REGION4_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR4_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR4_U_SMXP_3_0, REGION4_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR4_U_SMXP_3_0, REGION4_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR4_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR4_U_SMXP_3_0, 0x183d058)
    FIELD(POR_MPU_M0_PRLAR4_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR4_U_SMXP_3_0, REGION4_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR4_U_SMXP_3_0, REGION4_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR5_U_SMXP_3_0, 0x183d060)
    FIELD(POR_MPU_M0_PRBAR5_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR5_U_SMXP_3_0, REGION5_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR5_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR5_U_SMXP_3_0, REGION5_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR5_U_SMXP_3_0, REGION5_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR5_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR5_U_SMXP_3_0, 0x183d068)
    FIELD(POR_MPU_M0_PRLAR5_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR5_U_SMXP_3_0, REGION5_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR5_U_SMXP_3_0, REGION5_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR6_U_SMXP_3_0, 0x183d070)
    FIELD(POR_MPU_M0_PRBAR6_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR6_U_SMXP_3_0, REGION6_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR6_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR6_U_SMXP_3_0, REGION6_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR6_U_SMXP_3_0, REGION6_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR6_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR6_U_SMXP_3_0, 0x183d078)
    FIELD(POR_MPU_M0_PRLAR6_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR6_U_SMXP_3_0, REGION6_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR6_U_SMXP_3_0, REGION6_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR7_U_SMXP_3_0, 0x183d080)
    FIELD(POR_MPU_M0_PRBAR7_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR7_U_SMXP_3_0, REGION7_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR7_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR7_U_SMXP_3_0, REGION7_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR7_U_SMXP_3_0, REGION7_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR7_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR7_U_SMXP_3_0, 0x183d088)
    FIELD(POR_MPU_M0_PRLAR7_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR7_U_SMXP_3_0, REGION7_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR7_U_SMXP_3_0, REGION7_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR8_U_SMXP_3_0, 0x183d090)
    FIELD(POR_MPU_M0_PRBAR8_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR8_U_SMXP_3_0, REGION8_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR8_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR8_U_SMXP_3_0, REGION8_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR8_U_SMXP_3_0, REGION8_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR8_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR8_U_SMXP_3_0, 0x183d098)
    FIELD(POR_MPU_M0_PRLAR8_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR8_U_SMXP_3_0, REGION8_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR8_U_SMXP_3_0, REGION8_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR9_U_SMXP_3_0, 0x183d0a0)
    FIELD(POR_MPU_M0_PRBAR9_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR9_U_SMXP_3_0, REGION9_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR9_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR9_U_SMXP_3_0, REGION9_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR9_U_SMXP_3_0, REGION9_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR9_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR9_U_SMXP_3_0, 0x183d0a8)
    FIELD(POR_MPU_M0_PRLAR9_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR9_U_SMXP_3_0, REGION9_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR9_U_SMXP_3_0, REGION9_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR10_U_SMXP_3_0, 0x183d0b0)
    FIELD(POR_MPU_M0_PRBAR10_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR10_U_SMXP_3_0, REGION10_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR10_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR10_U_SMXP_3_0, REGION10_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR10_U_SMXP_3_0, REGION10_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR10_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR10_U_SMXP_3_0, 0x183d0b8)
    FIELD(POR_MPU_M0_PRLAR10_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR10_U_SMXP_3_0, REGION10_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR10_U_SMXP_3_0, REGION10_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR11_U_SMXP_3_0, 0x183d0c0)
    FIELD(POR_MPU_M0_PRBAR11_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR11_U_SMXP_3_0, REGION11_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR11_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR11_U_SMXP_3_0, REGION11_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR11_U_SMXP_3_0, REGION11_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR11_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR11_U_SMXP_3_0, 0x183d0c8)
    FIELD(POR_MPU_M0_PRLAR11_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR11_U_SMXP_3_0, REGION11_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR11_U_SMXP_3_0, REGION11_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR12_U_SMXP_3_0, 0x183d0d0)
    FIELD(POR_MPU_M0_PRBAR12_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR12_U_SMXP_3_0, REGION12_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR12_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR12_U_SMXP_3_0, REGION12_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR12_U_SMXP_3_0, REGION12_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR12_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR12_U_SMXP_3_0, 0x183d0d8)
    FIELD(POR_MPU_M0_PRLAR12_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR12_U_SMXP_3_0, REGION12_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR12_U_SMXP_3_0, REGION12_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR13_U_SMXP_3_0, 0x183d0e0)
    FIELD(POR_MPU_M0_PRBAR13_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR13_U_SMXP_3_0, REGION13_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR13_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR13_U_SMXP_3_0, REGION13_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR13_U_SMXP_3_0, REGION13_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR13_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR13_U_SMXP_3_0, 0x183d0e8)
    FIELD(POR_MPU_M0_PRLAR13_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR13_U_SMXP_3_0, REGION13_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR13_U_SMXP_3_0, REGION13_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR14_U_SMXP_3_0, 0x183d0f0)
    FIELD(POR_MPU_M0_PRBAR14_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR14_U_SMXP_3_0, REGION14_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR14_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR14_U_SMXP_3_0, REGION14_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR14_U_SMXP_3_0, REGION14_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR14_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR14_U_SMXP_3_0, 0x183d0f8)
    FIELD(POR_MPU_M0_PRLAR14_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR14_U_SMXP_3_0, REGION14_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR14_U_SMXP_3_0, REGION14_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR15_U_SMXP_3_0, 0x183d100)
    FIELD(POR_MPU_M0_PRBAR15_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR15_U_SMXP_3_0, REGION15_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR15_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR15_U_SMXP_3_0, REGION15_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR15_U_SMXP_3_0, REGION15_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR15_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR15_U_SMXP_3_0, 0x183d108)
    FIELD(POR_MPU_M0_PRLAR15_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR15_U_SMXP_3_0, REGION15_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR15_U_SMXP_3_0, REGION15_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR16_U_SMXP_3_0, 0x183d110)
    FIELD(POR_MPU_M0_PRBAR16_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR16_U_SMXP_3_0, REGION16_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR16_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR16_U_SMXP_3_0, REGION16_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR16_U_SMXP_3_0, REGION16_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR16_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR16_U_SMXP_3_0, 0x183d118)
    FIELD(POR_MPU_M0_PRLAR16_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR16_U_SMXP_3_0, REGION16_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR16_U_SMXP_3_0, REGION16_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR17_U_SMXP_3_0, 0x183d120)
    FIELD(POR_MPU_M0_PRBAR17_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR17_U_SMXP_3_0, REGION17_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR17_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR17_U_SMXP_3_0, REGION17_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR17_U_SMXP_3_0, REGION17_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR17_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR17_U_SMXP_3_0, 0x183d128)
    FIELD(POR_MPU_M0_PRLAR17_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR17_U_SMXP_3_0, REGION17_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR17_U_SMXP_3_0, REGION17_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR18_U_SMXP_3_0, 0x183d130)
    FIELD(POR_MPU_M0_PRBAR18_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR18_U_SMXP_3_0, REGION18_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR18_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR18_U_SMXP_3_0, REGION18_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR18_U_SMXP_3_0, REGION18_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR18_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR18_U_SMXP_3_0, 0x183d138)
    FIELD(POR_MPU_M0_PRLAR18_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR18_U_SMXP_3_0, REGION18_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR18_U_SMXP_3_0, REGION18_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR19_U_SMXP_3_0, 0x183d140)
    FIELD(POR_MPU_M0_PRBAR19_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR19_U_SMXP_3_0, REGION19_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR19_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR19_U_SMXP_3_0, REGION19_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR19_U_SMXP_3_0, REGION19_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR19_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR19_U_SMXP_3_0, 0x183d148)
    FIELD(POR_MPU_M0_PRLAR19_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR19_U_SMXP_3_0, REGION19_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR19_U_SMXP_3_0, REGION19_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR20_U_SMXP_3_0, 0x183d150)
    FIELD(POR_MPU_M0_PRBAR20_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR20_U_SMXP_3_0, REGION20_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR20_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR20_U_SMXP_3_0, REGION20_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR20_U_SMXP_3_0, REGION20_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR20_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR20_U_SMXP_3_0, 0x183d158)
    FIELD(POR_MPU_M0_PRLAR20_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR20_U_SMXP_3_0, REGION20_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR20_U_SMXP_3_0, REGION20_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR21_U_SMXP_3_0, 0x183d160)
    FIELD(POR_MPU_M0_PRBAR21_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR21_U_SMXP_3_0, REGION21_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR21_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR21_U_SMXP_3_0, REGION21_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR21_U_SMXP_3_0, REGION21_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR21_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR21_U_SMXP_3_0, 0x183d168)
    FIELD(POR_MPU_M0_PRLAR21_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR21_U_SMXP_3_0, REGION21_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR21_U_SMXP_3_0, REGION21_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR22_U_SMXP_3_0, 0x183d170)
    FIELD(POR_MPU_M0_PRBAR22_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR22_U_SMXP_3_0, REGION22_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR22_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR22_U_SMXP_3_0, REGION22_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR22_U_SMXP_3_0, REGION22_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR22_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR22_U_SMXP_3_0, 0x183d178)
    FIELD(POR_MPU_M0_PRLAR22_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR22_U_SMXP_3_0, REGION22_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR22_U_SMXP_3_0, REGION22_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR23_U_SMXP_3_0, 0x183d180)
    FIELD(POR_MPU_M0_PRBAR23_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR23_U_SMXP_3_0, REGION23_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR23_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR23_U_SMXP_3_0, REGION23_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR23_U_SMXP_3_0, REGION23_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR23_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR23_U_SMXP_3_0, 0x183d188)
    FIELD(POR_MPU_M0_PRLAR23_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR23_U_SMXP_3_0, REGION23_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR23_U_SMXP_3_0, REGION23_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR24_U_SMXP_3_0, 0x183d190)
    FIELD(POR_MPU_M0_PRBAR24_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR24_U_SMXP_3_0, REGION24_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR24_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR24_U_SMXP_3_0, REGION24_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR24_U_SMXP_3_0, REGION24_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR24_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR24_U_SMXP_3_0, 0x183d198)
    FIELD(POR_MPU_M0_PRLAR24_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR24_U_SMXP_3_0, REGION24_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR24_U_SMXP_3_0, REGION24_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR25_U_SMXP_3_0, 0x183d1a0)
    FIELD(POR_MPU_M0_PRBAR25_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR25_U_SMXP_3_0, REGION25_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR25_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR25_U_SMXP_3_0, REGION25_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR25_U_SMXP_3_0, REGION25_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR25_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR25_U_SMXP_3_0, 0x183d1a8)
    FIELD(POR_MPU_M0_PRLAR25_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR25_U_SMXP_3_0, REGION25_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR25_U_SMXP_3_0, REGION25_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR26_U_SMXP_3_0, 0x183d1b0)
    FIELD(POR_MPU_M0_PRBAR26_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR26_U_SMXP_3_0, REGION26_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR26_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR26_U_SMXP_3_0, REGION26_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR26_U_SMXP_3_0, REGION26_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR26_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR26_U_SMXP_3_0, 0x183d1b8)
    FIELD(POR_MPU_M0_PRLAR26_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR26_U_SMXP_3_0, REGION26_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR26_U_SMXP_3_0, REGION26_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR27_U_SMXP_3_0, 0x183d1c0)
    FIELD(POR_MPU_M0_PRBAR27_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR27_U_SMXP_3_0, REGION27_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR27_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR27_U_SMXP_3_0, REGION27_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR27_U_SMXP_3_0, REGION27_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR27_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR27_U_SMXP_3_0, 0x183d1c8)
    FIELD(POR_MPU_M0_PRLAR27_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR27_U_SMXP_3_0, REGION27_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR27_U_SMXP_3_0, REGION27_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR28_U_SMXP_3_0, 0x183d1d0)
    FIELD(POR_MPU_M0_PRBAR28_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR28_U_SMXP_3_0, REGION28_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR28_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR28_U_SMXP_3_0, REGION28_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR28_U_SMXP_3_0, REGION28_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR28_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR28_U_SMXP_3_0, 0x183d1d8)
    FIELD(POR_MPU_M0_PRLAR28_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR28_U_SMXP_3_0, REGION28_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR28_U_SMXP_3_0, REGION28_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR29_U_SMXP_3_0, 0x183d1e0)
    FIELD(POR_MPU_M0_PRBAR29_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR29_U_SMXP_3_0, REGION29_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR29_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR29_U_SMXP_3_0, REGION29_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR29_U_SMXP_3_0, REGION29_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR29_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR29_U_SMXP_3_0, 0x183d1e8)
    FIELD(POR_MPU_M0_PRLAR29_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR29_U_SMXP_3_0, REGION29_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR29_U_SMXP_3_0, REGION29_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR30_U_SMXP_3_0, 0x183d1f0)
    FIELD(POR_MPU_M0_PRBAR30_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR30_U_SMXP_3_0, REGION30_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR30_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR30_U_SMXP_3_0, REGION30_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR30_U_SMXP_3_0, REGION30_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR30_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR30_U_SMXP_3_0, 0x183d1f8)
    FIELD(POR_MPU_M0_PRLAR30_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR30_U_SMXP_3_0, REGION30_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR30_U_SMXP_3_0, REGION30_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR31_U_SMXP_3_0, 0x183d200)
    FIELD(POR_MPU_M0_PRBAR31_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR31_U_SMXP_3_0, REGION31_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR31_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR31_U_SMXP_3_0, REGION31_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR31_U_SMXP_3_0, REGION31_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR31_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR31_U_SMXP_3_0, 0x183d208)
    FIELD(POR_MPU_M0_PRLAR31_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR31_U_SMXP_3_0, REGION31_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR31_U_SMXP_3_0, REGION31_EN, 0, 1)
REG32(POR_MPU_M1_CTL_U_SMXP_3_0, 0x183d400)
    FIELD(POR_MPU_M1_CTL_U_SMXP_3_0, M1_EN, 2, 1)
    FIELD(POR_MPU_M1_CTL_U_SMXP_3_0, M1_ACTION, 0, 2)
REG32(POR_MPU_M1_PRBAR0_U_SMXP_3_0, 0x183d410)
    FIELD(POR_MPU_M1_PRBAR0_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR0_U_SMXP_3_0, REGION0_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR0_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR0_U_SMXP_3_0, REGION0_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR0_U_SMXP_3_0, REGION0_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR0_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR0_U_SMXP_3_0, 0x183d418)
    FIELD(POR_MPU_M1_PRLAR0_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR0_U_SMXP_3_0, REGION0_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR0_U_SMXP_3_0, REGION0_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR1_U_SMXP_3_0, 0x183d420)
    FIELD(POR_MPU_M1_PRBAR1_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR1_U_SMXP_3_0, REGION1_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR1_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR1_U_SMXP_3_0, REGION1_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR1_U_SMXP_3_0, REGION1_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR1_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR1_U_SMXP_3_0, 0x183d428)
    FIELD(POR_MPU_M1_PRLAR1_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR1_U_SMXP_3_0, REGION1_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR1_U_SMXP_3_0, REGION1_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR2_U_SMXP_3_0, 0x183d430)
    FIELD(POR_MPU_M1_PRBAR2_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR2_U_SMXP_3_0, REGION2_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR2_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR2_U_SMXP_3_0, REGION2_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR2_U_SMXP_3_0, REGION2_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR2_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR2_U_SMXP_3_0, 0x183d438)
    FIELD(POR_MPU_M1_PRLAR2_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR2_U_SMXP_3_0, REGION2_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR2_U_SMXP_3_0, REGION2_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR3_U_SMXP_3_0, 0x183d440)
    FIELD(POR_MPU_M1_PRBAR3_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR3_U_SMXP_3_0, REGION3_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR3_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR3_U_SMXP_3_0, REGION3_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR3_U_SMXP_3_0, REGION3_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR3_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR3_U_SMXP_3_0, 0x183d448)
    FIELD(POR_MPU_M1_PRLAR3_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR3_U_SMXP_3_0, REGION3_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR3_U_SMXP_3_0, REGION3_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR4_U_SMXP_3_0, 0x183d450)
    FIELD(POR_MPU_M1_PRBAR4_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR4_U_SMXP_3_0, REGION4_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR4_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR4_U_SMXP_3_0, REGION4_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR4_U_SMXP_3_0, REGION4_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR4_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR4_U_SMXP_3_0, 0x183d458)
    FIELD(POR_MPU_M1_PRLAR4_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR4_U_SMXP_3_0, REGION4_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR4_U_SMXP_3_0, REGION4_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR5_U_SMXP_3_0, 0x183d460)
    FIELD(POR_MPU_M1_PRBAR5_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR5_U_SMXP_3_0, REGION5_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR5_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR5_U_SMXP_3_0, REGION5_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR5_U_SMXP_3_0, REGION5_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR5_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR5_U_SMXP_3_0, 0x183d468)
    FIELD(POR_MPU_M1_PRLAR5_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR5_U_SMXP_3_0, REGION5_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR5_U_SMXP_3_0, REGION5_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR6_U_SMXP_3_0, 0x183d470)
    FIELD(POR_MPU_M1_PRBAR6_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR6_U_SMXP_3_0, REGION6_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR6_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR6_U_SMXP_3_0, REGION6_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR6_U_SMXP_3_0, REGION6_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR6_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR6_U_SMXP_3_0, 0x183d478)
    FIELD(POR_MPU_M1_PRLAR6_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR6_U_SMXP_3_0, REGION6_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR6_U_SMXP_3_0, REGION6_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR7_U_SMXP_3_0, 0x183d480)
    FIELD(POR_MPU_M1_PRBAR7_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR7_U_SMXP_3_0, REGION7_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR7_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR7_U_SMXP_3_0, REGION7_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR7_U_SMXP_3_0, REGION7_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR7_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR7_U_SMXP_3_0, 0x183d488)
    FIELD(POR_MPU_M1_PRLAR7_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR7_U_SMXP_3_0, REGION7_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR7_U_SMXP_3_0, REGION7_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR8_U_SMXP_3_0, 0x183d490)
    FIELD(POR_MPU_M1_PRBAR8_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR8_U_SMXP_3_0, REGION8_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR8_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR8_U_SMXP_3_0, REGION8_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR8_U_SMXP_3_0, REGION8_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR8_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR8_U_SMXP_3_0, 0x183d498)
    FIELD(POR_MPU_M1_PRLAR8_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR8_U_SMXP_3_0, REGION8_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR8_U_SMXP_3_0, REGION8_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR9_U_SMXP_3_0, 0x183d4a0)
    FIELD(POR_MPU_M1_PRBAR9_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR9_U_SMXP_3_0, REGION9_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR9_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR9_U_SMXP_3_0, REGION9_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR9_U_SMXP_3_0, REGION9_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR9_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR9_U_SMXP_3_0, 0x183d4a8)
    FIELD(POR_MPU_M1_PRLAR9_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR9_U_SMXP_3_0, REGION9_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR9_U_SMXP_3_0, REGION9_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR10_U_SMXP_3_0, 0x183d4b0)
    FIELD(POR_MPU_M1_PRBAR10_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR10_U_SMXP_3_0, REGION10_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR10_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR10_U_SMXP_3_0, REGION10_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR10_U_SMXP_3_0, REGION10_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR10_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR10_U_SMXP_3_0, 0x183d4b8)
    FIELD(POR_MPU_M1_PRLAR10_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR10_U_SMXP_3_0, REGION10_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR10_U_SMXP_3_0, REGION10_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR11_U_SMXP_3_0, 0x183d4c0)
    FIELD(POR_MPU_M1_PRBAR11_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR11_U_SMXP_3_0, REGION11_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR11_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR11_U_SMXP_3_0, REGION11_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR11_U_SMXP_3_0, REGION11_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR11_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR11_U_SMXP_3_0, 0x183d4c8)
    FIELD(POR_MPU_M1_PRLAR11_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR11_U_SMXP_3_0, REGION11_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR11_U_SMXP_3_0, REGION11_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR12_U_SMXP_3_0, 0x183d4d0)
    FIELD(POR_MPU_M1_PRBAR12_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR12_U_SMXP_3_0, REGION12_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR12_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR12_U_SMXP_3_0, REGION12_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR12_U_SMXP_3_0, REGION12_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR12_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR12_U_SMXP_3_0, 0x183d4d8)
    FIELD(POR_MPU_M1_PRLAR12_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR12_U_SMXP_3_0, REGION12_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR12_U_SMXP_3_0, REGION12_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR13_U_SMXP_3_0, 0x183d4e0)
    FIELD(POR_MPU_M1_PRBAR13_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR13_U_SMXP_3_0, REGION13_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR13_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR13_U_SMXP_3_0, REGION13_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR13_U_SMXP_3_0, REGION13_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR13_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR13_U_SMXP_3_0, 0x183d4e8)
    FIELD(POR_MPU_M1_PRLAR13_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR13_U_SMXP_3_0, REGION13_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR13_U_SMXP_3_0, REGION13_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR14_U_SMXP_3_0, 0x183d4f0)
    FIELD(POR_MPU_M1_PRBAR14_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR14_U_SMXP_3_0, REGION14_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR14_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR14_U_SMXP_3_0, REGION14_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR14_U_SMXP_3_0, REGION14_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR14_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR14_U_SMXP_3_0, 0x183d4f8)
    FIELD(POR_MPU_M1_PRLAR14_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR14_U_SMXP_3_0, REGION14_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR14_U_SMXP_3_0, REGION14_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR15_U_SMXP_3_0, 0x183d500)
    FIELD(POR_MPU_M1_PRBAR15_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR15_U_SMXP_3_0, REGION15_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR15_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR15_U_SMXP_3_0, REGION15_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR15_U_SMXP_3_0, REGION15_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR15_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR15_U_SMXP_3_0, 0x183d508)
    FIELD(POR_MPU_M1_PRLAR15_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR15_U_SMXP_3_0, REGION15_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR15_U_SMXP_3_0, REGION15_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR16_U_SMXP_3_0, 0x183d510)
    FIELD(POR_MPU_M1_PRBAR16_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR16_U_SMXP_3_0, REGION16_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR16_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR16_U_SMXP_3_0, REGION16_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR16_U_SMXP_3_0, REGION16_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR16_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR16_U_SMXP_3_0, 0x183d518)
    FIELD(POR_MPU_M1_PRLAR16_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR16_U_SMXP_3_0, REGION16_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR16_U_SMXP_3_0, REGION16_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR17_U_SMXP_3_0, 0x183d520)
    FIELD(POR_MPU_M1_PRBAR17_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR17_U_SMXP_3_0, REGION17_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR17_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR17_U_SMXP_3_0, REGION17_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR17_U_SMXP_3_0, REGION17_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR17_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR17_U_SMXP_3_0, 0x183d528)
    FIELD(POR_MPU_M1_PRLAR17_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR17_U_SMXP_3_0, REGION17_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR17_U_SMXP_3_0, REGION17_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR18_U_SMXP_3_0, 0x183d530)
    FIELD(POR_MPU_M1_PRBAR18_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR18_U_SMXP_3_0, REGION18_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR18_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR18_U_SMXP_3_0, REGION18_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR18_U_SMXP_3_0, REGION18_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR18_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR18_U_SMXP_3_0, 0x183d538)
    FIELD(POR_MPU_M1_PRLAR18_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR18_U_SMXP_3_0, REGION18_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR18_U_SMXP_3_0, REGION18_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR19_U_SMXP_3_0, 0x183d540)
    FIELD(POR_MPU_M1_PRBAR19_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR19_U_SMXP_3_0, REGION19_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR19_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR19_U_SMXP_3_0, REGION19_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR19_U_SMXP_3_0, REGION19_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR19_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR19_U_SMXP_3_0, 0x183d548)
    FIELD(POR_MPU_M1_PRLAR19_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR19_U_SMXP_3_0, REGION19_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR19_U_SMXP_3_0, REGION19_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR20_U_SMXP_3_0, 0x183d550)
    FIELD(POR_MPU_M1_PRBAR20_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR20_U_SMXP_3_0, REGION20_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR20_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR20_U_SMXP_3_0, REGION20_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR20_U_SMXP_3_0, REGION20_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR20_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR20_U_SMXP_3_0, 0x183d558)
    FIELD(POR_MPU_M1_PRLAR20_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR20_U_SMXP_3_0, REGION20_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR20_U_SMXP_3_0, REGION20_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR21_U_SMXP_3_0, 0x183d560)
    FIELD(POR_MPU_M1_PRBAR21_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR21_U_SMXP_3_0, REGION21_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR21_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR21_U_SMXP_3_0, REGION21_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR21_U_SMXP_3_0, REGION21_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR21_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR21_U_SMXP_3_0, 0x183d568)
    FIELD(POR_MPU_M1_PRLAR21_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR21_U_SMXP_3_0, REGION21_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR21_U_SMXP_3_0, REGION21_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR22_U_SMXP_3_0, 0x183d570)
    FIELD(POR_MPU_M1_PRBAR22_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR22_U_SMXP_3_0, REGION22_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR22_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR22_U_SMXP_3_0, REGION22_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR22_U_SMXP_3_0, REGION22_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR22_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR22_U_SMXP_3_0, 0x183d578)
    FIELD(POR_MPU_M1_PRLAR22_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR22_U_SMXP_3_0, REGION22_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR22_U_SMXP_3_0, REGION22_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR23_U_SMXP_3_0, 0x183d580)
    FIELD(POR_MPU_M1_PRBAR23_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR23_U_SMXP_3_0, REGION23_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR23_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR23_U_SMXP_3_0, REGION23_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR23_U_SMXP_3_0, REGION23_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR23_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR23_U_SMXP_3_0, 0x183d588)
    FIELD(POR_MPU_M1_PRLAR23_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR23_U_SMXP_3_0, REGION23_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR23_U_SMXP_3_0, REGION23_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR24_U_SMXP_3_0, 0x183d590)
    FIELD(POR_MPU_M1_PRBAR24_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR24_U_SMXP_3_0, REGION24_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR24_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR24_U_SMXP_3_0, REGION24_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR24_U_SMXP_3_0, REGION24_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR24_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR24_U_SMXP_3_0, 0x183d598)
    FIELD(POR_MPU_M1_PRLAR24_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR24_U_SMXP_3_0, REGION24_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR24_U_SMXP_3_0, REGION24_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR25_U_SMXP_3_0, 0x183d5a0)
    FIELD(POR_MPU_M1_PRBAR25_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR25_U_SMXP_3_0, REGION25_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR25_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR25_U_SMXP_3_0, REGION25_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR25_U_SMXP_3_0, REGION25_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR25_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR25_U_SMXP_3_0, 0x183d5a8)
    FIELD(POR_MPU_M1_PRLAR25_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR25_U_SMXP_3_0, REGION25_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR25_U_SMXP_3_0, REGION25_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR26_U_SMXP_3_0, 0x183d5b0)
    FIELD(POR_MPU_M1_PRBAR26_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR26_U_SMXP_3_0, REGION26_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR26_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR26_U_SMXP_3_0, REGION26_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR26_U_SMXP_3_0, REGION26_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR26_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR26_U_SMXP_3_0, 0x183d5b8)
    FIELD(POR_MPU_M1_PRLAR26_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR26_U_SMXP_3_0, REGION26_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR26_U_SMXP_3_0, REGION26_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR27_U_SMXP_3_0, 0x183d5c0)
    FIELD(POR_MPU_M1_PRBAR27_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR27_U_SMXP_3_0, REGION27_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR27_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR27_U_SMXP_3_0, REGION27_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR27_U_SMXP_3_0, REGION27_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR27_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR27_U_SMXP_3_0, 0x183d5c8)
    FIELD(POR_MPU_M1_PRLAR27_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR27_U_SMXP_3_0, REGION27_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR27_U_SMXP_3_0, REGION27_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR28_U_SMXP_3_0, 0x183d5d0)
    FIELD(POR_MPU_M1_PRBAR28_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR28_U_SMXP_3_0, REGION28_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR28_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR28_U_SMXP_3_0, REGION28_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR28_U_SMXP_3_0, REGION28_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR28_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR28_U_SMXP_3_0, 0x183d5d8)
    FIELD(POR_MPU_M1_PRLAR28_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR28_U_SMXP_3_0, REGION28_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR28_U_SMXP_3_0, REGION28_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR29_U_SMXP_3_0, 0x183d5e0)
    FIELD(POR_MPU_M1_PRBAR29_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR29_U_SMXP_3_0, REGION29_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR29_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR29_U_SMXP_3_0, REGION29_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR29_U_SMXP_3_0, REGION29_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR29_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR29_U_SMXP_3_0, 0x183d5e8)
    FIELD(POR_MPU_M1_PRLAR29_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR29_U_SMXP_3_0, REGION29_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR29_U_SMXP_3_0, REGION29_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR30_U_SMXP_3_0, 0x183d5f0)
    FIELD(POR_MPU_M1_PRBAR30_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR30_U_SMXP_3_0, REGION30_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR30_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR30_U_SMXP_3_0, REGION30_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR30_U_SMXP_3_0, REGION30_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR30_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR30_U_SMXP_3_0, 0x183d5f8)
    FIELD(POR_MPU_M1_PRLAR30_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR30_U_SMXP_3_0, REGION30_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR30_U_SMXP_3_0, REGION30_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR31_U_SMXP_3_0, 0x183d600)
    FIELD(POR_MPU_M1_PRBAR31_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR31_U_SMXP_3_0, REGION31_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR31_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR31_U_SMXP_3_0, REGION31_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR31_U_SMXP_3_0, REGION31_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR31_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR31_U_SMXP_3_0, 0x183d608)
    FIELD(POR_MPU_M1_PRLAR31_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR31_U_SMXP_3_0, REGION31_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR31_U_SMXP_3_0, REGION31_EN, 0, 1)
REG32(POR_MPU_M2_CTL_U_SMXP_3_0, 0x183d800)
    FIELD(POR_MPU_M2_CTL_U_SMXP_3_0, M2_EN, 2, 1)
    FIELD(POR_MPU_M2_CTL_U_SMXP_3_0, M2_ACTION, 0, 2)
REG32(POR_MPU_M2_PRBAR0_U_SMXP_3_0, 0x183d810)
    FIELD(POR_MPU_M2_PRBAR0_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR0_U_SMXP_3_0, REGION0_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR0_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR0_U_SMXP_3_0, REGION0_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR0_U_SMXP_3_0, REGION0_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR0_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR0_U_SMXP_3_0, 0x183d818)
    FIELD(POR_MPU_M2_PRLAR0_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR0_U_SMXP_3_0, REGION0_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR0_U_SMXP_3_0, REGION0_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR1_U_SMXP_3_0, 0x183d820)
    FIELD(POR_MPU_M2_PRBAR1_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR1_U_SMXP_3_0, REGION1_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR1_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR1_U_SMXP_3_0, REGION1_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR1_U_SMXP_3_0, REGION1_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR1_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR1_U_SMXP_3_0, 0x183d828)
    FIELD(POR_MPU_M2_PRLAR1_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR1_U_SMXP_3_0, REGION1_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR1_U_SMXP_3_0, REGION1_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR2_U_SMXP_3_0, 0x183d830)
    FIELD(POR_MPU_M2_PRBAR2_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR2_U_SMXP_3_0, REGION2_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR2_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR2_U_SMXP_3_0, REGION2_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR2_U_SMXP_3_0, REGION2_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR2_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR2_U_SMXP_3_0, 0x183d838)
    FIELD(POR_MPU_M2_PRLAR2_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR2_U_SMXP_3_0, REGION2_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR2_U_SMXP_3_0, REGION2_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR3_U_SMXP_3_0, 0x183d840)
    FIELD(POR_MPU_M2_PRBAR3_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR3_U_SMXP_3_0, REGION3_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR3_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR3_U_SMXP_3_0, REGION3_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR3_U_SMXP_3_0, REGION3_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR3_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR3_U_SMXP_3_0, 0x183d848)
    FIELD(POR_MPU_M2_PRLAR3_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR3_U_SMXP_3_0, REGION3_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR3_U_SMXP_3_0, REGION3_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR4_U_SMXP_3_0, 0x183d850)
    FIELD(POR_MPU_M2_PRBAR4_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR4_U_SMXP_3_0, REGION4_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR4_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR4_U_SMXP_3_0, REGION4_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR4_U_SMXP_3_0, REGION4_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR4_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR4_U_SMXP_3_0, 0x183d858)
    FIELD(POR_MPU_M2_PRLAR4_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR4_U_SMXP_3_0, REGION4_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR4_U_SMXP_3_0, REGION4_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR5_U_SMXP_3_0, 0x183d860)
    FIELD(POR_MPU_M2_PRBAR5_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR5_U_SMXP_3_0, REGION5_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR5_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR5_U_SMXP_3_0, REGION5_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR5_U_SMXP_3_0, REGION5_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR5_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR5_U_SMXP_3_0, 0x183d868)
    FIELD(POR_MPU_M2_PRLAR5_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR5_U_SMXP_3_0, REGION5_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR5_U_SMXP_3_0, REGION5_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR6_U_SMXP_3_0, 0x183d870)
    FIELD(POR_MPU_M2_PRBAR6_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR6_U_SMXP_3_0, REGION6_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR6_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR6_U_SMXP_3_0, REGION6_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR6_U_SMXP_3_0, REGION6_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR6_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR6_U_SMXP_3_0, 0x183d878)
    FIELD(POR_MPU_M2_PRLAR6_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR6_U_SMXP_3_0, REGION6_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR6_U_SMXP_3_0, REGION6_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR7_U_SMXP_3_0, 0x183d880)
    FIELD(POR_MPU_M2_PRBAR7_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR7_U_SMXP_3_0, REGION7_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR7_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR7_U_SMXP_3_0, REGION7_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR7_U_SMXP_3_0, REGION7_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR7_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR7_U_SMXP_3_0, 0x183d888)
    FIELD(POR_MPU_M2_PRLAR7_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR7_U_SMXP_3_0, REGION7_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR7_U_SMXP_3_0, REGION7_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR8_U_SMXP_3_0, 0x183d890)
    FIELD(POR_MPU_M2_PRBAR8_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR8_U_SMXP_3_0, REGION8_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR8_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR8_U_SMXP_3_0, REGION8_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR8_U_SMXP_3_0, REGION8_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR8_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR8_U_SMXP_3_0, 0x183d898)
    FIELD(POR_MPU_M2_PRLAR8_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR8_U_SMXP_3_0, REGION8_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR8_U_SMXP_3_0, REGION8_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR9_U_SMXP_3_0, 0x183d8a0)
    FIELD(POR_MPU_M2_PRBAR9_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR9_U_SMXP_3_0, REGION9_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR9_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR9_U_SMXP_3_0, REGION9_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR9_U_SMXP_3_0, REGION9_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR9_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR9_U_SMXP_3_0, 0x183d8a8)
    FIELD(POR_MPU_M2_PRLAR9_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR9_U_SMXP_3_0, REGION9_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR9_U_SMXP_3_0, REGION9_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR10_U_SMXP_3_0, 0x183d8b0)
    FIELD(POR_MPU_M2_PRBAR10_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR10_U_SMXP_3_0, REGION10_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR10_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR10_U_SMXP_3_0, REGION10_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR10_U_SMXP_3_0, REGION10_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR10_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR10_U_SMXP_3_0, 0x183d8b8)
    FIELD(POR_MPU_M2_PRLAR10_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR10_U_SMXP_3_0, REGION10_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR10_U_SMXP_3_0, REGION10_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR11_U_SMXP_3_0, 0x183d8c0)
    FIELD(POR_MPU_M2_PRBAR11_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR11_U_SMXP_3_0, REGION11_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR11_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR11_U_SMXP_3_0, REGION11_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR11_U_SMXP_3_0, REGION11_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR11_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR11_U_SMXP_3_0, 0x183d8c8)
    FIELD(POR_MPU_M2_PRLAR11_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR11_U_SMXP_3_0, REGION11_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR11_U_SMXP_3_0, REGION11_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR12_U_SMXP_3_0, 0x183d8d0)
    FIELD(POR_MPU_M2_PRBAR12_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR12_U_SMXP_3_0, REGION12_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR12_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR12_U_SMXP_3_0, REGION12_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR12_U_SMXP_3_0, REGION12_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR12_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR12_U_SMXP_3_0, 0x183d8d8)
    FIELD(POR_MPU_M2_PRLAR12_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR12_U_SMXP_3_0, REGION12_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR12_U_SMXP_3_0, REGION12_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR13_U_SMXP_3_0, 0x183d8e0)
    FIELD(POR_MPU_M2_PRBAR13_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR13_U_SMXP_3_0, REGION13_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR13_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR13_U_SMXP_3_0, REGION13_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR13_U_SMXP_3_0, REGION13_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR13_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR13_U_SMXP_3_0, 0x183d8e8)
    FIELD(POR_MPU_M2_PRLAR13_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR13_U_SMXP_3_0, REGION13_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR13_U_SMXP_3_0, REGION13_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR14_U_SMXP_3_0, 0x183d8f0)
    FIELD(POR_MPU_M2_PRBAR14_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR14_U_SMXP_3_0, REGION14_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR14_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR14_U_SMXP_3_0, REGION14_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR14_U_SMXP_3_0, REGION14_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR14_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR14_U_SMXP_3_0, 0x183d8f8)
    FIELD(POR_MPU_M2_PRLAR14_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR14_U_SMXP_3_0, REGION14_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR14_U_SMXP_3_0, REGION14_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR15_U_SMXP_3_0, 0x183d900)
    FIELD(POR_MPU_M2_PRBAR15_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR15_U_SMXP_3_0, REGION15_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR15_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR15_U_SMXP_3_0, REGION15_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR15_U_SMXP_3_0, REGION15_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR15_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR15_U_SMXP_3_0, 0x183d908)
    FIELD(POR_MPU_M2_PRLAR15_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR15_U_SMXP_3_0, REGION15_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR15_U_SMXP_3_0, REGION15_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR16_U_SMXP_3_0, 0x183d910)
    FIELD(POR_MPU_M2_PRBAR16_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR16_U_SMXP_3_0, REGION16_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR16_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR16_U_SMXP_3_0, REGION16_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR16_U_SMXP_3_0, REGION16_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR16_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR16_U_SMXP_3_0, 0x183d918)
    FIELD(POR_MPU_M2_PRLAR16_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR16_U_SMXP_3_0, REGION16_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR16_U_SMXP_3_0, REGION16_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR17_U_SMXP_3_0, 0x183d920)
    FIELD(POR_MPU_M2_PRBAR17_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR17_U_SMXP_3_0, REGION17_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR17_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR17_U_SMXP_3_0, REGION17_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR17_U_SMXP_3_0, REGION17_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR17_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR17_U_SMXP_3_0, 0x183d928)
    FIELD(POR_MPU_M2_PRLAR17_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR17_U_SMXP_3_0, REGION17_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR17_U_SMXP_3_0, REGION17_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR18_U_SMXP_3_0, 0x183d930)
    FIELD(POR_MPU_M2_PRBAR18_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR18_U_SMXP_3_0, REGION18_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR18_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR18_U_SMXP_3_0, REGION18_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR18_U_SMXP_3_0, REGION18_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR18_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR18_U_SMXP_3_0, 0x183d938)
    FIELD(POR_MPU_M2_PRLAR18_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR18_U_SMXP_3_0, REGION18_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR18_U_SMXP_3_0, REGION18_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR19_U_SMXP_3_0, 0x183d940)
    FIELD(POR_MPU_M2_PRBAR19_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR19_U_SMXP_3_0, REGION19_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR19_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR19_U_SMXP_3_0, REGION19_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR19_U_SMXP_3_0, REGION19_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR19_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR19_U_SMXP_3_0, 0x183d948)
    FIELD(POR_MPU_M2_PRLAR19_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR19_U_SMXP_3_0, REGION19_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR19_U_SMXP_3_0, REGION19_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR20_U_SMXP_3_0, 0x183d950)
    FIELD(POR_MPU_M2_PRBAR20_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR20_U_SMXP_3_0, REGION20_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR20_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR20_U_SMXP_3_0, REGION20_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR20_U_SMXP_3_0, REGION20_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR20_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR20_U_SMXP_3_0, 0x183d958)
    FIELD(POR_MPU_M2_PRLAR20_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR20_U_SMXP_3_0, REGION20_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR20_U_SMXP_3_0, REGION20_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR21_U_SMXP_3_0, 0x183d960)
    FIELD(POR_MPU_M2_PRBAR21_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR21_U_SMXP_3_0, REGION21_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR21_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR21_U_SMXP_3_0, REGION21_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR21_U_SMXP_3_0, REGION21_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR21_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR21_U_SMXP_3_0, 0x183d968)
    FIELD(POR_MPU_M2_PRLAR21_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR21_U_SMXP_3_0, REGION21_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR21_U_SMXP_3_0, REGION21_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR22_U_SMXP_3_0, 0x183d970)
    FIELD(POR_MPU_M2_PRBAR22_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR22_U_SMXP_3_0, REGION22_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR22_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR22_U_SMXP_3_0, REGION22_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR22_U_SMXP_3_0, REGION22_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR22_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR22_U_SMXP_3_0, 0x183d978)
    FIELD(POR_MPU_M2_PRLAR22_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR22_U_SMXP_3_0, REGION22_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR22_U_SMXP_3_0, REGION22_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR23_U_SMXP_3_0, 0x183d980)
    FIELD(POR_MPU_M2_PRBAR23_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR23_U_SMXP_3_0, REGION23_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR23_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR23_U_SMXP_3_0, REGION23_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR23_U_SMXP_3_0, REGION23_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR23_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR23_U_SMXP_3_0, 0x183d988)
    FIELD(POR_MPU_M2_PRLAR23_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR23_U_SMXP_3_0, REGION23_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR23_U_SMXP_3_0, REGION23_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR24_U_SMXP_3_0, 0x183d990)
    FIELD(POR_MPU_M2_PRBAR24_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR24_U_SMXP_3_0, REGION24_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR24_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR24_U_SMXP_3_0, REGION24_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR24_U_SMXP_3_0, REGION24_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR24_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR24_U_SMXP_3_0, 0x183d998)
    FIELD(POR_MPU_M2_PRLAR24_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR24_U_SMXP_3_0, REGION24_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR24_U_SMXP_3_0, REGION24_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR25_U_SMXP_3_0, 0x183d9a0)
    FIELD(POR_MPU_M2_PRBAR25_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR25_U_SMXP_3_0, REGION25_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR25_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR25_U_SMXP_3_0, REGION25_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR25_U_SMXP_3_0, REGION25_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR25_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR25_U_SMXP_3_0, 0x183d9a8)
    FIELD(POR_MPU_M2_PRLAR25_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR25_U_SMXP_3_0, REGION25_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR25_U_SMXP_3_0, REGION25_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR26_U_SMXP_3_0, 0x183d9b0)
    FIELD(POR_MPU_M2_PRBAR26_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR26_U_SMXP_3_0, REGION26_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR26_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR26_U_SMXP_3_0, REGION26_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR26_U_SMXP_3_0, REGION26_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR26_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR26_U_SMXP_3_0, 0x183d9b8)
    FIELD(POR_MPU_M2_PRLAR26_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR26_U_SMXP_3_0, REGION26_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR26_U_SMXP_3_0, REGION26_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR27_U_SMXP_3_0, 0x183d9c0)
    FIELD(POR_MPU_M2_PRBAR27_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR27_U_SMXP_3_0, REGION27_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR27_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR27_U_SMXP_3_0, REGION27_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR27_U_SMXP_3_0, REGION27_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR27_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR27_U_SMXP_3_0, 0x183d9c8)
    FIELD(POR_MPU_M2_PRLAR27_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR27_U_SMXP_3_0, REGION27_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR27_U_SMXP_3_0, REGION27_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR28_U_SMXP_3_0, 0x183d9d0)
    FIELD(POR_MPU_M2_PRBAR28_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR28_U_SMXP_3_0, REGION28_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR28_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR28_U_SMXP_3_0, REGION28_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR28_U_SMXP_3_0, REGION28_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR28_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR28_U_SMXP_3_0, 0x183d9d8)
    FIELD(POR_MPU_M2_PRLAR28_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR28_U_SMXP_3_0, REGION28_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR28_U_SMXP_3_0, REGION28_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR29_U_SMXP_3_0, 0x183d9e0)
    FIELD(POR_MPU_M2_PRBAR29_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR29_U_SMXP_3_0, REGION29_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR29_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR29_U_SMXP_3_0, REGION29_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR29_U_SMXP_3_0, REGION29_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR29_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR29_U_SMXP_3_0, 0x183d9e8)
    FIELD(POR_MPU_M2_PRLAR29_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR29_U_SMXP_3_0, REGION29_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR29_U_SMXP_3_0, REGION29_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR30_U_SMXP_3_0, 0x183d9f0)
    FIELD(POR_MPU_M2_PRBAR30_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR30_U_SMXP_3_0, REGION30_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR30_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR30_U_SMXP_3_0, REGION30_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR30_U_SMXP_3_0, REGION30_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR30_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR30_U_SMXP_3_0, 0x183d9f8)
    FIELD(POR_MPU_M2_PRLAR30_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR30_U_SMXP_3_0, REGION30_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR30_U_SMXP_3_0, REGION30_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR31_U_SMXP_3_0, 0x183da00)
    FIELD(POR_MPU_M2_PRBAR31_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR31_U_SMXP_3_0, REGION31_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR31_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR31_U_SMXP_3_0, REGION31_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR31_U_SMXP_3_0, REGION31_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR31_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR31_U_SMXP_3_0, 0x183da08)
    FIELD(POR_MPU_M2_PRLAR31_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR31_U_SMXP_3_0, REGION31_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR31_U_SMXP_3_0, REGION31_EN, 0, 1)
REG32(POR_MPU_M3_CTL_U_SMXP_3_0, 0x183dc00)
    FIELD(POR_MPU_M3_CTL_U_SMXP_3_0, M3_EN, 2, 1)
    FIELD(POR_MPU_M3_CTL_U_SMXP_3_0, M3_ACTION, 0, 2)
REG32(POR_MPU_M3_PRBAR0_U_SMXP_3_0, 0x183dc10)
    FIELD(POR_MPU_M3_PRBAR0_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR0_U_SMXP_3_0, REGION0_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR0_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR0_U_SMXP_3_0, REGION0_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR0_U_SMXP_3_0, REGION0_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR0_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR0_U_SMXP_3_0, 0x183dc18)
    FIELD(POR_MPU_M3_PRLAR0_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR0_U_SMXP_3_0, REGION0_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR0_U_SMXP_3_0, REGION0_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR1_U_SMXP_3_0, 0x183dc20)
    FIELD(POR_MPU_M3_PRBAR1_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR1_U_SMXP_3_0, REGION1_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR1_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR1_U_SMXP_3_0, REGION1_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR1_U_SMXP_3_0, REGION1_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR1_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR1_U_SMXP_3_0, 0x183dc28)
    FIELD(POR_MPU_M3_PRLAR1_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR1_U_SMXP_3_0, REGION1_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR1_U_SMXP_3_0, REGION1_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR2_U_SMXP_3_0, 0x183dc30)
    FIELD(POR_MPU_M3_PRBAR2_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR2_U_SMXP_3_0, REGION2_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR2_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR2_U_SMXP_3_0, REGION2_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR2_U_SMXP_3_0, REGION2_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR2_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR2_U_SMXP_3_0, 0x183dc38)
    FIELD(POR_MPU_M3_PRLAR2_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR2_U_SMXP_3_0, REGION2_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR2_U_SMXP_3_0, REGION2_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR3_U_SMXP_3_0, 0x183dc40)
    FIELD(POR_MPU_M3_PRBAR3_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR3_U_SMXP_3_0, REGION3_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR3_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR3_U_SMXP_3_0, REGION3_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR3_U_SMXP_3_0, REGION3_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR3_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR3_U_SMXP_3_0, 0x183dc48)
    FIELD(POR_MPU_M3_PRLAR3_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR3_U_SMXP_3_0, REGION3_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR3_U_SMXP_3_0, REGION3_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR4_U_SMXP_3_0, 0x183dc50)
    FIELD(POR_MPU_M3_PRBAR4_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR4_U_SMXP_3_0, REGION4_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR4_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR4_U_SMXP_3_0, REGION4_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR4_U_SMXP_3_0, REGION4_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR4_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR4_U_SMXP_3_0, 0x183dc58)
    FIELD(POR_MPU_M3_PRLAR4_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR4_U_SMXP_3_0, REGION4_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR4_U_SMXP_3_0, REGION4_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR5_U_SMXP_3_0, 0x183dc60)
    FIELD(POR_MPU_M3_PRBAR5_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR5_U_SMXP_3_0, REGION5_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR5_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR5_U_SMXP_3_0, REGION5_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR5_U_SMXP_3_0, REGION5_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR5_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR5_U_SMXP_3_0, 0x183dc68)
    FIELD(POR_MPU_M3_PRLAR5_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR5_U_SMXP_3_0, REGION5_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR5_U_SMXP_3_0, REGION5_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR6_U_SMXP_3_0, 0x183dc70)
    FIELD(POR_MPU_M3_PRBAR6_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR6_U_SMXP_3_0, REGION6_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR6_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR6_U_SMXP_3_0, REGION6_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR6_U_SMXP_3_0, REGION6_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR6_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR6_U_SMXP_3_0, 0x183dc78)
    FIELD(POR_MPU_M3_PRLAR6_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR6_U_SMXP_3_0, REGION6_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR6_U_SMXP_3_0, REGION6_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR7_U_SMXP_3_0, 0x183dc80)
    FIELD(POR_MPU_M3_PRBAR7_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR7_U_SMXP_3_0, REGION7_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR7_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR7_U_SMXP_3_0, REGION7_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR7_U_SMXP_3_0, REGION7_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR7_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR7_U_SMXP_3_0, 0x183dc88)
    FIELD(POR_MPU_M3_PRLAR7_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR7_U_SMXP_3_0, REGION7_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR7_U_SMXP_3_0, REGION7_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR8_U_SMXP_3_0, 0x183dc90)
    FIELD(POR_MPU_M3_PRBAR8_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR8_U_SMXP_3_0, REGION8_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR8_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR8_U_SMXP_3_0, REGION8_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR8_U_SMXP_3_0, REGION8_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR8_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR8_U_SMXP_3_0, 0x183dc98)
    FIELD(POR_MPU_M3_PRLAR8_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR8_U_SMXP_3_0, REGION8_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR8_U_SMXP_3_0, REGION8_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR9_U_SMXP_3_0, 0x183dca0)
    FIELD(POR_MPU_M3_PRBAR9_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR9_U_SMXP_3_0, REGION9_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR9_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR9_U_SMXP_3_0, REGION9_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR9_U_SMXP_3_0, REGION9_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR9_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR9_U_SMXP_3_0, 0x183dca8)
    FIELD(POR_MPU_M3_PRLAR9_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR9_U_SMXP_3_0, REGION9_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR9_U_SMXP_3_0, REGION9_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR10_U_SMXP_3_0, 0x183dcb0)
    FIELD(POR_MPU_M3_PRBAR10_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR10_U_SMXP_3_0, REGION10_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR10_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR10_U_SMXP_3_0, REGION10_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR10_U_SMXP_3_0, REGION10_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR10_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR10_U_SMXP_3_0, 0x183dcb8)
    FIELD(POR_MPU_M3_PRLAR10_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR10_U_SMXP_3_0, REGION10_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR10_U_SMXP_3_0, REGION10_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR11_U_SMXP_3_0, 0x183dcc0)
    FIELD(POR_MPU_M3_PRBAR11_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR11_U_SMXP_3_0, REGION11_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR11_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR11_U_SMXP_3_0, REGION11_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR11_U_SMXP_3_0, REGION11_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR11_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR11_U_SMXP_3_0, 0x183dcc8)
    FIELD(POR_MPU_M3_PRLAR11_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR11_U_SMXP_3_0, REGION11_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR11_U_SMXP_3_0, REGION11_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR12_U_SMXP_3_0, 0x183dcd0)
    FIELD(POR_MPU_M3_PRBAR12_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR12_U_SMXP_3_0, REGION12_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR12_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR12_U_SMXP_3_0, REGION12_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR12_U_SMXP_3_0, REGION12_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR12_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR12_U_SMXP_3_0, 0x183dcd8)
    FIELD(POR_MPU_M3_PRLAR12_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR12_U_SMXP_3_0, REGION12_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR12_U_SMXP_3_0, REGION12_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR13_U_SMXP_3_0, 0x183dce0)
    FIELD(POR_MPU_M3_PRBAR13_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR13_U_SMXP_3_0, REGION13_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR13_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR13_U_SMXP_3_0, REGION13_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR13_U_SMXP_3_0, REGION13_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR13_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR13_U_SMXP_3_0, 0x183dce8)
    FIELD(POR_MPU_M3_PRLAR13_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR13_U_SMXP_3_0, REGION13_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR13_U_SMXP_3_0, REGION13_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR14_U_SMXP_3_0, 0x183dcf0)
    FIELD(POR_MPU_M3_PRBAR14_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR14_U_SMXP_3_0, REGION14_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR14_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR14_U_SMXP_3_0, REGION14_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR14_U_SMXP_3_0, REGION14_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR14_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR14_U_SMXP_3_0, 0x183dcf8)
    FIELD(POR_MPU_M3_PRLAR14_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR14_U_SMXP_3_0, REGION14_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR14_U_SMXP_3_0, REGION14_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR15_U_SMXP_3_0, 0x183dd00)
    FIELD(POR_MPU_M3_PRBAR15_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR15_U_SMXP_3_0, REGION15_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR15_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR15_U_SMXP_3_0, REGION15_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR15_U_SMXP_3_0, REGION15_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR15_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR15_U_SMXP_3_0, 0x183dd08)
    FIELD(POR_MPU_M3_PRLAR15_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR15_U_SMXP_3_0, REGION15_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR15_U_SMXP_3_0, REGION15_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR16_U_SMXP_3_0, 0x183dd10)
    FIELD(POR_MPU_M3_PRBAR16_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR16_U_SMXP_3_0, REGION16_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR16_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR16_U_SMXP_3_0, REGION16_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR16_U_SMXP_3_0, REGION16_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR16_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR16_U_SMXP_3_0, 0x183dd18)
    FIELD(POR_MPU_M3_PRLAR16_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR16_U_SMXP_3_0, REGION16_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR16_U_SMXP_3_0, REGION16_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR17_U_SMXP_3_0, 0x183dd20)
    FIELD(POR_MPU_M3_PRBAR17_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR17_U_SMXP_3_0, REGION17_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR17_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR17_U_SMXP_3_0, REGION17_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR17_U_SMXP_3_0, REGION17_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR17_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR17_U_SMXP_3_0, 0x183dd28)
    FIELD(POR_MPU_M3_PRLAR17_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR17_U_SMXP_3_0, REGION17_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR17_U_SMXP_3_0, REGION17_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR18_U_SMXP_3_0, 0x183dd30)
    FIELD(POR_MPU_M3_PRBAR18_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR18_U_SMXP_3_0, REGION18_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR18_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR18_U_SMXP_3_0, REGION18_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR18_U_SMXP_3_0, REGION18_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR18_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR18_U_SMXP_3_0, 0x183dd38)
    FIELD(POR_MPU_M3_PRLAR18_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR18_U_SMXP_3_0, REGION18_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR18_U_SMXP_3_0, REGION18_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR19_U_SMXP_3_0, 0x183dd40)
    FIELD(POR_MPU_M3_PRBAR19_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR19_U_SMXP_3_0, REGION19_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR19_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR19_U_SMXP_3_0, REGION19_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR19_U_SMXP_3_0, REGION19_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR19_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR19_U_SMXP_3_0, 0x183dd48)
    FIELD(POR_MPU_M3_PRLAR19_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR19_U_SMXP_3_0, REGION19_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR19_U_SMXP_3_0, REGION19_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR20_U_SMXP_3_0, 0x183dd50)
    FIELD(POR_MPU_M3_PRBAR20_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR20_U_SMXP_3_0, REGION20_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR20_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR20_U_SMXP_3_0, REGION20_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR20_U_SMXP_3_0, REGION20_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR20_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR20_U_SMXP_3_0, 0x183dd58)
    FIELD(POR_MPU_M3_PRLAR20_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR20_U_SMXP_3_0, REGION20_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR20_U_SMXP_3_0, REGION20_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR21_U_SMXP_3_0, 0x183dd60)
    FIELD(POR_MPU_M3_PRBAR21_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR21_U_SMXP_3_0, REGION21_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR21_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR21_U_SMXP_3_0, REGION21_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR21_U_SMXP_3_0, REGION21_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR21_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR21_U_SMXP_3_0, 0x183dd68)
    FIELD(POR_MPU_M3_PRLAR21_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR21_U_SMXP_3_0, REGION21_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR21_U_SMXP_3_0, REGION21_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR22_U_SMXP_3_0, 0x183dd70)
    FIELD(POR_MPU_M3_PRBAR22_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR22_U_SMXP_3_0, REGION22_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR22_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR22_U_SMXP_3_0, REGION22_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR22_U_SMXP_3_0, REGION22_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR22_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR22_U_SMXP_3_0, 0x183dd78)
    FIELD(POR_MPU_M3_PRLAR22_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR22_U_SMXP_3_0, REGION22_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR22_U_SMXP_3_0, REGION22_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR23_U_SMXP_3_0, 0x183dd80)
    FIELD(POR_MPU_M3_PRBAR23_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR23_U_SMXP_3_0, REGION23_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR23_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR23_U_SMXP_3_0, REGION23_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR23_U_SMXP_3_0, REGION23_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR23_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR23_U_SMXP_3_0, 0x183dd88)
    FIELD(POR_MPU_M3_PRLAR23_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR23_U_SMXP_3_0, REGION23_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR23_U_SMXP_3_0, REGION23_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR24_U_SMXP_3_0, 0x183dd90)
    FIELD(POR_MPU_M3_PRBAR24_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR24_U_SMXP_3_0, REGION24_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR24_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR24_U_SMXP_3_0, REGION24_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR24_U_SMXP_3_0, REGION24_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR24_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR24_U_SMXP_3_0, 0x183dd98)
    FIELD(POR_MPU_M3_PRLAR24_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR24_U_SMXP_3_0, REGION24_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR24_U_SMXP_3_0, REGION24_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR25_U_SMXP_3_0, 0x183dda0)
    FIELD(POR_MPU_M3_PRBAR25_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR25_U_SMXP_3_0, REGION25_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR25_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR25_U_SMXP_3_0, REGION25_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR25_U_SMXP_3_0, REGION25_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR25_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR25_U_SMXP_3_0, 0x183dda8)
    FIELD(POR_MPU_M3_PRLAR25_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR25_U_SMXP_3_0, REGION25_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR25_U_SMXP_3_0, REGION25_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR26_U_SMXP_3_0, 0x183ddb0)
    FIELD(POR_MPU_M3_PRBAR26_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR26_U_SMXP_3_0, REGION26_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR26_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR26_U_SMXP_3_0, REGION26_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR26_U_SMXP_3_0, REGION26_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR26_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR26_U_SMXP_3_0, 0x183ddb8)
    FIELD(POR_MPU_M3_PRLAR26_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR26_U_SMXP_3_0, REGION26_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR26_U_SMXP_3_0, REGION26_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR27_U_SMXP_3_0, 0x183ddc0)
    FIELD(POR_MPU_M3_PRBAR27_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR27_U_SMXP_3_0, REGION27_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR27_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR27_U_SMXP_3_0, REGION27_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR27_U_SMXP_3_0, REGION27_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR27_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR27_U_SMXP_3_0, 0x183ddc8)
    FIELD(POR_MPU_M3_PRLAR27_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR27_U_SMXP_3_0, REGION27_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR27_U_SMXP_3_0, REGION27_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR28_U_SMXP_3_0, 0x183ddd0)
    FIELD(POR_MPU_M3_PRBAR28_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR28_U_SMXP_3_0, REGION28_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR28_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR28_U_SMXP_3_0, REGION28_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR28_U_SMXP_3_0, REGION28_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR28_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR28_U_SMXP_3_0, 0x183ddd8)
    FIELD(POR_MPU_M3_PRLAR28_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR28_U_SMXP_3_0, REGION28_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR28_U_SMXP_3_0, REGION28_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR29_U_SMXP_3_0, 0x183dde0)
    FIELD(POR_MPU_M3_PRBAR29_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR29_U_SMXP_3_0, REGION29_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR29_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR29_U_SMXP_3_0, REGION29_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR29_U_SMXP_3_0, REGION29_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR29_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR29_U_SMXP_3_0, 0x183dde8)
    FIELD(POR_MPU_M3_PRLAR29_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR29_U_SMXP_3_0, REGION29_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR29_U_SMXP_3_0, REGION29_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR30_U_SMXP_3_0, 0x183ddf0)
    FIELD(POR_MPU_M3_PRBAR30_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR30_U_SMXP_3_0, REGION30_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR30_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR30_U_SMXP_3_0, REGION30_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR30_U_SMXP_3_0, REGION30_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR30_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR30_U_SMXP_3_0, 0x183ddf8)
    FIELD(POR_MPU_M3_PRLAR30_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR30_U_SMXP_3_0, REGION30_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR30_U_SMXP_3_0, REGION30_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR31_U_SMXP_3_0, 0x183de00)
    FIELD(POR_MPU_M3_PRBAR31_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR31_U_SMXP_3_0, REGION31_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR31_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR31_U_SMXP_3_0, REGION31_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR31_U_SMXP_3_0, REGION31_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR31_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR31_U_SMXP_3_0, 0x183de08)
    FIELD(POR_MPU_M3_PRLAR31_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR31_U_SMXP_3_0, REGION31_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR31_U_SMXP_3_0, REGION31_EN, 0, 1)
REG32(POR_MPU_M4_CTL_U_SMXP_3_0, 0x183e000)
    FIELD(POR_MPU_M4_CTL_U_SMXP_3_0, M4_EN, 2, 1)
    FIELD(POR_MPU_M4_CTL_U_SMXP_3_0, M4_ACTION, 0, 2)
REG32(POR_MPU_M4_PRBAR0_U_SMXP_3_0, 0x183e010)
    FIELD(POR_MPU_M4_PRBAR0_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR0_U_SMXP_3_0, REGION0_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR0_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR0_U_SMXP_3_0, REGION0_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR0_U_SMXP_3_0, REGION0_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR0_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR0_U_SMXP_3_0, 0x183e018)
    FIELD(POR_MPU_M4_PRLAR0_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR0_U_SMXP_3_0, REGION0_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR0_U_SMXP_3_0, REGION0_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR1_U_SMXP_3_0, 0x183e020)
    FIELD(POR_MPU_M4_PRBAR1_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR1_U_SMXP_3_0, REGION1_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR1_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR1_U_SMXP_3_0, REGION1_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR1_U_SMXP_3_0, REGION1_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR1_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR1_U_SMXP_3_0, 0x183e028)
    FIELD(POR_MPU_M4_PRLAR1_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR1_U_SMXP_3_0, REGION1_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR1_U_SMXP_3_0, REGION1_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR2_U_SMXP_3_0, 0x183e030)
    FIELD(POR_MPU_M4_PRBAR2_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR2_U_SMXP_3_0, REGION2_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR2_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR2_U_SMXP_3_0, REGION2_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR2_U_SMXP_3_0, REGION2_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR2_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR2_U_SMXP_3_0, 0x183e038)
    FIELD(POR_MPU_M4_PRLAR2_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR2_U_SMXP_3_0, REGION2_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR2_U_SMXP_3_0, REGION2_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR3_U_SMXP_3_0, 0x183e040)
    FIELD(POR_MPU_M4_PRBAR3_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR3_U_SMXP_3_0, REGION3_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR3_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR3_U_SMXP_3_0, REGION3_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR3_U_SMXP_3_0, REGION3_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR3_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR3_U_SMXP_3_0, 0x183e048)
    FIELD(POR_MPU_M4_PRLAR3_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR3_U_SMXP_3_0, REGION3_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR3_U_SMXP_3_0, REGION3_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR4_U_SMXP_3_0, 0x183e050)
    FIELD(POR_MPU_M4_PRBAR4_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR4_U_SMXP_3_0, REGION4_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR4_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR4_U_SMXP_3_0, REGION4_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR4_U_SMXP_3_0, REGION4_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR4_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR4_U_SMXP_3_0, 0x183e058)
    FIELD(POR_MPU_M4_PRLAR4_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR4_U_SMXP_3_0, REGION4_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR4_U_SMXP_3_0, REGION4_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR5_U_SMXP_3_0, 0x183e060)
    FIELD(POR_MPU_M4_PRBAR5_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR5_U_SMXP_3_0, REGION5_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR5_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR5_U_SMXP_3_0, REGION5_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR5_U_SMXP_3_0, REGION5_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR5_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR5_U_SMXP_3_0, 0x183e068)
    FIELD(POR_MPU_M4_PRLAR5_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR5_U_SMXP_3_0, REGION5_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR5_U_SMXP_3_0, REGION5_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR6_U_SMXP_3_0, 0x183e070)
    FIELD(POR_MPU_M4_PRBAR6_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR6_U_SMXP_3_0, REGION6_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR6_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR6_U_SMXP_3_0, REGION6_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR6_U_SMXP_3_0, REGION6_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR6_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR6_U_SMXP_3_0, 0x183e078)
    FIELD(POR_MPU_M4_PRLAR6_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR6_U_SMXP_3_0, REGION6_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR6_U_SMXP_3_0, REGION6_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR7_U_SMXP_3_0, 0x183e080)
    FIELD(POR_MPU_M4_PRBAR7_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR7_U_SMXP_3_0, REGION7_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR7_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR7_U_SMXP_3_0, REGION7_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR7_U_SMXP_3_0, REGION7_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR7_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR7_U_SMXP_3_0, 0x183e088)
    FIELD(POR_MPU_M4_PRLAR7_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR7_U_SMXP_3_0, REGION7_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR7_U_SMXP_3_0, REGION7_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR8_U_SMXP_3_0, 0x183e090)
    FIELD(POR_MPU_M4_PRBAR8_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR8_U_SMXP_3_0, REGION8_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR8_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR8_U_SMXP_3_0, REGION8_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR8_U_SMXP_3_0, REGION8_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR8_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR8_U_SMXP_3_0, 0x183e098)
    FIELD(POR_MPU_M4_PRLAR8_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR8_U_SMXP_3_0, REGION8_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR8_U_SMXP_3_0, REGION8_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR9_U_SMXP_3_0, 0x183e0a0)
    FIELD(POR_MPU_M4_PRBAR9_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR9_U_SMXP_3_0, REGION9_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR9_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR9_U_SMXP_3_0, REGION9_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR9_U_SMXP_3_0, REGION9_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR9_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR9_U_SMXP_3_0, 0x183e0a8)
    FIELD(POR_MPU_M4_PRLAR9_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR9_U_SMXP_3_0, REGION9_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR9_U_SMXP_3_0, REGION9_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR10_U_SMXP_3_0, 0x183e0b0)
    FIELD(POR_MPU_M4_PRBAR10_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR10_U_SMXP_3_0, REGION10_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR10_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR10_U_SMXP_3_0, REGION10_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR10_U_SMXP_3_0, REGION10_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR10_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR10_U_SMXP_3_0, 0x183e0b8)
    FIELD(POR_MPU_M4_PRLAR10_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR10_U_SMXP_3_0, REGION10_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR10_U_SMXP_3_0, REGION10_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR11_U_SMXP_3_0, 0x183e0c0)
    FIELD(POR_MPU_M4_PRBAR11_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR11_U_SMXP_3_0, REGION11_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR11_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR11_U_SMXP_3_0, REGION11_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR11_U_SMXP_3_0, REGION11_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR11_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR11_U_SMXP_3_0, 0x183e0c8)
    FIELD(POR_MPU_M4_PRLAR11_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR11_U_SMXP_3_0, REGION11_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR11_U_SMXP_3_0, REGION11_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR12_U_SMXP_3_0, 0x183e0d0)
    FIELD(POR_MPU_M4_PRBAR12_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR12_U_SMXP_3_0, REGION12_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR12_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR12_U_SMXP_3_0, REGION12_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR12_U_SMXP_3_0, REGION12_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR12_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR12_U_SMXP_3_0, 0x183e0d8)
    FIELD(POR_MPU_M4_PRLAR12_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR12_U_SMXP_3_0, REGION12_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR12_U_SMXP_3_0, REGION12_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR13_U_SMXP_3_0, 0x183e0e0)
    FIELD(POR_MPU_M4_PRBAR13_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR13_U_SMXP_3_0, REGION13_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR13_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR13_U_SMXP_3_0, REGION13_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR13_U_SMXP_3_0, REGION13_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR13_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR13_U_SMXP_3_0, 0x183e0e8)
    FIELD(POR_MPU_M4_PRLAR13_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR13_U_SMXP_3_0, REGION13_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR13_U_SMXP_3_0, REGION13_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR14_U_SMXP_3_0, 0x183e0f0)
    FIELD(POR_MPU_M4_PRBAR14_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR14_U_SMXP_3_0, REGION14_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR14_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR14_U_SMXP_3_0, REGION14_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR14_U_SMXP_3_0, REGION14_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR14_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR14_U_SMXP_3_0, 0x183e0f8)
    FIELD(POR_MPU_M4_PRLAR14_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR14_U_SMXP_3_0, REGION14_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR14_U_SMXP_3_0, REGION14_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR15_U_SMXP_3_0, 0x183e100)
    FIELD(POR_MPU_M4_PRBAR15_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR15_U_SMXP_3_0, REGION15_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR15_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR15_U_SMXP_3_0, REGION15_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR15_U_SMXP_3_0, REGION15_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR15_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR15_U_SMXP_3_0, 0x183e108)
    FIELD(POR_MPU_M4_PRLAR15_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR15_U_SMXP_3_0, REGION15_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR15_U_SMXP_3_0, REGION15_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR16_U_SMXP_3_0, 0x183e110)
    FIELD(POR_MPU_M4_PRBAR16_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR16_U_SMXP_3_0, REGION16_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR16_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR16_U_SMXP_3_0, REGION16_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR16_U_SMXP_3_0, REGION16_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR16_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR16_U_SMXP_3_0, 0x183e118)
    FIELD(POR_MPU_M4_PRLAR16_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR16_U_SMXP_3_0, REGION16_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR16_U_SMXP_3_0, REGION16_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR17_U_SMXP_3_0, 0x183e120)
    FIELD(POR_MPU_M4_PRBAR17_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR17_U_SMXP_3_0, REGION17_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR17_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR17_U_SMXP_3_0, REGION17_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR17_U_SMXP_3_0, REGION17_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR17_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR17_U_SMXP_3_0, 0x183e128)
    FIELD(POR_MPU_M4_PRLAR17_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR17_U_SMXP_3_0, REGION17_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR17_U_SMXP_3_0, REGION17_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR18_U_SMXP_3_0, 0x183e130)
    FIELD(POR_MPU_M4_PRBAR18_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR18_U_SMXP_3_0, REGION18_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR18_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR18_U_SMXP_3_0, REGION18_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR18_U_SMXP_3_0, REGION18_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR18_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR18_U_SMXP_3_0, 0x183e138)
    FIELD(POR_MPU_M4_PRLAR18_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR18_U_SMXP_3_0, REGION18_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR18_U_SMXP_3_0, REGION18_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR19_U_SMXP_3_0, 0x183e140)
    FIELD(POR_MPU_M4_PRBAR19_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR19_U_SMXP_3_0, REGION19_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR19_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR19_U_SMXP_3_0, REGION19_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR19_U_SMXP_3_0, REGION19_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR19_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR19_U_SMXP_3_0, 0x183e148)
    FIELD(POR_MPU_M4_PRLAR19_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR19_U_SMXP_3_0, REGION19_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR19_U_SMXP_3_0, REGION19_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR20_U_SMXP_3_0, 0x183e150)
    FIELD(POR_MPU_M4_PRBAR20_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR20_U_SMXP_3_0, REGION20_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR20_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR20_U_SMXP_3_0, REGION20_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR20_U_SMXP_3_0, REGION20_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR20_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR20_U_SMXP_3_0, 0x183e158)
    FIELD(POR_MPU_M4_PRLAR20_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR20_U_SMXP_3_0, REGION20_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR20_U_SMXP_3_0, REGION20_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR21_U_SMXP_3_0, 0x183e160)
    FIELD(POR_MPU_M4_PRBAR21_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR21_U_SMXP_3_0, REGION21_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR21_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR21_U_SMXP_3_0, REGION21_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR21_U_SMXP_3_0, REGION21_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR21_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR21_U_SMXP_3_0, 0x183e168)
    FIELD(POR_MPU_M4_PRLAR21_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR21_U_SMXP_3_0, REGION21_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR21_U_SMXP_3_0, REGION21_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR22_U_SMXP_3_0, 0x183e170)
    FIELD(POR_MPU_M4_PRBAR22_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR22_U_SMXP_3_0, REGION22_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR22_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR22_U_SMXP_3_0, REGION22_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR22_U_SMXP_3_0, REGION22_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR22_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR22_U_SMXP_3_0, 0x183e178)
    FIELD(POR_MPU_M4_PRLAR22_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR22_U_SMXP_3_0, REGION22_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR22_U_SMXP_3_0, REGION22_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR23_U_SMXP_3_0, 0x183e180)
    FIELD(POR_MPU_M4_PRBAR23_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR23_U_SMXP_3_0, REGION23_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR23_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR23_U_SMXP_3_0, REGION23_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR23_U_SMXP_3_0, REGION23_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR23_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR23_U_SMXP_3_0, 0x183e188)
    FIELD(POR_MPU_M4_PRLAR23_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR23_U_SMXP_3_0, REGION23_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR23_U_SMXP_3_0, REGION23_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR24_U_SMXP_3_0, 0x183e190)
    FIELD(POR_MPU_M4_PRBAR24_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR24_U_SMXP_3_0, REGION24_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR24_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR24_U_SMXP_3_0, REGION24_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR24_U_SMXP_3_0, REGION24_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR24_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR24_U_SMXP_3_0, 0x183e198)
    FIELD(POR_MPU_M4_PRLAR24_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR24_U_SMXP_3_0, REGION24_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR24_U_SMXP_3_0, REGION24_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR25_U_SMXP_3_0, 0x183e1a0)
    FIELD(POR_MPU_M4_PRBAR25_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR25_U_SMXP_3_0, REGION25_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR25_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR25_U_SMXP_3_0, REGION25_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR25_U_SMXP_3_0, REGION25_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR25_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR25_U_SMXP_3_0, 0x183e1a8)
    FIELD(POR_MPU_M4_PRLAR25_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR25_U_SMXP_3_0, REGION25_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR25_U_SMXP_3_0, REGION25_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR26_U_SMXP_3_0, 0x183e1b0)
    FIELD(POR_MPU_M4_PRBAR26_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR26_U_SMXP_3_0, REGION26_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR26_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR26_U_SMXP_3_0, REGION26_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR26_U_SMXP_3_0, REGION26_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR26_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR26_U_SMXP_3_0, 0x183e1b8)
    FIELD(POR_MPU_M4_PRLAR26_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR26_U_SMXP_3_0, REGION26_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR26_U_SMXP_3_0, REGION26_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR27_U_SMXP_3_0, 0x183e1c0)
    FIELD(POR_MPU_M4_PRBAR27_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR27_U_SMXP_3_0, REGION27_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR27_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR27_U_SMXP_3_0, REGION27_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR27_U_SMXP_3_0, REGION27_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR27_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR27_U_SMXP_3_0, 0x183e1c8)
    FIELD(POR_MPU_M4_PRLAR27_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR27_U_SMXP_3_0, REGION27_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR27_U_SMXP_3_0, REGION27_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR28_U_SMXP_3_0, 0x183e1d0)
    FIELD(POR_MPU_M4_PRBAR28_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR28_U_SMXP_3_0, REGION28_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR28_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR28_U_SMXP_3_0, REGION28_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR28_U_SMXP_3_0, REGION28_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR28_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR28_U_SMXP_3_0, 0x183e1d8)
    FIELD(POR_MPU_M4_PRLAR28_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR28_U_SMXP_3_0, REGION28_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR28_U_SMXP_3_0, REGION28_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR29_U_SMXP_3_0, 0x183e1e0)
    FIELD(POR_MPU_M4_PRBAR29_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR29_U_SMXP_3_0, REGION29_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR29_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR29_U_SMXP_3_0, REGION29_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR29_U_SMXP_3_0, REGION29_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR29_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR29_U_SMXP_3_0, 0x183e1e8)
    FIELD(POR_MPU_M4_PRLAR29_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR29_U_SMXP_3_0, REGION29_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR29_U_SMXP_3_0, REGION29_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR30_U_SMXP_3_0, 0x183e1f0)
    FIELD(POR_MPU_M4_PRBAR30_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR30_U_SMXP_3_0, REGION30_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR30_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR30_U_SMXP_3_0, REGION30_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR30_U_SMXP_3_0, REGION30_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR30_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR30_U_SMXP_3_0, 0x183e1f8)
    FIELD(POR_MPU_M4_PRLAR30_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR30_U_SMXP_3_0, REGION30_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR30_U_SMXP_3_0, REGION30_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR31_U_SMXP_3_0, 0x183e200)
    FIELD(POR_MPU_M4_PRBAR31_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR31_U_SMXP_3_0, REGION31_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR31_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR31_U_SMXP_3_0, REGION31_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR31_U_SMXP_3_0, REGION31_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR31_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR31_U_SMXP_3_0, 0x183e208)
    FIELD(POR_MPU_M4_PRLAR31_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR31_U_SMXP_3_0, REGION31_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR31_U_SMXP_3_0, REGION31_EN, 0, 1)
REG32(POR_MPU_M5_CTL_U_SMXP_3_0, 0x183e400)
    FIELD(POR_MPU_M5_CTL_U_SMXP_3_0, M5_EN, 2, 1)
    FIELD(POR_MPU_M5_CTL_U_SMXP_3_0, M5_ACTION, 0, 2)
REG32(POR_MPU_M5_PRBAR0_U_SMXP_3_0, 0x183e410)
    FIELD(POR_MPU_M5_PRBAR0_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR0_U_SMXP_3_0, REGION0_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR0_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR0_U_SMXP_3_0, REGION0_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR0_U_SMXP_3_0, REGION0_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR0_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR0_U_SMXP_3_0, 0x183e418)
    FIELD(POR_MPU_M5_PRLAR0_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR0_U_SMXP_3_0, REGION0_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR0_U_SMXP_3_0, REGION0_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR1_U_SMXP_3_0, 0x183e420)
    FIELD(POR_MPU_M5_PRBAR1_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR1_U_SMXP_3_0, REGION1_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR1_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR1_U_SMXP_3_0, REGION1_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR1_U_SMXP_3_0, REGION1_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR1_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR1_U_SMXP_3_0, 0x183e428)
    FIELD(POR_MPU_M5_PRLAR1_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR1_U_SMXP_3_0, REGION1_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR1_U_SMXP_3_0, REGION1_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR2_U_SMXP_3_0, 0x183e430)
    FIELD(POR_MPU_M5_PRBAR2_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR2_U_SMXP_3_0, REGION2_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR2_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR2_U_SMXP_3_0, REGION2_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR2_U_SMXP_3_0, REGION2_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR2_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR2_U_SMXP_3_0, 0x183e438)
    FIELD(POR_MPU_M5_PRLAR2_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR2_U_SMXP_3_0, REGION2_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR2_U_SMXP_3_0, REGION2_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR3_U_SMXP_3_0, 0x183e440)
    FIELD(POR_MPU_M5_PRBAR3_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR3_U_SMXP_3_0, REGION3_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR3_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR3_U_SMXP_3_0, REGION3_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR3_U_SMXP_3_0, REGION3_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR3_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR3_U_SMXP_3_0, 0x183e448)
    FIELD(POR_MPU_M5_PRLAR3_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR3_U_SMXP_3_0, REGION3_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR3_U_SMXP_3_0, REGION3_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR4_U_SMXP_3_0, 0x183e450)
    FIELD(POR_MPU_M5_PRBAR4_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR4_U_SMXP_3_0, REGION4_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR4_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR4_U_SMXP_3_0, REGION4_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR4_U_SMXP_3_0, REGION4_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR4_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR4_U_SMXP_3_0, 0x183e458)
    FIELD(POR_MPU_M5_PRLAR4_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR4_U_SMXP_3_0, REGION4_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR4_U_SMXP_3_0, REGION4_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR5_U_SMXP_3_0, 0x183e460)
    FIELD(POR_MPU_M5_PRBAR5_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR5_U_SMXP_3_0, REGION5_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR5_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR5_U_SMXP_3_0, REGION5_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR5_U_SMXP_3_0, REGION5_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR5_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR5_U_SMXP_3_0, 0x183e468)
    FIELD(POR_MPU_M5_PRLAR5_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR5_U_SMXP_3_0, REGION5_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR5_U_SMXP_3_0, REGION5_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR6_U_SMXP_3_0, 0x183e470)
    FIELD(POR_MPU_M5_PRBAR6_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR6_U_SMXP_3_0, REGION6_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR6_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR6_U_SMXP_3_0, REGION6_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR6_U_SMXP_3_0, REGION6_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR6_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR6_U_SMXP_3_0, 0x183e478)
    FIELD(POR_MPU_M5_PRLAR6_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR6_U_SMXP_3_0, REGION6_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR6_U_SMXP_3_0, REGION6_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR7_U_SMXP_3_0, 0x183e480)
    FIELD(POR_MPU_M5_PRBAR7_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR7_U_SMXP_3_0, REGION7_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR7_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR7_U_SMXP_3_0, REGION7_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR7_U_SMXP_3_0, REGION7_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR7_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR7_U_SMXP_3_0, 0x183e488)
    FIELD(POR_MPU_M5_PRLAR7_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR7_U_SMXP_3_0, REGION7_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR7_U_SMXP_3_0, REGION7_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR8_U_SMXP_3_0, 0x183e490)
    FIELD(POR_MPU_M5_PRBAR8_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR8_U_SMXP_3_0, REGION8_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR8_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR8_U_SMXP_3_0, REGION8_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR8_U_SMXP_3_0, REGION8_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR8_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR8_U_SMXP_3_0, 0x183e498)
    FIELD(POR_MPU_M5_PRLAR8_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR8_U_SMXP_3_0, REGION8_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR8_U_SMXP_3_0, REGION8_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR9_U_SMXP_3_0, 0x183e4a0)
    FIELD(POR_MPU_M5_PRBAR9_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR9_U_SMXP_3_0, REGION9_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR9_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR9_U_SMXP_3_0, REGION9_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR9_U_SMXP_3_0, REGION9_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR9_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR9_U_SMXP_3_0, 0x183e4a8)
    FIELD(POR_MPU_M5_PRLAR9_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR9_U_SMXP_3_0, REGION9_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR9_U_SMXP_3_0, REGION9_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR10_U_SMXP_3_0, 0x183e4b0)
    FIELD(POR_MPU_M5_PRBAR10_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR10_U_SMXP_3_0, REGION10_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR10_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR10_U_SMXP_3_0, REGION10_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR10_U_SMXP_3_0, REGION10_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR10_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR10_U_SMXP_3_0, 0x183e4b8)
    FIELD(POR_MPU_M5_PRLAR10_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR10_U_SMXP_3_0, REGION10_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR10_U_SMXP_3_0, REGION10_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR11_U_SMXP_3_0, 0x183e4c0)
    FIELD(POR_MPU_M5_PRBAR11_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR11_U_SMXP_3_0, REGION11_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR11_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR11_U_SMXP_3_0, REGION11_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR11_U_SMXP_3_0, REGION11_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR11_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR11_U_SMXP_3_0, 0x183e4c8)
    FIELD(POR_MPU_M5_PRLAR11_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR11_U_SMXP_3_0, REGION11_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR11_U_SMXP_3_0, REGION11_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR12_U_SMXP_3_0, 0x183e4d0)
    FIELD(POR_MPU_M5_PRBAR12_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR12_U_SMXP_3_0, REGION12_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR12_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR12_U_SMXP_3_0, REGION12_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR12_U_SMXP_3_0, REGION12_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR12_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR12_U_SMXP_3_0, 0x183e4d8)
    FIELD(POR_MPU_M5_PRLAR12_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR12_U_SMXP_3_0, REGION12_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR12_U_SMXP_3_0, REGION12_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR13_U_SMXP_3_0, 0x183e4e0)
    FIELD(POR_MPU_M5_PRBAR13_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR13_U_SMXP_3_0, REGION13_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR13_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR13_U_SMXP_3_0, REGION13_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR13_U_SMXP_3_0, REGION13_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR13_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR13_U_SMXP_3_0, 0x183e4e8)
    FIELD(POR_MPU_M5_PRLAR13_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR13_U_SMXP_3_0, REGION13_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR13_U_SMXP_3_0, REGION13_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR14_U_SMXP_3_0, 0x183e4f0)
    FIELD(POR_MPU_M5_PRBAR14_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR14_U_SMXP_3_0, REGION14_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR14_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR14_U_SMXP_3_0, REGION14_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR14_U_SMXP_3_0, REGION14_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR14_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR14_U_SMXP_3_0, 0x183e4f8)
    FIELD(POR_MPU_M5_PRLAR14_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR14_U_SMXP_3_0, REGION14_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR14_U_SMXP_3_0, REGION14_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR15_U_SMXP_3_0, 0x183e500)
    FIELD(POR_MPU_M5_PRBAR15_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR15_U_SMXP_3_0, REGION15_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR15_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR15_U_SMXP_3_0, REGION15_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR15_U_SMXP_3_0, REGION15_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR15_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR15_U_SMXP_3_0, 0x183e508)
    FIELD(POR_MPU_M5_PRLAR15_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR15_U_SMXP_3_0, REGION15_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR15_U_SMXP_3_0, REGION15_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR16_U_SMXP_3_0, 0x183e510)
    FIELD(POR_MPU_M5_PRBAR16_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR16_U_SMXP_3_0, REGION16_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR16_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR16_U_SMXP_3_0, REGION16_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR16_U_SMXP_3_0, REGION16_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR16_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR16_U_SMXP_3_0, 0x183e518)
    FIELD(POR_MPU_M5_PRLAR16_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR16_U_SMXP_3_0, REGION16_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR16_U_SMXP_3_0, REGION16_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR17_U_SMXP_3_0, 0x183e520)
    FIELD(POR_MPU_M5_PRBAR17_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR17_U_SMXP_3_0, REGION17_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR17_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR17_U_SMXP_3_0, REGION17_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR17_U_SMXP_3_0, REGION17_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR17_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR17_U_SMXP_3_0, 0x183e528)
    FIELD(POR_MPU_M5_PRLAR17_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR17_U_SMXP_3_0, REGION17_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR17_U_SMXP_3_0, REGION17_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR18_U_SMXP_3_0, 0x183e530)
    FIELD(POR_MPU_M5_PRBAR18_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR18_U_SMXP_3_0, REGION18_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR18_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR18_U_SMXP_3_0, REGION18_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR18_U_SMXP_3_0, REGION18_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR18_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR18_U_SMXP_3_0, 0x183e538)
    FIELD(POR_MPU_M5_PRLAR18_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR18_U_SMXP_3_0, REGION18_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR18_U_SMXP_3_0, REGION18_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR19_U_SMXP_3_0, 0x183e540)
    FIELD(POR_MPU_M5_PRBAR19_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR19_U_SMXP_3_0, REGION19_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR19_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR19_U_SMXP_3_0, REGION19_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR19_U_SMXP_3_0, REGION19_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR19_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR19_U_SMXP_3_0, 0x183e548)
    FIELD(POR_MPU_M5_PRLAR19_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR19_U_SMXP_3_0, REGION19_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR19_U_SMXP_3_0, REGION19_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR20_U_SMXP_3_0, 0x183e550)
    FIELD(POR_MPU_M5_PRBAR20_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR20_U_SMXP_3_0, REGION20_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR20_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR20_U_SMXP_3_0, REGION20_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR20_U_SMXP_3_0, REGION20_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR20_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR20_U_SMXP_3_0, 0x183e558)
    FIELD(POR_MPU_M5_PRLAR20_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR20_U_SMXP_3_0, REGION20_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR20_U_SMXP_3_0, REGION20_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR21_U_SMXP_3_0, 0x183e560)
    FIELD(POR_MPU_M5_PRBAR21_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR21_U_SMXP_3_0, REGION21_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR21_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR21_U_SMXP_3_0, REGION21_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR21_U_SMXP_3_0, REGION21_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR21_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR21_U_SMXP_3_0, 0x183e568)
    FIELD(POR_MPU_M5_PRLAR21_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR21_U_SMXP_3_0, REGION21_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR21_U_SMXP_3_0, REGION21_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR22_U_SMXP_3_0, 0x183e570)
    FIELD(POR_MPU_M5_PRBAR22_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR22_U_SMXP_3_0, REGION22_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR22_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR22_U_SMXP_3_0, REGION22_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR22_U_SMXP_3_0, REGION22_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR22_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR22_U_SMXP_3_0, 0x183e578)
    FIELD(POR_MPU_M5_PRLAR22_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR22_U_SMXP_3_0, REGION22_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR22_U_SMXP_3_0, REGION22_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR23_U_SMXP_3_0, 0x183e580)
    FIELD(POR_MPU_M5_PRBAR23_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR23_U_SMXP_3_0, REGION23_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR23_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR23_U_SMXP_3_0, REGION23_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR23_U_SMXP_3_0, REGION23_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR23_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR23_U_SMXP_3_0, 0x183e588)
    FIELD(POR_MPU_M5_PRLAR23_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR23_U_SMXP_3_0, REGION23_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR23_U_SMXP_3_0, REGION23_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR24_U_SMXP_3_0, 0x183e590)
    FIELD(POR_MPU_M5_PRBAR24_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR24_U_SMXP_3_0, REGION24_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR24_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR24_U_SMXP_3_0, REGION24_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR24_U_SMXP_3_0, REGION24_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR24_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR24_U_SMXP_3_0, 0x183e598)
    FIELD(POR_MPU_M5_PRLAR24_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR24_U_SMXP_3_0, REGION24_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR24_U_SMXP_3_0, REGION24_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR25_U_SMXP_3_0, 0x183e5a0)
    FIELD(POR_MPU_M5_PRBAR25_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR25_U_SMXP_3_0, REGION25_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR25_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR25_U_SMXP_3_0, REGION25_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR25_U_SMXP_3_0, REGION25_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR25_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR25_U_SMXP_3_0, 0x183e5a8)
    FIELD(POR_MPU_M5_PRLAR25_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR25_U_SMXP_3_0, REGION25_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR25_U_SMXP_3_0, REGION25_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR26_U_SMXP_3_0, 0x183e5b0)
    FIELD(POR_MPU_M5_PRBAR26_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR26_U_SMXP_3_0, REGION26_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR26_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR26_U_SMXP_3_0, REGION26_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR26_U_SMXP_3_0, REGION26_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR26_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR26_U_SMXP_3_0, 0x183e5b8)
    FIELD(POR_MPU_M5_PRLAR26_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR26_U_SMXP_3_0, REGION26_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR26_U_SMXP_3_0, REGION26_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR27_U_SMXP_3_0, 0x183e5c0)
    FIELD(POR_MPU_M5_PRBAR27_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR27_U_SMXP_3_0, REGION27_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR27_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR27_U_SMXP_3_0, REGION27_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR27_U_SMXP_3_0, REGION27_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR27_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR27_U_SMXP_3_0, 0x183e5c8)
    FIELD(POR_MPU_M5_PRLAR27_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR27_U_SMXP_3_0, REGION27_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR27_U_SMXP_3_0, REGION27_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR28_U_SMXP_3_0, 0x183e5d0)
    FIELD(POR_MPU_M5_PRBAR28_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR28_U_SMXP_3_0, REGION28_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR28_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR28_U_SMXP_3_0, REGION28_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR28_U_SMXP_3_0, REGION28_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR28_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR28_U_SMXP_3_0, 0x183e5d8)
    FIELD(POR_MPU_M5_PRLAR28_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR28_U_SMXP_3_0, REGION28_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR28_U_SMXP_3_0, REGION28_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR29_U_SMXP_3_0, 0x183e5e0)
    FIELD(POR_MPU_M5_PRBAR29_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR29_U_SMXP_3_0, REGION29_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR29_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR29_U_SMXP_3_0, REGION29_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR29_U_SMXP_3_0, REGION29_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR29_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR29_U_SMXP_3_0, 0x183e5e8)
    FIELD(POR_MPU_M5_PRLAR29_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR29_U_SMXP_3_0, REGION29_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR29_U_SMXP_3_0, REGION29_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR30_U_SMXP_3_0, 0x183e5f0)
    FIELD(POR_MPU_M5_PRBAR30_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR30_U_SMXP_3_0, REGION30_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR30_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR30_U_SMXP_3_0, REGION30_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR30_U_SMXP_3_0, REGION30_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR30_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR30_U_SMXP_3_0, 0x183e5f8)
    FIELD(POR_MPU_M5_PRLAR30_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR30_U_SMXP_3_0, REGION30_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR30_U_SMXP_3_0, REGION30_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR31_U_SMXP_3_0, 0x183e600)
    FIELD(POR_MPU_M5_PRBAR31_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR31_U_SMXP_3_0, REGION31_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR31_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR31_U_SMXP_3_0, REGION31_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR31_U_SMXP_3_0, REGION31_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR31_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR31_U_SMXP_3_0, 0x183e608)
    FIELD(POR_MPU_M5_PRLAR31_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR31_U_SMXP_3_0, REGION31_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR31_U_SMXP_3_0, REGION31_EN, 0, 1)
REG32(POR_MPU_M6_CTL_U_SMXP_3_0, 0x183e800)
    FIELD(POR_MPU_M6_CTL_U_SMXP_3_0, M6_EN, 2, 1)
    FIELD(POR_MPU_M6_CTL_U_SMXP_3_0, M6_ACTION, 0, 2)
REG32(POR_MPU_M6_PRBAR0_U_SMXP_3_0, 0x183e810)
    FIELD(POR_MPU_M6_PRBAR0_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR0_U_SMXP_3_0, REGION0_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR0_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR0_U_SMXP_3_0, REGION0_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR0_U_SMXP_3_0, REGION0_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR0_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR0_U_SMXP_3_0, 0x183e818)
    FIELD(POR_MPU_M6_PRLAR0_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR0_U_SMXP_3_0, REGION0_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR0_U_SMXP_3_0, REGION0_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR1_U_SMXP_3_0, 0x183e820)
    FIELD(POR_MPU_M6_PRBAR1_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR1_U_SMXP_3_0, REGION1_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR1_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR1_U_SMXP_3_0, REGION1_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR1_U_SMXP_3_0, REGION1_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR1_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR1_U_SMXP_3_0, 0x183e828)
    FIELD(POR_MPU_M6_PRLAR1_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR1_U_SMXP_3_0, REGION1_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR1_U_SMXP_3_0, REGION1_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR2_U_SMXP_3_0, 0x183e830)
    FIELD(POR_MPU_M6_PRBAR2_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR2_U_SMXP_3_0, REGION2_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR2_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR2_U_SMXP_3_0, REGION2_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR2_U_SMXP_3_0, REGION2_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR2_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR2_U_SMXP_3_0, 0x183e838)
    FIELD(POR_MPU_M6_PRLAR2_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR2_U_SMXP_3_0, REGION2_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR2_U_SMXP_3_0, REGION2_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR3_U_SMXP_3_0, 0x183e840)
    FIELD(POR_MPU_M6_PRBAR3_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR3_U_SMXP_3_0, REGION3_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR3_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR3_U_SMXP_3_0, REGION3_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR3_U_SMXP_3_0, REGION3_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR3_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR3_U_SMXP_3_0, 0x183e848)
    FIELD(POR_MPU_M6_PRLAR3_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR3_U_SMXP_3_0, REGION3_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR3_U_SMXP_3_0, REGION3_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR4_U_SMXP_3_0, 0x183e850)
    FIELD(POR_MPU_M6_PRBAR4_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR4_U_SMXP_3_0, REGION4_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR4_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR4_U_SMXP_3_0, REGION4_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR4_U_SMXP_3_0, REGION4_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR4_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR4_U_SMXP_3_0, 0x183e858)
    FIELD(POR_MPU_M6_PRLAR4_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR4_U_SMXP_3_0, REGION4_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR4_U_SMXP_3_0, REGION4_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR5_U_SMXP_3_0, 0x183e860)
    FIELD(POR_MPU_M6_PRBAR5_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR5_U_SMXP_3_0, REGION5_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR5_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR5_U_SMXP_3_0, REGION5_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR5_U_SMXP_3_0, REGION5_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR5_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR5_U_SMXP_3_0, 0x183e868)
    FIELD(POR_MPU_M6_PRLAR5_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR5_U_SMXP_3_0, REGION5_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR5_U_SMXP_3_0, REGION5_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR6_U_SMXP_3_0, 0x183e870)
    FIELD(POR_MPU_M6_PRBAR6_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR6_U_SMXP_3_0, REGION6_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR6_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR6_U_SMXP_3_0, REGION6_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR6_U_SMXP_3_0, REGION6_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR6_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR6_U_SMXP_3_0, 0x183e878)
    FIELD(POR_MPU_M6_PRLAR6_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR6_U_SMXP_3_0, REGION6_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR6_U_SMXP_3_0, REGION6_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR7_U_SMXP_3_0, 0x183e880)
    FIELD(POR_MPU_M6_PRBAR7_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR7_U_SMXP_3_0, REGION7_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR7_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR7_U_SMXP_3_0, REGION7_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR7_U_SMXP_3_0, REGION7_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR7_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR7_U_SMXP_3_0, 0x183e888)
    FIELD(POR_MPU_M6_PRLAR7_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR7_U_SMXP_3_0, REGION7_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR7_U_SMXP_3_0, REGION7_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR8_U_SMXP_3_0, 0x183e890)
    FIELD(POR_MPU_M6_PRBAR8_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR8_U_SMXP_3_0, REGION8_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR8_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR8_U_SMXP_3_0, REGION8_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR8_U_SMXP_3_0, REGION8_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR8_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR8_U_SMXP_3_0, 0x183e898)
    FIELD(POR_MPU_M6_PRLAR8_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR8_U_SMXP_3_0, REGION8_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR8_U_SMXP_3_0, REGION8_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR9_U_SMXP_3_0, 0x183e8a0)
    FIELD(POR_MPU_M6_PRBAR9_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR9_U_SMXP_3_0, REGION9_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR9_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR9_U_SMXP_3_0, REGION9_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR9_U_SMXP_3_0, REGION9_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR9_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR9_U_SMXP_3_0, 0x183e8a8)
    FIELD(POR_MPU_M6_PRLAR9_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR9_U_SMXP_3_0, REGION9_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR9_U_SMXP_3_0, REGION9_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR10_U_SMXP_3_0, 0x183e8b0)
    FIELD(POR_MPU_M6_PRBAR10_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR10_U_SMXP_3_0, REGION10_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR10_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR10_U_SMXP_3_0, REGION10_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR10_U_SMXP_3_0, REGION10_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR10_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR10_U_SMXP_3_0, 0x183e8b8)
    FIELD(POR_MPU_M6_PRLAR10_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR10_U_SMXP_3_0, REGION10_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR10_U_SMXP_3_0, REGION10_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR11_U_SMXP_3_0, 0x183e8c0)
    FIELD(POR_MPU_M6_PRBAR11_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR11_U_SMXP_3_0, REGION11_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR11_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR11_U_SMXP_3_0, REGION11_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR11_U_SMXP_3_0, REGION11_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR11_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR11_U_SMXP_3_0, 0x183e8c8)
    FIELD(POR_MPU_M6_PRLAR11_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR11_U_SMXP_3_0, REGION11_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR11_U_SMXP_3_0, REGION11_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR12_U_SMXP_3_0, 0x183e8d0)
    FIELD(POR_MPU_M6_PRBAR12_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR12_U_SMXP_3_0, REGION12_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR12_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR12_U_SMXP_3_0, REGION12_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR12_U_SMXP_3_0, REGION12_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR12_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR12_U_SMXP_3_0, 0x183e8d8)
    FIELD(POR_MPU_M6_PRLAR12_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR12_U_SMXP_3_0, REGION12_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR12_U_SMXP_3_0, REGION12_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR13_U_SMXP_3_0, 0x183e8e0)
    FIELD(POR_MPU_M6_PRBAR13_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR13_U_SMXP_3_0, REGION13_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR13_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR13_U_SMXP_3_0, REGION13_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR13_U_SMXP_3_0, REGION13_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR13_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR13_U_SMXP_3_0, 0x183e8e8)
    FIELD(POR_MPU_M6_PRLAR13_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR13_U_SMXP_3_0, REGION13_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR13_U_SMXP_3_0, REGION13_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR14_U_SMXP_3_0, 0x183e8f0)
    FIELD(POR_MPU_M6_PRBAR14_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR14_U_SMXP_3_0, REGION14_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR14_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR14_U_SMXP_3_0, REGION14_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR14_U_SMXP_3_0, REGION14_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR14_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR14_U_SMXP_3_0, 0x183e8f8)
    FIELD(POR_MPU_M6_PRLAR14_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR14_U_SMXP_3_0, REGION14_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR14_U_SMXP_3_0, REGION14_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR15_U_SMXP_3_0, 0x183e900)
    FIELD(POR_MPU_M6_PRBAR15_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR15_U_SMXP_3_0, REGION15_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR15_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR15_U_SMXP_3_0, REGION15_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR15_U_SMXP_3_0, REGION15_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR15_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR15_U_SMXP_3_0, 0x183e908)
    FIELD(POR_MPU_M6_PRLAR15_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR15_U_SMXP_3_0, REGION15_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR15_U_SMXP_3_0, REGION15_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR16_U_SMXP_3_0, 0x183e910)
    FIELD(POR_MPU_M6_PRBAR16_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR16_U_SMXP_3_0, REGION16_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR16_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR16_U_SMXP_3_0, REGION16_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR16_U_SMXP_3_0, REGION16_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR16_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR16_U_SMXP_3_0, 0x183e918)
    FIELD(POR_MPU_M6_PRLAR16_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR16_U_SMXP_3_0, REGION16_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR16_U_SMXP_3_0, REGION16_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR17_U_SMXP_3_0, 0x183e920)
    FIELD(POR_MPU_M6_PRBAR17_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR17_U_SMXP_3_0, REGION17_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR17_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR17_U_SMXP_3_0, REGION17_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR17_U_SMXP_3_0, REGION17_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR17_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR17_U_SMXP_3_0, 0x183e928)
    FIELD(POR_MPU_M6_PRLAR17_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR17_U_SMXP_3_0, REGION17_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR17_U_SMXP_3_0, REGION17_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR18_U_SMXP_3_0, 0x183e930)
    FIELD(POR_MPU_M6_PRBAR18_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR18_U_SMXP_3_0, REGION18_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR18_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR18_U_SMXP_3_0, REGION18_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR18_U_SMXP_3_0, REGION18_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR18_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR18_U_SMXP_3_0, 0x183e938)
    FIELD(POR_MPU_M6_PRLAR18_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR18_U_SMXP_3_0, REGION18_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR18_U_SMXP_3_0, REGION18_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR19_U_SMXP_3_0, 0x183e940)
    FIELD(POR_MPU_M6_PRBAR19_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR19_U_SMXP_3_0, REGION19_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR19_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR19_U_SMXP_3_0, REGION19_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR19_U_SMXP_3_0, REGION19_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR19_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR19_U_SMXP_3_0, 0x183e948)
    FIELD(POR_MPU_M6_PRLAR19_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR19_U_SMXP_3_0, REGION19_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR19_U_SMXP_3_0, REGION19_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR20_U_SMXP_3_0, 0x183e950)
    FIELD(POR_MPU_M6_PRBAR20_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR20_U_SMXP_3_0, REGION20_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR20_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR20_U_SMXP_3_0, REGION20_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR20_U_SMXP_3_0, REGION20_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR20_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR20_U_SMXP_3_0, 0x183e958)
    FIELD(POR_MPU_M6_PRLAR20_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR20_U_SMXP_3_0, REGION20_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR20_U_SMXP_3_0, REGION20_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR21_U_SMXP_3_0, 0x183e960)
    FIELD(POR_MPU_M6_PRBAR21_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR21_U_SMXP_3_0, REGION21_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR21_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR21_U_SMXP_3_0, REGION21_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR21_U_SMXP_3_0, REGION21_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR21_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR21_U_SMXP_3_0, 0x183e968)
    FIELD(POR_MPU_M6_PRLAR21_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR21_U_SMXP_3_0, REGION21_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR21_U_SMXP_3_0, REGION21_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR22_U_SMXP_3_0, 0x183e970)
    FIELD(POR_MPU_M6_PRBAR22_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR22_U_SMXP_3_0, REGION22_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR22_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR22_U_SMXP_3_0, REGION22_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR22_U_SMXP_3_0, REGION22_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR22_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR22_U_SMXP_3_0, 0x183e978)
    FIELD(POR_MPU_M6_PRLAR22_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR22_U_SMXP_3_0, REGION22_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR22_U_SMXP_3_0, REGION22_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR23_U_SMXP_3_0, 0x183e980)
    FIELD(POR_MPU_M6_PRBAR23_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR23_U_SMXP_3_0, REGION23_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR23_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR23_U_SMXP_3_0, REGION23_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR23_U_SMXP_3_0, REGION23_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR23_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR23_U_SMXP_3_0, 0x183e988)
    FIELD(POR_MPU_M6_PRLAR23_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR23_U_SMXP_3_0, REGION23_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR23_U_SMXP_3_0, REGION23_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR24_U_SMXP_3_0, 0x183e990)
    FIELD(POR_MPU_M6_PRBAR24_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR24_U_SMXP_3_0, REGION24_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR24_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR24_U_SMXP_3_0, REGION24_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR24_U_SMXP_3_0, REGION24_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR24_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR24_U_SMXP_3_0, 0x183e998)
    FIELD(POR_MPU_M6_PRLAR24_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR24_U_SMXP_3_0, REGION24_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR24_U_SMXP_3_0, REGION24_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR25_U_SMXP_3_0, 0x183e9a0)
    FIELD(POR_MPU_M6_PRBAR25_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR25_U_SMXP_3_0, REGION25_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR25_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR25_U_SMXP_3_0, REGION25_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR25_U_SMXP_3_0, REGION25_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR25_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR25_U_SMXP_3_0, 0x183e9a8)
    FIELD(POR_MPU_M6_PRLAR25_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR25_U_SMXP_3_0, REGION25_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR25_U_SMXP_3_0, REGION25_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR26_U_SMXP_3_0, 0x183e9b0)
    FIELD(POR_MPU_M6_PRBAR26_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR26_U_SMXP_3_0, REGION26_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR26_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR26_U_SMXP_3_0, REGION26_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR26_U_SMXP_3_0, REGION26_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR26_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR26_U_SMXP_3_0, 0x183e9b8)
    FIELD(POR_MPU_M6_PRLAR26_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR26_U_SMXP_3_0, REGION26_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR26_U_SMXP_3_0, REGION26_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR27_U_SMXP_3_0, 0x183e9c0)
    FIELD(POR_MPU_M6_PRBAR27_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR27_U_SMXP_3_0, REGION27_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR27_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR27_U_SMXP_3_0, REGION27_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR27_U_SMXP_3_0, REGION27_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR27_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR27_U_SMXP_3_0, 0x183e9c8)
    FIELD(POR_MPU_M6_PRLAR27_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR27_U_SMXP_3_0, REGION27_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR27_U_SMXP_3_0, REGION27_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR28_U_SMXP_3_0, 0x183e9d0)
    FIELD(POR_MPU_M6_PRBAR28_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR28_U_SMXP_3_0, REGION28_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR28_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR28_U_SMXP_3_0, REGION28_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR28_U_SMXP_3_0, REGION28_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR28_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR28_U_SMXP_3_0, 0x183e9d8)
    FIELD(POR_MPU_M6_PRLAR28_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR28_U_SMXP_3_0, REGION28_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR28_U_SMXP_3_0, REGION28_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR29_U_SMXP_3_0, 0x183e9e0)
    FIELD(POR_MPU_M6_PRBAR29_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR29_U_SMXP_3_0, REGION29_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR29_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR29_U_SMXP_3_0, REGION29_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR29_U_SMXP_3_0, REGION29_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR29_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR29_U_SMXP_3_0, 0x183e9e8)
    FIELD(POR_MPU_M6_PRLAR29_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR29_U_SMXP_3_0, REGION29_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR29_U_SMXP_3_0, REGION29_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR30_U_SMXP_3_0, 0x183e9f0)
    FIELD(POR_MPU_M6_PRBAR30_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR30_U_SMXP_3_0, REGION30_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR30_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR30_U_SMXP_3_0, REGION30_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR30_U_SMXP_3_0, REGION30_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR30_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR30_U_SMXP_3_0, 0x183e9f8)
    FIELD(POR_MPU_M6_PRLAR30_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR30_U_SMXP_3_0, REGION30_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR30_U_SMXP_3_0, REGION30_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR31_U_SMXP_3_0, 0x183ea00)
    FIELD(POR_MPU_M6_PRBAR31_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR31_U_SMXP_3_0, REGION31_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR31_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR31_U_SMXP_3_0, REGION31_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR31_U_SMXP_3_0, REGION31_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR31_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR31_U_SMXP_3_0, 0x183ea08)
    FIELD(POR_MPU_M6_PRLAR31_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR31_U_SMXP_3_0, REGION31_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR31_U_SMXP_3_0, REGION31_EN, 0, 1)
REG32(POR_MPU_M7_CTL_U_SMXP_3_0, 0x183ec00)
    FIELD(POR_MPU_M7_CTL_U_SMXP_3_0, M7_EN, 2, 1)
    FIELD(POR_MPU_M7_CTL_U_SMXP_3_0, M7_ACTION, 0, 2)
REG32(POR_MPU_M7_PRBAR0_U_SMXP_3_0, 0x183ec10)
    FIELD(POR_MPU_M7_PRBAR0_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR0_U_SMXP_3_0, REGION0_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR0_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR0_U_SMXP_3_0, REGION0_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR0_U_SMXP_3_0, REGION0_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR0_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR0_U_SMXP_3_0, 0x183ec18)
    FIELD(POR_MPU_M7_PRLAR0_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR0_U_SMXP_3_0, REGION0_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR0_U_SMXP_3_0, REGION0_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR1_U_SMXP_3_0, 0x183ec20)
    FIELD(POR_MPU_M7_PRBAR1_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR1_U_SMXP_3_0, REGION1_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR1_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR1_U_SMXP_3_0, REGION1_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR1_U_SMXP_3_0, REGION1_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR1_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR1_U_SMXP_3_0, 0x183ec28)
    FIELD(POR_MPU_M7_PRLAR1_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR1_U_SMXP_3_0, REGION1_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR1_U_SMXP_3_0, REGION1_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR2_U_SMXP_3_0, 0x183ec30)
    FIELD(POR_MPU_M7_PRBAR2_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR2_U_SMXP_3_0, REGION2_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR2_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR2_U_SMXP_3_0, REGION2_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR2_U_SMXP_3_0, REGION2_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR2_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR2_U_SMXP_3_0, 0x183ec38)
    FIELD(POR_MPU_M7_PRLAR2_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR2_U_SMXP_3_0, REGION2_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR2_U_SMXP_3_0, REGION2_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR3_U_SMXP_3_0, 0x183ec40)
    FIELD(POR_MPU_M7_PRBAR3_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR3_U_SMXP_3_0, REGION3_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR3_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR3_U_SMXP_3_0, REGION3_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR3_U_SMXP_3_0, REGION3_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR3_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR3_U_SMXP_3_0, 0x183ec48)
    FIELD(POR_MPU_M7_PRLAR3_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR3_U_SMXP_3_0, REGION3_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR3_U_SMXP_3_0, REGION3_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR4_U_SMXP_3_0, 0x183ec50)
    FIELD(POR_MPU_M7_PRBAR4_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR4_U_SMXP_3_0, REGION4_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR4_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR4_U_SMXP_3_0, REGION4_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR4_U_SMXP_3_0, REGION4_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR4_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR4_U_SMXP_3_0, 0x183ec58)
    FIELD(POR_MPU_M7_PRLAR4_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR4_U_SMXP_3_0, REGION4_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR4_U_SMXP_3_0, REGION4_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR5_U_SMXP_3_0, 0x183ec60)
    FIELD(POR_MPU_M7_PRBAR5_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR5_U_SMXP_3_0, REGION5_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR5_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR5_U_SMXP_3_0, REGION5_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR5_U_SMXP_3_0, REGION5_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR5_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR5_U_SMXP_3_0, 0x183ec68)
    FIELD(POR_MPU_M7_PRLAR5_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR5_U_SMXP_3_0, REGION5_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR5_U_SMXP_3_0, REGION5_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR6_U_SMXP_3_0, 0x183ec70)
    FIELD(POR_MPU_M7_PRBAR6_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR6_U_SMXP_3_0, REGION6_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR6_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR6_U_SMXP_3_0, REGION6_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR6_U_SMXP_3_0, REGION6_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR6_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR6_U_SMXP_3_0, 0x183ec78)
    FIELD(POR_MPU_M7_PRLAR6_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR6_U_SMXP_3_0, REGION6_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR6_U_SMXP_3_0, REGION6_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR7_U_SMXP_3_0, 0x183ec80)
    FIELD(POR_MPU_M7_PRBAR7_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR7_U_SMXP_3_0, REGION7_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR7_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR7_U_SMXP_3_0, REGION7_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR7_U_SMXP_3_0, REGION7_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR7_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR7_U_SMXP_3_0, 0x183ec88)
    FIELD(POR_MPU_M7_PRLAR7_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR7_U_SMXP_3_0, REGION7_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR7_U_SMXP_3_0, REGION7_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR8_U_SMXP_3_0, 0x183ec90)
    FIELD(POR_MPU_M7_PRBAR8_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR8_U_SMXP_3_0, REGION8_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR8_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR8_U_SMXP_3_0, REGION8_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR8_U_SMXP_3_0, REGION8_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR8_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR8_U_SMXP_3_0, 0x183ec98)
    FIELD(POR_MPU_M7_PRLAR8_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR8_U_SMXP_3_0, REGION8_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR8_U_SMXP_3_0, REGION8_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR9_U_SMXP_3_0, 0x183eca0)
    FIELD(POR_MPU_M7_PRBAR9_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR9_U_SMXP_3_0, REGION9_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR9_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR9_U_SMXP_3_0, REGION9_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR9_U_SMXP_3_0, REGION9_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR9_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR9_U_SMXP_3_0, 0x183eca8)
    FIELD(POR_MPU_M7_PRLAR9_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR9_U_SMXP_3_0, REGION9_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR9_U_SMXP_3_0, REGION9_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR10_U_SMXP_3_0, 0x183ecb0)
    FIELD(POR_MPU_M7_PRBAR10_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR10_U_SMXP_3_0, REGION10_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR10_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR10_U_SMXP_3_0, REGION10_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR10_U_SMXP_3_0, REGION10_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR10_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR10_U_SMXP_3_0, 0x183ecb8)
    FIELD(POR_MPU_M7_PRLAR10_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR10_U_SMXP_3_0, REGION10_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR10_U_SMXP_3_0, REGION10_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR11_U_SMXP_3_0, 0x183ecc0)
    FIELD(POR_MPU_M7_PRBAR11_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR11_U_SMXP_3_0, REGION11_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR11_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR11_U_SMXP_3_0, REGION11_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR11_U_SMXP_3_0, REGION11_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR11_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR11_U_SMXP_3_0, 0x183ecc8)
    FIELD(POR_MPU_M7_PRLAR11_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR11_U_SMXP_3_0, REGION11_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR11_U_SMXP_3_0, REGION11_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR12_U_SMXP_3_0, 0x183ecd0)
    FIELD(POR_MPU_M7_PRBAR12_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR12_U_SMXP_3_0, REGION12_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR12_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR12_U_SMXP_3_0, REGION12_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR12_U_SMXP_3_0, REGION12_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR12_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR12_U_SMXP_3_0, 0x183ecd8)
    FIELD(POR_MPU_M7_PRLAR12_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR12_U_SMXP_3_0, REGION12_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR12_U_SMXP_3_0, REGION12_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR13_U_SMXP_3_0, 0x183ece0)
    FIELD(POR_MPU_M7_PRBAR13_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR13_U_SMXP_3_0, REGION13_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR13_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR13_U_SMXP_3_0, REGION13_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR13_U_SMXP_3_0, REGION13_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR13_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR13_U_SMXP_3_0, 0x183ece8)
    FIELD(POR_MPU_M7_PRLAR13_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR13_U_SMXP_3_0, REGION13_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR13_U_SMXP_3_0, REGION13_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR14_U_SMXP_3_0, 0x183ecf0)
    FIELD(POR_MPU_M7_PRBAR14_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR14_U_SMXP_3_0, REGION14_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR14_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR14_U_SMXP_3_0, REGION14_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR14_U_SMXP_3_0, REGION14_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR14_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR14_U_SMXP_3_0, 0x183ecf8)
    FIELD(POR_MPU_M7_PRLAR14_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR14_U_SMXP_3_0, REGION14_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR14_U_SMXP_3_0, REGION14_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR15_U_SMXP_3_0, 0x183ed00)
    FIELD(POR_MPU_M7_PRBAR15_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR15_U_SMXP_3_0, REGION15_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR15_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR15_U_SMXP_3_0, REGION15_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR15_U_SMXP_3_0, REGION15_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR15_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR15_U_SMXP_3_0, 0x183ed08)
    FIELD(POR_MPU_M7_PRLAR15_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR15_U_SMXP_3_0, REGION15_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR15_U_SMXP_3_0, REGION15_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR16_U_SMXP_3_0, 0x183ed10)
    FIELD(POR_MPU_M7_PRBAR16_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR16_U_SMXP_3_0, REGION16_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR16_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR16_U_SMXP_3_0, REGION16_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR16_U_SMXP_3_0, REGION16_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR16_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR16_U_SMXP_3_0, 0x183ed18)
    FIELD(POR_MPU_M7_PRLAR16_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR16_U_SMXP_3_0, REGION16_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR16_U_SMXP_3_0, REGION16_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR17_U_SMXP_3_0, 0x183ed20)
    FIELD(POR_MPU_M7_PRBAR17_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR17_U_SMXP_3_0, REGION17_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR17_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR17_U_SMXP_3_0, REGION17_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR17_U_SMXP_3_0, REGION17_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR17_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR17_U_SMXP_3_0, 0x183ed28)
    FIELD(POR_MPU_M7_PRLAR17_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR17_U_SMXP_3_0, REGION17_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR17_U_SMXP_3_0, REGION17_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR18_U_SMXP_3_0, 0x183ed30)
    FIELD(POR_MPU_M7_PRBAR18_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR18_U_SMXP_3_0, REGION18_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR18_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR18_U_SMXP_3_0, REGION18_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR18_U_SMXP_3_0, REGION18_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR18_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR18_U_SMXP_3_0, 0x183ed38)
    FIELD(POR_MPU_M7_PRLAR18_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR18_U_SMXP_3_0, REGION18_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR18_U_SMXP_3_0, REGION18_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR19_U_SMXP_3_0, 0x183ed40)
    FIELD(POR_MPU_M7_PRBAR19_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR19_U_SMXP_3_0, REGION19_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR19_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR19_U_SMXP_3_0, REGION19_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR19_U_SMXP_3_0, REGION19_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR19_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR19_U_SMXP_3_0, 0x183ed48)
    FIELD(POR_MPU_M7_PRLAR19_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR19_U_SMXP_3_0, REGION19_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR19_U_SMXP_3_0, REGION19_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR20_U_SMXP_3_0, 0x183ed50)
    FIELD(POR_MPU_M7_PRBAR20_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR20_U_SMXP_3_0, REGION20_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR20_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR20_U_SMXP_3_0, REGION20_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR20_U_SMXP_3_0, REGION20_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR20_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR20_U_SMXP_3_0, 0x183ed58)
    FIELD(POR_MPU_M7_PRLAR20_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR20_U_SMXP_3_0, REGION20_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR20_U_SMXP_3_0, REGION20_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR21_U_SMXP_3_0, 0x183ed60)
    FIELD(POR_MPU_M7_PRBAR21_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR21_U_SMXP_3_0, REGION21_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR21_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR21_U_SMXP_3_0, REGION21_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR21_U_SMXP_3_0, REGION21_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR21_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR21_U_SMXP_3_0, 0x183ed68)
    FIELD(POR_MPU_M7_PRLAR21_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR21_U_SMXP_3_0, REGION21_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR21_U_SMXP_3_0, REGION21_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR22_U_SMXP_3_0, 0x183ed70)
    FIELD(POR_MPU_M7_PRBAR22_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR22_U_SMXP_3_0, REGION22_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR22_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR22_U_SMXP_3_0, REGION22_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR22_U_SMXP_3_0, REGION22_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR22_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR22_U_SMXP_3_0, 0x183ed78)
    FIELD(POR_MPU_M7_PRLAR22_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR22_U_SMXP_3_0, REGION22_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR22_U_SMXP_3_0, REGION22_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR23_U_SMXP_3_0, 0x183ed80)
    FIELD(POR_MPU_M7_PRBAR23_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR23_U_SMXP_3_0, REGION23_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR23_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR23_U_SMXP_3_0, REGION23_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR23_U_SMXP_3_0, REGION23_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR23_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR23_U_SMXP_3_0, 0x183ed88)
    FIELD(POR_MPU_M7_PRLAR23_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR23_U_SMXP_3_0, REGION23_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR23_U_SMXP_3_0, REGION23_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR24_U_SMXP_3_0, 0x183ed90)
    FIELD(POR_MPU_M7_PRBAR24_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR24_U_SMXP_3_0, REGION24_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR24_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR24_U_SMXP_3_0, REGION24_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR24_U_SMXP_3_0, REGION24_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR24_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR24_U_SMXP_3_0, 0x183ed98)
    FIELD(POR_MPU_M7_PRLAR24_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR24_U_SMXP_3_0, REGION24_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR24_U_SMXP_3_0, REGION24_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR25_U_SMXP_3_0, 0x183eda0)
    FIELD(POR_MPU_M7_PRBAR25_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR25_U_SMXP_3_0, REGION25_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR25_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR25_U_SMXP_3_0, REGION25_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR25_U_SMXP_3_0, REGION25_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR25_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR25_U_SMXP_3_0, 0x183eda8)
    FIELD(POR_MPU_M7_PRLAR25_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR25_U_SMXP_3_0, REGION25_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR25_U_SMXP_3_0, REGION25_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR26_U_SMXP_3_0, 0x183edb0)
    FIELD(POR_MPU_M7_PRBAR26_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR26_U_SMXP_3_0, REGION26_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR26_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR26_U_SMXP_3_0, REGION26_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR26_U_SMXP_3_0, REGION26_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR26_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR26_U_SMXP_3_0, 0x183edb8)
    FIELD(POR_MPU_M7_PRLAR26_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR26_U_SMXP_3_0, REGION26_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR26_U_SMXP_3_0, REGION26_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR27_U_SMXP_3_0, 0x183edc0)
    FIELD(POR_MPU_M7_PRBAR27_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR27_U_SMXP_3_0, REGION27_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR27_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR27_U_SMXP_3_0, REGION27_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR27_U_SMXP_3_0, REGION27_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR27_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR27_U_SMXP_3_0, 0x183edc8)
    FIELD(POR_MPU_M7_PRLAR27_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR27_U_SMXP_3_0, REGION27_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR27_U_SMXP_3_0, REGION27_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR28_U_SMXP_3_0, 0x183edd0)
    FIELD(POR_MPU_M7_PRBAR28_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR28_U_SMXP_3_0, REGION28_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR28_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR28_U_SMXP_3_0, REGION28_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR28_U_SMXP_3_0, REGION28_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR28_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR28_U_SMXP_3_0, 0x183edd8)
    FIELD(POR_MPU_M7_PRLAR28_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR28_U_SMXP_3_0, REGION28_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR28_U_SMXP_3_0, REGION28_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR29_U_SMXP_3_0, 0x183ede0)
    FIELD(POR_MPU_M7_PRBAR29_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR29_U_SMXP_3_0, REGION29_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR29_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR29_U_SMXP_3_0, REGION29_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR29_U_SMXP_3_0, REGION29_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR29_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR29_U_SMXP_3_0, 0x183ede8)
    FIELD(POR_MPU_M7_PRLAR29_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR29_U_SMXP_3_0, REGION29_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR29_U_SMXP_3_0, REGION29_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR30_U_SMXP_3_0, 0x183edf0)
    FIELD(POR_MPU_M7_PRBAR30_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR30_U_SMXP_3_0, REGION30_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR30_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR30_U_SMXP_3_0, REGION30_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR30_U_SMXP_3_0, REGION30_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR30_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR30_U_SMXP_3_0, 0x183edf8)
    FIELD(POR_MPU_M7_PRLAR30_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR30_U_SMXP_3_0, REGION30_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR30_U_SMXP_3_0, REGION30_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR31_U_SMXP_3_0, 0x183ee00)
    FIELD(POR_MPU_M7_PRBAR31_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR31_U_SMXP_3_0, REGION31_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR31_U_SMXP_3_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR31_U_SMXP_3_0, REGION31_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR31_U_SMXP_3_0, REGION31_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR31_U_SMXP_3_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR31_U_SMXP_3_0, 0x183ee08)
    FIELD(POR_MPU_M7_PRLAR31_U_SMXP_3_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR31_U_SMXP_3_0, REGION31_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR31_U_SMXP_3_0, REGION31_EN, 0, 1)
REG32(POR_HNF_NODE_INFO_U_HNF_NID200, 0x1900000)
    FIELD(POR_HNF_NODE_INFO_U_HNF_NID200, RESERVED_48, 48, 16)
    FIELD(POR_HNF_NODE_INFO_U_HNF_NID200, LOGICAL_ID, 32, 16)
    FIELD(POR_HNF_NODE_INFO_U_HNF_NID200, NODE_ID, 16, 16)
    FIELD(POR_HNF_NODE_INFO_U_HNF_NID200, NODE_TYPE, 0, 16)
REG32(POR_HNF_CHILD_INFO_U_HNF_NID200, 0x1900080)
    FIELD(POR_HNF_CHILD_INFO_U_HNF_NID200, RESERVED_32, 32, 32)
    FIELD(POR_HNF_CHILD_INFO_U_HNF_NID200, CHILD_PTR_OFFSET, 16, 16)
    FIELD(POR_HNF_CHILD_INFO_U_HNF_NID200, CHILD_COUNT, 0, 16)
REG32(POR_HNF_UNIT_INFO_U_HNF_NID200, 0x1900900)
    FIELD(POR_HNF_UNIT_INFO_U_HNF_NID200, RESERVED_39, 39, 25)
    FIELD(POR_HNF_UNIT_INFO_U_HNF_NID200, NUM_POC_ENTRIES, 32, 7)
    FIELD(POR_HNF_UNIT_INFO_U_HNF_NID200, RESERVED_31, 31, 1)
    FIELD(POR_HNF_UNIT_INFO_U_HNF_NID200, NUM_EXCL, 24, 7)
    FIELD(POR_HNF_UNIT_INFO_U_HNF_NID200, RESERVED_23, 23, 1)
    FIELD(POR_HNF_UNIT_INFO_U_HNF_NID200, DATA_RAM_LATENCY, 20, 3)
    FIELD(POR_HNF_UNIT_INFO_U_HNF_NID200, RESERVED_19, 19, 1)
    FIELD(POR_HNF_UNIT_INFO_U_HNF_NID200, TAG_RAM_LAT, 16, 3)
    FIELD(POR_HNF_UNIT_INFO_U_HNF_NID200, RESERVED_13, 13, 3)
    FIELD(POR_HNF_UNIT_INFO_U_HNF_NID200, NUM_WAYS, 8, 5)
    FIELD(POR_HNF_UNIT_INFO_U_HNF_NID200, SF_SIZE, 4, 3)
    FIELD(POR_HNF_UNIT_INFO_U_HNF_NID200, SLC_SIZE, 0, 3)
REG32(POR_HNF_SECURE_REGISTER_GROUPS_OVERRIDE_U_HNF_NID200, 0x1900980)
    FIELD(POR_HNF_SECURE_REGISTER_GROUPS_OVERRIDE_U_HNF_NID200, SLCSF_DBGRD, 5, 1)
    FIELD(POR_HNF_SECURE_REGISTER_GROUPS_OVERRIDE_U_HNF_NID200, SAM_CONTROL, 4, 1)
    FIELD(POR_HNF_SECURE_REGISTER_GROUPS_OVERRIDE_U_HNF_NID200, SLC_LOCK_WAYS, 3, 1)
    FIELD(POR_HNF_SECURE_REGISTER_GROUPS_OVERRIDE_U_HNF_NID200, PPU, 2, 1)
    FIELD(POR_HNF_SECURE_REGISTER_GROUPS_OVERRIDE_U_HNF_NID200, CFG_CTL, 1, 1)
    FIELD(POR_HNF_SECURE_REGISTER_GROUPS_OVERRIDE_U_HNF_NID200, QOS, 0, 1)
REG32(POR_HNF_CFG_CTL_U_HNF_NID200, 0x1900a00)
    FIELD(POR_HNF_CFG_CTL_U_HNF_NID200, RESERVED_12, 12, 52)
    FIELD(POR_HNF_CFG_CTL_U_HNF_NID200, HNF_DMT_DISABLE, 11, 1)
    FIELD(POR_HNF_CFG_CTL_U_HNF_NID200, HNF_OCM_ALLWAYS_EN, 10, 1)
    FIELD(POR_HNF_CFG_CTL_U_HNF_NID200, HNF_OCM_EN, 9, 1)
    FIELD(POR_HNF_CFG_CTL_U_HNF_NID200, NCDEVCMO_MC_COMP, 8, 1)
    FIELD(POR_HNF_CFG_CTL_U_HNF_NID200, SF_ECC_SCRUB_DISABLE, 6, 1)
    FIELD(POR_HNF_CFG_CTL_U_HNF_NID200, SLC_TAG_ECC_SCRUB_DISABLE, 4, 1)
    FIELD(POR_HNF_CFG_CTL_U_HNF_NID200, POIS_DIS, 2, 1)
    FIELD(POR_HNF_CFG_CTL_U_HNF_NID200, ECC_DISABLE, 0, 1)
REG32(POR_HNF_AUX_CTL_U_HNF_NID200, 0x1900a08)
    FIELD(POR_HNF_AUX_CTL_U_HNF_NID200, RESERVED_58, 58, 6)
    FIELD(POR_HNF_AUX_CTL_U_HNF_NID200, SLC_ECC_PIPE_MODE_DIS, 57, 1)
    FIELD(POR_HNF_AUX_CTL_U_HNF_NID200, HNF_ORD_STASH_DATAPULL_EN, 56, 1)
    FIELD(POR_HNF_AUX_CTL_U_HNF_NID200, HNF_SHARED_INTV_DISABLE, 55, 1)
    FIELD(POR_HNF_AUX_CTL_U_HNF_NID200, RESERVED_53, 53, 2)
    FIELD(POR_HNF_AUX_CTL_U_HNF_NID200, HNF_SLC_LRU_DUALMODE_INSERT_VALUE, 51, 2)
    FIELD(POR_HNF_AUX_CTL_U_HNF_NID200, HNF_SLC_LRU_STATICMODE_INSERT_VALUE, 49, 2)
    FIELD(POR_HNF_AUX_CTL_U_HNF_NID200, HNF_SLC_LRU_SLCSRC_INSERT_VALUE, 47, 2)
    FIELD(POR_HNF_AUX_CTL_U_HNF_NID200, HNF_SLC_LRU_SEL_CNT_VALUE, 45, 2)
    FIELD(POR_HNF_AUX_CTL_U_HNF_NID200, HNF_SLC_LRU_SET_GROUPS, 43, 2)
    FIELD(POR_HNF_AUX_CTL_U_HNF_NID200, HNF_SLC_LRU_VICTIM_DISABLE, 42, 1)
    FIELD(POR_HNF_AUX_CTL_U_HNF_NID200, HNF_SLC_VICTIM_QOS_HIGH, 41, 1)
    FIELD(POR_HNF_AUX_CTL_U_HNF_NID200, HNF_SF_SNP_VEC_DISABLE, 40, 1)
    FIELD(POR_HNF_AUX_CTL_U_HNF_NID200, HNF_STASH_DATAPULL_DISABLE, 39, 1)
    FIELD(POR_HNF_AUX_CTL_U_HNF_NID200, RESERVED_37, 37, 2)
    FIELD(POR_HNF_AUX_CTL_U_HNF_NID200, HNF_CU_EXCL_OPT_EN, 36, 1)
    FIELD(POR_HNF_AUX_CTL_U_HNF_NID200, RESERVED_34, 34, 2)
    FIELD(POR_HNF_AUX_CTL_U_HNF_NID200, HNF_EXCL_SNP_FWD_EN, 33, 1)
    FIELD(POR_HNF_AUX_CTL_U_HNF_NID200, HNF_RD_EXCL_OPT_EN, 32, 1)
    FIELD(POR_HNF_AUX_CTL_U_HNF_NID200, RESERVED_17, 17, 15)
    FIELD(POR_HNF_AUX_CTL_U_HNF_NID200, HNF_POISON_INTR_EN, 16, 1)
    FIELD(POR_HNF_AUX_CTL_U_HNF_NID200, HNF_DCT_DISABLE, 15, 1)
    FIELD(POR_HNF_AUX_CTL_U_HNF_NID200, WLU_ALLOC_ON_HIT, 14, 1)
    FIELD(POR_HNF_AUX_CTL_U_HNF_NID200, SF_DISABLE, 13, 1)
    FIELD(POR_HNF_AUX_CTL_U_HNF_NID200, CG_DISABLE, 12, 1)
    FIELD(POR_HNF_AUX_CTL_U_HNF_NID200, SLC_POR_INIT_DISABLE, 11, 1)
    FIELD(POR_HNF_AUX_CTL_U_HNF_NID200, FRZ_MON_ON_OVFL, 10, 1)
    FIELD(POR_HNF_AUX_CTL_U_HNF_NID200, DIS_SEQREQ_COLL, 9, 1)
    FIELD(POR_HNF_AUX_CTL_U_HNF_NID200, DIS_LIKELYSH, 8, 1)
    FIELD(POR_HNF_AUX_CTL_U_HNF_NID200, HNF_STASH_DISABLE, 7, 1)
    FIELD(POR_HNF_AUX_CTL_U_HNF_NID200, DIS_SNP_ONCE, 6, 1)
    FIELD(POR_HNF_AUX_CTL_U_HNF_NID200, NON_SH_NO_ALLOC, 5, 1)
    FIELD(POR_HNF_AUX_CTL_U_HNF_NID200, IO_READ_NO_ALLOC, 4, 1)
    FIELD(POR_HNF_AUX_CTL_U_HNF_NID200, REV_QOS_POOL_ALLOC, 3, 1)
    FIELD(POR_HNF_AUX_CTL_U_HNF_NID200, NO_WU_ALLOC, 2, 1)
    FIELD(POR_HNF_AUX_CTL_U_HNF_NID200, HNF_HONOR_EWA, 1, 1)
    FIELD(POR_HNF_AUX_CTL_U_HNF_NID200, HNF_ONLY_MODE, 0, 1)
REG32(POR_HNF_R2_AUX_CTL_U_HNF_NID200, 0x1900a10)
    FIELD(POR_HNF_R2_AUX_CTL_U_HNF_NID200, HNF_SHD_RAM_LSCG_CG_DISABLE, 3, 1)
    FIELD(POR_HNF_R2_AUX_CTL_U_HNF_NID200, HNF_FORCE_FLUSH_EWA0_EN, 2, 1)
    FIELD(POR_HNF_R2_AUX_CTL_U_HNF_NID200, HNF_PCMO_TERMINATE_EN, 1, 1)
    FIELD(POR_HNF_R2_AUX_CTL_U_HNF_NID200, HNF_CHIC_RDNOSNPSEP_DIS, 0, 1)
REG32(RDF_HNF_AUX_CTL_U_HNF_NID200, 0x1900a18)
    FIELD(RDF_HNF_AUX_CTL_U_HNF_NID200, RESERVED_16, 16, 48)
    FIELD(RDF_HNF_AUX_CTL_U_HNF_NID200, RDF_1CYCTAG_ECCMODE_OPT_DIS, 15, 1)
    FIELD(RDF_HNF_AUX_CTL_U_HNF_NID200, RESERVED_13, 13, 2)
    FIELD(RDF_HNF_AUX_CTL_U_HNF_NID200, RDF_ALLOW_CLN_DATA_FROM_NO_WR_AP, 12, 1)
    FIELD(RDF_HNF_AUX_CTL_U_HNF_NID200, RESERVED_10, 10, 2)
    FIELD(RDF_HNF_AUX_CTL_U_HNF_NID200, RDF_SNP_MPU_ERR_LOG_EN, 9, 1)
    FIELD(RDF_HNF_AUX_CTL_U_HNF_NID200, RDF_MPU_ERR_LOG_DIS, 8, 1)
    FIELD(RDF_HNF_AUX_CTL_U_HNF_NID200, RESERVED_0, 0, 8)
REG32(POR_HNF_QOS_BAND_U_HNF_NID200, 0x1900a80)
    FIELD(POR_HNF_QOS_BAND_U_HNF_NID200, RESERVED_32, 32, 32)
    FIELD(POR_HNF_QOS_BAND_U_HNF_NID200, HIGHHIGH_MAX_QOS_VAL, 28, 4)
    FIELD(POR_HNF_QOS_BAND_U_HNF_NID200, HIGHHIGH_MIN_QOS_VAL, 24, 4)
    FIELD(POR_HNF_QOS_BAND_U_HNF_NID200, HIGH_MAX_QOS_VAL, 20, 4)
    FIELD(POR_HNF_QOS_BAND_U_HNF_NID200, HIGH_MIN_QOS_VAL, 16, 4)
    FIELD(POR_HNF_QOS_BAND_U_HNF_NID200, MED_MAX_QOS_VAL, 12, 4)
    FIELD(POR_HNF_QOS_BAND_U_HNF_NID200, MED_MIN_QOS_VAL, 8, 4)
    FIELD(POR_HNF_QOS_BAND_U_HNF_NID200, LOW_MAX_QOS_VAL, 4, 4)
    FIELD(POR_HNF_QOS_BAND_U_HNF_NID200, LOW_MIN_QOS_VAL, 0, 4)
REG32(POR_HNF_QOS_RESERVATION_U_HNF_NID200, 0x1900a88)
    FIELD(POR_HNF_QOS_RESERVATION_U_HNF_NID200, RESERVED_38, 38, 26)
    FIELD(POR_HNF_QOS_RESERVATION_U_HNF_NID200, SEQ_QOS_MAX_CNT, 32, 6)
    FIELD(POR_HNF_QOS_RESERVATION_U_HNF_NID200, RESERVED_30, 30, 2)
    FIELD(POR_HNF_QOS_RESERVATION_U_HNF_NID200, HIGHHIGH_QOS_MAX_CNT, 24, 6)
    FIELD(POR_HNF_QOS_RESERVATION_U_HNF_NID200, RESERVED_22, 22, 2)
    FIELD(POR_HNF_QOS_RESERVATION_U_HNF_NID200, HIGH_QOS_MAX_CNT, 16, 6)
    FIELD(POR_HNF_QOS_RESERVATION_U_HNF_NID200, RESERVED_14, 14, 2)
    FIELD(POR_HNF_QOS_RESERVATION_U_HNF_NID200, MED_QOS_MAX_CNT, 8, 6)
    FIELD(POR_HNF_QOS_RESERVATION_U_HNF_NID200, LOW_QOS_MAX_CNT, 0, 6)
REG32(POR_HNF_RN_STARVATION_U_HNF_NID200, 0x1900a90)
    FIELD(POR_HNF_RN_STARVATION_U_HNF_NID200, RESERVED_45, 45, 19)
    FIELD(POR_HNF_RN_STARVATION_U_HNF_NID200, RN_HIGH_OVER_HIGH_HIGH_MAX_CNT, 40, 5)
    FIELD(POR_HNF_RN_STARVATION_U_HNF_NID200, RESERVED_38, 38, 2)
    FIELD(POR_HNF_RN_STARVATION_U_HNF_NID200, RN_MED_OVER_HIGHHIGH_MAX_CNT, 32, 6)
    FIELD(POR_HNF_RN_STARVATION_U_HNF_NID200, RESERVED_29, 29, 3)
    FIELD(POR_HNF_RN_STARVATION_U_HNF_NID200, RN_MED_OVER_HIGH_MAX_CNT, 24, 5)
    FIELD(POR_HNF_RN_STARVATION_U_HNF_NID200, RESERVED_23, 23, 1)
    FIELD(POR_HNF_RN_STARVATION_U_HNF_NID200, RN_LOW_OVER_HIGHHIGH_MAX_CNT, 16, 7)
    FIELD(POR_HNF_RN_STARVATION_U_HNF_NID200, RESERVED_14, 14, 2)
    FIELD(POR_HNF_RN_STARVATION_U_HNF_NID200, RN_LOW_OVER_HIGH_MAX_CNT, 8, 6)
    FIELD(POR_HNF_RN_STARVATION_U_HNF_NID200, RN_LOW_OVER_MED_MAX_CNT, 0, 5)
REG32(POR_HNF_CFG_SLCSF_DBGRD_U_HNF_NID200, 0x1900b80)
    FIELD(POR_HNF_CFG_SLCSF_DBGRD_U_HNF_NID200, RESERVED_26, 26, 38)
    FIELD(POR_HNF_CFG_SLCSF_DBGRD_U_HNF_NID200, SLC_ACCESS_COMPONENT, 24, 2)
    FIELD(POR_HNF_CFG_SLCSF_DBGRD_U_HNF_NID200, RESERVED_23, 23, 1)
    FIELD(POR_HNF_CFG_SLCSF_DBGRD_U_HNF_NID200, SLC_ACCESS_DW, 20, 3)
    FIELD(POR_HNF_CFG_SLCSF_DBGRD_U_HNF_NID200, SLC_ACCESS_WAY, 16, 4)
    FIELD(POR_HNF_CFG_SLCSF_DBGRD_U_HNF_NID200, RESERVED_13, 13, 3)
    FIELD(POR_HNF_CFG_SLCSF_DBGRD_U_HNF_NID200, SLC_ACCESS_SET, 0, 13)
REG32(POR_HNF_SLC_CACHE_ACCESS_SLC_TAG_U_HNF_NID200, 0x1900b88)
    FIELD(POR_HNF_SLC_CACHE_ACCESS_SLC_TAG_U_HNF_NID200, RESERVED_48, 48, 16)
    FIELD(POR_HNF_SLC_CACHE_ACCESS_SLC_TAG_U_HNF_NID200, SLC_CACHE_ACCESS_SLC_TAG, 0, 48)
REG32(POR_HNF_SLC_CACHE_ACCESS_SLC_DATA_U_HNF_NID200, 0x1900b90)
REG32(POR_HNF_SLC_CACHE_ACCESS_SF_TAG_U_HNF_NID200, 0x1900b98)
REG32(POR_HNF_SLC_CACHE_ACCESS_SF_TAG1_U_HNF_NID200, 0x1900ba0)
REG32(POR_HNF_SLC_CACHE_ACCESS_SF_TAG2_U_HNF_NID200, 0x1900ba8)
REG32(POR_HNF_SLC_LOCK_WAYS_U_HNF_NID200, 0x1900c00)
    FIELD(POR_HNF_SLC_LOCK_WAYS_U_HNF_NID200, RESERVED_15, 15, 49)
    FIELD(POR_HNF_SLC_LOCK_WAYS_U_HNF_NID200, NUM_HNF, 8, 7)
    FIELD(POR_HNF_SLC_LOCK_WAYS_U_HNF_NID200, WAYS, 0, 4)
REG32(POR_HNF_SLC_LOCK_BASE0_U_HNF_NID200, 0x1900c08)
    FIELD(POR_HNF_SLC_LOCK_BASE0_U_HNF_NID200, BASE0_VLD, 63, 1)
    FIELD(POR_HNF_SLC_LOCK_BASE0_U_HNF_NID200, RESERVED_48, 48, 15)
    FIELD(POR_HNF_SLC_LOCK_BASE0_U_HNF_NID200, BASE0, 0, 48)
REG32(POR_HNF_SLC_LOCK_BASE1_U_HNF_NID200, 0x1900c10)
    FIELD(POR_HNF_SLC_LOCK_BASE1_U_HNF_NID200, BASE1_VLD, 63, 1)
    FIELD(POR_HNF_SLC_LOCK_BASE1_U_HNF_NID200, RESERVED_48, 48, 15)
    FIELD(POR_HNF_SLC_LOCK_BASE1_U_HNF_NID200, BASE1, 0, 48)
REG32(POR_HNF_SLC_LOCK_BASE2_U_HNF_NID200, 0x1900c18)
    FIELD(POR_HNF_SLC_LOCK_BASE2_U_HNF_NID200, BASE2_VLD, 63, 1)
    FIELD(POR_HNF_SLC_LOCK_BASE2_U_HNF_NID200, RESERVED_48, 48, 15)
    FIELD(POR_HNF_SLC_LOCK_BASE2_U_HNF_NID200, BASE2, 0, 48)
REG32(POR_HNF_SLC_LOCK_BASE3_U_HNF_NID200, 0x1900c20)
    FIELD(POR_HNF_SLC_LOCK_BASE3_U_HNF_NID200, BASE3_VLD, 63, 1)
    FIELD(POR_HNF_SLC_LOCK_BASE3_U_HNF_NID200, RESERVED_48, 48, 15)
    FIELD(POR_HNF_SLC_LOCK_BASE3_U_HNF_NID200, BASE3, 0, 48)
REG32(POR_HNF_RNF_REGION_VEC1_U_HNF_NID200, 0x1900c28)
REG32(POR_HNF_RNI_REGION_VEC_U_HNF_NID200, 0x1900c30)
    FIELD(POR_HNF_RNI_REGION_VEC_U_HNF_NID200, RESERVED_32, 32, 32)
    FIELD(POR_HNF_RNI_REGION_VEC_U_HNF_NID200, RNI_REGION_VEC, 0, 32)
REG32(POR_HNF_RNF_REGION_VEC_U_HNF_NID200, 0x1900c38)
REG32(POR_HNF_RND_REGION_VEC_U_HNF_NID200, 0x1900c40)
    FIELD(POR_HNF_RND_REGION_VEC_U_HNF_NID200, RESERVED_32, 32, 32)
    FIELD(POR_HNF_RND_REGION_VEC_U_HNF_NID200, RND_REGION_VEC, 0, 32)
REG32(POR_HNF_SLCWAY_PARTITION0_RNF_VEC_U_HNF_NID200, 0x1900c48)
REG32(POR_HNF_SLCWAY_PARTITION1_RNF_VEC_U_HNF_NID200, 0x1900c50)
REG32(POR_HNF_SLCWAY_PARTITION2_RNF_VEC_U_HNF_NID200, 0x1900c58)
REG32(POR_HNF_SLCWAY_PARTITION3_RNF_VEC_U_HNF_NID200, 0x1900c60)
REG32(POR_HNF_SLCWAY_PARTITION0_RNI_VEC_U_HNF_NID200, 0x1900c68)
    FIELD(POR_HNF_SLCWAY_PARTITION0_RNI_VEC_U_HNF_NID200, RESERVED_32, 32, 32)
    FIELD(POR_HNF_SLCWAY_PARTITION0_RNI_VEC_U_HNF_NID200, RNI_VEC0, 0, 32)
REG32(POR_HNF_SLCWAY_PARTITION1_RNI_VEC_U_HNF_NID200, 0x1900c70)
    FIELD(POR_HNF_SLCWAY_PARTITION1_RNI_VEC_U_HNF_NID200, RESERVED_32, 32, 32)
    FIELD(POR_HNF_SLCWAY_PARTITION1_RNI_VEC_U_HNF_NID200, RNI_VEC1, 0, 32)
REG32(POR_HNF_SLCWAY_PARTITION2_RNI_VEC_U_HNF_NID200, 0x1900c78)
    FIELD(POR_HNF_SLCWAY_PARTITION2_RNI_VEC_U_HNF_NID200, RESERVED_32, 32, 32)
    FIELD(POR_HNF_SLCWAY_PARTITION2_RNI_VEC_U_HNF_NID200, RNI_VEC2, 0, 32)
REG32(POR_HNF_SLCWAY_PARTITION3_RNI_VEC_U_HNF_NID200, 0x1900c80)
    FIELD(POR_HNF_SLCWAY_PARTITION3_RNI_VEC_U_HNF_NID200, RESERVED_32, 32, 32)
    FIELD(POR_HNF_SLCWAY_PARTITION3_RNI_VEC_U_HNF_NID200, RNI_VEC3, 0, 32)
REG32(POR_HNF_SLCWAY_PARTITION0_RND_VEC_U_HNF_NID200, 0x1900c88)
    FIELD(POR_HNF_SLCWAY_PARTITION0_RND_VEC_U_HNF_NID200, RESERVED_32, 32, 32)
    FIELD(POR_HNF_SLCWAY_PARTITION0_RND_VEC_U_HNF_NID200, RND_VEC0, 0, 32)
REG32(POR_HNF_SLCWAY_PARTITION1_RND_VEC_U_HNF_NID200, 0x1900c90)
    FIELD(POR_HNF_SLCWAY_PARTITION1_RND_VEC_U_HNF_NID200, RESERVED_32, 32, 32)
    FIELD(POR_HNF_SLCWAY_PARTITION1_RND_VEC_U_HNF_NID200, RND_VEC1, 0, 32)
REG32(POR_HNF_SLCWAY_PARTITION2_RND_VEC_U_HNF_NID200, 0x1900c98)
    FIELD(POR_HNF_SLCWAY_PARTITION2_RND_VEC_U_HNF_NID200, RESERVED_32, 32, 32)
    FIELD(POR_HNF_SLCWAY_PARTITION2_RND_VEC_U_HNF_NID200, RND_VEC2, 0, 32)
REG32(POR_HNF_SLCWAY_PARTITION3_RND_VEC_U_HNF_NID200, 0x1900ca0)
    FIELD(POR_HNF_SLCWAY_PARTITION3_RND_VEC_U_HNF_NID200, RESERVED_32, 32, 32)
    FIELD(POR_HNF_SLCWAY_PARTITION3_RND_VEC_U_HNF_NID200, RND_VEC3, 0, 32)
REG32(POR_HNF_RN_REGION_LOCK_U_HNF_NID200, 0x1900ca8)
    FIELD(POR_HNF_RN_REGION_LOCK_U_HNF_NID200, RN_PICK_LOCKED_WAYS_ONLY, 1, 1)
    FIELD(POR_HNF_RN_REGION_LOCK_U_HNF_NID200, RN_REGION_LOCK_EN, 0, 1)
REG32(POR_HNF_SLCWAY_PARTITION0_RNF_VEC1_U_HNF_NID200, 0x1900cb0)
REG32(POR_HNF_SLCWAY_PARTITION1_RNF_VEC1_U_HNF_NID200, 0x1900cb8)
REG32(POR_HNF_SLCWAY_PARTITION2_RNF_VEC1_U_HNF_NID200, 0x1900cc0)
REG32(POR_HNF_SLCWAY_PARTITION3_RNF_VEC1_U_HNF_NID200, 0x1900cc8)
REG32(POR_HNF_SAM_CONTROL_U_HNF_NID200, 0x1900d00)
    FIELD(POR_HNF_SAM_CONTROL_U_HNF_NID200, HN_CFG_SAM_INV_TOP_ADDRESS_BIT, 63, 1)
    FIELD(POR_HNF_SAM_CONTROL_U_HNF_NID200, RESERVED_62, 62, 1)
    FIELD(POR_HNF_SAM_CONTROL_U_HNF_NID200, HN_CFG_SAM_TOP_ADDRESS_BIT2, 56, 6)
    FIELD(POR_HNF_SAM_CONTROL_U_HNF_NID200, RESERVED_54, 54, 2)
    FIELD(POR_HNF_SAM_CONTROL_U_HNF_NID200, HN_CFG_SAM_TOP_ADDRESS_BIT1, 48, 6)
    FIELD(POR_HNF_SAM_CONTROL_U_HNF_NID200, RESERVED_46, 46, 2)
    FIELD(POR_HNF_SAM_CONTROL_U_HNF_NID200, HN_CFG_SAM_TOP_ADDRESS_BIT0, 40, 6)
    FIELD(POR_HNF_SAM_CONTROL_U_HNF_NID200, RESERVED_38, 38, 2)
    FIELD(POR_HNF_SAM_CONTROL_U_HNF_NID200, HN_CFG_SIX_SN_EN, 37, 1)
    FIELD(POR_HNF_SAM_CONTROL_U_HNF_NID200, HN_CFG_THREE_SN_EN, 36, 1)
    FIELD(POR_HNF_SAM_CONTROL_U_HNF_NID200, RESERVED_35, 35, 1)
    FIELD(POR_HNF_SAM_CONTROL_U_HNF_NID200, HN_CFG_SN2_NODEID, 24, 11)
    FIELD(POR_HNF_SAM_CONTROL_U_HNF_NID200, RESERVED_23, 23, 1)
    FIELD(POR_HNF_SAM_CONTROL_U_HNF_NID200, HN_CFG_SN1_NODEID, 12, 11)
    FIELD(POR_HNF_SAM_CONTROL_U_HNF_NID200, RESERVED_11, 11, 1)
    FIELD(POR_HNF_SAM_CONTROL_U_HNF_NID200, HN_CFG_SN0_NODEID, 0, 11)
REG32(POR_HNF_SAM_MEMREGION0_U_HNF_NID200, 0x1900d08)
    FIELD(POR_HNF_SAM_MEMREGION0_U_HNF_NID200, VALID, 63, 1)
    FIELD(POR_HNF_SAM_MEMREGION0_U_HNF_NID200, RESERVED_48, 48, 15)
    FIELD(POR_HNF_SAM_MEMREGION0_U_HNF_NID200, BASE_ADDR, 26, 22)
    FIELD(POR_HNF_SAM_MEMREGION0_U_HNF_NID200, RESERVED_17, 17, 9)
    FIELD(POR_HNF_SAM_MEMREGION0_U_HNF_NID200, SIZE, 12, 5)
    FIELD(POR_HNF_SAM_MEMREGION0_U_HNF_NID200, RESERVED_11, 11, 1)
    FIELD(POR_HNF_SAM_MEMREGION0_U_HNF_NID200, RANGE0_NODEID, 0, 11)
REG32(POR_HNF_SAM_MEMREGION1_U_HNF_NID200, 0x1900d10)
    FIELD(POR_HNF_SAM_MEMREGION1_U_HNF_NID200, VALID, 63, 1)
    FIELD(POR_HNF_SAM_MEMREGION1_U_HNF_NID200, RESERVED_48, 48, 15)
    FIELD(POR_HNF_SAM_MEMREGION1_U_HNF_NID200, BASE_ADDR, 26, 22)
    FIELD(POR_HNF_SAM_MEMREGION1_U_HNF_NID200, RESERVED_17, 17, 9)
    FIELD(POR_HNF_SAM_MEMREGION1_U_HNF_NID200, SIZE, 12, 5)
    FIELD(POR_HNF_SAM_MEMREGION1_U_HNF_NID200, RESERVED_11, 11, 1)
    FIELD(POR_HNF_SAM_MEMREGION1_U_HNF_NID200, RANGE1_NODEID, 0, 11)
REG32(POR_HNF_SAM_SN_PROPERTIES_U_HNF_NID200, 0x1900d18)
    FIELD(POR_HNF_SAM_SN_PROPERTIES_U_HNF_NID200, RESERVED_45, 45, 19)
    FIELD(POR_HNF_SAM_SN_PROPERTIES_U_HNF_NID200, RANGE1_SN_PCMO_PROP_DIS, 44, 1)
    FIELD(POR_HNF_SAM_SN_PROPERTIES_U_HNF_NID200, RANGE1_SN_CMO_PROP_EN, 43, 1)
    FIELD(POR_HNF_SAM_SN_PROPERTIES_U_HNF_NID200, RANGE1_SN_128B, 42, 1)
    FIELD(POR_HNF_SAM_SN_PROPERTIES_U_HNF_NID200, RESERVED_39, 39, 3)
    FIELD(POR_HNF_SAM_SN_PROPERTIES_U_HNF_NID200, RANGE0_SN_PCMO_PROP_DIS, 38, 1)
    FIELD(POR_HNF_SAM_SN_PROPERTIES_U_HNF_NID200, RANGE0_SN_CMO_PROP_EN, 37, 1)
    FIELD(POR_HNF_SAM_SN_PROPERTIES_U_HNF_NID200, RANGE0_SN_128B, 36, 1)
    FIELD(POR_HNF_SAM_SN_PROPERTIES_U_HNF_NID200, RESERVED_33, 33, 3)
    FIELD(POR_HNF_SAM_SN_PROPERTIES_U_HNF_NID200, SN5_PCMO_PROP_DIS, 32, 1)
    FIELD(POR_HNF_SAM_SN_PROPERTIES_U_HNF_NID200, SN5_CMO_PROP_EN, 31, 1)
    FIELD(POR_HNF_SAM_SN_PROPERTIES_U_HNF_NID200, SN5_128B, 30, 1)
    FIELD(POR_HNF_SAM_SN_PROPERTIES_U_HNF_NID200, RESERVED_27, 27, 3)
    FIELD(POR_HNF_SAM_SN_PROPERTIES_U_HNF_NID200, SN4_PCMO_PROP_DIS, 26, 1)
    FIELD(POR_HNF_SAM_SN_PROPERTIES_U_HNF_NID200, SN4_CMO_PROP_EN, 25, 1)
    FIELD(POR_HNF_SAM_SN_PROPERTIES_U_HNF_NID200, SN4_128B, 24, 1)
    FIELD(POR_HNF_SAM_SN_PROPERTIES_U_HNF_NID200, RESERVED_21, 21, 3)
    FIELD(POR_HNF_SAM_SN_PROPERTIES_U_HNF_NID200, SN3_PCMO_PROP_DIS, 20, 1)
    FIELD(POR_HNF_SAM_SN_PROPERTIES_U_HNF_NID200, SN3_CMO_PROP_EN, 19, 1)
    FIELD(POR_HNF_SAM_SN_PROPERTIES_U_HNF_NID200, SN3_128B, 18, 1)
    FIELD(POR_HNF_SAM_SN_PROPERTIES_U_HNF_NID200, RESERVED_15, 15, 3)
    FIELD(POR_HNF_SAM_SN_PROPERTIES_U_HNF_NID200, SN2_PCMO_PROP_DIS, 14, 1)
    FIELD(POR_HNF_SAM_SN_PROPERTIES_U_HNF_NID200, SN2_CMO_PROP_EN, 13, 1)
    FIELD(POR_HNF_SAM_SN_PROPERTIES_U_HNF_NID200, SN2_128B, 12, 1)
    FIELD(POR_HNF_SAM_SN_PROPERTIES_U_HNF_NID200, RESERVED_9, 9, 3)
    FIELD(POR_HNF_SAM_SN_PROPERTIES_U_HNF_NID200, SN1_PCMO_PROP_DIS, 8, 1)
    FIELD(POR_HNF_SAM_SN_PROPERTIES_U_HNF_NID200, SN1_CMO_PROP_EN, 7, 1)
    FIELD(POR_HNF_SAM_SN_PROPERTIES_U_HNF_NID200, SN1_128B, 6, 1)
    FIELD(POR_HNF_SAM_SN_PROPERTIES_U_HNF_NID200, SN0_PCMO_PROP_DIS, 2, 1)
    FIELD(POR_HNF_SAM_SN_PROPERTIES_U_HNF_NID200, SN0_CMO_PROP_EN, 1, 1)
    FIELD(POR_HNF_SAM_SN_PROPERTIES_U_HNF_NID200, SN0_128B, 0, 1)
REG32(POR_HNF_SAM_6SN_NODEID_U_HNF_NID200, 0x1900d20)
    FIELD(POR_HNF_SAM_6SN_NODEID_U_HNF_NID200, RESERVED_35, 35, 29)
    FIELD(POR_HNF_SAM_6SN_NODEID_U_HNF_NID200, HN_CFG_SN5_NODEID, 24, 11)
    FIELD(POR_HNF_SAM_6SN_NODEID_U_HNF_NID200, RESERVED_23, 23, 1)
    FIELD(POR_HNF_SAM_6SN_NODEID_U_HNF_NID200, HN_CFG_SN4_NODEID, 12, 11)
    FIELD(POR_HNF_SAM_6SN_NODEID_U_HNF_NID200, RESERVED_11, 11, 1)
    FIELD(POR_HNF_SAM_6SN_NODEID_U_HNF_NID200, HN_CFG_SN3_NODEID, 0, 11)
REG32(POR_HNF_RN_PHYS_ID0_U_HNF_NID200, 0x1900d28)
    FIELD(POR_HNF_RN_PHYS_ID0_U_HNF_NID200, VALID_RA1, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID0_U_HNF_NID200, CPA_EN_RA1, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID0_U_HNF_NID200, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID0_U_HNF_NID200, CPA_GRP_RA1, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID0_U_HNF_NID200, REMOTE_RA1, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID0_U_HNF_NID200, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID0_U_HNF_NID200, NODEID_RA1, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID0_U_HNF_NID200, VALID_RA0, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID0_U_HNF_NID200, CPA_EN_RA0, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID0_U_HNF_NID200, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID0_U_HNF_NID200, CPA_GRP_RA0, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID0_U_HNF_NID200, REMOTE_RA0, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID0_U_HNF_NID200, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID0_U_HNF_NID200, NODEID_RA0, 0, 11)
REG32(POR_HNF_RN_PHYS_ID1_U_HNF_NID200, 0x1900d30)
    FIELD(POR_HNF_RN_PHYS_ID1_U_HNF_NID200, VALID_RA3, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID1_U_HNF_NID200, CPA_EN_RA3, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID1_U_HNF_NID200, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID1_U_HNF_NID200, CPA_GRP_RA3, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID1_U_HNF_NID200, REMOTE_RA3, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID1_U_HNF_NID200, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID1_U_HNF_NID200, NODEID_RA3, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID1_U_HNF_NID200, VALID_RA2, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID1_U_HNF_NID200, CPA_EN_RA2, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID1_U_HNF_NID200, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID1_U_HNF_NID200, CPA_GRP_RA2, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID1_U_HNF_NID200, REMOTE_RA2, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID1_U_HNF_NID200, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID1_U_HNF_NID200, NODEID_RA2, 0, 11)
REG32(POR_HNF_RN_PHYS_ID2_U_HNF_NID200, 0x1900d38)
    FIELD(POR_HNF_RN_PHYS_ID2_U_HNF_NID200, VALID_RA5, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID2_U_HNF_NID200, CPA_EN_RA5, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID2_U_HNF_NID200, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID2_U_HNF_NID200, CPA_GRP_RA5, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID2_U_HNF_NID200, REMOTE_RA5, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID2_U_HNF_NID200, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID2_U_HNF_NID200, NODEID_RA5, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID2_U_HNF_NID200, VALID_RA4, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID2_U_HNF_NID200, CPA_EN_RA4, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID2_U_HNF_NID200, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID2_U_HNF_NID200, CPA_GRP_RA4, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID2_U_HNF_NID200, REMOTE_RA4, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID2_U_HNF_NID200, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID2_U_HNF_NID200, NODEID_RA4, 0, 11)
REG32(POR_HNF_RN_PHYS_ID3_U_HNF_NID200, 0x1900d40)
    FIELD(POR_HNF_RN_PHYS_ID3_U_HNF_NID200, VALID_RA7, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID3_U_HNF_NID200, CPA_EN_RA7, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID3_U_HNF_NID200, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID3_U_HNF_NID200, CPA_GRP_RA7, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID3_U_HNF_NID200, REMOTE_RA7, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID3_U_HNF_NID200, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID3_U_HNF_NID200, NODEID_RA7, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID3_U_HNF_NID200, VALID_RA6, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID3_U_HNF_NID200, CPA_EN_RA6, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID3_U_HNF_NID200, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID3_U_HNF_NID200, CPA_GRP_RA6, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID3_U_HNF_NID200, REMOTE_RA6, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID3_U_HNF_NID200, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID3_U_HNF_NID200, NODEID_RA6, 0, 11)
REG32(POR_HNF_RN_PHYS_ID4_U_HNF_NID200, 0x1900d48)
    FIELD(POR_HNF_RN_PHYS_ID4_U_HNF_NID200, VALID_RA9, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID4_U_HNF_NID200, CPA_EN_RA9, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID4_U_HNF_NID200, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID4_U_HNF_NID200, CPA_GRP_RA9, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID4_U_HNF_NID200, REMOTE_RA9, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID4_U_HNF_NID200, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID4_U_HNF_NID200, NODEID_RA9, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID4_U_HNF_NID200, VALID_RA8, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID4_U_HNF_NID200, CPA_EN_RA8, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID4_U_HNF_NID200, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID4_U_HNF_NID200, CPA_GRP_RA8, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID4_U_HNF_NID200, REMOTE_RA8, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID4_U_HNF_NID200, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID4_U_HNF_NID200, NODEID_RA8, 0, 11)
REG32(POR_HNF_RN_PHYS_ID5_U_HNF_NID200, 0x1900d50)
    FIELD(POR_HNF_RN_PHYS_ID5_U_HNF_NID200, VALID_RA11, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID5_U_HNF_NID200, CPA_EN_RA11, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID5_U_HNF_NID200, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID5_U_HNF_NID200, CPA_GRP_RA11, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID5_U_HNF_NID200, REMOTE_RA11, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID5_U_HNF_NID200, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID5_U_HNF_NID200, NODEID_RA11, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID5_U_HNF_NID200, VALID_RA10, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID5_U_HNF_NID200, CPA_EN_RA10, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID5_U_HNF_NID200, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID5_U_HNF_NID200, CPA_GRP_RA10, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID5_U_HNF_NID200, REMOTE_RA10, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID5_U_HNF_NID200, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID5_U_HNF_NID200, NODEID_RA10, 0, 11)
REG32(POR_HNF_RN_PHYS_ID6_U_HNF_NID200, 0x1900d58)
    FIELD(POR_HNF_RN_PHYS_ID6_U_HNF_NID200, VALID_RA13, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID6_U_HNF_NID200, CPA_EN_RA13, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID6_U_HNF_NID200, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID6_U_HNF_NID200, CPA_GRP_RA13, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID6_U_HNF_NID200, REMOTE_RA13, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID6_U_HNF_NID200, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID6_U_HNF_NID200, NODEID_RA13, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID6_U_HNF_NID200, VALID_RA12, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID6_U_HNF_NID200, CPA_EN_RA12, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID6_U_HNF_NID200, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID6_U_HNF_NID200, CPA_GRP_RA12, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID6_U_HNF_NID200, REMOTE_RA12, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID6_U_HNF_NID200, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID6_U_HNF_NID200, NODEID_RA12, 0, 11)
REG32(POR_HNF_RN_PHYS_ID7_U_HNF_NID200, 0x1900d60)
    FIELD(POR_HNF_RN_PHYS_ID7_U_HNF_NID200, VALID_RA15, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID7_U_HNF_NID200, CPA_EN_RA15, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID7_U_HNF_NID200, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID7_U_HNF_NID200, CPA_GRP_RA15, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID7_U_HNF_NID200, REMOTE_RA15, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID7_U_HNF_NID200, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID7_U_HNF_NID200, NODEID_RA15, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID7_U_HNF_NID200, VALID_RA14, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID7_U_HNF_NID200, CPA_EN_RA14, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID7_U_HNF_NID200, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID7_U_HNF_NID200, CPA_GRP_RA14, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID7_U_HNF_NID200, REMOTE_RA14, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID7_U_HNF_NID200, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID7_U_HNF_NID200, NODEID_RA14, 0, 11)
REG32(POR_HNF_RN_PHYS_ID8_U_HNF_NID200, 0x1900d68)
    FIELD(POR_HNF_RN_PHYS_ID8_U_HNF_NID200, VALID_RA17, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID8_U_HNF_NID200, CPA_EN_RA17, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID8_U_HNF_NID200, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID8_U_HNF_NID200, CPA_GRP_RA17, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID8_U_HNF_NID200, REMOTE_RA17, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID8_U_HNF_NID200, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID8_U_HNF_NID200, NODEID_RA17, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID8_U_HNF_NID200, VALID_RA16, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID8_U_HNF_NID200, CPA_EN_RA16, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID8_U_HNF_NID200, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID8_U_HNF_NID200, CPA_GRP_RA16, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID8_U_HNF_NID200, REMOTE_RA16, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID8_U_HNF_NID200, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID8_U_HNF_NID200, NODEID_RA16, 0, 11)
REG32(POR_HNF_RN_PHYS_ID9_U_HNF_NID200, 0x1900d70)
    FIELD(POR_HNF_RN_PHYS_ID9_U_HNF_NID200, VALID_RA19, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID9_U_HNF_NID200, CPA_EN_RA19, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID9_U_HNF_NID200, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID9_U_HNF_NID200, CPA_GRP_RA19, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID9_U_HNF_NID200, REMOTE_RA19, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID9_U_HNF_NID200, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID9_U_HNF_NID200, NODEID_RA19, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID9_U_HNF_NID200, VALID_RA18, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID9_U_HNF_NID200, CPA_EN_RA18, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID9_U_HNF_NID200, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID9_U_HNF_NID200, CPA_GRP_RA18, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID9_U_HNF_NID200, REMOTE_RA18, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID9_U_HNF_NID200, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID9_U_HNF_NID200, NODEID_RA18, 0, 11)
REG32(POR_HNF_RN_PHYS_ID10_U_HNF_NID200, 0x1900d78)
    FIELD(POR_HNF_RN_PHYS_ID10_U_HNF_NID200, VALID_RA21, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID10_U_HNF_NID200, CPA_EN_RA21, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID10_U_HNF_NID200, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID10_U_HNF_NID200, CPA_GRP_RA21, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID10_U_HNF_NID200, REMOTE_RA21, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID10_U_HNF_NID200, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID10_U_HNF_NID200, NODEID_RA21, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID10_U_HNF_NID200, VALID_RA20, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID10_U_HNF_NID200, CPA_EN_RA20, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID10_U_HNF_NID200, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID10_U_HNF_NID200, CPA_GRP_RA20, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID10_U_HNF_NID200, REMOTE_RA20, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID10_U_HNF_NID200, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID10_U_HNF_NID200, NODEID_RA20, 0, 11)
REG32(POR_HNF_RN_PHYS_ID11_U_HNF_NID200, 0x1900d80)
    FIELD(POR_HNF_RN_PHYS_ID11_U_HNF_NID200, VALID_RA23, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID11_U_HNF_NID200, CPA_EN_RA23, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID11_U_HNF_NID200, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID11_U_HNF_NID200, CPA_GRP_RA23, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID11_U_HNF_NID200, REMOTE_RA23, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID11_U_HNF_NID200, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID11_U_HNF_NID200, NODEID_RA23, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID11_U_HNF_NID200, VALID_RA22, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID11_U_HNF_NID200, CPA_EN_RA22, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID11_U_HNF_NID200, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID11_U_HNF_NID200, CPA_GRP_RA22, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID11_U_HNF_NID200, REMOTE_RA22, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID11_U_HNF_NID200, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID11_U_HNF_NID200, NODEID_RA22, 0, 11)
REG32(POR_HNF_RN_PHYS_ID12_U_HNF_NID200, 0x1900d88)
    FIELD(POR_HNF_RN_PHYS_ID12_U_HNF_NID200, VALID_RA25, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID12_U_HNF_NID200, CPA_EN_RA25, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID12_U_HNF_NID200, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID12_U_HNF_NID200, CPA_GRP_RA25, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID12_U_HNF_NID200, REMOTE_RA25, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID12_U_HNF_NID200, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID12_U_HNF_NID200, NODEID_RA25, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID12_U_HNF_NID200, VALID_RA24, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID12_U_HNF_NID200, CPA_EN_RA24, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID12_U_HNF_NID200, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID12_U_HNF_NID200, CPA_GRP_RA24, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID12_U_HNF_NID200, REMOTE_RA24, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID12_U_HNF_NID200, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID12_U_HNF_NID200, NODEID_RA24, 0, 11)
REG32(POR_HNF_RN_PHYS_ID13_U_HNF_NID200, 0x1900d90)
    FIELD(POR_HNF_RN_PHYS_ID13_U_HNF_NID200, VALID_RA27, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID13_U_HNF_NID200, CPA_EN_RA27, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID13_U_HNF_NID200, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID13_U_HNF_NID200, CPA_GRP_RA27, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID13_U_HNF_NID200, REMOTE_RA27, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID13_U_HNF_NID200, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID13_U_HNF_NID200, NODEID_RA27, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID13_U_HNF_NID200, VALID_RA26, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID13_U_HNF_NID200, CPA_EN_RA26, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID13_U_HNF_NID200, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID13_U_HNF_NID200, CPA_GRP_RA26, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID13_U_HNF_NID200, REMOTE_RA26, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID13_U_HNF_NID200, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID13_U_HNF_NID200, NODEID_RA26, 0, 11)
REG32(POR_HNF_RN_PHYS_ID14_U_HNF_NID200, 0x1900d98)
    FIELD(POR_HNF_RN_PHYS_ID14_U_HNF_NID200, VALID_RA29, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID14_U_HNF_NID200, CPA_EN_RA29, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID14_U_HNF_NID200, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID14_U_HNF_NID200, CPA_GRP_RA29, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID14_U_HNF_NID200, REMOTE_RA29, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID14_U_HNF_NID200, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID14_U_HNF_NID200, NODEID_RA29, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID14_U_HNF_NID200, VALID_RA28, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID14_U_HNF_NID200, CPA_EN_RA28, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID14_U_HNF_NID200, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID14_U_HNF_NID200, CPA_GRP_RA28, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID14_U_HNF_NID200, REMOTE_RA28, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID14_U_HNF_NID200, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID14_U_HNF_NID200, NODEID_RA28, 0, 11)
REG32(POR_HNF_RN_PHYS_ID15_U_HNF_NID200, 0x1900da0)
    FIELD(POR_HNF_RN_PHYS_ID15_U_HNF_NID200, VALID_RA31, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID15_U_HNF_NID200, CPA_EN_RA31, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID15_U_HNF_NID200, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID15_U_HNF_NID200, CPA_GRP_RA31, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID15_U_HNF_NID200, REMOTE_RA31, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID15_U_HNF_NID200, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID15_U_HNF_NID200, NODEID_RA31, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID15_U_HNF_NID200, VALID_RA30, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID15_U_HNF_NID200, CPA_EN_RA30, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID15_U_HNF_NID200, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID15_U_HNF_NID200, CPA_GRP_RA30, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID15_U_HNF_NID200, REMOTE_RA30, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID15_U_HNF_NID200, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID15_U_HNF_NID200, NODEID_RA30, 0, 11)
REG32(POR_HNF_RN_PHYS_ID16_U_HNF_NID200, 0x1900da8)
    FIELD(POR_HNF_RN_PHYS_ID16_U_HNF_NID200, VALID_RA33, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID16_U_HNF_NID200, CPA_EN_RA33, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID16_U_HNF_NID200, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID16_U_HNF_NID200, CPA_GRP_RA33, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID16_U_HNF_NID200, REMOTE_RA33, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID16_U_HNF_NID200, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID16_U_HNF_NID200, NODEID_RA33, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID16_U_HNF_NID200, VALID_RA32, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID16_U_HNF_NID200, CPA_EN_RA32, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID16_U_HNF_NID200, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID16_U_HNF_NID200, CPA_GRP_RA32, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID16_U_HNF_NID200, REMOTE_RA32, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID16_U_HNF_NID200, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID16_U_HNF_NID200, NODEID_RA32, 0, 11)
REG32(POR_HNF_RN_PHYS_ID17_U_HNF_NID200, 0x1900db0)
    FIELD(POR_HNF_RN_PHYS_ID17_U_HNF_NID200, VALID_RA35, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID17_U_HNF_NID200, CPA_EN_RA35, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID17_U_HNF_NID200, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID17_U_HNF_NID200, CPA_GRP_RA35, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID17_U_HNF_NID200, REMOTE_RA35, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID17_U_HNF_NID200, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID17_U_HNF_NID200, NODEID_RA35, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID17_U_HNF_NID200, VALID_RA34, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID17_U_HNF_NID200, CPA_EN_RA34, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID17_U_HNF_NID200, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID17_U_HNF_NID200, CPA_GRP_RA34, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID17_U_HNF_NID200, REMOTE_RA34, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID17_U_HNF_NID200, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID17_U_HNF_NID200, NODEID_RA34, 0, 11)
REG32(POR_HNF_RN_PHYS_ID18_U_HNF_NID200, 0x1900db8)
    FIELD(POR_HNF_RN_PHYS_ID18_U_HNF_NID200, VALID_RA37, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID18_U_HNF_NID200, CPA_EN_RA37, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID18_U_HNF_NID200, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID18_U_HNF_NID200, CPA_GRP_RA37, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID18_U_HNF_NID200, REMOTE_RA37, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID18_U_HNF_NID200, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID18_U_HNF_NID200, NODEID_RA37, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID18_U_HNF_NID200, VALID_RA36, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID18_U_HNF_NID200, CPA_EN_RA36, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID18_U_HNF_NID200, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID18_U_HNF_NID200, CPA_GRP_RA36, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID18_U_HNF_NID200, REMOTE_RA36, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID18_U_HNF_NID200, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID18_U_HNF_NID200, NODEID_RA36, 0, 11)
REG32(POR_HNF_RN_PHYS_ID19_U_HNF_NID200, 0x1900dc0)
    FIELD(POR_HNF_RN_PHYS_ID19_U_HNF_NID200, VALID_RA39, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID19_U_HNF_NID200, CPA_EN_RA39, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID19_U_HNF_NID200, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID19_U_HNF_NID200, CPA_GRP_RA39, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID19_U_HNF_NID200, REMOTE_RA39, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID19_U_HNF_NID200, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID19_U_HNF_NID200, NODEID_RA39, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID19_U_HNF_NID200, VALID_RA38, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID19_U_HNF_NID200, CPA_EN_RA38, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID19_U_HNF_NID200, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID19_U_HNF_NID200, CPA_GRP_RA38, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID19_U_HNF_NID200, REMOTE_RA38, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID19_U_HNF_NID200, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID19_U_HNF_NID200, NODEID_RA38, 0, 11)
REG32(POR_HNF_RN_PHYS_ID20_U_HNF_NID200, 0x1900dc8)
    FIELD(POR_HNF_RN_PHYS_ID20_U_HNF_NID200, VALID_RA41, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID20_U_HNF_NID200, CPA_EN_RA41, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID20_U_HNF_NID200, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID20_U_HNF_NID200, CPA_GRP_RA41, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID20_U_HNF_NID200, REMOTE_RA41, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID20_U_HNF_NID200, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID20_U_HNF_NID200, NODEID_RA41, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID20_U_HNF_NID200, VALID_RA40, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID20_U_HNF_NID200, CPA_EN_RA40, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID20_U_HNF_NID200, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID20_U_HNF_NID200, CPA_GRP_RA40, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID20_U_HNF_NID200, REMOTE_RA40, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID20_U_HNF_NID200, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID20_U_HNF_NID200, NODEID_RA40, 0, 11)
REG32(POR_HNF_RN_PHYS_ID21_U_HNF_NID200, 0x1900dd0)
    FIELD(POR_HNF_RN_PHYS_ID21_U_HNF_NID200, VALID_RA43, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID21_U_HNF_NID200, CPA_EN_RA43, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID21_U_HNF_NID200, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID21_U_HNF_NID200, CPA_GRP_RA43, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID21_U_HNF_NID200, REMOTE_RA43, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID21_U_HNF_NID200, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID21_U_HNF_NID200, NODEID_RA43, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID21_U_HNF_NID200, VALID_RA42, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID21_U_HNF_NID200, CPA_EN_RA42, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID21_U_HNF_NID200, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID21_U_HNF_NID200, CPA_GRP_RA42, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID21_U_HNF_NID200, REMOTE_RA42, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID21_U_HNF_NID200, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID21_U_HNF_NID200, NODEID_RA42, 0, 11)
REG32(POR_HNF_RN_PHYS_ID22_U_HNF_NID200, 0x1900dd8)
    FIELD(POR_HNF_RN_PHYS_ID22_U_HNF_NID200, VALID_RA45, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID22_U_HNF_NID200, CPA_EN_RA45, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID22_U_HNF_NID200, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID22_U_HNF_NID200, CPA_GRP_RA45, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID22_U_HNF_NID200, REMOTE_RA45, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID22_U_HNF_NID200, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID22_U_HNF_NID200, NODEID_RA45, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID22_U_HNF_NID200, VALID_RA44, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID22_U_HNF_NID200, CPA_EN_RA44, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID22_U_HNF_NID200, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID22_U_HNF_NID200, CPA_GRP_RA44, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID22_U_HNF_NID200, REMOTE_RA44, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID22_U_HNF_NID200, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID22_U_HNF_NID200, NODEID_RA44, 0, 11)
REG32(POR_HNF_RN_PHYS_ID23_U_HNF_NID200, 0x1900de0)
    FIELD(POR_HNF_RN_PHYS_ID23_U_HNF_NID200, VALID_RA47, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID23_U_HNF_NID200, CPA_EN_RA47, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID23_U_HNF_NID200, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID23_U_HNF_NID200, CPA_GRP_RA47, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID23_U_HNF_NID200, REMOTE_RA47, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID23_U_HNF_NID200, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID23_U_HNF_NID200, NODEID_RA47, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID23_U_HNF_NID200, VALID_RA46, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID23_U_HNF_NID200, CPA_EN_RA46, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID23_U_HNF_NID200, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID23_U_HNF_NID200, CPA_GRP_RA46, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID23_U_HNF_NID200, REMOTE_RA46, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID23_U_HNF_NID200, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID23_U_HNF_NID200, NODEID_RA46, 0, 11)
REG32(POR_HNF_RN_PHYS_ID24_U_HNF_NID200, 0x1900de8)
    FIELD(POR_HNF_RN_PHYS_ID24_U_HNF_NID200, VALID_RA49, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID24_U_HNF_NID200, CPA_EN_RA49, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID24_U_HNF_NID200, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID24_U_HNF_NID200, CPA_GRP_RA49, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID24_U_HNF_NID200, REMOTE_RA49, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID24_U_HNF_NID200, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID24_U_HNF_NID200, NODEID_RA49, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID24_U_HNF_NID200, VALID_RA48, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID24_U_HNF_NID200, CPA_EN_RA48, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID24_U_HNF_NID200, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID24_U_HNF_NID200, CPA_GRP_RA48, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID24_U_HNF_NID200, REMOTE_RA48, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID24_U_HNF_NID200, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID24_U_HNF_NID200, NODEID_RA48, 0, 11)
REG32(POR_HNF_RN_PHYS_ID25_U_HNF_NID200, 0x1900df0)
    FIELD(POR_HNF_RN_PHYS_ID25_U_HNF_NID200, VALID_RA51, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID25_U_HNF_NID200, CPA_EN_RA51, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID25_U_HNF_NID200, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID25_U_HNF_NID200, CPA_GRP_RA51, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID25_U_HNF_NID200, REMOTE_RA51, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID25_U_HNF_NID200, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID25_U_HNF_NID200, NODEID_RA51, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID25_U_HNF_NID200, VALID_RA50, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID25_U_HNF_NID200, CPA_EN_RA50, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID25_U_HNF_NID200, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID25_U_HNF_NID200, CPA_GRP_RA50, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID25_U_HNF_NID200, REMOTE_RA50, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID25_U_HNF_NID200, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID25_U_HNF_NID200, NODEID_RA50, 0, 11)
REG32(POR_HNF_RN_PHYS_ID26_U_HNF_NID200, 0x1900df8)
    FIELD(POR_HNF_RN_PHYS_ID26_U_HNF_NID200, VALID_RA53, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID26_U_HNF_NID200, CPA_EN_RA53, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID26_U_HNF_NID200, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID26_U_HNF_NID200, CPA_GRP_RA53, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID26_U_HNF_NID200, REMOTE_RA53, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID26_U_HNF_NID200, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID26_U_HNF_NID200, NODEID_RA53, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID26_U_HNF_NID200, VALID_RA52, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID26_U_HNF_NID200, CPA_EN_RA52, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID26_U_HNF_NID200, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID26_U_HNF_NID200, CPA_GRP_RA52, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID26_U_HNF_NID200, REMOTE_RA52, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID26_U_HNF_NID200, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID26_U_HNF_NID200, NODEID_RA52, 0, 11)
REG32(POR_HNF_RN_PHYS_ID27_U_HNF_NID200, 0x1900e00)
    FIELD(POR_HNF_RN_PHYS_ID27_U_HNF_NID200, VALID_RA55, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID27_U_HNF_NID200, CPA_EN_RA55, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID27_U_HNF_NID200, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID27_U_HNF_NID200, CPA_GRP_RA55, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID27_U_HNF_NID200, REMOTE_RA55, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID27_U_HNF_NID200, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID27_U_HNF_NID200, NODEID_RA55, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID27_U_HNF_NID200, VALID_RA54, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID27_U_HNF_NID200, CPA_EN_RA54, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID27_U_HNF_NID200, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID27_U_HNF_NID200, CPA_GRP_RA54, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID27_U_HNF_NID200, REMOTE_RA54, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID27_U_HNF_NID200, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID27_U_HNF_NID200, NODEID_RA54, 0, 11)
REG32(POR_HNF_RN_PHYS_ID28_U_HNF_NID200, 0x1900e08)
    FIELD(POR_HNF_RN_PHYS_ID28_U_HNF_NID200, VALID_RA57, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID28_U_HNF_NID200, CPA_EN_RA57, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID28_U_HNF_NID200, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID28_U_HNF_NID200, CPA_GRP_RA57, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID28_U_HNF_NID200, REMOTE_RA57, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID28_U_HNF_NID200, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID28_U_HNF_NID200, NODEID_RA57, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID28_U_HNF_NID200, VALID_RA56, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID28_U_HNF_NID200, CPA_EN_RA56, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID28_U_HNF_NID200, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID28_U_HNF_NID200, CPA_GRP_RA56, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID28_U_HNF_NID200, REMOTE_RA56, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID28_U_HNF_NID200, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID28_U_HNF_NID200, NODEID_RA56, 0, 11)
REG32(POR_HNF_RN_PHYS_ID29_U_HNF_NID200, 0x1900e10)
    FIELD(POR_HNF_RN_PHYS_ID29_U_HNF_NID200, VALID_RA59, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID29_U_HNF_NID200, CPA_EN_RA59, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID29_U_HNF_NID200, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID29_U_HNF_NID200, CPA_GRP_RA59, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID29_U_HNF_NID200, REMOTE_RA59, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID29_U_HNF_NID200, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID29_U_HNF_NID200, NODEID_RA59, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID29_U_HNF_NID200, VALID_RA58, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID29_U_HNF_NID200, CPA_EN_RA58, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID29_U_HNF_NID200, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID29_U_HNF_NID200, CPA_GRP_RA58, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID29_U_HNF_NID200, REMOTE_RA58, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID29_U_HNF_NID200, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID29_U_HNF_NID200, NODEID_RA58, 0, 11)
REG32(POR_HNF_RN_PHYS_ID30_U_HNF_NID200, 0x1900e18)
    FIELD(POR_HNF_RN_PHYS_ID30_U_HNF_NID200, VALID_RA61, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID30_U_HNF_NID200, CPA_EN_RA61, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID30_U_HNF_NID200, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID30_U_HNF_NID200, CPA_GRP_RA61, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID30_U_HNF_NID200, REMOTE_RA61, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID30_U_HNF_NID200, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID30_U_HNF_NID200, NODEID_RA61, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID30_U_HNF_NID200, VALID_RA60, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID30_U_HNF_NID200, CPA_EN_RA60, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID30_U_HNF_NID200, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID30_U_HNF_NID200, CPA_GRP_RA60, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID30_U_HNF_NID200, REMOTE_RA60, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID30_U_HNF_NID200, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID30_U_HNF_NID200, NODEID_RA60, 0, 11)
REG32(POR_HNF_RN_PHYS_ID31_U_HNF_NID200, 0x1900e20)
    FIELD(POR_HNF_RN_PHYS_ID31_U_HNF_NID200, VALID_RA63, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID31_U_HNF_NID200, CPA_EN_RA63, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID31_U_HNF_NID200, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID31_U_HNF_NID200, CPA_GRP_RA63, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID31_U_HNF_NID200, REMOTE_RA63, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID31_U_HNF_NID200, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID31_U_HNF_NID200, NODEID_RA63, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID31_U_HNF_NID200, VALID_RA62, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID31_U_HNF_NID200, CPA_EN_RA62, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID31_U_HNF_NID200, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID31_U_HNF_NID200, CPA_GRP_RA62, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID31_U_HNF_NID200, REMOTE_RA62, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID31_U_HNF_NID200, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID31_U_HNF_NID200, NODEID_RA62, 0, 11)
REG32(POR_HNF_RN_PHYS_ID32_U_HNF_NID200, 0x1900e28)
    FIELD(POR_HNF_RN_PHYS_ID32_U_HNF_NID200, VALID_RA65, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID32_U_HNF_NID200, CPA_EN_RA65, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID32_U_HNF_NID200, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID32_U_HNF_NID200, CPA_GRP_RA65, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID32_U_HNF_NID200, REMOTE_RA65, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID32_U_HNF_NID200, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID32_U_HNF_NID200, NODEID_RA65, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID32_U_HNF_NID200, VALID_RA64, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID32_U_HNF_NID200, CPA_EN_RA64, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID32_U_HNF_NID200, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID32_U_HNF_NID200, CPA_GRP_RA64, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID32_U_HNF_NID200, REMOTE_RA64, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID32_U_HNF_NID200, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID32_U_HNF_NID200, NODEID_RA64, 0, 11)
REG32(POR_HNF_RN_PHYS_ID33_U_HNF_NID200, 0x1900e30)
    FIELD(POR_HNF_RN_PHYS_ID33_U_HNF_NID200, VALID_RA67, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID33_U_HNF_NID200, CPA_EN_RA67, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID33_U_HNF_NID200, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID33_U_HNF_NID200, CPA_GRP_RA67, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID33_U_HNF_NID200, REMOTE_RA67, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID33_U_HNF_NID200, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID33_U_HNF_NID200, NODEID_RA67, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID33_U_HNF_NID200, VALID_RA66, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID33_U_HNF_NID200, CPA_EN_RA66, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID33_U_HNF_NID200, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID33_U_HNF_NID200, CPA_GRP_RA66, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID33_U_HNF_NID200, REMOTE_RA66, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID33_U_HNF_NID200, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID33_U_HNF_NID200, NODEID_RA66, 0, 11)
REG32(POR_HNF_RN_PHYS_ID34_U_HNF_NID200, 0x1900e38)
    FIELD(POR_HNF_RN_PHYS_ID34_U_HNF_NID200, VALID_RA69, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID34_U_HNF_NID200, CPA_EN_RA69, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID34_U_HNF_NID200, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID34_U_HNF_NID200, CPA_GRP_RA69, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID34_U_HNF_NID200, REMOTE_RA69, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID34_U_HNF_NID200, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID34_U_HNF_NID200, NODEID_RA69, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID34_U_HNF_NID200, VALID_RA68, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID34_U_HNF_NID200, CPA_EN_RA68, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID34_U_HNF_NID200, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID34_U_HNF_NID200, CPA_GRP_RA68, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID34_U_HNF_NID200, REMOTE_RA68, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID34_U_HNF_NID200, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID34_U_HNF_NID200, NODEID_RA68, 0, 11)
REG32(POR_HNF_RN_PHYS_ID35_U_HNF_NID200, 0x1900e40)
    FIELD(POR_HNF_RN_PHYS_ID35_U_HNF_NID200, VALID_RA71, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID35_U_HNF_NID200, CPA_EN_RA71, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID35_U_HNF_NID200, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID35_U_HNF_NID200, CPA_GRP_RA71, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID35_U_HNF_NID200, REMOTE_RA71, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID35_U_HNF_NID200, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID35_U_HNF_NID200, NODEID_RA71, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID35_U_HNF_NID200, VALID_RA70, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID35_U_HNF_NID200, CPA_EN_RA70, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID35_U_HNF_NID200, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID35_U_HNF_NID200, CPA_GRP_RA70, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID35_U_HNF_NID200, REMOTE_RA70, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID35_U_HNF_NID200, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID35_U_HNF_NID200, NODEID_RA70, 0, 11)
REG32(POR_HNF_RN_PHYS_ID36_U_HNF_NID200, 0x1900e48)
    FIELD(POR_HNF_RN_PHYS_ID36_U_HNF_NID200, VALID_RA73, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID36_U_HNF_NID200, CPA_EN_RA73, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID36_U_HNF_NID200, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID36_U_HNF_NID200, CPA_GRP_RA73, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID36_U_HNF_NID200, REMOTE_RA73, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID36_U_HNF_NID200, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID36_U_HNF_NID200, NODEID_RA73, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID36_U_HNF_NID200, VALID_RA72, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID36_U_HNF_NID200, CPA_EN_RA72, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID36_U_HNF_NID200, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID36_U_HNF_NID200, CPA_GRP_RA72, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID36_U_HNF_NID200, REMOTE_RA72, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID36_U_HNF_NID200, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID36_U_HNF_NID200, NODEID_RA72, 0, 11)
REG32(POR_HNF_RN_PHYS_ID37_U_HNF_NID200, 0x1900e50)
    FIELD(POR_HNF_RN_PHYS_ID37_U_HNF_NID200, VALID_RA75, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID37_U_HNF_NID200, CPA_EN_RA75, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID37_U_HNF_NID200, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID37_U_HNF_NID200, CPA_GRP_RA75, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID37_U_HNF_NID200, REMOTE_RA75, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID37_U_HNF_NID200, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID37_U_HNF_NID200, NODEID_RA75, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID37_U_HNF_NID200, VALID_RA74, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID37_U_HNF_NID200, CPA_EN_RA74, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID37_U_HNF_NID200, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID37_U_HNF_NID200, CPA_GRP_RA74, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID37_U_HNF_NID200, REMOTE_RA74, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID37_U_HNF_NID200, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID37_U_HNF_NID200, NODEID_RA74, 0, 11)
REG32(POR_HNF_RN_PHYS_ID38_U_HNF_NID200, 0x1900e58)
    FIELD(POR_HNF_RN_PHYS_ID38_U_HNF_NID200, VALID_RA77, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID38_U_HNF_NID200, CPA_EN_RA77, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID38_U_HNF_NID200, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID38_U_HNF_NID200, CPA_GRP_RA77, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID38_U_HNF_NID200, REMOTE_RA77, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID38_U_HNF_NID200, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID38_U_HNF_NID200, NODEID_RA77, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID38_U_HNF_NID200, VALID_RA76, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID38_U_HNF_NID200, CPA_EN_RA76, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID38_U_HNF_NID200, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID38_U_HNF_NID200, CPA_GRP_RA76, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID38_U_HNF_NID200, REMOTE_RA76, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID38_U_HNF_NID200, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID38_U_HNF_NID200, NODEID_RA76, 0, 11)
REG32(POR_HNF_RN_PHYS_ID39_U_HNF_NID200, 0x1900e60)
    FIELD(POR_HNF_RN_PHYS_ID39_U_HNF_NID200, VALID_RA79, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID39_U_HNF_NID200, CPA_EN_RA79, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID39_U_HNF_NID200, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID39_U_HNF_NID200, CPA_GRP_RA79, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID39_U_HNF_NID200, REMOTE_RA79, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID39_U_HNF_NID200, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID39_U_HNF_NID200, NODEID_RA79, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID39_U_HNF_NID200, VALID_RA78, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID39_U_HNF_NID200, CPA_EN_RA78, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID39_U_HNF_NID200, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID39_U_HNF_NID200, CPA_GRP_RA78, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID39_U_HNF_NID200, REMOTE_RA78, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID39_U_HNF_NID200, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID39_U_HNF_NID200, NODEID_RA78, 0, 11)
REG32(POR_HNF_RN_PHYS_ID40_U_HNF_NID200, 0x1900e68)
    FIELD(POR_HNF_RN_PHYS_ID40_U_HNF_NID200, VALID_RA81, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID40_U_HNF_NID200, CPA_EN_RA81, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID40_U_HNF_NID200, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID40_U_HNF_NID200, CPA_GRP_RA81, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID40_U_HNF_NID200, REMOTE_RA81, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID40_U_HNF_NID200, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID40_U_HNF_NID200, NODEID_RA81, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID40_U_HNF_NID200, VALID_RA80, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID40_U_HNF_NID200, CPA_EN_RA80, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID40_U_HNF_NID200, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID40_U_HNF_NID200, CPA_GRP_RA80, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID40_U_HNF_NID200, REMOTE_RA80, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID40_U_HNF_NID200, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID40_U_HNF_NID200, NODEID_RA80, 0, 11)
REG32(POR_HNF_RN_PHYS_ID41_U_HNF_NID200, 0x1900e70)
    FIELD(POR_HNF_RN_PHYS_ID41_U_HNF_NID200, VALID_RA83, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID41_U_HNF_NID200, CPA_EN_RA83, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID41_U_HNF_NID200, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID41_U_HNF_NID200, CPA_GRP_RA83, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID41_U_HNF_NID200, REMOTE_RA83, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID41_U_HNF_NID200, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID41_U_HNF_NID200, NODEID_RA83, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID41_U_HNF_NID200, VALID_RA82, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID41_U_HNF_NID200, CPA_EN_RA82, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID41_U_HNF_NID200, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID41_U_HNF_NID200, CPA_GRP_RA82, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID41_U_HNF_NID200, REMOTE_RA82, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID41_U_HNF_NID200, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID41_U_HNF_NID200, NODEID_RA82, 0, 11)
REG32(POR_HNF_RN_PHYS_ID42_U_HNF_NID200, 0x1900e78)
    FIELD(POR_HNF_RN_PHYS_ID42_U_HNF_NID200, VALID_RA85, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID42_U_HNF_NID200, CPA_EN_RA85, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID42_U_HNF_NID200, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID42_U_HNF_NID200, CPA_GRP_RA85, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID42_U_HNF_NID200, REMOTE_RA85, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID42_U_HNF_NID200, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID42_U_HNF_NID200, NODEID_RA85, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID42_U_HNF_NID200, VALID_RA84, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID42_U_HNF_NID200, CPA_EN_RA84, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID42_U_HNF_NID200, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID42_U_HNF_NID200, CPA_GRP_RA84, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID42_U_HNF_NID200, REMOTE_RA84, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID42_U_HNF_NID200, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID42_U_HNF_NID200, NODEID_RA84, 0, 11)
REG32(POR_HNF_RN_PHYS_ID43_U_HNF_NID200, 0x1900e80)
    FIELD(POR_HNF_RN_PHYS_ID43_U_HNF_NID200, VALID_RA87, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID43_U_HNF_NID200, CPA_EN_RA87, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID43_U_HNF_NID200, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID43_U_HNF_NID200, CPA_GRP_RA87, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID43_U_HNF_NID200, REMOTE_RA87, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID43_U_HNF_NID200, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID43_U_HNF_NID200, NODEID_RA87, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID43_U_HNF_NID200, VALID_RA86, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID43_U_HNF_NID200, CPA_EN_RA86, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID43_U_HNF_NID200, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID43_U_HNF_NID200, CPA_GRP_RA86, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID43_U_HNF_NID200, REMOTE_RA86, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID43_U_HNF_NID200, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID43_U_HNF_NID200, NODEID_RA86, 0, 11)
REG32(POR_HNF_RN_PHYS_ID44_U_HNF_NID200, 0x1900e88)
    FIELD(POR_HNF_RN_PHYS_ID44_U_HNF_NID200, VALID_RA89, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID44_U_HNF_NID200, CPA_EN_RA89, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID44_U_HNF_NID200, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID44_U_HNF_NID200, CPA_GRP_RA89, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID44_U_HNF_NID200, REMOTE_RA89, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID44_U_HNF_NID200, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID44_U_HNF_NID200, NODEID_RA89, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID44_U_HNF_NID200, VALID_RA88, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID44_U_HNF_NID200, CPA_EN_RA88, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID44_U_HNF_NID200, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID44_U_HNF_NID200, CPA_GRP_RA88, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID44_U_HNF_NID200, REMOTE_RA88, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID44_U_HNF_NID200, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID44_U_HNF_NID200, NODEID_RA88, 0, 11)
REG32(POR_HNF_RN_PHYS_ID45_U_HNF_NID200, 0x1900e90)
    FIELD(POR_HNF_RN_PHYS_ID45_U_HNF_NID200, VALID_RA91, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID45_U_HNF_NID200, CPA_EN_RA91, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID45_U_HNF_NID200, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID45_U_HNF_NID200, CPA_GRP_RA91, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID45_U_HNF_NID200, REMOTE_RA91, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID45_U_HNF_NID200, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID45_U_HNF_NID200, NODEID_RA91, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID45_U_HNF_NID200, VALID_RA90, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID45_U_HNF_NID200, CPA_EN_RA90, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID45_U_HNF_NID200, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID45_U_HNF_NID200, CPA_GRP_RA90, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID45_U_HNF_NID200, REMOTE_RA90, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID45_U_HNF_NID200, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID45_U_HNF_NID200, NODEID_RA90, 0, 11)
REG32(POR_HNF_RN_PHYS_ID46_U_HNF_NID200, 0x1900e98)
    FIELD(POR_HNF_RN_PHYS_ID46_U_HNF_NID200, VALID_RA93, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID46_U_HNF_NID200, CPA_EN_RA93, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID46_U_HNF_NID200, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID46_U_HNF_NID200, CPA_GRP_RA93, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID46_U_HNF_NID200, REMOTE_RA93, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID46_U_HNF_NID200, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID46_U_HNF_NID200, NODEID_RA93, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID46_U_HNF_NID200, VALID_RA92, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID46_U_HNF_NID200, CPA_EN_RA92, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID46_U_HNF_NID200, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID46_U_HNF_NID200, CPA_GRP_RA92, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID46_U_HNF_NID200, REMOTE_RA92, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID46_U_HNF_NID200, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID46_U_HNF_NID200, NODEID_RA92, 0, 11)
REG32(POR_HNF_RN_PHYS_ID47_U_HNF_NID200, 0x1900ea0)
    FIELD(POR_HNF_RN_PHYS_ID47_U_HNF_NID200, VALID_RA95, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID47_U_HNF_NID200, CPA_EN_RA95, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID47_U_HNF_NID200, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID47_U_HNF_NID200, CPA_GRP_RA95, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID47_U_HNF_NID200, REMOTE_RA95, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID47_U_HNF_NID200, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID47_U_HNF_NID200, NODEID_RA95, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID47_U_HNF_NID200, VALID_RA94, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID47_U_HNF_NID200, CPA_EN_RA94, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID47_U_HNF_NID200, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID47_U_HNF_NID200, CPA_GRP_RA94, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID47_U_HNF_NID200, REMOTE_RA94, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID47_U_HNF_NID200, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID47_U_HNF_NID200, NODEID_RA94, 0, 11)
REG32(POR_HNF_RN_PHYS_ID48_U_HNF_NID200, 0x1900ea8)
    FIELD(POR_HNF_RN_PHYS_ID48_U_HNF_NID200, VALID_RA97, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID48_U_HNF_NID200, CPA_EN_RA97, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID48_U_HNF_NID200, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID48_U_HNF_NID200, CPA_GRP_RA97, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID48_U_HNF_NID200, REMOTE_RA97, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID48_U_HNF_NID200, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID48_U_HNF_NID200, NODEID_RA97, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID48_U_HNF_NID200, VALID_RA96, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID48_U_HNF_NID200, CPA_EN_RA96, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID48_U_HNF_NID200, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID48_U_HNF_NID200, CPA_GRP_RA96, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID48_U_HNF_NID200, REMOTE_RA96, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID48_U_HNF_NID200, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID48_U_HNF_NID200, NODEID_RA96, 0, 11)
REG32(POR_HNF_RN_PHYS_ID49_U_HNF_NID200, 0x1900eb0)
    FIELD(POR_HNF_RN_PHYS_ID49_U_HNF_NID200, VALID_RA99, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID49_U_HNF_NID200, CPA_EN_RA99, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID49_U_HNF_NID200, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID49_U_HNF_NID200, CPA_GRP_RA99, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID49_U_HNF_NID200, REMOTE_RA99, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID49_U_HNF_NID200, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID49_U_HNF_NID200, NODEID_RA99, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID49_U_HNF_NID200, VALID_RA98, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID49_U_HNF_NID200, CPA_EN_RA98, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID49_U_HNF_NID200, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID49_U_HNF_NID200, CPA_GRP_RA98, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID49_U_HNF_NID200, REMOTE_RA98, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID49_U_HNF_NID200, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID49_U_HNF_NID200, NODEID_RA98, 0, 11)
REG32(POR_HNF_RN_PHYS_ID50_U_HNF_NID200, 0x1900eb8)
    FIELD(POR_HNF_RN_PHYS_ID50_U_HNF_NID200, VALID_RA101, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID50_U_HNF_NID200, CPA_EN_RA101, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID50_U_HNF_NID200, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID50_U_HNF_NID200, CPA_GRP_RA101, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID50_U_HNF_NID200, REMOTE_RA101, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID50_U_HNF_NID200, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID50_U_HNF_NID200, NODEID_RA101, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID50_U_HNF_NID200, VALID_RA100, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID50_U_HNF_NID200, CPA_EN_RA100, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID50_U_HNF_NID200, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID50_U_HNF_NID200, CPA_GRP_RA100, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID50_U_HNF_NID200, REMOTE_RA100, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID50_U_HNF_NID200, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID50_U_HNF_NID200, NODEID_RA100, 0, 11)
REG32(POR_HNF_RN_PHYS_ID51_U_HNF_NID200, 0x1900ec0)
    FIELD(POR_HNF_RN_PHYS_ID51_U_HNF_NID200, VALID_RA103, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID51_U_HNF_NID200, CPA_EN_RA103, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID51_U_HNF_NID200, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID51_U_HNF_NID200, CPA_GRP_RA103, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID51_U_HNF_NID200, REMOTE_RA103, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID51_U_HNF_NID200, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID51_U_HNF_NID200, NODEID_RA103, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID51_U_HNF_NID200, VALID_RA102, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID51_U_HNF_NID200, CPA_EN_RA102, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID51_U_HNF_NID200, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID51_U_HNF_NID200, CPA_GRP_RA102, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID51_U_HNF_NID200, REMOTE_RA102, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID51_U_HNF_NID200, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID51_U_HNF_NID200, NODEID_RA102, 0, 11)
REG32(POR_HNF_RN_PHYS_ID52_U_HNF_NID200, 0x1900ec8)
    FIELD(POR_HNF_RN_PHYS_ID52_U_HNF_NID200, VALID_RA105, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID52_U_HNF_NID200, CPA_EN_RA105, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID52_U_HNF_NID200, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID52_U_HNF_NID200, CPA_GRP_RA105, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID52_U_HNF_NID200, REMOTE_RA105, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID52_U_HNF_NID200, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID52_U_HNF_NID200, NODEID_RA105, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID52_U_HNF_NID200, VALID_RA104, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID52_U_HNF_NID200, CPA_EN_RA104, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID52_U_HNF_NID200, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID52_U_HNF_NID200, CPA_GRP_RA104, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID52_U_HNF_NID200, REMOTE_RA104, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID52_U_HNF_NID200, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID52_U_HNF_NID200, NODEID_RA104, 0, 11)
REG32(POR_HNF_RN_PHYS_ID53_U_HNF_NID200, 0x1900ed0)
    FIELD(POR_HNF_RN_PHYS_ID53_U_HNF_NID200, VALID_RA107, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID53_U_HNF_NID200, CPA_EN_RA107, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID53_U_HNF_NID200, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID53_U_HNF_NID200, CPA_GRP_RA107, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID53_U_HNF_NID200, REMOTE_RA107, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID53_U_HNF_NID200, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID53_U_HNF_NID200, NODEID_RA107, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID53_U_HNF_NID200, VALID_RA106, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID53_U_HNF_NID200, CPA_EN_RA106, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID53_U_HNF_NID200, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID53_U_HNF_NID200, CPA_GRP_RA106, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID53_U_HNF_NID200, REMOTE_RA106, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID53_U_HNF_NID200, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID53_U_HNF_NID200, NODEID_RA106, 0, 11)
REG32(POR_HNF_RN_PHYS_ID54_U_HNF_NID200, 0x1900ed8)
    FIELD(POR_HNF_RN_PHYS_ID54_U_HNF_NID200, VALID_RA109, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID54_U_HNF_NID200, CPA_EN_RA109, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID54_U_HNF_NID200, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID54_U_HNF_NID200, CPA_GRP_RA109, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID54_U_HNF_NID200, REMOTE_RA109, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID54_U_HNF_NID200, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID54_U_HNF_NID200, NODEID_RA109, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID54_U_HNF_NID200, VALID_RA108, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID54_U_HNF_NID200, CPA_EN_RA108, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID54_U_HNF_NID200, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID54_U_HNF_NID200, CPA_GRP_RA108, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID54_U_HNF_NID200, REMOTE_RA108, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID54_U_HNF_NID200, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID54_U_HNF_NID200, NODEID_RA108, 0, 11)
REG32(POR_HNF_RN_PHYS_ID55_U_HNF_NID200, 0x1900ee0)
    FIELD(POR_HNF_RN_PHYS_ID55_U_HNF_NID200, VALID_RA111, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID55_U_HNF_NID200, CPA_EN_RA111, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID55_U_HNF_NID200, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID55_U_HNF_NID200, CPA_GRP_RA111, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID55_U_HNF_NID200, REMOTE_RA111, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID55_U_HNF_NID200, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID55_U_HNF_NID200, NODEID_RA111, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID55_U_HNF_NID200, VALID_RA110, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID55_U_HNF_NID200, CPA_EN_RA110, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID55_U_HNF_NID200, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID55_U_HNF_NID200, CPA_GRP_RA110, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID55_U_HNF_NID200, REMOTE_RA110, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID55_U_HNF_NID200, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID55_U_HNF_NID200, NODEID_RA110, 0, 11)
REG32(POR_HNF_RN_PHYS_ID56_U_HNF_NID200, 0x1900ee8)
    FIELD(POR_HNF_RN_PHYS_ID56_U_HNF_NID200, VALID_RA113, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID56_U_HNF_NID200, CPA_EN_RA113, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID56_U_HNF_NID200, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID56_U_HNF_NID200, CPA_GRP_RA113, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID56_U_HNF_NID200, REMOTE_RA113, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID56_U_HNF_NID200, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID56_U_HNF_NID200, NODEID_RA113, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID56_U_HNF_NID200, VALID_RA112, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID56_U_HNF_NID200, CPA_EN_RA112, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID56_U_HNF_NID200, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID56_U_HNF_NID200, CPA_GRP_RA112, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID56_U_HNF_NID200, REMOTE_RA112, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID56_U_HNF_NID200, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID56_U_HNF_NID200, NODEID_RA112, 0, 11)
REG32(POR_HNF_RN_PHYS_ID57_U_HNF_NID200, 0x1900ef0)
    FIELD(POR_HNF_RN_PHYS_ID57_U_HNF_NID200, VALID_RA115, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID57_U_HNF_NID200, CPA_EN_RA115, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID57_U_HNF_NID200, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID57_U_HNF_NID200, CPA_GRP_RA115, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID57_U_HNF_NID200, REMOTE_RA115, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID57_U_HNF_NID200, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID57_U_HNF_NID200, NODEID_RA115, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID57_U_HNF_NID200, VALID_RA114, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID57_U_HNF_NID200, CPA_EN_RA114, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID57_U_HNF_NID200, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID57_U_HNF_NID200, CPA_GRP_RA114, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID57_U_HNF_NID200, REMOTE_RA114, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID57_U_HNF_NID200, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID57_U_HNF_NID200, NODEID_RA114, 0, 11)
REG32(POR_HNF_RN_PHYS_ID58_U_HNF_NID200, 0x1900ef8)
    FIELD(POR_HNF_RN_PHYS_ID58_U_HNF_NID200, VALID_RA117, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID58_U_HNF_NID200, CPA_EN_RA117, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID58_U_HNF_NID200, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID58_U_HNF_NID200, CPA_GRP_RA117, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID58_U_HNF_NID200, REMOTE_RA117, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID58_U_HNF_NID200, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID58_U_HNF_NID200, NODEID_RA117, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID58_U_HNF_NID200, VALID_RA116, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID58_U_HNF_NID200, CPA_EN_RA116, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID58_U_HNF_NID200, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID58_U_HNF_NID200, CPA_GRP_RA116, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID58_U_HNF_NID200, REMOTE_RA116, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID58_U_HNF_NID200, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID58_U_HNF_NID200, NODEID_RA116, 0, 11)
REG32(POR_HNF_SF_CXG_BLOCKED_WAYS_U_HNF_NID200, 0x1900f00)
    FIELD(POR_HNF_SF_CXG_BLOCKED_WAYS_U_HNF_NID200, SF_BLOCKED_WAYS, 0, 2)
REG32(POR_HNF_CML_PORT_AGGR_GRP0_ADD_MASK_U_HNF_NID200, 0x1900f10)
    FIELD(POR_HNF_CML_PORT_AGGR_GRP0_ADD_MASK_U_HNF_NID200, RESERVED_48, 48, 16)
    FIELD(POR_HNF_CML_PORT_AGGR_GRP0_ADD_MASK_U_HNF_NID200, ADDR_MASK, 6, 42)
    FIELD(POR_HNF_CML_PORT_AGGR_GRP0_ADD_MASK_U_HNF_NID200, RESERVED_0, 0, 6)
REG32(POR_HNF_CML_PORT_AGGR_GRP1_ADD_MASK_U_HNF_NID200, 0x1900f18)
    FIELD(POR_HNF_CML_PORT_AGGR_GRP1_ADD_MASK_U_HNF_NID200, RESERVED_48, 48, 16)
    FIELD(POR_HNF_CML_PORT_AGGR_GRP1_ADD_MASK_U_HNF_NID200, ADDR_MASK, 6, 42)
    FIELD(POR_HNF_CML_PORT_AGGR_GRP1_ADD_MASK_U_HNF_NID200, RESERVED_0, 0, 6)
REG32(POR_HNF_CML_PORT_AGGR_GRP0_REG_U_HNF_NID200, 0x1900f28)
    FIELD(POR_HNF_CML_PORT_AGGR_GRP0_REG_U_HNF_NID200, RESERVED_50, 50, 14)
    FIELD(POR_HNF_CML_PORT_AGGR_GRP0_REG_U_HNF_NID200, NUM_CXG_PAG0, 48, 2)
    FIELD(POR_HNF_CML_PORT_AGGR_GRP0_REG_U_HNF_NID200, RESERVED_47, 47, 1)
    FIELD(POR_HNF_CML_PORT_AGGR_GRP0_REG_U_HNF_NID200, PAG0_TGTID3, 36, 11)
    FIELD(POR_HNF_CML_PORT_AGGR_GRP0_REG_U_HNF_NID200, RESERVED_35, 35, 1)
    FIELD(POR_HNF_CML_PORT_AGGR_GRP0_REG_U_HNF_NID200, PAG0_TGTID2, 24, 11)
    FIELD(POR_HNF_CML_PORT_AGGR_GRP0_REG_U_HNF_NID200, RESERVED_23, 23, 1)
    FIELD(POR_HNF_CML_PORT_AGGR_GRP0_REG_U_HNF_NID200, PAG0_TGTID1, 12, 11)
    FIELD(POR_HNF_CML_PORT_AGGR_GRP0_REG_U_HNF_NID200, RESERVED_11, 11, 1)
    FIELD(POR_HNF_CML_PORT_AGGR_GRP0_REG_U_HNF_NID200, PAG0_TGTID0, 0, 11)
REG32(POR_HNF_CML_PORT_AGGR_GRP1_REG_U_HNF_NID200, 0x1900f30)
    FIELD(POR_HNF_CML_PORT_AGGR_GRP1_REG_U_HNF_NID200, RESERVED_50, 50, 14)
    FIELD(POR_HNF_CML_PORT_AGGR_GRP1_REG_U_HNF_NID200, NUM_CXG_PAG1, 48, 2)
    FIELD(POR_HNF_CML_PORT_AGGR_GRP1_REG_U_HNF_NID200, RESERVED_47, 47, 1)
    FIELD(POR_HNF_CML_PORT_AGGR_GRP1_REG_U_HNF_NID200, PAG1_TGTID3, 36, 11)
    FIELD(POR_HNF_CML_PORT_AGGR_GRP1_REG_U_HNF_NID200, RESERVED_35, 35, 1)
    FIELD(POR_HNF_CML_PORT_AGGR_GRP1_REG_U_HNF_NID200, PAG1_TGTID2, 24, 11)
    FIELD(POR_HNF_CML_PORT_AGGR_GRP1_REG_U_HNF_NID200, RESERVED_23, 23, 1)
    FIELD(POR_HNF_CML_PORT_AGGR_GRP1_REG_U_HNF_NID200, PAG1_TGTID1, 12, 11)
    FIELD(POR_HNF_CML_PORT_AGGR_GRP1_REG_U_HNF_NID200, RESERVED_11, 11, 1)
    FIELD(POR_HNF_CML_PORT_AGGR_GRP1_REG_U_HNF_NID200, PAG1_TGTID0, 0, 11)
REG32(HN_SAM_HASH_ADDR_MASK_REG_U_HNF_NID200, 0x1900f40)
    FIELD(HN_SAM_HASH_ADDR_MASK_REG_U_HNF_NID200, RESERVED_48, 48, 16)
    FIELD(HN_SAM_HASH_ADDR_MASK_REG_U_HNF_NID200, ADDR_MASK, 6, 42)
    FIELD(HN_SAM_HASH_ADDR_MASK_REG_U_HNF_NID200, RESERVED_0, 0, 6)
REG32(HN_SAM_REGION_CMP_ADDR_MASK_REG_U_HNF_NID200, 0x1900f48)
    FIELD(HN_SAM_REGION_CMP_ADDR_MASK_REG_U_HNF_NID200, RESERVED_48, 48, 16)
    FIELD(HN_SAM_REGION_CMP_ADDR_MASK_REG_U_HNF_NID200, ADDR_MASK, 26, 22)
    FIELD(HN_SAM_REGION_CMP_ADDR_MASK_REG_U_HNF_NID200, RESERVED_0, 0, 26)
REG32(POR_HNF_ABF_LO_ADDR_U_HNF_NID200, 0x1900f50)
    FIELD(POR_HNF_ABF_LO_ADDR_U_HNF_NID200, RESERVED_48, 48, 16)
    FIELD(POR_HNF_ABF_LO_ADDR_U_HNF_NID200, ABF_LO_ADDR, 0, 48)
REG32(POR_HNF_ABF_HI_ADDR_U_HNF_NID200, 0x1900f58)
    FIELD(POR_HNF_ABF_HI_ADDR_U_HNF_NID200, RESERVED_48, 48, 16)
    FIELD(POR_HNF_ABF_HI_ADDR_U_HNF_NID200, ABF_HI_ADDR, 0, 48)
REG32(POR_HNF_ABF_PR_U_HNF_NID200, 0x1900f60)
    FIELD(POR_HNF_ABF_PR_U_HNF_NID200, ABF_MODE, 1, 2)
    FIELD(POR_HNF_ABF_PR_U_HNF_NID200, ABF_ENABLE, 0, 1)
REG32(POR_HNF_ABF_SR_U_HNF_NID200, 0x1900f68)
    FIELD(POR_HNF_ABF_SR_U_HNF_NID200, ABF_SF_DISABLE_ABORT, 3, 1)
    FIELD(POR_HNF_ABF_SR_U_HNF_NID200, ABF_SF_PM_TRANSITION_ABORT, 2, 1)
    FIELD(POR_HNF_ABF_SR_U_HNF_NID200, ABF_INVALID_REQ_ABORT, 1, 1)
    FIELD(POR_HNF_ABF_SR_U_HNF_NID200, ABF_COMPLETE, 0, 1)
REG32(POR_HNF_RN_PHYS_ID59_U_HNF_NID200, 0x1900f70)
    FIELD(POR_HNF_RN_PHYS_ID59_U_HNF_NID200, VALID_RA119, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID59_U_HNF_NID200, CPA_EN_RA119, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID59_U_HNF_NID200, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID59_U_HNF_NID200, CPA_GRP_RA119, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID59_U_HNF_NID200, REMOTE_RA119, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID59_U_HNF_NID200, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID59_U_HNF_NID200, NODEID_RA119, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID59_U_HNF_NID200, VALID_RA118, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID59_U_HNF_NID200, CPA_EN_RA118, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID59_U_HNF_NID200, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID59_U_HNF_NID200, CPA_GRP_RA118, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID59_U_HNF_NID200, REMOTE_RA118, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID59_U_HNF_NID200, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID59_U_HNF_NID200, NODEID_RA118, 0, 11)
REG32(POR_HNF_RN_PHYS_ID60_U_HNF_NID200, 0x1900f78)
    FIELD(POR_HNF_RN_PHYS_ID60_U_HNF_NID200, VALID_RA121, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID60_U_HNF_NID200, CPA_EN_RA121, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID60_U_HNF_NID200, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID60_U_HNF_NID200, CPA_GRP_RA121, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID60_U_HNF_NID200, REMOTE_RA121, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID60_U_HNF_NID200, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID60_U_HNF_NID200, NODEID_RA121, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID60_U_HNF_NID200, VALID_RA120, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID60_U_HNF_NID200, CPA_EN_RA120, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID60_U_HNF_NID200, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID60_U_HNF_NID200, CPA_GRP_RA120, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID60_U_HNF_NID200, REMOTE_RA120, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID60_U_HNF_NID200, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID60_U_HNF_NID200, NODEID_RA120, 0, 11)
REG32(POR_HNF_RN_PHYS_ID61_U_HNF_NID200, 0x1900f80)
    FIELD(POR_HNF_RN_PHYS_ID61_U_HNF_NID200, VALID_RA123, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID61_U_HNF_NID200, CPA_EN_RA123, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID61_U_HNF_NID200, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID61_U_HNF_NID200, CPA_GRP_RA123, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID61_U_HNF_NID200, REMOTE_RA123, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID61_U_HNF_NID200, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID61_U_HNF_NID200, NODEID_RA123, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID61_U_HNF_NID200, VALID_RA122, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID61_U_HNF_NID200, CPA_EN_RA122, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID61_U_HNF_NID200, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID61_U_HNF_NID200, CPA_GRP_RA122, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID61_U_HNF_NID200, REMOTE_RA122, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID61_U_HNF_NID200, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID61_U_HNF_NID200, NODEID_RA122, 0, 11)
REG32(POR_HNF_RN_PHYS_ID62_U_HNF_NID200, 0x1900f88)
    FIELD(POR_HNF_RN_PHYS_ID62_U_HNF_NID200, VALID_RA125, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID62_U_HNF_NID200, CPA_EN_RA125, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID62_U_HNF_NID200, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID62_U_HNF_NID200, CPA_GRP_RA125, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID62_U_HNF_NID200, REMOTE_RA125, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID62_U_HNF_NID200, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID62_U_HNF_NID200, NODEID_RA125, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID62_U_HNF_NID200, VALID_RA124, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID62_U_HNF_NID200, CPA_EN_RA124, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID62_U_HNF_NID200, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID62_U_HNF_NID200, CPA_GRP_RA124, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID62_U_HNF_NID200, REMOTE_RA124, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID62_U_HNF_NID200, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID62_U_HNF_NID200, NODEID_RA124, 0, 11)
REG32(POR_HNF_RN_PHYS_ID63_U_HNF_NID200, 0x1900f90)
    FIELD(POR_HNF_RN_PHYS_ID63_U_HNF_NID200, VALID_RA127, 63, 1)
    FIELD(POR_HNF_RN_PHYS_ID63_U_HNF_NID200, CPA_EN_RA127, 62, 1)
    FIELD(POR_HNF_RN_PHYS_ID63_U_HNF_NID200, RESERVED_51, 51, 11)
    FIELD(POR_HNF_RN_PHYS_ID63_U_HNF_NID200, CPA_GRP_RA127, 49, 2)
    FIELD(POR_HNF_RN_PHYS_ID63_U_HNF_NID200, REMOTE_RA127, 48, 1)
    FIELD(POR_HNF_RN_PHYS_ID63_U_HNF_NID200, RESERVED_43, 43, 5)
    FIELD(POR_HNF_RN_PHYS_ID63_U_HNF_NID200, NODEID_RA127, 32, 11)
    FIELD(POR_HNF_RN_PHYS_ID63_U_HNF_NID200, VALID_RA126, 31, 1)
    FIELD(POR_HNF_RN_PHYS_ID63_U_HNF_NID200, CPA_EN_RA126, 30, 1)
    FIELD(POR_HNF_RN_PHYS_ID63_U_HNF_NID200, RESERVED_19, 19, 11)
    FIELD(POR_HNF_RN_PHYS_ID63_U_HNF_NID200, CPA_GRP_RA126, 17, 2)
    FIELD(POR_HNF_RN_PHYS_ID63_U_HNF_NID200, REMOTE_RA126, 16, 1)
    FIELD(POR_HNF_RN_PHYS_ID63_U_HNF_NID200, RESERVED_11, 11, 5)
    FIELD(POR_HNF_RN_PHYS_ID63_U_HNF_NID200, NODEID_RA126, 0, 11)
REG32(POR_HNF_LDID_MAP_TABLE_REG0_U_HNF_NID200, 0x1900f98)
    FIELD(POR_HNF_LDID_MAP_TABLE_REG0_U_HNF_NID200, VALID_CXHA1, 63, 1)
    FIELD(POR_HNF_LDID_MAP_TABLE_REG0_U_HNF_NID200, RESERVED_55, 55, 8)
    FIELD(POR_HNF_LDID_MAP_TABLE_REG0_U_HNF_NID200, STARTING_LDID_CXHA1, 48, 7)
    FIELD(POR_HNF_LDID_MAP_TABLE_REG0_U_HNF_NID200, RESERVED_43, 43, 5)
    FIELD(POR_HNF_LDID_MAP_TABLE_REG0_U_HNF_NID200, SRCID_CXHA1, 32, 11)
    FIELD(POR_HNF_LDID_MAP_TABLE_REG0_U_HNF_NID200, VALID_CXHA0, 31, 1)
    FIELD(POR_HNF_LDID_MAP_TABLE_REG0_U_HNF_NID200, RESERVED_23, 23, 8)
    FIELD(POR_HNF_LDID_MAP_TABLE_REG0_U_HNF_NID200, STARTING_LDID_CXHA0, 16, 7)
    FIELD(POR_HNF_LDID_MAP_TABLE_REG0_U_HNF_NID200, RESERVED_11, 11, 5)
    FIELD(POR_HNF_LDID_MAP_TABLE_REG0_U_HNF_NID200, SRCID_CXHA0, 0, 11)
REG32(POR_HNF_LDID_MAP_TABLE_REG1_U_HNF_NID200, 0x1900fa0)
    FIELD(POR_HNF_LDID_MAP_TABLE_REG1_U_HNF_NID200, VALID_CXHA3, 63, 1)
    FIELD(POR_HNF_LDID_MAP_TABLE_REG1_U_HNF_NID200, RESERVED_55, 55, 8)
    FIELD(POR_HNF_LDID_MAP_TABLE_REG1_U_HNF_NID200, STARTING_LDID_CXHA3, 48, 7)
    FIELD(POR_HNF_LDID_MAP_TABLE_REG1_U_HNF_NID200, RESERVED_43, 43, 5)
    FIELD(POR_HNF_LDID_MAP_TABLE_REG1_U_HNF_NID200, SRCID_CXHA3, 32, 11)
    FIELD(POR_HNF_LDID_MAP_TABLE_REG1_U_HNF_NID200, VALID_CXHA2, 31, 1)
    FIELD(POR_HNF_LDID_MAP_TABLE_REG1_U_HNF_NID200, RESERVED_23, 23, 8)
    FIELD(POR_HNF_LDID_MAP_TABLE_REG1_U_HNF_NID200, STARTING_LDID_CXHA2, 16, 7)
    FIELD(POR_HNF_LDID_MAP_TABLE_REG1_U_HNF_NID200, RESERVED_11, 11, 5)
    FIELD(POR_HNF_LDID_MAP_TABLE_REG1_U_HNF_NID200, SRCID_CXHA2, 0, 11)
REG32(POR_HNF_LDID_MAP_TABLE_REG2_U_HNF_NID200, 0x1900fa8)
    FIELD(POR_HNF_LDID_MAP_TABLE_REG2_U_HNF_NID200, VALID_CXHA5, 63, 1)
    FIELD(POR_HNF_LDID_MAP_TABLE_REG2_U_HNF_NID200, RESERVED_55, 55, 8)
    FIELD(POR_HNF_LDID_MAP_TABLE_REG2_U_HNF_NID200, STARTING_LDID_CXHA5, 48, 7)
    FIELD(POR_HNF_LDID_MAP_TABLE_REG2_U_HNF_NID200, RESERVED_43, 43, 5)
    FIELD(POR_HNF_LDID_MAP_TABLE_REG2_U_HNF_NID200, SRCID_CXHA5, 32, 11)
    FIELD(POR_HNF_LDID_MAP_TABLE_REG2_U_HNF_NID200, VALID_CXHA4, 31, 1)
    FIELD(POR_HNF_LDID_MAP_TABLE_REG2_U_HNF_NID200, RESERVED_23, 23, 8)
    FIELD(POR_HNF_LDID_MAP_TABLE_REG2_U_HNF_NID200, STARTING_LDID_CXHA4, 16, 7)
    FIELD(POR_HNF_LDID_MAP_TABLE_REG2_U_HNF_NID200, RESERVED_11, 11, 5)
    FIELD(POR_HNF_LDID_MAP_TABLE_REG2_U_HNF_NID200, SRCID_CXHA4, 0, 11)
REG32(POR_HNF_LDID_MAP_TABLE_REG3_U_HNF_NID200, 0x1900fb0)
    FIELD(POR_HNF_LDID_MAP_TABLE_REG3_U_HNF_NID200, VALID_CXHA7, 63, 1)
    FIELD(POR_HNF_LDID_MAP_TABLE_REG3_U_HNF_NID200, RESERVED_55, 55, 8)
    FIELD(POR_HNF_LDID_MAP_TABLE_REG3_U_HNF_NID200, STARTING_LDID_CXHA7, 48, 7)
    FIELD(POR_HNF_LDID_MAP_TABLE_REG3_U_HNF_NID200, RESERVED_43, 43, 5)
    FIELD(POR_HNF_LDID_MAP_TABLE_REG3_U_HNF_NID200, SRCID_CXHA7, 32, 11)
    FIELD(POR_HNF_LDID_MAP_TABLE_REG3_U_HNF_NID200, VALID_CXHA6, 31, 1)
    FIELD(POR_HNF_LDID_MAP_TABLE_REG3_U_HNF_NID200, RESERVED_23, 23, 8)
    FIELD(POR_HNF_LDID_MAP_TABLE_REG3_U_HNF_NID200, STARTING_LDID_CXHA6, 16, 7)
    FIELD(POR_HNF_LDID_MAP_TABLE_REG3_U_HNF_NID200, RESERVED_11, 11, 5)
    FIELD(POR_HNF_LDID_MAP_TABLE_REG3_U_HNF_NID200, SRCID_CXHA6, 0, 11)
REG32(POR_HNF_PPU_PWPR_U_HNF_NID200, 0x1901000)
    FIELD(POR_HNF_PPU_PWPR_U_HNF_NID200, RESERVED_9, 9, 23)
    FIELD(POR_HNF_PPU_PWPR_U_HNF_NID200, DYN_EN, 8, 1)
    FIELD(POR_HNF_PPU_PWPR_U_HNF_NID200, OP_MODE, 4, 4)
    FIELD(POR_HNF_PPU_PWPR_U_HNF_NID200, POLICY, 0, 4)
REG32(POR_HNF_PPU_PWSR_U_HNF_NID200, 0x1901008)
    FIELD(POR_HNF_PPU_PWSR_U_HNF_NID200, RESERVED_9, 9, 23)
    FIELD(POR_HNF_PPU_PWSR_U_HNF_NID200, DYN_EN_STATUS, 8, 1)
    FIELD(POR_HNF_PPU_PWSR_U_HNF_NID200, OP_MODE_STATUS, 4, 4)
    FIELD(POR_HNF_PPU_PWSR_U_HNF_NID200, POW_STATUS, 0, 4)
REG32(POR_HNF_PPU_MISR_U_HNF_NID200, 0x1901014)
    FIELD(POR_HNF_PPU_MISR_U_HNF_NID200, PCSMACCEPT_STATUS, 0, 1)
REG32(POR_HNF_PPU_DYN_RET_THRESHOLD_U_HNF_NID200, 0x1901100)
    FIELD(POR_HNF_PPU_DYN_RET_THRESHOLD_U_HNF_NID200, RESERVED_12, 12, 52)
    FIELD(POR_HNF_PPU_DYN_RET_THRESHOLD_U_HNF_NID200, DYN_RET_THRESHOLD, 0, 12)
REG32(POR_HNF_PPU_IDR0_U_HNF_NID200, 0x1901fb0)
    FIELD(POR_HNF_PPU_IDR0_U_HNF_NID200, RESERVED_30, 30, 2)
    FIELD(POR_HNF_PPU_IDR0_U_HNF_NID200, DYN_WRM_RST_SPT, 29, 1)
    FIELD(POR_HNF_PPU_IDR0_U_HNF_NID200, DYN_ALL_ON_SPT, 28, 1)
    FIELD(POR_HNF_PPU_IDR0_U_HNF_NID200, DYN_FNC_RET_SPT, 27, 1)
    FIELD(POR_HNF_PPU_IDR0_U_HNF_NID200, DYN_FULL_RET_SPT, 26, 1)
    FIELD(POR_HNF_PPU_IDR0_U_HNF_NID200, DYN_MEM_OFF_SPT, 25, 1)
    FIELD(POR_HNF_PPU_IDR0_U_HNF_NID200, DYN_LGC_RET_SPT, 24, 1)
    FIELD(POR_HNF_PPU_IDR0_U_HNF_NID200, DYN_MEM_RET_EMU_SPT, 23, 1)
    FIELD(POR_HNF_PPU_IDR0_U_HNF_NID200, DYN_MEM_RET_SPT, 22, 1)
    FIELD(POR_HNF_PPU_IDR0_U_HNF_NID200, DYN_OFF_EMU_SPT, 21, 1)
    FIELD(POR_HNF_PPU_IDR0_U_HNF_NID200, DYN_ALL_OFF_SPT, 20, 1)
    FIELD(POR_HNF_PPU_IDR0_U_HNF_NID200, RESERVED_19, 19, 1)
    FIELD(POR_HNF_PPU_IDR0_U_HNF_NID200, STA_DBG_RECOV_SPT, 18, 1)
    FIELD(POR_HNF_PPU_IDR0_U_HNF_NID200, STA_WRM_RST_SPT, 17, 1)
    FIELD(POR_HNF_PPU_IDR0_U_HNF_NID200, STA_ALL_ON_SPT, 16, 1)
    FIELD(POR_HNF_PPU_IDR0_U_HNF_NID200, STA_FNC_RET_SPT, 15, 1)
    FIELD(POR_HNF_PPU_IDR0_U_HNF_NID200, STA_FULL_RET_SPT, 14, 1)
    FIELD(POR_HNF_PPU_IDR0_U_HNF_NID200, STA_MEM_OFF_SPT, 13, 1)
    FIELD(POR_HNF_PPU_IDR0_U_HNF_NID200, STA_LGC_RET_SPT, 12, 1)
    FIELD(POR_HNF_PPU_IDR0_U_HNF_NID200, STA_MEM_RET_EMU_SPT, 11, 1)
    FIELD(POR_HNF_PPU_IDR0_U_HNF_NID200, STA_MEM_RET_SPT, 10, 1)
    FIELD(POR_HNF_PPU_IDR0_U_HNF_NID200, STA_OFF_EMU_SPT, 9, 1)
    FIELD(POR_HNF_PPU_IDR0_U_HNF_NID200, STA_ALL_OFF_SPT, 8, 1)
    FIELD(POR_HNF_PPU_IDR0_U_HNF_NID200, NUM_OPMODES, 4, 4)
    FIELD(POR_HNF_PPU_IDR0_U_HNF_NID200, DEVCHAN, 0, 4)
REG32(POR_HNF_PPU_IDR1_U_HNF_NID200, 0x1901fb4)
    FIELD(POR_HNF_PPU_IDR1_U_HNF_NID200, DYN_POLICY_MIN_IRQ_SPT, 3, 1)
    FIELD(POR_HNF_PPU_IDR1_U_HNF_NID200, OFF_LOCK_SPT, 2, 1)
    FIELD(POR_HNF_PPU_IDR1_U_HNF_NID200, SW_DEV_DEL_CONFIG_SPT, 1, 1)
    FIELD(POR_HNF_PPU_IDR1_U_HNF_NID200, PWR_MODE_ENTRY_DEL_SPT, 0, 1)
REG32(POR_HNF_PPU_IIDR_U_HNF_NID200, 0x1901fc8)
    FIELD(POR_HNF_PPU_IIDR_U_HNF_NID200, PRODUCT_ID, 20, 12)
    FIELD(POR_HNF_PPU_IIDR_U_HNF_NID200, VARIANT, 16, 4)
    FIELD(POR_HNF_PPU_IIDR_U_HNF_NID200, REVISION, 12, 4)
    FIELD(POR_HNF_PPU_IIDR_U_HNF_NID200, IMPLEMENTER, 0, 12)
REG32(POR_HNF_PPU_AIDR_U_HNF_NID200, 0x1901fcc)
    FIELD(POR_HNF_PPU_AIDR_U_HNF_NID200, ARCH_REV_MAJOR, 4, 4)
    FIELD(POR_HNF_PPU_AIDR_U_HNF_NID200, ARCH_REV_MINOR, 0, 4)
REG32(POR_HNF_PMU_EVENT_SEL_U_HNF_NID200, 0x1902000)
    FIELD(POR_HNF_PMU_EVENT_SEL_U_HNF_NID200, RESERVED_35, 35, 29)
    FIELD(POR_HNF_PMU_EVENT_SEL_U_HNF_NID200, PMU_OCCUP1_ID, 32, 3)
    FIELD(POR_HNF_PMU_EVENT_SEL_U_HNF_NID200, RESERVED_29, 29, 3)
    FIELD(POR_HNF_PMU_EVENT_SEL_U_HNF_NID200, PMU_EVENT3_ID, 24, 5)
    FIELD(POR_HNF_PMU_EVENT_SEL_U_HNF_NID200, RESERVED_21, 21, 3)
    FIELD(POR_HNF_PMU_EVENT_SEL_U_HNF_NID200, PMU_EVENT2_ID, 16, 5)
    FIELD(POR_HNF_PMU_EVENT_SEL_U_HNF_NID200, RESERVED_13, 13, 3)
    FIELD(POR_HNF_PMU_EVENT_SEL_U_HNF_NID200, PMU_EVENT1_ID, 8, 5)
    FIELD(POR_HNF_PMU_EVENT_SEL_U_HNF_NID200, PMU_EVENT0_ID, 0, 5)
REG32(POR_HNF_ERRFR_U_HNF_NID200, 0x1903000)
    FIELD(POR_HNF_ERRFR_U_HNF_NID200, RESERVED_15, 15, 49)
    FIELD(POR_HNF_ERRFR_U_HNF_NID200, CEC, 12, 3)
    FIELD(POR_HNF_ERRFR_U_HNF_NID200, CFI, 10, 2)
    FIELD(POR_HNF_ERRFR_U_HNF_NID200, FI, 6, 2)
    FIELD(POR_HNF_ERRFR_U_HNF_NID200, UI, 4, 2)
    FIELD(POR_HNF_ERRFR_U_HNF_NID200, DE, 2, 2)
    FIELD(POR_HNF_ERRFR_U_HNF_NID200, ED, 0, 2)
REG32(POR_HNF_ERRCTLR_U_HNF_NID200, 0x1903008)
    FIELD(POR_HNF_ERRCTLR_U_HNF_NID200, RESERVED_9, 9, 55)
    FIELD(POR_HNF_ERRCTLR_U_HNF_NID200, CFI, 8, 1)
    FIELD(POR_HNF_ERRCTLR_U_HNF_NID200, FI, 3, 1)
    FIELD(POR_HNF_ERRCTLR_U_HNF_NID200, UI, 2, 1)
    FIELD(POR_HNF_ERRCTLR_U_HNF_NID200, DE, 1, 1)
    FIELD(POR_HNF_ERRCTLR_U_HNF_NID200, ED, 0, 1)
REG32(POR_HNF_ERRSTATUS_U_HNF_NID200, 0x1903010)
    FIELD(POR_HNF_ERRSTATUS_U_HNF_NID200, RESERVED_32, 32, 32)
    FIELD(POR_HNF_ERRSTATUS_U_HNF_NID200, AV, 31, 1)
    FIELD(POR_HNF_ERRSTATUS_U_HNF_NID200, V, 30, 1)
    FIELD(POR_HNF_ERRSTATUS_U_HNF_NID200, UE, 29, 1)
    FIELD(POR_HNF_ERRSTATUS_U_HNF_NID200, RESERVED_28, 28, 1)
    FIELD(POR_HNF_ERRSTATUS_U_HNF_NID200, OF, 27, 1)
    FIELD(POR_HNF_ERRSTATUS_U_HNF_NID200, MV, 26, 1)
    FIELD(POR_HNF_ERRSTATUS_U_HNF_NID200, RESERVED_25, 25, 1)
    FIELD(POR_HNF_ERRSTATUS_U_HNF_NID200, CE, 24, 1)
    FIELD(POR_HNF_ERRSTATUS_U_HNF_NID200, DE, 23, 1)
    FIELD(POR_HNF_ERRSTATUS_U_HNF_NID200, RESERVED_0, 0, 23)
REG32(POR_HNF_ERRADDR_U_HNF_NID200, 0x1903018)
    FIELD(POR_HNF_ERRADDR_U_HNF_NID200, NS, 63, 1)
    FIELD(POR_HNF_ERRADDR_U_HNF_NID200, RESERVED_48, 48, 15)
    FIELD(POR_HNF_ERRADDR_U_HNF_NID200, ADDR, 0, 48)
REG32(POR_HNF_ERRMISC_U_HNF_NID200, 0x1903020)
    FIELD(POR_HNF_ERRMISC_U_HNF_NID200, CECOF, 63, 1)
    FIELD(POR_HNF_ERRMISC_U_HNF_NID200, SETMATCH, 62, 1)
    FIELD(POR_HNF_ERRMISC_U_HNF_NID200, RESERVED_61, 61, 1)
    FIELD(POR_HNF_ERRMISC_U_HNF_NID200, ERRSET, 48, 13)
    FIELD(POR_HNF_ERRMISC_U_HNF_NID200, CEC, 32, 16)
    FIELD(POR_HNF_ERRMISC_U_HNF_NID200, RESERVED_18, 18, 14)
    FIELD(POR_HNF_ERRMISC_U_HNF_NID200, OPTYPE, 16, 2)
    FIELD(POR_HNF_ERRMISC_U_HNF_NID200, RESERVED_15, 15, 1)
    FIELD(POR_HNF_ERRMISC_U_HNF_NID200, SRCID, 4, 11)
    FIELD(POR_HNF_ERRMISC_U_HNF_NID200, ERRSRC, 0, 4)
REG32(POR_HNF_ERR_INJ_U_HNF_NID200, 0x1903030)
    FIELD(POR_HNF_ERR_INJ_U_HNF_NID200, RESERVED_27, 27, 37)
    FIELD(POR_HNF_ERR_INJ_U_HNF_NID200, HNF_ERR_INJ_SRCID, 16, 11)
    FIELD(POR_HNF_ERR_INJ_U_HNF_NID200, RESERVED_9, 9, 7)
    FIELD(POR_HNF_ERR_INJ_U_HNF_NID200, HNF_ERR_INJ_LPID, 4, 5)
    FIELD(POR_HNF_ERR_INJ_U_HNF_NID200, HNF_ERR_INJ_EN, 0, 1)
REG32(POR_HNF_BYTE_PAR_ERR_INJ_U_HNF_NID200, 0x1903038)
    FIELD(POR_HNF_BYTE_PAR_ERR_INJ_U_HNF_NID200, HNF_BYTE_PAR_ERR_INJ, 0, 5)
REG32(POR_HNF_ERRFR_NS_U_HNF_NID200, 0x1903100)
    FIELD(POR_HNF_ERRFR_NS_U_HNF_NID200, RESERVED_15, 15, 49)
    FIELD(POR_HNF_ERRFR_NS_U_HNF_NID200, CEC, 12, 3)
    FIELD(POR_HNF_ERRFR_NS_U_HNF_NID200, CFI, 10, 2)
    FIELD(POR_HNF_ERRFR_NS_U_HNF_NID200, FI, 6, 2)
    FIELD(POR_HNF_ERRFR_NS_U_HNF_NID200, UI, 4, 2)
    FIELD(POR_HNF_ERRFR_NS_U_HNF_NID200, DE, 2, 2)
    FIELD(POR_HNF_ERRFR_NS_U_HNF_NID200, ED, 0, 2)
REG32(POR_HNF_ERRCTLR_NS_U_HNF_NID200, 0x1903108)
    FIELD(POR_HNF_ERRCTLR_NS_U_HNF_NID200, RESERVED_9, 9, 55)
    FIELD(POR_HNF_ERRCTLR_NS_U_HNF_NID200, CFI, 8, 1)
    FIELD(POR_HNF_ERRCTLR_NS_U_HNF_NID200, FI, 3, 1)
    FIELD(POR_HNF_ERRCTLR_NS_U_HNF_NID200, UI, 2, 1)
    FIELD(POR_HNF_ERRCTLR_NS_U_HNF_NID200, DE, 1, 1)
    FIELD(POR_HNF_ERRCTLR_NS_U_HNF_NID200, ED, 0, 1)
REG32(POR_HNF_ERRSTATUS_NS_U_HNF_NID200, 0x1903110)
    FIELD(POR_HNF_ERRSTATUS_NS_U_HNF_NID200, RESERVED_32, 32, 32)
    FIELD(POR_HNF_ERRSTATUS_NS_U_HNF_NID200, AV, 31, 1)
    FIELD(POR_HNF_ERRSTATUS_NS_U_HNF_NID200, V, 30, 1)
    FIELD(POR_HNF_ERRSTATUS_NS_U_HNF_NID200, UE, 29, 1)
    FIELD(POR_HNF_ERRSTATUS_NS_U_HNF_NID200, RESERVED_28, 28, 1)
    FIELD(POR_HNF_ERRSTATUS_NS_U_HNF_NID200, OF, 27, 1)
    FIELD(POR_HNF_ERRSTATUS_NS_U_HNF_NID200, MV, 26, 1)
    FIELD(POR_HNF_ERRSTATUS_NS_U_HNF_NID200, RESERVED_25, 25, 1)
    FIELD(POR_HNF_ERRSTATUS_NS_U_HNF_NID200, CE, 24, 1)
    FIELD(POR_HNF_ERRSTATUS_NS_U_HNF_NID200, DE, 23, 1)
    FIELD(POR_HNF_ERRSTATUS_NS_U_HNF_NID200, RESERVED_0, 0, 23)
REG32(POR_HNF_ERRADDR_NS_U_HNF_NID200, 0x1903118)
    FIELD(POR_HNF_ERRADDR_NS_U_HNF_NID200, NS, 63, 1)
    FIELD(POR_HNF_ERRADDR_NS_U_HNF_NID200, RESERVED_48, 48, 15)
    FIELD(POR_HNF_ERRADDR_NS_U_HNF_NID200, ADDR, 0, 48)
REG32(POR_HNF_ERRMISC_NS_U_HNF_NID200, 0x1903120)
    FIELD(POR_HNF_ERRMISC_NS_U_HNF_NID200, CECOF, 63, 1)
    FIELD(POR_HNF_ERRMISC_NS_U_HNF_NID200, SETMATCH, 62, 1)
    FIELD(POR_HNF_ERRMISC_NS_U_HNF_NID200, RESERVED_61, 61, 1)
    FIELD(POR_HNF_ERRMISC_NS_U_HNF_NID200, ERRSET, 48, 13)
    FIELD(POR_HNF_ERRMISC_NS_U_HNF_NID200, CEC, 32, 16)
    FIELD(POR_HNF_ERRMISC_NS_U_HNF_NID200, RESERVED_18, 18, 14)
    FIELD(POR_HNF_ERRMISC_NS_U_HNF_NID200, OPTYPE, 16, 2)
    FIELD(POR_HNF_ERRMISC_NS_U_HNF_NID200, RESERVED_15, 15, 1)
    FIELD(POR_HNF_ERRMISC_NS_U_HNF_NID200, SRCID, 4, 11)
    FIELD(POR_HNF_ERRMISC_NS_U_HNF_NID200, ERRSRC, 0, 4)
REG32(POR_MXP_NODE_INFO_U_SMXP_3_1, 0x1908000)
    FIELD(POR_MXP_NODE_INFO_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MXP_NODE_INFO_U_SMXP_3_1, LOGICAL_ID, 32, 16)
    FIELD(POR_MXP_NODE_INFO_U_SMXP_3_1, XY_ID, 16, 16)
    FIELD(POR_MXP_NODE_INFO_U_SMXP_3_1, NODE_TYPE, 0, 16)
REG32(POR_MXP_DEVICE_PORT_CONNECT_INFO_P0_U_SMXP_3_1, 0x1908008)
    FIELD(POR_MXP_DEVICE_PORT_CONNECT_INFO_P0_U_SMXP_3_1, RESERVED_32, 32, 32)
    FIELD(POR_MXP_DEVICE_PORT_CONNECT_INFO_P0_U_SMXP_3_1, NUM_DCS_P0_D3, 28, 4)
    FIELD(POR_MXP_DEVICE_PORT_CONNECT_INFO_P0_U_SMXP_3_1, NUM_DCS_P0_D2, 24, 4)
    FIELD(POR_MXP_DEVICE_PORT_CONNECT_INFO_P0_U_SMXP_3_1, NUM_DCS_P0_D1, 20, 4)
    FIELD(POR_MXP_DEVICE_PORT_CONNECT_INFO_P0_U_SMXP_3_1, NUM_DCS_P0_D0, 16, 4)
    FIELD(POR_MXP_DEVICE_PORT_CONNECT_INFO_P0_U_SMXP_3_1, DEVICE_TYPE_P0, 0, 5)
REG32(POR_MXP_DEVICE_PORT_CONNECT_INFO_P1_U_SMXP_3_1, 0x1908010)
    FIELD(POR_MXP_DEVICE_PORT_CONNECT_INFO_P1_U_SMXP_3_1, RESERVED_32, 32, 32)
    FIELD(POR_MXP_DEVICE_PORT_CONNECT_INFO_P1_U_SMXP_3_1, NUM_DCS_P1_D3, 28, 4)
    FIELD(POR_MXP_DEVICE_PORT_CONNECT_INFO_P1_U_SMXP_3_1, NUM_DCS_P1_D2, 24, 4)
    FIELD(POR_MXP_DEVICE_PORT_CONNECT_INFO_P1_U_SMXP_3_1, NUM_DCS_P1_D1, 20, 4)
    FIELD(POR_MXP_DEVICE_PORT_CONNECT_INFO_P1_U_SMXP_3_1, NUM_DCS_P1_D0, 16, 4)
    FIELD(POR_MXP_DEVICE_PORT_CONNECT_INFO_P1_U_SMXP_3_1, DEVICE_TYPE_P1, 0, 5)
REG32(POR_MXP_MESH_PORT_CONNECT_INFO_EAST_U_SMXP_3_1, 0x1908018)
    FIELD(POR_MXP_MESH_PORT_CONNECT_INFO_EAST_U_SMXP_3_1, NUM_MCS_EAST, 0, 4)
REG32(POR_MXP_MESH_PORT_CONNECT_INFO_NORTH_U_SMXP_3_1, 0x1908020)
    FIELD(POR_MXP_MESH_PORT_CONNECT_INFO_NORTH_U_SMXP_3_1, NUM_MCS_NORTH, 0, 4)
REG32(POR_MXP_CHILD_INFO_U_SMXP_3_1, 0x1908080)
    FIELD(POR_MXP_CHILD_INFO_U_SMXP_3_1, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_INFO_U_SMXP_3_1, CHILD_PTR_OFFSET, 16, 16)
    FIELD(POR_MXP_CHILD_INFO_U_SMXP_3_1, CHILD_COUNT, 0, 16)
REG32(POR_MXP_CHILD_POINTER_0_U_SMXP_3_1, 0x1908100)
    FIELD(POR_MXP_CHILD_POINTER_0_U_SMXP_3_1, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_POINTER_0_U_SMXP_3_1, RELATIVE_ADDRESS_0, 0, 32)
REG32(POR_MXP_CHILD_POINTER_1_U_SMXP_3_1, 0x1908108)
    FIELD(POR_MXP_CHILD_POINTER_1_U_SMXP_3_1, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_POINTER_1_U_SMXP_3_1, RELATIVE_ADDRESS_1, 0, 32)
REG32(POR_MXP_CHILD_POINTER_2_U_SMXP_3_1, 0x1908110)
    FIELD(POR_MXP_CHILD_POINTER_2_U_SMXP_3_1, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_POINTER_2_U_SMXP_3_1, RELATIVE_ADDRESS_2, 0, 32)
REG32(POR_MXP_CHILD_POINTER_3_U_SMXP_3_1, 0x1908118)
    FIELD(POR_MXP_CHILD_POINTER_3_U_SMXP_3_1, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_POINTER_3_U_SMXP_3_1, RELATIVE_ADDRESS_3, 0, 32)
REG32(POR_MXP_CHILD_POINTER_4_U_SMXP_3_1, 0x1908120)
    FIELD(POR_MXP_CHILD_POINTER_4_U_SMXP_3_1, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_POINTER_4_U_SMXP_3_1, RELATIVE_ADDRESS_4, 0, 32)
REG32(POR_MXP_CHILD_POINTER_5_U_SMXP_3_1, 0x1908128)
    FIELD(POR_MXP_CHILD_POINTER_5_U_SMXP_3_1, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_POINTER_5_U_SMXP_3_1, RELATIVE_ADDRESS_5, 0, 32)
REG32(POR_MXP_CHILD_POINTER_6_U_SMXP_3_1, 0x1908130)
    FIELD(POR_MXP_CHILD_POINTER_6_U_SMXP_3_1, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_POINTER_6_U_SMXP_3_1, RELATIVE_ADDRESS_6, 0, 32)
REG32(POR_MXP_CHILD_POINTER_7_U_SMXP_3_1, 0x1908138)
    FIELD(POR_MXP_CHILD_POINTER_7_U_SMXP_3_1, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_POINTER_7_U_SMXP_3_1, RELATIVE_ADDRESS_7, 0, 32)
REG32(POR_MXP_CHILD_POINTER_8_U_SMXP_3_1, 0x1908140)
    FIELD(POR_MXP_CHILD_POINTER_8_U_SMXP_3_1, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_POINTER_8_U_SMXP_3_1, RELATIVE_ADDRESS_8, 0, 32)
REG32(POR_MXP_CHILD_POINTER_9_U_SMXP_3_1, 0x1908148)
    FIELD(POR_MXP_CHILD_POINTER_9_U_SMXP_3_1, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_POINTER_9_U_SMXP_3_1, RELATIVE_ADDRESS_9, 0, 32)
REG32(POR_MXP_CHILD_POINTER_10_U_SMXP_3_1, 0x1908150)
    FIELD(POR_MXP_CHILD_POINTER_10_U_SMXP_3_1, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_POINTER_10_U_SMXP_3_1, RELATIVE_ADDRESS_10, 0, 32)
REG32(POR_MXP_CHILD_POINTER_11_U_SMXP_3_1, 0x1908158)
    FIELD(POR_MXP_CHILD_POINTER_11_U_SMXP_3_1, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_POINTER_11_U_SMXP_3_1, RELATIVE_ADDRESS_11, 0, 32)
REG32(POR_MXP_CHILD_POINTER_12_U_SMXP_3_1, 0x1908160)
    FIELD(POR_MXP_CHILD_POINTER_12_U_SMXP_3_1, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_POINTER_12_U_SMXP_3_1, RELATIVE_ADDRESS_12, 0, 32)
REG32(POR_MXP_CHILD_POINTER_13_U_SMXP_3_1, 0x1908168)
    FIELD(POR_MXP_CHILD_POINTER_13_U_SMXP_3_1, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_POINTER_13_U_SMXP_3_1, RELATIVE_ADDRESS_13, 0, 32)
REG32(POR_MXP_CHILD_POINTER_14_U_SMXP_3_1, 0x1908170)
    FIELD(POR_MXP_CHILD_POINTER_14_U_SMXP_3_1, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_POINTER_14_U_SMXP_3_1, RELATIVE_ADDRESS_14, 0, 32)
REG32(POR_MXP_CHILD_POINTER_15_U_SMXP_3_1, 0x1908178)
    FIELD(POR_MXP_CHILD_POINTER_15_U_SMXP_3_1, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_POINTER_15_U_SMXP_3_1, RELATIVE_ADDRESS_15, 0, 32)
REG32(POR_MXP_P0_INFO_U_SMXP_3_1, 0x1908900)
    FIELD(POR_MXP_P0_INFO_U_SMXP_3_1, RESERVED_26, 26, 38)
    FIELD(POR_MXP_P0_INFO_U_SMXP_3_1, A4S_SAFE_XFACE_DISABLE_P0, 25, 1)
    FIELD(POR_MXP_P0_INFO_U_SMXP_3_1, CHI_SAFE_XFACE_DISABLE_P0, 24, 1)
    FIELD(POR_MXP_P0_INFO_U_SMXP_3_1, A4S_LOGICALID_BASE_P0, 16, 8)
    FIELD(POR_MXP_P0_INFO_U_SMXP_3_1, RESERVED_14, 14, 2)
    FIELD(POR_MXP_P0_INFO_U_SMXP_3_1, A4S_NUM_P0, 11, 3)
    FIELD(POR_MXP_P0_INFO_U_SMXP_3_1, RXBUF_NUM_ENTRIES_P0, 8, 3)
    FIELD(POR_MXP_P0_INFO_U_SMXP_3_1, EXT_SAM_EN_P0, 7, 1)
    FIELD(POR_MXP_P0_INFO_U_SMXP_3_1, DATACHECK_EN_P0, 5, 1)
    FIELD(POR_MXP_P0_INFO_U_SMXP_3_1, POISON_EN_P0, 4, 1)
    FIELD(POR_MXP_P0_INFO_U_SMXP_3_1, NUM_DEV_P0, 0, 3)
REG32(POR_MXP_P1_INFO_U_SMXP_3_1, 0x1908908)
    FIELD(POR_MXP_P1_INFO_U_SMXP_3_1, RESERVED_26, 26, 38)
    FIELD(POR_MXP_P1_INFO_U_SMXP_3_1, A4S_SAFE_XFACE_DISABLE_P1, 25, 1)
    FIELD(POR_MXP_P1_INFO_U_SMXP_3_1, CHI_SAFE_XFACE_DISABLE_P1, 24, 1)
    FIELD(POR_MXP_P1_INFO_U_SMXP_3_1, A4S_LOGICALID_BASE_P1, 16, 8)
    FIELD(POR_MXP_P1_INFO_U_SMXP_3_1, RESERVED_14, 14, 2)
    FIELD(POR_MXP_P1_INFO_U_SMXP_3_1, A4S_NUM_P1, 11, 3)
    FIELD(POR_MXP_P1_INFO_U_SMXP_3_1, RXBUF_NUM_ENTRIES_P1, 8, 3)
    FIELD(POR_MXP_P1_INFO_U_SMXP_3_1, EXT_SAM_EN_P1, 7, 1)
    FIELD(POR_MXP_P1_INFO_U_SMXP_3_1, DATACHECK_EN_P1, 5, 1)
    FIELD(POR_MXP_P1_INFO_U_SMXP_3_1, POISON_EN_P1, 4, 1)
    FIELD(POR_MXP_P1_INFO_U_SMXP_3_1, NUM_DEV_P1, 0, 3)
REG32(POR_MXP_SECURE_REGISTER_GROUPS_OVERRIDE_U_SMXP_3_1, 0x1908980)
    FIELD(POR_MXP_SECURE_REGISTER_GROUPS_OVERRIDE_U_SMXP_3_1, SYSCOREQ_CTL, 1, 1)
    FIELD(POR_MXP_SECURE_REGISTER_GROUPS_OVERRIDE_U_SMXP_3_1, QOS, 0, 1)
REG32(POR_MXP_AUX_CTL_U_SMXP_3_1, 0x1908a00)
    FIELD(POR_MXP_AUX_CTL_U_SMXP_3_1, CLKGATE_DISABLE, 0, 1)
REG32(POR_MXP_P0_QOS_CONTROL_U_SMXP_3_1, 0x1908a80)
    FIELD(POR_MXP_P0_QOS_CONTROL_U_SMXP_3_1, RESERVED_20, 20, 44)
    FIELD(POR_MXP_P0_QOS_CONTROL_U_SMXP_3_1, P0_QOS_OVERRIDE, 16, 4)
    FIELD(POR_MXP_P0_QOS_CONTROL_U_SMXP_3_1, P0_PQV_MODE, 6, 1)
    FIELD(POR_MXP_P0_QOS_CONTROL_U_SMXP_3_1, P0_REG_MODE, 4, 1)
    FIELD(POR_MXP_P0_QOS_CONTROL_U_SMXP_3_1, P0_QOS_OVERRIDE_EN, 2, 1)
    FIELD(POR_MXP_P0_QOS_CONTROL_U_SMXP_3_1, P0_LAT_EN, 0, 1)
REG32(POR_MXP_P0_QOS_LAT_TGT_U_SMXP_3_1, 0x1908a88)
    FIELD(POR_MXP_P0_QOS_LAT_TGT_U_SMXP_3_1, RESERVED_12, 12, 52)
    FIELD(POR_MXP_P0_QOS_LAT_TGT_U_SMXP_3_1, P0_LAT_TGT, 0, 12)
REG32(POR_MXP_P0_QOS_LAT_SCALE_U_SMXP_3_1, 0x1908a90)
    FIELD(POR_MXP_P0_QOS_LAT_SCALE_U_SMXP_3_1, P0_LAT_SCALE, 0, 3)
REG32(POR_MXP_P0_QOS_LAT_RANGE_U_SMXP_3_1, 0x1908a98)
    FIELD(POR_MXP_P0_QOS_LAT_RANGE_U_SMXP_3_1, RESERVED_12, 12, 52)
    FIELD(POR_MXP_P0_QOS_LAT_RANGE_U_SMXP_3_1, P0_LAT_MAX_QOS, 8, 4)
    FIELD(POR_MXP_P0_QOS_LAT_RANGE_U_SMXP_3_1, P0_LAT_MIN_QOS, 0, 4)
REG32(POR_MXP_P1_QOS_CONTROL_U_SMXP_3_1, 0x1908aa0)
    FIELD(POR_MXP_P1_QOS_CONTROL_U_SMXP_3_1, RESERVED_20, 20, 44)
    FIELD(POR_MXP_P1_QOS_CONTROL_U_SMXP_3_1, P1_QOS_OVERRIDE, 16, 4)
    FIELD(POR_MXP_P1_QOS_CONTROL_U_SMXP_3_1, P1_PQV_MODE, 6, 1)
    FIELD(POR_MXP_P1_QOS_CONTROL_U_SMXP_3_1, P1_REG_MODE, 4, 1)
    FIELD(POR_MXP_P1_QOS_CONTROL_U_SMXP_3_1, P1_QOS_OVERRIDE_EN, 2, 1)
    FIELD(POR_MXP_P1_QOS_CONTROL_U_SMXP_3_1, P1_LAT_EN, 0, 1)
REG32(POR_MXP_P1_QOS_LAT_TGT_U_SMXP_3_1, 0x1908aa8)
    FIELD(POR_MXP_P1_QOS_LAT_TGT_U_SMXP_3_1, RESERVED_12, 12, 52)
    FIELD(POR_MXP_P1_QOS_LAT_TGT_U_SMXP_3_1, P1_LAT_TGT, 0, 12)
REG32(POR_MXP_P1_QOS_LAT_SCALE_U_SMXP_3_1, 0x1908ab0)
    FIELD(POR_MXP_P1_QOS_LAT_SCALE_U_SMXP_3_1, P1_LAT_SCALE, 0, 3)
REG32(POR_MXP_P1_QOS_LAT_RANGE_U_SMXP_3_1, 0x1908ab8)
    FIELD(POR_MXP_P1_QOS_LAT_RANGE_U_SMXP_3_1, RESERVED_12, 12, 52)
    FIELD(POR_MXP_P1_QOS_LAT_RANGE_U_SMXP_3_1, P1_LAT_MAX_QOS, 8, 4)
    FIELD(POR_MXP_P1_QOS_LAT_RANGE_U_SMXP_3_1, P1_LAT_MIN_QOS, 0, 4)
REG32(POR_MXP_P0_SYSCOREQ_CTL_U_SMXP_3_1, 0x1909000)
    FIELD(POR_MXP_P0_SYSCOREQ_CTL_U_SMXP_3_1, SNPDVM_REQ_P0_D3, 3, 1)
    FIELD(POR_MXP_P0_SYSCOREQ_CTL_U_SMXP_3_1, SNPDVM_REQ_P0_D2, 2, 1)
    FIELD(POR_MXP_P0_SYSCOREQ_CTL_U_SMXP_3_1, SNPDVM_REQ_P0_D1, 1, 1)
    FIELD(POR_MXP_P0_SYSCOREQ_CTL_U_SMXP_3_1, SNPDVM_REQ_P0_D0, 0, 1)
REG32(POR_MXP_P1_SYSCOREQ_CTL_U_SMXP_3_1, 0x1909008)
    FIELD(POR_MXP_P1_SYSCOREQ_CTL_U_SMXP_3_1, SNPDVM_REQ_P1_D3, 3, 1)
    FIELD(POR_MXP_P1_SYSCOREQ_CTL_U_SMXP_3_1, SNPDVM_REQ_P1_D2, 2, 1)
    FIELD(POR_MXP_P1_SYSCOREQ_CTL_U_SMXP_3_1, SNPDVM_REQ_P1_D1, 1, 1)
    FIELD(POR_MXP_P1_SYSCOREQ_CTL_U_SMXP_3_1, SNPDVM_REQ_P1_D0, 0, 1)
REG32(POR_MXP_P0_SYSCOACK_STATUS_U_SMXP_3_1, 0x1909010)
    FIELD(POR_MXP_P0_SYSCOACK_STATUS_U_SMXP_3_1, SNPDVM_ACK_P0_D3, 3, 1)
    FIELD(POR_MXP_P0_SYSCOACK_STATUS_U_SMXP_3_1, SNPDVM_ACK_P0_D2, 2, 1)
    FIELD(POR_MXP_P0_SYSCOACK_STATUS_U_SMXP_3_1, SNPDVM_ACK_P0_D1, 1, 1)
    FIELD(POR_MXP_P0_SYSCOACK_STATUS_U_SMXP_3_1, SNPDVM_ACK_P0_D0, 0, 1)
REG32(POR_MXP_P1_SYSCOACK_STATUS_U_SMXP_3_1, 0x1909018)
    FIELD(POR_MXP_P1_SYSCOACK_STATUS_U_SMXP_3_1, SNPDVM_ACK_P1_D3, 3, 1)
    FIELD(POR_MXP_P1_SYSCOACK_STATUS_U_SMXP_3_1, SNPDVM_ACK_P1_D2, 2, 1)
    FIELD(POR_MXP_P1_SYSCOACK_STATUS_U_SMXP_3_1, SNPDVM_ACK_P1_D1, 1, 1)
    FIELD(POR_MXP_P1_SYSCOACK_STATUS_U_SMXP_3_1, SNPDVM_ACK_P1_D0, 0, 1)
REG32(POR_MXP_PMU_EVENT_SEL_U_SMXP_3_1, 0x190a000)
    FIELD(POR_MXP_PMU_EVENT_SEL_U_SMXP_3_1, RESERVED_32, 32, 32)
    FIELD(POR_MXP_PMU_EVENT_SEL_U_SMXP_3_1, PMU_EVENT3_ID, 24, 8)
    FIELD(POR_MXP_PMU_EVENT_SEL_U_SMXP_3_1, PMU_EVENT2_ID, 16, 8)
    FIELD(POR_MXP_PMU_EVENT_SEL_U_SMXP_3_1, PMU_EVENT1_ID, 8, 8)
    FIELD(POR_MXP_PMU_EVENT_SEL_U_SMXP_3_1, PMU_EVENT0_ID, 0, 8)
REG32(POR_DTM_CONTROL_U_SMXP_3_1, 0x190a100)
    FIELD(POR_DTM_CONTROL_U_SMXP_3_1, TRACE_NO_ATB, 3, 1)
    FIELD(POR_DTM_CONTROL_U_SMXP_3_1, SAMPLE_PROFILE_ENABLE, 2, 1)
    FIELD(POR_DTM_CONTROL_U_SMXP_3_1, TRACE_TAG_ENABLE, 1, 1)
    FIELD(POR_DTM_CONTROL_U_SMXP_3_1, DTM_ENABLE, 0, 1)
REG32(POR_DTM_FIFO_ENTRY_READY_U_SMXP_3_1, 0x190a118)
    FIELD(POR_DTM_FIFO_ENTRY_READY_U_SMXP_3_1, READY, 0, 4)
REG32(POR_DTM_FIFO_ENTRY0_0_U_SMXP_3_1, 0x190a120)
REG32(POR_DTM_FIFO_ENTRY0_1_U_SMXP_3_1, 0x190a128)
REG32(POR_DTM_FIFO_ENTRY0_2_U_SMXP_3_1, 0x190a130)
    FIELD(POR_DTM_FIFO_ENTRY0_2_U_SMXP_3_1, RESERVED_32, 32, 32)
    FIELD(POR_DTM_FIFO_ENTRY0_2_U_SMXP_3_1, FIFO_CYCLE_COUNT, 16, 16)
    FIELD(POR_DTM_FIFO_ENTRY0_2_U_SMXP_3_1, FIFO_DATA2, 0, 16)
REG32(POR_DTM_FIFO_ENTRY1_0_U_SMXP_3_1, 0x190a138)
REG32(POR_DTM_FIFO_ENTRY1_1_U_SMXP_3_1, 0x190a140)
REG32(POR_DTM_FIFO_ENTRY1_2_U_SMXP_3_1, 0x190a148)
    FIELD(POR_DTM_FIFO_ENTRY1_2_U_SMXP_3_1, RESERVED_32, 32, 32)
    FIELD(POR_DTM_FIFO_ENTRY1_2_U_SMXP_3_1, FIFO_CYCLE_COUNT, 16, 16)
    FIELD(POR_DTM_FIFO_ENTRY1_2_U_SMXP_3_1, FIFO_DATA2, 0, 16)
REG32(POR_DTM_FIFO_ENTRY2_0_U_SMXP_3_1, 0x190a150)
REG32(POR_DTM_FIFO_ENTRY2_1_U_SMXP_3_1, 0x190a158)
REG32(POR_DTM_FIFO_ENTRY2_2_U_SMXP_3_1, 0x190a160)
    FIELD(POR_DTM_FIFO_ENTRY2_2_U_SMXP_3_1, RESERVED_32, 32, 32)
    FIELD(POR_DTM_FIFO_ENTRY2_2_U_SMXP_3_1, FIFO_CYCLE_COUNT, 16, 16)
    FIELD(POR_DTM_FIFO_ENTRY2_2_U_SMXP_3_1, FIFO_DATA2, 0, 16)
REG32(POR_DTM_FIFO_ENTRY3_0_U_SMXP_3_1, 0x190a168)
REG32(POR_DTM_FIFO_ENTRY3_1_U_SMXP_3_1, 0x190a170)
REG32(POR_DTM_FIFO_ENTRY3_2_U_SMXP_3_1, 0x190a178)
    FIELD(POR_DTM_FIFO_ENTRY3_2_U_SMXP_3_1, RESERVED_32, 32, 32)
    FIELD(POR_DTM_FIFO_ENTRY3_2_U_SMXP_3_1, FIFO_CYCLE_COUNT, 16, 16)
    FIELD(POR_DTM_FIFO_ENTRY3_2_U_SMXP_3_1, FIFO_DATA2, 0, 16)
REG32(POR_DTM_WP0_CONFIG_U_SMXP_3_1, 0x190a1a0)
    FIELD(POR_DTM_WP0_CONFIG_U_SMXP_3_1, RESERVED_15, 15, 49)
    FIELD(POR_DTM_WP0_CONFIG_U_SMXP_3_1, WP_DBGTRIG_EN, 14, 1)
    FIELD(POR_DTM_WP0_CONFIG_U_SMXP_3_1, WP_CTRIG_EN, 13, 1)
    FIELD(POR_DTM_WP0_CONFIG_U_SMXP_3_1, WP_CC_EN, 12, 1)
    FIELD(POR_DTM_WP0_CONFIG_U_SMXP_3_1, WP_PKT_TYPE, 9, 3)
    FIELD(POR_DTM_WP0_CONFIG_U_SMXP_3_1, WP_PKT_GEN, 8, 1)
    FIELD(POR_DTM_WP0_CONFIG_U_SMXP_3_1, WP_COMBINE, 6, 1)
    FIELD(POR_DTM_WP0_CONFIG_U_SMXP_3_1, WP_EXCLUSIVE, 5, 1)
    FIELD(POR_DTM_WP0_CONFIG_U_SMXP_3_1, WP_GRP, 4, 1)
    FIELD(POR_DTM_WP0_CONFIG_U_SMXP_3_1, WP_CHN_SEL, 1, 3)
    FIELD(POR_DTM_WP0_CONFIG_U_SMXP_3_1, WP_DEV_SEL, 0, 1)
REG32(POR_DTM_WP0_VAL_U_SMXP_3_1, 0x190a1a8)
REG32(POR_DTM_WP0_MASK_U_SMXP_3_1, 0x190a1b0)
REG32(POR_DTM_WP1_CONFIG_U_SMXP_3_1, 0x190a1b8)
    FIELD(POR_DTM_WP1_CONFIG_U_SMXP_3_1, RESERVED_15, 15, 49)
    FIELD(POR_DTM_WP1_CONFIG_U_SMXP_3_1, WP_DBGTRIG_EN, 14, 1)
    FIELD(POR_DTM_WP1_CONFIG_U_SMXP_3_1, WP_CTRIG_EN, 13, 1)
    FIELD(POR_DTM_WP1_CONFIG_U_SMXP_3_1, WP_CC_EN, 12, 1)
    FIELD(POR_DTM_WP1_CONFIG_U_SMXP_3_1, WP_PKT_TYPE, 9, 3)
    FIELD(POR_DTM_WP1_CONFIG_U_SMXP_3_1, WP_PKT_GEN, 8, 1)
    FIELD(POR_DTM_WP1_CONFIG_U_SMXP_3_1, WP_EXCLUSIVE, 5, 1)
    FIELD(POR_DTM_WP1_CONFIG_U_SMXP_3_1, WP_GRP, 4, 1)
    FIELD(POR_DTM_WP1_CONFIG_U_SMXP_3_1, WP_CHN_SEL, 1, 3)
    FIELD(POR_DTM_WP1_CONFIG_U_SMXP_3_1, WP_DEV_SEL, 0, 1)
REG32(POR_DTM_WP1_VAL_U_SMXP_3_1, 0x190a1c0)
REG32(POR_DTM_WP1_MASK_U_SMXP_3_1, 0x190a1c8)
REG32(POR_DTM_WP2_CONFIG_U_SMXP_3_1, 0x190a1d0)
    FIELD(POR_DTM_WP2_CONFIG_U_SMXP_3_1, RESERVED_15, 15, 49)
    FIELD(POR_DTM_WP2_CONFIG_U_SMXP_3_1, WP_DBGTRIG_EN, 14, 1)
    FIELD(POR_DTM_WP2_CONFIG_U_SMXP_3_1, WP_CTRIG_EN, 13, 1)
    FIELD(POR_DTM_WP2_CONFIG_U_SMXP_3_1, WP_CC_EN, 12, 1)
    FIELD(POR_DTM_WP2_CONFIG_U_SMXP_3_1, WP_PKT_TYPE, 9, 3)
    FIELD(POR_DTM_WP2_CONFIG_U_SMXP_3_1, WP_PKT_GEN, 8, 1)
    FIELD(POR_DTM_WP2_CONFIG_U_SMXP_3_1, WP_COMBINE, 6, 1)
    FIELD(POR_DTM_WP2_CONFIG_U_SMXP_3_1, WP_EXCLUSIVE, 5, 1)
    FIELD(POR_DTM_WP2_CONFIG_U_SMXP_3_1, WP_GRP, 4, 1)
    FIELD(POR_DTM_WP2_CONFIG_U_SMXP_3_1, WP_CHN_SEL, 1, 3)
    FIELD(POR_DTM_WP2_CONFIG_U_SMXP_3_1, WP_DEV_SEL, 0, 1)
REG32(POR_DTM_WP2_VAL_U_SMXP_3_1, 0x190a1d8)
REG32(POR_DTM_WP2_MASK_U_SMXP_3_1, 0x190a1e0)
REG32(POR_DTM_WP3_CONFIG_U_SMXP_3_1, 0x190a1e8)
    FIELD(POR_DTM_WP3_CONFIG_U_SMXP_3_1, RESERVED_15, 15, 49)
    FIELD(POR_DTM_WP3_CONFIG_U_SMXP_3_1, WP_DBGTRIG_EN, 14, 1)
    FIELD(POR_DTM_WP3_CONFIG_U_SMXP_3_1, WP_CTRIG_EN, 13, 1)
    FIELD(POR_DTM_WP3_CONFIG_U_SMXP_3_1, WP_CC_EN, 12, 1)
    FIELD(POR_DTM_WP3_CONFIG_U_SMXP_3_1, WP_PKT_TYPE, 9, 3)
    FIELD(POR_DTM_WP3_CONFIG_U_SMXP_3_1, WP_PKT_GEN, 8, 1)
    FIELD(POR_DTM_WP3_CONFIG_U_SMXP_3_1, WP_EXCLUSIVE, 5, 1)
    FIELD(POR_DTM_WP3_CONFIG_U_SMXP_3_1, WP_GRP, 4, 1)
    FIELD(POR_DTM_WP3_CONFIG_U_SMXP_3_1, WP_CHN_SEL, 1, 3)
    FIELD(POR_DTM_WP3_CONFIG_U_SMXP_3_1, WP_DEV_SEL, 0, 1)
REG32(POR_DTM_WP3_VAL_U_SMXP_3_1, 0x190a1f0)
REG32(POR_DTM_WP3_MASK_U_SMXP_3_1, 0x190a1f8)
REG32(POR_DTM_PMSICR_U_SMXP_3_1, 0x190a200)
    FIELD(POR_DTM_PMSICR_U_SMXP_3_1, RESERVED_32, 32, 32)
    FIELD(POR_DTM_PMSICR_U_SMXP_3_1, COUNT, 0, 32)
REG32(POR_DTM_PMSIRR_U_SMXP_3_1, 0x190a208)
    FIELD(POR_DTM_PMSIRR_U_SMXP_3_1, RESERVED_32, 32, 32)
    FIELD(POR_DTM_PMSIRR_U_SMXP_3_1, INTERVAL, 8, 24)
    FIELD(POR_DTM_PMSIRR_U_SMXP_3_1, RESERVED_0, 0, 8)
REG32(POR_DTM_PMU_CONFIG_U_SMXP_3_1, 0x190a210)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_3_1, RESERVED_62, 62, 2)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_3_1, PMEVCNT3_INPUT_SEL, 56, 6)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_3_1, RESERVED_54, 54, 2)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_3_1, PMEVCNT2_INPUT_SEL, 48, 6)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_3_1, RESERVED_46, 46, 2)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_3_1, PMEVCNT1_INPUT_SEL, 40, 6)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_3_1, RESERVED_38, 38, 2)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_3_1, PMEVCNT0_INPUT_SEL, 32, 6)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_3_1, RESERVED_31, 31, 1)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_3_1, PMEVCNT3_GLOBAL_NUM, 28, 3)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_3_1, RESERVED_27, 27, 1)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_3_1, PMEVCNT2_GLOBAL_NUM, 24, 3)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_3_1, RESERVED_23, 23, 1)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_3_1, PMEVCNT1_GLOBAL_NUM, 20, 3)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_3_1, RESERVED_19, 19, 1)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_3_1, PMEVCNT0_GLOBAL_NUM, 16, 3)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_3_1, RESERVED_9, 9, 7)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_3_1, CNTR_RST, 8, 1)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_3_1, PMEVCNT_PAIRED, 4, 4)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_3_1, PMEVCNTALL_COMBINED, 3, 1)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_3_1, PMEVCNT23_COMBINED, 2, 1)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_3_1, PMEVCNT01_COMBINED, 1, 1)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_3_1, PMU_EN, 0, 1)
REG32(POR_DTM_PMEVCNT_U_SMXP_3_1, 0x190a220)
    FIELD(POR_DTM_PMEVCNT_U_SMXP_3_1, PMEVCNT3, 48, 16)
    FIELD(POR_DTM_PMEVCNT_U_SMXP_3_1, PMEVCNT2, 32, 16)
    FIELD(POR_DTM_PMEVCNT_U_SMXP_3_1, PMEVCNT1, 16, 16)
    FIELD(POR_DTM_PMEVCNT_U_SMXP_3_1, PMEVCNT0, 0, 16)
REG32(POR_DTM_PMEVCNTSR_U_SMXP_3_1, 0x190a240)
    FIELD(POR_DTM_PMEVCNTSR_U_SMXP_3_1, PMEVCNTSR3, 48, 16)
    FIELD(POR_DTM_PMEVCNTSR_U_SMXP_3_1, PMEVCNTSR2, 32, 16)
    FIELD(POR_DTM_PMEVCNTSR_U_SMXP_3_1, PMEVCNTSR1, 16, 16)
    FIELD(POR_DTM_PMEVCNTSR_U_SMXP_3_1, PMEVCNTSR0, 0, 16)
REG32(POR_MXP_ERRFR_U_SMXP_3_1, 0x190b000)
    FIELD(POR_MXP_ERRFR_U_SMXP_3_1, RESERVED_15, 15, 49)
    FIELD(POR_MXP_ERRFR_U_SMXP_3_1, CEC, 12, 3)
    FIELD(POR_MXP_ERRFR_U_SMXP_3_1, CFI, 10, 2)
    FIELD(POR_MXP_ERRFR_U_SMXP_3_1, FI, 6, 2)
    FIELD(POR_MXP_ERRFR_U_SMXP_3_1, UI, 4, 2)
    FIELD(POR_MXP_ERRFR_U_SMXP_3_1, DE, 2, 2)
    FIELD(POR_MXP_ERRFR_U_SMXP_3_1, ED, 0, 2)
REG32(POR_MXP_ERRCTLR_U_SMXP_3_1, 0x190b008)
    FIELD(POR_MXP_ERRCTLR_U_SMXP_3_1, RESERVED_9, 9, 55)
    FIELD(POR_MXP_ERRCTLR_U_SMXP_3_1, CFI, 8, 1)
    FIELD(POR_MXP_ERRCTLR_U_SMXP_3_1, FI, 3, 1)
    FIELD(POR_MXP_ERRCTLR_U_SMXP_3_1, UI, 2, 1)
    FIELD(POR_MXP_ERRCTLR_U_SMXP_3_1, DE, 1, 1)
    FIELD(POR_MXP_ERRCTLR_U_SMXP_3_1, ED, 0, 1)
REG32(POR_MXP_ERRSTATUS_U_SMXP_3_1, 0x190b010)
    FIELD(POR_MXP_ERRSTATUS_U_SMXP_3_1, RESERVED_32, 32, 32)
    FIELD(POR_MXP_ERRSTATUS_U_SMXP_3_1, AV, 31, 1)
    FIELD(POR_MXP_ERRSTATUS_U_SMXP_3_1, V, 30, 1)
    FIELD(POR_MXP_ERRSTATUS_U_SMXP_3_1, UE, 29, 1)
    FIELD(POR_MXP_ERRSTATUS_U_SMXP_3_1, RESERVED_28, 28, 1)
    FIELD(POR_MXP_ERRSTATUS_U_SMXP_3_1, OF, 27, 1)
    FIELD(POR_MXP_ERRSTATUS_U_SMXP_3_1, MV, 26, 1)
    FIELD(POR_MXP_ERRSTATUS_U_SMXP_3_1, RESERVED_25, 25, 1)
    FIELD(POR_MXP_ERRSTATUS_U_SMXP_3_1, CE, 24, 1)
    FIELD(POR_MXP_ERRSTATUS_U_SMXP_3_1, DE, 23, 1)
    FIELD(POR_MXP_ERRSTATUS_U_SMXP_3_1, RESERVED_0, 0, 23)
REG32(POR_MXP_ERRMISC_U_SMXP_3_1, 0x190b028)
    FIELD(POR_MXP_ERRMISC_U_SMXP_3_1, RESERVED_59, 59, 5)
    FIELD(POR_MXP_ERRMISC_U_SMXP_3_1, TGTID, 48, 11)
    FIELD(POR_MXP_ERRMISC_U_SMXP_3_1, RESERVED_22, 22, 26)
    FIELD(POR_MXP_ERRMISC_U_SMXP_3_1, OPCODE, 16, 6)
    FIELD(POR_MXP_ERRMISC_U_SMXP_3_1, RESERVED_15, 15, 1)
    FIELD(POR_MXP_ERRMISC_U_SMXP_3_1, SRCID, 4, 11)
    FIELD(POR_MXP_ERRMISC_U_SMXP_3_1, ERRSRC, 0, 3)
REG32(POR_MXP_P0_BYTE_PAR_ERR_INJ_U_SMXP_3_1, 0x190b030)
    FIELD(POR_MXP_P0_BYTE_PAR_ERR_INJ_U_SMXP_3_1, P0_BYTE_PARITY_ERR_INJ, 0, 5)
REG32(POR_MXP_P1_BYTE_PAR_ERR_INJ_U_SMXP_3_1, 0x190b038)
    FIELD(POR_MXP_P1_BYTE_PAR_ERR_INJ_U_SMXP_3_1, P1_BYTE_PARITY_ERR_INJ, 0, 5)
REG32(POR_MXP_ERRFR_NS_U_SMXP_3_1, 0x190b100)
    FIELD(POR_MXP_ERRFR_NS_U_SMXP_3_1, RESERVED_15, 15, 49)
    FIELD(POR_MXP_ERRFR_NS_U_SMXP_3_1, CEC, 12, 3)
    FIELD(POR_MXP_ERRFR_NS_U_SMXP_3_1, CFI, 10, 2)
    FIELD(POR_MXP_ERRFR_NS_U_SMXP_3_1, FI, 6, 2)
    FIELD(POR_MXP_ERRFR_NS_U_SMXP_3_1, UI, 4, 2)
    FIELD(POR_MXP_ERRFR_NS_U_SMXP_3_1, DE, 2, 2)
    FIELD(POR_MXP_ERRFR_NS_U_SMXP_3_1, ED, 0, 2)
REG32(POR_MXP_ERRCTLR_NS_U_SMXP_3_1, 0x190b108)
    FIELD(POR_MXP_ERRCTLR_NS_U_SMXP_3_1, RESERVED_9, 9, 55)
    FIELD(POR_MXP_ERRCTLR_NS_U_SMXP_3_1, CFI, 8, 1)
    FIELD(POR_MXP_ERRCTLR_NS_U_SMXP_3_1, FI, 3, 1)
    FIELD(POR_MXP_ERRCTLR_NS_U_SMXP_3_1, UI, 2, 1)
    FIELD(POR_MXP_ERRCTLR_NS_U_SMXP_3_1, DE, 1, 1)
    FIELD(POR_MXP_ERRCTLR_NS_U_SMXP_3_1, ED, 0, 1)
REG32(POR_MXP_ERRSTATUS_NS_U_SMXP_3_1, 0x190b110)
    FIELD(POR_MXP_ERRSTATUS_NS_U_SMXP_3_1, RESERVED_32, 32, 32)
    FIELD(POR_MXP_ERRSTATUS_NS_U_SMXP_3_1, AV, 31, 1)
    FIELD(POR_MXP_ERRSTATUS_NS_U_SMXP_3_1, V, 30, 1)
    FIELD(POR_MXP_ERRSTATUS_NS_U_SMXP_3_1, UE, 29, 1)
    FIELD(POR_MXP_ERRSTATUS_NS_U_SMXP_3_1, RESERVED_28, 28, 1)
    FIELD(POR_MXP_ERRSTATUS_NS_U_SMXP_3_1, OF, 27, 1)
    FIELD(POR_MXP_ERRSTATUS_NS_U_SMXP_3_1, MV, 26, 1)
    FIELD(POR_MXP_ERRSTATUS_NS_U_SMXP_3_1, RESERVED_25, 25, 1)
    FIELD(POR_MXP_ERRSTATUS_NS_U_SMXP_3_1, CE, 24, 1)
    FIELD(POR_MXP_ERRSTATUS_NS_U_SMXP_3_1, DE, 23, 1)
    FIELD(POR_MXP_ERRSTATUS_NS_U_SMXP_3_1, RESERVED_0, 0, 23)
REG32(POR_MXP_ERRMISC_NS_U_SMXP_3_1, 0x190b128)
    FIELD(POR_MXP_ERRMISC_NS_U_SMXP_3_1, RESERVED_59, 59, 5)
    FIELD(POR_MXP_ERRMISC_NS_U_SMXP_3_1, TGTID, 48, 11)
    FIELD(POR_MXP_ERRMISC_NS_U_SMXP_3_1, RESERVED_22, 22, 26)
    FIELD(POR_MXP_ERRMISC_NS_U_SMXP_3_1, OPCODE, 16, 6)
    FIELD(POR_MXP_ERRMISC_NS_U_SMXP_3_1, RESERVED_15, 15, 1)
    FIELD(POR_MXP_ERRMISC_NS_U_SMXP_3_1, SRCID, 4, 11)
    FIELD(POR_MXP_ERRMISC_NS_U_SMXP_3_1, ERRSRC, 0, 3)
REG32(POR_FDC_NODE_INFO_U_SMXP_3_1, 0x192c000)
    FIELD(POR_FDC_NODE_INFO_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_FDC_NODE_INFO_U_SMXP_3_1, LOGICAL_ID, 32, 16)
    FIELD(POR_FDC_NODE_INFO_U_SMXP_3_1, NODE_ID, 16, 16)
    FIELD(POR_FDC_NODE_INFO_U_SMXP_3_1, NODE_TYPE, 0, 16)
REG32(POR_FDC_CHILD_INFO_U_SMXP_3_1, 0x192c080)
    FIELD(POR_FDC_CHILD_INFO_U_SMXP_3_1, RESERVED_32, 32, 32)
    FIELD(POR_FDC_CHILD_INFO_U_SMXP_3_1, CHILD_PTR_OFFSET, 16, 16)
    FIELD(POR_FDC_CHILD_INFO_U_SMXP_3_1, CHILD_COUNT, 0, 16)
REG32(POR_ERRFR_MXP_U_SMXP_3_1, 0x192f000)
    FIELD(POR_ERRFR_MXP_U_SMXP_3_1, FI, 6, 2)
    FIELD(POR_ERRFR_MXP_U_SMXP_3_1, UI, 4, 2)
    FIELD(POR_ERRFR_MXP_U_SMXP_3_1, ED, 0, 2)
REG32(POR_ERRCTLR_MXP_U_SMXP_3_1, 0x192f008)
    FIELD(POR_ERRCTLR_MXP_U_SMXP_3_1, RESERVED_32, 32, 32)
    FIELD(POR_ERRCTLR_MXP_U_SMXP_3_1, ERC, 14, 18)
    FIELD(POR_ERRCTLR_MXP_U_SMXP_3_1, FI, 3, 1)
    FIELD(POR_ERRCTLR_MXP_U_SMXP_3_1, UI, 2, 1)
    FIELD(POR_ERRCTLR_MXP_U_SMXP_3_1, ED, 0, 1)
REG32(POR_ERRSTATUS_MXP_U_SMXP_3_1, 0x192f010)
    FIELD(POR_ERRSTATUS_MXP_U_SMXP_3_1, RESERVED_31, 31, 33)
    FIELD(POR_ERRSTATUS_MXP_U_SMXP_3_1, V, 30, 1)
    FIELD(POR_ERRSTATUS_MXP_U_SMXP_3_1, UE, 29, 1)
    FIELD(POR_ERRSTATUS_MXP_U_SMXP_3_1, RESERVED_28, 28, 1)
    FIELD(POR_ERRSTATUS_MXP_U_SMXP_3_1, OF, 27, 1)
    FIELD(POR_ERRSTATUS_MXP_U_SMXP_3_1, RESERVED_24, 24, 3)
    FIELD(POR_ERRSTATUS_MXP_U_SMXP_3_1, DE, 23, 1)
    FIELD(POR_ERRSTATUS_MXP_U_SMXP_3_1, RESERVED_16, 16, 7)
    FIELD(POR_ERRSTATUS_MXP_U_SMXP_3_1, V_ERR_TYPE, 6, 10)
    FIELD(POR_ERRSTATUS_MXP_U_SMXP_3_1, RESERVED_0, 0, 6)
REG32(POR_FDC_AUX_CTL_MXP_U_SMXP_3_1, 0x192f018)
    FIELD(POR_FDC_AUX_CTL_MXP_U_SMXP_3_1, CLKGATE_OVERRIDE, 4, 1)
    FIELD(POR_FDC_AUX_CTL_MXP_U_SMXP_3_1, RESERVED_0, 0, 4)
REG32(POR_ERRFR_P0_D0_U_SMXP_3_1, 0x192f040)
    FIELD(POR_ERRFR_P0_D0_U_SMXP_3_1, FI, 6, 2)
    FIELD(POR_ERRFR_P0_D0_U_SMXP_3_1, UI, 4, 2)
    FIELD(POR_ERRFR_P0_D0_U_SMXP_3_1, ED, 0, 2)
REG32(POR_ERRCTLR_P0_D0_U_SMXP_3_1, 0x192f048)
    FIELD(POR_ERRCTLR_P0_D0_U_SMXP_3_1, RESERVED_32, 32, 32)
    FIELD(POR_ERRCTLR_P0_D0_U_SMXP_3_1, ERC, 14, 18)
    FIELD(POR_ERRCTLR_P0_D0_U_SMXP_3_1, FI, 3, 1)
    FIELD(POR_ERRCTLR_P0_D0_U_SMXP_3_1, UI, 2, 1)
    FIELD(POR_ERRCTLR_P0_D0_U_SMXP_3_1, ED, 0, 1)
REG32(POR_ERRSTATUS_P0_D0_U_SMXP_3_1, 0x192f050)
    FIELD(POR_ERRSTATUS_P0_D0_U_SMXP_3_1, RESERVED_31, 31, 33)
    FIELD(POR_ERRSTATUS_P0_D0_U_SMXP_3_1, V, 30, 1)
    FIELD(POR_ERRSTATUS_P0_D0_U_SMXP_3_1, UE, 29, 1)
    FIELD(POR_ERRSTATUS_P0_D0_U_SMXP_3_1, RESERVED_28, 28, 1)
    FIELD(POR_ERRSTATUS_P0_D0_U_SMXP_3_1, OF, 27, 1)
    FIELD(POR_ERRSTATUS_P0_D0_U_SMXP_3_1, RESERVED_24, 24, 3)
    FIELD(POR_ERRSTATUS_P0_D0_U_SMXP_3_1, DE, 23, 1)
    FIELD(POR_ERRSTATUS_P0_D0_U_SMXP_3_1, RESERVED_16, 16, 7)
    FIELD(POR_ERRSTATUS_P0_D0_U_SMXP_3_1, V_ERR_TYPE, 6, 10)
    FIELD(POR_ERRSTATUS_P0_D0_U_SMXP_3_1, RESERVED_0, 0, 6)
REG32(POR_FDC_AUX_CTL_P0_D0_U_SMXP_3_1, 0x192f058)
    FIELD(POR_FDC_AUX_CTL_P0_D0_U_SMXP_3_1, CLKGATE_OVERRIDE, 4, 1)
    FIELD(POR_FDC_AUX_CTL_P0_D0_U_SMXP_3_1, HANG_DET_CONFIG, 0, 4)
REG32(POR_ERRFR_P0_D1_U_SMXP_3_1, 0x192f080)
    FIELD(POR_ERRFR_P0_D1_U_SMXP_3_1, FI, 6, 2)
    FIELD(POR_ERRFR_P0_D1_U_SMXP_3_1, UI, 4, 2)
    FIELD(POR_ERRFR_P0_D1_U_SMXP_3_1, ED, 0, 2)
REG32(POR_ERRCTLR_P0_D1_U_SMXP_3_1, 0x192f088)
    FIELD(POR_ERRCTLR_P0_D1_U_SMXP_3_1, RESERVED_32, 32, 32)
    FIELD(POR_ERRCTLR_P0_D1_U_SMXP_3_1, ERC, 14, 18)
    FIELD(POR_ERRCTLR_P0_D1_U_SMXP_3_1, FI, 3, 1)
    FIELD(POR_ERRCTLR_P0_D1_U_SMXP_3_1, UI, 2, 1)
    FIELD(POR_ERRCTLR_P0_D1_U_SMXP_3_1, ED, 0, 1)
REG32(POR_ERRSTATUS_P0_D1_U_SMXP_3_1, 0x192f090)
    FIELD(POR_ERRSTATUS_P0_D1_U_SMXP_3_1, RESERVED_31, 31, 33)
    FIELD(POR_ERRSTATUS_P0_D1_U_SMXP_3_1, V, 30, 1)
    FIELD(POR_ERRSTATUS_P0_D1_U_SMXP_3_1, UE, 29, 1)
    FIELD(POR_ERRSTATUS_P0_D1_U_SMXP_3_1, RESERVED_28, 28, 1)
    FIELD(POR_ERRSTATUS_P0_D1_U_SMXP_3_1, OF, 27, 1)
    FIELD(POR_ERRSTATUS_P0_D1_U_SMXP_3_1, RESERVED_24, 24, 3)
    FIELD(POR_ERRSTATUS_P0_D1_U_SMXP_3_1, DE, 23, 1)
    FIELD(POR_ERRSTATUS_P0_D1_U_SMXP_3_1, RESERVED_16, 16, 7)
    FIELD(POR_ERRSTATUS_P0_D1_U_SMXP_3_1, V_ERR_TYPE, 6, 10)
    FIELD(POR_ERRSTATUS_P0_D1_U_SMXP_3_1, RESERVED_0, 0, 6)
REG32(POR_FDC_AUX_CTL_P0_D1_U_SMXP_3_1, 0x192f098)
    FIELD(POR_FDC_AUX_CTL_P0_D1_U_SMXP_3_1, CLKGATE_OVERRIDE, 4, 1)
    FIELD(POR_FDC_AUX_CTL_P0_D1_U_SMXP_3_1, HANG_DET_CONFIG, 0, 4)
REG32(POR_ERRFR_P0_D2_U_SMXP_3_1, 0x192f0c0)
    FIELD(POR_ERRFR_P0_D2_U_SMXP_3_1, FI, 6, 2)
    FIELD(POR_ERRFR_P0_D2_U_SMXP_3_1, UI, 4, 2)
    FIELD(POR_ERRFR_P0_D2_U_SMXP_3_1, ED, 0, 2)
REG32(POR_ERRCTLR_P0_D2_U_SMXP_3_1, 0x192f0c8)
    FIELD(POR_ERRCTLR_P0_D2_U_SMXP_3_1, RESERVED_32, 32, 32)
    FIELD(POR_ERRCTLR_P0_D2_U_SMXP_3_1, ERC, 14, 18)
    FIELD(POR_ERRCTLR_P0_D2_U_SMXP_3_1, FI, 3, 1)
    FIELD(POR_ERRCTLR_P0_D2_U_SMXP_3_1, UI, 2, 1)
    FIELD(POR_ERRCTLR_P0_D2_U_SMXP_3_1, ED, 0, 1)
REG32(POR_ERRSTATUS_P0_D2_U_SMXP_3_1, 0x192f0d0)
    FIELD(POR_ERRSTATUS_P0_D2_U_SMXP_3_1, RESERVED_31, 31, 33)
    FIELD(POR_ERRSTATUS_P0_D2_U_SMXP_3_1, V, 30, 1)
    FIELD(POR_ERRSTATUS_P0_D2_U_SMXP_3_1, UE, 29, 1)
    FIELD(POR_ERRSTATUS_P0_D2_U_SMXP_3_1, RESERVED_28, 28, 1)
    FIELD(POR_ERRSTATUS_P0_D2_U_SMXP_3_1, OF, 27, 1)
    FIELD(POR_ERRSTATUS_P0_D2_U_SMXP_3_1, RESERVED_24, 24, 3)
    FIELD(POR_ERRSTATUS_P0_D2_U_SMXP_3_1, DE, 23, 1)
    FIELD(POR_ERRSTATUS_P0_D2_U_SMXP_3_1, RESERVED_16, 16, 7)
    FIELD(POR_ERRSTATUS_P0_D2_U_SMXP_3_1, V_ERR_TYPE, 6, 10)
    FIELD(POR_ERRSTATUS_P0_D2_U_SMXP_3_1, RESERVED_0, 0, 6)
REG32(POR_FDC_AUX_CTL_P0_D2_U_SMXP_3_1, 0x192f0d8)
    FIELD(POR_FDC_AUX_CTL_P0_D2_U_SMXP_3_1, CLKGATE_OVERRIDE, 4, 1)
    FIELD(POR_FDC_AUX_CTL_P0_D2_U_SMXP_3_1, HANG_DET_CONFIG, 0, 4)
REG32(POR_ERRFR_P0_D3_U_SMXP_3_1, 0x192f100)
    FIELD(POR_ERRFR_P0_D3_U_SMXP_3_1, FI, 6, 2)
    FIELD(POR_ERRFR_P0_D3_U_SMXP_3_1, UI, 4, 2)
    FIELD(POR_ERRFR_P0_D3_U_SMXP_3_1, ED, 0, 2)
REG32(POR_ERRCTLR_P0_D3_U_SMXP_3_1, 0x192f108)
    FIELD(POR_ERRCTLR_P0_D3_U_SMXP_3_1, RESERVED_32, 32, 32)
    FIELD(POR_ERRCTLR_P0_D3_U_SMXP_3_1, ERC, 14, 18)
    FIELD(POR_ERRCTLR_P0_D3_U_SMXP_3_1, FI, 3, 1)
    FIELD(POR_ERRCTLR_P0_D3_U_SMXP_3_1, UI, 2, 1)
    FIELD(POR_ERRCTLR_P0_D3_U_SMXP_3_1, ED, 0, 1)
REG32(POR_ERRSTATUS_P0_D3_U_SMXP_3_1, 0x192f110)
    FIELD(POR_ERRSTATUS_P0_D3_U_SMXP_3_1, RESERVED_31, 31, 33)
    FIELD(POR_ERRSTATUS_P0_D3_U_SMXP_3_1, V, 30, 1)
    FIELD(POR_ERRSTATUS_P0_D3_U_SMXP_3_1, UE, 29, 1)
    FIELD(POR_ERRSTATUS_P0_D3_U_SMXP_3_1, RESERVED_28, 28, 1)
    FIELD(POR_ERRSTATUS_P0_D3_U_SMXP_3_1, OF, 27, 1)
    FIELD(POR_ERRSTATUS_P0_D3_U_SMXP_3_1, RESERVED_24, 24, 3)
    FIELD(POR_ERRSTATUS_P0_D3_U_SMXP_3_1, DE, 23, 1)
    FIELD(POR_ERRSTATUS_P0_D3_U_SMXP_3_1, RESERVED_16, 16, 7)
    FIELD(POR_ERRSTATUS_P0_D3_U_SMXP_3_1, V_ERR_TYPE, 6, 10)
    FIELD(POR_ERRSTATUS_P0_D3_U_SMXP_3_1, RESERVED_0, 0, 6)
REG32(POR_FDC_AUX_CTL_P0_D3_U_SMXP_3_1, 0x192f118)
    FIELD(POR_FDC_AUX_CTL_P0_D3_U_SMXP_3_1, CLKGATE_OVERRIDE, 4, 1)
    FIELD(POR_FDC_AUX_CTL_P0_D3_U_SMXP_3_1, HANG_DET_CONFIG, 0, 4)
REG32(POR_ERRFR_P1_D0_U_SMXP_3_1, 0x192f140)
    FIELD(POR_ERRFR_P1_D0_U_SMXP_3_1, FI, 6, 2)
    FIELD(POR_ERRFR_P1_D0_U_SMXP_3_1, UI, 4, 2)
    FIELD(POR_ERRFR_P1_D0_U_SMXP_3_1, ED, 0, 2)
REG32(POR_ERRCTLR_P1_D0_U_SMXP_3_1, 0x192f148)
    FIELD(POR_ERRCTLR_P1_D0_U_SMXP_3_1, RESERVED_32, 32, 32)
    FIELD(POR_ERRCTLR_P1_D0_U_SMXP_3_1, ERC, 14, 18)
    FIELD(POR_ERRCTLR_P1_D0_U_SMXP_3_1, FI, 3, 1)
    FIELD(POR_ERRCTLR_P1_D0_U_SMXP_3_1, UI, 2, 1)
    FIELD(POR_ERRCTLR_P1_D0_U_SMXP_3_1, ED, 0, 1)
REG32(POR_ERRSTATUS_P1_D0_U_SMXP_3_1, 0x192f150)
    FIELD(POR_ERRSTATUS_P1_D0_U_SMXP_3_1, RESERVED_31, 31, 33)
    FIELD(POR_ERRSTATUS_P1_D0_U_SMXP_3_1, V, 30, 1)
    FIELD(POR_ERRSTATUS_P1_D0_U_SMXP_3_1, UE, 29, 1)
    FIELD(POR_ERRSTATUS_P1_D0_U_SMXP_3_1, RESERVED_28, 28, 1)
    FIELD(POR_ERRSTATUS_P1_D0_U_SMXP_3_1, OF, 27, 1)
    FIELD(POR_ERRSTATUS_P1_D0_U_SMXP_3_1, RESERVED_24, 24, 3)
    FIELD(POR_ERRSTATUS_P1_D0_U_SMXP_3_1, DE, 23, 1)
    FIELD(POR_ERRSTATUS_P1_D0_U_SMXP_3_1, RESERVED_16, 16, 7)
    FIELD(POR_ERRSTATUS_P1_D0_U_SMXP_3_1, V_ERR_TYPE, 6, 10)
    FIELD(POR_ERRSTATUS_P1_D0_U_SMXP_3_1, RESERVED_0, 0, 6)
REG32(POR_FDC_AUX_CTL_P1_D0_U_SMXP_3_1, 0x192f158)
    FIELD(POR_FDC_AUX_CTL_P1_D0_U_SMXP_3_1, CLKGATE_OVERRIDE, 4, 1)
    FIELD(POR_FDC_AUX_CTL_P1_D0_U_SMXP_3_1, HANG_DET_CONFIG, 0, 4)
REG32(POR_ERRFR_P1_D1_U_SMXP_3_1, 0x192f180)
    FIELD(POR_ERRFR_P1_D1_U_SMXP_3_1, FI, 6, 2)
    FIELD(POR_ERRFR_P1_D1_U_SMXP_3_1, UI, 4, 2)
    FIELD(POR_ERRFR_P1_D1_U_SMXP_3_1, ED, 0, 2)
REG32(POR_ERRCTLR_P1_D1_U_SMXP_3_1, 0x192f188)
    FIELD(POR_ERRCTLR_P1_D1_U_SMXP_3_1, RESERVED_32, 32, 32)
    FIELD(POR_ERRCTLR_P1_D1_U_SMXP_3_1, ERC, 14, 18)
    FIELD(POR_ERRCTLR_P1_D1_U_SMXP_3_1, FI, 3, 1)
    FIELD(POR_ERRCTLR_P1_D1_U_SMXP_3_1, UI, 2, 1)
    FIELD(POR_ERRCTLR_P1_D1_U_SMXP_3_1, ED, 0, 1)
REG32(POR_ERRSTATUS_P1_D1_U_SMXP_3_1, 0x192f190)
    FIELD(POR_ERRSTATUS_P1_D1_U_SMXP_3_1, RESERVED_31, 31, 33)
    FIELD(POR_ERRSTATUS_P1_D1_U_SMXP_3_1, V, 30, 1)
    FIELD(POR_ERRSTATUS_P1_D1_U_SMXP_3_1, UE, 29, 1)
    FIELD(POR_ERRSTATUS_P1_D1_U_SMXP_3_1, RESERVED_28, 28, 1)
    FIELD(POR_ERRSTATUS_P1_D1_U_SMXP_3_1, OF, 27, 1)
    FIELD(POR_ERRSTATUS_P1_D1_U_SMXP_3_1, RESERVED_24, 24, 3)
    FIELD(POR_ERRSTATUS_P1_D1_U_SMXP_3_1, DE, 23, 1)
    FIELD(POR_ERRSTATUS_P1_D1_U_SMXP_3_1, RESERVED_16, 16, 7)
    FIELD(POR_ERRSTATUS_P1_D1_U_SMXP_3_1, V_ERR_TYPE, 6, 10)
    FIELD(POR_ERRSTATUS_P1_D1_U_SMXP_3_1, RESERVED_0, 0, 6)
REG32(POR_FDC_AUX_CTL_P1_D1_U_SMXP_3_1, 0x192f198)
    FIELD(POR_FDC_AUX_CTL_P1_D1_U_SMXP_3_1, CLKGATE_OVERRIDE, 4, 1)
    FIELD(POR_FDC_AUX_CTL_P1_D1_U_SMXP_3_1, HANG_DET_CONFIG, 0, 4)
REG32(POR_ERRFR_P1_D2_U_SMXP_3_1, 0x192f1c0)
    FIELD(POR_ERRFR_P1_D2_U_SMXP_3_1, FI, 6, 2)
    FIELD(POR_ERRFR_P1_D2_U_SMXP_3_1, UI, 4, 2)
    FIELD(POR_ERRFR_P1_D2_U_SMXP_3_1, ED, 0, 2)
REG32(POR_ERRCTLR_P1_D2_U_SMXP_3_1, 0x192f1c8)
    FIELD(POR_ERRCTLR_P1_D2_U_SMXP_3_1, RESERVED_32, 32, 32)
    FIELD(POR_ERRCTLR_P1_D2_U_SMXP_3_1, ERC, 14, 18)
    FIELD(POR_ERRCTLR_P1_D2_U_SMXP_3_1, FI, 3, 1)
    FIELD(POR_ERRCTLR_P1_D2_U_SMXP_3_1, UI, 2, 1)
    FIELD(POR_ERRCTLR_P1_D2_U_SMXP_3_1, ED, 0, 1)
REG32(POR_ERRSTATUS_P1_D2_U_SMXP_3_1, 0x192f1d0)
    FIELD(POR_ERRSTATUS_P1_D2_U_SMXP_3_1, RESERVED_31, 31, 33)
    FIELD(POR_ERRSTATUS_P1_D2_U_SMXP_3_1, V, 30, 1)
    FIELD(POR_ERRSTATUS_P1_D2_U_SMXP_3_1, UE, 29, 1)
    FIELD(POR_ERRSTATUS_P1_D2_U_SMXP_3_1, RESERVED_28, 28, 1)
    FIELD(POR_ERRSTATUS_P1_D2_U_SMXP_3_1, OF, 27, 1)
    FIELD(POR_ERRSTATUS_P1_D2_U_SMXP_3_1, RESERVED_24, 24, 3)
    FIELD(POR_ERRSTATUS_P1_D2_U_SMXP_3_1, DE, 23, 1)
    FIELD(POR_ERRSTATUS_P1_D2_U_SMXP_3_1, RESERVED_16, 16, 7)
    FIELD(POR_ERRSTATUS_P1_D2_U_SMXP_3_1, V_ERR_TYPE, 6, 10)
    FIELD(POR_ERRSTATUS_P1_D2_U_SMXP_3_1, RESERVED_0, 0, 6)
REG32(POR_FDC_AUX_CTL_P1_D2_U_SMXP_3_1, 0x192f1d8)
    FIELD(POR_FDC_AUX_CTL_P1_D2_U_SMXP_3_1, CLKGATE_OVERRIDE, 4, 1)
    FIELD(POR_FDC_AUX_CTL_P1_D2_U_SMXP_3_1, HANG_DET_CONFIG, 0, 4)
REG32(POR_ERRFR_P1_D3_U_SMXP_3_1, 0x192f200)
    FIELD(POR_ERRFR_P1_D3_U_SMXP_3_1, FI, 6, 2)
    FIELD(POR_ERRFR_P1_D3_U_SMXP_3_1, UI, 4, 2)
    FIELD(POR_ERRFR_P1_D3_U_SMXP_3_1, ED, 0, 2)
REG32(POR_ERRCTLR_P1_D3_U_SMXP_3_1, 0x192f208)
    FIELD(POR_ERRCTLR_P1_D3_U_SMXP_3_1, RESERVED_32, 32, 32)
    FIELD(POR_ERRCTLR_P1_D3_U_SMXP_3_1, ERC, 14, 18)
    FIELD(POR_ERRCTLR_P1_D3_U_SMXP_3_1, FI, 3, 1)
    FIELD(POR_ERRCTLR_P1_D3_U_SMXP_3_1, UI, 2, 1)
    FIELD(POR_ERRCTLR_P1_D3_U_SMXP_3_1, ED, 0, 1)
REG32(POR_ERRSTATUS_P1_D3_U_SMXP_3_1, 0x192f210)
    FIELD(POR_ERRSTATUS_P1_D3_U_SMXP_3_1, RESERVED_31, 31, 33)
    FIELD(POR_ERRSTATUS_P1_D3_U_SMXP_3_1, V, 30, 1)
    FIELD(POR_ERRSTATUS_P1_D3_U_SMXP_3_1, UE, 29, 1)
    FIELD(POR_ERRSTATUS_P1_D3_U_SMXP_3_1, RESERVED_28, 28, 1)
    FIELD(POR_ERRSTATUS_P1_D3_U_SMXP_3_1, OF, 27, 1)
    FIELD(POR_ERRSTATUS_P1_D3_U_SMXP_3_1, RESERVED_24, 24, 3)
    FIELD(POR_ERRSTATUS_P1_D3_U_SMXP_3_1, DE, 23, 1)
    FIELD(POR_ERRSTATUS_P1_D3_U_SMXP_3_1, RESERVED_16, 16, 7)
    FIELD(POR_ERRSTATUS_P1_D3_U_SMXP_3_1, V_ERR_TYPE, 6, 10)
    FIELD(POR_ERRSTATUS_P1_D3_U_SMXP_3_1, RESERVED_0, 0, 6)
REG32(POR_FDC_AUX_CTL_P1_D3_U_SMXP_3_1, 0x192f218)
    FIELD(POR_FDC_AUX_CTL_P1_D3_U_SMXP_3_1, CLKGATE_OVERRIDE, 4, 1)
    FIELD(POR_FDC_AUX_CTL_P1_D3_U_SMXP_3_1, HANG_DET_CONFIG, 0, 4)
REG32(POR_ERRINJECT_U_SMXP_3_1, 0x192f300)
    FIELD(POR_ERRINJECT_U_SMXP_3_1, ERR_DEV, 4, 4)
    FIELD(POR_ERRINJECT_U_SMXP_3_1, ERR_TYPE, 0, 4)
REG32(POR_FDC_KEY_U_SMXP_3_1, 0x192f308)
    FIELD(POR_FDC_KEY_U_SMXP_3_1, KEY, 0, 8)
REG32(POR_MPU_NODE_INFO_U_SMXP_3_1, 0x193c000)
    FIELD(POR_MPU_NODE_INFO_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_NODE_INFO_U_SMXP_3_1, LOGICAL_ID, 32, 16)
    FIELD(POR_MPU_NODE_INFO_U_SMXP_3_1, NODE_ID, 16, 16)
    FIELD(POR_MPU_NODE_INFO_U_SMXP_3_1, NODE_TYPE, 0, 16)
REG32(POR_MPU_CHILD_INFO_U_SMXP_3_1, 0x193c080)
    FIELD(POR_MPU_CHILD_INFO_U_SMXP_3_1, RESERVED_32, 32, 32)
    FIELD(POR_MPU_CHILD_INFO_U_SMXP_3_1, CHILD_PTR_OFFSET, 16, 16)
    FIELD(POR_MPU_CHILD_INFO_U_SMXP_3_1, CHILD_COUNT, 0, 16)
REG32(POR_MPU_UNIT_INFO_U_SMXP_3_1, 0x193c900)
    FIELD(POR_MPU_UNIT_INFO_U_SMXP_3_1, RESERVED_16, 16, 48)
    FIELD(POR_MPU_UNIT_INFO_U_SMXP_3_1, MASTER_7_PRESENT, 15, 1)
    FIELD(POR_MPU_UNIT_INFO_U_SMXP_3_1, MASTER_6_PRESENT, 14, 1)
    FIELD(POR_MPU_UNIT_INFO_U_SMXP_3_1, MASTER_5_PRESENT, 13, 1)
    FIELD(POR_MPU_UNIT_INFO_U_SMXP_3_1, MASTER_4_PRESENT, 12, 1)
    FIELD(POR_MPU_UNIT_INFO_U_SMXP_3_1, MASTER_3_PRESENT, 11, 1)
    FIELD(POR_MPU_UNIT_INFO_U_SMXP_3_1, MASTER_2_PRESENT, 10, 1)
    FIELD(POR_MPU_UNIT_INFO_U_SMXP_3_1, MASTER_1_PRESENT, 9, 1)
    FIELD(POR_MPU_UNIT_INFO_U_SMXP_3_1, MASTER_0_PRESENT, 8, 1)
    FIELD(POR_MPU_UNIT_INFO_U_SMXP_3_1, NUM_PROG_REGION, 0, 8)
REG32(POR_MPU_M0_CTL_U_SMXP_3_1, 0x193d000)
    FIELD(POR_MPU_M0_CTL_U_SMXP_3_1, M0_EN, 2, 1)
    FIELD(POR_MPU_M0_CTL_U_SMXP_3_1, M0_ACTION, 0, 2)
REG32(POR_MPU_M0_PRBAR0_U_SMXP_3_1, 0x193d010)
    FIELD(POR_MPU_M0_PRBAR0_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR0_U_SMXP_3_1, REGION0_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR0_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR0_U_SMXP_3_1, REGION0_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR0_U_SMXP_3_1, REGION0_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR0_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR0_U_SMXP_3_1, 0x193d018)
    FIELD(POR_MPU_M0_PRLAR0_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR0_U_SMXP_3_1, REGION0_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR0_U_SMXP_3_1, REGION0_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR1_U_SMXP_3_1, 0x193d020)
    FIELD(POR_MPU_M0_PRBAR1_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR1_U_SMXP_3_1, REGION1_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR1_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR1_U_SMXP_3_1, REGION1_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR1_U_SMXP_3_1, REGION1_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR1_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR1_U_SMXP_3_1, 0x193d028)
    FIELD(POR_MPU_M0_PRLAR1_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR1_U_SMXP_3_1, REGION1_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR1_U_SMXP_3_1, REGION1_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR2_U_SMXP_3_1, 0x193d030)
    FIELD(POR_MPU_M0_PRBAR2_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR2_U_SMXP_3_1, REGION2_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR2_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR2_U_SMXP_3_1, REGION2_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR2_U_SMXP_3_1, REGION2_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR2_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR2_U_SMXP_3_1, 0x193d038)
    FIELD(POR_MPU_M0_PRLAR2_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR2_U_SMXP_3_1, REGION2_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR2_U_SMXP_3_1, REGION2_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR3_U_SMXP_3_1, 0x193d040)
    FIELD(POR_MPU_M0_PRBAR3_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR3_U_SMXP_3_1, REGION3_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR3_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR3_U_SMXP_3_1, REGION3_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR3_U_SMXP_3_1, REGION3_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR3_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR3_U_SMXP_3_1, 0x193d048)
    FIELD(POR_MPU_M0_PRLAR3_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR3_U_SMXP_3_1, REGION3_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR3_U_SMXP_3_1, REGION3_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR4_U_SMXP_3_1, 0x193d050)
    FIELD(POR_MPU_M0_PRBAR4_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR4_U_SMXP_3_1, REGION4_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR4_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR4_U_SMXP_3_1, REGION4_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR4_U_SMXP_3_1, REGION4_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR4_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR4_U_SMXP_3_1, 0x193d058)
    FIELD(POR_MPU_M0_PRLAR4_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR4_U_SMXP_3_1, REGION4_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR4_U_SMXP_3_1, REGION4_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR5_U_SMXP_3_1, 0x193d060)
    FIELD(POR_MPU_M0_PRBAR5_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR5_U_SMXP_3_1, REGION5_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR5_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR5_U_SMXP_3_1, REGION5_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR5_U_SMXP_3_1, REGION5_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR5_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR5_U_SMXP_3_1, 0x193d068)
    FIELD(POR_MPU_M0_PRLAR5_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR5_U_SMXP_3_1, REGION5_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR5_U_SMXP_3_1, REGION5_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR6_U_SMXP_3_1, 0x193d070)
    FIELD(POR_MPU_M0_PRBAR6_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR6_U_SMXP_3_1, REGION6_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR6_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR6_U_SMXP_3_1, REGION6_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR6_U_SMXP_3_1, REGION6_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR6_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR6_U_SMXP_3_1, 0x193d078)
    FIELD(POR_MPU_M0_PRLAR6_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR6_U_SMXP_3_1, REGION6_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR6_U_SMXP_3_1, REGION6_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR7_U_SMXP_3_1, 0x193d080)
    FIELD(POR_MPU_M0_PRBAR7_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR7_U_SMXP_3_1, REGION7_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR7_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR7_U_SMXP_3_1, REGION7_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR7_U_SMXP_3_1, REGION7_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR7_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR7_U_SMXP_3_1, 0x193d088)
    FIELD(POR_MPU_M0_PRLAR7_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR7_U_SMXP_3_1, REGION7_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR7_U_SMXP_3_1, REGION7_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR8_U_SMXP_3_1, 0x193d090)
    FIELD(POR_MPU_M0_PRBAR8_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR8_U_SMXP_3_1, REGION8_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR8_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR8_U_SMXP_3_1, REGION8_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR8_U_SMXP_3_1, REGION8_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR8_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR8_U_SMXP_3_1, 0x193d098)
    FIELD(POR_MPU_M0_PRLAR8_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR8_U_SMXP_3_1, REGION8_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR8_U_SMXP_3_1, REGION8_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR9_U_SMXP_3_1, 0x193d0a0)
    FIELD(POR_MPU_M0_PRBAR9_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR9_U_SMXP_3_1, REGION9_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR9_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR9_U_SMXP_3_1, REGION9_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR9_U_SMXP_3_1, REGION9_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR9_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR9_U_SMXP_3_1, 0x193d0a8)
    FIELD(POR_MPU_M0_PRLAR9_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR9_U_SMXP_3_1, REGION9_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR9_U_SMXP_3_1, REGION9_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR10_U_SMXP_3_1, 0x193d0b0)
    FIELD(POR_MPU_M0_PRBAR10_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR10_U_SMXP_3_1, REGION10_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR10_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR10_U_SMXP_3_1, REGION10_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR10_U_SMXP_3_1, REGION10_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR10_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR10_U_SMXP_3_1, 0x193d0b8)
    FIELD(POR_MPU_M0_PRLAR10_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR10_U_SMXP_3_1, REGION10_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR10_U_SMXP_3_1, REGION10_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR11_U_SMXP_3_1, 0x193d0c0)
    FIELD(POR_MPU_M0_PRBAR11_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR11_U_SMXP_3_1, REGION11_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR11_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR11_U_SMXP_3_1, REGION11_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR11_U_SMXP_3_1, REGION11_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR11_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR11_U_SMXP_3_1, 0x193d0c8)
    FIELD(POR_MPU_M0_PRLAR11_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR11_U_SMXP_3_1, REGION11_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR11_U_SMXP_3_1, REGION11_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR12_U_SMXP_3_1, 0x193d0d0)
    FIELD(POR_MPU_M0_PRBAR12_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR12_U_SMXP_3_1, REGION12_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR12_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR12_U_SMXP_3_1, REGION12_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR12_U_SMXP_3_1, REGION12_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR12_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR12_U_SMXP_3_1, 0x193d0d8)
    FIELD(POR_MPU_M0_PRLAR12_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR12_U_SMXP_3_1, REGION12_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR12_U_SMXP_3_1, REGION12_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR13_U_SMXP_3_1, 0x193d0e0)
    FIELD(POR_MPU_M0_PRBAR13_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR13_U_SMXP_3_1, REGION13_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR13_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR13_U_SMXP_3_1, REGION13_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR13_U_SMXP_3_1, REGION13_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR13_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR13_U_SMXP_3_1, 0x193d0e8)
    FIELD(POR_MPU_M0_PRLAR13_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR13_U_SMXP_3_1, REGION13_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR13_U_SMXP_3_1, REGION13_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR14_U_SMXP_3_1, 0x193d0f0)
    FIELD(POR_MPU_M0_PRBAR14_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR14_U_SMXP_3_1, REGION14_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR14_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR14_U_SMXP_3_1, REGION14_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR14_U_SMXP_3_1, REGION14_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR14_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR14_U_SMXP_3_1, 0x193d0f8)
    FIELD(POR_MPU_M0_PRLAR14_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR14_U_SMXP_3_1, REGION14_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR14_U_SMXP_3_1, REGION14_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR15_U_SMXP_3_1, 0x193d100)
    FIELD(POR_MPU_M0_PRBAR15_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR15_U_SMXP_3_1, REGION15_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR15_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR15_U_SMXP_3_1, REGION15_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR15_U_SMXP_3_1, REGION15_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR15_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR15_U_SMXP_3_1, 0x193d108)
    FIELD(POR_MPU_M0_PRLAR15_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR15_U_SMXP_3_1, REGION15_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR15_U_SMXP_3_1, REGION15_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR16_U_SMXP_3_1, 0x193d110)
    FIELD(POR_MPU_M0_PRBAR16_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR16_U_SMXP_3_1, REGION16_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR16_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR16_U_SMXP_3_1, REGION16_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR16_U_SMXP_3_1, REGION16_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR16_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR16_U_SMXP_3_1, 0x193d118)
    FIELD(POR_MPU_M0_PRLAR16_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR16_U_SMXP_3_1, REGION16_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR16_U_SMXP_3_1, REGION16_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR17_U_SMXP_3_1, 0x193d120)
    FIELD(POR_MPU_M0_PRBAR17_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR17_U_SMXP_3_1, REGION17_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR17_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR17_U_SMXP_3_1, REGION17_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR17_U_SMXP_3_1, REGION17_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR17_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR17_U_SMXP_3_1, 0x193d128)
    FIELD(POR_MPU_M0_PRLAR17_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR17_U_SMXP_3_1, REGION17_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR17_U_SMXP_3_1, REGION17_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR18_U_SMXP_3_1, 0x193d130)
    FIELD(POR_MPU_M0_PRBAR18_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR18_U_SMXP_3_1, REGION18_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR18_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR18_U_SMXP_3_1, REGION18_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR18_U_SMXP_3_1, REGION18_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR18_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR18_U_SMXP_3_1, 0x193d138)
    FIELD(POR_MPU_M0_PRLAR18_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR18_U_SMXP_3_1, REGION18_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR18_U_SMXP_3_1, REGION18_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR19_U_SMXP_3_1, 0x193d140)
    FIELD(POR_MPU_M0_PRBAR19_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR19_U_SMXP_3_1, REGION19_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR19_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR19_U_SMXP_3_1, REGION19_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR19_U_SMXP_3_1, REGION19_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR19_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR19_U_SMXP_3_1, 0x193d148)
    FIELD(POR_MPU_M0_PRLAR19_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR19_U_SMXP_3_1, REGION19_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR19_U_SMXP_3_1, REGION19_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR20_U_SMXP_3_1, 0x193d150)
    FIELD(POR_MPU_M0_PRBAR20_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR20_U_SMXP_3_1, REGION20_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR20_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR20_U_SMXP_3_1, REGION20_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR20_U_SMXP_3_1, REGION20_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR20_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR20_U_SMXP_3_1, 0x193d158)
    FIELD(POR_MPU_M0_PRLAR20_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR20_U_SMXP_3_1, REGION20_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR20_U_SMXP_3_1, REGION20_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR21_U_SMXP_3_1, 0x193d160)
    FIELD(POR_MPU_M0_PRBAR21_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR21_U_SMXP_3_1, REGION21_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR21_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR21_U_SMXP_3_1, REGION21_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR21_U_SMXP_3_1, REGION21_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR21_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR21_U_SMXP_3_1, 0x193d168)
    FIELD(POR_MPU_M0_PRLAR21_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR21_U_SMXP_3_1, REGION21_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR21_U_SMXP_3_1, REGION21_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR22_U_SMXP_3_1, 0x193d170)
    FIELD(POR_MPU_M0_PRBAR22_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR22_U_SMXP_3_1, REGION22_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR22_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR22_U_SMXP_3_1, REGION22_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR22_U_SMXP_3_1, REGION22_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR22_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR22_U_SMXP_3_1, 0x193d178)
    FIELD(POR_MPU_M0_PRLAR22_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR22_U_SMXP_3_1, REGION22_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR22_U_SMXP_3_1, REGION22_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR23_U_SMXP_3_1, 0x193d180)
    FIELD(POR_MPU_M0_PRBAR23_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR23_U_SMXP_3_1, REGION23_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR23_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR23_U_SMXP_3_1, REGION23_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR23_U_SMXP_3_1, REGION23_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR23_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR23_U_SMXP_3_1, 0x193d188)
    FIELD(POR_MPU_M0_PRLAR23_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR23_U_SMXP_3_1, REGION23_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR23_U_SMXP_3_1, REGION23_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR24_U_SMXP_3_1, 0x193d190)
    FIELD(POR_MPU_M0_PRBAR24_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR24_U_SMXP_3_1, REGION24_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR24_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR24_U_SMXP_3_1, REGION24_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR24_U_SMXP_3_1, REGION24_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR24_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR24_U_SMXP_3_1, 0x193d198)
    FIELD(POR_MPU_M0_PRLAR24_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR24_U_SMXP_3_1, REGION24_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR24_U_SMXP_3_1, REGION24_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR25_U_SMXP_3_1, 0x193d1a0)
    FIELD(POR_MPU_M0_PRBAR25_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR25_U_SMXP_3_1, REGION25_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR25_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR25_U_SMXP_3_1, REGION25_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR25_U_SMXP_3_1, REGION25_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR25_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR25_U_SMXP_3_1, 0x193d1a8)
    FIELD(POR_MPU_M0_PRLAR25_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR25_U_SMXP_3_1, REGION25_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR25_U_SMXP_3_1, REGION25_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR26_U_SMXP_3_1, 0x193d1b0)
    FIELD(POR_MPU_M0_PRBAR26_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR26_U_SMXP_3_1, REGION26_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR26_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR26_U_SMXP_3_1, REGION26_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR26_U_SMXP_3_1, REGION26_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR26_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR26_U_SMXP_3_1, 0x193d1b8)
    FIELD(POR_MPU_M0_PRLAR26_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR26_U_SMXP_3_1, REGION26_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR26_U_SMXP_3_1, REGION26_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR27_U_SMXP_3_1, 0x193d1c0)
    FIELD(POR_MPU_M0_PRBAR27_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR27_U_SMXP_3_1, REGION27_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR27_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR27_U_SMXP_3_1, REGION27_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR27_U_SMXP_3_1, REGION27_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR27_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR27_U_SMXP_3_1, 0x193d1c8)
    FIELD(POR_MPU_M0_PRLAR27_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR27_U_SMXP_3_1, REGION27_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR27_U_SMXP_3_1, REGION27_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR28_U_SMXP_3_1, 0x193d1d0)
    FIELD(POR_MPU_M0_PRBAR28_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR28_U_SMXP_3_1, REGION28_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR28_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR28_U_SMXP_3_1, REGION28_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR28_U_SMXP_3_1, REGION28_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR28_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR28_U_SMXP_3_1, 0x193d1d8)
    FIELD(POR_MPU_M0_PRLAR28_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR28_U_SMXP_3_1, REGION28_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR28_U_SMXP_3_1, REGION28_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR29_U_SMXP_3_1, 0x193d1e0)
    FIELD(POR_MPU_M0_PRBAR29_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR29_U_SMXP_3_1, REGION29_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR29_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR29_U_SMXP_3_1, REGION29_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR29_U_SMXP_3_1, REGION29_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR29_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR29_U_SMXP_3_1, 0x193d1e8)
    FIELD(POR_MPU_M0_PRLAR29_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR29_U_SMXP_3_1, REGION29_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR29_U_SMXP_3_1, REGION29_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR30_U_SMXP_3_1, 0x193d1f0)
    FIELD(POR_MPU_M0_PRBAR30_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR30_U_SMXP_3_1, REGION30_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR30_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR30_U_SMXP_3_1, REGION30_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR30_U_SMXP_3_1, REGION30_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR30_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR30_U_SMXP_3_1, 0x193d1f8)
    FIELD(POR_MPU_M0_PRLAR30_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR30_U_SMXP_3_1, REGION30_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR30_U_SMXP_3_1, REGION30_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR31_U_SMXP_3_1, 0x193d200)
    FIELD(POR_MPU_M0_PRBAR31_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR31_U_SMXP_3_1, REGION31_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR31_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR31_U_SMXP_3_1, REGION31_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR31_U_SMXP_3_1, REGION31_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR31_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR31_U_SMXP_3_1, 0x193d208)
    FIELD(POR_MPU_M0_PRLAR31_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR31_U_SMXP_3_1, REGION31_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR31_U_SMXP_3_1, REGION31_EN, 0, 1)
REG32(POR_MPU_M1_CTL_U_SMXP_3_1, 0x193d400)
    FIELD(POR_MPU_M1_CTL_U_SMXP_3_1, M1_EN, 2, 1)
    FIELD(POR_MPU_M1_CTL_U_SMXP_3_1, M1_ACTION, 0, 2)
REG32(POR_MPU_M1_PRBAR0_U_SMXP_3_1, 0x193d410)
    FIELD(POR_MPU_M1_PRBAR0_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR0_U_SMXP_3_1, REGION0_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR0_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR0_U_SMXP_3_1, REGION0_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR0_U_SMXP_3_1, REGION0_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR0_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR0_U_SMXP_3_1, 0x193d418)
    FIELD(POR_MPU_M1_PRLAR0_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR0_U_SMXP_3_1, REGION0_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR0_U_SMXP_3_1, REGION0_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR1_U_SMXP_3_1, 0x193d420)
    FIELD(POR_MPU_M1_PRBAR1_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR1_U_SMXP_3_1, REGION1_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR1_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR1_U_SMXP_3_1, REGION1_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR1_U_SMXP_3_1, REGION1_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR1_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR1_U_SMXP_3_1, 0x193d428)
    FIELD(POR_MPU_M1_PRLAR1_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR1_U_SMXP_3_1, REGION1_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR1_U_SMXP_3_1, REGION1_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR2_U_SMXP_3_1, 0x193d430)
    FIELD(POR_MPU_M1_PRBAR2_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR2_U_SMXP_3_1, REGION2_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR2_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR2_U_SMXP_3_1, REGION2_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR2_U_SMXP_3_1, REGION2_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR2_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR2_U_SMXP_3_1, 0x193d438)
    FIELD(POR_MPU_M1_PRLAR2_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR2_U_SMXP_3_1, REGION2_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR2_U_SMXP_3_1, REGION2_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR3_U_SMXP_3_1, 0x193d440)
    FIELD(POR_MPU_M1_PRBAR3_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR3_U_SMXP_3_1, REGION3_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR3_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR3_U_SMXP_3_1, REGION3_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR3_U_SMXP_3_1, REGION3_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR3_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR3_U_SMXP_3_1, 0x193d448)
    FIELD(POR_MPU_M1_PRLAR3_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR3_U_SMXP_3_1, REGION3_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR3_U_SMXP_3_1, REGION3_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR4_U_SMXP_3_1, 0x193d450)
    FIELD(POR_MPU_M1_PRBAR4_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR4_U_SMXP_3_1, REGION4_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR4_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR4_U_SMXP_3_1, REGION4_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR4_U_SMXP_3_1, REGION4_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR4_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR4_U_SMXP_3_1, 0x193d458)
    FIELD(POR_MPU_M1_PRLAR4_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR4_U_SMXP_3_1, REGION4_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR4_U_SMXP_3_1, REGION4_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR5_U_SMXP_3_1, 0x193d460)
    FIELD(POR_MPU_M1_PRBAR5_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR5_U_SMXP_3_1, REGION5_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR5_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR5_U_SMXP_3_1, REGION5_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR5_U_SMXP_3_1, REGION5_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR5_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR5_U_SMXP_3_1, 0x193d468)
    FIELD(POR_MPU_M1_PRLAR5_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR5_U_SMXP_3_1, REGION5_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR5_U_SMXP_3_1, REGION5_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR6_U_SMXP_3_1, 0x193d470)
    FIELD(POR_MPU_M1_PRBAR6_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR6_U_SMXP_3_1, REGION6_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR6_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR6_U_SMXP_3_1, REGION6_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR6_U_SMXP_3_1, REGION6_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR6_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR6_U_SMXP_3_1, 0x193d478)
    FIELD(POR_MPU_M1_PRLAR6_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR6_U_SMXP_3_1, REGION6_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR6_U_SMXP_3_1, REGION6_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR7_U_SMXP_3_1, 0x193d480)
    FIELD(POR_MPU_M1_PRBAR7_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR7_U_SMXP_3_1, REGION7_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR7_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR7_U_SMXP_3_1, REGION7_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR7_U_SMXP_3_1, REGION7_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR7_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR7_U_SMXP_3_1, 0x193d488)
    FIELD(POR_MPU_M1_PRLAR7_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR7_U_SMXP_3_1, REGION7_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR7_U_SMXP_3_1, REGION7_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR8_U_SMXP_3_1, 0x193d490)
    FIELD(POR_MPU_M1_PRBAR8_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR8_U_SMXP_3_1, REGION8_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR8_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR8_U_SMXP_3_1, REGION8_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR8_U_SMXP_3_1, REGION8_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR8_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR8_U_SMXP_3_1, 0x193d498)
    FIELD(POR_MPU_M1_PRLAR8_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR8_U_SMXP_3_1, REGION8_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR8_U_SMXP_3_1, REGION8_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR9_U_SMXP_3_1, 0x193d4a0)
    FIELD(POR_MPU_M1_PRBAR9_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR9_U_SMXP_3_1, REGION9_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR9_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR9_U_SMXP_3_1, REGION9_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR9_U_SMXP_3_1, REGION9_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR9_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR9_U_SMXP_3_1, 0x193d4a8)
    FIELD(POR_MPU_M1_PRLAR9_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR9_U_SMXP_3_1, REGION9_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR9_U_SMXP_3_1, REGION9_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR10_U_SMXP_3_1, 0x193d4b0)
    FIELD(POR_MPU_M1_PRBAR10_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR10_U_SMXP_3_1, REGION10_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR10_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR10_U_SMXP_3_1, REGION10_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR10_U_SMXP_3_1, REGION10_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR10_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR10_U_SMXP_3_1, 0x193d4b8)
    FIELD(POR_MPU_M1_PRLAR10_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR10_U_SMXP_3_1, REGION10_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR10_U_SMXP_3_1, REGION10_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR11_U_SMXP_3_1, 0x193d4c0)
    FIELD(POR_MPU_M1_PRBAR11_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR11_U_SMXP_3_1, REGION11_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR11_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR11_U_SMXP_3_1, REGION11_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR11_U_SMXP_3_1, REGION11_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR11_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR11_U_SMXP_3_1, 0x193d4c8)
    FIELD(POR_MPU_M1_PRLAR11_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR11_U_SMXP_3_1, REGION11_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR11_U_SMXP_3_1, REGION11_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR12_U_SMXP_3_1, 0x193d4d0)
    FIELD(POR_MPU_M1_PRBAR12_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR12_U_SMXP_3_1, REGION12_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR12_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR12_U_SMXP_3_1, REGION12_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR12_U_SMXP_3_1, REGION12_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR12_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR12_U_SMXP_3_1, 0x193d4d8)
    FIELD(POR_MPU_M1_PRLAR12_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR12_U_SMXP_3_1, REGION12_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR12_U_SMXP_3_1, REGION12_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR13_U_SMXP_3_1, 0x193d4e0)
    FIELD(POR_MPU_M1_PRBAR13_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR13_U_SMXP_3_1, REGION13_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR13_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR13_U_SMXP_3_1, REGION13_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR13_U_SMXP_3_1, REGION13_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR13_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR13_U_SMXP_3_1, 0x193d4e8)
    FIELD(POR_MPU_M1_PRLAR13_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR13_U_SMXP_3_1, REGION13_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR13_U_SMXP_3_1, REGION13_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR14_U_SMXP_3_1, 0x193d4f0)
    FIELD(POR_MPU_M1_PRBAR14_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR14_U_SMXP_3_1, REGION14_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR14_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR14_U_SMXP_3_1, REGION14_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR14_U_SMXP_3_1, REGION14_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR14_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR14_U_SMXP_3_1, 0x193d4f8)
    FIELD(POR_MPU_M1_PRLAR14_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR14_U_SMXP_3_1, REGION14_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR14_U_SMXP_3_1, REGION14_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR15_U_SMXP_3_1, 0x193d500)
    FIELD(POR_MPU_M1_PRBAR15_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR15_U_SMXP_3_1, REGION15_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR15_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR15_U_SMXP_3_1, REGION15_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR15_U_SMXP_3_1, REGION15_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR15_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR15_U_SMXP_3_1, 0x193d508)
    FIELD(POR_MPU_M1_PRLAR15_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR15_U_SMXP_3_1, REGION15_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR15_U_SMXP_3_1, REGION15_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR16_U_SMXP_3_1, 0x193d510)
    FIELD(POR_MPU_M1_PRBAR16_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR16_U_SMXP_3_1, REGION16_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR16_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR16_U_SMXP_3_1, REGION16_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR16_U_SMXP_3_1, REGION16_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR16_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR16_U_SMXP_3_1, 0x193d518)
    FIELD(POR_MPU_M1_PRLAR16_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR16_U_SMXP_3_1, REGION16_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR16_U_SMXP_3_1, REGION16_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR17_U_SMXP_3_1, 0x193d520)
    FIELD(POR_MPU_M1_PRBAR17_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR17_U_SMXP_3_1, REGION17_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR17_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR17_U_SMXP_3_1, REGION17_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR17_U_SMXP_3_1, REGION17_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR17_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR17_U_SMXP_3_1, 0x193d528)
    FIELD(POR_MPU_M1_PRLAR17_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR17_U_SMXP_3_1, REGION17_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR17_U_SMXP_3_1, REGION17_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR18_U_SMXP_3_1, 0x193d530)
    FIELD(POR_MPU_M1_PRBAR18_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR18_U_SMXP_3_1, REGION18_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR18_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR18_U_SMXP_3_1, REGION18_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR18_U_SMXP_3_1, REGION18_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR18_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR18_U_SMXP_3_1, 0x193d538)
    FIELD(POR_MPU_M1_PRLAR18_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR18_U_SMXP_3_1, REGION18_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR18_U_SMXP_3_1, REGION18_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR19_U_SMXP_3_1, 0x193d540)
    FIELD(POR_MPU_M1_PRBAR19_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR19_U_SMXP_3_1, REGION19_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR19_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR19_U_SMXP_3_1, REGION19_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR19_U_SMXP_3_1, REGION19_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR19_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR19_U_SMXP_3_1, 0x193d548)
    FIELD(POR_MPU_M1_PRLAR19_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR19_U_SMXP_3_1, REGION19_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR19_U_SMXP_3_1, REGION19_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR20_U_SMXP_3_1, 0x193d550)
    FIELD(POR_MPU_M1_PRBAR20_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR20_U_SMXP_3_1, REGION20_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR20_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR20_U_SMXP_3_1, REGION20_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR20_U_SMXP_3_1, REGION20_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR20_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR20_U_SMXP_3_1, 0x193d558)
    FIELD(POR_MPU_M1_PRLAR20_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR20_U_SMXP_3_1, REGION20_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR20_U_SMXP_3_1, REGION20_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR21_U_SMXP_3_1, 0x193d560)
    FIELD(POR_MPU_M1_PRBAR21_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR21_U_SMXP_3_1, REGION21_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR21_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR21_U_SMXP_3_1, REGION21_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR21_U_SMXP_3_1, REGION21_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR21_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR21_U_SMXP_3_1, 0x193d568)
    FIELD(POR_MPU_M1_PRLAR21_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR21_U_SMXP_3_1, REGION21_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR21_U_SMXP_3_1, REGION21_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR22_U_SMXP_3_1, 0x193d570)
    FIELD(POR_MPU_M1_PRBAR22_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR22_U_SMXP_3_1, REGION22_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR22_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR22_U_SMXP_3_1, REGION22_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR22_U_SMXP_3_1, REGION22_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR22_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR22_U_SMXP_3_1, 0x193d578)
    FIELD(POR_MPU_M1_PRLAR22_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR22_U_SMXP_3_1, REGION22_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR22_U_SMXP_3_1, REGION22_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR23_U_SMXP_3_1, 0x193d580)
    FIELD(POR_MPU_M1_PRBAR23_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR23_U_SMXP_3_1, REGION23_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR23_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR23_U_SMXP_3_1, REGION23_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR23_U_SMXP_3_1, REGION23_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR23_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR23_U_SMXP_3_1, 0x193d588)
    FIELD(POR_MPU_M1_PRLAR23_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR23_U_SMXP_3_1, REGION23_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR23_U_SMXP_3_1, REGION23_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR24_U_SMXP_3_1, 0x193d590)
    FIELD(POR_MPU_M1_PRBAR24_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR24_U_SMXP_3_1, REGION24_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR24_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR24_U_SMXP_3_1, REGION24_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR24_U_SMXP_3_1, REGION24_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR24_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR24_U_SMXP_3_1, 0x193d598)
    FIELD(POR_MPU_M1_PRLAR24_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR24_U_SMXP_3_1, REGION24_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR24_U_SMXP_3_1, REGION24_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR25_U_SMXP_3_1, 0x193d5a0)
    FIELD(POR_MPU_M1_PRBAR25_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR25_U_SMXP_3_1, REGION25_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR25_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR25_U_SMXP_3_1, REGION25_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR25_U_SMXP_3_1, REGION25_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR25_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR25_U_SMXP_3_1, 0x193d5a8)
    FIELD(POR_MPU_M1_PRLAR25_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR25_U_SMXP_3_1, REGION25_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR25_U_SMXP_3_1, REGION25_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR26_U_SMXP_3_1, 0x193d5b0)
    FIELD(POR_MPU_M1_PRBAR26_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR26_U_SMXP_3_1, REGION26_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR26_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR26_U_SMXP_3_1, REGION26_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR26_U_SMXP_3_1, REGION26_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR26_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR26_U_SMXP_3_1, 0x193d5b8)
    FIELD(POR_MPU_M1_PRLAR26_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR26_U_SMXP_3_1, REGION26_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR26_U_SMXP_3_1, REGION26_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR27_U_SMXP_3_1, 0x193d5c0)
    FIELD(POR_MPU_M1_PRBAR27_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR27_U_SMXP_3_1, REGION27_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR27_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR27_U_SMXP_3_1, REGION27_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR27_U_SMXP_3_1, REGION27_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR27_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR27_U_SMXP_3_1, 0x193d5c8)
    FIELD(POR_MPU_M1_PRLAR27_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR27_U_SMXP_3_1, REGION27_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR27_U_SMXP_3_1, REGION27_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR28_U_SMXP_3_1, 0x193d5d0)
    FIELD(POR_MPU_M1_PRBAR28_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR28_U_SMXP_3_1, REGION28_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR28_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR28_U_SMXP_3_1, REGION28_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR28_U_SMXP_3_1, REGION28_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR28_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR28_U_SMXP_3_1, 0x193d5d8)
    FIELD(POR_MPU_M1_PRLAR28_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR28_U_SMXP_3_1, REGION28_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR28_U_SMXP_3_1, REGION28_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR29_U_SMXP_3_1, 0x193d5e0)
    FIELD(POR_MPU_M1_PRBAR29_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR29_U_SMXP_3_1, REGION29_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR29_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR29_U_SMXP_3_1, REGION29_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR29_U_SMXP_3_1, REGION29_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR29_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR29_U_SMXP_3_1, 0x193d5e8)
    FIELD(POR_MPU_M1_PRLAR29_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR29_U_SMXP_3_1, REGION29_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR29_U_SMXP_3_1, REGION29_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR30_U_SMXP_3_1, 0x193d5f0)
    FIELD(POR_MPU_M1_PRBAR30_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR30_U_SMXP_3_1, REGION30_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR30_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR30_U_SMXP_3_1, REGION30_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR30_U_SMXP_3_1, REGION30_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR30_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR30_U_SMXP_3_1, 0x193d5f8)
    FIELD(POR_MPU_M1_PRLAR30_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR30_U_SMXP_3_1, REGION30_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR30_U_SMXP_3_1, REGION30_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR31_U_SMXP_3_1, 0x193d600)
    FIELD(POR_MPU_M1_PRBAR31_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR31_U_SMXP_3_1, REGION31_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR31_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR31_U_SMXP_3_1, REGION31_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR31_U_SMXP_3_1, REGION31_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR31_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR31_U_SMXP_3_1, 0x193d608)
    FIELD(POR_MPU_M1_PRLAR31_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR31_U_SMXP_3_1, REGION31_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR31_U_SMXP_3_1, REGION31_EN, 0, 1)
REG32(POR_MPU_M2_CTL_U_SMXP_3_1, 0x193d800)
    FIELD(POR_MPU_M2_CTL_U_SMXP_3_1, M2_EN, 2, 1)
    FIELD(POR_MPU_M2_CTL_U_SMXP_3_1, M2_ACTION, 0, 2)
REG32(POR_MPU_M2_PRBAR0_U_SMXP_3_1, 0x193d810)
    FIELD(POR_MPU_M2_PRBAR0_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR0_U_SMXP_3_1, REGION0_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR0_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR0_U_SMXP_3_1, REGION0_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR0_U_SMXP_3_1, REGION0_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR0_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR0_U_SMXP_3_1, 0x193d818)
    FIELD(POR_MPU_M2_PRLAR0_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR0_U_SMXP_3_1, REGION0_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR0_U_SMXP_3_1, REGION0_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR1_U_SMXP_3_1, 0x193d820)
    FIELD(POR_MPU_M2_PRBAR1_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR1_U_SMXP_3_1, REGION1_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR1_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR1_U_SMXP_3_1, REGION1_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR1_U_SMXP_3_1, REGION1_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR1_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR1_U_SMXP_3_1, 0x193d828)
    FIELD(POR_MPU_M2_PRLAR1_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR1_U_SMXP_3_1, REGION1_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR1_U_SMXP_3_1, REGION1_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR2_U_SMXP_3_1, 0x193d830)
    FIELD(POR_MPU_M2_PRBAR2_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR2_U_SMXP_3_1, REGION2_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR2_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR2_U_SMXP_3_1, REGION2_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR2_U_SMXP_3_1, REGION2_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR2_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR2_U_SMXP_3_1, 0x193d838)
    FIELD(POR_MPU_M2_PRLAR2_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR2_U_SMXP_3_1, REGION2_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR2_U_SMXP_3_1, REGION2_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR3_U_SMXP_3_1, 0x193d840)
    FIELD(POR_MPU_M2_PRBAR3_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR3_U_SMXP_3_1, REGION3_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR3_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR3_U_SMXP_3_1, REGION3_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR3_U_SMXP_3_1, REGION3_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR3_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR3_U_SMXP_3_1, 0x193d848)
    FIELD(POR_MPU_M2_PRLAR3_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR3_U_SMXP_3_1, REGION3_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR3_U_SMXP_3_1, REGION3_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR4_U_SMXP_3_1, 0x193d850)
    FIELD(POR_MPU_M2_PRBAR4_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR4_U_SMXP_3_1, REGION4_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR4_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR4_U_SMXP_3_1, REGION4_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR4_U_SMXP_3_1, REGION4_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR4_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR4_U_SMXP_3_1, 0x193d858)
    FIELD(POR_MPU_M2_PRLAR4_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR4_U_SMXP_3_1, REGION4_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR4_U_SMXP_3_1, REGION4_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR5_U_SMXP_3_1, 0x193d860)
    FIELD(POR_MPU_M2_PRBAR5_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR5_U_SMXP_3_1, REGION5_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR5_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR5_U_SMXP_3_1, REGION5_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR5_U_SMXP_3_1, REGION5_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR5_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR5_U_SMXP_3_1, 0x193d868)
    FIELD(POR_MPU_M2_PRLAR5_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR5_U_SMXP_3_1, REGION5_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR5_U_SMXP_3_1, REGION5_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR6_U_SMXP_3_1, 0x193d870)
    FIELD(POR_MPU_M2_PRBAR6_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR6_U_SMXP_3_1, REGION6_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR6_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR6_U_SMXP_3_1, REGION6_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR6_U_SMXP_3_1, REGION6_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR6_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR6_U_SMXP_3_1, 0x193d878)
    FIELD(POR_MPU_M2_PRLAR6_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR6_U_SMXP_3_1, REGION6_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR6_U_SMXP_3_1, REGION6_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR7_U_SMXP_3_1, 0x193d880)
    FIELD(POR_MPU_M2_PRBAR7_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR7_U_SMXP_3_1, REGION7_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR7_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR7_U_SMXP_3_1, REGION7_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR7_U_SMXP_3_1, REGION7_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR7_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR7_U_SMXP_3_1, 0x193d888)
    FIELD(POR_MPU_M2_PRLAR7_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR7_U_SMXP_3_1, REGION7_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR7_U_SMXP_3_1, REGION7_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR8_U_SMXP_3_1, 0x193d890)
    FIELD(POR_MPU_M2_PRBAR8_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR8_U_SMXP_3_1, REGION8_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR8_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR8_U_SMXP_3_1, REGION8_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR8_U_SMXP_3_1, REGION8_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR8_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR8_U_SMXP_3_1, 0x193d898)
    FIELD(POR_MPU_M2_PRLAR8_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR8_U_SMXP_3_1, REGION8_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR8_U_SMXP_3_1, REGION8_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR9_U_SMXP_3_1, 0x193d8a0)
    FIELD(POR_MPU_M2_PRBAR9_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR9_U_SMXP_3_1, REGION9_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR9_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR9_U_SMXP_3_1, REGION9_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR9_U_SMXP_3_1, REGION9_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR9_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR9_U_SMXP_3_1, 0x193d8a8)
    FIELD(POR_MPU_M2_PRLAR9_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR9_U_SMXP_3_1, REGION9_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR9_U_SMXP_3_1, REGION9_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR10_U_SMXP_3_1, 0x193d8b0)
    FIELD(POR_MPU_M2_PRBAR10_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR10_U_SMXP_3_1, REGION10_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR10_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR10_U_SMXP_3_1, REGION10_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR10_U_SMXP_3_1, REGION10_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR10_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR10_U_SMXP_3_1, 0x193d8b8)
    FIELD(POR_MPU_M2_PRLAR10_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR10_U_SMXP_3_1, REGION10_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR10_U_SMXP_3_1, REGION10_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR11_U_SMXP_3_1, 0x193d8c0)
    FIELD(POR_MPU_M2_PRBAR11_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR11_U_SMXP_3_1, REGION11_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR11_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR11_U_SMXP_3_1, REGION11_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR11_U_SMXP_3_1, REGION11_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR11_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR11_U_SMXP_3_1, 0x193d8c8)
    FIELD(POR_MPU_M2_PRLAR11_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR11_U_SMXP_3_1, REGION11_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR11_U_SMXP_3_1, REGION11_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR12_U_SMXP_3_1, 0x193d8d0)
    FIELD(POR_MPU_M2_PRBAR12_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR12_U_SMXP_3_1, REGION12_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR12_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR12_U_SMXP_3_1, REGION12_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR12_U_SMXP_3_1, REGION12_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR12_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR12_U_SMXP_3_1, 0x193d8d8)
    FIELD(POR_MPU_M2_PRLAR12_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR12_U_SMXP_3_1, REGION12_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR12_U_SMXP_3_1, REGION12_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR13_U_SMXP_3_1, 0x193d8e0)
    FIELD(POR_MPU_M2_PRBAR13_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR13_U_SMXP_3_1, REGION13_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR13_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR13_U_SMXP_3_1, REGION13_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR13_U_SMXP_3_1, REGION13_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR13_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR13_U_SMXP_3_1, 0x193d8e8)
    FIELD(POR_MPU_M2_PRLAR13_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR13_U_SMXP_3_1, REGION13_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR13_U_SMXP_3_1, REGION13_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR14_U_SMXP_3_1, 0x193d8f0)
    FIELD(POR_MPU_M2_PRBAR14_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR14_U_SMXP_3_1, REGION14_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR14_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR14_U_SMXP_3_1, REGION14_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR14_U_SMXP_3_1, REGION14_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR14_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR14_U_SMXP_3_1, 0x193d8f8)
    FIELD(POR_MPU_M2_PRLAR14_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR14_U_SMXP_3_1, REGION14_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR14_U_SMXP_3_1, REGION14_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR15_U_SMXP_3_1, 0x193d900)
    FIELD(POR_MPU_M2_PRBAR15_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR15_U_SMXP_3_1, REGION15_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR15_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR15_U_SMXP_3_1, REGION15_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR15_U_SMXP_3_1, REGION15_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR15_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR15_U_SMXP_3_1, 0x193d908)
    FIELD(POR_MPU_M2_PRLAR15_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR15_U_SMXP_3_1, REGION15_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR15_U_SMXP_3_1, REGION15_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR16_U_SMXP_3_1, 0x193d910)
    FIELD(POR_MPU_M2_PRBAR16_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR16_U_SMXP_3_1, REGION16_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR16_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR16_U_SMXP_3_1, REGION16_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR16_U_SMXP_3_1, REGION16_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR16_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR16_U_SMXP_3_1, 0x193d918)
    FIELD(POR_MPU_M2_PRLAR16_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR16_U_SMXP_3_1, REGION16_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR16_U_SMXP_3_1, REGION16_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR17_U_SMXP_3_1, 0x193d920)
    FIELD(POR_MPU_M2_PRBAR17_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR17_U_SMXP_3_1, REGION17_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR17_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR17_U_SMXP_3_1, REGION17_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR17_U_SMXP_3_1, REGION17_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR17_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR17_U_SMXP_3_1, 0x193d928)
    FIELD(POR_MPU_M2_PRLAR17_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR17_U_SMXP_3_1, REGION17_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR17_U_SMXP_3_1, REGION17_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR18_U_SMXP_3_1, 0x193d930)
    FIELD(POR_MPU_M2_PRBAR18_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR18_U_SMXP_3_1, REGION18_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR18_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR18_U_SMXP_3_1, REGION18_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR18_U_SMXP_3_1, REGION18_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR18_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR18_U_SMXP_3_1, 0x193d938)
    FIELD(POR_MPU_M2_PRLAR18_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR18_U_SMXP_3_1, REGION18_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR18_U_SMXP_3_1, REGION18_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR19_U_SMXP_3_1, 0x193d940)
    FIELD(POR_MPU_M2_PRBAR19_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR19_U_SMXP_3_1, REGION19_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR19_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR19_U_SMXP_3_1, REGION19_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR19_U_SMXP_3_1, REGION19_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR19_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR19_U_SMXP_3_1, 0x193d948)
    FIELD(POR_MPU_M2_PRLAR19_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR19_U_SMXP_3_1, REGION19_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR19_U_SMXP_3_1, REGION19_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR20_U_SMXP_3_1, 0x193d950)
    FIELD(POR_MPU_M2_PRBAR20_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR20_U_SMXP_3_1, REGION20_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR20_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR20_U_SMXP_3_1, REGION20_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR20_U_SMXP_3_1, REGION20_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR20_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR20_U_SMXP_3_1, 0x193d958)
    FIELD(POR_MPU_M2_PRLAR20_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR20_U_SMXP_3_1, REGION20_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR20_U_SMXP_3_1, REGION20_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR21_U_SMXP_3_1, 0x193d960)
    FIELD(POR_MPU_M2_PRBAR21_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR21_U_SMXP_3_1, REGION21_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR21_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR21_U_SMXP_3_1, REGION21_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR21_U_SMXP_3_1, REGION21_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR21_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR21_U_SMXP_3_1, 0x193d968)
    FIELD(POR_MPU_M2_PRLAR21_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR21_U_SMXP_3_1, REGION21_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR21_U_SMXP_3_1, REGION21_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR22_U_SMXP_3_1, 0x193d970)
    FIELD(POR_MPU_M2_PRBAR22_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR22_U_SMXP_3_1, REGION22_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR22_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR22_U_SMXP_3_1, REGION22_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR22_U_SMXP_3_1, REGION22_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR22_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR22_U_SMXP_3_1, 0x193d978)
    FIELD(POR_MPU_M2_PRLAR22_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR22_U_SMXP_3_1, REGION22_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR22_U_SMXP_3_1, REGION22_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR23_U_SMXP_3_1, 0x193d980)
    FIELD(POR_MPU_M2_PRBAR23_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR23_U_SMXP_3_1, REGION23_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR23_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR23_U_SMXP_3_1, REGION23_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR23_U_SMXP_3_1, REGION23_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR23_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR23_U_SMXP_3_1, 0x193d988)
    FIELD(POR_MPU_M2_PRLAR23_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR23_U_SMXP_3_1, REGION23_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR23_U_SMXP_3_1, REGION23_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR24_U_SMXP_3_1, 0x193d990)
    FIELD(POR_MPU_M2_PRBAR24_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR24_U_SMXP_3_1, REGION24_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR24_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR24_U_SMXP_3_1, REGION24_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR24_U_SMXP_3_1, REGION24_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR24_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR24_U_SMXP_3_1, 0x193d998)
    FIELD(POR_MPU_M2_PRLAR24_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR24_U_SMXP_3_1, REGION24_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR24_U_SMXP_3_1, REGION24_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR25_U_SMXP_3_1, 0x193d9a0)
    FIELD(POR_MPU_M2_PRBAR25_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR25_U_SMXP_3_1, REGION25_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR25_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR25_U_SMXP_3_1, REGION25_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR25_U_SMXP_3_1, REGION25_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR25_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR25_U_SMXP_3_1, 0x193d9a8)
    FIELD(POR_MPU_M2_PRLAR25_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR25_U_SMXP_3_1, REGION25_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR25_U_SMXP_3_1, REGION25_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR26_U_SMXP_3_1, 0x193d9b0)
    FIELD(POR_MPU_M2_PRBAR26_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR26_U_SMXP_3_1, REGION26_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR26_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR26_U_SMXP_3_1, REGION26_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR26_U_SMXP_3_1, REGION26_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR26_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR26_U_SMXP_3_1, 0x193d9b8)
    FIELD(POR_MPU_M2_PRLAR26_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR26_U_SMXP_3_1, REGION26_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR26_U_SMXP_3_1, REGION26_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR27_U_SMXP_3_1, 0x193d9c0)
    FIELD(POR_MPU_M2_PRBAR27_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR27_U_SMXP_3_1, REGION27_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR27_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR27_U_SMXP_3_1, REGION27_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR27_U_SMXP_3_1, REGION27_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR27_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR27_U_SMXP_3_1, 0x193d9c8)
    FIELD(POR_MPU_M2_PRLAR27_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR27_U_SMXP_3_1, REGION27_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR27_U_SMXP_3_1, REGION27_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR28_U_SMXP_3_1, 0x193d9d0)
    FIELD(POR_MPU_M2_PRBAR28_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR28_U_SMXP_3_1, REGION28_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR28_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR28_U_SMXP_3_1, REGION28_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR28_U_SMXP_3_1, REGION28_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR28_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR28_U_SMXP_3_1, 0x193d9d8)
    FIELD(POR_MPU_M2_PRLAR28_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR28_U_SMXP_3_1, REGION28_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR28_U_SMXP_3_1, REGION28_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR29_U_SMXP_3_1, 0x193d9e0)
    FIELD(POR_MPU_M2_PRBAR29_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR29_U_SMXP_3_1, REGION29_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR29_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR29_U_SMXP_3_1, REGION29_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR29_U_SMXP_3_1, REGION29_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR29_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR29_U_SMXP_3_1, 0x193d9e8)
    FIELD(POR_MPU_M2_PRLAR29_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR29_U_SMXP_3_1, REGION29_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR29_U_SMXP_3_1, REGION29_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR30_U_SMXP_3_1, 0x193d9f0)
    FIELD(POR_MPU_M2_PRBAR30_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR30_U_SMXP_3_1, REGION30_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR30_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR30_U_SMXP_3_1, REGION30_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR30_U_SMXP_3_1, REGION30_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR30_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR30_U_SMXP_3_1, 0x193d9f8)
    FIELD(POR_MPU_M2_PRLAR30_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR30_U_SMXP_3_1, REGION30_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR30_U_SMXP_3_1, REGION30_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR31_U_SMXP_3_1, 0x193da00)
    FIELD(POR_MPU_M2_PRBAR31_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR31_U_SMXP_3_1, REGION31_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR31_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR31_U_SMXP_3_1, REGION31_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR31_U_SMXP_3_1, REGION31_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR31_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR31_U_SMXP_3_1, 0x193da08)
    FIELD(POR_MPU_M2_PRLAR31_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR31_U_SMXP_3_1, REGION31_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR31_U_SMXP_3_1, REGION31_EN, 0, 1)
REG32(POR_MPU_M3_CTL_U_SMXP_3_1, 0x193dc00)
    FIELD(POR_MPU_M3_CTL_U_SMXP_3_1, M3_EN, 2, 1)
    FIELD(POR_MPU_M3_CTL_U_SMXP_3_1, M3_ACTION, 0, 2)
REG32(POR_MPU_M3_PRBAR0_U_SMXP_3_1, 0x193dc10)
    FIELD(POR_MPU_M3_PRBAR0_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR0_U_SMXP_3_1, REGION0_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR0_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR0_U_SMXP_3_1, REGION0_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR0_U_SMXP_3_1, REGION0_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR0_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR0_U_SMXP_3_1, 0x193dc18)
    FIELD(POR_MPU_M3_PRLAR0_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR0_U_SMXP_3_1, REGION0_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR0_U_SMXP_3_1, REGION0_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR1_U_SMXP_3_1, 0x193dc20)
    FIELD(POR_MPU_M3_PRBAR1_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR1_U_SMXP_3_1, REGION1_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR1_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR1_U_SMXP_3_1, REGION1_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR1_U_SMXP_3_1, REGION1_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR1_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR1_U_SMXP_3_1, 0x193dc28)
    FIELD(POR_MPU_M3_PRLAR1_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR1_U_SMXP_3_1, REGION1_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR1_U_SMXP_3_1, REGION1_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR2_U_SMXP_3_1, 0x193dc30)
    FIELD(POR_MPU_M3_PRBAR2_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR2_U_SMXP_3_1, REGION2_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR2_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR2_U_SMXP_3_1, REGION2_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR2_U_SMXP_3_1, REGION2_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR2_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR2_U_SMXP_3_1, 0x193dc38)
    FIELD(POR_MPU_M3_PRLAR2_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR2_U_SMXP_3_1, REGION2_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR2_U_SMXP_3_1, REGION2_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR3_U_SMXP_3_1, 0x193dc40)
    FIELD(POR_MPU_M3_PRBAR3_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR3_U_SMXP_3_1, REGION3_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR3_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR3_U_SMXP_3_1, REGION3_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR3_U_SMXP_3_1, REGION3_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR3_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR3_U_SMXP_3_1, 0x193dc48)
    FIELD(POR_MPU_M3_PRLAR3_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR3_U_SMXP_3_1, REGION3_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR3_U_SMXP_3_1, REGION3_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR4_U_SMXP_3_1, 0x193dc50)
    FIELD(POR_MPU_M3_PRBAR4_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR4_U_SMXP_3_1, REGION4_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR4_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR4_U_SMXP_3_1, REGION4_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR4_U_SMXP_3_1, REGION4_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR4_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR4_U_SMXP_3_1, 0x193dc58)
    FIELD(POR_MPU_M3_PRLAR4_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR4_U_SMXP_3_1, REGION4_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR4_U_SMXP_3_1, REGION4_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR5_U_SMXP_3_1, 0x193dc60)
    FIELD(POR_MPU_M3_PRBAR5_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR5_U_SMXP_3_1, REGION5_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR5_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR5_U_SMXP_3_1, REGION5_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR5_U_SMXP_3_1, REGION5_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR5_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR5_U_SMXP_3_1, 0x193dc68)
    FIELD(POR_MPU_M3_PRLAR5_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR5_U_SMXP_3_1, REGION5_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR5_U_SMXP_3_1, REGION5_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR6_U_SMXP_3_1, 0x193dc70)
    FIELD(POR_MPU_M3_PRBAR6_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR6_U_SMXP_3_1, REGION6_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR6_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR6_U_SMXP_3_1, REGION6_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR6_U_SMXP_3_1, REGION6_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR6_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR6_U_SMXP_3_1, 0x193dc78)
    FIELD(POR_MPU_M3_PRLAR6_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR6_U_SMXP_3_1, REGION6_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR6_U_SMXP_3_1, REGION6_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR7_U_SMXP_3_1, 0x193dc80)
    FIELD(POR_MPU_M3_PRBAR7_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR7_U_SMXP_3_1, REGION7_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR7_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR7_U_SMXP_3_1, REGION7_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR7_U_SMXP_3_1, REGION7_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR7_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR7_U_SMXP_3_1, 0x193dc88)
    FIELD(POR_MPU_M3_PRLAR7_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR7_U_SMXP_3_1, REGION7_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR7_U_SMXP_3_1, REGION7_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR8_U_SMXP_3_1, 0x193dc90)
    FIELD(POR_MPU_M3_PRBAR8_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR8_U_SMXP_3_1, REGION8_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR8_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR8_U_SMXP_3_1, REGION8_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR8_U_SMXP_3_1, REGION8_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR8_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR8_U_SMXP_3_1, 0x193dc98)
    FIELD(POR_MPU_M3_PRLAR8_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR8_U_SMXP_3_1, REGION8_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR8_U_SMXP_3_1, REGION8_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR9_U_SMXP_3_1, 0x193dca0)
    FIELD(POR_MPU_M3_PRBAR9_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR9_U_SMXP_3_1, REGION9_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR9_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR9_U_SMXP_3_1, REGION9_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR9_U_SMXP_3_1, REGION9_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR9_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR9_U_SMXP_3_1, 0x193dca8)
    FIELD(POR_MPU_M3_PRLAR9_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR9_U_SMXP_3_1, REGION9_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR9_U_SMXP_3_1, REGION9_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR10_U_SMXP_3_1, 0x193dcb0)
    FIELD(POR_MPU_M3_PRBAR10_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR10_U_SMXP_3_1, REGION10_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR10_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR10_U_SMXP_3_1, REGION10_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR10_U_SMXP_3_1, REGION10_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR10_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR10_U_SMXP_3_1, 0x193dcb8)
    FIELD(POR_MPU_M3_PRLAR10_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR10_U_SMXP_3_1, REGION10_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR10_U_SMXP_3_1, REGION10_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR11_U_SMXP_3_1, 0x193dcc0)
    FIELD(POR_MPU_M3_PRBAR11_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR11_U_SMXP_3_1, REGION11_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR11_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR11_U_SMXP_3_1, REGION11_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR11_U_SMXP_3_1, REGION11_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR11_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR11_U_SMXP_3_1, 0x193dcc8)
    FIELD(POR_MPU_M3_PRLAR11_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR11_U_SMXP_3_1, REGION11_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR11_U_SMXP_3_1, REGION11_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR12_U_SMXP_3_1, 0x193dcd0)
    FIELD(POR_MPU_M3_PRBAR12_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR12_U_SMXP_3_1, REGION12_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR12_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR12_U_SMXP_3_1, REGION12_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR12_U_SMXP_3_1, REGION12_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR12_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR12_U_SMXP_3_1, 0x193dcd8)
    FIELD(POR_MPU_M3_PRLAR12_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR12_U_SMXP_3_1, REGION12_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR12_U_SMXP_3_1, REGION12_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR13_U_SMXP_3_1, 0x193dce0)
    FIELD(POR_MPU_M3_PRBAR13_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR13_U_SMXP_3_1, REGION13_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR13_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR13_U_SMXP_3_1, REGION13_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR13_U_SMXP_3_1, REGION13_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR13_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR13_U_SMXP_3_1, 0x193dce8)
    FIELD(POR_MPU_M3_PRLAR13_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR13_U_SMXP_3_1, REGION13_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR13_U_SMXP_3_1, REGION13_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR14_U_SMXP_3_1, 0x193dcf0)
    FIELD(POR_MPU_M3_PRBAR14_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR14_U_SMXP_3_1, REGION14_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR14_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR14_U_SMXP_3_1, REGION14_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR14_U_SMXP_3_1, REGION14_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR14_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR14_U_SMXP_3_1, 0x193dcf8)
    FIELD(POR_MPU_M3_PRLAR14_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR14_U_SMXP_3_1, REGION14_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR14_U_SMXP_3_1, REGION14_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR15_U_SMXP_3_1, 0x193dd00)
    FIELD(POR_MPU_M3_PRBAR15_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR15_U_SMXP_3_1, REGION15_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR15_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR15_U_SMXP_3_1, REGION15_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR15_U_SMXP_3_1, REGION15_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR15_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR15_U_SMXP_3_1, 0x193dd08)
    FIELD(POR_MPU_M3_PRLAR15_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR15_U_SMXP_3_1, REGION15_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR15_U_SMXP_3_1, REGION15_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR16_U_SMXP_3_1, 0x193dd10)
    FIELD(POR_MPU_M3_PRBAR16_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR16_U_SMXP_3_1, REGION16_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR16_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR16_U_SMXP_3_1, REGION16_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR16_U_SMXP_3_1, REGION16_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR16_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR16_U_SMXP_3_1, 0x193dd18)
    FIELD(POR_MPU_M3_PRLAR16_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR16_U_SMXP_3_1, REGION16_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR16_U_SMXP_3_1, REGION16_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR17_U_SMXP_3_1, 0x193dd20)
    FIELD(POR_MPU_M3_PRBAR17_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR17_U_SMXP_3_1, REGION17_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR17_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR17_U_SMXP_3_1, REGION17_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR17_U_SMXP_3_1, REGION17_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR17_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR17_U_SMXP_3_1, 0x193dd28)
    FIELD(POR_MPU_M3_PRLAR17_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR17_U_SMXP_3_1, REGION17_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR17_U_SMXP_3_1, REGION17_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR18_U_SMXP_3_1, 0x193dd30)
    FIELD(POR_MPU_M3_PRBAR18_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR18_U_SMXP_3_1, REGION18_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR18_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR18_U_SMXP_3_1, REGION18_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR18_U_SMXP_3_1, REGION18_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR18_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR18_U_SMXP_3_1, 0x193dd38)
    FIELD(POR_MPU_M3_PRLAR18_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR18_U_SMXP_3_1, REGION18_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR18_U_SMXP_3_1, REGION18_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR19_U_SMXP_3_1, 0x193dd40)
    FIELD(POR_MPU_M3_PRBAR19_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR19_U_SMXP_3_1, REGION19_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR19_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR19_U_SMXP_3_1, REGION19_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR19_U_SMXP_3_1, REGION19_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR19_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR19_U_SMXP_3_1, 0x193dd48)
    FIELD(POR_MPU_M3_PRLAR19_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR19_U_SMXP_3_1, REGION19_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR19_U_SMXP_3_1, REGION19_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR20_U_SMXP_3_1, 0x193dd50)
    FIELD(POR_MPU_M3_PRBAR20_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR20_U_SMXP_3_1, REGION20_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR20_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR20_U_SMXP_3_1, REGION20_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR20_U_SMXP_3_1, REGION20_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR20_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR20_U_SMXP_3_1, 0x193dd58)
    FIELD(POR_MPU_M3_PRLAR20_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR20_U_SMXP_3_1, REGION20_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR20_U_SMXP_3_1, REGION20_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR21_U_SMXP_3_1, 0x193dd60)
    FIELD(POR_MPU_M3_PRBAR21_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR21_U_SMXP_3_1, REGION21_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR21_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR21_U_SMXP_3_1, REGION21_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR21_U_SMXP_3_1, REGION21_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR21_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR21_U_SMXP_3_1, 0x193dd68)
    FIELD(POR_MPU_M3_PRLAR21_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR21_U_SMXP_3_1, REGION21_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR21_U_SMXP_3_1, REGION21_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR22_U_SMXP_3_1, 0x193dd70)
    FIELD(POR_MPU_M3_PRBAR22_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR22_U_SMXP_3_1, REGION22_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR22_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR22_U_SMXP_3_1, REGION22_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR22_U_SMXP_3_1, REGION22_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR22_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR22_U_SMXP_3_1, 0x193dd78)
    FIELD(POR_MPU_M3_PRLAR22_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR22_U_SMXP_3_1, REGION22_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR22_U_SMXP_3_1, REGION22_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR23_U_SMXP_3_1, 0x193dd80)
    FIELD(POR_MPU_M3_PRBAR23_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR23_U_SMXP_3_1, REGION23_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR23_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR23_U_SMXP_3_1, REGION23_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR23_U_SMXP_3_1, REGION23_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR23_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR23_U_SMXP_3_1, 0x193dd88)
    FIELD(POR_MPU_M3_PRLAR23_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR23_U_SMXP_3_1, REGION23_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR23_U_SMXP_3_1, REGION23_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR24_U_SMXP_3_1, 0x193dd90)
    FIELD(POR_MPU_M3_PRBAR24_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR24_U_SMXP_3_1, REGION24_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR24_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR24_U_SMXP_3_1, REGION24_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR24_U_SMXP_3_1, REGION24_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR24_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR24_U_SMXP_3_1, 0x193dd98)
    FIELD(POR_MPU_M3_PRLAR24_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR24_U_SMXP_3_1, REGION24_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR24_U_SMXP_3_1, REGION24_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR25_U_SMXP_3_1, 0x193dda0)
    FIELD(POR_MPU_M3_PRBAR25_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR25_U_SMXP_3_1, REGION25_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR25_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR25_U_SMXP_3_1, REGION25_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR25_U_SMXP_3_1, REGION25_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR25_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR25_U_SMXP_3_1, 0x193dda8)
    FIELD(POR_MPU_M3_PRLAR25_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR25_U_SMXP_3_1, REGION25_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR25_U_SMXP_3_1, REGION25_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR26_U_SMXP_3_1, 0x193ddb0)
    FIELD(POR_MPU_M3_PRBAR26_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR26_U_SMXP_3_1, REGION26_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR26_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR26_U_SMXP_3_1, REGION26_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR26_U_SMXP_3_1, REGION26_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR26_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR26_U_SMXP_3_1, 0x193ddb8)
    FIELD(POR_MPU_M3_PRLAR26_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR26_U_SMXP_3_1, REGION26_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR26_U_SMXP_3_1, REGION26_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR27_U_SMXP_3_1, 0x193ddc0)
    FIELD(POR_MPU_M3_PRBAR27_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR27_U_SMXP_3_1, REGION27_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR27_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR27_U_SMXP_3_1, REGION27_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR27_U_SMXP_3_1, REGION27_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR27_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR27_U_SMXP_3_1, 0x193ddc8)
    FIELD(POR_MPU_M3_PRLAR27_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR27_U_SMXP_3_1, REGION27_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR27_U_SMXP_3_1, REGION27_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR28_U_SMXP_3_1, 0x193ddd0)
    FIELD(POR_MPU_M3_PRBAR28_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR28_U_SMXP_3_1, REGION28_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR28_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR28_U_SMXP_3_1, REGION28_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR28_U_SMXP_3_1, REGION28_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR28_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR28_U_SMXP_3_1, 0x193ddd8)
    FIELD(POR_MPU_M3_PRLAR28_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR28_U_SMXP_3_1, REGION28_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR28_U_SMXP_3_1, REGION28_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR29_U_SMXP_3_1, 0x193dde0)
    FIELD(POR_MPU_M3_PRBAR29_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR29_U_SMXP_3_1, REGION29_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR29_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR29_U_SMXP_3_1, REGION29_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR29_U_SMXP_3_1, REGION29_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR29_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR29_U_SMXP_3_1, 0x193dde8)
    FIELD(POR_MPU_M3_PRLAR29_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR29_U_SMXP_3_1, REGION29_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR29_U_SMXP_3_1, REGION29_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR30_U_SMXP_3_1, 0x193ddf0)
    FIELD(POR_MPU_M3_PRBAR30_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR30_U_SMXP_3_1, REGION30_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR30_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR30_U_SMXP_3_1, REGION30_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR30_U_SMXP_3_1, REGION30_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR30_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR30_U_SMXP_3_1, 0x193ddf8)
    FIELD(POR_MPU_M3_PRLAR30_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR30_U_SMXP_3_1, REGION30_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR30_U_SMXP_3_1, REGION30_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR31_U_SMXP_3_1, 0x193de00)
    FIELD(POR_MPU_M3_PRBAR31_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR31_U_SMXP_3_1, REGION31_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR31_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR31_U_SMXP_3_1, REGION31_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR31_U_SMXP_3_1, REGION31_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR31_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR31_U_SMXP_3_1, 0x193de08)
    FIELD(POR_MPU_M3_PRLAR31_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR31_U_SMXP_3_1, REGION31_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR31_U_SMXP_3_1, REGION31_EN, 0, 1)
REG32(POR_MPU_M4_CTL_U_SMXP_3_1, 0x193e000)
    FIELD(POR_MPU_M4_CTL_U_SMXP_3_1, M4_EN, 2, 1)
    FIELD(POR_MPU_M4_CTL_U_SMXP_3_1, M4_ACTION, 0, 2)
REG32(POR_MPU_M4_PRBAR0_U_SMXP_3_1, 0x193e010)
    FIELD(POR_MPU_M4_PRBAR0_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR0_U_SMXP_3_1, REGION0_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR0_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR0_U_SMXP_3_1, REGION0_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR0_U_SMXP_3_1, REGION0_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR0_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR0_U_SMXP_3_1, 0x193e018)
    FIELD(POR_MPU_M4_PRLAR0_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR0_U_SMXP_3_1, REGION0_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR0_U_SMXP_3_1, REGION0_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR1_U_SMXP_3_1, 0x193e020)
    FIELD(POR_MPU_M4_PRBAR1_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR1_U_SMXP_3_1, REGION1_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR1_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR1_U_SMXP_3_1, REGION1_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR1_U_SMXP_3_1, REGION1_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR1_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR1_U_SMXP_3_1, 0x193e028)
    FIELD(POR_MPU_M4_PRLAR1_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR1_U_SMXP_3_1, REGION1_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR1_U_SMXP_3_1, REGION1_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR2_U_SMXP_3_1, 0x193e030)
    FIELD(POR_MPU_M4_PRBAR2_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR2_U_SMXP_3_1, REGION2_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR2_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR2_U_SMXP_3_1, REGION2_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR2_U_SMXP_3_1, REGION2_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR2_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR2_U_SMXP_3_1, 0x193e038)
    FIELD(POR_MPU_M4_PRLAR2_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR2_U_SMXP_3_1, REGION2_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR2_U_SMXP_3_1, REGION2_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR3_U_SMXP_3_1, 0x193e040)
    FIELD(POR_MPU_M4_PRBAR3_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR3_U_SMXP_3_1, REGION3_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR3_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR3_U_SMXP_3_1, REGION3_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR3_U_SMXP_3_1, REGION3_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR3_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR3_U_SMXP_3_1, 0x193e048)
    FIELD(POR_MPU_M4_PRLAR3_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR3_U_SMXP_3_1, REGION3_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR3_U_SMXP_3_1, REGION3_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR4_U_SMXP_3_1, 0x193e050)
    FIELD(POR_MPU_M4_PRBAR4_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR4_U_SMXP_3_1, REGION4_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR4_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR4_U_SMXP_3_1, REGION4_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR4_U_SMXP_3_1, REGION4_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR4_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR4_U_SMXP_3_1, 0x193e058)
    FIELD(POR_MPU_M4_PRLAR4_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR4_U_SMXP_3_1, REGION4_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR4_U_SMXP_3_1, REGION4_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR5_U_SMXP_3_1, 0x193e060)
    FIELD(POR_MPU_M4_PRBAR5_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR5_U_SMXP_3_1, REGION5_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR5_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR5_U_SMXP_3_1, REGION5_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR5_U_SMXP_3_1, REGION5_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR5_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR5_U_SMXP_3_1, 0x193e068)
    FIELD(POR_MPU_M4_PRLAR5_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR5_U_SMXP_3_1, REGION5_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR5_U_SMXP_3_1, REGION5_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR6_U_SMXP_3_1, 0x193e070)
    FIELD(POR_MPU_M4_PRBAR6_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR6_U_SMXP_3_1, REGION6_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR6_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR6_U_SMXP_3_1, REGION6_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR6_U_SMXP_3_1, REGION6_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR6_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR6_U_SMXP_3_1, 0x193e078)
    FIELD(POR_MPU_M4_PRLAR6_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR6_U_SMXP_3_1, REGION6_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR6_U_SMXP_3_1, REGION6_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR7_U_SMXP_3_1, 0x193e080)
    FIELD(POR_MPU_M4_PRBAR7_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR7_U_SMXP_3_1, REGION7_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR7_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR7_U_SMXP_3_1, REGION7_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR7_U_SMXP_3_1, REGION7_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR7_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR7_U_SMXP_3_1, 0x193e088)
    FIELD(POR_MPU_M4_PRLAR7_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR7_U_SMXP_3_1, REGION7_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR7_U_SMXP_3_1, REGION7_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR8_U_SMXP_3_1, 0x193e090)
    FIELD(POR_MPU_M4_PRBAR8_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR8_U_SMXP_3_1, REGION8_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR8_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR8_U_SMXP_3_1, REGION8_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR8_U_SMXP_3_1, REGION8_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR8_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR8_U_SMXP_3_1, 0x193e098)
    FIELD(POR_MPU_M4_PRLAR8_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR8_U_SMXP_3_1, REGION8_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR8_U_SMXP_3_1, REGION8_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR9_U_SMXP_3_1, 0x193e0a0)
    FIELD(POR_MPU_M4_PRBAR9_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR9_U_SMXP_3_1, REGION9_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR9_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR9_U_SMXP_3_1, REGION9_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR9_U_SMXP_3_1, REGION9_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR9_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR9_U_SMXP_3_1, 0x193e0a8)
    FIELD(POR_MPU_M4_PRLAR9_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR9_U_SMXP_3_1, REGION9_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR9_U_SMXP_3_1, REGION9_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR10_U_SMXP_3_1, 0x193e0b0)
    FIELD(POR_MPU_M4_PRBAR10_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR10_U_SMXP_3_1, REGION10_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR10_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR10_U_SMXP_3_1, REGION10_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR10_U_SMXP_3_1, REGION10_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR10_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR10_U_SMXP_3_1, 0x193e0b8)
    FIELD(POR_MPU_M4_PRLAR10_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR10_U_SMXP_3_1, REGION10_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR10_U_SMXP_3_1, REGION10_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR11_U_SMXP_3_1, 0x193e0c0)
    FIELD(POR_MPU_M4_PRBAR11_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR11_U_SMXP_3_1, REGION11_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR11_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR11_U_SMXP_3_1, REGION11_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR11_U_SMXP_3_1, REGION11_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR11_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR11_U_SMXP_3_1, 0x193e0c8)
    FIELD(POR_MPU_M4_PRLAR11_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR11_U_SMXP_3_1, REGION11_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR11_U_SMXP_3_1, REGION11_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR12_U_SMXP_3_1, 0x193e0d0)
    FIELD(POR_MPU_M4_PRBAR12_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR12_U_SMXP_3_1, REGION12_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR12_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR12_U_SMXP_3_1, REGION12_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR12_U_SMXP_3_1, REGION12_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR12_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR12_U_SMXP_3_1, 0x193e0d8)
    FIELD(POR_MPU_M4_PRLAR12_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR12_U_SMXP_3_1, REGION12_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR12_U_SMXP_3_1, REGION12_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR13_U_SMXP_3_1, 0x193e0e0)
    FIELD(POR_MPU_M4_PRBAR13_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR13_U_SMXP_3_1, REGION13_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR13_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR13_U_SMXP_3_1, REGION13_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR13_U_SMXP_3_1, REGION13_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR13_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR13_U_SMXP_3_1, 0x193e0e8)
    FIELD(POR_MPU_M4_PRLAR13_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR13_U_SMXP_3_1, REGION13_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR13_U_SMXP_3_1, REGION13_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR14_U_SMXP_3_1, 0x193e0f0)
    FIELD(POR_MPU_M4_PRBAR14_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR14_U_SMXP_3_1, REGION14_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR14_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR14_U_SMXP_3_1, REGION14_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR14_U_SMXP_3_1, REGION14_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR14_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR14_U_SMXP_3_1, 0x193e0f8)
    FIELD(POR_MPU_M4_PRLAR14_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR14_U_SMXP_3_1, REGION14_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR14_U_SMXP_3_1, REGION14_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR15_U_SMXP_3_1, 0x193e100)
    FIELD(POR_MPU_M4_PRBAR15_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR15_U_SMXP_3_1, REGION15_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR15_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR15_U_SMXP_3_1, REGION15_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR15_U_SMXP_3_1, REGION15_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR15_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR15_U_SMXP_3_1, 0x193e108)
    FIELD(POR_MPU_M4_PRLAR15_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR15_U_SMXP_3_1, REGION15_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR15_U_SMXP_3_1, REGION15_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR16_U_SMXP_3_1, 0x193e110)
    FIELD(POR_MPU_M4_PRBAR16_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR16_U_SMXP_3_1, REGION16_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR16_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR16_U_SMXP_3_1, REGION16_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR16_U_SMXP_3_1, REGION16_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR16_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR16_U_SMXP_3_1, 0x193e118)
    FIELD(POR_MPU_M4_PRLAR16_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR16_U_SMXP_3_1, REGION16_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR16_U_SMXP_3_1, REGION16_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR17_U_SMXP_3_1, 0x193e120)
    FIELD(POR_MPU_M4_PRBAR17_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR17_U_SMXP_3_1, REGION17_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR17_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR17_U_SMXP_3_1, REGION17_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR17_U_SMXP_3_1, REGION17_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR17_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR17_U_SMXP_3_1, 0x193e128)
    FIELD(POR_MPU_M4_PRLAR17_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR17_U_SMXP_3_1, REGION17_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR17_U_SMXP_3_1, REGION17_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR18_U_SMXP_3_1, 0x193e130)
    FIELD(POR_MPU_M4_PRBAR18_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR18_U_SMXP_3_1, REGION18_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR18_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR18_U_SMXP_3_1, REGION18_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR18_U_SMXP_3_1, REGION18_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR18_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR18_U_SMXP_3_1, 0x193e138)
    FIELD(POR_MPU_M4_PRLAR18_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR18_U_SMXP_3_1, REGION18_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR18_U_SMXP_3_1, REGION18_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR19_U_SMXP_3_1, 0x193e140)
    FIELD(POR_MPU_M4_PRBAR19_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR19_U_SMXP_3_1, REGION19_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR19_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR19_U_SMXP_3_1, REGION19_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR19_U_SMXP_3_1, REGION19_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR19_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR19_U_SMXP_3_1, 0x193e148)
    FIELD(POR_MPU_M4_PRLAR19_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR19_U_SMXP_3_1, REGION19_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR19_U_SMXP_3_1, REGION19_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR20_U_SMXP_3_1, 0x193e150)
    FIELD(POR_MPU_M4_PRBAR20_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR20_U_SMXP_3_1, REGION20_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR20_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR20_U_SMXP_3_1, REGION20_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR20_U_SMXP_3_1, REGION20_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR20_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR20_U_SMXP_3_1, 0x193e158)
    FIELD(POR_MPU_M4_PRLAR20_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR20_U_SMXP_3_1, REGION20_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR20_U_SMXP_3_1, REGION20_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR21_U_SMXP_3_1, 0x193e160)
    FIELD(POR_MPU_M4_PRBAR21_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR21_U_SMXP_3_1, REGION21_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR21_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR21_U_SMXP_3_1, REGION21_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR21_U_SMXP_3_1, REGION21_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR21_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR21_U_SMXP_3_1, 0x193e168)
    FIELD(POR_MPU_M4_PRLAR21_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR21_U_SMXP_3_1, REGION21_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR21_U_SMXP_3_1, REGION21_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR22_U_SMXP_3_1, 0x193e170)
    FIELD(POR_MPU_M4_PRBAR22_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR22_U_SMXP_3_1, REGION22_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR22_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR22_U_SMXP_3_1, REGION22_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR22_U_SMXP_3_1, REGION22_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR22_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR22_U_SMXP_3_1, 0x193e178)
    FIELD(POR_MPU_M4_PRLAR22_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR22_U_SMXP_3_1, REGION22_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR22_U_SMXP_3_1, REGION22_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR23_U_SMXP_3_1, 0x193e180)
    FIELD(POR_MPU_M4_PRBAR23_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR23_U_SMXP_3_1, REGION23_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR23_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR23_U_SMXP_3_1, REGION23_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR23_U_SMXP_3_1, REGION23_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR23_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR23_U_SMXP_3_1, 0x193e188)
    FIELD(POR_MPU_M4_PRLAR23_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR23_U_SMXP_3_1, REGION23_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR23_U_SMXP_3_1, REGION23_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR24_U_SMXP_3_1, 0x193e190)
    FIELD(POR_MPU_M4_PRBAR24_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR24_U_SMXP_3_1, REGION24_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR24_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR24_U_SMXP_3_1, REGION24_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR24_U_SMXP_3_1, REGION24_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR24_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR24_U_SMXP_3_1, 0x193e198)
    FIELD(POR_MPU_M4_PRLAR24_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR24_U_SMXP_3_1, REGION24_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR24_U_SMXP_3_1, REGION24_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR25_U_SMXP_3_1, 0x193e1a0)
    FIELD(POR_MPU_M4_PRBAR25_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR25_U_SMXP_3_1, REGION25_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR25_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR25_U_SMXP_3_1, REGION25_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR25_U_SMXP_3_1, REGION25_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR25_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR25_U_SMXP_3_1, 0x193e1a8)
    FIELD(POR_MPU_M4_PRLAR25_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR25_U_SMXP_3_1, REGION25_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR25_U_SMXP_3_1, REGION25_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR26_U_SMXP_3_1, 0x193e1b0)
    FIELD(POR_MPU_M4_PRBAR26_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR26_U_SMXP_3_1, REGION26_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR26_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR26_U_SMXP_3_1, REGION26_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR26_U_SMXP_3_1, REGION26_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR26_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR26_U_SMXP_3_1, 0x193e1b8)
    FIELD(POR_MPU_M4_PRLAR26_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR26_U_SMXP_3_1, REGION26_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR26_U_SMXP_3_1, REGION26_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR27_U_SMXP_3_1, 0x193e1c0)
    FIELD(POR_MPU_M4_PRBAR27_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR27_U_SMXP_3_1, REGION27_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR27_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR27_U_SMXP_3_1, REGION27_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR27_U_SMXP_3_1, REGION27_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR27_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR27_U_SMXP_3_1, 0x193e1c8)
    FIELD(POR_MPU_M4_PRLAR27_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR27_U_SMXP_3_1, REGION27_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR27_U_SMXP_3_1, REGION27_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR28_U_SMXP_3_1, 0x193e1d0)
    FIELD(POR_MPU_M4_PRBAR28_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR28_U_SMXP_3_1, REGION28_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR28_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR28_U_SMXP_3_1, REGION28_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR28_U_SMXP_3_1, REGION28_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR28_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR28_U_SMXP_3_1, 0x193e1d8)
    FIELD(POR_MPU_M4_PRLAR28_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR28_U_SMXP_3_1, REGION28_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR28_U_SMXP_3_1, REGION28_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR29_U_SMXP_3_1, 0x193e1e0)
    FIELD(POR_MPU_M4_PRBAR29_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR29_U_SMXP_3_1, REGION29_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR29_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR29_U_SMXP_3_1, REGION29_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR29_U_SMXP_3_1, REGION29_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR29_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR29_U_SMXP_3_1, 0x193e1e8)
    FIELD(POR_MPU_M4_PRLAR29_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR29_U_SMXP_3_1, REGION29_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR29_U_SMXP_3_1, REGION29_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR30_U_SMXP_3_1, 0x193e1f0)
    FIELD(POR_MPU_M4_PRBAR30_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR30_U_SMXP_3_1, REGION30_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR30_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR30_U_SMXP_3_1, REGION30_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR30_U_SMXP_3_1, REGION30_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR30_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR30_U_SMXP_3_1, 0x193e1f8)
    FIELD(POR_MPU_M4_PRLAR30_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR30_U_SMXP_3_1, REGION30_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR30_U_SMXP_3_1, REGION30_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR31_U_SMXP_3_1, 0x193e200)
    FIELD(POR_MPU_M4_PRBAR31_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR31_U_SMXP_3_1, REGION31_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR31_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR31_U_SMXP_3_1, REGION31_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR31_U_SMXP_3_1, REGION31_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR31_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR31_U_SMXP_3_1, 0x193e208)
    FIELD(POR_MPU_M4_PRLAR31_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR31_U_SMXP_3_1, REGION31_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR31_U_SMXP_3_1, REGION31_EN, 0, 1)
REG32(POR_MPU_M5_CTL_U_SMXP_3_1, 0x193e400)
    FIELD(POR_MPU_M5_CTL_U_SMXP_3_1, M5_EN, 2, 1)
    FIELD(POR_MPU_M5_CTL_U_SMXP_3_1, M5_ACTION, 0, 2)
REG32(POR_MPU_M5_PRBAR0_U_SMXP_3_1, 0x193e410)
    FIELD(POR_MPU_M5_PRBAR0_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR0_U_SMXP_3_1, REGION0_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR0_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR0_U_SMXP_3_1, REGION0_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR0_U_SMXP_3_1, REGION0_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR0_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR0_U_SMXP_3_1, 0x193e418)
    FIELD(POR_MPU_M5_PRLAR0_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR0_U_SMXP_3_1, REGION0_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR0_U_SMXP_3_1, REGION0_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR1_U_SMXP_3_1, 0x193e420)
    FIELD(POR_MPU_M5_PRBAR1_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR1_U_SMXP_3_1, REGION1_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR1_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR1_U_SMXP_3_1, REGION1_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR1_U_SMXP_3_1, REGION1_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR1_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR1_U_SMXP_3_1, 0x193e428)
    FIELD(POR_MPU_M5_PRLAR1_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR1_U_SMXP_3_1, REGION1_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR1_U_SMXP_3_1, REGION1_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR2_U_SMXP_3_1, 0x193e430)
    FIELD(POR_MPU_M5_PRBAR2_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR2_U_SMXP_3_1, REGION2_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR2_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR2_U_SMXP_3_1, REGION2_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR2_U_SMXP_3_1, REGION2_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR2_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR2_U_SMXP_3_1, 0x193e438)
    FIELD(POR_MPU_M5_PRLAR2_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR2_U_SMXP_3_1, REGION2_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR2_U_SMXP_3_1, REGION2_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR3_U_SMXP_3_1, 0x193e440)
    FIELD(POR_MPU_M5_PRBAR3_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR3_U_SMXP_3_1, REGION3_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR3_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR3_U_SMXP_3_1, REGION3_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR3_U_SMXP_3_1, REGION3_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR3_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR3_U_SMXP_3_1, 0x193e448)
    FIELD(POR_MPU_M5_PRLAR3_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR3_U_SMXP_3_1, REGION3_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR3_U_SMXP_3_1, REGION3_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR4_U_SMXP_3_1, 0x193e450)
    FIELD(POR_MPU_M5_PRBAR4_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR4_U_SMXP_3_1, REGION4_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR4_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR4_U_SMXP_3_1, REGION4_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR4_U_SMXP_3_1, REGION4_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR4_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR4_U_SMXP_3_1, 0x193e458)
    FIELD(POR_MPU_M5_PRLAR4_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR4_U_SMXP_3_1, REGION4_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR4_U_SMXP_3_1, REGION4_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR5_U_SMXP_3_1, 0x193e460)
    FIELD(POR_MPU_M5_PRBAR5_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR5_U_SMXP_3_1, REGION5_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR5_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR5_U_SMXP_3_1, REGION5_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR5_U_SMXP_3_1, REGION5_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR5_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR5_U_SMXP_3_1, 0x193e468)
    FIELD(POR_MPU_M5_PRLAR5_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR5_U_SMXP_3_1, REGION5_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR5_U_SMXP_3_1, REGION5_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR6_U_SMXP_3_1, 0x193e470)
    FIELD(POR_MPU_M5_PRBAR6_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR6_U_SMXP_3_1, REGION6_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR6_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR6_U_SMXP_3_1, REGION6_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR6_U_SMXP_3_1, REGION6_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR6_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR6_U_SMXP_3_1, 0x193e478)
    FIELD(POR_MPU_M5_PRLAR6_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR6_U_SMXP_3_1, REGION6_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR6_U_SMXP_3_1, REGION6_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR7_U_SMXP_3_1, 0x193e480)
    FIELD(POR_MPU_M5_PRBAR7_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR7_U_SMXP_3_1, REGION7_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR7_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR7_U_SMXP_3_1, REGION7_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR7_U_SMXP_3_1, REGION7_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR7_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR7_U_SMXP_3_1, 0x193e488)
    FIELD(POR_MPU_M5_PRLAR7_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR7_U_SMXP_3_1, REGION7_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR7_U_SMXP_3_1, REGION7_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR8_U_SMXP_3_1, 0x193e490)
    FIELD(POR_MPU_M5_PRBAR8_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR8_U_SMXP_3_1, REGION8_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR8_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR8_U_SMXP_3_1, REGION8_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR8_U_SMXP_3_1, REGION8_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR8_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR8_U_SMXP_3_1, 0x193e498)
    FIELD(POR_MPU_M5_PRLAR8_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR8_U_SMXP_3_1, REGION8_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR8_U_SMXP_3_1, REGION8_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR9_U_SMXP_3_1, 0x193e4a0)
    FIELD(POR_MPU_M5_PRBAR9_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR9_U_SMXP_3_1, REGION9_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR9_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR9_U_SMXP_3_1, REGION9_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR9_U_SMXP_3_1, REGION9_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR9_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR9_U_SMXP_3_1, 0x193e4a8)
    FIELD(POR_MPU_M5_PRLAR9_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR9_U_SMXP_3_1, REGION9_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR9_U_SMXP_3_1, REGION9_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR10_U_SMXP_3_1, 0x193e4b0)
    FIELD(POR_MPU_M5_PRBAR10_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR10_U_SMXP_3_1, REGION10_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR10_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR10_U_SMXP_3_1, REGION10_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR10_U_SMXP_3_1, REGION10_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR10_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR10_U_SMXP_3_1, 0x193e4b8)
    FIELD(POR_MPU_M5_PRLAR10_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR10_U_SMXP_3_1, REGION10_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR10_U_SMXP_3_1, REGION10_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR11_U_SMXP_3_1, 0x193e4c0)
    FIELD(POR_MPU_M5_PRBAR11_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR11_U_SMXP_3_1, REGION11_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR11_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR11_U_SMXP_3_1, REGION11_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR11_U_SMXP_3_1, REGION11_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR11_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR11_U_SMXP_3_1, 0x193e4c8)
    FIELD(POR_MPU_M5_PRLAR11_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR11_U_SMXP_3_1, REGION11_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR11_U_SMXP_3_1, REGION11_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR12_U_SMXP_3_1, 0x193e4d0)
    FIELD(POR_MPU_M5_PRBAR12_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR12_U_SMXP_3_1, REGION12_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR12_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR12_U_SMXP_3_1, REGION12_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR12_U_SMXP_3_1, REGION12_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR12_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR12_U_SMXP_3_1, 0x193e4d8)
    FIELD(POR_MPU_M5_PRLAR12_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR12_U_SMXP_3_1, REGION12_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR12_U_SMXP_3_1, REGION12_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR13_U_SMXP_3_1, 0x193e4e0)
    FIELD(POR_MPU_M5_PRBAR13_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR13_U_SMXP_3_1, REGION13_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR13_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR13_U_SMXP_3_1, REGION13_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR13_U_SMXP_3_1, REGION13_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR13_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR13_U_SMXP_3_1, 0x193e4e8)
    FIELD(POR_MPU_M5_PRLAR13_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR13_U_SMXP_3_1, REGION13_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR13_U_SMXP_3_1, REGION13_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR14_U_SMXP_3_1, 0x193e4f0)
    FIELD(POR_MPU_M5_PRBAR14_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR14_U_SMXP_3_1, REGION14_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR14_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR14_U_SMXP_3_1, REGION14_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR14_U_SMXP_3_1, REGION14_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR14_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR14_U_SMXP_3_1, 0x193e4f8)
    FIELD(POR_MPU_M5_PRLAR14_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR14_U_SMXP_3_1, REGION14_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR14_U_SMXP_3_1, REGION14_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR15_U_SMXP_3_1, 0x193e500)
    FIELD(POR_MPU_M5_PRBAR15_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR15_U_SMXP_3_1, REGION15_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR15_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR15_U_SMXP_3_1, REGION15_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR15_U_SMXP_3_1, REGION15_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR15_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR15_U_SMXP_3_1, 0x193e508)
    FIELD(POR_MPU_M5_PRLAR15_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR15_U_SMXP_3_1, REGION15_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR15_U_SMXP_3_1, REGION15_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR16_U_SMXP_3_1, 0x193e510)
    FIELD(POR_MPU_M5_PRBAR16_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR16_U_SMXP_3_1, REGION16_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR16_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR16_U_SMXP_3_1, REGION16_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR16_U_SMXP_3_1, REGION16_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR16_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR16_U_SMXP_3_1, 0x193e518)
    FIELD(POR_MPU_M5_PRLAR16_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR16_U_SMXP_3_1, REGION16_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR16_U_SMXP_3_1, REGION16_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR17_U_SMXP_3_1, 0x193e520)
    FIELD(POR_MPU_M5_PRBAR17_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR17_U_SMXP_3_1, REGION17_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR17_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR17_U_SMXP_3_1, REGION17_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR17_U_SMXP_3_1, REGION17_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR17_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR17_U_SMXP_3_1, 0x193e528)
    FIELD(POR_MPU_M5_PRLAR17_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR17_U_SMXP_3_1, REGION17_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR17_U_SMXP_3_1, REGION17_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR18_U_SMXP_3_1, 0x193e530)
    FIELD(POR_MPU_M5_PRBAR18_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR18_U_SMXP_3_1, REGION18_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR18_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR18_U_SMXP_3_1, REGION18_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR18_U_SMXP_3_1, REGION18_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR18_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR18_U_SMXP_3_1, 0x193e538)
    FIELD(POR_MPU_M5_PRLAR18_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR18_U_SMXP_3_1, REGION18_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR18_U_SMXP_3_1, REGION18_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR19_U_SMXP_3_1, 0x193e540)
    FIELD(POR_MPU_M5_PRBAR19_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR19_U_SMXP_3_1, REGION19_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR19_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR19_U_SMXP_3_1, REGION19_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR19_U_SMXP_3_1, REGION19_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR19_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR19_U_SMXP_3_1, 0x193e548)
    FIELD(POR_MPU_M5_PRLAR19_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR19_U_SMXP_3_1, REGION19_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR19_U_SMXP_3_1, REGION19_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR20_U_SMXP_3_1, 0x193e550)
    FIELD(POR_MPU_M5_PRBAR20_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR20_U_SMXP_3_1, REGION20_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR20_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR20_U_SMXP_3_1, REGION20_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR20_U_SMXP_3_1, REGION20_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR20_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR20_U_SMXP_3_1, 0x193e558)
    FIELD(POR_MPU_M5_PRLAR20_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR20_U_SMXP_3_1, REGION20_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR20_U_SMXP_3_1, REGION20_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR21_U_SMXP_3_1, 0x193e560)
    FIELD(POR_MPU_M5_PRBAR21_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR21_U_SMXP_3_1, REGION21_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR21_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR21_U_SMXP_3_1, REGION21_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR21_U_SMXP_3_1, REGION21_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR21_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR21_U_SMXP_3_1, 0x193e568)
    FIELD(POR_MPU_M5_PRLAR21_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR21_U_SMXP_3_1, REGION21_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR21_U_SMXP_3_1, REGION21_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR22_U_SMXP_3_1, 0x193e570)
    FIELD(POR_MPU_M5_PRBAR22_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR22_U_SMXP_3_1, REGION22_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR22_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR22_U_SMXP_3_1, REGION22_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR22_U_SMXP_3_1, REGION22_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR22_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR22_U_SMXP_3_1, 0x193e578)
    FIELD(POR_MPU_M5_PRLAR22_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR22_U_SMXP_3_1, REGION22_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR22_U_SMXP_3_1, REGION22_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR23_U_SMXP_3_1, 0x193e580)
    FIELD(POR_MPU_M5_PRBAR23_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR23_U_SMXP_3_1, REGION23_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR23_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR23_U_SMXP_3_1, REGION23_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR23_U_SMXP_3_1, REGION23_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR23_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR23_U_SMXP_3_1, 0x193e588)
    FIELD(POR_MPU_M5_PRLAR23_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR23_U_SMXP_3_1, REGION23_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR23_U_SMXP_3_1, REGION23_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR24_U_SMXP_3_1, 0x193e590)
    FIELD(POR_MPU_M5_PRBAR24_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR24_U_SMXP_3_1, REGION24_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR24_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR24_U_SMXP_3_1, REGION24_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR24_U_SMXP_3_1, REGION24_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR24_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR24_U_SMXP_3_1, 0x193e598)
    FIELD(POR_MPU_M5_PRLAR24_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR24_U_SMXP_3_1, REGION24_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR24_U_SMXP_3_1, REGION24_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR25_U_SMXP_3_1, 0x193e5a0)
    FIELD(POR_MPU_M5_PRBAR25_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR25_U_SMXP_3_1, REGION25_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR25_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR25_U_SMXP_3_1, REGION25_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR25_U_SMXP_3_1, REGION25_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR25_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR25_U_SMXP_3_1, 0x193e5a8)
    FIELD(POR_MPU_M5_PRLAR25_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR25_U_SMXP_3_1, REGION25_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR25_U_SMXP_3_1, REGION25_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR26_U_SMXP_3_1, 0x193e5b0)
    FIELD(POR_MPU_M5_PRBAR26_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR26_U_SMXP_3_1, REGION26_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR26_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR26_U_SMXP_3_1, REGION26_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR26_U_SMXP_3_1, REGION26_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR26_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR26_U_SMXP_3_1, 0x193e5b8)
    FIELD(POR_MPU_M5_PRLAR26_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR26_U_SMXP_3_1, REGION26_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR26_U_SMXP_3_1, REGION26_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR27_U_SMXP_3_1, 0x193e5c0)
    FIELD(POR_MPU_M5_PRBAR27_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR27_U_SMXP_3_1, REGION27_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR27_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR27_U_SMXP_3_1, REGION27_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR27_U_SMXP_3_1, REGION27_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR27_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR27_U_SMXP_3_1, 0x193e5c8)
    FIELD(POR_MPU_M5_PRLAR27_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR27_U_SMXP_3_1, REGION27_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR27_U_SMXP_3_1, REGION27_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR28_U_SMXP_3_1, 0x193e5d0)
    FIELD(POR_MPU_M5_PRBAR28_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR28_U_SMXP_3_1, REGION28_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR28_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR28_U_SMXP_3_1, REGION28_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR28_U_SMXP_3_1, REGION28_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR28_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR28_U_SMXP_3_1, 0x193e5d8)
    FIELD(POR_MPU_M5_PRLAR28_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR28_U_SMXP_3_1, REGION28_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR28_U_SMXP_3_1, REGION28_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR29_U_SMXP_3_1, 0x193e5e0)
    FIELD(POR_MPU_M5_PRBAR29_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR29_U_SMXP_3_1, REGION29_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR29_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR29_U_SMXP_3_1, REGION29_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR29_U_SMXP_3_1, REGION29_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR29_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR29_U_SMXP_3_1, 0x193e5e8)
    FIELD(POR_MPU_M5_PRLAR29_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR29_U_SMXP_3_1, REGION29_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR29_U_SMXP_3_1, REGION29_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR30_U_SMXP_3_1, 0x193e5f0)
    FIELD(POR_MPU_M5_PRBAR30_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR30_U_SMXP_3_1, REGION30_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR30_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR30_U_SMXP_3_1, REGION30_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR30_U_SMXP_3_1, REGION30_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR30_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR30_U_SMXP_3_1, 0x193e5f8)
    FIELD(POR_MPU_M5_PRLAR30_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR30_U_SMXP_3_1, REGION30_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR30_U_SMXP_3_1, REGION30_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR31_U_SMXP_3_1, 0x193e600)
    FIELD(POR_MPU_M5_PRBAR31_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR31_U_SMXP_3_1, REGION31_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR31_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR31_U_SMXP_3_1, REGION31_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR31_U_SMXP_3_1, REGION31_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR31_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR31_U_SMXP_3_1, 0x193e608)
    FIELD(POR_MPU_M5_PRLAR31_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR31_U_SMXP_3_1, REGION31_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR31_U_SMXP_3_1, REGION31_EN, 0, 1)
REG32(POR_MPU_M6_CTL_U_SMXP_3_1, 0x193e800)
    FIELD(POR_MPU_M6_CTL_U_SMXP_3_1, M6_EN, 2, 1)
    FIELD(POR_MPU_M6_CTL_U_SMXP_3_1, M6_ACTION, 0, 2)
REG32(POR_MPU_M6_PRBAR0_U_SMXP_3_1, 0x193e810)
    FIELD(POR_MPU_M6_PRBAR0_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR0_U_SMXP_3_1, REGION0_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR0_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR0_U_SMXP_3_1, REGION0_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR0_U_SMXP_3_1, REGION0_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR0_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR0_U_SMXP_3_1, 0x193e818)
    FIELD(POR_MPU_M6_PRLAR0_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR0_U_SMXP_3_1, REGION0_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR0_U_SMXP_3_1, REGION0_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR1_U_SMXP_3_1, 0x193e820)
    FIELD(POR_MPU_M6_PRBAR1_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR1_U_SMXP_3_1, REGION1_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR1_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR1_U_SMXP_3_1, REGION1_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR1_U_SMXP_3_1, REGION1_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR1_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR1_U_SMXP_3_1, 0x193e828)
    FIELD(POR_MPU_M6_PRLAR1_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR1_U_SMXP_3_1, REGION1_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR1_U_SMXP_3_1, REGION1_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR2_U_SMXP_3_1, 0x193e830)
    FIELD(POR_MPU_M6_PRBAR2_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR2_U_SMXP_3_1, REGION2_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR2_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR2_U_SMXP_3_1, REGION2_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR2_U_SMXP_3_1, REGION2_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR2_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR2_U_SMXP_3_1, 0x193e838)
    FIELD(POR_MPU_M6_PRLAR2_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR2_U_SMXP_3_1, REGION2_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR2_U_SMXP_3_1, REGION2_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR3_U_SMXP_3_1, 0x193e840)
    FIELD(POR_MPU_M6_PRBAR3_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR3_U_SMXP_3_1, REGION3_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR3_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR3_U_SMXP_3_1, REGION3_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR3_U_SMXP_3_1, REGION3_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR3_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR3_U_SMXP_3_1, 0x193e848)
    FIELD(POR_MPU_M6_PRLAR3_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR3_U_SMXP_3_1, REGION3_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR3_U_SMXP_3_1, REGION3_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR4_U_SMXP_3_1, 0x193e850)
    FIELD(POR_MPU_M6_PRBAR4_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR4_U_SMXP_3_1, REGION4_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR4_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR4_U_SMXP_3_1, REGION4_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR4_U_SMXP_3_1, REGION4_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR4_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR4_U_SMXP_3_1, 0x193e858)
    FIELD(POR_MPU_M6_PRLAR4_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR4_U_SMXP_3_1, REGION4_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR4_U_SMXP_3_1, REGION4_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR5_U_SMXP_3_1, 0x193e860)
    FIELD(POR_MPU_M6_PRBAR5_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR5_U_SMXP_3_1, REGION5_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR5_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR5_U_SMXP_3_1, REGION5_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR5_U_SMXP_3_1, REGION5_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR5_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR5_U_SMXP_3_1, 0x193e868)
    FIELD(POR_MPU_M6_PRLAR5_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR5_U_SMXP_3_1, REGION5_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR5_U_SMXP_3_1, REGION5_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR6_U_SMXP_3_1, 0x193e870)
    FIELD(POR_MPU_M6_PRBAR6_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR6_U_SMXP_3_1, REGION6_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR6_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR6_U_SMXP_3_1, REGION6_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR6_U_SMXP_3_1, REGION6_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR6_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR6_U_SMXP_3_1, 0x193e878)
    FIELD(POR_MPU_M6_PRLAR6_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR6_U_SMXP_3_1, REGION6_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR6_U_SMXP_3_1, REGION6_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR7_U_SMXP_3_1, 0x193e880)
    FIELD(POR_MPU_M6_PRBAR7_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR7_U_SMXP_3_1, REGION7_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR7_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR7_U_SMXP_3_1, REGION7_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR7_U_SMXP_3_1, REGION7_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR7_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR7_U_SMXP_3_1, 0x193e888)
    FIELD(POR_MPU_M6_PRLAR7_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR7_U_SMXP_3_1, REGION7_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR7_U_SMXP_3_1, REGION7_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR8_U_SMXP_3_1, 0x193e890)
    FIELD(POR_MPU_M6_PRBAR8_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR8_U_SMXP_3_1, REGION8_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR8_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR8_U_SMXP_3_1, REGION8_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR8_U_SMXP_3_1, REGION8_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR8_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR8_U_SMXP_3_1, 0x193e898)
    FIELD(POR_MPU_M6_PRLAR8_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR8_U_SMXP_3_1, REGION8_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR8_U_SMXP_3_1, REGION8_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR9_U_SMXP_3_1, 0x193e8a0)
    FIELD(POR_MPU_M6_PRBAR9_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR9_U_SMXP_3_1, REGION9_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR9_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR9_U_SMXP_3_1, REGION9_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR9_U_SMXP_3_1, REGION9_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR9_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR9_U_SMXP_3_1, 0x193e8a8)
    FIELD(POR_MPU_M6_PRLAR9_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR9_U_SMXP_3_1, REGION9_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR9_U_SMXP_3_1, REGION9_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR10_U_SMXP_3_1, 0x193e8b0)
    FIELD(POR_MPU_M6_PRBAR10_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR10_U_SMXP_3_1, REGION10_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR10_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR10_U_SMXP_3_1, REGION10_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR10_U_SMXP_3_1, REGION10_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR10_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR10_U_SMXP_3_1, 0x193e8b8)
    FIELD(POR_MPU_M6_PRLAR10_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR10_U_SMXP_3_1, REGION10_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR10_U_SMXP_3_1, REGION10_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR11_U_SMXP_3_1, 0x193e8c0)
    FIELD(POR_MPU_M6_PRBAR11_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR11_U_SMXP_3_1, REGION11_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR11_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR11_U_SMXP_3_1, REGION11_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR11_U_SMXP_3_1, REGION11_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR11_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR11_U_SMXP_3_1, 0x193e8c8)
    FIELD(POR_MPU_M6_PRLAR11_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR11_U_SMXP_3_1, REGION11_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR11_U_SMXP_3_1, REGION11_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR12_U_SMXP_3_1, 0x193e8d0)
    FIELD(POR_MPU_M6_PRBAR12_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR12_U_SMXP_3_1, REGION12_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR12_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR12_U_SMXP_3_1, REGION12_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR12_U_SMXP_3_1, REGION12_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR12_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR12_U_SMXP_3_1, 0x193e8d8)
    FIELD(POR_MPU_M6_PRLAR12_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR12_U_SMXP_3_1, REGION12_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR12_U_SMXP_3_1, REGION12_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR13_U_SMXP_3_1, 0x193e8e0)
    FIELD(POR_MPU_M6_PRBAR13_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR13_U_SMXP_3_1, REGION13_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR13_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR13_U_SMXP_3_1, REGION13_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR13_U_SMXP_3_1, REGION13_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR13_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR13_U_SMXP_3_1, 0x193e8e8)
    FIELD(POR_MPU_M6_PRLAR13_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR13_U_SMXP_3_1, REGION13_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR13_U_SMXP_3_1, REGION13_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR14_U_SMXP_3_1, 0x193e8f0)
    FIELD(POR_MPU_M6_PRBAR14_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR14_U_SMXP_3_1, REGION14_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR14_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR14_U_SMXP_3_1, REGION14_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR14_U_SMXP_3_1, REGION14_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR14_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR14_U_SMXP_3_1, 0x193e8f8)
    FIELD(POR_MPU_M6_PRLAR14_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR14_U_SMXP_3_1, REGION14_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR14_U_SMXP_3_1, REGION14_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR15_U_SMXP_3_1, 0x193e900)
    FIELD(POR_MPU_M6_PRBAR15_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR15_U_SMXP_3_1, REGION15_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR15_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR15_U_SMXP_3_1, REGION15_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR15_U_SMXP_3_1, REGION15_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR15_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR15_U_SMXP_3_1, 0x193e908)
    FIELD(POR_MPU_M6_PRLAR15_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR15_U_SMXP_3_1, REGION15_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR15_U_SMXP_3_1, REGION15_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR16_U_SMXP_3_1, 0x193e910)
    FIELD(POR_MPU_M6_PRBAR16_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR16_U_SMXP_3_1, REGION16_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR16_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR16_U_SMXP_3_1, REGION16_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR16_U_SMXP_3_1, REGION16_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR16_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR16_U_SMXP_3_1, 0x193e918)
    FIELD(POR_MPU_M6_PRLAR16_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR16_U_SMXP_3_1, REGION16_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR16_U_SMXP_3_1, REGION16_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR17_U_SMXP_3_1, 0x193e920)
    FIELD(POR_MPU_M6_PRBAR17_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR17_U_SMXP_3_1, REGION17_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR17_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR17_U_SMXP_3_1, REGION17_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR17_U_SMXP_3_1, REGION17_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR17_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR17_U_SMXP_3_1, 0x193e928)
    FIELD(POR_MPU_M6_PRLAR17_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR17_U_SMXP_3_1, REGION17_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR17_U_SMXP_3_1, REGION17_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR18_U_SMXP_3_1, 0x193e930)
    FIELD(POR_MPU_M6_PRBAR18_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR18_U_SMXP_3_1, REGION18_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR18_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR18_U_SMXP_3_1, REGION18_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR18_U_SMXP_3_1, REGION18_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR18_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR18_U_SMXP_3_1, 0x193e938)
    FIELD(POR_MPU_M6_PRLAR18_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR18_U_SMXP_3_1, REGION18_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR18_U_SMXP_3_1, REGION18_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR19_U_SMXP_3_1, 0x193e940)
    FIELD(POR_MPU_M6_PRBAR19_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR19_U_SMXP_3_1, REGION19_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR19_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR19_U_SMXP_3_1, REGION19_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR19_U_SMXP_3_1, REGION19_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR19_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR19_U_SMXP_3_1, 0x193e948)
    FIELD(POR_MPU_M6_PRLAR19_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR19_U_SMXP_3_1, REGION19_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR19_U_SMXP_3_1, REGION19_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR20_U_SMXP_3_1, 0x193e950)
    FIELD(POR_MPU_M6_PRBAR20_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR20_U_SMXP_3_1, REGION20_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR20_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR20_U_SMXP_3_1, REGION20_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR20_U_SMXP_3_1, REGION20_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR20_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR20_U_SMXP_3_1, 0x193e958)
    FIELD(POR_MPU_M6_PRLAR20_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR20_U_SMXP_3_1, REGION20_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR20_U_SMXP_3_1, REGION20_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR21_U_SMXP_3_1, 0x193e960)
    FIELD(POR_MPU_M6_PRBAR21_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR21_U_SMXP_3_1, REGION21_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR21_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR21_U_SMXP_3_1, REGION21_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR21_U_SMXP_3_1, REGION21_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR21_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR21_U_SMXP_3_1, 0x193e968)
    FIELD(POR_MPU_M6_PRLAR21_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR21_U_SMXP_3_1, REGION21_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR21_U_SMXP_3_1, REGION21_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR22_U_SMXP_3_1, 0x193e970)
    FIELD(POR_MPU_M6_PRBAR22_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR22_U_SMXP_3_1, REGION22_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR22_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR22_U_SMXP_3_1, REGION22_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR22_U_SMXP_3_1, REGION22_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR22_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR22_U_SMXP_3_1, 0x193e978)
    FIELD(POR_MPU_M6_PRLAR22_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR22_U_SMXP_3_1, REGION22_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR22_U_SMXP_3_1, REGION22_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR23_U_SMXP_3_1, 0x193e980)
    FIELD(POR_MPU_M6_PRBAR23_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR23_U_SMXP_3_1, REGION23_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR23_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR23_U_SMXP_3_1, REGION23_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR23_U_SMXP_3_1, REGION23_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR23_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR23_U_SMXP_3_1, 0x193e988)
    FIELD(POR_MPU_M6_PRLAR23_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR23_U_SMXP_3_1, REGION23_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR23_U_SMXP_3_1, REGION23_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR24_U_SMXP_3_1, 0x193e990)
    FIELD(POR_MPU_M6_PRBAR24_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR24_U_SMXP_3_1, REGION24_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR24_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR24_U_SMXP_3_1, REGION24_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR24_U_SMXP_3_1, REGION24_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR24_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR24_U_SMXP_3_1, 0x193e998)
    FIELD(POR_MPU_M6_PRLAR24_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR24_U_SMXP_3_1, REGION24_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR24_U_SMXP_3_1, REGION24_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR25_U_SMXP_3_1, 0x193e9a0)
    FIELD(POR_MPU_M6_PRBAR25_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR25_U_SMXP_3_1, REGION25_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR25_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR25_U_SMXP_3_1, REGION25_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR25_U_SMXP_3_1, REGION25_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR25_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR25_U_SMXP_3_1, 0x193e9a8)
    FIELD(POR_MPU_M6_PRLAR25_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR25_U_SMXP_3_1, REGION25_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR25_U_SMXP_3_1, REGION25_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR26_U_SMXP_3_1, 0x193e9b0)
    FIELD(POR_MPU_M6_PRBAR26_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR26_U_SMXP_3_1, REGION26_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR26_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR26_U_SMXP_3_1, REGION26_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR26_U_SMXP_3_1, REGION26_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR26_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR26_U_SMXP_3_1, 0x193e9b8)
    FIELD(POR_MPU_M6_PRLAR26_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR26_U_SMXP_3_1, REGION26_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR26_U_SMXP_3_1, REGION26_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR27_U_SMXP_3_1, 0x193e9c0)
    FIELD(POR_MPU_M6_PRBAR27_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR27_U_SMXP_3_1, REGION27_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR27_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR27_U_SMXP_3_1, REGION27_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR27_U_SMXP_3_1, REGION27_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR27_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR27_U_SMXP_3_1, 0x193e9c8)
    FIELD(POR_MPU_M6_PRLAR27_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR27_U_SMXP_3_1, REGION27_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR27_U_SMXP_3_1, REGION27_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR28_U_SMXP_3_1, 0x193e9d0)
    FIELD(POR_MPU_M6_PRBAR28_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR28_U_SMXP_3_1, REGION28_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR28_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR28_U_SMXP_3_1, REGION28_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR28_U_SMXP_3_1, REGION28_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR28_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR28_U_SMXP_3_1, 0x193e9d8)
    FIELD(POR_MPU_M6_PRLAR28_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR28_U_SMXP_3_1, REGION28_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR28_U_SMXP_3_1, REGION28_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR29_U_SMXP_3_1, 0x193e9e0)
    FIELD(POR_MPU_M6_PRBAR29_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR29_U_SMXP_3_1, REGION29_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR29_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR29_U_SMXP_3_1, REGION29_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR29_U_SMXP_3_1, REGION29_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR29_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR29_U_SMXP_3_1, 0x193e9e8)
    FIELD(POR_MPU_M6_PRLAR29_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR29_U_SMXP_3_1, REGION29_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR29_U_SMXP_3_1, REGION29_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR30_U_SMXP_3_1, 0x193e9f0)
    FIELD(POR_MPU_M6_PRBAR30_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR30_U_SMXP_3_1, REGION30_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR30_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR30_U_SMXP_3_1, REGION30_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR30_U_SMXP_3_1, REGION30_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR30_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR30_U_SMXP_3_1, 0x193e9f8)
    FIELD(POR_MPU_M6_PRLAR30_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR30_U_SMXP_3_1, REGION30_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR30_U_SMXP_3_1, REGION30_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR31_U_SMXP_3_1, 0x193ea00)
    FIELD(POR_MPU_M6_PRBAR31_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR31_U_SMXP_3_1, REGION31_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR31_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR31_U_SMXP_3_1, REGION31_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR31_U_SMXP_3_1, REGION31_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR31_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR31_U_SMXP_3_1, 0x193ea08)
    FIELD(POR_MPU_M6_PRLAR31_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR31_U_SMXP_3_1, REGION31_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR31_U_SMXP_3_1, REGION31_EN, 0, 1)
REG32(POR_MPU_M7_CTL_U_SMXP_3_1, 0x193ec00)
    FIELD(POR_MPU_M7_CTL_U_SMXP_3_1, M7_EN, 2, 1)
    FIELD(POR_MPU_M7_CTL_U_SMXP_3_1, M7_ACTION, 0, 2)
REG32(POR_MPU_M7_PRBAR0_U_SMXP_3_1, 0x193ec10)
    FIELD(POR_MPU_M7_PRBAR0_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR0_U_SMXP_3_1, REGION0_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR0_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR0_U_SMXP_3_1, REGION0_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR0_U_SMXP_3_1, REGION0_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR0_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR0_U_SMXP_3_1, 0x193ec18)
    FIELD(POR_MPU_M7_PRLAR0_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR0_U_SMXP_3_1, REGION0_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR0_U_SMXP_3_1, REGION0_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR1_U_SMXP_3_1, 0x193ec20)
    FIELD(POR_MPU_M7_PRBAR1_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR1_U_SMXP_3_1, REGION1_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR1_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR1_U_SMXP_3_1, REGION1_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR1_U_SMXP_3_1, REGION1_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR1_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR1_U_SMXP_3_1, 0x193ec28)
    FIELD(POR_MPU_M7_PRLAR1_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR1_U_SMXP_3_1, REGION1_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR1_U_SMXP_3_1, REGION1_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR2_U_SMXP_3_1, 0x193ec30)
    FIELD(POR_MPU_M7_PRBAR2_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR2_U_SMXP_3_1, REGION2_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR2_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR2_U_SMXP_3_1, REGION2_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR2_U_SMXP_3_1, REGION2_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR2_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR2_U_SMXP_3_1, 0x193ec38)
    FIELD(POR_MPU_M7_PRLAR2_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR2_U_SMXP_3_1, REGION2_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR2_U_SMXP_3_1, REGION2_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR3_U_SMXP_3_1, 0x193ec40)
    FIELD(POR_MPU_M7_PRBAR3_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR3_U_SMXP_3_1, REGION3_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR3_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR3_U_SMXP_3_1, REGION3_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR3_U_SMXP_3_1, REGION3_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR3_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR3_U_SMXP_3_1, 0x193ec48)
    FIELD(POR_MPU_M7_PRLAR3_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR3_U_SMXP_3_1, REGION3_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR3_U_SMXP_3_1, REGION3_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR4_U_SMXP_3_1, 0x193ec50)
    FIELD(POR_MPU_M7_PRBAR4_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR4_U_SMXP_3_1, REGION4_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR4_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR4_U_SMXP_3_1, REGION4_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR4_U_SMXP_3_1, REGION4_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR4_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR4_U_SMXP_3_1, 0x193ec58)
    FIELD(POR_MPU_M7_PRLAR4_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR4_U_SMXP_3_1, REGION4_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR4_U_SMXP_3_1, REGION4_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR5_U_SMXP_3_1, 0x193ec60)
    FIELD(POR_MPU_M7_PRBAR5_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR5_U_SMXP_3_1, REGION5_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR5_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR5_U_SMXP_3_1, REGION5_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR5_U_SMXP_3_1, REGION5_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR5_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR5_U_SMXP_3_1, 0x193ec68)
    FIELD(POR_MPU_M7_PRLAR5_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR5_U_SMXP_3_1, REGION5_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR5_U_SMXP_3_1, REGION5_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR6_U_SMXP_3_1, 0x193ec70)
    FIELD(POR_MPU_M7_PRBAR6_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR6_U_SMXP_3_1, REGION6_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR6_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR6_U_SMXP_3_1, REGION6_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR6_U_SMXP_3_1, REGION6_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR6_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR6_U_SMXP_3_1, 0x193ec78)
    FIELD(POR_MPU_M7_PRLAR6_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR6_U_SMXP_3_1, REGION6_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR6_U_SMXP_3_1, REGION6_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR7_U_SMXP_3_1, 0x193ec80)
    FIELD(POR_MPU_M7_PRBAR7_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR7_U_SMXP_3_1, REGION7_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR7_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR7_U_SMXP_3_1, REGION7_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR7_U_SMXP_3_1, REGION7_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR7_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR7_U_SMXP_3_1, 0x193ec88)
    FIELD(POR_MPU_M7_PRLAR7_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR7_U_SMXP_3_1, REGION7_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR7_U_SMXP_3_1, REGION7_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR8_U_SMXP_3_1, 0x193ec90)
    FIELD(POR_MPU_M7_PRBAR8_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR8_U_SMXP_3_1, REGION8_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR8_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR8_U_SMXP_3_1, REGION8_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR8_U_SMXP_3_1, REGION8_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR8_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR8_U_SMXP_3_1, 0x193ec98)
    FIELD(POR_MPU_M7_PRLAR8_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR8_U_SMXP_3_1, REGION8_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR8_U_SMXP_3_1, REGION8_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR9_U_SMXP_3_1, 0x193eca0)
    FIELD(POR_MPU_M7_PRBAR9_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR9_U_SMXP_3_1, REGION9_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR9_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR9_U_SMXP_3_1, REGION9_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR9_U_SMXP_3_1, REGION9_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR9_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR9_U_SMXP_3_1, 0x193eca8)
    FIELD(POR_MPU_M7_PRLAR9_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR9_U_SMXP_3_1, REGION9_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR9_U_SMXP_3_1, REGION9_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR10_U_SMXP_3_1, 0x193ecb0)
    FIELD(POR_MPU_M7_PRBAR10_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR10_U_SMXP_3_1, REGION10_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR10_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR10_U_SMXP_3_1, REGION10_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR10_U_SMXP_3_1, REGION10_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR10_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR10_U_SMXP_3_1, 0x193ecb8)
    FIELD(POR_MPU_M7_PRLAR10_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR10_U_SMXP_3_1, REGION10_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR10_U_SMXP_3_1, REGION10_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR11_U_SMXP_3_1, 0x193ecc0)
    FIELD(POR_MPU_M7_PRBAR11_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR11_U_SMXP_3_1, REGION11_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR11_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR11_U_SMXP_3_1, REGION11_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR11_U_SMXP_3_1, REGION11_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR11_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR11_U_SMXP_3_1, 0x193ecc8)
    FIELD(POR_MPU_M7_PRLAR11_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR11_U_SMXP_3_1, REGION11_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR11_U_SMXP_3_1, REGION11_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR12_U_SMXP_3_1, 0x193ecd0)
    FIELD(POR_MPU_M7_PRBAR12_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR12_U_SMXP_3_1, REGION12_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR12_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR12_U_SMXP_3_1, REGION12_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR12_U_SMXP_3_1, REGION12_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR12_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR12_U_SMXP_3_1, 0x193ecd8)
    FIELD(POR_MPU_M7_PRLAR12_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR12_U_SMXP_3_1, REGION12_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR12_U_SMXP_3_1, REGION12_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR13_U_SMXP_3_1, 0x193ece0)
    FIELD(POR_MPU_M7_PRBAR13_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR13_U_SMXP_3_1, REGION13_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR13_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR13_U_SMXP_3_1, REGION13_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR13_U_SMXP_3_1, REGION13_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR13_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR13_U_SMXP_3_1, 0x193ece8)
    FIELD(POR_MPU_M7_PRLAR13_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR13_U_SMXP_3_1, REGION13_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR13_U_SMXP_3_1, REGION13_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR14_U_SMXP_3_1, 0x193ecf0)
    FIELD(POR_MPU_M7_PRBAR14_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR14_U_SMXP_3_1, REGION14_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR14_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR14_U_SMXP_3_1, REGION14_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR14_U_SMXP_3_1, REGION14_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR14_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR14_U_SMXP_3_1, 0x193ecf8)
    FIELD(POR_MPU_M7_PRLAR14_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR14_U_SMXP_3_1, REGION14_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR14_U_SMXP_3_1, REGION14_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR15_U_SMXP_3_1, 0x193ed00)
    FIELD(POR_MPU_M7_PRBAR15_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR15_U_SMXP_3_1, REGION15_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR15_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR15_U_SMXP_3_1, REGION15_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR15_U_SMXP_3_1, REGION15_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR15_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR15_U_SMXP_3_1, 0x193ed08)
    FIELD(POR_MPU_M7_PRLAR15_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR15_U_SMXP_3_1, REGION15_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR15_U_SMXP_3_1, REGION15_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR16_U_SMXP_3_1, 0x193ed10)
    FIELD(POR_MPU_M7_PRBAR16_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR16_U_SMXP_3_1, REGION16_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR16_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR16_U_SMXP_3_1, REGION16_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR16_U_SMXP_3_1, REGION16_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR16_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR16_U_SMXP_3_1, 0x193ed18)
    FIELD(POR_MPU_M7_PRLAR16_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR16_U_SMXP_3_1, REGION16_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR16_U_SMXP_3_1, REGION16_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR17_U_SMXP_3_1, 0x193ed20)
    FIELD(POR_MPU_M7_PRBAR17_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR17_U_SMXP_3_1, REGION17_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR17_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR17_U_SMXP_3_1, REGION17_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR17_U_SMXP_3_1, REGION17_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR17_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR17_U_SMXP_3_1, 0x193ed28)
    FIELD(POR_MPU_M7_PRLAR17_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR17_U_SMXP_3_1, REGION17_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR17_U_SMXP_3_1, REGION17_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR18_U_SMXP_3_1, 0x193ed30)
    FIELD(POR_MPU_M7_PRBAR18_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR18_U_SMXP_3_1, REGION18_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR18_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR18_U_SMXP_3_1, REGION18_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR18_U_SMXP_3_1, REGION18_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR18_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR18_U_SMXP_3_1, 0x193ed38)
    FIELD(POR_MPU_M7_PRLAR18_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR18_U_SMXP_3_1, REGION18_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR18_U_SMXP_3_1, REGION18_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR19_U_SMXP_3_1, 0x193ed40)
    FIELD(POR_MPU_M7_PRBAR19_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR19_U_SMXP_3_1, REGION19_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR19_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR19_U_SMXP_3_1, REGION19_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR19_U_SMXP_3_1, REGION19_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR19_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR19_U_SMXP_3_1, 0x193ed48)
    FIELD(POR_MPU_M7_PRLAR19_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR19_U_SMXP_3_1, REGION19_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR19_U_SMXP_3_1, REGION19_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR20_U_SMXP_3_1, 0x193ed50)
    FIELD(POR_MPU_M7_PRBAR20_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR20_U_SMXP_3_1, REGION20_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR20_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR20_U_SMXP_3_1, REGION20_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR20_U_SMXP_3_1, REGION20_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR20_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR20_U_SMXP_3_1, 0x193ed58)
    FIELD(POR_MPU_M7_PRLAR20_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR20_U_SMXP_3_1, REGION20_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR20_U_SMXP_3_1, REGION20_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR21_U_SMXP_3_1, 0x193ed60)
    FIELD(POR_MPU_M7_PRBAR21_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR21_U_SMXP_3_1, REGION21_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR21_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR21_U_SMXP_3_1, REGION21_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR21_U_SMXP_3_1, REGION21_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR21_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR21_U_SMXP_3_1, 0x193ed68)
    FIELD(POR_MPU_M7_PRLAR21_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR21_U_SMXP_3_1, REGION21_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR21_U_SMXP_3_1, REGION21_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR22_U_SMXP_3_1, 0x193ed70)
    FIELD(POR_MPU_M7_PRBAR22_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR22_U_SMXP_3_1, REGION22_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR22_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR22_U_SMXP_3_1, REGION22_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR22_U_SMXP_3_1, REGION22_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR22_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR22_U_SMXP_3_1, 0x193ed78)
    FIELD(POR_MPU_M7_PRLAR22_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR22_U_SMXP_3_1, REGION22_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR22_U_SMXP_3_1, REGION22_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR23_U_SMXP_3_1, 0x193ed80)
    FIELD(POR_MPU_M7_PRBAR23_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR23_U_SMXP_3_1, REGION23_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR23_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR23_U_SMXP_3_1, REGION23_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR23_U_SMXP_3_1, REGION23_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR23_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR23_U_SMXP_3_1, 0x193ed88)
    FIELD(POR_MPU_M7_PRLAR23_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR23_U_SMXP_3_1, REGION23_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR23_U_SMXP_3_1, REGION23_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR24_U_SMXP_3_1, 0x193ed90)
    FIELD(POR_MPU_M7_PRBAR24_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR24_U_SMXP_3_1, REGION24_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR24_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR24_U_SMXP_3_1, REGION24_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR24_U_SMXP_3_1, REGION24_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR24_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR24_U_SMXP_3_1, 0x193ed98)
    FIELD(POR_MPU_M7_PRLAR24_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR24_U_SMXP_3_1, REGION24_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR24_U_SMXP_3_1, REGION24_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR25_U_SMXP_3_1, 0x193eda0)
    FIELD(POR_MPU_M7_PRBAR25_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR25_U_SMXP_3_1, REGION25_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR25_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR25_U_SMXP_3_1, REGION25_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR25_U_SMXP_3_1, REGION25_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR25_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR25_U_SMXP_3_1, 0x193eda8)
    FIELD(POR_MPU_M7_PRLAR25_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR25_U_SMXP_3_1, REGION25_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR25_U_SMXP_3_1, REGION25_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR26_U_SMXP_3_1, 0x193edb0)
    FIELD(POR_MPU_M7_PRBAR26_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR26_U_SMXP_3_1, REGION26_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR26_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR26_U_SMXP_3_1, REGION26_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR26_U_SMXP_3_1, REGION26_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR26_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR26_U_SMXP_3_1, 0x193edb8)
    FIELD(POR_MPU_M7_PRLAR26_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR26_U_SMXP_3_1, REGION26_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR26_U_SMXP_3_1, REGION26_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR27_U_SMXP_3_1, 0x193edc0)
    FIELD(POR_MPU_M7_PRBAR27_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR27_U_SMXP_3_1, REGION27_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR27_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR27_U_SMXP_3_1, REGION27_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR27_U_SMXP_3_1, REGION27_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR27_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR27_U_SMXP_3_1, 0x193edc8)
    FIELD(POR_MPU_M7_PRLAR27_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR27_U_SMXP_3_1, REGION27_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR27_U_SMXP_3_1, REGION27_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR28_U_SMXP_3_1, 0x193edd0)
    FIELD(POR_MPU_M7_PRBAR28_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR28_U_SMXP_3_1, REGION28_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR28_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR28_U_SMXP_3_1, REGION28_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR28_U_SMXP_3_1, REGION28_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR28_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR28_U_SMXP_3_1, 0x193edd8)
    FIELD(POR_MPU_M7_PRLAR28_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR28_U_SMXP_3_1, REGION28_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR28_U_SMXP_3_1, REGION28_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR29_U_SMXP_3_1, 0x193ede0)
    FIELD(POR_MPU_M7_PRBAR29_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR29_U_SMXP_3_1, REGION29_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR29_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR29_U_SMXP_3_1, REGION29_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR29_U_SMXP_3_1, REGION29_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR29_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR29_U_SMXP_3_1, 0x193ede8)
    FIELD(POR_MPU_M7_PRLAR29_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR29_U_SMXP_3_1, REGION29_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR29_U_SMXP_3_1, REGION29_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR30_U_SMXP_3_1, 0x193edf0)
    FIELD(POR_MPU_M7_PRBAR30_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR30_U_SMXP_3_1, REGION30_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR30_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR30_U_SMXP_3_1, REGION30_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR30_U_SMXP_3_1, REGION30_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR30_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR30_U_SMXP_3_1, 0x193edf8)
    FIELD(POR_MPU_M7_PRLAR30_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR30_U_SMXP_3_1, REGION30_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR30_U_SMXP_3_1, REGION30_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR31_U_SMXP_3_1, 0x193ee00)
    FIELD(POR_MPU_M7_PRBAR31_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR31_U_SMXP_3_1, REGION31_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR31_U_SMXP_3_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR31_U_SMXP_3_1, REGION31_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR31_U_SMXP_3_1, REGION31_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR31_U_SMXP_3_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR31_U_SMXP_3_1, 0x193ee08)
    FIELD(POR_MPU_M7_PRLAR31_U_SMXP_3_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR31_U_SMXP_3_1, REGION31_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR31_U_SMXP_3_1, REGION31_EN, 0, 1)
REG32(POR_RNSAM_NODE_INFO_U_RNFBESAM_NID204, 0x1968000)
    FIELD(POR_RNSAM_NODE_INFO_U_RNFBESAM_NID204, RESERVED_48, 48, 16)
    FIELD(POR_RNSAM_NODE_INFO_U_RNFBESAM_NID204, LOGICAL_ID, 32, 16)
    FIELD(POR_RNSAM_NODE_INFO_U_RNFBESAM_NID204, NODE_ID, 16, 16)
    FIELD(POR_RNSAM_NODE_INFO_U_RNFBESAM_NID204, NODE_TYPE, 0, 16)
REG32(POR_RNSAM_CHILD_INFO_U_RNFBESAM_NID204, 0x1968080)
    FIELD(POR_RNSAM_CHILD_INFO_U_RNFBESAM_NID204, RESERVED_32, 32, 32)
    FIELD(POR_RNSAM_CHILD_INFO_U_RNFBESAM_NID204, CHILD_PTR_OFFSET, 16, 16)
    FIELD(POR_RNSAM_CHILD_INFO_U_RNFBESAM_NID204, CHILD_COUNT, 0, 16)
REG32(POR_RNSAM_UNIT_INFO_U_RNFBESAM_NID204, 0x1968900)
    FIELD(POR_RNSAM_UNIT_INFO_U_RNFBESAM_NID204, RESERVED_37, 37, 27)
    FIELD(POR_RNSAM_UNIT_INFO_U_RNFBESAM_NID204, NUM_NON_HASH_GROUP, 32, 5)
    FIELD(POR_RNSAM_UNIT_INFO_U_RNFBESAM_NID204, RESERVED_20, 20, 12)
    FIELD(POR_RNSAM_UNIT_INFO_U_RNFBESAM_NID204, NUM_SYS_CACHE_GROUP, 16, 4)
    FIELD(POR_RNSAM_UNIT_INFO_U_RNFBESAM_NID204, NUM_HNF, 0, 8)
REG32(POR_RNSAM_SECURE_REGISTER_GROUPS_OVERRIDE_U_RNFBESAM_NID204, 0x1968980)
    FIELD(POR_RNSAM_SECURE_REGISTER_GROUPS_OVERRIDE_U_RNFBESAM_NID204, MEM_RANGE, 0, 1)
REG32(RNSAM_STATUS_U_RNFBESAM_NID204, 0x1968c00)
    FIELD(RNSAM_STATUS_U_RNFBESAM_NID204, NSTALL_REQ, 1, 1)
    FIELD(RNSAM_STATUS_U_RNFBESAM_NID204, USE_DEFAULT_NODE, 0, 1)
REG32(NON_HASH_MEM_REGION_REG0_U_RNFBESAM_NID204, 0x1968c08)
    FIELD(NON_HASH_MEM_REGION_REG0_U_RNFBESAM_NID204, RESERVED_63, 63, 1)
    FIELD(NON_HASH_MEM_REGION_REG0_U_RNFBESAM_NID204, REGION1_BASE_ADDR, 41, 22)
    FIELD(NON_HASH_MEM_REGION_REG0_U_RNFBESAM_NID204, REGION1_SIZE, 36, 5)
    FIELD(NON_HASH_MEM_REGION_REG0_U_RNFBESAM_NID204, REGION1_TARGET_TYPE, 34, 2)
    FIELD(NON_HASH_MEM_REGION_REG0_U_RNFBESAM_NID204, RESERVED_33, 33, 1)
    FIELD(NON_HASH_MEM_REGION_REG0_U_RNFBESAM_NID204, REGION1_VALID, 32, 1)
    FIELD(NON_HASH_MEM_REGION_REG0_U_RNFBESAM_NID204, RESERVED_31, 31, 1)
    FIELD(NON_HASH_MEM_REGION_REG0_U_RNFBESAM_NID204, REGION0_BASE_ADDR, 9, 22)
    FIELD(NON_HASH_MEM_REGION_REG0_U_RNFBESAM_NID204, REGION0_SIZE, 4, 5)
    FIELD(NON_HASH_MEM_REGION_REG0_U_RNFBESAM_NID204, REGION0_TARGET_TYPE, 2, 2)
    FIELD(NON_HASH_MEM_REGION_REG0_U_RNFBESAM_NID204, REGION0_VALID, 0, 1)
REG32(NON_HASH_MEM_REGION_REG1_U_RNFBESAM_NID204, 0x1968c10)
    FIELD(NON_HASH_MEM_REGION_REG1_U_RNFBESAM_NID204, RESERVED_63, 63, 1)
    FIELD(NON_HASH_MEM_REGION_REG1_U_RNFBESAM_NID204, REGION3_BASE_ADDR, 41, 22)
    FIELD(NON_HASH_MEM_REGION_REG1_U_RNFBESAM_NID204, REGION3_SIZE, 36, 5)
    FIELD(NON_HASH_MEM_REGION_REG1_U_RNFBESAM_NID204, REGION3_TARGET_TYPE, 34, 2)
    FIELD(NON_HASH_MEM_REGION_REG1_U_RNFBESAM_NID204, RESERVED_33, 33, 1)
    FIELD(NON_HASH_MEM_REGION_REG1_U_RNFBESAM_NID204, REGION3_VALID, 32, 1)
    FIELD(NON_HASH_MEM_REGION_REG1_U_RNFBESAM_NID204, RESERVED_31, 31, 1)
    FIELD(NON_HASH_MEM_REGION_REG1_U_RNFBESAM_NID204, REGION2_BASE_ADDR, 9, 22)
    FIELD(NON_HASH_MEM_REGION_REG1_U_RNFBESAM_NID204, REGION2_SIZE, 4, 5)
    FIELD(NON_HASH_MEM_REGION_REG1_U_RNFBESAM_NID204, REGION2_TARGET_TYPE, 2, 2)
    FIELD(NON_HASH_MEM_REGION_REG1_U_RNFBESAM_NID204, REGION2_VALID, 0, 1)
REG32(NON_HASH_MEM_REGION_REG2_U_RNFBESAM_NID204, 0x1968c18)
    FIELD(NON_HASH_MEM_REGION_REG2_U_RNFBESAM_NID204, RESERVED_63, 63, 1)
    FIELD(NON_HASH_MEM_REGION_REG2_U_RNFBESAM_NID204, REGION5_BASE_ADDR, 41, 22)
    FIELD(NON_HASH_MEM_REGION_REG2_U_RNFBESAM_NID204, REGION5_SIZE, 36, 5)
    FIELD(NON_HASH_MEM_REGION_REG2_U_RNFBESAM_NID204, REGION5_TARGET_TYPE, 34, 2)
    FIELD(NON_HASH_MEM_REGION_REG2_U_RNFBESAM_NID204, RESERVED_33, 33, 1)
    FIELD(NON_HASH_MEM_REGION_REG2_U_RNFBESAM_NID204, REGION5_VALID, 32, 1)
    FIELD(NON_HASH_MEM_REGION_REG2_U_RNFBESAM_NID204, RESERVED_31, 31, 1)
    FIELD(NON_HASH_MEM_REGION_REG2_U_RNFBESAM_NID204, REGION4_BASE_ADDR, 9, 22)
    FIELD(NON_HASH_MEM_REGION_REG2_U_RNFBESAM_NID204, REGION4_SIZE, 4, 5)
    FIELD(NON_HASH_MEM_REGION_REG2_U_RNFBESAM_NID204, REGION4_TARGET_TYPE, 2, 2)
    FIELD(NON_HASH_MEM_REGION_REG2_U_RNFBESAM_NID204, REGION4_VALID, 0, 1)
REG32(NON_HASH_MEM_REGION_REG3_U_RNFBESAM_NID204, 0x1968c20)
    FIELD(NON_HASH_MEM_REGION_REG3_U_RNFBESAM_NID204, RESERVED_63, 63, 1)
    FIELD(NON_HASH_MEM_REGION_REG3_U_RNFBESAM_NID204, REGION7_BASE_ADDR, 41, 22)
    FIELD(NON_HASH_MEM_REGION_REG3_U_RNFBESAM_NID204, REGION7_SIZE, 36, 5)
    FIELD(NON_HASH_MEM_REGION_REG3_U_RNFBESAM_NID204, REGION7_TARGET_TYPE, 34, 2)
    FIELD(NON_HASH_MEM_REGION_REG3_U_RNFBESAM_NID204, RESERVED_33, 33, 1)
    FIELD(NON_HASH_MEM_REGION_REG3_U_RNFBESAM_NID204, REGION7_VALID, 32, 1)
    FIELD(NON_HASH_MEM_REGION_REG3_U_RNFBESAM_NID204, RESERVED_31, 31, 1)
    FIELD(NON_HASH_MEM_REGION_REG3_U_RNFBESAM_NID204, REGION6_BASE_ADDR, 9, 22)
    FIELD(NON_HASH_MEM_REGION_REG3_U_RNFBESAM_NID204, REGION6_SIZE, 4, 5)
    FIELD(NON_HASH_MEM_REGION_REG3_U_RNFBESAM_NID204, REGION6_TARGET_TYPE, 2, 2)
    FIELD(NON_HASH_MEM_REGION_REG3_U_RNFBESAM_NID204, REGION6_VALID, 0, 1)
REG32(NON_HASH_TGT_NODEID0_U_RNFBESAM_NID204, 0x1968c30)
    FIELD(NON_HASH_TGT_NODEID0_U_RNFBESAM_NID204, RESERVED_47, 47, 17)
    FIELD(NON_HASH_TGT_NODEID0_U_RNFBESAM_NID204, NODEID_3, 36, 11)
    FIELD(NON_HASH_TGT_NODEID0_U_RNFBESAM_NID204, RESERVED_35, 35, 1)
    FIELD(NON_HASH_TGT_NODEID0_U_RNFBESAM_NID204, NODEID_2, 24, 11)
    FIELD(NON_HASH_TGT_NODEID0_U_RNFBESAM_NID204, RESERVED_23, 23, 1)
    FIELD(NON_HASH_TGT_NODEID0_U_RNFBESAM_NID204, NODEID_1, 12, 11)
    FIELD(NON_HASH_TGT_NODEID0_U_RNFBESAM_NID204, RESERVED_11, 11, 1)
    FIELD(NON_HASH_TGT_NODEID0_U_RNFBESAM_NID204, NODEID_0, 0, 11)
REG32(NON_HASH_TGT_NODEID1_U_RNFBESAM_NID204, 0x1968c38)
    FIELD(NON_HASH_TGT_NODEID1_U_RNFBESAM_NID204, RESERVED_47, 47, 17)
    FIELD(NON_HASH_TGT_NODEID1_U_RNFBESAM_NID204, NODEID_7, 36, 11)
    FIELD(NON_HASH_TGT_NODEID1_U_RNFBESAM_NID204, RESERVED_35, 35, 1)
    FIELD(NON_HASH_TGT_NODEID1_U_RNFBESAM_NID204, NODEID_6, 24, 11)
    FIELD(NON_HASH_TGT_NODEID1_U_RNFBESAM_NID204, RESERVED_23, 23, 1)
    FIELD(NON_HASH_TGT_NODEID1_U_RNFBESAM_NID204, NODEID_5, 12, 11)
    FIELD(NON_HASH_TGT_NODEID1_U_RNFBESAM_NID204, RESERVED_11, 11, 1)
    FIELD(NON_HASH_TGT_NODEID1_U_RNFBESAM_NID204, NODEID_4, 0, 11)
REG32(NON_HASH_TGT_NODEID2_U_RNFBESAM_NID204, 0x1968c40)
    FIELD(NON_HASH_TGT_NODEID2_U_RNFBESAM_NID204, RESERVED_23, 23, 41)
    FIELD(NON_HASH_TGT_NODEID2_U_RNFBESAM_NID204, NODEID_9, 12, 11)
    FIELD(NON_HASH_TGT_NODEID2_U_RNFBESAM_NID204, RESERVED_11, 11, 1)
    FIELD(NON_HASH_TGT_NODEID2_U_RNFBESAM_NID204, NODEID_8, 0, 11)
REG32(SYS_CACHE_GRP_REGION0_U_RNFBESAM_NID204, 0x1968c48)
    FIELD(SYS_CACHE_GRP_REGION0_U_RNFBESAM_NID204, RESERVED_63, 63, 1)
    FIELD(SYS_CACHE_GRP_REGION0_U_RNFBESAM_NID204, REGION1_BASE_ADDR, 41, 22)
    FIELD(SYS_CACHE_GRP_REGION0_U_RNFBESAM_NID204, REGION1_SIZE, 36, 5)
    FIELD(SYS_CACHE_GRP_REGION0_U_RNFBESAM_NID204, REGION1_TARGET_TYPE, 34, 2)
    FIELD(SYS_CACHE_GRP_REGION0_U_RNFBESAM_NID204, REGION1_NONHASH_REG_EN, 33, 1)
    FIELD(SYS_CACHE_GRP_REGION0_U_RNFBESAM_NID204, REGION1_VALID, 32, 1)
    FIELD(SYS_CACHE_GRP_REGION0_U_RNFBESAM_NID204, RESERVED_31, 31, 1)
    FIELD(SYS_CACHE_GRP_REGION0_U_RNFBESAM_NID204, REGION0_BASE_ADDR, 9, 22)
    FIELD(SYS_CACHE_GRP_REGION0_U_RNFBESAM_NID204, REGION0_SIZE, 4, 5)
    FIELD(SYS_CACHE_GRP_REGION0_U_RNFBESAM_NID204, REGION0_TARGET_TYPE, 2, 2)
    FIELD(SYS_CACHE_GRP_REGION0_U_RNFBESAM_NID204, REGION0_VALID, 0, 1)
REG32(SYS_CACHE_GRP_REGION1_U_RNFBESAM_NID204, 0x1968c50)
    FIELD(SYS_CACHE_GRP_REGION1_U_RNFBESAM_NID204, RESERVED_63, 63, 1)
    FIELD(SYS_CACHE_GRP_REGION1_U_RNFBESAM_NID204, REGION3_BASE_ADDR, 41, 22)
    FIELD(SYS_CACHE_GRP_REGION1_U_RNFBESAM_NID204, REGION3_SIZE, 36, 5)
    FIELD(SYS_CACHE_GRP_REGION1_U_RNFBESAM_NID204, REGION3_TARGET_TYPE, 34, 2)
    FIELD(SYS_CACHE_GRP_REGION1_U_RNFBESAM_NID204, REGION3_NONHASH_REG_EN, 33, 1)
    FIELD(SYS_CACHE_GRP_REGION1_U_RNFBESAM_NID204, REGION3_VALID, 32, 1)
    FIELD(SYS_CACHE_GRP_REGION1_U_RNFBESAM_NID204, RESERVED_31, 31, 1)
    FIELD(SYS_CACHE_GRP_REGION1_U_RNFBESAM_NID204, REGION2_BASE_ADDR, 9, 22)
    FIELD(SYS_CACHE_GRP_REGION1_U_RNFBESAM_NID204, REGION2_SIZE, 4, 5)
    FIELD(SYS_CACHE_GRP_REGION1_U_RNFBESAM_NID204, REGION2_TARGET_TYPE, 2, 2)
    FIELD(SYS_CACHE_GRP_REGION1_U_RNFBESAM_NID204, REGION2_NONHASH_REG_EN, 1, 1)
    FIELD(SYS_CACHE_GRP_REGION1_U_RNFBESAM_NID204, REGION2_VALID, 0, 1)
REG32(SYS_CACHE_GRP_HN_NODEID_REG0_U_RNFBESAM_NID204, 0x1968c58)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG0_U_RNFBESAM_NID204, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG0_U_RNFBESAM_NID204, NODEID_3, 36, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG0_U_RNFBESAM_NID204, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG0_U_RNFBESAM_NID204, NODEID_2, 24, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG0_U_RNFBESAM_NID204, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG0_U_RNFBESAM_NID204, NODEID_1, 12, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG0_U_RNFBESAM_NID204, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG0_U_RNFBESAM_NID204, NODEID_0, 0, 11)
REG32(SYS_CACHE_GRP_HN_NODEID_REG1_U_RNFBESAM_NID204, 0x1968c60)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG1_U_RNFBESAM_NID204, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG1_U_RNFBESAM_NID204, NODEID_7, 36, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG1_U_RNFBESAM_NID204, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG1_U_RNFBESAM_NID204, NODEID_6, 24, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG1_U_RNFBESAM_NID204, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG1_U_RNFBESAM_NID204, NODEID_5, 12, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG1_U_RNFBESAM_NID204, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG1_U_RNFBESAM_NID204, NODEID_4, 0, 11)
REG32(SYS_CACHE_GRP_HN_NODEID_REG2_U_RNFBESAM_NID204, 0x1968c68)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG2_U_RNFBESAM_NID204, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG2_U_RNFBESAM_NID204, NODEID_11, 36, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG2_U_RNFBESAM_NID204, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG2_U_RNFBESAM_NID204, NODEID_10, 24, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG2_U_RNFBESAM_NID204, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG2_U_RNFBESAM_NID204, NODEID_9, 12, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG2_U_RNFBESAM_NID204, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG2_U_RNFBESAM_NID204, NODEID_8, 0, 11)
REG32(SYS_CACHE_GRP_HN_NODEID_REG3_U_RNFBESAM_NID204, 0x1968c70)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG3_U_RNFBESAM_NID204, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG3_U_RNFBESAM_NID204, NODEID_15, 36, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG3_U_RNFBESAM_NID204, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG3_U_RNFBESAM_NID204, NODEID_14, 24, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG3_U_RNFBESAM_NID204, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG3_U_RNFBESAM_NID204, NODEID_13, 12, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG3_U_RNFBESAM_NID204, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG3_U_RNFBESAM_NID204, NODEID_12, 0, 11)
REG32(SYS_CACHE_GRP_HN_NODEID_REG4_U_RNFBESAM_NID204, 0x1968c78)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG4_U_RNFBESAM_NID204, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG4_U_RNFBESAM_NID204, NODEID_19, 36, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG4_U_RNFBESAM_NID204, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG4_U_RNFBESAM_NID204, NODEID_18, 24, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG4_U_RNFBESAM_NID204, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG4_U_RNFBESAM_NID204, NODEID_17, 12, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG4_U_RNFBESAM_NID204, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG4_U_RNFBESAM_NID204, NODEID_16, 0, 11)
REG32(SYS_CACHE_GRP_HN_NODEID_REG5_U_RNFBESAM_NID204, 0x1968c80)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG5_U_RNFBESAM_NID204, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG5_U_RNFBESAM_NID204, NODEID_23, 36, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG5_U_RNFBESAM_NID204, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG5_U_RNFBESAM_NID204, NODEID_22, 24, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG5_U_RNFBESAM_NID204, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG5_U_RNFBESAM_NID204, NODEID_21, 12, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG5_U_RNFBESAM_NID204, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG5_U_RNFBESAM_NID204, NODEID_20, 0, 11)
REG32(SYS_CACHE_GRP_HN_NODEID_REG6_U_RNFBESAM_NID204, 0x1968c88)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG6_U_RNFBESAM_NID204, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG6_U_RNFBESAM_NID204, NODEID_27, 36, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG6_U_RNFBESAM_NID204, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG6_U_RNFBESAM_NID204, NODEID_26, 24, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG6_U_RNFBESAM_NID204, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG6_U_RNFBESAM_NID204, NODEID_25, 12, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG6_U_RNFBESAM_NID204, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG6_U_RNFBESAM_NID204, NODEID_24, 0, 11)
REG32(SYS_CACHE_GRP_HN_NODEID_REG7_U_RNFBESAM_NID204, 0x1968c90)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG7_U_RNFBESAM_NID204, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG7_U_RNFBESAM_NID204, NODEID_31, 36, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG7_U_RNFBESAM_NID204, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG7_U_RNFBESAM_NID204, NODEID_30, 24, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG7_U_RNFBESAM_NID204, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG7_U_RNFBESAM_NID204, NODEID_29, 12, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG7_U_RNFBESAM_NID204, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG7_U_RNFBESAM_NID204, NODEID_28, 0, 11)
REG32(SYS_CACHE_GRP_NONHASH_NODEID_U_RNFBESAM_NID204, 0x1968c98)
    FIELD(SYS_CACHE_GRP_NONHASH_NODEID_U_RNFBESAM_NID204, RESERVED_35, 35, 29)
    FIELD(SYS_CACHE_GRP_NONHASH_NODEID_U_RNFBESAM_NID204, SCG3_NODEID, 24, 11)
    FIELD(SYS_CACHE_GRP_NONHASH_NODEID_U_RNFBESAM_NID204, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_NONHASH_NODEID_U_RNFBESAM_NID204, SCG2_NODEID, 12, 11)
    FIELD(SYS_CACHE_GRP_NONHASH_NODEID_U_RNFBESAM_NID204, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_NONHASH_NODEID_U_RNFBESAM_NID204, SCG1_NODEID, 0, 11)
REG32(SYS_CACHE_GROUP_HN_COUNT_U_RNFBESAM_NID204, 0x1968d00)
    FIELD(SYS_CACHE_GROUP_HN_COUNT_U_RNFBESAM_NID204, RESERVED_31, 31, 33)
    FIELD(SYS_CACHE_GROUP_HN_COUNT_U_RNFBESAM_NID204, SCG3_NUM_HNF, 24, 7)
    FIELD(SYS_CACHE_GROUP_HN_COUNT_U_RNFBESAM_NID204, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GROUP_HN_COUNT_U_RNFBESAM_NID204, SCG2_NUM_HNF, 16, 7)
    FIELD(SYS_CACHE_GROUP_HN_COUNT_U_RNFBESAM_NID204, RESERVED_15, 15, 1)
    FIELD(SYS_CACHE_GROUP_HN_COUNT_U_RNFBESAM_NID204, SCG1_NUM_HNF, 8, 7)
    FIELD(SYS_CACHE_GROUP_HN_COUNT_U_RNFBESAM_NID204, SCG0_NUM_HNF, 0, 7)
REG32(SYS_CACHE_GRP_SN_NODEID_REG0_U_RNFBESAM_NID204, 0x1968d08)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG0_U_RNFBESAM_NID204, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG0_U_RNFBESAM_NID204, SN_NODEID_3, 36, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG0_U_RNFBESAM_NID204, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG0_U_RNFBESAM_NID204, SN_NODEID_2, 24, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG0_U_RNFBESAM_NID204, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG0_U_RNFBESAM_NID204, SN_NODEID_1, 12, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG0_U_RNFBESAM_NID204, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG0_U_RNFBESAM_NID204, SN_NODEID_0, 0, 11)
REG32(SYS_CACHE_GRP_SN_NODEID_REG1_U_RNFBESAM_NID204, 0x1968d10)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG1_U_RNFBESAM_NID204, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG1_U_RNFBESAM_NID204, SN_NODEID_7, 36, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG1_U_RNFBESAM_NID204, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG1_U_RNFBESAM_NID204, SN_NODEID_6, 24, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG1_U_RNFBESAM_NID204, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG1_U_RNFBESAM_NID204, SN_NODEID_5, 12, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG1_U_RNFBESAM_NID204, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG1_U_RNFBESAM_NID204, SN_NODEID_4, 0, 11)
REG32(SYS_CACHE_GRP_SN_NODEID_REG2_U_RNFBESAM_NID204, 0x1968d18)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG2_U_RNFBESAM_NID204, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG2_U_RNFBESAM_NID204, SN_NODEID_11, 36, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG2_U_RNFBESAM_NID204, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG2_U_RNFBESAM_NID204, SN_NODEID_10, 24, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG2_U_RNFBESAM_NID204, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG2_U_RNFBESAM_NID204, SN_NODEID_9, 12, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG2_U_RNFBESAM_NID204, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG2_U_RNFBESAM_NID204, SN_NODEID_8, 0, 11)
REG32(SYS_CACHE_GRP_SN_NODEID_REG3_U_RNFBESAM_NID204, 0x1968d20)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG3_U_RNFBESAM_NID204, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG3_U_RNFBESAM_NID204, SN_NODEID_15, 36, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG3_U_RNFBESAM_NID204, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG3_U_RNFBESAM_NID204, SN_NODEID_14, 24, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG3_U_RNFBESAM_NID204, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG3_U_RNFBESAM_NID204, SN_NODEID_13, 12, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG3_U_RNFBESAM_NID204, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG3_U_RNFBESAM_NID204, SN_NODEID_12, 0, 11)
REG32(SYS_CACHE_GRP_SN_NODEID_REG4_U_RNFBESAM_NID204, 0x1968d28)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG4_U_RNFBESAM_NID204, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG4_U_RNFBESAM_NID204, SN_NODEID_19, 36, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG4_U_RNFBESAM_NID204, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG4_U_RNFBESAM_NID204, SN_NODEID_18, 24, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG4_U_RNFBESAM_NID204, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG4_U_RNFBESAM_NID204, SN_NODEID_17, 12, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG4_U_RNFBESAM_NID204, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG4_U_RNFBESAM_NID204, SN_NODEID_16, 0, 11)
REG32(SYS_CACHE_GRP_SN_NODEID_REG5_U_RNFBESAM_NID204, 0x1968d30)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG5_U_RNFBESAM_NID204, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG5_U_RNFBESAM_NID204, SN_NODEID_23, 36, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG5_U_RNFBESAM_NID204, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG5_U_RNFBESAM_NID204, SN_NODEID_22, 24, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG5_U_RNFBESAM_NID204, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG5_U_RNFBESAM_NID204, SN_NODEID_21, 12, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG5_U_RNFBESAM_NID204, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG5_U_RNFBESAM_NID204, SN_NODEID_20, 0, 11)
REG32(SYS_CACHE_GRP_SN_NODEID_REG6_U_RNFBESAM_NID204, 0x1968d38)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG6_U_RNFBESAM_NID204, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG6_U_RNFBESAM_NID204, SN_NODEID_27, 36, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG6_U_RNFBESAM_NID204, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG6_U_RNFBESAM_NID204, SN_NODEID_26, 24, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG6_U_RNFBESAM_NID204, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG6_U_RNFBESAM_NID204, SN_NODEID_25, 12, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG6_U_RNFBESAM_NID204, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG6_U_RNFBESAM_NID204, SN_NODEID_24, 0, 11)
REG32(SYS_CACHE_GRP_SN_NODEID_REG7_U_RNFBESAM_NID204, 0x1968d40)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG7_U_RNFBESAM_NID204, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG7_U_RNFBESAM_NID204, SN_NODEID_31, 36, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG7_U_RNFBESAM_NID204, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG7_U_RNFBESAM_NID204, SN_NODEID_30, 24, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG7_U_RNFBESAM_NID204, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG7_U_RNFBESAM_NID204, SN_NODEID_29, 12, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG7_U_RNFBESAM_NID204, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG7_U_RNFBESAM_NID204, SN_NODEID_28, 0, 11)
REG32(SYS_CACHE_GRP_SN_SAM_CFG0_U_RNFBESAM_NID204, 0x1968d48)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG0_U_RNFBESAM_NID204, RESERVED_46, 46, 18)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG0_U_RNFBESAM_NID204, SCG1_TOP_ADDRESS_BIT2, 40, 6)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG0_U_RNFBESAM_NID204, RESERVED_38, 38, 2)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG0_U_RNFBESAM_NID204, SCG1_TOP_ADDRESS_BIT1, 32, 6)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG0_U_RNFBESAM_NID204, RESERVED_30, 30, 2)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG0_U_RNFBESAM_NID204, SCG1_TOP_ADDRESS_BIT0, 24, 6)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG0_U_RNFBESAM_NID204, RESERVED_22, 22, 2)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG0_U_RNFBESAM_NID204, SCG0_TOP_ADDRESS_BIT2, 16, 6)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG0_U_RNFBESAM_NID204, RESERVED_14, 14, 2)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG0_U_RNFBESAM_NID204, SCG0_TOP_ADDRESS_BIT1, 8, 6)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG0_U_RNFBESAM_NID204, SCG0_TOP_ADDRESS_BIT0, 0, 6)
REG32(SYS_CACHE_GRP_SN_SAM_CFG1_U_RNFBESAM_NID204, 0x1968d50)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG1_U_RNFBESAM_NID204, RESERVED_46, 46, 18)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG1_U_RNFBESAM_NID204, SCG3_TOP_ADDRESS_BIT2, 40, 6)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG1_U_RNFBESAM_NID204, RESERVED_38, 38, 2)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG1_U_RNFBESAM_NID204, SCG3_TOP_ADDRESS_BIT1, 32, 6)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG1_U_RNFBESAM_NID204, RESERVED_30, 30, 2)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG1_U_RNFBESAM_NID204, SCG3_TOP_ADDRESS_BIT0, 24, 6)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG1_U_RNFBESAM_NID204, RESERVED_22, 22, 2)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG1_U_RNFBESAM_NID204, SCG2_TOP_ADDRESS_BIT2, 16, 6)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG1_U_RNFBESAM_NID204, RESERVED_14, 14, 2)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG1_U_RNFBESAM_NID204, SCG2_TOP_ADDRESS_BIT1, 8, 6)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG1_U_RNFBESAM_NID204, SCG2_TOP_ADDRESS_BIT0, 0, 6)
REG32(GIC_MEM_REGION_REG_U_RNFBESAM_NID204, 0x1968d58)
    FIELD(GIC_MEM_REGION_REG_U_RNFBESAM_NID204, RESERVED_63, 63, 1)
    FIELD(GIC_MEM_REGION_REG_U_RNFBESAM_NID204, GIC_REGION_NODEID, 52, 11)
    FIELD(GIC_MEM_REGION_REG_U_RNFBESAM_NID204, RESERVED_48, 48, 4)
    FIELD(GIC_MEM_REGION_REG_U_RNFBESAM_NID204, GIC_REGION_BASE_ADDR, 16, 32)
    FIELD(GIC_MEM_REGION_REG_U_RNFBESAM_NID204, GIC_REGION_SIZE, 4, 3)
    FIELD(GIC_MEM_REGION_REG_U_RNFBESAM_NID204, GIC_REGION_TARGET_TYPE, 2, 2)
    FIELD(GIC_MEM_REGION_REG_U_RNFBESAM_NID204, GIC_REGION_VALID, 0, 1)
REG32(SYS_CACHE_GRP_SN_ATTR_U_RNFBESAM_NID204, 0x1968d60)
    FIELD(SYS_CACHE_GRP_SN_ATTR_U_RNFBESAM_NID204, RESERVED_54, 54, 10)
    FIELD(SYS_CACHE_GRP_SN_ATTR_U_RNFBESAM_NID204, SN_MODE_SYS_CACHE_GRP3, 52, 2)
    FIELD(SYS_CACHE_GRP_SN_ATTR_U_RNFBESAM_NID204, RESERVED_49, 49, 3)
    FIELD(SYS_CACHE_GRP_SN_ATTR_U_RNFBESAM_NID204, INV_TOP_ADDRESS_BIT_SYS_CACHE_GRP3, 48, 1)
    FIELD(SYS_CACHE_GRP_SN_ATTR_U_RNFBESAM_NID204, RESERVED_38, 38, 10)
    FIELD(SYS_CACHE_GRP_SN_ATTR_U_RNFBESAM_NID204, SN_MODE_SYS_CACHE_GRP2, 36, 2)
    FIELD(SYS_CACHE_GRP_SN_ATTR_U_RNFBESAM_NID204, RESERVED_33, 33, 3)
    FIELD(SYS_CACHE_GRP_SN_ATTR_U_RNFBESAM_NID204, INV_TOP_ADDRESS_BIT_SYS_CACHE_GRP2, 32, 1)
    FIELD(SYS_CACHE_GRP_SN_ATTR_U_RNFBESAM_NID204, RESERVED_22, 22, 10)
    FIELD(SYS_CACHE_GRP_SN_ATTR_U_RNFBESAM_NID204, SN_MODE_SYS_CACHE_GRP1, 20, 2)
    FIELD(SYS_CACHE_GRP_SN_ATTR_U_RNFBESAM_NID204, RESERVED_17, 17, 3)
    FIELD(SYS_CACHE_GRP_SN_ATTR_U_RNFBESAM_NID204, INV_TOP_ADDRESS_BIT_SYS_CACHE_GRP1, 16, 1)
    FIELD(SYS_CACHE_GRP_SN_ATTR_U_RNFBESAM_NID204, SN_MODE_SYS_CACHE_GRP0, 4, 2)
    FIELD(SYS_CACHE_GRP_SN_ATTR_U_RNFBESAM_NID204, INV_TOP_ADDRESS_BIT_SYS_CACHE_GRP0, 0, 1)
REG32(SYS_CACHE_GRP_HN_CPA_EN_REG_U_RNFBESAM_NID204, 0x1968d68)
REG32(SYS_CACHE_GRP_HN_CPA_GRP_REG_U_RNFBESAM_NID204, 0x1968d70)
    FIELD(SYS_CACHE_GRP_HN_CPA_GRP_REG_U_RNFBESAM_NID204, RESERVED_50, 50, 14)
    FIELD(SYS_CACHE_GRP_HN_CPA_GRP_REG_U_RNFBESAM_NID204, CPA_GRP_SCG3, 48, 2)
    FIELD(SYS_CACHE_GRP_HN_CPA_GRP_REG_U_RNFBESAM_NID204, RESERVED_34, 34, 14)
    FIELD(SYS_CACHE_GRP_HN_CPA_GRP_REG_U_RNFBESAM_NID204, CPA_GRP_SCG2, 32, 2)
    FIELD(SYS_CACHE_GRP_HN_CPA_GRP_REG_U_RNFBESAM_NID204, RESERVED_18, 18, 14)
    FIELD(SYS_CACHE_GRP_HN_CPA_GRP_REG_U_RNFBESAM_NID204, CPA_GRP_SCG1, 16, 2)
    FIELD(SYS_CACHE_GRP_HN_CPA_GRP_REG_U_RNFBESAM_NID204, CPA_GRP_SCG0, 0, 2)
REG32(CML_PORT_AGGR_MODE_CTRL_REG_U_RNFBESAM_NID204, 0x1968e00)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNFBESAM_NID204, RESERVED_32, 32, 32)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNFBESAM_NID204, REGION7_PAG_GRPID, 30, 2)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNFBESAM_NID204, RESERVED_29, 29, 1)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNFBESAM_NID204, REGION7_PAG_EN, 28, 1)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNFBESAM_NID204, RESERVED_27, 27, 1)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNFBESAM_NID204, REGION6_PAG_GRPID, 25, 2)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNFBESAM_NID204, REGION6_PAG_EN, 24, 1)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNFBESAM_NID204, RESERVED_23, 23, 1)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNFBESAM_NID204, REGION5_PAG_GRPID, 21, 2)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNFBESAM_NID204, REGION5_PAG_EN, 20, 1)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNFBESAM_NID204, RESERVED_19, 19, 1)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNFBESAM_NID204, REGION4_PAG_GRPID, 17, 2)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNFBESAM_NID204, REGION4_PAG_EN, 16, 1)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNFBESAM_NID204, RESERVED_15, 15, 1)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNFBESAM_NID204, REGION3_PAG_GRPID, 13, 2)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNFBESAM_NID204, REGION3_PAG_EN, 12, 1)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNFBESAM_NID204, RESERVED_11, 11, 1)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNFBESAM_NID204, REGION2_PAG_GRPID, 9, 2)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNFBESAM_NID204, REGION2_PAG_EN, 8, 1)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNFBESAM_NID204, REGION1_PAG_GRPID, 5, 2)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNFBESAM_NID204, REGION1_PAG_EN, 4, 1)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNFBESAM_NID204, REGION0_PAG_GRPID, 1, 2)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNFBESAM_NID204, REGION0_PAG_EN, 0, 1)
REG32(CML_PORT_AGGR_GRP0_ADD_MASK_U_RNFBESAM_NID204, 0x1968e08)
    FIELD(CML_PORT_AGGR_GRP0_ADD_MASK_U_RNFBESAM_NID204, RESERVED_48, 48, 16)
    FIELD(CML_PORT_AGGR_GRP0_ADD_MASK_U_RNFBESAM_NID204, ADDR_MASK, 6, 42)
    FIELD(CML_PORT_AGGR_GRP0_ADD_MASK_U_RNFBESAM_NID204, RESERVED_0, 0, 6)
REG32(CML_PORT_AGGR_GRP1_ADD_MASK_U_RNFBESAM_NID204, 0x1968e10)
    FIELD(CML_PORT_AGGR_GRP1_ADD_MASK_U_RNFBESAM_NID204, RESERVED_48, 48, 16)
    FIELD(CML_PORT_AGGR_GRP1_ADD_MASK_U_RNFBESAM_NID204, ADDR_MASK, 6, 42)
    FIELD(CML_PORT_AGGR_GRP1_ADD_MASK_U_RNFBESAM_NID204, RESERVED_0, 0, 6)
REG32(CML_PORT_AGGR_GRP0_REG_U_RNFBESAM_NID204, 0x1968e40)
    FIELD(CML_PORT_AGGR_GRP0_REG_U_RNFBESAM_NID204, RESERVED_50, 50, 14)
    FIELD(CML_PORT_AGGR_GRP0_REG_U_RNFBESAM_NID204, NUM_CXG_PAG0, 48, 2)
    FIELD(CML_PORT_AGGR_GRP0_REG_U_RNFBESAM_NID204, RESERVED_47, 47, 1)
    FIELD(CML_PORT_AGGR_GRP0_REG_U_RNFBESAM_NID204, PAG0_TGTID3, 36, 11)
    FIELD(CML_PORT_AGGR_GRP0_REG_U_RNFBESAM_NID204, RESERVED_35, 35, 1)
    FIELD(CML_PORT_AGGR_GRP0_REG_U_RNFBESAM_NID204, PAG0_TGTID2, 24, 11)
    FIELD(CML_PORT_AGGR_GRP0_REG_U_RNFBESAM_NID204, RESERVED_23, 23, 1)
    FIELD(CML_PORT_AGGR_GRP0_REG_U_RNFBESAM_NID204, PAG0_TGTID1, 12, 11)
    FIELD(CML_PORT_AGGR_GRP0_REG_U_RNFBESAM_NID204, RESERVED_11, 11, 1)
    FIELD(CML_PORT_AGGR_GRP0_REG_U_RNFBESAM_NID204, PAG0_TGTID0, 0, 11)
REG32(CML_PORT_AGGR_GRP1_REG_U_RNFBESAM_NID204, 0x1968e48)
    FIELD(CML_PORT_AGGR_GRP1_REG_U_RNFBESAM_NID204, RESERVED_50, 50, 14)
    FIELD(CML_PORT_AGGR_GRP1_REG_U_RNFBESAM_NID204, NUM_CXG_PAG1, 48, 2)
    FIELD(CML_PORT_AGGR_GRP1_REG_U_RNFBESAM_NID204, RESERVED_47, 47, 1)
    FIELD(CML_PORT_AGGR_GRP1_REG_U_RNFBESAM_NID204, PAG1_TGTID3, 36, 11)
    FIELD(CML_PORT_AGGR_GRP1_REG_U_RNFBESAM_NID204, RESERVED_35, 35, 1)
    FIELD(CML_PORT_AGGR_GRP1_REG_U_RNFBESAM_NID204, PAG1_TGTID2, 24, 11)
    FIELD(CML_PORT_AGGR_GRP1_REG_U_RNFBESAM_NID204, RESERVED_23, 23, 1)
    FIELD(CML_PORT_AGGR_GRP1_REG_U_RNFBESAM_NID204, PAG1_TGTID1, 12, 11)
    FIELD(CML_PORT_AGGR_GRP1_REG_U_RNFBESAM_NID204, RESERVED_11, 11, 1)
    FIELD(CML_PORT_AGGR_GRP1_REG_U_RNFBESAM_NID204, PAG1_TGTID0, 0, 11)
REG32(SYS_CACHE_GRP_SECONDARY_REG0_U_RNFBESAM_NID204, 0x1968f00)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG0_U_RNFBESAM_NID204, RESERVED_63, 63, 1)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG0_U_RNFBESAM_NID204, REGION1_SCNDRY_BASE_ADDR, 41, 22)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG0_U_RNFBESAM_NID204, REGION1_SCNDRY_SIZE, 36, 5)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG0_U_RNFBESAM_NID204, REGION1_SCNDRY_TARGET_TYPE, 34, 2)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG0_U_RNFBESAM_NID204, RESERVED_33, 33, 1)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG0_U_RNFBESAM_NID204, REGION1_SCNDRY_VALID, 32, 1)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG0_U_RNFBESAM_NID204, RESERVED_31, 31, 1)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG0_U_RNFBESAM_NID204, REGION0_SCNDRY_BASE_ADDR, 9, 22)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG0_U_RNFBESAM_NID204, REGION0_SCNDRY_SIZE, 4, 5)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG0_U_RNFBESAM_NID204, REGION0_SCNDRY_TARGET_TYPE, 2, 2)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG0_U_RNFBESAM_NID204, REGION0_SCNDRY_VALID, 0, 1)
REG32(SYS_CACHE_GRP_SECONDARY_REG1_U_RNFBESAM_NID204, 0x1968f08)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG1_U_RNFBESAM_NID204, RESERVED_63, 63, 1)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG1_U_RNFBESAM_NID204, REGION3_SCNDRY_BASE_ADDR, 41, 22)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG1_U_RNFBESAM_NID204, REGION3_SCNDRY_SIZE, 36, 5)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG1_U_RNFBESAM_NID204, REGION3_SCNDRY_TARGET_TYPE, 34, 2)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG1_U_RNFBESAM_NID204, RESERVED_33, 33, 1)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG1_U_RNFBESAM_NID204, REGION3_SCNDRY_VALID, 32, 1)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG1_U_RNFBESAM_NID204, RESERVED_31, 31, 1)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG1_U_RNFBESAM_NID204, REGION2_SCNDRY_BASE_ADDR, 9, 22)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG1_U_RNFBESAM_NID204, REGION2_SCNDRY_SIZE, 4, 5)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG1_U_RNFBESAM_NID204, REGION2_SCNDRY_TARGET_TYPE, 2, 2)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG1_U_RNFBESAM_NID204, REGION2_SCNDRY_VALID, 0, 1)
REG32(SYS_CACHE_GRP_CAL_MODE_REG_U_RNFBESAM_NID204, 0x1968f10)
    FIELD(SYS_CACHE_GRP_CAL_MODE_REG_U_RNFBESAM_NID204, RESERVED_49, 49, 15)
    FIELD(SYS_CACHE_GRP_CAL_MODE_REG_U_RNFBESAM_NID204, SCG3_HNF_CAL_MODE_EN, 48, 1)
    FIELD(SYS_CACHE_GRP_CAL_MODE_REG_U_RNFBESAM_NID204, RESERVED_33, 33, 15)
    FIELD(SYS_CACHE_GRP_CAL_MODE_REG_U_RNFBESAM_NID204, SCG2_HNF_CAL_MODE_EN, 32, 1)
    FIELD(SYS_CACHE_GRP_CAL_MODE_REG_U_RNFBESAM_NID204, RESERVED_17, 17, 15)
    FIELD(SYS_CACHE_GRP_CAL_MODE_REG_U_RNFBESAM_NID204, SCG1_HNF_CAL_MODE_EN, 16, 1)
    FIELD(SYS_CACHE_GRP_CAL_MODE_REG_U_RNFBESAM_NID204, SCG0_HNF_CAL_MODE_EN, 0, 1)
REG32(RNSAM_HASH_ADDR_MASK_REG_U_RNFBESAM_NID204, 0x1968f18)
    FIELD(RNSAM_HASH_ADDR_MASK_REG_U_RNFBESAM_NID204, RESERVED_48, 48, 16)
    FIELD(RNSAM_HASH_ADDR_MASK_REG_U_RNFBESAM_NID204, ADDR_MASK, 6, 42)
    FIELD(RNSAM_HASH_ADDR_MASK_REG_U_RNFBESAM_NID204, RESERVED_0, 0, 6)
REG32(RNSAM_REGION_CMP_ADDR_MASK_REG_U_RNFBESAM_NID204, 0x1968f20)
    FIELD(RNSAM_REGION_CMP_ADDR_MASK_REG_U_RNFBESAM_NID204, RESERVED_48, 48, 16)
    FIELD(RNSAM_REGION_CMP_ADDR_MASK_REG_U_RNFBESAM_NID204, ADDR_MASK, 16, 32)
    FIELD(RNSAM_REGION_CMP_ADDR_MASK_REG_U_RNFBESAM_NID204, RESERVED_0, 0, 16)
REG32(SYS_CACHE_GRP_HN_NODEID_REG8_U_RNFBESAM_NID204, 0x1968f58)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG8_U_RNFBESAM_NID204, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG8_U_RNFBESAM_NID204, NODEID_35, 36, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG8_U_RNFBESAM_NID204, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG8_U_RNFBESAM_NID204, NODEID_34, 24, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG8_U_RNFBESAM_NID204, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG8_U_RNFBESAM_NID204, NODEID_33, 12, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG8_U_RNFBESAM_NID204, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG8_U_RNFBESAM_NID204, NODEID_32, 0, 11)
REG32(SYS_CACHE_GRP_HN_NODEID_REG9_U_RNFBESAM_NID204, 0x1968f60)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG9_U_RNFBESAM_NID204, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG9_U_RNFBESAM_NID204, NODEID_39, 36, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG9_U_RNFBESAM_NID204, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG9_U_RNFBESAM_NID204, NODEID_38, 24, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG9_U_RNFBESAM_NID204, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG9_U_RNFBESAM_NID204, NODEID_37, 12, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG9_U_RNFBESAM_NID204, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG9_U_RNFBESAM_NID204, NODEID_36, 0, 11)
REG32(SYS_CACHE_GRP_HN_NODEID_REG10_U_RNFBESAM_NID204, 0x1968f68)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG10_U_RNFBESAM_NID204, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG10_U_RNFBESAM_NID204, NODEID_43, 36, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG10_U_RNFBESAM_NID204, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG10_U_RNFBESAM_NID204, NODEID_42, 24, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG10_U_RNFBESAM_NID204, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG10_U_RNFBESAM_NID204, NODEID_41, 12, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG10_U_RNFBESAM_NID204, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG10_U_RNFBESAM_NID204, NODEID_40, 0, 11)
REG32(SYS_CACHE_GRP_HN_NODEID_REG11_U_RNFBESAM_NID204, 0x1968f70)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG11_U_RNFBESAM_NID204, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG11_U_RNFBESAM_NID204, NODEID_47, 36, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG11_U_RNFBESAM_NID204, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG11_U_RNFBESAM_NID204, NODEID_46, 24, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG11_U_RNFBESAM_NID204, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG11_U_RNFBESAM_NID204, NODEID_45, 12, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG11_U_RNFBESAM_NID204, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG11_U_RNFBESAM_NID204, NODEID_44, 0, 11)
REG32(SYS_CACHE_GRP_HN_NODEID_REG12_U_RNFBESAM_NID204, 0x1968f78)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG12_U_RNFBESAM_NID204, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG12_U_RNFBESAM_NID204, NODEID_51, 36, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG12_U_RNFBESAM_NID204, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG12_U_RNFBESAM_NID204, NODEID_50, 24, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG12_U_RNFBESAM_NID204, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG12_U_RNFBESAM_NID204, NODEID_49, 12, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG12_U_RNFBESAM_NID204, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG12_U_RNFBESAM_NID204, NODEID_48, 0, 11)
REG32(SYS_CACHE_GRP_HN_NODEID_REG13_U_RNFBESAM_NID204, 0x1968f80)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG13_U_RNFBESAM_NID204, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG13_U_RNFBESAM_NID204, NODEID_55, 36, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG13_U_RNFBESAM_NID204, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG13_U_RNFBESAM_NID204, NODEID_54, 24, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG13_U_RNFBESAM_NID204, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG13_U_RNFBESAM_NID204, NODEID_53, 12, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG13_U_RNFBESAM_NID204, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG13_U_RNFBESAM_NID204, NODEID_52, 0, 11)
REG32(SYS_CACHE_GRP_HN_NODEID_REG14_U_RNFBESAM_NID204, 0x1968f88)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG14_U_RNFBESAM_NID204, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG14_U_RNFBESAM_NID204, NODEID_59, 36, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG14_U_RNFBESAM_NID204, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG14_U_RNFBESAM_NID204, NODEID_58, 24, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG14_U_RNFBESAM_NID204, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG14_U_RNFBESAM_NID204, NODEID_57, 12, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG14_U_RNFBESAM_NID204, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG14_U_RNFBESAM_NID204, NODEID_56, 0, 11)
REG32(SYS_CACHE_GRP_HN_NODEID_REG15_U_RNFBESAM_NID204, 0x1968f90)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG15_U_RNFBESAM_NID204, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG15_U_RNFBESAM_NID204, NODEID_63, 36, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG15_U_RNFBESAM_NID204, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG15_U_RNFBESAM_NID204, NODEID_62, 24, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG15_U_RNFBESAM_NID204, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG15_U_RNFBESAM_NID204, NODEID_61, 12, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG15_U_RNFBESAM_NID204, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG15_U_RNFBESAM_NID204, NODEID_60, 0, 11)
REG32(SYS_CACHE_GRP_SN_NODEID_REG8_U_RNFBESAM_NID204, 0x1969008)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG8_U_RNFBESAM_NID204, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG8_U_RNFBESAM_NID204, SN_NODEID_35, 36, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG8_U_RNFBESAM_NID204, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG8_U_RNFBESAM_NID204, SN_NODEID_34, 24, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG8_U_RNFBESAM_NID204, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG8_U_RNFBESAM_NID204, SN_NODEID_33, 12, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG8_U_RNFBESAM_NID204, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG8_U_RNFBESAM_NID204, SN_NODEID_32, 0, 11)
REG32(SYS_CACHE_GRP_SN_NODEID_REG9_U_RNFBESAM_NID204, 0x1969010)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG9_U_RNFBESAM_NID204, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG9_U_RNFBESAM_NID204, SN_NODEID_39, 36, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG9_U_RNFBESAM_NID204, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG9_U_RNFBESAM_NID204, SN_NODEID_38, 24, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG9_U_RNFBESAM_NID204, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG9_U_RNFBESAM_NID204, SN_NODEID_37, 12, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG9_U_RNFBESAM_NID204, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG9_U_RNFBESAM_NID204, SN_NODEID_36, 0, 11)
REG32(SYS_CACHE_GRP_SN_NODEID_REG10_U_RNFBESAM_NID204, 0x1969018)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG10_U_RNFBESAM_NID204, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG10_U_RNFBESAM_NID204, SN_NODEID_43, 36, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG10_U_RNFBESAM_NID204, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG10_U_RNFBESAM_NID204, SN_NODEID_42, 24, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG10_U_RNFBESAM_NID204, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG10_U_RNFBESAM_NID204, SN_NODEID_41, 12, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG10_U_RNFBESAM_NID204, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG10_U_RNFBESAM_NID204, SN_NODEID_40, 0, 11)
REG32(SYS_CACHE_GRP_SN_NODEID_REG11_U_RNFBESAM_NID204, 0x1969020)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG11_U_RNFBESAM_NID204, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG11_U_RNFBESAM_NID204, SN_NODEID_47, 36, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG11_U_RNFBESAM_NID204, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG11_U_RNFBESAM_NID204, SN_NODEID_46, 24, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG11_U_RNFBESAM_NID204, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG11_U_RNFBESAM_NID204, SN_NODEID_45, 12, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG11_U_RNFBESAM_NID204, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG11_U_RNFBESAM_NID204, SN_NODEID_44, 0, 11)
REG32(SYS_CACHE_GRP_SN_NODEID_REG12_U_RNFBESAM_NID204, 0x1969028)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG12_U_RNFBESAM_NID204, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG12_U_RNFBESAM_NID204, SN_NODEID_51, 36, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG12_U_RNFBESAM_NID204, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG12_U_RNFBESAM_NID204, SN_NODEID_50, 24, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG12_U_RNFBESAM_NID204, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG12_U_RNFBESAM_NID204, SN_NODEID_49, 12, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG12_U_RNFBESAM_NID204, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG12_U_RNFBESAM_NID204, SN_NODEID_48, 0, 11)
REG32(SYS_CACHE_GRP_SN_NODEID_REG13_U_RNFBESAM_NID204, 0x1969030)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG13_U_RNFBESAM_NID204, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG13_U_RNFBESAM_NID204, SN_NODEID_55, 36, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG13_U_RNFBESAM_NID204, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG13_U_RNFBESAM_NID204, SN_NODEID_54, 24, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG13_U_RNFBESAM_NID204, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG13_U_RNFBESAM_NID204, SN_NODEID_53, 12, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG13_U_RNFBESAM_NID204, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG13_U_RNFBESAM_NID204, SN_NODEID_52, 0, 11)
REG32(SYS_CACHE_GRP_SN_NODEID_REG14_U_RNFBESAM_NID204, 0x1969038)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG14_U_RNFBESAM_NID204, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG14_U_RNFBESAM_NID204, SN_NODEID_59, 36, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG14_U_RNFBESAM_NID204, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG14_U_RNFBESAM_NID204, SN_NODEID_58, 24, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG14_U_RNFBESAM_NID204, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG14_U_RNFBESAM_NID204, SN_NODEID_57, 12, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG14_U_RNFBESAM_NID204, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG14_U_RNFBESAM_NID204, SN_NODEID_56, 0, 11)
REG32(SYS_CACHE_GRP_SN_NODEID_REG15_U_RNFBESAM_NID204, 0x1969040)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG15_U_RNFBESAM_NID204, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG15_U_RNFBESAM_NID204, SN_NODEID_63, 36, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG15_U_RNFBESAM_NID204, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG15_U_RNFBESAM_NID204, SN_NODEID_62, 24, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG15_U_RNFBESAM_NID204, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG15_U_RNFBESAM_NID204, SN_NODEID_61, 12, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG15_U_RNFBESAM_NID204, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG15_U_RNFBESAM_NID204, SN_NODEID_60, 0, 11)
REG32(POR_CFGM_NODE_INFO_U_HND_NID256, 0x2000000)
    FIELD(POR_CFGM_NODE_INFO_U_HND_NID256, RESERVED_48, 48, 16)
    FIELD(POR_CFGM_NODE_INFO_U_HND_NID256, LOGICAL_ID, 32, 16)
    FIELD(POR_CFGM_NODE_INFO_U_HND_NID256, NODE_ID, 16, 16)
    FIELD(POR_CFGM_NODE_INFO_U_HND_NID256, NODE_TYPE, 0, 16)
REG32(POR_CFGM_PERIPH_ID_0_PERIPH_ID_1_U_HND_NID256, 0x2000008)
    FIELD(POR_CFGM_PERIPH_ID_0_PERIPH_ID_1_U_HND_NID256, RESERVED_40, 40, 24)
    FIELD(POR_CFGM_PERIPH_ID_0_PERIPH_ID_1_U_HND_NID256, PERIPH_ID_1, 32, 8)
    FIELD(POR_CFGM_PERIPH_ID_0_PERIPH_ID_1_U_HND_NID256, PERIPH_ID_0, 0, 8)
REG32(POR_CFGM_PERIPH_ID_2_PERIPH_ID_3_U_HND_NID256, 0x2000010)
    FIELD(POR_CFGM_PERIPH_ID_2_PERIPH_ID_3_U_HND_NID256, RESERVED_40, 40, 24)
    FIELD(POR_CFGM_PERIPH_ID_2_PERIPH_ID_3_U_HND_NID256, PERIPH_ID_3, 32, 8)
    FIELD(POR_CFGM_PERIPH_ID_2_PERIPH_ID_3_U_HND_NID256, PERIPH_ID_2, 0, 8)
REG32(POR_CFGM_PERIPH_ID_4_PERIPH_ID_5_U_HND_NID256, 0x2000018)
    FIELD(POR_CFGM_PERIPH_ID_4_PERIPH_ID_5_U_HND_NID256, RESERVED_40, 40, 24)
    FIELD(POR_CFGM_PERIPH_ID_4_PERIPH_ID_5_U_HND_NID256, PERIPH_ID_5, 32, 8)
    FIELD(POR_CFGM_PERIPH_ID_4_PERIPH_ID_5_U_HND_NID256, PERIPH_ID_4, 0, 8)
REG32(POR_CFGM_PERIPH_ID_6_PERIPH_ID_7_U_HND_NID256, 0x2000020)
    FIELD(POR_CFGM_PERIPH_ID_6_PERIPH_ID_7_U_HND_NID256, RESERVED_40, 40, 24)
    FIELD(POR_CFGM_PERIPH_ID_6_PERIPH_ID_7_U_HND_NID256, PERIPH_ID_7, 32, 8)
    FIELD(POR_CFGM_PERIPH_ID_6_PERIPH_ID_7_U_HND_NID256, PERIPH_ID_6, 0, 8)
REG32(POR_CFGM_COMPONENT_ID_0_COMPONENT_ID_1_U_HND_NID256, 0x2000028)
    FIELD(POR_CFGM_COMPONENT_ID_0_COMPONENT_ID_1_U_HND_NID256, RESERVED_40, 40, 24)
    FIELD(POR_CFGM_COMPONENT_ID_0_COMPONENT_ID_1_U_HND_NID256, COMPONENT_ID_1, 32, 8)
    FIELD(POR_CFGM_COMPONENT_ID_0_COMPONENT_ID_1_U_HND_NID256, COMPONENT_ID_0, 0, 8)
REG32(POR_CFGM_COMPONENT_ID_2_COMPONENT_ID_3_U_HND_NID256, 0x2000030)
    FIELD(POR_CFGM_COMPONENT_ID_2_COMPONENT_ID_3_U_HND_NID256, RESERVED_40, 40, 24)
    FIELD(POR_CFGM_COMPONENT_ID_2_COMPONENT_ID_3_U_HND_NID256, COMPONENT_ID_3, 32, 8)
    FIELD(POR_CFGM_COMPONENT_ID_2_COMPONENT_ID_3_U_HND_NID256, COMPONENT_ID_2, 0, 8)
REG32(POR_CFGM_CHILD_INFO_U_HND_NID256, 0x2000080)
    FIELD(POR_CFGM_CHILD_INFO_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_INFO_U_HND_NID256, CHILD_PTR_OFFSET, 16, 16)
    FIELD(POR_CFGM_CHILD_INFO_U_HND_NID256, CHILD_COUNT, 0, 16)
REG32(POR_CFGM_CHILD_POINTER_0_U_HND_NID256, 0x2000100)
    FIELD(POR_CFGM_CHILD_POINTER_0_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_0_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_1_U_HND_NID256, 0x2000108)
    FIELD(POR_CFGM_CHILD_POINTER_1_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_1_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_2_U_HND_NID256, 0x2000110)
    FIELD(POR_CFGM_CHILD_POINTER_2_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_2_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_3_U_HND_NID256, 0x2000118)
    FIELD(POR_CFGM_CHILD_POINTER_3_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_3_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_4_U_HND_NID256, 0x2000120)
    FIELD(POR_CFGM_CHILD_POINTER_4_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_4_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_5_U_HND_NID256, 0x2000128)
    FIELD(POR_CFGM_CHILD_POINTER_5_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_5_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_6_U_HND_NID256, 0x2000130)
    FIELD(POR_CFGM_CHILD_POINTER_6_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_6_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_7_U_HND_NID256, 0x2000138)
    FIELD(POR_CFGM_CHILD_POINTER_7_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_7_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_8_U_HND_NID256, 0x2000140)
    FIELD(POR_CFGM_CHILD_POINTER_8_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_8_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_9_U_HND_NID256, 0x2000148)
    FIELD(POR_CFGM_CHILD_POINTER_9_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_9_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_10_U_HND_NID256, 0x2000150)
    FIELD(POR_CFGM_CHILD_POINTER_10_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_10_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_11_U_HND_NID256, 0x2000158)
    FIELD(POR_CFGM_CHILD_POINTER_11_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_11_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_12_U_HND_NID256, 0x2000160)
    FIELD(POR_CFGM_CHILD_POINTER_12_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_12_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_13_U_HND_NID256, 0x2000168)
    FIELD(POR_CFGM_CHILD_POINTER_13_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_13_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_14_U_HND_NID256, 0x2000170)
    FIELD(POR_CFGM_CHILD_POINTER_14_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_14_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_15_U_HND_NID256, 0x2000178)
    FIELD(POR_CFGM_CHILD_POINTER_15_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_15_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_16_U_HND_NID256, 0x2000180)
    FIELD(POR_CFGM_CHILD_POINTER_16_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_16_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_17_U_HND_NID256, 0x2000188)
    FIELD(POR_CFGM_CHILD_POINTER_17_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_17_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_18_U_HND_NID256, 0x2000190)
    FIELD(POR_CFGM_CHILD_POINTER_18_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_18_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_19_U_HND_NID256, 0x2000198)
    FIELD(POR_CFGM_CHILD_POINTER_19_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_19_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_20_U_HND_NID256, 0x20001a0)
    FIELD(POR_CFGM_CHILD_POINTER_20_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_20_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_21_U_HND_NID256, 0x20001a8)
    FIELD(POR_CFGM_CHILD_POINTER_21_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_21_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_22_U_HND_NID256, 0x20001b0)
    FIELD(POR_CFGM_CHILD_POINTER_22_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_22_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_23_U_HND_NID256, 0x20001b8)
    FIELD(POR_CFGM_CHILD_POINTER_23_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_23_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_24_U_HND_NID256, 0x20001c0)
    FIELD(POR_CFGM_CHILD_POINTER_24_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_24_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_25_U_HND_NID256, 0x20001c8)
    FIELD(POR_CFGM_CHILD_POINTER_25_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_25_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_26_U_HND_NID256, 0x20001d0)
    FIELD(POR_CFGM_CHILD_POINTER_26_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_26_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_27_U_HND_NID256, 0x20001d8)
    FIELD(POR_CFGM_CHILD_POINTER_27_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_27_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_28_U_HND_NID256, 0x20001e0)
    FIELD(POR_CFGM_CHILD_POINTER_28_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_28_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_29_U_HND_NID256, 0x20001e8)
    FIELD(POR_CFGM_CHILD_POINTER_29_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_29_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_30_U_HND_NID256, 0x20001f0)
    FIELD(POR_CFGM_CHILD_POINTER_30_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_30_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_31_U_HND_NID256, 0x20001f8)
    FIELD(POR_CFGM_CHILD_POINTER_31_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_31_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_32_U_HND_NID256, 0x2000200)
    FIELD(POR_CFGM_CHILD_POINTER_32_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_32_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_33_U_HND_NID256, 0x2000208)
    FIELD(POR_CFGM_CHILD_POINTER_33_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_33_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_34_U_HND_NID256, 0x2000210)
    FIELD(POR_CFGM_CHILD_POINTER_34_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_34_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_35_U_HND_NID256, 0x2000218)
    FIELD(POR_CFGM_CHILD_POINTER_35_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_35_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_36_U_HND_NID256, 0x2000220)
    FIELD(POR_CFGM_CHILD_POINTER_36_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_36_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_37_U_HND_NID256, 0x2000228)
    FIELD(POR_CFGM_CHILD_POINTER_37_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_37_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_38_U_HND_NID256, 0x2000230)
    FIELD(POR_CFGM_CHILD_POINTER_38_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_38_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_39_U_HND_NID256, 0x2000238)
    FIELD(POR_CFGM_CHILD_POINTER_39_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_39_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_40_U_HND_NID256, 0x2000240)
    FIELD(POR_CFGM_CHILD_POINTER_40_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_40_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_41_U_HND_NID256, 0x2000248)
    FIELD(POR_CFGM_CHILD_POINTER_41_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_41_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_42_U_HND_NID256, 0x2000250)
    FIELD(POR_CFGM_CHILD_POINTER_42_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_42_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_43_U_HND_NID256, 0x2000258)
    FIELD(POR_CFGM_CHILD_POINTER_43_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_43_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_44_U_HND_NID256, 0x2000260)
    FIELD(POR_CFGM_CHILD_POINTER_44_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_44_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_45_U_HND_NID256, 0x2000268)
    FIELD(POR_CFGM_CHILD_POINTER_45_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_45_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_46_U_HND_NID256, 0x2000270)
    FIELD(POR_CFGM_CHILD_POINTER_46_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_46_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_47_U_HND_NID256, 0x2000278)
    FIELD(POR_CFGM_CHILD_POINTER_47_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_47_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_48_U_HND_NID256, 0x2000280)
    FIELD(POR_CFGM_CHILD_POINTER_48_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_48_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_49_U_HND_NID256, 0x2000288)
    FIELD(POR_CFGM_CHILD_POINTER_49_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_49_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_50_U_HND_NID256, 0x2000290)
    FIELD(POR_CFGM_CHILD_POINTER_50_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_50_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_51_U_HND_NID256, 0x2000298)
    FIELD(POR_CFGM_CHILD_POINTER_51_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_51_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_52_U_HND_NID256, 0x20002a0)
    FIELD(POR_CFGM_CHILD_POINTER_52_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_52_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_53_U_HND_NID256, 0x20002a8)
    FIELD(POR_CFGM_CHILD_POINTER_53_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_53_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_54_U_HND_NID256, 0x20002b0)
    FIELD(POR_CFGM_CHILD_POINTER_54_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_54_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_55_U_HND_NID256, 0x20002b8)
    FIELD(POR_CFGM_CHILD_POINTER_55_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_55_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_56_U_HND_NID256, 0x20002c0)
    FIELD(POR_CFGM_CHILD_POINTER_56_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_56_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_57_U_HND_NID256, 0x20002c8)
    FIELD(POR_CFGM_CHILD_POINTER_57_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_57_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_58_U_HND_NID256, 0x20002d0)
    FIELD(POR_CFGM_CHILD_POINTER_58_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_58_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_59_U_HND_NID256, 0x20002d8)
    FIELD(POR_CFGM_CHILD_POINTER_59_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_59_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_60_U_HND_NID256, 0x20002e0)
    FIELD(POR_CFGM_CHILD_POINTER_60_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_60_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_61_U_HND_NID256, 0x20002e8)
    FIELD(POR_CFGM_CHILD_POINTER_61_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_61_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_62_U_HND_NID256, 0x20002f0)
    FIELD(POR_CFGM_CHILD_POINTER_62_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_62_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_63_U_HND_NID256, 0x20002f8)
    FIELD(POR_CFGM_CHILD_POINTER_63_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_63_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_64_U_HND_NID256, 0x2000300)
    FIELD(POR_CFGM_CHILD_POINTER_64_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_64_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_65_U_HND_NID256, 0x2000308)
    FIELD(POR_CFGM_CHILD_POINTER_65_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_65_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_66_U_HND_NID256, 0x2000310)
    FIELD(POR_CFGM_CHILD_POINTER_66_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_66_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_67_U_HND_NID256, 0x2000318)
    FIELD(POR_CFGM_CHILD_POINTER_67_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_67_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_68_U_HND_NID256, 0x2000320)
    FIELD(POR_CFGM_CHILD_POINTER_68_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_68_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_69_U_HND_NID256, 0x2000328)
    FIELD(POR_CFGM_CHILD_POINTER_69_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_69_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_70_U_HND_NID256, 0x2000330)
    FIELD(POR_CFGM_CHILD_POINTER_70_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_70_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_71_U_HND_NID256, 0x2000338)
    FIELD(POR_CFGM_CHILD_POINTER_71_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_71_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_72_U_HND_NID256, 0x2000340)
    FIELD(POR_CFGM_CHILD_POINTER_72_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_72_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_73_U_HND_NID256, 0x2000348)
    FIELD(POR_CFGM_CHILD_POINTER_73_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_73_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_74_U_HND_NID256, 0x2000350)
    FIELD(POR_CFGM_CHILD_POINTER_74_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_74_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_75_U_HND_NID256, 0x2000358)
    FIELD(POR_CFGM_CHILD_POINTER_75_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_75_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_76_U_HND_NID256, 0x2000360)
    FIELD(POR_CFGM_CHILD_POINTER_76_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_76_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_77_U_HND_NID256, 0x2000368)
    FIELD(POR_CFGM_CHILD_POINTER_77_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_77_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_78_U_HND_NID256, 0x2000370)
    FIELD(POR_CFGM_CHILD_POINTER_78_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_78_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_79_U_HND_NID256, 0x2000378)
    FIELD(POR_CFGM_CHILD_POINTER_79_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_79_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_80_U_HND_NID256, 0x2000380)
    FIELD(POR_CFGM_CHILD_POINTER_80_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_80_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_81_U_HND_NID256, 0x2000388)
    FIELD(POR_CFGM_CHILD_POINTER_81_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_81_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_82_U_HND_NID256, 0x2000390)
    FIELD(POR_CFGM_CHILD_POINTER_82_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_82_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_83_U_HND_NID256, 0x2000398)
    FIELD(POR_CFGM_CHILD_POINTER_83_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_83_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_84_U_HND_NID256, 0x20003a0)
    FIELD(POR_CFGM_CHILD_POINTER_84_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_84_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_85_U_HND_NID256, 0x20003a8)
    FIELD(POR_CFGM_CHILD_POINTER_85_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_85_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_86_U_HND_NID256, 0x20003b0)
    FIELD(POR_CFGM_CHILD_POINTER_86_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_86_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_87_U_HND_NID256, 0x20003b8)
    FIELD(POR_CFGM_CHILD_POINTER_87_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_87_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_88_U_HND_NID256, 0x20003c0)
    FIELD(POR_CFGM_CHILD_POINTER_88_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_88_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_89_U_HND_NID256, 0x20003c8)
    FIELD(POR_CFGM_CHILD_POINTER_89_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_89_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_90_U_HND_NID256, 0x20003d0)
    FIELD(POR_CFGM_CHILD_POINTER_90_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_90_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_91_U_HND_NID256, 0x20003d8)
    FIELD(POR_CFGM_CHILD_POINTER_91_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_91_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_92_U_HND_NID256, 0x20003e0)
    FIELD(POR_CFGM_CHILD_POINTER_92_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_92_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_93_U_HND_NID256, 0x20003e8)
    FIELD(POR_CFGM_CHILD_POINTER_93_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_93_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_94_U_HND_NID256, 0x20003f0)
    FIELD(POR_CFGM_CHILD_POINTER_94_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_94_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_95_U_HND_NID256, 0x20003f8)
    FIELD(POR_CFGM_CHILD_POINTER_95_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_95_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_96_U_HND_NID256, 0x2000400)
    FIELD(POR_CFGM_CHILD_POINTER_96_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_96_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_97_U_HND_NID256, 0x2000408)
    FIELD(POR_CFGM_CHILD_POINTER_97_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_97_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_98_U_HND_NID256, 0x2000410)
    FIELD(POR_CFGM_CHILD_POINTER_98_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_98_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_99_U_HND_NID256, 0x2000418)
    FIELD(POR_CFGM_CHILD_POINTER_99_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_99_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_100_U_HND_NID256, 0x2000420)
    FIELD(POR_CFGM_CHILD_POINTER_100_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_100_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_101_U_HND_NID256, 0x2000428)
    FIELD(POR_CFGM_CHILD_POINTER_101_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_101_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_102_U_HND_NID256, 0x2000430)
    FIELD(POR_CFGM_CHILD_POINTER_102_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_102_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_103_U_HND_NID256, 0x2000438)
    FIELD(POR_CFGM_CHILD_POINTER_103_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_103_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_104_U_HND_NID256, 0x2000440)
    FIELD(POR_CFGM_CHILD_POINTER_104_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_104_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_105_U_HND_NID256, 0x2000448)
    FIELD(POR_CFGM_CHILD_POINTER_105_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_105_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_106_U_HND_NID256, 0x2000450)
    FIELD(POR_CFGM_CHILD_POINTER_106_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_106_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_107_U_HND_NID256, 0x2000458)
    FIELD(POR_CFGM_CHILD_POINTER_107_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_107_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_108_U_HND_NID256, 0x2000460)
    FIELD(POR_CFGM_CHILD_POINTER_108_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_108_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_109_U_HND_NID256, 0x2000468)
    FIELD(POR_CFGM_CHILD_POINTER_109_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_109_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_110_U_HND_NID256, 0x2000470)
    FIELD(POR_CFGM_CHILD_POINTER_110_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_110_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_111_U_HND_NID256, 0x2000478)
    FIELD(POR_CFGM_CHILD_POINTER_111_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_111_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_112_U_HND_NID256, 0x2000480)
    FIELD(POR_CFGM_CHILD_POINTER_112_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_112_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_113_U_HND_NID256, 0x2000488)
    FIELD(POR_CFGM_CHILD_POINTER_113_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_113_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_114_U_HND_NID256, 0x2000490)
    FIELD(POR_CFGM_CHILD_POINTER_114_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_114_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_115_U_HND_NID256, 0x2000498)
    FIELD(POR_CFGM_CHILD_POINTER_115_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_115_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_116_U_HND_NID256, 0x20004a0)
    FIELD(POR_CFGM_CHILD_POINTER_116_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_116_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_117_U_HND_NID256, 0x20004a8)
    FIELD(POR_CFGM_CHILD_POINTER_117_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_117_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_118_U_HND_NID256, 0x20004b0)
    FIELD(POR_CFGM_CHILD_POINTER_118_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_118_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_119_U_HND_NID256, 0x20004b8)
    FIELD(POR_CFGM_CHILD_POINTER_119_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_119_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_120_U_HND_NID256, 0x20004c0)
    FIELD(POR_CFGM_CHILD_POINTER_120_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_120_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_121_U_HND_NID256, 0x20004c8)
    FIELD(POR_CFGM_CHILD_POINTER_121_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_121_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_122_U_HND_NID256, 0x20004d0)
    FIELD(POR_CFGM_CHILD_POINTER_122_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_122_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_123_U_HND_NID256, 0x20004d8)
    FIELD(POR_CFGM_CHILD_POINTER_123_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_123_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_124_U_HND_NID256, 0x20004e0)
    FIELD(POR_CFGM_CHILD_POINTER_124_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_124_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_125_U_HND_NID256, 0x20004e8)
    FIELD(POR_CFGM_CHILD_POINTER_125_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_125_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_126_U_HND_NID256, 0x20004f0)
    FIELD(POR_CFGM_CHILD_POINTER_126_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_126_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_127_U_HND_NID256, 0x20004f8)
    FIELD(POR_CFGM_CHILD_POINTER_127_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_127_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_128_U_HND_NID256, 0x2000500)
    FIELD(POR_CFGM_CHILD_POINTER_128_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_128_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_129_U_HND_NID256, 0x2000508)
    FIELD(POR_CFGM_CHILD_POINTER_129_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_129_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_130_U_HND_NID256, 0x2000510)
    FIELD(POR_CFGM_CHILD_POINTER_130_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_130_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_131_U_HND_NID256, 0x2000518)
    FIELD(POR_CFGM_CHILD_POINTER_131_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_131_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_132_U_HND_NID256, 0x2000520)
    FIELD(POR_CFGM_CHILD_POINTER_132_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_132_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_133_U_HND_NID256, 0x2000528)
    FIELD(POR_CFGM_CHILD_POINTER_133_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_133_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_134_U_HND_NID256, 0x2000530)
    FIELD(POR_CFGM_CHILD_POINTER_134_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_134_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_135_U_HND_NID256, 0x2000538)
    FIELD(POR_CFGM_CHILD_POINTER_135_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_135_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_136_U_HND_NID256, 0x2000540)
    FIELD(POR_CFGM_CHILD_POINTER_136_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_136_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_137_U_HND_NID256, 0x2000548)
    FIELD(POR_CFGM_CHILD_POINTER_137_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_137_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_138_U_HND_NID256, 0x2000550)
    FIELD(POR_CFGM_CHILD_POINTER_138_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_138_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_139_U_HND_NID256, 0x2000558)
    FIELD(POR_CFGM_CHILD_POINTER_139_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_139_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_140_U_HND_NID256, 0x2000560)
    FIELD(POR_CFGM_CHILD_POINTER_140_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_140_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_141_U_HND_NID256, 0x2000568)
    FIELD(POR_CFGM_CHILD_POINTER_141_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_141_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_142_U_HND_NID256, 0x2000570)
    FIELD(POR_CFGM_CHILD_POINTER_142_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_142_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_143_U_HND_NID256, 0x2000578)
    FIELD(POR_CFGM_CHILD_POINTER_143_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_143_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_144_U_HND_NID256, 0x2000580)
    FIELD(POR_CFGM_CHILD_POINTER_144_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_144_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_145_U_HND_NID256, 0x2000588)
    FIELD(POR_CFGM_CHILD_POINTER_145_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_145_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_146_U_HND_NID256, 0x2000590)
    FIELD(POR_CFGM_CHILD_POINTER_146_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_146_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_147_U_HND_NID256, 0x2000598)
    FIELD(POR_CFGM_CHILD_POINTER_147_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_147_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_148_U_HND_NID256, 0x20005a0)
    FIELD(POR_CFGM_CHILD_POINTER_148_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_148_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_149_U_HND_NID256, 0x20005a8)
    FIELD(POR_CFGM_CHILD_POINTER_149_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_149_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_150_U_HND_NID256, 0x20005b0)
    FIELD(POR_CFGM_CHILD_POINTER_150_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_150_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_151_U_HND_NID256, 0x20005b8)
    FIELD(POR_CFGM_CHILD_POINTER_151_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_151_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_152_U_HND_NID256, 0x20005c0)
    FIELD(POR_CFGM_CHILD_POINTER_152_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_152_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_153_U_HND_NID256, 0x20005c8)
    FIELD(POR_CFGM_CHILD_POINTER_153_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_153_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_154_U_HND_NID256, 0x20005d0)
    FIELD(POR_CFGM_CHILD_POINTER_154_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_154_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_155_U_HND_NID256, 0x20005d8)
    FIELD(POR_CFGM_CHILD_POINTER_155_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_155_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_156_U_HND_NID256, 0x20005e0)
    FIELD(POR_CFGM_CHILD_POINTER_156_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_156_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_157_U_HND_NID256, 0x20005e8)
    FIELD(POR_CFGM_CHILD_POINTER_157_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_157_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_158_U_HND_NID256, 0x20005f0)
    FIELD(POR_CFGM_CHILD_POINTER_158_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_158_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_159_U_HND_NID256, 0x20005f8)
    FIELD(POR_CFGM_CHILD_POINTER_159_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_159_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_160_U_HND_NID256, 0x2000600)
    FIELD(POR_CFGM_CHILD_POINTER_160_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_160_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_161_U_HND_NID256, 0x2000608)
    FIELD(POR_CFGM_CHILD_POINTER_161_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_161_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_162_U_HND_NID256, 0x2000610)
    FIELD(POR_CFGM_CHILD_POINTER_162_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_162_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_163_U_HND_NID256, 0x2000618)
    FIELD(POR_CFGM_CHILD_POINTER_163_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_163_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_164_U_HND_NID256, 0x2000620)
    FIELD(POR_CFGM_CHILD_POINTER_164_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_164_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_165_U_HND_NID256, 0x2000628)
    FIELD(POR_CFGM_CHILD_POINTER_165_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_165_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_166_U_HND_NID256, 0x2000630)
    FIELD(POR_CFGM_CHILD_POINTER_166_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_166_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_167_U_HND_NID256, 0x2000638)
    FIELD(POR_CFGM_CHILD_POINTER_167_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_167_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_168_U_HND_NID256, 0x2000640)
    FIELD(POR_CFGM_CHILD_POINTER_168_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_168_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_169_U_HND_NID256, 0x2000648)
    FIELD(POR_CFGM_CHILD_POINTER_169_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_169_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_170_U_HND_NID256, 0x2000650)
    FIELD(POR_CFGM_CHILD_POINTER_170_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_170_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_171_U_HND_NID256, 0x2000658)
    FIELD(POR_CFGM_CHILD_POINTER_171_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_171_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_172_U_HND_NID256, 0x2000660)
    FIELD(POR_CFGM_CHILD_POINTER_172_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_172_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_173_U_HND_NID256, 0x2000668)
    FIELD(POR_CFGM_CHILD_POINTER_173_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_173_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_174_U_HND_NID256, 0x2000670)
    FIELD(POR_CFGM_CHILD_POINTER_174_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_174_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_175_U_HND_NID256, 0x2000678)
    FIELD(POR_CFGM_CHILD_POINTER_175_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_175_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_176_U_HND_NID256, 0x2000680)
    FIELD(POR_CFGM_CHILD_POINTER_176_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_176_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_177_U_HND_NID256, 0x2000688)
    FIELD(POR_CFGM_CHILD_POINTER_177_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_177_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_178_U_HND_NID256, 0x2000690)
    FIELD(POR_CFGM_CHILD_POINTER_178_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_178_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_179_U_HND_NID256, 0x2000698)
    FIELD(POR_CFGM_CHILD_POINTER_179_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_179_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_180_U_HND_NID256, 0x20006a0)
    FIELD(POR_CFGM_CHILD_POINTER_180_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_180_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_181_U_HND_NID256, 0x20006a8)
    FIELD(POR_CFGM_CHILD_POINTER_181_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_181_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_182_U_HND_NID256, 0x20006b0)
    FIELD(POR_CFGM_CHILD_POINTER_182_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_182_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_183_U_HND_NID256, 0x20006b8)
    FIELD(POR_CFGM_CHILD_POINTER_183_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_183_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_184_U_HND_NID256, 0x20006c0)
    FIELD(POR_CFGM_CHILD_POINTER_184_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_184_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_185_U_HND_NID256, 0x20006c8)
    FIELD(POR_CFGM_CHILD_POINTER_185_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_185_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_186_U_HND_NID256, 0x20006d0)
    FIELD(POR_CFGM_CHILD_POINTER_186_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_186_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_187_U_HND_NID256, 0x20006d8)
    FIELD(POR_CFGM_CHILD_POINTER_187_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_187_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_188_U_HND_NID256, 0x20006e0)
    FIELD(POR_CFGM_CHILD_POINTER_188_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_188_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_189_U_HND_NID256, 0x20006e8)
    FIELD(POR_CFGM_CHILD_POINTER_189_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_189_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_190_U_HND_NID256, 0x20006f0)
    FIELD(POR_CFGM_CHILD_POINTER_190_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_190_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_191_U_HND_NID256, 0x20006f8)
    FIELD(POR_CFGM_CHILD_POINTER_191_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_191_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_192_U_HND_NID256, 0x2000700)
    FIELD(POR_CFGM_CHILD_POINTER_192_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_192_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_193_U_HND_NID256, 0x2000708)
    FIELD(POR_CFGM_CHILD_POINTER_193_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_193_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_194_U_HND_NID256, 0x2000710)
    FIELD(POR_CFGM_CHILD_POINTER_194_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_194_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_195_U_HND_NID256, 0x2000718)
    FIELD(POR_CFGM_CHILD_POINTER_195_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_195_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_196_U_HND_NID256, 0x2000720)
    FIELD(POR_CFGM_CHILD_POINTER_196_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_196_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_197_U_HND_NID256, 0x2000728)
    FIELD(POR_CFGM_CHILD_POINTER_197_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_197_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_198_U_HND_NID256, 0x2000730)
    FIELD(POR_CFGM_CHILD_POINTER_198_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_198_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_199_U_HND_NID256, 0x2000738)
    FIELD(POR_CFGM_CHILD_POINTER_199_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_199_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_200_U_HND_NID256, 0x2000740)
    FIELD(POR_CFGM_CHILD_POINTER_200_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_200_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_201_U_HND_NID256, 0x2000748)
    FIELD(POR_CFGM_CHILD_POINTER_201_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_201_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_202_U_HND_NID256, 0x2000750)
    FIELD(POR_CFGM_CHILD_POINTER_202_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_202_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_203_U_HND_NID256, 0x2000758)
    FIELD(POR_CFGM_CHILD_POINTER_203_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_203_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_204_U_HND_NID256, 0x2000760)
    FIELD(POR_CFGM_CHILD_POINTER_204_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_204_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_205_U_HND_NID256, 0x2000768)
    FIELD(POR_CFGM_CHILD_POINTER_205_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_205_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_206_U_HND_NID256, 0x2000770)
    FIELD(POR_CFGM_CHILD_POINTER_206_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_206_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_207_U_HND_NID256, 0x2000778)
    FIELD(POR_CFGM_CHILD_POINTER_207_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_207_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_208_U_HND_NID256, 0x2000780)
    FIELD(POR_CFGM_CHILD_POINTER_208_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_208_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_209_U_HND_NID256, 0x2000788)
    FIELD(POR_CFGM_CHILD_POINTER_209_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_209_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_210_U_HND_NID256, 0x2000790)
    FIELD(POR_CFGM_CHILD_POINTER_210_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_210_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_211_U_HND_NID256, 0x2000798)
    FIELD(POR_CFGM_CHILD_POINTER_211_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_211_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_212_U_HND_NID256, 0x20007a0)
    FIELD(POR_CFGM_CHILD_POINTER_212_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_212_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_213_U_HND_NID256, 0x20007a8)
    FIELD(POR_CFGM_CHILD_POINTER_213_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_213_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_214_U_HND_NID256, 0x20007b0)
    FIELD(POR_CFGM_CHILD_POINTER_214_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_214_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_215_U_HND_NID256, 0x20007b8)
    FIELD(POR_CFGM_CHILD_POINTER_215_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_215_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_216_U_HND_NID256, 0x20007c0)
    FIELD(POR_CFGM_CHILD_POINTER_216_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_216_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_217_U_HND_NID256, 0x20007c8)
    FIELD(POR_CFGM_CHILD_POINTER_217_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_217_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_218_U_HND_NID256, 0x20007d0)
    FIELD(POR_CFGM_CHILD_POINTER_218_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_218_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_219_U_HND_NID256, 0x20007d8)
    FIELD(POR_CFGM_CHILD_POINTER_219_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_219_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_220_U_HND_NID256, 0x20007e0)
    FIELD(POR_CFGM_CHILD_POINTER_220_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_220_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_221_U_HND_NID256, 0x20007e8)
    FIELD(POR_CFGM_CHILD_POINTER_221_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_221_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_222_U_HND_NID256, 0x20007f0)
    FIELD(POR_CFGM_CHILD_POINTER_222_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_222_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_223_U_HND_NID256, 0x20007f8)
    FIELD(POR_CFGM_CHILD_POINTER_223_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_223_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_224_U_HND_NID256, 0x2000800)
    FIELD(POR_CFGM_CHILD_POINTER_224_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_224_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_225_U_HND_NID256, 0x2000808)
    FIELD(POR_CFGM_CHILD_POINTER_225_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_225_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_226_U_HND_NID256, 0x2000810)
    FIELD(POR_CFGM_CHILD_POINTER_226_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_226_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_227_U_HND_NID256, 0x2000818)
    FIELD(POR_CFGM_CHILD_POINTER_227_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_227_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_228_U_HND_NID256, 0x2000820)
    FIELD(POR_CFGM_CHILD_POINTER_228_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_228_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_229_U_HND_NID256, 0x2000828)
    FIELD(POR_CFGM_CHILD_POINTER_229_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_229_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_230_U_HND_NID256, 0x2000830)
    FIELD(POR_CFGM_CHILD_POINTER_230_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_230_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_231_U_HND_NID256, 0x2000838)
    FIELD(POR_CFGM_CHILD_POINTER_231_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_231_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_232_U_HND_NID256, 0x2000840)
    FIELD(POR_CFGM_CHILD_POINTER_232_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_232_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_233_U_HND_NID256, 0x2000848)
    FIELD(POR_CFGM_CHILD_POINTER_233_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_233_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_234_U_HND_NID256, 0x2000850)
    FIELD(POR_CFGM_CHILD_POINTER_234_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_234_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_235_U_HND_NID256, 0x2000858)
    FIELD(POR_CFGM_CHILD_POINTER_235_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_235_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_236_U_HND_NID256, 0x2000860)
    FIELD(POR_CFGM_CHILD_POINTER_236_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_236_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_237_U_HND_NID256, 0x2000868)
    FIELD(POR_CFGM_CHILD_POINTER_237_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_237_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_238_U_HND_NID256, 0x2000870)
    FIELD(POR_CFGM_CHILD_POINTER_238_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_238_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_239_U_HND_NID256, 0x2000878)
    FIELD(POR_CFGM_CHILD_POINTER_239_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_239_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_240_U_HND_NID256, 0x2000880)
    FIELD(POR_CFGM_CHILD_POINTER_240_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_240_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_241_U_HND_NID256, 0x2000888)
    FIELD(POR_CFGM_CHILD_POINTER_241_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_241_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_242_U_HND_NID256, 0x2000890)
    FIELD(POR_CFGM_CHILD_POINTER_242_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_242_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_243_U_HND_NID256, 0x2000898)
    FIELD(POR_CFGM_CHILD_POINTER_243_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_243_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_244_U_HND_NID256, 0x20008a0)
    FIELD(POR_CFGM_CHILD_POINTER_244_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_244_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_245_U_HND_NID256, 0x20008a8)
    FIELD(POR_CFGM_CHILD_POINTER_245_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_245_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_246_U_HND_NID256, 0x20008b0)
    FIELD(POR_CFGM_CHILD_POINTER_246_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_246_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_247_U_HND_NID256, 0x20008b8)
    FIELD(POR_CFGM_CHILD_POINTER_247_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_247_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_248_U_HND_NID256, 0x20008c0)
    FIELD(POR_CFGM_CHILD_POINTER_248_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_248_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_249_U_HND_NID256, 0x20008c8)
    FIELD(POR_CFGM_CHILD_POINTER_249_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_249_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_250_U_HND_NID256, 0x20008d0)
    FIELD(POR_CFGM_CHILD_POINTER_250_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_250_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_251_U_HND_NID256, 0x20008d8)
    FIELD(POR_CFGM_CHILD_POINTER_251_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_251_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_252_U_HND_NID256, 0x20008e0)
    FIELD(POR_CFGM_CHILD_POINTER_252_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_252_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_253_U_HND_NID256, 0x20008e8)
    FIELD(POR_CFGM_CHILD_POINTER_253_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_253_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_254_U_HND_NID256, 0x20008f0)
    FIELD(POR_CFGM_CHILD_POINTER_254_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_254_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_CFGM_CHILD_POINTER_255_U_HND_NID256, 0x20008f8)
    FIELD(POR_CFGM_CHILD_POINTER_255_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_CFGM_CHILD_POINTER_255_U_HND_NID256, RELATIVE_ADDRESS, 0, 32)
REG32(POR_INFO_GLOBAL_U_HND_NID256, 0x2000900)
    FIELD(POR_INFO_GLOBAL_U_HND_NID256, RESERVED_56, 56, 8)
    FIELD(POR_INFO_GLOBAL_U_HND_NID256, MPU_NUM_REG, 50, 6)
    FIELD(POR_INFO_GLOBAL_U_HND_NID256, CHIC_MODE_EN, 49, 1)
    FIELD(POR_INFO_GLOBAL_U_HND_NID256, R2_ENABLE, 48, 1)
    FIELD(POR_INFO_GLOBAL_U_HND_NID256, RESERVED_42, 42, 6)
    FIELD(POR_INFO_GLOBAL_U_HND_NID256, RNSAM_NUM_ADD_HASHED_TGT, 36, 6)
    FIELD(POR_INFO_GLOBAL_U_HND_NID256, NUM_REMOTE_RNF, 28, 8)
    FIELD(POR_INFO_GLOBAL_U_HND_NID256, RESERVED_26, 26, 2)
    FIELD(POR_INFO_GLOBAL_U_HND_NID256, FLIT_PARITY_EN, 25, 1)
    FIELD(POR_INFO_GLOBAL_U_HND_NID256, DATACHECK_EN, 24, 1)
    FIELD(POR_INFO_GLOBAL_U_HND_NID256, PHYSICAL_ADDRESS_WIDTH, 16, 8)
    FIELD(POR_INFO_GLOBAL_U_HND_NID256, CHI_REQ_ADDR_WIDTH, 8, 8)
    FIELD(POR_INFO_GLOBAL_U_HND_NID256, CHI_REQ_RSVDC_WIDTH, 0, 8)
REG32(POR_CFGM_SECURE_ACCESS_U_HND_NID256, 0x2000980)
    FIELD(POR_CFGM_SECURE_ACCESS_U_HND_NID256, CONFIGURE_SECURE_ACCESS, 0, 2)
REG32(POR_PPU_INT_ENABLE_U_HND_NID256, 0x2001000)
REG32(POR_PPU_INT_STATUS_U_HND_NID256, 0x2001008)
REG32(POR_PPU_QACTIVE_HYST_U_HND_NID256, 0x2001010)
    FIELD(POR_PPU_QACTIVE_HYST_U_HND_NID256, RESERVED_16, 16, 48)
    FIELD(POR_PPU_QACTIVE_HYST_U_HND_NID256, HNF_PPU_QACT_HYST, 0, 16)
REG32(POR_CFGM_ERRGSR0_U_HND_NID256, 0x2003000)
REG32(POR_CFGM_ERRGSR1_U_HND_NID256, 0x2003008)
REG32(POR_CFGM_ERRGSR2_U_HND_NID256, 0x2003010)
REG32(POR_CFGM_ERRGSR3_U_HND_NID256, 0x2003018)
REG32(POR_CFGM_ERRGSR4_U_HND_NID256, 0x2003020)
REG32(POR_CFGM_ERRGSR5_U_HND_NID256, 0x2003080)
REG32(POR_CFGM_ERRGSR6_U_HND_NID256, 0x2003088)
REG32(POR_CFGM_ERRGSR7_U_HND_NID256, 0x2003090)
REG32(POR_CFGM_ERRGSR8_U_HND_NID256, 0x2003098)
REG32(POR_CFGM_ERRGSR9_U_HND_NID256, 0x20030a0)
REG32(POR_CFGM_ERRGSR0_NS_U_HND_NID256, 0x2003100)
REG32(POR_CFGM_ERRGSR1_NS_U_HND_NID256, 0x2003108)
REG32(POR_CFGM_ERRGSR2_NS_U_HND_NID256, 0x2003110)
REG32(POR_CFGM_ERRGSR3_NS_U_HND_NID256, 0x2003118)
REG32(POR_CFGM_ERRGSR4_NS_U_HND_NID256, 0x2003120)
REG32(POR_CFGM_ERRGSR5_NS_U_HND_NID256, 0x2003180)
REG32(POR_CFGM_ERRGSR6_NS_U_HND_NID256, 0x2003188)
REG32(POR_CFGM_ERRGSR7_NS_U_HND_NID256, 0x2003190)
REG32(POR_CFGM_ERRGSR8_NS_U_HND_NID256, 0x2003198)
REG32(POR_CFGM_ERRGSR9_NS_U_HND_NID256, 0x20031a0)
REG32(POR_CFGM_ERRDEVAFF_U_HND_NID256, 0x2003fa8)
REG32(POR_CFGM_ERRDEVARCH_U_HND_NID256, 0x2003fb8)
    FIELD(POR_CFGM_ERRDEVARCH_U_HND_NID256, ARCHITECT, 53, 11)
    FIELD(POR_CFGM_ERRDEVARCH_U_HND_NID256, PRESENT, 52, 1)
    FIELD(POR_CFGM_ERRDEVARCH_U_HND_NID256, REVISION, 48, 4)
    FIELD(POR_CFGM_ERRDEVARCH_U_HND_NID256, ARCHID, 32, 16)
    FIELD(POR_CFGM_ERRDEVARCH_U_HND_NID256, RESERVED_0, 0, 32)
REG32(POR_CFGM_ERRIDR_U_HND_NID256, 0x2003fc8)
    FIELD(POR_CFGM_ERRIDR_U_HND_NID256, RESERVED_16, 16, 48)
    FIELD(POR_CFGM_ERRIDR_U_HND_NID256, RECNUM, 0, 16)
REG32(POR_CFGM_ERRPIDR45_U_HND_NID256, 0x2003fd0)
    FIELD(POR_CFGM_ERRPIDR45_U_HND_NID256, RESERVED_40, 40, 24)
    FIELD(POR_CFGM_ERRPIDR45_U_HND_NID256, PIDR5, 32, 8)
    FIELD(POR_CFGM_ERRPIDR45_U_HND_NID256, PIDR4, 0, 8)
REG32(POR_CFGM_ERRPIDR67_U_HND_NID256, 0x2003fd8)
    FIELD(POR_CFGM_ERRPIDR67_U_HND_NID256, RESERVED_40, 40, 24)
    FIELD(POR_CFGM_ERRPIDR67_U_HND_NID256, PIDR7, 32, 8)
    FIELD(POR_CFGM_ERRPIDR67_U_HND_NID256, PIDR6, 0, 8)
REG32(POR_CFGM_ERRPIDR01_U_HND_NID256, 0x2003fe0)
    FIELD(POR_CFGM_ERRPIDR01_U_HND_NID256, RESERVED_40, 40, 24)
    FIELD(POR_CFGM_ERRPIDR01_U_HND_NID256, PIDR1, 32, 8)
    FIELD(POR_CFGM_ERRPIDR01_U_HND_NID256, PIDR0, 0, 8)
REG32(POR_CFGM_ERRPIDR23_U_HND_NID256, 0x2003fe8)
    FIELD(POR_CFGM_ERRPIDR23_U_HND_NID256, RESERVED_40, 40, 24)
    FIELD(POR_CFGM_ERRPIDR23_U_HND_NID256, PIDR3, 32, 8)
    FIELD(POR_CFGM_ERRPIDR23_U_HND_NID256, PIDR2, 0, 8)
REG32(POR_CFGM_ERRCIDR01_U_HND_NID256, 0x2003ff0)
    FIELD(POR_CFGM_ERRCIDR01_U_HND_NID256, RESERVED_40, 40, 24)
    FIELD(POR_CFGM_ERRCIDR01_U_HND_NID256, CIDR1, 32, 8)
    FIELD(POR_CFGM_ERRCIDR01_U_HND_NID256, CIDR0, 0, 8)
REG32(POR_CFGM_ERRCIDR23_U_HND_NID256, 0x2003ff8)
    FIELD(POR_CFGM_ERRCIDR23_U_HND_NID256, RESERVED_40, 40, 24)
    FIELD(POR_CFGM_ERRCIDR23_U_HND_NID256, CIDR3, 32, 8)
    FIELD(POR_CFGM_ERRCIDR23_U_HND_NID256, CIDR2, 0, 8)
REG32(POR_MXP_NODE_INFO_U_SMXP_4_0, 0x2008000)
    FIELD(POR_MXP_NODE_INFO_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MXP_NODE_INFO_U_SMXP_4_0, LOGICAL_ID, 32, 16)
    FIELD(POR_MXP_NODE_INFO_U_SMXP_4_0, XY_ID, 16, 16)
    FIELD(POR_MXP_NODE_INFO_U_SMXP_4_0, NODE_TYPE, 0, 16)
REG32(POR_MXP_DEVICE_PORT_CONNECT_INFO_P0_U_SMXP_4_0, 0x2008008)
    FIELD(POR_MXP_DEVICE_PORT_CONNECT_INFO_P0_U_SMXP_4_0, RESERVED_32, 32, 32)
    FIELD(POR_MXP_DEVICE_PORT_CONNECT_INFO_P0_U_SMXP_4_0, NUM_DCS_P0_D3, 28, 4)
    FIELD(POR_MXP_DEVICE_PORT_CONNECT_INFO_P0_U_SMXP_4_0, NUM_DCS_P0_D2, 24, 4)
    FIELD(POR_MXP_DEVICE_PORT_CONNECT_INFO_P0_U_SMXP_4_0, NUM_DCS_P0_D1, 20, 4)
    FIELD(POR_MXP_DEVICE_PORT_CONNECT_INFO_P0_U_SMXP_4_0, NUM_DCS_P0_D0, 16, 4)
    FIELD(POR_MXP_DEVICE_PORT_CONNECT_INFO_P0_U_SMXP_4_0, DEVICE_TYPE_P0, 0, 5)
REG32(POR_MXP_DEVICE_PORT_CONNECT_INFO_P1_U_SMXP_4_0, 0x2008010)
    FIELD(POR_MXP_DEVICE_PORT_CONNECT_INFO_P1_U_SMXP_4_0, RESERVED_32, 32, 32)
    FIELD(POR_MXP_DEVICE_PORT_CONNECT_INFO_P1_U_SMXP_4_0, NUM_DCS_P1_D3, 28, 4)
    FIELD(POR_MXP_DEVICE_PORT_CONNECT_INFO_P1_U_SMXP_4_0, NUM_DCS_P1_D2, 24, 4)
    FIELD(POR_MXP_DEVICE_PORT_CONNECT_INFO_P1_U_SMXP_4_0, NUM_DCS_P1_D1, 20, 4)
    FIELD(POR_MXP_DEVICE_PORT_CONNECT_INFO_P1_U_SMXP_4_0, NUM_DCS_P1_D0, 16, 4)
    FIELD(POR_MXP_DEVICE_PORT_CONNECT_INFO_P1_U_SMXP_4_0, DEVICE_TYPE_P1, 0, 5)
REG32(POR_MXP_MESH_PORT_CONNECT_INFO_EAST_U_SMXP_4_0, 0x2008018)
    FIELD(POR_MXP_MESH_PORT_CONNECT_INFO_EAST_U_SMXP_4_0, NUM_MCS_EAST, 0, 4)
REG32(POR_MXP_MESH_PORT_CONNECT_INFO_NORTH_U_SMXP_4_0, 0x2008020)
    FIELD(POR_MXP_MESH_PORT_CONNECT_INFO_NORTH_U_SMXP_4_0, NUM_MCS_NORTH, 0, 4)
REG32(POR_MXP_CHILD_INFO_U_SMXP_4_0, 0x2008080)
    FIELD(POR_MXP_CHILD_INFO_U_SMXP_4_0, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_INFO_U_SMXP_4_0, CHILD_PTR_OFFSET, 16, 16)
    FIELD(POR_MXP_CHILD_INFO_U_SMXP_4_0, CHILD_COUNT, 0, 16)
REG32(POR_MXP_CHILD_POINTER_0_U_SMXP_4_0, 0x2008100)
    FIELD(POR_MXP_CHILD_POINTER_0_U_SMXP_4_0, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_POINTER_0_U_SMXP_4_0, RELATIVE_ADDRESS_0, 0, 32)
REG32(POR_MXP_CHILD_POINTER_1_U_SMXP_4_0, 0x2008108)
    FIELD(POR_MXP_CHILD_POINTER_1_U_SMXP_4_0, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_POINTER_1_U_SMXP_4_0, RELATIVE_ADDRESS_1, 0, 32)
REG32(POR_MXP_CHILD_POINTER_2_U_SMXP_4_0, 0x2008110)
    FIELD(POR_MXP_CHILD_POINTER_2_U_SMXP_4_0, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_POINTER_2_U_SMXP_4_0, RELATIVE_ADDRESS_2, 0, 32)
REG32(POR_MXP_CHILD_POINTER_3_U_SMXP_4_0, 0x2008118)
    FIELD(POR_MXP_CHILD_POINTER_3_U_SMXP_4_0, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_POINTER_3_U_SMXP_4_0, RELATIVE_ADDRESS_3, 0, 32)
REG32(POR_MXP_CHILD_POINTER_4_U_SMXP_4_0, 0x2008120)
    FIELD(POR_MXP_CHILD_POINTER_4_U_SMXP_4_0, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_POINTER_4_U_SMXP_4_0, RELATIVE_ADDRESS_4, 0, 32)
REG32(POR_MXP_CHILD_POINTER_5_U_SMXP_4_0, 0x2008128)
    FIELD(POR_MXP_CHILD_POINTER_5_U_SMXP_4_0, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_POINTER_5_U_SMXP_4_0, RELATIVE_ADDRESS_5, 0, 32)
REG32(POR_MXP_CHILD_POINTER_6_U_SMXP_4_0, 0x2008130)
    FIELD(POR_MXP_CHILD_POINTER_6_U_SMXP_4_0, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_POINTER_6_U_SMXP_4_0, RELATIVE_ADDRESS_6, 0, 32)
REG32(POR_MXP_CHILD_POINTER_7_U_SMXP_4_0, 0x2008138)
    FIELD(POR_MXP_CHILD_POINTER_7_U_SMXP_4_0, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_POINTER_7_U_SMXP_4_0, RELATIVE_ADDRESS_7, 0, 32)
REG32(POR_MXP_CHILD_POINTER_8_U_SMXP_4_0, 0x2008140)
    FIELD(POR_MXP_CHILD_POINTER_8_U_SMXP_4_0, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_POINTER_8_U_SMXP_4_0, RELATIVE_ADDRESS_8, 0, 32)
REG32(POR_MXP_CHILD_POINTER_9_U_SMXP_4_0, 0x2008148)
    FIELD(POR_MXP_CHILD_POINTER_9_U_SMXP_4_0, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_POINTER_9_U_SMXP_4_0, RELATIVE_ADDRESS_9, 0, 32)
REG32(POR_MXP_CHILD_POINTER_10_U_SMXP_4_0, 0x2008150)
    FIELD(POR_MXP_CHILD_POINTER_10_U_SMXP_4_0, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_POINTER_10_U_SMXP_4_0, RELATIVE_ADDRESS_10, 0, 32)
REG32(POR_MXP_CHILD_POINTER_11_U_SMXP_4_0, 0x2008158)
    FIELD(POR_MXP_CHILD_POINTER_11_U_SMXP_4_0, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_POINTER_11_U_SMXP_4_0, RELATIVE_ADDRESS_11, 0, 32)
REG32(POR_MXP_CHILD_POINTER_12_U_SMXP_4_0, 0x2008160)
    FIELD(POR_MXP_CHILD_POINTER_12_U_SMXP_4_0, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_POINTER_12_U_SMXP_4_0, RELATIVE_ADDRESS_12, 0, 32)
REG32(POR_MXP_CHILD_POINTER_13_U_SMXP_4_0, 0x2008168)
    FIELD(POR_MXP_CHILD_POINTER_13_U_SMXP_4_0, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_POINTER_13_U_SMXP_4_0, RELATIVE_ADDRESS_13, 0, 32)
REG32(POR_MXP_CHILD_POINTER_14_U_SMXP_4_0, 0x2008170)
    FIELD(POR_MXP_CHILD_POINTER_14_U_SMXP_4_0, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_POINTER_14_U_SMXP_4_0, RELATIVE_ADDRESS_14, 0, 32)
REG32(POR_MXP_CHILD_POINTER_15_U_SMXP_4_0, 0x2008178)
    FIELD(POR_MXP_CHILD_POINTER_15_U_SMXP_4_0, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_POINTER_15_U_SMXP_4_0, RELATIVE_ADDRESS_15, 0, 32)
REG32(POR_MXP_P0_INFO_U_SMXP_4_0, 0x2008900)
    FIELD(POR_MXP_P0_INFO_U_SMXP_4_0, RESERVED_26, 26, 38)
    FIELD(POR_MXP_P0_INFO_U_SMXP_4_0, A4S_SAFE_XFACE_DISABLE_P0, 25, 1)
    FIELD(POR_MXP_P0_INFO_U_SMXP_4_0, CHI_SAFE_XFACE_DISABLE_P0, 24, 1)
    FIELD(POR_MXP_P0_INFO_U_SMXP_4_0, A4S_LOGICALID_BASE_P0, 16, 8)
    FIELD(POR_MXP_P0_INFO_U_SMXP_4_0, RESERVED_14, 14, 2)
    FIELD(POR_MXP_P0_INFO_U_SMXP_4_0, A4S_NUM_P0, 11, 3)
    FIELD(POR_MXP_P0_INFO_U_SMXP_4_0, RXBUF_NUM_ENTRIES_P0, 8, 3)
    FIELD(POR_MXP_P0_INFO_U_SMXP_4_0, EXT_SAM_EN_P0, 7, 1)
    FIELD(POR_MXP_P0_INFO_U_SMXP_4_0, DATACHECK_EN_P0, 5, 1)
    FIELD(POR_MXP_P0_INFO_U_SMXP_4_0, POISON_EN_P0, 4, 1)
    FIELD(POR_MXP_P0_INFO_U_SMXP_4_0, NUM_DEV_P0, 0, 3)
REG32(POR_MXP_P1_INFO_U_SMXP_4_0, 0x2008908)
    FIELD(POR_MXP_P1_INFO_U_SMXP_4_0, RESERVED_26, 26, 38)
    FIELD(POR_MXP_P1_INFO_U_SMXP_4_0, A4S_SAFE_XFACE_DISABLE_P1, 25, 1)
    FIELD(POR_MXP_P1_INFO_U_SMXP_4_0, CHI_SAFE_XFACE_DISABLE_P1, 24, 1)
    FIELD(POR_MXP_P1_INFO_U_SMXP_4_0, A4S_LOGICALID_BASE_P1, 16, 8)
    FIELD(POR_MXP_P1_INFO_U_SMXP_4_0, RESERVED_14, 14, 2)
    FIELD(POR_MXP_P1_INFO_U_SMXP_4_0, A4S_NUM_P1, 11, 3)
    FIELD(POR_MXP_P1_INFO_U_SMXP_4_0, RXBUF_NUM_ENTRIES_P1, 8, 3)
    FIELD(POR_MXP_P1_INFO_U_SMXP_4_0, EXT_SAM_EN_P1, 7, 1)
    FIELD(POR_MXP_P1_INFO_U_SMXP_4_0, DATACHECK_EN_P1, 5, 1)
    FIELD(POR_MXP_P1_INFO_U_SMXP_4_0, POISON_EN_P1, 4, 1)
    FIELD(POR_MXP_P1_INFO_U_SMXP_4_0, NUM_DEV_P1, 0, 3)
REG32(POR_MXP_SECURE_REGISTER_GROUPS_OVERRIDE_U_SMXP_4_0, 0x2008980)
    FIELD(POR_MXP_SECURE_REGISTER_GROUPS_OVERRIDE_U_SMXP_4_0, SYSCOREQ_CTL, 1, 1)
    FIELD(POR_MXP_SECURE_REGISTER_GROUPS_OVERRIDE_U_SMXP_4_0, QOS, 0, 1)
REG32(POR_MXP_AUX_CTL_U_SMXP_4_0, 0x2008a00)
    FIELD(POR_MXP_AUX_CTL_U_SMXP_4_0, CLKGATE_DISABLE, 0, 1)
REG32(POR_MXP_P0_QOS_CONTROL_U_SMXP_4_0, 0x2008a80)
    FIELD(POR_MXP_P0_QOS_CONTROL_U_SMXP_4_0, RESERVED_20, 20, 44)
    FIELD(POR_MXP_P0_QOS_CONTROL_U_SMXP_4_0, P0_QOS_OVERRIDE, 16, 4)
    FIELD(POR_MXP_P0_QOS_CONTROL_U_SMXP_4_0, P0_PQV_MODE, 6, 1)
    FIELD(POR_MXP_P0_QOS_CONTROL_U_SMXP_4_0, P0_REG_MODE, 4, 1)
    FIELD(POR_MXP_P0_QOS_CONTROL_U_SMXP_4_0, P0_QOS_OVERRIDE_EN, 2, 1)
    FIELD(POR_MXP_P0_QOS_CONTROL_U_SMXP_4_0, P0_LAT_EN, 0, 1)
REG32(POR_MXP_P0_QOS_LAT_TGT_U_SMXP_4_0, 0x2008a88)
    FIELD(POR_MXP_P0_QOS_LAT_TGT_U_SMXP_4_0, RESERVED_12, 12, 52)
    FIELD(POR_MXP_P0_QOS_LAT_TGT_U_SMXP_4_0, P0_LAT_TGT, 0, 12)
REG32(POR_MXP_P0_QOS_LAT_SCALE_U_SMXP_4_0, 0x2008a90)
    FIELD(POR_MXP_P0_QOS_LAT_SCALE_U_SMXP_4_0, P0_LAT_SCALE, 0, 3)
REG32(POR_MXP_P0_QOS_LAT_RANGE_U_SMXP_4_0, 0x2008a98)
    FIELD(POR_MXP_P0_QOS_LAT_RANGE_U_SMXP_4_0, RESERVED_12, 12, 52)
    FIELD(POR_MXP_P0_QOS_LAT_RANGE_U_SMXP_4_0, P0_LAT_MAX_QOS, 8, 4)
    FIELD(POR_MXP_P0_QOS_LAT_RANGE_U_SMXP_4_0, P0_LAT_MIN_QOS, 0, 4)
REG32(POR_MXP_P1_QOS_CONTROL_U_SMXP_4_0, 0x2008aa0)
    FIELD(POR_MXP_P1_QOS_CONTROL_U_SMXP_4_0, RESERVED_20, 20, 44)
    FIELD(POR_MXP_P1_QOS_CONTROL_U_SMXP_4_0, P1_QOS_OVERRIDE, 16, 4)
    FIELD(POR_MXP_P1_QOS_CONTROL_U_SMXP_4_0, P1_PQV_MODE, 6, 1)
    FIELD(POR_MXP_P1_QOS_CONTROL_U_SMXP_4_0, P1_REG_MODE, 4, 1)
    FIELD(POR_MXP_P1_QOS_CONTROL_U_SMXP_4_0, P1_QOS_OVERRIDE_EN, 2, 1)
    FIELD(POR_MXP_P1_QOS_CONTROL_U_SMXP_4_0, P1_LAT_EN, 0, 1)
REG32(POR_MXP_P1_QOS_LAT_TGT_U_SMXP_4_0, 0x2008aa8)
    FIELD(POR_MXP_P1_QOS_LAT_TGT_U_SMXP_4_0, RESERVED_12, 12, 52)
    FIELD(POR_MXP_P1_QOS_LAT_TGT_U_SMXP_4_0, P1_LAT_TGT, 0, 12)
REG32(POR_MXP_P1_QOS_LAT_SCALE_U_SMXP_4_0, 0x2008ab0)
    FIELD(POR_MXP_P1_QOS_LAT_SCALE_U_SMXP_4_0, P1_LAT_SCALE, 0, 3)
REG32(POR_MXP_P1_QOS_LAT_RANGE_U_SMXP_4_0, 0x2008ab8)
    FIELD(POR_MXP_P1_QOS_LAT_RANGE_U_SMXP_4_0, RESERVED_12, 12, 52)
    FIELD(POR_MXP_P1_QOS_LAT_RANGE_U_SMXP_4_0, P1_LAT_MAX_QOS, 8, 4)
    FIELD(POR_MXP_P1_QOS_LAT_RANGE_U_SMXP_4_0, P1_LAT_MIN_QOS, 0, 4)
REG32(POR_MXP_P0_SYSCOREQ_CTL_U_SMXP_4_0, 0x2009000)
    FIELD(POR_MXP_P0_SYSCOREQ_CTL_U_SMXP_4_0, SNPDVM_REQ_P0_D3, 3, 1)
    FIELD(POR_MXP_P0_SYSCOREQ_CTL_U_SMXP_4_0, SNPDVM_REQ_P0_D2, 2, 1)
    FIELD(POR_MXP_P0_SYSCOREQ_CTL_U_SMXP_4_0, SNPDVM_REQ_P0_D1, 1, 1)
    FIELD(POR_MXP_P0_SYSCOREQ_CTL_U_SMXP_4_0, SNPDVM_REQ_P0_D0, 0, 1)
REG32(POR_MXP_P1_SYSCOREQ_CTL_U_SMXP_4_0, 0x2009008)
    FIELD(POR_MXP_P1_SYSCOREQ_CTL_U_SMXP_4_0, SNPDVM_REQ_P1_D3, 3, 1)
    FIELD(POR_MXP_P1_SYSCOREQ_CTL_U_SMXP_4_0, SNPDVM_REQ_P1_D2, 2, 1)
    FIELD(POR_MXP_P1_SYSCOREQ_CTL_U_SMXP_4_0, SNPDVM_REQ_P1_D1, 1, 1)
    FIELD(POR_MXP_P1_SYSCOREQ_CTL_U_SMXP_4_0, SNPDVM_REQ_P1_D0, 0, 1)
REG32(POR_MXP_P0_SYSCOACK_STATUS_U_SMXP_4_0, 0x2009010)
    FIELD(POR_MXP_P0_SYSCOACK_STATUS_U_SMXP_4_0, SNPDVM_ACK_P0_D3, 3, 1)
    FIELD(POR_MXP_P0_SYSCOACK_STATUS_U_SMXP_4_0, SNPDVM_ACK_P0_D2, 2, 1)
    FIELD(POR_MXP_P0_SYSCOACK_STATUS_U_SMXP_4_0, SNPDVM_ACK_P0_D1, 1, 1)
    FIELD(POR_MXP_P0_SYSCOACK_STATUS_U_SMXP_4_0, SNPDVM_ACK_P0_D0, 0, 1)
REG32(POR_MXP_P1_SYSCOACK_STATUS_U_SMXP_4_0, 0x2009018)
    FIELD(POR_MXP_P1_SYSCOACK_STATUS_U_SMXP_4_0, SNPDVM_ACK_P1_D3, 3, 1)
    FIELD(POR_MXP_P1_SYSCOACK_STATUS_U_SMXP_4_0, SNPDVM_ACK_P1_D2, 2, 1)
    FIELD(POR_MXP_P1_SYSCOACK_STATUS_U_SMXP_4_0, SNPDVM_ACK_P1_D1, 1, 1)
    FIELD(POR_MXP_P1_SYSCOACK_STATUS_U_SMXP_4_0, SNPDVM_ACK_P1_D0, 0, 1)
REG32(POR_MXP_PMU_EVENT_SEL_U_SMXP_4_0, 0x200a000)
    FIELD(POR_MXP_PMU_EVENT_SEL_U_SMXP_4_0, RESERVED_32, 32, 32)
    FIELD(POR_MXP_PMU_EVENT_SEL_U_SMXP_4_0, PMU_EVENT3_ID, 24, 8)
    FIELD(POR_MXP_PMU_EVENT_SEL_U_SMXP_4_0, PMU_EVENT2_ID, 16, 8)
    FIELD(POR_MXP_PMU_EVENT_SEL_U_SMXP_4_0, PMU_EVENT1_ID, 8, 8)
    FIELD(POR_MXP_PMU_EVENT_SEL_U_SMXP_4_0, PMU_EVENT0_ID, 0, 8)
REG32(POR_DTM_CONTROL_U_SMXP_4_0, 0x200a100)
    FIELD(POR_DTM_CONTROL_U_SMXP_4_0, TRACE_NO_ATB, 3, 1)
    FIELD(POR_DTM_CONTROL_U_SMXP_4_0, SAMPLE_PROFILE_ENABLE, 2, 1)
    FIELD(POR_DTM_CONTROL_U_SMXP_4_0, TRACE_TAG_ENABLE, 1, 1)
    FIELD(POR_DTM_CONTROL_U_SMXP_4_0, DTM_ENABLE, 0, 1)
REG32(POR_DTM_FIFO_ENTRY_READY_U_SMXP_4_0, 0x200a118)
    FIELD(POR_DTM_FIFO_ENTRY_READY_U_SMXP_4_0, READY, 0, 4)
REG32(POR_DTM_FIFO_ENTRY0_0_U_SMXP_4_0, 0x200a120)
REG32(POR_DTM_FIFO_ENTRY0_1_U_SMXP_4_0, 0x200a128)
REG32(POR_DTM_FIFO_ENTRY0_2_U_SMXP_4_0, 0x200a130)
    FIELD(POR_DTM_FIFO_ENTRY0_2_U_SMXP_4_0, RESERVED_32, 32, 32)
    FIELD(POR_DTM_FIFO_ENTRY0_2_U_SMXP_4_0, FIFO_CYCLE_COUNT, 16, 16)
    FIELD(POR_DTM_FIFO_ENTRY0_2_U_SMXP_4_0, FIFO_DATA2, 0, 16)
REG32(POR_DTM_FIFO_ENTRY1_0_U_SMXP_4_0, 0x200a138)
REG32(POR_DTM_FIFO_ENTRY1_1_U_SMXP_4_0, 0x200a140)
REG32(POR_DTM_FIFO_ENTRY1_2_U_SMXP_4_0, 0x200a148)
    FIELD(POR_DTM_FIFO_ENTRY1_2_U_SMXP_4_0, RESERVED_32, 32, 32)
    FIELD(POR_DTM_FIFO_ENTRY1_2_U_SMXP_4_0, FIFO_CYCLE_COUNT, 16, 16)
    FIELD(POR_DTM_FIFO_ENTRY1_2_U_SMXP_4_0, FIFO_DATA2, 0, 16)
REG32(POR_DTM_FIFO_ENTRY2_0_U_SMXP_4_0, 0x200a150)
REG32(POR_DTM_FIFO_ENTRY2_1_U_SMXP_4_0, 0x200a158)
REG32(POR_DTM_FIFO_ENTRY2_2_U_SMXP_4_0, 0x200a160)
    FIELD(POR_DTM_FIFO_ENTRY2_2_U_SMXP_4_0, RESERVED_32, 32, 32)
    FIELD(POR_DTM_FIFO_ENTRY2_2_U_SMXP_4_0, FIFO_CYCLE_COUNT, 16, 16)
    FIELD(POR_DTM_FIFO_ENTRY2_2_U_SMXP_4_0, FIFO_DATA2, 0, 16)
REG32(POR_DTM_FIFO_ENTRY3_0_U_SMXP_4_0, 0x200a168)
REG32(POR_DTM_FIFO_ENTRY3_1_U_SMXP_4_0, 0x200a170)
REG32(POR_DTM_FIFO_ENTRY3_2_U_SMXP_4_0, 0x200a178)
    FIELD(POR_DTM_FIFO_ENTRY3_2_U_SMXP_4_0, RESERVED_32, 32, 32)
    FIELD(POR_DTM_FIFO_ENTRY3_2_U_SMXP_4_0, FIFO_CYCLE_COUNT, 16, 16)
    FIELD(POR_DTM_FIFO_ENTRY3_2_U_SMXP_4_0, FIFO_DATA2, 0, 16)
REG32(POR_DTM_WP0_CONFIG_U_SMXP_4_0, 0x200a1a0)
    FIELD(POR_DTM_WP0_CONFIG_U_SMXP_4_0, RESERVED_15, 15, 49)
    FIELD(POR_DTM_WP0_CONFIG_U_SMXP_4_0, WP_DBGTRIG_EN, 14, 1)
    FIELD(POR_DTM_WP0_CONFIG_U_SMXP_4_0, WP_CTRIG_EN, 13, 1)
    FIELD(POR_DTM_WP0_CONFIG_U_SMXP_4_0, WP_CC_EN, 12, 1)
    FIELD(POR_DTM_WP0_CONFIG_U_SMXP_4_0, WP_PKT_TYPE, 9, 3)
    FIELD(POR_DTM_WP0_CONFIG_U_SMXP_4_0, WP_PKT_GEN, 8, 1)
    FIELD(POR_DTM_WP0_CONFIG_U_SMXP_4_0, WP_COMBINE, 6, 1)
    FIELD(POR_DTM_WP0_CONFIG_U_SMXP_4_0, WP_EXCLUSIVE, 5, 1)
    FIELD(POR_DTM_WP0_CONFIG_U_SMXP_4_0, WP_GRP, 4, 1)
    FIELD(POR_DTM_WP0_CONFIG_U_SMXP_4_0, WP_CHN_SEL, 1, 3)
    FIELD(POR_DTM_WP0_CONFIG_U_SMXP_4_0, WP_DEV_SEL, 0, 1)
REG32(POR_DTM_WP0_VAL_U_SMXP_4_0, 0x200a1a8)
REG32(POR_DTM_WP0_MASK_U_SMXP_4_0, 0x200a1b0)
REG32(POR_DTM_WP1_CONFIG_U_SMXP_4_0, 0x200a1b8)
    FIELD(POR_DTM_WP1_CONFIG_U_SMXP_4_0, RESERVED_15, 15, 49)
    FIELD(POR_DTM_WP1_CONFIG_U_SMXP_4_0, WP_DBGTRIG_EN, 14, 1)
    FIELD(POR_DTM_WP1_CONFIG_U_SMXP_4_0, WP_CTRIG_EN, 13, 1)
    FIELD(POR_DTM_WP1_CONFIG_U_SMXP_4_0, WP_CC_EN, 12, 1)
    FIELD(POR_DTM_WP1_CONFIG_U_SMXP_4_0, WP_PKT_TYPE, 9, 3)
    FIELD(POR_DTM_WP1_CONFIG_U_SMXP_4_0, WP_PKT_GEN, 8, 1)
    FIELD(POR_DTM_WP1_CONFIG_U_SMXP_4_0, WP_EXCLUSIVE, 5, 1)
    FIELD(POR_DTM_WP1_CONFIG_U_SMXP_4_0, WP_GRP, 4, 1)
    FIELD(POR_DTM_WP1_CONFIG_U_SMXP_4_0, WP_CHN_SEL, 1, 3)
    FIELD(POR_DTM_WP1_CONFIG_U_SMXP_4_0, WP_DEV_SEL, 0, 1)
REG32(POR_DTM_WP1_VAL_U_SMXP_4_0, 0x200a1c0)
REG32(POR_DTM_WP1_MASK_U_SMXP_4_0, 0x200a1c8)
REG32(POR_DTM_WP2_CONFIG_U_SMXP_4_0, 0x200a1d0)
    FIELD(POR_DTM_WP2_CONFIG_U_SMXP_4_0, RESERVED_15, 15, 49)
    FIELD(POR_DTM_WP2_CONFIG_U_SMXP_4_0, WP_DBGTRIG_EN, 14, 1)
    FIELD(POR_DTM_WP2_CONFIG_U_SMXP_4_0, WP_CTRIG_EN, 13, 1)
    FIELD(POR_DTM_WP2_CONFIG_U_SMXP_4_0, WP_CC_EN, 12, 1)
    FIELD(POR_DTM_WP2_CONFIG_U_SMXP_4_0, WP_PKT_TYPE, 9, 3)
    FIELD(POR_DTM_WP2_CONFIG_U_SMXP_4_0, WP_PKT_GEN, 8, 1)
    FIELD(POR_DTM_WP2_CONFIG_U_SMXP_4_0, WP_COMBINE, 6, 1)
    FIELD(POR_DTM_WP2_CONFIG_U_SMXP_4_0, WP_EXCLUSIVE, 5, 1)
    FIELD(POR_DTM_WP2_CONFIG_U_SMXP_4_0, WP_GRP, 4, 1)
    FIELD(POR_DTM_WP2_CONFIG_U_SMXP_4_0, WP_CHN_SEL, 1, 3)
    FIELD(POR_DTM_WP2_CONFIG_U_SMXP_4_0, WP_DEV_SEL, 0, 1)
REG32(POR_DTM_WP2_VAL_U_SMXP_4_0, 0x200a1d8)
REG32(POR_DTM_WP2_MASK_U_SMXP_4_0, 0x200a1e0)
REG32(POR_DTM_WP3_CONFIG_U_SMXP_4_0, 0x200a1e8)
    FIELD(POR_DTM_WP3_CONFIG_U_SMXP_4_0, RESERVED_15, 15, 49)
    FIELD(POR_DTM_WP3_CONFIG_U_SMXP_4_0, WP_DBGTRIG_EN, 14, 1)
    FIELD(POR_DTM_WP3_CONFIG_U_SMXP_4_0, WP_CTRIG_EN, 13, 1)
    FIELD(POR_DTM_WP3_CONFIG_U_SMXP_4_0, WP_CC_EN, 12, 1)
    FIELD(POR_DTM_WP3_CONFIG_U_SMXP_4_0, WP_PKT_TYPE, 9, 3)
    FIELD(POR_DTM_WP3_CONFIG_U_SMXP_4_0, WP_PKT_GEN, 8, 1)
    FIELD(POR_DTM_WP3_CONFIG_U_SMXP_4_0, WP_EXCLUSIVE, 5, 1)
    FIELD(POR_DTM_WP3_CONFIG_U_SMXP_4_0, WP_GRP, 4, 1)
    FIELD(POR_DTM_WP3_CONFIG_U_SMXP_4_0, WP_CHN_SEL, 1, 3)
    FIELD(POR_DTM_WP3_CONFIG_U_SMXP_4_0, WP_DEV_SEL, 0, 1)
REG32(POR_DTM_WP3_VAL_U_SMXP_4_0, 0x200a1f0)
REG32(POR_DTM_WP3_MASK_U_SMXP_4_0, 0x200a1f8)
REG32(POR_DTM_PMSICR_U_SMXP_4_0, 0x200a200)
    FIELD(POR_DTM_PMSICR_U_SMXP_4_0, RESERVED_32, 32, 32)
    FIELD(POR_DTM_PMSICR_U_SMXP_4_0, COUNT, 0, 32)
REG32(POR_DTM_PMSIRR_U_SMXP_4_0, 0x200a208)
    FIELD(POR_DTM_PMSIRR_U_SMXP_4_0, RESERVED_32, 32, 32)
    FIELD(POR_DTM_PMSIRR_U_SMXP_4_0, INTERVAL, 8, 24)
    FIELD(POR_DTM_PMSIRR_U_SMXP_4_0, RESERVED_0, 0, 8)
REG32(POR_DTM_PMU_CONFIG_U_SMXP_4_0, 0x200a210)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_4_0, RESERVED_62, 62, 2)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_4_0, PMEVCNT3_INPUT_SEL, 56, 6)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_4_0, RESERVED_54, 54, 2)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_4_0, PMEVCNT2_INPUT_SEL, 48, 6)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_4_0, RESERVED_46, 46, 2)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_4_0, PMEVCNT1_INPUT_SEL, 40, 6)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_4_0, RESERVED_38, 38, 2)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_4_0, PMEVCNT0_INPUT_SEL, 32, 6)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_4_0, RESERVED_31, 31, 1)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_4_0, PMEVCNT3_GLOBAL_NUM, 28, 3)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_4_0, RESERVED_27, 27, 1)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_4_0, PMEVCNT2_GLOBAL_NUM, 24, 3)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_4_0, RESERVED_23, 23, 1)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_4_0, PMEVCNT1_GLOBAL_NUM, 20, 3)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_4_0, RESERVED_19, 19, 1)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_4_0, PMEVCNT0_GLOBAL_NUM, 16, 3)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_4_0, RESERVED_9, 9, 7)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_4_0, CNTR_RST, 8, 1)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_4_0, PMEVCNT_PAIRED, 4, 4)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_4_0, PMEVCNTALL_COMBINED, 3, 1)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_4_0, PMEVCNT23_COMBINED, 2, 1)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_4_0, PMEVCNT01_COMBINED, 1, 1)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_4_0, PMU_EN, 0, 1)
REG32(POR_DTM_PMEVCNT_U_SMXP_4_0, 0x200a220)
    FIELD(POR_DTM_PMEVCNT_U_SMXP_4_0, PMEVCNT3, 48, 16)
    FIELD(POR_DTM_PMEVCNT_U_SMXP_4_0, PMEVCNT2, 32, 16)
    FIELD(POR_DTM_PMEVCNT_U_SMXP_4_0, PMEVCNT1, 16, 16)
    FIELD(POR_DTM_PMEVCNT_U_SMXP_4_0, PMEVCNT0, 0, 16)
REG32(POR_DTM_PMEVCNTSR_U_SMXP_4_0, 0x200a240)
    FIELD(POR_DTM_PMEVCNTSR_U_SMXP_4_0, PMEVCNTSR3, 48, 16)
    FIELD(POR_DTM_PMEVCNTSR_U_SMXP_4_0, PMEVCNTSR2, 32, 16)
    FIELD(POR_DTM_PMEVCNTSR_U_SMXP_4_0, PMEVCNTSR1, 16, 16)
    FIELD(POR_DTM_PMEVCNTSR_U_SMXP_4_0, PMEVCNTSR0, 0, 16)
REG32(POR_MXP_ERRFR_U_SMXP_4_0, 0x200b000)
    FIELD(POR_MXP_ERRFR_U_SMXP_4_0, RESERVED_15, 15, 49)
    FIELD(POR_MXP_ERRFR_U_SMXP_4_0, CEC, 12, 3)
    FIELD(POR_MXP_ERRFR_U_SMXP_4_0, CFI, 10, 2)
    FIELD(POR_MXP_ERRFR_U_SMXP_4_0, FI, 6, 2)
    FIELD(POR_MXP_ERRFR_U_SMXP_4_0, UI, 4, 2)
    FIELD(POR_MXP_ERRFR_U_SMXP_4_0, DE, 2, 2)
    FIELD(POR_MXP_ERRFR_U_SMXP_4_0, ED, 0, 2)
REG32(POR_MXP_ERRCTLR_U_SMXP_4_0, 0x200b008)
    FIELD(POR_MXP_ERRCTLR_U_SMXP_4_0, RESERVED_9, 9, 55)
    FIELD(POR_MXP_ERRCTLR_U_SMXP_4_0, CFI, 8, 1)
    FIELD(POR_MXP_ERRCTLR_U_SMXP_4_0, FI, 3, 1)
    FIELD(POR_MXP_ERRCTLR_U_SMXP_4_0, UI, 2, 1)
    FIELD(POR_MXP_ERRCTLR_U_SMXP_4_0, DE, 1, 1)
    FIELD(POR_MXP_ERRCTLR_U_SMXP_4_0, ED, 0, 1)
REG32(POR_MXP_ERRSTATUS_U_SMXP_4_0, 0x200b010)
    FIELD(POR_MXP_ERRSTATUS_U_SMXP_4_0, RESERVED_32, 32, 32)
    FIELD(POR_MXP_ERRSTATUS_U_SMXP_4_0, AV, 31, 1)
    FIELD(POR_MXP_ERRSTATUS_U_SMXP_4_0, V, 30, 1)
    FIELD(POR_MXP_ERRSTATUS_U_SMXP_4_0, UE, 29, 1)
    FIELD(POR_MXP_ERRSTATUS_U_SMXP_4_0, RESERVED_28, 28, 1)
    FIELD(POR_MXP_ERRSTATUS_U_SMXP_4_0, OF, 27, 1)
    FIELD(POR_MXP_ERRSTATUS_U_SMXP_4_0, MV, 26, 1)
    FIELD(POR_MXP_ERRSTATUS_U_SMXP_4_0, RESERVED_25, 25, 1)
    FIELD(POR_MXP_ERRSTATUS_U_SMXP_4_0, CE, 24, 1)
    FIELD(POR_MXP_ERRSTATUS_U_SMXP_4_0, DE, 23, 1)
    FIELD(POR_MXP_ERRSTATUS_U_SMXP_4_0, RESERVED_0, 0, 23)
REG32(POR_MXP_ERRMISC_U_SMXP_4_0, 0x200b028)
    FIELD(POR_MXP_ERRMISC_U_SMXP_4_0, RESERVED_59, 59, 5)
    FIELD(POR_MXP_ERRMISC_U_SMXP_4_0, TGTID, 48, 11)
    FIELD(POR_MXP_ERRMISC_U_SMXP_4_0, RESERVED_22, 22, 26)
    FIELD(POR_MXP_ERRMISC_U_SMXP_4_0, OPCODE, 16, 6)
    FIELD(POR_MXP_ERRMISC_U_SMXP_4_0, RESERVED_15, 15, 1)
    FIELD(POR_MXP_ERRMISC_U_SMXP_4_0, SRCID, 4, 11)
    FIELD(POR_MXP_ERRMISC_U_SMXP_4_0, ERRSRC, 0, 3)
REG32(POR_MXP_P0_BYTE_PAR_ERR_INJ_U_SMXP_4_0, 0x200b030)
    FIELD(POR_MXP_P0_BYTE_PAR_ERR_INJ_U_SMXP_4_0, P0_BYTE_PARITY_ERR_INJ, 0, 5)
REG32(POR_MXP_P1_BYTE_PAR_ERR_INJ_U_SMXP_4_0, 0x200b038)
    FIELD(POR_MXP_P1_BYTE_PAR_ERR_INJ_U_SMXP_4_0, P1_BYTE_PARITY_ERR_INJ, 0, 5)
REG32(POR_MXP_ERRFR_NS_U_SMXP_4_0, 0x200b100)
    FIELD(POR_MXP_ERRFR_NS_U_SMXP_4_0, RESERVED_15, 15, 49)
    FIELD(POR_MXP_ERRFR_NS_U_SMXP_4_0, CEC, 12, 3)
    FIELD(POR_MXP_ERRFR_NS_U_SMXP_4_0, CFI, 10, 2)
    FIELD(POR_MXP_ERRFR_NS_U_SMXP_4_0, FI, 6, 2)
    FIELD(POR_MXP_ERRFR_NS_U_SMXP_4_0, UI, 4, 2)
    FIELD(POR_MXP_ERRFR_NS_U_SMXP_4_0, DE, 2, 2)
    FIELD(POR_MXP_ERRFR_NS_U_SMXP_4_0, ED, 0, 2)
REG32(POR_MXP_ERRCTLR_NS_U_SMXP_4_0, 0x200b108)
    FIELD(POR_MXP_ERRCTLR_NS_U_SMXP_4_0, RESERVED_9, 9, 55)
    FIELD(POR_MXP_ERRCTLR_NS_U_SMXP_4_0, CFI, 8, 1)
    FIELD(POR_MXP_ERRCTLR_NS_U_SMXP_4_0, FI, 3, 1)
    FIELD(POR_MXP_ERRCTLR_NS_U_SMXP_4_0, UI, 2, 1)
    FIELD(POR_MXP_ERRCTLR_NS_U_SMXP_4_0, DE, 1, 1)
    FIELD(POR_MXP_ERRCTLR_NS_U_SMXP_4_0, ED, 0, 1)
REG32(POR_MXP_ERRSTATUS_NS_U_SMXP_4_0, 0x200b110)
    FIELD(POR_MXP_ERRSTATUS_NS_U_SMXP_4_0, RESERVED_32, 32, 32)
    FIELD(POR_MXP_ERRSTATUS_NS_U_SMXP_4_0, AV, 31, 1)
    FIELD(POR_MXP_ERRSTATUS_NS_U_SMXP_4_0, V, 30, 1)
    FIELD(POR_MXP_ERRSTATUS_NS_U_SMXP_4_0, UE, 29, 1)
    FIELD(POR_MXP_ERRSTATUS_NS_U_SMXP_4_0, RESERVED_28, 28, 1)
    FIELD(POR_MXP_ERRSTATUS_NS_U_SMXP_4_0, OF, 27, 1)
    FIELD(POR_MXP_ERRSTATUS_NS_U_SMXP_4_0, MV, 26, 1)
    FIELD(POR_MXP_ERRSTATUS_NS_U_SMXP_4_0, RESERVED_25, 25, 1)
    FIELD(POR_MXP_ERRSTATUS_NS_U_SMXP_4_0, CE, 24, 1)
    FIELD(POR_MXP_ERRSTATUS_NS_U_SMXP_4_0, DE, 23, 1)
    FIELD(POR_MXP_ERRSTATUS_NS_U_SMXP_4_0, RESERVED_0, 0, 23)
REG32(POR_MXP_ERRMISC_NS_U_SMXP_4_0, 0x200b128)
    FIELD(POR_MXP_ERRMISC_NS_U_SMXP_4_0, RESERVED_59, 59, 5)
    FIELD(POR_MXP_ERRMISC_NS_U_SMXP_4_0, TGTID, 48, 11)
    FIELD(POR_MXP_ERRMISC_NS_U_SMXP_4_0, RESERVED_22, 22, 26)
    FIELD(POR_MXP_ERRMISC_NS_U_SMXP_4_0, OPCODE, 16, 6)
    FIELD(POR_MXP_ERRMISC_NS_U_SMXP_4_0, RESERVED_15, 15, 1)
    FIELD(POR_MXP_ERRMISC_NS_U_SMXP_4_0, SRCID, 4, 11)
    FIELD(POR_MXP_ERRMISC_NS_U_SMXP_4_0, ERRSRC, 0, 3)
REG32(POR_RNI_NODE_INFO_U_RNI_NID260, 0x2014000)
    FIELD(POR_RNI_NODE_INFO_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_RNI_NODE_INFO_U_RNI_NID260, LOGICAL_ID, 32, 16)
    FIELD(POR_RNI_NODE_INFO_U_RNI_NID260, NODE_ID, 16, 16)
    FIELD(POR_RNI_NODE_INFO_U_RNI_NID260, NODE_TYPE, 0, 16)
REG32(POR_RNI_CHILD_INFO_U_RNI_NID260, 0x2014080)
    FIELD(POR_RNI_CHILD_INFO_U_RNI_NID260, RESERVED_32, 32, 32)
    FIELD(POR_RNI_CHILD_INFO_U_RNI_NID260, CHILD_PTR_OFFSET, 16, 16)
    FIELD(POR_RNI_CHILD_INFO_U_RNI_NID260, CHILD_COUNT, 0, 16)
REG32(POR_RNI_UNIT_INFO_U_RNI_NID260, 0x2014900)
    FIELD(POR_RNI_UNIT_INFO_U_RNI_NID260, RESERVED_46, 46, 18)
    FIELD(POR_RNI_UNIT_INFO_U_RNI_NID260, A4S_SAFE_XFACE_DISABLE, 45, 1)
    FIELD(POR_RNI_UNIT_INFO_U_RNI_NID260, ACEL_SAFE_XFACE_DISABLE, 44, 1)
    FIELD(POR_RNI_UNIT_INFO_U_RNI_NID260, A4S_LOGICALID_BASE, 36, 8)
    FIELD(POR_RNI_UNIT_INFO_U_RNI_NID260, RESERVED_34, 34, 2)
    FIELD(POR_RNI_UNIT_INFO_U_RNI_NID260, A4S_NUM, 32, 2)
    FIELD(POR_RNI_UNIT_INFO_U_RNI_NID260, RESERVED_29, 29, 3)
    FIELD(POR_RNI_UNIT_INFO_U_RNI_NID260, FORCE_RDB_PREALLOC, 28, 1)
    FIELD(POR_RNI_UNIT_INFO_U_RNI_NID260, AX_DATAPOISON_EN, 27, 1)
    FIELD(POR_RNI_UNIT_INFO_U_RNI_NID260, AX_DATA_256BIT, 26, 1)
    FIELD(POR_RNI_UNIT_INFO_U_RNI_NID260, RESERVED_24, 24, 2)
    FIELD(POR_RNI_UNIT_INFO_U_RNI_NID260, NUM_RD_BUFS, 16, 8)
    FIELD(POR_RNI_UNIT_INFO_U_RNI_NID260, NUM_RD_REQS, 8, 8)
    FIELD(POR_RNI_UNIT_INFO_U_RNI_NID260, NUM_WR_REQS, 0, 8)
REG32(POR_RNI_SECURE_REGISTER_GROUPS_OVERRIDE_U_RNI_NID260, 0x2014980)
    FIELD(POR_RNI_SECURE_REGISTER_GROUPS_OVERRIDE_U_RNI_NID260, QOS_CTRL, 2, 1)
    FIELD(POR_RNI_SECURE_REGISTER_GROUPS_OVERRIDE_U_RNI_NID260, PORT_CTRL, 1, 1)
    FIELD(POR_RNI_SECURE_REGISTER_GROUPS_OVERRIDE_U_RNI_NID260, CFG_CTL, 0, 1)
REG32(POR_RNI_CFG_CTL_U_RNI_NID260, 0x2014a00)
    FIELD(POR_RNI_CFG_CTL_U_RNI_NID260, RESERVED_32, 32, 32)
    FIELD(POR_RNI_CFG_CTL_U_RNI_NID260, MAX_WRT_OUTSTD_CHITXN_CNT, 24, 8)
    FIELD(POR_RNI_CFG_CTL_U_RNI_NID260, MAX_RRT_OUTSTD_CHITXN_CNT, 16, 8)
    FIELD(POR_RNI_CFG_CTL_U_RNI_NID260, RESERVED_15, 15, 1)
    FIELD(POR_RNI_CFG_CTL_U_RNI_NID260, WRT_CRDGNT_WEIGHT, 12, 3)
    FIELD(POR_RNI_CFG_CTL_U_RNI_NID260, RESERVED_11, 11, 1)
    FIELD(POR_RNI_CFG_CTL_U_RNI_NID260, RRT_CRDGNT_WEIGHT, 8, 3)
    FIELD(POR_RNI_CFG_CTL_U_RNI_NID260, DIS_NCWR_STREAM, 6, 1)
    FIELD(POR_RNI_CFG_CTL_U_RNI_NID260, PCIE_MSTR_PRESENT, 5, 1)
    FIELD(POR_RNI_CFG_CTL_U_RNI_NID260, QPC15_ENTRY_RSV_EN, 4, 1)
    FIELD(POR_RNI_CFG_CTL_U_RNI_NID260, FORCE_PREALLOC_RDB, 3, 1)
    FIELD(POR_RNI_CFG_CTL_U_RNI_NID260, DIS_WR_STREAM, 2, 1)
    FIELD(POR_RNI_CFG_CTL_U_RNI_NID260, WFC, 1, 1)
    FIELD(POR_RNI_CFG_CTL_U_RNI_NID260, QPC_EN, 0, 1)
REG32(POR_RNI_AUX_CTL_U_RNI_NID260, 0x2014a08)
    FIELD(POR_RNI_AUX_CTL_U_RNI_NID260, SAMEID_WRSTASH_STREAM_EN, 5, 1)
    FIELD(POR_RNI_AUX_CTL_U_RNI_NID260, UPSTRM_DATCHECK_EN, 4, 1)
    FIELD(POR_RNI_AUX_CTL_U_RNI_NID260, DIS_NORM_RDSTREAM, 3, 1)
    FIELD(POR_RNI_AUX_CTL_U_RNI_NID260, PARK_PORT_ARB_PTR, 2, 1)
    FIELD(POR_RNI_AUX_CTL_U_RNI_NID260, AR_BYP_EN, 1, 1)
    FIELD(POR_RNI_AUX_CTL_U_RNI_NID260, CG_DISABLE, 0, 1)
REG32(POR_RNI_S0_PORT_CONTROL_U_RNI_NID260, 0x2014a10)
    FIELD(POR_RNI_S0_PORT_CONTROL_U_RNI_NID260, RESERVED_11, 11, 53)
    FIELD(POR_RNI_S0_PORT_CONTROL_U_RNI_NID260, S0_LPID_MASK, 0, 11)
REG32(POR_RNI_S1_PORT_CONTROL_U_RNI_NID260, 0x2014a18)
    FIELD(POR_RNI_S1_PORT_CONTROL_U_RNI_NID260, RESERVED_11, 11, 53)
    FIELD(POR_RNI_S1_PORT_CONTROL_U_RNI_NID260, S1_LPID_MASK, 0, 11)
REG32(POR_RNI_S2_PORT_CONTROL_U_RNI_NID260, 0x2014a20)
    FIELD(POR_RNI_S2_PORT_CONTROL_U_RNI_NID260, RESERVED_11, 11, 53)
    FIELD(POR_RNI_S2_PORT_CONTROL_U_RNI_NID260, S2_LPID_MASK, 0, 11)
REG32(POR_RNI_S0_QOS_CONTROL_U_RNI_NID260, 0x2014a80)
    FIELD(POR_RNI_S0_QOS_CONTROL_U_RNI_NID260, RESERVED_24, 24, 40)
    FIELD(POR_RNI_S0_QOS_CONTROL_U_RNI_NID260, S0_AR_QOS_OVERRIDE, 20, 4)
    FIELD(POR_RNI_S0_QOS_CONTROL_U_RNI_NID260, S0_AW_QOS_OVERRIDE, 16, 4)
    FIELD(POR_RNI_S0_QOS_CONTROL_U_RNI_NID260, S0_AR_PQV_MODE, 7, 1)
    FIELD(POR_RNI_S0_QOS_CONTROL_U_RNI_NID260, S0_AW_PQV_MODE, 6, 1)
    FIELD(POR_RNI_S0_QOS_CONTROL_U_RNI_NID260, S0_AR_REG_MODE, 5, 1)
    FIELD(POR_RNI_S0_QOS_CONTROL_U_RNI_NID260, S0_AW_REG_MODE, 4, 1)
    FIELD(POR_RNI_S0_QOS_CONTROL_U_RNI_NID260, S0_AR_QOS_OVERRIDE_EN, 3, 1)
    FIELD(POR_RNI_S0_QOS_CONTROL_U_RNI_NID260, S0_AW_QOS_OVERRIDE_EN, 2, 1)
    FIELD(POR_RNI_S0_QOS_CONTROL_U_RNI_NID260, S0_AR_LAT_EN, 1, 1)
    FIELD(POR_RNI_S0_QOS_CONTROL_U_RNI_NID260, S0_AW_LAT_EN, 0, 1)
REG32(POR_RNI_S0_QOS_LAT_TGT_U_RNI_NID260, 0x2014a88)
    FIELD(POR_RNI_S0_QOS_LAT_TGT_U_RNI_NID260, RESERVED_28, 28, 36)
    FIELD(POR_RNI_S0_QOS_LAT_TGT_U_RNI_NID260, S0_AR_LAT_TGT, 16, 12)
    FIELD(POR_RNI_S0_QOS_LAT_TGT_U_RNI_NID260, RESERVED_12, 12, 4)
    FIELD(POR_RNI_S0_QOS_LAT_TGT_U_RNI_NID260, S0_AW_LAT_TGT, 0, 12)
REG32(POR_RNI_S0_QOS_LAT_SCALE_U_RNI_NID260, 0x2014a90)
    FIELD(POR_RNI_S0_QOS_LAT_SCALE_U_RNI_NID260, RESERVED_11, 11, 53)
    FIELD(POR_RNI_S0_QOS_LAT_SCALE_U_RNI_NID260, S0_AR_LAT_SCALE, 8, 3)
    FIELD(POR_RNI_S0_QOS_LAT_SCALE_U_RNI_NID260, S0_AW_LAT_SCALE, 0, 3)
REG32(POR_RNI_S0_QOS_LAT_RANGE_U_RNI_NID260, 0x2014a98)
    FIELD(POR_RNI_S0_QOS_LAT_RANGE_U_RNI_NID260, RESERVED_28, 28, 36)
    FIELD(POR_RNI_S0_QOS_LAT_RANGE_U_RNI_NID260, S0_AR_LAT_MAX_QOS, 24, 4)
    FIELD(POR_RNI_S0_QOS_LAT_RANGE_U_RNI_NID260, RESERVED_20, 20, 4)
    FIELD(POR_RNI_S0_QOS_LAT_RANGE_U_RNI_NID260, S0_AR_LAT_MIN_QOS, 16, 4)
    FIELD(POR_RNI_S0_QOS_LAT_RANGE_U_RNI_NID260, RESERVED_12, 12, 4)
    FIELD(POR_RNI_S0_QOS_LAT_RANGE_U_RNI_NID260, S0_AW_LAT_MAX_QOS, 8, 4)
    FIELD(POR_RNI_S0_QOS_LAT_RANGE_U_RNI_NID260, S0_AW_LAT_MIN_QOS, 0, 4)
REG32(POR_RNI_S1_QOS_CONTROL_U_RNI_NID260, 0x2014aa0)
    FIELD(POR_RNI_S1_QOS_CONTROL_U_RNI_NID260, RESERVED_24, 24, 40)
    FIELD(POR_RNI_S1_QOS_CONTROL_U_RNI_NID260, S1_AR_QOS_OVERRIDE, 20, 4)
    FIELD(POR_RNI_S1_QOS_CONTROL_U_RNI_NID260, S1_AW_QOS_OVERRIDE, 16, 4)
    FIELD(POR_RNI_S1_QOS_CONTROL_U_RNI_NID260, S1_AR_PQV_MODE, 7, 1)
    FIELD(POR_RNI_S1_QOS_CONTROL_U_RNI_NID260, S1_AW_PQV_MODE, 6, 1)
    FIELD(POR_RNI_S1_QOS_CONTROL_U_RNI_NID260, S1_AR_REG_MODE, 5, 1)
    FIELD(POR_RNI_S1_QOS_CONTROL_U_RNI_NID260, S1_AW_REG_MODE, 4, 1)
    FIELD(POR_RNI_S1_QOS_CONTROL_U_RNI_NID260, S1_AR_QOS_OVERRIDE_EN, 3, 1)
    FIELD(POR_RNI_S1_QOS_CONTROL_U_RNI_NID260, S1_AW_QOS_OVERRIDE_EN, 2, 1)
    FIELD(POR_RNI_S1_QOS_CONTROL_U_RNI_NID260, S1_AR_LAT_EN, 1, 1)
    FIELD(POR_RNI_S1_QOS_CONTROL_U_RNI_NID260, S1_AW_LAT_EN, 0, 1)
REG32(POR_RNI_S1_QOS_LAT_TGT_U_RNI_NID260, 0x2014aa8)
    FIELD(POR_RNI_S1_QOS_LAT_TGT_U_RNI_NID260, RESERVED_28, 28, 36)
    FIELD(POR_RNI_S1_QOS_LAT_TGT_U_RNI_NID260, S1_AR_LAT_TGT, 16, 12)
    FIELD(POR_RNI_S1_QOS_LAT_TGT_U_RNI_NID260, RESERVED_12, 12, 4)
    FIELD(POR_RNI_S1_QOS_LAT_TGT_U_RNI_NID260, S1_AW_LAT_TGT, 0, 12)
REG32(POR_RNI_S1_QOS_LAT_SCALE_U_RNI_NID260, 0x2014ab0)
    FIELD(POR_RNI_S1_QOS_LAT_SCALE_U_RNI_NID260, RESERVED_11, 11, 53)
    FIELD(POR_RNI_S1_QOS_LAT_SCALE_U_RNI_NID260, S1_AR_LAT_SCALE, 8, 3)
    FIELD(POR_RNI_S1_QOS_LAT_SCALE_U_RNI_NID260, S1_AW_LAT_SCALE, 0, 3)
REG32(POR_RNI_S1_QOS_LAT_RANGE_U_RNI_NID260, 0x2014ab8)
    FIELD(POR_RNI_S1_QOS_LAT_RANGE_U_RNI_NID260, RESERVED_28, 28, 36)
    FIELD(POR_RNI_S1_QOS_LAT_RANGE_U_RNI_NID260, S1_AR_LAT_MAX_QOS, 24, 4)
    FIELD(POR_RNI_S1_QOS_LAT_RANGE_U_RNI_NID260, RESERVED_20, 20, 4)
    FIELD(POR_RNI_S1_QOS_LAT_RANGE_U_RNI_NID260, S1_AR_LAT_MIN_QOS, 16, 4)
    FIELD(POR_RNI_S1_QOS_LAT_RANGE_U_RNI_NID260, RESERVED_12, 12, 4)
    FIELD(POR_RNI_S1_QOS_LAT_RANGE_U_RNI_NID260, S1_AW_LAT_MAX_QOS, 8, 4)
    FIELD(POR_RNI_S1_QOS_LAT_RANGE_U_RNI_NID260, S1_AW_LAT_MIN_QOS, 0, 4)
REG32(POR_RNI_S2_QOS_CONTROL_U_RNI_NID260, 0x2014ac0)
    FIELD(POR_RNI_S2_QOS_CONTROL_U_RNI_NID260, RESERVED_24, 24, 40)
    FIELD(POR_RNI_S2_QOS_CONTROL_U_RNI_NID260, S2_AR_QOS_OVERRIDE, 20, 4)
    FIELD(POR_RNI_S2_QOS_CONTROL_U_RNI_NID260, S2_AW_QOS_OVERRIDE, 16, 4)
    FIELD(POR_RNI_S2_QOS_CONTROL_U_RNI_NID260, S2_AR_PQV_MODE, 7, 1)
    FIELD(POR_RNI_S2_QOS_CONTROL_U_RNI_NID260, S2_AW_PQV_MODE, 6, 1)
    FIELD(POR_RNI_S2_QOS_CONTROL_U_RNI_NID260, S2_AR_REG_MODE, 5, 1)
    FIELD(POR_RNI_S2_QOS_CONTROL_U_RNI_NID260, S2_AW_REG_MODE, 4, 1)
    FIELD(POR_RNI_S2_QOS_CONTROL_U_RNI_NID260, S2_AR_QOS_OVERRIDE_EN, 3, 1)
    FIELD(POR_RNI_S2_QOS_CONTROL_U_RNI_NID260, S2_AW_QOS_OVERRIDE_EN, 2, 1)
    FIELD(POR_RNI_S2_QOS_CONTROL_U_RNI_NID260, S2_AR_LAT_EN, 1, 1)
    FIELD(POR_RNI_S2_QOS_CONTROL_U_RNI_NID260, S2_AW_LAT_EN, 0, 1)
REG32(POR_RNI_S2_QOS_LAT_TGT_U_RNI_NID260, 0x2014ac8)
    FIELD(POR_RNI_S2_QOS_LAT_TGT_U_RNI_NID260, RESERVED_28, 28, 36)
    FIELD(POR_RNI_S2_QOS_LAT_TGT_U_RNI_NID260, S2_AR_LAT_TGT, 16, 12)
    FIELD(POR_RNI_S2_QOS_LAT_TGT_U_RNI_NID260, RESERVED_12, 12, 4)
    FIELD(POR_RNI_S2_QOS_LAT_TGT_U_RNI_NID260, S2_AW_LAT_TGT, 0, 12)
REG32(POR_RNI_S2_QOS_LAT_SCALE_U_RNI_NID260, 0x2014ad0)
    FIELD(POR_RNI_S2_QOS_LAT_SCALE_U_RNI_NID260, RESERVED_11, 11, 53)
    FIELD(POR_RNI_S2_QOS_LAT_SCALE_U_RNI_NID260, S2_AR_LAT_SCALE, 8, 3)
    FIELD(POR_RNI_S2_QOS_LAT_SCALE_U_RNI_NID260, S2_AW_LAT_SCALE, 0, 3)
REG32(POR_RNI_S2_QOS_LAT_RANGE_U_RNI_NID260, 0x2014ad8)
    FIELD(POR_RNI_S2_QOS_LAT_RANGE_U_RNI_NID260, RESERVED_28, 28, 36)
    FIELD(POR_RNI_S2_QOS_LAT_RANGE_U_RNI_NID260, S2_AR_LAT_MAX_QOS, 24, 4)
    FIELD(POR_RNI_S2_QOS_LAT_RANGE_U_RNI_NID260, RESERVED_20, 20, 4)
    FIELD(POR_RNI_S2_QOS_LAT_RANGE_U_RNI_NID260, S2_AR_LAT_MIN_QOS, 16, 4)
    FIELD(POR_RNI_S2_QOS_LAT_RANGE_U_RNI_NID260, RESERVED_12, 12, 4)
    FIELD(POR_RNI_S2_QOS_LAT_RANGE_U_RNI_NID260, S2_AW_LAT_MAX_QOS, 8, 4)
    FIELD(POR_RNI_S2_QOS_LAT_RANGE_U_RNI_NID260, S2_AW_LAT_MIN_QOS, 0, 4)
REG32(POR_RNI_PMU_EVENT_SEL_U_RNI_NID260, 0x2016000)
    FIELD(POR_RNI_PMU_EVENT_SEL_U_RNI_NID260, RESERVED_29, 29, 35)
    FIELD(POR_RNI_PMU_EVENT_SEL_U_RNI_NID260, PMU_EVENT3_ID, 24, 5)
    FIELD(POR_RNI_PMU_EVENT_SEL_U_RNI_NID260, RESERVED_21, 21, 3)
    FIELD(POR_RNI_PMU_EVENT_SEL_U_RNI_NID260, PMU_EVENT2_ID, 16, 5)
    FIELD(POR_RNI_PMU_EVENT_SEL_U_RNI_NID260, RESERVED_13, 13, 3)
    FIELD(POR_RNI_PMU_EVENT_SEL_U_RNI_NID260, PMU_EVENT1_ID, 8, 5)
    FIELD(POR_RNI_PMU_EVENT_SEL_U_RNI_NID260, PMU_EVENT0_ID, 0, 5)
REG32(POR_DN_NODE_INFO_U_HND_NID256, 0x2020000)
    FIELD(POR_DN_NODE_INFO_U_HND_NID256, RESERVED_48, 48, 16)
    FIELD(POR_DN_NODE_INFO_U_HND_NID256, LOGICAL_ID, 32, 16)
    FIELD(POR_DN_NODE_INFO_U_HND_NID256, NODE_ID, 16, 16)
    FIELD(POR_DN_NODE_INFO_U_HND_NID256, NODE_TYPE, 0, 16)
REG32(POR_DN_CHILD_INFO_U_HND_NID256, 0x2020080)
    FIELD(POR_DN_CHILD_INFO_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_DN_CHILD_INFO_U_HND_NID256, CHILD_PTR_OFFSET, 16, 16)
    FIELD(POR_DN_CHILD_INFO_U_HND_NID256, CHILD_COUNT, 0, 16)
REG32(POR_DN_BUILD_INFO_U_HND_NID256, 0x2020900)
    FIELD(POR_DN_BUILD_INFO_U_HND_NID256, DVM_V8_1_EN, 0, 1)
REG32(POR_DN_SECURE_REGISTER_GROUPS_OVERRIDE_U_HND_NID256, 0x2020980)
    FIELD(POR_DN_SECURE_REGISTER_GROUPS_OVERRIDE_U_HND_NID256, VMF, 0, 1)
REG32(POR_DN_AUX_CTL_U_HND_NID256, 0x2020a00)
    FIELD(POR_DN_AUX_CTL_U_HND_NID256, ENABLE_RND_ICACHE_OPS, 2, 1)
    FIELD(POR_DN_AUX_CTL_U_HND_NID256, DISABLE_CLK_GATING, 1, 1)
    FIELD(POR_DN_AUX_CTL_U_HND_NID256, DISABLE_VMF, 0, 1)
REG32(POR_DN_VMF0_CTRL_U_HND_NID256, 0x2020c00)
    FIELD(POR_DN_VMF0_CTRL_U_HND_NID256, RESERVED_48, 48, 16)
    FIELD(POR_DN_VMF0_CTRL_U_HND_NID256, MASK, 32, 16)
    FIELD(POR_DN_VMF0_CTRL_U_HND_NID256, RESERVED_17, 17, 15)
    FIELD(POR_DN_VMF0_CTRL_U_HND_NID256, VMID, 1, 16)
    FIELD(POR_DN_VMF0_CTRL_U_HND_NID256, VALID, 0, 1)
REG32(POR_DN_VMF0_RNF0_U_HND_NID256, 0x2020c08)
REG32(POR_DN_VMF0_RND_U_HND_NID256, 0x2020c10)
REG32(POR_DN_VMF0_CXRA_U_HND_NID256, 0x2020c18)
REG32(POR_DN_VMF1_CTRL_U_HND_NID256, 0x2020c20)
    FIELD(POR_DN_VMF1_CTRL_U_HND_NID256, RESERVED_48, 48, 16)
    FIELD(POR_DN_VMF1_CTRL_U_HND_NID256, MASK, 32, 16)
    FIELD(POR_DN_VMF1_CTRL_U_HND_NID256, RESERVED_17, 17, 15)
    FIELD(POR_DN_VMF1_CTRL_U_HND_NID256, VMID, 1, 16)
    FIELD(POR_DN_VMF1_CTRL_U_HND_NID256, VALID, 0, 1)
REG32(POR_DN_VMF1_RNF0_U_HND_NID256, 0x2020c28)
REG32(POR_DN_VMF1_RND_U_HND_NID256, 0x2020c30)
REG32(POR_DN_VMF1_CXRA_U_HND_NID256, 0x2020c38)
REG32(POR_DN_VMF2_CTRL_U_HND_NID256, 0x2020c40)
    FIELD(POR_DN_VMF2_CTRL_U_HND_NID256, RESERVED_48, 48, 16)
    FIELD(POR_DN_VMF2_CTRL_U_HND_NID256, MASK, 32, 16)
    FIELD(POR_DN_VMF2_CTRL_U_HND_NID256, RESERVED_17, 17, 15)
    FIELD(POR_DN_VMF2_CTRL_U_HND_NID256, VMID, 1, 16)
    FIELD(POR_DN_VMF2_CTRL_U_HND_NID256, VALID, 0, 1)
REG32(POR_DN_VMF2_RNF0_U_HND_NID256, 0x2020c48)
REG32(POR_DN_VMF2_RND_U_HND_NID256, 0x2020c50)
REG32(POR_DN_VMF2_CXRA_U_HND_NID256, 0x2020c58)
REG32(POR_DN_VMF3_CTRL_U_HND_NID256, 0x2020c60)
    FIELD(POR_DN_VMF3_CTRL_U_HND_NID256, RESERVED_48, 48, 16)
    FIELD(POR_DN_VMF3_CTRL_U_HND_NID256, MASK, 32, 16)
    FIELD(POR_DN_VMF3_CTRL_U_HND_NID256, RESERVED_17, 17, 15)
    FIELD(POR_DN_VMF3_CTRL_U_HND_NID256, VMID, 1, 16)
    FIELD(POR_DN_VMF3_CTRL_U_HND_NID256, VALID, 0, 1)
REG32(POR_DN_VMF3_RNF0_U_HND_NID256, 0x2020c68)
REG32(POR_DN_VMF3_RND_U_HND_NID256, 0x2020c70)
REG32(POR_DN_VMF3_CXRA_U_HND_NID256, 0x2020c78)
REG32(POR_DN_VMF4_CTRL_U_HND_NID256, 0x2020c80)
    FIELD(POR_DN_VMF4_CTRL_U_HND_NID256, RESERVED_48, 48, 16)
    FIELD(POR_DN_VMF4_CTRL_U_HND_NID256, MASK, 32, 16)
    FIELD(POR_DN_VMF4_CTRL_U_HND_NID256, RESERVED_17, 17, 15)
    FIELD(POR_DN_VMF4_CTRL_U_HND_NID256, VMID, 1, 16)
    FIELD(POR_DN_VMF4_CTRL_U_HND_NID256, VALID, 0, 1)
REG32(POR_DN_VMF4_RNF0_U_HND_NID256, 0x2020c88)
REG32(POR_DN_VMF4_RND_U_HND_NID256, 0x2020c90)
REG32(POR_DN_VMF4_CXRA_U_HND_NID256, 0x2020c98)
REG32(POR_DN_VMF5_CTRL_U_HND_NID256, 0x2020ca0)
    FIELD(POR_DN_VMF5_CTRL_U_HND_NID256, RESERVED_48, 48, 16)
    FIELD(POR_DN_VMF5_CTRL_U_HND_NID256, MASK, 32, 16)
    FIELD(POR_DN_VMF5_CTRL_U_HND_NID256, RESERVED_17, 17, 15)
    FIELD(POR_DN_VMF5_CTRL_U_HND_NID256, VMID, 1, 16)
    FIELD(POR_DN_VMF5_CTRL_U_HND_NID256, VALID, 0, 1)
REG32(POR_DN_VMF5_RNF0_U_HND_NID256, 0x2020ca8)
REG32(POR_DN_VMF5_RND_U_HND_NID256, 0x2020cb0)
REG32(POR_DN_VMF5_CXRA_U_HND_NID256, 0x2020cb8)
REG32(POR_DN_VMF6_CTRL_U_HND_NID256, 0x2020cc0)
    FIELD(POR_DN_VMF6_CTRL_U_HND_NID256, RESERVED_48, 48, 16)
    FIELD(POR_DN_VMF6_CTRL_U_HND_NID256, MASK, 32, 16)
    FIELD(POR_DN_VMF6_CTRL_U_HND_NID256, RESERVED_17, 17, 15)
    FIELD(POR_DN_VMF6_CTRL_U_HND_NID256, VMID, 1, 16)
    FIELD(POR_DN_VMF6_CTRL_U_HND_NID256, VALID, 0, 1)
REG32(POR_DN_VMF6_RNF0_U_HND_NID256, 0x2020cc8)
REG32(POR_DN_VMF6_RND_U_HND_NID256, 0x2020cd0)
REG32(POR_DN_VMF6_CXRA_U_HND_NID256, 0x2020cd8)
REG32(POR_DN_VMF7_CTRL_U_HND_NID256, 0x2020ce0)
    FIELD(POR_DN_VMF7_CTRL_U_HND_NID256, RESERVED_48, 48, 16)
    FIELD(POR_DN_VMF7_CTRL_U_HND_NID256, MASK, 32, 16)
    FIELD(POR_DN_VMF7_CTRL_U_HND_NID256, RESERVED_17, 17, 15)
    FIELD(POR_DN_VMF7_CTRL_U_HND_NID256, VMID, 1, 16)
    FIELD(POR_DN_VMF7_CTRL_U_HND_NID256, VALID, 0, 1)
REG32(POR_DN_VMF7_RNF0_U_HND_NID256, 0x2020ce8)
REG32(POR_DN_VMF7_RND_U_HND_NID256, 0x2020cf0)
REG32(POR_DN_VMF7_CXRA_U_HND_NID256, 0x2020cf8)
REG32(POR_DN_VMF8_CTRL_U_HND_NID256, 0x2020d00)
    FIELD(POR_DN_VMF8_CTRL_U_HND_NID256, RESERVED_48, 48, 16)
    FIELD(POR_DN_VMF8_CTRL_U_HND_NID256, MASK, 32, 16)
    FIELD(POR_DN_VMF8_CTRL_U_HND_NID256, RESERVED_17, 17, 15)
    FIELD(POR_DN_VMF8_CTRL_U_HND_NID256, VMID, 1, 16)
    FIELD(POR_DN_VMF8_CTRL_U_HND_NID256, VALID, 0, 1)
REG32(POR_DN_VMF8_RNF0_U_HND_NID256, 0x2020d08)
REG32(POR_DN_VMF8_RND_U_HND_NID256, 0x2020d10)
REG32(POR_DN_VMF8_CXRA_U_HND_NID256, 0x2020d18)
REG32(POR_DN_VMF9_CTRL_U_HND_NID256, 0x2020d20)
    FIELD(POR_DN_VMF9_CTRL_U_HND_NID256, RESERVED_48, 48, 16)
    FIELD(POR_DN_VMF9_CTRL_U_HND_NID256, MASK, 32, 16)
    FIELD(POR_DN_VMF9_CTRL_U_HND_NID256, RESERVED_17, 17, 15)
    FIELD(POR_DN_VMF9_CTRL_U_HND_NID256, VMID, 1, 16)
    FIELD(POR_DN_VMF9_CTRL_U_HND_NID256, VALID, 0, 1)
REG32(POR_DN_VMF9_RNF0_U_HND_NID256, 0x2020d28)
REG32(POR_DN_VMF9_RND_U_HND_NID256, 0x2020d30)
REG32(POR_DN_VMF9_CXRA_U_HND_NID256, 0x2020d38)
REG32(POR_DN_VMF10_CTRL_U_HND_NID256, 0x2020d40)
    FIELD(POR_DN_VMF10_CTRL_U_HND_NID256, RESERVED_48, 48, 16)
    FIELD(POR_DN_VMF10_CTRL_U_HND_NID256, MASK, 32, 16)
    FIELD(POR_DN_VMF10_CTRL_U_HND_NID256, RESERVED_17, 17, 15)
    FIELD(POR_DN_VMF10_CTRL_U_HND_NID256, VMID, 1, 16)
    FIELD(POR_DN_VMF10_CTRL_U_HND_NID256, VALID, 0, 1)
REG32(POR_DN_VMF10_RNF0_U_HND_NID256, 0x2020d48)
REG32(POR_DN_VMF10_RND_U_HND_NID256, 0x2020d50)
REG32(POR_DN_VMF10_CXRA_U_HND_NID256, 0x2020d58)
REG32(POR_DN_VMF11_CTRL_U_HND_NID256, 0x2020d60)
    FIELD(POR_DN_VMF11_CTRL_U_HND_NID256, RESERVED_48, 48, 16)
    FIELD(POR_DN_VMF11_CTRL_U_HND_NID256, MASK, 32, 16)
    FIELD(POR_DN_VMF11_CTRL_U_HND_NID256, RESERVED_17, 17, 15)
    FIELD(POR_DN_VMF11_CTRL_U_HND_NID256, VMID, 1, 16)
    FIELD(POR_DN_VMF11_CTRL_U_HND_NID256, VALID, 0, 1)
REG32(POR_DN_VMF11_RNF0_U_HND_NID256, 0x2020d68)
REG32(POR_DN_VMF11_RND_U_HND_NID256, 0x2020d70)
REG32(POR_DN_VMF11_CXRA_U_HND_NID256, 0x2020d78)
REG32(POR_DN_VMF12_CTRL_U_HND_NID256, 0x2020d80)
    FIELD(POR_DN_VMF12_CTRL_U_HND_NID256, RESERVED_48, 48, 16)
    FIELD(POR_DN_VMF12_CTRL_U_HND_NID256, MASK, 32, 16)
    FIELD(POR_DN_VMF12_CTRL_U_HND_NID256, RESERVED_17, 17, 15)
    FIELD(POR_DN_VMF12_CTRL_U_HND_NID256, VMID, 1, 16)
    FIELD(POR_DN_VMF12_CTRL_U_HND_NID256, VALID, 0, 1)
REG32(POR_DN_VMF12_RNF0_U_HND_NID256, 0x2020d88)
REG32(POR_DN_VMF12_RND_U_HND_NID256, 0x2020d90)
REG32(POR_DN_VMF12_CXRA_U_HND_NID256, 0x2020d98)
REG32(POR_DN_VMF13_CTRL_U_HND_NID256, 0x2020da0)
    FIELD(POR_DN_VMF13_CTRL_U_HND_NID256, RESERVED_48, 48, 16)
    FIELD(POR_DN_VMF13_CTRL_U_HND_NID256, MASK, 32, 16)
    FIELD(POR_DN_VMF13_CTRL_U_HND_NID256, RESERVED_17, 17, 15)
    FIELD(POR_DN_VMF13_CTRL_U_HND_NID256, VMID, 1, 16)
    FIELD(POR_DN_VMF13_CTRL_U_HND_NID256, VALID, 0, 1)
REG32(POR_DN_VMF13_RNF0_U_HND_NID256, 0x2020da8)
REG32(POR_DN_VMF13_RND_U_HND_NID256, 0x2020db0)
REG32(POR_DN_VMF13_CXRA_U_HND_NID256, 0x2020db8)
REG32(POR_DN_VMF14_CTRL_U_HND_NID256, 0x2020dc0)
    FIELD(POR_DN_VMF14_CTRL_U_HND_NID256, RESERVED_48, 48, 16)
    FIELD(POR_DN_VMF14_CTRL_U_HND_NID256, MASK, 32, 16)
    FIELD(POR_DN_VMF14_CTRL_U_HND_NID256, RESERVED_17, 17, 15)
    FIELD(POR_DN_VMF14_CTRL_U_HND_NID256, VMID, 1, 16)
    FIELD(POR_DN_VMF14_CTRL_U_HND_NID256, VALID, 0, 1)
REG32(POR_DN_VMF14_RNF0_U_HND_NID256, 0x2020dc8)
REG32(POR_DN_VMF14_RND_U_HND_NID256, 0x2020dd0)
REG32(POR_DN_VMF14_CXRA_U_HND_NID256, 0x2020dd8)
REG32(POR_DN_VMF15_CTRL_U_HND_NID256, 0x2020de0)
    FIELD(POR_DN_VMF15_CTRL_U_HND_NID256, RESERVED_48, 48, 16)
    FIELD(POR_DN_VMF15_CTRL_U_HND_NID256, MASK, 32, 16)
    FIELD(POR_DN_VMF15_CTRL_U_HND_NID256, RESERVED_17, 17, 15)
    FIELD(POR_DN_VMF15_CTRL_U_HND_NID256, VMID, 1, 16)
    FIELD(POR_DN_VMF15_CTRL_U_HND_NID256, VALID, 0, 1)
REG32(POR_DN_VMF15_RNF0_U_HND_NID256, 0x2020de8)
REG32(POR_DN_VMF15_RND_U_HND_NID256, 0x2020df0)
REG32(POR_DN_VMF15_CXRA_U_HND_NID256, 0x2020df8)
REG32(POR_DN_PMU_EVENT_SEL_U_HND_NID256, 0x2022000)
    FIELD(POR_DN_PMU_EVENT_SEL_U_HND_NID256, RESERVED_36, 36, 28)
    FIELD(POR_DN_PMU_EVENT_SEL_U_HND_NID256, PMU_OCCUP1_ID, 32, 4)
    FIELD(POR_DN_PMU_EVENT_SEL_U_HND_NID256, RESERVED_30, 30, 2)
    FIELD(POR_DN_PMU_EVENT_SEL_U_HND_NID256, PMU_EVENT3_ID, 24, 6)
    FIELD(POR_DN_PMU_EVENT_SEL_U_HND_NID256, RESERVED_22, 22, 2)
    FIELD(POR_DN_PMU_EVENT_SEL_U_HND_NID256, PMU_EVENT2_ID, 16, 6)
    FIELD(POR_DN_PMU_EVENT_SEL_U_HND_NID256, RESERVED_14, 14, 2)
    FIELD(POR_DN_PMU_EVENT_SEL_U_HND_NID256, PMU_EVENT1_ID, 8, 6)
    FIELD(POR_DN_PMU_EVENT_SEL_U_HND_NID256, PMU_EVENT0_ID, 0, 6)
REG32(POR_RNSAM_NODE_INFO_U_RNI_NID260, 0x2024000)
    FIELD(POR_RNSAM_NODE_INFO_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_RNSAM_NODE_INFO_U_RNI_NID260, LOGICAL_ID, 32, 16)
    FIELD(POR_RNSAM_NODE_INFO_U_RNI_NID260, NODE_ID, 16, 16)
    FIELD(POR_RNSAM_NODE_INFO_U_RNI_NID260, NODE_TYPE, 0, 16)
REG32(POR_RNSAM_CHILD_INFO_U_RNI_NID260, 0x2024080)
    FIELD(POR_RNSAM_CHILD_INFO_U_RNI_NID260, RESERVED_32, 32, 32)
    FIELD(POR_RNSAM_CHILD_INFO_U_RNI_NID260, CHILD_PTR_OFFSET, 16, 16)
    FIELD(POR_RNSAM_CHILD_INFO_U_RNI_NID260, CHILD_COUNT, 0, 16)
REG32(POR_RNSAM_UNIT_INFO_U_RNI_NID260, 0x2024900)
    FIELD(POR_RNSAM_UNIT_INFO_U_RNI_NID260, RESERVED_37, 37, 27)
    FIELD(POR_RNSAM_UNIT_INFO_U_RNI_NID260, NUM_NON_HASH_GROUP, 32, 5)
    FIELD(POR_RNSAM_UNIT_INFO_U_RNI_NID260, RESERVED_20, 20, 12)
    FIELD(POR_RNSAM_UNIT_INFO_U_RNI_NID260, NUM_SYS_CACHE_GROUP, 16, 4)
    FIELD(POR_RNSAM_UNIT_INFO_U_RNI_NID260, NUM_HNF, 0, 8)
REG32(POR_RNSAM_SECURE_REGISTER_GROUPS_OVERRIDE_U_RNI_NID260, 0x2024980)
    FIELD(POR_RNSAM_SECURE_REGISTER_GROUPS_OVERRIDE_U_RNI_NID260, MEM_RANGE, 0, 1)
REG32(RNSAM_STATUS_U_RNI_NID260, 0x2024c00)
    FIELD(RNSAM_STATUS_U_RNI_NID260, NSTALL_REQ, 1, 1)
    FIELD(RNSAM_STATUS_U_RNI_NID260, USE_DEFAULT_NODE, 0, 1)
REG32(NON_HASH_MEM_REGION_REG0_U_RNI_NID260, 0x2024c08)
    FIELD(NON_HASH_MEM_REGION_REG0_U_RNI_NID260, RESERVED_63, 63, 1)
    FIELD(NON_HASH_MEM_REGION_REG0_U_RNI_NID260, REGION1_BASE_ADDR, 41, 22)
    FIELD(NON_HASH_MEM_REGION_REG0_U_RNI_NID260, REGION1_SIZE, 36, 5)
    FIELD(NON_HASH_MEM_REGION_REG0_U_RNI_NID260, REGION1_TARGET_TYPE, 34, 2)
    FIELD(NON_HASH_MEM_REGION_REG0_U_RNI_NID260, RESERVED_33, 33, 1)
    FIELD(NON_HASH_MEM_REGION_REG0_U_RNI_NID260, REGION1_VALID, 32, 1)
    FIELD(NON_HASH_MEM_REGION_REG0_U_RNI_NID260, RESERVED_31, 31, 1)
    FIELD(NON_HASH_MEM_REGION_REG0_U_RNI_NID260, REGION0_BASE_ADDR, 9, 22)
    FIELD(NON_HASH_MEM_REGION_REG0_U_RNI_NID260, REGION0_SIZE, 4, 5)
    FIELD(NON_HASH_MEM_REGION_REG0_U_RNI_NID260, REGION0_TARGET_TYPE, 2, 2)
    FIELD(NON_HASH_MEM_REGION_REG0_U_RNI_NID260, REGION0_VALID, 0, 1)
REG32(NON_HASH_MEM_REGION_REG1_U_RNI_NID260, 0x2024c10)
    FIELD(NON_HASH_MEM_REGION_REG1_U_RNI_NID260, RESERVED_63, 63, 1)
    FIELD(NON_HASH_MEM_REGION_REG1_U_RNI_NID260, REGION3_BASE_ADDR, 41, 22)
    FIELD(NON_HASH_MEM_REGION_REG1_U_RNI_NID260, REGION3_SIZE, 36, 5)
    FIELD(NON_HASH_MEM_REGION_REG1_U_RNI_NID260, REGION3_TARGET_TYPE, 34, 2)
    FIELD(NON_HASH_MEM_REGION_REG1_U_RNI_NID260, RESERVED_33, 33, 1)
    FIELD(NON_HASH_MEM_REGION_REG1_U_RNI_NID260, REGION3_VALID, 32, 1)
    FIELD(NON_HASH_MEM_REGION_REG1_U_RNI_NID260, RESERVED_31, 31, 1)
    FIELD(NON_HASH_MEM_REGION_REG1_U_RNI_NID260, REGION2_BASE_ADDR, 9, 22)
    FIELD(NON_HASH_MEM_REGION_REG1_U_RNI_NID260, REGION2_SIZE, 4, 5)
    FIELD(NON_HASH_MEM_REGION_REG1_U_RNI_NID260, REGION2_TARGET_TYPE, 2, 2)
    FIELD(NON_HASH_MEM_REGION_REG1_U_RNI_NID260, REGION2_VALID, 0, 1)
REG32(NON_HASH_MEM_REGION_REG2_U_RNI_NID260, 0x2024c18)
    FIELD(NON_HASH_MEM_REGION_REG2_U_RNI_NID260, RESERVED_63, 63, 1)
    FIELD(NON_HASH_MEM_REGION_REG2_U_RNI_NID260, REGION5_BASE_ADDR, 41, 22)
    FIELD(NON_HASH_MEM_REGION_REG2_U_RNI_NID260, REGION5_SIZE, 36, 5)
    FIELD(NON_HASH_MEM_REGION_REG2_U_RNI_NID260, REGION5_TARGET_TYPE, 34, 2)
    FIELD(NON_HASH_MEM_REGION_REG2_U_RNI_NID260, RESERVED_33, 33, 1)
    FIELD(NON_HASH_MEM_REGION_REG2_U_RNI_NID260, REGION5_VALID, 32, 1)
    FIELD(NON_HASH_MEM_REGION_REG2_U_RNI_NID260, RESERVED_31, 31, 1)
    FIELD(NON_HASH_MEM_REGION_REG2_U_RNI_NID260, REGION4_BASE_ADDR, 9, 22)
    FIELD(NON_HASH_MEM_REGION_REG2_U_RNI_NID260, REGION4_SIZE, 4, 5)
    FIELD(NON_HASH_MEM_REGION_REG2_U_RNI_NID260, REGION4_TARGET_TYPE, 2, 2)
    FIELD(NON_HASH_MEM_REGION_REG2_U_RNI_NID260, REGION4_VALID, 0, 1)
REG32(NON_HASH_MEM_REGION_REG3_U_RNI_NID260, 0x2024c20)
    FIELD(NON_HASH_MEM_REGION_REG3_U_RNI_NID260, RESERVED_63, 63, 1)
    FIELD(NON_HASH_MEM_REGION_REG3_U_RNI_NID260, REGION7_BASE_ADDR, 41, 22)
    FIELD(NON_HASH_MEM_REGION_REG3_U_RNI_NID260, REGION7_SIZE, 36, 5)
    FIELD(NON_HASH_MEM_REGION_REG3_U_RNI_NID260, REGION7_TARGET_TYPE, 34, 2)
    FIELD(NON_HASH_MEM_REGION_REG3_U_RNI_NID260, RESERVED_33, 33, 1)
    FIELD(NON_HASH_MEM_REGION_REG3_U_RNI_NID260, REGION7_VALID, 32, 1)
    FIELD(NON_HASH_MEM_REGION_REG3_U_RNI_NID260, RESERVED_31, 31, 1)
    FIELD(NON_HASH_MEM_REGION_REG3_U_RNI_NID260, REGION6_BASE_ADDR, 9, 22)
    FIELD(NON_HASH_MEM_REGION_REG3_U_RNI_NID260, REGION6_SIZE, 4, 5)
    FIELD(NON_HASH_MEM_REGION_REG3_U_RNI_NID260, REGION6_TARGET_TYPE, 2, 2)
    FIELD(NON_HASH_MEM_REGION_REG3_U_RNI_NID260, REGION6_VALID, 0, 1)
REG32(NON_HASH_TGT_NODEID0_U_RNI_NID260, 0x2024c30)
    FIELD(NON_HASH_TGT_NODEID0_U_RNI_NID260, RESERVED_47, 47, 17)
    FIELD(NON_HASH_TGT_NODEID0_U_RNI_NID260, NODEID_3, 36, 11)
    FIELD(NON_HASH_TGT_NODEID0_U_RNI_NID260, RESERVED_35, 35, 1)
    FIELD(NON_HASH_TGT_NODEID0_U_RNI_NID260, NODEID_2, 24, 11)
    FIELD(NON_HASH_TGT_NODEID0_U_RNI_NID260, RESERVED_23, 23, 1)
    FIELD(NON_HASH_TGT_NODEID0_U_RNI_NID260, NODEID_1, 12, 11)
    FIELD(NON_HASH_TGT_NODEID0_U_RNI_NID260, RESERVED_11, 11, 1)
    FIELD(NON_HASH_TGT_NODEID0_U_RNI_NID260, NODEID_0, 0, 11)
REG32(NON_HASH_TGT_NODEID1_U_RNI_NID260, 0x2024c38)
    FIELD(NON_HASH_TGT_NODEID1_U_RNI_NID260, RESERVED_47, 47, 17)
    FIELD(NON_HASH_TGT_NODEID1_U_RNI_NID260, NODEID_7, 36, 11)
    FIELD(NON_HASH_TGT_NODEID1_U_RNI_NID260, RESERVED_35, 35, 1)
    FIELD(NON_HASH_TGT_NODEID1_U_RNI_NID260, NODEID_6, 24, 11)
    FIELD(NON_HASH_TGT_NODEID1_U_RNI_NID260, RESERVED_23, 23, 1)
    FIELD(NON_HASH_TGT_NODEID1_U_RNI_NID260, NODEID_5, 12, 11)
    FIELD(NON_HASH_TGT_NODEID1_U_RNI_NID260, RESERVED_11, 11, 1)
    FIELD(NON_HASH_TGT_NODEID1_U_RNI_NID260, NODEID_4, 0, 11)
REG32(NON_HASH_TGT_NODEID2_U_RNI_NID260, 0x2024c40)
    FIELD(NON_HASH_TGT_NODEID2_U_RNI_NID260, RESERVED_23, 23, 41)
    FIELD(NON_HASH_TGT_NODEID2_U_RNI_NID260, NODEID_9, 12, 11)
    FIELD(NON_HASH_TGT_NODEID2_U_RNI_NID260, RESERVED_11, 11, 1)
    FIELD(NON_HASH_TGT_NODEID2_U_RNI_NID260, NODEID_8, 0, 11)
REG32(SYS_CACHE_GRP_REGION0_U_RNI_NID260, 0x2024c48)
    FIELD(SYS_CACHE_GRP_REGION0_U_RNI_NID260, RESERVED_63, 63, 1)
    FIELD(SYS_CACHE_GRP_REGION0_U_RNI_NID260, REGION1_BASE_ADDR, 41, 22)
    FIELD(SYS_CACHE_GRP_REGION0_U_RNI_NID260, REGION1_SIZE, 36, 5)
    FIELD(SYS_CACHE_GRP_REGION0_U_RNI_NID260, REGION1_TARGET_TYPE, 34, 2)
    FIELD(SYS_CACHE_GRP_REGION0_U_RNI_NID260, REGION1_NONHASH_REG_EN, 33, 1)
    FIELD(SYS_CACHE_GRP_REGION0_U_RNI_NID260, REGION1_VALID, 32, 1)
    FIELD(SYS_CACHE_GRP_REGION0_U_RNI_NID260, RESERVED_31, 31, 1)
    FIELD(SYS_CACHE_GRP_REGION0_U_RNI_NID260, REGION0_BASE_ADDR, 9, 22)
    FIELD(SYS_CACHE_GRP_REGION0_U_RNI_NID260, REGION0_SIZE, 4, 5)
    FIELD(SYS_CACHE_GRP_REGION0_U_RNI_NID260, REGION0_TARGET_TYPE, 2, 2)
    FIELD(SYS_CACHE_GRP_REGION0_U_RNI_NID260, REGION0_VALID, 0, 1)
REG32(SYS_CACHE_GRP_REGION1_U_RNI_NID260, 0x2024c50)
    FIELD(SYS_CACHE_GRP_REGION1_U_RNI_NID260, RESERVED_63, 63, 1)
    FIELD(SYS_CACHE_GRP_REGION1_U_RNI_NID260, REGION3_BASE_ADDR, 41, 22)
    FIELD(SYS_CACHE_GRP_REGION1_U_RNI_NID260, REGION3_SIZE, 36, 5)
    FIELD(SYS_CACHE_GRP_REGION1_U_RNI_NID260, REGION3_TARGET_TYPE, 34, 2)
    FIELD(SYS_CACHE_GRP_REGION1_U_RNI_NID260, REGION3_NONHASH_REG_EN, 33, 1)
    FIELD(SYS_CACHE_GRP_REGION1_U_RNI_NID260, REGION3_VALID, 32, 1)
    FIELD(SYS_CACHE_GRP_REGION1_U_RNI_NID260, RESERVED_31, 31, 1)
    FIELD(SYS_CACHE_GRP_REGION1_U_RNI_NID260, REGION2_BASE_ADDR, 9, 22)
    FIELD(SYS_CACHE_GRP_REGION1_U_RNI_NID260, REGION2_SIZE, 4, 5)
    FIELD(SYS_CACHE_GRP_REGION1_U_RNI_NID260, REGION2_TARGET_TYPE, 2, 2)
    FIELD(SYS_CACHE_GRP_REGION1_U_RNI_NID260, REGION2_NONHASH_REG_EN, 1, 1)
    FIELD(SYS_CACHE_GRP_REGION1_U_RNI_NID260, REGION2_VALID, 0, 1)
REG32(SYS_CACHE_GRP_HN_NODEID_REG0_U_RNI_NID260, 0x2024c58)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG0_U_RNI_NID260, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG0_U_RNI_NID260, NODEID_3, 36, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG0_U_RNI_NID260, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG0_U_RNI_NID260, NODEID_2, 24, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG0_U_RNI_NID260, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG0_U_RNI_NID260, NODEID_1, 12, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG0_U_RNI_NID260, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG0_U_RNI_NID260, NODEID_0, 0, 11)
REG32(SYS_CACHE_GRP_HN_NODEID_REG1_U_RNI_NID260, 0x2024c60)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG1_U_RNI_NID260, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG1_U_RNI_NID260, NODEID_7, 36, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG1_U_RNI_NID260, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG1_U_RNI_NID260, NODEID_6, 24, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG1_U_RNI_NID260, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG1_U_RNI_NID260, NODEID_5, 12, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG1_U_RNI_NID260, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG1_U_RNI_NID260, NODEID_4, 0, 11)
REG32(SYS_CACHE_GRP_HN_NODEID_REG2_U_RNI_NID260, 0x2024c68)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG2_U_RNI_NID260, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG2_U_RNI_NID260, NODEID_11, 36, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG2_U_RNI_NID260, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG2_U_RNI_NID260, NODEID_10, 24, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG2_U_RNI_NID260, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG2_U_RNI_NID260, NODEID_9, 12, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG2_U_RNI_NID260, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG2_U_RNI_NID260, NODEID_8, 0, 11)
REG32(SYS_CACHE_GRP_HN_NODEID_REG3_U_RNI_NID260, 0x2024c70)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG3_U_RNI_NID260, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG3_U_RNI_NID260, NODEID_15, 36, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG3_U_RNI_NID260, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG3_U_RNI_NID260, NODEID_14, 24, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG3_U_RNI_NID260, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG3_U_RNI_NID260, NODEID_13, 12, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG3_U_RNI_NID260, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG3_U_RNI_NID260, NODEID_12, 0, 11)
REG32(SYS_CACHE_GRP_HN_NODEID_REG4_U_RNI_NID260, 0x2024c78)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG4_U_RNI_NID260, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG4_U_RNI_NID260, NODEID_19, 36, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG4_U_RNI_NID260, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG4_U_RNI_NID260, NODEID_18, 24, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG4_U_RNI_NID260, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG4_U_RNI_NID260, NODEID_17, 12, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG4_U_RNI_NID260, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG4_U_RNI_NID260, NODEID_16, 0, 11)
REG32(SYS_CACHE_GRP_HN_NODEID_REG5_U_RNI_NID260, 0x2024c80)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG5_U_RNI_NID260, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG5_U_RNI_NID260, NODEID_23, 36, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG5_U_RNI_NID260, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG5_U_RNI_NID260, NODEID_22, 24, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG5_U_RNI_NID260, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG5_U_RNI_NID260, NODEID_21, 12, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG5_U_RNI_NID260, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG5_U_RNI_NID260, NODEID_20, 0, 11)
REG32(SYS_CACHE_GRP_HN_NODEID_REG6_U_RNI_NID260, 0x2024c88)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG6_U_RNI_NID260, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG6_U_RNI_NID260, NODEID_27, 36, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG6_U_RNI_NID260, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG6_U_RNI_NID260, NODEID_26, 24, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG6_U_RNI_NID260, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG6_U_RNI_NID260, NODEID_25, 12, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG6_U_RNI_NID260, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG6_U_RNI_NID260, NODEID_24, 0, 11)
REG32(SYS_CACHE_GRP_HN_NODEID_REG7_U_RNI_NID260, 0x2024c90)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG7_U_RNI_NID260, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG7_U_RNI_NID260, NODEID_31, 36, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG7_U_RNI_NID260, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG7_U_RNI_NID260, NODEID_30, 24, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG7_U_RNI_NID260, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG7_U_RNI_NID260, NODEID_29, 12, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG7_U_RNI_NID260, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG7_U_RNI_NID260, NODEID_28, 0, 11)
REG32(SYS_CACHE_GRP_NONHASH_NODEID_U_RNI_NID260, 0x2024c98)
    FIELD(SYS_CACHE_GRP_NONHASH_NODEID_U_RNI_NID260, RESERVED_35, 35, 29)
    FIELD(SYS_CACHE_GRP_NONHASH_NODEID_U_RNI_NID260, SCG3_NODEID, 24, 11)
    FIELD(SYS_CACHE_GRP_NONHASH_NODEID_U_RNI_NID260, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_NONHASH_NODEID_U_RNI_NID260, SCG2_NODEID, 12, 11)
    FIELD(SYS_CACHE_GRP_NONHASH_NODEID_U_RNI_NID260, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_NONHASH_NODEID_U_RNI_NID260, SCG1_NODEID, 0, 11)
REG32(SYS_CACHE_GROUP_HN_COUNT_U_RNI_NID260, 0x2024d00)
    FIELD(SYS_CACHE_GROUP_HN_COUNT_U_RNI_NID260, RESERVED_31, 31, 33)
    FIELD(SYS_CACHE_GROUP_HN_COUNT_U_RNI_NID260, SCG3_NUM_HNF, 24, 7)
    FIELD(SYS_CACHE_GROUP_HN_COUNT_U_RNI_NID260, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GROUP_HN_COUNT_U_RNI_NID260, SCG2_NUM_HNF, 16, 7)
    FIELD(SYS_CACHE_GROUP_HN_COUNT_U_RNI_NID260, RESERVED_15, 15, 1)
    FIELD(SYS_CACHE_GROUP_HN_COUNT_U_RNI_NID260, SCG1_NUM_HNF, 8, 7)
    FIELD(SYS_CACHE_GROUP_HN_COUNT_U_RNI_NID260, SCG0_NUM_HNF, 0, 7)
REG32(SYS_CACHE_GRP_SN_NODEID_REG0_U_RNI_NID260, 0x2024d08)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG0_U_RNI_NID260, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG0_U_RNI_NID260, SN_NODEID_3, 36, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG0_U_RNI_NID260, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG0_U_RNI_NID260, SN_NODEID_2, 24, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG0_U_RNI_NID260, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG0_U_RNI_NID260, SN_NODEID_1, 12, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG0_U_RNI_NID260, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG0_U_RNI_NID260, SN_NODEID_0, 0, 11)
REG32(SYS_CACHE_GRP_SN_NODEID_REG1_U_RNI_NID260, 0x2024d10)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG1_U_RNI_NID260, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG1_U_RNI_NID260, SN_NODEID_7, 36, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG1_U_RNI_NID260, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG1_U_RNI_NID260, SN_NODEID_6, 24, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG1_U_RNI_NID260, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG1_U_RNI_NID260, SN_NODEID_5, 12, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG1_U_RNI_NID260, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG1_U_RNI_NID260, SN_NODEID_4, 0, 11)
REG32(SYS_CACHE_GRP_SN_NODEID_REG2_U_RNI_NID260, 0x2024d18)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG2_U_RNI_NID260, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG2_U_RNI_NID260, SN_NODEID_11, 36, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG2_U_RNI_NID260, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG2_U_RNI_NID260, SN_NODEID_10, 24, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG2_U_RNI_NID260, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG2_U_RNI_NID260, SN_NODEID_9, 12, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG2_U_RNI_NID260, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG2_U_RNI_NID260, SN_NODEID_8, 0, 11)
REG32(SYS_CACHE_GRP_SN_NODEID_REG3_U_RNI_NID260, 0x2024d20)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG3_U_RNI_NID260, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG3_U_RNI_NID260, SN_NODEID_15, 36, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG3_U_RNI_NID260, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG3_U_RNI_NID260, SN_NODEID_14, 24, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG3_U_RNI_NID260, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG3_U_RNI_NID260, SN_NODEID_13, 12, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG3_U_RNI_NID260, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG3_U_RNI_NID260, SN_NODEID_12, 0, 11)
REG32(SYS_CACHE_GRP_SN_NODEID_REG4_U_RNI_NID260, 0x2024d28)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG4_U_RNI_NID260, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG4_U_RNI_NID260, SN_NODEID_19, 36, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG4_U_RNI_NID260, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG4_U_RNI_NID260, SN_NODEID_18, 24, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG4_U_RNI_NID260, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG4_U_RNI_NID260, SN_NODEID_17, 12, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG4_U_RNI_NID260, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG4_U_RNI_NID260, SN_NODEID_16, 0, 11)
REG32(SYS_CACHE_GRP_SN_NODEID_REG5_U_RNI_NID260, 0x2024d30)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG5_U_RNI_NID260, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG5_U_RNI_NID260, SN_NODEID_23, 36, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG5_U_RNI_NID260, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG5_U_RNI_NID260, SN_NODEID_22, 24, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG5_U_RNI_NID260, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG5_U_RNI_NID260, SN_NODEID_21, 12, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG5_U_RNI_NID260, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG5_U_RNI_NID260, SN_NODEID_20, 0, 11)
REG32(SYS_CACHE_GRP_SN_NODEID_REG6_U_RNI_NID260, 0x2024d38)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG6_U_RNI_NID260, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG6_U_RNI_NID260, SN_NODEID_27, 36, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG6_U_RNI_NID260, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG6_U_RNI_NID260, SN_NODEID_26, 24, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG6_U_RNI_NID260, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG6_U_RNI_NID260, SN_NODEID_25, 12, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG6_U_RNI_NID260, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG6_U_RNI_NID260, SN_NODEID_24, 0, 11)
REG32(SYS_CACHE_GRP_SN_NODEID_REG7_U_RNI_NID260, 0x2024d40)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG7_U_RNI_NID260, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG7_U_RNI_NID260, SN_NODEID_31, 36, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG7_U_RNI_NID260, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG7_U_RNI_NID260, SN_NODEID_30, 24, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG7_U_RNI_NID260, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG7_U_RNI_NID260, SN_NODEID_29, 12, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG7_U_RNI_NID260, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG7_U_RNI_NID260, SN_NODEID_28, 0, 11)
REG32(SYS_CACHE_GRP_SN_SAM_CFG0_U_RNI_NID260, 0x2024d48)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG0_U_RNI_NID260, RESERVED_46, 46, 18)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG0_U_RNI_NID260, SCG1_TOP_ADDRESS_BIT2, 40, 6)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG0_U_RNI_NID260, RESERVED_38, 38, 2)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG0_U_RNI_NID260, SCG1_TOP_ADDRESS_BIT1, 32, 6)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG0_U_RNI_NID260, RESERVED_30, 30, 2)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG0_U_RNI_NID260, SCG1_TOP_ADDRESS_BIT0, 24, 6)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG0_U_RNI_NID260, RESERVED_22, 22, 2)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG0_U_RNI_NID260, SCG0_TOP_ADDRESS_BIT2, 16, 6)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG0_U_RNI_NID260, RESERVED_14, 14, 2)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG0_U_RNI_NID260, SCG0_TOP_ADDRESS_BIT1, 8, 6)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG0_U_RNI_NID260, SCG0_TOP_ADDRESS_BIT0, 0, 6)
REG32(SYS_CACHE_GRP_SN_SAM_CFG1_U_RNI_NID260, 0x2024d50)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG1_U_RNI_NID260, RESERVED_46, 46, 18)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG1_U_RNI_NID260, SCG3_TOP_ADDRESS_BIT2, 40, 6)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG1_U_RNI_NID260, RESERVED_38, 38, 2)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG1_U_RNI_NID260, SCG3_TOP_ADDRESS_BIT1, 32, 6)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG1_U_RNI_NID260, RESERVED_30, 30, 2)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG1_U_RNI_NID260, SCG3_TOP_ADDRESS_BIT0, 24, 6)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG1_U_RNI_NID260, RESERVED_22, 22, 2)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG1_U_RNI_NID260, SCG2_TOP_ADDRESS_BIT2, 16, 6)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG1_U_RNI_NID260, RESERVED_14, 14, 2)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG1_U_RNI_NID260, SCG2_TOP_ADDRESS_BIT1, 8, 6)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG1_U_RNI_NID260, SCG2_TOP_ADDRESS_BIT0, 0, 6)
REG32(GIC_MEM_REGION_REG_U_RNI_NID260, 0x2024d58)
    FIELD(GIC_MEM_REGION_REG_U_RNI_NID260, RESERVED_63, 63, 1)
    FIELD(GIC_MEM_REGION_REG_U_RNI_NID260, GIC_REGION_NODEID, 52, 11)
    FIELD(GIC_MEM_REGION_REG_U_RNI_NID260, RESERVED_48, 48, 4)
    FIELD(GIC_MEM_REGION_REG_U_RNI_NID260, GIC_REGION_BASE_ADDR, 16, 32)
    FIELD(GIC_MEM_REGION_REG_U_RNI_NID260, GIC_REGION_SIZE, 4, 3)
    FIELD(GIC_MEM_REGION_REG_U_RNI_NID260, GIC_REGION_TARGET_TYPE, 2, 2)
    FIELD(GIC_MEM_REGION_REG_U_RNI_NID260, GIC_REGION_VALID, 0, 1)
REG32(SYS_CACHE_GRP_SN_ATTR_U_RNI_NID260, 0x2024d60)
    FIELD(SYS_CACHE_GRP_SN_ATTR_U_RNI_NID260, RESERVED_54, 54, 10)
    FIELD(SYS_CACHE_GRP_SN_ATTR_U_RNI_NID260, SN_MODE_SYS_CACHE_GRP3, 52, 2)
    FIELD(SYS_CACHE_GRP_SN_ATTR_U_RNI_NID260, RESERVED_49, 49, 3)
    FIELD(SYS_CACHE_GRP_SN_ATTR_U_RNI_NID260, INV_TOP_ADDRESS_BIT_SYS_CACHE_GRP3, 48, 1)
    FIELD(SYS_CACHE_GRP_SN_ATTR_U_RNI_NID260, RESERVED_38, 38, 10)
    FIELD(SYS_CACHE_GRP_SN_ATTR_U_RNI_NID260, SN_MODE_SYS_CACHE_GRP2, 36, 2)
    FIELD(SYS_CACHE_GRP_SN_ATTR_U_RNI_NID260, RESERVED_33, 33, 3)
    FIELD(SYS_CACHE_GRP_SN_ATTR_U_RNI_NID260, INV_TOP_ADDRESS_BIT_SYS_CACHE_GRP2, 32, 1)
    FIELD(SYS_CACHE_GRP_SN_ATTR_U_RNI_NID260, RESERVED_22, 22, 10)
    FIELD(SYS_CACHE_GRP_SN_ATTR_U_RNI_NID260, SN_MODE_SYS_CACHE_GRP1, 20, 2)
    FIELD(SYS_CACHE_GRP_SN_ATTR_U_RNI_NID260, RESERVED_17, 17, 3)
    FIELD(SYS_CACHE_GRP_SN_ATTR_U_RNI_NID260, INV_TOP_ADDRESS_BIT_SYS_CACHE_GRP1, 16, 1)
    FIELD(SYS_CACHE_GRP_SN_ATTR_U_RNI_NID260, SN_MODE_SYS_CACHE_GRP0, 4, 2)
    FIELD(SYS_CACHE_GRP_SN_ATTR_U_RNI_NID260, INV_TOP_ADDRESS_BIT_SYS_CACHE_GRP0, 0, 1)
REG32(SYS_CACHE_GRP_HN_CPA_EN_REG_U_RNI_NID260, 0x2024d68)
REG32(SYS_CACHE_GRP_HN_CPA_GRP_REG_U_RNI_NID260, 0x2024d70)
    FIELD(SYS_CACHE_GRP_HN_CPA_GRP_REG_U_RNI_NID260, RESERVED_50, 50, 14)
    FIELD(SYS_CACHE_GRP_HN_CPA_GRP_REG_U_RNI_NID260, CPA_GRP_SCG3, 48, 2)
    FIELD(SYS_CACHE_GRP_HN_CPA_GRP_REG_U_RNI_NID260, RESERVED_34, 34, 14)
    FIELD(SYS_CACHE_GRP_HN_CPA_GRP_REG_U_RNI_NID260, CPA_GRP_SCG2, 32, 2)
    FIELD(SYS_CACHE_GRP_HN_CPA_GRP_REG_U_RNI_NID260, RESERVED_18, 18, 14)
    FIELD(SYS_CACHE_GRP_HN_CPA_GRP_REG_U_RNI_NID260, CPA_GRP_SCG1, 16, 2)
    FIELD(SYS_CACHE_GRP_HN_CPA_GRP_REG_U_RNI_NID260, CPA_GRP_SCG0, 0, 2)
REG32(CML_PORT_AGGR_MODE_CTRL_REG_U_RNI_NID260, 0x2024e00)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNI_NID260, RESERVED_32, 32, 32)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNI_NID260, REGION7_PAG_GRPID, 30, 2)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNI_NID260, RESERVED_29, 29, 1)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNI_NID260, REGION7_PAG_EN, 28, 1)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNI_NID260, RESERVED_27, 27, 1)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNI_NID260, REGION6_PAG_GRPID, 25, 2)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNI_NID260, REGION6_PAG_EN, 24, 1)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNI_NID260, RESERVED_23, 23, 1)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNI_NID260, REGION5_PAG_GRPID, 21, 2)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNI_NID260, REGION5_PAG_EN, 20, 1)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNI_NID260, RESERVED_19, 19, 1)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNI_NID260, REGION4_PAG_GRPID, 17, 2)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNI_NID260, REGION4_PAG_EN, 16, 1)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNI_NID260, RESERVED_15, 15, 1)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNI_NID260, REGION3_PAG_GRPID, 13, 2)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNI_NID260, REGION3_PAG_EN, 12, 1)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNI_NID260, RESERVED_11, 11, 1)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNI_NID260, REGION2_PAG_GRPID, 9, 2)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNI_NID260, REGION2_PAG_EN, 8, 1)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNI_NID260, REGION1_PAG_GRPID, 5, 2)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNI_NID260, REGION1_PAG_EN, 4, 1)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNI_NID260, REGION0_PAG_GRPID, 1, 2)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNI_NID260, REGION0_PAG_EN, 0, 1)
REG32(CML_PORT_AGGR_GRP0_ADD_MASK_U_RNI_NID260, 0x2024e08)
    FIELD(CML_PORT_AGGR_GRP0_ADD_MASK_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(CML_PORT_AGGR_GRP0_ADD_MASK_U_RNI_NID260, ADDR_MASK, 6, 42)
    FIELD(CML_PORT_AGGR_GRP0_ADD_MASK_U_RNI_NID260, RESERVED_0, 0, 6)
REG32(CML_PORT_AGGR_GRP1_ADD_MASK_U_RNI_NID260, 0x2024e10)
    FIELD(CML_PORT_AGGR_GRP1_ADD_MASK_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(CML_PORT_AGGR_GRP1_ADD_MASK_U_RNI_NID260, ADDR_MASK, 6, 42)
    FIELD(CML_PORT_AGGR_GRP1_ADD_MASK_U_RNI_NID260, RESERVED_0, 0, 6)
REG32(CML_PORT_AGGR_GRP0_REG_U_RNI_NID260, 0x2024e40)
    FIELD(CML_PORT_AGGR_GRP0_REG_U_RNI_NID260, RESERVED_50, 50, 14)
    FIELD(CML_PORT_AGGR_GRP0_REG_U_RNI_NID260, NUM_CXG_PAG0, 48, 2)
    FIELD(CML_PORT_AGGR_GRP0_REG_U_RNI_NID260, RESERVED_47, 47, 1)
    FIELD(CML_PORT_AGGR_GRP0_REG_U_RNI_NID260, PAG0_TGTID3, 36, 11)
    FIELD(CML_PORT_AGGR_GRP0_REG_U_RNI_NID260, RESERVED_35, 35, 1)
    FIELD(CML_PORT_AGGR_GRP0_REG_U_RNI_NID260, PAG0_TGTID2, 24, 11)
    FIELD(CML_PORT_AGGR_GRP0_REG_U_RNI_NID260, RESERVED_23, 23, 1)
    FIELD(CML_PORT_AGGR_GRP0_REG_U_RNI_NID260, PAG0_TGTID1, 12, 11)
    FIELD(CML_PORT_AGGR_GRP0_REG_U_RNI_NID260, RESERVED_11, 11, 1)
    FIELD(CML_PORT_AGGR_GRP0_REG_U_RNI_NID260, PAG0_TGTID0, 0, 11)
REG32(CML_PORT_AGGR_GRP1_REG_U_RNI_NID260, 0x2024e48)
    FIELD(CML_PORT_AGGR_GRP1_REG_U_RNI_NID260, RESERVED_50, 50, 14)
    FIELD(CML_PORT_AGGR_GRP1_REG_U_RNI_NID260, NUM_CXG_PAG1, 48, 2)
    FIELD(CML_PORT_AGGR_GRP1_REG_U_RNI_NID260, RESERVED_47, 47, 1)
    FIELD(CML_PORT_AGGR_GRP1_REG_U_RNI_NID260, PAG1_TGTID3, 36, 11)
    FIELD(CML_PORT_AGGR_GRP1_REG_U_RNI_NID260, RESERVED_35, 35, 1)
    FIELD(CML_PORT_AGGR_GRP1_REG_U_RNI_NID260, PAG1_TGTID2, 24, 11)
    FIELD(CML_PORT_AGGR_GRP1_REG_U_RNI_NID260, RESERVED_23, 23, 1)
    FIELD(CML_PORT_AGGR_GRP1_REG_U_RNI_NID260, PAG1_TGTID1, 12, 11)
    FIELD(CML_PORT_AGGR_GRP1_REG_U_RNI_NID260, RESERVED_11, 11, 1)
    FIELD(CML_PORT_AGGR_GRP1_REG_U_RNI_NID260, PAG1_TGTID0, 0, 11)
REG32(SYS_CACHE_GRP_SECONDARY_REG0_U_RNI_NID260, 0x2024f00)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG0_U_RNI_NID260, RESERVED_63, 63, 1)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG0_U_RNI_NID260, REGION1_SCNDRY_BASE_ADDR, 41, 22)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG0_U_RNI_NID260, REGION1_SCNDRY_SIZE, 36, 5)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG0_U_RNI_NID260, REGION1_SCNDRY_TARGET_TYPE, 34, 2)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG0_U_RNI_NID260, RESERVED_33, 33, 1)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG0_U_RNI_NID260, REGION1_SCNDRY_VALID, 32, 1)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG0_U_RNI_NID260, RESERVED_31, 31, 1)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG0_U_RNI_NID260, REGION0_SCNDRY_BASE_ADDR, 9, 22)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG0_U_RNI_NID260, REGION0_SCNDRY_SIZE, 4, 5)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG0_U_RNI_NID260, REGION0_SCNDRY_TARGET_TYPE, 2, 2)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG0_U_RNI_NID260, REGION0_SCNDRY_VALID, 0, 1)
REG32(SYS_CACHE_GRP_SECONDARY_REG1_U_RNI_NID260, 0x2024f08)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG1_U_RNI_NID260, RESERVED_63, 63, 1)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG1_U_RNI_NID260, REGION3_SCNDRY_BASE_ADDR, 41, 22)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG1_U_RNI_NID260, REGION3_SCNDRY_SIZE, 36, 5)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG1_U_RNI_NID260, REGION3_SCNDRY_TARGET_TYPE, 34, 2)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG1_U_RNI_NID260, RESERVED_33, 33, 1)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG1_U_RNI_NID260, REGION3_SCNDRY_VALID, 32, 1)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG1_U_RNI_NID260, RESERVED_31, 31, 1)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG1_U_RNI_NID260, REGION2_SCNDRY_BASE_ADDR, 9, 22)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG1_U_RNI_NID260, REGION2_SCNDRY_SIZE, 4, 5)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG1_U_RNI_NID260, REGION2_SCNDRY_TARGET_TYPE, 2, 2)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG1_U_RNI_NID260, REGION2_SCNDRY_VALID, 0, 1)
REG32(SYS_CACHE_GRP_CAL_MODE_REG_U_RNI_NID260, 0x2024f10)
    FIELD(SYS_CACHE_GRP_CAL_MODE_REG_U_RNI_NID260, RESERVED_49, 49, 15)
    FIELD(SYS_CACHE_GRP_CAL_MODE_REG_U_RNI_NID260, SCG3_HNF_CAL_MODE_EN, 48, 1)
    FIELD(SYS_CACHE_GRP_CAL_MODE_REG_U_RNI_NID260, RESERVED_33, 33, 15)
    FIELD(SYS_CACHE_GRP_CAL_MODE_REG_U_RNI_NID260, SCG2_HNF_CAL_MODE_EN, 32, 1)
    FIELD(SYS_CACHE_GRP_CAL_MODE_REG_U_RNI_NID260, RESERVED_17, 17, 15)
    FIELD(SYS_CACHE_GRP_CAL_MODE_REG_U_RNI_NID260, SCG1_HNF_CAL_MODE_EN, 16, 1)
    FIELD(SYS_CACHE_GRP_CAL_MODE_REG_U_RNI_NID260, SCG0_HNF_CAL_MODE_EN, 0, 1)
REG32(RNSAM_HASH_ADDR_MASK_REG_U_RNI_NID260, 0x2024f18)
    FIELD(RNSAM_HASH_ADDR_MASK_REG_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(RNSAM_HASH_ADDR_MASK_REG_U_RNI_NID260, ADDR_MASK, 6, 42)
    FIELD(RNSAM_HASH_ADDR_MASK_REG_U_RNI_NID260, RESERVED_0, 0, 6)
REG32(RNSAM_REGION_CMP_ADDR_MASK_REG_U_RNI_NID260, 0x2024f20)
    FIELD(RNSAM_REGION_CMP_ADDR_MASK_REG_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(RNSAM_REGION_CMP_ADDR_MASK_REG_U_RNI_NID260, ADDR_MASK, 16, 32)
    FIELD(RNSAM_REGION_CMP_ADDR_MASK_REG_U_RNI_NID260, RESERVED_0, 0, 16)
REG32(SYS_CACHE_GRP_HN_NODEID_REG8_U_RNI_NID260, 0x2024f58)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG8_U_RNI_NID260, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG8_U_RNI_NID260, NODEID_35, 36, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG8_U_RNI_NID260, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG8_U_RNI_NID260, NODEID_34, 24, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG8_U_RNI_NID260, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG8_U_RNI_NID260, NODEID_33, 12, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG8_U_RNI_NID260, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG8_U_RNI_NID260, NODEID_32, 0, 11)
REG32(SYS_CACHE_GRP_HN_NODEID_REG9_U_RNI_NID260, 0x2024f60)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG9_U_RNI_NID260, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG9_U_RNI_NID260, NODEID_39, 36, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG9_U_RNI_NID260, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG9_U_RNI_NID260, NODEID_38, 24, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG9_U_RNI_NID260, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG9_U_RNI_NID260, NODEID_37, 12, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG9_U_RNI_NID260, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG9_U_RNI_NID260, NODEID_36, 0, 11)
REG32(SYS_CACHE_GRP_HN_NODEID_REG10_U_RNI_NID260, 0x2024f68)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG10_U_RNI_NID260, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG10_U_RNI_NID260, NODEID_43, 36, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG10_U_RNI_NID260, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG10_U_RNI_NID260, NODEID_42, 24, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG10_U_RNI_NID260, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG10_U_RNI_NID260, NODEID_41, 12, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG10_U_RNI_NID260, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG10_U_RNI_NID260, NODEID_40, 0, 11)
REG32(SYS_CACHE_GRP_HN_NODEID_REG11_U_RNI_NID260, 0x2024f70)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG11_U_RNI_NID260, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG11_U_RNI_NID260, NODEID_47, 36, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG11_U_RNI_NID260, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG11_U_RNI_NID260, NODEID_46, 24, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG11_U_RNI_NID260, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG11_U_RNI_NID260, NODEID_45, 12, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG11_U_RNI_NID260, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG11_U_RNI_NID260, NODEID_44, 0, 11)
REG32(SYS_CACHE_GRP_HN_NODEID_REG12_U_RNI_NID260, 0x2024f78)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG12_U_RNI_NID260, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG12_U_RNI_NID260, NODEID_51, 36, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG12_U_RNI_NID260, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG12_U_RNI_NID260, NODEID_50, 24, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG12_U_RNI_NID260, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG12_U_RNI_NID260, NODEID_49, 12, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG12_U_RNI_NID260, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG12_U_RNI_NID260, NODEID_48, 0, 11)
REG32(SYS_CACHE_GRP_HN_NODEID_REG13_U_RNI_NID260, 0x2024f80)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG13_U_RNI_NID260, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG13_U_RNI_NID260, NODEID_55, 36, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG13_U_RNI_NID260, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG13_U_RNI_NID260, NODEID_54, 24, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG13_U_RNI_NID260, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG13_U_RNI_NID260, NODEID_53, 12, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG13_U_RNI_NID260, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG13_U_RNI_NID260, NODEID_52, 0, 11)
REG32(SYS_CACHE_GRP_HN_NODEID_REG14_U_RNI_NID260, 0x2024f88)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG14_U_RNI_NID260, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG14_U_RNI_NID260, NODEID_59, 36, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG14_U_RNI_NID260, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG14_U_RNI_NID260, NODEID_58, 24, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG14_U_RNI_NID260, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG14_U_RNI_NID260, NODEID_57, 12, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG14_U_RNI_NID260, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG14_U_RNI_NID260, NODEID_56, 0, 11)
REG32(SYS_CACHE_GRP_HN_NODEID_REG15_U_RNI_NID260, 0x2024f90)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG15_U_RNI_NID260, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG15_U_RNI_NID260, NODEID_63, 36, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG15_U_RNI_NID260, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG15_U_RNI_NID260, NODEID_62, 24, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG15_U_RNI_NID260, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG15_U_RNI_NID260, NODEID_61, 12, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG15_U_RNI_NID260, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG15_U_RNI_NID260, NODEID_60, 0, 11)
REG32(SYS_CACHE_GRP_SN_NODEID_REG8_U_RNI_NID260, 0x2025008)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG8_U_RNI_NID260, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG8_U_RNI_NID260, SN_NODEID_35, 36, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG8_U_RNI_NID260, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG8_U_RNI_NID260, SN_NODEID_34, 24, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG8_U_RNI_NID260, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG8_U_RNI_NID260, SN_NODEID_33, 12, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG8_U_RNI_NID260, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG8_U_RNI_NID260, SN_NODEID_32, 0, 11)
REG32(SYS_CACHE_GRP_SN_NODEID_REG9_U_RNI_NID260, 0x2025010)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG9_U_RNI_NID260, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG9_U_RNI_NID260, SN_NODEID_39, 36, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG9_U_RNI_NID260, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG9_U_RNI_NID260, SN_NODEID_38, 24, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG9_U_RNI_NID260, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG9_U_RNI_NID260, SN_NODEID_37, 12, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG9_U_RNI_NID260, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG9_U_RNI_NID260, SN_NODEID_36, 0, 11)
REG32(SYS_CACHE_GRP_SN_NODEID_REG10_U_RNI_NID260, 0x2025018)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG10_U_RNI_NID260, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG10_U_RNI_NID260, SN_NODEID_43, 36, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG10_U_RNI_NID260, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG10_U_RNI_NID260, SN_NODEID_42, 24, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG10_U_RNI_NID260, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG10_U_RNI_NID260, SN_NODEID_41, 12, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG10_U_RNI_NID260, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG10_U_RNI_NID260, SN_NODEID_40, 0, 11)
REG32(SYS_CACHE_GRP_SN_NODEID_REG11_U_RNI_NID260, 0x2025020)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG11_U_RNI_NID260, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG11_U_RNI_NID260, SN_NODEID_47, 36, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG11_U_RNI_NID260, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG11_U_RNI_NID260, SN_NODEID_46, 24, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG11_U_RNI_NID260, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG11_U_RNI_NID260, SN_NODEID_45, 12, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG11_U_RNI_NID260, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG11_U_RNI_NID260, SN_NODEID_44, 0, 11)
REG32(SYS_CACHE_GRP_SN_NODEID_REG12_U_RNI_NID260, 0x2025028)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG12_U_RNI_NID260, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG12_U_RNI_NID260, SN_NODEID_51, 36, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG12_U_RNI_NID260, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG12_U_RNI_NID260, SN_NODEID_50, 24, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG12_U_RNI_NID260, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG12_U_RNI_NID260, SN_NODEID_49, 12, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG12_U_RNI_NID260, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG12_U_RNI_NID260, SN_NODEID_48, 0, 11)
REG32(SYS_CACHE_GRP_SN_NODEID_REG13_U_RNI_NID260, 0x2025030)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG13_U_RNI_NID260, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG13_U_RNI_NID260, SN_NODEID_55, 36, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG13_U_RNI_NID260, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG13_U_RNI_NID260, SN_NODEID_54, 24, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG13_U_RNI_NID260, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG13_U_RNI_NID260, SN_NODEID_53, 12, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG13_U_RNI_NID260, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG13_U_RNI_NID260, SN_NODEID_52, 0, 11)
REG32(SYS_CACHE_GRP_SN_NODEID_REG14_U_RNI_NID260, 0x2025038)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG14_U_RNI_NID260, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG14_U_RNI_NID260, SN_NODEID_59, 36, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG14_U_RNI_NID260, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG14_U_RNI_NID260, SN_NODEID_58, 24, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG14_U_RNI_NID260, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG14_U_RNI_NID260, SN_NODEID_57, 12, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG14_U_RNI_NID260, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG14_U_RNI_NID260, SN_NODEID_56, 0, 11)
REG32(SYS_CACHE_GRP_SN_NODEID_REG15_U_RNI_NID260, 0x2025040)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG15_U_RNI_NID260, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG15_U_RNI_NID260, SN_NODEID_63, 36, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG15_U_RNI_NID260, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG15_U_RNI_NID260, SN_NODEID_62, 24, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG15_U_RNI_NID260, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG15_U_RNI_NID260, SN_NODEID_61, 12, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG15_U_RNI_NID260, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG15_U_RNI_NID260, SN_NODEID_60, 0, 11)
REG32(POR_FDC_NODE_INFO_U_SMXP_4_0, 0x202c000)
    FIELD(POR_FDC_NODE_INFO_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_FDC_NODE_INFO_U_SMXP_4_0, LOGICAL_ID, 32, 16)
    FIELD(POR_FDC_NODE_INFO_U_SMXP_4_0, NODE_ID, 16, 16)
    FIELD(POR_FDC_NODE_INFO_U_SMXP_4_0, NODE_TYPE, 0, 16)
REG32(POR_FDC_CHILD_INFO_U_SMXP_4_0, 0x202c080)
    FIELD(POR_FDC_CHILD_INFO_U_SMXP_4_0, RESERVED_32, 32, 32)
    FIELD(POR_FDC_CHILD_INFO_U_SMXP_4_0, CHILD_PTR_OFFSET, 16, 16)
    FIELD(POR_FDC_CHILD_INFO_U_SMXP_4_0, CHILD_COUNT, 0, 16)
REG32(POR_ERRFR_MXP_U_SMXP_4_0, 0x202f000)
    FIELD(POR_ERRFR_MXP_U_SMXP_4_0, FI, 6, 2)
    FIELD(POR_ERRFR_MXP_U_SMXP_4_0, UI, 4, 2)
    FIELD(POR_ERRFR_MXP_U_SMXP_4_0, ED, 0, 2)
REG32(POR_ERRCTLR_MXP_U_SMXP_4_0, 0x202f008)
    FIELD(POR_ERRCTLR_MXP_U_SMXP_4_0, RESERVED_32, 32, 32)
    FIELD(POR_ERRCTLR_MXP_U_SMXP_4_0, ERC, 14, 18)
    FIELD(POR_ERRCTLR_MXP_U_SMXP_4_0, FI, 3, 1)
    FIELD(POR_ERRCTLR_MXP_U_SMXP_4_0, UI, 2, 1)
    FIELD(POR_ERRCTLR_MXP_U_SMXP_4_0, ED, 0, 1)
REG32(POR_ERRSTATUS_MXP_U_SMXP_4_0, 0x202f010)
    FIELD(POR_ERRSTATUS_MXP_U_SMXP_4_0, RESERVED_31, 31, 33)
    FIELD(POR_ERRSTATUS_MXP_U_SMXP_4_0, V, 30, 1)
    FIELD(POR_ERRSTATUS_MXP_U_SMXP_4_0, UE, 29, 1)
    FIELD(POR_ERRSTATUS_MXP_U_SMXP_4_0, RESERVED_28, 28, 1)
    FIELD(POR_ERRSTATUS_MXP_U_SMXP_4_0, OF, 27, 1)
    FIELD(POR_ERRSTATUS_MXP_U_SMXP_4_0, RESERVED_24, 24, 3)
    FIELD(POR_ERRSTATUS_MXP_U_SMXP_4_0, DE, 23, 1)
    FIELD(POR_ERRSTATUS_MXP_U_SMXP_4_0, RESERVED_16, 16, 7)
    FIELD(POR_ERRSTATUS_MXP_U_SMXP_4_0, V_ERR_TYPE, 6, 10)
    FIELD(POR_ERRSTATUS_MXP_U_SMXP_4_0, RESERVED_0, 0, 6)
REG32(POR_FDC_AUX_CTL_MXP_U_SMXP_4_0, 0x202f018)
    FIELD(POR_FDC_AUX_CTL_MXP_U_SMXP_4_0, CLKGATE_OVERRIDE, 4, 1)
    FIELD(POR_FDC_AUX_CTL_MXP_U_SMXP_4_0, RESERVED_0, 0, 4)
REG32(POR_ERRFR_P0_D0_U_SMXP_4_0, 0x202f040)
    FIELD(POR_ERRFR_P0_D0_U_SMXP_4_0, FI, 6, 2)
    FIELD(POR_ERRFR_P0_D0_U_SMXP_4_0, UI, 4, 2)
    FIELD(POR_ERRFR_P0_D0_U_SMXP_4_0, ED, 0, 2)
REG32(POR_ERRCTLR_P0_D0_U_SMXP_4_0, 0x202f048)
    FIELD(POR_ERRCTLR_P0_D0_U_SMXP_4_0, RESERVED_32, 32, 32)
    FIELD(POR_ERRCTLR_P0_D0_U_SMXP_4_0, ERC, 14, 18)
    FIELD(POR_ERRCTLR_P0_D0_U_SMXP_4_0, FI, 3, 1)
    FIELD(POR_ERRCTLR_P0_D0_U_SMXP_4_0, UI, 2, 1)
    FIELD(POR_ERRCTLR_P0_D0_U_SMXP_4_0, ED, 0, 1)
REG32(POR_ERRSTATUS_P0_D0_U_SMXP_4_0, 0x202f050)
    FIELD(POR_ERRSTATUS_P0_D0_U_SMXP_4_0, RESERVED_31, 31, 33)
    FIELD(POR_ERRSTATUS_P0_D0_U_SMXP_4_0, V, 30, 1)
    FIELD(POR_ERRSTATUS_P0_D0_U_SMXP_4_0, UE, 29, 1)
    FIELD(POR_ERRSTATUS_P0_D0_U_SMXP_4_0, RESERVED_28, 28, 1)
    FIELD(POR_ERRSTATUS_P0_D0_U_SMXP_4_0, OF, 27, 1)
    FIELD(POR_ERRSTATUS_P0_D0_U_SMXP_4_0, RESERVED_24, 24, 3)
    FIELD(POR_ERRSTATUS_P0_D0_U_SMXP_4_0, DE, 23, 1)
    FIELD(POR_ERRSTATUS_P0_D0_U_SMXP_4_0, RESERVED_16, 16, 7)
    FIELD(POR_ERRSTATUS_P0_D0_U_SMXP_4_0, V_ERR_TYPE, 6, 10)
    FIELD(POR_ERRSTATUS_P0_D0_U_SMXP_4_0, RESERVED_0, 0, 6)
REG32(POR_FDC_AUX_CTL_P0_D0_U_SMXP_4_0, 0x202f058)
    FIELD(POR_FDC_AUX_CTL_P0_D0_U_SMXP_4_0, CLKGATE_OVERRIDE, 4, 1)
    FIELD(POR_FDC_AUX_CTL_P0_D0_U_SMXP_4_0, HANG_DET_CONFIG, 0, 4)
REG32(POR_ERRFR_P0_D1_U_SMXP_4_0, 0x202f080)
    FIELD(POR_ERRFR_P0_D1_U_SMXP_4_0, FI, 6, 2)
    FIELD(POR_ERRFR_P0_D1_U_SMXP_4_0, UI, 4, 2)
    FIELD(POR_ERRFR_P0_D1_U_SMXP_4_0, ED, 0, 2)
REG32(POR_ERRCTLR_P0_D1_U_SMXP_4_0, 0x202f088)
    FIELD(POR_ERRCTLR_P0_D1_U_SMXP_4_0, RESERVED_32, 32, 32)
    FIELD(POR_ERRCTLR_P0_D1_U_SMXP_4_0, ERC, 14, 18)
    FIELD(POR_ERRCTLR_P0_D1_U_SMXP_4_0, FI, 3, 1)
    FIELD(POR_ERRCTLR_P0_D1_U_SMXP_4_0, UI, 2, 1)
    FIELD(POR_ERRCTLR_P0_D1_U_SMXP_4_0, ED, 0, 1)
REG32(POR_ERRSTATUS_P0_D1_U_SMXP_4_0, 0x202f090)
    FIELD(POR_ERRSTATUS_P0_D1_U_SMXP_4_0, RESERVED_31, 31, 33)
    FIELD(POR_ERRSTATUS_P0_D1_U_SMXP_4_0, V, 30, 1)
    FIELD(POR_ERRSTATUS_P0_D1_U_SMXP_4_0, UE, 29, 1)
    FIELD(POR_ERRSTATUS_P0_D1_U_SMXP_4_0, RESERVED_28, 28, 1)
    FIELD(POR_ERRSTATUS_P0_D1_U_SMXP_4_0, OF, 27, 1)
    FIELD(POR_ERRSTATUS_P0_D1_U_SMXP_4_0, RESERVED_24, 24, 3)
    FIELD(POR_ERRSTATUS_P0_D1_U_SMXP_4_0, DE, 23, 1)
    FIELD(POR_ERRSTATUS_P0_D1_U_SMXP_4_0, RESERVED_16, 16, 7)
    FIELD(POR_ERRSTATUS_P0_D1_U_SMXP_4_0, V_ERR_TYPE, 6, 10)
    FIELD(POR_ERRSTATUS_P0_D1_U_SMXP_4_0, RESERVED_0, 0, 6)
REG32(POR_FDC_AUX_CTL_P0_D1_U_SMXP_4_0, 0x202f098)
    FIELD(POR_FDC_AUX_CTL_P0_D1_U_SMXP_4_0, CLKGATE_OVERRIDE, 4, 1)
    FIELD(POR_FDC_AUX_CTL_P0_D1_U_SMXP_4_0, HANG_DET_CONFIG, 0, 4)
REG32(POR_ERRFR_P0_D2_U_SMXP_4_0, 0x202f0c0)
    FIELD(POR_ERRFR_P0_D2_U_SMXP_4_0, FI, 6, 2)
    FIELD(POR_ERRFR_P0_D2_U_SMXP_4_0, UI, 4, 2)
    FIELD(POR_ERRFR_P0_D2_U_SMXP_4_0, ED, 0, 2)
REG32(POR_ERRCTLR_P0_D2_U_SMXP_4_0, 0x202f0c8)
    FIELD(POR_ERRCTLR_P0_D2_U_SMXP_4_0, RESERVED_32, 32, 32)
    FIELD(POR_ERRCTLR_P0_D2_U_SMXP_4_0, ERC, 14, 18)
    FIELD(POR_ERRCTLR_P0_D2_U_SMXP_4_0, FI, 3, 1)
    FIELD(POR_ERRCTLR_P0_D2_U_SMXP_4_0, UI, 2, 1)
    FIELD(POR_ERRCTLR_P0_D2_U_SMXP_4_0, ED, 0, 1)
REG32(POR_ERRSTATUS_P0_D2_U_SMXP_4_0, 0x202f0d0)
    FIELD(POR_ERRSTATUS_P0_D2_U_SMXP_4_0, RESERVED_31, 31, 33)
    FIELD(POR_ERRSTATUS_P0_D2_U_SMXP_4_0, V, 30, 1)
    FIELD(POR_ERRSTATUS_P0_D2_U_SMXP_4_0, UE, 29, 1)
    FIELD(POR_ERRSTATUS_P0_D2_U_SMXP_4_0, RESERVED_28, 28, 1)
    FIELD(POR_ERRSTATUS_P0_D2_U_SMXP_4_0, OF, 27, 1)
    FIELD(POR_ERRSTATUS_P0_D2_U_SMXP_4_0, RESERVED_24, 24, 3)
    FIELD(POR_ERRSTATUS_P0_D2_U_SMXP_4_0, DE, 23, 1)
    FIELD(POR_ERRSTATUS_P0_D2_U_SMXP_4_0, RESERVED_16, 16, 7)
    FIELD(POR_ERRSTATUS_P0_D2_U_SMXP_4_0, V_ERR_TYPE, 6, 10)
    FIELD(POR_ERRSTATUS_P0_D2_U_SMXP_4_0, RESERVED_0, 0, 6)
REG32(POR_FDC_AUX_CTL_P0_D2_U_SMXP_4_0, 0x202f0d8)
    FIELD(POR_FDC_AUX_CTL_P0_D2_U_SMXP_4_0, CLKGATE_OVERRIDE, 4, 1)
    FIELD(POR_FDC_AUX_CTL_P0_D2_U_SMXP_4_0, HANG_DET_CONFIG, 0, 4)
REG32(POR_ERRFR_P0_D3_U_SMXP_4_0, 0x202f100)
    FIELD(POR_ERRFR_P0_D3_U_SMXP_4_0, FI, 6, 2)
    FIELD(POR_ERRFR_P0_D3_U_SMXP_4_0, UI, 4, 2)
    FIELD(POR_ERRFR_P0_D3_U_SMXP_4_0, ED, 0, 2)
REG32(POR_ERRCTLR_P0_D3_U_SMXP_4_0, 0x202f108)
    FIELD(POR_ERRCTLR_P0_D3_U_SMXP_4_0, RESERVED_32, 32, 32)
    FIELD(POR_ERRCTLR_P0_D3_U_SMXP_4_0, ERC, 14, 18)
    FIELD(POR_ERRCTLR_P0_D3_U_SMXP_4_0, FI, 3, 1)
    FIELD(POR_ERRCTLR_P0_D3_U_SMXP_4_0, UI, 2, 1)
    FIELD(POR_ERRCTLR_P0_D3_U_SMXP_4_0, ED, 0, 1)
REG32(POR_ERRSTATUS_P0_D3_U_SMXP_4_0, 0x202f110)
    FIELD(POR_ERRSTATUS_P0_D3_U_SMXP_4_0, RESERVED_31, 31, 33)
    FIELD(POR_ERRSTATUS_P0_D3_U_SMXP_4_0, V, 30, 1)
    FIELD(POR_ERRSTATUS_P0_D3_U_SMXP_4_0, UE, 29, 1)
    FIELD(POR_ERRSTATUS_P0_D3_U_SMXP_4_0, RESERVED_28, 28, 1)
    FIELD(POR_ERRSTATUS_P0_D3_U_SMXP_4_0, OF, 27, 1)
    FIELD(POR_ERRSTATUS_P0_D3_U_SMXP_4_0, RESERVED_24, 24, 3)
    FIELD(POR_ERRSTATUS_P0_D3_U_SMXP_4_0, DE, 23, 1)
    FIELD(POR_ERRSTATUS_P0_D3_U_SMXP_4_0, RESERVED_16, 16, 7)
    FIELD(POR_ERRSTATUS_P0_D3_U_SMXP_4_0, V_ERR_TYPE, 6, 10)
    FIELD(POR_ERRSTATUS_P0_D3_U_SMXP_4_0, RESERVED_0, 0, 6)
REG32(POR_FDC_AUX_CTL_P0_D3_U_SMXP_4_0, 0x202f118)
    FIELD(POR_FDC_AUX_CTL_P0_D3_U_SMXP_4_0, CLKGATE_OVERRIDE, 4, 1)
    FIELD(POR_FDC_AUX_CTL_P0_D3_U_SMXP_4_0, HANG_DET_CONFIG, 0, 4)
REG32(POR_ERRFR_P1_D0_U_SMXP_4_0, 0x202f140)
    FIELD(POR_ERRFR_P1_D0_U_SMXP_4_0, FI, 6, 2)
    FIELD(POR_ERRFR_P1_D0_U_SMXP_4_0, UI, 4, 2)
    FIELD(POR_ERRFR_P1_D0_U_SMXP_4_0, ED, 0, 2)
REG32(POR_ERRCTLR_P1_D0_U_SMXP_4_0, 0x202f148)
    FIELD(POR_ERRCTLR_P1_D0_U_SMXP_4_0, RESERVED_32, 32, 32)
    FIELD(POR_ERRCTLR_P1_D0_U_SMXP_4_0, ERC, 14, 18)
    FIELD(POR_ERRCTLR_P1_D0_U_SMXP_4_0, FI, 3, 1)
    FIELD(POR_ERRCTLR_P1_D0_U_SMXP_4_0, UI, 2, 1)
    FIELD(POR_ERRCTLR_P1_D0_U_SMXP_4_0, ED, 0, 1)
REG32(POR_ERRSTATUS_P1_D0_U_SMXP_4_0, 0x202f150)
    FIELD(POR_ERRSTATUS_P1_D0_U_SMXP_4_0, RESERVED_31, 31, 33)
    FIELD(POR_ERRSTATUS_P1_D0_U_SMXP_4_0, V, 30, 1)
    FIELD(POR_ERRSTATUS_P1_D0_U_SMXP_4_0, UE, 29, 1)
    FIELD(POR_ERRSTATUS_P1_D0_U_SMXP_4_0, RESERVED_28, 28, 1)
    FIELD(POR_ERRSTATUS_P1_D0_U_SMXP_4_0, OF, 27, 1)
    FIELD(POR_ERRSTATUS_P1_D0_U_SMXP_4_0, RESERVED_24, 24, 3)
    FIELD(POR_ERRSTATUS_P1_D0_U_SMXP_4_0, DE, 23, 1)
    FIELD(POR_ERRSTATUS_P1_D0_U_SMXP_4_0, RESERVED_16, 16, 7)
    FIELD(POR_ERRSTATUS_P1_D0_U_SMXP_4_0, V_ERR_TYPE, 6, 10)
    FIELD(POR_ERRSTATUS_P1_D0_U_SMXP_4_0, RESERVED_0, 0, 6)
REG32(POR_FDC_AUX_CTL_P1_D0_U_SMXP_4_0, 0x202f158)
    FIELD(POR_FDC_AUX_CTL_P1_D0_U_SMXP_4_0, CLKGATE_OVERRIDE, 4, 1)
    FIELD(POR_FDC_AUX_CTL_P1_D0_U_SMXP_4_0, HANG_DET_CONFIG, 0, 4)
REG32(POR_ERRFR_P1_D1_U_SMXP_4_0, 0x202f180)
    FIELD(POR_ERRFR_P1_D1_U_SMXP_4_0, FI, 6, 2)
    FIELD(POR_ERRFR_P1_D1_U_SMXP_4_0, UI, 4, 2)
    FIELD(POR_ERRFR_P1_D1_U_SMXP_4_0, ED, 0, 2)
REG32(POR_ERRCTLR_P1_D1_U_SMXP_4_0, 0x202f188)
    FIELD(POR_ERRCTLR_P1_D1_U_SMXP_4_0, RESERVED_32, 32, 32)
    FIELD(POR_ERRCTLR_P1_D1_U_SMXP_4_0, ERC, 14, 18)
    FIELD(POR_ERRCTLR_P1_D1_U_SMXP_4_0, FI, 3, 1)
    FIELD(POR_ERRCTLR_P1_D1_U_SMXP_4_0, UI, 2, 1)
    FIELD(POR_ERRCTLR_P1_D1_U_SMXP_4_0, ED, 0, 1)
REG32(POR_ERRSTATUS_P1_D1_U_SMXP_4_0, 0x202f190)
    FIELD(POR_ERRSTATUS_P1_D1_U_SMXP_4_0, RESERVED_31, 31, 33)
    FIELD(POR_ERRSTATUS_P1_D1_U_SMXP_4_0, V, 30, 1)
    FIELD(POR_ERRSTATUS_P1_D1_U_SMXP_4_0, UE, 29, 1)
    FIELD(POR_ERRSTATUS_P1_D1_U_SMXP_4_0, RESERVED_28, 28, 1)
    FIELD(POR_ERRSTATUS_P1_D1_U_SMXP_4_0, OF, 27, 1)
    FIELD(POR_ERRSTATUS_P1_D1_U_SMXP_4_0, RESERVED_24, 24, 3)
    FIELD(POR_ERRSTATUS_P1_D1_U_SMXP_4_0, DE, 23, 1)
    FIELD(POR_ERRSTATUS_P1_D1_U_SMXP_4_0, RESERVED_16, 16, 7)
    FIELD(POR_ERRSTATUS_P1_D1_U_SMXP_4_0, V_ERR_TYPE, 6, 10)
    FIELD(POR_ERRSTATUS_P1_D1_U_SMXP_4_0, RESERVED_0, 0, 6)
REG32(POR_FDC_AUX_CTL_P1_D1_U_SMXP_4_0, 0x202f198)
    FIELD(POR_FDC_AUX_CTL_P1_D1_U_SMXP_4_0, CLKGATE_OVERRIDE, 4, 1)
    FIELD(POR_FDC_AUX_CTL_P1_D1_U_SMXP_4_0, HANG_DET_CONFIG, 0, 4)
REG32(POR_ERRFR_P1_D2_U_SMXP_4_0, 0x202f1c0)
    FIELD(POR_ERRFR_P1_D2_U_SMXP_4_0, FI, 6, 2)
    FIELD(POR_ERRFR_P1_D2_U_SMXP_4_0, UI, 4, 2)
    FIELD(POR_ERRFR_P1_D2_U_SMXP_4_0, ED, 0, 2)
REG32(POR_ERRCTLR_P1_D2_U_SMXP_4_0, 0x202f1c8)
    FIELD(POR_ERRCTLR_P1_D2_U_SMXP_4_0, RESERVED_32, 32, 32)
    FIELD(POR_ERRCTLR_P1_D2_U_SMXP_4_0, ERC, 14, 18)
    FIELD(POR_ERRCTLR_P1_D2_U_SMXP_4_0, FI, 3, 1)
    FIELD(POR_ERRCTLR_P1_D2_U_SMXP_4_0, UI, 2, 1)
    FIELD(POR_ERRCTLR_P1_D2_U_SMXP_4_0, ED, 0, 1)
REG32(POR_ERRSTATUS_P1_D2_U_SMXP_4_0, 0x202f1d0)
    FIELD(POR_ERRSTATUS_P1_D2_U_SMXP_4_0, RESERVED_31, 31, 33)
    FIELD(POR_ERRSTATUS_P1_D2_U_SMXP_4_0, V, 30, 1)
    FIELD(POR_ERRSTATUS_P1_D2_U_SMXP_4_0, UE, 29, 1)
    FIELD(POR_ERRSTATUS_P1_D2_U_SMXP_4_0, RESERVED_28, 28, 1)
    FIELD(POR_ERRSTATUS_P1_D2_U_SMXP_4_0, OF, 27, 1)
    FIELD(POR_ERRSTATUS_P1_D2_U_SMXP_4_0, RESERVED_24, 24, 3)
    FIELD(POR_ERRSTATUS_P1_D2_U_SMXP_4_0, DE, 23, 1)
    FIELD(POR_ERRSTATUS_P1_D2_U_SMXP_4_0, RESERVED_16, 16, 7)
    FIELD(POR_ERRSTATUS_P1_D2_U_SMXP_4_0, V_ERR_TYPE, 6, 10)
    FIELD(POR_ERRSTATUS_P1_D2_U_SMXP_4_0, RESERVED_0, 0, 6)
REG32(POR_FDC_AUX_CTL_P1_D2_U_SMXP_4_0, 0x202f1d8)
    FIELD(POR_FDC_AUX_CTL_P1_D2_U_SMXP_4_0, CLKGATE_OVERRIDE, 4, 1)
    FIELD(POR_FDC_AUX_CTL_P1_D2_U_SMXP_4_0, HANG_DET_CONFIG, 0, 4)
REG32(POR_ERRFR_P1_D3_U_SMXP_4_0, 0x202f200)
    FIELD(POR_ERRFR_P1_D3_U_SMXP_4_0, FI, 6, 2)
    FIELD(POR_ERRFR_P1_D3_U_SMXP_4_0, UI, 4, 2)
    FIELD(POR_ERRFR_P1_D3_U_SMXP_4_0, ED, 0, 2)
REG32(POR_ERRCTLR_P1_D3_U_SMXP_4_0, 0x202f208)
    FIELD(POR_ERRCTLR_P1_D3_U_SMXP_4_0, RESERVED_32, 32, 32)
    FIELD(POR_ERRCTLR_P1_D3_U_SMXP_4_0, ERC, 14, 18)
    FIELD(POR_ERRCTLR_P1_D3_U_SMXP_4_0, FI, 3, 1)
    FIELD(POR_ERRCTLR_P1_D3_U_SMXP_4_0, UI, 2, 1)
    FIELD(POR_ERRCTLR_P1_D3_U_SMXP_4_0, ED, 0, 1)
REG32(POR_ERRSTATUS_P1_D3_U_SMXP_4_0, 0x202f210)
    FIELD(POR_ERRSTATUS_P1_D3_U_SMXP_4_0, RESERVED_31, 31, 33)
    FIELD(POR_ERRSTATUS_P1_D3_U_SMXP_4_0, V, 30, 1)
    FIELD(POR_ERRSTATUS_P1_D3_U_SMXP_4_0, UE, 29, 1)
    FIELD(POR_ERRSTATUS_P1_D3_U_SMXP_4_0, RESERVED_28, 28, 1)
    FIELD(POR_ERRSTATUS_P1_D3_U_SMXP_4_0, OF, 27, 1)
    FIELD(POR_ERRSTATUS_P1_D3_U_SMXP_4_0, RESERVED_24, 24, 3)
    FIELD(POR_ERRSTATUS_P1_D3_U_SMXP_4_0, DE, 23, 1)
    FIELD(POR_ERRSTATUS_P1_D3_U_SMXP_4_0, RESERVED_16, 16, 7)
    FIELD(POR_ERRSTATUS_P1_D3_U_SMXP_4_0, V_ERR_TYPE, 6, 10)
    FIELD(POR_ERRSTATUS_P1_D3_U_SMXP_4_0, RESERVED_0, 0, 6)
REG32(POR_FDC_AUX_CTL_P1_D3_U_SMXP_4_0, 0x202f218)
    FIELD(POR_FDC_AUX_CTL_P1_D3_U_SMXP_4_0, CLKGATE_OVERRIDE, 4, 1)
    FIELD(POR_FDC_AUX_CTL_P1_D3_U_SMXP_4_0, HANG_DET_CONFIG, 0, 4)
REG32(POR_ERRINJECT_U_SMXP_4_0, 0x202f300)
    FIELD(POR_ERRINJECT_U_SMXP_4_0, ERR_DEV, 4, 4)
    FIELD(POR_ERRINJECT_U_SMXP_4_0, ERR_TYPE, 0, 4)
REG32(POR_FDC_KEY_U_SMXP_4_0, 0x202f308)
    FIELD(POR_FDC_KEY_U_SMXP_4_0, KEY, 0, 8)
REG32(POR_DT_NODE_INFO_U_HND_NID256, 0x2030000)
    FIELD(POR_DT_NODE_INFO_U_HND_NID256, RESERVED_48, 48, 16)
    FIELD(POR_DT_NODE_INFO_U_HND_NID256, LOGICAL_ID, 32, 16)
    FIELD(POR_DT_NODE_INFO_U_HND_NID256, NODE_ID, 16, 16)
    FIELD(POR_DT_NODE_INFO_U_HND_NID256, NODE_TYPE, 0, 16)
REG32(POR_DT_CHILD_INFO_U_HND_NID256, 0x2030080)
    FIELD(POR_DT_CHILD_INFO_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_DT_CHILD_INFO_U_HND_NID256, CHILD_PTR_OFFSET, 16, 16)
    FIELD(POR_DT_CHILD_INFO_U_HND_NID256, CHILD_COUNT, 0, 16)
REG32(POR_DT_SECURE_ACCESS_U_HND_NID256, 0x2030980)
    FIELD(POR_DT_SECURE_ACCESS_U_HND_NID256, PM_DISABLE, 2, 1)
    FIELD(POR_DT_SECURE_ACCESS_U_HND_NID256, DT_DISABLE, 1, 1)
    FIELD(POR_DT_SECURE_ACCESS_U_HND_NID256, SECURE_DEBUG_DISABLE, 0, 1)
REG32(POR_DT_DTC_CTL_U_HND_NID256, 0x2030a00)
    FIELD(POR_DT_DTC_CTL_U_HND_NID256, RESERVED_11, 11, 53)
    FIELD(POR_DT_DTC_CTL_U_HND_NID256, CG_DISABLE, 10, 1)
    FIELD(POR_DT_DTC_CTL_U_HND_NID256, CROSS_TRIGGER_COUNT, 4, 6)
    FIELD(POR_DT_DTC_CTL_U_HND_NID256, DT_WAIT_FOR_TRIGGER, 3, 1)
    FIELD(POR_DT_DTC_CTL_U_HND_NID256, ATBTRIGGER_EN, 2, 1)
    FIELD(POR_DT_DTC_CTL_U_HND_NID256, DBGTRIGGER_EN, 1, 1)
    FIELD(POR_DT_DTC_CTL_U_HND_NID256, DT_EN, 0, 1)
REG32(POR_DT_TRIGGER_STATUS_U_HND_NID256, 0x2030a10)
    FIELD(POR_DT_TRIGGER_STATUS_U_HND_NID256, RESERVED_24, 24, 40)
    FIELD(POR_DT_TRIGGER_STATUS_U_HND_NID256, TRIGGER_WP, 20, 4)
    FIELD(POR_DT_TRIGGER_STATUS_U_HND_NID256, RESERVED_19, 19, 1)
    FIELD(POR_DT_TRIGGER_STATUS_U_HND_NID256, TRIGGER_NODEID, 8, 11)
    FIELD(POR_DT_TRIGGER_STATUS_U_HND_NID256, TRIGGER_STATUS, 0, 1)
REG32(POR_DT_TRIGGER_STATUS_CLR_U_HND_NID256, 0x2030a20)
    FIELD(POR_DT_TRIGGER_STATUS_CLR_U_HND_NID256, TRIGGER_STATUS_CLR, 0, 1)
REG32(POR_DT_TRACE_CONTROL_U_HND_NID256, 0x2030a30)
    FIELD(POR_DT_TRACE_CONTROL_U_HND_NID256, RESERVED_9, 9, 55)
    FIELD(POR_DT_TRACE_CONTROL_U_HND_NID256, CC_ENABLE, 8, 1)
    FIELD(POR_DT_TRACE_CONTROL_U_HND_NID256, TIMESTAMP_PERIOD, 5, 3)
    FIELD(POR_DT_TRACE_CONTROL_U_HND_NID256, ASYNC_PERIOD, 0, 5)
REG32(POR_DT_TRACEID_U_HND_NID256, 0x2030a48)
    FIELD(POR_DT_TRACEID_U_HND_NID256, TRACEID, 0, 7)
REG32(POR_DT_PMEVCNTAB_U_HND_NID256, 0x2032000)
    FIELD(POR_DT_PMEVCNTAB_U_HND_NID256, PMEVCNTB, 32, 32)
    FIELD(POR_DT_PMEVCNTAB_U_HND_NID256, PMEVCNTA, 0, 32)
REG32(POR_DT_PMEVCNTCD_U_HND_NID256, 0x2032010)
    FIELD(POR_DT_PMEVCNTCD_U_HND_NID256, PMEVCNTD, 32, 32)
    FIELD(POR_DT_PMEVCNTCD_U_HND_NID256, PMEVCNTC, 0, 32)
REG32(POR_DT_PMEVCNTEF_U_HND_NID256, 0x2032020)
    FIELD(POR_DT_PMEVCNTEF_U_HND_NID256, PMEVCNTF, 32, 32)
    FIELD(POR_DT_PMEVCNTEF_U_HND_NID256, PMEVCNTE, 0, 32)
REG32(POR_DT_PMEVCNTGH_U_HND_NID256, 0x2032030)
    FIELD(POR_DT_PMEVCNTGH_U_HND_NID256, PMEVCNTH, 32, 32)
    FIELD(POR_DT_PMEVCNTGH_U_HND_NID256, PMEVCNTG, 0, 32)
REG32(POR_DT_PMCCNTR_U_HND_NID256, 0x2032040)
    FIELD(POR_DT_PMCCNTR_U_HND_NID256, RESERVED_40, 40, 24)
    FIELD(POR_DT_PMCCNTR_U_HND_NID256, PMCCNTR, 0, 40)
REG32(POR_DT_PMEVCNTSRAB_U_HND_NID256, 0x2032050)
    FIELD(POR_DT_PMEVCNTSRAB_U_HND_NID256, PMEVCNTSRB, 32, 32)
    FIELD(POR_DT_PMEVCNTSRAB_U_HND_NID256, PMEVCNTSRA, 0, 32)
REG32(POR_DT_PMEVCNTSRCD_U_HND_NID256, 0x2032060)
    FIELD(POR_DT_PMEVCNTSRCD_U_HND_NID256, PMEVCNTSRD, 32, 32)
    FIELD(POR_DT_PMEVCNTSRCD_U_HND_NID256, PMEVCNTSRC, 0, 32)
REG32(POR_DT_PMEVCNTSREF_U_HND_NID256, 0x2032070)
    FIELD(POR_DT_PMEVCNTSREF_U_HND_NID256, PMEVCNTSRF, 32, 32)
    FIELD(POR_DT_PMEVCNTSREF_U_HND_NID256, PMEVCNTSRE, 0, 32)
REG32(POR_DT_PMEVCNTSRGH_U_HND_NID256, 0x2032080)
    FIELD(POR_DT_PMEVCNTSRGH_U_HND_NID256, PMEVCNTSRH, 32, 32)
    FIELD(POR_DT_PMEVCNTSRGH_U_HND_NID256, PMEVCNTSRG, 0, 32)
REG32(POR_DT_PMCCNTRSR_U_HND_NID256, 0x2032090)
    FIELD(POR_DT_PMCCNTRSR_U_HND_NID256, RESERVED_40, 40, 24)
    FIELD(POR_DT_PMCCNTRSR_U_HND_NID256, PMCCNTRSR, 0, 40)
REG32(POR_DT_PMCR_U_HND_NID256, 0x2032100)
    FIELD(POR_DT_PMCR_U_HND_NID256, OVFL_INTR_EN, 6, 1)
    FIELD(POR_DT_PMCR_U_HND_NID256, CNTR_RST, 5, 1)
    FIELD(POR_DT_PMCR_U_HND_NID256, CNTCFG, 1, 4)
    FIELD(POR_DT_PMCR_U_HND_NID256, PMU_EN, 0, 1)
REG32(POR_DT_PMOVSR_U_HND_NID256, 0x2032118)
    FIELD(POR_DT_PMOVSR_U_HND_NID256, RESERVED_9, 9, 55)
    FIELD(POR_DT_PMOVSR_U_HND_NID256, PMOVSR, 0, 9)
REG32(POR_DT_PMOVSR_CLR_U_HND_NID256, 0x2032120)
    FIELD(POR_DT_PMOVSR_CLR_U_HND_NID256, RESERVED_9, 9, 55)
    FIELD(POR_DT_PMOVSR_CLR_U_HND_NID256, PMOVSR_CLR, 0, 9)
REG32(POR_DT_PMSSR_U_HND_NID256, 0x2032128)
    FIELD(POR_DT_PMSSR_U_HND_NID256, RESERVED_17, 17, 47)
    FIELD(POR_DT_PMSSR_U_HND_NID256, SS_PIN_ACTIVE, 16, 1)
    FIELD(POR_DT_PMSSR_U_HND_NID256, SS_CFG_ACTIVE, 15, 1)
    FIELD(POR_DT_PMSSR_U_HND_NID256, RESERVED_9, 9, 6)
    FIELD(POR_DT_PMSSR_U_HND_NID256, SS_STATUS, 0, 9)
REG32(POR_DT_PMSRR_U_HND_NID256, 0x2032130)
    FIELD(POR_DT_PMSRR_U_HND_NID256, SS_REQ, 0, 1)
REG32(POR_DT_CLAIM_U_HND_NID256, 0x2032da0)
    FIELD(POR_DT_CLAIM_U_HND_NID256, CLR, 32, 32)
    FIELD(POR_DT_CLAIM_U_HND_NID256, SET, 0, 32)
REG32(POR_DT_DEVAFF_U_HND_NID256, 0x2032da8)
REG32(POR_DT_LSR_U_HND_NID256, 0x2032db0)
    FIELD(POR_DT_LSR_U_HND_NID256, RESERVED_35, 35, 29)
    FIELD(POR_DT_LSR_U_HND_NID256, LSRVALUE, 32, 3)
    FIELD(POR_DT_LSR_U_HND_NID256, RESERVED_0, 0, 32)
REG32(POR_DT_AUTHSTATUS_DEVARCH_U_HND_NID256, 0x2032db8)
    FIELD(POR_DT_AUTHSTATUS_DEVARCH_U_HND_NID256, ARCHITECT, 53, 11)
    FIELD(POR_DT_AUTHSTATUS_DEVARCH_U_HND_NID256, PRESENT, 52, 1)
    FIELD(POR_DT_AUTHSTATUS_DEVARCH_U_HND_NID256, REVISION, 47, 5)
    FIELD(POR_DT_AUTHSTATUS_DEVARCH_U_HND_NID256, ARCHID, 32, 15)
    FIELD(POR_DT_AUTHSTATUS_DEVARCH_U_HND_NID256, SNID, 6, 2)
    FIELD(POR_DT_AUTHSTATUS_DEVARCH_U_HND_NID256, NSNID, 2, 2)
    FIELD(POR_DT_AUTHSTATUS_DEVARCH_U_HND_NID256, RESERVED_0, 0, 2)
REG32(POR_DT_DEVID_U_HND_NID256, 0x2032dc0)
REG32(POR_DT_DEVTYPE_U_HND_NID256, 0x2032dc8)
    FIELD(POR_DT_DEVTYPE_U_HND_NID256, RESERVED_40, 40, 24)
    FIELD(POR_DT_DEVTYPE_U_HND_NID256, SUB, 36, 4)
    FIELD(POR_DT_DEVTYPE_U_HND_NID256, MAJOR, 32, 4)
    FIELD(POR_DT_DEVTYPE_U_HND_NID256, RESERVED_0, 0, 32)
REG32(POR_DT_PIDR45_U_HND_NID256, 0x2032dd0)
    FIELD(POR_DT_PIDR45_U_HND_NID256, RESERVED_40, 40, 24)
    FIELD(POR_DT_PIDR45_U_HND_NID256, PIDR5, 32, 8)
    FIELD(POR_DT_PIDR45_U_HND_NID256, PIDR4, 0, 8)
REG32(POR_DT_PIDR67_U_HND_NID256, 0x2032dd8)
    FIELD(POR_DT_PIDR67_U_HND_NID256, RESERVED_40, 40, 24)
    FIELD(POR_DT_PIDR67_U_HND_NID256, PIDR7, 32, 8)
    FIELD(POR_DT_PIDR67_U_HND_NID256, PIDR6, 0, 8)
REG32(POR_DT_PIDR01_U_HND_NID256, 0x2032de0)
    FIELD(POR_DT_PIDR01_U_HND_NID256, RESERVED_40, 40, 24)
    FIELD(POR_DT_PIDR01_U_HND_NID256, PIDR1, 32, 8)
    FIELD(POR_DT_PIDR01_U_HND_NID256, PIDR0, 0, 8)
REG32(POR_DT_PIDR23_U_HND_NID256, 0x2032de8)
    FIELD(POR_DT_PIDR23_U_HND_NID256, RESERVED_40, 40, 24)
    FIELD(POR_DT_PIDR23_U_HND_NID256, PIDR3, 32, 8)
    FIELD(POR_DT_PIDR23_U_HND_NID256, PIDR2, 0, 8)
REG32(POR_DT_CIDR01_U_HND_NID256, 0x2032df0)
    FIELD(POR_DT_CIDR01_U_HND_NID256, RESERVED_40, 40, 24)
    FIELD(POR_DT_CIDR01_U_HND_NID256, CIDR1, 32, 8)
    FIELD(POR_DT_CIDR01_U_HND_NID256, CIDR0, 0, 8)
REG32(POR_DT_CIDR23_U_HND_NID256, 0x2032df8)
    FIELD(POR_DT_CIDR23_U_HND_NID256, RESERVED_40, 40, 24)
    FIELD(POR_DT_CIDR23_U_HND_NID256, CIDR3, 32, 8)
    FIELD(POR_DT_CIDR23_U_HND_NID256, CIDR2, 0, 8)
REG32(POR_MPU_NODE_INFO_U_RNI_NID260, 0x2034000)
    FIELD(POR_MPU_NODE_INFO_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_NODE_INFO_U_RNI_NID260, LOGICAL_ID, 32, 16)
    FIELD(POR_MPU_NODE_INFO_U_RNI_NID260, NODE_ID, 16, 16)
    FIELD(POR_MPU_NODE_INFO_U_RNI_NID260, NODE_TYPE, 0, 16)
REG32(POR_MPU_CHILD_INFO_U_RNI_NID260, 0x2034080)
    FIELD(POR_MPU_CHILD_INFO_U_RNI_NID260, RESERVED_32, 32, 32)
    FIELD(POR_MPU_CHILD_INFO_U_RNI_NID260, CHILD_PTR_OFFSET, 16, 16)
    FIELD(POR_MPU_CHILD_INFO_U_RNI_NID260, CHILD_COUNT, 0, 16)
REG32(POR_MPU_UNIT_INFO_U_RNI_NID260, 0x2034900)
    FIELD(POR_MPU_UNIT_INFO_U_RNI_NID260, RESERVED_16, 16, 48)
    FIELD(POR_MPU_UNIT_INFO_U_RNI_NID260, MASTER_7_PRESENT, 15, 1)
    FIELD(POR_MPU_UNIT_INFO_U_RNI_NID260, MASTER_6_PRESENT, 14, 1)
    FIELD(POR_MPU_UNIT_INFO_U_RNI_NID260, MASTER_5_PRESENT, 13, 1)
    FIELD(POR_MPU_UNIT_INFO_U_RNI_NID260, MASTER_4_PRESENT, 12, 1)
    FIELD(POR_MPU_UNIT_INFO_U_RNI_NID260, MASTER_3_PRESENT, 11, 1)
    FIELD(POR_MPU_UNIT_INFO_U_RNI_NID260, MASTER_2_PRESENT, 10, 1)
    FIELD(POR_MPU_UNIT_INFO_U_RNI_NID260, MASTER_1_PRESENT, 9, 1)
    FIELD(POR_MPU_UNIT_INFO_U_RNI_NID260, MASTER_0_PRESENT, 8, 1)
    FIELD(POR_MPU_UNIT_INFO_U_RNI_NID260, NUM_PROG_REGION, 0, 8)
REG32(POR_MPU_M0_CTL_U_RNI_NID260, 0x2035000)
    FIELD(POR_MPU_M0_CTL_U_RNI_NID260, M0_EN, 2, 1)
    FIELD(POR_MPU_M0_CTL_U_RNI_NID260, M0_ACTION, 0, 2)
REG32(POR_MPU_M0_PRBAR0_U_RNI_NID260, 0x2035010)
    FIELD(POR_MPU_M0_PRBAR0_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR0_U_RNI_NID260, REGION0_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR0_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR0_U_RNI_NID260, REGION0_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR0_U_RNI_NID260, REGION0_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR0_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR0_U_RNI_NID260, 0x2035018)
    FIELD(POR_MPU_M0_PRLAR0_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR0_U_RNI_NID260, REGION0_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR0_U_RNI_NID260, REGION0_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR1_U_RNI_NID260, 0x2035020)
    FIELD(POR_MPU_M0_PRBAR1_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR1_U_RNI_NID260, REGION1_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR1_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR1_U_RNI_NID260, REGION1_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR1_U_RNI_NID260, REGION1_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR1_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR1_U_RNI_NID260, 0x2035028)
    FIELD(POR_MPU_M0_PRLAR1_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR1_U_RNI_NID260, REGION1_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR1_U_RNI_NID260, REGION1_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR2_U_RNI_NID260, 0x2035030)
    FIELD(POR_MPU_M0_PRBAR2_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR2_U_RNI_NID260, REGION2_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR2_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR2_U_RNI_NID260, REGION2_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR2_U_RNI_NID260, REGION2_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR2_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR2_U_RNI_NID260, 0x2035038)
    FIELD(POR_MPU_M0_PRLAR2_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR2_U_RNI_NID260, REGION2_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR2_U_RNI_NID260, REGION2_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR3_U_RNI_NID260, 0x2035040)
    FIELD(POR_MPU_M0_PRBAR3_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR3_U_RNI_NID260, REGION3_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR3_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR3_U_RNI_NID260, REGION3_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR3_U_RNI_NID260, REGION3_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR3_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR3_U_RNI_NID260, 0x2035048)
    FIELD(POR_MPU_M0_PRLAR3_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR3_U_RNI_NID260, REGION3_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR3_U_RNI_NID260, REGION3_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR4_U_RNI_NID260, 0x2035050)
    FIELD(POR_MPU_M0_PRBAR4_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR4_U_RNI_NID260, REGION4_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR4_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR4_U_RNI_NID260, REGION4_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR4_U_RNI_NID260, REGION4_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR4_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR4_U_RNI_NID260, 0x2035058)
    FIELD(POR_MPU_M0_PRLAR4_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR4_U_RNI_NID260, REGION4_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR4_U_RNI_NID260, REGION4_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR5_U_RNI_NID260, 0x2035060)
    FIELD(POR_MPU_M0_PRBAR5_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR5_U_RNI_NID260, REGION5_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR5_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR5_U_RNI_NID260, REGION5_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR5_U_RNI_NID260, REGION5_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR5_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR5_U_RNI_NID260, 0x2035068)
    FIELD(POR_MPU_M0_PRLAR5_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR5_U_RNI_NID260, REGION5_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR5_U_RNI_NID260, REGION5_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR6_U_RNI_NID260, 0x2035070)
    FIELD(POR_MPU_M0_PRBAR6_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR6_U_RNI_NID260, REGION6_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR6_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR6_U_RNI_NID260, REGION6_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR6_U_RNI_NID260, REGION6_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR6_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR6_U_RNI_NID260, 0x2035078)
    FIELD(POR_MPU_M0_PRLAR6_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR6_U_RNI_NID260, REGION6_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR6_U_RNI_NID260, REGION6_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR7_U_RNI_NID260, 0x2035080)
    FIELD(POR_MPU_M0_PRBAR7_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR7_U_RNI_NID260, REGION7_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR7_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR7_U_RNI_NID260, REGION7_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR7_U_RNI_NID260, REGION7_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR7_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR7_U_RNI_NID260, 0x2035088)
    FIELD(POR_MPU_M0_PRLAR7_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR7_U_RNI_NID260, REGION7_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR7_U_RNI_NID260, REGION7_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR8_U_RNI_NID260, 0x2035090)
    FIELD(POR_MPU_M0_PRBAR8_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR8_U_RNI_NID260, REGION8_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR8_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR8_U_RNI_NID260, REGION8_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR8_U_RNI_NID260, REGION8_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR8_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR8_U_RNI_NID260, 0x2035098)
    FIELD(POR_MPU_M0_PRLAR8_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR8_U_RNI_NID260, REGION8_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR8_U_RNI_NID260, REGION8_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR9_U_RNI_NID260, 0x20350a0)
    FIELD(POR_MPU_M0_PRBAR9_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR9_U_RNI_NID260, REGION9_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR9_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR9_U_RNI_NID260, REGION9_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR9_U_RNI_NID260, REGION9_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR9_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR9_U_RNI_NID260, 0x20350a8)
    FIELD(POR_MPU_M0_PRLAR9_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR9_U_RNI_NID260, REGION9_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR9_U_RNI_NID260, REGION9_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR10_U_RNI_NID260, 0x20350b0)
    FIELD(POR_MPU_M0_PRBAR10_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR10_U_RNI_NID260, REGION10_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR10_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR10_U_RNI_NID260, REGION10_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR10_U_RNI_NID260, REGION10_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR10_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR10_U_RNI_NID260, 0x20350b8)
    FIELD(POR_MPU_M0_PRLAR10_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR10_U_RNI_NID260, REGION10_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR10_U_RNI_NID260, REGION10_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR11_U_RNI_NID260, 0x20350c0)
    FIELD(POR_MPU_M0_PRBAR11_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR11_U_RNI_NID260, REGION11_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR11_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR11_U_RNI_NID260, REGION11_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR11_U_RNI_NID260, REGION11_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR11_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR11_U_RNI_NID260, 0x20350c8)
    FIELD(POR_MPU_M0_PRLAR11_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR11_U_RNI_NID260, REGION11_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR11_U_RNI_NID260, REGION11_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR12_U_RNI_NID260, 0x20350d0)
    FIELD(POR_MPU_M0_PRBAR12_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR12_U_RNI_NID260, REGION12_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR12_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR12_U_RNI_NID260, REGION12_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR12_U_RNI_NID260, REGION12_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR12_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR12_U_RNI_NID260, 0x20350d8)
    FIELD(POR_MPU_M0_PRLAR12_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR12_U_RNI_NID260, REGION12_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR12_U_RNI_NID260, REGION12_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR13_U_RNI_NID260, 0x20350e0)
    FIELD(POR_MPU_M0_PRBAR13_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR13_U_RNI_NID260, REGION13_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR13_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR13_U_RNI_NID260, REGION13_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR13_U_RNI_NID260, REGION13_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR13_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR13_U_RNI_NID260, 0x20350e8)
    FIELD(POR_MPU_M0_PRLAR13_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR13_U_RNI_NID260, REGION13_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR13_U_RNI_NID260, REGION13_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR14_U_RNI_NID260, 0x20350f0)
    FIELD(POR_MPU_M0_PRBAR14_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR14_U_RNI_NID260, REGION14_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR14_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR14_U_RNI_NID260, REGION14_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR14_U_RNI_NID260, REGION14_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR14_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR14_U_RNI_NID260, 0x20350f8)
    FIELD(POR_MPU_M0_PRLAR14_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR14_U_RNI_NID260, REGION14_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR14_U_RNI_NID260, REGION14_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR15_U_RNI_NID260, 0x2035100)
    FIELD(POR_MPU_M0_PRBAR15_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR15_U_RNI_NID260, REGION15_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR15_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR15_U_RNI_NID260, REGION15_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR15_U_RNI_NID260, REGION15_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR15_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR15_U_RNI_NID260, 0x2035108)
    FIELD(POR_MPU_M0_PRLAR15_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR15_U_RNI_NID260, REGION15_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR15_U_RNI_NID260, REGION15_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR16_U_RNI_NID260, 0x2035110)
    FIELD(POR_MPU_M0_PRBAR16_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR16_U_RNI_NID260, REGION16_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR16_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR16_U_RNI_NID260, REGION16_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR16_U_RNI_NID260, REGION16_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR16_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR16_U_RNI_NID260, 0x2035118)
    FIELD(POR_MPU_M0_PRLAR16_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR16_U_RNI_NID260, REGION16_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR16_U_RNI_NID260, REGION16_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR17_U_RNI_NID260, 0x2035120)
    FIELD(POR_MPU_M0_PRBAR17_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR17_U_RNI_NID260, REGION17_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR17_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR17_U_RNI_NID260, REGION17_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR17_U_RNI_NID260, REGION17_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR17_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR17_U_RNI_NID260, 0x2035128)
    FIELD(POR_MPU_M0_PRLAR17_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR17_U_RNI_NID260, REGION17_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR17_U_RNI_NID260, REGION17_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR18_U_RNI_NID260, 0x2035130)
    FIELD(POR_MPU_M0_PRBAR18_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR18_U_RNI_NID260, REGION18_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR18_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR18_U_RNI_NID260, REGION18_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR18_U_RNI_NID260, REGION18_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR18_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR18_U_RNI_NID260, 0x2035138)
    FIELD(POR_MPU_M0_PRLAR18_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR18_U_RNI_NID260, REGION18_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR18_U_RNI_NID260, REGION18_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR19_U_RNI_NID260, 0x2035140)
    FIELD(POR_MPU_M0_PRBAR19_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR19_U_RNI_NID260, REGION19_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR19_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR19_U_RNI_NID260, REGION19_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR19_U_RNI_NID260, REGION19_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR19_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR19_U_RNI_NID260, 0x2035148)
    FIELD(POR_MPU_M0_PRLAR19_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR19_U_RNI_NID260, REGION19_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR19_U_RNI_NID260, REGION19_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR20_U_RNI_NID260, 0x2035150)
    FIELD(POR_MPU_M0_PRBAR20_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR20_U_RNI_NID260, REGION20_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR20_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR20_U_RNI_NID260, REGION20_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR20_U_RNI_NID260, REGION20_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR20_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR20_U_RNI_NID260, 0x2035158)
    FIELD(POR_MPU_M0_PRLAR20_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR20_U_RNI_NID260, REGION20_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR20_U_RNI_NID260, REGION20_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR21_U_RNI_NID260, 0x2035160)
    FIELD(POR_MPU_M0_PRBAR21_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR21_U_RNI_NID260, REGION21_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR21_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR21_U_RNI_NID260, REGION21_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR21_U_RNI_NID260, REGION21_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR21_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR21_U_RNI_NID260, 0x2035168)
    FIELD(POR_MPU_M0_PRLAR21_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR21_U_RNI_NID260, REGION21_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR21_U_RNI_NID260, REGION21_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR22_U_RNI_NID260, 0x2035170)
    FIELD(POR_MPU_M0_PRBAR22_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR22_U_RNI_NID260, REGION22_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR22_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR22_U_RNI_NID260, REGION22_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR22_U_RNI_NID260, REGION22_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR22_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR22_U_RNI_NID260, 0x2035178)
    FIELD(POR_MPU_M0_PRLAR22_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR22_U_RNI_NID260, REGION22_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR22_U_RNI_NID260, REGION22_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR23_U_RNI_NID260, 0x2035180)
    FIELD(POR_MPU_M0_PRBAR23_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR23_U_RNI_NID260, REGION23_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR23_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR23_U_RNI_NID260, REGION23_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR23_U_RNI_NID260, REGION23_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR23_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR23_U_RNI_NID260, 0x2035188)
    FIELD(POR_MPU_M0_PRLAR23_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR23_U_RNI_NID260, REGION23_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR23_U_RNI_NID260, REGION23_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR24_U_RNI_NID260, 0x2035190)
    FIELD(POR_MPU_M0_PRBAR24_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR24_U_RNI_NID260, REGION24_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR24_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR24_U_RNI_NID260, REGION24_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR24_U_RNI_NID260, REGION24_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR24_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR24_U_RNI_NID260, 0x2035198)
    FIELD(POR_MPU_M0_PRLAR24_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR24_U_RNI_NID260, REGION24_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR24_U_RNI_NID260, REGION24_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR25_U_RNI_NID260, 0x20351a0)
    FIELD(POR_MPU_M0_PRBAR25_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR25_U_RNI_NID260, REGION25_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR25_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR25_U_RNI_NID260, REGION25_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR25_U_RNI_NID260, REGION25_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR25_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR25_U_RNI_NID260, 0x20351a8)
    FIELD(POR_MPU_M0_PRLAR25_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR25_U_RNI_NID260, REGION25_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR25_U_RNI_NID260, REGION25_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR26_U_RNI_NID260, 0x20351b0)
    FIELD(POR_MPU_M0_PRBAR26_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR26_U_RNI_NID260, REGION26_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR26_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR26_U_RNI_NID260, REGION26_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR26_U_RNI_NID260, REGION26_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR26_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR26_U_RNI_NID260, 0x20351b8)
    FIELD(POR_MPU_M0_PRLAR26_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR26_U_RNI_NID260, REGION26_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR26_U_RNI_NID260, REGION26_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR27_U_RNI_NID260, 0x20351c0)
    FIELD(POR_MPU_M0_PRBAR27_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR27_U_RNI_NID260, REGION27_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR27_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR27_U_RNI_NID260, REGION27_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR27_U_RNI_NID260, REGION27_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR27_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR27_U_RNI_NID260, 0x20351c8)
    FIELD(POR_MPU_M0_PRLAR27_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR27_U_RNI_NID260, REGION27_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR27_U_RNI_NID260, REGION27_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR28_U_RNI_NID260, 0x20351d0)
    FIELD(POR_MPU_M0_PRBAR28_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR28_U_RNI_NID260, REGION28_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR28_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR28_U_RNI_NID260, REGION28_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR28_U_RNI_NID260, REGION28_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR28_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR28_U_RNI_NID260, 0x20351d8)
    FIELD(POR_MPU_M0_PRLAR28_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR28_U_RNI_NID260, REGION28_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR28_U_RNI_NID260, REGION28_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR29_U_RNI_NID260, 0x20351e0)
    FIELD(POR_MPU_M0_PRBAR29_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR29_U_RNI_NID260, REGION29_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR29_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR29_U_RNI_NID260, REGION29_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR29_U_RNI_NID260, REGION29_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR29_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR29_U_RNI_NID260, 0x20351e8)
    FIELD(POR_MPU_M0_PRLAR29_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR29_U_RNI_NID260, REGION29_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR29_U_RNI_NID260, REGION29_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR30_U_RNI_NID260, 0x20351f0)
    FIELD(POR_MPU_M0_PRBAR30_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR30_U_RNI_NID260, REGION30_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR30_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR30_U_RNI_NID260, REGION30_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR30_U_RNI_NID260, REGION30_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR30_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR30_U_RNI_NID260, 0x20351f8)
    FIELD(POR_MPU_M0_PRLAR30_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR30_U_RNI_NID260, REGION30_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR30_U_RNI_NID260, REGION30_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR31_U_RNI_NID260, 0x2035200)
    FIELD(POR_MPU_M0_PRBAR31_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR31_U_RNI_NID260, REGION31_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR31_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR31_U_RNI_NID260, REGION31_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR31_U_RNI_NID260, REGION31_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR31_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR31_U_RNI_NID260, 0x2035208)
    FIELD(POR_MPU_M0_PRLAR31_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR31_U_RNI_NID260, REGION31_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR31_U_RNI_NID260, REGION31_EN, 0, 1)
REG32(POR_MPU_M1_CTL_U_RNI_NID260, 0x2035400)
    FIELD(POR_MPU_M1_CTL_U_RNI_NID260, M1_EN, 2, 1)
    FIELD(POR_MPU_M1_CTL_U_RNI_NID260, M1_ACTION, 0, 2)
REG32(POR_MPU_M1_PRBAR0_U_RNI_NID260, 0x2035410)
    FIELD(POR_MPU_M1_PRBAR0_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR0_U_RNI_NID260, REGION0_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR0_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR0_U_RNI_NID260, REGION0_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR0_U_RNI_NID260, REGION0_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR0_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR0_U_RNI_NID260, 0x2035418)
    FIELD(POR_MPU_M1_PRLAR0_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR0_U_RNI_NID260, REGION0_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR0_U_RNI_NID260, REGION0_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR1_U_RNI_NID260, 0x2035420)
    FIELD(POR_MPU_M1_PRBAR1_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR1_U_RNI_NID260, REGION1_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR1_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR1_U_RNI_NID260, REGION1_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR1_U_RNI_NID260, REGION1_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR1_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR1_U_RNI_NID260, 0x2035428)
    FIELD(POR_MPU_M1_PRLAR1_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR1_U_RNI_NID260, REGION1_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR1_U_RNI_NID260, REGION1_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR2_U_RNI_NID260, 0x2035430)
    FIELD(POR_MPU_M1_PRBAR2_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR2_U_RNI_NID260, REGION2_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR2_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR2_U_RNI_NID260, REGION2_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR2_U_RNI_NID260, REGION2_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR2_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR2_U_RNI_NID260, 0x2035438)
    FIELD(POR_MPU_M1_PRLAR2_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR2_U_RNI_NID260, REGION2_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR2_U_RNI_NID260, REGION2_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR3_U_RNI_NID260, 0x2035440)
    FIELD(POR_MPU_M1_PRBAR3_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR3_U_RNI_NID260, REGION3_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR3_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR3_U_RNI_NID260, REGION3_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR3_U_RNI_NID260, REGION3_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR3_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR3_U_RNI_NID260, 0x2035448)
    FIELD(POR_MPU_M1_PRLAR3_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR3_U_RNI_NID260, REGION3_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR3_U_RNI_NID260, REGION3_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR4_U_RNI_NID260, 0x2035450)
    FIELD(POR_MPU_M1_PRBAR4_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR4_U_RNI_NID260, REGION4_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR4_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR4_U_RNI_NID260, REGION4_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR4_U_RNI_NID260, REGION4_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR4_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR4_U_RNI_NID260, 0x2035458)
    FIELD(POR_MPU_M1_PRLAR4_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR4_U_RNI_NID260, REGION4_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR4_U_RNI_NID260, REGION4_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR5_U_RNI_NID260, 0x2035460)
    FIELD(POR_MPU_M1_PRBAR5_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR5_U_RNI_NID260, REGION5_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR5_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR5_U_RNI_NID260, REGION5_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR5_U_RNI_NID260, REGION5_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR5_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR5_U_RNI_NID260, 0x2035468)
    FIELD(POR_MPU_M1_PRLAR5_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR5_U_RNI_NID260, REGION5_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR5_U_RNI_NID260, REGION5_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR6_U_RNI_NID260, 0x2035470)
    FIELD(POR_MPU_M1_PRBAR6_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR6_U_RNI_NID260, REGION6_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR6_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR6_U_RNI_NID260, REGION6_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR6_U_RNI_NID260, REGION6_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR6_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR6_U_RNI_NID260, 0x2035478)
    FIELD(POR_MPU_M1_PRLAR6_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR6_U_RNI_NID260, REGION6_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR6_U_RNI_NID260, REGION6_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR7_U_RNI_NID260, 0x2035480)
    FIELD(POR_MPU_M1_PRBAR7_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR7_U_RNI_NID260, REGION7_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR7_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR7_U_RNI_NID260, REGION7_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR7_U_RNI_NID260, REGION7_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR7_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR7_U_RNI_NID260, 0x2035488)
    FIELD(POR_MPU_M1_PRLAR7_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR7_U_RNI_NID260, REGION7_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR7_U_RNI_NID260, REGION7_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR8_U_RNI_NID260, 0x2035490)
    FIELD(POR_MPU_M1_PRBAR8_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR8_U_RNI_NID260, REGION8_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR8_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR8_U_RNI_NID260, REGION8_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR8_U_RNI_NID260, REGION8_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR8_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR8_U_RNI_NID260, 0x2035498)
    FIELD(POR_MPU_M1_PRLAR8_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR8_U_RNI_NID260, REGION8_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR8_U_RNI_NID260, REGION8_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR9_U_RNI_NID260, 0x20354a0)
    FIELD(POR_MPU_M1_PRBAR9_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR9_U_RNI_NID260, REGION9_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR9_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR9_U_RNI_NID260, REGION9_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR9_U_RNI_NID260, REGION9_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR9_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR9_U_RNI_NID260, 0x20354a8)
    FIELD(POR_MPU_M1_PRLAR9_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR9_U_RNI_NID260, REGION9_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR9_U_RNI_NID260, REGION9_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR10_U_RNI_NID260, 0x20354b0)
    FIELD(POR_MPU_M1_PRBAR10_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR10_U_RNI_NID260, REGION10_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR10_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR10_U_RNI_NID260, REGION10_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR10_U_RNI_NID260, REGION10_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR10_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR10_U_RNI_NID260, 0x20354b8)
    FIELD(POR_MPU_M1_PRLAR10_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR10_U_RNI_NID260, REGION10_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR10_U_RNI_NID260, REGION10_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR11_U_RNI_NID260, 0x20354c0)
    FIELD(POR_MPU_M1_PRBAR11_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR11_U_RNI_NID260, REGION11_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR11_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR11_U_RNI_NID260, REGION11_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR11_U_RNI_NID260, REGION11_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR11_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR11_U_RNI_NID260, 0x20354c8)
    FIELD(POR_MPU_M1_PRLAR11_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR11_U_RNI_NID260, REGION11_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR11_U_RNI_NID260, REGION11_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR12_U_RNI_NID260, 0x20354d0)
    FIELD(POR_MPU_M1_PRBAR12_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR12_U_RNI_NID260, REGION12_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR12_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR12_U_RNI_NID260, REGION12_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR12_U_RNI_NID260, REGION12_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR12_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR12_U_RNI_NID260, 0x20354d8)
    FIELD(POR_MPU_M1_PRLAR12_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR12_U_RNI_NID260, REGION12_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR12_U_RNI_NID260, REGION12_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR13_U_RNI_NID260, 0x20354e0)
    FIELD(POR_MPU_M1_PRBAR13_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR13_U_RNI_NID260, REGION13_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR13_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR13_U_RNI_NID260, REGION13_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR13_U_RNI_NID260, REGION13_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR13_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR13_U_RNI_NID260, 0x20354e8)
    FIELD(POR_MPU_M1_PRLAR13_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR13_U_RNI_NID260, REGION13_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR13_U_RNI_NID260, REGION13_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR14_U_RNI_NID260, 0x20354f0)
    FIELD(POR_MPU_M1_PRBAR14_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR14_U_RNI_NID260, REGION14_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR14_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR14_U_RNI_NID260, REGION14_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR14_U_RNI_NID260, REGION14_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR14_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR14_U_RNI_NID260, 0x20354f8)
    FIELD(POR_MPU_M1_PRLAR14_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR14_U_RNI_NID260, REGION14_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR14_U_RNI_NID260, REGION14_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR15_U_RNI_NID260, 0x2035500)
    FIELD(POR_MPU_M1_PRBAR15_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR15_U_RNI_NID260, REGION15_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR15_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR15_U_RNI_NID260, REGION15_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR15_U_RNI_NID260, REGION15_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR15_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR15_U_RNI_NID260, 0x2035508)
    FIELD(POR_MPU_M1_PRLAR15_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR15_U_RNI_NID260, REGION15_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR15_U_RNI_NID260, REGION15_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR16_U_RNI_NID260, 0x2035510)
    FIELD(POR_MPU_M1_PRBAR16_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR16_U_RNI_NID260, REGION16_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR16_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR16_U_RNI_NID260, REGION16_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR16_U_RNI_NID260, REGION16_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR16_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR16_U_RNI_NID260, 0x2035518)
    FIELD(POR_MPU_M1_PRLAR16_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR16_U_RNI_NID260, REGION16_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR16_U_RNI_NID260, REGION16_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR17_U_RNI_NID260, 0x2035520)
    FIELD(POR_MPU_M1_PRBAR17_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR17_U_RNI_NID260, REGION17_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR17_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR17_U_RNI_NID260, REGION17_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR17_U_RNI_NID260, REGION17_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR17_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR17_U_RNI_NID260, 0x2035528)
    FIELD(POR_MPU_M1_PRLAR17_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR17_U_RNI_NID260, REGION17_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR17_U_RNI_NID260, REGION17_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR18_U_RNI_NID260, 0x2035530)
    FIELD(POR_MPU_M1_PRBAR18_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR18_U_RNI_NID260, REGION18_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR18_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR18_U_RNI_NID260, REGION18_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR18_U_RNI_NID260, REGION18_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR18_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR18_U_RNI_NID260, 0x2035538)
    FIELD(POR_MPU_M1_PRLAR18_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR18_U_RNI_NID260, REGION18_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR18_U_RNI_NID260, REGION18_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR19_U_RNI_NID260, 0x2035540)
    FIELD(POR_MPU_M1_PRBAR19_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR19_U_RNI_NID260, REGION19_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR19_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR19_U_RNI_NID260, REGION19_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR19_U_RNI_NID260, REGION19_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR19_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR19_U_RNI_NID260, 0x2035548)
    FIELD(POR_MPU_M1_PRLAR19_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR19_U_RNI_NID260, REGION19_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR19_U_RNI_NID260, REGION19_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR20_U_RNI_NID260, 0x2035550)
    FIELD(POR_MPU_M1_PRBAR20_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR20_U_RNI_NID260, REGION20_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR20_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR20_U_RNI_NID260, REGION20_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR20_U_RNI_NID260, REGION20_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR20_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR20_U_RNI_NID260, 0x2035558)
    FIELD(POR_MPU_M1_PRLAR20_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR20_U_RNI_NID260, REGION20_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR20_U_RNI_NID260, REGION20_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR21_U_RNI_NID260, 0x2035560)
    FIELD(POR_MPU_M1_PRBAR21_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR21_U_RNI_NID260, REGION21_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR21_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR21_U_RNI_NID260, REGION21_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR21_U_RNI_NID260, REGION21_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR21_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR21_U_RNI_NID260, 0x2035568)
    FIELD(POR_MPU_M1_PRLAR21_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR21_U_RNI_NID260, REGION21_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR21_U_RNI_NID260, REGION21_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR22_U_RNI_NID260, 0x2035570)
    FIELD(POR_MPU_M1_PRBAR22_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR22_U_RNI_NID260, REGION22_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR22_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR22_U_RNI_NID260, REGION22_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR22_U_RNI_NID260, REGION22_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR22_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR22_U_RNI_NID260, 0x2035578)
    FIELD(POR_MPU_M1_PRLAR22_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR22_U_RNI_NID260, REGION22_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR22_U_RNI_NID260, REGION22_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR23_U_RNI_NID260, 0x2035580)
    FIELD(POR_MPU_M1_PRBAR23_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR23_U_RNI_NID260, REGION23_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR23_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR23_U_RNI_NID260, REGION23_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR23_U_RNI_NID260, REGION23_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR23_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR23_U_RNI_NID260, 0x2035588)
    FIELD(POR_MPU_M1_PRLAR23_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR23_U_RNI_NID260, REGION23_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR23_U_RNI_NID260, REGION23_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR24_U_RNI_NID260, 0x2035590)
    FIELD(POR_MPU_M1_PRBAR24_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR24_U_RNI_NID260, REGION24_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR24_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR24_U_RNI_NID260, REGION24_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR24_U_RNI_NID260, REGION24_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR24_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR24_U_RNI_NID260, 0x2035598)
    FIELD(POR_MPU_M1_PRLAR24_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR24_U_RNI_NID260, REGION24_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR24_U_RNI_NID260, REGION24_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR25_U_RNI_NID260, 0x20355a0)
    FIELD(POR_MPU_M1_PRBAR25_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR25_U_RNI_NID260, REGION25_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR25_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR25_U_RNI_NID260, REGION25_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR25_U_RNI_NID260, REGION25_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR25_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR25_U_RNI_NID260, 0x20355a8)
    FIELD(POR_MPU_M1_PRLAR25_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR25_U_RNI_NID260, REGION25_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR25_U_RNI_NID260, REGION25_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR26_U_RNI_NID260, 0x20355b0)
    FIELD(POR_MPU_M1_PRBAR26_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR26_U_RNI_NID260, REGION26_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR26_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR26_U_RNI_NID260, REGION26_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR26_U_RNI_NID260, REGION26_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR26_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR26_U_RNI_NID260, 0x20355b8)
    FIELD(POR_MPU_M1_PRLAR26_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR26_U_RNI_NID260, REGION26_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR26_U_RNI_NID260, REGION26_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR27_U_RNI_NID260, 0x20355c0)
    FIELD(POR_MPU_M1_PRBAR27_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR27_U_RNI_NID260, REGION27_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR27_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR27_U_RNI_NID260, REGION27_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR27_U_RNI_NID260, REGION27_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR27_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR27_U_RNI_NID260, 0x20355c8)
    FIELD(POR_MPU_M1_PRLAR27_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR27_U_RNI_NID260, REGION27_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR27_U_RNI_NID260, REGION27_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR28_U_RNI_NID260, 0x20355d0)
    FIELD(POR_MPU_M1_PRBAR28_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR28_U_RNI_NID260, REGION28_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR28_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR28_U_RNI_NID260, REGION28_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR28_U_RNI_NID260, REGION28_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR28_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR28_U_RNI_NID260, 0x20355d8)
    FIELD(POR_MPU_M1_PRLAR28_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR28_U_RNI_NID260, REGION28_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR28_U_RNI_NID260, REGION28_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR29_U_RNI_NID260, 0x20355e0)
    FIELD(POR_MPU_M1_PRBAR29_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR29_U_RNI_NID260, REGION29_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR29_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR29_U_RNI_NID260, REGION29_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR29_U_RNI_NID260, REGION29_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR29_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR29_U_RNI_NID260, 0x20355e8)
    FIELD(POR_MPU_M1_PRLAR29_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR29_U_RNI_NID260, REGION29_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR29_U_RNI_NID260, REGION29_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR30_U_RNI_NID260, 0x20355f0)
    FIELD(POR_MPU_M1_PRBAR30_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR30_U_RNI_NID260, REGION30_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR30_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR30_U_RNI_NID260, REGION30_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR30_U_RNI_NID260, REGION30_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR30_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR30_U_RNI_NID260, 0x20355f8)
    FIELD(POR_MPU_M1_PRLAR30_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR30_U_RNI_NID260, REGION30_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR30_U_RNI_NID260, REGION30_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR31_U_RNI_NID260, 0x2035600)
    FIELD(POR_MPU_M1_PRBAR31_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR31_U_RNI_NID260, REGION31_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR31_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR31_U_RNI_NID260, REGION31_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR31_U_RNI_NID260, REGION31_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR31_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR31_U_RNI_NID260, 0x2035608)
    FIELD(POR_MPU_M1_PRLAR31_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR31_U_RNI_NID260, REGION31_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR31_U_RNI_NID260, REGION31_EN, 0, 1)
REG32(POR_MPU_M2_CTL_U_RNI_NID260, 0x2035800)
    FIELD(POR_MPU_M2_CTL_U_RNI_NID260, M2_EN, 2, 1)
    FIELD(POR_MPU_M2_CTL_U_RNI_NID260, M2_ACTION, 0, 2)
REG32(POR_MPU_M2_PRBAR0_U_RNI_NID260, 0x2035810)
    FIELD(POR_MPU_M2_PRBAR0_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR0_U_RNI_NID260, REGION0_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR0_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR0_U_RNI_NID260, REGION0_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR0_U_RNI_NID260, REGION0_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR0_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR0_U_RNI_NID260, 0x2035818)
    FIELD(POR_MPU_M2_PRLAR0_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR0_U_RNI_NID260, REGION0_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR0_U_RNI_NID260, REGION0_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR1_U_RNI_NID260, 0x2035820)
    FIELD(POR_MPU_M2_PRBAR1_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR1_U_RNI_NID260, REGION1_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR1_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR1_U_RNI_NID260, REGION1_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR1_U_RNI_NID260, REGION1_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR1_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR1_U_RNI_NID260, 0x2035828)
    FIELD(POR_MPU_M2_PRLAR1_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR1_U_RNI_NID260, REGION1_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR1_U_RNI_NID260, REGION1_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR2_U_RNI_NID260, 0x2035830)
    FIELD(POR_MPU_M2_PRBAR2_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR2_U_RNI_NID260, REGION2_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR2_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR2_U_RNI_NID260, REGION2_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR2_U_RNI_NID260, REGION2_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR2_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR2_U_RNI_NID260, 0x2035838)
    FIELD(POR_MPU_M2_PRLAR2_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR2_U_RNI_NID260, REGION2_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR2_U_RNI_NID260, REGION2_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR3_U_RNI_NID260, 0x2035840)
    FIELD(POR_MPU_M2_PRBAR3_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR3_U_RNI_NID260, REGION3_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR3_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR3_U_RNI_NID260, REGION3_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR3_U_RNI_NID260, REGION3_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR3_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR3_U_RNI_NID260, 0x2035848)
    FIELD(POR_MPU_M2_PRLAR3_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR3_U_RNI_NID260, REGION3_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR3_U_RNI_NID260, REGION3_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR4_U_RNI_NID260, 0x2035850)
    FIELD(POR_MPU_M2_PRBAR4_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR4_U_RNI_NID260, REGION4_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR4_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR4_U_RNI_NID260, REGION4_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR4_U_RNI_NID260, REGION4_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR4_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR4_U_RNI_NID260, 0x2035858)
    FIELD(POR_MPU_M2_PRLAR4_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR4_U_RNI_NID260, REGION4_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR4_U_RNI_NID260, REGION4_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR5_U_RNI_NID260, 0x2035860)
    FIELD(POR_MPU_M2_PRBAR5_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR5_U_RNI_NID260, REGION5_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR5_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR5_U_RNI_NID260, REGION5_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR5_U_RNI_NID260, REGION5_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR5_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR5_U_RNI_NID260, 0x2035868)
    FIELD(POR_MPU_M2_PRLAR5_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR5_U_RNI_NID260, REGION5_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR5_U_RNI_NID260, REGION5_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR6_U_RNI_NID260, 0x2035870)
    FIELD(POR_MPU_M2_PRBAR6_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR6_U_RNI_NID260, REGION6_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR6_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR6_U_RNI_NID260, REGION6_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR6_U_RNI_NID260, REGION6_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR6_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR6_U_RNI_NID260, 0x2035878)
    FIELD(POR_MPU_M2_PRLAR6_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR6_U_RNI_NID260, REGION6_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR6_U_RNI_NID260, REGION6_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR7_U_RNI_NID260, 0x2035880)
    FIELD(POR_MPU_M2_PRBAR7_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR7_U_RNI_NID260, REGION7_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR7_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR7_U_RNI_NID260, REGION7_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR7_U_RNI_NID260, REGION7_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR7_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR7_U_RNI_NID260, 0x2035888)
    FIELD(POR_MPU_M2_PRLAR7_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR7_U_RNI_NID260, REGION7_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR7_U_RNI_NID260, REGION7_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR8_U_RNI_NID260, 0x2035890)
    FIELD(POR_MPU_M2_PRBAR8_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR8_U_RNI_NID260, REGION8_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR8_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR8_U_RNI_NID260, REGION8_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR8_U_RNI_NID260, REGION8_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR8_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR8_U_RNI_NID260, 0x2035898)
    FIELD(POR_MPU_M2_PRLAR8_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR8_U_RNI_NID260, REGION8_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR8_U_RNI_NID260, REGION8_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR9_U_RNI_NID260, 0x20358a0)
    FIELD(POR_MPU_M2_PRBAR9_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR9_U_RNI_NID260, REGION9_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR9_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR9_U_RNI_NID260, REGION9_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR9_U_RNI_NID260, REGION9_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR9_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR9_U_RNI_NID260, 0x20358a8)
    FIELD(POR_MPU_M2_PRLAR9_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR9_U_RNI_NID260, REGION9_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR9_U_RNI_NID260, REGION9_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR10_U_RNI_NID260, 0x20358b0)
    FIELD(POR_MPU_M2_PRBAR10_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR10_U_RNI_NID260, REGION10_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR10_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR10_U_RNI_NID260, REGION10_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR10_U_RNI_NID260, REGION10_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR10_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR10_U_RNI_NID260, 0x20358b8)
    FIELD(POR_MPU_M2_PRLAR10_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR10_U_RNI_NID260, REGION10_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR10_U_RNI_NID260, REGION10_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR11_U_RNI_NID260, 0x20358c0)
    FIELD(POR_MPU_M2_PRBAR11_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR11_U_RNI_NID260, REGION11_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR11_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR11_U_RNI_NID260, REGION11_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR11_U_RNI_NID260, REGION11_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR11_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR11_U_RNI_NID260, 0x20358c8)
    FIELD(POR_MPU_M2_PRLAR11_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR11_U_RNI_NID260, REGION11_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR11_U_RNI_NID260, REGION11_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR12_U_RNI_NID260, 0x20358d0)
    FIELD(POR_MPU_M2_PRBAR12_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR12_U_RNI_NID260, REGION12_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR12_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR12_U_RNI_NID260, REGION12_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR12_U_RNI_NID260, REGION12_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR12_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR12_U_RNI_NID260, 0x20358d8)
    FIELD(POR_MPU_M2_PRLAR12_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR12_U_RNI_NID260, REGION12_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR12_U_RNI_NID260, REGION12_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR13_U_RNI_NID260, 0x20358e0)
    FIELD(POR_MPU_M2_PRBAR13_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR13_U_RNI_NID260, REGION13_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR13_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR13_U_RNI_NID260, REGION13_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR13_U_RNI_NID260, REGION13_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR13_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR13_U_RNI_NID260, 0x20358e8)
    FIELD(POR_MPU_M2_PRLAR13_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR13_U_RNI_NID260, REGION13_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR13_U_RNI_NID260, REGION13_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR14_U_RNI_NID260, 0x20358f0)
    FIELD(POR_MPU_M2_PRBAR14_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR14_U_RNI_NID260, REGION14_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR14_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR14_U_RNI_NID260, REGION14_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR14_U_RNI_NID260, REGION14_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR14_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR14_U_RNI_NID260, 0x20358f8)
    FIELD(POR_MPU_M2_PRLAR14_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR14_U_RNI_NID260, REGION14_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR14_U_RNI_NID260, REGION14_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR15_U_RNI_NID260, 0x2035900)
    FIELD(POR_MPU_M2_PRBAR15_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR15_U_RNI_NID260, REGION15_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR15_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR15_U_RNI_NID260, REGION15_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR15_U_RNI_NID260, REGION15_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR15_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR15_U_RNI_NID260, 0x2035908)
    FIELD(POR_MPU_M2_PRLAR15_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR15_U_RNI_NID260, REGION15_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR15_U_RNI_NID260, REGION15_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR16_U_RNI_NID260, 0x2035910)
    FIELD(POR_MPU_M2_PRBAR16_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR16_U_RNI_NID260, REGION16_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR16_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR16_U_RNI_NID260, REGION16_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR16_U_RNI_NID260, REGION16_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR16_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR16_U_RNI_NID260, 0x2035918)
    FIELD(POR_MPU_M2_PRLAR16_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR16_U_RNI_NID260, REGION16_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR16_U_RNI_NID260, REGION16_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR17_U_RNI_NID260, 0x2035920)
    FIELD(POR_MPU_M2_PRBAR17_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR17_U_RNI_NID260, REGION17_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR17_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR17_U_RNI_NID260, REGION17_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR17_U_RNI_NID260, REGION17_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR17_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR17_U_RNI_NID260, 0x2035928)
    FIELD(POR_MPU_M2_PRLAR17_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR17_U_RNI_NID260, REGION17_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR17_U_RNI_NID260, REGION17_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR18_U_RNI_NID260, 0x2035930)
    FIELD(POR_MPU_M2_PRBAR18_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR18_U_RNI_NID260, REGION18_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR18_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR18_U_RNI_NID260, REGION18_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR18_U_RNI_NID260, REGION18_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR18_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR18_U_RNI_NID260, 0x2035938)
    FIELD(POR_MPU_M2_PRLAR18_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR18_U_RNI_NID260, REGION18_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR18_U_RNI_NID260, REGION18_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR19_U_RNI_NID260, 0x2035940)
    FIELD(POR_MPU_M2_PRBAR19_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR19_U_RNI_NID260, REGION19_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR19_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR19_U_RNI_NID260, REGION19_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR19_U_RNI_NID260, REGION19_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR19_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR19_U_RNI_NID260, 0x2035948)
    FIELD(POR_MPU_M2_PRLAR19_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR19_U_RNI_NID260, REGION19_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR19_U_RNI_NID260, REGION19_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR20_U_RNI_NID260, 0x2035950)
    FIELD(POR_MPU_M2_PRBAR20_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR20_U_RNI_NID260, REGION20_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR20_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR20_U_RNI_NID260, REGION20_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR20_U_RNI_NID260, REGION20_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR20_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR20_U_RNI_NID260, 0x2035958)
    FIELD(POR_MPU_M2_PRLAR20_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR20_U_RNI_NID260, REGION20_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR20_U_RNI_NID260, REGION20_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR21_U_RNI_NID260, 0x2035960)
    FIELD(POR_MPU_M2_PRBAR21_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR21_U_RNI_NID260, REGION21_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR21_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR21_U_RNI_NID260, REGION21_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR21_U_RNI_NID260, REGION21_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR21_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR21_U_RNI_NID260, 0x2035968)
    FIELD(POR_MPU_M2_PRLAR21_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR21_U_RNI_NID260, REGION21_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR21_U_RNI_NID260, REGION21_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR22_U_RNI_NID260, 0x2035970)
    FIELD(POR_MPU_M2_PRBAR22_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR22_U_RNI_NID260, REGION22_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR22_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR22_U_RNI_NID260, REGION22_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR22_U_RNI_NID260, REGION22_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR22_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR22_U_RNI_NID260, 0x2035978)
    FIELD(POR_MPU_M2_PRLAR22_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR22_U_RNI_NID260, REGION22_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR22_U_RNI_NID260, REGION22_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR23_U_RNI_NID260, 0x2035980)
    FIELD(POR_MPU_M2_PRBAR23_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR23_U_RNI_NID260, REGION23_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR23_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR23_U_RNI_NID260, REGION23_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR23_U_RNI_NID260, REGION23_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR23_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR23_U_RNI_NID260, 0x2035988)
    FIELD(POR_MPU_M2_PRLAR23_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR23_U_RNI_NID260, REGION23_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR23_U_RNI_NID260, REGION23_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR24_U_RNI_NID260, 0x2035990)
    FIELD(POR_MPU_M2_PRBAR24_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR24_U_RNI_NID260, REGION24_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR24_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR24_U_RNI_NID260, REGION24_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR24_U_RNI_NID260, REGION24_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR24_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR24_U_RNI_NID260, 0x2035998)
    FIELD(POR_MPU_M2_PRLAR24_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR24_U_RNI_NID260, REGION24_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR24_U_RNI_NID260, REGION24_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR25_U_RNI_NID260, 0x20359a0)
    FIELD(POR_MPU_M2_PRBAR25_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR25_U_RNI_NID260, REGION25_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR25_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR25_U_RNI_NID260, REGION25_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR25_U_RNI_NID260, REGION25_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR25_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR25_U_RNI_NID260, 0x20359a8)
    FIELD(POR_MPU_M2_PRLAR25_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR25_U_RNI_NID260, REGION25_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR25_U_RNI_NID260, REGION25_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR26_U_RNI_NID260, 0x20359b0)
    FIELD(POR_MPU_M2_PRBAR26_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR26_U_RNI_NID260, REGION26_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR26_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR26_U_RNI_NID260, REGION26_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR26_U_RNI_NID260, REGION26_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR26_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR26_U_RNI_NID260, 0x20359b8)
    FIELD(POR_MPU_M2_PRLAR26_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR26_U_RNI_NID260, REGION26_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR26_U_RNI_NID260, REGION26_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR27_U_RNI_NID260, 0x20359c0)
    FIELD(POR_MPU_M2_PRBAR27_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR27_U_RNI_NID260, REGION27_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR27_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR27_U_RNI_NID260, REGION27_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR27_U_RNI_NID260, REGION27_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR27_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR27_U_RNI_NID260, 0x20359c8)
    FIELD(POR_MPU_M2_PRLAR27_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR27_U_RNI_NID260, REGION27_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR27_U_RNI_NID260, REGION27_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR28_U_RNI_NID260, 0x20359d0)
    FIELD(POR_MPU_M2_PRBAR28_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR28_U_RNI_NID260, REGION28_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR28_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR28_U_RNI_NID260, REGION28_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR28_U_RNI_NID260, REGION28_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR28_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR28_U_RNI_NID260, 0x20359d8)
    FIELD(POR_MPU_M2_PRLAR28_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR28_U_RNI_NID260, REGION28_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR28_U_RNI_NID260, REGION28_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR29_U_RNI_NID260, 0x20359e0)
    FIELD(POR_MPU_M2_PRBAR29_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR29_U_RNI_NID260, REGION29_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR29_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR29_U_RNI_NID260, REGION29_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR29_U_RNI_NID260, REGION29_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR29_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR29_U_RNI_NID260, 0x20359e8)
    FIELD(POR_MPU_M2_PRLAR29_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR29_U_RNI_NID260, REGION29_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR29_U_RNI_NID260, REGION29_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR30_U_RNI_NID260, 0x20359f0)
    FIELD(POR_MPU_M2_PRBAR30_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR30_U_RNI_NID260, REGION30_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR30_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR30_U_RNI_NID260, REGION30_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR30_U_RNI_NID260, REGION30_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR30_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR30_U_RNI_NID260, 0x20359f8)
    FIELD(POR_MPU_M2_PRLAR30_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR30_U_RNI_NID260, REGION30_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR30_U_RNI_NID260, REGION30_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR31_U_RNI_NID260, 0x2035a00)
    FIELD(POR_MPU_M2_PRBAR31_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR31_U_RNI_NID260, REGION31_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR31_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR31_U_RNI_NID260, REGION31_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR31_U_RNI_NID260, REGION31_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR31_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR31_U_RNI_NID260, 0x2035a08)
    FIELD(POR_MPU_M2_PRLAR31_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR31_U_RNI_NID260, REGION31_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR31_U_RNI_NID260, REGION31_EN, 0, 1)
REG32(POR_MPU_M3_CTL_U_RNI_NID260, 0x2035c00)
    FIELD(POR_MPU_M3_CTL_U_RNI_NID260, M3_EN, 2, 1)
    FIELD(POR_MPU_M3_CTL_U_RNI_NID260, M3_ACTION, 0, 2)
REG32(POR_MPU_M3_PRBAR0_U_RNI_NID260, 0x2035c10)
    FIELD(POR_MPU_M3_PRBAR0_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR0_U_RNI_NID260, REGION0_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR0_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR0_U_RNI_NID260, REGION0_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR0_U_RNI_NID260, REGION0_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR0_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR0_U_RNI_NID260, 0x2035c18)
    FIELD(POR_MPU_M3_PRLAR0_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR0_U_RNI_NID260, REGION0_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR0_U_RNI_NID260, REGION0_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR1_U_RNI_NID260, 0x2035c20)
    FIELD(POR_MPU_M3_PRBAR1_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR1_U_RNI_NID260, REGION1_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR1_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR1_U_RNI_NID260, REGION1_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR1_U_RNI_NID260, REGION1_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR1_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR1_U_RNI_NID260, 0x2035c28)
    FIELD(POR_MPU_M3_PRLAR1_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR1_U_RNI_NID260, REGION1_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR1_U_RNI_NID260, REGION1_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR2_U_RNI_NID260, 0x2035c30)
    FIELD(POR_MPU_M3_PRBAR2_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR2_U_RNI_NID260, REGION2_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR2_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR2_U_RNI_NID260, REGION2_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR2_U_RNI_NID260, REGION2_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR2_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR2_U_RNI_NID260, 0x2035c38)
    FIELD(POR_MPU_M3_PRLAR2_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR2_U_RNI_NID260, REGION2_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR2_U_RNI_NID260, REGION2_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR3_U_RNI_NID260, 0x2035c40)
    FIELD(POR_MPU_M3_PRBAR3_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR3_U_RNI_NID260, REGION3_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR3_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR3_U_RNI_NID260, REGION3_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR3_U_RNI_NID260, REGION3_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR3_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR3_U_RNI_NID260, 0x2035c48)
    FIELD(POR_MPU_M3_PRLAR3_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR3_U_RNI_NID260, REGION3_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR3_U_RNI_NID260, REGION3_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR4_U_RNI_NID260, 0x2035c50)
    FIELD(POR_MPU_M3_PRBAR4_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR4_U_RNI_NID260, REGION4_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR4_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR4_U_RNI_NID260, REGION4_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR4_U_RNI_NID260, REGION4_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR4_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR4_U_RNI_NID260, 0x2035c58)
    FIELD(POR_MPU_M3_PRLAR4_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR4_U_RNI_NID260, REGION4_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR4_U_RNI_NID260, REGION4_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR5_U_RNI_NID260, 0x2035c60)
    FIELD(POR_MPU_M3_PRBAR5_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR5_U_RNI_NID260, REGION5_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR5_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR5_U_RNI_NID260, REGION5_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR5_U_RNI_NID260, REGION5_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR5_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR5_U_RNI_NID260, 0x2035c68)
    FIELD(POR_MPU_M3_PRLAR5_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR5_U_RNI_NID260, REGION5_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR5_U_RNI_NID260, REGION5_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR6_U_RNI_NID260, 0x2035c70)
    FIELD(POR_MPU_M3_PRBAR6_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR6_U_RNI_NID260, REGION6_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR6_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR6_U_RNI_NID260, REGION6_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR6_U_RNI_NID260, REGION6_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR6_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR6_U_RNI_NID260, 0x2035c78)
    FIELD(POR_MPU_M3_PRLAR6_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR6_U_RNI_NID260, REGION6_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR6_U_RNI_NID260, REGION6_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR7_U_RNI_NID260, 0x2035c80)
    FIELD(POR_MPU_M3_PRBAR7_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR7_U_RNI_NID260, REGION7_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR7_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR7_U_RNI_NID260, REGION7_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR7_U_RNI_NID260, REGION7_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR7_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR7_U_RNI_NID260, 0x2035c88)
    FIELD(POR_MPU_M3_PRLAR7_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR7_U_RNI_NID260, REGION7_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR7_U_RNI_NID260, REGION7_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR8_U_RNI_NID260, 0x2035c90)
    FIELD(POR_MPU_M3_PRBAR8_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR8_U_RNI_NID260, REGION8_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR8_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR8_U_RNI_NID260, REGION8_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR8_U_RNI_NID260, REGION8_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR8_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR8_U_RNI_NID260, 0x2035c98)
    FIELD(POR_MPU_M3_PRLAR8_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR8_U_RNI_NID260, REGION8_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR8_U_RNI_NID260, REGION8_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR9_U_RNI_NID260, 0x2035ca0)
    FIELD(POR_MPU_M3_PRBAR9_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR9_U_RNI_NID260, REGION9_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR9_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR9_U_RNI_NID260, REGION9_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR9_U_RNI_NID260, REGION9_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR9_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR9_U_RNI_NID260, 0x2035ca8)
    FIELD(POR_MPU_M3_PRLAR9_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR9_U_RNI_NID260, REGION9_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR9_U_RNI_NID260, REGION9_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR10_U_RNI_NID260, 0x2035cb0)
    FIELD(POR_MPU_M3_PRBAR10_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR10_U_RNI_NID260, REGION10_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR10_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR10_U_RNI_NID260, REGION10_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR10_U_RNI_NID260, REGION10_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR10_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR10_U_RNI_NID260, 0x2035cb8)
    FIELD(POR_MPU_M3_PRLAR10_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR10_U_RNI_NID260, REGION10_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR10_U_RNI_NID260, REGION10_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR11_U_RNI_NID260, 0x2035cc0)
    FIELD(POR_MPU_M3_PRBAR11_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR11_U_RNI_NID260, REGION11_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR11_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR11_U_RNI_NID260, REGION11_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR11_U_RNI_NID260, REGION11_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR11_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR11_U_RNI_NID260, 0x2035cc8)
    FIELD(POR_MPU_M3_PRLAR11_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR11_U_RNI_NID260, REGION11_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR11_U_RNI_NID260, REGION11_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR12_U_RNI_NID260, 0x2035cd0)
    FIELD(POR_MPU_M3_PRBAR12_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR12_U_RNI_NID260, REGION12_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR12_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR12_U_RNI_NID260, REGION12_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR12_U_RNI_NID260, REGION12_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR12_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR12_U_RNI_NID260, 0x2035cd8)
    FIELD(POR_MPU_M3_PRLAR12_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR12_U_RNI_NID260, REGION12_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR12_U_RNI_NID260, REGION12_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR13_U_RNI_NID260, 0x2035ce0)
    FIELD(POR_MPU_M3_PRBAR13_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR13_U_RNI_NID260, REGION13_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR13_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR13_U_RNI_NID260, REGION13_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR13_U_RNI_NID260, REGION13_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR13_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR13_U_RNI_NID260, 0x2035ce8)
    FIELD(POR_MPU_M3_PRLAR13_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR13_U_RNI_NID260, REGION13_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR13_U_RNI_NID260, REGION13_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR14_U_RNI_NID260, 0x2035cf0)
    FIELD(POR_MPU_M3_PRBAR14_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR14_U_RNI_NID260, REGION14_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR14_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR14_U_RNI_NID260, REGION14_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR14_U_RNI_NID260, REGION14_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR14_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR14_U_RNI_NID260, 0x2035cf8)
    FIELD(POR_MPU_M3_PRLAR14_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR14_U_RNI_NID260, REGION14_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR14_U_RNI_NID260, REGION14_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR15_U_RNI_NID260, 0x2035d00)
    FIELD(POR_MPU_M3_PRBAR15_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR15_U_RNI_NID260, REGION15_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR15_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR15_U_RNI_NID260, REGION15_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR15_U_RNI_NID260, REGION15_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR15_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR15_U_RNI_NID260, 0x2035d08)
    FIELD(POR_MPU_M3_PRLAR15_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR15_U_RNI_NID260, REGION15_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR15_U_RNI_NID260, REGION15_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR16_U_RNI_NID260, 0x2035d10)
    FIELD(POR_MPU_M3_PRBAR16_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR16_U_RNI_NID260, REGION16_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR16_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR16_U_RNI_NID260, REGION16_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR16_U_RNI_NID260, REGION16_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR16_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR16_U_RNI_NID260, 0x2035d18)
    FIELD(POR_MPU_M3_PRLAR16_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR16_U_RNI_NID260, REGION16_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR16_U_RNI_NID260, REGION16_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR17_U_RNI_NID260, 0x2035d20)
    FIELD(POR_MPU_M3_PRBAR17_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR17_U_RNI_NID260, REGION17_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR17_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR17_U_RNI_NID260, REGION17_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR17_U_RNI_NID260, REGION17_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR17_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR17_U_RNI_NID260, 0x2035d28)
    FIELD(POR_MPU_M3_PRLAR17_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR17_U_RNI_NID260, REGION17_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR17_U_RNI_NID260, REGION17_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR18_U_RNI_NID260, 0x2035d30)
    FIELD(POR_MPU_M3_PRBAR18_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR18_U_RNI_NID260, REGION18_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR18_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR18_U_RNI_NID260, REGION18_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR18_U_RNI_NID260, REGION18_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR18_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR18_U_RNI_NID260, 0x2035d38)
    FIELD(POR_MPU_M3_PRLAR18_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR18_U_RNI_NID260, REGION18_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR18_U_RNI_NID260, REGION18_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR19_U_RNI_NID260, 0x2035d40)
    FIELD(POR_MPU_M3_PRBAR19_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR19_U_RNI_NID260, REGION19_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR19_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR19_U_RNI_NID260, REGION19_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR19_U_RNI_NID260, REGION19_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR19_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR19_U_RNI_NID260, 0x2035d48)
    FIELD(POR_MPU_M3_PRLAR19_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR19_U_RNI_NID260, REGION19_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR19_U_RNI_NID260, REGION19_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR20_U_RNI_NID260, 0x2035d50)
    FIELD(POR_MPU_M3_PRBAR20_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR20_U_RNI_NID260, REGION20_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR20_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR20_U_RNI_NID260, REGION20_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR20_U_RNI_NID260, REGION20_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR20_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR20_U_RNI_NID260, 0x2035d58)
    FIELD(POR_MPU_M3_PRLAR20_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR20_U_RNI_NID260, REGION20_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR20_U_RNI_NID260, REGION20_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR21_U_RNI_NID260, 0x2035d60)
    FIELD(POR_MPU_M3_PRBAR21_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR21_U_RNI_NID260, REGION21_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR21_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR21_U_RNI_NID260, REGION21_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR21_U_RNI_NID260, REGION21_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR21_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR21_U_RNI_NID260, 0x2035d68)
    FIELD(POR_MPU_M3_PRLAR21_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR21_U_RNI_NID260, REGION21_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR21_U_RNI_NID260, REGION21_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR22_U_RNI_NID260, 0x2035d70)
    FIELD(POR_MPU_M3_PRBAR22_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR22_U_RNI_NID260, REGION22_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR22_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR22_U_RNI_NID260, REGION22_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR22_U_RNI_NID260, REGION22_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR22_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR22_U_RNI_NID260, 0x2035d78)
    FIELD(POR_MPU_M3_PRLAR22_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR22_U_RNI_NID260, REGION22_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR22_U_RNI_NID260, REGION22_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR23_U_RNI_NID260, 0x2035d80)
    FIELD(POR_MPU_M3_PRBAR23_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR23_U_RNI_NID260, REGION23_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR23_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR23_U_RNI_NID260, REGION23_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR23_U_RNI_NID260, REGION23_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR23_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR23_U_RNI_NID260, 0x2035d88)
    FIELD(POR_MPU_M3_PRLAR23_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR23_U_RNI_NID260, REGION23_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR23_U_RNI_NID260, REGION23_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR24_U_RNI_NID260, 0x2035d90)
    FIELD(POR_MPU_M3_PRBAR24_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR24_U_RNI_NID260, REGION24_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR24_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR24_U_RNI_NID260, REGION24_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR24_U_RNI_NID260, REGION24_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR24_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR24_U_RNI_NID260, 0x2035d98)
    FIELD(POR_MPU_M3_PRLAR24_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR24_U_RNI_NID260, REGION24_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR24_U_RNI_NID260, REGION24_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR25_U_RNI_NID260, 0x2035da0)
    FIELD(POR_MPU_M3_PRBAR25_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR25_U_RNI_NID260, REGION25_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR25_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR25_U_RNI_NID260, REGION25_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR25_U_RNI_NID260, REGION25_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR25_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR25_U_RNI_NID260, 0x2035da8)
    FIELD(POR_MPU_M3_PRLAR25_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR25_U_RNI_NID260, REGION25_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR25_U_RNI_NID260, REGION25_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR26_U_RNI_NID260, 0x2035db0)
    FIELD(POR_MPU_M3_PRBAR26_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR26_U_RNI_NID260, REGION26_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR26_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR26_U_RNI_NID260, REGION26_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR26_U_RNI_NID260, REGION26_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR26_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR26_U_RNI_NID260, 0x2035db8)
    FIELD(POR_MPU_M3_PRLAR26_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR26_U_RNI_NID260, REGION26_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR26_U_RNI_NID260, REGION26_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR27_U_RNI_NID260, 0x2035dc0)
    FIELD(POR_MPU_M3_PRBAR27_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR27_U_RNI_NID260, REGION27_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR27_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR27_U_RNI_NID260, REGION27_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR27_U_RNI_NID260, REGION27_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR27_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR27_U_RNI_NID260, 0x2035dc8)
    FIELD(POR_MPU_M3_PRLAR27_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR27_U_RNI_NID260, REGION27_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR27_U_RNI_NID260, REGION27_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR28_U_RNI_NID260, 0x2035dd0)
    FIELD(POR_MPU_M3_PRBAR28_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR28_U_RNI_NID260, REGION28_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR28_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR28_U_RNI_NID260, REGION28_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR28_U_RNI_NID260, REGION28_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR28_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR28_U_RNI_NID260, 0x2035dd8)
    FIELD(POR_MPU_M3_PRLAR28_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR28_U_RNI_NID260, REGION28_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR28_U_RNI_NID260, REGION28_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR29_U_RNI_NID260, 0x2035de0)
    FIELD(POR_MPU_M3_PRBAR29_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR29_U_RNI_NID260, REGION29_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR29_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR29_U_RNI_NID260, REGION29_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR29_U_RNI_NID260, REGION29_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR29_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR29_U_RNI_NID260, 0x2035de8)
    FIELD(POR_MPU_M3_PRLAR29_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR29_U_RNI_NID260, REGION29_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR29_U_RNI_NID260, REGION29_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR30_U_RNI_NID260, 0x2035df0)
    FIELD(POR_MPU_M3_PRBAR30_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR30_U_RNI_NID260, REGION30_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR30_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR30_U_RNI_NID260, REGION30_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR30_U_RNI_NID260, REGION30_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR30_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR30_U_RNI_NID260, 0x2035df8)
    FIELD(POR_MPU_M3_PRLAR30_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR30_U_RNI_NID260, REGION30_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR30_U_RNI_NID260, REGION30_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR31_U_RNI_NID260, 0x2035e00)
    FIELD(POR_MPU_M3_PRBAR31_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR31_U_RNI_NID260, REGION31_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR31_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR31_U_RNI_NID260, REGION31_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR31_U_RNI_NID260, REGION31_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR31_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR31_U_RNI_NID260, 0x2035e08)
    FIELD(POR_MPU_M3_PRLAR31_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR31_U_RNI_NID260, REGION31_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR31_U_RNI_NID260, REGION31_EN, 0, 1)
REG32(POR_MPU_M4_CTL_U_RNI_NID260, 0x2036000)
    FIELD(POR_MPU_M4_CTL_U_RNI_NID260, M4_EN, 2, 1)
    FIELD(POR_MPU_M4_CTL_U_RNI_NID260, M4_ACTION, 0, 2)
REG32(POR_MPU_M4_PRBAR0_U_RNI_NID260, 0x2036010)
    FIELD(POR_MPU_M4_PRBAR0_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR0_U_RNI_NID260, REGION0_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR0_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR0_U_RNI_NID260, REGION0_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR0_U_RNI_NID260, REGION0_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR0_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR0_U_RNI_NID260, 0x2036018)
    FIELD(POR_MPU_M4_PRLAR0_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR0_U_RNI_NID260, REGION0_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR0_U_RNI_NID260, REGION0_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR1_U_RNI_NID260, 0x2036020)
    FIELD(POR_MPU_M4_PRBAR1_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR1_U_RNI_NID260, REGION1_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR1_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR1_U_RNI_NID260, REGION1_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR1_U_RNI_NID260, REGION1_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR1_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR1_U_RNI_NID260, 0x2036028)
    FIELD(POR_MPU_M4_PRLAR1_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR1_U_RNI_NID260, REGION1_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR1_U_RNI_NID260, REGION1_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR2_U_RNI_NID260, 0x2036030)
    FIELD(POR_MPU_M4_PRBAR2_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR2_U_RNI_NID260, REGION2_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR2_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR2_U_RNI_NID260, REGION2_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR2_U_RNI_NID260, REGION2_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR2_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR2_U_RNI_NID260, 0x2036038)
    FIELD(POR_MPU_M4_PRLAR2_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR2_U_RNI_NID260, REGION2_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR2_U_RNI_NID260, REGION2_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR3_U_RNI_NID260, 0x2036040)
    FIELD(POR_MPU_M4_PRBAR3_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR3_U_RNI_NID260, REGION3_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR3_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR3_U_RNI_NID260, REGION3_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR3_U_RNI_NID260, REGION3_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR3_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR3_U_RNI_NID260, 0x2036048)
    FIELD(POR_MPU_M4_PRLAR3_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR3_U_RNI_NID260, REGION3_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR3_U_RNI_NID260, REGION3_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR4_U_RNI_NID260, 0x2036050)
    FIELD(POR_MPU_M4_PRBAR4_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR4_U_RNI_NID260, REGION4_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR4_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR4_U_RNI_NID260, REGION4_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR4_U_RNI_NID260, REGION4_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR4_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR4_U_RNI_NID260, 0x2036058)
    FIELD(POR_MPU_M4_PRLAR4_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR4_U_RNI_NID260, REGION4_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR4_U_RNI_NID260, REGION4_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR5_U_RNI_NID260, 0x2036060)
    FIELD(POR_MPU_M4_PRBAR5_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR5_U_RNI_NID260, REGION5_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR5_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR5_U_RNI_NID260, REGION5_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR5_U_RNI_NID260, REGION5_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR5_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR5_U_RNI_NID260, 0x2036068)
    FIELD(POR_MPU_M4_PRLAR5_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR5_U_RNI_NID260, REGION5_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR5_U_RNI_NID260, REGION5_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR6_U_RNI_NID260, 0x2036070)
    FIELD(POR_MPU_M4_PRBAR6_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR6_U_RNI_NID260, REGION6_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR6_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR6_U_RNI_NID260, REGION6_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR6_U_RNI_NID260, REGION6_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR6_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR6_U_RNI_NID260, 0x2036078)
    FIELD(POR_MPU_M4_PRLAR6_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR6_U_RNI_NID260, REGION6_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR6_U_RNI_NID260, REGION6_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR7_U_RNI_NID260, 0x2036080)
    FIELD(POR_MPU_M4_PRBAR7_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR7_U_RNI_NID260, REGION7_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR7_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR7_U_RNI_NID260, REGION7_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR7_U_RNI_NID260, REGION7_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR7_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR7_U_RNI_NID260, 0x2036088)
    FIELD(POR_MPU_M4_PRLAR7_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR7_U_RNI_NID260, REGION7_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR7_U_RNI_NID260, REGION7_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR8_U_RNI_NID260, 0x2036090)
    FIELD(POR_MPU_M4_PRBAR8_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR8_U_RNI_NID260, REGION8_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR8_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR8_U_RNI_NID260, REGION8_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR8_U_RNI_NID260, REGION8_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR8_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR8_U_RNI_NID260, 0x2036098)
    FIELD(POR_MPU_M4_PRLAR8_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR8_U_RNI_NID260, REGION8_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR8_U_RNI_NID260, REGION8_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR9_U_RNI_NID260, 0x20360a0)
    FIELD(POR_MPU_M4_PRBAR9_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR9_U_RNI_NID260, REGION9_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR9_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR9_U_RNI_NID260, REGION9_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR9_U_RNI_NID260, REGION9_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR9_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR9_U_RNI_NID260, 0x20360a8)
    FIELD(POR_MPU_M4_PRLAR9_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR9_U_RNI_NID260, REGION9_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR9_U_RNI_NID260, REGION9_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR10_U_RNI_NID260, 0x20360b0)
    FIELD(POR_MPU_M4_PRBAR10_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR10_U_RNI_NID260, REGION10_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR10_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR10_U_RNI_NID260, REGION10_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR10_U_RNI_NID260, REGION10_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR10_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR10_U_RNI_NID260, 0x20360b8)
    FIELD(POR_MPU_M4_PRLAR10_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR10_U_RNI_NID260, REGION10_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR10_U_RNI_NID260, REGION10_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR11_U_RNI_NID260, 0x20360c0)
    FIELD(POR_MPU_M4_PRBAR11_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR11_U_RNI_NID260, REGION11_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR11_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR11_U_RNI_NID260, REGION11_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR11_U_RNI_NID260, REGION11_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR11_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR11_U_RNI_NID260, 0x20360c8)
    FIELD(POR_MPU_M4_PRLAR11_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR11_U_RNI_NID260, REGION11_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR11_U_RNI_NID260, REGION11_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR12_U_RNI_NID260, 0x20360d0)
    FIELD(POR_MPU_M4_PRBAR12_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR12_U_RNI_NID260, REGION12_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR12_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR12_U_RNI_NID260, REGION12_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR12_U_RNI_NID260, REGION12_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR12_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR12_U_RNI_NID260, 0x20360d8)
    FIELD(POR_MPU_M4_PRLAR12_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR12_U_RNI_NID260, REGION12_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR12_U_RNI_NID260, REGION12_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR13_U_RNI_NID260, 0x20360e0)
    FIELD(POR_MPU_M4_PRBAR13_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR13_U_RNI_NID260, REGION13_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR13_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR13_U_RNI_NID260, REGION13_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR13_U_RNI_NID260, REGION13_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR13_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR13_U_RNI_NID260, 0x20360e8)
    FIELD(POR_MPU_M4_PRLAR13_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR13_U_RNI_NID260, REGION13_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR13_U_RNI_NID260, REGION13_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR14_U_RNI_NID260, 0x20360f0)
    FIELD(POR_MPU_M4_PRBAR14_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR14_U_RNI_NID260, REGION14_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR14_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR14_U_RNI_NID260, REGION14_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR14_U_RNI_NID260, REGION14_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR14_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR14_U_RNI_NID260, 0x20360f8)
    FIELD(POR_MPU_M4_PRLAR14_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR14_U_RNI_NID260, REGION14_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR14_U_RNI_NID260, REGION14_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR15_U_RNI_NID260, 0x2036100)
    FIELD(POR_MPU_M4_PRBAR15_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR15_U_RNI_NID260, REGION15_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR15_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR15_U_RNI_NID260, REGION15_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR15_U_RNI_NID260, REGION15_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR15_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR15_U_RNI_NID260, 0x2036108)
    FIELD(POR_MPU_M4_PRLAR15_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR15_U_RNI_NID260, REGION15_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR15_U_RNI_NID260, REGION15_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR16_U_RNI_NID260, 0x2036110)
    FIELD(POR_MPU_M4_PRBAR16_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR16_U_RNI_NID260, REGION16_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR16_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR16_U_RNI_NID260, REGION16_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR16_U_RNI_NID260, REGION16_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR16_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR16_U_RNI_NID260, 0x2036118)
    FIELD(POR_MPU_M4_PRLAR16_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR16_U_RNI_NID260, REGION16_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR16_U_RNI_NID260, REGION16_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR17_U_RNI_NID260, 0x2036120)
    FIELD(POR_MPU_M4_PRBAR17_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR17_U_RNI_NID260, REGION17_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR17_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR17_U_RNI_NID260, REGION17_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR17_U_RNI_NID260, REGION17_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR17_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR17_U_RNI_NID260, 0x2036128)
    FIELD(POR_MPU_M4_PRLAR17_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR17_U_RNI_NID260, REGION17_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR17_U_RNI_NID260, REGION17_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR18_U_RNI_NID260, 0x2036130)
    FIELD(POR_MPU_M4_PRBAR18_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR18_U_RNI_NID260, REGION18_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR18_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR18_U_RNI_NID260, REGION18_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR18_U_RNI_NID260, REGION18_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR18_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR18_U_RNI_NID260, 0x2036138)
    FIELD(POR_MPU_M4_PRLAR18_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR18_U_RNI_NID260, REGION18_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR18_U_RNI_NID260, REGION18_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR19_U_RNI_NID260, 0x2036140)
    FIELD(POR_MPU_M4_PRBAR19_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR19_U_RNI_NID260, REGION19_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR19_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR19_U_RNI_NID260, REGION19_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR19_U_RNI_NID260, REGION19_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR19_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR19_U_RNI_NID260, 0x2036148)
    FIELD(POR_MPU_M4_PRLAR19_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR19_U_RNI_NID260, REGION19_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR19_U_RNI_NID260, REGION19_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR20_U_RNI_NID260, 0x2036150)
    FIELD(POR_MPU_M4_PRBAR20_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR20_U_RNI_NID260, REGION20_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR20_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR20_U_RNI_NID260, REGION20_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR20_U_RNI_NID260, REGION20_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR20_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR20_U_RNI_NID260, 0x2036158)
    FIELD(POR_MPU_M4_PRLAR20_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR20_U_RNI_NID260, REGION20_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR20_U_RNI_NID260, REGION20_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR21_U_RNI_NID260, 0x2036160)
    FIELD(POR_MPU_M4_PRBAR21_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR21_U_RNI_NID260, REGION21_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR21_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR21_U_RNI_NID260, REGION21_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR21_U_RNI_NID260, REGION21_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR21_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR21_U_RNI_NID260, 0x2036168)
    FIELD(POR_MPU_M4_PRLAR21_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR21_U_RNI_NID260, REGION21_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR21_U_RNI_NID260, REGION21_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR22_U_RNI_NID260, 0x2036170)
    FIELD(POR_MPU_M4_PRBAR22_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR22_U_RNI_NID260, REGION22_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR22_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR22_U_RNI_NID260, REGION22_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR22_U_RNI_NID260, REGION22_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR22_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR22_U_RNI_NID260, 0x2036178)
    FIELD(POR_MPU_M4_PRLAR22_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR22_U_RNI_NID260, REGION22_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR22_U_RNI_NID260, REGION22_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR23_U_RNI_NID260, 0x2036180)
    FIELD(POR_MPU_M4_PRBAR23_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR23_U_RNI_NID260, REGION23_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR23_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR23_U_RNI_NID260, REGION23_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR23_U_RNI_NID260, REGION23_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR23_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR23_U_RNI_NID260, 0x2036188)
    FIELD(POR_MPU_M4_PRLAR23_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR23_U_RNI_NID260, REGION23_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR23_U_RNI_NID260, REGION23_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR24_U_RNI_NID260, 0x2036190)
    FIELD(POR_MPU_M4_PRBAR24_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR24_U_RNI_NID260, REGION24_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR24_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR24_U_RNI_NID260, REGION24_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR24_U_RNI_NID260, REGION24_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR24_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR24_U_RNI_NID260, 0x2036198)
    FIELD(POR_MPU_M4_PRLAR24_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR24_U_RNI_NID260, REGION24_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR24_U_RNI_NID260, REGION24_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR25_U_RNI_NID260, 0x20361a0)
    FIELD(POR_MPU_M4_PRBAR25_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR25_U_RNI_NID260, REGION25_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR25_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR25_U_RNI_NID260, REGION25_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR25_U_RNI_NID260, REGION25_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR25_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR25_U_RNI_NID260, 0x20361a8)
    FIELD(POR_MPU_M4_PRLAR25_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR25_U_RNI_NID260, REGION25_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR25_U_RNI_NID260, REGION25_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR26_U_RNI_NID260, 0x20361b0)
    FIELD(POR_MPU_M4_PRBAR26_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR26_U_RNI_NID260, REGION26_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR26_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR26_U_RNI_NID260, REGION26_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR26_U_RNI_NID260, REGION26_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR26_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR26_U_RNI_NID260, 0x20361b8)
    FIELD(POR_MPU_M4_PRLAR26_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR26_U_RNI_NID260, REGION26_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR26_U_RNI_NID260, REGION26_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR27_U_RNI_NID260, 0x20361c0)
    FIELD(POR_MPU_M4_PRBAR27_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR27_U_RNI_NID260, REGION27_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR27_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR27_U_RNI_NID260, REGION27_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR27_U_RNI_NID260, REGION27_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR27_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR27_U_RNI_NID260, 0x20361c8)
    FIELD(POR_MPU_M4_PRLAR27_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR27_U_RNI_NID260, REGION27_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR27_U_RNI_NID260, REGION27_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR28_U_RNI_NID260, 0x20361d0)
    FIELD(POR_MPU_M4_PRBAR28_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR28_U_RNI_NID260, REGION28_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR28_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR28_U_RNI_NID260, REGION28_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR28_U_RNI_NID260, REGION28_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR28_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR28_U_RNI_NID260, 0x20361d8)
    FIELD(POR_MPU_M4_PRLAR28_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR28_U_RNI_NID260, REGION28_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR28_U_RNI_NID260, REGION28_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR29_U_RNI_NID260, 0x20361e0)
    FIELD(POR_MPU_M4_PRBAR29_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR29_U_RNI_NID260, REGION29_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR29_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR29_U_RNI_NID260, REGION29_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR29_U_RNI_NID260, REGION29_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR29_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR29_U_RNI_NID260, 0x20361e8)
    FIELD(POR_MPU_M4_PRLAR29_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR29_U_RNI_NID260, REGION29_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR29_U_RNI_NID260, REGION29_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR30_U_RNI_NID260, 0x20361f0)
    FIELD(POR_MPU_M4_PRBAR30_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR30_U_RNI_NID260, REGION30_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR30_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR30_U_RNI_NID260, REGION30_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR30_U_RNI_NID260, REGION30_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR30_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR30_U_RNI_NID260, 0x20361f8)
    FIELD(POR_MPU_M4_PRLAR30_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR30_U_RNI_NID260, REGION30_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR30_U_RNI_NID260, REGION30_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR31_U_RNI_NID260, 0x2036200)
    FIELD(POR_MPU_M4_PRBAR31_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR31_U_RNI_NID260, REGION31_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR31_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR31_U_RNI_NID260, REGION31_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR31_U_RNI_NID260, REGION31_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR31_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR31_U_RNI_NID260, 0x2036208)
    FIELD(POR_MPU_M4_PRLAR31_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR31_U_RNI_NID260, REGION31_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR31_U_RNI_NID260, REGION31_EN, 0, 1)
REG32(POR_MPU_M5_CTL_U_RNI_NID260, 0x2036400)
    FIELD(POR_MPU_M5_CTL_U_RNI_NID260, M5_EN, 2, 1)
    FIELD(POR_MPU_M5_CTL_U_RNI_NID260, M5_ACTION, 0, 2)
REG32(POR_MPU_M5_PRBAR0_U_RNI_NID260, 0x2036410)
    FIELD(POR_MPU_M5_PRBAR0_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR0_U_RNI_NID260, REGION0_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR0_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR0_U_RNI_NID260, REGION0_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR0_U_RNI_NID260, REGION0_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR0_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR0_U_RNI_NID260, 0x2036418)
    FIELD(POR_MPU_M5_PRLAR0_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR0_U_RNI_NID260, REGION0_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR0_U_RNI_NID260, REGION0_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR1_U_RNI_NID260, 0x2036420)
    FIELD(POR_MPU_M5_PRBAR1_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR1_U_RNI_NID260, REGION1_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR1_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR1_U_RNI_NID260, REGION1_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR1_U_RNI_NID260, REGION1_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR1_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR1_U_RNI_NID260, 0x2036428)
    FIELD(POR_MPU_M5_PRLAR1_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR1_U_RNI_NID260, REGION1_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR1_U_RNI_NID260, REGION1_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR2_U_RNI_NID260, 0x2036430)
    FIELD(POR_MPU_M5_PRBAR2_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR2_U_RNI_NID260, REGION2_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR2_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR2_U_RNI_NID260, REGION2_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR2_U_RNI_NID260, REGION2_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR2_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR2_U_RNI_NID260, 0x2036438)
    FIELD(POR_MPU_M5_PRLAR2_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR2_U_RNI_NID260, REGION2_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR2_U_RNI_NID260, REGION2_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR3_U_RNI_NID260, 0x2036440)
    FIELD(POR_MPU_M5_PRBAR3_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR3_U_RNI_NID260, REGION3_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR3_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR3_U_RNI_NID260, REGION3_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR3_U_RNI_NID260, REGION3_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR3_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR3_U_RNI_NID260, 0x2036448)
    FIELD(POR_MPU_M5_PRLAR3_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR3_U_RNI_NID260, REGION3_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR3_U_RNI_NID260, REGION3_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR4_U_RNI_NID260, 0x2036450)
    FIELD(POR_MPU_M5_PRBAR4_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR4_U_RNI_NID260, REGION4_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR4_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR4_U_RNI_NID260, REGION4_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR4_U_RNI_NID260, REGION4_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR4_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR4_U_RNI_NID260, 0x2036458)
    FIELD(POR_MPU_M5_PRLAR4_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR4_U_RNI_NID260, REGION4_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR4_U_RNI_NID260, REGION4_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR5_U_RNI_NID260, 0x2036460)
    FIELD(POR_MPU_M5_PRBAR5_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR5_U_RNI_NID260, REGION5_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR5_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR5_U_RNI_NID260, REGION5_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR5_U_RNI_NID260, REGION5_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR5_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR5_U_RNI_NID260, 0x2036468)
    FIELD(POR_MPU_M5_PRLAR5_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR5_U_RNI_NID260, REGION5_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR5_U_RNI_NID260, REGION5_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR6_U_RNI_NID260, 0x2036470)
    FIELD(POR_MPU_M5_PRBAR6_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR6_U_RNI_NID260, REGION6_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR6_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR6_U_RNI_NID260, REGION6_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR6_U_RNI_NID260, REGION6_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR6_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR6_U_RNI_NID260, 0x2036478)
    FIELD(POR_MPU_M5_PRLAR6_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR6_U_RNI_NID260, REGION6_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR6_U_RNI_NID260, REGION6_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR7_U_RNI_NID260, 0x2036480)
    FIELD(POR_MPU_M5_PRBAR7_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR7_U_RNI_NID260, REGION7_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR7_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR7_U_RNI_NID260, REGION7_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR7_U_RNI_NID260, REGION7_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR7_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR7_U_RNI_NID260, 0x2036488)
    FIELD(POR_MPU_M5_PRLAR7_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR7_U_RNI_NID260, REGION7_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR7_U_RNI_NID260, REGION7_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR8_U_RNI_NID260, 0x2036490)
    FIELD(POR_MPU_M5_PRBAR8_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR8_U_RNI_NID260, REGION8_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR8_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR8_U_RNI_NID260, REGION8_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR8_U_RNI_NID260, REGION8_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR8_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR8_U_RNI_NID260, 0x2036498)
    FIELD(POR_MPU_M5_PRLAR8_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR8_U_RNI_NID260, REGION8_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR8_U_RNI_NID260, REGION8_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR9_U_RNI_NID260, 0x20364a0)
    FIELD(POR_MPU_M5_PRBAR9_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR9_U_RNI_NID260, REGION9_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR9_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR9_U_RNI_NID260, REGION9_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR9_U_RNI_NID260, REGION9_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR9_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR9_U_RNI_NID260, 0x20364a8)
    FIELD(POR_MPU_M5_PRLAR9_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR9_U_RNI_NID260, REGION9_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR9_U_RNI_NID260, REGION9_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR10_U_RNI_NID260, 0x20364b0)
    FIELD(POR_MPU_M5_PRBAR10_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR10_U_RNI_NID260, REGION10_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR10_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR10_U_RNI_NID260, REGION10_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR10_U_RNI_NID260, REGION10_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR10_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR10_U_RNI_NID260, 0x20364b8)
    FIELD(POR_MPU_M5_PRLAR10_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR10_U_RNI_NID260, REGION10_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR10_U_RNI_NID260, REGION10_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR11_U_RNI_NID260, 0x20364c0)
    FIELD(POR_MPU_M5_PRBAR11_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR11_U_RNI_NID260, REGION11_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR11_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR11_U_RNI_NID260, REGION11_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR11_U_RNI_NID260, REGION11_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR11_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR11_U_RNI_NID260, 0x20364c8)
    FIELD(POR_MPU_M5_PRLAR11_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR11_U_RNI_NID260, REGION11_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR11_U_RNI_NID260, REGION11_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR12_U_RNI_NID260, 0x20364d0)
    FIELD(POR_MPU_M5_PRBAR12_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR12_U_RNI_NID260, REGION12_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR12_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR12_U_RNI_NID260, REGION12_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR12_U_RNI_NID260, REGION12_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR12_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR12_U_RNI_NID260, 0x20364d8)
    FIELD(POR_MPU_M5_PRLAR12_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR12_U_RNI_NID260, REGION12_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR12_U_RNI_NID260, REGION12_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR13_U_RNI_NID260, 0x20364e0)
    FIELD(POR_MPU_M5_PRBAR13_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR13_U_RNI_NID260, REGION13_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR13_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR13_U_RNI_NID260, REGION13_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR13_U_RNI_NID260, REGION13_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR13_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR13_U_RNI_NID260, 0x20364e8)
    FIELD(POR_MPU_M5_PRLAR13_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR13_U_RNI_NID260, REGION13_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR13_U_RNI_NID260, REGION13_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR14_U_RNI_NID260, 0x20364f0)
    FIELD(POR_MPU_M5_PRBAR14_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR14_U_RNI_NID260, REGION14_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR14_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR14_U_RNI_NID260, REGION14_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR14_U_RNI_NID260, REGION14_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR14_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR14_U_RNI_NID260, 0x20364f8)
    FIELD(POR_MPU_M5_PRLAR14_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR14_U_RNI_NID260, REGION14_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR14_U_RNI_NID260, REGION14_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR15_U_RNI_NID260, 0x2036500)
    FIELD(POR_MPU_M5_PRBAR15_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR15_U_RNI_NID260, REGION15_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR15_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR15_U_RNI_NID260, REGION15_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR15_U_RNI_NID260, REGION15_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR15_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR15_U_RNI_NID260, 0x2036508)
    FIELD(POR_MPU_M5_PRLAR15_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR15_U_RNI_NID260, REGION15_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR15_U_RNI_NID260, REGION15_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR16_U_RNI_NID260, 0x2036510)
    FIELD(POR_MPU_M5_PRBAR16_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR16_U_RNI_NID260, REGION16_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR16_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR16_U_RNI_NID260, REGION16_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR16_U_RNI_NID260, REGION16_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR16_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR16_U_RNI_NID260, 0x2036518)
    FIELD(POR_MPU_M5_PRLAR16_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR16_U_RNI_NID260, REGION16_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR16_U_RNI_NID260, REGION16_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR17_U_RNI_NID260, 0x2036520)
    FIELD(POR_MPU_M5_PRBAR17_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR17_U_RNI_NID260, REGION17_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR17_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR17_U_RNI_NID260, REGION17_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR17_U_RNI_NID260, REGION17_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR17_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR17_U_RNI_NID260, 0x2036528)
    FIELD(POR_MPU_M5_PRLAR17_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR17_U_RNI_NID260, REGION17_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR17_U_RNI_NID260, REGION17_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR18_U_RNI_NID260, 0x2036530)
    FIELD(POR_MPU_M5_PRBAR18_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR18_U_RNI_NID260, REGION18_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR18_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR18_U_RNI_NID260, REGION18_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR18_U_RNI_NID260, REGION18_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR18_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR18_U_RNI_NID260, 0x2036538)
    FIELD(POR_MPU_M5_PRLAR18_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR18_U_RNI_NID260, REGION18_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR18_U_RNI_NID260, REGION18_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR19_U_RNI_NID260, 0x2036540)
    FIELD(POR_MPU_M5_PRBAR19_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR19_U_RNI_NID260, REGION19_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR19_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR19_U_RNI_NID260, REGION19_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR19_U_RNI_NID260, REGION19_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR19_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR19_U_RNI_NID260, 0x2036548)
    FIELD(POR_MPU_M5_PRLAR19_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR19_U_RNI_NID260, REGION19_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR19_U_RNI_NID260, REGION19_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR20_U_RNI_NID260, 0x2036550)
    FIELD(POR_MPU_M5_PRBAR20_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR20_U_RNI_NID260, REGION20_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR20_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR20_U_RNI_NID260, REGION20_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR20_U_RNI_NID260, REGION20_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR20_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR20_U_RNI_NID260, 0x2036558)
    FIELD(POR_MPU_M5_PRLAR20_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR20_U_RNI_NID260, REGION20_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR20_U_RNI_NID260, REGION20_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR21_U_RNI_NID260, 0x2036560)
    FIELD(POR_MPU_M5_PRBAR21_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR21_U_RNI_NID260, REGION21_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR21_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR21_U_RNI_NID260, REGION21_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR21_U_RNI_NID260, REGION21_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR21_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR21_U_RNI_NID260, 0x2036568)
    FIELD(POR_MPU_M5_PRLAR21_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR21_U_RNI_NID260, REGION21_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR21_U_RNI_NID260, REGION21_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR22_U_RNI_NID260, 0x2036570)
    FIELD(POR_MPU_M5_PRBAR22_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR22_U_RNI_NID260, REGION22_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR22_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR22_U_RNI_NID260, REGION22_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR22_U_RNI_NID260, REGION22_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR22_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR22_U_RNI_NID260, 0x2036578)
    FIELD(POR_MPU_M5_PRLAR22_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR22_U_RNI_NID260, REGION22_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR22_U_RNI_NID260, REGION22_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR23_U_RNI_NID260, 0x2036580)
    FIELD(POR_MPU_M5_PRBAR23_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR23_U_RNI_NID260, REGION23_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR23_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR23_U_RNI_NID260, REGION23_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR23_U_RNI_NID260, REGION23_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR23_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR23_U_RNI_NID260, 0x2036588)
    FIELD(POR_MPU_M5_PRLAR23_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR23_U_RNI_NID260, REGION23_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR23_U_RNI_NID260, REGION23_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR24_U_RNI_NID260, 0x2036590)
    FIELD(POR_MPU_M5_PRBAR24_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR24_U_RNI_NID260, REGION24_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR24_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR24_U_RNI_NID260, REGION24_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR24_U_RNI_NID260, REGION24_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR24_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR24_U_RNI_NID260, 0x2036598)
    FIELD(POR_MPU_M5_PRLAR24_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR24_U_RNI_NID260, REGION24_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR24_U_RNI_NID260, REGION24_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR25_U_RNI_NID260, 0x20365a0)
    FIELD(POR_MPU_M5_PRBAR25_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR25_U_RNI_NID260, REGION25_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR25_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR25_U_RNI_NID260, REGION25_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR25_U_RNI_NID260, REGION25_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR25_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR25_U_RNI_NID260, 0x20365a8)
    FIELD(POR_MPU_M5_PRLAR25_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR25_U_RNI_NID260, REGION25_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR25_U_RNI_NID260, REGION25_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR26_U_RNI_NID260, 0x20365b0)
    FIELD(POR_MPU_M5_PRBAR26_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR26_U_RNI_NID260, REGION26_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR26_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR26_U_RNI_NID260, REGION26_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR26_U_RNI_NID260, REGION26_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR26_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR26_U_RNI_NID260, 0x20365b8)
    FIELD(POR_MPU_M5_PRLAR26_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR26_U_RNI_NID260, REGION26_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR26_U_RNI_NID260, REGION26_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR27_U_RNI_NID260, 0x20365c0)
    FIELD(POR_MPU_M5_PRBAR27_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR27_U_RNI_NID260, REGION27_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR27_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR27_U_RNI_NID260, REGION27_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR27_U_RNI_NID260, REGION27_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR27_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR27_U_RNI_NID260, 0x20365c8)
    FIELD(POR_MPU_M5_PRLAR27_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR27_U_RNI_NID260, REGION27_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR27_U_RNI_NID260, REGION27_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR28_U_RNI_NID260, 0x20365d0)
    FIELD(POR_MPU_M5_PRBAR28_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR28_U_RNI_NID260, REGION28_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR28_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR28_U_RNI_NID260, REGION28_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR28_U_RNI_NID260, REGION28_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR28_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR28_U_RNI_NID260, 0x20365d8)
    FIELD(POR_MPU_M5_PRLAR28_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR28_U_RNI_NID260, REGION28_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR28_U_RNI_NID260, REGION28_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR29_U_RNI_NID260, 0x20365e0)
    FIELD(POR_MPU_M5_PRBAR29_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR29_U_RNI_NID260, REGION29_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR29_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR29_U_RNI_NID260, REGION29_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR29_U_RNI_NID260, REGION29_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR29_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR29_U_RNI_NID260, 0x20365e8)
    FIELD(POR_MPU_M5_PRLAR29_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR29_U_RNI_NID260, REGION29_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR29_U_RNI_NID260, REGION29_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR30_U_RNI_NID260, 0x20365f0)
    FIELD(POR_MPU_M5_PRBAR30_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR30_U_RNI_NID260, REGION30_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR30_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR30_U_RNI_NID260, REGION30_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR30_U_RNI_NID260, REGION30_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR30_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR30_U_RNI_NID260, 0x20365f8)
    FIELD(POR_MPU_M5_PRLAR30_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR30_U_RNI_NID260, REGION30_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR30_U_RNI_NID260, REGION30_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR31_U_RNI_NID260, 0x2036600)
    FIELD(POR_MPU_M5_PRBAR31_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR31_U_RNI_NID260, REGION31_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR31_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR31_U_RNI_NID260, REGION31_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR31_U_RNI_NID260, REGION31_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR31_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR31_U_RNI_NID260, 0x2036608)
    FIELD(POR_MPU_M5_PRLAR31_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR31_U_RNI_NID260, REGION31_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR31_U_RNI_NID260, REGION31_EN, 0, 1)
REG32(POR_MPU_M6_CTL_U_RNI_NID260, 0x2036800)
    FIELD(POR_MPU_M6_CTL_U_RNI_NID260, M6_EN, 2, 1)
    FIELD(POR_MPU_M6_CTL_U_RNI_NID260, M6_ACTION, 0, 2)
REG32(POR_MPU_M6_PRBAR0_U_RNI_NID260, 0x2036810)
    FIELD(POR_MPU_M6_PRBAR0_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR0_U_RNI_NID260, REGION0_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR0_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR0_U_RNI_NID260, REGION0_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR0_U_RNI_NID260, REGION0_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR0_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR0_U_RNI_NID260, 0x2036818)
    FIELD(POR_MPU_M6_PRLAR0_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR0_U_RNI_NID260, REGION0_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR0_U_RNI_NID260, REGION0_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR1_U_RNI_NID260, 0x2036820)
    FIELD(POR_MPU_M6_PRBAR1_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR1_U_RNI_NID260, REGION1_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR1_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR1_U_RNI_NID260, REGION1_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR1_U_RNI_NID260, REGION1_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR1_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR1_U_RNI_NID260, 0x2036828)
    FIELD(POR_MPU_M6_PRLAR1_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR1_U_RNI_NID260, REGION1_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR1_U_RNI_NID260, REGION1_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR2_U_RNI_NID260, 0x2036830)
    FIELD(POR_MPU_M6_PRBAR2_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR2_U_RNI_NID260, REGION2_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR2_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR2_U_RNI_NID260, REGION2_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR2_U_RNI_NID260, REGION2_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR2_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR2_U_RNI_NID260, 0x2036838)
    FIELD(POR_MPU_M6_PRLAR2_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR2_U_RNI_NID260, REGION2_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR2_U_RNI_NID260, REGION2_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR3_U_RNI_NID260, 0x2036840)
    FIELD(POR_MPU_M6_PRBAR3_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR3_U_RNI_NID260, REGION3_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR3_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR3_U_RNI_NID260, REGION3_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR3_U_RNI_NID260, REGION3_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR3_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR3_U_RNI_NID260, 0x2036848)
    FIELD(POR_MPU_M6_PRLAR3_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR3_U_RNI_NID260, REGION3_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR3_U_RNI_NID260, REGION3_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR4_U_RNI_NID260, 0x2036850)
    FIELD(POR_MPU_M6_PRBAR4_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR4_U_RNI_NID260, REGION4_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR4_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR4_U_RNI_NID260, REGION4_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR4_U_RNI_NID260, REGION4_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR4_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR4_U_RNI_NID260, 0x2036858)
    FIELD(POR_MPU_M6_PRLAR4_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR4_U_RNI_NID260, REGION4_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR4_U_RNI_NID260, REGION4_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR5_U_RNI_NID260, 0x2036860)
    FIELD(POR_MPU_M6_PRBAR5_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR5_U_RNI_NID260, REGION5_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR5_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR5_U_RNI_NID260, REGION5_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR5_U_RNI_NID260, REGION5_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR5_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR5_U_RNI_NID260, 0x2036868)
    FIELD(POR_MPU_M6_PRLAR5_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR5_U_RNI_NID260, REGION5_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR5_U_RNI_NID260, REGION5_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR6_U_RNI_NID260, 0x2036870)
    FIELD(POR_MPU_M6_PRBAR6_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR6_U_RNI_NID260, REGION6_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR6_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR6_U_RNI_NID260, REGION6_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR6_U_RNI_NID260, REGION6_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR6_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR6_U_RNI_NID260, 0x2036878)
    FIELD(POR_MPU_M6_PRLAR6_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR6_U_RNI_NID260, REGION6_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR6_U_RNI_NID260, REGION6_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR7_U_RNI_NID260, 0x2036880)
    FIELD(POR_MPU_M6_PRBAR7_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR7_U_RNI_NID260, REGION7_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR7_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR7_U_RNI_NID260, REGION7_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR7_U_RNI_NID260, REGION7_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR7_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR7_U_RNI_NID260, 0x2036888)
    FIELD(POR_MPU_M6_PRLAR7_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR7_U_RNI_NID260, REGION7_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR7_U_RNI_NID260, REGION7_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR8_U_RNI_NID260, 0x2036890)
    FIELD(POR_MPU_M6_PRBAR8_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR8_U_RNI_NID260, REGION8_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR8_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR8_U_RNI_NID260, REGION8_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR8_U_RNI_NID260, REGION8_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR8_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR8_U_RNI_NID260, 0x2036898)
    FIELD(POR_MPU_M6_PRLAR8_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR8_U_RNI_NID260, REGION8_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR8_U_RNI_NID260, REGION8_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR9_U_RNI_NID260, 0x20368a0)
    FIELD(POR_MPU_M6_PRBAR9_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR9_U_RNI_NID260, REGION9_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR9_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR9_U_RNI_NID260, REGION9_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR9_U_RNI_NID260, REGION9_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR9_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR9_U_RNI_NID260, 0x20368a8)
    FIELD(POR_MPU_M6_PRLAR9_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR9_U_RNI_NID260, REGION9_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR9_U_RNI_NID260, REGION9_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR10_U_RNI_NID260, 0x20368b0)
    FIELD(POR_MPU_M6_PRBAR10_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR10_U_RNI_NID260, REGION10_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR10_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR10_U_RNI_NID260, REGION10_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR10_U_RNI_NID260, REGION10_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR10_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR10_U_RNI_NID260, 0x20368b8)
    FIELD(POR_MPU_M6_PRLAR10_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR10_U_RNI_NID260, REGION10_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR10_U_RNI_NID260, REGION10_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR11_U_RNI_NID260, 0x20368c0)
    FIELD(POR_MPU_M6_PRBAR11_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR11_U_RNI_NID260, REGION11_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR11_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR11_U_RNI_NID260, REGION11_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR11_U_RNI_NID260, REGION11_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR11_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR11_U_RNI_NID260, 0x20368c8)
    FIELD(POR_MPU_M6_PRLAR11_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR11_U_RNI_NID260, REGION11_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR11_U_RNI_NID260, REGION11_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR12_U_RNI_NID260, 0x20368d0)
    FIELD(POR_MPU_M6_PRBAR12_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR12_U_RNI_NID260, REGION12_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR12_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR12_U_RNI_NID260, REGION12_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR12_U_RNI_NID260, REGION12_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR12_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR12_U_RNI_NID260, 0x20368d8)
    FIELD(POR_MPU_M6_PRLAR12_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR12_U_RNI_NID260, REGION12_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR12_U_RNI_NID260, REGION12_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR13_U_RNI_NID260, 0x20368e0)
    FIELD(POR_MPU_M6_PRBAR13_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR13_U_RNI_NID260, REGION13_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR13_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR13_U_RNI_NID260, REGION13_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR13_U_RNI_NID260, REGION13_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR13_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR13_U_RNI_NID260, 0x20368e8)
    FIELD(POR_MPU_M6_PRLAR13_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR13_U_RNI_NID260, REGION13_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR13_U_RNI_NID260, REGION13_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR14_U_RNI_NID260, 0x20368f0)
    FIELD(POR_MPU_M6_PRBAR14_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR14_U_RNI_NID260, REGION14_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR14_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR14_U_RNI_NID260, REGION14_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR14_U_RNI_NID260, REGION14_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR14_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR14_U_RNI_NID260, 0x20368f8)
    FIELD(POR_MPU_M6_PRLAR14_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR14_U_RNI_NID260, REGION14_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR14_U_RNI_NID260, REGION14_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR15_U_RNI_NID260, 0x2036900)
    FIELD(POR_MPU_M6_PRBAR15_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR15_U_RNI_NID260, REGION15_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR15_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR15_U_RNI_NID260, REGION15_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR15_U_RNI_NID260, REGION15_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR15_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR15_U_RNI_NID260, 0x2036908)
    FIELD(POR_MPU_M6_PRLAR15_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR15_U_RNI_NID260, REGION15_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR15_U_RNI_NID260, REGION15_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR16_U_RNI_NID260, 0x2036910)
    FIELD(POR_MPU_M6_PRBAR16_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR16_U_RNI_NID260, REGION16_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR16_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR16_U_RNI_NID260, REGION16_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR16_U_RNI_NID260, REGION16_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR16_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR16_U_RNI_NID260, 0x2036918)
    FIELD(POR_MPU_M6_PRLAR16_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR16_U_RNI_NID260, REGION16_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR16_U_RNI_NID260, REGION16_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR17_U_RNI_NID260, 0x2036920)
    FIELD(POR_MPU_M6_PRBAR17_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR17_U_RNI_NID260, REGION17_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR17_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR17_U_RNI_NID260, REGION17_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR17_U_RNI_NID260, REGION17_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR17_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR17_U_RNI_NID260, 0x2036928)
    FIELD(POR_MPU_M6_PRLAR17_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR17_U_RNI_NID260, REGION17_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR17_U_RNI_NID260, REGION17_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR18_U_RNI_NID260, 0x2036930)
    FIELD(POR_MPU_M6_PRBAR18_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR18_U_RNI_NID260, REGION18_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR18_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR18_U_RNI_NID260, REGION18_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR18_U_RNI_NID260, REGION18_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR18_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR18_U_RNI_NID260, 0x2036938)
    FIELD(POR_MPU_M6_PRLAR18_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR18_U_RNI_NID260, REGION18_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR18_U_RNI_NID260, REGION18_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR19_U_RNI_NID260, 0x2036940)
    FIELD(POR_MPU_M6_PRBAR19_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR19_U_RNI_NID260, REGION19_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR19_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR19_U_RNI_NID260, REGION19_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR19_U_RNI_NID260, REGION19_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR19_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR19_U_RNI_NID260, 0x2036948)
    FIELD(POR_MPU_M6_PRLAR19_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR19_U_RNI_NID260, REGION19_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR19_U_RNI_NID260, REGION19_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR20_U_RNI_NID260, 0x2036950)
    FIELD(POR_MPU_M6_PRBAR20_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR20_U_RNI_NID260, REGION20_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR20_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR20_U_RNI_NID260, REGION20_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR20_U_RNI_NID260, REGION20_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR20_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR20_U_RNI_NID260, 0x2036958)
    FIELD(POR_MPU_M6_PRLAR20_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR20_U_RNI_NID260, REGION20_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR20_U_RNI_NID260, REGION20_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR21_U_RNI_NID260, 0x2036960)
    FIELD(POR_MPU_M6_PRBAR21_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR21_U_RNI_NID260, REGION21_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR21_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR21_U_RNI_NID260, REGION21_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR21_U_RNI_NID260, REGION21_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR21_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR21_U_RNI_NID260, 0x2036968)
    FIELD(POR_MPU_M6_PRLAR21_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR21_U_RNI_NID260, REGION21_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR21_U_RNI_NID260, REGION21_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR22_U_RNI_NID260, 0x2036970)
    FIELD(POR_MPU_M6_PRBAR22_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR22_U_RNI_NID260, REGION22_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR22_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR22_U_RNI_NID260, REGION22_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR22_U_RNI_NID260, REGION22_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR22_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR22_U_RNI_NID260, 0x2036978)
    FIELD(POR_MPU_M6_PRLAR22_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR22_U_RNI_NID260, REGION22_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR22_U_RNI_NID260, REGION22_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR23_U_RNI_NID260, 0x2036980)
    FIELD(POR_MPU_M6_PRBAR23_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR23_U_RNI_NID260, REGION23_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR23_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR23_U_RNI_NID260, REGION23_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR23_U_RNI_NID260, REGION23_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR23_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR23_U_RNI_NID260, 0x2036988)
    FIELD(POR_MPU_M6_PRLAR23_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR23_U_RNI_NID260, REGION23_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR23_U_RNI_NID260, REGION23_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR24_U_RNI_NID260, 0x2036990)
    FIELD(POR_MPU_M6_PRBAR24_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR24_U_RNI_NID260, REGION24_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR24_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR24_U_RNI_NID260, REGION24_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR24_U_RNI_NID260, REGION24_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR24_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR24_U_RNI_NID260, 0x2036998)
    FIELD(POR_MPU_M6_PRLAR24_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR24_U_RNI_NID260, REGION24_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR24_U_RNI_NID260, REGION24_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR25_U_RNI_NID260, 0x20369a0)
    FIELD(POR_MPU_M6_PRBAR25_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR25_U_RNI_NID260, REGION25_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR25_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR25_U_RNI_NID260, REGION25_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR25_U_RNI_NID260, REGION25_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR25_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR25_U_RNI_NID260, 0x20369a8)
    FIELD(POR_MPU_M6_PRLAR25_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR25_U_RNI_NID260, REGION25_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR25_U_RNI_NID260, REGION25_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR26_U_RNI_NID260, 0x20369b0)
    FIELD(POR_MPU_M6_PRBAR26_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR26_U_RNI_NID260, REGION26_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR26_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR26_U_RNI_NID260, REGION26_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR26_U_RNI_NID260, REGION26_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR26_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR26_U_RNI_NID260, 0x20369b8)
    FIELD(POR_MPU_M6_PRLAR26_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR26_U_RNI_NID260, REGION26_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR26_U_RNI_NID260, REGION26_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR27_U_RNI_NID260, 0x20369c0)
    FIELD(POR_MPU_M6_PRBAR27_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR27_U_RNI_NID260, REGION27_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR27_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR27_U_RNI_NID260, REGION27_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR27_U_RNI_NID260, REGION27_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR27_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR27_U_RNI_NID260, 0x20369c8)
    FIELD(POR_MPU_M6_PRLAR27_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR27_U_RNI_NID260, REGION27_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR27_U_RNI_NID260, REGION27_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR28_U_RNI_NID260, 0x20369d0)
    FIELD(POR_MPU_M6_PRBAR28_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR28_U_RNI_NID260, REGION28_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR28_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR28_U_RNI_NID260, REGION28_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR28_U_RNI_NID260, REGION28_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR28_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR28_U_RNI_NID260, 0x20369d8)
    FIELD(POR_MPU_M6_PRLAR28_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR28_U_RNI_NID260, REGION28_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR28_U_RNI_NID260, REGION28_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR29_U_RNI_NID260, 0x20369e0)
    FIELD(POR_MPU_M6_PRBAR29_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR29_U_RNI_NID260, REGION29_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR29_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR29_U_RNI_NID260, REGION29_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR29_U_RNI_NID260, REGION29_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR29_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR29_U_RNI_NID260, 0x20369e8)
    FIELD(POR_MPU_M6_PRLAR29_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR29_U_RNI_NID260, REGION29_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR29_U_RNI_NID260, REGION29_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR30_U_RNI_NID260, 0x20369f0)
    FIELD(POR_MPU_M6_PRBAR30_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR30_U_RNI_NID260, REGION30_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR30_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR30_U_RNI_NID260, REGION30_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR30_U_RNI_NID260, REGION30_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR30_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR30_U_RNI_NID260, 0x20369f8)
    FIELD(POR_MPU_M6_PRLAR30_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR30_U_RNI_NID260, REGION30_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR30_U_RNI_NID260, REGION30_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR31_U_RNI_NID260, 0x2036a00)
    FIELD(POR_MPU_M6_PRBAR31_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR31_U_RNI_NID260, REGION31_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR31_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR31_U_RNI_NID260, REGION31_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR31_U_RNI_NID260, REGION31_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR31_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR31_U_RNI_NID260, 0x2036a08)
    FIELD(POR_MPU_M6_PRLAR31_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR31_U_RNI_NID260, REGION31_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR31_U_RNI_NID260, REGION31_EN, 0, 1)
REG32(POR_MPU_M7_CTL_U_RNI_NID260, 0x2036c00)
    FIELD(POR_MPU_M7_CTL_U_RNI_NID260, M7_EN, 2, 1)
    FIELD(POR_MPU_M7_CTL_U_RNI_NID260, M7_ACTION, 0, 2)
REG32(POR_MPU_M7_PRBAR0_U_RNI_NID260, 0x2036c10)
    FIELD(POR_MPU_M7_PRBAR0_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR0_U_RNI_NID260, REGION0_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR0_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR0_U_RNI_NID260, REGION0_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR0_U_RNI_NID260, REGION0_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR0_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR0_U_RNI_NID260, 0x2036c18)
    FIELD(POR_MPU_M7_PRLAR0_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR0_U_RNI_NID260, REGION0_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR0_U_RNI_NID260, REGION0_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR1_U_RNI_NID260, 0x2036c20)
    FIELD(POR_MPU_M7_PRBAR1_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR1_U_RNI_NID260, REGION1_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR1_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR1_U_RNI_NID260, REGION1_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR1_U_RNI_NID260, REGION1_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR1_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR1_U_RNI_NID260, 0x2036c28)
    FIELD(POR_MPU_M7_PRLAR1_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR1_U_RNI_NID260, REGION1_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR1_U_RNI_NID260, REGION1_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR2_U_RNI_NID260, 0x2036c30)
    FIELD(POR_MPU_M7_PRBAR2_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR2_U_RNI_NID260, REGION2_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR2_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR2_U_RNI_NID260, REGION2_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR2_U_RNI_NID260, REGION2_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR2_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR2_U_RNI_NID260, 0x2036c38)
    FIELD(POR_MPU_M7_PRLAR2_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR2_U_RNI_NID260, REGION2_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR2_U_RNI_NID260, REGION2_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR3_U_RNI_NID260, 0x2036c40)
    FIELD(POR_MPU_M7_PRBAR3_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR3_U_RNI_NID260, REGION3_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR3_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR3_U_RNI_NID260, REGION3_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR3_U_RNI_NID260, REGION3_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR3_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR3_U_RNI_NID260, 0x2036c48)
    FIELD(POR_MPU_M7_PRLAR3_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR3_U_RNI_NID260, REGION3_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR3_U_RNI_NID260, REGION3_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR4_U_RNI_NID260, 0x2036c50)
    FIELD(POR_MPU_M7_PRBAR4_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR4_U_RNI_NID260, REGION4_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR4_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR4_U_RNI_NID260, REGION4_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR4_U_RNI_NID260, REGION4_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR4_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR4_U_RNI_NID260, 0x2036c58)
    FIELD(POR_MPU_M7_PRLAR4_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR4_U_RNI_NID260, REGION4_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR4_U_RNI_NID260, REGION4_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR5_U_RNI_NID260, 0x2036c60)
    FIELD(POR_MPU_M7_PRBAR5_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR5_U_RNI_NID260, REGION5_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR5_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR5_U_RNI_NID260, REGION5_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR5_U_RNI_NID260, REGION5_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR5_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR5_U_RNI_NID260, 0x2036c68)
    FIELD(POR_MPU_M7_PRLAR5_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR5_U_RNI_NID260, REGION5_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR5_U_RNI_NID260, REGION5_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR6_U_RNI_NID260, 0x2036c70)
    FIELD(POR_MPU_M7_PRBAR6_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR6_U_RNI_NID260, REGION6_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR6_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR6_U_RNI_NID260, REGION6_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR6_U_RNI_NID260, REGION6_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR6_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR6_U_RNI_NID260, 0x2036c78)
    FIELD(POR_MPU_M7_PRLAR6_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR6_U_RNI_NID260, REGION6_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR6_U_RNI_NID260, REGION6_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR7_U_RNI_NID260, 0x2036c80)
    FIELD(POR_MPU_M7_PRBAR7_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR7_U_RNI_NID260, REGION7_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR7_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR7_U_RNI_NID260, REGION7_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR7_U_RNI_NID260, REGION7_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR7_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR7_U_RNI_NID260, 0x2036c88)
    FIELD(POR_MPU_M7_PRLAR7_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR7_U_RNI_NID260, REGION7_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR7_U_RNI_NID260, REGION7_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR8_U_RNI_NID260, 0x2036c90)
    FIELD(POR_MPU_M7_PRBAR8_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR8_U_RNI_NID260, REGION8_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR8_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR8_U_RNI_NID260, REGION8_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR8_U_RNI_NID260, REGION8_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR8_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR8_U_RNI_NID260, 0x2036c98)
    FIELD(POR_MPU_M7_PRLAR8_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR8_U_RNI_NID260, REGION8_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR8_U_RNI_NID260, REGION8_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR9_U_RNI_NID260, 0x2036ca0)
    FIELD(POR_MPU_M7_PRBAR9_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR9_U_RNI_NID260, REGION9_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR9_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR9_U_RNI_NID260, REGION9_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR9_U_RNI_NID260, REGION9_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR9_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR9_U_RNI_NID260, 0x2036ca8)
    FIELD(POR_MPU_M7_PRLAR9_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR9_U_RNI_NID260, REGION9_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR9_U_RNI_NID260, REGION9_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR10_U_RNI_NID260, 0x2036cb0)
    FIELD(POR_MPU_M7_PRBAR10_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR10_U_RNI_NID260, REGION10_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR10_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR10_U_RNI_NID260, REGION10_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR10_U_RNI_NID260, REGION10_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR10_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR10_U_RNI_NID260, 0x2036cb8)
    FIELD(POR_MPU_M7_PRLAR10_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR10_U_RNI_NID260, REGION10_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR10_U_RNI_NID260, REGION10_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR11_U_RNI_NID260, 0x2036cc0)
    FIELD(POR_MPU_M7_PRBAR11_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR11_U_RNI_NID260, REGION11_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR11_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR11_U_RNI_NID260, REGION11_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR11_U_RNI_NID260, REGION11_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR11_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR11_U_RNI_NID260, 0x2036cc8)
    FIELD(POR_MPU_M7_PRLAR11_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR11_U_RNI_NID260, REGION11_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR11_U_RNI_NID260, REGION11_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR12_U_RNI_NID260, 0x2036cd0)
    FIELD(POR_MPU_M7_PRBAR12_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR12_U_RNI_NID260, REGION12_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR12_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR12_U_RNI_NID260, REGION12_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR12_U_RNI_NID260, REGION12_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR12_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR12_U_RNI_NID260, 0x2036cd8)
    FIELD(POR_MPU_M7_PRLAR12_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR12_U_RNI_NID260, REGION12_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR12_U_RNI_NID260, REGION12_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR13_U_RNI_NID260, 0x2036ce0)
    FIELD(POR_MPU_M7_PRBAR13_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR13_U_RNI_NID260, REGION13_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR13_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR13_U_RNI_NID260, REGION13_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR13_U_RNI_NID260, REGION13_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR13_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR13_U_RNI_NID260, 0x2036ce8)
    FIELD(POR_MPU_M7_PRLAR13_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR13_U_RNI_NID260, REGION13_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR13_U_RNI_NID260, REGION13_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR14_U_RNI_NID260, 0x2036cf0)
    FIELD(POR_MPU_M7_PRBAR14_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR14_U_RNI_NID260, REGION14_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR14_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR14_U_RNI_NID260, REGION14_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR14_U_RNI_NID260, REGION14_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR14_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR14_U_RNI_NID260, 0x2036cf8)
    FIELD(POR_MPU_M7_PRLAR14_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR14_U_RNI_NID260, REGION14_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR14_U_RNI_NID260, REGION14_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR15_U_RNI_NID260, 0x2036d00)
    FIELD(POR_MPU_M7_PRBAR15_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR15_U_RNI_NID260, REGION15_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR15_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR15_U_RNI_NID260, REGION15_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR15_U_RNI_NID260, REGION15_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR15_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR15_U_RNI_NID260, 0x2036d08)
    FIELD(POR_MPU_M7_PRLAR15_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR15_U_RNI_NID260, REGION15_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR15_U_RNI_NID260, REGION15_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR16_U_RNI_NID260, 0x2036d10)
    FIELD(POR_MPU_M7_PRBAR16_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR16_U_RNI_NID260, REGION16_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR16_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR16_U_RNI_NID260, REGION16_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR16_U_RNI_NID260, REGION16_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR16_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR16_U_RNI_NID260, 0x2036d18)
    FIELD(POR_MPU_M7_PRLAR16_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR16_U_RNI_NID260, REGION16_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR16_U_RNI_NID260, REGION16_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR17_U_RNI_NID260, 0x2036d20)
    FIELD(POR_MPU_M7_PRBAR17_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR17_U_RNI_NID260, REGION17_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR17_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR17_U_RNI_NID260, REGION17_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR17_U_RNI_NID260, REGION17_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR17_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR17_U_RNI_NID260, 0x2036d28)
    FIELD(POR_MPU_M7_PRLAR17_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR17_U_RNI_NID260, REGION17_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR17_U_RNI_NID260, REGION17_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR18_U_RNI_NID260, 0x2036d30)
    FIELD(POR_MPU_M7_PRBAR18_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR18_U_RNI_NID260, REGION18_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR18_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR18_U_RNI_NID260, REGION18_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR18_U_RNI_NID260, REGION18_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR18_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR18_U_RNI_NID260, 0x2036d38)
    FIELD(POR_MPU_M7_PRLAR18_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR18_U_RNI_NID260, REGION18_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR18_U_RNI_NID260, REGION18_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR19_U_RNI_NID260, 0x2036d40)
    FIELD(POR_MPU_M7_PRBAR19_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR19_U_RNI_NID260, REGION19_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR19_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR19_U_RNI_NID260, REGION19_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR19_U_RNI_NID260, REGION19_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR19_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR19_U_RNI_NID260, 0x2036d48)
    FIELD(POR_MPU_M7_PRLAR19_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR19_U_RNI_NID260, REGION19_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR19_U_RNI_NID260, REGION19_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR20_U_RNI_NID260, 0x2036d50)
    FIELD(POR_MPU_M7_PRBAR20_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR20_U_RNI_NID260, REGION20_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR20_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR20_U_RNI_NID260, REGION20_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR20_U_RNI_NID260, REGION20_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR20_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR20_U_RNI_NID260, 0x2036d58)
    FIELD(POR_MPU_M7_PRLAR20_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR20_U_RNI_NID260, REGION20_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR20_U_RNI_NID260, REGION20_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR21_U_RNI_NID260, 0x2036d60)
    FIELD(POR_MPU_M7_PRBAR21_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR21_U_RNI_NID260, REGION21_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR21_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR21_U_RNI_NID260, REGION21_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR21_U_RNI_NID260, REGION21_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR21_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR21_U_RNI_NID260, 0x2036d68)
    FIELD(POR_MPU_M7_PRLAR21_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR21_U_RNI_NID260, REGION21_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR21_U_RNI_NID260, REGION21_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR22_U_RNI_NID260, 0x2036d70)
    FIELD(POR_MPU_M7_PRBAR22_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR22_U_RNI_NID260, REGION22_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR22_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR22_U_RNI_NID260, REGION22_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR22_U_RNI_NID260, REGION22_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR22_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR22_U_RNI_NID260, 0x2036d78)
    FIELD(POR_MPU_M7_PRLAR22_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR22_U_RNI_NID260, REGION22_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR22_U_RNI_NID260, REGION22_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR23_U_RNI_NID260, 0x2036d80)
    FIELD(POR_MPU_M7_PRBAR23_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR23_U_RNI_NID260, REGION23_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR23_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR23_U_RNI_NID260, REGION23_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR23_U_RNI_NID260, REGION23_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR23_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR23_U_RNI_NID260, 0x2036d88)
    FIELD(POR_MPU_M7_PRLAR23_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR23_U_RNI_NID260, REGION23_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR23_U_RNI_NID260, REGION23_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR24_U_RNI_NID260, 0x2036d90)
    FIELD(POR_MPU_M7_PRBAR24_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR24_U_RNI_NID260, REGION24_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR24_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR24_U_RNI_NID260, REGION24_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR24_U_RNI_NID260, REGION24_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR24_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR24_U_RNI_NID260, 0x2036d98)
    FIELD(POR_MPU_M7_PRLAR24_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR24_U_RNI_NID260, REGION24_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR24_U_RNI_NID260, REGION24_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR25_U_RNI_NID260, 0x2036da0)
    FIELD(POR_MPU_M7_PRBAR25_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR25_U_RNI_NID260, REGION25_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR25_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR25_U_RNI_NID260, REGION25_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR25_U_RNI_NID260, REGION25_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR25_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR25_U_RNI_NID260, 0x2036da8)
    FIELD(POR_MPU_M7_PRLAR25_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR25_U_RNI_NID260, REGION25_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR25_U_RNI_NID260, REGION25_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR26_U_RNI_NID260, 0x2036db0)
    FIELD(POR_MPU_M7_PRBAR26_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR26_U_RNI_NID260, REGION26_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR26_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR26_U_RNI_NID260, REGION26_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR26_U_RNI_NID260, REGION26_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR26_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR26_U_RNI_NID260, 0x2036db8)
    FIELD(POR_MPU_M7_PRLAR26_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR26_U_RNI_NID260, REGION26_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR26_U_RNI_NID260, REGION26_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR27_U_RNI_NID260, 0x2036dc0)
    FIELD(POR_MPU_M7_PRBAR27_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR27_U_RNI_NID260, REGION27_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR27_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR27_U_RNI_NID260, REGION27_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR27_U_RNI_NID260, REGION27_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR27_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR27_U_RNI_NID260, 0x2036dc8)
    FIELD(POR_MPU_M7_PRLAR27_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR27_U_RNI_NID260, REGION27_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR27_U_RNI_NID260, REGION27_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR28_U_RNI_NID260, 0x2036dd0)
    FIELD(POR_MPU_M7_PRBAR28_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR28_U_RNI_NID260, REGION28_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR28_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR28_U_RNI_NID260, REGION28_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR28_U_RNI_NID260, REGION28_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR28_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR28_U_RNI_NID260, 0x2036dd8)
    FIELD(POR_MPU_M7_PRLAR28_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR28_U_RNI_NID260, REGION28_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR28_U_RNI_NID260, REGION28_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR29_U_RNI_NID260, 0x2036de0)
    FIELD(POR_MPU_M7_PRBAR29_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR29_U_RNI_NID260, REGION29_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR29_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR29_U_RNI_NID260, REGION29_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR29_U_RNI_NID260, REGION29_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR29_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR29_U_RNI_NID260, 0x2036de8)
    FIELD(POR_MPU_M7_PRLAR29_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR29_U_RNI_NID260, REGION29_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR29_U_RNI_NID260, REGION29_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR30_U_RNI_NID260, 0x2036df0)
    FIELD(POR_MPU_M7_PRBAR30_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR30_U_RNI_NID260, REGION30_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR30_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR30_U_RNI_NID260, REGION30_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR30_U_RNI_NID260, REGION30_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR30_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR30_U_RNI_NID260, 0x2036df8)
    FIELD(POR_MPU_M7_PRLAR30_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR30_U_RNI_NID260, REGION30_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR30_U_RNI_NID260, REGION30_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR31_U_RNI_NID260, 0x2036e00)
    FIELD(POR_MPU_M7_PRBAR31_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR31_U_RNI_NID260, REGION31_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR31_U_RNI_NID260, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR31_U_RNI_NID260, REGION31_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR31_U_RNI_NID260, REGION31_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR31_U_RNI_NID260, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR31_U_RNI_NID260, 0x2036e08)
    FIELD(POR_MPU_M7_PRLAR31_U_RNI_NID260, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR31_U_RNI_NID260, REGION31_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR31_U_RNI_NID260, REGION31_EN, 0, 1)
REG32(POR_MPU_NODE_INFO_U_SMXP_4_0, 0x203c000)
    FIELD(POR_MPU_NODE_INFO_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_NODE_INFO_U_SMXP_4_0, LOGICAL_ID, 32, 16)
    FIELD(POR_MPU_NODE_INFO_U_SMXP_4_0, NODE_ID, 16, 16)
    FIELD(POR_MPU_NODE_INFO_U_SMXP_4_0, NODE_TYPE, 0, 16)
REG32(POR_MPU_CHILD_INFO_U_SMXP_4_0, 0x203c080)
    FIELD(POR_MPU_CHILD_INFO_U_SMXP_4_0, RESERVED_32, 32, 32)
    FIELD(POR_MPU_CHILD_INFO_U_SMXP_4_0, CHILD_PTR_OFFSET, 16, 16)
    FIELD(POR_MPU_CHILD_INFO_U_SMXP_4_0, CHILD_COUNT, 0, 16)
REG32(POR_MPU_UNIT_INFO_U_SMXP_4_0, 0x203c900)
    FIELD(POR_MPU_UNIT_INFO_U_SMXP_4_0, RESERVED_16, 16, 48)
    FIELD(POR_MPU_UNIT_INFO_U_SMXP_4_0, MASTER_7_PRESENT, 15, 1)
    FIELD(POR_MPU_UNIT_INFO_U_SMXP_4_0, MASTER_6_PRESENT, 14, 1)
    FIELD(POR_MPU_UNIT_INFO_U_SMXP_4_0, MASTER_5_PRESENT, 13, 1)
    FIELD(POR_MPU_UNIT_INFO_U_SMXP_4_0, MASTER_4_PRESENT, 12, 1)
    FIELD(POR_MPU_UNIT_INFO_U_SMXP_4_0, MASTER_3_PRESENT, 11, 1)
    FIELD(POR_MPU_UNIT_INFO_U_SMXP_4_0, MASTER_2_PRESENT, 10, 1)
    FIELD(POR_MPU_UNIT_INFO_U_SMXP_4_0, MASTER_1_PRESENT, 9, 1)
    FIELD(POR_MPU_UNIT_INFO_U_SMXP_4_0, MASTER_0_PRESENT, 8, 1)
    FIELD(POR_MPU_UNIT_INFO_U_SMXP_4_0, NUM_PROG_REGION, 0, 8)
REG32(POR_MPU_M0_CTL_U_SMXP_4_0, 0x203d000)
    FIELD(POR_MPU_M0_CTL_U_SMXP_4_0, M0_EN, 2, 1)
    FIELD(POR_MPU_M0_CTL_U_SMXP_4_0, M0_ACTION, 0, 2)
REG32(POR_MPU_M0_PRBAR0_U_SMXP_4_0, 0x203d010)
    FIELD(POR_MPU_M0_PRBAR0_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR0_U_SMXP_4_0, REGION0_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR0_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR0_U_SMXP_4_0, REGION0_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR0_U_SMXP_4_0, REGION0_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR0_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR0_U_SMXP_4_0, 0x203d018)
    FIELD(POR_MPU_M0_PRLAR0_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR0_U_SMXP_4_0, REGION0_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR0_U_SMXP_4_0, REGION0_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR1_U_SMXP_4_0, 0x203d020)
    FIELD(POR_MPU_M0_PRBAR1_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR1_U_SMXP_4_0, REGION1_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR1_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR1_U_SMXP_4_0, REGION1_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR1_U_SMXP_4_0, REGION1_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR1_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR1_U_SMXP_4_0, 0x203d028)
    FIELD(POR_MPU_M0_PRLAR1_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR1_U_SMXP_4_0, REGION1_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR1_U_SMXP_4_0, REGION1_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR2_U_SMXP_4_0, 0x203d030)
    FIELD(POR_MPU_M0_PRBAR2_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR2_U_SMXP_4_0, REGION2_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR2_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR2_U_SMXP_4_0, REGION2_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR2_U_SMXP_4_0, REGION2_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR2_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR2_U_SMXP_4_0, 0x203d038)
    FIELD(POR_MPU_M0_PRLAR2_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR2_U_SMXP_4_0, REGION2_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR2_U_SMXP_4_0, REGION2_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR3_U_SMXP_4_0, 0x203d040)
    FIELD(POR_MPU_M0_PRBAR3_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR3_U_SMXP_4_0, REGION3_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR3_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR3_U_SMXP_4_0, REGION3_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR3_U_SMXP_4_0, REGION3_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR3_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR3_U_SMXP_4_0, 0x203d048)
    FIELD(POR_MPU_M0_PRLAR3_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR3_U_SMXP_4_0, REGION3_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR3_U_SMXP_4_0, REGION3_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR4_U_SMXP_4_0, 0x203d050)
    FIELD(POR_MPU_M0_PRBAR4_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR4_U_SMXP_4_0, REGION4_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR4_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR4_U_SMXP_4_0, REGION4_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR4_U_SMXP_4_0, REGION4_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR4_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR4_U_SMXP_4_0, 0x203d058)
    FIELD(POR_MPU_M0_PRLAR4_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR4_U_SMXP_4_0, REGION4_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR4_U_SMXP_4_0, REGION4_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR5_U_SMXP_4_0, 0x203d060)
    FIELD(POR_MPU_M0_PRBAR5_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR5_U_SMXP_4_0, REGION5_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR5_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR5_U_SMXP_4_0, REGION5_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR5_U_SMXP_4_0, REGION5_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR5_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR5_U_SMXP_4_0, 0x203d068)
    FIELD(POR_MPU_M0_PRLAR5_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR5_U_SMXP_4_0, REGION5_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR5_U_SMXP_4_0, REGION5_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR6_U_SMXP_4_0, 0x203d070)
    FIELD(POR_MPU_M0_PRBAR6_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR6_U_SMXP_4_0, REGION6_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR6_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR6_U_SMXP_4_0, REGION6_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR6_U_SMXP_4_0, REGION6_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR6_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR6_U_SMXP_4_0, 0x203d078)
    FIELD(POR_MPU_M0_PRLAR6_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR6_U_SMXP_4_0, REGION6_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR6_U_SMXP_4_0, REGION6_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR7_U_SMXP_4_0, 0x203d080)
    FIELD(POR_MPU_M0_PRBAR7_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR7_U_SMXP_4_0, REGION7_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR7_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR7_U_SMXP_4_0, REGION7_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR7_U_SMXP_4_0, REGION7_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR7_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR7_U_SMXP_4_0, 0x203d088)
    FIELD(POR_MPU_M0_PRLAR7_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR7_U_SMXP_4_0, REGION7_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR7_U_SMXP_4_0, REGION7_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR8_U_SMXP_4_0, 0x203d090)
    FIELD(POR_MPU_M0_PRBAR8_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR8_U_SMXP_4_0, REGION8_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR8_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR8_U_SMXP_4_0, REGION8_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR8_U_SMXP_4_0, REGION8_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR8_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR8_U_SMXP_4_0, 0x203d098)
    FIELD(POR_MPU_M0_PRLAR8_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR8_U_SMXP_4_0, REGION8_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR8_U_SMXP_4_0, REGION8_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR9_U_SMXP_4_0, 0x203d0a0)
    FIELD(POR_MPU_M0_PRBAR9_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR9_U_SMXP_4_0, REGION9_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR9_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR9_U_SMXP_4_0, REGION9_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR9_U_SMXP_4_0, REGION9_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR9_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR9_U_SMXP_4_0, 0x203d0a8)
    FIELD(POR_MPU_M0_PRLAR9_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR9_U_SMXP_4_0, REGION9_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR9_U_SMXP_4_0, REGION9_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR10_U_SMXP_4_0, 0x203d0b0)
    FIELD(POR_MPU_M0_PRBAR10_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR10_U_SMXP_4_0, REGION10_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR10_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR10_U_SMXP_4_0, REGION10_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR10_U_SMXP_4_0, REGION10_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR10_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR10_U_SMXP_4_0, 0x203d0b8)
    FIELD(POR_MPU_M0_PRLAR10_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR10_U_SMXP_4_0, REGION10_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR10_U_SMXP_4_0, REGION10_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR11_U_SMXP_4_0, 0x203d0c0)
    FIELD(POR_MPU_M0_PRBAR11_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR11_U_SMXP_4_0, REGION11_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR11_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR11_U_SMXP_4_0, REGION11_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR11_U_SMXP_4_0, REGION11_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR11_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR11_U_SMXP_4_0, 0x203d0c8)
    FIELD(POR_MPU_M0_PRLAR11_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR11_U_SMXP_4_0, REGION11_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR11_U_SMXP_4_0, REGION11_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR12_U_SMXP_4_0, 0x203d0d0)
    FIELD(POR_MPU_M0_PRBAR12_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR12_U_SMXP_4_0, REGION12_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR12_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR12_U_SMXP_4_0, REGION12_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR12_U_SMXP_4_0, REGION12_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR12_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR12_U_SMXP_4_0, 0x203d0d8)
    FIELD(POR_MPU_M0_PRLAR12_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR12_U_SMXP_4_0, REGION12_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR12_U_SMXP_4_0, REGION12_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR13_U_SMXP_4_0, 0x203d0e0)
    FIELD(POR_MPU_M0_PRBAR13_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR13_U_SMXP_4_0, REGION13_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR13_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR13_U_SMXP_4_0, REGION13_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR13_U_SMXP_4_0, REGION13_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR13_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR13_U_SMXP_4_0, 0x203d0e8)
    FIELD(POR_MPU_M0_PRLAR13_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR13_U_SMXP_4_0, REGION13_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR13_U_SMXP_4_0, REGION13_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR14_U_SMXP_4_0, 0x203d0f0)
    FIELD(POR_MPU_M0_PRBAR14_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR14_U_SMXP_4_0, REGION14_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR14_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR14_U_SMXP_4_0, REGION14_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR14_U_SMXP_4_0, REGION14_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR14_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR14_U_SMXP_4_0, 0x203d0f8)
    FIELD(POR_MPU_M0_PRLAR14_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR14_U_SMXP_4_0, REGION14_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR14_U_SMXP_4_0, REGION14_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR15_U_SMXP_4_0, 0x203d100)
    FIELD(POR_MPU_M0_PRBAR15_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR15_U_SMXP_4_0, REGION15_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR15_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR15_U_SMXP_4_0, REGION15_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR15_U_SMXP_4_0, REGION15_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR15_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR15_U_SMXP_4_0, 0x203d108)
    FIELD(POR_MPU_M0_PRLAR15_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR15_U_SMXP_4_0, REGION15_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR15_U_SMXP_4_0, REGION15_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR16_U_SMXP_4_0, 0x203d110)
    FIELD(POR_MPU_M0_PRBAR16_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR16_U_SMXP_4_0, REGION16_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR16_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR16_U_SMXP_4_0, REGION16_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR16_U_SMXP_4_0, REGION16_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR16_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR16_U_SMXP_4_0, 0x203d118)
    FIELD(POR_MPU_M0_PRLAR16_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR16_U_SMXP_4_0, REGION16_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR16_U_SMXP_4_0, REGION16_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR17_U_SMXP_4_0, 0x203d120)
    FIELD(POR_MPU_M0_PRBAR17_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR17_U_SMXP_4_0, REGION17_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR17_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR17_U_SMXP_4_0, REGION17_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR17_U_SMXP_4_0, REGION17_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR17_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR17_U_SMXP_4_0, 0x203d128)
    FIELD(POR_MPU_M0_PRLAR17_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR17_U_SMXP_4_0, REGION17_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR17_U_SMXP_4_0, REGION17_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR18_U_SMXP_4_0, 0x203d130)
    FIELD(POR_MPU_M0_PRBAR18_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR18_U_SMXP_4_0, REGION18_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR18_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR18_U_SMXP_4_0, REGION18_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR18_U_SMXP_4_0, REGION18_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR18_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR18_U_SMXP_4_0, 0x203d138)
    FIELD(POR_MPU_M0_PRLAR18_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR18_U_SMXP_4_0, REGION18_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR18_U_SMXP_4_0, REGION18_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR19_U_SMXP_4_0, 0x203d140)
    FIELD(POR_MPU_M0_PRBAR19_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR19_U_SMXP_4_0, REGION19_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR19_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR19_U_SMXP_4_0, REGION19_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR19_U_SMXP_4_0, REGION19_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR19_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR19_U_SMXP_4_0, 0x203d148)
    FIELD(POR_MPU_M0_PRLAR19_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR19_U_SMXP_4_0, REGION19_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR19_U_SMXP_4_0, REGION19_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR20_U_SMXP_4_0, 0x203d150)
    FIELD(POR_MPU_M0_PRBAR20_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR20_U_SMXP_4_0, REGION20_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR20_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR20_U_SMXP_4_0, REGION20_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR20_U_SMXP_4_0, REGION20_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR20_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR20_U_SMXP_4_0, 0x203d158)
    FIELD(POR_MPU_M0_PRLAR20_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR20_U_SMXP_4_0, REGION20_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR20_U_SMXP_4_0, REGION20_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR21_U_SMXP_4_0, 0x203d160)
    FIELD(POR_MPU_M0_PRBAR21_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR21_U_SMXP_4_0, REGION21_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR21_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR21_U_SMXP_4_0, REGION21_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR21_U_SMXP_4_0, REGION21_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR21_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR21_U_SMXP_4_0, 0x203d168)
    FIELD(POR_MPU_M0_PRLAR21_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR21_U_SMXP_4_0, REGION21_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR21_U_SMXP_4_0, REGION21_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR22_U_SMXP_4_0, 0x203d170)
    FIELD(POR_MPU_M0_PRBAR22_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR22_U_SMXP_4_0, REGION22_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR22_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR22_U_SMXP_4_0, REGION22_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR22_U_SMXP_4_0, REGION22_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR22_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR22_U_SMXP_4_0, 0x203d178)
    FIELD(POR_MPU_M0_PRLAR22_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR22_U_SMXP_4_0, REGION22_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR22_U_SMXP_4_0, REGION22_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR23_U_SMXP_4_0, 0x203d180)
    FIELD(POR_MPU_M0_PRBAR23_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR23_U_SMXP_4_0, REGION23_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR23_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR23_U_SMXP_4_0, REGION23_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR23_U_SMXP_4_0, REGION23_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR23_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR23_U_SMXP_4_0, 0x203d188)
    FIELD(POR_MPU_M0_PRLAR23_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR23_U_SMXP_4_0, REGION23_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR23_U_SMXP_4_0, REGION23_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR24_U_SMXP_4_0, 0x203d190)
    FIELD(POR_MPU_M0_PRBAR24_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR24_U_SMXP_4_0, REGION24_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR24_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR24_U_SMXP_4_0, REGION24_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR24_U_SMXP_4_0, REGION24_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR24_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR24_U_SMXP_4_0, 0x203d198)
    FIELD(POR_MPU_M0_PRLAR24_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR24_U_SMXP_4_0, REGION24_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR24_U_SMXP_4_0, REGION24_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR25_U_SMXP_4_0, 0x203d1a0)
    FIELD(POR_MPU_M0_PRBAR25_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR25_U_SMXP_4_0, REGION25_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR25_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR25_U_SMXP_4_0, REGION25_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR25_U_SMXP_4_0, REGION25_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR25_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR25_U_SMXP_4_0, 0x203d1a8)
    FIELD(POR_MPU_M0_PRLAR25_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR25_U_SMXP_4_0, REGION25_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR25_U_SMXP_4_0, REGION25_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR26_U_SMXP_4_0, 0x203d1b0)
    FIELD(POR_MPU_M0_PRBAR26_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR26_U_SMXP_4_0, REGION26_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR26_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR26_U_SMXP_4_0, REGION26_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR26_U_SMXP_4_0, REGION26_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR26_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR26_U_SMXP_4_0, 0x203d1b8)
    FIELD(POR_MPU_M0_PRLAR26_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR26_U_SMXP_4_0, REGION26_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR26_U_SMXP_4_0, REGION26_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR27_U_SMXP_4_0, 0x203d1c0)
    FIELD(POR_MPU_M0_PRBAR27_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR27_U_SMXP_4_0, REGION27_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR27_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR27_U_SMXP_4_0, REGION27_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR27_U_SMXP_4_0, REGION27_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR27_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR27_U_SMXP_4_0, 0x203d1c8)
    FIELD(POR_MPU_M0_PRLAR27_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR27_U_SMXP_4_0, REGION27_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR27_U_SMXP_4_0, REGION27_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR28_U_SMXP_4_0, 0x203d1d0)
    FIELD(POR_MPU_M0_PRBAR28_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR28_U_SMXP_4_0, REGION28_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR28_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR28_U_SMXP_4_0, REGION28_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR28_U_SMXP_4_0, REGION28_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR28_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR28_U_SMXP_4_0, 0x203d1d8)
    FIELD(POR_MPU_M0_PRLAR28_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR28_U_SMXP_4_0, REGION28_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR28_U_SMXP_4_0, REGION28_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR29_U_SMXP_4_0, 0x203d1e0)
    FIELD(POR_MPU_M0_PRBAR29_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR29_U_SMXP_4_0, REGION29_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR29_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR29_U_SMXP_4_0, REGION29_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR29_U_SMXP_4_0, REGION29_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR29_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR29_U_SMXP_4_0, 0x203d1e8)
    FIELD(POR_MPU_M0_PRLAR29_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR29_U_SMXP_4_0, REGION29_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR29_U_SMXP_4_0, REGION29_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR30_U_SMXP_4_0, 0x203d1f0)
    FIELD(POR_MPU_M0_PRBAR30_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR30_U_SMXP_4_0, REGION30_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR30_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR30_U_SMXP_4_0, REGION30_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR30_U_SMXP_4_0, REGION30_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR30_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR30_U_SMXP_4_0, 0x203d1f8)
    FIELD(POR_MPU_M0_PRLAR30_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR30_U_SMXP_4_0, REGION30_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR30_U_SMXP_4_0, REGION30_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR31_U_SMXP_4_0, 0x203d200)
    FIELD(POR_MPU_M0_PRBAR31_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR31_U_SMXP_4_0, REGION31_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR31_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR31_U_SMXP_4_0, REGION31_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR31_U_SMXP_4_0, REGION31_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR31_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR31_U_SMXP_4_0, 0x203d208)
    FIELD(POR_MPU_M0_PRLAR31_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR31_U_SMXP_4_0, REGION31_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR31_U_SMXP_4_0, REGION31_EN, 0, 1)
REG32(POR_MPU_M1_CTL_U_SMXP_4_0, 0x203d400)
    FIELD(POR_MPU_M1_CTL_U_SMXP_4_0, M1_EN, 2, 1)
    FIELD(POR_MPU_M1_CTL_U_SMXP_4_0, M1_ACTION, 0, 2)
REG32(POR_MPU_M1_PRBAR0_U_SMXP_4_0, 0x203d410)
    FIELD(POR_MPU_M1_PRBAR0_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR0_U_SMXP_4_0, REGION0_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR0_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR0_U_SMXP_4_0, REGION0_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR0_U_SMXP_4_0, REGION0_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR0_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR0_U_SMXP_4_0, 0x203d418)
    FIELD(POR_MPU_M1_PRLAR0_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR0_U_SMXP_4_0, REGION0_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR0_U_SMXP_4_0, REGION0_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR1_U_SMXP_4_0, 0x203d420)
    FIELD(POR_MPU_M1_PRBAR1_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR1_U_SMXP_4_0, REGION1_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR1_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR1_U_SMXP_4_0, REGION1_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR1_U_SMXP_4_0, REGION1_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR1_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR1_U_SMXP_4_0, 0x203d428)
    FIELD(POR_MPU_M1_PRLAR1_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR1_U_SMXP_4_0, REGION1_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR1_U_SMXP_4_0, REGION1_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR2_U_SMXP_4_0, 0x203d430)
    FIELD(POR_MPU_M1_PRBAR2_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR2_U_SMXP_4_0, REGION2_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR2_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR2_U_SMXP_4_0, REGION2_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR2_U_SMXP_4_0, REGION2_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR2_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR2_U_SMXP_4_0, 0x203d438)
    FIELD(POR_MPU_M1_PRLAR2_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR2_U_SMXP_4_0, REGION2_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR2_U_SMXP_4_0, REGION2_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR3_U_SMXP_4_0, 0x203d440)
    FIELD(POR_MPU_M1_PRBAR3_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR3_U_SMXP_4_0, REGION3_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR3_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR3_U_SMXP_4_0, REGION3_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR3_U_SMXP_4_0, REGION3_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR3_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR3_U_SMXP_4_0, 0x203d448)
    FIELD(POR_MPU_M1_PRLAR3_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR3_U_SMXP_4_0, REGION3_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR3_U_SMXP_4_0, REGION3_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR4_U_SMXP_4_0, 0x203d450)
    FIELD(POR_MPU_M1_PRBAR4_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR4_U_SMXP_4_0, REGION4_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR4_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR4_U_SMXP_4_0, REGION4_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR4_U_SMXP_4_0, REGION4_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR4_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR4_U_SMXP_4_0, 0x203d458)
    FIELD(POR_MPU_M1_PRLAR4_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR4_U_SMXP_4_0, REGION4_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR4_U_SMXP_4_0, REGION4_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR5_U_SMXP_4_0, 0x203d460)
    FIELD(POR_MPU_M1_PRBAR5_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR5_U_SMXP_4_0, REGION5_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR5_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR5_U_SMXP_4_0, REGION5_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR5_U_SMXP_4_0, REGION5_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR5_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR5_U_SMXP_4_0, 0x203d468)
    FIELD(POR_MPU_M1_PRLAR5_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR5_U_SMXP_4_0, REGION5_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR5_U_SMXP_4_0, REGION5_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR6_U_SMXP_4_0, 0x203d470)
    FIELD(POR_MPU_M1_PRBAR6_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR6_U_SMXP_4_0, REGION6_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR6_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR6_U_SMXP_4_0, REGION6_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR6_U_SMXP_4_0, REGION6_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR6_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR6_U_SMXP_4_0, 0x203d478)
    FIELD(POR_MPU_M1_PRLAR6_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR6_U_SMXP_4_0, REGION6_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR6_U_SMXP_4_0, REGION6_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR7_U_SMXP_4_0, 0x203d480)
    FIELD(POR_MPU_M1_PRBAR7_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR7_U_SMXP_4_0, REGION7_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR7_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR7_U_SMXP_4_0, REGION7_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR7_U_SMXP_4_0, REGION7_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR7_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR7_U_SMXP_4_0, 0x203d488)
    FIELD(POR_MPU_M1_PRLAR7_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR7_U_SMXP_4_0, REGION7_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR7_U_SMXP_4_0, REGION7_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR8_U_SMXP_4_0, 0x203d490)
    FIELD(POR_MPU_M1_PRBAR8_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR8_U_SMXP_4_0, REGION8_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR8_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR8_U_SMXP_4_0, REGION8_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR8_U_SMXP_4_0, REGION8_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR8_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR8_U_SMXP_4_0, 0x203d498)
    FIELD(POR_MPU_M1_PRLAR8_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR8_U_SMXP_4_0, REGION8_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR8_U_SMXP_4_0, REGION8_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR9_U_SMXP_4_0, 0x203d4a0)
    FIELD(POR_MPU_M1_PRBAR9_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR9_U_SMXP_4_0, REGION9_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR9_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR9_U_SMXP_4_0, REGION9_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR9_U_SMXP_4_0, REGION9_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR9_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR9_U_SMXP_4_0, 0x203d4a8)
    FIELD(POR_MPU_M1_PRLAR9_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR9_U_SMXP_4_0, REGION9_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR9_U_SMXP_4_0, REGION9_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR10_U_SMXP_4_0, 0x203d4b0)
    FIELD(POR_MPU_M1_PRBAR10_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR10_U_SMXP_4_0, REGION10_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR10_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR10_U_SMXP_4_0, REGION10_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR10_U_SMXP_4_0, REGION10_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR10_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR10_U_SMXP_4_0, 0x203d4b8)
    FIELD(POR_MPU_M1_PRLAR10_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR10_U_SMXP_4_0, REGION10_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR10_U_SMXP_4_0, REGION10_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR11_U_SMXP_4_0, 0x203d4c0)
    FIELD(POR_MPU_M1_PRBAR11_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR11_U_SMXP_4_0, REGION11_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR11_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR11_U_SMXP_4_0, REGION11_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR11_U_SMXP_4_0, REGION11_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR11_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR11_U_SMXP_4_0, 0x203d4c8)
    FIELD(POR_MPU_M1_PRLAR11_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR11_U_SMXP_4_0, REGION11_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR11_U_SMXP_4_0, REGION11_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR12_U_SMXP_4_0, 0x203d4d0)
    FIELD(POR_MPU_M1_PRBAR12_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR12_U_SMXP_4_0, REGION12_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR12_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR12_U_SMXP_4_0, REGION12_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR12_U_SMXP_4_0, REGION12_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR12_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR12_U_SMXP_4_0, 0x203d4d8)
    FIELD(POR_MPU_M1_PRLAR12_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR12_U_SMXP_4_0, REGION12_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR12_U_SMXP_4_0, REGION12_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR13_U_SMXP_4_0, 0x203d4e0)
    FIELD(POR_MPU_M1_PRBAR13_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR13_U_SMXP_4_0, REGION13_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR13_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR13_U_SMXP_4_0, REGION13_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR13_U_SMXP_4_0, REGION13_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR13_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR13_U_SMXP_4_0, 0x203d4e8)
    FIELD(POR_MPU_M1_PRLAR13_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR13_U_SMXP_4_0, REGION13_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR13_U_SMXP_4_0, REGION13_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR14_U_SMXP_4_0, 0x203d4f0)
    FIELD(POR_MPU_M1_PRBAR14_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR14_U_SMXP_4_0, REGION14_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR14_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR14_U_SMXP_4_0, REGION14_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR14_U_SMXP_4_0, REGION14_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR14_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR14_U_SMXP_4_0, 0x203d4f8)
    FIELD(POR_MPU_M1_PRLAR14_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR14_U_SMXP_4_0, REGION14_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR14_U_SMXP_4_0, REGION14_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR15_U_SMXP_4_0, 0x203d500)
    FIELD(POR_MPU_M1_PRBAR15_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR15_U_SMXP_4_0, REGION15_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR15_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR15_U_SMXP_4_0, REGION15_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR15_U_SMXP_4_0, REGION15_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR15_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR15_U_SMXP_4_0, 0x203d508)
    FIELD(POR_MPU_M1_PRLAR15_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR15_U_SMXP_4_0, REGION15_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR15_U_SMXP_4_0, REGION15_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR16_U_SMXP_4_0, 0x203d510)
    FIELD(POR_MPU_M1_PRBAR16_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR16_U_SMXP_4_0, REGION16_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR16_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR16_U_SMXP_4_0, REGION16_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR16_U_SMXP_4_0, REGION16_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR16_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR16_U_SMXP_4_0, 0x203d518)
    FIELD(POR_MPU_M1_PRLAR16_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR16_U_SMXP_4_0, REGION16_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR16_U_SMXP_4_0, REGION16_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR17_U_SMXP_4_0, 0x203d520)
    FIELD(POR_MPU_M1_PRBAR17_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR17_U_SMXP_4_0, REGION17_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR17_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR17_U_SMXP_4_0, REGION17_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR17_U_SMXP_4_0, REGION17_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR17_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR17_U_SMXP_4_0, 0x203d528)
    FIELD(POR_MPU_M1_PRLAR17_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR17_U_SMXP_4_0, REGION17_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR17_U_SMXP_4_0, REGION17_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR18_U_SMXP_4_0, 0x203d530)
    FIELD(POR_MPU_M1_PRBAR18_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR18_U_SMXP_4_0, REGION18_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR18_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR18_U_SMXP_4_0, REGION18_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR18_U_SMXP_4_0, REGION18_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR18_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR18_U_SMXP_4_0, 0x203d538)
    FIELD(POR_MPU_M1_PRLAR18_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR18_U_SMXP_4_0, REGION18_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR18_U_SMXP_4_0, REGION18_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR19_U_SMXP_4_0, 0x203d540)
    FIELD(POR_MPU_M1_PRBAR19_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR19_U_SMXP_4_0, REGION19_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR19_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR19_U_SMXP_4_0, REGION19_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR19_U_SMXP_4_0, REGION19_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR19_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR19_U_SMXP_4_0, 0x203d548)
    FIELD(POR_MPU_M1_PRLAR19_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR19_U_SMXP_4_0, REGION19_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR19_U_SMXP_4_0, REGION19_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR20_U_SMXP_4_0, 0x203d550)
    FIELD(POR_MPU_M1_PRBAR20_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR20_U_SMXP_4_0, REGION20_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR20_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR20_U_SMXP_4_0, REGION20_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR20_U_SMXP_4_0, REGION20_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR20_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR20_U_SMXP_4_0, 0x203d558)
    FIELD(POR_MPU_M1_PRLAR20_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR20_U_SMXP_4_0, REGION20_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR20_U_SMXP_4_0, REGION20_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR21_U_SMXP_4_0, 0x203d560)
    FIELD(POR_MPU_M1_PRBAR21_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR21_U_SMXP_4_0, REGION21_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR21_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR21_U_SMXP_4_0, REGION21_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR21_U_SMXP_4_0, REGION21_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR21_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR21_U_SMXP_4_0, 0x203d568)
    FIELD(POR_MPU_M1_PRLAR21_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR21_U_SMXP_4_0, REGION21_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR21_U_SMXP_4_0, REGION21_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR22_U_SMXP_4_0, 0x203d570)
    FIELD(POR_MPU_M1_PRBAR22_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR22_U_SMXP_4_0, REGION22_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR22_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR22_U_SMXP_4_0, REGION22_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR22_U_SMXP_4_0, REGION22_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR22_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR22_U_SMXP_4_0, 0x203d578)
    FIELD(POR_MPU_M1_PRLAR22_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR22_U_SMXP_4_0, REGION22_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR22_U_SMXP_4_0, REGION22_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR23_U_SMXP_4_0, 0x203d580)
    FIELD(POR_MPU_M1_PRBAR23_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR23_U_SMXP_4_0, REGION23_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR23_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR23_U_SMXP_4_0, REGION23_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR23_U_SMXP_4_0, REGION23_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR23_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR23_U_SMXP_4_0, 0x203d588)
    FIELD(POR_MPU_M1_PRLAR23_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR23_U_SMXP_4_0, REGION23_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR23_U_SMXP_4_0, REGION23_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR24_U_SMXP_4_0, 0x203d590)
    FIELD(POR_MPU_M1_PRBAR24_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR24_U_SMXP_4_0, REGION24_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR24_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR24_U_SMXP_4_0, REGION24_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR24_U_SMXP_4_0, REGION24_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR24_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR24_U_SMXP_4_0, 0x203d598)
    FIELD(POR_MPU_M1_PRLAR24_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR24_U_SMXP_4_0, REGION24_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR24_U_SMXP_4_0, REGION24_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR25_U_SMXP_4_0, 0x203d5a0)
    FIELD(POR_MPU_M1_PRBAR25_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR25_U_SMXP_4_0, REGION25_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR25_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR25_U_SMXP_4_0, REGION25_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR25_U_SMXP_4_0, REGION25_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR25_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR25_U_SMXP_4_0, 0x203d5a8)
    FIELD(POR_MPU_M1_PRLAR25_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR25_U_SMXP_4_0, REGION25_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR25_U_SMXP_4_0, REGION25_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR26_U_SMXP_4_0, 0x203d5b0)
    FIELD(POR_MPU_M1_PRBAR26_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR26_U_SMXP_4_0, REGION26_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR26_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR26_U_SMXP_4_0, REGION26_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR26_U_SMXP_4_0, REGION26_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR26_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR26_U_SMXP_4_0, 0x203d5b8)
    FIELD(POR_MPU_M1_PRLAR26_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR26_U_SMXP_4_0, REGION26_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR26_U_SMXP_4_0, REGION26_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR27_U_SMXP_4_0, 0x203d5c0)
    FIELD(POR_MPU_M1_PRBAR27_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR27_U_SMXP_4_0, REGION27_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR27_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR27_U_SMXP_4_0, REGION27_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR27_U_SMXP_4_0, REGION27_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR27_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR27_U_SMXP_4_0, 0x203d5c8)
    FIELD(POR_MPU_M1_PRLAR27_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR27_U_SMXP_4_0, REGION27_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR27_U_SMXP_4_0, REGION27_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR28_U_SMXP_4_0, 0x203d5d0)
    FIELD(POR_MPU_M1_PRBAR28_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR28_U_SMXP_4_0, REGION28_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR28_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR28_U_SMXP_4_0, REGION28_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR28_U_SMXP_4_0, REGION28_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR28_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR28_U_SMXP_4_0, 0x203d5d8)
    FIELD(POR_MPU_M1_PRLAR28_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR28_U_SMXP_4_0, REGION28_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR28_U_SMXP_4_0, REGION28_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR29_U_SMXP_4_0, 0x203d5e0)
    FIELD(POR_MPU_M1_PRBAR29_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR29_U_SMXP_4_0, REGION29_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR29_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR29_U_SMXP_4_0, REGION29_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR29_U_SMXP_4_0, REGION29_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR29_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR29_U_SMXP_4_0, 0x203d5e8)
    FIELD(POR_MPU_M1_PRLAR29_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR29_U_SMXP_4_0, REGION29_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR29_U_SMXP_4_0, REGION29_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR30_U_SMXP_4_0, 0x203d5f0)
    FIELD(POR_MPU_M1_PRBAR30_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR30_U_SMXP_4_0, REGION30_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR30_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR30_U_SMXP_4_0, REGION30_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR30_U_SMXP_4_0, REGION30_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR30_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR30_U_SMXP_4_0, 0x203d5f8)
    FIELD(POR_MPU_M1_PRLAR30_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR30_U_SMXP_4_0, REGION30_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR30_U_SMXP_4_0, REGION30_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR31_U_SMXP_4_0, 0x203d600)
    FIELD(POR_MPU_M1_PRBAR31_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR31_U_SMXP_4_0, REGION31_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR31_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR31_U_SMXP_4_0, REGION31_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR31_U_SMXP_4_0, REGION31_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR31_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR31_U_SMXP_4_0, 0x203d608)
    FIELD(POR_MPU_M1_PRLAR31_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR31_U_SMXP_4_0, REGION31_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR31_U_SMXP_4_0, REGION31_EN, 0, 1)
REG32(POR_MPU_M2_CTL_U_SMXP_4_0, 0x203d800)
    FIELD(POR_MPU_M2_CTL_U_SMXP_4_0, M2_EN, 2, 1)
    FIELD(POR_MPU_M2_CTL_U_SMXP_4_0, M2_ACTION, 0, 2)
REG32(POR_MPU_M2_PRBAR0_U_SMXP_4_0, 0x203d810)
    FIELD(POR_MPU_M2_PRBAR0_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR0_U_SMXP_4_0, REGION0_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR0_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR0_U_SMXP_4_0, REGION0_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR0_U_SMXP_4_0, REGION0_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR0_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR0_U_SMXP_4_0, 0x203d818)
    FIELD(POR_MPU_M2_PRLAR0_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR0_U_SMXP_4_0, REGION0_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR0_U_SMXP_4_0, REGION0_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR1_U_SMXP_4_0, 0x203d820)
    FIELD(POR_MPU_M2_PRBAR1_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR1_U_SMXP_4_0, REGION1_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR1_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR1_U_SMXP_4_0, REGION1_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR1_U_SMXP_4_0, REGION1_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR1_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR1_U_SMXP_4_0, 0x203d828)
    FIELD(POR_MPU_M2_PRLAR1_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR1_U_SMXP_4_0, REGION1_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR1_U_SMXP_4_0, REGION1_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR2_U_SMXP_4_0, 0x203d830)
    FIELD(POR_MPU_M2_PRBAR2_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR2_U_SMXP_4_0, REGION2_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR2_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR2_U_SMXP_4_0, REGION2_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR2_U_SMXP_4_0, REGION2_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR2_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR2_U_SMXP_4_0, 0x203d838)
    FIELD(POR_MPU_M2_PRLAR2_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR2_U_SMXP_4_0, REGION2_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR2_U_SMXP_4_0, REGION2_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR3_U_SMXP_4_0, 0x203d840)
    FIELD(POR_MPU_M2_PRBAR3_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR3_U_SMXP_4_0, REGION3_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR3_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR3_U_SMXP_4_0, REGION3_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR3_U_SMXP_4_0, REGION3_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR3_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR3_U_SMXP_4_0, 0x203d848)
    FIELD(POR_MPU_M2_PRLAR3_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR3_U_SMXP_4_0, REGION3_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR3_U_SMXP_4_0, REGION3_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR4_U_SMXP_4_0, 0x203d850)
    FIELD(POR_MPU_M2_PRBAR4_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR4_U_SMXP_4_0, REGION4_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR4_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR4_U_SMXP_4_0, REGION4_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR4_U_SMXP_4_0, REGION4_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR4_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR4_U_SMXP_4_0, 0x203d858)
    FIELD(POR_MPU_M2_PRLAR4_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR4_U_SMXP_4_0, REGION4_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR4_U_SMXP_4_0, REGION4_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR5_U_SMXP_4_0, 0x203d860)
    FIELD(POR_MPU_M2_PRBAR5_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR5_U_SMXP_4_0, REGION5_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR5_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR5_U_SMXP_4_0, REGION5_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR5_U_SMXP_4_0, REGION5_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR5_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR5_U_SMXP_4_0, 0x203d868)
    FIELD(POR_MPU_M2_PRLAR5_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR5_U_SMXP_4_0, REGION5_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR5_U_SMXP_4_0, REGION5_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR6_U_SMXP_4_0, 0x203d870)
    FIELD(POR_MPU_M2_PRBAR6_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR6_U_SMXP_4_0, REGION6_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR6_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR6_U_SMXP_4_0, REGION6_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR6_U_SMXP_4_0, REGION6_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR6_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR6_U_SMXP_4_0, 0x203d878)
    FIELD(POR_MPU_M2_PRLAR6_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR6_U_SMXP_4_0, REGION6_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR6_U_SMXP_4_0, REGION6_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR7_U_SMXP_4_0, 0x203d880)
    FIELD(POR_MPU_M2_PRBAR7_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR7_U_SMXP_4_0, REGION7_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR7_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR7_U_SMXP_4_0, REGION7_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR7_U_SMXP_4_0, REGION7_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR7_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR7_U_SMXP_4_0, 0x203d888)
    FIELD(POR_MPU_M2_PRLAR7_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR7_U_SMXP_4_0, REGION7_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR7_U_SMXP_4_0, REGION7_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR8_U_SMXP_4_0, 0x203d890)
    FIELD(POR_MPU_M2_PRBAR8_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR8_U_SMXP_4_0, REGION8_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR8_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR8_U_SMXP_4_0, REGION8_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR8_U_SMXP_4_0, REGION8_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR8_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR8_U_SMXP_4_0, 0x203d898)
    FIELD(POR_MPU_M2_PRLAR8_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR8_U_SMXP_4_0, REGION8_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR8_U_SMXP_4_0, REGION8_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR9_U_SMXP_4_0, 0x203d8a0)
    FIELD(POR_MPU_M2_PRBAR9_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR9_U_SMXP_4_0, REGION9_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR9_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR9_U_SMXP_4_0, REGION9_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR9_U_SMXP_4_0, REGION9_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR9_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR9_U_SMXP_4_0, 0x203d8a8)
    FIELD(POR_MPU_M2_PRLAR9_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR9_U_SMXP_4_0, REGION9_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR9_U_SMXP_4_0, REGION9_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR10_U_SMXP_4_0, 0x203d8b0)
    FIELD(POR_MPU_M2_PRBAR10_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR10_U_SMXP_4_0, REGION10_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR10_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR10_U_SMXP_4_0, REGION10_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR10_U_SMXP_4_0, REGION10_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR10_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR10_U_SMXP_4_0, 0x203d8b8)
    FIELD(POR_MPU_M2_PRLAR10_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR10_U_SMXP_4_0, REGION10_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR10_U_SMXP_4_0, REGION10_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR11_U_SMXP_4_0, 0x203d8c0)
    FIELD(POR_MPU_M2_PRBAR11_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR11_U_SMXP_4_0, REGION11_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR11_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR11_U_SMXP_4_0, REGION11_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR11_U_SMXP_4_0, REGION11_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR11_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR11_U_SMXP_4_0, 0x203d8c8)
    FIELD(POR_MPU_M2_PRLAR11_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR11_U_SMXP_4_0, REGION11_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR11_U_SMXP_4_0, REGION11_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR12_U_SMXP_4_0, 0x203d8d0)
    FIELD(POR_MPU_M2_PRBAR12_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR12_U_SMXP_4_0, REGION12_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR12_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR12_U_SMXP_4_0, REGION12_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR12_U_SMXP_4_0, REGION12_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR12_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR12_U_SMXP_4_0, 0x203d8d8)
    FIELD(POR_MPU_M2_PRLAR12_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR12_U_SMXP_4_0, REGION12_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR12_U_SMXP_4_0, REGION12_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR13_U_SMXP_4_0, 0x203d8e0)
    FIELD(POR_MPU_M2_PRBAR13_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR13_U_SMXP_4_0, REGION13_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR13_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR13_U_SMXP_4_0, REGION13_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR13_U_SMXP_4_0, REGION13_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR13_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR13_U_SMXP_4_0, 0x203d8e8)
    FIELD(POR_MPU_M2_PRLAR13_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR13_U_SMXP_4_0, REGION13_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR13_U_SMXP_4_0, REGION13_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR14_U_SMXP_4_0, 0x203d8f0)
    FIELD(POR_MPU_M2_PRBAR14_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR14_U_SMXP_4_0, REGION14_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR14_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR14_U_SMXP_4_0, REGION14_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR14_U_SMXP_4_0, REGION14_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR14_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR14_U_SMXP_4_0, 0x203d8f8)
    FIELD(POR_MPU_M2_PRLAR14_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR14_U_SMXP_4_0, REGION14_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR14_U_SMXP_4_0, REGION14_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR15_U_SMXP_4_0, 0x203d900)
    FIELD(POR_MPU_M2_PRBAR15_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR15_U_SMXP_4_0, REGION15_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR15_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR15_U_SMXP_4_0, REGION15_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR15_U_SMXP_4_0, REGION15_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR15_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR15_U_SMXP_4_0, 0x203d908)
    FIELD(POR_MPU_M2_PRLAR15_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR15_U_SMXP_4_0, REGION15_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR15_U_SMXP_4_0, REGION15_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR16_U_SMXP_4_0, 0x203d910)
    FIELD(POR_MPU_M2_PRBAR16_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR16_U_SMXP_4_0, REGION16_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR16_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR16_U_SMXP_4_0, REGION16_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR16_U_SMXP_4_0, REGION16_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR16_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR16_U_SMXP_4_0, 0x203d918)
    FIELD(POR_MPU_M2_PRLAR16_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR16_U_SMXP_4_0, REGION16_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR16_U_SMXP_4_0, REGION16_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR17_U_SMXP_4_0, 0x203d920)
    FIELD(POR_MPU_M2_PRBAR17_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR17_U_SMXP_4_0, REGION17_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR17_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR17_U_SMXP_4_0, REGION17_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR17_U_SMXP_4_0, REGION17_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR17_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR17_U_SMXP_4_0, 0x203d928)
    FIELD(POR_MPU_M2_PRLAR17_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR17_U_SMXP_4_0, REGION17_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR17_U_SMXP_4_0, REGION17_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR18_U_SMXP_4_0, 0x203d930)
    FIELD(POR_MPU_M2_PRBAR18_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR18_U_SMXP_4_0, REGION18_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR18_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR18_U_SMXP_4_0, REGION18_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR18_U_SMXP_4_0, REGION18_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR18_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR18_U_SMXP_4_0, 0x203d938)
    FIELD(POR_MPU_M2_PRLAR18_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR18_U_SMXP_4_0, REGION18_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR18_U_SMXP_4_0, REGION18_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR19_U_SMXP_4_0, 0x203d940)
    FIELD(POR_MPU_M2_PRBAR19_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR19_U_SMXP_4_0, REGION19_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR19_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR19_U_SMXP_4_0, REGION19_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR19_U_SMXP_4_0, REGION19_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR19_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR19_U_SMXP_4_0, 0x203d948)
    FIELD(POR_MPU_M2_PRLAR19_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR19_U_SMXP_4_0, REGION19_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR19_U_SMXP_4_0, REGION19_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR20_U_SMXP_4_0, 0x203d950)
    FIELD(POR_MPU_M2_PRBAR20_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR20_U_SMXP_4_0, REGION20_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR20_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR20_U_SMXP_4_0, REGION20_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR20_U_SMXP_4_0, REGION20_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR20_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR20_U_SMXP_4_0, 0x203d958)
    FIELD(POR_MPU_M2_PRLAR20_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR20_U_SMXP_4_0, REGION20_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR20_U_SMXP_4_0, REGION20_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR21_U_SMXP_4_0, 0x203d960)
    FIELD(POR_MPU_M2_PRBAR21_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR21_U_SMXP_4_0, REGION21_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR21_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR21_U_SMXP_4_0, REGION21_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR21_U_SMXP_4_0, REGION21_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR21_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR21_U_SMXP_4_0, 0x203d968)
    FIELD(POR_MPU_M2_PRLAR21_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR21_U_SMXP_4_0, REGION21_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR21_U_SMXP_4_0, REGION21_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR22_U_SMXP_4_0, 0x203d970)
    FIELD(POR_MPU_M2_PRBAR22_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR22_U_SMXP_4_0, REGION22_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR22_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR22_U_SMXP_4_0, REGION22_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR22_U_SMXP_4_0, REGION22_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR22_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR22_U_SMXP_4_0, 0x203d978)
    FIELD(POR_MPU_M2_PRLAR22_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR22_U_SMXP_4_0, REGION22_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR22_U_SMXP_4_0, REGION22_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR23_U_SMXP_4_0, 0x203d980)
    FIELD(POR_MPU_M2_PRBAR23_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR23_U_SMXP_4_0, REGION23_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR23_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR23_U_SMXP_4_0, REGION23_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR23_U_SMXP_4_0, REGION23_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR23_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR23_U_SMXP_4_0, 0x203d988)
    FIELD(POR_MPU_M2_PRLAR23_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR23_U_SMXP_4_0, REGION23_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR23_U_SMXP_4_0, REGION23_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR24_U_SMXP_4_0, 0x203d990)
    FIELD(POR_MPU_M2_PRBAR24_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR24_U_SMXP_4_0, REGION24_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR24_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR24_U_SMXP_4_0, REGION24_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR24_U_SMXP_4_0, REGION24_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR24_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR24_U_SMXP_4_0, 0x203d998)
    FIELD(POR_MPU_M2_PRLAR24_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR24_U_SMXP_4_0, REGION24_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR24_U_SMXP_4_0, REGION24_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR25_U_SMXP_4_0, 0x203d9a0)
    FIELD(POR_MPU_M2_PRBAR25_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR25_U_SMXP_4_0, REGION25_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR25_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR25_U_SMXP_4_0, REGION25_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR25_U_SMXP_4_0, REGION25_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR25_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR25_U_SMXP_4_0, 0x203d9a8)
    FIELD(POR_MPU_M2_PRLAR25_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR25_U_SMXP_4_0, REGION25_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR25_U_SMXP_4_0, REGION25_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR26_U_SMXP_4_0, 0x203d9b0)
    FIELD(POR_MPU_M2_PRBAR26_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR26_U_SMXP_4_0, REGION26_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR26_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR26_U_SMXP_4_0, REGION26_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR26_U_SMXP_4_0, REGION26_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR26_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR26_U_SMXP_4_0, 0x203d9b8)
    FIELD(POR_MPU_M2_PRLAR26_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR26_U_SMXP_4_0, REGION26_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR26_U_SMXP_4_0, REGION26_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR27_U_SMXP_4_0, 0x203d9c0)
    FIELD(POR_MPU_M2_PRBAR27_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR27_U_SMXP_4_0, REGION27_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR27_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR27_U_SMXP_4_0, REGION27_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR27_U_SMXP_4_0, REGION27_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR27_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR27_U_SMXP_4_0, 0x203d9c8)
    FIELD(POR_MPU_M2_PRLAR27_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR27_U_SMXP_4_0, REGION27_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR27_U_SMXP_4_0, REGION27_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR28_U_SMXP_4_0, 0x203d9d0)
    FIELD(POR_MPU_M2_PRBAR28_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR28_U_SMXP_4_0, REGION28_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR28_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR28_U_SMXP_4_0, REGION28_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR28_U_SMXP_4_0, REGION28_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR28_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR28_U_SMXP_4_0, 0x203d9d8)
    FIELD(POR_MPU_M2_PRLAR28_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR28_U_SMXP_4_0, REGION28_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR28_U_SMXP_4_0, REGION28_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR29_U_SMXP_4_0, 0x203d9e0)
    FIELD(POR_MPU_M2_PRBAR29_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR29_U_SMXP_4_0, REGION29_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR29_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR29_U_SMXP_4_0, REGION29_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR29_U_SMXP_4_0, REGION29_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR29_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR29_U_SMXP_4_0, 0x203d9e8)
    FIELD(POR_MPU_M2_PRLAR29_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR29_U_SMXP_4_0, REGION29_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR29_U_SMXP_4_0, REGION29_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR30_U_SMXP_4_0, 0x203d9f0)
    FIELD(POR_MPU_M2_PRBAR30_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR30_U_SMXP_4_0, REGION30_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR30_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR30_U_SMXP_4_0, REGION30_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR30_U_SMXP_4_0, REGION30_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR30_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR30_U_SMXP_4_0, 0x203d9f8)
    FIELD(POR_MPU_M2_PRLAR30_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR30_U_SMXP_4_0, REGION30_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR30_U_SMXP_4_0, REGION30_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR31_U_SMXP_4_0, 0x203da00)
    FIELD(POR_MPU_M2_PRBAR31_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR31_U_SMXP_4_0, REGION31_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR31_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR31_U_SMXP_4_0, REGION31_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR31_U_SMXP_4_0, REGION31_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR31_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR31_U_SMXP_4_0, 0x203da08)
    FIELD(POR_MPU_M2_PRLAR31_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR31_U_SMXP_4_0, REGION31_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR31_U_SMXP_4_0, REGION31_EN, 0, 1)
REG32(POR_MPU_M3_CTL_U_SMXP_4_0, 0x203dc00)
    FIELD(POR_MPU_M3_CTL_U_SMXP_4_0, M3_EN, 2, 1)
    FIELD(POR_MPU_M3_CTL_U_SMXP_4_0, M3_ACTION, 0, 2)
REG32(POR_MPU_M3_PRBAR0_U_SMXP_4_0, 0x203dc10)
    FIELD(POR_MPU_M3_PRBAR0_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR0_U_SMXP_4_0, REGION0_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR0_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR0_U_SMXP_4_0, REGION0_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR0_U_SMXP_4_0, REGION0_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR0_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR0_U_SMXP_4_0, 0x203dc18)
    FIELD(POR_MPU_M3_PRLAR0_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR0_U_SMXP_4_0, REGION0_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR0_U_SMXP_4_0, REGION0_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR1_U_SMXP_4_0, 0x203dc20)
    FIELD(POR_MPU_M3_PRBAR1_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR1_U_SMXP_4_0, REGION1_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR1_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR1_U_SMXP_4_0, REGION1_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR1_U_SMXP_4_0, REGION1_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR1_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR1_U_SMXP_4_0, 0x203dc28)
    FIELD(POR_MPU_M3_PRLAR1_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR1_U_SMXP_4_0, REGION1_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR1_U_SMXP_4_0, REGION1_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR2_U_SMXP_4_0, 0x203dc30)
    FIELD(POR_MPU_M3_PRBAR2_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR2_U_SMXP_4_0, REGION2_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR2_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR2_U_SMXP_4_0, REGION2_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR2_U_SMXP_4_0, REGION2_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR2_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR2_U_SMXP_4_0, 0x203dc38)
    FIELD(POR_MPU_M3_PRLAR2_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR2_U_SMXP_4_0, REGION2_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR2_U_SMXP_4_0, REGION2_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR3_U_SMXP_4_0, 0x203dc40)
    FIELD(POR_MPU_M3_PRBAR3_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR3_U_SMXP_4_0, REGION3_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR3_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR3_U_SMXP_4_0, REGION3_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR3_U_SMXP_4_0, REGION3_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR3_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR3_U_SMXP_4_0, 0x203dc48)
    FIELD(POR_MPU_M3_PRLAR3_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR3_U_SMXP_4_0, REGION3_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR3_U_SMXP_4_0, REGION3_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR4_U_SMXP_4_0, 0x203dc50)
    FIELD(POR_MPU_M3_PRBAR4_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR4_U_SMXP_4_0, REGION4_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR4_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR4_U_SMXP_4_0, REGION4_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR4_U_SMXP_4_0, REGION4_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR4_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR4_U_SMXP_4_0, 0x203dc58)
    FIELD(POR_MPU_M3_PRLAR4_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR4_U_SMXP_4_0, REGION4_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR4_U_SMXP_4_0, REGION4_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR5_U_SMXP_4_0, 0x203dc60)
    FIELD(POR_MPU_M3_PRBAR5_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR5_U_SMXP_4_0, REGION5_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR5_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR5_U_SMXP_4_0, REGION5_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR5_U_SMXP_4_0, REGION5_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR5_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR5_U_SMXP_4_0, 0x203dc68)
    FIELD(POR_MPU_M3_PRLAR5_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR5_U_SMXP_4_0, REGION5_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR5_U_SMXP_4_0, REGION5_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR6_U_SMXP_4_0, 0x203dc70)
    FIELD(POR_MPU_M3_PRBAR6_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR6_U_SMXP_4_0, REGION6_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR6_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR6_U_SMXP_4_0, REGION6_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR6_U_SMXP_4_0, REGION6_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR6_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR6_U_SMXP_4_0, 0x203dc78)
    FIELD(POR_MPU_M3_PRLAR6_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR6_U_SMXP_4_0, REGION6_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR6_U_SMXP_4_0, REGION6_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR7_U_SMXP_4_0, 0x203dc80)
    FIELD(POR_MPU_M3_PRBAR7_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR7_U_SMXP_4_0, REGION7_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR7_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR7_U_SMXP_4_0, REGION7_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR7_U_SMXP_4_0, REGION7_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR7_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR7_U_SMXP_4_0, 0x203dc88)
    FIELD(POR_MPU_M3_PRLAR7_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR7_U_SMXP_4_0, REGION7_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR7_U_SMXP_4_0, REGION7_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR8_U_SMXP_4_0, 0x203dc90)
    FIELD(POR_MPU_M3_PRBAR8_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR8_U_SMXP_4_0, REGION8_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR8_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR8_U_SMXP_4_0, REGION8_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR8_U_SMXP_4_0, REGION8_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR8_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR8_U_SMXP_4_0, 0x203dc98)
    FIELD(POR_MPU_M3_PRLAR8_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR8_U_SMXP_4_0, REGION8_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR8_U_SMXP_4_0, REGION8_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR9_U_SMXP_4_0, 0x203dca0)
    FIELD(POR_MPU_M3_PRBAR9_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR9_U_SMXP_4_0, REGION9_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR9_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR9_U_SMXP_4_0, REGION9_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR9_U_SMXP_4_0, REGION9_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR9_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR9_U_SMXP_4_0, 0x203dca8)
    FIELD(POR_MPU_M3_PRLAR9_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR9_U_SMXP_4_0, REGION9_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR9_U_SMXP_4_0, REGION9_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR10_U_SMXP_4_0, 0x203dcb0)
    FIELD(POR_MPU_M3_PRBAR10_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR10_U_SMXP_4_0, REGION10_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR10_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR10_U_SMXP_4_0, REGION10_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR10_U_SMXP_4_0, REGION10_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR10_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR10_U_SMXP_4_0, 0x203dcb8)
    FIELD(POR_MPU_M3_PRLAR10_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR10_U_SMXP_4_0, REGION10_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR10_U_SMXP_4_0, REGION10_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR11_U_SMXP_4_0, 0x203dcc0)
    FIELD(POR_MPU_M3_PRBAR11_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR11_U_SMXP_4_0, REGION11_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR11_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR11_U_SMXP_4_0, REGION11_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR11_U_SMXP_4_0, REGION11_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR11_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR11_U_SMXP_4_0, 0x203dcc8)
    FIELD(POR_MPU_M3_PRLAR11_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR11_U_SMXP_4_0, REGION11_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR11_U_SMXP_4_0, REGION11_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR12_U_SMXP_4_0, 0x203dcd0)
    FIELD(POR_MPU_M3_PRBAR12_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR12_U_SMXP_4_0, REGION12_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR12_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR12_U_SMXP_4_0, REGION12_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR12_U_SMXP_4_0, REGION12_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR12_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR12_U_SMXP_4_0, 0x203dcd8)
    FIELD(POR_MPU_M3_PRLAR12_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR12_U_SMXP_4_0, REGION12_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR12_U_SMXP_4_0, REGION12_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR13_U_SMXP_4_0, 0x203dce0)
    FIELD(POR_MPU_M3_PRBAR13_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR13_U_SMXP_4_0, REGION13_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR13_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR13_U_SMXP_4_0, REGION13_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR13_U_SMXP_4_0, REGION13_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR13_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR13_U_SMXP_4_0, 0x203dce8)
    FIELD(POR_MPU_M3_PRLAR13_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR13_U_SMXP_4_0, REGION13_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR13_U_SMXP_4_0, REGION13_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR14_U_SMXP_4_0, 0x203dcf0)
    FIELD(POR_MPU_M3_PRBAR14_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR14_U_SMXP_4_0, REGION14_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR14_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR14_U_SMXP_4_0, REGION14_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR14_U_SMXP_4_0, REGION14_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR14_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR14_U_SMXP_4_0, 0x203dcf8)
    FIELD(POR_MPU_M3_PRLAR14_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR14_U_SMXP_4_0, REGION14_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR14_U_SMXP_4_0, REGION14_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR15_U_SMXP_4_0, 0x203dd00)
    FIELD(POR_MPU_M3_PRBAR15_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR15_U_SMXP_4_0, REGION15_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR15_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR15_U_SMXP_4_0, REGION15_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR15_U_SMXP_4_0, REGION15_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR15_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR15_U_SMXP_4_0, 0x203dd08)
    FIELD(POR_MPU_M3_PRLAR15_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR15_U_SMXP_4_0, REGION15_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR15_U_SMXP_4_0, REGION15_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR16_U_SMXP_4_0, 0x203dd10)
    FIELD(POR_MPU_M3_PRBAR16_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR16_U_SMXP_4_0, REGION16_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR16_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR16_U_SMXP_4_0, REGION16_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR16_U_SMXP_4_0, REGION16_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR16_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR16_U_SMXP_4_0, 0x203dd18)
    FIELD(POR_MPU_M3_PRLAR16_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR16_U_SMXP_4_0, REGION16_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR16_U_SMXP_4_0, REGION16_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR17_U_SMXP_4_0, 0x203dd20)
    FIELD(POR_MPU_M3_PRBAR17_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR17_U_SMXP_4_0, REGION17_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR17_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR17_U_SMXP_4_0, REGION17_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR17_U_SMXP_4_0, REGION17_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR17_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR17_U_SMXP_4_0, 0x203dd28)
    FIELD(POR_MPU_M3_PRLAR17_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR17_U_SMXP_4_0, REGION17_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR17_U_SMXP_4_0, REGION17_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR18_U_SMXP_4_0, 0x203dd30)
    FIELD(POR_MPU_M3_PRBAR18_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR18_U_SMXP_4_0, REGION18_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR18_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR18_U_SMXP_4_0, REGION18_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR18_U_SMXP_4_0, REGION18_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR18_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR18_U_SMXP_4_0, 0x203dd38)
    FIELD(POR_MPU_M3_PRLAR18_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR18_U_SMXP_4_0, REGION18_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR18_U_SMXP_4_0, REGION18_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR19_U_SMXP_4_0, 0x203dd40)
    FIELD(POR_MPU_M3_PRBAR19_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR19_U_SMXP_4_0, REGION19_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR19_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR19_U_SMXP_4_0, REGION19_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR19_U_SMXP_4_0, REGION19_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR19_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR19_U_SMXP_4_0, 0x203dd48)
    FIELD(POR_MPU_M3_PRLAR19_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR19_U_SMXP_4_0, REGION19_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR19_U_SMXP_4_0, REGION19_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR20_U_SMXP_4_0, 0x203dd50)
    FIELD(POR_MPU_M3_PRBAR20_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR20_U_SMXP_4_0, REGION20_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR20_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR20_U_SMXP_4_0, REGION20_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR20_U_SMXP_4_0, REGION20_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR20_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR20_U_SMXP_4_0, 0x203dd58)
    FIELD(POR_MPU_M3_PRLAR20_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR20_U_SMXP_4_0, REGION20_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR20_U_SMXP_4_0, REGION20_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR21_U_SMXP_4_0, 0x203dd60)
    FIELD(POR_MPU_M3_PRBAR21_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR21_U_SMXP_4_0, REGION21_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR21_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR21_U_SMXP_4_0, REGION21_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR21_U_SMXP_4_0, REGION21_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR21_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR21_U_SMXP_4_0, 0x203dd68)
    FIELD(POR_MPU_M3_PRLAR21_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR21_U_SMXP_4_0, REGION21_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR21_U_SMXP_4_0, REGION21_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR22_U_SMXP_4_0, 0x203dd70)
    FIELD(POR_MPU_M3_PRBAR22_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR22_U_SMXP_4_0, REGION22_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR22_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR22_U_SMXP_4_0, REGION22_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR22_U_SMXP_4_0, REGION22_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR22_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR22_U_SMXP_4_0, 0x203dd78)
    FIELD(POR_MPU_M3_PRLAR22_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR22_U_SMXP_4_0, REGION22_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR22_U_SMXP_4_0, REGION22_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR23_U_SMXP_4_0, 0x203dd80)
    FIELD(POR_MPU_M3_PRBAR23_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR23_U_SMXP_4_0, REGION23_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR23_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR23_U_SMXP_4_0, REGION23_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR23_U_SMXP_4_0, REGION23_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR23_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR23_U_SMXP_4_0, 0x203dd88)
    FIELD(POR_MPU_M3_PRLAR23_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR23_U_SMXP_4_0, REGION23_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR23_U_SMXP_4_0, REGION23_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR24_U_SMXP_4_0, 0x203dd90)
    FIELD(POR_MPU_M3_PRBAR24_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR24_U_SMXP_4_0, REGION24_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR24_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR24_U_SMXP_4_0, REGION24_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR24_U_SMXP_4_0, REGION24_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR24_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR24_U_SMXP_4_0, 0x203dd98)
    FIELD(POR_MPU_M3_PRLAR24_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR24_U_SMXP_4_0, REGION24_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR24_U_SMXP_4_0, REGION24_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR25_U_SMXP_4_0, 0x203dda0)
    FIELD(POR_MPU_M3_PRBAR25_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR25_U_SMXP_4_0, REGION25_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR25_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR25_U_SMXP_4_0, REGION25_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR25_U_SMXP_4_0, REGION25_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR25_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR25_U_SMXP_4_0, 0x203dda8)
    FIELD(POR_MPU_M3_PRLAR25_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR25_U_SMXP_4_0, REGION25_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR25_U_SMXP_4_0, REGION25_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR26_U_SMXP_4_0, 0x203ddb0)
    FIELD(POR_MPU_M3_PRBAR26_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR26_U_SMXP_4_0, REGION26_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR26_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR26_U_SMXP_4_0, REGION26_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR26_U_SMXP_4_0, REGION26_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR26_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR26_U_SMXP_4_0, 0x203ddb8)
    FIELD(POR_MPU_M3_PRLAR26_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR26_U_SMXP_4_0, REGION26_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR26_U_SMXP_4_0, REGION26_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR27_U_SMXP_4_0, 0x203ddc0)
    FIELD(POR_MPU_M3_PRBAR27_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR27_U_SMXP_4_0, REGION27_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR27_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR27_U_SMXP_4_0, REGION27_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR27_U_SMXP_4_0, REGION27_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR27_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR27_U_SMXP_4_0, 0x203ddc8)
    FIELD(POR_MPU_M3_PRLAR27_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR27_U_SMXP_4_0, REGION27_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR27_U_SMXP_4_0, REGION27_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR28_U_SMXP_4_0, 0x203ddd0)
    FIELD(POR_MPU_M3_PRBAR28_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR28_U_SMXP_4_0, REGION28_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR28_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR28_U_SMXP_4_0, REGION28_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR28_U_SMXP_4_0, REGION28_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR28_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR28_U_SMXP_4_0, 0x203ddd8)
    FIELD(POR_MPU_M3_PRLAR28_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR28_U_SMXP_4_0, REGION28_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR28_U_SMXP_4_0, REGION28_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR29_U_SMXP_4_0, 0x203dde0)
    FIELD(POR_MPU_M3_PRBAR29_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR29_U_SMXP_4_0, REGION29_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR29_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR29_U_SMXP_4_0, REGION29_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR29_U_SMXP_4_0, REGION29_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR29_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR29_U_SMXP_4_0, 0x203dde8)
    FIELD(POR_MPU_M3_PRLAR29_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR29_U_SMXP_4_0, REGION29_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR29_U_SMXP_4_0, REGION29_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR30_U_SMXP_4_0, 0x203ddf0)
    FIELD(POR_MPU_M3_PRBAR30_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR30_U_SMXP_4_0, REGION30_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR30_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR30_U_SMXP_4_0, REGION30_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR30_U_SMXP_4_0, REGION30_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR30_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR30_U_SMXP_4_0, 0x203ddf8)
    FIELD(POR_MPU_M3_PRLAR30_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR30_U_SMXP_4_0, REGION30_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR30_U_SMXP_4_0, REGION30_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR31_U_SMXP_4_0, 0x203de00)
    FIELD(POR_MPU_M3_PRBAR31_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR31_U_SMXP_4_0, REGION31_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR31_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR31_U_SMXP_4_0, REGION31_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR31_U_SMXP_4_0, REGION31_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR31_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR31_U_SMXP_4_0, 0x203de08)
    FIELD(POR_MPU_M3_PRLAR31_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR31_U_SMXP_4_0, REGION31_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR31_U_SMXP_4_0, REGION31_EN, 0, 1)
REG32(POR_MPU_M4_CTL_U_SMXP_4_0, 0x203e000)
    FIELD(POR_MPU_M4_CTL_U_SMXP_4_0, M4_EN, 2, 1)
    FIELD(POR_MPU_M4_CTL_U_SMXP_4_0, M4_ACTION, 0, 2)
REG32(POR_MPU_M4_PRBAR0_U_SMXP_4_0, 0x203e010)
    FIELD(POR_MPU_M4_PRBAR0_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR0_U_SMXP_4_0, REGION0_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR0_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR0_U_SMXP_4_0, REGION0_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR0_U_SMXP_4_0, REGION0_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR0_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR0_U_SMXP_4_0, 0x203e018)
    FIELD(POR_MPU_M4_PRLAR0_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR0_U_SMXP_4_0, REGION0_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR0_U_SMXP_4_0, REGION0_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR1_U_SMXP_4_0, 0x203e020)
    FIELD(POR_MPU_M4_PRBAR1_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR1_U_SMXP_4_0, REGION1_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR1_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR1_U_SMXP_4_0, REGION1_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR1_U_SMXP_4_0, REGION1_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR1_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR1_U_SMXP_4_0, 0x203e028)
    FIELD(POR_MPU_M4_PRLAR1_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR1_U_SMXP_4_0, REGION1_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR1_U_SMXP_4_0, REGION1_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR2_U_SMXP_4_0, 0x203e030)
    FIELD(POR_MPU_M4_PRBAR2_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR2_U_SMXP_4_0, REGION2_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR2_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR2_U_SMXP_4_0, REGION2_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR2_U_SMXP_4_0, REGION2_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR2_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR2_U_SMXP_4_0, 0x203e038)
    FIELD(POR_MPU_M4_PRLAR2_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR2_U_SMXP_4_0, REGION2_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR2_U_SMXP_4_0, REGION2_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR3_U_SMXP_4_0, 0x203e040)
    FIELD(POR_MPU_M4_PRBAR3_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR3_U_SMXP_4_0, REGION3_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR3_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR3_U_SMXP_4_0, REGION3_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR3_U_SMXP_4_0, REGION3_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR3_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR3_U_SMXP_4_0, 0x203e048)
    FIELD(POR_MPU_M4_PRLAR3_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR3_U_SMXP_4_0, REGION3_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR3_U_SMXP_4_0, REGION3_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR4_U_SMXP_4_0, 0x203e050)
    FIELD(POR_MPU_M4_PRBAR4_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR4_U_SMXP_4_0, REGION4_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR4_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR4_U_SMXP_4_0, REGION4_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR4_U_SMXP_4_0, REGION4_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR4_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR4_U_SMXP_4_0, 0x203e058)
    FIELD(POR_MPU_M4_PRLAR4_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR4_U_SMXP_4_0, REGION4_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR4_U_SMXP_4_0, REGION4_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR5_U_SMXP_4_0, 0x203e060)
    FIELD(POR_MPU_M4_PRBAR5_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR5_U_SMXP_4_0, REGION5_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR5_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR5_U_SMXP_4_0, REGION5_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR5_U_SMXP_4_0, REGION5_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR5_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR5_U_SMXP_4_0, 0x203e068)
    FIELD(POR_MPU_M4_PRLAR5_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR5_U_SMXP_4_0, REGION5_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR5_U_SMXP_4_0, REGION5_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR6_U_SMXP_4_0, 0x203e070)
    FIELD(POR_MPU_M4_PRBAR6_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR6_U_SMXP_4_0, REGION6_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR6_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR6_U_SMXP_4_0, REGION6_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR6_U_SMXP_4_0, REGION6_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR6_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR6_U_SMXP_4_0, 0x203e078)
    FIELD(POR_MPU_M4_PRLAR6_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR6_U_SMXP_4_0, REGION6_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR6_U_SMXP_4_0, REGION6_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR7_U_SMXP_4_0, 0x203e080)
    FIELD(POR_MPU_M4_PRBAR7_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR7_U_SMXP_4_0, REGION7_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR7_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR7_U_SMXP_4_0, REGION7_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR7_U_SMXP_4_0, REGION7_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR7_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR7_U_SMXP_4_0, 0x203e088)
    FIELD(POR_MPU_M4_PRLAR7_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR7_U_SMXP_4_0, REGION7_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR7_U_SMXP_4_0, REGION7_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR8_U_SMXP_4_0, 0x203e090)
    FIELD(POR_MPU_M4_PRBAR8_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR8_U_SMXP_4_0, REGION8_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR8_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR8_U_SMXP_4_0, REGION8_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR8_U_SMXP_4_0, REGION8_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR8_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR8_U_SMXP_4_0, 0x203e098)
    FIELD(POR_MPU_M4_PRLAR8_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR8_U_SMXP_4_0, REGION8_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR8_U_SMXP_4_0, REGION8_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR9_U_SMXP_4_0, 0x203e0a0)
    FIELD(POR_MPU_M4_PRBAR9_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR9_U_SMXP_4_0, REGION9_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR9_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR9_U_SMXP_4_0, REGION9_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR9_U_SMXP_4_0, REGION9_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR9_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR9_U_SMXP_4_0, 0x203e0a8)
    FIELD(POR_MPU_M4_PRLAR9_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR9_U_SMXP_4_0, REGION9_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR9_U_SMXP_4_0, REGION9_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR10_U_SMXP_4_0, 0x203e0b0)
    FIELD(POR_MPU_M4_PRBAR10_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR10_U_SMXP_4_0, REGION10_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR10_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR10_U_SMXP_4_0, REGION10_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR10_U_SMXP_4_0, REGION10_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR10_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR10_U_SMXP_4_0, 0x203e0b8)
    FIELD(POR_MPU_M4_PRLAR10_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR10_U_SMXP_4_0, REGION10_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR10_U_SMXP_4_0, REGION10_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR11_U_SMXP_4_0, 0x203e0c0)
    FIELD(POR_MPU_M4_PRBAR11_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR11_U_SMXP_4_0, REGION11_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR11_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR11_U_SMXP_4_0, REGION11_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR11_U_SMXP_4_0, REGION11_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR11_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR11_U_SMXP_4_0, 0x203e0c8)
    FIELD(POR_MPU_M4_PRLAR11_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR11_U_SMXP_4_0, REGION11_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR11_U_SMXP_4_0, REGION11_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR12_U_SMXP_4_0, 0x203e0d0)
    FIELD(POR_MPU_M4_PRBAR12_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR12_U_SMXP_4_0, REGION12_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR12_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR12_U_SMXP_4_0, REGION12_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR12_U_SMXP_4_0, REGION12_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR12_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR12_U_SMXP_4_0, 0x203e0d8)
    FIELD(POR_MPU_M4_PRLAR12_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR12_U_SMXP_4_0, REGION12_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR12_U_SMXP_4_0, REGION12_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR13_U_SMXP_4_0, 0x203e0e0)
    FIELD(POR_MPU_M4_PRBAR13_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR13_U_SMXP_4_0, REGION13_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR13_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR13_U_SMXP_4_0, REGION13_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR13_U_SMXP_4_0, REGION13_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR13_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR13_U_SMXP_4_0, 0x203e0e8)
    FIELD(POR_MPU_M4_PRLAR13_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR13_U_SMXP_4_0, REGION13_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR13_U_SMXP_4_0, REGION13_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR14_U_SMXP_4_0, 0x203e0f0)
    FIELD(POR_MPU_M4_PRBAR14_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR14_U_SMXP_4_0, REGION14_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR14_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR14_U_SMXP_4_0, REGION14_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR14_U_SMXP_4_0, REGION14_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR14_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR14_U_SMXP_4_0, 0x203e0f8)
    FIELD(POR_MPU_M4_PRLAR14_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR14_U_SMXP_4_0, REGION14_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR14_U_SMXP_4_0, REGION14_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR15_U_SMXP_4_0, 0x203e100)
    FIELD(POR_MPU_M4_PRBAR15_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR15_U_SMXP_4_0, REGION15_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR15_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR15_U_SMXP_4_0, REGION15_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR15_U_SMXP_4_0, REGION15_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR15_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR15_U_SMXP_4_0, 0x203e108)
    FIELD(POR_MPU_M4_PRLAR15_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR15_U_SMXP_4_0, REGION15_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR15_U_SMXP_4_0, REGION15_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR16_U_SMXP_4_0, 0x203e110)
    FIELD(POR_MPU_M4_PRBAR16_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR16_U_SMXP_4_0, REGION16_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR16_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR16_U_SMXP_4_0, REGION16_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR16_U_SMXP_4_0, REGION16_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR16_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR16_U_SMXP_4_0, 0x203e118)
    FIELD(POR_MPU_M4_PRLAR16_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR16_U_SMXP_4_0, REGION16_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR16_U_SMXP_4_0, REGION16_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR17_U_SMXP_4_0, 0x203e120)
    FIELD(POR_MPU_M4_PRBAR17_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR17_U_SMXP_4_0, REGION17_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR17_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR17_U_SMXP_4_0, REGION17_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR17_U_SMXP_4_0, REGION17_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR17_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR17_U_SMXP_4_0, 0x203e128)
    FIELD(POR_MPU_M4_PRLAR17_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR17_U_SMXP_4_0, REGION17_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR17_U_SMXP_4_0, REGION17_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR18_U_SMXP_4_0, 0x203e130)
    FIELD(POR_MPU_M4_PRBAR18_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR18_U_SMXP_4_0, REGION18_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR18_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR18_U_SMXP_4_0, REGION18_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR18_U_SMXP_4_0, REGION18_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR18_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR18_U_SMXP_4_0, 0x203e138)
    FIELD(POR_MPU_M4_PRLAR18_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR18_U_SMXP_4_0, REGION18_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR18_U_SMXP_4_0, REGION18_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR19_U_SMXP_4_0, 0x203e140)
    FIELD(POR_MPU_M4_PRBAR19_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR19_U_SMXP_4_0, REGION19_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR19_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR19_U_SMXP_4_0, REGION19_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR19_U_SMXP_4_0, REGION19_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR19_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR19_U_SMXP_4_0, 0x203e148)
    FIELD(POR_MPU_M4_PRLAR19_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR19_U_SMXP_4_0, REGION19_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR19_U_SMXP_4_0, REGION19_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR20_U_SMXP_4_0, 0x203e150)
    FIELD(POR_MPU_M4_PRBAR20_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR20_U_SMXP_4_0, REGION20_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR20_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR20_U_SMXP_4_0, REGION20_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR20_U_SMXP_4_0, REGION20_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR20_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR20_U_SMXP_4_0, 0x203e158)
    FIELD(POR_MPU_M4_PRLAR20_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR20_U_SMXP_4_0, REGION20_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR20_U_SMXP_4_0, REGION20_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR21_U_SMXP_4_0, 0x203e160)
    FIELD(POR_MPU_M4_PRBAR21_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR21_U_SMXP_4_0, REGION21_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR21_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR21_U_SMXP_4_0, REGION21_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR21_U_SMXP_4_0, REGION21_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR21_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR21_U_SMXP_4_0, 0x203e168)
    FIELD(POR_MPU_M4_PRLAR21_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR21_U_SMXP_4_0, REGION21_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR21_U_SMXP_4_0, REGION21_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR22_U_SMXP_4_0, 0x203e170)
    FIELD(POR_MPU_M4_PRBAR22_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR22_U_SMXP_4_0, REGION22_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR22_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR22_U_SMXP_4_0, REGION22_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR22_U_SMXP_4_0, REGION22_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR22_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR22_U_SMXP_4_0, 0x203e178)
    FIELD(POR_MPU_M4_PRLAR22_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR22_U_SMXP_4_0, REGION22_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR22_U_SMXP_4_0, REGION22_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR23_U_SMXP_4_0, 0x203e180)
    FIELD(POR_MPU_M4_PRBAR23_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR23_U_SMXP_4_0, REGION23_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR23_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR23_U_SMXP_4_0, REGION23_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR23_U_SMXP_4_0, REGION23_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR23_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR23_U_SMXP_4_0, 0x203e188)
    FIELD(POR_MPU_M4_PRLAR23_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR23_U_SMXP_4_0, REGION23_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR23_U_SMXP_4_0, REGION23_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR24_U_SMXP_4_0, 0x203e190)
    FIELD(POR_MPU_M4_PRBAR24_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR24_U_SMXP_4_0, REGION24_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR24_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR24_U_SMXP_4_0, REGION24_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR24_U_SMXP_4_0, REGION24_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR24_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR24_U_SMXP_4_0, 0x203e198)
    FIELD(POR_MPU_M4_PRLAR24_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR24_U_SMXP_4_0, REGION24_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR24_U_SMXP_4_0, REGION24_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR25_U_SMXP_4_0, 0x203e1a0)
    FIELD(POR_MPU_M4_PRBAR25_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR25_U_SMXP_4_0, REGION25_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR25_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR25_U_SMXP_4_0, REGION25_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR25_U_SMXP_4_0, REGION25_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR25_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR25_U_SMXP_4_0, 0x203e1a8)
    FIELD(POR_MPU_M4_PRLAR25_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR25_U_SMXP_4_0, REGION25_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR25_U_SMXP_4_0, REGION25_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR26_U_SMXP_4_0, 0x203e1b0)
    FIELD(POR_MPU_M4_PRBAR26_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR26_U_SMXP_4_0, REGION26_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR26_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR26_U_SMXP_4_0, REGION26_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR26_U_SMXP_4_0, REGION26_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR26_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR26_U_SMXP_4_0, 0x203e1b8)
    FIELD(POR_MPU_M4_PRLAR26_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR26_U_SMXP_4_0, REGION26_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR26_U_SMXP_4_0, REGION26_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR27_U_SMXP_4_0, 0x203e1c0)
    FIELD(POR_MPU_M4_PRBAR27_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR27_U_SMXP_4_0, REGION27_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR27_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR27_U_SMXP_4_0, REGION27_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR27_U_SMXP_4_0, REGION27_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR27_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR27_U_SMXP_4_0, 0x203e1c8)
    FIELD(POR_MPU_M4_PRLAR27_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR27_U_SMXP_4_0, REGION27_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR27_U_SMXP_4_0, REGION27_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR28_U_SMXP_4_0, 0x203e1d0)
    FIELD(POR_MPU_M4_PRBAR28_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR28_U_SMXP_4_0, REGION28_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR28_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR28_U_SMXP_4_0, REGION28_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR28_U_SMXP_4_0, REGION28_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR28_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR28_U_SMXP_4_0, 0x203e1d8)
    FIELD(POR_MPU_M4_PRLAR28_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR28_U_SMXP_4_0, REGION28_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR28_U_SMXP_4_0, REGION28_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR29_U_SMXP_4_0, 0x203e1e0)
    FIELD(POR_MPU_M4_PRBAR29_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR29_U_SMXP_4_0, REGION29_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR29_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR29_U_SMXP_4_0, REGION29_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR29_U_SMXP_4_0, REGION29_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR29_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR29_U_SMXP_4_0, 0x203e1e8)
    FIELD(POR_MPU_M4_PRLAR29_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR29_U_SMXP_4_0, REGION29_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR29_U_SMXP_4_0, REGION29_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR30_U_SMXP_4_0, 0x203e1f0)
    FIELD(POR_MPU_M4_PRBAR30_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR30_U_SMXP_4_0, REGION30_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR30_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR30_U_SMXP_4_0, REGION30_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR30_U_SMXP_4_0, REGION30_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR30_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR30_U_SMXP_4_0, 0x203e1f8)
    FIELD(POR_MPU_M4_PRLAR30_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR30_U_SMXP_4_0, REGION30_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR30_U_SMXP_4_0, REGION30_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR31_U_SMXP_4_0, 0x203e200)
    FIELD(POR_MPU_M4_PRBAR31_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR31_U_SMXP_4_0, REGION31_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR31_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR31_U_SMXP_4_0, REGION31_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR31_U_SMXP_4_0, REGION31_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR31_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR31_U_SMXP_4_0, 0x203e208)
    FIELD(POR_MPU_M4_PRLAR31_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR31_U_SMXP_4_0, REGION31_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR31_U_SMXP_4_0, REGION31_EN, 0, 1)
REG32(POR_MPU_M5_CTL_U_SMXP_4_0, 0x203e400)
    FIELD(POR_MPU_M5_CTL_U_SMXP_4_0, M5_EN, 2, 1)
    FIELD(POR_MPU_M5_CTL_U_SMXP_4_0, M5_ACTION, 0, 2)
REG32(POR_MPU_M5_PRBAR0_U_SMXP_4_0, 0x203e410)
    FIELD(POR_MPU_M5_PRBAR0_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR0_U_SMXP_4_0, REGION0_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR0_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR0_U_SMXP_4_0, REGION0_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR0_U_SMXP_4_0, REGION0_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR0_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR0_U_SMXP_4_0, 0x203e418)
    FIELD(POR_MPU_M5_PRLAR0_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR0_U_SMXP_4_0, REGION0_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR0_U_SMXP_4_0, REGION0_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR1_U_SMXP_4_0, 0x203e420)
    FIELD(POR_MPU_M5_PRBAR1_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR1_U_SMXP_4_0, REGION1_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR1_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR1_U_SMXP_4_0, REGION1_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR1_U_SMXP_4_0, REGION1_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR1_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR1_U_SMXP_4_0, 0x203e428)
    FIELD(POR_MPU_M5_PRLAR1_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR1_U_SMXP_4_0, REGION1_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR1_U_SMXP_4_0, REGION1_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR2_U_SMXP_4_0, 0x203e430)
    FIELD(POR_MPU_M5_PRBAR2_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR2_U_SMXP_4_0, REGION2_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR2_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR2_U_SMXP_4_0, REGION2_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR2_U_SMXP_4_0, REGION2_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR2_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR2_U_SMXP_4_0, 0x203e438)
    FIELD(POR_MPU_M5_PRLAR2_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR2_U_SMXP_4_0, REGION2_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR2_U_SMXP_4_0, REGION2_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR3_U_SMXP_4_0, 0x203e440)
    FIELD(POR_MPU_M5_PRBAR3_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR3_U_SMXP_4_0, REGION3_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR3_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR3_U_SMXP_4_0, REGION3_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR3_U_SMXP_4_0, REGION3_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR3_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR3_U_SMXP_4_0, 0x203e448)
    FIELD(POR_MPU_M5_PRLAR3_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR3_U_SMXP_4_0, REGION3_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR3_U_SMXP_4_0, REGION3_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR4_U_SMXP_4_0, 0x203e450)
    FIELD(POR_MPU_M5_PRBAR4_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR4_U_SMXP_4_0, REGION4_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR4_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR4_U_SMXP_4_0, REGION4_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR4_U_SMXP_4_0, REGION4_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR4_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR4_U_SMXP_4_0, 0x203e458)
    FIELD(POR_MPU_M5_PRLAR4_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR4_U_SMXP_4_0, REGION4_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR4_U_SMXP_4_0, REGION4_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR5_U_SMXP_4_0, 0x203e460)
    FIELD(POR_MPU_M5_PRBAR5_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR5_U_SMXP_4_0, REGION5_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR5_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR5_U_SMXP_4_0, REGION5_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR5_U_SMXP_4_0, REGION5_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR5_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR5_U_SMXP_4_0, 0x203e468)
    FIELD(POR_MPU_M5_PRLAR5_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR5_U_SMXP_4_0, REGION5_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR5_U_SMXP_4_0, REGION5_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR6_U_SMXP_4_0, 0x203e470)
    FIELD(POR_MPU_M5_PRBAR6_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR6_U_SMXP_4_0, REGION6_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR6_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR6_U_SMXP_4_0, REGION6_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR6_U_SMXP_4_0, REGION6_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR6_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR6_U_SMXP_4_0, 0x203e478)
    FIELD(POR_MPU_M5_PRLAR6_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR6_U_SMXP_4_0, REGION6_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR6_U_SMXP_4_0, REGION6_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR7_U_SMXP_4_0, 0x203e480)
    FIELD(POR_MPU_M5_PRBAR7_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR7_U_SMXP_4_0, REGION7_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR7_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR7_U_SMXP_4_0, REGION7_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR7_U_SMXP_4_0, REGION7_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR7_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR7_U_SMXP_4_0, 0x203e488)
    FIELD(POR_MPU_M5_PRLAR7_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR7_U_SMXP_4_0, REGION7_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR7_U_SMXP_4_0, REGION7_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR8_U_SMXP_4_0, 0x203e490)
    FIELD(POR_MPU_M5_PRBAR8_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR8_U_SMXP_4_0, REGION8_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR8_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR8_U_SMXP_4_0, REGION8_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR8_U_SMXP_4_0, REGION8_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR8_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR8_U_SMXP_4_0, 0x203e498)
    FIELD(POR_MPU_M5_PRLAR8_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR8_U_SMXP_4_0, REGION8_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR8_U_SMXP_4_0, REGION8_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR9_U_SMXP_4_0, 0x203e4a0)
    FIELD(POR_MPU_M5_PRBAR9_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR9_U_SMXP_4_0, REGION9_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR9_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR9_U_SMXP_4_0, REGION9_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR9_U_SMXP_4_0, REGION9_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR9_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR9_U_SMXP_4_0, 0x203e4a8)
    FIELD(POR_MPU_M5_PRLAR9_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR9_U_SMXP_4_0, REGION9_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR9_U_SMXP_4_0, REGION9_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR10_U_SMXP_4_0, 0x203e4b0)
    FIELD(POR_MPU_M5_PRBAR10_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR10_U_SMXP_4_0, REGION10_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR10_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR10_U_SMXP_4_0, REGION10_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR10_U_SMXP_4_0, REGION10_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR10_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR10_U_SMXP_4_0, 0x203e4b8)
    FIELD(POR_MPU_M5_PRLAR10_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR10_U_SMXP_4_0, REGION10_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR10_U_SMXP_4_0, REGION10_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR11_U_SMXP_4_0, 0x203e4c0)
    FIELD(POR_MPU_M5_PRBAR11_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR11_U_SMXP_4_0, REGION11_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR11_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR11_U_SMXP_4_0, REGION11_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR11_U_SMXP_4_0, REGION11_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR11_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR11_U_SMXP_4_0, 0x203e4c8)
    FIELD(POR_MPU_M5_PRLAR11_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR11_U_SMXP_4_0, REGION11_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR11_U_SMXP_4_0, REGION11_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR12_U_SMXP_4_0, 0x203e4d0)
    FIELD(POR_MPU_M5_PRBAR12_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR12_U_SMXP_4_0, REGION12_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR12_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR12_U_SMXP_4_0, REGION12_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR12_U_SMXP_4_0, REGION12_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR12_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR12_U_SMXP_4_0, 0x203e4d8)
    FIELD(POR_MPU_M5_PRLAR12_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR12_U_SMXP_4_0, REGION12_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR12_U_SMXP_4_0, REGION12_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR13_U_SMXP_4_0, 0x203e4e0)
    FIELD(POR_MPU_M5_PRBAR13_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR13_U_SMXP_4_0, REGION13_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR13_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR13_U_SMXP_4_0, REGION13_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR13_U_SMXP_4_0, REGION13_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR13_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR13_U_SMXP_4_0, 0x203e4e8)
    FIELD(POR_MPU_M5_PRLAR13_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR13_U_SMXP_4_0, REGION13_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR13_U_SMXP_4_0, REGION13_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR14_U_SMXP_4_0, 0x203e4f0)
    FIELD(POR_MPU_M5_PRBAR14_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR14_U_SMXP_4_0, REGION14_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR14_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR14_U_SMXP_4_0, REGION14_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR14_U_SMXP_4_0, REGION14_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR14_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR14_U_SMXP_4_0, 0x203e4f8)
    FIELD(POR_MPU_M5_PRLAR14_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR14_U_SMXP_4_0, REGION14_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR14_U_SMXP_4_0, REGION14_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR15_U_SMXP_4_0, 0x203e500)
    FIELD(POR_MPU_M5_PRBAR15_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR15_U_SMXP_4_0, REGION15_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR15_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR15_U_SMXP_4_0, REGION15_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR15_U_SMXP_4_0, REGION15_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR15_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR15_U_SMXP_4_0, 0x203e508)
    FIELD(POR_MPU_M5_PRLAR15_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR15_U_SMXP_4_0, REGION15_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR15_U_SMXP_4_0, REGION15_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR16_U_SMXP_4_0, 0x203e510)
    FIELD(POR_MPU_M5_PRBAR16_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR16_U_SMXP_4_0, REGION16_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR16_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR16_U_SMXP_4_0, REGION16_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR16_U_SMXP_4_0, REGION16_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR16_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR16_U_SMXP_4_0, 0x203e518)
    FIELD(POR_MPU_M5_PRLAR16_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR16_U_SMXP_4_0, REGION16_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR16_U_SMXP_4_0, REGION16_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR17_U_SMXP_4_0, 0x203e520)
    FIELD(POR_MPU_M5_PRBAR17_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR17_U_SMXP_4_0, REGION17_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR17_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR17_U_SMXP_4_0, REGION17_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR17_U_SMXP_4_0, REGION17_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR17_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR17_U_SMXP_4_0, 0x203e528)
    FIELD(POR_MPU_M5_PRLAR17_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR17_U_SMXP_4_0, REGION17_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR17_U_SMXP_4_0, REGION17_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR18_U_SMXP_4_0, 0x203e530)
    FIELD(POR_MPU_M5_PRBAR18_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR18_U_SMXP_4_0, REGION18_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR18_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR18_U_SMXP_4_0, REGION18_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR18_U_SMXP_4_0, REGION18_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR18_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR18_U_SMXP_4_0, 0x203e538)
    FIELD(POR_MPU_M5_PRLAR18_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR18_U_SMXP_4_0, REGION18_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR18_U_SMXP_4_0, REGION18_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR19_U_SMXP_4_0, 0x203e540)
    FIELD(POR_MPU_M5_PRBAR19_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR19_U_SMXP_4_0, REGION19_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR19_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR19_U_SMXP_4_0, REGION19_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR19_U_SMXP_4_0, REGION19_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR19_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR19_U_SMXP_4_0, 0x203e548)
    FIELD(POR_MPU_M5_PRLAR19_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR19_U_SMXP_4_0, REGION19_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR19_U_SMXP_4_0, REGION19_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR20_U_SMXP_4_0, 0x203e550)
    FIELD(POR_MPU_M5_PRBAR20_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR20_U_SMXP_4_0, REGION20_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR20_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR20_U_SMXP_4_0, REGION20_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR20_U_SMXP_4_0, REGION20_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR20_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR20_U_SMXP_4_0, 0x203e558)
    FIELD(POR_MPU_M5_PRLAR20_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR20_U_SMXP_4_0, REGION20_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR20_U_SMXP_4_0, REGION20_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR21_U_SMXP_4_0, 0x203e560)
    FIELD(POR_MPU_M5_PRBAR21_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR21_U_SMXP_4_0, REGION21_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR21_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR21_U_SMXP_4_0, REGION21_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR21_U_SMXP_4_0, REGION21_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR21_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR21_U_SMXP_4_0, 0x203e568)
    FIELD(POR_MPU_M5_PRLAR21_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR21_U_SMXP_4_0, REGION21_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR21_U_SMXP_4_0, REGION21_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR22_U_SMXP_4_0, 0x203e570)
    FIELD(POR_MPU_M5_PRBAR22_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR22_U_SMXP_4_0, REGION22_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR22_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR22_U_SMXP_4_0, REGION22_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR22_U_SMXP_4_0, REGION22_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR22_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR22_U_SMXP_4_0, 0x203e578)
    FIELD(POR_MPU_M5_PRLAR22_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR22_U_SMXP_4_0, REGION22_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR22_U_SMXP_4_0, REGION22_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR23_U_SMXP_4_0, 0x203e580)
    FIELD(POR_MPU_M5_PRBAR23_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR23_U_SMXP_4_0, REGION23_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR23_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR23_U_SMXP_4_0, REGION23_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR23_U_SMXP_4_0, REGION23_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR23_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR23_U_SMXP_4_0, 0x203e588)
    FIELD(POR_MPU_M5_PRLAR23_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR23_U_SMXP_4_0, REGION23_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR23_U_SMXP_4_0, REGION23_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR24_U_SMXP_4_0, 0x203e590)
    FIELD(POR_MPU_M5_PRBAR24_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR24_U_SMXP_4_0, REGION24_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR24_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR24_U_SMXP_4_0, REGION24_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR24_U_SMXP_4_0, REGION24_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR24_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR24_U_SMXP_4_0, 0x203e598)
    FIELD(POR_MPU_M5_PRLAR24_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR24_U_SMXP_4_0, REGION24_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR24_U_SMXP_4_0, REGION24_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR25_U_SMXP_4_0, 0x203e5a0)
    FIELD(POR_MPU_M5_PRBAR25_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR25_U_SMXP_4_0, REGION25_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR25_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR25_U_SMXP_4_0, REGION25_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR25_U_SMXP_4_0, REGION25_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR25_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR25_U_SMXP_4_0, 0x203e5a8)
    FIELD(POR_MPU_M5_PRLAR25_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR25_U_SMXP_4_0, REGION25_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR25_U_SMXP_4_0, REGION25_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR26_U_SMXP_4_0, 0x203e5b0)
    FIELD(POR_MPU_M5_PRBAR26_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR26_U_SMXP_4_0, REGION26_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR26_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR26_U_SMXP_4_0, REGION26_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR26_U_SMXP_4_0, REGION26_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR26_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR26_U_SMXP_4_0, 0x203e5b8)
    FIELD(POR_MPU_M5_PRLAR26_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR26_U_SMXP_4_0, REGION26_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR26_U_SMXP_4_0, REGION26_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR27_U_SMXP_4_0, 0x203e5c0)
    FIELD(POR_MPU_M5_PRBAR27_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR27_U_SMXP_4_0, REGION27_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR27_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR27_U_SMXP_4_0, REGION27_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR27_U_SMXP_4_0, REGION27_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR27_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR27_U_SMXP_4_0, 0x203e5c8)
    FIELD(POR_MPU_M5_PRLAR27_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR27_U_SMXP_4_0, REGION27_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR27_U_SMXP_4_0, REGION27_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR28_U_SMXP_4_0, 0x203e5d0)
    FIELD(POR_MPU_M5_PRBAR28_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR28_U_SMXP_4_0, REGION28_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR28_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR28_U_SMXP_4_0, REGION28_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR28_U_SMXP_4_0, REGION28_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR28_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR28_U_SMXP_4_0, 0x203e5d8)
    FIELD(POR_MPU_M5_PRLAR28_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR28_U_SMXP_4_0, REGION28_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR28_U_SMXP_4_0, REGION28_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR29_U_SMXP_4_0, 0x203e5e0)
    FIELD(POR_MPU_M5_PRBAR29_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR29_U_SMXP_4_0, REGION29_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR29_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR29_U_SMXP_4_0, REGION29_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR29_U_SMXP_4_0, REGION29_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR29_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR29_U_SMXP_4_0, 0x203e5e8)
    FIELD(POR_MPU_M5_PRLAR29_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR29_U_SMXP_4_0, REGION29_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR29_U_SMXP_4_0, REGION29_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR30_U_SMXP_4_0, 0x203e5f0)
    FIELD(POR_MPU_M5_PRBAR30_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR30_U_SMXP_4_0, REGION30_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR30_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR30_U_SMXP_4_0, REGION30_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR30_U_SMXP_4_0, REGION30_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR30_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR30_U_SMXP_4_0, 0x203e5f8)
    FIELD(POR_MPU_M5_PRLAR30_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR30_U_SMXP_4_0, REGION30_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR30_U_SMXP_4_0, REGION30_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR31_U_SMXP_4_0, 0x203e600)
    FIELD(POR_MPU_M5_PRBAR31_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR31_U_SMXP_4_0, REGION31_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR31_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR31_U_SMXP_4_0, REGION31_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR31_U_SMXP_4_0, REGION31_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR31_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR31_U_SMXP_4_0, 0x203e608)
    FIELD(POR_MPU_M5_PRLAR31_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR31_U_SMXP_4_0, REGION31_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR31_U_SMXP_4_0, REGION31_EN, 0, 1)
REG32(POR_MPU_M6_CTL_U_SMXP_4_0, 0x203e800)
    FIELD(POR_MPU_M6_CTL_U_SMXP_4_0, M6_EN, 2, 1)
    FIELD(POR_MPU_M6_CTL_U_SMXP_4_0, M6_ACTION, 0, 2)
REG32(POR_MPU_M6_PRBAR0_U_SMXP_4_0, 0x203e810)
    FIELD(POR_MPU_M6_PRBAR0_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR0_U_SMXP_4_0, REGION0_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR0_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR0_U_SMXP_4_0, REGION0_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR0_U_SMXP_4_0, REGION0_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR0_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR0_U_SMXP_4_0, 0x203e818)
    FIELD(POR_MPU_M6_PRLAR0_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR0_U_SMXP_4_0, REGION0_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR0_U_SMXP_4_0, REGION0_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR1_U_SMXP_4_0, 0x203e820)
    FIELD(POR_MPU_M6_PRBAR1_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR1_U_SMXP_4_0, REGION1_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR1_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR1_U_SMXP_4_0, REGION1_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR1_U_SMXP_4_0, REGION1_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR1_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR1_U_SMXP_4_0, 0x203e828)
    FIELD(POR_MPU_M6_PRLAR1_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR1_U_SMXP_4_0, REGION1_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR1_U_SMXP_4_0, REGION1_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR2_U_SMXP_4_0, 0x203e830)
    FIELD(POR_MPU_M6_PRBAR2_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR2_U_SMXP_4_0, REGION2_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR2_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR2_U_SMXP_4_0, REGION2_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR2_U_SMXP_4_0, REGION2_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR2_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR2_U_SMXP_4_0, 0x203e838)
    FIELD(POR_MPU_M6_PRLAR2_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR2_U_SMXP_4_0, REGION2_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR2_U_SMXP_4_0, REGION2_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR3_U_SMXP_4_0, 0x203e840)
    FIELD(POR_MPU_M6_PRBAR3_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR3_U_SMXP_4_0, REGION3_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR3_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR3_U_SMXP_4_0, REGION3_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR3_U_SMXP_4_0, REGION3_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR3_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR3_U_SMXP_4_0, 0x203e848)
    FIELD(POR_MPU_M6_PRLAR3_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR3_U_SMXP_4_0, REGION3_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR3_U_SMXP_4_0, REGION3_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR4_U_SMXP_4_0, 0x203e850)
    FIELD(POR_MPU_M6_PRBAR4_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR4_U_SMXP_4_0, REGION4_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR4_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR4_U_SMXP_4_0, REGION4_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR4_U_SMXP_4_0, REGION4_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR4_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR4_U_SMXP_4_0, 0x203e858)
    FIELD(POR_MPU_M6_PRLAR4_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR4_U_SMXP_4_0, REGION4_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR4_U_SMXP_4_0, REGION4_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR5_U_SMXP_4_0, 0x203e860)
    FIELD(POR_MPU_M6_PRBAR5_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR5_U_SMXP_4_0, REGION5_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR5_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR5_U_SMXP_4_0, REGION5_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR5_U_SMXP_4_0, REGION5_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR5_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR5_U_SMXP_4_0, 0x203e868)
    FIELD(POR_MPU_M6_PRLAR5_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR5_U_SMXP_4_0, REGION5_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR5_U_SMXP_4_0, REGION5_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR6_U_SMXP_4_0, 0x203e870)
    FIELD(POR_MPU_M6_PRBAR6_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR6_U_SMXP_4_0, REGION6_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR6_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR6_U_SMXP_4_0, REGION6_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR6_U_SMXP_4_0, REGION6_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR6_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR6_U_SMXP_4_0, 0x203e878)
    FIELD(POR_MPU_M6_PRLAR6_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR6_U_SMXP_4_0, REGION6_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR6_U_SMXP_4_0, REGION6_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR7_U_SMXP_4_0, 0x203e880)
    FIELD(POR_MPU_M6_PRBAR7_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR7_U_SMXP_4_0, REGION7_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR7_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR7_U_SMXP_4_0, REGION7_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR7_U_SMXP_4_0, REGION7_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR7_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR7_U_SMXP_4_0, 0x203e888)
    FIELD(POR_MPU_M6_PRLAR7_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR7_U_SMXP_4_0, REGION7_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR7_U_SMXP_4_0, REGION7_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR8_U_SMXP_4_0, 0x203e890)
    FIELD(POR_MPU_M6_PRBAR8_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR8_U_SMXP_4_0, REGION8_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR8_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR8_U_SMXP_4_0, REGION8_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR8_U_SMXP_4_0, REGION8_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR8_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR8_U_SMXP_4_0, 0x203e898)
    FIELD(POR_MPU_M6_PRLAR8_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR8_U_SMXP_4_0, REGION8_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR8_U_SMXP_4_0, REGION8_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR9_U_SMXP_4_0, 0x203e8a0)
    FIELD(POR_MPU_M6_PRBAR9_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR9_U_SMXP_4_0, REGION9_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR9_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR9_U_SMXP_4_0, REGION9_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR9_U_SMXP_4_0, REGION9_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR9_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR9_U_SMXP_4_0, 0x203e8a8)
    FIELD(POR_MPU_M6_PRLAR9_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR9_U_SMXP_4_0, REGION9_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR9_U_SMXP_4_0, REGION9_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR10_U_SMXP_4_0, 0x203e8b0)
    FIELD(POR_MPU_M6_PRBAR10_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR10_U_SMXP_4_0, REGION10_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR10_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR10_U_SMXP_4_0, REGION10_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR10_U_SMXP_4_0, REGION10_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR10_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR10_U_SMXP_4_0, 0x203e8b8)
    FIELD(POR_MPU_M6_PRLAR10_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR10_U_SMXP_4_0, REGION10_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR10_U_SMXP_4_0, REGION10_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR11_U_SMXP_4_0, 0x203e8c0)
    FIELD(POR_MPU_M6_PRBAR11_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR11_U_SMXP_4_0, REGION11_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR11_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR11_U_SMXP_4_0, REGION11_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR11_U_SMXP_4_0, REGION11_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR11_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR11_U_SMXP_4_0, 0x203e8c8)
    FIELD(POR_MPU_M6_PRLAR11_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR11_U_SMXP_4_0, REGION11_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR11_U_SMXP_4_0, REGION11_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR12_U_SMXP_4_0, 0x203e8d0)
    FIELD(POR_MPU_M6_PRBAR12_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR12_U_SMXP_4_0, REGION12_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR12_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR12_U_SMXP_4_0, REGION12_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR12_U_SMXP_4_0, REGION12_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR12_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR12_U_SMXP_4_0, 0x203e8d8)
    FIELD(POR_MPU_M6_PRLAR12_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR12_U_SMXP_4_0, REGION12_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR12_U_SMXP_4_0, REGION12_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR13_U_SMXP_4_0, 0x203e8e0)
    FIELD(POR_MPU_M6_PRBAR13_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR13_U_SMXP_4_0, REGION13_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR13_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR13_U_SMXP_4_0, REGION13_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR13_U_SMXP_4_0, REGION13_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR13_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR13_U_SMXP_4_0, 0x203e8e8)
    FIELD(POR_MPU_M6_PRLAR13_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR13_U_SMXP_4_0, REGION13_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR13_U_SMXP_4_0, REGION13_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR14_U_SMXP_4_0, 0x203e8f0)
    FIELD(POR_MPU_M6_PRBAR14_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR14_U_SMXP_4_0, REGION14_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR14_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR14_U_SMXP_4_0, REGION14_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR14_U_SMXP_4_0, REGION14_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR14_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR14_U_SMXP_4_0, 0x203e8f8)
    FIELD(POR_MPU_M6_PRLAR14_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR14_U_SMXP_4_0, REGION14_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR14_U_SMXP_4_0, REGION14_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR15_U_SMXP_4_0, 0x203e900)
    FIELD(POR_MPU_M6_PRBAR15_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR15_U_SMXP_4_0, REGION15_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR15_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR15_U_SMXP_4_0, REGION15_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR15_U_SMXP_4_0, REGION15_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR15_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR15_U_SMXP_4_0, 0x203e908)
    FIELD(POR_MPU_M6_PRLAR15_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR15_U_SMXP_4_0, REGION15_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR15_U_SMXP_4_0, REGION15_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR16_U_SMXP_4_0, 0x203e910)
    FIELD(POR_MPU_M6_PRBAR16_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR16_U_SMXP_4_0, REGION16_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR16_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR16_U_SMXP_4_0, REGION16_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR16_U_SMXP_4_0, REGION16_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR16_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR16_U_SMXP_4_0, 0x203e918)
    FIELD(POR_MPU_M6_PRLAR16_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR16_U_SMXP_4_0, REGION16_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR16_U_SMXP_4_0, REGION16_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR17_U_SMXP_4_0, 0x203e920)
    FIELD(POR_MPU_M6_PRBAR17_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR17_U_SMXP_4_0, REGION17_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR17_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR17_U_SMXP_4_0, REGION17_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR17_U_SMXP_4_0, REGION17_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR17_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR17_U_SMXP_4_0, 0x203e928)
    FIELD(POR_MPU_M6_PRLAR17_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR17_U_SMXP_4_0, REGION17_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR17_U_SMXP_4_0, REGION17_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR18_U_SMXP_4_0, 0x203e930)
    FIELD(POR_MPU_M6_PRBAR18_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR18_U_SMXP_4_0, REGION18_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR18_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR18_U_SMXP_4_0, REGION18_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR18_U_SMXP_4_0, REGION18_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR18_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR18_U_SMXP_4_0, 0x203e938)
    FIELD(POR_MPU_M6_PRLAR18_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR18_U_SMXP_4_0, REGION18_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR18_U_SMXP_4_0, REGION18_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR19_U_SMXP_4_0, 0x203e940)
    FIELD(POR_MPU_M6_PRBAR19_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR19_U_SMXP_4_0, REGION19_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR19_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR19_U_SMXP_4_0, REGION19_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR19_U_SMXP_4_0, REGION19_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR19_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR19_U_SMXP_4_0, 0x203e948)
    FIELD(POR_MPU_M6_PRLAR19_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR19_U_SMXP_4_0, REGION19_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR19_U_SMXP_4_0, REGION19_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR20_U_SMXP_4_0, 0x203e950)
    FIELD(POR_MPU_M6_PRBAR20_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR20_U_SMXP_4_0, REGION20_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR20_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR20_U_SMXP_4_0, REGION20_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR20_U_SMXP_4_0, REGION20_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR20_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR20_U_SMXP_4_0, 0x203e958)
    FIELD(POR_MPU_M6_PRLAR20_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR20_U_SMXP_4_0, REGION20_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR20_U_SMXP_4_0, REGION20_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR21_U_SMXP_4_0, 0x203e960)
    FIELD(POR_MPU_M6_PRBAR21_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR21_U_SMXP_4_0, REGION21_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR21_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR21_U_SMXP_4_0, REGION21_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR21_U_SMXP_4_0, REGION21_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR21_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR21_U_SMXP_4_0, 0x203e968)
    FIELD(POR_MPU_M6_PRLAR21_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR21_U_SMXP_4_0, REGION21_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR21_U_SMXP_4_0, REGION21_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR22_U_SMXP_4_0, 0x203e970)
    FIELD(POR_MPU_M6_PRBAR22_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR22_U_SMXP_4_0, REGION22_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR22_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR22_U_SMXP_4_0, REGION22_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR22_U_SMXP_4_0, REGION22_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR22_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR22_U_SMXP_4_0, 0x203e978)
    FIELD(POR_MPU_M6_PRLAR22_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR22_U_SMXP_4_0, REGION22_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR22_U_SMXP_4_0, REGION22_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR23_U_SMXP_4_0, 0x203e980)
    FIELD(POR_MPU_M6_PRBAR23_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR23_U_SMXP_4_0, REGION23_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR23_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR23_U_SMXP_4_0, REGION23_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR23_U_SMXP_4_0, REGION23_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR23_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR23_U_SMXP_4_0, 0x203e988)
    FIELD(POR_MPU_M6_PRLAR23_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR23_U_SMXP_4_0, REGION23_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR23_U_SMXP_4_0, REGION23_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR24_U_SMXP_4_0, 0x203e990)
    FIELD(POR_MPU_M6_PRBAR24_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR24_U_SMXP_4_0, REGION24_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR24_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR24_U_SMXP_4_0, REGION24_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR24_U_SMXP_4_0, REGION24_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR24_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR24_U_SMXP_4_0, 0x203e998)
    FIELD(POR_MPU_M6_PRLAR24_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR24_U_SMXP_4_0, REGION24_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR24_U_SMXP_4_0, REGION24_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR25_U_SMXP_4_0, 0x203e9a0)
    FIELD(POR_MPU_M6_PRBAR25_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR25_U_SMXP_4_0, REGION25_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR25_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR25_U_SMXP_4_0, REGION25_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR25_U_SMXP_4_0, REGION25_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR25_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR25_U_SMXP_4_0, 0x203e9a8)
    FIELD(POR_MPU_M6_PRLAR25_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR25_U_SMXP_4_0, REGION25_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR25_U_SMXP_4_0, REGION25_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR26_U_SMXP_4_0, 0x203e9b0)
    FIELD(POR_MPU_M6_PRBAR26_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR26_U_SMXP_4_0, REGION26_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR26_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR26_U_SMXP_4_0, REGION26_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR26_U_SMXP_4_0, REGION26_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR26_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR26_U_SMXP_4_0, 0x203e9b8)
    FIELD(POR_MPU_M6_PRLAR26_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR26_U_SMXP_4_0, REGION26_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR26_U_SMXP_4_0, REGION26_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR27_U_SMXP_4_0, 0x203e9c0)
    FIELD(POR_MPU_M6_PRBAR27_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR27_U_SMXP_4_0, REGION27_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR27_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR27_U_SMXP_4_0, REGION27_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR27_U_SMXP_4_0, REGION27_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR27_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR27_U_SMXP_4_0, 0x203e9c8)
    FIELD(POR_MPU_M6_PRLAR27_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR27_U_SMXP_4_0, REGION27_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR27_U_SMXP_4_0, REGION27_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR28_U_SMXP_4_0, 0x203e9d0)
    FIELD(POR_MPU_M6_PRBAR28_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR28_U_SMXP_4_0, REGION28_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR28_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR28_U_SMXP_4_0, REGION28_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR28_U_SMXP_4_0, REGION28_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR28_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR28_U_SMXP_4_0, 0x203e9d8)
    FIELD(POR_MPU_M6_PRLAR28_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR28_U_SMXP_4_0, REGION28_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR28_U_SMXP_4_0, REGION28_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR29_U_SMXP_4_0, 0x203e9e0)
    FIELD(POR_MPU_M6_PRBAR29_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR29_U_SMXP_4_0, REGION29_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR29_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR29_U_SMXP_4_0, REGION29_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR29_U_SMXP_4_0, REGION29_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR29_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR29_U_SMXP_4_0, 0x203e9e8)
    FIELD(POR_MPU_M6_PRLAR29_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR29_U_SMXP_4_0, REGION29_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR29_U_SMXP_4_0, REGION29_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR30_U_SMXP_4_0, 0x203e9f0)
    FIELD(POR_MPU_M6_PRBAR30_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR30_U_SMXP_4_0, REGION30_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR30_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR30_U_SMXP_4_0, REGION30_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR30_U_SMXP_4_0, REGION30_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR30_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR30_U_SMXP_4_0, 0x203e9f8)
    FIELD(POR_MPU_M6_PRLAR30_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR30_U_SMXP_4_0, REGION30_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR30_U_SMXP_4_0, REGION30_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR31_U_SMXP_4_0, 0x203ea00)
    FIELD(POR_MPU_M6_PRBAR31_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR31_U_SMXP_4_0, REGION31_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR31_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR31_U_SMXP_4_0, REGION31_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR31_U_SMXP_4_0, REGION31_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR31_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR31_U_SMXP_4_0, 0x203ea08)
    FIELD(POR_MPU_M6_PRLAR31_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR31_U_SMXP_4_0, REGION31_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR31_U_SMXP_4_0, REGION31_EN, 0, 1)
REG32(POR_MPU_M7_CTL_U_SMXP_4_0, 0x203ec00)
    FIELD(POR_MPU_M7_CTL_U_SMXP_4_0, M7_EN, 2, 1)
    FIELD(POR_MPU_M7_CTL_U_SMXP_4_0, M7_ACTION, 0, 2)
REG32(POR_MPU_M7_PRBAR0_U_SMXP_4_0, 0x203ec10)
    FIELD(POR_MPU_M7_PRBAR0_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR0_U_SMXP_4_0, REGION0_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR0_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR0_U_SMXP_4_0, REGION0_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR0_U_SMXP_4_0, REGION0_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR0_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR0_U_SMXP_4_0, 0x203ec18)
    FIELD(POR_MPU_M7_PRLAR0_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR0_U_SMXP_4_0, REGION0_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR0_U_SMXP_4_0, REGION0_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR1_U_SMXP_4_0, 0x203ec20)
    FIELD(POR_MPU_M7_PRBAR1_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR1_U_SMXP_4_0, REGION1_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR1_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR1_U_SMXP_4_0, REGION1_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR1_U_SMXP_4_0, REGION1_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR1_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR1_U_SMXP_4_0, 0x203ec28)
    FIELD(POR_MPU_M7_PRLAR1_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR1_U_SMXP_4_0, REGION1_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR1_U_SMXP_4_0, REGION1_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR2_U_SMXP_4_0, 0x203ec30)
    FIELD(POR_MPU_M7_PRBAR2_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR2_U_SMXP_4_0, REGION2_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR2_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR2_U_SMXP_4_0, REGION2_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR2_U_SMXP_4_0, REGION2_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR2_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR2_U_SMXP_4_0, 0x203ec38)
    FIELD(POR_MPU_M7_PRLAR2_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR2_U_SMXP_4_0, REGION2_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR2_U_SMXP_4_0, REGION2_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR3_U_SMXP_4_0, 0x203ec40)
    FIELD(POR_MPU_M7_PRBAR3_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR3_U_SMXP_4_0, REGION3_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR3_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR3_U_SMXP_4_0, REGION3_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR3_U_SMXP_4_0, REGION3_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR3_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR3_U_SMXP_4_0, 0x203ec48)
    FIELD(POR_MPU_M7_PRLAR3_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR3_U_SMXP_4_0, REGION3_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR3_U_SMXP_4_0, REGION3_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR4_U_SMXP_4_0, 0x203ec50)
    FIELD(POR_MPU_M7_PRBAR4_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR4_U_SMXP_4_0, REGION4_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR4_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR4_U_SMXP_4_0, REGION4_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR4_U_SMXP_4_0, REGION4_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR4_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR4_U_SMXP_4_0, 0x203ec58)
    FIELD(POR_MPU_M7_PRLAR4_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR4_U_SMXP_4_0, REGION4_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR4_U_SMXP_4_0, REGION4_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR5_U_SMXP_4_0, 0x203ec60)
    FIELD(POR_MPU_M7_PRBAR5_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR5_U_SMXP_4_0, REGION5_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR5_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR5_U_SMXP_4_0, REGION5_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR5_U_SMXP_4_0, REGION5_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR5_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR5_U_SMXP_4_0, 0x203ec68)
    FIELD(POR_MPU_M7_PRLAR5_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR5_U_SMXP_4_0, REGION5_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR5_U_SMXP_4_0, REGION5_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR6_U_SMXP_4_0, 0x203ec70)
    FIELD(POR_MPU_M7_PRBAR6_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR6_U_SMXP_4_0, REGION6_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR6_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR6_U_SMXP_4_0, REGION6_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR6_U_SMXP_4_0, REGION6_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR6_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR6_U_SMXP_4_0, 0x203ec78)
    FIELD(POR_MPU_M7_PRLAR6_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR6_U_SMXP_4_0, REGION6_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR6_U_SMXP_4_0, REGION6_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR7_U_SMXP_4_0, 0x203ec80)
    FIELD(POR_MPU_M7_PRBAR7_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR7_U_SMXP_4_0, REGION7_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR7_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR7_U_SMXP_4_0, REGION7_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR7_U_SMXP_4_0, REGION7_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR7_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR7_U_SMXP_4_0, 0x203ec88)
    FIELD(POR_MPU_M7_PRLAR7_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR7_U_SMXP_4_0, REGION7_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR7_U_SMXP_4_0, REGION7_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR8_U_SMXP_4_0, 0x203ec90)
    FIELD(POR_MPU_M7_PRBAR8_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR8_U_SMXP_4_0, REGION8_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR8_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR8_U_SMXP_4_0, REGION8_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR8_U_SMXP_4_0, REGION8_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR8_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR8_U_SMXP_4_0, 0x203ec98)
    FIELD(POR_MPU_M7_PRLAR8_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR8_U_SMXP_4_0, REGION8_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR8_U_SMXP_4_0, REGION8_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR9_U_SMXP_4_0, 0x203eca0)
    FIELD(POR_MPU_M7_PRBAR9_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR9_U_SMXP_4_0, REGION9_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR9_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR9_U_SMXP_4_0, REGION9_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR9_U_SMXP_4_0, REGION9_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR9_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR9_U_SMXP_4_0, 0x203eca8)
    FIELD(POR_MPU_M7_PRLAR9_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR9_U_SMXP_4_0, REGION9_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR9_U_SMXP_4_0, REGION9_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR10_U_SMXP_4_0, 0x203ecb0)
    FIELD(POR_MPU_M7_PRBAR10_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR10_U_SMXP_4_0, REGION10_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR10_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR10_U_SMXP_4_0, REGION10_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR10_U_SMXP_4_0, REGION10_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR10_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR10_U_SMXP_4_0, 0x203ecb8)
    FIELD(POR_MPU_M7_PRLAR10_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR10_U_SMXP_4_0, REGION10_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR10_U_SMXP_4_0, REGION10_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR11_U_SMXP_4_0, 0x203ecc0)
    FIELD(POR_MPU_M7_PRBAR11_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR11_U_SMXP_4_0, REGION11_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR11_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR11_U_SMXP_4_0, REGION11_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR11_U_SMXP_4_0, REGION11_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR11_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR11_U_SMXP_4_0, 0x203ecc8)
    FIELD(POR_MPU_M7_PRLAR11_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR11_U_SMXP_4_0, REGION11_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR11_U_SMXP_4_0, REGION11_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR12_U_SMXP_4_0, 0x203ecd0)
    FIELD(POR_MPU_M7_PRBAR12_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR12_U_SMXP_4_0, REGION12_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR12_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR12_U_SMXP_4_0, REGION12_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR12_U_SMXP_4_0, REGION12_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR12_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR12_U_SMXP_4_0, 0x203ecd8)
    FIELD(POR_MPU_M7_PRLAR12_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR12_U_SMXP_4_0, REGION12_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR12_U_SMXP_4_0, REGION12_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR13_U_SMXP_4_0, 0x203ece0)
    FIELD(POR_MPU_M7_PRBAR13_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR13_U_SMXP_4_0, REGION13_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR13_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR13_U_SMXP_4_0, REGION13_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR13_U_SMXP_4_0, REGION13_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR13_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR13_U_SMXP_4_0, 0x203ece8)
    FIELD(POR_MPU_M7_PRLAR13_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR13_U_SMXP_4_0, REGION13_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR13_U_SMXP_4_0, REGION13_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR14_U_SMXP_4_0, 0x203ecf0)
    FIELD(POR_MPU_M7_PRBAR14_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR14_U_SMXP_4_0, REGION14_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR14_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR14_U_SMXP_4_0, REGION14_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR14_U_SMXP_4_0, REGION14_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR14_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR14_U_SMXP_4_0, 0x203ecf8)
    FIELD(POR_MPU_M7_PRLAR14_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR14_U_SMXP_4_0, REGION14_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR14_U_SMXP_4_0, REGION14_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR15_U_SMXP_4_0, 0x203ed00)
    FIELD(POR_MPU_M7_PRBAR15_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR15_U_SMXP_4_0, REGION15_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR15_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR15_U_SMXP_4_0, REGION15_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR15_U_SMXP_4_0, REGION15_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR15_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR15_U_SMXP_4_0, 0x203ed08)
    FIELD(POR_MPU_M7_PRLAR15_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR15_U_SMXP_4_0, REGION15_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR15_U_SMXP_4_0, REGION15_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR16_U_SMXP_4_0, 0x203ed10)
    FIELD(POR_MPU_M7_PRBAR16_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR16_U_SMXP_4_0, REGION16_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR16_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR16_U_SMXP_4_0, REGION16_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR16_U_SMXP_4_0, REGION16_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR16_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR16_U_SMXP_4_0, 0x203ed18)
    FIELD(POR_MPU_M7_PRLAR16_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR16_U_SMXP_4_0, REGION16_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR16_U_SMXP_4_0, REGION16_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR17_U_SMXP_4_0, 0x203ed20)
    FIELD(POR_MPU_M7_PRBAR17_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR17_U_SMXP_4_0, REGION17_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR17_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR17_U_SMXP_4_0, REGION17_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR17_U_SMXP_4_0, REGION17_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR17_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR17_U_SMXP_4_0, 0x203ed28)
    FIELD(POR_MPU_M7_PRLAR17_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR17_U_SMXP_4_0, REGION17_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR17_U_SMXP_4_0, REGION17_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR18_U_SMXP_4_0, 0x203ed30)
    FIELD(POR_MPU_M7_PRBAR18_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR18_U_SMXP_4_0, REGION18_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR18_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR18_U_SMXP_4_0, REGION18_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR18_U_SMXP_4_0, REGION18_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR18_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR18_U_SMXP_4_0, 0x203ed38)
    FIELD(POR_MPU_M7_PRLAR18_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR18_U_SMXP_4_0, REGION18_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR18_U_SMXP_4_0, REGION18_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR19_U_SMXP_4_0, 0x203ed40)
    FIELD(POR_MPU_M7_PRBAR19_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR19_U_SMXP_4_0, REGION19_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR19_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR19_U_SMXP_4_0, REGION19_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR19_U_SMXP_4_0, REGION19_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR19_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR19_U_SMXP_4_0, 0x203ed48)
    FIELD(POR_MPU_M7_PRLAR19_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR19_U_SMXP_4_0, REGION19_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR19_U_SMXP_4_0, REGION19_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR20_U_SMXP_4_0, 0x203ed50)
    FIELD(POR_MPU_M7_PRBAR20_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR20_U_SMXP_4_0, REGION20_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR20_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR20_U_SMXP_4_0, REGION20_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR20_U_SMXP_4_0, REGION20_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR20_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR20_U_SMXP_4_0, 0x203ed58)
    FIELD(POR_MPU_M7_PRLAR20_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR20_U_SMXP_4_0, REGION20_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR20_U_SMXP_4_0, REGION20_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR21_U_SMXP_4_0, 0x203ed60)
    FIELD(POR_MPU_M7_PRBAR21_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR21_U_SMXP_4_0, REGION21_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR21_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR21_U_SMXP_4_0, REGION21_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR21_U_SMXP_4_0, REGION21_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR21_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR21_U_SMXP_4_0, 0x203ed68)
    FIELD(POR_MPU_M7_PRLAR21_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR21_U_SMXP_4_0, REGION21_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR21_U_SMXP_4_0, REGION21_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR22_U_SMXP_4_0, 0x203ed70)
    FIELD(POR_MPU_M7_PRBAR22_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR22_U_SMXP_4_0, REGION22_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR22_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR22_U_SMXP_4_0, REGION22_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR22_U_SMXP_4_0, REGION22_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR22_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR22_U_SMXP_4_0, 0x203ed78)
    FIELD(POR_MPU_M7_PRLAR22_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR22_U_SMXP_4_0, REGION22_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR22_U_SMXP_4_0, REGION22_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR23_U_SMXP_4_0, 0x203ed80)
    FIELD(POR_MPU_M7_PRBAR23_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR23_U_SMXP_4_0, REGION23_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR23_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR23_U_SMXP_4_0, REGION23_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR23_U_SMXP_4_0, REGION23_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR23_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR23_U_SMXP_4_0, 0x203ed88)
    FIELD(POR_MPU_M7_PRLAR23_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR23_U_SMXP_4_0, REGION23_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR23_U_SMXP_4_0, REGION23_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR24_U_SMXP_4_0, 0x203ed90)
    FIELD(POR_MPU_M7_PRBAR24_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR24_U_SMXP_4_0, REGION24_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR24_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR24_U_SMXP_4_0, REGION24_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR24_U_SMXP_4_0, REGION24_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR24_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR24_U_SMXP_4_0, 0x203ed98)
    FIELD(POR_MPU_M7_PRLAR24_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR24_U_SMXP_4_0, REGION24_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR24_U_SMXP_4_0, REGION24_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR25_U_SMXP_4_0, 0x203eda0)
    FIELD(POR_MPU_M7_PRBAR25_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR25_U_SMXP_4_0, REGION25_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR25_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR25_U_SMXP_4_0, REGION25_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR25_U_SMXP_4_0, REGION25_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR25_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR25_U_SMXP_4_0, 0x203eda8)
    FIELD(POR_MPU_M7_PRLAR25_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR25_U_SMXP_4_0, REGION25_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR25_U_SMXP_4_0, REGION25_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR26_U_SMXP_4_0, 0x203edb0)
    FIELD(POR_MPU_M7_PRBAR26_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR26_U_SMXP_4_0, REGION26_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR26_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR26_U_SMXP_4_0, REGION26_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR26_U_SMXP_4_0, REGION26_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR26_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR26_U_SMXP_4_0, 0x203edb8)
    FIELD(POR_MPU_M7_PRLAR26_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR26_U_SMXP_4_0, REGION26_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR26_U_SMXP_4_0, REGION26_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR27_U_SMXP_4_0, 0x203edc0)
    FIELD(POR_MPU_M7_PRBAR27_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR27_U_SMXP_4_0, REGION27_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR27_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR27_U_SMXP_4_0, REGION27_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR27_U_SMXP_4_0, REGION27_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR27_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR27_U_SMXP_4_0, 0x203edc8)
    FIELD(POR_MPU_M7_PRLAR27_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR27_U_SMXP_4_0, REGION27_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR27_U_SMXP_4_0, REGION27_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR28_U_SMXP_4_0, 0x203edd0)
    FIELD(POR_MPU_M7_PRBAR28_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR28_U_SMXP_4_0, REGION28_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR28_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR28_U_SMXP_4_0, REGION28_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR28_U_SMXP_4_0, REGION28_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR28_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR28_U_SMXP_4_0, 0x203edd8)
    FIELD(POR_MPU_M7_PRLAR28_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR28_U_SMXP_4_0, REGION28_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR28_U_SMXP_4_0, REGION28_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR29_U_SMXP_4_0, 0x203ede0)
    FIELD(POR_MPU_M7_PRBAR29_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR29_U_SMXP_4_0, REGION29_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR29_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR29_U_SMXP_4_0, REGION29_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR29_U_SMXP_4_0, REGION29_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR29_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR29_U_SMXP_4_0, 0x203ede8)
    FIELD(POR_MPU_M7_PRLAR29_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR29_U_SMXP_4_0, REGION29_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR29_U_SMXP_4_0, REGION29_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR30_U_SMXP_4_0, 0x203edf0)
    FIELD(POR_MPU_M7_PRBAR30_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR30_U_SMXP_4_0, REGION30_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR30_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR30_U_SMXP_4_0, REGION30_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR30_U_SMXP_4_0, REGION30_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR30_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR30_U_SMXP_4_0, 0x203edf8)
    FIELD(POR_MPU_M7_PRLAR30_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR30_U_SMXP_4_0, REGION30_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR30_U_SMXP_4_0, REGION30_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR31_U_SMXP_4_0, 0x203ee00)
    FIELD(POR_MPU_M7_PRBAR31_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR31_U_SMXP_4_0, REGION31_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR31_U_SMXP_4_0, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR31_U_SMXP_4_0, REGION31_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR31_U_SMXP_4_0, REGION31_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR31_U_SMXP_4_0, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR31_U_SMXP_4_0, 0x203ee08)
    FIELD(POR_MPU_M7_PRLAR31_U_SMXP_4_0, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR31_U_SMXP_4_0, REGION31_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR31_U_SMXP_4_0, REGION31_EN, 0, 1)
REG32(POR_HNI_NODE_INFO_U_HND_NID256, 0x2050000)
    FIELD(POR_HNI_NODE_INFO_U_HND_NID256, RESERVED_48, 48, 16)
    FIELD(POR_HNI_NODE_INFO_U_HND_NID256, LOGICAL_ID, 32, 16)
    FIELD(POR_HNI_NODE_INFO_U_HND_NID256, NODE_ID, 16, 16)
    FIELD(POR_HNI_NODE_INFO_U_HND_NID256, NODE_TYPE, 0, 16)
REG32(POR_HNI_CHILD_INFO_U_HND_NID256, 0x2050080)
    FIELD(POR_HNI_CHILD_INFO_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_HNI_CHILD_INFO_U_HND_NID256, CHILD_PTR_OFFSET, 16, 16)
    FIELD(POR_HNI_CHILD_INFO_U_HND_NID256, CHILD_COUNT, 0, 16)
REG32(POR_HNI_UNIT_INFO_U_HND_NID256, 0x2050900)
    FIELD(POR_HNI_UNIT_INFO_U_HND_NID256, RESERVED_30, 30, 34)
    FIELD(POR_HNI_UNIT_INFO_U_HND_NID256, APB_SAFE_XFACE_DISABLE, 29, 1)
    FIELD(POR_HNI_UNIT_INFO_U_HND_NID256, ACEL_SAFE_XFACE_DISABLE, 28, 1)
    FIELD(POR_HNI_UNIT_INFO_U_HND_NID256, AXDATA_POISON_EN, 27, 1)
    FIELD(POR_HNI_UNIT_INFO_U_HND_NID256, A4S_NUM, 25, 2)
    FIELD(POR_HNI_UNIT_INFO_U_HND_NID256, AXDATA_WIDTH, 24, 1)
    FIELD(POR_HNI_UNIT_INFO_U_HND_NID256, RESERVED_21, 21, 3)
    FIELD(POR_HNI_UNIT_INFO_U_HND_NID256, NUM_WR_DATA_BUF, 16, 5)
    FIELD(POR_HNI_UNIT_INFO_U_HND_NID256, NUM_AX_REQS, 8, 8)
    FIELD(POR_HNI_UNIT_INFO_U_HND_NID256, NUM_EXCL, 0, 8)
REG32(POR_HNI_SECURE_REGISTER_GROUPS_OVERRIDE_U_HND_NID256, 0x2050980)
    FIELD(POR_HNI_SECURE_REGISTER_GROUPS_OVERRIDE_U_HND_NID256, SAM, 1, 1)
    FIELD(POR_HNI_SECURE_REGISTER_GROUPS_OVERRIDE_U_HND_NID256, CFG_CTL, 0, 1)
REG32(POR_HNI_CFG_CTL_U_HND_NID256, 0x2050a00)
    FIELD(POR_HNI_CFG_CTL_U_HND_NID256, REQERR_COHREQ_EN, 0, 1)
REG32(POR_HNI_AUX_CTL_U_HND_NID256, 0x2050a08)
    FIELD(POR_HNI_AUX_CTL_U_HND_NID256, DISABLE_MPU_ERR_LOGGING, 5, 1)
    FIELD(POR_HNI_AUX_CTL_U_HND_NID256, SIDE_READER_FOR_PHYMEM_PRESENT, 4, 1)
    FIELD(POR_HNI_AUX_CTL_U_HND_NID256, CG_DISABLE, 0, 1)
REG32(POR_HNI_SAM_ADDRREGION0_CFG_U_HND_NID256, 0x2050c00)
    FIELD(POR_HNI_SAM_ADDRREGION0_CFG_U_HND_NID256, RESERVED_63, 63, 1)
    FIELD(POR_HNI_SAM_ADDRREGION0_CFG_U_HND_NID256, POS_EARLY_WR_COMP_EN, 62, 1)
    FIELD(POR_HNI_SAM_ADDRREGION0_CFG_U_HND_NID256, POS_EARLY_RDACK_EN, 61, 1)
    FIELD(POR_HNI_SAM_ADDRREGION0_CFG_U_HND_NID256, SER_DEVNE_WR, 60, 1)
    FIELD(POR_HNI_SAM_ADDRREGION0_CFG_U_HND_NID256, SER_ALL_WR, 59, 1)
    FIELD(POR_HNI_SAM_ADDRREGION0_CFG_U_HND_NID256, PHYSICAL_MEM_EN, 58, 1)
    FIELD(POR_HNI_SAM_ADDRREGION0_CFG_U_HND_NID256, ORDER_REGION_SIZE, 0, 6)
REG32(POR_HNI_SAM_ADDRREGION1_CFG_U_HND_NID256, 0x2050c08)
    FIELD(POR_HNI_SAM_ADDRREGION1_CFG_U_HND_NID256, VALID, 63, 1)
    FIELD(POR_HNI_SAM_ADDRREGION1_CFG_U_HND_NID256, POS_EARLY_WR_COMP_EN, 62, 1)
    FIELD(POR_HNI_SAM_ADDRREGION1_CFG_U_HND_NID256, POS_EARLY_RDACK_EN, 61, 1)
    FIELD(POR_HNI_SAM_ADDRREGION1_CFG_U_HND_NID256, SER_DEVNE_WR, 60, 1)
    FIELD(POR_HNI_SAM_ADDRREGION1_CFG_U_HND_NID256, SER_ALL_WR, 59, 1)
    FIELD(POR_HNI_SAM_ADDRREGION1_CFG_U_HND_NID256, PHYSICAL_MEM_EN, 58, 1)
    FIELD(POR_HNI_SAM_ADDRREGION1_CFG_U_HND_NID256, RESERVED_56, 56, 2)
    FIELD(POR_HNI_SAM_ADDRREGION1_CFG_U_HND_NID256, BASE_ADDR, 20, 36)
    FIELD(POR_HNI_SAM_ADDRREGION1_CFG_U_HND_NID256, RESERVED_16, 16, 4)
    FIELD(POR_HNI_SAM_ADDRREGION1_CFG_U_HND_NID256, ADDR_REGION_SIZE, 10, 6)
    FIELD(POR_HNI_SAM_ADDRREGION1_CFG_U_HND_NID256, ORDER_REGION_SIZE, 0, 6)
REG32(POR_HNI_SAM_ADDRREGION2_CFG_U_HND_NID256, 0x2050c10)
    FIELD(POR_HNI_SAM_ADDRREGION2_CFG_U_HND_NID256, VALID, 63, 1)
    FIELD(POR_HNI_SAM_ADDRREGION2_CFG_U_HND_NID256, POS_EARLY_WR_COMP_EN, 62, 1)
    FIELD(POR_HNI_SAM_ADDRREGION2_CFG_U_HND_NID256, POS_EARLY_RDACK_EN, 61, 1)
    FIELD(POR_HNI_SAM_ADDRREGION2_CFG_U_HND_NID256, SER_DEVNE_WR, 60, 1)
    FIELD(POR_HNI_SAM_ADDRREGION2_CFG_U_HND_NID256, SER_ALL_WR, 59, 1)
    FIELD(POR_HNI_SAM_ADDRREGION2_CFG_U_HND_NID256, PHYSICAL_MEM_EN, 58, 1)
    FIELD(POR_HNI_SAM_ADDRREGION2_CFG_U_HND_NID256, RESERVED_56, 56, 2)
    FIELD(POR_HNI_SAM_ADDRREGION2_CFG_U_HND_NID256, BASE_ADDR, 20, 36)
    FIELD(POR_HNI_SAM_ADDRREGION2_CFG_U_HND_NID256, RESERVED_16, 16, 4)
    FIELD(POR_HNI_SAM_ADDRREGION2_CFG_U_HND_NID256, ADDR_REGION_SIZE, 10, 6)
    FIELD(POR_HNI_SAM_ADDRREGION2_CFG_U_HND_NID256, ORDER_REGION_SIZE, 0, 6)
REG32(POR_HNI_SAM_ADDRREGION3_CFG_U_HND_NID256, 0x2050c18)
    FIELD(POR_HNI_SAM_ADDRREGION3_CFG_U_HND_NID256, VALID, 63, 1)
    FIELD(POR_HNI_SAM_ADDRREGION3_CFG_U_HND_NID256, POS_EARLY_WR_COMP_EN, 62, 1)
    FIELD(POR_HNI_SAM_ADDRREGION3_CFG_U_HND_NID256, POS_EARLY_RDACK_EN, 61, 1)
    FIELD(POR_HNI_SAM_ADDRREGION3_CFG_U_HND_NID256, SER_DEVNE_WR, 60, 1)
    FIELD(POR_HNI_SAM_ADDRREGION3_CFG_U_HND_NID256, SER_ALL_WR, 59, 1)
    FIELD(POR_HNI_SAM_ADDRREGION3_CFG_U_HND_NID256, PHYSICAL_MEM_EN, 58, 1)
    FIELD(POR_HNI_SAM_ADDRREGION3_CFG_U_HND_NID256, RESERVED_56, 56, 2)
    FIELD(POR_HNI_SAM_ADDRREGION3_CFG_U_HND_NID256, BASE_ADDR, 20, 36)
    FIELD(POR_HNI_SAM_ADDRREGION3_CFG_U_HND_NID256, RESERVED_16, 16, 4)
    FIELD(POR_HNI_SAM_ADDRREGION3_CFG_U_HND_NID256, ADDR_REGION_SIZE, 10, 6)
    FIELD(POR_HNI_SAM_ADDRREGION3_CFG_U_HND_NID256, ORDER_REGION_SIZE, 0, 6)
REG32(POR_HNI_PMU_EVENT_SEL_U_HND_NID256, 0x2052000)
    FIELD(POR_HNI_PMU_EVENT_SEL_U_HND_NID256, RESERVED_30, 30, 34)
    FIELD(POR_HNI_PMU_EVENT_SEL_U_HND_NID256, PMU_EVENT3_ID, 24, 6)
    FIELD(POR_HNI_PMU_EVENT_SEL_U_HND_NID256, RESERVED_22, 22, 2)
    FIELD(POR_HNI_PMU_EVENT_SEL_U_HND_NID256, PMU_EVENT2_ID, 16, 6)
    FIELD(POR_HNI_PMU_EVENT_SEL_U_HND_NID256, RESERVED_14, 14, 2)
    FIELD(POR_HNI_PMU_EVENT_SEL_U_HND_NID256, PMU_EVENT1_ID, 8, 6)
    FIELD(POR_HNI_PMU_EVENT_SEL_U_HND_NID256, PMU_EVENT0_ID, 0, 6)
REG32(POR_HNI_ERRFR_U_HND_NID256, 0x2053000)
    FIELD(POR_HNI_ERRFR_U_HND_NID256, RESERVED_15, 15, 49)
    FIELD(POR_HNI_ERRFR_U_HND_NID256, CEC, 12, 3)
    FIELD(POR_HNI_ERRFR_U_HND_NID256, CFI, 10, 2)
    FIELD(POR_HNI_ERRFR_U_HND_NID256, FI, 6, 2)
    FIELD(POR_HNI_ERRFR_U_HND_NID256, UI, 4, 2)
    FIELD(POR_HNI_ERRFR_U_HND_NID256, DE, 2, 2)
    FIELD(POR_HNI_ERRFR_U_HND_NID256, ED, 0, 2)
REG32(POR_HNI_ERRCTLR_U_HND_NID256, 0x2053008)
    FIELD(POR_HNI_ERRCTLR_U_HND_NID256, RESERVED_9, 9, 55)
    FIELD(POR_HNI_ERRCTLR_U_HND_NID256, CFI, 8, 1)
    FIELD(POR_HNI_ERRCTLR_U_HND_NID256, FI, 3, 1)
    FIELD(POR_HNI_ERRCTLR_U_HND_NID256, UI, 2, 1)
    FIELD(POR_HNI_ERRCTLR_U_HND_NID256, DE, 1, 1)
    FIELD(POR_HNI_ERRCTLR_U_HND_NID256, ED, 0, 1)
REG32(POR_HNI_ERRSTATUS_U_HND_NID256, 0x2053010)
    FIELD(POR_HNI_ERRSTATUS_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_HNI_ERRSTATUS_U_HND_NID256, AV, 31, 1)
    FIELD(POR_HNI_ERRSTATUS_U_HND_NID256, V, 30, 1)
    FIELD(POR_HNI_ERRSTATUS_U_HND_NID256, UE, 29, 1)
    FIELD(POR_HNI_ERRSTATUS_U_HND_NID256, RESERVED_28, 28, 1)
    FIELD(POR_HNI_ERRSTATUS_U_HND_NID256, OF, 27, 1)
    FIELD(POR_HNI_ERRSTATUS_U_HND_NID256, MV, 26, 1)
    FIELD(POR_HNI_ERRSTATUS_U_HND_NID256, RESERVED_25, 25, 1)
    FIELD(POR_HNI_ERRSTATUS_U_HND_NID256, CE, 24, 1)
    FIELD(POR_HNI_ERRSTATUS_U_HND_NID256, DE, 23, 1)
    FIELD(POR_HNI_ERRSTATUS_U_HND_NID256, RESERVED_0, 0, 23)
REG32(POR_HNI_ERRADDR_U_HND_NID256, 0x2053018)
    FIELD(POR_HNI_ERRADDR_U_HND_NID256, NS, 63, 1)
    FIELD(POR_HNI_ERRADDR_U_HND_NID256, RESERVED_48, 48, 15)
    FIELD(POR_HNI_ERRADDR_U_HND_NID256, ADDR, 0, 48)
REG32(POR_HNI_ERRMISC_U_HND_NID256, 0x2053020)
    FIELD(POR_HNI_ERRMISC_U_HND_NID256, RESERVED_57, 57, 7)
    FIELD(POR_HNI_ERRMISC_U_HND_NID256, LPID, 52, 5)
    FIELD(POR_HNI_ERRMISC_U_HND_NID256, RESERVED_50, 50, 2)
    FIELD(POR_HNI_ERRMISC_U_HND_NID256, ORDER, 48, 2)
    FIELD(POR_HNI_ERRMISC_U_HND_NID256, RESERVED_31, 31, 17)
    FIELD(POR_HNI_ERRMISC_U_HND_NID256, SIZE, 28, 3)
    FIELD(POR_HNI_ERRMISC_U_HND_NID256, MEMATTR, 24, 4)
    FIELD(POR_HNI_ERRMISC_U_HND_NID256, RESERVED_22, 22, 2)
    FIELD(POR_HNI_ERRMISC_U_HND_NID256, OPCODE, 16, 6)
    FIELD(POR_HNI_ERRMISC_U_HND_NID256, RESERVED_15, 15, 1)
    FIELD(POR_HNI_ERRMISC_U_HND_NID256, SRCID, 4, 11)
    FIELD(POR_HNI_ERRMISC_U_HND_NID256, ERRSRC, 0, 4)
REG32(POR_HNI_ERRFR_NS_U_HND_NID256, 0x2053100)
    FIELD(POR_HNI_ERRFR_NS_U_HND_NID256, RESERVED_15, 15, 49)
    FIELD(POR_HNI_ERRFR_NS_U_HND_NID256, CEC, 12, 3)
    FIELD(POR_HNI_ERRFR_NS_U_HND_NID256, CFI, 10, 2)
    FIELD(POR_HNI_ERRFR_NS_U_HND_NID256, FI, 6, 2)
    FIELD(POR_HNI_ERRFR_NS_U_HND_NID256, UI, 4, 2)
    FIELD(POR_HNI_ERRFR_NS_U_HND_NID256, DE, 2, 2)
    FIELD(POR_HNI_ERRFR_NS_U_HND_NID256, ED, 0, 2)
REG32(POR_HNI_ERRCTLR_NS_U_HND_NID256, 0x2053108)
    FIELD(POR_HNI_ERRCTLR_NS_U_HND_NID256, RESERVED_9, 9, 55)
    FIELD(POR_HNI_ERRCTLR_NS_U_HND_NID256, CFI, 8, 1)
    FIELD(POR_HNI_ERRCTLR_NS_U_HND_NID256, FI, 3, 1)
    FIELD(POR_HNI_ERRCTLR_NS_U_HND_NID256, UI, 2, 1)
    FIELD(POR_HNI_ERRCTLR_NS_U_HND_NID256, DE, 1, 1)
    FIELD(POR_HNI_ERRCTLR_NS_U_HND_NID256, ED, 0, 1)
REG32(POR_HNI_ERRSTATUS_NS_U_HND_NID256, 0x2053110)
    FIELD(POR_HNI_ERRSTATUS_NS_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_HNI_ERRSTATUS_NS_U_HND_NID256, AV, 31, 1)
    FIELD(POR_HNI_ERRSTATUS_NS_U_HND_NID256, V, 30, 1)
    FIELD(POR_HNI_ERRSTATUS_NS_U_HND_NID256, UE, 29, 1)
    FIELD(POR_HNI_ERRSTATUS_NS_U_HND_NID256, RESERVED_28, 28, 1)
    FIELD(POR_HNI_ERRSTATUS_NS_U_HND_NID256, OF, 27, 1)
    FIELD(POR_HNI_ERRSTATUS_NS_U_HND_NID256, MV, 26, 1)
    FIELD(POR_HNI_ERRSTATUS_NS_U_HND_NID256, RESERVED_25, 25, 1)
    FIELD(POR_HNI_ERRSTATUS_NS_U_HND_NID256, CE, 24, 1)
    FIELD(POR_HNI_ERRSTATUS_NS_U_HND_NID256, DE, 23, 1)
    FIELD(POR_HNI_ERRSTATUS_NS_U_HND_NID256, RESERVED_0, 0, 23)
REG32(POR_HNI_ERRADDR_NS_U_HND_NID256, 0x2053118)
    FIELD(POR_HNI_ERRADDR_NS_U_HND_NID256, NS, 63, 1)
    FIELD(POR_HNI_ERRADDR_NS_U_HND_NID256, RESERVED_48, 48, 15)
    FIELD(POR_HNI_ERRADDR_NS_U_HND_NID256, ADDR, 0, 48)
REG32(POR_HNI_ERRMISC_NS_U_HND_NID256, 0x2053120)
    FIELD(POR_HNI_ERRMISC_NS_U_HND_NID256, RESERVED_57, 57, 7)
    FIELD(POR_HNI_ERRMISC_NS_U_HND_NID256, LPID, 52, 5)
    FIELD(POR_HNI_ERRMISC_NS_U_HND_NID256, RESERVED_50, 50, 2)
    FIELD(POR_HNI_ERRMISC_NS_U_HND_NID256, ORDER, 48, 2)
    FIELD(POR_HNI_ERRMISC_NS_U_HND_NID256, RESERVED_31, 31, 17)
    FIELD(POR_HNI_ERRMISC_NS_U_HND_NID256, SIZE, 28, 3)
    FIELD(POR_HNI_ERRMISC_NS_U_HND_NID256, MEMATTR, 24, 4)
    FIELD(POR_HNI_ERRMISC_NS_U_HND_NID256, RESERVED_22, 22, 2)
    FIELD(POR_HNI_ERRMISC_NS_U_HND_NID256, OPCODE, 16, 6)
    FIELD(POR_HNI_ERRMISC_NS_U_HND_NID256, RESERVED_15, 15, 1)
    FIELD(POR_HNI_ERRMISC_NS_U_HND_NID256, SRCID, 4, 11)
    FIELD(POR_HNI_ERRMISC_NS_U_HND_NID256, ERRSRC, 0, 4)
REG32(POR_FMU_NODE_INFO_U_HND_NID256, 0x20a0000)
    FIELD(POR_FMU_NODE_INFO_U_HND_NID256, RESERVED_48, 48, 16)
    FIELD(POR_FMU_NODE_INFO_U_HND_NID256, LOGICAL_ID, 32, 16)
    FIELD(POR_FMU_NODE_INFO_U_HND_NID256, NODE_ID, 16, 16)
    FIELD(POR_FMU_NODE_INFO_U_HND_NID256, NODE_TYPE, 0, 16)
REG32(POR_FMU_CHILD_INFO_U_HND_NID256, 0x20a0080)
    FIELD(POR_FMU_CHILD_INFO_U_HND_NID256, RESERVED_32, 32, 32)
    FIELD(POR_FMU_CHILD_INFO_U_HND_NID256, CHILD_PTR_OFFSET, 16, 16)
    FIELD(POR_FMU_CHILD_INFO_U_HND_NID256, CHILD_COUNT, 0, 16)
REG32(POR_FMU_CTL_U_HND_NID256, 0x20a0c10)
    FIELD(POR_FMU_CTL_U_HND_NID256, APB_ACCESS_OVERRIDE, 3, 1)
    FIELD(POR_FMU_CTL_U_HND_NID256, FMU_ERRGSR_DISABLE, 2, 1)
    FIELD(POR_FMU_CTL_U_HND_NID256, FHI_EN, 1, 1)
    FIELD(POR_FMU_CTL_U_HND_NID256, ERI_EN, 0, 1)
REG32(POR_FMU_KEY_U_HND_NID256, 0x20a0c18)
    FIELD(POR_FMU_KEY_U_HND_NID256, KEY, 0, 8)
REG32(POR_FMU_ERRGSR_CLK_MXP_U_HND_NID256, 0x20a3008)
REG32(POR_FMU_ERRGSR_RST_MXP_U_HND_NID256, 0x20a3010)
REG32(POR_FMU_ERRGSR_LSC_MXP_U_HND_NID256, 0x20a3018)
REG32(POR_FMU_ERRGSR_IOC_MXP_U_HND_NID256, 0x20a3020)
REG32(POR_FMU_ERRGSR_ASYNC_MXP_U_HND_NID256, 0x20a3028)
REG32(POR_FMU_ERRGSR_HANG_MXP_U_HND_NID256, 0x20a3030)
REG32(POR_FMU_ERRGSR_MPU_MXP_U_HND_NID256, 0x20a3038)
REG32(POR_FMU_ERRGSR_ECCUE_MXP_U_HND_NID256, 0x20a3040)
REG32(POR_FMU_ERRGSR_ECCCE_MXP_U_HND_NID256, 0x20a3048)
REG32(POR_FMU_ERRGSR_CLK_P0_D0_U_HND_NID256, 0x20a3050)
REG32(POR_FMU_ERRGSR_RST_P0_D0_U_HND_NID256, 0x20a3058)
REG32(POR_FMU_ERRGSR_LSC_P0_D0_U_HND_NID256, 0x20a3060)
REG32(POR_FMU_ERRGSR_IOC_P0_D0_U_HND_NID256, 0x20a3068)
REG32(POR_FMU_ERRGSR_ASYNC_P0_D0_U_HND_NID256, 0x20a3070)
REG32(POR_FMU_ERRGSR_HANG_P0_D0_U_HND_NID256, 0x20a3078)
REG32(POR_FMU_ERRGSR_MPU_P0_D0_U_HND_NID256, 0x20a3080)
REG32(POR_FMU_ERRGSR_ECCUE_P0_D0_U_HND_NID256, 0x20a3088)
REG32(POR_FMU_ERRGSR_ECCCE_P0_D0_U_HND_NID256, 0x20a3090)
REG32(POR_FMU_ERRGSR_CLK_P0_D1_U_HND_NID256, 0x20a3098)
REG32(POR_FMU_ERRGSR_RST_P0_D1_U_HND_NID256, 0x20a30a0)
REG32(POR_FMU_ERRGSR_LSC_P0_D1_U_HND_NID256, 0x20a30a8)
REG32(POR_FMU_ERRGSR_IOC_P0_D1_U_HND_NID256, 0x20a30b0)
REG32(POR_FMU_ERRGSR_ASYNC_P0_D1_U_HND_NID256, 0x20a30b8)
REG32(POR_FMU_ERRGSR_HANG_P0_D1_U_HND_NID256, 0x20a30c0)
REG32(POR_FMU_ERRGSR_MPU_P0_D1_U_HND_NID256, 0x20a30c8)
REG32(POR_FMU_ERRGSR_ECCUE_P0_D1_U_HND_NID256, 0x20a30d0)
REG32(POR_FMU_ERRGSR_ECCCE_P0_D1_U_HND_NID256, 0x20a30d8)
REG32(POR_FMU_ERRGSR_CLK_P0_D2_U_HND_NID256, 0x20a30e0)
REG32(POR_FMU_ERRGSR_RST_P0_D2_U_HND_NID256, 0x20a30e8)
REG32(POR_FMU_ERRGSR_LSC_P0_D2_U_HND_NID256, 0x20a30f0)
REG32(POR_FMU_ERRGSR_IOC_P0_D2_U_HND_NID256, 0x20a30f8)
REG32(POR_FMU_ERRGSR_ASYNC_P0_D2_U_HND_NID256, 0x20a3100)
REG32(POR_FMU_ERRGSR_HANG_P0_D2_U_HND_NID256, 0x20a3108)
REG32(POR_FMU_ERRGSR_MPU_P0_D2_U_HND_NID256, 0x20a3110)
REG32(POR_FMU_ERRGSR_ECCUE_P0_D2_U_HND_NID256, 0x20a3118)
REG32(POR_FMU_ERRGSR_ECCCE_P0_D2_U_HND_NID256, 0x20a3120)
REG32(POR_FMU_ERRGSR_CLK_P0_D3_U_HND_NID256, 0x20a3128)
REG32(POR_FMU_ERRGSR_RST_P0_D3_U_HND_NID256, 0x20a3130)
REG32(POR_FMU_ERRGSR_LSC_P0_D3_U_HND_NID256, 0x20a3138)
REG32(POR_FMU_ERRGSR_IOC_P0_D3_U_HND_NID256, 0x20a3140)
REG32(POR_FMU_ERRGSR_ASYNC_P0_D3_U_HND_NID256, 0x20a3148)
REG32(POR_FMU_ERRGSR_HANG_P0_D3_U_HND_NID256, 0x20a3150)
REG32(POR_FMU_ERRGSR_MPU_P0_D3_U_HND_NID256, 0x20a3158)
REG32(POR_FMU_ERRGSR_ECCUE_P0_D3_U_HND_NID256, 0x20a3160)
REG32(POR_FMU_ERRGSR_ECCCE_P0_D3_U_HND_NID256, 0x20a3168)
REG32(POR_FMU_ERRGSR_CLK_P1_D0_U_HND_NID256, 0x20a3170)
REG32(POR_FMU_ERRGSR_RST_P1_D0_U_HND_NID256, 0x20a3178)
REG32(POR_FMU_ERRGSR_LSC_P1_D0_U_HND_NID256, 0x20a3180)
REG32(POR_FMU_ERRGSR_IOC_P1_D0_U_HND_NID256, 0x20a3188)
REG32(POR_FMU_ERRGSR_ASYNC_P1_D0_U_HND_NID256, 0x20a3190)
REG32(POR_FMU_ERRGSR_HANG_P1_D0_U_HND_NID256, 0x20a3198)
REG32(POR_FMU_ERRGSR_MPU_P1_D0_U_HND_NID256, 0x20a31a0)
REG32(POR_FMU_ERRGSR_ECCUE_P1_D0_U_HND_NID256, 0x20a31a8)
REG32(POR_FMU_ERRGSR_ECCCE_P1_D0_U_HND_NID256, 0x20a31b0)
REG32(POR_FMU_ERRGSR_CLK_P1_D1_U_HND_NID256, 0x20a31b8)
REG32(POR_FMU_ERRGSR_RST_P1_D1_U_HND_NID256, 0x20a31c0)
REG32(POR_FMU_ERRGSR_LSC_P1_D1_U_HND_NID256, 0x20a31c8)
REG32(POR_FMU_ERRGSR_IOC_P1_D1_U_HND_NID256, 0x20a31d0)
REG32(POR_FMU_ERRGSR_ASYNC_P1_D1_U_HND_NID256, 0x20a31d8)
REG32(POR_FMU_ERRGSR_HANG_P1_D1_U_HND_NID256, 0x20a31e0)
REG32(POR_FMU_ERRGSR_MPU_P1_D1_U_HND_NID256, 0x20a31e8)
REG32(POR_FMU_ERRGSR_ECCUE_P1_D1_U_HND_NID256, 0x20a31f0)
REG32(POR_FMU_ERRGSR_ECCCE_P1_D1_U_HND_NID256, 0x20a31f8)
REG32(POR_FMU_ERRGSR_CLK_P1_D2_U_HND_NID256, 0x20a3200)
REG32(POR_FMU_ERRGSR_RST_P1_D2_U_HND_NID256, 0x20a3208)
REG32(POR_FMU_ERRGSR_LSC_P1_D2_U_HND_NID256, 0x20a3210)
REG32(POR_FMU_ERRGSR_IOC_P1_D2_U_HND_NID256, 0x20a3218)
REG32(POR_FMU_ERRGSR_ASYNC_P1_D2_U_HND_NID256, 0x20a3220)
REG32(POR_FMU_ERRGSR_HANG_P1_D2_U_HND_NID256, 0x20a3228)
REG32(POR_FMU_ERRGSR_MPU_P1_D2_U_HND_NID256, 0x20a3230)
REG32(POR_FMU_ERRGSR_ECCUE_P1_D2_U_HND_NID256, 0x20a3238)
REG32(POR_FMU_ERRGSR_ECCCE_P1_D2_U_HND_NID256, 0x20a3240)
REG32(POR_FMU_ERRGSR_CLK_P1_D3_U_HND_NID256, 0x20a3248)
REG32(POR_FMU_ERRGSR_RST_P1_D3_U_HND_NID256, 0x20a3250)
REG32(POR_FMU_ERRGSR_LSC_P1_D3_U_HND_NID256, 0x20a3258)
REG32(POR_FMU_ERRGSR_IOC_P1_D3_U_HND_NID256, 0x20a3260)
REG32(POR_FMU_ERRGSR_ASYNC_P1_D3_U_HND_NID256, 0x20a3268)
REG32(POR_FMU_ERRGSR_HANG_P1_D3_U_HND_NID256, 0x20a3270)
REG32(POR_FMU_ERRGSR_MPU_P1_D3_U_HND_NID256, 0x20a3278)
REG32(POR_FMU_ERRGSR_ECCUE_P1_D3_U_HND_NID256, 0x20a3280)
REG32(POR_FMU_ERRGSR_ECCCE_P1_D3_U_HND_NID256, 0x20a3288)
REG32(POR_CXG_RA_NODE_INFO_U_CXRH_NID264, 0x2100000)
    FIELD(POR_CXG_RA_NODE_INFO_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_CXG_RA_NODE_INFO_U_CXRH_NID264, LOGICAL_ID, 32, 16)
    FIELD(POR_CXG_RA_NODE_INFO_U_CXRH_NID264, NODE_ID, 16, 16)
    FIELD(POR_CXG_RA_NODE_INFO_U_CXRH_NID264, NODE_TYPE, 0, 16)
REG32(POR_CXG_RA_CHILD_INFO_U_CXRH_NID264, 0x2100080)
    FIELD(POR_CXG_RA_CHILD_INFO_U_CXRH_NID264, RESERVED_32, 32, 32)
    FIELD(POR_CXG_RA_CHILD_INFO_U_CXRH_NID264, CHILD_PTR_OFFSET, 16, 16)
    FIELD(POR_CXG_RA_CHILD_INFO_U_CXRH_NID264, CHILD_COUNT, 0, 16)
REG32(POR_CXG_RA_UNIT_INFO_U_CXRH_NID264, 0x2100900)
    FIELD(POR_CXG_RA_UNIT_INFO_U_CXRH_NID264, RESERVED_62, 62, 2)
    FIELD(POR_CXG_RA_UNIT_INFO_U_CXRH_NID264, SMP_MODE_ENABLE, 61, 1)
    FIELD(POR_CXG_RA_UNIT_INFO_U_CXRH_NID264, SNOOP_DATABUFFER_DEPTH, 52, 9)
    FIELD(POR_CXG_RA_UNIT_INFO_U_CXRH_NID264, SNOOP_TRACKER_DEPTH, 43, 9)
    FIELD(POR_CXG_RA_UNIT_INFO_U_CXRH_NID264, WDB_DEPTH, 34, 9)
    FIELD(POR_CXG_RA_UNIT_INFO_U_CXRH_NID264, RDB_DEPTH, 25, 9)
    FIELD(POR_CXG_RA_UNIT_INFO_U_CXRH_NID264, REQUEST_TRACKER_DEPTH, 16, 9)
    FIELD(POR_CXG_RA_UNIT_INFO_U_CXRH_NID264, A4S_LOGICALID, 8, 8)
    FIELD(POR_CXG_RA_UNIT_INFO_U_CXRH_NID264, NUM_MEM_REGION_LIMIT_ENABLED, 6, 1)
    FIELD(POR_CXG_RA_UNIT_INFO_U_CXRH_NID264, NUM_MEM_REGIONS, 0, 5)
REG32(POR_CXG_RA_SECURE_REGISTER_GROUPS_OVERRIDE_U_CXRH_NID264, 0x2100980)
    FIELD(POR_CXG_RA_SECURE_REGISTER_GROUPS_OVERRIDE_U_CXRH_NID264, LDID_CTL, 3, 1)
    FIELD(POR_CXG_RA_SECURE_REGISTER_GROUPS_OVERRIDE_U_CXRH_NID264, LINKID_CTL, 2, 1)
    FIELD(POR_CXG_RA_SECURE_REGISTER_GROUPS_OVERRIDE_U_CXRH_NID264, RASAM_CTL, 1, 1)
    FIELD(POR_CXG_RA_SECURE_REGISTER_GROUPS_OVERRIDE_U_CXRH_NID264, CFG_CTL, 0, 1)
REG32(POR_CXG_RA_CFG_CTL_U_CXRH_NID264, 0x2100a00)
    FIELD(POR_CXG_RA_CFG_CTL_U_CXRH_NID264, RESERVED_9, 9, 55)
    FIELD(POR_CXG_RA_CFG_CTL_U_CXRH_NID264, EN_CXLA_PMUCMD_PROP, 8, 1)
    FIELD(POR_CXG_RA_CFG_CTL_U_CXRH_NID264, PCIE_NONQOS15_ENTRY_RSV_EN, 2, 1)
    FIELD(POR_CXG_RA_CFG_CTL_U_CXRH_NID264, QOS15_ENTRY_RSV_EN, 1, 1)
    FIELD(POR_CXG_RA_CFG_CTL_U_CXRH_NID264, PCIE_QOS15_ENTRY_RSV_EN, 0, 1)
REG32(POR_CXG_RA_AUX_CTL_U_CXRH_NID264, 0x2100a08)
    FIELD(POR_CXG_RA_AUX_CTL_U_CXRH_NID264, RESERVED_10, 10, 54)
    FIELD(POR_CXG_RA_AUX_CTL_U_CXRH_NID264, DIS_DBIDDISPQ_RSP, 9, 1)
    FIELD(POR_CXG_RA_AUX_CTL_U_CXRH_NID264, DIS_WRREQCHAIN, 8, 1)
    FIELD(POR_CXG_RA_AUX_CTL_U_CXRH_NID264, DIS_RDREQCHAIN, 7, 1)
    FIELD(POR_CXG_RA_AUX_CTL_U_CXRH_NID264, R2BYP_EN, 6, 1)
    FIELD(POR_CXG_RA_AUX_CTL_U_CXRH_NID264, DIS_REM_SECURE_ACCESS, 5, 1)
    FIELD(POR_CXG_RA_AUX_CTL_U_CXRH_NID264, SAMEADDR_ORD_WFC, 4, 1)
    FIELD(POR_CXG_RA_AUX_CTL_U_CXRH_NID264, DEVNR_ORD_WFC, 3, 1)
    FIELD(POR_CXG_RA_AUX_CTL_U_CXRH_NID264, EARLY_COMPACK_EN, 2, 1)
    FIELD(POR_CXG_RA_AUX_CTL_U_CXRH_NID264, EARLY_RDRCPT_EN, 1, 1)
    FIELD(POR_CXG_RA_AUX_CTL_U_CXRH_NID264, CG_DISABLE, 0, 1)
REG32(POR_CXG_RA_SAM_ADDR_REGION_REG0_U_CXRH_NID264, 0x2100da8)
    FIELD(POR_CXG_RA_SAM_ADDR_REGION_REG0_U_CXRH_NID264, REG0_VALID, 63, 1)
    FIELD(POR_CXG_RA_SAM_ADDR_REGION_REG0_U_CXRH_NID264, RESERVED_58, 58, 5)
    FIELD(POR_CXG_RA_SAM_ADDR_REGION_REG0_U_CXRH_NID264, REG0_HA_TGTID, 52, 6)
    FIELD(POR_CXG_RA_SAM_ADDR_REGION_REG0_U_CXRH_NID264, RESERVED_48, 48, 4)
    FIELD(POR_CXG_RA_SAM_ADDR_REGION_REG0_U_CXRH_NID264, REG0_BASE_ADDR, 16, 32)
    FIELD(POR_CXG_RA_SAM_ADDR_REGION_REG0_U_CXRH_NID264, REG0_SIZE, 0, 6)
REG32(POR_CXG_RA_SAM_ADDR_REGION_REG1_U_CXRH_NID264, 0x2100db0)
    FIELD(POR_CXG_RA_SAM_ADDR_REGION_REG1_U_CXRH_NID264, REG1_VALID, 63, 1)
    FIELD(POR_CXG_RA_SAM_ADDR_REGION_REG1_U_CXRH_NID264, RESERVED_58, 58, 5)
    FIELD(POR_CXG_RA_SAM_ADDR_REGION_REG1_U_CXRH_NID264, REG1_HA_TGTID, 52, 6)
    FIELD(POR_CXG_RA_SAM_ADDR_REGION_REG1_U_CXRH_NID264, RESERVED_48, 48, 4)
    FIELD(POR_CXG_RA_SAM_ADDR_REGION_REG1_U_CXRH_NID264, REG1_BASE_ADDR, 16, 32)
    FIELD(POR_CXG_RA_SAM_ADDR_REGION_REG1_U_CXRH_NID264, REG1_SIZE, 0, 6)
REG32(POR_CXG_RA_SAM_ADDR_REGION_REG2_U_CXRH_NID264, 0x2100db8)
    FIELD(POR_CXG_RA_SAM_ADDR_REGION_REG2_U_CXRH_NID264, REG2_VALID, 63, 1)
    FIELD(POR_CXG_RA_SAM_ADDR_REGION_REG2_U_CXRH_NID264, RESERVED_58, 58, 5)
    FIELD(POR_CXG_RA_SAM_ADDR_REGION_REG2_U_CXRH_NID264, REG2_HA_TGTID, 52, 6)
    FIELD(POR_CXG_RA_SAM_ADDR_REGION_REG2_U_CXRH_NID264, RESERVED_48, 48, 4)
    FIELD(POR_CXG_RA_SAM_ADDR_REGION_REG2_U_CXRH_NID264, REG2_BASE_ADDR, 16, 32)
    FIELD(POR_CXG_RA_SAM_ADDR_REGION_REG2_U_CXRH_NID264, REG2_SIZE, 0, 6)
REG32(POR_CXG_RA_SAM_ADDR_REGION_REG3_U_CXRH_NID264, 0x2100dc0)
    FIELD(POR_CXG_RA_SAM_ADDR_REGION_REG3_U_CXRH_NID264, REG3_VALID, 63, 1)
    FIELD(POR_CXG_RA_SAM_ADDR_REGION_REG3_U_CXRH_NID264, RESERVED_58, 58, 5)
    FIELD(POR_CXG_RA_SAM_ADDR_REGION_REG3_U_CXRH_NID264, REG3_HA_TGTID, 52, 6)
    FIELD(POR_CXG_RA_SAM_ADDR_REGION_REG3_U_CXRH_NID264, RESERVED_48, 48, 4)
    FIELD(POR_CXG_RA_SAM_ADDR_REGION_REG3_U_CXRH_NID264, REG3_BASE_ADDR, 16, 32)
    FIELD(POR_CXG_RA_SAM_ADDR_REGION_REG3_U_CXRH_NID264, REG3_SIZE, 0, 6)
REG32(POR_CXG_RA_SAM_ADDR_REGION_REG4_U_CXRH_NID264, 0x2100dc8)
    FIELD(POR_CXG_RA_SAM_ADDR_REGION_REG4_U_CXRH_NID264, REG4_VALID, 63, 1)
    FIELD(POR_CXG_RA_SAM_ADDR_REGION_REG4_U_CXRH_NID264, RESERVED_58, 58, 5)
    FIELD(POR_CXG_RA_SAM_ADDR_REGION_REG4_U_CXRH_NID264, REG4_HA_TGTID, 52, 6)
    FIELD(POR_CXG_RA_SAM_ADDR_REGION_REG4_U_CXRH_NID264, RESERVED_48, 48, 4)
    FIELD(POR_CXG_RA_SAM_ADDR_REGION_REG4_U_CXRH_NID264, REG4_BASE_ADDR, 16, 32)
    FIELD(POR_CXG_RA_SAM_ADDR_REGION_REG4_U_CXRH_NID264, REG4_SIZE, 0, 6)
REG32(POR_CXG_RA_SAM_ADDR_REGION_REG5_U_CXRH_NID264, 0x2100dd0)
    FIELD(POR_CXG_RA_SAM_ADDR_REGION_REG5_U_CXRH_NID264, REG5_VALID, 63, 1)
    FIELD(POR_CXG_RA_SAM_ADDR_REGION_REG5_U_CXRH_NID264, RESERVED_58, 58, 5)
    FIELD(POR_CXG_RA_SAM_ADDR_REGION_REG5_U_CXRH_NID264, REG5_HA_TGTID, 52, 6)
    FIELD(POR_CXG_RA_SAM_ADDR_REGION_REG5_U_CXRH_NID264, RESERVED_48, 48, 4)
    FIELD(POR_CXG_RA_SAM_ADDR_REGION_REG5_U_CXRH_NID264, REG5_BASE_ADDR, 16, 32)
    FIELD(POR_CXG_RA_SAM_ADDR_REGION_REG5_U_CXRH_NID264, REG5_SIZE, 0, 6)
REG32(POR_CXG_RA_SAM_ADDR_REGION_REG6_U_CXRH_NID264, 0x2100dd8)
    FIELD(POR_CXG_RA_SAM_ADDR_REGION_REG6_U_CXRH_NID264, REG6_VALID, 63, 1)
    FIELD(POR_CXG_RA_SAM_ADDR_REGION_REG6_U_CXRH_NID264, RESERVED_58, 58, 5)
    FIELD(POR_CXG_RA_SAM_ADDR_REGION_REG6_U_CXRH_NID264, REG6_HA_TGTID, 52, 6)
    FIELD(POR_CXG_RA_SAM_ADDR_REGION_REG6_U_CXRH_NID264, RESERVED_48, 48, 4)
    FIELD(POR_CXG_RA_SAM_ADDR_REGION_REG6_U_CXRH_NID264, REG6_BASE_ADDR, 16, 32)
    FIELD(POR_CXG_RA_SAM_ADDR_REGION_REG6_U_CXRH_NID264, REG6_SIZE, 0, 6)
REG32(POR_CXG_RA_SAM_ADDR_REGION_REG7_U_CXRH_NID264, 0x2100de0)
    FIELD(POR_CXG_RA_SAM_ADDR_REGION_REG7_U_CXRH_NID264, REG7_VALID, 63, 1)
    FIELD(POR_CXG_RA_SAM_ADDR_REGION_REG7_U_CXRH_NID264, RESERVED_58, 58, 5)
    FIELD(POR_CXG_RA_SAM_ADDR_REGION_REG7_U_CXRH_NID264, REG7_HA_TGTID, 52, 6)
    FIELD(POR_CXG_RA_SAM_ADDR_REGION_REG7_U_CXRH_NID264, RESERVED_48, 48, 4)
    FIELD(POR_CXG_RA_SAM_ADDR_REGION_REG7_U_CXRH_NID264, REG7_BASE_ADDR, 16, 32)
    FIELD(POR_CXG_RA_SAM_ADDR_REGION_REG7_U_CXRH_NID264, REG7_SIZE, 0, 6)
REG32(POR_CXG_RA_SAM_MEM_REGION0_LIMIT_REG_U_CXRH_NID264, 0x2100e00)
    FIELD(POR_CXG_RA_SAM_MEM_REGION0_LIMIT_REG_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_CXG_RA_SAM_MEM_REGION0_LIMIT_REG_U_CXRH_NID264, REG0_LIMIT_ADDR, 16, 32)
    FIELD(POR_CXG_RA_SAM_MEM_REGION0_LIMIT_REG_U_CXRH_NID264, RESERVED_0, 0, 16)
REG32(POR_CXG_RA_SAM_MEM_REGION1_LIMIT_REG_U_CXRH_NID264, 0x2100e08)
    FIELD(POR_CXG_RA_SAM_MEM_REGION1_LIMIT_REG_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_CXG_RA_SAM_MEM_REGION1_LIMIT_REG_U_CXRH_NID264, REG1_LIMIT_ADDR, 16, 32)
    FIELD(POR_CXG_RA_SAM_MEM_REGION1_LIMIT_REG_U_CXRH_NID264, RESERVED_0, 0, 16)
REG32(POR_CXG_RA_SAM_MEM_REGION2_LIMIT_REG_U_CXRH_NID264, 0x2100e10)
    FIELD(POR_CXG_RA_SAM_MEM_REGION2_LIMIT_REG_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_CXG_RA_SAM_MEM_REGION2_LIMIT_REG_U_CXRH_NID264, REG2_LIMIT_ADDR, 16, 32)
    FIELD(POR_CXG_RA_SAM_MEM_REGION2_LIMIT_REG_U_CXRH_NID264, RESERVED_0, 0, 16)
REG32(POR_CXG_RA_SAM_MEM_REGION3_LIMIT_REG_U_CXRH_NID264, 0x2100e18)
    FIELD(POR_CXG_RA_SAM_MEM_REGION3_LIMIT_REG_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_CXG_RA_SAM_MEM_REGION3_LIMIT_REG_U_CXRH_NID264, REG3_LIMIT_ADDR, 16, 32)
    FIELD(POR_CXG_RA_SAM_MEM_REGION3_LIMIT_REG_U_CXRH_NID264, RESERVED_0, 0, 16)
REG32(POR_CXG_RA_SAM_MEM_REGION4_LIMIT_REG_U_CXRH_NID264, 0x2100e20)
    FIELD(POR_CXG_RA_SAM_MEM_REGION4_LIMIT_REG_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_CXG_RA_SAM_MEM_REGION4_LIMIT_REG_U_CXRH_NID264, REG4_LIMIT_ADDR, 16, 32)
    FIELD(POR_CXG_RA_SAM_MEM_REGION4_LIMIT_REG_U_CXRH_NID264, RESERVED_0, 0, 16)
REG32(POR_CXG_RA_SAM_MEM_REGION5_LIMIT_REG_U_CXRH_NID264, 0x2100e28)
    FIELD(POR_CXG_RA_SAM_MEM_REGION5_LIMIT_REG_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_CXG_RA_SAM_MEM_REGION5_LIMIT_REG_U_CXRH_NID264, REG5_LIMIT_ADDR, 16, 32)
    FIELD(POR_CXG_RA_SAM_MEM_REGION5_LIMIT_REG_U_CXRH_NID264, RESERVED_0, 0, 16)
REG32(POR_CXG_RA_SAM_MEM_REGION6_LIMIT_REG_U_CXRH_NID264, 0x2100e30)
    FIELD(POR_CXG_RA_SAM_MEM_REGION6_LIMIT_REG_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_CXG_RA_SAM_MEM_REGION6_LIMIT_REG_U_CXRH_NID264, REG6_LIMIT_ADDR, 16, 32)
    FIELD(POR_CXG_RA_SAM_MEM_REGION6_LIMIT_REG_U_CXRH_NID264, RESERVED_0, 0, 16)
REG32(POR_CXG_RA_SAM_MEM_REGION7_LIMIT_REG_U_CXRH_NID264, 0x2100e38)
    FIELD(POR_CXG_RA_SAM_MEM_REGION7_LIMIT_REG_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_CXG_RA_SAM_MEM_REGION7_LIMIT_REG_U_CXRH_NID264, REG7_LIMIT_ADDR, 16, 32)
    FIELD(POR_CXG_RA_SAM_MEM_REGION7_LIMIT_REG_U_CXRH_NID264, RESERVED_0, 0, 16)
REG32(POR_CXG_RA_AGENTID_TO_LINKID_REG0_U_CXRH_NID264, 0x2100e60)
    FIELD(POR_CXG_RA_AGENTID_TO_LINKID_REG0_U_CXRH_NID264, RESERVED_58, 58, 6)
    FIELD(POR_CXG_RA_AGENTID_TO_LINKID_REG0_U_CXRH_NID264, AGENT7_LINKID, 56, 2)
    FIELD(POR_CXG_RA_AGENTID_TO_LINKID_REG0_U_CXRH_NID264, RESERVED_50, 50, 6)
    FIELD(POR_CXG_RA_AGENTID_TO_LINKID_REG0_U_CXRH_NID264, AGENT6_LINKID, 48, 2)
    FIELD(POR_CXG_RA_AGENTID_TO_LINKID_REG0_U_CXRH_NID264, RESERVED_42, 42, 6)
    FIELD(POR_CXG_RA_AGENTID_TO_LINKID_REG0_U_CXRH_NID264, AGENT5_LINKID, 40, 2)
    FIELD(POR_CXG_RA_AGENTID_TO_LINKID_REG0_U_CXRH_NID264, RESERVED_34, 34, 6)
    FIELD(POR_CXG_RA_AGENTID_TO_LINKID_REG0_U_CXRH_NID264, AGENT4_LINKID, 32, 2)
    FIELD(POR_CXG_RA_AGENTID_TO_LINKID_REG0_U_CXRH_NID264, RESERVED_26, 26, 6)
    FIELD(POR_CXG_RA_AGENTID_TO_LINKID_REG0_U_CXRH_NID264, AGENT3_LINKID, 24, 2)
    FIELD(POR_CXG_RA_AGENTID_TO_LINKID_REG0_U_CXRH_NID264, RESERVED_18, 18, 6)
    FIELD(POR_CXG_RA_AGENTID_TO_LINKID_REG0_U_CXRH_NID264, AGENT2_LINKID, 16, 2)
    FIELD(POR_CXG_RA_AGENTID_TO_LINKID_REG0_U_CXRH_NID264, RESERVED_10, 10, 6)
    FIELD(POR_CXG_RA_AGENTID_TO_LINKID_REG0_U_CXRH_NID264, AGENT1_LINKID, 8, 2)
    FIELD(POR_CXG_RA_AGENTID_TO_LINKID_REG0_U_CXRH_NID264, AGENT0_LINKID, 0, 2)
REG32(POR_CXG_RA_AGENTID_TO_LINKID_REG1_U_CXRH_NID264, 0x2100e68)
    FIELD(POR_CXG_RA_AGENTID_TO_LINKID_REG1_U_CXRH_NID264, RESERVED_58, 58, 6)
    FIELD(POR_CXG_RA_AGENTID_TO_LINKID_REG1_U_CXRH_NID264, AGENT15_LINKID, 56, 2)
    FIELD(POR_CXG_RA_AGENTID_TO_LINKID_REG1_U_CXRH_NID264, RESERVED_50, 50, 6)
    FIELD(POR_CXG_RA_AGENTID_TO_LINKID_REG1_U_CXRH_NID264, AGENT14_LINKID, 48, 2)
    FIELD(POR_CXG_RA_AGENTID_TO_LINKID_REG1_U_CXRH_NID264, RESERVED_42, 42, 6)
    FIELD(POR_CXG_RA_AGENTID_TO_LINKID_REG1_U_CXRH_NID264, AGENT13_LINKID, 40, 2)
    FIELD(POR_CXG_RA_AGENTID_TO_LINKID_REG1_U_CXRH_NID264, RESERVED_34, 34, 6)
    FIELD(POR_CXG_RA_AGENTID_TO_LINKID_REG1_U_CXRH_NID264, AGENT12_LINKID, 32, 2)
    FIELD(POR_CXG_RA_AGENTID_TO_LINKID_REG1_U_CXRH_NID264, RESERVED_26, 26, 6)
    FIELD(POR_CXG_RA_AGENTID_TO_LINKID_REG1_U_CXRH_NID264, AGENT11_LINKID, 24, 2)
    FIELD(POR_CXG_RA_AGENTID_TO_LINKID_REG1_U_CXRH_NID264, RESERVED_18, 18, 6)
    FIELD(POR_CXG_RA_AGENTID_TO_LINKID_REG1_U_CXRH_NID264, AGENT10_LINKID, 16, 2)
    FIELD(POR_CXG_RA_AGENTID_TO_LINKID_REG1_U_CXRH_NID264, RESERVED_10, 10, 6)
    FIELD(POR_CXG_RA_AGENTID_TO_LINKID_REG1_U_CXRH_NID264, AGENT9_LINKID, 8, 2)
    FIELD(POR_CXG_RA_AGENTID_TO_LINKID_REG1_U_CXRH_NID264, AGENT8_LINKID, 0, 2)
REG32(POR_CXG_RA_AGENTID_TO_LINKID_REG2_U_CXRH_NID264, 0x2100e70)
    FIELD(POR_CXG_RA_AGENTID_TO_LINKID_REG2_U_CXRH_NID264, RESERVED_58, 58, 6)
    FIELD(POR_CXG_RA_AGENTID_TO_LINKID_REG2_U_CXRH_NID264, AGENT23_LINKID, 56, 2)
    FIELD(POR_CXG_RA_AGENTID_TO_LINKID_REG2_U_CXRH_NID264, RESERVED_50, 50, 6)
    FIELD(POR_CXG_RA_AGENTID_TO_LINKID_REG2_U_CXRH_NID264, AGENT22_LINKID, 48, 2)
    FIELD(POR_CXG_RA_AGENTID_TO_LINKID_REG2_U_CXRH_NID264, RESERVED_42, 42, 6)
    FIELD(POR_CXG_RA_AGENTID_TO_LINKID_REG2_U_CXRH_NID264, AGENT21_LINKID, 40, 2)
    FIELD(POR_CXG_RA_AGENTID_TO_LINKID_REG2_U_CXRH_NID264, RESERVED_34, 34, 6)
    FIELD(POR_CXG_RA_AGENTID_TO_LINKID_REG2_U_CXRH_NID264, AGENT20_LINKID, 32, 2)
    FIELD(POR_CXG_RA_AGENTID_TO_LINKID_REG2_U_CXRH_NID264, RESERVED_26, 26, 6)
    FIELD(POR_CXG_RA_AGENTID_TO_LINKID_REG2_U_CXRH_NID264, AGENT19_LINKID, 24, 2)
    FIELD(POR_CXG_RA_AGENTID_TO_LINKID_REG2_U_CXRH_NID264, RESERVED_18, 18, 6)
    FIELD(POR_CXG_RA_AGENTID_TO_LINKID_REG2_U_CXRH_NID264, AGENT18_LINKID, 16, 2)
    FIELD(POR_CXG_RA_AGENTID_TO_LINKID_REG2_U_CXRH_NID264, RESERVED_10, 10, 6)
    FIELD(POR_CXG_RA_AGENTID_TO_LINKID_REG2_U_CXRH_NID264, AGENT17_LINKID, 8, 2)
    FIELD(POR_CXG_RA_AGENTID_TO_LINKID_REG2_U_CXRH_NID264, AGENT16_LINKID, 0, 2)
REG32(POR_CXG_RA_AGENTID_TO_LINKID_REG3_U_CXRH_NID264, 0x2100e78)
    FIELD(POR_CXG_RA_AGENTID_TO_LINKID_REG3_U_CXRH_NID264, RESERVED_58, 58, 6)
    FIELD(POR_CXG_RA_AGENTID_TO_LINKID_REG3_U_CXRH_NID264, AGENT31_LINKID, 56, 2)
    FIELD(POR_CXG_RA_AGENTID_TO_LINKID_REG3_U_CXRH_NID264, RESERVED_50, 50, 6)
    FIELD(POR_CXG_RA_AGENTID_TO_LINKID_REG3_U_CXRH_NID264, AGENT30_LINKID, 48, 2)
    FIELD(POR_CXG_RA_AGENTID_TO_LINKID_REG3_U_CXRH_NID264, RESERVED_42, 42, 6)
    FIELD(POR_CXG_RA_AGENTID_TO_LINKID_REG3_U_CXRH_NID264, AGENT29_LINKID, 40, 2)
    FIELD(POR_CXG_RA_AGENTID_TO_LINKID_REG3_U_CXRH_NID264, RESERVED_34, 34, 6)
    FIELD(POR_CXG_RA_AGENTID_TO_LINKID_REG3_U_CXRH_NID264, AGENT28_LINKID, 32, 2)
    FIELD(POR_CXG_RA_AGENTID_TO_LINKID_REG3_U_CXRH_NID264, RESERVED_26, 26, 6)
    FIELD(POR_CXG_RA_AGENTID_TO_LINKID_REG3_U_CXRH_NID264, AGENT27_LINKID, 24, 2)
    FIELD(POR_CXG_RA_AGENTID_TO_LINKID_REG3_U_CXRH_NID264, RESERVED_18, 18, 6)
    FIELD(POR_CXG_RA_AGENTID_TO_LINKID_REG3_U_CXRH_NID264, AGENT26_LINKID, 16, 2)
    FIELD(POR_CXG_RA_AGENTID_TO_LINKID_REG3_U_CXRH_NID264, RESERVED_10, 10, 6)
    FIELD(POR_CXG_RA_AGENTID_TO_LINKID_REG3_U_CXRH_NID264, AGENT25_LINKID, 8, 2)
    FIELD(POR_CXG_RA_AGENTID_TO_LINKID_REG3_U_CXRH_NID264, AGENT24_LINKID, 0, 2)
REG32(POR_CXG_RA_AGENTID_TO_LINKID_REG4_U_CXRH_NID264, 0x2100e80)
    FIELD(POR_CXG_RA_AGENTID_TO_LINKID_REG4_U_CXRH_NID264, RESERVED_58, 58, 6)
    FIELD(POR_CXG_RA_AGENTID_TO_LINKID_REG4_U_CXRH_NID264, AGENT39_LINKID, 56, 2)
    FIELD(POR_CXG_RA_AGENTID_TO_LINKID_REG4_U_CXRH_NID264, RESERVED_50, 50, 6)
    FIELD(POR_CXG_RA_AGENTID_TO_LINKID_REG4_U_CXRH_NID264, AGENT38_LINKID, 48, 2)
    FIELD(POR_CXG_RA_AGENTID_TO_LINKID_REG4_U_CXRH_NID264, RESERVED_42, 42, 6)
    FIELD(POR_CXG_RA_AGENTID_TO_LINKID_REG4_U_CXRH_NID264, AGENT37_LINKID, 40, 2)
    FIELD(POR_CXG_RA_AGENTID_TO_LINKID_REG4_U_CXRH_NID264, RESERVED_34, 34, 6)
    FIELD(POR_CXG_RA_AGENTID_TO_LINKID_REG4_U_CXRH_NID264, AGENT36_LINKID, 32, 2)
    FIELD(POR_CXG_RA_AGENTID_TO_LINKID_REG4_U_CXRH_NID264, RESERVED_26, 26, 6)
    FIELD(POR_CXG_RA_AGENTID_TO_LINKID_REG4_U_CXRH_NID264, AGENT35_LINKID, 24, 2)
    FIELD(POR_CXG_RA_AGENTID_TO_LINKID_REG4_U_CXRH_NID264, RESERVED_18, 18, 6)
    FIELD(POR_CXG_RA_AGENTID_TO_LINKID_REG4_U_CXRH_NID264, AGENT34_LINKID, 16, 2)
    FIELD(POR_CXG_RA_AGENTID_TO_LINKID_REG4_U_CXRH_NID264, RESERVED_10, 10, 6)
    FIELD(POR_CXG_RA_AGENTID_TO_LINKID_REG4_U_CXRH_NID264, AGENT33_LINKID, 8, 2)
    FIELD(POR_CXG_RA_AGENTID_TO_LINKID_REG4_U_CXRH_NID264, AGENT32_LINKID, 0, 2)
REG32(POR_CXG_RA_AGENTID_TO_LINKID_REG5_U_CXRH_NID264, 0x2100e88)
    FIELD(POR_CXG_RA_AGENTID_TO_LINKID_REG5_U_CXRH_NID264, RESERVED_58, 58, 6)
    FIELD(POR_CXG_RA_AGENTID_TO_LINKID_REG5_U_CXRH_NID264, AGENT47_LINKID, 56, 2)
    FIELD(POR_CXG_RA_AGENTID_TO_LINKID_REG5_U_CXRH_NID264, RESERVED_50, 50, 6)
    FIELD(POR_CXG_RA_AGENTID_TO_LINKID_REG5_U_CXRH_NID264, AGENT46_LINKID, 48, 2)
    FIELD(POR_CXG_RA_AGENTID_TO_LINKID_REG5_U_CXRH_NID264, RESERVED_42, 42, 6)
    FIELD(POR_CXG_RA_AGENTID_TO_LINKID_REG5_U_CXRH_NID264, AGENT45_LINKID, 40, 2)
    FIELD(POR_CXG_RA_AGENTID_TO_LINKID_REG5_U_CXRH_NID264, RESERVED_34, 34, 6)
    FIELD(POR_CXG_RA_AGENTID_TO_LINKID_REG5_U_CXRH_NID264, AGENT44_LINKID, 32, 2)
    FIELD(POR_CXG_RA_AGENTID_TO_LINKID_REG5_U_CXRH_NID264, RESERVED_26, 26, 6)
    FIELD(POR_CXG_RA_AGENTID_TO_LINKID_REG5_U_CXRH_NID264, AGENT43_LINKID, 24, 2)
    FIELD(POR_CXG_RA_AGENTID_TO_LINKID_REG5_U_CXRH_NID264, RESERVED_18, 18, 6)
    FIELD(POR_CXG_RA_AGENTID_TO_LINKID_REG5_U_CXRH_NID264, AGENT42_LINKID, 16, 2)
    FIELD(POR_CXG_RA_AGENTID_TO_LINKID_REG5_U_CXRH_NID264, RESERVED_10, 10, 6)
    FIELD(POR_CXG_RA_AGENTID_TO_LINKID_REG5_U_CXRH_NID264, AGENT41_LINKID, 8, 2)
    FIELD(POR_CXG_RA_AGENTID_TO_LINKID_REG5_U_CXRH_NID264, AGENT40_LINKID, 0, 2)
REG32(POR_CXG_RA_AGENTID_TO_LINKID_REG6_U_CXRH_NID264, 0x2100e90)
    FIELD(POR_CXG_RA_AGENTID_TO_LINKID_REG6_U_CXRH_NID264, RESERVED_58, 58, 6)
    FIELD(POR_CXG_RA_AGENTID_TO_LINKID_REG6_U_CXRH_NID264, AGENT55_LINKID, 56, 2)
    FIELD(POR_CXG_RA_AGENTID_TO_LINKID_REG6_U_CXRH_NID264, RESERVED_50, 50, 6)
    FIELD(POR_CXG_RA_AGENTID_TO_LINKID_REG6_U_CXRH_NID264, AGENT54_LINKID, 48, 2)
    FIELD(POR_CXG_RA_AGENTID_TO_LINKID_REG6_U_CXRH_NID264, RESERVED_42, 42, 6)
    FIELD(POR_CXG_RA_AGENTID_TO_LINKID_REG6_U_CXRH_NID264, AGENT53_LINKID, 40, 2)
    FIELD(POR_CXG_RA_AGENTID_TO_LINKID_REG6_U_CXRH_NID264, RESERVED_34, 34, 6)
    FIELD(POR_CXG_RA_AGENTID_TO_LINKID_REG6_U_CXRH_NID264, AGENT52_LINKID, 32, 2)
    FIELD(POR_CXG_RA_AGENTID_TO_LINKID_REG6_U_CXRH_NID264, RESERVED_26, 26, 6)
    FIELD(POR_CXG_RA_AGENTID_TO_LINKID_REG6_U_CXRH_NID264, AGENT51_LINKID, 24, 2)
    FIELD(POR_CXG_RA_AGENTID_TO_LINKID_REG6_U_CXRH_NID264, RESERVED_18, 18, 6)
    FIELD(POR_CXG_RA_AGENTID_TO_LINKID_REG6_U_CXRH_NID264, AGENT50_LINKID, 16, 2)
    FIELD(POR_CXG_RA_AGENTID_TO_LINKID_REG6_U_CXRH_NID264, RESERVED_10, 10, 6)
    FIELD(POR_CXG_RA_AGENTID_TO_LINKID_REG6_U_CXRH_NID264, AGENT49_LINKID, 8, 2)
    FIELD(POR_CXG_RA_AGENTID_TO_LINKID_REG6_U_CXRH_NID264, AGENT48_LINKID, 0, 2)
REG32(POR_CXG_RA_AGENTID_TO_LINKID_REG7_U_CXRH_NID264, 0x2100e98)
    FIELD(POR_CXG_RA_AGENTID_TO_LINKID_REG7_U_CXRH_NID264, RESERVED_58, 58, 6)
    FIELD(POR_CXG_RA_AGENTID_TO_LINKID_REG7_U_CXRH_NID264, AGENT63_LINKID, 56, 2)
    FIELD(POR_CXG_RA_AGENTID_TO_LINKID_REG7_U_CXRH_NID264, RESERVED_50, 50, 6)
    FIELD(POR_CXG_RA_AGENTID_TO_LINKID_REG7_U_CXRH_NID264, AGENT62_LINKID, 48, 2)
    FIELD(POR_CXG_RA_AGENTID_TO_LINKID_REG7_U_CXRH_NID264, RESERVED_42, 42, 6)
    FIELD(POR_CXG_RA_AGENTID_TO_LINKID_REG7_U_CXRH_NID264, AGENT61_LINKID, 40, 2)
    FIELD(POR_CXG_RA_AGENTID_TO_LINKID_REG7_U_CXRH_NID264, RESERVED_34, 34, 6)
    FIELD(POR_CXG_RA_AGENTID_TO_LINKID_REG7_U_CXRH_NID264, AGENT60_LINKID, 32, 2)
    FIELD(POR_CXG_RA_AGENTID_TO_LINKID_REG7_U_CXRH_NID264, RESERVED_26, 26, 6)
    FIELD(POR_CXG_RA_AGENTID_TO_LINKID_REG7_U_CXRH_NID264, AGENT59_LINKID, 24, 2)
    FIELD(POR_CXG_RA_AGENTID_TO_LINKID_REG7_U_CXRH_NID264, RESERVED_18, 18, 6)
    FIELD(POR_CXG_RA_AGENTID_TO_LINKID_REG7_U_CXRH_NID264, AGENT58_LINKID, 16, 2)
    FIELD(POR_CXG_RA_AGENTID_TO_LINKID_REG7_U_CXRH_NID264, RESERVED_10, 10, 6)
    FIELD(POR_CXG_RA_AGENTID_TO_LINKID_REG7_U_CXRH_NID264, AGENT57_LINKID, 8, 2)
    FIELD(POR_CXG_RA_AGENTID_TO_LINKID_REG7_U_CXRH_NID264, AGENT56_LINKID, 0, 2)
REG32(POR_CXG_RA_RNF_LDID_TO_RAID_REG0_U_CXRH_NID264, 0x2100ea0)
    FIELD(POR_CXG_RA_RNF_LDID_TO_RAID_REG0_U_CXRH_NID264, RESERVED_62, 62, 2)
    FIELD(POR_CXG_RA_RNF_LDID_TO_RAID_REG0_U_CXRH_NID264, LDID7_RAID, 56, 6)
    FIELD(POR_CXG_RA_RNF_LDID_TO_RAID_REG0_U_CXRH_NID264, RESERVED_54, 54, 2)
    FIELD(POR_CXG_RA_RNF_LDID_TO_RAID_REG0_U_CXRH_NID264, LDID6_RAID, 48, 6)
    FIELD(POR_CXG_RA_RNF_LDID_TO_RAID_REG0_U_CXRH_NID264, RESERVED_46, 46, 2)
    FIELD(POR_CXG_RA_RNF_LDID_TO_RAID_REG0_U_CXRH_NID264, LDID5_RAID, 40, 6)
    FIELD(POR_CXG_RA_RNF_LDID_TO_RAID_REG0_U_CXRH_NID264, RESERVED_38, 38, 2)
    FIELD(POR_CXG_RA_RNF_LDID_TO_RAID_REG0_U_CXRH_NID264, LDID4_RAID, 32, 6)
    FIELD(POR_CXG_RA_RNF_LDID_TO_RAID_REG0_U_CXRH_NID264, RESERVED_30, 30, 2)
    FIELD(POR_CXG_RA_RNF_LDID_TO_RAID_REG0_U_CXRH_NID264, LDID3_RAID, 24, 6)
    FIELD(POR_CXG_RA_RNF_LDID_TO_RAID_REG0_U_CXRH_NID264, RESERVED_22, 22, 2)
    FIELD(POR_CXG_RA_RNF_LDID_TO_RAID_REG0_U_CXRH_NID264, LDID2_RAID, 16, 6)
    FIELD(POR_CXG_RA_RNF_LDID_TO_RAID_REG0_U_CXRH_NID264, RESERVED_14, 14, 2)
    FIELD(POR_CXG_RA_RNF_LDID_TO_RAID_REG0_U_CXRH_NID264, LDID1_RAID, 8, 6)
    FIELD(POR_CXG_RA_RNF_LDID_TO_RAID_REG0_U_CXRH_NID264, LDID0_RAID, 0, 6)
REG32(POR_CXG_RA_RNF_LDID_TO_RAID_REG1_U_CXRH_NID264, 0x2100ea8)
    FIELD(POR_CXG_RA_RNF_LDID_TO_RAID_REG1_U_CXRH_NID264, RESERVED_62, 62, 2)
    FIELD(POR_CXG_RA_RNF_LDID_TO_RAID_REG1_U_CXRH_NID264, LDID15_RAID, 56, 6)
    FIELD(POR_CXG_RA_RNF_LDID_TO_RAID_REG1_U_CXRH_NID264, RESERVED_54, 54, 2)
    FIELD(POR_CXG_RA_RNF_LDID_TO_RAID_REG1_U_CXRH_NID264, LDID14_RAID, 48, 6)
    FIELD(POR_CXG_RA_RNF_LDID_TO_RAID_REG1_U_CXRH_NID264, RESERVED_46, 46, 2)
    FIELD(POR_CXG_RA_RNF_LDID_TO_RAID_REG1_U_CXRH_NID264, LDID13_RAID, 40, 6)
    FIELD(POR_CXG_RA_RNF_LDID_TO_RAID_REG1_U_CXRH_NID264, RESERVED_38, 38, 2)
    FIELD(POR_CXG_RA_RNF_LDID_TO_RAID_REG1_U_CXRH_NID264, LDID12_RAID, 32, 6)
    FIELD(POR_CXG_RA_RNF_LDID_TO_RAID_REG1_U_CXRH_NID264, RESERVED_30, 30, 2)
    FIELD(POR_CXG_RA_RNF_LDID_TO_RAID_REG1_U_CXRH_NID264, LDID11_RAID, 24, 6)
    FIELD(POR_CXG_RA_RNF_LDID_TO_RAID_REG1_U_CXRH_NID264, RESERVED_22, 22, 2)
    FIELD(POR_CXG_RA_RNF_LDID_TO_RAID_REG1_U_CXRH_NID264, LDID10_RAID, 16, 6)
    FIELD(POR_CXG_RA_RNF_LDID_TO_RAID_REG1_U_CXRH_NID264, RESERVED_14, 14, 2)
    FIELD(POR_CXG_RA_RNF_LDID_TO_RAID_REG1_U_CXRH_NID264, LDID9_RAID, 8, 6)
    FIELD(POR_CXG_RA_RNF_LDID_TO_RAID_REG1_U_CXRH_NID264, LDID8_RAID, 0, 6)
REG32(POR_CXG_RA_RNF_LDID_TO_RAID_REG2_U_CXRH_NID264, 0x2100eb0)
    FIELD(POR_CXG_RA_RNF_LDID_TO_RAID_REG2_U_CXRH_NID264, RESERVED_62, 62, 2)
    FIELD(POR_CXG_RA_RNF_LDID_TO_RAID_REG2_U_CXRH_NID264, LDID23_RAID, 56, 6)
    FIELD(POR_CXG_RA_RNF_LDID_TO_RAID_REG2_U_CXRH_NID264, RESERVED_54, 54, 2)
    FIELD(POR_CXG_RA_RNF_LDID_TO_RAID_REG2_U_CXRH_NID264, LDID22_RAID, 48, 6)
    FIELD(POR_CXG_RA_RNF_LDID_TO_RAID_REG2_U_CXRH_NID264, RESERVED_46, 46, 2)
    FIELD(POR_CXG_RA_RNF_LDID_TO_RAID_REG2_U_CXRH_NID264, LDID21_RAID, 40, 6)
    FIELD(POR_CXG_RA_RNF_LDID_TO_RAID_REG2_U_CXRH_NID264, RESERVED_38, 38, 2)
    FIELD(POR_CXG_RA_RNF_LDID_TO_RAID_REG2_U_CXRH_NID264, LDID20_RAID, 32, 6)
    FIELD(POR_CXG_RA_RNF_LDID_TO_RAID_REG2_U_CXRH_NID264, RESERVED_30, 30, 2)
    FIELD(POR_CXG_RA_RNF_LDID_TO_RAID_REG2_U_CXRH_NID264, LDID19_RAID, 24, 6)
    FIELD(POR_CXG_RA_RNF_LDID_TO_RAID_REG2_U_CXRH_NID264, RESERVED_22, 22, 2)
    FIELD(POR_CXG_RA_RNF_LDID_TO_RAID_REG2_U_CXRH_NID264, LDID18_RAID, 16, 6)
    FIELD(POR_CXG_RA_RNF_LDID_TO_RAID_REG2_U_CXRH_NID264, RESERVED_14, 14, 2)
    FIELD(POR_CXG_RA_RNF_LDID_TO_RAID_REG2_U_CXRH_NID264, LDID17_RAID, 8, 6)
    FIELD(POR_CXG_RA_RNF_LDID_TO_RAID_REG2_U_CXRH_NID264, LDID16_RAID, 0, 6)
REG32(POR_CXG_RA_RNF_LDID_TO_RAID_REG3_U_CXRH_NID264, 0x2100eb8)
    FIELD(POR_CXG_RA_RNF_LDID_TO_RAID_REG3_U_CXRH_NID264, RESERVED_62, 62, 2)
    FIELD(POR_CXG_RA_RNF_LDID_TO_RAID_REG3_U_CXRH_NID264, LDID31_RAID, 56, 6)
    FIELD(POR_CXG_RA_RNF_LDID_TO_RAID_REG3_U_CXRH_NID264, RESERVED_54, 54, 2)
    FIELD(POR_CXG_RA_RNF_LDID_TO_RAID_REG3_U_CXRH_NID264, LDID30_RAID, 48, 6)
    FIELD(POR_CXG_RA_RNF_LDID_TO_RAID_REG3_U_CXRH_NID264, RESERVED_46, 46, 2)
    FIELD(POR_CXG_RA_RNF_LDID_TO_RAID_REG3_U_CXRH_NID264, LDID29_RAID, 40, 6)
    FIELD(POR_CXG_RA_RNF_LDID_TO_RAID_REG3_U_CXRH_NID264, RESERVED_38, 38, 2)
    FIELD(POR_CXG_RA_RNF_LDID_TO_RAID_REG3_U_CXRH_NID264, LDID28_RAID, 32, 6)
    FIELD(POR_CXG_RA_RNF_LDID_TO_RAID_REG3_U_CXRH_NID264, RESERVED_30, 30, 2)
    FIELD(POR_CXG_RA_RNF_LDID_TO_RAID_REG3_U_CXRH_NID264, LDID27_RAID, 24, 6)
    FIELD(POR_CXG_RA_RNF_LDID_TO_RAID_REG3_U_CXRH_NID264, RESERVED_22, 22, 2)
    FIELD(POR_CXG_RA_RNF_LDID_TO_RAID_REG3_U_CXRH_NID264, LDID26_RAID, 16, 6)
    FIELD(POR_CXG_RA_RNF_LDID_TO_RAID_REG3_U_CXRH_NID264, RESERVED_14, 14, 2)
    FIELD(POR_CXG_RA_RNF_LDID_TO_RAID_REG3_U_CXRH_NID264, LDID25_RAID, 8, 6)
    FIELD(POR_CXG_RA_RNF_LDID_TO_RAID_REG3_U_CXRH_NID264, LDID24_RAID, 0, 6)
REG32(POR_CXG_RA_RNF_LDID_TO_RAID_REG4_U_CXRH_NID264, 0x2100ec0)
    FIELD(POR_CXG_RA_RNF_LDID_TO_RAID_REG4_U_CXRH_NID264, RESERVED_62, 62, 2)
    FIELD(POR_CXG_RA_RNF_LDID_TO_RAID_REG4_U_CXRH_NID264, LDID39_RAID, 56, 6)
    FIELD(POR_CXG_RA_RNF_LDID_TO_RAID_REG4_U_CXRH_NID264, RESERVED_54, 54, 2)
    FIELD(POR_CXG_RA_RNF_LDID_TO_RAID_REG4_U_CXRH_NID264, LDID38_RAID, 48, 6)
    FIELD(POR_CXG_RA_RNF_LDID_TO_RAID_REG4_U_CXRH_NID264, RESERVED_46, 46, 2)
    FIELD(POR_CXG_RA_RNF_LDID_TO_RAID_REG4_U_CXRH_NID264, LDID37_RAID, 40, 6)
    FIELD(POR_CXG_RA_RNF_LDID_TO_RAID_REG4_U_CXRH_NID264, RESERVED_38, 38, 2)
    FIELD(POR_CXG_RA_RNF_LDID_TO_RAID_REG4_U_CXRH_NID264, LDID36_RAID, 32, 6)
    FIELD(POR_CXG_RA_RNF_LDID_TO_RAID_REG4_U_CXRH_NID264, RESERVED_30, 30, 2)
    FIELD(POR_CXG_RA_RNF_LDID_TO_RAID_REG4_U_CXRH_NID264, LDID35_RAID, 24, 6)
    FIELD(POR_CXG_RA_RNF_LDID_TO_RAID_REG4_U_CXRH_NID264, RESERVED_22, 22, 2)
    FIELD(POR_CXG_RA_RNF_LDID_TO_RAID_REG4_U_CXRH_NID264, LDID34_RAID, 16, 6)
    FIELD(POR_CXG_RA_RNF_LDID_TO_RAID_REG4_U_CXRH_NID264, RESERVED_14, 14, 2)
    FIELD(POR_CXG_RA_RNF_LDID_TO_RAID_REG4_U_CXRH_NID264, LDID33_RAID, 8, 6)
    FIELD(POR_CXG_RA_RNF_LDID_TO_RAID_REG4_U_CXRH_NID264, LDID32_RAID, 0, 6)
REG32(POR_CXG_RA_RNF_LDID_TO_RAID_REG5_U_CXRH_NID264, 0x2100ec8)
    FIELD(POR_CXG_RA_RNF_LDID_TO_RAID_REG5_U_CXRH_NID264, RESERVED_62, 62, 2)
    FIELD(POR_CXG_RA_RNF_LDID_TO_RAID_REG5_U_CXRH_NID264, LDID47_RAID, 56, 6)
    FIELD(POR_CXG_RA_RNF_LDID_TO_RAID_REG5_U_CXRH_NID264, RESERVED_54, 54, 2)
    FIELD(POR_CXG_RA_RNF_LDID_TO_RAID_REG5_U_CXRH_NID264, LDID46_RAID, 48, 6)
    FIELD(POR_CXG_RA_RNF_LDID_TO_RAID_REG5_U_CXRH_NID264, RESERVED_46, 46, 2)
    FIELD(POR_CXG_RA_RNF_LDID_TO_RAID_REG5_U_CXRH_NID264, LDID45_RAID, 40, 6)
    FIELD(POR_CXG_RA_RNF_LDID_TO_RAID_REG5_U_CXRH_NID264, RESERVED_38, 38, 2)
    FIELD(POR_CXG_RA_RNF_LDID_TO_RAID_REG5_U_CXRH_NID264, LDID44_RAID, 32, 6)
    FIELD(POR_CXG_RA_RNF_LDID_TO_RAID_REG5_U_CXRH_NID264, RESERVED_30, 30, 2)
    FIELD(POR_CXG_RA_RNF_LDID_TO_RAID_REG5_U_CXRH_NID264, LDID43_RAID, 24, 6)
    FIELD(POR_CXG_RA_RNF_LDID_TO_RAID_REG5_U_CXRH_NID264, RESERVED_22, 22, 2)
    FIELD(POR_CXG_RA_RNF_LDID_TO_RAID_REG5_U_CXRH_NID264, LDID42_RAID, 16, 6)
    FIELD(POR_CXG_RA_RNF_LDID_TO_RAID_REG5_U_CXRH_NID264, RESERVED_14, 14, 2)
    FIELD(POR_CXG_RA_RNF_LDID_TO_RAID_REG5_U_CXRH_NID264, LDID41_RAID, 8, 6)
    FIELD(POR_CXG_RA_RNF_LDID_TO_RAID_REG5_U_CXRH_NID264, LDID40_RAID, 0, 6)
REG32(POR_CXG_RA_RNF_LDID_TO_RAID_REG6_U_CXRH_NID264, 0x2100ed0)
    FIELD(POR_CXG_RA_RNF_LDID_TO_RAID_REG6_U_CXRH_NID264, RESERVED_62, 62, 2)
    FIELD(POR_CXG_RA_RNF_LDID_TO_RAID_REG6_U_CXRH_NID264, LDID55_RAID, 56, 6)
    FIELD(POR_CXG_RA_RNF_LDID_TO_RAID_REG6_U_CXRH_NID264, RESERVED_54, 54, 2)
    FIELD(POR_CXG_RA_RNF_LDID_TO_RAID_REG6_U_CXRH_NID264, LDID54_RAID, 48, 6)
    FIELD(POR_CXG_RA_RNF_LDID_TO_RAID_REG6_U_CXRH_NID264, RESERVED_46, 46, 2)
    FIELD(POR_CXG_RA_RNF_LDID_TO_RAID_REG6_U_CXRH_NID264, LDID53_RAID, 40, 6)
    FIELD(POR_CXG_RA_RNF_LDID_TO_RAID_REG6_U_CXRH_NID264, RESERVED_38, 38, 2)
    FIELD(POR_CXG_RA_RNF_LDID_TO_RAID_REG6_U_CXRH_NID264, LDID52_RAID, 32, 6)
    FIELD(POR_CXG_RA_RNF_LDID_TO_RAID_REG6_U_CXRH_NID264, RESERVED_30, 30, 2)
    FIELD(POR_CXG_RA_RNF_LDID_TO_RAID_REG6_U_CXRH_NID264, LDID51_RAID, 24, 6)
    FIELD(POR_CXG_RA_RNF_LDID_TO_RAID_REG6_U_CXRH_NID264, RESERVED_22, 22, 2)
    FIELD(POR_CXG_RA_RNF_LDID_TO_RAID_REG6_U_CXRH_NID264, LDID50_RAID, 16, 6)
    FIELD(POR_CXG_RA_RNF_LDID_TO_RAID_REG6_U_CXRH_NID264, RESERVED_14, 14, 2)
    FIELD(POR_CXG_RA_RNF_LDID_TO_RAID_REG6_U_CXRH_NID264, LDID49_RAID, 8, 6)
    FIELD(POR_CXG_RA_RNF_LDID_TO_RAID_REG6_U_CXRH_NID264, LDID48_RAID, 0, 6)
REG32(POR_CXG_RA_RNF_LDID_TO_RAID_REG7_U_CXRH_NID264, 0x2100ed8)
    FIELD(POR_CXG_RA_RNF_LDID_TO_RAID_REG7_U_CXRH_NID264, RESERVED_62, 62, 2)
    FIELD(POR_CXG_RA_RNF_LDID_TO_RAID_REG7_U_CXRH_NID264, LDID63_RAID, 56, 6)
    FIELD(POR_CXG_RA_RNF_LDID_TO_RAID_REG7_U_CXRH_NID264, RESERVED_54, 54, 2)
    FIELD(POR_CXG_RA_RNF_LDID_TO_RAID_REG7_U_CXRH_NID264, LDID62_RAID, 48, 6)
    FIELD(POR_CXG_RA_RNF_LDID_TO_RAID_REG7_U_CXRH_NID264, RESERVED_46, 46, 2)
    FIELD(POR_CXG_RA_RNF_LDID_TO_RAID_REG7_U_CXRH_NID264, LDID61_RAID, 40, 6)
    FIELD(POR_CXG_RA_RNF_LDID_TO_RAID_REG7_U_CXRH_NID264, RESERVED_38, 38, 2)
    FIELD(POR_CXG_RA_RNF_LDID_TO_RAID_REG7_U_CXRH_NID264, LDID60_RAID, 32, 6)
    FIELD(POR_CXG_RA_RNF_LDID_TO_RAID_REG7_U_CXRH_NID264, RESERVED_30, 30, 2)
    FIELD(POR_CXG_RA_RNF_LDID_TO_RAID_REG7_U_CXRH_NID264, LDID59_RAID, 24, 6)
    FIELD(POR_CXG_RA_RNF_LDID_TO_RAID_REG7_U_CXRH_NID264, RESERVED_22, 22, 2)
    FIELD(POR_CXG_RA_RNF_LDID_TO_RAID_REG7_U_CXRH_NID264, LDID58_RAID, 16, 6)
    FIELD(POR_CXG_RA_RNF_LDID_TO_RAID_REG7_U_CXRH_NID264, RESERVED_14, 14, 2)
    FIELD(POR_CXG_RA_RNF_LDID_TO_RAID_REG7_U_CXRH_NID264, LDID57_RAID, 8, 6)
    FIELD(POR_CXG_RA_RNF_LDID_TO_RAID_REG7_U_CXRH_NID264, LDID56_RAID, 0, 6)
REG32(POR_CXG_RA_RNI_LDID_TO_RAID_REG0_U_CXRH_NID264, 0x2100ee0)
    FIELD(POR_CXG_RA_RNI_LDID_TO_RAID_REG0_U_CXRH_NID264, RESERVED_62, 62, 2)
    FIELD(POR_CXG_RA_RNI_LDID_TO_RAID_REG0_U_CXRH_NID264, LDID7_RAID, 56, 6)
    FIELD(POR_CXG_RA_RNI_LDID_TO_RAID_REG0_U_CXRH_NID264, RESERVED_54, 54, 2)
    FIELD(POR_CXG_RA_RNI_LDID_TO_RAID_REG0_U_CXRH_NID264, LDID6_RAID, 48, 6)
    FIELD(POR_CXG_RA_RNI_LDID_TO_RAID_REG0_U_CXRH_NID264, RESERVED_46, 46, 2)
    FIELD(POR_CXG_RA_RNI_LDID_TO_RAID_REG0_U_CXRH_NID264, LDID5_RAID, 40, 6)
    FIELD(POR_CXG_RA_RNI_LDID_TO_RAID_REG0_U_CXRH_NID264, RESERVED_38, 38, 2)
    FIELD(POR_CXG_RA_RNI_LDID_TO_RAID_REG0_U_CXRH_NID264, LDID4_RAID, 32, 6)
    FIELD(POR_CXG_RA_RNI_LDID_TO_RAID_REG0_U_CXRH_NID264, RESERVED_30, 30, 2)
    FIELD(POR_CXG_RA_RNI_LDID_TO_RAID_REG0_U_CXRH_NID264, LDID3_RAID, 24, 6)
    FIELD(POR_CXG_RA_RNI_LDID_TO_RAID_REG0_U_CXRH_NID264, RESERVED_22, 22, 2)
    FIELD(POR_CXG_RA_RNI_LDID_TO_RAID_REG0_U_CXRH_NID264, LDID2_RAID, 16, 6)
    FIELD(POR_CXG_RA_RNI_LDID_TO_RAID_REG0_U_CXRH_NID264, RESERVED_14, 14, 2)
    FIELD(POR_CXG_RA_RNI_LDID_TO_RAID_REG0_U_CXRH_NID264, LDID1_RAID, 8, 6)
    FIELD(POR_CXG_RA_RNI_LDID_TO_RAID_REG0_U_CXRH_NID264, LDID0_RAID, 0, 6)
REG32(POR_CXG_RA_RNI_LDID_TO_RAID_REG1_U_CXRH_NID264, 0x2100ee8)
    FIELD(POR_CXG_RA_RNI_LDID_TO_RAID_REG1_U_CXRH_NID264, RESERVED_62, 62, 2)
    FIELD(POR_CXG_RA_RNI_LDID_TO_RAID_REG1_U_CXRH_NID264, LDID15_RAID, 56, 6)
    FIELD(POR_CXG_RA_RNI_LDID_TO_RAID_REG1_U_CXRH_NID264, RESERVED_54, 54, 2)
    FIELD(POR_CXG_RA_RNI_LDID_TO_RAID_REG1_U_CXRH_NID264, LDID14_RAID, 48, 6)
    FIELD(POR_CXG_RA_RNI_LDID_TO_RAID_REG1_U_CXRH_NID264, RESERVED_46, 46, 2)
    FIELD(POR_CXG_RA_RNI_LDID_TO_RAID_REG1_U_CXRH_NID264, LDID13_RAID, 40, 6)
    FIELD(POR_CXG_RA_RNI_LDID_TO_RAID_REG1_U_CXRH_NID264, RESERVED_38, 38, 2)
    FIELD(POR_CXG_RA_RNI_LDID_TO_RAID_REG1_U_CXRH_NID264, LDID12_RAID, 32, 6)
    FIELD(POR_CXG_RA_RNI_LDID_TO_RAID_REG1_U_CXRH_NID264, RESERVED_30, 30, 2)
    FIELD(POR_CXG_RA_RNI_LDID_TO_RAID_REG1_U_CXRH_NID264, LDID11_RAID, 24, 6)
    FIELD(POR_CXG_RA_RNI_LDID_TO_RAID_REG1_U_CXRH_NID264, RESERVED_22, 22, 2)
    FIELD(POR_CXG_RA_RNI_LDID_TO_RAID_REG1_U_CXRH_NID264, LDID10_RAID, 16, 6)
    FIELD(POR_CXG_RA_RNI_LDID_TO_RAID_REG1_U_CXRH_NID264, RESERVED_14, 14, 2)
    FIELD(POR_CXG_RA_RNI_LDID_TO_RAID_REG1_U_CXRH_NID264, LDID9_RAID, 8, 6)
    FIELD(POR_CXG_RA_RNI_LDID_TO_RAID_REG1_U_CXRH_NID264, LDID8_RAID, 0, 6)
REG32(POR_CXG_RA_RNI_LDID_TO_RAID_REG2_U_CXRH_NID264, 0x2100ef0)
    FIELD(POR_CXG_RA_RNI_LDID_TO_RAID_REG2_U_CXRH_NID264, RESERVED_62, 62, 2)
    FIELD(POR_CXG_RA_RNI_LDID_TO_RAID_REG2_U_CXRH_NID264, LDID23_RAID, 56, 6)
    FIELD(POR_CXG_RA_RNI_LDID_TO_RAID_REG2_U_CXRH_NID264, RESERVED_54, 54, 2)
    FIELD(POR_CXG_RA_RNI_LDID_TO_RAID_REG2_U_CXRH_NID264, LDID22_RAID, 48, 6)
    FIELD(POR_CXG_RA_RNI_LDID_TO_RAID_REG2_U_CXRH_NID264, RESERVED_46, 46, 2)
    FIELD(POR_CXG_RA_RNI_LDID_TO_RAID_REG2_U_CXRH_NID264, LDID21_RAID, 40, 6)
    FIELD(POR_CXG_RA_RNI_LDID_TO_RAID_REG2_U_CXRH_NID264, RESERVED_38, 38, 2)
    FIELD(POR_CXG_RA_RNI_LDID_TO_RAID_REG2_U_CXRH_NID264, LDID20_RAID, 32, 6)
    FIELD(POR_CXG_RA_RNI_LDID_TO_RAID_REG2_U_CXRH_NID264, RESERVED_30, 30, 2)
    FIELD(POR_CXG_RA_RNI_LDID_TO_RAID_REG2_U_CXRH_NID264, LDID19_RAID, 24, 6)
    FIELD(POR_CXG_RA_RNI_LDID_TO_RAID_REG2_U_CXRH_NID264, RESERVED_22, 22, 2)
    FIELD(POR_CXG_RA_RNI_LDID_TO_RAID_REG2_U_CXRH_NID264, LDID18_RAID, 16, 6)
    FIELD(POR_CXG_RA_RNI_LDID_TO_RAID_REG2_U_CXRH_NID264, RESERVED_14, 14, 2)
    FIELD(POR_CXG_RA_RNI_LDID_TO_RAID_REG2_U_CXRH_NID264, LDID17_RAID, 8, 6)
    FIELD(POR_CXG_RA_RNI_LDID_TO_RAID_REG2_U_CXRH_NID264, LDID16_RAID, 0, 6)
REG32(POR_CXG_RA_RNI_LDID_TO_RAID_REG3_U_CXRH_NID264, 0x2100ef8)
    FIELD(POR_CXG_RA_RNI_LDID_TO_RAID_REG3_U_CXRH_NID264, RESERVED_62, 62, 2)
    FIELD(POR_CXG_RA_RNI_LDID_TO_RAID_REG3_U_CXRH_NID264, LDID31_RAID, 56, 6)
    FIELD(POR_CXG_RA_RNI_LDID_TO_RAID_REG3_U_CXRH_NID264, RESERVED_54, 54, 2)
    FIELD(POR_CXG_RA_RNI_LDID_TO_RAID_REG3_U_CXRH_NID264, LDID30_RAID, 48, 6)
    FIELD(POR_CXG_RA_RNI_LDID_TO_RAID_REG3_U_CXRH_NID264, RESERVED_46, 46, 2)
    FIELD(POR_CXG_RA_RNI_LDID_TO_RAID_REG3_U_CXRH_NID264, LDID29_RAID, 40, 6)
    FIELD(POR_CXG_RA_RNI_LDID_TO_RAID_REG3_U_CXRH_NID264, RESERVED_38, 38, 2)
    FIELD(POR_CXG_RA_RNI_LDID_TO_RAID_REG3_U_CXRH_NID264, LDID28_RAID, 32, 6)
    FIELD(POR_CXG_RA_RNI_LDID_TO_RAID_REG3_U_CXRH_NID264, RESERVED_30, 30, 2)
    FIELD(POR_CXG_RA_RNI_LDID_TO_RAID_REG3_U_CXRH_NID264, LDID27_RAID, 24, 6)
    FIELD(POR_CXG_RA_RNI_LDID_TO_RAID_REG3_U_CXRH_NID264, RESERVED_22, 22, 2)
    FIELD(POR_CXG_RA_RNI_LDID_TO_RAID_REG3_U_CXRH_NID264, LDID26_RAID, 16, 6)
    FIELD(POR_CXG_RA_RNI_LDID_TO_RAID_REG3_U_CXRH_NID264, RESERVED_14, 14, 2)
    FIELD(POR_CXG_RA_RNI_LDID_TO_RAID_REG3_U_CXRH_NID264, LDID25_RAID, 8, 6)
    FIELD(POR_CXG_RA_RNI_LDID_TO_RAID_REG3_U_CXRH_NID264, LDID24_RAID, 0, 6)
REG32(POR_CXG_RA_RND_LDID_TO_RAID_REG0_U_CXRH_NID264, 0x2100f00)
    FIELD(POR_CXG_RA_RND_LDID_TO_RAID_REG0_U_CXRH_NID264, RESERVED_62, 62, 2)
    FIELD(POR_CXG_RA_RND_LDID_TO_RAID_REG0_U_CXRH_NID264, LDID7_RAID, 56, 6)
    FIELD(POR_CXG_RA_RND_LDID_TO_RAID_REG0_U_CXRH_NID264, RESERVED_54, 54, 2)
    FIELD(POR_CXG_RA_RND_LDID_TO_RAID_REG0_U_CXRH_NID264, LDID6_RAID, 48, 6)
    FIELD(POR_CXG_RA_RND_LDID_TO_RAID_REG0_U_CXRH_NID264, RESERVED_46, 46, 2)
    FIELD(POR_CXG_RA_RND_LDID_TO_RAID_REG0_U_CXRH_NID264, LDID5_RAID, 40, 6)
    FIELD(POR_CXG_RA_RND_LDID_TO_RAID_REG0_U_CXRH_NID264, RESERVED_38, 38, 2)
    FIELD(POR_CXG_RA_RND_LDID_TO_RAID_REG0_U_CXRH_NID264, LDID4_RAID, 32, 6)
    FIELD(POR_CXG_RA_RND_LDID_TO_RAID_REG0_U_CXRH_NID264, RESERVED_30, 30, 2)
    FIELD(POR_CXG_RA_RND_LDID_TO_RAID_REG0_U_CXRH_NID264, LDID3_RAID, 24, 6)
    FIELD(POR_CXG_RA_RND_LDID_TO_RAID_REG0_U_CXRH_NID264, RESERVED_22, 22, 2)
    FIELD(POR_CXG_RA_RND_LDID_TO_RAID_REG0_U_CXRH_NID264, LDID2_RAID, 16, 6)
    FIELD(POR_CXG_RA_RND_LDID_TO_RAID_REG0_U_CXRH_NID264, RESERVED_14, 14, 2)
    FIELD(POR_CXG_RA_RND_LDID_TO_RAID_REG0_U_CXRH_NID264, LDID1_RAID, 8, 6)
    FIELD(POR_CXG_RA_RND_LDID_TO_RAID_REG0_U_CXRH_NID264, LDID0_RAID, 0, 6)
REG32(POR_CXG_RA_RND_LDID_TO_RAID_REG1_U_CXRH_NID264, 0x2100f08)
    FIELD(POR_CXG_RA_RND_LDID_TO_RAID_REG1_U_CXRH_NID264, RESERVED_62, 62, 2)
    FIELD(POR_CXG_RA_RND_LDID_TO_RAID_REG1_U_CXRH_NID264, LDID15_RAID, 56, 6)
    FIELD(POR_CXG_RA_RND_LDID_TO_RAID_REG1_U_CXRH_NID264, RESERVED_54, 54, 2)
    FIELD(POR_CXG_RA_RND_LDID_TO_RAID_REG1_U_CXRH_NID264, LDID14_RAID, 48, 6)
    FIELD(POR_CXG_RA_RND_LDID_TO_RAID_REG1_U_CXRH_NID264, RESERVED_46, 46, 2)
    FIELD(POR_CXG_RA_RND_LDID_TO_RAID_REG1_U_CXRH_NID264, LDID13_RAID, 40, 6)
    FIELD(POR_CXG_RA_RND_LDID_TO_RAID_REG1_U_CXRH_NID264, RESERVED_38, 38, 2)
    FIELD(POR_CXG_RA_RND_LDID_TO_RAID_REG1_U_CXRH_NID264, LDID12_RAID, 32, 6)
    FIELD(POR_CXG_RA_RND_LDID_TO_RAID_REG1_U_CXRH_NID264, RESERVED_30, 30, 2)
    FIELD(POR_CXG_RA_RND_LDID_TO_RAID_REG1_U_CXRH_NID264, LDID11_RAID, 24, 6)
    FIELD(POR_CXG_RA_RND_LDID_TO_RAID_REG1_U_CXRH_NID264, RESERVED_22, 22, 2)
    FIELD(POR_CXG_RA_RND_LDID_TO_RAID_REG1_U_CXRH_NID264, LDID10_RAID, 16, 6)
    FIELD(POR_CXG_RA_RND_LDID_TO_RAID_REG1_U_CXRH_NID264, RESERVED_14, 14, 2)
    FIELD(POR_CXG_RA_RND_LDID_TO_RAID_REG1_U_CXRH_NID264, LDID9_RAID, 8, 6)
    FIELD(POR_CXG_RA_RND_LDID_TO_RAID_REG1_U_CXRH_NID264, LDID8_RAID, 0, 6)
REG32(POR_CXG_RA_RND_LDID_TO_RAID_REG2_U_CXRH_NID264, 0x2100f10)
    FIELD(POR_CXG_RA_RND_LDID_TO_RAID_REG2_U_CXRH_NID264, RESERVED_62, 62, 2)
    FIELD(POR_CXG_RA_RND_LDID_TO_RAID_REG2_U_CXRH_NID264, LDID23_RAID, 56, 6)
    FIELD(POR_CXG_RA_RND_LDID_TO_RAID_REG2_U_CXRH_NID264, RESERVED_54, 54, 2)
    FIELD(POR_CXG_RA_RND_LDID_TO_RAID_REG2_U_CXRH_NID264, LDID22_RAID, 48, 6)
    FIELD(POR_CXG_RA_RND_LDID_TO_RAID_REG2_U_CXRH_NID264, RESERVED_46, 46, 2)
    FIELD(POR_CXG_RA_RND_LDID_TO_RAID_REG2_U_CXRH_NID264, LDID21_RAID, 40, 6)
    FIELD(POR_CXG_RA_RND_LDID_TO_RAID_REG2_U_CXRH_NID264, RESERVED_38, 38, 2)
    FIELD(POR_CXG_RA_RND_LDID_TO_RAID_REG2_U_CXRH_NID264, LDID20_RAID, 32, 6)
    FIELD(POR_CXG_RA_RND_LDID_TO_RAID_REG2_U_CXRH_NID264, RESERVED_30, 30, 2)
    FIELD(POR_CXG_RA_RND_LDID_TO_RAID_REG2_U_CXRH_NID264, LDID19_RAID, 24, 6)
    FIELD(POR_CXG_RA_RND_LDID_TO_RAID_REG2_U_CXRH_NID264, RESERVED_22, 22, 2)
    FIELD(POR_CXG_RA_RND_LDID_TO_RAID_REG2_U_CXRH_NID264, LDID18_RAID, 16, 6)
    FIELD(POR_CXG_RA_RND_LDID_TO_RAID_REG2_U_CXRH_NID264, RESERVED_14, 14, 2)
    FIELD(POR_CXG_RA_RND_LDID_TO_RAID_REG2_U_CXRH_NID264, LDID17_RAID, 8, 6)
    FIELD(POR_CXG_RA_RND_LDID_TO_RAID_REG2_U_CXRH_NID264, LDID16_RAID, 0, 6)
REG32(POR_CXG_RA_RND_LDID_TO_RAID_REG3_U_CXRH_NID264, 0x2100f18)
    FIELD(POR_CXG_RA_RND_LDID_TO_RAID_REG3_U_CXRH_NID264, RESERVED_62, 62, 2)
    FIELD(POR_CXG_RA_RND_LDID_TO_RAID_REG3_U_CXRH_NID264, LDID31_RAID, 56, 6)
    FIELD(POR_CXG_RA_RND_LDID_TO_RAID_REG3_U_CXRH_NID264, RESERVED_54, 54, 2)
    FIELD(POR_CXG_RA_RND_LDID_TO_RAID_REG3_U_CXRH_NID264, LDID30_RAID, 48, 6)
    FIELD(POR_CXG_RA_RND_LDID_TO_RAID_REG3_U_CXRH_NID264, RESERVED_46, 46, 2)
    FIELD(POR_CXG_RA_RND_LDID_TO_RAID_REG3_U_CXRH_NID264, LDID29_RAID, 40, 6)
    FIELD(POR_CXG_RA_RND_LDID_TO_RAID_REG3_U_CXRH_NID264, RESERVED_38, 38, 2)
    FIELD(POR_CXG_RA_RND_LDID_TO_RAID_REG3_U_CXRH_NID264, LDID28_RAID, 32, 6)
    FIELD(POR_CXG_RA_RND_LDID_TO_RAID_REG3_U_CXRH_NID264, RESERVED_30, 30, 2)
    FIELD(POR_CXG_RA_RND_LDID_TO_RAID_REG3_U_CXRH_NID264, LDID27_RAID, 24, 6)
    FIELD(POR_CXG_RA_RND_LDID_TO_RAID_REG3_U_CXRH_NID264, RESERVED_22, 22, 2)
    FIELD(POR_CXG_RA_RND_LDID_TO_RAID_REG3_U_CXRH_NID264, LDID26_RAID, 16, 6)
    FIELD(POR_CXG_RA_RND_LDID_TO_RAID_REG3_U_CXRH_NID264, RESERVED_14, 14, 2)
    FIELD(POR_CXG_RA_RND_LDID_TO_RAID_REG3_U_CXRH_NID264, LDID25_RAID, 8, 6)
    FIELD(POR_CXG_RA_RND_LDID_TO_RAID_REG3_U_CXRH_NID264, LDID24_RAID, 0, 6)
REG32(POR_CXG_RA_AGENTID_TO_LINKID_VAL_U_CXRH_NID264, 0x2100f20)
REG32(POR_CXG_RA_RNF_LDID_TO_RAID_VAL_U_CXRH_NID264, 0x2100f28)
REG32(POR_CXG_RA_RNI_LDID_TO_RAID_VAL_U_CXRH_NID264, 0x2100f30)
    FIELD(POR_CXG_RA_RNI_LDID_TO_RAID_VAL_U_CXRH_NID264, RESERVED_32, 32, 32)
    FIELD(POR_CXG_RA_RNI_LDID_TO_RAID_VAL_U_CXRH_NID264, VALID, 0, 32)
REG32(POR_CXG_RA_RND_LDID_TO_RAID_VAL_U_CXRH_NID264, 0x2100f38)
    FIELD(POR_CXG_RA_RND_LDID_TO_RAID_VAL_U_CXRH_NID264, RESERVED_32, 32, 32)
    FIELD(POR_CXG_RA_RND_LDID_TO_RAID_VAL_U_CXRH_NID264, VALID, 0, 32)
REG32(POR_CXG_RA_CXPRTCL_LINK0_CTL_U_CXRH_NID264, 0x2101000)
    FIELD(POR_CXG_RA_CXPRTCL_LINK0_CTL_U_CXRH_NID264, RESERVED_9, 9, 55)
    FIELD(POR_CXG_RA_CXPRTCL_LINK0_CTL_U_CXRH_NID264, LNK0_DIS_CPUEVENT_PROP, 8, 1)
    FIELD(POR_CXG_RA_CXPRTCL_LINK0_CTL_U_CXRH_NID264, LNK0_NUM_SNPCRDS, 4, 4)
    FIELD(POR_CXG_RA_CXPRTCL_LINK0_CTL_U_CXRH_NID264, LNK0_DVMDOMAIN_REQ, 3, 1)
    FIELD(POR_CXG_RA_CXPRTCL_LINK0_CTL_U_CXRH_NID264, LNK0_LINK_UP, 2, 1)
    FIELD(POR_CXG_RA_CXPRTCL_LINK0_CTL_U_CXRH_NID264, LNK0_LINK_REQ, 1, 1)
    FIELD(POR_CXG_RA_CXPRTCL_LINK0_CTL_U_CXRH_NID264, LNK0_LINK_EN, 0, 1)
REG32(POR_CXG_RA_CXPRTCL_LINK0_STATUS_U_CXRH_NID264, 0x2101008)
    FIELD(POR_CXG_RA_CXPRTCL_LINK0_STATUS_U_CXRH_NID264, LNK0_OT_CBKWR, 3, 1)
    FIELD(POR_CXG_RA_CXPRTCL_LINK0_STATUS_U_CXRH_NID264, LNK0_DVMDOMAIN_ACK, 2, 1)
    FIELD(POR_CXG_RA_CXPRTCL_LINK0_STATUS_U_CXRH_NID264, LNK0_LINK_DOWN, 1, 1)
    FIELD(POR_CXG_RA_CXPRTCL_LINK0_STATUS_U_CXRH_NID264, LNK0_LINK_ACK, 0, 1)
REG32(POR_CXG_RA_CXPRTCL_LINK1_CTL_U_CXRH_NID264, 0x2101010)
    FIELD(POR_CXG_RA_CXPRTCL_LINK1_CTL_U_CXRH_NID264, RESERVED_9, 9, 55)
    FIELD(POR_CXG_RA_CXPRTCL_LINK1_CTL_U_CXRH_NID264, LNK1_DIS_CPUEVENT_PROP, 8, 1)
    FIELD(POR_CXG_RA_CXPRTCL_LINK1_CTL_U_CXRH_NID264, LNK1_NUM_SNPCRDS, 4, 4)
    FIELD(POR_CXG_RA_CXPRTCL_LINK1_CTL_U_CXRH_NID264, LNK1_DVMDOMAIN_REQ, 3, 1)
    FIELD(POR_CXG_RA_CXPRTCL_LINK1_CTL_U_CXRH_NID264, LNK1_LINK_UP, 2, 1)
    FIELD(POR_CXG_RA_CXPRTCL_LINK1_CTL_U_CXRH_NID264, LNK1_LINK_REQ, 1, 1)
    FIELD(POR_CXG_RA_CXPRTCL_LINK1_CTL_U_CXRH_NID264, LNK1_LINK_EN, 0, 1)
REG32(POR_CXG_RA_CXPRTCL_LINK1_STATUS_U_CXRH_NID264, 0x2101018)
    FIELD(POR_CXG_RA_CXPRTCL_LINK1_STATUS_U_CXRH_NID264, LNK1_OT_CBKWR, 3, 1)
    FIELD(POR_CXG_RA_CXPRTCL_LINK1_STATUS_U_CXRH_NID264, LNK1_DVMDOMAIN_ACK, 2, 1)
    FIELD(POR_CXG_RA_CXPRTCL_LINK1_STATUS_U_CXRH_NID264, LNK1_LINK_DOWN, 1, 1)
    FIELD(POR_CXG_RA_CXPRTCL_LINK1_STATUS_U_CXRH_NID264, LNK1_LINK_ACK, 0, 1)
REG32(POR_CXG_RA_CXPRTCL_LINK2_CTL_U_CXRH_NID264, 0x2101020)
    FIELD(POR_CXG_RA_CXPRTCL_LINK2_CTL_U_CXRH_NID264, RESERVED_9, 9, 55)
    FIELD(POR_CXG_RA_CXPRTCL_LINK2_CTL_U_CXRH_NID264, LNK2_DIS_CPUEVENT_PROP, 8, 1)
    FIELD(POR_CXG_RA_CXPRTCL_LINK2_CTL_U_CXRH_NID264, LNK2_NUM_SNPCRDS, 4, 4)
    FIELD(POR_CXG_RA_CXPRTCL_LINK2_CTL_U_CXRH_NID264, LNK2_DVMDOMAIN_REQ, 3, 1)
    FIELD(POR_CXG_RA_CXPRTCL_LINK2_CTL_U_CXRH_NID264, LNK2_LINK_UP, 2, 1)
    FIELD(POR_CXG_RA_CXPRTCL_LINK2_CTL_U_CXRH_NID264, LNK2_LINK_REQ, 1, 1)
    FIELD(POR_CXG_RA_CXPRTCL_LINK2_CTL_U_CXRH_NID264, LNK2_LINK_EN, 0, 1)
REG32(POR_CXG_RA_CXPRTCL_LINK2_STATUS_U_CXRH_NID264, 0x2101028)
    FIELD(POR_CXG_RA_CXPRTCL_LINK2_STATUS_U_CXRH_NID264, LNK2_OT_CBKWR, 3, 1)
    FIELD(POR_CXG_RA_CXPRTCL_LINK2_STATUS_U_CXRH_NID264, LNK2_DVMDOMAIN_ACK, 2, 1)
    FIELD(POR_CXG_RA_CXPRTCL_LINK2_STATUS_U_CXRH_NID264, LNK2_LINK_DOWN, 1, 1)
    FIELD(POR_CXG_RA_CXPRTCL_LINK2_STATUS_U_CXRH_NID264, LNK2_LINK_ACK, 0, 1)
REG32(POR_CXG_RA_PMU_EVENT_SEL_U_CXRH_NID264, 0x2102000)
    FIELD(POR_CXG_RA_PMU_EVENT_SEL_U_CXRH_NID264, RESERVED_36, 36, 28)
    FIELD(POR_CXG_RA_PMU_EVENT_SEL_U_CXRH_NID264, PMU_OCCUP1_ID, 32, 4)
    FIELD(POR_CXG_RA_PMU_EVENT_SEL_U_CXRH_NID264, RESERVED_30, 30, 2)
    FIELD(POR_CXG_RA_PMU_EVENT_SEL_U_CXRH_NID264, PMU_EVENT3_ID, 24, 6)
    FIELD(POR_CXG_RA_PMU_EVENT_SEL_U_CXRH_NID264, RESERVED_22, 22, 2)
    FIELD(POR_CXG_RA_PMU_EVENT_SEL_U_CXRH_NID264, PMU_EVENT2_ID, 16, 6)
    FIELD(POR_CXG_RA_PMU_EVENT_SEL_U_CXRH_NID264, RESERVED_14, 14, 2)
    FIELD(POR_CXG_RA_PMU_EVENT_SEL_U_CXRH_NID264, PMU_EVENT1_ID, 8, 6)
    FIELD(POR_CXG_RA_PMU_EVENT_SEL_U_CXRH_NID264, PMU_EVENT0_ID, 0, 6)
REG32(POR_MXP_NODE_INFO_U_SMXP_4_1, 0x2108000)
    FIELD(POR_MXP_NODE_INFO_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MXP_NODE_INFO_U_SMXP_4_1, LOGICAL_ID, 32, 16)
    FIELD(POR_MXP_NODE_INFO_U_SMXP_4_1, XY_ID, 16, 16)
    FIELD(POR_MXP_NODE_INFO_U_SMXP_4_1, NODE_TYPE, 0, 16)
REG32(POR_MXP_DEVICE_PORT_CONNECT_INFO_P0_U_SMXP_4_1, 0x2108008)
    FIELD(POR_MXP_DEVICE_PORT_CONNECT_INFO_P0_U_SMXP_4_1, RESERVED_32, 32, 32)
    FIELD(POR_MXP_DEVICE_PORT_CONNECT_INFO_P0_U_SMXP_4_1, NUM_DCS_P0_D3, 28, 4)
    FIELD(POR_MXP_DEVICE_PORT_CONNECT_INFO_P0_U_SMXP_4_1, NUM_DCS_P0_D2, 24, 4)
    FIELD(POR_MXP_DEVICE_PORT_CONNECT_INFO_P0_U_SMXP_4_1, NUM_DCS_P0_D1, 20, 4)
    FIELD(POR_MXP_DEVICE_PORT_CONNECT_INFO_P0_U_SMXP_4_1, NUM_DCS_P0_D0, 16, 4)
    FIELD(POR_MXP_DEVICE_PORT_CONNECT_INFO_P0_U_SMXP_4_1, DEVICE_TYPE_P0, 0, 5)
REG32(POR_MXP_DEVICE_PORT_CONNECT_INFO_P1_U_SMXP_4_1, 0x2108010)
    FIELD(POR_MXP_DEVICE_PORT_CONNECT_INFO_P1_U_SMXP_4_1, RESERVED_32, 32, 32)
    FIELD(POR_MXP_DEVICE_PORT_CONNECT_INFO_P1_U_SMXP_4_1, NUM_DCS_P1_D3, 28, 4)
    FIELD(POR_MXP_DEVICE_PORT_CONNECT_INFO_P1_U_SMXP_4_1, NUM_DCS_P1_D2, 24, 4)
    FIELD(POR_MXP_DEVICE_PORT_CONNECT_INFO_P1_U_SMXP_4_1, NUM_DCS_P1_D1, 20, 4)
    FIELD(POR_MXP_DEVICE_PORT_CONNECT_INFO_P1_U_SMXP_4_1, NUM_DCS_P1_D0, 16, 4)
    FIELD(POR_MXP_DEVICE_PORT_CONNECT_INFO_P1_U_SMXP_4_1, DEVICE_TYPE_P1, 0, 5)
REG32(POR_MXP_MESH_PORT_CONNECT_INFO_EAST_U_SMXP_4_1, 0x2108018)
    FIELD(POR_MXP_MESH_PORT_CONNECT_INFO_EAST_U_SMXP_4_1, NUM_MCS_EAST, 0, 4)
REG32(POR_MXP_MESH_PORT_CONNECT_INFO_NORTH_U_SMXP_4_1, 0x2108020)
    FIELD(POR_MXP_MESH_PORT_CONNECT_INFO_NORTH_U_SMXP_4_1, NUM_MCS_NORTH, 0, 4)
REG32(POR_MXP_CHILD_INFO_U_SMXP_4_1, 0x2108080)
    FIELD(POR_MXP_CHILD_INFO_U_SMXP_4_1, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_INFO_U_SMXP_4_1, CHILD_PTR_OFFSET, 16, 16)
    FIELD(POR_MXP_CHILD_INFO_U_SMXP_4_1, CHILD_COUNT, 0, 16)
REG32(POR_MXP_CHILD_POINTER_0_U_SMXP_4_1, 0x2108100)
    FIELD(POR_MXP_CHILD_POINTER_0_U_SMXP_4_1, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_POINTER_0_U_SMXP_4_1, RELATIVE_ADDRESS_0, 0, 32)
REG32(POR_MXP_CHILD_POINTER_1_U_SMXP_4_1, 0x2108108)
    FIELD(POR_MXP_CHILD_POINTER_1_U_SMXP_4_1, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_POINTER_1_U_SMXP_4_1, RELATIVE_ADDRESS_1, 0, 32)
REG32(POR_MXP_CHILD_POINTER_2_U_SMXP_4_1, 0x2108110)
    FIELD(POR_MXP_CHILD_POINTER_2_U_SMXP_4_1, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_POINTER_2_U_SMXP_4_1, RELATIVE_ADDRESS_2, 0, 32)
REG32(POR_MXP_CHILD_POINTER_3_U_SMXP_4_1, 0x2108118)
    FIELD(POR_MXP_CHILD_POINTER_3_U_SMXP_4_1, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_POINTER_3_U_SMXP_4_1, RELATIVE_ADDRESS_3, 0, 32)
REG32(POR_MXP_CHILD_POINTER_4_U_SMXP_4_1, 0x2108120)
    FIELD(POR_MXP_CHILD_POINTER_4_U_SMXP_4_1, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_POINTER_4_U_SMXP_4_1, RELATIVE_ADDRESS_4, 0, 32)
REG32(POR_MXP_CHILD_POINTER_5_U_SMXP_4_1, 0x2108128)
    FIELD(POR_MXP_CHILD_POINTER_5_U_SMXP_4_1, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_POINTER_5_U_SMXP_4_1, RELATIVE_ADDRESS_5, 0, 32)
REG32(POR_MXP_CHILD_POINTER_6_U_SMXP_4_1, 0x2108130)
    FIELD(POR_MXP_CHILD_POINTER_6_U_SMXP_4_1, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_POINTER_6_U_SMXP_4_1, RELATIVE_ADDRESS_6, 0, 32)
REG32(POR_MXP_CHILD_POINTER_7_U_SMXP_4_1, 0x2108138)
    FIELD(POR_MXP_CHILD_POINTER_7_U_SMXP_4_1, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_POINTER_7_U_SMXP_4_1, RELATIVE_ADDRESS_7, 0, 32)
REG32(POR_MXP_CHILD_POINTER_8_U_SMXP_4_1, 0x2108140)
    FIELD(POR_MXP_CHILD_POINTER_8_U_SMXP_4_1, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_POINTER_8_U_SMXP_4_1, RELATIVE_ADDRESS_8, 0, 32)
REG32(POR_MXP_CHILD_POINTER_9_U_SMXP_4_1, 0x2108148)
    FIELD(POR_MXP_CHILD_POINTER_9_U_SMXP_4_1, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_POINTER_9_U_SMXP_4_1, RELATIVE_ADDRESS_9, 0, 32)
REG32(POR_MXP_CHILD_POINTER_10_U_SMXP_4_1, 0x2108150)
    FIELD(POR_MXP_CHILD_POINTER_10_U_SMXP_4_1, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_POINTER_10_U_SMXP_4_1, RELATIVE_ADDRESS_10, 0, 32)
REG32(POR_MXP_CHILD_POINTER_11_U_SMXP_4_1, 0x2108158)
    FIELD(POR_MXP_CHILD_POINTER_11_U_SMXP_4_1, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_POINTER_11_U_SMXP_4_1, RELATIVE_ADDRESS_11, 0, 32)
REG32(POR_MXP_CHILD_POINTER_12_U_SMXP_4_1, 0x2108160)
    FIELD(POR_MXP_CHILD_POINTER_12_U_SMXP_4_1, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_POINTER_12_U_SMXP_4_1, RELATIVE_ADDRESS_12, 0, 32)
REG32(POR_MXP_CHILD_POINTER_13_U_SMXP_4_1, 0x2108168)
    FIELD(POR_MXP_CHILD_POINTER_13_U_SMXP_4_1, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_POINTER_13_U_SMXP_4_1, RELATIVE_ADDRESS_13, 0, 32)
REG32(POR_MXP_CHILD_POINTER_14_U_SMXP_4_1, 0x2108170)
    FIELD(POR_MXP_CHILD_POINTER_14_U_SMXP_4_1, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_POINTER_14_U_SMXP_4_1, RELATIVE_ADDRESS_14, 0, 32)
REG32(POR_MXP_CHILD_POINTER_15_U_SMXP_4_1, 0x2108178)
    FIELD(POR_MXP_CHILD_POINTER_15_U_SMXP_4_1, RESERVED_32, 32, 32)
    FIELD(POR_MXP_CHILD_POINTER_15_U_SMXP_4_1, RELATIVE_ADDRESS_15, 0, 32)
REG32(POR_MXP_P0_INFO_U_SMXP_4_1, 0x2108900)
    FIELD(POR_MXP_P0_INFO_U_SMXP_4_1, RESERVED_26, 26, 38)
    FIELD(POR_MXP_P0_INFO_U_SMXP_4_1, A4S_SAFE_XFACE_DISABLE_P0, 25, 1)
    FIELD(POR_MXP_P0_INFO_U_SMXP_4_1, CHI_SAFE_XFACE_DISABLE_P0, 24, 1)
    FIELD(POR_MXP_P0_INFO_U_SMXP_4_1, A4S_LOGICALID_BASE_P0, 16, 8)
    FIELD(POR_MXP_P0_INFO_U_SMXP_4_1, RESERVED_14, 14, 2)
    FIELD(POR_MXP_P0_INFO_U_SMXP_4_1, A4S_NUM_P0, 11, 3)
    FIELD(POR_MXP_P0_INFO_U_SMXP_4_1, RXBUF_NUM_ENTRIES_P0, 8, 3)
    FIELD(POR_MXP_P0_INFO_U_SMXP_4_1, EXT_SAM_EN_P0, 7, 1)
    FIELD(POR_MXP_P0_INFO_U_SMXP_4_1, DATACHECK_EN_P0, 5, 1)
    FIELD(POR_MXP_P0_INFO_U_SMXP_4_1, POISON_EN_P0, 4, 1)
    FIELD(POR_MXP_P0_INFO_U_SMXP_4_1, NUM_DEV_P0, 0, 3)
REG32(POR_MXP_P1_INFO_U_SMXP_4_1, 0x2108908)
    FIELD(POR_MXP_P1_INFO_U_SMXP_4_1, RESERVED_26, 26, 38)
    FIELD(POR_MXP_P1_INFO_U_SMXP_4_1, A4S_SAFE_XFACE_DISABLE_P1, 25, 1)
    FIELD(POR_MXP_P1_INFO_U_SMXP_4_1, CHI_SAFE_XFACE_DISABLE_P1, 24, 1)
    FIELD(POR_MXP_P1_INFO_U_SMXP_4_1, A4S_LOGICALID_BASE_P1, 16, 8)
    FIELD(POR_MXP_P1_INFO_U_SMXP_4_1, RESERVED_14, 14, 2)
    FIELD(POR_MXP_P1_INFO_U_SMXP_4_1, A4S_NUM_P1, 11, 3)
    FIELD(POR_MXP_P1_INFO_U_SMXP_4_1, RXBUF_NUM_ENTRIES_P1, 8, 3)
    FIELD(POR_MXP_P1_INFO_U_SMXP_4_1, EXT_SAM_EN_P1, 7, 1)
    FIELD(POR_MXP_P1_INFO_U_SMXP_4_1, DATACHECK_EN_P1, 5, 1)
    FIELD(POR_MXP_P1_INFO_U_SMXP_4_1, POISON_EN_P1, 4, 1)
    FIELD(POR_MXP_P1_INFO_U_SMXP_4_1, NUM_DEV_P1, 0, 3)
REG32(POR_MXP_SECURE_REGISTER_GROUPS_OVERRIDE_U_SMXP_4_1, 0x2108980)
    FIELD(POR_MXP_SECURE_REGISTER_GROUPS_OVERRIDE_U_SMXP_4_1, SYSCOREQ_CTL, 1, 1)
    FIELD(POR_MXP_SECURE_REGISTER_GROUPS_OVERRIDE_U_SMXP_4_1, QOS, 0, 1)
REG32(POR_MXP_AUX_CTL_U_SMXP_4_1, 0x2108a00)
    FIELD(POR_MXP_AUX_CTL_U_SMXP_4_1, CLKGATE_DISABLE, 0, 1)
REG32(POR_MXP_P0_QOS_CONTROL_U_SMXP_4_1, 0x2108a80)
    FIELD(POR_MXP_P0_QOS_CONTROL_U_SMXP_4_1, RESERVED_20, 20, 44)
    FIELD(POR_MXP_P0_QOS_CONTROL_U_SMXP_4_1, P0_QOS_OVERRIDE, 16, 4)
    FIELD(POR_MXP_P0_QOS_CONTROL_U_SMXP_4_1, P0_PQV_MODE, 6, 1)
    FIELD(POR_MXP_P0_QOS_CONTROL_U_SMXP_4_1, P0_REG_MODE, 4, 1)
    FIELD(POR_MXP_P0_QOS_CONTROL_U_SMXP_4_1, P0_QOS_OVERRIDE_EN, 2, 1)
    FIELD(POR_MXP_P0_QOS_CONTROL_U_SMXP_4_1, P0_LAT_EN, 0, 1)
REG32(POR_MXP_P0_QOS_LAT_TGT_U_SMXP_4_1, 0x2108a88)
    FIELD(POR_MXP_P0_QOS_LAT_TGT_U_SMXP_4_1, RESERVED_12, 12, 52)
    FIELD(POR_MXP_P0_QOS_LAT_TGT_U_SMXP_4_1, P0_LAT_TGT, 0, 12)
REG32(POR_MXP_P0_QOS_LAT_SCALE_U_SMXP_4_1, 0x2108a90)
    FIELD(POR_MXP_P0_QOS_LAT_SCALE_U_SMXP_4_1, P0_LAT_SCALE, 0, 3)
REG32(POR_MXP_P0_QOS_LAT_RANGE_U_SMXP_4_1, 0x2108a98)
    FIELD(POR_MXP_P0_QOS_LAT_RANGE_U_SMXP_4_1, RESERVED_12, 12, 52)
    FIELD(POR_MXP_P0_QOS_LAT_RANGE_U_SMXP_4_1, P0_LAT_MAX_QOS, 8, 4)
    FIELD(POR_MXP_P0_QOS_LAT_RANGE_U_SMXP_4_1, P0_LAT_MIN_QOS, 0, 4)
REG32(POR_MXP_P1_QOS_CONTROL_U_SMXP_4_1, 0x2108aa0)
    FIELD(POR_MXP_P1_QOS_CONTROL_U_SMXP_4_1, RESERVED_20, 20, 44)
    FIELD(POR_MXP_P1_QOS_CONTROL_U_SMXP_4_1, P1_QOS_OVERRIDE, 16, 4)
    FIELD(POR_MXP_P1_QOS_CONTROL_U_SMXP_4_1, P1_PQV_MODE, 6, 1)
    FIELD(POR_MXP_P1_QOS_CONTROL_U_SMXP_4_1, P1_REG_MODE, 4, 1)
    FIELD(POR_MXP_P1_QOS_CONTROL_U_SMXP_4_1, P1_QOS_OVERRIDE_EN, 2, 1)
    FIELD(POR_MXP_P1_QOS_CONTROL_U_SMXP_4_1, P1_LAT_EN, 0, 1)
REG32(POR_MXP_P1_QOS_LAT_TGT_U_SMXP_4_1, 0x2108aa8)
    FIELD(POR_MXP_P1_QOS_LAT_TGT_U_SMXP_4_1, RESERVED_12, 12, 52)
    FIELD(POR_MXP_P1_QOS_LAT_TGT_U_SMXP_4_1, P1_LAT_TGT, 0, 12)
REG32(POR_MXP_P1_QOS_LAT_SCALE_U_SMXP_4_1, 0x2108ab0)
    FIELD(POR_MXP_P1_QOS_LAT_SCALE_U_SMXP_4_1, P1_LAT_SCALE, 0, 3)
REG32(POR_MXP_P1_QOS_LAT_RANGE_U_SMXP_4_1, 0x2108ab8)
    FIELD(POR_MXP_P1_QOS_LAT_RANGE_U_SMXP_4_1, RESERVED_12, 12, 52)
    FIELD(POR_MXP_P1_QOS_LAT_RANGE_U_SMXP_4_1, P1_LAT_MAX_QOS, 8, 4)
    FIELD(POR_MXP_P1_QOS_LAT_RANGE_U_SMXP_4_1, P1_LAT_MIN_QOS, 0, 4)
REG32(POR_MXP_P0_SYSCOREQ_CTL_U_SMXP_4_1, 0x2109000)
    FIELD(POR_MXP_P0_SYSCOREQ_CTL_U_SMXP_4_1, SNPDVM_REQ_P0_D3, 3, 1)
    FIELD(POR_MXP_P0_SYSCOREQ_CTL_U_SMXP_4_1, SNPDVM_REQ_P0_D2, 2, 1)
    FIELD(POR_MXP_P0_SYSCOREQ_CTL_U_SMXP_4_1, SNPDVM_REQ_P0_D1, 1, 1)
    FIELD(POR_MXP_P0_SYSCOREQ_CTL_U_SMXP_4_1, SNPDVM_REQ_P0_D0, 0, 1)
REG32(POR_MXP_P1_SYSCOREQ_CTL_U_SMXP_4_1, 0x2109008)
    FIELD(POR_MXP_P1_SYSCOREQ_CTL_U_SMXP_4_1, SNPDVM_REQ_P1_D3, 3, 1)
    FIELD(POR_MXP_P1_SYSCOREQ_CTL_U_SMXP_4_1, SNPDVM_REQ_P1_D2, 2, 1)
    FIELD(POR_MXP_P1_SYSCOREQ_CTL_U_SMXP_4_1, SNPDVM_REQ_P1_D1, 1, 1)
    FIELD(POR_MXP_P1_SYSCOREQ_CTL_U_SMXP_4_1, SNPDVM_REQ_P1_D0, 0, 1)
REG32(POR_MXP_P0_SYSCOACK_STATUS_U_SMXP_4_1, 0x2109010)
    FIELD(POR_MXP_P0_SYSCOACK_STATUS_U_SMXP_4_1, SNPDVM_ACK_P0_D3, 3, 1)
    FIELD(POR_MXP_P0_SYSCOACK_STATUS_U_SMXP_4_1, SNPDVM_ACK_P0_D2, 2, 1)
    FIELD(POR_MXP_P0_SYSCOACK_STATUS_U_SMXP_4_1, SNPDVM_ACK_P0_D1, 1, 1)
    FIELD(POR_MXP_P0_SYSCOACK_STATUS_U_SMXP_4_1, SNPDVM_ACK_P0_D0, 0, 1)
REG32(POR_MXP_P1_SYSCOACK_STATUS_U_SMXP_4_1, 0x2109018)
    FIELD(POR_MXP_P1_SYSCOACK_STATUS_U_SMXP_4_1, SNPDVM_ACK_P1_D3, 3, 1)
    FIELD(POR_MXP_P1_SYSCOACK_STATUS_U_SMXP_4_1, SNPDVM_ACK_P1_D2, 2, 1)
    FIELD(POR_MXP_P1_SYSCOACK_STATUS_U_SMXP_4_1, SNPDVM_ACK_P1_D1, 1, 1)
    FIELD(POR_MXP_P1_SYSCOACK_STATUS_U_SMXP_4_1, SNPDVM_ACK_P1_D0, 0, 1)
REG32(POR_MXP_PMU_EVENT_SEL_U_SMXP_4_1, 0x210a000)
    FIELD(POR_MXP_PMU_EVENT_SEL_U_SMXP_4_1, RESERVED_32, 32, 32)
    FIELD(POR_MXP_PMU_EVENT_SEL_U_SMXP_4_1, PMU_EVENT3_ID, 24, 8)
    FIELD(POR_MXP_PMU_EVENT_SEL_U_SMXP_4_1, PMU_EVENT2_ID, 16, 8)
    FIELD(POR_MXP_PMU_EVENT_SEL_U_SMXP_4_1, PMU_EVENT1_ID, 8, 8)
    FIELD(POR_MXP_PMU_EVENT_SEL_U_SMXP_4_1, PMU_EVENT0_ID, 0, 8)
REG32(POR_DTM_CONTROL_U_SMXP_4_1, 0x210a100)
    FIELD(POR_DTM_CONTROL_U_SMXP_4_1, TRACE_NO_ATB, 3, 1)
    FIELD(POR_DTM_CONTROL_U_SMXP_4_1, SAMPLE_PROFILE_ENABLE, 2, 1)
    FIELD(POR_DTM_CONTROL_U_SMXP_4_1, TRACE_TAG_ENABLE, 1, 1)
    FIELD(POR_DTM_CONTROL_U_SMXP_4_1, DTM_ENABLE, 0, 1)
REG32(POR_DTM_FIFO_ENTRY_READY_U_SMXP_4_1, 0x210a118)
    FIELD(POR_DTM_FIFO_ENTRY_READY_U_SMXP_4_1, READY, 0, 4)
REG32(POR_DTM_FIFO_ENTRY0_0_U_SMXP_4_1, 0x210a120)
REG32(POR_DTM_FIFO_ENTRY0_1_U_SMXP_4_1, 0x210a128)
REG32(POR_DTM_FIFO_ENTRY0_2_U_SMXP_4_1, 0x210a130)
    FIELD(POR_DTM_FIFO_ENTRY0_2_U_SMXP_4_1, RESERVED_32, 32, 32)
    FIELD(POR_DTM_FIFO_ENTRY0_2_U_SMXP_4_1, FIFO_CYCLE_COUNT, 16, 16)
    FIELD(POR_DTM_FIFO_ENTRY0_2_U_SMXP_4_1, FIFO_DATA2, 0, 16)
REG32(POR_DTM_FIFO_ENTRY1_0_U_SMXP_4_1, 0x210a138)
REG32(POR_DTM_FIFO_ENTRY1_1_U_SMXP_4_1, 0x210a140)
REG32(POR_DTM_FIFO_ENTRY1_2_U_SMXP_4_1, 0x210a148)
    FIELD(POR_DTM_FIFO_ENTRY1_2_U_SMXP_4_1, RESERVED_32, 32, 32)
    FIELD(POR_DTM_FIFO_ENTRY1_2_U_SMXP_4_1, FIFO_CYCLE_COUNT, 16, 16)
    FIELD(POR_DTM_FIFO_ENTRY1_2_U_SMXP_4_1, FIFO_DATA2, 0, 16)
REG32(POR_DTM_FIFO_ENTRY2_0_U_SMXP_4_1, 0x210a150)
REG32(POR_DTM_FIFO_ENTRY2_1_U_SMXP_4_1, 0x210a158)
REG32(POR_DTM_FIFO_ENTRY2_2_U_SMXP_4_1, 0x210a160)
    FIELD(POR_DTM_FIFO_ENTRY2_2_U_SMXP_4_1, RESERVED_32, 32, 32)
    FIELD(POR_DTM_FIFO_ENTRY2_2_U_SMXP_4_1, FIFO_CYCLE_COUNT, 16, 16)
    FIELD(POR_DTM_FIFO_ENTRY2_2_U_SMXP_4_1, FIFO_DATA2, 0, 16)
REG32(POR_DTM_FIFO_ENTRY3_0_U_SMXP_4_1, 0x210a168)
REG32(POR_DTM_FIFO_ENTRY3_1_U_SMXP_4_1, 0x210a170)
REG32(POR_DTM_FIFO_ENTRY3_2_U_SMXP_4_1, 0x210a178)
    FIELD(POR_DTM_FIFO_ENTRY3_2_U_SMXP_4_1, RESERVED_32, 32, 32)
    FIELD(POR_DTM_FIFO_ENTRY3_2_U_SMXP_4_1, FIFO_CYCLE_COUNT, 16, 16)
    FIELD(POR_DTM_FIFO_ENTRY3_2_U_SMXP_4_1, FIFO_DATA2, 0, 16)
REG32(POR_DTM_WP0_CONFIG_U_SMXP_4_1, 0x210a1a0)
    FIELD(POR_DTM_WP0_CONFIG_U_SMXP_4_1, RESERVED_15, 15, 49)
    FIELD(POR_DTM_WP0_CONFIG_U_SMXP_4_1, WP_DBGTRIG_EN, 14, 1)
    FIELD(POR_DTM_WP0_CONFIG_U_SMXP_4_1, WP_CTRIG_EN, 13, 1)
    FIELD(POR_DTM_WP0_CONFIG_U_SMXP_4_1, WP_CC_EN, 12, 1)
    FIELD(POR_DTM_WP0_CONFIG_U_SMXP_4_1, WP_PKT_TYPE, 9, 3)
    FIELD(POR_DTM_WP0_CONFIG_U_SMXP_4_1, WP_PKT_GEN, 8, 1)
    FIELD(POR_DTM_WP0_CONFIG_U_SMXP_4_1, WP_COMBINE, 6, 1)
    FIELD(POR_DTM_WP0_CONFIG_U_SMXP_4_1, WP_EXCLUSIVE, 5, 1)
    FIELD(POR_DTM_WP0_CONFIG_U_SMXP_4_1, WP_GRP, 4, 1)
    FIELD(POR_DTM_WP0_CONFIG_U_SMXP_4_1, WP_CHN_SEL, 1, 3)
    FIELD(POR_DTM_WP0_CONFIG_U_SMXP_4_1, WP_DEV_SEL, 0, 1)
REG32(POR_DTM_WP0_VAL_U_SMXP_4_1, 0x210a1a8)
REG32(POR_DTM_WP0_MASK_U_SMXP_4_1, 0x210a1b0)
REG32(POR_DTM_WP1_CONFIG_U_SMXP_4_1, 0x210a1b8)
    FIELD(POR_DTM_WP1_CONFIG_U_SMXP_4_1, RESERVED_15, 15, 49)
    FIELD(POR_DTM_WP1_CONFIG_U_SMXP_4_1, WP_DBGTRIG_EN, 14, 1)
    FIELD(POR_DTM_WP1_CONFIG_U_SMXP_4_1, WP_CTRIG_EN, 13, 1)
    FIELD(POR_DTM_WP1_CONFIG_U_SMXP_4_1, WP_CC_EN, 12, 1)
    FIELD(POR_DTM_WP1_CONFIG_U_SMXP_4_1, WP_PKT_TYPE, 9, 3)
    FIELD(POR_DTM_WP1_CONFIG_U_SMXP_4_1, WP_PKT_GEN, 8, 1)
    FIELD(POR_DTM_WP1_CONFIG_U_SMXP_4_1, WP_EXCLUSIVE, 5, 1)
    FIELD(POR_DTM_WP1_CONFIG_U_SMXP_4_1, WP_GRP, 4, 1)
    FIELD(POR_DTM_WP1_CONFIG_U_SMXP_4_1, WP_CHN_SEL, 1, 3)
    FIELD(POR_DTM_WP1_CONFIG_U_SMXP_4_1, WP_DEV_SEL, 0, 1)
REG32(POR_DTM_WP1_VAL_U_SMXP_4_1, 0x210a1c0)
REG32(POR_DTM_WP1_MASK_U_SMXP_4_1, 0x210a1c8)
REG32(POR_DTM_WP2_CONFIG_U_SMXP_4_1, 0x210a1d0)
    FIELD(POR_DTM_WP2_CONFIG_U_SMXP_4_1, RESERVED_15, 15, 49)
    FIELD(POR_DTM_WP2_CONFIG_U_SMXP_4_1, WP_DBGTRIG_EN, 14, 1)
    FIELD(POR_DTM_WP2_CONFIG_U_SMXP_4_1, WP_CTRIG_EN, 13, 1)
    FIELD(POR_DTM_WP2_CONFIG_U_SMXP_4_1, WP_CC_EN, 12, 1)
    FIELD(POR_DTM_WP2_CONFIG_U_SMXP_4_1, WP_PKT_TYPE, 9, 3)
    FIELD(POR_DTM_WP2_CONFIG_U_SMXP_4_1, WP_PKT_GEN, 8, 1)
    FIELD(POR_DTM_WP2_CONFIG_U_SMXP_4_1, WP_COMBINE, 6, 1)
    FIELD(POR_DTM_WP2_CONFIG_U_SMXP_4_1, WP_EXCLUSIVE, 5, 1)
    FIELD(POR_DTM_WP2_CONFIG_U_SMXP_4_1, WP_GRP, 4, 1)
    FIELD(POR_DTM_WP2_CONFIG_U_SMXP_4_1, WP_CHN_SEL, 1, 3)
    FIELD(POR_DTM_WP2_CONFIG_U_SMXP_4_1, WP_DEV_SEL, 0, 1)
REG32(POR_DTM_WP2_VAL_U_SMXP_4_1, 0x210a1d8)
REG32(POR_DTM_WP2_MASK_U_SMXP_4_1, 0x210a1e0)
REG32(POR_DTM_WP3_CONFIG_U_SMXP_4_1, 0x210a1e8)
    FIELD(POR_DTM_WP3_CONFIG_U_SMXP_4_1, RESERVED_15, 15, 49)
    FIELD(POR_DTM_WP3_CONFIG_U_SMXP_4_1, WP_DBGTRIG_EN, 14, 1)
    FIELD(POR_DTM_WP3_CONFIG_U_SMXP_4_1, WP_CTRIG_EN, 13, 1)
    FIELD(POR_DTM_WP3_CONFIG_U_SMXP_4_1, WP_CC_EN, 12, 1)
    FIELD(POR_DTM_WP3_CONFIG_U_SMXP_4_1, WP_PKT_TYPE, 9, 3)
    FIELD(POR_DTM_WP3_CONFIG_U_SMXP_4_1, WP_PKT_GEN, 8, 1)
    FIELD(POR_DTM_WP3_CONFIG_U_SMXP_4_1, WP_EXCLUSIVE, 5, 1)
    FIELD(POR_DTM_WP3_CONFIG_U_SMXP_4_1, WP_GRP, 4, 1)
    FIELD(POR_DTM_WP3_CONFIG_U_SMXP_4_1, WP_CHN_SEL, 1, 3)
    FIELD(POR_DTM_WP3_CONFIG_U_SMXP_4_1, WP_DEV_SEL, 0, 1)
REG32(POR_DTM_WP3_VAL_U_SMXP_4_1, 0x210a1f0)
REG32(POR_DTM_WP3_MASK_U_SMXP_4_1, 0x210a1f8)
REG32(POR_DTM_PMSICR_U_SMXP_4_1, 0x210a200)
    FIELD(POR_DTM_PMSICR_U_SMXP_4_1, RESERVED_32, 32, 32)
    FIELD(POR_DTM_PMSICR_U_SMXP_4_1, COUNT, 0, 32)
REG32(POR_DTM_PMSIRR_U_SMXP_4_1, 0x210a208)
    FIELD(POR_DTM_PMSIRR_U_SMXP_4_1, RESERVED_32, 32, 32)
    FIELD(POR_DTM_PMSIRR_U_SMXP_4_1, INTERVAL, 8, 24)
    FIELD(POR_DTM_PMSIRR_U_SMXP_4_1, RESERVED_0, 0, 8)
REG32(POR_DTM_PMU_CONFIG_U_SMXP_4_1, 0x210a210)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_4_1, RESERVED_62, 62, 2)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_4_1, PMEVCNT3_INPUT_SEL, 56, 6)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_4_1, RESERVED_54, 54, 2)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_4_1, PMEVCNT2_INPUT_SEL, 48, 6)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_4_1, RESERVED_46, 46, 2)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_4_1, PMEVCNT1_INPUT_SEL, 40, 6)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_4_1, RESERVED_38, 38, 2)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_4_1, PMEVCNT0_INPUT_SEL, 32, 6)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_4_1, RESERVED_31, 31, 1)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_4_1, PMEVCNT3_GLOBAL_NUM, 28, 3)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_4_1, RESERVED_27, 27, 1)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_4_1, PMEVCNT2_GLOBAL_NUM, 24, 3)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_4_1, RESERVED_23, 23, 1)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_4_1, PMEVCNT1_GLOBAL_NUM, 20, 3)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_4_1, RESERVED_19, 19, 1)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_4_1, PMEVCNT0_GLOBAL_NUM, 16, 3)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_4_1, RESERVED_9, 9, 7)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_4_1, CNTR_RST, 8, 1)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_4_1, PMEVCNT_PAIRED, 4, 4)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_4_1, PMEVCNTALL_COMBINED, 3, 1)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_4_1, PMEVCNT23_COMBINED, 2, 1)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_4_1, PMEVCNT01_COMBINED, 1, 1)
    FIELD(POR_DTM_PMU_CONFIG_U_SMXP_4_1, PMU_EN, 0, 1)
REG32(POR_DTM_PMEVCNT_U_SMXP_4_1, 0x210a220)
    FIELD(POR_DTM_PMEVCNT_U_SMXP_4_1, PMEVCNT3, 48, 16)
    FIELD(POR_DTM_PMEVCNT_U_SMXP_4_1, PMEVCNT2, 32, 16)
    FIELD(POR_DTM_PMEVCNT_U_SMXP_4_1, PMEVCNT1, 16, 16)
    FIELD(POR_DTM_PMEVCNT_U_SMXP_4_1, PMEVCNT0, 0, 16)
REG32(POR_DTM_PMEVCNTSR_U_SMXP_4_1, 0x210a240)
    FIELD(POR_DTM_PMEVCNTSR_U_SMXP_4_1, PMEVCNTSR3, 48, 16)
    FIELD(POR_DTM_PMEVCNTSR_U_SMXP_4_1, PMEVCNTSR2, 32, 16)
    FIELD(POR_DTM_PMEVCNTSR_U_SMXP_4_1, PMEVCNTSR1, 16, 16)
    FIELD(POR_DTM_PMEVCNTSR_U_SMXP_4_1, PMEVCNTSR0, 0, 16)
REG32(POR_MXP_ERRFR_U_SMXP_4_1, 0x210b000)
    FIELD(POR_MXP_ERRFR_U_SMXP_4_1, RESERVED_15, 15, 49)
    FIELD(POR_MXP_ERRFR_U_SMXP_4_1, CEC, 12, 3)
    FIELD(POR_MXP_ERRFR_U_SMXP_4_1, CFI, 10, 2)
    FIELD(POR_MXP_ERRFR_U_SMXP_4_1, FI, 6, 2)
    FIELD(POR_MXP_ERRFR_U_SMXP_4_1, UI, 4, 2)
    FIELD(POR_MXP_ERRFR_U_SMXP_4_1, DE, 2, 2)
    FIELD(POR_MXP_ERRFR_U_SMXP_4_1, ED, 0, 2)
REG32(POR_MXP_ERRCTLR_U_SMXP_4_1, 0x210b008)
    FIELD(POR_MXP_ERRCTLR_U_SMXP_4_1, RESERVED_9, 9, 55)
    FIELD(POR_MXP_ERRCTLR_U_SMXP_4_1, CFI, 8, 1)
    FIELD(POR_MXP_ERRCTLR_U_SMXP_4_1, FI, 3, 1)
    FIELD(POR_MXP_ERRCTLR_U_SMXP_4_1, UI, 2, 1)
    FIELD(POR_MXP_ERRCTLR_U_SMXP_4_1, DE, 1, 1)
    FIELD(POR_MXP_ERRCTLR_U_SMXP_4_1, ED, 0, 1)
REG32(POR_MXP_ERRSTATUS_U_SMXP_4_1, 0x210b010)
    FIELD(POR_MXP_ERRSTATUS_U_SMXP_4_1, RESERVED_32, 32, 32)
    FIELD(POR_MXP_ERRSTATUS_U_SMXP_4_1, AV, 31, 1)
    FIELD(POR_MXP_ERRSTATUS_U_SMXP_4_1, V, 30, 1)
    FIELD(POR_MXP_ERRSTATUS_U_SMXP_4_1, UE, 29, 1)
    FIELD(POR_MXP_ERRSTATUS_U_SMXP_4_1, RESERVED_28, 28, 1)
    FIELD(POR_MXP_ERRSTATUS_U_SMXP_4_1, OF, 27, 1)
    FIELD(POR_MXP_ERRSTATUS_U_SMXP_4_1, MV, 26, 1)
    FIELD(POR_MXP_ERRSTATUS_U_SMXP_4_1, RESERVED_25, 25, 1)
    FIELD(POR_MXP_ERRSTATUS_U_SMXP_4_1, CE, 24, 1)
    FIELD(POR_MXP_ERRSTATUS_U_SMXP_4_1, DE, 23, 1)
    FIELD(POR_MXP_ERRSTATUS_U_SMXP_4_1, RESERVED_0, 0, 23)
REG32(POR_MXP_ERRMISC_U_SMXP_4_1, 0x210b028)
    FIELD(POR_MXP_ERRMISC_U_SMXP_4_1, RESERVED_59, 59, 5)
    FIELD(POR_MXP_ERRMISC_U_SMXP_4_1, TGTID, 48, 11)
    FIELD(POR_MXP_ERRMISC_U_SMXP_4_1, RESERVED_22, 22, 26)
    FIELD(POR_MXP_ERRMISC_U_SMXP_4_1, OPCODE, 16, 6)
    FIELD(POR_MXP_ERRMISC_U_SMXP_4_1, RESERVED_15, 15, 1)
    FIELD(POR_MXP_ERRMISC_U_SMXP_4_1, SRCID, 4, 11)
    FIELD(POR_MXP_ERRMISC_U_SMXP_4_1, ERRSRC, 0, 3)
REG32(POR_MXP_P0_BYTE_PAR_ERR_INJ_U_SMXP_4_1, 0x210b030)
    FIELD(POR_MXP_P0_BYTE_PAR_ERR_INJ_U_SMXP_4_1, P0_BYTE_PARITY_ERR_INJ, 0, 5)
REG32(POR_MXP_P1_BYTE_PAR_ERR_INJ_U_SMXP_4_1, 0x210b038)
    FIELD(POR_MXP_P1_BYTE_PAR_ERR_INJ_U_SMXP_4_1, P1_BYTE_PARITY_ERR_INJ, 0, 5)
REG32(POR_MXP_ERRFR_NS_U_SMXP_4_1, 0x210b100)
    FIELD(POR_MXP_ERRFR_NS_U_SMXP_4_1, RESERVED_15, 15, 49)
    FIELD(POR_MXP_ERRFR_NS_U_SMXP_4_1, CEC, 12, 3)
    FIELD(POR_MXP_ERRFR_NS_U_SMXP_4_1, CFI, 10, 2)
    FIELD(POR_MXP_ERRFR_NS_U_SMXP_4_1, FI, 6, 2)
    FIELD(POR_MXP_ERRFR_NS_U_SMXP_4_1, UI, 4, 2)
    FIELD(POR_MXP_ERRFR_NS_U_SMXP_4_1, DE, 2, 2)
    FIELD(POR_MXP_ERRFR_NS_U_SMXP_4_1, ED, 0, 2)
REG32(POR_MXP_ERRCTLR_NS_U_SMXP_4_1, 0x210b108)
    FIELD(POR_MXP_ERRCTLR_NS_U_SMXP_4_1, RESERVED_9, 9, 55)
    FIELD(POR_MXP_ERRCTLR_NS_U_SMXP_4_1, CFI, 8, 1)
    FIELD(POR_MXP_ERRCTLR_NS_U_SMXP_4_1, FI, 3, 1)
    FIELD(POR_MXP_ERRCTLR_NS_U_SMXP_4_1, UI, 2, 1)
    FIELD(POR_MXP_ERRCTLR_NS_U_SMXP_4_1, DE, 1, 1)
    FIELD(POR_MXP_ERRCTLR_NS_U_SMXP_4_1, ED, 0, 1)
REG32(POR_MXP_ERRSTATUS_NS_U_SMXP_4_1, 0x210b110)
    FIELD(POR_MXP_ERRSTATUS_NS_U_SMXP_4_1, RESERVED_32, 32, 32)
    FIELD(POR_MXP_ERRSTATUS_NS_U_SMXP_4_1, AV, 31, 1)
    FIELD(POR_MXP_ERRSTATUS_NS_U_SMXP_4_1, V, 30, 1)
    FIELD(POR_MXP_ERRSTATUS_NS_U_SMXP_4_1, UE, 29, 1)
    FIELD(POR_MXP_ERRSTATUS_NS_U_SMXP_4_1, RESERVED_28, 28, 1)
    FIELD(POR_MXP_ERRSTATUS_NS_U_SMXP_4_1, OF, 27, 1)
    FIELD(POR_MXP_ERRSTATUS_NS_U_SMXP_4_1, MV, 26, 1)
    FIELD(POR_MXP_ERRSTATUS_NS_U_SMXP_4_1, RESERVED_25, 25, 1)
    FIELD(POR_MXP_ERRSTATUS_NS_U_SMXP_4_1, CE, 24, 1)
    FIELD(POR_MXP_ERRSTATUS_NS_U_SMXP_4_1, DE, 23, 1)
    FIELD(POR_MXP_ERRSTATUS_NS_U_SMXP_4_1, RESERVED_0, 0, 23)
REG32(POR_MXP_ERRMISC_NS_U_SMXP_4_1, 0x210b128)
    FIELD(POR_MXP_ERRMISC_NS_U_SMXP_4_1, RESERVED_59, 59, 5)
    FIELD(POR_MXP_ERRMISC_NS_U_SMXP_4_1, TGTID, 48, 11)
    FIELD(POR_MXP_ERRMISC_NS_U_SMXP_4_1, RESERVED_22, 22, 26)
    FIELD(POR_MXP_ERRMISC_NS_U_SMXP_4_1, OPCODE, 16, 6)
    FIELD(POR_MXP_ERRMISC_NS_U_SMXP_4_1, RESERVED_15, 15, 1)
    FIELD(POR_MXP_ERRMISC_NS_U_SMXP_4_1, SRCID, 4, 11)
    FIELD(POR_MXP_ERRMISC_NS_U_SMXP_4_1, ERRSRC, 0, 3)
REG32(POR_CXG_HA_NODE_INFO_U_CXRH_NID264, 0x2110000)
    FIELD(POR_CXG_HA_NODE_INFO_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_CXG_HA_NODE_INFO_U_CXRH_NID264, LOGICAL_ID, 32, 16)
    FIELD(POR_CXG_HA_NODE_INFO_U_CXRH_NID264, NODE_ID, 16, 16)
    FIELD(POR_CXG_HA_NODE_INFO_U_CXRH_NID264, NODE_TYPE, 0, 16)
REG32(POR_CXG_HA_ID_U_CXRH_NID264, 0x2110008)
    FIELD(POR_CXG_HA_ID_U_CXRH_NID264, CCIX_HAID, 0, 6)
REG32(POR_CXG_HA_CHILD_INFO_U_CXRH_NID264, 0x2110080)
    FIELD(POR_CXG_HA_CHILD_INFO_U_CXRH_NID264, RESERVED_32, 32, 32)
    FIELD(POR_CXG_HA_CHILD_INFO_U_CXRH_NID264, CHILD_PTR_OFFSET, 16, 16)
    FIELD(POR_CXG_HA_CHILD_INFO_U_CXRH_NID264, CHILD_COUNT, 0, 16)
REG32(POR_CXG_HA_UNIT_INFO_U_CXRH_NID264, 0x2110900)
    FIELD(POR_CXG_HA_UNIT_INFO_U_CXRH_NID264, SMP_MODE_ENABLE, 63, 1)
    FIELD(POR_CXG_HA_UNIT_INFO_U_CXRH_NID264, SNOOP_COMPACK_HAZBUF_DEPTH, 54, 9)
    FIELD(POR_CXG_HA_UNIT_INFO_U_CXRH_NID264, SNOOP_DATABUFFER_DEPTH, 45, 9)
    FIELD(POR_CXG_HA_UNIT_INFO_U_CXRH_NID264, SNOOP_TRACKER_DEPTH, 36, 9)
    FIELD(POR_CXG_HA_UNIT_INFO_U_CXRH_NID264, SNOOP_REQUEST_SINKBUFFER_DEPTH, 27, 9)
    FIELD(POR_CXG_HA_UNIT_INFO_U_CXRH_NID264, WDB_DEPTH, 18, 9)
    FIELD(POR_CXG_HA_UNIT_INFO_U_CXRH_NID264, RDB_DEPTH, 9, 9)
    FIELD(POR_CXG_HA_UNIT_INFO_U_CXRH_NID264, REQUEST_TRACKER_DEPTH, 0, 9)
REG32(POR_CXG_HA_SECURE_REGISTER_GROUPS_OVERRIDE_U_CXRH_NID264, 0x2110980)
    FIELD(POR_CXG_HA_SECURE_REGISTER_GROUPS_OVERRIDE_U_CXRH_NID264, LINKID_CTL, 1, 1)
    FIELD(POR_CXG_HA_SECURE_REGISTER_GROUPS_OVERRIDE_U_CXRH_NID264, LDID_CTL, 0, 1)
REG32(POR_CXG_HA_AUX_CTL_U_CXRH_NID264, 0x2110a08)
    FIELD(POR_CXG_HA_AUX_CTL_U_CXRH_NID264, DISABLE_CG_FLOPEN, 5, 1)
    FIELD(POR_CXG_HA_AUX_CTL_U_CXRH_NID264, DISABLE_SECURE_ACCESS, 4, 1)
    FIELD(POR_CXG_HA_AUX_CTL_U_CXRH_NID264, EARLY_COMPACK_EN, 3, 1)
    FIELD(POR_CXG_HA_AUX_CTL_U_CXRH_NID264, REMOTE_CHIA_RNF_PRESENT, 2, 1)
    FIELD(POR_CXG_HA_AUX_CTL_U_CXRH_NID264, SNOOP_DATARET_DISABLE, 1, 1)
    FIELD(POR_CXG_HA_AUX_CTL_U_CXRH_NID264, CG_DISABLE, 0, 1)
REG32(POR_CXG_HA_RNF_RAID_TO_LDID_REG0_U_CXRH_NID264, 0x2110c00)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG0_U_CXRH_NID264, LDID7_RNF, 63, 1)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG0_U_CXRH_NID264, RESERVED_62, 62, 1)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG0_U_CXRH_NID264, LDID7, 56, 6)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG0_U_CXRH_NID264, LDID6_RNF, 55, 1)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG0_U_CXRH_NID264, RESERVED_54, 54, 1)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG0_U_CXRH_NID264, LDID6, 48, 6)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG0_U_CXRH_NID264, LDID5_RNF, 47, 1)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG0_U_CXRH_NID264, RESERVED_46, 46, 1)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG0_U_CXRH_NID264, LDID5, 40, 6)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG0_U_CXRH_NID264, LDID4_RNF, 39, 1)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG0_U_CXRH_NID264, RESERVED_38, 38, 1)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG0_U_CXRH_NID264, LDID4, 32, 6)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG0_U_CXRH_NID264, LDID3_RNF, 31, 1)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG0_U_CXRH_NID264, RESERVED_30, 30, 1)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG0_U_CXRH_NID264, LDID3, 24, 6)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG0_U_CXRH_NID264, LDID2_RNF, 23, 1)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG0_U_CXRH_NID264, RESERVED_22, 22, 1)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG0_U_CXRH_NID264, LDID2, 16, 6)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG0_U_CXRH_NID264, LDID1_RNF, 15, 1)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG0_U_CXRH_NID264, RESERVED_14, 14, 1)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG0_U_CXRH_NID264, LDID1, 8, 6)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG0_U_CXRH_NID264, LDID0_RNF, 7, 1)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG0_U_CXRH_NID264, LDID0, 0, 6)
REG32(POR_CXG_HA_RNF_RAID_TO_LDID_REG1_U_CXRH_NID264, 0x2110c08)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG1_U_CXRH_NID264, LDID15_RNF, 63, 1)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG1_U_CXRH_NID264, RESERVED_62, 62, 1)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG1_U_CXRH_NID264, LDID15, 56, 6)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG1_U_CXRH_NID264, LDID14_RNF, 55, 1)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG1_U_CXRH_NID264, RESERVED_54, 54, 1)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG1_U_CXRH_NID264, LDID14, 48, 6)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG1_U_CXRH_NID264, LDID13_RNF, 47, 1)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG1_U_CXRH_NID264, RESERVED_46, 46, 1)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG1_U_CXRH_NID264, LDID13, 40, 6)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG1_U_CXRH_NID264, LDID12_RNF, 39, 1)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG1_U_CXRH_NID264, RESERVED_38, 38, 1)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG1_U_CXRH_NID264, LDID12, 32, 6)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG1_U_CXRH_NID264, LDID11_RNF, 31, 1)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG1_U_CXRH_NID264, RESERVED_30, 30, 1)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG1_U_CXRH_NID264, LDID11, 24, 6)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG1_U_CXRH_NID264, LDID10_RNF, 23, 1)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG1_U_CXRH_NID264, RESERVED_22, 22, 1)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG1_U_CXRH_NID264, LDID10, 16, 6)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG1_U_CXRH_NID264, LDID9_RNF, 15, 1)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG1_U_CXRH_NID264, RESERVED_14, 14, 1)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG1_U_CXRH_NID264, LDID9, 8, 6)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG1_U_CXRH_NID264, LDID8_RNF, 7, 1)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG1_U_CXRH_NID264, LDID8, 0, 6)
REG32(POR_CXG_HA_RNF_RAID_TO_LDID_REG2_U_CXRH_NID264, 0x2110c10)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG2_U_CXRH_NID264, LDID23_RNF, 63, 1)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG2_U_CXRH_NID264, RESERVED_62, 62, 1)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG2_U_CXRH_NID264, LDID23, 56, 6)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG2_U_CXRH_NID264, LDID22_RNF, 55, 1)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG2_U_CXRH_NID264, RESERVED_54, 54, 1)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG2_U_CXRH_NID264, LDID22, 48, 6)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG2_U_CXRH_NID264, LDID21_RNF, 47, 1)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG2_U_CXRH_NID264, RESERVED_46, 46, 1)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG2_U_CXRH_NID264, LDID21, 40, 6)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG2_U_CXRH_NID264, LDID20_RNF, 39, 1)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG2_U_CXRH_NID264, RESERVED_38, 38, 1)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG2_U_CXRH_NID264, LDID20, 32, 6)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG2_U_CXRH_NID264, LDID19_RNF, 31, 1)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG2_U_CXRH_NID264, RESERVED_30, 30, 1)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG2_U_CXRH_NID264, LDID19, 24, 6)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG2_U_CXRH_NID264, LDID18_RNF, 23, 1)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG2_U_CXRH_NID264, RESERVED_22, 22, 1)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG2_U_CXRH_NID264, LDID18, 16, 6)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG2_U_CXRH_NID264, LDID17_RNF, 15, 1)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG2_U_CXRH_NID264, RESERVED_14, 14, 1)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG2_U_CXRH_NID264, LDID17, 8, 6)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG2_U_CXRH_NID264, LDID16_RNF, 7, 1)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG2_U_CXRH_NID264, LDID16, 0, 6)
REG32(POR_CXG_HA_RNF_RAID_TO_LDID_REG3_U_CXRH_NID264, 0x2110c18)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG3_U_CXRH_NID264, LDID31_RNF, 63, 1)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG3_U_CXRH_NID264, RESERVED_62, 62, 1)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG3_U_CXRH_NID264, LDID31, 56, 6)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG3_U_CXRH_NID264, LDID30_RNF, 55, 1)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG3_U_CXRH_NID264, RESERVED_54, 54, 1)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG3_U_CXRH_NID264, LDID30, 48, 6)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG3_U_CXRH_NID264, LDID29_RNF, 47, 1)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG3_U_CXRH_NID264, RESERVED_46, 46, 1)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG3_U_CXRH_NID264, LDID29, 40, 6)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG3_U_CXRH_NID264, LDID28_RNF, 39, 1)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG3_U_CXRH_NID264, RESERVED_38, 38, 1)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG3_U_CXRH_NID264, LDID28, 32, 6)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG3_U_CXRH_NID264, LDID27_RNF, 31, 1)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG3_U_CXRH_NID264, RESERVED_30, 30, 1)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG3_U_CXRH_NID264, LDID27, 24, 6)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG3_U_CXRH_NID264, LDID26_RNF, 23, 1)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG3_U_CXRH_NID264, RESERVED_22, 22, 1)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG3_U_CXRH_NID264, LDID26, 16, 6)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG3_U_CXRH_NID264, LDID25_RNF, 15, 1)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG3_U_CXRH_NID264, RESERVED_14, 14, 1)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG3_U_CXRH_NID264, LDID25, 8, 6)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG3_U_CXRH_NID264, LDID24_RNF, 7, 1)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG3_U_CXRH_NID264, LDID24, 0, 6)
REG32(POR_CXG_HA_RNF_RAID_TO_LDID_REG4_U_CXRH_NID264, 0x2110c20)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG4_U_CXRH_NID264, LDID39_RNF, 63, 1)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG4_U_CXRH_NID264, RESERVED_62, 62, 1)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG4_U_CXRH_NID264, LDID39, 56, 6)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG4_U_CXRH_NID264, LDID38_RNF, 55, 1)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG4_U_CXRH_NID264, RESERVED_54, 54, 1)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG4_U_CXRH_NID264, LDID38, 48, 6)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG4_U_CXRH_NID264, LDID37_RNF, 47, 1)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG4_U_CXRH_NID264, RESERVED_46, 46, 1)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG4_U_CXRH_NID264, LDID37, 40, 6)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG4_U_CXRH_NID264, LDID36_RNF, 39, 1)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG4_U_CXRH_NID264, RESERVED_38, 38, 1)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG4_U_CXRH_NID264, LDID36, 32, 6)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG4_U_CXRH_NID264, LDID35_RNF, 31, 1)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG4_U_CXRH_NID264, RESERVED_30, 30, 1)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG4_U_CXRH_NID264, LDID35, 24, 6)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG4_U_CXRH_NID264, LDID34_RNF, 23, 1)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG4_U_CXRH_NID264, RESERVED_22, 22, 1)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG4_U_CXRH_NID264, LDID34, 16, 6)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG4_U_CXRH_NID264, LDID33_RNF, 15, 1)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG4_U_CXRH_NID264, RESERVED_14, 14, 1)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG4_U_CXRH_NID264, LDID33, 8, 6)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG4_U_CXRH_NID264, LDID32_RNF, 7, 1)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG4_U_CXRH_NID264, LDID32, 0, 6)
REG32(POR_CXG_HA_RNF_RAID_TO_LDID_REG5_U_CXRH_NID264, 0x2110c28)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG5_U_CXRH_NID264, LDID47_RNF, 63, 1)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG5_U_CXRH_NID264, RESERVED_62, 62, 1)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG5_U_CXRH_NID264, LDID47, 56, 6)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG5_U_CXRH_NID264, LDID46_RNF, 55, 1)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG5_U_CXRH_NID264, RESERVED_54, 54, 1)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG5_U_CXRH_NID264, LDID46, 48, 6)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG5_U_CXRH_NID264, LDID45_RNF, 47, 1)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG5_U_CXRH_NID264, RESERVED_46, 46, 1)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG5_U_CXRH_NID264, LDID45, 40, 6)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG5_U_CXRH_NID264, LDID44_RNF, 39, 1)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG5_U_CXRH_NID264, RESERVED_38, 38, 1)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG5_U_CXRH_NID264, LDID44, 32, 6)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG5_U_CXRH_NID264, LDID43_RNF, 31, 1)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG5_U_CXRH_NID264, RESERVED_30, 30, 1)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG5_U_CXRH_NID264, LDID43, 24, 6)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG5_U_CXRH_NID264, LDID42_RNF, 23, 1)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG5_U_CXRH_NID264, RESERVED_22, 22, 1)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG5_U_CXRH_NID264, LDID42, 16, 6)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG5_U_CXRH_NID264, LDID41_RNF, 15, 1)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG5_U_CXRH_NID264, RESERVED_14, 14, 1)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG5_U_CXRH_NID264, LDID41, 8, 6)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG5_U_CXRH_NID264, LDID40_RNF, 7, 1)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG5_U_CXRH_NID264, LDID40, 0, 6)
REG32(POR_CXG_HA_RNF_RAID_TO_LDID_REG6_U_CXRH_NID264, 0x2110c30)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG6_U_CXRH_NID264, LDID55_RNF, 63, 1)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG6_U_CXRH_NID264, RESERVED_62, 62, 1)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG6_U_CXRH_NID264, LDID55, 56, 6)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG6_U_CXRH_NID264, LDID54_RNF, 55, 1)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG6_U_CXRH_NID264, RESERVED_54, 54, 1)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG6_U_CXRH_NID264, LDID54, 48, 6)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG6_U_CXRH_NID264, LDID53_RNF, 47, 1)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG6_U_CXRH_NID264, RESERVED_46, 46, 1)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG6_U_CXRH_NID264, LDID53, 40, 6)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG6_U_CXRH_NID264, LDID52_RNF, 39, 1)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG6_U_CXRH_NID264, RESERVED_38, 38, 1)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG6_U_CXRH_NID264, LDID52, 32, 6)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG6_U_CXRH_NID264, LDID51_RNF, 31, 1)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG6_U_CXRH_NID264, RESERVED_30, 30, 1)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG6_U_CXRH_NID264, LDID51, 24, 6)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG6_U_CXRH_NID264, LDID50_RNF, 23, 1)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG6_U_CXRH_NID264, RESERVED_22, 22, 1)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG6_U_CXRH_NID264, LDID50, 16, 6)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG6_U_CXRH_NID264, LDID49_RNF, 15, 1)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG6_U_CXRH_NID264, RESERVED_14, 14, 1)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG6_U_CXRH_NID264, LDID49, 8, 6)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG6_U_CXRH_NID264, LDID48_RNF, 7, 1)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG6_U_CXRH_NID264, LDID48, 0, 6)
REG32(POR_CXG_HA_RNF_RAID_TO_LDID_REG7_U_CXRH_NID264, 0x2110c38)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG7_U_CXRH_NID264, LDID63_RNF, 63, 1)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG7_U_CXRH_NID264, RESERVED_62, 62, 1)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG7_U_CXRH_NID264, LDID63, 56, 6)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG7_U_CXRH_NID264, LDID62_RNF, 55, 1)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG7_U_CXRH_NID264, RESERVED_54, 54, 1)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG7_U_CXRH_NID264, LDID62, 48, 6)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG7_U_CXRH_NID264, LDID61_RNF, 47, 1)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG7_U_CXRH_NID264, RESERVED_46, 46, 1)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG7_U_CXRH_NID264, LDID61, 40, 6)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG7_U_CXRH_NID264, LDID60_RNF, 39, 1)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG7_U_CXRH_NID264, RESERVED_38, 38, 1)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG7_U_CXRH_NID264, LDID60, 32, 6)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG7_U_CXRH_NID264, LDID59_RNF, 31, 1)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG7_U_CXRH_NID264, RESERVED_30, 30, 1)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG7_U_CXRH_NID264, LDID59, 24, 6)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG7_U_CXRH_NID264, LDID58_RNF, 23, 1)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG7_U_CXRH_NID264, RESERVED_22, 22, 1)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG7_U_CXRH_NID264, LDID58, 16, 6)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG7_U_CXRH_NID264, LDID57_RNF, 15, 1)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG7_U_CXRH_NID264, RESERVED_14, 14, 1)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG7_U_CXRH_NID264, LDID57, 8, 6)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG7_U_CXRH_NID264, LDID56_RNF, 7, 1)
    FIELD(POR_CXG_HA_RNF_RAID_TO_LDID_REG7_U_CXRH_NID264, LDID56, 0, 6)
REG32(POR_CXG_HA_AGENTID_TO_LINKID_REG0_U_CXRH_NID264, 0x2110c40)
    FIELD(POR_CXG_HA_AGENTID_TO_LINKID_REG0_U_CXRH_NID264, RESERVED_58, 58, 6)
    FIELD(POR_CXG_HA_AGENTID_TO_LINKID_REG0_U_CXRH_NID264, AGENT7_LINKID, 56, 2)
    FIELD(POR_CXG_HA_AGENTID_TO_LINKID_REG0_U_CXRH_NID264, RESERVED_50, 50, 6)
    FIELD(POR_CXG_HA_AGENTID_TO_LINKID_REG0_U_CXRH_NID264, AGENT6_LINKID, 48, 2)
    FIELD(POR_CXG_HA_AGENTID_TO_LINKID_REG0_U_CXRH_NID264, RESERVED_42, 42, 6)
    FIELD(POR_CXG_HA_AGENTID_TO_LINKID_REG0_U_CXRH_NID264, AGENT5_LINKID, 40, 2)
    FIELD(POR_CXG_HA_AGENTID_TO_LINKID_REG0_U_CXRH_NID264, RESERVED_34, 34, 6)
    FIELD(POR_CXG_HA_AGENTID_TO_LINKID_REG0_U_CXRH_NID264, AGENT4_LINKID, 32, 2)
    FIELD(POR_CXG_HA_AGENTID_TO_LINKID_REG0_U_CXRH_NID264, RESERVED_26, 26, 6)
    FIELD(POR_CXG_HA_AGENTID_TO_LINKID_REG0_U_CXRH_NID264, AGENT3_LINKID, 24, 2)
    FIELD(POR_CXG_HA_AGENTID_TO_LINKID_REG0_U_CXRH_NID264, RESERVED_18, 18, 6)
    FIELD(POR_CXG_HA_AGENTID_TO_LINKID_REG0_U_CXRH_NID264, AGENT2_LINKID, 16, 2)
    FIELD(POR_CXG_HA_AGENTID_TO_LINKID_REG0_U_CXRH_NID264, RESERVED_10, 10, 6)
    FIELD(POR_CXG_HA_AGENTID_TO_LINKID_REG0_U_CXRH_NID264, AGENT1_LINKID, 8, 2)
    FIELD(POR_CXG_HA_AGENTID_TO_LINKID_REG0_U_CXRH_NID264, AGENT0_LINKID, 0, 2)
REG32(POR_CXG_HA_AGENTID_TO_LINKID_REG1_U_CXRH_NID264, 0x2110c48)
    FIELD(POR_CXG_HA_AGENTID_TO_LINKID_REG1_U_CXRH_NID264, RESERVED_58, 58, 6)
    FIELD(POR_CXG_HA_AGENTID_TO_LINKID_REG1_U_CXRH_NID264, AGENT15_LINKID, 56, 2)
    FIELD(POR_CXG_HA_AGENTID_TO_LINKID_REG1_U_CXRH_NID264, RESERVED_50, 50, 6)
    FIELD(POR_CXG_HA_AGENTID_TO_LINKID_REG1_U_CXRH_NID264, AGENT14_LINKID, 48, 2)
    FIELD(POR_CXG_HA_AGENTID_TO_LINKID_REG1_U_CXRH_NID264, RESERVED_42, 42, 6)
    FIELD(POR_CXG_HA_AGENTID_TO_LINKID_REG1_U_CXRH_NID264, AGENT13_LINKID, 40, 2)
    FIELD(POR_CXG_HA_AGENTID_TO_LINKID_REG1_U_CXRH_NID264, RESERVED_34, 34, 6)
    FIELD(POR_CXG_HA_AGENTID_TO_LINKID_REG1_U_CXRH_NID264, AGENT12_LINKID, 32, 2)
    FIELD(POR_CXG_HA_AGENTID_TO_LINKID_REG1_U_CXRH_NID264, RESERVED_26, 26, 6)
    FIELD(POR_CXG_HA_AGENTID_TO_LINKID_REG1_U_CXRH_NID264, AGENT11_LINKID, 24, 2)
    FIELD(POR_CXG_HA_AGENTID_TO_LINKID_REG1_U_CXRH_NID264, RESERVED_18, 18, 6)
    FIELD(POR_CXG_HA_AGENTID_TO_LINKID_REG1_U_CXRH_NID264, AGENT10_LINKID, 16, 2)
    FIELD(POR_CXG_HA_AGENTID_TO_LINKID_REG1_U_CXRH_NID264, RESERVED_10, 10, 6)
    FIELD(POR_CXG_HA_AGENTID_TO_LINKID_REG1_U_CXRH_NID264, AGENT9_LINKID, 8, 2)
    FIELD(POR_CXG_HA_AGENTID_TO_LINKID_REG1_U_CXRH_NID264, AGENT8_LINKID, 0, 2)
REG32(POR_CXG_HA_AGENTID_TO_LINKID_REG2_U_CXRH_NID264, 0x2110c50)
    FIELD(POR_CXG_HA_AGENTID_TO_LINKID_REG2_U_CXRH_NID264, RESERVED_58, 58, 6)
    FIELD(POR_CXG_HA_AGENTID_TO_LINKID_REG2_U_CXRH_NID264, AGENT23_LINKID, 56, 2)
    FIELD(POR_CXG_HA_AGENTID_TO_LINKID_REG2_U_CXRH_NID264, RESERVED_50, 50, 6)
    FIELD(POR_CXG_HA_AGENTID_TO_LINKID_REG2_U_CXRH_NID264, AGENT22_LINKID, 48, 2)
    FIELD(POR_CXG_HA_AGENTID_TO_LINKID_REG2_U_CXRH_NID264, RESERVED_42, 42, 6)
    FIELD(POR_CXG_HA_AGENTID_TO_LINKID_REG2_U_CXRH_NID264, AGENT21_LINKID, 40, 2)
    FIELD(POR_CXG_HA_AGENTID_TO_LINKID_REG2_U_CXRH_NID264, RESERVED_34, 34, 6)
    FIELD(POR_CXG_HA_AGENTID_TO_LINKID_REG2_U_CXRH_NID264, AGENT20_LINKID, 32, 2)
    FIELD(POR_CXG_HA_AGENTID_TO_LINKID_REG2_U_CXRH_NID264, RESERVED_26, 26, 6)
    FIELD(POR_CXG_HA_AGENTID_TO_LINKID_REG2_U_CXRH_NID264, AGENT19_LINKID, 24, 2)
    FIELD(POR_CXG_HA_AGENTID_TO_LINKID_REG2_U_CXRH_NID264, RESERVED_18, 18, 6)
    FIELD(POR_CXG_HA_AGENTID_TO_LINKID_REG2_U_CXRH_NID264, AGENT18_LINKID, 16, 2)
    FIELD(POR_CXG_HA_AGENTID_TO_LINKID_REG2_U_CXRH_NID264, RESERVED_10, 10, 6)
    FIELD(POR_CXG_HA_AGENTID_TO_LINKID_REG2_U_CXRH_NID264, AGENT17_LINKID, 8, 2)
    FIELD(POR_CXG_HA_AGENTID_TO_LINKID_REG2_U_CXRH_NID264, AGENT16_LINKID, 0, 2)
REG32(POR_CXG_HA_AGENTID_TO_LINKID_REG3_U_CXRH_NID264, 0x2110c58)
    FIELD(POR_CXG_HA_AGENTID_TO_LINKID_REG3_U_CXRH_NID264, RESERVED_58, 58, 6)
    FIELD(POR_CXG_HA_AGENTID_TO_LINKID_REG3_U_CXRH_NID264, AGENT31_LINKID, 56, 2)
    FIELD(POR_CXG_HA_AGENTID_TO_LINKID_REG3_U_CXRH_NID264, RESERVED_50, 50, 6)
    FIELD(POR_CXG_HA_AGENTID_TO_LINKID_REG3_U_CXRH_NID264, AGENT30_LINKID, 48, 2)
    FIELD(POR_CXG_HA_AGENTID_TO_LINKID_REG3_U_CXRH_NID264, RESERVED_42, 42, 6)
    FIELD(POR_CXG_HA_AGENTID_TO_LINKID_REG3_U_CXRH_NID264, AGENT29_LINKID, 40, 2)
    FIELD(POR_CXG_HA_AGENTID_TO_LINKID_REG3_U_CXRH_NID264, RESERVED_34, 34, 6)
    FIELD(POR_CXG_HA_AGENTID_TO_LINKID_REG3_U_CXRH_NID264, AGENT28_LINKID, 32, 2)
    FIELD(POR_CXG_HA_AGENTID_TO_LINKID_REG3_U_CXRH_NID264, RESERVED_26, 26, 6)
    FIELD(POR_CXG_HA_AGENTID_TO_LINKID_REG3_U_CXRH_NID264, AGENT27_LINKID, 24, 2)
    FIELD(POR_CXG_HA_AGENTID_TO_LINKID_REG3_U_CXRH_NID264, RESERVED_18, 18, 6)
    FIELD(POR_CXG_HA_AGENTID_TO_LINKID_REG3_U_CXRH_NID264, AGENT26_LINKID, 16, 2)
    FIELD(POR_CXG_HA_AGENTID_TO_LINKID_REG3_U_CXRH_NID264, RESERVED_10, 10, 6)
    FIELD(POR_CXG_HA_AGENTID_TO_LINKID_REG3_U_CXRH_NID264, AGENT25_LINKID, 8, 2)
    FIELD(POR_CXG_HA_AGENTID_TO_LINKID_REG3_U_CXRH_NID264, AGENT24_LINKID, 0, 2)
REG32(POR_CXG_HA_AGENTID_TO_LINKID_REG4_U_CXRH_NID264, 0x2110c60)
    FIELD(POR_CXG_HA_AGENTID_TO_LINKID_REG4_U_CXRH_NID264, RESERVED_58, 58, 6)
    FIELD(POR_CXG_HA_AGENTID_TO_LINKID_REG4_U_CXRH_NID264, AGENT39_LINKID, 56, 2)
    FIELD(POR_CXG_HA_AGENTID_TO_LINKID_REG4_U_CXRH_NID264, RESERVED_50, 50, 6)
    FIELD(POR_CXG_HA_AGENTID_TO_LINKID_REG4_U_CXRH_NID264, AGENT38_LINKID, 48, 2)
    FIELD(POR_CXG_HA_AGENTID_TO_LINKID_REG4_U_CXRH_NID264, RESERVED_42, 42, 6)
    FIELD(POR_CXG_HA_AGENTID_TO_LINKID_REG4_U_CXRH_NID264, AGENT37_LINKID, 40, 2)
    FIELD(POR_CXG_HA_AGENTID_TO_LINKID_REG4_U_CXRH_NID264, RESERVED_34, 34, 6)
    FIELD(POR_CXG_HA_AGENTID_TO_LINKID_REG4_U_CXRH_NID264, AGENT36_LINKID, 32, 2)
    FIELD(POR_CXG_HA_AGENTID_TO_LINKID_REG4_U_CXRH_NID264, RESERVED_26, 26, 6)
    FIELD(POR_CXG_HA_AGENTID_TO_LINKID_REG4_U_CXRH_NID264, AGENT35_LINKID, 24, 2)
    FIELD(POR_CXG_HA_AGENTID_TO_LINKID_REG4_U_CXRH_NID264, RESERVED_18, 18, 6)
    FIELD(POR_CXG_HA_AGENTID_TO_LINKID_REG4_U_CXRH_NID264, AGENT34_LINKID, 16, 2)
    FIELD(POR_CXG_HA_AGENTID_TO_LINKID_REG4_U_CXRH_NID264, RESERVED_10, 10, 6)
    FIELD(POR_CXG_HA_AGENTID_TO_LINKID_REG4_U_CXRH_NID264, AGENT33_LINKID, 8, 2)
    FIELD(POR_CXG_HA_AGENTID_TO_LINKID_REG4_U_CXRH_NID264, AGENT32_LINKID, 0, 2)
REG32(POR_CXG_HA_AGENTID_TO_LINKID_REG5_U_CXRH_NID264, 0x2110c68)
    FIELD(POR_CXG_HA_AGENTID_TO_LINKID_REG5_U_CXRH_NID264, RESERVED_58, 58, 6)
    FIELD(POR_CXG_HA_AGENTID_TO_LINKID_REG5_U_CXRH_NID264, AGENT47_LINKID, 56, 2)
    FIELD(POR_CXG_HA_AGENTID_TO_LINKID_REG5_U_CXRH_NID264, RESERVED_50, 50, 6)
    FIELD(POR_CXG_HA_AGENTID_TO_LINKID_REG5_U_CXRH_NID264, AGENT46_LINKID, 48, 2)
    FIELD(POR_CXG_HA_AGENTID_TO_LINKID_REG5_U_CXRH_NID264, RESERVED_42, 42, 6)
    FIELD(POR_CXG_HA_AGENTID_TO_LINKID_REG5_U_CXRH_NID264, AGENT45_LINKID, 40, 2)
    FIELD(POR_CXG_HA_AGENTID_TO_LINKID_REG5_U_CXRH_NID264, RESERVED_34, 34, 6)
    FIELD(POR_CXG_HA_AGENTID_TO_LINKID_REG5_U_CXRH_NID264, AGENT44_LINKID, 32, 2)
    FIELD(POR_CXG_HA_AGENTID_TO_LINKID_REG5_U_CXRH_NID264, RESERVED_26, 26, 6)
    FIELD(POR_CXG_HA_AGENTID_TO_LINKID_REG5_U_CXRH_NID264, AGENT43_LINKID, 24, 2)
    FIELD(POR_CXG_HA_AGENTID_TO_LINKID_REG5_U_CXRH_NID264, RESERVED_18, 18, 6)
    FIELD(POR_CXG_HA_AGENTID_TO_LINKID_REG5_U_CXRH_NID264, AGENT42_LINKID, 16, 2)
    FIELD(POR_CXG_HA_AGENTID_TO_LINKID_REG5_U_CXRH_NID264, RESERVED_10, 10, 6)
    FIELD(POR_CXG_HA_AGENTID_TO_LINKID_REG5_U_CXRH_NID264, AGENT41_LINKID, 8, 2)
    FIELD(POR_CXG_HA_AGENTID_TO_LINKID_REG5_U_CXRH_NID264, AGENT40_LINKID, 0, 2)
REG32(POR_CXG_HA_AGENTID_TO_LINKID_REG6_U_CXRH_NID264, 0x2110c70)
    FIELD(POR_CXG_HA_AGENTID_TO_LINKID_REG6_U_CXRH_NID264, RESERVED_58, 58, 6)
    FIELD(POR_CXG_HA_AGENTID_TO_LINKID_REG6_U_CXRH_NID264, AGENT55_LINKID, 56, 2)
    FIELD(POR_CXG_HA_AGENTID_TO_LINKID_REG6_U_CXRH_NID264, RESERVED_50, 50, 6)
    FIELD(POR_CXG_HA_AGENTID_TO_LINKID_REG6_U_CXRH_NID264, AGENT54_LINKID, 48, 2)
    FIELD(POR_CXG_HA_AGENTID_TO_LINKID_REG6_U_CXRH_NID264, RESERVED_42, 42, 6)
    FIELD(POR_CXG_HA_AGENTID_TO_LINKID_REG6_U_CXRH_NID264, AGENT53_LINKID, 40, 2)
    FIELD(POR_CXG_HA_AGENTID_TO_LINKID_REG6_U_CXRH_NID264, RESERVED_34, 34, 6)
    FIELD(POR_CXG_HA_AGENTID_TO_LINKID_REG6_U_CXRH_NID264, AGENT52_LINKID, 32, 2)
    FIELD(POR_CXG_HA_AGENTID_TO_LINKID_REG6_U_CXRH_NID264, RESERVED_26, 26, 6)
    FIELD(POR_CXG_HA_AGENTID_TO_LINKID_REG6_U_CXRH_NID264, AGENT51_LINKID, 24, 2)
    FIELD(POR_CXG_HA_AGENTID_TO_LINKID_REG6_U_CXRH_NID264, RESERVED_18, 18, 6)
    FIELD(POR_CXG_HA_AGENTID_TO_LINKID_REG6_U_CXRH_NID264, AGENT50_LINKID, 16, 2)
    FIELD(POR_CXG_HA_AGENTID_TO_LINKID_REG6_U_CXRH_NID264, RESERVED_10, 10, 6)
    FIELD(POR_CXG_HA_AGENTID_TO_LINKID_REG6_U_CXRH_NID264, AGENT49_LINKID, 8, 2)
    FIELD(POR_CXG_HA_AGENTID_TO_LINKID_REG6_U_CXRH_NID264, AGENT48_LINKID, 0, 2)
REG32(POR_CXG_HA_AGENTID_TO_LINKID_REG7_U_CXRH_NID264, 0x2110c78)
    FIELD(POR_CXG_HA_AGENTID_TO_LINKID_REG7_U_CXRH_NID264, RESERVED_58, 58, 6)
    FIELD(POR_CXG_HA_AGENTID_TO_LINKID_REG7_U_CXRH_NID264, AGENT63_LINKID, 56, 2)
    FIELD(POR_CXG_HA_AGENTID_TO_LINKID_REG7_U_CXRH_NID264, RESERVED_50, 50, 6)
    FIELD(POR_CXG_HA_AGENTID_TO_LINKID_REG7_U_CXRH_NID264, AGENT62_LINKID, 48, 2)
    FIELD(POR_CXG_HA_AGENTID_TO_LINKID_REG7_U_CXRH_NID264, RESERVED_42, 42, 6)
    FIELD(POR_CXG_HA_AGENTID_TO_LINKID_REG7_U_CXRH_NID264, AGENT61_LINKID, 40, 2)
    FIELD(POR_CXG_HA_AGENTID_TO_LINKID_REG7_U_CXRH_NID264, RESERVED_34, 34, 6)
    FIELD(POR_CXG_HA_AGENTID_TO_LINKID_REG7_U_CXRH_NID264, AGENT60_LINKID, 32, 2)
    FIELD(POR_CXG_HA_AGENTID_TO_LINKID_REG7_U_CXRH_NID264, RESERVED_26, 26, 6)
    FIELD(POR_CXG_HA_AGENTID_TO_LINKID_REG7_U_CXRH_NID264, AGENT59_LINKID, 24, 2)
    FIELD(POR_CXG_HA_AGENTID_TO_LINKID_REG7_U_CXRH_NID264, RESERVED_18, 18, 6)
    FIELD(POR_CXG_HA_AGENTID_TO_LINKID_REG7_U_CXRH_NID264, AGENT58_LINKID, 16, 2)
    FIELD(POR_CXG_HA_AGENTID_TO_LINKID_REG7_U_CXRH_NID264, RESERVED_10, 10, 6)
    FIELD(POR_CXG_HA_AGENTID_TO_LINKID_REG7_U_CXRH_NID264, AGENT57_LINKID, 8, 2)
    FIELD(POR_CXG_HA_AGENTID_TO_LINKID_REG7_U_CXRH_NID264, AGENT56_LINKID, 0, 2)
REG32(POR_CXG_HA_AGENTID_TO_LINKID_VAL_U_CXRH_NID264, 0x2110d00)
REG32(POR_CXG_HA_RNF_RAID_TO_LDID_VAL_U_CXRH_NID264, 0x2110d08)
REG32(POR_CXG_HA_CXPRTCL_LINK0_CTL_U_CXRH_NID264, 0x2111000)
    FIELD(POR_CXG_HA_CXPRTCL_LINK0_CTL_U_CXRH_NID264, RESERVED_12, 12, 52)
    FIELD(POR_CXG_HA_CXPRTCL_LINK0_CTL_U_CXRH_NID264, LNK0_NUM_DATCRDS, 8, 4)
    FIELD(POR_CXG_HA_CXPRTCL_LINK0_CTL_U_CXRH_NID264, LNK0_NUM_REQCRDS, 4, 4)
    FIELD(POR_CXG_HA_CXPRTCL_LINK0_CTL_U_CXRH_NID264, LNK0_SNOOPDOMAIN_REQ, 3, 1)
    FIELD(POR_CXG_HA_CXPRTCL_LINK0_CTL_U_CXRH_NID264, LNK0_LINK_UP, 2, 1)
    FIELD(POR_CXG_HA_CXPRTCL_LINK0_CTL_U_CXRH_NID264, LNK0_LINK_REQ, 1, 1)
    FIELD(POR_CXG_HA_CXPRTCL_LINK0_CTL_U_CXRH_NID264, LNK0_LINK_EN, 0, 1)
REG32(POR_CXG_HA_CXPRTCL_LINK0_STATUS_U_CXRH_NID264, 0x2111008)
    FIELD(POR_CXG_HA_CXPRTCL_LINK0_STATUS_U_CXRH_NID264, LNK0_SNOOPDOMAIN_ACK, 2, 1)
    FIELD(POR_CXG_HA_CXPRTCL_LINK0_STATUS_U_CXRH_NID264, LNK0_LINK_DOWN, 1, 1)
    FIELD(POR_CXG_HA_CXPRTCL_LINK0_STATUS_U_CXRH_NID264, LNK0_LINK_ACK, 0, 1)
REG32(POR_CXG_HA_CXPRTCL_LINK1_CTL_U_CXRH_NID264, 0x2111010)
    FIELD(POR_CXG_HA_CXPRTCL_LINK1_CTL_U_CXRH_NID264, RESERVED_12, 12, 52)
    FIELD(POR_CXG_HA_CXPRTCL_LINK1_CTL_U_CXRH_NID264, LNK1_NUM_DATCRDS, 8, 4)
    FIELD(POR_CXG_HA_CXPRTCL_LINK1_CTL_U_CXRH_NID264, LNK1_NUM_REQCRDS, 4, 4)
    FIELD(POR_CXG_HA_CXPRTCL_LINK1_CTL_U_CXRH_NID264, LNK1_SNOOPDOMAIN_REQ, 3, 1)
    FIELD(POR_CXG_HA_CXPRTCL_LINK1_CTL_U_CXRH_NID264, LNK1_LINK_UP, 2, 1)
    FIELD(POR_CXG_HA_CXPRTCL_LINK1_CTL_U_CXRH_NID264, LNK1_LINK_REQ, 1, 1)
    FIELD(POR_CXG_HA_CXPRTCL_LINK1_CTL_U_CXRH_NID264, LNK1_LINK_EN, 0, 1)
REG32(POR_CXG_HA_CXPRTCL_LINK1_STATUS_U_CXRH_NID264, 0x2111018)
    FIELD(POR_CXG_HA_CXPRTCL_LINK1_STATUS_U_CXRH_NID264, LNK1_SNOOPDOMAIN_ACK, 2, 1)
    FIELD(POR_CXG_HA_CXPRTCL_LINK1_STATUS_U_CXRH_NID264, LNK1_LINK_DOWN, 1, 1)
    FIELD(POR_CXG_HA_CXPRTCL_LINK1_STATUS_U_CXRH_NID264, LNK1_LINK_ACK, 0, 1)
REG32(POR_CXG_HA_CXPRTCL_LINK2_CTL_U_CXRH_NID264, 0x2111020)
    FIELD(POR_CXG_HA_CXPRTCL_LINK2_CTL_U_CXRH_NID264, RESERVED_12, 12, 52)
    FIELD(POR_CXG_HA_CXPRTCL_LINK2_CTL_U_CXRH_NID264, LNK2_NUM_DATCRDS, 8, 4)
    FIELD(POR_CXG_HA_CXPRTCL_LINK2_CTL_U_CXRH_NID264, LNK2_NUM_REQCRDS, 4, 4)
    FIELD(POR_CXG_HA_CXPRTCL_LINK2_CTL_U_CXRH_NID264, LNK2_SNOOPDOMAIN_REQ, 3, 1)
    FIELD(POR_CXG_HA_CXPRTCL_LINK2_CTL_U_CXRH_NID264, LNK2_LINK_UP, 2, 1)
    FIELD(POR_CXG_HA_CXPRTCL_LINK2_CTL_U_CXRH_NID264, LNK2_LINK_REQ, 1, 1)
    FIELD(POR_CXG_HA_CXPRTCL_LINK2_CTL_U_CXRH_NID264, LNK2_LINK_EN, 0, 1)
REG32(POR_CXG_HA_CXPRTCL_LINK2_STATUS_U_CXRH_NID264, 0x2111028)
    FIELD(POR_CXG_HA_CXPRTCL_LINK2_STATUS_U_CXRH_NID264, LNK2_SNOOPDOMAIN_ACK, 2, 1)
    FIELD(POR_CXG_HA_CXPRTCL_LINK2_STATUS_U_CXRH_NID264, LNK2_LINK_DOWN, 1, 1)
    FIELD(POR_CXG_HA_CXPRTCL_LINK2_STATUS_U_CXRH_NID264, LNK2_LINK_ACK, 0, 1)
REG32(POR_CXG_HA_PMU_EVENT_SEL_U_CXRH_NID264, 0x2112000)
    FIELD(POR_CXG_HA_PMU_EVENT_SEL_U_CXRH_NID264, RESERVED_36, 36, 28)
    FIELD(POR_CXG_HA_PMU_EVENT_SEL_U_CXRH_NID264, PMU_OCCUP1_ID, 32, 4)
    FIELD(POR_CXG_HA_PMU_EVENT_SEL_U_CXRH_NID264, RESERVED_30, 30, 2)
    FIELD(POR_CXG_HA_PMU_EVENT_SEL_U_CXRH_NID264, PMU_EVENT3_ID, 24, 6)
    FIELD(POR_CXG_HA_PMU_EVENT_SEL_U_CXRH_NID264, RESERVED_22, 22, 2)
    FIELD(POR_CXG_HA_PMU_EVENT_SEL_U_CXRH_NID264, PMU_EVENT2_ID, 16, 6)
    FIELD(POR_CXG_HA_PMU_EVENT_SEL_U_CXRH_NID264, RESERVED_14, 14, 2)
    FIELD(POR_CXG_HA_PMU_EVENT_SEL_U_CXRH_NID264, PMU_EVENT1_ID, 8, 6)
    FIELD(POR_CXG_HA_PMU_EVENT_SEL_U_CXRH_NID264, PMU_EVENT0_ID, 0, 6)
REG32(POR_CXG_HA_ERRFR_U_CXRH_NID264, 0x2113000)
    FIELD(POR_CXG_HA_ERRFR_U_CXRH_NID264, RESERVED_15, 15, 49)
    FIELD(POR_CXG_HA_ERRFR_U_CXRH_NID264, CEC, 12, 3)
    FIELD(POR_CXG_HA_ERRFR_U_CXRH_NID264, CFI, 10, 2)
    FIELD(POR_CXG_HA_ERRFR_U_CXRH_NID264, FI, 6, 2)
    FIELD(POR_CXG_HA_ERRFR_U_CXRH_NID264, UI, 4, 2)
    FIELD(POR_CXG_HA_ERRFR_U_CXRH_NID264, DE, 2, 2)
    FIELD(POR_CXG_HA_ERRFR_U_CXRH_NID264, ED, 0, 2)
REG32(POR_CXG_HA_ERRCTLR_U_CXRH_NID264, 0x2113008)
    FIELD(POR_CXG_HA_ERRCTLR_U_CXRH_NID264, RESERVED_9, 9, 55)
    FIELD(POR_CXG_HA_ERRCTLR_U_CXRH_NID264, CFI, 8, 1)
    FIELD(POR_CXG_HA_ERRCTLR_U_CXRH_NID264, FI, 3, 1)
    FIELD(POR_CXG_HA_ERRCTLR_U_CXRH_NID264, UI, 2, 1)
    FIELD(POR_CXG_HA_ERRCTLR_U_CXRH_NID264, DE, 1, 1)
    FIELD(POR_CXG_HA_ERRCTLR_U_CXRH_NID264, ED, 0, 1)
REG32(POR_CXG_HA_ERRSTATUS_U_CXRH_NID264, 0x2113010)
    FIELD(POR_CXG_HA_ERRSTATUS_U_CXRH_NID264, RESERVED_32, 32, 32)
    FIELD(POR_CXG_HA_ERRSTATUS_U_CXRH_NID264, AV, 31, 1)
    FIELD(POR_CXG_HA_ERRSTATUS_U_CXRH_NID264, V, 30, 1)
    FIELD(POR_CXG_HA_ERRSTATUS_U_CXRH_NID264, UE, 29, 1)
    FIELD(POR_CXG_HA_ERRSTATUS_U_CXRH_NID264, RESERVED_28, 28, 1)
    FIELD(POR_CXG_HA_ERRSTATUS_U_CXRH_NID264, OF, 27, 1)
    FIELD(POR_CXG_HA_ERRSTATUS_U_CXRH_NID264, MV, 26, 1)
    FIELD(POR_CXG_HA_ERRSTATUS_U_CXRH_NID264, RESERVED_25, 25, 1)
    FIELD(POR_CXG_HA_ERRSTATUS_U_CXRH_NID264, CE, 24, 1)
    FIELD(POR_CXG_HA_ERRSTATUS_U_CXRH_NID264, DE, 23, 1)
    FIELD(POR_CXG_HA_ERRSTATUS_U_CXRH_NID264, RESERVED_0, 0, 23)
REG32(POR_CXG_HA_ERRADDR_U_CXRH_NID264, 0x2113018)
    FIELD(POR_CXG_HA_ERRADDR_U_CXRH_NID264, NS, 63, 1)
    FIELD(POR_CXG_HA_ERRADDR_U_CXRH_NID264, RESERVED_48, 48, 15)
    FIELD(POR_CXG_HA_ERRADDR_U_CXRH_NID264, ADDR, 0, 48)
REG32(POR_CXG_HA_ERRMISC_U_CXRH_NID264, 0x2113020)
    FIELD(POR_CXG_HA_ERRMISC_U_CXRH_NID264, RESERVED_56, 56, 8)
    FIELD(POR_CXG_HA_ERRMISC_U_CXRH_NID264, ERRSET, 48, 8)
    FIELD(POR_CXG_HA_ERRMISC_U_CXRH_NID264, RESERVED_10, 10, 38)
    FIELD(POR_CXG_HA_ERRMISC_U_CXRH_NID264, SRCID, 4, 6)
    FIELD(POR_CXG_HA_ERRMISC_U_CXRH_NID264, ERRSRC, 0, 2)
REG32(POR_CXG_HA_ERRFR_NS_U_CXRH_NID264, 0x2113100)
    FIELD(POR_CXG_HA_ERRFR_NS_U_CXRH_NID264, RESERVED_15, 15, 49)
    FIELD(POR_CXG_HA_ERRFR_NS_U_CXRH_NID264, CEC, 12, 3)
    FIELD(POR_CXG_HA_ERRFR_NS_U_CXRH_NID264, CFI, 10, 2)
    FIELD(POR_CXG_HA_ERRFR_NS_U_CXRH_NID264, FI, 6, 2)
    FIELD(POR_CXG_HA_ERRFR_NS_U_CXRH_NID264, UI, 4, 2)
    FIELD(POR_CXG_HA_ERRFR_NS_U_CXRH_NID264, DE, 2, 2)
    FIELD(POR_CXG_HA_ERRFR_NS_U_CXRH_NID264, ED, 0, 2)
REG32(POR_CXG_HA_ERRCTLR_NS_U_CXRH_NID264, 0x2113108)
    FIELD(POR_CXG_HA_ERRCTLR_NS_U_CXRH_NID264, RESERVED_9, 9, 55)
    FIELD(POR_CXG_HA_ERRCTLR_NS_U_CXRH_NID264, CFI, 8, 1)
    FIELD(POR_CXG_HA_ERRCTLR_NS_U_CXRH_NID264, FI, 3, 1)
    FIELD(POR_CXG_HA_ERRCTLR_NS_U_CXRH_NID264, UI, 2, 1)
    FIELD(POR_CXG_HA_ERRCTLR_NS_U_CXRH_NID264, DE, 1, 1)
    FIELD(POR_CXG_HA_ERRCTLR_NS_U_CXRH_NID264, ED, 0, 1)
REG32(POR_CXG_HA_ERRSTATUS_NS_U_CXRH_NID264, 0x2113110)
    FIELD(POR_CXG_HA_ERRSTATUS_NS_U_CXRH_NID264, RESERVED_32, 32, 32)
    FIELD(POR_CXG_HA_ERRSTATUS_NS_U_CXRH_NID264, AV, 31, 1)
    FIELD(POR_CXG_HA_ERRSTATUS_NS_U_CXRH_NID264, V, 30, 1)
    FIELD(POR_CXG_HA_ERRSTATUS_NS_U_CXRH_NID264, UE, 29, 1)
    FIELD(POR_CXG_HA_ERRSTATUS_NS_U_CXRH_NID264, RESERVED_28, 28, 1)
    FIELD(POR_CXG_HA_ERRSTATUS_NS_U_CXRH_NID264, OF, 27, 1)
    FIELD(POR_CXG_HA_ERRSTATUS_NS_U_CXRH_NID264, MV, 26, 1)
    FIELD(POR_CXG_HA_ERRSTATUS_NS_U_CXRH_NID264, RESERVED_25, 25, 1)
    FIELD(POR_CXG_HA_ERRSTATUS_NS_U_CXRH_NID264, CE, 24, 1)
    FIELD(POR_CXG_HA_ERRSTATUS_NS_U_CXRH_NID264, DE, 23, 1)
    FIELD(POR_CXG_HA_ERRSTATUS_NS_U_CXRH_NID264, RESERVED_0, 0, 23)
REG32(POR_CXG_HA_ERRADDR_NS_U_CXRH_NID264, 0x2113118)
    FIELD(POR_CXG_HA_ERRADDR_NS_U_CXRH_NID264, NS, 63, 1)
    FIELD(POR_CXG_HA_ERRADDR_NS_U_CXRH_NID264, RESERVED_48, 48, 15)
    FIELD(POR_CXG_HA_ERRADDR_NS_U_CXRH_NID264, ADDR, 0, 48)
REG32(POR_CXG_HA_ERRMISC_NS_U_CXRH_NID264, 0x2113120)
    FIELD(POR_CXG_HA_ERRMISC_NS_U_CXRH_NID264, RESERVED_56, 56, 8)
    FIELD(POR_CXG_HA_ERRMISC_NS_U_CXRH_NID264, ERRSET, 48, 8)
    FIELD(POR_CXG_HA_ERRMISC_NS_U_CXRH_NID264, RESERVED_10, 10, 38)
    FIELD(POR_CXG_HA_ERRMISC_NS_U_CXRH_NID264, SRCID, 4, 6)
    FIELD(POR_CXG_HA_ERRMISC_NS_U_CXRH_NID264, ERRSRC, 0, 2)
REG32(POR_CXLA_NODE_INFO_U_CXRH_NID264, 0x2120000)
    FIELD(POR_CXLA_NODE_INFO_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_CXLA_NODE_INFO_U_CXRH_NID264, LOGICAL_ID, 32, 16)
    FIELD(POR_CXLA_NODE_INFO_U_CXRH_NID264, NODE_ID, 16, 16)
    FIELD(POR_CXLA_NODE_INFO_U_CXRH_NID264, NODE_TYPE, 0, 16)
REG32(POR_CXLA_CHILD_INFO_U_CXRH_NID264, 0x2120080)
    FIELD(POR_CXLA_CHILD_INFO_U_CXRH_NID264, RESERVED_32, 32, 32)
    FIELD(POR_CXLA_CHILD_INFO_U_CXRH_NID264, CHILD_PTR_OFFSET, 16, 16)
    FIELD(POR_CXLA_CHILD_INFO_U_CXRH_NID264, CHILD_COUNT, 0, 16)
REG32(POR_CXLA_UNIT_INFO_U_CXRH_NID264, 0x2120900)
    FIELD(POR_CXLA_UNIT_INFO_U_CXRH_NID264, RESERVED_23, 23, 41)
    FIELD(POR_CXLA_UNIT_INFO_U_CXRH_NID264, CXS_SAFE_XFACE_DISABLE, 22, 1)
    FIELD(POR_CXLA_UNIT_INFO_U_CXRH_NID264, DB_FIFO_DEPTH, 16, 6)
    FIELD(POR_CXLA_UNIT_INFO_U_CXRH_NID264, RESERVED_15, 15, 1)
    FIELD(POR_CXLA_UNIT_INFO_U_CXRH_NID264, TLP_COUNT_RX, 12, 3)
    FIELD(POR_CXLA_UNIT_INFO_U_CXRH_NID264, RESERVED_11, 11, 1)
    FIELD(POR_CXLA_UNIT_INFO_U_CXRH_NID264, TLP_COUNT_TX, 8, 3)
    FIELD(POR_CXLA_UNIT_INFO_U_CXRH_NID264, DB_LCRD_COUNT, 1, 4)
    FIELD(POR_CXLA_UNIT_INFO_U_CXRH_NID264, DB_PRESENT, 0, 1)
REG32(POR_CXLA_SECURE_REGISTER_GROUPS_OVERRIDE_U_CXRH_NID264, 0x2120980)
    FIELD(POR_CXLA_SECURE_REGISTER_GROUPS_OVERRIDE_U_CXRH_NID264, LINKID_CTL, 2, 1)
    FIELD(POR_CXLA_SECURE_REGISTER_GROUPS_OVERRIDE_U_CXRH_NID264, CFG_CTL, 0, 1)
REG32(POR_CXLA_AUX_CTL_U_CXRH_NID264, 0x2120a08)
    FIELD(POR_CXLA_AUX_CTL_U_CXRH_NID264, RESERVED_47, 47, 17)
    FIELD(POR_CXLA_AUX_CTL_U_CXRH_NID264, CRDGNT_CYCLE_COUNT_TH, 44, 3)
    FIELD(POR_CXLA_AUX_CTL_U_CXRH_NID264, RESERVED_43, 43, 1)
    FIELD(POR_CXLA_AUX_CTL_U_CXRH_NID264, CRDGNT_CRD_COUNT_TH, 40, 3)
    FIELD(POR_CXLA_AUX_CTL_U_CXRH_NID264, RESERVED_39, 39, 1)
    FIELD(POR_CXLA_AUX_CTL_U_CXRH_NID264, MISC_TIMEOUT_TH, 36, 3)
    FIELD(POR_CXLA_AUX_CTL_U_CXRH_NID264, RESERVED_35, 35, 1)
    FIELD(POR_CXLA_AUX_CTL_U_CXRH_NID264, SNP_TIMEOUT_TH, 32, 3)
    FIELD(POR_CXLA_AUX_CTL_U_CXRH_NID264, RESERVED_31, 31, 1)
    FIELD(POR_CXLA_AUX_CTL_U_CXRH_NID264, REQDAT_TIMEOUT_TH, 28, 3)
    FIELD(POR_CXLA_AUX_CTL_U_CXRH_NID264, RESERVED_27, 27, 1)
    FIELD(POR_CXLA_AUX_CTL_U_CXRH_NID264, SNPRSP_TIMEOUT_TH, 24, 3)
    FIELD(POR_CXLA_AUX_CTL_U_CXRH_NID264, RESERVED_23, 23, 1)
    FIELD(POR_CXLA_AUX_CTL_U_CXRH_NID264, SNPDAT_TIMEOUT_TH, 20, 3)
    FIELD(POR_CXLA_AUX_CTL_U_CXRH_NID264, RESERVED_19, 19, 1)
    FIELD(POR_CXLA_AUX_CTL_U_CXRH_NID264, REQRSP_TIMEOUT_TH, 16, 3)
    FIELD(POR_CXLA_AUX_CTL_U_CXRH_NID264, RESERVED_15, 15, 1)
    FIELD(POR_CXLA_AUX_CTL_U_CXRH_NID264, RSPDAT_TIMEOUT_TH, 12, 3)
    FIELD(POR_CXLA_AUX_CTL_U_CXRH_NID264, RESERVED_11, 11, 1)
    FIELD(POR_CXLA_AUX_CTL_U_CXRH_NID264, IDLE_TIMEOUT_TH, 8, 3)
    FIELD(POR_CXLA_AUX_CTL_U_CXRH_NID264, TLP_TIMEOUT_EN, 7, 1)
    FIELD(POR_CXLA_AUX_CTL_U_CXRH_NID264, CG_DISABLE, 0, 1)
REG32(POR_CXLA_CCIX_PROP_CAPABILITIES_U_CXRH_NID264, 0x2120c00)
    FIELD(POR_CXLA_CCIX_PROP_CAPABILITIES_U_CXRH_NID264, RESERVED_11, 11, 53)
    FIELD(POR_CXLA_CCIX_PROP_CAPABILITIES_U_CXRH_NID264, NOMESSAGEPACK, 10, 1)
    FIELD(POR_CXLA_CCIX_PROP_CAPABILITIES_U_CXRH_NID264, MAXPACKETSIZE, 7, 3)
    FIELD(POR_CXLA_CCIX_PROP_CAPABILITIES_U_CXRH_NID264, PKTHEADER, 6, 1)
    FIELD(POR_CXLA_CCIX_PROP_CAPABILITIES_U_CXRH_NID264, ADDRWIDTH, 3, 3)
    FIELD(POR_CXLA_CCIX_PROP_CAPABILITIES_U_CXRH_NID264, CACHELINESIZE, 2, 1)
    FIELD(POR_CXLA_CCIX_PROP_CAPABILITIES_U_CXRH_NID264, PARTIALCACHESTATES, 1, 1)
    FIELD(POR_CXLA_CCIX_PROP_CAPABILITIES_U_CXRH_NID264, NOCOMPACK, 0, 1)
REG32(POR_CXLA_CCIX_PROP_CONFIGURED_U_CXRH_NID264, 0x2120c08)
    FIELD(POR_CXLA_CCIX_PROP_CONFIGURED_U_CXRH_NID264, RESERVED_11, 11, 53)
    FIELD(POR_CXLA_CCIX_PROP_CONFIGURED_U_CXRH_NID264, NOMESSAGEPACK, 10, 1)
    FIELD(POR_CXLA_CCIX_PROP_CONFIGURED_U_CXRH_NID264, MAXPACKETSIZE, 7, 3)
    FIELD(POR_CXLA_CCIX_PROP_CONFIGURED_U_CXRH_NID264, PKTHEADER, 6, 1)
    FIELD(POR_CXLA_CCIX_PROP_CONFIGURED_U_CXRH_NID264, ADDRWIDTH, 3, 3)
    FIELD(POR_CXLA_CCIX_PROP_CONFIGURED_U_CXRH_NID264, CACHELINESIZE, 2, 1)
    FIELD(POR_CXLA_CCIX_PROP_CONFIGURED_U_CXRH_NID264, PARTIALCACHESTATES, 1, 1)
    FIELD(POR_CXLA_CCIX_PROP_CONFIGURED_U_CXRH_NID264, NOCOMPACK, 0, 1)
REG32(POR_CXLA_TX_CXS_ATTR_CAPABILITIES_U_CXRH_NID264, 0x2120c10)
    FIELD(POR_CXLA_TX_CXS_ATTR_CAPABILITIES_U_CXRH_NID264, RESERVED_10, 10, 54)
    FIELD(POR_CXLA_TX_CXS_ATTR_CAPABILITIES_U_CXRH_NID264, TXCXSCONTROLREPLICATION, 8, 2)
    FIELD(POR_CXLA_TX_CXS_ATTR_CAPABILITIES_U_CXRH_NID264, TXCXSDATACHECK, 6, 2)
    FIELD(POR_CXLA_TX_CXS_ATTR_CAPABILITIES_U_CXRH_NID264, TXCXSERRORFULLPKT, 5, 1)
    FIELD(POR_CXLA_TX_CXS_ATTR_CAPABILITIES_U_CXRH_NID264, TXCXSCONTINUOUSDATA, 4, 1)
    FIELD(POR_CXLA_TX_CXS_ATTR_CAPABILITIES_U_CXRH_NID264, TXCXSMAXPKTPERFLIT, 2, 2)
    FIELD(POR_CXLA_TX_CXS_ATTR_CAPABILITIES_U_CXRH_NID264, TXCXSDATAFLITWIDTH, 0, 2)
REG32(POR_CXLA_RX_CXS_ATTR_CAPABILITIES_U_CXRH_NID264, 0x2120c18)
    FIELD(POR_CXLA_RX_CXS_ATTR_CAPABILITIES_U_CXRH_NID264, RESERVED_10, 10, 54)
    FIELD(POR_CXLA_RX_CXS_ATTR_CAPABILITIES_U_CXRH_NID264, RXCXSCONTROLREPLICATION, 8, 2)
    FIELD(POR_CXLA_RX_CXS_ATTR_CAPABILITIES_U_CXRH_NID264, RXCXSDATACHECK, 6, 2)
    FIELD(POR_CXLA_RX_CXS_ATTR_CAPABILITIES_U_CXRH_NID264, RXCXSERRORFULLPKT, 5, 1)
    FIELD(POR_CXLA_RX_CXS_ATTR_CAPABILITIES_U_CXRH_NID264, RXCXSCONTINUOUSDATA, 4, 1)
    FIELD(POR_CXLA_RX_CXS_ATTR_CAPABILITIES_U_CXRH_NID264, RXCXSMAXPKTPERFLIT, 2, 2)
    FIELD(POR_CXLA_RX_CXS_ATTR_CAPABILITIES_U_CXRH_NID264, RXCXSDATAFLITWIDTH, 0, 2)
REG32(POR_CXLA_AGENTID_TO_LINKID_REG0_U_CXRH_NID264, 0x2120c30)
    FIELD(POR_CXLA_AGENTID_TO_LINKID_REG0_U_CXRH_NID264, RESERVED_58, 58, 6)
    FIELD(POR_CXLA_AGENTID_TO_LINKID_REG0_U_CXRH_NID264, AGENT7_LINKID, 56, 2)
    FIELD(POR_CXLA_AGENTID_TO_LINKID_REG0_U_CXRH_NID264, RESERVED_50, 50, 6)
    FIELD(POR_CXLA_AGENTID_TO_LINKID_REG0_U_CXRH_NID264, AGENT6_LINKID, 48, 2)
    FIELD(POR_CXLA_AGENTID_TO_LINKID_REG0_U_CXRH_NID264, RESERVED_42, 42, 6)
    FIELD(POR_CXLA_AGENTID_TO_LINKID_REG0_U_CXRH_NID264, AGENT5_LINKID, 40, 2)
    FIELD(POR_CXLA_AGENTID_TO_LINKID_REG0_U_CXRH_NID264, RESERVED_34, 34, 6)
    FIELD(POR_CXLA_AGENTID_TO_LINKID_REG0_U_CXRH_NID264, AGENT4_LINKID, 32, 2)
    FIELD(POR_CXLA_AGENTID_TO_LINKID_REG0_U_CXRH_NID264, RESERVED_26, 26, 6)
    FIELD(POR_CXLA_AGENTID_TO_LINKID_REG0_U_CXRH_NID264, AGENT3_LINKID, 24, 2)
    FIELD(POR_CXLA_AGENTID_TO_LINKID_REG0_U_CXRH_NID264, RESERVED_18, 18, 6)
    FIELD(POR_CXLA_AGENTID_TO_LINKID_REG0_U_CXRH_NID264, AGENT2_LINKID, 16, 2)
    FIELD(POR_CXLA_AGENTID_TO_LINKID_REG0_U_CXRH_NID264, RESERVED_10, 10, 6)
    FIELD(POR_CXLA_AGENTID_TO_LINKID_REG0_U_CXRH_NID264, AGENT1_LINKID, 8, 2)
    FIELD(POR_CXLA_AGENTID_TO_LINKID_REG0_U_CXRH_NID264, AGENT0_LINKID, 0, 2)
REG32(POR_CXLA_AGENTID_TO_LINKID_REG1_U_CXRH_NID264, 0x2120c38)
    FIELD(POR_CXLA_AGENTID_TO_LINKID_REG1_U_CXRH_NID264, RESERVED_58, 58, 6)
    FIELD(POR_CXLA_AGENTID_TO_LINKID_REG1_U_CXRH_NID264, AGENT15_LINKID, 56, 2)
    FIELD(POR_CXLA_AGENTID_TO_LINKID_REG1_U_CXRH_NID264, RESERVED_50, 50, 6)
    FIELD(POR_CXLA_AGENTID_TO_LINKID_REG1_U_CXRH_NID264, AGENT14_LINKID, 48, 2)
    FIELD(POR_CXLA_AGENTID_TO_LINKID_REG1_U_CXRH_NID264, RESERVED_42, 42, 6)
    FIELD(POR_CXLA_AGENTID_TO_LINKID_REG1_U_CXRH_NID264, AGENT13_LINKID, 40, 2)
    FIELD(POR_CXLA_AGENTID_TO_LINKID_REG1_U_CXRH_NID264, RESERVED_34, 34, 6)
    FIELD(POR_CXLA_AGENTID_TO_LINKID_REG1_U_CXRH_NID264, AGENT12_LINKID, 32, 2)
    FIELD(POR_CXLA_AGENTID_TO_LINKID_REG1_U_CXRH_NID264, RESERVED_26, 26, 6)
    FIELD(POR_CXLA_AGENTID_TO_LINKID_REG1_U_CXRH_NID264, AGENT11_LINKID, 24, 2)
    FIELD(POR_CXLA_AGENTID_TO_LINKID_REG1_U_CXRH_NID264, RESERVED_18, 18, 6)
    FIELD(POR_CXLA_AGENTID_TO_LINKID_REG1_U_CXRH_NID264, AGENT10_LINKID, 16, 2)
    FIELD(POR_CXLA_AGENTID_TO_LINKID_REG1_U_CXRH_NID264, RESERVED_10, 10, 6)
    FIELD(POR_CXLA_AGENTID_TO_LINKID_REG1_U_CXRH_NID264, AGENT9_LINKID, 8, 2)
    FIELD(POR_CXLA_AGENTID_TO_LINKID_REG1_U_CXRH_NID264, AGENT8_LINKID, 0, 2)
REG32(POR_CXLA_AGENTID_TO_LINKID_REG2_U_CXRH_NID264, 0x2120c40)
    FIELD(POR_CXLA_AGENTID_TO_LINKID_REG2_U_CXRH_NID264, RESERVED_58, 58, 6)
    FIELD(POR_CXLA_AGENTID_TO_LINKID_REG2_U_CXRH_NID264, AGENT23_LINKID, 56, 2)
    FIELD(POR_CXLA_AGENTID_TO_LINKID_REG2_U_CXRH_NID264, RESERVED_50, 50, 6)
    FIELD(POR_CXLA_AGENTID_TO_LINKID_REG2_U_CXRH_NID264, AGENT22_LINKID, 48, 2)
    FIELD(POR_CXLA_AGENTID_TO_LINKID_REG2_U_CXRH_NID264, RESERVED_42, 42, 6)
    FIELD(POR_CXLA_AGENTID_TO_LINKID_REG2_U_CXRH_NID264, AGENT21_LINKID, 40, 2)
    FIELD(POR_CXLA_AGENTID_TO_LINKID_REG2_U_CXRH_NID264, RESERVED_34, 34, 6)
    FIELD(POR_CXLA_AGENTID_TO_LINKID_REG2_U_CXRH_NID264, AGENT20_LINKID, 32, 2)
    FIELD(POR_CXLA_AGENTID_TO_LINKID_REG2_U_CXRH_NID264, RESERVED_26, 26, 6)
    FIELD(POR_CXLA_AGENTID_TO_LINKID_REG2_U_CXRH_NID264, AGENT19_LINKID, 24, 2)
    FIELD(POR_CXLA_AGENTID_TO_LINKID_REG2_U_CXRH_NID264, RESERVED_18, 18, 6)
    FIELD(POR_CXLA_AGENTID_TO_LINKID_REG2_U_CXRH_NID264, AGENT18_LINKID, 16, 2)
    FIELD(POR_CXLA_AGENTID_TO_LINKID_REG2_U_CXRH_NID264, RESERVED_10, 10, 6)
    FIELD(POR_CXLA_AGENTID_TO_LINKID_REG2_U_CXRH_NID264, AGENT17_LINKID, 8, 2)
    FIELD(POR_CXLA_AGENTID_TO_LINKID_REG2_U_CXRH_NID264, AGENT16_LINKID, 0, 2)
REG32(POR_CXLA_AGENTID_TO_LINKID_REG3_U_CXRH_NID264, 0x2120c48)
    FIELD(POR_CXLA_AGENTID_TO_LINKID_REG3_U_CXRH_NID264, RESERVED_58, 58, 6)
    FIELD(POR_CXLA_AGENTID_TO_LINKID_REG3_U_CXRH_NID264, AGENT31_LINKID, 56, 2)
    FIELD(POR_CXLA_AGENTID_TO_LINKID_REG3_U_CXRH_NID264, RESERVED_50, 50, 6)
    FIELD(POR_CXLA_AGENTID_TO_LINKID_REG3_U_CXRH_NID264, AGENT30_LINKID, 48, 2)
    FIELD(POR_CXLA_AGENTID_TO_LINKID_REG3_U_CXRH_NID264, RESERVED_42, 42, 6)
    FIELD(POR_CXLA_AGENTID_TO_LINKID_REG3_U_CXRH_NID264, AGENT29_LINKID, 40, 2)
    FIELD(POR_CXLA_AGENTID_TO_LINKID_REG3_U_CXRH_NID264, RESERVED_34, 34, 6)
    FIELD(POR_CXLA_AGENTID_TO_LINKID_REG3_U_CXRH_NID264, AGENT28_LINKID, 32, 2)
    FIELD(POR_CXLA_AGENTID_TO_LINKID_REG3_U_CXRH_NID264, RESERVED_26, 26, 6)
    FIELD(POR_CXLA_AGENTID_TO_LINKID_REG3_U_CXRH_NID264, AGENT27_LINKID, 24, 2)
    FIELD(POR_CXLA_AGENTID_TO_LINKID_REG3_U_CXRH_NID264, RESERVED_18, 18, 6)
    FIELD(POR_CXLA_AGENTID_TO_LINKID_REG3_U_CXRH_NID264, AGENT26_LINKID, 16, 2)
    FIELD(POR_CXLA_AGENTID_TO_LINKID_REG3_U_CXRH_NID264, RESERVED_10, 10, 6)
    FIELD(POR_CXLA_AGENTID_TO_LINKID_REG3_U_CXRH_NID264, AGENT25_LINKID, 8, 2)
    FIELD(POR_CXLA_AGENTID_TO_LINKID_REG3_U_CXRH_NID264, AGENT24_LINKID, 0, 2)
REG32(POR_CXLA_AGENTID_TO_LINKID_REG4_U_CXRH_NID264, 0x2120c50)
    FIELD(POR_CXLA_AGENTID_TO_LINKID_REG4_U_CXRH_NID264, RESERVED_58, 58, 6)
    FIELD(POR_CXLA_AGENTID_TO_LINKID_REG4_U_CXRH_NID264, AGENT39_LINKID, 56, 2)
    FIELD(POR_CXLA_AGENTID_TO_LINKID_REG4_U_CXRH_NID264, RESERVED_50, 50, 6)
    FIELD(POR_CXLA_AGENTID_TO_LINKID_REG4_U_CXRH_NID264, AGENT38_LINKID, 48, 2)
    FIELD(POR_CXLA_AGENTID_TO_LINKID_REG4_U_CXRH_NID264, RESERVED_42, 42, 6)
    FIELD(POR_CXLA_AGENTID_TO_LINKID_REG4_U_CXRH_NID264, AGENT37_LINKID, 40, 2)
    FIELD(POR_CXLA_AGENTID_TO_LINKID_REG4_U_CXRH_NID264, RESERVED_34, 34, 6)
    FIELD(POR_CXLA_AGENTID_TO_LINKID_REG4_U_CXRH_NID264, AGENT36_LINKID, 32, 2)
    FIELD(POR_CXLA_AGENTID_TO_LINKID_REG4_U_CXRH_NID264, RESERVED_26, 26, 6)
    FIELD(POR_CXLA_AGENTID_TO_LINKID_REG4_U_CXRH_NID264, AGENT35_LINKID, 24, 2)
    FIELD(POR_CXLA_AGENTID_TO_LINKID_REG4_U_CXRH_NID264, RESERVED_18, 18, 6)
    FIELD(POR_CXLA_AGENTID_TO_LINKID_REG4_U_CXRH_NID264, AGENT34_LINKID, 16, 2)
    FIELD(POR_CXLA_AGENTID_TO_LINKID_REG4_U_CXRH_NID264, RESERVED_10, 10, 6)
    FIELD(POR_CXLA_AGENTID_TO_LINKID_REG4_U_CXRH_NID264, AGENT33_LINKID, 8, 2)
    FIELD(POR_CXLA_AGENTID_TO_LINKID_REG4_U_CXRH_NID264, AGENT32_LINKID, 0, 2)
REG32(POR_CXLA_AGENTID_TO_LINKID_REG5_U_CXRH_NID264, 0x2120c58)
    FIELD(POR_CXLA_AGENTID_TO_LINKID_REG5_U_CXRH_NID264, RESERVED_58, 58, 6)
    FIELD(POR_CXLA_AGENTID_TO_LINKID_REG5_U_CXRH_NID264, AGENT47_LINKID, 56, 2)
    FIELD(POR_CXLA_AGENTID_TO_LINKID_REG5_U_CXRH_NID264, RESERVED_50, 50, 6)
    FIELD(POR_CXLA_AGENTID_TO_LINKID_REG5_U_CXRH_NID264, AGENT46_LINKID, 48, 2)
    FIELD(POR_CXLA_AGENTID_TO_LINKID_REG5_U_CXRH_NID264, RESERVED_42, 42, 6)
    FIELD(POR_CXLA_AGENTID_TO_LINKID_REG5_U_CXRH_NID264, AGENT45_LINKID, 40, 2)
    FIELD(POR_CXLA_AGENTID_TO_LINKID_REG5_U_CXRH_NID264, RESERVED_34, 34, 6)
    FIELD(POR_CXLA_AGENTID_TO_LINKID_REG5_U_CXRH_NID264, AGENT44_LINKID, 32, 2)
    FIELD(POR_CXLA_AGENTID_TO_LINKID_REG5_U_CXRH_NID264, RESERVED_26, 26, 6)
    FIELD(POR_CXLA_AGENTID_TO_LINKID_REG5_U_CXRH_NID264, AGENT43_LINKID, 24, 2)
    FIELD(POR_CXLA_AGENTID_TO_LINKID_REG5_U_CXRH_NID264, RESERVED_18, 18, 6)
    FIELD(POR_CXLA_AGENTID_TO_LINKID_REG5_U_CXRH_NID264, AGENT42_LINKID, 16, 2)
    FIELD(POR_CXLA_AGENTID_TO_LINKID_REG5_U_CXRH_NID264, RESERVED_10, 10, 6)
    FIELD(POR_CXLA_AGENTID_TO_LINKID_REG5_U_CXRH_NID264, AGENT41_LINKID, 8, 2)
    FIELD(POR_CXLA_AGENTID_TO_LINKID_REG5_U_CXRH_NID264, AGENT40_LINKID, 0, 2)
REG32(POR_CXLA_AGENTID_TO_LINKID_REG6_U_CXRH_NID264, 0x2120c60)
    FIELD(POR_CXLA_AGENTID_TO_LINKID_REG6_U_CXRH_NID264, RESERVED_58, 58, 6)
    FIELD(POR_CXLA_AGENTID_TO_LINKID_REG6_U_CXRH_NID264, AGENT55_LINKID, 56, 2)
    FIELD(POR_CXLA_AGENTID_TO_LINKID_REG6_U_CXRH_NID264, RESERVED_50, 50, 6)
    FIELD(POR_CXLA_AGENTID_TO_LINKID_REG6_U_CXRH_NID264, AGENT54_LINKID, 48, 2)
    FIELD(POR_CXLA_AGENTID_TO_LINKID_REG6_U_CXRH_NID264, RESERVED_42, 42, 6)
    FIELD(POR_CXLA_AGENTID_TO_LINKID_REG6_U_CXRH_NID264, AGENT53_LINKID, 40, 2)
    FIELD(POR_CXLA_AGENTID_TO_LINKID_REG6_U_CXRH_NID264, RESERVED_34, 34, 6)
    FIELD(POR_CXLA_AGENTID_TO_LINKID_REG6_U_CXRH_NID264, AGENT52_LINKID, 32, 2)
    FIELD(POR_CXLA_AGENTID_TO_LINKID_REG6_U_CXRH_NID264, RESERVED_26, 26, 6)
    FIELD(POR_CXLA_AGENTID_TO_LINKID_REG6_U_CXRH_NID264, AGENT51_LINKID, 24, 2)
    FIELD(POR_CXLA_AGENTID_TO_LINKID_REG6_U_CXRH_NID264, RESERVED_18, 18, 6)
    FIELD(POR_CXLA_AGENTID_TO_LINKID_REG6_U_CXRH_NID264, AGENT50_LINKID, 16, 2)
    FIELD(POR_CXLA_AGENTID_TO_LINKID_REG6_U_CXRH_NID264, RESERVED_10, 10, 6)
    FIELD(POR_CXLA_AGENTID_TO_LINKID_REG6_U_CXRH_NID264, AGENT49_LINKID, 8, 2)
    FIELD(POR_CXLA_AGENTID_TO_LINKID_REG6_U_CXRH_NID264, AGENT48_LINKID, 0, 2)
REG32(POR_CXLA_AGENTID_TO_LINKID_REG7_U_CXRH_NID264, 0x2120c68)
    FIELD(POR_CXLA_AGENTID_TO_LINKID_REG7_U_CXRH_NID264, RESERVED_58, 58, 6)
    FIELD(POR_CXLA_AGENTID_TO_LINKID_REG7_U_CXRH_NID264, AGENT63_LINKID, 56, 2)
    FIELD(POR_CXLA_AGENTID_TO_LINKID_REG7_U_CXRH_NID264, RESERVED_50, 50, 6)
    FIELD(POR_CXLA_AGENTID_TO_LINKID_REG7_U_CXRH_NID264, AGENT62_LINKID, 48, 2)
    FIELD(POR_CXLA_AGENTID_TO_LINKID_REG7_U_CXRH_NID264, RESERVED_42, 42, 6)
    FIELD(POR_CXLA_AGENTID_TO_LINKID_REG7_U_CXRH_NID264, AGENT61_LINKID, 40, 2)
    FIELD(POR_CXLA_AGENTID_TO_LINKID_REG7_U_CXRH_NID264, RESERVED_34, 34, 6)
    FIELD(POR_CXLA_AGENTID_TO_LINKID_REG7_U_CXRH_NID264, AGENT60_LINKID, 32, 2)
    FIELD(POR_CXLA_AGENTID_TO_LINKID_REG7_U_CXRH_NID264, RESERVED_26, 26, 6)
    FIELD(POR_CXLA_AGENTID_TO_LINKID_REG7_U_CXRH_NID264, AGENT59_LINKID, 24, 2)
    FIELD(POR_CXLA_AGENTID_TO_LINKID_REG7_U_CXRH_NID264, RESERVED_18, 18, 6)
    FIELD(POR_CXLA_AGENTID_TO_LINKID_REG7_U_CXRH_NID264, AGENT58_LINKID, 16, 2)
    FIELD(POR_CXLA_AGENTID_TO_LINKID_REG7_U_CXRH_NID264, RESERVED_10, 10, 6)
    FIELD(POR_CXLA_AGENTID_TO_LINKID_REG7_U_CXRH_NID264, AGENT57_LINKID, 8, 2)
    FIELD(POR_CXLA_AGENTID_TO_LINKID_REG7_U_CXRH_NID264, AGENT56_LINKID, 0, 2)
REG32(POR_CXLA_AGENTID_TO_LINKID_VAL_U_CXRH_NID264, 0x2120c70)
REG32(POR_CXLA_LINKID_TO_PCIE_BUS_NUM_U_CXRH_NID264, 0x2120c78)
    FIELD(POR_CXLA_LINKID_TO_PCIE_BUS_NUM_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_CXLA_LINKID_TO_PCIE_BUS_NUM_U_CXRH_NID264, LINK2_PCIE_DEV_NUM, 43, 5)
    FIELD(POR_CXLA_LINKID_TO_PCIE_BUS_NUM_U_CXRH_NID264, LINK2_PCIE_FUNC_NUM, 40, 3)
    FIELD(POR_CXLA_LINKID_TO_PCIE_BUS_NUM_U_CXRH_NID264, LINK2_PCIE_BUS_NUM, 32, 8)
    FIELD(POR_CXLA_LINKID_TO_PCIE_BUS_NUM_U_CXRH_NID264, LINK1_PCIE_DEV_NUM, 27, 5)
    FIELD(POR_CXLA_LINKID_TO_PCIE_BUS_NUM_U_CXRH_NID264, LINK1_PCIE_FUNC_NUM, 24, 3)
    FIELD(POR_CXLA_LINKID_TO_PCIE_BUS_NUM_U_CXRH_NID264, LINK1_PCIE_BUS_NUM, 16, 8)
    FIELD(POR_CXLA_LINKID_TO_PCIE_BUS_NUM_U_CXRH_NID264, LINK0_PCIE_DEV_NUM, 11, 5)
    FIELD(POR_CXLA_LINKID_TO_PCIE_BUS_NUM_U_CXRH_NID264, LINK0_PCIE_FUNC_NUM, 8, 3)
    FIELD(POR_CXLA_LINKID_TO_PCIE_BUS_NUM_U_CXRH_NID264, LINK0_PCIE_BUS_NUM, 0, 8)
REG32(POR_CXLA_TLP_HDR_FIELDS_U_CXRH_NID264, 0x2120c80)
    FIELD(POR_CXLA_TLP_HDR_FIELDS_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_CXLA_TLP_HDR_FIELDS_U_CXRH_NID264, VENDORID, 32, 16)
    FIELD(POR_CXLA_TLP_HDR_FIELDS_U_CXRH_NID264, MESSAGECODE, 24, 8)
    FIELD(POR_CXLA_TLP_HDR_FIELDS_U_CXRH_NID264, RESERVED_19, 19, 5)
    FIELD(POR_CXLA_TLP_HDR_FIELDS_U_CXRH_NID264, TD, 18, 1)
    FIELD(POR_CXLA_TLP_HDR_FIELDS_U_CXRH_NID264, EP, 17, 1)
    FIELD(POR_CXLA_TLP_HDR_FIELDS_U_CXRH_NID264, AT, 15, 2)
    FIELD(POR_CXLA_TLP_HDR_FIELDS_U_CXRH_NID264, TC, 12, 3)
    FIELD(POR_CXLA_TLP_HDR_FIELDS_U_CXRH_NID264, ATTR, 8, 4)
    FIELD(POR_CXLA_TLP_HDR_FIELDS_U_CXRH_NID264, FMT, 5, 3)
    FIELD(POR_CXLA_TLP_HDR_FIELDS_U_CXRH_NID264, PKT_TYPE, 0, 5)
REG32(POR_CXLA_PERMSG_PYLD_0_63_U_CXRH_NID264, 0x2120d00)
REG32(POR_CXLA_PERMSG_PYLD_64_127_U_CXRH_NID264, 0x2120d08)
REG32(POR_CXLA_PERMSG_PYLD_128_191_U_CXRH_NID264, 0x2120d10)
REG32(POR_CXLA_PERMSG_PYLD_192_255_U_CXRH_NID264, 0x2120d18)
REG32(POR_CXLA_PERMSG_CTL_U_CXRH_NID264, 0x2120d20)
    FIELD(POR_CXLA_PERMSG_CTL_U_CXRH_NID264, RESERVED_14, 14, 50)
    FIELD(POR_CXLA_PERMSG_CTL_U_CXRH_NID264, PER_MSG_SRCID, 8, 6)
    FIELD(POR_CXLA_PERMSG_CTL_U_CXRH_NID264, PER_MSG_SRCID_OVRD, 1, 1)
    FIELD(POR_CXLA_PERMSG_CTL_U_CXRH_NID264, PER_MSG_VLD_SET, 0, 1)
REG32(POR_CXLA_ERR_AGENT_ID_U_CXRH_NID264, 0x2120d28)
    FIELD(POR_CXLA_ERR_AGENT_ID_U_CXRH_NID264, CCIX_ERR_AGENT_ID, 0, 6)
REG32(POR_CXLA_PMU_EVENT_SEL_U_CXRH_NID264, 0x2122000)
    FIELD(POR_CXLA_PMU_EVENT_SEL_U_CXRH_NID264, RESERVED_29, 29, 35)
    FIELD(POR_CXLA_PMU_EVENT_SEL_U_CXRH_NID264, PMU_EVENT3_ID, 24, 5)
    FIELD(POR_CXLA_PMU_EVENT_SEL_U_CXRH_NID264, RESERVED_21, 21, 3)
    FIELD(POR_CXLA_PMU_EVENT_SEL_U_CXRH_NID264, PMU_EVENT2_ID, 16, 5)
    FIELD(POR_CXLA_PMU_EVENT_SEL_U_CXRH_NID264, RESERVED_13, 13, 3)
    FIELD(POR_CXLA_PMU_EVENT_SEL_U_CXRH_NID264, PMU_EVENT1_ID, 8, 5)
    FIELD(POR_CXLA_PMU_EVENT_SEL_U_CXRH_NID264, PMU_EVENT0_ID, 0, 5)
REG32(POR_CXLA_PMU_CONFIG_U_CXRH_NID264, 0x2122210)
    FIELD(POR_CXLA_PMU_CONFIG_U_CXRH_NID264, RESERVED_31, 31, 33)
    FIELD(POR_CXLA_PMU_CONFIG_U_CXRH_NID264, PMEVCNT3_GLOBAL_NUM, 28, 3)
    FIELD(POR_CXLA_PMU_CONFIG_U_CXRH_NID264, RESERVED_27, 27, 1)
    FIELD(POR_CXLA_PMU_CONFIG_U_CXRH_NID264, PMEVCNT2_GLOBAL_NUM, 24, 3)
    FIELD(POR_CXLA_PMU_CONFIG_U_CXRH_NID264, RESERVED_23, 23, 1)
    FIELD(POR_CXLA_PMU_CONFIG_U_CXRH_NID264, PMEVCNT1_GLOBAL_NUM, 20, 3)
    FIELD(POR_CXLA_PMU_CONFIG_U_CXRH_NID264, RESERVED_19, 19, 1)
    FIELD(POR_CXLA_PMU_CONFIG_U_CXRH_NID264, PMEVCNT0_GLOBAL_NUM, 16, 3)
    FIELD(POR_CXLA_PMU_CONFIG_U_CXRH_NID264, RESERVED_9, 9, 7)
    FIELD(POR_CXLA_PMU_CONFIG_U_CXRH_NID264, CNTR_RST, 8, 1)
    FIELD(POR_CXLA_PMU_CONFIG_U_CXRH_NID264, PMEVCNT_PAIRED, 4, 4)
    FIELD(POR_CXLA_PMU_CONFIG_U_CXRH_NID264, PMEVCNTALL_COMBINED, 3, 1)
    FIELD(POR_CXLA_PMU_CONFIG_U_CXRH_NID264, PMEVCNT23_COMBINED, 2, 1)
    FIELD(POR_CXLA_PMU_CONFIG_U_CXRH_NID264, PMEVCNT01_COMBINED, 1, 1)
    FIELD(POR_CXLA_PMU_CONFIG_U_CXRH_NID264, PMU_EN, 0, 1)
REG32(POR_CXLA_PMEVCNT_U_CXRH_NID264, 0x2122220)
    FIELD(POR_CXLA_PMEVCNT_U_CXRH_NID264, PMEVCNT3, 48, 16)
    FIELD(POR_CXLA_PMEVCNT_U_CXRH_NID264, PMEVCNT2, 32, 16)
    FIELD(POR_CXLA_PMEVCNT_U_CXRH_NID264, PMEVCNT1, 16, 16)
    FIELD(POR_CXLA_PMEVCNT_U_CXRH_NID264, PMEVCNT0, 0, 16)
REG32(POR_CXLA_PMEVCNTSR_U_CXRH_NID264, 0x2122240)
    FIELD(POR_CXLA_PMEVCNTSR_U_CXRH_NID264, PMEVCNTSR3, 48, 16)
    FIELD(POR_CXLA_PMEVCNTSR_U_CXRH_NID264, PMEVCNTSR2, 32, 16)
    FIELD(POR_CXLA_PMEVCNTSR_U_CXRH_NID264, PMEVCNTSR1, 16, 16)
    FIELD(POR_CXLA_PMEVCNTSR_U_CXRH_NID264, PMEVCNTSR0, 0, 16)
REG32(POR_FDC_NODE_INFO_U_SMXP_4_1, 0x212c000)
    FIELD(POR_FDC_NODE_INFO_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_FDC_NODE_INFO_U_SMXP_4_1, LOGICAL_ID, 32, 16)
    FIELD(POR_FDC_NODE_INFO_U_SMXP_4_1, NODE_ID, 16, 16)
    FIELD(POR_FDC_NODE_INFO_U_SMXP_4_1, NODE_TYPE, 0, 16)
REG32(POR_FDC_CHILD_INFO_U_SMXP_4_1, 0x212c080)
    FIELD(POR_FDC_CHILD_INFO_U_SMXP_4_1, RESERVED_32, 32, 32)
    FIELD(POR_FDC_CHILD_INFO_U_SMXP_4_1, CHILD_PTR_OFFSET, 16, 16)
    FIELD(POR_FDC_CHILD_INFO_U_SMXP_4_1, CHILD_COUNT, 0, 16)
REG32(POR_ERRFR_MXP_U_SMXP_4_1, 0x212f000)
    FIELD(POR_ERRFR_MXP_U_SMXP_4_1, FI, 6, 2)
    FIELD(POR_ERRFR_MXP_U_SMXP_4_1, UI, 4, 2)
    FIELD(POR_ERRFR_MXP_U_SMXP_4_1, ED, 0, 2)
REG32(POR_ERRCTLR_MXP_U_SMXP_4_1, 0x212f008)
    FIELD(POR_ERRCTLR_MXP_U_SMXP_4_1, RESERVED_32, 32, 32)
    FIELD(POR_ERRCTLR_MXP_U_SMXP_4_1, ERC, 14, 18)
    FIELD(POR_ERRCTLR_MXP_U_SMXP_4_1, FI, 3, 1)
    FIELD(POR_ERRCTLR_MXP_U_SMXP_4_1, UI, 2, 1)
    FIELD(POR_ERRCTLR_MXP_U_SMXP_4_1, ED, 0, 1)
REG32(POR_ERRSTATUS_MXP_U_SMXP_4_1, 0x212f010)
    FIELD(POR_ERRSTATUS_MXP_U_SMXP_4_1, RESERVED_31, 31, 33)
    FIELD(POR_ERRSTATUS_MXP_U_SMXP_4_1, V, 30, 1)
    FIELD(POR_ERRSTATUS_MXP_U_SMXP_4_1, UE, 29, 1)
    FIELD(POR_ERRSTATUS_MXP_U_SMXP_4_1, RESERVED_28, 28, 1)
    FIELD(POR_ERRSTATUS_MXP_U_SMXP_4_1, OF, 27, 1)
    FIELD(POR_ERRSTATUS_MXP_U_SMXP_4_1, RESERVED_24, 24, 3)
    FIELD(POR_ERRSTATUS_MXP_U_SMXP_4_1, DE, 23, 1)
    FIELD(POR_ERRSTATUS_MXP_U_SMXP_4_1, RESERVED_16, 16, 7)
    FIELD(POR_ERRSTATUS_MXP_U_SMXP_4_1, V_ERR_TYPE, 6, 10)
    FIELD(POR_ERRSTATUS_MXP_U_SMXP_4_1, RESERVED_0, 0, 6)
REG32(POR_FDC_AUX_CTL_MXP_U_SMXP_4_1, 0x212f018)
    FIELD(POR_FDC_AUX_CTL_MXP_U_SMXP_4_1, CLKGATE_OVERRIDE, 4, 1)
    FIELD(POR_FDC_AUX_CTL_MXP_U_SMXP_4_1, RESERVED_0, 0, 4)
REG32(POR_ERRFR_P0_D0_U_SMXP_4_1, 0x212f040)
    FIELD(POR_ERRFR_P0_D0_U_SMXP_4_1, FI, 6, 2)
    FIELD(POR_ERRFR_P0_D0_U_SMXP_4_1, UI, 4, 2)
    FIELD(POR_ERRFR_P0_D0_U_SMXP_4_1, ED, 0, 2)
REG32(POR_ERRCTLR_P0_D0_U_SMXP_4_1, 0x212f048)
    FIELD(POR_ERRCTLR_P0_D0_U_SMXP_4_1, RESERVED_32, 32, 32)
    FIELD(POR_ERRCTLR_P0_D0_U_SMXP_4_1, ERC, 14, 18)
    FIELD(POR_ERRCTLR_P0_D0_U_SMXP_4_1, FI, 3, 1)
    FIELD(POR_ERRCTLR_P0_D0_U_SMXP_4_1, UI, 2, 1)
    FIELD(POR_ERRCTLR_P0_D0_U_SMXP_4_1, ED, 0, 1)
REG32(POR_ERRSTATUS_P0_D0_U_SMXP_4_1, 0x212f050)
    FIELD(POR_ERRSTATUS_P0_D0_U_SMXP_4_1, RESERVED_31, 31, 33)
    FIELD(POR_ERRSTATUS_P0_D0_U_SMXP_4_1, V, 30, 1)
    FIELD(POR_ERRSTATUS_P0_D0_U_SMXP_4_1, UE, 29, 1)
    FIELD(POR_ERRSTATUS_P0_D0_U_SMXP_4_1, RESERVED_28, 28, 1)
    FIELD(POR_ERRSTATUS_P0_D0_U_SMXP_4_1, OF, 27, 1)
    FIELD(POR_ERRSTATUS_P0_D0_U_SMXP_4_1, RESERVED_24, 24, 3)
    FIELD(POR_ERRSTATUS_P0_D0_U_SMXP_4_1, DE, 23, 1)
    FIELD(POR_ERRSTATUS_P0_D0_U_SMXP_4_1, RESERVED_16, 16, 7)
    FIELD(POR_ERRSTATUS_P0_D0_U_SMXP_4_1, V_ERR_TYPE, 6, 10)
    FIELD(POR_ERRSTATUS_P0_D0_U_SMXP_4_1, RESERVED_0, 0, 6)
REG32(POR_FDC_AUX_CTL_P0_D0_U_SMXP_4_1, 0x212f058)
    FIELD(POR_FDC_AUX_CTL_P0_D0_U_SMXP_4_1, CLKGATE_OVERRIDE, 4, 1)
    FIELD(POR_FDC_AUX_CTL_P0_D0_U_SMXP_4_1, HANG_DET_CONFIG, 0, 4)
REG32(POR_ERRFR_P0_D1_U_SMXP_4_1, 0x212f080)
    FIELD(POR_ERRFR_P0_D1_U_SMXP_4_1, FI, 6, 2)
    FIELD(POR_ERRFR_P0_D1_U_SMXP_4_1, UI, 4, 2)
    FIELD(POR_ERRFR_P0_D1_U_SMXP_4_1, ED, 0, 2)
REG32(POR_ERRCTLR_P0_D1_U_SMXP_4_1, 0x212f088)
    FIELD(POR_ERRCTLR_P0_D1_U_SMXP_4_1, RESERVED_32, 32, 32)
    FIELD(POR_ERRCTLR_P0_D1_U_SMXP_4_1, ERC, 14, 18)
    FIELD(POR_ERRCTLR_P0_D1_U_SMXP_4_1, FI, 3, 1)
    FIELD(POR_ERRCTLR_P0_D1_U_SMXP_4_1, UI, 2, 1)
    FIELD(POR_ERRCTLR_P0_D1_U_SMXP_4_1, ED, 0, 1)
REG32(POR_ERRSTATUS_P0_D1_U_SMXP_4_1, 0x212f090)
    FIELD(POR_ERRSTATUS_P0_D1_U_SMXP_4_1, RESERVED_31, 31, 33)
    FIELD(POR_ERRSTATUS_P0_D1_U_SMXP_4_1, V, 30, 1)
    FIELD(POR_ERRSTATUS_P0_D1_U_SMXP_4_1, UE, 29, 1)
    FIELD(POR_ERRSTATUS_P0_D1_U_SMXP_4_1, RESERVED_28, 28, 1)
    FIELD(POR_ERRSTATUS_P0_D1_U_SMXP_4_1, OF, 27, 1)
    FIELD(POR_ERRSTATUS_P0_D1_U_SMXP_4_1, RESERVED_24, 24, 3)
    FIELD(POR_ERRSTATUS_P0_D1_U_SMXP_4_1, DE, 23, 1)
    FIELD(POR_ERRSTATUS_P0_D1_U_SMXP_4_1, RESERVED_16, 16, 7)
    FIELD(POR_ERRSTATUS_P0_D1_U_SMXP_4_1, V_ERR_TYPE, 6, 10)
    FIELD(POR_ERRSTATUS_P0_D1_U_SMXP_4_1, RESERVED_0, 0, 6)
REG32(POR_FDC_AUX_CTL_P0_D1_U_SMXP_4_1, 0x212f098)
    FIELD(POR_FDC_AUX_CTL_P0_D1_U_SMXP_4_1, CLKGATE_OVERRIDE, 4, 1)
    FIELD(POR_FDC_AUX_CTL_P0_D1_U_SMXP_4_1, HANG_DET_CONFIG, 0, 4)
REG32(POR_ERRFR_P0_D2_U_SMXP_4_1, 0x212f0c0)
    FIELD(POR_ERRFR_P0_D2_U_SMXP_4_1, FI, 6, 2)
    FIELD(POR_ERRFR_P0_D2_U_SMXP_4_1, UI, 4, 2)
    FIELD(POR_ERRFR_P0_D2_U_SMXP_4_1, ED, 0, 2)
REG32(POR_ERRCTLR_P0_D2_U_SMXP_4_1, 0x212f0c8)
    FIELD(POR_ERRCTLR_P0_D2_U_SMXP_4_1, RESERVED_32, 32, 32)
    FIELD(POR_ERRCTLR_P0_D2_U_SMXP_4_1, ERC, 14, 18)
    FIELD(POR_ERRCTLR_P0_D2_U_SMXP_4_1, FI, 3, 1)
    FIELD(POR_ERRCTLR_P0_D2_U_SMXP_4_1, UI, 2, 1)
    FIELD(POR_ERRCTLR_P0_D2_U_SMXP_4_1, ED, 0, 1)
REG32(POR_ERRSTATUS_P0_D2_U_SMXP_4_1, 0x212f0d0)
    FIELD(POR_ERRSTATUS_P0_D2_U_SMXP_4_1, RESERVED_31, 31, 33)
    FIELD(POR_ERRSTATUS_P0_D2_U_SMXP_4_1, V, 30, 1)
    FIELD(POR_ERRSTATUS_P0_D2_U_SMXP_4_1, UE, 29, 1)
    FIELD(POR_ERRSTATUS_P0_D2_U_SMXP_4_1, RESERVED_28, 28, 1)
    FIELD(POR_ERRSTATUS_P0_D2_U_SMXP_4_1, OF, 27, 1)
    FIELD(POR_ERRSTATUS_P0_D2_U_SMXP_4_1, RESERVED_24, 24, 3)
    FIELD(POR_ERRSTATUS_P0_D2_U_SMXP_4_1, DE, 23, 1)
    FIELD(POR_ERRSTATUS_P0_D2_U_SMXP_4_1, RESERVED_16, 16, 7)
    FIELD(POR_ERRSTATUS_P0_D2_U_SMXP_4_1, V_ERR_TYPE, 6, 10)
    FIELD(POR_ERRSTATUS_P0_D2_U_SMXP_4_1, RESERVED_0, 0, 6)
REG32(POR_FDC_AUX_CTL_P0_D2_U_SMXP_4_1, 0x212f0d8)
    FIELD(POR_FDC_AUX_CTL_P0_D2_U_SMXP_4_1, CLKGATE_OVERRIDE, 4, 1)
    FIELD(POR_FDC_AUX_CTL_P0_D2_U_SMXP_4_1, HANG_DET_CONFIG, 0, 4)
REG32(POR_ERRFR_P0_D3_U_SMXP_4_1, 0x212f100)
    FIELD(POR_ERRFR_P0_D3_U_SMXP_4_1, FI, 6, 2)
    FIELD(POR_ERRFR_P0_D3_U_SMXP_4_1, UI, 4, 2)
    FIELD(POR_ERRFR_P0_D3_U_SMXP_4_1, ED, 0, 2)
REG32(POR_ERRCTLR_P0_D3_U_SMXP_4_1, 0x212f108)
    FIELD(POR_ERRCTLR_P0_D3_U_SMXP_4_1, RESERVED_32, 32, 32)
    FIELD(POR_ERRCTLR_P0_D3_U_SMXP_4_1, ERC, 14, 18)
    FIELD(POR_ERRCTLR_P0_D3_U_SMXP_4_1, FI, 3, 1)
    FIELD(POR_ERRCTLR_P0_D3_U_SMXP_4_1, UI, 2, 1)
    FIELD(POR_ERRCTLR_P0_D3_U_SMXP_4_1, ED, 0, 1)
REG32(POR_ERRSTATUS_P0_D3_U_SMXP_4_1, 0x212f110)
    FIELD(POR_ERRSTATUS_P0_D3_U_SMXP_4_1, RESERVED_31, 31, 33)
    FIELD(POR_ERRSTATUS_P0_D3_U_SMXP_4_1, V, 30, 1)
    FIELD(POR_ERRSTATUS_P0_D3_U_SMXP_4_1, UE, 29, 1)
    FIELD(POR_ERRSTATUS_P0_D3_U_SMXP_4_1, RESERVED_28, 28, 1)
    FIELD(POR_ERRSTATUS_P0_D3_U_SMXP_4_1, OF, 27, 1)
    FIELD(POR_ERRSTATUS_P0_D3_U_SMXP_4_1, RESERVED_24, 24, 3)
    FIELD(POR_ERRSTATUS_P0_D3_U_SMXP_4_1, DE, 23, 1)
    FIELD(POR_ERRSTATUS_P0_D3_U_SMXP_4_1, RESERVED_16, 16, 7)
    FIELD(POR_ERRSTATUS_P0_D3_U_SMXP_4_1, V_ERR_TYPE, 6, 10)
    FIELD(POR_ERRSTATUS_P0_D3_U_SMXP_4_1, RESERVED_0, 0, 6)
REG32(POR_FDC_AUX_CTL_P0_D3_U_SMXP_4_1, 0x212f118)
    FIELD(POR_FDC_AUX_CTL_P0_D3_U_SMXP_4_1, CLKGATE_OVERRIDE, 4, 1)
    FIELD(POR_FDC_AUX_CTL_P0_D3_U_SMXP_4_1, HANG_DET_CONFIG, 0, 4)
REG32(POR_ERRFR_P1_D0_U_SMXP_4_1, 0x212f140)
    FIELD(POR_ERRFR_P1_D0_U_SMXP_4_1, FI, 6, 2)
    FIELD(POR_ERRFR_P1_D0_U_SMXP_4_1, UI, 4, 2)
    FIELD(POR_ERRFR_P1_D0_U_SMXP_4_1, ED, 0, 2)
REG32(POR_ERRCTLR_P1_D0_U_SMXP_4_1, 0x212f148)
    FIELD(POR_ERRCTLR_P1_D0_U_SMXP_4_1, RESERVED_32, 32, 32)
    FIELD(POR_ERRCTLR_P1_D0_U_SMXP_4_1, ERC, 14, 18)
    FIELD(POR_ERRCTLR_P1_D0_U_SMXP_4_1, FI, 3, 1)
    FIELD(POR_ERRCTLR_P1_D0_U_SMXP_4_1, UI, 2, 1)
    FIELD(POR_ERRCTLR_P1_D0_U_SMXP_4_1, ED, 0, 1)
REG32(POR_ERRSTATUS_P1_D0_U_SMXP_4_1, 0x212f150)
    FIELD(POR_ERRSTATUS_P1_D0_U_SMXP_4_1, RESERVED_31, 31, 33)
    FIELD(POR_ERRSTATUS_P1_D0_U_SMXP_4_1, V, 30, 1)
    FIELD(POR_ERRSTATUS_P1_D0_U_SMXP_4_1, UE, 29, 1)
    FIELD(POR_ERRSTATUS_P1_D0_U_SMXP_4_1, RESERVED_28, 28, 1)
    FIELD(POR_ERRSTATUS_P1_D0_U_SMXP_4_1, OF, 27, 1)
    FIELD(POR_ERRSTATUS_P1_D0_U_SMXP_4_1, RESERVED_24, 24, 3)
    FIELD(POR_ERRSTATUS_P1_D0_U_SMXP_4_1, DE, 23, 1)
    FIELD(POR_ERRSTATUS_P1_D0_U_SMXP_4_1, RESERVED_16, 16, 7)
    FIELD(POR_ERRSTATUS_P1_D0_U_SMXP_4_1, V_ERR_TYPE, 6, 10)
    FIELD(POR_ERRSTATUS_P1_D0_U_SMXP_4_1, RESERVED_0, 0, 6)
REG32(POR_FDC_AUX_CTL_P1_D0_U_SMXP_4_1, 0x212f158)
    FIELD(POR_FDC_AUX_CTL_P1_D0_U_SMXP_4_1, CLKGATE_OVERRIDE, 4, 1)
    FIELD(POR_FDC_AUX_CTL_P1_D0_U_SMXP_4_1, HANG_DET_CONFIG, 0, 4)
REG32(POR_ERRFR_P1_D1_U_SMXP_4_1, 0x212f180)
    FIELD(POR_ERRFR_P1_D1_U_SMXP_4_1, FI, 6, 2)
    FIELD(POR_ERRFR_P1_D1_U_SMXP_4_1, UI, 4, 2)
    FIELD(POR_ERRFR_P1_D1_U_SMXP_4_1, ED, 0, 2)
REG32(POR_ERRCTLR_P1_D1_U_SMXP_4_1, 0x212f188)
    FIELD(POR_ERRCTLR_P1_D1_U_SMXP_4_1, RESERVED_32, 32, 32)
    FIELD(POR_ERRCTLR_P1_D1_U_SMXP_4_1, ERC, 14, 18)
    FIELD(POR_ERRCTLR_P1_D1_U_SMXP_4_1, FI, 3, 1)
    FIELD(POR_ERRCTLR_P1_D1_U_SMXP_4_1, UI, 2, 1)
    FIELD(POR_ERRCTLR_P1_D1_U_SMXP_4_1, ED, 0, 1)
REG32(POR_ERRSTATUS_P1_D1_U_SMXP_4_1, 0x212f190)
    FIELD(POR_ERRSTATUS_P1_D1_U_SMXP_4_1, RESERVED_31, 31, 33)
    FIELD(POR_ERRSTATUS_P1_D1_U_SMXP_4_1, V, 30, 1)
    FIELD(POR_ERRSTATUS_P1_D1_U_SMXP_4_1, UE, 29, 1)
    FIELD(POR_ERRSTATUS_P1_D1_U_SMXP_4_1, RESERVED_28, 28, 1)
    FIELD(POR_ERRSTATUS_P1_D1_U_SMXP_4_1, OF, 27, 1)
    FIELD(POR_ERRSTATUS_P1_D1_U_SMXP_4_1, RESERVED_24, 24, 3)
    FIELD(POR_ERRSTATUS_P1_D1_U_SMXP_4_1, DE, 23, 1)
    FIELD(POR_ERRSTATUS_P1_D1_U_SMXP_4_1, RESERVED_16, 16, 7)
    FIELD(POR_ERRSTATUS_P1_D1_U_SMXP_4_1, V_ERR_TYPE, 6, 10)
    FIELD(POR_ERRSTATUS_P1_D1_U_SMXP_4_1, RESERVED_0, 0, 6)
REG32(POR_FDC_AUX_CTL_P1_D1_U_SMXP_4_1, 0x212f198)
    FIELD(POR_FDC_AUX_CTL_P1_D1_U_SMXP_4_1, CLKGATE_OVERRIDE, 4, 1)
    FIELD(POR_FDC_AUX_CTL_P1_D1_U_SMXP_4_1, HANG_DET_CONFIG, 0, 4)
REG32(POR_ERRFR_P1_D2_U_SMXP_4_1, 0x212f1c0)
    FIELD(POR_ERRFR_P1_D2_U_SMXP_4_1, FI, 6, 2)
    FIELD(POR_ERRFR_P1_D2_U_SMXP_4_1, UI, 4, 2)
    FIELD(POR_ERRFR_P1_D2_U_SMXP_4_1, ED, 0, 2)
REG32(POR_ERRCTLR_P1_D2_U_SMXP_4_1, 0x212f1c8)
    FIELD(POR_ERRCTLR_P1_D2_U_SMXP_4_1, RESERVED_32, 32, 32)
    FIELD(POR_ERRCTLR_P1_D2_U_SMXP_4_1, ERC, 14, 18)
    FIELD(POR_ERRCTLR_P1_D2_U_SMXP_4_1, FI, 3, 1)
    FIELD(POR_ERRCTLR_P1_D2_U_SMXP_4_1, UI, 2, 1)
    FIELD(POR_ERRCTLR_P1_D2_U_SMXP_4_1, ED, 0, 1)
REG32(POR_ERRSTATUS_P1_D2_U_SMXP_4_1, 0x212f1d0)
    FIELD(POR_ERRSTATUS_P1_D2_U_SMXP_4_1, RESERVED_31, 31, 33)
    FIELD(POR_ERRSTATUS_P1_D2_U_SMXP_4_1, V, 30, 1)
    FIELD(POR_ERRSTATUS_P1_D2_U_SMXP_4_1, UE, 29, 1)
    FIELD(POR_ERRSTATUS_P1_D2_U_SMXP_4_1, RESERVED_28, 28, 1)
    FIELD(POR_ERRSTATUS_P1_D2_U_SMXP_4_1, OF, 27, 1)
    FIELD(POR_ERRSTATUS_P1_D2_U_SMXP_4_1, RESERVED_24, 24, 3)
    FIELD(POR_ERRSTATUS_P1_D2_U_SMXP_4_1, DE, 23, 1)
    FIELD(POR_ERRSTATUS_P1_D2_U_SMXP_4_1, RESERVED_16, 16, 7)
    FIELD(POR_ERRSTATUS_P1_D2_U_SMXP_4_1, V_ERR_TYPE, 6, 10)
    FIELD(POR_ERRSTATUS_P1_D2_U_SMXP_4_1, RESERVED_0, 0, 6)
REG32(POR_FDC_AUX_CTL_P1_D2_U_SMXP_4_1, 0x212f1d8)
    FIELD(POR_FDC_AUX_CTL_P1_D2_U_SMXP_4_1, CLKGATE_OVERRIDE, 4, 1)
    FIELD(POR_FDC_AUX_CTL_P1_D2_U_SMXP_4_1, HANG_DET_CONFIG, 0, 4)
REG32(POR_ERRFR_P1_D3_U_SMXP_4_1, 0x212f200)
    FIELD(POR_ERRFR_P1_D3_U_SMXP_4_1, FI, 6, 2)
    FIELD(POR_ERRFR_P1_D3_U_SMXP_4_1, UI, 4, 2)
    FIELD(POR_ERRFR_P1_D3_U_SMXP_4_1, ED, 0, 2)
REG32(POR_ERRCTLR_P1_D3_U_SMXP_4_1, 0x212f208)
    FIELD(POR_ERRCTLR_P1_D3_U_SMXP_4_1, RESERVED_32, 32, 32)
    FIELD(POR_ERRCTLR_P1_D3_U_SMXP_4_1, ERC, 14, 18)
    FIELD(POR_ERRCTLR_P1_D3_U_SMXP_4_1, FI, 3, 1)
    FIELD(POR_ERRCTLR_P1_D3_U_SMXP_4_1, UI, 2, 1)
    FIELD(POR_ERRCTLR_P1_D3_U_SMXP_4_1, ED, 0, 1)
REG32(POR_ERRSTATUS_P1_D3_U_SMXP_4_1, 0x212f210)
    FIELD(POR_ERRSTATUS_P1_D3_U_SMXP_4_1, RESERVED_31, 31, 33)
    FIELD(POR_ERRSTATUS_P1_D3_U_SMXP_4_1, V, 30, 1)
    FIELD(POR_ERRSTATUS_P1_D3_U_SMXP_4_1, UE, 29, 1)
    FIELD(POR_ERRSTATUS_P1_D3_U_SMXP_4_1, RESERVED_28, 28, 1)
    FIELD(POR_ERRSTATUS_P1_D3_U_SMXP_4_1, OF, 27, 1)
    FIELD(POR_ERRSTATUS_P1_D3_U_SMXP_4_1, RESERVED_24, 24, 3)
    FIELD(POR_ERRSTATUS_P1_D3_U_SMXP_4_1, DE, 23, 1)
    FIELD(POR_ERRSTATUS_P1_D3_U_SMXP_4_1, RESERVED_16, 16, 7)
    FIELD(POR_ERRSTATUS_P1_D3_U_SMXP_4_1, V_ERR_TYPE, 6, 10)
    FIELD(POR_ERRSTATUS_P1_D3_U_SMXP_4_1, RESERVED_0, 0, 6)
REG32(POR_FDC_AUX_CTL_P1_D3_U_SMXP_4_1, 0x212f218)
    FIELD(POR_FDC_AUX_CTL_P1_D3_U_SMXP_4_1, CLKGATE_OVERRIDE, 4, 1)
    FIELD(POR_FDC_AUX_CTL_P1_D3_U_SMXP_4_1, HANG_DET_CONFIG, 0, 4)
REG32(POR_ERRINJECT_U_SMXP_4_1, 0x212f300)
    FIELD(POR_ERRINJECT_U_SMXP_4_1, ERR_DEV, 4, 4)
    FIELD(POR_ERRINJECT_U_SMXP_4_1, ERR_TYPE, 0, 4)
REG32(POR_FDC_KEY_U_SMXP_4_1, 0x212f308)
    FIELD(POR_FDC_KEY_U_SMXP_4_1, KEY, 0, 8)
REG32(POR_MPU_NODE_INFO_U_SMXP_4_1, 0x213c000)
    FIELD(POR_MPU_NODE_INFO_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_NODE_INFO_U_SMXP_4_1, LOGICAL_ID, 32, 16)
    FIELD(POR_MPU_NODE_INFO_U_SMXP_4_1, NODE_ID, 16, 16)
    FIELD(POR_MPU_NODE_INFO_U_SMXP_4_1, NODE_TYPE, 0, 16)
REG32(POR_MPU_CHILD_INFO_U_SMXP_4_1, 0x213c080)
    FIELD(POR_MPU_CHILD_INFO_U_SMXP_4_1, RESERVED_32, 32, 32)
    FIELD(POR_MPU_CHILD_INFO_U_SMXP_4_1, CHILD_PTR_OFFSET, 16, 16)
    FIELD(POR_MPU_CHILD_INFO_U_SMXP_4_1, CHILD_COUNT, 0, 16)
REG32(POR_MPU_UNIT_INFO_U_SMXP_4_1, 0x213c900)
    FIELD(POR_MPU_UNIT_INFO_U_SMXP_4_1, RESERVED_16, 16, 48)
    FIELD(POR_MPU_UNIT_INFO_U_SMXP_4_1, MASTER_7_PRESENT, 15, 1)
    FIELD(POR_MPU_UNIT_INFO_U_SMXP_4_1, MASTER_6_PRESENT, 14, 1)
    FIELD(POR_MPU_UNIT_INFO_U_SMXP_4_1, MASTER_5_PRESENT, 13, 1)
    FIELD(POR_MPU_UNIT_INFO_U_SMXP_4_1, MASTER_4_PRESENT, 12, 1)
    FIELD(POR_MPU_UNIT_INFO_U_SMXP_4_1, MASTER_3_PRESENT, 11, 1)
    FIELD(POR_MPU_UNIT_INFO_U_SMXP_4_1, MASTER_2_PRESENT, 10, 1)
    FIELD(POR_MPU_UNIT_INFO_U_SMXP_4_1, MASTER_1_PRESENT, 9, 1)
    FIELD(POR_MPU_UNIT_INFO_U_SMXP_4_1, MASTER_0_PRESENT, 8, 1)
    FIELD(POR_MPU_UNIT_INFO_U_SMXP_4_1, NUM_PROG_REGION, 0, 8)
REG32(POR_MPU_M0_CTL_U_SMXP_4_1, 0x213d000)
    FIELD(POR_MPU_M0_CTL_U_SMXP_4_1, M0_EN, 2, 1)
    FIELD(POR_MPU_M0_CTL_U_SMXP_4_1, M0_ACTION, 0, 2)
REG32(POR_MPU_M0_PRBAR0_U_SMXP_4_1, 0x213d010)
    FIELD(POR_MPU_M0_PRBAR0_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR0_U_SMXP_4_1, REGION0_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR0_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR0_U_SMXP_4_1, REGION0_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR0_U_SMXP_4_1, REGION0_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR0_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR0_U_SMXP_4_1, 0x213d018)
    FIELD(POR_MPU_M0_PRLAR0_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR0_U_SMXP_4_1, REGION0_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR0_U_SMXP_4_1, REGION0_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR1_U_SMXP_4_1, 0x213d020)
    FIELD(POR_MPU_M0_PRBAR1_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR1_U_SMXP_4_1, REGION1_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR1_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR1_U_SMXP_4_1, REGION1_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR1_U_SMXP_4_1, REGION1_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR1_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR1_U_SMXP_4_1, 0x213d028)
    FIELD(POR_MPU_M0_PRLAR1_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR1_U_SMXP_4_1, REGION1_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR1_U_SMXP_4_1, REGION1_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR2_U_SMXP_4_1, 0x213d030)
    FIELD(POR_MPU_M0_PRBAR2_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR2_U_SMXP_4_1, REGION2_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR2_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR2_U_SMXP_4_1, REGION2_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR2_U_SMXP_4_1, REGION2_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR2_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR2_U_SMXP_4_1, 0x213d038)
    FIELD(POR_MPU_M0_PRLAR2_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR2_U_SMXP_4_1, REGION2_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR2_U_SMXP_4_1, REGION2_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR3_U_SMXP_4_1, 0x213d040)
    FIELD(POR_MPU_M0_PRBAR3_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR3_U_SMXP_4_1, REGION3_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR3_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR3_U_SMXP_4_1, REGION3_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR3_U_SMXP_4_1, REGION3_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR3_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR3_U_SMXP_4_1, 0x213d048)
    FIELD(POR_MPU_M0_PRLAR3_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR3_U_SMXP_4_1, REGION3_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR3_U_SMXP_4_1, REGION3_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR4_U_SMXP_4_1, 0x213d050)
    FIELD(POR_MPU_M0_PRBAR4_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR4_U_SMXP_4_1, REGION4_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR4_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR4_U_SMXP_4_1, REGION4_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR4_U_SMXP_4_1, REGION4_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR4_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR4_U_SMXP_4_1, 0x213d058)
    FIELD(POR_MPU_M0_PRLAR4_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR4_U_SMXP_4_1, REGION4_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR4_U_SMXP_4_1, REGION4_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR5_U_SMXP_4_1, 0x213d060)
    FIELD(POR_MPU_M0_PRBAR5_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR5_U_SMXP_4_1, REGION5_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR5_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR5_U_SMXP_4_1, REGION5_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR5_U_SMXP_4_1, REGION5_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR5_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR5_U_SMXP_4_1, 0x213d068)
    FIELD(POR_MPU_M0_PRLAR5_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR5_U_SMXP_4_1, REGION5_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR5_U_SMXP_4_1, REGION5_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR6_U_SMXP_4_1, 0x213d070)
    FIELD(POR_MPU_M0_PRBAR6_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR6_U_SMXP_4_1, REGION6_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR6_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR6_U_SMXP_4_1, REGION6_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR6_U_SMXP_4_1, REGION6_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR6_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR6_U_SMXP_4_1, 0x213d078)
    FIELD(POR_MPU_M0_PRLAR6_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR6_U_SMXP_4_1, REGION6_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR6_U_SMXP_4_1, REGION6_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR7_U_SMXP_4_1, 0x213d080)
    FIELD(POR_MPU_M0_PRBAR7_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR7_U_SMXP_4_1, REGION7_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR7_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR7_U_SMXP_4_1, REGION7_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR7_U_SMXP_4_1, REGION7_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR7_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR7_U_SMXP_4_1, 0x213d088)
    FIELD(POR_MPU_M0_PRLAR7_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR7_U_SMXP_4_1, REGION7_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR7_U_SMXP_4_1, REGION7_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR8_U_SMXP_4_1, 0x213d090)
    FIELD(POR_MPU_M0_PRBAR8_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR8_U_SMXP_4_1, REGION8_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR8_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR8_U_SMXP_4_1, REGION8_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR8_U_SMXP_4_1, REGION8_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR8_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR8_U_SMXP_4_1, 0x213d098)
    FIELD(POR_MPU_M0_PRLAR8_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR8_U_SMXP_4_1, REGION8_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR8_U_SMXP_4_1, REGION8_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR9_U_SMXP_4_1, 0x213d0a0)
    FIELD(POR_MPU_M0_PRBAR9_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR9_U_SMXP_4_1, REGION9_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR9_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR9_U_SMXP_4_1, REGION9_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR9_U_SMXP_4_1, REGION9_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR9_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR9_U_SMXP_4_1, 0x213d0a8)
    FIELD(POR_MPU_M0_PRLAR9_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR9_U_SMXP_4_1, REGION9_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR9_U_SMXP_4_1, REGION9_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR10_U_SMXP_4_1, 0x213d0b0)
    FIELD(POR_MPU_M0_PRBAR10_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR10_U_SMXP_4_1, REGION10_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR10_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR10_U_SMXP_4_1, REGION10_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR10_U_SMXP_4_1, REGION10_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR10_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR10_U_SMXP_4_1, 0x213d0b8)
    FIELD(POR_MPU_M0_PRLAR10_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR10_U_SMXP_4_1, REGION10_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR10_U_SMXP_4_1, REGION10_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR11_U_SMXP_4_1, 0x213d0c0)
    FIELD(POR_MPU_M0_PRBAR11_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR11_U_SMXP_4_1, REGION11_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR11_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR11_U_SMXP_4_1, REGION11_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR11_U_SMXP_4_1, REGION11_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR11_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR11_U_SMXP_4_1, 0x213d0c8)
    FIELD(POR_MPU_M0_PRLAR11_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR11_U_SMXP_4_1, REGION11_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR11_U_SMXP_4_1, REGION11_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR12_U_SMXP_4_1, 0x213d0d0)
    FIELD(POR_MPU_M0_PRBAR12_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR12_U_SMXP_4_1, REGION12_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR12_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR12_U_SMXP_4_1, REGION12_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR12_U_SMXP_4_1, REGION12_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR12_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR12_U_SMXP_4_1, 0x213d0d8)
    FIELD(POR_MPU_M0_PRLAR12_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR12_U_SMXP_4_1, REGION12_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR12_U_SMXP_4_1, REGION12_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR13_U_SMXP_4_1, 0x213d0e0)
    FIELD(POR_MPU_M0_PRBAR13_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR13_U_SMXP_4_1, REGION13_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR13_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR13_U_SMXP_4_1, REGION13_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR13_U_SMXP_4_1, REGION13_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR13_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR13_U_SMXP_4_1, 0x213d0e8)
    FIELD(POR_MPU_M0_PRLAR13_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR13_U_SMXP_4_1, REGION13_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR13_U_SMXP_4_1, REGION13_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR14_U_SMXP_4_1, 0x213d0f0)
    FIELD(POR_MPU_M0_PRBAR14_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR14_U_SMXP_4_1, REGION14_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR14_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR14_U_SMXP_4_1, REGION14_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR14_U_SMXP_4_1, REGION14_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR14_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR14_U_SMXP_4_1, 0x213d0f8)
    FIELD(POR_MPU_M0_PRLAR14_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR14_U_SMXP_4_1, REGION14_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR14_U_SMXP_4_1, REGION14_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR15_U_SMXP_4_1, 0x213d100)
    FIELD(POR_MPU_M0_PRBAR15_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR15_U_SMXP_4_1, REGION15_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR15_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR15_U_SMXP_4_1, REGION15_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR15_U_SMXP_4_1, REGION15_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR15_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR15_U_SMXP_4_1, 0x213d108)
    FIELD(POR_MPU_M0_PRLAR15_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR15_U_SMXP_4_1, REGION15_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR15_U_SMXP_4_1, REGION15_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR16_U_SMXP_4_1, 0x213d110)
    FIELD(POR_MPU_M0_PRBAR16_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR16_U_SMXP_4_1, REGION16_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR16_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR16_U_SMXP_4_1, REGION16_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR16_U_SMXP_4_1, REGION16_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR16_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR16_U_SMXP_4_1, 0x213d118)
    FIELD(POR_MPU_M0_PRLAR16_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR16_U_SMXP_4_1, REGION16_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR16_U_SMXP_4_1, REGION16_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR17_U_SMXP_4_1, 0x213d120)
    FIELD(POR_MPU_M0_PRBAR17_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR17_U_SMXP_4_1, REGION17_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR17_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR17_U_SMXP_4_1, REGION17_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR17_U_SMXP_4_1, REGION17_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR17_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR17_U_SMXP_4_1, 0x213d128)
    FIELD(POR_MPU_M0_PRLAR17_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR17_U_SMXP_4_1, REGION17_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR17_U_SMXP_4_1, REGION17_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR18_U_SMXP_4_1, 0x213d130)
    FIELD(POR_MPU_M0_PRBAR18_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR18_U_SMXP_4_1, REGION18_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR18_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR18_U_SMXP_4_1, REGION18_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR18_U_SMXP_4_1, REGION18_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR18_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR18_U_SMXP_4_1, 0x213d138)
    FIELD(POR_MPU_M0_PRLAR18_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR18_U_SMXP_4_1, REGION18_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR18_U_SMXP_4_1, REGION18_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR19_U_SMXP_4_1, 0x213d140)
    FIELD(POR_MPU_M0_PRBAR19_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR19_U_SMXP_4_1, REGION19_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR19_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR19_U_SMXP_4_1, REGION19_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR19_U_SMXP_4_1, REGION19_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR19_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR19_U_SMXP_4_1, 0x213d148)
    FIELD(POR_MPU_M0_PRLAR19_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR19_U_SMXP_4_1, REGION19_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR19_U_SMXP_4_1, REGION19_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR20_U_SMXP_4_1, 0x213d150)
    FIELD(POR_MPU_M0_PRBAR20_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR20_U_SMXP_4_1, REGION20_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR20_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR20_U_SMXP_4_1, REGION20_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR20_U_SMXP_4_1, REGION20_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR20_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR20_U_SMXP_4_1, 0x213d158)
    FIELD(POR_MPU_M0_PRLAR20_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR20_U_SMXP_4_1, REGION20_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR20_U_SMXP_4_1, REGION20_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR21_U_SMXP_4_1, 0x213d160)
    FIELD(POR_MPU_M0_PRBAR21_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR21_U_SMXP_4_1, REGION21_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR21_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR21_U_SMXP_4_1, REGION21_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR21_U_SMXP_4_1, REGION21_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR21_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR21_U_SMXP_4_1, 0x213d168)
    FIELD(POR_MPU_M0_PRLAR21_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR21_U_SMXP_4_1, REGION21_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR21_U_SMXP_4_1, REGION21_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR22_U_SMXP_4_1, 0x213d170)
    FIELD(POR_MPU_M0_PRBAR22_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR22_U_SMXP_4_1, REGION22_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR22_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR22_U_SMXP_4_1, REGION22_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR22_U_SMXP_4_1, REGION22_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR22_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR22_U_SMXP_4_1, 0x213d178)
    FIELD(POR_MPU_M0_PRLAR22_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR22_U_SMXP_4_1, REGION22_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR22_U_SMXP_4_1, REGION22_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR23_U_SMXP_4_1, 0x213d180)
    FIELD(POR_MPU_M0_PRBAR23_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR23_U_SMXP_4_1, REGION23_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR23_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR23_U_SMXP_4_1, REGION23_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR23_U_SMXP_4_1, REGION23_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR23_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR23_U_SMXP_4_1, 0x213d188)
    FIELD(POR_MPU_M0_PRLAR23_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR23_U_SMXP_4_1, REGION23_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR23_U_SMXP_4_1, REGION23_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR24_U_SMXP_4_1, 0x213d190)
    FIELD(POR_MPU_M0_PRBAR24_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR24_U_SMXP_4_1, REGION24_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR24_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR24_U_SMXP_4_1, REGION24_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR24_U_SMXP_4_1, REGION24_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR24_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR24_U_SMXP_4_1, 0x213d198)
    FIELD(POR_MPU_M0_PRLAR24_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR24_U_SMXP_4_1, REGION24_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR24_U_SMXP_4_1, REGION24_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR25_U_SMXP_4_1, 0x213d1a0)
    FIELD(POR_MPU_M0_PRBAR25_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR25_U_SMXP_4_1, REGION25_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR25_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR25_U_SMXP_4_1, REGION25_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR25_U_SMXP_4_1, REGION25_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR25_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR25_U_SMXP_4_1, 0x213d1a8)
    FIELD(POR_MPU_M0_PRLAR25_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR25_U_SMXP_4_1, REGION25_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR25_U_SMXP_4_1, REGION25_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR26_U_SMXP_4_1, 0x213d1b0)
    FIELD(POR_MPU_M0_PRBAR26_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR26_U_SMXP_4_1, REGION26_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR26_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR26_U_SMXP_4_1, REGION26_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR26_U_SMXP_4_1, REGION26_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR26_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR26_U_SMXP_4_1, 0x213d1b8)
    FIELD(POR_MPU_M0_PRLAR26_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR26_U_SMXP_4_1, REGION26_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR26_U_SMXP_4_1, REGION26_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR27_U_SMXP_4_1, 0x213d1c0)
    FIELD(POR_MPU_M0_PRBAR27_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR27_U_SMXP_4_1, REGION27_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR27_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR27_U_SMXP_4_1, REGION27_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR27_U_SMXP_4_1, REGION27_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR27_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR27_U_SMXP_4_1, 0x213d1c8)
    FIELD(POR_MPU_M0_PRLAR27_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR27_U_SMXP_4_1, REGION27_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR27_U_SMXP_4_1, REGION27_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR28_U_SMXP_4_1, 0x213d1d0)
    FIELD(POR_MPU_M0_PRBAR28_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR28_U_SMXP_4_1, REGION28_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR28_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR28_U_SMXP_4_1, REGION28_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR28_U_SMXP_4_1, REGION28_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR28_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR28_U_SMXP_4_1, 0x213d1d8)
    FIELD(POR_MPU_M0_PRLAR28_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR28_U_SMXP_4_1, REGION28_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR28_U_SMXP_4_1, REGION28_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR29_U_SMXP_4_1, 0x213d1e0)
    FIELD(POR_MPU_M0_PRBAR29_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR29_U_SMXP_4_1, REGION29_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR29_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR29_U_SMXP_4_1, REGION29_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR29_U_SMXP_4_1, REGION29_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR29_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR29_U_SMXP_4_1, 0x213d1e8)
    FIELD(POR_MPU_M0_PRLAR29_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR29_U_SMXP_4_1, REGION29_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR29_U_SMXP_4_1, REGION29_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR30_U_SMXP_4_1, 0x213d1f0)
    FIELD(POR_MPU_M0_PRBAR30_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR30_U_SMXP_4_1, REGION30_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR30_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR30_U_SMXP_4_1, REGION30_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR30_U_SMXP_4_1, REGION30_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR30_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR30_U_SMXP_4_1, 0x213d1f8)
    FIELD(POR_MPU_M0_PRLAR30_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR30_U_SMXP_4_1, REGION30_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR30_U_SMXP_4_1, REGION30_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR31_U_SMXP_4_1, 0x213d200)
    FIELD(POR_MPU_M0_PRBAR31_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR31_U_SMXP_4_1, REGION31_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR31_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR31_U_SMXP_4_1, REGION31_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR31_U_SMXP_4_1, REGION31_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR31_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR31_U_SMXP_4_1, 0x213d208)
    FIELD(POR_MPU_M0_PRLAR31_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR31_U_SMXP_4_1, REGION31_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR31_U_SMXP_4_1, REGION31_EN, 0, 1)
REG32(POR_MPU_M1_CTL_U_SMXP_4_1, 0x213d400)
    FIELD(POR_MPU_M1_CTL_U_SMXP_4_1, M1_EN, 2, 1)
    FIELD(POR_MPU_M1_CTL_U_SMXP_4_1, M1_ACTION, 0, 2)
REG32(POR_MPU_M1_PRBAR0_U_SMXP_4_1, 0x213d410)
    FIELD(POR_MPU_M1_PRBAR0_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR0_U_SMXP_4_1, REGION0_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR0_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR0_U_SMXP_4_1, REGION0_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR0_U_SMXP_4_1, REGION0_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR0_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR0_U_SMXP_4_1, 0x213d418)
    FIELD(POR_MPU_M1_PRLAR0_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR0_U_SMXP_4_1, REGION0_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR0_U_SMXP_4_1, REGION0_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR1_U_SMXP_4_1, 0x213d420)
    FIELD(POR_MPU_M1_PRBAR1_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR1_U_SMXP_4_1, REGION1_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR1_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR1_U_SMXP_4_1, REGION1_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR1_U_SMXP_4_1, REGION1_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR1_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR1_U_SMXP_4_1, 0x213d428)
    FIELD(POR_MPU_M1_PRLAR1_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR1_U_SMXP_4_1, REGION1_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR1_U_SMXP_4_1, REGION1_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR2_U_SMXP_4_1, 0x213d430)
    FIELD(POR_MPU_M1_PRBAR2_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR2_U_SMXP_4_1, REGION2_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR2_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR2_U_SMXP_4_1, REGION2_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR2_U_SMXP_4_1, REGION2_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR2_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR2_U_SMXP_4_1, 0x213d438)
    FIELD(POR_MPU_M1_PRLAR2_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR2_U_SMXP_4_1, REGION2_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR2_U_SMXP_4_1, REGION2_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR3_U_SMXP_4_1, 0x213d440)
    FIELD(POR_MPU_M1_PRBAR3_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR3_U_SMXP_4_1, REGION3_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR3_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR3_U_SMXP_4_1, REGION3_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR3_U_SMXP_4_1, REGION3_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR3_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR3_U_SMXP_4_1, 0x213d448)
    FIELD(POR_MPU_M1_PRLAR3_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR3_U_SMXP_4_1, REGION3_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR3_U_SMXP_4_1, REGION3_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR4_U_SMXP_4_1, 0x213d450)
    FIELD(POR_MPU_M1_PRBAR4_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR4_U_SMXP_4_1, REGION4_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR4_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR4_U_SMXP_4_1, REGION4_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR4_U_SMXP_4_1, REGION4_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR4_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR4_U_SMXP_4_1, 0x213d458)
    FIELD(POR_MPU_M1_PRLAR4_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR4_U_SMXP_4_1, REGION4_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR4_U_SMXP_4_1, REGION4_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR5_U_SMXP_4_1, 0x213d460)
    FIELD(POR_MPU_M1_PRBAR5_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR5_U_SMXP_4_1, REGION5_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR5_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR5_U_SMXP_4_1, REGION5_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR5_U_SMXP_4_1, REGION5_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR5_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR5_U_SMXP_4_1, 0x213d468)
    FIELD(POR_MPU_M1_PRLAR5_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR5_U_SMXP_4_1, REGION5_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR5_U_SMXP_4_1, REGION5_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR6_U_SMXP_4_1, 0x213d470)
    FIELD(POR_MPU_M1_PRBAR6_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR6_U_SMXP_4_1, REGION6_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR6_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR6_U_SMXP_4_1, REGION6_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR6_U_SMXP_4_1, REGION6_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR6_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR6_U_SMXP_4_1, 0x213d478)
    FIELD(POR_MPU_M1_PRLAR6_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR6_U_SMXP_4_1, REGION6_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR6_U_SMXP_4_1, REGION6_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR7_U_SMXP_4_1, 0x213d480)
    FIELD(POR_MPU_M1_PRBAR7_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR7_U_SMXP_4_1, REGION7_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR7_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR7_U_SMXP_4_1, REGION7_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR7_U_SMXP_4_1, REGION7_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR7_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR7_U_SMXP_4_1, 0x213d488)
    FIELD(POR_MPU_M1_PRLAR7_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR7_U_SMXP_4_1, REGION7_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR7_U_SMXP_4_1, REGION7_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR8_U_SMXP_4_1, 0x213d490)
    FIELD(POR_MPU_M1_PRBAR8_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR8_U_SMXP_4_1, REGION8_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR8_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR8_U_SMXP_4_1, REGION8_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR8_U_SMXP_4_1, REGION8_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR8_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR8_U_SMXP_4_1, 0x213d498)
    FIELD(POR_MPU_M1_PRLAR8_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR8_U_SMXP_4_1, REGION8_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR8_U_SMXP_4_1, REGION8_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR9_U_SMXP_4_1, 0x213d4a0)
    FIELD(POR_MPU_M1_PRBAR9_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR9_U_SMXP_4_1, REGION9_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR9_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR9_U_SMXP_4_1, REGION9_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR9_U_SMXP_4_1, REGION9_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR9_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR9_U_SMXP_4_1, 0x213d4a8)
    FIELD(POR_MPU_M1_PRLAR9_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR9_U_SMXP_4_1, REGION9_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR9_U_SMXP_4_1, REGION9_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR10_U_SMXP_4_1, 0x213d4b0)
    FIELD(POR_MPU_M1_PRBAR10_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR10_U_SMXP_4_1, REGION10_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR10_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR10_U_SMXP_4_1, REGION10_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR10_U_SMXP_4_1, REGION10_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR10_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR10_U_SMXP_4_1, 0x213d4b8)
    FIELD(POR_MPU_M1_PRLAR10_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR10_U_SMXP_4_1, REGION10_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR10_U_SMXP_4_1, REGION10_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR11_U_SMXP_4_1, 0x213d4c0)
    FIELD(POR_MPU_M1_PRBAR11_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR11_U_SMXP_4_1, REGION11_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR11_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR11_U_SMXP_4_1, REGION11_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR11_U_SMXP_4_1, REGION11_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR11_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR11_U_SMXP_4_1, 0x213d4c8)
    FIELD(POR_MPU_M1_PRLAR11_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR11_U_SMXP_4_1, REGION11_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR11_U_SMXP_4_1, REGION11_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR12_U_SMXP_4_1, 0x213d4d0)
    FIELD(POR_MPU_M1_PRBAR12_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR12_U_SMXP_4_1, REGION12_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR12_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR12_U_SMXP_4_1, REGION12_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR12_U_SMXP_4_1, REGION12_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR12_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR12_U_SMXP_4_1, 0x213d4d8)
    FIELD(POR_MPU_M1_PRLAR12_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR12_U_SMXP_4_1, REGION12_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR12_U_SMXP_4_1, REGION12_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR13_U_SMXP_4_1, 0x213d4e0)
    FIELD(POR_MPU_M1_PRBAR13_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR13_U_SMXP_4_1, REGION13_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR13_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR13_U_SMXP_4_1, REGION13_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR13_U_SMXP_4_1, REGION13_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR13_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR13_U_SMXP_4_1, 0x213d4e8)
    FIELD(POR_MPU_M1_PRLAR13_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR13_U_SMXP_4_1, REGION13_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR13_U_SMXP_4_1, REGION13_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR14_U_SMXP_4_1, 0x213d4f0)
    FIELD(POR_MPU_M1_PRBAR14_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR14_U_SMXP_4_1, REGION14_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR14_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR14_U_SMXP_4_1, REGION14_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR14_U_SMXP_4_1, REGION14_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR14_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR14_U_SMXP_4_1, 0x213d4f8)
    FIELD(POR_MPU_M1_PRLAR14_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR14_U_SMXP_4_1, REGION14_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR14_U_SMXP_4_1, REGION14_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR15_U_SMXP_4_1, 0x213d500)
    FIELD(POR_MPU_M1_PRBAR15_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR15_U_SMXP_4_1, REGION15_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR15_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR15_U_SMXP_4_1, REGION15_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR15_U_SMXP_4_1, REGION15_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR15_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR15_U_SMXP_4_1, 0x213d508)
    FIELD(POR_MPU_M1_PRLAR15_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR15_U_SMXP_4_1, REGION15_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR15_U_SMXP_4_1, REGION15_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR16_U_SMXP_4_1, 0x213d510)
    FIELD(POR_MPU_M1_PRBAR16_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR16_U_SMXP_4_1, REGION16_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR16_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR16_U_SMXP_4_1, REGION16_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR16_U_SMXP_4_1, REGION16_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR16_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR16_U_SMXP_4_1, 0x213d518)
    FIELD(POR_MPU_M1_PRLAR16_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR16_U_SMXP_4_1, REGION16_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR16_U_SMXP_4_1, REGION16_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR17_U_SMXP_4_1, 0x213d520)
    FIELD(POR_MPU_M1_PRBAR17_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR17_U_SMXP_4_1, REGION17_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR17_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR17_U_SMXP_4_1, REGION17_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR17_U_SMXP_4_1, REGION17_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR17_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR17_U_SMXP_4_1, 0x213d528)
    FIELD(POR_MPU_M1_PRLAR17_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR17_U_SMXP_4_1, REGION17_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR17_U_SMXP_4_1, REGION17_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR18_U_SMXP_4_1, 0x213d530)
    FIELD(POR_MPU_M1_PRBAR18_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR18_U_SMXP_4_1, REGION18_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR18_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR18_U_SMXP_4_1, REGION18_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR18_U_SMXP_4_1, REGION18_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR18_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR18_U_SMXP_4_1, 0x213d538)
    FIELD(POR_MPU_M1_PRLAR18_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR18_U_SMXP_4_1, REGION18_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR18_U_SMXP_4_1, REGION18_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR19_U_SMXP_4_1, 0x213d540)
    FIELD(POR_MPU_M1_PRBAR19_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR19_U_SMXP_4_1, REGION19_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR19_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR19_U_SMXP_4_1, REGION19_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR19_U_SMXP_4_1, REGION19_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR19_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR19_U_SMXP_4_1, 0x213d548)
    FIELD(POR_MPU_M1_PRLAR19_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR19_U_SMXP_4_1, REGION19_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR19_U_SMXP_4_1, REGION19_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR20_U_SMXP_4_1, 0x213d550)
    FIELD(POR_MPU_M1_PRBAR20_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR20_U_SMXP_4_1, REGION20_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR20_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR20_U_SMXP_4_1, REGION20_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR20_U_SMXP_4_1, REGION20_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR20_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR20_U_SMXP_4_1, 0x213d558)
    FIELD(POR_MPU_M1_PRLAR20_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR20_U_SMXP_4_1, REGION20_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR20_U_SMXP_4_1, REGION20_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR21_U_SMXP_4_1, 0x213d560)
    FIELD(POR_MPU_M1_PRBAR21_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR21_U_SMXP_4_1, REGION21_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR21_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR21_U_SMXP_4_1, REGION21_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR21_U_SMXP_4_1, REGION21_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR21_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR21_U_SMXP_4_1, 0x213d568)
    FIELD(POR_MPU_M1_PRLAR21_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR21_U_SMXP_4_1, REGION21_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR21_U_SMXP_4_1, REGION21_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR22_U_SMXP_4_1, 0x213d570)
    FIELD(POR_MPU_M1_PRBAR22_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR22_U_SMXP_4_1, REGION22_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR22_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR22_U_SMXP_4_1, REGION22_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR22_U_SMXP_4_1, REGION22_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR22_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR22_U_SMXP_4_1, 0x213d578)
    FIELD(POR_MPU_M1_PRLAR22_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR22_U_SMXP_4_1, REGION22_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR22_U_SMXP_4_1, REGION22_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR23_U_SMXP_4_1, 0x213d580)
    FIELD(POR_MPU_M1_PRBAR23_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR23_U_SMXP_4_1, REGION23_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR23_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR23_U_SMXP_4_1, REGION23_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR23_U_SMXP_4_1, REGION23_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR23_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR23_U_SMXP_4_1, 0x213d588)
    FIELD(POR_MPU_M1_PRLAR23_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR23_U_SMXP_4_1, REGION23_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR23_U_SMXP_4_1, REGION23_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR24_U_SMXP_4_1, 0x213d590)
    FIELD(POR_MPU_M1_PRBAR24_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR24_U_SMXP_4_1, REGION24_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR24_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR24_U_SMXP_4_1, REGION24_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR24_U_SMXP_4_1, REGION24_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR24_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR24_U_SMXP_4_1, 0x213d598)
    FIELD(POR_MPU_M1_PRLAR24_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR24_U_SMXP_4_1, REGION24_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR24_U_SMXP_4_1, REGION24_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR25_U_SMXP_4_1, 0x213d5a0)
    FIELD(POR_MPU_M1_PRBAR25_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR25_U_SMXP_4_1, REGION25_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR25_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR25_U_SMXP_4_1, REGION25_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR25_U_SMXP_4_1, REGION25_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR25_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR25_U_SMXP_4_1, 0x213d5a8)
    FIELD(POR_MPU_M1_PRLAR25_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR25_U_SMXP_4_1, REGION25_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR25_U_SMXP_4_1, REGION25_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR26_U_SMXP_4_1, 0x213d5b0)
    FIELD(POR_MPU_M1_PRBAR26_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR26_U_SMXP_4_1, REGION26_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR26_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR26_U_SMXP_4_1, REGION26_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR26_U_SMXP_4_1, REGION26_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR26_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR26_U_SMXP_4_1, 0x213d5b8)
    FIELD(POR_MPU_M1_PRLAR26_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR26_U_SMXP_4_1, REGION26_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR26_U_SMXP_4_1, REGION26_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR27_U_SMXP_4_1, 0x213d5c0)
    FIELD(POR_MPU_M1_PRBAR27_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR27_U_SMXP_4_1, REGION27_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR27_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR27_U_SMXP_4_1, REGION27_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR27_U_SMXP_4_1, REGION27_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR27_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR27_U_SMXP_4_1, 0x213d5c8)
    FIELD(POR_MPU_M1_PRLAR27_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR27_U_SMXP_4_1, REGION27_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR27_U_SMXP_4_1, REGION27_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR28_U_SMXP_4_1, 0x213d5d0)
    FIELD(POR_MPU_M1_PRBAR28_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR28_U_SMXP_4_1, REGION28_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR28_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR28_U_SMXP_4_1, REGION28_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR28_U_SMXP_4_1, REGION28_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR28_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR28_U_SMXP_4_1, 0x213d5d8)
    FIELD(POR_MPU_M1_PRLAR28_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR28_U_SMXP_4_1, REGION28_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR28_U_SMXP_4_1, REGION28_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR29_U_SMXP_4_1, 0x213d5e0)
    FIELD(POR_MPU_M1_PRBAR29_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR29_U_SMXP_4_1, REGION29_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR29_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR29_U_SMXP_4_1, REGION29_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR29_U_SMXP_4_1, REGION29_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR29_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR29_U_SMXP_4_1, 0x213d5e8)
    FIELD(POR_MPU_M1_PRLAR29_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR29_U_SMXP_4_1, REGION29_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR29_U_SMXP_4_1, REGION29_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR30_U_SMXP_4_1, 0x213d5f0)
    FIELD(POR_MPU_M1_PRBAR30_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR30_U_SMXP_4_1, REGION30_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR30_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR30_U_SMXP_4_1, REGION30_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR30_U_SMXP_4_1, REGION30_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR30_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR30_U_SMXP_4_1, 0x213d5f8)
    FIELD(POR_MPU_M1_PRLAR30_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR30_U_SMXP_4_1, REGION30_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR30_U_SMXP_4_1, REGION30_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR31_U_SMXP_4_1, 0x213d600)
    FIELD(POR_MPU_M1_PRBAR31_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR31_U_SMXP_4_1, REGION31_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR31_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR31_U_SMXP_4_1, REGION31_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR31_U_SMXP_4_1, REGION31_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR31_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR31_U_SMXP_4_1, 0x213d608)
    FIELD(POR_MPU_M1_PRLAR31_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR31_U_SMXP_4_1, REGION31_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR31_U_SMXP_4_1, REGION31_EN, 0, 1)
REG32(POR_MPU_M2_CTL_U_SMXP_4_1, 0x213d800)
    FIELD(POR_MPU_M2_CTL_U_SMXP_4_1, M2_EN, 2, 1)
    FIELD(POR_MPU_M2_CTL_U_SMXP_4_1, M2_ACTION, 0, 2)
REG32(POR_MPU_M2_PRBAR0_U_SMXP_4_1, 0x213d810)
    FIELD(POR_MPU_M2_PRBAR0_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR0_U_SMXP_4_1, REGION0_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR0_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR0_U_SMXP_4_1, REGION0_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR0_U_SMXP_4_1, REGION0_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR0_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR0_U_SMXP_4_1, 0x213d818)
    FIELD(POR_MPU_M2_PRLAR0_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR0_U_SMXP_4_1, REGION0_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR0_U_SMXP_4_1, REGION0_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR1_U_SMXP_4_1, 0x213d820)
    FIELD(POR_MPU_M2_PRBAR1_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR1_U_SMXP_4_1, REGION1_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR1_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR1_U_SMXP_4_1, REGION1_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR1_U_SMXP_4_1, REGION1_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR1_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR1_U_SMXP_4_1, 0x213d828)
    FIELD(POR_MPU_M2_PRLAR1_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR1_U_SMXP_4_1, REGION1_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR1_U_SMXP_4_1, REGION1_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR2_U_SMXP_4_1, 0x213d830)
    FIELD(POR_MPU_M2_PRBAR2_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR2_U_SMXP_4_1, REGION2_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR2_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR2_U_SMXP_4_1, REGION2_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR2_U_SMXP_4_1, REGION2_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR2_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR2_U_SMXP_4_1, 0x213d838)
    FIELD(POR_MPU_M2_PRLAR2_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR2_U_SMXP_4_1, REGION2_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR2_U_SMXP_4_1, REGION2_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR3_U_SMXP_4_1, 0x213d840)
    FIELD(POR_MPU_M2_PRBAR3_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR3_U_SMXP_4_1, REGION3_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR3_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR3_U_SMXP_4_1, REGION3_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR3_U_SMXP_4_1, REGION3_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR3_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR3_U_SMXP_4_1, 0x213d848)
    FIELD(POR_MPU_M2_PRLAR3_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR3_U_SMXP_4_1, REGION3_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR3_U_SMXP_4_1, REGION3_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR4_U_SMXP_4_1, 0x213d850)
    FIELD(POR_MPU_M2_PRBAR4_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR4_U_SMXP_4_1, REGION4_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR4_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR4_U_SMXP_4_1, REGION4_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR4_U_SMXP_4_1, REGION4_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR4_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR4_U_SMXP_4_1, 0x213d858)
    FIELD(POR_MPU_M2_PRLAR4_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR4_U_SMXP_4_1, REGION4_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR4_U_SMXP_4_1, REGION4_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR5_U_SMXP_4_1, 0x213d860)
    FIELD(POR_MPU_M2_PRBAR5_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR5_U_SMXP_4_1, REGION5_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR5_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR5_U_SMXP_4_1, REGION5_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR5_U_SMXP_4_1, REGION5_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR5_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR5_U_SMXP_4_1, 0x213d868)
    FIELD(POR_MPU_M2_PRLAR5_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR5_U_SMXP_4_1, REGION5_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR5_U_SMXP_4_1, REGION5_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR6_U_SMXP_4_1, 0x213d870)
    FIELD(POR_MPU_M2_PRBAR6_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR6_U_SMXP_4_1, REGION6_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR6_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR6_U_SMXP_4_1, REGION6_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR6_U_SMXP_4_1, REGION6_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR6_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR6_U_SMXP_4_1, 0x213d878)
    FIELD(POR_MPU_M2_PRLAR6_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR6_U_SMXP_4_1, REGION6_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR6_U_SMXP_4_1, REGION6_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR7_U_SMXP_4_1, 0x213d880)
    FIELD(POR_MPU_M2_PRBAR7_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR7_U_SMXP_4_1, REGION7_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR7_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR7_U_SMXP_4_1, REGION7_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR7_U_SMXP_4_1, REGION7_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR7_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR7_U_SMXP_4_1, 0x213d888)
    FIELD(POR_MPU_M2_PRLAR7_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR7_U_SMXP_4_1, REGION7_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR7_U_SMXP_4_1, REGION7_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR8_U_SMXP_4_1, 0x213d890)
    FIELD(POR_MPU_M2_PRBAR8_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR8_U_SMXP_4_1, REGION8_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR8_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR8_U_SMXP_4_1, REGION8_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR8_U_SMXP_4_1, REGION8_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR8_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR8_U_SMXP_4_1, 0x213d898)
    FIELD(POR_MPU_M2_PRLAR8_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR8_U_SMXP_4_1, REGION8_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR8_U_SMXP_4_1, REGION8_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR9_U_SMXP_4_1, 0x213d8a0)
    FIELD(POR_MPU_M2_PRBAR9_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR9_U_SMXP_4_1, REGION9_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR9_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR9_U_SMXP_4_1, REGION9_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR9_U_SMXP_4_1, REGION9_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR9_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR9_U_SMXP_4_1, 0x213d8a8)
    FIELD(POR_MPU_M2_PRLAR9_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR9_U_SMXP_4_1, REGION9_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR9_U_SMXP_4_1, REGION9_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR10_U_SMXP_4_1, 0x213d8b0)
    FIELD(POR_MPU_M2_PRBAR10_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR10_U_SMXP_4_1, REGION10_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR10_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR10_U_SMXP_4_1, REGION10_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR10_U_SMXP_4_1, REGION10_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR10_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR10_U_SMXP_4_1, 0x213d8b8)
    FIELD(POR_MPU_M2_PRLAR10_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR10_U_SMXP_4_1, REGION10_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR10_U_SMXP_4_1, REGION10_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR11_U_SMXP_4_1, 0x213d8c0)
    FIELD(POR_MPU_M2_PRBAR11_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR11_U_SMXP_4_1, REGION11_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR11_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR11_U_SMXP_4_1, REGION11_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR11_U_SMXP_4_1, REGION11_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR11_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR11_U_SMXP_4_1, 0x213d8c8)
    FIELD(POR_MPU_M2_PRLAR11_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR11_U_SMXP_4_1, REGION11_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR11_U_SMXP_4_1, REGION11_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR12_U_SMXP_4_1, 0x213d8d0)
    FIELD(POR_MPU_M2_PRBAR12_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR12_U_SMXP_4_1, REGION12_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR12_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR12_U_SMXP_4_1, REGION12_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR12_U_SMXP_4_1, REGION12_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR12_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR12_U_SMXP_4_1, 0x213d8d8)
    FIELD(POR_MPU_M2_PRLAR12_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR12_U_SMXP_4_1, REGION12_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR12_U_SMXP_4_1, REGION12_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR13_U_SMXP_4_1, 0x213d8e0)
    FIELD(POR_MPU_M2_PRBAR13_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR13_U_SMXP_4_1, REGION13_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR13_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR13_U_SMXP_4_1, REGION13_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR13_U_SMXP_4_1, REGION13_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR13_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR13_U_SMXP_4_1, 0x213d8e8)
    FIELD(POR_MPU_M2_PRLAR13_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR13_U_SMXP_4_1, REGION13_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR13_U_SMXP_4_1, REGION13_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR14_U_SMXP_4_1, 0x213d8f0)
    FIELD(POR_MPU_M2_PRBAR14_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR14_U_SMXP_4_1, REGION14_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR14_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR14_U_SMXP_4_1, REGION14_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR14_U_SMXP_4_1, REGION14_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR14_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR14_U_SMXP_4_1, 0x213d8f8)
    FIELD(POR_MPU_M2_PRLAR14_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR14_U_SMXP_4_1, REGION14_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR14_U_SMXP_4_1, REGION14_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR15_U_SMXP_4_1, 0x213d900)
    FIELD(POR_MPU_M2_PRBAR15_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR15_U_SMXP_4_1, REGION15_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR15_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR15_U_SMXP_4_1, REGION15_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR15_U_SMXP_4_1, REGION15_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR15_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR15_U_SMXP_4_1, 0x213d908)
    FIELD(POR_MPU_M2_PRLAR15_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR15_U_SMXP_4_1, REGION15_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR15_U_SMXP_4_1, REGION15_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR16_U_SMXP_4_1, 0x213d910)
    FIELD(POR_MPU_M2_PRBAR16_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR16_U_SMXP_4_1, REGION16_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR16_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR16_U_SMXP_4_1, REGION16_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR16_U_SMXP_4_1, REGION16_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR16_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR16_U_SMXP_4_1, 0x213d918)
    FIELD(POR_MPU_M2_PRLAR16_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR16_U_SMXP_4_1, REGION16_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR16_U_SMXP_4_1, REGION16_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR17_U_SMXP_4_1, 0x213d920)
    FIELD(POR_MPU_M2_PRBAR17_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR17_U_SMXP_4_1, REGION17_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR17_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR17_U_SMXP_4_1, REGION17_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR17_U_SMXP_4_1, REGION17_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR17_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR17_U_SMXP_4_1, 0x213d928)
    FIELD(POR_MPU_M2_PRLAR17_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR17_U_SMXP_4_1, REGION17_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR17_U_SMXP_4_1, REGION17_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR18_U_SMXP_4_1, 0x213d930)
    FIELD(POR_MPU_M2_PRBAR18_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR18_U_SMXP_4_1, REGION18_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR18_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR18_U_SMXP_4_1, REGION18_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR18_U_SMXP_4_1, REGION18_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR18_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR18_U_SMXP_4_1, 0x213d938)
    FIELD(POR_MPU_M2_PRLAR18_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR18_U_SMXP_4_1, REGION18_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR18_U_SMXP_4_1, REGION18_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR19_U_SMXP_4_1, 0x213d940)
    FIELD(POR_MPU_M2_PRBAR19_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR19_U_SMXP_4_1, REGION19_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR19_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR19_U_SMXP_4_1, REGION19_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR19_U_SMXP_4_1, REGION19_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR19_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR19_U_SMXP_4_1, 0x213d948)
    FIELD(POR_MPU_M2_PRLAR19_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR19_U_SMXP_4_1, REGION19_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR19_U_SMXP_4_1, REGION19_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR20_U_SMXP_4_1, 0x213d950)
    FIELD(POR_MPU_M2_PRBAR20_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR20_U_SMXP_4_1, REGION20_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR20_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR20_U_SMXP_4_1, REGION20_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR20_U_SMXP_4_1, REGION20_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR20_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR20_U_SMXP_4_1, 0x213d958)
    FIELD(POR_MPU_M2_PRLAR20_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR20_U_SMXP_4_1, REGION20_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR20_U_SMXP_4_1, REGION20_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR21_U_SMXP_4_1, 0x213d960)
    FIELD(POR_MPU_M2_PRBAR21_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR21_U_SMXP_4_1, REGION21_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR21_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR21_U_SMXP_4_1, REGION21_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR21_U_SMXP_4_1, REGION21_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR21_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR21_U_SMXP_4_1, 0x213d968)
    FIELD(POR_MPU_M2_PRLAR21_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR21_U_SMXP_4_1, REGION21_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR21_U_SMXP_4_1, REGION21_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR22_U_SMXP_4_1, 0x213d970)
    FIELD(POR_MPU_M2_PRBAR22_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR22_U_SMXP_4_1, REGION22_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR22_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR22_U_SMXP_4_1, REGION22_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR22_U_SMXP_4_1, REGION22_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR22_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR22_U_SMXP_4_1, 0x213d978)
    FIELD(POR_MPU_M2_PRLAR22_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR22_U_SMXP_4_1, REGION22_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR22_U_SMXP_4_1, REGION22_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR23_U_SMXP_4_1, 0x213d980)
    FIELD(POR_MPU_M2_PRBAR23_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR23_U_SMXP_4_1, REGION23_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR23_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR23_U_SMXP_4_1, REGION23_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR23_U_SMXP_4_1, REGION23_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR23_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR23_U_SMXP_4_1, 0x213d988)
    FIELD(POR_MPU_M2_PRLAR23_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR23_U_SMXP_4_1, REGION23_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR23_U_SMXP_4_1, REGION23_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR24_U_SMXP_4_1, 0x213d990)
    FIELD(POR_MPU_M2_PRBAR24_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR24_U_SMXP_4_1, REGION24_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR24_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR24_U_SMXP_4_1, REGION24_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR24_U_SMXP_4_1, REGION24_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR24_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR24_U_SMXP_4_1, 0x213d998)
    FIELD(POR_MPU_M2_PRLAR24_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR24_U_SMXP_4_1, REGION24_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR24_U_SMXP_4_1, REGION24_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR25_U_SMXP_4_1, 0x213d9a0)
    FIELD(POR_MPU_M2_PRBAR25_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR25_U_SMXP_4_1, REGION25_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR25_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR25_U_SMXP_4_1, REGION25_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR25_U_SMXP_4_1, REGION25_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR25_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR25_U_SMXP_4_1, 0x213d9a8)
    FIELD(POR_MPU_M2_PRLAR25_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR25_U_SMXP_4_1, REGION25_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR25_U_SMXP_4_1, REGION25_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR26_U_SMXP_4_1, 0x213d9b0)
    FIELD(POR_MPU_M2_PRBAR26_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR26_U_SMXP_4_1, REGION26_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR26_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR26_U_SMXP_4_1, REGION26_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR26_U_SMXP_4_1, REGION26_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR26_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR26_U_SMXP_4_1, 0x213d9b8)
    FIELD(POR_MPU_M2_PRLAR26_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR26_U_SMXP_4_1, REGION26_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR26_U_SMXP_4_1, REGION26_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR27_U_SMXP_4_1, 0x213d9c0)
    FIELD(POR_MPU_M2_PRBAR27_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR27_U_SMXP_4_1, REGION27_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR27_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR27_U_SMXP_4_1, REGION27_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR27_U_SMXP_4_1, REGION27_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR27_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR27_U_SMXP_4_1, 0x213d9c8)
    FIELD(POR_MPU_M2_PRLAR27_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR27_U_SMXP_4_1, REGION27_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR27_U_SMXP_4_1, REGION27_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR28_U_SMXP_4_1, 0x213d9d0)
    FIELD(POR_MPU_M2_PRBAR28_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR28_U_SMXP_4_1, REGION28_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR28_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR28_U_SMXP_4_1, REGION28_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR28_U_SMXP_4_1, REGION28_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR28_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR28_U_SMXP_4_1, 0x213d9d8)
    FIELD(POR_MPU_M2_PRLAR28_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR28_U_SMXP_4_1, REGION28_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR28_U_SMXP_4_1, REGION28_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR29_U_SMXP_4_1, 0x213d9e0)
    FIELD(POR_MPU_M2_PRBAR29_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR29_U_SMXP_4_1, REGION29_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR29_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR29_U_SMXP_4_1, REGION29_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR29_U_SMXP_4_1, REGION29_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR29_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR29_U_SMXP_4_1, 0x213d9e8)
    FIELD(POR_MPU_M2_PRLAR29_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR29_U_SMXP_4_1, REGION29_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR29_U_SMXP_4_1, REGION29_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR30_U_SMXP_4_1, 0x213d9f0)
    FIELD(POR_MPU_M2_PRBAR30_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR30_U_SMXP_4_1, REGION30_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR30_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR30_U_SMXP_4_1, REGION30_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR30_U_SMXP_4_1, REGION30_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR30_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR30_U_SMXP_4_1, 0x213d9f8)
    FIELD(POR_MPU_M2_PRLAR30_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR30_U_SMXP_4_1, REGION30_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR30_U_SMXP_4_1, REGION30_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR31_U_SMXP_4_1, 0x213da00)
    FIELD(POR_MPU_M2_PRBAR31_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR31_U_SMXP_4_1, REGION31_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR31_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR31_U_SMXP_4_1, REGION31_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR31_U_SMXP_4_1, REGION31_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR31_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR31_U_SMXP_4_1, 0x213da08)
    FIELD(POR_MPU_M2_PRLAR31_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR31_U_SMXP_4_1, REGION31_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR31_U_SMXP_4_1, REGION31_EN, 0, 1)
REG32(POR_MPU_M3_CTL_U_SMXP_4_1, 0x213dc00)
    FIELD(POR_MPU_M3_CTL_U_SMXP_4_1, M3_EN, 2, 1)
    FIELD(POR_MPU_M3_CTL_U_SMXP_4_1, M3_ACTION, 0, 2)
REG32(POR_MPU_M3_PRBAR0_U_SMXP_4_1, 0x213dc10)
    FIELD(POR_MPU_M3_PRBAR0_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR0_U_SMXP_4_1, REGION0_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR0_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR0_U_SMXP_4_1, REGION0_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR0_U_SMXP_4_1, REGION0_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR0_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR0_U_SMXP_4_1, 0x213dc18)
    FIELD(POR_MPU_M3_PRLAR0_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR0_U_SMXP_4_1, REGION0_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR0_U_SMXP_4_1, REGION0_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR1_U_SMXP_4_1, 0x213dc20)
    FIELD(POR_MPU_M3_PRBAR1_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR1_U_SMXP_4_1, REGION1_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR1_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR1_U_SMXP_4_1, REGION1_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR1_U_SMXP_4_1, REGION1_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR1_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR1_U_SMXP_4_1, 0x213dc28)
    FIELD(POR_MPU_M3_PRLAR1_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR1_U_SMXP_4_1, REGION1_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR1_U_SMXP_4_1, REGION1_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR2_U_SMXP_4_1, 0x213dc30)
    FIELD(POR_MPU_M3_PRBAR2_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR2_U_SMXP_4_1, REGION2_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR2_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR2_U_SMXP_4_1, REGION2_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR2_U_SMXP_4_1, REGION2_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR2_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR2_U_SMXP_4_1, 0x213dc38)
    FIELD(POR_MPU_M3_PRLAR2_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR2_U_SMXP_4_1, REGION2_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR2_U_SMXP_4_1, REGION2_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR3_U_SMXP_4_1, 0x213dc40)
    FIELD(POR_MPU_M3_PRBAR3_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR3_U_SMXP_4_1, REGION3_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR3_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR3_U_SMXP_4_1, REGION3_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR3_U_SMXP_4_1, REGION3_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR3_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR3_U_SMXP_4_1, 0x213dc48)
    FIELD(POR_MPU_M3_PRLAR3_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR3_U_SMXP_4_1, REGION3_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR3_U_SMXP_4_1, REGION3_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR4_U_SMXP_4_1, 0x213dc50)
    FIELD(POR_MPU_M3_PRBAR4_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR4_U_SMXP_4_1, REGION4_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR4_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR4_U_SMXP_4_1, REGION4_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR4_U_SMXP_4_1, REGION4_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR4_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR4_U_SMXP_4_1, 0x213dc58)
    FIELD(POR_MPU_M3_PRLAR4_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR4_U_SMXP_4_1, REGION4_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR4_U_SMXP_4_1, REGION4_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR5_U_SMXP_4_1, 0x213dc60)
    FIELD(POR_MPU_M3_PRBAR5_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR5_U_SMXP_4_1, REGION5_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR5_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR5_U_SMXP_4_1, REGION5_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR5_U_SMXP_4_1, REGION5_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR5_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR5_U_SMXP_4_1, 0x213dc68)
    FIELD(POR_MPU_M3_PRLAR5_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR5_U_SMXP_4_1, REGION5_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR5_U_SMXP_4_1, REGION5_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR6_U_SMXP_4_1, 0x213dc70)
    FIELD(POR_MPU_M3_PRBAR6_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR6_U_SMXP_4_1, REGION6_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR6_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR6_U_SMXP_4_1, REGION6_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR6_U_SMXP_4_1, REGION6_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR6_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR6_U_SMXP_4_1, 0x213dc78)
    FIELD(POR_MPU_M3_PRLAR6_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR6_U_SMXP_4_1, REGION6_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR6_U_SMXP_4_1, REGION6_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR7_U_SMXP_4_1, 0x213dc80)
    FIELD(POR_MPU_M3_PRBAR7_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR7_U_SMXP_4_1, REGION7_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR7_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR7_U_SMXP_4_1, REGION7_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR7_U_SMXP_4_1, REGION7_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR7_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR7_U_SMXP_4_1, 0x213dc88)
    FIELD(POR_MPU_M3_PRLAR7_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR7_U_SMXP_4_1, REGION7_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR7_U_SMXP_4_1, REGION7_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR8_U_SMXP_4_1, 0x213dc90)
    FIELD(POR_MPU_M3_PRBAR8_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR8_U_SMXP_4_1, REGION8_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR8_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR8_U_SMXP_4_1, REGION8_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR8_U_SMXP_4_1, REGION8_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR8_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR8_U_SMXP_4_1, 0x213dc98)
    FIELD(POR_MPU_M3_PRLAR8_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR8_U_SMXP_4_1, REGION8_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR8_U_SMXP_4_1, REGION8_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR9_U_SMXP_4_1, 0x213dca0)
    FIELD(POR_MPU_M3_PRBAR9_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR9_U_SMXP_4_1, REGION9_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR9_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR9_U_SMXP_4_1, REGION9_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR9_U_SMXP_4_1, REGION9_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR9_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR9_U_SMXP_4_1, 0x213dca8)
    FIELD(POR_MPU_M3_PRLAR9_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR9_U_SMXP_4_1, REGION9_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR9_U_SMXP_4_1, REGION9_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR10_U_SMXP_4_1, 0x213dcb0)
    FIELD(POR_MPU_M3_PRBAR10_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR10_U_SMXP_4_1, REGION10_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR10_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR10_U_SMXP_4_1, REGION10_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR10_U_SMXP_4_1, REGION10_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR10_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR10_U_SMXP_4_1, 0x213dcb8)
    FIELD(POR_MPU_M3_PRLAR10_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR10_U_SMXP_4_1, REGION10_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR10_U_SMXP_4_1, REGION10_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR11_U_SMXP_4_1, 0x213dcc0)
    FIELD(POR_MPU_M3_PRBAR11_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR11_U_SMXP_4_1, REGION11_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR11_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR11_U_SMXP_4_1, REGION11_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR11_U_SMXP_4_1, REGION11_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR11_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR11_U_SMXP_4_1, 0x213dcc8)
    FIELD(POR_MPU_M3_PRLAR11_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR11_U_SMXP_4_1, REGION11_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR11_U_SMXP_4_1, REGION11_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR12_U_SMXP_4_1, 0x213dcd0)
    FIELD(POR_MPU_M3_PRBAR12_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR12_U_SMXP_4_1, REGION12_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR12_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR12_U_SMXP_4_1, REGION12_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR12_U_SMXP_4_1, REGION12_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR12_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR12_U_SMXP_4_1, 0x213dcd8)
    FIELD(POR_MPU_M3_PRLAR12_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR12_U_SMXP_4_1, REGION12_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR12_U_SMXP_4_1, REGION12_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR13_U_SMXP_4_1, 0x213dce0)
    FIELD(POR_MPU_M3_PRBAR13_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR13_U_SMXP_4_1, REGION13_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR13_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR13_U_SMXP_4_1, REGION13_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR13_U_SMXP_4_1, REGION13_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR13_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR13_U_SMXP_4_1, 0x213dce8)
    FIELD(POR_MPU_M3_PRLAR13_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR13_U_SMXP_4_1, REGION13_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR13_U_SMXP_4_1, REGION13_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR14_U_SMXP_4_1, 0x213dcf0)
    FIELD(POR_MPU_M3_PRBAR14_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR14_U_SMXP_4_1, REGION14_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR14_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR14_U_SMXP_4_1, REGION14_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR14_U_SMXP_4_1, REGION14_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR14_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR14_U_SMXP_4_1, 0x213dcf8)
    FIELD(POR_MPU_M3_PRLAR14_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR14_U_SMXP_4_1, REGION14_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR14_U_SMXP_4_1, REGION14_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR15_U_SMXP_4_1, 0x213dd00)
    FIELD(POR_MPU_M3_PRBAR15_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR15_U_SMXP_4_1, REGION15_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR15_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR15_U_SMXP_4_1, REGION15_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR15_U_SMXP_4_1, REGION15_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR15_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR15_U_SMXP_4_1, 0x213dd08)
    FIELD(POR_MPU_M3_PRLAR15_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR15_U_SMXP_4_1, REGION15_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR15_U_SMXP_4_1, REGION15_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR16_U_SMXP_4_1, 0x213dd10)
    FIELD(POR_MPU_M3_PRBAR16_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR16_U_SMXP_4_1, REGION16_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR16_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR16_U_SMXP_4_1, REGION16_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR16_U_SMXP_4_1, REGION16_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR16_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR16_U_SMXP_4_1, 0x213dd18)
    FIELD(POR_MPU_M3_PRLAR16_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR16_U_SMXP_4_1, REGION16_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR16_U_SMXP_4_1, REGION16_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR17_U_SMXP_4_1, 0x213dd20)
    FIELD(POR_MPU_M3_PRBAR17_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR17_U_SMXP_4_1, REGION17_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR17_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR17_U_SMXP_4_1, REGION17_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR17_U_SMXP_4_1, REGION17_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR17_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR17_U_SMXP_4_1, 0x213dd28)
    FIELD(POR_MPU_M3_PRLAR17_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR17_U_SMXP_4_1, REGION17_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR17_U_SMXP_4_1, REGION17_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR18_U_SMXP_4_1, 0x213dd30)
    FIELD(POR_MPU_M3_PRBAR18_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR18_U_SMXP_4_1, REGION18_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR18_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR18_U_SMXP_4_1, REGION18_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR18_U_SMXP_4_1, REGION18_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR18_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR18_U_SMXP_4_1, 0x213dd38)
    FIELD(POR_MPU_M3_PRLAR18_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR18_U_SMXP_4_1, REGION18_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR18_U_SMXP_4_1, REGION18_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR19_U_SMXP_4_1, 0x213dd40)
    FIELD(POR_MPU_M3_PRBAR19_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR19_U_SMXP_4_1, REGION19_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR19_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR19_U_SMXP_4_1, REGION19_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR19_U_SMXP_4_1, REGION19_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR19_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR19_U_SMXP_4_1, 0x213dd48)
    FIELD(POR_MPU_M3_PRLAR19_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR19_U_SMXP_4_1, REGION19_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR19_U_SMXP_4_1, REGION19_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR20_U_SMXP_4_1, 0x213dd50)
    FIELD(POR_MPU_M3_PRBAR20_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR20_U_SMXP_4_1, REGION20_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR20_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR20_U_SMXP_4_1, REGION20_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR20_U_SMXP_4_1, REGION20_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR20_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR20_U_SMXP_4_1, 0x213dd58)
    FIELD(POR_MPU_M3_PRLAR20_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR20_U_SMXP_4_1, REGION20_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR20_U_SMXP_4_1, REGION20_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR21_U_SMXP_4_1, 0x213dd60)
    FIELD(POR_MPU_M3_PRBAR21_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR21_U_SMXP_4_1, REGION21_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR21_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR21_U_SMXP_4_1, REGION21_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR21_U_SMXP_4_1, REGION21_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR21_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR21_U_SMXP_4_1, 0x213dd68)
    FIELD(POR_MPU_M3_PRLAR21_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR21_U_SMXP_4_1, REGION21_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR21_U_SMXP_4_1, REGION21_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR22_U_SMXP_4_1, 0x213dd70)
    FIELD(POR_MPU_M3_PRBAR22_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR22_U_SMXP_4_1, REGION22_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR22_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR22_U_SMXP_4_1, REGION22_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR22_U_SMXP_4_1, REGION22_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR22_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR22_U_SMXP_4_1, 0x213dd78)
    FIELD(POR_MPU_M3_PRLAR22_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR22_U_SMXP_4_1, REGION22_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR22_U_SMXP_4_1, REGION22_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR23_U_SMXP_4_1, 0x213dd80)
    FIELD(POR_MPU_M3_PRBAR23_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR23_U_SMXP_4_1, REGION23_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR23_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR23_U_SMXP_4_1, REGION23_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR23_U_SMXP_4_1, REGION23_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR23_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR23_U_SMXP_4_1, 0x213dd88)
    FIELD(POR_MPU_M3_PRLAR23_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR23_U_SMXP_4_1, REGION23_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR23_U_SMXP_4_1, REGION23_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR24_U_SMXP_4_1, 0x213dd90)
    FIELD(POR_MPU_M3_PRBAR24_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR24_U_SMXP_4_1, REGION24_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR24_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR24_U_SMXP_4_1, REGION24_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR24_U_SMXP_4_1, REGION24_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR24_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR24_U_SMXP_4_1, 0x213dd98)
    FIELD(POR_MPU_M3_PRLAR24_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR24_U_SMXP_4_1, REGION24_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR24_U_SMXP_4_1, REGION24_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR25_U_SMXP_4_1, 0x213dda0)
    FIELD(POR_MPU_M3_PRBAR25_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR25_U_SMXP_4_1, REGION25_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR25_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR25_U_SMXP_4_1, REGION25_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR25_U_SMXP_4_1, REGION25_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR25_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR25_U_SMXP_4_1, 0x213dda8)
    FIELD(POR_MPU_M3_PRLAR25_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR25_U_SMXP_4_1, REGION25_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR25_U_SMXP_4_1, REGION25_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR26_U_SMXP_4_1, 0x213ddb0)
    FIELD(POR_MPU_M3_PRBAR26_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR26_U_SMXP_4_1, REGION26_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR26_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR26_U_SMXP_4_1, REGION26_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR26_U_SMXP_4_1, REGION26_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR26_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR26_U_SMXP_4_1, 0x213ddb8)
    FIELD(POR_MPU_M3_PRLAR26_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR26_U_SMXP_4_1, REGION26_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR26_U_SMXP_4_1, REGION26_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR27_U_SMXP_4_1, 0x213ddc0)
    FIELD(POR_MPU_M3_PRBAR27_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR27_U_SMXP_4_1, REGION27_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR27_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR27_U_SMXP_4_1, REGION27_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR27_U_SMXP_4_1, REGION27_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR27_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR27_U_SMXP_4_1, 0x213ddc8)
    FIELD(POR_MPU_M3_PRLAR27_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR27_U_SMXP_4_1, REGION27_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR27_U_SMXP_4_1, REGION27_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR28_U_SMXP_4_1, 0x213ddd0)
    FIELD(POR_MPU_M3_PRBAR28_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR28_U_SMXP_4_1, REGION28_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR28_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR28_U_SMXP_4_1, REGION28_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR28_U_SMXP_4_1, REGION28_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR28_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR28_U_SMXP_4_1, 0x213ddd8)
    FIELD(POR_MPU_M3_PRLAR28_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR28_U_SMXP_4_1, REGION28_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR28_U_SMXP_4_1, REGION28_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR29_U_SMXP_4_1, 0x213dde0)
    FIELD(POR_MPU_M3_PRBAR29_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR29_U_SMXP_4_1, REGION29_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR29_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR29_U_SMXP_4_1, REGION29_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR29_U_SMXP_4_1, REGION29_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR29_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR29_U_SMXP_4_1, 0x213dde8)
    FIELD(POR_MPU_M3_PRLAR29_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR29_U_SMXP_4_1, REGION29_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR29_U_SMXP_4_1, REGION29_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR30_U_SMXP_4_1, 0x213ddf0)
    FIELD(POR_MPU_M3_PRBAR30_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR30_U_SMXP_4_1, REGION30_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR30_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR30_U_SMXP_4_1, REGION30_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR30_U_SMXP_4_1, REGION30_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR30_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR30_U_SMXP_4_1, 0x213ddf8)
    FIELD(POR_MPU_M3_PRLAR30_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR30_U_SMXP_4_1, REGION30_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR30_U_SMXP_4_1, REGION30_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR31_U_SMXP_4_1, 0x213de00)
    FIELD(POR_MPU_M3_PRBAR31_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR31_U_SMXP_4_1, REGION31_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR31_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR31_U_SMXP_4_1, REGION31_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR31_U_SMXP_4_1, REGION31_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR31_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR31_U_SMXP_4_1, 0x213de08)
    FIELD(POR_MPU_M3_PRLAR31_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR31_U_SMXP_4_1, REGION31_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR31_U_SMXP_4_1, REGION31_EN, 0, 1)
REG32(POR_MPU_M4_CTL_U_SMXP_4_1, 0x213e000)
    FIELD(POR_MPU_M4_CTL_U_SMXP_4_1, M4_EN, 2, 1)
    FIELD(POR_MPU_M4_CTL_U_SMXP_4_1, M4_ACTION, 0, 2)
REG32(POR_MPU_M4_PRBAR0_U_SMXP_4_1, 0x213e010)
    FIELD(POR_MPU_M4_PRBAR0_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR0_U_SMXP_4_1, REGION0_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR0_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR0_U_SMXP_4_1, REGION0_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR0_U_SMXP_4_1, REGION0_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR0_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR0_U_SMXP_4_1, 0x213e018)
    FIELD(POR_MPU_M4_PRLAR0_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR0_U_SMXP_4_1, REGION0_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR0_U_SMXP_4_1, REGION0_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR1_U_SMXP_4_1, 0x213e020)
    FIELD(POR_MPU_M4_PRBAR1_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR1_U_SMXP_4_1, REGION1_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR1_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR1_U_SMXP_4_1, REGION1_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR1_U_SMXP_4_1, REGION1_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR1_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR1_U_SMXP_4_1, 0x213e028)
    FIELD(POR_MPU_M4_PRLAR1_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR1_U_SMXP_4_1, REGION1_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR1_U_SMXP_4_1, REGION1_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR2_U_SMXP_4_1, 0x213e030)
    FIELD(POR_MPU_M4_PRBAR2_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR2_U_SMXP_4_1, REGION2_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR2_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR2_U_SMXP_4_1, REGION2_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR2_U_SMXP_4_1, REGION2_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR2_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR2_U_SMXP_4_1, 0x213e038)
    FIELD(POR_MPU_M4_PRLAR2_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR2_U_SMXP_4_1, REGION2_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR2_U_SMXP_4_1, REGION2_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR3_U_SMXP_4_1, 0x213e040)
    FIELD(POR_MPU_M4_PRBAR3_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR3_U_SMXP_4_1, REGION3_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR3_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR3_U_SMXP_4_1, REGION3_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR3_U_SMXP_4_1, REGION3_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR3_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR3_U_SMXP_4_1, 0x213e048)
    FIELD(POR_MPU_M4_PRLAR3_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR3_U_SMXP_4_1, REGION3_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR3_U_SMXP_4_1, REGION3_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR4_U_SMXP_4_1, 0x213e050)
    FIELD(POR_MPU_M4_PRBAR4_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR4_U_SMXP_4_1, REGION4_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR4_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR4_U_SMXP_4_1, REGION4_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR4_U_SMXP_4_1, REGION4_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR4_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR4_U_SMXP_4_1, 0x213e058)
    FIELD(POR_MPU_M4_PRLAR4_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR4_U_SMXP_4_1, REGION4_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR4_U_SMXP_4_1, REGION4_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR5_U_SMXP_4_1, 0x213e060)
    FIELD(POR_MPU_M4_PRBAR5_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR5_U_SMXP_4_1, REGION5_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR5_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR5_U_SMXP_4_1, REGION5_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR5_U_SMXP_4_1, REGION5_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR5_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR5_U_SMXP_4_1, 0x213e068)
    FIELD(POR_MPU_M4_PRLAR5_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR5_U_SMXP_4_1, REGION5_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR5_U_SMXP_4_1, REGION5_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR6_U_SMXP_4_1, 0x213e070)
    FIELD(POR_MPU_M4_PRBAR6_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR6_U_SMXP_4_1, REGION6_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR6_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR6_U_SMXP_4_1, REGION6_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR6_U_SMXP_4_1, REGION6_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR6_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR6_U_SMXP_4_1, 0x213e078)
    FIELD(POR_MPU_M4_PRLAR6_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR6_U_SMXP_4_1, REGION6_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR6_U_SMXP_4_1, REGION6_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR7_U_SMXP_4_1, 0x213e080)
    FIELD(POR_MPU_M4_PRBAR7_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR7_U_SMXP_4_1, REGION7_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR7_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR7_U_SMXP_4_1, REGION7_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR7_U_SMXP_4_1, REGION7_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR7_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR7_U_SMXP_4_1, 0x213e088)
    FIELD(POR_MPU_M4_PRLAR7_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR7_U_SMXP_4_1, REGION7_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR7_U_SMXP_4_1, REGION7_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR8_U_SMXP_4_1, 0x213e090)
    FIELD(POR_MPU_M4_PRBAR8_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR8_U_SMXP_4_1, REGION8_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR8_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR8_U_SMXP_4_1, REGION8_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR8_U_SMXP_4_1, REGION8_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR8_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR8_U_SMXP_4_1, 0x213e098)
    FIELD(POR_MPU_M4_PRLAR8_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR8_U_SMXP_4_1, REGION8_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR8_U_SMXP_4_1, REGION8_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR9_U_SMXP_4_1, 0x213e0a0)
    FIELD(POR_MPU_M4_PRBAR9_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR9_U_SMXP_4_1, REGION9_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR9_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR9_U_SMXP_4_1, REGION9_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR9_U_SMXP_4_1, REGION9_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR9_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR9_U_SMXP_4_1, 0x213e0a8)
    FIELD(POR_MPU_M4_PRLAR9_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR9_U_SMXP_4_1, REGION9_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR9_U_SMXP_4_1, REGION9_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR10_U_SMXP_4_1, 0x213e0b0)
    FIELD(POR_MPU_M4_PRBAR10_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR10_U_SMXP_4_1, REGION10_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR10_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR10_U_SMXP_4_1, REGION10_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR10_U_SMXP_4_1, REGION10_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR10_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR10_U_SMXP_4_1, 0x213e0b8)
    FIELD(POR_MPU_M4_PRLAR10_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR10_U_SMXP_4_1, REGION10_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR10_U_SMXP_4_1, REGION10_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR11_U_SMXP_4_1, 0x213e0c0)
    FIELD(POR_MPU_M4_PRBAR11_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR11_U_SMXP_4_1, REGION11_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR11_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR11_U_SMXP_4_1, REGION11_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR11_U_SMXP_4_1, REGION11_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR11_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR11_U_SMXP_4_1, 0x213e0c8)
    FIELD(POR_MPU_M4_PRLAR11_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR11_U_SMXP_4_1, REGION11_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR11_U_SMXP_4_1, REGION11_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR12_U_SMXP_4_1, 0x213e0d0)
    FIELD(POR_MPU_M4_PRBAR12_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR12_U_SMXP_4_1, REGION12_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR12_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR12_U_SMXP_4_1, REGION12_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR12_U_SMXP_4_1, REGION12_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR12_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR12_U_SMXP_4_1, 0x213e0d8)
    FIELD(POR_MPU_M4_PRLAR12_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR12_U_SMXP_4_1, REGION12_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR12_U_SMXP_4_1, REGION12_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR13_U_SMXP_4_1, 0x213e0e0)
    FIELD(POR_MPU_M4_PRBAR13_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR13_U_SMXP_4_1, REGION13_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR13_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR13_U_SMXP_4_1, REGION13_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR13_U_SMXP_4_1, REGION13_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR13_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR13_U_SMXP_4_1, 0x213e0e8)
    FIELD(POR_MPU_M4_PRLAR13_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR13_U_SMXP_4_1, REGION13_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR13_U_SMXP_4_1, REGION13_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR14_U_SMXP_4_1, 0x213e0f0)
    FIELD(POR_MPU_M4_PRBAR14_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR14_U_SMXP_4_1, REGION14_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR14_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR14_U_SMXP_4_1, REGION14_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR14_U_SMXP_4_1, REGION14_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR14_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR14_U_SMXP_4_1, 0x213e0f8)
    FIELD(POR_MPU_M4_PRLAR14_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR14_U_SMXP_4_1, REGION14_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR14_U_SMXP_4_1, REGION14_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR15_U_SMXP_4_1, 0x213e100)
    FIELD(POR_MPU_M4_PRBAR15_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR15_U_SMXP_4_1, REGION15_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR15_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR15_U_SMXP_4_1, REGION15_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR15_U_SMXP_4_1, REGION15_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR15_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR15_U_SMXP_4_1, 0x213e108)
    FIELD(POR_MPU_M4_PRLAR15_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR15_U_SMXP_4_1, REGION15_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR15_U_SMXP_4_1, REGION15_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR16_U_SMXP_4_1, 0x213e110)
    FIELD(POR_MPU_M4_PRBAR16_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR16_U_SMXP_4_1, REGION16_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR16_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR16_U_SMXP_4_1, REGION16_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR16_U_SMXP_4_1, REGION16_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR16_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR16_U_SMXP_4_1, 0x213e118)
    FIELD(POR_MPU_M4_PRLAR16_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR16_U_SMXP_4_1, REGION16_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR16_U_SMXP_4_1, REGION16_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR17_U_SMXP_4_1, 0x213e120)
    FIELD(POR_MPU_M4_PRBAR17_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR17_U_SMXP_4_1, REGION17_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR17_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR17_U_SMXP_4_1, REGION17_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR17_U_SMXP_4_1, REGION17_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR17_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR17_U_SMXP_4_1, 0x213e128)
    FIELD(POR_MPU_M4_PRLAR17_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR17_U_SMXP_4_1, REGION17_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR17_U_SMXP_4_1, REGION17_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR18_U_SMXP_4_1, 0x213e130)
    FIELD(POR_MPU_M4_PRBAR18_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR18_U_SMXP_4_1, REGION18_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR18_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR18_U_SMXP_4_1, REGION18_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR18_U_SMXP_4_1, REGION18_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR18_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR18_U_SMXP_4_1, 0x213e138)
    FIELD(POR_MPU_M4_PRLAR18_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR18_U_SMXP_4_1, REGION18_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR18_U_SMXP_4_1, REGION18_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR19_U_SMXP_4_1, 0x213e140)
    FIELD(POR_MPU_M4_PRBAR19_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR19_U_SMXP_4_1, REGION19_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR19_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR19_U_SMXP_4_1, REGION19_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR19_U_SMXP_4_1, REGION19_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR19_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR19_U_SMXP_4_1, 0x213e148)
    FIELD(POR_MPU_M4_PRLAR19_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR19_U_SMXP_4_1, REGION19_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR19_U_SMXP_4_1, REGION19_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR20_U_SMXP_4_1, 0x213e150)
    FIELD(POR_MPU_M4_PRBAR20_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR20_U_SMXP_4_1, REGION20_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR20_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR20_U_SMXP_4_1, REGION20_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR20_U_SMXP_4_1, REGION20_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR20_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR20_U_SMXP_4_1, 0x213e158)
    FIELD(POR_MPU_M4_PRLAR20_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR20_U_SMXP_4_1, REGION20_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR20_U_SMXP_4_1, REGION20_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR21_U_SMXP_4_1, 0x213e160)
    FIELD(POR_MPU_M4_PRBAR21_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR21_U_SMXP_4_1, REGION21_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR21_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR21_U_SMXP_4_1, REGION21_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR21_U_SMXP_4_1, REGION21_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR21_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR21_U_SMXP_4_1, 0x213e168)
    FIELD(POR_MPU_M4_PRLAR21_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR21_U_SMXP_4_1, REGION21_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR21_U_SMXP_4_1, REGION21_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR22_U_SMXP_4_1, 0x213e170)
    FIELD(POR_MPU_M4_PRBAR22_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR22_U_SMXP_4_1, REGION22_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR22_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR22_U_SMXP_4_1, REGION22_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR22_U_SMXP_4_1, REGION22_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR22_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR22_U_SMXP_4_1, 0x213e178)
    FIELD(POR_MPU_M4_PRLAR22_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR22_U_SMXP_4_1, REGION22_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR22_U_SMXP_4_1, REGION22_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR23_U_SMXP_4_1, 0x213e180)
    FIELD(POR_MPU_M4_PRBAR23_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR23_U_SMXP_4_1, REGION23_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR23_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR23_U_SMXP_4_1, REGION23_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR23_U_SMXP_4_1, REGION23_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR23_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR23_U_SMXP_4_1, 0x213e188)
    FIELD(POR_MPU_M4_PRLAR23_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR23_U_SMXP_4_1, REGION23_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR23_U_SMXP_4_1, REGION23_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR24_U_SMXP_4_1, 0x213e190)
    FIELD(POR_MPU_M4_PRBAR24_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR24_U_SMXP_4_1, REGION24_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR24_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR24_U_SMXP_4_1, REGION24_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR24_U_SMXP_4_1, REGION24_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR24_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR24_U_SMXP_4_1, 0x213e198)
    FIELD(POR_MPU_M4_PRLAR24_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR24_U_SMXP_4_1, REGION24_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR24_U_SMXP_4_1, REGION24_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR25_U_SMXP_4_1, 0x213e1a0)
    FIELD(POR_MPU_M4_PRBAR25_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR25_U_SMXP_4_1, REGION25_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR25_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR25_U_SMXP_4_1, REGION25_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR25_U_SMXP_4_1, REGION25_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR25_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR25_U_SMXP_4_1, 0x213e1a8)
    FIELD(POR_MPU_M4_PRLAR25_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR25_U_SMXP_4_1, REGION25_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR25_U_SMXP_4_1, REGION25_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR26_U_SMXP_4_1, 0x213e1b0)
    FIELD(POR_MPU_M4_PRBAR26_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR26_U_SMXP_4_1, REGION26_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR26_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR26_U_SMXP_4_1, REGION26_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR26_U_SMXP_4_1, REGION26_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR26_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR26_U_SMXP_4_1, 0x213e1b8)
    FIELD(POR_MPU_M4_PRLAR26_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR26_U_SMXP_4_1, REGION26_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR26_U_SMXP_4_1, REGION26_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR27_U_SMXP_4_1, 0x213e1c0)
    FIELD(POR_MPU_M4_PRBAR27_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR27_U_SMXP_4_1, REGION27_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR27_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR27_U_SMXP_4_1, REGION27_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR27_U_SMXP_4_1, REGION27_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR27_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR27_U_SMXP_4_1, 0x213e1c8)
    FIELD(POR_MPU_M4_PRLAR27_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR27_U_SMXP_4_1, REGION27_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR27_U_SMXP_4_1, REGION27_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR28_U_SMXP_4_1, 0x213e1d0)
    FIELD(POR_MPU_M4_PRBAR28_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR28_U_SMXP_4_1, REGION28_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR28_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR28_U_SMXP_4_1, REGION28_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR28_U_SMXP_4_1, REGION28_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR28_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR28_U_SMXP_4_1, 0x213e1d8)
    FIELD(POR_MPU_M4_PRLAR28_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR28_U_SMXP_4_1, REGION28_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR28_U_SMXP_4_1, REGION28_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR29_U_SMXP_4_1, 0x213e1e0)
    FIELD(POR_MPU_M4_PRBAR29_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR29_U_SMXP_4_1, REGION29_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR29_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR29_U_SMXP_4_1, REGION29_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR29_U_SMXP_4_1, REGION29_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR29_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR29_U_SMXP_4_1, 0x213e1e8)
    FIELD(POR_MPU_M4_PRLAR29_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR29_U_SMXP_4_1, REGION29_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR29_U_SMXP_4_1, REGION29_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR30_U_SMXP_4_1, 0x213e1f0)
    FIELD(POR_MPU_M4_PRBAR30_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR30_U_SMXP_4_1, REGION30_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR30_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR30_U_SMXP_4_1, REGION30_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR30_U_SMXP_4_1, REGION30_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR30_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR30_U_SMXP_4_1, 0x213e1f8)
    FIELD(POR_MPU_M4_PRLAR30_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR30_U_SMXP_4_1, REGION30_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR30_U_SMXP_4_1, REGION30_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR31_U_SMXP_4_1, 0x213e200)
    FIELD(POR_MPU_M4_PRBAR31_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR31_U_SMXP_4_1, REGION31_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR31_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR31_U_SMXP_4_1, REGION31_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR31_U_SMXP_4_1, REGION31_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR31_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR31_U_SMXP_4_1, 0x213e208)
    FIELD(POR_MPU_M4_PRLAR31_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR31_U_SMXP_4_1, REGION31_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR31_U_SMXP_4_1, REGION31_EN, 0, 1)
REG32(POR_MPU_M5_CTL_U_SMXP_4_1, 0x213e400)
    FIELD(POR_MPU_M5_CTL_U_SMXP_4_1, M5_EN, 2, 1)
    FIELD(POR_MPU_M5_CTL_U_SMXP_4_1, M5_ACTION, 0, 2)
REG32(POR_MPU_M5_PRBAR0_U_SMXP_4_1, 0x213e410)
    FIELD(POR_MPU_M5_PRBAR0_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR0_U_SMXP_4_1, REGION0_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR0_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR0_U_SMXP_4_1, REGION0_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR0_U_SMXP_4_1, REGION0_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR0_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR0_U_SMXP_4_1, 0x213e418)
    FIELD(POR_MPU_M5_PRLAR0_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR0_U_SMXP_4_1, REGION0_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR0_U_SMXP_4_1, REGION0_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR1_U_SMXP_4_1, 0x213e420)
    FIELD(POR_MPU_M5_PRBAR1_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR1_U_SMXP_4_1, REGION1_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR1_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR1_U_SMXP_4_1, REGION1_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR1_U_SMXP_4_1, REGION1_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR1_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR1_U_SMXP_4_1, 0x213e428)
    FIELD(POR_MPU_M5_PRLAR1_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR1_U_SMXP_4_1, REGION1_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR1_U_SMXP_4_1, REGION1_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR2_U_SMXP_4_1, 0x213e430)
    FIELD(POR_MPU_M5_PRBAR2_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR2_U_SMXP_4_1, REGION2_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR2_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR2_U_SMXP_4_1, REGION2_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR2_U_SMXP_4_1, REGION2_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR2_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR2_U_SMXP_4_1, 0x213e438)
    FIELD(POR_MPU_M5_PRLAR2_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR2_U_SMXP_4_1, REGION2_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR2_U_SMXP_4_1, REGION2_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR3_U_SMXP_4_1, 0x213e440)
    FIELD(POR_MPU_M5_PRBAR3_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR3_U_SMXP_4_1, REGION3_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR3_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR3_U_SMXP_4_1, REGION3_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR3_U_SMXP_4_1, REGION3_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR3_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR3_U_SMXP_4_1, 0x213e448)
    FIELD(POR_MPU_M5_PRLAR3_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR3_U_SMXP_4_1, REGION3_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR3_U_SMXP_4_1, REGION3_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR4_U_SMXP_4_1, 0x213e450)
    FIELD(POR_MPU_M5_PRBAR4_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR4_U_SMXP_4_1, REGION4_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR4_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR4_U_SMXP_4_1, REGION4_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR4_U_SMXP_4_1, REGION4_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR4_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR4_U_SMXP_4_1, 0x213e458)
    FIELD(POR_MPU_M5_PRLAR4_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR4_U_SMXP_4_1, REGION4_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR4_U_SMXP_4_1, REGION4_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR5_U_SMXP_4_1, 0x213e460)
    FIELD(POR_MPU_M5_PRBAR5_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR5_U_SMXP_4_1, REGION5_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR5_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR5_U_SMXP_4_1, REGION5_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR5_U_SMXP_4_1, REGION5_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR5_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR5_U_SMXP_4_1, 0x213e468)
    FIELD(POR_MPU_M5_PRLAR5_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR5_U_SMXP_4_1, REGION5_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR5_U_SMXP_4_1, REGION5_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR6_U_SMXP_4_1, 0x213e470)
    FIELD(POR_MPU_M5_PRBAR6_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR6_U_SMXP_4_1, REGION6_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR6_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR6_U_SMXP_4_1, REGION6_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR6_U_SMXP_4_1, REGION6_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR6_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR6_U_SMXP_4_1, 0x213e478)
    FIELD(POR_MPU_M5_PRLAR6_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR6_U_SMXP_4_1, REGION6_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR6_U_SMXP_4_1, REGION6_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR7_U_SMXP_4_1, 0x213e480)
    FIELD(POR_MPU_M5_PRBAR7_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR7_U_SMXP_4_1, REGION7_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR7_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR7_U_SMXP_4_1, REGION7_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR7_U_SMXP_4_1, REGION7_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR7_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR7_U_SMXP_4_1, 0x213e488)
    FIELD(POR_MPU_M5_PRLAR7_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR7_U_SMXP_4_1, REGION7_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR7_U_SMXP_4_1, REGION7_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR8_U_SMXP_4_1, 0x213e490)
    FIELD(POR_MPU_M5_PRBAR8_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR8_U_SMXP_4_1, REGION8_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR8_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR8_U_SMXP_4_1, REGION8_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR8_U_SMXP_4_1, REGION8_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR8_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR8_U_SMXP_4_1, 0x213e498)
    FIELD(POR_MPU_M5_PRLAR8_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR8_U_SMXP_4_1, REGION8_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR8_U_SMXP_4_1, REGION8_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR9_U_SMXP_4_1, 0x213e4a0)
    FIELD(POR_MPU_M5_PRBAR9_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR9_U_SMXP_4_1, REGION9_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR9_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR9_U_SMXP_4_1, REGION9_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR9_U_SMXP_4_1, REGION9_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR9_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR9_U_SMXP_4_1, 0x213e4a8)
    FIELD(POR_MPU_M5_PRLAR9_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR9_U_SMXP_4_1, REGION9_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR9_U_SMXP_4_1, REGION9_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR10_U_SMXP_4_1, 0x213e4b0)
    FIELD(POR_MPU_M5_PRBAR10_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR10_U_SMXP_4_1, REGION10_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR10_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR10_U_SMXP_4_1, REGION10_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR10_U_SMXP_4_1, REGION10_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR10_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR10_U_SMXP_4_1, 0x213e4b8)
    FIELD(POR_MPU_M5_PRLAR10_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR10_U_SMXP_4_1, REGION10_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR10_U_SMXP_4_1, REGION10_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR11_U_SMXP_4_1, 0x213e4c0)
    FIELD(POR_MPU_M5_PRBAR11_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR11_U_SMXP_4_1, REGION11_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR11_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR11_U_SMXP_4_1, REGION11_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR11_U_SMXP_4_1, REGION11_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR11_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR11_U_SMXP_4_1, 0x213e4c8)
    FIELD(POR_MPU_M5_PRLAR11_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR11_U_SMXP_4_1, REGION11_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR11_U_SMXP_4_1, REGION11_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR12_U_SMXP_4_1, 0x213e4d0)
    FIELD(POR_MPU_M5_PRBAR12_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR12_U_SMXP_4_1, REGION12_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR12_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR12_U_SMXP_4_1, REGION12_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR12_U_SMXP_4_1, REGION12_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR12_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR12_U_SMXP_4_1, 0x213e4d8)
    FIELD(POR_MPU_M5_PRLAR12_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR12_U_SMXP_4_1, REGION12_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR12_U_SMXP_4_1, REGION12_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR13_U_SMXP_4_1, 0x213e4e0)
    FIELD(POR_MPU_M5_PRBAR13_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR13_U_SMXP_4_1, REGION13_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR13_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR13_U_SMXP_4_1, REGION13_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR13_U_SMXP_4_1, REGION13_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR13_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR13_U_SMXP_4_1, 0x213e4e8)
    FIELD(POR_MPU_M5_PRLAR13_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR13_U_SMXP_4_1, REGION13_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR13_U_SMXP_4_1, REGION13_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR14_U_SMXP_4_1, 0x213e4f0)
    FIELD(POR_MPU_M5_PRBAR14_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR14_U_SMXP_4_1, REGION14_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR14_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR14_U_SMXP_4_1, REGION14_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR14_U_SMXP_4_1, REGION14_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR14_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR14_U_SMXP_4_1, 0x213e4f8)
    FIELD(POR_MPU_M5_PRLAR14_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR14_U_SMXP_4_1, REGION14_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR14_U_SMXP_4_1, REGION14_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR15_U_SMXP_4_1, 0x213e500)
    FIELD(POR_MPU_M5_PRBAR15_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR15_U_SMXP_4_1, REGION15_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR15_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR15_U_SMXP_4_1, REGION15_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR15_U_SMXP_4_1, REGION15_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR15_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR15_U_SMXP_4_1, 0x213e508)
    FIELD(POR_MPU_M5_PRLAR15_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR15_U_SMXP_4_1, REGION15_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR15_U_SMXP_4_1, REGION15_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR16_U_SMXP_4_1, 0x213e510)
    FIELD(POR_MPU_M5_PRBAR16_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR16_U_SMXP_4_1, REGION16_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR16_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR16_U_SMXP_4_1, REGION16_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR16_U_SMXP_4_1, REGION16_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR16_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR16_U_SMXP_4_1, 0x213e518)
    FIELD(POR_MPU_M5_PRLAR16_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR16_U_SMXP_4_1, REGION16_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR16_U_SMXP_4_1, REGION16_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR17_U_SMXP_4_1, 0x213e520)
    FIELD(POR_MPU_M5_PRBAR17_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR17_U_SMXP_4_1, REGION17_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR17_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR17_U_SMXP_4_1, REGION17_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR17_U_SMXP_4_1, REGION17_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR17_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR17_U_SMXP_4_1, 0x213e528)
    FIELD(POR_MPU_M5_PRLAR17_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR17_U_SMXP_4_1, REGION17_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR17_U_SMXP_4_1, REGION17_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR18_U_SMXP_4_1, 0x213e530)
    FIELD(POR_MPU_M5_PRBAR18_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR18_U_SMXP_4_1, REGION18_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR18_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR18_U_SMXP_4_1, REGION18_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR18_U_SMXP_4_1, REGION18_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR18_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR18_U_SMXP_4_1, 0x213e538)
    FIELD(POR_MPU_M5_PRLAR18_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR18_U_SMXP_4_1, REGION18_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR18_U_SMXP_4_1, REGION18_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR19_U_SMXP_4_1, 0x213e540)
    FIELD(POR_MPU_M5_PRBAR19_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR19_U_SMXP_4_1, REGION19_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR19_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR19_U_SMXP_4_1, REGION19_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR19_U_SMXP_4_1, REGION19_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR19_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR19_U_SMXP_4_1, 0x213e548)
    FIELD(POR_MPU_M5_PRLAR19_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR19_U_SMXP_4_1, REGION19_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR19_U_SMXP_4_1, REGION19_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR20_U_SMXP_4_1, 0x213e550)
    FIELD(POR_MPU_M5_PRBAR20_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR20_U_SMXP_4_1, REGION20_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR20_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR20_U_SMXP_4_1, REGION20_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR20_U_SMXP_4_1, REGION20_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR20_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR20_U_SMXP_4_1, 0x213e558)
    FIELD(POR_MPU_M5_PRLAR20_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR20_U_SMXP_4_1, REGION20_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR20_U_SMXP_4_1, REGION20_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR21_U_SMXP_4_1, 0x213e560)
    FIELD(POR_MPU_M5_PRBAR21_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR21_U_SMXP_4_1, REGION21_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR21_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR21_U_SMXP_4_1, REGION21_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR21_U_SMXP_4_1, REGION21_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR21_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR21_U_SMXP_4_1, 0x213e568)
    FIELD(POR_MPU_M5_PRLAR21_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR21_U_SMXP_4_1, REGION21_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR21_U_SMXP_4_1, REGION21_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR22_U_SMXP_4_1, 0x213e570)
    FIELD(POR_MPU_M5_PRBAR22_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR22_U_SMXP_4_1, REGION22_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR22_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR22_U_SMXP_4_1, REGION22_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR22_U_SMXP_4_1, REGION22_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR22_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR22_U_SMXP_4_1, 0x213e578)
    FIELD(POR_MPU_M5_PRLAR22_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR22_U_SMXP_4_1, REGION22_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR22_U_SMXP_4_1, REGION22_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR23_U_SMXP_4_1, 0x213e580)
    FIELD(POR_MPU_M5_PRBAR23_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR23_U_SMXP_4_1, REGION23_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR23_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR23_U_SMXP_4_1, REGION23_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR23_U_SMXP_4_1, REGION23_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR23_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR23_U_SMXP_4_1, 0x213e588)
    FIELD(POR_MPU_M5_PRLAR23_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR23_U_SMXP_4_1, REGION23_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR23_U_SMXP_4_1, REGION23_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR24_U_SMXP_4_1, 0x213e590)
    FIELD(POR_MPU_M5_PRBAR24_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR24_U_SMXP_4_1, REGION24_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR24_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR24_U_SMXP_4_1, REGION24_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR24_U_SMXP_4_1, REGION24_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR24_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR24_U_SMXP_4_1, 0x213e598)
    FIELD(POR_MPU_M5_PRLAR24_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR24_U_SMXP_4_1, REGION24_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR24_U_SMXP_4_1, REGION24_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR25_U_SMXP_4_1, 0x213e5a0)
    FIELD(POR_MPU_M5_PRBAR25_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR25_U_SMXP_4_1, REGION25_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR25_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR25_U_SMXP_4_1, REGION25_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR25_U_SMXP_4_1, REGION25_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR25_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR25_U_SMXP_4_1, 0x213e5a8)
    FIELD(POR_MPU_M5_PRLAR25_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR25_U_SMXP_4_1, REGION25_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR25_U_SMXP_4_1, REGION25_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR26_U_SMXP_4_1, 0x213e5b0)
    FIELD(POR_MPU_M5_PRBAR26_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR26_U_SMXP_4_1, REGION26_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR26_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR26_U_SMXP_4_1, REGION26_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR26_U_SMXP_4_1, REGION26_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR26_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR26_U_SMXP_4_1, 0x213e5b8)
    FIELD(POR_MPU_M5_PRLAR26_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR26_U_SMXP_4_1, REGION26_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR26_U_SMXP_4_1, REGION26_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR27_U_SMXP_4_1, 0x213e5c0)
    FIELD(POR_MPU_M5_PRBAR27_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR27_U_SMXP_4_1, REGION27_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR27_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR27_U_SMXP_4_1, REGION27_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR27_U_SMXP_4_1, REGION27_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR27_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR27_U_SMXP_4_1, 0x213e5c8)
    FIELD(POR_MPU_M5_PRLAR27_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR27_U_SMXP_4_1, REGION27_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR27_U_SMXP_4_1, REGION27_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR28_U_SMXP_4_1, 0x213e5d0)
    FIELD(POR_MPU_M5_PRBAR28_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR28_U_SMXP_4_1, REGION28_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR28_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR28_U_SMXP_4_1, REGION28_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR28_U_SMXP_4_1, REGION28_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR28_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR28_U_SMXP_4_1, 0x213e5d8)
    FIELD(POR_MPU_M5_PRLAR28_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR28_U_SMXP_4_1, REGION28_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR28_U_SMXP_4_1, REGION28_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR29_U_SMXP_4_1, 0x213e5e0)
    FIELD(POR_MPU_M5_PRBAR29_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR29_U_SMXP_4_1, REGION29_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR29_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR29_U_SMXP_4_1, REGION29_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR29_U_SMXP_4_1, REGION29_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR29_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR29_U_SMXP_4_1, 0x213e5e8)
    FIELD(POR_MPU_M5_PRLAR29_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR29_U_SMXP_4_1, REGION29_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR29_U_SMXP_4_1, REGION29_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR30_U_SMXP_4_1, 0x213e5f0)
    FIELD(POR_MPU_M5_PRBAR30_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR30_U_SMXP_4_1, REGION30_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR30_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR30_U_SMXP_4_1, REGION30_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR30_U_SMXP_4_1, REGION30_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR30_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR30_U_SMXP_4_1, 0x213e5f8)
    FIELD(POR_MPU_M5_PRLAR30_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR30_U_SMXP_4_1, REGION30_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR30_U_SMXP_4_1, REGION30_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR31_U_SMXP_4_1, 0x213e600)
    FIELD(POR_MPU_M5_PRBAR31_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR31_U_SMXP_4_1, REGION31_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR31_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR31_U_SMXP_4_1, REGION31_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR31_U_SMXP_4_1, REGION31_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR31_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR31_U_SMXP_4_1, 0x213e608)
    FIELD(POR_MPU_M5_PRLAR31_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR31_U_SMXP_4_1, REGION31_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR31_U_SMXP_4_1, REGION31_EN, 0, 1)
REG32(POR_MPU_M6_CTL_U_SMXP_4_1, 0x213e800)
    FIELD(POR_MPU_M6_CTL_U_SMXP_4_1, M6_EN, 2, 1)
    FIELD(POR_MPU_M6_CTL_U_SMXP_4_1, M6_ACTION, 0, 2)
REG32(POR_MPU_M6_PRBAR0_U_SMXP_4_1, 0x213e810)
    FIELD(POR_MPU_M6_PRBAR0_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR0_U_SMXP_4_1, REGION0_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR0_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR0_U_SMXP_4_1, REGION0_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR0_U_SMXP_4_1, REGION0_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR0_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR0_U_SMXP_4_1, 0x213e818)
    FIELD(POR_MPU_M6_PRLAR0_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR0_U_SMXP_4_1, REGION0_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR0_U_SMXP_4_1, REGION0_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR1_U_SMXP_4_1, 0x213e820)
    FIELD(POR_MPU_M6_PRBAR1_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR1_U_SMXP_4_1, REGION1_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR1_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR1_U_SMXP_4_1, REGION1_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR1_U_SMXP_4_1, REGION1_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR1_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR1_U_SMXP_4_1, 0x213e828)
    FIELD(POR_MPU_M6_PRLAR1_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR1_U_SMXP_4_1, REGION1_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR1_U_SMXP_4_1, REGION1_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR2_U_SMXP_4_1, 0x213e830)
    FIELD(POR_MPU_M6_PRBAR2_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR2_U_SMXP_4_1, REGION2_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR2_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR2_U_SMXP_4_1, REGION2_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR2_U_SMXP_4_1, REGION2_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR2_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR2_U_SMXP_4_1, 0x213e838)
    FIELD(POR_MPU_M6_PRLAR2_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR2_U_SMXP_4_1, REGION2_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR2_U_SMXP_4_1, REGION2_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR3_U_SMXP_4_1, 0x213e840)
    FIELD(POR_MPU_M6_PRBAR3_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR3_U_SMXP_4_1, REGION3_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR3_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR3_U_SMXP_4_1, REGION3_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR3_U_SMXP_4_1, REGION3_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR3_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR3_U_SMXP_4_1, 0x213e848)
    FIELD(POR_MPU_M6_PRLAR3_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR3_U_SMXP_4_1, REGION3_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR3_U_SMXP_4_1, REGION3_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR4_U_SMXP_4_1, 0x213e850)
    FIELD(POR_MPU_M6_PRBAR4_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR4_U_SMXP_4_1, REGION4_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR4_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR4_U_SMXP_4_1, REGION4_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR4_U_SMXP_4_1, REGION4_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR4_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR4_U_SMXP_4_1, 0x213e858)
    FIELD(POR_MPU_M6_PRLAR4_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR4_U_SMXP_4_1, REGION4_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR4_U_SMXP_4_1, REGION4_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR5_U_SMXP_4_1, 0x213e860)
    FIELD(POR_MPU_M6_PRBAR5_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR5_U_SMXP_4_1, REGION5_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR5_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR5_U_SMXP_4_1, REGION5_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR5_U_SMXP_4_1, REGION5_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR5_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR5_U_SMXP_4_1, 0x213e868)
    FIELD(POR_MPU_M6_PRLAR5_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR5_U_SMXP_4_1, REGION5_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR5_U_SMXP_4_1, REGION5_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR6_U_SMXP_4_1, 0x213e870)
    FIELD(POR_MPU_M6_PRBAR6_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR6_U_SMXP_4_1, REGION6_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR6_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR6_U_SMXP_4_1, REGION6_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR6_U_SMXP_4_1, REGION6_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR6_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR6_U_SMXP_4_1, 0x213e878)
    FIELD(POR_MPU_M6_PRLAR6_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR6_U_SMXP_4_1, REGION6_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR6_U_SMXP_4_1, REGION6_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR7_U_SMXP_4_1, 0x213e880)
    FIELD(POR_MPU_M6_PRBAR7_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR7_U_SMXP_4_1, REGION7_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR7_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR7_U_SMXP_4_1, REGION7_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR7_U_SMXP_4_1, REGION7_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR7_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR7_U_SMXP_4_1, 0x213e888)
    FIELD(POR_MPU_M6_PRLAR7_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR7_U_SMXP_4_1, REGION7_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR7_U_SMXP_4_1, REGION7_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR8_U_SMXP_4_1, 0x213e890)
    FIELD(POR_MPU_M6_PRBAR8_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR8_U_SMXP_4_1, REGION8_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR8_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR8_U_SMXP_4_1, REGION8_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR8_U_SMXP_4_1, REGION8_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR8_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR8_U_SMXP_4_1, 0x213e898)
    FIELD(POR_MPU_M6_PRLAR8_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR8_U_SMXP_4_1, REGION8_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR8_U_SMXP_4_1, REGION8_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR9_U_SMXP_4_1, 0x213e8a0)
    FIELD(POR_MPU_M6_PRBAR9_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR9_U_SMXP_4_1, REGION9_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR9_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR9_U_SMXP_4_1, REGION9_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR9_U_SMXP_4_1, REGION9_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR9_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR9_U_SMXP_4_1, 0x213e8a8)
    FIELD(POR_MPU_M6_PRLAR9_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR9_U_SMXP_4_1, REGION9_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR9_U_SMXP_4_1, REGION9_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR10_U_SMXP_4_1, 0x213e8b0)
    FIELD(POR_MPU_M6_PRBAR10_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR10_U_SMXP_4_1, REGION10_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR10_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR10_U_SMXP_4_1, REGION10_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR10_U_SMXP_4_1, REGION10_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR10_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR10_U_SMXP_4_1, 0x213e8b8)
    FIELD(POR_MPU_M6_PRLAR10_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR10_U_SMXP_4_1, REGION10_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR10_U_SMXP_4_1, REGION10_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR11_U_SMXP_4_1, 0x213e8c0)
    FIELD(POR_MPU_M6_PRBAR11_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR11_U_SMXP_4_1, REGION11_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR11_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR11_U_SMXP_4_1, REGION11_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR11_U_SMXP_4_1, REGION11_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR11_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR11_U_SMXP_4_1, 0x213e8c8)
    FIELD(POR_MPU_M6_PRLAR11_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR11_U_SMXP_4_1, REGION11_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR11_U_SMXP_4_1, REGION11_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR12_U_SMXP_4_1, 0x213e8d0)
    FIELD(POR_MPU_M6_PRBAR12_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR12_U_SMXP_4_1, REGION12_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR12_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR12_U_SMXP_4_1, REGION12_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR12_U_SMXP_4_1, REGION12_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR12_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR12_U_SMXP_4_1, 0x213e8d8)
    FIELD(POR_MPU_M6_PRLAR12_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR12_U_SMXP_4_1, REGION12_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR12_U_SMXP_4_1, REGION12_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR13_U_SMXP_4_1, 0x213e8e0)
    FIELD(POR_MPU_M6_PRBAR13_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR13_U_SMXP_4_1, REGION13_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR13_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR13_U_SMXP_4_1, REGION13_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR13_U_SMXP_4_1, REGION13_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR13_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR13_U_SMXP_4_1, 0x213e8e8)
    FIELD(POR_MPU_M6_PRLAR13_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR13_U_SMXP_4_1, REGION13_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR13_U_SMXP_4_1, REGION13_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR14_U_SMXP_4_1, 0x213e8f0)
    FIELD(POR_MPU_M6_PRBAR14_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR14_U_SMXP_4_1, REGION14_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR14_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR14_U_SMXP_4_1, REGION14_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR14_U_SMXP_4_1, REGION14_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR14_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR14_U_SMXP_4_1, 0x213e8f8)
    FIELD(POR_MPU_M6_PRLAR14_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR14_U_SMXP_4_1, REGION14_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR14_U_SMXP_4_1, REGION14_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR15_U_SMXP_4_1, 0x213e900)
    FIELD(POR_MPU_M6_PRBAR15_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR15_U_SMXP_4_1, REGION15_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR15_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR15_U_SMXP_4_1, REGION15_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR15_U_SMXP_4_1, REGION15_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR15_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR15_U_SMXP_4_1, 0x213e908)
    FIELD(POR_MPU_M6_PRLAR15_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR15_U_SMXP_4_1, REGION15_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR15_U_SMXP_4_1, REGION15_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR16_U_SMXP_4_1, 0x213e910)
    FIELD(POR_MPU_M6_PRBAR16_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR16_U_SMXP_4_1, REGION16_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR16_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR16_U_SMXP_4_1, REGION16_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR16_U_SMXP_4_1, REGION16_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR16_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR16_U_SMXP_4_1, 0x213e918)
    FIELD(POR_MPU_M6_PRLAR16_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR16_U_SMXP_4_1, REGION16_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR16_U_SMXP_4_1, REGION16_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR17_U_SMXP_4_1, 0x213e920)
    FIELD(POR_MPU_M6_PRBAR17_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR17_U_SMXP_4_1, REGION17_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR17_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR17_U_SMXP_4_1, REGION17_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR17_U_SMXP_4_1, REGION17_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR17_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR17_U_SMXP_4_1, 0x213e928)
    FIELD(POR_MPU_M6_PRLAR17_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR17_U_SMXP_4_1, REGION17_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR17_U_SMXP_4_1, REGION17_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR18_U_SMXP_4_1, 0x213e930)
    FIELD(POR_MPU_M6_PRBAR18_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR18_U_SMXP_4_1, REGION18_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR18_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR18_U_SMXP_4_1, REGION18_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR18_U_SMXP_4_1, REGION18_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR18_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR18_U_SMXP_4_1, 0x213e938)
    FIELD(POR_MPU_M6_PRLAR18_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR18_U_SMXP_4_1, REGION18_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR18_U_SMXP_4_1, REGION18_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR19_U_SMXP_4_1, 0x213e940)
    FIELD(POR_MPU_M6_PRBAR19_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR19_U_SMXP_4_1, REGION19_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR19_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR19_U_SMXP_4_1, REGION19_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR19_U_SMXP_4_1, REGION19_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR19_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR19_U_SMXP_4_1, 0x213e948)
    FIELD(POR_MPU_M6_PRLAR19_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR19_U_SMXP_4_1, REGION19_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR19_U_SMXP_4_1, REGION19_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR20_U_SMXP_4_1, 0x213e950)
    FIELD(POR_MPU_M6_PRBAR20_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR20_U_SMXP_4_1, REGION20_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR20_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR20_U_SMXP_4_1, REGION20_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR20_U_SMXP_4_1, REGION20_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR20_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR20_U_SMXP_4_1, 0x213e958)
    FIELD(POR_MPU_M6_PRLAR20_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR20_U_SMXP_4_1, REGION20_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR20_U_SMXP_4_1, REGION20_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR21_U_SMXP_4_1, 0x213e960)
    FIELD(POR_MPU_M6_PRBAR21_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR21_U_SMXP_4_1, REGION21_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR21_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR21_U_SMXP_4_1, REGION21_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR21_U_SMXP_4_1, REGION21_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR21_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR21_U_SMXP_4_1, 0x213e968)
    FIELD(POR_MPU_M6_PRLAR21_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR21_U_SMXP_4_1, REGION21_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR21_U_SMXP_4_1, REGION21_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR22_U_SMXP_4_1, 0x213e970)
    FIELD(POR_MPU_M6_PRBAR22_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR22_U_SMXP_4_1, REGION22_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR22_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR22_U_SMXP_4_1, REGION22_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR22_U_SMXP_4_1, REGION22_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR22_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR22_U_SMXP_4_1, 0x213e978)
    FIELD(POR_MPU_M6_PRLAR22_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR22_U_SMXP_4_1, REGION22_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR22_U_SMXP_4_1, REGION22_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR23_U_SMXP_4_1, 0x213e980)
    FIELD(POR_MPU_M6_PRBAR23_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR23_U_SMXP_4_1, REGION23_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR23_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR23_U_SMXP_4_1, REGION23_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR23_U_SMXP_4_1, REGION23_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR23_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR23_U_SMXP_4_1, 0x213e988)
    FIELD(POR_MPU_M6_PRLAR23_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR23_U_SMXP_4_1, REGION23_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR23_U_SMXP_4_1, REGION23_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR24_U_SMXP_4_1, 0x213e990)
    FIELD(POR_MPU_M6_PRBAR24_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR24_U_SMXP_4_1, REGION24_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR24_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR24_U_SMXP_4_1, REGION24_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR24_U_SMXP_4_1, REGION24_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR24_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR24_U_SMXP_4_1, 0x213e998)
    FIELD(POR_MPU_M6_PRLAR24_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR24_U_SMXP_4_1, REGION24_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR24_U_SMXP_4_1, REGION24_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR25_U_SMXP_4_1, 0x213e9a0)
    FIELD(POR_MPU_M6_PRBAR25_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR25_U_SMXP_4_1, REGION25_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR25_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR25_U_SMXP_4_1, REGION25_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR25_U_SMXP_4_1, REGION25_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR25_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR25_U_SMXP_4_1, 0x213e9a8)
    FIELD(POR_MPU_M6_PRLAR25_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR25_U_SMXP_4_1, REGION25_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR25_U_SMXP_4_1, REGION25_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR26_U_SMXP_4_1, 0x213e9b0)
    FIELD(POR_MPU_M6_PRBAR26_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR26_U_SMXP_4_1, REGION26_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR26_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR26_U_SMXP_4_1, REGION26_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR26_U_SMXP_4_1, REGION26_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR26_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR26_U_SMXP_4_1, 0x213e9b8)
    FIELD(POR_MPU_M6_PRLAR26_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR26_U_SMXP_4_1, REGION26_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR26_U_SMXP_4_1, REGION26_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR27_U_SMXP_4_1, 0x213e9c0)
    FIELD(POR_MPU_M6_PRBAR27_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR27_U_SMXP_4_1, REGION27_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR27_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR27_U_SMXP_4_1, REGION27_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR27_U_SMXP_4_1, REGION27_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR27_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR27_U_SMXP_4_1, 0x213e9c8)
    FIELD(POR_MPU_M6_PRLAR27_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR27_U_SMXP_4_1, REGION27_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR27_U_SMXP_4_1, REGION27_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR28_U_SMXP_4_1, 0x213e9d0)
    FIELD(POR_MPU_M6_PRBAR28_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR28_U_SMXP_4_1, REGION28_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR28_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR28_U_SMXP_4_1, REGION28_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR28_U_SMXP_4_1, REGION28_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR28_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR28_U_SMXP_4_1, 0x213e9d8)
    FIELD(POR_MPU_M6_PRLAR28_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR28_U_SMXP_4_1, REGION28_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR28_U_SMXP_4_1, REGION28_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR29_U_SMXP_4_1, 0x213e9e0)
    FIELD(POR_MPU_M6_PRBAR29_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR29_U_SMXP_4_1, REGION29_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR29_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR29_U_SMXP_4_1, REGION29_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR29_U_SMXP_4_1, REGION29_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR29_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR29_U_SMXP_4_1, 0x213e9e8)
    FIELD(POR_MPU_M6_PRLAR29_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR29_U_SMXP_4_1, REGION29_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR29_U_SMXP_4_1, REGION29_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR30_U_SMXP_4_1, 0x213e9f0)
    FIELD(POR_MPU_M6_PRBAR30_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR30_U_SMXP_4_1, REGION30_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR30_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR30_U_SMXP_4_1, REGION30_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR30_U_SMXP_4_1, REGION30_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR30_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR30_U_SMXP_4_1, 0x213e9f8)
    FIELD(POR_MPU_M6_PRLAR30_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR30_U_SMXP_4_1, REGION30_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR30_U_SMXP_4_1, REGION30_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR31_U_SMXP_4_1, 0x213ea00)
    FIELD(POR_MPU_M6_PRBAR31_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR31_U_SMXP_4_1, REGION31_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR31_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR31_U_SMXP_4_1, REGION31_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR31_U_SMXP_4_1, REGION31_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR31_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR31_U_SMXP_4_1, 0x213ea08)
    FIELD(POR_MPU_M6_PRLAR31_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR31_U_SMXP_4_1, REGION31_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR31_U_SMXP_4_1, REGION31_EN, 0, 1)
REG32(POR_MPU_M7_CTL_U_SMXP_4_1, 0x213ec00)
    FIELD(POR_MPU_M7_CTL_U_SMXP_4_1, M7_EN, 2, 1)
    FIELD(POR_MPU_M7_CTL_U_SMXP_4_1, M7_ACTION, 0, 2)
REG32(POR_MPU_M7_PRBAR0_U_SMXP_4_1, 0x213ec10)
    FIELD(POR_MPU_M7_PRBAR0_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR0_U_SMXP_4_1, REGION0_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR0_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR0_U_SMXP_4_1, REGION0_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR0_U_SMXP_4_1, REGION0_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR0_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR0_U_SMXP_4_1, 0x213ec18)
    FIELD(POR_MPU_M7_PRLAR0_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR0_U_SMXP_4_1, REGION0_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR0_U_SMXP_4_1, REGION0_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR1_U_SMXP_4_1, 0x213ec20)
    FIELD(POR_MPU_M7_PRBAR1_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR1_U_SMXP_4_1, REGION1_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR1_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR1_U_SMXP_4_1, REGION1_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR1_U_SMXP_4_1, REGION1_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR1_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR1_U_SMXP_4_1, 0x213ec28)
    FIELD(POR_MPU_M7_PRLAR1_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR1_U_SMXP_4_1, REGION1_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR1_U_SMXP_4_1, REGION1_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR2_U_SMXP_4_1, 0x213ec30)
    FIELD(POR_MPU_M7_PRBAR2_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR2_U_SMXP_4_1, REGION2_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR2_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR2_U_SMXP_4_1, REGION2_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR2_U_SMXP_4_1, REGION2_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR2_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR2_U_SMXP_4_1, 0x213ec38)
    FIELD(POR_MPU_M7_PRLAR2_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR2_U_SMXP_4_1, REGION2_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR2_U_SMXP_4_1, REGION2_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR3_U_SMXP_4_1, 0x213ec40)
    FIELD(POR_MPU_M7_PRBAR3_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR3_U_SMXP_4_1, REGION3_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR3_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR3_U_SMXP_4_1, REGION3_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR3_U_SMXP_4_1, REGION3_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR3_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR3_U_SMXP_4_1, 0x213ec48)
    FIELD(POR_MPU_M7_PRLAR3_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR3_U_SMXP_4_1, REGION3_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR3_U_SMXP_4_1, REGION3_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR4_U_SMXP_4_1, 0x213ec50)
    FIELD(POR_MPU_M7_PRBAR4_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR4_U_SMXP_4_1, REGION4_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR4_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR4_U_SMXP_4_1, REGION4_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR4_U_SMXP_4_1, REGION4_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR4_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR4_U_SMXP_4_1, 0x213ec58)
    FIELD(POR_MPU_M7_PRLAR4_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR4_U_SMXP_4_1, REGION4_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR4_U_SMXP_4_1, REGION4_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR5_U_SMXP_4_1, 0x213ec60)
    FIELD(POR_MPU_M7_PRBAR5_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR5_U_SMXP_4_1, REGION5_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR5_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR5_U_SMXP_4_1, REGION5_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR5_U_SMXP_4_1, REGION5_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR5_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR5_U_SMXP_4_1, 0x213ec68)
    FIELD(POR_MPU_M7_PRLAR5_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR5_U_SMXP_4_1, REGION5_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR5_U_SMXP_4_1, REGION5_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR6_U_SMXP_4_1, 0x213ec70)
    FIELD(POR_MPU_M7_PRBAR6_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR6_U_SMXP_4_1, REGION6_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR6_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR6_U_SMXP_4_1, REGION6_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR6_U_SMXP_4_1, REGION6_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR6_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR6_U_SMXP_4_1, 0x213ec78)
    FIELD(POR_MPU_M7_PRLAR6_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR6_U_SMXP_4_1, REGION6_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR6_U_SMXP_4_1, REGION6_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR7_U_SMXP_4_1, 0x213ec80)
    FIELD(POR_MPU_M7_PRBAR7_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR7_U_SMXP_4_1, REGION7_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR7_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR7_U_SMXP_4_1, REGION7_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR7_U_SMXP_4_1, REGION7_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR7_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR7_U_SMXP_4_1, 0x213ec88)
    FIELD(POR_MPU_M7_PRLAR7_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR7_U_SMXP_4_1, REGION7_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR7_U_SMXP_4_1, REGION7_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR8_U_SMXP_4_1, 0x213ec90)
    FIELD(POR_MPU_M7_PRBAR8_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR8_U_SMXP_4_1, REGION8_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR8_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR8_U_SMXP_4_1, REGION8_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR8_U_SMXP_4_1, REGION8_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR8_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR8_U_SMXP_4_1, 0x213ec98)
    FIELD(POR_MPU_M7_PRLAR8_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR8_U_SMXP_4_1, REGION8_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR8_U_SMXP_4_1, REGION8_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR9_U_SMXP_4_1, 0x213eca0)
    FIELD(POR_MPU_M7_PRBAR9_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR9_U_SMXP_4_1, REGION9_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR9_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR9_U_SMXP_4_1, REGION9_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR9_U_SMXP_4_1, REGION9_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR9_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR9_U_SMXP_4_1, 0x213eca8)
    FIELD(POR_MPU_M7_PRLAR9_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR9_U_SMXP_4_1, REGION9_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR9_U_SMXP_4_1, REGION9_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR10_U_SMXP_4_1, 0x213ecb0)
    FIELD(POR_MPU_M7_PRBAR10_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR10_U_SMXP_4_1, REGION10_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR10_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR10_U_SMXP_4_1, REGION10_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR10_U_SMXP_4_1, REGION10_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR10_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR10_U_SMXP_4_1, 0x213ecb8)
    FIELD(POR_MPU_M7_PRLAR10_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR10_U_SMXP_4_1, REGION10_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR10_U_SMXP_4_1, REGION10_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR11_U_SMXP_4_1, 0x213ecc0)
    FIELD(POR_MPU_M7_PRBAR11_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR11_U_SMXP_4_1, REGION11_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR11_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR11_U_SMXP_4_1, REGION11_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR11_U_SMXP_4_1, REGION11_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR11_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR11_U_SMXP_4_1, 0x213ecc8)
    FIELD(POR_MPU_M7_PRLAR11_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR11_U_SMXP_4_1, REGION11_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR11_U_SMXP_4_1, REGION11_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR12_U_SMXP_4_1, 0x213ecd0)
    FIELD(POR_MPU_M7_PRBAR12_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR12_U_SMXP_4_1, REGION12_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR12_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR12_U_SMXP_4_1, REGION12_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR12_U_SMXP_4_1, REGION12_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR12_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR12_U_SMXP_4_1, 0x213ecd8)
    FIELD(POR_MPU_M7_PRLAR12_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR12_U_SMXP_4_1, REGION12_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR12_U_SMXP_4_1, REGION12_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR13_U_SMXP_4_1, 0x213ece0)
    FIELD(POR_MPU_M7_PRBAR13_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR13_U_SMXP_4_1, REGION13_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR13_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR13_U_SMXP_4_1, REGION13_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR13_U_SMXP_4_1, REGION13_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR13_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR13_U_SMXP_4_1, 0x213ece8)
    FIELD(POR_MPU_M7_PRLAR13_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR13_U_SMXP_4_1, REGION13_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR13_U_SMXP_4_1, REGION13_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR14_U_SMXP_4_1, 0x213ecf0)
    FIELD(POR_MPU_M7_PRBAR14_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR14_U_SMXP_4_1, REGION14_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR14_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR14_U_SMXP_4_1, REGION14_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR14_U_SMXP_4_1, REGION14_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR14_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR14_U_SMXP_4_1, 0x213ecf8)
    FIELD(POR_MPU_M7_PRLAR14_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR14_U_SMXP_4_1, REGION14_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR14_U_SMXP_4_1, REGION14_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR15_U_SMXP_4_1, 0x213ed00)
    FIELD(POR_MPU_M7_PRBAR15_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR15_U_SMXP_4_1, REGION15_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR15_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR15_U_SMXP_4_1, REGION15_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR15_U_SMXP_4_1, REGION15_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR15_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR15_U_SMXP_4_1, 0x213ed08)
    FIELD(POR_MPU_M7_PRLAR15_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR15_U_SMXP_4_1, REGION15_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR15_U_SMXP_4_1, REGION15_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR16_U_SMXP_4_1, 0x213ed10)
    FIELD(POR_MPU_M7_PRBAR16_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR16_U_SMXP_4_1, REGION16_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR16_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR16_U_SMXP_4_1, REGION16_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR16_U_SMXP_4_1, REGION16_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR16_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR16_U_SMXP_4_1, 0x213ed18)
    FIELD(POR_MPU_M7_PRLAR16_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR16_U_SMXP_4_1, REGION16_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR16_U_SMXP_4_1, REGION16_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR17_U_SMXP_4_1, 0x213ed20)
    FIELD(POR_MPU_M7_PRBAR17_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR17_U_SMXP_4_1, REGION17_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR17_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR17_U_SMXP_4_1, REGION17_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR17_U_SMXP_4_1, REGION17_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR17_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR17_U_SMXP_4_1, 0x213ed28)
    FIELD(POR_MPU_M7_PRLAR17_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR17_U_SMXP_4_1, REGION17_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR17_U_SMXP_4_1, REGION17_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR18_U_SMXP_4_1, 0x213ed30)
    FIELD(POR_MPU_M7_PRBAR18_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR18_U_SMXP_4_1, REGION18_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR18_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR18_U_SMXP_4_1, REGION18_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR18_U_SMXP_4_1, REGION18_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR18_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR18_U_SMXP_4_1, 0x213ed38)
    FIELD(POR_MPU_M7_PRLAR18_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR18_U_SMXP_4_1, REGION18_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR18_U_SMXP_4_1, REGION18_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR19_U_SMXP_4_1, 0x213ed40)
    FIELD(POR_MPU_M7_PRBAR19_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR19_U_SMXP_4_1, REGION19_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR19_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR19_U_SMXP_4_1, REGION19_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR19_U_SMXP_4_1, REGION19_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR19_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR19_U_SMXP_4_1, 0x213ed48)
    FIELD(POR_MPU_M7_PRLAR19_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR19_U_SMXP_4_1, REGION19_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR19_U_SMXP_4_1, REGION19_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR20_U_SMXP_4_1, 0x213ed50)
    FIELD(POR_MPU_M7_PRBAR20_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR20_U_SMXP_4_1, REGION20_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR20_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR20_U_SMXP_4_1, REGION20_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR20_U_SMXP_4_1, REGION20_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR20_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR20_U_SMXP_4_1, 0x213ed58)
    FIELD(POR_MPU_M7_PRLAR20_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR20_U_SMXP_4_1, REGION20_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR20_U_SMXP_4_1, REGION20_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR21_U_SMXP_4_1, 0x213ed60)
    FIELD(POR_MPU_M7_PRBAR21_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR21_U_SMXP_4_1, REGION21_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR21_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR21_U_SMXP_4_1, REGION21_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR21_U_SMXP_4_1, REGION21_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR21_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR21_U_SMXP_4_1, 0x213ed68)
    FIELD(POR_MPU_M7_PRLAR21_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR21_U_SMXP_4_1, REGION21_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR21_U_SMXP_4_1, REGION21_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR22_U_SMXP_4_1, 0x213ed70)
    FIELD(POR_MPU_M7_PRBAR22_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR22_U_SMXP_4_1, REGION22_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR22_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR22_U_SMXP_4_1, REGION22_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR22_U_SMXP_4_1, REGION22_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR22_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR22_U_SMXP_4_1, 0x213ed78)
    FIELD(POR_MPU_M7_PRLAR22_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR22_U_SMXP_4_1, REGION22_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR22_U_SMXP_4_1, REGION22_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR23_U_SMXP_4_1, 0x213ed80)
    FIELD(POR_MPU_M7_PRBAR23_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR23_U_SMXP_4_1, REGION23_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR23_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR23_U_SMXP_4_1, REGION23_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR23_U_SMXP_4_1, REGION23_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR23_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR23_U_SMXP_4_1, 0x213ed88)
    FIELD(POR_MPU_M7_PRLAR23_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR23_U_SMXP_4_1, REGION23_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR23_U_SMXP_4_1, REGION23_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR24_U_SMXP_4_1, 0x213ed90)
    FIELD(POR_MPU_M7_PRBAR24_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR24_U_SMXP_4_1, REGION24_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR24_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR24_U_SMXP_4_1, REGION24_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR24_U_SMXP_4_1, REGION24_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR24_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR24_U_SMXP_4_1, 0x213ed98)
    FIELD(POR_MPU_M7_PRLAR24_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR24_U_SMXP_4_1, REGION24_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR24_U_SMXP_4_1, REGION24_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR25_U_SMXP_4_1, 0x213eda0)
    FIELD(POR_MPU_M7_PRBAR25_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR25_U_SMXP_4_1, REGION25_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR25_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR25_U_SMXP_4_1, REGION25_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR25_U_SMXP_4_1, REGION25_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR25_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR25_U_SMXP_4_1, 0x213eda8)
    FIELD(POR_MPU_M7_PRLAR25_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR25_U_SMXP_4_1, REGION25_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR25_U_SMXP_4_1, REGION25_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR26_U_SMXP_4_1, 0x213edb0)
    FIELD(POR_MPU_M7_PRBAR26_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR26_U_SMXP_4_1, REGION26_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR26_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR26_U_SMXP_4_1, REGION26_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR26_U_SMXP_4_1, REGION26_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR26_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR26_U_SMXP_4_1, 0x213edb8)
    FIELD(POR_MPU_M7_PRLAR26_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR26_U_SMXP_4_1, REGION26_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR26_U_SMXP_4_1, REGION26_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR27_U_SMXP_4_1, 0x213edc0)
    FIELD(POR_MPU_M7_PRBAR27_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR27_U_SMXP_4_1, REGION27_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR27_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR27_U_SMXP_4_1, REGION27_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR27_U_SMXP_4_1, REGION27_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR27_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR27_U_SMXP_4_1, 0x213edc8)
    FIELD(POR_MPU_M7_PRLAR27_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR27_U_SMXP_4_1, REGION27_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR27_U_SMXP_4_1, REGION27_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR28_U_SMXP_4_1, 0x213edd0)
    FIELD(POR_MPU_M7_PRBAR28_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR28_U_SMXP_4_1, REGION28_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR28_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR28_U_SMXP_4_1, REGION28_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR28_U_SMXP_4_1, REGION28_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR28_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR28_U_SMXP_4_1, 0x213edd8)
    FIELD(POR_MPU_M7_PRLAR28_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR28_U_SMXP_4_1, REGION28_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR28_U_SMXP_4_1, REGION28_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR29_U_SMXP_4_1, 0x213ede0)
    FIELD(POR_MPU_M7_PRBAR29_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR29_U_SMXP_4_1, REGION29_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR29_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR29_U_SMXP_4_1, REGION29_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR29_U_SMXP_4_1, REGION29_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR29_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR29_U_SMXP_4_1, 0x213ede8)
    FIELD(POR_MPU_M7_PRLAR29_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR29_U_SMXP_4_1, REGION29_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR29_U_SMXP_4_1, REGION29_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR30_U_SMXP_4_1, 0x213edf0)
    FIELD(POR_MPU_M7_PRBAR30_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR30_U_SMXP_4_1, REGION30_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR30_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR30_U_SMXP_4_1, REGION30_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR30_U_SMXP_4_1, REGION30_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR30_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR30_U_SMXP_4_1, 0x213edf8)
    FIELD(POR_MPU_M7_PRLAR30_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR30_U_SMXP_4_1, REGION30_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR30_U_SMXP_4_1, REGION30_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR31_U_SMXP_4_1, 0x213ee00)
    FIELD(POR_MPU_M7_PRBAR31_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR31_U_SMXP_4_1, REGION31_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR31_U_SMXP_4_1, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR31_U_SMXP_4_1, REGION31_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR31_U_SMXP_4_1, REGION31_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR31_U_SMXP_4_1, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR31_U_SMXP_4_1, 0x213ee08)
    FIELD(POR_MPU_M7_PRLAR31_U_SMXP_4_1, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR31_U_SMXP_4_1, REGION31_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR31_U_SMXP_4_1, REGION31_EN, 0, 1)
REG32(POR_RNSAM_NODE_INFO_U_CXRH_NID264, 0x2150000)
    FIELD(POR_RNSAM_NODE_INFO_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_RNSAM_NODE_INFO_U_CXRH_NID264, LOGICAL_ID, 32, 16)
    FIELD(POR_RNSAM_NODE_INFO_U_CXRH_NID264, NODE_ID, 16, 16)
    FIELD(POR_RNSAM_NODE_INFO_U_CXRH_NID264, NODE_TYPE, 0, 16)
REG32(POR_RNSAM_CHILD_INFO_U_CXRH_NID264, 0x2150080)
    FIELD(POR_RNSAM_CHILD_INFO_U_CXRH_NID264, RESERVED_32, 32, 32)
    FIELD(POR_RNSAM_CHILD_INFO_U_CXRH_NID264, CHILD_PTR_OFFSET, 16, 16)
    FIELD(POR_RNSAM_CHILD_INFO_U_CXRH_NID264, CHILD_COUNT, 0, 16)
REG32(POR_RNSAM_UNIT_INFO_U_CXRH_NID264, 0x2150900)
    FIELD(POR_RNSAM_UNIT_INFO_U_CXRH_NID264, RESERVED_37, 37, 27)
    FIELD(POR_RNSAM_UNIT_INFO_U_CXRH_NID264, NUM_NON_HASH_GROUP, 32, 5)
    FIELD(POR_RNSAM_UNIT_INFO_U_CXRH_NID264, RESERVED_20, 20, 12)
    FIELD(POR_RNSAM_UNIT_INFO_U_CXRH_NID264, NUM_SYS_CACHE_GROUP, 16, 4)
    FIELD(POR_RNSAM_UNIT_INFO_U_CXRH_NID264, NUM_HNF, 0, 8)
REG32(POR_RNSAM_SECURE_REGISTER_GROUPS_OVERRIDE_U_CXRH_NID264, 0x2150980)
    FIELD(POR_RNSAM_SECURE_REGISTER_GROUPS_OVERRIDE_U_CXRH_NID264, MEM_RANGE, 0, 1)
REG32(RNSAM_STATUS_U_CXRH_NID264, 0x2150c00)
    FIELD(RNSAM_STATUS_U_CXRH_NID264, NSTALL_REQ, 1, 1)
    FIELD(RNSAM_STATUS_U_CXRH_NID264, USE_DEFAULT_NODE, 0, 1)
REG32(NON_HASH_MEM_REGION_REG0_U_CXRH_NID264, 0x2150c08)
    FIELD(NON_HASH_MEM_REGION_REG0_U_CXRH_NID264, RESERVED_63, 63, 1)
    FIELD(NON_HASH_MEM_REGION_REG0_U_CXRH_NID264, REGION1_BASE_ADDR, 41, 22)
    FIELD(NON_HASH_MEM_REGION_REG0_U_CXRH_NID264, REGION1_SIZE, 36, 5)
    FIELD(NON_HASH_MEM_REGION_REG0_U_CXRH_NID264, REGION1_TARGET_TYPE, 34, 2)
    FIELD(NON_HASH_MEM_REGION_REG0_U_CXRH_NID264, RESERVED_33, 33, 1)
    FIELD(NON_HASH_MEM_REGION_REG0_U_CXRH_NID264, REGION1_VALID, 32, 1)
    FIELD(NON_HASH_MEM_REGION_REG0_U_CXRH_NID264, RESERVED_31, 31, 1)
    FIELD(NON_HASH_MEM_REGION_REG0_U_CXRH_NID264, REGION0_BASE_ADDR, 9, 22)
    FIELD(NON_HASH_MEM_REGION_REG0_U_CXRH_NID264, REGION0_SIZE, 4, 5)
    FIELD(NON_HASH_MEM_REGION_REG0_U_CXRH_NID264, REGION0_TARGET_TYPE, 2, 2)
    FIELD(NON_HASH_MEM_REGION_REG0_U_CXRH_NID264, REGION0_VALID, 0, 1)
REG32(NON_HASH_MEM_REGION_REG1_U_CXRH_NID264, 0x2150c10)
    FIELD(NON_HASH_MEM_REGION_REG1_U_CXRH_NID264, RESERVED_63, 63, 1)
    FIELD(NON_HASH_MEM_REGION_REG1_U_CXRH_NID264, REGION3_BASE_ADDR, 41, 22)
    FIELD(NON_HASH_MEM_REGION_REG1_U_CXRH_NID264, REGION3_SIZE, 36, 5)
    FIELD(NON_HASH_MEM_REGION_REG1_U_CXRH_NID264, REGION3_TARGET_TYPE, 34, 2)
    FIELD(NON_HASH_MEM_REGION_REG1_U_CXRH_NID264, RESERVED_33, 33, 1)
    FIELD(NON_HASH_MEM_REGION_REG1_U_CXRH_NID264, REGION3_VALID, 32, 1)
    FIELD(NON_HASH_MEM_REGION_REG1_U_CXRH_NID264, RESERVED_31, 31, 1)
    FIELD(NON_HASH_MEM_REGION_REG1_U_CXRH_NID264, REGION2_BASE_ADDR, 9, 22)
    FIELD(NON_HASH_MEM_REGION_REG1_U_CXRH_NID264, REGION2_SIZE, 4, 5)
    FIELD(NON_HASH_MEM_REGION_REG1_U_CXRH_NID264, REGION2_TARGET_TYPE, 2, 2)
    FIELD(NON_HASH_MEM_REGION_REG1_U_CXRH_NID264, REGION2_VALID, 0, 1)
REG32(NON_HASH_MEM_REGION_REG2_U_CXRH_NID264, 0x2150c18)
    FIELD(NON_HASH_MEM_REGION_REG2_U_CXRH_NID264, RESERVED_63, 63, 1)
    FIELD(NON_HASH_MEM_REGION_REG2_U_CXRH_NID264, REGION5_BASE_ADDR, 41, 22)
    FIELD(NON_HASH_MEM_REGION_REG2_U_CXRH_NID264, REGION5_SIZE, 36, 5)
    FIELD(NON_HASH_MEM_REGION_REG2_U_CXRH_NID264, REGION5_TARGET_TYPE, 34, 2)
    FIELD(NON_HASH_MEM_REGION_REG2_U_CXRH_NID264, RESERVED_33, 33, 1)
    FIELD(NON_HASH_MEM_REGION_REG2_U_CXRH_NID264, REGION5_VALID, 32, 1)
    FIELD(NON_HASH_MEM_REGION_REG2_U_CXRH_NID264, RESERVED_31, 31, 1)
    FIELD(NON_HASH_MEM_REGION_REG2_U_CXRH_NID264, REGION4_BASE_ADDR, 9, 22)
    FIELD(NON_HASH_MEM_REGION_REG2_U_CXRH_NID264, REGION4_SIZE, 4, 5)
    FIELD(NON_HASH_MEM_REGION_REG2_U_CXRH_NID264, REGION4_TARGET_TYPE, 2, 2)
    FIELD(NON_HASH_MEM_REGION_REG2_U_CXRH_NID264, REGION4_VALID, 0, 1)
REG32(NON_HASH_MEM_REGION_REG3_U_CXRH_NID264, 0x2150c20)
    FIELD(NON_HASH_MEM_REGION_REG3_U_CXRH_NID264, RESERVED_63, 63, 1)
    FIELD(NON_HASH_MEM_REGION_REG3_U_CXRH_NID264, REGION7_BASE_ADDR, 41, 22)
    FIELD(NON_HASH_MEM_REGION_REG3_U_CXRH_NID264, REGION7_SIZE, 36, 5)
    FIELD(NON_HASH_MEM_REGION_REG3_U_CXRH_NID264, REGION7_TARGET_TYPE, 34, 2)
    FIELD(NON_HASH_MEM_REGION_REG3_U_CXRH_NID264, RESERVED_33, 33, 1)
    FIELD(NON_HASH_MEM_REGION_REG3_U_CXRH_NID264, REGION7_VALID, 32, 1)
    FIELD(NON_HASH_MEM_REGION_REG3_U_CXRH_NID264, RESERVED_31, 31, 1)
    FIELD(NON_HASH_MEM_REGION_REG3_U_CXRH_NID264, REGION6_BASE_ADDR, 9, 22)
    FIELD(NON_HASH_MEM_REGION_REG3_U_CXRH_NID264, REGION6_SIZE, 4, 5)
    FIELD(NON_HASH_MEM_REGION_REG3_U_CXRH_NID264, REGION6_TARGET_TYPE, 2, 2)
    FIELD(NON_HASH_MEM_REGION_REG3_U_CXRH_NID264, REGION6_VALID, 0, 1)
REG32(NON_HASH_TGT_NODEID0_U_CXRH_NID264, 0x2150c30)
    FIELD(NON_HASH_TGT_NODEID0_U_CXRH_NID264, RESERVED_47, 47, 17)
    FIELD(NON_HASH_TGT_NODEID0_U_CXRH_NID264, NODEID_3, 36, 11)
    FIELD(NON_HASH_TGT_NODEID0_U_CXRH_NID264, RESERVED_35, 35, 1)
    FIELD(NON_HASH_TGT_NODEID0_U_CXRH_NID264, NODEID_2, 24, 11)
    FIELD(NON_HASH_TGT_NODEID0_U_CXRH_NID264, RESERVED_23, 23, 1)
    FIELD(NON_HASH_TGT_NODEID0_U_CXRH_NID264, NODEID_1, 12, 11)
    FIELD(NON_HASH_TGT_NODEID0_U_CXRH_NID264, RESERVED_11, 11, 1)
    FIELD(NON_HASH_TGT_NODEID0_U_CXRH_NID264, NODEID_0, 0, 11)
REG32(NON_HASH_TGT_NODEID1_U_CXRH_NID264, 0x2150c38)
    FIELD(NON_HASH_TGT_NODEID1_U_CXRH_NID264, RESERVED_47, 47, 17)
    FIELD(NON_HASH_TGT_NODEID1_U_CXRH_NID264, NODEID_7, 36, 11)
    FIELD(NON_HASH_TGT_NODEID1_U_CXRH_NID264, RESERVED_35, 35, 1)
    FIELD(NON_HASH_TGT_NODEID1_U_CXRH_NID264, NODEID_6, 24, 11)
    FIELD(NON_HASH_TGT_NODEID1_U_CXRH_NID264, RESERVED_23, 23, 1)
    FIELD(NON_HASH_TGT_NODEID1_U_CXRH_NID264, NODEID_5, 12, 11)
    FIELD(NON_HASH_TGT_NODEID1_U_CXRH_NID264, RESERVED_11, 11, 1)
    FIELD(NON_HASH_TGT_NODEID1_U_CXRH_NID264, NODEID_4, 0, 11)
REG32(NON_HASH_TGT_NODEID2_U_CXRH_NID264, 0x2150c40)
    FIELD(NON_HASH_TGT_NODEID2_U_CXRH_NID264, RESERVED_23, 23, 41)
    FIELD(NON_HASH_TGT_NODEID2_U_CXRH_NID264, NODEID_9, 12, 11)
    FIELD(NON_HASH_TGT_NODEID2_U_CXRH_NID264, RESERVED_11, 11, 1)
    FIELD(NON_HASH_TGT_NODEID2_U_CXRH_NID264, NODEID_8, 0, 11)
REG32(SYS_CACHE_GRP_REGION0_U_CXRH_NID264, 0x2150c48)
    FIELD(SYS_CACHE_GRP_REGION0_U_CXRH_NID264, RESERVED_63, 63, 1)
    FIELD(SYS_CACHE_GRP_REGION0_U_CXRH_NID264, REGION1_BASE_ADDR, 41, 22)
    FIELD(SYS_CACHE_GRP_REGION0_U_CXRH_NID264, REGION1_SIZE, 36, 5)
    FIELD(SYS_CACHE_GRP_REGION0_U_CXRH_NID264, REGION1_TARGET_TYPE, 34, 2)
    FIELD(SYS_CACHE_GRP_REGION0_U_CXRH_NID264, REGION1_NONHASH_REG_EN, 33, 1)
    FIELD(SYS_CACHE_GRP_REGION0_U_CXRH_NID264, REGION1_VALID, 32, 1)
    FIELD(SYS_CACHE_GRP_REGION0_U_CXRH_NID264, RESERVED_31, 31, 1)
    FIELD(SYS_CACHE_GRP_REGION0_U_CXRH_NID264, REGION0_BASE_ADDR, 9, 22)
    FIELD(SYS_CACHE_GRP_REGION0_U_CXRH_NID264, REGION0_SIZE, 4, 5)
    FIELD(SYS_CACHE_GRP_REGION0_U_CXRH_NID264, REGION0_TARGET_TYPE, 2, 2)
    FIELD(SYS_CACHE_GRP_REGION0_U_CXRH_NID264, REGION0_VALID, 0, 1)
REG32(SYS_CACHE_GRP_REGION1_U_CXRH_NID264, 0x2150c50)
    FIELD(SYS_CACHE_GRP_REGION1_U_CXRH_NID264, RESERVED_63, 63, 1)
    FIELD(SYS_CACHE_GRP_REGION1_U_CXRH_NID264, REGION3_BASE_ADDR, 41, 22)
    FIELD(SYS_CACHE_GRP_REGION1_U_CXRH_NID264, REGION3_SIZE, 36, 5)
    FIELD(SYS_CACHE_GRP_REGION1_U_CXRH_NID264, REGION3_TARGET_TYPE, 34, 2)
    FIELD(SYS_CACHE_GRP_REGION1_U_CXRH_NID264, REGION3_NONHASH_REG_EN, 33, 1)
    FIELD(SYS_CACHE_GRP_REGION1_U_CXRH_NID264, REGION3_VALID, 32, 1)
    FIELD(SYS_CACHE_GRP_REGION1_U_CXRH_NID264, RESERVED_31, 31, 1)
    FIELD(SYS_CACHE_GRP_REGION1_U_CXRH_NID264, REGION2_BASE_ADDR, 9, 22)
    FIELD(SYS_CACHE_GRP_REGION1_U_CXRH_NID264, REGION2_SIZE, 4, 5)
    FIELD(SYS_CACHE_GRP_REGION1_U_CXRH_NID264, REGION2_TARGET_TYPE, 2, 2)
    FIELD(SYS_CACHE_GRP_REGION1_U_CXRH_NID264, REGION2_NONHASH_REG_EN, 1, 1)
    FIELD(SYS_CACHE_GRP_REGION1_U_CXRH_NID264, REGION2_VALID, 0, 1)
REG32(SYS_CACHE_GRP_HN_NODEID_REG0_U_CXRH_NID264, 0x2150c58)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG0_U_CXRH_NID264, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG0_U_CXRH_NID264, NODEID_3, 36, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG0_U_CXRH_NID264, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG0_U_CXRH_NID264, NODEID_2, 24, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG0_U_CXRH_NID264, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG0_U_CXRH_NID264, NODEID_1, 12, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG0_U_CXRH_NID264, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG0_U_CXRH_NID264, NODEID_0, 0, 11)
REG32(SYS_CACHE_GRP_HN_NODEID_REG1_U_CXRH_NID264, 0x2150c60)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG1_U_CXRH_NID264, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG1_U_CXRH_NID264, NODEID_7, 36, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG1_U_CXRH_NID264, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG1_U_CXRH_NID264, NODEID_6, 24, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG1_U_CXRH_NID264, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG1_U_CXRH_NID264, NODEID_5, 12, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG1_U_CXRH_NID264, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG1_U_CXRH_NID264, NODEID_4, 0, 11)
REG32(SYS_CACHE_GRP_HN_NODEID_REG2_U_CXRH_NID264, 0x2150c68)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG2_U_CXRH_NID264, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG2_U_CXRH_NID264, NODEID_11, 36, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG2_U_CXRH_NID264, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG2_U_CXRH_NID264, NODEID_10, 24, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG2_U_CXRH_NID264, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG2_U_CXRH_NID264, NODEID_9, 12, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG2_U_CXRH_NID264, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG2_U_CXRH_NID264, NODEID_8, 0, 11)
REG32(SYS_CACHE_GRP_HN_NODEID_REG3_U_CXRH_NID264, 0x2150c70)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG3_U_CXRH_NID264, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG3_U_CXRH_NID264, NODEID_15, 36, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG3_U_CXRH_NID264, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG3_U_CXRH_NID264, NODEID_14, 24, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG3_U_CXRH_NID264, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG3_U_CXRH_NID264, NODEID_13, 12, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG3_U_CXRH_NID264, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG3_U_CXRH_NID264, NODEID_12, 0, 11)
REG32(SYS_CACHE_GRP_HN_NODEID_REG4_U_CXRH_NID264, 0x2150c78)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG4_U_CXRH_NID264, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG4_U_CXRH_NID264, NODEID_19, 36, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG4_U_CXRH_NID264, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG4_U_CXRH_NID264, NODEID_18, 24, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG4_U_CXRH_NID264, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG4_U_CXRH_NID264, NODEID_17, 12, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG4_U_CXRH_NID264, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG4_U_CXRH_NID264, NODEID_16, 0, 11)
REG32(SYS_CACHE_GRP_HN_NODEID_REG5_U_CXRH_NID264, 0x2150c80)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG5_U_CXRH_NID264, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG5_U_CXRH_NID264, NODEID_23, 36, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG5_U_CXRH_NID264, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG5_U_CXRH_NID264, NODEID_22, 24, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG5_U_CXRH_NID264, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG5_U_CXRH_NID264, NODEID_21, 12, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG5_U_CXRH_NID264, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG5_U_CXRH_NID264, NODEID_20, 0, 11)
REG32(SYS_CACHE_GRP_HN_NODEID_REG6_U_CXRH_NID264, 0x2150c88)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG6_U_CXRH_NID264, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG6_U_CXRH_NID264, NODEID_27, 36, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG6_U_CXRH_NID264, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG6_U_CXRH_NID264, NODEID_26, 24, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG6_U_CXRH_NID264, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG6_U_CXRH_NID264, NODEID_25, 12, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG6_U_CXRH_NID264, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG6_U_CXRH_NID264, NODEID_24, 0, 11)
REG32(SYS_CACHE_GRP_HN_NODEID_REG7_U_CXRH_NID264, 0x2150c90)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG7_U_CXRH_NID264, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG7_U_CXRH_NID264, NODEID_31, 36, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG7_U_CXRH_NID264, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG7_U_CXRH_NID264, NODEID_30, 24, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG7_U_CXRH_NID264, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG7_U_CXRH_NID264, NODEID_29, 12, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG7_U_CXRH_NID264, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG7_U_CXRH_NID264, NODEID_28, 0, 11)
REG32(SYS_CACHE_GRP_NONHASH_NODEID_U_CXRH_NID264, 0x2150c98)
    FIELD(SYS_CACHE_GRP_NONHASH_NODEID_U_CXRH_NID264, RESERVED_35, 35, 29)
    FIELD(SYS_CACHE_GRP_NONHASH_NODEID_U_CXRH_NID264, SCG3_NODEID, 24, 11)
    FIELD(SYS_CACHE_GRP_NONHASH_NODEID_U_CXRH_NID264, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_NONHASH_NODEID_U_CXRH_NID264, SCG2_NODEID, 12, 11)
    FIELD(SYS_CACHE_GRP_NONHASH_NODEID_U_CXRH_NID264, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_NONHASH_NODEID_U_CXRH_NID264, SCG1_NODEID, 0, 11)
REG32(SYS_CACHE_GROUP_HN_COUNT_U_CXRH_NID264, 0x2150d00)
    FIELD(SYS_CACHE_GROUP_HN_COUNT_U_CXRH_NID264, RESERVED_31, 31, 33)
    FIELD(SYS_CACHE_GROUP_HN_COUNT_U_CXRH_NID264, SCG3_NUM_HNF, 24, 7)
    FIELD(SYS_CACHE_GROUP_HN_COUNT_U_CXRH_NID264, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GROUP_HN_COUNT_U_CXRH_NID264, SCG2_NUM_HNF, 16, 7)
    FIELD(SYS_CACHE_GROUP_HN_COUNT_U_CXRH_NID264, RESERVED_15, 15, 1)
    FIELD(SYS_CACHE_GROUP_HN_COUNT_U_CXRH_NID264, SCG1_NUM_HNF, 8, 7)
    FIELD(SYS_CACHE_GROUP_HN_COUNT_U_CXRH_NID264, SCG0_NUM_HNF, 0, 7)
REG32(SYS_CACHE_GRP_SN_NODEID_REG0_U_CXRH_NID264, 0x2150d08)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG0_U_CXRH_NID264, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG0_U_CXRH_NID264, SN_NODEID_3, 36, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG0_U_CXRH_NID264, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG0_U_CXRH_NID264, SN_NODEID_2, 24, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG0_U_CXRH_NID264, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG0_U_CXRH_NID264, SN_NODEID_1, 12, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG0_U_CXRH_NID264, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG0_U_CXRH_NID264, SN_NODEID_0, 0, 11)
REG32(SYS_CACHE_GRP_SN_NODEID_REG1_U_CXRH_NID264, 0x2150d10)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG1_U_CXRH_NID264, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG1_U_CXRH_NID264, SN_NODEID_7, 36, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG1_U_CXRH_NID264, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG1_U_CXRH_NID264, SN_NODEID_6, 24, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG1_U_CXRH_NID264, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG1_U_CXRH_NID264, SN_NODEID_5, 12, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG1_U_CXRH_NID264, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG1_U_CXRH_NID264, SN_NODEID_4, 0, 11)
REG32(SYS_CACHE_GRP_SN_NODEID_REG2_U_CXRH_NID264, 0x2150d18)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG2_U_CXRH_NID264, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG2_U_CXRH_NID264, SN_NODEID_11, 36, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG2_U_CXRH_NID264, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG2_U_CXRH_NID264, SN_NODEID_10, 24, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG2_U_CXRH_NID264, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG2_U_CXRH_NID264, SN_NODEID_9, 12, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG2_U_CXRH_NID264, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG2_U_CXRH_NID264, SN_NODEID_8, 0, 11)
REG32(SYS_CACHE_GRP_SN_NODEID_REG3_U_CXRH_NID264, 0x2150d20)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG3_U_CXRH_NID264, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG3_U_CXRH_NID264, SN_NODEID_15, 36, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG3_U_CXRH_NID264, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG3_U_CXRH_NID264, SN_NODEID_14, 24, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG3_U_CXRH_NID264, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG3_U_CXRH_NID264, SN_NODEID_13, 12, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG3_U_CXRH_NID264, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG3_U_CXRH_NID264, SN_NODEID_12, 0, 11)
REG32(SYS_CACHE_GRP_SN_NODEID_REG4_U_CXRH_NID264, 0x2150d28)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG4_U_CXRH_NID264, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG4_U_CXRH_NID264, SN_NODEID_19, 36, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG4_U_CXRH_NID264, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG4_U_CXRH_NID264, SN_NODEID_18, 24, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG4_U_CXRH_NID264, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG4_U_CXRH_NID264, SN_NODEID_17, 12, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG4_U_CXRH_NID264, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG4_U_CXRH_NID264, SN_NODEID_16, 0, 11)
REG32(SYS_CACHE_GRP_SN_NODEID_REG5_U_CXRH_NID264, 0x2150d30)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG5_U_CXRH_NID264, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG5_U_CXRH_NID264, SN_NODEID_23, 36, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG5_U_CXRH_NID264, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG5_U_CXRH_NID264, SN_NODEID_22, 24, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG5_U_CXRH_NID264, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG5_U_CXRH_NID264, SN_NODEID_21, 12, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG5_U_CXRH_NID264, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG5_U_CXRH_NID264, SN_NODEID_20, 0, 11)
REG32(SYS_CACHE_GRP_SN_NODEID_REG6_U_CXRH_NID264, 0x2150d38)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG6_U_CXRH_NID264, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG6_U_CXRH_NID264, SN_NODEID_27, 36, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG6_U_CXRH_NID264, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG6_U_CXRH_NID264, SN_NODEID_26, 24, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG6_U_CXRH_NID264, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG6_U_CXRH_NID264, SN_NODEID_25, 12, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG6_U_CXRH_NID264, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG6_U_CXRH_NID264, SN_NODEID_24, 0, 11)
REG32(SYS_CACHE_GRP_SN_NODEID_REG7_U_CXRH_NID264, 0x2150d40)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG7_U_CXRH_NID264, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG7_U_CXRH_NID264, SN_NODEID_31, 36, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG7_U_CXRH_NID264, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG7_U_CXRH_NID264, SN_NODEID_30, 24, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG7_U_CXRH_NID264, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG7_U_CXRH_NID264, SN_NODEID_29, 12, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG7_U_CXRH_NID264, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG7_U_CXRH_NID264, SN_NODEID_28, 0, 11)
REG32(SYS_CACHE_GRP_SN_SAM_CFG0_U_CXRH_NID264, 0x2150d48)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG0_U_CXRH_NID264, RESERVED_46, 46, 18)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG0_U_CXRH_NID264, SCG1_TOP_ADDRESS_BIT2, 40, 6)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG0_U_CXRH_NID264, RESERVED_38, 38, 2)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG0_U_CXRH_NID264, SCG1_TOP_ADDRESS_BIT1, 32, 6)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG0_U_CXRH_NID264, RESERVED_30, 30, 2)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG0_U_CXRH_NID264, SCG1_TOP_ADDRESS_BIT0, 24, 6)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG0_U_CXRH_NID264, RESERVED_22, 22, 2)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG0_U_CXRH_NID264, SCG0_TOP_ADDRESS_BIT2, 16, 6)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG0_U_CXRH_NID264, RESERVED_14, 14, 2)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG0_U_CXRH_NID264, SCG0_TOP_ADDRESS_BIT1, 8, 6)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG0_U_CXRH_NID264, SCG0_TOP_ADDRESS_BIT0, 0, 6)
REG32(SYS_CACHE_GRP_SN_SAM_CFG1_U_CXRH_NID264, 0x2150d50)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG1_U_CXRH_NID264, RESERVED_46, 46, 18)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG1_U_CXRH_NID264, SCG3_TOP_ADDRESS_BIT2, 40, 6)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG1_U_CXRH_NID264, RESERVED_38, 38, 2)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG1_U_CXRH_NID264, SCG3_TOP_ADDRESS_BIT1, 32, 6)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG1_U_CXRH_NID264, RESERVED_30, 30, 2)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG1_U_CXRH_NID264, SCG3_TOP_ADDRESS_BIT0, 24, 6)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG1_U_CXRH_NID264, RESERVED_22, 22, 2)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG1_U_CXRH_NID264, SCG2_TOP_ADDRESS_BIT2, 16, 6)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG1_U_CXRH_NID264, RESERVED_14, 14, 2)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG1_U_CXRH_NID264, SCG2_TOP_ADDRESS_BIT1, 8, 6)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG1_U_CXRH_NID264, SCG2_TOP_ADDRESS_BIT0, 0, 6)
REG32(GIC_MEM_REGION_REG_U_CXRH_NID264, 0x2150d58)
    FIELD(GIC_MEM_REGION_REG_U_CXRH_NID264, RESERVED_63, 63, 1)
    FIELD(GIC_MEM_REGION_REG_U_CXRH_NID264, GIC_REGION_NODEID, 52, 11)
    FIELD(GIC_MEM_REGION_REG_U_CXRH_NID264, RESERVED_48, 48, 4)
    FIELD(GIC_MEM_REGION_REG_U_CXRH_NID264, GIC_REGION_BASE_ADDR, 16, 32)
    FIELD(GIC_MEM_REGION_REG_U_CXRH_NID264, GIC_REGION_SIZE, 4, 3)
    FIELD(GIC_MEM_REGION_REG_U_CXRH_NID264, GIC_REGION_TARGET_TYPE, 2, 2)
    FIELD(GIC_MEM_REGION_REG_U_CXRH_NID264, GIC_REGION_VALID, 0, 1)
REG32(SYS_CACHE_GRP_SN_ATTR_U_CXRH_NID264, 0x2150d60)
    FIELD(SYS_CACHE_GRP_SN_ATTR_U_CXRH_NID264, RESERVED_54, 54, 10)
    FIELD(SYS_CACHE_GRP_SN_ATTR_U_CXRH_NID264, SN_MODE_SYS_CACHE_GRP3, 52, 2)
    FIELD(SYS_CACHE_GRP_SN_ATTR_U_CXRH_NID264, RESERVED_49, 49, 3)
    FIELD(SYS_CACHE_GRP_SN_ATTR_U_CXRH_NID264, INV_TOP_ADDRESS_BIT_SYS_CACHE_GRP3, 48, 1)
    FIELD(SYS_CACHE_GRP_SN_ATTR_U_CXRH_NID264, RESERVED_38, 38, 10)
    FIELD(SYS_CACHE_GRP_SN_ATTR_U_CXRH_NID264, SN_MODE_SYS_CACHE_GRP2, 36, 2)
    FIELD(SYS_CACHE_GRP_SN_ATTR_U_CXRH_NID264, RESERVED_33, 33, 3)
    FIELD(SYS_CACHE_GRP_SN_ATTR_U_CXRH_NID264, INV_TOP_ADDRESS_BIT_SYS_CACHE_GRP2, 32, 1)
    FIELD(SYS_CACHE_GRP_SN_ATTR_U_CXRH_NID264, RESERVED_22, 22, 10)
    FIELD(SYS_CACHE_GRP_SN_ATTR_U_CXRH_NID264, SN_MODE_SYS_CACHE_GRP1, 20, 2)
    FIELD(SYS_CACHE_GRP_SN_ATTR_U_CXRH_NID264, RESERVED_17, 17, 3)
    FIELD(SYS_CACHE_GRP_SN_ATTR_U_CXRH_NID264, INV_TOP_ADDRESS_BIT_SYS_CACHE_GRP1, 16, 1)
    FIELD(SYS_CACHE_GRP_SN_ATTR_U_CXRH_NID264, SN_MODE_SYS_CACHE_GRP0, 4, 2)
    FIELD(SYS_CACHE_GRP_SN_ATTR_U_CXRH_NID264, INV_TOP_ADDRESS_BIT_SYS_CACHE_GRP0, 0, 1)
REG32(SYS_CACHE_GRP_HN_CPA_EN_REG_U_CXRH_NID264, 0x2150d68)
REG32(SYS_CACHE_GRP_HN_CPA_GRP_REG_U_CXRH_NID264, 0x2150d70)
    FIELD(SYS_CACHE_GRP_HN_CPA_GRP_REG_U_CXRH_NID264, RESERVED_50, 50, 14)
    FIELD(SYS_CACHE_GRP_HN_CPA_GRP_REG_U_CXRH_NID264, CPA_GRP_SCG3, 48, 2)
    FIELD(SYS_CACHE_GRP_HN_CPA_GRP_REG_U_CXRH_NID264, RESERVED_34, 34, 14)
    FIELD(SYS_CACHE_GRP_HN_CPA_GRP_REG_U_CXRH_NID264, CPA_GRP_SCG2, 32, 2)
    FIELD(SYS_CACHE_GRP_HN_CPA_GRP_REG_U_CXRH_NID264, RESERVED_18, 18, 14)
    FIELD(SYS_CACHE_GRP_HN_CPA_GRP_REG_U_CXRH_NID264, CPA_GRP_SCG1, 16, 2)
    FIELD(SYS_CACHE_GRP_HN_CPA_GRP_REG_U_CXRH_NID264, CPA_GRP_SCG0, 0, 2)
REG32(CML_PORT_AGGR_MODE_CTRL_REG_U_CXRH_NID264, 0x2150e00)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_CXRH_NID264, RESERVED_32, 32, 32)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_CXRH_NID264, REGION7_PAG_GRPID, 30, 2)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_CXRH_NID264, RESERVED_29, 29, 1)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_CXRH_NID264, REGION7_PAG_EN, 28, 1)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_CXRH_NID264, RESERVED_27, 27, 1)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_CXRH_NID264, REGION6_PAG_GRPID, 25, 2)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_CXRH_NID264, REGION6_PAG_EN, 24, 1)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_CXRH_NID264, RESERVED_23, 23, 1)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_CXRH_NID264, REGION5_PAG_GRPID, 21, 2)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_CXRH_NID264, REGION5_PAG_EN, 20, 1)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_CXRH_NID264, RESERVED_19, 19, 1)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_CXRH_NID264, REGION4_PAG_GRPID, 17, 2)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_CXRH_NID264, REGION4_PAG_EN, 16, 1)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_CXRH_NID264, RESERVED_15, 15, 1)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_CXRH_NID264, REGION3_PAG_GRPID, 13, 2)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_CXRH_NID264, REGION3_PAG_EN, 12, 1)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_CXRH_NID264, RESERVED_11, 11, 1)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_CXRH_NID264, REGION2_PAG_GRPID, 9, 2)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_CXRH_NID264, REGION2_PAG_EN, 8, 1)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_CXRH_NID264, REGION1_PAG_GRPID, 5, 2)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_CXRH_NID264, REGION1_PAG_EN, 4, 1)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_CXRH_NID264, REGION0_PAG_GRPID, 1, 2)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_CXRH_NID264, REGION0_PAG_EN, 0, 1)
REG32(CML_PORT_AGGR_GRP0_ADD_MASK_U_CXRH_NID264, 0x2150e08)
    FIELD(CML_PORT_AGGR_GRP0_ADD_MASK_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(CML_PORT_AGGR_GRP0_ADD_MASK_U_CXRH_NID264, ADDR_MASK, 6, 42)
    FIELD(CML_PORT_AGGR_GRP0_ADD_MASK_U_CXRH_NID264, RESERVED_0, 0, 6)
REG32(CML_PORT_AGGR_GRP1_ADD_MASK_U_CXRH_NID264, 0x2150e10)
    FIELD(CML_PORT_AGGR_GRP1_ADD_MASK_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(CML_PORT_AGGR_GRP1_ADD_MASK_U_CXRH_NID264, ADDR_MASK, 6, 42)
    FIELD(CML_PORT_AGGR_GRP1_ADD_MASK_U_CXRH_NID264, RESERVED_0, 0, 6)
REG32(CML_PORT_AGGR_GRP0_REG_U_CXRH_NID264, 0x2150e40)
    FIELD(CML_PORT_AGGR_GRP0_REG_U_CXRH_NID264, RESERVED_50, 50, 14)
    FIELD(CML_PORT_AGGR_GRP0_REG_U_CXRH_NID264, NUM_CXG_PAG0, 48, 2)
    FIELD(CML_PORT_AGGR_GRP0_REG_U_CXRH_NID264, RESERVED_47, 47, 1)
    FIELD(CML_PORT_AGGR_GRP0_REG_U_CXRH_NID264, PAG0_TGTID3, 36, 11)
    FIELD(CML_PORT_AGGR_GRP0_REG_U_CXRH_NID264, RESERVED_35, 35, 1)
    FIELD(CML_PORT_AGGR_GRP0_REG_U_CXRH_NID264, PAG0_TGTID2, 24, 11)
    FIELD(CML_PORT_AGGR_GRP0_REG_U_CXRH_NID264, RESERVED_23, 23, 1)
    FIELD(CML_PORT_AGGR_GRP0_REG_U_CXRH_NID264, PAG0_TGTID1, 12, 11)
    FIELD(CML_PORT_AGGR_GRP0_REG_U_CXRH_NID264, RESERVED_11, 11, 1)
    FIELD(CML_PORT_AGGR_GRP0_REG_U_CXRH_NID264, PAG0_TGTID0, 0, 11)
REG32(CML_PORT_AGGR_GRP1_REG_U_CXRH_NID264, 0x2150e48)
    FIELD(CML_PORT_AGGR_GRP1_REG_U_CXRH_NID264, RESERVED_50, 50, 14)
    FIELD(CML_PORT_AGGR_GRP1_REG_U_CXRH_NID264, NUM_CXG_PAG1, 48, 2)
    FIELD(CML_PORT_AGGR_GRP1_REG_U_CXRH_NID264, RESERVED_47, 47, 1)
    FIELD(CML_PORT_AGGR_GRP1_REG_U_CXRH_NID264, PAG1_TGTID3, 36, 11)
    FIELD(CML_PORT_AGGR_GRP1_REG_U_CXRH_NID264, RESERVED_35, 35, 1)
    FIELD(CML_PORT_AGGR_GRP1_REG_U_CXRH_NID264, PAG1_TGTID2, 24, 11)
    FIELD(CML_PORT_AGGR_GRP1_REG_U_CXRH_NID264, RESERVED_23, 23, 1)
    FIELD(CML_PORT_AGGR_GRP1_REG_U_CXRH_NID264, PAG1_TGTID1, 12, 11)
    FIELD(CML_PORT_AGGR_GRP1_REG_U_CXRH_NID264, RESERVED_11, 11, 1)
    FIELD(CML_PORT_AGGR_GRP1_REG_U_CXRH_NID264, PAG1_TGTID0, 0, 11)
REG32(SYS_CACHE_GRP_SECONDARY_REG0_U_CXRH_NID264, 0x2150f00)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG0_U_CXRH_NID264, RESERVED_63, 63, 1)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG0_U_CXRH_NID264, REGION1_SCNDRY_BASE_ADDR, 41, 22)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG0_U_CXRH_NID264, REGION1_SCNDRY_SIZE, 36, 5)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG0_U_CXRH_NID264, REGION1_SCNDRY_TARGET_TYPE, 34, 2)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG0_U_CXRH_NID264, RESERVED_33, 33, 1)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG0_U_CXRH_NID264, REGION1_SCNDRY_VALID, 32, 1)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG0_U_CXRH_NID264, RESERVED_31, 31, 1)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG0_U_CXRH_NID264, REGION0_SCNDRY_BASE_ADDR, 9, 22)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG0_U_CXRH_NID264, REGION0_SCNDRY_SIZE, 4, 5)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG0_U_CXRH_NID264, REGION0_SCNDRY_TARGET_TYPE, 2, 2)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG0_U_CXRH_NID264, REGION0_SCNDRY_VALID, 0, 1)
REG32(SYS_CACHE_GRP_SECONDARY_REG1_U_CXRH_NID264, 0x2150f08)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG1_U_CXRH_NID264, RESERVED_63, 63, 1)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG1_U_CXRH_NID264, REGION3_SCNDRY_BASE_ADDR, 41, 22)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG1_U_CXRH_NID264, REGION3_SCNDRY_SIZE, 36, 5)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG1_U_CXRH_NID264, REGION3_SCNDRY_TARGET_TYPE, 34, 2)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG1_U_CXRH_NID264, RESERVED_33, 33, 1)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG1_U_CXRH_NID264, REGION3_SCNDRY_VALID, 32, 1)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG1_U_CXRH_NID264, RESERVED_31, 31, 1)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG1_U_CXRH_NID264, REGION2_SCNDRY_BASE_ADDR, 9, 22)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG1_U_CXRH_NID264, REGION2_SCNDRY_SIZE, 4, 5)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG1_U_CXRH_NID264, REGION2_SCNDRY_TARGET_TYPE, 2, 2)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG1_U_CXRH_NID264, REGION2_SCNDRY_VALID, 0, 1)
REG32(SYS_CACHE_GRP_CAL_MODE_REG_U_CXRH_NID264, 0x2150f10)
    FIELD(SYS_CACHE_GRP_CAL_MODE_REG_U_CXRH_NID264, RESERVED_49, 49, 15)
    FIELD(SYS_CACHE_GRP_CAL_MODE_REG_U_CXRH_NID264, SCG3_HNF_CAL_MODE_EN, 48, 1)
    FIELD(SYS_CACHE_GRP_CAL_MODE_REG_U_CXRH_NID264, RESERVED_33, 33, 15)
    FIELD(SYS_CACHE_GRP_CAL_MODE_REG_U_CXRH_NID264, SCG2_HNF_CAL_MODE_EN, 32, 1)
    FIELD(SYS_CACHE_GRP_CAL_MODE_REG_U_CXRH_NID264, RESERVED_17, 17, 15)
    FIELD(SYS_CACHE_GRP_CAL_MODE_REG_U_CXRH_NID264, SCG1_HNF_CAL_MODE_EN, 16, 1)
    FIELD(SYS_CACHE_GRP_CAL_MODE_REG_U_CXRH_NID264, SCG0_HNF_CAL_MODE_EN, 0, 1)
REG32(RNSAM_HASH_ADDR_MASK_REG_U_CXRH_NID264, 0x2150f18)
    FIELD(RNSAM_HASH_ADDR_MASK_REG_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(RNSAM_HASH_ADDR_MASK_REG_U_CXRH_NID264, ADDR_MASK, 6, 42)
    FIELD(RNSAM_HASH_ADDR_MASK_REG_U_CXRH_NID264, RESERVED_0, 0, 6)
REG32(RNSAM_REGION_CMP_ADDR_MASK_REG_U_CXRH_NID264, 0x2150f20)
    FIELD(RNSAM_REGION_CMP_ADDR_MASK_REG_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(RNSAM_REGION_CMP_ADDR_MASK_REG_U_CXRH_NID264, ADDR_MASK, 16, 32)
    FIELD(RNSAM_REGION_CMP_ADDR_MASK_REG_U_CXRH_NID264, RESERVED_0, 0, 16)
REG32(SYS_CACHE_GRP_HN_NODEID_REG8_U_CXRH_NID264, 0x2150f58)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG8_U_CXRH_NID264, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG8_U_CXRH_NID264, NODEID_35, 36, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG8_U_CXRH_NID264, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG8_U_CXRH_NID264, NODEID_34, 24, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG8_U_CXRH_NID264, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG8_U_CXRH_NID264, NODEID_33, 12, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG8_U_CXRH_NID264, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG8_U_CXRH_NID264, NODEID_32, 0, 11)
REG32(SYS_CACHE_GRP_HN_NODEID_REG9_U_CXRH_NID264, 0x2150f60)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG9_U_CXRH_NID264, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG9_U_CXRH_NID264, NODEID_39, 36, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG9_U_CXRH_NID264, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG9_U_CXRH_NID264, NODEID_38, 24, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG9_U_CXRH_NID264, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG9_U_CXRH_NID264, NODEID_37, 12, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG9_U_CXRH_NID264, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG9_U_CXRH_NID264, NODEID_36, 0, 11)
REG32(SYS_CACHE_GRP_HN_NODEID_REG10_U_CXRH_NID264, 0x2150f68)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG10_U_CXRH_NID264, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG10_U_CXRH_NID264, NODEID_43, 36, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG10_U_CXRH_NID264, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG10_U_CXRH_NID264, NODEID_42, 24, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG10_U_CXRH_NID264, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG10_U_CXRH_NID264, NODEID_41, 12, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG10_U_CXRH_NID264, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG10_U_CXRH_NID264, NODEID_40, 0, 11)
REG32(SYS_CACHE_GRP_HN_NODEID_REG11_U_CXRH_NID264, 0x2150f70)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG11_U_CXRH_NID264, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG11_U_CXRH_NID264, NODEID_47, 36, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG11_U_CXRH_NID264, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG11_U_CXRH_NID264, NODEID_46, 24, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG11_U_CXRH_NID264, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG11_U_CXRH_NID264, NODEID_45, 12, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG11_U_CXRH_NID264, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG11_U_CXRH_NID264, NODEID_44, 0, 11)
REG32(SYS_CACHE_GRP_HN_NODEID_REG12_U_CXRH_NID264, 0x2150f78)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG12_U_CXRH_NID264, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG12_U_CXRH_NID264, NODEID_51, 36, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG12_U_CXRH_NID264, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG12_U_CXRH_NID264, NODEID_50, 24, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG12_U_CXRH_NID264, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG12_U_CXRH_NID264, NODEID_49, 12, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG12_U_CXRH_NID264, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG12_U_CXRH_NID264, NODEID_48, 0, 11)
REG32(SYS_CACHE_GRP_HN_NODEID_REG13_U_CXRH_NID264, 0x2150f80)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG13_U_CXRH_NID264, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG13_U_CXRH_NID264, NODEID_55, 36, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG13_U_CXRH_NID264, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG13_U_CXRH_NID264, NODEID_54, 24, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG13_U_CXRH_NID264, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG13_U_CXRH_NID264, NODEID_53, 12, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG13_U_CXRH_NID264, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG13_U_CXRH_NID264, NODEID_52, 0, 11)
REG32(SYS_CACHE_GRP_HN_NODEID_REG14_U_CXRH_NID264, 0x2150f88)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG14_U_CXRH_NID264, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG14_U_CXRH_NID264, NODEID_59, 36, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG14_U_CXRH_NID264, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG14_U_CXRH_NID264, NODEID_58, 24, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG14_U_CXRH_NID264, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG14_U_CXRH_NID264, NODEID_57, 12, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG14_U_CXRH_NID264, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG14_U_CXRH_NID264, NODEID_56, 0, 11)
REG32(SYS_CACHE_GRP_HN_NODEID_REG15_U_CXRH_NID264, 0x2150f90)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG15_U_CXRH_NID264, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG15_U_CXRH_NID264, NODEID_63, 36, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG15_U_CXRH_NID264, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG15_U_CXRH_NID264, NODEID_62, 24, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG15_U_CXRH_NID264, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG15_U_CXRH_NID264, NODEID_61, 12, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG15_U_CXRH_NID264, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG15_U_CXRH_NID264, NODEID_60, 0, 11)
REG32(SYS_CACHE_GRP_SN_NODEID_REG8_U_CXRH_NID264, 0x2151008)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG8_U_CXRH_NID264, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG8_U_CXRH_NID264, SN_NODEID_35, 36, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG8_U_CXRH_NID264, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG8_U_CXRH_NID264, SN_NODEID_34, 24, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG8_U_CXRH_NID264, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG8_U_CXRH_NID264, SN_NODEID_33, 12, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG8_U_CXRH_NID264, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG8_U_CXRH_NID264, SN_NODEID_32, 0, 11)
REG32(SYS_CACHE_GRP_SN_NODEID_REG9_U_CXRH_NID264, 0x2151010)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG9_U_CXRH_NID264, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG9_U_CXRH_NID264, SN_NODEID_39, 36, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG9_U_CXRH_NID264, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG9_U_CXRH_NID264, SN_NODEID_38, 24, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG9_U_CXRH_NID264, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG9_U_CXRH_NID264, SN_NODEID_37, 12, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG9_U_CXRH_NID264, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG9_U_CXRH_NID264, SN_NODEID_36, 0, 11)
REG32(SYS_CACHE_GRP_SN_NODEID_REG10_U_CXRH_NID264, 0x2151018)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG10_U_CXRH_NID264, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG10_U_CXRH_NID264, SN_NODEID_43, 36, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG10_U_CXRH_NID264, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG10_U_CXRH_NID264, SN_NODEID_42, 24, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG10_U_CXRH_NID264, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG10_U_CXRH_NID264, SN_NODEID_41, 12, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG10_U_CXRH_NID264, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG10_U_CXRH_NID264, SN_NODEID_40, 0, 11)
REG32(SYS_CACHE_GRP_SN_NODEID_REG11_U_CXRH_NID264, 0x2151020)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG11_U_CXRH_NID264, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG11_U_CXRH_NID264, SN_NODEID_47, 36, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG11_U_CXRH_NID264, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG11_U_CXRH_NID264, SN_NODEID_46, 24, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG11_U_CXRH_NID264, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG11_U_CXRH_NID264, SN_NODEID_45, 12, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG11_U_CXRH_NID264, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG11_U_CXRH_NID264, SN_NODEID_44, 0, 11)
REG32(SYS_CACHE_GRP_SN_NODEID_REG12_U_CXRH_NID264, 0x2151028)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG12_U_CXRH_NID264, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG12_U_CXRH_NID264, SN_NODEID_51, 36, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG12_U_CXRH_NID264, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG12_U_CXRH_NID264, SN_NODEID_50, 24, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG12_U_CXRH_NID264, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG12_U_CXRH_NID264, SN_NODEID_49, 12, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG12_U_CXRH_NID264, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG12_U_CXRH_NID264, SN_NODEID_48, 0, 11)
REG32(SYS_CACHE_GRP_SN_NODEID_REG13_U_CXRH_NID264, 0x2151030)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG13_U_CXRH_NID264, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG13_U_CXRH_NID264, SN_NODEID_55, 36, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG13_U_CXRH_NID264, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG13_U_CXRH_NID264, SN_NODEID_54, 24, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG13_U_CXRH_NID264, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG13_U_CXRH_NID264, SN_NODEID_53, 12, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG13_U_CXRH_NID264, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG13_U_CXRH_NID264, SN_NODEID_52, 0, 11)
REG32(SYS_CACHE_GRP_SN_NODEID_REG14_U_CXRH_NID264, 0x2151038)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG14_U_CXRH_NID264, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG14_U_CXRH_NID264, SN_NODEID_59, 36, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG14_U_CXRH_NID264, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG14_U_CXRH_NID264, SN_NODEID_58, 24, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG14_U_CXRH_NID264, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG14_U_CXRH_NID264, SN_NODEID_57, 12, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG14_U_CXRH_NID264, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG14_U_CXRH_NID264, SN_NODEID_56, 0, 11)
REG32(SYS_CACHE_GRP_SN_NODEID_REG15_U_CXRH_NID264, 0x2151040)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG15_U_CXRH_NID264, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG15_U_CXRH_NID264, SN_NODEID_63, 36, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG15_U_CXRH_NID264, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG15_U_CXRH_NID264, SN_NODEID_62, 24, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG15_U_CXRH_NID264, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG15_U_CXRH_NID264, SN_NODEID_61, 12, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG15_U_CXRH_NID264, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG15_U_CXRH_NID264, SN_NODEID_60, 0, 11)
REG32(POR_RNSAM_NODE_INFO_U_RNFBESAM_NID268, 0x2168000)
    FIELD(POR_RNSAM_NODE_INFO_U_RNFBESAM_NID268, RESERVED_48, 48, 16)
    FIELD(POR_RNSAM_NODE_INFO_U_RNFBESAM_NID268, LOGICAL_ID, 32, 16)
    FIELD(POR_RNSAM_NODE_INFO_U_RNFBESAM_NID268, NODE_ID, 16, 16)
    FIELD(POR_RNSAM_NODE_INFO_U_RNFBESAM_NID268, NODE_TYPE, 0, 16)
REG32(POR_RNSAM_CHILD_INFO_U_RNFBESAM_NID268, 0x2168080)
    FIELD(POR_RNSAM_CHILD_INFO_U_RNFBESAM_NID268, RESERVED_32, 32, 32)
    FIELD(POR_RNSAM_CHILD_INFO_U_RNFBESAM_NID268, CHILD_PTR_OFFSET, 16, 16)
    FIELD(POR_RNSAM_CHILD_INFO_U_RNFBESAM_NID268, CHILD_COUNT, 0, 16)
REG32(POR_RNSAM_UNIT_INFO_U_RNFBESAM_NID268, 0x2168900)
    FIELD(POR_RNSAM_UNIT_INFO_U_RNFBESAM_NID268, RESERVED_37, 37, 27)
    FIELD(POR_RNSAM_UNIT_INFO_U_RNFBESAM_NID268, NUM_NON_HASH_GROUP, 32, 5)
    FIELD(POR_RNSAM_UNIT_INFO_U_RNFBESAM_NID268, RESERVED_20, 20, 12)
    FIELD(POR_RNSAM_UNIT_INFO_U_RNFBESAM_NID268, NUM_SYS_CACHE_GROUP, 16, 4)
    FIELD(POR_RNSAM_UNIT_INFO_U_RNFBESAM_NID268, NUM_HNF, 0, 8)
REG32(POR_RNSAM_SECURE_REGISTER_GROUPS_OVERRIDE_U_RNFBESAM_NID268, 0x2168980)
    FIELD(POR_RNSAM_SECURE_REGISTER_GROUPS_OVERRIDE_U_RNFBESAM_NID268, MEM_RANGE, 0, 1)
REG32(RNSAM_STATUS_U_RNFBESAM_NID268, 0x2168c00)
    FIELD(RNSAM_STATUS_U_RNFBESAM_NID268, NSTALL_REQ, 1, 1)
    FIELD(RNSAM_STATUS_U_RNFBESAM_NID268, USE_DEFAULT_NODE, 0, 1)
REG32(NON_HASH_MEM_REGION_REG0_U_RNFBESAM_NID268, 0x2168c08)
    FIELD(NON_HASH_MEM_REGION_REG0_U_RNFBESAM_NID268, RESERVED_63, 63, 1)
    FIELD(NON_HASH_MEM_REGION_REG0_U_RNFBESAM_NID268, REGION1_BASE_ADDR, 41, 22)
    FIELD(NON_HASH_MEM_REGION_REG0_U_RNFBESAM_NID268, REGION1_SIZE, 36, 5)
    FIELD(NON_HASH_MEM_REGION_REG0_U_RNFBESAM_NID268, REGION1_TARGET_TYPE, 34, 2)
    FIELD(NON_HASH_MEM_REGION_REG0_U_RNFBESAM_NID268, RESERVED_33, 33, 1)
    FIELD(NON_HASH_MEM_REGION_REG0_U_RNFBESAM_NID268, REGION1_VALID, 32, 1)
    FIELD(NON_HASH_MEM_REGION_REG0_U_RNFBESAM_NID268, RESERVED_31, 31, 1)
    FIELD(NON_HASH_MEM_REGION_REG0_U_RNFBESAM_NID268, REGION0_BASE_ADDR, 9, 22)
    FIELD(NON_HASH_MEM_REGION_REG0_U_RNFBESAM_NID268, REGION0_SIZE, 4, 5)
    FIELD(NON_HASH_MEM_REGION_REG0_U_RNFBESAM_NID268, REGION0_TARGET_TYPE, 2, 2)
    FIELD(NON_HASH_MEM_REGION_REG0_U_RNFBESAM_NID268, REGION0_VALID, 0, 1)
REG32(NON_HASH_MEM_REGION_REG1_U_RNFBESAM_NID268, 0x2168c10)
    FIELD(NON_HASH_MEM_REGION_REG1_U_RNFBESAM_NID268, RESERVED_63, 63, 1)
    FIELD(NON_HASH_MEM_REGION_REG1_U_RNFBESAM_NID268, REGION3_BASE_ADDR, 41, 22)
    FIELD(NON_HASH_MEM_REGION_REG1_U_RNFBESAM_NID268, REGION3_SIZE, 36, 5)
    FIELD(NON_HASH_MEM_REGION_REG1_U_RNFBESAM_NID268, REGION3_TARGET_TYPE, 34, 2)
    FIELD(NON_HASH_MEM_REGION_REG1_U_RNFBESAM_NID268, RESERVED_33, 33, 1)
    FIELD(NON_HASH_MEM_REGION_REG1_U_RNFBESAM_NID268, REGION3_VALID, 32, 1)
    FIELD(NON_HASH_MEM_REGION_REG1_U_RNFBESAM_NID268, RESERVED_31, 31, 1)
    FIELD(NON_HASH_MEM_REGION_REG1_U_RNFBESAM_NID268, REGION2_BASE_ADDR, 9, 22)
    FIELD(NON_HASH_MEM_REGION_REG1_U_RNFBESAM_NID268, REGION2_SIZE, 4, 5)
    FIELD(NON_HASH_MEM_REGION_REG1_U_RNFBESAM_NID268, REGION2_TARGET_TYPE, 2, 2)
    FIELD(NON_HASH_MEM_REGION_REG1_U_RNFBESAM_NID268, REGION2_VALID, 0, 1)
REG32(NON_HASH_MEM_REGION_REG2_U_RNFBESAM_NID268, 0x2168c18)
    FIELD(NON_HASH_MEM_REGION_REG2_U_RNFBESAM_NID268, RESERVED_63, 63, 1)
    FIELD(NON_HASH_MEM_REGION_REG2_U_RNFBESAM_NID268, REGION5_BASE_ADDR, 41, 22)
    FIELD(NON_HASH_MEM_REGION_REG2_U_RNFBESAM_NID268, REGION5_SIZE, 36, 5)
    FIELD(NON_HASH_MEM_REGION_REG2_U_RNFBESAM_NID268, REGION5_TARGET_TYPE, 34, 2)
    FIELD(NON_HASH_MEM_REGION_REG2_U_RNFBESAM_NID268, RESERVED_33, 33, 1)
    FIELD(NON_HASH_MEM_REGION_REG2_U_RNFBESAM_NID268, REGION5_VALID, 32, 1)
    FIELD(NON_HASH_MEM_REGION_REG2_U_RNFBESAM_NID268, RESERVED_31, 31, 1)
    FIELD(NON_HASH_MEM_REGION_REG2_U_RNFBESAM_NID268, REGION4_BASE_ADDR, 9, 22)
    FIELD(NON_HASH_MEM_REGION_REG2_U_RNFBESAM_NID268, REGION4_SIZE, 4, 5)
    FIELD(NON_HASH_MEM_REGION_REG2_U_RNFBESAM_NID268, REGION4_TARGET_TYPE, 2, 2)
    FIELD(NON_HASH_MEM_REGION_REG2_U_RNFBESAM_NID268, REGION4_VALID, 0, 1)
REG32(NON_HASH_MEM_REGION_REG3_U_RNFBESAM_NID268, 0x2168c20)
    FIELD(NON_HASH_MEM_REGION_REG3_U_RNFBESAM_NID268, RESERVED_63, 63, 1)
    FIELD(NON_HASH_MEM_REGION_REG3_U_RNFBESAM_NID268, REGION7_BASE_ADDR, 41, 22)
    FIELD(NON_HASH_MEM_REGION_REG3_U_RNFBESAM_NID268, REGION7_SIZE, 36, 5)
    FIELD(NON_HASH_MEM_REGION_REG3_U_RNFBESAM_NID268, REGION7_TARGET_TYPE, 34, 2)
    FIELD(NON_HASH_MEM_REGION_REG3_U_RNFBESAM_NID268, RESERVED_33, 33, 1)
    FIELD(NON_HASH_MEM_REGION_REG3_U_RNFBESAM_NID268, REGION7_VALID, 32, 1)
    FIELD(NON_HASH_MEM_REGION_REG3_U_RNFBESAM_NID268, RESERVED_31, 31, 1)
    FIELD(NON_HASH_MEM_REGION_REG3_U_RNFBESAM_NID268, REGION6_BASE_ADDR, 9, 22)
    FIELD(NON_HASH_MEM_REGION_REG3_U_RNFBESAM_NID268, REGION6_SIZE, 4, 5)
    FIELD(NON_HASH_MEM_REGION_REG3_U_RNFBESAM_NID268, REGION6_TARGET_TYPE, 2, 2)
    FIELD(NON_HASH_MEM_REGION_REG3_U_RNFBESAM_NID268, REGION6_VALID, 0, 1)
REG32(NON_HASH_TGT_NODEID0_U_RNFBESAM_NID268, 0x2168c30)
    FIELD(NON_HASH_TGT_NODEID0_U_RNFBESAM_NID268, RESERVED_47, 47, 17)
    FIELD(NON_HASH_TGT_NODEID0_U_RNFBESAM_NID268, NODEID_3, 36, 11)
    FIELD(NON_HASH_TGT_NODEID0_U_RNFBESAM_NID268, RESERVED_35, 35, 1)
    FIELD(NON_HASH_TGT_NODEID0_U_RNFBESAM_NID268, NODEID_2, 24, 11)
    FIELD(NON_HASH_TGT_NODEID0_U_RNFBESAM_NID268, RESERVED_23, 23, 1)
    FIELD(NON_HASH_TGT_NODEID0_U_RNFBESAM_NID268, NODEID_1, 12, 11)
    FIELD(NON_HASH_TGT_NODEID0_U_RNFBESAM_NID268, RESERVED_11, 11, 1)
    FIELD(NON_HASH_TGT_NODEID0_U_RNFBESAM_NID268, NODEID_0, 0, 11)
REG32(NON_HASH_TGT_NODEID1_U_RNFBESAM_NID268, 0x2168c38)
    FIELD(NON_HASH_TGT_NODEID1_U_RNFBESAM_NID268, RESERVED_47, 47, 17)
    FIELD(NON_HASH_TGT_NODEID1_U_RNFBESAM_NID268, NODEID_7, 36, 11)
    FIELD(NON_HASH_TGT_NODEID1_U_RNFBESAM_NID268, RESERVED_35, 35, 1)
    FIELD(NON_HASH_TGT_NODEID1_U_RNFBESAM_NID268, NODEID_6, 24, 11)
    FIELD(NON_HASH_TGT_NODEID1_U_RNFBESAM_NID268, RESERVED_23, 23, 1)
    FIELD(NON_HASH_TGT_NODEID1_U_RNFBESAM_NID268, NODEID_5, 12, 11)
    FIELD(NON_HASH_TGT_NODEID1_U_RNFBESAM_NID268, RESERVED_11, 11, 1)
    FIELD(NON_HASH_TGT_NODEID1_U_RNFBESAM_NID268, NODEID_4, 0, 11)
REG32(NON_HASH_TGT_NODEID2_U_RNFBESAM_NID268, 0x2168c40)
    FIELD(NON_HASH_TGT_NODEID2_U_RNFBESAM_NID268, RESERVED_23, 23, 41)
    FIELD(NON_HASH_TGT_NODEID2_U_RNFBESAM_NID268, NODEID_9, 12, 11)
    FIELD(NON_HASH_TGT_NODEID2_U_RNFBESAM_NID268, RESERVED_11, 11, 1)
    FIELD(NON_HASH_TGT_NODEID2_U_RNFBESAM_NID268, NODEID_8, 0, 11)
REG32(SYS_CACHE_GRP_REGION0_U_RNFBESAM_NID268, 0x2168c48)
    FIELD(SYS_CACHE_GRP_REGION0_U_RNFBESAM_NID268, RESERVED_63, 63, 1)
    FIELD(SYS_CACHE_GRP_REGION0_U_RNFBESAM_NID268, REGION1_BASE_ADDR, 41, 22)
    FIELD(SYS_CACHE_GRP_REGION0_U_RNFBESAM_NID268, REGION1_SIZE, 36, 5)
    FIELD(SYS_CACHE_GRP_REGION0_U_RNFBESAM_NID268, REGION1_TARGET_TYPE, 34, 2)
    FIELD(SYS_CACHE_GRP_REGION0_U_RNFBESAM_NID268, REGION1_NONHASH_REG_EN, 33, 1)
    FIELD(SYS_CACHE_GRP_REGION0_U_RNFBESAM_NID268, REGION1_VALID, 32, 1)
    FIELD(SYS_CACHE_GRP_REGION0_U_RNFBESAM_NID268, RESERVED_31, 31, 1)
    FIELD(SYS_CACHE_GRP_REGION0_U_RNFBESAM_NID268, REGION0_BASE_ADDR, 9, 22)
    FIELD(SYS_CACHE_GRP_REGION0_U_RNFBESAM_NID268, REGION0_SIZE, 4, 5)
    FIELD(SYS_CACHE_GRP_REGION0_U_RNFBESAM_NID268, REGION0_TARGET_TYPE, 2, 2)
    FIELD(SYS_CACHE_GRP_REGION0_U_RNFBESAM_NID268, REGION0_VALID, 0, 1)
REG32(SYS_CACHE_GRP_REGION1_U_RNFBESAM_NID268, 0x2168c50)
    FIELD(SYS_CACHE_GRP_REGION1_U_RNFBESAM_NID268, RESERVED_63, 63, 1)
    FIELD(SYS_CACHE_GRP_REGION1_U_RNFBESAM_NID268, REGION3_BASE_ADDR, 41, 22)
    FIELD(SYS_CACHE_GRP_REGION1_U_RNFBESAM_NID268, REGION3_SIZE, 36, 5)
    FIELD(SYS_CACHE_GRP_REGION1_U_RNFBESAM_NID268, REGION3_TARGET_TYPE, 34, 2)
    FIELD(SYS_CACHE_GRP_REGION1_U_RNFBESAM_NID268, REGION3_NONHASH_REG_EN, 33, 1)
    FIELD(SYS_CACHE_GRP_REGION1_U_RNFBESAM_NID268, REGION3_VALID, 32, 1)
    FIELD(SYS_CACHE_GRP_REGION1_U_RNFBESAM_NID268, RESERVED_31, 31, 1)
    FIELD(SYS_CACHE_GRP_REGION1_U_RNFBESAM_NID268, REGION2_BASE_ADDR, 9, 22)
    FIELD(SYS_CACHE_GRP_REGION1_U_RNFBESAM_NID268, REGION2_SIZE, 4, 5)
    FIELD(SYS_CACHE_GRP_REGION1_U_RNFBESAM_NID268, REGION2_TARGET_TYPE, 2, 2)
    FIELD(SYS_CACHE_GRP_REGION1_U_RNFBESAM_NID268, REGION2_NONHASH_REG_EN, 1, 1)
    FIELD(SYS_CACHE_GRP_REGION1_U_RNFBESAM_NID268, REGION2_VALID, 0, 1)
REG32(SYS_CACHE_GRP_HN_NODEID_REG0_U_RNFBESAM_NID268, 0x2168c58)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG0_U_RNFBESAM_NID268, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG0_U_RNFBESAM_NID268, NODEID_3, 36, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG0_U_RNFBESAM_NID268, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG0_U_RNFBESAM_NID268, NODEID_2, 24, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG0_U_RNFBESAM_NID268, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG0_U_RNFBESAM_NID268, NODEID_1, 12, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG0_U_RNFBESAM_NID268, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG0_U_RNFBESAM_NID268, NODEID_0, 0, 11)
REG32(SYS_CACHE_GRP_HN_NODEID_REG1_U_RNFBESAM_NID268, 0x2168c60)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG1_U_RNFBESAM_NID268, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG1_U_RNFBESAM_NID268, NODEID_7, 36, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG1_U_RNFBESAM_NID268, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG1_U_RNFBESAM_NID268, NODEID_6, 24, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG1_U_RNFBESAM_NID268, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG1_U_RNFBESAM_NID268, NODEID_5, 12, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG1_U_RNFBESAM_NID268, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG1_U_RNFBESAM_NID268, NODEID_4, 0, 11)
REG32(SYS_CACHE_GRP_HN_NODEID_REG2_U_RNFBESAM_NID268, 0x2168c68)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG2_U_RNFBESAM_NID268, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG2_U_RNFBESAM_NID268, NODEID_11, 36, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG2_U_RNFBESAM_NID268, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG2_U_RNFBESAM_NID268, NODEID_10, 24, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG2_U_RNFBESAM_NID268, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG2_U_RNFBESAM_NID268, NODEID_9, 12, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG2_U_RNFBESAM_NID268, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG2_U_RNFBESAM_NID268, NODEID_8, 0, 11)
REG32(SYS_CACHE_GRP_HN_NODEID_REG3_U_RNFBESAM_NID268, 0x2168c70)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG3_U_RNFBESAM_NID268, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG3_U_RNFBESAM_NID268, NODEID_15, 36, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG3_U_RNFBESAM_NID268, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG3_U_RNFBESAM_NID268, NODEID_14, 24, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG3_U_RNFBESAM_NID268, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG3_U_RNFBESAM_NID268, NODEID_13, 12, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG3_U_RNFBESAM_NID268, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG3_U_RNFBESAM_NID268, NODEID_12, 0, 11)
REG32(SYS_CACHE_GRP_HN_NODEID_REG4_U_RNFBESAM_NID268, 0x2168c78)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG4_U_RNFBESAM_NID268, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG4_U_RNFBESAM_NID268, NODEID_19, 36, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG4_U_RNFBESAM_NID268, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG4_U_RNFBESAM_NID268, NODEID_18, 24, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG4_U_RNFBESAM_NID268, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG4_U_RNFBESAM_NID268, NODEID_17, 12, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG4_U_RNFBESAM_NID268, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG4_U_RNFBESAM_NID268, NODEID_16, 0, 11)
REG32(SYS_CACHE_GRP_HN_NODEID_REG5_U_RNFBESAM_NID268, 0x2168c80)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG5_U_RNFBESAM_NID268, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG5_U_RNFBESAM_NID268, NODEID_23, 36, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG5_U_RNFBESAM_NID268, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG5_U_RNFBESAM_NID268, NODEID_22, 24, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG5_U_RNFBESAM_NID268, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG5_U_RNFBESAM_NID268, NODEID_21, 12, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG5_U_RNFBESAM_NID268, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG5_U_RNFBESAM_NID268, NODEID_20, 0, 11)
REG32(SYS_CACHE_GRP_HN_NODEID_REG6_U_RNFBESAM_NID268, 0x2168c88)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG6_U_RNFBESAM_NID268, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG6_U_RNFBESAM_NID268, NODEID_27, 36, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG6_U_RNFBESAM_NID268, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG6_U_RNFBESAM_NID268, NODEID_26, 24, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG6_U_RNFBESAM_NID268, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG6_U_RNFBESAM_NID268, NODEID_25, 12, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG6_U_RNFBESAM_NID268, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG6_U_RNFBESAM_NID268, NODEID_24, 0, 11)
REG32(SYS_CACHE_GRP_HN_NODEID_REG7_U_RNFBESAM_NID268, 0x2168c90)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG7_U_RNFBESAM_NID268, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG7_U_RNFBESAM_NID268, NODEID_31, 36, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG7_U_RNFBESAM_NID268, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG7_U_RNFBESAM_NID268, NODEID_30, 24, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG7_U_RNFBESAM_NID268, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG7_U_RNFBESAM_NID268, NODEID_29, 12, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG7_U_RNFBESAM_NID268, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG7_U_RNFBESAM_NID268, NODEID_28, 0, 11)
REG32(SYS_CACHE_GRP_NONHASH_NODEID_U_RNFBESAM_NID268, 0x2168c98)
    FIELD(SYS_CACHE_GRP_NONHASH_NODEID_U_RNFBESAM_NID268, RESERVED_35, 35, 29)
    FIELD(SYS_CACHE_GRP_NONHASH_NODEID_U_RNFBESAM_NID268, SCG3_NODEID, 24, 11)
    FIELD(SYS_CACHE_GRP_NONHASH_NODEID_U_RNFBESAM_NID268, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_NONHASH_NODEID_U_RNFBESAM_NID268, SCG2_NODEID, 12, 11)
    FIELD(SYS_CACHE_GRP_NONHASH_NODEID_U_RNFBESAM_NID268, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_NONHASH_NODEID_U_RNFBESAM_NID268, SCG1_NODEID, 0, 11)
REG32(SYS_CACHE_GROUP_HN_COUNT_U_RNFBESAM_NID268, 0x2168d00)
    FIELD(SYS_CACHE_GROUP_HN_COUNT_U_RNFBESAM_NID268, RESERVED_31, 31, 33)
    FIELD(SYS_CACHE_GROUP_HN_COUNT_U_RNFBESAM_NID268, SCG3_NUM_HNF, 24, 7)
    FIELD(SYS_CACHE_GROUP_HN_COUNT_U_RNFBESAM_NID268, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GROUP_HN_COUNT_U_RNFBESAM_NID268, SCG2_NUM_HNF, 16, 7)
    FIELD(SYS_CACHE_GROUP_HN_COUNT_U_RNFBESAM_NID268, RESERVED_15, 15, 1)
    FIELD(SYS_CACHE_GROUP_HN_COUNT_U_RNFBESAM_NID268, SCG1_NUM_HNF, 8, 7)
    FIELD(SYS_CACHE_GROUP_HN_COUNT_U_RNFBESAM_NID268, SCG0_NUM_HNF, 0, 7)
REG32(SYS_CACHE_GRP_SN_NODEID_REG0_U_RNFBESAM_NID268, 0x2168d08)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG0_U_RNFBESAM_NID268, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG0_U_RNFBESAM_NID268, SN_NODEID_3, 36, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG0_U_RNFBESAM_NID268, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG0_U_RNFBESAM_NID268, SN_NODEID_2, 24, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG0_U_RNFBESAM_NID268, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG0_U_RNFBESAM_NID268, SN_NODEID_1, 12, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG0_U_RNFBESAM_NID268, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG0_U_RNFBESAM_NID268, SN_NODEID_0, 0, 11)
REG32(SYS_CACHE_GRP_SN_NODEID_REG1_U_RNFBESAM_NID268, 0x2168d10)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG1_U_RNFBESAM_NID268, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG1_U_RNFBESAM_NID268, SN_NODEID_7, 36, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG1_U_RNFBESAM_NID268, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG1_U_RNFBESAM_NID268, SN_NODEID_6, 24, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG1_U_RNFBESAM_NID268, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG1_U_RNFBESAM_NID268, SN_NODEID_5, 12, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG1_U_RNFBESAM_NID268, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG1_U_RNFBESAM_NID268, SN_NODEID_4, 0, 11)
REG32(SYS_CACHE_GRP_SN_NODEID_REG2_U_RNFBESAM_NID268, 0x2168d18)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG2_U_RNFBESAM_NID268, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG2_U_RNFBESAM_NID268, SN_NODEID_11, 36, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG2_U_RNFBESAM_NID268, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG2_U_RNFBESAM_NID268, SN_NODEID_10, 24, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG2_U_RNFBESAM_NID268, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG2_U_RNFBESAM_NID268, SN_NODEID_9, 12, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG2_U_RNFBESAM_NID268, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG2_U_RNFBESAM_NID268, SN_NODEID_8, 0, 11)
REG32(SYS_CACHE_GRP_SN_NODEID_REG3_U_RNFBESAM_NID268, 0x2168d20)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG3_U_RNFBESAM_NID268, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG3_U_RNFBESAM_NID268, SN_NODEID_15, 36, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG3_U_RNFBESAM_NID268, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG3_U_RNFBESAM_NID268, SN_NODEID_14, 24, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG3_U_RNFBESAM_NID268, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG3_U_RNFBESAM_NID268, SN_NODEID_13, 12, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG3_U_RNFBESAM_NID268, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG3_U_RNFBESAM_NID268, SN_NODEID_12, 0, 11)
REG32(SYS_CACHE_GRP_SN_NODEID_REG4_U_RNFBESAM_NID268, 0x2168d28)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG4_U_RNFBESAM_NID268, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG4_U_RNFBESAM_NID268, SN_NODEID_19, 36, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG4_U_RNFBESAM_NID268, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG4_U_RNFBESAM_NID268, SN_NODEID_18, 24, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG4_U_RNFBESAM_NID268, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG4_U_RNFBESAM_NID268, SN_NODEID_17, 12, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG4_U_RNFBESAM_NID268, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG4_U_RNFBESAM_NID268, SN_NODEID_16, 0, 11)
REG32(SYS_CACHE_GRP_SN_NODEID_REG5_U_RNFBESAM_NID268, 0x2168d30)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG5_U_RNFBESAM_NID268, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG5_U_RNFBESAM_NID268, SN_NODEID_23, 36, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG5_U_RNFBESAM_NID268, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG5_U_RNFBESAM_NID268, SN_NODEID_22, 24, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG5_U_RNFBESAM_NID268, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG5_U_RNFBESAM_NID268, SN_NODEID_21, 12, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG5_U_RNFBESAM_NID268, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG5_U_RNFBESAM_NID268, SN_NODEID_20, 0, 11)
REG32(SYS_CACHE_GRP_SN_NODEID_REG6_U_RNFBESAM_NID268, 0x2168d38)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG6_U_RNFBESAM_NID268, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG6_U_RNFBESAM_NID268, SN_NODEID_27, 36, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG6_U_RNFBESAM_NID268, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG6_U_RNFBESAM_NID268, SN_NODEID_26, 24, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG6_U_RNFBESAM_NID268, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG6_U_RNFBESAM_NID268, SN_NODEID_25, 12, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG6_U_RNFBESAM_NID268, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG6_U_RNFBESAM_NID268, SN_NODEID_24, 0, 11)
REG32(SYS_CACHE_GRP_SN_NODEID_REG7_U_RNFBESAM_NID268, 0x2168d40)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG7_U_RNFBESAM_NID268, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG7_U_RNFBESAM_NID268, SN_NODEID_31, 36, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG7_U_RNFBESAM_NID268, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG7_U_RNFBESAM_NID268, SN_NODEID_30, 24, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG7_U_RNFBESAM_NID268, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG7_U_RNFBESAM_NID268, SN_NODEID_29, 12, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG7_U_RNFBESAM_NID268, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG7_U_RNFBESAM_NID268, SN_NODEID_28, 0, 11)
REG32(SYS_CACHE_GRP_SN_SAM_CFG0_U_RNFBESAM_NID268, 0x2168d48)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG0_U_RNFBESAM_NID268, RESERVED_46, 46, 18)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG0_U_RNFBESAM_NID268, SCG1_TOP_ADDRESS_BIT2, 40, 6)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG0_U_RNFBESAM_NID268, RESERVED_38, 38, 2)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG0_U_RNFBESAM_NID268, SCG1_TOP_ADDRESS_BIT1, 32, 6)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG0_U_RNFBESAM_NID268, RESERVED_30, 30, 2)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG0_U_RNFBESAM_NID268, SCG1_TOP_ADDRESS_BIT0, 24, 6)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG0_U_RNFBESAM_NID268, RESERVED_22, 22, 2)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG0_U_RNFBESAM_NID268, SCG0_TOP_ADDRESS_BIT2, 16, 6)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG0_U_RNFBESAM_NID268, RESERVED_14, 14, 2)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG0_U_RNFBESAM_NID268, SCG0_TOP_ADDRESS_BIT1, 8, 6)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG0_U_RNFBESAM_NID268, SCG0_TOP_ADDRESS_BIT0, 0, 6)
REG32(SYS_CACHE_GRP_SN_SAM_CFG1_U_RNFBESAM_NID268, 0x2168d50)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG1_U_RNFBESAM_NID268, RESERVED_46, 46, 18)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG1_U_RNFBESAM_NID268, SCG3_TOP_ADDRESS_BIT2, 40, 6)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG1_U_RNFBESAM_NID268, RESERVED_38, 38, 2)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG1_U_RNFBESAM_NID268, SCG3_TOP_ADDRESS_BIT1, 32, 6)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG1_U_RNFBESAM_NID268, RESERVED_30, 30, 2)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG1_U_RNFBESAM_NID268, SCG3_TOP_ADDRESS_BIT0, 24, 6)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG1_U_RNFBESAM_NID268, RESERVED_22, 22, 2)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG1_U_RNFBESAM_NID268, SCG2_TOP_ADDRESS_BIT2, 16, 6)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG1_U_RNFBESAM_NID268, RESERVED_14, 14, 2)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG1_U_RNFBESAM_NID268, SCG2_TOP_ADDRESS_BIT1, 8, 6)
    FIELD(SYS_CACHE_GRP_SN_SAM_CFG1_U_RNFBESAM_NID268, SCG2_TOP_ADDRESS_BIT0, 0, 6)
REG32(GIC_MEM_REGION_REG_U_RNFBESAM_NID268, 0x2168d58)
    FIELD(GIC_MEM_REGION_REG_U_RNFBESAM_NID268, RESERVED_63, 63, 1)
    FIELD(GIC_MEM_REGION_REG_U_RNFBESAM_NID268, GIC_REGION_NODEID, 52, 11)
    FIELD(GIC_MEM_REGION_REG_U_RNFBESAM_NID268, RESERVED_48, 48, 4)
    FIELD(GIC_MEM_REGION_REG_U_RNFBESAM_NID268, GIC_REGION_BASE_ADDR, 16, 32)
    FIELD(GIC_MEM_REGION_REG_U_RNFBESAM_NID268, GIC_REGION_SIZE, 4, 3)
    FIELD(GIC_MEM_REGION_REG_U_RNFBESAM_NID268, GIC_REGION_TARGET_TYPE, 2, 2)
    FIELD(GIC_MEM_REGION_REG_U_RNFBESAM_NID268, GIC_REGION_VALID, 0, 1)
REG32(SYS_CACHE_GRP_SN_ATTR_U_RNFBESAM_NID268, 0x2168d60)
    FIELD(SYS_CACHE_GRP_SN_ATTR_U_RNFBESAM_NID268, RESERVED_54, 54, 10)
    FIELD(SYS_CACHE_GRP_SN_ATTR_U_RNFBESAM_NID268, SN_MODE_SYS_CACHE_GRP3, 52, 2)
    FIELD(SYS_CACHE_GRP_SN_ATTR_U_RNFBESAM_NID268, RESERVED_49, 49, 3)
    FIELD(SYS_CACHE_GRP_SN_ATTR_U_RNFBESAM_NID268, INV_TOP_ADDRESS_BIT_SYS_CACHE_GRP3, 48, 1)
    FIELD(SYS_CACHE_GRP_SN_ATTR_U_RNFBESAM_NID268, RESERVED_38, 38, 10)
    FIELD(SYS_CACHE_GRP_SN_ATTR_U_RNFBESAM_NID268, SN_MODE_SYS_CACHE_GRP2, 36, 2)
    FIELD(SYS_CACHE_GRP_SN_ATTR_U_RNFBESAM_NID268, RESERVED_33, 33, 3)
    FIELD(SYS_CACHE_GRP_SN_ATTR_U_RNFBESAM_NID268, INV_TOP_ADDRESS_BIT_SYS_CACHE_GRP2, 32, 1)
    FIELD(SYS_CACHE_GRP_SN_ATTR_U_RNFBESAM_NID268, RESERVED_22, 22, 10)
    FIELD(SYS_CACHE_GRP_SN_ATTR_U_RNFBESAM_NID268, SN_MODE_SYS_CACHE_GRP1, 20, 2)
    FIELD(SYS_CACHE_GRP_SN_ATTR_U_RNFBESAM_NID268, RESERVED_17, 17, 3)
    FIELD(SYS_CACHE_GRP_SN_ATTR_U_RNFBESAM_NID268, INV_TOP_ADDRESS_BIT_SYS_CACHE_GRP1, 16, 1)
    FIELD(SYS_CACHE_GRP_SN_ATTR_U_RNFBESAM_NID268, SN_MODE_SYS_CACHE_GRP0, 4, 2)
    FIELD(SYS_CACHE_GRP_SN_ATTR_U_RNFBESAM_NID268, INV_TOP_ADDRESS_BIT_SYS_CACHE_GRP0, 0, 1)
REG32(SYS_CACHE_GRP_HN_CPA_EN_REG_U_RNFBESAM_NID268, 0x2168d68)
REG32(SYS_CACHE_GRP_HN_CPA_GRP_REG_U_RNFBESAM_NID268, 0x2168d70)
    FIELD(SYS_CACHE_GRP_HN_CPA_GRP_REG_U_RNFBESAM_NID268, RESERVED_50, 50, 14)
    FIELD(SYS_CACHE_GRP_HN_CPA_GRP_REG_U_RNFBESAM_NID268, CPA_GRP_SCG3, 48, 2)
    FIELD(SYS_CACHE_GRP_HN_CPA_GRP_REG_U_RNFBESAM_NID268, RESERVED_34, 34, 14)
    FIELD(SYS_CACHE_GRP_HN_CPA_GRP_REG_U_RNFBESAM_NID268, CPA_GRP_SCG2, 32, 2)
    FIELD(SYS_CACHE_GRP_HN_CPA_GRP_REG_U_RNFBESAM_NID268, RESERVED_18, 18, 14)
    FIELD(SYS_CACHE_GRP_HN_CPA_GRP_REG_U_RNFBESAM_NID268, CPA_GRP_SCG1, 16, 2)
    FIELD(SYS_CACHE_GRP_HN_CPA_GRP_REG_U_RNFBESAM_NID268, CPA_GRP_SCG0, 0, 2)
REG32(CML_PORT_AGGR_MODE_CTRL_REG_U_RNFBESAM_NID268, 0x2168e00)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNFBESAM_NID268, RESERVED_32, 32, 32)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNFBESAM_NID268, REGION7_PAG_GRPID, 30, 2)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNFBESAM_NID268, RESERVED_29, 29, 1)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNFBESAM_NID268, REGION7_PAG_EN, 28, 1)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNFBESAM_NID268, RESERVED_27, 27, 1)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNFBESAM_NID268, REGION6_PAG_GRPID, 25, 2)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNFBESAM_NID268, REGION6_PAG_EN, 24, 1)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNFBESAM_NID268, RESERVED_23, 23, 1)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNFBESAM_NID268, REGION5_PAG_GRPID, 21, 2)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNFBESAM_NID268, REGION5_PAG_EN, 20, 1)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNFBESAM_NID268, RESERVED_19, 19, 1)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNFBESAM_NID268, REGION4_PAG_GRPID, 17, 2)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNFBESAM_NID268, REGION4_PAG_EN, 16, 1)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNFBESAM_NID268, RESERVED_15, 15, 1)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNFBESAM_NID268, REGION3_PAG_GRPID, 13, 2)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNFBESAM_NID268, REGION3_PAG_EN, 12, 1)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNFBESAM_NID268, RESERVED_11, 11, 1)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNFBESAM_NID268, REGION2_PAG_GRPID, 9, 2)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNFBESAM_NID268, REGION2_PAG_EN, 8, 1)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNFBESAM_NID268, REGION1_PAG_GRPID, 5, 2)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNFBESAM_NID268, REGION1_PAG_EN, 4, 1)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNFBESAM_NID268, REGION0_PAG_GRPID, 1, 2)
    FIELD(CML_PORT_AGGR_MODE_CTRL_REG_U_RNFBESAM_NID268, REGION0_PAG_EN, 0, 1)
REG32(CML_PORT_AGGR_GRP0_ADD_MASK_U_RNFBESAM_NID268, 0x2168e08)
    FIELD(CML_PORT_AGGR_GRP0_ADD_MASK_U_RNFBESAM_NID268, RESERVED_48, 48, 16)
    FIELD(CML_PORT_AGGR_GRP0_ADD_MASK_U_RNFBESAM_NID268, ADDR_MASK, 6, 42)
    FIELD(CML_PORT_AGGR_GRP0_ADD_MASK_U_RNFBESAM_NID268, RESERVED_0, 0, 6)
REG32(CML_PORT_AGGR_GRP1_ADD_MASK_U_RNFBESAM_NID268, 0x2168e10)
    FIELD(CML_PORT_AGGR_GRP1_ADD_MASK_U_RNFBESAM_NID268, RESERVED_48, 48, 16)
    FIELD(CML_PORT_AGGR_GRP1_ADD_MASK_U_RNFBESAM_NID268, ADDR_MASK, 6, 42)
    FIELD(CML_PORT_AGGR_GRP1_ADD_MASK_U_RNFBESAM_NID268, RESERVED_0, 0, 6)
REG32(CML_PORT_AGGR_GRP0_REG_U_RNFBESAM_NID268, 0x2168e40)
    FIELD(CML_PORT_AGGR_GRP0_REG_U_RNFBESAM_NID268, RESERVED_50, 50, 14)
    FIELD(CML_PORT_AGGR_GRP0_REG_U_RNFBESAM_NID268, NUM_CXG_PAG0, 48, 2)
    FIELD(CML_PORT_AGGR_GRP0_REG_U_RNFBESAM_NID268, RESERVED_47, 47, 1)
    FIELD(CML_PORT_AGGR_GRP0_REG_U_RNFBESAM_NID268, PAG0_TGTID3, 36, 11)
    FIELD(CML_PORT_AGGR_GRP0_REG_U_RNFBESAM_NID268, RESERVED_35, 35, 1)
    FIELD(CML_PORT_AGGR_GRP0_REG_U_RNFBESAM_NID268, PAG0_TGTID2, 24, 11)
    FIELD(CML_PORT_AGGR_GRP0_REG_U_RNFBESAM_NID268, RESERVED_23, 23, 1)
    FIELD(CML_PORT_AGGR_GRP0_REG_U_RNFBESAM_NID268, PAG0_TGTID1, 12, 11)
    FIELD(CML_PORT_AGGR_GRP0_REG_U_RNFBESAM_NID268, RESERVED_11, 11, 1)
    FIELD(CML_PORT_AGGR_GRP0_REG_U_RNFBESAM_NID268, PAG0_TGTID0, 0, 11)
REG32(CML_PORT_AGGR_GRP1_REG_U_RNFBESAM_NID268, 0x2168e48)
    FIELD(CML_PORT_AGGR_GRP1_REG_U_RNFBESAM_NID268, RESERVED_50, 50, 14)
    FIELD(CML_PORT_AGGR_GRP1_REG_U_RNFBESAM_NID268, NUM_CXG_PAG1, 48, 2)
    FIELD(CML_PORT_AGGR_GRP1_REG_U_RNFBESAM_NID268, RESERVED_47, 47, 1)
    FIELD(CML_PORT_AGGR_GRP1_REG_U_RNFBESAM_NID268, PAG1_TGTID3, 36, 11)
    FIELD(CML_PORT_AGGR_GRP1_REG_U_RNFBESAM_NID268, RESERVED_35, 35, 1)
    FIELD(CML_PORT_AGGR_GRP1_REG_U_RNFBESAM_NID268, PAG1_TGTID2, 24, 11)
    FIELD(CML_PORT_AGGR_GRP1_REG_U_RNFBESAM_NID268, RESERVED_23, 23, 1)
    FIELD(CML_PORT_AGGR_GRP1_REG_U_RNFBESAM_NID268, PAG1_TGTID1, 12, 11)
    FIELD(CML_PORT_AGGR_GRP1_REG_U_RNFBESAM_NID268, RESERVED_11, 11, 1)
    FIELD(CML_PORT_AGGR_GRP1_REG_U_RNFBESAM_NID268, PAG1_TGTID0, 0, 11)
REG32(SYS_CACHE_GRP_SECONDARY_REG0_U_RNFBESAM_NID268, 0x2168f00)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG0_U_RNFBESAM_NID268, RESERVED_63, 63, 1)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG0_U_RNFBESAM_NID268, REGION1_SCNDRY_BASE_ADDR, 41, 22)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG0_U_RNFBESAM_NID268, REGION1_SCNDRY_SIZE, 36, 5)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG0_U_RNFBESAM_NID268, REGION1_SCNDRY_TARGET_TYPE, 34, 2)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG0_U_RNFBESAM_NID268, RESERVED_33, 33, 1)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG0_U_RNFBESAM_NID268, REGION1_SCNDRY_VALID, 32, 1)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG0_U_RNFBESAM_NID268, RESERVED_31, 31, 1)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG0_U_RNFBESAM_NID268, REGION0_SCNDRY_BASE_ADDR, 9, 22)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG0_U_RNFBESAM_NID268, REGION0_SCNDRY_SIZE, 4, 5)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG0_U_RNFBESAM_NID268, REGION0_SCNDRY_TARGET_TYPE, 2, 2)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG0_U_RNFBESAM_NID268, REGION0_SCNDRY_VALID, 0, 1)
REG32(SYS_CACHE_GRP_SECONDARY_REG1_U_RNFBESAM_NID268, 0x2168f08)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG1_U_RNFBESAM_NID268, RESERVED_63, 63, 1)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG1_U_RNFBESAM_NID268, REGION3_SCNDRY_BASE_ADDR, 41, 22)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG1_U_RNFBESAM_NID268, REGION3_SCNDRY_SIZE, 36, 5)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG1_U_RNFBESAM_NID268, REGION3_SCNDRY_TARGET_TYPE, 34, 2)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG1_U_RNFBESAM_NID268, RESERVED_33, 33, 1)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG1_U_RNFBESAM_NID268, REGION3_SCNDRY_VALID, 32, 1)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG1_U_RNFBESAM_NID268, RESERVED_31, 31, 1)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG1_U_RNFBESAM_NID268, REGION2_SCNDRY_BASE_ADDR, 9, 22)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG1_U_RNFBESAM_NID268, REGION2_SCNDRY_SIZE, 4, 5)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG1_U_RNFBESAM_NID268, REGION2_SCNDRY_TARGET_TYPE, 2, 2)
    FIELD(SYS_CACHE_GRP_SECONDARY_REG1_U_RNFBESAM_NID268, REGION2_SCNDRY_VALID, 0, 1)
REG32(SYS_CACHE_GRP_CAL_MODE_REG_U_RNFBESAM_NID268, 0x2168f10)
    FIELD(SYS_CACHE_GRP_CAL_MODE_REG_U_RNFBESAM_NID268, RESERVED_49, 49, 15)
    FIELD(SYS_CACHE_GRP_CAL_MODE_REG_U_RNFBESAM_NID268, SCG3_HNF_CAL_MODE_EN, 48, 1)
    FIELD(SYS_CACHE_GRP_CAL_MODE_REG_U_RNFBESAM_NID268, RESERVED_33, 33, 15)
    FIELD(SYS_CACHE_GRP_CAL_MODE_REG_U_RNFBESAM_NID268, SCG2_HNF_CAL_MODE_EN, 32, 1)
    FIELD(SYS_CACHE_GRP_CAL_MODE_REG_U_RNFBESAM_NID268, RESERVED_17, 17, 15)
    FIELD(SYS_CACHE_GRP_CAL_MODE_REG_U_RNFBESAM_NID268, SCG1_HNF_CAL_MODE_EN, 16, 1)
    FIELD(SYS_CACHE_GRP_CAL_MODE_REG_U_RNFBESAM_NID268, SCG0_HNF_CAL_MODE_EN, 0, 1)
REG32(RNSAM_HASH_ADDR_MASK_REG_U_RNFBESAM_NID268, 0x2168f18)
    FIELD(RNSAM_HASH_ADDR_MASK_REG_U_RNFBESAM_NID268, RESERVED_48, 48, 16)
    FIELD(RNSAM_HASH_ADDR_MASK_REG_U_RNFBESAM_NID268, ADDR_MASK, 6, 42)
    FIELD(RNSAM_HASH_ADDR_MASK_REG_U_RNFBESAM_NID268, RESERVED_0, 0, 6)
REG32(RNSAM_REGION_CMP_ADDR_MASK_REG_U_RNFBESAM_NID268, 0x2168f20)
    FIELD(RNSAM_REGION_CMP_ADDR_MASK_REG_U_RNFBESAM_NID268, RESERVED_48, 48, 16)
    FIELD(RNSAM_REGION_CMP_ADDR_MASK_REG_U_RNFBESAM_NID268, ADDR_MASK, 16, 32)
    FIELD(RNSAM_REGION_CMP_ADDR_MASK_REG_U_RNFBESAM_NID268, RESERVED_0, 0, 16)
REG32(SYS_CACHE_GRP_HN_NODEID_REG8_U_RNFBESAM_NID268, 0x2168f58)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG8_U_RNFBESAM_NID268, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG8_U_RNFBESAM_NID268, NODEID_35, 36, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG8_U_RNFBESAM_NID268, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG8_U_RNFBESAM_NID268, NODEID_34, 24, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG8_U_RNFBESAM_NID268, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG8_U_RNFBESAM_NID268, NODEID_33, 12, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG8_U_RNFBESAM_NID268, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG8_U_RNFBESAM_NID268, NODEID_32, 0, 11)
REG32(SYS_CACHE_GRP_HN_NODEID_REG9_U_RNFBESAM_NID268, 0x2168f60)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG9_U_RNFBESAM_NID268, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG9_U_RNFBESAM_NID268, NODEID_39, 36, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG9_U_RNFBESAM_NID268, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG9_U_RNFBESAM_NID268, NODEID_38, 24, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG9_U_RNFBESAM_NID268, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG9_U_RNFBESAM_NID268, NODEID_37, 12, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG9_U_RNFBESAM_NID268, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG9_U_RNFBESAM_NID268, NODEID_36, 0, 11)
REG32(SYS_CACHE_GRP_HN_NODEID_REG10_U_RNFBESAM_NID268, 0x2168f68)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG10_U_RNFBESAM_NID268, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG10_U_RNFBESAM_NID268, NODEID_43, 36, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG10_U_RNFBESAM_NID268, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG10_U_RNFBESAM_NID268, NODEID_42, 24, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG10_U_RNFBESAM_NID268, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG10_U_RNFBESAM_NID268, NODEID_41, 12, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG10_U_RNFBESAM_NID268, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG10_U_RNFBESAM_NID268, NODEID_40, 0, 11)
REG32(SYS_CACHE_GRP_HN_NODEID_REG11_U_RNFBESAM_NID268, 0x2168f70)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG11_U_RNFBESAM_NID268, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG11_U_RNFBESAM_NID268, NODEID_47, 36, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG11_U_RNFBESAM_NID268, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG11_U_RNFBESAM_NID268, NODEID_46, 24, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG11_U_RNFBESAM_NID268, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG11_U_RNFBESAM_NID268, NODEID_45, 12, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG11_U_RNFBESAM_NID268, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG11_U_RNFBESAM_NID268, NODEID_44, 0, 11)
REG32(SYS_CACHE_GRP_HN_NODEID_REG12_U_RNFBESAM_NID268, 0x2168f78)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG12_U_RNFBESAM_NID268, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG12_U_RNFBESAM_NID268, NODEID_51, 36, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG12_U_RNFBESAM_NID268, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG12_U_RNFBESAM_NID268, NODEID_50, 24, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG12_U_RNFBESAM_NID268, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG12_U_RNFBESAM_NID268, NODEID_49, 12, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG12_U_RNFBESAM_NID268, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG12_U_RNFBESAM_NID268, NODEID_48, 0, 11)
REG32(SYS_CACHE_GRP_HN_NODEID_REG13_U_RNFBESAM_NID268, 0x2168f80)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG13_U_RNFBESAM_NID268, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG13_U_RNFBESAM_NID268, NODEID_55, 36, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG13_U_RNFBESAM_NID268, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG13_U_RNFBESAM_NID268, NODEID_54, 24, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG13_U_RNFBESAM_NID268, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG13_U_RNFBESAM_NID268, NODEID_53, 12, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG13_U_RNFBESAM_NID268, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG13_U_RNFBESAM_NID268, NODEID_52, 0, 11)
REG32(SYS_CACHE_GRP_HN_NODEID_REG14_U_RNFBESAM_NID268, 0x2168f88)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG14_U_RNFBESAM_NID268, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG14_U_RNFBESAM_NID268, NODEID_59, 36, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG14_U_RNFBESAM_NID268, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG14_U_RNFBESAM_NID268, NODEID_58, 24, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG14_U_RNFBESAM_NID268, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG14_U_RNFBESAM_NID268, NODEID_57, 12, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG14_U_RNFBESAM_NID268, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG14_U_RNFBESAM_NID268, NODEID_56, 0, 11)
REG32(SYS_CACHE_GRP_HN_NODEID_REG15_U_RNFBESAM_NID268, 0x2168f90)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG15_U_RNFBESAM_NID268, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG15_U_RNFBESAM_NID268, NODEID_63, 36, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG15_U_RNFBESAM_NID268, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG15_U_RNFBESAM_NID268, NODEID_62, 24, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG15_U_RNFBESAM_NID268, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG15_U_RNFBESAM_NID268, NODEID_61, 12, 11)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG15_U_RNFBESAM_NID268, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_HN_NODEID_REG15_U_RNFBESAM_NID268, NODEID_60, 0, 11)
REG32(SYS_CACHE_GRP_SN_NODEID_REG8_U_RNFBESAM_NID268, 0x2169008)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG8_U_RNFBESAM_NID268, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG8_U_RNFBESAM_NID268, SN_NODEID_35, 36, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG8_U_RNFBESAM_NID268, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG8_U_RNFBESAM_NID268, SN_NODEID_34, 24, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG8_U_RNFBESAM_NID268, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG8_U_RNFBESAM_NID268, SN_NODEID_33, 12, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG8_U_RNFBESAM_NID268, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG8_U_RNFBESAM_NID268, SN_NODEID_32, 0, 11)
REG32(SYS_CACHE_GRP_SN_NODEID_REG9_U_RNFBESAM_NID268, 0x2169010)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG9_U_RNFBESAM_NID268, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG9_U_RNFBESAM_NID268, SN_NODEID_39, 36, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG9_U_RNFBESAM_NID268, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG9_U_RNFBESAM_NID268, SN_NODEID_38, 24, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG9_U_RNFBESAM_NID268, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG9_U_RNFBESAM_NID268, SN_NODEID_37, 12, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG9_U_RNFBESAM_NID268, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG9_U_RNFBESAM_NID268, SN_NODEID_36, 0, 11)
REG32(SYS_CACHE_GRP_SN_NODEID_REG10_U_RNFBESAM_NID268, 0x2169018)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG10_U_RNFBESAM_NID268, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG10_U_RNFBESAM_NID268, SN_NODEID_43, 36, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG10_U_RNFBESAM_NID268, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG10_U_RNFBESAM_NID268, SN_NODEID_42, 24, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG10_U_RNFBESAM_NID268, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG10_U_RNFBESAM_NID268, SN_NODEID_41, 12, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG10_U_RNFBESAM_NID268, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG10_U_RNFBESAM_NID268, SN_NODEID_40, 0, 11)
REG32(SYS_CACHE_GRP_SN_NODEID_REG11_U_RNFBESAM_NID268, 0x2169020)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG11_U_RNFBESAM_NID268, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG11_U_RNFBESAM_NID268, SN_NODEID_47, 36, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG11_U_RNFBESAM_NID268, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG11_U_RNFBESAM_NID268, SN_NODEID_46, 24, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG11_U_RNFBESAM_NID268, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG11_U_RNFBESAM_NID268, SN_NODEID_45, 12, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG11_U_RNFBESAM_NID268, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG11_U_RNFBESAM_NID268, SN_NODEID_44, 0, 11)
REG32(SYS_CACHE_GRP_SN_NODEID_REG12_U_RNFBESAM_NID268, 0x2169028)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG12_U_RNFBESAM_NID268, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG12_U_RNFBESAM_NID268, SN_NODEID_51, 36, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG12_U_RNFBESAM_NID268, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG12_U_RNFBESAM_NID268, SN_NODEID_50, 24, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG12_U_RNFBESAM_NID268, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG12_U_RNFBESAM_NID268, SN_NODEID_49, 12, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG12_U_RNFBESAM_NID268, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG12_U_RNFBESAM_NID268, SN_NODEID_48, 0, 11)
REG32(SYS_CACHE_GRP_SN_NODEID_REG13_U_RNFBESAM_NID268, 0x2169030)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG13_U_RNFBESAM_NID268, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG13_U_RNFBESAM_NID268, SN_NODEID_55, 36, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG13_U_RNFBESAM_NID268, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG13_U_RNFBESAM_NID268, SN_NODEID_54, 24, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG13_U_RNFBESAM_NID268, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG13_U_RNFBESAM_NID268, SN_NODEID_53, 12, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG13_U_RNFBESAM_NID268, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG13_U_RNFBESAM_NID268, SN_NODEID_52, 0, 11)
REG32(SYS_CACHE_GRP_SN_NODEID_REG14_U_RNFBESAM_NID268, 0x2169038)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG14_U_RNFBESAM_NID268, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG14_U_RNFBESAM_NID268, SN_NODEID_59, 36, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG14_U_RNFBESAM_NID268, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG14_U_RNFBESAM_NID268, SN_NODEID_58, 24, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG14_U_RNFBESAM_NID268, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG14_U_RNFBESAM_NID268, SN_NODEID_57, 12, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG14_U_RNFBESAM_NID268, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG14_U_RNFBESAM_NID268, SN_NODEID_56, 0, 11)
REG32(SYS_CACHE_GRP_SN_NODEID_REG15_U_RNFBESAM_NID268, 0x2169040)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG15_U_RNFBESAM_NID268, RESERVED_47, 47, 17)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG15_U_RNFBESAM_NID268, SN_NODEID_63, 36, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG15_U_RNFBESAM_NID268, RESERVED_35, 35, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG15_U_RNFBESAM_NID268, SN_NODEID_62, 24, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG15_U_RNFBESAM_NID268, RESERVED_23, 23, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG15_U_RNFBESAM_NID268, SN_NODEID_61, 12, 11)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG15_U_RNFBESAM_NID268, RESERVED_11, 11, 1)
    FIELD(SYS_CACHE_GRP_SN_NODEID_REG15_U_RNFBESAM_NID268, SN_NODEID_60, 0, 11)
REG32(POR_MPU_NODE_INFO_U_CXRH_NID264, 0x21d0000)
    FIELD(POR_MPU_NODE_INFO_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_NODE_INFO_U_CXRH_NID264, LOGICAL_ID, 32, 16)
    FIELD(POR_MPU_NODE_INFO_U_CXRH_NID264, NODE_ID, 16, 16)
    FIELD(POR_MPU_NODE_INFO_U_CXRH_NID264, NODE_TYPE, 0, 16)
REG32(POR_MPU_CHILD_INFO_U_CXRH_NID264, 0x21d0080)
    FIELD(POR_MPU_CHILD_INFO_U_CXRH_NID264, RESERVED_32, 32, 32)
    FIELD(POR_MPU_CHILD_INFO_U_CXRH_NID264, CHILD_PTR_OFFSET, 16, 16)
    FIELD(POR_MPU_CHILD_INFO_U_CXRH_NID264, CHILD_COUNT, 0, 16)
REG32(POR_MPU_UNIT_INFO_U_CXRH_NID264, 0x21d0900)
    FIELD(POR_MPU_UNIT_INFO_U_CXRH_NID264, RESERVED_16, 16, 48)
    FIELD(POR_MPU_UNIT_INFO_U_CXRH_NID264, MASTER_7_PRESENT, 15, 1)
    FIELD(POR_MPU_UNIT_INFO_U_CXRH_NID264, MASTER_6_PRESENT, 14, 1)
    FIELD(POR_MPU_UNIT_INFO_U_CXRH_NID264, MASTER_5_PRESENT, 13, 1)
    FIELD(POR_MPU_UNIT_INFO_U_CXRH_NID264, MASTER_4_PRESENT, 12, 1)
    FIELD(POR_MPU_UNIT_INFO_U_CXRH_NID264, MASTER_3_PRESENT, 11, 1)
    FIELD(POR_MPU_UNIT_INFO_U_CXRH_NID264, MASTER_2_PRESENT, 10, 1)
    FIELD(POR_MPU_UNIT_INFO_U_CXRH_NID264, MASTER_1_PRESENT, 9, 1)
    FIELD(POR_MPU_UNIT_INFO_U_CXRH_NID264, MASTER_0_PRESENT, 8, 1)
    FIELD(POR_MPU_UNIT_INFO_U_CXRH_NID264, NUM_PROG_REGION, 0, 8)
REG32(POR_MPU_M0_CTL_U_CXRH_NID264, 0x21d1000)
    FIELD(POR_MPU_M0_CTL_U_CXRH_NID264, M0_EN, 2, 1)
    FIELD(POR_MPU_M0_CTL_U_CXRH_NID264, M0_ACTION, 0, 2)
REG32(POR_MPU_M0_PRBAR0_U_CXRH_NID264, 0x21d1010)
    FIELD(POR_MPU_M0_PRBAR0_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR0_U_CXRH_NID264, REGION0_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR0_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR0_U_CXRH_NID264, REGION0_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR0_U_CXRH_NID264, REGION0_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR0_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR0_U_CXRH_NID264, 0x21d1018)
    FIELD(POR_MPU_M0_PRLAR0_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR0_U_CXRH_NID264, REGION0_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR0_U_CXRH_NID264, REGION0_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR1_U_CXRH_NID264, 0x21d1020)
    FIELD(POR_MPU_M0_PRBAR1_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR1_U_CXRH_NID264, REGION1_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR1_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR1_U_CXRH_NID264, REGION1_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR1_U_CXRH_NID264, REGION1_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR1_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR1_U_CXRH_NID264, 0x21d1028)
    FIELD(POR_MPU_M0_PRLAR1_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR1_U_CXRH_NID264, REGION1_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR1_U_CXRH_NID264, REGION1_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR2_U_CXRH_NID264, 0x21d1030)
    FIELD(POR_MPU_M0_PRBAR2_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR2_U_CXRH_NID264, REGION2_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR2_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR2_U_CXRH_NID264, REGION2_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR2_U_CXRH_NID264, REGION2_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR2_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR2_U_CXRH_NID264, 0x21d1038)
    FIELD(POR_MPU_M0_PRLAR2_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR2_U_CXRH_NID264, REGION2_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR2_U_CXRH_NID264, REGION2_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR3_U_CXRH_NID264, 0x21d1040)
    FIELD(POR_MPU_M0_PRBAR3_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR3_U_CXRH_NID264, REGION3_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR3_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR3_U_CXRH_NID264, REGION3_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR3_U_CXRH_NID264, REGION3_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR3_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR3_U_CXRH_NID264, 0x21d1048)
    FIELD(POR_MPU_M0_PRLAR3_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR3_U_CXRH_NID264, REGION3_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR3_U_CXRH_NID264, REGION3_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR4_U_CXRH_NID264, 0x21d1050)
    FIELD(POR_MPU_M0_PRBAR4_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR4_U_CXRH_NID264, REGION4_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR4_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR4_U_CXRH_NID264, REGION4_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR4_U_CXRH_NID264, REGION4_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR4_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR4_U_CXRH_NID264, 0x21d1058)
    FIELD(POR_MPU_M0_PRLAR4_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR4_U_CXRH_NID264, REGION4_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR4_U_CXRH_NID264, REGION4_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR5_U_CXRH_NID264, 0x21d1060)
    FIELD(POR_MPU_M0_PRBAR5_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR5_U_CXRH_NID264, REGION5_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR5_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR5_U_CXRH_NID264, REGION5_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR5_U_CXRH_NID264, REGION5_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR5_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR5_U_CXRH_NID264, 0x21d1068)
    FIELD(POR_MPU_M0_PRLAR5_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR5_U_CXRH_NID264, REGION5_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR5_U_CXRH_NID264, REGION5_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR6_U_CXRH_NID264, 0x21d1070)
    FIELD(POR_MPU_M0_PRBAR6_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR6_U_CXRH_NID264, REGION6_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR6_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR6_U_CXRH_NID264, REGION6_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR6_U_CXRH_NID264, REGION6_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR6_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR6_U_CXRH_NID264, 0x21d1078)
    FIELD(POR_MPU_M0_PRLAR6_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR6_U_CXRH_NID264, REGION6_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR6_U_CXRH_NID264, REGION6_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR7_U_CXRH_NID264, 0x21d1080)
    FIELD(POR_MPU_M0_PRBAR7_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR7_U_CXRH_NID264, REGION7_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR7_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR7_U_CXRH_NID264, REGION7_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR7_U_CXRH_NID264, REGION7_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR7_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR7_U_CXRH_NID264, 0x21d1088)
    FIELD(POR_MPU_M0_PRLAR7_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR7_U_CXRH_NID264, REGION7_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR7_U_CXRH_NID264, REGION7_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR8_U_CXRH_NID264, 0x21d1090)
    FIELD(POR_MPU_M0_PRBAR8_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR8_U_CXRH_NID264, REGION8_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR8_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR8_U_CXRH_NID264, REGION8_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR8_U_CXRH_NID264, REGION8_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR8_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR8_U_CXRH_NID264, 0x21d1098)
    FIELD(POR_MPU_M0_PRLAR8_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR8_U_CXRH_NID264, REGION8_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR8_U_CXRH_NID264, REGION8_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR9_U_CXRH_NID264, 0x21d10a0)
    FIELD(POR_MPU_M0_PRBAR9_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR9_U_CXRH_NID264, REGION9_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR9_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR9_U_CXRH_NID264, REGION9_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR9_U_CXRH_NID264, REGION9_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR9_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR9_U_CXRH_NID264, 0x21d10a8)
    FIELD(POR_MPU_M0_PRLAR9_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR9_U_CXRH_NID264, REGION9_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR9_U_CXRH_NID264, REGION9_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR10_U_CXRH_NID264, 0x21d10b0)
    FIELD(POR_MPU_M0_PRBAR10_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR10_U_CXRH_NID264, REGION10_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR10_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR10_U_CXRH_NID264, REGION10_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR10_U_CXRH_NID264, REGION10_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR10_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR10_U_CXRH_NID264, 0x21d10b8)
    FIELD(POR_MPU_M0_PRLAR10_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR10_U_CXRH_NID264, REGION10_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR10_U_CXRH_NID264, REGION10_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR11_U_CXRH_NID264, 0x21d10c0)
    FIELD(POR_MPU_M0_PRBAR11_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR11_U_CXRH_NID264, REGION11_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR11_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR11_U_CXRH_NID264, REGION11_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR11_U_CXRH_NID264, REGION11_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR11_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR11_U_CXRH_NID264, 0x21d10c8)
    FIELD(POR_MPU_M0_PRLAR11_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR11_U_CXRH_NID264, REGION11_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR11_U_CXRH_NID264, REGION11_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR12_U_CXRH_NID264, 0x21d10d0)
    FIELD(POR_MPU_M0_PRBAR12_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR12_U_CXRH_NID264, REGION12_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR12_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR12_U_CXRH_NID264, REGION12_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR12_U_CXRH_NID264, REGION12_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR12_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR12_U_CXRH_NID264, 0x21d10d8)
    FIELD(POR_MPU_M0_PRLAR12_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR12_U_CXRH_NID264, REGION12_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR12_U_CXRH_NID264, REGION12_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR13_U_CXRH_NID264, 0x21d10e0)
    FIELD(POR_MPU_M0_PRBAR13_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR13_U_CXRH_NID264, REGION13_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR13_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR13_U_CXRH_NID264, REGION13_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR13_U_CXRH_NID264, REGION13_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR13_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR13_U_CXRH_NID264, 0x21d10e8)
    FIELD(POR_MPU_M0_PRLAR13_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR13_U_CXRH_NID264, REGION13_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR13_U_CXRH_NID264, REGION13_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR14_U_CXRH_NID264, 0x21d10f0)
    FIELD(POR_MPU_M0_PRBAR14_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR14_U_CXRH_NID264, REGION14_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR14_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR14_U_CXRH_NID264, REGION14_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR14_U_CXRH_NID264, REGION14_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR14_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR14_U_CXRH_NID264, 0x21d10f8)
    FIELD(POR_MPU_M0_PRLAR14_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR14_U_CXRH_NID264, REGION14_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR14_U_CXRH_NID264, REGION14_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR15_U_CXRH_NID264, 0x21d1100)
    FIELD(POR_MPU_M0_PRBAR15_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR15_U_CXRH_NID264, REGION15_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR15_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR15_U_CXRH_NID264, REGION15_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR15_U_CXRH_NID264, REGION15_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR15_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR15_U_CXRH_NID264, 0x21d1108)
    FIELD(POR_MPU_M0_PRLAR15_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR15_U_CXRH_NID264, REGION15_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR15_U_CXRH_NID264, REGION15_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR16_U_CXRH_NID264, 0x21d1110)
    FIELD(POR_MPU_M0_PRBAR16_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR16_U_CXRH_NID264, REGION16_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR16_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR16_U_CXRH_NID264, REGION16_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR16_U_CXRH_NID264, REGION16_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR16_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR16_U_CXRH_NID264, 0x21d1118)
    FIELD(POR_MPU_M0_PRLAR16_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR16_U_CXRH_NID264, REGION16_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR16_U_CXRH_NID264, REGION16_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR17_U_CXRH_NID264, 0x21d1120)
    FIELD(POR_MPU_M0_PRBAR17_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR17_U_CXRH_NID264, REGION17_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR17_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR17_U_CXRH_NID264, REGION17_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR17_U_CXRH_NID264, REGION17_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR17_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR17_U_CXRH_NID264, 0x21d1128)
    FIELD(POR_MPU_M0_PRLAR17_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR17_U_CXRH_NID264, REGION17_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR17_U_CXRH_NID264, REGION17_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR18_U_CXRH_NID264, 0x21d1130)
    FIELD(POR_MPU_M0_PRBAR18_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR18_U_CXRH_NID264, REGION18_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR18_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR18_U_CXRH_NID264, REGION18_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR18_U_CXRH_NID264, REGION18_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR18_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR18_U_CXRH_NID264, 0x21d1138)
    FIELD(POR_MPU_M0_PRLAR18_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR18_U_CXRH_NID264, REGION18_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR18_U_CXRH_NID264, REGION18_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR19_U_CXRH_NID264, 0x21d1140)
    FIELD(POR_MPU_M0_PRBAR19_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR19_U_CXRH_NID264, REGION19_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR19_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR19_U_CXRH_NID264, REGION19_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR19_U_CXRH_NID264, REGION19_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR19_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR19_U_CXRH_NID264, 0x21d1148)
    FIELD(POR_MPU_M0_PRLAR19_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR19_U_CXRH_NID264, REGION19_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR19_U_CXRH_NID264, REGION19_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR20_U_CXRH_NID264, 0x21d1150)
    FIELD(POR_MPU_M0_PRBAR20_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR20_U_CXRH_NID264, REGION20_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR20_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR20_U_CXRH_NID264, REGION20_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR20_U_CXRH_NID264, REGION20_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR20_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR20_U_CXRH_NID264, 0x21d1158)
    FIELD(POR_MPU_M0_PRLAR20_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR20_U_CXRH_NID264, REGION20_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR20_U_CXRH_NID264, REGION20_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR21_U_CXRH_NID264, 0x21d1160)
    FIELD(POR_MPU_M0_PRBAR21_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR21_U_CXRH_NID264, REGION21_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR21_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR21_U_CXRH_NID264, REGION21_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR21_U_CXRH_NID264, REGION21_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR21_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR21_U_CXRH_NID264, 0x21d1168)
    FIELD(POR_MPU_M0_PRLAR21_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR21_U_CXRH_NID264, REGION21_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR21_U_CXRH_NID264, REGION21_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR22_U_CXRH_NID264, 0x21d1170)
    FIELD(POR_MPU_M0_PRBAR22_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR22_U_CXRH_NID264, REGION22_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR22_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR22_U_CXRH_NID264, REGION22_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR22_U_CXRH_NID264, REGION22_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR22_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR22_U_CXRH_NID264, 0x21d1178)
    FIELD(POR_MPU_M0_PRLAR22_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR22_U_CXRH_NID264, REGION22_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR22_U_CXRH_NID264, REGION22_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR23_U_CXRH_NID264, 0x21d1180)
    FIELD(POR_MPU_M0_PRBAR23_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR23_U_CXRH_NID264, REGION23_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR23_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR23_U_CXRH_NID264, REGION23_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR23_U_CXRH_NID264, REGION23_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR23_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR23_U_CXRH_NID264, 0x21d1188)
    FIELD(POR_MPU_M0_PRLAR23_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR23_U_CXRH_NID264, REGION23_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR23_U_CXRH_NID264, REGION23_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR24_U_CXRH_NID264, 0x21d1190)
    FIELD(POR_MPU_M0_PRBAR24_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR24_U_CXRH_NID264, REGION24_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR24_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR24_U_CXRH_NID264, REGION24_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR24_U_CXRH_NID264, REGION24_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR24_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR24_U_CXRH_NID264, 0x21d1198)
    FIELD(POR_MPU_M0_PRLAR24_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR24_U_CXRH_NID264, REGION24_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR24_U_CXRH_NID264, REGION24_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR25_U_CXRH_NID264, 0x21d11a0)
    FIELD(POR_MPU_M0_PRBAR25_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR25_U_CXRH_NID264, REGION25_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR25_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR25_U_CXRH_NID264, REGION25_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR25_U_CXRH_NID264, REGION25_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR25_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR25_U_CXRH_NID264, 0x21d11a8)
    FIELD(POR_MPU_M0_PRLAR25_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR25_U_CXRH_NID264, REGION25_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR25_U_CXRH_NID264, REGION25_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR26_U_CXRH_NID264, 0x21d11b0)
    FIELD(POR_MPU_M0_PRBAR26_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR26_U_CXRH_NID264, REGION26_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR26_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR26_U_CXRH_NID264, REGION26_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR26_U_CXRH_NID264, REGION26_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR26_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR26_U_CXRH_NID264, 0x21d11b8)
    FIELD(POR_MPU_M0_PRLAR26_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR26_U_CXRH_NID264, REGION26_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR26_U_CXRH_NID264, REGION26_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR27_U_CXRH_NID264, 0x21d11c0)
    FIELD(POR_MPU_M0_PRBAR27_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR27_U_CXRH_NID264, REGION27_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR27_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR27_U_CXRH_NID264, REGION27_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR27_U_CXRH_NID264, REGION27_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR27_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR27_U_CXRH_NID264, 0x21d11c8)
    FIELD(POR_MPU_M0_PRLAR27_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR27_U_CXRH_NID264, REGION27_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR27_U_CXRH_NID264, REGION27_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR28_U_CXRH_NID264, 0x21d11d0)
    FIELD(POR_MPU_M0_PRBAR28_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR28_U_CXRH_NID264, REGION28_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR28_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR28_U_CXRH_NID264, REGION28_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR28_U_CXRH_NID264, REGION28_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR28_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR28_U_CXRH_NID264, 0x21d11d8)
    FIELD(POR_MPU_M0_PRLAR28_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR28_U_CXRH_NID264, REGION28_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR28_U_CXRH_NID264, REGION28_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR29_U_CXRH_NID264, 0x21d11e0)
    FIELD(POR_MPU_M0_PRBAR29_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR29_U_CXRH_NID264, REGION29_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR29_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR29_U_CXRH_NID264, REGION29_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR29_U_CXRH_NID264, REGION29_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR29_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR29_U_CXRH_NID264, 0x21d11e8)
    FIELD(POR_MPU_M0_PRLAR29_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR29_U_CXRH_NID264, REGION29_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR29_U_CXRH_NID264, REGION29_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR30_U_CXRH_NID264, 0x21d11f0)
    FIELD(POR_MPU_M0_PRBAR30_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR30_U_CXRH_NID264, REGION30_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR30_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR30_U_CXRH_NID264, REGION30_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR30_U_CXRH_NID264, REGION30_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR30_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR30_U_CXRH_NID264, 0x21d11f8)
    FIELD(POR_MPU_M0_PRLAR30_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR30_U_CXRH_NID264, REGION30_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR30_U_CXRH_NID264, REGION30_EN, 0, 1)
REG32(POR_MPU_M0_PRBAR31_U_CXRH_NID264, 0x21d1200)
    FIELD(POR_MPU_M0_PRBAR31_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRBAR31_U_CXRH_NID264, REGION31_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRBAR31_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M0_PRBAR31_U_CXRH_NID264, REGION31_BR, 9, 1)
    FIELD(POR_MPU_M0_PRBAR31_U_CXRH_NID264, REGION31_AP, 2, 4)
    FIELD(POR_MPU_M0_PRBAR31_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M0_PRLAR31_U_CXRH_NID264, 0x21d1208)
    FIELD(POR_MPU_M0_PRLAR31_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M0_PRLAR31_U_CXRH_NID264, REGION31_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M0_PRLAR31_U_CXRH_NID264, REGION31_EN, 0, 1)
REG32(POR_MPU_M1_CTL_U_CXRH_NID264, 0x21d1400)
    FIELD(POR_MPU_M1_CTL_U_CXRH_NID264, M1_EN, 2, 1)
    FIELD(POR_MPU_M1_CTL_U_CXRH_NID264, M1_ACTION, 0, 2)
REG32(POR_MPU_M1_PRBAR0_U_CXRH_NID264, 0x21d1410)
    FIELD(POR_MPU_M1_PRBAR0_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR0_U_CXRH_NID264, REGION0_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR0_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR0_U_CXRH_NID264, REGION0_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR0_U_CXRH_NID264, REGION0_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR0_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR0_U_CXRH_NID264, 0x21d1418)
    FIELD(POR_MPU_M1_PRLAR0_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR0_U_CXRH_NID264, REGION0_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR0_U_CXRH_NID264, REGION0_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR1_U_CXRH_NID264, 0x21d1420)
    FIELD(POR_MPU_M1_PRBAR1_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR1_U_CXRH_NID264, REGION1_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR1_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR1_U_CXRH_NID264, REGION1_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR1_U_CXRH_NID264, REGION1_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR1_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR1_U_CXRH_NID264, 0x21d1428)
    FIELD(POR_MPU_M1_PRLAR1_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR1_U_CXRH_NID264, REGION1_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR1_U_CXRH_NID264, REGION1_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR2_U_CXRH_NID264, 0x21d1430)
    FIELD(POR_MPU_M1_PRBAR2_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR2_U_CXRH_NID264, REGION2_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR2_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR2_U_CXRH_NID264, REGION2_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR2_U_CXRH_NID264, REGION2_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR2_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR2_U_CXRH_NID264, 0x21d1438)
    FIELD(POR_MPU_M1_PRLAR2_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR2_U_CXRH_NID264, REGION2_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR2_U_CXRH_NID264, REGION2_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR3_U_CXRH_NID264, 0x21d1440)
    FIELD(POR_MPU_M1_PRBAR3_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR3_U_CXRH_NID264, REGION3_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR3_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR3_U_CXRH_NID264, REGION3_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR3_U_CXRH_NID264, REGION3_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR3_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR3_U_CXRH_NID264, 0x21d1448)
    FIELD(POR_MPU_M1_PRLAR3_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR3_U_CXRH_NID264, REGION3_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR3_U_CXRH_NID264, REGION3_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR4_U_CXRH_NID264, 0x21d1450)
    FIELD(POR_MPU_M1_PRBAR4_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR4_U_CXRH_NID264, REGION4_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR4_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR4_U_CXRH_NID264, REGION4_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR4_U_CXRH_NID264, REGION4_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR4_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR4_U_CXRH_NID264, 0x21d1458)
    FIELD(POR_MPU_M1_PRLAR4_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR4_U_CXRH_NID264, REGION4_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR4_U_CXRH_NID264, REGION4_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR5_U_CXRH_NID264, 0x21d1460)
    FIELD(POR_MPU_M1_PRBAR5_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR5_U_CXRH_NID264, REGION5_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR5_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR5_U_CXRH_NID264, REGION5_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR5_U_CXRH_NID264, REGION5_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR5_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR5_U_CXRH_NID264, 0x21d1468)
    FIELD(POR_MPU_M1_PRLAR5_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR5_U_CXRH_NID264, REGION5_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR5_U_CXRH_NID264, REGION5_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR6_U_CXRH_NID264, 0x21d1470)
    FIELD(POR_MPU_M1_PRBAR6_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR6_U_CXRH_NID264, REGION6_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR6_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR6_U_CXRH_NID264, REGION6_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR6_U_CXRH_NID264, REGION6_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR6_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR6_U_CXRH_NID264, 0x21d1478)
    FIELD(POR_MPU_M1_PRLAR6_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR6_U_CXRH_NID264, REGION6_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR6_U_CXRH_NID264, REGION6_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR7_U_CXRH_NID264, 0x21d1480)
    FIELD(POR_MPU_M1_PRBAR7_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR7_U_CXRH_NID264, REGION7_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR7_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR7_U_CXRH_NID264, REGION7_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR7_U_CXRH_NID264, REGION7_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR7_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR7_U_CXRH_NID264, 0x21d1488)
    FIELD(POR_MPU_M1_PRLAR7_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR7_U_CXRH_NID264, REGION7_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR7_U_CXRH_NID264, REGION7_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR8_U_CXRH_NID264, 0x21d1490)
    FIELD(POR_MPU_M1_PRBAR8_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR8_U_CXRH_NID264, REGION8_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR8_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR8_U_CXRH_NID264, REGION8_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR8_U_CXRH_NID264, REGION8_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR8_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR8_U_CXRH_NID264, 0x21d1498)
    FIELD(POR_MPU_M1_PRLAR8_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR8_U_CXRH_NID264, REGION8_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR8_U_CXRH_NID264, REGION8_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR9_U_CXRH_NID264, 0x21d14a0)
    FIELD(POR_MPU_M1_PRBAR9_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR9_U_CXRH_NID264, REGION9_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR9_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR9_U_CXRH_NID264, REGION9_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR9_U_CXRH_NID264, REGION9_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR9_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR9_U_CXRH_NID264, 0x21d14a8)
    FIELD(POR_MPU_M1_PRLAR9_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR9_U_CXRH_NID264, REGION9_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR9_U_CXRH_NID264, REGION9_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR10_U_CXRH_NID264, 0x21d14b0)
    FIELD(POR_MPU_M1_PRBAR10_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR10_U_CXRH_NID264, REGION10_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR10_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR10_U_CXRH_NID264, REGION10_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR10_U_CXRH_NID264, REGION10_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR10_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR10_U_CXRH_NID264, 0x21d14b8)
    FIELD(POR_MPU_M1_PRLAR10_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR10_U_CXRH_NID264, REGION10_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR10_U_CXRH_NID264, REGION10_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR11_U_CXRH_NID264, 0x21d14c0)
    FIELD(POR_MPU_M1_PRBAR11_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR11_U_CXRH_NID264, REGION11_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR11_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR11_U_CXRH_NID264, REGION11_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR11_U_CXRH_NID264, REGION11_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR11_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR11_U_CXRH_NID264, 0x21d14c8)
    FIELD(POR_MPU_M1_PRLAR11_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR11_U_CXRH_NID264, REGION11_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR11_U_CXRH_NID264, REGION11_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR12_U_CXRH_NID264, 0x21d14d0)
    FIELD(POR_MPU_M1_PRBAR12_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR12_U_CXRH_NID264, REGION12_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR12_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR12_U_CXRH_NID264, REGION12_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR12_U_CXRH_NID264, REGION12_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR12_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR12_U_CXRH_NID264, 0x21d14d8)
    FIELD(POR_MPU_M1_PRLAR12_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR12_U_CXRH_NID264, REGION12_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR12_U_CXRH_NID264, REGION12_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR13_U_CXRH_NID264, 0x21d14e0)
    FIELD(POR_MPU_M1_PRBAR13_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR13_U_CXRH_NID264, REGION13_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR13_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR13_U_CXRH_NID264, REGION13_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR13_U_CXRH_NID264, REGION13_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR13_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR13_U_CXRH_NID264, 0x21d14e8)
    FIELD(POR_MPU_M1_PRLAR13_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR13_U_CXRH_NID264, REGION13_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR13_U_CXRH_NID264, REGION13_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR14_U_CXRH_NID264, 0x21d14f0)
    FIELD(POR_MPU_M1_PRBAR14_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR14_U_CXRH_NID264, REGION14_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR14_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR14_U_CXRH_NID264, REGION14_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR14_U_CXRH_NID264, REGION14_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR14_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR14_U_CXRH_NID264, 0x21d14f8)
    FIELD(POR_MPU_M1_PRLAR14_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR14_U_CXRH_NID264, REGION14_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR14_U_CXRH_NID264, REGION14_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR15_U_CXRH_NID264, 0x21d1500)
    FIELD(POR_MPU_M1_PRBAR15_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR15_U_CXRH_NID264, REGION15_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR15_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR15_U_CXRH_NID264, REGION15_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR15_U_CXRH_NID264, REGION15_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR15_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR15_U_CXRH_NID264, 0x21d1508)
    FIELD(POR_MPU_M1_PRLAR15_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR15_U_CXRH_NID264, REGION15_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR15_U_CXRH_NID264, REGION15_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR16_U_CXRH_NID264, 0x21d1510)
    FIELD(POR_MPU_M1_PRBAR16_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR16_U_CXRH_NID264, REGION16_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR16_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR16_U_CXRH_NID264, REGION16_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR16_U_CXRH_NID264, REGION16_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR16_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR16_U_CXRH_NID264, 0x21d1518)
    FIELD(POR_MPU_M1_PRLAR16_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR16_U_CXRH_NID264, REGION16_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR16_U_CXRH_NID264, REGION16_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR17_U_CXRH_NID264, 0x21d1520)
    FIELD(POR_MPU_M1_PRBAR17_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR17_U_CXRH_NID264, REGION17_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR17_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR17_U_CXRH_NID264, REGION17_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR17_U_CXRH_NID264, REGION17_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR17_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR17_U_CXRH_NID264, 0x21d1528)
    FIELD(POR_MPU_M1_PRLAR17_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR17_U_CXRH_NID264, REGION17_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR17_U_CXRH_NID264, REGION17_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR18_U_CXRH_NID264, 0x21d1530)
    FIELD(POR_MPU_M1_PRBAR18_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR18_U_CXRH_NID264, REGION18_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR18_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR18_U_CXRH_NID264, REGION18_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR18_U_CXRH_NID264, REGION18_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR18_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR18_U_CXRH_NID264, 0x21d1538)
    FIELD(POR_MPU_M1_PRLAR18_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR18_U_CXRH_NID264, REGION18_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR18_U_CXRH_NID264, REGION18_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR19_U_CXRH_NID264, 0x21d1540)
    FIELD(POR_MPU_M1_PRBAR19_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR19_U_CXRH_NID264, REGION19_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR19_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR19_U_CXRH_NID264, REGION19_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR19_U_CXRH_NID264, REGION19_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR19_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR19_U_CXRH_NID264, 0x21d1548)
    FIELD(POR_MPU_M1_PRLAR19_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR19_U_CXRH_NID264, REGION19_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR19_U_CXRH_NID264, REGION19_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR20_U_CXRH_NID264, 0x21d1550)
    FIELD(POR_MPU_M1_PRBAR20_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR20_U_CXRH_NID264, REGION20_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR20_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR20_U_CXRH_NID264, REGION20_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR20_U_CXRH_NID264, REGION20_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR20_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR20_U_CXRH_NID264, 0x21d1558)
    FIELD(POR_MPU_M1_PRLAR20_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR20_U_CXRH_NID264, REGION20_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR20_U_CXRH_NID264, REGION20_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR21_U_CXRH_NID264, 0x21d1560)
    FIELD(POR_MPU_M1_PRBAR21_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR21_U_CXRH_NID264, REGION21_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR21_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR21_U_CXRH_NID264, REGION21_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR21_U_CXRH_NID264, REGION21_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR21_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR21_U_CXRH_NID264, 0x21d1568)
    FIELD(POR_MPU_M1_PRLAR21_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR21_U_CXRH_NID264, REGION21_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR21_U_CXRH_NID264, REGION21_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR22_U_CXRH_NID264, 0x21d1570)
    FIELD(POR_MPU_M1_PRBAR22_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR22_U_CXRH_NID264, REGION22_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR22_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR22_U_CXRH_NID264, REGION22_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR22_U_CXRH_NID264, REGION22_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR22_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR22_U_CXRH_NID264, 0x21d1578)
    FIELD(POR_MPU_M1_PRLAR22_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR22_U_CXRH_NID264, REGION22_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR22_U_CXRH_NID264, REGION22_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR23_U_CXRH_NID264, 0x21d1580)
    FIELD(POR_MPU_M1_PRBAR23_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR23_U_CXRH_NID264, REGION23_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR23_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR23_U_CXRH_NID264, REGION23_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR23_U_CXRH_NID264, REGION23_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR23_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR23_U_CXRH_NID264, 0x21d1588)
    FIELD(POR_MPU_M1_PRLAR23_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR23_U_CXRH_NID264, REGION23_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR23_U_CXRH_NID264, REGION23_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR24_U_CXRH_NID264, 0x21d1590)
    FIELD(POR_MPU_M1_PRBAR24_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR24_U_CXRH_NID264, REGION24_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR24_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR24_U_CXRH_NID264, REGION24_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR24_U_CXRH_NID264, REGION24_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR24_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR24_U_CXRH_NID264, 0x21d1598)
    FIELD(POR_MPU_M1_PRLAR24_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR24_U_CXRH_NID264, REGION24_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR24_U_CXRH_NID264, REGION24_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR25_U_CXRH_NID264, 0x21d15a0)
    FIELD(POR_MPU_M1_PRBAR25_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR25_U_CXRH_NID264, REGION25_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR25_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR25_U_CXRH_NID264, REGION25_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR25_U_CXRH_NID264, REGION25_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR25_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR25_U_CXRH_NID264, 0x21d15a8)
    FIELD(POR_MPU_M1_PRLAR25_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR25_U_CXRH_NID264, REGION25_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR25_U_CXRH_NID264, REGION25_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR26_U_CXRH_NID264, 0x21d15b0)
    FIELD(POR_MPU_M1_PRBAR26_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR26_U_CXRH_NID264, REGION26_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR26_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR26_U_CXRH_NID264, REGION26_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR26_U_CXRH_NID264, REGION26_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR26_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR26_U_CXRH_NID264, 0x21d15b8)
    FIELD(POR_MPU_M1_PRLAR26_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR26_U_CXRH_NID264, REGION26_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR26_U_CXRH_NID264, REGION26_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR27_U_CXRH_NID264, 0x21d15c0)
    FIELD(POR_MPU_M1_PRBAR27_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR27_U_CXRH_NID264, REGION27_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR27_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR27_U_CXRH_NID264, REGION27_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR27_U_CXRH_NID264, REGION27_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR27_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR27_U_CXRH_NID264, 0x21d15c8)
    FIELD(POR_MPU_M1_PRLAR27_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR27_U_CXRH_NID264, REGION27_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR27_U_CXRH_NID264, REGION27_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR28_U_CXRH_NID264, 0x21d15d0)
    FIELD(POR_MPU_M1_PRBAR28_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR28_U_CXRH_NID264, REGION28_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR28_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR28_U_CXRH_NID264, REGION28_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR28_U_CXRH_NID264, REGION28_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR28_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR28_U_CXRH_NID264, 0x21d15d8)
    FIELD(POR_MPU_M1_PRLAR28_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR28_U_CXRH_NID264, REGION28_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR28_U_CXRH_NID264, REGION28_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR29_U_CXRH_NID264, 0x21d15e0)
    FIELD(POR_MPU_M1_PRBAR29_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR29_U_CXRH_NID264, REGION29_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR29_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR29_U_CXRH_NID264, REGION29_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR29_U_CXRH_NID264, REGION29_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR29_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR29_U_CXRH_NID264, 0x21d15e8)
    FIELD(POR_MPU_M1_PRLAR29_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR29_U_CXRH_NID264, REGION29_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR29_U_CXRH_NID264, REGION29_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR30_U_CXRH_NID264, 0x21d15f0)
    FIELD(POR_MPU_M1_PRBAR30_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR30_U_CXRH_NID264, REGION30_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR30_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR30_U_CXRH_NID264, REGION30_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR30_U_CXRH_NID264, REGION30_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR30_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR30_U_CXRH_NID264, 0x21d15f8)
    FIELD(POR_MPU_M1_PRLAR30_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR30_U_CXRH_NID264, REGION30_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR30_U_CXRH_NID264, REGION30_EN, 0, 1)
REG32(POR_MPU_M1_PRBAR31_U_CXRH_NID264, 0x21d1600)
    FIELD(POR_MPU_M1_PRBAR31_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRBAR31_U_CXRH_NID264, REGION31_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRBAR31_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M1_PRBAR31_U_CXRH_NID264, REGION31_BR, 9, 1)
    FIELD(POR_MPU_M1_PRBAR31_U_CXRH_NID264, REGION31_AP, 2, 4)
    FIELD(POR_MPU_M1_PRBAR31_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M1_PRLAR31_U_CXRH_NID264, 0x21d1608)
    FIELD(POR_MPU_M1_PRLAR31_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M1_PRLAR31_U_CXRH_NID264, REGION31_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M1_PRLAR31_U_CXRH_NID264, REGION31_EN, 0, 1)
REG32(POR_MPU_M2_CTL_U_CXRH_NID264, 0x21d1800)
    FIELD(POR_MPU_M2_CTL_U_CXRH_NID264, M2_EN, 2, 1)
    FIELD(POR_MPU_M2_CTL_U_CXRH_NID264, M2_ACTION, 0, 2)
REG32(POR_MPU_M2_PRBAR0_U_CXRH_NID264, 0x21d1810)
    FIELD(POR_MPU_M2_PRBAR0_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR0_U_CXRH_NID264, REGION0_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR0_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR0_U_CXRH_NID264, REGION0_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR0_U_CXRH_NID264, REGION0_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR0_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR0_U_CXRH_NID264, 0x21d1818)
    FIELD(POR_MPU_M2_PRLAR0_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR0_U_CXRH_NID264, REGION0_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR0_U_CXRH_NID264, REGION0_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR1_U_CXRH_NID264, 0x21d1820)
    FIELD(POR_MPU_M2_PRBAR1_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR1_U_CXRH_NID264, REGION1_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR1_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR1_U_CXRH_NID264, REGION1_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR1_U_CXRH_NID264, REGION1_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR1_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR1_U_CXRH_NID264, 0x21d1828)
    FIELD(POR_MPU_M2_PRLAR1_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR1_U_CXRH_NID264, REGION1_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR1_U_CXRH_NID264, REGION1_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR2_U_CXRH_NID264, 0x21d1830)
    FIELD(POR_MPU_M2_PRBAR2_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR2_U_CXRH_NID264, REGION2_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR2_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR2_U_CXRH_NID264, REGION2_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR2_U_CXRH_NID264, REGION2_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR2_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR2_U_CXRH_NID264, 0x21d1838)
    FIELD(POR_MPU_M2_PRLAR2_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR2_U_CXRH_NID264, REGION2_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR2_U_CXRH_NID264, REGION2_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR3_U_CXRH_NID264, 0x21d1840)
    FIELD(POR_MPU_M2_PRBAR3_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR3_U_CXRH_NID264, REGION3_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR3_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR3_U_CXRH_NID264, REGION3_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR3_U_CXRH_NID264, REGION3_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR3_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR3_U_CXRH_NID264, 0x21d1848)
    FIELD(POR_MPU_M2_PRLAR3_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR3_U_CXRH_NID264, REGION3_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR3_U_CXRH_NID264, REGION3_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR4_U_CXRH_NID264, 0x21d1850)
    FIELD(POR_MPU_M2_PRBAR4_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR4_U_CXRH_NID264, REGION4_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR4_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR4_U_CXRH_NID264, REGION4_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR4_U_CXRH_NID264, REGION4_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR4_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR4_U_CXRH_NID264, 0x21d1858)
    FIELD(POR_MPU_M2_PRLAR4_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR4_U_CXRH_NID264, REGION4_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR4_U_CXRH_NID264, REGION4_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR5_U_CXRH_NID264, 0x21d1860)
    FIELD(POR_MPU_M2_PRBAR5_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR5_U_CXRH_NID264, REGION5_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR5_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR5_U_CXRH_NID264, REGION5_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR5_U_CXRH_NID264, REGION5_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR5_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR5_U_CXRH_NID264, 0x21d1868)
    FIELD(POR_MPU_M2_PRLAR5_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR5_U_CXRH_NID264, REGION5_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR5_U_CXRH_NID264, REGION5_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR6_U_CXRH_NID264, 0x21d1870)
    FIELD(POR_MPU_M2_PRBAR6_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR6_U_CXRH_NID264, REGION6_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR6_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR6_U_CXRH_NID264, REGION6_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR6_U_CXRH_NID264, REGION6_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR6_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR6_U_CXRH_NID264, 0x21d1878)
    FIELD(POR_MPU_M2_PRLAR6_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR6_U_CXRH_NID264, REGION6_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR6_U_CXRH_NID264, REGION6_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR7_U_CXRH_NID264, 0x21d1880)
    FIELD(POR_MPU_M2_PRBAR7_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR7_U_CXRH_NID264, REGION7_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR7_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR7_U_CXRH_NID264, REGION7_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR7_U_CXRH_NID264, REGION7_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR7_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR7_U_CXRH_NID264, 0x21d1888)
    FIELD(POR_MPU_M2_PRLAR7_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR7_U_CXRH_NID264, REGION7_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR7_U_CXRH_NID264, REGION7_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR8_U_CXRH_NID264, 0x21d1890)
    FIELD(POR_MPU_M2_PRBAR8_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR8_U_CXRH_NID264, REGION8_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR8_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR8_U_CXRH_NID264, REGION8_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR8_U_CXRH_NID264, REGION8_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR8_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR8_U_CXRH_NID264, 0x21d1898)
    FIELD(POR_MPU_M2_PRLAR8_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR8_U_CXRH_NID264, REGION8_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR8_U_CXRH_NID264, REGION8_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR9_U_CXRH_NID264, 0x21d18a0)
    FIELD(POR_MPU_M2_PRBAR9_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR9_U_CXRH_NID264, REGION9_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR9_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR9_U_CXRH_NID264, REGION9_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR9_U_CXRH_NID264, REGION9_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR9_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR9_U_CXRH_NID264, 0x21d18a8)
    FIELD(POR_MPU_M2_PRLAR9_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR9_U_CXRH_NID264, REGION9_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR9_U_CXRH_NID264, REGION9_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR10_U_CXRH_NID264, 0x21d18b0)
    FIELD(POR_MPU_M2_PRBAR10_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR10_U_CXRH_NID264, REGION10_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR10_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR10_U_CXRH_NID264, REGION10_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR10_U_CXRH_NID264, REGION10_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR10_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR10_U_CXRH_NID264, 0x21d18b8)
    FIELD(POR_MPU_M2_PRLAR10_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR10_U_CXRH_NID264, REGION10_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR10_U_CXRH_NID264, REGION10_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR11_U_CXRH_NID264, 0x21d18c0)
    FIELD(POR_MPU_M2_PRBAR11_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR11_U_CXRH_NID264, REGION11_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR11_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR11_U_CXRH_NID264, REGION11_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR11_U_CXRH_NID264, REGION11_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR11_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR11_U_CXRH_NID264, 0x21d18c8)
    FIELD(POR_MPU_M2_PRLAR11_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR11_U_CXRH_NID264, REGION11_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR11_U_CXRH_NID264, REGION11_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR12_U_CXRH_NID264, 0x21d18d0)
    FIELD(POR_MPU_M2_PRBAR12_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR12_U_CXRH_NID264, REGION12_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR12_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR12_U_CXRH_NID264, REGION12_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR12_U_CXRH_NID264, REGION12_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR12_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR12_U_CXRH_NID264, 0x21d18d8)
    FIELD(POR_MPU_M2_PRLAR12_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR12_U_CXRH_NID264, REGION12_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR12_U_CXRH_NID264, REGION12_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR13_U_CXRH_NID264, 0x21d18e0)
    FIELD(POR_MPU_M2_PRBAR13_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR13_U_CXRH_NID264, REGION13_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR13_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR13_U_CXRH_NID264, REGION13_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR13_U_CXRH_NID264, REGION13_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR13_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR13_U_CXRH_NID264, 0x21d18e8)
    FIELD(POR_MPU_M2_PRLAR13_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR13_U_CXRH_NID264, REGION13_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR13_U_CXRH_NID264, REGION13_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR14_U_CXRH_NID264, 0x21d18f0)
    FIELD(POR_MPU_M2_PRBAR14_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR14_U_CXRH_NID264, REGION14_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR14_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR14_U_CXRH_NID264, REGION14_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR14_U_CXRH_NID264, REGION14_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR14_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR14_U_CXRH_NID264, 0x21d18f8)
    FIELD(POR_MPU_M2_PRLAR14_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR14_U_CXRH_NID264, REGION14_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR14_U_CXRH_NID264, REGION14_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR15_U_CXRH_NID264, 0x21d1900)
    FIELD(POR_MPU_M2_PRBAR15_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR15_U_CXRH_NID264, REGION15_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR15_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR15_U_CXRH_NID264, REGION15_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR15_U_CXRH_NID264, REGION15_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR15_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR15_U_CXRH_NID264, 0x21d1908)
    FIELD(POR_MPU_M2_PRLAR15_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR15_U_CXRH_NID264, REGION15_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR15_U_CXRH_NID264, REGION15_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR16_U_CXRH_NID264, 0x21d1910)
    FIELD(POR_MPU_M2_PRBAR16_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR16_U_CXRH_NID264, REGION16_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR16_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR16_U_CXRH_NID264, REGION16_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR16_U_CXRH_NID264, REGION16_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR16_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR16_U_CXRH_NID264, 0x21d1918)
    FIELD(POR_MPU_M2_PRLAR16_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR16_U_CXRH_NID264, REGION16_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR16_U_CXRH_NID264, REGION16_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR17_U_CXRH_NID264, 0x21d1920)
    FIELD(POR_MPU_M2_PRBAR17_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR17_U_CXRH_NID264, REGION17_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR17_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR17_U_CXRH_NID264, REGION17_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR17_U_CXRH_NID264, REGION17_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR17_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR17_U_CXRH_NID264, 0x21d1928)
    FIELD(POR_MPU_M2_PRLAR17_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR17_U_CXRH_NID264, REGION17_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR17_U_CXRH_NID264, REGION17_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR18_U_CXRH_NID264, 0x21d1930)
    FIELD(POR_MPU_M2_PRBAR18_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR18_U_CXRH_NID264, REGION18_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR18_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR18_U_CXRH_NID264, REGION18_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR18_U_CXRH_NID264, REGION18_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR18_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR18_U_CXRH_NID264, 0x21d1938)
    FIELD(POR_MPU_M2_PRLAR18_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR18_U_CXRH_NID264, REGION18_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR18_U_CXRH_NID264, REGION18_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR19_U_CXRH_NID264, 0x21d1940)
    FIELD(POR_MPU_M2_PRBAR19_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR19_U_CXRH_NID264, REGION19_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR19_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR19_U_CXRH_NID264, REGION19_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR19_U_CXRH_NID264, REGION19_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR19_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR19_U_CXRH_NID264, 0x21d1948)
    FIELD(POR_MPU_M2_PRLAR19_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR19_U_CXRH_NID264, REGION19_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR19_U_CXRH_NID264, REGION19_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR20_U_CXRH_NID264, 0x21d1950)
    FIELD(POR_MPU_M2_PRBAR20_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR20_U_CXRH_NID264, REGION20_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR20_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR20_U_CXRH_NID264, REGION20_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR20_U_CXRH_NID264, REGION20_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR20_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR20_U_CXRH_NID264, 0x21d1958)
    FIELD(POR_MPU_M2_PRLAR20_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR20_U_CXRH_NID264, REGION20_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR20_U_CXRH_NID264, REGION20_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR21_U_CXRH_NID264, 0x21d1960)
    FIELD(POR_MPU_M2_PRBAR21_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR21_U_CXRH_NID264, REGION21_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR21_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR21_U_CXRH_NID264, REGION21_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR21_U_CXRH_NID264, REGION21_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR21_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR21_U_CXRH_NID264, 0x21d1968)
    FIELD(POR_MPU_M2_PRLAR21_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR21_U_CXRH_NID264, REGION21_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR21_U_CXRH_NID264, REGION21_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR22_U_CXRH_NID264, 0x21d1970)
    FIELD(POR_MPU_M2_PRBAR22_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR22_U_CXRH_NID264, REGION22_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR22_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR22_U_CXRH_NID264, REGION22_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR22_U_CXRH_NID264, REGION22_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR22_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR22_U_CXRH_NID264, 0x21d1978)
    FIELD(POR_MPU_M2_PRLAR22_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR22_U_CXRH_NID264, REGION22_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR22_U_CXRH_NID264, REGION22_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR23_U_CXRH_NID264, 0x21d1980)
    FIELD(POR_MPU_M2_PRBAR23_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR23_U_CXRH_NID264, REGION23_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR23_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR23_U_CXRH_NID264, REGION23_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR23_U_CXRH_NID264, REGION23_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR23_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR23_U_CXRH_NID264, 0x21d1988)
    FIELD(POR_MPU_M2_PRLAR23_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR23_U_CXRH_NID264, REGION23_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR23_U_CXRH_NID264, REGION23_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR24_U_CXRH_NID264, 0x21d1990)
    FIELD(POR_MPU_M2_PRBAR24_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR24_U_CXRH_NID264, REGION24_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR24_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR24_U_CXRH_NID264, REGION24_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR24_U_CXRH_NID264, REGION24_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR24_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR24_U_CXRH_NID264, 0x21d1998)
    FIELD(POR_MPU_M2_PRLAR24_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR24_U_CXRH_NID264, REGION24_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR24_U_CXRH_NID264, REGION24_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR25_U_CXRH_NID264, 0x21d19a0)
    FIELD(POR_MPU_M2_PRBAR25_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR25_U_CXRH_NID264, REGION25_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR25_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR25_U_CXRH_NID264, REGION25_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR25_U_CXRH_NID264, REGION25_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR25_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR25_U_CXRH_NID264, 0x21d19a8)
    FIELD(POR_MPU_M2_PRLAR25_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR25_U_CXRH_NID264, REGION25_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR25_U_CXRH_NID264, REGION25_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR26_U_CXRH_NID264, 0x21d19b0)
    FIELD(POR_MPU_M2_PRBAR26_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR26_U_CXRH_NID264, REGION26_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR26_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR26_U_CXRH_NID264, REGION26_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR26_U_CXRH_NID264, REGION26_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR26_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR26_U_CXRH_NID264, 0x21d19b8)
    FIELD(POR_MPU_M2_PRLAR26_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR26_U_CXRH_NID264, REGION26_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR26_U_CXRH_NID264, REGION26_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR27_U_CXRH_NID264, 0x21d19c0)
    FIELD(POR_MPU_M2_PRBAR27_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR27_U_CXRH_NID264, REGION27_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR27_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR27_U_CXRH_NID264, REGION27_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR27_U_CXRH_NID264, REGION27_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR27_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR27_U_CXRH_NID264, 0x21d19c8)
    FIELD(POR_MPU_M2_PRLAR27_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR27_U_CXRH_NID264, REGION27_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR27_U_CXRH_NID264, REGION27_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR28_U_CXRH_NID264, 0x21d19d0)
    FIELD(POR_MPU_M2_PRBAR28_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR28_U_CXRH_NID264, REGION28_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR28_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR28_U_CXRH_NID264, REGION28_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR28_U_CXRH_NID264, REGION28_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR28_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR28_U_CXRH_NID264, 0x21d19d8)
    FIELD(POR_MPU_M2_PRLAR28_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR28_U_CXRH_NID264, REGION28_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR28_U_CXRH_NID264, REGION28_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR29_U_CXRH_NID264, 0x21d19e0)
    FIELD(POR_MPU_M2_PRBAR29_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR29_U_CXRH_NID264, REGION29_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR29_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR29_U_CXRH_NID264, REGION29_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR29_U_CXRH_NID264, REGION29_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR29_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR29_U_CXRH_NID264, 0x21d19e8)
    FIELD(POR_MPU_M2_PRLAR29_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR29_U_CXRH_NID264, REGION29_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR29_U_CXRH_NID264, REGION29_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR30_U_CXRH_NID264, 0x21d19f0)
    FIELD(POR_MPU_M2_PRBAR30_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR30_U_CXRH_NID264, REGION30_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR30_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR30_U_CXRH_NID264, REGION30_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR30_U_CXRH_NID264, REGION30_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR30_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR30_U_CXRH_NID264, 0x21d19f8)
    FIELD(POR_MPU_M2_PRLAR30_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR30_U_CXRH_NID264, REGION30_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR30_U_CXRH_NID264, REGION30_EN, 0, 1)
REG32(POR_MPU_M2_PRBAR31_U_CXRH_NID264, 0x21d1a00)
    FIELD(POR_MPU_M2_PRBAR31_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRBAR31_U_CXRH_NID264, REGION31_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRBAR31_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M2_PRBAR31_U_CXRH_NID264, REGION31_BR, 9, 1)
    FIELD(POR_MPU_M2_PRBAR31_U_CXRH_NID264, REGION31_AP, 2, 4)
    FIELD(POR_MPU_M2_PRBAR31_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M2_PRLAR31_U_CXRH_NID264, 0x21d1a08)
    FIELD(POR_MPU_M2_PRLAR31_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M2_PRLAR31_U_CXRH_NID264, REGION31_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M2_PRLAR31_U_CXRH_NID264, REGION31_EN, 0, 1)
REG32(POR_MPU_M3_CTL_U_CXRH_NID264, 0x21d1c00)
    FIELD(POR_MPU_M3_CTL_U_CXRH_NID264, M3_EN, 2, 1)
    FIELD(POR_MPU_M3_CTL_U_CXRH_NID264, M3_ACTION, 0, 2)
REG32(POR_MPU_M3_PRBAR0_U_CXRH_NID264, 0x21d1c10)
    FIELD(POR_MPU_M3_PRBAR0_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR0_U_CXRH_NID264, REGION0_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR0_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR0_U_CXRH_NID264, REGION0_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR0_U_CXRH_NID264, REGION0_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR0_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR0_U_CXRH_NID264, 0x21d1c18)
    FIELD(POR_MPU_M3_PRLAR0_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR0_U_CXRH_NID264, REGION0_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR0_U_CXRH_NID264, REGION0_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR1_U_CXRH_NID264, 0x21d1c20)
    FIELD(POR_MPU_M3_PRBAR1_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR1_U_CXRH_NID264, REGION1_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR1_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR1_U_CXRH_NID264, REGION1_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR1_U_CXRH_NID264, REGION1_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR1_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR1_U_CXRH_NID264, 0x21d1c28)
    FIELD(POR_MPU_M3_PRLAR1_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR1_U_CXRH_NID264, REGION1_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR1_U_CXRH_NID264, REGION1_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR2_U_CXRH_NID264, 0x21d1c30)
    FIELD(POR_MPU_M3_PRBAR2_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR2_U_CXRH_NID264, REGION2_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR2_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR2_U_CXRH_NID264, REGION2_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR2_U_CXRH_NID264, REGION2_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR2_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR2_U_CXRH_NID264, 0x21d1c38)
    FIELD(POR_MPU_M3_PRLAR2_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR2_U_CXRH_NID264, REGION2_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR2_U_CXRH_NID264, REGION2_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR3_U_CXRH_NID264, 0x21d1c40)
    FIELD(POR_MPU_M3_PRBAR3_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR3_U_CXRH_NID264, REGION3_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR3_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR3_U_CXRH_NID264, REGION3_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR3_U_CXRH_NID264, REGION3_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR3_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR3_U_CXRH_NID264, 0x21d1c48)
    FIELD(POR_MPU_M3_PRLAR3_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR3_U_CXRH_NID264, REGION3_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR3_U_CXRH_NID264, REGION3_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR4_U_CXRH_NID264, 0x21d1c50)
    FIELD(POR_MPU_M3_PRBAR4_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR4_U_CXRH_NID264, REGION4_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR4_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR4_U_CXRH_NID264, REGION4_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR4_U_CXRH_NID264, REGION4_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR4_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR4_U_CXRH_NID264, 0x21d1c58)
    FIELD(POR_MPU_M3_PRLAR4_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR4_U_CXRH_NID264, REGION4_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR4_U_CXRH_NID264, REGION4_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR5_U_CXRH_NID264, 0x21d1c60)
    FIELD(POR_MPU_M3_PRBAR5_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR5_U_CXRH_NID264, REGION5_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR5_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR5_U_CXRH_NID264, REGION5_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR5_U_CXRH_NID264, REGION5_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR5_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR5_U_CXRH_NID264, 0x21d1c68)
    FIELD(POR_MPU_M3_PRLAR5_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR5_U_CXRH_NID264, REGION5_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR5_U_CXRH_NID264, REGION5_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR6_U_CXRH_NID264, 0x21d1c70)
    FIELD(POR_MPU_M3_PRBAR6_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR6_U_CXRH_NID264, REGION6_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR6_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR6_U_CXRH_NID264, REGION6_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR6_U_CXRH_NID264, REGION6_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR6_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR6_U_CXRH_NID264, 0x21d1c78)
    FIELD(POR_MPU_M3_PRLAR6_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR6_U_CXRH_NID264, REGION6_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR6_U_CXRH_NID264, REGION6_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR7_U_CXRH_NID264, 0x21d1c80)
    FIELD(POR_MPU_M3_PRBAR7_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR7_U_CXRH_NID264, REGION7_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR7_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR7_U_CXRH_NID264, REGION7_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR7_U_CXRH_NID264, REGION7_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR7_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR7_U_CXRH_NID264, 0x21d1c88)
    FIELD(POR_MPU_M3_PRLAR7_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR7_U_CXRH_NID264, REGION7_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR7_U_CXRH_NID264, REGION7_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR8_U_CXRH_NID264, 0x21d1c90)
    FIELD(POR_MPU_M3_PRBAR8_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR8_U_CXRH_NID264, REGION8_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR8_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR8_U_CXRH_NID264, REGION8_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR8_U_CXRH_NID264, REGION8_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR8_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR8_U_CXRH_NID264, 0x21d1c98)
    FIELD(POR_MPU_M3_PRLAR8_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR8_U_CXRH_NID264, REGION8_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR8_U_CXRH_NID264, REGION8_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR9_U_CXRH_NID264, 0x21d1ca0)
    FIELD(POR_MPU_M3_PRBAR9_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR9_U_CXRH_NID264, REGION9_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR9_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR9_U_CXRH_NID264, REGION9_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR9_U_CXRH_NID264, REGION9_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR9_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR9_U_CXRH_NID264, 0x21d1ca8)
    FIELD(POR_MPU_M3_PRLAR9_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR9_U_CXRH_NID264, REGION9_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR9_U_CXRH_NID264, REGION9_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR10_U_CXRH_NID264, 0x21d1cb0)
    FIELD(POR_MPU_M3_PRBAR10_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR10_U_CXRH_NID264, REGION10_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR10_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR10_U_CXRH_NID264, REGION10_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR10_U_CXRH_NID264, REGION10_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR10_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR10_U_CXRH_NID264, 0x21d1cb8)
    FIELD(POR_MPU_M3_PRLAR10_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR10_U_CXRH_NID264, REGION10_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR10_U_CXRH_NID264, REGION10_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR11_U_CXRH_NID264, 0x21d1cc0)
    FIELD(POR_MPU_M3_PRBAR11_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR11_U_CXRH_NID264, REGION11_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR11_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR11_U_CXRH_NID264, REGION11_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR11_U_CXRH_NID264, REGION11_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR11_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR11_U_CXRH_NID264, 0x21d1cc8)
    FIELD(POR_MPU_M3_PRLAR11_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR11_U_CXRH_NID264, REGION11_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR11_U_CXRH_NID264, REGION11_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR12_U_CXRH_NID264, 0x21d1cd0)
    FIELD(POR_MPU_M3_PRBAR12_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR12_U_CXRH_NID264, REGION12_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR12_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR12_U_CXRH_NID264, REGION12_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR12_U_CXRH_NID264, REGION12_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR12_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR12_U_CXRH_NID264, 0x21d1cd8)
    FIELD(POR_MPU_M3_PRLAR12_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR12_U_CXRH_NID264, REGION12_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR12_U_CXRH_NID264, REGION12_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR13_U_CXRH_NID264, 0x21d1ce0)
    FIELD(POR_MPU_M3_PRBAR13_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR13_U_CXRH_NID264, REGION13_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR13_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR13_U_CXRH_NID264, REGION13_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR13_U_CXRH_NID264, REGION13_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR13_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR13_U_CXRH_NID264, 0x21d1ce8)
    FIELD(POR_MPU_M3_PRLAR13_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR13_U_CXRH_NID264, REGION13_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR13_U_CXRH_NID264, REGION13_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR14_U_CXRH_NID264, 0x21d1cf0)
    FIELD(POR_MPU_M3_PRBAR14_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR14_U_CXRH_NID264, REGION14_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR14_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR14_U_CXRH_NID264, REGION14_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR14_U_CXRH_NID264, REGION14_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR14_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR14_U_CXRH_NID264, 0x21d1cf8)
    FIELD(POR_MPU_M3_PRLAR14_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR14_U_CXRH_NID264, REGION14_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR14_U_CXRH_NID264, REGION14_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR15_U_CXRH_NID264, 0x21d1d00)
    FIELD(POR_MPU_M3_PRBAR15_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR15_U_CXRH_NID264, REGION15_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR15_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR15_U_CXRH_NID264, REGION15_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR15_U_CXRH_NID264, REGION15_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR15_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR15_U_CXRH_NID264, 0x21d1d08)
    FIELD(POR_MPU_M3_PRLAR15_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR15_U_CXRH_NID264, REGION15_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR15_U_CXRH_NID264, REGION15_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR16_U_CXRH_NID264, 0x21d1d10)
    FIELD(POR_MPU_M3_PRBAR16_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR16_U_CXRH_NID264, REGION16_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR16_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR16_U_CXRH_NID264, REGION16_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR16_U_CXRH_NID264, REGION16_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR16_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR16_U_CXRH_NID264, 0x21d1d18)
    FIELD(POR_MPU_M3_PRLAR16_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR16_U_CXRH_NID264, REGION16_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR16_U_CXRH_NID264, REGION16_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR17_U_CXRH_NID264, 0x21d1d20)
    FIELD(POR_MPU_M3_PRBAR17_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR17_U_CXRH_NID264, REGION17_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR17_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR17_U_CXRH_NID264, REGION17_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR17_U_CXRH_NID264, REGION17_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR17_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR17_U_CXRH_NID264, 0x21d1d28)
    FIELD(POR_MPU_M3_PRLAR17_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR17_U_CXRH_NID264, REGION17_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR17_U_CXRH_NID264, REGION17_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR18_U_CXRH_NID264, 0x21d1d30)
    FIELD(POR_MPU_M3_PRBAR18_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR18_U_CXRH_NID264, REGION18_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR18_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR18_U_CXRH_NID264, REGION18_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR18_U_CXRH_NID264, REGION18_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR18_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR18_U_CXRH_NID264, 0x21d1d38)
    FIELD(POR_MPU_M3_PRLAR18_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR18_U_CXRH_NID264, REGION18_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR18_U_CXRH_NID264, REGION18_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR19_U_CXRH_NID264, 0x21d1d40)
    FIELD(POR_MPU_M3_PRBAR19_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR19_U_CXRH_NID264, REGION19_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR19_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR19_U_CXRH_NID264, REGION19_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR19_U_CXRH_NID264, REGION19_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR19_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR19_U_CXRH_NID264, 0x21d1d48)
    FIELD(POR_MPU_M3_PRLAR19_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR19_U_CXRH_NID264, REGION19_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR19_U_CXRH_NID264, REGION19_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR20_U_CXRH_NID264, 0x21d1d50)
    FIELD(POR_MPU_M3_PRBAR20_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR20_U_CXRH_NID264, REGION20_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR20_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR20_U_CXRH_NID264, REGION20_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR20_U_CXRH_NID264, REGION20_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR20_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR20_U_CXRH_NID264, 0x21d1d58)
    FIELD(POR_MPU_M3_PRLAR20_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR20_U_CXRH_NID264, REGION20_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR20_U_CXRH_NID264, REGION20_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR21_U_CXRH_NID264, 0x21d1d60)
    FIELD(POR_MPU_M3_PRBAR21_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR21_U_CXRH_NID264, REGION21_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR21_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR21_U_CXRH_NID264, REGION21_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR21_U_CXRH_NID264, REGION21_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR21_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR21_U_CXRH_NID264, 0x21d1d68)
    FIELD(POR_MPU_M3_PRLAR21_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR21_U_CXRH_NID264, REGION21_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR21_U_CXRH_NID264, REGION21_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR22_U_CXRH_NID264, 0x21d1d70)
    FIELD(POR_MPU_M3_PRBAR22_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR22_U_CXRH_NID264, REGION22_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR22_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR22_U_CXRH_NID264, REGION22_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR22_U_CXRH_NID264, REGION22_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR22_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR22_U_CXRH_NID264, 0x21d1d78)
    FIELD(POR_MPU_M3_PRLAR22_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR22_U_CXRH_NID264, REGION22_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR22_U_CXRH_NID264, REGION22_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR23_U_CXRH_NID264, 0x21d1d80)
    FIELD(POR_MPU_M3_PRBAR23_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR23_U_CXRH_NID264, REGION23_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR23_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR23_U_CXRH_NID264, REGION23_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR23_U_CXRH_NID264, REGION23_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR23_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR23_U_CXRH_NID264, 0x21d1d88)
    FIELD(POR_MPU_M3_PRLAR23_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR23_U_CXRH_NID264, REGION23_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR23_U_CXRH_NID264, REGION23_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR24_U_CXRH_NID264, 0x21d1d90)
    FIELD(POR_MPU_M3_PRBAR24_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR24_U_CXRH_NID264, REGION24_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR24_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR24_U_CXRH_NID264, REGION24_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR24_U_CXRH_NID264, REGION24_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR24_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR24_U_CXRH_NID264, 0x21d1d98)
    FIELD(POR_MPU_M3_PRLAR24_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR24_U_CXRH_NID264, REGION24_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR24_U_CXRH_NID264, REGION24_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR25_U_CXRH_NID264, 0x21d1da0)
    FIELD(POR_MPU_M3_PRBAR25_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR25_U_CXRH_NID264, REGION25_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR25_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR25_U_CXRH_NID264, REGION25_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR25_U_CXRH_NID264, REGION25_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR25_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR25_U_CXRH_NID264, 0x21d1da8)
    FIELD(POR_MPU_M3_PRLAR25_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR25_U_CXRH_NID264, REGION25_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR25_U_CXRH_NID264, REGION25_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR26_U_CXRH_NID264, 0x21d1db0)
    FIELD(POR_MPU_M3_PRBAR26_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR26_U_CXRH_NID264, REGION26_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR26_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR26_U_CXRH_NID264, REGION26_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR26_U_CXRH_NID264, REGION26_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR26_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR26_U_CXRH_NID264, 0x21d1db8)
    FIELD(POR_MPU_M3_PRLAR26_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR26_U_CXRH_NID264, REGION26_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR26_U_CXRH_NID264, REGION26_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR27_U_CXRH_NID264, 0x21d1dc0)
    FIELD(POR_MPU_M3_PRBAR27_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR27_U_CXRH_NID264, REGION27_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR27_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR27_U_CXRH_NID264, REGION27_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR27_U_CXRH_NID264, REGION27_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR27_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR27_U_CXRH_NID264, 0x21d1dc8)
    FIELD(POR_MPU_M3_PRLAR27_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR27_U_CXRH_NID264, REGION27_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR27_U_CXRH_NID264, REGION27_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR28_U_CXRH_NID264, 0x21d1dd0)
    FIELD(POR_MPU_M3_PRBAR28_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR28_U_CXRH_NID264, REGION28_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR28_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR28_U_CXRH_NID264, REGION28_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR28_U_CXRH_NID264, REGION28_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR28_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR28_U_CXRH_NID264, 0x21d1dd8)
    FIELD(POR_MPU_M3_PRLAR28_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR28_U_CXRH_NID264, REGION28_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR28_U_CXRH_NID264, REGION28_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR29_U_CXRH_NID264, 0x21d1de0)
    FIELD(POR_MPU_M3_PRBAR29_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR29_U_CXRH_NID264, REGION29_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR29_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR29_U_CXRH_NID264, REGION29_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR29_U_CXRH_NID264, REGION29_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR29_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR29_U_CXRH_NID264, 0x21d1de8)
    FIELD(POR_MPU_M3_PRLAR29_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR29_U_CXRH_NID264, REGION29_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR29_U_CXRH_NID264, REGION29_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR30_U_CXRH_NID264, 0x21d1df0)
    FIELD(POR_MPU_M3_PRBAR30_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR30_U_CXRH_NID264, REGION30_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR30_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR30_U_CXRH_NID264, REGION30_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR30_U_CXRH_NID264, REGION30_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR30_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR30_U_CXRH_NID264, 0x21d1df8)
    FIELD(POR_MPU_M3_PRLAR30_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR30_U_CXRH_NID264, REGION30_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR30_U_CXRH_NID264, REGION30_EN, 0, 1)
REG32(POR_MPU_M3_PRBAR31_U_CXRH_NID264, 0x21d1e00)
    FIELD(POR_MPU_M3_PRBAR31_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRBAR31_U_CXRH_NID264, REGION31_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRBAR31_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M3_PRBAR31_U_CXRH_NID264, REGION31_BR, 9, 1)
    FIELD(POR_MPU_M3_PRBAR31_U_CXRH_NID264, REGION31_AP, 2, 4)
    FIELD(POR_MPU_M3_PRBAR31_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M3_PRLAR31_U_CXRH_NID264, 0x21d1e08)
    FIELD(POR_MPU_M3_PRLAR31_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M3_PRLAR31_U_CXRH_NID264, REGION31_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M3_PRLAR31_U_CXRH_NID264, REGION31_EN, 0, 1)
REG32(POR_MPU_M4_CTL_U_CXRH_NID264, 0x21d2000)
    FIELD(POR_MPU_M4_CTL_U_CXRH_NID264, M4_EN, 2, 1)
    FIELD(POR_MPU_M4_CTL_U_CXRH_NID264, M4_ACTION, 0, 2)
REG32(POR_MPU_M4_PRBAR0_U_CXRH_NID264, 0x21d2010)
    FIELD(POR_MPU_M4_PRBAR0_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR0_U_CXRH_NID264, REGION0_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR0_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR0_U_CXRH_NID264, REGION0_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR0_U_CXRH_NID264, REGION0_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR0_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR0_U_CXRH_NID264, 0x21d2018)
    FIELD(POR_MPU_M4_PRLAR0_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR0_U_CXRH_NID264, REGION0_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR0_U_CXRH_NID264, REGION0_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR1_U_CXRH_NID264, 0x21d2020)
    FIELD(POR_MPU_M4_PRBAR1_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR1_U_CXRH_NID264, REGION1_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR1_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR1_U_CXRH_NID264, REGION1_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR1_U_CXRH_NID264, REGION1_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR1_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR1_U_CXRH_NID264, 0x21d2028)
    FIELD(POR_MPU_M4_PRLAR1_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR1_U_CXRH_NID264, REGION1_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR1_U_CXRH_NID264, REGION1_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR2_U_CXRH_NID264, 0x21d2030)
    FIELD(POR_MPU_M4_PRBAR2_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR2_U_CXRH_NID264, REGION2_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR2_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR2_U_CXRH_NID264, REGION2_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR2_U_CXRH_NID264, REGION2_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR2_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR2_U_CXRH_NID264, 0x21d2038)
    FIELD(POR_MPU_M4_PRLAR2_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR2_U_CXRH_NID264, REGION2_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR2_U_CXRH_NID264, REGION2_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR3_U_CXRH_NID264, 0x21d2040)
    FIELD(POR_MPU_M4_PRBAR3_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR3_U_CXRH_NID264, REGION3_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR3_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR3_U_CXRH_NID264, REGION3_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR3_U_CXRH_NID264, REGION3_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR3_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR3_U_CXRH_NID264, 0x21d2048)
    FIELD(POR_MPU_M4_PRLAR3_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR3_U_CXRH_NID264, REGION3_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR3_U_CXRH_NID264, REGION3_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR4_U_CXRH_NID264, 0x21d2050)
    FIELD(POR_MPU_M4_PRBAR4_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR4_U_CXRH_NID264, REGION4_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR4_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR4_U_CXRH_NID264, REGION4_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR4_U_CXRH_NID264, REGION4_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR4_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR4_U_CXRH_NID264, 0x21d2058)
    FIELD(POR_MPU_M4_PRLAR4_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR4_U_CXRH_NID264, REGION4_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR4_U_CXRH_NID264, REGION4_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR5_U_CXRH_NID264, 0x21d2060)
    FIELD(POR_MPU_M4_PRBAR5_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR5_U_CXRH_NID264, REGION5_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR5_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR5_U_CXRH_NID264, REGION5_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR5_U_CXRH_NID264, REGION5_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR5_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR5_U_CXRH_NID264, 0x21d2068)
    FIELD(POR_MPU_M4_PRLAR5_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR5_U_CXRH_NID264, REGION5_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR5_U_CXRH_NID264, REGION5_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR6_U_CXRH_NID264, 0x21d2070)
    FIELD(POR_MPU_M4_PRBAR6_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR6_U_CXRH_NID264, REGION6_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR6_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR6_U_CXRH_NID264, REGION6_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR6_U_CXRH_NID264, REGION6_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR6_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR6_U_CXRH_NID264, 0x21d2078)
    FIELD(POR_MPU_M4_PRLAR6_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR6_U_CXRH_NID264, REGION6_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR6_U_CXRH_NID264, REGION6_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR7_U_CXRH_NID264, 0x21d2080)
    FIELD(POR_MPU_M4_PRBAR7_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR7_U_CXRH_NID264, REGION7_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR7_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR7_U_CXRH_NID264, REGION7_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR7_U_CXRH_NID264, REGION7_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR7_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR7_U_CXRH_NID264, 0x21d2088)
    FIELD(POR_MPU_M4_PRLAR7_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR7_U_CXRH_NID264, REGION7_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR7_U_CXRH_NID264, REGION7_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR8_U_CXRH_NID264, 0x21d2090)
    FIELD(POR_MPU_M4_PRBAR8_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR8_U_CXRH_NID264, REGION8_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR8_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR8_U_CXRH_NID264, REGION8_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR8_U_CXRH_NID264, REGION8_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR8_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR8_U_CXRH_NID264, 0x21d2098)
    FIELD(POR_MPU_M4_PRLAR8_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR8_U_CXRH_NID264, REGION8_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR8_U_CXRH_NID264, REGION8_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR9_U_CXRH_NID264, 0x21d20a0)
    FIELD(POR_MPU_M4_PRBAR9_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR9_U_CXRH_NID264, REGION9_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR9_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR9_U_CXRH_NID264, REGION9_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR9_U_CXRH_NID264, REGION9_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR9_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR9_U_CXRH_NID264, 0x21d20a8)
    FIELD(POR_MPU_M4_PRLAR9_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR9_U_CXRH_NID264, REGION9_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR9_U_CXRH_NID264, REGION9_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR10_U_CXRH_NID264, 0x21d20b0)
    FIELD(POR_MPU_M4_PRBAR10_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR10_U_CXRH_NID264, REGION10_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR10_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR10_U_CXRH_NID264, REGION10_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR10_U_CXRH_NID264, REGION10_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR10_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR10_U_CXRH_NID264, 0x21d20b8)
    FIELD(POR_MPU_M4_PRLAR10_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR10_U_CXRH_NID264, REGION10_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR10_U_CXRH_NID264, REGION10_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR11_U_CXRH_NID264, 0x21d20c0)
    FIELD(POR_MPU_M4_PRBAR11_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR11_U_CXRH_NID264, REGION11_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR11_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR11_U_CXRH_NID264, REGION11_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR11_U_CXRH_NID264, REGION11_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR11_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR11_U_CXRH_NID264, 0x21d20c8)
    FIELD(POR_MPU_M4_PRLAR11_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR11_U_CXRH_NID264, REGION11_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR11_U_CXRH_NID264, REGION11_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR12_U_CXRH_NID264, 0x21d20d0)
    FIELD(POR_MPU_M4_PRBAR12_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR12_U_CXRH_NID264, REGION12_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR12_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR12_U_CXRH_NID264, REGION12_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR12_U_CXRH_NID264, REGION12_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR12_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR12_U_CXRH_NID264, 0x21d20d8)
    FIELD(POR_MPU_M4_PRLAR12_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR12_U_CXRH_NID264, REGION12_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR12_U_CXRH_NID264, REGION12_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR13_U_CXRH_NID264, 0x21d20e0)
    FIELD(POR_MPU_M4_PRBAR13_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR13_U_CXRH_NID264, REGION13_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR13_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR13_U_CXRH_NID264, REGION13_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR13_U_CXRH_NID264, REGION13_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR13_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR13_U_CXRH_NID264, 0x21d20e8)
    FIELD(POR_MPU_M4_PRLAR13_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR13_U_CXRH_NID264, REGION13_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR13_U_CXRH_NID264, REGION13_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR14_U_CXRH_NID264, 0x21d20f0)
    FIELD(POR_MPU_M4_PRBAR14_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR14_U_CXRH_NID264, REGION14_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR14_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR14_U_CXRH_NID264, REGION14_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR14_U_CXRH_NID264, REGION14_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR14_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR14_U_CXRH_NID264, 0x21d20f8)
    FIELD(POR_MPU_M4_PRLAR14_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR14_U_CXRH_NID264, REGION14_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR14_U_CXRH_NID264, REGION14_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR15_U_CXRH_NID264, 0x21d2100)
    FIELD(POR_MPU_M4_PRBAR15_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR15_U_CXRH_NID264, REGION15_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR15_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR15_U_CXRH_NID264, REGION15_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR15_U_CXRH_NID264, REGION15_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR15_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR15_U_CXRH_NID264, 0x21d2108)
    FIELD(POR_MPU_M4_PRLAR15_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR15_U_CXRH_NID264, REGION15_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR15_U_CXRH_NID264, REGION15_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR16_U_CXRH_NID264, 0x21d2110)
    FIELD(POR_MPU_M4_PRBAR16_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR16_U_CXRH_NID264, REGION16_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR16_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR16_U_CXRH_NID264, REGION16_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR16_U_CXRH_NID264, REGION16_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR16_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR16_U_CXRH_NID264, 0x21d2118)
    FIELD(POR_MPU_M4_PRLAR16_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR16_U_CXRH_NID264, REGION16_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR16_U_CXRH_NID264, REGION16_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR17_U_CXRH_NID264, 0x21d2120)
    FIELD(POR_MPU_M4_PRBAR17_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR17_U_CXRH_NID264, REGION17_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR17_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR17_U_CXRH_NID264, REGION17_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR17_U_CXRH_NID264, REGION17_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR17_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR17_U_CXRH_NID264, 0x21d2128)
    FIELD(POR_MPU_M4_PRLAR17_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR17_U_CXRH_NID264, REGION17_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR17_U_CXRH_NID264, REGION17_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR18_U_CXRH_NID264, 0x21d2130)
    FIELD(POR_MPU_M4_PRBAR18_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR18_U_CXRH_NID264, REGION18_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR18_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR18_U_CXRH_NID264, REGION18_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR18_U_CXRH_NID264, REGION18_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR18_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR18_U_CXRH_NID264, 0x21d2138)
    FIELD(POR_MPU_M4_PRLAR18_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR18_U_CXRH_NID264, REGION18_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR18_U_CXRH_NID264, REGION18_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR19_U_CXRH_NID264, 0x21d2140)
    FIELD(POR_MPU_M4_PRBAR19_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR19_U_CXRH_NID264, REGION19_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR19_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR19_U_CXRH_NID264, REGION19_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR19_U_CXRH_NID264, REGION19_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR19_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR19_U_CXRH_NID264, 0x21d2148)
    FIELD(POR_MPU_M4_PRLAR19_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR19_U_CXRH_NID264, REGION19_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR19_U_CXRH_NID264, REGION19_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR20_U_CXRH_NID264, 0x21d2150)
    FIELD(POR_MPU_M4_PRBAR20_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR20_U_CXRH_NID264, REGION20_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR20_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR20_U_CXRH_NID264, REGION20_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR20_U_CXRH_NID264, REGION20_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR20_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR20_U_CXRH_NID264, 0x21d2158)
    FIELD(POR_MPU_M4_PRLAR20_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR20_U_CXRH_NID264, REGION20_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR20_U_CXRH_NID264, REGION20_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR21_U_CXRH_NID264, 0x21d2160)
    FIELD(POR_MPU_M4_PRBAR21_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR21_U_CXRH_NID264, REGION21_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR21_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR21_U_CXRH_NID264, REGION21_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR21_U_CXRH_NID264, REGION21_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR21_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR21_U_CXRH_NID264, 0x21d2168)
    FIELD(POR_MPU_M4_PRLAR21_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR21_U_CXRH_NID264, REGION21_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR21_U_CXRH_NID264, REGION21_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR22_U_CXRH_NID264, 0x21d2170)
    FIELD(POR_MPU_M4_PRBAR22_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR22_U_CXRH_NID264, REGION22_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR22_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR22_U_CXRH_NID264, REGION22_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR22_U_CXRH_NID264, REGION22_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR22_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR22_U_CXRH_NID264, 0x21d2178)
    FIELD(POR_MPU_M4_PRLAR22_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR22_U_CXRH_NID264, REGION22_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR22_U_CXRH_NID264, REGION22_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR23_U_CXRH_NID264, 0x21d2180)
    FIELD(POR_MPU_M4_PRBAR23_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR23_U_CXRH_NID264, REGION23_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR23_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR23_U_CXRH_NID264, REGION23_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR23_U_CXRH_NID264, REGION23_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR23_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR23_U_CXRH_NID264, 0x21d2188)
    FIELD(POR_MPU_M4_PRLAR23_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR23_U_CXRH_NID264, REGION23_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR23_U_CXRH_NID264, REGION23_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR24_U_CXRH_NID264, 0x21d2190)
    FIELD(POR_MPU_M4_PRBAR24_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR24_U_CXRH_NID264, REGION24_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR24_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR24_U_CXRH_NID264, REGION24_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR24_U_CXRH_NID264, REGION24_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR24_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR24_U_CXRH_NID264, 0x21d2198)
    FIELD(POR_MPU_M4_PRLAR24_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR24_U_CXRH_NID264, REGION24_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR24_U_CXRH_NID264, REGION24_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR25_U_CXRH_NID264, 0x21d21a0)
    FIELD(POR_MPU_M4_PRBAR25_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR25_U_CXRH_NID264, REGION25_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR25_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR25_U_CXRH_NID264, REGION25_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR25_U_CXRH_NID264, REGION25_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR25_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR25_U_CXRH_NID264, 0x21d21a8)
    FIELD(POR_MPU_M4_PRLAR25_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR25_U_CXRH_NID264, REGION25_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR25_U_CXRH_NID264, REGION25_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR26_U_CXRH_NID264, 0x21d21b0)
    FIELD(POR_MPU_M4_PRBAR26_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR26_U_CXRH_NID264, REGION26_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR26_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR26_U_CXRH_NID264, REGION26_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR26_U_CXRH_NID264, REGION26_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR26_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR26_U_CXRH_NID264, 0x21d21b8)
    FIELD(POR_MPU_M4_PRLAR26_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR26_U_CXRH_NID264, REGION26_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR26_U_CXRH_NID264, REGION26_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR27_U_CXRH_NID264, 0x21d21c0)
    FIELD(POR_MPU_M4_PRBAR27_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR27_U_CXRH_NID264, REGION27_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR27_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR27_U_CXRH_NID264, REGION27_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR27_U_CXRH_NID264, REGION27_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR27_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR27_U_CXRH_NID264, 0x21d21c8)
    FIELD(POR_MPU_M4_PRLAR27_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR27_U_CXRH_NID264, REGION27_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR27_U_CXRH_NID264, REGION27_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR28_U_CXRH_NID264, 0x21d21d0)
    FIELD(POR_MPU_M4_PRBAR28_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR28_U_CXRH_NID264, REGION28_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR28_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR28_U_CXRH_NID264, REGION28_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR28_U_CXRH_NID264, REGION28_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR28_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR28_U_CXRH_NID264, 0x21d21d8)
    FIELD(POR_MPU_M4_PRLAR28_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR28_U_CXRH_NID264, REGION28_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR28_U_CXRH_NID264, REGION28_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR29_U_CXRH_NID264, 0x21d21e0)
    FIELD(POR_MPU_M4_PRBAR29_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR29_U_CXRH_NID264, REGION29_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR29_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR29_U_CXRH_NID264, REGION29_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR29_U_CXRH_NID264, REGION29_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR29_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR29_U_CXRH_NID264, 0x21d21e8)
    FIELD(POR_MPU_M4_PRLAR29_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR29_U_CXRH_NID264, REGION29_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR29_U_CXRH_NID264, REGION29_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR30_U_CXRH_NID264, 0x21d21f0)
    FIELD(POR_MPU_M4_PRBAR30_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR30_U_CXRH_NID264, REGION30_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR30_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR30_U_CXRH_NID264, REGION30_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR30_U_CXRH_NID264, REGION30_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR30_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR30_U_CXRH_NID264, 0x21d21f8)
    FIELD(POR_MPU_M4_PRLAR30_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR30_U_CXRH_NID264, REGION30_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR30_U_CXRH_NID264, REGION30_EN, 0, 1)
REG32(POR_MPU_M4_PRBAR31_U_CXRH_NID264, 0x21d2200)
    FIELD(POR_MPU_M4_PRBAR31_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRBAR31_U_CXRH_NID264, REGION31_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRBAR31_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M4_PRBAR31_U_CXRH_NID264, REGION31_BR, 9, 1)
    FIELD(POR_MPU_M4_PRBAR31_U_CXRH_NID264, REGION31_AP, 2, 4)
    FIELD(POR_MPU_M4_PRBAR31_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M4_PRLAR31_U_CXRH_NID264, 0x21d2208)
    FIELD(POR_MPU_M4_PRLAR31_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M4_PRLAR31_U_CXRH_NID264, REGION31_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M4_PRLAR31_U_CXRH_NID264, REGION31_EN, 0, 1)
REG32(POR_MPU_M5_CTL_U_CXRH_NID264, 0x21d2400)
    FIELD(POR_MPU_M5_CTL_U_CXRH_NID264, M5_EN, 2, 1)
    FIELD(POR_MPU_M5_CTL_U_CXRH_NID264, M5_ACTION, 0, 2)
REG32(POR_MPU_M5_PRBAR0_U_CXRH_NID264, 0x21d2410)
    FIELD(POR_MPU_M5_PRBAR0_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR0_U_CXRH_NID264, REGION0_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR0_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR0_U_CXRH_NID264, REGION0_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR0_U_CXRH_NID264, REGION0_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR0_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR0_U_CXRH_NID264, 0x21d2418)
    FIELD(POR_MPU_M5_PRLAR0_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR0_U_CXRH_NID264, REGION0_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR0_U_CXRH_NID264, REGION0_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR1_U_CXRH_NID264, 0x21d2420)
    FIELD(POR_MPU_M5_PRBAR1_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR1_U_CXRH_NID264, REGION1_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR1_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR1_U_CXRH_NID264, REGION1_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR1_U_CXRH_NID264, REGION1_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR1_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR1_U_CXRH_NID264, 0x21d2428)
    FIELD(POR_MPU_M5_PRLAR1_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR1_U_CXRH_NID264, REGION1_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR1_U_CXRH_NID264, REGION1_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR2_U_CXRH_NID264, 0x21d2430)
    FIELD(POR_MPU_M5_PRBAR2_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR2_U_CXRH_NID264, REGION2_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR2_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR2_U_CXRH_NID264, REGION2_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR2_U_CXRH_NID264, REGION2_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR2_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR2_U_CXRH_NID264, 0x21d2438)
    FIELD(POR_MPU_M5_PRLAR2_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR2_U_CXRH_NID264, REGION2_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR2_U_CXRH_NID264, REGION2_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR3_U_CXRH_NID264, 0x21d2440)
    FIELD(POR_MPU_M5_PRBAR3_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR3_U_CXRH_NID264, REGION3_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR3_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR3_U_CXRH_NID264, REGION3_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR3_U_CXRH_NID264, REGION3_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR3_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR3_U_CXRH_NID264, 0x21d2448)
    FIELD(POR_MPU_M5_PRLAR3_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR3_U_CXRH_NID264, REGION3_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR3_U_CXRH_NID264, REGION3_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR4_U_CXRH_NID264, 0x21d2450)
    FIELD(POR_MPU_M5_PRBAR4_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR4_U_CXRH_NID264, REGION4_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR4_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR4_U_CXRH_NID264, REGION4_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR4_U_CXRH_NID264, REGION4_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR4_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR4_U_CXRH_NID264, 0x21d2458)
    FIELD(POR_MPU_M5_PRLAR4_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR4_U_CXRH_NID264, REGION4_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR4_U_CXRH_NID264, REGION4_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR5_U_CXRH_NID264, 0x21d2460)
    FIELD(POR_MPU_M5_PRBAR5_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR5_U_CXRH_NID264, REGION5_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR5_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR5_U_CXRH_NID264, REGION5_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR5_U_CXRH_NID264, REGION5_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR5_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR5_U_CXRH_NID264, 0x21d2468)
    FIELD(POR_MPU_M5_PRLAR5_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR5_U_CXRH_NID264, REGION5_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR5_U_CXRH_NID264, REGION5_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR6_U_CXRH_NID264, 0x21d2470)
    FIELD(POR_MPU_M5_PRBAR6_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR6_U_CXRH_NID264, REGION6_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR6_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR6_U_CXRH_NID264, REGION6_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR6_U_CXRH_NID264, REGION6_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR6_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR6_U_CXRH_NID264, 0x21d2478)
    FIELD(POR_MPU_M5_PRLAR6_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR6_U_CXRH_NID264, REGION6_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR6_U_CXRH_NID264, REGION6_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR7_U_CXRH_NID264, 0x21d2480)
    FIELD(POR_MPU_M5_PRBAR7_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR7_U_CXRH_NID264, REGION7_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR7_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR7_U_CXRH_NID264, REGION7_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR7_U_CXRH_NID264, REGION7_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR7_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR7_U_CXRH_NID264, 0x21d2488)
    FIELD(POR_MPU_M5_PRLAR7_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR7_U_CXRH_NID264, REGION7_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR7_U_CXRH_NID264, REGION7_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR8_U_CXRH_NID264, 0x21d2490)
    FIELD(POR_MPU_M5_PRBAR8_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR8_U_CXRH_NID264, REGION8_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR8_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR8_U_CXRH_NID264, REGION8_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR8_U_CXRH_NID264, REGION8_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR8_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR8_U_CXRH_NID264, 0x21d2498)
    FIELD(POR_MPU_M5_PRLAR8_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR8_U_CXRH_NID264, REGION8_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR8_U_CXRH_NID264, REGION8_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR9_U_CXRH_NID264, 0x21d24a0)
    FIELD(POR_MPU_M5_PRBAR9_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR9_U_CXRH_NID264, REGION9_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR9_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR9_U_CXRH_NID264, REGION9_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR9_U_CXRH_NID264, REGION9_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR9_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR9_U_CXRH_NID264, 0x21d24a8)
    FIELD(POR_MPU_M5_PRLAR9_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR9_U_CXRH_NID264, REGION9_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR9_U_CXRH_NID264, REGION9_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR10_U_CXRH_NID264, 0x21d24b0)
    FIELD(POR_MPU_M5_PRBAR10_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR10_U_CXRH_NID264, REGION10_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR10_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR10_U_CXRH_NID264, REGION10_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR10_U_CXRH_NID264, REGION10_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR10_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR10_U_CXRH_NID264, 0x21d24b8)
    FIELD(POR_MPU_M5_PRLAR10_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR10_U_CXRH_NID264, REGION10_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR10_U_CXRH_NID264, REGION10_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR11_U_CXRH_NID264, 0x21d24c0)
    FIELD(POR_MPU_M5_PRBAR11_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR11_U_CXRH_NID264, REGION11_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR11_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR11_U_CXRH_NID264, REGION11_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR11_U_CXRH_NID264, REGION11_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR11_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR11_U_CXRH_NID264, 0x21d24c8)
    FIELD(POR_MPU_M5_PRLAR11_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR11_U_CXRH_NID264, REGION11_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR11_U_CXRH_NID264, REGION11_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR12_U_CXRH_NID264, 0x21d24d0)
    FIELD(POR_MPU_M5_PRBAR12_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR12_U_CXRH_NID264, REGION12_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR12_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR12_U_CXRH_NID264, REGION12_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR12_U_CXRH_NID264, REGION12_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR12_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR12_U_CXRH_NID264, 0x21d24d8)
    FIELD(POR_MPU_M5_PRLAR12_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR12_U_CXRH_NID264, REGION12_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR12_U_CXRH_NID264, REGION12_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR13_U_CXRH_NID264, 0x21d24e0)
    FIELD(POR_MPU_M5_PRBAR13_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR13_U_CXRH_NID264, REGION13_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR13_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR13_U_CXRH_NID264, REGION13_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR13_U_CXRH_NID264, REGION13_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR13_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR13_U_CXRH_NID264, 0x21d24e8)
    FIELD(POR_MPU_M5_PRLAR13_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR13_U_CXRH_NID264, REGION13_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR13_U_CXRH_NID264, REGION13_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR14_U_CXRH_NID264, 0x21d24f0)
    FIELD(POR_MPU_M5_PRBAR14_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR14_U_CXRH_NID264, REGION14_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR14_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR14_U_CXRH_NID264, REGION14_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR14_U_CXRH_NID264, REGION14_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR14_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR14_U_CXRH_NID264, 0x21d24f8)
    FIELD(POR_MPU_M5_PRLAR14_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR14_U_CXRH_NID264, REGION14_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR14_U_CXRH_NID264, REGION14_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR15_U_CXRH_NID264, 0x21d2500)
    FIELD(POR_MPU_M5_PRBAR15_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR15_U_CXRH_NID264, REGION15_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR15_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR15_U_CXRH_NID264, REGION15_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR15_U_CXRH_NID264, REGION15_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR15_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR15_U_CXRH_NID264, 0x21d2508)
    FIELD(POR_MPU_M5_PRLAR15_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR15_U_CXRH_NID264, REGION15_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR15_U_CXRH_NID264, REGION15_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR16_U_CXRH_NID264, 0x21d2510)
    FIELD(POR_MPU_M5_PRBAR16_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR16_U_CXRH_NID264, REGION16_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR16_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR16_U_CXRH_NID264, REGION16_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR16_U_CXRH_NID264, REGION16_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR16_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR16_U_CXRH_NID264, 0x21d2518)
    FIELD(POR_MPU_M5_PRLAR16_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR16_U_CXRH_NID264, REGION16_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR16_U_CXRH_NID264, REGION16_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR17_U_CXRH_NID264, 0x21d2520)
    FIELD(POR_MPU_M5_PRBAR17_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR17_U_CXRH_NID264, REGION17_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR17_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR17_U_CXRH_NID264, REGION17_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR17_U_CXRH_NID264, REGION17_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR17_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR17_U_CXRH_NID264, 0x21d2528)
    FIELD(POR_MPU_M5_PRLAR17_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR17_U_CXRH_NID264, REGION17_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR17_U_CXRH_NID264, REGION17_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR18_U_CXRH_NID264, 0x21d2530)
    FIELD(POR_MPU_M5_PRBAR18_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR18_U_CXRH_NID264, REGION18_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR18_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR18_U_CXRH_NID264, REGION18_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR18_U_CXRH_NID264, REGION18_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR18_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR18_U_CXRH_NID264, 0x21d2538)
    FIELD(POR_MPU_M5_PRLAR18_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR18_U_CXRH_NID264, REGION18_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR18_U_CXRH_NID264, REGION18_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR19_U_CXRH_NID264, 0x21d2540)
    FIELD(POR_MPU_M5_PRBAR19_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR19_U_CXRH_NID264, REGION19_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR19_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR19_U_CXRH_NID264, REGION19_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR19_U_CXRH_NID264, REGION19_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR19_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR19_U_CXRH_NID264, 0x21d2548)
    FIELD(POR_MPU_M5_PRLAR19_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR19_U_CXRH_NID264, REGION19_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR19_U_CXRH_NID264, REGION19_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR20_U_CXRH_NID264, 0x21d2550)
    FIELD(POR_MPU_M5_PRBAR20_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR20_U_CXRH_NID264, REGION20_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR20_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR20_U_CXRH_NID264, REGION20_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR20_U_CXRH_NID264, REGION20_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR20_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR20_U_CXRH_NID264, 0x21d2558)
    FIELD(POR_MPU_M5_PRLAR20_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR20_U_CXRH_NID264, REGION20_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR20_U_CXRH_NID264, REGION20_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR21_U_CXRH_NID264, 0x21d2560)
    FIELD(POR_MPU_M5_PRBAR21_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR21_U_CXRH_NID264, REGION21_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR21_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR21_U_CXRH_NID264, REGION21_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR21_U_CXRH_NID264, REGION21_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR21_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR21_U_CXRH_NID264, 0x21d2568)
    FIELD(POR_MPU_M5_PRLAR21_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR21_U_CXRH_NID264, REGION21_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR21_U_CXRH_NID264, REGION21_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR22_U_CXRH_NID264, 0x21d2570)
    FIELD(POR_MPU_M5_PRBAR22_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR22_U_CXRH_NID264, REGION22_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR22_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR22_U_CXRH_NID264, REGION22_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR22_U_CXRH_NID264, REGION22_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR22_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR22_U_CXRH_NID264, 0x21d2578)
    FIELD(POR_MPU_M5_PRLAR22_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR22_U_CXRH_NID264, REGION22_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR22_U_CXRH_NID264, REGION22_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR23_U_CXRH_NID264, 0x21d2580)
    FIELD(POR_MPU_M5_PRBAR23_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR23_U_CXRH_NID264, REGION23_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR23_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR23_U_CXRH_NID264, REGION23_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR23_U_CXRH_NID264, REGION23_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR23_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR23_U_CXRH_NID264, 0x21d2588)
    FIELD(POR_MPU_M5_PRLAR23_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR23_U_CXRH_NID264, REGION23_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR23_U_CXRH_NID264, REGION23_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR24_U_CXRH_NID264, 0x21d2590)
    FIELD(POR_MPU_M5_PRBAR24_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR24_U_CXRH_NID264, REGION24_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR24_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR24_U_CXRH_NID264, REGION24_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR24_U_CXRH_NID264, REGION24_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR24_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR24_U_CXRH_NID264, 0x21d2598)
    FIELD(POR_MPU_M5_PRLAR24_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR24_U_CXRH_NID264, REGION24_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR24_U_CXRH_NID264, REGION24_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR25_U_CXRH_NID264, 0x21d25a0)
    FIELD(POR_MPU_M5_PRBAR25_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR25_U_CXRH_NID264, REGION25_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR25_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR25_U_CXRH_NID264, REGION25_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR25_U_CXRH_NID264, REGION25_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR25_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR25_U_CXRH_NID264, 0x21d25a8)
    FIELD(POR_MPU_M5_PRLAR25_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR25_U_CXRH_NID264, REGION25_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR25_U_CXRH_NID264, REGION25_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR26_U_CXRH_NID264, 0x21d25b0)
    FIELD(POR_MPU_M5_PRBAR26_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR26_U_CXRH_NID264, REGION26_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR26_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR26_U_CXRH_NID264, REGION26_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR26_U_CXRH_NID264, REGION26_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR26_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR26_U_CXRH_NID264, 0x21d25b8)
    FIELD(POR_MPU_M5_PRLAR26_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR26_U_CXRH_NID264, REGION26_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR26_U_CXRH_NID264, REGION26_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR27_U_CXRH_NID264, 0x21d25c0)
    FIELD(POR_MPU_M5_PRBAR27_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR27_U_CXRH_NID264, REGION27_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR27_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR27_U_CXRH_NID264, REGION27_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR27_U_CXRH_NID264, REGION27_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR27_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR27_U_CXRH_NID264, 0x21d25c8)
    FIELD(POR_MPU_M5_PRLAR27_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR27_U_CXRH_NID264, REGION27_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR27_U_CXRH_NID264, REGION27_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR28_U_CXRH_NID264, 0x21d25d0)
    FIELD(POR_MPU_M5_PRBAR28_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR28_U_CXRH_NID264, REGION28_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR28_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR28_U_CXRH_NID264, REGION28_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR28_U_CXRH_NID264, REGION28_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR28_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR28_U_CXRH_NID264, 0x21d25d8)
    FIELD(POR_MPU_M5_PRLAR28_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR28_U_CXRH_NID264, REGION28_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR28_U_CXRH_NID264, REGION28_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR29_U_CXRH_NID264, 0x21d25e0)
    FIELD(POR_MPU_M5_PRBAR29_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR29_U_CXRH_NID264, REGION29_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR29_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR29_U_CXRH_NID264, REGION29_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR29_U_CXRH_NID264, REGION29_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR29_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR29_U_CXRH_NID264, 0x21d25e8)
    FIELD(POR_MPU_M5_PRLAR29_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR29_U_CXRH_NID264, REGION29_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR29_U_CXRH_NID264, REGION29_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR30_U_CXRH_NID264, 0x21d25f0)
    FIELD(POR_MPU_M5_PRBAR30_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR30_U_CXRH_NID264, REGION30_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR30_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR30_U_CXRH_NID264, REGION30_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR30_U_CXRH_NID264, REGION30_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR30_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR30_U_CXRH_NID264, 0x21d25f8)
    FIELD(POR_MPU_M5_PRLAR30_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR30_U_CXRH_NID264, REGION30_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR30_U_CXRH_NID264, REGION30_EN, 0, 1)
REG32(POR_MPU_M5_PRBAR31_U_CXRH_NID264, 0x21d2600)
    FIELD(POR_MPU_M5_PRBAR31_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRBAR31_U_CXRH_NID264, REGION31_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRBAR31_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M5_PRBAR31_U_CXRH_NID264, REGION31_BR, 9, 1)
    FIELD(POR_MPU_M5_PRBAR31_U_CXRH_NID264, REGION31_AP, 2, 4)
    FIELD(POR_MPU_M5_PRBAR31_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M5_PRLAR31_U_CXRH_NID264, 0x21d2608)
    FIELD(POR_MPU_M5_PRLAR31_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M5_PRLAR31_U_CXRH_NID264, REGION31_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M5_PRLAR31_U_CXRH_NID264, REGION31_EN, 0, 1)
REG32(POR_MPU_M6_CTL_U_CXRH_NID264, 0x21d2800)
    FIELD(POR_MPU_M6_CTL_U_CXRH_NID264, M6_EN, 2, 1)
    FIELD(POR_MPU_M6_CTL_U_CXRH_NID264, M6_ACTION, 0, 2)
REG32(POR_MPU_M6_PRBAR0_U_CXRH_NID264, 0x21d2810)
    FIELD(POR_MPU_M6_PRBAR0_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR0_U_CXRH_NID264, REGION0_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR0_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR0_U_CXRH_NID264, REGION0_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR0_U_CXRH_NID264, REGION0_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR0_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR0_U_CXRH_NID264, 0x21d2818)
    FIELD(POR_MPU_M6_PRLAR0_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR0_U_CXRH_NID264, REGION0_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR0_U_CXRH_NID264, REGION0_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR1_U_CXRH_NID264, 0x21d2820)
    FIELD(POR_MPU_M6_PRBAR1_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR1_U_CXRH_NID264, REGION1_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR1_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR1_U_CXRH_NID264, REGION1_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR1_U_CXRH_NID264, REGION1_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR1_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR1_U_CXRH_NID264, 0x21d2828)
    FIELD(POR_MPU_M6_PRLAR1_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR1_U_CXRH_NID264, REGION1_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR1_U_CXRH_NID264, REGION1_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR2_U_CXRH_NID264, 0x21d2830)
    FIELD(POR_MPU_M6_PRBAR2_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR2_U_CXRH_NID264, REGION2_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR2_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR2_U_CXRH_NID264, REGION2_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR2_U_CXRH_NID264, REGION2_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR2_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR2_U_CXRH_NID264, 0x21d2838)
    FIELD(POR_MPU_M6_PRLAR2_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR2_U_CXRH_NID264, REGION2_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR2_U_CXRH_NID264, REGION2_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR3_U_CXRH_NID264, 0x21d2840)
    FIELD(POR_MPU_M6_PRBAR3_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR3_U_CXRH_NID264, REGION3_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR3_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR3_U_CXRH_NID264, REGION3_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR3_U_CXRH_NID264, REGION3_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR3_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR3_U_CXRH_NID264, 0x21d2848)
    FIELD(POR_MPU_M6_PRLAR3_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR3_U_CXRH_NID264, REGION3_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR3_U_CXRH_NID264, REGION3_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR4_U_CXRH_NID264, 0x21d2850)
    FIELD(POR_MPU_M6_PRBAR4_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR4_U_CXRH_NID264, REGION4_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR4_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR4_U_CXRH_NID264, REGION4_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR4_U_CXRH_NID264, REGION4_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR4_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR4_U_CXRH_NID264, 0x21d2858)
    FIELD(POR_MPU_M6_PRLAR4_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR4_U_CXRH_NID264, REGION4_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR4_U_CXRH_NID264, REGION4_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR5_U_CXRH_NID264, 0x21d2860)
    FIELD(POR_MPU_M6_PRBAR5_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR5_U_CXRH_NID264, REGION5_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR5_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR5_U_CXRH_NID264, REGION5_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR5_U_CXRH_NID264, REGION5_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR5_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR5_U_CXRH_NID264, 0x21d2868)
    FIELD(POR_MPU_M6_PRLAR5_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR5_U_CXRH_NID264, REGION5_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR5_U_CXRH_NID264, REGION5_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR6_U_CXRH_NID264, 0x21d2870)
    FIELD(POR_MPU_M6_PRBAR6_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR6_U_CXRH_NID264, REGION6_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR6_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR6_U_CXRH_NID264, REGION6_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR6_U_CXRH_NID264, REGION6_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR6_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR6_U_CXRH_NID264, 0x21d2878)
    FIELD(POR_MPU_M6_PRLAR6_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR6_U_CXRH_NID264, REGION6_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR6_U_CXRH_NID264, REGION6_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR7_U_CXRH_NID264, 0x21d2880)
    FIELD(POR_MPU_M6_PRBAR7_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR7_U_CXRH_NID264, REGION7_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR7_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR7_U_CXRH_NID264, REGION7_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR7_U_CXRH_NID264, REGION7_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR7_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR7_U_CXRH_NID264, 0x21d2888)
    FIELD(POR_MPU_M6_PRLAR7_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR7_U_CXRH_NID264, REGION7_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR7_U_CXRH_NID264, REGION7_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR8_U_CXRH_NID264, 0x21d2890)
    FIELD(POR_MPU_M6_PRBAR8_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR8_U_CXRH_NID264, REGION8_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR8_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR8_U_CXRH_NID264, REGION8_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR8_U_CXRH_NID264, REGION8_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR8_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR8_U_CXRH_NID264, 0x21d2898)
    FIELD(POR_MPU_M6_PRLAR8_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR8_U_CXRH_NID264, REGION8_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR8_U_CXRH_NID264, REGION8_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR9_U_CXRH_NID264, 0x21d28a0)
    FIELD(POR_MPU_M6_PRBAR9_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR9_U_CXRH_NID264, REGION9_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR9_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR9_U_CXRH_NID264, REGION9_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR9_U_CXRH_NID264, REGION9_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR9_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR9_U_CXRH_NID264, 0x21d28a8)
    FIELD(POR_MPU_M6_PRLAR9_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR9_U_CXRH_NID264, REGION9_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR9_U_CXRH_NID264, REGION9_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR10_U_CXRH_NID264, 0x21d28b0)
    FIELD(POR_MPU_M6_PRBAR10_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR10_U_CXRH_NID264, REGION10_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR10_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR10_U_CXRH_NID264, REGION10_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR10_U_CXRH_NID264, REGION10_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR10_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR10_U_CXRH_NID264, 0x21d28b8)
    FIELD(POR_MPU_M6_PRLAR10_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR10_U_CXRH_NID264, REGION10_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR10_U_CXRH_NID264, REGION10_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR11_U_CXRH_NID264, 0x21d28c0)
    FIELD(POR_MPU_M6_PRBAR11_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR11_U_CXRH_NID264, REGION11_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR11_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR11_U_CXRH_NID264, REGION11_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR11_U_CXRH_NID264, REGION11_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR11_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR11_U_CXRH_NID264, 0x21d28c8)
    FIELD(POR_MPU_M6_PRLAR11_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR11_U_CXRH_NID264, REGION11_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR11_U_CXRH_NID264, REGION11_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR12_U_CXRH_NID264, 0x21d28d0)
    FIELD(POR_MPU_M6_PRBAR12_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR12_U_CXRH_NID264, REGION12_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR12_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR12_U_CXRH_NID264, REGION12_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR12_U_CXRH_NID264, REGION12_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR12_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR12_U_CXRH_NID264, 0x21d28d8)
    FIELD(POR_MPU_M6_PRLAR12_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR12_U_CXRH_NID264, REGION12_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR12_U_CXRH_NID264, REGION12_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR13_U_CXRH_NID264, 0x21d28e0)
    FIELD(POR_MPU_M6_PRBAR13_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR13_U_CXRH_NID264, REGION13_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR13_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR13_U_CXRH_NID264, REGION13_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR13_U_CXRH_NID264, REGION13_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR13_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR13_U_CXRH_NID264, 0x21d28e8)
    FIELD(POR_MPU_M6_PRLAR13_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR13_U_CXRH_NID264, REGION13_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR13_U_CXRH_NID264, REGION13_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR14_U_CXRH_NID264, 0x21d28f0)
    FIELD(POR_MPU_M6_PRBAR14_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR14_U_CXRH_NID264, REGION14_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR14_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR14_U_CXRH_NID264, REGION14_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR14_U_CXRH_NID264, REGION14_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR14_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR14_U_CXRH_NID264, 0x21d28f8)
    FIELD(POR_MPU_M6_PRLAR14_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR14_U_CXRH_NID264, REGION14_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR14_U_CXRH_NID264, REGION14_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR15_U_CXRH_NID264, 0x21d2900)
    FIELD(POR_MPU_M6_PRBAR15_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR15_U_CXRH_NID264, REGION15_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR15_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR15_U_CXRH_NID264, REGION15_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR15_U_CXRH_NID264, REGION15_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR15_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR15_U_CXRH_NID264, 0x21d2908)
    FIELD(POR_MPU_M6_PRLAR15_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR15_U_CXRH_NID264, REGION15_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR15_U_CXRH_NID264, REGION15_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR16_U_CXRH_NID264, 0x21d2910)
    FIELD(POR_MPU_M6_PRBAR16_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR16_U_CXRH_NID264, REGION16_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR16_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR16_U_CXRH_NID264, REGION16_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR16_U_CXRH_NID264, REGION16_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR16_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR16_U_CXRH_NID264, 0x21d2918)
    FIELD(POR_MPU_M6_PRLAR16_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR16_U_CXRH_NID264, REGION16_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR16_U_CXRH_NID264, REGION16_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR17_U_CXRH_NID264, 0x21d2920)
    FIELD(POR_MPU_M6_PRBAR17_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR17_U_CXRH_NID264, REGION17_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR17_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR17_U_CXRH_NID264, REGION17_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR17_U_CXRH_NID264, REGION17_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR17_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR17_U_CXRH_NID264, 0x21d2928)
    FIELD(POR_MPU_M6_PRLAR17_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR17_U_CXRH_NID264, REGION17_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR17_U_CXRH_NID264, REGION17_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR18_U_CXRH_NID264, 0x21d2930)
    FIELD(POR_MPU_M6_PRBAR18_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR18_U_CXRH_NID264, REGION18_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR18_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR18_U_CXRH_NID264, REGION18_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR18_U_CXRH_NID264, REGION18_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR18_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR18_U_CXRH_NID264, 0x21d2938)
    FIELD(POR_MPU_M6_PRLAR18_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR18_U_CXRH_NID264, REGION18_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR18_U_CXRH_NID264, REGION18_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR19_U_CXRH_NID264, 0x21d2940)
    FIELD(POR_MPU_M6_PRBAR19_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR19_U_CXRH_NID264, REGION19_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR19_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR19_U_CXRH_NID264, REGION19_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR19_U_CXRH_NID264, REGION19_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR19_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR19_U_CXRH_NID264, 0x21d2948)
    FIELD(POR_MPU_M6_PRLAR19_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR19_U_CXRH_NID264, REGION19_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR19_U_CXRH_NID264, REGION19_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR20_U_CXRH_NID264, 0x21d2950)
    FIELD(POR_MPU_M6_PRBAR20_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR20_U_CXRH_NID264, REGION20_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR20_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR20_U_CXRH_NID264, REGION20_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR20_U_CXRH_NID264, REGION20_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR20_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR20_U_CXRH_NID264, 0x21d2958)
    FIELD(POR_MPU_M6_PRLAR20_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR20_U_CXRH_NID264, REGION20_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR20_U_CXRH_NID264, REGION20_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR21_U_CXRH_NID264, 0x21d2960)
    FIELD(POR_MPU_M6_PRBAR21_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR21_U_CXRH_NID264, REGION21_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR21_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR21_U_CXRH_NID264, REGION21_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR21_U_CXRH_NID264, REGION21_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR21_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR21_U_CXRH_NID264, 0x21d2968)
    FIELD(POR_MPU_M6_PRLAR21_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR21_U_CXRH_NID264, REGION21_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR21_U_CXRH_NID264, REGION21_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR22_U_CXRH_NID264, 0x21d2970)
    FIELD(POR_MPU_M6_PRBAR22_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR22_U_CXRH_NID264, REGION22_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR22_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR22_U_CXRH_NID264, REGION22_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR22_U_CXRH_NID264, REGION22_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR22_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR22_U_CXRH_NID264, 0x21d2978)
    FIELD(POR_MPU_M6_PRLAR22_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR22_U_CXRH_NID264, REGION22_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR22_U_CXRH_NID264, REGION22_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR23_U_CXRH_NID264, 0x21d2980)
    FIELD(POR_MPU_M6_PRBAR23_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR23_U_CXRH_NID264, REGION23_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR23_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR23_U_CXRH_NID264, REGION23_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR23_U_CXRH_NID264, REGION23_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR23_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR23_U_CXRH_NID264, 0x21d2988)
    FIELD(POR_MPU_M6_PRLAR23_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR23_U_CXRH_NID264, REGION23_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR23_U_CXRH_NID264, REGION23_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR24_U_CXRH_NID264, 0x21d2990)
    FIELD(POR_MPU_M6_PRBAR24_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR24_U_CXRH_NID264, REGION24_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR24_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR24_U_CXRH_NID264, REGION24_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR24_U_CXRH_NID264, REGION24_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR24_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR24_U_CXRH_NID264, 0x21d2998)
    FIELD(POR_MPU_M6_PRLAR24_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR24_U_CXRH_NID264, REGION24_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR24_U_CXRH_NID264, REGION24_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR25_U_CXRH_NID264, 0x21d29a0)
    FIELD(POR_MPU_M6_PRBAR25_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR25_U_CXRH_NID264, REGION25_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR25_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR25_U_CXRH_NID264, REGION25_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR25_U_CXRH_NID264, REGION25_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR25_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR25_U_CXRH_NID264, 0x21d29a8)
    FIELD(POR_MPU_M6_PRLAR25_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR25_U_CXRH_NID264, REGION25_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR25_U_CXRH_NID264, REGION25_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR26_U_CXRH_NID264, 0x21d29b0)
    FIELD(POR_MPU_M6_PRBAR26_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR26_U_CXRH_NID264, REGION26_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR26_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR26_U_CXRH_NID264, REGION26_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR26_U_CXRH_NID264, REGION26_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR26_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR26_U_CXRH_NID264, 0x21d29b8)
    FIELD(POR_MPU_M6_PRLAR26_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR26_U_CXRH_NID264, REGION26_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR26_U_CXRH_NID264, REGION26_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR27_U_CXRH_NID264, 0x21d29c0)
    FIELD(POR_MPU_M6_PRBAR27_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR27_U_CXRH_NID264, REGION27_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR27_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR27_U_CXRH_NID264, REGION27_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR27_U_CXRH_NID264, REGION27_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR27_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR27_U_CXRH_NID264, 0x21d29c8)
    FIELD(POR_MPU_M6_PRLAR27_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR27_U_CXRH_NID264, REGION27_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR27_U_CXRH_NID264, REGION27_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR28_U_CXRH_NID264, 0x21d29d0)
    FIELD(POR_MPU_M6_PRBAR28_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR28_U_CXRH_NID264, REGION28_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR28_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR28_U_CXRH_NID264, REGION28_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR28_U_CXRH_NID264, REGION28_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR28_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR28_U_CXRH_NID264, 0x21d29d8)
    FIELD(POR_MPU_M6_PRLAR28_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR28_U_CXRH_NID264, REGION28_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR28_U_CXRH_NID264, REGION28_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR29_U_CXRH_NID264, 0x21d29e0)
    FIELD(POR_MPU_M6_PRBAR29_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR29_U_CXRH_NID264, REGION29_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR29_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR29_U_CXRH_NID264, REGION29_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR29_U_CXRH_NID264, REGION29_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR29_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR29_U_CXRH_NID264, 0x21d29e8)
    FIELD(POR_MPU_M6_PRLAR29_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR29_U_CXRH_NID264, REGION29_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR29_U_CXRH_NID264, REGION29_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR30_U_CXRH_NID264, 0x21d29f0)
    FIELD(POR_MPU_M6_PRBAR30_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR30_U_CXRH_NID264, REGION30_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR30_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR30_U_CXRH_NID264, REGION30_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR30_U_CXRH_NID264, REGION30_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR30_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR30_U_CXRH_NID264, 0x21d29f8)
    FIELD(POR_MPU_M6_PRLAR30_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR30_U_CXRH_NID264, REGION30_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR30_U_CXRH_NID264, REGION30_EN, 0, 1)
REG32(POR_MPU_M6_PRBAR31_U_CXRH_NID264, 0x21d2a00)
    FIELD(POR_MPU_M6_PRBAR31_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRBAR31_U_CXRH_NID264, REGION31_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRBAR31_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M6_PRBAR31_U_CXRH_NID264, REGION31_BR, 9, 1)
    FIELD(POR_MPU_M6_PRBAR31_U_CXRH_NID264, REGION31_AP, 2, 4)
    FIELD(POR_MPU_M6_PRBAR31_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M6_PRLAR31_U_CXRH_NID264, 0x21d2a08)
    FIELD(POR_MPU_M6_PRLAR31_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M6_PRLAR31_U_CXRH_NID264, REGION31_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M6_PRLAR31_U_CXRH_NID264, REGION31_EN, 0, 1)
REG32(POR_MPU_M7_CTL_U_CXRH_NID264, 0x21d2c00)
    FIELD(POR_MPU_M7_CTL_U_CXRH_NID264, M7_EN, 2, 1)
    FIELD(POR_MPU_M7_CTL_U_CXRH_NID264, M7_ACTION, 0, 2)
REG32(POR_MPU_M7_PRBAR0_U_CXRH_NID264, 0x21d2c10)
    FIELD(POR_MPU_M7_PRBAR0_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR0_U_CXRH_NID264, REGION0_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR0_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR0_U_CXRH_NID264, REGION0_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR0_U_CXRH_NID264, REGION0_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR0_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR0_U_CXRH_NID264, 0x21d2c18)
    FIELD(POR_MPU_M7_PRLAR0_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR0_U_CXRH_NID264, REGION0_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR0_U_CXRH_NID264, REGION0_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR1_U_CXRH_NID264, 0x21d2c20)
    FIELD(POR_MPU_M7_PRBAR1_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR1_U_CXRH_NID264, REGION1_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR1_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR1_U_CXRH_NID264, REGION1_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR1_U_CXRH_NID264, REGION1_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR1_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR1_U_CXRH_NID264, 0x21d2c28)
    FIELD(POR_MPU_M7_PRLAR1_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR1_U_CXRH_NID264, REGION1_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR1_U_CXRH_NID264, REGION1_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR2_U_CXRH_NID264, 0x21d2c30)
    FIELD(POR_MPU_M7_PRBAR2_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR2_U_CXRH_NID264, REGION2_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR2_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR2_U_CXRH_NID264, REGION2_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR2_U_CXRH_NID264, REGION2_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR2_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR2_U_CXRH_NID264, 0x21d2c38)
    FIELD(POR_MPU_M7_PRLAR2_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR2_U_CXRH_NID264, REGION2_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR2_U_CXRH_NID264, REGION2_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR3_U_CXRH_NID264, 0x21d2c40)
    FIELD(POR_MPU_M7_PRBAR3_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR3_U_CXRH_NID264, REGION3_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR3_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR3_U_CXRH_NID264, REGION3_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR3_U_CXRH_NID264, REGION3_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR3_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR3_U_CXRH_NID264, 0x21d2c48)
    FIELD(POR_MPU_M7_PRLAR3_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR3_U_CXRH_NID264, REGION3_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR3_U_CXRH_NID264, REGION3_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR4_U_CXRH_NID264, 0x21d2c50)
    FIELD(POR_MPU_M7_PRBAR4_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR4_U_CXRH_NID264, REGION4_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR4_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR4_U_CXRH_NID264, REGION4_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR4_U_CXRH_NID264, REGION4_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR4_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR4_U_CXRH_NID264, 0x21d2c58)
    FIELD(POR_MPU_M7_PRLAR4_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR4_U_CXRH_NID264, REGION4_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR4_U_CXRH_NID264, REGION4_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR5_U_CXRH_NID264, 0x21d2c60)
    FIELD(POR_MPU_M7_PRBAR5_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR5_U_CXRH_NID264, REGION5_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR5_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR5_U_CXRH_NID264, REGION5_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR5_U_CXRH_NID264, REGION5_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR5_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR5_U_CXRH_NID264, 0x21d2c68)
    FIELD(POR_MPU_M7_PRLAR5_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR5_U_CXRH_NID264, REGION5_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR5_U_CXRH_NID264, REGION5_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR6_U_CXRH_NID264, 0x21d2c70)
    FIELD(POR_MPU_M7_PRBAR6_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR6_U_CXRH_NID264, REGION6_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR6_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR6_U_CXRH_NID264, REGION6_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR6_U_CXRH_NID264, REGION6_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR6_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR6_U_CXRH_NID264, 0x21d2c78)
    FIELD(POR_MPU_M7_PRLAR6_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR6_U_CXRH_NID264, REGION6_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR6_U_CXRH_NID264, REGION6_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR7_U_CXRH_NID264, 0x21d2c80)
    FIELD(POR_MPU_M7_PRBAR7_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR7_U_CXRH_NID264, REGION7_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR7_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR7_U_CXRH_NID264, REGION7_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR7_U_CXRH_NID264, REGION7_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR7_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR7_U_CXRH_NID264, 0x21d2c88)
    FIELD(POR_MPU_M7_PRLAR7_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR7_U_CXRH_NID264, REGION7_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR7_U_CXRH_NID264, REGION7_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR8_U_CXRH_NID264, 0x21d2c90)
    FIELD(POR_MPU_M7_PRBAR8_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR8_U_CXRH_NID264, REGION8_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR8_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR8_U_CXRH_NID264, REGION8_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR8_U_CXRH_NID264, REGION8_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR8_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR8_U_CXRH_NID264, 0x21d2c98)
    FIELD(POR_MPU_M7_PRLAR8_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR8_U_CXRH_NID264, REGION8_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR8_U_CXRH_NID264, REGION8_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR9_U_CXRH_NID264, 0x21d2ca0)
    FIELD(POR_MPU_M7_PRBAR9_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR9_U_CXRH_NID264, REGION9_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR9_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR9_U_CXRH_NID264, REGION9_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR9_U_CXRH_NID264, REGION9_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR9_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR9_U_CXRH_NID264, 0x21d2ca8)
    FIELD(POR_MPU_M7_PRLAR9_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR9_U_CXRH_NID264, REGION9_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR9_U_CXRH_NID264, REGION9_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR10_U_CXRH_NID264, 0x21d2cb0)
    FIELD(POR_MPU_M7_PRBAR10_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR10_U_CXRH_NID264, REGION10_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR10_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR10_U_CXRH_NID264, REGION10_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR10_U_CXRH_NID264, REGION10_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR10_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR10_U_CXRH_NID264, 0x21d2cb8)
    FIELD(POR_MPU_M7_PRLAR10_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR10_U_CXRH_NID264, REGION10_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR10_U_CXRH_NID264, REGION10_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR11_U_CXRH_NID264, 0x21d2cc0)
    FIELD(POR_MPU_M7_PRBAR11_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR11_U_CXRH_NID264, REGION11_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR11_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR11_U_CXRH_NID264, REGION11_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR11_U_CXRH_NID264, REGION11_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR11_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR11_U_CXRH_NID264, 0x21d2cc8)
    FIELD(POR_MPU_M7_PRLAR11_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR11_U_CXRH_NID264, REGION11_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR11_U_CXRH_NID264, REGION11_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR12_U_CXRH_NID264, 0x21d2cd0)
    FIELD(POR_MPU_M7_PRBAR12_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR12_U_CXRH_NID264, REGION12_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR12_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR12_U_CXRH_NID264, REGION12_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR12_U_CXRH_NID264, REGION12_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR12_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR12_U_CXRH_NID264, 0x21d2cd8)
    FIELD(POR_MPU_M7_PRLAR12_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR12_U_CXRH_NID264, REGION12_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR12_U_CXRH_NID264, REGION12_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR13_U_CXRH_NID264, 0x21d2ce0)
    FIELD(POR_MPU_M7_PRBAR13_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR13_U_CXRH_NID264, REGION13_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR13_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR13_U_CXRH_NID264, REGION13_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR13_U_CXRH_NID264, REGION13_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR13_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR13_U_CXRH_NID264, 0x21d2ce8)
    FIELD(POR_MPU_M7_PRLAR13_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR13_U_CXRH_NID264, REGION13_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR13_U_CXRH_NID264, REGION13_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR14_U_CXRH_NID264, 0x21d2cf0)
    FIELD(POR_MPU_M7_PRBAR14_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR14_U_CXRH_NID264, REGION14_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR14_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR14_U_CXRH_NID264, REGION14_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR14_U_CXRH_NID264, REGION14_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR14_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR14_U_CXRH_NID264, 0x21d2cf8)
    FIELD(POR_MPU_M7_PRLAR14_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR14_U_CXRH_NID264, REGION14_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR14_U_CXRH_NID264, REGION14_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR15_U_CXRH_NID264, 0x21d2d00)
    FIELD(POR_MPU_M7_PRBAR15_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR15_U_CXRH_NID264, REGION15_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR15_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR15_U_CXRH_NID264, REGION15_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR15_U_CXRH_NID264, REGION15_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR15_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR15_U_CXRH_NID264, 0x21d2d08)
    FIELD(POR_MPU_M7_PRLAR15_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR15_U_CXRH_NID264, REGION15_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR15_U_CXRH_NID264, REGION15_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR16_U_CXRH_NID264, 0x21d2d10)
    FIELD(POR_MPU_M7_PRBAR16_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR16_U_CXRH_NID264, REGION16_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR16_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR16_U_CXRH_NID264, REGION16_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR16_U_CXRH_NID264, REGION16_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR16_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR16_U_CXRH_NID264, 0x21d2d18)
    FIELD(POR_MPU_M7_PRLAR16_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR16_U_CXRH_NID264, REGION16_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR16_U_CXRH_NID264, REGION16_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR17_U_CXRH_NID264, 0x21d2d20)
    FIELD(POR_MPU_M7_PRBAR17_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR17_U_CXRH_NID264, REGION17_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR17_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR17_U_CXRH_NID264, REGION17_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR17_U_CXRH_NID264, REGION17_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR17_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR17_U_CXRH_NID264, 0x21d2d28)
    FIELD(POR_MPU_M7_PRLAR17_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR17_U_CXRH_NID264, REGION17_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR17_U_CXRH_NID264, REGION17_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR18_U_CXRH_NID264, 0x21d2d30)
    FIELD(POR_MPU_M7_PRBAR18_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR18_U_CXRH_NID264, REGION18_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR18_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR18_U_CXRH_NID264, REGION18_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR18_U_CXRH_NID264, REGION18_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR18_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR18_U_CXRH_NID264, 0x21d2d38)
    FIELD(POR_MPU_M7_PRLAR18_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR18_U_CXRH_NID264, REGION18_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR18_U_CXRH_NID264, REGION18_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR19_U_CXRH_NID264, 0x21d2d40)
    FIELD(POR_MPU_M7_PRBAR19_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR19_U_CXRH_NID264, REGION19_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR19_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR19_U_CXRH_NID264, REGION19_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR19_U_CXRH_NID264, REGION19_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR19_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR19_U_CXRH_NID264, 0x21d2d48)
    FIELD(POR_MPU_M7_PRLAR19_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR19_U_CXRH_NID264, REGION19_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR19_U_CXRH_NID264, REGION19_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR20_U_CXRH_NID264, 0x21d2d50)
    FIELD(POR_MPU_M7_PRBAR20_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR20_U_CXRH_NID264, REGION20_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR20_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR20_U_CXRH_NID264, REGION20_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR20_U_CXRH_NID264, REGION20_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR20_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR20_U_CXRH_NID264, 0x21d2d58)
    FIELD(POR_MPU_M7_PRLAR20_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR20_U_CXRH_NID264, REGION20_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR20_U_CXRH_NID264, REGION20_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR21_U_CXRH_NID264, 0x21d2d60)
    FIELD(POR_MPU_M7_PRBAR21_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR21_U_CXRH_NID264, REGION21_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR21_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR21_U_CXRH_NID264, REGION21_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR21_U_CXRH_NID264, REGION21_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR21_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR21_U_CXRH_NID264, 0x21d2d68)
    FIELD(POR_MPU_M7_PRLAR21_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR21_U_CXRH_NID264, REGION21_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR21_U_CXRH_NID264, REGION21_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR22_U_CXRH_NID264, 0x21d2d70)
    FIELD(POR_MPU_M7_PRBAR22_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR22_U_CXRH_NID264, REGION22_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR22_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR22_U_CXRH_NID264, REGION22_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR22_U_CXRH_NID264, REGION22_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR22_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR22_U_CXRH_NID264, 0x21d2d78)
    FIELD(POR_MPU_M7_PRLAR22_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR22_U_CXRH_NID264, REGION22_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR22_U_CXRH_NID264, REGION22_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR23_U_CXRH_NID264, 0x21d2d80)
    FIELD(POR_MPU_M7_PRBAR23_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR23_U_CXRH_NID264, REGION23_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR23_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR23_U_CXRH_NID264, REGION23_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR23_U_CXRH_NID264, REGION23_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR23_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR23_U_CXRH_NID264, 0x21d2d88)
    FIELD(POR_MPU_M7_PRLAR23_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR23_U_CXRH_NID264, REGION23_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR23_U_CXRH_NID264, REGION23_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR24_U_CXRH_NID264, 0x21d2d90)
    FIELD(POR_MPU_M7_PRBAR24_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR24_U_CXRH_NID264, REGION24_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR24_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR24_U_CXRH_NID264, REGION24_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR24_U_CXRH_NID264, REGION24_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR24_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR24_U_CXRH_NID264, 0x21d2d98)
    FIELD(POR_MPU_M7_PRLAR24_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR24_U_CXRH_NID264, REGION24_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR24_U_CXRH_NID264, REGION24_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR25_U_CXRH_NID264, 0x21d2da0)
    FIELD(POR_MPU_M7_PRBAR25_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR25_U_CXRH_NID264, REGION25_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR25_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR25_U_CXRH_NID264, REGION25_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR25_U_CXRH_NID264, REGION25_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR25_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR25_U_CXRH_NID264, 0x21d2da8)
    FIELD(POR_MPU_M7_PRLAR25_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR25_U_CXRH_NID264, REGION25_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR25_U_CXRH_NID264, REGION25_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR26_U_CXRH_NID264, 0x21d2db0)
    FIELD(POR_MPU_M7_PRBAR26_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR26_U_CXRH_NID264, REGION26_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR26_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR26_U_CXRH_NID264, REGION26_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR26_U_CXRH_NID264, REGION26_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR26_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR26_U_CXRH_NID264, 0x21d2db8)
    FIELD(POR_MPU_M7_PRLAR26_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR26_U_CXRH_NID264, REGION26_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR26_U_CXRH_NID264, REGION26_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR27_U_CXRH_NID264, 0x21d2dc0)
    FIELD(POR_MPU_M7_PRBAR27_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR27_U_CXRH_NID264, REGION27_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR27_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR27_U_CXRH_NID264, REGION27_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR27_U_CXRH_NID264, REGION27_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR27_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR27_U_CXRH_NID264, 0x21d2dc8)
    FIELD(POR_MPU_M7_PRLAR27_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR27_U_CXRH_NID264, REGION27_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR27_U_CXRH_NID264, REGION27_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR28_U_CXRH_NID264, 0x21d2dd0)
    FIELD(POR_MPU_M7_PRBAR28_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR28_U_CXRH_NID264, REGION28_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR28_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR28_U_CXRH_NID264, REGION28_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR28_U_CXRH_NID264, REGION28_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR28_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR28_U_CXRH_NID264, 0x21d2dd8)
    FIELD(POR_MPU_M7_PRLAR28_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR28_U_CXRH_NID264, REGION28_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR28_U_CXRH_NID264, REGION28_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR29_U_CXRH_NID264, 0x21d2de0)
    FIELD(POR_MPU_M7_PRBAR29_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR29_U_CXRH_NID264, REGION29_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR29_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR29_U_CXRH_NID264, REGION29_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR29_U_CXRH_NID264, REGION29_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR29_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR29_U_CXRH_NID264, 0x21d2de8)
    FIELD(POR_MPU_M7_PRLAR29_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR29_U_CXRH_NID264, REGION29_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR29_U_CXRH_NID264, REGION29_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR30_U_CXRH_NID264, 0x21d2df0)
    FIELD(POR_MPU_M7_PRBAR30_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR30_U_CXRH_NID264, REGION30_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR30_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR30_U_CXRH_NID264, REGION30_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR30_U_CXRH_NID264, REGION30_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR30_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR30_U_CXRH_NID264, 0x21d2df8)
    FIELD(POR_MPU_M7_PRLAR30_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR30_U_CXRH_NID264, REGION30_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR30_U_CXRH_NID264, REGION30_EN, 0, 1)
REG32(POR_MPU_M7_PRBAR31_U_CXRH_NID264, 0x21d2e00)
    FIELD(POR_MPU_M7_PRBAR31_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRBAR31_U_CXRH_NID264, REGION31_BASE_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRBAR31_U_CXRH_NID264, RESERVED_10, 10, 2)
    FIELD(POR_MPU_M7_PRBAR31_U_CXRH_NID264, REGION31_BR, 9, 1)
    FIELD(POR_MPU_M7_PRBAR31_U_CXRH_NID264, REGION31_AP, 2, 4)
    FIELD(POR_MPU_M7_PRBAR31_U_CXRH_NID264, RESERVED_0, 0, 2)
REG32(POR_MPU_M7_PRLAR31_U_CXRH_NID264, 0x21d2e08)
    FIELD(POR_MPU_M7_PRLAR31_U_CXRH_NID264, RESERVED_48, 48, 16)
    FIELD(POR_MPU_M7_PRLAR31_U_CXRH_NID264, REGION31_LIMIT_ADDR, 12, 36)
    FIELD(POR_MPU_M7_PRLAR31_U_CXRH_NID264, REGION31_EN, 0, 1)

#define CMN_R_MAX (R_POR_MPU_M7_PRLAR31_U_CXRH_NID264 + 1)

/*
 * These macros generate an offset relative to the first SAM node for each
 * corresponding SAM
 */
#define CMN_RN_SAM_OFFSET(x) (x - A_POR_RNSAM_NODE_INFO_U_RNI_NID4)
#define CMN_HNI_SAM_OFFSET(x) (x - A_POR_HNI_NODE_INFO_U_HNI_NID196)
#define CMN_HNF_SAM_OFFSET(x) (x - A_POR_HNF_NODE_INFO_U_HNF_NID8)

#define NUM_RN_SAM 10
#define NUM_HNI_SAM 2
#define NUM_HNF_SAM 4
#define CMN_NODE_SIZE 0x4000
#define ADDRESS_WIDTH 48

typedef struct CMN600AE CMN600AE;

typedef struct {
    uint64_t base;
    uint64_t size;
    uint64_t limit;
    uint8_t base_shift;
    bool valid;
} sam_mr;

typedef struct CMNRNSAMNode {
    CMN600AE *parent;
    MemoryRegion iomem;
    uint64_t base;

    sam_mr non_hash_regions[8];
    sam_mr cache_grps[4];
    sam_mr cache_grp_scndry[4];
    sam_mr gic_region;
} CMNRNSAMNode;

typedef struct CMNHNISAMNode {
    CMN600AE *parent;
    MemoryRegion iomem;
    uint64_t base;

    sam_mr regions[3];
} CMNHNISAMNode;

typedef struct CMNHNFSAMNode {
    CMN600AE *parent;
    MemoryRegion iomem;
    uint64_t base;

    sam_mr regions[2];
} CMNHNFSAMNode;

struct CMN600AE {
    SysBusDevice parent_obj;
    MemoryRegion iomem;
    RegisterInfoArray *reg_array;

    CMNRNSAMNode  rn_sam_nodes[NUM_RN_SAM];
    CMNHNISAMNode hni_sam_nodes[NUM_HNI_SAM];
    CMNHNFSAMNode hnf_sam_nodes[NUM_HNF_SAM];
    uint64_t regs[CMN_R_MAX];
    RegisterInfo regs_info[CMN_R_MAX];
};

static const RegisterAccessInfo cmn_regs_info[] = {
    {   .name = "POR_SBSX_NODE_INFO_U_SBSX_NID0",
        .addr = A_POR_SBSX_NODE_INFO_U_SBSX_NID0,
        .reset = 0x7,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_SBSX_CHILD_INFO_U_SBSX_NID0",
        .addr = A_POR_SBSX_CHILD_INFO_U_SBSX_NID0,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_SBSX_UNIT_INFO_U_SBSX_NID0",
        .addr = A_POR_SBSX_UNIT_INFO_U_SBSX_NID0,
        .reset = 0x84011,
        .rsvd = 0xee,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_SBSX_AUX_CTL_U_SBSX_NID0",
        .addr = A_POR_SBSX_AUX_CTL_U_SBSX_NID0,
        .rsvd = 0xfffffffffffffffeL,
        .ro = 0xfffffffffffffffeL,
    },{ .name = "POR_SBSX_PMU_EVENT_SEL_U_SBSX_NID0",
        .addr = A_POR_SBSX_PMU_EVENT_SEL_U_SBSX_NID0,
        .rsvd = 0xc0,
        .ro = 0xffffffffc0c0c0c0L,
    },{ .name = "POR_SBSX_ERRFR_U_SBSX_NID0",
        .addr = A_POR_SBSX_ERRFR_U_SBSX_NID0,
        .reset = 0xa1,
        .rsvd = 0x300,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_SBSX_ERRCTLR_U_SBSX_NID0",
        .addr = A_POR_SBSX_ERRCTLR_U_SBSX_NID0,
        .rsvd = 0xf0,
        .ro = 0xfffffffffffffef0L,
    },{ .name = "POR_SBSX_ERRSTATUS_U_SBSX_NID0",
        .addr = A_POR_SBSX_ERRSTATUS_U_SBSX_NID0,
        .ro = 0xffffffff127fffffL,
    },{ .name = "POR_SBSX_ERRADDR_U_SBSX_NID0",
        .addr = A_POR_SBSX_ERRADDR_U_SBSX_NID0,
        .ro = 0x7fff000000000000,
    },{ .name = "POR_SBSX_ERRMISC_U_SBSX_NID0",
        .addr = A_POR_SBSX_ERRMISC_U_SBSX_NID0,
        .ro = 0xffffffff80fe800fL,
    },{ .name = "POR_SBSX_ERRFR_NS_U_SBSX_NID0",
        .addr = A_POR_SBSX_ERRFR_NS_U_SBSX_NID0,
        .reset = 0xa1,
        .rsvd = 0x300,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_SBSX_ERRCTLR_NS_U_SBSX_NID0",
        .addr = A_POR_SBSX_ERRCTLR_NS_U_SBSX_NID0,
        .rsvd = 0xf0,
        .ro = 0xfffffffffffffef0L,
    },{ .name = "POR_SBSX_ERRSTATUS_NS_U_SBSX_NID0",
        .addr = A_POR_SBSX_ERRSTATUS_NS_U_SBSX_NID0,
        .ro = 0xffffffff127fffffL,
    },{ .name = "POR_SBSX_ERRADDR_NS_U_SBSX_NID0",
        .addr = A_POR_SBSX_ERRADDR_NS_U_SBSX_NID0,
        .ro = 0x7fff000000000000,
    },{ .name = "POR_SBSX_ERRMISC_NS_U_SBSX_NID0",
        .addr = A_POR_SBSX_ERRMISC_NS_U_SBSX_NID0,
        .ro = 0xffffffff80fe800fL,
    },{ .name = "POR_MXP_NODE_INFO_U_SMXP_0_0",
        .addr = A_POR_MXP_NODE_INFO_U_SMXP_0_0,
        .reset = 0x1080006,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_DEVICE_PORT_CONNECT_INFO_P0_U_SMXP_0_0",
        .addr = A_POR_MXP_DEVICE_PORT_CONNECT_INFO_P0_U_SMXP_0_0,
        .reset = 0xd,
        .rsvd = 0xffe0,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_DEVICE_PORT_CONNECT_INFO_P1_U_SMXP_0_0",
        .addr = A_POR_MXP_DEVICE_PORT_CONNECT_INFO_P1_U_SMXP_0_0,
        .reset = 0x1,
        .rsvd = 0xffe0,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_MESH_PORT_CONNECT_INFO_EAST_U_SMXP_0_0",
        .addr = A_POR_MXP_MESH_PORT_CONNECT_INFO_EAST_U_SMXP_0_0,
        .rsvd = 0xfffffffffffffff0L,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_MESH_PORT_CONNECT_INFO_NORTH_U_SMXP_0_0",
        .addr = A_POR_MXP_MESH_PORT_CONNECT_INFO_NORTH_U_SMXP_0_0,
        .rsvd = 0xfffffffffffffff0L,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_INFO_U_SMXP_0_0",
        .addr = A_POR_MXP_CHILD_INFO_U_SMXP_0_0,
        .reset = 0x1000006,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_POINTER_0_U_SMXP_0_0",
        .addr = A_POR_MXP_CHILD_POINTER_0_U_SMXP_0_0,
        .reset = 0x8212c000,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_POINTER_1_U_SMXP_0_0",
        .addr = A_POR_MXP_CHILD_POINTER_1_U_SMXP_0_0,
        .reset = 0x8213c000,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_POINTER_2_U_SMXP_0_0",
        .addr = A_POR_MXP_CHILD_POINTER_2_U_SMXP_0_0,
        .reset = 0x2168000,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_POINTER_3_U_SMXP_0_0",
        .addr = A_POR_MXP_CHILD_POINTER_3_U_SMXP_0_0,
        .reset = 0x821d0000,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_POINTER_4_U_SMXP_0_0",
        .addr = A_POR_MXP_CHILD_POINTER_4_U_SMXP_0_0,
        .reset = 0x82120000,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_POINTER_5_U_SMXP_0_0",
        .addr = A_POR_MXP_CHILD_POINTER_5_U_SMXP_0_0,
        .reset = 0x2150000,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_POINTER_6_U_SMXP_0_0",
        .addr = A_POR_MXP_CHILD_POINTER_6_U_SMXP_0_0,
        .reset = 0x2110000,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_POINTER_7_U_SMXP_0_0",
        .addr = A_POR_MXP_CHILD_POINTER_7_U_SMXP_0_0,
        .reset = 0x2100000,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_POINTER_8_U_SMXP_0_0",
        .addr = A_POR_MXP_CHILD_POINTER_8_U_SMXP_0_0,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_POINTER_9_U_SMXP_0_0",
        .addr = A_POR_MXP_CHILD_POINTER_9_U_SMXP_0_0,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_POINTER_10_U_SMXP_0_0",
        .addr = A_POR_MXP_CHILD_POINTER_10_U_SMXP_0_0,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_POINTER_11_U_SMXP_0_0",
        .addr = A_POR_MXP_CHILD_POINTER_11_U_SMXP_0_0,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_POINTER_12_U_SMXP_0_0",
        .addr = A_POR_MXP_CHILD_POINTER_12_U_SMXP_0_0,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_POINTER_13_U_SMXP_0_0",
        .addr = A_POR_MXP_CHILD_POINTER_13_U_SMXP_0_0,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_POINTER_14_U_SMXP_0_0",
        .addr = A_POR_MXP_CHILD_POINTER_14_U_SMXP_0_0,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_POINTER_15_U_SMXP_0_0",
        .addr = A_POR_MXP_CHILD_POINTER_15_U_SMXP_0_0,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_P0_INFO_U_SMXP_0_0",
        .addr = A_POR_MXP_P0_INFO_U_SMXP_0_0,
        .reset = 0x211,
        .rsvd = 0x48,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_P1_INFO_U_SMXP_0_0",
        .addr = A_POR_MXP_P1_INFO_U_SMXP_0_0,
        .reset = 0x211,
        .rsvd = 0x48,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_SECURE_REGISTER_GROUPS_OVERRIDE_U_SMXP_0_0",
        .addr = A_POR_MXP_SECURE_REGISTER_GROUPS_OVERRIDE_U_SMXP_0_0,
        .rsvd = 0xfffffffffffffffcL,
        .ro = 0xfffffffffffffffcL,
    },{ .name = "POR_MXP_AUX_CTL_U_SMXP_0_0",
        .addr = A_POR_MXP_AUX_CTL_U_SMXP_0_0,
        .rsvd = 0xfffffffffffffffeL,
        .ro = 0xfffffffffffffffeL,
    },{ .name = "POR_MXP_P0_QOS_CONTROL_U_SMXP_0_0",
        .addr = A_POR_MXP_P0_QOS_CONTROL_U_SMXP_0_0,
        .rsvd = 0xffaa,
        .ro = 0xfffffffffff0ffaaL,
    },{ .name = "POR_MXP_P0_QOS_LAT_TGT_U_SMXP_0_0",
        .addr = A_POR_MXP_P0_QOS_LAT_TGT_U_SMXP_0_0,
        .ro = 0xfffffffffffff000L,
    },{ .name = "POR_MXP_P0_QOS_LAT_SCALE_U_SMXP_0_0",
        .addr = A_POR_MXP_P0_QOS_LAT_SCALE_U_SMXP_0_0,
        .rsvd = 0xfffffffffffffff8L,
        .ro = 0xfffffffffffffff8L,
    },{ .name = "POR_MXP_P0_QOS_LAT_RANGE_U_SMXP_0_0",
        .addr = A_POR_MXP_P0_QOS_LAT_RANGE_U_SMXP_0_0,
        .rsvd = 0xf0,
        .ro = 0xfffffffffffff0f0L,
    },{ .name = "POR_MXP_P1_QOS_CONTROL_U_SMXP_0_0",
        .addr = A_POR_MXP_P1_QOS_CONTROL_U_SMXP_0_0,
        .rsvd = 0xffaa,
        .ro = 0xfffffffffff0ffaaL,
    },{ .name = "POR_MXP_P1_QOS_LAT_TGT_U_SMXP_0_0",
        .addr = A_POR_MXP_P1_QOS_LAT_TGT_U_SMXP_0_0,
        .ro = 0xfffffffffffff000L,
    },{ .name = "POR_MXP_P1_QOS_LAT_SCALE_U_SMXP_0_0",
        .addr = A_POR_MXP_P1_QOS_LAT_SCALE_U_SMXP_0_0,
        .rsvd = 0xfffffffffffffff8L,
        .ro = 0xfffffffffffffff8L,
    },{ .name = "POR_MXP_P1_QOS_LAT_RANGE_U_SMXP_0_0",
        .addr = A_POR_MXP_P1_QOS_LAT_RANGE_U_SMXP_0_0,
        .rsvd = 0xf0,
        .ro = 0xfffffffffffff0f0L,
    },{ .name = "POR_MXP_P0_SYSCOREQ_CTL_U_SMXP_0_0",
        .addr = A_POR_MXP_P0_SYSCOREQ_CTL_U_SMXP_0_0,
        .rsvd = 0xfffffffffffffff0L,
        .ro = 0xfffffffffffffff0L,
    },{ .name = "POR_MXP_P1_SYSCOREQ_CTL_U_SMXP_0_0",
        .addr = A_POR_MXP_P1_SYSCOREQ_CTL_U_SMXP_0_0,
        .rsvd = 0xfffffffffffffff0L,
        .ro = 0xfffffffffffffff0L,
    },{ .name = "POR_MXP_P0_SYSCOACK_STATUS_U_SMXP_0_0",
        .addr = A_POR_MXP_P0_SYSCOACK_STATUS_U_SMXP_0_0,
        .rsvd = 0xfffffffffffffff0L,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_P1_SYSCOACK_STATUS_U_SMXP_0_0",
        .addr = A_POR_MXP_P1_SYSCOACK_STATUS_U_SMXP_0_0,
        .rsvd = 0xfffffffffffffff0L,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_PMU_EVENT_SEL_U_SMXP_0_0",
        .addr = A_POR_MXP_PMU_EVENT_SEL_U_SMXP_0_0,
        .ro = 0xffffffff00000000L,
    },{ .name = "POR_DTM_CONTROL_U_SMXP_0_0",
        .addr = A_POR_DTM_CONTROL_U_SMXP_0_0,
        .rsvd = 0xfffffffffffffff0L,
        .ro = 0xfffffffffffffff0L,
    },{ .name = "POR_DTM_FIFO_ENTRY_READY_U_SMXP_0_0",
        .addr = A_POR_DTM_FIFO_ENTRY_READY_U_SMXP_0_0,
        .rsvd = 0xfffffffffffffff0L,
        .ro = 0xfffffffffffffff0L,
    },{ .name = "POR_DTM_FIFO_ENTRY0_0_U_SMXP_0_0",
        .addr = A_POR_DTM_FIFO_ENTRY0_0_U_SMXP_0_0,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_DTM_FIFO_ENTRY0_1_U_SMXP_0_0",
        .addr = A_POR_DTM_FIFO_ENTRY0_1_U_SMXP_0_0,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_DTM_FIFO_ENTRY0_2_U_SMXP_0_0",
        .addr = A_POR_DTM_FIFO_ENTRY0_2_U_SMXP_0_0,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_DTM_FIFO_ENTRY1_0_U_SMXP_0_0",
        .addr = A_POR_DTM_FIFO_ENTRY1_0_U_SMXP_0_0,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_DTM_FIFO_ENTRY1_1_U_SMXP_0_0",
        .addr = A_POR_DTM_FIFO_ENTRY1_1_U_SMXP_0_0,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_DTM_FIFO_ENTRY1_2_U_SMXP_0_0",
        .addr = A_POR_DTM_FIFO_ENTRY1_2_U_SMXP_0_0,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_DTM_FIFO_ENTRY2_0_U_SMXP_0_0",
        .addr = A_POR_DTM_FIFO_ENTRY2_0_U_SMXP_0_0,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_DTM_FIFO_ENTRY2_1_U_SMXP_0_0",
        .addr = A_POR_DTM_FIFO_ENTRY2_1_U_SMXP_0_0,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_DTM_FIFO_ENTRY2_2_U_SMXP_0_0",
        .addr = A_POR_DTM_FIFO_ENTRY2_2_U_SMXP_0_0,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_DTM_FIFO_ENTRY3_0_U_SMXP_0_0",
        .addr = A_POR_DTM_FIFO_ENTRY3_0_U_SMXP_0_0,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_DTM_FIFO_ENTRY3_1_U_SMXP_0_0",
        .addr = A_POR_DTM_FIFO_ENTRY3_1_U_SMXP_0_0,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_DTM_FIFO_ENTRY3_2_U_SMXP_0_0",
        .addr = A_POR_DTM_FIFO_ENTRY3_2_U_SMXP_0_0,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_DTM_WP0_CONFIG_U_SMXP_0_0",
        .addr = A_POR_DTM_WP0_CONFIG_U_SMXP_0_0,
        .rsvd = 0x80,
        .ro = 0xffffffffffff8080L,
    },{ .name = "POR_DTM_WP0_VAL_U_SMXP_0_0",
        .addr = A_POR_DTM_WP0_VAL_U_SMXP_0_0,
    },{ .name = "POR_DTM_WP0_MASK_U_SMXP_0_0",
        .addr = A_POR_DTM_WP0_MASK_U_SMXP_0_0,
    },{ .name = "POR_DTM_WP1_CONFIG_U_SMXP_0_0",
        .addr = A_POR_DTM_WP1_CONFIG_U_SMXP_0_0,
        .rsvd = 0xc0,
        .ro = 0xffffffffffff80c0L,
    },{ .name = "POR_DTM_WP1_VAL_U_SMXP_0_0",
        .addr = A_POR_DTM_WP1_VAL_U_SMXP_0_0,
    },{ .name = "POR_DTM_WP1_MASK_U_SMXP_0_0",
        .addr = A_POR_DTM_WP1_MASK_U_SMXP_0_0,
    },{ .name = "POR_DTM_WP2_CONFIG_U_SMXP_0_0",
        .addr = A_POR_DTM_WP2_CONFIG_U_SMXP_0_0,
        .rsvd = 0x80,
        .ro = 0xffffffffffff8080L,
    },{ .name = "POR_DTM_WP2_VAL_U_SMXP_0_0",
        .addr = A_POR_DTM_WP2_VAL_U_SMXP_0_0,
    },{ .name = "POR_DTM_WP2_MASK_U_SMXP_0_0",
        .addr = A_POR_DTM_WP2_MASK_U_SMXP_0_0,
    },{ .name = "POR_DTM_WP3_CONFIG_U_SMXP_0_0",
        .addr = A_POR_DTM_WP3_CONFIG_U_SMXP_0_0,
        .rsvd = 0xc0,
        .ro = 0xffffffffffff80c0L,
    },{ .name = "POR_DTM_WP3_VAL_U_SMXP_0_0",
        .addr = A_POR_DTM_WP3_VAL_U_SMXP_0_0,
    },{ .name = "POR_DTM_WP3_MASK_U_SMXP_0_0",
        .addr = A_POR_DTM_WP3_MASK_U_SMXP_0_0,
    },{ .name = "POR_DTM_PMSICR_U_SMXP_0_0",
        .addr = A_POR_DTM_PMSICR_U_SMXP_0_0,
        .ro = 0xffffffff00000000L,
    },{ .name = "POR_DTM_PMSIRR_U_SMXP_0_0",
        .addr = A_POR_DTM_PMSIRR_U_SMXP_0_0,
        .ro = 0xffffffff000000ffL,
    },{ .name = "POR_DTM_PMU_CONFIG_U_SMXP_0_0",
        .addr = A_POR_DTM_PMU_CONFIG_U_SMXP_0_0,
        .ro = 0xc0c0c0c08888fe00L,
    },{ .name = "POR_DTM_PMEVCNT_U_SMXP_0_0",
        .addr = A_POR_DTM_PMEVCNT_U_SMXP_0_0,
    },{ .name = "POR_DTM_PMEVCNTSR_U_SMXP_0_0",
        .addr = A_POR_DTM_PMEVCNTSR_U_SMXP_0_0,
    },{ .name = "POR_MXP_ERRFR_U_SMXP_0_0",  .addr = A_POR_MXP_ERRFR_U_SMXP_0_0,
        .rsvd = 0x300,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_ERRCTLR_U_SMXP_0_0",
        .addr = A_POR_MXP_ERRCTLR_U_SMXP_0_0,
        .rsvd = 0xf0,
        .ro = 0xfffffffffffffef0L,
    },{ .name = "POR_MXP_ERRSTATUS_U_SMXP_0_0",
        .addr = A_POR_MXP_ERRSTATUS_U_SMXP_0_0,
        .ro = 0xffffffff127fffffL,
    },{ .name = "POR_MXP_ERRMISC_U_SMXP_0_0",
        .addr = A_POR_MXP_ERRMISC_U_SMXP_0_0,
        .rsvd = 0x8,
        .ro = 0xf800ffffffc08008L,
    },{ .name = "POR_MXP_P0_BYTE_PAR_ERR_INJ_U_SMXP_0_0",
        .addr = A_POR_MXP_P0_BYTE_PAR_ERR_INJ_U_SMXP_0_0,
        .rsvd = 0xffffffffffffffe0L,
        .ro = 0xffffffffffffffe0L,
    },{ .name = "POR_MXP_P1_BYTE_PAR_ERR_INJ_U_SMXP_0_0",
        .addr = A_POR_MXP_P1_BYTE_PAR_ERR_INJ_U_SMXP_0_0,
        .rsvd = 0xffffffffffffffe0L,
        .ro = 0xffffffffffffffe0L,
    },{ .name = "POR_MXP_ERRFR_NS_U_SMXP_0_0",
        .addr = A_POR_MXP_ERRFR_NS_U_SMXP_0_0,
        .rsvd = 0x300,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_ERRCTLR_NS_U_SMXP_0_0",
        .addr = A_POR_MXP_ERRCTLR_NS_U_SMXP_0_0,
        .rsvd = 0xf0,
        .ro = 0xfffffffffffffef0L,
    },{ .name = "POR_MXP_ERRSTATUS_NS_U_SMXP_0_0",
        .addr = A_POR_MXP_ERRSTATUS_NS_U_SMXP_0_0,
        .ro = 0xffffffff127fffffL,
    },{ .name = "POR_MXP_ERRMISC_NS_U_SMXP_0_0",
        .addr = A_POR_MXP_ERRMISC_NS_U_SMXP_0_0,
        .rsvd = 0x8,
        .ro = 0xf800ffffffc08008L,
    },{ .name = "POR_RNI_NODE_INFO_U_RNI_NID4",
        .addr = A_POR_RNI_NODE_INFO_U_RNI_NID4,
        .reset = 0x4000a,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_RNI_CHILD_INFO_U_RNI_NID4",
        .addr = A_POR_RNI_CHILD_INFO_U_RNI_NID4,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_RNI_UNIT_INFO_U_RNI_NID4",
        .addr = A_POR_RNI_UNIT_INFO_U_RNI_NID4,
        .reset = 0x8044020,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_RNI_SECURE_REGISTER_GROUPS_OVERRIDE_U_RNI_NID4",
        .addr = A_POR_RNI_SECURE_REGISTER_GROUPS_OVERRIDE_U_RNI_NID4,
        .rsvd = 0xfffffffffffffff8L,
        .ro = 0xfffffffffffffff8L,
    },{ .name = "POR_RNI_CFG_CTL_U_RNI_NID4",
        .addr = A_POR_RNI_CFG_CTL_U_RNI_NID4,
        .reset = 0x20401401,
        .rsvd = 0x80,
        .ro = 0xffffffff00008880L,
    },{ .name = "POR_RNI_AUX_CTL_U_RNI_NID4",
        .addr = A_POR_RNI_AUX_CTL_U_RNI_NID4,
        .reset = 0x22,
        .rsvd = 0xffffffffffffffc0L,
        .ro = 0xffffffffffffffc0L,
    },{ .name = "POR_RNI_S0_PORT_CONTROL_U_RNI_NID4",
        .addr = A_POR_RNI_S0_PORT_CONTROL_U_RNI_NID4,
        .ro = 0xfffffffffffff800L,
    },{ .name = "POR_RNI_S1_PORT_CONTROL_U_RNI_NID4",
        .addr = A_POR_RNI_S1_PORT_CONTROL_U_RNI_NID4,
        .ro = 0xfffffffffffff800L,
    },{ .name = "POR_RNI_S2_PORT_CONTROL_U_RNI_NID4",
        .addr = A_POR_RNI_S2_PORT_CONTROL_U_RNI_NID4,
        .ro = 0xfffffffffffff800L,
    },{ .name = "POR_RNI_S0_QOS_CONTROL_U_RNI_NID4",
        .addr = A_POR_RNI_S0_QOS_CONTROL_U_RNI_NID4,
        .rsvd = 0xff00,
        .ro = 0xffffffffff00ff00L,
    },{ .name = "POR_RNI_S0_QOS_LAT_TGT_U_RNI_NID4",
        .addr = A_POR_RNI_S0_QOS_LAT_TGT_U_RNI_NID4,
        .ro = 0xfffffffff000f000L,
    },{ .name = "POR_RNI_S0_QOS_LAT_SCALE_U_RNI_NID4",
        .addr = A_POR_RNI_S0_QOS_LAT_SCALE_U_RNI_NID4,
        .rsvd = 0xf8,
        .ro = 0xfffffffffffff8f8L,
    },{ .name = "POR_RNI_S0_QOS_LAT_RANGE_U_RNI_NID4",
        .addr = A_POR_RNI_S0_QOS_LAT_RANGE_U_RNI_NID4,
        .rsvd = 0xf0,
        .ro = 0xfffffffff0f0f0f0L,
    },{ .name = "POR_RNI_S1_QOS_CONTROL_U_RNI_NID4",
        .addr = A_POR_RNI_S1_QOS_CONTROL_U_RNI_NID4,
        .rsvd = 0xff00,
        .ro = 0xffffffffff00ff00L,
    },{ .name = "POR_RNI_S1_QOS_LAT_TGT_U_RNI_NID4",
        .addr = A_POR_RNI_S1_QOS_LAT_TGT_U_RNI_NID4,
        .ro = 0xfffffffff000f000L,
    },{ .name = "POR_RNI_S1_QOS_LAT_SCALE_U_RNI_NID4",
        .addr = A_POR_RNI_S1_QOS_LAT_SCALE_U_RNI_NID4,
        .rsvd = 0xf8,
        .ro = 0xfffffffffffff8f8L,
    },{ .name = "POR_RNI_S1_QOS_LAT_RANGE_U_RNI_NID4",
        .addr = A_POR_RNI_S1_QOS_LAT_RANGE_U_RNI_NID4,
        .rsvd = 0xf0,
        .ro = 0xfffffffff0f0f0f0L,
    },{ .name = "POR_RNI_S2_QOS_CONTROL_U_RNI_NID4",
        .addr = A_POR_RNI_S2_QOS_CONTROL_U_RNI_NID4,
        .rsvd = 0xff00,
        .ro = 0xffffffffff00ff00L,
    },{ .name = "POR_RNI_S2_QOS_LAT_TGT_U_RNI_NID4",
        .addr = A_POR_RNI_S2_QOS_LAT_TGT_U_RNI_NID4,
        .ro = 0xfffffffff000f000L,
    },{ .name = "POR_RNI_S2_QOS_LAT_SCALE_U_RNI_NID4",
        .addr = A_POR_RNI_S2_QOS_LAT_SCALE_U_RNI_NID4,
        .rsvd = 0xf8,
        .ro = 0xfffffffffffff8f8L,
    },{ .name = "POR_RNI_S2_QOS_LAT_RANGE_U_RNI_NID4",
        .addr = A_POR_RNI_S2_QOS_LAT_RANGE_U_RNI_NID4,
        .rsvd = 0xf0,
        .ro = 0xfffffffff0f0f0f0L,
    },{ .name = "POR_RNI_PMU_EVENT_SEL_U_RNI_NID4",
        .addr = A_POR_RNI_PMU_EVENT_SEL_U_RNI_NID4,
        .rsvd = 0xe0,
        .ro = 0xffffffffe0e0e0e0L,
    },{ .name = "POR_RNSAM_NODE_INFO_U_RNI_NID4",
        .addr = A_POR_RNSAM_NODE_INFO_U_RNI_NID4,
        .reset = 0x4000f,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_RNSAM_CHILD_INFO_U_RNI_NID4",
        .addr = A_POR_RNSAM_CHILD_INFO_U_RNI_NID4,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_RNSAM_UNIT_INFO_U_RNI_NID4",
        .addr = A_POR_RNSAM_UNIT_INFO_U_RNI_NID4,
        .reset = 0x800040004,
        .rsvd = 0xff00,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_RNSAM_SECURE_REGISTER_GROUPS_OVERRIDE_U_RNI_NID4",
        .addr = A_POR_RNSAM_SECURE_REGISTER_GROUPS_OVERRIDE_U_RNI_NID4,
        .rsvd = 0xfffffffffffffffeL,
        .ro = 0xfffffffffffffffeL,
    },{ .name = "RNSAM_STATUS_U_RNI_NID4",  .addr = A_RNSAM_STATUS_U_RNI_NID4,
        .reset = 0x1,
        .rsvd = 0xfffffffffffffffcL,
        .ro = 0xfffffffffffffffcL,
    },{ .name = "NON_HASH_MEM_REGION_REG0_U_RNI_NID4",
        .addr = A_NON_HASH_MEM_REGION_REG0_U_RNI_NID4,
        .rsvd = 0x2,
        .ro = 0x8000000280000002L,
    },{ .name = "NON_HASH_MEM_REGION_REG1_U_RNI_NID4",
        .addr = A_NON_HASH_MEM_REGION_REG1_U_RNI_NID4,
        .rsvd = 0x2,
        .ro = 0x8000000280000002L,
    },{ .name = "NON_HASH_MEM_REGION_REG2_U_RNI_NID4",
        .addr = A_NON_HASH_MEM_REGION_REG2_U_RNI_NID4,
        .rsvd = 0x2,
        .ro = 0x8000000280000002L,
    },{ .name = "NON_HASH_MEM_REGION_REG3_U_RNI_NID4",
        .addr = A_NON_HASH_MEM_REGION_REG3_U_RNI_NID4,
        .rsvd = 0x2,
        .ro = 0x8000000280000002L,
    },{ .name = "NON_HASH_TGT_NODEID0_U_RNI_NID4",
        .addr = A_NON_HASH_TGT_NODEID0_U_RNI_NID4,
        .ro = 0xffff800800800800L,
    },{ .name = "NON_HASH_TGT_NODEID1_U_RNI_NID4",
        .addr = A_NON_HASH_TGT_NODEID1_U_RNI_NID4,
        .ro = 0xffff800800800800L,
    },{ .name = "NON_HASH_TGT_NODEID2_U_RNI_NID4",
        .addr = A_NON_HASH_TGT_NODEID2_U_RNI_NID4,
        .ro = 0xffffffffff800800L,
    },{ .name = "SYS_CACHE_GRP_REGION0_U_RNI_NID4",
        .addr = A_SYS_CACHE_GRP_REGION0_U_RNI_NID4,
        .rsvd = 0x2,
        .ro = 0x8000000080000002L,
    },{ .name = "SYS_CACHE_GRP_REGION1_U_RNI_NID4",
        .addr = A_SYS_CACHE_GRP_REGION1_U_RNI_NID4,
        .ro = 0x8000000080000000L,
    },{ .name = "SYS_CACHE_GRP_HN_NODEID_REG0_U_RNI_NID4",
        .addr = A_SYS_CACHE_GRP_HN_NODEID_REG0_U_RNI_NID4,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_HN_NODEID_REG1_U_RNI_NID4",
        .addr = A_SYS_CACHE_GRP_HN_NODEID_REG1_U_RNI_NID4,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_HN_NODEID_REG2_U_RNI_NID4",
        .addr = A_SYS_CACHE_GRP_HN_NODEID_REG2_U_RNI_NID4,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_HN_NODEID_REG3_U_RNI_NID4",
        .addr = A_SYS_CACHE_GRP_HN_NODEID_REG3_U_RNI_NID4,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_HN_NODEID_REG4_U_RNI_NID4",
        .addr = A_SYS_CACHE_GRP_HN_NODEID_REG4_U_RNI_NID4,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_HN_NODEID_REG5_U_RNI_NID4",
        .addr = A_SYS_CACHE_GRP_HN_NODEID_REG5_U_RNI_NID4,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_HN_NODEID_REG6_U_RNI_NID4",
        .addr = A_SYS_CACHE_GRP_HN_NODEID_REG6_U_RNI_NID4,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_HN_NODEID_REG7_U_RNI_NID4",
        .addr = A_SYS_CACHE_GRP_HN_NODEID_REG7_U_RNI_NID4,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_NONHASH_NODEID_U_RNI_NID4",
        .addr = A_SYS_CACHE_GRP_NONHASH_NODEID_U_RNI_NID4,
        .ro = 0xfffffff800800800L,
    },{ .name = "SYS_CACHE_GROUP_HN_COUNT_U_RNI_NID4",
        .addr = A_SYS_CACHE_GROUP_HN_COUNT_U_RNI_NID4,
        .rsvd = 0x80,
        .ro = 0xffffffff80808080L,
    },{ .name = "SYS_CACHE_GRP_SN_NODEID_REG0_U_RNI_NID4",
        .addr = A_SYS_CACHE_GRP_SN_NODEID_REG0_U_RNI_NID4,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_SN_NODEID_REG1_U_RNI_NID4",
        .addr = A_SYS_CACHE_GRP_SN_NODEID_REG1_U_RNI_NID4,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_SN_NODEID_REG2_U_RNI_NID4",
        .addr = A_SYS_CACHE_GRP_SN_NODEID_REG2_U_RNI_NID4,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_SN_NODEID_REG3_U_RNI_NID4",
        .addr = A_SYS_CACHE_GRP_SN_NODEID_REG3_U_RNI_NID4,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_SN_NODEID_REG4_U_RNI_NID4",
        .addr = A_SYS_CACHE_GRP_SN_NODEID_REG4_U_RNI_NID4,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_SN_NODEID_REG5_U_RNI_NID4",
        .addr = A_SYS_CACHE_GRP_SN_NODEID_REG5_U_RNI_NID4,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_SN_NODEID_REG6_U_RNI_NID4",
        .addr = A_SYS_CACHE_GRP_SN_NODEID_REG6_U_RNI_NID4,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_SN_NODEID_REG7_U_RNI_NID4",
        .addr = A_SYS_CACHE_GRP_SN_NODEID_REG7_U_RNI_NID4,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_SN_SAM_CFG0_U_RNI_NID4",
        .addr = A_SYS_CACHE_GRP_SN_SAM_CFG0_U_RNI_NID4,
        .rsvd = 0xc0,
        .ro = 0xffffc0c0c0c0c0c0L,
    },{ .name = "SYS_CACHE_GRP_SN_SAM_CFG1_U_RNI_NID4",
        .addr = A_SYS_CACHE_GRP_SN_SAM_CFG1_U_RNI_NID4,
        .rsvd = 0xc0,
        .ro = 0xffffc0c0c0c0c0c0L,
    },{ .name = "GIC_MEM_REGION_REG_U_RNI_NID4",
        .addr = A_GIC_MEM_REGION_REG_U_RNI_NID4,
        .rsvd = 0xff82,
        .ro = 0x800f00000000ff82L,
    },{ .name = "SYS_CACHE_GRP_SN_ATTR_U_RNI_NID4",
        .addr = A_SYS_CACHE_GRP_SN_ATTR_U_RNI_NID4,
        .rsvd = 0xffce,
        .ro = 0xffceffceffceffceL,
    },{ .name = "SYS_CACHE_GRP_HN_CPA_EN_REG_U_RNI_NID4",
        .addr = A_SYS_CACHE_GRP_HN_CPA_EN_REG_U_RNI_NID4,
    },{ .name = "SYS_CACHE_GRP_HN_CPA_GRP_REG_U_RNI_NID4",
        .addr = A_SYS_CACHE_GRP_HN_CPA_GRP_REG_U_RNI_NID4,
        .rsvd = 0xfffc,
        .ro = 0xfffcfffcfffcfffcL,
    },{ .name = "CML_PORT_AGGR_MODE_CTRL_REG_U_RNI_NID4",
        .addr = A_CML_PORT_AGGR_MODE_CTRL_REG_U_RNI_NID4,
        .rsvd = 0x88,
        .ro = 0xffffffff28888888L,
    },{ .name = "CML_PORT_AGGR_GRP0_ADD_MASK_U_RNI_NID4",
        .addr = A_CML_PORT_AGGR_GRP0_ADD_MASK_U_RNI_NID4,
        .reset = 0x40,
        .ro = 0xffff00000000003fL,
    },{ .name = "CML_PORT_AGGR_GRP1_ADD_MASK_U_RNI_NID4",
        .addr = A_CML_PORT_AGGR_GRP1_ADD_MASK_U_RNI_NID4,
        .reset = 0x40,
        .ro = 0xffff00000000003fL,
    },{ .name = "CML_PORT_AGGR_GRP0_REG_U_RNI_NID4",
        .addr = A_CML_PORT_AGGR_GRP0_REG_U_RNI_NID4,
        .ro = 0xfffc800800800800L,
    },{ .name = "CML_PORT_AGGR_GRP1_REG_U_RNI_NID4",
        .addr = A_CML_PORT_AGGR_GRP1_REG_U_RNI_NID4,
        .ro = 0xfffc800800800800L,
    },{ .name = "SYS_CACHE_GRP_SECONDARY_REG0_U_RNI_NID4",
        .addr = A_SYS_CACHE_GRP_SECONDARY_REG0_U_RNI_NID4,
        .rsvd = 0x2,
        .ro = 0x8000000280000002L,
    },{ .name = "SYS_CACHE_GRP_SECONDARY_REG1_U_RNI_NID4",
        .addr = A_SYS_CACHE_GRP_SECONDARY_REG1_U_RNI_NID4,
        .rsvd = 0x2,
        .ro = 0x8000000280000002L,
    },{ .name = "SYS_CACHE_GRP_CAL_MODE_REG_U_RNI_NID4",
        .addr = A_SYS_CACHE_GRP_CAL_MODE_REG_U_RNI_NID4,
        .rsvd = 0xfffe,
        .ro = 0xfffefffefffefffeL,
    },{ .name = "RNSAM_HASH_ADDR_MASK_REG_U_RNI_NID4",
        .addr = A_RNSAM_HASH_ADDR_MASK_REG_U_RNI_NID4,
        .reset = 0xffffffffffc0,
        .ro = 0xffff00000000003fL,
    },{ .name = "RNSAM_REGION_CMP_ADDR_MASK_REG_U_RNI_NID4",
        .addr = A_RNSAM_REGION_CMP_ADDR_MASK_REG_U_RNI_NID4,
        .reset = 0xffffffff0000,
        .ro = 0xffff00000000ffffL,
    },{ .name = "SYS_CACHE_GRP_HN_NODEID_REG8_U_RNI_NID4",
        .addr = A_SYS_CACHE_GRP_HN_NODEID_REG8_U_RNI_NID4,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_HN_NODEID_REG9_U_RNI_NID4",
        .addr = A_SYS_CACHE_GRP_HN_NODEID_REG9_U_RNI_NID4,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_HN_NODEID_REG10_U_RNI_NID4",
        .addr = A_SYS_CACHE_GRP_HN_NODEID_REG10_U_RNI_NID4,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_HN_NODEID_REG11_U_RNI_NID4",
        .addr = A_SYS_CACHE_GRP_HN_NODEID_REG11_U_RNI_NID4,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_HN_NODEID_REG12_U_RNI_NID4",
        .addr = A_SYS_CACHE_GRP_HN_NODEID_REG12_U_RNI_NID4,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_HN_NODEID_REG13_U_RNI_NID4",
        .addr = A_SYS_CACHE_GRP_HN_NODEID_REG13_U_RNI_NID4,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_HN_NODEID_REG14_U_RNI_NID4",
        .addr = A_SYS_CACHE_GRP_HN_NODEID_REG14_U_RNI_NID4,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_HN_NODEID_REG15_U_RNI_NID4",
        .addr = A_SYS_CACHE_GRP_HN_NODEID_REG15_U_RNI_NID4,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_SN_NODEID_REG8_U_RNI_NID4",
        .addr = A_SYS_CACHE_GRP_SN_NODEID_REG8_U_RNI_NID4,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_SN_NODEID_REG9_U_RNI_NID4",
        .addr = A_SYS_CACHE_GRP_SN_NODEID_REG9_U_RNI_NID4,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_SN_NODEID_REG10_U_RNI_NID4",
        .addr = A_SYS_CACHE_GRP_SN_NODEID_REG10_U_RNI_NID4,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_SN_NODEID_REG11_U_RNI_NID4",
        .addr = A_SYS_CACHE_GRP_SN_NODEID_REG11_U_RNI_NID4,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_SN_NODEID_REG12_U_RNI_NID4",
        .addr = A_SYS_CACHE_GRP_SN_NODEID_REG12_U_RNI_NID4,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_SN_NODEID_REG13_U_RNI_NID4",
        .addr = A_SYS_CACHE_GRP_SN_NODEID_REG13_U_RNI_NID4,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_SN_NODEID_REG14_U_RNI_NID4",
        .addr = A_SYS_CACHE_GRP_SN_NODEID_REG14_U_RNI_NID4,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_SN_NODEID_REG15_U_RNI_NID4",
        .addr = A_SYS_CACHE_GRP_SN_NODEID_REG15_U_RNI_NID4,
        .ro = 0xffff800800800800L,
    },{ .name = "POR_FDC_NODE_INFO_U_SMXP_0_0",
        .addr = A_POR_FDC_NODE_INFO_U_SMXP_0_0,
        .reset = 0x201,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_FDC_CHILD_INFO_U_SMXP_0_0",
        .addr = A_POR_FDC_CHILD_INFO_U_SMXP_0_0,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_ERRFR_MXP_U_SMXP_0_0",  .addr = A_POR_ERRFR_MXP_U_SMXP_0_0,
        .reset = 0xa1,
        .rsvd = 0xffffffffffffff0cL,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_ERRCTLR_MXP_U_SMXP_0_0",
        .addr = A_POR_ERRCTLR_MXP_U_SMXP_0_0,
        .reset = 0xd,
        .rsvd = 0x3ff2,
        .ro = 0xffffffff00003ff2L,
    },{ .name = "POR_ERRSTATUS_MXP_U_SMXP_0_0",
        .addr = A_POR_ERRSTATUS_MXP_U_SMXP_0_0,
        .ro = 0xffffffff977f003fL,
    },{ .name = "POR_FDC_AUX_CTL_MXP_U_SMXP_0_0",
        .addr = A_POR_FDC_AUX_CTL_MXP_U_SMXP_0_0,
        .rsvd = 0xffffffffffffffe0L,
        .ro = 0xffffffffffffffefL,
    },{ .name = "POR_ERRFR_P0_D0_U_SMXP_0_0",
        .addr = A_POR_ERRFR_P0_D0_U_SMXP_0_0,
        .reset = 0xa1,
        .rsvd = 0xffffffffffffff0cL,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_ERRCTLR_P0_D0_U_SMXP_0_0",
        .addr = A_POR_ERRCTLR_P0_D0_U_SMXP_0_0,
        .reset = 0xd,
        .rsvd = 0x3ff2,
        .ro = 0xffffffff00003ff2L,
    },{ .name = "POR_ERRSTATUS_P0_D0_U_SMXP_0_0",
        .addr = A_POR_ERRSTATUS_P0_D0_U_SMXP_0_0,
        .ro = 0xffffffff977f003fL,
    },{ .name = "POR_FDC_AUX_CTL_P0_D0_U_SMXP_0_0",
        .addr = A_POR_FDC_AUX_CTL_P0_D0_U_SMXP_0_0,
        .rsvd = 0xffffffffffffffe0L,
        .ro = 0xffffffffffffffe0L,
    },{ .name = "POR_ERRFR_P0_D1_U_SMXP_0_0",
        .addr = A_POR_ERRFR_P0_D1_U_SMXP_0_0,
        .reset = 0xa1,
        .rsvd = 0xffffffffffffff0cL,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_ERRCTLR_P0_D1_U_SMXP_0_0",
        .addr = A_POR_ERRCTLR_P0_D1_U_SMXP_0_0,
        .reset = 0xd,
        .rsvd = 0x3ff2,
        .ro = 0xffffffff00003ff2L,
    },{ .name = "POR_ERRSTATUS_P0_D1_U_SMXP_0_0",
        .addr = A_POR_ERRSTATUS_P0_D1_U_SMXP_0_0,
        .ro = 0xffffffff977f003fL,
    },{ .name = "POR_FDC_AUX_CTL_P0_D1_U_SMXP_0_0",
        .addr = A_POR_FDC_AUX_CTL_P0_D1_U_SMXP_0_0,
        .rsvd = 0xffffffffffffffe0L,
        .ro = 0xffffffffffffffe0L,
    },{ .name = "POR_ERRFR_P0_D2_U_SMXP_0_0",
        .addr = A_POR_ERRFR_P0_D2_U_SMXP_0_0,
        .reset = 0xa1,
        .rsvd = 0xffffffffffffff0cL,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_ERRCTLR_P0_D2_U_SMXP_0_0",
        .addr = A_POR_ERRCTLR_P0_D2_U_SMXP_0_0,
        .reset = 0xd,
        .rsvd = 0x3ff2,
        .ro = 0xffffffff00003ff2L,
    },{ .name = "POR_ERRSTATUS_P0_D2_U_SMXP_0_0",
        .addr = A_POR_ERRSTATUS_P0_D2_U_SMXP_0_0,
        .ro = 0xffffffff977f003fL,
    },{ .name = "POR_FDC_AUX_CTL_P0_D2_U_SMXP_0_0",
        .addr = A_POR_FDC_AUX_CTL_P0_D2_U_SMXP_0_0,
        .rsvd = 0xffffffffffffffe0L,
        .ro = 0xffffffffffffffe0L,
    },{ .name = "POR_ERRFR_P0_D3_U_SMXP_0_0",
        .addr = A_POR_ERRFR_P0_D3_U_SMXP_0_0,
        .reset = 0xa1,
        .rsvd = 0xffffffffffffff0cL,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_ERRCTLR_P0_D3_U_SMXP_0_0",
        .addr = A_POR_ERRCTLR_P0_D3_U_SMXP_0_0,
        .reset = 0xd,
        .rsvd = 0x3ff2,
        .ro = 0xffffffff00003ff2L,
    },{ .name = "POR_ERRSTATUS_P0_D3_U_SMXP_0_0",
        .addr = A_POR_ERRSTATUS_P0_D3_U_SMXP_0_0,
        .ro = 0xffffffff977f003fL,
    },{ .name = "POR_FDC_AUX_CTL_P0_D3_U_SMXP_0_0",
        .addr = A_POR_FDC_AUX_CTL_P0_D3_U_SMXP_0_0,
        .rsvd = 0xffffffffffffffe0L,
        .ro = 0xffffffffffffffe0L,
    },{ .name = "POR_ERRFR_P1_D0_U_SMXP_0_0",
        .addr = A_POR_ERRFR_P1_D0_U_SMXP_0_0,
        .reset = 0xa1,
        .rsvd = 0xffffffffffffff0cL,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_ERRCTLR_P1_D0_U_SMXP_0_0",
        .addr = A_POR_ERRCTLR_P1_D0_U_SMXP_0_0,
        .reset = 0xd,
        .rsvd = 0x3ff2,
        .ro = 0xffffffff00003ff2L,
    },{ .name = "POR_ERRSTATUS_P1_D0_U_SMXP_0_0",
        .addr = A_POR_ERRSTATUS_P1_D0_U_SMXP_0_0,
        .ro = 0xffffffff977f003fL,
    },{ .name = "POR_FDC_AUX_CTL_P1_D0_U_SMXP_0_0",
        .addr = A_POR_FDC_AUX_CTL_P1_D0_U_SMXP_0_0,
        .rsvd = 0xffffffffffffffe0L,
        .ro = 0xffffffffffffffe0L,
    },{ .name = "POR_ERRFR_P1_D1_U_SMXP_0_0",
        .addr = A_POR_ERRFR_P1_D1_U_SMXP_0_0,
        .reset = 0xa1,
        .rsvd = 0xffffffffffffff0cL,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_ERRCTLR_P1_D1_U_SMXP_0_0",
        .addr = A_POR_ERRCTLR_P1_D1_U_SMXP_0_0,
        .reset = 0xd,
        .rsvd = 0x3ff2,
        .ro = 0xffffffff00003ff2L,
    },{ .name = "POR_ERRSTATUS_P1_D1_U_SMXP_0_0",
        .addr = A_POR_ERRSTATUS_P1_D1_U_SMXP_0_0,
        .ro = 0xffffffff977f003fL,
    },{ .name = "POR_FDC_AUX_CTL_P1_D1_U_SMXP_0_0",
        .addr = A_POR_FDC_AUX_CTL_P1_D1_U_SMXP_0_0,
        .rsvd = 0xffffffffffffffe0L,
        .ro = 0xffffffffffffffe0L,
    },{ .name = "POR_ERRFR_P1_D2_U_SMXP_0_0",
        .addr = A_POR_ERRFR_P1_D2_U_SMXP_0_0,
        .reset = 0xa1,
        .rsvd = 0xffffffffffffff0cL,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_ERRCTLR_P1_D2_U_SMXP_0_0",
        .addr = A_POR_ERRCTLR_P1_D2_U_SMXP_0_0,
        .reset = 0xd,
        .rsvd = 0x3ff2,
        .ro = 0xffffffff00003ff2L,
    },{ .name = "POR_ERRSTATUS_P1_D2_U_SMXP_0_0",
        .addr = A_POR_ERRSTATUS_P1_D2_U_SMXP_0_0,
        .ro = 0xffffffff977f003fL,
    },{ .name = "POR_FDC_AUX_CTL_P1_D2_U_SMXP_0_0",
        .addr = A_POR_FDC_AUX_CTL_P1_D2_U_SMXP_0_0,
        .rsvd = 0xffffffffffffffe0L,
        .ro = 0xffffffffffffffe0L,
    },{ .name = "POR_ERRFR_P1_D3_U_SMXP_0_0",
        .addr = A_POR_ERRFR_P1_D3_U_SMXP_0_0,
        .reset = 0xa1,
        .rsvd = 0xffffffffffffff0cL,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_ERRCTLR_P1_D3_U_SMXP_0_0",
        .addr = A_POR_ERRCTLR_P1_D3_U_SMXP_0_0,
        .reset = 0xd,
        .rsvd = 0x3ff2,
        .ro = 0xffffffff00003ff2L,
    },{ .name = "POR_ERRSTATUS_P1_D3_U_SMXP_0_0",
        .addr = A_POR_ERRSTATUS_P1_D3_U_SMXP_0_0,
        .ro = 0xffffffff977f003fL,
    },{ .name = "POR_FDC_AUX_CTL_P1_D3_U_SMXP_0_0",
        .addr = A_POR_FDC_AUX_CTL_P1_D3_U_SMXP_0_0,
        .rsvd = 0xffffffffffffffe0L,
        .ro = 0xffffffffffffffe0L,
    },{ .name = "POR_ERRINJECT_U_SMXP_0_0",  .addr = A_POR_ERRINJECT_U_SMXP_0_0,
        .rsvd = 0xffffffffffffff00L,
        .ro = 0xffffffffffffff00L,
    },{ .name = "POR_FDC_KEY_U_SMXP_0_0",  .addr = A_POR_FDC_KEY_U_SMXP_0_0,
        .reset = 0xbe,
        .rsvd = 0xffffffffffffff00L,
        .ro = 0xffffffffffffff00L,
    },{ .name = "POR_MPU_NODE_INFO_U_RNI_NID4",
        .addr = A_POR_MPU_NODE_INFO_U_RNI_NID4,
        .reset = 0x202,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MPU_CHILD_INFO_U_RNI_NID4",
        .addr = A_POR_MPU_CHILD_INFO_U_RNI_NID4,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MPU_UNIT_INFO_U_RNI_NID4",
        .addr = A_POR_MPU_UNIT_INFO_U_RNI_NID4,
        .reset = 0x20,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MPU_M0_CTL_U_RNI_NID4",
        .addr = A_POR_MPU_M0_CTL_U_RNI_NID4,
        .reset = 0x2,
        .rsvd = 0xfffffffffffffff8L,
        .ro = 0xfffffffffffffff8L,
    },{ .name = "POR_MPU_M0_PRBAR0_U_RNI_NID4",
        .addr = A_POR_MPU_M0_PRBAR0_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR0_U_RNI_NID4",
        .addr = A_POR_MPU_M0_PRLAR0_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR1_U_RNI_NID4",
        .addr = A_POR_MPU_M0_PRBAR1_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR1_U_RNI_NID4",
        .addr = A_POR_MPU_M0_PRLAR1_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR2_U_RNI_NID4",
        .addr = A_POR_MPU_M0_PRBAR2_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR2_U_RNI_NID4",
        .addr = A_POR_MPU_M0_PRLAR2_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR3_U_RNI_NID4",
        .addr = A_POR_MPU_M0_PRBAR3_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR3_U_RNI_NID4",
        .addr = A_POR_MPU_M0_PRLAR3_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR4_U_RNI_NID4",
        .addr = A_POR_MPU_M0_PRBAR4_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR4_U_RNI_NID4",
        .addr = A_POR_MPU_M0_PRLAR4_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR5_U_RNI_NID4",
        .addr = A_POR_MPU_M0_PRBAR5_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR5_U_RNI_NID4",
        .addr = A_POR_MPU_M0_PRLAR5_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR6_U_RNI_NID4",
        .addr = A_POR_MPU_M0_PRBAR6_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR6_U_RNI_NID4",
        .addr = A_POR_MPU_M0_PRLAR6_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR7_U_RNI_NID4",
        .addr = A_POR_MPU_M0_PRBAR7_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR7_U_RNI_NID4",
        .addr = A_POR_MPU_M0_PRLAR7_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR8_U_RNI_NID4",
        .addr = A_POR_MPU_M0_PRBAR8_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR8_U_RNI_NID4",
        .addr = A_POR_MPU_M0_PRLAR8_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR9_U_RNI_NID4",
        .addr = A_POR_MPU_M0_PRBAR9_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR9_U_RNI_NID4",
        .addr = A_POR_MPU_M0_PRLAR9_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR10_U_RNI_NID4",
        .addr = A_POR_MPU_M0_PRBAR10_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR10_U_RNI_NID4",
        .addr = A_POR_MPU_M0_PRLAR10_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR11_U_RNI_NID4",
        .addr = A_POR_MPU_M0_PRBAR11_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR11_U_RNI_NID4",
        .addr = A_POR_MPU_M0_PRLAR11_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR12_U_RNI_NID4",
        .addr = A_POR_MPU_M0_PRBAR12_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR12_U_RNI_NID4",
        .addr = A_POR_MPU_M0_PRLAR12_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR13_U_RNI_NID4",
        .addr = A_POR_MPU_M0_PRBAR13_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR13_U_RNI_NID4",
        .addr = A_POR_MPU_M0_PRLAR13_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR14_U_RNI_NID4",
        .addr = A_POR_MPU_M0_PRBAR14_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR14_U_RNI_NID4",
        .addr = A_POR_MPU_M0_PRLAR14_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR15_U_RNI_NID4",
        .addr = A_POR_MPU_M0_PRBAR15_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR15_U_RNI_NID4",
        .addr = A_POR_MPU_M0_PRLAR15_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR16_U_RNI_NID4",
        .addr = A_POR_MPU_M0_PRBAR16_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR16_U_RNI_NID4",
        .addr = A_POR_MPU_M0_PRLAR16_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR17_U_RNI_NID4",
        .addr = A_POR_MPU_M0_PRBAR17_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR17_U_RNI_NID4",
        .addr = A_POR_MPU_M0_PRLAR17_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR18_U_RNI_NID4",
        .addr = A_POR_MPU_M0_PRBAR18_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR18_U_RNI_NID4",
        .addr = A_POR_MPU_M0_PRLAR18_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR19_U_RNI_NID4",
        .addr = A_POR_MPU_M0_PRBAR19_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR19_U_RNI_NID4",
        .addr = A_POR_MPU_M0_PRLAR19_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR20_U_RNI_NID4",
        .addr = A_POR_MPU_M0_PRBAR20_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR20_U_RNI_NID4",
        .addr = A_POR_MPU_M0_PRLAR20_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR21_U_RNI_NID4",
        .addr = A_POR_MPU_M0_PRBAR21_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR21_U_RNI_NID4",
        .addr = A_POR_MPU_M0_PRLAR21_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR22_U_RNI_NID4",
        .addr = A_POR_MPU_M0_PRBAR22_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR22_U_RNI_NID4",
        .addr = A_POR_MPU_M0_PRLAR22_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR23_U_RNI_NID4",
        .addr = A_POR_MPU_M0_PRBAR23_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR23_U_RNI_NID4",
        .addr = A_POR_MPU_M0_PRLAR23_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR24_U_RNI_NID4",
        .addr = A_POR_MPU_M0_PRBAR24_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR24_U_RNI_NID4",
        .addr = A_POR_MPU_M0_PRLAR24_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR25_U_RNI_NID4",
        .addr = A_POR_MPU_M0_PRBAR25_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR25_U_RNI_NID4",
        .addr = A_POR_MPU_M0_PRLAR25_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR26_U_RNI_NID4",
        .addr = A_POR_MPU_M0_PRBAR26_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR26_U_RNI_NID4",
        .addr = A_POR_MPU_M0_PRLAR26_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR27_U_RNI_NID4",
        .addr = A_POR_MPU_M0_PRBAR27_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR27_U_RNI_NID4",
        .addr = A_POR_MPU_M0_PRLAR27_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR28_U_RNI_NID4",
        .addr = A_POR_MPU_M0_PRBAR28_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR28_U_RNI_NID4",
        .addr = A_POR_MPU_M0_PRLAR28_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR29_U_RNI_NID4",
        .addr = A_POR_MPU_M0_PRBAR29_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR29_U_RNI_NID4",
        .addr = A_POR_MPU_M0_PRLAR29_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR30_U_RNI_NID4",
        .addr = A_POR_MPU_M0_PRBAR30_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR30_U_RNI_NID4",
        .addr = A_POR_MPU_M0_PRLAR30_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR31_U_RNI_NID4",
        .addr = A_POR_MPU_M0_PRBAR31_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR31_U_RNI_NID4",
        .addr = A_POR_MPU_M0_PRLAR31_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_CTL_U_RNI_NID4",
        .addr = A_POR_MPU_M1_CTL_U_RNI_NID4,
        .reset = 0x2,
        .rsvd = 0xfffffffffffffff8L,
        .ro = 0xfffffffffffffff8L,
    },{ .name = "POR_MPU_M1_PRBAR0_U_RNI_NID4",
        .addr = A_POR_MPU_M1_PRBAR0_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR0_U_RNI_NID4",
        .addr = A_POR_MPU_M1_PRLAR0_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR1_U_RNI_NID4",
        .addr = A_POR_MPU_M1_PRBAR1_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR1_U_RNI_NID4",
        .addr = A_POR_MPU_M1_PRLAR1_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR2_U_RNI_NID4",
        .addr = A_POR_MPU_M1_PRBAR2_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR2_U_RNI_NID4",
        .addr = A_POR_MPU_M1_PRLAR2_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR3_U_RNI_NID4",
        .addr = A_POR_MPU_M1_PRBAR3_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR3_U_RNI_NID4",
        .addr = A_POR_MPU_M1_PRLAR3_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR4_U_RNI_NID4",
        .addr = A_POR_MPU_M1_PRBAR4_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR4_U_RNI_NID4",
        .addr = A_POR_MPU_M1_PRLAR4_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR5_U_RNI_NID4",
        .addr = A_POR_MPU_M1_PRBAR5_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR5_U_RNI_NID4",
        .addr = A_POR_MPU_M1_PRLAR5_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR6_U_RNI_NID4",
        .addr = A_POR_MPU_M1_PRBAR6_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR6_U_RNI_NID4",
        .addr = A_POR_MPU_M1_PRLAR6_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR7_U_RNI_NID4",
        .addr = A_POR_MPU_M1_PRBAR7_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR7_U_RNI_NID4",
        .addr = A_POR_MPU_M1_PRLAR7_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR8_U_RNI_NID4",
        .addr = A_POR_MPU_M1_PRBAR8_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR8_U_RNI_NID4",
        .addr = A_POR_MPU_M1_PRLAR8_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR9_U_RNI_NID4",
        .addr = A_POR_MPU_M1_PRBAR9_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR9_U_RNI_NID4",
        .addr = A_POR_MPU_M1_PRLAR9_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR10_U_RNI_NID4",
        .addr = A_POR_MPU_M1_PRBAR10_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR10_U_RNI_NID4",
        .addr = A_POR_MPU_M1_PRLAR10_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR11_U_RNI_NID4",
        .addr = A_POR_MPU_M1_PRBAR11_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR11_U_RNI_NID4",
        .addr = A_POR_MPU_M1_PRLAR11_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR12_U_RNI_NID4",
        .addr = A_POR_MPU_M1_PRBAR12_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR12_U_RNI_NID4",
        .addr = A_POR_MPU_M1_PRLAR12_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR13_U_RNI_NID4",
        .addr = A_POR_MPU_M1_PRBAR13_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR13_U_RNI_NID4",
        .addr = A_POR_MPU_M1_PRLAR13_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR14_U_RNI_NID4",
        .addr = A_POR_MPU_M1_PRBAR14_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR14_U_RNI_NID4",
        .addr = A_POR_MPU_M1_PRLAR14_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR15_U_RNI_NID4",
        .addr = A_POR_MPU_M1_PRBAR15_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR15_U_RNI_NID4",
        .addr = A_POR_MPU_M1_PRLAR15_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR16_U_RNI_NID4",
        .addr = A_POR_MPU_M1_PRBAR16_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR16_U_RNI_NID4",
        .addr = A_POR_MPU_M1_PRLAR16_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR17_U_RNI_NID4",
        .addr = A_POR_MPU_M1_PRBAR17_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR17_U_RNI_NID4",
        .addr = A_POR_MPU_M1_PRLAR17_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR18_U_RNI_NID4",
        .addr = A_POR_MPU_M1_PRBAR18_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR18_U_RNI_NID4",
        .addr = A_POR_MPU_M1_PRLAR18_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR19_U_RNI_NID4",
        .addr = A_POR_MPU_M1_PRBAR19_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR19_U_RNI_NID4",
        .addr = A_POR_MPU_M1_PRLAR19_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR20_U_RNI_NID4",
        .addr = A_POR_MPU_M1_PRBAR20_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR20_U_RNI_NID4",
        .addr = A_POR_MPU_M1_PRLAR20_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR21_U_RNI_NID4",
        .addr = A_POR_MPU_M1_PRBAR21_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR21_U_RNI_NID4",
        .addr = A_POR_MPU_M1_PRLAR21_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR22_U_RNI_NID4",
        .addr = A_POR_MPU_M1_PRBAR22_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR22_U_RNI_NID4",
        .addr = A_POR_MPU_M1_PRLAR22_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR23_U_RNI_NID4",
        .addr = A_POR_MPU_M1_PRBAR23_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR23_U_RNI_NID4",
        .addr = A_POR_MPU_M1_PRLAR23_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR24_U_RNI_NID4",
        .addr = A_POR_MPU_M1_PRBAR24_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR24_U_RNI_NID4",
        .addr = A_POR_MPU_M1_PRLAR24_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR25_U_RNI_NID4",
        .addr = A_POR_MPU_M1_PRBAR25_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR25_U_RNI_NID4",
        .addr = A_POR_MPU_M1_PRLAR25_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR26_U_RNI_NID4",
        .addr = A_POR_MPU_M1_PRBAR26_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR26_U_RNI_NID4",
        .addr = A_POR_MPU_M1_PRLAR26_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR27_U_RNI_NID4",
        .addr = A_POR_MPU_M1_PRBAR27_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR27_U_RNI_NID4",
        .addr = A_POR_MPU_M1_PRLAR27_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR28_U_RNI_NID4",
        .addr = A_POR_MPU_M1_PRBAR28_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR28_U_RNI_NID4",
        .addr = A_POR_MPU_M1_PRLAR28_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR29_U_RNI_NID4",
        .addr = A_POR_MPU_M1_PRBAR29_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR29_U_RNI_NID4",
        .addr = A_POR_MPU_M1_PRLAR29_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR30_U_RNI_NID4",
        .addr = A_POR_MPU_M1_PRBAR30_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR30_U_RNI_NID4",
        .addr = A_POR_MPU_M1_PRLAR30_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR31_U_RNI_NID4",
        .addr = A_POR_MPU_M1_PRBAR31_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR31_U_RNI_NID4",
        .addr = A_POR_MPU_M1_PRLAR31_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_CTL_U_RNI_NID4",
        .addr = A_POR_MPU_M2_CTL_U_RNI_NID4,
        .reset = 0x2,
        .rsvd = 0xfffffffffffffff8L,
        .ro = 0xfffffffffffffff8L,
    },{ .name = "POR_MPU_M2_PRBAR0_U_RNI_NID4",
        .addr = A_POR_MPU_M2_PRBAR0_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR0_U_RNI_NID4",
        .addr = A_POR_MPU_M2_PRLAR0_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR1_U_RNI_NID4",
        .addr = A_POR_MPU_M2_PRBAR1_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR1_U_RNI_NID4",
        .addr = A_POR_MPU_M2_PRLAR1_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR2_U_RNI_NID4",
        .addr = A_POR_MPU_M2_PRBAR2_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR2_U_RNI_NID4",
        .addr = A_POR_MPU_M2_PRLAR2_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR3_U_RNI_NID4",
        .addr = A_POR_MPU_M2_PRBAR3_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR3_U_RNI_NID4",
        .addr = A_POR_MPU_M2_PRLAR3_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR4_U_RNI_NID4",
        .addr = A_POR_MPU_M2_PRBAR4_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR4_U_RNI_NID4",
        .addr = A_POR_MPU_M2_PRLAR4_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR5_U_RNI_NID4",
        .addr = A_POR_MPU_M2_PRBAR5_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR5_U_RNI_NID4",
        .addr = A_POR_MPU_M2_PRLAR5_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR6_U_RNI_NID4",
        .addr = A_POR_MPU_M2_PRBAR6_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR6_U_RNI_NID4",
        .addr = A_POR_MPU_M2_PRLAR6_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR7_U_RNI_NID4",
        .addr = A_POR_MPU_M2_PRBAR7_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR7_U_RNI_NID4",
        .addr = A_POR_MPU_M2_PRLAR7_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR8_U_RNI_NID4",
        .addr = A_POR_MPU_M2_PRBAR8_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR8_U_RNI_NID4",
        .addr = A_POR_MPU_M2_PRLAR8_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR9_U_RNI_NID4",
        .addr = A_POR_MPU_M2_PRBAR9_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR9_U_RNI_NID4",
        .addr = A_POR_MPU_M2_PRLAR9_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR10_U_RNI_NID4",
        .addr = A_POR_MPU_M2_PRBAR10_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR10_U_RNI_NID4",
        .addr = A_POR_MPU_M2_PRLAR10_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR11_U_RNI_NID4",
        .addr = A_POR_MPU_M2_PRBAR11_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR11_U_RNI_NID4",
        .addr = A_POR_MPU_M2_PRLAR11_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR12_U_RNI_NID4",
        .addr = A_POR_MPU_M2_PRBAR12_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR12_U_RNI_NID4",
        .addr = A_POR_MPU_M2_PRLAR12_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR13_U_RNI_NID4",
        .addr = A_POR_MPU_M2_PRBAR13_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR13_U_RNI_NID4",
        .addr = A_POR_MPU_M2_PRLAR13_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR14_U_RNI_NID4",
        .addr = A_POR_MPU_M2_PRBAR14_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR14_U_RNI_NID4",
        .addr = A_POR_MPU_M2_PRLAR14_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR15_U_RNI_NID4",
        .addr = A_POR_MPU_M2_PRBAR15_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR15_U_RNI_NID4",
        .addr = A_POR_MPU_M2_PRLAR15_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR16_U_RNI_NID4",
        .addr = A_POR_MPU_M2_PRBAR16_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR16_U_RNI_NID4",
        .addr = A_POR_MPU_M2_PRLAR16_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR17_U_RNI_NID4",
        .addr = A_POR_MPU_M2_PRBAR17_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR17_U_RNI_NID4",
        .addr = A_POR_MPU_M2_PRLAR17_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR18_U_RNI_NID4",
        .addr = A_POR_MPU_M2_PRBAR18_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR18_U_RNI_NID4",
        .addr = A_POR_MPU_M2_PRLAR18_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR19_U_RNI_NID4",
        .addr = A_POR_MPU_M2_PRBAR19_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR19_U_RNI_NID4",
        .addr = A_POR_MPU_M2_PRLAR19_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR20_U_RNI_NID4",
        .addr = A_POR_MPU_M2_PRBAR20_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR20_U_RNI_NID4",
        .addr = A_POR_MPU_M2_PRLAR20_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR21_U_RNI_NID4",
        .addr = A_POR_MPU_M2_PRBAR21_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR21_U_RNI_NID4",
        .addr = A_POR_MPU_M2_PRLAR21_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR22_U_RNI_NID4",
        .addr = A_POR_MPU_M2_PRBAR22_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR22_U_RNI_NID4",
        .addr = A_POR_MPU_M2_PRLAR22_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR23_U_RNI_NID4",
        .addr = A_POR_MPU_M2_PRBAR23_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR23_U_RNI_NID4",
        .addr = A_POR_MPU_M2_PRLAR23_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR24_U_RNI_NID4",
        .addr = A_POR_MPU_M2_PRBAR24_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR24_U_RNI_NID4",
        .addr = A_POR_MPU_M2_PRLAR24_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR25_U_RNI_NID4",
        .addr = A_POR_MPU_M2_PRBAR25_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR25_U_RNI_NID4",
        .addr = A_POR_MPU_M2_PRLAR25_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR26_U_RNI_NID4",
        .addr = A_POR_MPU_M2_PRBAR26_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR26_U_RNI_NID4",
        .addr = A_POR_MPU_M2_PRLAR26_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR27_U_RNI_NID4",
        .addr = A_POR_MPU_M2_PRBAR27_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR27_U_RNI_NID4",
        .addr = A_POR_MPU_M2_PRLAR27_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR28_U_RNI_NID4",
        .addr = A_POR_MPU_M2_PRBAR28_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR28_U_RNI_NID4",
        .addr = A_POR_MPU_M2_PRLAR28_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR29_U_RNI_NID4",
        .addr = A_POR_MPU_M2_PRBAR29_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR29_U_RNI_NID4",
        .addr = A_POR_MPU_M2_PRLAR29_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR30_U_RNI_NID4",
        .addr = A_POR_MPU_M2_PRBAR30_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR30_U_RNI_NID4",
        .addr = A_POR_MPU_M2_PRLAR30_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR31_U_RNI_NID4",
        .addr = A_POR_MPU_M2_PRBAR31_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR31_U_RNI_NID4",
        .addr = A_POR_MPU_M2_PRLAR31_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_CTL_U_RNI_NID4",
        .addr = A_POR_MPU_M3_CTL_U_RNI_NID4,
        .reset = 0x2,
        .rsvd = 0xfffffffffffffff8L,
        .ro = 0xfffffffffffffff8L,
    },{ .name = "POR_MPU_M3_PRBAR0_U_RNI_NID4",
        .addr = A_POR_MPU_M3_PRBAR0_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR0_U_RNI_NID4",
        .addr = A_POR_MPU_M3_PRLAR0_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR1_U_RNI_NID4",
        .addr = A_POR_MPU_M3_PRBAR1_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR1_U_RNI_NID4",
        .addr = A_POR_MPU_M3_PRLAR1_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR2_U_RNI_NID4",
        .addr = A_POR_MPU_M3_PRBAR2_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR2_U_RNI_NID4",
        .addr = A_POR_MPU_M3_PRLAR2_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR3_U_RNI_NID4",
        .addr = A_POR_MPU_M3_PRBAR3_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR3_U_RNI_NID4",
        .addr = A_POR_MPU_M3_PRLAR3_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR4_U_RNI_NID4",
        .addr = A_POR_MPU_M3_PRBAR4_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR4_U_RNI_NID4",
        .addr = A_POR_MPU_M3_PRLAR4_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR5_U_RNI_NID4",
        .addr = A_POR_MPU_M3_PRBAR5_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR5_U_RNI_NID4",
        .addr = A_POR_MPU_M3_PRLAR5_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR6_U_RNI_NID4",
        .addr = A_POR_MPU_M3_PRBAR6_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR6_U_RNI_NID4",
        .addr = A_POR_MPU_M3_PRLAR6_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR7_U_RNI_NID4",
        .addr = A_POR_MPU_M3_PRBAR7_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR7_U_RNI_NID4",
        .addr = A_POR_MPU_M3_PRLAR7_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR8_U_RNI_NID4",
        .addr = A_POR_MPU_M3_PRBAR8_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR8_U_RNI_NID4",
        .addr = A_POR_MPU_M3_PRLAR8_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR9_U_RNI_NID4",
        .addr = A_POR_MPU_M3_PRBAR9_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR9_U_RNI_NID4",
        .addr = A_POR_MPU_M3_PRLAR9_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR10_U_RNI_NID4",
        .addr = A_POR_MPU_M3_PRBAR10_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR10_U_RNI_NID4",
        .addr = A_POR_MPU_M3_PRLAR10_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR11_U_RNI_NID4",
        .addr = A_POR_MPU_M3_PRBAR11_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR11_U_RNI_NID4",
        .addr = A_POR_MPU_M3_PRLAR11_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR12_U_RNI_NID4",
        .addr = A_POR_MPU_M3_PRBAR12_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR12_U_RNI_NID4",
        .addr = A_POR_MPU_M3_PRLAR12_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR13_U_RNI_NID4",
        .addr = A_POR_MPU_M3_PRBAR13_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR13_U_RNI_NID4",
        .addr = A_POR_MPU_M3_PRLAR13_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR14_U_RNI_NID4",
        .addr = A_POR_MPU_M3_PRBAR14_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR14_U_RNI_NID4",
        .addr = A_POR_MPU_M3_PRLAR14_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR15_U_RNI_NID4",
        .addr = A_POR_MPU_M3_PRBAR15_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR15_U_RNI_NID4",
        .addr = A_POR_MPU_M3_PRLAR15_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR16_U_RNI_NID4",
        .addr = A_POR_MPU_M3_PRBAR16_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR16_U_RNI_NID4",
        .addr = A_POR_MPU_M3_PRLAR16_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR17_U_RNI_NID4",
        .addr = A_POR_MPU_M3_PRBAR17_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR17_U_RNI_NID4",
        .addr = A_POR_MPU_M3_PRLAR17_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR18_U_RNI_NID4",
        .addr = A_POR_MPU_M3_PRBAR18_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR18_U_RNI_NID4",
        .addr = A_POR_MPU_M3_PRLAR18_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR19_U_RNI_NID4",
        .addr = A_POR_MPU_M3_PRBAR19_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR19_U_RNI_NID4",
        .addr = A_POR_MPU_M3_PRLAR19_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR20_U_RNI_NID4",
        .addr = A_POR_MPU_M3_PRBAR20_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR20_U_RNI_NID4",
        .addr = A_POR_MPU_M3_PRLAR20_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR21_U_RNI_NID4",
        .addr = A_POR_MPU_M3_PRBAR21_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR21_U_RNI_NID4",
        .addr = A_POR_MPU_M3_PRLAR21_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR22_U_RNI_NID4",
        .addr = A_POR_MPU_M3_PRBAR22_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR22_U_RNI_NID4",
        .addr = A_POR_MPU_M3_PRLAR22_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR23_U_RNI_NID4",
        .addr = A_POR_MPU_M3_PRBAR23_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR23_U_RNI_NID4",
        .addr = A_POR_MPU_M3_PRLAR23_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR24_U_RNI_NID4",
        .addr = A_POR_MPU_M3_PRBAR24_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR24_U_RNI_NID4",
        .addr = A_POR_MPU_M3_PRLAR24_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR25_U_RNI_NID4",
        .addr = A_POR_MPU_M3_PRBAR25_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR25_U_RNI_NID4",
        .addr = A_POR_MPU_M3_PRLAR25_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR26_U_RNI_NID4",
        .addr = A_POR_MPU_M3_PRBAR26_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR26_U_RNI_NID4",
        .addr = A_POR_MPU_M3_PRLAR26_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR27_U_RNI_NID4",
        .addr = A_POR_MPU_M3_PRBAR27_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR27_U_RNI_NID4",
        .addr = A_POR_MPU_M3_PRLAR27_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR28_U_RNI_NID4",
        .addr = A_POR_MPU_M3_PRBAR28_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR28_U_RNI_NID4",
        .addr = A_POR_MPU_M3_PRLAR28_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR29_U_RNI_NID4",
        .addr = A_POR_MPU_M3_PRBAR29_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR29_U_RNI_NID4",
        .addr = A_POR_MPU_M3_PRLAR29_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR30_U_RNI_NID4",
        .addr = A_POR_MPU_M3_PRBAR30_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR30_U_RNI_NID4",
        .addr = A_POR_MPU_M3_PRLAR30_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR31_U_RNI_NID4",
        .addr = A_POR_MPU_M3_PRBAR31_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR31_U_RNI_NID4",
        .addr = A_POR_MPU_M3_PRLAR31_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_CTL_U_RNI_NID4",
        .addr = A_POR_MPU_M4_CTL_U_RNI_NID4,
        .reset = 0x2,
        .rsvd = 0xfffffffffffffff8L,
        .ro = 0xfffffffffffffff8L,
    },{ .name = "POR_MPU_M4_PRBAR0_U_RNI_NID4",
        .addr = A_POR_MPU_M4_PRBAR0_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR0_U_RNI_NID4",
        .addr = A_POR_MPU_M4_PRLAR0_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR1_U_RNI_NID4",
        .addr = A_POR_MPU_M4_PRBAR1_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR1_U_RNI_NID4",
        .addr = A_POR_MPU_M4_PRLAR1_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR2_U_RNI_NID4",
        .addr = A_POR_MPU_M4_PRBAR2_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR2_U_RNI_NID4",
        .addr = A_POR_MPU_M4_PRLAR2_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR3_U_RNI_NID4",
        .addr = A_POR_MPU_M4_PRBAR3_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR3_U_RNI_NID4",
        .addr = A_POR_MPU_M4_PRLAR3_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR4_U_RNI_NID4",
        .addr = A_POR_MPU_M4_PRBAR4_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR4_U_RNI_NID4",
        .addr = A_POR_MPU_M4_PRLAR4_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR5_U_RNI_NID4",
        .addr = A_POR_MPU_M4_PRBAR5_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR5_U_RNI_NID4",
        .addr = A_POR_MPU_M4_PRLAR5_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR6_U_RNI_NID4",
        .addr = A_POR_MPU_M4_PRBAR6_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR6_U_RNI_NID4",
        .addr = A_POR_MPU_M4_PRLAR6_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR7_U_RNI_NID4",
        .addr = A_POR_MPU_M4_PRBAR7_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR7_U_RNI_NID4",
        .addr = A_POR_MPU_M4_PRLAR7_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR8_U_RNI_NID4",
        .addr = A_POR_MPU_M4_PRBAR8_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR8_U_RNI_NID4",
        .addr = A_POR_MPU_M4_PRLAR8_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR9_U_RNI_NID4",
        .addr = A_POR_MPU_M4_PRBAR9_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR9_U_RNI_NID4",
        .addr = A_POR_MPU_M4_PRLAR9_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR10_U_RNI_NID4",
        .addr = A_POR_MPU_M4_PRBAR10_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR10_U_RNI_NID4",
        .addr = A_POR_MPU_M4_PRLAR10_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR11_U_RNI_NID4",
        .addr = A_POR_MPU_M4_PRBAR11_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR11_U_RNI_NID4",
        .addr = A_POR_MPU_M4_PRLAR11_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR12_U_RNI_NID4",
        .addr = A_POR_MPU_M4_PRBAR12_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR12_U_RNI_NID4",
        .addr = A_POR_MPU_M4_PRLAR12_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR13_U_RNI_NID4",
        .addr = A_POR_MPU_M4_PRBAR13_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR13_U_RNI_NID4",
        .addr = A_POR_MPU_M4_PRLAR13_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR14_U_RNI_NID4",
        .addr = A_POR_MPU_M4_PRBAR14_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR14_U_RNI_NID4",
        .addr = A_POR_MPU_M4_PRLAR14_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR15_U_RNI_NID4",
        .addr = A_POR_MPU_M4_PRBAR15_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR15_U_RNI_NID4",
        .addr = A_POR_MPU_M4_PRLAR15_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR16_U_RNI_NID4",
        .addr = A_POR_MPU_M4_PRBAR16_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR16_U_RNI_NID4",
        .addr = A_POR_MPU_M4_PRLAR16_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR17_U_RNI_NID4",
        .addr = A_POR_MPU_M4_PRBAR17_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR17_U_RNI_NID4",
        .addr = A_POR_MPU_M4_PRLAR17_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR18_U_RNI_NID4",
        .addr = A_POR_MPU_M4_PRBAR18_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR18_U_RNI_NID4",
        .addr = A_POR_MPU_M4_PRLAR18_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR19_U_RNI_NID4",
        .addr = A_POR_MPU_M4_PRBAR19_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR19_U_RNI_NID4",
        .addr = A_POR_MPU_M4_PRLAR19_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR20_U_RNI_NID4",
        .addr = A_POR_MPU_M4_PRBAR20_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR20_U_RNI_NID4",
        .addr = A_POR_MPU_M4_PRLAR20_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR21_U_RNI_NID4",
        .addr = A_POR_MPU_M4_PRBAR21_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR21_U_RNI_NID4",
        .addr = A_POR_MPU_M4_PRLAR21_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR22_U_RNI_NID4",
        .addr = A_POR_MPU_M4_PRBAR22_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR22_U_RNI_NID4",
        .addr = A_POR_MPU_M4_PRLAR22_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR23_U_RNI_NID4",
        .addr = A_POR_MPU_M4_PRBAR23_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR23_U_RNI_NID4",
        .addr = A_POR_MPU_M4_PRLAR23_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR24_U_RNI_NID4",
        .addr = A_POR_MPU_M4_PRBAR24_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR24_U_RNI_NID4",
        .addr = A_POR_MPU_M4_PRLAR24_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR25_U_RNI_NID4",
        .addr = A_POR_MPU_M4_PRBAR25_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR25_U_RNI_NID4",
        .addr = A_POR_MPU_M4_PRLAR25_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR26_U_RNI_NID4",
        .addr = A_POR_MPU_M4_PRBAR26_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR26_U_RNI_NID4",
        .addr = A_POR_MPU_M4_PRLAR26_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR27_U_RNI_NID4",
        .addr = A_POR_MPU_M4_PRBAR27_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR27_U_RNI_NID4",
        .addr = A_POR_MPU_M4_PRLAR27_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR28_U_RNI_NID4",
        .addr = A_POR_MPU_M4_PRBAR28_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR28_U_RNI_NID4",
        .addr = A_POR_MPU_M4_PRLAR28_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR29_U_RNI_NID4",
        .addr = A_POR_MPU_M4_PRBAR29_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR29_U_RNI_NID4",
        .addr = A_POR_MPU_M4_PRLAR29_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR30_U_RNI_NID4",
        .addr = A_POR_MPU_M4_PRBAR30_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR30_U_RNI_NID4",
        .addr = A_POR_MPU_M4_PRLAR30_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR31_U_RNI_NID4",
        .addr = A_POR_MPU_M4_PRBAR31_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR31_U_RNI_NID4",
        .addr = A_POR_MPU_M4_PRLAR31_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_CTL_U_RNI_NID4",
        .addr = A_POR_MPU_M5_CTL_U_RNI_NID4,
        .reset = 0x2,
        .rsvd = 0xfffffffffffffff8L,
        .ro = 0xfffffffffffffff8L,
    },{ .name = "POR_MPU_M5_PRBAR0_U_RNI_NID4",
        .addr = A_POR_MPU_M5_PRBAR0_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR0_U_RNI_NID4",
        .addr = A_POR_MPU_M5_PRLAR0_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR1_U_RNI_NID4",
        .addr = A_POR_MPU_M5_PRBAR1_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR1_U_RNI_NID4",
        .addr = A_POR_MPU_M5_PRLAR1_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR2_U_RNI_NID4",
        .addr = A_POR_MPU_M5_PRBAR2_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR2_U_RNI_NID4",
        .addr = A_POR_MPU_M5_PRLAR2_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR3_U_RNI_NID4",
        .addr = A_POR_MPU_M5_PRBAR3_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR3_U_RNI_NID4",
        .addr = A_POR_MPU_M5_PRLAR3_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR4_U_RNI_NID4",
        .addr = A_POR_MPU_M5_PRBAR4_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR4_U_RNI_NID4",
        .addr = A_POR_MPU_M5_PRLAR4_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR5_U_RNI_NID4",
        .addr = A_POR_MPU_M5_PRBAR5_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR5_U_RNI_NID4",
        .addr = A_POR_MPU_M5_PRLAR5_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR6_U_RNI_NID4",
        .addr = A_POR_MPU_M5_PRBAR6_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR6_U_RNI_NID4",
        .addr = A_POR_MPU_M5_PRLAR6_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR7_U_RNI_NID4",
        .addr = A_POR_MPU_M5_PRBAR7_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR7_U_RNI_NID4",
        .addr = A_POR_MPU_M5_PRLAR7_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR8_U_RNI_NID4",
        .addr = A_POR_MPU_M5_PRBAR8_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR8_U_RNI_NID4",
        .addr = A_POR_MPU_M5_PRLAR8_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR9_U_RNI_NID4",
        .addr = A_POR_MPU_M5_PRBAR9_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR9_U_RNI_NID4",
        .addr = A_POR_MPU_M5_PRLAR9_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR10_U_RNI_NID4",
        .addr = A_POR_MPU_M5_PRBAR10_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR10_U_RNI_NID4",
        .addr = A_POR_MPU_M5_PRLAR10_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR11_U_RNI_NID4",
        .addr = A_POR_MPU_M5_PRBAR11_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR11_U_RNI_NID4",
        .addr = A_POR_MPU_M5_PRLAR11_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR12_U_RNI_NID4",
        .addr = A_POR_MPU_M5_PRBAR12_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR12_U_RNI_NID4",
        .addr = A_POR_MPU_M5_PRLAR12_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR13_U_RNI_NID4",
        .addr = A_POR_MPU_M5_PRBAR13_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR13_U_RNI_NID4",
        .addr = A_POR_MPU_M5_PRLAR13_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR14_U_RNI_NID4",
        .addr = A_POR_MPU_M5_PRBAR14_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR14_U_RNI_NID4",
        .addr = A_POR_MPU_M5_PRLAR14_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR15_U_RNI_NID4",
        .addr = A_POR_MPU_M5_PRBAR15_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR15_U_RNI_NID4",
        .addr = A_POR_MPU_M5_PRLAR15_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR16_U_RNI_NID4",
        .addr = A_POR_MPU_M5_PRBAR16_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR16_U_RNI_NID4",
        .addr = A_POR_MPU_M5_PRLAR16_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR17_U_RNI_NID4",
        .addr = A_POR_MPU_M5_PRBAR17_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR17_U_RNI_NID4",
        .addr = A_POR_MPU_M5_PRLAR17_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR18_U_RNI_NID4",
        .addr = A_POR_MPU_M5_PRBAR18_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR18_U_RNI_NID4",
        .addr = A_POR_MPU_M5_PRLAR18_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR19_U_RNI_NID4",
        .addr = A_POR_MPU_M5_PRBAR19_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR19_U_RNI_NID4",
        .addr = A_POR_MPU_M5_PRLAR19_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR20_U_RNI_NID4",
        .addr = A_POR_MPU_M5_PRBAR20_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR20_U_RNI_NID4",
        .addr = A_POR_MPU_M5_PRLAR20_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR21_U_RNI_NID4",
        .addr = A_POR_MPU_M5_PRBAR21_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR21_U_RNI_NID4",
        .addr = A_POR_MPU_M5_PRLAR21_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR22_U_RNI_NID4",
        .addr = A_POR_MPU_M5_PRBAR22_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR22_U_RNI_NID4",
        .addr = A_POR_MPU_M5_PRLAR22_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR23_U_RNI_NID4",
        .addr = A_POR_MPU_M5_PRBAR23_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR23_U_RNI_NID4",
        .addr = A_POR_MPU_M5_PRLAR23_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR24_U_RNI_NID4",
        .addr = A_POR_MPU_M5_PRBAR24_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR24_U_RNI_NID4",
        .addr = A_POR_MPU_M5_PRLAR24_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR25_U_RNI_NID4",
        .addr = A_POR_MPU_M5_PRBAR25_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR25_U_RNI_NID4",
        .addr = A_POR_MPU_M5_PRLAR25_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR26_U_RNI_NID4",
        .addr = A_POR_MPU_M5_PRBAR26_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR26_U_RNI_NID4",
        .addr = A_POR_MPU_M5_PRLAR26_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR27_U_RNI_NID4",
        .addr = A_POR_MPU_M5_PRBAR27_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR27_U_RNI_NID4",
        .addr = A_POR_MPU_M5_PRLAR27_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR28_U_RNI_NID4",
        .addr = A_POR_MPU_M5_PRBAR28_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR28_U_RNI_NID4",
        .addr = A_POR_MPU_M5_PRLAR28_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR29_U_RNI_NID4",
        .addr = A_POR_MPU_M5_PRBAR29_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR29_U_RNI_NID4",
        .addr = A_POR_MPU_M5_PRLAR29_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR30_U_RNI_NID4",
        .addr = A_POR_MPU_M5_PRBAR30_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR30_U_RNI_NID4",
        .addr = A_POR_MPU_M5_PRLAR30_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR31_U_RNI_NID4",
        .addr = A_POR_MPU_M5_PRBAR31_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR31_U_RNI_NID4",
        .addr = A_POR_MPU_M5_PRLAR31_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_CTL_U_RNI_NID4",
        .addr = A_POR_MPU_M6_CTL_U_RNI_NID4,
        .reset = 0x2,
        .rsvd = 0xfffffffffffffff8L,
        .ro = 0xfffffffffffffff8L,
    },{ .name = "POR_MPU_M6_PRBAR0_U_RNI_NID4",
        .addr = A_POR_MPU_M6_PRBAR0_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR0_U_RNI_NID4",
        .addr = A_POR_MPU_M6_PRLAR0_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR1_U_RNI_NID4",
        .addr = A_POR_MPU_M6_PRBAR1_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR1_U_RNI_NID4",
        .addr = A_POR_MPU_M6_PRLAR1_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR2_U_RNI_NID4",
        .addr = A_POR_MPU_M6_PRBAR2_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR2_U_RNI_NID4",
        .addr = A_POR_MPU_M6_PRLAR2_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR3_U_RNI_NID4",
        .addr = A_POR_MPU_M6_PRBAR3_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR3_U_RNI_NID4",
        .addr = A_POR_MPU_M6_PRLAR3_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR4_U_RNI_NID4",
        .addr = A_POR_MPU_M6_PRBAR4_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR4_U_RNI_NID4",
        .addr = A_POR_MPU_M6_PRLAR4_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR5_U_RNI_NID4",
        .addr = A_POR_MPU_M6_PRBAR5_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR5_U_RNI_NID4",
        .addr = A_POR_MPU_M6_PRLAR5_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR6_U_RNI_NID4",
        .addr = A_POR_MPU_M6_PRBAR6_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR6_U_RNI_NID4",
        .addr = A_POR_MPU_M6_PRLAR6_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR7_U_RNI_NID4",
        .addr = A_POR_MPU_M6_PRBAR7_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR7_U_RNI_NID4",
        .addr = A_POR_MPU_M6_PRLAR7_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR8_U_RNI_NID4",
        .addr = A_POR_MPU_M6_PRBAR8_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR8_U_RNI_NID4",
        .addr = A_POR_MPU_M6_PRLAR8_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR9_U_RNI_NID4",
        .addr = A_POR_MPU_M6_PRBAR9_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR9_U_RNI_NID4",
        .addr = A_POR_MPU_M6_PRLAR9_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR10_U_RNI_NID4",
        .addr = A_POR_MPU_M6_PRBAR10_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR10_U_RNI_NID4",
        .addr = A_POR_MPU_M6_PRLAR10_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR11_U_RNI_NID4",
        .addr = A_POR_MPU_M6_PRBAR11_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR11_U_RNI_NID4",
        .addr = A_POR_MPU_M6_PRLAR11_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR12_U_RNI_NID4",
        .addr = A_POR_MPU_M6_PRBAR12_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR12_U_RNI_NID4",
        .addr = A_POR_MPU_M6_PRLAR12_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR13_U_RNI_NID4",
        .addr = A_POR_MPU_M6_PRBAR13_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR13_U_RNI_NID4",
        .addr = A_POR_MPU_M6_PRLAR13_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR14_U_RNI_NID4",
        .addr = A_POR_MPU_M6_PRBAR14_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR14_U_RNI_NID4",
        .addr = A_POR_MPU_M6_PRLAR14_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR15_U_RNI_NID4",
        .addr = A_POR_MPU_M6_PRBAR15_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR15_U_RNI_NID4",
        .addr = A_POR_MPU_M6_PRLAR15_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR16_U_RNI_NID4",
        .addr = A_POR_MPU_M6_PRBAR16_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR16_U_RNI_NID4",
        .addr = A_POR_MPU_M6_PRLAR16_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR17_U_RNI_NID4",
        .addr = A_POR_MPU_M6_PRBAR17_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR17_U_RNI_NID4",
        .addr = A_POR_MPU_M6_PRLAR17_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR18_U_RNI_NID4",
        .addr = A_POR_MPU_M6_PRBAR18_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR18_U_RNI_NID4",
        .addr = A_POR_MPU_M6_PRLAR18_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR19_U_RNI_NID4",
        .addr = A_POR_MPU_M6_PRBAR19_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR19_U_RNI_NID4",
        .addr = A_POR_MPU_M6_PRLAR19_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR20_U_RNI_NID4",
        .addr = A_POR_MPU_M6_PRBAR20_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR20_U_RNI_NID4",
        .addr = A_POR_MPU_M6_PRLAR20_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR21_U_RNI_NID4",
        .addr = A_POR_MPU_M6_PRBAR21_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR21_U_RNI_NID4",
        .addr = A_POR_MPU_M6_PRLAR21_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR22_U_RNI_NID4",
        .addr = A_POR_MPU_M6_PRBAR22_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR22_U_RNI_NID4",
        .addr = A_POR_MPU_M6_PRLAR22_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR23_U_RNI_NID4",
        .addr = A_POR_MPU_M6_PRBAR23_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR23_U_RNI_NID4",
        .addr = A_POR_MPU_M6_PRLAR23_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR24_U_RNI_NID4",
        .addr = A_POR_MPU_M6_PRBAR24_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR24_U_RNI_NID4",
        .addr = A_POR_MPU_M6_PRLAR24_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR25_U_RNI_NID4",
        .addr = A_POR_MPU_M6_PRBAR25_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR25_U_RNI_NID4",
        .addr = A_POR_MPU_M6_PRLAR25_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR26_U_RNI_NID4",
        .addr = A_POR_MPU_M6_PRBAR26_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR26_U_RNI_NID4",
        .addr = A_POR_MPU_M6_PRLAR26_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR27_U_RNI_NID4",
        .addr = A_POR_MPU_M6_PRBAR27_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR27_U_RNI_NID4",
        .addr = A_POR_MPU_M6_PRLAR27_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR28_U_RNI_NID4",
        .addr = A_POR_MPU_M6_PRBAR28_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR28_U_RNI_NID4",
        .addr = A_POR_MPU_M6_PRLAR28_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR29_U_RNI_NID4",
        .addr = A_POR_MPU_M6_PRBAR29_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR29_U_RNI_NID4",
        .addr = A_POR_MPU_M6_PRLAR29_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR30_U_RNI_NID4",
        .addr = A_POR_MPU_M6_PRBAR30_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR30_U_RNI_NID4",
        .addr = A_POR_MPU_M6_PRLAR30_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR31_U_RNI_NID4",
        .addr = A_POR_MPU_M6_PRBAR31_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR31_U_RNI_NID4",
        .addr = A_POR_MPU_M6_PRLAR31_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_CTL_U_RNI_NID4",
        .addr = A_POR_MPU_M7_CTL_U_RNI_NID4,
        .reset = 0x2,
        .rsvd = 0xfffffffffffffff8L,
        .ro = 0xfffffffffffffff8L,
    },{ .name = "POR_MPU_M7_PRBAR0_U_RNI_NID4",
        .addr = A_POR_MPU_M7_PRBAR0_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR0_U_RNI_NID4",
        .addr = A_POR_MPU_M7_PRLAR0_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR1_U_RNI_NID4",
        .addr = A_POR_MPU_M7_PRBAR1_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR1_U_RNI_NID4",
        .addr = A_POR_MPU_M7_PRLAR1_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR2_U_RNI_NID4",
        .addr = A_POR_MPU_M7_PRBAR2_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR2_U_RNI_NID4",
        .addr = A_POR_MPU_M7_PRLAR2_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR3_U_RNI_NID4",
        .addr = A_POR_MPU_M7_PRBAR3_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR3_U_RNI_NID4",
        .addr = A_POR_MPU_M7_PRLAR3_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR4_U_RNI_NID4",
        .addr = A_POR_MPU_M7_PRBAR4_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR4_U_RNI_NID4",
        .addr = A_POR_MPU_M7_PRLAR4_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR5_U_RNI_NID4",
        .addr = A_POR_MPU_M7_PRBAR5_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR5_U_RNI_NID4",
        .addr = A_POR_MPU_M7_PRLAR5_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR6_U_RNI_NID4",
        .addr = A_POR_MPU_M7_PRBAR6_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR6_U_RNI_NID4",
        .addr = A_POR_MPU_M7_PRLAR6_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR7_U_RNI_NID4",
        .addr = A_POR_MPU_M7_PRBAR7_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR7_U_RNI_NID4",
        .addr = A_POR_MPU_M7_PRLAR7_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR8_U_RNI_NID4",
        .addr = A_POR_MPU_M7_PRBAR8_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR8_U_RNI_NID4",
        .addr = A_POR_MPU_M7_PRLAR8_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR9_U_RNI_NID4",
        .addr = A_POR_MPU_M7_PRBAR9_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR9_U_RNI_NID4",
        .addr = A_POR_MPU_M7_PRLAR9_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR10_U_RNI_NID4",
        .addr = A_POR_MPU_M7_PRBAR10_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR10_U_RNI_NID4",
        .addr = A_POR_MPU_M7_PRLAR10_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR11_U_RNI_NID4",
        .addr = A_POR_MPU_M7_PRBAR11_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR11_U_RNI_NID4",
        .addr = A_POR_MPU_M7_PRLAR11_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR12_U_RNI_NID4",
        .addr = A_POR_MPU_M7_PRBAR12_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR12_U_RNI_NID4",
        .addr = A_POR_MPU_M7_PRLAR12_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR13_U_RNI_NID4",
        .addr = A_POR_MPU_M7_PRBAR13_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR13_U_RNI_NID4",
        .addr = A_POR_MPU_M7_PRLAR13_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR14_U_RNI_NID4",
        .addr = A_POR_MPU_M7_PRBAR14_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR14_U_RNI_NID4",
        .addr = A_POR_MPU_M7_PRLAR14_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR15_U_RNI_NID4",
        .addr = A_POR_MPU_M7_PRBAR15_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR15_U_RNI_NID4",
        .addr = A_POR_MPU_M7_PRLAR15_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR16_U_RNI_NID4",
        .addr = A_POR_MPU_M7_PRBAR16_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR16_U_RNI_NID4",
        .addr = A_POR_MPU_M7_PRLAR16_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR17_U_RNI_NID4",
        .addr = A_POR_MPU_M7_PRBAR17_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR17_U_RNI_NID4",
        .addr = A_POR_MPU_M7_PRLAR17_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR18_U_RNI_NID4",
        .addr = A_POR_MPU_M7_PRBAR18_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR18_U_RNI_NID4",
        .addr = A_POR_MPU_M7_PRLAR18_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR19_U_RNI_NID4",
        .addr = A_POR_MPU_M7_PRBAR19_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR19_U_RNI_NID4",
        .addr = A_POR_MPU_M7_PRLAR19_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR20_U_RNI_NID4",
        .addr = A_POR_MPU_M7_PRBAR20_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR20_U_RNI_NID4",
        .addr = A_POR_MPU_M7_PRLAR20_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR21_U_RNI_NID4",
        .addr = A_POR_MPU_M7_PRBAR21_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR21_U_RNI_NID4",
        .addr = A_POR_MPU_M7_PRLAR21_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR22_U_RNI_NID4",
        .addr = A_POR_MPU_M7_PRBAR22_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR22_U_RNI_NID4",
        .addr = A_POR_MPU_M7_PRLAR22_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR23_U_RNI_NID4",
        .addr = A_POR_MPU_M7_PRBAR23_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR23_U_RNI_NID4",
        .addr = A_POR_MPU_M7_PRLAR23_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR24_U_RNI_NID4",
        .addr = A_POR_MPU_M7_PRBAR24_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR24_U_RNI_NID4",
        .addr = A_POR_MPU_M7_PRLAR24_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR25_U_RNI_NID4",
        .addr = A_POR_MPU_M7_PRBAR25_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR25_U_RNI_NID4",
        .addr = A_POR_MPU_M7_PRLAR25_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR26_U_RNI_NID4",
        .addr = A_POR_MPU_M7_PRBAR26_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR26_U_RNI_NID4",
        .addr = A_POR_MPU_M7_PRLAR26_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR27_U_RNI_NID4",
        .addr = A_POR_MPU_M7_PRBAR27_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR27_U_RNI_NID4",
        .addr = A_POR_MPU_M7_PRLAR27_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR28_U_RNI_NID4",
        .addr = A_POR_MPU_M7_PRBAR28_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR28_U_RNI_NID4",
        .addr = A_POR_MPU_M7_PRLAR28_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR29_U_RNI_NID4",
        .addr = A_POR_MPU_M7_PRBAR29_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR29_U_RNI_NID4",
        .addr = A_POR_MPU_M7_PRLAR29_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR30_U_RNI_NID4",
        .addr = A_POR_MPU_M7_PRBAR30_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR30_U_RNI_NID4",
        .addr = A_POR_MPU_M7_PRLAR30_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR31_U_RNI_NID4",
        .addr = A_POR_MPU_M7_PRBAR31_U_RNI_NID4,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR31_U_RNI_NID4",
        .addr = A_POR_MPU_M7_PRLAR31_U_RNI_NID4,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_NODE_INFO_U_SMXP_0_0",
        .addr = A_POR_MPU_NODE_INFO_U_SMXP_0_0,
        .reset = 0x202,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MPU_CHILD_INFO_U_SMXP_0_0",
        .addr = A_POR_MPU_CHILD_INFO_U_SMXP_0_0,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MPU_UNIT_INFO_U_SMXP_0_0",
        .addr = A_POR_MPU_UNIT_INFO_U_SMXP_0_0,
        .reset = 0x20,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MPU_M0_CTL_U_SMXP_0_0",
        .addr = A_POR_MPU_M0_CTL_U_SMXP_0_0,
        .reset = 0x2,
        .rsvd = 0xfffffffffffffff8L,
        .ro = 0xfffffffffffffff8L,
    },{ .name = "POR_MPU_M0_PRBAR0_U_SMXP_0_0",
        .addr = A_POR_MPU_M0_PRBAR0_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR0_U_SMXP_0_0",
        .addr = A_POR_MPU_M0_PRLAR0_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR1_U_SMXP_0_0",
        .addr = A_POR_MPU_M0_PRBAR1_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR1_U_SMXP_0_0",
        .addr = A_POR_MPU_M0_PRLAR1_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR2_U_SMXP_0_0",
        .addr = A_POR_MPU_M0_PRBAR2_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR2_U_SMXP_0_0",
        .addr = A_POR_MPU_M0_PRLAR2_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR3_U_SMXP_0_0",
        .addr = A_POR_MPU_M0_PRBAR3_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR3_U_SMXP_0_0",
        .addr = A_POR_MPU_M0_PRLAR3_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR4_U_SMXP_0_0",
        .addr = A_POR_MPU_M0_PRBAR4_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR4_U_SMXP_0_0",
        .addr = A_POR_MPU_M0_PRLAR4_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR5_U_SMXP_0_0",
        .addr = A_POR_MPU_M0_PRBAR5_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR5_U_SMXP_0_0",
        .addr = A_POR_MPU_M0_PRLAR5_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR6_U_SMXP_0_0",
        .addr = A_POR_MPU_M0_PRBAR6_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR6_U_SMXP_0_0",
        .addr = A_POR_MPU_M0_PRLAR6_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR7_U_SMXP_0_0",
        .addr = A_POR_MPU_M0_PRBAR7_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR7_U_SMXP_0_0",
        .addr = A_POR_MPU_M0_PRLAR7_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR8_U_SMXP_0_0",
        .addr = A_POR_MPU_M0_PRBAR8_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR8_U_SMXP_0_0",
        .addr = A_POR_MPU_M0_PRLAR8_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR9_U_SMXP_0_0",
        .addr = A_POR_MPU_M0_PRBAR9_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR9_U_SMXP_0_0",
        .addr = A_POR_MPU_M0_PRLAR9_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR10_U_SMXP_0_0",
        .addr = A_POR_MPU_M0_PRBAR10_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR10_U_SMXP_0_0",
        .addr = A_POR_MPU_M0_PRLAR10_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR11_U_SMXP_0_0",
        .addr = A_POR_MPU_M0_PRBAR11_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR11_U_SMXP_0_0",
        .addr = A_POR_MPU_M0_PRLAR11_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR12_U_SMXP_0_0",
        .addr = A_POR_MPU_M0_PRBAR12_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR12_U_SMXP_0_0",
        .addr = A_POR_MPU_M0_PRLAR12_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR13_U_SMXP_0_0",
        .addr = A_POR_MPU_M0_PRBAR13_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR13_U_SMXP_0_0",
        .addr = A_POR_MPU_M0_PRLAR13_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR14_U_SMXP_0_0",
        .addr = A_POR_MPU_M0_PRBAR14_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR14_U_SMXP_0_0",
        .addr = A_POR_MPU_M0_PRLAR14_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR15_U_SMXP_0_0",
        .addr = A_POR_MPU_M0_PRBAR15_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR15_U_SMXP_0_0",
        .addr = A_POR_MPU_M0_PRLAR15_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR16_U_SMXP_0_0",
        .addr = A_POR_MPU_M0_PRBAR16_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR16_U_SMXP_0_0",
        .addr = A_POR_MPU_M0_PRLAR16_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR17_U_SMXP_0_0",
        .addr = A_POR_MPU_M0_PRBAR17_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR17_U_SMXP_0_0",
        .addr = A_POR_MPU_M0_PRLAR17_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR18_U_SMXP_0_0",
        .addr = A_POR_MPU_M0_PRBAR18_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR18_U_SMXP_0_0",
        .addr = A_POR_MPU_M0_PRLAR18_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR19_U_SMXP_0_0",
        .addr = A_POR_MPU_M0_PRBAR19_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR19_U_SMXP_0_0",
        .addr = A_POR_MPU_M0_PRLAR19_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR20_U_SMXP_0_0",
        .addr = A_POR_MPU_M0_PRBAR20_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR20_U_SMXP_0_0",
        .addr = A_POR_MPU_M0_PRLAR20_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR21_U_SMXP_0_0",
        .addr = A_POR_MPU_M0_PRBAR21_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR21_U_SMXP_0_0",
        .addr = A_POR_MPU_M0_PRLAR21_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR22_U_SMXP_0_0",
        .addr = A_POR_MPU_M0_PRBAR22_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR22_U_SMXP_0_0",
        .addr = A_POR_MPU_M0_PRLAR22_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR23_U_SMXP_0_0",
        .addr = A_POR_MPU_M0_PRBAR23_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR23_U_SMXP_0_0",
        .addr = A_POR_MPU_M0_PRLAR23_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR24_U_SMXP_0_0",
        .addr = A_POR_MPU_M0_PRBAR24_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR24_U_SMXP_0_0",
        .addr = A_POR_MPU_M0_PRLAR24_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR25_U_SMXP_0_0",
        .addr = A_POR_MPU_M0_PRBAR25_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR25_U_SMXP_0_0",
        .addr = A_POR_MPU_M0_PRLAR25_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR26_U_SMXP_0_0",
        .addr = A_POR_MPU_M0_PRBAR26_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR26_U_SMXP_0_0",
        .addr = A_POR_MPU_M0_PRLAR26_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR27_U_SMXP_0_0",
        .addr = A_POR_MPU_M0_PRBAR27_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR27_U_SMXP_0_0",
        .addr = A_POR_MPU_M0_PRLAR27_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR28_U_SMXP_0_0",
        .addr = A_POR_MPU_M0_PRBAR28_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR28_U_SMXP_0_0",
        .addr = A_POR_MPU_M0_PRLAR28_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR29_U_SMXP_0_0",
        .addr = A_POR_MPU_M0_PRBAR29_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR29_U_SMXP_0_0",
        .addr = A_POR_MPU_M0_PRLAR29_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR30_U_SMXP_0_0",
        .addr = A_POR_MPU_M0_PRBAR30_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR30_U_SMXP_0_0",
        .addr = A_POR_MPU_M0_PRLAR30_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR31_U_SMXP_0_0",
        .addr = A_POR_MPU_M0_PRBAR31_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR31_U_SMXP_0_0",
        .addr = A_POR_MPU_M0_PRLAR31_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_CTL_U_SMXP_0_0",
        .addr = A_POR_MPU_M1_CTL_U_SMXP_0_0,
        .reset = 0x2,
        .rsvd = 0xfffffffffffffff8L,
        .ro = 0xfffffffffffffff8L,
    },{ .name = "POR_MPU_M1_PRBAR0_U_SMXP_0_0",
        .addr = A_POR_MPU_M1_PRBAR0_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR0_U_SMXP_0_0",
        .addr = A_POR_MPU_M1_PRLAR0_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR1_U_SMXP_0_0",
        .addr = A_POR_MPU_M1_PRBAR1_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR1_U_SMXP_0_0",
        .addr = A_POR_MPU_M1_PRLAR1_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR2_U_SMXP_0_0",
        .addr = A_POR_MPU_M1_PRBAR2_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR2_U_SMXP_0_0",
        .addr = A_POR_MPU_M1_PRLAR2_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR3_U_SMXP_0_0",
        .addr = A_POR_MPU_M1_PRBAR3_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR3_U_SMXP_0_0",
        .addr = A_POR_MPU_M1_PRLAR3_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR4_U_SMXP_0_0",
        .addr = A_POR_MPU_M1_PRBAR4_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR4_U_SMXP_0_0",
        .addr = A_POR_MPU_M1_PRLAR4_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR5_U_SMXP_0_0",
        .addr = A_POR_MPU_M1_PRBAR5_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR5_U_SMXP_0_0",
        .addr = A_POR_MPU_M1_PRLAR5_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR6_U_SMXP_0_0",
        .addr = A_POR_MPU_M1_PRBAR6_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR6_U_SMXP_0_0",
        .addr = A_POR_MPU_M1_PRLAR6_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR7_U_SMXP_0_0",
        .addr = A_POR_MPU_M1_PRBAR7_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR7_U_SMXP_0_0",
        .addr = A_POR_MPU_M1_PRLAR7_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR8_U_SMXP_0_0",
        .addr = A_POR_MPU_M1_PRBAR8_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR8_U_SMXP_0_0",
        .addr = A_POR_MPU_M1_PRLAR8_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR9_U_SMXP_0_0",
        .addr = A_POR_MPU_M1_PRBAR9_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR9_U_SMXP_0_0",
        .addr = A_POR_MPU_M1_PRLAR9_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR10_U_SMXP_0_0",
        .addr = A_POR_MPU_M1_PRBAR10_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR10_U_SMXP_0_0",
        .addr = A_POR_MPU_M1_PRLAR10_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR11_U_SMXP_0_0",
        .addr = A_POR_MPU_M1_PRBAR11_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR11_U_SMXP_0_0",
        .addr = A_POR_MPU_M1_PRLAR11_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR12_U_SMXP_0_0",
        .addr = A_POR_MPU_M1_PRBAR12_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR12_U_SMXP_0_0",
        .addr = A_POR_MPU_M1_PRLAR12_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR13_U_SMXP_0_0",
        .addr = A_POR_MPU_M1_PRBAR13_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR13_U_SMXP_0_0",
        .addr = A_POR_MPU_M1_PRLAR13_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR14_U_SMXP_0_0",
        .addr = A_POR_MPU_M1_PRBAR14_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR14_U_SMXP_0_0",
        .addr = A_POR_MPU_M1_PRLAR14_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR15_U_SMXP_0_0",
        .addr = A_POR_MPU_M1_PRBAR15_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR15_U_SMXP_0_0",
        .addr = A_POR_MPU_M1_PRLAR15_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR16_U_SMXP_0_0",
        .addr = A_POR_MPU_M1_PRBAR16_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR16_U_SMXP_0_0",
        .addr = A_POR_MPU_M1_PRLAR16_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR17_U_SMXP_0_0",
        .addr = A_POR_MPU_M1_PRBAR17_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR17_U_SMXP_0_0",
        .addr = A_POR_MPU_M1_PRLAR17_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR18_U_SMXP_0_0",
        .addr = A_POR_MPU_M1_PRBAR18_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR18_U_SMXP_0_0",
        .addr = A_POR_MPU_M1_PRLAR18_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR19_U_SMXP_0_0",
        .addr = A_POR_MPU_M1_PRBAR19_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR19_U_SMXP_0_0",
        .addr = A_POR_MPU_M1_PRLAR19_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR20_U_SMXP_0_0",
        .addr = A_POR_MPU_M1_PRBAR20_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR20_U_SMXP_0_0",
        .addr = A_POR_MPU_M1_PRLAR20_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR21_U_SMXP_0_0",
        .addr = A_POR_MPU_M1_PRBAR21_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR21_U_SMXP_0_0",
        .addr = A_POR_MPU_M1_PRLAR21_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR22_U_SMXP_0_0",
        .addr = A_POR_MPU_M1_PRBAR22_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR22_U_SMXP_0_0",
        .addr = A_POR_MPU_M1_PRLAR22_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR23_U_SMXP_0_0",
        .addr = A_POR_MPU_M1_PRBAR23_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR23_U_SMXP_0_0",
        .addr = A_POR_MPU_M1_PRLAR23_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR24_U_SMXP_0_0",
        .addr = A_POR_MPU_M1_PRBAR24_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR24_U_SMXP_0_0",
        .addr = A_POR_MPU_M1_PRLAR24_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR25_U_SMXP_0_0",
        .addr = A_POR_MPU_M1_PRBAR25_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR25_U_SMXP_0_0",
        .addr = A_POR_MPU_M1_PRLAR25_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR26_U_SMXP_0_0",
        .addr = A_POR_MPU_M1_PRBAR26_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR26_U_SMXP_0_0",
        .addr = A_POR_MPU_M1_PRLAR26_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR27_U_SMXP_0_0",
        .addr = A_POR_MPU_M1_PRBAR27_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR27_U_SMXP_0_0",
        .addr = A_POR_MPU_M1_PRLAR27_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR28_U_SMXP_0_0",
        .addr = A_POR_MPU_M1_PRBAR28_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR28_U_SMXP_0_0",
        .addr = A_POR_MPU_M1_PRLAR28_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR29_U_SMXP_0_0",
        .addr = A_POR_MPU_M1_PRBAR29_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR29_U_SMXP_0_0",
        .addr = A_POR_MPU_M1_PRLAR29_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR30_U_SMXP_0_0",
        .addr = A_POR_MPU_M1_PRBAR30_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR30_U_SMXP_0_0",
        .addr = A_POR_MPU_M1_PRLAR30_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR31_U_SMXP_0_0",
        .addr = A_POR_MPU_M1_PRBAR31_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR31_U_SMXP_0_0",
        .addr = A_POR_MPU_M1_PRLAR31_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_CTL_U_SMXP_0_0",
        .addr = A_POR_MPU_M2_CTL_U_SMXP_0_0,
        .reset = 0x2,
        .rsvd = 0xfffffffffffffff8L,
        .ro = 0xfffffffffffffff8L,
    },{ .name = "POR_MPU_M2_PRBAR0_U_SMXP_0_0",
        .addr = A_POR_MPU_M2_PRBAR0_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR0_U_SMXP_0_0",
        .addr = A_POR_MPU_M2_PRLAR0_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR1_U_SMXP_0_0",
        .addr = A_POR_MPU_M2_PRBAR1_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR1_U_SMXP_0_0",
        .addr = A_POR_MPU_M2_PRLAR1_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR2_U_SMXP_0_0",
        .addr = A_POR_MPU_M2_PRBAR2_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR2_U_SMXP_0_0",
        .addr = A_POR_MPU_M2_PRLAR2_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR3_U_SMXP_0_0",
        .addr = A_POR_MPU_M2_PRBAR3_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR3_U_SMXP_0_0",
        .addr = A_POR_MPU_M2_PRLAR3_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR4_U_SMXP_0_0",
        .addr = A_POR_MPU_M2_PRBAR4_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR4_U_SMXP_0_0",
        .addr = A_POR_MPU_M2_PRLAR4_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR5_U_SMXP_0_0",
        .addr = A_POR_MPU_M2_PRBAR5_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR5_U_SMXP_0_0",
        .addr = A_POR_MPU_M2_PRLAR5_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR6_U_SMXP_0_0",
        .addr = A_POR_MPU_M2_PRBAR6_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR6_U_SMXP_0_0",
        .addr = A_POR_MPU_M2_PRLAR6_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR7_U_SMXP_0_0",
        .addr = A_POR_MPU_M2_PRBAR7_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR7_U_SMXP_0_0",
        .addr = A_POR_MPU_M2_PRLAR7_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR8_U_SMXP_0_0",
        .addr = A_POR_MPU_M2_PRBAR8_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR8_U_SMXP_0_0",
        .addr = A_POR_MPU_M2_PRLAR8_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR9_U_SMXP_0_0",
        .addr = A_POR_MPU_M2_PRBAR9_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR9_U_SMXP_0_0",
        .addr = A_POR_MPU_M2_PRLAR9_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR10_U_SMXP_0_0",
        .addr = A_POR_MPU_M2_PRBAR10_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR10_U_SMXP_0_0",
        .addr = A_POR_MPU_M2_PRLAR10_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR11_U_SMXP_0_0",
        .addr = A_POR_MPU_M2_PRBAR11_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR11_U_SMXP_0_0",
        .addr = A_POR_MPU_M2_PRLAR11_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR12_U_SMXP_0_0",
        .addr = A_POR_MPU_M2_PRBAR12_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR12_U_SMXP_0_0",
        .addr = A_POR_MPU_M2_PRLAR12_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR13_U_SMXP_0_0",
        .addr = A_POR_MPU_M2_PRBAR13_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR13_U_SMXP_0_0",
        .addr = A_POR_MPU_M2_PRLAR13_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR14_U_SMXP_0_0",
        .addr = A_POR_MPU_M2_PRBAR14_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR14_U_SMXP_0_0",
        .addr = A_POR_MPU_M2_PRLAR14_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR15_U_SMXP_0_0",
        .addr = A_POR_MPU_M2_PRBAR15_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR15_U_SMXP_0_0",
        .addr = A_POR_MPU_M2_PRLAR15_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR16_U_SMXP_0_0",
        .addr = A_POR_MPU_M2_PRBAR16_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR16_U_SMXP_0_0",
        .addr = A_POR_MPU_M2_PRLAR16_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR17_U_SMXP_0_0",
        .addr = A_POR_MPU_M2_PRBAR17_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR17_U_SMXP_0_0",
        .addr = A_POR_MPU_M2_PRLAR17_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR18_U_SMXP_0_0",
        .addr = A_POR_MPU_M2_PRBAR18_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR18_U_SMXP_0_0",
        .addr = A_POR_MPU_M2_PRLAR18_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR19_U_SMXP_0_0",
        .addr = A_POR_MPU_M2_PRBAR19_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR19_U_SMXP_0_0",
        .addr = A_POR_MPU_M2_PRLAR19_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR20_U_SMXP_0_0",
        .addr = A_POR_MPU_M2_PRBAR20_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR20_U_SMXP_0_0",
        .addr = A_POR_MPU_M2_PRLAR20_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR21_U_SMXP_0_0",
        .addr = A_POR_MPU_M2_PRBAR21_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR21_U_SMXP_0_0",
        .addr = A_POR_MPU_M2_PRLAR21_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR22_U_SMXP_0_0",
        .addr = A_POR_MPU_M2_PRBAR22_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR22_U_SMXP_0_0",
        .addr = A_POR_MPU_M2_PRLAR22_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR23_U_SMXP_0_0",
        .addr = A_POR_MPU_M2_PRBAR23_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR23_U_SMXP_0_0",
        .addr = A_POR_MPU_M2_PRLAR23_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR24_U_SMXP_0_0",
        .addr = A_POR_MPU_M2_PRBAR24_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR24_U_SMXP_0_0",
        .addr = A_POR_MPU_M2_PRLAR24_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR25_U_SMXP_0_0",
        .addr = A_POR_MPU_M2_PRBAR25_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR25_U_SMXP_0_0",
        .addr = A_POR_MPU_M2_PRLAR25_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR26_U_SMXP_0_0",
        .addr = A_POR_MPU_M2_PRBAR26_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR26_U_SMXP_0_0",
        .addr = A_POR_MPU_M2_PRLAR26_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR27_U_SMXP_0_0",
        .addr = A_POR_MPU_M2_PRBAR27_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR27_U_SMXP_0_0",
        .addr = A_POR_MPU_M2_PRLAR27_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR28_U_SMXP_0_0",
        .addr = A_POR_MPU_M2_PRBAR28_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR28_U_SMXP_0_0",
        .addr = A_POR_MPU_M2_PRLAR28_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR29_U_SMXP_0_0",
        .addr = A_POR_MPU_M2_PRBAR29_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR29_U_SMXP_0_0",
        .addr = A_POR_MPU_M2_PRLAR29_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR30_U_SMXP_0_0",
        .addr = A_POR_MPU_M2_PRBAR30_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR30_U_SMXP_0_0",
        .addr = A_POR_MPU_M2_PRLAR30_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR31_U_SMXP_0_0",
        .addr = A_POR_MPU_M2_PRBAR31_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR31_U_SMXP_0_0",
        .addr = A_POR_MPU_M2_PRLAR31_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_CTL_U_SMXP_0_0",
        .addr = A_POR_MPU_M3_CTL_U_SMXP_0_0,
        .reset = 0x2,
        .rsvd = 0xfffffffffffffff8L,
        .ro = 0xfffffffffffffff8L,
    },{ .name = "POR_MPU_M3_PRBAR0_U_SMXP_0_0",
        .addr = A_POR_MPU_M3_PRBAR0_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR0_U_SMXP_0_0",
        .addr = A_POR_MPU_M3_PRLAR0_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR1_U_SMXP_0_0",
        .addr = A_POR_MPU_M3_PRBAR1_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR1_U_SMXP_0_0",
        .addr = A_POR_MPU_M3_PRLAR1_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR2_U_SMXP_0_0",
        .addr = A_POR_MPU_M3_PRBAR2_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR2_U_SMXP_0_0",
        .addr = A_POR_MPU_M3_PRLAR2_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR3_U_SMXP_0_0",
        .addr = A_POR_MPU_M3_PRBAR3_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR3_U_SMXP_0_0",
        .addr = A_POR_MPU_M3_PRLAR3_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR4_U_SMXP_0_0",
        .addr = A_POR_MPU_M3_PRBAR4_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR4_U_SMXP_0_0",
        .addr = A_POR_MPU_M3_PRLAR4_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR5_U_SMXP_0_0",
        .addr = A_POR_MPU_M3_PRBAR5_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR5_U_SMXP_0_0",
        .addr = A_POR_MPU_M3_PRLAR5_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR6_U_SMXP_0_0",
        .addr = A_POR_MPU_M3_PRBAR6_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR6_U_SMXP_0_0",
        .addr = A_POR_MPU_M3_PRLAR6_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR7_U_SMXP_0_0",
        .addr = A_POR_MPU_M3_PRBAR7_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR7_U_SMXP_0_0",
        .addr = A_POR_MPU_M3_PRLAR7_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR8_U_SMXP_0_0",
        .addr = A_POR_MPU_M3_PRBAR8_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR8_U_SMXP_0_0",
        .addr = A_POR_MPU_M3_PRLAR8_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR9_U_SMXP_0_0",
        .addr = A_POR_MPU_M3_PRBAR9_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR9_U_SMXP_0_0",
        .addr = A_POR_MPU_M3_PRLAR9_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR10_U_SMXP_0_0",
        .addr = A_POR_MPU_M3_PRBAR10_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR10_U_SMXP_0_0",
        .addr = A_POR_MPU_M3_PRLAR10_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR11_U_SMXP_0_0",
        .addr = A_POR_MPU_M3_PRBAR11_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR11_U_SMXP_0_0",
        .addr = A_POR_MPU_M3_PRLAR11_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR12_U_SMXP_0_0",
        .addr = A_POR_MPU_M3_PRBAR12_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR12_U_SMXP_0_0",
        .addr = A_POR_MPU_M3_PRLAR12_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR13_U_SMXP_0_0",
        .addr = A_POR_MPU_M3_PRBAR13_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR13_U_SMXP_0_0",
        .addr = A_POR_MPU_M3_PRLAR13_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR14_U_SMXP_0_0",
        .addr = A_POR_MPU_M3_PRBAR14_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR14_U_SMXP_0_0",
        .addr = A_POR_MPU_M3_PRLAR14_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR15_U_SMXP_0_0",
        .addr = A_POR_MPU_M3_PRBAR15_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR15_U_SMXP_0_0",
        .addr = A_POR_MPU_M3_PRLAR15_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR16_U_SMXP_0_0",
        .addr = A_POR_MPU_M3_PRBAR16_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR16_U_SMXP_0_0",
        .addr = A_POR_MPU_M3_PRLAR16_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR17_U_SMXP_0_0",
        .addr = A_POR_MPU_M3_PRBAR17_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR17_U_SMXP_0_0",
        .addr = A_POR_MPU_M3_PRLAR17_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR18_U_SMXP_0_0",
        .addr = A_POR_MPU_M3_PRBAR18_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR18_U_SMXP_0_0",
        .addr = A_POR_MPU_M3_PRLAR18_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR19_U_SMXP_0_0",
        .addr = A_POR_MPU_M3_PRBAR19_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR19_U_SMXP_0_0",
        .addr = A_POR_MPU_M3_PRLAR19_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR20_U_SMXP_0_0",
        .addr = A_POR_MPU_M3_PRBAR20_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR20_U_SMXP_0_0",
        .addr = A_POR_MPU_M3_PRLAR20_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR21_U_SMXP_0_0",
        .addr = A_POR_MPU_M3_PRBAR21_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR21_U_SMXP_0_0",
        .addr = A_POR_MPU_M3_PRLAR21_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR22_U_SMXP_0_0",
        .addr = A_POR_MPU_M3_PRBAR22_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR22_U_SMXP_0_0",
        .addr = A_POR_MPU_M3_PRLAR22_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR23_U_SMXP_0_0",
        .addr = A_POR_MPU_M3_PRBAR23_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR23_U_SMXP_0_0",
        .addr = A_POR_MPU_M3_PRLAR23_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR24_U_SMXP_0_0",
        .addr = A_POR_MPU_M3_PRBAR24_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR24_U_SMXP_0_0",
        .addr = A_POR_MPU_M3_PRLAR24_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR25_U_SMXP_0_0",
        .addr = A_POR_MPU_M3_PRBAR25_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR25_U_SMXP_0_0",
        .addr = A_POR_MPU_M3_PRLAR25_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR26_U_SMXP_0_0",
        .addr = A_POR_MPU_M3_PRBAR26_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR26_U_SMXP_0_0",
        .addr = A_POR_MPU_M3_PRLAR26_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR27_U_SMXP_0_0",
        .addr = A_POR_MPU_M3_PRBAR27_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR27_U_SMXP_0_0",
        .addr = A_POR_MPU_M3_PRLAR27_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR28_U_SMXP_0_0",
        .addr = A_POR_MPU_M3_PRBAR28_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR28_U_SMXP_0_0",
        .addr = A_POR_MPU_M3_PRLAR28_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR29_U_SMXP_0_0",
        .addr = A_POR_MPU_M3_PRBAR29_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR29_U_SMXP_0_0",
        .addr = A_POR_MPU_M3_PRLAR29_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR30_U_SMXP_0_0",
        .addr = A_POR_MPU_M3_PRBAR30_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR30_U_SMXP_0_0",
        .addr = A_POR_MPU_M3_PRLAR30_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR31_U_SMXP_0_0",
        .addr = A_POR_MPU_M3_PRBAR31_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR31_U_SMXP_0_0",
        .addr = A_POR_MPU_M3_PRLAR31_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_CTL_U_SMXP_0_0",
        .addr = A_POR_MPU_M4_CTL_U_SMXP_0_0,
        .reset = 0x2,
        .rsvd = 0xfffffffffffffff8L,
        .ro = 0xfffffffffffffff8L,
    },{ .name = "POR_MPU_M4_PRBAR0_U_SMXP_0_0",
        .addr = A_POR_MPU_M4_PRBAR0_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR0_U_SMXP_0_0",
        .addr = A_POR_MPU_M4_PRLAR0_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR1_U_SMXP_0_0",
        .addr = A_POR_MPU_M4_PRBAR1_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR1_U_SMXP_0_0",
        .addr = A_POR_MPU_M4_PRLAR1_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR2_U_SMXP_0_0",
        .addr = A_POR_MPU_M4_PRBAR2_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR2_U_SMXP_0_0",
        .addr = A_POR_MPU_M4_PRLAR2_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR3_U_SMXP_0_0",
        .addr = A_POR_MPU_M4_PRBAR3_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR3_U_SMXP_0_0",
        .addr = A_POR_MPU_M4_PRLAR3_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR4_U_SMXP_0_0",
        .addr = A_POR_MPU_M4_PRBAR4_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR4_U_SMXP_0_0",
        .addr = A_POR_MPU_M4_PRLAR4_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR5_U_SMXP_0_0",
        .addr = A_POR_MPU_M4_PRBAR5_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR5_U_SMXP_0_0",
        .addr = A_POR_MPU_M4_PRLAR5_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR6_U_SMXP_0_0",
        .addr = A_POR_MPU_M4_PRBAR6_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR6_U_SMXP_0_0",
        .addr = A_POR_MPU_M4_PRLAR6_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR7_U_SMXP_0_0",
        .addr = A_POR_MPU_M4_PRBAR7_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR7_U_SMXP_0_0",
        .addr = A_POR_MPU_M4_PRLAR7_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR8_U_SMXP_0_0",
        .addr = A_POR_MPU_M4_PRBAR8_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR8_U_SMXP_0_0",
        .addr = A_POR_MPU_M4_PRLAR8_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR9_U_SMXP_0_0",
        .addr = A_POR_MPU_M4_PRBAR9_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR9_U_SMXP_0_0",
        .addr = A_POR_MPU_M4_PRLAR9_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR10_U_SMXP_0_0",
        .addr = A_POR_MPU_M4_PRBAR10_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR10_U_SMXP_0_0",
        .addr = A_POR_MPU_M4_PRLAR10_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR11_U_SMXP_0_0",
        .addr = A_POR_MPU_M4_PRBAR11_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR11_U_SMXP_0_0",
        .addr = A_POR_MPU_M4_PRLAR11_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR12_U_SMXP_0_0",
        .addr = A_POR_MPU_M4_PRBAR12_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR12_U_SMXP_0_0",
        .addr = A_POR_MPU_M4_PRLAR12_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR13_U_SMXP_0_0",
        .addr = A_POR_MPU_M4_PRBAR13_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR13_U_SMXP_0_0",
        .addr = A_POR_MPU_M4_PRLAR13_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR14_U_SMXP_0_0",
        .addr = A_POR_MPU_M4_PRBAR14_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR14_U_SMXP_0_0",
        .addr = A_POR_MPU_M4_PRLAR14_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR15_U_SMXP_0_0",
        .addr = A_POR_MPU_M4_PRBAR15_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR15_U_SMXP_0_0",
        .addr = A_POR_MPU_M4_PRLAR15_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR16_U_SMXP_0_0",
        .addr = A_POR_MPU_M4_PRBAR16_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR16_U_SMXP_0_0",
        .addr = A_POR_MPU_M4_PRLAR16_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR17_U_SMXP_0_0",
        .addr = A_POR_MPU_M4_PRBAR17_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR17_U_SMXP_0_0",
        .addr = A_POR_MPU_M4_PRLAR17_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR18_U_SMXP_0_0",
        .addr = A_POR_MPU_M4_PRBAR18_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR18_U_SMXP_0_0",
        .addr = A_POR_MPU_M4_PRLAR18_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR19_U_SMXP_0_0",
        .addr = A_POR_MPU_M4_PRBAR19_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR19_U_SMXP_0_0",
        .addr = A_POR_MPU_M4_PRLAR19_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR20_U_SMXP_0_0",
        .addr = A_POR_MPU_M4_PRBAR20_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR20_U_SMXP_0_0",
        .addr = A_POR_MPU_M4_PRLAR20_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR21_U_SMXP_0_0",
        .addr = A_POR_MPU_M4_PRBAR21_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR21_U_SMXP_0_0",
        .addr = A_POR_MPU_M4_PRLAR21_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR22_U_SMXP_0_0",
        .addr = A_POR_MPU_M4_PRBAR22_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR22_U_SMXP_0_0",
        .addr = A_POR_MPU_M4_PRLAR22_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR23_U_SMXP_0_0",
        .addr = A_POR_MPU_M4_PRBAR23_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR23_U_SMXP_0_0",
        .addr = A_POR_MPU_M4_PRLAR23_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR24_U_SMXP_0_0",
        .addr = A_POR_MPU_M4_PRBAR24_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR24_U_SMXP_0_0",
        .addr = A_POR_MPU_M4_PRLAR24_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR25_U_SMXP_0_0",
        .addr = A_POR_MPU_M4_PRBAR25_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR25_U_SMXP_0_0",
        .addr = A_POR_MPU_M4_PRLAR25_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR26_U_SMXP_0_0",
        .addr = A_POR_MPU_M4_PRBAR26_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR26_U_SMXP_0_0",
        .addr = A_POR_MPU_M4_PRLAR26_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR27_U_SMXP_0_0",
        .addr = A_POR_MPU_M4_PRBAR27_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR27_U_SMXP_0_0",
        .addr = A_POR_MPU_M4_PRLAR27_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR28_U_SMXP_0_0",
        .addr = A_POR_MPU_M4_PRBAR28_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR28_U_SMXP_0_0",
        .addr = A_POR_MPU_M4_PRLAR28_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR29_U_SMXP_0_0",
        .addr = A_POR_MPU_M4_PRBAR29_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR29_U_SMXP_0_0",
        .addr = A_POR_MPU_M4_PRLAR29_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR30_U_SMXP_0_0",
        .addr = A_POR_MPU_M4_PRBAR30_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR30_U_SMXP_0_0",
        .addr = A_POR_MPU_M4_PRLAR30_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR31_U_SMXP_0_0",
        .addr = A_POR_MPU_M4_PRBAR31_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR31_U_SMXP_0_0",
        .addr = A_POR_MPU_M4_PRLAR31_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_CTL_U_SMXP_0_0",
        .addr = A_POR_MPU_M5_CTL_U_SMXP_0_0,
        .reset = 0x2,
        .rsvd = 0xfffffffffffffff8L,
        .ro = 0xfffffffffffffff8L,
    },{ .name = "POR_MPU_M5_PRBAR0_U_SMXP_0_0",
        .addr = A_POR_MPU_M5_PRBAR0_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR0_U_SMXP_0_0",
        .addr = A_POR_MPU_M5_PRLAR0_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR1_U_SMXP_0_0",
        .addr = A_POR_MPU_M5_PRBAR1_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR1_U_SMXP_0_0",
        .addr = A_POR_MPU_M5_PRLAR1_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR2_U_SMXP_0_0",
        .addr = A_POR_MPU_M5_PRBAR2_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR2_U_SMXP_0_0",
        .addr = A_POR_MPU_M5_PRLAR2_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR3_U_SMXP_0_0",
        .addr = A_POR_MPU_M5_PRBAR3_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR3_U_SMXP_0_0",
        .addr = A_POR_MPU_M5_PRLAR3_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR4_U_SMXP_0_0",
        .addr = A_POR_MPU_M5_PRBAR4_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR4_U_SMXP_0_0",
        .addr = A_POR_MPU_M5_PRLAR4_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR5_U_SMXP_0_0",
        .addr = A_POR_MPU_M5_PRBAR5_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR5_U_SMXP_0_0",
        .addr = A_POR_MPU_M5_PRLAR5_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR6_U_SMXP_0_0",
        .addr = A_POR_MPU_M5_PRBAR6_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR6_U_SMXP_0_0",
        .addr = A_POR_MPU_M5_PRLAR6_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR7_U_SMXP_0_0",
        .addr = A_POR_MPU_M5_PRBAR7_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR7_U_SMXP_0_0",
        .addr = A_POR_MPU_M5_PRLAR7_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR8_U_SMXP_0_0",
        .addr = A_POR_MPU_M5_PRBAR8_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR8_U_SMXP_0_0",
        .addr = A_POR_MPU_M5_PRLAR8_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR9_U_SMXP_0_0",
        .addr = A_POR_MPU_M5_PRBAR9_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR9_U_SMXP_0_0",
        .addr = A_POR_MPU_M5_PRLAR9_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR10_U_SMXP_0_0",
        .addr = A_POR_MPU_M5_PRBAR10_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR10_U_SMXP_0_0",
        .addr = A_POR_MPU_M5_PRLAR10_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR11_U_SMXP_0_0",
        .addr = A_POR_MPU_M5_PRBAR11_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR11_U_SMXP_0_0",
        .addr = A_POR_MPU_M5_PRLAR11_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR12_U_SMXP_0_0",
        .addr = A_POR_MPU_M5_PRBAR12_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR12_U_SMXP_0_0",
        .addr = A_POR_MPU_M5_PRLAR12_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR13_U_SMXP_0_0",
        .addr = A_POR_MPU_M5_PRBAR13_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR13_U_SMXP_0_0",
        .addr = A_POR_MPU_M5_PRLAR13_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR14_U_SMXP_0_0",
        .addr = A_POR_MPU_M5_PRBAR14_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR14_U_SMXP_0_0",
        .addr = A_POR_MPU_M5_PRLAR14_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR15_U_SMXP_0_0",
        .addr = A_POR_MPU_M5_PRBAR15_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR15_U_SMXP_0_0",
        .addr = A_POR_MPU_M5_PRLAR15_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR16_U_SMXP_0_0",
        .addr = A_POR_MPU_M5_PRBAR16_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR16_U_SMXP_0_0",
        .addr = A_POR_MPU_M5_PRLAR16_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR17_U_SMXP_0_0",
        .addr = A_POR_MPU_M5_PRBAR17_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR17_U_SMXP_0_0",
        .addr = A_POR_MPU_M5_PRLAR17_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR18_U_SMXP_0_0",
        .addr = A_POR_MPU_M5_PRBAR18_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR18_U_SMXP_0_0",
        .addr = A_POR_MPU_M5_PRLAR18_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR19_U_SMXP_0_0",
        .addr = A_POR_MPU_M5_PRBAR19_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR19_U_SMXP_0_0",
        .addr = A_POR_MPU_M5_PRLAR19_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR20_U_SMXP_0_0",
        .addr = A_POR_MPU_M5_PRBAR20_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR20_U_SMXP_0_0",
        .addr = A_POR_MPU_M5_PRLAR20_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR21_U_SMXP_0_0",
        .addr = A_POR_MPU_M5_PRBAR21_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR21_U_SMXP_0_0",
        .addr = A_POR_MPU_M5_PRLAR21_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR22_U_SMXP_0_0",
        .addr = A_POR_MPU_M5_PRBAR22_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR22_U_SMXP_0_0",
        .addr = A_POR_MPU_M5_PRLAR22_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR23_U_SMXP_0_0",
        .addr = A_POR_MPU_M5_PRBAR23_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR23_U_SMXP_0_0",
        .addr = A_POR_MPU_M5_PRLAR23_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR24_U_SMXP_0_0",
        .addr = A_POR_MPU_M5_PRBAR24_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR24_U_SMXP_0_0",
        .addr = A_POR_MPU_M5_PRLAR24_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR25_U_SMXP_0_0",
        .addr = A_POR_MPU_M5_PRBAR25_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR25_U_SMXP_0_0",
        .addr = A_POR_MPU_M5_PRLAR25_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR26_U_SMXP_0_0",
        .addr = A_POR_MPU_M5_PRBAR26_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR26_U_SMXP_0_0",
        .addr = A_POR_MPU_M5_PRLAR26_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR27_U_SMXP_0_0",
        .addr = A_POR_MPU_M5_PRBAR27_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR27_U_SMXP_0_0",
        .addr = A_POR_MPU_M5_PRLAR27_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR28_U_SMXP_0_0",
        .addr = A_POR_MPU_M5_PRBAR28_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR28_U_SMXP_0_0",
        .addr = A_POR_MPU_M5_PRLAR28_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR29_U_SMXP_0_0",
        .addr = A_POR_MPU_M5_PRBAR29_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR29_U_SMXP_0_0",
        .addr = A_POR_MPU_M5_PRLAR29_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR30_U_SMXP_0_0",
        .addr = A_POR_MPU_M5_PRBAR30_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR30_U_SMXP_0_0",
        .addr = A_POR_MPU_M5_PRLAR30_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR31_U_SMXP_0_0",
        .addr = A_POR_MPU_M5_PRBAR31_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR31_U_SMXP_0_0",
        .addr = A_POR_MPU_M5_PRLAR31_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_CTL_U_SMXP_0_0",
        .addr = A_POR_MPU_M6_CTL_U_SMXP_0_0,
        .reset = 0x2,
        .rsvd = 0xfffffffffffffff8L,
        .ro = 0xfffffffffffffff8L,
    },{ .name = "POR_MPU_M6_PRBAR0_U_SMXP_0_0",
        .addr = A_POR_MPU_M6_PRBAR0_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR0_U_SMXP_0_0",
        .addr = A_POR_MPU_M6_PRLAR0_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR1_U_SMXP_0_0",
        .addr = A_POR_MPU_M6_PRBAR1_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR1_U_SMXP_0_0",
        .addr = A_POR_MPU_M6_PRLAR1_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR2_U_SMXP_0_0",
        .addr = A_POR_MPU_M6_PRBAR2_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR2_U_SMXP_0_0",
        .addr = A_POR_MPU_M6_PRLAR2_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR3_U_SMXP_0_0",
        .addr = A_POR_MPU_M6_PRBAR3_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR3_U_SMXP_0_0",
        .addr = A_POR_MPU_M6_PRLAR3_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR4_U_SMXP_0_0",
        .addr = A_POR_MPU_M6_PRBAR4_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR4_U_SMXP_0_0",
        .addr = A_POR_MPU_M6_PRLAR4_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR5_U_SMXP_0_0",
        .addr = A_POR_MPU_M6_PRBAR5_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR5_U_SMXP_0_0",
        .addr = A_POR_MPU_M6_PRLAR5_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR6_U_SMXP_0_0",
        .addr = A_POR_MPU_M6_PRBAR6_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR6_U_SMXP_0_0",
        .addr = A_POR_MPU_M6_PRLAR6_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR7_U_SMXP_0_0",
        .addr = A_POR_MPU_M6_PRBAR7_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR7_U_SMXP_0_0",
        .addr = A_POR_MPU_M6_PRLAR7_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR8_U_SMXP_0_0",
        .addr = A_POR_MPU_M6_PRBAR8_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR8_U_SMXP_0_0",
        .addr = A_POR_MPU_M6_PRLAR8_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR9_U_SMXP_0_0",
        .addr = A_POR_MPU_M6_PRBAR9_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR9_U_SMXP_0_0",
        .addr = A_POR_MPU_M6_PRLAR9_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR10_U_SMXP_0_0",
        .addr = A_POR_MPU_M6_PRBAR10_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR10_U_SMXP_0_0",
        .addr = A_POR_MPU_M6_PRLAR10_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR11_U_SMXP_0_0",
        .addr = A_POR_MPU_M6_PRBAR11_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR11_U_SMXP_0_0",
        .addr = A_POR_MPU_M6_PRLAR11_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR12_U_SMXP_0_0",
        .addr = A_POR_MPU_M6_PRBAR12_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR12_U_SMXP_0_0",
        .addr = A_POR_MPU_M6_PRLAR12_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR13_U_SMXP_0_0",
        .addr = A_POR_MPU_M6_PRBAR13_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR13_U_SMXP_0_0",
        .addr = A_POR_MPU_M6_PRLAR13_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR14_U_SMXP_0_0",
        .addr = A_POR_MPU_M6_PRBAR14_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR14_U_SMXP_0_0",
        .addr = A_POR_MPU_M6_PRLAR14_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR15_U_SMXP_0_0",
        .addr = A_POR_MPU_M6_PRBAR15_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR15_U_SMXP_0_0",
        .addr = A_POR_MPU_M6_PRLAR15_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR16_U_SMXP_0_0",
        .addr = A_POR_MPU_M6_PRBAR16_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR16_U_SMXP_0_0",
        .addr = A_POR_MPU_M6_PRLAR16_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR17_U_SMXP_0_0",
        .addr = A_POR_MPU_M6_PRBAR17_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR17_U_SMXP_0_0",
        .addr = A_POR_MPU_M6_PRLAR17_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR18_U_SMXP_0_0",
        .addr = A_POR_MPU_M6_PRBAR18_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR18_U_SMXP_0_0",
        .addr = A_POR_MPU_M6_PRLAR18_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR19_U_SMXP_0_0",
        .addr = A_POR_MPU_M6_PRBAR19_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR19_U_SMXP_0_0",
        .addr = A_POR_MPU_M6_PRLAR19_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR20_U_SMXP_0_0",
        .addr = A_POR_MPU_M6_PRBAR20_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR20_U_SMXP_0_0",
        .addr = A_POR_MPU_M6_PRLAR20_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR21_U_SMXP_0_0",
        .addr = A_POR_MPU_M6_PRBAR21_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR21_U_SMXP_0_0",
        .addr = A_POR_MPU_M6_PRLAR21_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR22_U_SMXP_0_0",
        .addr = A_POR_MPU_M6_PRBAR22_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR22_U_SMXP_0_0",
        .addr = A_POR_MPU_M6_PRLAR22_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR23_U_SMXP_0_0",
        .addr = A_POR_MPU_M6_PRBAR23_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR23_U_SMXP_0_0",
        .addr = A_POR_MPU_M6_PRLAR23_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR24_U_SMXP_0_0",
        .addr = A_POR_MPU_M6_PRBAR24_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR24_U_SMXP_0_0",
        .addr = A_POR_MPU_M6_PRLAR24_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR25_U_SMXP_0_0",
        .addr = A_POR_MPU_M6_PRBAR25_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR25_U_SMXP_0_0",
        .addr = A_POR_MPU_M6_PRLAR25_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR26_U_SMXP_0_0",
        .addr = A_POR_MPU_M6_PRBAR26_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR26_U_SMXP_0_0",
        .addr = A_POR_MPU_M6_PRLAR26_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR27_U_SMXP_0_0",
        .addr = A_POR_MPU_M6_PRBAR27_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR27_U_SMXP_0_0",
        .addr = A_POR_MPU_M6_PRLAR27_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR28_U_SMXP_0_0",
        .addr = A_POR_MPU_M6_PRBAR28_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR28_U_SMXP_0_0",
        .addr = A_POR_MPU_M6_PRLAR28_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR29_U_SMXP_0_0",
        .addr = A_POR_MPU_M6_PRBAR29_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR29_U_SMXP_0_0",
        .addr = A_POR_MPU_M6_PRLAR29_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR30_U_SMXP_0_0",
        .addr = A_POR_MPU_M6_PRBAR30_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR30_U_SMXP_0_0",
        .addr = A_POR_MPU_M6_PRLAR30_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR31_U_SMXP_0_0",
        .addr = A_POR_MPU_M6_PRBAR31_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR31_U_SMXP_0_0",
        .addr = A_POR_MPU_M6_PRLAR31_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_CTL_U_SMXP_0_0",
        .addr = A_POR_MPU_M7_CTL_U_SMXP_0_0,
        .reset = 0x2,
        .rsvd = 0xfffffffffffffff8L,
        .ro = 0xfffffffffffffff8L,
    },{ .name = "POR_MPU_M7_PRBAR0_U_SMXP_0_0",
        .addr = A_POR_MPU_M7_PRBAR0_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR0_U_SMXP_0_0",
        .addr = A_POR_MPU_M7_PRLAR0_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR1_U_SMXP_0_0",
        .addr = A_POR_MPU_M7_PRBAR1_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR1_U_SMXP_0_0",
        .addr = A_POR_MPU_M7_PRLAR1_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR2_U_SMXP_0_0",
        .addr = A_POR_MPU_M7_PRBAR2_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR2_U_SMXP_0_0",
        .addr = A_POR_MPU_M7_PRLAR2_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR3_U_SMXP_0_0",
        .addr = A_POR_MPU_M7_PRBAR3_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR3_U_SMXP_0_0",
        .addr = A_POR_MPU_M7_PRLAR3_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR4_U_SMXP_0_0",
        .addr = A_POR_MPU_M7_PRBAR4_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR4_U_SMXP_0_0",
        .addr = A_POR_MPU_M7_PRLAR4_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR5_U_SMXP_0_0",
        .addr = A_POR_MPU_M7_PRBAR5_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR5_U_SMXP_0_0",
        .addr = A_POR_MPU_M7_PRLAR5_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR6_U_SMXP_0_0",
        .addr = A_POR_MPU_M7_PRBAR6_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR6_U_SMXP_0_0",
        .addr = A_POR_MPU_M7_PRLAR6_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR7_U_SMXP_0_0",
        .addr = A_POR_MPU_M7_PRBAR7_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR7_U_SMXP_0_0",
        .addr = A_POR_MPU_M7_PRLAR7_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR8_U_SMXP_0_0",
        .addr = A_POR_MPU_M7_PRBAR8_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR8_U_SMXP_0_0",
        .addr = A_POR_MPU_M7_PRLAR8_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR9_U_SMXP_0_0",
        .addr = A_POR_MPU_M7_PRBAR9_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR9_U_SMXP_0_0",
        .addr = A_POR_MPU_M7_PRLAR9_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR10_U_SMXP_0_0",
        .addr = A_POR_MPU_M7_PRBAR10_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR10_U_SMXP_0_0",
        .addr = A_POR_MPU_M7_PRLAR10_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR11_U_SMXP_0_0",
        .addr = A_POR_MPU_M7_PRBAR11_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR11_U_SMXP_0_0",
        .addr = A_POR_MPU_M7_PRLAR11_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR12_U_SMXP_0_0",
        .addr = A_POR_MPU_M7_PRBAR12_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR12_U_SMXP_0_0",
        .addr = A_POR_MPU_M7_PRLAR12_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR13_U_SMXP_0_0",
        .addr = A_POR_MPU_M7_PRBAR13_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR13_U_SMXP_0_0",
        .addr = A_POR_MPU_M7_PRLAR13_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR14_U_SMXP_0_0",
        .addr = A_POR_MPU_M7_PRBAR14_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR14_U_SMXP_0_0",
        .addr = A_POR_MPU_M7_PRLAR14_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR15_U_SMXP_0_0",
        .addr = A_POR_MPU_M7_PRBAR15_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR15_U_SMXP_0_0",
        .addr = A_POR_MPU_M7_PRLAR15_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR16_U_SMXP_0_0",
        .addr = A_POR_MPU_M7_PRBAR16_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR16_U_SMXP_0_0",
        .addr = A_POR_MPU_M7_PRLAR16_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR17_U_SMXP_0_0",
        .addr = A_POR_MPU_M7_PRBAR17_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR17_U_SMXP_0_0",
        .addr = A_POR_MPU_M7_PRLAR17_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR18_U_SMXP_0_0",
        .addr = A_POR_MPU_M7_PRBAR18_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR18_U_SMXP_0_0",
        .addr = A_POR_MPU_M7_PRLAR18_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR19_U_SMXP_0_0",
        .addr = A_POR_MPU_M7_PRBAR19_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR19_U_SMXP_0_0",
        .addr = A_POR_MPU_M7_PRLAR19_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR20_U_SMXP_0_0",
        .addr = A_POR_MPU_M7_PRBAR20_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR20_U_SMXP_0_0",
        .addr = A_POR_MPU_M7_PRLAR20_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR21_U_SMXP_0_0",
        .addr = A_POR_MPU_M7_PRBAR21_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR21_U_SMXP_0_0",
        .addr = A_POR_MPU_M7_PRLAR21_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR22_U_SMXP_0_0",
        .addr = A_POR_MPU_M7_PRBAR22_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR22_U_SMXP_0_0",
        .addr = A_POR_MPU_M7_PRLAR22_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR23_U_SMXP_0_0",
        .addr = A_POR_MPU_M7_PRBAR23_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR23_U_SMXP_0_0",
        .addr = A_POR_MPU_M7_PRLAR23_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR24_U_SMXP_0_0",
        .addr = A_POR_MPU_M7_PRBAR24_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR24_U_SMXP_0_0",
        .addr = A_POR_MPU_M7_PRLAR24_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR25_U_SMXP_0_0",
        .addr = A_POR_MPU_M7_PRBAR25_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR25_U_SMXP_0_0",
        .addr = A_POR_MPU_M7_PRLAR25_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR26_U_SMXP_0_0",
        .addr = A_POR_MPU_M7_PRBAR26_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR26_U_SMXP_0_0",
        .addr = A_POR_MPU_M7_PRLAR26_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR27_U_SMXP_0_0",
        .addr = A_POR_MPU_M7_PRBAR27_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR27_U_SMXP_0_0",
        .addr = A_POR_MPU_M7_PRLAR27_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR28_U_SMXP_0_0",
        .addr = A_POR_MPU_M7_PRBAR28_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR28_U_SMXP_0_0",
        .addr = A_POR_MPU_M7_PRLAR28_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR29_U_SMXP_0_0",
        .addr = A_POR_MPU_M7_PRBAR29_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR29_U_SMXP_0_0",
        .addr = A_POR_MPU_M7_PRLAR29_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR30_U_SMXP_0_0",
        .addr = A_POR_MPU_M7_PRBAR30_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR30_U_SMXP_0_0",
        .addr = A_POR_MPU_M7_PRLAR30_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR31_U_SMXP_0_0",
        .addr = A_POR_MPU_M7_PRBAR31_U_SMXP_0_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR31_U_SMXP_0_0",
        .addr = A_POR_MPU_M7_PRLAR31_U_SMXP_0_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_HNF_NODE_INFO_U_HNF_NID8",
        .addr = A_POR_HNF_NODE_INFO_U_HNF_NID8,
        .reset = 0x80005,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_HNF_CHILD_INFO_U_HNF_NID8",
        .addr = A_POR_HNF_CHILD_INFO_U_HNF_NID8,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_HNF_UNIT_INFO_U_HNF_NID8",
        .addr = A_POR_HNF_UNIT_INFO_U_HNF_NID8,
        .reset = 0x4000000000,
        .rsvd = 0x88,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_HNF_SECURE_REGISTER_GROUPS_OVERRIDE_U_HNF_NID8",
        .addr = A_POR_HNF_SECURE_REGISTER_GROUPS_OVERRIDE_U_HNF_NID8,
        .rsvd = 0xffffffffffffffc0L,
        .ro = 0xffffffffffffffc0L,
    },{ .name = "POR_HNF_CFG_CTL_U_HNF_NID8",
        .addr = A_POR_HNF_CFG_CTL_U_HNF_NID8,
        .reset = 0x50,
        .rsvd = 0xaa,
        .ro = 0xfffffffffffff0aaL,
    },{ .name = "POR_HNF_AUX_CTL_U_HNF_NID8",
        .addr = A_POR_HNF_AUX_CTL_U_HNF_NID8,
        .reset = 0x11c4c9000000002,
        .ro = 0xfc60006cfffe0000L,
    },{ .name = "POR_HNF_R2_AUX_CTL_U_HNF_NID8",
        .addr = A_POR_HNF_R2_AUX_CTL_U_HNF_NID8,
        .rsvd = 0xfffffffffffffff0L,
        .ro = 0xfffffffffffffff0L,
    },{ .name = "RDF_HNF_AUX_CTL_U_HNF_NID8",
        .addr = A_RDF_HNF_AUX_CTL_U_HNF_NID8,
        .ro = 0xffffffffffff6cffL,
    },{ .name = "POR_HNF_QOS_BAND_U_HNF_NID8",
        .addr = A_POR_HNF_QOS_BAND_U_HNF_NID8,
        .reset = 0xffecb870,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_HNF_QOS_RESERVATION_U_HNF_NID8",
        .addr = A_POR_HNF_QOS_RESERVATION_U_HNF_NID8,
        .reset = 0x13f3e1f0a,
        .rsvd = 0xc0,
        .ro = 0xffffffc0c0c0c0c0L,
    },{ .name = "POR_HNF_RN_STARVATION_U_HNF_NID8",
        .addr = A_POR_HNF_RN_STARVATION_U_HNF_NID8,
        .reset = 0x1f3f1f3f3f1f,
        .rsvd = 0xe0,
        .ro = 0xffffe0c0e080c0e0L,
    },{ .name = "POR_HNF_CFG_SLCSF_DBGRD_U_HNF_NID8",
        .addr = A_POR_HNF_CFG_SLCSF_DBGRD_U_HNF_NID8,
        .ro = 0xfffffffffc80e000L,
    },{ .name = "POR_HNF_SLC_CACHE_ACCESS_SLC_TAG_U_HNF_NID8",
        .addr = A_POR_HNF_SLC_CACHE_ACCESS_SLC_TAG_U_HNF_NID8,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_HNF_SLC_CACHE_ACCESS_SLC_DATA_U_HNF_NID8",
        .addr = A_POR_HNF_SLC_CACHE_ACCESS_SLC_DATA_U_HNF_NID8,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_HNF_SLC_CACHE_ACCESS_SF_TAG_U_HNF_NID8",
        .addr = A_POR_HNF_SLC_CACHE_ACCESS_SF_TAG_U_HNF_NID8,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_HNF_SLC_CACHE_ACCESS_SF_TAG1_U_HNF_NID8",
        .addr = A_POR_HNF_SLC_CACHE_ACCESS_SF_TAG1_U_HNF_NID8,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_HNF_SLC_CACHE_ACCESS_SF_TAG2_U_HNF_NID8",
        .addr = A_POR_HNF_SLC_CACHE_ACCESS_SF_TAG2_U_HNF_NID8,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_HNF_SLC_LOCK_WAYS_U_HNF_NID8",
        .addr = A_POR_HNF_SLC_LOCK_WAYS_U_HNF_NID8,
        .reset = 0x400,
        .rsvd = 0xf0,
        .ro = 0xffffffffffff80f0L,
    },{ .name = "POR_HNF_SLC_LOCK_BASE0_U_HNF_NID8",
        .addr = A_POR_HNF_SLC_LOCK_BASE0_U_HNF_NID8,
        .ro = 0x7fff000000000000,
    },{ .name = "POR_HNF_SLC_LOCK_BASE1_U_HNF_NID8",
        .addr = A_POR_HNF_SLC_LOCK_BASE1_U_HNF_NID8,
        .ro = 0x7fff000000000000,
    },{ .name = "POR_HNF_SLC_LOCK_BASE2_U_HNF_NID8",
        .addr = A_POR_HNF_SLC_LOCK_BASE2_U_HNF_NID8,
        .ro = 0x7fff000000000000,
    },{ .name = "POR_HNF_SLC_LOCK_BASE3_U_HNF_NID8",
        .addr = A_POR_HNF_SLC_LOCK_BASE3_U_HNF_NID8,
        .ro = 0x7fff000000000000,
    },{ .name = "POR_HNF_RNF_REGION_VEC1_U_HNF_NID8",
        .addr = A_POR_HNF_RNF_REGION_VEC1_U_HNF_NID8,
    },{ .name = "POR_HNF_RNI_REGION_VEC_U_HNF_NID8",
        .addr = A_POR_HNF_RNI_REGION_VEC_U_HNF_NID8,
        .ro = 0xffffffff00000000L,
    },{ .name = "POR_HNF_RNF_REGION_VEC_U_HNF_NID8",
        .addr = A_POR_HNF_RNF_REGION_VEC_U_HNF_NID8,
    },{ .name = "POR_HNF_RND_REGION_VEC_U_HNF_NID8",
        .addr = A_POR_HNF_RND_REGION_VEC_U_HNF_NID8,
        .ro = 0xffffffff00000000L,
    },{ .name = "POR_HNF_SLCWAY_PARTITION0_RNF_VEC_U_HNF_NID8",
        .addr = A_POR_HNF_SLCWAY_PARTITION0_RNF_VEC_U_HNF_NID8,
        .reset = 0xffffffffffffffffL,
    },{ .name = "POR_HNF_SLCWAY_PARTITION1_RNF_VEC_U_HNF_NID8",
        .addr = A_POR_HNF_SLCWAY_PARTITION1_RNF_VEC_U_HNF_NID8,
        .reset = 0xffffffffffffffffL,
    },{ .name = "POR_HNF_SLCWAY_PARTITION2_RNF_VEC_U_HNF_NID8",
        .addr = A_POR_HNF_SLCWAY_PARTITION2_RNF_VEC_U_HNF_NID8,
        .reset = 0xffffffffffffffffL,
    },{ .name = "POR_HNF_SLCWAY_PARTITION3_RNF_VEC_U_HNF_NID8",
        .addr = A_POR_HNF_SLCWAY_PARTITION3_RNF_VEC_U_HNF_NID8,
        .reset = 0xffffffffffffffffL,
    },{ .name = "POR_HNF_SLCWAY_PARTITION0_RNI_VEC_U_HNF_NID8",
        .addr = A_POR_HNF_SLCWAY_PARTITION0_RNI_VEC_U_HNF_NID8,
        .reset = 0xffffffff,
        .ro = 0xffffffff00000000L,
    },{ .name = "POR_HNF_SLCWAY_PARTITION1_RNI_VEC_U_HNF_NID8",
        .addr = A_POR_HNF_SLCWAY_PARTITION1_RNI_VEC_U_HNF_NID8,
        .reset = 0xffffffff,
        .ro = 0xffffffff00000000L,
    },{ .name = "POR_HNF_SLCWAY_PARTITION2_RNI_VEC_U_HNF_NID8",
        .addr = A_POR_HNF_SLCWAY_PARTITION2_RNI_VEC_U_HNF_NID8,
        .reset = 0xffffffff,
        .ro = 0xffffffff00000000L,
    },{ .name = "POR_HNF_SLCWAY_PARTITION3_RNI_VEC_U_HNF_NID8",
        .addr = A_POR_HNF_SLCWAY_PARTITION3_RNI_VEC_U_HNF_NID8,
        .reset = 0xffffffff,
        .ro = 0xffffffff00000000L,
    },{ .name = "POR_HNF_SLCWAY_PARTITION0_RND_VEC_U_HNF_NID8",
        .addr = A_POR_HNF_SLCWAY_PARTITION0_RND_VEC_U_HNF_NID8,
        .reset = 0xffffffff,
        .ro = 0xffffffff00000000L,
    },{ .name = "POR_HNF_SLCWAY_PARTITION1_RND_VEC_U_HNF_NID8",
        .addr = A_POR_HNF_SLCWAY_PARTITION1_RND_VEC_U_HNF_NID8,
        .reset = 0xffffffff,
        .ro = 0xffffffff00000000L,
    },{ .name = "POR_HNF_SLCWAY_PARTITION2_RND_VEC_U_HNF_NID8",
        .addr = A_POR_HNF_SLCWAY_PARTITION2_RND_VEC_U_HNF_NID8,
        .reset = 0xffffffff,
        .ro = 0xffffffff00000000L,
    },{ .name = "POR_HNF_SLCWAY_PARTITION3_RND_VEC_U_HNF_NID8",
        .addr = A_POR_HNF_SLCWAY_PARTITION3_RND_VEC_U_HNF_NID8,
        .reset = 0xffffffff,
        .ro = 0xffffffff00000000L,
    },{ .name = "POR_HNF_RN_REGION_LOCK_U_HNF_NID8",
        .addr = A_POR_HNF_RN_REGION_LOCK_U_HNF_NID8,
        .rsvd = 0xfffffffffffffffcL,
        .ro = 0xfffffffffffffffcL,
    },{ .name = "POR_HNF_SLCWAY_PARTITION0_RNF_VEC1_U_HNF_NID8",
        .addr = A_POR_HNF_SLCWAY_PARTITION0_RNF_VEC1_U_HNF_NID8,
        .reset = 0xffffffffffffffffL,
    },{ .name = "POR_HNF_SLCWAY_PARTITION1_RNF_VEC1_U_HNF_NID8",
        .addr = A_POR_HNF_SLCWAY_PARTITION1_RNF_VEC1_U_HNF_NID8,
        .reset = 0xffffffffffffffffL,
    },{ .name = "POR_HNF_SLCWAY_PARTITION2_RNF_VEC1_U_HNF_NID8",
        .addr = A_POR_HNF_SLCWAY_PARTITION2_RNF_VEC1_U_HNF_NID8,
        .reset = 0xffffffffffffffffL,
    },{ .name = "POR_HNF_SLCWAY_PARTITION3_RNF_VEC1_U_HNF_NID8",
        .addr = A_POR_HNF_SLCWAY_PARTITION3_RNF_VEC1_U_HNF_NID8,
        .reset = 0xffffffffffffffffL,
    },{ .name = "POR_HNF_SAM_CONTROL_U_HNF_NID8",
        .addr = A_POR_HNF_SAM_CONTROL_U_HNF_NID8,
        .ro = 0x40c0c0c800800800,
    },{ .name = "POR_HNF_SAM_MEMREGION0_U_HNF_NID8",
        .addr = A_POR_HNF_SAM_MEMREGION0_U_HNF_NID8,
        .ro = 0x7fff000003fe0800,
    },{ .name = "POR_HNF_SAM_MEMREGION1_U_HNF_NID8",
        .addr = A_POR_HNF_SAM_MEMREGION1_U_HNF_NID8,
        .ro = 0x7fff000003fe0800,
    },{ .name = "POR_HNF_SAM_SN_PROPERTIES_U_HNF_NID8",
        .addr = A_POR_HNF_SAM_SN_PROPERTIES_U_HNF_NID8,
        .rsvd = 0x38,
        .ro = 0xffffe38e38e38e38L,
    },{ .name = "POR_HNF_SAM_6SN_NODEID_U_HNF_NID8",
        .addr = A_POR_HNF_SAM_6SN_NODEID_U_HNF_NID8,
        .ro = 0xfffffff800800800L,
    },{ .name = "POR_HNF_RN_PHYS_ID0_U_HNF_NID8",
        .addr = A_POR_HNF_RN_PHYS_ID0_U_HNF_NID8,
        .reset = 0x8000004c8000000cL,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID1_U_HNF_NID8",
        .addr = A_POR_HNF_RN_PHYS_ID1_U_HNF_NID8,
        .reset = 0x800000cc8000008cL,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID2_U_HNF_NID8",
        .addr = A_POR_HNF_RN_PHYS_ID2_U_HNF_NID8,
        .reset = 0x8000010c,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID3_U_HNF_NID8",
        .addr = A_POR_HNF_RN_PHYS_ID3_U_HNF_NID8,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID4_U_HNF_NID8",
        .addr = A_POR_HNF_RN_PHYS_ID4_U_HNF_NID8,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID5_U_HNF_NID8",
        .addr = A_POR_HNF_RN_PHYS_ID5_U_HNF_NID8,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID6_U_HNF_NID8",
        .addr = A_POR_HNF_RN_PHYS_ID6_U_HNF_NID8,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID7_U_HNF_NID8",
        .addr = A_POR_HNF_RN_PHYS_ID7_U_HNF_NID8,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID8_U_HNF_NID8",
        .addr = A_POR_HNF_RN_PHYS_ID8_U_HNF_NID8,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID9_U_HNF_NID8",
        .addr = A_POR_HNF_RN_PHYS_ID9_U_HNF_NID8,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID10_U_HNF_NID8",
        .addr = A_POR_HNF_RN_PHYS_ID10_U_HNF_NID8,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID11_U_HNF_NID8",
        .addr = A_POR_HNF_RN_PHYS_ID11_U_HNF_NID8,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID12_U_HNF_NID8",
        .addr = A_POR_HNF_RN_PHYS_ID12_U_HNF_NID8,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID13_U_HNF_NID8",
        .addr = A_POR_HNF_RN_PHYS_ID13_U_HNF_NID8,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID14_U_HNF_NID8",
        .addr = A_POR_HNF_RN_PHYS_ID14_U_HNF_NID8,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID15_U_HNF_NID8",
        .addr = A_POR_HNF_RN_PHYS_ID15_U_HNF_NID8,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID16_U_HNF_NID8",
        .addr = A_POR_HNF_RN_PHYS_ID16_U_HNF_NID8,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID17_U_HNF_NID8",
        .addr = A_POR_HNF_RN_PHYS_ID17_U_HNF_NID8,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID18_U_HNF_NID8",
        .addr = A_POR_HNF_RN_PHYS_ID18_U_HNF_NID8,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID19_U_HNF_NID8",
        .addr = A_POR_HNF_RN_PHYS_ID19_U_HNF_NID8,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID20_U_HNF_NID8",
        .addr = A_POR_HNF_RN_PHYS_ID20_U_HNF_NID8,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID21_U_HNF_NID8",
        .addr = A_POR_HNF_RN_PHYS_ID21_U_HNF_NID8,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID22_U_HNF_NID8",
        .addr = A_POR_HNF_RN_PHYS_ID22_U_HNF_NID8,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID23_U_HNF_NID8",
        .addr = A_POR_HNF_RN_PHYS_ID23_U_HNF_NID8,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID24_U_HNF_NID8",
        .addr = A_POR_HNF_RN_PHYS_ID24_U_HNF_NID8,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID25_U_HNF_NID8",
        .addr = A_POR_HNF_RN_PHYS_ID25_U_HNF_NID8,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID26_U_HNF_NID8",
        .addr = A_POR_HNF_RN_PHYS_ID26_U_HNF_NID8,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID27_U_HNF_NID8",
        .addr = A_POR_HNF_RN_PHYS_ID27_U_HNF_NID8,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID28_U_HNF_NID8",
        .addr = A_POR_HNF_RN_PHYS_ID28_U_HNF_NID8,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID29_U_HNF_NID8",
        .addr = A_POR_HNF_RN_PHYS_ID29_U_HNF_NID8,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID30_U_HNF_NID8",
        .addr = A_POR_HNF_RN_PHYS_ID30_U_HNF_NID8,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID31_U_HNF_NID8",
        .addr = A_POR_HNF_RN_PHYS_ID31_U_HNF_NID8,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID32_U_HNF_NID8",
        .addr = A_POR_HNF_RN_PHYS_ID32_U_HNF_NID8,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID33_U_HNF_NID8",
        .addr = A_POR_HNF_RN_PHYS_ID33_U_HNF_NID8,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID34_U_HNF_NID8",
        .addr = A_POR_HNF_RN_PHYS_ID34_U_HNF_NID8,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID35_U_HNF_NID8",
        .addr = A_POR_HNF_RN_PHYS_ID35_U_HNF_NID8,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID36_U_HNF_NID8",
        .addr = A_POR_HNF_RN_PHYS_ID36_U_HNF_NID8,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID37_U_HNF_NID8",
        .addr = A_POR_HNF_RN_PHYS_ID37_U_HNF_NID8,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID38_U_HNF_NID8",
        .addr = A_POR_HNF_RN_PHYS_ID38_U_HNF_NID8,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID39_U_HNF_NID8",
        .addr = A_POR_HNF_RN_PHYS_ID39_U_HNF_NID8,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID40_U_HNF_NID8",
        .addr = A_POR_HNF_RN_PHYS_ID40_U_HNF_NID8,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID41_U_HNF_NID8",
        .addr = A_POR_HNF_RN_PHYS_ID41_U_HNF_NID8,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID42_U_HNF_NID8",
        .addr = A_POR_HNF_RN_PHYS_ID42_U_HNF_NID8,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID43_U_HNF_NID8",
        .addr = A_POR_HNF_RN_PHYS_ID43_U_HNF_NID8,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID44_U_HNF_NID8",
        .addr = A_POR_HNF_RN_PHYS_ID44_U_HNF_NID8,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID45_U_HNF_NID8",
        .addr = A_POR_HNF_RN_PHYS_ID45_U_HNF_NID8,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID46_U_HNF_NID8",
        .addr = A_POR_HNF_RN_PHYS_ID46_U_HNF_NID8,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID47_U_HNF_NID8",
        .addr = A_POR_HNF_RN_PHYS_ID47_U_HNF_NID8,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID48_U_HNF_NID8",
        .addr = A_POR_HNF_RN_PHYS_ID48_U_HNF_NID8,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID49_U_HNF_NID8",
        .addr = A_POR_HNF_RN_PHYS_ID49_U_HNF_NID8,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID50_U_HNF_NID8",
        .addr = A_POR_HNF_RN_PHYS_ID50_U_HNF_NID8,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID51_U_HNF_NID8",
        .addr = A_POR_HNF_RN_PHYS_ID51_U_HNF_NID8,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID52_U_HNF_NID8",
        .addr = A_POR_HNF_RN_PHYS_ID52_U_HNF_NID8,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID53_U_HNF_NID8",
        .addr = A_POR_HNF_RN_PHYS_ID53_U_HNF_NID8,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID54_U_HNF_NID8",
        .addr = A_POR_HNF_RN_PHYS_ID54_U_HNF_NID8,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID55_U_HNF_NID8",
        .addr = A_POR_HNF_RN_PHYS_ID55_U_HNF_NID8,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID56_U_HNF_NID8",
        .addr = A_POR_HNF_RN_PHYS_ID56_U_HNF_NID8,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID57_U_HNF_NID8",
        .addr = A_POR_HNF_RN_PHYS_ID57_U_HNF_NID8,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID58_U_HNF_NID8",
        .addr = A_POR_HNF_RN_PHYS_ID58_U_HNF_NID8,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_SF_CXG_BLOCKED_WAYS_U_HNF_NID8",
        .addr = A_POR_HNF_SF_CXG_BLOCKED_WAYS_U_HNF_NID8,
        .rsvd = 0xfffffffffffffffcL,
        .ro = 0xfffffffffffffffcL,
    },{ .name = "POR_HNF_CML_PORT_AGGR_GRP0_ADD_MASK_U_HNF_NID8",
        .addr = A_POR_HNF_CML_PORT_AGGR_GRP0_ADD_MASK_U_HNF_NID8,
        .reset = 0x40,
        .ro = 0xffff00000000003fL,
    },{ .name = "POR_HNF_CML_PORT_AGGR_GRP1_ADD_MASK_U_HNF_NID8",
        .addr = A_POR_HNF_CML_PORT_AGGR_GRP1_ADD_MASK_U_HNF_NID8,
        .reset = 0x40,
        .ro = 0xffff00000000003fL,
    },{ .name = "POR_HNF_CML_PORT_AGGR_GRP0_REG_U_HNF_NID8",
        .addr = A_POR_HNF_CML_PORT_AGGR_GRP0_REG_U_HNF_NID8,
        .ro = 0xfffc800800800800L,
    },{ .name = "POR_HNF_CML_PORT_AGGR_GRP1_REG_U_HNF_NID8",
        .addr = A_POR_HNF_CML_PORT_AGGR_GRP1_REG_U_HNF_NID8,
        .ro = 0xfffc800800800800L,
    },{ .name = "HN_SAM_HASH_ADDR_MASK_REG_U_HNF_NID8",
        .addr = A_HN_SAM_HASH_ADDR_MASK_REG_U_HNF_NID8,
        .reset = 0xffffffffffc0,
        .ro = 0xffff00000000003fL,
    },{ .name = "HN_SAM_REGION_CMP_ADDR_MASK_REG_U_HNF_NID8",
        .addr = A_HN_SAM_REGION_CMP_ADDR_MASK_REG_U_HNF_NID8,
        .reset = 0xfffffc000000,
        .ro = 0xffff000003ffffffL,
    },{ .name = "POR_HNF_ABF_LO_ADDR_U_HNF_NID8",
        .addr = A_POR_HNF_ABF_LO_ADDR_U_HNF_NID8,
        .ro = 0xffff000000000000L,
    },{ .name = "POR_HNF_ABF_HI_ADDR_U_HNF_NID8",
        .addr = A_POR_HNF_ABF_HI_ADDR_U_HNF_NID8,
        .ro = 0xffff000000000000L,
    },{ .name = "POR_HNF_ABF_PR_U_HNF_NID8",
        .addr = A_POR_HNF_ABF_PR_U_HNF_NID8,
        .rsvd = 0xfffffffffffffff8L,
        .ro = 0xfffffffffffffff8L,
    },{ .name = "POR_HNF_ABF_SR_U_HNF_NID8",
        .addr = A_POR_HNF_ABF_SR_U_HNF_NID8,
        .rsvd = 0xfffffffffffffff0L,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_HNF_RN_PHYS_ID59_U_HNF_NID8",
        .addr = A_POR_HNF_RN_PHYS_ID59_U_HNF_NID8,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID60_U_HNF_NID8",
        .addr = A_POR_HNF_RN_PHYS_ID60_U_HNF_NID8,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID61_U_HNF_NID8",
        .addr = A_POR_HNF_RN_PHYS_ID61_U_HNF_NID8,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID62_U_HNF_NID8",
        .addr = A_POR_HNF_RN_PHYS_ID62_U_HNF_NID8,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID63_U_HNF_NID8",
        .addr = A_POR_HNF_RN_PHYS_ID63_U_HNF_NID8,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_LDID_MAP_TABLE_REG0_U_HNF_NID8",
        .addr = A_POR_HNF_LDID_MAP_TABLE_REG0_U_HNF_NID8,
        .ro = 0x7f80f8007f80f800,
    },{ .name = "POR_HNF_LDID_MAP_TABLE_REG1_U_HNF_NID8",
        .addr = A_POR_HNF_LDID_MAP_TABLE_REG1_U_HNF_NID8,
        .ro = 0x7f80f8007f80f800,
    },{ .name = "POR_HNF_LDID_MAP_TABLE_REG2_U_HNF_NID8",
        .addr = A_POR_HNF_LDID_MAP_TABLE_REG2_U_HNF_NID8,
        .ro = 0x7f80f8007f80f800,
    },{ .name = "POR_HNF_LDID_MAP_TABLE_REG3_U_HNF_NID8",
        .addr = A_POR_HNF_LDID_MAP_TABLE_REG3_U_HNF_NID8,
        .ro = 0x7f80f8007f80f800,
    },{ .name = "POR_HNF_PPU_PWPR_U_HNF_NID8",
        .addr = A_POR_HNF_PPU_PWPR_U_HNF_NID8,
        .ro = 0xfffffe00,
    },{ .name = "POR_HNF_PPU_PWSR_U_HNF_NID8",
        .addr = A_POR_HNF_PPU_PWSR_U_HNF_NID8,
        .ro = 0xffffffff,
    },{ .name = "POR_HNF_PPU_MISR_U_HNF_NID8",
        .addr = A_POR_HNF_PPU_MISR_U_HNF_NID8,
        .rsvd = 0xfffffffe,
        .ro = 0xffffffff,
    },{ .name = "POR_HNF_PPU_DYN_RET_THRESHOLD_U_HNF_NID8",
        .addr = A_POR_HNF_PPU_DYN_RET_THRESHOLD_U_HNF_NID8,
        .ro = 0xfffffffffffff000L,
    },{ .name = "POR_HNF_PPU_IDR0_U_HNF_NID8",
        .addr = A_POR_HNF_PPU_IDR0_U_HNF_NID8,
        .reset = 0x801a540,
        .ro = 0xffffffff,
    },{ .name = "POR_HNF_PPU_IDR1_U_HNF_NID8",
        .addr = A_POR_HNF_PPU_IDR1_U_HNF_NID8,
        .rsvd = 0xfffffff0,
        .ro = 0xffffffff,
    },{ .name = "POR_HNF_PPU_IIDR_U_HNF_NID8",
        .addr = A_POR_HNF_PPU_IIDR_U_HNF_NID8,
        .reset = 0x4340043b,
        .ro = 0xffffffff,
    },{ .name = "POR_HNF_PPU_AIDR_U_HNF_NID8",
        .addr = A_POR_HNF_PPU_AIDR_U_HNF_NID8,
        .reset = 0x11,
        .rsvd = 0xffffff00,
        .ro = 0xffffffff,
    },{ .name = "POR_HNF_PMU_EVENT_SEL_U_HNF_NID8",
        .addr = A_POR_HNF_PMU_EVENT_SEL_U_HNF_NID8,
        .rsvd = 0xe0,
        .ro = 0xfffffff8e0e0e0e0L,
    },{ .name = "POR_HNF_ERRFR_U_HNF_NID8",  .addr = A_POR_HNF_ERRFR_U_HNF_NID8,
        .reset = 0x48a5,
        .rsvd = 0x300,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_HNF_ERRCTLR_U_HNF_NID8",
        .addr = A_POR_HNF_ERRCTLR_U_HNF_NID8,
        .rsvd = 0xf0,
        .ro = 0xfffffffffffffef0L,
    },{ .name = "POR_HNF_ERRSTATUS_U_HNF_NID8",
        .addr = A_POR_HNF_ERRSTATUS_U_HNF_NID8,
        .ro = 0xffffffff127fffffL,
    },{ .name = "POR_HNF_ERRADDR_U_HNF_NID8",
        .addr = A_POR_HNF_ERRADDR_U_HNF_NID8,
        .ro = 0x7fff000000000000,
    },{ .name = "POR_HNF_ERRMISC_U_HNF_NID8",
        .addr = A_POR_HNF_ERRMISC_U_HNF_NID8,
        .ro = 0x20000000fffc8000,
    },{ .name = "POR_HNF_ERR_INJ_U_HNF_NID8",
        .addr = A_POR_HNF_ERR_INJ_U_HNF_NID8,
        .rsvd = 0xe,
        .ro = 0xfffffffff800fe0eL,
    },{ .name = "POR_HNF_BYTE_PAR_ERR_INJ_U_HNF_NID8",
        .addr = A_POR_HNF_BYTE_PAR_ERR_INJ_U_HNF_NID8,
        .rsvd = 0xffffffffffffffe0L,
        .ro = 0xffffffffffffffe0L,
    },{ .name = "POR_HNF_ERRFR_NS_U_HNF_NID8",
        .addr = A_POR_HNF_ERRFR_NS_U_HNF_NID8,
        .reset = 0x48a5,
        .rsvd = 0x300,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_HNF_ERRCTLR_NS_U_HNF_NID8",
        .addr = A_POR_HNF_ERRCTLR_NS_U_HNF_NID8,
        .rsvd = 0xf0,
        .ro = 0xfffffffffffffef0L,
    },{ .name = "POR_HNF_ERRSTATUS_NS_U_HNF_NID8",
        .addr = A_POR_HNF_ERRSTATUS_NS_U_HNF_NID8,
        .ro = 0xffffffff127fffffL,
    },{ .name = "POR_HNF_ERRADDR_NS_U_HNF_NID8",
        .addr = A_POR_HNF_ERRADDR_NS_U_HNF_NID8,
        .ro = 0x7fff000000000000,
    },{ .name = "POR_HNF_ERRMISC_NS_U_HNF_NID8",
        .addr = A_POR_HNF_ERRMISC_NS_U_HNF_NID8,
        .ro = 0x20000000fffc8000,
    },{ .name = "POR_MXP_NODE_INFO_U_SMXP_0_1",
        .addr = A_POR_MXP_NODE_INFO_U_SMXP_0_1,
        .reset = 0x1080006,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_DEVICE_PORT_CONNECT_INFO_P0_U_SMXP_0_1",
        .addr = A_POR_MXP_DEVICE_PORT_CONNECT_INFO_P0_U_SMXP_0_1,
        .reset = 0xd,
        .rsvd = 0xffe0,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_DEVICE_PORT_CONNECT_INFO_P1_U_SMXP_0_1",
        .addr = A_POR_MXP_DEVICE_PORT_CONNECT_INFO_P1_U_SMXP_0_1,
        .reset = 0x1,
        .rsvd = 0xffe0,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_MESH_PORT_CONNECT_INFO_EAST_U_SMXP_0_1",
        .addr = A_POR_MXP_MESH_PORT_CONNECT_INFO_EAST_U_SMXP_0_1,
        .rsvd = 0xfffffffffffffff0L,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_MESH_PORT_CONNECT_INFO_NORTH_U_SMXP_0_1",
        .addr = A_POR_MXP_MESH_PORT_CONNECT_INFO_NORTH_U_SMXP_0_1,
        .rsvd = 0xfffffffffffffff0L,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_INFO_U_SMXP_0_1",
        .addr = A_POR_MXP_CHILD_INFO_U_SMXP_0_1,
        .reset = 0x1000006,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_POINTER_0_U_SMXP_0_1",
        .addr = A_POR_MXP_CHILD_POINTER_0_U_SMXP_0_1,
        .reset = 0x8212c000,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_POINTER_1_U_SMXP_0_1",
        .addr = A_POR_MXP_CHILD_POINTER_1_U_SMXP_0_1,
        .reset = 0x8213c000,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_POINTER_2_U_SMXP_0_1",
        .addr = A_POR_MXP_CHILD_POINTER_2_U_SMXP_0_1,
        .reset = 0x2168000,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_POINTER_3_U_SMXP_0_1",
        .addr = A_POR_MXP_CHILD_POINTER_3_U_SMXP_0_1,
        .reset = 0x821d0000,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_POINTER_4_U_SMXP_0_1",
        .addr = A_POR_MXP_CHILD_POINTER_4_U_SMXP_0_1,
        .reset = 0x82120000,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_POINTER_5_U_SMXP_0_1",
        .addr = A_POR_MXP_CHILD_POINTER_5_U_SMXP_0_1,
        .reset = 0x2150000,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_POINTER_6_U_SMXP_0_1",
        .addr = A_POR_MXP_CHILD_POINTER_6_U_SMXP_0_1,
        .reset = 0x2110000,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_POINTER_7_U_SMXP_0_1",
        .addr = A_POR_MXP_CHILD_POINTER_7_U_SMXP_0_1,
        .reset = 0x2100000,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_POINTER_8_U_SMXP_0_1",
        .addr = A_POR_MXP_CHILD_POINTER_8_U_SMXP_0_1,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_POINTER_9_U_SMXP_0_1",
        .addr = A_POR_MXP_CHILD_POINTER_9_U_SMXP_0_1,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_POINTER_10_U_SMXP_0_1",
        .addr = A_POR_MXP_CHILD_POINTER_10_U_SMXP_0_1,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_POINTER_11_U_SMXP_0_1",
        .addr = A_POR_MXP_CHILD_POINTER_11_U_SMXP_0_1,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_POINTER_12_U_SMXP_0_1",
        .addr = A_POR_MXP_CHILD_POINTER_12_U_SMXP_0_1,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_POINTER_13_U_SMXP_0_1",
        .addr = A_POR_MXP_CHILD_POINTER_13_U_SMXP_0_1,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_POINTER_14_U_SMXP_0_1",
        .addr = A_POR_MXP_CHILD_POINTER_14_U_SMXP_0_1,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_POINTER_15_U_SMXP_0_1",
        .addr = A_POR_MXP_CHILD_POINTER_15_U_SMXP_0_1,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_P0_INFO_U_SMXP_0_1",
        .addr = A_POR_MXP_P0_INFO_U_SMXP_0_1,
        .reset = 0x211,
        .rsvd = 0x48,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_P1_INFO_U_SMXP_0_1",
        .addr = A_POR_MXP_P1_INFO_U_SMXP_0_1,
        .reset = 0x211,
        .rsvd = 0x48,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_SECURE_REGISTER_GROUPS_OVERRIDE_U_SMXP_0_1",
        .addr = A_POR_MXP_SECURE_REGISTER_GROUPS_OVERRIDE_U_SMXP_0_1,
        .rsvd = 0xfffffffffffffffcL,
        .ro = 0xfffffffffffffffcL,
    },{ .name = "POR_MXP_AUX_CTL_U_SMXP_0_1",
        .addr = A_POR_MXP_AUX_CTL_U_SMXP_0_1,
        .rsvd = 0xfffffffffffffffeL,
        .ro = 0xfffffffffffffffeL,
    },{ .name = "POR_MXP_P0_QOS_CONTROL_U_SMXP_0_1",
        .addr = A_POR_MXP_P0_QOS_CONTROL_U_SMXP_0_1,
        .rsvd = 0xffaa,
        .ro = 0xfffffffffff0ffaaL,
    },{ .name = "POR_MXP_P0_QOS_LAT_TGT_U_SMXP_0_1",
        .addr = A_POR_MXP_P0_QOS_LAT_TGT_U_SMXP_0_1,
        .ro = 0xfffffffffffff000L,
    },{ .name = "POR_MXP_P0_QOS_LAT_SCALE_U_SMXP_0_1",
        .addr = A_POR_MXP_P0_QOS_LAT_SCALE_U_SMXP_0_1,
        .rsvd = 0xfffffffffffffff8L,
        .ro = 0xfffffffffffffff8L,
    },{ .name = "POR_MXP_P0_QOS_LAT_RANGE_U_SMXP_0_1",
        .addr = A_POR_MXP_P0_QOS_LAT_RANGE_U_SMXP_0_1,
        .rsvd = 0xf0,
        .ro = 0xfffffffffffff0f0L,
    },{ .name = "POR_MXP_P1_QOS_CONTROL_U_SMXP_0_1",
        .addr = A_POR_MXP_P1_QOS_CONTROL_U_SMXP_0_1,
        .rsvd = 0xffaa,
        .ro = 0xfffffffffff0ffaaL,
    },{ .name = "POR_MXP_P1_QOS_LAT_TGT_U_SMXP_0_1",
        .addr = A_POR_MXP_P1_QOS_LAT_TGT_U_SMXP_0_1,
        .ro = 0xfffffffffffff000L,
    },{ .name = "POR_MXP_P1_QOS_LAT_SCALE_U_SMXP_0_1",
        .addr = A_POR_MXP_P1_QOS_LAT_SCALE_U_SMXP_0_1,
        .rsvd = 0xfffffffffffffff8L,
        .ro = 0xfffffffffffffff8L,
    },{ .name = "POR_MXP_P1_QOS_LAT_RANGE_U_SMXP_0_1",
        .addr = A_POR_MXP_P1_QOS_LAT_RANGE_U_SMXP_0_1,
        .rsvd = 0xf0,
        .ro = 0xfffffffffffff0f0L,
    },{ .name = "POR_MXP_P0_SYSCOREQ_CTL_U_SMXP_0_1",
        .addr = A_POR_MXP_P0_SYSCOREQ_CTL_U_SMXP_0_1,
        .rsvd = 0xfffffffffffffff0L,
        .ro = 0xfffffffffffffff0L,
    },{ .name = "POR_MXP_P1_SYSCOREQ_CTL_U_SMXP_0_1",
        .addr = A_POR_MXP_P1_SYSCOREQ_CTL_U_SMXP_0_1,
        .rsvd = 0xfffffffffffffff0L,
        .ro = 0xfffffffffffffff0L,
    },{ .name = "POR_MXP_P0_SYSCOACK_STATUS_U_SMXP_0_1",
        .addr = A_POR_MXP_P0_SYSCOACK_STATUS_U_SMXP_0_1,
        .rsvd = 0xfffffffffffffff0L,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_P1_SYSCOACK_STATUS_U_SMXP_0_1",
        .addr = A_POR_MXP_P1_SYSCOACK_STATUS_U_SMXP_0_1,
        .rsvd = 0xfffffffffffffff0L,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_PMU_EVENT_SEL_U_SMXP_0_1",
        .addr = A_POR_MXP_PMU_EVENT_SEL_U_SMXP_0_1,
        .ro = 0xffffffff00000000L,
    },{ .name = "POR_DTM_CONTROL_U_SMXP_0_1",
        .addr = A_POR_DTM_CONTROL_U_SMXP_0_1,
        .rsvd = 0xfffffffffffffff0L,
        .ro = 0xfffffffffffffff0L,
    },{ .name = "POR_DTM_FIFO_ENTRY_READY_U_SMXP_0_1",
        .addr = A_POR_DTM_FIFO_ENTRY_READY_U_SMXP_0_1,
        .rsvd = 0xfffffffffffffff0L,
        .ro = 0xfffffffffffffff0L,
    },{ .name = "POR_DTM_FIFO_ENTRY0_0_U_SMXP_0_1",
        .addr = A_POR_DTM_FIFO_ENTRY0_0_U_SMXP_0_1,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_DTM_FIFO_ENTRY0_1_U_SMXP_0_1",
        .addr = A_POR_DTM_FIFO_ENTRY0_1_U_SMXP_0_1,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_DTM_FIFO_ENTRY0_2_U_SMXP_0_1",
        .addr = A_POR_DTM_FIFO_ENTRY0_2_U_SMXP_0_1,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_DTM_FIFO_ENTRY1_0_U_SMXP_0_1",
        .addr = A_POR_DTM_FIFO_ENTRY1_0_U_SMXP_0_1,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_DTM_FIFO_ENTRY1_1_U_SMXP_0_1",
        .addr = A_POR_DTM_FIFO_ENTRY1_1_U_SMXP_0_1,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_DTM_FIFO_ENTRY1_2_U_SMXP_0_1",
        .addr = A_POR_DTM_FIFO_ENTRY1_2_U_SMXP_0_1,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_DTM_FIFO_ENTRY2_0_U_SMXP_0_1",
        .addr = A_POR_DTM_FIFO_ENTRY2_0_U_SMXP_0_1,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_DTM_FIFO_ENTRY2_1_U_SMXP_0_1",
        .addr = A_POR_DTM_FIFO_ENTRY2_1_U_SMXP_0_1,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_DTM_FIFO_ENTRY2_2_U_SMXP_0_1",
        .addr = A_POR_DTM_FIFO_ENTRY2_2_U_SMXP_0_1,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_DTM_FIFO_ENTRY3_0_U_SMXP_0_1",
        .addr = A_POR_DTM_FIFO_ENTRY3_0_U_SMXP_0_1,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_DTM_FIFO_ENTRY3_1_U_SMXP_0_1",
        .addr = A_POR_DTM_FIFO_ENTRY3_1_U_SMXP_0_1,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_DTM_FIFO_ENTRY3_2_U_SMXP_0_1",
        .addr = A_POR_DTM_FIFO_ENTRY3_2_U_SMXP_0_1,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_DTM_WP0_CONFIG_U_SMXP_0_1",
        .addr = A_POR_DTM_WP0_CONFIG_U_SMXP_0_1,
        .rsvd = 0x80,
        .ro = 0xffffffffffff8080L,
    },{ .name = "POR_DTM_WP0_VAL_U_SMXP_0_1",
        .addr = A_POR_DTM_WP0_VAL_U_SMXP_0_1,
    },{ .name = "POR_DTM_WP0_MASK_U_SMXP_0_1",
        .addr = A_POR_DTM_WP0_MASK_U_SMXP_0_1,
    },{ .name = "POR_DTM_WP1_CONFIG_U_SMXP_0_1",
        .addr = A_POR_DTM_WP1_CONFIG_U_SMXP_0_1,
        .rsvd = 0xc0,
        .ro = 0xffffffffffff80c0L,
    },{ .name = "POR_DTM_WP1_VAL_U_SMXP_0_1",
        .addr = A_POR_DTM_WP1_VAL_U_SMXP_0_1,
    },{ .name = "POR_DTM_WP1_MASK_U_SMXP_0_1",
        .addr = A_POR_DTM_WP1_MASK_U_SMXP_0_1,
    },{ .name = "POR_DTM_WP2_CONFIG_U_SMXP_0_1",
        .addr = A_POR_DTM_WP2_CONFIG_U_SMXP_0_1,
        .rsvd = 0x80,
        .ro = 0xffffffffffff8080L,
    },{ .name = "POR_DTM_WP2_VAL_U_SMXP_0_1",
        .addr = A_POR_DTM_WP2_VAL_U_SMXP_0_1,
    },{ .name = "POR_DTM_WP2_MASK_U_SMXP_0_1",
        .addr = A_POR_DTM_WP2_MASK_U_SMXP_0_1,
    },{ .name = "POR_DTM_WP3_CONFIG_U_SMXP_0_1",
        .addr = A_POR_DTM_WP3_CONFIG_U_SMXP_0_1,
        .rsvd = 0xc0,
        .ro = 0xffffffffffff80c0L,
    },{ .name = "POR_DTM_WP3_VAL_U_SMXP_0_1",
        .addr = A_POR_DTM_WP3_VAL_U_SMXP_0_1,
    },{ .name = "POR_DTM_WP3_MASK_U_SMXP_0_1",
        .addr = A_POR_DTM_WP3_MASK_U_SMXP_0_1,
    },{ .name = "POR_DTM_PMSICR_U_SMXP_0_1",
        .addr = A_POR_DTM_PMSICR_U_SMXP_0_1,
        .ro = 0xffffffff00000000L,
    },{ .name = "POR_DTM_PMSIRR_U_SMXP_0_1",
        .addr = A_POR_DTM_PMSIRR_U_SMXP_0_1,
        .ro = 0xffffffff000000ffL,
    },{ .name = "POR_DTM_PMU_CONFIG_U_SMXP_0_1",
        .addr = A_POR_DTM_PMU_CONFIG_U_SMXP_0_1,
        .ro = 0xc0c0c0c08888fe00L,
    },{ .name = "POR_DTM_PMEVCNT_U_SMXP_0_1",
        .addr = A_POR_DTM_PMEVCNT_U_SMXP_0_1,
    },{ .name = "POR_DTM_PMEVCNTSR_U_SMXP_0_1",
        .addr = A_POR_DTM_PMEVCNTSR_U_SMXP_0_1,
    },{ .name = "POR_MXP_ERRFR_U_SMXP_0_1",  .addr = A_POR_MXP_ERRFR_U_SMXP_0_1,
        .rsvd = 0x300,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_ERRCTLR_U_SMXP_0_1",
        .addr = A_POR_MXP_ERRCTLR_U_SMXP_0_1,
        .rsvd = 0xf0,
        .ro = 0xfffffffffffffef0L,
    },{ .name = "POR_MXP_ERRSTATUS_U_SMXP_0_1",
        .addr = A_POR_MXP_ERRSTATUS_U_SMXP_0_1,
        .ro = 0xffffffff127fffffL,
    },{ .name = "POR_MXP_ERRMISC_U_SMXP_0_1",
        .addr = A_POR_MXP_ERRMISC_U_SMXP_0_1,
        .rsvd = 0x8,
        .ro = 0xf800ffffffc08008L,
    },{ .name = "POR_MXP_P0_BYTE_PAR_ERR_INJ_U_SMXP_0_1",
        .addr = A_POR_MXP_P0_BYTE_PAR_ERR_INJ_U_SMXP_0_1,
        .rsvd = 0xffffffffffffffe0L,
        .ro = 0xffffffffffffffe0L,
    },{ .name = "POR_MXP_P1_BYTE_PAR_ERR_INJ_U_SMXP_0_1",
        .addr = A_POR_MXP_P1_BYTE_PAR_ERR_INJ_U_SMXP_0_1,
        .rsvd = 0xffffffffffffffe0L,
        .ro = 0xffffffffffffffe0L,
    },{ .name = "POR_MXP_ERRFR_NS_U_SMXP_0_1",
        .addr = A_POR_MXP_ERRFR_NS_U_SMXP_0_1,
        .rsvd = 0x300,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_ERRCTLR_NS_U_SMXP_0_1",
        .addr = A_POR_MXP_ERRCTLR_NS_U_SMXP_0_1,
        .rsvd = 0xf0,
        .ro = 0xfffffffffffffef0L,
    },{ .name = "POR_MXP_ERRSTATUS_NS_U_SMXP_0_1",
        .addr = A_POR_MXP_ERRSTATUS_NS_U_SMXP_0_1,
        .ro = 0xffffffff127fffffL,
    },{ .name = "POR_MXP_ERRMISC_NS_U_SMXP_0_1",
        .addr = A_POR_MXP_ERRMISC_NS_U_SMXP_0_1,
        .rsvd = 0x8,
        .ro = 0xf800ffffffc08008L,
    },{ .name = "POR_FDC_NODE_INFO_U_SMXP_0_1",
        .addr = A_POR_FDC_NODE_INFO_U_SMXP_0_1,
        .reset = 0x201,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_FDC_CHILD_INFO_U_SMXP_0_1",
        .addr = A_POR_FDC_CHILD_INFO_U_SMXP_0_1,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_ERRFR_MXP_U_SMXP_0_1",  .addr = A_POR_ERRFR_MXP_U_SMXP_0_1,
        .reset = 0xa1,
        .rsvd = 0xffffffffffffff0cL,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_ERRCTLR_MXP_U_SMXP_0_1",
        .addr = A_POR_ERRCTLR_MXP_U_SMXP_0_1,
        .reset = 0xd,
        .rsvd = 0x3ff2,
        .ro = 0xffffffff00003ff2L,
    },{ .name = "POR_ERRSTATUS_MXP_U_SMXP_0_1",
        .addr = A_POR_ERRSTATUS_MXP_U_SMXP_0_1,
        .ro = 0xffffffff977f003fL,
    },{ .name = "POR_FDC_AUX_CTL_MXP_U_SMXP_0_1",
        .addr = A_POR_FDC_AUX_CTL_MXP_U_SMXP_0_1,
        .rsvd = 0xffffffffffffffe0L,
        .ro = 0xffffffffffffffefL,
    },{ .name = "POR_ERRFR_P0_D0_U_SMXP_0_1",
        .addr = A_POR_ERRFR_P0_D0_U_SMXP_0_1,
        .reset = 0xa1,
        .rsvd = 0xffffffffffffff0cL,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_ERRCTLR_P0_D0_U_SMXP_0_1",
        .addr = A_POR_ERRCTLR_P0_D0_U_SMXP_0_1,
        .reset = 0xd,
        .rsvd = 0x3ff2,
        .ro = 0xffffffff00003ff2L,
    },{ .name = "POR_ERRSTATUS_P0_D0_U_SMXP_0_1",
        .addr = A_POR_ERRSTATUS_P0_D0_U_SMXP_0_1,
        .ro = 0xffffffff977f003fL,
    },{ .name = "POR_FDC_AUX_CTL_P0_D0_U_SMXP_0_1",
        .addr = A_POR_FDC_AUX_CTL_P0_D0_U_SMXP_0_1,
        .rsvd = 0xffffffffffffffe0L,
        .ro = 0xffffffffffffffe0L,
    },{ .name = "POR_ERRFR_P0_D1_U_SMXP_0_1",
        .addr = A_POR_ERRFR_P0_D1_U_SMXP_0_1,
        .reset = 0xa1,
        .rsvd = 0xffffffffffffff0cL,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_ERRCTLR_P0_D1_U_SMXP_0_1",
        .addr = A_POR_ERRCTLR_P0_D1_U_SMXP_0_1,
        .reset = 0xd,
        .rsvd = 0x3ff2,
        .ro = 0xffffffff00003ff2L,
    },{ .name = "POR_ERRSTATUS_P0_D1_U_SMXP_0_1",
        .addr = A_POR_ERRSTATUS_P0_D1_U_SMXP_0_1,
        .ro = 0xffffffff977f003fL,
    },{ .name = "POR_FDC_AUX_CTL_P0_D1_U_SMXP_0_1",
        .addr = A_POR_FDC_AUX_CTL_P0_D1_U_SMXP_0_1,
        .rsvd = 0xffffffffffffffe0L,
        .ro = 0xffffffffffffffe0L,
    },{ .name = "POR_ERRFR_P0_D2_U_SMXP_0_1",
        .addr = A_POR_ERRFR_P0_D2_U_SMXP_0_1,
        .reset = 0xa1,
        .rsvd = 0xffffffffffffff0cL,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_ERRCTLR_P0_D2_U_SMXP_0_1",
        .addr = A_POR_ERRCTLR_P0_D2_U_SMXP_0_1,
        .reset = 0xd,
        .rsvd = 0x3ff2,
        .ro = 0xffffffff00003ff2L,
    },{ .name = "POR_ERRSTATUS_P0_D2_U_SMXP_0_1",
        .addr = A_POR_ERRSTATUS_P0_D2_U_SMXP_0_1,
        .ro = 0xffffffff977f003fL,
    },{ .name = "POR_FDC_AUX_CTL_P0_D2_U_SMXP_0_1",
        .addr = A_POR_FDC_AUX_CTL_P0_D2_U_SMXP_0_1,
        .rsvd = 0xffffffffffffffe0L,
        .ro = 0xffffffffffffffe0L,
    },{ .name = "POR_ERRFR_P0_D3_U_SMXP_0_1",
        .addr = A_POR_ERRFR_P0_D3_U_SMXP_0_1,
        .reset = 0xa1,
        .rsvd = 0xffffffffffffff0cL,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_ERRCTLR_P0_D3_U_SMXP_0_1",
        .addr = A_POR_ERRCTLR_P0_D3_U_SMXP_0_1,
        .reset = 0xd,
        .rsvd = 0x3ff2,
        .ro = 0xffffffff00003ff2L,
    },{ .name = "POR_ERRSTATUS_P0_D3_U_SMXP_0_1",
        .addr = A_POR_ERRSTATUS_P0_D3_U_SMXP_0_1,
        .ro = 0xffffffff977f003fL,
    },{ .name = "POR_FDC_AUX_CTL_P0_D3_U_SMXP_0_1",
        .addr = A_POR_FDC_AUX_CTL_P0_D3_U_SMXP_0_1,
        .rsvd = 0xffffffffffffffe0L,
        .ro = 0xffffffffffffffe0L,
    },{ .name = "POR_ERRFR_P1_D0_U_SMXP_0_1",
        .addr = A_POR_ERRFR_P1_D0_U_SMXP_0_1,
        .reset = 0xa1,
        .rsvd = 0xffffffffffffff0cL,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_ERRCTLR_P1_D0_U_SMXP_0_1",
        .addr = A_POR_ERRCTLR_P1_D0_U_SMXP_0_1,
        .reset = 0xd,
        .rsvd = 0x3ff2,
        .ro = 0xffffffff00003ff2L,
    },{ .name = "POR_ERRSTATUS_P1_D0_U_SMXP_0_1",
        .addr = A_POR_ERRSTATUS_P1_D0_U_SMXP_0_1,
        .ro = 0xffffffff977f003fL,
    },{ .name = "POR_FDC_AUX_CTL_P1_D0_U_SMXP_0_1",
        .addr = A_POR_FDC_AUX_CTL_P1_D0_U_SMXP_0_1,
        .rsvd = 0xffffffffffffffe0L,
        .ro = 0xffffffffffffffe0L,
    },{ .name = "POR_ERRFR_P1_D1_U_SMXP_0_1",
        .addr = A_POR_ERRFR_P1_D1_U_SMXP_0_1,
        .reset = 0xa1,
        .rsvd = 0xffffffffffffff0cL,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_ERRCTLR_P1_D1_U_SMXP_0_1",
        .addr = A_POR_ERRCTLR_P1_D1_U_SMXP_0_1,
        .reset = 0xd,
        .rsvd = 0x3ff2,
        .ro = 0xffffffff00003ff2L,
    },{ .name = "POR_ERRSTATUS_P1_D1_U_SMXP_0_1",
        .addr = A_POR_ERRSTATUS_P1_D1_U_SMXP_0_1,
        .ro = 0xffffffff977f003fL,
    },{ .name = "POR_FDC_AUX_CTL_P1_D1_U_SMXP_0_1",
        .addr = A_POR_FDC_AUX_CTL_P1_D1_U_SMXP_0_1,
        .rsvd = 0xffffffffffffffe0L,
        .ro = 0xffffffffffffffe0L,
    },{ .name = "POR_ERRFR_P1_D2_U_SMXP_0_1",
        .addr = A_POR_ERRFR_P1_D2_U_SMXP_0_1,
        .reset = 0xa1,
        .rsvd = 0xffffffffffffff0cL,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_ERRCTLR_P1_D2_U_SMXP_0_1",
        .addr = A_POR_ERRCTLR_P1_D2_U_SMXP_0_1,
        .reset = 0xd,
        .rsvd = 0x3ff2,
        .ro = 0xffffffff00003ff2L,
    },{ .name = "POR_ERRSTATUS_P1_D2_U_SMXP_0_1",
        .addr = A_POR_ERRSTATUS_P1_D2_U_SMXP_0_1,
        .ro = 0xffffffff977f003fL,
    },{ .name = "POR_FDC_AUX_CTL_P1_D2_U_SMXP_0_1",
        .addr = A_POR_FDC_AUX_CTL_P1_D2_U_SMXP_0_1,
        .rsvd = 0xffffffffffffffe0L,
        .ro = 0xffffffffffffffe0L,
    },{ .name = "POR_ERRFR_P1_D3_U_SMXP_0_1",
        .addr = A_POR_ERRFR_P1_D3_U_SMXP_0_1,
        .reset = 0xa1,
        .rsvd = 0xffffffffffffff0cL,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_ERRCTLR_P1_D3_U_SMXP_0_1",
        .addr = A_POR_ERRCTLR_P1_D3_U_SMXP_0_1,
        .reset = 0xd,
        .rsvd = 0x3ff2,
        .ro = 0xffffffff00003ff2L,
    },{ .name = "POR_ERRSTATUS_P1_D3_U_SMXP_0_1",
        .addr = A_POR_ERRSTATUS_P1_D3_U_SMXP_0_1,
        .ro = 0xffffffff977f003fL,
    },{ .name = "POR_FDC_AUX_CTL_P1_D3_U_SMXP_0_1",
        .addr = A_POR_FDC_AUX_CTL_P1_D3_U_SMXP_0_1,
        .rsvd = 0xffffffffffffffe0L,
        .ro = 0xffffffffffffffe0L,
    },{ .name = "POR_ERRINJECT_U_SMXP_0_1",  .addr = A_POR_ERRINJECT_U_SMXP_0_1,
        .rsvd = 0xffffffffffffff00L,
        .ro = 0xffffffffffffff00L,
    },{ .name = "POR_FDC_KEY_U_SMXP_0_1",  .addr = A_POR_FDC_KEY_U_SMXP_0_1,
        .reset = 0xbe,
        .rsvd = 0xffffffffffffff00L,
        .ro = 0xffffffffffffff00L,
    },{ .name = "POR_MPU_NODE_INFO_U_SMXP_0_1",
        .addr = A_POR_MPU_NODE_INFO_U_SMXP_0_1,
        .reset = 0x202,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MPU_CHILD_INFO_U_SMXP_0_1",
        .addr = A_POR_MPU_CHILD_INFO_U_SMXP_0_1,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MPU_UNIT_INFO_U_SMXP_0_1",
        .addr = A_POR_MPU_UNIT_INFO_U_SMXP_0_1,
        .reset = 0x20,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MPU_M0_CTL_U_SMXP_0_1",
        .addr = A_POR_MPU_M0_CTL_U_SMXP_0_1,
        .reset = 0x2,
        .rsvd = 0xfffffffffffffff8L,
        .ro = 0xfffffffffffffff8L,
    },{ .name = "POR_MPU_M0_PRBAR0_U_SMXP_0_1",
        .addr = A_POR_MPU_M0_PRBAR0_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR0_U_SMXP_0_1",
        .addr = A_POR_MPU_M0_PRLAR0_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR1_U_SMXP_0_1",
        .addr = A_POR_MPU_M0_PRBAR1_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR1_U_SMXP_0_1",
        .addr = A_POR_MPU_M0_PRLAR1_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR2_U_SMXP_0_1",
        .addr = A_POR_MPU_M0_PRBAR2_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR2_U_SMXP_0_1",
        .addr = A_POR_MPU_M0_PRLAR2_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR3_U_SMXP_0_1",
        .addr = A_POR_MPU_M0_PRBAR3_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR3_U_SMXP_0_1",
        .addr = A_POR_MPU_M0_PRLAR3_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR4_U_SMXP_0_1",
        .addr = A_POR_MPU_M0_PRBAR4_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR4_U_SMXP_0_1",
        .addr = A_POR_MPU_M0_PRLAR4_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR5_U_SMXP_0_1",
        .addr = A_POR_MPU_M0_PRBAR5_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR5_U_SMXP_0_1",
        .addr = A_POR_MPU_M0_PRLAR5_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR6_U_SMXP_0_1",
        .addr = A_POR_MPU_M0_PRBAR6_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR6_U_SMXP_0_1",
        .addr = A_POR_MPU_M0_PRLAR6_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR7_U_SMXP_0_1",
        .addr = A_POR_MPU_M0_PRBAR7_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR7_U_SMXP_0_1",
        .addr = A_POR_MPU_M0_PRLAR7_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR8_U_SMXP_0_1",
        .addr = A_POR_MPU_M0_PRBAR8_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR8_U_SMXP_0_1",
        .addr = A_POR_MPU_M0_PRLAR8_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR9_U_SMXP_0_1",
        .addr = A_POR_MPU_M0_PRBAR9_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR9_U_SMXP_0_1",
        .addr = A_POR_MPU_M0_PRLAR9_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR10_U_SMXP_0_1",
        .addr = A_POR_MPU_M0_PRBAR10_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR10_U_SMXP_0_1",
        .addr = A_POR_MPU_M0_PRLAR10_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR11_U_SMXP_0_1",
        .addr = A_POR_MPU_M0_PRBAR11_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR11_U_SMXP_0_1",
        .addr = A_POR_MPU_M0_PRLAR11_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR12_U_SMXP_0_1",
        .addr = A_POR_MPU_M0_PRBAR12_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR12_U_SMXP_0_1",
        .addr = A_POR_MPU_M0_PRLAR12_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR13_U_SMXP_0_1",
        .addr = A_POR_MPU_M0_PRBAR13_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR13_U_SMXP_0_1",
        .addr = A_POR_MPU_M0_PRLAR13_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR14_U_SMXP_0_1",
        .addr = A_POR_MPU_M0_PRBAR14_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR14_U_SMXP_0_1",
        .addr = A_POR_MPU_M0_PRLAR14_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR15_U_SMXP_0_1",
        .addr = A_POR_MPU_M0_PRBAR15_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR15_U_SMXP_0_1",
        .addr = A_POR_MPU_M0_PRLAR15_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR16_U_SMXP_0_1",
        .addr = A_POR_MPU_M0_PRBAR16_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR16_U_SMXP_0_1",
        .addr = A_POR_MPU_M0_PRLAR16_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR17_U_SMXP_0_1",
        .addr = A_POR_MPU_M0_PRBAR17_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR17_U_SMXP_0_1",
        .addr = A_POR_MPU_M0_PRLAR17_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR18_U_SMXP_0_1",
        .addr = A_POR_MPU_M0_PRBAR18_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR18_U_SMXP_0_1",
        .addr = A_POR_MPU_M0_PRLAR18_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR19_U_SMXP_0_1",
        .addr = A_POR_MPU_M0_PRBAR19_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR19_U_SMXP_0_1",
        .addr = A_POR_MPU_M0_PRLAR19_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR20_U_SMXP_0_1",
        .addr = A_POR_MPU_M0_PRBAR20_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR20_U_SMXP_0_1",
        .addr = A_POR_MPU_M0_PRLAR20_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR21_U_SMXP_0_1",
        .addr = A_POR_MPU_M0_PRBAR21_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR21_U_SMXP_0_1",
        .addr = A_POR_MPU_M0_PRLAR21_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR22_U_SMXP_0_1",
        .addr = A_POR_MPU_M0_PRBAR22_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR22_U_SMXP_0_1",
        .addr = A_POR_MPU_M0_PRLAR22_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR23_U_SMXP_0_1",
        .addr = A_POR_MPU_M0_PRBAR23_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR23_U_SMXP_0_1",
        .addr = A_POR_MPU_M0_PRLAR23_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR24_U_SMXP_0_1",
        .addr = A_POR_MPU_M0_PRBAR24_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR24_U_SMXP_0_1",
        .addr = A_POR_MPU_M0_PRLAR24_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR25_U_SMXP_0_1",
        .addr = A_POR_MPU_M0_PRBAR25_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR25_U_SMXP_0_1",
        .addr = A_POR_MPU_M0_PRLAR25_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR26_U_SMXP_0_1",
        .addr = A_POR_MPU_M0_PRBAR26_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR26_U_SMXP_0_1",
        .addr = A_POR_MPU_M0_PRLAR26_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR27_U_SMXP_0_1",
        .addr = A_POR_MPU_M0_PRBAR27_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR27_U_SMXP_0_1",
        .addr = A_POR_MPU_M0_PRLAR27_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR28_U_SMXP_0_1",
        .addr = A_POR_MPU_M0_PRBAR28_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR28_U_SMXP_0_1",
        .addr = A_POR_MPU_M0_PRLAR28_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR29_U_SMXP_0_1",
        .addr = A_POR_MPU_M0_PRBAR29_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR29_U_SMXP_0_1",
        .addr = A_POR_MPU_M0_PRLAR29_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR30_U_SMXP_0_1",
        .addr = A_POR_MPU_M0_PRBAR30_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR30_U_SMXP_0_1",
        .addr = A_POR_MPU_M0_PRLAR30_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR31_U_SMXP_0_1",
        .addr = A_POR_MPU_M0_PRBAR31_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR31_U_SMXP_0_1",
        .addr = A_POR_MPU_M0_PRLAR31_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_CTL_U_SMXP_0_1",
        .addr = A_POR_MPU_M1_CTL_U_SMXP_0_1,
        .reset = 0x2,
        .rsvd = 0xfffffffffffffff8L,
        .ro = 0xfffffffffffffff8L,
    },{ .name = "POR_MPU_M1_PRBAR0_U_SMXP_0_1",
        .addr = A_POR_MPU_M1_PRBAR0_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR0_U_SMXP_0_1",
        .addr = A_POR_MPU_M1_PRLAR0_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR1_U_SMXP_0_1",
        .addr = A_POR_MPU_M1_PRBAR1_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR1_U_SMXP_0_1",
        .addr = A_POR_MPU_M1_PRLAR1_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR2_U_SMXP_0_1",
        .addr = A_POR_MPU_M1_PRBAR2_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR2_U_SMXP_0_1",
        .addr = A_POR_MPU_M1_PRLAR2_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR3_U_SMXP_0_1",
        .addr = A_POR_MPU_M1_PRBAR3_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR3_U_SMXP_0_1",
        .addr = A_POR_MPU_M1_PRLAR3_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR4_U_SMXP_0_1",
        .addr = A_POR_MPU_M1_PRBAR4_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR4_U_SMXP_0_1",
        .addr = A_POR_MPU_M1_PRLAR4_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR5_U_SMXP_0_1",
        .addr = A_POR_MPU_M1_PRBAR5_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR5_U_SMXP_0_1",
        .addr = A_POR_MPU_M1_PRLAR5_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR6_U_SMXP_0_1",
        .addr = A_POR_MPU_M1_PRBAR6_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR6_U_SMXP_0_1",
        .addr = A_POR_MPU_M1_PRLAR6_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR7_U_SMXP_0_1",
        .addr = A_POR_MPU_M1_PRBAR7_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR7_U_SMXP_0_1",
        .addr = A_POR_MPU_M1_PRLAR7_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR8_U_SMXP_0_1",
        .addr = A_POR_MPU_M1_PRBAR8_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR8_U_SMXP_0_1",
        .addr = A_POR_MPU_M1_PRLAR8_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR9_U_SMXP_0_1",
        .addr = A_POR_MPU_M1_PRBAR9_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR9_U_SMXP_0_1",
        .addr = A_POR_MPU_M1_PRLAR9_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR10_U_SMXP_0_1",
        .addr = A_POR_MPU_M1_PRBAR10_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR10_U_SMXP_0_1",
        .addr = A_POR_MPU_M1_PRLAR10_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR11_U_SMXP_0_1",
        .addr = A_POR_MPU_M1_PRBAR11_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR11_U_SMXP_0_1",
        .addr = A_POR_MPU_M1_PRLAR11_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR12_U_SMXP_0_1",
        .addr = A_POR_MPU_M1_PRBAR12_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR12_U_SMXP_0_1",
        .addr = A_POR_MPU_M1_PRLAR12_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR13_U_SMXP_0_1",
        .addr = A_POR_MPU_M1_PRBAR13_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR13_U_SMXP_0_1",
        .addr = A_POR_MPU_M1_PRLAR13_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR14_U_SMXP_0_1",
        .addr = A_POR_MPU_M1_PRBAR14_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR14_U_SMXP_0_1",
        .addr = A_POR_MPU_M1_PRLAR14_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR15_U_SMXP_0_1",
        .addr = A_POR_MPU_M1_PRBAR15_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR15_U_SMXP_0_1",
        .addr = A_POR_MPU_M1_PRLAR15_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR16_U_SMXP_0_1",
        .addr = A_POR_MPU_M1_PRBAR16_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR16_U_SMXP_0_1",
        .addr = A_POR_MPU_M1_PRLAR16_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR17_U_SMXP_0_1",
        .addr = A_POR_MPU_M1_PRBAR17_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR17_U_SMXP_0_1",
        .addr = A_POR_MPU_M1_PRLAR17_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR18_U_SMXP_0_1",
        .addr = A_POR_MPU_M1_PRBAR18_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR18_U_SMXP_0_1",
        .addr = A_POR_MPU_M1_PRLAR18_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR19_U_SMXP_0_1",
        .addr = A_POR_MPU_M1_PRBAR19_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR19_U_SMXP_0_1",
        .addr = A_POR_MPU_M1_PRLAR19_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR20_U_SMXP_0_1",
        .addr = A_POR_MPU_M1_PRBAR20_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR20_U_SMXP_0_1",
        .addr = A_POR_MPU_M1_PRLAR20_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR21_U_SMXP_0_1",
        .addr = A_POR_MPU_M1_PRBAR21_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR21_U_SMXP_0_1",
        .addr = A_POR_MPU_M1_PRLAR21_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR22_U_SMXP_0_1",
        .addr = A_POR_MPU_M1_PRBAR22_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR22_U_SMXP_0_1",
        .addr = A_POR_MPU_M1_PRLAR22_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR23_U_SMXP_0_1",
        .addr = A_POR_MPU_M1_PRBAR23_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR23_U_SMXP_0_1",
        .addr = A_POR_MPU_M1_PRLAR23_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR24_U_SMXP_0_1",
        .addr = A_POR_MPU_M1_PRBAR24_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR24_U_SMXP_0_1",
        .addr = A_POR_MPU_M1_PRLAR24_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR25_U_SMXP_0_1",
        .addr = A_POR_MPU_M1_PRBAR25_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR25_U_SMXP_0_1",
        .addr = A_POR_MPU_M1_PRLAR25_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR26_U_SMXP_0_1",
        .addr = A_POR_MPU_M1_PRBAR26_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR26_U_SMXP_0_1",
        .addr = A_POR_MPU_M1_PRLAR26_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR27_U_SMXP_0_1",
        .addr = A_POR_MPU_M1_PRBAR27_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR27_U_SMXP_0_1",
        .addr = A_POR_MPU_M1_PRLAR27_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR28_U_SMXP_0_1",
        .addr = A_POR_MPU_M1_PRBAR28_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR28_U_SMXP_0_1",
        .addr = A_POR_MPU_M1_PRLAR28_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR29_U_SMXP_0_1",
        .addr = A_POR_MPU_M1_PRBAR29_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR29_U_SMXP_0_1",
        .addr = A_POR_MPU_M1_PRLAR29_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR30_U_SMXP_0_1",
        .addr = A_POR_MPU_M1_PRBAR30_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR30_U_SMXP_0_1",
        .addr = A_POR_MPU_M1_PRLAR30_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR31_U_SMXP_0_1",
        .addr = A_POR_MPU_M1_PRBAR31_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR31_U_SMXP_0_1",
        .addr = A_POR_MPU_M1_PRLAR31_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_CTL_U_SMXP_0_1",
        .addr = A_POR_MPU_M2_CTL_U_SMXP_0_1,
        .reset = 0x2,
        .rsvd = 0xfffffffffffffff8L,
        .ro = 0xfffffffffffffff8L,
    },{ .name = "POR_MPU_M2_PRBAR0_U_SMXP_0_1",
        .addr = A_POR_MPU_M2_PRBAR0_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR0_U_SMXP_0_1",
        .addr = A_POR_MPU_M2_PRLAR0_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR1_U_SMXP_0_1",
        .addr = A_POR_MPU_M2_PRBAR1_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR1_U_SMXP_0_1",
        .addr = A_POR_MPU_M2_PRLAR1_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR2_U_SMXP_0_1",
        .addr = A_POR_MPU_M2_PRBAR2_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR2_U_SMXP_0_1",
        .addr = A_POR_MPU_M2_PRLAR2_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR3_U_SMXP_0_1",
        .addr = A_POR_MPU_M2_PRBAR3_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR3_U_SMXP_0_1",
        .addr = A_POR_MPU_M2_PRLAR3_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR4_U_SMXP_0_1",
        .addr = A_POR_MPU_M2_PRBAR4_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR4_U_SMXP_0_1",
        .addr = A_POR_MPU_M2_PRLAR4_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR5_U_SMXP_0_1",
        .addr = A_POR_MPU_M2_PRBAR5_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR5_U_SMXP_0_1",
        .addr = A_POR_MPU_M2_PRLAR5_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR6_U_SMXP_0_1",
        .addr = A_POR_MPU_M2_PRBAR6_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR6_U_SMXP_0_1",
        .addr = A_POR_MPU_M2_PRLAR6_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR7_U_SMXP_0_1",
        .addr = A_POR_MPU_M2_PRBAR7_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR7_U_SMXP_0_1",
        .addr = A_POR_MPU_M2_PRLAR7_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR8_U_SMXP_0_1",
        .addr = A_POR_MPU_M2_PRBAR8_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR8_U_SMXP_0_1",
        .addr = A_POR_MPU_M2_PRLAR8_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR9_U_SMXP_0_1",
        .addr = A_POR_MPU_M2_PRBAR9_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR9_U_SMXP_0_1",
        .addr = A_POR_MPU_M2_PRLAR9_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR10_U_SMXP_0_1",
        .addr = A_POR_MPU_M2_PRBAR10_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR10_U_SMXP_0_1",
        .addr = A_POR_MPU_M2_PRLAR10_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR11_U_SMXP_0_1",
        .addr = A_POR_MPU_M2_PRBAR11_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR11_U_SMXP_0_1",
        .addr = A_POR_MPU_M2_PRLAR11_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR12_U_SMXP_0_1",
        .addr = A_POR_MPU_M2_PRBAR12_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR12_U_SMXP_0_1",
        .addr = A_POR_MPU_M2_PRLAR12_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR13_U_SMXP_0_1",
        .addr = A_POR_MPU_M2_PRBAR13_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR13_U_SMXP_0_1",
        .addr = A_POR_MPU_M2_PRLAR13_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR14_U_SMXP_0_1",
        .addr = A_POR_MPU_M2_PRBAR14_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR14_U_SMXP_0_1",
        .addr = A_POR_MPU_M2_PRLAR14_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR15_U_SMXP_0_1",
        .addr = A_POR_MPU_M2_PRBAR15_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR15_U_SMXP_0_1",
        .addr = A_POR_MPU_M2_PRLAR15_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR16_U_SMXP_0_1",
        .addr = A_POR_MPU_M2_PRBAR16_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR16_U_SMXP_0_1",
        .addr = A_POR_MPU_M2_PRLAR16_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR17_U_SMXP_0_1",
        .addr = A_POR_MPU_M2_PRBAR17_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR17_U_SMXP_0_1",
        .addr = A_POR_MPU_M2_PRLAR17_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR18_U_SMXP_0_1",
        .addr = A_POR_MPU_M2_PRBAR18_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR18_U_SMXP_0_1",
        .addr = A_POR_MPU_M2_PRLAR18_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR19_U_SMXP_0_1",
        .addr = A_POR_MPU_M2_PRBAR19_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR19_U_SMXP_0_1",
        .addr = A_POR_MPU_M2_PRLAR19_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR20_U_SMXP_0_1",
        .addr = A_POR_MPU_M2_PRBAR20_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR20_U_SMXP_0_1",
        .addr = A_POR_MPU_M2_PRLAR20_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR21_U_SMXP_0_1",
        .addr = A_POR_MPU_M2_PRBAR21_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR21_U_SMXP_0_1",
        .addr = A_POR_MPU_M2_PRLAR21_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR22_U_SMXP_0_1",
        .addr = A_POR_MPU_M2_PRBAR22_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR22_U_SMXP_0_1",
        .addr = A_POR_MPU_M2_PRLAR22_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR23_U_SMXP_0_1",
        .addr = A_POR_MPU_M2_PRBAR23_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR23_U_SMXP_0_1",
        .addr = A_POR_MPU_M2_PRLAR23_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR24_U_SMXP_0_1",
        .addr = A_POR_MPU_M2_PRBAR24_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR24_U_SMXP_0_1",
        .addr = A_POR_MPU_M2_PRLAR24_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR25_U_SMXP_0_1",
        .addr = A_POR_MPU_M2_PRBAR25_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR25_U_SMXP_0_1",
        .addr = A_POR_MPU_M2_PRLAR25_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR26_U_SMXP_0_1",
        .addr = A_POR_MPU_M2_PRBAR26_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR26_U_SMXP_0_1",
        .addr = A_POR_MPU_M2_PRLAR26_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR27_U_SMXP_0_1",
        .addr = A_POR_MPU_M2_PRBAR27_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR27_U_SMXP_0_1",
        .addr = A_POR_MPU_M2_PRLAR27_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR28_U_SMXP_0_1",
        .addr = A_POR_MPU_M2_PRBAR28_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR28_U_SMXP_0_1",
        .addr = A_POR_MPU_M2_PRLAR28_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR29_U_SMXP_0_1",
        .addr = A_POR_MPU_M2_PRBAR29_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR29_U_SMXP_0_1",
        .addr = A_POR_MPU_M2_PRLAR29_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR30_U_SMXP_0_1",
        .addr = A_POR_MPU_M2_PRBAR30_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR30_U_SMXP_0_1",
        .addr = A_POR_MPU_M2_PRLAR30_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR31_U_SMXP_0_1",
        .addr = A_POR_MPU_M2_PRBAR31_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR31_U_SMXP_0_1",
        .addr = A_POR_MPU_M2_PRLAR31_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_CTL_U_SMXP_0_1",
        .addr = A_POR_MPU_M3_CTL_U_SMXP_0_1,
        .reset = 0x2,
        .rsvd = 0xfffffffffffffff8L,
        .ro = 0xfffffffffffffff8L,
    },{ .name = "POR_MPU_M3_PRBAR0_U_SMXP_0_1",
        .addr = A_POR_MPU_M3_PRBAR0_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR0_U_SMXP_0_1",
        .addr = A_POR_MPU_M3_PRLAR0_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR1_U_SMXP_0_1",
        .addr = A_POR_MPU_M3_PRBAR1_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR1_U_SMXP_0_1",
        .addr = A_POR_MPU_M3_PRLAR1_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR2_U_SMXP_0_1",
        .addr = A_POR_MPU_M3_PRBAR2_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR2_U_SMXP_0_1",
        .addr = A_POR_MPU_M3_PRLAR2_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR3_U_SMXP_0_1",
        .addr = A_POR_MPU_M3_PRBAR3_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR3_U_SMXP_0_1",
        .addr = A_POR_MPU_M3_PRLAR3_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR4_U_SMXP_0_1",
        .addr = A_POR_MPU_M3_PRBAR4_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR4_U_SMXP_0_1",
        .addr = A_POR_MPU_M3_PRLAR4_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR5_U_SMXP_0_1",
        .addr = A_POR_MPU_M3_PRBAR5_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR5_U_SMXP_0_1",
        .addr = A_POR_MPU_M3_PRLAR5_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR6_U_SMXP_0_1",
        .addr = A_POR_MPU_M3_PRBAR6_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR6_U_SMXP_0_1",
        .addr = A_POR_MPU_M3_PRLAR6_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR7_U_SMXP_0_1",
        .addr = A_POR_MPU_M3_PRBAR7_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR7_U_SMXP_0_1",
        .addr = A_POR_MPU_M3_PRLAR7_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR8_U_SMXP_0_1",
        .addr = A_POR_MPU_M3_PRBAR8_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR8_U_SMXP_0_1",
        .addr = A_POR_MPU_M3_PRLAR8_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR9_U_SMXP_0_1",
        .addr = A_POR_MPU_M3_PRBAR9_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR9_U_SMXP_0_1",
        .addr = A_POR_MPU_M3_PRLAR9_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR10_U_SMXP_0_1",
        .addr = A_POR_MPU_M3_PRBAR10_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR10_U_SMXP_0_1",
        .addr = A_POR_MPU_M3_PRLAR10_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR11_U_SMXP_0_1",
        .addr = A_POR_MPU_M3_PRBAR11_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR11_U_SMXP_0_1",
        .addr = A_POR_MPU_M3_PRLAR11_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR12_U_SMXP_0_1",
        .addr = A_POR_MPU_M3_PRBAR12_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR12_U_SMXP_0_1",
        .addr = A_POR_MPU_M3_PRLAR12_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR13_U_SMXP_0_1",
        .addr = A_POR_MPU_M3_PRBAR13_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR13_U_SMXP_0_1",
        .addr = A_POR_MPU_M3_PRLAR13_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR14_U_SMXP_0_1",
        .addr = A_POR_MPU_M3_PRBAR14_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR14_U_SMXP_0_1",
        .addr = A_POR_MPU_M3_PRLAR14_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR15_U_SMXP_0_1",
        .addr = A_POR_MPU_M3_PRBAR15_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR15_U_SMXP_0_1",
        .addr = A_POR_MPU_M3_PRLAR15_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR16_U_SMXP_0_1",
        .addr = A_POR_MPU_M3_PRBAR16_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR16_U_SMXP_0_1",
        .addr = A_POR_MPU_M3_PRLAR16_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR17_U_SMXP_0_1",
        .addr = A_POR_MPU_M3_PRBAR17_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR17_U_SMXP_0_1",
        .addr = A_POR_MPU_M3_PRLAR17_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR18_U_SMXP_0_1",
        .addr = A_POR_MPU_M3_PRBAR18_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR18_U_SMXP_0_1",
        .addr = A_POR_MPU_M3_PRLAR18_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR19_U_SMXP_0_1",
        .addr = A_POR_MPU_M3_PRBAR19_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR19_U_SMXP_0_1",
        .addr = A_POR_MPU_M3_PRLAR19_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR20_U_SMXP_0_1",
        .addr = A_POR_MPU_M3_PRBAR20_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR20_U_SMXP_0_1",
        .addr = A_POR_MPU_M3_PRLAR20_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR21_U_SMXP_0_1",
        .addr = A_POR_MPU_M3_PRBAR21_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR21_U_SMXP_0_1",
        .addr = A_POR_MPU_M3_PRLAR21_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR22_U_SMXP_0_1",
        .addr = A_POR_MPU_M3_PRBAR22_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR22_U_SMXP_0_1",
        .addr = A_POR_MPU_M3_PRLAR22_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR23_U_SMXP_0_1",
        .addr = A_POR_MPU_M3_PRBAR23_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR23_U_SMXP_0_1",
        .addr = A_POR_MPU_M3_PRLAR23_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR24_U_SMXP_0_1",
        .addr = A_POR_MPU_M3_PRBAR24_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR24_U_SMXP_0_1",
        .addr = A_POR_MPU_M3_PRLAR24_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR25_U_SMXP_0_1",
        .addr = A_POR_MPU_M3_PRBAR25_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR25_U_SMXP_0_1",
        .addr = A_POR_MPU_M3_PRLAR25_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR26_U_SMXP_0_1",
        .addr = A_POR_MPU_M3_PRBAR26_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR26_U_SMXP_0_1",
        .addr = A_POR_MPU_M3_PRLAR26_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR27_U_SMXP_0_1",
        .addr = A_POR_MPU_M3_PRBAR27_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR27_U_SMXP_0_1",
        .addr = A_POR_MPU_M3_PRLAR27_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR28_U_SMXP_0_1",
        .addr = A_POR_MPU_M3_PRBAR28_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR28_U_SMXP_0_1",
        .addr = A_POR_MPU_M3_PRLAR28_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR29_U_SMXP_0_1",
        .addr = A_POR_MPU_M3_PRBAR29_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR29_U_SMXP_0_1",
        .addr = A_POR_MPU_M3_PRLAR29_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR30_U_SMXP_0_1",
        .addr = A_POR_MPU_M3_PRBAR30_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR30_U_SMXP_0_1",
        .addr = A_POR_MPU_M3_PRLAR30_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR31_U_SMXP_0_1",
        .addr = A_POR_MPU_M3_PRBAR31_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR31_U_SMXP_0_1",
        .addr = A_POR_MPU_M3_PRLAR31_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_CTL_U_SMXP_0_1",
        .addr = A_POR_MPU_M4_CTL_U_SMXP_0_1,
        .reset = 0x2,
        .rsvd = 0xfffffffffffffff8L,
        .ro = 0xfffffffffffffff8L,
    },{ .name = "POR_MPU_M4_PRBAR0_U_SMXP_0_1",
        .addr = A_POR_MPU_M4_PRBAR0_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR0_U_SMXP_0_1",
        .addr = A_POR_MPU_M4_PRLAR0_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR1_U_SMXP_0_1",
        .addr = A_POR_MPU_M4_PRBAR1_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR1_U_SMXP_0_1",
        .addr = A_POR_MPU_M4_PRLAR1_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR2_U_SMXP_0_1",
        .addr = A_POR_MPU_M4_PRBAR2_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR2_U_SMXP_0_1",
        .addr = A_POR_MPU_M4_PRLAR2_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR3_U_SMXP_0_1",
        .addr = A_POR_MPU_M4_PRBAR3_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR3_U_SMXP_0_1",
        .addr = A_POR_MPU_M4_PRLAR3_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR4_U_SMXP_0_1",
        .addr = A_POR_MPU_M4_PRBAR4_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR4_U_SMXP_0_1",
        .addr = A_POR_MPU_M4_PRLAR4_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR5_U_SMXP_0_1",
        .addr = A_POR_MPU_M4_PRBAR5_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR5_U_SMXP_0_1",
        .addr = A_POR_MPU_M4_PRLAR5_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR6_U_SMXP_0_1",
        .addr = A_POR_MPU_M4_PRBAR6_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR6_U_SMXP_0_1",
        .addr = A_POR_MPU_M4_PRLAR6_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR7_U_SMXP_0_1",
        .addr = A_POR_MPU_M4_PRBAR7_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR7_U_SMXP_0_1",
        .addr = A_POR_MPU_M4_PRLAR7_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR8_U_SMXP_0_1",
        .addr = A_POR_MPU_M4_PRBAR8_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR8_U_SMXP_0_1",
        .addr = A_POR_MPU_M4_PRLAR8_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR9_U_SMXP_0_1",
        .addr = A_POR_MPU_M4_PRBAR9_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR9_U_SMXP_0_1",
        .addr = A_POR_MPU_M4_PRLAR9_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR10_U_SMXP_0_1",
        .addr = A_POR_MPU_M4_PRBAR10_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR10_U_SMXP_0_1",
        .addr = A_POR_MPU_M4_PRLAR10_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR11_U_SMXP_0_1",
        .addr = A_POR_MPU_M4_PRBAR11_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR11_U_SMXP_0_1",
        .addr = A_POR_MPU_M4_PRLAR11_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR12_U_SMXP_0_1",
        .addr = A_POR_MPU_M4_PRBAR12_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR12_U_SMXP_0_1",
        .addr = A_POR_MPU_M4_PRLAR12_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR13_U_SMXP_0_1",
        .addr = A_POR_MPU_M4_PRBAR13_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR13_U_SMXP_0_1",
        .addr = A_POR_MPU_M4_PRLAR13_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR14_U_SMXP_0_1",
        .addr = A_POR_MPU_M4_PRBAR14_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR14_U_SMXP_0_1",
        .addr = A_POR_MPU_M4_PRLAR14_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR15_U_SMXP_0_1",
        .addr = A_POR_MPU_M4_PRBAR15_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR15_U_SMXP_0_1",
        .addr = A_POR_MPU_M4_PRLAR15_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR16_U_SMXP_0_1",
        .addr = A_POR_MPU_M4_PRBAR16_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR16_U_SMXP_0_1",
        .addr = A_POR_MPU_M4_PRLAR16_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR17_U_SMXP_0_1",
        .addr = A_POR_MPU_M4_PRBAR17_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR17_U_SMXP_0_1",
        .addr = A_POR_MPU_M4_PRLAR17_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR18_U_SMXP_0_1",
        .addr = A_POR_MPU_M4_PRBAR18_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR18_U_SMXP_0_1",
        .addr = A_POR_MPU_M4_PRLAR18_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR19_U_SMXP_0_1",
        .addr = A_POR_MPU_M4_PRBAR19_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR19_U_SMXP_0_1",
        .addr = A_POR_MPU_M4_PRLAR19_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR20_U_SMXP_0_1",
        .addr = A_POR_MPU_M4_PRBAR20_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR20_U_SMXP_0_1",
        .addr = A_POR_MPU_M4_PRLAR20_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR21_U_SMXP_0_1",
        .addr = A_POR_MPU_M4_PRBAR21_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR21_U_SMXP_0_1",
        .addr = A_POR_MPU_M4_PRLAR21_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR22_U_SMXP_0_1",
        .addr = A_POR_MPU_M4_PRBAR22_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR22_U_SMXP_0_1",
        .addr = A_POR_MPU_M4_PRLAR22_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR23_U_SMXP_0_1",
        .addr = A_POR_MPU_M4_PRBAR23_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR23_U_SMXP_0_1",
        .addr = A_POR_MPU_M4_PRLAR23_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR24_U_SMXP_0_1",
        .addr = A_POR_MPU_M4_PRBAR24_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR24_U_SMXP_0_1",
        .addr = A_POR_MPU_M4_PRLAR24_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR25_U_SMXP_0_1",
        .addr = A_POR_MPU_M4_PRBAR25_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR25_U_SMXP_0_1",
        .addr = A_POR_MPU_M4_PRLAR25_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR26_U_SMXP_0_1",
        .addr = A_POR_MPU_M4_PRBAR26_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR26_U_SMXP_0_1",
        .addr = A_POR_MPU_M4_PRLAR26_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR27_U_SMXP_0_1",
        .addr = A_POR_MPU_M4_PRBAR27_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR27_U_SMXP_0_1",
        .addr = A_POR_MPU_M4_PRLAR27_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR28_U_SMXP_0_1",
        .addr = A_POR_MPU_M4_PRBAR28_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR28_U_SMXP_0_1",
        .addr = A_POR_MPU_M4_PRLAR28_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR29_U_SMXP_0_1",
        .addr = A_POR_MPU_M4_PRBAR29_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR29_U_SMXP_0_1",
        .addr = A_POR_MPU_M4_PRLAR29_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR30_U_SMXP_0_1",
        .addr = A_POR_MPU_M4_PRBAR30_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR30_U_SMXP_0_1",
        .addr = A_POR_MPU_M4_PRLAR30_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR31_U_SMXP_0_1",
        .addr = A_POR_MPU_M4_PRBAR31_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR31_U_SMXP_0_1",
        .addr = A_POR_MPU_M4_PRLAR31_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_CTL_U_SMXP_0_1",
        .addr = A_POR_MPU_M5_CTL_U_SMXP_0_1,
        .reset = 0x2,
        .rsvd = 0xfffffffffffffff8L,
        .ro = 0xfffffffffffffff8L,
    },{ .name = "POR_MPU_M5_PRBAR0_U_SMXP_0_1",
        .addr = A_POR_MPU_M5_PRBAR0_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR0_U_SMXP_0_1",
        .addr = A_POR_MPU_M5_PRLAR0_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR1_U_SMXP_0_1",
        .addr = A_POR_MPU_M5_PRBAR1_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR1_U_SMXP_0_1",
        .addr = A_POR_MPU_M5_PRLAR1_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR2_U_SMXP_0_1",
        .addr = A_POR_MPU_M5_PRBAR2_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR2_U_SMXP_0_1",
        .addr = A_POR_MPU_M5_PRLAR2_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR3_U_SMXP_0_1",
        .addr = A_POR_MPU_M5_PRBAR3_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR3_U_SMXP_0_1",
        .addr = A_POR_MPU_M5_PRLAR3_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR4_U_SMXP_0_1",
        .addr = A_POR_MPU_M5_PRBAR4_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR4_U_SMXP_0_1",
        .addr = A_POR_MPU_M5_PRLAR4_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR5_U_SMXP_0_1",
        .addr = A_POR_MPU_M5_PRBAR5_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR5_U_SMXP_0_1",
        .addr = A_POR_MPU_M5_PRLAR5_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR6_U_SMXP_0_1",
        .addr = A_POR_MPU_M5_PRBAR6_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR6_U_SMXP_0_1",
        .addr = A_POR_MPU_M5_PRLAR6_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR7_U_SMXP_0_1",
        .addr = A_POR_MPU_M5_PRBAR7_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR7_U_SMXP_0_1",
        .addr = A_POR_MPU_M5_PRLAR7_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR8_U_SMXP_0_1",
        .addr = A_POR_MPU_M5_PRBAR8_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR8_U_SMXP_0_1",
        .addr = A_POR_MPU_M5_PRLAR8_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR9_U_SMXP_0_1",
        .addr = A_POR_MPU_M5_PRBAR9_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR9_U_SMXP_0_1",
        .addr = A_POR_MPU_M5_PRLAR9_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR10_U_SMXP_0_1",
        .addr = A_POR_MPU_M5_PRBAR10_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR10_U_SMXP_0_1",
        .addr = A_POR_MPU_M5_PRLAR10_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR11_U_SMXP_0_1",
        .addr = A_POR_MPU_M5_PRBAR11_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR11_U_SMXP_0_1",
        .addr = A_POR_MPU_M5_PRLAR11_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR12_U_SMXP_0_1",
        .addr = A_POR_MPU_M5_PRBAR12_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR12_U_SMXP_0_1",
        .addr = A_POR_MPU_M5_PRLAR12_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR13_U_SMXP_0_1",
        .addr = A_POR_MPU_M5_PRBAR13_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR13_U_SMXP_0_1",
        .addr = A_POR_MPU_M5_PRLAR13_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR14_U_SMXP_0_1",
        .addr = A_POR_MPU_M5_PRBAR14_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR14_U_SMXP_0_1",
        .addr = A_POR_MPU_M5_PRLAR14_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR15_U_SMXP_0_1",
        .addr = A_POR_MPU_M5_PRBAR15_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR15_U_SMXP_0_1",
        .addr = A_POR_MPU_M5_PRLAR15_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR16_U_SMXP_0_1",
        .addr = A_POR_MPU_M5_PRBAR16_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR16_U_SMXP_0_1",
        .addr = A_POR_MPU_M5_PRLAR16_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR17_U_SMXP_0_1",
        .addr = A_POR_MPU_M5_PRBAR17_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR17_U_SMXP_0_1",
        .addr = A_POR_MPU_M5_PRLAR17_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR18_U_SMXP_0_1",
        .addr = A_POR_MPU_M5_PRBAR18_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR18_U_SMXP_0_1",
        .addr = A_POR_MPU_M5_PRLAR18_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR19_U_SMXP_0_1",
        .addr = A_POR_MPU_M5_PRBAR19_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR19_U_SMXP_0_1",
        .addr = A_POR_MPU_M5_PRLAR19_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR20_U_SMXP_0_1",
        .addr = A_POR_MPU_M5_PRBAR20_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR20_U_SMXP_0_1",
        .addr = A_POR_MPU_M5_PRLAR20_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR21_U_SMXP_0_1",
        .addr = A_POR_MPU_M5_PRBAR21_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR21_U_SMXP_0_1",
        .addr = A_POR_MPU_M5_PRLAR21_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR22_U_SMXP_0_1",
        .addr = A_POR_MPU_M5_PRBAR22_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR22_U_SMXP_0_1",
        .addr = A_POR_MPU_M5_PRLAR22_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR23_U_SMXP_0_1",
        .addr = A_POR_MPU_M5_PRBAR23_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR23_U_SMXP_0_1",
        .addr = A_POR_MPU_M5_PRLAR23_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR24_U_SMXP_0_1",
        .addr = A_POR_MPU_M5_PRBAR24_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR24_U_SMXP_0_1",
        .addr = A_POR_MPU_M5_PRLAR24_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR25_U_SMXP_0_1",
        .addr = A_POR_MPU_M5_PRBAR25_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR25_U_SMXP_0_1",
        .addr = A_POR_MPU_M5_PRLAR25_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR26_U_SMXP_0_1",
        .addr = A_POR_MPU_M5_PRBAR26_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR26_U_SMXP_0_1",
        .addr = A_POR_MPU_M5_PRLAR26_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR27_U_SMXP_0_1",
        .addr = A_POR_MPU_M5_PRBAR27_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR27_U_SMXP_0_1",
        .addr = A_POR_MPU_M5_PRLAR27_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR28_U_SMXP_0_1",
        .addr = A_POR_MPU_M5_PRBAR28_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR28_U_SMXP_0_1",
        .addr = A_POR_MPU_M5_PRLAR28_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR29_U_SMXP_0_1",
        .addr = A_POR_MPU_M5_PRBAR29_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR29_U_SMXP_0_1",
        .addr = A_POR_MPU_M5_PRLAR29_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR30_U_SMXP_0_1",
        .addr = A_POR_MPU_M5_PRBAR30_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR30_U_SMXP_0_1",
        .addr = A_POR_MPU_M5_PRLAR30_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR31_U_SMXP_0_1",
        .addr = A_POR_MPU_M5_PRBAR31_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR31_U_SMXP_0_1",
        .addr = A_POR_MPU_M5_PRLAR31_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_CTL_U_SMXP_0_1",
        .addr = A_POR_MPU_M6_CTL_U_SMXP_0_1,
        .reset = 0x2,
        .rsvd = 0xfffffffffffffff8L,
        .ro = 0xfffffffffffffff8L,
    },{ .name = "POR_MPU_M6_PRBAR0_U_SMXP_0_1",
        .addr = A_POR_MPU_M6_PRBAR0_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR0_U_SMXP_0_1",
        .addr = A_POR_MPU_M6_PRLAR0_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR1_U_SMXP_0_1",
        .addr = A_POR_MPU_M6_PRBAR1_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR1_U_SMXP_0_1",
        .addr = A_POR_MPU_M6_PRLAR1_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR2_U_SMXP_0_1",
        .addr = A_POR_MPU_M6_PRBAR2_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR2_U_SMXP_0_1",
        .addr = A_POR_MPU_M6_PRLAR2_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR3_U_SMXP_0_1",
        .addr = A_POR_MPU_M6_PRBAR3_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR3_U_SMXP_0_1",
        .addr = A_POR_MPU_M6_PRLAR3_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR4_U_SMXP_0_1",
        .addr = A_POR_MPU_M6_PRBAR4_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR4_U_SMXP_0_1",
        .addr = A_POR_MPU_M6_PRLAR4_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR5_U_SMXP_0_1",
        .addr = A_POR_MPU_M6_PRBAR5_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR5_U_SMXP_0_1",
        .addr = A_POR_MPU_M6_PRLAR5_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR6_U_SMXP_0_1",
        .addr = A_POR_MPU_M6_PRBAR6_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR6_U_SMXP_0_1",
        .addr = A_POR_MPU_M6_PRLAR6_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR7_U_SMXP_0_1",
        .addr = A_POR_MPU_M6_PRBAR7_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR7_U_SMXP_0_1",
        .addr = A_POR_MPU_M6_PRLAR7_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR8_U_SMXP_0_1",
        .addr = A_POR_MPU_M6_PRBAR8_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR8_U_SMXP_0_1",
        .addr = A_POR_MPU_M6_PRLAR8_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR9_U_SMXP_0_1",
        .addr = A_POR_MPU_M6_PRBAR9_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR9_U_SMXP_0_1",
        .addr = A_POR_MPU_M6_PRLAR9_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR10_U_SMXP_0_1",
        .addr = A_POR_MPU_M6_PRBAR10_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR10_U_SMXP_0_1",
        .addr = A_POR_MPU_M6_PRLAR10_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR11_U_SMXP_0_1",
        .addr = A_POR_MPU_M6_PRBAR11_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR11_U_SMXP_0_1",
        .addr = A_POR_MPU_M6_PRLAR11_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR12_U_SMXP_0_1",
        .addr = A_POR_MPU_M6_PRBAR12_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR12_U_SMXP_0_1",
        .addr = A_POR_MPU_M6_PRLAR12_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR13_U_SMXP_0_1",
        .addr = A_POR_MPU_M6_PRBAR13_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR13_U_SMXP_0_1",
        .addr = A_POR_MPU_M6_PRLAR13_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR14_U_SMXP_0_1",
        .addr = A_POR_MPU_M6_PRBAR14_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR14_U_SMXP_0_1",
        .addr = A_POR_MPU_M6_PRLAR14_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR15_U_SMXP_0_1",
        .addr = A_POR_MPU_M6_PRBAR15_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR15_U_SMXP_0_1",
        .addr = A_POR_MPU_M6_PRLAR15_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR16_U_SMXP_0_1",
        .addr = A_POR_MPU_M6_PRBAR16_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR16_U_SMXP_0_1",
        .addr = A_POR_MPU_M6_PRLAR16_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR17_U_SMXP_0_1",
        .addr = A_POR_MPU_M6_PRBAR17_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR17_U_SMXP_0_1",
        .addr = A_POR_MPU_M6_PRLAR17_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR18_U_SMXP_0_1",
        .addr = A_POR_MPU_M6_PRBAR18_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR18_U_SMXP_0_1",
        .addr = A_POR_MPU_M6_PRLAR18_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR19_U_SMXP_0_1",
        .addr = A_POR_MPU_M6_PRBAR19_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR19_U_SMXP_0_1",
        .addr = A_POR_MPU_M6_PRLAR19_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR20_U_SMXP_0_1",
        .addr = A_POR_MPU_M6_PRBAR20_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR20_U_SMXP_0_1",
        .addr = A_POR_MPU_M6_PRLAR20_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR21_U_SMXP_0_1",
        .addr = A_POR_MPU_M6_PRBAR21_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR21_U_SMXP_0_1",
        .addr = A_POR_MPU_M6_PRLAR21_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR22_U_SMXP_0_1",
        .addr = A_POR_MPU_M6_PRBAR22_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR22_U_SMXP_0_1",
        .addr = A_POR_MPU_M6_PRLAR22_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR23_U_SMXP_0_1",
        .addr = A_POR_MPU_M6_PRBAR23_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR23_U_SMXP_0_1",
        .addr = A_POR_MPU_M6_PRLAR23_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR24_U_SMXP_0_1",
        .addr = A_POR_MPU_M6_PRBAR24_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR24_U_SMXP_0_1",
        .addr = A_POR_MPU_M6_PRLAR24_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR25_U_SMXP_0_1",
        .addr = A_POR_MPU_M6_PRBAR25_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR25_U_SMXP_0_1",
        .addr = A_POR_MPU_M6_PRLAR25_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR26_U_SMXP_0_1",
        .addr = A_POR_MPU_M6_PRBAR26_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR26_U_SMXP_0_1",
        .addr = A_POR_MPU_M6_PRLAR26_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR27_U_SMXP_0_1",
        .addr = A_POR_MPU_M6_PRBAR27_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR27_U_SMXP_0_1",
        .addr = A_POR_MPU_M6_PRLAR27_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR28_U_SMXP_0_1",
        .addr = A_POR_MPU_M6_PRBAR28_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR28_U_SMXP_0_1",
        .addr = A_POR_MPU_M6_PRLAR28_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR29_U_SMXP_0_1",
        .addr = A_POR_MPU_M6_PRBAR29_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR29_U_SMXP_0_1",
        .addr = A_POR_MPU_M6_PRLAR29_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR30_U_SMXP_0_1",
        .addr = A_POR_MPU_M6_PRBAR30_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR30_U_SMXP_0_1",
        .addr = A_POR_MPU_M6_PRLAR30_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR31_U_SMXP_0_1",
        .addr = A_POR_MPU_M6_PRBAR31_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR31_U_SMXP_0_1",
        .addr = A_POR_MPU_M6_PRLAR31_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_CTL_U_SMXP_0_1",
        .addr = A_POR_MPU_M7_CTL_U_SMXP_0_1,
        .reset = 0x2,
        .rsvd = 0xfffffffffffffff8L,
        .ro = 0xfffffffffffffff8L,
    },{ .name = "POR_MPU_M7_PRBAR0_U_SMXP_0_1",
        .addr = A_POR_MPU_M7_PRBAR0_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR0_U_SMXP_0_1",
        .addr = A_POR_MPU_M7_PRLAR0_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR1_U_SMXP_0_1",
        .addr = A_POR_MPU_M7_PRBAR1_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR1_U_SMXP_0_1",
        .addr = A_POR_MPU_M7_PRLAR1_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR2_U_SMXP_0_1",
        .addr = A_POR_MPU_M7_PRBAR2_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR2_U_SMXP_0_1",
        .addr = A_POR_MPU_M7_PRLAR2_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR3_U_SMXP_0_1",
        .addr = A_POR_MPU_M7_PRBAR3_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR3_U_SMXP_0_1",
        .addr = A_POR_MPU_M7_PRLAR3_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR4_U_SMXP_0_1",
        .addr = A_POR_MPU_M7_PRBAR4_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR4_U_SMXP_0_1",
        .addr = A_POR_MPU_M7_PRLAR4_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR5_U_SMXP_0_1",
        .addr = A_POR_MPU_M7_PRBAR5_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR5_U_SMXP_0_1",
        .addr = A_POR_MPU_M7_PRLAR5_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR6_U_SMXP_0_1",
        .addr = A_POR_MPU_M7_PRBAR6_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR6_U_SMXP_0_1",
        .addr = A_POR_MPU_M7_PRLAR6_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR7_U_SMXP_0_1",
        .addr = A_POR_MPU_M7_PRBAR7_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR7_U_SMXP_0_1",
        .addr = A_POR_MPU_M7_PRLAR7_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR8_U_SMXP_0_1",
        .addr = A_POR_MPU_M7_PRBAR8_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR8_U_SMXP_0_1",
        .addr = A_POR_MPU_M7_PRLAR8_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR9_U_SMXP_0_1",
        .addr = A_POR_MPU_M7_PRBAR9_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR9_U_SMXP_0_1",
        .addr = A_POR_MPU_M7_PRLAR9_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR10_U_SMXP_0_1",
        .addr = A_POR_MPU_M7_PRBAR10_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR10_U_SMXP_0_1",
        .addr = A_POR_MPU_M7_PRLAR10_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR11_U_SMXP_0_1",
        .addr = A_POR_MPU_M7_PRBAR11_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR11_U_SMXP_0_1",
        .addr = A_POR_MPU_M7_PRLAR11_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR12_U_SMXP_0_1",
        .addr = A_POR_MPU_M7_PRBAR12_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR12_U_SMXP_0_1",
        .addr = A_POR_MPU_M7_PRLAR12_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR13_U_SMXP_0_1",
        .addr = A_POR_MPU_M7_PRBAR13_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR13_U_SMXP_0_1",
        .addr = A_POR_MPU_M7_PRLAR13_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR14_U_SMXP_0_1",
        .addr = A_POR_MPU_M7_PRBAR14_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR14_U_SMXP_0_1",
        .addr = A_POR_MPU_M7_PRLAR14_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR15_U_SMXP_0_1",
        .addr = A_POR_MPU_M7_PRBAR15_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR15_U_SMXP_0_1",
        .addr = A_POR_MPU_M7_PRLAR15_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR16_U_SMXP_0_1",
        .addr = A_POR_MPU_M7_PRBAR16_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR16_U_SMXP_0_1",
        .addr = A_POR_MPU_M7_PRLAR16_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR17_U_SMXP_0_1",
        .addr = A_POR_MPU_M7_PRBAR17_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR17_U_SMXP_0_1",
        .addr = A_POR_MPU_M7_PRLAR17_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR18_U_SMXP_0_1",
        .addr = A_POR_MPU_M7_PRBAR18_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR18_U_SMXP_0_1",
        .addr = A_POR_MPU_M7_PRLAR18_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR19_U_SMXP_0_1",
        .addr = A_POR_MPU_M7_PRBAR19_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR19_U_SMXP_0_1",
        .addr = A_POR_MPU_M7_PRLAR19_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR20_U_SMXP_0_1",
        .addr = A_POR_MPU_M7_PRBAR20_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR20_U_SMXP_0_1",
        .addr = A_POR_MPU_M7_PRLAR20_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR21_U_SMXP_0_1",
        .addr = A_POR_MPU_M7_PRBAR21_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR21_U_SMXP_0_1",
        .addr = A_POR_MPU_M7_PRLAR21_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR22_U_SMXP_0_1",
        .addr = A_POR_MPU_M7_PRBAR22_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR22_U_SMXP_0_1",
        .addr = A_POR_MPU_M7_PRLAR22_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR23_U_SMXP_0_1",
        .addr = A_POR_MPU_M7_PRBAR23_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR23_U_SMXP_0_1",
        .addr = A_POR_MPU_M7_PRLAR23_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR24_U_SMXP_0_1",
        .addr = A_POR_MPU_M7_PRBAR24_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR24_U_SMXP_0_1",
        .addr = A_POR_MPU_M7_PRLAR24_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR25_U_SMXP_0_1",
        .addr = A_POR_MPU_M7_PRBAR25_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR25_U_SMXP_0_1",
        .addr = A_POR_MPU_M7_PRLAR25_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR26_U_SMXP_0_1",
        .addr = A_POR_MPU_M7_PRBAR26_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR26_U_SMXP_0_1",
        .addr = A_POR_MPU_M7_PRLAR26_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR27_U_SMXP_0_1",
        .addr = A_POR_MPU_M7_PRBAR27_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR27_U_SMXP_0_1",
        .addr = A_POR_MPU_M7_PRLAR27_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR28_U_SMXP_0_1",
        .addr = A_POR_MPU_M7_PRBAR28_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR28_U_SMXP_0_1",
        .addr = A_POR_MPU_M7_PRLAR28_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR29_U_SMXP_0_1",
        .addr = A_POR_MPU_M7_PRBAR29_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR29_U_SMXP_0_1",
        .addr = A_POR_MPU_M7_PRLAR29_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR30_U_SMXP_0_1",
        .addr = A_POR_MPU_M7_PRBAR30_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR30_U_SMXP_0_1",
        .addr = A_POR_MPU_M7_PRLAR30_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR31_U_SMXP_0_1",
        .addr = A_POR_MPU_M7_PRBAR31_U_SMXP_0_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR31_U_SMXP_0_1",
        .addr = A_POR_MPU_M7_PRLAR31_U_SMXP_0_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_RNSAM_NODE_INFO_U_RNFBESAM_NID12",
        .addr = A_POR_RNSAM_NODE_INFO_U_RNFBESAM_NID12,
        .reset = 0x4000f,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_RNSAM_CHILD_INFO_U_RNFBESAM_NID12",
        .addr = A_POR_RNSAM_CHILD_INFO_U_RNFBESAM_NID12,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_RNSAM_UNIT_INFO_U_RNFBESAM_NID12",
        .addr = A_POR_RNSAM_UNIT_INFO_U_RNFBESAM_NID12,
        .reset = 0x800040004,
        .rsvd = 0xff00,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_RNSAM_SECURE_REGISTER_GROUPS_OVERRIDE_U_RNFBESAM_NID12",
        .addr = A_POR_RNSAM_SECURE_REGISTER_GROUPS_OVERRIDE_U_RNFBESAM_NID12,
        .rsvd = 0xfffffffffffffffeL,
        .ro = 0xfffffffffffffffeL,
    },{ .name = "RNSAM_STATUS_U_RNFBESAM_NID12",
        .addr = A_RNSAM_STATUS_U_RNFBESAM_NID12,
        .reset = 0x1,
        .rsvd = 0xfffffffffffffffcL,
        .ro = 0xfffffffffffffffcL,
    },{ .name = "NON_HASH_MEM_REGION_REG0_U_RNFBESAM_NID12",
        .addr = A_NON_HASH_MEM_REGION_REG0_U_RNFBESAM_NID12,
        .rsvd = 0x2,
        .ro = 0x8000000280000002L,
    },{ .name = "NON_HASH_MEM_REGION_REG1_U_RNFBESAM_NID12",
        .addr = A_NON_HASH_MEM_REGION_REG1_U_RNFBESAM_NID12,
        .rsvd = 0x2,
        .ro = 0x8000000280000002L,
    },{ .name = "NON_HASH_MEM_REGION_REG2_U_RNFBESAM_NID12",
        .addr = A_NON_HASH_MEM_REGION_REG2_U_RNFBESAM_NID12,
        .rsvd = 0x2,
        .ro = 0x8000000280000002L,
    },{ .name = "NON_HASH_MEM_REGION_REG3_U_RNFBESAM_NID12",
        .addr = A_NON_HASH_MEM_REGION_REG3_U_RNFBESAM_NID12,
        .rsvd = 0x2,
        .ro = 0x8000000280000002L,
    },{ .name = "NON_HASH_TGT_NODEID0_U_RNFBESAM_NID12",
        .addr = A_NON_HASH_TGT_NODEID0_U_RNFBESAM_NID12,
        .ro = 0xffff800800800800L,
    },{ .name = "NON_HASH_TGT_NODEID1_U_RNFBESAM_NID12",
        .addr = A_NON_HASH_TGT_NODEID1_U_RNFBESAM_NID12,
        .ro = 0xffff800800800800L,
    },{ .name = "NON_HASH_TGT_NODEID2_U_RNFBESAM_NID12",
        .addr = A_NON_HASH_TGT_NODEID2_U_RNFBESAM_NID12,
        .ro = 0xffffffffff800800L,
    },{ .name = "SYS_CACHE_GRP_REGION0_U_RNFBESAM_NID12",
        .addr = A_SYS_CACHE_GRP_REGION0_U_RNFBESAM_NID12,
        .rsvd = 0x2,
        .ro = 0x8000000080000002L,
    },{ .name = "SYS_CACHE_GRP_REGION1_U_RNFBESAM_NID12",
        .addr = A_SYS_CACHE_GRP_REGION1_U_RNFBESAM_NID12,
        .ro = 0x8000000080000000L,
    },{ .name = "SYS_CACHE_GRP_HN_NODEID_REG0_U_RNFBESAM_NID12",
        .addr = A_SYS_CACHE_GRP_HN_NODEID_REG0_U_RNFBESAM_NID12,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_HN_NODEID_REG1_U_RNFBESAM_NID12",
        .addr = A_SYS_CACHE_GRP_HN_NODEID_REG1_U_RNFBESAM_NID12,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_HN_NODEID_REG2_U_RNFBESAM_NID12",
        .addr = A_SYS_CACHE_GRP_HN_NODEID_REG2_U_RNFBESAM_NID12,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_HN_NODEID_REG3_U_RNFBESAM_NID12",
        .addr = A_SYS_CACHE_GRP_HN_NODEID_REG3_U_RNFBESAM_NID12,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_HN_NODEID_REG4_U_RNFBESAM_NID12",
        .addr = A_SYS_CACHE_GRP_HN_NODEID_REG4_U_RNFBESAM_NID12,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_HN_NODEID_REG5_U_RNFBESAM_NID12",
        .addr = A_SYS_CACHE_GRP_HN_NODEID_REG5_U_RNFBESAM_NID12,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_HN_NODEID_REG6_U_RNFBESAM_NID12",
        .addr = A_SYS_CACHE_GRP_HN_NODEID_REG6_U_RNFBESAM_NID12,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_HN_NODEID_REG7_U_RNFBESAM_NID12",
        .addr = A_SYS_CACHE_GRP_HN_NODEID_REG7_U_RNFBESAM_NID12,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_NONHASH_NODEID_U_RNFBESAM_NID12",
        .addr = A_SYS_CACHE_GRP_NONHASH_NODEID_U_RNFBESAM_NID12,
        .ro = 0xfffffff800800800L,
    },{ .name = "SYS_CACHE_GROUP_HN_COUNT_U_RNFBESAM_NID12",
        .addr = A_SYS_CACHE_GROUP_HN_COUNT_U_RNFBESAM_NID12,
        .rsvd = 0x80,
        .ro = 0xffffffff80808080L,
    },{ .name = "SYS_CACHE_GRP_SN_NODEID_REG0_U_RNFBESAM_NID12",
        .addr = A_SYS_CACHE_GRP_SN_NODEID_REG0_U_RNFBESAM_NID12,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_SN_NODEID_REG1_U_RNFBESAM_NID12",
        .addr = A_SYS_CACHE_GRP_SN_NODEID_REG1_U_RNFBESAM_NID12,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_SN_NODEID_REG2_U_RNFBESAM_NID12",
        .addr = A_SYS_CACHE_GRP_SN_NODEID_REG2_U_RNFBESAM_NID12,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_SN_NODEID_REG3_U_RNFBESAM_NID12",
        .addr = A_SYS_CACHE_GRP_SN_NODEID_REG3_U_RNFBESAM_NID12,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_SN_NODEID_REG4_U_RNFBESAM_NID12",
        .addr = A_SYS_CACHE_GRP_SN_NODEID_REG4_U_RNFBESAM_NID12,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_SN_NODEID_REG5_U_RNFBESAM_NID12",
        .addr = A_SYS_CACHE_GRP_SN_NODEID_REG5_U_RNFBESAM_NID12,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_SN_NODEID_REG6_U_RNFBESAM_NID12",
        .addr = A_SYS_CACHE_GRP_SN_NODEID_REG6_U_RNFBESAM_NID12,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_SN_NODEID_REG7_U_RNFBESAM_NID12",
        .addr = A_SYS_CACHE_GRP_SN_NODEID_REG7_U_RNFBESAM_NID12,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_SN_SAM_CFG0_U_RNFBESAM_NID12",
        .addr = A_SYS_CACHE_GRP_SN_SAM_CFG0_U_RNFBESAM_NID12,
        .rsvd = 0xc0,
        .ro = 0xffffc0c0c0c0c0c0L,
    },{ .name = "SYS_CACHE_GRP_SN_SAM_CFG1_U_RNFBESAM_NID12",
        .addr = A_SYS_CACHE_GRP_SN_SAM_CFG1_U_RNFBESAM_NID12,
        .rsvd = 0xc0,
        .ro = 0xffffc0c0c0c0c0c0L,
    },{ .name = "GIC_MEM_REGION_REG_U_RNFBESAM_NID12",
        .addr = A_GIC_MEM_REGION_REG_U_RNFBESAM_NID12,
        .rsvd = 0xff82,
        .ro = 0x800f00000000ff82L,
    },{ .name = "SYS_CACHE_GRP_SN_ATTR_U_RNFBESAM_NID12",
        .addr = A_SYS_CACHE_GRP_SN_ATTR_U_RNFBESAM_NID12,
        .rsvd = 0xffce,
        .ro = 0xffceffceffceffceL,
    },{ .name = "SYS_CACHE_GRP_HN_CPA_EN_REG_U_RNFBESAM_NID12",
        .addr = A_SYS_CACHE_GRP_HN_CPA_EN_REG_U_RNFBESAM_NID12,
    },{ .name = "SYS_CACHE_GRP_HN_CPA_GRP_REG_U_RNFBESAM_NID12",
        .addr = A_SYS_CACHE_GRP_HN_CPA_GRP_REG_U_RNFBESAM_NID12,
        .rsvd = 0xfffc,
        .ro = 0xfffcfffcfffcfffcL,
    },{ .name = "CML_PORT_AGGR_MODE_CTRL_REG_U_RNFBESAM_NID12",
        .addr = A_CML_PORT_AGGR_MODE_CTRL_REG_U_RNFBESAM_NID12,
        .rsvd = 0x88,
        .ro = 0xffffffff28888888L,
    },{ .name = "CML_PORT_AGGR_GRP0_ADD_MASK_U_RNFBESAM_NID12",
        .addr = A_CML_PORT_AGGR_GRP0_ADD_MASK_U_RNFBESAM_NID12,
        .reset = 0x40,
        .ro = 0xffff00000000003fL,
    },{ .name = "CML_PORT_AGGR_GRP1_ADD_MASK_U_RNFBESAM_NID12",
        .addr = A_CML_PORT_AGGR_GRP1_ADD_MASK_U_RNFBESAM_NID12,
        .reset = 0x40,
        .ro = 0xffff00000000003fL,
    },{ .name = "CML_PORT_AGGR_GRP0_REG_U_RNFBESAM_NID12",
        .addr = A_CML_PORT_AGGR_GRP0_REG_U_RNFBESAM_NID12,
        .ro = 0xfffc800800800800L,
    },{ .name = "CML_PORT_AGGR_GRP1_REG_U_RNFBESAM_NID12",
        .addr = A_CML_PORT_AGGR_GRP1_REG_U_RNFBESAM_NID12,
        .ro = 0xfffc800800800800L,
    },{ .name = "SYS_CACHE_GRP_SECONDARY_REG0_U_RNFBESAM_NID12",
        .addr = A_SYS_CACHE_GRP_SECONDARY_REG0_U_RNFBESAM_NID12,
        .rsvd = 0x2,
        .ro = 0x8000000280000002L,
    },{ .name = "SYS_CACHE_GRP_SECONDARY_REG1_U_RNFBESAM_NID12",
        .addr = A_SYS_CACHE_GRP_SECONDARY_REG1_U_RNFBESAM_NID12,
        .rsvd = 0x2,
        .ro = 0x8000000280000002L,
    },{ .name = "SYS_CACHE_GRP_CAL_MODE_REG_U_RNFBESAM_NID12",
        .addr = A_SYS_CACHE_GRP_CAL_MODE_REG_U_RNFBESAM_NID12,
        .rsvd = 0xfffe,
        .ro = 0xfffefffefffefffeL,
    },{ .name = "RNSAM_HASH_ADDR_MASK_REG_U_RNFBESAM_NID12",
        .addr = A_RNSAM_HASH_ADDR_MASK_REG_U_RNFBESAM_NID12,
        .reset = 0xffffffffffc0,
        .ro = 0xffff00000000003fL,
    },{ .name = "RNSAM_REGION_CMP_ADDR_MASK_REG_U_RNFBESAM_NID12",
        .addr = A_RNSAM_REGION_CMP_ADDR_MASK_REG_U_RNFBESAM_NID12,
        .reset = 0xffffffff0000,
        .ro = 0xffff00000000ffffL,
    },{ .name = "SYS_CACHE_GRP_HN_NODEID_REG8_U_RNFBESAM_NID12",
        .addr = A_SYS_CACHE_GRP_HN_NODEID_REG8_U_RNFBESAM_NID12,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_HN_NODEID_REG9_U_RNFBESAM_NID12",
        .addr = A_SYS_CACHE_GRP_HN_NODEID_REG9_U_RNFBESAM_NID12,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_HN_NODEID_REG10_U_RNFBESAM_NID12",
        .addr = A_SYS_CACHE_GRP_HN_NODEID_REG10_U_RNFBESAM_NID12,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_HN_NODEID_REG11_U_RNFBESAM_NID12",
        .addr = A_SYS_CACHE_GRP_HN_NODEID_REG11_U_RNFBESAM_NID12,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_HN_NODEID_REG12_U_RNFBESAM_NID12",
        .addr = A_SYS_CACHE_GRP_HN_NODEID_REG12_U_RNFBESAM_NID12,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_HN_NODEID_REG13_U_RNFBESAM_NID12",
        .addr = A_SYS_CACHE_GRP_HN_NODEID_REG13_U_RNFBESAM_NID12,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_HN_NODEID_REG14_U_RNFBESAM_NID12",
        .addr = A_SYS_CACHE_GRP_HN_NODEID_REG14_U_RNFBESAM_NID12,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_HN_NODEID_REG15_U_RNFBESAM_NID12",
        .addr = A_SYS_CACHE_GRP_HN_NODEID_REG15_U_RNFBESAM_NID12,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_SN_NODEID_REG8_U_RNFBESAM_NID12",
        .addr = A_SYS_CACHE_GRP_SN_NODEID_REG8_U_RNFBESAM_NID12,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_SN_NODEID_REG9_U_RNFBESAM_NID12",
        .addr = A_SYS_CACHE_GRP_SN_NODEID_REG9_U_RNFBESAM_NID12,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_SN_NODEID_REG10_U_RNFBESAM_NID12",
        .addr = A_SYS_CACHE_GRP_SN_NODEID_REG10_U_RNFBESAM_NID12,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_SN_NODEID_REG11_U_RNFBESAM_NID12",
        .addr = A_SYS_CACHE_GRP_SN_NODEID_REG11_U_RNFBESAM_NID12,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_SN_NODEID_REG12_U_RNFBESAM_NID12",
        .addr = A_SYS_CACHE_GRP_SN_NODEID_REG12_U_RNFBESAM_NID12,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_SN_NODEID_REG13_U_RNFBESAM_NID12",
        .addr = A_SYS_CACHE_GRP_SN_NODEID_REG13_U_RNFBESAM_NID12,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_SN_NODEID_REG14_U_RNFBESAM_NID12",
        .addr = A_SYS_CACHE_GRP_SN_NODEID_REG14_U_RNFBESAM_NID12,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_SN_NODEID_REG15_U_RNFBESAM_NID12",
        .addr = A_SYS_CACHE_GRP_SN_NODEID_REG15_U_RNFBESAM_NID12,
        .ro = 0xffff800800800800L,
    },{ .name = "POR_SBSX_NODE_INFO_U_SBSX_NID64",
        .addr = A_POR_SBSX_NODE_INFO_U_SBSX_NID64,
        .reset = 0x7,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_SBSX_CHILD_INFO_U_SBSX_NID64",
        .addr = A_POR_SBSX_CHILD_INFO_U_SBSX_NID64,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_SBSX_UNIT_INFO_U_SBSX_NID64",
        .addr = A_POR_SBSX_UNIT_INFO_U_SBSX_NID64,
        .reset = 0x84011,
        .rsvd = 0xee,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_SBSX_AUX_CTL_U_SBSX_NID64",
        .addr = A_POR_SBSX_AUX_CTL_U_SBSX_NID64,
        .rsvd = 0xfffffffffffffffeL,
        .ro = 0xfffffffffffffffeL,
    },{ .name = "POR_SBSX_PMU_EVENT_SEL_U_SBSX_NID64",
        .addr = A_POR_SBSX_PMU_EVENT_SEL_U_SBSX_NID64,
        .rsvd = 0xc0,
        .ro = 0xffffffffc0c0c0c0L,
    },{ .name = "POR_SBSX_ERRFR_U_SBSX_NID64",
        .addr = A_POR_SBSX_ERRFR_U_SBSX_NID64,
        .reset = 0xa1,
        .rsvd = 0x300,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_SBSX_ERRCTLR_U_SBSX_NID64",
        .addr = A_POR_SBSX_ERRCTLR_U_SBSX_NID64,
        .rsvd = 0xf0,
        .ro = 0xfffffffffffffef0L,
    },{ .name = "POR_SBSX_ERRSTATUS_U_SBSX_NID64",
        .addr = A_POR_SBSX_ERRSTATUS_U_SBSX_NID64,
        .ro = 0xffffffff127fffffL,
    },{ .name = "POR_SBSX_ERRADDR_U_SBSX_NID64",
        .addr = A_POR_SBSX_ERRADDR_U_SBSX_NID64,
        .ro = 0x7fff000000000000,
    },{ .name = "POR_SBSX_ERRMISC_U_SBSX_NID64",
        .addr = A_POR_SBSX_ERRMISC_U_SBSX_NID64,
        .ro = 0xffffffff80fe800fL,
    },{ .name = "POR_SBSX_ERRFR_NS_U_SBSX_NID64",
        .addr = A_POR_SBSX_ERRFR_NS_U_SBSX_NID64,
        .reset = 0xa1,
        .rsvd = 0x300,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_SBSX_ERRCTLR_NS_U_SBSX_NID64",
        .addr = A_POR_SBSX_ERRCTLR_NS_U_SBSX_NID64,
        .rsvd = 0xf0,
        .ro = 0xfffffffffffffef0L,
    },{ .name = "POR_SBSX_ERRSTATUS_NS_U_SBSX_NID64",
        .addr = A_POR_SBSX_ERRSTATUS_NS_U_SBSX_NID64,
        .ro = 0xffffffff127fffffL,
    },{ .name = "POR_SBSX_ERRADDR_NS_U_SBSX_NID64",
        .addr = A_POR_SBSX_ERRADDR_NS_U_SBSX_NID64,
        .ro = 0x7fff000000000000,
    },{ .name = "POR_SBSX_ERRMISC_NS_U_SBSX_NID64",
        .addr = A_POR_SBSX_ERRMISC_NS_U_SBSX_NID64,
        .ro = 0xffffffff80fe800fL,
    },{ .name = "POR_MXP_NODE_INFO_U_SMXP_1_0",
        .addr = A_POR_MXP_NODE_INFO_U_SMXP_1_0,
        .reset = 0x1080006,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_DEVICE_PORT_CONNECT_INFO_P0_U_SMXP_1_0",
        .addr = A_POR_MXP_DEVICE_PORT_CONNECT_INFO_P0_U_SMXP_1_0,
        .reset = 0xd,
        .rsvd = 0xffe0,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_DEVICE_PORT_CONNECT_INFO_P1_U_SMXP_1_0",
        .addr = A_POR_MXP_DEVICE_PORT_CONNECT_INFO_P1_U_SMXP_1_0,
        .reset = 0x1,
        .rsvd = 0xffe0,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_MESH_PORT_CONNECT_INFO_EAST_U_SMXP_1_0",
        .addr = A_POR_MXP_MESH_PORT_CONNECT_INFO_EAST_U_SMXP_1_0,
        .rsvd = 0xfffffffffffffff0L,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_MESH_PORT_CONNECT_INFO_NORTH_U_SMXP_1_0",
        .addr = A_POR_MXP_MESH_PORT_CONNECT_INFO_NORTH_U_SMXP_1_0,
        .rsvd = 0xfffffffffffffff0L,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_INFO_U_SMXP_1_0",
        .addr = A_POR_MXP_CHILD_INFO_U_SMXP_1_0,
        .reset = 0x1000006,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_POINTER_0_U_SMXP_1_0",
        .addr = A_POR_MXP_CHILD_POINTER_0_U_SMXP_1_0,
        .reset = 0x8212c000,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_POINTER_1_U_SMXP_1_0",
        .addr = A_POR_MXP_CHILD_POINTER_1_U_SMXP_1_0,
        .reset = 0x8213c000,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_POINTER_2_U_SMXP_1_0",
        .addr = A_POR_MXP_CHILD_POINTER_2_U_SMXP_1_0,
        .reset = 0x2168000,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_POINTER_3_U_SMXP_1_0",
        .addr = A_POR_MXP_CHILD_POINTER_3_U_SMXP_1_0,
        .reset = 0x821d0000,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_POINTER_4_U_SMXP_1_0",
        .addr = A_POR_MXP_CHILD_POINTER_4_U_SMXP_1_0,
        .reset = 0x82120000,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_POINTER_5_U_SMXP_1_0",
        .addr = A_POR_MXP_CHILD_POINTER_5_U_SMXP_1_0,
        .reset = 0x2150000,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_POINTER_6_U_SMXP_1_0",
        .addr = A_POR_MXP_CHILD_POINTER_6_U_SMXP_1_0,
        .reset = 0x2110000,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_POINTER_7_U_SMXP_1_0",
        .addr = A_POR_MXP_CHILD_POINTER_7_U_SMXP_1_0,
        .reset = 0x2100000,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_POINTER_8_U_SMXP_1_0",
        .addr = A_POR_MXP_CHILD_POINTER_8_U_SMXP_1_0,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_POINTER_9_U_SMXP_1_0",
        .addr = A_POR_MXP_CHILD_POINTER_9_U_SMXP_1_0,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_POINTER_10_U_SMXP_1_0",
        .addr = A_POR_MXP_CHILD_POINTER_10_U_SMXP_1_0,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_POINTER_11_U_SMXP_1_0",
        .addr = A_POR_MXP_CHILD_POINTER_11_U_SMXP_1_0,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_POINTER_12_U_SMXP_1_0",
        .addr = A_POR_MXP_CHILD_POINTER_12_U_SMXP_1_0,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_POINTER_13_U_SMXP_1_0",
        .addr = A_POR_MXP_CHILD_POINTER_13_U_SMXP_1_0,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_POINTER_14_U_SMXP_1_0",
        .addr = A_POR_MXP_CHILD_POINTER_14_U_SMXP_1_0,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_POINTER_15_U_SMXP_1_0",
        .addr = A_POR_MXP_CHILD_POINTER_15_U_SMXP_1_0,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_P0_INFO_U_SMXP_1_0",
        .addr = A_POR_MXP_P0_INFO_U_SMXP_1_0,
        .reset = 0x211,
        .rsvd = 0x48,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_P1_INFO_U_SMXP_1_0",
        .addr = A_POR_MXP_P1_INFO_U_SMXP_1_0,
        .reset = 0x211,
        .rsvd = 0x48,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_SECURE_REGISTER_GROUPS_OVERRIDE_U_SMXP_1_0",
        .addr = A_POR_MXP_SECURE_REGISTER_GROUPS_OVERRIDE_U_SMXP_1_0,
        .rsvd = 0xfffffffffffffffcL,
        .ro = 0xfffffffffffffffcL,
    },{ .name = "POR_MXP_AUX_CTL_U_SMXP_1_0",
        .addr = A_POR_MXP_AUX_CTL_U_SMXP_1_0,
        .rsvd = 0xfffffffffffffffeL,
        .ro = 0xfffffffffffffffeL,
    },{ .name = "POR_MXP_P0_QOS_CONTROL_U_SMXP_1_0",
        .addr = A_POR_MXP_P0_QOS_CONTROL_U_SMXP_1_0,
        .rsvd = 0xffaa,
        .ro = 0xfffffffffff0ffaaL,
    },{ .name = "POR_MXP_P0_QOS_LAT_TGT_U_SMXP_1_0",
        .addr = A_POR_MXP_P0_QOS_LAT_TGT_U_SMXP_1_0,
        .ro = 0xfffffffffffff000L,
    },{ .name = "POR_MXP_P0_QOS_LAT_SCALE_U_SMXP_1_0",
        .addr = A_POR_MXP_P0_QOS_LAT_SCALE_U_SMXP_1_0,
        .rsvd = 0xfffffffffffffff8L,
        .ro = 0xfffffffffffffff8L,
    },{ .name = "POR_MXP_P0_QOS_LAT_RANGE_U_SMXP_1_0",
        .addr = A_POR_MXP_P0_QOS_LAT_RANGE_U_SMXP_1_0,
        .rsvd = 0xf0,
        .ro = 0xfffffffffffff0f0L,
    },{ .name = "POR_MXP_P1_QOS_CONTROL_U_SMXP_1_0",
        .addr = A_POR_MXP_P1_QOS_CONTROL_U_SMXP_1_0,
        .rsvd = 0xffaa,
        .ro = 0xfffffffffff0ffaaL,
    },{ .name = "POR_MXP_P1_QOS_LAT_TGT_U_SMXP_1_0",
        .addr = A_POR_MXP_P1_QOS_LAT_TGT_U_SMXP_1_0,
        .ro = 0xfffffffffffff000L,
    },{ .name = "POR_MXP_P1_QOS_LAT_SCALE_U_SMXP_1_0",
        .addr = A_POR_MXP_P1_QOS_LAT_SCALE_U_SMXP_1_0,
        .rsvd = 0xfffffffffffffff8L,
        .ro = 0xfffffffffffffff8L,
    },{ .name = "POR_MXP_P1_QOS_LAT_RANGE_U_SMXP_1_0",
        .addr = A_POR_MXP_P1_QOS_LAT_RANGE_U_SMXP_1_0,
        .rsvd = 0xf0,
        .ro = 0xfffffffffffff0f0L,
    },{ .name = "POR_MXP_P0_SYSCOREQ_CTL_U_SMXP_1_0",
        .addr = A_POR_MXP_P0_SYSCOREQ_CTL_U_SMXP_1_0,
        .rsvd = 0xfffffffffffffff0L,
        .ro = 0xfffffffffffffff0L,
    },{ .name = "POR_MXP_P1_SYSCOREQ_CTL_U_SMXP_1_0",
        .addr = A_POR_MXP_P1_SYSCOREQ_CTL_U_SMXP_1_0,
        .rsvd = 0xfffffffffffffff0L,
        .ro = 0xfffffffffffffff0L,
    },{ .name = "POR_MXP_P0_SYSCOACK_STATUS_U_SMXP_1_0",
        .addr = A_POR_MXP_P0_SYSCOACK_STATUS_U_SMXP_1_0,
        .rsvd = 0xfffffffffffffff0L,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_P1_SYSCOACK_STATUS_U_SMXP_1_0",
        .addr = A_POR_MXP_P1_SYSCOACK_STATUS_U_SMXP_1_0,
        .rsvd = 0xfffffffffffffff0L,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_PMU_EVENT_SEL_U_SMXP_1_0",
        .addr = A_POR_MXP_PMU_EVENT_SEL_U_SMXP_1_0,
        .ro = 0xffffffff00000000L,
    },{ .name = "POR_DTM_CONTROL_U_SMXP_1_0",
        .addr = A_POR_DTM_CONTROL_U_SMXP_1_0,
        .rsvd = 0xfffffffffffffff0L,
        .ro = 0xfffffffffffffff0L,
    },{ .name = "POR_DTM_FIFO_ENTRY_READY_U_SMXP_1_0",
        .addr = A_POR_DTM_FIFO_ENTRY_READY_U_SMXP_1_0,
        .rsvd = 0xfffffffffffffff0L,
        .ro = 0xfffffffffffffff0L,
    },{ .name = "POR_DTM_FIFO_ENTRY0_0_U_SMXP_1_0",
        .addr = A_POR_DTM_FIFO_ENTRY0_0_U_SMXP_1_0,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_DTM_FIFO_ENTRY0_1_U_SMXP_1_0",
        .addr = A_POR_DTM_FIFO_ENTRY0_1_U_SMXP_1_0,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_DTM_FIFO_ENTRY0_2_U_SMXP_1_0",
        .addr = A_POR_DTM_FIFO_ENTRY0_2_U_SMXP_1_0,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_DTM_FIFO_ENTRY1_0_U_SMXP_1_0",
        .addr = A_POR_DTM_FIFO_ENTRY1_0_U_SMXP_1_0,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_DTM_FIFO_ENTRY1_1_U_SMXP_1_0",
        .addr = A_POR_DTM_FIFO_ENTRY1_1_U_SMXP_1_0,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_DTM_FIFO_ENTRY1_2_U_SMXP_1_0",
        .addr = A_POR_DTM_FIFO_ENTRY1_2_U_SMXP_1_0,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_DTM_FIFO_ENTRY2_0_U_SMXP_1_0",
        .addr = A_POR_DTM_FIFO_ENTRY2_0_U_SMXP_1_0,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_DTM_FIFO_ENTRY2_1_U_SMXP_1_0",
        .addr = A_POR_DTM_FIFO_ENTRY2_1_U_SMXP_1_0,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_DTM_FIFO_ENTRY2_2_U_SMXP_1_0",
        .addr = A_POR_DTM_FIFO_ENTRY2_2_U_SMXP_1_0,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_DTM_FIFO_ENTRY3_0_U_SMXP_1_0",
        .addr = A_POR_DTM_FIFO_ENTRY3_0_U_SMXP_1_0,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_DTM_FIFO_ENTRY3_1_U_SMXP_1_0",
        .addr = A_POR_DTM_FIFO_ENTRY3_1_U_SMXP_1_0,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_DTM_FIFO_ENTRY3_2_U_SMXP_1_0",
        .addr = A_POR_DTM_FIFO_ENTRY3_2_U_SMXP_1_0,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_DTM_WP0_CONFIG_U_SMXP_1_0",
        .addr = A_POR_DTM_WP0_CONFIG_U_SMXP_1_0,
        .rsvd = 0x80,
        .ro = 0xffffffffffff8080L,
    },{ .name = "POR_DTM_WP0_VAL_U_SMXP_1_0",
        .addr = A_POR_DTM_WP0_VAL_U_SMXP_1_0,
    },{ .name = "POR_DTM_WP0_MASK_U_SMXP_1_0",
        .addr = A_POR_DTM_WP0_MASK_U_SMXP_1_0,
    },{ .name = "POR_DTM_WP1_CONFIG_U_SMXP_1_0",
        .addr = A_POR_DTM_WP1_CONFIG_U_SMXP_1_0,
        .rsvd = 0xc0,
        .ro = 0xffffffffffff80c0L,
    },{ .name = "POR_DTM_WP1_VAL_U_SMXP_1_0",
        .addr = A_POR_DTM_WP1_VAL_U_SMXP_1_0,
    },{ .name = "POR_DTM_WP1_MASK_U_SMXP_1_0",
        .addr = A_POR_DTM_WP1_MASK_U_SMXP_1_0,
    },{ .name = "POR_DTM_WP2_CONFIG_U_SMXP_1_0",
        .addr = A_POR_DTM_WP2_CONFIG_U_SMXP_1_0,
        .rsvd = 0x80,
        .ro = 0xffffffffffff8080L,
    },{ .name = "POR_DTM_WP2_VAL_U_SMXP_1_0",
        .addr = A_POR_DTM_WP2_VAL_U_SMXP_1_0,
    },{ .name = "POR_DTM_WP2_MASK_U_SMXP_1_0",
        .addr = A_POR_DTM_WP2_MASK_U_SMXP_1_0,
    },{ .name = "POR_DTM_WP3_CONFIG_U_SMXP_1_0",
        .addr = A_POR_DTM_WP3_CONFIG_U_SMXP_1_0,
        .rsvd = 0xc0,
        .ro = 0xffffffffffff80c0L,
    },{ .name = "POR_DTM_WP3_VAL_U_SMXP_1_0",
        .addr = A_POR_DTM_WP3_VAL_U_SMXP_1_0,
    },{ .name = "POR_DTM_WP3_MASK_U_SMXP_1_0",
        .addr = A_POR_DTM_WP3_MASK_U_SMXP_1_0,
    },{ .name = "POR_DTM_PMSICR_U_SMXP_1_0",
        .addr = A_POR_DTM_PMSICR_U_SMXP_1_0,
        .ro = 0xffffffff00000000L,
    },{ .name = "POR_DTM_PMSIRR_U_SMXP_1_0",
        .addr = A_POR_DTM_PMSIRR_U_SMXP_1_0,
        .ro = 0xffffffff000000ffL,
    },{ .name = "POR_DTM_PMU_CONFIG_U_SMXP_1_0",
        .addr = A_POR_DTM_PMU_CONFIG_U_SMXP_1_0,
        .ro = 0xc0c0c0c08888fe00L,
    },{ .name = "POR_DTM_PMEVCNT_U_SMXP_1_0",
        .addr = A_POR_DTM_PMEVCNT_U_SMXP_1_0,
    },{ .name = "POR_DTM_PMEVCNTSR_U_SMXP_1_0",
        .addr = A_POR_DTM_PMEVCNTSR_U_SMXP_1_0,
    },{ .name = "POR_MXP_ERRFR_U_SMXP_1_0",  .addr = A_POR_MXP_ERRFR_U_SMXP_1_0,
        .rsvd = 0x300,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_ERRCTLR_U_SMXP_1_0",
        .addr = A_POR_MXP_ERRCTLR_U_SMXP_1_0,
        .rsvd = 0xf0,
        .ro = 0xfffffffffffffef0L,
    },{ .name = "POR_MXP_ERRSTATUS_U_SMXP_1_0",
        .addr = A_POR_MXP_ERRSTATUS_U_SMXP_1_0,
        .ro = 0xffffffff127fffffL,
    },{ .name = "POR_MXP_ERRMISC_U_SMXP_1_0",
        .addr = A_POR_MXP_ERRMISC_U_SMXP_1_0,
        .rsvd = 0x8,
        .ro = 0xf800ffffffc08008L,
    },{ .name = "POR_MXP_P0_BYTE_PAR_ERR_INJ_U_SMXP_1_0",
        .addr = A_POR_MXP_P0_BYTE_PAR_ERR_INJ_U_SMXP_1_0,
        .rsvd = 0xffffffffffffffe0L,
        .ro = 0xffffffffffffffe0L,
    },{ .name = "POR_MXP_P1_BYTE_PAR_ERR_INJ_U_SMXP_1_0",
        .addr = A_POR_MXP_P1_BYTE_PAR_ERR_INJ_U_SMXP_1_0,
        .rsvd = 0xffffffffffffffe0L,
        .ro = 0xffffffffffffffe0L,
    },{ .name = "POR_MXP_ERRFR_NS_U_SMXP_1_0",
        .addr = A_POR_MXP_ERRFR_NS_U_SMXP_1_0,
        .rsvd = 0x300,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_ERRCTLR_NS_U_SMXP_1_0",
        .addr = A_POR_MXP_ERRCTLR_NS_U_SMXP_1_0,
        .rsvd = 0xf0,
        .ro = 0xfffffffffffffef0L,
    },{ .name = "POR_MXP_ERRSTATUS_NS_U_SMXP_1_0",
        .addr = A_POR_MXP_ERRSTATUS_NS_U_SMXP_1_0,
        .ro = 0xffffffff127fffffL,
    },{ .name = "POR_MXP_ERRMISC_NS_U_SMXP_1_0",
        .addr = A_POR_MXP_ERRMISC_NS_U_SMXP_1_0,
        .rsvd = 0x8,
        .ro = 0xf800ffffffc08008L,
    },{ .name = "POR_RND_NODE_INFO_U_RND_NID68",
        .addr = A_POR_RND_NODE_INFO_U_RND_NID68,
        .reset = 0x44000d,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_RND_CHILD_INFO_U_RND_NID68",
        .addr = A_POR_RND_CHILD_INFO_U_RND_NID68,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_RND_UNIT_INFO_U_RND_NID68",
        .addr = A_POR_RND_UNIT_INFO_U_RND_NID68,
        .reset = 0xc044020,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_RND_SECURE_REGISTER_GROUPS_OVERRIDE_U_RND_NID68",
        .addr = A_POR_RND_SECURE_REGISTER_GROUPS_OVERRIDE_U_RND_NID68,
        .rsvd = 0xfffffffffffffff8L,
        .ro = 0xfffffffffffffff8L,
    },{ .name = "POR_RND_CFG_CTL_U_RND_NID68",
        .addr = A_POR_RND_CFG_CTL_U_RND_NID68,
        .reset = 0x20401401,
        .rsvd = 0x80,
        .ro = 0xffffffff00008880L,
    },{ .name = "POR_RND_AUX_CTL_U_RND_NID68",
        .addr = A_POR_RND_AUX_CTL_U_RND_NID68,
        .reset = 0x22,
        .rsvd = 0xffffffffffffffc0L,
        .ro = 0xffffffffffffffc0L,
    },{ .name = "POR_RND_S0_PORT_CONTROL_U_RND_NID68",
        .addr = A_POR_RND_S0_PORT_CONTROL_U_RND_NID68,
        .ro = 0xfffffffffffff800L,
    },{ .name = "POR_RND_S1_PORT_CONTROL_U_RND_NID68",
        .addr = A_POR_RND_S1_PORT_CONTROL_U_RND_NID68,
        .ro = 0xfffffffffffff800L,
    },{ .name = "POR_RND_S2_PORT_CONTROL_U_RND_NID68",
        .addr = A_POR_RND_S2_PORT_CONTROL_U_RND_NID68,
        .ro = 0xfffffffffffff800L,
    },{ .name = "POR_RND_S0_QOS_CONTROL_U_RND_NID68",
        .addr = A_POR_RND_S0_QOS_CONTROL_U_RND_NID68,
        .rsvd = 0xff00,
        .ro = 0xffffffffff00ff00L,
    },{ .name = "POR_RND_S0_QOS_LAT_TGT_U_RND_NID68",
        .addr = A_POR_RND_S0_QOS_LAT_TGT_U_RND_NID68,
        .ro = 0xfffffffff000f000L,
    },{ .name = "POR_RND_S0_QOS_LAT_SCALE_U_RND_NID68",
        .addr = A_POR_RND_S0_QOS_LAT_SCALE_U_RND_NID68,
        .rsvd = 0xf8,
        .ro = 0xfffffffffffff8f8L,
    },{ .name = "POR_RND_S0_QOS_LAT_RANGE_U_RND_NID68",
        .addr = A_POR_RND_S0_QOS_LAT_RANGE_U_RND_NID68,
        .rsvd = 0xf0,
        .ro = 0xfffffffff0f0f0f0L,
    },{ .name = "POR_RND_S1_QOS_CONTROL_U_RND_NID68",
        .addr = A_POR_RND_S1_QOS_CONTROL_U_RND_NID68,
        .rsvd = 0xff00,
        .ro = 0xffffffffff00ff00L,
    },{ .name = "POR_RND_S1_QOS_LAT_TGT_U_RND_NID68",
        .addr = A_POR_RND_S1_QOS_LAT_TGT_U_RND_NID68,
        .ro = 0xfffffffff000f000L,
    },{ .name = "POR_RND_S1_QOS_LAT_SCALE_U_RND_NID68",
        .addr = A_POR_RND_S1_QOS_LAT_SCALE_U_RND_NID68,
        .rsvd = 0xf8,
        .ro = 0xfffffffffffff8f8L,
    },{ .name = "POR_RND_S1_QOS_LAT_RANGE_U_RND_NID68",
        .addr = A_POR_RND_S1_QOS_LAT_RANGE_U_RND_NID68,
        .rsvd = 0xf0,
        .ro = 0xfffffffff0f0f0f0L,
    },{ .name = "POR_RND_S2_QOS_CONTROL_U_RND_NID68",
        .addr = A_POR_RND_S2_QOS_CONTROL_U_RND_NID68,
        .rsvd = 0xff00,
        .ro = 0xffffffffff00ff00L,
    },{ .name = "POR_RND_S2_QOS_LAT_TGT_U_RND_NID68",
        .addr = A_POR_RND_S2_QOS_LAT_TGT_U_RND_NID68,
        .ro = 0xfffffffff000f000L,
    },{ .name = "POR_RND_S2_QOS_LAT_SCALE_U_RND_NID68",
        .addr = A_POR_RND_S2_QOS_LAT_SCALE_U_RND_NID68,
        .rsvd = 0xf8,
        .ro = 0xfffffffffffff8f8L,
    },{ .name = "POR_RND_S2_QOS_LAT_RANGE_U_RND_NID68",
        .addr = A_POR_RND_S2_QOS_LAT_RANGE_U_RND_NID68,
        .rsvd = 0xf0,
        .ro = 0xfffffffff0f0f0f0L,
    },{ .name = "POR_RND_SYSCOREQ_CTL_U_RND_NID68",
        .addr = A_POR_RND_SYSCOREQ_CTL_U_RND_NID68,
        .rsvd = 0xfffffffffffffff8L,
        .ro = 0xfffffffffffffff8L,
    },{ .name = "POR_RND_SYSCOACK_STATUS_U_RND_NID68",
        .addr = A_POR_RND_SYSCOACK_STATUS_U_RND_NID68,
        .rsvd = 0xfffffffffffffff8L,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_RND_PMU_EVENT_SEL_U_RND_NID68",
        .addr = A_POR_RND_PMU_EVENT_SEL_U_RND_NID68,
        .rsvd = 0xe0,
        .ro = 0xffffffffe0e0e0e0L,
    },{ .name = "POR_RNSAM_NODE_INFO_U_RND_NID68",
        .addr = A_POR_RNSAM_NODE_INFO_U_RND_NID68,
        .reset = 0x4000f,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_RNSAM_CHILD_INFO_U_RND_NID68",
        .addr = A_POR_RNSAM_CHILD_INFO_U_RND_NID68,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_RNSAM_UNIT_INFO_U_RND_NID68",
        .addr = A_POR_RNSAM_UNIT_INFO_U_RND_NID68,
        .reset = 0x800040004,
        .rsvd = 0xff00,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_RNSAM_SECURE_REGISTER_GROUPS_OVERRIDE_U_RND_NID68",
        .addr = A_POR_RNSAM_SECURE_REGISTER_GROUPS_OVERRIDE_U_RND_NID68,
        .rsvd = 0xfffffffffffffffeL,
        .ro = 0xfffffffffffffffeL,
    },{ .name = "RNSAM_STATUS_U_RND_NID68",  .addr = A_RNSAM_STATUS_U_RND_NID68,
        .reset = 0x1,
        .rsvd = 0xfffffffffffffffcL,
        .ro = 0xfffffffffffffffcL,
    },{ .name = "NON_HASH_MEM_REGION_REG0_U_RND_NID68",
        .addr = A_NON_HASH_MEM_REGION_REG0_U_RND_NID68,
        .rsvd = 0x2,
        .ro = 0x8000000280000002L,
    },{ .name = "NON_HASH_MEM_REGION_REG1_U_RND_NID68",
        .addr = A_NON_HASH_MEM_REGION_REG1_U_RND_NID68,
        .rsvd = 0x2,
        .ro = 0x8000000280000002L,
    },{ .name = "NON_HASH_MEM_REGION_REG2_U_RND_NID68",
        .addr = A_NON_HASH_MEM_REGION_REG2_U_RND_NID68,
        .rsvd = 0x2,
        .ro = 0x8000000280000002L,
    },{ .name = "NON_HASH_MEM_REGION_REG3_U_RND_NID68",
        .addr = A_NON_HASH_MEM_REGION_REG3_U_RND_NID68,
        .rsvd = 0x2,
        .ro = 0x8000000280000002L,
    },{ .name = "NON_HASH_TGT_NODEID0_U_RND_NID68",
        .addr = A_NON_HASH_TGT_NODEID0_U_RND_NID68,
        .ro = 0xffff800800800800L,
    },{ .name = "NON_HASH_TGT_NODEID1_U_RND_NID68",
        .addr = A_NON_HASH_TGT_NODEID1_U_RND_NID68,
        .ro = 0xffff800800800800L,
    },{ .name = "NON_HASH_TGT_NODEID2_U_RND_NID68",
        .addr = A_NON_HASH_TGT_NODEID2_U_RND_NID68,
        .ro = 0xffffffffff800800L,
    },{ .name = "SYS_CACHE_GRP_REGION0_U_RND_NID68",
        .addr = A_SYS_CACHE_GRP_REGION0_U_RND_NID68,
        .rsvd = 0x2,
        .ro = 0x8000000080000002L,
    },{ .name = "SYS_CACHE_GRP_REGION1_U_RND_NID68",
        .addr = A_SYS_CACHE_GRP_REGION1_U_RND_NID68,
        .ro = 0x8000000080000000L,
    },{ .name = "SYS_CACHE_GRP_HN_NODEID_REG0_U_RND_NID68",
        .addr = A_SYS_CACHE_GRP_HN_NODEID_REG0_U_RND_NID68,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_HN_NODEID_REG1_U_RND_NID68",
        .addr = A_SYS_CACHE_GRP_HN_NODEID_REG1_U_RND_NID68,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_HN_NODEID_REG2_U_RND_NID68",
        .addr = A_SYS_CACHE_GRP_HN_NODEID_REG2_U_RND_NID68,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_HN_NODEID_REG3_U_RND_NID68",
        .addr = A_SYS_CACHE_GRP_HN_NODEID_REG3_U_RND_NID68,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_HN_NODEID_REG4_U_RND_NID68",
        .addr = A_SYS_CACHE_GRP_HN_NODEID_REG4_U_RND_NID68,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_HN_NODEID_REG5_U_RND_NID68",
        .addr = A_SYS_CACHE_GRP_HN_NODEID_REG5_U_RND_NID68,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_HN_NODEID_REG6_U_RND_NID68",
        .addr = A_SYS_CACHE_GRP_HN_NODEID_REG6_U_RND_NID68,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_HN_NODEID_REG7_U_RND_NID68",
        .addr = A_SYS_CACHE_GRP_HN_NODEID_REG7_U_RND_NID68,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_NONHASH_NODEID_U_RND_NID68",
        .addr = A_SYS_CACHE_GRP_NONHASH_NODEID_U_RND_NID68,
        .ro = 0xfffffff800800800L,
    },{ .name = "SYS_CACHE_GROUP_HN_COUNT_U_RND_NID68",
        .addr = A_SYS_CACHE_GROUP_HN_COUNT_U_RND_NID68,
        .rsvd = 0x80,
        .ro = 0xffffffff80808080L,
    },{ .name = "SYS_CACHE_GRP_SN_NODEID_REG0_U_RND_NID68",
        .addr = A_SYS_CACHE_GRP_SN_NODEID_REG0_U_RND_NID68,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_SN_NODEID_REG1_U_RND_NID68",
        .addr = A_SYS_CACHE_GRP_SN_NODEID_REG1_U_RND_NID68,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_SN_NODEID_REG2_U_RND_NID68",
        .addr = A_SYS_CACHE_GRP_SN_NODEID_REG2_U_RND_NID68,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_SN_NODEID_REG3_U_RND_NID68",
        .addr = A_SYS_CACHE_GRP_SN_NODEID_REG3_U_RND_NID68,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_SN_NODEID_REG4_U_RND_NID68",
        .addr = A_SYS_CACHE_GRP_SN_NODEID_REG4_U_RND_NID68,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_SN_NODEID_REG5_U_RND_NID68",
        .addr = A_SYS_CACHE_GRP_SN_NODEID_REG5_U_RND_NID68,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_SN_NODEID_REG6_U_RND_NID68",
        .addr = A_SYS_CACHE_GRP_SN_NODEID_REG6_U_RND_NID68,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_SN_NODEID_REG7_U_RND_NID68",
        .addr = A_SYS_CACHE_GRP_SN_NODEID_REG7_U_RND_NID68,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_SN_SAM_CFG0_U_RND_NID68",
        .addr = A_SYS_CACHE_GRP_SN_SAM_CFG0_U_RND_NID68,
        .rsvd = 0xc0,
        .ro = 0xffffc0c0c0c0c0c0L,
    },{ .name = "SYS_CACHE_GRP_SN_SAM_CFG1_U_RND_NID68",
        .addr = A_SYS_CACHE_GRP_SN_SAM_CFG1_U_RND_NID68,
        .rsvd = 0xc0,
        .ro = 0xffffc0c0c0c0c0c0L,
    },{ .name = "GIC_MEM_REGION_REG_U_RND_NID68",
        .addr = A_GIC_MEM_REGION_REG_U_RND_NID68,
        .rsvd = 0xff82,
        .ro = 0x800f00000000ff82L,
    },{ .name = "SYS_CACHE_GRP_SN_ATTR_U_RND_NID68",
        .addr = A_SYS_CACHE_GRP_SN_ATTR_U_RND_NID68,
        .rsvd = 0xffce,
        .ro = 0xffceffceffceffceL,
    },{ .name = "SYS_CACHE_GRP_HN_CPA_EN_REG_U_RND_NID68",
        .addr = A_SYS_CACHE_GRP_HN_CPA_EN_REG_U_RND_NID68,
    },{ .name = "SYS_CACHE_GRP_HN_CPA_GRP_REG_U_RND_NID68",
        .addr = A_SYS_CACHE_GRP_HN_CPA_GRP_REG_U_RND_NID68,
        .rsvd = 0xfffc,
        .ro = 0xfffcfffcfffcfffcL,
    },{ .name = "CML_PORT_AGGR_MODE_CTRL_REG_U_RND_NID68",
        .addr = A_CML_PORT_AGGR_MODE_CTRL_REG_U_RND_NID68,
        .rsvd = 0x88,
        .ro = 0xffffffff28888888L,
    },{ .name = "CML_PORT_AGGR_GRP0_ADD_MASK_U_RND_NID68",
        .addr = A_CML_PORT_AGGR_GRP0_ADD_MASK_U_RND_NID68,
        .reset = 0x40,
        .ro = 0xffff00000000003fL,
    },{ .name = "CML_PORT_AGGR_GRP1_ADD_MASK_U_RND_NID68",
        .addr = A_CML_PORT_AGGR_GRP1_ADD_MASK_U_RND_NID68,
        .reset = 0x40,
        .ro = 0xffff00000000003fL,
    },{ .name = "CML_PORT_AGGR_GRP0_REG_U_RND_NID68",
        .addr = A_CML_PORT_AGGR_GRP0_REG_U_RND_NID68,
        .ro = 0xfffc800800800800L,
    },{ .name = "CML_PORT_AGGR_GRP1_REG_U_RND_NID68",
        .addr = A_CML_PORT_AGGR_GRP1_REG_U_RND_NID68,
        .ro = 0xfffc800800800800L,
    },{ .name = "SYS_CACHE_GRP_SECONDARY_REG0_U_RND_NID68",
        .addr = A_SYS_CACHE_GRP_SECONDARY_REG0_U_RND_NID68,
        .rsvd = 0x2,
        .ro = 0x8000000280000002L,
    },{ .name = "SYS_CACHE_GRP_SECONDARY_REG1_U_RND_NID68",
        .addr = A_SYS_CACHE_GRP_SECONDARY_REG1_U_RND_NID68,
        .rsvd = 0x2,
        .ro = 0x8000000280000002L,
    },{ .name = "SYS_CACHE_GRP_CAL_MODE_REG_U_RND_NID68",
        .addr = A_SYS_CACHE_GRP_CAL_MODE_REG_U_RND_NID68,
        .rsvd = 0xfffe,
        .ro = 0xfffefffefffefffeL,
    },{ .name = "RNSAM_HASH_ADDR_MASK_REG_U_RND_NID68",
        .addr = A_RNSAM_HASH_ADDR_MASK_REG_U_RND_NID68,
        .reset = 0xffffffffffc0,
        .ro = 0xffff00000000003fL,
    },{ .name = "RNSAM_REGION_CMP_ADDR_MASK_REG_U_RND_NID68",
        .addr = A_RNSAM_REGION_CMP_ADDR_MASK_REG_U_RND_NID68,
        .reset = 0xffffffff0000,
        .ro = 0xffff00000000ffffL,
    },{ .name = "SYS_CACHE_GRP_HN_NODEID_REG8_U_RND_NID68",
        .addr = A_SYS_CACHE_GRP_HN_NODEID_REG8_U_RND_NID68,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_HN_NODEID_REG9_U_RND_NID68",
        .addr = A_SYS_CACHE_GRP_HN_NODEID_REG9_U_RND_NID68,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_HN_NODEID_REG10_U_RND_NID68",
        .addr = A_SYS_CACHE_GRP_HN_NODEID_REG10_U_RND_NID68,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_HN_NODEID_REG11_U_RND_NID68",
        .addr = A_SYS_CACHE_GRP_HN_NODEID_REG11_U_RND_NID68,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_HN_NODEID_REG12_U_RND_NID68",
        .addr = A_SYS_CACHE_GRP_HN_NODEID_REG12_U_RND_NID68,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_HN_NODEID_REG13_U_RND_NID68",
        .addr = A_SYS_CACHE_GRP_HN_NODEID_REG13_U_RND_NID68,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_HN_NODEID_REG14_U_RND_NID68",
        .addr = A_SYS_CACHE_GRP_HN_NODEID_REG14_U_RND_NID68,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_HN_NODEID_REG15_U_RND_NID68",
        .addr = A_SYS_CACHE_GRP_HN_NODEID_REG15_U_RND_NID68,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_SN_NODEID_REG8_U_RND_NID68",
        .addr = A_SYS_CACHE_GRP_SN_NODEID_REG8_U_RND_NID68,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_SN_NODEID_REG9_U_RND_NID68",
        .addr = A_SYS_CACHE_GRP_SN_NODEID_REG9_U_RND_NID68,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_SN_NODEID_REG10_U_RND_NID68",
        .addr = A_SYS_CACHE_GRP_SN_NODEID_REG10_U_RND_NID68,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_SN_NODEID_REG11_U_RND_NID68",
        .addr = A_SYS_CACHE_GRP_SN_NODEID_REG11_U_RND_NID68,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_SN_NODEID_REG12_U_RND_NID68",
        .addr = A_SYS_CACHE_GRP_SN_NODEID_REG12_U_RND_NID68,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_SN_NODEID_REG13_U_RND_NID68",
        .addr = A_SYS_CACHE_GRP_SN_NODEID_REG13_U_RND_NID68,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_SN_NODEID_REG14_U_RND_NID68",
        .addr = A_SYS_CACHE_GRP_SN_NODEID_REG14_U_RND_NID68,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_SN_NODEID_REG15_U_RND_NID68",
        .addr = A_SYS_CACHE_GRP_SN_NODEID_REG15_U_RND_NID68,
        .ro = 0xffff800800800800L,
    },{ .name = "POR_FDC_NODE_INFO_U_SMXP_1_0",
        .addr = A_POR_FDC_NODE_INFO_U_SMXP_1_0,
        .reset = 0x201,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_FDC_CHILD_INFO_U_SMXP_1_0",
        .addr = A_POR_FDC_CHILD_INFO_U_SMXP_1_0,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_ERRFR_MXP_U_SMXP_1_0",  .addr = A_POR_ERRFR_MXP_U_SMXP_1_0,
        .reset = 0xa1,
        .rsvd = 0xffffffffffffff0cL,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_ERRCTLR_MXP_U_SMXP_1_0",
        .addr = A_POR_ERRCTLR_MXP_U_SMXP_1_0,
        .reset = 0xd,
        .rsvd = 0x3ff2,
        .ro = 0xffffffff00003ff2L,
    },{ .name = "POR_ERRSTATUS_MXP_U_SMXP_1_0",
        .addr = A_POR_ERRSTATUS_MXP_U_SMXP_1_0,
        .ro = 0xffffffff977f003fL,
    },{ .name = "POR_FDC_AUX_CTL_MXP_U_SMXP_1_0",
        .addr = A_POR_FDC_AUX_CTL_MXP_U_SMXP_1_0,
        .rsvd = 0xffffffffffffffe0L,
        .ro = 0xffffffffffffffefL,
    },{ .name = "POR_ERRFR_P0_D0_U_SMXP_1_0",
        .addr = A_POR_ERRFR_P0_D0_U_SMXP_1_0,
        .reset = 0xa1,
        .rsvd = 0xffffffffffffff0cL,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_ERRCTLR_P0_D0_U_SMXP_1_0",
        .addr = A_POR_ERRCTLR_P0_D0_U_SMXP_1_0,
        .reset = 0xd,
        .rsvd = 0x3ff2,
        .ro = 0xffffffff00003ff2L,
    },{ .name = "POR_ERRSTATUS_P0_D0_U_SMXP_1_0",
        .addr = A_POR_ERRSTATUS_P0_D0_U_SMXP_1_0,
        .ro = 0xffffffff977f003fL,
    },{ .name = "POR_FDC_AUX_CTL_P0_D0_U_SMXP_1_0",
        .addr = A_POR_FDC_AUX_CTL_P0_D0_U_SMXP_1_0,
        .rsvd = 0xffffffffffffffe0L,
        .ro = 0xffffffffffffffe0L,
    },{ .name = "POR_ERRFR_P0_D1_U_SMXP_1_0",
        .addr = A_POR_ERRFR_P0_D1_U_SMXP_1_0,
        .reset = 0xa1,
        .rsvd = 0xffffffffffffff0cL,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_ERRCTLR_P0_D1_U_SMXP_1_0",
        .addr = A_POR_ERRCTLR_P0_D1_U_SMXP_1_0,
        .reset = 0xd,
        .rsvd = 0x3ff2,
        .ro = 0xffffffff00003ff2L,
    },{ .name = "POR_ERRSTATUS_P0_D1_U_SMXP_1_0",
        .addr = A_POR_ERRSTATUS_P0_D1_U_SMXP_1_0,
        .ro = 0xffffffff977f003fL,
    },{ .name = "POR_FDC_AUX_CTL_P0_D1_U_SMXP_1_0",
        .addr = A_POR_FDC_AUX_CTL_P0_D1_U_SMXP_1_0,
        .rsvd = 0xffffffffffffffe0L,
        .ro = 0xffffffffffffffe0L,
    },{ .name = "POR_ERRFR_P0_D2_U_SMXP_1_0",
        .addr = A_POR_ERRFR_P0_D2_U_SMXP_1_0,
        .reset = 0xa1,
        .rsvd = 0xffffffffffffff0cL,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_ERRCTLR_P0_D2_U_SMXP_1_0",
        .addr = A_POR_ERRCTLR_P0_D2_U_SMXP_1_0,
        .reset = 0xd,
        .rsvd = 0x3ff2,
        .ro = 0xffffffff00003ff2L,
    },{ .name = "POR_ERRSTATUS_P0_D2_U_SMXP_1_0",
        .addr = A_POR_ERRSTATUS_P0_D2_U_SMXP_1_0,
        .ro = 0xffffffff977f003fL,
    },{ .name = "POR_FDC_AUX_CTL_P0_D2_U_SMXP_1_0",
        .addr = A_POR_FDC_AUX_CTL_P0_D2_U_SMXP_1_0,
        .rsvd = 0xffffffffffffffe0L,
        .ro = 0xffffffffffffffe0L,
    },{ .name = "POR_ERRFR_P0_D3_U_SMXP_1_0",
        .addr = A_POR_ERRFR_P0_D3_U_SMXP_1_0,
        .reset = 0xa1,
        .rsvd = 0xffffffffffffff0cL,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_ERRCTLR_P0_D3_U_SMXP_1_0",
        .addr = A_POR_ERRCTLR_P0_D3_U_SMXP_1_0,
        .reset = 0xd,
        .rsvd = 0x3ff2,
        .ro = 0xffffffff00003ff2L,
    },{ .name = "POR_ERRSTATUS_P0_D3_U_SMXP_1_0",
        .addr = A_POR_ERRSTATUS_P0_D3_U_SMXP_1_0,
        .ro = 0xffffffff977f003fL,
    },{ .name = "POR_FDC_AUX_CTL_P0_D3_U_SMXP_1_0",
        .addr = A_POR_FDC_AUX_CTL_P0_D3_U_SMXP_1_0,
        .rsvd = 0xffffffffffffffe0L,
        .ro = 0xffffffffffffffe0L,
    },{ .name = "POR_ERRFR_P1_D0_U_SMXP_1_0",
        .addr = A_POR_ERRFR_P1_D0_U_SMXP_1_0,
        .reset = 0xa1,
        .rsvd = 0xffffffffffffff0cL,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_ERRCTLR_P1_D0_U_SMXP_1_0",
        .addr = A_POR_ERRCTLR_P1_D0_U_SMXP_1_0,
        .reset = 0xd,
        .rsvd = 0x3ff2,
        .ro = 0xffffffff00003ff2L,
    },{ .name = "POR_ERRSTATUS_P1_D0_U_SMXP_1_0",
        .addr = A_POR_ERRSTATUS_P1_D0_U_SMXP_1_0,
        .ro = 0xffffffff977f003fL,
    },{ .name = "POR_FDC_AUX_CTL_P1_D0_U_SMXP_1_0",
        .addr = A_POR_FDC_AUX_CTL_P1_D0_U_SMXP_1_0,
        .rsvd = 0xffffffffffffffe0L,
        .ro = 0xffffffffffffffe0L,
    },{ .name = "POR_ERRFR_P1_D1_U_SMXP_1_0",
        .addr = A_POR_ERRFR_P1_D1_U_SMXP_1_0,
        .reset = 0xa1,
        .rsvd = 0xffffffffffffff0cL,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_ERRCTLR_P1_D1_U_SMXP_1_0",
        .addr = A_POR_ERRCTLR_P1_D1_U_SMXP_1_0,
        .reset = 0xd,
        .rsvd = 0x3ff2,
        .ro = 0xffffffff00003ff2L,
    },{ .name = "POR_ERRSTATUS_P1_D1_U_SMXP_1_0",
        .addr = A_POR_ERRSTATUS_P1_D1_U_SMXP_1_0,
        .ro = 0xffffffff977f003fL,
    },{ .name = "POR_FDC_AUX_CTL_P1_D1_U_SMXP_1_0",
        .addr = A_POR_FDC_AUX_CTL_P1_D1_U_SMXP_1_0,
        .rsvd = 0xffffffffffffffe0L,
        .ro = 0xffffffffffffffe0L,
    },{ .name = "POR_ERRFR_P1_D2_U_SMXP_1_0",
        .addr = A_POR_ERRFR_P1_D2_U_SMXP_1_0,
        .reset = 0xa1,
        .rsvd = 0xffffffffffffff0cL,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_ERRCTLR_P1_D2_U_SMXP_1_0",
        .addr = A_POR_ERRCTLR_P1_D2_U_SMXP_1_0,
        .reset = 0xd,
        .rsvd = 0x3ff2,
        .ro = 0xffffffff00003ff2L,
    },{ .name = "POR_ERRSTATUS_P1_D2_U_SMXP_1_0",
        .addr = A_POR_ERRSTATUS_P1_D2_U_SMXP_1_0,
        .ro = 0xffffffff977f003fL,
    },{ .name = "POR_FDC_AUX_CTL_P1_D2_U_SMXP_1_0",
        .addr = A_POR_FDC_AUX_CTL_P1_D2_U_SMXP_1_0,
        .rsvd = 0xffffffffffffffe0L,
        .ro = 0xffffffffffffffe0L,
    },{ .name = "POR_ERRFR_P1_D3_U_SMXP_1_0",
        .addr = A_POR_ERRFR_P1_D3_U_SMXP_1_0,
        .reset = 0xa1,
        .rsvd = 0xffffffffffffff0cL,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_ERRCTLR_P1_D3_U_SMXP_1_0",
        .addr = A_POR_ERRCTLR_P1_D3_U_SMXP_1_0,
        .reset = 0xd,
        .rsvd = 0x3ff2,
        .ro = 0xffffffff00003ff2L,
    },{ .name = "POR_ERRSTATUS_P1_D3_U_SMXP_1_0",
        .addr = A_POR_ERRSTATUS_P1_D3_U_SMXP_1_0,
        .ro = 0xffffffff977f003fL,
    },{ .name = "POR_FDC_AUX_CTL_P1_D3_U_SMXP_1_0",
        .addr = A_POR_FDC_AUX_CTL_P1_D3_U_SMXP_1_0,
        .rsvd = 0xffffffffffffffe0L,
        .ro = 0xffffffffffffffe0L,
    },{ .name = "POR_ERRINJECT_U_SMXP_1_0",  .addr = A_POR_ERRINJECT_U_SMXP_1_0,
        .rsvd = 0xffffffffffffff00L,
        .ro = 0xffffffffffffff00L,
    },{ .name = "POR_FDC_KEY_U_SMXP_1_0",  .addr = A_POR_FDC_KEY_U_SMXP_1_0,
        .reset = 0xbe,
        .rsvd = 0xffffffffffffff00L,
        .ro = 0xffffffffffffff00L,
    },{ .name = "POR_MPU_NODE_INFO_U_RND_NID68",
        .addr = A_POR_MPU_NODE_INFO_U_RND_NID68,
        .reset = 0x202,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MPU_CHILD_INFO_U_RND_NID68",
        .addr = A_POR_MPU_CHILD_INFO_U_RND_NID68,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MPU_UNIT_INFO_U_RND_NID68",
        .addr = A_POR_MPU_UNIT_INFO_U_RND_NID68,
        .reset = 0x20,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MPU_M0_CTL_U_RND_NID68",
        .addr = A_POR_MPU_M0_CTL_U_RND_NID68,
        .reset = 0x2,
        .rsvd = 0xfffffffffffffff8L,
        .ro = 0xfffffffffffffff8L,
    },{ .name = "POR_MPU_M0_PRBAR0_U_RND_NID68",
        .addr = A_POR_MPU_M0_PRBAR0_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR0_U_RND_NID68",
        .addr = A_POR_MPU_M0_PRLAR0_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR1_U_RND_NID68",
        .addr = A_POR_MPU_M0_PRBAR1_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR1_U_RND_NID68",
        .addr = A_POR_MPU_M0_PRLAR1_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR2_U_RND_NID68",
        .addr = A_POR_MPU_M0_PRBAR2_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR2_U_RND_NID68",
        .addr = A_POR_MPU_M0_PRLAR2_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR3_U_RND_NID68",
        .addr = A_POR_MPU_M0_PRBAR3_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR3_U_RND_NID68",
        .addr = A_POR_MPU_M0_PRLAR3_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR4_U_RND_NID68",
        .addr = A_POR_MPU_M0_PRBAR4_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR4_U_RND_NID68",
        .addr = A_POR_MPU_M0_PRLAR4_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR5_U_RND_NID68",
        .addr = A_POR_MPU_M0_PRBAR5_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR5_U_RND_NID68",
        .addr = A_POR_MPU_M0_PRLAR5_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR6_U_RND_NID68",
        .addr = A_POR_MPU_M0_PRBAR6_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR6_U_RND_NID68",
        .addr = A_POR_MPU_M0_PRLAR6_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR7_U_RND_NID68",
        .addr = A_POR_MPU_M0_PRBAR7_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR7_U_RND_NID68",
        .addr = A_POR_MPU_M0_PRLAR7_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR8_U_RND_NID68",
        .addr = A_POR_MPU_M0_PRBAR8_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR8_U_RND_NID68",
        .addr = A_POR_MPU_M0_PRLAR8_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR9_U_RND_NID68",
        .addr = A_POR_MPU_M0_PRBAR9_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR9_U_RND_NID68",
        .addr = A_POR_MPU_M0_PRLAR9_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR10_U_RND_NID68",
        .addr = A_POR_MPU_M0_PRBAR10_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR10_U_RND_NID68",
        .addr = A_POR_MPU_M0_PRLAR10_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR11_U_RND_NID68",
        .addr = A_POR_MPU_M0_PRBAR11_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR11_U_RND_NID68",
        .addr = A_POR_MPU_M0_PRLAR11_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR12_U_RND_NID68",
        .addr = A_POR_MPU_M0_PRBAR12_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR12_U_RND_NID68",
        .addr = A_POR_MPU_M0_PRLAR12_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR13_U_RND_NID68",
        .addr = A_POR_MPU_M0_PRBAR13_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR13_U_RND_NID68",
        .addr = A_POR_MPU_M0_PRLAR13_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR14_U_RND_NID68",
        .addr = A_POR_MPU_M0_PRBAR14_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR14_U_RND_NID68",
        .addr = A_POR_MPU_M0_PRLAR14_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR15_U_RND_NID68",
        .addr = A_POR_MPU_M0_PRBAR15_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR15_U_RND_NID68",
        .addr = A_POR_MPU_M0_PRLAR15_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR16_U_RND_NID68",
        .addr = A_POR_MPU_M0_PRBAR16_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR16_U_RND_NID68",
        .addr = A_POR_MPU_M0_PRLAR16_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR17_U_RND_NID68",
        .addr = A_POR_MPU_M0_PRBAR17_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR17_U_RND_NID68",
        .addr = A_POR_MPU_M0_PRLAR17_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR18_U_RND_NID68",
        .addr = A_POR_MPU_M0_PRBAR18_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR18_U_RND_NID68",
        .addr = A_POR_MPU_M0_PRLAR18_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR19_U_RND_NID68",
        .addr = A_POR_MPU_M0_PRBAR19_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR19_U_RND_NID68",
        .addr = A_POR_MPU_M0_PRLAR19_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR20_U_RND_NID68",
        .addr = A_POR_MPU_M0_PRBAR20_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR20_U_RND_NID68",
        .addr = A_POR_MPU_M0_PRLAR20_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR21_U_RND_NID68",
        .addr = A_POR_MPU_M0_PRBAR21_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR21_U_RND_NID68",
        .addr = A_POR_MPU_M0_PRLAR21_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR22_U_RND_NID68",
        .addr = A_POR_MPU_M0_PRBAR22_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR22_U_RND_NID68",
        .addr = A_POR_MPU_M0_PRLAR22_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR23_U_RND_NID68",
        .addr = A_POR_MPU_M0_PRBAR23_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR23_U_RND_NID68",
        .addr = A_POR_MPU_M0_PRLAR23_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR24_U_RND_NID68",
        .addr = A_POR_MPU_M0_PRBAR24_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR24_U_RND_NID68",
        .addr = A_POR_MPU_M0_PRLAR24_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR25_U_RND_NID68",
        .addr = A_POR_MPU_M0_PRBAR25_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR25_U_RND_NID68",
        .addr = A_POR_MPU_M0_PRLAR25_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR26_U_RND_NID68",
        .addr = A_POR_MPU_M0_PRBAR26_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR26_U_RND_NID68",
        .addr = A_POR_MPU_M0_PRLAR26_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR27_U_RND_NID68",
        .addr = A_POR_MPU_M0_PRBAR27_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR27_U_RND_NID68",
        .addr = A_POR_MPU_M0_PRLAR27_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR28_U_RND_NID68",
        .addr = A_POR_MPU_M0_PRBAR28_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR28_U_RND_NID68",
        .addr = A_POR_MPU_M0_PRLAR28_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR29_U_RND_NID68",
        .addr = A_POR_MPU_M0_PRBAR29_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR29_U_RND_NID68",
        .addr = A_POR_MPU_M0_PRLAR29_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR30_U_RND_NID68",
        .addr = A_POR_MPU_M0_PRBAR30_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR30_U_RND_NID68",
        .addr = A_POR_MPU_M0_PRLAR30_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR31_U_RND_NID68",
        .addr = A_POR_MPU_M0_PRBAR31_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR31_U_RND_NID68",
        .addr = A_POR_MPU_M0_PRLAR31_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_CTL_U_RND_NID68",
        .addr = A_POR_MPU_M1_CTL_U_RND_NID68,
        .reset = 0x2,
        .rsvd = 0xfffffffffffffff8L,
        .ro = 0xfffffffffffffff8L,
    },{ .name = "POR_MPU_M1_PRBAR0_U_RND_NID68",
        .addr = A_POR_MPU_M1_PRBAR0_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR0_U_RND_NID68",
        .addr = A_POR_MPU_M1_PRLAR0_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR1_U_RND_NID68",
        .addr = A_POR_MPU_M1_PRBAR1_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR1_U_RND_NID68",
        .addr = A_POR_MPU_M1_PRLAR1_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR2_U_RND_NID68",
        .addr = A_POR_MPU_M1_PRBAR2_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR2_U_RND_NID68",
        .addr = A_POR_MPU_M1_PRLAR2_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR3_U_RND_NID68",
        .addr = A_POR_MPU_M1_PRBAR3_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR3_U_RND_NID68",
        .addr = A_POR_MPU_M1_PRLAR3_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR4_U_RND_NID68",
        .addr = A_POR_MPU_M1_PRBAR4_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR4_U_RND_NID68",
        .addr = A_POR_MPU_M1_PRLAR4_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR5_U_RND_NID68",
        .addr = A_POR_MPU_M1_PRBAR5_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR5_U_RND_NID68",
        .addr = A_POR_MPU_M1_PRLAR5_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR6_U_RND_NID68",
        .addr = A_POR_MPU_M1_PRBAR6_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR6_U_RND_NID68",
        .addr = A_POR_MPU_M1_PRLAR6_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR7_U_RND_NID68",
        .addr = A_POR_MPU_M1_PRBAR7_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR7_U_RND_NID68",
        .addr = A_POR_MPU_M1_PRLAR7_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR8_U_RND_NID68",
        .addr = A_POR_MPU_M1_PRBAR8_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR8_U_RND_NID68",
        .addr = A_POR_MPU_M1_PRLAR8_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR9_U_RND_NID68",
        .addr = A_POR_MPU_M1_PRBAR9_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR9_U_RND_NID68",
        .addr = A_POR_MPU_M1_PRLAR9_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR10_U_RND_NID68",
        .addr = A_POR_MPU_M1_PRBAR10_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR10_U_RND_NID68",
        .addr = A_POR_MPU_M1_PRLAR10_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR11_U_RND_NID68",
        .addr = A_POR_MPU_M1_PRBAR11_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR11_U_RND_NID68",
        .addr = A_POR_MPU_M1_PRLAR11_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR12_U_RND_NID68",
        .addr = A_POR_MPU_M1_PRBAR12_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR12_U_RND_NID68",
        .addr = A_POR_MPU_M1_PRLAR12_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR13_U_RND_NID68",
        .addr = A_POR_MPU_M1_PRBAR13_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR13_U_RND_NID68",
        .addr = A_POR_MPU_M1_PRLAR13_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR14_U_RND_NID68",
        .addr = A_POR_MPU_M1_PRBAR14_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR14_U_RND_NID68",
        .addr = A_POR_MPU_M1_PRLAR14_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR15_U_RND_NID68",
        .addr = A_POR_MPU_M1_PRBAR15_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR15_U_RND_NID68",
        .addr = A_POR_MPU_M1_PRLAR15_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR16_U_RND_NID68",
        .addr = A_POR_MPU_M1_PRBAR16_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR16_U_RND_NID68",
        .addr = A_POR_MPU_M1_PRLAR16_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR17_U_RND_NID68",
        .addr = A_POR_MPU_M1_PRBAR17_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR17_U_RND_NID68",
        .addr = A_POR_MPU_M1_PRLAR17_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR18_U_RND_NID68",
        .addr = A_POR_MPU_M1_PRBAR18_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR18_U_RND_NID68",
        .addr = A_POR_MPU_M1_PRLAR18_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR19_U_RND_NID68",
        .addr = A_POR_MPU_M1_PRBAR19_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR19_U_RND_NID68",
        .addr = A_POR_MPU_M1_PRLAR19_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR20_U_RND_NID68",
        .addr = A_POR_MPU_M1_PRBAR20_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR20_U_RND_NID68",
        .addr = A_POR_MPU_M1_PRLAR20_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR21_U_RND_NID68",
        .addr = A_POR_MPU_M1_PRBAR21_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR21_U_RND_NID68",
        .addr = A_POR_MPU_M1_PRLAR21_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR22_U_RND_NID68",
        .addr = A_POR_MPU_M1_PRBAR22_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR22_U_RND_NID68",
        .addr = A_POR_MPU_M1_PRLAR22_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR23_U_RND_NID68",
        .addr = A_POR_MPU_M1_PRBAR23_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR23_U_RND_NID68",
        .addr = A_POR_MPU_M1_PRLAR23_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR24_U_RND_NID68",
        .addr = A_POR_MPU_M1_PRBAR24_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR24_U_RND_NID68",
        .addr = A_POR_MPU_M1_PRLAR24_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR25_U_RND_NID68",
        .addr = A_POR_MPU_M1_PRBAR25_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR25_U_RND_NID68",
        .addr = A_POR_MPU_M1_PRLAR25_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR26_U_RND_NID68",
        .addr = A_POR_MPU_M1_PRBAR26_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR26_U_RND_NID68",
        .addr = A_POR_MPU_M1_PRLAR26_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR27_U_RND_NID68",
        .addr = A_POR_MPU_M1_PRBAR27_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR27_U_RND_NID68",
        .addr = A_POR_MPU_M1_PRLAR27_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR28_U_RND_NID68",
        .addr = A_POR_MPU_M1_PRBAR28_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR28_U_RND_NID68",
        .addr = A_POR_MPU_M1_PRLAR28_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR29_U_RND_NID68",
        .addr = A_POR_MPU_M1_PRBAR29_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR29_U_RND_NID68",
        .addr = A_POR_MPU_M1_PRLAR29_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR30_U_RND_NID68",
        .addr = A_POR_MPU_M1_PRBAR30_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR30_U_RND_NID68",
        .addr = A_POR_MPU_M1_PRLAR30_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR31_U_RND_NID68",
        .addr = A_POR_MPU_M1_PRBAR31_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR31_U_RND_NID68",
        .addr = A_POR_MPU_M1_PRLAR31_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_CTL_U_RND_NID68",
        .addr = A_POR_MPU_M2_CTL_U_RND_NID68,
        .reset = 0x2,
        .rsvd = 0xfffffffffffffff8L,
        .ro = 0xfffffffffffffff8L,
    },{ .name = "POR_MPU_M2_PRBAR0_U_RND_NID68",
        .addr = A_POR_MPU_M2_PRBAR0_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR0_U_RND_NID68",
        .addr = A_POR_MPU_M2_PRLAR0_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR1_U_RND_NID68",
        .addr = A_POR_MPU_M2_PRBAR1_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR1_U_RND_NID68",
        .addr = A_POR_MPU_M2_PRLAR1_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR2_U_RND_NID68",
        .addr = A_POR_MPU_M2_PRBAR2_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR2_U_RND_NID68",
        .addr = A_POR_MPU_M2_PRLAR2_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR3_U_RND_NID68",
        .addr = A_POR_MPU_M2_PRBAR3_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR3_U_RND_NID68",
        .addr = A_POR_MPU_M2_PRLAR3_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR4_U_RND_NID68",
        .addr = A_POR_MPU_M2_PRBAR4_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR4_U_RND_NID68",
        .addr = A_POR_MPU_M2_PRLAR4_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR5_U_RND_NID68",
        .addr = A_POR_MPU_M2_PRBAR5_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR5_U_RND_NID68",
        .addr = A_POR_MPU_M2_PRLAR5_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR6_U_RND_NID68",
        .addr = A_POR_MPU_M2_PRBAR6_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR6_U_RND_NID68",
        .addr = A_POR_MPU_M2_PRLAR6_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR7_U_RND_NID68",
        .addr = A_POR_MPU_M2_PRBAR7_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR7_U_RND_NID68",
        .addr = A_POR_MPU_M2_PRLAR7_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR8_U_RND_NID68",
        .addr = A_POR_MPU_M2_PRBAR8_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR8_U_RND_NID68",
        .addr = A_POR_MPU_M2_PRLAR8_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR9_U_RND_NID68",
        .addr = A_POR_MPU_M2_PRBAR9_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR9_U_RND_NID68",
        .addr = A_POR_MPU_M2_PRLAR9_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR10_U_RND_NID68",
        .addr = A_POR_MPU_M2_PRBAR10_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR10_U_RND_NID68",
        .addr = A_POR_MPU_M2_PRLAR10_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR11_U_RND_NID68",
        .addr = A_POR_MPU_M2_PRBAR11_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR11_U_RND_NID68",
        .addr = A_POR_MPU_M2_PRLAR11_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR12_U_RND_NID68",
        .addr = A_POR_MPU_M2_PRBAR12_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR12_U_RND_NID68",
        .addr = A_POR_MPU_M2_PRLAR12_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR13_U_RND_NID68",
        .addr = A_POR_MPU_M2_PRBAR13_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR13_U_RND_NID68",
        .addr = A_POR_MPU_M2_PRLAR13_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR14_U_RND_NID68",
        .addr = A_POR_MPU_M2_PRBAR14_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR14_U_RND_NID68",
        .addr = A_POR_MPU_M2_PRLAR14_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR15_U_RND_NID68",
        .addr = A_POR_MPU_M2_PRBAR15_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR15_U_RND_NID68",
        .addr = A_POR_MPU_M2_PRLAR15_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR16_U_RND_NID68",
        .addr = A_POR_MPU_M2_PRBAR16_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR16_U_RND_NID68",
        .addr = A_POR_MPU_M2_PRLAR16_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR17_U_RND_NID68",
        .addr = A_POR_MPU_M2_PRBAR17_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR17_U_RND_NID68",
        .addr = A_POR_MPU_M2_PRLAR17_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR18_U_RND_NID68",
        .addr = A_POR_MPU_M2_PRBAR18_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR18_U_RND_NID68",
        .addr = A_POR_MPU_M2_PRLAR18_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR19_U_RND_NID68",
        .addr = A_POR_MPU_M2_PRBAR19_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR19_U_RND_NID68",
        .addr = A_POR_MPU_M2_PRLAR19_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR20_U_RND_NID68",
        .addr = A_POR_MPU_M2_PRBAR20_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR20_U_RND_NID68",
        .addr = A_POR_MPU_M2_PRLAR20_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR21_U_RND_NID68",
        .addr = A_POR_MPU_M2_PRBAR21_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR21_U_RND_NID68",
        .addr = A_POR_MPU_M2_PRLAR21_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR22_U_RND_NID68",
        .addr = A_POR_MPU_M2_PRBAR22_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR22_U_RND_NID68",
        .addr = A_POR_MPU_M2_PRLAR22_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR23_U_RND_NID68",
        .addr = A_POR_MPU_M2_PRBAR23_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR23_U_RND_NID68",
        .addr = A_POR_MPU_M2_PRLAR23_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR24_U_RND_NID68",
        .addr = A_POR_MPU_M2_PRBAR24_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR24_U_RND_NID68",
        .addr = A_POR_MPU_M2_PRLAR24_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR25_U_RND_NID68",
        .addr = A_POR_MPU_M2_PRBAR25_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR25_U_RND_NID68",
        .addr = A_POR_MPU_M2_PRLAR25_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR26_U_RND_NID68",
        .addr = A_POR_MPU_M2_PRBAR26_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR26_U_RND_NID68",
        .addr = A_POR_MPU_M2_PRLAR26_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR27_U_RND_NID68",
        .addr = A_POR_MPU_M2_PRBAR27_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR27_U_RND_NID68",
        .addr = A_POR_MPU_M2_PRLAR27_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR28_U_RND_NID68",
        .addr = A_POR_MPU_M2_PRBAR28_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR28_U_RND_NID68",
        .addr = A_POR_MPU_M2_PRLAR28_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR29_U_RND_NID68",
        .addr = A_POR_MPU_M2_PRBAR29_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR29_U_RND_NID68",
        .addr = A_POR_MPU_M2_PRLAR29_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR30_U_RND_NID68",
        .addr = A_POR_MPU_M2_PRBAR30_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR30_U_RND_NID68",
        .addr = A_POR_MPU_M2_PRLAR30_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR31_U_RND_NID68",
        .addr = A_POR_MPU_M2_PRBAR31_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR31_U_RND_NID68",
        .addr = A_POR_MPU_M2_PRLAR31_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_CTL_U_RND_NID68",
        .addr = A_POR_MPU_M3_CTL_U_RND_NID68,
        .reset = 0x2,
        .rsvd = 0xfffffffffffffff8L,
        .ro = 0xfffffffffffffff8L,
    },{ .name = "POR_MPU_M3_PRBAR0_U_RND_NID68",
        .addr = A_POR_MPU_M3_PRBAR0_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR0_U_RND_NID68",
        .addr = A_POR_MPU_M3_PRLAR0_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR1_U_RND_NID68",
        .addr = A_POR_MPU_M3_PRBAR1_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR1_U_RND_NID68",
        .addr = A_POR_MPU_M3_PRLAR1_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR2_U_RND_NID68",
        .addr = A_POR_MPU_M3_PRBAR2_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR2_U_RND_NID68",
        .addr = A_POR_MPU_M3_PRLAR2_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR3_U_RND_NID68",
        .addr = A_POR_MPU_M3_PRBAR3_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR3_U_RND_NID68",
        .addr = A_POR_MPU_M3_PRLAR3_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR4_U_RND_NID68",
        .addr = A_POR_MPU_M3_PRBAR4_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR4_U_RND_NID68",
        .addr = A_POR_MPU_M3_PRLAR4_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR5_U_RND_NID68",
        .addr = A_POR_MPU_M3_PRBAR5_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR5_U_RND_NID68",
        .addr = A_POR_MPU_M3_PRLAR5_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR6_U_RND_NID68",
        .addr = A_POR_MPU_M3_PRBAR6_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR6_U_RND_NID68",
        .addr = A_POR_MPU_M3_PRLAR6_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR7_U_RND_NID68",
        .addr = A_POR_MPU_M3_PRBAR7_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR7_U_RND_NID68",
        .addr = A_POR_MPU_M3_PRLAR7_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR8_U_RND_NID68",
        .addr = A_POR_MPU_M3_PRBAR8_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR8_U_RND_NID68",
        .addr = A_POR_MPU_M3_PRLAR8_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR9_U_RND_NID68",
        .addr = A_POR_MPU_M3_PRBAR9_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR9_U_RND_NID68",
        .addr = A_POR_MPU_M3_PRLAR9_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR10_U_RND_NID68",
        .addr = A_POR_MPU_M3_PRBAR10_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR10_U_RND_NID68",
        .addr = A_POR_MPU_M3_PRLAR10_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR11_U_RND_NID68",
        .addr = A_POR_MPU_M3_PRBAR11_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR11_U_RND_NID68",
        .addr = A_POR_MPU_M3_PRLAR11_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR12_U_RND_NID68",
        .addr = A_POR_MPU_M3_PRBAR12_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR12_U_RND_NID68",
        .addr = A_POR_MPU_M3_PRLAR12_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR13_U_RND_NID68",
        .addr = A_POR_MPU_M3_PRBAR13_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR13_U_RND_NID68",
        .addr = A_POR_MPU_M3_PRLAR13_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR14_U_RND_NID68",
        .addr = A_POR_MPU_M3_PRBAR14_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR14_U_RND_NID68",
        .addr = A_POR_MPU_M3_PRLAR14_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR15_U_RND_NID68",
        .addr = A_POR_MPU_M3_PRBAR15_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR15_U_RND_NID68",
        .addr = A_POR_MPU_M3_PRLAR15_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR16_U_RND_NID68",
        .addr = A_POR_MPU_M3_PRBAR16_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR16_U_RND_NID68",
        .addr = A_POR_MPU_M3_PRLAR16_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR17_U_RND_NID68",
        .addr = A_POR_MPU_M3_PRBAR17_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR17_U_RND_NID68",
        .addr = A_POR_MPU_M3_PRLAR17_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR18_U_RND_NID68",
        .addr = A_POR_MPU_M3_PRBAR18_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR18_U_RND_NID68",
        .addr = A_POR_MPU_M3_PRLAR18_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR19_U_RND_NID68",
        .addr = A_POR_MPU_M3_PRBAR19_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR19_U_RND_NID68",
        .addr = A_POR_MPU_M3_PRLAR19_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR20_U_RND_NID68",
        .addr = A_POR_MPU_M3_PRBAR20_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR20_U_RND_NID68",
        .addr = A_POR_MPU_M3_PRLAR20_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR21_U_RND_NID68",
        .addr = A_POR_MPU_M3_PRBAR21_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR21_U_RND_NID68",
        .addr = A_POR_MPU_M3_PRLAR21_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR22_U_RND_NID68",
        .addr = A_POR_MPU_M3_PRBAR22_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR22_U_RND_NID68",
        .addr = A_POR_MPU_M3_PRLAR22_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR23_U_RND_NID68",
        .addr = A_POR_MPU_M3_PRBAR23_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR23_U_RND_NID68",
        .addr = A_POR_MPU_M3_PRLAR23_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR24_U_RND_NID68",
        .addr = A_POR_MPU_M3_PRBAR24_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR24_U_RND_NID68",
        .addr = A_POR_MPU_M3_PRLAR24_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR25_U_RND_NID68",
        .addr = A_POR_MPU_M3_PRBAR25_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR25_U_RND_NID68",
        .addr = A_POR_MPU_M3_PRLAR25_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR26_U_RND_NID68",
        .addr = A_POR_MPU_M3_PRBAR26_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR26_U_RND_NID68",
        .addr = A_POR_MPU_M3_PRLAR26_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR27_U_RND_NID68",
        .addr = A_POR_MPU_M3_PRBAR27_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR27_U_RND_NID68",
        .addr = A_POR_MPU_M3_PRLAR27_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR28_U_RND_NID68",
        .addr = A_POR_MPU_M3_PRBAR28_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR28_U_RND_NID68",
        .addr = A_POR_MPU_M3_PRLAR28_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR29_U_RND_NID68",
        .addr = A_POR_MPU_M3_PRBAR29_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR29_U_RND_NID68",
        .addr = A_POR_MPU_M3_PRLAR29_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR30_U_RND_NID68",
        .addr = A_POR_MPU_M3_PRBAR30_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR30_U_RND_NID68",
        .addr = A_POR_MPU_M3_PRLAR30_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR31_U_RND_NID68",
        .addr = A_POR_MPU_M3_PRBAR31_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR31_U_RND_NID68",
        .addr = A_POR_MPU_M3_PRLAR31_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_CTL_U_RND_NID68",
        .addr = A_POR_MPU_M4_CTL_U_RND_NID68,
        .reset = 0x2,
        .rsvd = 0xfffffffffffffff8L,
        .ro = 0xfffffffffffffff8L,
    },{ .name = "POR_MPU_M4_PRBAR0_U_RND_NID68",
        .addr = A_POR_MPU_M4_PRBAR0_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR0_U_RND_NID68",
        .addr = A_POR_MPU_M4_PRLAR0_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR1_U_RND_NID68",
        .addr = A_POR_MPU_M4_PRBAR1_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR1_U_RND_NID68",
        .addr = A_POR_MPU_M4_PRLAR1_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR2_U_RND_NID68",
        .addr = A_POR_MPU_M4_PRBAR2_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR2_U_RND_NID68",
        .addr = A_POR_MPU_M4_PRLAR2_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR3_U_RND_NID68",
        .addr = A_POR_MPU_M4_PRBAR3_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR3_U_RND_NID68",
        .addr = A_POR_MPU_M4_PRLAR3_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR4_U_RND_NID68",
        .addr = A_POR_MPU_M4_PRBAR4_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR4_U_RND_NID68",
        .addr = A_POR_MPU_M4_PRLAR4_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR5_U_RND_NID68",
        .addr = A_POR_MPU_M4_PRBAR5_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR5_U_RND_NID68",
        .addr = A_POR_MPU_M4_PRLAR5_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR6_U_RND_NID68",
        .addr = A_POR_MPU_M4_PRBAR6_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR6_U_RND_NID68",
        .addr = A_POR_MPU_M4_PRLAR6_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR7_U_RND_NID68",
        .addr = A_POR_MPU_M4_PRBAR7_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR7_U_RND_NID68",
        .addr = A_POR_MPU_M4_PRLAR7_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR8_U_RND_NID68",
        .addr = A_POR_MPU_M4_PRBAR8_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR8_U_RND_NID68",
        .addr = A_POR_MPU_M4_PRLAR8_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR9_U_RND_NID68",
        .addr = A_POR_MPU_M4_PRBAR9_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR9_U_RND_NID68",
        .addr = A_POR_MPU_M4_PRLAR9_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR10_U_RND_NID68",
        .addr = A_POR_MPU_M4_PRBAR10_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR10_U_RND_NID68",
        .addr = A_POR_MPU_M4_PRLAR10_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR11_U_RND_NID68",
        .addr = A_POR_MPU_M4_PRBAR11_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR11_U_RND_NID68",
        .addr = A_POR_MPU_M4_PRLAR11_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR12_U_RND_NID68",
        .addr = A_POR_MPU_M4_PRBAR12_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR12_U_RND_NID68",
        .addr = A_POR_MPU_M4_PRLAR12_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR13_U_RND_NID68",
        .addr = A_POR_MPU_M4_PRBAR13_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR13_U_RND_NID68",
        .addr = A_POR_MPU_M4_PRLAR13_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR14_U_RND_NID68",
        .addr = A_POR_MPU_M4_PRBAR14_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR14_U_RND_NID68",
        .addr = A_POR_MPU_M4_PRLAR14_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR15_U_RND_NID68",
        .addr = A_POR_MPU_M4_PRBAR15_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR15_U_RND_NID68",
        .addr = A_POR_MPU_M4_PRLAR15_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR16_U_RND_NID68",
        .addr = A_POR_MPU_M4_PRBAR16_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR16_U_RND_NID68",
        .addr = A_POR_MPU_M4_PRLAR16_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR17_U_RND_NID68",
        .addr = A_POR_MPU_M4_PRBAR17_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR17_U_RND_NID68",
        .addr = A_POR_MPU_M4_PRLAR17_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR18_U_RND_NID68",
        .addr = A_POR_MPU_M4_PRBAR18_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR18_U_RND_NID68",
        .addr = A_POR_MPU_M4_PRLAR18_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR19_U_RND_NID68",
        .addr = A_POR_MPU_M4_PRBAR19_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR19_U_RND_NID68",
        .addr = A_POR_MPU_M4_PRLAR19_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR20_U_RND_NID68",
        .addr = A_POR_MPU_M4_PRBAR20_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR20_U_RND_NID68",
        .addr = A_POR_MPU_M4_PRLAR20_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR21_U_RND_NID68",
        .addr = A_POR_MPU_M4_PRBAR21_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR21_U_RND_NID68",
        .addr = A_POR_MPU_M4_PRLAR21_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR22_U_RND_NID68",
        .addr = A_POR_MPU_M4_PRBAR22_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR22_U_RND_NID68",
        .addr = A_POR_MPU_M4_PRLAR22_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR23_U_RND_NID68",
        .addr = A_POR_MPU_M4_PRBAR23_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR23_U_RND_NID68",
        .addr = A_POR_MPU_M4_PRLAR23_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR24_U_RND_NID68",
        .addr = A_POR_MPU_M4_PRBAR24_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR24_U_RND_NID68",
        .addr = A_POR_MPU_M4_PRLAR24_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR25_U_RND_NID68",
        .addr = A_POR_MPU_M4_PRBAR25_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR25_U_RND_NID68",
        .addr = A_POR_MPU_M4_PRLAR25_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR26_U_RND_NID68",
        .addr = A_POR_MPU_M4_PRBAR26_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR26_U_RND_NID68",
        .addr = A_POR_MPU_M4_PRLAR26_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR27_U_RND_NID68",
        .addr = A_POR_MPU_M4_PRBAR27_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR27_U_RND_NID68",
        .addr = A_POR_MPU_M4_PRLAR27_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR28_U_RND_NID68",
        .addr = A_POR_MPU_M4_PRBAR28_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR28_U_RND_NID68",
        .addr = A_POR_MPU_M4_PRLAR28_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR29_U_RND_NID68",
        .addr = A_POR_MPU_M4_PRBAR29_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR29_U_RND_NID68",
        .addr = A_POR_MPU_M4_PRLAR29_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR30_U_RND_NID68",
        .addr = A_POR_MPU_M4_PRBAR30_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR30_U_RND_NID68",
        .addr = A_POR_MPU_M4_PRLAR30_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR31_U_RND_NID68",
        .addr = A_POR_MPU_M4_PRBAR31_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR31_U_RND_NID68",
        .addr = A_POR_MPU_M4_PRLAR31_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_CTL_U_RND_NID68",
        .addr = A_POR_MPU_M5_CTL_U_RND_NID68,
        .reset = 0x2,
        .rsvd = 0xfffffffffffffff8L,
        .ro = 0xfffffffffffffff8L,
    },{ .name = "POR_MPU_M5_PRBAR0_U_RND_NID68",
        .addr = A_POR_MPU_M5_PRBAR0_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR0_U_RND_NID68",
        .addr = A_POR_MPU_M5_PRLAR0_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR1_U_RND_NID68",
        .addr = A_POR_MPU_M5_PRBAR1_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR1_U_RND_NID68",
        .addr = A_POR_MPU_M5_PRLAR1_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR2_U_RND_NID68",
        .addr = A_POR_MPU_M5_PRBAR2_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR2_U_RND_NID68",
        .addr = A_POR_MPU_M5_PRLAR2_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR3_U_RND_NID68",
        .addr = A_POR_MPU_M5_PRBAR3_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR3_U_RND_NID68",
        .addr = A_POR_MPU_M5_PRLAR3_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR4_U_RND_NID68",
        .addr = A_POR_MPU_M5_PRBAR4_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR4_U_RND_NID68",
        .addr = A_POR_MPU_M5_PRLAR4_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR5_U_RND_NID68",
        .addr = A_POR_MPU_M5_PRBAR5_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR5_U_RND_NID68",
        .addr = A_POR_MPU_M5_PRLAR5_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR6_U_RND_NID68",
        .addr = A_POR_MPU_M5_PRBAR6_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR6_U_RND_NID68",
        .addr = A_POR_MPU_M5_PRLAR6_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR7_U_RND_NID68",
        .addr = A_POR_MPU_M5_PRBAR7_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR7_U_RND_NID68",
        .addr = A_POR_MPU_M5_PRLAR7_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR8_U_RND_NID68",
        .addr = A_POR_MPU_M5_PRBAR8_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR8_U_RND_NID68",
        .addr = A_POR_MPU_M5_PRLAR8_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR9_U_RND_NID68",
        .addr = A_POR_MPU_M5_PRBAR9_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR9_U_RND_NID68",
        .addr = A_POR_MPU_M5_PRLAR9_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR10_U_RND_NID68",
        .addr = A_POR_MPU_M5_PRBAR10_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR10_U_RND_NID68",
        .addr = A_POR_MPU_M5_PRLAR10_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR11_U_RND_NID68",
        .addr = A_POR_MPU_M5_PRBAR11_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR11_U_RND_NID68",
        .addr = A_POR_MPU_M5_PRLAR11_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR12_U_RND_NID68",
        .addr = A_POR_MPU_M5_PRBAR12_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR12_U_RND_NID68",
        .addr = A_POR_MPU_M5_PRLAR12_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR13_U_RND_NID68",
        .addr = A_POR_MPU_M5_PRBAR13_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR13_U_RND_NID68",
        .addr = A_POR_MPU_M5_PRLAR13_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR14_U_RND_NID68",
        .addr = A_POR_MPU_M5_PRBAR14_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR14_U_RND_NID68",
        .addr = A_POR_MPU_M5_PRLAR14_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR15_U_RND_NID68",
        .addr = A_POR_MPU_M5_PRBAR15_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR15_U_RND_NID68",
        .addr = A_POR_MPU_M5_PRLAR15_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR16_U_RND_NID68",
        .addr = A_POR_MPU_M5_PRBAR16_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR16_U_RND_NID68",
        .addr = A_POR_MPU_M5_PRLAR16_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR17_U_RND_NID68",
        .addr = A_POR_MPU_M5_PRBAR17_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR17_U_RND_NID68",
        .addr = A_POR_MPU_M5_PRLAR17_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR18_U_RND_NID68",
        .addr = A_POR_MPU_M5_PRBAR18_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR18_U_RND_NID68",
        .addr = A_POR_MPU_M5_PRLAR18_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR19_U_RND_NID68",
        .addr = A_POR_MPU_M5_PRBAR19_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR19_U_RND_NID68",
        .addr = A_POR_MPU_M5_PRLAR19_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR20_U_RND_NID68",
        .addr = A_POR_MPU_M5_PRBAR20_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR20_U_RND_NID68",
        .addr = A_POR_MPU_M5_PRLAR20_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR21_U_RND_NID68",
        .addr = A_POR_MPU_M5_PRBAR21_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR21_U_RND_NID68",
        .addr = A_POR_MPU_M5_PRLAR21_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR22_U_RND_NID68",
        .addr = A_POR_MPU_M5_PRBAR22_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR22_U_RND_NID68",
        .addr = A_POR_MPU_M5_PRLAR22_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR23_U_RND_NID68",
        .addr = A_POR_MPU_M5_PRBAR23_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR23_U_RND_NID68",
        .addr = A_POR_MPU_M5_PRLAR23_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR24_U_RND_NID68",
        .addr = A_POR_MPU_M5_PRBAR24_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR24_U_RND_NID68",
        .addr = A_POR_MPU_M5_PRLAR24_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR25_U_RND_NID68",
        .addr = A_POR_MPU_M5_PRBAR25_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR25_U_RND_NID68",
        .addr = A_POR_MPU_M5_PRLAR25_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR26_U_RND_NID68",
        .addr = A_POR_MPU_M5_PRBAR26_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR26_U_RND_NID68",
        .addr = A_POR_MPU_M5_PRLAR26_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR27_U_RND_NID68",
        .addr = A_POR_MPU_M5_PRBAR27_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR27_U_RND_NID68",
        .addr = A_POR_MPU_M5_PRLAR27_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR28_U_RND_NID68",
        .addr = A_POR_MPU_M5_PRBAR28_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR28_U_RND_NID68",
        .addr = A_POR_MPU_M5_PRLAR28_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR29_U_RND_NID68",
        .addr = A_POR_MPU_M5_PRBAR29_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR29_U_RND_NID68",
        .addr = A_POR_MPU_M5_PRLAR29_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR30_U_RND_NID68",
        .addr = A_POR_MPU_M5_PRBAR30_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR30_U_RND_NID68",
        .addr = A_POR_MPU_M5_PRLAR30_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR31_U_RND_NID68",
        .addr = A_POR_MPU_M5_PRBAR31_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR31_U_RND_NID68",
        .addr = A_POR_MPU_M5_PRLAR31_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_CTL_U_RND_NID68",
        .addr = A_POR_MPU_M6_CTL_U_RND_NID68,
        .reset = 0x2,
        .rsvd = 0xfffffffffffffff8L,
        .ro = 0xfffffffffffffff8L,
    },{ .name = "POR_MPU_M6_PRBAR0_U_RND_NID68",
        .addr = A_POR_MPU_M6_PRBAR0_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR0_U_RND_NID68",
        .addr = A_POR_MPU_M6_PRLAR0_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR1_U_RND_NID68",
        .addr = A_POR_MPU_M6_PRBAR1_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR1_U_RND_NID68",
        .addr = A_POR_MPU_M6_PRLAR1_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR2_U_RND_NID68",
        .addr = A_POR_MPU_M6_PRBAR2_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR2_U_RND_NID68",
        .addr = A_POR_MPU_M6_PRLAR2_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR3_U_RND_NID68",
        .addr = A_POR_MPU_M6_PRBAR3_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR3_U_RND_NID68",
        .addr = A_POR_MPU_M6_PRLAR3_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR4_U_RND_NID68",
        .addr = A_POR_MPU_M6_PRBAR4_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR4_U_RND_NID68",
        .addr = A_POR_MPU_M6_PRLAR4_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR5_U_RND_NID68",
        .addr = A_POR_MPU_M6_PRBAR5_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR5_U_RND_NID68",
        .addr = A_POR_MPU_M6_PRLAR5_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR6_U_RND_NID68",
        .addr = A_POR_MPU_M6_PRBAR6_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR6_U_RND_NID68",
        .addr = A_POR_MPU_M6_PRLAR6_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR7_U_RND_NID68",
        .addr = A_POR_MPU_M6_PRBAR7_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR7_U_RND_NID68",
        .addr = A_POR_MPU_M6_PRLAR7_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR8_U_RND_NID68",
        .addr = A_POR_MPU_M6_PRBAR8_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR8_U_RND_NID68",
        .addr = A_POR_MPU_M6_PRLAR8_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR9_U_RND_NID68",
        .addr = A_POR_MPU_M6_PRBAR9_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR9_U_RND_NID68",
        .addr = A_POR_MPU_M6_PRLAR9_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR10_U_RND_NID68",
        .addr = A_POR_MPU_M6_PRBAR10_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR10_U_RND_NID68",
        .addr = A_POR_MPU_M6_PRLAR10_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR11_U_RND_NID68",
        .addr = A_POR_MPU_M6_PRBAR11_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR11_U_RND_NID68",
        .addr = A_POR_MPU_M6_PRLAR11_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR12_U_RND_NID68",
        .addr = A_POR_MPU_M6_PRBAR12_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR12_U_RND_NID68",
        .addr = A_POR_MPU_M6_PRLAR12_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR13_U_RND_NID68",
        .addr = A_POR_MPU_M6_PRBAR13_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR13_U_RND_NID68",
        .addr = A_POR_MPU_M6_PRLAR13_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR14_U_RND_NID68",
        .addr = A_POR_MPU_M6_PRBAR14_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR14_U_RND_NID68",
        .addr = A_POR_MPU_M6_PRLAR14_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR15_U_RND_NID68",
        .addr = A_POR_MPU_M6_PRBAR15_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR15_U_RND_NID68",
        .addr = A_POR_MPU_M6_PRLAR15_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR16_U_RND_NID68",
        .addr = A_POR_MPU_M6_PRBAR16_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR16_U_RND_NID68",
        .addr = A_POR_MPU_M6_PRLAR16_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR17_U_RND_NID68",
        .addr = A_POR_MPU_M6_PRBAR17_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR17_U_RND_NID68",
        .addr = A_POR_MPU_M6_PRLAR17_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR18_U_RND_NID68",
        .addr = A_POR_MPU_M6_PRBAR18_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR18_U_RND_NID68",
        .addr = A_POR_MPU_M6_PRLAR18_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR19_U_RND_NID68",
        .addr = A_POR_MPU_M6_PRBAR19_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR19_U_RND_NID68",
        .addr = A_POR_MPU_M6_PRLAR19_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR20_U_RND_NID68",
        .addr = A_POR_MPU_M6_PRBAR20_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR20_U_RND_NID68",
        .addr = A_POR_MPU_M6_PRLAR20_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR21_U_RND_NID68",
        .addr = A_POR_MPU_M6_PRBAR21_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR21_U_RND_NID68",
        .addr = A_POR_MPU_M6_PRLAR21_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR22_U_RND_NID68",
        .addr = A_POR_MPU_M6_PRBAR22_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR22_U_RND_NID68",
        .addr = A_POR_MPU_M6_PRLAR22_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR23_U_RND_NID68",
        .addr = A_POR_MPU_M6_PRBAR23_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR23_U_RND_NID68",
        .addr = A_POR_MPU_M6_PRLAR23_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR24_U_RND_NID68",
        .addr = A_POR_MPU_M6_PRBAR24_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR24_U_RND_NID68",
        .addr = A_POR_MPU_M6_PRLAR24_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR25_U_RND_NID68",
        .addr = A_POR_MPU_M6_PRBAR25_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR25_U_RND_NID68",
        .addr = A_POR_MPU_M6_PRLAR25_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR26_U_RND_NID68",
        .addr = A_POR_MPU_M6_PRBAR26_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR26_U_RND_NID68",
        .addr = A_POR_MPU_M6_PRLAR26_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR27_U_RND_NID68",
        .addr = A_POR_MPU_M6_PRBAR27_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR27_U_RND_NID68",
        .addr = A_POR_MPU_M6_PRLAR27_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR28_U_RND_NID68",
        .addr = A_POR_MPU_M6_PRBAR28_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR28_U_RND_NID68",
        .addr = A_POR_MPU_M6_PRLAR28_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR29_U_RND_NID68",
        .addr = A_POR_MPU_M6_PRBAR29_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR29_U_RND_NID68",
        .addr = A_POR_MPU_M6_PRLAR29_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR30_U_RND_NID68",
        .addr = A_POR_MPU_M6_PRBAR30_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR30_U_RND_NID68",
        .addr = A_POR_MPU_M6_PRLAR30_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR31_U_RND_NID68",
        .addr = A_POR_MPU_M6_PRBAR31_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR31_U_RND_NID68",
        .addr = A_POR_MPU_M6_PRLAR31_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_CTL_U_RND_NID68",
        .addr = A_POR_MPU_M7_CTL_U_RND_NID68,
        .reset = 0x2,
        .rsvd = 0xfffffffffffffff8L,
        .ro = 0xfffffffffffffff8L,
    },{ .name = "POR_MPU_M7_PRBAR0_U_RND_NID68",
        .addr = A_POR_MPU_M7_PRBAR0_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR0_U_RND_NID68",
        .addr = A_POR_MPU_M7_PRLAR0_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR1_U_RND_NID68",
        .addr = A_POR_MPU_M7_PRBAR1_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR1_U_RND_NID68",
        .addr = A_POR_MPU_M7_PRLAR1_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR2_U_RND_NID68",
        .addr = A_POR_MPU_M7_PRBAR2_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR2_U_RND_NID68",
        .addr = A_POR_MPU_M7_PRLAR2_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR3_U_RND_NID68",
        .addr = A_POR_MPU_M7_PRBAR3_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR3_U_RND_NID68",
        .addr = A_POR_MPU_M7_PRLAR3_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR4_U_RND_NID68",
        .addr = A_POR_MPU_M7_PRBAR4_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR4_U_RND_NID68",
        .addr = A_POR_MPU_M7_PRLAR4_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR5_U_RND_NID68",
        .addr = A_POR_MPU_M7_PRBAR5_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR5_U_RND_NID68",
        .addr = A_POR_MPU_M7_PRLAR5_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR6_U_RND_NID68",
        .addr = A_POR_MPU_M7_PRBAR6_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR6_U_RND_NID68",
        .addr = A_POR_MPU_M7_PRLAR6_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR7_U_RND_NID68",
        .addr = A_POR_MPU_M7_PRBAR7_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR7_U_RND_NID68",
        .addr = A_POR_MPU_M7_PRLAR7_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR8_U_RND_NID68",
        .addr = A_POR_MPU_M7_PRBAR8_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR8_U_RND_NID68",
        .addr = A_POR_MPU_M7_PRLAR8_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR9_U_RND_NID68",
        .addr = A_POR_MPU_M7_PRBAR9_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR9_U_RND_NID68",
        .addr = A_POR_MPU_M7_PRLAR9_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR10_U_RND_NID68",
        .addr = A_POR_MPU_M7_PRBAR10_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR10_U_RND_NID68",
        .addr = A_POR_MPU_M7_PRLAR10_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR11_U_RND_NID68",
        .addr = A_POR_MPU_M7_PRBAR11_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR11_U_RND_NID68",
        .addr = A_POR_MPU_M7_PRLAR11_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR12_U_RND_NID68",
        .addr = A_POR_MPU_M7_PRBAR12_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR12_U_RND_NID68",
        .addr = A_POR_MPU_M7_PRLAR12_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR13_U_RND_NID68",
        .addr = A_POR_MPU_M7_PRBAR13_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR13_U_RND_NID68",
        .addr = A_POR_MPU_M7_PRLAR13_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR14_U_RND_NID68",
        .addr = A_POR_MPU_M7_PRBAR14_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR14_U_RND_NID68",
        .addr = A_POR_MPU_M7_PRLAR14_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR15_U_RND_NID68",
        .addr = A_POR_MPU_M7_PRBAR15_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR15_U_RND_NID68",
        .addr = A_POR_MPU_M7_PRLAR15_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR16_U_RND_NID68",
        .addr = A_POR_MPU_M7_PRBAR16_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR16_U_RND_NID68",
        .addr = A_POR_MPU_M7_PRLAR16_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR17_U_RND_NID68",
        .addr = A_POR_MPU_M7_PRBAR17_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR17_U_RND_NID68",
        .addr = A_POR_MPU_M7_PRLAR17_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR18_U_RND_NID68",
        .addr = A_POR_MPU_M7_PRBAR18_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR18_U_RND_NID68",
        .addr = A_POR_MPU_M7_PRLAR18_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR19_U_RND_NID68",
        .addr = A_POR_MPU_M7_PRBAR19_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR19_U_RND_NID68",
        .addr = A_POR_MPU_M7_PRLAR19_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR20_U_RND_NID68",
        .addr = A_POR_MPU_M7_PRBAR20_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR20_U_RND_NID68",
        .addr = A_POR_MPU_M7_PRLAR20_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR21_U_RND_NID68",
        .addr = A_POR_MPU_M7_PRBAR21_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR21_U_RND_NID68",
        .addr = A_POR_MPU_M7_PRLAR21_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR22_U_RND_NID68",
        .addr = A_POR_MPU_M7_PRBAR22_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR22_U_RND_NID68",
        .addr = A_POR_MPU_M7_PRLAR22_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR23_U_RND_NID68",
        .addr = A_POR_MPU_M7_PRBAR23_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR23_U_RND_NID68",
        .addr = A_POR_MPU_M7_PRLAR23_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR24_U_RND_NID68",
        .addr = A_POR_MPU_M7_PRBAR24_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR24_U_RND_NID68",
        .addr = A_POR_MPU_M7_PRLAR24_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR25_U_RND_NID68",
        .addr = A_POR_MPU_M7_PRBAR25_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR25_U_RND_NID68",
        .addr = A_POR_MPU_M7_PRLAR25_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR26_U_RND_NID68",
        .addr = A_POR_MPU_M7_PRBAR26_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR26_U_RND_NID68",
        .addr = A_POR_MPU_M7_PRLAR26_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR27_U_RND_NID68",
        .addr = A_POR_MPU_M7_PRBAR27_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR27_U_RND_NID68",
        .addr = A_POR_MPU_M7_PRLAR27_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR28_U_RND_NID68",
        .addr = A_POR_MPU_M7_PRBAR28_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR28_U_RND_NID68",
        .addr = A_POR_MPU_M7_PRLAR28_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR29_U_RND_NID68",
        .addr = A_POR_MPU_M7_PRBAR29_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR29_U_RND_NID68",
        .addr = A_POR_MPU_M7_PRLAR29_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR30_U_RND_NID68",
        .addr = A_POR_MPU_M7_PRBAR30_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR30_U_RND_NID68",
        .addr = A_POR_MPU_M7_PRLAR30_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR31_U_RND_NID68",
        .addr = A_POR_MPU_M7_PRBAR31_U_RND_NID68,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR31_U_RND_NID68",
        .addr = A_POR_MPU_M7_PRLAR31_U_RND_NID68,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_NODE_INFO_U_SMXP_1_0",
        .addr = A_POR_MPU_NODE_INFO_U_SMXP_1_0,
        .reset = 0x202,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MPU_CHILD_INFO_U_SMXP_1_0",
        .addr = A_POR_MPU_CHILD_INFO_U_SMXP_1_0,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MPU_UNIT_INFO_U_SMXP_1_0",
        .addr = A_POR_MPU_UNIT_INFO_U_SMXP_1_0,
        .reset = 0x20,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MPU_M0_CTL_U_SMXP_1_0",
        .addr = A_POR_MPU_M0_CTL_U_SMXP_1_0,
        .reset = 0x2,
        .rsvd = 0xfffffffffffffff8L,
        .ro = 0xfffffffffffffff8L,
    },{ .name = "POR_MPU_M0_PRBAR0_U_SMXP_1_0",
        .addr = A_POR_MPU_M0_PRBAR0_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR0_U_SMXP_1_0",
        .addr = A_POR_MPU_M0_PRLAR0_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR1_U_SMXP_1_0",
        .addr = A_POR_MPU_M0_PRBAR1_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR1_U_SMXP_1_0",
        .addr = A_POR_MPU_M0_PRLAR1_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR2_U_SMXP_1_0",
        .addr = A_POR_MPU_M0_PRBAR2_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR2_U_SMXP_1_0",
        .addr = A_POR_MPU_M0_PRLAR2_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR3_U_SMXP_1_0",
        .addr = A_POR_MPU_M0_PRBAR3_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR3_U_SMXP_1_0",
        .addr = A_POR_MPU_M0_PRLAR3_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR4_U_SMXP_1_0",
        .addr = A_POR_MPU_M0_PRBAR4_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR4_U_SMXP_1_0",
        .addr = A_POR_MPU_M0_PRLAR4_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR5_U_SMXP_1_0",
        .addr = A_POR_MPU_M0_PRBAR5_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR5_U_SMXP_1_0",
        .addr = A_POR_MPU_M0_PRLAR5_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR6_U_SMXP_1_0",
        .addr = A_POR_MPU_M0_PRBAR6_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR6_U_SMXP_1_0",
        .addr = A_POR_MPU_M0_PRLAR6_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR7_U_SMXP_1_0",
        .addr = A_POR_MPU_M0_PRBAR7_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR7_U_SMXP_1_0",
        .addr = A_POR_MPU_M0_PRLAR7_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR8_U_SMXP_1_0",
        .addr = A_POR_MPU_M0_PRBAR8_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR8_U_SMXP_1_0",
        .addr = A_POR_MPU_M0_PRLAR8_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR9_U_SMXP_1_0",
        .addr = A_POR_MPU_M0_PRBAR9_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR9_U_SMXP_1_0",
        .addr = A_POR_MPU_M0_PRLAR9_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR10_U_SMXP_1_0",
        .addr = A_POR_MPU_M0_PRBAR10_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR10_U_SMXP_1_0",
        .addr = A_POR_MPU_M0_PRLAR10_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR11_U_SMXP_1_0",
        .addr = A_POR_MPU_M0_PRBAR11_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR11_U_SMXP_1_0",
        .addr = A_POR_MPU_M0_PRLAR11_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR12_U_SMXP_1_0",
        .addr = A_POR_MPU_M0_PRBAR12_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR12_U_SMXP_1_0",
        .addr = A_POR_MPU_M0_PRLAR12_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR13_U_SMXP_1_0",
        .addr = A_POR_MPU_M0_PRBAR13_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR13_U_SMXP_1_0",
        .addr = A_POR_MPU_M0_PRLAR13_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR14_U_SMXP_1_0",
        .addr = A_POR_MPU_M0_PRBAR14_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR14_U_SMXP_1_0",
        .addr = A_POR_MPU_M0_PRLAR14_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR15_U_SMXP_1_0",
        .addr = A_POR_MPU_M0_PRBAR15_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR15_U_SMXP_1_0",
        .addr = A_POR_MPU_M0_PRLAR15_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR16_U_SMXP_1_0",
        .addr = A_POR_MPU_M0_PRBAR16_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR16_U_SMXP_1_0",
        .addr = A_POR_MPU_M0_PRLAR16_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR17_U_SMXP_1_0",
        .addr = A_POR_MPU_M0_PRBAR17_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR17_U_SMXP_1_0",
        .addr = A_POR_MPU_M0_PRLAR17_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR18_U_SMXP_1_0",
        .addr = A_POR_MPU_M0_PRBAR18_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR18_U_SMXP_1_0",
        .addr = A_POR_MPU_M0_PRLAR18_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR19_U_SMXP_1_0",
        .addr = A_POR_MPU_M0_PRBAR19_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR19_U_SMXP_1_0",
        .addr = A_POR_MPU_M0_PRLAR19_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR20_U_SMXP_1_0",
        .addr = A_POR_MPU_M0_PRBAR20_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR20_U_SMXP_1_0",
        .addr = A_POR_MPU_M0_PRLAR20_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR21_U_SMXP_1_0",
        .addr = A_POR_MPU_M0_PRBAR21_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR21_U_SMXP_1_0",
        .addr = A_POR_MPU_M0_PRLAR21_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR22_U_SMXP_1_0",
        .addr = A_POR_MPU_M0_PRBAR22_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR22_U_SMXP_1_0",
        .addr = A_POR_MPU_M0_PRLAR22_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR23_U_SMXP_1_0",
        .addr = A_POR_MPU_M0_PRBAR23_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR23_U_SMXP_1_0",
        .addr = A_POR_MPU_M0_PRLAR23_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR24_U_SMXP_1_0",
        .addr = A_POR_MPU_M0_PRBAR24_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR24_U_SMXP_1_0",
        .addr = A_POR_MPU_M0_PRLAR24_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR25_U_SMXP_1_0",
        .addr = A_POR_MPU_M0_PRBAR25_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR25_U_SMXP_1_0",
        .addr = A_POR_MPU_M0_PRLAR25_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR26_U_SMXP_1_0",
        .addr = A_POR_MPU_M0_PRBAR26_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR26_U_SMXP_1_0",
        .addr = A_POR_MPU_M0_PRLAR26_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR27_U_SMXP_1_0",
        .addr = A_POR_MPU_M0_PRBAR27_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR27_U_SMXP_1_0",
        .addr = A_POR_MPU_M0_PRLAR27_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR28_U_SMXP_1_0",
        .addr = A_POR_MPU_M0_PRBAR28_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR28_U_SMXP_1_0",
        .addr = A_POR_MPU_M0_PRLAR28_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR29_U_SMXP_1_0",
        .addr = A_POR_MPU_M0_PRBAR29_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR29_U_SMXP_1_0",
        .addr = A_POR_MPU_M0_PRLAR29_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR30_U_SMXP_1_0",
        .addr = A_POR_MPU_M0_PRBAR30_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR30_U_SMXP_1_0",
        .addr = A_POR_MPU_M0_PRLAR30_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR31_U_SMXP_1_0",
        .addr = A_POR_MPU_M0_PRBAR31_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR31_U_SMXP_1_0",
        .addr = A_POR_MPU_M0_PRLAR31_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_CTL_U_SMXP_1_0",
        .addr = A_POR_MPU_M1_CTL_U_SMXP_1_0,
        .reset = 0x2,
        .rsvd = 0xfffffffffffffff8L,
        .ro = 0xfffffffffffffff8L,
    },{ .name = "POR_MPU_M1_PRBAR0_U_SMXP_1_0",
        .addr = A_POR_MPU_M1_PRBAR0_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR0_U_SMXP_1_0",
        .addr = A_POR_MPU_M1_PRLAR0_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR1_U_SMXP_1_0",
        .addr = A_POR_MPU_M1_PRBAR1_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR1_U_SMXP_1_0",
        .addr = A_POR_MPU_M1_PRLAR1_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR2_U_SMXP_1_0",
        .addr = A_POR_MPU_M1_PRBAR2_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR2_U_SMXP_1_0",
        .addr = A_POR_MPU_M1_PRLAR2_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR3_U_SMXP_1_0",
        .addr = A_POR_MPU_M1_PRBAR3_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR3_U_SMXP_1_0",
        .addr = A_POR_MPU_M1_PRLAR3_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR4_U_SMXP_1_0",
        .addr = A_POR_MPU_M1_PRBAR4_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR4_U_SMXP_1_0",
        .addr = A_POR_MPU_M1_PRLAR4_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR5_U_SMXP_1_0",
        .addr = A_POR_MPU_M1_PRBAR5_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR5_U_SMXP_1_0",
        .addr = A_POR_MPU_M1_PRLAR5_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR6_U_SMXP_1_0",
        .addr = A_POR_MPU_M1_PRBAR6_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR6_U_SMXP_1_0",
        .addr = A_POR_MPU_M1_PRLAR6_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR7_U_SMXP_1_0",
        .addr = A_POR_MPU_M1_PRBAR7_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR7_U_SMXP_1_0",
        .addr = A_POR_MPU_M1_PRLAR7_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR8_U_SMXP_1_0",
        .addr = A_POR_MPU_M1_PRBAR8_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR8_U_SMXP_1_0",
        .addr = A_POR_MPU_M1_PRLAR8_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR9_U_SMXP_1_0",
        .addr = A_POR_MPU_M1_PRBAR9_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR9_U_SMXP_1_0",
        .addr = A_POR_MPU_M1_PRLAR9_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR10_U_SMXP_1_0",
        .addr = A_POR_MPU_M1_PRBAR10_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR10_U_SMXP_1_0",
        .addr = A_POR_MPU_M1_PRLAR10_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR11_U_SMXP_1_0",
        .addr = A_POR_MPU_M1_PRBAR11_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR11_U_SMXP_1_0",
        .addr = A_POR_MPU_M1_PRLAR11_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR12_U_SMXP_1_0",
        .addr = A_POR_MPU_M1_PRBAR12_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR12_U_SMXP_1_0",
        .addr = A_POR_MPU_M1_PRLAR12_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR13_U_SMXP_1_0",
        .addr = A_POR_MPU_M1_PRBAR13_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR13_U_SMXP_1_0",
        .addr = A_POR_MPU_M1_PRLAR13_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR14_U_SMXP_1_0",
        .addr = A_POR_MPU_M1_PRBAR14_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR14_U_SMXP_1_0",
        .addr = A_POR_MPU_M1_PRLAR14_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR15_U_SMXP_1_0",
        .addr = A_POR_MPU_M1_PRBAR15_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR15_U_SMXP_1_0",
        .addr = A_POR_MPU_M1_PRLAR15_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR16_U_SMXP_1_0",
        .addr = A_POR_MPU_M1_PRBAR16_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR16_U_SMXP_1_0",
        .addr = A_POR_MPU_M1_PRLAR16_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR17_U_SMXP_1_0",
        .addr = A_POR_MPU_M1_PRBAR17_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR17_U_SMXP_1_0",
        .addr = A_POR_MPU_M1_PRLAR17_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR18_U_SMXP_1_0",
        .addr = A_POR_MPU_M1_PRBAR18_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR18_U_SMXP_1_0",
        .addr = A_POR_MPU_M1_PRLAR18_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR19_U_SMXP_1_0",
        .addr = A_POR_MPU_M1_PRBAR19_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR19_U_SMXP_1_0",
        .addr = A_POR_MPU_M1_PRLAR19_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR20_U_SMXP_1_0",
        .addr = A_POR_MPU_M1_PRBAR20_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR20_U_SMXP_1_0",
        .addr = A_POR_MPU_M1_PRLAR20_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR21_U_SMXP_1_0",
        .addr = A_POR_MPU_M1_PRBAR21_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR21_U_SMXP_1_0",
        .addr = A_POR_MPU_M1_PRLAR21_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR22_U_SMXP_1_0",
        .addr = A_POR_MPU_M1_PRBAR22_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR22_U_SMXP_1_0",
        .addr = A_POR_MPU_M1_PRLAR22_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR23_U_SMXP_1_0",
        .addr = A_POR_MPU_M1_PRBAR23_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR23_U_SMXP_1_0",
        .addr = A_POR_MPU_M1_PRLAR23_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR24_U_SMXP_1_0",
        .addr = A_POR_MPU_M1_PRBAR24_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR24_U_SMXP_1_0",
        .addr = A_POR_MPU_M1_PRLAR24_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR25_U_SMXP_1_0",
        .addr = A_POR_MPU_M1_PRBAR25_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR25_U_SMXP_1_0",
        .addr = A_POR_MPU_M1_PRLAR25_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR26_U_SMXP_1_0",
        .addr = A_POR_MPU_M1_PRBAR26_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR26_U_SMXP_1_0",
        .addr = A_POR_MPU_M1_PRLAR26_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR27_U_SMXP_1_0",
        .addr = A_POR_MPU_M1_PRBAR27_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR27_U_SMXP_1_0",
        .addr = A_POR_MPU_M1_PRLAR27_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR28_U_SMXP_1_0",
        .addr = A_POR_MPU_M1_PRBAR28_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR28_U_SMXP_1_0",
        .addr = A_POR_MPU_M1_PRLAR28_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR29_U_SMXP_1_0",
        .addr = A_POR_MPU_M1_PRBAR29_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR29_U_SMXP_1_0",
        .addr = A_POR_MPU_M1_PRLAR29_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR30_U_SMXP_1_0",
        .addr = A_POR_MPU_M1_PRBAR30_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR30_U_SMXP_1_0",
        .addr = A_POR_MPU_M1_PRLAR30_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR31_U_SMXP_1_0",
        .addr = A_POR_MPU_M1_PRBAR31_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR31_U_SMXP_1_0",
        .addr = A_POR_MPU_M1_PRLAR31_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_CTL_U_SMXP_1_0",
        .addr = A_POR_MPU_M2_CTL_U_SMXP_1_0,
        .reset = 0x2,
        .rsvd = 0xfffffffffffffff8L,
        .ro = 0xfffffffffffffff8L,
    },{ .name = "POR_MPU_M2_PRBAR0_U_SMXP_1_0",
        .addr = A_POR_MPU_M2_PRBAR0_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR0_U_SMXP_1_0",
        .addr = A_POR_MPU_M2_PRLAR0_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR1_U_SMXP_1_0",
        .addr = A_POR_MPU_M2_PRBAR1_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR1_U_SMXP_1_0",
        .addr = A_POR_MPU_M2_PRLAR1_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR2_U_SMXP_1_0",
        .addr = A_POR_MPU_M2_PRBAR2_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR2_U_SMXP_1_0",
        .addr = A_POR_MPU_M2_PRLAR2_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR3_U_SMXP_1_0",
        .addr = A_POR_MPU_M2_PRBAR3_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR3_U_SMXP_1_0",
        .addr = A_POR_MPU_M2_PRLAR3_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR4_U_SMXP_1_0",
        .addr = A_POR_MPU_M2_PRBAR4_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR4_U_SMXP_1_0",
        .addr = A_POR_MPU_M2_PRLAR4_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR5_U_SMXP_1_0",
        .addr = A_POR_MPU_M2_PRBAR5_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR5_U_SMXP_1_0",
        .addr = A_POR_MPU_M2_PRLAR5_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR6_U_SMXP_1_0",
        .addr = A_POR_MPU_M2_PRBAR6_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR6_U_SMXP_1_0",
        .addr = A_POR_MPU_M2_PRLAR6_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR7_U_SMXP_1_0",
        .addr = A_POR_MPU_M2_PRBAR7_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR7_U_SMXP_1_0",
        .addr = A_POR_MPU_M2_PRLAR7_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR8_U_SMXP_1_0",
        .addr = A_POR_MPU_M2_PRBAR8_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR8_U_SMXP_1_0",
        .addr = A_POR_MPU_M2_PRLAR8_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR9_U_SMXP_1_0",
        .addr = A_POR_MPU_M2_PRBAR9_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR9_U_SMXP_1_0",
        .addr = A_POR_MPU_M2_PRLAR9_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR10_U_SMXP_1_0",
        .addr = A_POR_MPU_M2_PRBAR10_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR10_U_SMXP_1_0",
        .addr = A_POR_MPU_M2_PRLAR10_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR11_U_SMXP_1_0",
        .addr = A_POR_MPU_M2_PRBAR11_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR11_U_SMXP_1_0",
        .addr = A_POR_MPU_M2_PRLAR11_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR12_U_SMXP_1_0",
        .addr = A_POR_MPU_M2_PRBAR12_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR12_U_SMXP_1_0",
        .addr = A_POR_MPU_M2_PRLAR12_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR13_U_SMXP_1_0",
        .addr = A_POR_MPU_M2_PRBAR13_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR13_U_SMXP_1_0",
        .addr = A_POR_MPU_M2_PRLAR13_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR14_U_SMXP_1_0",
        .addr = A_POR_MPU_M2_PRBAR14_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR14_U_SMXP_1_0",
        .addr = A_POR_MPU_M2_PRLAR14_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR15_U_SMXP_1_0",
        .addr = A_POR_MPU_M2_PRBAR15_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR15_U_SMXP_1_0",
        .addr = A_POR_MPU_M2_PRLAR15_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR16_U_SMXP_1_0",
        .addr = A_POR_MPU_M2_PRBAR16_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR16_U_SMXP_1_0",
        .addr = A_POR_MPU_M2_PRLAR16_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR17_U_SMXP_1_0",
        .addr = A_POR_MPU_M2_PRBAR17_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR17_U_SMXP_1_0",
        .addr = A_POR_MPU_M2_PRLAR17_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR18_U_SMXP_1_0",
        .addr = A_POR_MPU_M2_PRBAR18_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR18_U_SMXP_1_0",
        .addr = A_POR_MPU_M2_PRLAR18_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR19_U_SMXP_1_0",
        .addr = A_POR_MPU_M2_PRBAR19_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR19_U_SMXP_1_0",
        .addr = A_POR_MPU_M2_PRLAR19_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR20_U_SMXP_1_0",
        .addr = A_POR_MPU_M2_PRBAR20_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR20_U_SMXP_1_0",
        .addr = A_POR_MPU_M2_PRLAR20_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR21_U_SMXP_1_0",
        .addr = A_POR_MPU_M2_PRBAR21_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR21_U_SMXP_1_0",
        .addr = A_POR_MPU_M2_PRLAR21_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR22_U_SMXP_1_0",
        .addr = A_POR_MPU_M2_PRBAR22_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR22_U_SMXP_1_0",
        .addr = A_POR_MPU_M2_PRLAR22_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR23_U_SMXP_1_0",
        .addr = A_POR_MPU_M2_PRBAR23_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR23_U_SMXP_1_0",
        .addr = A_POR_MPU_M2_PRLAR23_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR24_U_SMXP_1_0",
        .addr = A_POR_MPU_M2_PRBAR24_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR24_U_SMXP_1_0",
        .addr = A_POR_MPU_M2_PRLAR24_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR25_U_SMXP_1_0",
        .addr = A_POR_MPU_M2_PRBAR25_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR25_U_SMXP_1_0",
        .addr = A_POR_MPU_M2_PRLAR25_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR26_U_SMXP_1_0",
        .addr = A_POR_MPU_M2_PRBAR26_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR26_U_SMXP_1_0",
        .addr = A_POR_MPU_M2_PRLAR26_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR27_U_SMXP_1_0",
        .addr = A_POR_MPU_M2_PRBAR27_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR27_U_SMXP_1_0",
        .addr = A_POR_MPU_M2_PRLAR27_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR28_U_SMXP_1_0",
        .addr = A_POR_MPU_M2_PRBAR28_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR28_U_SMXP_1_0",
        .addr = A_POR_MPU_M2_PRLAR28_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR29_U_SMXP_1_0",
        .addr = A_POR_MPU_M2_PRBAR29_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR29_U_SMXP_1_0",
        .addr = A_POR_MPU_M2_PRLAR29_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR30_U_SMXP_1_0",
        .addr = A_POR_MPU_M2_PRBAR30_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR30_U_SMXP_1_0",
        .addr = A_POR_MPU_M2_PRLAR30_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR31_U_SMXP_1_0",
        .addr = A_POR_MPU_M2_PRBAR31_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR31_U_SMXP_1_0",
        .addr = A_POR_MPU_M2_PRLAR31_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_CTL_U_SMXP_1_0",
        .addr = A_POR_MPU_M3_CTL_U_SMXP_1_0,
        .reset = 0x2,
        .rsvd = 0xfffffffffffffff8L,
        .ro = 0xfffffffffffffff8L,
    },{ .name = "POR_MPU_M3_PRBAR0_U_SMXP_1_0",
        .addr = A_POR_MPU_M3_PRBAR0_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR0_U_SMXP_1_0",
        .addr = A_POR_MPU_M3_PRLAR0_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR1_U_SMXP_1_0",
        .addr = A_POR_MPU_M3_PRBAR1_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR1_U_SMXP_1_0",
        .addr = A_POR_MPU_M3_PRLAR1_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR2_U_SMXP_1_0",
        .addr = A_POR_MPU_M3_PRBAR2_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR2_U_SMXP_1_0",
        .addr = A_POR_MPU_M3_PRLAR2_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR3_U_SMXP_1_0",
        .addr = A_POR_MPU_M3_PRBAR3_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR3_U_SMXP_1_0",
        .addr = A_POR_MPU_M3_PRLAR3_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR4_U_SMXP_1_0",
        .addr = A_POR_MPU_M3_PRBAR4_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR4_U_SMXP_1_0",
        .addr = A_POR_MPU_M3_PRLAR4_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR5_U_SMXP_1_0",
        .addr = A_POR_MPU_M3_PRBAR5_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR5_U_SMXP_1_0",
        .addr = A_POR_MPU_M3_PRLAR5_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR6_U_SMXP_1_0",
        .addr = A_POR_MPU_M3_PRBAR6_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR6_U_SMXP_1_0",
        .addr = A_POR_MPU_M3_PRLAR6_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR7_U_SMXP_1_0",
        .addr = A_POR_MPU_M3_PRBAR7_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR7_U_SMXP_1_0",
        .addr = A_POR_MPU_M3_PRLAR7_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR8_U_SMXP_1_0",
        .addr = A_POR_MPU_M3_PRBAR8_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR8_U_SMXP_1_0",
        .addr = A_POR_MPU_M3_PRLAR8_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR9_U_SMXP_1_0",
        .addr = A_POR_MPU_M3_PRBAR9_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR9_U_SMXP_1_0",
        .addr = A_POR_MPU_M3_PRLAR9_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR10_U_SMXP_1_0",
        .addr = A_POR_MPU_M3_PRBAR10_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR10_U_SMXP_1_0",
        .addr = A_POR_MPU_M3_PRLAR10_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR11_U_SMXP_1_0",
        .addr = A_POR_MPU_M3_PRBAR11_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR11_U_SMXP_1_0",
        .addr = A_POR_MPU_M3_PRLAR11_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR12_U_SMXP_1_0",
        .addr = A_POR_MPU_M3_PRBAR12_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR12_U_SMXP_1_0",
        .addr = A_POR_MPU_M3_PRLAR12_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR13_U_SMXP_1_0",
        .addr = A_POR_MPU_M3_PRBAR13_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR13_U_SMXP_1_0",
        .addr = A_POR_MPU_M3_PRLAR13_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR14_U_SMXP_1_0",
        .addr = A_POR_MPU_M3_PRBAR14_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR14_U_SMXP_1_0",
        .addr = A_POR_MPU_M3_PRLAR14_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR15_U_SMXP_1_0",
        .addr = A_POR_MPU_M3_PRBAR15_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR15_U_SMXP_1_0",
        .addr = A_POR_MPU_M3_PRLAR15_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR16_U_SMXP_1_0",
        .addr = A_POR_MPU_M3_PRBAR16_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR16_U_SMXP_1_0",
        .addr = A_POR_MPU_M3_PRLAR16_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR17_U_SMXP_1_0",
        .addr = A_POR_MPU_M3_PRBAR17_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR17_U_SMXP_1_0",
        .addr = A_POR_MPU_M3_PRLAR17_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR18_U_SMXP_1_0",
        .addr = A_POR_MPU_M3_PRBAR18_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR18_U_SMXP_1_0",
        .addr = A_POR_MPU_M3_PRLAR18_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR19_U_SMXP_1_0",
        .addr = A_POR_MPU_M3_PRBAR19_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR19_U_SMXP_1_0",
        .addr = A_POR_MPU_M3_PRLAR19_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR20_U_SMXP_1_0",
        .addr = A_POR_MPU_M3_PRBAR20_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR20_U_SMXP_1_0",
        .addr = A_POR_MPU_M3_PRLAR20_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR21_U_SMXP_1_0",
        .addr = A_POR_MPU_M3_PRBAR21_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR21_U_SMXP_1_0",
        .addr = A_POR_MPU_M3_PRLAR21_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR22_U_SMXP_1_0",
        .addr = A_POR_MPU_M3_PRBAR22_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR22_U_SMXP_1_0",
        .addr = A_POR_MPU_M3_PRLAR22_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR23_U_SMXP_1_0",
        .addr = A_POR_MPU_M3_PRBAR23_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR23_U_SMXP_1_0",
        .addr = A_POR_MPU_M3_PRLAR23_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR24_U_SMXP_1_0",
        .addr = A_POR_MPU_M3_PRBAR24_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR24_U_SMXP_1_0",
        .addr = A_POR_MPU_M3_PRLAR24_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR25_U_SMXP_1_0",
        .addr = A_POR_MPU_M3_PRBAR25_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR25_U_SMXP_1_0",
        .addr = A_POR_MPU_M3_PRLAR25_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR26_U_SMXP_1_0",
        .addr = A_POR_MPU_M3_PRBAR26_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR26_U_SMXP_1_0",
        .addr = A_POR_MPU_M3_PRLAR26_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR27_U_SMXP_1_0",
        .addr = A_POR_MPU_M3_PRBAR27_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR27_U_SMXP_1_0",
        .addr = A_POR_MPU_M3_PRLAR27_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR28_U_SMXP_1_0",
        .addr = A_POR_MPU_M3_PRBAR28_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR28_U_SMXP_1_0",
        .addr = A_POR_MPU_M3_PRLAR28_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR29_U_SMXP_1_0",
        .addr = A_POR_MPU_M3_PRBAR29_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR29_U_SMXP_1_0",
        .addr = A_POR_MPU_M3_PRLAR29_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR30_U_SMXP_1_0",
        .addr = A_POR_MPU_M3_PRBAR30_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR30_U_SMXP_1_0",
        .addr = A_POR_MPU_M3_PRLAR30_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR31_U_SMXP_1_0",
        .addr = A_POR_MPU_M3_PRBAR31_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR31_U_SMXP_1_0",
        .addr = A_POR_MPU_M3_PRLAR31_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_CTL_U_SMXP_1_0",
        .addr = A_POR_MPU_M4_CTL_U_SMXP_1_0,
        .reset = 0x2,
        .rsvd = 0xfffffffffffffff8L,
        .ro = 0xfffffffffffffff8L,
    },{ .name = "POR_MPU_M4_PRBAR0_U_SMXP_1_0",
        .addr = A_POR_MPU_M4_PRBAR0_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR0_U_SMXP_1_0",
        .addr = A_POR_MPU_M4_PRLAR0_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR1_U_SMXP_1_0",
        .addr = A_POR_MPU_M4_PRBAR1_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR1_U_SMXP_1_0",
        .addr = A_POR_MPU_M4_PRLAR1_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR2_U_SMXP_1_0",
        .addr = A_POR_MPU_M4_PRBAR2_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR2_U_SMXP_1_0",
        .addr = A_POR_MPU_M4_PRLAR2_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR3_U_SMXP_1_0",
        .addr = A_POR_MPU_M4_PRBAR3_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR3_U_SMXP_1_0",
        .addr = A_POR_MPU_M4_PRLAR3_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR4_U_SMXP_1_0",
        .addr = A_POR_MPU_M4_PRBAR4_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR4_U_SMXP_1_0",
        .addr = A_POR_MPU_M4_PRLAR4_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR5_U_SMXP_1_0",
        .addr = A_POR_MPU_M4_PRBAR5_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR5_U_SMXP_1_0",
        .addr = A_POR_MPU_M4_PRLAR5_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR6_U_SMXP_1_0",
        .addr = A_POR_MPU_M4_PRBAR6_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR6_U_SMXP_1_0",
        .addr = A_POR_MPU_M4_PRLAR6_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR7_U_SMXP_1_0",
        .addr = A_POR_MPU_M4_PRBAR7_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR7_U_SMXP_1_0",
        .addr = A_POR_MPU_M4_PRLAR7_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR8_U_SMXP_1_0",
        .addr = A_POR_MPU_M4_PRBAR8_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR8_U_SMXP_1_0",
        .addr = A_POR_MPU_M4_PRLAR8_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR9_U_SMXP_1_0",
        .addr = A_POR_MPU_M4_PRBAR9_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR9_U_SMXP_1_0",
        .addr = A_POR_MPU_M4_PRLAR9_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR10_U_SMXP_1_0",
        .addr = A_POR_MPU_M4_PRBAR10_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR10_U_SMXP_1_0",
        .addr = A_POR_MPU_M4_PRLAR10_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR11_U_SMXP_1_0",
        .addr = A_POR_MPU_M4_PRBAR11_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR11_U_SMXP_1_0",
        .addr = A_POR_MPU_M4_PRLAR11_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR12_U_SMXP_1_0",
        .addr = A_POR_MPU_M4_PRBAR12_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR12_U_SMXP_1_0",
        .addr = A_POR_MPU_M4_PRLAR12_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR13_U_SMXP_1_0",
        .addr = A_POR_MPU_M4_PRBAR13_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR13_U_SMXP_1_0",
        .addr = A_POR_MPU_M4_PRLAR13_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR14_U_SMXP_1_0",
        .addr = A_POR_MPU_M4_PRBAR14_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR14_U_SMXP_1_0",
        .addr = A_POR_MPU_M4_PRLAR14_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR15_U_SMXP_1_0",
        .addr = A_POR_MPU_M4_PRBAR15_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR15_U_SMXP_1_0",
        .addr = A_POR_MPU_M4_PRLAR15_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR16_U_SMXP_1_0",
        .addr = A_POR_MPU_M4_PRBAR16_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR16_U_SMXP_1_0",
        .addr = A_POR_MPU_M4_PRLAR16_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR17_U_SMXP_1_0",
        .addr = A_POR_MPU_M4_PRBAR17_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR17_U_SMXP_1_0",
        .addr = A_POR_MPU_M4_PRLAR17_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR18_U_SMXP_1_0",
        .addr = A_POR_MPU_M4_PRBAR18_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR18_U_SMXP_1_0",
        .addr = A_POR_MPU_M4_PRLAR18_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR19_U_SMXP_1_0",
        .addr = A_POR_MPU_M4_PRBAR19_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR19_U_SMXP_1_0",
        .addr = A_POR_MPU_M4_PRLAR19_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR20_U_SMXP_1_0",
        .addr = A_POR_MPU_M4_PRBAR20_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR20_U_SMXP_1_0",
        .addr = A_POR_MPU_M4_PRLAR20_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR21_U_SMXP_1_0",
        .addr = A_POR_MPU_M4_PRBAR21_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR21_U_SMXP_1_0",
        .addr = A_POR_MPU_M4_PRLAR21_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR22_U_SMXP_1_0",
        .addr = A_POR_MPU_M4_PRBAR22_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR22_U_SMXP_1_0",
        .addr = A_POR_MPU_M4_PRLAR22_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR23_U_SMXP_1_0",
        .addr = A_POR_MPU_M4_PRBAR23_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR23_U_SMXP_1_0",
        .addr = A_POR_MPU_M4_PRLAR23_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR24_U_SMXP_1_0",
        .addr = A_POR_MPU_M4_PRBAR24_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR24_U_SMXP_1_0",
        .addr = A_POR_MPU_M4_PRLAR24_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR25_U_SMXP_1_0",
        .addr = A_POR_MPU_M4_PRBAR25_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR25_U_SMXP_1_0",
        .addr = A_POR_MPU_M4_PRLAR25_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR26_U_SMXP_1_0",
        .addr = A_POR_MPU_M4_PRBAR26_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR26_U_SMXP_1_0",
        .addr = A_POR_MPU_M4_PRLAR26_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR27_U_SMXP_1_0",
        .addr = A_POR_MPU_M4_PRBAR27_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR27_U_SMXP_1_0",
        .addr = A_POR_MPU_M4_PRLAR27_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR28_U_SMXP_1_0",
        .addr = A_POR_MPU_M4_PRBAR28_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR28_U_SMXP_1_0",
        .addr = A_POR_MPU_M4_PRLAR28_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR29_U_SMXP_1_0",
        .addr = A_POR_MPU_M4_PRBAR29_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR29_U_SMXP_1_0",
        .addr = A_POR_MPU_M4_PRLAR29_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR30_U_SMXP_1_0",
        .addr = A_POR_MPU_M4_PRBAR30_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR30_U_SMXP_1_0",
        .addr = A_POR_MPU_M4_PRLAR30_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR31_U_SMXP_1_0",
        .addr = A_POR_MPU_M4_PRBAR31_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR31_U_SMXP_1_0",
        .addr = A_POR_MPU_M4_PRLAR31_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_CTL_U_SMXP_1_0",
        .addr = A_POR_MPU_M5_CTL_U_SMXP_1_0,
        .reset = 0x2,
        .rsvd = 0xfffffffffffffff8L,
        .ro = 0xfffffffffffffff8L,
    },{ .name = "POR_MPU_M5_PRBAR0_U_SMXP_1_0",
        .addr = A_POR_MPU_M5_PRBAR0_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR0_U_SMXP_1_0",
        .addr = A_POR_MPU_M5_PRLAR0_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR1_U_SMXP_1_0",
        .addr = A_POR_MPU_M5_PRBAR1_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR1_U_SMXP_1_0",
        .addr = A_POR_MPU_M5_PRLAR1_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR2_U_SMXP_1_0",
        .addr = A_POR_MPU_M5_PRBAR2_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR2_U_SMXP_1_0",
        .addr = A_POR_MPU_M5_PRLAR2_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR3_U_SMXP_1_0",
        .addr = A_POR_MPU_M5_PRBAR3_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR3_U_SMXP_1_0",
        .addr = A_POR_MPU_M5_PRLAR3_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR4_U_SMXP_1_0",
        .addr = A_POR_MPU_M5_PRBAR4_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR4_U_SMXP_1_0",
        .addr = A_POR_MPU_M5_PRLAR4_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR5_U_SMXP_1_0",
        .addr = A_POR_MPU_M5_PRBAR5_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR5_U_SMXP_1_0",
        .addr = A_POR_MPU_M5_PRLAR5_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR6_U_SMXP_1_0",
        .addr = A_POR_MPU_M5_PRBAR6_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR6_U_SMXP_1_0",
        .addr = A_POR_MPU_M5_PRLAR6_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR7_U_SMXP_1_0",
        .addr = A_POR_MPU_M5_PRBAR7_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR7_U_SMXP_1_0",
        .addr = A_POR_MPU_M5_PRLAR7_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR8_U_SMXP_1_0",
        .addr = A_POR_MPU_M5_PRBAR8_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR8_U_SMXP_1_0",
        .addr = A_POR_MPU_M5_PRLAR8_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR9_U_SMXP_1_0",
        .addr = A_POR_MPU_M5_PRBAR9_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR9_U_SMXP_1_0",
        .addr = A_POR_MPU_M5_PRLAR9_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR10_U_SMXP_1_0",
        .addr = A_POR_MPU_M5_PRBAR10_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR10_U_SMXP_1_0",
        .addr = A_POR_MPU_M5_PRLAR10_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR11_U_SMXP_1_0",
        .addr = A_POR_MPU_M5_PRBAR11_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR11_U_SMXP_1_0",
        .addr = A_POR_MPU_M5_PRLAR11_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR12_U_SMXP_1_0",
        .addr = A_POR_MPU_M5_PRBAR12_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR12_U_SMXP_1_0",
        .addr = A_POR_MPU_M5_PRLAR12_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR13_U_SMXP_1_0",
        .addr = A_POR_MPU_M5_PRBAR13_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR13_U_SMXP_1_0",
        .addr = A_POR_MPU_M5_PRLAR13_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR14_U_SMXP_1_0",
        .addr = A_POR_MPU_M5_PRBAR14_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR14_U_SMXP_1_0",
        .addr = A_POR_MPU_M5_PRLAR14_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR15_U_SMXP_1_0",
        .addr = A_POR_MPU_M5_PRBAR15_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR15_U_SMXP_1_0",
        .addr = A_POR_MPU_M5_PRLAR15_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR16_U_SMXP_1_0",
        .addr = A_POR_MPU_M5_PRBAR16_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR16_U_SMXP_1_0",
        .addr = A_POR_MPU_M5_PRLAR16_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR17_U_SMXP_1_0",
        .addr = A_POR_MPU_M5_PRBAR17_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR17_U_SMXP_1_0",
        .addr = A_POR_MPU_M5_PRLAR17_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR18_U_SMXP_1_0",
        .addr = A_POR_MPU_M5_PRBAR18_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR18_U_SMXP_1_0",
        .addr = A_POR_MPU_M5_PRLAR18_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR19_U_SMXP_1_0",
        .addr = A_POR_MPU_M5_PRBAR19_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR19_U_SMXP_1_0",
        .addr = A_POR_MPU_M5_PRLAR19_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR20_U_SMXP_1_0",
        .addr = A_POR_MPU_M5_PRBAR20_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR20_U_SMXP_1_0",
        .addr = A_POR_MPU_M5_PRLAR20_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR21_U_SMXP_1_0",
        .addr = A_POR_MPU_M5_PRBAR21_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR21_U_SMXP_1_0",
        .addr = A_POR_MPU_M5_PRLAR21_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR22_U_SMXP_1_0",
        .addr = A_POR_MPU_M5_PRBAR22_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR22_U_SMXP_1_0",
        .addr = A_POR_MPU_M5_PRLAR22_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR23_U_SMXP_1_0",
        .addr = A_POR_MPU_M5_PRBAR23_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR23_U_SMXP_1_0",
        .addr = A_POR_MPU_M5_PRLAR23_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR24_U_SMXP_1_0",
        .addr = A_POR_MPU_M5_PRBAR24_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR24_U_SMXP_1_0",
        .addr = A_POR_MPU_M5_PRLAR24_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR25_U_SMXP_1_0",
        .addr = A_POR_MPU_M5_PRBAR25_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR25_U_SMXP_1_0",
        .addr = A_POR_MPU_M5_PRLAR25_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR26_U_SMXP_1_0",
        .addr = A_POR_MPU_M5_PRBAR26_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR26_U_SMXP_1_0",
        .addr = A_POR_MPU_M5_PRLAR26_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR27_U_SMXP_1_0",
        .addr = A_POR_MPU_M5_PRBAR27_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR27_U_SMXP_1_0",
        .addr = A_POR_MPU_M5_PRLAR27_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR28_U_SMXP_1_0",
        .addr = A_POR_MPU_M5_PRBAR28_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR28_U_SMXP_1_0",
        .addr = A_POR_MPU_M5_PRLAR28_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR29_U_SMXP_1_0",
        .addr = A_POR_MPU_M5_PRBAR29_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR29_U_SMXP_1_0",
        .addr = A_POR_MPU_M5_PRLAR29_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR30_U_SMXP_1_0",
        .addr = A_POR_MPU_M5_PRBAR30_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR30_U_SMXP_1_0",
        .addr = A_POR_MPU_M5_PRLAR30_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR31_U_SMXP_1_0",
        .addr = A_POR_MPU_M5_PRBAR31_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR31_U_SMXP_1_0",
        .addr = A_POR_MPU_M5_PRLAR31_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_CTL_U_SMXP_1_0",
        .addr = A_POR_MPU_M6_CTL_U_SMXP_1_0,
        .reset = 0x2,
        .rsvd = 0xfffffffffffffff8L,
        .ro = 0xfffffffffffffff8L,
    },{ .name = "POR_MPU_M6_PRBAR0_U_SMXP_1_0",
        .addr = A_POR_MPU_M6_PRBAR0_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR0_U_SMXP_1_0",
        .addr = A_POR_MPU_M6_PRLAR0_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR1_U_SMXP_1_0",
        .addr = A_POR_MPU_M6_PRBAR1_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR1_U_SMXP_1_0",
        .addr = A_POR_MPU_M6_PRLAR1_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR2_U_SMXP_1_0",
        .addr = A_POR_MPU_M6_PRBAR2_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR2_U_SMXP_1_0",
        .addr = A_POR_MPU_M6_PRLAR2_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR3_U_SMXP_1_0",
        .addr = A_POR_MPU_M6_PRBAR3_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR3_U_SMXP_1_0",
        .addr = A_POR_MPU_M6_PRLAR3_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR4_U_SMXP_1_0",
        .addr = A_POR_MPU_M6_PRBAR4_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR4_U_SMXP_1_0",
        .addr = A_POR_MPU_M6_PRLAR4_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR5_U_SMXP_1_0",
        .addr = A_POR_MPU_M6_PRBAR5_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR5_U_SMXP_1_0",
        .addr = A_POR_MPU_M6_PRLAR5_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR6_U_SMXP_1_0",
        .addr = A_POR_MPU_M6_PRBAR6_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR6_U_SMXP_1_0",
        .addr = A_POR_MPU_M6_PRLAR6_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR7_U_SMXP_1_0",
        .addr = A_POR_MPU_M6_PRBAR7_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR7_U_SMXP_1_0",
        .addr = A_POR_MPU_M6_PRLAR7_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR8_U_SMXP_1_0",
        .addr = A_POR_MPU_M6_PRBAR8_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR8_U_SMXP_1_0",
        .addr = A_POR_MPU_M6_PRLAR8_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR9_U_SMXP_1_0",
        .addr = A_POR_MPU_M6_PRBAR9_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR9_U_SMXP_1_0",
        .addr = A_POR_MPU_M6_PRLAR9_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR10_U_SMXP_1_0",
        .addr = A_POR_MPU_M6_PRBAR10_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR10_U_SMXP_1_0",
        .addr = A_POR_MPU_M6_PRLAR10_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR11_U_SMXP_1_0",
        .addr = A_POR_MPU_M6_PRBAR11_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR11_U_SMXP_1_0",
        .addr = A_POR_MPU_M6_PRLAR11_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR12_U_SMXP_1_0",
        .addr = A_POR_MPU_M6_PRBAR12_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR12_U_SMXP_1_0",
        .addr = A_POR_MPU_M6_PRLAR12_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR13_U_SMXP_1_0",
        .addr = A_POR_MPU_M6_PRBAR13_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR13_U_SMXP_1_0",
        .addr = A_POR_MPU_M6_PRLAR13_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR14_U_SMXP_1_0",
        .addr = A_POR_MPU_M6_PRBAR14_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR14_U_SMXP_1_0",
        .addr = A_POR_MPU_M6_PRLAR14_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR15_U_SMXP_1_0",
        .addr = A_POR_MPU_M6_PRBAR15_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR15_U_SMXP_1_0",
        .addr = A_POR_MPU_M6_PRLAR15_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR16_U_SMXP_1_0",
        .addr = A_POR_MPU_M6_PRBAR16_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR16_U_SMXP_1_0",
        .addr = A_POR_MPU_M6_PRLAR16_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR17_U_SMXP_1_0",
        .addr = A_POR_MPU_M6_PRBAR17_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR17_U_SMXP_1_0",
        .addr = A_POR_MPU_M6_PRLAR17_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR18_U_SMXP_1_0",
        .addr = A_POR_MPU_M6_PRBAR18_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR18_U_SMXP_1_0",
        .addr = A_POR_MPU_M6_PRLAR18_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR19_U_SMXP_1_0",
        .addr = A_POR_MPU_M6_PRBAR19_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR19_U_SMXP_1_0",
        .addr = A_POR_MPU_M6_PRLAR19_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR20_U_SMXP_1_0",
        .addr = A_POR_MPU_M6_PRBAR20_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR20_U_SMXP_1_0",
        .addr = A_POR_MPU_M6_PRLAR20_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR21_U_SMXP_1_0",
        .addr = A_POR_MPU_M6_PRBAR21_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR21_U_SMXP_1_0",
        .addr = A_POR_MPU_M6_PRLAR21_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR22_U_SMXP_1_0",
        .addr = A_POR_MPU_M6_PRBAR22_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR22_U_SMXP_1_0",
        .addr = A_POR_MPU_M6_PRLAR22_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR23_U_SMXP_1_0",
        .addr = A_POR_MPU_M6_PRBAR23_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR23_U_SMXP_1_0",
        .addr = A_POR_MPU_M6_PRLAR23_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR24_U_SMXP_1_0",
        .addr = A_POR_MPU_M6_PRBAR24_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR24_U_SMXP_1_0",
        .addr = A_POR_MPU_M6_PRLAR24_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR25_U_SMXP_1_0",
        .addr = A_POR_MPU_M6_PRBAR25_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR25_U_SMXP_1_0",
        .addr = A_POR_MPU_M6_PRLAR25_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR26_U_SMXP_1_0",
        .addr = A_POR_MPU_M6_PRBAR26_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR26_U_SMXP_1_0",
        .addr = A_POR_MPU_M6_PRLAR26_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR27_U_SMXP_1_0",
        .addr = A_POR_MPU_M6_PRBAR27_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR27_U_SMXP_1_0",
        .addr = A_POR_MPU_M6_PRLAR27_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR28_U_SMXP_1_0",
        .addr = A_POR_MPU_M6_PRBAR28_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR28_U_SMXP_1_0",
        .addr = A_POR_MPU_M6_PRLAR28_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR29_U_SMXP_1_0",
        .addr = A_POR_MPU_M6_PRBAR29_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR29_U_SMXP_1_0",
        .addr = A_POR_MPU_M6_PRLAR29_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR30_U_SMXP_1_0",
        .addr = A_POR_MPU_M6_PRBAR30_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR30_U_SMXP_1_0",
        .addr = A_POR_MPU_M6_PRLAR30_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR31_U_SMXP_1_0",
        .addr = A_POR_MPU_M6_PRBAR31_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR31_U_SMXP_1_0",
        .addr = A_POR_MPU_M6_PRLAR31_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_CTL_U_SMXP_1_0",
        .addr = A_POR_MPU_M7_CTL_U_SMXP_1_0,
        .reset = 0x2,
        .rsvd = 0xfffffffffffffff8L,
        .ro = 0xfffffffffffffff8L,
    },{ .name = "POR_MPU_M7_PRBAR0_U_SMXP_1_0",
        .addr = A_POR_MPU_M7_PRBAR0_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR0_U_SMXP_1_0",
        .addr = A_POR_MPU_M7_PRLAR0_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR1_U_SMXP_1_0",
        .addr = A_POR_MPU_M7_PRBAR1_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR1_U_SMXP_1_0",
        .addr = A_POR_MPU_M7_PRLAR1_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR2_U_SMXP_1_0",
        .addr = A_POR_MPU_M7_PRBAR2_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR2_U_SMXP_1_0",
        .addr = A_POR_MPU_M7_PRLAR2_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR3_U_SMXP_1_0",
        .addr = A_POR_MPU_M7_PRBAR3_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR3_U_SMXP_1_0",
        .addr = A_POR_MPU_M7_PRLAR3_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR4_U_SMXP_1_0",
        .addr = A_POR_MPU_M7_PRBAR4_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR4_U_SMXP_1_0",
        .addr = A_POR_MPU_M7_PRLAR4_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR5_U_SMXP_1_0",
        .addr = A_POR_MPU_M7_PRBAR5_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR5_U_SMXP_1_0",
        .addr = A_POR_MPU_M7_PRLAR5_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR6_U_SMXP_1_0",
        .addr = A_POR_MPU_M7_PRBAR6_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR6_U_SMXP_1_0",
        .addr = A_POR_MPU_M7_PRLAR6_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR7_U_SMXP_1_0",
        .addr = A_POR_MPU_M7_PRBAR7_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR7_U_SMXP_1_0",
        .addr = A_POR_MPU_M7_PRLAR7_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR8_U_SMXP_1_0",
        .addr = A_POR_MPU_M7_PRBAR8_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR8_U_SMXP_1_0",
        .addr = A_POR_MPU_M7_PRLAR8_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR9_U_SMXP_1_0",
        .addr = A_POR_MPU_M7_PRBAR9_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR9_U_SMXP_1_0",
        .addr = A_POR_MPU_M7_PRLAR9_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR10_U_SMXP_1_0",
        .addr = A_POR_MPU_M7_PRBAR10_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR10_U_SMXP_1_0",
        .addr = A_POR_MPU_M7_PRLAR10_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR11_U_SMXP_1_0",
        .addr = A_POR_MPU_M7_PRBAR11_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR11_U_SMXP_1_0",
        .addr = A_POR_MPU_M7_PRLAR11_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR12_U_SMXP_1_0",
        .addr = A_POR_MPU_M7_PRBAR12_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR12_U_SMXP_1_0",
        .addr = A_POR_MPU_M7_PRLAR12_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR13_U_SMXP_1_0",
        .addr = A_POR_MPU_M7_PRBAR13_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR13_U_SMXP_1_0",
        .addr = A_POR_MPU_M7_PRLAR13_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR14_U_SMXP_1_0",
        .addr = A_POR_MPU_M7_PRBAR14_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR14_U_SMXP_1_0",
        .addr = A_POR_MPU_M7_PRLAR14_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR15_U_SMXP_1_0",
        .addr = A_POR_MPU_M7_PRBAR15_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR15_U_SMXP_1_0",
        .addr = A_POR_MPU_M7_PRLAR15_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR16_U_SMXP_1_0",
        .addr = A_POR_MPU_M7_PRBAR16_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR16_U_SMXP_1_0",
        .addr = A_POR_MPU_M7_PRLAR16_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR17_U_SMXP_1_0",
        .addr = A_POR_MPU_M7_PRBAR17_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR17_U_SMXP_1_0",
        .addr = A_POR_MPU_M7_PRLAR17_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR18_U_SMXP_1_0",
        .addr = A_POR_MPU_M7_PRBAR18_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR18_U_SMXP_1_0",
        .addr = A_POR_MPU_M7_PRLAR18_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR19_U_SMXP_1_0",
        .addr = A_POR_MPU_M7_PRBAR19_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR19_U_SMXP_1_0",
        .addr = A_POR_MPU_M7_PRLAR19_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR20_U_SMXP_1_0",
        .addr = A_POR_MPU_M7_PRBAR20_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR20_U_SMXP_1_0",
        .addr = A_POR_MPU_M7_PRLAR20_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR21_U_SMXP_1_0",
        .addr = A_POR_MPU_M7_PRBAR21_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR21_U_SMXP_1_0",
        .addr = A_POR_MPU_M7_PRLAR21_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR22_U_SMXP_1_0",
        .addr = A_POR_MPU_M7_PRBAR22_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR22_U_SMXP_1_0",
        .addr = A_POR_MPU_M7_PRLAR22_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR23_U_SMXP_1_0",
        .addr = A_POR_MPU_M7_PRBAR23_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR23_U_SMXP_1_0",
        .addr = A_POR_MPU_M7_PRLAR23_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR24_U_SMXP_1_0",
        .addr = A_POR_MPU_M7_PRBAR24_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR24_U_SMXP_1_0",
        .addr = A_POR_MPU_M7_PRLAR24_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR25_U_SMXP_1_0",
        .addr = A_POR_MPU_M7_PRBAR25_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR25_U_SMXP_1_0",
        .addr = A_POR_MPU_M7_PRLAR25_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR26_U_SMXP_1_0",
        .addr = A_POR_MPU_M7_PRBAR26_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR26_U_SMXP_1_0",
        .addr = A_POR_MPU_M7_PRLAR26_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR27_U_SMXP_1_0",
        .addr = A_POR_MPU_M7_PRBAR27_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR27_U_SMXP_1_0",
        .addr = A_POR_MPU_M7_PRLAR27_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR28_U_SMXP_1_0",
        .addr = A_POR_MPU_M7_PRBAR28_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR28_U_SMXP_1_0",
        .addr = A_POR_MPU_M7_PRLAR28_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR29_U_SMXP_1_0",
        .addr = A_POR_MPU_M7_PRBAR29_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR29_U_SMXP_1_0",
        .addr = A_POR_MPU_M7_PRLAR29_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR30_U_SMXP_1_0",
        .addr = A_POR_MPU_M7_PRBAR30_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR30_U_SMXP_1_0",
        .addr = A_POR_MPU_M7_PRLAR30_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR31_U_SMXP_1_0",
        .addr = A_POR_MPU_M7_PRBAR31_U_SMXP_1_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR31_U_SMXP_1_0",
        .addr = A_POR_MPU_M7_PRLAR31_U_SMXP_1_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_HNF_NODE_INFO_U_HNF_NID72",
        .addr = A_POR_HNF_NODE_INFO_U_HNF_NID72,
        .reset = 0x80005,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_HNF_CHILD_INFO_U_HNF_NID72",
        .addr = A_POR_HNF_CHILD_INFO_U_HNF_NID72,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_HNF_UNIT_INFO_U_HNF_NID72",
        .addr = A_POR_HNF_UNIT_INFO_U_HNF_NID72,
        .reset = 0x4000000000,
        .rsvd = 0x88,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_HNF_SECURE_REGISTER_GROUPS_OVERRIDE_U_HNF_NID72",
        .addr = A_POR_HNF_SECURE_REGISTER_GROUPS_OVERRIDE_U_HNF_NID72,
        .rsvd = 0xffffffffffffffc0L,
        .ro = 0xffffffffffffffc0L,
    },{ .name = "POR_HNF_CFG_CTL_U_HNF_NID72",
        .addr = A_POR_HNF_CFG_CTL_U_HNF_NID72,
        .reset = 0x50,
        .rsvd = 0xaa,
        .ro = 0xfffffffffffff0aaL,
    },{ .name = "POR_HNF_AUX_CTL_U_HNF_NID72",
        .addr = A_POR_HNF_AUX_CTL_U_HNF_NID72,
        .reset = 0x11c4c9000000002,
        .ro = 0xfc60006cfffe0000L,
    },{ .name = "POR_HNF_R2_AUX_CTL_U_HNF_NID72",
        .addr = A_POR_HNF_R2_AUX_CTL_U_HNF_NID72,
        .rsvd = 0xfffffffffffffff0L,
        .ro = 0xfffffffffffffff0L,
    },{ .name = "RDF_HNF_AUX_CTL_U_HNF_NID72",
        .addr = A_RDF_HNF_AUX_CTL_U_HNF_NID72,
        .ro = 0xffffffffffff6cffL,
    },{ .name = "POR_HNF_QOS_BAND_U_HNF_NID72",
        .addr = A_POR_HNF_QOS_BAND_U_HNF_NID72,
        .reset = 0xffecb870,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_HNF_QOS_RESERVATION_U_HNF_NID72",
        .addr = A_POR_HNF_QOS_RESERVATION_U_HNF_NID72,
        .reset = 0x13f3e1f0a,
        .rsvd = 0xc0,
        .ro = 0xffffffc0c0c0c0c0L,
    },{ .name = "POR_HNF_RN_STARVATION_U_HNF_NID72",
        .addr = A_POR_HNF_RN_STARVATION_U_HNF_NID72,
        .reset = 0x1f3f1f3f3f1f,
        .rsvd = 0xe0,
        .ro = 0xffffe0c0e080c0e0L,
    },{ .name = "POR_HNF_CFG_SLCSF_DBGRD_U_HNF_NID72",
        .addr = A_POR_HNF_CFG_SLCSF_DBGRD_U_HNF_NID72,
        .ro = 0xfffffffffc80e000L,
    },{ .name = "POR_HNF_SLC_CACHE_ACCESS_SLC_TAG_U_HNF_NID72",
        .addr = A_POR_HNF_SLC_CACHE_ACCESS_SLC_TAG_U_HNF_NID72,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_HNF_SLC_CACHE_ACCESS_SLC_DATA_U_HNF_NID72",
        .addr = A_POR_HNF_SLC_CACHE_ACCESS_SLC_DATA_U_HNF_NID72,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_HNF_SLC_CACHE_ACCESS_SF_TAG_U_HNF_NID72",
        .addr = A_POR_HNF_SLC_CACHE_ACCESS_SF_TAG_U_HNF_NID72,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_HNF_SLC_CACHE_ACCESS_SF_TAG1_U_HNF_NID72",
        .addr = A_POR_HNF_SLC_CACHE_ACCESS_SF_TAG1_U_HNF_NID72,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_HNF_SLC_CACHE_ACCESS_SF_TAG2_U_HNF_NID72",
        .addr = A_POR_HNF_SLC_CACHE_ACCESS_SF_TAG2_U_HNF_NID72,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_HNF_SLC_LOCK_WAYS_U_HNF_NID72",
        .addr = A_POR_HNF_SLC_LOCK_WAYS_U_HNF_NID72,
        .reset = 0x400,
        .rsvd = 0xf0,
        .ro = 0xffffffffffff80f0L,
    },{ .name = "POR_HNF_SLC_LOCK_BASE0_U_HNF_NID72",
        .addr = A_POR_HNF_SLC_LOCK_BASE0_U_HNF_NID72,
        .ro = 0x7fff000000000000,
    },{ .name = "POR_HNF_SLC_LOCK_BASE1_U_HNF_NID72",
        .addr = A_POR_HNF_SLC_LOCK_BASE1_U_HNF_NID72,
        .ro = 0x7fff000000000000,
    },{ .name = "POR_HNF_SLC_LOCK_BASE2_U_HNF_NID72",
        .addr = A_POR_HNF_SLC_LOCK_BASE2_U_HNF_NID72,
        .ro = 0x7fff000000000000,
    },{ .name = "POR_HNF_SLC_LOCK_BASE3_U_HNF_NID72",
        .addr = A_POR_HNF_SLC_LOCK_BASE3_U_HNF_NID72,
        .ro = 0x7fff000000000000,
    },{ .name = "POR_HNF_RNF_REGION_VEC1_U_HNF_NID72",
        .addr = A_POR_HNF_RNF_REGION_VEC1_U_HNF_NID72,
    },{ .name = "POR_HNF_RNI_REGION_VEC_U_HNF_NID72",
        .addr = A_POR_HNF_RNI_REGION_VEC_U_HNF_NID72,
        .ro = 0xffffffff00000000L,
    },{ .name = "POR_HNF_RNF_REGION_VEC_U_HNF_NID72",
        .addr = A_POR_HNF_RNF_REGION_VEC_U_HNF_NID72,
    },{ .name = "POR_HNF_RND_REGION_VEC_U_HNF_NID72",
        .addr = A_POR_HNF_RND_REGION_VEC_U_HNF_NID72,
        .ro = 0xffffffff00000000L,
    },{ .name = "POR_HNF_SLCWAY_PARTITION0_RNF_VEC_U_HNF_NID72",
        .addr = A_POR_HNF_SLCWAY_PARTITION0_RNF_VEC_U_HNF_NID72,
        .reset = 0xffffffffffffffffL,
    },{ .name = "POR_HNF_SLCWAY_PARTITION1_RNF_VEC_U_HNF_NID72",
        .addr = A_POR_HNF_SLCWAY_PARTITION1_RNF_VEC_U_HNF_NID72,
        .reset = 0xffffffffffffffffL,
    },{ .name = "POR_HNF_SLCWAY_PARTITION2_RNF_VEC_U_HNF_NID72",
        .addr = A_POR_HNF_SLCWAY_PARTITION2_RNF_VEC_U_HNF_NID72,
        .reset = 0xffffffffffffffffL,
    },{ .name = "POR_HNF_SLCWAY_PARTITION3_RNF_VEC_U_HNF_NID72",
        .addr = A_POR_HNF_SLCWAY_PARTITION3_RNF_VEC_U_HNF_NID72,
        .reset = 0xffffffffffffffffL,
    },{ .name = "POR_HNF_SLCWAY_PARTITION0_RNI_VEC_U_HNF_NID72",
        .addr = A_POR_HNF_SLCWAY_PARTITION0_RNI_VEC_U_HNF_NID72,
        .reset = 0xffffffff,
        .ro = 0xffffffff00000000L,
    },{ .name = "POR_HNF_SLCWAY_PARTITION1_RNI_VEC_U_HNF_NID72",
        .addr = A_POR_HNF_SLCWAY_PARTITION1_RNI_VEC_U_HNF_NID72,
        .reset = 0xffffffff,
        .ro = 0xffffffff00000000L,
    },{ .name = "POR_HNF_SLCWAY_PARTITION2_RNI_VEC_U_HNF_NID72",
        .addr = A_POR_HNF_SLCWAY_PARTITION2_RNI_VEC_U_HNF_NID72,
        .reset = 0xffffffff,
        .ro = 0xffffffff00000000L,
    },{ .name = "POR_HNF_SLCWAY_PARTITION3_RNI_VEC_U_HNF_NID72",
        .addr = A_POR_HNF_SLCWAY_PARTITION3_RNI_VEC_U_HNF_NID72,
        .reset = 0xffffffff,
        .ro = 0xffffffff00000000L,
    },{ .name = "POR_HNF_SLCWAY_PARTITION0_RND_VEC_U_HNF_NID72",
        .addr = A_POR_HNF_SLCWAY_PARTITION0_RND_VEC_U_HNF_NID72,
        .reset = 0xffffffff,
        .ro = 0xffffffff00000000L,
    },{ .name = "POR_HNF_SLCWAY_PARTITION1_RND_VEC_U_HNF_NID72",
        .addr = A_POR_HNF_SLCWAY_PARTITION1_RND_VEC_U_HNF_NID72,
        .reset = 0xffffffff,
        .ro = 0xffffffff00000000L,
    },{ .name = "POR_HNF_SLCWAY_PARTITION2_RND_VEC_U_HNF_NID72",
        .addr = A_POR_HNF_SLCWAY_PARTITION2_RND_VEC_U_HNF_NID72,
        .reset = 0xffffffff,
        .ro = 0xffffffff00000000L,
    },{ .name = "POR_HNF_SLCWAY_PARTITION3_RND_VEC_U_HNF_NID72",
        .addr = A_POR_HNF_SLCWAY_PARTITION3_RND_VEC_U_HNF_NID72,
        .reset = 0xffffffff,
        .ro = 0xffffffff00000000L,
    },{ .name = "POR_HNF_RN_REGION_LOCK_U_HNF_NID72",
        .addr = A_POR_HNF_RN_REGION_LOCK_U_HNF_NID72,
        .rsvd = 0xfffffffffffffffcL,
        .ro = 0xfffffffffffffffcL,
    },{ .name = "POR_HNF_SLCWAY_PARTITION0_RNF_VEC1_U_HNF_NID72",
        .addr = A_POR_HNF_SLCWAY_PARTITION0_RNF_VEC1_U_HNF_NID72,
        .reset = 0xffffffffffffffffL,
    },{ .name = "POR_HNF_SLCWAY_PARTITION1_RNF_VEC1_U_HNF_NID72",
        .addr = A_POR_HNF_SLCWAY_PARTITION1_RNF_VEC1_U_HNF_NID72,
        .reset = 0xffffffffffffffffL,
    },{ .name = "POR_HNF_SLCWAY_PARTITION2_RNF_VEC1_U_HNF_NID72",
        .addr = A_POR_HNF_SLCWAY_PARTITION2_RNF_VEC1_U_HNF_NID72,
        .reset = 0xffffffffffffffffL,
    },{ .name = "POR_HNF_SLCWAY_PARTITION3_RNF_VEC1_U_HNF_NID72",
        .addr = A_POR_HNF_SLCWAY_PARTITION3_RNF_VEC1_U_HNF_NID72,
        .reset = 0xffffffffffffffffL,
    },{ .name = "POR_HNF_SAM_CONTROL_U_HNF_NID72",
        .addr = A_POR_HNF_SAM_CONTROL_U_HNF_NID72,
        .ro = 0x40c0c0c800800800,
    },{ .name = "POR_HNF_SAM_MEMREGION0_U_HNF_NID72",
        .addr = A_POR_HNF_SAM_MEMREGION0_U_HNF_NID72,
        .ro = 0x7fff000003fe0800,
    },{ .name = "POR_HNF_SAM_MEMREGION1_U_HNF_NID72",
        .addr = A_POR_HNF_SAM_MEMREGION1_U_HNF_NID72,
        .ro = 0x7fff000003fe0800,
    },{ .name = "POR_HNF_SAM_SN_PROPERTIES_U_HNF_NID72",
        .addr = A_POR_HNF_SAM_SN_PROPERTIES_U_HNF_NID72,
        .rsvd = 0x38,
        .ro = 0xffffe38e38e38e38L,
    },{ .name = "POR_HNF_SAM_6SN_NODEID_U_HNF_NID72",
        .addr = A_POR_HNF_SAM_6SN_NODEID_U_HNF_NID72,
        .ro = 0xfffffff800800800L,
    },{ .name = "POR_HNF_RN_PHYS_ID0_U_HNF_NID72",
        .addr = A_POR_HNF_RN_PHYS_ID0_U_HNF_NID72,
        .reset = 0x8000004c8000000cL,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID1_U_HNF_NID72",
        .addr = A_POR_HNF_RN_PHYS_ID1_U_HNF_NID72,
        .reset = 0x800000cc8000008cL,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID2_U_HNF_NID72",
        .addr = A_POR_HNF_RN_PHYS_ID2_U_HNF_NID72,
        .reset = 0x8000010c,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID3_U_HNF_NID72",
        .addr = A_POR_HNF_RN_PHYS_ID3_U_HNF_NID72,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID4_U_HNF_NID72",
        .addr = A_POR_HNF_RN_PHYS_ID4_U_HNF_NID72,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID5_U_HNF_NID72",
        .addr = A_POR_HNF_RN_PHYS_ID5_U_HNF_NID72,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID6_U_HNF_NID72",
        .addr = A_POR_HNF_RN_PHYS_ID6_U_HNF_NID72,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID7_U_HNF_NID72",
        .addr = A_POR_HNF_RN_PHYS_ID7_U_HNF_NID72,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID8_U_HNF_NID72",
        .addr = A_POR_HNF_RN_PHYS_ID8_U_HNF_NID72,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID9_U_HNF_NID72",
        .addr = A_POR_HNF_RN_PHYS_ID9_U_HNF_NID72,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID10_U_HNF_NID72",
        .addr = A_POR_HNF_RN_PHYS_ID10_U_HNF_NID72,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID11_U_HNF_NID72",
        .addr = A_POR_HNF_RN_PHYS_ID11_U_HNF_NID72,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID12_U_HNF_NID72",
        .addr = A_POR_HNF_RN_PHYS_ID12_U_HNF_NID72,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID13_U_HNF_NID72",
        .addr = A_POR_HNF_RN_PHYS_ID13_U_HNF_NID72,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID14_U_HNF_NID72",
        .addr = A_POR_HNF_RN_PHYS_ID14_U_HNF_NID72,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID15_U_HNF_NID72",
        .addr = A_POR_HNF_RN_PHYS_ID15_U_HNF_NID72,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID16_U_HNF_NID72",
        .addr = A_POR_HNF_RN_PHYS_ID16_U_HNF_NID72,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID17_U_HNF_NID72",
        .addr = A_POR_HNF_RN_PHYS_ID17_U_HNF_NID72,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID18_U_HNF_NID72",
        .addr = A_POR_HNF_RN_PHYS_ID18_U_HNF_NID72,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID19_U_HNF_NID72",
        .addr = A_POR_HNF_RN_PHYS_ID19_U_HNF_NID72,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID20_U_HNF_NID72",
        .addr = A_POR_HNF_RN_PHYS_ID20_U_HNF_NID72,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID21_U_HNF_NID72",
        .addr = A_POR_HNF_RN_PHYS_ID21_U_HNF_NID72,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID22_U_HNF_NID72",
        .addr = A_POR_HNF_RN_PHYS_ID22_U_HNF_NID72,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID23_U_HNF_NID72",
        .addr = A_POR_HNF_RN_PHYS_ID23_U_HNF_NID72,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID24_U_HNF_NID72",
        .addr = A_POR_HNF_RN_PHYS_ID24_U_HNF_NID72,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID25_U_HNF_NID72",
        .addr = A_POR_HNF_RN_PHYS_ID25_U_HNF_NID72,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID26_U_HNF_NID72",
        .addr = A_POR_HNF_RN_PHYS_ID26_U_HNF_NID72,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID27_U_HNF_NID72",
        .addr = A_POR_HNF_RN_PHYS_ID27_U_HNF_NID72,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID28_U_HNF_NID72",
        .addr = A_POR_HNF_RN_PHYS_ID28_U_HNF_NID72,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID29_U_HNF_NID72",
        .addr = A_POR_HNF_RN_PHYS_ID29_U_HNF_NID72,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID30_U_HNF_NID72",
        .addr = A_POR_HNF_RN_PHYS_ID30_U_HNF_NID72,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID31_U_HNF_NID72",
        .addr = A_POR_HNF_RN_PHYS_ID31_U_HNF_NID72,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID32_U_HNF_NID72",
        .addr = A_POR_HNF_RN_PHYS_ID32_U_HNF_NID72,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID33_U_HNF_NID72",
        .addr = A_POR_HNF_RN_PHYS_ID33_U_HNF_NID72,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID34_U_HNF_NID72",
        .addr = A_POR_HNF_RN_PHYS_ID34_U_HNF_NID72,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID35_U_HNF_NID72",
        .addr = A_POR_HNF_RN_PHYS_ID35_U_HNF_NID72,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID36_U_HNF_NID72",
        .addr = A_POR_HNF_RN_PHYS_ID36_U_HNF_NID72,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID37_U_HNF_NID72",
        .addr = A_POR_HNF_RN_PHYS_ID37_U_HNF_NID72,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID38_U_HNF_NID72",
        .addr = A_POR_HNF_RN_PHYS_ID38_U_HNF_NID72,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID39_U_HNF_NID72",
        .addr = A_POR_HNF_RN_PHYS_ID39_U_HNF_NID72,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID40_U_HNF_NID72",
        .addr = A_POR_HNF_RN_PHYS_ID40_U_HNF_NID72,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID41_U_HNF_NID72",
        .addr = A_POR_HNF_RN_PHYS_ID41_U_HNF_NID72,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID42_U_HNF_NID72",
        .addr = A_POR_HNF_RN_PHYS_ID42_U_HNF_NID72,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID43_U_HNF_NID72",
        .addr = A_POR_HNF_RN_PHYS_ID43_U_HNF_NID72,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID44_U_HNF_NID72",
        .addr = A_POR_HNF_RN_PHYS_ID44_U_HNF_NID72,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID45_U_HNF_NID72",
        .addr = A_POR_HNF_RN_PHYS_ID45_U_HNF_NID72,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID46_U_HNF_NID72",
        .addr = A_POR_HNF_RN_PHYS_ID46_U_HNF_NID72,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID47_U_HNF_NID72",
        .addr = A_POR_HNF_RN_PHYS_ID47_U_HNF_NID72,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID48_U_HNF_NID72",
        .addr = A_POR_HNF_RN_PHYS_ID48_U_HNF_NID72,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID49_U_HNF_NID72",
        .addr = A_POR_HNF_RN_PHYS_ID49_U_HNF_NID72,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID50_U_HNF_NID72",
        .addr = A_POR_HNF_RN_PHYS_ID50_U_HNF_NID72,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID51_U_HNF_NID72",
        .addr = A_POR_HNF_RN_PHYS_ID51_U_HNF_NID72,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID52_U_HNF_NID72",
        .addr = A_POR_HNF_RN_PHYS_ID52_U_HNF_NID72,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID53_U_HNF_NID72",
        .addr = A_POR_HNF_RN_PHYS_ID53_U_HNF_NID72,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID54_U_HNF_NID72",
        .addr = A_POR_HNF_RN_PHYS_ID54_U_HNF_NID72,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID55_U_HNF_NID72",
        .addr = A_POR_HNF_RN_PHYS_ID55_U_HNF_NID72,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID56_U_HNF_NID72",
        .addr = A_POR_HNF_RN_PHYS_ID56_U_HNF_NID72,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID57_U_HNF_NID72",
        .addr = A_POR_HNF_RN_PHYS_ID57_U_HNF_NID72,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID58_U_HNF_NID72",
        .addr = A_POR_HNF_RN_PHYS_ID58_U_HNF_NID72,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_SF_CXG_BLOCKED_WAYS_U_HNF_NID72",
        .addr = A_POR_HNF_SF_CXG_BLOCKED_WAYS_U_HNF_NID72,
        .rsvd = 0xfffffffffffffffcL,
        .ro = 0xfffffffffffffffcL,
    },{ .name = "POR_HNF_CML_PORT_AGGR_GRP0_ADD_MASK_U_HNF_NID72",
        .addr = A_POR_HNF_CML_PORT_AGGR_GRP0_ADD_MASK_U_HNF_NID72,
        .reset = 0x40,
        .ro = 0xffff00000000003fL,
    },{ .name = "POR_HNF_CML_PORT_AGGR_GRP1_ADD_MASK_U_HNF_NID72",
        .addr = A_POR_HNF_CML_PORT_AGGR_GRP1_ADD_MASK_U_HNF_NID72,
        .reset = 0x40,
        .ro = 0xffff00000000003fL,
    },{ .name = "POR_HNF_CML_PORT_AGGR_GRP0_REG_U_HNF_NID72",
        .addr = A_POR_HNF_CML_PORT_AGGR_GRP0_REG_U_HNF_NID72,
        .ro = 0xfffc800800800800L,
    },{ .name = "POR_HNF_CML_PORT_AGGR_GRP1_REG_U_HNF_NID72",
        .addr = A_POR_HNF_CML_PORT_AGGR_GRP1_REG_U_HNF_NID72,
        .ro = 0xfffc800800800800L,
    },{ .name = "HN_SAM_HASH_ADDR_MASK_REG_U_HNF_NID72",
        .addr = A_HN_SAM_HASH_ADDR_MASK_REG_U_HNF_NID72,
        .reset = 0xffffffffffc0,
        .ro = 0xffff00000000003fL,
    },{ .name = "HN_SAM_REGION_CMP_ADDR_MASK_REG_U_HNF_NID72",
        .addr = A_HN_SAM_REGION_CMP_ADDR_MASK_REG_U_HNF_NID72,
        .reset = 0xfffffc000000,
        .ro = 0xffff000003ffffffL,
    },{ .name = "POR_HNF_ABF_LO_ADDR_U_HNF_NID72",
        .addr = A_POR_HNF_ABF_LO_ADDR_U_HNF_NID72,
        .ro = 0xffff000000000000L,
    },{ .name = "POR_HNF_ABF_HI_ADDR_U_HNF_NID72",
        .addr = A_POR_HNF_ABF_HI_ADDR_U_HNF_NID72,
        .ro = 0xffff000000000000L,
    },{ .name = "POR_HNF_ABF_PR_U_HNF_NID72",
        .addr = A_POR_HNF_ABF_PR_U_HNF_NID72,
        .rsvd = 0xfffffffffffffff8L,
        .ro = 0xfffffffffffffff8L,
    },{ .name = "POR_HNF_ABF_SR_U_HNF_NID72",
        .addr = A_POR_HNF_ABF_SR_U_HNF_NID72,
        .rsvd = 0xfffffffffffffff0L,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_HNF_RN_PHYS_ID59_U_HNF_NID72",
        .addr = A_POR_HNF_RN_PHYS_ID59_U_HNF_NID72,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID60_U_HNF_NID72",
        .addr = A_POR_HNF_RN_PHYS_ID60_U_HNF_NID72,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID61_U_HNF_NID72",
        .addr = A_POR_HNF_RN_PHYS_ID61_U_HNF_NID72,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID62_U_HNF_NID72",
        .addr = A_POR_HNF_RN_PHYS_ID62_U_HNF_NID72,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID63_U_HNF_NID72",
        .addr = A_POR_HNF_RN_PHYS_ID63_U_HNF_NID72,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_LDID_MAP_TABLE_REG0_U_HNF_NID72",
        .addr = A_POR_HNF_LDID_MAP_TABLE_REG0_U_HNF_NID72,
        .ro = 0x7f80f8007f80f800,
    },{ .name = "POR_HNF_LDID_MAP_TABLE_REG1_U_HNF_NID72",
        .addr = A_POR_HNF_LDID_MAP_TABLE_REG1_U_HNF_NID72,
        .ro = 0x7f80f8007f80f800,
    },{ .name = "POR_HNF_LDID_MAP_TABLE_REG2_U_HNF_NID72",
        .addr = A_POR_HNF_LDID_MAP_TABLE_REG2_U_HNF_NID72,
        .ro = 0x7f80f8007f80f800,
    },{ .name = "POR_HNF_LDID_MAP_TABLE_REG3_U_HNF_NID72",
        .addr = A_POR_HNF_LDID_MAP_TABLE_REG3_U_HNF_NID72,
        .ro = 0x7f80f8007f80f800,
    },{ .name = "POR_HNF_PPU_PWPR_U_HNF_NID72",
        .addr = A_POR_HNF_PPU_PWPR_U_HNF_NID72,
        .ro = 0xfffffe00,
    },{ .name = "POR_HNF_PPU_PWSR_U_HNF_NID72",
        .addr = A_POR_HNF_PPU_PWSR_U_HNF_NID72,
        .ro = 0xffffffff,
    },{ .name = "POR_HNF_PPU_MISR_U_HNF_NID72",
        .addr = A_POR_HNF_PPU_MISR_U_HNF_NID72,
        .rsvd = 0xfffffffe,
        .ro = 0xffffffff,
    },{ .name = "POR_HNF_PPU_DYN_RET_THRESHOLD_U_HNF_NID72",
        .addr = A_POR_HNF_PPU_DYN_RET_THRESHOLD_U_HNF_NID72,
        .ro = 0xfffffffffffff000L,
    },{ .name = "POR_HNF_PPU_IDR0_U_HNF_NID72",
        .addr = A_POR_HNF_PPU_IDR0_U_HNF_NID72,
        .reset = 0x801a540,
        .ro = 0xffffffff,
    },{ .name = "POR_HNF_PPU_IDR1_U_HNF_NID72",
        .addr = A_POR_HNF_PPU_IDR1_U_HNF_NID72,
        .rsvd = 0xfffffff0,
        .ro = 0xffffffff,
    },{ .name = "POR_HNF_PPU_IIDR_U_HNF_NID72",
        .addr = A_POR_HNF_PPU_IIDR_U_HNF_NID72,
        .reset = 0x4340043b,
        .ro = 0xffffffff,
    },{ .name = "POR_HNF_PPU_AIDR_U_HNF_NID72",
        .addr = A_POR_HNF_PPU_AIDR_U_HNF_NID72,
        .reset = 0x11,
        .rsvd = 0xffffff00,
        .ro = 0xffffffff,
    },{ .name = "POR_HNF_PMU_EVENT_SEL_U_HNF_NID72",
        .addr = A_POR_HNF_PMU_EVENT_SEL_U_HNF_NID72,
        .rsvd = 0xe0,
        .ro = 0xfffffff8e0e0e0e0L,
    },{ .name = "POR_HNF_ERRFR_U_HNF_NID72",
        .addr = A_POR_HNF_ERRFR_U_HNF_NID72,
        .reset = 0x48a5,
        .rsvd = 0x300,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_HNF_ERRCTLR_U_HNF_NID72",
        .addr = A_POR_HNF_ERRCTLR_U_HNF_NID72,
        .rsvd = 0xf0,
        .ro = 0xfffffffffffffef0L,
    },{ .name = "POR_HNF_ERRSTATUS_U_HNF_NID72",
        .addr = A_POR_HNF_ERRSTATUS_U_HNF_NID72,
        .ro = 0xffffffff127fffffL,
    },{ .name = "POR_HNF_ERRADDR_U_HNF_NID72",
        .addr = A_POR_HNF_ERRADDR_U_HNF_NID72,
        .ro = 0x7fff000000000000,
    },{ .name = "POR_HNF_ERRMISC_U_HNF_NID72",
        .addr = A_POR_HNF_ERRMISC_U_HNF_NID72,
        .ro = 0x20000000fffc8000,
    },{ .name = "POR_HNF_ERR_INJ_U_HNF_NID72",
        .addr = A_POR_HNF_ERR_INJ_U_HNF_NID72,
        .rsvd = 0xe,
        .ro = 0xfffffffff800fe0eL,
    },{ .name = "POR_HNF_BYTE_PAR_ERR_INJ_U_HNF_NID72",
        .addr = A_POR_HNF_BYTE_PAR_ERR_INJ_U_HNF_NID72,
        .rsvd = 0xffffffffffffffe0L,
        .ro = 0xffffffffffffffe0L,
    },{ .name = "POR_HNF_ERRFR_NS_U_HNF_NID72",
        .addr = A_POR_HNF_ERRFR_NS_U_HNF_NID72,
        .reset = 0x48a5,
        .rsvd = 0x300,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_HNF_ERRCTLR_NS_U_HNF_NID72",
        .addr = A_POR_HNF_ERRCTLR_NS_U_HNF_NID72,
        .rsvd = 0xf0,
        .ro = 0xfffffffffffffef0L,
    },{ .name = "POR_HNF_ERRSTATUS_NS_U_HNF_NID72",
        .addr = A_POR_HNF_ERRSTATUS_NS_U_HNF_NID72,
        .ro = 0xffffffff127fffffL,
    },{ .name = "POR_HNF_ERRADDR_NS_U_HNF_NID72",
        .addr = A_POR_HNF_ERRADDR_NS_U_HNF_NID72,
        .ro = 0x7fff000000000000,
    },{ .name = "POR_HNF_ERRMISC_NS_U_HNF_NID72",
        .addr = A_POR_HNF_ERRMISC_NS_U_HNF_NID72,
        .ro = 0x20000000fffc8000,
    },{ .name = "POR_MXP_NODE_INFO_U_SMXP_1_1",
        .addr = A_POR_MXP_NODE_INFO_U_SMXP_1_1,
        .reset = 0x1080006,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_DEVICE_PORT_CONNECT_INFO_P0_U_SMXP_1_1",
        .addr = A_POR_MXP_DEVICE_PORT_CONNECT_INFO_P0_U_SMXP_1_1,
        .reset = 0xd,
        .rsvd = 0xffe0,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_DEVICE_PORT_CONNECT_INFO_P1_U_SMXP_1_1",
        .addr = A_POR_MXP_DEVICE_PORT_CONNECT_INFO_P1_U_SMXP_1_1,
        .reset = 0x1,
        .rsvd = 0xffe0,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_MESH_PORT_CONNECT_INFO_EAST_U_SMXP_1_1",
        .addr = A_POR_MXP_MESH_PORT_CONNECT_INFO_EAST_U_SMXP_1_1,
        .rsvd = 0xfffffffffffffff0L,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_MESH_PORT_CONNECT_INFO_NORTH_U_SMXP_1_1",
        .addr = A_POR_MXP_MESH_PORT_CONNECT_INFO_NORTH_U_SMXP_1_1,
        .rsvd = 0xfffffffffffffff0L,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_INFO_U_SMXP_1_1",
        .addr = A_POR_MXP_CHILD_INFO_U_SMXP_1_1,
        .reset = 0x1000006,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_POINTER_0_U_SMXP_1_1",
        .addr = A_POR_MXP_CHILD_POINTER_0_U_SMXP_1_1,
        .reset = 0x8212c000,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_POINTER_1_U_SMXP_1_1",
        .addr = A_POR_MXP_CHILD_POINTER_1_U_SMXP_1_1,
        .reset = 0x8213c000,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_POINTER_2_U_SMXP_1_1",
        .addr = A_POR_MXP_CHILD_POINTER_2_U_SMXP_1_1,
        .reset = 0x2168000,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_POINTER_3_U_SMXP_1_1",
        .addr = A_POR_MXP_CHILD_POINTER_3_U_SMXP_1_1,
        .reset = 0x821d0000,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_POINTER_4_U_SMXP_1_1",
        .addr = A_POR_MXP_CHILD_POINTER_4_U_SMXP_1_1,
        .reset = 0x82120000,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_POINTER_5_U_SMXP_1_1",
        .addr = A_POR_MXP_CHILD_POINTER_5_U_SMXP_1_1,
        .reset = 0x2150000,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_POINTER_6_U_SMXP_1_1",
        .addr = A_POR_MXP_CHILD_POINTER_6_U_SMXP_1_1,
        .reset = 0x2110000,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_POINTER_7_U_SMXP_1_1",
        .addr = A_POR_MXP_CHILD_POINTER_7_U_SMXP_1_1,
        .reset = 0x2100000,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_POINTER_8_U_SMXP_1_1",
        .addr = A_POR_MXP_CHILD_POINTER_8_U_SMXP_1_1,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_POINTER_9_U_SMXP_1_1",
        .addr = A_POR_MXP_CHILD_POINTER_9_U_SMXP_1_1,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_POINTER_10_U_SMXP_1_1",
        .addr = A_POR_MXP_CHILD_POINTER_10_U_SMXP_1_1,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_POINTER_11_U_SMXP_1_1",
        .addr = A_POR_MXP_CHILD_POINTER_11_U_SMXP_1_1,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_POINTER_12_U_SMXP_1_1",
        .addr = A_POR_MXP_CHILD_POINTER_12_U_SMXP_1_1,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_POINTER_13_U_SMXP_1_1",
        .addr = A_POR_MXP_CHILD_POINTER_13_U_SMXP_1_1,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_POINTER_14_U_SMXP_1_1",
        .addr = A_POR_MXP_CHILD_POINTER_14_U_SMXP_1_1,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_POINTER_15_U_SMXP_1_1",
        .addr = A_POR_MXP_CHILD_POINTER_15_U_SMXP_1_1,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_P0_INFO_U_SMXP_1_1",
        .addr = A_POR_MXP_P0_INFO_U_SMXP_1_1,
        .reset = 0x211,
        .rsvd = 0x48,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_P1_INFO_U_SMXP_1_1",
        .addr = A_POR_MXP_P1_INFO_U_SMXP_1_1,
        .reset = 0x211,
        .rsvd = 0x48,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_SECURE_REGISTER_GROUPS_OVERRIDE_U_SMXP_1_1",
        .addr = A_POR_MXP_SECURE_REGISTER_GROUPS_OVERRIDE_U_SMXP_1_1,
        .rsvd = 0xfffffffffffffffcL,
        .ro = 0xfffffffffffffffcL,
    },{ .name = "POR_MXP_AUX_CTL_U_SMXP_1_1",
        .addr = A_POR_MXP_AUX_CTL_U_SMXP_1_1,
        .rsvd = 0xfffffffffffffffeL,
        .ro = 0xfffffffffffffffeL,
    },{ .name = "POR_MXP_P0_QOS_CONTROL_U_SMXP_1_1",
        .addr = A_POR_MXP_P0_QOS_CONTROL_U_SMXP_1_1,
        .rsvd = 0xffaa,
        .ro = 0xfffffffffff0ffaaL,
    },{ .name = "POR_MXP_P0_QOS_LAT_TGT_U_SMXP_1_1",
        .addr = A_POR_MXP_P0_QOS_LAT_TGT_U_SMXP_1_1,
        .ro = 0xfffffffffffff000L,
    },{ .name = "POR_MXP_P0_QOS_LAT_SCALE_U_SMXP_1_1",
        .addr = A_POR_MXP_P0_QOS_LAT_SCALE_U_SMXP_1_1,
        .rsvd = 0xfffffffffffffff8L,
        .ro = 0xfffffffffffffff8L,
    },{ .name = "POR_MXP_P0_QOS_LAT_RANGE_U_SMXP_1_1",
        .addr = A_POR_MXP_P0_QOS_LAT_RANGE_U_SMXP_1_1,
        .rsvd = 0xf0,
        .ro = 0xfffffffffffff0f0L,
    },{ .name = "POR_MXP_P1_QOS_CONTROL_U_SMXP_1_1",
        .addr = A_POR_MXP_P1_QOS_CONTROL_U_SMXP_1_1,
        .rsvd = 0xffaa,
        .ro = 0xfffffffffff0ffaaL,
    },{ .name = "POR_MXP_P1_QOS_LAT_TGT_U_SMXP_1_1",
        .addr = A_POR_MXP_P1_QOS_LAT_TGT_U_SMXP_1_1,
        .ro = 0xfffffffffffff000L,
    },{ .name = "POR_MXP_P1_QOS_LAT_SCALE_U_SMXP_1_1",
        .addr = A_POR_MXP_P1_QOS_LAT_SCALE_U_SMXP_1_1,
        .rsvd = 0xfffffffffffffff8L,
        .ro = 0xfffffffffffffff8L,
    },{ .name = "POR_MXP_P1_QOS_LAT_RANGE_U_SMXP_1_1",
        .addr = A_POR_MXP_P1_QOS_LAT_RANGE_U_SMXP_1_1,
        .rsvd = 0xf0,
        .ro = 0xfffffffffffff0f0L,
    },{ .name = "POR_MXP_P0_SYSCOREQ_CTL_U_SMXP_1_1",
        .addr = A_POR_MXP_P0_SYSCOREQ_CTL_U_SMXP_1_1,
        .rsvd = 0xfffffffffffffff0L,
        .ro = 0xfffffffffffffff0L,
    },{ .name = "POR_MXP_P1_SYSCOREQ_CTL_U_SMXP_1_1",
        .addr = A_POR_MXP_P1_SYSCOREQ_CTL_U_SMXP_1_1,
        .rsvd = 0xfffffffffffffff0L,
        .ro = 0xfffffffffffffff0L,
    },{ .name = "POR_MXP_P0_SYSCOACK_STATUS_U_SMXP_1_1",
        .addr = A_POR_MXP_P0_SYSCOACK_STATUS_U_SMXP_1_1,
        .rsvd = 0xfffffffffffffff0L,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_P1_SYSCOACK_STATUS_U_SMXP_1_1",
        .addr = A_POR_MXP_P1_SYSCOACK_STATUS_U_SMXP_1_1,
        .rsvd = 0xfffffffffffffff0L,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_PMU_EVENT_SEL_U_SMXP_1_1",
        .addr = A_POR_MXP_PMU_EVENT_SEL_U_SMXP_1_1,
        .ro = 0xffffffff00000000L,
    },{ .name = "POR_DTM_CONTROL_U_SMXP_1_1",
        .addr = A_POR_DTM_CONTROL_U_SMXP_1_1,
        .rsvd = 0xfffffffffffffff0L,
        .ro = 0xfffffffffffffff0L,
    },{ .name = "POR_DTM_FIFO_ENTRY_READY_U_SMXP_1_1",
        .addr = A_POR_DTM_FIFO_ENTRY_READY_U_SMXP_1_1,
        .rsvd = 0xfffffffffffffff0L,
        .ro = 0xfffffffffffffff0L,
    },{ .name = "POR_DTM_FIFO_ENTRY0_0_U_SMXP_1_1",
        .addr = A_POR_DTM_FIFO_ENTRY0_0_U_SMXP_1_1,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_DTM_FIFO_ENTRY0_1_U_SMXP_1_1",
        .addr = A_POR_DTM_FIFO_ENTRY0_1_U_SMXP_1_1,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_DTM_FIFO_ENTRY0_2_U_SMXP_1_1",
        .addr = A_POR_DTM_FIFO_ENTRY0_2_U_SMXP_1_1,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_DTM_FIFO_ENTRY1_0_U_SMXP_1_1",
        .addr = A_POR_DTM_FIFO_ENTRY1_0_U_SMXP_1_1,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_DTM_FIFO_ENTRY1_1_U_SMXP_1_1",
        .addr = A_POR_DTM_FIFO_ENTRY1_1_U_SMXP_1_1,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_DTM_FIFO_ENTRY1_2_U_SMXP_1_1",
        .addr = A_POR_DTM_FIFO_ENTRY1_2_U_SMXP_1_1,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_DTM_FIFO_ENTRY2_0_U_SMXP_1_1",
        .addr = A_POR_DTM_FIFO_ENTRY2_0_U_SMXP_1_1,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_DTM_FIFO_ENTRY2_1_U_SMXP_1_1",
        .addr = A_POR_DTM_FIFO_ENTRY2_1_U_SMXP_1_1,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_DTM_FIFO_ENTRY2_2_U_SMXP_1_1",
        .addr = A_POR_DTM_FIFO_ENTRY2_2_U_SMXP_1_1,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_DTM_FIFO_ENTRY3_0_U_SMXP_1_1",
        .addr = A_POR_DTM_FIFO_ENTRY3_0_U_SMXP_1_1,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_DTM_FIFO_ENTRY3_1_U_SMXP_1_1",
        .addr = A_POR_DTM_FIFO_ENTRY3_1_U_SMXP_1_1,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_DTM_FIFO_ENTRY3_2_U_SMXP_1_1",
        .addr = A_POR_DTM_FIFO_ENTRY3_2_U_SMXP_1_1,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_DTM_WP0_CONFIG_U_SMXP_1_1",
        .addr = A_POR_DTM_WP0_CONFIG_U_SMXP_1_1,
        .rsvd = 0x80,
        .ro = 0xffffffffffff8080L,
    },{ .name = "POR_DTM_WP0_VAL_U_SMXP_1_1",
        .addr = A_POR_DTM_WP0_VAL_U_SMXP_1_1,
    },{ .name = "POR_DTM_WP0_MASK_U_SMXP_1_1",
        .addr = A_POR_DTM_WP0_MASK_U_SMXP_1_1,
    },{ .name = "POR_DTM_WP1_CONFIG_U_SMXP_1_1",
        .addr = A_POR_DTM_WP1_CONFIG_U_SMXP_1_1,
        .rsvd = 0xc0,
        .ro = 0xffffffffffff80c0L,
    },{ .name = "POR_DTM_WP1_VAL_U_SMXP_1_1",
        .addr = A_POR_DTM_WP1_VAL_U_SMXP_1_1,
    },{ .name = "POR_DTM_WP1_MASK_U_SMXP_1_1",
        .addr = A_POR_DTM_WP1_MASK_U_SMXP_1_1,
    },{ .name = "POR_DTM_WP2_CONFIG_U_SMXP_1_1",
        .addr = A_POR_DTM_WP2_CONFIG_U_SMXP_1_1,
        .rsvd = 0x80,
        .ro = 0xffffffffffff8080L,
    },{ .name = "POR_DTM_WP2_VAL_U_SMXP_1_1",
        .addr = A_POR_DTM_WP2_VAL_U_SMXP_1_1,
    },{ .name = "POR_DTM_WP2_MASK_U_SMXP_1_1",
        .addr = A_POR_DTM_WP2_MASK_U_SMXP_1_1,
    },{ .name = "POR_DTM_WP3_CONFIG_U_SMXP_1_1",
        .addr = A_POR_DTM_WP3_CONFIG_U_SMXP_1_1,
        .rsvd = 0xc0,
        .ro = 0xffffffffffff80c0L,
    },{ .name = "POR_DTM_WP3_VAL_U_SMXP_1_1",
        .addr = A_POR_DTM_WP3_VAL_U_SMXP_1_1,
    },{ .name = "POR_DTM_WP3_MASK_U_SMXP_1_1",
        .addr = A_POR_DTM_WP3_MASK_U_SMXP_1_1,
    },{ .name = "POR_DTM_PMSICR_U_SMXP_1_1",
        .addr = A_POR_DTM_PMSICR_U_SMXP_1_1,
        .ro = 0xffffffff00000000L,
    },{ .name = "POR_DTM_PMSIRR_U_SMXP_1_1",
        .addr = A_POR_DTM_PMSIRR_U_SMXP_1_1,
        .ro = 0xffffffff000000ffL,
    },{ .name = "POR_DTM_PMU_CONFIG_U_SMXP_1_1",
        .addr = A_POR_DTM_PMU_CONFIG_U_SMXP_1_1,
        .ro = 0xc0c0c0c08888fe00L,
    },{ .name = "POR_DTM_PMEVCNT_U_SMXP_1_1",
        .addr = A_POR_DTM_PMEVCNT_U_SMXP_1_1,
    },{ .name = "POR_DTM_PMEVCNTSR_U_SMXP_1_1",
        .addr = A_POR_DTM_PMEVCNTSR_U_SMXP_1_1,
    },{ .name = "POR_MXP_ERRFR_U_SMXP_1_1",  .addr = A_POR_MXP_ERRFR_U_SMXP_1_1,
        .rsvd = 0x300,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_ERRCTLR_U_SMXP_1_1",
        .addr = A_POR_MXP_ERRCTLR_U_SMXP_1_1,
        .rsvd = 0xf0,
        .ro = 0xfffffffffffffef0L,
    },{ .name = "POR_MXP_ERRSTATUS_U_SMXP_1_1",
        .addr = A_POR_MXP_ERRSTATUS_U_SMXP_1_1,
        .ro = 0xffffffff127fffffL,
    },{ .name = "POR_MXP_ERRMISC_U_SMXP_1_1",
        .addr = A_POR_MXP_ERRMISC_U_SMXP_1_1,
        .rsvd = 0x8,
        .ro = 0xf800ffffffc08008L,
    },{ .name = "POR_MXP_P0_BYTE_PAR_ERR_INJ_U_SMXP_1_1",
        .addr = A_POR_MXP_P0_BYTE_PAR_ERR_INJ_U_SMXP_1_1,
        .rsvd = 0xffffffffffffffe0L,
        .ro = 0xffffffffffffffe0L,
    },{ .name = "POR_MXP_P1_BYTE_PAR_ERR_INJ_U_SMXP_1_1",
        .addr = A_POR_MXP_P1_BYTE_PAR_ERR_INJ_U_SMXP_1_1,
        .rsvd = 0xffffffffffffffe0L,
        .ro = 0xffffffffffffffe0L,
    },{ .name = "POR_MXP_ERRFR_NS_U_SMXP_1_1",
        .addr = A_POR_MXP_ERRFR_NS_U_SMXP_1_1,
        .rsvd = 0x300,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_ERRCTLR_NS_U_SMXP_1_1",
        .addr = A_POR_MXP_ERRCTLR_NS_U_SMXP_1_1,
        .rsvd = 0xf0,
        .ro = 0xfffffffffffffef0L,
    },{ .name = "POR_MXP_ERRSTATUS_NS_U_SMXP_1_1",
        .addr = A_POR_MXP_ERRSTATUS_NS_U_SMXP_1_1,
        .ro = 0xffffffff127fffffL,
    },{ .name = "POR_MXP_ERRMISC_NS_U_SMXP_1_1",
        .addr = A_POR_MXP_ERRMISC_NS_U_SMXP_1_1,
        .rsvd = 0x8,
        .ro = 0xf800ffffffc08008L,
    },{ .name = "POR_FDC_NODE_INFO_U_SMXP_1_1",
        .addr = A_POR_FDC_NODE_INFO_U_SMXP_1_1,
        .reset = 0x201,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_FDC_CHILD_INFO_U_SMXP_1_1",
        .addr = A_POR_FDC_CHILD_INFO_U_SMXP_1_1,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_ERRFR_MXP_U_SMXP_1_1",  .addr = A_POR_ERRFR_MXP_U_SMXP_1_1,
        .reset = 0xa1,
        .rsvd = 0xffffffffffffff0cL,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_ERRCTLR_MXP_U_SMXP_1_1",
        .addr = A_POR_ERRCTLR_MXP_U_SMXP_1_1,
        .reset = 0xd,
        .rsvd = 0x3ff2,
        .ro = 0xffffffff00003ff2L,
    },{ .name = "POR_ERRSTATUS_MXP_U_SMXP_1_1",
        .addr = A_POR_ERRSTATUS_MXP_U_SMXP_1_1,
        .ro = 0xffffffff977f003fL,
    },{ .name = "POR_FDC_AUX_CTL_MXP_U_SMXP_1_1",
        .addr = A_POR_FDC_AUX_CTL_MXP_U_SMXP_1_1,
        .rsvd = 0xffffffffffffffe0L,
        .ro = 0xffffffffffffffefL,
    },{ .name = "POR_ERRFR_P0_D0_U_SMXP_1_1",
        .addr = A_POR_ERRFR_P0_D0_U_SMXP_1_1,
        .reset = 0xa1,
        .rsvd = 0xffffffffffffff0cL,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_ERRCTLR_P0_D0_U_SMXP_1_1",
        .addr = A_POR_ERRCTLR_P0_D0_U_SMXP_1_1,
        .reset = 0xd,
        .rsvd = 0x3ff2,
        .ro = 0xffffffff00003ff2L,
    },{ .name = "POR_ERRSTATUS_P0_D0_U_SMXP_1_1",
        .addr = A_POR_ERRSTATUS_P0_D0_U_SMXP_1_1,
        .ro = 0xffffffff977f003fL,
    },{ .name = "POR_FDC_AUX_CTL_P0_D0_U_SMXP_1_1",
        .addr = A_POR_FDC_AUX_CTL_P0_D0_U_SMXP_1_1,
        .rsvd = 0xffffffffffffffe0L,
        .ro = 0xffffffffffffffe0L,
    },{ .name = "POR_ERRFR_P0_D1_U_SMXP_1_1",
        .addr = A_POR_ERRFR_P0_D1_U_SMXP_1_1,
        .reset = 0xa1,
        .rsvd = 0xffffffffffffff0cL,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_ERRCTLR_P0_D1_U_SMXP_1_1",
        .addr = A_POR_ERRCTLR_P0_D1_U_SMXP_1_1,
        .reset = 0xd,
        .rsvd = 0x3ff2,
        .ro = 0xffffffff00003ff2L,
    },{ .name = "POR_ERRSTATUS_P0_D1_U_SMXP_1_1",
        .addr = A_POR_ERRSTATUS_P0_D1_U_SMXP_1_1,
        .ro = 0xffffffff977f003fL,
    },{ .name = "POR_FDC_AUX_CTL_P0_D1_U_SMXP_1_1",
        .addr = A_POR_FDC_AUX_CTL_P0_D1_U_SMXP_1_1,
        .rsvd = 0xffffffffffffffe0L,
        .ro = 0xffffffffffffffe0L,
    },{ .name = "POR_ERRFR_P0_D2_U_SMXP_1_1",
        .addr = A_POR_ERRFR_P0_D2_U_SMXP_1_1,
        .reset = 0xa1,
        .rsvd = 0xffffffffffffff0cL,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_ERRCTLR_P0_D2_U_SMXP_1_1",
        .addr = A_POR_ERRCTLR_P0_D2_U_SMXP_1_1,
        .reset = 0xd,
        .rsvd = 0x3ff2,
        .ro = 0xffffffff00003ff2L,
    },{ .name = "POR_ERRSTATUS_P0_D2_U_SMXP_1_1",
        .addr = A_POR_ERRSTATUS_P0_D2_U_SMXP_1_1,
        .ro = 0xffffffff977f003fL,
    },{ .name = "POR_FDC_AUX_CTL_P0_D2_U_SMXP_1_1",
        .addr = A_POR_FDC_AUX_CTL_P0_D2_U_SMXP_1_1,
        .rsvd = 0xffffffffffffffe0L,
        .ro = 0xffffffffffffffe0L,
    },{ .name = "POR_ERRFR_P0_D3_U_SMXP_1_1",
        .addr = A_POR_ERRFR_P0_D3_U_SMXP_1_1,
        .reset = 0xa1,
        .rsvd = 0xffffffffffffff0cL,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_ERRCTLR_P0_D3_U_SMXP_1_1",
        .addr = A_POR_ERRCTLR_P0_D3_U_SMXP_1_1,
        .reset = 0xd,
        .rsvd = 0x3ff2,
        .ro = 0xffffffff00003ff2L,
    },{ .name = "POR_ERRSTATUS_P0_D3_U_SMXP_1_1",
        .addr = A_POR_ERRSTATUS_P0_D3_U_SMXP_1_1,
        .ro = 0xffffffff977f003fL,
    },{ .name = "POR_FDC_AUX_CTL_P0_D3_U_SMXP_1_1",
        .addr = A_POR_FDC_AUX_CTL_P0_D3_U_SMXP_1_1,
        .rsvd = 0xffffffffffffffe0L,
        .ro = 0xffffffffffffffe0L,
    },{ .name = "POR_ERRFR_P1_D0_U_SMXP_1_1",
        .addr = A_POR_ERRFR_P1_D0_U_SMXP_1_1,
        .reset = 0xa1,
        .rsvd = 0xffffffffffffff0cL,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_ERRCTLR_P1_D0_U_SMXP_1_1",
        .addr = A_POR_ERRCTLR_P1_D0_U_SMXP_1_1,
        .reset = 0xd,
        .rsvd = 0x3ff2,
        .ro = 0xffffffff00003ff2L,
    },{ .name = "POR_ERRSTATUS_P1_D0_U_SMXP_1_1",
        .addr = A_POR_ERRSTATUS_P1_D0_U_SMXP_1_1,
        .ro = 0xffffffff977f003fL,
    },{ .name = "POR_FDC_AUX_CTL_P1_D0_U_SMXP_1_1",
        .addr = A_POR_FDC_AUX_CTL_P1_D0_U_SMXP_1_1,
        .rsvd = 0xffffffffffffffe0L,
        .ro = 0xffffffffffffffe0L,
    },{ .name = "POR_ERRFR_P1_D1_U_SMXP_1_1",
        .addr = A_POR_ERRFR_P1_D1_U_SMXP_1_1,
        .reset = 0xa1,
        .rsvd = 0xffffffffffffff0cL,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_ERRCTLR_P1_D1_U_SMXP_1_1",
        .addr = A_POR_ERRCTLR_P1_D1_U_SMXP_1_1,
        .reset = 0xd,
        .rsvd = 0x3ff2,
        .ro = 0xffffffff00003ff2L,
    },{ .name = "POR_ERRSTATUS_P1_D1_U_SMXP_1_1",
        .addr = A_POR_ERRSTATUS_P1_D1_U_SMXP_1_1,
        .ro = 0xffffffff977f003fL,
    },{ .name = "POR_FDC_AUX_CTL_P1_D1_U_SMXP_1_1",
        .addr = A_POR_FDC_AUX_CTL_P1_D1_U_SMXP_1_1,
        .rsvd = 0xffffffffffffffe0L,
        .ro = 0xffffffffffffffe0L,
    },{ .name = "POR_ERRFR_P1_D2_U_SMXP_1_1",
        .addr = A_POR_ERRFR_P1_D2_U_SMXP_1_1,
        .reset = 0xa1,
        .rsvd = 0xffffffffffffff0cL,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_ERRCTLR_P1_D2_U_SMXP_1_1",
        .addr = A_POR_ERRCTLR_P1_D2_U_SMXP_1_1,
        .reset = 0xd,
        .rsvd = 0x3ff2,
        .ro = 0xffffffff00003ff2L,
    },{ .name = "POR_ERRSTATUS_P1_D2_U_SMXP_1_1",
        .addr = A_POR_ERRSTATUS_P1_D2_U_SMXP_1_1,
        .ro = 0xffffffff977f003fL,
    },{ .name = "POR_FDC_AUX_CTL_P1_D2_U_SMXP_1_1",
        .addr = A_POR_FDC_AUX_CTL_P1_D2_U_SMXP_1_1,
        .rsvd = 0xffffffffffffffe0L,
        .ro = 0xffffffffffffffe0L,
    },{ .name = "POR_ERRFR_P1_D3_U_SMXP_1_1",
        .addr = A_POR_ERRFR_P1_D3_U_SMXP_1_1,
        .reset = 0xa1,
        .rsvd = 0xffffffffffffff0cL,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_ERRCTLR_P1_D3_U_SMXP_1_1",
        .addr = A_POR_ERRCTLR_P1_D3_U_SMXP_1_1,
        .reset = 0xd,
        .rsvd = 0x3ff2,
        .ro = 0xffffffff00003ff2L,
    },{ .name = "POR_ERRSTATUS_P1_D3_U_SMXP_1_1",
        .addr = A_POR_ERRSTATUS_P1_D3_U_SMXP_1_1,
        .ro = 0xffffffff977f003fL,
    },{ .name = "POR_FDC_AUX_CTL_P1_D3_U_SMXP_1_1",
        .addr = A_POR_FDC_AUX_CTL_P1_D3_U_SMXP_1_1,
        .rsvd = 0xffffffffffffffe0L,
        .ro = 0xffffffffffffffe0L,
    },{ .name = "POR_ERRINJECT_U_SMXP_1_1",  .addr = A_POR_ERRINJECT_U_SMXP_1_1,
        .rsvd = 0xffffffffffffff00L,
        .ro = 0xffffffffffffff00L,
    },{ .name = "POR_FDC_KEY_U_SMXP_1_1",  .addr = A_POR_FDC_KEY_U_SMXP_1_1,
        .reset = 0xbe,
        .rsvd = 0xffffffffffffff00L,
        .ro = 0xffffffffffffff00L,
    },{ .name = "POR_MPU_NODE_INFO_U_SMXP_1_1",
        .addr = A_POR_MPU_NODE_INFO_U_SMXP_1_1,
        .reset = 0x202,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MPU_CHILD_INFO_U_SMXP_1_1",
        .addr = A_POR_MPU_CHILD_INFO_U_SMXP_1_1,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MPU_UNIT_INFO_U_SMXP_1_1",
        .addr = A_POR_MPU_UNIT_INFO_U_SMXP_1_1,
        .reset = 0x20,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MPU_M0_CTL_U_SMXP_1_1",
        .addr = A_POR_MPU_M0_CTL_U_SMXP_1_1,
        .reset = 0x2,
        .rsvd = 0xfffffffffffffff8L,
        .ro = 0xfffffffffffffff8L,
    },{ .name = "POR_MPU_M0_PRBAR0_U_SMXP_1_1",
        .addr = A_POR_MPU_M0_PRBAR0_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR0_U_SMXP_1_1",
        .addr = A_POR_MPU_M0_PRLAR0_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR1_U_SMXP_1_1",
        .addr = A_POR_MPU_M0_PRBAR1_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR1_U_SMXP_1_1",
        .addr = A_POR_MPU_M0_PRLAR1_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR2_U_SMXP_1_1",
        .addr = A_POR_MPU_M0_PRBAR2_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR2_U_SMXP_1_1",
        .addr = A_POR_MPU_M0_PRLAR2_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR3_U_SMXP_1_1",
        .addr = A_POR_MPU_M0_PRBAR3_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR3_U_SMXP_1_1",
        .addr = A_POR_MPU_M0_PRLAR3_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR4_U_SMXP_1_1",
        .addr = A_POR_MPU_M0_PRBAR4_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR4_U_SMXP_1_1",
        .addr = A_POR_MPU_M0_PRLAR4_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR5_U_SMXP_1_1",
        .addr = A_POR_MPU_M0_PRBAR5_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR5_U_SMXP_1_1",
        .addr = A_POR_MPU_M0_PRLAR5_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR6_U_SMXP_1_1",
        .addr = A_POR_MPU_M0_PRBAR6_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR6_U_SMXP_1_1",
        .addr = A_POR_MPU_M0_PRLAR6_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR7_U_SMXP_1_1",
        .addr = A_POR_MPU_M0_PRBAR7_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR7_U_SMXP_1_1",
        .addr = A_POR_MPU_M0_PRLAR7_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR8_U_SMXP_1_1",
        .addr = A_POR_MPU_M0_PRBAR8_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR8_U_SMXP_1_1",
        .addr = A_POR_MPU_M0_PRLAR8_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR9_U_SMXP_1_1",
        .addr = A_POR_MPU_M0_PRBAR9_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR9_U_SMXP_1_1",
        .addr = A_POR_MPU_M0_PRLAR9_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR10_U_SMXP_1_1",
        .addr = A_POR_MPU_M0_PRBAR10_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR10_U_SMXP_1_1",
        .addr = A_POR_MPU_M0_PRLAR10_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR11_U_SMXP_1_1",
        .addr = A_POR_MPU_M0_PRBAR11_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR11_U_SMXP_1_1",
        .addr = A_POR_MPU_M0_PRLAR11_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR12_U_SMXP_1_1",
        .addr = A_POR_MPU_M0_PRBAR12_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR12_U_SMXP_1_1",
        .addr = A_POR_MPU_M0_PRLAR12_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR13_U_SMXP_1_1",
        .addr = A_POR_MPU_M0_PRBAR13_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR13_U_SMXP_1_1",
        .addr = A_POR_MPU_M0_PRLAR13_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR14_U_SMXP_1_1",
        .addr = A_POR_MPU_M0_PRBAR14_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR14_U_SMXP_1_1",
        .addr = A_POR_MPU_M0_PRLAR14_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR15_U_SMXP_1_1",
        .addr = A_POR_MPU_M0_PRBAR15_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR15_U_SMXP_1_1",
        .addr = A_POR_MPU_M0_PRLAR15_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR16_U_SMXP_1_1",
        .addr = A_POR_MPU_M0_PRBAR16_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR16_U_SMXP_1_1",
        .addr = A_POR_MPU_M0_PRLAR16_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR17_U_SMXP_1_1",
        .addr = A_POR_MPU_M0_PRBAR17_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR17_U_SMXP_1_1",
        .addr = A_POR_MPU_M0_PRLAR17_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR18_U_SMXP_1_1",
        .addr = A_POR_MPU_M0_PRBAR18_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR18_U_SMXP_1_1",
        .addr = A_POR_MPU_M0_PRLAR18_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR19_U_SMXP_1_1",
        .addr = A_POR_MPU_M0_PRBAR19_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR19_U_SMXP_1_1",
        .addr = A_POR_MPU_M0_PRLAR19_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR20_U_SMXP_1_1",
        .addr = A_POR_MPU_M0_PRBAR20_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR20_U_SMXP_1_1",
        .addr = A_POR_MPU_M0_PRLAR20_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR21_U_SMXP_1_1",
        .addr = A_POR_MPU_M0_PRBAR21_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR21_U_SMXP_1_1",
        .addr = A_POR_MPU_M0_PRLAR21_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR22_U_SMXP_1_1",
        .addr = A_POR_MPU_M0_PRBAR22_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR22_U_SMXP_1_1",
        .addr = A_POR_MPU_M0_PRLAR22_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR23_U_SMXP_1_1",
        .addr = A_POR_MPU_M0_PRBAR23_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR23_U_SMXP_1_1",
        .addr = A_POR_MPU_M0_PRLAR23_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR24_U_SMXP_1_1",
        .addr = A_POR_MPU_M0_PRBAR24_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR24_U_SMXP_1_1",
        .addr = A_POR_MPU_M0_PRLAR24_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR25_U_SMXP_1_1",
        .addr = A_POR_MPU_M0_PRBAR25_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR25_U_SMXP_1_1",
        .addr = A_POR_MPU_M0_PRLAR25_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR26_U_SMXP_1_1",
        .addr = A_POR_MPU_M0_PRBAR26_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR26_U_SMXP_1_1",
        .addr = A_POR_MPU_M0_PRLAR26_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR27_U_SMXP_1_1",
        .addr = A_POR_MPU_M0_PRBAR27_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR27_U_SMXP_1_1",
        .addr = A_POR_MPU_M0_PRLAR27_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR28_U_SMXP_1_1",
        .addr = A_POR_MPU_M0_PRBAR28_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR28_U_SMXP_1_1",
        .addr = A_POR_MPU_M0_PRLAR28_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR29_U_SMXP_1_1",
        .addr = A_POR_MPU_M0_PRBAR29_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR29_U_SMXP_1_1",
        .addr = A_POR_MPU_M0_PRLAR29_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR30_U_SMXP_1_1",
        .addr = A_POR_MPU_M0_PRBAR30_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR30_U_SMXP_1_1",
        .addr = A_POR_MPU_M0_PRLAR30_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR31_U_SMXP_1_1",
        .addr = A_POR_MPU_M0_PRBAR31_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR31_U_SMXP_1_1",
        .addr = A_POR_MPU_M0_PRLAR31_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_CTL_U_SMXP_1_1",
        .addr = A_POR_MPU_M1_CTL_U_SMXP_1_1,
        .reset = 0x2,
        .rsvd = 0xfffffffffffffff8L,
        .ro = 0xfffffffffffffff8L,
    },{ .name = "POR_MPU_M1_PRBAR0_U_SMXP_1_1",
        .addr = A_POR_MPU_M1_PRBAR0_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR0_U_SMXP_1_1",
        .addr = A_POR_MPU_M1_PRLAR0_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR1_U_SMXP_1_1",
        .addr = A_POR_MPU_M1_PRBAR1_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR1_U_SMXP_1_1",
        .addr = A_POR_MPU_M1_PRLAR1_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR2_U_SMXP_1_1",
        .addr = A_POR_MPU_M1_PRBAR2_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR2_U_SMXP_1_1",
        .addr = A_POR_MPU_M1_PRLAR2_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR3_U_SMXP_1_1",
        .addr = A_POR_MPU_M1_PRBAR3_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR3_U_SMXP_1_1",
        .addr = A_POR_MPU_M1_PRLAR3_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR4_U_SMXP_1_1",
        .addr = A_POR_MPU_M1_PRBAR4_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR4_U_SMXP_1_1",
        .addr = A_POR_MPU_M1_PRLAR4_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR5_U_SMXP_1_1",
        .addr = A_POR_MPU_M1_PRBAR5_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR5_U_SMXP_1_1",
        .addr = A_POR_MPU_M1_PRLAR5_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR6_U_SMXP_1_1",
        .addr = A_POR_MPU_M1_PRBAR6_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR6_U_SMXP_1_1",
        .addr = A_POR_MPU_M1_PRLAR6_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR7_U_SMXP_1_1",
        .addr = A_POR_MPU_M1_PRBAR7_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR7_U_SMXP_1_1",
        .addr = A_POR_MPU_M1_PRLAR7_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR8_U_SMXP_1_1",
        .addr = A_POR_MPU_M1_PRBAR8_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR8_U_SMXP_1_1",
        .addr = A_POR_MPU_M1_PRLAR8_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR9_U_SMXP_1_1",
        .addr = A_POR_MPU_M1_PRBAR9_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR9_U_SMXP_1_1",
        .addr = A_POR_MPU_M1_PRLAR9_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR10_U_SMXP_1_1",
        .addr = A_POR_MPU_M1_PRBAR10_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR10_U_SMXP_1_1",
        .addr = A_POR_MPU_M1_PRLAR10_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR11_U_SMXP_1_1",
        .addr = A_POR_MPU_M1_PRBAR11_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR11_U_SMXP_1_1",
        .addr = A_POR_MPU_M1_PRLAR11_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR12_U_SMXP_1_1",
        .addr = A_POR_MPU_M1_PRBAR12_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR12_U_SMXP_1_1",
        .addr = A_POR_MPU_M1_PRLAR12_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR13_U_SMXP_1_1",
        .addr = A_POR_MPU_M1_PRBAR13_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR13_U_SMXP_1_1",
        .addr = A_POR_MPU_M1_PRLAR13_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR14_U_SMXP_1_1",
        .addr = A_POR_MPU_M1_PRBAR14_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR14_U_SMXP_1_1",
        .addr = A_POR_MPU_M1_PRLAR14_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR15_U_SMXP_1_1",
        .addr = A_POR_MPU_M1_PRBAR15_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR15_U_SMXP_1_1",
        .addr = A_POR_MPU_M1_PRLAR15_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR16_U_SMXP_1_1",
        .addr = A_POR_MPU_M1_PRBAR16_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR16_U_SMXP_1_1",
        .addr = A_POR_MPU_M1_PRLAR16_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR17_U_SMXP_1_1",
        .addr = A_POR_MPU_M1_PRBAR17_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR17_U_SMXP_1_1",
        .addr = A_POR_MPU_M1_PRLAR17_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR18_U_SMXP_1_1",
        .addr = A_POR_MPU_M1_PRBAR18_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR18_U_SMXP_1_1",
        .addr = A_POR_MPU_M1_PRLAR18_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR19_U_SMXP_1_1",
        .addr = A_POR_MPU_M1_PRBAR19_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR19_U_SMXP_1_1",
        .addr = A_POR_MPU_M1_PRLAR19_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR20_U_SMXP_1_1",
        .addr = A_POR_MPU_M1_PRBAR20_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR20_U_SMXP_1_1",
        .addr = A_POR_MPU_M1_PRLAR20_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR21_U_SMXP_1_1",
        .addr = A_POR_MPU_M1_PRBAR21_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR21_U_SMXP_1_1",
        .addr = A_POR_MPU_M1_PRLAR21_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR22_U_SMXP_1_1",
        .addr = A_POR_MPU_M1_PRBAR22_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR22_U_SMXP_1_1",
        .addr = A_POR_MPU_M1_PRLAR22_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR23_U_SMXP_1_1",
        .addr = A_POR_MPU_M1_PRBAR23_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR23_U_SMXP_1_1",
        .addr = A_POR_MPU_M1_PRLAR23_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR24_U_SMXP_1_1",
        .addr = A_POR_MPU_M1_PRBAR24_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR24_U_SMXP_1_1",
        .addr = A_POR_MPU_M1_PRLAR24_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR25_U_SMXP_1_1",
        .addr = A_POR_MPU_M1_PRBAR25_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR25_U_SMXP_1_1",
        .addr = A_POR_MPU_M1_PRLAR25_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR26_U_SMXP_1_1",
        .addr = A_POR_MPU_M1_PRBAR26_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR26_U_SMXP_1_1",
        .addr = A_POR_MPU_M1_PRLAR26_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR27_U_SMXP_1_1",
        .addr = A_POR_MPU_M1_PRBAR27_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR27_U_SMXP_1_1",
        .addr = A_POR_MPU_M1_PRLAR27_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR28_U_SMXP_1_1",
        .addr = A_POR_MPU_M1_PRBAR28_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR28_U_SMXP_1_1",
        .addr = A_POR_MPU_M1_PRLAR28_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR29_U_SMXP_1_1",
        .addr = A_POR_MPU_M1_PRBAR29_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR29_U_SMXP_1_1",
        .addr = A_POR_MPU_M1_PRLAR29_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR30_U_SMXP_1_1",
        .addr = A_POR_MPU_M1_PRBAR30_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR30_U_SMXP_1_1",
        .addr = A_POR_MPU_M1_PRLAR30_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR31_U_SMXP_1_1",
        .addr = A_POR_MPU_M1_PRBAR31_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR31_U_SMXP_1_1",
        .addr = A_POR_MPU_M1_PRLAR31_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_CTL_U_SMXP_1_1",
        .addr = A_POR_MPU_M2_CTL_U_SMXP_1_1,
        .reset = 0x2,
        .rsvd = 0xfffffffffffffff8L,
        .ro = 0xfffffffffffffff8L,
    },{ .name = "POR_MPU_M2_PRBAR0_U_SMXP_1_1",
        .addr = A_POR_MPU_M2_PRBAR0_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR0_U_SMXP_1_1",
        .addr = A_POR_MPU_M2_PRLAR0_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR1_U_SMXP_1_1",
        .addr = A_POR_MPU_M2_PRBAR1_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR1_U_SMXP_1_1",
        .addr = A_POR_MPU_M2_PRLAR1_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR2_U_SMXP_1_1",
        .addr = A_POR_MPU_M2_PRBAR2_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR2_U_SMXP_1_1",
        .addr = A_POR_MPU_M2_PRLAR2_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR3_U_SMXP_1_1",
        .addr = A_POR_MPU_M2_PRBAR3_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR3_U_SMXP_1_1",
        .addr = A_POR_MPU_M2_PRLAR3_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR4_U_SMXP_1_1",
        .addr = A_POR_MPU_M2_PRBAR4_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR4_U_SMXP_1_1",
        .addr = A_POR_MPU_M2_PRLAR4_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR5_U_SMXP_1_1",
        .addr = A_POR_MPU_M2_PRBAR5_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR5_U_SMXP_1_1",
        .addr = A_POR_MPU_M2_PRLAR5_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR6_U_SMXP_1_1",
        .addr = A_POR_MPU_M2_PRBAR6_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR6_U_SMXP_1_1",
        .addr = A_POR_MPU_M2_PRLAR6_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR7_U_SMXP_1_1",
        .addr = A_POR_MPU_M2_PRBAR7_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR7_U_SMXP_1_1",
        .addr = A_POR_MPU_M2_PRLAR7_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR8_U_SMXP_1_1",
        .addr = A_POR_MPU_M2_PRBAR8_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR8_U_SMXP_1_1",
        .addr = A_POR_MPU_M2_PRLAR8_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR9_U_SMXP_1_1",
        .addr = A_POR_MPU_M2_PRBAR9_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR9_U_SMXP_1_1",
        .addr = A_POR_MPU_M2_PRLAR9_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR10_U_SMXP_1_1",
        .addr = A_POR_MPU_M2_PRBAR10_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR10_U_SMXP_1_1",
        .addr = A_POR_MPU_M2_PRLAR10_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR11_U_SMXP_1_1",
        .addr = A_POR_MPU_M2_PRBAR11_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR11_U_SMXP_1_1",
        .addr = A_POR_MPU_M2_PRLAR11_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR12_U_SMXP_1_1",
        .addr = A_POR_MPU_M2_PRBAR12_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR12_U_SMXP_1_1",
        .addr = A_POR_MPU_M2_PRLAR12_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR13_U_SMXP_1_1",
        .addr = A_POR_MPU_M2_PRBAR13_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR13_U_SMXP_1_1",
        .addr = A_POR_MPU_M2_PRLAR13_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR14_U_SMXP_1_1",
        .addr = A_POR_MPU_M2_PRBAR14_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR14_U_SMXP_1_1",
        .addr = A_POR_MPU_M2_PRLAR14_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR15_U_SMXP_1_1",
        .addr = A_POR_MPU_M2_PRBAR15_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR15_U_SMXP_1_1",
        .addr = A_POR_MPU_M2_PRLAR15_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR16_U_SMXP_1_1",
        .addr = A_POR_MPU_M2_PRBAR16_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR16_U_SMXP_1_1",
        .addr = A_POR_MPU_M2_PRLAR16_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR17_U_SMXP_1_1",
        .addr = A_POR_MPU_M2_PRBAR17_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR17_U_SMXP_1_1",
        .addr = A_POR_MPU_M2_PRLAR17_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR18_U_SMXP_1_1",
        .addr = A_POR_MPU_M2_PRBAR18_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR18_U_SMXP_1_1",
        .addr = A_POR_MPU_M2_PRLAR18_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR19_U_SMXP_1_1",
        .addr = A_POR_MPU_M2_PRBAR19_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR19_U_SMXP_1_1",
        .addr = A_POR_MPU_M2_PRLAR19_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR20_U_SMXP_1_1",
        .addr = A_POR_MPU_M2_PRBAR20_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR20_U_SMXP_1_1",
        .addr = A_POR_MPU_M2_PRLAR20_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR21_U_SMXP_1_1",
        .addr = A_POR_MPU_M2_PRBAR21_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR21_U_SMXP_1_1",
        .addr = A_POR_MPU_M2_PRLAR21_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR22_U_SMXP_1_1",
        .addr = A_POR_MPU_M2_PRBAR22_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR22_U_SMXP_1_1",
        .addr = A_POR_MPU_M2_PRLAR22_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR23_U_SMXP_1_1",
        .addr = A_POR_MPU_M2_PRBAR23_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR23_U_SMXP_1_1",
        .addr = A_POR_MPU_M2_PRLAR23_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR24_U_SMXP_1_1",
        .addr = A_POR_MPU_M2_PRBAR24_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR24_U_SMXP_1_1",
        .addr = A_POR_MPU_M2_PRLAR24_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR25_U_SMXP_1_1",
        .addr = A_POR_MPU_M2_PRBAR25_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR25_U_SMXP_1_1",
        .addr = A_POR_MPU_M2_PRLAR25_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR26_U_SMXP_1_1",
        .addr = A_POR_MPU_M2_PRBAR26_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR26_U_SMXP_1_1",
        .addr = A_POR_MPU_M2_PRLAR26_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR27_U_SMXP_1_1",
        .addr = A_POR_MPU_M2_PRBAR27_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR27_U_SMXP_1_1",
        .addr = A_POR_MPU_M2_PRLAR27_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR28_U_SMXP_1_1",
        .addr = A_POR_MPU_M2_PRBAR28_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR28_U_SMXP_1_1",
        .addr = A_POR_MPU_M2_PRLAR28_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR29_U_SMXP_1_1",
        .addr = A_POR_MPU_M2_PRBAR29_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR29_U_SMXP_1_1",
        .addr = A_POR_MPU_M2_PRLAR29_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR30_U_SMXP_1_1",
        .addr = A_POR_MPU_M2_PRBAR30_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR30_U_SMXP_1_1",
        .addr = A_POR_MPU_M2_PRLAR30_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR31_U_SMXP_1_1",
        .addr = A_POR_MPU_M2_PRBAR31_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR31_U_SMXP_1_1",
        .addr = A_POR_MPU_M2_PRLAR31_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_CTL_U_SMXP_1_1",
        .addr = A_POR_MPU_M3_CTL_U_SMXP_1_1,
        .reset = 0x2,
        .rsvd = 0xfffffffffffffff8L,
        .ro = 0xfffffffffffffff8L,
    },{ .name = "POR_MPU_M3_PRBAR0_U_SMXP_1_1",
        .addr = A_POR_MPU_M3_PRBAR0_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR0_U_SMXP_1_1",
        .addr = A_POR_MPU_M3_PRLAR0_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR1_U_SMXP_1_1",
        .addr = A_POR_MPU_M3_PRBAR1_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR1_U_SMXP_1_1",
        .addr = A_POR_MPU_M3_PRLAR1_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR2_U_SMXP_1_1",
        .addr = A_POR_MPU_M3_PRBAR2_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR2_U_SMXP_1_1",
        .addr = A_POR_MPU_M3_PRLAR2_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR3_U_SMXP_1_1",
        .addr = A_POR_MPU_M3_PRBAR3_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR3_U_SMXP_1_1",
        .addr = A_POR_MPU_M3_PRLAR3_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR4_U_SMXP_1_1",
        .addr = A_POR_MPU_M3_PRBAR4_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR4_U_SMXP_1_1",
        .addr = A_POR_MPU_M3_PRLAR4_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR5_U_SMXP_1_1",
        .addr = A_POR_MPU_M3_PRBAR5_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR5_U_SMXP_1_1",
        .addr = A_POR_MPU_M3_PRLAR5_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR6_U_SMXP_1_1",
        .addr = A_POR_MPU_M3_PRBAR6_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR6_U_SMXP_1_1",
        .addr = A_POR_MPU_M3_PRLAR6_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR7_U_SMXP_1_1",
        .addr = A_POR_MPU_M3_PRBAR7_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR7_U_SMXP_1_1",
        .addr = A_POR_MPU_M3_PRLAR7_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR8_U_SMXP_1_1",
        .addr = A_POR_MPU_M3_PRBAR8_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR8_U_SMXP_1_1",
        .addr = A_POR_MPU_M3_PRLAR8_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR9_U_SMXP_1_1",
        .addr = A_POR_MPU_M3_PRBAR9_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR9_U_SMXP_1_1",
        .addr = A_POR_MPU_M3_PRLAR9_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR10_U_SMXP_1_1",
        .addr = A_POR_MPU_M3_PRBAR10_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR10_U_SMXP_1_1",
        .addr = A_POR_MPU_M3_PRLAR10_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR11_U_SMXP_1_1",
        .addr = A_POR_MPU_M3_PRBAR11_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR11_U_SMXP_1_1",
        .addr = A_POR_MPU_M3_PRLAR11_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR12_U_SMXP_1_1",
        .addr = A_POR_MPU_M3_PRBAR12_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR12_U_SMXP_1_1",
        .addr = A_POR_MPU_M3_PRLAR12_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR13_U_SMXP_1_1",
        .addr = A_POR_MPU_M3_PRBAR13_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR13_U_SMXP_1_1",
        .addr = A_POR_MPU_M3_PRLAR13_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR14_U_SMXP_1_1",
        .addr = A_POR_MPU_M3_PRBAR14_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR14_U_SMXP_1_1",
        .addr = A_POR_MPU_M3_PRLAR14_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR15_U_SMXP_1_1",
        .addr = A_POR_MPU_M3_PRBAR15_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR15_U_SMXP_1_1",
        .addr = A_POR_MPU_M3_PRLAR15_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR16_U_SMXP_1_1",
        .addr = A_POR_MPU_M3_PRBAR16_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR16_U_SMXP_1_1",
        .addr = A_POR_MPU_M3_PRLAR16_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR17_U_SMXP_1_1",
        .addr = A_POR_MPU_M3_PRBAR17_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR17_U_SMXP_1_1",
        .addr = A_POR_MPU_M3_PRLAR17_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR18_U_SMXP_1_1",
        .addr = A_POR_MPU_M3_PRBAR18_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR18_U_SMXP_1_1",
        .addr = A_POR_MPU_M3_PRLAR18_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR19_U_SMXP_1_1",
        .addr = A_POR_MPU_M3_PRBAR19_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR19_U_SMXP_1_1",
        .addr = A_POR_MPU_M3_PRLAR19_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR20_U_SMXP_1_1",
        .addr = A_POR_MPU_M3_PRBAR20_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR20_U_SMXP_1_1",
        .addr = A_POR_MPU_M3_PRLAR20_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR21_U_SMXP_1_1",
        .addr = A_POR_MPU_M3_PRBAR21_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR21_U_SMXP_1_1",
        .addr = A_POR_MPU_M3_PRLAR21_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR22_U_SMXP_1_1",
        .addr = A_POR_MPU_M3_PRBAR22_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR22_U_SMXP_1_1",
        .addr = A_POR_MPU_M3_PRLAR22_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR23_U_SMXP_1_1",
        .addr = A_POR_MPU_M3_PRBAR23_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR23_U_SMXP_1_1",
        .addr = A_POR_MPU_M3_PRLAR23_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR24_U_SMXP_1_1",
        .addr = A_POR_MPU_M3_PRBAR24_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR24_U_SMXP_1_1",
        .addr = A_POR_MPU_M3_PRLAR24_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR25_U_SMXP_1_1",
        .addr = A_POR_MPU_M3_PRBAR25_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR25_U_SMXP_1_1",
        .addr = A_POR_MPU_M3_PRLAR25_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR26_U_SMXP_1_1",
        .addr = A_POR_MPU_M3_PRBAR26_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR26_U_SMXP_1_1",
        .addr = A_POR_MPU_M3_PRLAR26_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR27_U_SMXP_1_1",
        .addr = A_POR_MPU_M3_PRBAR27_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR27_U_SMXP_1_1",
        .addr = A_POR_MPU_M3_PRLAR27_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR28_U_SMXP_1_1",
        .addr = A_POR_MPU_M3_PRBAR28_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR28_U_SMXP_1_1",
        .addr = A_POR_MPU_M3_PRLAR28_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR29_U_SMXP_1_1",
        .addr = A_POR_MPU_M3_PRBAR29_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR29_U_SMXP_1_1",
        .addr = A_POR_MPU_M3_PRLAR29_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR30_U_SMXP_1_1",
        .addr = A_POR_MPU_M3_PRBAR30_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR30_U_SMXP_1_1",
        .addr = A_POR_MPU_M3_PRLAR30_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR31_U_SMXP_1_1",
        .addr = A_POR_MPU_M3_PRBAR31_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR31_U_SMXP_1_1",
        .addr = A_POR_MPU_M3_PRLAR31_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_CTL_U_SMXP_1_1",
        .addr = A_POR_MPU_M4_CTL_U_SMXP_1_1,
        .reset = 0x2,
        .rsvd = 0xfffffffffffffff8L,
        .ro = 0xfffffffffffffff8L,
    },{ .name = "POR_MPU_M4_PRBAR0_U_SMXP_1_1",
        .addr = A_POR_MPU_M4_PRBAR0_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR0_U_SMXP_1_1",
        .addr = A_POR_MPU_M4_PRLAR0_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR1_U_SMXP_1_1",
        .addr = A_POR_MPU_M4_PRBAR1_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR1_U_SMXP_1_1",
        .addr = A_POR_MPU_M4_PRLAR1_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR2_U_SMXP_1_1",
        .addr = A_POR_MPU_M4_PRBAR2_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR2_U_SMXP_1_1",
        .addr = A_POR_MPU_M4_PRLAR2_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR3_U_SMXP_1_1",
        .addr = A_POR_MPU_M4_PRBAR3_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR3_U_SMXP_1_1",
        .addr = A_POR_MPU_M4_PRLAR3_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR4_U_SMXP_1_1",
        .addr = A_POR_MPU_M4_PRBAR4_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR4_U_SMXP_1_1",
        .addr = A_POR_MPU_M4_PRLAR4_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR5_U_SMXP_1_1",
        .addr = A_POR_MPU_M4_PRBAR5_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR5_U_SMXP_1_1",
        .addr = A_POR_MPU_M4_PRLAR5_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR6_U_SMXP_1_1",
        .addr = A_POR_MPU_M4_PRBAR6_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR6_U_SMXP_1_1",
        .addr = A_POR_MPU_M4_PRLAR6_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR7_U_SMXP_1_1",
        .addr = A_POR_MPU_M4_PRBAR7_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR7_U_SMXP_1_1",
        .addr = A_POR_MPU_M4_PRLAR7_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR8_U_SMXP_1_1",
        .addr = A_POR_MPU_M4_PRBAR8_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR8_U_SMXP_1_1",
        .addr = A_POR_MPU_M4_PRLAR8_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR9_U_SMXP_1_1",
        .addr = A_POR_MPU_M4_PRBAR9_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR9_U_SMXP_1_1",
        .addr = A_POR_MPU_M4_PRLAR9_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR10_U_SMXP_1_1",
        .addr = A_POR_MPU_M4_PRBAR10_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR10_U_SMXP_1_1",
        .addr = A_POR_MPU_M4_PRLAR10_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR11_U_SMXP_1_1",
        .addr = A_POR_MPU_M4_PRBAR11_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR11_U_SMXP_1_1",
        .addr = A_POR_MPU_M4_PRLAR11_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR12_U_SMXP_1_1",
        .addr = A_POR_MPU_M4_PRBAR12_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR12_U_SMXP_1_1",
        .addr = A_POR_MPU_M4_PRLAR12_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR13_U_SMXP_1_1",
        .addr = A_POR_MPU_M4_PRBAR13_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR13_U_SMXP_1_1",
        .addr = A_POR_MPU_M4_PRLAR13_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR14_U_SMXP_1_1",
        .addr = A_POR_MPU_M4_PRBAR14_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR14_U_SMXP_1_1",
        .addr = A_POR_MPU_M4_PRLAR14_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR15_U_SMXP_1_1",
        .addr = A_POR_MPU_M4_PRBAR15_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR15_U_SMXP_1_1",
        .addr = A_POR_MPU_M4_PRLAR15_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR16_U_SMXP_1_1",
        .addr = A_POR_MPU_M4_PRBAR16_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR16_U_SMXP_1_1",
        .addr = A_POR_MPU_M4_PRLAR16_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR17_U_SMXP_1_1",
        .addr = A_POR_MPU_M4_PRBAR17_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR17_U_SMXP_1_1",
        .addr = A_POR_MPU_M4_PRLAR17_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR18_U_SMXP_1_1",
        .addr = A_POR_MPU_M4_PRBAR18_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR18_U_SMXP_1_1",
        .addr = A_POR_MPU_M4_PRLAR18_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR19_U_SMXP_1_1",
        .addr = A_POR_MPU_M4_PRBAR19_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR19_U_SMXP_1_1",
        .addr = A_POR_MPU_M4_PRLAR19_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR20_U_SMXP_1_1",
        .addr = A_POR_MPU_M4_PRBAR20_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR20_U_SMXP_1_1",
        .addr = A_POR_MPU_M4_PRLAR20_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR21_U_SMXP_1_1",
        .addr = A_POR_MPU_M4_PRBAR21_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR21_U_SMXP_1_1",
        .addr = A_POR_MPU_M4_PRLAR21_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR22_U_SMXP_1_1",
        .addr = A_POR_MPU_M4_PRBAR22_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR22_U_SMXP_1_1",
        .addr = A_POR_MPU_M4_PRLAR22_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR23_U_SMXP_1_1",
        .addr = A_POR_MPU_M4_PRBAR23_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR23_U_SMXP_1_1",
        .addr = A_POR_MPU_M4_PRLAR23_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR24_U_SMXP_1_1",
        .addr = A_POR_MPU_M4_PRBAR24_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR24_U_SMXP_1_1",
        .addr = A_POR_MPU_M4_PRLAR24_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR25_U_SMXP_1_1",
        .addr = A_POR_MPU_M4_PRBAR25_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR25_U_SMXP_1_1",
        .addr = A_POR_MPU_M4_PRLAR25_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR26_U_SMXP_1_1",
        .addr = A_POR_MPU_M4_PRBAR26_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR26_U_SMXP_1_1",
        .addr = A_POR_MPU_M4_PRLAR26_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR27_U_SMXP_1_1",
        .addr = A_POR_MPU_M4_PRBAR27_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR27_U_SMXP_1_1",
        .addr = A_POR_MPU_M4_PRLAR27_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR28_U_SMXP_1_1",
        .addr = A_POR_MPU_M4_PRBAR28_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR28_U_SMXP_1_1",
        .addr = A_POR_MPU_M4_PRLAR28_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR29_U_SMXP_1_1",
        .addr = A_POR_MPU_M4_PRBAR29_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR29_U_SMXP_1_1",
        .addr = A_POR_MPU_M4_PRLAR29_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR30_U_SMXP_1_1",
        .addr = A_POR_MPU_M4_PRBAR30_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR30_U_SMXP_1_1",
        .addr = A_POR_MPU_M4_PRLAR30_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR31_U_SMXP_1_1",
        .addr = A_POR_MPU_M4_PRBAR31_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR31_U_SMXP_1_1",
        .addr = A_POR_MPU_M4_PRLAR31_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_CTL_U_SMXP_1_1",
        .addr = A_POR_MPU_M5_CTL_U_SMXP_1_1,
        .reset = 0x2,
        .rsvd = 0xfffffffffffffff8L,
        .ro = 0xfffffffffffffff8L,
    },{ .name = "POR_MPU_M5_PRBAR0_U_SMXP_1_1",
        .addr = A_POR_MPU_M5_PRBAR0_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR0_U_SMXP_1_1",
        .addr = A_POR_MPU_M5_PRLAR0_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR1_U_SMXP_1_1",
        .addr = A_POR_MPU_M5_PRBAR1_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR1_U_SMXP_1_1",
        .addr = A_POR_MPU_M5_PRLAR1_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR2_U_SMXP_1_1",
        .addr = A_POR_MPU_M5_PRBAR2_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR2_U_SMXP_1_1",
        .addr = A_POR_MPU_M5_PRLAR2_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR3_U_SMXP_1_1",
        .addr = A_POR_MPU_M5_PRBAR3_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR3_U_SMXP_1_1",
        .addr = A_POR_MPU_M5_PRLAR3_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR4_U_SMXP_1_1",
        .addr = A_POR_MPU_M5_PRBAR4_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR4_U_SMXP_1_1",
        .addr = A_POR_MPU_M5_PRLAR4_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR5_U_SMXP_1_1",
        .addr = A_POR_MPU_M5_PRBAR5_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR5_U_SMXP_1_1",
        .addr = A_POR_MPU_M5_PRLAR5_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR6_U_SMXP_1_1",
        .addr = A_POR_MPU_M5_PRBAR6_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR6_U_SMXP_1_1",
        .addr = A_POR_MPU_M5_PRLAR6_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR7_U_SMXP_1_1",
        .addr = A_POR_MPU_M5_PRBAR7_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR7_U_SMXP_1_1",
        .addr = A_POR_MPU_M5_PRLAR7_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR8_U_SMXP_1_1",
        .addr = A_POR_MPU_M5_PRBAR8_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR8_U_SMXP_1_1",
        .addr = A_POR_MPU_M5_PRLAR8_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR9_U_SMXP_1_1",
        .addr = A_POR_MPU_M5_PRBAR9_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR9_U_SMXP_1_1",
        .addr = A_POR_MPU_M5_PRLAR9_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR10_U_SMXP_1_1",
        .addr = A_POR_MPU_M5_PRBAR10_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR10_U_SMXP_1_1",
        .addr = A_POR_MPU_M5_PRLAR10_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR11_U_SMXP_1_1",
        .addr = A_POR_MPU_M5_PRBAR11_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR11_U_SMXP_1_1",
        .addr = A_POR_MPU_M5_PRLAR11_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR12_U_SMXP_1_1",
        .addr = A_POR_MPU_M5_PRBAR12_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR12_U_SMXP_1_1",
        .addr = A_POR_MPU_M5_PRLAR12_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR13_U_SMXP_1_1",
        .addr = A_POR_MPU_M5_PRBAR13_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR13_U_SMXP_1_1",
        .addr = A_POR_MPU_M5_PRLAR13_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR14_U_SMXP_1_1",
        .addr = A_POR_MPU_M5_PRBAR14_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR14_U_SMXP_1_1",
        .addr = A_POR_MPU_M5_PRLAR14_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR15_U_SMXP_1_1",
        .addr = A_POR_MPU_M5_PRBAR15_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR15_U_SMXP_1_1",
        .addr = A_POR_MPU_M5_PRLAR15_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR16_U_SMXP_1_1",
        .addr = A_POR_MPU_M5_PRBAR16_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR16_U_SMXP_1_1",
        .addr = A_POR_MPU_M5_PRLAR16_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR17_U_SMXP_1_1",
        .addr = A_POR_MPU_M5_PRBAR17_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR17_U_SMXP_1_1",
        .addr = A_POR_MPU_M5_PRLAR17_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR18_U_SMXP_1_1",
        .addr = A_POR_MPU_M5_PRBAR18_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR18_U_SMXP_1_1",
        .addr = A_POR_MPU_M5_PRLAR18_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR19_U_SMXP_1_1",
        .addr = A_POR_MPU_M5_PRBAR19_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR19_U_SMXP_1_1",
        .addr = A_POR_MPU_M5_PRLAR19_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR20_U_SMXP_1_1",
        .addr = A_POR_MPU_M5_PRBAR20_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR20_U_SMXP_1_1",
        .addr = A_POR_MPU_M5_PRLAR20_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR21_U_SMXP_1_1",
        .addr = A_POR_MPU_M5_PRBAR21_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR21_U_SMXP_1_1",
        .addr = A_POR_MPU_M5_PRLAR21_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR22_U_SMXP_1_1",
        .addr = A_POR_MPU_M5_PRBAR22_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR22_U_SMXP_1_1",
        .addr = A_POR_MPU_M5_PRLAR22_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR23_U_SMXP_1_1",
        .addr = A_POR_MPU_M5_PRBAR23_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR23_U_SMXP_1_1",
        .addr = A_POR_MPU_M5_PRLAR23_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR24_U_SMXP_1_1",
        .addr = A_POR_MPU_M5_PRBAR24_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR24_U_SMXP_1_1",
        .addr = A_POR_MPU_M5_PRLAR24_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR25_U_SMXP_1_1",
        .addr = A_POR_MPU_M5_PRBAR25_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR25_U_SMXP_1_1",
        .addr = A_POR_MPU_M5_PRLAR25_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR26_U_SMXP_1_1",
        .addr = A_POR_MPU_M5_PRBAR26_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR26_U_SMXP_1_1",
        .addr = A_POR_MPU_M5_PRLAR26_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR27_U_SMXP_1_1",
        .addr = A_POR_MPU_M5_PRBAR27_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR27_U_SMXP_1_1",
        .addr = A_POR_MPU_M5_PRLAR27_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR28_U_SMXP_1_1",
        .addr = A_POR_MPU_M5_PRBAR28_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR28_U_SMXP_1_1",
        .addr = A_POR_MPU_M5_PRLAR28_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR29_U_SMXP_1_1",
        .addr = A_POR_MPU_M5_PRBAR29_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR29_U_SMXP_1_1",
        .addr = A_POR_MPU_M5_PRLAR29_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR30_U_SMXP_1_1",
        .addr = A_POR_MPU_M5_PRBAR30_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR30_U_SMXP_1_1",
        .addr = A_POR_MPU_M5_PRLAR30_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR31_U_SMXP_1_1",
        .addr = A_POR_MPU_M5_PRBAR31_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR31_U_SMXP_1_1",
        .addr = A_POR_MPU_M5_PRLAR31_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_CTL_U_SMXP_1_1",
        .addr = A_POR_MPU_M6_CTL_U_SMXP_1_1,
        .reset = 0x2,
        .rsvd = 0xfffffffffffffff8L,
        .ro = 0xfffffffffffffff8L,
    },{ .name = "POR_MPU_M6_PRBAR0_U_SMXP_1_1",
        .addr = A_POR_MPU_M6_PRBAR0_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR0_U_SMXP_1_1",
        .addr = A_POR_MPU_M6_PRLAR0_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR1_U_SMXP_1_1",
        .addr = A_POR_MPU_M6_PRBAR1_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR1_U_SMXP_1_1",
        .addr = A_POR_MPU_M6_PRLAR1_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR2_U_SMXP_1_1",
        .addr = A_POR_MPU_M6_PRBAR2_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR2_U_SMXP_1_1",
        .addr = A_POR_MPU_M6_PRLAR2_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR3_U_SMXP_1_1",
        .addr = A_POR_MPU_M6_PRBAR3_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR3_U_SMXP_1_1",
        .addr = A_POR_MPU_M6_PRLAR3_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR4_U_SMXP_1_1",
        .addr = A_POR_MPU_M6_PRBAR4_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR4_U_SMXP_1_1",
        .addr = A_POR_MPU_M6_PRLAR4_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR5_U_SMXP_1_1",
        .addr = A_POR_MPU_M6_PRBAR5_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR5_U_SMXP_1_1",
        .addr = A_POR_MPU_M6_PRLAR5_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR6_U_SMXP_1_1",
        .addr = A_POR_MPU_M6_PRBAR6_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR6_U_SMXP_1_1",
        .addr = A_POR_MPU_M6_PRLAR6_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR7_U_SMXP_1_1",
        .addr = A_POR_MPU_M6_PRBAR7_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR7_U_SMXP_1_1",
        .addr = A_POR_MPU_M6_PRLAR7_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR8_U_SMXP_1_1",
        .addr = A_POR_MPU_M6_PRBAR8_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR8_U_SMXP_1_1",
        .addr = A_POR_MPU_M6_PRLAR8_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR9_U_SMXP_1_1",
        .addr = A_POR_MPU_M6_PRBAR9_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR9_U_SMXP_1_1",
        .addr = A_POR_MPU_M6_PRLAR9_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR10_U_SMXP_1_1",
        .addr = A_POR_MPU_M6_PRBAR10_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR10_U_SMXP_1_1",
        .addr = A_POR_MPU_M6_PRLAR10_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR11_U_SMXP_1_1",
        .addr = A_POR_MPU_M6_PRBAR11_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR11_U_SMXP_1_1",
        .addr = A_POR_MPU_M6_PRLAR11_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR12_U_SMXP_1_1",
        .addr = A_POR_MPU_M6_PRBAR12_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR12_U_SMXP_1_1",
        .addr = A_POR_MPU_M6_PRLAR12_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR13_U_SMXP_1_1",
        .addr = A_POR_MPU_M6_PRBAR13_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR13_U_SMXP_1_1",
        .addr = A_POR_MPU_M6_PRLAR13_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR14_U_SMXP_1_1",
        .addr = A_POR_MPU_M6_PRBAR14_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR14_U_SMXP_1_1",
        .addr = A_POR_MPU_M6_PRLAR14_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR15_U_SMXP_1_1",
        .addr = A_POR_MPU_M6_PRBAR15_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR15_U_SMXP_1_1",
        .addr = A_POR_MPU_M6_PRLAR15_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR16_U_SMXP_1_1",
        .addr = A_POR_MPU_M6_PRBAR16_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR16_U_SMXP_1_1",
        .addr = A_POR_MPU_M6_PRLAR16_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR17_U_SMXP_1_1",
        .addr = A_POR_MPU_M6_PRBAR17_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR17_U_SMXP_1_1",
        .addr = A_POR_MPU_M6_PRLAR17_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR18_U_SMXP_1_1",
        .addr = A_POR_MPU_M6_PRBAR18_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR18_U_SMXP_1_1",
        .addr = A_POR_MPU_M6_PRLAR18_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR19_U_SMXP_1_1",
        .addr = A_POR_MPU_M6_PRBAR19_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR19_U_SMXP_1_1",
        .addr = A_POR_MPU_M6_PRLAR19_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR20_U_SMXP_1_1",
        .addr = A_POR_MPU_M6_PRBAR20_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR20_U_SMXP_1_1",
        .addr = A_POR_MPU_M6_PRLAR20_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR21_U_SMXP_1_1",
        .addr = A_POR_MPU_M6_PRBAR21_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR21_U_SMXP_1_1",
        .addr = A_POR_MPU_M6_PRLAR21_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR22_U_SMXP_1_1",
        .addr = A_POR_MPU_M6_PRBAR22_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR22_U_SMXP_1_1",
        .addr = A_POR_MPU_M6_PRLAR22_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR23_U_SMXP_1_1",
        .addr = A_POR_MPU_M6_PRBAR23_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR23_U_SMXP_1_1",
        .addr = A_POR_MPU_M6_PRLAR23_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR24_U_SMXP_1_1",
        .addr = A_POR_MPU_M6_PRBAR24_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR24_U_SMXP_1_1",
        .addr = A_POR_MPU_M6_PRLAR24_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR25_U_SMXP_1_1",
        .addr = A_POR_MPU_M6_PRBAR25_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR25_U_SMXP_1_1",
        .addr = A_POR_MPU_M6_PRLAR25_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR26_U_SMXP_1_1",
        .addr = A_POR_MPU_M6_PRBAR26_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR26_U_SMXP_1_1",
        .addr = A_POR_MPU_M6_PRLAR26_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR27_U_SMXP_1_1",
        .addr = A_POR_MPU_M6_PRBAR27_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR27_U_SMXP_1_1",
        .addr = A_POR_MPU_M6_PRLAR27_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR28_U_SMXP_1_1",
        .addr = A_POR_MPU_M6_PRBAR28_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR28_U_SMXP_1_1",
        .addr = A_POR_MPU_M6_PRLAR28_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR29_U_SMXP_1_1",
        .addr = A_POR_MPU_M6_PRBAR29_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR29_U_SMXP_1_1",
        .addr = A_POR_MPU_M6_PRLAR29_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR30_U_SMXP_1_1",
        .addr = A_POR_MPU_M6_PRBAR30_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR30_U_SMXP_1_1",
        .addr = A_POR_MPU_M6_PRLAR30_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR31_U_SMXP_1_1",
        .addr = A_POR_MPU_M6_PRBAR31_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR31_U_SMXP_1_1",
        .addr = A_POR_MPU_M6_PRLAR31_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_CTL_U_SMXP_1_1",
        .addr = A_POR_MPU_M7_CTL_U_SMXP_1_1,
        .reset = 0x2,
        .rsvd = 0xfffffffffffffff8L,
        .ro = 0xfffffffffffffff8L,
    },{ .name = "POR_MPU_M7_PRBAR0_U_SMXP_1_1",
        .addr = A_POR_MPU_M7_PRBAR0_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR0_U_SMXP_1_1",
        .addr = A_POR_MPU_M7_PRLAR0_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR1_U_SMXP_1_1",
        .addr = A_POR_MPU_M7_PRBAR1_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR1_U_SMXP_1_1",
        .addr = A_POR_MPU_M7_PRLAR1_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR2_U_SMXP_1_1",
        .addr = A_POR_MPU_M7_PRBAR2_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR2_U_SMXP_1_1",
        .addr = A_POR_MPU_M7_PRLAR2_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR3_U_SMXP_1_1",
        .addr = A_POR_MPU_M7_PRBAR3_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR3_U_SMXP_1_1",
        .addr = A_POR_MPU_M7_PRLAR3_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR4_U_SMXP_1_1",
        .addr = A_POR_MPU_M7_PRBAR4_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR4_U_SMXP_1_1",
        .addr = A_POR_MPU_M7_PRLAR4_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR5_U_SMXP_1_1",
        .addr = A_POR_MPU_M7_PRBAR5_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR5_U_SMXP_1_1",
        .addr = A_POR_MPU_M7_PRLAR5_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR6_U_SMXP_1_1",
        .addr = A_POR_MPU_M7_PRBAR6_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR6_U_SMXP_1_1",
        .addr = A_POR_MPU_M7_PRLAR6_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR7_U_SMXP_1_1",
        .addr = A_POR_MPU_M7_PRBAR7_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR7_U_SMXP_1_1",
        .addr = A_POR_MPU_M7_PRLAR7_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR8_U_SMXP_1_1",
        .addr = A_POR_MPU_M7_PRBAR8_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR8_U_SMXP_1_1",
        .addr = A_POR_MPU_M7_PRLAR8_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR9_U_SMXP_1_1",
        .addr = A_POR_MPU_M7_PRBAR9_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR9_U_SMXP_1_1",
        .addr = A_POR_MPU_M7_PRLAR9_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR10_U_SMXP_1_1",
        .addr = A_POR_MPU_M7_PRBAR10_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR10_U_SMXP_1_1",
        .addr = A_POR_MPU_M7_PRLAR10_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR11_U_SMXP_1_1",
        .addr = A_POR_MPU_M7_PRBAR11_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR11_U_SMXP_1_1",
        .addr = A_POR_MPU_M7_PRLAR11_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR12_U_SMXP_1_1",
        .addr = A_POR_MPU_M7_PRBAR12_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR12_U_SMXP_1_1",
        .addr = A_POR_MPU_M7_PRLAR12_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR13_U_SMXP_1_1",
        .addr = A_POR_MPU_M7_PRBAR13_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR13_U_SMXP_1_1",
        .addr = A_POR_MPU_M7_PRLAR13_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR14_U_SMXP_1_1",
        .addr = A_POR_MPU_M7_PRBAR14_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR14_U_SMXP_1_1",
        .addr = A_POR_MPU_M7_PRLAR14_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR15_U_SMXP_1_1",
        .addr = A_POR_MPU_M7_PRBAR15_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR15_U_SMXP_1_1",
        .addr = A_POR_MPU_M7_PRLAR15_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR16_U_SMXP_1_1",
        .addr = A_POR_MPU_M7_PRBAR16_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR16_U_SMXP_1_1",
        .addr = A_POR_MPU_M7_PRLAR16_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR17_U_SMXP_1_1",
        .addr = A_POR_MPU_M7_PRBAR17_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR17_U_SMXP_1_1",
        .addr = A_POR_MPU_M7_PRLAR17_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR18_U_SMXP_1_1",
        .addr = A_POR_MPU_M7_PRBAR18_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR18_U_SMXP_1_1",
        .addr = A_POR_MPU_M7_PRLAR18_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR19_U_SMXP_1_1",
        .addr = A_POR_MPU_M7_PRBAR19_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR19_U_SMXP_1_1",
        .addr = A_POR_MPU_M7_PRLAR19_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR20_U_SMXP_1_1",
        .addr = A_POR_MPU_M7_PRBAR20_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR20_U_SMXP_1_1",
        .addr = A_POR_MPU_M7_PRLAR20_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR21_U_SMXP_1_1",
        .addr = A_POR_MPU_M7_PRBAR21_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR21_U_SMXP_1_1",
        .addr = A_POR_MPU_M7_PRLAR21_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR22_U_SMXP_1_1",
        .addr = A_POR_MPU_M7_PRBAR22_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR22_U_SMXP_1_1",
        .addr = A_POR_MPU_M7_PRLAR22_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR23_U_SMXP_1_1",
        .addr = A_POR_MPU_M7_PRBAR23_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR23_U_SMXP_1_1",
        .addr = A_POR_MPU_M7_PRLAR23_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR24_U_SMXP_1_1",
        .addr = A_POR_MPU_M7_PRBAR24_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR24_U_SMXP_1_1",
        .addr = A_POR_MPU_M7_PRLAR24_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR25_U_SMXP_1_1",
        .addr = A_POR_MPU_M7_PRBAR25_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR25_U_SMXP_1_1",
        .addr = A_POR_MPU_M7_PRLAR25_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR26_U_SMXP_1_1",
        .addr = A_POR_MPU_M7_PRBAR26_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR26_U_SMXP_1_1",
        .addr = A_POR_MPU_M7_PRLAR26_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR27_U_SMXP_1_1",
        .addr = A_POR_MPU_M7_PRBAR27_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR27_U_SMXP_1_1",
        .addr = A_POR_MPU_M7_PRLAR27_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR28_U_SMXP_1_1",
        .addr = A_POR_MPU_M7_PRBAR28_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR28_U_SMXP_1_1",
        .addr = A_POR_MPU_M7_PRLAR28_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR29_U_SMXP_1_1",
        .addr = A_POR_MPU_M7_PRBAR29_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR29_U_SMXP_1_1",
        .addr = A_POR_MPU_M7_PRLAR29_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR30_U_SMXP_1_1",
        .addr = A_POR_MPU_M7_PRBAR30_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR30_U_SMXP_1_1",
        .addr = A_POR_MPU_M7_PRLAR30_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR31_U_SMXP_1_1",
        .addr = A_POR_MPU_M7_PRBAR31_U_SMXP_1_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR31_U_SMXP_1_1",
        .addr = A_POR_MPU_M7_PRLAR31_U_SMXP_1_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_RNSAM_NODE_INFO_U_RNFBESAM_NID76",
        .addr = A_POR_RNSAM_NODE_INFO_U_RNFBESAM_NID76,
        .reset = 0x4000f,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_RNSAM_CHILD_INFO_U_RNFBESAM_NID76",
        .addr = A_POR_RNSAM_CHILD_INFO_U_RNFBESAM_NID76,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_RNSAM_UNIT_INFO_U_RNFBESAM_NID76",
        .addr = A_POR_RNSAM_UNIT_INFO_U_RNFBESAM_NID76,
        .reset = 0x800040004,
        .rsvd = 0xff00,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_RNSAM_SECURE_REGISTER_GROUPS_OVERRIDE_U_RNFBESAM_NID76",
        .addr = A_POR_RNSAM_SECURE_REGISTER_GROUPS_OVERRIDE_U_RNFBESAM_NID76,
        .rsvd = 0xfffffffffffffffeL,
        .ro = 0xfffffffffffffffeL,
    },{ .name = "RNSAM_STATUS_U_RNFBESAM_NID76",
        .addr = A_RNSAM_STATUS_U_RNFBESAM_NID76,
        .reset = 0x1,
        .rsvd = 0xfffffffffffffffcL,
        .ro = 0xfffffffffffffffcL,
    },{ .name = "NON_HASH_MEM_REGION_REG0_U_RNFBESAM_NID76",
        .addr = A_NON_HASH_MEM_REGION_REG0_U_RNFBESAM_NID76,
        .rsvd = 0x2,
        .ro = 0x8000000280000002L,
    },{ .name = "NON_HASH_MEM_REGION_REG1_U_RNFBESAM_NID76",
        .addr = A_NON_HASH_MEM_REGION_REG1_U_RNFBESAM_NID76,
        .rsvd = 0x2,
        .ro = 0x8000000280000002L,
    },{ .name = "NON_HASH_MEM_REGION_REG2_U_RNFBESAM_NID76",
        .addr = A_NON_HASH_MEM_REGION_REG2_U_RNFBESAM_NID76,
        .rsvd = 0x2,
        .ro = 0x8000000280000002L,
    },{ .name = "NON_HASH_MEM_REGION_REG3_U_RNFBESAM_NID76",
        .addr = A_NON_HASH_MEM_REGION_REG3_U_RNFBESAM_NID76,
        .rsvd = 0x2,
        .ro = 0x8000000280000002L,
    },{ .name = "NON_HASH_TGT_NODEID0_U_RNFBESAM_NID76",
        .addr = A_NON_HASH_TGT_NODEID0_U_RNFBESAM_NID76,
        .ro = 0xffff800800800800L,
    },{ .name = "NON_HASH_TGT_NODEID1_U_RNFBESAM_NID76",
        .addr = A_NON_HASH_TGT_NODEID1_U_RNFBESAM_NID76,
        .ro = 0xffff800800800800L,
    },{ .name = "NON_HASH_TGT_NODEID2_U_RNFBESAM_NID76",
        .addr = A_NON_HASH_TGT_NODEID2_U_RNFBESAM_NID76,
        .ro = 0xffffffffff800800L,
    },{ .name = "SYS_CACHE_GRP_REGION0_U_RNFBESAM_NID76",
        .addr = A_SYS_CACHE_GRP_REGION0_U_RNFBESAM_NID76,
        .rsvd = 0x2,
        .ro = 0x8000000080000002L,
    },{ .name = "SYS_CACHE_GRP_REGION1_U_RNFBESAM_NID76",
        .addr = A_SYS_CACHE_GRP_REGION1_U_RNFBESAM_NID76,
        .ro = 0x8000000080000000L,
    },{ .name = "SYS_CACHE_GRP_HN_NODEID_REG0_U_RNFBESAM_NID76",
        .addr = A_SYS_CACHE_GRP_HN_NODEID_REG0_U_RNFBESAM_NID76,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_HN_NODEID_REG1_U_RNFBESAM_NID76",
        .addr = A_SYS_CACHE_GRP_HN_NODEID_REG1_U_RNFBESAM_NID76,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_HN_NODEID_REG2_U_RNFBESAM_NID76",
        .addr = A_SYS_CACHE_GRP_HN_NODEID_REG2_U_RNFBESAM_NID76,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_HN_NODEID_REG3_U_RNFBESAM_NID76",
        .addr = A_SYS_CACHE_GRP_HN_NODEID_REG3_U_RNFBESAM_NID76,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_HN_NODEID_REG4_U_RNFBESAM_NID76",
        .addr = A_SYS_CACHE_GRP_HN_NODEID_REG4_U_RNFBESAM_NID76,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_HN_NODEID_REG5_U_RNFBESAM_NID76",
        .addr = A_SYS_CACHE_GRP_HN_NODEID_REG5_U_RNFBESAM_NID76,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_HN_NODEID_REG6_U_RNFBESAM_NID76",
        .addr = A_SYS_CACHE_GRP_HN_NODEID_REG6_U_RNFBESAM_NID76,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_HN_NODEID_REG7_U_RNFBESAM_NID76",
        .addr = A_SYS_CACHE_GRP_HN_NODEID_REG7_U_RNFBESAM_NID76,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_NONHASH_NODEID_U_RNFBESAM_NID76",
        .addr = A_SYS_CACHE_GRP_NONHASH_NODEID_U_RNFBESAM_NID76,
        .ro = 0xfffffff800800800L,
    },{ .name = "SYS_CACHE_GROUP_HN_COUNT_U_RNFBESAM_NID76",
        .addr = A_SYS_CACHE_GROUP_HN_COUNT_U_RNFBESAM_NID76,
        .rsvd = 0x80,
        .ro = 0xffffffff80808080L,
    },{ .name = "SYS_CACHE_GRP_SN_NODEID_REG0_U_RNFBESAM_NID76",
        .addr = A_SYS_CACHE_GRP_SN_NODEID_REG0_U_RNFBESAM_NID76,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_SN_NODEID_REG1_U_RNFBESAM_NID76",
        .addr = A_SYS_CACHE_GRP_SN_NODEID_REG1_U_RNFBESAM_NID76,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_SN_NODEID_REG2_U_RNFBESAM_NID76",
        .addr = A_SYS_CACHE_GRP_SN_NODEID_REG2_U_RNFBESAM_NID76,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_SN_NODEID_REG3_U_RNFBESAM_NID76",
        .addr = A_SYS_CACHE_GRP_SN_NODEID_REG3_U_RNFBESAM_NID76,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_SN_NODEID_REG4_U_RNFBESAM_NID76",
        .addr = A_SYS_CACHE_GRP_SN_NODEID_REG4_U_RNFBESAM_NID76,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_SN_NODEID_REG5_U_RNFBESAM_NID76",
        .addr = A_SYS_CACHE_GRP_SN_NODEID_REG5_U_RNFBESAM_NID76,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_SN_NODEID_REG6_U_RNFBESAM_NID76",
        .addr = A_SYS_CACHE_GRP_SN_NODEID_REG6_U_RNFBESAM_NID76,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_SN_NODEID_REG7_U_RNFBESAM_NID76",
        .addr = A_SYS_CACHE_GRP_SN_NODEID_REG7_U_RNFBESAM_NID76,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_SN_SAM_CFG0_U_RNFBESAM_NID76",
        .addr = A_SYS_CACHE_GRP_SN_SAM_CFG0_U_RNFBESAM_NID76,
        .rsvd = 0xc0,
        .ro = 0xffffc0c0c0c0c0c0L,
    },{ .name = "SYS_CACHE_GRP_SN_SAM_CFG1_U_RNFBESAM_NID76",
        .addr = A_SYS_CACHE_GRP_SN_SAM_CFG1_U_RNFBESAM_NID76,
        .rsvd = 0xc0,
        .ro = 0xffffc0c0c0c0c0c0L,
    },{ .name = "GIC_MEM_REGION_REG_U_RNFBESAM_NID76",
        .addr = A_GIC_MEM_REGION_REG_U_RNFBESAM_NID76,
        .rsvd = 0xff82,
        .ro = 0x800f00000000ff82L,
    },{ .name = "SYS_CACHE_GRP_SN_ATTR_U_RNFBESAM_NID76",
        .addr = A_SYS_CACHE_GRP_SN_ATTR_U_RNFBESAM_NID76,
        .rsvd = 0xffce,
        .ro = 0xffceffceffceffceL,
    },{ .name = "SYS_CACHE_GRP_HN_CPA_EN_REG_U_RNFBESAM_NID76",
        .addr = A_SYS_CACHE_GRP_HN_CPA_EN_REG_U_RNFBESAM_NID76,
    },{ .name = "SYS_CACHE_GRP_HN_CPA_GRP_REG_U_RNFBESAM_NID76",
        .addr = A_SYS_CACHE_GRP_HN_CPA_GRP_REG_U_RNFBESAM_NID76,
        .rsvd = 0xfffc,
        .ro = 0xfffcfffcfffcfffcL,
    },{ .name = "CML_PORT_AGGR_MODE_CTRL_REG_U_RNFBESAM_NID76",
        .addr = A_CML_PORT_AGGR_MODE_CTRL_REG_U_RNFBESAM_NID76,
        .rsvd = 0x88,
        .ro = 0xffffffff28888888L,
    },{ .name = "CML_PORT_AGGR_GRP0_ADD_MASK_U_RNFBESAM_NID76",
        .addr = A_CML_PORT_AGGR_GRP0_ADD_MASK_U_RNFBESAM_NID76,
        .reset = 0x40,
        .ro = 0xffff00000000003fL,
    },{ .name = "CML_PORT_AGGR_GRP1_ADD_MASK_U_RNFBESAM_NID76",
        .addr = A_CML_PORT_AGGR_GRP1_ADD_MASK_U_RNFBESAM_NID76,
        .reset = 0x40,
        .ro = 0xffff00000000003fL,
    },{ .name = "CML_PORT_AGGR_GRP0_REG_U_RNFBESAM_NID76",
        .addr = A_CML_PORT_AGGR_GRP0_REG_U_RNFBESAM_NID76,
        .ro = 0xfffc800800800800L,
    },{ .name = "CML_PORT_AGGR_GRP1_REG_U_RNFBESAM_NID76",
        .addr = A_CML_PORT_AGGR_GRP1_REG_U_RNFBESAM_NID76,
        .ro = 0xfffc800800800800L,
    },{ .name = "SYS_CACHE_GRP_SECONDARY_REG0_U_RNFBESAM_NID76",
        .addr = A_SYS_CACHE_GRP_SECONDARY_REG0_U_RNFBESAM_NID76,
        .rsvd = 0x2,
        .ro = 0x8000000280000002L,
    },{ .name = "SYS_CACHE_GRP_SECONDARY_REG1_U_RNFBESAM_NID76",
        .addr = A_SYS_CACHE_GRP_SECONDARY_REG1_U_RNFBESAM_NID76,
        .rsvd = 0x2,
        .ro = 0x8000000280000002L,
    },{ .name = "SYS_CACHE_GRP_CAL_MODE_REG_U_RNFBESAM_NID76",
        .addr = A_SYS_CACHE_GRP_CAL_MODE_REG_U_RNFBESAM_NID76,
        .rsvd = 0xfffe,
        .ro = 0xfffefffefffefffeL,
    },{ .name = "RNSAM_HASH_ADDR_MASK_REG_U_RNFBESAM_NID76",
        .addr = A_RNSAM_HASH_ADDR_MASK_REG_U_RNFBESAM_NID76,
        .reset = 0xffffffffffc0,
        .ro = 0xffff00000000003fL,
    },{ .name = "RNSAM_REGION_CMP_ADDR_MASK_REG_U_RNFBESAM_NID76",
        .addr = A_RNSAM_REGION_CMP_ADDR_MASK_REG_U_RNFBESAM_NID76,
        .reset = 0xffffffff0000,
        .ro = 0xffff00000000ffffL,
    },{ .name = "SYS_CACHE_GRP_HN_NODEID_REG8_U_RNFBESAM_NID76",
        .addr = A_SYS_CACHE_GRP_HN_NODEID_REG8_U_RNFBESAM_NID76,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_HN_NODEID_REG9_U_RNFBESAM_NID76",
        .addr = A_SYS_CACHE_GRP_HN_NODEID_REG9_U_RNFBESAM_NID76,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_HN_NODEID_REG10_U_RNFBESAM_NID76",
        .addr = A_SYS_CACHE_GRP_HN_NODEID_REG10_U_RNFBESAM_NID76,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_HN_NODEID_REG11_U_RNFBESAM_NID76",
        .addr = A_SYS_CACHE_GRP_HN_NODEID_REG11_U_RNFBESAM_NID76,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_HN_NODEID_REG12_U_RNFBESAM_NID76",
        .addr = A_SYS_CACHE_GRP_HN_NODEID_REG12_U_RNFBESAM_NID76,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_HN_NODEID_REG13_U_RNFBESAM_NID76",
        .addr = A_SYS_CACHE_GRP_HN_NODEID_REG13_U_RNFBESAM_NID76,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_HN_NODEID_REG14_U_RNFBESAM_NID76",
        .addr = A_SYS_CACHE_GRP_HN_NODEID_REG14_U_RNFBESAM_NID76,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_HN_NODEID_REG15_U_RNFBESAM_NID76",
        .addr = A_SYS_CACHE_GRP_HN_NODEID_REG15_U_RNFBESAM_NID76,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_SN_NODEID_REG8_U_RNFBESAM_NID76",
        .addr = A_SYS_CACHE_GRP_SN_NODEID_REG8_U_RNFBESAM_NID76,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_SN_NODEID_REG9_U_RNFBESAM_NID76",
        .addr = A_SYS_CACHE_GRP_SN_NODEID_REG9_U_RNFBESAM_NID76,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_SN_NODEID_REG10_U_RNFBESAM_NID76",
        .addr = A_SYS_CACHE_GRP_SN_NODEID_REG10_U_RNFBESAM_NID76,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_SN_NODEID_REG11_U_RNFBESAM_NID76",
        .addr = A_SYS_CACHE_GRP_SN_NODEID_REG11_U_RNFBESAM_NID76,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_SN_NODEID_REG12_U_RNFBESAM_NID76",
        .addr = A_SYS_CACHE_GRP_SN_NODEID_REG12_U_RNFBESAM_NID76,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_SN_NODEID_REG13_U_RNFBESAM_NID76",
        .addr = A_SYS_CACHE_GRP_SN_NODEID_REG13_U_RNFBESAM_NID76,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_SN_NODEID_REG14_U_RNFBESAM_NID76",
        .addr = A_SYS_CACHE_GRP_SN_NODEID_REG14_U_RNFBESAM_NID76,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_SN_NODEID_REG15_U_RNFBESAM_NID76",
        .addr = A_SYS_CACHE_GRP_SN_NODEID_REG15_U_RNFBESAM_NID76,
        .ro = 0xffff800800800800L,
    },{ .name = "POR_SBSX_NODE_INFO_U_SBSX_NID128",
        .addr = A_POR_SBSX_NODE_INFO_U_SBSX_NID128,
        .reset = 0x7,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_SBSX_CHILD_INFO_U_SBSX_NID128",
        .addr = A_POR_SBSX_CHILD_INFO_U_SBSX_NID128,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_SBSX_UNIT_INFO_U_SBSX_NID128",
        .addr = A_POR_SBSX_UNIT_INFO_U_SBSX_NID128,
        .reset = 0x84011,
        .rsvd = 0xee,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_SBSX_AUX_CTL_U_SBSX_NID128",
        .addr = A_POR_SBSX_AUX_CTL_U_SBSX_NID128,
        .rsvd = 0xfffffffffffffffeL,
        .ro = 0xfffffffffffffffeL,
    },{ .name = "POR_SBSX_PMU_EVENT_SEL_U_SBSX_NID128",
        .addr = A_POR_SBSX_PMU_EVENT_SEL_U_SBSX_NID128,
        .rsvd = 0xc0,
        .ro = 0xffffffffc0c0c0c0L,
    },{ .name = "POR_SBSX_ERRFR_U_SBSX_NID128",
        .addr = A_POR_SBSX_ERRFR_U_SBSX_NID128,
        .reset = 0xa1,
        .rsvd = 0x300,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_SBSX_ERRCTLR_U_SBSX_NID128",
        .addr = A_POR_SBSX_ERRCTLR_U_SBSX_NID128,
        .rsvd = 0xf0,
        .ro = 0xfffffffffffffef0L,
    },{ .name = "POR_SBSX_ERRSTATUS_U_SBSX_NID128",
        .addr = A_POR_SBSX_ERRSTATUS_U_SBSX_NID128,
        .ro = 0xffffffff127fffffL,
    },{ .name = "POR_SBSX_ERRADDR_U_SBSX_NID128",
        .addr = A_POR_SBSX_ERRADDR_U_SBSX_NID128,
        .ro = 0x7fff000000000000,
    },{ .name = "POR_SBSX_ERRMISC_U_SBSX_NID128",
        .addr = A_POR_SBSX_ERRMISC_U_SBSX_NID128,
        .ro = 0xffffffff80fe800fL,
    },{ .name = "POR_SBSX_ERRFR_NS_U_SBSX_NID128",
        .addr = A_POR_SBSX_ERRFR_NS_U_SBSX_NID128,
        .reset = 0xa1,
        .rsvd = 0x300,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_SBSX_ERRCTLR_NS_U_SBSX_NID128",
        .addr = A_POR_SBSX_ERRCTLR_NS_U_SBSX_NID128,
        .rsvd = 0xf0,
        .ro = 0xfffffffffffffef0L,
    },{ .name = "POR_SBSX_ERRSTATUS_NS_U_SBSX_NID128",
        .addr = A_POR_SBSX_ERRSTATUS_NS_U_SBSX_NID128,
        .ro = 0xffffffff127fffffL,
    },{ .name = "POR_SBSX_ERRADDR_NS_U_SBSX_NID128",
        .addr = A_POR_SBSX_ERRADDR_NS_U_SBSX_NID128,
        .ro = 0x7fff000000000000,
    },{ .name = "POR_SBSX_ERRMISC_NS_U_SBSX_NID128",
        .addr = A_POR_SBSX_ERRMISC_NS_U_SBSX_NID128,
        .ro = 0xffffffff80fe800fL,
    },{ .name = "POR_MXP_NODE_INFO_U_SMXP_2_0",
        .addr = A_POR_MXP_NODE_INFO_U_SMXP_2_0,
        .reset = 0x1080006,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_DEVICE_PORT_CONNECT_INFO_P0_U_SMXP_2_0",
        .addr = A_POR_MXP_DEVICE_PORT_CONNECT_INFO_P0_U_SMXP_2_0,
        .reset = 0xd,
        .rsvd = 0xffe0,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_DEVICE_PORT_CONNECT_INFO_P1_U_SMXP_2_0",
        .addr = A_POR_MXP_DEVICE_PORT_CONNECT_INFO_P1_U_SMXP_2_0,
        .reset = 0x1,
        .rsvd = 0xffe0,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_MESH_PORT_CONNECT_INFO_EAST_U_SMXP_2_0",
        .addr = A_POR_MXP_MESH_PORT_CONNECT_INFO_EAST_U_SMXP_2_0,
        .rsvd = 0xfffffffffffffff0L,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_MESH_PORT_CONNECT_INFO_NORTH_U_SMXP_2_0",
        .addr = A_POR_MXP_MESH_PORT_CONNECT_INFO_NORTH_U_SMXP_2_0,
        .rsvd = 0xfffffffffffffff0L,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_INFO_U_SMXP_2_0",
        .addr = A_POR_MXP_CHILD_INFO_U_SMXP_2_0,
        .reset = 0x1000006,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_POINTER_0_U_SMXP_2_0",
        .addr = A_POR_MXP_CHILD_POINTER_0_U_SMXP_2_0,
        .reset = 0x8212c000,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_POINTER_1_U_SMXP_2_0",
        .addr = A_POR_MXP_CHILD_POINTER_1_U_SMXP_2_0,
        .reset = 0x8213c000,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_POINTER_2_U_SMXP_2_0",
        .addr = A_POR_MXP_CHILD_POINTER_2_U_SMXP_2_0,
        .reset = 0x2168000,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_POINTER_3_U_SMXP_2_0",
        .addr = A_POR_MXP_CHILD_POINTER_3_U_SMXP_2_0,
        .reset = 0x821d0000,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_POINTER_4_U_SMXP_2_0",
        .addr = A_POR_MXP_CHILD_POINTER_4_U_SMXP_2_0,
        .reset = 0x82120000,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_POINTER_5_U_SMXP_2_0",
        .addr = A_POR_MXP_CHILD_POINTER_5_U_SMXP_2_0,
        .reset = 0x2150000,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_POINTER_6_U_SMXP_2_0",
        .addr = A_POR_MXP_CHILD_POINTER_6_U_SMXP_2_0,
        .reset = 0x2110000,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_POINTER_7_U_SMXP_2_0",
        .addr = A_POR_MXP_CHILD_POINTER_7_U_SMXP_2_0,
        .reset = 0x2100000,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_POINTER_8_U_SMXP_2_0",
        .addr = A_POR_MXP_CHILD_POINTER_8_U_SMXP_2_0,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_POINTER_9_U_SMXP_2_0",
        .addr = A_POR_MXP_CHILD_POINTER_9_U_SMXP_2_0,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_POINTER_10_U_SMXP_2_0",
        .addr = A_POR_MXP_CHILD_POINTER_10_U_SMXP_2_0,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_POINTER_11_U_SMXP_2_0",
        .addr = A_POR_MXP_CHILD_POINTER_11_U_SMXP_2_0,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_POINTER_12_U_SMXP_2_0",
        .addr = A_POR_MXP_CHILD_POINTER_12_U_SMXP_2_0,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_POINTER_13_U_SMXP_2_0",
        .addr = A_POR_MXP_CHILD_POINTER_13_U_SMXP_2_0,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_POINTER_14_U_SMXP_2_0",
        .addr = A_POR_MXP_CHILD_POINTER_14_U_SMXP_2_0,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_POINTER_15_U_SMXP_2_0",
        .addr = A_POR_MXP_CHILD_POINTER_15_U_SMXP_2_0,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_P0_INFO_U_SMXP_2_0",
        .addr = A_POR_MXP_P0_INFO_U_SMXP_2_0,
        .reset = 0x211,
        .rsvd = 0x48,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_P1_INFO_U_SMXP_2_0",
        .addr = A_POR_MXP_P1_INFO_U_SMXP_2_0,
        .reset = 0x211,
        .rsvd = 0x48,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_SECURE_REGISTER_GROUPS_OVERRIDE_U_SMXP_2_0",
        .addr = A_POR_MXP_SECURE_REGISTER_GROUPS_OVERRIDE_U_SMXP_2_0,
        .rsvd = 0xfffffffffffffffcL,
        .ro = 0xfffffffffffffffcL,
    },{ .name = "POR_MXP_AUX_CTL_U_SMXP_2_0",
        .addr = A_POR_MXP_AUX_CTL_U_SMXP_2_0,
        .rsvd = 0xfffffffffffffffeL,
        .ro = 0xfffffffffffffffeL,
    },{ .name = "POR_MXP_P0_QOS_CONTROL_U_SMXP_2_0",
        .addr = A_POR_MXP_P0_QOS_CONTROL_U_SMXP_2_0,
        .rsvd = 0xffaa,
        .ro = 0xfffffffffff0ffaaL,
    },{ .name = "POR_MXP_P0_QOS_LAT_TGT_U_SMXP_2_0",
        .addr = A_POR_MXP_P0_QOS_LAT_TGT_U_SMXP_2_0,
        .ro = 0xfffffffffffff000L,
    },{ .name = "POR_MXP_P0_QOS_LAT_SCALE_U_SMXP_2_0",
        .addr = A_POR_MXP_P0_QOS_LAT_SCALE_U_SMXP_2_0,
        .rsvd = 0xfffffffffffffff8L,
        .ro = 0xfffffffffffffff8L,
    },{ .name = "POR_MXP_P0_QOS_LAT_RANGE_U_SMXP_2_0",
        .addr = A_POR_MXP_P0_QOS_LAT_RANGE_U_SMXP_2_0,
        .rsvd = 0xf0,
        .ro = 0xfffffffffffff0f0L,
    },{ .name = "POR_MXP_P1_QOS_CONTROL_U_SMXP_2_0",
        .addr = A_POR_MXP_P1_QOS_CONTROL_U_SMXP_2_0,
        .rsvd = 0xffaa,
        .ro = 0xfffffffffff0ffaaL,
    },{ .name = "POR_MXP_P1_QOS_LAT_TGT_U_SMXP_2_0",
        .addr = A_POR_MXP_P1_QOS_LAT_TGT_U_SMXP_2_0,
        .ro = 0xfffffffffffff000L,
    },{ .name = "POR_MXP_P1_QOS_LAT_SCALE_U_SMXP_2_0",
        .addr = A_POR_MXP_P1_QOS_LAT_SCALE_U_SMXP_2_0,
        .rsvd = 0xfffffffffffffff8L,
        .ro = 0xfffffffffffffff8L,
    },{ .name = "POR_MXP_P1_QOS_LAT_RANGE_U_SMXP_2_0",
        .addr = A_POR_MXP_P1_QOS_LAT_RANGE_U_SMXP_2_0,
        .rsvd = 0xf0,
        .ro = 0xfffffffffffff0f0L,
    },{ .name = "POR_MXP_P0_SYSCOREQ_CTL_U_SMXP_2_0",
        .addr = A_POR_MXP_P0_SYSCOREQ_CTL_U_SMXP_2_0,
        .rsvd = 0xfffffffffffffff0L,
        .ro = 0xfffffffffffffff0L,
    },{ .name = "POR_MXP_P1_SYSCOREQ_CTL_U_SMXP_2_0",
        .addr = A_POR_MXP_P1_SYSCOREQ_CTL_U_SMXP_2_0,
        .rsvd = 0xfffffffffffffff0L,
        .ro = 0xfffffffffffffff0L,
    },{ .name = "POR_MXP_P0_SYSCOACK_STATUS_U_SMXP_2_0",
        .addr = A_POR_MXP_P0_SYSCOACK_STATUS_U_SMXP_2_0,
        .rsvd = 0xfffffffffffffff0L,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_P1_SYSCOACK_STATUS_U_SMXP_2_0",
        .addr = A_POR_MXP_P1_SYSCOACK_STATUS_U_SMXP_2_0,
        .rsvd = 0xfffffffffffffff0L,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_PMU_EVENT_SEL_U_SMXP_2_0",
        .addr = A_POR_MXP_PMU_EVENT_SEL_U_SMXP_2_0,
        .ro = 0xffffffff00000000L,
    },{ .name = "POR_DTM_CONTROL_U_SMXP_2_0",
        .addr = A_POR_DTM_CONTROL_U_SMXP_2_0,
        .rsvd = 0xfffffffffffffff0L,
        .ro = 0xfffffffffffffff0L,
    },{ .name = "POR_DTM_FIFO_ENTRY_READY_U_SMXP_2_0",
        .addr = A_POR_DTM_FIFO_ENTRY_READY_U_SMXP_2_0,
        .rsvd = 0xfffffffffffffff0L,
        .ro = 0xfffffffffffffff0L,
    },{ .name = "POR_DTM_FIFO_ENTRY0_0_U_SMXP_2_0",
        .addr = A_POR_DTM_FIFO_ENTRY0_0_U_SMXP_2_0,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_DTM_FIFO_ENTRY0_1_U_SMXP_2_0",
        .addr = A_POR_DTM_FIFO_ENTRY0_1_U_SMXP_2_0,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_DTM_FIFO_ENTRY0_2_U_SMXP_2_0",
        .addr = A_POR_DTM_FIFO_ENTRY0_2_U_SMXP_2_0,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_DTM_FIFO_ENTRY1_0_U_SMXP_2_0",
        .addr = A_POR_DTM_FIFO_ENTRY1_0_U_SMXP_2_0,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_DTM_FIFO_ENTRY1_1_U_SMXP_2_0",
        .addr = A_POR_DTM_FIFO_ENTRY1_1_U_SMXP_2_0,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_DTM_FIFO_ENTRY1_2_U_SMXP_2_0",
        .addr = A_POR_DTM_FIFO_ENTRY1_2_U_SMXP_2_0,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_DTM_FIFO_ENTRY2_0_U_SMXP_2_0",
        .addr = A_POR_DTM_FIFO_ENTRY2_0_U_SMXP_2_0,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_DTM_FIFO_ENTRY2_1_U_SMXP_2_0",
        .addr = A_POR_DTM_FIFO_ENTRY2_1_U_SMXP_2_0,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_DTM_FIFO_ENTRY2_2_U_SMXP_2_0",
        .addr = A_POR_DTM_FIFO_ENTRY2_2_U_SMXP_2_0,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_DTM_FIFO_ENTRY3_0_U_SMXP_2_0",
        .addr = A_POR_DTM_FIFO_ENTRY3_0_U_SMXP_2_0,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_DTM_FIFO_ENTRY3_1_U_SMXP_2_0",
        .addr = A_POR_DTM_FIFO_ENTRY3_1_U_SMXP_2_0,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_DTM_FIFO_ENTRY3_2_U_SMXP_2_0",
        .addr = A_POR_DTM_FIFO_ENTRY3_2_U_SMXP_2_0,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_DTM_WP0_CONFIG_U_SMXP_2_0",
        .addr = A_POR_DTM_WP0_CONFIG_U_SMXP_2_0,
        .rsvd = 0x80,
        .ro = 0xffffffffffff8080L,
    },{ .name = "POR_DTM_WP0_VAL_U_SMXP_2_0",
        .addr = A_POR_DTM_WP0_VAL_U_SMXP_2_0,
    },{ .name = "POR_DTM_WP0_MASK_U_SMXP_2_0",
        .addr = A_POR_DTM_WP0_MASK_U_SMXP_2_0,
    },{ .name = "POR_DTM_WP1_CONFIG_U_SMXP_2_0",
        .addr = A_POR_DTM_WP1_CONFIG_U_SMXP_2_0,
        .rsvd = 0xc0,
        .ro = 0xffffffffffff80c0L,
    },{ .name = "POR_DTM_WP1_VAL_U_SMXP_2_0",
        .addr = A_POR_DTM_WP1_VAL_U_SMXP_2_0,
    },{ .name = "POR_DTM_WP1_MASK_U_SMXP_2_0",
        .addr = A_POR_DTM_WP1_MASK_U_SMXP_2_0,
    },{ .name = "POR_DTM_WP2_CONFIG_U_SMXP_2_0",
        .addr = A_POR_DTM_WP2_CONFIG_U_SMXP_2_0,
        .rsvd = 0x80,
        .ro = 0xffffffffffff8080L,
    },{ .name = "POR_DTM_WP2_VAL_U_SMXP_2_0",
        .addr = A_POR_DTM_WP2_VAL_U_SMXP_2_0,
    },{ .name = "POR_DTM_WP2_MASK_U_SMXP_2_0",
        .addr = A_POR_DTM_WP2_MASK_U_SMXP_2_0,
    },{ .name = "POR_DTM_WP3_CONFIG_U_SMXP_2_0",
        .addr = A_POR_DTM_WP3_CONFIG_U_SMXP_2_0,
        .rsvd = 0xc0,
        .ro = 0xffffffffffff80c0L,
    },{ .name = "POR_DTM_WP3_VAL_U_SMXP_2_0",
        .addr = A_POR_DTM_WP3_VAL_U_SMXP_2_0,
    },{ .name = "POR_DTM_WP3_MASK_U_SMXP_2_0",
        .addr = A_POR_DTM_WP3_MASK_U_SMXP_2_0,
    },{ .name = "POR_DTM_PMSICR_U_SMXP_2_0",
        .addr = A_POR_DTM_PMSICR_U_SMXP_2_0,
        .ro = 0xffffffff00000000L,
    },{ .name = "POR_DTM_PMSIRR_U_SMXP_2_0",
        .addr = A_POR_DTM_PMSIRR_U_SMXP_2_0,
        .ro = 0xffffffff000000ffL,
    },{ .name = "POR_DTM_PMU_CONFIG_U_SMXP_2_0",
        .addr = A_POR_DTM_PMU_CONFIG_U_SMXP_2_0,
        .ro = 0xc0c0c0c08888fe00L,
    },{ .name = "POR_DTM_PMEVCNT_U_SMXP_2_0",
        .addr = A_POR_DTM_PMEVCNT_U_SMXP_2_0,
    },{ .name = "POR_DTM_PMEVCNTSR_U_SMXP_2_0",
        .addr = A_POR_DTM_PMEVCNTSR_U_SMXP_2_0,
    },{ .name = "POR_MXP_ERRFR_U_SMXP_2_0",  .addr = A_POR_MXP_ERRFR_U_SMXP_2_0,
        .rsvd = 0x300,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_ERRCTLR_U_SMXP_2_0",
        .addr = A_POR_MXP_ERRCTLR_U_SMXP_2_0,
        .rsvd = 0xf0,
        .ro = 0xfffffffffffffef0L,
    },{ .name = "POR_MXP_ERRSTATUS_U_SMXP_2_0",
        .addr = A_POR_MXP_ERRSTATUS_U_SMXP_2_0,
        .ro = 0xffffffff127fffffL,
    },{ .name = "POR_MXP_ERRMISC_U_SMXP_2_0",
        .addr = A_POR_MXP_ERRMISC_U_SMXP_2_0,
        .rsvd = 0x8,
        .ro = 0xf800ffffffc08008L,
    },{ .name = "POR_MXP_P0_BYTE_PAR_ERR_INJ_U_SMXP_2_0",
        .addr = A_POR_MXP_P0_BYTE_PAR_ERR_INJ_U_SMXP_2_0,
        .rsvd = 0xffffffffffffffe0L,
        .ro = 0xffffffffffffffe0L,
    },{ .name = "POR_MXP_P1_BYTE_PAR_ERR_INJ_U_SMXP_2_0",
        .addr = A_POR_MXP_P1_BYTE_PAR_ERR_INJ_U_SMXP_2_0,
        .rsvd = 0xffffffffffffffe0L,
        .ro = 0xffffffffffffffe0L,
    },{ .name = "POR_MXP_ERRFR_NS_U_SMXP_2_0",
        .addr = A_POR_MXP_ERRFR_NS_U_SMXP_2_0,
        .rsvd = 0x300,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_ERRCTLR_NS_U_SMXP_2_0",
        .addr = A_POR_MXP_ERRCTLR_NS_U_SMXP_2_0,
        .rsvd = 0xf0,
        .ro = 0xfffffffffffffef0L,
    },{ .name = "POR_MXP_ERRSTATUS_NS_U_SMXP_2_0",
        .addr = A_POR_MXP_ERRSTATUS_NS_U_SMXP_2_0,
        .ro = 0xffffffff127fffffL,
    },{ .name = "POR_MXP_ERRMISC_NS_U_SMXP_2_0",
        .addr = A_POR_MXP_ERRMISC_NS_U_SMXP_2_0,
        .rsvd = 0x8,
        .ro = 0xf800ffffffc08008L,
    },{ .name = "POR_RNI_NODE_INFO_U_RNI_NID132",
        .addr = A_POR_RNI_NODE_INFO_U_RNI_NID132,
        .reset = 0x4000a,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_RNI_CHILD_INFO_U_RNI_NID132",
        .addr = A_POR_RNI_CHILD_INFO_U_RNI_NID132,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_RNI_UNIT_INFO_U_RNI_NID132",
        .addr = A_POR_RNI_UNIT_INFO_U_RNI_NID132,
        .reset = 0x8044020,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_RNI_SECURE_REGISTER_GROUPS_OVERRIDE_U_RNI_NID132",
        .addr = A_POR_RNI_SECURE_REGISTER_GROUPS_OVERRIDE_U_RNI_NID132,
        .rsvd = 0xfffffffffffffff8L,
        .ro = 0xfffffffffffffff8L,
    },{ .name = "POR_RNI_CFG_CTL_U_RNI_NID132",
        .addr = A_POR_RNI_CFG_CTL_U_RNI_NID132,
        .reset = 0x20401401,
        .rsvd = 0x80,
        .ro = 0xffffffff00008880L,
    },{ .name = "POR_RNI_AUX_CTL_U_RNI_NID132",
        .addr = A_POR_RNI_AUX_CTL_U_RNI_NID132,
        .reset = 0x22,
        .rsvd = 0xffffffffffffffc0L,
        .ro = 0xffffffffffffffc0L,
    },{ .name = "POR_RNI_S0_PORT_CONTROL_U_RNI_NID132",
        .addr = A_POR_RNI_S0_PORT_CONTROL_U_RNI_NID132,
        .ro = 0xfffffffffffff800L,
    },{ .name = "POR_RNI_S1_PORT_CONTROL_U_RNI_NID132",
        .addr = A_POR_RNI_S1_PORT_CONTROL_U_RNI_NID132,
        .ro = 0xfffffffffffff800L,
    },{ .name = "POR_RNI_S2_PORT_CONTROL_U_RNI_NID132",
        .addr = A_POR_RNI_S2_PORT_CONTROL_U_RNI_NID132,
        .ro = 0xfffffffffffff800L,
    },{ .name = "POR_RNI_S0_QOS_CONTROL_U_RNI_NID132",
        .addr = A_POR_RNI_S0_QOS_CONTROL_U_RNI_NID132,
        .rsvd = 0xff00,
        .ro = 0xffffffffff00ff00L,
    },{ .name = "POR_RNI_S0_QOS_LAT_TGT_U_RNI_NID132",
        .addr = A_POR_RNI_S0_QOS_LAT_TGT_U_RNI_NID132,
        .ro = 0xfffffffff000f000L,
    },{ .name = "POR_RNI_S0_QOS_LAT_SCALE_U_RNI_NID132",
        .addr = A_POR_RNI_S0_QOS_LAT_SCALE_U_RNI_NID132,
        .rsvd = 0xf8,
        .ro = 0xfffffffffffff8f8L,
    },{ .name = "POR_RNI_S0_QOS_LAT_RANGE_U_RNI_NID132",
        .addr = A_POR_RNI_S0_QOS_LAT_RANGE_U_RNI_NID132,
        .rsvd = 0xf0,
        .ro = 0xfffffffff0f0f0f0L,
    },{ .name = "POR_RNI_S1_QOS_CONTROL_U_RNI_NID132",
        .addr = A_POR_RNI_S1_QOS_CONTROL_U_RNI_NID132,
        .rsvd = 0xff00,
        .ro = 0xffffffffff00ff00L,
    },{ .name = "POR_RNI_S1_QOS_LAT_TGT_U_RNI_NID132",
        .addr = A_POR_RNI_S1_QOS_LAT_TGT_U_RNI_NID132,
        .ro = 0xfffffffff000f000L,
    },{ .name = "POR_RNI_S1_QOS_LAT_SCALE_U_RNI_NID132",
        .addr = A_POR_RNI_S1_QOS_LAT_SCALE_U_RNI_NID132,
        .rsvd = 0xf8,
        .ro = 0xfffffffffffff8f8L,
    },{ .name = "POR_RNI_S1_QOS_LAT_RANGE_U_RNI_NID132",
        .addr = A_POR_RNI_S1_QOS_LAT_RANGE_U_RNI_NID132,
        .rsvd = 0xf0,
        .ro = 0xfffffffff0f0f0f0L,
    },{ .name = "POR_RNI_S2_QOS_CONTROL_U_RNI_NID132",
        .addr = A_POR_RNI_S2_QOS_CONTROL_U_RNI_NID132,
        .rsvd = 0xff00,
        .ro = 0xffffffffff00ff00L,
    },{ .name = "POR_RNI_S2_QOS_LAT_TGT_U_RNI_NID132",
        .addr = A_POR_RNI_S2_QOS_LAT_TGT_U_RNI_NID132,
        .ro = 0xfffffffff000f000L,
    },{ .name = "POR_RNI_S2_QOS_LAT_SCALE_U_RNI_NID132",
        .addr = A_POR_RNI_S2_QOS_LAT_SCALE_U_RNI_NID132,
        .rsvd = 0xf8,
        .ro = 0xfffffffffffff8f8L,
    },{ .name = "POR_RNI_S2_QOS_LAT_RANGE_U_RNI_NID132",
        .addr = A_POR_RNI_S2_QOS_LAT_RANGE_U_RNI_NID132,
        .rsvd = 0xf0,
        .ro = 0xfffffffff0f0f0f0L,
    },{ .name = "POR_RNI_PMU_EVENT_SEL_U_RNI_NID132",
        .addr = A_POR_RNI_PMU_EVENT_SEL_U_RNI_NID132,
        .rsvd = 0xe0,
        .ro = 0xffffffffe0e0e0e0L,
    },{ .name = "POR_RNSAM_NODE_INFO_U_RNI_NID132",
        .addr = A_POR_RNSAM_NODE_INFO_U_RNI_NID132,
        .reset = 0x4000f,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_RNSAM_CHILD_INFO_U_RNI_NID132",
        .addr = A_POR_RNSAM_CHILD_INFO_U_RNI_NID132,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_RNSAM_UNIT_INFO_U_RNI_NID132",
        .addr = A_POR_RNSAM_UNIT_INFO_U_RNI_NID132,
        .reset = 0x800040004,
        .rsvd = 0xff00,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_RNSAM_SECURE_REGISTER_GROUPS_OVERRIDE_U_RNI_NID132",
        .addr = A_POR_RNSAM_SECURE_REGISTER_GROUPS_OVERRIDE_U_RNI_NID132,
        .rsvd = 0xfffffffffffffffeL,
        .ro = 0xfffffffffffffffeL,
    },{ .name = "RNSAM_STATUS_U_RNI_NID132",
        .addr = A_RNSAM_STATUS_U_RNI_NID132,
        .reset = 0x1,
        .rsvd = 0xfffffffffffffffcL,
        .ro = 0xfffffffffffffffcL,
    },{ .name = "NON_HASH_MEM_REGION_REG0_U_RNI_NID132",
        .addr = A_NON_HASH_MEM_REGION_REG0_U_RNI_NID132,
        .rsvd = 0x2,
        .ro = 0x8000000280000002L,
    },{ .name = "NON_HASH_MEM_REGION_REG1_U_RNI_NID132",
        .addr = A_NON_HASH_MEM_REGION_REG1_U_RNI_NID132,
        .rsvd = 0x2,
        .ro = 0x8000000280000002L,
    },{ .name = "NON_HASH_MEM_REGION_REG2_U_RNI_NID132",
        .addr = A_NON_HASH_MEM_REGION_REG2_U_RNI_NID132,
        .rsvd = 0x2,
        .ro = 0x8000000280000002L,
    },{ .name = "NON_HASH_MEM_REGION_REG3_U_RNI_NID132",
        .addr = A_NON_HASH_MEM_REGION_REG3_U_RNI_NID132,
        .rsvd = 0x2,
        .ro = 0x8000000280000002L,
    },{ .name = "NON_HASH_TGT_NODEID0_U_RNI_NID132",
        .addr = A_NON_HASH_TGT_NODEID0_U_RNI_NID132,
        .ro = 0xffff800800800800L,
    },{ .name = "NON_HASH_TGT_NODEID1_U_RNI_NID132",
        .addr = A_NON_HASH_TGT_NODEID1_U_RNI_NID132,
        .ro = 0xffff800800800800L,
    },{ .name = "NON_HASH_TGT_NODEID2_U_RNI_NID132",
        .addr = A_NON_HASH_TGT_NODEID2_U_RNI_NID132,
        .ro = 0xffffffffff800800L,
    },{ .name = "SYS_CACHE_GRP_REGION0_U_RNI_NID132",
        .addr = A_SYS_CACHE_GRP_REGION0_U_RNI_NID132,
        .rsvd = 0x2,
        .ro = 0x8000000080000002L,
    },{ .name = "SYS_CACHE_GRP_REGION1_U_RNI_NID132",
        .addr = A_SYS_CACHE_GRP_REGION1_U_RNI_NID132,
        .ro = 0x8000000080000000L,
    },{ .name = "SYS_CACHE_GRP_HN_NODEID_REG0_U_RNI_NID132",
        .addr = A_SYS_CACHE_GRP_HN_NODEID_REG0_U_RNI_NID132,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_HN_NODEID_REG1_U_RNI_NID132",
        .addr = A_SYS_CACHE_GRP_HN_NODEID_REG1_U_RNI_NID132,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_HN_NODEID_REG2_U_RNI_NID132",
        .addr = A_SYS_CACHE_GRP_HN_NODEID_REG2_U_RNI_NID132,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_HN_NODEID_REG3_U_RNI_NID132",
        .addr = A_SYS_CACHE_GRP_HN_NODEID_REG3_U_RNI_NID132,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_HN_NODEID_REG4_U_RNI_NID132",
        .addr = A_SYS_CACHE_GRP_HN_NODEID_REG4_U_RNI_NID132,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_HN_NODEID_REG5_U_RNI_NID132",
        .addr = A_SYS_CACHE_GRP_HN_NODEID_REG5_U_RNI_NID132,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_HN_NODEID_REG6_U_RNI_NID132",
        .addr = A_SYS_CACHE_GRP_HN_NODEID_REG6_U_RNI_NID132,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_HN_NODEID_REG7_U_RNI_NID132",
        .addr = A_SYS_CACHE_GRP_HN_NODEID_REG7_U_RNI_NID132,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_NONHASH_NODEID_U_RNI_NID132",
        .addr = A_SYS_CACHE_GRP_NONHASH_NODEID_U_RNI_NID132,
        .ro = 0xfffffff800800800L,
    },{ .name = "SYS_CACHE_GROUP_HN_COUNT_U_RNI_NID132",
        .addr = A_SYS_CACHE_GROUP_HN_COUNT_U_RNI_NID132,
        .rsvd = 0x80,
        .ro = 0xffffffff80808080L,
    },{ .name = "SYS_CACHE_GRP_SN_NODEID_REG0_U_RNI_NID132",
        .addr = A_SYS_CACHE_GRP_SN_NODEID_REG0_U_RNI_NID132,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_SN_NODEID_REG1_U_RNI_NID132",
        .addr = A_SYS_CACHE_GRP_SN_NODEID_REG1_U_RNI_NID132,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_SN_NODEID_REG2_U_RNI_NID132",
        .addr = A_SYS_CACHE_GRP_SN_NODEID_REG2_U_RNI_NID132,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_SN_NODEID_REG3_U_RNI_NID132",
        .addr = A_SYS_CACHE_GRP_SN_NODEID_REG3_U_RNI_NID132,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_SN_NODEID_REG4_U_RNI_NID132",
        .addr = A_SYS_CACHE_GRP_SN_NODEID_REG4_U_RNI_NID132,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_SN_NODEID_REG5_U_RNI_NID132",
        .addr = A_SYS_CACHE_GRP_SN_NODEID_REG5_U_RNI_NID132,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_SN_NODEID_REG6_U_RNI_NID132",
        .addr = A_SYS_CACHE_GRP_SN_NODEID_REG6_U_RNI_NID132,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_SN_NODEID_REG7_U_RNI_NID132",
        .addr = A_SYS_CACHE_GRP_SN_NODEID_REG7_U_RNI_NID132,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_SN_SAM_CFG0_U_RNI_NID132",
        .addr = A_SYS_CACHE_GRP_SN_SAM_CFG0_U_RNI_NID132,
        .rsvd = 0xc0,
        .ro = 0xffffc0c0c0c0c0c0L,
    },{ .name = "SYS_CACHE_GRP_SN_SAM_CFG1_U_RNI_NID132",
        .addr = A_SYS_CACHE_GRP_SN_SAM_CFG1_U_RNI_NID132,
        .rsvd = 0xc0,
        .ro = 0xffffc0c0c0c0c0c0L,
    },{ .name = "GIC_MEM_REGION_REG_U_RNI_NID132",
        .addr = A_GIC_MEM_REGION_REG_U_RNI_NID132,
        .rsvd = 0xff82,
        .ro = 0x800f00000000ff82L,
    },{ .name = "SYS_CACHE_GRP_SN_ATTR_U_RNI_NID132",
        .addr = A_SYS_CACHE_GRP_SN_ATTR_U_RNI_NID132,
        .rsvd = 0xffce,
        .ro = 0xffceffceffceffceL,
    },{ .name = "SYS_CACHE_GRP_HN_CPA_EN_REG_U_RNI_NID132",
        .addr = A_SYS_CACHE_GRP_HN_CPA_EN_REG_U_RNI_NID132,
    },{ .name = "SYS_CACHE_GRP_HN_CPA_GRP_REG_U_RNI_NID132",
        .addr = A_SYS_CACHE_GRP_HN_CPA_GRP_REG_U_RNI_NID132,
        .rsvd = 0xfffc,
        .ro = 0xfffcfffcfffcfffcL,
    },{ .name = "CML_PORT_AGGR_MODE_CTRL_REG_U_RNI_NID132",
        .addr = A_CML_PORT_AGGR_MODE_CTRL_REG_U_RNI_NID132,
        .rsvd = 0x88,
        .ro = 0xffffffff28888888L,
    },{ .name = "CML_PORT_AGGR_GRP0_ADD_MASK_U_RNI_NID132",
        .addr = A_CML_PORT_AGGR_GRP0_ADD_MASK_U_RNI_NID132,
        .reset = 0x40,
        .ro = 0xffff00000000003fL,
    },{ .name = "CML_PORT_AGGR_GRP1_ADD_MASK_U_RNI_NID132",
        .addr = A_CML_PORT_AGGR_GRP1_ADD_MASK_U_RNI_NID132,
        .reset = 0x40,
        .ro = 0xffff00000000003fL,
    },{ .name = "CML_PORT_AGGR_GRP0_REG_U_RNI_NID132",
        .addr = A_CML_PORT_AGGR_GRP0_REG_U_RNI_NID132,
        .ro = 0xfffc800800800800L,
    },{ .name = "CML_PORT_AGGR_GRP1_REG_U_RNI_NID132",
        .addr = A_CML_PORT_AGGR_GRP1_REG_U_RNI_NID132,
        .ro = 0xfffc800800800800L,
    },{ .name = "SYS_CACHE_GRP_SECONDARY_REG0_U_RNI_NID132",
        .addr = A_SYS_CACHE_GRP_SECONDARY_REG0_U_RNI_NID132,
        .rsvd = 0x2,
        .ro = 0x8000000280000002L,
    },{ .name = "SYS_CACHE_GRP_SECONDARY_REG1_U_RNI_NID132",
        .addr = A_SYS_CACHE_GRP_SECONDARY_REG1_U_RNI_NID132,
        .rsvd = 0x2,
        .ro = 0x8000000280000002L,
    },{ .name = "SYS_CACHE_GRP_CAL_MODE_REG_U_RNI_NID132",
        .addr = A_SYS_CACHE_GRP_CAL_MODE_REG_U_RNI_NID132,
        .rsvd = 0xfffe,
        .ro = 0xfffefffefffefffeL,
    },{ .name = "RNSAM_HASH_ADDR_MASK_REG_U_RNI_NID132",
        .addr = A_RNSAM_HASH_ADDR_MASK_REG_U_RNI_NID132,
        .reset = 0xffffffffffc0,
        .ro = 0xffff00000000003fL,
    },{ .name = "RNSAM_REGION_CMP_ADDR_MASK_REG_U_RNI_NID132",
        .addr = A_RNSAM_REGION_CMP_ADDR_MASK_REG_U_RNI_NID132,
        .reset = 0xffffffff0000,
        .ro = 0xffff00000000ffffL,
    },{ .name = "SYS_CACHE_GRP_HN_NODEID_REG8_U_RNI_NID132",
        .addr = A_SYS_CACHE_GRP_HN_NODEID_REG8_U_RNI_NID132,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_HN_NODEID_REG9_U_RNI_NID132",
        .addr = A_SYS_CACHE_GRP_HN_NODEID_REG9_U_RNI_NID132,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_HN_NODEID_REG10_U_RNI_NID132",
        .addr = A_SYS_CACHE_GRP_HN_NODEID_REG10_U_RNI_NID132,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_HN_NODEID_REG11_U_RNI_NID132",
        .addr = A_SYS_CACHE_GRP_HN_NODEID_REG11_U_RNI_NID132,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_HN_NODEID_REG12_U_RNI_NID132",
        .addr = A_SYS_CACHE_GRP_HN_NODEID_REG12_U_RNI_NID132,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_HN_NODEID_REG13_U_RNI_NID132",
        .addr = A_SYS_CACHE_GRP_HN_NODEID_REG13_U_RNI_NID132,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_HN_NODEID_REG14_U_RNI_NID132",
        .addr = A_SYS_CACHE_GRP_HN_NODEID_REG14_U_RNI_NID132,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_HN_NODEID_REG15_U_RNI_NID132",
        .addr = A_SYS_CACHE_GRP_HN_NODEID_REG15_U_RNI_NID132,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_SN_NODEID_REG8_U_RNI_NID132",
        .addr = A_SYS_CACHE_GRP_SN_NODEID_REG8_U_RNI_NID132,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_SN_NODEID_REG9_U_RNI_NID132",
        .addr = A_SYS_CACHE_GRP_SN_NODEID_REG9_U_RNI_NID132,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_SN_NODEID_REG10_U_RNI_NID132",
        .addr = A_SYS_CACHE_GRP_SN_NODEID_REG10_U_RNI_NID132,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_SN_NODEID_REG11_U_RNI_NID132",
        .addr = A_SYS_CACHE_GRP_SN_NODEID_REG11_U_RNI_NID132,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_SN_NODEID_REG12_U_RNI_NID132",
        .addr = A_SYS_CACHE_GRP_SN_NODEID_REG12_U_RNI_NID132,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_SN_NODEID_REG13_U_RNI_NID132",
        .addr = A_SYS_CACHE_GRP_SN_NODEID_REG13_U_RNI_NID132,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_SN_NODEID_REG14_U_RNI_NID132",
        .addr = A_SYS_CACHE_GRP_SN_NODEID_REG14_U_RNI_NID132,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_SN_NODEID_REG15_U_RNI_NID132",
        .addr = A_SYS_CACHE_GRP_SN_NODEID_REG15_U_RNI_NID132,
        .ro = 0xffff800800800800L,
    },{ .name = "POR_FDC_NODE_INFO_U_SMXP_2_0",
        .addr = A_POR_FDC_NODE_INFO_U_SMXP_2_0,
        .reset = 0x201,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_FDC_CHILD_INFO_U_SMXP_2_0",
        .addr = A_POR_FDC_CHILD_INFO_U_SMXP_2_0,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_ERRFR_MXP_U_SMXP_2_0",  .addr = A_POR_ERRFR_MXP_U_SMXP_2_0,
        .reset = 0xa1,
        .rsvd = 0xffffffffffffff0cL,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_ERRCTLR_MXP_U_SMXP_2_0",
        .addr = A_POR_ERRCTLR_MXP_U_SMXP_2_0,
        .reset = 0xd,
        .rsvd = 0x3ff2,
        .ro = 0xffffffff00003ff2L,
    },{ .name = "POR_ERRSTATUS_MXP_U_SMXP_2_0",
        .addr = A_POR_ERRSTATUS_MXP_U_SMXP_2_0,
        .ro = 0xffffffff977f003fL,
    },{ .name = "POR_FDC_AUX_CTL_MXP_U_SMXP_2_0",
        .addr = A_POR_FDC_AUX_CTL_MXP_U_SMXP_2_0,
        .rsvd = 0xffffffffffffffe0L,
        .ro = 0xffffffffffffffefL,
    },{ .name = "POR_ERRFR_P0_D0_U_SMXP_2_0",
        .addr = A_POR_ERRFR_P0_D0_U_SMXP_2_0,
        .reset = 0xa1,
        .rsvd = 0xffffffffffffff0cL,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_ERRCTLR_P0_D0_U_SMXP_2_0",
        .addr = A_POR_ERRCTLR_P0_D0_U_SMXP_2_0,
        .reset = 0xd,
        .rsvd = 0x3ff2,
        .ro = 0xffffffff00003ff2L,
    },{ .name = "POR_ERRSTATUS_P0_D0_U_SMXP_2_0",
        .addr = A_POR_ERRSTATUS_P0_D0_U_SMXP_2_0,
        .ro = 0xffffffff977f003fL,
    },{ .name = "POR_FDC_AUX_CTL_P0_D0_U_SMXP_2_0",
        .addr = A_POR_FDC_AUX_CTL_P0_D0_U_SMXP_2_0,
        .rsvd = 0xffffffffffffffe0L,
        .ro = 0xffffffffffffffe0L,
    },{ .name = "POR_ERRFR_P0_D1_U_SMXP_2_0",
        .addr = A_POR_ERRFR_P0_D1_U_SMXP_2_0,
        .reset = 0xa1,
        .rsvd = 0xffffffffffffff0cL,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_ERRCTLR_P0_D1_U_SMXP_2_0",
        .addr = A_POR_ERRCTLR_P0_D1_U_SMXP_2_0,
        .reset = 0xd,
        .rsvd = 0x3ff2,
        .ro = 0xffffffff00003ff2L,
    },{ .name = "POR_ERRSTATUS_P0_D1_U_SMXP_2_0",
        .addr = A_POR_ERRSTATUS_P0_D1_U_SMXP_2_0,
        .ro = 0xffffffff977f003fL,
    },{ .name = "POR_FDC_AUX_CTL_P0_D1_U_SMXP_2_0",
        .addr = A_POR_FDC_AUX_CTL_P0_D1_U_SMXP_2_0,
        .rsvd = 0xffffffffffffffe0L,
        .ro = 0xffffffffffffffe0L,
    },{ .name = "POR_ERRFR_P0_D2_U_SMXP_2_0",
        .addr = A_POR_ERRFR_P0_D2_U_SMXP_2_0,
        .reset = 0xa1,
        .rsvd = 0xffffffffffffff0cL,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_ERRCTLR_P0_D2_U_SMXP_2_0",
        .addr = A_POR_ERRCTLR_P0_D2_U_SMXP_2_0,
        .reset = 0xd,
        .rsvd = 0x3ff2,
        .ro = 0xffffffff00003ff2L,
    },{ .name = "POR_ERRSTATUS_P0_D2_U_SMXP_2_0",
        .addr = A_POR_ERRSTATUS_P0_D2_U_SMXP_2_0,
        .ro = 0xffffffff977f003fL,
    },{ .name = "POR_FDC_AUX_CTL_P0_D2_U_SMXP_2_0",
        .addr = A_POR_FDC_AUX_CTL_P0_D2_U_SMXP_2_0,
        .rsvd = 0xffffffffffffffe0L,
        .ro = 0xffffffffffffffe0L,
    },{ .name = "POR_ERRFR_P0_D3_U_SMXP_2_0",
        .addr = A_POR_ERRFR_P0_D3_U_SMXP_2_0,
        .reset = 0xa1,
        .rsvd = 0xffffffffffffff0cL,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_ERRCTLR_P0_D3_U_SMXP_2_0",
        .addr = A_POR_ERRCTLR_P0_D3_U_SMXP_2_0,
        .reset = 0xd,
        .rsvd = 0x3ff2,
        .ro = 0xffffffff00003ff2L,
    },{ .name = "POR_ERRSTATUS_P0_D3_U_SMXP_2_0",
        .addr = A_POR_ERRSTATUS_P0_D3_U_SMXP_2_0,
        .ro = 0xffffffff977f003fL,
    },{ .name = "POR_FDC_AUX_CTL_P0_D3_U_SMXP_2_0",
        .addr = A_POR_FDC_AUX_CTL_P0_D3_U_SMXP_2_0,
        .rsvd = 0xffffffffffffffe0L,
        .ro = 0xffffffffffffffe0L,
    },{ .name = "POR_ERRFR_P1_D0_U_SMXP_2_0",
        .addr = A_POR_ERRFR_P1_D0_U_SMXP_2_0,
        .reset = 0xa1,
        .rsvd = 0xffffffffffffff0cL,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_ERRCTLR_P1_D0_U_SMXP_2_0",
        .addr = A_POR_ERRCTLR_P1_D0_U_SMXP_2_0,
        .reset = 0xd,
        .rsvd = 0x3ff2,
        .ro = 0xffffffff00003ff2L,
    },{ .name = "POR_ERRSTATUS_P1_D0_U_SMXP_2_0",
        .addr = A_POR_ERRSTATUS_P1_D0_U_SMXP_2_0,
        .ro = 0xffffffff977f003fL,
    },{ .name = "POR_FDC_AUX_CTL_P1_D0_U_SMXP_2_0",
        .addr = A_POR_FDC_AUX_CTL_P1_D0_U_SMXP_2_0,
        .rsvd = 0xffffffffffffffe0L,
        .ro = 0xffffffffffffffe0L,
    },{ .name = "POR_ERRFR_P1_D1_U_SMXP_2_0",
        .addr = A_POR_ERRFR_P1_D1_U_SMXP_2_0,
        .reset = 0xa1,
        .rsvd = 0xffffffffffffff0cL,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_ERRCTLR_P1_D1_U_SMXP_2_0",
        .addr = A_POR_ERRCTLR_P1_D1_U_SMXP_2_0,
        .reset = 0xd,
        .rsvd = 0x3ff2,
        .ro = 0xffffffff00003ff2L,
    },{ .name = "POR_ERRSTATUS_P1_D1_U_SMXP_2_0",
        .addr = A_POR_ERRSTATUS_P1_D1_U_SMXP_2_0,
        .ro = 0xffffffff977f003fL,
    },{ .name = "POR_FDC_AUX_CTL_P1_D1_U_SMXP_2_0",
        .addr = A_POR_FDC_AUX_CTL_P1_D1_U_SMXP_2_0,
        .rsvd = 0xffffffffffffffe0L,
        .ro = 0xffffffffffffffe0L,
    },{ .name = "POR_ERRFR_P1_D2_U_SMXP_2_0",
        .addr = A_POR_ERRFR_P1_D2_U_SMXP_2_0,
        .reset = 0xa1,
        .rsvd = 0xffffffffffffff0cL,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_ERRCTLR_P1_D2_U_SMXP_2_0",
        .addr = A_POR_ERRCTLR_P1_D2_U_SMXP_2_0,
        .reset = 0xd,
        .rsvd = 0x3ff2,
        .ro = 0xffffffff00003ff2L,
    },{ .name = "POR_ERRSTATUS_P1_D2_U_SMXP_2_0",
        .addr = A_POR_ERRSTATUS_P1_D2_U_SMXP_2_0,
        .ro = 0xffffffff977f003fL,
    },{ .name = "POR_FDC_AUX_CTL_P1_D2_U_SMXP_2_0",
        .addr = A_POR_FDC_AUX_CTL_P1_D2_U_SMXP_2_0,
        .rsvd = 0xffffffffffffffe0L,
        .ro = 0xffffffffffffffe0L,
    },{ .name = "POR_ERRFR_P1_D3_U_SMXP_2_0",
        .addr = A_POR_ERRFR_P1_D3_U_SMXP_2_0,
        .reset = 0xa1,
        .rsvd = 0xffffffffffffff0cL,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_ERRCTLR_P1_D3_U_SMXP_2_0",
        .addr = A_POR_ERRCTLR_P1_D3_U_SMXP_2_0,
        .reset = 0xd,
        .rsvd = 0x3ff2,
        .ro = 0xffffffff00003ff2L,
    },{ .name = "POR_ERRSTATUS_P1_D3_U_SMXP_2_0",
        .addr = A_POR_ERRSTATUS_P1_D3_U_SMXP_2_0,
        .ro = 0xffffffff977f003fL,
    },{ .name = "POR_FDC_AUX_CTL_P1_D3_U_SMXP_2_0",
        .addr = A_POR_FDC_AUX_CTL_P1_D3_U_SMXP_2_0,
        .rsvd = 0xffffffffffffffe0L,
        .ro = 0xffffffffffffffe0L,
    },{ .name = "POR_ERRINJECT_U_SMXP_2_0",  .addr = A_POR_ERRINJECT_U_SMXP_2_0,
        .rsvd = 0xffffffffffffff00L,
        .ro = 0xffffffffffffff00L,
    },{ .name = "POR_FDC_KEY_U_SMXP_2_0",  .addr = A_POR_FDC_KEY_U_SMXP_2_0,
        .reset = 0xbe,
        .rsvd = 0xffffffffffffff00L,
        .ro = 0xffffffffffffff00L,
    },{ .name = "POR_MPU_NODE_INFO_U_RNI_NID132",
        .addr = A_POR_MPU_NODE_INFO_U_RNI_NID132,
        .reset = 0x202,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MPU_CHILD_INFO_U_RNI_NID132",
        .addr = A_POR_MPU_CHILD_INFO_U_RNI_NID132,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MPU_UNIT_INFO_U_RNI_NID132",
        .addr = A_POR_MPU_UNIT_INFO_U_RNI_NID132,
        .reset = 0x20,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MPU_M0_CTL_U_RNI_NID132",
        .addr = A_POR_MPU_M0_CTL_U_RNI_NID132,
        .reset = 0x2,
        .rsvd = 0xfffffffffffffff8L,
        .ro = 0xfffffffffffffff8L,
    },{ .name = "POR_MPU_M0_PRBAR0_U_RNI_NID132",
        .addr = A_POR_MPU_M0_PRBAR0_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR0_U_RNI_NID132",
        .addr = A_POR_MPU_M0_PRLAR0_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR1_U_RNI_NID132",
        .addr = A_POR_MPU_M0_PRBAR1_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR1_U_RNI_NID132",
        .addr = A_POR_MPU_M0_PRLAR1_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR2_U_RNI_NID132",
        .addr = A_POR_MPU_M0_PRBAR2_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR2_U_RNI_NID132",
        .addr = A_POR_MPU_M0_PRLAR2_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR3_U_RNI_NID132",
        .addr = A_POR_MPU_M0_PRBAR3_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR3_U_RNI_NID132",
        .addr = A_POR_MPU_M0_PRLAR3_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR4_U_RNI_NID132",
        .addr = A_POR_MPU_M0_PRBAR4_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR4_U_RNI_NID132",
        .addr = A_POR_MPU_M0_PRLAR4_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR5_U_RNI_NID132",
        .addr = A_POR_MPU_M0_PRBAR5_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR5_U_RNI_NID132",
        .addr = A_POR_MPU_M0_PRLAR5_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR6_U_RNI_NID132",
        .addr = A_POR_MPU_M0_PRBAR6_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR6_U_RNI_NID132",
        .addr = A_POR_MPU_M0_PRLAR6_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR7_U_RNI_NID132",
        .addr = A_POR_MPU_M0_PRBAR7_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR7_U_RNI_NID132",
        .addr = A_POR_MPU_M0_PRLAR7_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR8_U_RNI_NID132",
        .addr = A_POR_MPU_M0_PRBAR8_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR8_U_RNI_NID132",
        .addr = A_POR_MPU_M0_PRLAR8_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR9_U_RNI_NID132",
        .addr = A_POR_MPU_M0_PRBAR9_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR9_U_RNI_NID132",
        .addr = A_POR_MPU_M0_PRLAR9_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR10_U_RNI_NID132",
        .addr = A_POR_MPU_M0_PRBAR10_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR10_U_RNI_NID132",
        .addr = A_POR_MPU_M0_PRLAR10_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR11_U_RNI_NID132",
        .addr = A_POR_MPU_M0_PRBAR11_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR11_U_RNI_NID132",
        .addr = A_POR_MPU_M0_PRLAR11_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR12_U_RNI_NID132",
        .addr = A_POR_MPU_M0_PRBAR12_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR12_U_RNI_NID132",
        .addr = A_POR_MPU_M0_PRLAR12_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR13_U_RNI_NID132",
        .addr = A_POR_MPU_M0_PRBAR13_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR13_U_RNI_NID132",
        .addr = A_POR_MPU_M0_PRLAR13_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR14_U_RNI_NID132",
        .addr = A_POR_MPU_M0_PRBAR14_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR14_U_RNI_NID132",
        .addr = A_POR_MPU_M0_PRLAR14_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR15_U_RNI_NID132",
        .addr = A_POR_MPU_M0_PRBAR15_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR15_U_RNI_NID132",
        .addr = A_POR_MPU_M0_PRLAR15_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR16_U_RNI_NID132",
        .addr = A_POR_MPU_M0_PRBAR16_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR16_U_RNI_NID132",
        .addr = A_POR_MPU_M0_PRLAR16_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR17_U_RNI_NID132",
        .addr = A_POR_MPU_M0_PRBAR17_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR17_U_RNI_NID132",
        .addr = A_POR_MPU_M0_PRLAR17_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR18_U_RNI_NID132",
        .addr = A_POR_MPU_M0_PRBAR18_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR18_U_RNI_NID132",
        .addr = A_POR_MPU_M0_PRLAR18_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR19_U_RNI_NID132",
        .addr = A_POR_MPU_M0_PRBAR19_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR19_U_RNI_NID132",
        .addr = A_POR_MPU_M0_PRLAR19_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR20_U_RNI_NID132",
        .addr = A_POR_MPU_M0_PRBAR20_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR20_U_RNI_NID132",
        .addr = A_POR_MPU_M0_PRLAR20_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR21_U_RNI_NID132",
        .addr = A_POR_MPU_M0_PRBAR21_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR21_U_RNI_NID132",
        .addr = A_POR_MPU_M0_PRLAR21_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR22_U_RNI_NID132",
        .addr = A_POR_MPU_M0_PRBAR22_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR22_U_RNI_NID132",
        .addr = A_POR_MPU_M0_PRLAR22_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR23_U_RNI_NID132",
        .addr = A_POR_MPU_M0_PRBAR23_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR23_U_RNI_NID132",
        .addr = A_POR_MPU_M0_PRLAR23_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR24_U_RNI_NID132",
        .addr = A_POR_MPU_M0_PRBAR24_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR24_U_RNI_NID132",
        .addr = A_POR_MPU_M0_PRLAR24_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR25_U_RNI_NID132",
        .addr = A_POR_MPU_M0_PRBAR25_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR25_U_RNI_NID132",
        .addr = A_POR_MPU_M0_PRLAR25_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR26_U_RNI_NID132",
        .addr = A_POR_MPU_M0_PRBAR26_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR26_U_RNI_NID132",
        .addr = A_POR_MPU_M0_PRLAR26_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR27_U_RNI_NID132",
        .addr = A_POR_MPU_M0_PRBAR27_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR27_U_RNI_NID132",
        .addr = A_POR_MPU_M0_PRLAR27_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR28_U_RNI_NID132",
        .addr = A_POR_MPU_M0_PRBAR28_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR28_U_RNI_NID132",
        .addr = A_POR_MPU_M0_PRLAR28_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR29_U_RNI_NID132",
        .addr = A_POR_MPU_M0_PRBAR29_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR29_U_RNI_NID132",
        .addr = A_POR_MPU_M0_PRLAR29_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR30_U_RNI_NID132",
        .addr = A_POR_MPU_M0_PRBAR30_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR30_U_RNI_NID132",
        .addr = A_POR_MPU_M0_PRLAR30_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR31_U_RNI_NID132",
        .addr = A_POR_MPU_M0_PRBAR31_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR31_U_RNI_NID132",
        .addr = A_POR_MPU_M0_PRLAR31_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_CTL_U_RNI_NID132",
        .addr = A_POR_MPU_M1_CTL_U_RNI_NID132,
        .reset = 0x2,
        .rsvd = 0xfffffffffffffff8L,
        .ro = 0xfffffffffffffff8L,
    },{ .name = "POR_MPU_M1_PRBAR0_U_RNI_NID132",
        .addr = A_POR_MPU_M1_PRBAR0_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR0_U_RNI_NID132",
        .addr = A_POR_MPU_M1_PRLAR0_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR1_U_RNI_NID132",
        .addr = A_POR_MPU_M1_PRBAR1_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR1_U_RNI_NID132",
        .addr = A_POR_MPU_M1_PRLAR1_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR2_U_RNI_NID132",
        .addr = A_POR_MPU_M1_PRBAR2_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR2_U_RNI_NID132",
        .addr = A_POR_MPU_M1_PRLAR2_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR3_U_RNI_NID132",
        .addr = A_POR_MPU_M1_PRBAR3_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR3_U_RNI_NID132",
        .addr = A_POR_MPU_M1_PRLAR3_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR4_U_RNI_NID132",
        .addr = A_POR_MPU_M1_PRBAR4_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR4_U_RNI_NID132",
        .addr = A_POR_MPU_M1_PRLAR4_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR5_U_RNI_NID132",
        .addr = A_POR_MPU_M1_PRBAR5_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR5_U_RNI_NID132",
        .addr = A_POR_MPU_M1_PRLAR5_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR6_U_RNI_NID132",
        .addr = A_POR_MPU_M1_PRBAR6_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR6_U_RNI_NID132",
        .addr = A_POR_MPU_M1_PRLAR6_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR7_U_RNI_NID132",
        .addr = A_POR_MPU_M1_PRBAR7_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR7_U_RNI_NID132",
        .addr = A_POR_MPU_M1_PRLAR7_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR8_U_RNI_NID132",
        .addr = A_POR_MPU_M1_PRBAR8_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR8_U_RNI_NID132",
        .addr = A_POR_MPU_M1_PRLAR8_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR9_U_RNI_NID132",
        .addr = A_POR_MPU_M1_PRBAR9_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR9_U_RNI_NID132",
        .addr = A_POR_MPU_M1_PRLAR9_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR10_U_RNI_NID132",
        .addr = A_POR_MPU_M1_PRBAR10_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR10_U_RNI_NID132",
        .addr = A_POR_MPU_M1_PRLAR10_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR11_U_RNI_NID132",
        .addr = A_POR_MPU_M1_PRBAR11_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR11_U_RNI_NID132",
        .addr = A_POR_MPU_M1_PRLAR11_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR12_U_RNI_NID132",
        .addr = A_POR_MPU_M1_PRBAR12_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR12_U_RNI_NID132",
        .addr = A_POR_MPU_M1_PRLAR12_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR13_U_RNI_NID132",
        .addr = A_POR_MPU_M1_PRBAR13_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR13_U_RNI_NID132",
        .addr = A_POR_MPU_M1_PRLAR13_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR14_U_RNI_NID132",
        .addr = A_POR_MPU_M1_PRBAR14_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR14_U_RNI_NID132",
        .addr = A_POR_MPU_M1_PRLAR14_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR15_U_RNI_NID132",
        .addr = A_POR_MPU_M1_PRBAR15_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR15_U_RNI_NID132",
        .addr = A_POR_MPU_M1_PRLAR15_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR16_U_RNI_NID132",
        .addr = A_POR_MPU_M1_PRBAR16_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR16_U_RNI_NID132",
        .addr = A_POR_MPU_M1_PRLAR16_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR17_U_RNI_NID132",
        .addr = A_POR_MPU_M1_PRBAR17_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR17_U_RNI_NID132",
        .addr = A_POR_MPU_M1_PRLAR17_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR18_U_RNI_NID132",
        .addr = A_POR_MPU_M1_PRBAR18_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR18_U_RNI_NID132",
        .addr = A_POR_MPU_M1_PRLAR18_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR19_U_RNI_NID132",
        .addr = A_POR_MPU_M1_PRBAR19_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR19_U_RNI_NID132",
        .addr = A_POR_MPU_M1_PRLAR19_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR20_U_RNI_NID132",
        .addr = A_POR_MPU_M1_PRBAR20_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR20_U_RNI_NID132",
        .addr = A_POR_MPU_M1_PRLAR20_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR21_U_RNI_NID132",
        .addr = A_POR_MPU_M1_PRBAR21_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR21_U_RNI_NID132",
        .addr = A_POR_MPU_M1_PRLAR21_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR22_U_RNI_NID132",
        .addr = A_POR_MPU_M1_PRBAR22_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR22_U_RNI_NID132",
        .addr = A_POR_MPU_M1_PRLAR22_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR23_U_RNI_NID132",
        .addr = A_POR_MPU_M1_PRBAR23_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR23_U_RNI_NID132",
        .addr = A_POR_MPU_M1_PRLAR23_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR24_U_RNI_NID132",
        .addr = A_POR_MPU_M1_PRBAR24_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR24_U_RNI_NID132",
        .addr = A_POR_MPU_M1_PRLAR24_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR25_U_RNI_NID132",
        .addr = A_POR_MPU_M1_PRBAR25_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR25_U_RNI_NID132",
        .addr = A_POR_MPU_M1_PRLAR25_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR26_U_RNI_NID132",
        .addr = A_POR_MPU_M1_PRBAR26_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR26_U_RNI_NID132",
        .addr = A_POR_MPU_M1_PRLAR26_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR27_U_RNI_NID132",
        .addr = A_POR_MPU_M1_PRBAR27_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR27_U_RNI_NID132",
        .addr = A_POR_MPU_M1_PRLAR27_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR28_U_RNI_NID132",
        .addr = A_POR_MPU_M1_PRBAR28_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR28_U_RNI_NID132",
        .addr = A_POR_MPU_M1_PRLAR28_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR29_U_RNI_NID132",
        .addr = A_POR_MPU_M1_PRBAR29_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR29_U_RNI_NID132",
        .addr = A_POR_MPU_M1_PRLAR29_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR30_U_RNI_NID132",
        .addr = A_POR_MPU_M1_PRBAR30_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR30_U_RNI_NID132",
        .addr = A_POR_MPU_M1_PRLAR30_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR31_U_RNI_NID132",
        .addr = A_POR_MPU_M1_PRBAR31_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR31_U_RNI_NID132",
        .addr = A_POR_MPU_M1_PRLAR31_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_CTL_U_RNI_NID132",
        .addr = A_POR_MPU_M2_CTL_U_RNI_NID132,
        .reset = 0x2,
        .rsvd = 0xfffffffffffffff8L,
        .ro = 0xfffffffffffffff8L,
    },{ .name = "POR_MPU_M2_PRBAR0_U_RNI_NID132",
        .addr = A_POR_MPU_M2_PRBAR0_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR0_U_RNI_NID132",
        .addr = A_POR_MPU_M2_PRLAR0_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR1_U_RNI_NID132",
        .addr = A_POR_MPU_M2_PRBAR1_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR1_U_RNI_NID132",
        .addr = A_POR_MPU_M2_PRLAR1_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR2_U_RNI_NID132",
        .addr = A_POR_MPU_M2_PRBAR2_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR2_U_RNI_NID132",
        .addr = A_POR_MPU_M2_PRLAR2_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR3_U_RNI_NID132",
        .addr = A_POR_MPU_M2_PRBAR3_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR3_U_RNI_NID132",
        .addr = A_POR_MPU_M2_PRLAR3_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR4_U_RNI_NID132",
        .addr = A_POR_MPU_M2_PRBAR4_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR4_U_RNI_NID132",
        .addr = A_POR_MPU_M2_PRLAR4_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR5_U_RNI_NID132",
        .addr = A_POR_MPU_M2_PRBAR5_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR5_U_RNI_NID132",
        .addr = A_POR_MPU_M2_PRLAR5_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR6_U_RNI_NID132",
        .addr = A_POR_MPU_M2_PRBAR6_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR6_U_RNI_NID132",
        .addr = A_POR_MPU_M2_PRLAR6_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR7_U_RNI_NID132",
        .addr = A_POR_MPU_M2_PRBAR7_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR7_U_RNI_NID132",
        .addr = A_POR_MPU_M2_PRLAR7_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR8_U_RNI_NID132",
        .addr = A_POR_MPU_M2_PRBAR8_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR8_U_RNI_NID132",
        .addr = A_POR_MPU_M2_PRLAR8_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR9_U_RNI_NID132",
        .addr = A_POR_MPU_M2_PRBAR9_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR9_U_RNI_NID132",
        .addr = A_POR_MPU_M2_PRLAR9_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR10_U_RNI_NID132",
        .addr = A_POR_MPU_M2_PRBAR10_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR10_U_RNI_NID132",
        .addr = A_POR_MPU_M2_PRLAR10_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR11_U_RNI_NID132",
        .addr = A_POR_MPU_M2_PRBAR11_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR11_U_RNI_NID132",
        .addr = A_POR_MPU_M2_PRLAR11_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR12_U_RNI_NID132",
        .addr = A_POR_MPU_M2_PRBAR12_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR12_U_RNI_NID132",
        .addr = A_POR_MPU_M2_PRLAR12_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR13_U_RNI_NID132",
        .addr = A_POR_MPU_M2_PRBAR13_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR13_U_RNI_NID132",
        .addr = A_POR_MPU_M2_PRLAR13_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR14_U_RNI_NID132",
        .addr = A_POR_MPU_M2_PRBAR14_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR14_U_RNI_NID132",
        .addr = A_POR_MPU_M2_PRLAR14_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR15_U_RNI_NID132",
        .addr = A_POR_MPU_M2_PRBAR15_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR15_U_RNI_NID132",
        .addr = A_POR_MPU_M2_PRLAR15_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR16_U_RNI_NID132",
        .addr = A_POR_MPU_M2_PRBAR16_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR16_U_RNI_NID132",
        .addr = A_POR_MPU_M2_PRLAR16_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR17_U_RNI_NID132",
        .addr = A_POR_MPU_M2_PRBAR17_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR17_U_RNI_NID132",
        .addr = A_POR_MPU_M2_PRLAR17_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR18_U_RNI_NID132",
        .addr = A_POR_MPU_M2_PRBAR18_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR18_U_RNI_NID132",
        .addr = A_POR_MPU_M2_PRLAR18_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR19_U_RNI_NID132",
        .addr = A_POR_MPU_M2_PRBAR19_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR19_U_RNI_NID132",
        .addr = A_POR_MPU_M2_PRLAR19_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR20_U_RNI_NID132",
        .addr = A_POR_MPU_M2_PRBAR20_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR20_U_RNI_NID132",
        .addr = A_POR_MPU_M2_PRLAR20_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR21_U_RNI_NID132",
        .addr = A_POR_MPU_M2_PRBAR21_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR21_U_RNI_NID132",
        .addr = A_POR_MPU_M2_PRLAR21_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR22_U_RNI_NID132",
        .addr = A_POR_MPU_M2_PRBAR22_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR22_U_RNI_NID132",
        .addr = A_POR_MPU_M2_PRLAR22_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR23_U_RNI_NID132",
        .addr = A_POR_MPU_M2_PRBAR23_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR23_U_RNI_NID132",
        .addr = A_POR_MPU_M2_PRLAR23_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR24_U_RNI_NID132",
        .addr = A_POR_MPU_M2_PRBAR24_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR24_U_RNI_NID132",
        .addr = A_POR_MPU_M2_PRLAR24_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR25_U_RNI_NID132",
        .addr = A_POR_MPU_M2_PRBAR25_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR25_U_RNI_NID132",
        .addr = A_POR_MPU_M2_PRLAR25_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR26_U_RNI_NID132",
        .addr = A_POR_MPU_M2_PRBAR26_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR26_U_RNI_NID132",
        .addr = A_POR_MPU_M2_PRLAR26_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR27_U_RNI_NID132",
        .addr = A_POR_MPU_M2_PRBAR27_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR27_U_RNI_NID132",
        .addr = A_POR_MPU_M2_PRLAR27_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR28_U_RNI_NID132",
        .addr = A_POR_MPU_M2_PRBAR28_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR28_U_RNI_NID132",
        .addr = A_POR_MPU_M2_PRLAR28_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR29_U_RNI_NID132",
        .addr = A_POR_MPU_M2_PRBAR29_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR29_U_RNI_NID132",
        .addr = A_POR_MPU_M2_PRLAR29_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR30_U_RNI_NID132",
        .addr = A_POR_MPU_M2_PRBAR30_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR30_U_RNI_NID132",
        .addr = A_POR_MPU_M2_PRLAR30_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR31_U_RNI_NID132",
        .addr = A_POR_MPU_M2_PRBAR31_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR31_U_RNI_NID132",
        .addr = A_POR_MPU_M2_PRLAR31_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_CTL_U_RNI_NID132",
        .addr = A_POR_MPU_M3_CTL_U_RNI_NID132,
        .reset = 0x2,
        .rsvd = 0xfffffffffffffff8L,
        .ro = 0xfffffffffffffff8L,
    },{ .name = "POR_MPU_M3_PRBAR0_U_RNI_NID132",
        .addr = A_POR_MPU_M3_PRBAR0_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR0_U_RNI_NID132",
        .addr = A_POR_MPU_M3_PRLAR0_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR1_U_RNI_NID132",
        .addr = A_POR_MPU_M3_PRBAR1_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR1_U_RNI_NID132",
        .addr = A_POR_MPU_M3_PRLAR1_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR2_U_RNI_NID132",
        .addr = A_POR_MPU_M3_PRBAR2_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR2_U_RNI_NID132",
        .addr = A_POR_MPU_M3_PRLAR2_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR3_U_RNI_NID132",
        .addr = A_POR_MPU_M3_PRBAR3_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR3_U_RNI_NID132",
        .addr = A_POR_MPU_M3_PRLAR3_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR4_U_RNI_NID132",
        .addr = A_POR_MPU_M3_PRBAR4_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR4_U_RNI_NID132",
        .addr = A_POR_MPU_M3_PRLAR4_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR5_U_RNI_NID132",
        .addr = A_POR_MPU_M3_PRBAR5_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR5_U_RNI_NID132",
        .addr = A_POR_MPU_M3_PRLAR5_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR6_U_RNI_NID132",
        .addr = A_POR_MPU_M3_PRBAR6_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR6_U_RNI_NID132",
        .addr = A_POR_MPU_M3_PRLAR6_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR7_U_RNI_NID132",
        .addr = A_POR_MPU_M3_PRBAR7_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR7_U_RNI_NID132",
        .addr = A_POR_MPU_M3_PRLAR7_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR8_U_RNI_NID132",
        .addr = A_POR_MPU_M3_PRBAR8_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR8_U_RNI_NID132",
        .addr = A_POR_MPU_M3_PRLAR8_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR9_U_RNI_NID132",
        .addr = A_POR_MPU_M3_PRBAR9_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR9_U_RNI_NID132",
        .addr = A_POR_MPU_M3_PRLAR9_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR10_U_RNI_NID132",
        .addr = A_POR_MPU_M3_PRBAR10_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR10_U_RNI_NID132",
        .addr = A_POR_MPU_M3_PRLAR10_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR11_U_RNI_NID132",
        .addr = A_POR_MPU_M3_PRBAR11_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR11_U_RNI_NID132",
        .addr = A_POR_MPU_M3_PRLAR11_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR12_U_RNI_NID132",
        .addr = A_POR_MPU_M3_PRBAR12_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR12_U_RNI_NID132",
        .addr = A_POR_MPU_M3_PRLAR12_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR13_U_RNI_NID132",
        .addr = A_POR_MPU_M3_PRBAR13_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR13_U_RNI_NID132",
        .addr = A_POR_MPU_M3_PRLAR13_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR14_U_RNI_NID132",
        .addr = A_POR_MPU_M3_PRBAR14_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR14_U_RNI_NID132",
        .addr = A_POR_MPU_M3_PRLAR14_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR15_U_RNI_NID132",
        .addr = A_POR_MPU_M3_PRBAR15_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR15_U_RNI_NID132",
        .addr = A_POR_MPU_M3_PRLAR15_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR16_U_RNI_NID132",
        .addr = A_POR_MPU_M3_PRBAR16_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR16_U_RNI_NID132",
        .addr = A_POR_MPU_M3_PRLAR16_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR17_U_RNI_NID132",
        .addr = A_POR_MPU_M3_PRBAR17_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR17_U_RNI_NID132",
        .addr = A_POR_MPU_M3_PRLAR17_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR18_U_RNI_NID132",
        .addr = A_POR_MPU_M3_PRBAR18_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR18_U_RNI_NID132",
        .addr = A_POR_MPU_M3_PRLAR18_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR19_U_RNI_NID132",
        .addr = A_POR_MPU_M3_PRBAR19_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR19_U_RNI_NID132",
        .addr = A_POR_MPU_M3_PRLAR19_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR20_U_RNI_NID132",
        .addr = A_POR_MPU_M3_PRBAR20_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR20_U_RNI_NID132",
        .addr = A_POR_MPU_M3_PRLAR20_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR21_U_RNI_NID132",
        .addr = A_POR_MPU_M3_PRBAR21_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR21_U_RNI_NID132",
        .addr = A_POR_MPU_M3_PRLAR21_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR22_U_RNI_NID132",
        .addr = A_POR_MPU_M3_PRBAR22_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR22_U_RNI_NID132",
        .addr = A_POR_MPU_M3_PRLAR22_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR23_U_RNI_NID132",
        .addr = A_POR_MPU_M3_PRBAR23_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR23_U_RNI_NID132",
        .addr = A_POR_MPU_M3_PRLAR23_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR24_U_RNI_NID132",
        .addr = A_POR_MPU_M3_PRBAR24_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR24_U_RNI_NID132",
        .addr = A_POR_MPU_M3_PRLAR24_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR25_U_RNI_NID132",
        .addr = A_POR_MPU_M3_PRBAR25_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR25_U_RNI_NID132",
        .addr = A_POR_MPU_M3_PRLAR25_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR26_U_RNI_NID132",
        .addr = A_POR_MPU_M3_PRBAR26_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR26_U_RNI_NID132",
        .addr = A_POR_MPU_M3_PRLAR26_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR27_U_RNI_NID132",
        .addr = A_POR_MPU_M3_PRBAR27_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR27_U_RNI_NID132",
        .addr = A_POR_MPU_M3_PRLAR27_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR28_U_RNI_NID132",
        .addr = A_POR_MPU_M3_PRBAR28_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR28_U_RNI_NID132",
        .addr = A_POR_MPU_M3_PRLAR28_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR29_U_RNI_NID132",
        .addr = A_POR_MPU_M3_PRBAR29_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR29_U_RNI_NID132",
        .addr = A_POR_MPU_M3_PRLAR29_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR30_U_RNI_NID132",
        .addr = A_POR_MPU_M3_PRBAR30_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR30_U_RNI_NID132",
        .addr = A_POR_MPU_M3_PRLAR30_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR31_U_RNI_NID132",
        .addr = A_POR_MPU_M3_PRBAR31_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR31_U_RNI_NID132",
        .addr = A_POR_MPU_M3_PRLAR31_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_CTL_U_RNI_NID132",
        .addr = A_POR_MPU_M4_CTL_U_RNI_NID132,
        .reset = 0x2,
        .rsvd = 0xfffffffffffffff8L,
        .ro = 0xfffffffffffffff8L,
    },{ .name = "POR_MPU_M4_PRBAR0_U_RNI_NID132",
        .addr = A_POR_MPU_M4_PRBAR0_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR0_U_RNI_NID132",
        .addr = A_POR_MPU_M4_PRLAR0_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR1_U_RNI_NID132",
        .addr = A_POR_MPU_M4_PRBAR1_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR1_U_RNI_NID132",
        .addr = A_POR_MPU_M4_PRLAR1_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR2_U_RNI_NID132",
        .addr = A_POR_MPU_M4_PRBAR2_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR2_U_RNI_NID132",
        .addr = A_POR_MPU_M4_PRLAR2_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR3_U_RNI_NID132",
        .addr = A_POR_MPU_M4_PRBAR3_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR3_U_RNI_NID132",
        .addr = A_POR_MPU_M4_PRLAR3_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR4_U_RNI_NID132",
        .addr = A_POR_MPU_M4_PRBAR4_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR4_U_RNI_NID132",
        .addr = A_POR_MPU_M4_PRLAR4_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR5_U_RNI_NID132",
        .addr = A_POR_MPU_M4_PRBAR5_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR5_U_RNI_NID132",
        .addr = A_POR_MPU_M4_PRLAR5_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR6_U_RNI_NID132",
        .addr = A_POR_MPU_M4_PRBAR6_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR6_U_RNI_NID132",
        .addr = A_POR_MPU_M4_PRLAR6_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR7_U_RNI_NID132",
        .addr = A_POR_MPU_M4_PRBAR7_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR7_U_RNI_NID132",
        .addr = A_POR_MPU_M4_PRLAR7_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR8_U_RNI_NID132",
        .addr = A_POR_MPU_M4_PRBAR8_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR8_U_RNI_NID132",
        .addr = A_POR_MPU_M4_PRLAR8_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR9_U_RNI_NID132",
        .addr = A_POR_MPU_M4_PRBAR9_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR9_U_RNI_NID132",
        .addr = A_POR_MPU_M4_PRLAR9_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR10_U_RNI_NID132",
        .addr = A_POR_MPU_M4_PRBAR10_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR10_U_RNI_NID132",
        .addr = A_POR_MPU_M4_PRLAR10_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR11_U_RNI_NID132",
        .addr = A_POR_MPU_M4_PRBAR11_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR11_U_RNI_NID132",
        .addr = A_POR_MPU_M4_PRLAR11_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR12_U_RNI_NID132",
        .addr = A_POR_MPU_M4_PRBAR12_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR12_U_RNI_NID132",
        .addr = A_POR_MPU_M4_PRLAR12_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR13_U_RNI_NID132",
        .addr = A_POR_MPU_M4_PRBAR13_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR13_U_RNI_NID132",
        .addr = A_POR_MPU_M4_PRLAR13_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR14_U_RNI_NID132",
        .addr = A_POR_MPU_M4_PRBAR14_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR14_U_RNI_NID132",
        .addr = A_POR_MPU_M4_PRLAR14_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR15_U_RNI_NID132",
        .addr = A_POR_MPU_M4_PRBAR15_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR15_U_RNI_NID132",
        .addr = A_POR_MPU_M4_PRLAR15_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR16_U_RNI_NID132",
        .addr = A_POR_MPU_M4_PRBAR16_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR16_U_RNI_NID132",
        .addr = A_POR_MPU_M4_PRLAR16_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR17_U_RNI_NID132",
        .addr = A_POR_MPU_M4_PRBAR17_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR17_U_RNI_NID132",
        .addr = A_POR_MPU_M4_PRLAR17_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR18_U_RNI_NID132",
        .addr = A_POR_MPU_M4_PRBAR18_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR18_U_RNI_NID132",
        .addr = A_POR_MPU_M4_PRLAR18_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR19_U_RNI_NID132",
        .addr = A_POR_MPU_M4_PRBAR19_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR19_U_RNI_NID132",
        .addr = A_POR_MPU_M4_PRLAR19_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR20_U_RNI_NID132",
        .addr = A_POR_MPU_M4_PRBAR20_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR20_U_RNI_NID132",
        .addr = A_POR_MPU_M4_PRLAR20_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR21_U_RNI_NID132",
        .addr = A_POR_MPU_M4_PRBAR21_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR21_U_RNI_NID132",
        .addr = A_POR_MPU_M4_PRLAR21_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR22_U_RNI_NID132",
        .addr = A_POR_MPU_M4_PRBAR22_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR22_U_RNI_NID132",
        .addr = A_POR_MPU_M4_PRLAR22_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR23_U_RNI_NID132",
        .addr = A_POR_MPU_M4_PRBAR23_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR23_U_RNI_NID132",
        .addr = A_POR_MPU_M4_PRLAR23_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR24_U_RNI_NID132",
        .addr = A_POR_MPU_M4_PRBAR24_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR24_U_RNI_NID132",
        .addr = A_POR_MPU_M4_PRLAR24_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR25_U_RNI_NID132",
        .addr = A_POR_MPU_M4_PRBAR25_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR25_U_RNI_NID132",
        .addr = A_POR_MPU_M4_PRLAR25_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR26_U_RNI_NID132",
        .addr = A_POR_MPU_M4_PRBAR26_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR26_U_RNI_NID132",
        .addr = A_POR_MPU_M4_PRLAR26_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR27_U_RNI_NID132",
        .addr = A_POR_MPU_M4_PRBAR27_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR27_U_RNI_NID132",
        .addr = A_POR_MPU_M4_PRLAR27_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR28_U_RNI_NID132",
        .addr = A_POR_MPU_M4_PRBAR28_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR28_U_RNI_NID132",
        .addr = A_POR_MPU_M4_PRLAR28_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR29_U_RNI_NID132",
        .addr = A_POR_MPU_M4_PRBAR29_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR29_U_RNI_NID132",
        .addr = A_POR_MPU_M4_PRLAR29_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR30_U_RNI_NID132",
        .addr = A_POR_MPU_M4_PRBAR30_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR30_U_RNI_NID132",
        .addr = A_POR_MPU_M4_PRLAR30_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR31_U_RNI_NID132",
        .addr = A_POR_MPU_M4_PRBAR31_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR31_U_RNI_NID132",
        .addr = A_POR_MPU_M4_PRLAR31_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_CTL_U_RNI_NID132",
        .addr = A_POR_MPU_M5_CTL_U_RNI_NID132,
        .reset = 0x2,
        .rsvd = 0xfffffffffffffff8L,
        .ro = 0xfffffffffffffff8L,
    },{ .name = "POR_MPU_M5_PRBAR0_U_RNI_NID132",
        .addr = A_POR_MPU_M5_PRBAR0_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR0_U_RNI_NID132",
        .addr = A_POR_MPU_M5_PRLAR0_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR1_U_RNI_NID132",
        .addr = A_POR_MPU_M5_PRBAR1_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR1_U_RNI_NID132",
        .addr = A_POR_MPU_M5_PRLAR1_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR2_U_RNI_NID132",
        .addr = A_POR_MPU_M5_PRBAR2_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR2_U_RNI_NID132",
        .addr = A_POR_MPU_M5_PRLAR2_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR3_U_RNI_NID132",
        .addr = A_POR_MPU_M5_PRBAR3_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR3_U_RNI_NID132",
        .addr = A_POR_MPU_M5_PRLAR3_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR4_U_RNI_NID132",
        .addr = A_POR_MPU_M5_PRBAR4_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR4_U_RNI_NID132",
        .addr = A_POR_MPU_M5_PRLAR4_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR5_U_RNI_NID132",
        .addr = A_POR_MPU_M5_PRBAR5_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR5_U_RNI_NID132",
        .addr = A_POR_MPU_M5_PRLAR5_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR6_U_RNI_NID132",
        .addr = A_POR_MPU_M5_PRBAR6_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR6_U_RNI_NID132",
        .addr = A_POR_MPU_M5_PRLAR6_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR7_U_RNI_NID132",
        .addr = A_POR_MPU_M5_PRBAR7_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR7_U_RNI_NID132",
        .addr = A_POR_MPU_M5_PRLAR7_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR8_U_RNI_NID132",
        .addr = A_POR_MPU_M5_PRBAR8_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR8_U_RNI_NID132",
        .addr = A_POR_MPU_M5_PRLAR8_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR9_U_RNI_NID132",
        .addr = A_POR_MPU_M5_PRBAR9_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR9_U_RNI_NID132",
        .addr = A_POR_MPU_M5_PRLAR9_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR10_U_RNI_NID132",
        .addr = A_POR_MPU_M5_PRBAR10_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR10_U_RNI_NID132",
        .addr = A_POR_MPU_M5_PRLAR10_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR11_U_RNI_NID132",
        .addr = A_POR_MPU_M5_PRBAR11_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR11_U_RNI_NID132",
        .addr = A_POR_MPU_M5_PRLAR11_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR12_U_RNI_NID132",
        .addr = A_POR_MPU_M5_PRBAR12_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR12_U_RNI_NID132",
        .addr = A_POR_MPU_M5_PRLAR12_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR13_U_RNI_NID132",
        .addr = A_POR_MPU_M5_PRBAR13_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR13_U_RNI_NID132",
        .addr = A_POR_MPU_M5_PRLAR13_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR14_U_RNI_NID132",
        .addr = A_POR_MPU_M5_PRBAR14_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR14_U_RNI_NID132",
        .addr = A_POR_MPU_M5_PRLAR14_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR15_U_RNI_NID132",
        .addr = A_POR_MPU_M5_PRBAR15_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR15_U_RNI_NID132",
        .addr = A_POR_MPU_M5_PRLAR15_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR16_U_RNI_NID132",
        .addr = A_POR_MPU_M5_PRBAR16_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR16_U_RNI_NID132",
        .addr = A_POR_MPU_M5_PRLAR16_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR17_U_RNI_NID132",
        .addr = A_POR_MPU_M5_PRBAR17_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR17_U_RNI_NID132",
        .addr = A_POR_MPU_M5_PRLAR17_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR18_U_RNI_NID132",
        .addr = A_POR_MPU_M5_PRBAR18_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR18_U_RNI_NID132",
        .addr = A_POR_MPU_M5_PRLAR18_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR19_U_RNI_NID132",
        .addr = A_POR_MPU_M5_PRBAR19_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR19_U_RNI_NID132",
        .addr = A_POR_MPU_M5_PRLAR19_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR20_U_RNI_NID132",
        .addr = A_POR_MPU_M5_PRBAR20_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR20_U_RNI_NID132",
        .addr = A_POR_MPU_M5_PRLAR20_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR21_U_RNI_NID132",
        .addr = A_POR_MPU_M5_PRBAR21_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR21_U_RNI_NID132",
        .addr = A_POR_MPU_M5_PRLAR21_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR22_U_RNI_NID132",
        .addr = A_POR_MPU_M5_PRBAR22_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR22_U_RNI_NID132",
        .addr = A_POR_MPU_M5_PRLAR22_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR23_U_RNI_NID132",
        .addr = A_POR_MPU_M5_PRBAR23_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR23_U_RNI_NID132",
        .addr = A_POR_MPU_M5_PRLAR23_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR24_U_RNI_NID132",
        .addr = A_POR_MPU_M5_PRBAR24_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR24_U_RNI_NID132",
        .addr = A_POR_MPU_M5_PRLAR24_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR25_U_RNI_NID132",
        .addr = A_POR_MPU_M5_PRBAR25_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR25_U_RNI_NID132",
        .addr = A_POR_MPU_M5_PRLAR25_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR26_U_RNI_NID132",
        .addr = A_POR_MPU_M5_PRBAR26_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR26_U_RNI_NID132",
        .addr = A_POR_MPU_M5_PRLAR26_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR27_U_RNI_NID132",
        .addr = A_POR_MPU_M5_PRBAR27_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR27_U_RNI_NID132",
        .addr = A_POR_MPU_M5_PRLAR27_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR28_U_RNI_NID132",
        .addr = A_POR_MPU_M5_PRBAR28_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR28_U_RNI_NID132",
        .addr = A_POR_MPU_M5_PRLAR28_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR29_U_RNI_NID132",
        .addr = A_POR_MPU_M5_PRBAR29_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR29_U_RNI_NID132",
        .addr = A_POR_MPU_M5_PRLAR29_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR30_U_RNI_NID132",
        .addr = A_POR_MPU_M5_PRBAR30_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR30_U_RNI_NID132",
        .addr = A_POR_MPU_M5_PRLAR30_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR31_U_RNI_NID132",
        .addr = A_POR_MPU_M5_PRBAR31_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR31_U_RNI_NID132",
        .addr = A_POR_MPU_M5_PRLAR31_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_CTL_U_RNI_NID132",
        .addr = A_POR_MPU_M6_CTL_U_RNI_NID132,
        .reset = 0x2,
        .rsvd = 0xfffffffffffffff8L,
        .ro = 0xfffffffffffffff8L,
    },{ .name = "POR_MPU_M6_PRBAR0_U_RNI_NID132",
        .addr = A_POR_MPU_M6_PRBAR0_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR0_U_RNI_NID132",
        .addr = A_POR_MPU_M6_PRLAR0_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR1_U_RNI_NID132",
        .addr = A_POR_MPU_M6_PRBAR1_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR1_U_RNI_NID132",
        .addr = A_POR_MPU_M6_PRLAR1_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR2_U_RNI_NID132",
        .addr = A_POR_MPU_M6_PRBAR2_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR2_U_RNI_NID132",
        .addr = A_POR_MPU_M6_PRLAR2_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR3_U_RNI_NID132",
        .addr = A_POR_MPU_M6_PRBAR3_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR3_U_RNI_NID132",
        .addr = A_POR_MPU_M6_PRLAR3_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR4_U_RNI_NID132",
        .addr = A_POR_MPU_M6_PRBAR4_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR4_U_RNI_NID132",
        .addr = A_POR_MPU_M6_PRLAR4_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR5_U_RNI_NID132",
        .addr = A_POR_MPU_M6_PRBAR5_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR5_U_RNI_NID132",
        .addr = A_POR_MPU_M6_PRLAR5_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR6_U_RNI_NID132",
        .addr = A_POR_MPU_M6_PRBAR6_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR6_U_RNI_NID132",
        .addr = A_POR_MPU_M6_PRLAR6_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR7_U_RNI_NID132",
        .addr = A_POR_MPU_M6_PRBAR7_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR7_U_RNI_NID132",
        .addr = A_POR_MPU_M6_PRLAR7_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR8_U_RNI_NID132",
        .addr = A_POR_MPU_M6_PRBAR8_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR8_U_RNI_NID132",
        .addr = A_POR_MPU_M6_PRLAR8_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR9_U_RNI_NID132",
        .addr = A_POR_MPU_M6_PRBAR9_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR9_U_RNI_NID132",
        .addr = A_POR_MPU_M6_PRLAR9_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR10_U_RNI_NID132",
        .addr = A_POR_MPU_M6_PRBAR10_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR10_U_RNI_NID132",
        .addr = A_POR_MPU_M6_PRLAR10_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR11_U_RNI_NID132",
        .addr = A_POR_MPU_M6_PRBAR11_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR11_U_RNI_NID132",
        .addr = A_POR_MPU_M6_PRLAR11_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR12_U_RNI_NID132",
        .addr = A_POR_MPU_M6_PRBAR12_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR12_U_RNI_NID132",
        .addr = A_POR_MPU_M6_PRLAR12_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR13_U_RNI_NID132",
        .addr = A_POR_MPU_M6_PRBAR13_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR13_U_RNI_NID132",
        .addr = A_POR_MPU_M6_PRLAR13_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR14_U_RNI_NID132",
        .addr = A_POR_MPU_M6_PRBAR14_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR14_U_RNI_NID132",
        .addr = A_POR_MPU_M6_PRLAR14_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR15_U_RNI_NID132",
        .addr = A_POR_MPU_M6_PRBAR15_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR15_U_RNI_NID132",
        .addr = A_POR_MPU_M6_PRLAR15_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR16_U_RNI_NID132",
        .addr = A_POR_MPU_M6_PRBAR16_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR16_U_RNI_NID132",
        .addr = A_POR_MPU_M6_PRLAR16_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR17_U_RNI_NID132",
        .addr = A_POR_MPU_M6_PRBAR17_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR17_U_RNI_NID132",
        .addr = A_POR_MPU_M6_PRLAR17_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR18_U_RNI_NID132",
        .addr = A_POR_MPU_M6_PRBAR18_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR18_U_RNI_NID132",
        .addr = A_POR_MPU_M6_PRLAR18_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR19_U_RNI_NID132",
        .addr = A_POR_MPU_M6_PRBAR19_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR19_U_RNI_NID132",
        .addr = A_POR_MPU_M6_PRLAR19_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR20_U_RNI_NID132",
        .addr = A_POR_MPU_M6_PRBAR20_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR20_U_RNI_NID132",
        .addr = A_POR_MPU_M6_PRLAR20_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR21_U_RNI_NID132",
        .addr = A_POR_MPU_M6_PRBAR21_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR21_U_RNI_NID132",
        .addr = A_POR_MPU_M6_PRLAR21_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR22_U_RNI_NID132",
        .addr = A_POR_MPU_M6_PRBAR22_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR22_U_RNI_NID132",
        .addr = A_POR_MPU_M6_PRLAR22_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR23_U_RNI_NID132",
        .addr = A_POR_MPU_M6_PRBAR23_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR23_U_RNI_NID132",
        .addr = A_POR_MPU_M6_PRLAR23_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR24_U_RNI_NID132",
        .addr = A_POR_MPU_M6_PRBAR24_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR24_U_RNI_NID132",
        .addr = A_POR_MPU_M6_PRLAR24_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR25_U_RNI_NID132",
        .addr = A_POR_MPU_M6_PRBAR25_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR25_U_RNI_NID132",
        .addr = A_POR_MPU_M6_PRLAR25_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR26_U_RNI_NID132",
        .addr = A_POR_MPU_M6_PRBAR26_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR26_U_RNI_NID132",
        .addr = A_POR_MPU_M6_PRLAR26_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR27_U_RNI_NID132",
        .addr = A_POR_MPU_M6_PRBAR27_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR27_U_RNI_NID132",
        .addr = A_POR_MPU_M6_PRLAR27_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR28_U_RNI_NID132",
        .addr = A_POR_MPU_M6_PRBAR28_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR28_U_RNI_NID132",
        .addr = A_POR_MPU_M6_PRLAR28_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR29_U_RNI_NID132",
        .addr = A_POR_MPU_M6_PRBAR29_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR29_U_RNI_NID132",
        .addr = A_POR_MPU_M6_PRLAR29_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR30_U_RNI_NID132",
        .addr = A_POR_MPU_M6_PRBAR30_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR30_U_RNI_NID132",
        .addr = A_POR_MPU_M6_PRLAR30_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR31_U_RNI_NID132",
        .addr = A_POR_MPU_M6_PRBAR31_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR31_U_RNI_NID132",
        .addr = A_POR_MPU_M6_PRLAR31_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_CTL_U_RNI_NID132",
        .addr = A_POR_MPU_M7_CTL_U_RNI_NID132,
        .reset = 0x2,
        .rsvd = 0xfffffffffffffff8L,
        .ro = 0xfffffffffffffff8L,
    },{ .name = "POR_MPU_M7_PRBAR0_U_RNI_NID132",
        .addr = A_POR_MPU_M7_PRBAR0_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR0_U_RNI_NID132",
        .addr = A_POR_MPU_M7_PRLAR0_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR1_U_RNI_NID132",
        .addr = A_POR_MPU_M7_PRBAR1_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR1_U_RNI_NID132",
        .addr = A_POR_MPU_M7_PRLAR1_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR2_U_RNI_NID132",
        .addr = A_POR_MPU_M7_PRBAR2_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR2_U_RNI_NID132",
        .addr = A_POR_MPU_M7_PRLAR2_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR3_U_RNI_NID132",
        .addr = A_POR_MPU_M7_PRBAR3_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR3_U_RNI_NID132",
        .addr = A_POR_MPU_M7_PRLAR3_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR4_U_RNI_NID132",
        .addr = A_POR_MPU_M7_PRBAR4_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR4_U_RNI_NID132",
        .addr = A_POR_MPU_M7_PRLAR4_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR5_U_RNI_NID132",
        .addr = A_POR_MPU_M7_PRBAR5_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR5_U_RNI_NID132",
        .addr = A_POR_MPU_M7_PRLAR5_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR6_U_RNI_NID132",
        .addr = A_POR_MPU_M7_PRBAR6_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR6_U_RNI_NID132",
        .addr = A_POR_MPU_M7_PRLAR6_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR7_U_RNI_NID132",
        .addr = A_POR_MPU_M7_PRBAR7_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR7_U_RNI_NID132",
        .addr = A_POR_MPU_M7_PRLAR7_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR8_U_RNI_NID132",
        .addr = A_POR_MPU_M7_PRBAR8_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR8_U_RNI_NID132",
        .addr = A_POR_MPU_M7_PRLAR8_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR9_U_RNI_NID132",
        .addr = A_POR_MPU_M7_PRBAR9_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR9_U_RNI_NID132",
        .addr = A_POR_MPU_M7_PRLAR9_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR10_U_RNI_NID132",
        .addr = A_POR_MPU_M7_PRBAR10_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR10_U_RNI_NID132",
        .addr = A_POR_MPU_M7_PRLAR10_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR11_U_RNI_NID132",
        .addr = A_POR_MPU_M7_PRBAR11_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR11_U_RNI_NID132",
        .addr = A_POR_MPU_M7_PRLAR11_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR12_U_RNI_NID132",
        .addr = A_POR_MPU_M7_PRBAR12_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR12_U_RNI_NID132",
        .addr = A_POR_MPU_M7_PRLAR12_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR13_U_RNI_NID132",
        .addr = A_POR_MPU_M7_PRBAR13_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR13_U_RNI_NID132",
        .addr = A_POR_MPU_M7_PRLAR13_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR14_U_RNI_NID132",
        .addr = A_POR_MPU_M7_PRBAR14_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR14_U_RNI_NID132",
        .addr = A_POR_MPU_M7_PRLAR14_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR15_U_RNI_NID132",
        .addr = A_POR_MPU_M7_PRBAR15_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR15_U_RNI_NID132",
        .addr = A_POR_MPU_M7_PRLAR15_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR16_U_RNI_NID132",
        .addr = A_POR_MPU_M7_PRBAR16_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR16_U_RNI_NID132",
        .addr = A_POR_MPU_M7_PRLAR16_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR17_U_RNI_NID132",
        .addr = A_POR_MPU_M7_PRBAR17_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR17_U_RNI_NID132",
        .addr = A_POR_MPU_M7_PRLAR17_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR18_U_RNI_NID132",
        .addr = A_POR_MPU_M7_PRBAR18_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR18_U_RNI_NID132",
        .addr = A_POR_MPU_M7_PRLAR18_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR19_U_RNI_NID132",
        .addr = A_POR_MPU_M7_PRBAR19_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR19_U_RNI_NID132",
        .addr = A_POR_MPU_M7_PRLAR19_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR20_U_RNI_NID132",
        .addr = A_POR_MPU_M7_PRBAR20_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR20_U_RNI_NID132",
        .addr = A_POR_MPU_M7_PRLAR20_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR21_U_RNI_NID132",
        .addr = A_POR_MPU_M7_PRBAR21_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR21_U_RNI_NID132",
        .addr = A_POR_MPU_M7_PRLAR21_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR22_U_RNI_NID132",
        .addr = A_POR_MPU_M7_PRBAR22_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR22_U_RNI_NID132",
        .addr = A_POR_MPU_M7_PRLAR22_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR23_U_RNI_NID132",
        .addr = A_POR_MPU_M7_PRBAR23_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR23_U_RNI_NID132",
        .addr = A_POR_MPU_M7_PRLAR23_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR24_U_RNI_NID132",
        .addr = A_POR_MPU_M7_PRBAR24_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR24_U_RNI_NID132",
        .addr = A_POR_MPU_M7_PRLAR24_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR25_U_RNI_NID132",
        .addr = A_POR_MPU_M7_PRBAR25_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR25_U_RNI_NID132",
        .addr = A_POR_MPU_M7_PRLAR25_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR26_U_RNI_NID132",
        .addr = A_POR_MPU_M7_PRBAR26_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR26_U_RNI_NID132",
        .addr = A_POR_MPU_M7_PRLAR26_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR27_U_RNI_NID132",
        .addr = A_POR_MPU_M7_PRBAR27_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR27_U_RNI_NID132",
        .addr = A_POR_MPU_M7_PRLAR27_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR28_U_RNI_NID132",
        .addr = A_POR_MPU_M7_PRBAR28_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR28_U_RNI_NID132",
        .addr = A_POR_MPU_M7_PRLAR28_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR29_U_RNI_NID132",
        .addr = A_POR_MPU_M7_PRBAR29_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR29_U_RNI_NID132",
        .addr = A_POR_MPU_M7_PRLAR29_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR30_U_RNI_NID132",
        .addr = A_POR_MPU_M7_PRBAR30_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR30_U_RNI_NID132",
        .addr = A_POR_MPU_M7_PRLAR30_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR31_U_RNI_NID132",
        .addr = A_POR_MPU_M7_PRBAR31_U_RNI_NID132,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR31_U_RNI_NID132",
        .addr = A_POR_MPU_M7_PRLAR31_U_RNI_NID132,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_NODE_INFO_U_SMXP_2_0",
        .addr = A_POR_MPU_NODE_INFO_U_SMXP_2_0,
        .reset = 0x202,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MPU_CHILD_INFO_U_SMXP_2_0",
        .addr = A_POR_MPU_CHILD_INFO_U_SMXP_2_0,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MPU_UNIT_INFO_U_SMXP_2_0",
        .addr = A_POR_MPU_UNIT_INFO_U_SMXP_2_0,
        .reset = 0x20,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MPU_M0_CTL_U_SMXP_2_0",
        .addr = A_POR_MPU_M0_CTL_U_SMXP_2_0,
        .reset = 0x2,
        .rsvd = 0xfffffffffffffff8L,
        .ro = 0xfffffffffffffff8L,
    },{ .name = "POR_MPU_M0_PRBAR0_U_SMXP_2_0",
        .addr = A_POR_MPU_M0_PRBAR0_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR0_U_SMXP_2_0",
        .addr = A_POR_MPU_M0_PRLAR0_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR1_U_SMXP_2_0",
        .addr = A_POR_MPU_M0_PRBAR1_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR1_U_SMXP_2_0",
        .addr = A_POR_MPU_M0_PRLAR1_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR2_U_SMXP_2_0",
        .addr = A_POR_MPU_M0_PRBAR2_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR2_U_SMXP_2_0",
        .addr = A_POR_MPU_M0_PRLAR2_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR3_U_SMXP_2_0",
        .addr = A_POR_MPU_M0_PRBAR3_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR3_U_SMXP_2_0",
        .addr = A_POR_MPU_M0_PRLAR3_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR4_U_SMXP_2_0",
        .addr = A_POR_MPU_M0_PRBAR4_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR4_U_SMXP_2_0",
        .addr = A_POR_MPU_M0_PRLAR4_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR5_U_SMXP_2_0",
        .addr = A_POR_MPU_M0_PRBAR5_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR5_U_SMXP_2_0",
        .addr = A_POR_MPU_M0_PRLAR5_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR6_U_SMXP_2_0",
        .addr = A_POR_MPU_M0_PRBAR6_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR6_U_SMXP_2_0",
        .addr = A_POR_MPU_M0_PRLAR6_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR7_U_SMXP_2_0",
        .addr = A_POR_MPU_M0_PRBAR7_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR7_U_SMXP_2_0",
        .addr = A_POR_MPU_M0_PRLAR7_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR8_U_SMXP_2_0",
        .addr = A_POR_MPU_M0_PRBAR8_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR8_U_SMXP_2_0",
        .addr = A_POR_MPU_M0_PRLAR8_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR9_U_SMXP_2_0",
        .addr = A_POR_MPU_M0_PRBAR9_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR9_U_SMXP_2_0",
        .addr = A_POR_MPU_M0_PRLAR9_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR10_U_SMXP_2_0",
        .addr = A_POR_MPU_M0_PRBAR10_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR10_U_SMXP_2_0",
        .addr = A_POR_MPU_M0_PRLAR10_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR11_U_SMXP_2_0",
        .addr = A_POR_MPU_M0_PRBAR11_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR11_U_SMXP_2_0",
        .addr = A_POR_MPU_M0_PRLAR11_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR12_U_SMXP_2_0",
        .addr = A_POR_MPU_M0_PRBAR12_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR12_U_SMXP_2_0",
        .addr = A_POR_MPU_M0_PRLAR12_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR13_U_SMXP_2_0",
        .addr = A_POR_MPU_M0_PRBAR13_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR13_U_SMXP_2_0",
        .addr = A_POR_MPU_M0_PRLAR13_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR14_U_SMXP_2_0",
        .addr = A_POR_MPU_M0_PRBAR14_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR14_U_SMXP_2_0",
        .addr = A_POR_MPU_M0_PRLAR14_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR15_U_SMXP_2_0",
        .addr = A_POR_MPU_M0_PRBAR15_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR15_U_SMXP_2_0",
        .addr = A_POR_MPU_M0_PRLAR15_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR16_U_SMXP_2_0",
        .addr = A_POR_MPU_M0_PRBAR16_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR16_U_SMXP_2_0",
        .addr = A_POR_MPU_M0_PRLAR16_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR17_U_SMXP_2_0",
        .addr = A_POR_MPU_M0_PRBAR17_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR17_U_SMXP_2_0",
        .addr = A_POR_MPU_M0_PRLAR17_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR18_U_SMXP_2_0",
        .addr = A_POR_MPU_M0_PRBAR18_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR18_U_SMXP_2_0",
        .addr = A_POR_MPU_M0_PRLAR18_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR19_U_SMXP_2_0",
        .addr = A_POR_MPU_M0_PRBAR19_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR19_U_SMXP_2_0",
        .addr = A_POR_MPU_M0_PRLAR19_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR20_U_SMXP_2_0",
        .addr = A_POR_MPU_M0_PRBAR20_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR20_U_SMXP_2_0",
        .addr = A_POR_MPU_M0_PRLAR20_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR21_U_SMXP_2_0",
        .addr = A_POR_MPU_M0_PRBAR21_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR21_U_SMXP_2_0",
        .addr = A_POR_MPU_M0_PRLAR21_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR22_U_SMXP_2_0",
        .addr = A_POR_MPU_M0_PRBAR22_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR22_U_SMXP_2_0",
        .addr = A_POR_MPU_M0_PRLAR22_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR23_U_SMXP_2_0",
        .addr = A_POR_MPU_M0_PRBAR23_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR23_U_SMXP_2_0",
        .addr = A_POR_MPU_M0_PRLAR23_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR24_U_SMXP_2_0",
        .addr = A_POR_MPU_M0_PRBAR24_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR24_U_SMXP_2_0",
        .addr = A_POR_MPU_M0_PRLAR24_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR25_U_SMXP_2_0",
        .addr = A_POR_MPU_M0_PRBAR25_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR25_U_SMXP_2_0",
        .addr = A_POR_MPU_M0_PRLAR25_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR26_U_SMXP_2_0",
        .addr = A_POR_MPU_M0_PRBAR26_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR26_U_SMXP_2_0",
        .addr = A_POR_MPU_M0_PRLAR26_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR27_U_SMXP_2_0",
        .addr = A_POR_MPU_M0_PRBAR27_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR27_U_SMXP_2_0",
        .addr = A_POR_MPU_M0_PRLAR27_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR28_U_SMXP_2_0",
        .addr = A_POR_MPU_M0_PRBAR28_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR28_U_SMXP_2_0",
        .addr = A_POR_MPU_M0_PRLAR28_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR29_U_SMXP_2_0",
        .addr = A_POR_MPU_M0_PRBAR29_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR29_U_SMXP_2_0",
        .addr = A_POR_MPU_M0_PRLAR29_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR30_U_SMXP_2_0",
        .addr = A_POR_MPU_M0_PRBAR30_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR30_U_SMXP_2_0",
        .addr = A_POR_MPU_M0_PRLAR30_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR31_U_SMXP_2_0",
        .addr = A_POR_MPU_M0_PRBAR31_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR31_U_SMXP_2_0",
        .addr = A_POR_MPU_M0_PRLAR31_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_CTL_U_SMXP_2_0",
        .addr = A_POR_MPU_M1_CTL_U_SMXP_2_0,
        .reset = 0x2,
        .rsvd = 0xfffffffffffffff8L,
        .ro = 0xfffffffffffffff8L,
    },{ .name = "POR_MPU_M1_PRBAR0_U_SMXP_2_0",
        .addr = A_POR_MPU_M1_PRBAR0_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR0_U_SMXP_2_0",
        .addr = A_POR_MPU_M1_PRLAR0_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR1_U_SMXP_2_0",
        .addr = A_POR_MPU_M1_PRBAR1_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR1_U_SMXP_2_0",
        .addr = A_POR_MPU_M1_PRLAR1_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR2_U_SMXP_2_0",
        .addr = A_POR_MPU_M1_PRBAR2_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR2_U_SMXP_2_0",
        .addr = A_POR_MPU_M1_PRLAR2_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR3_U_SMXP_2_0",
        .addr = A_POR_MPU_M1_PRBAR3_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR3_U_SMXP_2_0",
        .addr = A_POR_MPU_M1_PRLAR3_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR4_U_SMXP_2_0",
        .addr = A_POR_MPU_M1_PRBAR4_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR4_U_SMXP_2_0",
        .addr = A_POR_MPU_M1_PRLAR4_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR5_U_SMXP_2_0",
        .addr = A_POR_MPU_M1_PRBAR5_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR5_U_SMXP_2_0",
        .addr = A_POR_MPU_M1_PRLAR5_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR6_U_SMXP_2_0",
        .addr = A_POR_MPU_M1_PRBAR6_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR6_U_SMXP_2_0",
        .addr = A_POR_MPU_M1_PRLAR6_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR7_U_SMXP_2_0",
        .addr = A_POR_MPU_M1_PRBAR7_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR7_U_SMXP_2_0",
        .addr = A_POR_MPU_M1_PRLAR7_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR8_U_SMXP_2_0",
        .addr = A_POR_MPU_M1_PRBAR8_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR8_U_SMXP_2_0",
        .addr = A_POR_MPU_M1_PRLAR8_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR9_U_SMXP_2_0",
        .addr = A_POR_MPU_M1_PRBAR9_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR9_U_SMXP_2_0",
        .addr = A_POR_MPU_M1_PRLAR9_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR10_U_SMXP_2_0",
        .addr = A_POR_MPU_M1_PRBAR10_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR10_U_SMXP_2_0",
        .addr = A_POR_MPU_M1_PRLAR10_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR11_U_SMXP_2_0",
        .addr = A_POR_MPU_M1_PRBAR11_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR11_U_SMXP_2_0",
        .addr = A_POR_MPU_M1_PRLAR11_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR12_U_SMXP_2_0",
        .addr = A_POR_MPU_M1_PRBAR12_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR12_U_SMXP_2_0",
        .addr = A_POR_MPU_M1_PRLAR12_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR13_U_SMXP_2_0",
        .addr = A_POR_MPU_M1_PRBAR13_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR13_U_SMXP_2_0",
        .addr = A_POR_MPU_M1_PRLAR13_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR14_U_SMXP_2_0",
        .addr = A_POR_MPU_M1_PRBAR14_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR14_U_SMXP_2_0",
        .addr = A_POR_MPU_M1_PRLAR14_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR15_U_SMXP_2_0",
        .addr = A_POR_MPU_M1_PRBAR15_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR15_U_SMXP_2_0",
        .addr = A_POR_MPU_M1_PRLAR15_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR16_U_SMXP_2_0",
        .addr = A_POR_MPU_M1_PRBAR16_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR16_U_SMXP_2_0",
        .addr = A_POR_MPU_M1_PRLAR16_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR17_U_SMXP_2_0",
        .addr = A_POR_MPU_M1_PRBAR17_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR17_U_SMXP_2_0",
        .addr = A_POR_MPU_M1_PRLAR17_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR18_U_SMXP_2_0",
        .addr = A_POR_MPU_M1_PRBAR18_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR18_U_SMXP_2_0",
        .addr = A_POR_MPU_M1_PRLAR18_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR19_U_SMXP_2_0",
        .addr = A_POR_MPU_M1_PRBAR19_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR19_U_SMXP_2_0",
        .addr = A_POR_MPU_M1_PRLAR19_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR20_U_SMXP_2_0",
        .addr = A_POR_MPU_M1_PRBAR20_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR20_U_SMXP_2_0",
        .addr = A_POR_MPU_M1_PRLAR20_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR21_U_SMXP_2_0",
        .addr = A_POR_MPU_M1_PRBAR21_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR21_U_SMXP_2_0",
        .addr = A_POR_MPU_M1_PRLAR21_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR22_U_SMXP_2_0",
        .addr = A_POR_MPU_M1_PRBAR22_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR22_U_SMXP_2_0",
        .addr = A_POR_MPU_M1_PRLAR22_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR23_U_SMXP_2_0",
        .addr = A_POR_MPU_M1_PRBAR23_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR23_U_SMXP_2_0",
        .addr = A_POR_MPU_M1_PRLAR23_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR24_U_SMXP_2_0",
        .addr = A_POR_MPU_M1_PRBAR24_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR24_U_SMXP_2_0",
        .addr = A_POR_MPU_M1_PRLAR24_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR25_U_SMXP_2_0",
        .addr = A_POR_MPU_M1_PRBAR25_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR25_U_SMXP_2_0",
        .addr = A_POR_MPU_M1_PRLAR25_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR26_U_SMXP_2_0",
        .addr = A_POR_MPU_M1_PRBAR26_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR26_U_SMXP_2_0",
        .addr = A_POR_MPU_M1_PRLAR26_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR27_U_SMXP_2_0",
        .addr = A_POR_MPU_M1_PRBAR27_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR27_U_SMXP_2_0",
        .addr = A_POR_MPU_M1_PRLAR27_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR28_U_SMXP_2_0",
        .addr = A_POR_MPU_M1_PRBAR28_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR28_U_SMXP_2_0",
        .addr = A_POR_MPU_M1_PRLAR28_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR29_U_SMXP_2_0",
        .addr = A_POR_MPU_M1_PRBAR29_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR29_U_SMXP_2_0",
        .addr = A_POR_MPU_M1_PRLAR29_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR30_U_SMXP_2_0",
        .addr = A_POR_MPU_M1_PRBAR30_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR30_U_SMXP_2_0",
        .addr = A_POR_MPU_M1_PRLAR30_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR31_U_SMXP_2_0",
        .addr = A_POR_MPU_M1_PRBAR31_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR31_U_SMXP_2_0",
        .addr = A_POR_MPU_M1_PRLAR31_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_CTL_U_SMXP_2_0",
        .addr = A_POR_MPU_M2_CTL_U_SMXP_2_0,
        .reset = 0x2,
        .rsvd = 0xfffffffffffffff8L,
        .ro = 0xfffffffffffffff8L,
    },{ .name = "POR_MPU_M2_PRBAR0_U_SMXP_2_0",
        .addr = A_POR_MPU_M2_PRBAR0_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR0_U_SMXP_2_0",
        .addr = A_POR_MPU_M2_PRLAR0_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR1_U_SMXP_2_0",
        .addr = A_POR_MPU_M2_PRBAR1_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR1_U_SMXP_2_0",
        .addr = A_POR_MPU_M2_PRLAR1_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR2_U_SMXP_2_0",
        .addr = A_POR_MPU_M2_PRBAR2_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR2_U_SMXP_2_0",
        .addr = A_POR_MPU_M2_PRLAR2_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR3_U_SMXP_2_0",
        .addr = A_POR_MPU_M2_PRBAR3_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR3_U_SMXP_2_0",
        .addr = A_POR_MPU_M2_PRLAR3_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR4_U_SMXP_2_0",
        .addr = A_POR_MPU_M2_PRBAR4_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR4_U_SMXP_2_0",
        .addr = A_POR_MPU_M2_PRLAR4_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR5_U_SMXP_2_0",
        .addr = A_POR_MPU_M2_PRBAR5_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR5_U_SMXP_2_0",
        .addr = A_POR_MPU_M2_PRLAR5_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR6_U_SMXP_2_0",
        .addr = A_POR_MPU_M2_PRBAR6_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR6_U_SMXP_2_0",
        .addr = A_POR_MPU_M2_PRLAR6_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR7_U_SMXP_2_0",
        .addr = A_POR_MPU_M2_PRBAR7_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR7_U_SMXP_2_0",
        .addr = A_POR_MPU_M2_PRLAR7_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR8_U_SMXP_2_0",
        .addr = A_POR_MPU_M2_PRBAR8_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR8_U_SMXP_2_0",
        .addr = A_POR_MPU_M2_PRLAR8_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR9_U_SMXP_2_0",
        .addr = A_POR_MPU_M2_PRBAR9_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR9_U_SMXP_2_0",
        .addr = A_POR_MPU_M2_PRLAR9_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR10_U_SMXP_2_0",
        .addr = A_POR_MPU_M2_PRBAR10_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR10_U_SMXP_2_0",
        .addr = A_POR_MPU_M2_PRLAR10_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR11_U_SMXP_2_0",
        .addr = A_POR_MPU_M2_PRBAR11_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR11_U_SMXP_2_0",
        .addr = A_POR_MPU_M2_PRLAR11_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR12_U_SMXP_2_0",
        .addr = A_POR_MPU_M2_PRBAR12_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR12_U_SMXP_2_0",
        .addr = A_POR_MPU_M2_PRLAR12_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR13_U_SMXP_2_0",
        .addr = A_POR_MPU_M2_PRBAR13_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR13_U_SMXP_2_0",
        .addr = A_POR_MPU_M2_PRLAR13_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR14_U_SMXP_2_0",
        .addr = A_POR_MPU_M2_PRBAR14_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR14_U_SMXP_2_0",
        .addr = A_POR_MPU_M2_PRLAR14_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR15_U_SMXP_2_0",
        .addr = A_POR_MPU_M2_PRBAR15_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR15_U_SMXP_2_0",
        .addr = A_POR_MPU_M2_PRLAR15_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR16_U_SMXP_2_0",
        .addr = A_POR_MPU_M2_PRBAR16_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR16_U_SMXP_2_0",
        .addr = A_POR_MPU_M2_PRLAR16_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR17_U_SMXP_2_0",
        .addr = A_POR_MPU_M2_PRBAR17_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR17_U_SMXP_2_0",
        .addr = A_POR_MPU_M2_PRLAR17_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR18_U_SMXP_2_0",
        .addr = A_POR_MPU_M2_PRBAR18_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR18_U_SMXP_2_0",
        .addr = A_POR_MPU_M2_PRLAR18_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR19_U_SMXP_2_0",
        .addr = A_POR_MPU_M2_PRBAR19_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR19_U_SMXP_2_0",
        .addr = A_POR_MPU_M2_PRLAR19_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR20_U_SMXP_2_0",
        .addr = A_POR_MPU_M2_PRBAR20_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR20_U_SMXP_2_0",
        .addr = A_POR_MPU_M2_PRLAR20_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR21_U_SMXP_2_0",
        .addr = A_POR_MPU_M2_PRBAR21_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR21_U_SMXP_2_0",
        .addr = A_POR_MPU_M2_PRLAR21_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR22_U_SMXP_2_0",
        .addr = A_POR_MPU_M2_PRBAR22_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR22_U_SMXP_2_0",
        .addr = A_POR_MPU_M2_PRLAR22_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR23_U_SMXP_2_0",
        .addr = A_POR_MPU_M2_PRBAR23_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR23_U_SMXP_2_0",
        .addr = A_POR_MPU_M2_PRLAR23_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR24_U_SMXP_2_0",
        .addr = A_POR_MPU_M2_PRBAR24_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR24_U_SMXP_2_0",
        .addr = A_POR_MPU_M2_PRLAR24_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR25_U_SMXP_2_0",
        .addr = A_POR_MPU_M2_PRBAR25_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR25_U_SMXP_2_0",
        .addr = A_POR_MPU_M2_PRLAR25_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR26_U_SMXP_2_0",
        .addr = A_POR_MPU_M2_PRBAR26_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR26_U_SMXP_2_0",
        .addr = A_POR_MPU_M2_PRLAR26_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR27_U_SMXP_2_0",
        .addr = A_POR_MPU_M2_PRBAR27_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR27_U_SMXP_2_0",
        .addr = A_POR_MPU_M2_PRLAR27_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR28_U_SMXP_2_0",
        .addr = A_POR_MPU_M2_PRBAR28_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR28_U_SMXP_2_0",
        .addr = A_POR_MPU_M2_PRLAR28_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR29_U_SMXP_2_0",
        .addr = A_POR_MPU_M2_PRBAR29_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR29_U_SMXP_2_0",
        .addr = A_POR_MPU_M2_PRLAR29_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR30_U_SMXP_2_0",
        .addr = A_POR_MPU_M2_PRBAR30_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR30_U_SMXP_2_0",
        .addr = A_POR_MPU_M2_PRLAR30_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR31_U_SMXP_2_0",
        .addr = A_POR_MPU_M2_PRBAR31_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR31_U_SMXP_2_0",
        .addr = A_POR_MPU_M2_PRLAR31_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_CTL_U_SMXP_2_0",
        .addr = A_POR_MPU_M3_CTL_U_SMXP_2_0,
        .reset = 0x2,
        .rsvd = 0xfffffffffffffff8L,
        .ro = 0xfffffffffffffff8L,
    },{ .name = "POR_MPU_M3_PRBAR0_U_SMXP_2_0",
        .addr = A_POR_MPU_M3_PRBAR0_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR0_U_SMXP_2_0",
        .addr = A_POR_MPU_M3_PRLAR0_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR1_U_SMXP_2_0",
        .addr = A_POR_MPU_M3_PRBAR1_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR1_U_SMXP_2_0",
        .addr = A_POR_MPU_M3_PRLAR1_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR2_U_SMXP_2_0",
        .addr = A_POR_MPU_M3_PRBAR2_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR2_U_SMXP_2_0",
        .addr = A_POR_MPU_M3_PRLAR2_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR3_U_SMXP_2_0",
        .addr = A_POR_MPU_M3_PRBAR3_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR3_U_SMXP_2_0",
        .addr = A_POR_MPU_M3_PRLAR3_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR4_U_SMXP_2_0",
        .addr = A_POR_MPU_M3_PRBAR4_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR4_U_SMXP_2_0",
        .addr = A_POR_MPU_M3_PRLAR4_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR5_U_SMXP_2_0",
        .addr = A_POR_MPU_M3_PRBAR5_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR5_U_SMXP_2_0",
        .addr = A_POR_MPU_M3_PRLAR5_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR6_U_SMXP_2_0",
        .addr = A_POR_MPU_M3_PRBAR6_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR6_U_SMXP_2_0",
        .addr = A_POR_MPU_M3_PRLAR6_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR7_U_SMXP_2_0",
        .addr = A_POR_MPU_M3_PRBAR7_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR7_U_SMXP_2_0",
        .addr = A_POR_MPU_M3_PRLAR7_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR8_U_SMXP_2_0",
        .addr = A_POR_MPU_M3_PRBAR8_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR8_U_SMXP_2_0",
        .addr = A_POR_MPU_M3_PRLAR8_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR9_U_SMXP_2_0",
        .addr = A_POR_MPU_M3_PRBAR9_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR9_U_SMXP_2_0",
        .addr = A_POR_MPU_M3_PRLAR9_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR10_U_SMXP_2_0",
        .addr = A_POR_MPU_M3_PRBAR10_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR10_U_SMXP_2_0",
        .addr = A_POR_MPU_M3_PRLAR10_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR11_U_SMXP_2_0",
        .addr = A_POR_MPU_M3_PRBAR11_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR11_U_SMXP_2_0",
        .addr = A_POR_MPU_M3_PRLAR11_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR12_U_SMXP_2_0",
        .addr = A_POR_MPU_M3_PRBAR12_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR12_U_SMXP_2_0",
        .addr = A_POR_MPU_M3_PRLAR12_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR13_U_SMXP_2_0",
        .addr = A_POR_MPU_M3_PRBAR13_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR13_U_SMXP_2_0",
        .addr = A_POR_MPU_M3_PRLAR13_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR14_U_SMXP_2_0",
        .addr = A_POR_MPU_M3_PRBAR14_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR14_U_SMXP_2_0",
        .addr = A_POR_MPU_M3_PRLAR14_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR15_U_SMXP_2_0",
        .addr = A_POR_MPU_M3_PRBAR15_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR15_U_SMXP_2_0",
        .addr = A_POR_MPU_M3_PRLAR15_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR16_U_SMXP_2_0",
        .addr = A_POR_MPU_M3_PRBAR16_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR16_U_SMXP_2_0",
        .addr = A_POR_MPU_M3_PRLAR16_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR17_U_SMXP_2_0",
        .addr = A_POR_MPU_M3_PRBAR17_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR17_U_SMXP_2_0",
        .addr = A_POR_MPU_M3_PRLAR17_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR18_U_SMXP_2_0",
        .addr = A_POR_MPU_M3_PRBAR18_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR18_U_SMXP_2_0",
        .addr = A_POR_MPU_M3_PRLAR18_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR19_U_SMXP_2_0",
        .addr = A_POR_MPU_M3_PRBAR19_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR19_U_SMXP_2_0",
        .addr = A_POR_MPU_M3_PRLAR19_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR20_U_SMXP_2_0",
        .addr = A_POR_MPU_M3_PRBAR20_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR20_U_SMXP_2_0",
        .addr = A_POR_MPU_M3_PRLAR20_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR21_U_SMXP_2_0",
        .addr = A_POR_MPU_M3_PRBAR21_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR21_U_SMXP_2_0",
        .addr = A_POR_MPU_M3_PRLAR21_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR22_U_SMXP_2_0",
        .addr = A_POR_MPU_M3_PRBAR22_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR22_U_SMXP_2_0",
        .addr = A_POR_MPU_M3_PRLAR22_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR23_U_SMXP_2_0",
        .addr = A_POR_MPU_M3_PRBAR23_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR23_U_SMXP_2_0",
        .addr = A_POR_MPU_M3_PRLAR23_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR24_U_SMXP_2_0",
        .addr = A_POR_MPU_M3_PRBAR24_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR24_U_SMXP_2_0",
        .addr = A_POR_MPU_M3_PRLAR24_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR25_U_SMXP_2_0",
        .addr = A_POR_MPU_M3_PRBAR25_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR25_U_SMXP_2_0",
        .addr = A_POR_MPU_M3_PRLAR25_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR26_U_SMXP_2_0",
        .addr = A_POR_MPU_M3_PRBAR26_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR26_U_SMXP_2_0",
        .addr = A_POR_MPU_M3_PRLAR26_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR27_U_SMXP_2_0",
        .addr = A_POR_MPU_M3_PRBAR27_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR27_U_SMXP_2_0",
        .addr = A_POR_MPU_M3_PRLAR27_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR28_U_SMXP_2_0",
        .addr = A_POR_MPU_M3_PRBAR28_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR28_U_SMXP_2_0",
        .addr = A_POR_MPU_M3_PRLAR28_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR29_U_SMXP_2_0",
        .addr = A_POR_MPU_M3_PRBAR29_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR29_U_SMXP_2_0",
        .addr = A_POR_MPU_M3_PRLAR29_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR30_U_SMXP_2_0",
        .addr = A_POR_MPU_M3_PRBAR30_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR30_U_SMXP_2_0",
        .addr = A_POR_MPU_M3_PRLAR30_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR31_U_SMXP_2_0",
        .addr = A_POR_MPU_M3_PRBAR31_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR31_U_SMXP_2_0",
        .addr = A_POR_MPU_M3_PRLAR31_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_CTL_U_SMXP_2_0",
        .addr = A_POR_MPU_M4_CTL_U_SMXP_2_0,
        .reset = 0x2,
        .rsvd = 0xfffffffffffffff8L,
        .ro = 0xfffffffffffffff8L,
    },{ .name = "POR_MPU_M4_PRBAR0_U_SMXP_2_0",
        .addr = A_POR_MPU_M4_PRBAR0_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR0_U_SMXP_2_0",
        .addr = A_POR_MPU_M4_PRLAR0_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR1_U_SMXP_2_0",
        .addr = A_POR_MPU_M4_PRBAR1_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR1_U_SMXP_2_0",
        .addr = A_POR_MPU_M4_PRLAR1_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR2_U_SMXP_2_0",
        .addr = A_POR_MPU_M4_PRBAR2_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR2_U_SMXP_2_0",
        .addr = A_POR_MPU_M4_PRLAR2_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR3_U_SMXP_2_0",
        .addr = A_POR_MPU_M4_PRBAR3_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR3_U_SMXP_2_0",
        .addr = A_POR_MPU_M4_PRLAR3_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR4_U_SMXP_2_0",
        .addr = A_POR_MPU_M4_PRBAR4_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR4_U_SMXP_2_0",
        .addr = A_POR_MPU_M4_PRLAR4_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR5_U_SMXP_2_0",
        .addr = A_POR_MPU_M4_PRBAR5_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR5_U_SMXP_2_0",
        .addr = A_POR_MPU_M4_PRLAR5_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR6_U_SMXP_2_0",
        .addr = A_POR_MPU_M4_PRBAR6_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR6_U_SMXP_2_0",
        .addr = A_POR_MPU_M4_PRLAR6_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR7_U_SMXP_2_0",
        .addr = A_POR_MPU_M4_PRBAR7_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR7_U_SMXP_2_0",
        .addr = A_POR_MPU_M4_PRLAR7_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR8_U_SMXP_2_0",
        .addr = A_POR_MPU_M4_PRBAR8_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR8_U_SMXP_2_0",
        .addr = A_POR_MPU_M4_PRLAR8_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR9_U_SMXP_2_0",
        .addr = A_POR_MPU_M4_PRBAR9_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR9_U_SMXP_2_0",
        .addr = A_POR_MPU_M4_PRLAR9_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR10_U_SMXP_2_0",
        .addr = A_POR_MPU_M4_PRBAR10_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR10_U_SMXP_2_0",
        .addr = A_POR_MPU_M4_PRLAR10_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR11_U_SMXP_2_0",
        .addr = A_POR_MPU_M4_PRBAR11_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR11_U_SMXP_2_0",
        .addr = A_POR_MPU_M4_PRLAR11_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR12_U_SMXP_2_0",
        .addr = A_POR_MPU_M4_PRBAR12_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR12_U_SMXP_2_0",
        .addr = A_POR_MPU_M4_PRLAR12_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR13_U_SMXP_2_0",
        .addr = A_POR_MPU_M4_PRBAR13_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR13_U_SMXP_2_0",
        .addr = A_POR_MPU_M4_PRLAR13_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR14_U_SMXP_2_0",
        .addr = A_POR_MPU_M4_PRBAR14_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR14_U_SMXP_2_0",
        .addr = A_POR_MPU_M4_PRLAR14_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR15_U_SMXP_2_0",
        .addr = A_POR_MPU_M4_PRBAR15_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR15_U_SMXP_2_0",
        .addr = A_POR_MPU_M4_PRLAR15_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR16_U_SMXP_2_0",
        .addr = A_POR_MPU_M4_PRBAR16_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR16_U_SMXP_2_0",
        .addr = A_POR_MPU_M4_PRLAR16_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR17_U_SMXP_2_0",
        .addr = A_POR_MPU_M4_PRBAR17_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR17_U_SMXP_2_0",
        .addr = A_POR_MPU_M4_PRLAR17_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR18_U_SMXP_2_0",
        .addr = A_POR_MPU_M4_PRBAR18_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR18_U_SMXP_2_0",
        .addr = A_POR_MPU_M4_PRLAR18_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR19_U_SMXP_2_0",
        .addr = A_POR_MPU_M4_PRBAR19_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR19_U_SMXP_2_0",
        .addr = A_POR_MPU_M4_PRLAR19_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR20_U_SMXP_2_0",
        .addr = A_POR_MPU_M4_PRBAR20_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR20_U_SMXP_2_0",
        .addr = A_POR_MPU_M4_PRLAR20_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR21_U_SMXP_2_0",
        .addr = A_POR_MPU_M4_PRBAR21_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR21_U_SMXP_2_0",
        .addr = A_POR_MPU_M4_PRLAR21_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR22_U_SMXP_2_0",
        .addr = A_POR_MPU_M4_PRBAR22_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR22_U_SMXP_2_0",
        .addr = A_POR_MPU_M4_PRLAR22_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR23_U_SMXP_2_0",
        .addr = A_POR_MPU_M4_PRBAR23_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR23_U_SMXP_2_0",
        .addr = A_POR_MPU_M4_PRLAR23_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR24_U_SMXP_2_0",
        .addr = A_POR_MPU_M4_PRBAR24_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR24_U_SMXP_2_0",
        .addr = A_POR_MPU_M4_PRLAR24_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR25_U_SMXP_2_0",
        .addr = A_POR_MPU_M4_PRBAR25_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR25_U_SMXP_2_0",
        .addr = A_POR_MPU_M4_PRLAR25_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR26_U_SMXP_2_0",
        .addr = A_POR_MPU_M4_PRBAR26_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR26_U_SMXP_2_0",
        .addr = A_POR_MPU_M4_PRLAR26_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR27_U_SMXP_2_0",
        .addr = A_POR_MPU_M4_PRBAR27_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR27_U_SMXP_2_0",
        .addr = A_POR_MPU_M4_PRLAR27_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR28_U_SMXP_2_0",
        .addr = A_POR_MPU_M4_PRBAR28_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR28_U_SMXP_2_0",
        .addr = A_POR_MPU_M4_PRLAR28_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR29_U_SMXP_2_0",
        .addr = A_POR_MPU_M4_PRBAR29_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR29_U_SMXP_2_0",
        .addr = A_POR_MPU_M4_PRLAR29_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR30_U_SMXP_2_0",
        .addr = A_POR_MPU_M4_PRBAR30_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR30_U_SMXP_2_0",
        .addr = A_POR_MPU_M4_PRLAR30_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR31_U_SMXP_2_0",
        .addr = A_POR_MPU_M4_PRBAR31_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR31_U_SMXP_2_0",
        .addr = A_POR_MPU_M4_PRLAR31_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_CTL_U_SMXP_2_0",
        .addr = A_POR_MPU_M5_CTL_U_SMXP_2_0,
        .reset = 0x2,
        .rsvd = 0xfffffffffffffff8L,
        .ro = 0xfffffffffffffff8L,
    },{ .name = "POR_MPU_M5_PRBAR0_U_SMXP_2_0",
        .addr = A_POR_MPU_M5_PRBAR0_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR0_U_SMXP_2_0",
        .addr = A_POR_MPU_M5_PRLAR0_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR1_U_SMXP_2_0",
        .addr = A_POR_MPU_M5_PRBAR1_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR1_U_SMXP_2_0",
        .addr = A_POR_MPU_M5_PRLAR1_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR2_U_SMXP_2_0",
        .addr = A_POR_MPU_M5_PRBAR2_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR2_U_SMXP_2_0",
        .addr = A_POR_MPU_M5_PRLAR2_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR3_U_SMXP_2_0",
        .addr = A_POR_MPU_M5_PRBAR3_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR3_U_SMXP_2_0",
        .addr = A_POR_MPU_M5_PRLAR3_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR4_U_SMXP_2_0",
        .addr = A_POR_MPU_M5_PRBAR4_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR4_U_SMXP_2_0",
        .addr = A_POR_MPU_M5_PRLAR4_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR5_U_SMXP_2_0",
        .addr = A_POR_MPU_M5_PRBAR5_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR5_U_SMXP_2_0",
        .addr = A_POR_MPU_M5_PRLAR5_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR6_U_SMXP_2_0",
        .addr = A_POR_MPU_M5_PRBAR6_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR6_U_SMXP_2_0",
        .addr = A_POR_MPU_M5_PRLAR6_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR7_U_SMXP_2_0",
        .addr = A_POR_MPU_M5_PRBAR7_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR7_U_SMXP_2_0",
        .addr = A_POR_MPU_M5_PRLAR7_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR8_U_SMXP_2_0",
        .addr = A_POR_MPU_M5_PRBAR8_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR8_U_SMXP_2_0",
        .addr = A_POR_MPU_M5_PRLAR8_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR9_U_SMXP_2_0",
        .addr = A_POR_MPU_M5_PRBAR9_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR9_U_SMXP_2_0",
        .addr = A_POR_MPU_M5_PRLAR9_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR10_U_SMXP_2_0",
        .addr = A_POR_MPU_M5_PRBAR10_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR10_U_SMXP_2_0",
        .addr = A_POR_MPU_M5_PRLAR10_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR11_U_SMXP_2_0",
        .addr = A_POR_MPU_M5_PRBAR11_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR11_U_SMXP_2_0",
        .addr = A_POR_MPU_M5_PRLAR11_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR12_U_SMXP_2_0",
        .addr = A_POR_MPU_M5_PRBAR12_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR12_U_SMXP_2_0",
        .addr = A_POR_MPU_M5_PRLAR12_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR13_U_SMXP_2_0",
        .addr = A_POR_MPU_M5_PRBAR13_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR13_U_SMXP_2_0",
        .addr = A_POR_MPU_M5_PRLAR13_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR14_U_SMXP_2_0",
        .addr = A_POR_MPU_M5_PRBAR14_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR14_U_SMXP_2_0",
        .addr = A_POR_MPU_M5_PRLAR14_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR15_U_SMXP_2_0",
        .addr = A_POR_MPU_M5_PRBAR15_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR15_U_SMXP_2_0",
        .addr = A_POR_MPU_M5_PRLAR15_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR16_U_SMXP_2_0",
        .addr = A_POR_MPU_M5_PRBAR16_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR16_U_SMXP_2_0",
        .addr = A_POR_MPU_M5_PRLAR16_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR17_U_SMXP_2_0",
        .addr = A_POR_MPU_M5_PRBAR17_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR17_U_SMXP_2_0",
        .addr = A_POR_MPU_M5_PRLAR17_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR18_U_SMXP_2_0",
        .addr = A_POR_MPU_M5_PRBAR18_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR18_U_SMXP_2_0",
        .addr = A_POR_MPU_M5_PRLAR18_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR19_U_SMXP_2_0",
        .addr = A_POR_MPU_M5_PRBAR19_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR19_U_SMXP_2_0",
        .addr = A_POR_MPU_M5_PRLAR19_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR20_U_SMXP_2_0",
        .addr = A_POR_MPU_M5_PRBAR20_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR20_U_SMXP_2_0",
        .addr = A_POR_MPU_M5_PRLAR20_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR21_U_SMXP_2_0",
        .addr = A_POR_MPU_M5_PRBAR21_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR21_U_SMXP_2_0",
        .addr = A_POR_MPU_M5_PRLAR21_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR22_U_SMXP_2_0",
        .addr = A_POR_MPU_M5_PRBAR22_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR22_U_SMXP_2_0",
        .addr = A_POR_MPU_M5_PRLAR22_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR23_U_SMXP_2_0",
        .addr = A_POR_MPU_M5_PRBAR23_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR23_U_SMXP_2_0",
        .addr = A_POR_MPU_M5_PRLAR23_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR24_U_SMXP_2_0",
        .addr = A_POR_MPU_M5_PRBAR24_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR24_U_SMXP_2_0",
        .addr = A_POR_MPU_M5_PRLAR24_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR25_U_SMXP_2_0",
        .addr = A_POR_MPU_M5_PRBAR25_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR25_U_SMXP_2_0",
        .addr = A_POR_MPU_M5_PRLAR25_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR26_U_SMXP_2_0",
        .addr = A_POR_MPU_M5_PRBAR26_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR26_U_SMXP_2_0",
        .addr = A_POR_MPU_M5_PRLAR26_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR27_U_SMXP_2_0",
        .addr = A_POR_MPU_M5_PRBAR27_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR27_U_SMXP_2_0",
        .addr = A_POR_MPU_M5_PRLAR27_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR28_U_SMXP_2_0",
        .addr = A_POR_MPU_M5_PRBAR28_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR28_U_SMXP_2_0",
        .addr = A_POR_MPU_M5_PRLAR28_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR29_U_SMXP_2_0",
        .addr = A_POR_MPU_M5_PRBAR29_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR29_U_SMXP_2_0",
        .addr = A_POR_MPU_M5_PRLAR29_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR30_U_SMXP_2_0",
        .addr = A_POR_MPU_M5_PRBAR30_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR30_U_SMXP_2_0",
        .addr = A_POR_MPU_M5_PRLAR30_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR31_U_SMXP_2_0",
        .addr = A_POR_MPU_M5_PRBAR31_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR31_U_SMXP_2_0",
        .addr = A_POR_MPU_M5_PRLAR31_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_CTL_U_SMXP_2_0",
        .addr = A_POR_MPU_M6_CTL_U_SMXP_2_0,
        .reset = 0x2,
        .rsvd = 0xfffffffffffffff8L,
        .ro = 0xfffffffffffffff8L,
    },{ .name = "POR_MPU_M6_PRBAR0_U_SMXP_2_0",
        .addr = A_POR_MPU_M6_PRBAR0_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR0_U_SMXP_2_0",
        .addr = A_POR_MPU_M6_PRLAR0_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR1_U_SMXP_2_0",
        .addr = A_POR_MPU_M6_PRBAR1_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR1_U_SMXP_2_0",
        .addr = A_POR_MPU_M6_PRLAR1_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR2_U_SMXP_2_0",
        .addr = A_POR_MPU_M6_PRBAR2_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR2_U_SMXP_2_0",
        .addr = A_POR_MPU_M6_PRLAR2_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR3_U_SMXP_2_0",
        .addr = A_POR_MPU_M6_PRBAR3_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR3_U_SMXP_2_0",
        .addr = A_POR_MPU_M6_PRLAR3_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR4_U_SMXP_2_0",
        .addr = A_POR_MPU_M6_PRBAR4_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR4_U_SMXP_2_0",
        .addr = A_POR_MPU_M6_PRLAR4_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR5_U_SMXP_2_0",
        .addr = A_POR_MPU_M6_PRBAR5_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR5_U_SMXP_2_0",
        .addr = A_POR_MPU_M6_PRLAR5_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR6_U_SMXP_2_0",
        .addr = A_POR_MPU_M6_PRBAR6_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR6_U_SMXP_2_0",
        .addr = A_POR_MPU_M6_PRLAR6_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR7_U_SMXP_2_0",
        .addr = A_POR_MPU_M6_PRBAR7_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR7_U_SMXP_2_0",
        .addr = A_POR_MPU_M6_PRLAR7_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR8_U_SMXP_2_0",
        .addr = A_POR_MPU_M6_PRBAR8_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR8_U_SMXP_2_0",
        .addr = A_POR_MPU_M6_PRLAR8_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR9_U_SMXP_2_0",
        .addr = A_POR_MPU_M6_PRBAR9_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR9_U_SMXP_2_0",
        .addr = A_POR_MPU_M6_PRLAR9_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR10_U_SMXP_2_0",
        .addr = A_POR_MPU_M6_PRBAR10_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR10_U_SMXP_2_0",
        .addr = A_POR_MPU_M6_PRLAR10_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR11_U_SMXP_2_0",
        .addr = A_POR_MPU_M6_PRBAR11_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR11_U_SMXP_2_0",
        .addr = A_POR_MPU_M6_PRLAR11_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR12_U_SMXP_2_0",
        .addr = A_POR_MPU_M6_PRBAR12_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR12_U_SMXP_2_0",
        .addr = A_POR_MPU_M6_PRLAR12_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR13_U_SMXP_2_0",
        .addr = A_POR_MPU_M6_PRBAR13_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR13_U_SMXP_2_0",
        .addr = A_POR_MPU_M6_PRLAR13_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR14_U_SMXP_2_0",
        .addr = A_POR_MPU_M6_PRBAR14_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR14_U_SMXP_2_0",
        .addr = A_POR_MPU_M6_PRLAR14_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR15_U_SMXP_2_0",
        .addr = A_POR_MPU_M6_PRBAR15_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR15_U_SMXP_2_0",
        .addr = A_POR_MPU_M6_PRLAR15_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR16_U_SMXP_2_0",
        .addr = A_POR_MPU_M6_PRBAR16_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR16_U_SMXP_2_0",
        .addr = A_POR_MPU_M6_PRLAR16_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR17_U_SMXP_2_0",
        .addr = A_POR_MPU_M6_PRBAR17_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR17_U_SMXP_2_0",
        .addr = A_POR_MPU_M6_PRLAR17_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR18_U_SMXP_2_0",
        .addr = A_POR_MPU_M6_PRBAR18_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR18_U_SMXP_2_0",
        .addr = A_POR_MPU_M6_PRLAR18_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR19_U_SMXP_2_0",
        .addr = A_POR_MPU_M6_PRBAR19_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR19_U_SMXP_2_0",
        .addr = A_POR_MPU_M6_PRLAR19_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR20_U_SMXP_2_0",
        .addr = A_POR_MPU_M6_PRBAR20_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR20_U_SMXP_2_0",
        .addr = A_POR_MPU_M6_PRLAR20_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR21_U_SMXP_2_0",
        .addr = A_POR_MPU_M6_PRBAR21_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR21_U_SMXP_2_0",
        .addr = A_POR_MPU_M6_PRLAR21_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR22_U_SMXP_2_0",
        .addr = A_POR_MPU_M6_PRBAR22_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR22_U_SMXP_2_0",
        .addr = A_POR_MPU_M6_PRLAR22_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR23_U_SMXP_2_0",
        .addr = A_POR_MPU_M6_PRBAR23_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR23_U_SMXP_2_0",
        .addr = A_POR_MPU_M6_PRLAR23_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR24_U_SMXP_2_0",
        .addr = A_POR_MPU_M6_PRBAR24_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR24_U_SMXP_2_0",
        .addr = A_POR_MPU_M6_PRLAR24_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR25_U_SMXP_2_0",
        .addr = A_POR_MPU_M6_PRBAR25_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR25_U_SMXP_2_0",
        .addr = A_POR_MPU_M6_PRLAR25_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR26_U_SMXP_2_0",
        .addr = A_POR_MPU_M6_PRBAR26_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR26_U_SMXP_2_0",
        .addr = A_POR_MPU_M6_PRLAR26_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR27_U_SMXP_2_0",
        .addr = A_POR_MPU_M6_PRBAR27_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR27_U_SMXP_2_0",
        .addr = A_POR_MPU_M6_PRLAR27_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR28_U_SMXP_2_0",
        .addr = A_POR_MPU_M6_PRBAR28_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR28_U_SMXP_2_0",
        .addr = A_POR_MPU_M6_PRLAR28_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR29_U_SMXP_2_0",
        .addr = A_POR_MPU_M6_PRBAR29_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR29_U_SMXP_2_0",
        .addr = A_POR_MPU_M6_PRLAR29_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR30_U_SMXP_2_0",
        .addr = A_POR_MPU_M6_PRBAR30_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR30_U_SMXP_2_0",
        .addr = A_POR_MPU_M6_PRLAR30_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR31_U_SMXP_2_0",
        .addr = A_POR_MPU_M6_PRBAR31_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR31_U_SMXP_2_0",
        .addr = A_POR_MPU_M6_PRLAR31_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_CTL_U_SMXP_2_0",
        .addr = A_POR_MPU_M7_CTL_U_SMXP_2_0,
        .reset = 0x2,
        .rsvd = 0xfffffffffffffff8L,
        .ro = 0xfffffffffffffff8L,
    },{ .name = "POR_MPU_M7_PRBAR0_U_SMXP_2_0",
        .addr = A_POR_MPU_M7_PRBAR0_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR0_U_SMXP_2_0",
        .addr = A_POR_MPU_M7_PRLAR0_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR1_U_SMXP_2_0",
        .addr = A_POR_MPU_M7_PRBAR1_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR1_U_SMXP_2_0",
        .addr = A_POR_MPU_M7_PRLAR1_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR2_U_SMXP_2_0",
        .addr = A_POR_MPU_M7_PRBAR2_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR2_U_SMXP_2_0",
        .addr = A_POR_MPU_M7_PRLAR2_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR3_U_SMXP_2_0",
        .addr = A_POR_MPU_M7_PRBAR3_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR3_U_SMXP_2_0",
        .addr = A_POR_MPU_M7_PRLAR3_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR4_U_SMXP_2_0",
        .addr = A_POR_MPU_M7_PRBAR4_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR4_U_SMXP_2_0",
        .addr = A_POR_MPU_M7_PRLAR4_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR5_U_SMXP_2_0",
        .addr = A_POR_MPU_M7_PRBAR5_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR5_U_SMXP_2_0",
        .addr = A_POR_MPU_M7_PRLAR5_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR6_U_SMXP_2_0",
        .addr = A_POR_MPU_M7_PRBAR6_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR6_U_SMXP_2_0",
        .addr = A_POR_MPU_M7_PRLAR6_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR7_U_SMXP_2_0",
        .addr = A_POR_MPU_M7_PRBAR7_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR7_U_SMXP_2_0",
        .addr = A_POR_MPU_M7_PRLAR7_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR8_U_SMXP_2_0",
        .addr = A_POR_MPU_M7_PRBAR8_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR8_U_SMXP_2_0",
        .addr = A_POR_MPU_M7_PRLAR8_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR9_U_SMXP_2_0",
        .addr = A_POR_MPU_M7_PRBAR9_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR9_U_SMXP_2_0",
        .addr = A_POR_MPU_M7_PRLAR9_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR10_U_SMXP_2_0",
        .addr = A_POR_MPU_M7_PRBAR10_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR10_U_SMXP_2_0",
        .addr = A_POR_MPU_M7_PRLAR10_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR11_U_SMXP_2_0",
        .addr = A_POR_MPU_M7_PRBAR11_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR11_U_SMXP_2_0",
        .addr = A_POR_MPU_M7_PRLAR11_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR12_U_SMXP_2_0",
        .addr = A_POR_MPU_M7_PRBAR12_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR12_U_SMXP_2_0",
        .addr = A_POR_MPU_M7_PRLAR12_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR13_U_SMXP_2_0",
        .addr = A_POR_MPU_M7_PRBAR13_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR13_U_SMXP_2_0",
        .addr = A_POR_MPU_M7_PRLAR13_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR14_U_SMXP_2_0",
        .addr = A_POR_MPU_M7_PRBAR14_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR14_U_SMXP_2_0",
        .addr = A_POR_MPU_M7_PRLAR14_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR15_U_SMXP_2_0",
        .addr = A_POR_MPU_M7_PRBAR15_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR15_U_SMXP_2_0",
        .addr = A_POR_MPU_M7_PRLAR15_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR16_U_SMXP_2_0",
        .addr = A_POR_MPU_M7_PRBAR16_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR16_U_SMXP_2_0",
        .addr = A_POR_MPU_M7_PRLAR16_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR17_U_SMXP_2_0",
        .addr = A_POR_MPU_M7_PRBAR17_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR17_U_SMXP_2_0",
        .addr = A_POR_MPU_M7_PRLAR17_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR18_U_SMXP_2_0",
        .addr = A_POR_MPU_M7_PRBAR18_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR18_U_SMXP_2_0",
        .addr = A_POR_MPU_M7_PRLAR18_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR19_U_SMXP_2_0",
        .addr = A_POR_MPU_M7_PRBAR19_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR19_U_SMXP_2_0",
        .addr = A_POR_MPU_M7_PRLAR19_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR20_U_SMXP_2_0",
        .addr = A_POR_MPU_M7_PRBAR20_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR20_U_SMXP_2_0",
        .addr = A_POR_MPU_M7_PRLAR20_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR21_U_SMXP_2_0",
        .addr = A_POR_MPU_M7_PRBAR21_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR21_U_SMXP_2_0",
        .addr = A_POR_MPU_M7_PRLAR21_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR22_U_SMXP_2_0",
        .addr = A_POR_MPU_M7_PRBAR22_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR22_U_SMXP_2_0",
        .addr = A_POR_MPU_M7_PRLAR22_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR23_U_SMXP_2_0",
        .addr = A_POR_MPU_M7_PRBAR23_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR23_U_SMXP_2_0",
        .addr = A_POR_MPU_M7_PRLAR23_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR24_U_SMXP_2_0",
        .addr = A_POR_MPU_M7_PRBAR24_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR24_U_SMXP_2_0",
        .addr = A_POR_MPU_M7_PRLAR24_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR25_U_SMXP_2_0",
        .addr = A_POR_MPU_M7_PRBAR25_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR25_U_SMXP_2_0",
        .addr = A_POR_MPU_M7_PRLAR25_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR26_U_SMXP_2_0",
        .addr = A_POR_MPU_M7_PRBAR26_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR26_U_SMXP_2_0",
        .addr = A_POR_MPU_M7_PRLAR26_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR27_U_SMXP_2_0",
        .addr = A_POR_MPU_M7_PRBAR27_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR27_U_SMXP_2_0",
        .addr = A_POR_MPU_M7_PRLAR27_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR28_U_SMXP_2_0",
        .addr = A_POR_MPU_M7_PRBAR28_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR28_U_SMXP_2_0",
        .addr = A_POR_MPU_M7_PRLAR28_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR29_U_SMXP_2_0",
        .addr = A_POR_MPU_M7_PRBAR29_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR29_U_SMXP_2_0",
        .addr = A_POR_MPU_M7_PRLAR29_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR30_U_SMXP_2_0",
        .addr = A_POR_MPU_M7_PRBAR30_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR30_U_SMXP_2_0",
        .addr = A_POR_MPU_M7_PRLAR30_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR31_U_SMXP_2_0",
        .addr = A_POR_MPU_M7_PRBAR31_U_SMXP_2_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR31_U_SMXP_2_0",
        .addr = A_POR_MPU_M7_PRLAR31_U_SMXP_2_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_HNF_NODE_INFO_U_HNF_NID136",
        .addr = A_POR_HNF_NODE_INFO_U_HNF_NID136,
        .reset = 0x80005,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_HNF_CHILD_INFO_U_HNF_NID136",
        .addr = A_POR_HNF_CHILD_INFO_U_HNF_NID136,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_HNF_UNIT_INFO_U_HNF_NID136",
        .addr = A_POR_HNF_UNIT_INFO_U_HNF_NID136,
        .reset = 0x4000000000,
        .rsvd = 0x88,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_HNF_SECURE_REGISTER_GROUPS_OVERRIDE_U_HNF_NID136",
        .addr = A_POR_HNF_SECURE_REGISTER_GROUPS_OVERRIDE_U_HNF_NID136,
        .rsvd = 0xffffffffffffffc0L,
        .ro = 0xffffffffffffffc0L,
    },{ .name = "POR_HNF_CFG_CTL_U_HNF_NID136",
        .addr = A_POR_HNF_CFG_CTL_U_HNF_NID136,
        .reset = 0x50,
        .rsvd = 0xaa,
        .ro = 0xfffffffffffff0aaL,
    },{ .name = "POR_HNF_AUX_CTL_U_HNF_NID136",
        .addr = A_POR_HNF_AUX_CTL_U_HNF_NID136,
        .reset = 0x11c4c9000000002,
        .ro = 0xfc60006cfffe0000L,
    },{ .name = "POR_HNF_R2_AUX_CTL_U_HNF_NID136",
        .addr = A_POR_HNF_R2_AUX_CTL_U_HNF_NID136,
        .rsvd = 0xfffffffffffffff0L,
        .ro = 0xfffffffffffffff0L,
    },{ .name = "RDF_HNF_AUX_CTL_U_HNF_NID136",
        .addr = A_RDF_HNF_AUX_CTL_U_HNF_NID136,
        .ro = 0xffffffffffff6cffL,
    },{ .name = "POR_HNF_QOS_BAND_U_HNF_NID136",
        .addr = A_POR_HNF_QOS_BAND_U_HNF_NID136,
        .reset = 0xffecb870,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_HNF_QOS_RESERVATION_U_HNF_NID136",
        .addr = A_POR_HNF_QOS_RESERVATION_U_HNF_NID136,
        .reset = 0x13f3e1f0a,
        .rsvd = 0xc0,
        .ro = 0xffffffc0c0c0c0c0L,
    },{ .name = "POR_HNF_RN_STARVATION_U_HNF_NID136",
        .addr = A_POR_HNF_RN_STARVATION_U_HNF_NID136,
        .reset = 0x1f3f1f3f3f1f,
        .rsvd = 0xe0,
        .ro = 0xffffe0c0e080c0e0L,
    },{ .name = "POR_HNF_CFG_SLCSF_DBGRD_U_HNF_NID136",
        .addr = A_POR_HNF_CFG_SLCSF_DBGRD_U_HNF_NID136,
        .ro = 0xfffffffffc80e000L,
    },{ .name = "POR_HNF_SLC_CACHE_ACCESS_SLC_TAG_U_HNF_NID136",
        .addr = A_POR_HNF_SLC_CACHE_ACCESS_SLC_TAG_U_HNF_NID136,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_HNF_SLC_CACHE_ACCESS_SLC_DATA_U_HNF_NID136",
        .addr = A_POR_HNF_SLC_CACHE_ACCESS_SLC_DATA_U_HNF_NID136,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_HNF_SLC_CACHE_ACCESS_SF_TAG_U_HNF_NID136",
        .addr = A_POR_HNF_SLC_CACHE_ACCESS_SF_TAG_U_HNF_NID136,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_HNF_SLC_CACHE_ACCESS_SF_TAG1_U_HNF_NID136",
        .addr = A_POR_HNF_SLC_CACHE_ACCESS_SF_TAG1_U_HNF_NID136,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_HNF_SLC_CACHE_ACCESS_SF_TAG2_U_HNF_NID136",
        .addr = A_POR_HNF_SLC_CACHE_ACCESS_SF_TAG2_U_HNF_NID136,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_HNF_SLC_LOCK_WAYS_U_HNF_NID136",
        .addr = A_POR_HNF_SLC_LOCK_WAYS_U_HNF_NID136,
        .reset = 0x400,
        .rsvd = 0xf0,
        .ro = 0xffffffffffff80f0L,
    },{ .name = "POR_HNF_SLC_LOCK_BASE0_U_HNF_NID136",
        .addr = A_POR_HNF_SLC_LOCK_BASE0_U_HNF_NID136,
        .ro = 0x7fff000000000000,
    },{ .name = "POR_HNF_SLC_LOCK_BASE1_U_HNF_NID136",
        .addr = A_POR_HNF_SLC_LOCK_BASE1_U_HNF_NID136,
        .ro = 0x7fff000000000000,
    },{ .name = "POR_HNF_SLC_LOCK_BASE2_U_HNF_NID136",
        .addr = A_POR_HNF_SLC_LOCK_BASE2_U_HNF_NID136,
        .ro = 0x7fff000000000000,
    },{ .name = "POR_HNF_SLC_LOCK_BASE3_U_HNF_NID136",
        .addr = A_POR_HNF_SLC_LOCK_BASE3_U_HNF_NID136,
        .ro = 0x7fff000000000000,
    },{ .name = "POR_HNF_RNF_REGION_VEC1_U_HNF_NID136",
        .addr = A_POR_HNF_RNF_REGION_VEC1_U_HNF_NID136,
    },{ .name = "POR_HNF_RNI_REGION_VEC_U_HNF_NID136",
        .addr = A_POR_HNF_RNI_REGION_VEC_U_HNF_NID136,
        .ro = 0xffffffff00000000L,
    },{ .name = "POR_HNF_RNF_REGION_VEC_U_HNF_NID136",
        .addr = A_POR_HNF_RNF_REGION_VEC_U_HNF_NID136,
    },{ .name = "POR_HNF_RND_REGION_VEC_U_HNF_NID136",
        .addr = A_POR_HNF_RND_REGION_VEC_U_HNF_NID136,
        .ro = 0xffffffff00000000L,
    },{ .name = "POR_HNF_SLCWAY_PARTITION0_RNF_VEC_U_HNF_NID136",
        .addr = A_POR_HNF_SLCWAY_PARTITION0_RNF_VEC_U_HNF_NID136,
        .reset = 0xffffffffffffffffL,
    },{ .name = "POR_HNF_SLCWAY_PARTITION1_RNF_VEC_U_HNF_NID136",
        .addr = A_POR_HNF_SLCWAY_PARTITION1_RNF_VEC_U_HNF_NID136,
        .reset = 0xffffffffffffffffL,
    },{ .name = "POR_HNF_SLCWAY_PARTITION2_RNF_VEC_U_HNF_NID136",
        .addr = A_POR_HNF_SLCWAY_PARTITION2_RNF_VEC_U_HNF_NID136,
        .reset = 0xffffffffffffffffL,
    },{ .name = "POR_HNF_SLCWAY_PARTITION3_RNF_VEC_U_HNF_NID136",
        .addr = A_POR_HNF_SLCWAY_PARTITION3_RNF_VEC_U_HNF_NID136,
        .reset = 0xffffffffffffffffL,
    },{ .name = "POR_HNF_SLCWAY_PARTITION0_RNI_VEC_U_HNF_NID136",
        .addr = A_POR_HNF_SLCWAY_PARTITION0_RNI_VEC_U_HNF_NID136,
        .reset = 0xffffffff,
        .ro = 0xffffffff00000000L,
    },{ .name = "POR_HNF_SLCWAY_PARTITION1_RNI_VEC_U_HNF_NID136",
        .addr = A_POR_HNF_SLCWAY_PARTITION1_RNI_VEC_U_HNF_NID136,
        .reset = 0xffffffff,
        .ro = 0xffffffff00000000L,
    },{ .name = "POR_HNF_SLCWAY_PARTITION2_RNI_VEC_U_HNF_NID136",
        .addr = A_POR_HNF_SLCWAY_PARTITION2_RNI_VEC_U_HNF_NID136,
        .reset = 0xffffffff,
        .ro = 0xffffffff00000000L,
    },{ .name = "POR_HNF_SLCWAY_PARTITION3_RNI_VEC_U_HNF_NID136",
        .addr = A_POR_HNF_SLCWAY_PARTITION3_RNI_VEC_U_HNF_NID136,
        .reset = 0xffffffff,
        .ro = 0xffffffff00000000L,
    },{ .name = "POR_HNF_SLCWAY_PARTITION0_RND_VEC_U_HNF_NID136",
        .addr = A_POR_HNF_SLCWAY_PARTITION0_RND_VEC_U_HNF_NID136,
        .reset = 0xffffffff,
        .ro = 0xffffffff00000000L,
    },{ .name = "POR_HNF_SLCWAY_PARTITION1_RND_VEC_U_HNF_NID136",
        .addr = A_POR_HNF_SLCWAY_PARTITION1_RND_VEC_U_HNF_NID136,
        .reset = 0xffffffff,
        .ro = 0xffffffff00000000L,
    },{ .name = "POR_HNF_SLCWAY_PARTITION2_RND_VEC_U_HNF_NID136",
        .addr = A_POR_HNF_SLCWAY_PARTITION2_RND_VEC_U_HNF_NID136,
        .reset = 0xffffffff,
        .ro = 0xffffffff00000000L,
    },{ .name = "POR_HNF_SLCWAY_PARTITION3_RND_VEC_U_HNF_NID136",
        .addr = A_POR_HNF_SLCWAY_PARTITION3_RND_VEC_U_HNF_NID136,
        .reset = 0xffffffff,
        .ro = 0xffffffff00000000L,
    },{ .name = "POR_HNF_RN_REGION_LOCK_U_HNF_NID136",
        .addr = A_POR_HNF_RN_REGION_LOCK_U_HNF_NID136,
        .rsvd = 0xfffffffffffffffcL,
        .ro = 0xfffffffffffffffcL,
    },{ .name = "POR_HNF_SLCWAY_PARTITION0_RNF_VEC1_U_HNF_NID136",
        .addr = A_POR_HNF_SLCWAY_PARTITION0_RNF_VEC1_U_HNF_NID136,
        .reset = 0xffffffffffffffffL,
    },{ .name = "POR_HNF_SLCWAY_PARTITION1_RNF_VEC1_U_HNF_NID136",
        .addr = A_POR_HNF_SLCWAY_PARTITION1_RNF_VEC1_U_HNF_NID136,
        .reset = 0xffffffffffffffffL,
    },{ .name = "POR_HNF_SLCWAY_PARTITION2_RNF_VEC1_U_HNF_NID136",
        .addr = A_POR_HNF_SLCWAY_PARTITION2_RNF_VEC1_U_HNF_NID136,
        .reset = 0xffffffffffffffffL,
    },{ .name = "POR_HNF_SLCWAY_PARTITION3_RNF_VEC1_U_HNF_NID136",
        .addr = A_POR_HNF_SLCWAY_PARTITION3_RNF_VEC1_U_HNF_NID136,
        .reset = 0xffffffffffffffffL,
    },{ .name = "POR_HNF_SAM_CONTROL_U_HNF_NID136",
        .addr = A_POR_HNF_SAM_CONTROL_U_HNF_NID136,
        .ro = 0x40c0c0c800800800,
    },{ .name = "POR_HNF_SAM_MEMREGION0_U_HNF_NID136",
        .addr = A_POR_HNF_SAM_MEMREGION0_U_HNF_NID136,
        .ro = 0x7fff000003fe0800,
    },{ .name = "POR_HNF_SAM_MEMREGION1_U_HNF_NID136",
        .addr = A_POR_HNF_SAM_MEMREGION1_U_HNF_NID136,
        .ro = 0x7fff000003fe0800,
    },{ .name = "POR_HNF_SAM_SN_PROPERTIES_U_HNF_NID136",
        .addr = A_POR_HNF_SAM_SN_PROPERTIES_U_HNF_NID136,
        .rsvd = 0x38,
        .ro = 0xffffe38e38e38e38L,
    },{ .name = "POR_HNF_SAM_6SN_NODEID_U_HNF_NID136",
        .addr = A_POR_HNF_SAM_6SN_NODEID_U_HNF_NID136,
        .ro = 0xfffffff800800800L,
    },{ .name = "POR_HNF_RN_PHYS_ID0_U_HNF_NID136",
        .addr = A_POR_HNF_RN_PHYS_ID0_U_HNF_NID136,
        .reset = 0x8000004c8000000cL,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID1_U_HNF_NID136",
        .addr = A_POR_HNF_RN_PHYS_ID1_U_HNF_NID136,
        .reset = 0x800000cc8000008cL,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID2_U_HNF_NID136",
        .addr = A_POR_HNF_RN_PHYS_ID2_U_HNF_NID136,
        .reset = 0x8000010c,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID3_U_HNF_NID136",
        .addr = A_POR_HNF_RN_PHYS_ID3_U_HNF_NID136,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID4_U_HNF_NID136",
        .addr = A_POR_HNF_RN_PHYS_ID4_U_HNF_NID136,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID5_U_HNF_NID136",
        .addr = A_POR_HNF_RN_PHYS_ID5_U_HNF_NID136,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID6_U_HNF_NID136",
        .addr = A_POR_HNF_RN_PHYS_ID6_U_HNF_NID136,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID7_U_HNF_NID136",
        .addr = A_POR_HNF_RN_PHYS_ID7_U_HNF_NID136,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID8_U_HNF_NID136",
        .addr = A_POR_HNF_RN_PHYS_ID8_U_HNF_NID136,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID9_U_HNF_NID136",
        .addr = A_POR_HNF_RN_PHYS_ID9_U_HNF_NID136,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID10_U_HNF_NID136",
        .addr = A_POR_HNF_RN_PHYS_ID10_U_HNF_NID136,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID11_U_HNF_NID136",
        .addr = A_POR_HNF_RN_PHYS_ID11_U_HNF_NID136,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID12_U_HNF_NID136",
        .addr = A_POR_HNF_RN_PHYS_ID12_U_HNF_NID136,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID13_U_HNF_NID136",
        .addr = A_POR_HNF_RN_PHYS_ID13_U_HNF_NID136,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID14_U_HNF_NID136",
        .addr = A_POR_HNF_RN_PHYS_ID14_U_HNF_NID136,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID15_U_HNF_NID136",
        .addr = A_POR_HNF_RN_PHYS_ID15_U_HNF_NID136,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID16_U_HNF_NID136",
        .addr = A_POR_HNF_RN_PHYS_ID16_U_HNF_NID136,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID17_U_HNF_NID136",
        .addr = A_POR_HNF_RN_PHYS_ID17_U_HNF_NID136,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID18_U_HNF_NID136",
        .addr = A_POR_HNF_RN_PHYS_ID18_U_HNF_NID136,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID19_U_HNF_NID136",
        .addr = A_POR_HNF_RN_PHYS_ID19_U_HNF_NID136,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID20_U_HNF_NID136",
        .addr = A_POR_HNF_RN_PHYS_ID20_U_HNF_NID136,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID21_U_HNF_NID136",
        .addr = A_POR_HNF_RN_PHYS_ID21_U_HNF_NID136,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID22_U_HNF_NID136",
        .addr = A_POR_HNF_RN_PHYS_ID22_U_HNF_NID136,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID23_U_HNF_NID136",
        .addr = A_POR_HNF_RN_PHYS_ID23_U_HNF_NID136,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID24_U_HNF_NID136",
        .addr = A_POR_HNF_RN_PHYS_ID24_U_HNF_NID136,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID25_U_HNF_NID136",
        .addr = A_POR_HNF_RN_PHYS_ID25_U_HNF_NID136,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID26_U_HNF_NID136",
        .addr = A_POR_HNF_RN_PHYS_ID26_U_HNF_NID136,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID27_U_HNF_NID136",
        .addr = A_POR_HNF_RN_PHYS_ID27_U_HNF_NID136,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID28_U_HNF_NID136",
        .addr = A_POR_HNF_RN_PHYS_ID28_U_HNF_NID136,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID29_U_HNF_NID136",
        .addr = A_POR_HNF_RN_PHYS_ID29_U_HNF_NID136,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID30_U_HNF_NID136",
        .addr = A_POR_HNF_RN_PHYS_ID30_U_HNF_NID136,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID31_U_HNF_NID136",
        .addr = A_POR_HNF_RN_PHYS_ID31_U_HNF_NID136,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID32_U_HNF_NID136",
        .addr = A_POR_HNF_RN_PHYS_ID32_U_HNF_NID136,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID33_U_HNF_NID136",
        .addr = A_POR_HNF_RN_PHYS_ID33_U_HNF_NID136,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID34_U_HNF_NID136",
        .addr = A_POR_HNF_RN_PHYS_ID34_U_HNF_NID136,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID35_U_HNF_NID136",
        .addr = A_POR_HNF_RN_PHYS_ID35_U_HNF_NID136,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID36_U_HNF_NID136",
        .addr = A_POR_HNF_RN_PHYS_ID36_U_HNF_NID136,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID37_U_HNF_NID136",
        .addr = A_POR_HNF_RN_PHYS_ID37_U_HNF_NID136,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID38_U_HNF_NID136",
        .addr = A_POR_HNF_RN_PHYS_ID38_U_HNF_NID136,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID39_U_HNF_NID136",
        .addr = A_POR_HNF_RN_PHYS_ID39_U_HNF_NID136,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID40_U_HNF_NID136",
        .addr = A_POR_HNF_RN_PHYS_ID40_U_HNF_NID136,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID41_U_HNF_NID136",
        .addr = A_POR_HNF_RN_PHYS_ID41_U_HNF_NID136,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID42_U_HNF_NID136",
        .addr = A_POR_HNF_RN_PHYS_ID42_U_HNF_NID136,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID43_U_HNF_NID136",
        .addr = A_POR_HNF_RN_PHYS_ID43_U_HNF_NID136,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID44_U_HNF_NID136",
        .addr = A_POR_HNF_RN_PHYS_ID44_U_HNF_NID136,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID45_U_HNF_NID136",
        .addr = A_POR_HNF_RN_PHYS_ID45_U_HNF_NID136,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID46_U_HNF_NID136",
        .addr = A_POR_HNF_RN_PHYS_ID46_U_HNF_NID136,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID47_U_HNF_NID136",
        .addr = A_POR_HNF_RN_PHYS_ID47_U_HNF_NID136,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID48_U_HNF_NID136",
        .addr = A_POR_HNF_RN_PHYS_ID48_U_HNF_NID136,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID49_U_HNF_NID136",
        .addr = A_POR_HNF_RN_PHYS_ID49_U_HNF_NID136,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID50_U_HNF_NID136",
        .addr = A_POR_HNF_RN_PHYS_ID50_U_HNF_NID136,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID51_U_HNF_NID136",
        .addr = A_POR_HNF_RN_PHYS_ID51_U_HNF_NID136,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID52_U_HNF_NID136",
        .addr = A_POR_HNF_RN_PHYS_ID52_U_HNF_NID136,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID53_U_HNF_NID136",
        .addr = A_POR_HNF_RN_PHYS_ID53_U_HNF_NID136,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID54_U_HNF_NID136",
        .addr = A_POR_HNF_RN_PHYS_ID54_U_HNF_NID136,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID55_U_HNF_NID136",
        .addr = A_POR_HNF_RN_PHYS_ID55_U_HNF_NID136,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID56_U_HNF_NID136",
        .addr = A_POR_HNF_RN_PHYS_ID56_U_HNF_NID136,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID57_U_HNF_NID136",
        .addr = A_POR_HNF_RN_PHYS_ID57_U_HNF_NID136,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID58_U_HNF_NID136",
        .addr = A_POR_HNF_RN_PHYS_ID58_U_HNF_NID136,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_SF_CXG_BLOCKED_WAYS_U_HNF_NID136",
        .addr = A_POR_HNF_SF_CXG_BLOCKED_WAYS_U_HNF_NID136,
        .rsvd = 0xfffffffffffffffcL,
        .ro = 0xfffffffffffffffcL,
    },{ .name = "POR_HNF_CML_PORT_AGGR_GRP0_ADD_MASK_U_HNF_NID136",
        .addr = A_POR_HNF_CML_PORT_AGGR_GRP0_ADD_MASK_U_HNF_NID136,
        .reset = 0x40,
        .ro = 0xffff00000000003fL,
    },{ .name = "POR_HNF_CML_PORT_AGGR_GRP1_ADD_MASK_U_HNF_NID136",
        .addr = A_POR_HNF_CML_PORT_AGGR_GRP1_ADD_MASK_U_HNF_NID136,
        .reset = 0x40,
        .ro = 0xffff00000000003fL,
    },{ .name = "POR_HNF_CML_PORT_AGGR_GRP0_REG_U_HNF_NID136",
        .addr = A_POR_HNF_CML_PORT_AGGR_GRP0_REG_U_HNF_NID136,
        .ro = 0xfffc800800800800L,
    },{ .name = "POR_HNF_CML_PORT_AGGR_GRP1_REG_U_HNF_NID136",
        .addr = A_POR_HNF_CML_PORT_AGGR_GRP1_REG_U_HNF_NID136,
        .ro = 0xfffc800800800800L,
    },{ .name = "HN_SAM_HASH_ADDR_MASK_REG_U_HNF_NID136",
        .addr = A_HN_SAM_HASH_ADDR_MASK_REG_U_HNF_NID136,
        .reset = 0xffffffffffc0,
        .ro = 0xffff00000000003fL,
    },{ .name = "HN_SAM_REGION_CMP_ADDR_MASK_REG_U_HNF_NID136",
        .addr = A_HN_SAM_REGION_CMP_ADDR_MASK_REG_U_HNF_NID136,
        .reset = 0xfffffc000000,
        .ro = 0xffff000003ffffffL,
    },{ .name = "POR_HNF_ABF_LO_ADDR_U_HNF_NID136",
        .addr = A_POR_HNF_ABF_LO_ADDR_U_HNF_NID136,
        .ro = 0xffff000000000000L,
    },{ .name = "POR_HNF_ABF_HI_ADDR_U_HNF_NID136",
        .addr = A_POR_HNF_ABF_HI_ADDR_U_HNF_NID136,
        .ro = 0xffff000000000000L,
    },{ .name = "POR_HNF_ABF_PR_U_HNF_NID136",
        .addr = A_POR_HNF_ABF_PR_U_HNF_NID136,
        .rsvd = 0xfffffffffffffff8L,
        .ro = 0xfffffffffffffff8L,
    },{ .name = "POR_HNF_ABF_SR_U_HNF_NID136",
        .addr = A_POR_HNF_ABF_SR_U_HNF_NID136,
        .rsvd = 0xfffffffffffffff0L,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_HNF_RN_PHYS_ID59_U_HNF_NID136",
        .addr = A_POR_HNF_RN_PHYS_ID59_U_HNF_NID136,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID60_U_HNF_NID136",
        .addr = A_POR_HNF_RN_PHYS_ID60_U_HNF_NID136,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID61_U_HNF_NID136",
        .addr = A_POR_HNF_RN_PHYS_ID61_U_HNF_NID136,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID62_U_HNF_NID136",
        .addr = A_POR_HNF_RN_PHYS_ID62_U_HNF_NID136,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID63_U_HNF_NID136",
        .addr = A_POR_HNF_RN_PHYS_ID63_U_HNF_NID136,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_LDID_MAP_TABLE_REG0_U_HNF_NID136",
        .addr = A_POR_HNF_LDID_MAP_TABLE_REG0_U_HNF_NID136,
        .ro = 0x7f80f8007f80f800,
    },{ .name = "POR_HNF_LDID_MAP_TABLE_REG1_U_HNF_NID136",
        .addr = A_POR_HNF_LDID_MAP_TABLE_REG1_U_HNF_NID136,
        .ro = 0x7f80f8007f80f800,
    },{ .name = "POR_HNF_LDID_MAP_TABLE_REG2_U_HNF_NID136",
        .addr = A_POR_HNF_LDID_MAP_TABLE_REG2_U_HNF_NID136,
        .ro = 0x7f80f8007f80f800,
    },{ .name = "POR_HNF_LDID_MAP_TABLE_REG3_U_HNF_NID136",
        .addr = A_POR_HNF_LDID_MAP_TABLE_REG3_U_HNF_NID136,
        .ro = 0x7f80f8007f80f800,
    },{ .name = "POR_HNF_PPU_PWPR_U_HNF_NID136",
        .addr = A_POR_HNF_PPU_PWPR_U_HNF_NID136,
        .ro = 0xfffffe00,
    },{ .name = "POR_HNF_PPU_PWSR_U_HNF_NID136",
        .addr = A_POR_HNF_PPU_PWSR_U_HNF_NID136,
        .ro = 0xffffffff,
    },{ .name = "POR_HNF_PPU_MISR_U_HNF_NID136",
        .addr = A_POR_HNF_PPU_MISR_U_HNF_NID136,
        .rsvd = 0xfffffffe,
        .ro = 0xffffffff,
    },{ .name = "POR_HNF_PPU_DYN_RET_THRESHOLD_U_HNF_NID136",
        .addr = A_POR_HNF_PPU_DYN_RET_THRESHOLD_U_HNF_NID136,
        .ro = 0xfffffffffffff000L,
    },{ .name = "POR_HNF_PPU_IDR0_U_HNF_NID136",
        .addr = A_POR_HNF_PPU_IDR0_U_HNF_NID136,
        .reset = 0x801a540,
        .ro = 0xffffffff,
    },{ .name = "POR_HNF_PPU_IDR1_U_HNF_NID136",
        .addr = A_POR_HNF_PPU_IDR1_U_HNF_NID136,
        .rsvd = 0xfffffff0,
        .ro = 0xffffffff,
    },{ .name = "POR_HNF_PPU_IIDR_U_HNF_NID136",
        .addr = A_POR_HNF_PPU_IIDR_U_HNF_NID136,
        .reset = 0x4340043b,
        .ro = 0xffffffff,
    },{ .name = "POR_HNF_PPU_AIDR_U_HNF_NID136",
        .addr = A_POR_HNF_PPU_AIDR_U_HNF_NID136,
        .reset = 0x11,
        .rsvd = 0xffffff00,
        .ro = 0xffffffff,
    },{ .name = "POR_HNF_PMU_EVENT_SEL_U_HNF_NID136",
        .addr = A_POR_HNF_PMU_EVENT_SEL_U_HNF_NID136,
        .rsvd = 0xe0,
        .ro = 0xfffffff8e0e0e0e0L,
    },{ .name = "POR_HNF_ERRFR_U_HNF_NID136",
        .addr = A_POR_HNF_ERRFR_U_HNF_NID136,
        .reset = 0x48a5,
        .rsvd = 0x300,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_HNF_ERRCTLR_U_HNF_NID136",
        .addr = A_POR_HNF_ERRCTLR_U_HNF_NID136,
        .rsvd = 0xf0,
        .ro = 0xfffffffffffffef0L,
    },{ .name = "POR_HNF_ERRSTATUS_U_HNF_NID136",
        .addr = A_POR_HNF_ERRSTATUS_U_HNF_NID136,
        .ro = 0xffffffff127fffffL,
    },{ .name = "POR_HNF_ERRADDR_U_HNF_NID136",
        .addr = A_POR_HNF_ERRADDR_U_HNF_NID136,
        .ro = 0x7fff000000000000,
    },{ .name = "POR_HNF_ERRMISC_U_HNF_NID136",
        .addr = A_POR_HNF_ERRMISC_U_HNF_NID136,
        .ro = 0x20000000fffc8000,
    },{ .name = "POR_HNF_ERR_INJ_U_HNF_NID136",
        .addr = A_POR_HNF_ERR_INJ_U_HNF_NID136,
        .rsvd = 0xe,
        .ro = 0xfffffffff800fe0eL,
    },{ .name = "POR_HNF_BYTE_PAR_ERR_INJ_U_HNF_NID136",
        .addr = A_POR_HNF_BYTE_PAR_ERR_INJ_U_HNF_NID136,
        .rsvd = 0xffffffffffffffe0L,
        .ro = 0xffffffffffffffe0L,
    },{ .name = "POR_HNF_ERRFR_NS_U_HNF_NID136",
        .addr = A_POR_HNF_ERRFR_NS_U_HNF_NID136,
        .reset = 0x48a5,
        .rsvd = 0x300,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_HNF_ERRCTLR_NS_U_HNF_NID136",
        .addr = A_POR_HNF_ERRCTLR_NS_U_HNF_NID136,
        .rsvd = 0xf0,
        .ro = 0xfffffffffffffef0L,
    },{ .name = "POR_HNF_ERRSTATUS_NS_U_HNF_NID136",
        .addr = A_POR_HNF_ERRSTATUS_NS_U_HNF_NID136,
        .ro = 0xffffffff127fffffL,
    },{ .name = "POR_HNF_ERRADDR_NS_U_HNF_NID136",
        .addr = A_POR_HNF_ERRADDR_NS_U_HNF_NID136,
        .ro = 0x7fff000000000000,
    },{ .name = "POR_HNF_ERRMISC_NS_U_HNF_NID136",
        .addr = A_POR_HNF_ERRMISC_NS_U_HNF_NID136,
        .ro = 0x20000000fffc8000,
    },{ .name = "POR_MXP_NODE_INFO_U_SMXP_2_1",
        .addr = A_POR_MXP_NODE_INFO_U_SMXP_2_1,
        .reset = 0x1080006,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_DEVICE_PORT_CONNECT_INFO_P0_U_SMXP_2_1",
        .addr = A_POR_MXP_DEVICE_PORT_CONNECT_INFO_P0_U_SMXP_2_1,
        .reset = 0xd,
        .rsvd = 0xffe0,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_DEVICE_PORT_CONNECT_INFO_P1_U_SMXP_2_1",
        .addr = A_POR_MXP_DEVICE_PORT_CONNECT_INFO_P1_U_SMXP_2_1,
        .reset = 0x1,
        .rsvd = 0xffe0,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_MESH_PORT_CONNECT_INFO_EAST_U_SMXP_2_1",
        .addr = A_POR_MXP_MESH_PORT_CONNECT_INFO_EAST_U_SMXP_2_1,
        .rsvd = 0xfffffffffffffff0L,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_MESH_PORT_CONNECT_INFO_NORTH_U_SMXP_2_1",
        .addr = A_POR_MXP_MESH_PORT_CONNECT_INFO_NORTH_U_SMXP_2_1,
        .rsvd = 0xfffffffffffffff0L,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_INFO_U_SMXP_2_1",
        .addr = A_POR_MXP_CHILD_INFO_U_SMXP_2_1,
        .reset = 0x1000006,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_POINTER_0_U_SMXP_2_1",
        .addr = A_POR_MXP_CHILD_POINTER_0_U_SMXP_2_1,
        .reset = 0x8212c000,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_POINTER_1_U_SMXP_2_1",
        .addr = A_POR_MXP_CHILD_POINTER_1_U_SMXP_2_1,
        .reset = 0x8213c000,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_POINTER_2_U_SMXP_2_1",
        .addr = A_POR_MXP_CHILD_POINTER_2_U_SMXP_2_1,
        .reset = 0x2168000,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_POINTER_3_U_SMXP_2_1",
        .addr = A_POR_MXP_CHILD_POINTER_3_U_SMXP_2_1,
        .reset = 0x821d0000,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_POINTER_4_U_SMXP_2_1",
        .addr = A_POR_MXP_CHILD_POINTER_4_U_SMXP_2_1,
        .reset = 0x82120000,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_POINTER_5_U_SMXP_2_1",
        .addr = A_POR_MXP_CHILD_POINTER_5_U_SMXP_2_1,
        .reset = 0x2150000,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_POINTER_6_U_SMXP_2_1",
        .addr = A_POR_MXP_CHILD_POINTER_6_U_SMXP_2_1,
        .reset = 0x2110000,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_POINTER_7_U_SMXP_2_1",
        .addr = A_POR_MXP_CHILD_POINTER_7_U_SMXP_2_1,
        .reset = 0x2100000,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_POINTER_8_U_SMXP_2_1",
        .addr = A_POR_MXP_CHILD_POINTER_8_U_SMXP_2_1,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_POINTER_9_U_SMXP_2_1",
        .addr = A_POR_MXP_CHILD_POINTER_9_U_SMXP_2_1,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_POINTER_10_U_SMXP_2_1",
        .addr = A_POR_MXP_CHILD_POINTER_10_U_SMXP_2_1,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_POINTER_11_U_SMXP_2_1",
        .addr = A_POR_MXP_CHILD_POINTER_11_U_SMXP_2_1,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_POINTER_12_U_SMXP_2_1",
        .addr = A_POR_MXP_CHILD_POINTER_12_U_SMXP_2_1,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_POINTER_13_U_SMXP_2_1",
        .addr = A_POR_MXP_CHILD_POINTER_13_U_SMXP_2_1,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_POINTER_14_U_SMXP_2_1",
        .addr = A_POR_MXP_CHILD_POINTER_14_U_SMXP_2_1,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_POINTER_15_U_SMXP_2_1",
        .addr = A_POR_MXP_CHILD_POINTER_15_U_SMXP_2_1,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_P0_INFO_U_SMXP_2_1",
        .addr = A_POR_MXP_P0_INFO_U_SMXP_2_1,
        .reset = 0x211,
        .rsvd = 0x48,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_P1_INFO_U_SMXP_2_1",
        .addr = A_POR_MXP_P1_INFO_U_SMXP_2_1,
        .reset = 0x211,
        .rsvd = 0x48,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_SECURE_REGISTER_GROUPS_OVERRIDE_U_SMXP_2_1",
        .addr = A_POR_MXP_SECURE_REGISTER_GROUPS_OVERRIDE_U_SMXP_2_1,
        .rsvd = 0xfffffffffffffffcL,
        .ro = 0xfffffffffffffffcL,
    },{ .name = "POR_MXP_AUX_CTL_U_SMXP_2_1",
        .addr = A_POR_MXP_AUX_CTL_U_SMXP_2_1,
        .rsvd = 0xfffffffffffffffeL,
        .ro = 0xfffffffffffffffeL,
    },{ .name = "POR_MXP_P0_QOS_CONTROL_U_SMXP_2_1",
        .addr = A_POR_MXP_P0_QOS_CONTROL_U_SMXP_2_1,
        .rsvd = 0xffaa,
        .ro = 0xfffffffffff0ffaaL,
    },{ .name = "POR_MXP_P0_QOS_LAT_TGT_U_SMXP_2_1",
        .addr = A_POR_MXP_P0_QOS_LAT_TGT_U_SMXP_2_1,
        .ro = 0xfffffffffffff000L,
    },{ .name = "POR_MXP_P0_QOS_LAT_SCALE_U_SMXP_2_1",
        .addr = A_POR_MXP_P0_QOS_LAT_SCALE_U_SMXP_2_1,
        .rsvd = 0xfffffffffffffff8L,
        .ro = 0xfffffffffffffff8L,
    },{ .name = "POR_MXP_P0_QOS_LAT_RANGE_U_SMXP_2_1",
        .addr = A_POR_MXP_P0_QOS_LAT_RANGE_U_SMXP_2_1,
        .rsvd = 0xf0,
        .ro = 0xfffffffffffff0f0L,
    },{ .name = "POR_MXP_P1_QOS_CONTROL_U_SMXP_2_1",
        .addr = A_POR_MXP_P1_QOS_CONTROL_U_SMXP_2_1,
        .rsvd = 0xffaa,
        .ro = 0xfffffffffff0ffaaL,
    },{ .name = "POR_MXP_P1_QOS_LAT_TGT_U_SMXP_2_1",
        .addr = A_POR_MXP_P1_QOS_LAT_TGT_U_SMXP_2_1,
        .ro = 0xfffffffffffff000L,
    },{ .name = "POR_MXP_P1_QOS_LAT_SCALE_U_SMXP_2_1",
        .addr = A_POR_MXP_P1_QOS_LAT_SCALE_U_SMXP_2_1,
        .rsvd = 0xfffffffffffffff8L,
        .ro = 0xfffffffffffffff8L,
    },{ .name = "POR_MXP_P1_QOS_LAT_RANGE_U_SMXP_2_1",
        .addr = A_POR_MXP_P1_QOS_LAT_RANGE_U_SMXP_2_1,
        .rsvd = 0xf0,
        .ro = 0xfffffffffffff0f0L,
    },{ .name = "POR_MXP_P0_SYSCOREQ_CTL_U_SMXP_2_1",
        .addr = A_POR_MXP_P0_SYSCOREQ_CTL_U_SMXP_2_1,
        .rsvd = 0xfffffffffffffff0L,
        .ro = 0xfffffffffffffff0L,
    },{ .name = "POR_MXP_P1_SYSCOREQ_CTL_U_SMXP_2_1",
        .addr = A_POR_MXP_P1_SYSCOREQ_CTL_U_SMXP_2_1,
        .rsvd = 0xfffffffffffffff0L,
        .ro = 0xfffffffffffffff0L,
    },{ .name = "POR_MXP_P0_SYSCOACK_STATUS_U_SMXP_2_1",
        .addr = A_POR_MXP_P0_SYSCOACK_STATUS_U_SMXP_2_1,
        .rsvd = 0xfffffffffffffff0L,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_P1_SYSCOACK_STATUS_U_SMXP_2_1",
        .addr = A_POR_MXP_P1_SYSCOACK_STATUS_U_SMXP_2_1,
        .rsvd = 0xfffffffffffffff0L,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_PMU_EVENT_SEL_U_SMXP_2_1",
        .addr = A_POR_MXP_PMU_EVENT_SEL_U_SMXP_2_1,
        .ro = 0xffffffff00000000L,
    },{ .name = "POR_DTM_CONTROL_U_SMXP_2_1",
        .addr = A_POR_DTM_CONTROL_U_SMXP_2_1,
        .rsvd = 0xfffffffffffffff0L,
        .ro = 0xfffffffffffffff0L,
    },{ .name = "POR_DTM_FIFO_ENTRY_READY_U_SMXP_2_1",
        .addr = A_POR_DTM_FIFO_ENTRY_READY_U_SMXP_2_1,
        .rsvd = 0xfffffffffffffff0L,
        .ro = 0xfffffffffffffff0L,
    },{ .name = "POR_DTM_FIFO_ENTRY0_0_U_SMXP_2_1",
        .addr = A_POR_DTM_FIFO_ENTRY0_0_U_SMXP_2_1,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_DTM_FIFO_ENTRY0_1_U_SMXP_2_1",
        .addr = A_POR_DTM_FIFO_ENTRY0_1_U_SMXP_2_1,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_DTM_FIFO_ENTRY0_2_U_SMXP_2_1",
        .addr = A_POR_DTM_FIFO_ENTRY0_2_U_SMXP_2_1,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_DTM_FIFO_ENTRY1_0_U_SMXP_2_1",
        .addr = A_POR_DTM_FIFO_ENTRY1_0_U_SMXP_2_1,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_DTM_FIFO_ENTRY1_1_U_SMXP_2_1",
        .addr = A_POR_DTM_FIFO_ENTRY1_1_U_SMXP_2_1,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_DTM_FIFO_ENTRY1_2_U_SMXP_2_1",
        .addr = A_POR_DTM_FIFO_ENTRY1_2_U_SMXP_2_1,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_DTM_FIFO_ENTRY2_0_U_SMXP_2_1",
        .addr = A_POR_DTM_FIFO_ENTRY2_0_U_SMXP_2_1,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_DTM_FIFO_ENTRY2_1_U_SMXP_2_1",
        .addr = A_POR_DTM_FIFO_ENTRY2_1_U_SMXP_2_1,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_DTM_FIFO_ENTRY2_2_U_SMXP_2_1",
        .addr = A_POR_DTM_FIFO_ENTRY2_2_U_SMXP_2_1,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_DTM_FIFO_ENTRY3_0_U_SMXP_2_1",
        .addr = A_POR_DTM_FIFO_ENTRY3_0_U_SMXP_2_1,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_DTM_FIFO_ENTRY3_1_U_SMXP_2_1",
        .addr = A_POR_DTM_FIFO_ENTRY3_1_U_SMXP_2_1,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_DTM_FIFO_ENTRY3_2_U_SMXP_2_1",
        .addr = A_POR_DTM_FIFO_ENTRY3_2_U_SMXP_2_1,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_DTM_WP0_CONFIG_U_SMXP_2_1",
        .addr = A_POR_DTM_WP0_CONFIG_U_SMXP_2_1,
        .rsvd = 0x80,
        .ro = 0xffffffffffff8080L,
    },{ .name = "POR_DTM_WP0_VAL_U_SMXP_2_1",
        .addr = A_POR_DTM_WP0_VAL_U_SMXP_2_1,
    },{ .name = "POR_DTM_WP0_MASK_U_SMXP_2_1",
        .addr = A_POR_DTM_WP0_MASK_U_SMXP_2_1,
    },{ .name = "POR_DTM_WP1_CONFIG_U_SMXP_2_1",
        .addr = A_POR_DTM_WP1_CONFIG_U_SMXP_2_1,
        .rsvd = 0xc0,
        .ro = 0xffffffffffff80c0L,
    },{ .name = "POR_DTM_WP1_VAL_U_SMXP_2_1",
        .addr = A_POR_DTM_WP1_VAL_U_SMXP_2_1,
    },{ .name = "POR_DTM_WP1_MASK_U_SMXP_2_1",
        .addr = A_POR_DTM_WP1_MASK_U_SMXP_2_1,
    },{ .name = "POR_DTM_WP2_CONFIG_U_SMXP_2_1",
        .addr = A_POR_DTM_WP2_CONFIG_U_SMXP_2_1,
        .rsvd = 0x80,
        .ro = 0xffffffffffff8080L,
    },{ .name = "POR_DTM_WP2_VAL_U_SMXP_2_1",
        .addr = A_POR_DTM_WP2_VAL_U_SMXP_2_1,
    },{ .name = "POR_DTM_WP2_MASK_U_SMXP_2_1",
        .addr = A_POR_DTM_WP2_MASK_U_SMXP_2_1,
    },{ .name = "POR_DTM_WP3_CONFIG_U_SMXP_2_1",
        .addr = A_POR_DTM_WP3_CONFIG_U_SMXP_2_1,
        .rsvd = 0xc0,
        .ro = 0xffffffffffff80c0L,
    },{ .name = "POR_DTM_WP3_VAL_U_SMXP_2_1",
        .addr = A_POR_DTM_WP3_VAL_U_SMXP_2_1,
    },{ .name = "POR_DTM_WP3_MASK_U_SMXP_2_1",
        .addr = A_POR_DTM_WP3_MASK_U_SMXP_2_1,
    },{ .name = "POR_DTM_PMSICR_U_SMXP_2_1",
        .addr = A_POR_DTM_PMSICR_U_SMXP_2_1,
        .ro = 0xffffffff00000000L,
    },{ .name = "POR_DTM_PMSIRR_U_SMXP_2_1",
        .addr = A_POR_DTM_PMSIRR_U_SMXP_2_1,
        .ro = 0xffffffff000000ffL,
    },{ .name = "POR_DTM_PMU_CONFIG_U_SMXP_2_1",
        .addr = A_POR_DTM_PMU_CONFIG_U_SMXP_2_1,
        .ro = 0xc0c0c0c08888fe00L,
    },{ .name = "POR_DTM_PMEVCNT_U_SMXP_2_1",
        .addr = A_POR_DTM_PMEVCNT_U_SMXP_2_1,
    },{ .name = "POR_DTM_PMEVCNTSR_U_SMXP_2_1",
        .addr = A_POR_DTM_PMEVCNTSR_U_SMXP_2_1,
    },{ .name = "POR_MXP_ERRFR_U_SMXP_2_1",  .addr = A_POR_MXP_ERRFR_U_SMXP_2_1,
        .rsvd = 0x300,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_ERRCTLR_U_SMXP_2_1",
        .addr = A_POR_MXP_ERRCTLR_U_SMXP_2_1,
        .rsvd = 0xf0,
        .ro = 0xfffffffffffffef0L,
    },{ .name = "POR_MXP_ERRSTATUS_U_SMXP_2_1",
        .addr = A_POR_MXP_ERRSTATUS_U_SMXP_2_1,
        .ro = 0xffffffff127fffffL,
    },{ .name = "POR_MXP_ERRMISC_U_SMXP_2_1",
        .addr = A_POR_MXP_ERRMISC_U_SMXP_2_1,
        .rsvd = 0x8,
        .ro = 0xf800ffffffc08008L,
    },{ .name = "POR_MXP_P0_BYTE_PAR_ERR_INJ_U_SMXP_2_1",
        .addr = A_POR_MXP_P0_BYTE_PAR_ERR_INJ_U_SMXP_2_1,
        .rsvd = 0xffffffffffffffe0L,
        .ro = 0xffffffffffffffe0L,
    },{ .name = "POR_MXP_P1_BYTE_PAR_ERR_INJ_U_SMXP_2_1",
        .addr = A_POR_MXP_P1_BYTE_PAR_ERR_INJ_U_SMXP_2_1,
        .rsvd = 0xffffffffffffffe0L,
        .ro = 0xffffffffffffffe0L,
    },{ .name = "POR_MXP_ERRFR_NS_U_SMXP_2_1",
        .addr = A_POR_MXP_ERRFR_NS_U_SMXP_2_1,
        .rsvd = 0x300,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_ERRCTLR_NS_U_SMXP_2_1",
        .addr = A_POR_MXP_ERRCTLR_NS_U_SMXP_2_1,
        .rsvd = 0xf0,
        .ro = 0xfffffffffffffef0L,
    },{ .name = "POR_MXP_ERRSTATUS_NS_U_SMXP_2_1",
        .addr = A_POR_MXP_ERRSTATUS_NS_U_SMXP_2_1,
        .ro = 0xffffffff127fffffL,
    },{ .name = "POR_MXP_ERRMISC_NS_U_SMXP_2_1",
        .addr = A_POR_MXP_ERRMISC_NS_U_SMXP_2_1,
        .rsvd = 0x8,
        .ro = 0xf800ffffffc08008L,
    },{ .name = "POR_FDC_NODE_INFO_U_SMXP_2_1",
        .addr = A_POR_FDC_NODE_INFO_U_SMXP_2_1,
        .reset = 0x201,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_FDC_CHILD_INFO_U_SMXP_2_1",
        .addr = A_POR_FDC_CHILD_INFO_U_SMXP_2_1,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_ERRFR_MXP_U_SMXP_2_1",  .addr = A_POR_ERRFR_MXP_U_SMXP_2_1,
        .reset = 0xa1,
        .rsvd = 0xffffffffffffff0cL,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_ERRCTLR_MXP_U_SMXP_2_1",
        .addr = A_POR_ERRCTLR_MXP_U_SMXP_2_1,
        .reset = 0xd,
        .rsvd = 0x3ff2,
        .ro = 0xffffffff00003ff2L,
    },{ .name = "POR_ERRSTATUS_MXP_U_SMXP_2_1",
        .addr = A_POR_ERRSTATUS_MXP_U_SMXP_2_1,
        .ro = 0xffffffff977f003fL,
    },{ .name = "POR_FDC_AUX_CTL_MXP_U_SMXP_2_1",
        .addr = A_POR_FDC_AUX_CTL_MXP_U_SMXP_2_1,
        .rsvd = 0xffffffffffffffe0L,
        .ro = 0xffffffffffffffefL,
    },{ .name = "POR_ERRFR_P0_D0_U_SMXP_2_1",
        .addr = A_POR_ERRFR_P0_D0_U_SMXP_2_1,
        .reset = 0xa1,
        .rsvd = 0xffffffffffffff0cL,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_ERRCTLR_P0_D0_U_SMXP_2_1",
        .addr = A_POR_ERRCTLR_P0_D0_U_SMXP_2_1,
        .reset = 0xd,
        .rsvd = 0x3ff2,
        .ro = 0xffffffff00003ff2L,
    },{ .name = "POR_ERRSTATUS_P0_D0_U_SMXP_2_1",
        .addr = A_POR_ERRSTATUS_P0_D0_U_SMXP_2_1,
        .ro = 0xffffffff977f003fL,
    },{ .name = "POR_FDC_AUX_CTL_P0_D0_U_SMXP_2_1",
        .addr = A_POR_FDC_AUX_CTL_P0_D0_U_SMXP_2_1,
        .rsvd = 0xffffffffffffffe0L,
        .ro = 0xffffffffffffffe0L,
    },{ .name = "POR_ERRFR_P0_D1_U_SMXP_2_1",
        .addr = A_POR_ERRFR_P0_D1_U_SMXP_2_1,
        .reset = 0xa1,
        .rsvd = 0xffffffffffffff0cL,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_ERRCTLR_P0_D1_U_SMXP_2_1",
        .addr = A_POR_ERRCTLR_P0_D1_U_SMXP_2_1,
        .reset = 0xd,
        .rsvd = 0x3ff2,
        .ro = 0xffffffff00003ff2L,
    },{ .name = "POR_ERRSTATUS_P0_D1_U_SMXP_2_1",
        .addr = A_POR_ERRSTATUS_P0_D1_U_SMXP_2_1,
        .ro = 0xffffffff977f003fL,
    },{ .name = "POR_FDC_AUX_CTL_P0_D1_U_SMXP_2_1",
        .addr = A_POR_FDC_AUX_CTL_P0_D1_U_SMXP_2_1,
        .rsvd = 0xffffffffffffffe0L,
        .ro = 0xffffffffffffffe0L,
    },{ .name = "POR_ERRFR_P0_D2_U_SMXP_2_1",
        .addr = A_POR_ERRFR_P0_D2_U_SMXP_2_1,
        .reset = 0xa1,
        .rsvd = 0xffffffffffffff0cL,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_ERRCTLR_P0_D2_U_SMXP_2_1",
        .addr = A_POR_ERRCTLR_P0_D2_U_SMXP_2_1,
        .reset = 0xd,
        .rsvd = 0x3ff2,
        .ro = 0xffffffff00003ff2L,
    },{ .name = "POR_ERRSTATUS_P0_D2_U_SMXP_2_1",
        .addr = A_POR_ERRSTATUS_P0_D2_U_SMXP_2_1,
        .ro = 0xffffffff977f003fL,
    },{ .name = "POR_FDC_AUX_CTL_P0_D2_U_SMXP_2_1",
        .addr = A_POR_FDC_AUX_CTL_P0_D2_U_SMXP_2_1,
        .rsvd = 0xffffffffffffffe0L,
        .ro = 0xffffffffffffffe0L,
    },{ .name = "POR_ERRFR_P0_D3_U_SMXP_2_1",
        .addr = A_POR_ERRFR_P0_D3_U_SMXP_2_1,
        .reset = 0xa1,
        .rsvd = 0xffffffffffffff0cL,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_ERRCTLR_P0_D3_U_SMXP_2_1",
        .addr = A_POR_ERRCTLR_P0_D3_U_SMXP_2_1,
        .reset = 0xd,
        .rsvd = 0x3ff2,
        .ro = 0xffffffff00003ff2L,
    },{ .name = "POR_ERRSTATUS_P0_D3_U_SMXP_2_1",
        .addr = A_POR_ERRSTATUS_P0_D3_U_SMXP_2_1,
        .ro = 0xffffffff977f003fL,
    },{ .name = "POR_FDC_AUX_CTL_P0_D3_U_SMXP_2_1",
        .addr = A_POR_FDC_AUX_CTL_P0_D3_U_SMXP_2_1,
        .rsvd = 0xffffffffffffffe0L,
        .ro = 0xffffffffffffffe0L,
    },{ .name = "POR_ERRFR_P1_D0_U_SMXP_2_1",
        .addr = A_POR_ERRFR_P1_D0_U_SMXP_2_1,
        .reset = 0xa1,
        .rsvd = 0xffffffffffffff0cL,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_ERRCTLR_P1_D0_U_SMXP_2_1",
        .addr = A_POR_ERRCTLR_P1_D0_U_SMXP_2_1,
        .reset = 0xd,
        .rsvd = 0x3ff2,
        .ro = 0xffffffff00003ff2L,
    },{ .name = "POR_ERRSTATUS_P1_D0_U_SMXP_2_1",
        .addr = A_POR_ERRSTATUS_P1_D0_U_SMXP_2_1,
        .ro = 0xffffffff977f003fL,
    },{ .name = "POR_FDC_AUX_CTL_P1_D0_U_SMXP_2_1",
        .addr = A_POR_FDC_AUX_CTL_P1_D0_U_SMXP_2_1,
        .rsvd = 0xffffffffffffffe0L,
        .ro = 0xffffffffffffffe0L,
    },{ .name = "POR_ERRFR_P1_D1_U_SMXP_2_1",
        .addr = A_POR_ERRFR_P1_D1_U_SMXP_2_1,
        .reset = 0xa1,
        .rsvd = 0xffffffffffffff0cL,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_ERRCTLR_P1_D1_U_SMXP_2_1",
        .addr = A_POR_ERRCTLR_P1_D1_U_SMXP_2_1,
        .reset = 0xd,
        .rsvd = 0x3ff2,
        .ro = 0xffffffff00003ff2L,
    },{ .name = "POR_ERRSTATUS_P1_D1_U_SMXP_2_1",
        .addr = A_POR_ERRSTATUS_P1_D1_U_SMXP_2_1,
        .ro = 0xffffffff977f003fL,
    },{ .name = "POR_FDC_AUX_CTL_P1_D1_U_SMXP_2_1",
        .addr = A_POR_FDC_AUX_CTL_P1_D1_U_SMXP_2_1,
        .rsvd = 0xffffffffffffffe0L,
        .ro = 0xffffffffffffffe0L,
    },{ .name = "POR_ERRFR_P1_D2_U_SMXP_2_1",
        .addr = A_POR_ERRFR_P1_D2_U_SMXP_2_1,
        .reset = 0xa1,
        .rsvd = 0xffffffffffffff0cL,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_ERRCTLR_P1_D2_U_SMXP_2_1",
        .addr = A_POR_ERRCTLR_P1_D2_U_SMXP_2_1,
        .reset = 0xd,
        .rsvd = 0x3ff2,
        .ro = 0xffffffff00003ff2L,
    },{ .name = "POR_ERRSTATUS_P1_D2_U_SMXP_2_1",
        .addr = A_POR_ERRSTATUS_P1_D2_U_SMXP_2_1,
        .ro = 0xffffffff977f003fL,
    },{ .name = "POR_FDC_AUX_CTL_P1_D2_U_SMXP_2_1",
        .addr = A_POR_FDC_AUX_CTL_P1_D2_U_SMXP_2_1,
        .rsvd = 0xffffffffffffffe0L,
        .ro = 0xffffffffffffffe0L,
    },{ .name = "POR_ERRFR_P1_D3_U_SMXP_2_1",
        .addr = A_POR_ERRFR_P1_D3_U_SMXP_2_1,
        .reset = 0xa1,
        .rsvd = 0xffffffffffffff0cL,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_ERRCTLR_P1_D3_U_SMXP_2_1",
        .addr = A_POR_ERRCTLR_P1_D3_U_SMXP_2_1,
        .reset = 0xd,
        .rsvd = 0x3ff2,
        .ro = 0xffffffff00003ff2L,
    },{ .name = "POR_ERRSTATUS_P1_D3_U_SMXP_2_1",
        .addr = A_POR_ERRSTATUS_P1_D3_U_SMXP_2_1,
        .ro = 0xffffffff977f003fL,
    },{ .name = "POR_FDC_AUX_CTL_P1_D3_U_SMXP_2_1",
        .addr = A_POR_FDC_AUX_CTL_P1_D3_U_SMXP_2_1,
        .rsvd = 0xffffffffffffffe0L,
        .ro = 0xffffffffffffffe0L,
    },{ .name = "POR_ERRINJECT_U_SMXP_2_1",  .addr = A_POR_ERRINJECT_U_SMXP_2_1,
        .rsvd = 0xffffffffffffff00L,
        .ro = 0xffffffffffffff00L,
    },{ .name = "POR_FDC_KEY_U_SMXP_2_1",  .addr = A_POR_FDC_KEY_U_SMXP_2_1,
        .reset = 0xbe,
        .rsvd = 0xffffffffffffff00L,
        .ro = 0xffffffffffffff00L,
    },{ .name = "POR_MPU_NODE_INFO_U_SMXP_2_1",
        .addr = A_POR_MPU_NODE_INFO_U_SMXP_2_1,
        .reset = 0x202,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MPU_CHILD_INFO_U_SMXP_2_1",
        .addr = A_POR_MPU_CHILD_INFO_U_SMXP_2_1,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MPU_UNIT_INFO_U_SMXP_2_1",
        .addr = A_POR_MPU_UNIT_INFO_U_SMXP_2_1,
        .reset = 0x20,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MPU_M0_CTL_U_SMXP_2_1",
        .addr = A_POR_MPU_M0_CTL_U_SMXP_2_1,
        .reset = 0x2,
        .rsvd = 0xfffffffffffffff8L,
        .ro = 0xfffffffffffffff8L,
    },{ .name = "POR_MPU_M0_PRBAR0_U_SMXP_2_1",
        .addr = A_POR_MPU_M0_PRBAR0_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR0_U_SMXP_2_1",
        .addr = A_POR_MPU_M0_PRLAR0_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR1_U_SMXP_2_1",
        .addr = A_POR_MPU_M0_PRBAR1_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR1_U_SMXP_2_1",
        .addr = A_POR_MPU_M0_PRLAR1_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR2_U_SMXP_2_1",
        .addr = A_POR_MPU_M0_PRBAR2_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR2_U_SMXP_2_1",
        .addr = A_POR_MPU_M0_PRLAR2_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR3_U_SMXP_2_1",
        .addr = A_POR_MPU_M0_PRBAR3_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR3_U_SMXP_2_1",
        .addr = A_POR_MPU_M0_PRLAR3_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR4_U_SMXP_2_1",
        .addr = A_POR_MPU_M0_PRBAR4_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR4_U_SMXP_2_1",
        .addr = A_POR_MPU_M0_PRLAR4_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR5_U_SMXP_2_1",
        .addr = A_POR_MPU_M0_PRBAR5_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR5_U_SMXP_2_1",
        .addr = A_POR_MPU_M0_PRLAR5_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR6_U_SMXP_2_1",
        .addr = A_POR_MPU_M0_PRBAR6_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR6_U_SMXP_2_1",
        .addr = A_POR_MPU_M0_PRLAR6_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR7_U_SMXP_2_1",
        .addr = A_POR_MPU_M0_PRBAR7_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR7_U_SMXP_2_1",
        .addr = A_POR_MPU_M0_PRLAR7_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR8_U_SMXP_2_1",
        .addr = A_POR_MPU_M0_PRBAR8_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR8_U_SMXP_2_1",
        .addr = A_POR_MPU_M0_PRLAR8_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR9_U_SMXP_2_1",
        .addr = A_POR_MPU_M0_PRBAR9_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR9_U_SMXP_2_1",
        .addr = A_POR_MPU_M0_PRLAR9_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR10_U_SMXP_2_1",
        .addr = A_POR_MPU_M0_PRBAR10_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR10_U_SMXP_2_1",
        .addr = A_POR_MPU_M0_PRLAR10_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR11_U_SMXP_2_1",
        .addr = A_POR_MPU_M0_PRBAR11_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR11_U_SMXP_2_1",
        .addr = A_POR_MPU_M0_PRLAR11_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR12_U_SMXP_2_1",
        .addr = A_POR_MPU_M0_PRBAR12_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR12_U_SMXP_2_1",
        .addr = A_POR_MPU_M0_PRLAR12_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR13_U_SMXP_2_1",
        .addr = A_POR_MPU_M0_PRBAR13_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR13_U_SMXP_2_1",
        .addr = A_POR_MPU_M0_PRLAR13_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR14_U_SMXP_2_1",
        .addr = A_POR_MPU_M0_PRBAR14_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR14_U_SMXP_2_1",
        .addr = A_POR_MPU_M0_PRLAR14_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR15_U_SMXP_2_1",
        .addr = A_POR_MPU_M0_PRBAR15_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR15_U_SMXP_2_1",
        .addr = A_POR_MPU_M0_PRLAR15_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR16_U_SMXP_2_1",
        .addr = A_POR_MPU_M0_PRBAR16_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR16_U_SMXP_2_1",
        .addr = A_POR_MPU_M0_PRLAR16_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR17_U_SMXP_2_1",
        .addr = A_POR_MPU_M0_PRBAR17_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR17_U_SMXP_2_1",
        .addr = A_POR_MPU_M0_PRLAR17_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR18_U_SMXP_2_1",
        .addr = A_POR_MPU_M0_PRBAR18_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR18_U_SMXP_2_1",
        .addr = A_POR_MPU_M0_PRLAR18_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR19_U_SMXP_2_1",
        .addr = A_POR_MPU_M0_PRBAR19_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR19_U_SMXP_2_1",
        .addr = A_POR_MPU_M0_PRLAR19_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR20_U_SMXP_2_1",
        .addr = A_POR_MPU_M0_PRBAR20_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR20_U_SMXP_2_1",
        .addr = A_POR_MPU_M0_PRLAR20_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR21_U_SMXP_2_1",
        .addr = A_POR_MPU_M0_PRBAR21_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR21_U_SMXP_2_1",
        .addr = A_POR_MPU_M0_PRLAR21_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR22_U_SMXP_2_1",
        .addr = A_POR_MPU_M0_PRBAR22_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR22_U_SMXP_2_1",
        .addr = A_POR_MPU_M0_PRLAR22_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR23_U_SMXP_2_1",
        .addr = A_POR_MPU_M0_PRBAR23_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR23_U_SMXP_2_1",
        .addr = A_POR_MPU_M0_PRLAR23_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR24_U_SMXP_2_1",
        .addr = A_POR_MPU_M0_PRBAR24_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR24_U_SMXP_2_1",
        .addr = A_POR_MPU_M0_PRLAR24_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR25_U_SMXP_2_1",
        .addr = A_POR_MPU_M0_PRBAR25_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR25_U_SMXP_2_1",
        .addr = A_POR_MPU_M0_PRLAR25_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR26_U_SMXP_2_1",
        .addr = A_POR_MPU_M0_PRBAR26_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR26_U_SMXP_2_1",
        .addr = A_POR_MPU_M0_PRLAR26_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR27_U_SMXP_2_1",
        .addr = A_POR_MPU_M0_PRBAR27_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR27_U_SMXP_2_1",
        .addr = A_POR_MPU_M0_PRLAR27_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR28_U_SMXP_2_1",
        .addr = A_POR_MPU_M0_PRBAR28_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR28_U_SMXP_2_1",
        .addr = A_POR_MPU_M0_PRLAR28_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR29_U_SMXP_2_1",
        .addr = A_POR_MPU_M0_PRBAR29_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR29_U_SMXP_2_1",
        .addr = A_POR_MPU_M0_PRLAR29_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR30_U_SMXP_2_1",
        .addr = A_POR_MPU_M0_PRBAR30_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR30_U_SMXP_2_1",
        .addr = A_POR_MPU_M0_PRLAR30_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR31_U_SMXP_2_1",
        .addr = A_POR_MPU_M0_PRBAR31_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR31_U_SMXP_2_1",
        .addr = A_POR_MPU_M0_PRLAR31_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_CTL_U_SMXP_2_1",
        .addr = A_POR_MPU_M1_CTL_U_SMXP_2_1,
        .reset = 0x2,
        .rsvd = 0xfffffffffffffff8L,
        .ro = 0xfffffffffffffff8L,
    },{ .name = "POR_MPU_M1_PRBAR0_U_SMXP_2_1",
        .addr = A_POR_MPU_M1_PRBAR0_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR0_U_SMXP_2_1",
        .addr = A_POR_MPU_M1_PRLAR0_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR1_U_SMXP_2_1",
        .addr = A_POR_MPU_M1_PRBAR1_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR1_U_SMXP_2_1",
        .addr = A_POR_MPU_M1_PRLAR1_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR2_U_SMXP_2_1",
        .addr = A_POR_MPU_M1_PRBAR2_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR2_U_SMXP_2_1",
        .addr = A_POR_MPU_M1_PRLAR2_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR3_U_SMXP_2_1",
        .addr = A_POR_MPU_M1_PRBAR3_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR3_U_SMXP_2_1",
        .addr = A_POR_MPU_M1_PRLAR3_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR4_U_SMXP_2_1",
        .addr = A_POR_MPU_M1_PRBAR4_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR4_U_SMXP_2_1",
        .addr = A_POR_MPU_M1_PRLAR4_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR5_U_SMXP_2_1",
        .addr = A_POR_MPU_M1_PRBAR5_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR5_U_SMXP_2_1",
        .addr = A_POR_MPU_M1_PRLAR5_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR6_U_SMXP_2_1",
        .addr = A_POR_MPU_M1_PRBAR6_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR6_U_SMXP_2_1",
        .addr = A_POR_MPU_M1_PRLAR6_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR7_U_SMXP_2_1",
        .addr = A_POR_MPU_M1_PRBAR7_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR7_U_SMXP_2_1",
        .addr = A_POR_MPU_M1_PRLAR7_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR8_U_SMXP_2_1",
        .addr = A_POR_MPU_M1_PRBAR8_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR8_U_SMXP_2_1",
        .addr = A_POR_MPU_M1_PRLAR8_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR9_U_SMXP_2_1",
        .addr = A_POR_MPU_M1_PRBAR9_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR9_U_SMXP_2_1",
        .addr = A_POR_MPU_M1_PRLAR9_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR10_U_SMXP_2_1",
        .addr = A_POR_MPU_M1_PRBAR10_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR10_U_SMXP_2_1",
        .addr = A_POR_MPU_M1_PRLAR10_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR11_U_SMXP_2_1",
        .addr = A_POR_MPU_M1_PRBAR11_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR11_U_SMXP_2_1",
        .addr = A_POR_MPU_M1_PRLAR11_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR12_U_SMXP_2_1",
        .addr = A_POR_MPU_M1_PRBAR12_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR12_U_SMXP_2_1",
        .addr = A_POR_MPU_M1_PRLAR12_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR13_U_SMXP_2_1",
        .addr = A_POR_MPU_M1_PRBAR13_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR13_U_SMXP_2_1",
        .addr = A_POR_MPU_M1_PRLAR13_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR14_U_SMXP_2_1",
        .addr = A_POR_MPU_M1_PRBAR14_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR14_U_SMXP_2_1",
        .addr = A_POR_MPU_M1_PRLAR14_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR15_U_SMXP_2_1",
        .addr = A_POR_MPU_M1_PRBAR15_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR15_U_SMXP_2_1",
        .addr = A_POR_MPU_M1_PRLAR15_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR16_U_SMXP_2_1",
        .addr = A_POR_MPU_M1_PRBAR16_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR16_U_SMXP_2_1",
        .addr = A_POR_MPU_M1_PRLAR16_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR17_U_SMXP_2_1",
        .addr = A_POR_MPU_M1_PRBAR17_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR17_U_SMXP_2_1",
        .addr = A_POR_MPU_M1_PRLAR17_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR18_U_SMXP_2_1",
        .addr = A_POR_MPU_M1_PRBAR18_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR18_U_SMXP_2_1",
        .addr = A_POR_MPU_M1_PRLAR18_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR19_U_SMXP_2_1",
        .addr = A_POR_MPU_M1_PRBAR19_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR19_U_SMXP_2_1",
        .addr = A_POR_MPU_M1_PRLAR19_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR20_U_SMXP_2_1",
        .addr = A_POR_MPU_M1_PRBAR20_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR20_U_SMXP_2_1",
        .addr = A_POR_MPU_M1_PRLAR20_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR21_U_SMXP_2_1",
        .addr = A_POR_MPU_M1_PRBAR21_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR21_U_SMXP_2_1",
        .addr = A_POR_MPU_M1_PRLAR21_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR22_U_SMXP_2_1",
        .addr = A_POR_MPU_M1_PRBAR22_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR22_U_SMXP_2_1",
        .addr = A_POR_MPU_M1_PRLAR22_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR23_U_SMXP_2_1",
        .addr = A_POR_MPU_M1_PRBAR23_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR23_U_SMXP_2_1",
        .addr = A_POR_MPU_M1_PRLAR23_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR24_U_SMXP_2_1",
        .addr = A_POR_MPU_M1_PRBAR24_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR24_U_SMXP_2_1",
        .addr = A_POR_MPU_M1_PRLAR24_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR25_U_SMXP_2_1",
        .addr = A_POR_MPU_M1_PRBAR25_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR25_U_SMXP_2_1",
        .addr = A_POR_MPU_M1_PRLAR25_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR26_U_SMXP_2_1",
        .addr = A_POR_MPU_M1_PRBAR26_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR26_U_SMXP_2_1",
        .addr = A_POR_MPU_M1_PRLAR26_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR27_U_SMXP_2_1",
        .addr = A_POR_MPU_M1_PRBAR27_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR27_U_SMXP_2_1",
        .addr = A_POR_MPU_M1_PRLAR27_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR28_U_SMXP_2_1",
        .addr = A_POR_MPU_M1_PRBAR28_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR28_U_SMXP_2_1",
        .addr = A_POR_MPU_M1_PRLAR28_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR29_U_SMXP_2_1",
        .addr = A_POR_MPU_M1_PRBAR29_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR29_U_SMXP_2_1",
        .addr = A_POR_MPU_M1_PRLAR29_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR30_U_SMXP_2_1",
        .addr = A_POR_MPU_M1_PRBAR30_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR30_U_SMXP_2_1",
        .addr = A_POR_MPU_M1_PRLAR30_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR31_U_SMXP_2_1",
        .addr = A_POR_MPU_M1_PRBAR31_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR31_U_SMXP_2_1",
        .addr = A_POR_MPU_M1_PRLAR31_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_CTL_U_SMXP_2_1",
        .addr = A_POR_MPU_M2_CTL_U_SMXP_2_1,
        .reset = 0x2,
        .rsvd = 0xfffffffffffffff8L,
        .ro = 0xfffffffffffffff8L,
    },{ .name = "POR_MPU_M2_PRBAR0_U_SMXP_2_1",
        .addr = A_POR_MPU_M2_PRBAR0_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR0_U_SMXP_2_1",
        .addr = A_POR_MPU_M2_PRLAR0_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR1_U_SMXP_2_1",
        .addr = A_POR_MPU_M2_PRBAR1_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR1_U_SMXP_2_1",
        .addr = A_POR_MPU_M2_PRLAR1_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR2_U_SMXP_2_1",
        .addr = A_POR_MPU_M2_PRBAR2_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR2_U_SMXP_2_1",
        .addr = A_POR_MPU_M2_PRLAR2_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR3_U_SMXP_2_1",
        .addr = A_POR_MPU_M2_PRBAR3_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR3_U_SMXP_2_1",
        .addr = A_POR_MPU_M2_PRLAR3_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR4_U_SMXP_2_1",
        .addr = A_POR_MPU_M2_PRBAR4_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR4_U_SMXP_2_1",
        .addr = A_POR_MPU_M2_PRLAR4_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR5_U_SMXP_2_1",
        .addr = A_POR_MPU_M2_PRBAR5_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR5_U_SMXP_2_1",
        .addr = A_POR_MPU_M2_PRLAR5_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR6_U_SMXP_2_1",
        .addr = A_POR_MPU_M2_PRBAR6_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR6_U_SMXP_2_1",
        .addr = A_POR_MPU_M2_PRLAR6_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR7_U_SMXP_2_1",
        .addr = A_POR_MPU_M2_PRBAR7_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR7_U_SMXP_2_1",
        .addr = A_POR_MPU_M2_PRLAR7_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR8_U_SMXP_2_1",
        .addr = A_POR_MPU_M2_PRBAR8_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR8_U_SMXP_2_1",
        .addr = A_POR_MPU_M2_PRLAR8_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR9_U_SMXP_2_1",
        .addr = A_POR_MPU_M2_PRBAR9_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR9_U_SMXP_2_1",
        .addr = A_POR_MPU_M2_PRLAR9_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR10_U_SMXP_2_1",
        .addr = A_POR_MPU_M2_PRBAR10_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR10_U_SMXP_2_1",
        .addr = A_POR_MPU_M2_PRLAR10_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR11_U_SMXP_2_1",
        .addr = A_POR_MPU_M2_PRBAR11_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR11_U_SMXP_2_1",
        .addr = A_POR_MPU_M2_PRLAR11_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR12_U_SMXP_2_1",
        .addr = A_POR_MPU_M2_PRBAR12_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR12_U_SMXP_2_1",
        .addr = A_POR_MPU_M2_PRLAR12_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR13_U_SMXP_2_1",
        .addr = A_POR_MPU_M2_PRBAR13_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR13_U_SMXP_2_1",
        .addr = A_POR_MPU_M2_PRLAR13_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR14_U_SMXP_2_1",
        .addr = A_POR_MPU_M2_PRBAR14_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR14_U_SMXP_2_1",
        .addr = A_POR_MPU_M2_PRLAR14_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR15_U_SMXP_2_1",
        .addr = A_POR_MPU_M2_PRBAR15_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR15_U_SMXP_2_1",
        .addr = A_POR_MPU_M2_PRLAR15_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR16_U_SMXP_2_1",
        .addr = A_POR_MPU_M2_PRBAR16_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR16_U_SMXP_2_1",
        .addr = A_POR_MPU_M2_PRLAR16_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR17_U_SMXP_2_1",
        .addr = A_POR_MPU_M2_PRBAR17_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR17_U_SMXP_2_1",
        .addr = A_POR_MPU_M2_PRLAR17_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR18_U_SMXP_2_1",
        .addr = A_POR_MPU_M2_PRBAR18_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR18_U_SMXP_2_1",
        .addr = A_POR_MPU_M2_PRLAR18_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR19_U_SMXP_2_1",
        .addr = A_POR_MPU_M2_PRBAR19_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR19_U_SMXP_2_1",
        .addr = A_POR_MPU_M2_PRLAR19_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR20_U_SMXP_2_1",
        .addr = A_POR_MPU_M2_PRBAR20_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR20_U_SMXP_2_1",
        .addr = A_POR_MPU_M2_PRLAR20_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR21_U_SMXP_2_1",
        .addr = A_POR_MPU_M2_PRBAR21_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR21_U_SMXP_2_1",
        .addr = A_POR_MPU_M2_PRLAR21_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR22_U_SMXP_2_1",
        .addr = A_POR_MPU_M2_PRBAR22_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR22_U_SMXP_2_1",
        .addr = A_POR_MPU_M2_PRLAR22_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR23_U_SMXP_2_1",
        .addr = A_POR_MPU_M2_PRBAR23_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR23_U_SMXP_2_1",
        .addr = A_POR_MPU_M2_PRLAR23_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR24_U_SMXP_2_1",
        .addr = A_POR_MPU_M2_PRBAR24_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR24_U_SMXP_2_1",
        .addr = A_POR_MPU_M2_PRLAR24_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR25_U_SMXP_2_1",
        .addr = A_POR_MPU_M2_PRBAR25_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR25_U_SMXP_2_1",
        .addr = A_POR_MPU_M2_PRLAR25_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR26_U_SMXP_2_1",
        .addr = A_POR_MPU_M2_PRBAR26_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR26_U_SMXP_2_1",
        .addr = A_POR_MPU_M2_PRLAR26_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR27_U_SMXP_2_1",
        .addr = A_POR_MPU_M2_PRBAR27_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR27_U_SMXP_2_1",
        .addr = A_POR_MPU_M2_PRLAR27_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR28_U_SMXP_2_1",
        .addr = A_POR_MPU_M2_PRBAR28_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR28_U_SMXP_2_1",
        .addr = A_POR_MPU_M2_PRLAR28_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR29_U_SMXP_2_1",
        .addr = A_POR_MPU_M2_PRBAR29_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR29_U_SMXP_2_1",
        .addr = A_POR_MPU_M2_PRLAR29_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR30_U_SMXP_2_1",
        .addr = A_POR_MPU_M2_PRBAR30_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR30_U_SMXP_2_1",
        .addr = A_POR_MPU_M2_PRLAR30_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR31_U_SMXP_2_1",
        .addr = A_POR_MPU_M2_PRBAR31_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR31_U_SMXP_2_1",
        .addr = A_POR_MPU_M2_PRLAR31_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_CTL_U_SMXP_2_1",
        .addr = A_POR_MPU_M3_CTL_U_SMXP_2_1,
        .reset = 0x2,
        .rsvd = 0xfffffffffffffff8L,
        .ro = 0xfffffffffffffff8L,
    },{ .name = "POR_MPU_M3_PRBAR0_U_SMXP_2_1",
        .addr = A_POR_MPU_M3_PRBAR0_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR0_U_SMXP_2_1",
        .addr = A_POR_MPU_M3_PRLAR0_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR1_U_SMXP_2_1",
        .addr = A_POR_MPU_M3_PRBAR1_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR1_U_SMXP_2_1",
        .addr = A_POR_MPU_M3_PRLAR1_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR2_U_SMXP_2_1",
        .addr = A_POR_MPU_M3_PRBAR2_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR2_U_SMXP_2_1",
        .addr = A_POR_MPU_M3_PRLAR2_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR3_U_SMXP_2_1",
        .addr = A_POR_MPU_M3_PRBAR3_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR3_U_SMXP_2_1",
        .addr = A_POR_MPU_M3_PRLAR3_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR4_U_SMXP_2_1",
        .addr = A_POR_MPU_M3_PRBAR4_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR4_U_SMXP_2_1",
        .addr = A_POR_MPU_M3_PRLAR4_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR5_U_SMXP_2_1",
        .addr = A_POR_MPU_M3_PRBAR5_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR5_U_SMXP_2_1",
        .addr = A_POR_MPU_M3_PRLAR5_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR6_U_SMXP_2_1",
        .addr = A_POR_MPU_M3_PRBAR6_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR6_U_SMXP_2_1",
        .addr = A_POR_MPU_M3_PRLAR6_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR7_U_SMXP_2_1",
        .addr = A_POR_MPU_M3_PRBAR7_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR7_U_SMXP_2_1",
        .addr = A_POR_MPU_M3_PRLAR7_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR8_U_SMXP_2_1",
        .addr = A_POR_MPU_M3_PRBAR8_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR8_U_SMXP_2_1",
        .addr = A_POR_MPU_M3_PRLAR8_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR9_U_SMXP_2_1",
        .addr = A_POR_MPU_M3_PRBAR9_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR9_U_SMXP_2_1",
        .addr = A_POR_MPU_M3_PRLAR9_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR10_U_SMXP_2_1",
        .addr = A_POR_MPU_M3_PRBAR10_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR10_U_SMXP_2_1",
        .addr = A_POR_MPU_M3_PRLAR10_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR11_U_SMXP_2_1",
        .addr = A_POR_MPU_M3_PRBAR11_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR11_U_SMXP_2_1",
        .addr = A_POR_MPU_M3_PRLAR11_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR12_U_SMXP_2_1",
        .addr = A_POR_MPU_M3_PRBAR12_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR12_U_SMXP_2_1",
        .addr = A_POR_MPU_M3_PRLAR12_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR13_U_SMXP_2_1",
        .addr = A_POR_MPU_M3_PRBAR13_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR13_U_SMXP_2_1",
        .addr = A_POR_MPU_M3_PRLAR13_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR14_U_SMXP_2_1",
        .addr = A_POR_MPU_M3_PRBAR14_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR14_U_SMXP_2_1",
        .addr = A_POR_MPU_M3_PRLAR14_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR15_U_SMXP_2_1",
        .addr = A_POR_MPU_M3_PRBAR15_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR15_U_SMXP_2_1",
        .addr = A_POR_MPU_M3_PRLAR15_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR16_U_SMXP_2_1",
        .addr = A_POR_MPU_M3_PRBAR16_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR16_U_SMXP_2_1",
        .addr = A_POR_MPU_M3_PRLAR16_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR17_U_SMXP_2_1",
        .addr = A_POR_MPU_M3_PRBAR17_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR17_U_SMXP_2_1",
        .addr = A_POR_MPU_M3_PRLAR17_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR18_U_SMXP_2_1",
        .addr = A_POR_MPU_M3_PRBAR18_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR18_U_SMXP_2_1",
        .addr = A_POR_MPU_M3_PRLAR18_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR19_U_SMXP_2_1",
        .addr = A_POR_MPU_M3_PRBAR19_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR19_U_SMXP_2_1",
        .addr = A_POR_MPU_M3_PRLAR19_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR20_U_SMXP_2_1",
        .addr = A_POR_MPU_M3_PRBAR20_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR20_U_SMXP_2_1",
        .addr = A_POR_MPU_M3_PRLAR20_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR21_U_SMXP_2_1",
        .addr = A_POR_MPU_M3_PRBAR21_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR21_U_SMXP_2_1",
        .addr = A_POR_MPU_M3_PRLAR21_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR22_U_SMXP_2_1",
        .addr = A_POR_MPU_M3_PRBAR22_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR22_U_SMXP_2_1",
        .addr = A_POR_MPU_M3_PRLAR22_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR23_U_SMXP_2_1",
        .addr = A_POR_MPU_M3_PRBAR23_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR23_U_SMXP_2_1",
        .addr = A_POR_MPU_M3_PRLAR23_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR24_U_SMXP_2_1",
        .addr = A_POR_MPU_M3_PRBAR24_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR24_U_SMXP_2_1",
        .addr = A_POR_MPU_M3_PRLAR24_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR25_U_SMXP_2_1",
        .addr = A_POR_MPU_M3_PRBAR25_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR25_U_SMXP_2_1",
        .addr = A_POR_MPU_M3_PRLAR25_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR26_U_SMXP_2_1",
        .addr = A_POR_MPU_M3_PRBAR26_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR26_U_SMXP_2_1",
        .addr = A_POR_MPU_M3_PRLAR26_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR27_U_SMXP_2_1",
        .addr = A_POR_MPU_M3_PRBAR27_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR27_U_SMXP_2_1",
        .addr = A_POR_MPU_M3_PRLAR27_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR28_U_SMXP_2_1",
        .addr = A_POR_MPU_M3_PRBAR28_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR28_U_SMXP_2_1",
        .addr = A_POR_MPU_M3_PRLAR28_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR29_U_SMXP_2_1",
        .addr = A_POR_MPU_M3_PRBAR29_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR29_U_SMXP_2_1",
        .addr = A_POR_MPU_M3_PRLAR29_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR30_U_SMXP_2_1",
        .addr = A_POR_MPU_M3_PRBAR30_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR30_U_SMXP_2_1",
        .addr = A_POR_MPU_M3_PRLAR30_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR31_U_SMXP_2_1",
        .addr = A_POR_MPU_M3_PRBAR31_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR31_U_SMXP_2_1",
        .addr = A_POR_MPU_M3_PRLAR31_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_CTL_U_SMXP_2_1",
        .addr = A_POR_MPU_M4_CTL_U_SMXP_2_1,
        .reset = 0x2,
        .rsvd = 0xfffffffffffffff8L,
        .ro = 0xfffffffffffffff8L,
    },{ .name = "POR_MPU_M4_PRBAR0_U_SMXP_2_1",
        .addr = A_POR_MPU_M4_PRBAR0_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR0_U_SMXP_2_1",
        .addr = A_POR_MPU_M4_PRLAR0_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR1_U_SMXP_2_1",
        .addr = A_POR_MPU_M4_PRBAR1_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR1_U_SMXP_2_1",
        .addr = A_POR_MPU_M4_PRLAR1_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR2_U_SMXP_2_1",
        .addr = A_POR_MPU_M4_PRBAR2_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR2_U_SMXP_2_1",
        .addr = A_POR_MPU_M4_PRLAR2_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR3_U_SMXP_2_1",
        .addr = A_POR_MPU_M4_PRBAR3_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR3_U_SMXP_2_1",
        .addr = A_POR_MPU_M4_PRLAR3_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR4_U_SMXP_2_1",
        .addr = A_POR_MPU_M4_PRBAR4_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR4_U_SMXP_2_1",
        .addr = A_POR_MPU_M4_PRLAR4_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR5_U_SMXP_2_1",
        .addr = A_POR_MPU_M4_PRBAR5_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR5_U_SMXP_2_1",
        .addr = A_POR_MPU_M4_PRLAR5_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR6_U_SMXP_2_1",
        .addr = A_POR_MPU_M4_PRBAR6_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR6_U_SMXP_2_1",
        .addr = A_POR_MPU_M4_PRLAR6_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR7_U_SMXP_2_1",
        .addr = A_POR_MPU_M4_PRBAR7_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR7_U_SMXP_2_1",
        .addr = A_POR_MPU_M4_PRLAR7_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR8_U_SMXP_2_1",
        .addr = A_POR_MPU_M4_PRBAR8_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR8_U_SMXP_2_1",
        .addr = A_POR_MPU_M4_PRLAR8_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR9_U_SMXP_2_1",
        .addr = A_POR_MPU_M4_PRBAR9_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR9_U_SMXP_2_1",
        .addr = A_POR_MPU_M4_PRLAR9_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR10_U_SMXP_2_1",
        .addr = A_POR_MPU_M4_PRBAR10_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR10_U_SMXP_2_1",
        .addr = A_POR_MPU_M4_PRLAR10_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR11_U_SMXP_2_1",
        .addr = A_POR_MPU_M4_PRBAR11_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR11_U_SMXP_2_1",
        .addr = A_POR_MPU_M4_PRLAR11_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR12_U_SMXP_2_1",
        .addr = A_POR_MPU_M4_PRBAR12_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR12_U_SMXP_2_1",
        .addr = A_POR_MPU_M4_PRLAR12_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR13_U_SMXP_2_1",
        .addr = A_POR_MPU_M4_PRBAR13_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR13_U_SMXP_2_1",
        .addr = A_POR_MPU_M4_PRLAR13_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR14_U_SMXP_2_1",
        .addr = A_POR_MPU_M4_PRBAR14_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR14_U_SMXP_2_1",
        .addr = A_POR_MPU_M4_PRLAR14_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR15_U_SMXP_2_1",
        .addr = A_POR_MPU_M4_PRBAR15_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR15_U_SMXP_2_1",
        .addr = A_POR_MPU_M4_PRLAR15_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR16_U_SMXP_2_1",
        .addr = A_POR_MPU_M4_PRBAR16_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR16_U_SMXP_2_1",
        .addr = A_POR_MPU_M4_PRLAR16_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR17_U_SMXP_2_1",
        .addr = A_POR_MPU_M4_PRBAR17_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR17_U_SMXP_2_1",
        .addr = A_POR_MPU_M4_PRLAR17_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR18_U_SMXP_2_1",
        .addr = A_POR_MPU_M4_PRBAR18_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR18_U_SMXP_2_1",
        .addr = A_POR_MPU_M4_PRLAR18_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR19_U_SMXP_2_1",
        .addr = A_POR_MPU_M4_PRBAR19_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR19_U_SMXP_2_1",
        .addr = A_POR_MPU_M4_PRLAR19_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR20_U_SMXP_2_1",
        .addr = A_POR_MPU_M4_PRBAR20_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR20_U_SMXP_2_1",
        .addr = A_POR_MPU_M4_PRLAR20_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR21_U_SMXP_2_1",
        .addr = A_POR_MPU_M4_PRBAR21_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR21_U_SMXP_2_1",
        .addr = A_POR_MPU_M4_PRLAR21_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR22_U_SMXP_2_1",
        .addr = A_POR_MPU_M4_PRBAR22_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR22_U_SMXP_2_1",
        .addr = A_POR_MPU_M4_PRLAR22_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR23_U_SMXP_2_1",
        .addr = A_POR_MPU_M4_PRBAR23_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR23_U_SMXP_2_1",
        .addr = A_POR_MPU_M4_PRLAR23_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR24_U_SMXP_2_1",
        .addr = A_POR_MPU_M4_PRBAR24_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR24_U_SMXP_2_1",
        .addr = A_POR_MPU_M4_PRLAR24_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR25_U_SMXP_2_1",
        .addr = A_POR_MPU_M4_PRBAR25_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR25_U_SMXP_2_1",
        .addr = A_POR_MPU_M4_PRLAR25_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR26_U_SMXP_2_1",
        .addr = A_POR_MPU_M4_PRBAR26_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR26_U_SMXP_2_1",
        .addr = A_POR_MPU_M4_PRLAR26_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR27_U_SMXP_2_1",
        .addr = A_POR_MPU_M4_PRBAR27_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR27_U_SMXP_2_1",
        .addr = A_POR_MPU_M4_PRLAR27_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR28_U_SMXP_2_1",
        .addr = A_POR_MPU_M4_PRBAR28_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR28_U_SMXP_2_1",
        .addr = A_POR_MPU_M4_PRLAR28_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR29_U_SMXP_2_1",
        .addr = A_POR_MPU_M4_PRBAR29_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR29_U_SMXP_2_1",
        .addr = A_POR_MPU_M4_PRLAR29_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR30_U_SMXP_2_1",
        .addr = A_POR_MPU_M4_PRBAR30_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR30_U_SMXP_2_1",
        .addr = A_POR_MPU_M4_PRLAR30_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR31_U_SMXP_2_1",
        .addr = A_POR_MPU_M4_PRBAR31_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR31_U_SMXP_2_1",
        .addr = A_POR_MPU_M4_PRLAR31_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_CTL_U_SMXP_2_1",
        .addr = A_POR_MPU_M5_CTL_U_SMXP_2_1,
        .reset = 0x2,
        .rsvd = 0xfffffffffffffff8L,
        .ro = 0xfffffffffffffff8L,
    },{ .name = "POR_MPU_M5_PRBAR0_U_SMXP_2_1",
        .addr = A_POR_MPU_M5_PRBAR0_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR0_U_SMXP_2_1",
        .addr = A_POR_MPU_M5_PRLAR0_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR1_U_SMXP_2_1",
        .addr = A_POR_MPU_M5_PRBAR1_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR1_U_SMXP_2_1",
        .addr = A_POR_MPU_M5_PRLAR1_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR2_U_SMXP_2_1",
        .addr = A_POR_MPU_M5_PRBAR2_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR2_U_SMXP_2_1",
        .addr = A_POR_MPU_M5_PRLAR2_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR3_U_SMXP_2_1",
        .addr = A_POR_MPU_M5_PRBAR3_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR3_U_SMXP_2_1",
        .addr = A_POR_MPU_M5_PRLAR3_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR4_U_SMXP_2_1",
        .addr = A_POR_MPU_M5_PRBAR4_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR4_U_SMXP_2_1",
        .addr = A_POR_MPU_M5_PRLAR4_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR5_U_SMXP_2_1",
        .addr = A_POR_MPU_M5_PRBAR5_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR5_U_SMXP_2_1",
        .addr = A_POR_MPU_M5_PRLAR5_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR6_U_SMXP_2_1",
        .addr = A_POR_MPU_M5_PRBAR6_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR6_U_SMXP_2_1",
        .addr = A_POR_MPU_M5_PRLAR6_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR7_U_SMXP_2_1",
        .addr = A_POR_MPU_M5_PRBAR7_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR7_U_SMXP_2_1",
        .addr = A_POR_MPU_M5_PRLAR7_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR8_U_SMXP_2_1",
        .addr = A_POR_MPU_M5_PRBAR8_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR8_U_SMXP_2_1",
        .addr = A_POR_MPU_M5_PRLAR8_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR9_U_SMXP_2_1",
        .addr = A_POR_MPU_M5_PRBAR9_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR9_U_SMXP_2_1",
        .addr = A_POR_MPU_M5_PRLAR9_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR10_U_SMXP_2_1",
        .addr = A_POR_MPU_M5_PRBAR10_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR10_U_SMXP_2_1",
        .addr = A_POR_MPU_M5_PRLAR10_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR11_U_SMXP_2_1",
        .addr = A_POR_MPU_M5_PRBAR11_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR11_U_SMXP_2_1",
        .addr = A_POR_MPU_M5_PRLAR11_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR12_U_SMXP_2_1",
        .addr = A_POR_MPU_M5_PRBAR12_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR12_U_SMXP_2_1",
        .addr = A_POR_MPU_M5_PRLAR12_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR13_U_SMXP_2_1",
        .addr = A_POR_MPU_M5_PRBAR13_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR13_U_SMXP_2_1",
        .addr = A_POR_MPU_M5_PRLAR13_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR14_U_SMXP_2_1",
        .addr = A_POR_MPU_M5_PRBAR14_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR14_U_SMXP_2_1",
        .addr = A_POR_MPU_M5_PRLAR14_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR15_U_SMXP_2_1",
        .addr = A_POR_MPU_M5_PRBAR15_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR15_U_SMXP_2_1",
        .addr = A_POR_MPU_M5_PRLAR15_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR16_U_SMXP_2_1",
        .addr = A_POR_MPU_M5_PRBAR16_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR16_U_SMXP_2_1",
        .addr = A_POR_MPU_M5_PRLAR16_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR17_U_SMXP_2_1",
        .addr = A_POR_MPU_M5_PRBAR17_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR17_U_SMXP_2_1",
        .addr = A_POR_MPU_M5_PRLAR17_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR18_U_SMXP_2_1",
        .addr = A_POR_MPU_M5_PRBAR18_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR18_U_SMXP_2_1",
        .addr = A_POR_MPU_M5_PRLAR18_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR19_U_SMXP_2_1",
        .addr = A_POR_MPU_M5_PRBAR19_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR19_U_SMXP_2_1",
        .addr = A_POR_MPU_M5_PRLAR19_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR20_U_SMXP_2_1",
        .addr = A_POR_MPU_M5_PRBAR20_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR20_U_SMXP_2_1",
        .addr = A_POR_MPU_M5_PRLAR20_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR21_U_SMXP_2_1",
        .addr = A_POR_MPU_M5_PRBAR21_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR21_U_SMXP_2_1",
        .addr = A_POR_MPU_M5_PRLAR21_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR22_U_SMXP_2_1",
        .addr = A_POR_MPU_M5_PRBAR22_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR22_U_SMXP_2_1",
        .addr = A_POR_MPU_M5_PRLAR22_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR23_U_SMXP_2_1",
        .addr = A_POR_MPU_M5_PRBAR23_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR23_U_SMXP_2_1",
        .addr = A_POR_MPU_M5_PRLAR23_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR24_U_SMXP_2_1",
        .addr = A_POR_MPU_M5_PRBAR24_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR24_U_SMXP_2_1",
        .addr = A_POR_MPU_M5_PRLAR24_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR25_U_SMXP_2_1",
        .addr = A_POR_MPU_M5_PRBAR25_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR25_U_SMXP_2_1",
        .addr = A_POR_MPU_M5_PRLAR25_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR26_U_SMXP_2_1",
        .addr = A_POR_MPU_M5_PRBAR26_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR26_U_SMXP_2_1",
        .addr = A_POR_MPU_M5_PRLAR26_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR27_U_SMXP_2_1",
        .addr = A_POR_MPU_M5_PRBAR27_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR27_U_SMXP_2_1",
        .addr = A_POR_MPU_M5_PRLAR27_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR28_U_SMXP_2_1",
        .addr = A_POR_MPU_M5_PRBAR28_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR28_U_SMXP_2_1",
        .addr = A_POR_MPU_M5_PRLAR28_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR29_U_SMXP_2_1",
        .addr = A_POR_MPU_M5_PRBAR29_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR29_U_SMXP_2_1",
        .addr = A_POR_MPU_M5_PRLAR29_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR30_U_SMXP_2_1",
        .addr = A_POR_MPU_M5_PRBAR30_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR30_U_SMXP_2_1",
        .addr = A_POR_MPU_M5_PRLAR30_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR31_U_SMXP_2_1",
        .addr = A_POR_MPU_M5_PRBAR31_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR31_U_SMXP_2_1",
        .addr = A_POR_MPU_M5_PRLAR31_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_CTL_U_SMXP_2_1",
        .addr = A_POR_MPU_M6_CTL_U_SMXP_2_1,
        .reset = 0x2,
        .rsvd = 0xfffffffffffffff8L,
        .ro = 0xfffffffffffffff8L,
    },{ .name = "POR_MPU_M6_PRBAR0_U_SMXP_2_1",
        .addr = A_POR_MPU_M6_PRBAR0_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR0_U_SMXP_2_1",
        .addr = A_POR_MPU_M6_PRLAR0_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR1_U_SMXP_2_1",
        .addr = A_POR_MPU_M6_PRBAR1_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR1_U_SMXP_2_1",
        .addr = A_POR_MPU_M6_PRLAR1_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR2_U_SMXP_2_1",
        .addr = A_POR_MPU_M6_PRBAR2_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR2_U_SMXP_2_1",
        .addr = A_POR_MPU_M6_PRLAR2_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR3_U_SMXP_2_1",
        .addr = A_POR_MPU_M6_PRBAR3_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR3_U_SMXP_2_1",
        .addr = A_POR_MPU_M6_PRLAR3_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR4_U_SMXP_2_1",
        .addr = A_POR_MPU_M6_PRBAR4_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR4_U_SMXP_2_1",
        .addr = A_POR_MPU_M6_PRLAR4_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR5_U_SMXP_2_1",
        .addr = A_POR_MPU_M6_PRBAR5_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR5_U_SMXP_2_1",
        .addr = A_POR_MPU_M6_PRLAR5_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR6_U_SMXP_2_1",
        .addr = A_POR_MPU_M6_PRBAR6_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR6_U_SMXP_2_1",
        .addr = A_POR_MPU_M6_PRLAR6_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR7_U_SMXP_2_1",
        .addr = A_POR_MPU_M6_PRBAR7_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR7_U_SMXP_2_1",
        .addr = A_POR_MPU_M6_PRLAR7_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR8_U_SMXP_2_1",
        .addr = A_POR_MPU_M6_PRBAR8_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR8_U_SMXP_2_1",
        .addr = A_POR_MPU_M6_PRLAR8_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR9_U_SMXP_2_1",
        .addr = A_POR_MPU_M6_PRBAR9_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR9_U_SMXP_2_1",
        .addr = A_POR_MPU_M6_PRLAR9_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR10_U_SMXP_2_1",
        .addr = A_POR_MPU_M6_PRBAR10_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR10_U_SMXP_2_1",
        .addr = A_POR_MPU_M6_PRLAR10_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR11_U_SMXP_2_1",
        .addr = A_POR_MPU_M6_PRBAR11_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR11_U_SMXP_2_1",
        .addr = A_POR_MPU_M6_PRLAR11_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR12_U_SMXP_2_1",
        .addr = A_POR_MPU_M6_PRBAR12_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR12_U_SMXP_2_1",
        .addr = A_POR_MPU_M6_PRLAR12_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR13_U_SMXP_2_1",
        .addr = A_POR_MPU_M6_PRBAR13_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR13_U_SMXP_2_1",
        .addr = A_POR_MPU_M6_PRLAR13_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR14_U_SMXP_2_1",
        .addr = A_POR_MPU_M6_PRBAR14_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR14_U_SMXP_2_1",
        .addr = A_POR_MPU_M6_PRLAR14_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR15_U_SMXP_2_1",
        .addr = A_POR_MPU_M6_PRBAR15_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR15_U_SMXP_2_1",
        .addr = A_POR_MPU_M6_PRLAR15_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR16_U_SMXP_2_1",
        .addr = A_POR_MPU_M6_PRBAR16_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR16_U_SMXP_2_1",
        .addr = A_POR_MPU_M6_PRLAR16_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR17_U_SMXP_2_1",
        .addr = A_POR_MPU_M6_PRBAR17_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR17_U_SMXP_2_1",
        .addr = A_POR_MPU_M6_PRLAR17_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR18_U_SMXP_2_1",
        .addr = A_POR_MPU_M6_PRBAR18_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR18_U_SMXP_2_1",
        .addr = A_POR_MPU_M6_PRLAR18_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR19_U_SMXP_2_1",
        .addr = A_POR_MPU_M6_PRBAR19_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR19_U_SMXP_2_1",
        .addr = A_POR_MPU_M6_PRLAR19_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR20_U_SMXP_2_1",
        .addr = A_POR_MPU_M6_PRBAR20_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR20_U_SMXP_2_1",
        .addr = A_POR_MPU_M6_PRLAR20_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR21_U_SMXP_2_1",
        .addr = A_POR_MPU_M6_PRBAR21_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR21_U_SMXP_2_1",
        .addr = A_POR_MPU_M6_PRLAR21_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR22_U_SMXP_2_1",
        .addr = A_POR_MPU_M6_PRBAR22_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR22_U_SMXP_2_1",
        .addr = A_POR_MPU_M6_PRLAR22_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR23_U_SMXP_2_1",
        .addr = A_POR_MPU_M6_PRBAR23_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR23_U_SMXP_2_1",
        .addr = A_POR_MPU_M6_PRLAR23_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR24_U_SMXP_2_1",
        .addr = A_POR_MPU_M6_PRBAR24_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR24_U_SMXP_2_1",
        .addr = A_POR_MPU_M6_PRLAR24_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR25_U_SMXP_2_1",
        .addr = A_POR_MPU_M6_PRBAR25_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR25_U_SMXP_2_1",
        .addr = A_POR_MPU_M6_PRLAR25_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR26_U_SMXP_2_1",
        .addr = A_POR_MPU_M6_PRBAR26_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR26_U_SMXP_2_1",
        .addr = A_POR_MPU_M6_PRLAR26_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR27_U_SMXP_2_1",
        .addr = A_POR_MPU_M6_PRBAR27_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR27_U_SMXP_2_1",
        .addr = A_POR_MPU_M6_PRLAR27_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR28_U_SMXP_2_1",
        .addr = A_POR_MPU_M6_PRBAR28_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR28_U_SMXP_2_1",
        .addr = A_POR_MPU_M6_PRLAR28_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR29_U_SMXP_2_1",
        .addr = A_POR_MPU_M6_PRBAR29_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR29_U_SMXP_2_1",
        .addr = A_POR_MPU_M6_PRLAR29_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR30_U_SMXP_2_1",
        .addr = A_POR_MPU_M6_PRBAR30_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR30_U_SMXP_2_1",
        .addr = A_POR_MPU_M6_PRLAR30_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR31_U_SMXP_2_1",
        .addr = A_POR_MPU_M6_PRBAR31_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR31_U_SMXP_2_1",
        .addr = A_POR_MPU_M6_PRLAR31_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_CTL_U_SMXP_2_1",
        .addr = A_POR_MPU_M7_CTL_U_SMXP_2_1,
        .reset = 0x2,
        .rsvd = 0xfffffffffffffff8L,
        .ro = 0xfffffffffffffff8L,
    },{ .name = "POR_MPU_M7_PRBAR0_U_SMXP_2_1",
        .addr = A_POR_MPU_M7_PRBAR0_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR0_U_SMXP_2_1",
        .addr = A_POR_MPU_M7_PRLAR0_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR1_U_SMXP_2_1",
        .addr = A_POR_MPU_M7_PRBAR1_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR1_U_SMXP_2_1",
        .addr = A_POR_MPU_M7_PRLAR1_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR2_U_SMXP_2_1",
        .addr = A_POR_MPU_M7_PRBAR2_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR2_U_SMXP_2_1",
        .addr = A_POR_MPU_M7_PRLAR2_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR3_U_SMXP_2_1",
        .addr = A_POR_MPU_M7_PRBAR3_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR3_U_SMXP_2_1",
        .addr = A_POR_MPU_M7_PRLAR3_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR4_U_SMXP_2_1",
        .addr = A_POR_MPU_M7_PRBAR4_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR4_U_SMXP_2_1",
        .addr = A_POR_MPU_M7_PRLAR4_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR5_U_SMXP_2_1",
        .addr = A_POR_MPU_M7_PRBAR5_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR5_U_SMXP_2_1",
        .addr = A_POR_MPU_M7_PRLAR5_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR6_U_SMXP_2_1",
        .addr = A_POR_MPU_M7_PRBAR6_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR6_U_SMXP_2_1",
        .addr = A_POR_MPU_M7_PRLAR6_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR7_U_SMXP_2_1",
        .addr = A_POR_MPU_M7_PRBAR7_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR7_U_SMXP_2_1",
        .addr = A_POR_MPU_M7_PRLAR7_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR8_U_SMXP_2_1",
        .addr = A_POR_MPU_M7_PRBAR8_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR8_U_SMXP_2_1",
        .addr = A_POR_MPU_M7_PRLAR8_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR9_U_SMXP_2_1",
        .addr = A_POR_MPU_M7_PRBAR9_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR9_U_SMXP_2_1",
        .addr = A_POR_MPU_M7_PRLAR9_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR10_U_SMXP_2_1",
        .addr = A_POR_MPU_M7_PRBAR10_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR10_U_SMXP_2_1",
        .addr = A_POR_MPU_M7_PRLAR10_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR11_U_SMXP_2_1",
        .addr = A_POR_MPU_M7_PRBAR11_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR11_U_SMXP_2_1",
        .addr = A_POR_MPU_M7_PRLAR11_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR12_U_SMXP_2_1",
        .addr = A_POR_MPU_M7_PRBAR12_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR12_U_SMXP_2_1",
        .addr = A_POR_MPU_M7_PRLAR12_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR13_U_SMXP_2_1",
        .addr = A_POR_MPU_M7_PRBAR13_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR13_U_SMXP_2_1",
        .addr = A_POR_MPU_M7_PRLAR13_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR14_U_SMXP_2_1",
        .addr = A_POR_MPU_M7_PRBAR14_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR14_U_SMXP_2_1",
        .addr = A_POR_MPU_M7_PRLAR14_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR15_U_SMXP_2_1",
        .addr = A_POR_MPU_M7_PRBAR15_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR15_U_SMXP_2_1",
        .addr = A_POR_MPU_M7_PRLAR15_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR16_U_SMXP_2_1",
        .addr = A_POR_MPU_M7_PRBAR16_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR16_U_SMXP_2_1",
        .addr = A_POR_MPU_M7_PRLAR16_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR17_U_SMXP_2_1",
        .addr = A_POR_MPU_M7_PRBAR17_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR17_U_SMXP_2_1",
        .addr = A_POR_MPU_M7_PRLAR17_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR18_U_SMXP_2_1",
        .addr = A_POR_MPU_M7_PRBAR18_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR18_U_SMXP_2_1",
        .addr = A_POR_MPU_M7_PRLAR18_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR19_U_SMXP_2_1",
        .addr = A_POR_MPU_M7_PRBAR19_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR19_U_SMXP_2_1",
        .addr = A_POR_MPU_M7_PRLAR19_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR20_U_SMXP_2_1",
        .addr = A_POR_MPU_M7_PRBAR20_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR20_U_SMXP_2_1",
        .addr = A_POR_MPU_M7_PRLAR20_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR21_U_SMXP_2_1",
        .addr = A_POR_MPU_M7_PRBAR21_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR21_U_SMXP_2_1",
        .addr = A_POR_MPU_M7_PRLAR21_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR22_U_SMXP_2_1",
        .addr = A_POR_MPU_M7_PRBAR22_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR22_U_SMXP_2_1",
        .addr = A_POR_MPU_M7_PRLAR22_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR23_U_SMXP_2_1",
        .addr = A_POR_MPU_M7_PRBAR23_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR23_U_SMXP_2_1",
        .addr = A_POR_MPU_M7_PRLAR23_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR24_U_SMXP_2_1",
        .addr = A_POR_MPU_M7_PRBAR24_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR24_U_SMXP_2_1",
        .addr = A_POR_MPU_M7_PRLAR24_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR25_U_SMXP_2_1",
        .addr = A_POR_MPU_M7_PRBAR25_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR25_U_SMXP_2_1",
        .addr = A_POR_MPU_M7_PRLAR25_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR26_U_SMXP_2_1",
        .addr = A_POR_MPU_M7_PRBAR26_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR26_U_SMXP_2_1",
        .addr = A_POR_MPU_M7_PRLAR26_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR27_U_SMXP_2_1",
        .addr = A_POR_MPU_M7_PRBAR27_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR27_U_SMXP_2_1",
        .addr = A_POR_MPU_M7_PRLAR27_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR28_U_SMXP_2_1",
        .addr = A_POR_MPU_M7_PRBAR28_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR28_U_SMXP_2_1",
        .addr = A_POR_MPU_M7_PRLAR28_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR29_U_SMXP_2_1",
        .addr = A_POR_MPU_M7_PRBAR29_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR29_U_SMXP_2_1",
        .addr = A_POR_MPU_M7_PRLAR29_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR30_U_SMXP_2_1",
        .addr = A_POR_MPU_M7_PRBAR30_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR30_U_SMXP_2_1",
        .addr = A_POR_MPU_M7_PRLAR30_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR31_U_SMXP_2_1",
        .addr = A_POR_MPU_M7_PRBAR31_U_SMXP_2_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR31_U_SMXP_2_1",
        .addr = A_POR_MPU_M7_PRLAR31_U_SMXP_2_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_RNSAM_NODE_INFO_U_RNFBESAM_NID140",
        .addr = A_POR_RNSAM_NODE_INFO_U_RNFBESAM_NID140,
        .reset = 0x4000f,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_RNSAM_CHILD_INFO_U_RNFBESAM_NID140",
        .addr = A_POR_RNSAM_CHILD_INFO_U_RNFBESAM_NID140,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_RNSAM_UNIT_INFO_U_RNFBESAM_NID140",
        .addr = A_POR_RNSAM_UNIT_INFO_U_RNFBESAM_NID140,
        .reset = 0x800040004,
        .rsvd = 0xff00,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_RNSAM_SECURE_REGISTER_GROUPS_OVERRIDE_U_RNFBESAM_NID140",
        .addr = A_POR_RNSAM_SECURE_REGISTER_GROUPS_OVERRIDE_U_RNFBESAM_NID140,
        .rsvd = 0xfffffffffffffffeL,
        .ro = 0xfffffffffffffffeL,
    },{ .name = "RNSAM_STATUS_U_RNFBESAM_NID140",
        .addr = A_RNSAM_STATUS_U_RNFBESAM_NID140,
        .reset = 0x1,
        .rsvd = 0xfffffffffffffffcL,
        .ro = 0xfffffffffffffffcL,
    },{ .name = "NON_HASH_MEM_REGION_REG0_U_RNFBESAM_NID140",
        .addr = A_NON_HASH_MEM_REGION_REG0_U_RNFBESAM_NID140,
        .rsvd = 0x2,
        .ro = 0x8000000280000002L,
    },{ .name = "NON_HASH_MEM_REGION_REG1_U_RNFBESAM_NID140",
        .addr = A_NON_HASH_MEM_REGION_REG1_U_RNFBESAM_NID140,
        .rsvd = 0x2,
        .ro = 0x8000000280000002L,
    },{ .name = "NON_HASH_MEM_REGION_REG2_U_RNFBESAM_NID140",
        .addr = A_NON_HASH_MEM_REGION_REG2_U_RNFBESAM_NID140,
        .rsvd = 0x2,
        .ro = 0x8000000280000002L,
    },{ .name = "NON_HASH_MEM_REGION_REG3_U_RNFBESAM_NID140",
        .addr = A_NON_HASH_MEM_REGION_REG3_U_RNFBESAM_NID140,
        .rsvd = 0x2,
        .ro = 0x8000000280000002L,
    },{ .name = "NON_HASH_TGT_NODEID0_U_RNFBESAM_NID140",
        .addr = A_NON_HASH_TGT_NODEID0_U_RNFBESAM_NID140,
        .ro = 0xffff800800800800L,
    },{ .name = "NON_HASH_TGT_NODEID1_U_RNFBESAM_NID140",
        .addr = A_NON_HASH_TGT_NODEID1_U_RNFBESAM_NID140,
        .ro = 0xffff800800800800L,
    },{ .name = "NON_HASH_TGT_NODEID2_U_RNFBESAM_NID140",
        .addr = A_NON_HASH_TGT_NODEID2_U_RNFBESAM_NID140,
        .ro = 0xffffffffff800800L,
    },{ .name = "SYS_CACHE_GRP_REGION0_U_RNFBESAM_NID140",
        .addr = A_SYS_CACHE_GRP_REGION0_U_RNFBESAM_NID140,
        .rsvd = 0x2,
        .ro = 0x8000000080000002L,
    },{ .name = "SYS_CACHE_GRP_REGION1_U_RNFBESAM_NID140",
        .addr = A_SYS_CACHE_GRP_REGION1_U_RNFBESAM_NID140,
        .ro = 0x8000000080000000L,
    },{ .name = "SYS_CACHE_GRP_HN_NODEID_REG0_U_RNFBESAM_NID140",
        .addr = A_SYS_CACHE_GRP_HN_NODEID_REG0_U_RNFBESAM_NID140,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_HN_NODEID_REG1_U_RNFBESAM_NID140",
        .addr = A_SYS_CACHE_GRP_HN_NODEID_REG1_U_RNFBESAM_NID140,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_HN_NODEID_REG2_U_RNFBESAM_NID140",
        .addr = A_SYS_CACHE_GRP_HN_NODEID_REG2_U_RNFBESAM_NID140,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_HN_NODEID_REG3_U_RNFBESAM_NID140",
        .addr = A_SYS_CACHE_GRP_HN_NODEID_REG3_U_RNFBESAM_NID140,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_HN_NODEID_REG4_U_RNFBESAM_NID140",
        .addr = A_SYS_CACHE_GRP_HN_NODEID_REG4_U_RNFBESAM_NID140,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_HN_NODEID_REG5_U_RNFBESAM_NID140",
        .addr = A_SYS_CACHE_GRP_HN_NODEID_REG5_U_RNFBESAM_NID140,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_HN_NODEID_REG6_U_RNFBESAM_NID140",
        .addr = A_SYS_CACHE_GRP_HN_NODEID_REG6_U_RNFBESAM_NID140,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_HN_NODEID_REG7_U_RNFBESAM_NID140",
        .addr = A_SYS_CACHE_GRP_HN_NODEID_REG7_U_RNFBESAM_NID140,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_NONHASH_NODEID_U_RNFBESAM_NID140",
        .addr = A_SYS_CACHE_GRP_NONHASH_NODEID_U_RNFBESAM_NID140,
        .ro = 0xfffffff800800800L,
    },{ .name = "SYS_CACHE_GROUP_HN_COUNT_U_RNFBESAM_NID140",
        .addr = A_SYS_CACHE_GROUP_HN_COUNT_U_RNFBESAM_NID140,
        .rsvd = 0x80,
        .ro = 0xffffffff80808080L,
    },{ .name = "SYS_CACHE_GRP_SN_NODEID_REG0_U_RNFBESAM_NID140",
        .addr = A_SYS_CACHE_GRP_SN_NODEID_REG0_U_RNFBESAM_NID140,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_SN_NODEID_REG1_U_RNFBESAM_NID140",
        .addr = A_SYS_CACHE_GRP_SN_NODEID_REG1_U_RNFBESAM_NID140,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_SN_NODEID_REG2_U_RNFBESAM_NID140",
        .addr = A_SYS_CACHE_GRP_SN_NODEID_REG2_U_RNFBESAM_NID140,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_SN_NODEID_REG3_U_RNFBESAM_NID140",
        .addr = A_SYS_CACHE_GRP_SN_NODEID_REG3_U_RNFBESAM_NID140,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_SN_NODEID_REG4_U_RNFBESAM_NID140",
        .addr = A_SYS_CACHE_GRP_SN_NODEID_REG4_U_RNFBESAM_NID140,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_SN_NODEID_REG5_U_RNFBESAM_NID140",
        .addr = A_SYS_CACHE_GRP_SN_NODEID_REG5_U_RNFBESAM_NID140,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_SN_NODEID_REG6_U_RNFBESAM_NID140",
        .addr = A_SYS_CACHE_GRP_SN_NODEID_REG6_U_RNFBESAM_NID140,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_SN_NODEID_REG7_U_RNFBESAM_NID140",
        .addr = A_SYS_CACHE_GRP_SN_NODEID_REG7_U_RNFBESAM_NID140,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_SN_SAM_CFG0_U_RNFBESAM_NID140",
        .addr = A_SYS_CACHE_GRP_SN_SAM_CFG0_U_RNFBESAM_NID140,
        .rsvd = 0xc0,
        .ro = 0xffffc0c0c0c0c0c0L,
    },{ .name = "SYS_CACHE_GRP_SN_SAM_CFG1_U_RNFBESAM_NID140",
        .addr = A_SYS_CACHE_GRP_SN_SAM_CFG1_U_RNFBESAM_NID140,
        .rsvd = 0xc0,
        .ro = 0xffffc0c0c0c0c0c0L,
    },{ .name = "GIC_MEM_REGION_REG_U_RNFBESAM_NID140",
        .addr = A_GIC_MEM_REGION_REG_U_RNFBESAM_NID140,
        .rsvd = 0xff82,
        .ro = 0x800f00000000ff82L,
    },{ .name = "SYS_CACHE_GRP_SN_ATTR_U_RNFBESAM_NID140",
        .addr = A_SYS_CACHE_GRP_SN_ATTR_U_RNFBESAM_NID140,
        .rsvd = 0xffce,
        .ro = 0xffceffceffceffceL,
    },{ .name = "SYS_CACHE_GRP_HN_CPA_EN_REG_U_RNFBESAM_NID140",
        .addr = A_SYS_CACHE_GRP_HN_CPA_EN_REG_U_RNFBESAM_NID140,
    },{ .name = "SYS_CACHE_GRP_HN_CPA_GRP_REG_U_RNFBESAM_NID140",
        .addr = A_SYS_CACHE_GRP_HN_CPA_GRP_REG_U_RNFBESAM_NID140,
        .rsvd = 0xfffc,
        .ro = 0xfffcfffcfffcfffcL,
    },{ .name = "CML_PORT_AGGR_MODE_CTRL_REG_U_RNFBESAM_NID140",
        .addr = A_CML_PORT_AGGR_MODE_CTRL_REG_U_RNFBESAM_NID140,
        .rsvd = 0x88,
        .ro = 0xffffffff28888888L,
    },{ .name = "CML_PORT_AGGR_GRP0_ADD_MASK_U_RNFBESAM_NID140",
        .addr = A_CML_PORT_AGGR_GRP0_ADD_MASK_U_RNFBESAM_NID140,
        .reset = 0x40,
        .ro = 0xffff00000000003fL,
    },{ .name = "CML_PORT_AGGR_GRP1_ADD_MASK_U_RNFBESAM_NID140",
        .addr = A_CML_PORT_AGGR_GRP1_ADD_MASK_U_RNFBESAM_NID140,
        .reset = 0x40,
        .ro = 0xffff00000000003fL,
    },{ .name = "CML_PORT_AGGR_GRP0_REG_U_RNFBESAM_NID140",
        .addr = A_CML_PORT_AGGR_GRP0_REG_U_RNFBESAM_NID140,
        .ro = 0xfffc800800800800L,
    },{ .name = "CML_PORT_AGGR_GRP1_REG_U_RNFBESAM_NID140",
        .addr = A_CML_PORT_AGGR_GRP1_REG_U_RNFBESAM_NID140,
        .ro = 0xfffc800800800800L,
    },{ .name = "SYS_CACHE_GRP_SECONDARY_REG0_U_RNFBESAM_NID140",
        .addr = A_SYS_CACHE_GRP_SECONDARY_REG0_U_RNFBESAM_NID140,
        .rsvd = 0x2,
        .ro = 0x8000000280000002L,
    },{ .name = "SYS_CACHE_GRP_SECONDARY_REG1_U_RNFBESAM_NID140",
        .addr = A_SYS_CACHE_GRP_SECONDARY_REG1_U_RNFBESAM_NID140,
        .rsvd = 0x2,
        .ro = 0x8000000280000002L,
    },{ .name = "SYS_CACHE_GRP_CAL_MODE_REG_U_RNFBESAM_NID140",
        .addr = A_SYS_CACHE_GRP_CAL_MODE_REG_U_RNFBESAM_NID140,
        .rsvd = 0xfffe,
        .ro = 0xfffefffefffefffeL,
    },{ .name = "RNSAM_HASH_ADDR_MASK_REG_U_RNFBESAM_NID140",
        .addr = A_RNSAM_HASH_ADDR_MASK_REG_U_RNFBESAM_NID140,
        .reset = 0xffffffffffc0,
        .ro = 0xffff00000000003fL,
    },{ .name = "RNSAM_REGION_CMP_ADDR_MASK_REG_U_RNFBESAM_NID140",
        .addr = A_RNSAM_REGION_CMP_ADDR_MASK_REG_U_RNFBESAM_NID140,
        .reset = 0xffffffff0000,
        .ro = 0xffff00000000ffffL,
    },{ .name = "SYS_CACHE_GRP_HN_NODEID_REG8_U_RNFBESAM_NID140",
        .addr = A_SYS_CACHE_GRP_HN_NODEID_REG8_U_RNFBESAM_NID140,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_HN_NODEID_REG9_U_RNFBESAM_NID140",
        .addr = A_SYS_CACHE_GRP_HN_NODEID_REG9_U_RNFBESAM_NID140,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_HN_NODEID_REG10_U_RNFBESAM_NID140",
        .addr = A_SYS_CACHE_GRP_HN_NODEID_REG10_U_RNFBESAM_NID140,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_HN_NODEID_REG11_U_RNFBESAM_NID140",
        .addr = A_SYS_CACHE_GRP_HN_NODEID_REG11_U_RNFBESAM_NID140,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_HN_NODEID_REG12_U_RNFBESAM_NID140",
        .addr = A_SYS_CACHE_GRP_HN_NODEID_REG12_U_RNFBESAM_NID140,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_HN_NODEID_REG13_U_RNFBESAM_NID140",
        .addr = A_SYS_CACHE_GRP_HN_NODEID_REG13_U_RNFBESAM_NID140,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_HN_NODEID_REG14_U_RNFBESAM_NID140",
        .addr = A_SYS_CACHE_GRP_HN_NODEID_REG14_U_RNFBESAM_NID140,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_HN_NODEID_REG15_U_RNFBESAM_NID140",
        .addr = A_SYS_CACHE_GRP_HN_NODEID_REG15_U_RNFBESAM_NID140,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_SN_NODEID_REG8_U_RNFBESAM_NID140",
        .addr = A_SYS_CACHE_GRP_SN_NODEID_REG8_U_RNFBESAM_NID140,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_SN_NODEID_REG9_U_RNFBESAM_NID140",
        .addr = A_SYS_CACHE_GRP_SN_NODEID_REG9_U_RNFBESAM_NID140,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_SN_NODEID_REG10_U_RNFBESAM_NID140",
        .addr = A_SYS_CACHE_GRP_SN_NODEID_REG10_U_RNFBESAM_NID140,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_SN_NODEID_REG11_U_RNFBESAM_NID140",
        .addr = A_SYS_CACHE_GRP_SN_NODEID_REG11_U_RNFBESAM_NID140,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_SN_NODEID_REG12_U_RNFBESAM_NID140",
        .addr = A_SYS_CACHE_GRP_SN_NODEID_REG12_U_RNFBESAM_NID140,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_SN_NODEID_REG13_U_RNFBESAM_NID140",
        .addr = A_SYS_CACHE_GRP_SN_NODEID_REG13_U_RNFBESAM_NID140,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_SN_NODEID_REG14_U_RNFBESAM_NID140",
        .addr = A_SYS_CACHE_GRP_SN_NODEID_REG14_U_RNFBESAM_NID140,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_SN_NODEID_REG15_U_RNFBESAM_NID140",
        .addr = A_SYS_CACHE_GRP_SN_NODEID_REG15_U_RNFBESAM_NID140,
        .ro = 0xffff800800800800L,
    },{ .name = "POR_SBSX_NODE_INFO_U_SBSX_NID192",
        .addr = A_POR_SBSX_NODE_INFO_U_SBSX_NID192,
        .reset = 0x7,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_SBSX_CHILD_INFO_U_SBSX_NID192",
        .addr = A_POR_SBSX_CHILD_INFO_U_SBSX_NID192,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_SBSX_UNIT_INFO_U_SBSX_NID192",
        .addr = A_POR_SBSX_UNIT_INFO_U_SBSX_NID192,
        .reset = 0x84011,
        .rsvd = 0xee,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_SBSX_AUX_CTL_U_SBSX_NID192",
        .addr = A_POR_SBSX_AUX_CTL_U_SBSX_NID192,
        .rsvd = 0xfffffffffffffffeL,
        .ro = 0xfffffffffffffffeL,
    },{ .name = "POR_SBSX_PMU_EVENT_SEL_U_SBSX_NID192",
        .addr = A_POR_SBSX_PMU_EVENT_SEL_U_SBSX_NID192,
        .rsvd = 0xc0,
        .ro = 0xffffffffc0c0c0c0L,
    },{ .name = "POR_SBSX_ERRFR_U_SBSX_NID192",
        .addr = A_POR_SBSX_ERRFR_U_SBSX_NID192,
        .reset = 0xa1,
        .rsvd = 0x300,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_SBSX_ERRCTLR_U_SBSX_NID192",
        .addr = A_POR_SBSX_ERRCTLR_U_SBSX_NID192,
        .rsvd = 0xf0,
        .ro = 0xfffffffffffffef0L,
    },{ .name = "POR_SBSX_ERRSTATUS_U_SBSX_NID192",
        .addr = A_POR_SBSX_ERRSTATUS_U_SBSX_NID192,
        .ro = 0xffffffff127fffffL,
    },{ .name = "POR_SBSX_ERRADDR_U_SBSX_NID192",
        .addr = A_POR_SBSX_ERRADDR_U_SBSX_NID192,
        .ro = 0x7fff000000000000,
    },{ .name = "POR_SBSX_ERRMISC_U_SBSX_NID192",
        .addr = A_POR_SBSX_ERRMISC_U_SBSX_NID192,
        .ro = 0xffffffff80fe800fL,
    },{ .name = "POR_SBSX_ERRFR_NS_U_SBSX_NID192",
        .addr = A_POR_SBSX_ERRFR_NS_U_SBSX_NID192,
        .reset = 0xa1,
        .rsvd = 0x300,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_SBSX_ERRCTLR_NS_U_SBSX_NID192",
        .addr = A_POR_SBSX_ERRCTLR_NS_U_SBSX_NID192,
        .rsvd = 0xf0,
        .ro = 0xfffffffffffffef0L,
    },{ .name = "POR_SBSX_ERRSTATUS_NS_U_SBSX_NID192",
        .addr = A_POR_SBSX_ERRSTATUS_NS_U_SBSX_NID192,
        .ro = 0xffffffff127fffffL,
    },{ .name = "POR_SBSX_ERRADDR_NS_U_SBSX_NID192",
        .addr = A_POR_SBSX_ERRADDR_NS_U_SBSX_NID192,
        .ro = 0x7fff000000000000,
    },{ .name = "POR_SBSX_ERRMISC_NS_U_SBSX_NID192",
        .addr = A_POR_SBSX_ERRMISC_NS_U_SBSX_NID192,
        .ro = 0xffffffff80fe800fL,
    },{ .name = "POR_MXP_NODE_INFO_U_SMXP_3_0",
        .addr = A_POR_MXP_NODE_INFO_U_SMXP_3_0,
        .reset = 0x1080006,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_DEVICE_PORT_CONNECT_INFO_P0_U_SMXP_3_0",
        .addr = A_POR_MXP_DEVICE_PORT_CONNECT_INFO_P0_U_SMXP_3_0,
        .reset = 0xd,
        .rsvd = 0xffe0,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_DEVICE_PORT_CONNECT_INFO_P1_U_SMXP_3_0",
        .addr = A_POR_MXP_DEVICE_PORT_CONNECT_INFO_P1_U_SMXP_3_0,
        .reset = 0x1,
        .rsvd = 0xffe0,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_MESH_PORT_CONNECT_INFO_EAST_U_SMXP_3_0",
        .addr = A_POR_MXP_MESH_PORT_CONNECT_INFO_EAST_U_SMXP_3_0,
        .rsvd = 0xfffffffffffffff0L,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_MESH_PORT_CONNECT_INFO_NORTH_U_SMXP_3_0",
        .addr = A_POR_MXP_MESH_PORT_CONNECT_INFO_NORTH_U_SMXP_3_0,
        .rsvd = 0xfffffffffffffff0L,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_INFO_U_SMXP_3_0",
        .addr = A_POR_MXP_CHILD_INFO_U_SMXP_3_0,
        .reset = 0x1000006,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_POINTER_0_U_SMXP_3_0",
        .addr = A_POR_MXP_CHILD_POINTER_0_U_SMXP_3_0,
        .reset = 0x8212c000,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_POINTER_1_U_SMXP_3_0",
        .addr = A_POR_MXP_CHILD_POINTER_1_U_SMXP_3_0,
        .reset = 0x8213c000,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_POINTER_2_U_SMXP_3_0",
        .addr = A_POR_MXP_CHILD_POINTER_2_U_SMXP_3_0,
        .reset = 0x2168000,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_POINTER_3_U_SMXP_3_0",
        .addr = A_POR_MXP_CHILD_POINTER_3_U_SMXP_3_0,
        .reset = 0x821d0000,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_POINTER_4_U_SMXP_3_0",
        .addr = A_POR_MXP_CHILD_POINTER_4_U_SMXP_3_0,
        .reset = 0x82120000,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_POINTER_5_U_SMXP_3_0",
        .addr = A_POR_MXP_CHILD_POINTER_5_U_SMXP_3_0,
        .reset = 0x2150000,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_POINTER_6_U_SMXP_3_0",
        .addr = A_POR_MXP_CHILD_POINTER_6_U_SMXP_3_0,
        .reset = 0x2110000,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_POINTER_7_U_SMXP_3_0",
        .addr = A_POR_MXP_CHILD_POINTER_7_U_SMXP_3_0,
        .reset = 0x2100000,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_POINTER_8_U_SMXP_3_0",
        .addr = A_POR_MXP_CHILD_POINTER_8_U_SMXP_3_0,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_POINTER_9_U_SMXP_3_0",
        .addr = A_POR_MXP_CHILD_POINTER_9_U_SMXP_3_0,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_POINTER_10_U_SMXP_3_0",
        .addr = A_POR_MXP_CHILD_POINTER_10_U_SMXP_3_0,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_POINTER_11_U_SMXP_3_0",
        .addr = A_POR_MXP_CHILD_POINTER_11_U_SMXP_3_0,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_POINTER_12_U_SMXP_3_0",
        .addr = A_POR_MXP_CHILD_POINTER_12_U_SMXP_3_0,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_POINTER_13_U_SMXP_3_0",
        .addr = A_POR_MXP_CHILD_POINTER_13_U_SMXP_3_0,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_POINTER_14_U_SMXP_3_0",
        .addr = A_POR_MXP_CHILD_POINTER_14_U_SMXP_3_0,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_POINTER_15_U_SMXP_3_0",
        .addr = A_POR_MXP_CHILD_POINTER_15_U_SMXP_3_0,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_P0_INFO_U_SMXP_3_0",
        .addr = A_POR_MXP_P0_INFO_U_SMXP_3_0,
        .reset = 0x211,
        .rsvd = 0x48,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_P1_INFO_U_SMXP_3_0",
        .addr = A_POR_MXP_P1_INFO_U_SMXP_3_0,
        .reset = 0x211,
        .rsvd = 0x48,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_SECURE_REGISTER_GROUPS_OVERRIDE_U_SMXP_3_0",
        .addr = A_POR_MXP_SECURE_REGISTER_GROUPS_OVERRIDE_U_SMXP_3_0,
        .rsvd = 0xfffffffffffffffcL,
        .ro = 0xfffffffffffffffcL,
    },{ .name = "POR_MXP_AUX_CTL_U_SMXP_3_0",
        .addr = A_POR_MXP_AUX_CTL_U_SMXP_3_0,
        .rsvd = 0xfffffffffffffffeL,
        .ro = 0xfffffffffffffffeL,
    },{ .name = "POR_MXP_P0_QOS_CONTROL_U_SMXP_3_0",
        .addr = A_POR_MXP_P0_QOS_CONTROL_U_SMXP_3_0,
        .rsvd = 0xffaa,
        .ro = 0xfffffffffff0ffaaL,
    },{ .name = "POR_MXP_P0_QOS_LAT_TGT_U_SMXP_3_0",
        .addr = A_POR_MXP_P0_QOS_LAT_TGT_U_SMXP_3_0,
        .ro = 0xfffffffffffff000L,
    },{ .name = "POR_MXP_P0_QOS_LAT_SCALE_U_SMXP_3_0",
        .addr = A_POR_MXP_P0_QOS_LAT_SCALE_U_SMXP_3_0,
        .rsvd = 0xfffffffffffffff8L,
        .ro = 0xfffffffffffffff8L,
    },{ .name = "POR_MXP_P0_QOS_LAT_RANGE_U_SMXP_3_0",
        .addr = A_POR_MXP_P0_QOS_LAT_RANGE_U_SMXP_3_0,
        .rsvd = 0xf0,
        .ro = 0xfffffffffffff0f0L,
    },{ .name = "POR_MXP_P1_QOS_CONTROL_U_SMXP_3_0",
        .addr = A_POR_MXP_P1_QOS_CONTROL_U_SMXP_3_0,
        .rsvd = 0xffaa,
        .ro = 0xfffffffffff0ffaaL,
    },{ .name = "POR_MXP_P1_QOS_LAT_TGT_U_SMXP_3_0",
        .addr = A_POR_MXP_P1_QOS_LAT_TGT_U_SMXP_3_0,
        .ro = 0xfffffffffffff000L,
    },{ .name = "POR_MXP_P1_QOS_LAT_SCALE_U_SMXP_3_0",
        .addr = A_POR_MXP_P1_QOS_LAT_SCALE_U_SMXP_3_0,
        .rsvd = 0xfffffffffffffff8L,
        .ro = 0xfffffffffffffff8L,
    },{ .name = "POR_MXP_P1_QOS_LAT_RANGE_U_SMXP_3_0",
        .addr = A_POR_MXP_P1_QOS_LAT_RANGE_U_SMXP_3_0,
        .rsvd = 0xf0,
        .ro = 0xfffffffffffff0f0L,
    },{ .name = "POR_MXP_P0_SYSCOREQ_CTL_U_SMXP_3_0",
        .addr = A_POR_MXP_P0_SYSCOREQ_CTL_U_SMXP_3_0,
        .rsvd = 0xfffffffffffffff0L,
        .ro = 0xfffffffffffffff0L,
    },{ .name = "POR_MXP_P1_SYSCOREQ_CTL_U_SMXP_3_0",
        .addr = A_POR_MXP_P1_SYSCOREQ_CTL_U_SMXP_3_0,
        .rsvd = 0xfffffffffffffff0L,
        .ro = 0xfffffffffffffff0L,
    },{ .name = "POR_MXP_P0_SYSCOACK_STATUS_U_SMXP_3_0",
        .addr = A_POR_MXP_P0_SYSCOACK_STATUS_U_SMXP_3_0,
        .rsvd = 0xfffffffffffffff0L,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_P1_SYSCOACK_STATUS_U_SMXP_3_0",
        .addr = A_POR_MXP_P1_SYSCOACK_STATUS_U_SMXP_3_0,
        .rsvd = 0xfffffffffffffff0L,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_PMU_EVENT_SEL_U_SMXP_3_0",
        .addr = A_POR_MXP_PMU_EVENT_SEL_U_SMXP_3_0,
        .ro = 0xffffffff00000000L,
    },{ .name = "POR_DTM_CONTROL_U_SMXP_3_0",
        .addr = A_POR_DTM_CONTROL_U_SMXP_3_0,
        .rsvd = 0xfffffffffffffff0L,
        .ro = 0xfffffffffffffff0L,
    },{ .name = "POR_DTM_FIFO_ENTRY_READY_U_SMXP_3_0",
        .addr = A_POR_DTM_FIFO_ENTRY_READY_U_SMXP_3_0,
        .rsvd = 0xfffffffffffffff0L,
        .ro = 0xfffffffffffffff0L,
    },{ .name = "POR_DTM_FIFO_ENTRY0_0_U_SMXP_3_0",
        .addr = A_POR_DTM_FIFO_ENTRY0_0_U_SMXP_3_0,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_DTM_FIFO_ENTRY0_1_U_SMXP_3_0",
        .addr = A_POR_DTM_FIFO_ENTRY0_1_U_SMXP_3_0,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_DTM_FIFO_ENTRY0_2_U_SMXP_3_0",
        .addr = A_POR_DTM_FIFO_ENTRY0_2_U_SMXP_3_0,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_DTM_FIFO_ENTRY1_0_U_SMXP_3_0",
        .addr = A_POR_DTM_FIFO_ENTRY1_0_U_SMXP_3_0,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_DTM_FIFO_ENTRY1_1_U_SMXP_3_0",
        .addr = A_POR_DTM_FIFO_ENTRY1_1_U_SMXP_3_0,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_DTM_FIFO_ENTRY1_2_U_SMXP_3_0",
        .addr = A_POR_DTM_FIFO_ENTRY1_2_U_SMXP_3_0,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_DTM_FIFO_ENTRY2_0_U_SMXP_3_0",
        .addr = A_POR_DTM_FIFO_ENTRY2_0_U_SMXP_3_0,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_DTM_FIFO_ENTRY2_1_U_SMXP_3_0",
        .addr = A_POR_DTM_FIFO_ENTRY2_1_U_SMXP_3_0,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_DTM_FIFO_ENTRY2_2_U_SMXP_3_0",
        .addr = A_POR_DTM_FIFO_ENTRY2_2_U_SMXP_3_0,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_DTM_FIFO_ENTRY3_0_U_SMXP_3_0",
        .addr = A_POR_DTM_FIFO_ENTRY3_0_U_SMXP_3_0,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_DTM_FIFO_ENTRY3_1_U_SMXP_3_0",
        .addr = A_POR_DTM_FIFO_ENTRY3_1_U_SMXP_3_0,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_DTM_FIFO_ENTRY3_2_U_SMXP_3_0",
        .addr = A_POR_DTM_FIFO_ENTRY3_2_U_SMXP_3_0,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_DTM_WP0_CONFIG_U_SMXP_3_0",
        .addr = A_POR_DTM_WP0_CONFIG_U_SMXP_3_0,
        .rsvd = 0x80,
        .ro = 0xffffffffffff8080L,
    },{ .name = "POR_DTM_WP0_VAL_U_SMXP_3_0",
        .addr = A_POR_DTM_WP0_VAL_U_SMXP_3_0,
    },{ .name = "POR_DTM_WP0_MASK_U_SMXP_3_0",
        .addr = A_POR_DTM_WP0_MASK_U_SMXP_3_0,
    },{ .name = "POR_DTM_WP1_CONFIG_U_SMXP_3_0",
        .addr = A_POR_DTM_WP1_CONFIG_U_SMXP_3_0,
        .rsvd = 0xc0,
        .ro = 0xffffffffffff80c0L,
    },{ .name = "POR_DTM_WP1_VAL_U_SMXP_3_0",
        .addr = A_POR_DTM_WP1_VAL_U_SMXP_3_0,
    },{ .name = "POR_DTM_WP1_MASK_U_SMXP_3_0",
        .addr = A_POR_DTM_WP1_MASK_U_SMXP_3_0,
    },{ .name = "POR_DTM_WP2_CONFIG_U_SMXP_3_0",
        .addr = A_POR_DTM_WP2_CONFIG_U_SMXP_3_0,
        .rsvd = 0x80,
        .ro = 0xffffffffffff8080L,
    },{ .name = "POR_DTM_WP2_VAL_U_SMXP_3_0",
        .addr = A_POR_DTM_WP2_VAL_U_SMXP_3_0,
    },{ .name = "POR_DTM_WP2_MASK_U_SMXP_3_0",
        .addr = A_POR_DTM_WP2_MASK_U_SMXP_3_0,
    },{ .name = "POR_DTM_WP3_CONFIG_U_SMXP_3_0",
        .addr = A_POR_DTM_WP3_CONFIG_U_SMXP_3_0,
        .rsvd = 0xc0,
        .ro = 0xffffffffffff80c0L,
    },{ .name = "POR_DTM_WP3_VAL_U_SMXP_3_0",
        .addr = A_POR_DTM_WP3_VAL_U_SMXP_3_0,
    },{ .name = "POR_DTM_WP3_MASK_U_SMXP_3_0",
        .addr = A_POR_DTM_WP3_MASK_U_SMXP_3_0,
    },{ .name = "POR_DTM_PMSICR_U_SMXP_3_0",
        .addr = A_POR_DTM_PMSICR_U_SMXP_3_0,
        .ro = 0xffffffff00000000L,
    },{ .name = "POR_DTM_PMSIRR_U_SMXP_3_0",
        .addr = A_POR_DTM_PMSIRR_U_SMXP_3_0,
        .ro = 0xffffffff000000ffL,
    },{ .name = "POR_DTM_PMU_CONFIG_U_SMXP_3_0",
        .addr = A_POR_DTM_PMU_CONFIG_U_SMXP_3_0,
        .ro = 0xc0c0c0c08888fe00L,
    },{ .name = "POR_DTM_PMEVCNT_U_SMXP_3_0",
        .addr = A_POR_DTM_PMEVCNT_U_SMXP_3_0,
    },{ .name = "POR_DTM_PMEVCNTSR_U_SMXP_3_0",
        .addr = A_POR_DTM_PMEVCNTSR_U_SMXP_3_0,
    },{ .name = "POR_MXP_ERRFR_U_SMXP_3_0",  .addr = A_POR_MXP_ERRFR_U_SMXP_3_0,
        .rsvd = 0x300,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_ERRCTLR_U_SMXP_3_0",
        .addr = A_POR_MXP_ERRCTLR_U_SMXP_3_0,
        .rsvd = 0xf0,
        .ro = 0xfffffffffffffef0L,
    },{ .name = "POR_MXP_ERRSTATUS_U_SMXP_3_0",
        .addr = A_POR_MXP_ERRSTATUS_U_SMXP_3_0,
        .ro = 0xffffffff127fffffL,
    },{ .name = "POR_MXP_ERRMISC_U_SMXP_3_0",
        .addr = A_POR_MXP_ERRMISC_U_SMXP_3_0,
        .rsvd = 0x8,
        .ro = 0xf800ffffffc08008L,
    },{ .name = "POR_MXP_P0_BYTE_PAR_ERR_INJ_U_SMXP_3_0",
        .addr = A_POR_MXP_P0_BYTE_PAR_ERR_INJ_U_SMXP_3_0,
        .rsvd = 0xffffffffffffffe0L,
        .ro = 0xffffffffffffffe0L,
    },{ .name = "POR_MXP_P1_BYTE_PAR_ERR_INJ_U_SMXP_3_0",
        .addr = A_POR_MXP_P1_BYTE_PAR_ERR_INJ_U_SMXP_3_0,
        .rsvd = 0xffffffffffffffe0L,
        .ro = 0xffffffffffffffe0L,
    },{ .name = "POR_MXP_ERRFR_NS_U_SMXP_3_0",
        .addr = A_POR_MXP_ERRFR_NS_U_SMXP_3_0,
        .rsvd = 0x300,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_ERRCTLR_NS_U_SMXP_3_0",
        .addr = A_POR_MXP_ERRCTLR_NS_U_SMXP_3_0,
        .rsvd = 0xf0,
        .ro = 0xfffffffffffffef0L,
    },{ .name = "POR_MXP_ERRSTATUS_NS_U_SMXP_3_0",
        .addr = A_POR_MXP_ERRSTATUS_NS_U_SMXP_3_0,
        .ro = 0xffffffff127fffffL,
    },{ .name = "POR_MXP_ERRMISC_NS_U_SMXP_3_0",
        .addr = A_POR_MXP_ERRMISC_NS_U_SMXP_3_0,
        .rsvd = 0x8,
        .ro = 0xf800ffffffc08008L,
    },{ .name = "POR_HNI_NODE_INFO_U_HNI_NID196",
        .addr = A_POR_HNI_NODE_INFO_U_HNI_NID196,
        .reset = 0x100c40004,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_HNI_CHILD_INFO_U_HNI_NID196",
        .addr = A_POR_HNI_CHILD_INFO_U_HNI_NID196,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_HNI_UNIT_INFO_U_HNI_NID196",
        .addr = A_POR_HNI_UNIT_INFO_U_HNI_NID196,
        .reset = 0x11102020,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_HNI_SECURE_REGISTER_GROUPS_OVERRIDE_U_HNI_NID196",
        .addr = A_POR_HNI_SECURE_REGISTER_GROUPS_OVERRIDE_U_HNI_NID196,
        .rsvd = 0xfffffffffffffffcL,
        .ro = 0xfffffffffffffffcL,
    },{ .name = "POR_HNI_CFG_CTL_U_HNI_NID196",
        .addr = A_POR_HNI_CFG_CTL_U_HNI_NID196,
        .reset = 0x1,
        .rsvd = 0xfffffffffffffffeL,
        .ro = 0xfffffffffffffffeL,
    },{ .name = "POR_HNI_AUX_CTL_U_HNI_NID196",
        .addr = A_POR_HNI_AUX_CTL_U_HNI_NID196,
        .rsvd = 0xffffffffffffffceL,
        .ro = 0xffffffffffffffceL,
    },{ .name = "POR_HNI_SAM_ADDRREGION0_CFG_U_HNI_NID196",
        .addr = A_POR_HNI_SAM_ADDRREGION0_CFG_U_HNI_NID196,
        .reset = 0x600000000000003f,
        .rsvd = 0x3ffffffffffffc0,
        .ro = 0x83ffffffffffffc0L,
    },{ .name = "POR_HNI_SAM_ADDRREGION1_CFG_U_HNI_NID196",
        .addr = A_POR_HNI_SAM_ADDRREGION1_CFG_U_HNI_NID196,
        .reset = 0x6000000000000000,
        .rsvd = 0x3c0,
        .ro = 0x3000000000f03c0,
    },{ .name = "POR_HNI_SAM_ADDRREGION2_CFG_U_HNI_NID196",
        .addr = A_POR_HNI_SAM_ADDRREGION2_CFG_U_HNI_NID196,
        .reset = 0x6000000000000000,
        .rsvd = 0x3c0,
        .ro = 0x3000000000f03c0,
    },{ .name = "POR_HNI_SAM_ADDRREGION3_CFG_U_HNI_NID196",
        .addr = A_POR_HNI_SAM_ADDRREGION3_CFG_U_HNI_NID196,
        .reset = 0x6000000000000000,
        .rsvd = 0x3c0,
        .ro = 0x3000000000f03c0,
    },{ .name = "POR_HNI_PMU_EVENT_SEL_U_HNI_NID196",
        .addr = A_POR_HNI_PMU_EVENT_SEL_U_HNI_NID196,
        .rsvd = 0xc0,
        .ro = 0xffffffffc0c0c0c0L,
    },{ .name = "POR_HNI_ERRFR_U_HNI_NID196",
        .addr = A_POR_HNI_ERRFR_U_HNI_NID196,
        .reset = 0xa5,
        .rsvd = 0x300,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_HNI_ERRCTLR_U_HNI_NID196",
        .addr = A_POR_HNI_ERRCTLR_U_HNI_NID196,
        .rsvd = 0xf0,
        .ro = 0xfffffffffffffef0L,
    },{ .name = "POR_HNI_ERRSTATUS_U_HNI_NID196",
        .addr = A_POR_HNI_ERRSTATUS_U_HNI_NID196,
        .ro = 0xffffffff127fffffL,
    },{ .name = "POR_HNI_ERRADDR_U_HNI_NID196",
        .addr = A_POR_HNI_ERRADDR_U_HNI_NID196,
        .ro = 0x7fff000000000000,
    },{ .name = "POR_HNI_ERRMISC_U_HNI_NID196",
        .addr = A_POR_HNI_ERRMISC_U_HNI_NID196,
        .ro = 0xfe0cffff80c08000L,
    },{ .name = "POR_HNI_ERRFR_NS_U_HNI_NID196",
        .addr = A_POR_HNI_ERRFR_NS_U_HNI_NID196,
        .reset = 0xa5,
        .rsvd = 0x300,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_HNI_ERRCTLR_NS_U_HNI_NID196",
        .addr = A_POR_HNI_ERRCTLR_NS_U_HNI_NID196,
        .rsvd = 0xf0,
        .ro = 0xfffffffffffffef0L,
    },{ .name = "POR_HNI_ERRSTATUS_NS_U_HNI_NID196",
        .addr = A_POR_HNI_ERRSTATUS_NS_U_HNI_NID196,
        .ro = 0xffffffff127fffffL,
    },{ .name = "POR_HNI_ERRADDR_NS_U_HNI_NID196",
        .addr = A_POR_HNI_ERRADDR_NS_U_HNI_NID196,
        .ro = 0x7fff000000000000,
    },{ .name = "POR_HNI_ERRMISC_NS_U_HNI_NID196",
        .addr = A_POR_HNI_ERRMISC_NS_U_HNI_NID196,
        .ro = 0xfe0cffff80c08000L,
    },{ .name = "POR_FDC_NODE_INFO_U_SMXP_3_0",
        .addr = A_POR_FDC_NODE_INFO_U_SMXP_3_0,
        .reset = 0x201,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_FDC_CHILD_INFO_U_SMXP_3_0",
        .addr = A_POR_FDC_CHILD_INFO_U_SMXP_3_0,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_ERRFR_MXP_U_SMXP_3_0",  .addr = A_POR_ERRFR_MXP_U_SMXP_3_0,
        .reset = 0xa1,
        .rsvd = 0xffffffffffffff0cL,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_ERRCTLR_MXP_U_SMXP_3_0",
        .addr = A_POR_ERRCTLR_MXP_U_SMXP_3_0,
        .reset = 0xd,
        .rsvd = 0x3ff2,
        .ro = 0xffffffff00003ff2L,
    },{ .name = "POR_ERRSTATUS_MXP_U_SMXP_3_0",
        .addr = A_POR_ERRSTATUS_MXP_U_SMXP_3_0,
        .ro = 0xffffffff977f003fL,
    },{ .name = "POR_FDC_AUX_CTL_MXP_U_SMXP_3_0",
        .addr = A_POR_FDC_AUX_CTL_MXP_U_SMXP_3_0,
        .rsvd = 0xffffffffffffffe0L,
        .ro = 0xffffffffffffffefL,
    },{ .name = "POR_ERRFR_P0_D0_U_SMXP_3_0",
        .addr = A_POR_ERRFR_P0_D0_U_SMXP_3_0,
        .reset = 0xa1,
        .rsvd = 0xffffffffffffff0cL,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_ERRCTLR_P0_D0_U_SMXP_3_0",
        .addr = A_POR_ERRCTLR_P0_D0_U_SMXP_3_0,
        .reset = 0xd,
        .rsvd = 0x3ff2,
        .ro = 0xffffffff00003ff2L,
    },{ .name = "POR_ERRSTATUS_P0_D0_U_SMXP_3_0",
        .addr = A_POR_ERRSTATUS_P0_D0_U_SMXP_3_0,
        .ro = 0xffffffff977f003fL,
    },{ .name = "POR_FDC_AUX_CTL_P0_D0_U_SMXP_3_0",
        .addr = A_POR_FDC_AUX_CTL_P0_D0_U_SMXP_3_0,
        .rsvd = 0xffffffffffffffe0L,
        .ro = 0xffffffffffffffe0L,
    },{ .name = "POR_ERRFR_P0_D1_U_SMXP_3_0",
        .addr = A_POR_ERRFR_P0_D1_U_SMXP_3_0,
        .reset = 0xa1,
        .rsvd = 0xffffffffffffff0cL,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_ERRCTLR_P0_D1_U_SMXP_3_0",
        .addr = A_POR_ERRCTLR_P0_D1_U_SMXP_3_0,
        .reset = 0xd,
        .rsvd = 0x3ff2,
        .ro = 0xffffffff00003ff2L,
    },{ .name = "POR_ERRSTATUS_P0_D1_U_SMXP_3_0",
        .addr = A_POR_ERRSTATUS_P0_D1_U_SMXP_3_0,
        .ro = 0xffffffff977f003fL,
    },{ .name = "POR_FDC_AUX_CTL_P0_D1_U_SMXP_3_0",
        .addr = A_POR_FDC_AUX_CTL_P0_D1_U_SMXP_3_0,
        .rsvd = 0xffffffffffffffe0L,
        .ro = 0xffffffffffffffe0L,
    },{ .name = "POR_ERRFR_P0_D2_U_SMXP_3_0",
        .addr = A_POR_ERRFR_P0_D2_U_SMXP_3_0,
        .reset = 0xa1,
        .rsvd = 0xffffffffffffff0cL,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_ERRCTLR_P0_D2_U_SMXP_3_0",
        .addr = A_POR_ERRCTLR_P0_D2_U_SMXP_3_0,
        .reset = 0xd,
        .rsvd = 0x3ff2,
        .ro = 0xffffffff00003ff2L,
    },{ .name = "POR_ERRSTATUS_P0_D2_U_SMXP_3_0",
        .addr = A_POR_ERRSTATUS_P0_D2_U_SMXP_3_0,
        .ro = 0xffffffff977f003fL,
    },{ .name = "POR_FDC_AUX_CTL_P0_D2_U_SMXP_3_0",
        .addr = A_POR_FDC_AUX_CTL_P0_D2_U_SMXP_3_0,
        .rsvd = 0xffffffffffffffe0L,
        .ro = 0xffffffffffffffe0L,
    },{ .name = "POR_ERRFR_P0_D3_U_SMXP_3_0",
        .addr = A_POR_ERRFR_P0_D3_U_SMXP_3_0,
        .reset = 0xa1,
        .rsvd = 0xffffffffffffff0cL,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_ERRCTLR_P0_D3_U_SMXP_3_0",
        .addr = A_POR_ERRCTLR_P0_D3_U_SMXP_3_0,
        .reset = 0xd,
        .rsvd = 0x3ff2,
        .ro = 0xffffffff00003ff2L,
    },{ .name = "POR_ERRSTATUS_P0_D3_U_SMXP_3_0",
        .addr = A_POR_ERRSTATUS_P0_D3_U_SMXP_3_0,
        .ro = 0xffffffff977f003fL,
    },{ .name = "POR_FDC_AUX_CTL_P0_D3_U_SMXP_3_0",
        .addr = A_POR_FDC_AUX_CTL_P0_D3_U_SMXP_3_0,
        .rsvd = 0xffffffffffffffe0L,
        .ro = 0xffffffffffffffe0L,
    },{ .name = "POR_ERRFR_P1_D0_U_SMXP_3_0",
        .addr = A_POR_ERRFR_P1_D0_U_SMXP_3_0,
        .reset = 0xa1,
        .rsvd = 0xffffffffffffff0cL,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_ERRCTLR_P1_D0_U_SMXP_3_0",
        .addr = A_POR_ERRCTLR_P1_D0_U_SMXP_3_0,
        .reset = 0xd,
        .rsvd = 0x3ff2,
        .ro = 0xffffffff00003ff2L,
    },{ .name = "POR_ERRSTATUS_P1_D0_U_SMXP_3_0",
        .addr = A_POR_ERRSTATUS_P1_D0_U_SMXP_3_0,
        .ro = 0xffffffff977f003fL,
    },{ .name = "POR_FDC_AUX_CTL_P1_D0_U_SMXP_3_0",
        .addr = A_POR_FDC_AUX_CTL_P1_D0_U_SMXP_3_0,
        .rsvd = 0xffffffffffffffe0L,
        .ro = 0xffffffffffffffe0L,
    },{ .name = "POR_ERRFR_P1_D1_U_SMXP_3_0",
        .addr = A_POR_ERRFR_P1_D1_U_SMXP_3_0,
        .reset = 0xa1,
        .rsvd = 0xffffffffffffff0cL,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_ERRCTLR_P1_D1_U_SMXP_3_0",
        .addr = A_POR_ERRCTLR_P1_D1_U_SMXP_3_0,
        .reset = 0xd,
        .rsvd = 0x3ff2,
        .ro = 0xffffffff00003ff2L,
    },{ .name = "POR_ERRSTATUS_P1_D1_U_SMXP_3_0",
        .addr = A_POR_ERRSTATUS_P1_D1_U_SMXP_3_0,
        .ro = 0xffffffff977f003fL,
    },{ .name = "POR_FDC_AUX_CTL_P1_D1_U_SMXP_3_0",
        .addr = A_POR_FDC_AUX_CTL_P1_D1_U_SMXP_3_0,
        .rsvd = 0xffffffffffffffe0L,
        .ro = 0xffffffffffffffe0L,
    },{ .name = "POR_ERRFR_P1_D2_U_SMXP_3_0",
        .addr = A_POR_ERRFR_P1_D2_U_SMXP_3_0,
        .reset = 0xa1,
        .rsvd = 0xffffffffffffff0cL,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_ERRCTLR_P1_D2_U_SMXP_3_0",
        .addr = A_POR_ERRCTLR_P1_D2_U_SMXP_3_0,
        .reset = 0xd,
        .rsvd = 0x3ff2,
        .ro = 0xffffffff00003ff2L,
    },{ .name = "POR_ERRSTATUS_P1_D2_U_SMXP_3_0",
        .addr = A_POR_ERRSTATUS_P1_D2_U_SMXP_3_0,
        .ro = 0xffffffff977f003fL,
    },{ .name = "POR_FDC_AUX_CTL_P1_D2_U_SMXP_3_0",
        .addr = A_POR_FDC_AUX_CTL_P1_D2_U_SMXP_3_0,
        .rsvd = 0xffffffffffffffe0L,
        .ro = 0xffffffffffffffe0L,
    },{ .name = "POR_ERRFR_P1_D3_U_SMXP_3_0",
        .addr = A_POR_ERRFR_P1_D3_U_SMXP_3_0,
        .reset = 0xa1,
        .rsvd = 0xffffffffffffff0cL,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_ERRCTLR_P1_D3_U_SMXP_3_0",
        .addr = A_POR_ERRCTLR_P1_D3_U_SMXP_3_0,
        .reset = 0xd,
        .rsvd = 0x3ff2,
        .ro = 0xffffffff00003ff2L,
    },{ .name = "POR_ERRSTATUS_P1_D3_U_SMXP_3_0",
        .addr = A_POR_ERRSTATUS_P1_D3_U_SMXP_3_0,
        .ro = 0xffffffff977f003fL,
    },{ .name = "POR_FDC_AUX_CTL_P1_D3_U_SMXP_3_0",
        .addr = A_POR_FDC_AUX_CTL_P1_D3_U_SMXP_3_0,
        .rsvd = 0xffffffffffffffe0L,
        .ro = 0xffffffffffffffe0L,
    },{ .name = "POR_ERRINJECT_U_SMXP_3_0",  .addr = A_POR_ERRINJECT_U_SMXP_3_0,
        .rsvd = 0xffffffffffffff00L,
        .ro = 0xffffffffffffff00L,
    },{ .name = "POR_FDC_KEY_U_SMXP_3_0",  .addr = A_POR_FDC_KEY_U_SMXP_3_0,
        .reset = 0xbe,
        .rsvd = 0xffffffffffffff00L,
        .ro = 0xffffffffffffff00L,
    },{ .name = "POR_MPU_NODE_INFO_U_SMXP_3_0",
        .addr = A_POR_MPU_NODE_INFO_U_SMXP_3_0,
        .reset = 0x202,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MPU_CHILD_INFO_U_SMXP_3_0",
        .addr = A_POR_MPU_CHILD_INFO_U_SMXP_3_0,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MPU_UNIT_INFO_U_SMXP_3_0",
        .addr = A_POR_MPU_UNIT_INFO_U_SMXP_3_0,
        .reset = 0x20,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MPU_M0_CTL_U_SMXP_3_0",
        .addr = A_POR_MPU_M0_CTL_U_SMXP_3_0,
        .reset = 0x2,
        .rsvd = 0xfffffffffffffff8L,
        .ro = 0xfffffffffffffff8L,
    },{ .name = "POR_MPU_M0_PRBAR0_U_SMXP_3_0",
        .addr = A_POR_MPU_M0_PRBAR0_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR0_U_SMXP_3_0",
        .addr = A_POR_MPU_M0_PRLAR0_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR1_U_SMXP_3_0",
        .addr = A_POR_MPU_M0_PRBAR1_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR1_U_SMXP_3_0",
        .addr = A_POR_MPU_M0_PRLAR1_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR2_U_SMXP_3_0",
        .addr = A_POR_MPU_M0_PRBAR2_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR2_U_SMXP_3_0",
        .addr = A_POR_MPU_M0_PRLAR2_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR3_U_SMXP_3_0",
        .addr = A_POR_MPU_M0_PRBAR3_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR3_U_SMXP_3_0",
        .addr = A_POR_MPU_M0_PRLAR3_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR4_U_SMXP_3_0",
        .addr = A_POR_MPU_M0_PRBAR4_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR4_U_SMXP_3_0",
        .addr = A_POR_MPU_M0_PRLAR4_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR5_U_SMXP_3_0",
        .addr = A_POR_MPU_M0_PRBAR5_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR5_U_SMXP_3_0",
        .addr = A_POR_MPU_M0_PRLAR5_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR6_U_SMXP_3_0",
        .addr = A_POR_MPU_M0_PRBAR6_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR6_U_SMXP_3_0",
        .addr = A_POR_MPU_M0_PRLAR6_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR7_U_SMXP_3_0",
        .addr = A_POR_MPU_M0_PRBAR7_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR7_U_SMXP_3_0",
        .addr = A_POR_MPU_M0_PRLAR7_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR8_U_SMXP_3_0",
        .addr = A_POR_MPU_M0_PRBAR8_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR8_U_SMXP_3_0",
        .addr = A_POR_MPU_M0_PRLAR8_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR9_U_SMXP_3_0",
        .addr = A_POR_MPU_M0_PRBAR9_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR9_U_SMXP_3_0",
        .addr = A_POR_MPU_M0_PRLAR9_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR10_U_SMXP_3_0",
        .addr = A_POR_MPU_M0_PRBAR10_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR10_U_SMXP_3_0",
        .addr = A_POR_MPU_M0_PRLAR10_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR11_U_SMXP_3_0",
        .addr = A_POR_MPU_M0_PRBAR11_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR11_U_SMXP_3_0",
        .addr = A_POR_MPU_M0_PRLAR11_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR12_U_SMXP_3_0",
        .addr = A_POR_MPU_M0_PRBAR12_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR12_U_SMXP_3_0",
        .addr = A_POR_MPU_M0_PRLAR12_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR13_U_SMXP_3_0",
        .addr = A_POR_MPU_M0_PRBAR13_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR13_U_SMXP_3_0",
        .addr = A_POR_MPU_M0_PRLAR13_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR14_U_SMXP_3_0",
        .addr = A_POR_MPU_M0_PRBAR14_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR14_U_SMXP_3_0",
        .addr = A_POR_MPU_M0_PRLAR14_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR15_U_SMXP_3_0",
        .addr = A_POR_MPU_M0_PRBAR15_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR15_U_SMXP_3_0",
        .addr = A_POR_MPU_M0_PRLAR15_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR16_U_SMXP_3_0",
        .addr = A_POR_MPU_M0_PRBAR16_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR16_U_SMXP_3_0",
        .addr = A_POR_MPU_M0_PRLAR16_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR17_U_SMXP_3_0",
        .addr = A_POR_MPU_M0_PRBAR17_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR17_U_SMXP_3_0",
        .addr = A_POR_MPU_M0_PRLAR17_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR18_U_SMXP_3_0",
        .addr = A_POR_MPU_M0_PRBAR18_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR18_U_SMXP_3_0",
        .addr = A_POR_MPU_M0_PRLAR18_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR19_U_SMXP_3_0",
        .addr = A_POR_MPU_M0_PRBAR19_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR19_U_SMXP_3_0",
        .addr = A_POR_MPU_M0_PRLAR19_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR20_U_SMXP_3_0",
        .addr = A_POR_MPU_M0_PRBAR20_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR20_U_SMXP_3_0",
        .addr = A_POR_MPU_M0_PRLAR20_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR21_U_SMXP_3_0",
        .addr = A_POR_MPU_M0_PRBAR21_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR21_U_SMXP_3_0",
        .addr = A_POR_MPU_M0_PRLAR21_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR22_U_SMXP_3_0",
        .addr = A_POR_MPU_M0_PRBAR22_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR22_U_SMXP_3_0",
        .addr = A_POR_MPU_M0_PRLAR22_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR23_U_SMXP_3_0",
        .addr = A_POR_MPU_M0_PRBAR23_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR23_U_SMXP_3_0",
        .addr = A_POR_MPU_M0_PRLAR23_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR24_U_SMXP_3_0",
        .addr = A_POR_MPU_M0_PRBAR24_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR24_U_SMXP_3_0",
        .addr = A_POR_MPU_M0_PRLAR24_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR25_U_SMXP_3_0",
        .addr = A_POR_MPU_M0_PRBAR25_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR25_U_SMXP_3_0",
        .addr = A_POR_MPU_M0_PRLAR25_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR26_U_SMXP_3_0",
        .addr = A_POR_MPU_M0_PRBAR26_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR26_U_SMXP_3_0",
        .addr = A_POR_MPU_M0_PRLAR26_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR27_U_SMXP_3_0",
        .addr = A_POR_MPU_M0_PRBAR27_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR27_U_SMXP_3_0",
        .addr = A_POR_MPU_M0_PRLAR27_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR28_U_SMXP_3_0",
        .addr = A_POR_MPU_M0_PRBAR28_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR28_U_SMXP_3_0",
        .addr = A_POR_MPU_M0_PRLAR28_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR29_U_SMXP_3_0",
        .addr = A_POR_MPU_M0_PRBAR29_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR29_U_SMXP_3_0",
        .addr = A_POR_MPU_M0_PRLAR29_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR30_U_SMXP_3_0",
        .addr = A_POR_MPU_M0_PRBAR30_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR30_U_SMXP_3_0",
        .addr = A_POR_MPU_M0_PRLAR30_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR31_U_SMXP_3_0",
        .addr = A_POR_MPU_M0_PRBAR31_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR31_U_SMXP_3_0",
        .addr = A_POR_MPU_M0_PRLAR31_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_CTL_U_SMXP_3_0",
        .addr = A_POR_MPU_M1_CTL_U_SMXP_3_0,
        .reset = 0x2,
        .rsvd = 0xfffffffffffffff8L,
        .ro = 0xfffffffffffffff8L,
    },{ .name = "POR_MPU_M1_PRBAR0_U_SMXP_3_0",
        .addr = A_POR_MPU_M1_PRBAR0_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR0_U_SMXP_3_0",
        .addr = A_POR_MPU_M1_PRLAR0_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR1_U_SMXP_3_0",
        .addr = A_POR_MPU_M1_PRBAR1_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR1_U_SMXP_3_0",
        .addr = A_POR_MPU_M1_PRLAR1_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR2_U_SMXP_3_0",
        .addr = A_POR_MPU_M1_PRBAR2_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR2_U_SMXP_3_0",
        .addr = A_POR_MPU_M1_PRLAR2_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR3_U_SMXP_3_0",
        .addr = A_POR_MPU_M1_PRBAR3_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR3_U_SMXP_3_0",
        .addr = A_POR_MPU_M1_PRLAR3_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR4_U_SMXP_3_0",
        .addr = A_POR_MPU_M1_PRBAR4_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR4_U_SMXP_3_0",
        .addr = A_POR_MPU_M1_PRLAR4_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR5_U_SMXP_3_0",
        .addr = A_POR_MPU_M1_PRBAR5_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR5_U_SMXP_3_0",
        .addr = A_POR_MPU_M1_PRLAR5_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR6_U_SMXP_3_0",
        .addr = A_POR_MPU_M1_PRBAR6_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR6_U_SMXP_3_0",
        .addr = A_POR_MPU_M1_PRLAR6_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR7_U_SMXP_3_0",
        .addr = A_POR_MPU_M1_PRBAR7_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR7_U_SMXP_3_0",
        .addr = A_POR_MPU_M1_PRLAR7_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR8_U_SMXP_3_0",
        .addr = A_POR_MPU_M1_PRBAR8_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR8_U_SMXP_3_0",
        .addr = A_POR_MPU_M1_PRLAR8_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR9_U_SMXP_3_0",
        .addr = A_POR_MPU_M1_PRBAR9_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR9_U_SMXP_3_0",
        .addr = A_POR_MPU_M1_PRLAR9_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR10_U_SMXP_3_0",
        .addr = A_POR_MPU_M1_PRBAR10_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR10_U_SMXP_3_0",
        .addr = A_POR_MPU_M1_PRLAR10_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR11_U_SMXP_3_0",
        .addr = A_POR_MPU_M1_PRBAR11_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR11_U_SMXP_3_0",
        .addr = A_POR_MPU_M1_PRLAR11_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR12_U_SMXP_3_0",
        .addr = A_POR_MPU_M1_PRBAR12_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR12_U_SMXP_3_0",
        .addr = A_POR_MPU_M1_PRLAR12_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR13_U_SMXP_3_0",
        .addr = A_POR_MPU_M1_PRBAR13_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR13_U_SMXP_3_0",
        .addr = A_POR_MPU_M1_PRLAR13_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR14_U_SMXP_3_0",
        .addr = A_POR_MPU_M1_PRBAR14_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR14_U_SMXP_3_0",
        .addr = A_POR_MPU_M1_PRLAR14_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR15_U_SMXP_3_0",
        .addr = A_POR_MPU_M1_PRBAR15_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR15_U_SMXP_3_0",
        .addr = A_POR_MPU_M1_PRLAR15_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR16_U_SMXP_3_0",
        .addr = A_POR_MPU_M1_PRBAR16_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR16_U_SMXP_3_0",
        .addr = A_POR_MPU_M1_PRLAR16_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR17_U_SMXP_3_0",
        .addr = A_POR_MPU_M1_PRBAR17_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR17_U_SMXP_3_0",
        .addr = A_POR_MPU_M1_PRLAR17_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR18_U_SMXP_3_0",
        .addr = A_POR_MPU_M1_PRBAR18_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR18_U_SMXP_3_0",
        .addr = A_POR_MPU_M1_PRLAR18_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR19_U_SMXP_3_0",
        .addr = A_POR_MPU_M1_PRBAR19_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR19_U_SMXP_3_0",
        .addr = A_POR_MPU_M1_PRLAR19_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR20_U_SMXP_3_0",
        .addr = A_POR_MPU_M1_PRBAR20_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR20_U_SMXP_3_0",
        .addr = A_POR_MPU_M1_PRLAR20_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR21_U_SMXP_3_0",
        .addr = A_POR_MPU_M1_PRBAR21_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR21_U_SMXP_3_0",
        .addr = A_POR_MPU_M1_PRLAR21_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR22_U_SMXP_3_0",
        .addr = A_POR_MPU_M1_PRBAR22_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR22_U_SMXP_3_0",
        .addr = A_POR_MPU_M1_PRLAR22_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR23_U_SMXP_3_0",
        .addr = A_POR_MPU_M1_PRBAR23_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR23_U_SMXP_3_0",
        .addr = A_POR_MPU_M1_PRLAR23_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR24_U_SMXP_3_0",
        .addr = A_POR_MPU_M1_PRBAR24_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR24_U_SMXP_3_0",
        .addr = A_POR_MPU_M1_PRLAR24_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR25_U_SMXP_3_0",
        .addr = A_POR_MPU_M1_PRBAR25_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR25_U_SMXP_3_0",
        .addr = A_POR_MPU_M1_PRLAR25_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR26_U_SMXP_3_0",
        .addr = A_POR_MPU_M1_PRBAR26_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR26_U_SMXP_3_0",
        .addr = A_POR_MPU_M1_PRLAR26_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR27_U_SMXP_3_0",
        .addr = A_POR_MPU_M1_PRBAR27_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR27_U_SMXP_3_0",
        .addr = A_POR_MPU_M1_PRLAR27_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR28_U_SMXP_3_0",
        .addr = A_POR_MPU_M1_PRBAR28_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR28_U_SMXP_3_0",
        .addr = A_POR_MPU_M1_PRLAR28_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR29_U_SMXP_3_0",
        .addr = A_POR_MPU_M1_PRBAR29_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR29_U_SMXP_3_0",
        .addr = A_POR_MPU_M1_PRLAR29_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR30_U_SMXP_3_0",
        .addr = A_POR_MPU_M1_PRBAR30_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR30_U_SMXP_3_0",
        .addr = A_POR_MPU_M1_PRLAR30_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR31_U_SMXP_3_0",
        .addr = A_POR_MPU_M1_PRBAR31_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR31_U_SMXP_3_0",
        .addr = A_POR_MPU_M1_PRLAR31_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_CTL_U_SMXP_3_0",
        .addr = A_POR_MPU_M2_CTL_U_SMXP_3_0,
        .reset = 0x2,
        .rsvd = 0xfffffffffffffff8L,
        .ro = 0xfffffffffffffff8L,
    },{ .name = "POR_MPU_M2_PRBAR0_U_SMXP_3_0",
        .addr = A_POR_MPU_M2_PRBAR0_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR0_U_SMXP_3_0",
        .addr = A_POR_MPU_M2_PRLAR0_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR1_U_SMXP_3_0",
        .addr = A_POR_MPU_M2_PRBAR1_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR1_U_SMXP_3_0",
        .addr = A_POR_MPU_M2_PRLAR1_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR2_U_SMXP_3_0",
        .addr = A_POR_MPU_M2_PRBAR2_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR2_U_SMXP_3_0",
        .addr = A_POR_MPU_M2_PRLAR2_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR3_U_SMXP_3_0",
        .addr = A_POR_MPU_M2_PRBAR3_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR3_U_SMXP_3_0",
        .addr = A_POR_MPU_M2_PRLAR3_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR4_U_SMXP_3_0",
        .addr = A_POR_MPU_M2_PRBAR4_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR4_U_SMXP_3_0",
        .addr = A_POR_MPU_M2_PRLAR4_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR5_U_SMXP_3_0",
        .addr = A_POR_MPU_M2_PRBAR5_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR5_U_SMXP_3_0",
        .addr = A_POR_MPU_M2_PRLAR5_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR6_U_SMXP_3_0",
        .addr = A_POR_MPU_M2_PRBAR6_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR6_U_SMXP_3_0",
        .addr = A_POR_MPU_M2_PRLAR6_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR7_U_SMXP_3_0",
        .addr = A_POR_MPU_M2_PRBAR7_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR7_U_SMXP_3_0",
        .addr = A_POR_MPU_M2_PRLAR7_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR8_U_SMXP_3_0",
        .addr = A_POR_MPU_M2_PRBAR8_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR8_U_SMXP_3_0",
        .addr = A_POR_MPU_M2_PRLAR8_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR9_U_SMXP_3_0",
        .addr = A_POR_MPU_M2_PRBAR9_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR9_U_SMXP_3_0",
        .addr = A_POR_MPU_M2_PRLAR9_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR10_U_SMXP_3_0",
        .addr = A_POR_MPU_M2_PRBAR10_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR10_U_SMXP_3_0",
        .addr = A_POR_MPU_M2_PRLAR10_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR11_U_SMXP_3_0",
        .addr = A_POR_MPU_M2_PRBAR11_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR11_U_SMXP_3_0",
        .addr = A_POR_MPU_M2_PRLAR11_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR12_U_SMXP_3_0",
        .addr = A_POR_MPU_M2_PRBAR12_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR12_U_SMXP_3_0",
        .addr = A_POR_MPU_M2_PRLAR12_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR13_U_SMXP_3_0",
        .addr = A_POR_MPU_M2_PRBAR13_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR13_U_SMXP_3_0",
        .addr = A_POR_MPU_M2_PRLAR13_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR14_U_SMXP_3_0",
        .addr = A_POR_MPU_M2_PRBAR14_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR14_U_SMXP_3_0",
        .addr = A_POR_MPU_M2_PRLAR14_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR15_U_SMXP_3_0",
        .addr = A_POR_MPU_M2_PRBAR15_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR15_U_SMXP_3_0",
        .addr = A_POR_MPU_M2_PRLAR15_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR16_U_SMXP_3_0",
        .addr = A_POR_MPU_M2_PRBAR16_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR16_U_SMXP_3_0",
        .addr = A_POR_MPU_M2_PRLAR16_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR17_U_SMXP_3_0",
        .addr = A_POR_MPU_M2_PRBAR17_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR17_U_SMXP_3_0",
        .addr = A_POR_MPU_M2_PRLAR17_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR18_U_SMXP_3_0",
        .addr = A_POR_MPU_M2_PRBAR18_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR18_U_SMXP_3_0",
        .addr = A_POR_MPU_M2_PRLAR18_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR19_U_SMXP_3_0",
        .addr = A_POR_MPU_M2_PRBAR19_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR19_U_SMXP_3_0",
        .addr = A_POR_MPU_M2_PRLAR19_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR20_U_SMXP_3_0",
        .addr = A_POR_MPU_M2_PRBAR20_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR20_U_SMXP_3_0",
        .addr = A_POR_MPU_M2_PRLAR20_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR21_U_SMXP_3_0",
        .addr = A_POR_MPU_M2_PRBAR21_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR21_U_SMXP_3_0",
        .addr = A_POR_MPU_M2_PRLAR21_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR22_U_SMXP_3_0",
        .addr = A_POR_MPU_M2_PRBAR22_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR22_U_SMXP_3_0",
        .addr = A_POR_MPU_M2_PRLAR22_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR23_U_SMXP_3_0",
        .addr = A_POR_MPU_M2_PRBAR23_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR23_U_SMXP_3_0",
        .addr = A_POR_MPU_M2_PRLAR23_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR24_U_SMXP_3_0",
        .addr = A_POR_MPU_M2_PRBAR24_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR24_U_SMXP_3_0",
        .addr = A_POR_MPU_M2_PRLAR24_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR25_U_SMXP_3_0",
        .addr = A_POR_MPU_M2_PRBAR25_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR25_U_SMXP_3_0",
        .addr = A_POR_MPU_M2_PRLAR25_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR26_U_SMXP_3_0",
        .addr = A_POR_MPU_M2_PRBAR26_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR26_U_SMXP_3_0",
        .addr = A_POR_MPU_M2_PRLAR26_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR27_U_SMXP_3_0",
        .addr = A_POR_MPU_M2_PRBAR27_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR27_U_SMXP_3_0",
        .addr = A_POR_MPU_M2_PRLAR27_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR28_U_SMXP_3_0",
        .addr = A_POR_MPU_M2_PRBAR28_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR28_U_SMXP_3_0",
        .addr = A_POR_MPU_M2_PRLAR28_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR29_U_SMXP_3_0",
        .addr = A_POR_MPU_M2_PRBAR29_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR29_U_SMXP_3_0",
        .addr = A_POR_MPU_M2_PRLAR29_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR30_U_SMXP_3_0",
        .addr = A_POR_MPU_M2_PRBAR30_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR30_U_SMXP_3_0",
        .addr = A_POR_MPU_M2_PRLAR30_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR31_U_SMXP_3_0",
        .addr = A_POR_MPU_M2_PRBAR31_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR31_U_SMXP_3_0",
        .addr = A_POR_MPU_M2_PRLAR31_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_CTL_U_SMXP_3_0",
        .addr = A_POR_MPU_M3_CTL_U_SMXP_3_0,
        .reset = 0x2,
        .rsvd = 0xfffffffffffffff8L,
        .ro = 0xfffffffffffffff8L,
    },{ .name = "POR_MPU_M3_PRBAR0_U_SMXP_3_0",
        .addr = A_POR_MPU_M3_PRBAR0_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR0_U_SMXP_3_0",
        .addr = A_POR_MPU_M3_PRLAR0_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR1_U_SMXP_3_0",
        .addr = A_POR_MPU_M3_PRBAR1_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR1_U_SMXP_3_0",
        .addr = A_POR_MPU_M3_PRLAR1_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR2_U_SMXP_3_0",
        .addr = A_POR_MPU_M3_PRBAR2_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR2_U_SMXP_3_0",
        .addr = A_POR_MPU_M3_PRLAR2_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR3_U_SMXP_3_0",
        .addr = A_POR_MPU_M3_PRBAR3_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR3_U_SMXP_3_0",
        .addr = A_POR_MPU_M3_PRLAR3_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR4_U_SMXP_3_0",
        .addr = A_POR_MPU_M3_PRBAR4_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR4_U_SMXP_3_0",
        .addr = A_POR_MPU_M3_PRLAR4_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR5_U_SMXP_3_0",
        .addr = A_POR_MPU_M3_PRBAR5_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR5_U_SMXP_3_0",
        .addr = A_POR_MPU_M3_PRLAR5_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR6_U_SMXP_3_0",
        .addr = A_POR_MPU_M3_PRBAR6_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR6_U_SMXP_3_0",
        .addr = A_POR_MPU_M3_PRLAR6_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR7_U_SMXP_3_0",
        .addr = A_POR_MPU_M3_PRBAR7_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR7_U_SMXP_3_0",
        .addr = A_POR_MPU_M3_PRLAR7_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR8_U_SMXP_3_0",
        .addr = A_POR_MPU_M3_PRBAR8_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR8_U_SMXP_3_0",
        .addr = A_POR_MPU_M3_PRLAR8_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR9_U_SMXP_3_0",
        .addr = A_POR_MPU_M3_PRBAR9_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR9_U_SMXP_3_0",
        .addr = A_POR_MPU_M3_PRLAR9_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR10_U_SMXP_3_0",
        .addr = A_POR_MPU_M3_PRBAR10_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR10_U_SMXP_3_0",
        .addr = A_POR_MPU_M3_PRLAR10_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR11_U_SMXP_3_0",
        .addr = A_POR_MPU_M3_PRBAR11_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR11_U_SMXP_3_0",
        .addr = A_POR_MPU_M3_PRLAR11_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR12_U_SMXP_3_0",
        .addr = A_POR_MPU_M3_PRBAR12_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR12_U_SMXP_3_0",
        .addr = A_POR_MPU_M3_PRLAR12_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR13_U_SMXP_3_0",
        .addr = A_POR_MPU_M3_PRBAR13_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR13_U_SMXP_3_0",
        .addr = A_POR_MPU_M3_PRLAR13_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR14_U_SMXP_3_0",
        .addr = A_POR_MPU_M3_PRBAR14_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR14_U_SMXP_3_0",
        .addr = A_POR_MPU_M3_PRLAR14_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR15_U_SMXP_3_0",
        .addr = A_POR_MPU_M3_PRBAR15_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR15_U_SMXP_3_0",
        .addr = A_POR_MPU_M3_PRLAR15_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR16_U_SMXP_3_0",
        .addr = A_POR_MPU_M3_PRBAR16_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR16_U_SMXP_3_0",
        .addr = A_POR_MPU_M3_PRLAR16_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR17_U_SMXP_3_0",
        .addr = A_POR_MPU_M3_PRBAR17_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR17_U_SMXP_3_0",
        .addr = A_POR_MPU_M3_PRLAR17_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR18_U_SMXP_3_0",
        .addr = A_POR_MPU_M3_PRBAR18_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR18_U_SMXP_3_0",
        .addr = A_POR_MPU_M3_PRLAR18_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR19_U_SMXP_3_0",
        .addr = A_POR_MPU_M3_PRBAR19_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR19_U_SMXP_3_0",
        .addr = A_POR_MPU_M3_PRLAR19_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR20_U_SMXP_3_0",
        .addr = A_POR_MPU_M3_PRBAR20_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR20_U_SMXP_3_0",
        .addr = A_POR_MPU_M3_PRLAR20_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR21_U_SMXP_3_0",
        .addr = A_POR_MPU_M3_PRBAR21_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR21_U_SMXP_3_0",
        .addr = A_POR_MPU_M3_PRLAR21_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR22_U_SMXP_3_0",
        .addr = A_POR_MPU_M3_PRBAR22_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR22_U_SMXP_3_0",
        .addr = A_POR_MPU_M3_PRLAR22_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR23_U_SMXP_3_0",
        .addr = A_POR_MPU_M3_PRBAR23_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR23_U_SMXP_3_0",
        .addr = A_POR_MPU_M3_PRLAR23_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR24_U_SMXP_3_0",
        .addr = A_POR_MPU_M3_PRBAR24_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR24_U_SMXP_3_0",
        .addr = A_POR_MPU_M3_PRLAR24_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR25_U_SMXP_3_0",
        .addr = A_POR_MPU_M3_PRBAR25_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR25_U_SMXP_3_0",
        .addr = A_POR_MPU_M3_PRLAR25_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR26_U_SMXP_3_0",
        .addr = A_POR_MPU_M3_PRBAR26_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR26_U_SMXP_3_0",
        .addr = A_POR_MPU_M3_PRLAR26_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR27_U_SMXP_3_0",
        .addr = A_POR_MPU_M3_PRBAR27_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR27_U_SMXP_3_0",
        .addr = A_POR_MPU_M3_PRLAR27_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR28_U_SMXP_3_0",
        .addr = A_POR_MPU_M3_PRBAR28_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR28_U_SMXP_3_0",
        .addr = A_POR_MPU_M3_PRLAR28_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR29_U_SMXP_3_0",
        .addr = A_POR_MPU_M3_PRBAR29_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR29_U_SMXP_3_0",
        .addr = A_POR_MPU_M3_PRLAR29_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR30_U_SMXP_3_0",
        .addr = A_POR_MPU_M3_PRBAR30_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR30_U_SMXP_3_0",
        .addr = A_POR_MPU_M3_PRLAR30_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR31_U_SMXP_3_0",
        .addr = A_POR_MPU_M3_PRBAR31_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR31_U_SMXP_3_0",
        .addr = A_POR_MPU_M3_PRLAR31_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_CTL_U_SMXP_3_0",
        .addr = A_POR_MPU_M4_CTL_U_SMXP_3_0,
        .reset = 0x2,
        .rsvd = 0xfffffffffffffff8L,
        .ro = 0xfffffffffffffff8L,
    },{ .name = "POR_MPU_M4_PRBAR0_U_SMXP_3_0",
        .addr = A_POR_MPU_M4_PRBAR0_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR0_U_SMXP_3_0",
        .addr = A_POR_MPU_M4_PRLAR0_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR1_U_SMXP_3_0",
        .addr = A_POR_MPU_M4_PRBAR1_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR1_U_SMXP_3_0",
        .addr = A_POR_MPU_M4_PRLAR1_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR2_U_SMXP_3_0",
        .addr = A_POR_MPU_M4_PRBAR2_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR2_U_SMXP_3_0",
        .addr = A_POR_MPU_M4_PRLAR2_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR3_U_SMXP_3_0",
        .addr = A_POR_MPU_M4_PRBAR3_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR3_U_SMXP_3_0",
        .addr = A_POR_MPU_M4_PRLAR3_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR4_U_SMXP_3_0",
        .addr = A_POR_MPU_M4_PRBAR4_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR4_U_SMXP_3_0",
        .addr = A_POR_MPU_M4_PRLAR4_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR5_U_SMXP_3_0",
        .addr = A_POR_MPU_M4_PRBAR5_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR5_U_SMXP_3_0",
        .addr = A_POR_MPU_M4_PRLAR5_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR6_U_SMXP_3_0",
        .addr = A_POR_MPU_M4_PRBAR6_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR6_U_SMXP_3_0",
        .addr = A_POR_MPU_M4_PRLAR6_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR7_U_SMXP_3_0",
        .addr = A_POR_MPU_M4_PRBAR7_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR7_U_SMXP_3_0",
        .addr = A_POR_MPU_M4_PRLAR7_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR8_U_SMXP_3_0",
        .addr = A_POR_MPU_M4_PRBAR8_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR8_U_SMXP_3_0",
        .addr = A_POR_MPU_M4_PRLAR8_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR9_U_SMXP_3_0",
        .addr = A_POR_MPU_M4_PRBAR9_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR9_U_SMXP_3_0",
        .addr = A_POR_MPU_M4_PRLAR9_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR10_U_SMXP_3_0",
        .addr = A_POR_MPU_M4_PRBAR10_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR10_U_SMXP_3_0",
        .addr = A_POR_MPU_M4_PRLAR10_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR11_U_SMXP_3_0",
        .addr = A_POR_MPU_M4_PRBAR11_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR11_U_SMXP_3_0",
        .addr = A_POR_MPU_M4_PRLAR11_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR12_U_SMXP_3_0",
        .addr = A_POR_MPU_M4_PRBAR12_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR12_U_SMXP_3_0",
        .addr = A_POR_MPU_M4_PRLAR12_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR13_U_SMXP_3_0",
        .addr = A_POR_MPU_M4_PRBAR13_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR13_U_SMXP_3_0",
        .addr = A_POR_MPU_M4_PRLAR13_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR14_U_SMXP_3_0",
        .addr = A_POR_MPU_M4_PRBAR14_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR14_U_SMXP_3_0",
        .addr = A_POR_MPU_M4_PRLAR14_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR15_U_SMXP_3_0",
        .addr = A_POR_MPU_M4_PRBAR15_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR15_U_SMXP_3_0",
        .addr = A_POR_MPU_M4_PRLAR15_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR16_U_SMXP_3_0",
        .addr = A_POR_MPU_M4_PRBAR16_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR16_U_SMXP_3_0",
        .addr = A_POR_MPU_M4_PRLAR16_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR17_U_SMXP_3_0",
        .addr = A_POR_MPU_M4_PRBAR17_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR17_U_SMXP_3_0",
        .addr = A_POR_MPU_M4_PRLAR17_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR18_U_SMXP_3_0",
        .addr = A_POR_MPU_M4_PRBAR18_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR18_U_SMXP_3_0",
        .addr = A_POR_MPU_M4_PRLAR18_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR19_U_SMXP_3_0",
        .addr = A_POR_MPU_M4_PRBAR19_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR19_U_SMXP_3_0",
        .addr = A_POR_MPU_M4_PRLAR19_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR20_U_SMXP_3_0",
        .addr = A_POR_MPU_M4_PRBAR20_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR20_U_SMXP_3_0",
        .addr = A_POR_MPU_M4_PRLAR20_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR21_U_SMXP_3_0",
        .addr = A_POR_MPU_M4_PRBAR21_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR21_U_SMXP_3_0",
        .addr = A_POR_MPU_M4_PRLAR21_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR22_U_SMXP_3_0",
        .addr = A_POR_MPU_M4_PRBAR22_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR22_U_SMXP_3_0",
        .addr = A_POR_MPU_M4_PRLAR22_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR23_U_SMXP_3_0",
        .addr = A_POR_MPU_M4_PRBAR23_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR23_U_SMXP_3_0",
        .addr = A_POR_MPU_M4_PRLAR23_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR24_U_SMXP_3_0",
        .addr = A_POR_MPU_M4_PRBAR24_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR24_U_SMXP_3_0",
        .addr = A_POR_MPU_M4_PRLAR24_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR25_U_SMXP_3_0",
        .addr = A_POR_MPU_M4_PRBAR25_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR25_U_SMXP_3_0",
        .addr = A_POR_MPU_M4_PRLAR25_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR26_U_SMXP_3_0",
        .addr = A_POR_MPU_M4_PRBAR26_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR26_U_SMXP_3_0",
        .addr = A_POR_MPU_M4_PRLAR26_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR27_U_SMXP_3_0",
        .addr = A_POR_MPU_M4_PRBAR27_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR27_U_SMXP_3_0",
        .addr = A_POR_MPU_M4_PRLAR27_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR28_U_SMXP_3_0",
        .addr = A_POR_MPU_M4_PRBAR28_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR28_U_SMXP_3_0",
        .addr = A_POR_MPU_M4_PRLAR28_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR29_U_SMXP_3_0",
        .addr = A_POR_MPU_M4_PRBAR29_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR29_U_SMXP_3_0",
        .addr = A_POR_MPU_M4_PRLAR29_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR30_U_SMXP_3_0",
        .addr = A_POR_MPU_M4_PRBAR30_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR30_U_SMXP_3_0",
        .addr = A_POR_MPU_M4_PRLAR30_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR31_U_SMXP_3_0",
        .addr = A_POR_MPU_M4_PRBAR31_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR31_U_SMXP_3_0",
        .addr = A_POR_MPU_M4_PRLAR31_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_CTL_U_SMXP_3_0",
        .addr = A_POR_MPU_M5_CTL_U_SMXP_3_0,
        .reset = 0x2,
        .rsvd = 0xfffffffffffffff8L,
        .ro = 0xfffffffffffffff8L,
    },{ .name = "POR_MPU_M5_PRBAR0_U_SMXP_3_0",
        .addr = A_POR_MPU_M5_PRBAR0_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR0_U_SMXP_3_0",
        .addr = A_POR_MPU_M5_PRLAR0_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR1_U_SMXP_3_0",
        .addr = A_POR_MPU_M5_PRBAR1_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR1_U_SMXP_3_0",
        .addr = A_POR_MPU_M5_PRLAR1_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR2_U_SMXP_3_0",
        .addr = A_POR_MPU_M5_PRBAR2_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR2_U_SMXP_3_0",
        .addr = A_POR_MPU_M5_PRLAR2_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR3_U_SMXP_3_0",
        .addr = A_POR_MPU_M5_PRBAR3_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR3_U_SMXP_3_0",
        .addr = A_POR_MPU_M5_PRLAR3_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR4_U_SMXP_3_0",
        .addr = A_POR_MPU_M5_PRBAR4_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR4_U_SMXP_3_0",
        .addr = A_POR_MPU_M5_PRLAR4_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR5_U_SMXP_3_0",
        .addr = A_POR_MPU_M5_PRBAR5_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR5_U_SMXP_3_0",
        .addr = A_POR_MPU_M5_PRLAR5_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR6_U_SMXP_3_0",
        .addr = A_POR_MPU_M5_PRBAR6_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR6_U_SMXP_3_0",
        .addr = A_POR_MPU_M5_PRLAR6_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR7_U_SMXP_3_0",
        .addr = A_POR_MPU_M5_PRBAR7_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR7_U_SMXP_3_0",
        .addr = A_POR_MPU_M5_PRLAR7_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR8_U_SMXP_3_0",
        .addr = A_POR_MPU_M5_PRBAR8_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR8_U_SMXP_3_0",
        .addr = A_POR_MPU_M5_PRLAR8_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR9_U_SMXP_3_0",
        .addr = A_POR_MPU_M5_PRBAR9_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR9_U_SMXP_3_0",
        .addr = A_POR_MPU_M5_PRLAR9_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR10_U_SMXP_3_0",
        .addr = A_POR_MPU_M5_PRBAR10_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR10_U_SMXP_3_0",
        .addr = A_POR_MPU_M5_PRLAR10_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR11_U_SMXP_3_0",
        .addr = A_POR_MPU_M5_PRBAR11_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR11_U_SMXP_3_0",
        .addr = A_POR_MPU_M5_PRLAR11_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR12_U_SMXP_3_0",
        .addr = A_POR_MPU_M5_PRBAR12_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR12_U_SMXP_3_0",
        .addr = A_POR_MPU_M5_PRLAR12_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR13_U_SMXP_3_0",
        .addr = A_POR_MPU_M5_PRBAR13_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR13_U_SMXP_3_0",
        .addr = A_POR_MPU_M5_PRLAR13_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR14_U_SMXP_3_0",
        .addr = A_POR_MPU_M5_PRBAR14_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR14_U_SMXP_3_0",
        .addr = A_POR_MPU_M5_PRLAR14_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR15_U_SMXP_3_0",
        .addr = A_POR_MPU_M5_PRBAR15_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR15_U_SMXP_3_0",
        .addr = A_POR_MPU_M5_PRLAR15_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR16_U_SMXP_3_0",
        .addr = A_POR_MPU_M5_PRBAR16_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR16_U_SMXP_3_0",
        .addr = A_POR_MPU_M5_PRLAR16_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR17_U_SMXP_3_0",
        .addr = A_POR_MPU_M5_PRBAR17_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR17_U_SMXP_3_0",
        .addr = A_POR_MPU_M5_PRLAR17_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR18_U_SMXP_3_0",
        .addr = A_POR_MPU_M5_PRBAR18_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR18_U_SMXP_3_0",
        .addr = A_POR_MPU_M5_PRLAR18_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR19_U_SMXP_3_0",
        .addr = A_POR_MPU_M5_PRBAR19_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR19_U_SMXP_3_0",
        .addr = A_POR_MPU_M5_PRLAR19_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR20_U_SMXP_3_0",
        .addr = A_POR_MPU_M5_PRBAR20_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR20_U_SMXP_3_0",
        .addr = A_POR_MPU_M5_PRLAR20_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR21_U_SMXP_3_0",
        .addr = A_POR_MPU_M5_PRBAR21_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR21_U_SMXP_3_0",
        .addr = A_POR_MPU_M5_PRLAR21_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR22_U_SMXP_3_0",
        .addr = A_POR_MPU_M5_PRBAR22_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR22_U_SMXP_3_0",
        .addr = A_POR_MPU_M5_PRLAR22_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR23_U_SMXP_3_0",
        .addr = A_POR_MPU_M5_PRBAR23_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR23_U_SMXP_3_0",
        .addr = A_POR_MPU_M5_PRLAR23_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR24_U_SMXP_3_0",
        .addr = A_POR_MPU_M5_PRBAR24_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR24_U_SMXP_3_0",
        .addr = A_POR_MPU_M5_PRLAR24_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR25_U_SMXP_3_0",
        .addr = A_POR_MPU_M5_PRBAR25_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR25_U_SMXP_3_0",
        .addr = A_POR_MPU_M5_PRLAR25_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR26_U_SMXP_3_0",
        .addr = A_POR_MPU_M5_PRBAR26_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR26_U_SMXP_3_0",
        .addr = A_POR_MPU_M5_PRLAR26_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR27_U_SMXP_3_0",
        .addr = A_POR_MPU_M5_PRBAR27_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR27_U_SMXP_3_0",
        .addr = A_POR_MPU_M5_PRLAR27_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR28_U_SMXP_3_0",
        .addr = A_POR_MPU_M5_PRBAR28_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR28_U_SMXP_3_0",
        .addr = A_POR_MPU_M5_PRLAR28_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR29_U_SMXP_3_0",
        .addr = A_POR_MPU_M5_PRBAR29_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR29_U_SMXP_3_0",
        .addr = A_POR_MPU_M5_PRLAR29_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR30_U_SMXP_3_0",
        .addr = A_POR_MPU_M5_PRBAR30_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR30_U_SMXP_3_0",
        .addr = A_POR_MPU_M5_PRLAR30_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR31_U_SMXP_3_0",
        .addr = A_POR_MPU_M5_PRBAR31_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR31_U_SMXP_3_0",
        .addr = A_POR_MPU_M5_PRLAR31_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_CTL_U_SMXP_3_0",
        .addr = A_POR_MPU_M6_CTL_U_SMXP_3_0,
        .reset = 0x2,
        .rsvd = 0xfffffffffffffff8L,
        .ro = 0xfffffffffffffff8L,
    },{ .name = "POR_MPU_M6_PRBAR0_U_SMXP_3_0",
        .addr = A_POR_MPU_M6_PRBAR0_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR0_U_SMXP_3_0",
        .addr = A_POR_MPU_M6_PRLAR0_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR1_U_SMXP_3_0",
        .addr = A_POR_MPU_M6_PRBAR1_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR1_U_SMXP_3_0",
        .addr = A_POR_MPU_M6_PRLAR1_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR2_U_SMXP_3_0",
        .addr = A_POR_MPU_M6_PRBAR2_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR2_U_SMXP_3_0",
        .addr = A_POR_MPU_M6_PRLAR2_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR3_U_SMXP_3_0",
        .addr = A_POR_MPU_M6_PRBAR3_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR3_U_SMXP_3_0",
        .addr = A_POR_MPU_M6_PRLAR3_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR4_U_SMXP_3_0",
        .addr = A_POR_MPU_M6_PRBAR4_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR4_U_SMXP_3_0",
        .addr = A_POR_MPU_M6_PRLAR4_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR5_U_SMXP_3_0",
        .addr = A_POR_MPU_M6_PRBAR5_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR5_U_SMXP_3_0",
        .addr = A_POR_MPU_M6_PRLAR5_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR6_U_SMXP_3_0",
        .addr = A_POR_MPU_M6_PRBAR6_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR6_U_SMXP_3_0",
        .addr = A_POR_MPU_M6_PRLAR6_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR7_U_SMXP_3_0",
        .addr = A_POR_MPU_M6_PRBAR7_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR7_U_SMXP_3_0",
        .addr = A_POR_MPU_M6_PRLAR7_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR8_U_SMXP_3_0",
        .addr = A_POR_MPU_M6_PRBAR8_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR8_U_SMXP_3_0",
        .addr = A_POR_MPU_M6_PRLAR8_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR9_U_SMXP_3_0",
        .addr = A_POR_MPU_M6_PRBAR9_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR9_U_SMXP_3_0",
        .addr = A_POR_MPU_M6_PRLAR9_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR10_U_SMXP_3_0",
        .addr = A_POR_MPU_M6_PRBAR10_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR10_U_SMXP_3_0",
        .addr = A_POR_MPU_M6_PRLAR10_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR11_U_SMXP_3_0",
        .addr = A_POR_MPU_M6_PRBAR11_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR11_U_SMXP_3_0",
        .addr = A_POR_MPU_M6_PRLAR11_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR12_U_SMXP_3_0",
        .addr = A_POR_MPU_M6_PRBAR12_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR12_U_SMXP_3_0",
        .addr = A_POR_MPU_M6_PRLAR12_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR13_U_SMXP_3_0",
        .addr = A_POR_MPU_M6_PRBAR13_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR13_U_SMXP_3_0",
        .addr = A_POR_MPU_M6_PRLAR13_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR14_U_SMXP_3_0",
        .addr = A_POR_MPU_M6_PRBAR14_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR14_U_SMXP_3_0",
        .addr = A_POR_MPU_M6_PRLAR14_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR15_U_SMXP_3_0",
        .addr = A_POR_MPU_M6_PRBAR15_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR15_U_SMXP_3_0",
        .addr = A_POR_MPU_M6_PRLAR15_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR16_U_SMXP_3_0",
        .addr = A_POR_MPU_M6_PRBAR16_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR16_U_SMXP_3_0",
        .addr = A_POR_MPU_M6_PRLAR16_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR17_U_SMXP_3_0",
        .addr = A_POR_MPU_M6_PRBAR17_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR17_U_SMXP_3_0",
        .addr = A_POR_MPU_M6_PRLAR17_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR18_U_SMXP_3_0",
        .addr = A_POR_MPU_M6_PRBAR18_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR18_U_SMXP_3_0",
        .addr = A_POR_MPU_M6_PRLAR18_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR19_U_SMXP_3_0",
        .addr = A_POR_MPU_M6_PRBAR19_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR19_U_SMXP_3_0",
        .addr = A_POR_MPU_M6_PRLAR19_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR20_U_SMXP_3_0",
        .addr = A_POR_MPU_M6_PRBAR20_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR20_U_SMXP_3_0",
        .addr = A_POR_MPU_M6_PRLAR20_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR21_U_SMXP_3_0",
        .addr = A_POR_MPU_M6_PRBAR21_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR21_U_SMXP_3_0",
        .addr = A_POR_MPU_M6_PRLAR21_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR22_U_SMXP_3_0",
        .addr = A_POR_MPU_M6_PRBAR22_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR22_U_SMXP_3_0",
        .addr = A_POR_MPU_M6_PRLAR22_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR23_U_SMXP_3_0",
        .addr = A_POR_MPU_M6_PRBAR23_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR23_U_SMXP_3_0",
        .addr = A_POR_MPU_M6_PRLAR23_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR24_U_SMXP_3_0",
        .addr = A_POR_MPU_M6_PRBAR24_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR24_U_SMXP_3_0",
        .addr = A_POR_MPU_M6_PRLAR24_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR25_U_SMXP_3_0",
        .addr = A_POR_MPU_M6_PRBAR25_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR25_U_SMXP_3_0",
        .addr = A_POR_MPU_M6_PRLAR25_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR26_U_SMXP_3_0",
        .addr = A_POR_MPU_M6_PRBAR26_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR26_U_SMXP_3_0",
        .addr = A_POR_MPU_M6_PRLAR26_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR27_U_SMXP_3_0",
        .addr = A_POR_MPU_M6_PRBAR27_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR27_U_SMXP_3_0",
        .addr = A_POR_MPU_M6_PRLAR27_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR28_U_SMXP_3_0",
        .addr = A_POR_MPU_M6_PRBAR28_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR28_U_SMXP_3_0",
        .addr = A_POR_MPU_M6_PRLAR28_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR29_U_SMXP_3_0",
        .addr = A_POR_MPU_M6_PRBAR29_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR29_U_SMXP_3_0",
        .addr = A_POR_MPU_M6_PRLAR29_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR30_U_SMXP_3_0",
        .addr = A_POR_MPU_M6_PRBAR30_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR30_U_SMXP_3_0",
        .addr = A_POR_MPU_M6_PRLAR30_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR31_U_SMXP_3_0",
        .addr = A_POR_MPU_M6_PRBAR31_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR31_U_SMXP_3_0",
        .addr = A_POR_MPU_M6_PRLAR31_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_CTL_U_SMXP_3_0",
        .addr = A_POR_MPU_M7_CTL_U_SMXP_3_0,
        .reset = 0x2,
        .rsvd = 0xfffffffffffffff8L,
        .ro = 0xfffffffffffffff8L,
    },{ .name = "POR_MPU_M7_PRBAR0_U_SMXP_3_0",
        .addr = A_POR_MPU_M7_PRBAR0_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR0_U_SMXP_3_0",
        .addr = A_POR_MPU_M7_PRLAR0_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR1_U_SMXP_3_0",
        .addr = A_POR_MPU_M7_PRBAR1_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR1_U_SMXP_3_0",
        .addr = A_POR_MPU_M7_PRLAR1_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR2_U_SMXP_3_0",
        .addr = A_POR_MPU_M7_PRBAR2_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR2_U_SMXP_3_0",
        .addr = A_POR_MPU_M7_PRLAR2_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR3_U_SMXP_3_0",
        .addr = A_POR_MPU_M7_PRBAR3_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR3_U_SMXP_3_0",
        .addr = A_POR_MPU_M7_PRLAR3_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR4_U_SMXP_3_0",
        .addr = A_POR_MPU_M7_PRBAR4_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR4_U_SMXP_3_0",
        .addr = A_POR_MPU_M7_PRLAR4_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR5_U_SMXP_3_0",
        .addr = A_POR_MPU_M7_PRBAR5_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR5_U_SMXP_3_0",
        .addr = A_POR_MPU_M7_PRLAR5_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR6_U_SMXP_3_0",
        .addr = A_POR_MPU_M7_PRBAR6_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR6_U_SMXP_3_0",
        .addr = A_POR_MPU_M7_PRLAR6_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR7_U_SMXP_3_0",
        .addr = A_POR_MPU_M7_PRBAR7_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR7_U_SMXP_3_0",
        .addr = A_POR_MPU_M7_PRLAR7_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR8_U_SMXP_3_0",
        .addr = A_POR_MPU_M7_PRBAR8_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR8_U_SMXP_3_0",
        .addr = A_POR_MPU_M7_PRLAR8_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR9_U_SMXP_3_0",
        .addr = A_POR_MPU_M7_PRBAR9_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR9_U_SMXP_3_0",
        .addr = A_POR_MPU_M7_PRLAR9_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR10_U_SMXP_3_0",
        .addr = A_POR_MPU_M7_PRBAR10_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR10_U_SMXP_3_0",
        .addr = A_POR_MPU_M7_PRLAR10_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR11_U_SMXP_3_0",
        .addr = A_POR_MPU_M7_PRBAR11_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR11_U_SMXP_3_0",
        .addr = A_POR_MPU_M7_PRLAR11_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR12_U_SMXP_3_0",
        .addr = A_POR_MPU_M7_PRBAR12_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR12_U_SMXP_3_0",
        .addr = A_POR_MPU_M7_PRLAR12_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR13_U_SMXP_3_0",
        .addr = A_POR_MPU_M7_PRBAR13_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR13_U_SMXP_3_0",
        .addr = A_POR_MPU_M7_PRLAR13_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR14_U_SMXP_3_0",
        .addr = A_POR_MPU_M7_PRBAR14_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR14_U_SMXP_3_0",
        .addr = A_POR_MPU_M7_PRLAR14_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR15_U_SMXP_3_0",
        .addr = A_POR_MPU_M7_PRBAR15_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR15_U_SMXP_3_0",
        .addr = A_POR_MPU_M7_PRLAR15_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR16_U_SMXP_3_0",
        .addr = A_POR_MPU_M7_PRBAR16_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR16_U_SMXP_3_0",
        .addr = A_POR_MPU_M7_PRLAR16_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR17_U_SMXP_3_0",
        .addr = A_POR_MPU_M7_PRBAR17_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR17_U_SMXP_3_0",
        .addr = A_POR_MPU_M7_PRLAR17_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR18_U_SMXP_3_0",
        .addr = A_POR_MPU_M7_PRBAR18_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR18_U_SMXP_3_0",
        .addr = A_POR_MPU_M7_PRLAR18_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR19_U_SMXP_3_0",
        .addr = A_POR_MPU_M7_PRBAR19_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR19_U_SMXP_3_0",
        .addr = A_POR_MPU_M7_PRLAR19_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR20_U_SMXP_3_0",
        .addr = A_POR_MPU_M7_PRBAR20_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR20_U_SMXP_3_0",
        .addr = A_POR_MPU_M7_PRLAR20_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR21_U_SMXP_3_0",
        .addr = A_POR_MPU_M7_PRBAR21_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR21_U_SMXP_3_0",
        .addr = A_POR_MPU_M7_PRLAR21_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR22_U_SMXP_3_0",
        .addr = A_POR_MPU_M7_PRBAR22_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR22_U_SMXP_3_0",
        .addr = A_POR_MPU_M7_PRLAR22_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR23_U_SMXP_3_0",
        .addr = A_POR_MPU_M7_PRBAR23_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR23_U_SMXP_3_0",
        .addr = A_POR_MPU_M7_PRLAR23_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR24_U_SMXP_3_0",
        .addr = A_POR_MPU_M7_PRBAR24_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR24_U_SMXP_3_0",
        .addr = A_POR_MPU_M7_PRLAR24_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR25_U_SMXP_3_0",
        .addr = A_POR_MPU_M7_PRBAR25_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR25_U_SMXP_3_0",
        .addr = A_POR_MPU_M7_PRLAR25_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR26_U_SMXP_3_0",
        .addr = A_POR_MPU_M7_PRBAR26_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR26_U_SMXP_3_0",
        .addr = A_POR_MPU_M7_PRLAR26_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR27_U_SMXP_3_0",
        .addr = A_POR_MPU_M7_PRBAR27_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR27_U_SMXP_3_0",
        .addr = A_POR_MPU_M7_PRLAR27_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR28_U_SMXP_3_0",
        .addr = A_POR_MPU_M7_PRBAR28_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR28_U_SMXP_3_0",
        .addr = A_POR_MPU_M7_PRLAR28_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR29_U_SMXP_3_0",
        .addr = A_POR_MPU_M7_PRBAR29_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR29_U_SMXP_3_0",
        .addr = A_POR_MPU_M7_PRLAR29_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR30_U_SMXP_3_0",
        .addr = A_POR_MPU_M7_PRBAR30_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR30_U_SMXP_3_0",
        .addr = A_POR_MPU_M7_PRLAR30_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR31_U_SMXP_3_0",
        .addr = A_POR_MPU_M7_PRBAR31_U_SMXP_3_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR31_U_SMXP_3_0",
        .addr = A_POR_MPU_M7_PRLAR31_U_SMXP_3_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_HNF_NODE_INFO_U_HNF_NID200",
        .addr = A_POR_HNF_NODE_INFO_U_HNF_NID200,
        .reset = 0x80005,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_HNF_CHILD_INFO_U_HNF_NID200",
        .addr = A_POR_HNF_CHILD_INFO_U_HNF_NID200,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_HNF_UNIT_INFO_U_HNF_NID200",
        .addr = A_POR_HNF_UNIT_INFO_U_HNF_NID200,
        .reset = 0x4000000000,
        .rsvd = 0x88,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_HNF_SECURE_REGISTER_GROUPS_OVERRIDE_U_HNF_NID200",
        .addr = A_POR_HNF_SECURE_REGISTER_GROUPS_OVERRIDE_U_HNF_NID200,
        .rsvd = 0xffffffffffffffc0L,
        .ro = 0xffffffffffffffc0L,
    },{ .name = "POR_HNF_CFG_CTL_U_HNF_NID200",
        .addr = A_POR_HNF_CFG_CTL_U_HNF_NID200,
        .reset = 0x50,
        .rsvd = 0xaa,
        .ro = 0xfffffffffffff0aaL,
    },{ .name = "POR_HNF_AUX_CTL_U_HNF_NID200",
        .addr = A_POR_HNF_AUX_CTL_U_HNF_NID200,
        .reset = 0x11c4c9000000002,
        .ro = 0xfc60006cfffe0000L,
    },{ .name = "POR_HNF_R2_AUX_CTL_U_HNF_NID200",
        .addr = A_POR_HNF_R2_AUX_CTL_U_HNF_NID200,
        .rsvd = 0xfffffffffffffff0L,
        .ro = 0xfffffffffffffff0L,
    },{ .name = "RDF_HNF_AUX_CTL_U_HNF_NID200",
        .addr = A_RDF_HNF_AUX_CTL_U_HNF_NID200,
        .ro = 0xffffffffffff6cffL,
    },{ .name = "POR_HNF_QOS_BAND_U_HNF_NID200",
        .addr = A_POR_HNF_QOS_BAND_U_HNF_NID200,
        .reset = 0xffecb870,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_HNF_QOS_RESERVATION_U_HNF_NID200",
        .addr = A_POR_HNF_QOS_RESERVATION_U_HNF_NID200,
        .reset = 0x13f3e1f0a,
        .rsvd = 0xc0,
        .ro = 0xffffffc0c0c0c0c0L,
    },{ .name = "POR_HNF_RN_STARVATION_U_HNF_NID200",
        .addr = A_POR_HNF_RN_STARVATION_U_HNF_NID200,
        .reset = 0x1f3f1f3f3f1f,
        .rsvd = 0xe0,
        .ro = 0xffffe0c0e080c0e0L,
    },{ .name = "POR_HNF_CFG_SLCSF_DBGRD_U_HNF_NID200",
        .addr = A_POR_HNF_CFG_SLCSF_DBGRD_U_HNF_NID200,
        .ro = 0xfffffffffc80e000L,
    },{ .name = "POR_HNF_SLC_CACHE_ACCESS_SLC_TAG_U_HNF_NID200",
        .addr = A_POR_HNF_SLC_CACHE_ACCESS_SLC_TAG_U_HNF_NID200,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_HNF_SLC_CACHE_ACCESS_SLC_DATA_U_HNF_NID200",
        .addr = A_POR_HNF_SLC_CACHE_ACCESS_SLC_DATA_U_HNF_NID200,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_HNF_SLC_CACHE_ACCESS_SF_TAG_U_HNF_NID200",
        .addr = A_POR_HNF_SLC_CACHE_ACCESS_SF_TAG_U_HNF_NID200,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_HNF_SLC_CACHE_ACCESS_SF_TAG1_U_HNF_NID200",
        .addr = A_POR_HNF_SLC_CACHE_ACCESS_SF_TAG1_U_HNF_NID200,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_HNF_SLC_CACHE_ACCESS_SF_TAG2_U_HNF_NID200",
        .addr = A_POR_HNF_SLC_CACHE_ACCESS_SF_TAG2_U_HNF_NID200,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_HNF_SLC_LOCK_WAYS_U_HNF_NID200",
        .addr = A_POR_HNF_SLC_LOCK_WAYS_U_HNF_NID200,
        .reset = 0x400,
        .rsvd = 0xf0,
        .ro = 0xffffffffffff80f0L,
    },{ .name = "POR_HNF_SLC_LOCK_BASE0_U_HNF_NID200",
        .addr = A_POR_HNF_SLC_LOCK_BASE0_U_HNF_NID200,
        .ro = 0x7fff000000000000,
    },{ .name = "POR_HNF_SLC_LOCK_BASE1_U_HNF_NID200",
        .addr = A_POR_HNF_SLC_LOCK_BASE1_U_HNF_NID200,
        .ro = 0x7fff000000000000,
    },{ .name = "POR_HNF_SLC_LOCK_BASE2_U_HNF_NID200",
        .addr = A_POR_HNF_SLC_LOCK_BASE2_U_HNF_NID200,
        .ro = 0x7fff000000000000,
    },{ .name = "POR_HNF_SLC_LOCK_BASE3_U_HNF_NID200",
        .addr = A_POR_HNF_SLC_LOCK_BASE3_U_HNF_NID200,
        .ro = 0x7fff000000000000,
    },{ .name = "POR_HNF_RNF_REGION_VEC1_U_HNF_NID200",
        .addr = A_POR_HNF_RNF_REGION_VEC1_U_HNF_NID200,
    },{ .name = "POR_HNF_RNI_REGION_VEC_U_HNF_NID200",
        .addr = A_POR_HNF_RNI_REGION_VEC_U_HNF_NID200,
        .ro = 0xffffffff00000000L,
    },{ .name = "POR_HNF_RNF_REGION_VEC_U_HNF_NID200",
        .addr = A_POR_HNF_RNF_REGION_VEC_U_HNF_NID200,
    },{ .name = "POR_HNF_RND_REGION_VEC_U_HNF_NID200",
        .addr = A_POR_HNF_RND_REGION_VEC_U_HNF_NID200,
        .ro = 0xffffffff00000000L,
    },{ .name = "POR_HNF_SLCWAY_PARTITION0_RNF_VEC_U_HNF_NID200",
        .addr = A_POR_HNF_SLCWAY_PARTITION0_RNF_VEC_U_HNF_NID200,
        .reset = 0xffffffffffffffffL,
    },{ .name = "POR_HNF_SLCWAY_PARTITION1_RNF_VEC_U_HNF_NID200",
        .addr = A_POR_HNF_SLCWAY_PARTITION1_RNF_VEC_U_HNF_NID200,
        .reset = 0xffffffffffffffffL,
    },{ .name = "POR_HNF_SLCWAY_PARTITION2_RNF_VEC_U_HNF_NID200",
        .addr = A_POR_HNF_SLCWAY_PARTITION2_RNF_VEC_U_HNF_NID200,
        .reset = 0xffffffffffffffffL,
    },{ .name = "POR_HNF_SLCWAY_PARTITION3_RNF_VEC_U_HNF_NID200",
        .addr = A_POR_HNF_SLCWAY_PARTITION3_RNF_VEC_U_HNF_NID200,
        .reset = 0xffffffffffffffffL,
    },{ .name = "POR_HNF_SLCWAY_PARTITION0_RNI_VEC_U_HNF_NID200",
        .addr = A_POR_HNF_SLCWAY_PARTITION0_RNI_VEC_U_HNF_NID200,
        .reset = 0xffffffff,
        .ro = 0xffffffff00000000L,
    },{ .name = "POR_HNF_SLCWAY_PARTITION1_RNI_VEC_U_HNF_NID200",
        .addr = A_POR_HNF_SLCWAY_PARTITION1_RNI_VEC_U_HNF_NID200,
        .reset = 0xffffffff,
        .ro = 0xffffffff00000000L,
    },{ .name = "POR_HNF_SLCWAY_PARTITION2_RNI_VEC_U_HNF_NID200",
        .addr = A_POR_HNF_SLCWAY_PARTITION2_RNI_VEC_U_HNF_NID200,
        .reset = 0xffffffff,
        .ro = 0xffffffff00000000L,
    },{ .name = "POR_HNF_SLCWAY_PARTITION3_RNI_VEC_U_HNF_NID200",
        .addr = A_POR_HNF_SLCWAY_PARTITION3_RNI_VEC_U_HNF_NID200,
        .reset = 0xffffffff,
        .ro = 0xffffffff00000000L,
    },{ .name = "POR_HNF_SLCWAY_PARTITION0_RND_VEC_U_HNF_NID200",
        .addr = A_POR_HNF_SLCWAY_PARTITION0_RND_VEC_U_HNF_NID200,
        .reset = 0xffffffff,
        .ro = 0xffffffff00000000L,
    },{ .name = "POR_HNF_SLCWAY_PARTITION1_RND_VEC_U_HNF_NID200",
        .addr = A_POR_HNF_SLCWAY_PARTITION1_RND_VEC_U_HNF_NID200,
        .reset = 0xffffffff,
        .ro = 0xffffffff00000000L,
    },{ .name = "POR_HNF_SLCWAY_PARTITION2_RND_VEC_U_HNF_NID200",
        .addr = A_POR_HNF_SLCWAY_PARTITION2_RND_VEC_U_HNF_NID200,
        .reset = 0xffffffff,
        .ro = 0xffffffff00000000L,
    },{ .name = "POR_HNF_SLCWAY_PARTITION3_RND_VEC_U_HNF_NID200",
        .addr = A_POR_HNF_SLCWAY_PARTITION3_RND_VEC_U_HNF_NID200,
        .reset = 0xffffffff,
        .ro = 0xffffffff00000000L,
    },{ .name = "POR_HNF_RN_REGION_LOCK_U_HNF_NID200",
        .addr = A_POR_HNF_RN_REGION_LOCK_U_HNF_NID200,
        .rsvd = 0xfffffffffffffffcL,
        .ro = 0xfffffffffffffffcL,
    },{ .name = "POR_HNF_SLCWAY_PARTITION0_RNF_VEC1_U_HNF_NID200",
        .addr = A_POR_HNF_SLCWAY_PARTITION0_RNF_VEC1_U_HNF_NID200,
        .reset = 0xffffffffffffffffL,
    },{ .name = "POR_HNF_SLCWAY_PARTITION1_RNF_VEC1_U_HNF_NID200",
        .addr = A_POR_HNF_SLCWAY_PARTITION1_RNF_VEC1_U_HNF_NID200,
        .reset = 0xffffffffffffffffL,
    },{ .name = "POR_HNF_SLCWAY_PARTITION2_RNF_VEC1_U_HNF_NID200",
        .addr = A_POR_HNF_SLCWAY_PARTITION2_RNF_VEC1_U_HNF_NID200,
        .reset = 0xffffffffffffffffL,
    },{ .name = "POR_HNF_SLCWAY_PARTITION3_RNF_VEC1_U_HNF_NID200",
        .addr = A_POR_HNF_SLCWAY_PARTITION3_RNF_VEC1_U_HNF_NID200,
        .reset = 0xffffffffffffffffL,
    },{ .name = "POR_HNF_SAM_CONTROL_U_HNF_NID200",
        .addr = A_POR_HNF_SAM_CONTROL_U_HNF_NID200,
        .ro = 0x40c0c0c800800800,
    },{ .name = "POR_HNF_SAM_MEMREGION0_U_HNF_NID200",
        .addr = A_POR_HNF_SAM_MEMREGION0_U_HNF_NID200,
        .ro = 0x7fff000003fe0800,
    },{ .name = "POR_HNF_SAM_MEMREGION1_U_HNF_NID200",
        .addr = A_POR_HNF_SAM_MEMREGION1_U_HNF_NID200,
        .ro = 0x7fff000003fe0800,
    },{ .name = "POR_HNF_SAM_SN_PROPERTIES_U_HNF_NID200",
        .addr = A_POR_HNF_SAM_SN_PROPERTIES_U_HNF_NID200,
        .rsvd = 0x38,
        .ro = 0xffffe38e38e38e38L,
    },{ .name = "POR_HNF_SAM_6SN_NODEID_U_HNF_NID200",
        .addr = A_POR_HNF_SAM_6SN_NODEID_U_HNF_NID200,
        .ro = 0xfffffff800800800L,
    },{ .name = "POR_HNF_RN_PHYS_ID0_U_HNF_NID200",
        .addr = A_POR_HNF_RN_PHYS_ID0_U_HNF_NID200,
        .reset = 0x8000004c8000000cL,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID1_U_HNF_NID200",
        .addr = A_POR_HNF_RN_PHYS_ID1_U_HNF_NID200,
        .reset = 0x800000cc8000008cL,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID2_U_HNF_NID200",
        .addr = A_POR_HNF_RN_PHYS_ID2_U_HNF_NID200,
        .reset = 0x8000010c,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID3_U_HNF_NID200",
        .addr = A_POR_HNF_RN_PHYS_ID3_U_HNF_NID200,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID4_U_HNF_NID200",
        .addr = A_POR_HNF_RN_PHYS_ID4_U_HNF_NID200,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID5_U_HNF_NID200",
        .addr = A_POR_HNF_RN_PHYS_ID5_U_HNF_NID200,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID6_U_HNF_NID200",
        .addr = A_POR_HNF_RN_PHYS_ID6_U_HNF_NID200,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID7_U_HNF_NID200",
        .addr = A_POR_HNF_RN_PHYS_ID7_U_HNF_NID200,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID8_U_HNF_NID200",
        .addr = A_POR_HNF_RN_PHYS_ID8_U_HNF_NID200,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID9_U_HNF_NID200",
        .addr = A_POR_HNF_RN_PHYS_ID9_U_HNF_NID200,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID10_U_HNF_NID200",
        .addr = A_POR_HNF_RN_PHYS_ID10_U_HNF_NID200,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID11_U_HNF_NID200",
        .addr = A_POR_HNF_RN_PHYS_ID11_U_HNF_NID200,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID12_U_HNF_NID200",
        .addr = A_POR_HNF_RN_PHYS_ID12_U_HNF_NID200,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID13_U_HNF_NID200",
        .addr = A_POR_HNF_RN_PHYS_ID13_U_HNF_NID200,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID14_U_HNF_NID200",
        .addr = A_POR_HNF_RN_PHYS_ID14_U_HNF_NID200,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID15_U_HNF_NID200",
        .addr = A_POR_HNF_RN_PHYS_ID15_U_HNF_NID200,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID16_U_HNF_NID200",
        .addr = A_POR_HNF_RN_PHYS_ID16_U_HNF_NID200,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID17_U_HNF_NID200",
        .addr = A_POR_HNF_RN_PHYS_ID17_U_HNF_NID200,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID18_U_HNF_NID200",
        .addr = A_POR_HNF_RN_PHYS_ID18_U_HNF_NID200,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID19_U_HNF_NID200",
        .addr = A_POR_HNF_RN_PHYS_ID19_U_HNF_NID200,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID20_U_HNF_NID200",
        .addr = A_POR_HNF_RN_PHYS_ID20_U_HNF_NID200,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID21_U_HNF_NID200",
        .addr = A_POR_HNF_RN_PHYS_ID21_U_HNF_NID200,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID22_U_HNF_NID200",
        .addr = A_POR_HNF_RN_PHYS_ID22_U_HNF_NID200,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID23_U_HNF_NID200",
        .addr = A_POR_HNF_RN_PHYS_ID23_U_HNF_NID200,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID24_U_HNF_NID200",
        .addr = A_POR_HNF_RN_PHYS_ID24_U_HNF_NID200,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID25_U_HNF_NID200",
        .addr = A_POR_HNF_RN_PHYS_ID25_U_HNF_NID200,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID26_U_HNF_NID200",
        .addr = A_POR_HNF_RN_PHYS_ID26_U_HNF_NID200,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID27_U_HNF_NID200",
        .addr = A_POR_HNF_RN_PHYS_ID27_U_HNF_NID200,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID28_U_HNF_NID200",
        .addr = A_POR_HNF_RN_PHYS_ID28_U_HNF_NID200,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID29_U_HNF_NID200",
        .addr = A_POR_HNF_RN_PHYS_ID29_U_HNF_NID200,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID30_U_HNF_NID200",
        .addr = A_POR_HNF_RN_PHYS_ID30_U_HNF_NID200,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID31_U_HNF_NID200",
        .addr = A_POR_HNF_RN_PHYS_ID31_U_HNF_NID200,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID32_U_HNF_NID200",
        .addr = A_POR_HNF_RN_PHYS_ID32_U_HNF_NID200,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID33_U_HNF_NID200",
        .addr = A_POR_HNF_RN_PHYS_ID33_U_HNF_NID200,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID34_U_HNF_NID200",
        .addr = A_POR_HNF_RN_PHYS_ID34_U_HNF_NID200,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID35_U_HNF_NID200",
        .addr = A_POR_HNF_RN_PHYS_ID35_U_HNF_NID200,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID36_U_HNF_NID200",
        .addr = A_POR_HNF_RN_PHYS_ID36_U_HNF_NID200,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID37_U_HNF_NID200",
        .addr = A_POR_HNF_RN_PHYS_ID37_U_HNF_NID200,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID38_U_HNF_NID200",
        .addr = A_POR_HNF_RN_PHYS_ID38_U_HNF_NID200,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID39_U_HNF_NID200",
        .addr = A_POR_HNF_RN_PHYS_ID39_U_HNF_NID200,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID40_U_HNF_NID200",
        .addr = A_POR_HNF_RN_PHYS_ID40_U_HNF_NID200,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID41_U_HNF_NID200",
        .addr = A_POR_HNF_RN_PHYS_ID41_U_HNF_NID200,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID42_U_HNF_NID200",
        .addr = A_POR_HNF_RN_PHYS_ID42_U_HNF_NID200,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID43_U_HNF_NID200",
        .addr = A_POR_HNF_RN_PHYS_ID43_U_HNF_NID200,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID44_U_HNF_NID200",
        .addr = A_POR_HNF_RN_PHYS_ID44_U_HNF_NID200,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID45_U_HNF_NID200",
        .addr = A_POR_HNF_RN_PHYS_ID45_U_HNF_NID200,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID46_U_HNF_NID200",
        .addr = A_POR_HNF_RN_PHYS_ID46_U_HNF_NID200,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID47_U_HNF_NID200",
        .addr = A_POR_HNF_RN_PHYS_ID47_U_HNF_NID200,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID48_U_HNF_NID200",
        .addr = A_POR_HNF_RN_PHYS_ID48_U_HNF_NID200,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID49_U_HNF_NID200",
        .addr = A_POR_HNF_RN_PHYS_ID49_U_HNF_NID200,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID50_U_HNF_NID200",
        .addr = A_POR_HNF_RN_PHYS_ID50_U_HNF_NID200,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID51_U_HNF_NID200",
        .addr = A_POR_HNF_RN_PHYS_ID51_U_HNF_NID200,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID52_U_HNF_NID200",
        .addr = A_POR_HNF_RN_PHYS_ID52_U_HNF_NID200,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID53_U_HNF_NID200",
        .addr = A_POR_HNF_RN_PHYS_ID53_U_HNF_NID200,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID54_U_HNF_NID200",
        .addr = A_POR_HNF_RN_PHYS_ID54_U_HNF_NID200,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID55_U_HNF_NID200",
        .addr = A_POR_HNF_RN_PHYS_ID55_U_HNF_NID200,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID56_U_HNF_NID200",
        .addr = A_POR_HNF_RN_PHYS_ID56_U_HNF_NID200,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID57_U_HNF_NID200",
        .addr = A_POR_HNF_RN_PHYS_ID57_U_HNF_NID200,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID58_U_HNF_NID200",
        .addr = A_POR_HNF_RN_PHYS_ID58_U_HNF_NID200,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_SF_CXG_BLOCKED_WAYS_U_HNF_NID200",
        .addr = A_POR_HNF_SF_CXG_BLOCKED_WAYS_U_HNF_NID200,
        .rsvd = 0xfffffffffffffffcL,
        .ro = 0xfffffffffffffffcL,
    },{ .name = "POR_HNF_CML_PORT_AGGR_GRP0_ADD_MASK_U_HNF_NID200",
        .addr = A_POR_HNF_CML_PORT_AGGR_GRP0_ADD_MASK_U_HNF_NID200,
        .reset = 0x40,
        .ro = 0xffff00000000003fL,
    },{ .name = "POR_HNF_CML_PORT_AGGR_GRP1_ADD_MASK_U_HNF_NID200",
        .addr = A_POR_HNF_CML_PORT_AGGR_GRP1_ADD_MASK_U_HNF_NID200,
        .reset = 0x40,
        .ro = 0xffff00000000003fL,
    },{ .name = "POR_HNF_CML_PORT_AGGR_GRP0_REG_U_HNF_NID200",
        .addr = A_POR_HNF_CML_PORT_AGGR_GRP0_REG_U_HNF_NID200,
        .ro = 0xfffc800800800800L,
    },{ .name = "POR_HNF_CML_PORT_AGGR_GRP1_REG_U_HNF_NID200",
        .addr = A_POR_HNF_CML_PORT_AGGR_GRP1_REG_U_HNF_NID200,
        .ro = 0xfffc800800800800L,
    },{ .name = "HN_SAM_HASH_ADDR_MASK_REG_U_HNF_NID200",
        .addr = A_HN_SAM_HASH_ADDR_MASK_REG_U_HNF_NID200,
        .reset = 0xffffffffffc0,
        .ro = 0xffff00000000003fL,
    },{ .name = "HN_SAM_REGION_CMP_ADDR_MASK_REG_U_HNF_NID200",
        .addr = A_HN_SAM_REGION_CMP_ADDR_MASK_REG_U_HNF_NID200,
        .reset = 0xfffffc000000,
        .ro = 0xffff000003ffffffL,
    },{ .name = "POR_HNF_ABF_LO_ADDR_U_HNF_NID200",
        .addr = A_POR_HNF_ABF_LO_ADDR_U_HNF_NID200,
        .ro = 0xffff000000000000L,
    },{ .name = "POR_HNF_ABF_HI_ADDR_U_HNF_NID200",
        .addr = A_POR_HNF_ABF_HI_ADDR_U_HNF_NID200,
        .ro = 0xffff000000000000L,
    },{ .name = "POR_HNF_ABF_PR_U_HNF_NID200",
        .addr = A_POR_HNF_ABF_PR_U_HNF_NID200,
        .rsvd = 0xfffffffffffffff8L,
        .ro = 0xfffffffffffffff8L,
    },{ .name = "POR_HNF_ABF_SR_U_HNF_NID200",
        .addr = A_POR_HNF_ABF_SR_U_HNF_NID200,
        .rsvd = 0xfffffffffffffff0L,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_HNF_RN_PHYS_ID59_U_HNF_NID200",
        .addr = A_POR_HNF_RN_PHYS_ID59_U_HNF_NID200,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID60_U_HNF_NID200",
        .addr = A_POR_HNF_RN_PHYS_ID60_U_HNF_NID200,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID61_U_HNF_NID200",
        .addr = A_POR_HNF_RN_PHYS_ID61_U_HNF_NID200,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID62_U_HNF_NID200",
        .addr = A_POR_HNF_RN_PHYS_ID62_U_HNF_NID200,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_RN_PHYS_ID63_U_HNF_NID200",
        .addr = A_POR_HNF_RN_PHYS_ID63_U_HNF_NID200,
        .ro = 0x3ff8f8003ff8f800,
    },{ .name = "POR_HNF_LDID_MAP_TABLE_REG0_U_HNF_NID200",
        .addr = A_POR_HNF_LDID_MAP_TABLE_REG0_U_HNF_NID200,
        .ro = 0x7f80f8007f80f800,
    },{ .name = "POR_HNF_LDID_MAP_TABLE_REG1_U_HNF_NID200",
        .addr = A_POR_HNF_LDID_MAP_TABLE_REG1_U_HNF_NID200,
        .ro = 0x7f80f8007f80f800,
    },{ .name = "POR_HNF_LDID_MAP_TABLE_REG2_U_HNF_NID200",
        .addr = A_POR_HNF_LDID_MAP_TABLE_REG2_U_HNF_NID200,
        .ro = 0x7f80f8007f80f800,
    },{ .name = "POR_HNF_LDID_MAP_TABLE_REG3_U_HNF_NID200",
        .addr = A_POR_HNF_LDID_MAP_TABLE_REG3_U_HNF_NID200,
        .ro = 0x7f80f8007f80f800,
    },{ .name = "POR_HNF_PPU_PWPR_U_HNF_NID200",
        .addr = A_POR_HNF_PPU_PWPR_U_HNF_NID200,
        .ro = 0xfffffe00,
    },{ .name = "POR_HNF_PPU_PWSR_U_HNF_NID200",
        .addr = A_POR_HNF_PPU_PWSR_U_HNF_NID200,
        .ro = 0xffffffff,
    },{ .name = "POR_HNF_PPU_MISR_U_HNF_NID200",
        .addr = A_POR_HNF_PPU_MISR_U_HNF_NID200,
        .rsvd = 0xfffffffe,
        .ro = 0xffffffff,
    },{ .name = "POR_HNF_PPU_DYN_RET_THRESHOLD_U_HNF_NID200",
        .addr = A_POR_HNF_PPU_DYN_RET_THRESHOLD_U_HNF_NID200,
        .ro = 0xfffffffffffff000L,
    },{ .name = "POR_HNF_PPU_IDR0_U_HNF_NID200",
        .addr = A_POR_HNF_PPU_IDR0_U_HNF_NID200,
        .reset = 0x801a540,
        .ro = 0xffffffff,
    },{ .name = "POR_HNF_PPU_IDR1_U_HNF_NID200",
        .addr = A_POR_HNF_PPU_IDR1_U_HNF_NID200,
        .rsvd = 0xfffffff0,
        .ro = 0xffffffff,
    },{ .name = "POR_HNF_PPU_IIDR_U_HNF_NID200",
        .addr = A_POR_HNF_PPU_IIDR_U_HNF_NID200,
        .reset = 0x4340043b,
        .ro = 0xffffffff,
    },{ .name = "POR_HNF_PPU_AIDR_U_HNF_NID200",
        .addr = A_POR_HNF_PPU_AIDR_U_HNF_NID200,
        .reset = 0x11,
        .rsvd = 0xffffff00,
        .ro = 0xffffffff,
    },{ .name = "POR_HNF_PMU_EVENT_SEL_U_HNF_NID200",
        .addr = A_POR_HNF_PMU_EVENT_SEL_U_HNF_NID200,
        .rsvd = 0xe0,
        .ro = 0xfffffff8e0e0e0e0L,
    },{ .name = "POR_HNF_ERRFR_U_HNF_NID200",
        .addr = A_POR_HNF_ERRFR_U_HNF_NID200,
        .reset = 0x48a5,
        .rsvd = 0x300,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_HNF_ERRCTLR_U_HNF_NID200",
        .addr = A_POR_HNF_ERRCTLR_U_HNF_NID200,
        .rsvd = 0xf0,
        .ro = 0xfffffffffffffef0L,
    },{ .name = "POR_HNF_ERRSTATUS_U_HNF_NID200",
        .addr = A_POR_HNF_ERRSTATUS_U_HNF_NID200,
        .ro = 0xffffffff127fffffL,
    },{ .name = "POR_HNF_ERRADDR_U_HNF_NID200",
        .addr = A_POR_HNF_ERRADDR_U_HNF_NID200,
        .ro = 0x7fff000000000000,
    },{ .name = "POR_HNF_ERRMISC_U_HNF_NID200",
        .addr = A_POR_HNF_ERRMISC_U_HNF_NID200,
        .ro = 0x20000000fffc8000,
    },{ .name = "POR_HNF_ERR_INJ_U_HNF_NID200",
        .addr = A_POR_HNF_ERR_INJ_U_HNF_NID200,
        .rsvd = 0xe,
        .ro = 0xfffffffff800fe0eL,
    },{ .name = "POR_HNF_BYTE_PAR_ERR_INJ_U_HNF_NID200",
        .addr = A_POR_HNF_BYTE_PAR_ERR_INJ_U_HNF_NID200,
        .rsvd = 0xffffffffffffffe0L,
        .ro = 0xffffffffffffffe0L,
    },{ .name = "POR_HNF_ERRFR_NS_U_HNF_NID200",
        .addr = A_POR_HNF_ERRFR_NS_U_HNF_NID200,
        .reset = 0x48a5,
        .rsvd = 0x300,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_HNF_ERRCTLR_NS_U_HNF_NID200",
        .addr = A_POR_HNF_ERRCTLR_NS_U_HNF_NID200,
        .rsvd = 0xf0,
        .ro = 0xfffffffffffffef0L,
    },{ .name = "POR_HNF_ERRSTATUS_NS_U_HNF_NID200",
        .addr = A_POR_HNF_ERRSTATUS_NS_U_HNF_NID200,
        .ro = 0xffffffff127fffffL,
    },{ .name = "POR_HNF_ERRADDR_NS_U_HNF_NID200",
        .addr = A_POR_HNF_ERRADDR_NS_U_HNF_NID200,
        .ro = 0x7fff000000000000,
    },{ .name = "POR_HNF_ERRMISC_NS_U_HNF_NID200",
        .addr = A_POR_HNF_ERRMISC_NS_U_HNF_NID200,
        .ro = 0x20000000fffc8000,
    },{ .name = "POR_MXP_NODE_INFO_U_SMXP_3_1",
        .addr = A_POR_MXP_NODE_INFO_U_SMXP_3_1,
        .reset = 0x1080006,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_DEVICE_PORT_CONNECT_INFO_P0_U_SMXP_3_1",
        .addr = A_POR_MXP_DEVICE_PORT_CONNECT_INFO_P0_U_SMXP_3_1,
        .reset = 0xd,
        .rsvd = 0xffe0,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_DEVICE_PORT_CONNECT_INFO_P1_U_SMXP_3_1",
        .addr = A_POR_MXP_DEVICE_PORT_CONNECT_INFO_P1_U_SMXP_3_1,
        .reset = 0x1,
        .rsvd = 0xffe0,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_MESH_PORT_CONNECT_INFO_EAST_U_SMXP_3_1",
        .addr = A_POR_MXP_MESH_PORT_CONNECT_INFO_EAST_U_SMXP_3_1,
        .rsvd = 0xfffffffffffffff0L,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_MESH_PORT_CONNECT_INFO_NORTH_U_SMXP_3_1",
        .addr = A_POR_MXP_MESH_PORT_CONNECT_INFO_NORTH_U_SMXP_3_1,
        .rsvd = 0xfffffffffffffff0L,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_INFO_U_SMXP_3_1",
        .addr = A_POR_MXP_CHILD_INFO_U_SMXP_3_1,
        .reset = 0x1000006,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_POINTER_0_U_SMXP_3_1",
        .addr = A_POR_MXP_CHILD_POINTER_0_U_SMXP_3_1,
        .reset = 0x8212c000,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_POINTER_1_U_SMXP_3_1",
        .addr = A_POR_MXP_CHILD_POINTER_1_U_SMXP_3_1,
        .reset = 0x8213c000,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_POINTER_2_U_SMXP_3_1",
        .addr = A_POR_MXP_CHILD_POINTER_2_U_SMXP_3_1,
        .reset = 0x2168000,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_POINTER_3_U_SMXP_3_1",
        .addr = A_POR_MXP_CHILD_POINTER_3_U_SMXP_3_1,
        .reset = 0x821d0000,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_POINTER_4_U_SMXP_3_1",
        .addr = A_POR_MXP_CHILD_POINTER_4_U_SMXP_3_1,
        .reset = 0x82120000,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_POINTER_5_U_SMXP_3_1",
        .addr = A_POR_MXP_CHILD_POINTER_5_U_SMXP_3_1,
        .reset = 0x2150000,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_POINTER_6_U_SMXP_3_1",
        .addr = A_POR_MXP_CHILD_POINTER_6_U_SMXP_3_1,
        .reset = 0x2110000,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_POINTER_7_U_SMXP_3_1",
        .addr = A_POR_MXP_CHILD_POINTER_7_U_SMXP_3_1,
        .reset = 0x2100000,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_POINTER_8_U_SMXP_3_1",
        .addr = A_POR_MXP_CHILD_POINTER_8_U_SMXP_3_1,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_POINTER_9_U_SMXP_3_1",
        .addr = A_POR_MXP_CHILD_POINTER_9_U_SMXP_3_1,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_POINTER_10_U_SMXP_3_1",
        .addr = A_POR_MXP_CHILD_POINTER_10_U_SMXP_3_1,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_POINTER_11_U_SMXP_3_1",
        .addr = A_POR_MXP_CHILD_POINTER_11_U_SMXP_3_1,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_POINTER_12_U_SMXP_3_1",
        .addr = A_POR_MXP_CHILD_POINTER_12_U_SMXP_3_1,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_POINTER_13_U_SMXP_3_1",
        .addr = A_POR_MXP_CHILD_POINTER_13_U_SMXP_3_1,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_POINTER_14_U_SMXP_3_1",
        .addr = A_POR_MXP_CHILD_POINTER_14_U_SMXP_3_1,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_POINTER_15_U_SMXP_3_1",
        .addr = A_POR_MXP_CHILD_POINTER_15_U_SMXP_3_1,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_P0_INFO_U_SMXP_3_1",
        .addr = A_POR_MXP_P0_INFO_U_SMXP_3_1,
        .reset = 0x211,
        .rsvd = 0x48,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_P1_INFO_U_SMXP_3_1",
        .addr = A_POR_MXP_P1_INFO_U_SMXP_3_1,
        .reset = 0x211,
        .rsvd = 0x48,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_SECURE_REGISTER_GROUPS_OVERRIDE_U_SMXP_3_1",
        .addr = A_POR_MXP_SECURE_REGISTER_GROUPS_OVERRIDE_U_SMXP_3_1,
        .rsvd = 0xfffffffffffffffcL,
        .ro = 0xfffffffffffffffcL,
    },{ .name = "POR_MXP_AUX_CTL_U_SMXP_3_1",
        .addr = A_POR_MXP_AUX_CTL_U_SMXP_3_1,
        .rsvd = 0xfffffffffffffffeL,
        .ro = 0xfffffffffffffffeL,
    },{ .name = "POR_MXP_P0_QOS_CONTROL_U_SMXP_3_1",
        .addr = A_POR_MXP_P0_QOS_CONTROL_U_SMXP_3_1,
        .rsvd = 0xffaa,
        .ro = 0xfffffffffff0ffaaL,
    },{ .name = "POR_MXP_P0_QOS_LAT_TGT_U_SMXP_3_1",
        .addr = A_POR_MXP_P0_QOS_LAT_TGT_U_SMXP_3_1,
        .ro = 0xfffffffffffff000L,
    },{ .name = "POR_MXP_P0_QOS_LAT_SCALE_U_SMXP_3_1",
        .addr = A_POR_MXP_P0_QOS_LAT_SCALE_U_SMXP_3_1,
        .rsvd = 0xfffffffffffffff8L,
        .ro = 0xfffffffffffffff8L,
    },{ .name = "POR_MXP_P0_QOS_LAT_RANGE_U_SMXP_3_1",
        .addr = A_POR_MXP_P0_QOS_LAT_RANGE_U_SMXP_3_1,
        .rsvd = 0xf0,
        .ro = 0xfffffffffffff0f0L,
    },{ .name = "POR_MXP_P1_QOS_CONTROL_U_SMXP_3_1",
        .addr = A_POR_MXP_P1_QOS_CONTROL_U_SMXP_3_1,
        .rsvd = 0xffaa,
        .ro = 0xfffffffffff0ffaaL,
    },{ .name = "POR_MXP_P1_QOS_LAT_TGT_U_SMXP_3_1",
        .addr = A_POR_MXP_P1_QOS_LAT_TGT_U_SMXP_3_1,
        .ro = 0xfffffffffffff000L,
    },{ .name = "POR_MXP_P1_QOS_LAT_SCALE_U_SMXP_3_1",
        .addr = A_POR_MXP_P1_QOS_LAT_SCALE_U_SMXP_3_1,
        .rsvd = 0xfffffffffffffff8L,
        .ro = 0xfffffffffffffff8L,
    },{ .name = "POR_MXP_P1_QOS_LAT_RANGE_U_SMXP_3_1",
        .addr = A_POR_MXP_P1_QOS_LAT_RANGE_U_SMXP_3_1,
        .rsvd = 0xf0,
        .ro = 0xfffffffffffff0f0L,
    },{ .name = "POR_MXP_P0_SYSCOREQ_CTL_U_SMXP_3_1",
        .addr = A_POR_MXP_P0_SYSCOREQ_CTL_U_SMXP_3_1,
        .rsvd = 0xfffffffffffffff0L,
        .ro = 0xfffffffffffffff0L,
    },{ .name = "POR_MXP_P1_SYSCOREQ_CTL_U_SMXP_3_1",
        .addr = A_POR_MXP_P1_SYSCOREQ_CTL_U_SMXP_3_1,
        .rsvd = 0xfffffffffffffff0L,
        .ro = 0xfffffffffffffff0L,
    },{ .name = "POR_MXP_P0_SYSCOACK_STATUS_U_SMXP_3_1",
        .addr = A_POR_MXP_P0_SYSCOACK_STATUS_U_SMXP_3_1,
        .rsvd = 0xfffffffffffffff0L,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_P1_SYSCOACK_STATUS_U_SMXP_3_1",
        .addr = A_POR_MXP_P1_SYSCOACK_STATUS_U_SMXP_3_1,
        .rsvd = 0xfffffffffffffff0L,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_PMU_EVENT_SEL_U_SMXP_3_1",
        .addr = A_POR_MXP_PMU_EVENT_SEL_U_SMXP_3_1,
        .ro = 0xffffffff00000000L,
    },{ .name = "POR_DTM_CONTROL_U_SMXP_3_1",
        .addr = A_POR_DTM_CONTROL_U_SMXP_3_1,
        .rsvd = 0xfffffffffffffff0L,
        .ro = 0xfffffffffffffff0L,
    },{ .name = "POR_DTM_FIFO_ENTRY_READY_U_SMXP_3_1",
        .addr = A_POR_DTM_FIFO_ENTRY_READY_U_SMXP_3_1,
        .rsvd = 0xfffffffffffffff0L,
        .ro = 0xfffffffffffffff0L,
    },{ .name = "POR_DTM_FIFO_ENTRY0_0_U_SMXP_3_1",
        .addr = A_POR_DTM_FIFO_ENTRY0_0_U_SMXP_3_1,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_DTM_FIFO_ENTRY0_1_U_SMXP_3_1",
        .addr = A_POR_DTM_FIFO_ENTRY0_1_U_SMXP_3_1,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_DTM_FIFO_ENTRY0_2_U_SMXP_3_1",
        .addr = A_POR_DTM_FIFO_ENTRY0_2_U_SMXP_3_1,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_DTM_FIFO_ENTRY1_0_U_SMXP_3_1",
        .addr = A_POR_DTM_FIFO_ENTRY1_0_U_SMXP_3_1,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_DTM_FIFO_ENTRY1_1_U_SMXP_3_1",
        .addr = A_POR_DTM_FIFO_ENTRY1_1_U_SMXP_3_1,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_DTM_FIFO_ENTRY1_2_U_SMXP_3_1",
        .addr = A_POR_DTM_FIFO_ENTRY1_2_U_SMXP_3_1,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_DTM_FIFO_ENTRY2_0_U_SMXP_3_1",
        .addr = A_POR_DTM_FIFO_ENTRY2_0_U_SMXP_3_1,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_DTM_FIFO_ENTRY2_1_U_SMXP_3_1",
        .addr = A_POR_DTM_FIFO_ENTRY2_1_U_SMXP_3_1,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_DTM_FIFO_ENTRY2_2_U_SMXP_3_1",
        .addr = A_POR_DTM_FIFO_ENTRY2_2_U_SMXP_3_1,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_DTM_FIFO_ENTRY3_0_U_SMXP_3_1",
        .addr = A_POR_DTM_FIFO_ENTRY3_0_U_SMXP_3_1,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_DTM_FIFO_ENTRY3_1_U_SMXP_3_1",
        .addr = A_POR_DTM_FIFO_ENTRY3_1_U_SMXP_3_1,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_DTM_FIFO_ENTRY3_2_U_SMXP_3_1",
        .addr = A_POR_DTM_FIFO_ENTRY3_2_U_SMXP_3_1,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_DTM_WP0_CONFIG_U_SMXP_3_1",
        .addr = A_POR_DTM_WP0_CONFIG_U_SMXP_3_1,
        .rsvd = 0x80,
        .ro = 0xffffffffffff8080L,
    },{ .name = "POR_DTM_WP0_VAL_U_SMXP_3_1",
        .addr = A_POR_DTM_WP0_VAL_U_SMXP_3_1,
    },{ .name = "POR_DTM_WP0_MASK_U_SMXP_3_1",
        .addr = A_POR_DTM_WP0_MASK_U_SMXP_3_1,
    },{ .name = "POR_DTM_WP1_CONFIG_U_SMXP_3_1",
        .addr = A_POR_DTM_WP1_CONFIG_U_SMXP_3_1,
        .rsvd = 0xc0,
        .ro = 0xffffffffffff80c0L,
    },{ .name = "POR_DTM_WP1_VAL_U_SMXP_3_1",
        .addr = A_POR_DTM_WP1_VAL_U_SMXP_3_1,
    },{ .name = "POR_DTM_WP1_MASK_U_SMXP_3_1",
        .addr = A_POR_DTM_WP1_MASK_U_SMXP_3_1,
    },{ .name = "POR_DTM_WP2_CONFIG_U_SMXP_3_1",
        .addr = A_POR_DTM_WP2_CONFIG_U_SMXP_3_1,
        .rsvd = 0x80,
        .ro = 0xffffffffffff8080L,
    },{ .name = "POR_DTM_WP2_VAL_U_SMXP_3_1",
        .addr = A_POR_DTM_WP2_VAL_U_SMXP_3_1,
    },{ .name = "POR_DTM_WP2_MASK_U_SMXP_3_1",
        .addr = A_POR_DTM_WP2_MASK_U_SMXP_3_1,
    },{ .name = "POR_DTM_WP3_CONFIG_U_SMXP_3_1",
        .addr = A_POR_DTM_WP3_CONFIG_U_SMXP_3_1,
        .rsvd = 0xc0,
        .ro = 0xffffffffffff80c0L,
    },{ .name = "POR_DTM_WP3_VAL_U_SMXP_3_1",
        .addr = A_POR_DTM_WP3_VAL_U_SMXP_3_1,
    },{ .name = "POR_DTM_WP3_MASK_U_SMXP_3_1",
        .addr = A_POR_DTM_WP3_MASK_U_SMXP_3_1,
    },{ .name = "POR_DTM_PMSICR_U_SMXP_3_1",
        .addr = A_POR_DTM_PMSICR_U_SMXP_3_1,
        .ro = 0xffffffff00000000L,
    },{ .name = "POR_DTM_PMSIRR_U_SMXP_3_1",
        .addr = A_POR_DTM_PMSIRR_U_SMXP_3_1,
        .ro = 0xffffffff000000ffL,
    },{ .name = "POR_DTM_PMU_CONFIG_U_SMXP_3_1",
        .addr = A_POR_DTM_PMU_CONFIG_U_SMXP_3_1,
        .ro = 0xc0c0c0c08888fe00L,
    },{ .name = "POR_DTM_PMEVCNT_U_SMXP_3_1",
        .addr = A_POR_DTM_PMEVCNT_U_SMXP_3_1,
    },{ .name = "POR_DTM_PMEVCNTSR_U_SMXP_3_1",
        .addr = A_POR_DTM_PMEVCNTSR_U_SMXP_3_1,
    },{ .name = "POR_MXP_ERRFR_U_SMXP_3_1",  .addr = A_POR_MXP_ERRFR_U_SMXP_3_1,
        .rsvd = 0x300,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_ERRCTLR_U_SMXP_3_1",
        .addr = A_POR_MXP_ERRCTLR_U_SMXP_3_1,
        .rsvd = 0xf0,
        .ro = 0xfffffffffffffef0L,
    },{ .name = "POR_MXP_ERRSTATUS_U_SMXP_3_1",
        .addr = A_POR_MXP_ERRSTATUS_U_SMXP_3_1,
        .ro = 0xffffffff127fffffL,
    },{ .name = "POR_MXP_ERRMISC_U_SMXP_3_1",
        .addr = A_POR_MXP_ERRMISC_U_SMXP_3_1,
        .rsvd = 0x8,
        .ro = 0xf800ffffffc08008L,
    },{ .name = "POR_MXP_P0_BYTE_PAR_ERR_INJ_U_SMXP_3_1",
        .addr = A_POR_MXP_P0_BYTE_PAR_ERR_INJ_U_SMXP_3_1,
        .rsvd = 0xffffffffffffffe0L,
        .ro = 0xffffffffffffffe0L,
    },{ .name = "POR_MXP_P1_BYTE_PAR_ERR_INJ_U_SMXP_3_1",
        .addr = A_POR_MXP_P1_BYTE_PAR_ERR_INJ_U_SMXP_3_1,
        .rsvd = 0xffffffffffffffe0L,
        .ro = 0xffffffffffffffe0L,
    },{ .name = "POR_MXP_ERRFR_NS_U_SMXP_3_1",
        .addr = A_POR_MXP_ERRFR_NS_U_SMXP_3_1,
        .rsvd = 0x300,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_ERRCTLR_NS_U_SMXP_3_1",
        .addr = A_POR_MXP_ERRCTLR_NS_U_SMXP_3_1,
        .rsvd = 0xf0,
        .ro = 0xfffffffffffffef0L,
    },{ .name = "POR_MXP_ERRSTATUS_NS_U_SMXP_3_1",
        .addr = A_POR_MXP_ERRSTATUS_NS_U_SMXP_3_1,
        .ro = 0xffffffff127fffffL,
    },{ .name = "POR_MXP_ERRMISC_NS_U_SMXP_3_1",
        .addr = A_POR_MXP_ERRMISC_NS_U_SMXP_3_1,
        .rsvd = 0x8,
        .ro = 0xf800ffffffc08008L,
    },{ .name = "POR_FDC_NODE_INFO_U_SMXP_3_1",
        .addr = A_POR_FDC_NODE_INFO_U_SMXP_3_1,
        .reset = 0x201,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_FDC_CHILD_INFO_U_SMXP_3_1",
        .addr = A_POR_FDC_CHILD_INFO_U_SMXP_3_1,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_ERRFR_MXP_U_SMXP_3_1",  .addr = A_POR_ERRFR_MXP_U_SMXP_3_1,
        .reset = 0xa1,
        .rsvd = 0xffffffffffffff0cL,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_ERRCTLR_MXP_U_SMXP_3_1",
        .addr = A_POR_ERRCTLR_MXP_U_SMXP_3_1,
        .reset = 0xd,
        .rsvd = 0x3ff2,
        .ro = 0xffffffff00003ff2L,
    },{ .name = "POR_ERRSTATUS_MXP_U_SMXP_3_1",
        .addr = A_POR_ERRSTATUS_MXP_U_SMXP_3_1,
        .ro = 0xffffffff977f003fL,
    },{ .name = "POR_FDC_AUX_CTL_MXP_U_SMXP_3_1",
        .addr = A_POR_FDC_AUX_CTL_MXP_U_SMXP_3_1,
        .rsvd = 0xffffffffffffffe0L,
        .ro = 0xffffffffffffffefL,
    },{ .name = "POR_ERRFR_P0_D0_U_SMXP_3_1",
        .addr = A_POR_ERRFR_P0_D0_U_SMXP_3_1,
        .reset = 0xa1,
        .rsvd = 0xffffffffffffff0cL,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_ERRCTLR_P0_D0_U_SMXP_3_1",
        .addr = A_POR_ERRCTLR_P0_D0_U_SMXP_3_1,
        .reset = 0xd,
        .rsvd = 0x3ff2,
        .ro = 0xffffffff00003ff2L,
    },{ .name = "POR_ERRSTATUS_P0_D0_U_SMXP_3_1",
        .addr = A_POR_ERRSTATUS_P0_D0_U_SMXP_3_1,
        .ro = 0xffffffff977f003fL,
    },{ .name = "POR_FDC_AUX_CTL_P0_D0_U_SMXP_3_1",
        .addr = A_POR_FDC_AUX_CTL_P0_D0_U_SMXP_3_1,
        .rsvd = 0xffffffffffffffe0L,
        .ro = 0xffffffffffffffe0L,
    },{ .name = "POR_ERRFR_P0_D1_U_SMXP_3_1",
        .addr = A_POR_ERRFR_P0_D1_U_SMXP_3_1,
        .reset = 0xa1,
        .rsvd = 0xffffffffffffff0cL,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_ERRCTLR_P0_D1_U_SMXP_3_1",
        .addr = A_POR_ERRCTLR_P0_D1_U_SMXP_3_1,
        .reset = 0xd,
        .rsvd = 0x3ff2,
        .ro = 0xffffffff00003ff2L,
    },{ .name = "POR_ERRSTATUS_P0_D1_U_SMXP_3_1",
        .addr = A_POR_ERRSTATUS_P0_D1_U_SMXP_3_1,
        .ro = 0xffffffff977f003fL,
    },{ .name = "POR_FDC_AUX_CTL_P0_D1_U_SMXP_3_1",
        .addr = A_POR_FDC_AUX_CTL_P0_D1_U_SMXP_3_1,
        .rsvd = 0xffffffffffffffe0L,
        .ro = 0xffffffffffffffe0L,
    },{ .name = "POR_ERRFR_P0_D2_U_SMXP_3_1",
        .addr = A_POR_ERRFR_P0_D2_U_SMXP_3_1,
        .reset = 0xa1,
        .rsvd = 0xffffffffffffff0cL,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_ERRCTLR_P0_D2_U_SMXP_3_1",
        .addr = A_POR_ERRCTLR_P0_D2_U_SMXP_3_1,
        .reset = 0xd,
        .rsvd = 0x3ff2,
        .ro = 0xffffffff00003ff2L,
    },{ .name = "POR_ERRSTATUS_P0_D2_U_SMXP_3_1",
        .addr = A_POR_ERRSTATUS_P0_D2_U_SMXP_3_1,
        .ro = 0xffffffff977f003fL,
    },{ .name = "POR_FDC_AUX_CTL_P0_D2_U_SMXP_3_1",
        .addr = A_POR_FDC_AUX_CTL_P0_D2_U_SMXP_3_1,
        .rsvd = 0xffffffffffffffe0L,
        .ro = 0xffffffffffffffe0L,
    },{ .name = "POR_ERRFR_P0_D3_U_SMXP_3_1",
        .addr = A_POR_ERRFR_P0_D3_U_SMXP_3_1,
        .reset = 0xa1,
        .rsvd = 0xffffffffffffff0cL,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_ERRCTLR_P0_D3_U_SMXP_3_1",
        .addr = A_POR_ERRCTLR_P0_D3_U_SMXP_3_1,
        .reset = 0xd,
        .rsvd = 0x3ff2,
        .ro = 0xffffffff00003ff2L,
    },{ .name = "POR_ERRSTATUS_P0_D3_U_SMXP_3_1",
        .addr = A_POR_ERRSTATUS_P0_D3_U_SMXP_3_1,
        .ro = 0xffffffff977f003fL,
    },{ .name = "POR_FDC_AUX_CTL_P0_D3_U_SMXP_3_1",
        .addr = A_POR_FDC_AUX_CTL_P0_D3_U_SMXP_3_1,
        .rsvd = 0xffffffffffffffe0L,
        .ro = 0xffffffffffffffe0L,
    },{ .name = "POR_ERRFR_P1_D0_U_SMXP_3_1",
        .addr = A_POR_ERRFR_P1_D0_U_SMXP_3_1,
        .reset = 0xa1,
        .rsvd = 0xffffffffffffff0cL,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_ERRCTLR_P1_D0_U_SMXP_3_1",
        .addr = A_POR_ERRCTLR_P1_D0_U_SMXP_3_1,
        .reset = 0xd,
        .rsvd = 0x3ff2,
        .ro = 0xffffffff00003ff2L,
    },{ .name = "POR_ERRSTATUS_P1_D0_U_SMXP_3_1",
        .addr = A_POR_ERRSTATUS_P1_D0_U_SMXP_3_1,
        .ro = 0xffffffff977f003fL,
    },{ .name = "POR_FDC_AUX_CTL_P1_D0_U_SMXP_3_1",
        .addr = A_POR_FDC_AUX_CTL_P1_D0_U_SMXP_3_1,
        .rsvd = 0xffffffffffffffe0L,
        .ro = 0xffffffffffffffe0L,
    },{ .name = "POR_ERRFR_P1_D1_U_SMXP_3_1",
        .addr = A_POR_ERRFR_P1_D1_U_SMXP_3_1,
        .reset = 0xa1,
        .rsvd = 0xffffffffffffff0cL,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_ERRCTLR_P1_D1_U_SMXP_3_1",
        .addr = A_POR_ERRCTLR_P1_D1_U_SMXP_3_1,
        .reset = 0xd,
        .rsvd = 0x3ff2,
        .ro = 0xffffffff00003ff2L,
    },{ .name = "POR_ERRSTATUS_P1_D1_U_SMXP_3_1",
        .addr = A_POR_ERRSTATUS_P1_D1_U_SMXP_3_1,
        .ro = 0xffffffff977f003fL,
    },{ .name = "POR_FDC_AUX_CTL_P1_D1_U_SMXP_3_1",
        .addr = A_POR_FDC_AUX_CTL_P1_D1_U_SMXP_3_1,
        .rsvd = 0xffffffffffffffe0L,
        .ro = 0xffffffffffffffe0L,
    },{ .name = "POR_ERRFR_P1_D2_U_SMXP_3_1",
        .addr = A_POR_ERRFR_P1_D2_U_SMXP_3_1,
        .reset = 0xa1,
        .rsvd = 0xffffffffffffff0cL,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_ERRCTLR_P1_D2_U_SMXP_3_1",
        .addr = A_POR_ERRCTLR_P1_D2_U_SMXP_3_1,
        .reset = 0xd,
        .rsvd = 0x3ff2,
        .ro = 0xffffffff00003ff2L,
    },{ .name = "POR_ERRSTATUS_P1_D2_U_SMXP_3_1",
        .addr = A_POR_ERRSTATUS_P1_D2_U_SMXP_3_1,
        .ro = 0xffffffff977f003fL,
    },{ .name = "POR_FDC_AUX_CTL_P1_D2_U_SMXP_3_1",
        .addr = A_POR_FDC_AUX_CTL_P1_D2_U_SMXP_3_1,
        .rsvd = 0xffffffffffffffe0L,
        .ro = 0xffffffffffffffe0L,
    },{ .name = "POR_ERRFR_P1_D3_U_SMXP_3_1",
        .addr = A_POR_ERRFR_P1_D3_U_SMXP_3_1,
        .reset = 0xa1,
        .rsvd = 0xffffffffffffff0cL,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_ERRCTLR_P1_D3_U_SMXP_3_1",
        .addr = A_POR_ERRCTLR_P1_D3_U_SMXP_3_1,
        .reset = 0xd,
        .rsvd = 0x3ff2,
        .ro = 0xffffffff00003ff2L,
    },{ .name = "POR_ERRSTATUS_P1_D3_U_SMXP_3_1",
        .addr = A_POR_ERRSTATUS_P1_D3_U_SMXP_3_1,
        .ro = 0xffffffff977f003fL,
    },{ .name = "POR_FDC_AUX_CTL_P1_D3_U_SMXP_3_1",
        .addr = A_POR_FDC_AUX_CTL_P1_D3_U_SMXP_3_1,
        .rsvd = 0xffffffffffffffe0L,
        .ro = 0xffffffffffffffe0L,
    },{ .name = "POR_ERRINJECT_U_SMXP_3_1",  .addr = A_POR_ERRINJECT_U_SMXP_3_1,
        .rsvd = 0xffffffffffffff00L,
        .ro = 0xffffffffffffff00L,
    },{ .name = "POR_FDC_KEY_U_SMXP_3_1",  .addr = A_POR_FDC_KEY_U_SMXP_3_1,
        .reset = 0xbe,
        .rsvd = 0xffffffffffffff00L,
        .ro = 0xffffffffffffff00L,
    },{ .name = "POR_MPU_NODE_INFO_U_SMXP_3_1",
        .addr = A_POR_MPU_NODE_INFO_U_SMXP_3_1,
        .reset = 0x202,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MPU_CHILD_INFO_U_SMXP_3_1",
        .addr = A_POR_MPU_CHILD_INFO_U_SMXP_3_1,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MPU_UNIT_INFO_U_SMXP_3_1",
        .addr = A_POR_MPU_UNIT_INFO_U_SMXP_3_1,
        .reset = 0x20,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MPU_M0_CTL_U_SMXP_3_1",
        .addr = A_POR_MPU_M0_CTL_U_SMXP_3_1,
        .reset = 0x2,
        .rsvd = 0xfffffffffffffff8L,
        .ro = 0xfffffffffffffff8L,
    },{ .name = "POR_MPU_M0_PRBAR0_U_SMXP_3_1",
        .addr = A_POR_MPU_M0_PRBAR0_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR0_U_SMXP_3_1",
        .addr = A_POR_MPU_M0_PRLAR0_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR1_U_SMXP_3_1",
        .addr = A_POR_MPU_M0_PRBAR1_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR1_U_SMXP_3_1",
        .addr = A_POR_MPU_M0_PRLAR1_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR2_U_SMXP_3_1",
        .addr = A_POR_MPU_M0_PRBAR2_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR2_U_SMXP_3_1",
        .addr = A_POR_MPU_M0_PRLAR2_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR3_U_SMXP_3_1",
        .addr = A_POR_MPU_M0_PRBAR3_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR3_U_SMXP_3_1",
        .addr = A_POR_MPU_M0_PRLAR3_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR4_U_SMXP_3_1",
        .addr = A_POR_MPU_M0_PRBAR4_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR4_U_SMXP_3_1",
        .addr = A_POR_MPU_M0_PRLAR4_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR5_U_SMXP_3_1",
        .addr = A_POR_MPU_M0_PRBAR5_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR5_U_SMXP_3_1",
        .addr = A_POR_MPU_M0_PRLAR5_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR6_U_SMXP_3_1",
        .addr = A_POR_MPU_M0_PRBAR6_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR6_U_SMXP_3_1",
        .addr = A_POR_MPU_M0_PRLAR6_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR7_U_SMXP_3_1",
        .addr = A_POR_MPU_M0_PRBAR7_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR7_U_SMXP_3_1",
        .addr = A_POR_MPU_M0_PRLAR7_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR8_U_SMXP_3_1",
        .addr = A_POR_MPU_M0_PRBAR8_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR8_U_SMXP_3_1",
        .addr = A_POR_MPU_M0_PRLAR8_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR9_U_SMXP_3_1",
        .addr = A_POR_MPU_M0_PRBAR9_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR9_U_SMXP_3_1",
        .addr = A_POR_MPU_M0_PRLAR9_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR10_U_SMXP_3_1",
        .addr = A_POR_MPU_M0_PRBAR10_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR10_U_SMXP_3_1",
        .addr = A_POR_MPU_M0_PRLAR10_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR11_U_SMXP_3_1",
        .addr = A_POR_MPU_M0_PRBAR11_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR11_U_SMXP_3_1",
        .addr = A_POR_MPU_M0_PRLAR11_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR12_U_SMXP_3_1",
        .addr = A_POR_MPU_M0_PRBAR12_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR12_U_SMXP_3_1",
        .addr = A_POR_MPU_M0_PRLAR12_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR13_U_SMXP_3_1",
        .addr = A_POR_MPU_M0_PRBAR13_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR13_U_SMXP_3_1",
        .addr = A_POR_MPU_M0_PRLAR13_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR14_U_SMXP_3_1",
        .addr = A_POR_MPU_M0_PRBAR14_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR14_U_SMXP_3_1",
        .addr = A_POR_MPU_M0_PRLAR14_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR15_U_SMXP_3_1",
        .addr = A_POR_MPU_M0_PRBAR15_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR15_U_SMXP_3_1",
        .addr = A_POR_MPU_M0_PRLAR15_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR16_U_SMXP_3_1",
        .addr = A_POR_MPU_M0_PRBAR16_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR16_U_SMXP_3_1",
        .addr = A_POR_MPU_M0_PRLAR16_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR17_U_SMXP_3_1",
        .addr = A_POR_MPU_M0_PRBAR17_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR17_U_SMXP_3_1",
        .addr = A_POR_MPU_M0_PRLAR17_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR18_U_SMXP_3_1",
        .addr = A_POR_MPU_M0_PRBAR18_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR18_U_SMXP_3_1",
        .addr = A_POR_MPU_M0_PRLAR18_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR19_U_SMXP_3_1",
        .addr = A_POR_MPU_M0_PRBAR19_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR19_U_SMXP_3_1",
        .addr = A_POR_MPU_M0_PRLAR19_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR20_U_SMXP_3_1",
        .addr = A_POR_MPU_M0_PRBAR20_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR20_U_SMXP_3_1",
        .addr = A_POR_MPU_M0_PRLAR20_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR21_U_SMXP_3_1",
        .addr = A_POR_MPU_M0_PRBAR21_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR21_U_SMXP_3_1",
        .addr = A_POR_MPU_M0_PRLAR21_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR22_U_SMXP_3_1",
        .addr = A_POR_MPU_M0_PRBAR22_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR22_U_SMXP_3_1",
        .addr = A_POR_MPU_M0_PRLAR22_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR23_U_SMXP_3_1",
        .addr = A_POR_MPU_M0_PRBAR23_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR23_U_SMXP_3_1",
        .addr = A_POR_MPU_M0_PRLAR23_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR24_U_SMXP_3_1",
        .addr = A_POR_MPU_M0_PRBAR24_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR24_U_SMXP_3_1",
        .addr = A_POR_MPU_M0_PRLAR24_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR25_U_SMXP_3_1",
        .addr = A_POR_MPU_M0_PRBAR25_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR25_U_SMXP_3_1",
        .addr = A_POR_MPU_M0_PRLAR25_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR26_U_SMXP_3_1",
        .addr = A_POR_MPU_M0_PRBAR26_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR26_U_SMXP_3_1",
        .addr = A_POR_MPU_M0_PRLAR26_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR27_U_SMXP_3_1",
        .addr = A_POR_MPU_M0_PRBAR27_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR27_U_SMXP_3_1",
        .addr = A_POR_MPU_M0_PRLAR27_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR28_U_SMXP_3_1",
        .addr = A_POR_MPU_M0_PRBAR28_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR28_U_SMXP_3_1",
        .addr = A_POR_MPU_M0_PRLAR28_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR29_U_SMXP_3_1",
        .addr = A_POR_MPU_M0_PRBAR29_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR29_U_SMXP_3_1",
        .addr = A_POR_MPU_M0_PRLAR29_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR30_U_SMXP_3_1",
        .addr = A_POR_MPU_M0_PRBAR30_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR30_U_SMXP_3_1",
        .addr = A_POR_MPU_M0_PRLAR30_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR31_U_SMXP_3_1",
        .addr = A_POR_MPU_M0_PRBAR31_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR31_U_SMXP_3_1",
        .addr = A_POR_MPU_M0_PRLAR31_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_CTL_U_SMXP_3_1",
        .addr = A_POR_MPU_M1_CTL_U_SMXP_3_1,
        .reset = 0x2,
        .rsvd = 0xfffffffffffffff8L,
        .ro = 0xfffffffffffffff8L,
    },{ .name = "POR_MPU_M1_PRBAR0_U_SMXP_3_1",
        .addr = A_POR_MPU_M1_PRBAR0_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR0_U_SMXP_3_1",
        .addr = A_POR_MPU_M1_PRLAR0_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR1_U_SMXP_3_1",
        .addr = A_POR_MPU_M1_PRBAR1_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR1_U_SMXP_3_1",
        .addr = A_POR_MPU_M1_PRLAR1_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR2_U_SMXP_3_1",
        .addr = A_POR_MPU_M1_PRBAR2_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR2_U_SMXP_3_1",
        .addr = A_POR_MPU_M1_PRLAR2_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR3_U_SMXP_3_1",
        .addr = A_POR_MPU_M1_PRBAR3_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR3_U_SMXP_3_1",
        .addr = A_POR_MPU_M1_PRLAR3_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR4_U_SMXP_3_1",
        .addr = A_POR_MPU_M1_PRBAR4_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR4_U_SMXP_3_1",
        .addr = A_POR_MPU_M1_PRLAR4_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR5_U_SMXP_3_1",
        .addr = A_POR_MPU_M1_PRBAR5_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR5_U_SMXP_3_1",
        .addr = A_POR_MPU_M1_PRLAR5_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR6_U_SMXP_3_1",
        .addr = A_POR_MPU_M1_PRBAR6_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR6_U_SMXP_3_1",
        .addr = A_POR_MPU_M1_PRLAR6_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR7_U_SMXP_3_1",
        .addr = A_POR_MPU_M1_PRBAR7_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR7_U_SMXP_3_1",
        .addr = A_POR_MPU_M1_PRLAR7_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR8_U_SMXP_3_1",
        .addr = A_POR_MPU_M1_PRBAR8_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR8_U_SMXP_3_1",
        .addr = A_POR_MPU_M1_PRLAR8_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR9_U_SMXP_3_1",
        .addr = A_POR_MPU_M1_PRBAR9_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR9_U_SMXP_3_1",
        .addr = A_POR_MPU_M1_PRLAR9_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR10_U_SMXP_3_1",
        .addr = A_POR_MPU_M1_PRBAR10_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR10_U_SMXP_3_1",
        .addr = A_POR_MPU_M1_PRLAR10_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR11_U_SMXP_3_1",
        .addr = A_POR_MPU_M1_PRBAR11_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR11_U_SMXP_3_1",
        .addr = A_POR_MPU_M1_PRLAR11_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR12_U_SMXP_3_1",
        .addr = A_POR_MPU_M1_PRBAR12_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR12_U_SMXP_3_1",
        .addr = A_POR_MPU_M1_PRLAR12_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR13_U_SMXP_3_1",
        .addr = A_POR_MPU_M1_PRBAR13_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR13_U_SMXP_3_1",
        .addr = A_POR_MPU_M1_PRLAR13_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR14_U_SMXP_3_1",
        .addr = A_POR_MPU_M1_PRBAR14_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR14_U_SMXP_3_1",
        .addr = A_POR_MPU_M1_PRLAR14_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR15_U_SMXP_3_1",
        .addr = A_POR_MPU_M1_PRBAR15_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR15_U_SMXP_3_1",
        .addr = A_POR_MPU_M1_PRLAR15_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR16_U_SMXP_3_1",
        .addr = A_POR_MPU_M1_PRBAR16_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR16_U_SMXP_3_1",
        .addr = A_POR_MPU_M1_PRLAR16_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR17_U_SMXP_3_1",
        .addr = A_POR_MPU_M1_PRBAR17_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR17_U_SMXP_3_1",
        .addr = A_POR_MPU_M1_PRLAR17_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR18_U_SMXP_3_1",
        .addr = A_POR_MPU_M1_PRBAR18_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR18_U_SMXP_3_1",
        .addr = A_POR_MPU_M1_PRLAR18_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR19_U_SMXP_3_1",
        .addr = A_POR_MPU_M1_PRBAR19_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR19_U_SMXP_3_1",
        .addr = A_POR_MPU_M1_PRLAR19_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR20_U_SMXP_3_1",
        .addr = A_POR_MPU_M1_PRBAR20_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR20_U_SMXP_3_1",
        .addr = A_POR_MPU_M1_PRLAR20_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR21_U_SMXP_3_1",
        .addr = A_POR_MPU_M1_PRBAR21_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR21_U_SMXP_3_1",
        .addr = A_POR_MPU_M1_PRLAR21_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR22_U_SMXP_3_1",
        .addr = A_POR_MPU_M1_PRBAR22_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR22_U_SMXP_3_1",
        .addr = A_POR_MPU_M1_PRLAR22_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR23_U_SMXP_3_1",
        .addr = A_POR_MPU_M1_PRBAR23_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR23_U_SMXP_3_1",
        .addr = A_POR_MPU_M1_PRLAR23_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR24_U_SMXP_3_1",
        .addr = A_POR_MPU_M1_PRBAR24_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR24_U_SMXP_3_1",
        .addr = A_POR_MPU_M1_PRLAR24_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR25_U_SMXP_3_1",
        .addr = A_POR_MPU_M1_PRBAR25_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR25_U_SMXP_3_1",
        .addr = A_POR_MPU_M1_PRLAR25_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR26_U_SMXP_3_1",
        .addr = A_POR_MPU_M1_PRBAR26_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR26_U_SMXP_3_1",
        .addr = A_POR_MPU_M1_PRLAR26_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR27_U_SMXP_3_1",
        .addr = A_POR_MPU_M1_PRBAR27_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR27_U_SMXP_3_1",
        .addr = A_POR_MPU_M1_PRLAR27_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR28_U_SMXP_3_1",
        .addr = A_POR_MPU_M1_PRBAR28_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR28_U_SMXP_3_1",
        .addr = A_POR_MPU_M1_PRLAR28_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR29_U_SMXP_3_1",
        .addr = A_POR_MPU_M1_PRBAR29_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR29_U_SMXP_3_1",
        .addr = A_POR_MPU_M1_PRLAR29_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR30_U_SMXP_3_1",
        .addr = A_POR_MPU_M1_PRBAR30_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR30_U_SMXP_3_1",
        .addr = A_POR_MPU_M1_PRLAR30_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR31_U_SMXP_3_1",
        .addr = A_POR_MPU_M1_PRBAR31_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR31_U_SMXP_3_1",
        .addr = A_POR_MPU_M1_PRLAR31_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_CTL_U_SMXP_3_1",
        .addr = A_POR_MPU_M2_CTL_U_SMXP_3_1,
        .reset = 0x2,
        .rsvd = 0xfffffffffffffff8L,
        .ro = 0xfffffffffffffff8L,
    },{ .name = "POR_MPU_M2_PRBAR0_U_SMXP_3_1",
        .addr = A_POR_MPU_M2_PRBAR0_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR0_U_SMXP_3_1",
        .addr = A_POR_MPU_M2_PRLAR0_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR1_U_SMXP_3_1",
        .addr = A_POR_MPU_M2_PRBAR1_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR1_U_SMXP_3_1",
        .addr = A_POR_MPU_M2_PRLAR1_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR2_U_SMXP_3_1",
        .addr = A_POR_MPU_M2_PRBAR2_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR2_U_SMXP_3_1",
        .addr = A_POR_MPU_M2_PRLAR2_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR3_U_SMXP_3_1",
        .addr = A_POR_MPU_M2_PRBAR3_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR3_U_SMXP_3_1",
        .addr = A_POR_MPU_M2_PRLAR3_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR4_U_SMXP_3_1",
        .addr = A_POR_MPU_M2_PRBAR4_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR4_U_SMXP_3_1",
        .addr = A_POR_MPU_M2_PRLAR4_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR5_U_SMXP_3_1",
        .addr = A_POR_MPU_M2_PRBAR5_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR5_U_SMXP_3_1",
        .addr = A_POR_MPU_M2_PRLAR5_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR6_U_SMXP_3_1",
        .addr = A_POR_MPU_M2_PRBAR6_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR6_U_SMXP_3_1",
        .addr = A_POR_MPU_M2_PRLAR6_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR7_U_SMXP_3_1",
        .addr = A_POR_MPU_M2_PRBAR7_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR7_U_SMXP_3_1",
        .addr = A_POR_MPU_M2_PRLAR7_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR8_U_SMXP_3_1",
        .addr = A_POR_MPU_M2_PRBAR8_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR8_U_SMXP_3_1",
        .addr = A_POR_MPU_M2_PRLAR8_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR9_U_SMXP_3_1",
        .addr = A_POR_MPU_M2_PRBAR9_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR9_U_SMXP_3_1",
        .addr = A_POR_MPU_M2_PRLAR9_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR10_U_SMXP_3_1",
        .addr = A_POR_MPU_M2_PRBAR10_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR10_U_SMXP_3_1",
        .addr = A_POR_MPU_M2_PRLAR10_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR11_U_SMXP_3_1",
        .addr = A_POR_MPU_M2_PRBAR11_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR11_U_SMXP_3_1",
        .addr = A_POR_MPU_M2_PRLAR11_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR12_U_SMXP_3_1",
        .addr = A_POR_MPU_M2_PRBAR12_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR12_U_SMXP_3_1",
        .addr = A_POR_MPU_M2_PRLAR12_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR13_U_SMXP_3_1",
        .addr = A_POR_MPU_M2_PRBAR13_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR13_U_SMXP_3_1",
        .addr = A_POR_MPU_M2_PRLAR13_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR14_U_SMXP_3_1",
        .addr = A_POR_MPU_M2_PRBAR14_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR14_U_SMXP_3_1",
        .addr = A_POR_MPU_M2_PRLAR14_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR15_U_SMXP_3_1",
        .addr = A_POR_MPU_M2_PRBAR15_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR15_U_SMXP_3_1",
        .addr = A_POR_MPU_M2_PRLAR15_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR16_U_SMXP_3_1",
        .addr = A_POR_MPU_M2_PRBAR16_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR16_U_SMXP_3_1",
        .addr = A_POR_MPU_M2_PRLAR16_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR17_U_SMXP_3_1",
        .addr = A_POR_MPU_M2_PRBAR17_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR17_U_SMXP_3_1",
        .addr = A_POR_MPU_M2_PRLAR17_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR18_U_SMXP_3_1",
        .addr = A_POR_MPU_M2_PRBAR18_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR18_U_SMXP_3_1",
        .addr = A_POR_MPU_M2_PRLAR18_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR19_U_SMXP_3_1",
        .addr = A_POR_MPU_M2_PRBAR19_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR19_U_SMXP_3_1",
        .addr = A_POR_MPU_M2_PRLAR19_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR20_U_SMXP_3_1",
        .addr = A_POR_MPU_M2_PRBAR20_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR20_U_SMXP_3_1",
        .addr = A_POR_MPU_M2_PRLAR20_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR21_U_SMXP_3_1",
        .addr = A_POR_MPU_M2_PRBAR21_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR21_U_SMXP_3_1",
        .addr = A_POR_MPU_M2_PRLAR21_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR22_U_SMXP_3_1",
        .addr = A_POR_MPU_M2_PRBAR22_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR22_U_SMXP_3_1",
        .addr = A_POR_MPU_M2_PRLAR22_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR23_U_SMXP_3_1",
        .addr = A_POR_MPU_M2_PRBAR23_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR23_U_SMXP_3_1",
        .addr = A_POR_MPU_M2_PRLAR23_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR24_U_SMXP_3_1",
        .addr = A_POR_MPU_M2_PRBAR24_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR24_U_SMXP_3_1",
        .addr = A_POR_MPU_M2_PRLAR24_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR25_U_SMXP_3_1",
        .addr = A_POR_MPU_M2_PRBAR25_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR25_U_SMXP_3_1",
        .addr = A_POR_MPU_M2_PRLAR25_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR26_U_SMXP_3_1",
        .addr = A_POR_MPU_M2_PRBAR26_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR26_U_SMXP_3_1",
        .addr = A_POR_MPU_M2_PRLAR26_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR27_U_SMXP_3_1",
        .addr = A_POR_MPU_M2_PRBAR27_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR27_U_SMXP_3_1",
        .addr = A_POR_MPU_M2_PRLAR27_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR28_U_SMXP_3_1",
        .addr = A_POR_MPU_M2_PRBAR28_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR28_U_SMXP_3_1",
        .addr = A_POR_MPU_M2_PRLAR28_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR29_U_SMXP_3_1",
        .addr = A_POR_MPU_M2_PRBAR29_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR29_U_SMXP_3_1",
        .addr = A_POR_MPU_M2_PRLAR29_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR30_U_SMXP_3_1",
        .addr = A_POR_MPU_M2_PRBAR30_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR30_U_SMXP_3_1",
        .addr = A_POR_MPU_M2_PRLAR30_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR31_U_SMXP_3_1",
        .addr = A_POR_MPU_M2_PRBAR31_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR31_U_SMXP_3_1",
        .addr = A_POR_MPU_M2_PRLAR31_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_CTL_U_SMXP_3_1",
        .addr = A_POR_MPU_M3_CTL_U_SMXP_3_1,
        .reset = 0x2,
        .rsvd = 0xfffffffffffffff8L,
        .ro = 0xfffffffffffffff8L,
    },{ .name = "POR_MPU_M3_PRBAR0_U_SMXP_3_1",
        .addr = A_POR_MPU_M3_PRBAR0_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR0_U_SMXP_3_1",
        .addr = A_POR_MPU_M3_PRLAR0_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR1_U_SMXP_3_1",
        .addr = A_POR_MPU_M3_PRBAR1_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR1_U_SMXP_3_1",
        .addr = A_POR_MPU_M3_PRLAR1_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR2_U_SMXP_3_1",
        .addr = A_POR_MPU_M3_PRBAR2_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR2_U_SMXP_3_1",
        .addr = A_POR_MPU_M3_PRLAR2_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR3_U_SMXP_3_1",
        .addr = A_POR_MPU_M3_PRBAR3_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR3_U_SMXP_3_1",
        .addr = A_POR_MPU_M3_PRLAR3_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR4_U_SMXP_3_1",
        .addr = A_POR_MPU_M3_PRBAR4_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR4_U_SMXP_3_1",
        .addr = A_POR_MPU_M3_PRLAR4_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR5_U_SMXP_3_1",
        .addr = A_POR_MPU_M3_PRBAR5_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR5_U_SMXP_3_1",
        .addr = A_POR_MPU_M3_PRLAR5_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR6_U_SMXP_3_1",
        .addr = A_POR_MPU_M3_PRBAR6_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR6_U_SMXP_3_1",
        .addr = A_POR_MPU_M3_PRLAR6_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR7_U_SMXP_3_1",
        .addr = A_POR_MPU_M3_PRBAR7_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR7_U_SMXP_3_1",
        .addr = A_POR_MPU_M3_PRLAR7_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR8_U_SMXP_3_1",
        .addr = A_POR_MPU_M3_PRBAR8_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR8_U_SMXP_3_1",
        .addr = A_POR_MPU_M3_PRLAR8_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR9_U_SMXP_3_1",
        .addr = A_POR_MPU_M3_PRBAR9_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR9_U_SMXP_3_1",
        .addr = A_POR_MPU_M3_PRLAR9_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR10_U_SMXP_3_1",
        .addr = A_POR_MPU_M3_PRBAR10_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR10_U_SMXP_3_1",
        .addr = A_POR_MPU_M3_PRLAR10_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR11_U_SMXP_3_1",
        .addr = A_POR_MPU_M3_PRBAR11_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR11_U_SMXP_3_1",
        .addr = A_POR_MPU_M3_PRLAR11_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR12_U_SMXP_3_1",
        .addr = A_POR_MPU_M3_PRBAR12_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR12_U_SMXP_3_1",
        .addr = A_POR_MPU_M3_PRLAR12_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR13_U_SMXP_3_1",
        .addr = A_POR_MPU_M3_PRBAR13_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR13_U_SMXP_3_1",
        .addr = A_POR_MPU_M3_PRLAR13_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR14_U_SMXP_3_1",
        .addr = A_POR_MPU_M3_PRBAR14_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR14_U_SMXP_3_1",
        .addr = A_POR_MPU_M3_PRLAR14_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR15_U_SMXP_3_1",
        .addr = A_POR_MPU_M3_PRBAR15_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR15_U_SMXP_3_1",
        .addr = A_POR_MPU_M3_PRLAR15_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR16_U_SMXP_3_1",
        .addr = A_POR_MPU_M3_PRBAR16_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR16_U_SMXP_3_1",
        .addr = A_POR_MPU_M3_PRLAR16_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR17_U_SMXP_3_1",
        .addr = A_POR_MPU_M3_PRBAR17_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR17_U_SMXP_3_1",
        .addr = A_POR_MPU_M3_PRLAR17_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR18_U_SMXP_3_1",
        .addr = A_POR_MPU_M3_PRBAR18_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR18_U_SMXP_3_1",
        .addr = A_POR_MPU_M3_PRLAR18_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR19_U_SMXP_3_1",
        .addr = A_POR_MPU_M3_PRBAR19_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR19_U_SMXP_3_1",
        .addr = A_POR_MPU_M3_PRLAR19_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR20_U_SMXP_3_1",
        .addr = A_POR_MPU_M3_PRBAR20_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR20_U_SMXP_3_1",
        .addr = A_POR_MPU_M3_PRLAR20_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR21_U_SMXP_3_1",
        .addr = A_POR_MPU_M3_PRBAR21_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR21_U_SMXP_3_1",
        .addr = A_POR_MPU_M3_PRLAR21_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR22_U_SMXP_3_1",
        .addr = A_POR_MPU_M3_PRBAR22_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR22_U_SMXP_3_1",
        .addr = A_POR_MPU_M3_PRLAR22_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR23_U_SMXP_3_1",
        .addr = A_POR_MPU_M3_PRBAR23_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR23_U_SMXP_3_1",
        .addr = A_POR_MPU_M3_PRLAR23_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR24_U_SMXP_3_1",
        .addr = A_POR_MPU_M3_PRBAR24_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR24_U_SMXP_3_1",
        .addr = A_POR_MPU_M3_PRLAR24_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR25_U_SMXP_3_1",
        .addr = A_POR_MPU_M3_PRBAR25_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR25_U_SMXP_3_1",
        .addr = A_POR_MPU_M3_PRLAR25_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR26_U_SMXP_3_1",
        .addr = A_POR_MPU_M3_PRBAR26_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR26_U_SMXP_3_1",
        .addr = A_POR_MPU_M3_PRLAR26_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR27_U_SMXP_3_1",
        .addr = A_POR_MPU_M3_PRBAR27_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR27_U_SMXP_3_1",
        .addr = A_POR_MPU_M3_PRLAR27_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR28_U_SMXP_3_1",
        .addr = A_POR_MPU_M3_PRBAR28_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR28_U_SMXP_3_1",
        .addr = A_POR_MPU_M3_PRLAR28_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR29_U_SMXP_3_1",
        .addr = A_POR_MPU_M3_PRBAR29_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR29_U_SMXP_3_1",
        .addr = A_POR_MPU_M3_PRLAR29_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR30_U_SMXP_3_1",
        .addr = A_POR_MPU_M3_PRBAR30_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR30_U_SMXP_3_1",
        .addr = A_POR_MPU_M3_PRLAR30_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR31_U_SMXP_3_1",
        .addr = A_POR_MPU_M3_PRBAR31_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR31_U_SMXP_3_1",
        .addr = A_POR_MPU_M3_PRLAR31_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_CTL_U_SMXP_3_1",
        .addr = A_POR_MPU_M4_CTL_U_SMXP_3_1,
        .reset = 0x2,
        .rsvd = 0xfffffffffffffff8L,
        .ro = 0xfffffffffffffff8L,
    },{ .name = "POR_MPU_M4_PRBAR0_U_SMXP_3_1",
        .addr = A_POR_MPU_M4_PRBAR0_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR0_U_SMXP_3_1",
        .addr = A_POR_MPU_M4_PRLAR0_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR1_U_SMXP_3_1",
        .addr = A_POR_MPU_M4_PRBAR1_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR1_U_SMXP_3_1",
        .addr = A_POR_MPU_M4_PRLAR1_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR2_U_SMXP_3_1",
        .addr = A_POR_MPU_M4_PRBAR2_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR2_U_SMXP_3_1",
        .addr = A_POR_MPU_M4_PRLAR2_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR3_U_SMXP_3_1",
        .addr = A_POR_MPU_M4_PRBAR3_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR3_U_SMXP_3_1",
        .addr = A_POR_MPU_M4_PRLAR3_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR4_U_SMXP_3_1",
        .addr = A_POR_MPU_M4_PRBAR4_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR4_U_SMXP_3_1",
        .addr = A_POR_MPU_M4_PRLAR4_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR5_U_SMXP_3_1",
        .addr = A_POR_MPU_M4_PRBAR5_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR5_U_SMXP_3_1",
        .addr = A_POR_MPU_M4_PRLAR5_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR6_U_SMXP_3_1",
        .addr = A_POR_MPU_M4_PRBAR6_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR6_U_SMXP_3_1",
        .addr = A_POR_MPU_M4_PRLAR6_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR7_U_SMXP_3_1",
        .addr = A_POR_MPU_M4_PRBAR7_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR7_U_SMXP_3_1",
        .addr = A_POR_MPU_M4_PRLAR7_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR8_U_SMXP_3_1",
        .addr = A_POR_MPU_M4_PRBAR8_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR8_U_SMXP_3_1",
        .addr = A_POR_MPU_M4_PRLAR8_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR9_U_SMXP_3_1",
        .addr = A_POR_MPU_M4_PRBAR9_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR9_U_SMXP_3_1",
        .addr = A_POR_MPU_M4_PRLAR9_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR10_U_SMXP_3_1",
        .addr = A_POR_MPU_M4_PRBAR10_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR10_U_SMXP_3_1",
        .addr = A_POR_MPU_M4_PRLAR10_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR11_U_SMXP_3_1",
        .addr = A_POR_MPU_M4_PRBAR11_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR11_U_SMXP_3_1",
        .addr = A_POR_MPU_M4_PRLAR11_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR12_U_SMXP_3_1",
        .addr = A_POR_MPU_M4_PRBAR12_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR12_U_SMXP_3_1",
        .addr = A_POR_MPU_M4_PRLAR12_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR13_U_SMXP_3_1",
        .addr = A_POR_MPU_M4_PRBAR13_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR13_U_SMXP_3_1",
        .addr = A_POR_MPU_M4_PRLAR13_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR14_U_SMXP_3_1",
        .addr = A_POR_MPU_M4_PRBAR14_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR14_U_SMXP_3_1",
        .addr = A_POR_MPU_M4_PRLAR14_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR15_U_SMXP_3_1",
        .addr = A_POR_MPU_M4_PRBAR15_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR15_U_SMXP_3_1",
        .addr = A_POR_MPU_M4_PRLAR15_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR16_U_SMXP_3_1",
        .addr = A_POR_MPU_M4_PRBAR16_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR16_U_SMXP_3_1",
        .addr = A_POR_MPU_M4_PRLAR16_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR17_U_SMXP_3_1",
        .addr = A_POR_MPU_M4_PRBAR17_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR17_U_SMXP_3_1",
        .addr = A_POR_MPU_M4_PRLAR17_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR18_U_SMXP_3_1",
        .addr = A_POR_MPU_M4_PRBAR18_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR18_U_SMXP_3_1",
        .addr = A_POR_MPU_M4_PRLAR18_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR19_U_SMXP_3_1",
        .addr = A_POR_MPU_M4_PRBAR19_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR19_U_SMXP_3_1",
        .addr = A_POR_MPU_M4_PRLAR19_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR20_U_SMXP_3_1",
        .addr = A_POR_MPU_M4_PRBAR20_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR20_U_SMXP_3_1",
        .addr = A_POR_MPU_M4_PRLAR20_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR21_U_SMXP_3_1",
        .addr = A_POR_MPU_M4_PRBAR21_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR21_U_SMXP_3_1",
        .addr = A_POR_MPU_M4_PRLAR21_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR22_U_SMXP_3_1",
        .addr = A_POR_MPU_M4_PRBAR22_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR22_U_SMXP_3_1",
        .addr = A_POR_MPU_M4_PRLAR22_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR23_U_SMXP_3_1",
        .addr = A_POR_MPU_M4_PRBAR23_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR23_U_SMXP_3_1",
        .addr = A_POR_MPU_M4_PRLAR23_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR24_U_SMXP_3_1",
        .addr = A_POR_MPU_M4_PRBAR24_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR24_U_SMXP_3_1",
        .addr = A_POR_MPU_M4_PRLAR24_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR25_U_SMXP_3_1",
        .addr = A_POR_MPU_M4_PRBAR25_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR25_U_SMXP_3_1",
        .addr = A_POR_MPU_M4_PRLAR25_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR26_U_SMXP_3_1",
        .addr = A_POR_MPU_M4_PRBAR26_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR26_U_SMXP_3_1",
        .addr = A_POR_MPU_M4_PRLAR26_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR27_U_SMXP_3_1",
        .addr = A_POR_MPU_M4_PRBAR27_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR27_U_SMXP_3_1",
        .addr = A_POR_MPU_M4_PRLAR27_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR28_U_SMXP_3_1",
        .addr = A_POR_MPU_M4_PRBAR28_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR28_U_SMXP_3_1",
        .addr = A_POR_MPU_M4_PRLAR28_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR29_U_SMXP_3_1",
        .addr = A_POR_MPU_M4_PRBAR29_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR29_U_SMXP_3_1",
        .addr = A_POR_MPU_M4_PRLAR29_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR30_U_SMXP_3_1",
        .addr = A_POR_MPU_M4_PRBAR30_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR30_U_SMXP_3_1",
        .addr = A_POR_MPU_M4_PRLAR30_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR31_U_SMXP_3_1",
        .addr = A_POR_MPU_M4_PRBAR31_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR31_U_SMXP_3_1",
        .addr = A_POR_MPU_M4_PRLAR31_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_CTL_U_SMXP_3_1",
        .addr = A_POR_MPU_M5_CTL_U_SMXP_3_1,
        .reset = 0x2,
        .rsvd = 0xfffffffffffffff8L,
        .ro = 0xfffffffffffffff8L,
    },{ .name = "POR_MPU_M5_PRBAR0_U_SMXP_3_1",
        .addr = A_POR_MPU_M5_PRBAR0_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR0_U_SMXP_3_1",
        .addr = A_POR_MPU_M5_PRLAR0_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR1_U_SMXP_3_1",
        .addr = A_POR_MPU_M5_PRBAR1_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR1_U_SMXP_3_1",
        .addr = A_POR_MPU_M5_PRLAR1_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR2_U_SMXP_3_1",
        .addr = A_POR_MPU_M5_PRBAR2_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR2_U_SMXP_3_1",
        .addr = A_POR_MPU_M5_PRLAR2_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR3_U_SMXP_3_1",
        .addr = A_POR_MPU_M5_PRBAR3_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR3_U_SMXP_3_1",
        .addr = A_POR_MPU_M5_PRLAR3_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR4_U_SMXP_3_1",
        .addr = A_POR_MPU_M5_PRBAR4_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR4_U_SMXP_3_1",
        .addr = A_POR_MPU_M5_PRLAR4_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR5_U_SMXP_3_1",
        .addr = A_POR_MPU_M5_PRBAR5_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR5_U_SMXP_3_1",
        .addr = A_POR_MPU_M5_PRLAR5_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR6_U_SMXP_3_1",
        .addr = A_POR_MPU_M5_PRBAR6_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR6_U_SMXP_3_1",
        .addr = A_POR_MPU_M5_PRLAR6_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR7_U_SMXP_3_1",
        .addr = A_POR_MPU_M5_PRBAR7_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR7_U_SMXP_3_1",
        .addr = A_POR_MPU_M5_PRLAR7_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR8_U_SMXP_3_1",
        .addr = A_POR_MPU_M5_PRBAR8_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR8_U_SMXP_3_1",
        .addr = A_POR_MPU_M5_PRLAR8_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR9_U_SMXP_3_1",
        .addr = A_POR_MPU_M5_PRBAR9_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR9_U_SMXP_3_1",
        .addr = A_POR_MPU_M5_PRLAR9_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR10_U_SMXP_3_1",
        .addr = A_POR_MPU_M5_PRBAR10_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR10_U_SMXP_3_1",
        .addr = A_POR_MPU_M5_PRLAR10_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR11_U_SMXP_3_1",
        .addr = A_POR_MPU_M5_PRBAR11_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR11_U_SMXP_3_1",
        .addr = A_POR_MPU_M5_PRLAR11_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR12_U_SMXP_3_1",
        .addr = A_POR_MPU_M5_PRBAR12_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR12_U_SMXP_3_1",
        .addr = A_POR_MPU_M5_PRLAR12_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR13_U_SMXP_3_1",
        .addr = A_POR_MPU_M5_PRBAR13_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR13_U_SMXP_3_1",
        .addr = A_POR_MPU_M5_PRLAR13_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR14_U_SMXP_3_1",
        .addr = A_POR_MPU_M5_PRBAR14_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR14_U_SMXP_3_1",
        .addr = A_POR_MPU_M5_PRLAR14_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR15_U_SMXP_3_1",
        .addr = A_POR_MPU_M5_PRBAR15_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR15_U_SMXP_3_1",
        .addr = A_POR_MPU_M5_PRLAR15_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR16_U_SMXP_3_1",
        .addr = A_POR_MPU_M5_PRBAR16_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR16_U_SMXP_3_1",
        .addr = A_POR_MPU_M5_PRLAR16_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR17_U_SMXP_3_1",
        .addr = A_POR_MPU_M5_PRBAR17_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR17_U_SMXP_3_1",
        .addr = A_POR_MPU_M5_PRLAR17_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR18_U_SMXP_3_1",
        .addr = A_POR_MPU_M5_PRBAR18_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR18_U_SMXP_3_1",
        .addr = A_POR_MPU_M5_PRLAR18_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR19_U_SMXP_3_1",
        .addr = A_POR_MPU_M5_PRBAR19_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR19_U_SMXP_3_1",
        .addr = A_POR_MPU_M5_PRLAR19_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR20_U_SMXP_3_1",
        .addr = A_POR_MPU_M5_PRBAR20_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR20_U_SMXP_3_1",
        .addr = A_POR_MPU_M5_PRLAR20_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR21_U_SMXP_3_1",
        .addr = A_POR_MPU_M5_PRBAR21_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR21_U_SMXP_3_1",
        .addr = A_POR_MPU_M5_PRLAR21_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR22_U_SMXP_3_1",
        .addr = A_POR_MPU_M5_PRBAR22_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR22_U_SMXP_3_1",
        .addr = A_POR_MPU_M5_PRLAR22_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR23_U_SMXP_3_1",
        .addr = A_POR_MPU_M5_PRBAR23_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR23_U_SMXP_3_1",
        .addr = A_POR_MPU_M5_PRLAR23_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR24_U_SMXP_3_1",
        .addr = A_POR_MPU_M5_PRBAR24_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR24_U_SMXP_3_1",
        .addr = A_POR_MPU_M5_PRLAR24_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR25_U_SMXP_3_1",
        .addr = A_POR_MPU_M5_PRBAR25_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR25_U_SMXP_3_1",
        .addr = A_POR_MPU_M5_PRLAR25_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR26_U_SMXP_3_1",
        .addr = A_POR_MPU_M5_PRBAR26_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR26_U_SMXP_3_1",
        .addr = A_POR_MPU_M5_PRLAR26_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR27_U_SMXP_3_1",
        .addr = A_POR_MPU_M5_PRBAR27_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR27_U_SMXP_3_1",
        .addr = A_POR_MPU_M5_PRLAR27_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR28_U_SMXP_3_1",
        .addr = A_POR_MPU_M5_PRBAR28_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR28_U_SMXP_3_1",
        .addr = A_POR_MPU_M5_PRLAR28_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR29_U_SMXP_3_1",
        .addr = A_POR_MPU_M5_PRBAR29_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR29_U_SMXP_3_1",
        .addr = A_POR_MPU_M5_PRLAR29_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR30_U_SMXP_3_1",
        .addr = A_POR_MPU_M5_PRBAR30_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR30_U_SMXP_3_1",
        .addr = A_POR_MPU_M5_PRLAR30_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR31_U_SMXP_3_1",
        .addr = A_POR_MPU_M5_PRBAR31_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR31_U_SMXP_3_1",
        .addr = A_POR_MPU_M5_PRLAR31_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_CTL_U_SMXP_3_1",
        .addr = A_POR_MPU_M6_CTL_U_SMXP_3_1,
        .reset = 0x2,
        .rsvd = 0xfffffffffffffff8L,
        .ro = 0xfffffffffffffff8L,
    },{ .name = "POR_MPU_M6_PRBAR0_U_SMXP_3_1",
        .addr = A_POR_MPU_M6_PRBAR0_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR0_U_SMXP_3_1",
        .addr = A_POR_MPU_M6_PRLAR0_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR1_U_SMXP_3_1",
        .addr = A_POR_MPU_M6_PRBAR1_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR1_U_SMXP_3_1",
        .addr = A_POR_MPU_M6_PRLAR1_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR2_U_SMXP_3_1",
        .addr = A_POR_MPU_M6_PRBAR2_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR2_U_SMXP_3_1",
        .addr = A_POR_MPU_M6_PRLAR2_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR3_U_SMXP_3_1",
        .addr = A_POR_MPU_M6_PRBAR3_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR3_U_SMXP_3_1",
        .addr = A_POR_MPU_M6_PRLAR3_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR4_U_SMXP_3_1",
        .addr = A_POR_MPU_M6_PRBAR4_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR4_U_SMXP_3_1",
        .addr = A_POR_MPU_M6_PRLAR4_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR5_U_SMXP_3_1",
        .addr = A_POR_MPU_M6_PRBAR5_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR5_U_SMXP_3_1",
        .addr = A_POR_MPU_M6_PRLAR5_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR6_U_SMXP_3_1",
        .addr = A_POR_MPU_M6_PRBAR6_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR6_U_SMXP_3_1",
        .addr = A_POR_MPU_M6_PRLAR6_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR7_U_SMXP_3_1",
        .addr = A_POR_MPU_M6_PRBAR7_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR7_U_SMXP_3_1",
        .addr = A_POR_MPU_M6_PRLAR7_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR8_U_SMXP_3_1",
        .addr = A_POR_MPU_M6_PRBAR8_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR8_U_SMXP_3_1",
        .addr = A_POR_MPU_M6_PRLAR8_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR9_U_SMXP_3_1",
        .addr = A_POR_MPU_M6_PRBAR9_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR9_U_SMXP_3_1",
        .addr = A_POR_MPU_M6_PRLAR9_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR10_U_SMXP_3_1",
        .addr = A_POR_MPU_M6_PRBAR10_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR10_U_SMXP_3_1",
        .addr = A_POR_MPU_M6_PRLAR10_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR11_U_SMXP_3_1",
        .addr = A_POR_MPU_M6_PRBAR11_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR11_U_SMXP_3_1",
        .addr = A_POR_MPU_M6_PRLAR11_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR12_U_SMXP_3_1",
        .addr = A_POR_MPU_M6_PRBAR12_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR12_U_SMXP_3_1",
        .addr = A_POR_MPU_M6_PRLAR12_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR13_U_SMXP_3_1",
        .addr = A_POR_MPU_M6_PRBAR13_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR13_U_SMXP_3_1",
        .addr = A_POR_MPU_M6_PRLAR13_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR14_U_SMXP_3_1",
        .addr = A_POR_MPU_M6_PRBAR14_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR14_U_SMXP_3_1",
        .addr = A_POR_MPU_M6_PRLAR14_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR15_U_SMXP_3_1",
        .addr = A_POR_MPU_M6_PRBAR15_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR15_U_SMXP_3_1",
        .addr = A_POR_MPU_M6_PRLAR15_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR16_U_SMXP_3_1",
        .addr = A_POR_MPU_M6_PRBAR16_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR16_U_SMXP_3_1",
        .addr = A_POR_MPU_M6_PRLAR16_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR17_U_SMXP_3_1",
        .addr = A_POR_MPU_M6_PRBAR17_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR17_U_SMXP_3_1",
        .addr = A_POR_MPU_M6_PRLAR17_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR18_U_SMXP_3_1",
        .addr = A_POR_MPU_M6_PRBAR18_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR18_U_SMXP_3_1",
        .addr = A_POR_MPU_M6_PRLAR18_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR19_U_SMXP_3_1",
        .addr = A_POR_MPU_M6_PRBAR19_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR19_U_SMXP_3_1",
        .addr = A_POR_MPU_M6_PRLAR19_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR20_U_SMXP_3_1",
        .addr = A_POR_MPU_M6_PRBAR20_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR20_U_SMXP_3_1",
        .addr = A_POR_MPU_M6_PRLAR20_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR21_U_SMXP_3_1",
        .addr = A_POR_MPU_M6_PRBAR21_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR21_U_SMXP_3_1",
        .addr = A_POR_MPU_M6_PRLAR21_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR22_U_SMXP_3_1",
        .addr = A_POR_MPU_M6_PRBAR22_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR22_U_SMXP_3_1",
        .addr = A_POR_MPU_M6_PRLAR22_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR23_U_SMXP_3_1",
        .addr = A_POR_MPU_M6_PRBAR23_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR23_U_SMXP_3_1",
        .addr = A_POR_MPU_M6_PRLAR23_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR24_U_SMXP_3_1",
        .addr = A_POR_MPU_M6_PRBAR24_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR24_U_SMXP_3_1",
        .addr = A_POR_MPU_M6_PRLAR24_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR25_U_SMXP_3_1",
        .addr = A_POR_MPU_M6_PRBAR25_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR25_U_SMXP_3_1",
        .addr = A_POR_MPU_M6_PRLAR25_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR26_U_SMXP_3_1",
        .addr = A_POR_MPU_M6_PRBAR26_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR26_U_SMXP_3_1",
        .addr = A_POR_MPU_M6_PRLAR26_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR27_U_SMXP_3_1",
        .addr = A_POR_MPU_M6_PRBAR27_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR27_U_SMXP_3_1",
        .addr = A_POR_MPU_M6_PRLAR27_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR28_U_SMXP_3_1",
        .addr = A_POR_MPU_M6_PRBAR28_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR28_U_SMXP_3_1",
        .addr = A_POR_MPU_M6_PRLAR28_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR29_U_SMXP_3_1",
        .addr = A_POR_MPU_M6_PRBAR29_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR29_U_SMXP_3_1",
        .addr = A_POR_MPU_M6_PRLAR29_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR30_U_SMXP_3_1",
        .addr = A_POR_MPU_M6_PRBAR30_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR30_U_SMXP_3_1",
        .addr = A_POR_MPU_M6_PRLAR30_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR31_U_SMXP_3_1",
        .addr = A_POR_MPU_M6_PRBAR31_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR31_U_SMXP_3_1",
        .addr = A_POR_MPU_M6_PRLAR31_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_CTL_U_SMXP_3_1",
        .addr = A_POR_MPU_M7_CTL_U_SMXP_3_1,
        .reset = 0x2,
        .rsvd = 0xfffffffffffffff8L,
        .ro = 0xfffffffffffffff8L,
    },{ .name = "POR_MPU_M7_PRBAR0_U_SMXP_3_1",
        .addr = A_POR_MPU_M7_PRBAR0_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR0_U_SMXP_3_1",
        .addr = A_POR_MPU_M7_PRLAR0_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR1_U_SMXP_3_1",
        .addr = A_POR_MPU_M7_PRBAR1_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR1_U_SMXP_3_1",
        .addr = A_POR_MPU_M7_PRLAR1_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR2_U_SMXP_3_1",
        .addr = A_POR_MPU_M7_PRBAR2_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR2_U_SMXP_3_1",
        .addr = A_POR_MPU_M7_PRLAR2_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR3_U_SMXP_3_1",
        .addr = A_POR_MPU_M7_PRBAR3_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR3_U_SMXP_3_1",
        .addr = A_POR_MPU_M7_PRLAR3_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR4_U_SMXP_3_1",
        .addr = A_POR_MPU_M7_PRBAR4_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR4_U_SMXP_3_1",
        .addr = A_POR_MPU_M7_PRLAR4_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR5_U_SMXP_3_1",
        .addr = A_POR_MPU_M7_PRBAR5_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR5_U_SMXP_3_1",
        .addr = A_POR_MPU_M7_PRLAR5_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR6_U_SMXP_3_1",
        .addr = A_POR_MPU_M7_PRBAR6_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR6_U_SMXP_3_1",
        .addr = A_POR_MPU_M7_PRLAR6_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR7_U_SMXP_3_1",
        .addr = A_POR_MPU_M7_PRBAR7_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR7_U_SMXP_3_1",
        .addr = A_POR_MPU_M7_PRLAR7_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR8_U_SMXP_3_1",
        .addr = A_POR_MPU_M7_PRBAR8_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR8_U_SMXP_3_1",
        .addr = A_POR_MPU_M7_PRLAR8_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR9_U_SMXP_3_1",
        .addr = A_POR_MPU_M7_PRBAR9_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR9_U_SMXP_3_1",
        .addr = A_POR_MPU_M7_PRLAR9_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR10_U_SMXP_3_1",
        .addr = A_POR_MPU_M7_PRBAR10_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR10_U_SMXP_3_1",
        .addr = A_POR_MPU_M7_PRLAR10_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR11_U_SMXP_3_1",
        .addr = A_POR_MPU_M7_PRBAR11_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR11_U_SMXP_3_1",
        .addr = A_POR_MPU_M7_PRLAR11_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR12_U_SMXP_3_1",
        .addr = A_POR_MPU_M7_PRBAR12_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR12_U_SMXP_3_1",
        .addr = A_POR_MPU_M7_PRLAR12_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR13_U_SMXP_3_1",
        .addr = A_POR_MPU_M7_PRBAR13_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR13_U_SMXP_3_1",
        .addr = A_POR_MPU_M7_PRLAR13_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR14_U_SMXP_3_1",
        .addr = A_POR_MPU_M7_PRBAR14_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR14_U_SMXP_3_1",
        .addr = A_POR_MPU_M7_PRLAR14_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR15_U_SMXP_3_1",
        .addr = A_POR_MPU_M7_PRBAR15_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR15_U_SMXP_3_1",
        .addr = A_POR_MPU_M7_PRLAR15_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR16_U_SMXP_3_1",
        .addr = A_POR_MPU_M7_PRBAR16_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR16_U_SMXP_3_1",
        .addr = A_POR_MPU_M7_PRLAR16_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR17_U_SMXP_3_1",
        .addr = A_POR_MPU_M7_PRBAR17_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR17_U_SMXP_3_1",
        .addr = A_POR_MPU_M7_PRLAR17_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR18_U_SMXP_3_1",
        .addr = A_POR_MPU_M7_PRBAR18_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR18_U_SMXP_3_1",
        .addr = A_POR_MPU_M7_PRLAR18_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR19_U_SMXP_3_1",
        .addr = A_POR_MPU_M7_PRBAR19_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR19_U_SMXP_3_1",
        .addr = A_POR_MPU_M7_PRLAR19_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR20_U_SMXP_3_1",
        .addr = A_POR_MPU_M7_PRBAR20_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR20_U_SMXP_3_1",
        .addr = A_POR_MPU_M7_PRLAR20_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR21_U_SMXP_3_1",
        .addr = A_POR_MPU_M7_PRBAR21_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR21_U_SMXP_3_1",
        .addr = A_POR_MPU_M7_PRLAR21_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR22_U_SMXP_3_1",
        .addr = A_POR_MPU_M7_PRBAR22_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR22_U_SMXP_3_1",
        .addr = A_POR_MPU_M7_PRLAR22_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR23_U_SMXP_3_1",
        .addr = A_POR_MPU_M7_PRBAR23_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR23_U_SMXP_3_1",
        .addr = A_POR_MPU_M7_PRLAR23_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR24_U_SMXP_3_1",
        .addr = A_POR_MPU_M7_PRBAR24_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR24_U_SMXP_3_1",
        .addr = A_POR_MPU_M7_PRLAR24_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR25_U_SMXP_3_1",
        .addr = A_POR_MPU_M7_PRBAR25_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR25_U_SMXP_3_1",
        .addr = A_POR_MPU_M7_PRLAR25_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR26_U_SMXP_3_1",
        .addr = A_POR_MPU_M7_PRBAR26_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR26_U_SMXP_3_1",
        .addr = A_POR_MPU_M7_PRLAR26_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR27_U_SMXP_3_1",
        .addr = A_POR_MPU_M7_PRBAR27_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR27_U_SMXP_3_1",
        .addr = A_POR_MPU_M7_PRLAR27_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR28_U_SMXP_3_1",
        .addr = A_POR_MPU_M7_PRBAR28_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR28_U_SMXP_3_1",
        .addr = A_POR_MPU_M7_PRLAR28_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR29_U_SMXP_3_1",
        .addr = A_POR_MPU_M7_PRBAR29_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR29_U_SMXP_3_1",
        .addr = A_POR_MPU_M7_PRLAR29_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR30_U_SMXP_3_1",
        .addr = A_POR_MPU_M7_PRBAR30_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR30_U_SMXP_3_1",
        .addr = A_POR_MPU_M7_PRLAR30_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR31_U_SMXP_3_1",
        .addr = A_POR_MPU_M7_PRBAR31_U_SMXP_3_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR31_U_SMXP_3_1",
        .addr = A_POR_MPU_M7_PRLAR31_U_SMXP_3_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_RNSAM_NODE_INFO_U_RNFBESAM_NID204",
        .addr = A_POR_RNSAM_NODE_INFO_U_RNFBESAM_NID204,
        .reset = 0x4000f,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_RNSAM_CHILD_INFO_U_RNFBESAM_NID204",
        .addr = A_POR_RNSAM_CHILD_INFO_U_RNFBESAM_NID204,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_RNSAM_UNIT_INFO_U_RNFBESAM_NID204",
        .addr = A_POR_RNSAM_UNIT_INFO_U_RNFBESAM_NID204,
        .reset = 0x800040004,
        .rsvd = 0xff00,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_RNSAM_SECURE_REGISTER_GROUPS_OVERRIDE_U_RNFBESAM_NID204",
        .addr = A_POR_RNSAM_SECURE_REGISTER_GROUPS_OVERRIDE_U_RNFBESAM_NID204,
        .rsvd = 0xfffffffffffffffeL,
        .ro = 0xfffffffffffffffeL,
    },{ .name = "RNSAM_STATUS_U_RNFBESAM_NID204",
        .addr = A_RNSAM_STATUS_U_RNFBESAM_NID204,
        .reset = 0x1,
        .rsvd = 0xfffffffffffffffcL,
        .ro = 0xfffffffffffffffcL,
    },{ .name = "NON_HASH_MEM_REGION_REG0_U_RNFBESAM_NID204",
        .addr = A_NON_HASH_MEM_REGION_REG0_U_RNFBESAM_NID204,
        .rsvd = 0x2,
        .ro = 0x8000000280000002L,
    },{ .name = "NON_HASH_MEM_REGION_REG1_U_RNFBESAM_NID204",
        .addr = A_NON_HASH_MEM_REGION_REG1_U_RNFBESAM_NID204,
        .rsvd = 0x2,
        .ro = 0x8000000280000002L,
    },{ .name = "NON_HASH_MEM_REGION_REG2_U_RNFBESAM_NID204",
        .addr = A_NON_HASH_MEM_REGION_REG2_U_RNFBESAM_NID204,
        .rsvd = 0x2,
        .ro = 0x8000000280000002L,
    },{ .name = "NON_HASH_MEM_REGION_REG3_U_RNFBESAM_NID204",
        .addr = A_NON_HASH_MEM_REGION_REG3_U_RNFBESAM_NID204,
        .rsvd = 0x2,
        .ro = 0x8000000280000002L,
    },{ .name = "NON_HASH_TGT_NODEID0_U_RNFBESAM_NID204",
        .addr = A_NON_HASH_TGT_NODEID0_U_RNFBESAM_NID204,
        .ro = 0xffff800800800800L,
    },{ .name = "NON_HASH_TGT_NODEID1_U_RNFBESAM_NID204",
        .addr = A_NON_HASH_TGT_NODEID1_U_RNFBESAM_NID204,
        .ro = 0xffff800800800800L,
    },{ .name = "NON_HASH_TGT_NODEID2_U_RNFBESAM_NID204",
        .addr = A_NON_HASH_TGT_NODEID2_U_RNFBESAM_NID204,
        .ro = 0xffffffffff800800L,
    },{ .name = "SYS_CACHE_GRP_REGION0_U_RNFBESAM_NID204",
        .addr = A_SYS_CACHE_GRP_REGION0_U_RNFBESAM_NID204,
        .rsvd = 0x2,
        .ro = 0x8000000080000002L,
    },{ .name = "SYS_CACHE_GRP_REGION1_U_RNFBESAM_NID204",
        .addr = A_SYS_CACHE_GRP_REGION1_U_RNFBESAM_NID204,
        .ro = 0x8000000080000000L,
    },{ .name = "SYS_CACHE_GRP_HN_NODEID_REG0_U_RNFBESAM_NID204",
        .addr = A_SYS_CACHE_GRP_HN_NODEID_REG0_U_RNFBESAM_NID204,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_HN_NODEID_REG1_U_RNFBESAM_NID204",
        .addr = A_SYS_CACHE_GRP_HN_NODEID_REG1_U_RNFBESAM_NID204,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_HN_NODEID_REG2_U_RNFBESAM_NID204",
        .addr = A_SYS_CACHE_GRP_HN_NODEID_REG2_U_RNFBESAM_NID204,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_HN_NODEID_REG3_U_RNFBESAM_NID204",
        .addr = A_SYS_CACHE_GRP_HN_NODEID_REG3_U_RNFBESAM_NID204,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_HN_NODEID_REG4_U_RNFBESAM_NID204",
        .addr = A_SYS_CACHE_GRP_HN_NODEID_REG4_U_RNFBESAM_NID204,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_HN_NODEID_REG5_U_RNFBESAM_NID204",
        .addr = A_SYS_CACHE_GRP_HN_NODEID_REG5_U_RNFBESAM_NID204,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_HN_NODEID_REG6_U_RNFBESAM_NID204",
        .addr = A_SYS_CACHE_GRP_HN_NODEID_REG6_U_RNFBESAM_NID204,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_HN_NODEID_REG7_U_RNFBESAM_NID204",
        .addr = A_SYS_CACHE_GRP_HN_NODEID_REG7_U_RNFBESAM_NID204,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_NONHASH_NODEID_U_RNFBESAM_NID204",
        .addr = A_SYS_CACHE_GRP_NONHASH_NODEID_U_RNFBESAM_NID204,
        .ro = 0xfffffff800800800L,
    },{ .name = "SYS_CACHE_GROUP_HN_COUNT_U_RNFBESAM_NID204",
        .addr = A_SYS_CACHE_GROUP_HN_COUNT_U_RNFBESAM_NID204,
        .rsvd = 0x80,
        .ro = 0xffffffff80808080L,
    },{ .name = "SYS_CACHE_GRP_SN_NODEID_REG0_U_RNFBESAM_NID204",
        .addr = A_SYS_CACHE_GRP_SN_NODEID_REG0_U_RNFBESAM_NID204,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_SN_NODEID_REG1_U_RNFBESAM_NID204",
        .addr = A_SYS_CACHE_GRP_SN_NODEID_REG1_U_RNFBESAM_NID204,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_SN_NODEID_REG2_U_RNFBESAM_NID204",
        .addr = A_SYS_CACHE_GRP_SN_NODEID_REG2_U_RNFBESAM_NID204,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_SN_NODEID_REG3_U_RNFBESAM_NID204",
        .addr = A_SYS_CACHE_GRP_SN_NODEID_REG3_U_RNFBESAM_NID204,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_SN_NODEID_REG4_U_RNFBESAM_NID204",
        .addr = A_SYS_CACHE_GRP_SN_NODEID_REG4_U_RNFBESAM_NID204,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_SN_NODEID_REG5_U_RNFBESAM_NID204",
        .addr = A_SYS_CACHE_GRP_SN_NODEID_REG5_U_RNFBESAM_NID204,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_SN_NODEID_REG6_U_RNFBESAM_NID204",
        .addr = A_SYS_CACHE_GRP_SN_NODEID_REG6_U_RNFBESAM_NID204,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_SN_NODEID_REG7_U_RNFBESAM_NID204",
        .addr = A_SYS_CACHE_GRP_SN_NODEID_REG7_U_RNFBESAM_NID204,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_SN_SAM_CFG0_U_RNFBESAM_NID204",
        .addr = A_SYS_CACHE_GRP_SN_SAM_CFG0_U_RNFBESAM_NID204,
        .rsvd = 0xc0,
        .ro = 0xffffc0c0c0c0c0c0L,
    },{ .name = "SYS_CACHE_GRP_SN_SAM_CFG1_U_RNFBESAM_NID204",
        .addr = A_SYS_CACHE_GRP_SN_SAM_CFG1_U_RNFBESAM_NID204,
        .rsvd = 0xc0,
        .ro = 0xffffc0c0c0c0c0c0L,
    },{ .name = "GIC_MEM_REGION_REG_U_RNFBESAM_NID204",
        .addr = A_GIC_MEM_REGION_REG_U_RNFBESAM_NID204,
        .rsvd = 0xff82,
        .ro = 0x800f00000000ff82L,
    },{ .name = "SYS_CACHE_GRP_SN_ATTR_U_RNFBESAM_NID204",
        .addr = A_SYS_CACHE_GRP_SN_ATTR_U_RNFBESAM_NID204,
        .rsvd = 0xffce,
        .ro = 0xffceffceffceffceL,
    },{ .name = "SYS_CACHE_GRP_HN_CPA_EN_REG_U_RNFBESAM_NID204",
        .addr = A_SYS_CACHE_GRP_HN_CPA_EN_REG_U_RNFBESAM_NID204,
    },{ .name = "SYS_CACHE_GRP_HN_CPA_GRP_REG_U_RNFBESAM_NID204",
        .addr = A_SYS_CACHE_GRP_HN_CPA_GRP_REG_U_RNFBESAM_NID204,
        .rsvd = 0xfffc,
        .ro = 0xfffcfffcfffcfffcL,
    },{ .name = "CML_PORT_AGGR_MODE_CTRL_REG_U_RNFBESAM_NID204",
        .addr = A_CML_PORT_AGGR_MODE_CTRL_REG_U_RNFBESAM_NID204,
        .rsvd = 0x88,
        .ro = 0xffffffff28888888L,
    },{ .name = "CML_PORT_AGGR_GRP0_ADD_MASK_U_RNFBESAM_NID204",
        .addr = A_CML_PORT_AGGR_GRP0_ADD_MASK_U_RNFBESAM_NID204,
        .reset = 0x40,
        .ro = 0xffff00000000003fL,
    },{ .name = "CML_PORT_AGGR_GRP1_ADD_MASK_U_RNFBESAM_NID204",
        .addr = A_CML_PORT_AGGR_GRP1_ADD_MASK_U_RNFBESAM_NID204,
        .reset = 0x40,
        .ro = 0xffff00000000003fL,
    },{ .name = "CML_PORT_AGGR_GRP0_REG_U_RNFBESAM_NID204",
        .addr = A_CML_PORT_AGGR_GRP0_REG_U_RNFBESAM_NID204,
        .ro = 0xfffc800800800800L,
    },{ .name = "CML_PORT_AGGR_GRP1_REG_U_RNFBESAM_NID204",
        .addr = A_CML_PORT_AGGR_GRP1_REG_U_RNFBESAM_NID204,
        .ro = 0xfffc800800800800L,
    },{ .name = "SYS_CACHE_GRP_SECONDARY_REG0_U_RNFBESAM_NID204",
        .addr = A_SYS_CACHE_GRP_SECONDARY_REG0_U_RNFBESAM_NID204,
        .rsvd = 0x2,
        .ro = 0x8000000280000002L,
    },{ .name = "SYS_CACHE_GRP_SECONDARY_REG1_U_RNFBESAM_NID204",
        .addr = A_SYS_CACHE_GRP_SECONDARY_REG1_U_RNFBESAM_NID204,
        .rsvd = 0x2,
        .ro = 0x8000000280000002L,
    },{ .name = "SYS_CACHE_GRP_CAL_MODE_REG_U_RNFBESAM_NID204",
        .addr = A_SYS_CACHE_GRP_CAL_MODE_REG_U_RNFBESAM_NID204,
        .rsvd = 0xfffe,
        .ro = 0xfffefffefffefffeL,
    },{ .name = "RNSAM_HASH_ADDR_MASK_REG_U_RNFBESAM_NID204",
        .addr = A_RNSAM_HASH_ADDR_MASK_REG_U_RNFBESAM_NID204,
        .reset = 0xffffffffffc0,
        .ro = 0xffff00000000003fL,
    },{ .name = "RNSAM_REGION_CMP_ADDR_MASK_REG_U_RNFBESAM_NID204",
        .addr = A_RNSAM_REGION_CMP_ADDR_MASK_REG_U_RNFBESAM_NID204,
        .reset = 0xffffffff0000,
        .ro = 0xffff00000000ffffL,
    },{ .name = "SYS_CACHE_GRP_HN_NODEID_REG8_U_RNFBESAM_NID204",
        .addr = A_SYS_CACHE_GRP_HN_NODEID_REG8_U_RNFBESAM_NID204,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_HN_NODEID_REG9_U_RNFBESAM_NID204",
        .addr = A_SYS_CACHE_GRP_HN_NODEID_REG9_U_RNFBESAM_NID204,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_HN_NODEID_REG10_U_RNFBESAM_NID204",
        .addr = A_SYS_CACHE_GRP_HN_NODEID_REG10_U_RNFBESAM_NID204,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_HN_NODEID_REG11_U_RNFBESAM_NID204",
        .addr = A_SYS_CACHE_GRP_HN_NODEID_REG11_U_RNFBESAM_NID204,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_HN_NODEID_REG12_U_RNFBESAM_NID204",
        .addr = A_SYS_CACHE_GRP_HN_NODEID_REG12_U_RNFBESAM_NID204,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_HN_NODEID_REG13_U_RNFBESAM_NID204",
        .addr = A_SYS_CACHE_GRP_HN_NODEID_REG13_U_RNFBESAM_NID204,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_HN_NODEID_REG14_U_RNFBESAM_NID204",
        .addr = A_SYS_CACHE_GRP_HN_NODEID_REG14_U_RNFBESAM_NID204,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_HN_NODEID_REG15_U_RNFBESAM_NID204",
        .addr = A_SYS_CACHE_GRP_HN_NODEID_REG15_U_RNFBESAM_NID204,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_SN_NODEID_REG8_U_RNFBESAM_NID204",
        .addr = A_SYS_CACHE_GRP_SN_NODEID_REG8_U_RNFBESAM_NID204,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_SN_NODEID_REG9_U_RNFBESAM_NID204",
        .addr = A_SYS_CACHE_GRP_SN_NODEID_REG9_U_RNFBESAM_NID204,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_SN_NODEID_REG10_U_RNFBESAM_NID204",
        .addr = A_SYS_CACHE_GRP_SN_NODEID_REG10_U_RNFBESAM_NID204,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_SN_NODEID_REG11_U_RNFBESAM_NID204",
        .addr = A_SYS_CACHE_GRP_SN_NODEID_REG11_U_RNFBESAM_NID204,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_SN_NODEID_REG12_U_RNFBESAM_NID204",
        .addr = A_SYS_CACHE_GRP_SN_NODEID_REG12_U_RNFBESAM_NID204,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_SN_NODEID_REG13_U_RNFBESAM_NID204",
        .addr = A_SYS_CACHE_GRP_SN_NODEID_REG13_U_RNFBESAM_NID204,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_SN_NODEID_REG14_U_RNFBESAM_NID204",
        .addr = A_SYS_CACHE_GRP_SN_NODEID_REG14_U_RNFBESAM_NID204,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_SN_NODEID_REG15_U_RNFBESAM_NID204",
        .addr = A_SYS_CACHE_GRP_SN_NODEID_REG15_U_RNFBESAM_NID204,
        .ro = 0xffff800800800800L,
    },{ .name = "POR_CFGM_NODE_INFO_U_HND_NID256",
        .addr = A_POR_CFGM_NODE_INFO_U_HND_NID256,
        .reset = 0x1000002,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_PERIPH_ID_0_PERIPH_ID_1_U_HND_NID256",
        .addr = A_POR_CFGM_PERIPH_ID_0_PERIPH_ID_1_U_HND_NID256,
        .reset = 0xb400000038,
        .rsvd = 0xffffff00,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_PERIPH_ID_2_PERIPH_ID_3_U_HND_NID256",
        .addr = A_POR_CFGM_PERIPH_ID_2_PERIPH_ID_3_U_HND_NID256,
        .reset = 0xb,
        .rsvd = 0xffffff00,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_PERIPH_ID_4_PERIPH_ID_5_U_HND_NID256",
        .addr = A_POR_CFGM_PERIPH_ID_4_PERIPH_ID_5_U_HND_NID256,
        .reset = 0xc4,
        .rsvd = 0xffffff00,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_PERIPH_ID_6_PERIPH_ID_7_U_HND_NID256",
        .addr = A_POR_CFGM_PERIPH_ID_6_PERIPH_ID_7_U_HND_NID256,
        .rsvd = 0xffffff00,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_COMPONENT_ID_0_COMPONENT_ID_1_U_HND_NID256",
        .addr = A_POR_CFGM_COMPONENT_ID_0_COMPONENT_ID_1_U_HND_NID256,
        .reset = 0xf00000000d,
        .rsvd = 0xffffff00,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_COMPONENT_ID_2_COMPONENT_ID_3_U_HND_NID256",
        .addr = A_POR_CFGM_COMPONENT_ID_2_COMPONENT_ID_3_U_HND_NID256,
        .reset = 0xb100000005,
        .rsvd = 0xffffff00,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_INFO_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_INFO_U_HND_NID256,
        .reset = 0x100000a,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_0_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_0_U_HND_NID256,
        .reset = 0x2108000,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_1_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_1_U_HND_NID256,
        .reset = 0x2008000,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_2_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_2_U_HND_NID256,
        .reset = 0x1908000,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_3_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_3_U_HND_NID256,
        .reset = 0x1808000,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_4_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_4_U_HND_NID256,
        .reset = 0x1108000,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_5_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_5_U_HND_NID256,
        .reset = 0x1008000,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_6_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_6_U_HND_NID256,
        .reset = 0x908000,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_7_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_7_U_HND_NID256,
        .reset = 0x808000,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_8_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_8_U_HND_NID256,
        .reset = 0x108000,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_9_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_9_U_HND_NID256,
        .reset = 0x8000,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_10_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_10_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_11_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_11_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_12_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_12_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_13_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_13_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_14_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_14_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_15_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_15_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_16_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_16_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_17_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_17_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_18_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_18_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_19_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_19_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_20_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_20_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_21_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_21_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_22_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_22_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_23_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_23_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_24_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_24_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_25_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_25_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_26_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_26_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_27_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_27_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_28_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_28_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_29_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_29_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_30_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_30_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_31_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_31_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_32_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_32_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_33_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_33_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_34_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_34_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_35_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_35_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_36_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_36_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_37_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_37_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_38_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_38_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_39_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_39_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_40_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_40_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_41_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_41_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_42_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_42_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_43_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_43_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_44_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_44_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_45_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_45_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_46_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_46_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_47_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_47_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_48_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_48_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_49_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_49_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_50_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_50_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_51_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_51_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_52_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_52_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_53_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_53_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_54_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_54_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_55_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_55_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_56_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_56_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_57_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_57_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_58_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_58_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_59_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_59_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_60_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_60_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_61_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_61_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_62_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_62_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_63_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_63_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_64_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_64_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_65_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_65_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_66_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_66_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_67_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_67_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_68_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_68_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_69_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_69_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_70_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_70_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_71_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_71_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_72_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_72_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_73_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_73_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_74_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_74_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_75_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_75_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_76_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_76_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_77_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_77_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_78_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_78_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_79_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_79_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_80_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_80_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_81_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_81_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_82_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_82_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_83_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_83_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_84_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_84_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_85_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_85_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_86_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_86_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_87_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_87_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_88_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_88_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_89_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_89_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_90_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_90_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_91_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_91_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_92_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_92_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_93_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_93_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_94_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_94_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_95_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_95_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_96_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_96_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_97_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_97_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_98_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_98_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_99_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_99_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_100_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_100_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_101_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_101_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_102_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_102_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_103_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_103_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_104_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_104_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_105_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_105_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_106_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_106_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_107_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_107_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_108_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_108_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_109_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_109_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_110_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_110_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_111_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_111_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_112_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_112_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_113_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_113_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_114_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_114_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_115_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_115_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_116_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_116_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_117_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_117_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_118_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_118_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_119_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_119_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_120_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_120_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_121_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_121_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_122_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_122_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_123_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_123_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_124_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_124_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_125_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_125_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_126_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_126_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_127_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_127_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_128_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_128_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_129_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_129_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_130_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_130_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_131_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_131_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_132_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_132_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_133_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_133_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_134_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_134_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_135_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_135_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_136_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_136_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_137_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_137_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_138_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_138_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_139_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_139_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_140_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_140_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_141_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_141_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_142_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_142_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_143_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_143_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_144_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_144_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_145_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_145_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_146_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_146_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_147_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_147_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_148_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_148_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_149_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_149_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_150_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_150_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_151_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_151_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_152_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_152_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_153_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_153_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_154_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_154_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_155_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_155_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_156_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_156_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_157_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_157_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_158_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_158_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_159_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_159_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_160_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_160_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_161_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_161_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_162_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_162_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_163_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_163_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_164_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_164_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_165_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_165_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_166_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_166_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_167_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_167_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_168_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_168_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_169_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_169_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_170_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_170_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_171_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_171_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_172_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_172_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_173_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_173_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_174_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_174_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_175_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_175_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_176_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_176_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_177_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_177_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_178_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_178_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_179_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_179_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_180_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_180_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_181_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_181_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_182_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_182_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_183_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_183_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_184_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_184_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_185_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_185_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_186_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_186_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_187_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_187_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_188_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_188_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_189_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_189_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_190_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_190_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_191_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_191_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_192_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_192_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_193_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_193_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_194_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_194_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_195_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_195_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_196_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_196_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_197_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_197_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_198_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_198_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_199_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_199_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_200_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_200_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_201_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_201_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_202_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_202_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_203_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_203_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_204_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_204_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_205_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_205_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_206_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_206_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_207_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_207_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_208_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_208_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_209_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_209_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_210_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_210_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_211_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_211_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_212_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_212_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_213_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_213_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_214_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_214_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_215_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_215_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_216_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_216_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_217_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_217_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_218_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_218_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_219_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_219_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_220_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_220_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_221_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_221_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_222_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_222_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_223_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_223_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_224_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_224_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_225_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_225_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_226_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_226_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_227_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_227_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_228_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_228_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_229_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_229_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_230_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_230_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_231_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_231_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_232_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_232_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_233_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_233_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_234_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_234_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_235_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_235_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_236_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_236_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_237_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_237_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_238_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_238_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_239_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_239_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_240_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_240_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_241_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_241_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_242_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_242_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_243_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_243_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_244_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_244_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_245_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_245_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_246_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_246_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_247_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_247_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_248_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_248_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_249_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_249_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_250_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_250_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_251_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_251_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_252_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_252_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_253_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_253_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_254_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_254_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_CHILD_POINTER_255_U_HND_NID256",
        .addr = A_POR_CFGM_CHILD_POINTER_255_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_INFO_GLOBAL_U_HND_NID256",
        .addr = A_POR_INFO_GLOBAL_U_HND_NID256,
        .reset = 0x8100005030300c,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_SECURE_ACCESS_U_HND_NID256",
        .addr = A_POR_CFGM_SECURE_ACCESS_U_HND_NID256,
        .rsvd = 0xfffffffffffffffcL,
        .ro = 0xfffffffffffffffcL,
    },{ .name = "POR_PPU_INT_ENABLE_U_HND_NID256",
        .addr = A_POR_PPU_INT_ENABLE_U_HND_NID256,
    },{ .name = "POR_PPU_INT_STATUS_U_HND_NID256",
        .addr = A_POR_PPU_INT_STATUS_U_HND_NID256,
    },{ .name = "POR_PPU_QACTIVE_HYST_U_HND_NID256",
        .addr = A_POR_PPU_QACTIVE_HYST_U_HND_NID256,
        .reset = 0x10,
        .ro = 0xffffffffffff0000L,
    },{ .name = "POR_CFGM_ERRGSR0_U_HND_NID256",
        .addr = A_POR_CFGM_ERRGSR0_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_ERRGSR1_U_HND_NID256",
        .addr = A_POR_CFGM_ERRGSR1_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_ERRGSR2_U_HND_NID256",
        .addr = A_POR_CFGM_ERRGSR2_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_ERRGSR3_U_HND_NID256",
        .addr = A_POR_CFGM_ERRGSR3_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_ERRGSR4_U_HND_NID256",
        .addr = A_POR_CFGM_ERRGSR4_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_ERRGSR5_U_HND_NID256",
        .addr = A_POR_CFGM_ERRGSR5_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_ERRGSR6_U_HND_NID256",
        .addr = A_POR_CFGM_ERRGSR6_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_ERRGSR7_U_HND_NID256",
        .addr = A_POR_CFGM_ERRGSR7_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_ERRGSR8_U_HND_NID256",
        .addr = A_POR_CFGM_ERRGSR8_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_ERRGSR9_U_HND_NID256",
        .addr = A_POR_CFGM_ERRGSR9_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_ERRGSR0_NS_U_HND_NID256",
        .addr = A_POR_CFGM_ERRGSR0_NS_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_ERRGSR1_NS_U_HND_NID256",
        .addr = A_POR_CFGM_ERRGSR1_NS_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_ERRGSR2_NS_U_HND_NID256",
        .addr = A_POR_CFGM_ERRGSR2_NS_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_ERRGSR3_NS_U_HND_NID256",
        .addr = A_POR_CFGM_ERRGSR3_NS_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_ERRGSR4_NS_U_HND_NID256",
        .addr = A_POR_CFGM_ERRGSR4_NS_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_ERRGSR5_NS_U_HND_NID256",
        .addr = A_POR_CFGM_ERRGSR5_NS_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_ERRGSR6_NS_U_HND_NID256",
        .addr = A_POR_CFGM_ERRGSR6_NS_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_ERRGSR7_NS_U_HND_NID256",
        .addr = A_POR_CFGM_ERRGSR7_NS_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_ERRGSR8_NS_U_HND_NID256",
        .addr = A_POR_CFGM_ERRGSR8_NS_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_ERRGSR9_NS_U_HND_NID256",
        .addr = A_POR_CFGM_ERRGSR9_NS_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_ERRDEVAFF_U_HND_NID256",
        .addr = A_POR_CFGM_ERRDEVAFF_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_ERRDEVARCH_U_HND_NID256",
        .addr = A_POR_CFGM_ERRDEVARCH_U_HND_NID256,
        .reset = 0x47700a0000000000,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_ERRIDR_U_HND_NID256",
        .addr = A_POR_CFGM_ERRIDR_U_HND_NID256,
        .reset = 0x2a,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_ERRPIDR45_U_HND_NID256",
        .addr = A_POR_CFGM_ERRPIDR45_U_HND_NID256,
        .reset = 0x4,
        .rsvd = 0xffffff00,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_ERRPIDR67_U_HND_NID256",
        .addr = A_POR_CFGM_ERRPIDR67_U_HND_NID256,
        .rsvd = 0xffffff00,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_ERRPIDR01_U_HND_NID256",
        .addr = A_POR_CFGM_ERRPIDR01_U_HND_NID256,
        .reset = 0xb400000034,
        .rsvd = 0xffffff00,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_ERRPIDR23_U_HND_NID256",
        .addr = A_POR_CFGM_ERRPIDR23_U_HND_NID256,
        .reset = 0x7,
        .rsvd = 0xffffff00,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_ERRCIDR01_U_HND_NID256",
        .addr = A_POR_CFGM_ERRCIDR01_U_HND_NID256,
        .reset = 0xff0000000d,
        .rsvd = 0xffffff00,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CFGM_ERRCIDR23_U_HND_NID256",
        .addr = A_POR_CFGM_ERRCIDR23_U_HND_NID256,
        .reset = 0xb100000005,
        .rsvd = 0xffffff00,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_NODE_INFO_U_SMXP_4_0",
        .addr = A_POR_MXP_NODE_INFO_U_SMXP_4_0,
        .reset = 0x1080006,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_DEVICE_PORT_CONNECT_INFO_P0_U_SMXP_4_0",
        .addr = A_POR_MXP_DEVICE_PORT_CONNECT_INFO_P0_U_SMXP_4_0,
        .reset = 0xd,
        .rsvd = 0xffe0,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_DEVICE_PORT_CONNECT_INFO_P1_U_SMXP_4_0",
        .addr = A_POR_MXP_DEVICE_PORT_CONNECT_INFO_P1_U_SMXP_4_0,
        .reset = 0x1,
        .rsvd = 0xffe0,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_MESH_PORT_CONNECT_INFO_EAST_U_SMXP_4_0",
        .addr = A_POR_MXP_MESH_PORT_CONNECT_INFO_EAST_U_SMXP_4_0,
        .rsvd = 0xfffffffffffffff0L,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_MESH_PORT_CONNECT_INFO_NORTH_U_SMXP_4_0",
        .addr = A_POR_MXP_MESH_PORT_CONNECT_INFO_NORTH_U_SMXP_4_0,
        .rsvd = 0xfffffffffffffff0L,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_INFO_U_SMXP_4_0",
        .addr = A_POR_MXP_CHILD_INFO_U_SMXP_4_0,
        .reset = 0x1000006,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_POINTER_0_U_SMXP_4_0",
        .addr = A_POR_MXP_CHILD_POINTER_0_U_SMXP_4_0,
        .reset = 0x8212c000,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_POINTER_1_U_SMXP_4_0",
        .addr = A_POR_MXP_CHILD_POINTER_1_U_SMXP_4_0,
        .reset = 0x8213c000,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_POINTER_2_U_SMXP_4_0",
        .addr = A_POR_MXP_CHILD_POINTER_2_U_SMXP_4_0,
        .reset = 0x2168000,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_POINTER_3_U_SMXP_4_0",
        .addr = A_POR_MXP_CHILD_POINTER_3_U_SMXP_4_0,
        .reset = 0x821d0000,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_POINTER_4_U_SMXP_4_0",
        .addr = A_POR_MXP_CHILD_POINTER_4_U_SMXP_4_0,
        .reset = 0x82120000,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_POINTER_5_U_SMXP_4_0",
        .addr = A_POR_MXP_CHILD_POINTER_5_U_SMXP_4_0,
        .reset = 0x2150000,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_POINTER_6_U_SMXP_4_0",
        .addr = A_POR_MXP_CHILD_POINTER_6_U_SMXP_4_0,
        .reset = 0x2110000,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_POINTER_7_U_SMXP_4_0",
        .addr = A_POR_MXP_CHILD_POINTER_7_U_SMXP_4_0,
        .reset = 0x2100000,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_POINTER_8_U_SMXP_4_0",
        .addr = A_POR_MXP_CHILD_POINTER_8_U_SMXP_4_0,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_POINTER_9_U_SMXP_4_0",
        .addr = A_POR_MXP_CHILD_POINTER_9_U_SMXP_4_0,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_POINTER_10_U_SMXP_4_0",
        .addr = A_POR_MXP_CHILD_POINTER_10_U_SMXP_4_0,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_POINTER_11_U_SMXP_4_0",
        .addr = A_POR_MXP_CHILD_POINTER_11_U_SMXP_4_0,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_POINTER_12_U_SMXP_4_0",
        .addr = A_POR_MXP_CHILD_POINTER_12_U_SMXP_4_0,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_POINTER_13_U_SMXP_4_0",
        .addr = A_POR_MXP_CHILD_POINTER_13_U_SMXP_4_0,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_POINTER_14_U_SMXP_4_0",
        .addr = A_POR_MXP_CHILD_POINTER_14_U_SMXP_4_0,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_POINTER_15_U_SMXP_4_0",
        .addr = A_POR_MXP_CHILD_POINTER_15_U_SMXP_4_0,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_P0_INFO_U_SMXP_4_0",
        .addr = A_POR_MXP_P0_INFO_U_SMXP_4_0,
        .reset = 0x211,
        .rsvd = 0x48,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_P1_INFO_U_SMXP_4_0",
        .addr = A_POR_MXP_P1_INFO_U_SMXP_4_0,
        .reset = 0x211,
        .rsvd = 0x48,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_SECURE_REGISTER_GROUPS_OVERRIDE_U_SMXP_4_0",
        .addr = A_POR_MXP_SECURE_REGISTER_GROUPS_OVERRIDE_U_SMXP_4_0,
        .rsvd = 0xfffffffffffffffcL,
        .ro = 0xfffffffffffffffcL,
    },{ .name = "POR_MXP_AUX_CTL_U_SMXP_4_0",
        .addr = A_POR_MXP_AUX_CTL_U_SMXP_4_0,
        .rsvd = 0xfffffffffffffffeL,
        .ro = 0xfffffffffffffffeL,
    },{ .name = "POR_MXP_P0_QOS_CONTROL_U_SMXP_4_0",
        .addr = A_POR_MXP_P0_QOS_CONTROL_U_SMXP_4_0,
        .rsvd = 0xffaa,
        .ro = 0xfffffffffff0ffaaL,
    },{ .name = "POR_MXP_P0_QOS_LAT_TGT_U_SMXP_4_0",
        .addr = A_POR_MXP_P0_QOS_LAT_TGT_U_SMXP_4_0,
        .ro = 0xfffffffffffff000L,
    },{ .name = "POR_MXP_P0_QOS_LAT_SCALE_U_SMXP_4_0",
        .addr = A_POR_MXP_P0_QOS_LAT_SCALE_U_SMXP_4_0,
        .rsvd = 0xfffffffffffffff8L,
        .ro = 0xfffffffffffffff8L,
    },{ .name = "POR_MXP_P0_QOS_LAT_RANGE_U_SMXP_4_0",
        .addr = A_POR_MXP_P0_QOS_LAT_RANGE_U_SMXP_4_0,
        .rsvd = 0xf0,
        .ro = 0xfffffffffffff0f0L,
    },{ .name = "POR_MXP_P1_QOS_CONTROL_U_SMXP_4_0",
        .addr = A_POR_MXP_P1_QOS_CONTROL_U_SMXP_4_0,
        .rsvd = 0xffaa,
        .ro = 0xfffffffffff0ffaaL,
    },{ .name = "POR_MXP_P1_QOS_LAT_TGT_U_SMXP_4_0",
        .addr = A_POR_MXP_P1_QOS_LAT_TGT_U_SMXP_4_0,
        .ro = 0xfffffffffffff000L,
    },{ .name = "POR_MXP_P1_QOS_LAT_SCALE_U_SMXP_4_0",
        .addr = A_POR_MXP_P1_QOS_LAT_SCALE_U_SMXP_4_0,
        .rsvd = 0xfffffffffffffff8L,
        .ro = 0xfffffffffffffff8L,
    },{ .name = "POR_MXP_P1_QOS_LAT_RANGE_U_SMXP_4_0",
        .addr = A_POR_MXP_P1_QOS_LAT_RANGE_U_SMXP_4_0,
        .rsvd = 0xf0,
        .ro = 0xfffffffffffff0f0L,
    },{ .name = "POR_MXP_P0_SYSCOREQ_CTL_U_SMXP_4_0",
        .addr = A_POR_MXP_P0_SYSCOREQ_CTL_U_SMXP_4_0,
        .rsvd = 0xfffffffffffffff0L,
        .ro = 0xfffffffffffffff0L,
    },{ .name = "POR_MXP_P1_SYSCOREQ_CTL_U_SMXP_4_0",
        .addr = A_POR_MXP_P1_SYSCOREQ_CTL_U_SMXP_4_0,
        .rsvd = 0xfffffffffffffff0L,
        .ro = 0xfffffffffffffff0L,
    },{ .name = "POR_MXP_P0_SYSCOACK_STATUS_U_SMXP_4_0",
        .addr = A_POR_MXP_P0_SYSCOACK_STATUS_U_SMXP_4_0,
        .rsvd = 0xfffffffffffffff0L,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_P1_SYSCOACK_STATUS_U_SMXP_4_0",
        .addr = A_POR_MXP_P1_SYSCOACK_STATUS_U_SMXP_4_0,
        .rsvd = 0xfffffffffffffff0L,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_PMU_EVENT_SEL_U_SMXP_4_0",
        .addr = A_POR_MXP_PMU_EVENT_SEL_U_SMXP_4_0,
        .ro = 0xffffffff00000000L,
    },{ .name = "POR_DTM_CONTROL_U_SMXP_4_0",
        .addr = A_POR_DTM_CONTROL_U_SMXP_4_0,
        .rsvd = 0xfffffffffffffff0L,
        .ro = 0xfffffffffffffff0L,
    },{ .name = "POR_DTM_FIFO_ENTRY_READY_U_SMXP_4_0",
        .addr = A_POR_DTM_FIFO_ENTRY_READY_U_SMXP_4_0,
        .rsvd = 0xfffffffffffffff0L,
        .ro = 0xfffffffffffffff0L,
    },{ .name = "POR_DTM_FIFO_ENTRY0_0_U_SMXP_4_0",
        .addr = A_POR_DTM_FIFO_ENTRY0_0_U_SMXP_4_0,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_DTM_FIFO_ENTRY0_1_U_SMXP_4_0",
        .addr = A_POR_DTM_FIFO_ENTRY0_1_U_SMXP_4_0,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_DTM_FIFO_ENTRY0_2_U_SMXP_4_0",
        .addr = A_POR_DTM_FIFO_ENTRY0_2_U_SMXP_4_0,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_DTM_FIFO_ENTRY1_0_U_SMXP_4_0",
        .addr = A_POR_DTM_FIFO_ENTRY1_0_U_SMXP_4_0,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_DTM_FIFO_ENTRY1_1_U_SMXP_4_0",
        .addr = A_POR_DTM_FIFO_ENTRY1_1_U_SMXP_4_0,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_DTM_FIFO_ENTRY1_2_U_SMXP_4_0",
        .addr = A_POR_DTM_FIFO_ENTRY1_2_U_SMXP_4_0,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_DTM_FIFO_ENTRY2_0_U_SMXP_4_0",
        .addr = A_POR_DTM_FIFO_ENTRY2_0_U_SMXP_4_0,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_DTM_FIFO_ENTRY2_1_U_SMXP_4_0",
        .addr = A_POR_DTM_FIFO_ENTRY2_1_U_SMXP_4_0,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_DTM_FIFO_ENTRY2_2_U_SMXP_4_0",
        .addr = A_POR_DTM_FIFO_ENTRY2_2_U_SMXP_4_0,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_DTM_FIFO_ENTRY3_0_U_SMXP_4_0",
        .addr = A_POR_DTM_FIFO_ENTRY3_0_U_SMXP_4_0,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_DTM_FIFO_ENTRY3_1_U_SMXP_4_0",
        .addr = A_POR_DTM_FIFO_ENTRY3_1_U_SMXP_4_0,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_DTM_FIFO_ENTRY3_2_U_SMXP_4_0",
        .addr = A_POR_DTM_FIFO_ENTRY3_2_U_SMXP_4_0,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_DTM_WP0_CONFIG_U_SMXP_4_0",
        .addr = A_POR_DTM_WP0_CONFIG_U_SMXP_4_0,
        .rsvd = 0x80,
        .ro = 0xffffffffffff8080L,
    },{ .name = "POR_DTM_WP0_VAL_U_SMXP_4_0",
        .addr = A_POR_DTM_WP0_VAL_U_SMXP_4_0,
    },{ .name = "POR_DTM_WP0_MASK_U_SMXP_4_0",
        .addr = A_POR_DTM_WP0_MASK_U_SMXP_4_0,
    },{ .name = "POR_DTM_WP1_CONFIG_U_SMXP_4_0",
        .addr = A_POR_DTM_WP1_CONFIG_U_SMXP_4_0,
        .rsvd = 0xc0,
        .ro = 0xffffffffffff80c0L,
    },{ .name = "POR_DTM_WP1_VAL_U_SMXP_4_0",
        .addr = A_POR_DTM_WP1_VAL_U_SMXP_4_0,
    },{ .name = "POR_DTM_WP1_MASK_U_SMXP_4_0",
        .addr = A_POR_DTM_WP1_MASK_U_SMXP_4_0,
    },{ .name = "POR_DTM_WP2_CONFIG_U_SMXP_4_0",
        .addr = A_POR_DTM_WP2_CONFIG_U_SMXP_4_0,
        .rsvd = 0x80,
        .ro = 0xffffffffffff8080L,
    },{ .name = "POR_DTM_WP2_VAL_U_SMXP_4_0",
        .addr = A_POR_DTM_WP2_VAL_U_SMXP_4_0,
    },{ .name = "POR_DTM_WP2_MASK_U_SMXP_4_0",
        .addr = A_POR_DTM_WP2_MASK_U_SMXP_4_0,
    },{ .name = "POR_DTM_WP3_CONFIG_U_SMXP_4_0",
        .addr = A_POR_DTM_WP3_CONFIG_U_SMXP_4_0,
        .rsvd = 0xc0,
        .ro = 0xffffffffffff80c0L,
    },{ .name = "POR_DTM_WP3_VAL_U_SMXP_4_0",
        .addr = A_POR_DTM_WP3_VAL_U_SMXP_4_0,
    },{ .name = "POR_DTM_WP3_MASK_U_SMXP_4_0",
        .addr = A_POR_DTM_WP3_MASK_U_SMXP_4_0,
    },{ .name = "POR_DTM_PMSICR_U_SMXP_4_0",
        .addr = A_POR_DTM_PMSICR_U_SMXP_4_0,
        .ro = 0xffffffff00000000L,
    },{ .name = "POR_DTM_PMSIRR_U_SMXP_4_0",
        .addr = A_POR_DTM_PMSIRR_U_SMXP_4_0,
        .ro = 0xffffffff000000ffL,
    },{ .name = "POR_DTM_PMU_CONFIG_U_SMXP_4_0",
        .addr = A_POR_DTM_PMU_CONFIG_U_SMXP_4_0,
        .ro = 0xc0c0c0c08888fe00L,
    },{ .name = "POR_DTM_PMEVCNT_U_SMXP_4_0",
        .addr = A_POR_DTM_PMEVCNT_U_SMXP_4_0,
    },{ .name = "POR_DTM_PMEVCNTSR_U_SMXP_4_0",
        .addr = A_POR_DTM_PMEVCNTSR_U_SMXP_4_0,
    },{ .name = "POR_MXP_ERRFR_U_SMXP_4_0",  .addr = A_POR_MXP_ERRFR_U_SMXP_4_0,
        .rsvd = 0x300,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_ERRCTLR_U_SMXP_4_0",
        .addr = A_POR_MXP_ERRCTLR_U_SMXP_4_0,
        .rsvd = 0xf0,
        .ro = 0xfffffffffffffef0L,
    },{ .name = "POR_MXP_ERRSTATUS_U_SMXP_4_0",
        .addr = A_POR_MXP_ERRSTATUS_U_SMXP_4_0,
        .ro = 0xffffffff127fffffL,
    },{ .name = "POR_MXP_ERRMISC_U_SMXP_4_0",
        .addr = A_POR_MXP_ERRMISC_U_SMXP_4_0,
        .rsvd = 0x8,
        .ro = 0xf800ffffffc08008L,
    },{ .name = "POR_MXP_P0_BYTE_PAR_ERR_INJ_U_SMXP_4_0",
        .addr = A_POR_MXP_P0_BYTE_PAR_ERR_INJ_U_SMXP_4_0,
        .rsvd = 0xffffffffffffffe0L,
        .ro = 0xffffffffffffffe0L,
    },{ .name = "POR_MXP_P1_BYTE_PAR_ERR_INJ_U_SMXP_4_0",
        .addr = A_POR_MXP_P1_BYTE_PAR_ERR_INJ_U_SMXP_4_0,
        .rsvd = 0xffffffffffffffe0L,
        .ro = 0xffffffffffffffe0L,
    },{ .name = "POR_MXP_ERRFR_NS_U_SMXP_4_0",
        .addr = A_POR_MXP_ERRFR_NS_U_SMXP_4_0,
        .rsvd = 0x300,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_ERRCTLR_NS_U_SMXP_4_0",
        .addr = A_POR_MXP_ERRCTLR_NS_U_SMXP_4_0,
        .rsvd = 0xf0,
        .ro = 0xfffffffffffffef0L,
    },{ .name = "POR_MXP_ERRSTATUS_NS_U_SMXP_4_0",
        .addr = A_POR_MXP_ERRSTATUS_NS_U_SMXP_4_0,
        .ro = 0xffffffff127fffffL,
    },{ .name = "POR_MXP_ERRMISC_NS_U_SMXP_4_0",
        .addr = A_POR_MXP_ERRMISC_NS_U_SMXP_4_0,
        .rsvd = 0x8,
        .ro = 0xf800ffffffc08008L,
    },{ .name = "POR_RNI_NODE_INFO_U_RNI_NID260",
        .addr = A_POR_RNI_NODE_INFO_U_RNI_NID260,
        .reset = 0x4000a,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_RNI_CHILD_INFO_U_RNI_NID260",
        .addr = A_POR_RNI_CHILD_INFO_U_RNI_NID260,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_RNI_UNIT_INFO_U_RNI_NID260",
        .addr = A_POR_RNI_UNIT_INFO_U_RNI_NID260,
        .reset = 0x8044020,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_RNI_SECURE_REGISTER_GROUPS_OVERRIDE_U_RNI_NID260",
        .addr = A_POR_RNI_SECURE_REGISTER_GROUPS_OVERRIDE_U_RNI_NID260,
        .rsvd = 0xfffffffffffffff8L,
        .ro = 0xfffffffffffffff8L,
    },{ .name = "POR_RNI_CFG_CTL_U_RNI_NID260",
        .addr = A_POR_RNI_CFG_CTL_U_RNI_NID260,
        .reset = 0x20401401,
        .rsvd = 0x80,
        .ro = 0xffffffff00008880L,
    },{ .name = "POR_RNI_AUX_CTL_U_RNI_NID260",
        .addr = A_POR_RNI_AUX_CTL_U_RNI_NID260,
        .reset = 0x22,
        .rsvd = 0xffffffffffffffc0L,
        .ro = 0xffffffffffffffc0L,
    },{ .name = "POR_RNI_S0_PORT_CONTROL_U_RNI_NID260",
        .addr = A_POR_RNI_S0_PORT_CONTROL_U_RNI_NID260,
        .ro = 0xfffffffffffff800L,
    },{ .name = "POR_RNI_S1_PORT_CONTROL_U_RNI_NID260",
        .addr = A_POR_RNI_S1_PORT_CONTROL_U_RNI_NID260,
        .ro = 0xfffffffffffff800L,
    },{ .name = "POR_RNI_S2_PORT_CONTROL_U_RNI_NID260",
        .addr = A_POR_RNI_S2_PORT_CONTROL_U_RNI_NID260,
        .ro = 0xfffffffffffff800L,
    },{ .name = "POR_RNI_S0_QOS_CONTROL_U_RNI_NID260",
        .addr = A_POR_RNI_S0_QOS_CONTROL_U_RNI_NID260,
        .rsvd = 0xff00,
        .ro = 0xffffffffff00ff00L,
    },{ .name = "POR_RNI_S0_QOS_LAT_TGT_U_RNI_NID260",
        .addr = A_POR_RNI_S0_QOS_LAT_TGT_U_RNI_NID260,
        .ro = 0xfffffffff000f000L,
    },{ .name = "POR_RNI_S0_QOS_LAT_SCALE_U_RNI_NID260",
        .addr = A_POR_RNI_S0_QOS_LAT_SCALE_U_RNI_NID260,
        .rsvd = 0xf8,
        .ro = 0xfffffffffffff8f8L,
    },{ .name = "POR_RNI_S0_QOS_LAT_RANGE_U_RNI_NID260",
        .addr = A_POR_RNI_S0_QOS_LAT_RANGE_U_RNI_NID260,
        .rsvd = 0xf0,
        .ro = 0xfffffffff0f0f0f0L,
    },{ .name = "POR_RNI_S1_QOS_CONTROL_U_RNI_NID260",
        .addr = A_POR_RNI_S1_QOS_CONTROL_U_RNI_NID260,
        .rsvd = 0xff00,
        .ro = 0xffffffffff00ff00L,
    },{ .name = "POR_RNI_S1_QOS_LAT_TGT_U_RNI_NID260",
        .addr = A_POR_RNI_S1_QOS_LAT_TGT_U_RNI_NID260,
        .ro = 0xfffffffff000f000L,
    },{ .name = "POR_RNI_S1_QOS_LAT_SCALE_U_RNI_NID260",
        .addr = A_POR_RNI_S1_QOS_LAT_SCALE_U_RNI_NID260,
        .rsvd = 0xf8,
        .ro = 0xfffffffffffff8f8L,
    },{ .name = "POR_RNI_S1_QOS_LAT_RANGE_U_RNI_NID260",
        .addr = A_POR_RNI_S1_QOS_LAT_RANGE_U_RNI_NID260,
        .rsvd = 0xf0,
        .ro = 0xfffffffff0f0f0f0L,
    },{ .name = "POR_RNI_S2_QOS_CONTROL_U_RNI_NID260",
        .addr = A_POR_RNI_S2_QOS_CONTROL_U_RNI_NID260,
        .rsvd = 0xff00,
        .ro = 0xffffffffff00ff00L,
    },{ .name = "POR_RNI_S2_QOS_LAT_TGT_U_RNI_NID260",
        .addr = A_POR_RNI_S2_QOS_LAT_TGT_U_RNI_NID260,
        .ro = 0xfffffffff000f000L,
    },{ .name = "POR_RNI_S2_QOS_LAT_SCALE_U_RNI_NID260",
        .addr = A_POR_RNI_S2_QOS_LAT_SCALE_U_RNI_NID260,
        .rsvd = 0xf8,
        .ro = 0xfffffffffffff8f8L,
    },{ .name = "POR_RNI_S2_QOS_LAT_RANGE_U_RNI_NID260",
        .addr = A_POR_RNI_S2_QOS_LAT_RANGE_U_RNI_NID260,
        .rsvd = 0xf0,
        .ro = 0xfffffffff0f0f0f0L,
    },{ .name = "POR_RNI_PMU_EVENT_SEL_U_RNI_NID260",
        .addr = A_POR_RNI_PMU_EVENT_SEL_U_RNI_NID260,
        .rsvd = 0xe0,
        .ro = 0xffffffffe0e0e0e0L,
    },{ .name = "POR_DN_NODE_INFO_U_HND_NID256",
        .addr = A_POR_DN_NODE_INFO_U_HND_NID256,
        .reset = 0x1000001,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_DN_CHILD_INFO_U_HND_NID256",
        .addr = A_POR_DN_CHILD_INFO_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_DN_BUILD_INFO_U_HND_NID256",
        .addr = A_POR_DN_BUILD_INFO_U_HND_NID256,
        .rsvd = 0xfffffffffffffffeL,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_DN_SECURE_REGISTER_GROUPS_OVERRIDE_U_HND_NID256",
        .addr = A_POR_DN_SECURE_REGISTER_GROUPS_OVERRIDE_U_HND_NID256,
        .rsvd = 0xfffffffffffffffeL,
        .ro = 0xfffffffffffffffeL,
    },{ .name = "POR_DN_AUX_CTL_U_HND_NID256",
        .addr = A_POR_DN_AUX_CTL_U_HND_NID256,
        .reset = 0x5,
        .rsvd = 0xfffffffffffffff8L,
        .ro = 0xfffffffffffffff8L,
    },{ .name = "POR_DN_VMF0_CTRL_U_HND_NID256",
        .addr = A_POR_DN_VMF0_CTRL_U_HND_NID256,
        .reset = 0xffff00000000,
        .ro = 0xffff0000fffe0000L,
    },{ .name = "POR_DN_VMF0_RNF0_U_HND_NID256",
        .addr = A_POR_DN_VMF0_RNF0_U_HND_NID256,
    },{ .name = "POR_DN_VMF0_RND_U_HND_NID256",
        .addr = A_POR_DN_VMF0_RND_U_HND_NID256,
    },{ .name = "POR_DN_VMF0_CXRA_U_HND_NID256",
        .addr = A_POR_DN_VMF0_CXRA_U_HND_NID256,
    },{ .name = "POR_DN_VMF1_CTRL_U_HND_NID256",
        .addr = A_POR_DN_VMF1_CTRL_U_HND_NID256,
        .reset = 0xffff00000000,
        .ro = 0xffff0000fffe0000L,
    },{ .name = "POR_DN_VMF1_RNF0_U_HND_NID256",
        .addr = A_POR_DN_VMF1_RNF0_U_HND_NID256,
    },{ .name = "POR_DN_VMF1_RND_U_HND_NID256",
        .addr = A_POR_DN_VMF1_RND_U_HND_NID256,
    },{ .name = "POR_DN_VMF1_CXRA_U_HND_NID256",
        .addr = A_POR_DN_VMF1_CXRA_U_HND_NID256,
    },{ .name = "POR_DN_VMF2_CTRL_U_HND_NID256",
        .addr = A_POR_DN_VMF2_CTRL_U_HND_NID256,
        .reset = 0xffff00000000,
        .ro = 0xffff0000fffe0000L,
    },{ .name = "POR_DN_VMF2_RNF0_U_HND_NID256",
        .addr = A_POR_DN_VMF2_RNF0_U_HND_NID256,
    },{ .name = "POR_DN_VMF2_RND_U_HND_NID256",
        .addr = A_POR_DN_VMF2_RND_U_HND_NID256,
    },{ .name = "POR_DN_VMF2_CXRA_U_HND_NID256",
        .addr = A_POR_DN_VMF2_CXRA_U_HND_NID256,
    },{ .name = "POR_DN_VMF3_CTRL_U_HND_NID256",
        .addr = A_POR_DN_VMF3_CTRL_U_HND_NID256,
        .reset = 0xffff00000000,
        .ro = 0xffff0000fffe0000L,
    },{ .name = "POR_DN_VMF3_RNF0_U_HND_NID256",
        .addr = A_POR_DN_VMF3_RNF0_U_HND_NID256,
    },{ .name = "POR_DN_VMF3_RND_U_HND_NID256",
        .addr = A_POR_DN_VMF3_RND_U_HND_NID256,
    },{ .name = "POR_DN_VMF3_CXRA_U_HND_NID256",
        .addr = A_POR_DN_VMF3_CXRA_U_HND_NID256,
    },{ .name = "POR_DN_VMF4_CTRL_U_HND_NID256",
        .addr = A_POR_DN_VMF4_CTRL_U_HND_NID256,
        .reset = 0xffff00000000,
        .ro = 0xffff0000fffe0000L,
    },{ .name = "POR_DN_VMF4_RNF0_U_HND_NID256",
        .addr = A_POR_DN_VMF4_RNF0_U_HND_NID256,
    },{ .name = "POR_DN_VMF4_RND_U_HND_NID256",
        .addr = A_POR_DN_VMF4_RND_U_HND_NID256,
    },{ .name = "POR_DN_VMF4_CXRA_U_HND_NID256",
        .addr = A_POR_DN_VMF4_CXRA_U_HND_NID256,
    },{ .name = "POR_DN_VMF5_CTRL_U_HND_NID256",
        .addr = A_POR_DN_VMF5_CTRL_U_HND_NID256,
        .reset = 0xffff00000000,
        .ro = 0xffff0000fffe0000L,
    },{ .name = "POR_DN_VMF5_RNF0_U_HND_NID256",
        .addr = A_POR_DN_VMF5_RNF0_U_HND_NID256,
    },{ .name = "POR_DN_VMF5_RND_U_HND_NID256",
        .addr = A_POR_DN_VMF5_RND_U_HND_NID256,
    },{ .name = "POR_DN_VMF5_CXRA_U_HND_NID256",
        .addr = A_POR_DN_VMF5_CXRA_U_HND_NID256,
    },{ .name = "POR_DN_VMF6_CTRL_U_HND_NID256",
        .addr = A_POR_DN_VMF6_CTRL_U_HND_NID256,
        .reset = 0xffff00000000,
        .ro = 0xffff0000fffe0000L,
    },{ .name = "POR_DN_VMF6_RNF0_U_HND_NID256",
        .addr = A_POR_DN_VMF6_RNF0_U_HND_NID256,
    },{ .name = "POR_DN_VMF6_RND_U_HND_NID256",
        .addr = A_POR_DN_VMF6_RND_U_HND_NID256,
    },{ .name = "POR_DN_VMF6_CXRA_U_HND_NID256",
        .addr = A_POR_DN_VMF6_CXRA_U_HND_NID256,
    },{ .name = "POR_DN_VMF7_CTRL_U_HND_NID256",
        .addr = A_POR_DN_VMF7_CTRL_U_HND_NID256,
        .reset = 0xffff00000000,
        .ro = 0xffff0000fffe0000L,
    },{ .name = "POR_DN_VMF7_RNF0_U_HND_NID256",
        .addr = A_POR_DN_VMF7_RNF0_U_HND_NID256,
    },{ .name = "POR_DN_VMF7_RND_U_HND_NID256",
        .addr = A_POR_DN_VMF7_RND_U_HND_NID256,
    },{ .name = "POR_DN_VMF7_CXRA_U_HND_NID256",
        .addr = A_POR_DN_VMF7_CXRA_U_HND_NID256,
    },{ .name = "POR_DN_VMF8_CTRL_U_HND_NID256",
        .addr = A_POR_DN_VMF8_CTRL_U_HND_NID256,
        .reset = 0xffff00000000,
        .ro = 0xffff0000fffe0000L,
    },{ .name = "POR_DN_VMF8_RNF0_U_HND_NID256",
        .addr = A_POR_DN_VMF8_RNF0_U_HND_NID256,
    },{ .name = "POR_DN_VMF8_RND_U_HND_NID256",
        .addr = A_POR_DN_VMF8_RND_U_HND_NID256,
    },{ .name = "POR_DN_VMF8_CXRA_U_HND_NID256",
        .addr = A_POR_DN_VMF8_CXRA_U_HND_NID256,
    },{ .name = "POR_DN_VMF9_CTRL_U_HND_NID256",
        .addr = A_POR_DN_VMF9_CTRL_U_HND_NID256,
        .reset = 0xffff00000000,
        .ro = 0xffff0000fffe0000L,
    },{ .name = "POR_DN_VMF9_RNF0_U_HND_NID256",
        .addr = A_POR_DN_VMF9_RNF0_U_HND_NID256,
    },{ .name = "POR_DN_VMF9_RND_U_HND_NID256",
        .addr = A_POR_DN_VMF9_RND_U_HND_NID256,
    },{ .name = "POR_DN_VMF9_CXRA_U_HND_NID256",
        .addr = A_POR_DN_VMF9_CXRA_U_HND_NID256,
    },{ .name = "POR_DN_VMF10_CTRL_U_HND_NID256",
        .addr = A_POR_DN_VMF10_CTRL_U_HND_NID256,
        .reset = 0xffff00000000,
        .ro = 0xffff0000fffe0000L,
    },{ .name = "POR_DN_VMF10_RNF0_U_HND_NID256",
        .addr = A_POR_DN_VMF10_RNF0_U_HND_NID256,
    },{ .name = "POR_DN_VMF10_RND_U_HND_NID256",
        .addr = A_POR_DN_VMF10_RND_U_HND_NID256,
    },{ .name = "POR_DN_VMF10_CXRA_U_HND_NID256",
        .addr = A_POR_DN_VMF10_CXRA_U_HND_NID256,
    },{ .name = "POR_DN_VMF11_CTRL_U_HND_NID256",
        .addr = A_POR_DN_VMF11_CTRL_U_HND_NID256,
        .reset = 0xffff00000000,
        .ro = 0xffff0000fffe0000L,
    },{ .name = "POR_DN_VMF11_RNF0_U_HND_NID256",
        .addr = A_POR_DN_VMF11_RNF0_U_HND_NID256,
    },{ .name = "POR_DN_VMF11_RND_U_HND_NID256",
        .addr = A_POR_DN_VMF11_RND_U_HND_NID256,
    },{ .name = "POR_DN_VMF11_CXRA_U_HND_NID256",
        .addr = A_POR_DN_VMF11_CXRA_U_HND_NID256,
    },{ .name = "POR_DN_VMF12_CTRL_U_HND_NID256",
        .addr = A_POR_DN_VMF12_CTRL_U_HND_NID256,
        .reset = 0xffff00000000,
        .ro = 0xffff0000fffe0000L,
    },{ .name = "POR_DN_VMF12_RNF0_U_HND_NID256",
        .addr = A_POR_DN_VMF12_RNF0_U_HND_NID256,
    },{ .name = "POR_DN_VMF12_RND_U_HND_NID256",
        .addr = A_POR_DN_VMF12_RND_U_HND_NID256,
    },{ .name = "POR_DN_VMF12_CXRA_U_HND_NID256",
        .addr = A_POR_DN_VMF12_CXRA_U_HND_NID256,
    },{ .name = "POR_DN_VMF13_CTRL_U_HND_NID256",
        .addr = A_POR_DN_VMF13_CTRL_U_HND_NID256,
        .reset = 0xffff00000000,
        .ro = 0xffff0000fffe0000L,
    },{ .name = "POR_DN_VMF13_RNF0_U_HND_NID256",
        .addr = A_POR_DN_VMF13_RNF0_U_HND_NID256,
    },{ .name = "POR_DN_VMF13_RND_U_HND_NID256",
        .addr = A_POR_DN_VMF13_RND_U_HND_NID256,
    },{ .name = "POR_DN_VMF13_CXRA_U_HND_NID256",
        .addr = A_POR_DN_VMF13_CXRA_U_HND_NID256,
    },{ .name = "POR_DN_VMF14_CTRL_U_HND_NID256",
        .addr = A_POR_DN_VMF14_CTRL_U_HND_NID256,
        .reset = 0xffff00000000,
        .ro = 0xffff0000fffe0000L,
    },{ .name = "POR_DN_VMF14_RNF0_U_HND_NID256",
        .addr = A_POR_DN_VMF14_RNF0_U_HND_NID256,
    },{ .name = "POR_DN_VMF14_RND_U_HND_NID256",
        .addr = A_POR_DN_VMF14_RND_U_HND_NID256,
    },{ .name = "POR_DN_VMF14_CXRA_U_HND_NID256",
        .addr = A_POR_DN_VMF14_CXRA_U_HND_NID256,
    },{ .name = "POR_DN_VMF15_CTRL_U_HND_NID256",
        .addr = A_POR_DN_VMF15_CTRL_U_HND_NID256,
        .reset = 0xffff00000000,
        .ro = 0xffff0000fffe0000L,
    },{ .name = "POR_DN_VMF15_RNF0_U_HND_NID256",
        .addr = A_POR_DN_VMF15_RNF0_U_HND_NID256,
    },{ .name = "POR_DN_VMF15_RND_U_HND_NID256",
        .addr = A_POR_DN_VMF15_RND_U_HND_NID256,
    },{ .name = "POR_DN_VMF15_CXRA_U_HND_NID256",
        .addr = A_POR_DN_VMF15_CXRA_U_HND_NID256,
    },{ .name = "POR_DN_PMU_EVENT_SEL_U_HND_NID256",
        .addr = A_POR_DN_PMU_EVENT_SEL_U_HND_NID256,
        .rsvd = 0xc0,
        .ro = 0xfffffff0c0c0c0c0L,
    },{ .name = "POR_RNSAM_NODE_INFO_U_RNI_NID260",
        .addr = A_POR_RNSAM_NODE_INFO_U_RNI_NID260,
        .reset = 0x4000f,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_RNSAM_CHILD_INFO_U_RNI_NID260",
        .addr = A_POR_RNSAM_CHILD_INFO_U_RNI_NID260,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_RNSAM_UNIT_INFO_U_RNI_NID260",
        .addr = A_POR_RNSAM_UNIT_INFO_U_RNI_NID260,
        .reset = 0x800040004,
        .rsvd = 0xff00,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_RNSAM_SECURE_REGISTER_GROUPS_OVERRIDE_U_RNI_NID260",
        .addr = A_POR_RNSAM_SECURE_REGISTER_GROUPS_OVERRIDE_U_RNI_NID260,
        .rsvd = 0xfffffffffffffffeL,
        .ro = 0xfffffffffffffffeL,
    },{ .name = "RNSAM_STATUS_U_RNI_NID260",
        .addr = A_RNSAM_STATUS_U_RNI_NID260,
        .reset = 0x1,
        .rsvd = 0xfffffffffffffffcL,
        .ro = 0xfffffffffffffffcL,
    },{ .name = "NON_HASH_MEM_REGION_REG0_U_RNI_NID260",
        .addr = A_NON_HASH_MEM_REGION_REG0_U_RNI_NID260,
        .rsvd = 0x2,
        .ro = 0x8000000280000002L,
    },{ .name = "NON_HASH_MEM_REGION_REG1_U_RNI_NID260",
        .addr = A_NON_HASH_MEM_REGION_REG1_U_RNI_NID260,
        .rsvd = 0x2,
        .ro = 0x8000000280000002L,
    },{ .name = "NON_HASH_MEM_REGION_REG2_U_RNI_NID260",
        .addr = A_NON_HASH_MEM_REGION_REG2_U_RNI_NID260,
        .rsvd = 0x2,
        .ro = 0x8000000280000002L,
    },{ .name = "NON_HASH_MEM_REGION_REG3_U_RNI_NID260",
        .addr = A_NON_HASH_MEM_REGION_REG3_U_RNI_NID260,
        .rsvd = 0x2,
        .ro = 0x8000000280000002L,
    },{ .name = "NON_HASH_TGT_NODEID0_U_RNI_NID260",
        .addr = A_NON_HASH_TGT_NODEID0_U_RNI_NID260,
        .ro = 0xffff800800800800L,
    },{ .name = "NON_HASH_TGT_NODEID1_U_RNI_NID260",
        .addr = A_NON_HASH_TGT_NODEID1_U_RNI_NID260,
        .ro = 0xffff800800800800L,
    },{ .name = "NON_HASH_TGT_NODEID2_U_RNI_NID260",
        .addr = A_NON_HASH_TGT_NODEID2_U_RNI_NID260,
        .ro = 0xffffffffff800800L,
    },{ .name = "SYS_CACHE_GRP_REGION0_U_RNI_NID260",
        .addr = A_SYS_CACHE_GRP_REGION0_U_RNI_NID260,
        .rsvd = 0x2,
        .ro = 0x8000000080000002L,
    },{ .name = "SYS_CACHE_GRP_REGION1_U_RNI_NID260",
        .addr = A_SYS_CACHE_GRP_REGION1_U_RNI_NID260,
        .ro = 0x8000000080000000L,
    },{ .name = "SYS_CACHE_GRP_HN_NODEID_REG0_U_RNI_NID260",
        .addr = A_SYS_CACHE_GRP_HN_NODEID_REG0_U_RNI_NID260,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_HN_NODEID_REG1_U_RNI_NID260",
        .addr = A_SYS_CACHE_GRP_HN_NODEID_REG1_U_RNI_NID260,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_HN_NODEID_REG2_U_RNI_NID260",
        .addr = A_SYS_CACHE_GRP_HN_NODEID_REG2_U_RNI_NID260,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_HN_NODEID_REG3_U_RNI_NID260",
        .addr = A_SYS_CACHE_GRP_HN_NODEID_REG3_U_RNI_NID260,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_HN_NODEID_REG4_U_RNI_NID260",
        .addr = A_SYS_CACHE_GRP_HN_NODEID_REG4_U_RNI_NID260,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_HN_NODEID_REG5_U_RNI_NID260",
        .addr = A_SYS_CACHE_GRP_HN_NODEID_REG5_U_RNI_NID260,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_HN_NODEID_REG6_U_RNI_NID260",
        .addr = A_SYS_CACHE_GRP_HN_NODEID_REG6_U_RNI_NID260,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_HN_NODEID_REG7_U_RNI_NID260",
        .addr = A_SYS_CACHE_GRP_HN_NODEID_REG7_U_RNI_NID260,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_NONHASH_NODEID_U_RNI_NID260",
        .addr = A_SYS_CACHE_GRP_NONHASH_NODEID_U_RNI_NID260,
        .ro = 0xfffffff800800800L,
    },{ .name = "SYS_CACHE_GROUP_HN_COUNT_U_RNI_NID260",
        .addr = A_SYS_CACHE_GROUP_HN_COUNT_U_RNI_NID260,
        .rsvd = 0x80,
        .ro = 0xffffffff80808080L,
    },{ .name = "SYS_CACHE_GRP_SN_NODEID_REG0_U_RNI_NID260",
        .addr = A_SYS_CACHE_GRP_SN_NODEID_REG0_U_RNI_NID260,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_SN_NODEID_REG1_U_RNI_NID260",
        .addr = A_SYS_CACHE_GRP_SN_NODEID_REG1_U_RNI_NID260,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_SN_NODEID_REG2_U_RNI_NID260",
        .addr = A_SYS_CACHE_GRP_SN_NODEID_REG2_U_RNI_NID260,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_SN_NODEID_REG3_U_RNI_NID260",
        .addr = A_SYS_CACHE_GRP_SN_NODEID_REG3_U_RNI_NID260,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_SN_NODEID_REG4_U_RNI_NID260",
        .addr = A_SYS_CACHE_GRP_SN_NODEID_REG4_U_RNI_NID260,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_SN_NODEID_REG5_U_RNI_NID260",
        .addr = A_SYS_CACHE_GRP_SN_NODEID_REG5_U_RNI_NID260,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_SN_NODEID_REG6_U_RNI_NID260",
        .addr = A_SYS_CACHE_GRP_SN_NODEID_REG6_U_RNI_NID260,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_SN_NODEID_REG7_U_RNI_NID260",
        .addr = A_SYS_CACHE_GRP_SN_NODEID_REG7_U_RNI_NID260,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_SN_SAM_CFG0_U_RNI_NID260",
        .addr = A_SYS_CACHE_GRP_SN_SAM_CFG0_U_RNI_NID260,
        .rsvd = 0xc0,
        .ro = 0xffffc0c0c0c0c0c0L,
    },{ .name = "SYS_CACHE_GRP_SN_SAM_CFG1_U_RNI_NID260",
        .addr = A_SYS_CACHE_GRP_SN_SAM_CFG1_U_RNI_NID260,
        .rsvd = 0xc0,
        .ro = 0xffffc0c0c0c0c0c0L,
    },{ .name = "GIC_MEM_REGION_REG_U_RNI_NID260",
        .addr = A_GIC_MEM_REGION_REG_U_RNI_NID260,
        .rsvd = 0xff82,
        .ro = 0x800f00000000ff82L,
    },{ .name = "SYS_CACHE_GRP_SN_ATTR_U_RNI_NID260",
        .addr = A_SYS_CACHE_GRP_SN_ATTR_U_RNI_NID260,
        .rsvd = 0xffce,
        .ro = 0xffceffceffceffceL,
    },{ .name = "SYS_CACHE_GRP_HN_CPA_EN_REG_U_RNI_NID260",
        .addr = A_SYS_CACHE_GRP_HN_CPA_EN_REG_U_RNI_NID260,
    },{ .name = "SYS_CACHE_GRP_HN_CPA_GRP_REG_U_RNI_NID260",
        .addr = A_SYS_CACHE_GRP_HN_CPA_GRP_REG_U_RNI_NID260,
        .rsvd = 0xfffc,
        .ro = 0xfffcfffcfffcfffcL,
    },{ .name = "CML_PORT_AGGR_MODE_CTRL_REG_U_RNI_NID260",
        .addr = A_CML_PORT_AGGR_MODE_CTRL_REG_U_RNI_NID260,
        .rsvd = 0x88,
        .ro = 0xffffffff28888888L,
    },{ .name = "CML_PORT_AGGR_GRP0_ADD_MASK_U_RNI_NID260",
        .addr = A_CML_PORT_AGGR_GRP0_ADD_MASK_U_RNI_NID260,
        .reset = 0x40,
        .ro = 0xffff00000000003fL,
    },{ .name = "CML_PORT_AGGR_GRP1_ADD_MASK_U_RNI_NID260",
        .addr = A_CML_PORT_AGGR_GRP1_ADD_MASK_U_RNI_NID260,
        .reset = 0x40,
        .ro = 0xffff00000000003fL,
    },{ .name = "CML_PORT_AGGR_GRP0_REG_U_RNI_NID260",
        .addr = A_CML_PORT_AGGR_GRP0_REG_U_RNI_NID260,
        .ro = 0xfffc800800800800L,
    },{ .name = "CML_PORT_AGGR_GRP1_REG_U_RNI_NID260",
        .addr = A_CML_PORT_AGGR_GRP1_REG_U_RNI_NID260,
        .ro = 0xfffc800800800800L,
    },{ .name = "SYS_CACHE_GRP_SECONDARY_REG0_U_RNI_NID260",
        .addr = A_SYS_CACHE_GRP_SECONDARY_REG0_U_RNI_NID260,
        .rsvd = 0x2,
        .ro = 0x8000000280000002L,
    },{ .name = "SYS_CACHE_GRP_SECONDARY_REG1_U_RNI_NID260",
        .addr = A_SYS_CACHE_GRP_SECONDARY_REG1_U_RNI_NID260,
        .rsvd = 0x2,
        .ro = 0x8000000280000002L,
    },{ .name = "SYS_CACHE_GRP_CAL_MODE_REG_U_RNI_NID260",
        .addr = A_SYS_CACHE_GRP_CAL_MODE_REG_U_RNI_NID260,
        .rsvd = 0xfffe,
        .ro = 0xfffefffefffefffeL,
    },{ .name = "RNSAM_HASH_ADDR_MASK_REG_U_RNI_NID260",
        .addr = A_RNSAM_HASH_ADDR_MASK_REG_U_RNI_NID260,
        .reset = 0xffffffffffc0,
        .ro = 0xffff00000000003fL,
    },{ .name = "RNSAM_REGION_CMP_ADDR_MASK_REG_U_RNI_NID260",
        .addr = A_RNSAM_REGION_CMP_ADDR_MASK_REG_U_RNI_NID260,
        .reset = 0xffffffff0000,
        .ro = 0xffff00000000ffffL,
    },{ .name = "SYS_CACHE_GRP_HN_NODEID_REG8_U_RNI_NID260",
        .addr = A_SYS_CACHE_GRP_HN_NODEID_REG8_U_RNI_NID260,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_HN_NODEID_REG9_U_RNI_NID260",
        .addr = A_SYS_CACHE_GRP_HN_NODEID_REG9_U_RNI_NID260,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_HN_NODEID_REG10_U_RNI_NID260",
        .addr = A_SYS_CACHE_GRP_HN_NODEID_REG10_U_RNI_NID260,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_HN_NODEID_REG11_U_RNI_NID260",
        .addr = A_SYS_CACHE_GRP_HN_NODEID_REG11_U_RNI_NID260,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_HN_NODEID_REG12_U_RNI_NID260",
        .addr = A_SYS_CACHE_GRP_HN_NODEID_REG12_U_RNI_NID260,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_HN_NODEID_REG13_U_RNI_NID260",
        .addr = A_SYS_CACHE_GRP_HN_NODEID_REG13_U_RNI_NID260,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_HN_NODEID_REG14_U_RNI_NID260",
        .addr = A_SYS_CACHE_GRP_HN_NODEID_REG14_U_RNI_NID260,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_HN_NODEID_REG15_U_RNI_NID260",
        .addr = A_SYS_CACHE_GRP_HN_NODEID_REG15_U_RNI_NID260,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_SN_NODEID_REG8_U_RNI_NID260",
        .addr = A_SYS_CACHE_GRP_SN_NODEID_REG8_U_RNI_NID260,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_SN_NODEID_REG9_U_RNI_NID260",
        .addr = A_SYS_CACHE_GRP_SN_NODEID_REG9_U_RNI_NID260,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_SN_NODEID_REG10_U_RNI_NID260",
        .addr = A_SYS_CACHE_GRP_SN_NODEID_REG10_U_RNI_NID260,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_SN_NODEID_REG11_U_RNI_NID260",
        .addr = A_SYS_CACHE_GRP_SN_NODEID_REG11_U_RNI_NID260,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_SN_NODEID_REG12_U_RNI_NID260",
        .addr = A_SYS_CACHE_GRP_SN_NODEID_REG12_U_RNI_NID260,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_SN_NODEID_REG13_U_RNI_NID260",
        .addr = A_SYS_CACHE_GRP_SN_NODEID_REG13_U_RNI_NID260,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_SN_NODEID_REG14_U_RNI_NID260",
        .addr = A_SYS_CACHE_GRP_SN_NODEID_REG14_U_RNI_NID260,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_SN_NODEID_REG15_U_RNI_NID260",
        .addr = A_SYS_CACHE_GRP_SN_NODEID_REG15_U_RNI_NID260,
        .ro = 0xffff800800800800L,
    },{ .name = "POR_FDC_NODE_INFO_U_SMXP_4_0",
        .addr = A_POR_FDC_NODE_INFO_U_SMXP_4_0,
        .reset = 0x201,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_FDC_CHILD_INFO_U_SMXP_4_0",
        .addr = A_POR_FDC_CHILD_INFO_U_SMXP_4_0,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_ERRFR_MXP_U_SMXP_4_0",  .addr = A_POR_ERRFR_MXP_U_SMXP_4_0,
        .reset = 0xa1,
        .rsvd = 0xffffffffffffff0cL,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_ERRCTLR_MXP_U_SMXP_4_0",
        .addr = A_POR_ERRCTLR_MXP_U_SMXP_4_0,
        .reset = 0xd,
        .rsvd = 0x3ff2,
        .ro = 0xffffffff00003ff2L,
    },{ .name = "POR_ERRSTATUS_MXP_U_SMXP_4_0",
        .addr = A_POR_ERRSTATUS_MXP_U_SMXP_4_0,
        .ro = 0xffffffff977f003fL,
    },{ .name = "POR_FDC_AUX_CTL_MXP_U_SMXP_4_0",
        .addr = A_POR_FDC_AUX_CTL_MXP_U_SMXP_4_0,
        .rsvd = 0xffffffffffffffe0L,
        .ro = 0xffffffffffffffefL,
    },{ .name = "POR_ERRFR_P0_D0_U_SMXP_4_0",
        .addr = A_POR_ERRFR_P0_D0_U_SMXP_4_0,
        .reset = 0xa1,
        .rsvd = 0xffffffffffffff0cL,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_ERRCTLR_P0_D0_U_SMXP_4_0",
        .addr = A_POR_ERRCTLR_P0_D0_U_SMXP_4_0,
        .reset = 0xd,
        .rsvd = 0x3ff2,
        .ro = 0xffffffff00003ff2L,
    },{ .name = "POR_ERRSTATUS_P0_D0_U_SMXP_4_0",
        .addr = A_POR_ERRSTATUS_P0_D0_U_SMXP_4_0,
        .ro = 0xffffffff977f003fL,
    },{ .name = "POR_FDC_AUX_CTL_P0_D0_U_SMXP_4_0",
        .addr = A_POR_FDC_AUX_CTL_P0_D0_U_SMXP_4_0,
        .rsvd = 0xffffffffffffffe0L,
        .ro = 0xffffffffffffffe0L,
    },{ .name = "POR_ERRFR_P0_D1_U_SMXP_4_0",
        .addr = A_POR_ERRFR_P0_D1_U_SMXP_4_0,
        .reset = 0xa1,
        .rsvd = 0xffffffffffffff0cL,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_ERRCTLR_P0_D1_U_SMXP_4_0",
        .addr = A_POR_ERRCTLR_P0_D1_U_SMXP_4_0,
        .reset = 0xd,
        .rsvd = 0x3ff2,
        .ro = 0xffffffff00003ff2L,
    },{ .name = "POR_ERRSTATUS_P0_D1_U_SMXP_4_0",
        .addr = A_POR_ERRSTATUS_P0_D1_U_SMXP_4_0,
        .ro = 0xffffffff977f003fL,
    },{ .name = "POR_FDC_AUX_CTL_P0_D1_U_SMXP_4_0",
        .addr = A_POR_FDC_AUX_CTL_P0_D1_U_SMXP_4_0,
        .rsvd = 0xffffffffffffffe0L,
        .ro = 0xffffffffffffffe0L,
    },{ .name = "POR_ERRFR_P0_D2_U_SMXP_4_0",
        .addr = A_POR_ERRFR_P0_D2_U_SMXP_4_0,
        .reset = 0xa1,
        .rsvd = 0xffffffffffffff0cL,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_ERRCTLR_P0_D2_U_SMXP_4_0",
        .addr = A_POR_ERRCTLR_P0_D2_U_SMXP_4_0,
        .reset = 0xd,
        .rsvd = 0x3ff2,
        .ro = 0xffffffff00003ff2L,
    },{ .name = "POR_ERRSTATUS_P0_D2_U_SMXP_4_0",
        .addr = A_POR_ERRSTATUS_P0_D2_U_SMXP_4_0,
        .ro = 0xffffffff977f003fL,
    },{ .name = "POR_FDC_AUX_CTL_P0_D2_U_SMXP_4_0",
        .addr = A_POR_FDC_AUX_CTL_P0_D2_U_SMXP_4_0,
        .rsvd = 0xffffffffffffffe0L,
        .ro = 0xffffffffffffffe0L,
    },{ .name = "POR_ERRFR_P0_D3_U_SMXP_4_0",
        .addr = A_POR_ERRFR_P0_D3_U_SMXP_4_0,
        .reset = 0xa1,
        .rsvd = 0xffffffffffffff0cL,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_ERRCTLR_P0_D3_U_SMXP_4_0",
        .addr = A_POR_ERRCTLR_P0_D3_U_SMXP_4_0,
        .reset = 0xd,
        .rsvd = 0x3ff2,
        .ro = 0xffffffff00003ff2L,
    },{ .name = "POR_ERRSTATUS_P0_D3_U_SMXP_4_0",
        .addr = A_POR_ERRSTATUS_P0_D3_U_SMXP_4_0,
        .ro = 0xffffffff977f003fL,
    },{ .name = "POR_FDC_AUX_CTL_P0_D3_U_SMXP_4_0",
        .addr = A_POR_FDC_AUX_CTL_P0_D3_U_SMXP_4_0,
        .rsvd = 0xffffffffffffffe0L,
        .ro = 0xffffffffffffffe0L,
    },{ .name = "POR_ERRFR_P1_D0_U_SMXP_4_0",
        .addr = A_POR_ERRFR_P1_D0_U_SMXP_4_0,
        .reset = 0xa1,
        .rsvd = 0xffffffffffffff0cL,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_ERRCTLR_P1_D0_U_SMXP_4_0",
        .addr = A_POR_ERRCTLR_P1_D0_U_SMXP_4_0,
        .reset = 0xd,
        .rsvd = 0x3ff2,
        .ro = 0xffffffff00003ff2L,
    },{ .name = "POR_ERRSTATUS_P1_D0_U_SMXP_4_0",
        .addr = A_POR_ERRSTATUS_P1_D0_U_SMXP_4_0,
        .ro = 0xffffffff977f003fL,
    },{ .name = "POR_FDC_AUX_CTL_P1_D0_U_SMXP_4_0",
        .addr = A_POR_FDC_AUX_CTL_P1_D0_U_SMXP_4_0,
        .rsvd = 0xffffffffffffffe0L,
        .ro = 0xffffffffffffffe0L,
    },{ .name = "POR_ERRFR_P1_D1_U_SMXP_4_0",
        .addr = A_POR_ERRFR_P1_D1_U_SMXP_4_0,
        .reset = 0xa1,
        .rsvd = 0xffffffffffffff0cL,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_ERRCTLR_P1_D1_U_SMXP_4_0",
        .addr = A_POR_ERRCTLR_P1_D1_U_SMXP_4_0,
        .reset = 0xd,
        .rsvd = 0x3ff2,
        .ro = 0xffffffff00003ff2L,
    },{ .name = "POR_ERRSTATUS_P1_D1_U_SMXP_4_0",
        .addr = A_POR_ERRSTATUS_P1_D1_U_SMXP_4_0,
        .ro = 0xffffffff977f003fL,
    },{ .name = "POR_FDC_AUX_CTL_P1_D1_U_SMXP_4_0",
        .addr = A_POR_FDC_AUX_CTL_P1_D1_U_SMXP_4_0,
        .rsvd = 0xffffffffffffffe0L,
        .ro = 0xffffffffffffffe0L,
    },{ .name = "POR_ERRFR_P1_D2_U_SMXP_4_0",
        .addr = A_POR_ERRFR_P1_D2_U_SMXP_4_0,
        .reset = 0xa1,
        .rsvd = 0xffffffffffffff0cL,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_ERRCTLR_P1_D2_U_SMXP_4_0",
        .addr = A_POR_ERRCTLR_P1_D2_U_SMXP_4_0,
        .reset = 0xd,
        .rsvd = 0x3ff2,
        .ro = 0xffffffff00003ff2L,
    },{ .name = "POR_ERRSTATUS_P1_D2_U_SMXP_4_0",
        .addr = A_POR_ERRSTATUS_P1_D2_U_SMXP_4_0,
        .ro = 0xffffffff977f003fL,
    },{ .name = "POR_FDC_AUX_CTL_P1_D2_U_SMXP_4_0",
        .addr = A_POR_FDC_AUX_CTL_P1_D2_U_SMXP_4_0,
        .rsvd = 0xffffffffffffffe0L,
        .ro = 0xffffffffffffffe0L,
    },{ .name = "POR_ERRFR_P1_D3_U_SMXP_4_0",
        .addr = A_POR_ERRFR_P1_D3_U_SMXP_4_0,
        .reset = 0xa1,
        .rsvd = 0xffffffffffffff0cL,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_ERRCTLR_P1_D3_U_SMXP_4_0",
        .addr = A_POR_ERRCTLR_P1_D3_U_SMXP_4_0,
        .reset = 0xd,
        .rsvd = 0x3ff2,
        .ro = 0xffffffff00003ff2L,
    },{ .name = "POR_ERRSTATUS_P1_D3_U_SMXP_4_0",
        .addr = A_POR_ERRSTATUS_P1_D3_U_SMXP_4_0,
        .ro = 0xffffffff977f003fL,
    },{ .name = "POR_FDC_AUX_CTL_P1_D3_U_SMXP_4_0",
        .addr = A_POR_FDC_AUX_CTL_P1_D3_U_SMXP_4_0,
        .rsvd = 0xffffffffffffffe0L,
        .ro = 0xffffffffffffffe0L,
    },{ .name = "POR_ERRINJECT_U_SMXP_4_0",  .addr = A_POR_ERRINJECT_U_SMXP_4_0,
        .rsvd = 0xffffffffffffff00L,
        .ro = 0xffffffffffffff00L,
    },{ .name = "POR_FDC_KEY_U_SMXP_4_0",  .addr = A_POR_FDC_KEY_U_SMXP_4_0,
        .reset = 0xbe,
        .rsvd = 0xffffffffffffff00L,
        .ro = 0xffffffffffffff00L,
    },{ .name = "POR_DT_NODE_INFO_U_HND_NID256",
        .addr = A_POR_DT_NODE_INFO_U_HND_NID256,
        .reset = 0x1000003,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_DT_CHILD_INFO_U_HND_NID256",
        .addr = A_POR_DT_CHILD_INFO_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_DT_SECURE_ACCESS_U_HND_NID256",
        .addr = A_POR_DT_SECURE_ACCESS_U_HND_NID256,
        .rsvd = 0xfffffffffffffff8L,
        .ro = 0xfffffffffffffff8L,
    },{ .name = "POR_DT_DTC_CTL_U_HND_NID256",
        .addr = A_POR_DT_DTC_CTL_U_HND_NID256,
        .ro = 0xfffffffffffff800L,
    },{ .name = "POR_DT_TRIGGER_STATUS_U_HND_NID256",
        .addr = A_POR_DT_TRIGGER_STATUS_U_HND_NID256,
        .rsvd = 0xfe,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_DT_TRIGGER_STATUS_CLR_U_HND_NID256",
        .addr = A_POR_DT_TRIGGER_STATUS_CLR_U_HND_NID256,
        .rsvd = 0xfffffffffffffffeL,
        .ro = 0xfffffffffffffffeL,
    },{ .name = "POR_DT_TRACE_CONTROL_U_HND_NID256",
        .addr = A_POR_DT_TRACE_CONTROL_U_HND_NID256,
        .ro = 0xfffffffffffffe00L,
    },{ .name = "POR_DT_TRACEID_U_HND_NID256",
        .addr = A_POR_DT_TRACEID_U_HND_NID256,
        .rsvd = 0xffffffffffffff80L,
        .ro = 0xffffffffffffff80L,
    },{ .name = "POR_DT_PMEVCNTAB_U_HND_NID256",
        .addr = A_POR_DT_PMEVCNTAB_U_HND_NID256,
    },{ .name = "POR_DT_PMEVCNTCD_U_HND_NID256",
        .addr = A_POR_DT_PMEVCNTCD_U_HND_NID256,
    },{ .name = "POR_DT_PMEVCNTEF_U_HND_NID256",
        .addr = A_POR_DT_PMEVCNTEF_U_HND_NID256,
    },{ .name = "POR_DT_PMEVCNTGH_U_HND_NID256",
        .addr = A_POR_DT_PMEVCNTGH_U_HND_NID256,
    },{ .name = "POR_DT_PMCCNTR_U_HND_NID256",
        .addr = A_POR_DT_PMCCNTR_U_HND_NID256,
        .ro = 0xffffff0000000000L,
    },{ .name = "POR_DT_PMEVCNTSRAB_U_HND_NID256",
        .addr = A_POR_DT_PMEVCNTSRAB_U_HND_NID256,
    },{ .name = "POR_DT_PMEVCNTSRCD_U_HND_NID256",
        .addr = A_POR_DT_PMEVCNTSRCD_U_HND_NID256,
    },{ .name = "POR_DT_PMEVCNTSREF_U_HND_NID256",
        .addr = A_POR_DT_PMEVCNTSREF_U_HND_NID256,
    },{ .name = "POR_DT_PMEVCNTSRGH_U_HND_NID256",
        .addr = A_POR_DT_PMEVCNTSRGH_U_HND_NID256,
    },{ .name = "POR_DT_PMCCNTRSR_U_HND_NID256",
        .addr = A_POR_DT_PMCCNTRSR_U_HND_NID256,
        .ro = 0xffffff0000000000L,
    },{ .name = "POR_DT_PMCR_U_HND_NID256",  .addr = A_POR_DT_PMCR_U_HND_NID256,
        .rsvd = 0xffffffffffffff80L,
        .ro = 0xffffffffffffff80L,
    },{ .name = "POR_DT_PMOVSR_U_HND_NID256",
        .addr = A_POR_DT_PMOVSR_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_DT_PMOVSR_CLR_U_HND_NID256",
        .addr = A_POR_DT_PMOVSR_CLR_U_HND_NID256,
        .ro = 0xfffffffffffffe00L,
    },{ .name = "POR_DT_PMSSR_U_HND_NID256",
        .addr = A_POR_DT_PMSSR_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_DT_PMSRR_U_HND_NID256",
        .addr = A_POR_DT_PMSRR_U_HND_NID256,
        .rsvd = 0xfffffffffffffffeL,
        .ro = 0xfffffffffffffffeL,
    },{ .name = "POR_DT_CLAIM_U_HND_NID256",
        .addr = A_POR_DT_CLAIM_U_HND_NID256,
        .reset = 0xffffffff,
    },{ .name = "POR_DT_DEVAFF_U_HND_NID256",
        .addr = A_POR_DT_DEVAFF_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_DT_LSR_U_HND_NID256",  .addr = A_POR_DT_LSR_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_DT_AUTHSTATUS_DEVARCH_U_HND_NID256",
        .addr = A_POR_DT_AUTHSTATUS_DEVARCH_U_HND_NID256,
        .reset = 0x10000000000088,
        .rsvd = 0xffffff30,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_DT_DEVID_U_HND_NID256",
        .addr = A_POR_DT_DEVID_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_DT_DEVTYPE_U_HND_NID256",
        .addr = A_POR_DT_DEVTYPE_U_HND_NID256,
        .reset = 0x4300000000,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_DT_PIDR45_U_HND_NID256",
        .addr = A_POR_DT_PIDR45_U_HND_NID256,
        .reset = 0x4,
        .rsvd = 0xffffff00,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_DT_PIDR67_U_HND_NID256",
        .addr = A_POR_DT_PIDR67_U_HND_NID256,
        .rsvd = 0xffffff00,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_DT_PIDR01_U_HND_NID256",
        .addr = A_POR_DT_PIDR01_U_HND_NID256,
        .reset = 0xb400000034,
        .rsvd = 0xffffff00,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_DT_PIDR23_U_HND_NID256",
        .addr = A_POR_DT_PIDR23_U_HND_NID256,
        .reset = 0x7,
        .rsvd = 0xffffff00,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_DT_CIDR01_U_HND_NID256",
        .addr = A_POR_DT_CIDR01_U_HND_NID256,
        .reset = 0x9f0000000d,
        .rsvd = 0xffffff00,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_DT_CIDR23_U_HND_NID256",
        .addr = A_POR_DT_CIDR23_U_HND_NID256,
        .reset = 0xb100000005,
        .rsvd = 0xffffff00,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MPU_NODE_INFO_U_RNI_NID260",
        .addr = A_POR_MPU_NODE_INFO_U_RNI_NID260,
        .reset = 0x202,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MPU_CHILD_INFO_U_RNI_NID260",
        .addr = A_POR_MPU_CHILD_INFO_U_RNI_NID260,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MPU_UNIT_INFO_U_RNI_NID260",
        .addr = A_POR_MPU_UNIT_INFO_U_RNI_NID260,
        .reset = 0x20,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MPU_M0_CTL_U_RNI_NID260",
        .addr = A_POR_MPU_M0_CTL_U_RNI_NID260,
        .reset = 0x2,
        .rsvd = 0xfffffffffffffff8L,
        .ro = 0xfffffffffffffff8L,
    },{ .name = "POR_MPU_M0_PRBAR0_U_RNI_NID260",
        .addr = A_POR_MPU_M0_PRBAR0_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR0_U_RNI_NID260",
        .addr = A_POR_MPU_M0_PRLAR0_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR1_U_RNI_NID260",
        .addr = A_POR_MPU_M0_PRBAR1_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR1_U_RNI_NID260",
        .addr = A_POR_MPU_M0_PRLAR1_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR2_U_RNI_NID260",
        .addr = A_POR_MPU_M0_PRBAR2_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR2_U_RNI_NID260",
        .addr = A_POR_MPU_M0_PRLAR2_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR3_U_RNI_NID260",
        .addr = A_POR_MPU_M0_PRBAR3_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR3_U_RNI_NID260",
        .addr = A_POR_MPU_M0_PRLAR3_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR4_U_RNI_NID260",
        .addr = A_POR_MPU_M0_PRBAR4_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR4_U_RNI_NID260",
        .addr = A_POR_MPU_M0_PRLAR4_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR5_U_RNI_NID260",
        .addr = A_POR_MPU_M0_PRBAR5_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR5_U_RNI_NID260",
        .addr = A_POR_MPU_M0_PRLAR5_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR6_U_RNI_NID260",
        .addr = A_POR_MPU_M0_PRBAR6_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR6_U_RNI_NID260",
        .addr = A_POR_MPU_M0_PRLAR6_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR7_U_RNI_NID260",
        .addr = A_POR_MPU_M0_PRBAR7_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR7_U_RNI_NID260",
        .addr = A_POR_MPU_M0_PRLAR7_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR8_U_RNI_NID260",
        .addr = A_POR_MPU_M0_PRBAR8_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR8_U_RNI_NID260",
        .addr = A_POR_MPU_M0_PRLAR8_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR9_U_RNI_NID260",
        .addr = A_POR_MPU_M0_PRBAR9_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR9_U_RNI_NID260",
        .addr = A_POR_MPU_M0_PRLAR9_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR10_U_RNI_NID260",
        .addr = A_POR_MPU_M0_PRBAR10_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR10_U_RNI_NID260",
        .addr = A_POR_MPU_M0_PRLAR10_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR11_U_RNI_NID260",
        .addr = A_POR_MPU_M0_PRBAR11_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR11_U_RNI_NID260",
        .addr = A_POR_MPU_M0_PRLAR11_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR12_U_RNI_NID260",
        .addr = A_POR_MPU_M0_PRBAR12_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR12_U_RNI_NID260",
        .addr = A_POR_MPU_M0_PRLAR12_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR13_U_RNI_NID260",
        .addr = A_POR_MPU_M0_PRBAR13_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR13_U_RNI_NID260",
        .addr = A_POR_MPU_M0_PRLAR13_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR14_U_RNI_NID260",
        .addr = A_POR_MPU_M0_PRBAR14_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR14_U_RNI_NID260",
        .addr = A_POR_MPU_M0_PRLAR14_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR15_U_RNI_NID260",
        .addr = A_POR_MPU_M0_PRBAR15_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR15_U_RNI_NID260",
        .addr = A_POR_MPU_M0_PRLAR15_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR16_U_RNI_NID260",
        .addr = A_POR_MPU_M0_PRBAR16_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR16_U_RNI_NID260",
        .addr = A_POR_MPU_M0_PRLAR16_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR17_U_RNI_NID260",
        .addr = A_POR_MPU_M0_PRBAR17_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR17_U_RNI_NID260",
        .addr = A_POR_MPU_M0_PRLAR17_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR18_U_RNI_NID260",
        .addr = A_POR_MPU_M0_PRBAR18_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR18_U_RNI_NID260",
        .addr = A_POR_MPU_M0_PRLAR18_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR19_U_RNI_NID260",
        .addr = A_POR_MPU_M0_PRBAR19_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR19_U_RNI_NID260",
        .addr = A_POR_MPU_M0_PRLAR19_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR20_U_RNI_NID260",
        .addr = A_POR_MPU_M0_PRBAR20_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR20_U_RNI_NID260",
        .addr = A_POR_MPU_M0_PRLAR20_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR21_U_RNI_NID260",
        .addr = A_POR_MPU_M0_PRBAR21_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR21_U_RNI_NID260",
        .addr = A_POR_MPU_M0_PRLAR21_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR22_U_RNI_NID260",
        .addr = A_POR_MPU_M0_PRBAR22_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR22_U_RNI_NID260",
        .addr = A_POR_MPU_M0_PRLAR22_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR23_U_RNI_NID260",
        .addr = A_POR_MPU_M0_PRBAR23_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR23_U_RNI_NID260",
        .addr = A_POR_MPU_M0_PRLAR23_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR24_U_RNI_NID260",
        .addr = A_POR_MPU_M0_PRBAR24_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR24_U_RNI_NID260",
        .addr = A_POR_MPU_M0_PRLAR24_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR25_U_RNI_NID260",
        .addr = A_POR_MPU_M0_PRBAR25_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR25_U_RNI_NID260",
        .addr = A_POR_MPU_M0_PRLAR25_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR26_U_RNI_NID260",
        .addr = A_POR_MPU_M0_PRBAR26_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR26_U_RNI_NID260",
        .addr = A_POR_MPU_M0_PRLAR26_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR27_U_RNI_NID260",
        .addr = A_POR_MPU_M0_PRBAR27_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR27_U_RNI_NID260",
        .addr = A_POR_MPU_M0_PRLAR27_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR28_U_RNI_NID260",
        .addr = A_POR_MPU_M0_PRBAR28_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR28_U_RNI_NID260",
        .addr = A_POR_MPU_M0_PRLAR28_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR29_U_RNI_NID260",
        .addr = A_POR_MPU_M0_PRBAR29_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR29_U_RNI_NID260",
        .addr = A_POR_MPU_M0_PRLAR29_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR30_U_RNI_NID260",
        .addr = A_POR_MPU_M0_PRBAR30_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR30_U_RNI_NID260",
        .addr = A_POR_MPU_M0_PRLAR30_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR31_U_RNI_NID260",
        .addr = A_POR_MPU_M0_PRBAR31_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR31_U_RNI_NID260",
        .addr = A_POR_MPU_M0_PRLAR31_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_CTL_U_RNI_NID260",
        .addr = A_POR_MPU_M1_CTL_U_RNI_NID260,
        .reset = 0x2,
        .rsvd = 0xfffffffffffffff8L,
        .ro = 0xfffffffffffffff8L,
    },{ .name = "POR_MPU_M1_PRBAR0_U_RNI_NID260",
        .addr = A_POR_MPU_M1_PRBAR0_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR0_U_RNI_NID260",
        .addr = A_POR_MPU_M1_PRLAR0_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR1_U_RNI_NID260",
        .addr = A_POR_MPU_M1_PRBAR1_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR1_U_RNI_NID260",
        .addr = A_POR_MPU_M1_PRLAR1_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR2_U_RNI_NID260",
        .addr = A_POR_MPU_M1_PRBAR2_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR2_U_RNI_NID260",
        .addr = A_POR_MPU_M1_PRLAR2_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR3_U_RNI_NID260",
        .addr = A_POR_MPU_M1_PRBAR3_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR3_U_RNI_NID260",
        .addr = A_POR_MPU_M1_PRLAR3_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR4_U_RNI_NID260",
        .addr = A_POR_MPU_M1_PRBAR4_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR4_U_RNI_NID260",
        .addr = A_POR_MPU_M1_PRLAR4_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR5_U_RNI_NID260",
        .addr = A_POR_MPU_M1_PRBAR5_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR5_U_RNI_NID260",
        .addr = A_POR_MPU_M1_PRLAR5_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR6_U_RNI_NID260",
        .addr = A_POR_MPU_M1_PRBAR6_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR6_U_RNI_NID260",
        .addr = A_POR_MPU_M1_PRLAR6_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR7_U_RNI_NID260",
        .addr = A_POR_MPU_M1_PRBAR7_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR7_U_RNI_NID260",
        .addr = A_POR_MPU_M1_PRLAR7_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR8_U_RNI_NID260",
        .addr = A_POR_MPU_M1_PRBAR8_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR8_U_RNI_NID260",
        .addr = A_POR_MPU_M1_PRLAR8_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR9_U_RNI_NID260",
        .addr = A_POR_MPU_M1_PRBAR9_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR9_U_RNI_NID260",
        .addr = A_POR_MPU_M1_PRLAR9_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR10_U_RNI_NID260",
        .addr = A_POR_MPU_M1_PRBAR10_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR10_U_RNI_NID260",
        .addr = A_POR_MPU_M1_PRLAR10_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR11_U_RNI_NID260",
        .addr = A_POR_MPU_M1_PRBAR11_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR11_U_RNI_NID260",
        .addr = A_POR_MPU_M1_PRLAR11_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR12_U_RNI_NID260",
        .addr = A_POR_MPU_M1_PRBAR12_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR12_U_RNI_NID260",
        .addr = A_POR_MPU_M1_PRLAR12_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR13_U_RNI_NID260",
        .addr = A_POR_MPU_M1_PRBAR13_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR13_U_RNI_NID260",
        .addr = A_POR_MPU_M1_PRLAR13_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR14_U_RNI_NID260",
        .addr = A_POR_MPU_M1_PRBAR14_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR14_U_RNI_NID260",
        .addr = A_POR_MPU_M1_PRLAR14_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR15_U_RNI_NID260",
        .addr = A_POR_MPU_M1_PRBAR15_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR15_U_RNI_NID260",
        .addr = A_POR_MPU_M1_PRLAR15_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR16_U_RNI_NID260",
        .addr = A_POR_MPU_M1_PRBAR16_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR16_U_RNI_NID260",
        .addr = A_POR_MPU_M1_PRLAR16_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR17_U_RNI_NID260",
        .addr = A_POR_MPU_M1_PRBAR17_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR17_U_RNI_NID260",
        .addr = A_POR_MPU_M1_PRLAR17_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR18_U_RNI_NID260",
        .addr = A_POR_MPU_M1_PRBAR18_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR18_U_RNI_NID260",
        .addr = A_POR_MPU_M1_PRLAR18_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR19_U_RNI_NID260",
        .addr = A_POR_MPU_M1_PRBAR19_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR19_U_RNI_NID260",
        .addr = A_POR_MPU_M1_PRLAR19_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR20_U_RNI_NID260",
        .addr = A_POR_MPU_M1_PRBAR20_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR20_U_RNI_NID260",
        .addr = A_POR_MPU_M1_PRLAR20_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR21_U_RNI_NID260",
        .addr = A_POR_MPU_M1_PRBAR21_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR21_U_RNI_NID260",
        .addr = A_POR_MPU_M1_PRLAR21_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR22_U_RNI_NID260",
        .addr = A_POR_MPU_M1_PRBAR22_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR22_U_RNI_NID260",
        .addr = A_POR_MPU_M1_PRLAR22_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR23_U_RNI_NID260",
        .addr = A_POR_MPU_M1_PRBAR23_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR23_U_RNI_NID260",
        .addr = A_POR_MPU_M1_PRLAR23_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR24_U_RNI_NID260",
        .addr = A_POR_MPU_M1_PRBAR24_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR24_U_RNI_NID260",
        .addr = A_POR_MPU_M1_PRLAR24_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR25_U_RNI_NID260",
        .addr = A_POR_MPU_M1_PRBAR25_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR25_U_RNI_NID260",
        .addr = A_POR_MPU_M1_PRLAR25_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR26_U_RNI_NID260",
        .addr = A_POR_MPU_M1_PRBAR26_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR26_U_RNI_NID260",
        .addr = A_POR_MPU_M1_PRLAR26_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR27_U_RNI_NID260",
        .addr = A_POR_MPU_M1_PRBAR27_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR27_U_RNI_NID260",
        .addr = A_POR_MPU_M1_PRLAR27_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR28_U_RNI_NID260",
        .addr = A_POR_MPU_M1_PRBAR28_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR28_U_RNI_NID260",
        .addr = A_POR_MPU_M1_PRLAR28_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR29_U_RNI_NID260",
        .addr = A_POR_MPU_M1_PRBAR29_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR29_U_RNI_NID260",
        .addr = A_POR_MPU_M1_PRLAR29_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR30_U_RNI_NID260",
        .addr = A_POR_MPU_M1_PRBAR30_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR30_U_RNI_NID260",
        .addr = A_POR_MPU_M1_PRLAR30_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR31_U_RNI_NID260",
        .addr = A_POR_MPU_M1_PRBAR31_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR31_U_RNI_NID260",
        .addr = A_POR_MPU_M1_PRLAR31_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_CTL_U_RNI_NID260",
        .addr = A_POR_MPU_M2_CTL_U_RNI_NID260,
        .reset = 0x2,
        .rsvd = 0xfffffffffffffff8L,
        .ro = 0xfffffffffffffff8L,
    },{ .name = "POR_MPU_M2_PRBAR0_U_RNI_NID260",
        .addr = A_POR_MPU_M2_PRBAR0_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR0_U_RNI_NID260",
        .addr = A_POR_MPU_M2_PRLAR0_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR1_U_RNI_NID260",
        .addr = A_POR_MPU_M2_PRBAR1_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR1_U_RNI_NID260",
        .addr = A_POR_MPU_M2_PRLAR1_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR2_U_RNI_NID260",
        .addr = A_POR_MPU_M2_PRBAR2_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR2_U_RNI_NID260",
        .addr = A_POR_MPU_M2_PRLAR2_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR3_U_RNI_NID260",
        .addr = A_POR_MPU_M2_PRBAR3_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR3_U_RNI_NID260",
        .addr = A_POR_MPU_M2_PRLAR3_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR4_U_RNI_NID260",
        .addr = A_POR_MPU_M2_PRBAR4_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR4_U_RNI_NID260",
        .addr = A_POR_MPU_M2_PRLAR4_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR5_U_RNI_NID260",
        .addr = A_POR_MPU_M2_PRBAR5_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR5_U_RNI_NID260",
        .addr = A_POR_MPU_M2_PRLAR5_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR6_U_RNI_NID260",
        .addr = A_POR_MPU_M2_PRBAR6_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR6_U_RNI_NID260",
        .addr = A_POR_MPU_M2_PRLAR6_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR7_U_RNI_NID260",
        .addr = A_POR_MPU_M2_PRBAR7_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR7_U_RNI_NID260",
        .addr = A_POR_MPU_M2_PRLAR7_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR8_U_RNI_NID260",
        .addr = A_POR_MPU_M2_PRBAR8_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR8_U_RNI_NID260",
        .addr = A_POR_MPU_M2_PRLAR8_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR9_U_RNI_NID260",
        .addr = A_POR_MPU_M2_PRBAR9_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR9_U_RNI_NID260",
        .addr = A_POR_MPU_M2_PRLAR9_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR10_U_RNI_NID260",
        .addr = A_POR_MPU_M2_PRBAR10_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR10_U_RNI_NID260",
        .addr = A_POR_MPU_M2_PRLAR10_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR11_U_RNI_NID260",
        .addr = A_POR_MPU_M2_PRBAR11_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR11_U_RNI_NID260",
        .addr = A_POR_MPU_M2_PRLAR11_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR12_U_RNI_NID260",
        .addr = A_POR_MPU_M2_PRBAR12_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR12_U_RNI_NID260",
        .addr = A_POR_MPU_M2_PRLAR12_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR13_U_RNI_NID260",
        .addr = A_POR_MPU_M2_PRBAR13_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR13_U_RNI_NID260",
        .addr = A_POR_MPU_M2_PRLAR13_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR14_U_RNI_NID260",
        .addr = A_POR_MPU_M2_PRBAR14_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR14_U_RNI_NID260",
        .addr = A_POR_MPU_M2_PRLAR14_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR15_U_RNI_NID260",
        .addr = A_POR_MPU_M2_PRBAR15_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR15_U_RNI_NID260",
        .addr = A_POR_MPU_M2_PRLAR15_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR16_U_RNI_NID260",
        .addr = A_POR_MPU_M2_PRBAR16_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR16_U_RNI_NID260",
        .addr = A_POR_MPU_M2_PRLAR16_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR17_U_RNI_NID260",
        .addr = A_POR_MPU_M2_PRBAR17_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR17_U_RNI_NID260",
        .addr = A_POR_MPU_M2_PRLAR17_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR18_U_RNI_NID260",
        .addr = A_POR_MPU_M2_PRBAR18_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR18_U_RNI_NID260",
        .addr = A_POR_MPU_M2_PRLAR18_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR19_U_RNI_NID260",
        .addr = A_POR_MPU_M2_PRBAR19_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR19_U_RNI_NID260",
        .addr = A_POR_MPU_M2_PRLAR19_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR20_U_RNI_NID260",
        .addr = A_POR_MPU_M2_PRBAR20_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR20_U_RNI_NID260",
        .addr = A_POR_MPU_M2_PRLAR20_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR21_U_RNI_NID260",
        .addr = A_POR_MPU_M2_PRBAR21_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR21_U_RNI_NID260",
        .addr = A_POR_MPU_M2_PRLAR21_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR22_U_RNI_NID260",
        .addr = A_POR_MPU_M2_PRBAR22_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR22_U_RNI_NID260",
        .addr = A_POR_MPU_M2_PRLAR22_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR23_U_RNI_NID260",
        .addr = A_POR_MPU_M2_PRBAR23_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR23_U_RNI_NID260",
        .addr = A_POR_MPU_M2_PRLAR23_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR24_U_RNI_NID260",
        .addr = A_POR_MPU_M2_PRBAR24_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR24_U_RNI_NID260",
        .addr = A_POR_MPU_M2_PRLAR24_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR25_U_RNI_NID260",
        .addr = A_POR_MPU_M2_PRBAR25_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR25_U_RNI_NID260",
        .addr = A_POR_MPU_M2_PRLAR25_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR26_U_RNI_NID260",
        .addr = A_POR_MPU_M2_PRBAR26_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR26_U_RNI_NID260",
        .addr = A_POR_MPU_M2_PRLAR26_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR27_U_RNI_NID260",
        .addr = A_POR_MPU_M2_PRBAR27_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR27_U_RNI_NID260",
        .addr = A_POR_MPU_M2_PRLAR27_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR28_U_RNI_NID260",
        .addr = A_POR_MPU_M2_PRBAR28_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR28_U_RNI_NID260",
        .addr = A_POR_MPU_M2_PRLAR28_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR29_U_RNI_NID260",
        .addr = A_POR_MPU_M2_PRBAR29_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR29_U_RNI_NID260",
        .addr = A_POR_MPU_M2_PRLAR29_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR30_U_RNI_NID260",
        .addr = A_POR_MPU_M2_PRBAR30_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR30_U_RNI_NID260",
        .addr = A_POR_MPU_M2_PRLAR30_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR31_U_RNI_NID260",
        .addr = A_POR_MPU_M2_PRBAR31_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR31_U_RNI_NID260",
        .addr = A_POR_MPU_M2_PRLAR31_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_CTL_U_RNI_NID260",
        .addr = A_POR_MPU_M3_CTL_U_RNI_NID260,
        .reset = 0x2,
        .rsvd = 0xfffffffffffffff8L,
        .ro = 0xfffffffffffffff8L,
    },{ .name = "POR_MPU_M3_PRBAR0_U_RNI_NID260",
        .addr = A_POR_MPU_M3_PRBAR0_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR0_U_RNI_NID260",
        .addr = A_POR_MPU_M3_PRLAR0_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR1_U_RNI_NID260",
        .addr = A_POR_MPU_M3_PRBAR1_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR1_U_RNI_NID260",
        .addr = A_POR_MPU_M3_PRLAR1_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR2_U_RNI_NID260",
        .addr = A_POR_MPU_M3_PRBAR2_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR2_U_RNI_NID260",
        .addr = A_POR_MPU_M3_PRLAR2_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR3_U_RNI_NID260",
        .addr = A_POR_MPU_M3_PRBAR3_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR3_U_RNI_NID260",
        .addr = A_POR_MPU_M3_PRLAR3_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR4_U_RNI_NID260",
        .addr = A_POR_MPU_M3_PRBAR4_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR4_U_RNI_NID260",
        .addr = A_POR_MPU_M3_PRLAR4_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR5_U_RNI_NID260",
        .addr = A_POR_MPU_M3_PRBAR5_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR5_U_RNI_NID260",
        .addr = A_POR_MPU_M3_PRLAR5_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR6_U_RNI_NID260",
        .addr = A_POR_MPU_M3_PRBAR6_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR6_U_RNI_NID260",
        .addr = A_POR_MPU_M3_PRLAR6_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR7_U_RNI_NID260",
        .addr = A_POR_MPU_M3_PRBAR7_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR7_U_RNI_NID260",
        .addr = A_POR_MPU_M3_PRLAR7_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR8_U_RNI_NID260",
        .addr = A_POR_MPU_M3_PRBAR8_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR8_U_RNI_NID260",
        .addr = A_POR_MPU_M3_PRLAR8_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR9_U_RNI_NID260",
        .addr = A_POR_MPU_M3_PRBAR9_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR9_U_RNI_NID260",
        .addr = A_POR_MPU_M3_PRLAR9_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR10_U_RNI_NID260",
        .addr = A_POR_MPU_M3_PRBAR10_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR10_U_RNI_NID260",
        .addr = A_POR_MPU_M3_PRLAR10_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR11_U_RNI_NID260",
        .addr = A_POR_MPU_M3_PRBAR11_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR11_U_RNI_NID260",
        .addr = A_POR_MPU_M3_PRLAR11_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR12_U_RNI_NID260",
        .addr = A_POR_MPU_M3_PRBAR12_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR12_U_RNI_NID260",
        .addr = A_POR_MPU_M3_PRLAR12_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR13_U_RNI_NID260",
        .addr = A_POR_MPU_M3_PRBAR13_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR13_U_RNI_NID260",
        .addr = A_POR_MPU_M3_PRLAR13_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR14_U_RNI_NID260",
        .addr = A_POR_MPU_M3_PRBAR14_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR14_U_RNI_NID260",
        .addr = A_POR_MPU_M3_PRLAR14_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR15_U_RNI_NID260",
        .addr = A_POR_MPU_M3_PRBAR15_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR15_U_RNI_NID260",
        .addr = A_POR_MPU_M3_PRLAR15_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR16_U_RNI_NID260",
        .addr = A_POR_MPU_M3_PRBAR16_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR16_U_RNI_NID260",
        .addr = A_POR_MPU_M3_PRLAR16_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR17_U_RNI_NID260",
        .addr = A_POR_MPU_M3_PRBAR17_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR17_U_RNI_NID260",
        .addr = A_POR_MPU_M3_PRLAR17_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR18_U_RNI_NID260",
        .addr = A_POR_MPU_M3_PRBAR18_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR18_U_RNI_NID260",
        .addr = A_POR_MPU_M3_PRLAR18_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR19_U_RNI_NID260",
        .addr = A_POR_MPU_M3_PRBAR19_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR19_U_RNI_NID260",
        .addr = A_POR_MPU_M3_PRLAR19_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR20_U_RNI_NID260",
        .addr = A_POR_MPU_M3_PRBAR20_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR20_U_RNI_NID260",
        .addr = A_POR_MPU_M3_PRLAR20_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR21_U_RNI_NID260",
        .addr = A_POR_MPU_M3_PRBAR21_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR21_U_RNI_NID260",
        .addr = A_POR_MPU_M3_PRLAR21_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR22_U_RNI_NID260",
        .addr = A_POR_MPU_M3_PRBAR22_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR22_U_RNI_NID260",
        .addr = A_POR_MPU_M3_PRLAR22_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR23_U_RNI_NID260",
        .addr = A_POR_MPU_M3_PRBAR23_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR23_U_RNI_NID260",
        .addr = A_POR_MPU_M3_PRLAR23_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR24_U_RNI_NID260",
        .addr = A_POR_MPU_M3_PRBAR24_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR24_U_RNI_NID260",
        .addr = A_POR_MPU_M3_PRLAR24_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR25_U_RNI_NID260",
        .addr = A_POR_MPU_M3_PRBAR25_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR25_U_RNI_NID260",
        .addr = A_POR_MPU_M3_PRLAR25_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR26_U_RNI_NID260",
        .addr = A_POR_MPU_M3_PRBAR26_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR26_U_RNI_NID260",
        .addr = A_POR_MPU_M3_PRLAR26_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR27_U_RNI_NID260",
        .addr = A_POR_MPU_M3_PRBAR27_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR27_U_RNI_NID260",
        .addr = A_POR_MPU_M3_PRLAR27_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR28_U_RNI_NID260",
        .addr = A_POR_MPU_M3_PRBAR28_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR28_U_RNI_NID260",
        .addr = A_POR_MPU_M3_PRLAR28_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR29_U_RNI_NID260",
        .addr = A_POR_MPU_M3_PRBAR29_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR29_U_RNI_NID260",
        .addr = A_POR_MPU_M3_PRLAR29_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR30_U_RNI_NID260",
        .addr = A_POR_MPU_M3_PRBAR30_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR30_U_RNI_NID260",
        .addr = A_POR_MPU_M3_PRLAR30_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR31_U_RNI_NID260",
        .addr = A_POR_MPU_M3_PRBAR31_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR31_U_RNI_NID260",
        .addr = A_POR_MPU_M3_PRLAR31_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_CTL_U_RNI_NID260",
        .addr = A_POR_MPU_M4_CTL_U_RNI_NID260,
        .reset = 0x2,
        .rsvd = 0xfffffffffffffff8L,
        .ro = 0xfffffffffffffff8L,
    },{ .name = "POR_MPU_M4_PRBAR0_U_RNI_NID260",
        .addr = A_POR_MPU_M4_PRBAR0_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR0_U_RNI_NID260",
        .addr = A_POR_MPU_M4_PRLAR0_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR1_U_RNI_NID260",
        .addr = A_POR_MPU_M4_PRBAR1_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR1_U_RNI_NID260",
        .addr = A_POR_MPU_M4_PRLAR1_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR2_U_RNI_NID260",
        .addr = A_POR_MPU_M4_PRBAR2_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR2_U_RNI_NID260",
        .addr = A_POR_MPU_M4_PRLAR2_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR3_U_RNI_NID260",
        .addr = A_POR_MPU_M4_PRBAR3_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR3_U_RNI_NID260",
        .addr = A_POR_MPU_M4_PRLAR3_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR4_U_RNI_NID260",
        .addr = A_POR_MPU_M4_PRBAR4_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR4_U_RNI_NID260",
        .addr = A_POR_MPU_M4_PRLAR4_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR5_U_RNI_NID260",
        .addr = A_POR_MPU_M4_PRBAR5_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR5_U_RNI_NID260",
        .addr = A_POR_MPU_M4_PRLAR5_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR6_U_RNI_NID260",
        .addr = A_POR_MPU_M4_PRBAR6_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR6_U_RNI_NID260",
        .addr = A_POR_MPU_M4_PRLAR6_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR7_U_RNI_NID260",
        .addr = A_POR_MPU_M4_PRBAR7_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR7_U_RNI_NID260",
        .addr = A_POR_MPU_M4_PRLAR7_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR8_U_RNI_NID260",
        .addr = A_POR_MPU_M4_PRBAR8_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR8_U_RNI_NID260",
        .addr = A_POR_MPU_M4_PRLAR8_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR9_U_RNI_NID260",
        .addr = A_POR_MPU_M4_PRBAR9_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR9_U_RNI_NID260",
        .addr = A_POR_MPU_M4_PRLAR9_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR10_U_RNI_NID260",
        .addr = A_POR_MPU_M4_PRBAR10_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR10_U_RNI_NID260",
        .addr = A_POR_MPU_M4_PRLAR10_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR11_U_RNI_NID260",
        .addr = A_POR_MPU_M4_PRBAR11_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR11_U_RNI_NID260",
        .addr = A_POR_MPU_M4_PRLAR11_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR12_U_RNI_NID260",
        .addr = A_POR_MPU_M4_PRBAR12_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR12_U_RNI_NID260",
        .addr = A_POR_MPU_M4_PRLAR12_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR13_U_RNI_NID260",
        .addr = A_POR_MPU_M4_PRBAR13_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR13_U_RNI_NID260",
        .addr = A_POR_MPU_M4_PRLAR13_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR14_U_RNI_NID260",
        .addr = A_POR_MPU_M4_PRBAR14_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR14_U_RNI_NID260",
        .addr = A_POR_MPU_M4_PRLAR14_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR15_U_RNI_NID260",
        .addr = A_POR_MPU_M4_PRBAR15_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR15_U_RNI_NID260",
        .addr = A_POR_MPU_M4_PRLAR15_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR16_U_RNI_NID260",
        .addr = A_POR_MPU_M4_PRBAR16_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR16_U_RNI_NID260",
        .addr = A_POR_MPU_M4_PRLAR16_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR17_U_RNI_NID260",
        .addr = A_POR_MPU_M4_PRBAR17_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR17_U_RNI_NID260",
        .addr = A_POR_MPU_M4_PRLAR17_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR18_U_RNI_NID260",
        .addr = A_POR_MPU_M4_PRBAR18_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR18_U_RNI_NID260",
        .addr = A_POR_MPU_M4_PRLAR18_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR19_U_RNI_NID260",
        .addr = A_POR_MPU_M4_PRBAR19_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR19_U_RNI_NID260",
        .addr = A_POR_MPU_M4_PRLAR19_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR20_U_RNI_NID260",
        .addr = A_POR_MPU_M4_PRBAR20_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR20_U_RNI_NID260",
        .addr = A_POR_MPU_M4_PRLAR20_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR21_U_RNI_NID260",
        .addr = A_POR_MPU_M4_PRBAR21_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR21_U_RNI_NID260",
        .addr = A_POR_MPU_M4_PRLAR21_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR22_U_RNI_NID260",
        .addr = A_POR_MPU_M4_PRBAR22_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR22_U_RNI_NID260",
        .addr = A_POR_MPU_M4_PRLAR22_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR23_U_RNI_NID260",
        .addr = A_POR_MPU_M4_PRBAR23_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR23_U_RNI_NID260",
        .addr = A_POR_MPU_M4_PRLAR23_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR24_U_RNI_NID260",
        .addr = A_POR_MPU_M4_PRBAR24_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR24_U_RNI_NID260",
        .addr = A_POR_MPU_M4_PRLAR24_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR25_U_RNI_NID260",
        .addr = A_POR_MPU_M4_PRBAR25_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR25_U_RNI_NID260",
        .addr = A_POR_MPU_M4_PRLAR25_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR26_U_RNI_NID260",
        .addr = A_POR_MPU_M4_PRBAR26_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR26_U_RNI_NID260",
        .addr = A_POR_MPU_M4_PRLAR26_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR27_U_RNI_NID260",
        .addr = A_POR_MPU_M4_PRBAR27_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR27_U_RNI_NID260",
        .addr = A_POR_MPU_M4_PRLAR27_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR28_U_RNI_NID260",
        .addr = A_POR_MPU_M4_PRBAR28_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR28_U_RNI_NID260",
        .addr = A_POR_MPU_M4_PRLAR28_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR29_U_RNI_NID260",
        .addr = A_POR_MPU_M4_PRBAR29_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR29_U_RNI_NID260",
        .addr = A_POR_MPU_M4_PRLAR29_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR30_U_RNI_NID260",
        .addr = A_POR_MPU_M4_PRBAR30_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR30_U_RNI_NID260",
        .addr = A_POR_MPU_M4_PRLAR30_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR31_U_RNI_NID260",
        .addr = A_POR_MPU_M4_PRBAR31_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR31_U_RNI_NID260",
        .addr = A_POR_MPU_M4_PRLAR31_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_CTL_U_RNI_NID260",
        .addr = A_POR_MPU_M5_CTL_U_RNI_NID260,
        .reset = 0x2,
        .rsvd = 0xfffffffffffffff8L,
        .ro = 0xfffffffffffffff8L,
    },{ .name = "POR_MPU_M5_PRBAR0_U_RNI_NID260",
        .addr = A_POR_MPU_M5_PRBAR0_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR0_U_RNI_NID260",
        .addr = A_POR_MPU_M5_PRLAR0_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR1_U_RNI_NID260",
        .addr = A_POR_MPU_M5_PRBAR1_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR1_U_RNI_NID260",
        .addr = A_POR_MPU_M5_PRLAR1_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR2_U_RNI_NID260",
        .addr = A_POR_MPU_M5_PRBAR2_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR2_U_RNI_NID260",
        .addr = A_POR_MPU_M5_PRLAR2_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR3_U_RNI_NID260",
        .addr = A_POR_MPU_M5_PRBAR3_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR3_U_RNI_NID260",
        .addr = A_POR_MPU_M5_PRLAR3_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR4_U_RNI_NID260",
        .addr = A_POR_MPU_M5_PRBAR4_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR4_U_RNI_NID260",
        .addr = A_POR_MPU_M5_PRLAR4_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR5_U_RNI_NID260",
        .addr = A_POR_MPU_M5_PRBAR5_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR5_U_RNI_NID260",
        .addr = A_POR_MPU_M5_PRLAR5_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR6_U_RNI_NID260",
        .addr = A_POR_MPU_M5_PRBAR6_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR6_U_RNI_NID260",
        .addr = A_POR_MPU_M5_PRLAR6_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR7_U_RNI_NID260",
        .addr = A_POR_MPU_M5_PRBAR7_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR7_U_RNI_NID260",
        .addr = A_POR_MPU_M5_PRLAR7_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR8_U_RNI_NID260",
        .addr = A_POR_MPU_M5_PRBAR8_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR8_U_RNI_NID260",
        .addr = A_POR_MPU_M5_PRLAR8_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR9_U_RNI_NID260",
        .addr = A_POR_MPU_M5_PRBAR9_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR9_U_RNI_NID260",
        .addr = A_POR_MPU_M5_PRLAR9_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR10_U_RNI_NID260",
        .addr = A_POR_MPU_M5_PRBAR10_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR10_U_RNI_NID260",
        .addr = A_POR_MPU_M5_PRLAR10_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR11_U_RNI_NID260",
        .addr = A_POR_MPU_M5_PRBAR11_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR11_U_RNI_NID260",
        .addr = A_POR_MPU_M5_PRLAR11_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR12_U_RNI_NID260",
        .addr = A_POR_MPU_M5_PRBAR12_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR12_U_RNI_NID260",
        .addr = A_POR_MPU_M5_PRLAR12_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR13_U_RNI_NID260",
        .addr = A_POR_MPU_M5_PRBAR13_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR13_U_RNI_NID260",
        .addr = A_POR_MPU_M5_PRLAR13_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR14_U_RNI_NID260",
        .addr = A_POR_MPU_M5_PRBAR14_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR14_U_RNI_NID260",
        .addr = A_POR_MPU_M5_PRLAR14_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR15_U_RNI_NID260",
        .addr = A_POR_MPU_M5_PRBAR15_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR15_U_RNI_NID260",
        .addr = A_POR_MPU_M5_PRLAR15_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR16_U_RNI_NID260",
        .addr = A_POR_MPU_M5_PRBAR16_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR16_U_RNI_NID260",
        .addr = A_POR_MPU_M5_PRLAR16_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR17_U_RNI_NID260",
        .addr = A_POR_MPU_M5_PRBAR17_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR17_U_RNI_NID260",
        .addr = A_POR_MPU_M5_PRLAR17_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR18_U_RNI_NID260",
        .addr = A_POR_MPU_M5_PRBAR18_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR18_U_RNI_NID260",
        .addr = A_POR_MPU_M5_PRLAR18_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR19_U_RNI_NID260",
        .addr = A_POR_MPU_M5_PRBAR19_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR19_U_RNI_NID260",
        .addr = A_POR_MPU_M5_PRLAR19_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR20_U_RNI_NID260",
        .addr = A_POR_MPU_M5_PRBAR20_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR20_U_RNI_NID260",
        .addr = A_POR_MPU_M5_PRLAR20_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR21_U_RNI_NID260",
        .addr = A_POR_MPU_M5_PRBAR21_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR21_U_RNI_NID260",
        .addr = A_POR_MPU_M5_PRLAR21_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR22_U_RNI_NID260",
        .addr = A_POR_MPU_M5_PRBAR22_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR22_U_RNI_NID260",
        .addr = A_POR_MPU_M5_PRLAR22_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR23_U_RNI_NID260",
        .addr = A_POR_MPU_M5_PRBAR23_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR23_U_RNI_NID260",
        .addr = A_POR_MPU_M5_PRLAR23_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR24_U_RNI_NID260",
        .addr = A_POR_MPU_M5_PRBAR24_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR24_U_RNI_NID260",
        .addr = A_POR_MPU_M5_PRLAR24_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR25_U_RNI_NID260",
        .addr = A_POR_MPU_M5_PRBAR25_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR25_U_RNI_NID260",
        .addr = A_POR_MPU_M5_PRLAR25_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR26_U_RNI_NID260",
        .addr = A_POR_MPU_M5_PRBAR26_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR26_U_RNI_NID260",
        .addr = A_POR_MPU_M5_PRLAR26_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR27_U_RNI_NID260",
        .addr = A_POR_MPU_M5_PRBAR27_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR27_U_RNI_NID260",
        .addr = A_POR_MPU_M5_PRLAR27_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR28_U_RNI_NID260",
        .addr = A_POR_MPU_M5_PRBAR28_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR28_U_RNI_NID260",
        .addr = A_POR_MPU_M5_PRLAR28_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR29_U_RNI_NID260",
        .addr = A_POR_MPU_M5_PRBAR29_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR29_U_RNI_NID260",
        .addr = A_POR_MPU_M5_PRLAR29_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR30_U_RNI_NID260",
        .addr = A_POR_MPU_M5_PRBAR30_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR30_U_RNI_NID260",
        .addr = A_POR_MPU_M5_PRLAR30_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR31_U_RNI_NID260",
        .addr = A_POR_MPU_M5_PRBAR31_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR31_U_RNI_NID260",
        .addr = A_POR_MPU_M5_PRLAR31_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_CTL_U_RNI_NID260",
        .addr = A_POR_MPU_M6_CTL_U_RNI_NID260,
        .reset = 0x2,
        .rsvd = 0xfffffffffffffff8L,
        .ro = 0xfffffffffffffff8L,
    },{ .name = "POR_MPU_M6_PRBAR0_U_RNI_NID260",
        .addr = A_POR_MPU_M6_PRBAR0_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR0_U_RNI_NID260",
        .addr = A_POR_MPU_M6_PRLAR0_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR1_U_RNI_NID260",
        .addr = A_POR_MPU_M6_PRBAR1_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR1_U_RNI_NID260",
        .addr = A_POR_MPU_M6_PRLAR1_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR2_U_RNI_NID260",
        .addr = A_POR_MPU_M6_PRBAR2_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR2_U_RNI_NID260",
        .addr = A_POR_MPU_M6_PRLAR2_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR3_U_RNI_NID260",
        .addr = A_POR_MPU_M6_PRBAR3_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR3_U_RNI_NID260",
        .addr = A_POR_MPU_M6_PRLAR3_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR4_U_RNI_NID260",
        .addr = A_POR_MPU_M6_PRBAR4_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR4_U_RNI_NID260",
        .addr = A_POR_MPU_M6_PRLAR4_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR5_U_RNI_NID260",
        .addr = A_POR_MPU_M6_PRBAR5_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR5_U_RNI_NID260",
        .addr = A_POR_MPU_M6_PRLAR5_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR6_U_RNI_NID260",
        .addr = A_POR_MPU_M6_PRBAR6_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR6_U_RNI_NID260",
        .addr = A_POR_MPU_M6_PRLAR6_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR7_U_RNI_NID260",
        .addr = A_POR_MPU_M6_PRBAR7_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR7_U_RNI_NID260",
        .addr = A_POR_MPU_M6_PRLAR7_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR8_U_RNI_NID260",
        .addr = A_POR_MPU_M6_PRBAR8_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR8_U_RNI_NID260",
        .addr = A_POR_MPU_M6_PRLAR8_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR9_U_RNI_NID260",
        .addr = A_POR_MPU_M6_PRBAR9_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR9_U_RNI_NID260",
        .addr = A_POR_MPU_M6_PRLAR9_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR10_U_RNI_NID260",
        .addr = A_POR_MPU_M6_PRBAR10_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR10_U_RNI_NID260",
        .addr = A_POR_MPU_M6_PRLAR10_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR11_U_RNI_NID260",
        .addr = A_POR_MPU_M6_PRBAR11_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR11_U_RNI_NID260",
        .addr = A_POR_MPU_M6_PRLAR11_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR12_U_RNI_NID260",
        .addr = A_POR_MPU_M6_PRBAR12_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR12_U_RNI_NID260",
        .addr = A_POR_MPU_M6_PRLAR12_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR13_U_RNI_NID260",
        .addr = A_POR_MPU_M6_PRBAR13_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR13_U_RNI_NID260",
        .addr = A_POR_MPU_M6_PRLAR13_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR14_U_RNI_NID260",
        .addr = A_POR_MPU_M6_PRBAR14_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR14_U_RNI_NID260",
        .addr = A_POR_MPU_M6_PRLAR14_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR15_U_RNI_NID260",
        .addr = A_POR_MPU_M6_PRBAR15_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR15_U_RNI_NID260",
        .addr = A_POR_MPU_M6_PRLAR15_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR16_U_RNI_NID260",
        .addr = A_POR_MPU_M6_PRBAR16_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR16_U_RNI_NID260",
        .addr = A_POR_MPU_M6_PRLAR16_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR17_U_RNI_NID260",
        .addr = A_POR_MPU_M6_PRBAR17_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR17_U_RNI_NID260",
        .addr = A_POR_MPU_M6_PRLAR17_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR18_U_RNI_NID260",
        .addr = A_POR_MPU_M6_PRBAR18_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR18_U_RNI_NID260",
        .addr = A_POR_MPU_M6_PRLAR18_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR19_U_RNI_NID260",
        .addr = A_POR_MPU_M6_PRBAR19_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR19_U_RNI_NID260",
        .addr = A_POR_MPU_M6_PRLAR19_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR20_U_RNI_NID260",
        .addr = A_POR_MPU_M6_PRBAR20_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR20_U_RNI_NID260",
        .addr = A_POR_MPU_M6_PRLAR20_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR21_U_RNI_NID260",
        .addr = A_POR_MPU_M6_PRBAR21_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR21_U_RNI_NID260",
        .addr = A_POR_MPU_M6_PRLAR21_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR22_U_RNI_NID260",
        .addr = A_POR_MPU_M6_PRBAR22_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR22_U_RNI_NID260",
        .addr = A_POR_MPU_M6_PRLAR22_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR23_U_RNI_NID260",
        .addr = A_POR_MPU_M6_PRBAR23_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR23_U_RNI_NID260",
        .addr = A_POR_MPU_M6_PRLAR23_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR24_U_RNI_NID260",
        .addr = A_POR_MPU_M6_PRBAR24_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR24_U_RNI_NID260",
        .addr = A_POR_MPU_M6_PRLAR24_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR25_U_RNI_NID260",
        .addr = A_POR_MPU_M6_PRBAR25_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR25_U_RNI_NID260",
        .addr = A_POR_MPU_M6_PRLAR25_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR26_U_RNI_NID260",
        .addr = A_POR_MPU_M6_PRBAR26_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR26_U_RNI_NID260",
        .addr = A_POR_MPU_M6_PRLAR26_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR27_U_RNI_NID260",
        .addr = A_POR_MPU_M6_PRBAR27_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR27_U_RNI_NID260",
        .addr = A_POR_MPU_M6_PRLAR27_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR28_U_RNI_NID260",
        .addr = A_POR_MPU_M6_PRBAR28_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR28_U_RNI_NID260",
        .addr = A_POR_MPU_M6_PRLAR28_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR29_U_RNI_NID260",
        .addr = A_POR_MPU_M6_PRBAR29_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR29_U_RNI_NID260",
        .addr = A_POR_MPU_M6_PRLAR29_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR30_U_RNI_NID260",
        .addr = A_POR_MPU_M6_PRBAR30_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR30_U_RNI_NID260",
        .addr = A_POR_MPU_M6_PRLAR30_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR31_U_RNI_NID260",
        .addr = A_POR_MPU_M6_PRBAR31_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR31_U_RNI_NID260",
        .addr = A_POR_MPU_M6_PRLAR31_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_CTL_U_RNI_NID260",
        .addr = A_POR_MPU_M7_CTL_U_RNI_NID260,
        .reset = 0x2,
        .rsvd = 0xfffffffffffffff8L,
        .ro = 0xfffffffffffffff8L,
    },{ .name = "POR_MPU_M7_PRBAR0_U_RNI_NID260",
        .addr = A_POR_MPU_M7_PRBAR0_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR0_U_RNI_NID260",
        .addr = A_POR_MPU_M7_PRLAR0_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR1_U_RNI_NID260",
        .addr = A_POR_MPU_M7_PRBAR1_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR1_U_RNI_NID260",
        .addr = A_POR_MPU_M7_PRLAR1_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR2_U_RNI_NID260",
        .addr = A_POR_MPU_M7_PRBAR2_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR2_U_RNI_NID260",
        .addr = A_POR_MPU_M7_PRLAR2_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR3_U_RNI_NID260",
        .addr = A_POR_MPU_M7_PRBAR3_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR3_U_RNI_NID260",
        .addr = A_POR_MPU_M7_PRLAR3_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR4_U_RNI_NID260",
        .addr = A_POR_MPU_M7_PRBAR4_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR4_U_RNI_NID260",
        .addr = A_POR_MPU_M7_PRLAR4_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR5_U_RNI_NID260",
        .addr = A_POR_MPU_M7_PRBAR5_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR5_U_RNI_NID260",
        .addr = A_POR_MPU_M7_PRLAR5_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR6_U_RNI_NID260",
        .addr = A_POR_MPU_M7_PRBAR6_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR6_U_RNI_NID260",
        .addr = A_POR_MPU_M7_PRLAR6_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR7_U_RNI_NID260",
        .addr = A_POR_MPU_M7_PRBAR7_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR7_U_RNI_NID260",
        .addr = A_POR_MPU_M7_PRLAR7_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR8_U_RNI_NID260",
        .addr = A_POR_MPU_M7_PRBAR8_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR8_U_RNI_NID260",
        .addr = A_POR_MPU_M7_PRLAR8_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR9_U_RNI_NID260",
        .addr = A_POR_MPU_M7_PRBAR9_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR9_U_RNI_NID260",
        .addr = A_POR_MPU_M7_PRLAR9_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR10_U_RNI_NID260",
        .addr = A_POR_MPU_M7_PRBAR10_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR10_U_RNI_NID260",
        .addr = A_POR_MPU_M7_PRLAR10_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR11_U_RNI_NID260",
        .addr = A_POR_MPU_M7_PRBAR11_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR11_U_RNI_NID260",
        .addr = A_POR_MPU_M7_PRLAR11_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR12_U_RNI_NID260",
        .addr = A_POR_MPU_M7_PRBAR12_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR12_U_RNI_NID260",
        .addr = A_POR_MPU_M7_PRLAR12_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR13_U_RNI_NID260",
        .addr = A_POR_MPU_M7_PRBAR13_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR13_U_RNI_NID260",
        .addr = A_POR_MPU_M7_PRLAR13_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR14_U_RNI_NID260",
        .addr = A_POR_MPU_M7_PRBAR14_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR14_U_RNI_NID260",
        .addr = A_POR_MPU_M7_PRLAR14_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR15_U_RNI_NID260",
        .addr = A_POR_MPU_M7_PRBAR15_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR15_U_RNI_NID260",
        .addr = A_POR_MPU_M7_PRLAR15_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR16_U_RNI_NID260",
        .addr = A_POR_MPU_M7_PRBAR16_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR16_U_RNI_NID260",
        .addr = A_POR_MPU_M7_PRLAR16_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR17_U_RNI_NID260",
        .addr = A_POR_MPU_M7_PRBAR17_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR17_U_RNI_NID260",
        .addr = A_POR_MPU_M7_PRLAR17_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR18_U_RNI_NID260",
        .addr = A_POR_MPU_M7_PRBAR18_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR18_U_RNI_NID260",
        .addr = A_POR_MPU_M7_PRLAR18_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR19_U_RNI_NID260",
        .addr = A_POR_MPU_M7_PRBAR19_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR19_U_RNI_NID260",
        .addr = A_POR_MPU_M7_PRLAR19_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR20_U_RNI_NID260",
        .addr = A_POR_MPU_M7_PRBAR20_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR20_U_RNI_NID260",
        .addr = A_POR_MPU_M7_PRLAR20_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR21_U_RNI_NID260",
        .addr = A_POR_MPU_M7_PRBAR21_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR21_U_RNI_NID260",
        .addr = A_POR_MPU_M7_PRLAR21_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR22_U_RNI_NID260",
        .addr = A_POR_MPU_M7_PRBAR22_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR22_U_RNI_NID260",
        .addr = A_POR_MPU_M7_PRLAR22_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR23_U_RNI_NID260",
        .addr = A_POR_MPU_M7_PRBAR23_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR23_U_RNI_NID260",
        .addr = A_POR_MPU_M7_PRLAR23_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR24_U_RNI_NID260",
        .addr = A_POR_MPU_M7_PRBAR24_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR24_U_RNI_NID260",
        .addr = A_POR_MPU_M7_PRLAR24_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR25_U_RNI_NID260",
        .addr = A_POR_MPU_M7_PRBAR25_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR25_U_RNI_NID260",
        .addr = A_POR_MPU_M7_PRLAR25_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR26_U_RNI_NID260",
        .addr = A_POR_MPU_M7_PRBAR26_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR26_U_RNI_NID260",
        .addr = A_POR_MPU_M7_PRLAR26_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR27_U_RNI_NID260",
        .addr = A_POR_MPU_M7_PRBAR27_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR27_U_RNI_NID260",
        .addr = A_POR_MPU_M7_PRLAR27_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR28_U_RNI_NID260",
        .addr = A_POR_MPU_M7_PRBAR28_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR28_U_RNI_NID260",
        .addr = A_POR_MPU_M7_PRLAR28_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR29_U_RNI_NID260",
        .addr = A_POR_MPU_M7_PRBAR29_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR29_U_RNI_NID260",
        .addr = A_POR_MPU_M7_PRLAR29_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR30_U_RNI_NID260",
        .addr = A_POR_MPU_M7_PRBAR30_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR30_U_RNI_NID260",
        .addr = A_POR_MPU_M7_PRLAR30_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR31_U_RNI_NID260",
        .addr = A_POR_MPU_M7_PRBAR31_U_RNI_NID260,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR31_U_RNI_NID260",
        .addr = A_POR_MPU_M7_PRLAR31_U_RNI_NID260,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_NODE_INFO_U_SMXP_4_0",
        .addr = A_POR_MPU_NODE_INFO_U_SMXP_4_0,
        .reset = 0x202,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MPU_CHILD_INFO_U_SMXP_4_0",
        .addr = A_POR_MPU_CHILD_INFO_U_SMXP_4_0,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MPU_UNIT_INFO_U_SMXP_4_0",
        .addr = A_POR_MPU_UNIT_INFO_U_SMXP_4_0,
        .reset = 0x20,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MPU_M0_CTL_U_SMXP_4_0",
        .addr = A_POR_MPU_M0_CTL_U_SMXP_4_0,
        .reset = 0x2,
        .rsvd = 0xfffffffffffffff8L,
        .ro = 0xfffffffffffffff8L,
    },{ .name = "POR_MPU_M0_PRBAR0_U_SMXP_4_0",
        .addr = A_POR_MPU_M0_PRBAR0_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR0_U_SMXP_4_0",
        .addr = A_POR_MPU_M0_PRLAR0_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR1_U_SMXP_4_0",
        .addr = A_POR_MPU_M0_PRBAR1_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR1_U_SMXP_4_0",
        .addr = A_POR_MPU_M0_PRLAR1_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR2_U_SMXP_4_0",
        .addr = A_POR_MPU_M0_PRBAR2_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR2_U_SMXP_4_0",
        .addr = A_POR_MPU_M0_PRLAR2_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR3_U_SMXP_4_0",
        .addr = A_POR_MPU_M0_PRBAR3_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR3_U_SMXP_4_0",
        .addr = A_POR_MPU_M0_PRLAR3_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR4_U_SMXP_4_0",
        .addr = A_POR_MPU_M0_PRBAR4_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR4_U_SMXP_4_0",
        .addr = A_POR_MPU_M0_PRLAR4_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR5_U_SMXP_4_0",
        .addr = A_POR_MPU_M0_PRBAR5_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR5_U_SMXP_4_0",
        .addr = A_POR_MPU_M0_PRLAR5_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR6_U_SMXP_4_0",
        .addr = A_POR_MPU_M0_PRBAR6_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR6_U_SMXP_4_0",
        .addr = A_POR_MPU_M0_PRLAR6_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR7_U_SMXP_4_0",
        .addr = A_POR_MPU_M0_PRBAR7_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR7_U_SMXP_4_0",
        .addr = A_POR_MPU_M0_PRLAR7_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR8_U_SMXP_4_0",
        .addr = A_POR_MPU_M0_PRBAR8_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR8_U_SMXP_4_0",
        .addr = A_POR_MPU_M0_PRLAR8_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR9_U_SMXP_4_0",
        .addr = A_POR_MPU_M0_PRBAR9_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR9_U_SMXP_4_0",
        .addr = A_POR_MPU_M0_PRLAR9_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR10_U_SMXP_4_0",
        .addr = A_POR_MPU_M0_PRBAR10_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR10_U_SMXP_4_0",
        .addr = A_POR_MPU_M0_PRLAR10_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR11_U_SMXP_4_0",
        .addr = A_POR_MPU_M0_PRBAR11_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR11_U_SMXP_4_0",
        .addr = A_POR_MPU_M0_PRLAR11_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR12_U_SMXP_4_0",
        .addr = A_POR_MPU_M0_PRBAR12_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR12_U_SMXP_4_0",
        .addr = A_POR_MPU_M0_PRLAR12_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR13_U_SMXP_4_0",
        .addr = A_POR_MPU_M0_PRBAR13_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR13_U_SMXP_4_0",
        .addr = A_POR_MPU_M0_PRLAR13_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR14_U_SMXP_4_0",
        .addr = A_POR_MPU_M0_PRBAR14_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR14_U_SMXP_4_0",
        .addr = A_POR_MPU_M0_PRLAR14_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR15_U_SMXP_4_0",
        .addr = A_POR_MPU_M0_PRBAR15_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR15_U_SMXP_4_0",
        .addr = A_POR_MPU_M0_PRLAR15_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR16_U_SMXP_4_0",
        .addr = A_POR_MPU_M0_PRBAR16_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR16_U_SMXP_4_0",
        .addr = A_POR_MPU_M0_PRLAR16_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR17_U_SMXP_4_0",
        .addr = A_POR_MPU_M0_PRBAR17_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR17_U_SMXP_4_0",
        .addr = A_POR_MPU_M0_PRLAR17_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR18_U_SMXP_4_0",
        .addr = A_POR_MPU_M0_PRBAR18_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR18_U_SMXP_4_0",
        .addr = A_POR_MPU_M0_PRLAR18_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR19_U_SMXP_4_0",
        .addr = A_POR_MPU_M0_PRBAR19_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR19_U_SMXP_4_0",
        .addr = A_POR_MPU_M0_PRLAR19_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR20_U_SMXP_4_0",
        .addr = A_POR_MPU_M0_PRBAR20_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR20_U_SMXP_4_0",
        .addr = A_POR_MPU_M0_PRLAR20_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR21_U_SMXP_4_0",
        .addr = A_POR_MPU_M0_PRBAR21_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR21_U_SMXP_4_0",
        .addr = A_POR_MPU_M0_PRLAR21_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR22_U_SMXP_4_0",
        .addr = A_POR_MPU_M0_PRBAR22_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR22_U_SMXP_4_0",
        .addr = A_POR_MPU_M0_PRLAR22_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR23_U_SMXP_4_0",
        .addr = A_POR_MPU_M0_PRBAR23_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR23_U_SMXP_4_0",
        .addr = A_POR_MPU_M0_PRLAR23_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR24_U_SMXP_4_0",
        .addr = A_POR_MPU_M0_PRBAR24_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR24_U_SMXP_4_0",
        .addr = A_POR_MPU_M0_PRLAR24_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR25_U_SMXP_4_0",
        .addr = A_POR_MPU_M0_PRBAR25_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR25_U_SMXP_4_0",
        .addr = A_POR_MPU_M0_PRLAR25_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR26_U_SMXP_4_0",
        .addr = A_POR_MPU_M0_PRBAR26_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR26_U_SMXP_4_0",
        .addr = A_POR_MPU_M0_PRLAR26_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR27_U_SMXP_4_0",
        .addr = A_POR_MPU_M0_PRBAR27_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR27_U_SMXP_4_0",
        .addr = A_POR_MPU_M0_PRLAR27_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR28_U_SMXP_4_0",
        .addr = A_POR_MPU_M0_PRBAR28_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR28_U_SMXP_4_0",
        .addr = A_POR_MPU_M0_PRLAR28_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR29_U_SMXP_4_0",
        .addr = A_POR_MPU_M0_PRBAR29_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR29_U_SMXP_4_0",
        .addr = A_POR_MPU_M0_PRLAR29_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR30_U_SMXP_4_0",
        .addr = A_POR_MPU_M0_PRBAR30_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR30_U_SMXP_4_0",
        .addr = A_POR_MPU_M0_PRLAR30_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR31_U_SMXP_4_0",
        .addr = A_POR_MPU_M0_PRBAR31_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR31_U_SMXP_4_0",
        .addr = A_POR_MPU_M0_PRLAR31_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_CTL_U_SMXP_4_0",
        .addr = A_POR_MPU_M1_CTL_U_SMXP_4_0,
        .reset = 0x2,
        .rsvd = 0xfffffffffffffff8L,
        .ro = 0xfffffffffffffff8L,
    },{ .name = "POR_MPU_M1_PRBAR0_U_SMXP_4_0",
        .addr = A_POR_MPU_M1_PRBAR0_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR0_U_SMXP_4_0",
        .addr = A_POR_MPU_M1_PRLAR0_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR1_U_SMXP_4_0",
        .addr = A_POR_MPU_M1_PRBAR1_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR1_U_SMXP_4_0",
        .addr = A_POR_MPU_M1_PRLAR1_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR2_U_SMXP_4_0",
        .addr = A_POR_MPU_M1_PRBAR2_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR2_U_SMXP_4_0",
        .addr = A_POR_MPU_M1_PRLAR2_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR3_U_SMXP_4_0",
        .addr = A_POR_MPU_M1_PRBAR3_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR3_U_SMXP_4_0",
        .addr = A_POR_MPU_M1_PRLAR3_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR4_U_SMXP_4_0",
        .addr = A_POR_MPU_M1_PRBAR4_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR4_U_SMXP_4_0",
        .addr = A_POR_MPU_M1_PRLAR4_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR5_U_SMXP_4_0",
        .addr = A_POR_MPU_M1_PRBAR5_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR5_U_SMXP_4_0",
        .addr = A_POR_MPU_M1_PRLAR5_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR6_U_SMXP_4_0",
        .addr = A_POR_MPU_M1_PRBAR6_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR6_U_SMXP_4_0",
        .addr = A_POR_MPU_M1_PRLAR6_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR7_U_SMXP_4_0",
        .addr = A_POR_MPU_M1_PRBAR7_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR7_U_SMXP_4_0",
        .addr = A_POR_MPU_M1_PRLAR7_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR8_U_SMXP_4_0",
        .addr = A_POR_MPU_M1_PRBAR8_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR8_U_SMXP_4_0",
        .addr = A_POR_MPU_M1_PRLAR8_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR9_U_SMXP_4_0",
        .addr = A_POR_MPU_M1_PRBAR9_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR9_U_SMXP_4_0",
        .addr = A_POR_MPU_M1_PRLAR9_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR10_U_SMXP_4_0",
        .addr = A_POR_MPU_M1_PRBAR10_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR10_U_SMXP_4_0",
        .addr = A_POR_MPU_M1_PRLAR10_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR11_U_SMXP_4_0",
        .addr = A_POR_MPU_M1_PRBAR11_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR11_U_SMXP_4_0",
        .addr = A_POR_MPU_M1_PRLAR11_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR12_U_SMXP_4_0",
        .addr = A_POR_MPU_M1_PRBAR12_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR12_U_SMXP_4_0",
        .addr = A_POR_MPU_M1_PRLAR12_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR13_U_SMXP_4_0",
        .addr = A_POR_MPU_M1_PRBAR13_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR13_U_SMXP_4_0",
        .addr = A_POR_MPU_M1_PRLAR13_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR14_U_SMXP_4_0",
        .addr = A_POR_MPU_M1_PRBAR14_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR14_U_SMXP_4_0",
        .addr = A_POR_MPU_M1_PRLAR14_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR15_U_SMXP_4_0",
        .addr = A_POR_MPU_M1_PRBAR15_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR15_U_SMXP_4_0",
        .addr = A_POR_MPU_M1_PRLAR15_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR16_U_SMXP_4_0",
        .addr = A_POR_MPU_M1_PRBAR16_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR16_U_SMXP_4_0",
        .addr = A_POR_MPU_M1_PRLAR16_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR17_U_SMXP_4_0",
        .addr = A_POR_MPU_M1_PRBAR17_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR17_U_SMXP_4_0",
        .addr = A_POR_MPU_M1_PRLAR17_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR18_U_SMXP_4_0",
        .addr = A_POR_MPU_M1_PRBAR18_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR18_U_SMXP_4_0",
        .addr = A_POR_MPU_M1_PRLAR18_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR19_U_SMXP_4_0",
        .addr = A_POR_MPU_M1_PRBAR19_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR19_U_SMXP_4_0",
        .addr = A_POR_MPU_M1_PRLAR19_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR20_U_SMXP_4_0",
        .addr = A_POR_MPU_M1_PRBAR20_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR20_U_SMXP_4_0",
        .addr = A_POR_MPU_M1_PRLAR20_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR21_U_SMXP_4_0",
        .addr = A_POR_MPU_M1_PRBAR21_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR21_U_SMXP_4_0",
        .addr = A_POR_MPU_M1_PRLAR21_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR22_U_SMXP_4_0",
        .addr = A_POR_MPU_M1_PRBAR22_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR22_U_SMXP_4_0",
        .addr = A_POR_MPU_M1_PRLAR22_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR23_U_SMXP_4_0",
        .addr = A_POR_MPU_M1_PRBAR23_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR23_U_SMXP_4_0",
        .addr = A_POR_MPU_M1_PRLAR23_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR24_U_SMXP_4_0",
        .addr = A_POR_MPU_M1_PRBAR24_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR24_U_SMXP_4_0",
        .addr = A_POR_MPU_M1_PRLAR24_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR25_U_SMXP_4_0",
        .addr = A_POR_MPU_M1_PRBAR25_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR25_U_SMXP_4_0",
        .addr = A_POR_MPU_M1_PRLAR25_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR26_U_SMXP_4_0",
        .addr = A_POR_MPU_M1_PRBAR26_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR26_U_SMXP_4_0",
        .addr = A_POR_MPU_M1_PRLAR26_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR27_U_SMXP_4_0",
        .addr = A_POR_MPU_M1_PRBAR27_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR27_U_SMXP_4_0",
        .addr = A_POR_MPU_M1_PRLAR27_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR28_U_SMXP_4_0",
        .addr = A_POR_MPU_M1_PRBAR28_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR28_U_SMXP_4_0",
        .addr = A_POR_MPU_M1_PRLAR28_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR29_U_SMXP_4_0",
        .addr = A_POR_MPU_M1_PRBAR29_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR29_U_SMXP_4_0",
        .addr = A_POR_MPU_M1_PRLAR29_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR30_U_SMXP_4_0",
        .addr = A_POR_MPU_M1_PRBAR30_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR30_U_SMXP_4_0",
        .addr = A_POR_MPU_M1_PRLAR30_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR31_U_SMXP_4_0",
        .addr = A_POR_MPU_M1_PRBAR31_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR31_U_SMXP_4_0",
        .addr = A_POR_MPU_M1_PRLAR31_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_CTL_U_SMXP_4_0",
        .addr = A_POR_MPU_M2_CTL_U_SMXP_4_0,
        .reset = 0x2,
        .rsvd = 0xfffffffffffffff8L,
        .ro = 0xfffffffffffffff8L,
    },{ .name = "POR_MPU_M2_PRBAR0_U_SMXP_4_0",
        .addr = A_POR_MPU_M2_PRBAR0_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR0_U_SMXP_4_0",
        .addr = A_POR_MPU_M2_PRLAR0_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR1_U_SMXP_4_0",
        .addr = A_POR_MPU_M2_PRBAR1_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR1_U_SMXP_4_0",
        .addr = A_POR_MPU_M2_PRLAR1_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR2_U_SMXP_4_0",
        .addr = A_POR_MPU_M2_PRBAR2_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR2_U_SMXP_4_0",
        .addr = A_POR_MPU_M2_PRLAR2_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR3_U_SMXP_4_0",
        .addr = A_POR_MPU_M2_PRBAR3_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR3_U_SMXP_4_0",
        .addr = A_POR_MPU_M2_PRLAR3_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR4_U_SMXP_4_0",
        .addr = A_POR_MPU_M2_PRBAR4_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR4_U_SMXP_4_0",
        .addr = A_POR_MPU_M2_PRLAR4_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR5_U_SMXP_4_0",
        .addr = A_POR_MPU_M2_PRBAR5_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR5_U_SMXP_4_0",
        .addr = A_POR_MPU_M2_PRLAR5_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR6_U_SMXP_4_0",
        .addr = A_POR_MPU_M2_PRBAR6_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR6_U_SMXP_4_0",
        .addr = A_POR_MPU_M2_PRLAR6_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR7_U_SMXP_4_0",
        .addr = A_POR_MPU_M2_PRBAR7_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR7_U_SMXP_4_0",
        .addr = A_POR_MPU_M2_PRLAR7_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR8_U_SMXP_4_0",
        .addr = A_POR_MPU_M2_PRBAR8_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR8_U_SMXP_4_0",
        .addr = A_POR_MPU_M2_PRLAR8_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR9_U_SMXP_4_0",
        .addr = A_POR_MPU_M2_PRBAR9_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR9_U_SMXP_4_0",
        .addr = A_POR_MPU_M2_PRLAR9_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR10_U_SMXP_4_0",
        .addr = A_POR_MPU_M2_PRBAR10_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR10_U_SMXP_4_0",
        .addr = A_POR_MPU_M2_PRLAR10_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR11_U_SMXP_4_0",
        .addr = A_POR_MPU_M2_PRBAR11_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR11_U_SMXP_4_0",
        .addr = A_POR_MPU_M2_PRLAR11_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR12_U_SMXP_4_0",
        .addr = A_POR_MPU_M2_PRBAR12_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR12_U_SMXP_4_0",
        .addr = A_POR_MPU_M2_PRLAR12_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR13_U_SMXP_4_0",
        .addr = A_POR_MPU_M2_PRBAR13_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR13_U_SMXP_4_0",
        .addr = A_POR_MPU_M2_PRLAR13_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR14_U_SMXP_4_0",
        .addr = A_POR_MPU_M2_PRBAR14_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR14_U_SMXP_4_0",
        .addr = A_POR_MPU_M2_PRLAR14_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR15_U_SMXP_4_0",
        .addr = A_POR_MPU_M2_PRBAR15_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR15_U_SMXP_4_0",
        .addr = A_POR_MPU_M2_PRLAR15_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR16_U_SMXP_4_0",
        .addr = A_POR_MPU_M2_PRBAR16_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR16_U_SMXP_4_0",
        .addr = A_POR_MPU_M2_PRLAR16_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR17_U_SMXP_4_0",
        .addr = A_POR_MPU_M2_PRBAR17_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR17_U_SMXP_4_0",
        .addr = A_POR_MPU_M2_PRLAR17_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR18_U_SMXP_4_0",
        .addr = A_POR_MPU_M2_PRBAR18_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR18_U_SMXP_4_0",
        .addr = A_POR_MPU_M2_PRLAR18_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR19_U_SMXP_4_0",
        .addr = A_POR_MPU_M2_PRBAR19_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR19_U_SMXP_4_0",
        .addr = A_POR_MPU_M2_PRLAR19_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR20_U_SMXP_4_0",
        .addr = A_POR_MPU_M2_PRBAR20_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR20_U_SMXP_4_0",
        .addr = A_POR_MPU_M2_PRLAR20_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR21_U_SMXP_4_0",
        .addr = A_POR_MPU_M2_PRBAR21_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR21_U_SMXP_4_0",
        .addr = A_POR_MPU_M2_PRLAR21_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR22_U_SMXP_4_0",
        .addr = A_POR_MPU_M2_PRBAR22_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR22_U_SMXP_4_0",
        .addr = A_POR_MPU_M2_PRLAR22_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR23_U_SMXP_4_0",
        .addr = A_POR_MPU_M2_PRBAR23_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR23_U_SMXP_4_0",
        .addr = A_POR_MPU_M2_PRLAR23_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR24_U_SMXP_4_0",
        .addr = A_POR_MPU_M2_PRBAR24_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR24_U_SMXP_4_0",
        .addr = A_POR_MPU_M2_PRLAR24_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR25_U_SMXP_4_0",
        .addr = A_POR_MPU_M2_PRBAR25_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR25_U_SMXP_4_0",
        .addr = A_POR_MPU_M2_PRLAR25_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR26_U_SMXP_4_0",
        .addr = A_POR_MPU_M2_PRBAR26_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR26_U_SMXP_4_0",
        .addr = A_POR_MPU_M2_PRLAR26_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR27_U_SMXP_4_0",
        .addr = A_POR_MPU_M2_PRBAR27_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR27_U_SMXP_4_0",
        .addr = A_POR_MPU_M2_PRLAR27_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR28_U_SMXP_4_0",
        .addr = A_POR_MPU_M2_PRBAR28_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR28_U_SMXP_4_0",
        .addr = A_POR_MPU_M2_PRLAR28_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR29_U_SMXP_4_0",
        .addr = A_POR_MPU_M2_PRBAR29_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR29_U_SMXP_4_0",
        .addr = A_POR_MPU_M2_PRLAR29_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR30_U_SMXP_4_0",
        .addr = A_POR_MPU_M2_PRBAR30_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR30_U_SMXP_4_0",
        .addr = A_POR_MPU_M2_PRLAR30_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR31_U_SMXP_4_0",
        .addr = A_POR_MPU_M2_PRBAR31_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR31_U_SMXP_4_0",
        .addr = A_POR_MPU_M2_PRLAR31_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_CTL_U_SMXP_4_0",
        .addr = A_POR_MPU_M3_CTL_U_SMXP_4_0,
        .reset = 0x2,
        .rsvd = 0xfffffffffffffff8L,
        .ro = 0xfffffffffffffff8L,
    },{ .name = "POR_MPU_M3_PRBAR0_U_SMXP_4_0",
        .addr = A_POR_MPU_M3_PRBAR0_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR0_U_SMXP_4_0",
        .addr = A_POR_MPU_M3_PRLAR0_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR1_U_SMXP_4_0",
        .addr = A_POR_MPU_M3_PRBAR1_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR1_U_SMXP_4_0",
        .addr = A_POR_MPU_M3_PRLAR1_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR2_U_SMXP_4_0",
        .addr = A_POR_MPU_M3_PRBAR2_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR2_U_SMXP_4_0",
        .addr = A_POR_MPU_M3_PRLAR2_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR3_U_SMXP_4_0",
        .addr = A_POR_MPU_M3_PRBAR3_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR3_U_SMXP_4_0",
        .addr = A_POR_MPU_M3_PRLAR3_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR4_U_SMXP_4_0",
        .addr = A_POR_MPU_M3_PRBAR4_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR4_U_SMXP_4_0",
        .addr = A_POR_MPU_M3_PRLAR4_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR5_U_SMXP_4_0",
        .addr = A_POR_MPU_M3_PRBAR5_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR5_U_SMXP_4_0",
        .addr = A_POR_MPU_M3_PRLAR5_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR6_U_SMXP_4_0",
        .addr = A_POR_MPU_M3_PRBAR6_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR6_U_SMXP_4_0",
        .addr = A_POR_MPU_M3_PRLAR6_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR7_U_SMXP_4_0",
        .addr = A_POR_MPU_M3_PRBAR7_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR7_U_SMXP_4_0",
        .addr = A_POR_MPU_M3_PRLAR7_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR8_U_SMXP_4_0",
        .addr = A_POR_MPU_M3_PRBAR8_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR8_U_SMXP_4_0",
        .addr = A_POR_MPU_M3_PRLAR8_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR9_U_SMXP_4_0",
        .addr = A_POR_MPU_M3_PRBAR9_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR9_U_SMXP_4_0",
        .addr = A_POR_MPU_M3_PRLAR9_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR10_U_SMXP_4_0",
        .addr = A_POR_MPU_M3_PRBAR10_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR10_U_SMXP_4_0",
        .addr = A_POR_MPU_M3_PRLAR10_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR11_U_SMXP_4_0",
        .addr = A_POR_MPU_M3_PRBAR11_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR11_U_SMXP_4_0",
        .addr = A_POR_MPU_M3_PRLAR11_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR12_U_SMXP_4_0",
        .addr = A_POR_MPU_M3_PRBAR12_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR12_U_SMXP_4_0",
        .addr = A_POR_MPU_M3_PRLAR12_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR13_U_SMXP_4_0",
        .addr = A_POR_MPU_M3_PRBAR13_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR13_U_SMXP_4_0",
        .addr = A_POR_MPU_M3_PRLAR13_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR14_U_SMXP_4_0",
        .addr = A_POR_MPU_M3_PRBAR14_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR14_U_SMXP_4_0",
        .addr = A_POR_MPU_M3_PRLAR14_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR15_U_SMXP_4_0",
        .addr = A_POR_MPU_M3_PRBAR15_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR15_U_SMXP_4_0",
        .addr = A_POR_MPU_M3_PRLAR15_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR16_U_SMXP_4_0",
        .addr = A_POR_MPU_M3_PRBAR16_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR16_U_SMXP_4_0",
        .addr = A_POR_MPU_M3_PRLAR16_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR17_U_SMXP_4_0",
        .addr = A_POR_MPU_M3_PRBAR17_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR17_U_SMXP_4_0",
        .addr = A_POR_MPU_M3_PRLAR17_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR18_U_SMXP_4_0",
        .addr = A_POR_MPU_M3_PRBAR18_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR18_U_SMXP_4_0",
        .addr = A_POR_MPU_M3_PRLAR18_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR19_U_SMXP_4_0",
        .addr = A_POR_MPU_M3_PRBAR19_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR19_U_SMXP_4_0",
        .addr = A_POR_MPU_M3_PRLAR19_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR20_U_SMXP_4_0",
        .addr = A_POR_MPU_M3_PRBAR20_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR20_U_SMXP_4_0",
        .addr = A_POR_MPU_M3_PRLAR20_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR21_U_SMXP_4_0",
        .addr = A_POR_MPU_M3_PRBAR21_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR21_U_SMXP_4_0",
        .addr = A_POR_MPU_M3_PRLAR21_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR22_U_SMXP_4_0",
        .addr = A_POR_MPU_M3_PRBAR22_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR22_U_SMXP_4_0",
        .addr = A_POR_MPU_M3_PRLAR22_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR23_U_SMXP_4_0",
        .addr = A_POR_MPU_M3_PRBAR23_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR23_U_SMXP_4_0",
        .addr = A_POR_MPU_M3_PRLAR23_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR24_U_SMXP_4_0",
        .addr = A_POR_MPU_M3_PRBAR24_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR24_U_SMXP_4_0",
        .addr = A_POR_MPU_M3_PRLAR24_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR25_U_SMXP_4_0",
        .addr = A_POR_MPU_M3_PRBAR25_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR25_U_SMXP_4_0",
        .addr = A_POR_MPU_M3_PRLAR25_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR26_U_SMXP_4_0",
        .addr = A_POR_MPU_M3_PRBAR26_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR26_U_SMXP_4_0",
        .addr = A_POR_MPU_M3_PRLAR26_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR27_U_SMXP_4_0",
        .addr = A_POR_MPU_M3_PRBAR27_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR27_U_SMXP_4_0",
        .addr = A_POR_MPU_M3_PRLAR27_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR28_U_SMXP_4_0",
        .addr = A_POR_MPU_M3_PRBAR28_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR28_U_SMXP_4_0",
        .addr = A_POR_MPU_M3_PRLAR28_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR29_U_SMXP_4_0",
        .addr = A_POR_MPU_M3_PRBAR29_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR29_U_SMXP_4_0",
        .addr = A_POR_MPU_M3_PRLAR29_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR30_U_SMXP_4_0",
        .addr = A_POR_MPU_M3_PRBAR30_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR30_U_SMXP_4_0",
        .addr = A_POR_MPU_M3_PRLAR30_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR31_U_SMXP_4_0",
        .addr = A_POR_MPU_M3_PRBAR31_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR31_U_SMXP_4_0",
        .addr = A_POR_MPU_M3_PRLAR31_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_CTL_U_SMXP_4_0",
        .addr = A_POR_MPU_M4_CTL_U_SMXP_4_0,
        .reset = 0x2,
        .rsvd = 0xfffffffffffffff8L,
        .ro = 0xfffffffffffffff8L,
    },{ .name = "POR_MPU_M4_PRBAR0_U_SMXP_4_0",
        .addr = A_POR_MPU_M4_PRBAR0_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR0_U_SMXP_4_0",
        .addr = A_POR_MPU_M4_PRLAR0_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR1_U_SMXP_4_0",
        .addr = A_POR_MPU_M4_PRBAR1_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR1_U_SMXP_4_0",
        .addr = A_POR_MPU_M4_PRLAR1_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR2_U_SMXP_4_0",
        .addr = A_POR_MPU_M4_PRBAR2_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR2_U_SMXP_4_0",
        .addr = A_POR_MPU_M4_PRLAR2_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR3_U_SMXP_4_0",
        .addr = A_POR_MPU_M4_PRBAR3_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR3_U_SMXP_4_0",
        .addr = A_POR_MPU_M4_PRLAR3_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR4_U_SMXP_4_0",
        .addr = A_POR_MPU_M4_PRBAR4_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR4_U_SMXP_4_0",
        .addr = A_POR_MPU_M4_PRLAR4_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR5_U_SMXP_4_0",
        .addr = A_POR_MPU_M4_PRBAR5_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR5_U_SMXP_4_0",
        .addr = A_POR_MPU_M4_PRLAR5_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR6_U_SMXP_4_0",
        .addr = A_POR_MPU_M4_PRBAR6_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR6_U_SMXP_4_0",
        .addr = A_POR_MPU_M4_PRLAR6_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR7_U_SMXP_4_0",
        .addr = A_POR_MPU_M4_PRBAR7_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR7_U_SMXP_4_0",
        .addr = A_POR_MPU_M4_PRLAR7_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR8_U_SMXP_4_0",
        .addr = A_POR_MPU_M4_PRBAR8_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR8_U_SMXP_4_0",
        .addr = A_POR_MPU_M4_PRLAR8_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR9_U_SMXP_4_0",
        .addr = A_POR_MPU_M4_PRBAR9_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR9_U_SMXP_4_0",
        .addr = A_POR_MPU_M4_PRLAR9_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR10_U_SMXP_4_0",
        .addr = A_POR_MPU_M4_PRBAR10_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR10_U_SMXP_4_0",
        .addr = A_POR_MPU_M4_PRLAR10_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR11_U_SMXP_4_0",
        .addr = A_POR_MPU_M4_PRBAR11_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR11_U_SMXP_4_0",
        .addr = A_POR_MPU_M4_PRLAR11_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR12_U_SMXP_4_0",
        .addr = A_POR_MPU_M4_PRBAR12_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR12_U_SMXP_4_0",
        .addr = A_POR_MPU_M4_PRLAR12_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR13_U_SMXP_4_0",
        .addr = A_POR_MPU_M4_PRBAR13_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR13_U_SMXP_4_0",
        .addr = A_POR_MPU_M4_PRLAR13_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR14_U_SMXP_4_0",
        .addr = A_POR_MPU_M4_PRBAR14_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR14_U_SMXP_4_0",
        .addr = A_POR_MPU_M4_PRLAR14_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR15_U_SMXP_4_0",
        .addr = A_POR_MPU_M4_PRBAR15_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR15_U_SMXP_4_0",
        .addr = A_POR_MPU_M4_PRLAR15_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR16_U_SMXP_4_0",
        .addr = A_POR_MPU_M4_PRBAR16_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR16_U_SMXP_4_0",
        .addr = A_POR_MPU_M4_PRLAR16_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR17_U_SMXP_4_0",
        .addr = A_POR_MPU_M4_PRBAR17_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR17_U_SMXP_4_0",
        .addr = A_POR_MPU_M4_PRLAR17_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR18_U_SMXP_4_0",
        .addr = A_POR_MPU_M4_PRBAR18_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR18_U_SMXP_4_0",
        .addr = A_POR_MPU_M4_PRLAR18_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR19_U_SMXP_4_0",
        .addr = A_POR_MPU_M4_PRBAR19_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR19_U_SMXP_4_0",
        .addr = A_POR_MPU_M4_PRLAR19_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR20_U_SMXP_4_0",
        .addr = A_POR_MPU_M4_PRBAR20_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR20_U_SMXP_4_0",
        .addr = A_POR_MPU_M4_PRLAR20_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR21_U_SMXP_4_0",
        .addr = A_POR_MPU_M4_PRBAR21_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR21_U_SMXP_4_0",
        .addr = A_POR_MPU_M4_PRLAR21_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR22_U_SMXP_4_0",
        .addr = A_POR_MPU_M4_PRBAR22_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR22_U_SMXP_4_0",
        .addr = A_POR_MPU_M4_PRLAR22_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR23_U_SMXP_4_0",
        .addr = A_POR_MPU_M4_PRBAR23_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR23_U_SMXP_4_0",
        .addr = A_POR_MPU_M4_PRLAR23_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR24_U_SMXP_4_0",
        .addr = A_POR_MPU_M4_PRBAR24_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR24_U_SMXP_4_0",
        .addr = A_POR_MPU_M4_PRLAR24_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR25_U_SMXP_4_0",
        .addr = A_POR_MPU_M4_PRBAR25_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR25_U_SMXP_4_0",
        .addr = A_POR_MPU_M4_PRLAR25_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR26_U_SMXP_4_0",
        .addr = A_POR_MPU_M4_PRBAR26_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR26_U_SMXP_4_0",
        .addr = A_POR_MPU_M4_PRLAR26_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR27_U_SMXP_4_0",
        .addr = A_POR_MPU_M4_PRBAR27_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR27_U_SMXP_4_0",
        .addr = A_POR_MPU_M4_PRLAR27_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR28_U_SMXP_4_0",
        .addr = A_POR_MPU_M4_PRBAR28_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR28_U_SMXP_4_0",
        .addr = A_POR_MPU_M4_PRLAR28_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR29_U_SMXP_4_0",
        .addr = A_POR_MPU_M4_PRBAR29_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR29_U_SMXP_4_0",
        .addr = A_POR_MPU_M4_PRLAR29_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR30_U_SMXP_4_0",
        .addr = A_POR_MPU_M4_PRBAR30_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR30_U_SMXP_4_0",
        .addr = A_POR_MPU_M4_PRLAR30_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR31_U_SMXP_4_0",
        .addr = A_POR_MPU_M4_PRBAR31_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR31_U_SMXP_4_0",
        .addr = A_POR_MPU_M4_PRLAR31_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_CTL_U_SMXP_4_0",
        .addr = A_POR_MPU_M5_CTL_U_SMXP_4_0,
        .reset = 0x2,
        .rsvd = 0xfffffffffffffff8L,
        .ro = 0xfffffffffffffff8L,
    },{ .name = "POR_MPU_M5_PRBAR0_U_SMXP_4_0",
        .addr = A_POR_MPU_M5_PRBAR0_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR0_U_SMXP_4_0",
        .addr = A_POR_MPU_M5_PRLAR0_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR1_U_SMXP_4_0",
        .addr = A_POR_MPU_M5_PRBAR1_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR1_U_SMXP_4_0",
        .addr = A_POR_MPU_M5_PRLAR1_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR2_U_SMXP_4_0",
        .addr = A_POR_MPU_M5_PRBAR2_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR2_U_SMXP_4_0",
        .addr = A_POR_MPU_M5_PRLAR2_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR3_U_SMXP_4_0",
        .addr = A_POR_MPU_M5_PRBAR3_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR3_U_SMXP_4_0",
        .addr = A_POR_MPU_M5_PRLAR3_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR4_U_SMXP_4_0",
        .addr = A_POR_MPU_M5_PRBAR4_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR4_U_SMXP_4_0",
        .addr = A_POR_MPU_M5_PRLAR4_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR5_U_SMXP_4_0",
        .addr = A_POR_MPU_M5_PRBAR5_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR5_U_SMXP_4_0",
        .addr = A_POR_MPU_M5_PRLAR5_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR6_U_SMXP_4_0",
        .addr = A_POR_MPU_M5_PRBAR6_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR6_U_SMXP_4_0",
        .addr = A_POR_MPU_M5_PRLAR6_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR7_U_SMXP_4_0",
        .addr = A_POR_MPU_M5_PRBAR7_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR7_U_SMXP_4_0",
        .addr = A_POR_MPU_M5_PRLAR7_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR8_U_SMXP_4_0",
        .addr = A_POR_MPU_M5_PRBAR8_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR8_U_SMXP_4_0",
        .addr = A_POR_MPU_M5_PRLAR8_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR9_U_SMXP_4_0",
        .addr = A_POR_MPU_M5_PRBAR9_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR9_U_SMXP_4_0",
        .addr = A_POR_MPU_M5_PRLAR9_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR10_U_SMXP_4_0",
        .addr = A_POR_MPU_M5_PRBAR10_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR10_U_SMXP_4_0",
        .addr = A_POR_MPU_M5_PRLAR10_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR11_U_SMXP_4_0",
        .addr = A_POR_MPU_M5_PRBAR11_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR11_U_SMXP_4_0",
        .addr = A_POR_MPU_M5_PRLAR11_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR12_U_SMXP_4_0",
        .addr = A_POR_MPU_M5_PRBAR12_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR12_U_SMXP_4_0",
        .addr = A_POR_MPU_M5_PRLAR12_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR13_U_SMXP_4_0",
        .addr = A_POR_MPU_M5_PRBAR13_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR13_U_SMXP_4_0",
        .addr = A_POR_MPU_M5_PRLAR13_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR14_U_SMXP_4_0",
        .addr = A_POR_MPU_M5_PRBAR14_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR14_U_SMXP_4_0",
        .addr = A_POR_MPU_M5_PRLAR14_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR15_U_SMXP_4_0",
        .addr = A_POR_MPU_M5_PRBAR15_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR15_U_SMXP_4_0",
        .addr = A_POR_MPU_M5_PRLAR15_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR16_U_SMXP_4_0",
        .addr = A_POR_MPU_M5_PRBAR16_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR16_U_SMXP_4_0",
        .addr = A_POR_MPU_M5_PRLAR16_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR17_U_SMXP_4_0",
        .addr = A_POR_MPU_M5_PRBAR17_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR17_U_SMXP_4_0",
        .addr = A_POR_MPU_M5_PRLAR17_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR18_U_SMXP_4_0",
        .addr = A_POR_MPU_M5_PRBAR18_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR18_U_SMXP_4_0",
        .addr = A_POR_MPU_M5_PRLAR18_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR19_U_SMXP_4_0",
        .addr = A_POR_MPU_M5_PRBAR19_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR19_U_SMXP_4_0",
        .addr = A_POR_MPU_M5_PRLAR19_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR20_U_SMXP_4_0",
        .addr = A_POR_MPU_M5_PRBAR20_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR20_U_SMXP_4_0",
        .addr = A_POR_MPU_M5_PRLAR20_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR21_U_SMXP_4_0",
        .addr = A_POR_MPU_M5_PRBAR21_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR21_U_SMXP_4_0",
        .addr = A_POR_MPU_M5_PRLAR21_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR22_U_SMXP_4_0",
        .addr = A_POR_MPU_M5_PRBAR22_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR22_U_SMXP_4_0",
        .addr = A_POR_MPU_M5_PRLAR22_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR23_U_SMXP_4_0",
        .addr = A_POR_MPU_M5_PRBAR23_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR23_U_SMXP_4_0",
        .addr = A_POR_MPU_M5_PRLAR23_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR24_U_SMXP_4_0",
        .addr = A_POR_MPU_M5_PRBAR24_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR24_U_SMXP_4_0",
        .addr = A_POR_MPU_M5_PRLAR24_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR25_U_SMXP_4_0",
        .addr = A_POR_MPU_M5_PRBAR25_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR25_U_SMXP_4_0",
        .addr = A_POR_MPU_M5_PRLAR25_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR26_U_SMXP_4_0",
        .addr = A_POR_MPU_M5_PRBAR26_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR26_U_SMXP_4_0",
        .addr = A_POR_MPU_M5_PRLAR26_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR27_U_SMXP_4_0",
        .addr = A_POR_MPU_M5_PRBAR27_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR27_U_SMXP_4_0",
        .addr = A_POR_MPU_M5_PRLAR27_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR28_U_SMXP_4_0",
        .addr = A_POR_MPU_M5_PRBAR28_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR28_U_SMXP_4_0",
        .addr = A_POR_MPU_M5_PRLAR28_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR29_U_SMXP_4_0",
        .addr = A_POR_MPU_M5_PRBAR29_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR29_U_SMXP_4_0",
        .addr = A_POR_MPU_M5_PRLAR29_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR30_U_SMXP_4_0",
        .addr = A_POR_MPU_M5_PRBAR30_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR30_U_SMXP_4_0",
        .addr = A_POR_MPU_M5_PRLAR30_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR31_U_SMXP_4_0",
        .addr = A_POR_MPU_M5_PRBAR31_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR31_U_SMXP_4_0",
        .addr = A_POR_MPU_M5_PRLAR31_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_CTL_U_SMXP_4_0",
        .addr = A_POR_MPU_M6_CTL_U_SMXP_4_0,
        .reset = 0x2,
        .rsvd = 0xfffffffffffffff8L,
        .ro = 0xfffffffffffffff8L,
    },{ .name = "POR_MPU_M6_PRBAR0_U_SMXP_4_0",
        .addr = A_POR_MPU_M6_PRBAR0_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR0_U_SMXP_4_0",
        .addr = A_POR_MPU_M6_PRLAR0_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR1_U_SMXP_4_0",
        .addr = A_POR_MPU_M6_PRBAR1_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR1_U_SMXP_4_0",
        .addr = A_POR_MPU_M6_PRLAR1_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR2_U_SMXP_4_0",
        .addr = A_POR_MPU_M6_PRBAR2_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR2_U_SMXP_4_0",
        .addr = A_POR_MPU_M6_PRLAR2_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR3_U_SMXP_4_0",
        .addr = A_POR_MPU_M6_PRBAR3_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR3_U_SMXP_4_0",
        .addr = A_POR_MPU_M6_PRLAR3_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR4_U_SMXP_4_0",
        .addr = A_POR_MPU_M6_PRBAR4_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR4_U_SMXP_4_0",
        .addr = A_POR_MPU_M6_PRLAR4_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR5_U_SMXP_4_0",
        .addr = A_POR_MPU_M6_PRBAR5_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR5_U_SMXP_4_0",
        .addr = A_POR_MPU_M6_PRLAR5_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR6_U_SMXP_4_0",
        .addr = A_POR_MPU_M6_PRBAR6_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR6_U_SMXP_4_0",
        .addr = A_POR_MPU_M6_PRLAR6_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR7_U_SMXP_4_0",
        .addr = A_POR_MPU_M6_PRBAR7_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR7_U_SMXP_4_0",
        .addr = A_POR_MPU_M6_PRLAR7_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR8_U_SMXP_4_0",
        .addr = A_POR_MPU_M6_PRBAR8_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR8_U_SMXP_4_0",
        .addr = A_POR_MPU_M6_PRLAR8_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR9_U_SMXP_4_0",
        .addr = A_POR_MPU_M6_PRBAR9_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR9_U_SMXP_4_0",
        .addr = A_POR_MPU_M6_PRLAR9_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR10_U_SMXP_4_0",
        .addr = A_POR_MPU_M6_PRBAR10_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR10_U_SMXP_4_0",
        .addr = A_POR_MPU_M6_PRLAR10_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR11_U_SMXP_4_0",
        .addr = A_POR_MPU_M6_PRBAR11_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR11_U_SMXP_4_0",
        .addr = A_POR_MPU_M6_PRLAR11_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR12_U_SMXP_4_0",
        .addr = A_POR_MPU_M6_PRBAR12_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR12_U_SMXP_4_0",
        .addr = A_POR_MPU_M6_PRLAR12_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR13_U_SMXP_4_0",
        .addr = A_POR_MPU_M6_PRBAR13_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR13_U_SMXP_4_0",
        .addr = A_POR_MPU_M6_PRLAR13_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR14_U_SMXP_4_0",
        .addr = A_POR_MPU_M6_PRBAR14_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR14_U_SMXP_4_0",
        .addr = A_POR_MPU_M6_PRLAR14_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR15_U_SMXP_4_0",
        .addr = A_POR_MPU_M6_PRBAR15_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR15_U_SMXP_4_0",
        .addr = A_POR_MPU_M6_PRLAR15_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR16_U_SMXP_4_0",
        .addr = A_POR_MPU_M6_PRBAR16_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR16_U_SMXP_4_0",
        .addr = A_POR_MPU_M6_PRLAR16_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR17_U_SMXP_4_0",
        .addr = A_POR_MPU_M6_PRBAR17_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR17_U_SMXP_4_0",
        .addr = A_POR_MPU_M6_PRLAR17_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR18_U_SMXP_4_0",
        .addr = A_POR_MPU_M6_PRBAR18_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR18_U_SMXP_4_0",
        .addr = A_POR_MPU_M6_PRLAR18_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR19_U_SMXP_4_0",
        .addr = A_POR_MPU_M6_PRBAR19_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR19_U_SMXP_4_0",
        .addr = A_POR_MPU_M6_PRLAR19_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR20_U_SMXP_4_0",
        .addr = A_POR_MPU_M6_PRBAR20_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR20_U_SMXP_4_0",
        .addr = A_POR_MPU_M6_PRLAR20_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR21_U_SMXP_4_0",
        .addr = A_POR_MPU_M6_PRBAR21_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR21_U_SMXP_4_0",
        .addr = A_POR_MPU_M6_PRLAR21_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR22_U_SMXP_4_0",
        .addr = A_POR_MPU_M6_PRBAR22_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR22_U_SMXP_4_0",
        .addr = A_POR_MPU_M6_PRLAR22_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR23_U_SMXP_4_0",
        .addr = A_POR_MPU_M6_PRBAR23_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR23_U_SMXP_4_0",
        .addr = A_POR_MPU_M6_PRLAR23_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR24_U_SMXP_4_0",
        .addr = A_POR_MPU_M6_PRBAR24_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR24_U_SMXP_4_0",
        .addr = A_POR_MPU_M6_PRLAR24_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR25_U_SMXP_4_0",
        .addr = A_POR_MPU_M6_PRBAR25_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR25_U_SMXP_4_0",
        .addr = A_POR_MPU_M6_PRLAR25_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR26_U_SMXP_4_0",
        .addr = A_POR_MPU_M6_PRBAR26_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR26_U_SMXP_4_0",
        .addr = A_POR_MPU_M6_PRLAR26_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR27_U_SMXP_4_0",
        .addr = A_POR_MPU_M6_PRBAR27_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR27_U_SMXP_4_0",
        .addr = A_POR_MPU_M6_PRLAR27_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR28_U_SMXP_4_0",
        .addr = A_POR_MPU_M6_PRBAR28_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR28_U_SMXP_4_0",
        .addr = A_POR_MPU_M6_PRLAR28_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR29_U_SMXP_4_0",
        .addr = A_POR_MPU_M6_PRBAR29_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR29_U_SMXP_4_0",
        .addr = A_POR_MPU_M6_PRLAR29_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR30_U_SMXP_4_0",
        .addr = A_POR_MPU_M6_PRBAR30_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR30_U_SMXP_4_0",
        .addr = A_POR_MPU_M6_PRLAR30_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR31_U_SMXP_4_0",
        .addr = A_POR_MPU_M6_PRBAR31_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR31_U_SMXP_4_0",
        .addr = A_POR_MPU_M6_PRLAR31_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_CTL_U_SMXP_4_0",
        .addr = A_POR_MPU_M7_CTL_U_SMXP_4_0,
        .reset = 0x2,
        .rsvd = 0xfffffffffffffff8L,
        .ro = 0xfffffffffffffff8L,
    },{ .name = "POR_MPU_M7_PRBAR0_U_SMXP_4_0",
        .addr = A_POR_MPU_M7_PRBAR0_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR0_U_SMXP_4_0",
        .addr = A_POR_MPU_M7_PRLAR0_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR1_U_SMXP_4_0",
        .addr = A_POR_MPU_M7_PRBAR1_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR1_U_SMXP_4_0",
        .addr = A_POR_MPU_M7_PRLAR1_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR2_U_SMXP_4_0",
        .addr = A_POR_MPU_M7_PRBAR2_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR2_U_SMXP_4_0",
        .addr = A_POR_MPU_M7_PRLAR2_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR3_U_SMXP_4_0",
        .addr = A_POR_MPU_M7_PRBAR3_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR3_U_SMXP_4_0",
        .addr = A_POR_MPU_M7_PRLAR3_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR4_U_SMXP_4_0",
        .addr = A_POR_MPU_M7_PRBAR4_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR4_U_SMXP_4_0",
        .addr = A_POR_MPU_M7_PRLAR4_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR5_U_SMXP_4_0",
        .addr = A_POR_MPU_M7_PRBAR5_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR5_U_SMXP_4_0",
        .addr = A_POR_MPU_M7_PRLAR5_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR6_U_SMXP_4_0",
        .addr = A_POR_MPU_M7_PRBAR6_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR6_U_SMXP_4_0",
        .addr = A_POR_MPU_M7_PRLAR6_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR7_U_SMXP_4_0",
        .addr = A_POR_MPU_M7_PRBAR7_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR7_U_SMXP_4_0",
        .addr = A_POR_MPU_M7_PRLAR7_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR8_U_SMXP_4_0",
        .addr = A_POR_MPU_M7_PRBAR8_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR8_U_SMXP_4_0",
        .addr = A_POR_MPU_M7_PRLAR8_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR9_U_SMXP_4_0",
        .addr = A_POR_MPU_M7_PRBAR9_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR9_U_SMXP_4_0",
        .addr = A_POR_MPU_M7_PRLAR9_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR10_U_SMXP_4_0",
        .addr = A_POR_MPU_M7_PRBAR10_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR10_U_SMXP_4_0",
        .addr = A_POR_MPU_M7_PRLAR10_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR11_U_SMXP_4_0",
        .addr = A_POR_MPU_M7_PRBAR11_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR11_U_SMXP_4_0",
        .addr = A_POR_MPU_M7_PRLAR11_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR12_U_SMXP_4_0",
        .addr = A_POR_MPU_M7_PRBAR12_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR12_U_SMXP_4_0",
        .addr = A_POR_MPU_M7_PRLAR12_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR13_U_SMXP_4_0",
        .addr = A_POR_MPU_M7_PRBAR13_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR13_U_SMXP_4_0",
        .addr = A_POR_MPU_M7_PRLAR13_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR14_U_SMXP_4_0",
        .addr = A_POR_MPU_M7_PRBAR14_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR14_U_SMXP_4_0",
        .addr = A_POR_MPU_M7_PRLAR14_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR15_U_SMXP_4_0",
        .addr = A_POR_MPU_M7_PRBAR15_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR15_U_SMXP_4_0",
        .addr = A_POR_MPU_M7_PRLAR15_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR16_U_SMXP_4_0",
        .addr = A_POR_MPU_M7_PRBAR16_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR16_U_SMXP_4_0",
        .addr = A_POR_MPU_M7_PRLAR16_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR17_U_SMXP_4_0",
        .addr = A_POR_MPU_M7_PRBAR17_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR17_U_SMXP_4_0",
        .addr = A_POR_MPU_M7_PRLAR17_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR18_U_SMXP_4_0",
        .addr = A_POR_MPU_M7_PRBAR18_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR18_U_SMXP_4_0",
        .addr = A_POR_MPU_M7_PRLAR18_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR19_U_SMXP_4_0",
        .addr = A_POR_MPU_M7_PRBAR19_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR19_U_SMXP_4_0",
        .addr = A_POR_MPU_M7_PRLAR19_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR20_U_SMXP_4_0",
        .addr = A_POR_MPU_M7_PRBAR20_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR20_U_SMXP_4_0",
        .addr = A_POR_MPU_M7_PRLAR20_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR21_U_SMXP_4_0",
        .addr = A_POR_MPU_M7_PRBAR21_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR21_U_SMXP_4_0",
        .addr = A_POR_MPU_M7_PRLAR21_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR22_U_SMXP_4_0",
        .addr = A_POR_MPU_M7_PRBAR22_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR22_U_SMXP_4_0",
        .addr = A_POR_MPU_M7_PRLAR22_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR23_U_SMXP_4_0",
        .addr = A_POR_MPU_M7_PRBAR23_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR23_U_SMXP_4_0",
        .addr = A_POR_MPU_M7_PRLAR23_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR24_U_SMXP_4_0",
        .addr = A_POR_MPU_M7_PRBAR24_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR24_U_SMXP_4_0",
        .addr = A_POR_MPU_M7_PRLAR24_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR25_U_SMXP_4_0",
        .addr = A_POR_MPU_M7_PRBAR25_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR25_U_SMXP_4_0",
        .addr = A_POR_MPU_M7_PRLAR25_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR26_U_SMXP_4_0",
        .addr = A_POR_MPU_M7_PRBAR26_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR26_U_SMXP_4_0",
        .addr = A_POR_MPU_M7_PRLAR26_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR27_U_SMXP_4_0",
        .addr = A_POR_MPU_M7_PRBAR27_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR27_U_SMXP_4_0",
        .addr = A_POR_MPU_M7_PRLAR27_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR28_U_SMXP_4_0",
        .addr = A_POR_MPU_M7_PRBAR28_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR28_U_SMXP_4_0",
        .addr = A_POR_MPU_M7_PRLAR28_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR29_U_SMXP_4_0",
        .addr = A_POR_MPU_M7_PRBAR29_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR29_U_SMXP_4_0",
        .addr = A_POR_MPU_M7_PRLAR29_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR30_U_SMXP_4_0",
        .addr = A_POR_MPU_M7_PRBAR30_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR30_U_SMXP_4_0",
        .addr = A_POR_MPU_M7_PRLAR30_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR31_U_SMXP_4_0",
        .addr = A_POR_MPU_M7_PRBAR31_U_SMXP_4_0,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR31_U_SMXP_4_0",
        .addr = A_POR_MPU_M7_PRLAR31_U_SMXP_4_0,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_HNI_NODE_INFO_U_HND_NID256",
        .addr = A_POR_HNI_NODE_INFO_U_HND_NID256,
        .reset = 0x100c40004,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_HNI_CHILD_INFO_U_HND_NID256",
        .addr = A_POR_HNI_CHILD_INFO_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_HNI_UNIT_INFO_U_HND_NID256",
        .addr = A_POR_HNI_UNIT_INFO_U_HND_NID256,
        .reset = 0x11102020,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_HNI_SECURE_REGISTER_GROUPS_OVERRIDE_U_HND_NID256",
        .addr = A_POR_HNI_SECURE_REGISTER_GROUPS_OVERRIDE_U_HND_NID256,
        .rsvd = 0xfffffffffffffffcL,
        .ro = 0xfffffffffffffffcL,
    },{ .name = "POR_HNI_CFG_CTL_U_HND_NID256",
        .addr = A_POR_HNI_CFG_CTL_U_HND_NID256,
        .reset = 0x1,
        .rsvd = 0xfffffffffffffffeL,
        .ro = 0xfffffffffffffffeL,
    },{ .name = "POR_HNI_AUX_CTL_U_HND_NID256",
        .addr = A_POR_HNI_AUX_CTL_U_HND_NID256,
        .rsvd = 0xffffffffffffffceL,
        .ro = 0xffffffffffffffceL,
    },{ .name = "POR_HNI_SAM_ADDRREGION0_CFG_U_HND_NID256",
        .addr = A_POR_HNI_SAM_ADDRREGION0_CFG_U_HND_NID256,
        .reset = 0x600000000000003f,
        .rsvd = 0x3ffffffffffffc0,
        .ro = 0x83ffffffffffffc0L,
    },{ .name = "POR_HNI_SAM_ADDRREGION1_CFG_U_HND_NID256",
        .addr = A_POR_HNI_SAM_ADDRREGION1_CFG_U_HND_NID256,
        .reset = 0x6000000000000000,
        .rsvd = 0x3c0,
        .ro = 0x3000000000f03c0,
    },{ .name = "POR_HNI_SAM_ADDRREGION2_CFG_U_HND_NID256",
        .addr = A_POR_HNI_SAM_ADDRREGION2_CFG_U_HND_NID256,
        .reset = 0x6000000000000000,
        .rsvd = 0x3c0,
        .ro = 0x3000000000f03c0,
    },{ .name = "POR_HNI_SAM_ADDRREGION3_CFG_U_HND_NID256",
        .addr = A_POR_HNI_SAM_ADDRREGION3_CFG_U_HND_NID256,
        .reset = 0x6000000000000000,
        .rsvd = 0x3c0,
        .ro = 0x3000000000f03c0,
    },{ .name = "POR_HNI_PMU_EVENT_SEL_U_HND_NID256",
        .addr = A_POR_HNI_PMU_EVENT_SEL_U_HND_NID256,
        .rsvd = 0xc0,
        .ro = 0xffffffffc0c0c0c0L,
    },{ .name = "POR_HNI_ERRFR_U_HND_NID256",
        .addr = A_POR_HNI_ERRFR_U_HND_NID256,
        .reset = 0xa5,
        .rsvd = 0x300,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_HNI_ERRCTLR_U_HND_NID256",
        .addr = A_POR_HNI_ERRCTLR_U_HND_NID256,
        .rsvd = 0xf0,
        .ro = 0xfffffffffffffef0L,
    },{ .name = "POR_HNI_ERRSTATUS_U_HND_NID256",
        .addr = A_POR_HNI_ERRSTATUS_U_HND_NID256,
        .ro = 0xffffffff127fffffL,
    },{ .name = "POR_HNI_ERRADDR_U_HND_NID256",
        .addr = A_POR_HNI_ERRADDR_U_HND_NID256,
        .ro = 0x7fff000000000000,
    },{ .name = "POR_HNI_ERRMISC_U_HND_NID256",
        .addr = A_POR_HNI_ERRMISC_U_HND_NID256,
        .ro = 0xfe0cffff80c08000L,
    },{ .name = "POR_HNI_ERRFR_NS_U_HND_NID256",
        .addr = A_POR_HNI_ERRFR_NS_U_HND_NID256,
        .reset = 0xa5,
        .rsvd = 0x300,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_HNI_ERRCTLR_NS_U_HND_NID256",
        .addr = A_POR_HNI_ERRCTLR_NS_U_HND_NID256,
        .rsvd = 0xf0,
        .ro = 0xfffffffffffffef0L,
    },{ .name = "POR_HNI_ERRSTATUS_NS_U_HND_NID256",
        .addr = A_POR_HNI_ERRSTATUS_NS_U_HND_NID256,
        .ro = 0xffffffff127fffffL,
    },{ .name = "POR_HNI_ERRADDR_NS_U_HND_NID256",
        .addr = A_POR_HNI_ERRADDR_NS_U_HND_NID256,
        .ro = 0x7fff000000000000,
    },{ .name = "POR_HNI_ERRMISC_NS_U_HND_NID256",
        .addr = A_POR_HNI_ERRMISC_NS_U_HND_NID256,
        .ro = 0xfe0cffff80c08000L,
    },{ .name = "POR_FMU_NODE_INFO_U_HND_NID256",
        .addr = A_POR_FMU_NODE_INFO_U_HND_NID256,
        .reset = 0x1000200,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_FMU_CHILD_INFO_U_HND_NID256",
        .addr = A_POR_FMU_CHILD_INFO_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_FMU_CTL_U_HND_NID256",  .addr = A_POR_FMU_CTL_U_HND_NID256,
        .rsvd = 0xfffffffffffffff0L,
        .ro = 0xfffffffffffffff0L,
    },{ .name = "POR_FMU_KEY_U_HND_NID256",  .addr = A_POR_FMU_KEY_U_HND_NID256,
        .reset = 0xbe,
        .rsvd = 0xffffffffffffff00L,
        .ro = 0xffffffffffffff00L,
    },{ .name = "POR_FMU_ERRGSR_CLK_MXP_U_HND_NID256",
        .addr = A_POR_FMU_ERRGSR_CLK_MXP_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_FMU_ERRGSR_RST_MXP_U_HND_NID256",
        .addr = A_POR_FMU_ERRGSR_RST_MXP_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_FMU_ERRGSR_LSC_MXP_U_HND_NID256",
        .addr = A_POR_FMU_ERRGSR_LSC_MXP_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_FMU_ERRGSR_IOC_MXP_U_HND_NID256",
        .addr = A_POR_FMU_ERRGSR_IOC_MXP_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_FMU_ERRGSR_ASYNC_MXP_U_HND_NID256",
        .addr = A_POR_FMU_ERRGSR_ASYNC_MXP_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_FMU_ERRGSR_HANG_MXP_U_HND_NID256",
        .addr = A_POR_FMU_ERRGSR_HANG_MXP_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_FMU_ERRGSR_MPU_MXP_U_HND_NID256",
        .addr = A_POR_FMU_ERRGSR_MPU_MXP_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_FMU_ERRGSR_ECCUE_MXP_U_HND_NID256",
        .addr = A_POR_FMU_ERRGSR_ECCUE_MXP_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_FMU_ERRGSR_ECCCE_MXP_U_HND_NID256",
        .addr = A_POR_FMU_ERRGSR_ECCCE_MXP_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_FMU_ERRGSR_CLK_P0_D0_U_HND_NID256",
        .addr = A_POR_FMU_ERRGSR_CLK_P0_D0_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_FMU_ERRGSR_RST_P0_D0_U_HND_NID256",
        .addr = A_POR_FMU_ERRGSR_RST_P0_D0_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_FMU_ERRGSR_LSC_P0_D0_U_HND_NID256",
        .addr = A_POR_FMU_ERRGSR_LSC_P0_D0_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_FMU_ERRGSR_IOC_P0_D0_U_HND_NID256",
        .addr = A_POR_FMU_ERRGSR_IOC_P0_D0_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_FMU_ERRGSR_ASYNC_P0_D0_U_HND_NID256",
        .addr = A_POR_FMU_ERRGSR_ASYNC_P0_D0_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_FMU_ERRGSR_HANG_P0_D0_U_HND_NID256",
        .addr = A_POR_FMU_ERRGSR_HANG_P0_D0_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_FMU_ERRGSR_MPU_P0_D0_U_HND_NID256",
        .addr = A_POR_FMU_ERRGSR_MPU_P0_D0_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_FMU_ERRGSR_ECCUE_P0_D0_U_HND_NID256",
        .addr = A_POR_FMU_ERRGSR_ECCUE_P0_D0_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_FMU_ERRGSR_ECCCE_P0_D0_U_HND_NID256",
        .addr = A_POR_FMU_ERRGSR_ECCCE_P0_D0_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_FMU_ERRGSR_CLK_P0_D1_U_HND_NID256",
        .addr = A_POR_FMU_ERRGSR_CLK_P0_D1_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_FMU_ERRGSR_RST_P0_D1_U_HND_NID256",
        .addr = A_POR_FMU_ERRGSR_RST_P0_D1_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_FMU_ERRGSR_LSC_P0_D1_U_HND_NID256",
        .addr = A_POR_FMU_ERRGSR_LSC_P0_D1_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_FMU_ERRGSR_IOC_P0_D1_U_HND_NID256",
        .addr = A_POR_FMU_ERRGSR_IOC_P0_D1_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_FMU_ERRGSR_ASYNC_P0_D1_U_HND_NID256",
        .addr = A_POR_FMU_ERRGSR_ASYNC_P0_D1_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_FMU_ERRGSR_HANG_P0_D1_U_HND_NID256",
        .addr = A_POR_FMU_ERRGSR_HANG_P0_D1_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_FMU_ERRGSR_MPU_P0_D1_U_HND_NID256",
        .addr = A_POR_FMU_ERRGSR_MPU_P0_D1_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_FMU_ERRGSR_ECCUE_P0_D1_U_HND_NID256",
        .addr = A_POR_FMU_ERRGSR_ECCUE_P0_D1_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_FMU_ERRGSR_ECCCE_P0_D1_U_HND_NID256",
        .addr = A_POR_FMU_ERRGSR_ECCCE_P0_D1_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_FMU_ERRGSR_CLK_P0_D2_U_HND_NID256",
        .addr = A_POR_FMU_ERRGSR_CLK_P0_D2_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_FMU_ERRGSR_RST_P0_D2_U_HND_NID256",
        .addr = A_POR_FMU_ERRGSR_RST_P0_D2_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_FMU_ERRGSR_LSC_P0_D2_U_HND_NID256",
        .addr = A_POR_FMU_ERRGSR_LSC_P0_D2_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_FMU_ERRGSR_IOC_P0_D2_U_HND_NID256",
        .addr = A_POR_FMU_ERRGSR_IOC_P0_D2_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_FMU_ERRGSR_ASYNC_P0_D2_U_HND_NID256",
        .addr = A_POR_FMU_ERRGSR_ASYNC_P0_D2_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_FMU_ERRGSR_HANG_P0_D2_U_HND_NID256",
        .addr = A_POR_FMU_ERRGSR_HANG_P0_D2_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_FMU_ERRGSR_MPU_P0_D2_U_HND_NID256",
        .addr = A_POR_FMU_ERRGSR_MPU_P0_D2_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_FMU_ERRGSR_ECCUE_P0_D2_U_HND_NID256",
        .addr = A_POR_FMU_ERRGSR_ECCUE_P0_D2_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_FMU_ERRGSR_ECCCE_P0_D2_U_HND_NID256",
        .addr = A_POR_FMU_ERRGSR_ECCCE_P0_D2_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_FMU_ERRGSR_CLK_P0_D3_U_HND_NID256",
        .addr = A_POR_FMU_ERRGSR_CLK_P0_D3_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_FMU_ERRGSR_RST_P0_D3_U_HND_NID256",
        .addr = A_POR_FMU_ERRGSR_RST_P0_D3_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_FMU_ERRGSR_LSC_P0_D3_U_HND_NID256",
        .addr = A_POR_FMU_ERRGSR_LSC_P0_D3_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_FMU_ERRGSR_IOC_P0_D3_U_HND_NID256",
        .addr = A_POR_FMU_ERRGSR_IOC_P0_D3_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_FMU_ERRGSR_ASYNC_P0_D3_U_HND_NID256",
        .addr = A_POR_FMU_ERRGSR_ASYNC_P0_D3_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_FMU_ERRGSR_HANG_P0_D3_U_HND_NID256",
        .addr = A_POR_FMU_ERRGSR_HANG_P0_D3_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_FMU_ERRGSR_MPU_P0_D3_U_HND_NID256",
        .addr = A_POR_FMU_ERRGSR_MPU_P0_D3_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_FMU_ERRGSR_ECCUE_P0_D3_U_HND_NID256",
        .addr = A_POR_FMU_ERRGSR_ECCUE_P0_D3_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_FMU_ERRGSR_ECCCE_P0_D3_U_HND_NID256",
        .addr = A_POR_FMU_ERRGSR_ECCCE_P0_D3_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_FMU_ERRGSR_CLK_P1_D0_U_HND_NID256",
        .addr = A_POR_FMU_ERRGSR_CLK_P1_D0_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_FMU_ERRGSR_RST_P1_D0_U_HND_NID256",
        .addr = A_POR_FMU_ERRGSR_RST_P1_D0_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_FMU_ERRGSR_LSC_P1_D0_U_HND_NID256",
        .addr = A_POR_FMU_ERRGSR_LSC_P1_D0_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_FMU_ERRGSR_IOC_P1_D0_U_HND_NID256",
        .addr = A_POR_FMU_ERRGSR_IOC_P1_D0_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_FMU_ERRGSR_ASYNC_P1_D0_U_HND_NID256",
        .addr = A_POR_FMU_ERRGSR_ASYNC_P1_D0_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_FMU_ERRGSR_HANG_P1_D0_U_HND_NID256",
        .addr = A_POR_FMU_ERRGSR_HANG_P1_D0_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_FMU_ERRGSR_MPU_P1_D0_U_HND_NID256",
        .addr = A_POR_FMU_ERRGSR_MPU_P1_D0_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_FMU_ERRGSR_ECCUE_P1_D0_U_HND_NID256",
        .addr = A_POR_FMU_ERRGSR_ECCUE_P1_D0_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_FMU_ERRGSR_ECCCE_P1_D0_U_HND_NID256",
        .addr = A_POR_FMU_ERRGSR_ECCCE_P1_D0_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_FMU_ERRGSR_CLK_P1_D1_U_HND_NID256",
        .addr = A_POR_FMU_ERRGSR_CLK_P1_D1_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_FMU_ERRGSR_RST_P1_D1_U_HND_NID256",
        .addr = A_POR_FMU_ERRGSR_RST_P1_D1_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_FMU_ERRGSR_LSC_P1_D1_U_HND_NID256",
        .addr = A_POR_FMU_ERRGSR_LSC_P1_D1_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_FMU_ERRGSR_IOC_P1_D1_U_HND_NID256",
        .addr = A_POR_FMU_ERRGSR_IOC_P1_D1_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_FMU_ERRGSR_ASYNC_P1_D1_U_HND_NID256",
        .addr = A_POR_FMU_ERRGSR_ASYNC_P1_D1_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_FMU_ERRGSR_HANG_P1_D1_U_HND_NID256",
        .addr = A_POR_FMU_ERRGSR_HANG_P1_D1_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_FMU_ERRGSR_MPU_P1_D1_U_HND_NID256",
        .addr = A_POR_FMU_ERRGSR_MPU_P1_D1_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_FMU_ERRGSR_ECCUE_P1_D1_U_HND_NID256",
        .addr = A_POR_FMU_ERRGSR_ECCUE_P1_D1_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_FMU_ERRGSR_ECCCE_P1_D1_U_HND_NID256",
        .addr = A_POR_FMU_ERRGSR_ECCCE_P1_D1_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_FMU_ERRGSR_CLK_P1_D2_U_HND_NID256",
        .addr = A_POR_FMU_ERRGSR_CLK_P1_D2_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_FMU_ERRGSR_RST_P1_D2_U_HND_NID256",
        .addr = A_POR_FMU_ERRGSR_RST_P1_D2_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_FMU_ERRGSR_LSC_P1_D2_U_HND_NID256",
        .addr = A_POR_FMU_ERRGSR_LSC_P1_D2_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_FMU_ERRGSR_IOC_P1_D2_U_HND_NID256",
        .addr = A_POR_FMU_ERRGSR_IOC_P1_D2_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_FMU_ERRGSR_ASYNC_P1_D2_U_HND_NID256",
        .addr = A_POR_FMU_ERRGSR_ASYNC_P1_D2_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_FMU_ERRGSR_HANG_P1_D2_U_HND_NID256",
        .addr = A_POR_FMU_ERRGSR_HANG_P1_D2_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_FMU_ERRGSR_MPU_P1_D2_U_HND_NID256",
        .addr = A_POR_FMU_ERRGSR_MPU_P1_D2_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_FMU_ERRGSR_ECCUE_P1_D2_U_HND_NID256",
        .addr = A_POR_FMU_ERRGSR_ECCUE_P1_D2_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_FMU_ERRGSR_ECCCE_P1_D2_U_HND_NID256",
        .addr = A_POR_FMU_ERRGSR_ECCCE_P1_D2_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_FMU_ERRGSR_CLK_P1_D3_U_HND_NID256",
        .addr = A_POR_FMU_ERRGSR_CLK_P1_D3_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_FMU_ERRGSR_RST_P1_D3_U_HND_NID256",
        .addr = A_POR_FMU_ERRGSR_RST_P1_D3_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_FMU_ERRGSR_LSC_P1_D3_U_HND_NID256",
        .addr = A_POR_FMU_ERRGSR_LSC_P1_D3_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_FMU_ERRGSR_IOC_P1_D3_U_HND_NID256",
        .addr = A_POR_FMU_ERRGSR_IOC_P1_D3_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_FMU_ERRGSR_ASYNC_P1_D3_U_HND_NID256",
        .addr = A_POR_FMU_ERRGSR_ASYNC_P1_D3_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_FMU_ERRGSR_HANG_P1_D3_U_HND_NID256",
        .addr = A_POR_FMU_ERRGSR_HANG_P1_D3_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_FMU_ERRGSR_MPU_P1_D3_U_HND_NID256",
        .addr = A_POR_FMU_ERRGSR_MPU_P1_D3_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_FMU_ERRGSR_ECCUE_P1_D3_U_HND_NID256",
        .addr = A_POR_FMU_ERRGSR_ECCUE_P1_D3_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_FMU_ERRGSR_ECCCE_P1_D3_U_HND_NID256",
        .addr = A_POR_FMU_ERRGSR_ECCCE_P1_D3_U_HND_NID256,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CXG_RA_NODE_INFO_U_CXRH_NID264",
        .addr = A_POR_CXG_RA_NODE_INFO_U_CXRH_NID264,
        .reset = 0x1080100,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CXG_RA_CHILD_INFO_U_CXRH_NID264",
        .addr = A_POR_CXG_RA_CHILD_INFO_U_CXRH_NID264,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CXG_RA_UNIT_INFO_U_CXRH_NID264",
        .addr = A_POR_CXG_RA_UNIT_INFO_U_CXRH_NID264,
        .reset = 0x2102008040800008,
        .rsvd = 0xa0,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CXG_RA_SECURE_REGISTER_GROUPS_OVERRIDE_U_CXRH_NID264",
        .addr = A_POR_CXG_RA_SECURE_REGISTER_GROUPS_OVERRIDE_U_CXRH_NID264,
        .rsvd = 0xfffffffffffffff0L,
        .ro = 0xfffffffffffffff0L,
    },{ .name = "POR_CXG_RA_CFG_CTL_U_CXRH_NID264",
        .addr = A_POR_CXG_RA_CFG_CTL_U_CXRH_NID264,
        .reset = 0x7,
        .rsvd = 0xf8,
        .ro = 0xfffffffffffffef8L,
    },{ .name = "POR_CXG_RA_AUX_CTL_U_CXRH_NID264",
        .addr = A_POR_CXG_RA_AUX_CTL_U_CXRH_NID264,
        .reset = 0x6,
        .ro = 0xfffffffffffffc00L,
    },{ .name = "POR_CXG_RA_SAM_ADDR_REGION_REG0_U_CXRH_NID264",
        .addr = A_POR_CXG_RA_SAM_ADDR_REGION_REG0_U_CXRH_NID264,
        .rsvd = 0xffc0,
        .ro = 0x7c0f00000000ffc0,
    },{ .name = "POR_CXG_RA_SAM_ADDR_REGION_REG1_U_CXRH_NID264",
        .addr = A_POR_CXG_RA_SAM_ADDR_REGION_REG1_U_CXRH_NID264,
        .rsvd = 0xffc0,
        .ro = 0x7c0f00000000ffc0,
    },{ .name = "POR_CXG_RA_SAM_ADDR_REGION_REG2_U_CXRH_NID264",
        .addr = A_POR_CXG_RA_SAM_ADDR_REGION_REG2_U_CXRH_NID264,
        .rsvd = 0xffc0,
        .ro = 0x7c0f00000000ffc0,
    },{ .name = "POR_CXG_RA_SAM_ADDR_REGION_REG3_U_CXRH_NID264",
        .addr = A_POR_CXG_RA_SAM_ADDR_REGION_REG3_U_CXRH_NID264,
        .rsvd = 0xffc0,
        .ro = 0x7c0f00000000ffc0,
    },{ .name = "POR_CXG_RA_SAM_ADDR_REGION_REG4_U_CXRH_NID264",
        .addr = A_POR_CXG_RA_SAM_ADDR_REGION_REG4_U_CXRH_NID264,
        .rsvd = 0xffc0,
        .ro = 0x7c0f00000000ffc0,
    },{ .name = "POR_CXG_RA_SAM_ADDR_REGION_REG5_U_CXRH_NID264",
        .addr = A_POR_CXG_RA_SAM_ADDR_REGION_REG5_U_CXRH_NID264,
        .rsvd = 0xffc0,
        .ro = 0x7c0f00000000ffc0,
    },{ .name = "POR_CXG_RA_SAM_ADDR_REGION_REG6_U_CXRH_NID264",
        .addr = A_POR_CXG_RA_SAM_ADDR_REGION_REG6_U_CXRH_NID264,
        .rsvd = 0xffc0,
        .ro = 0x7c0f00000000ffc0,
    },{ .name = "POR_CXG_RA_SAM_ADDR_REGION_REG7_U_CXRH_NID264",
        .addr = A_POR_CXG_RA_SAM_ADDR_REGION_REG7_U_CXRH_NID264,
        .rsvd = 0xffc0,
        .ro = 0x7c0f00000000ffc0,
    },{ .name = "POR_CXG_RA_SAM_MEM_REGION0_LIMIT_REG_U_CXRH_NID264",
        .addr = A_POR_CXG_RA_SAM_MEM_REGION0_LIMIT_REG_U_CXRH_NID264,
        .ro = 0xffff00000000ffffL,
    },{ .name = "POR_CXG_RA_SAM_MEM_REGION1_LIMIT_REG_U_CXRH_NID264",
        .addr = A_POR_CXG_RA_SAM_MEM_REGION1_LIMIT_REG_U_CXRH_NID264,
        .ro = 0xffff00000000ffffL,
    },{ .name = "POR_CXG_RA_SAM_MEM_REGION2_LIMIT_REG_U_CXRH_NID264",
        .addr = A_POR_CXG_RA_SAM_MEM_REGION2_LIMIT_REG_U_CXRH_NID264,
        .ro = 0xffff00000000ffffL,
    },{ .name = "POR_CXG_RA_SAM_MEM_REGION3_LIMIT_REG_U_CXRH_NID264",
        .addr = A_POR_CXG_RA_SAM_MEM_REGION3_LIMIT_REG_U_CXRH_NID264,
        .ro = 0xffff00000000ffffL,
    },{ .name = "POR_CXG_RA_SAM_MEM_REGION4_LIMIT_REG_U_CXRH_NID264",
        .addr = A_POR_CXG_RA_SAM_MEM_REGION4_LIMIT_REG_U_CXRH_NID264,
        .ro = 0xffff00000000ffffL,
    },{ .name = "POR_CXG_RA_SAM_MEM_REGION5_LIMIT_REG_U_CXRH_NID264",
        .addr = A_POR_CXG_RA_SAM_MEM_REGION5_LIMIT_REG_U_CXRH_NID264,
        .ro = 0xffff00000000ffffL,
    },{ .name = "POR_CXG_RA_SAM_MEM_REGION6_LIMIT_REG_U_CXRH_NID264",
        .addr = A_POR_CXG_RA_SAM_MEM_REGION6_LIMIT_REG_U_CXRH_NID264,
        .ro = 0xffff00000000ffffL,
    },{ .name = "POR_CXG_RA_SAM_MEM_REGION7_LIMIT_REG_U_CXRH_NID264",
        .addr = A_POR_CXG_RA_SAM_MEM_REGION7_LIMIT_REG_U_CXRH_NID264,
        .ro = 0xffff00000000ffffL,
    },{ .name = "POR_CXG_RA_AGENTID_TO_LINKID_REG0_U_CXRH_NID264",
        .addr = A_POR_CXG_RA_AGENTID_TO_LINKID_REG0_U_CXRH_NID264,
        .rsvd = 0xfc,
        .ro = 0xfcfcfcfcfcfcfcfcL,
    },{ .name = "POR_CXG_RA_AGENTID_TO_LINKID_REG1_U_CXRH_NID264",
        .addr = A_POR_CXG_RA_AGENTID_TO_LINKID_REG1_U_CXRH_NID264,
        .rsvd = 0xfc,
        .ro = 0xfcfcfcfcfcfcfcfcL,
    },{ .name = "POR_CXG_RA_AGENTID_TO_LINKID_REG2_U_CXRH_NID264",
        .addr = A_POR_CXG_RA_AGENTID_TO_LINKID_REG2_U_CXRH_NID264,
        .rsvd = 0xfc,
        .ro = 0xfcfcfcfcfcfcfcfcL,
    },{ .name = "POR_CXG_RA_AGENTID_TO_LINKID_REG3_U_CXRH_NID264",
        .addr = A_POR_CXG_RA_AGENTID_TO_LINKID_REG3_U_CXRH_NID264,
        .rsvd = 0xfc,
        .ro = 0xfcfcfcfcfcfcfcfcL,
    },{ .name = "POR_CXG_RA_AGENTID_TO_LINKID_REG4_U_CXRH_NID264",
        .addr = A_POR_CXG_RA_AGENTID_TO_LINKID_REG4_U_CXRH_NID264,
        .rsvd = 0xfc,
        .ro = 0xfcfcfcfcfcfcfcfcL,
    },{ .name = "POR_CXG_RA_AGENTID_TO_LINKID_REG5_U_CXRH_NID264",
        .addr = A_POR_CXG_RA_AGENTID_TO_LINKID_REG5_U_CXRH_NID264,
        .rsvd = 0xfc,
        .ro = 0xfcfcfcfcfcfcfcfcL,
    },{ .name = "POR_CXG_RA_AGENTID_TO_LINKID_REG6_U_CXRH_NID264",
        .addr = A_POR_CXG_RA_AGENTID_TO_LINKID_REG6_U_CXRH_NID264,
        .rsvd = 0xfc,
        .ro = 0xfcfcfcfcfcfcfcfcL,
    },{ .name = "POR_CXG_RA_AGENTID_TO_LINKID_REG7_U_CXRH_NID264",
        .addr = A_POR_CXG_RA_AGENTID_TO_LINKID_REG7_U_CXRH_NID264,
        .rsvd = 0xfc,
        .ro = 0xfcfcfcfcfcfcfcfcL,
    },{ .name = "POR_CXG_RA_RNF_LDID_TO_RAID_REG0_U_CXRH_NID264",
        .addr = A_POR_CXG_RA_RNF_LDID_TO_RAID_REG0_U_CXRH_NID264,
        .rsvd = 0xc0,
        .ro = 0xc0c0c0c0c0c0c0c0L,
    },{ .name = "POR_CXG_RA_RNF_LDID_TO_RAID_REG1_U_CXRH_NID264",
        .addr = A_POR_CXG_RA_RNF_LDID_TO_RAID_REG1_U_CXRH_NID264,
        .rsvd = 0xc0,
        .ro = 0xc0c0c0c0c0c0c0c0L,
    },{ .name = "POR_CXG_RA_RNF_LDID_TO_RAID_REG2_U_CXRH_NID264",
        .addr = A_POR_CXG_RA_RNF_LDID_TO_RAID_REG2_U_CXRH_NID264,
        .rsvd = 0xc0,
        .ro = 0xc0c0c0c0c0c0c0c0L,
    },{ .name = "POR_CXG_RA_RNF_LDID_TO_RAID_REG3_U_CXRH_NID264",
        .addr = A_POR_CXG_RA_RNF_LDID_TO_RAID_REG3_U_CXRH_NID264,
        .rsvd = 0xc0,
        .ro = 0xc0c0c0c0c0c0c0c0L,
    },{ .name = "POR_CXG_RA_RNF_LDID_TO_RAID_REG4_U_CXRH_NID264",
        .addr = A_POR_CXG_RA_RNF_LDID_TO_RAID_REG4_U_CXRH_NID264,
        .rsvd = 0xc0,
        .ro = 0xc0c0c0c0c0c0c0c0L,
    },{ .name = "POR_CXG_RA_RNF_LDID_TO_RAID_REG5_U_CXRH_NID264",
        .addr = A_POR_CXG_RA_RNF_LDID_TO_RAID_REG5_U_CXRH_NID264,
        .rsvd = 0xc0,
        .ro = 0xc0c0c0c0c0c0c0c0L,
    },{ .name = "POR_CXG_RA_RNF_LDID_TO_RAID_REG6_U_CXRH_NID264",
        .addr = A_POR_CXG_RA_RNF_LDID_TO_RAID_REG6_U_CXRH_NID264,
        .rsvd = 0xc0,
        .ro = 0xc0c0c0c0c0c0c0c0L,
    },{ .name = "POR_CXG_RA_RNF_LDID_TO_RAID_REG7_U_CXRH_NID264",
        .addr = A_POR_CXG_RA_RNF_LDID_TO_RAID_REG7_U_CXRH_NID264,
        .rsvd = 0xc0,
        .ro = 0xc0c0c0c0c0c0c0c0L,
    },{ .name = "POR_CXG_RA_RNI_LDID_TO_RAID_REG0_U_CXRH_NID264",
        .addr = A_POR_CXG_RA_RNI_LDID_TO_RAID_REG0_U_CXRH_NID264,
        .rsvd = 0xc0,
        .ro = 0xc0c0c0c0c0c0c0c0L,
    },{ .name = "POR_CXG_RA_RNI_LDID_TO_RAID_REG1_U_CXRH_NID264",
        .addr = A_POR_CXG_RA_RNI_LDID_TO_RAID_REG1_U_CXRH_NID264,
        .rsvd = 0xc0,
        .ro = 0xc0c0c0c0c0c0c0c0L,
    },{ .name = "POR_CXG_RA_RNI_LDID_TO_RAID_REG2_U_CXRH_NID264",
        .addr = A_POR_CXG_RA_RNI_LDID_TO_RAID_REG2_U_CXRH_NID264,
        .rsvd = 0xc0,
        .ro = 0xc0c0c0c0c0c0c0c0L,
    },{ .name = "POR_CXG_RA_RNI_LDID_TO_RAID_REG3_U_CXRH_NID264",
        .addr = A_POR_CXG_RA_RNI_LDID_TO_RAID_REG3_U_CXRH_NID264,
        .rsvd = 0xc0,
        .ro = 0xc0c0c0c0c0c0c0c0L,
    },{ .name = "POR_CXG_RA_RND_LDID_TO_RAID_REG0_U_CXRH_NID264",
        .addr = A_POR_CXG_RA_RND_LDID_TO_RAID_REG0_U_CXRH_NID264,
        .rsvd = 0xc0,
        .ro = 0xc0c0c0c0c0c0c0c0L,
    },{ .name = "POR_CXG_RA_RND_LDID_TO_RAID_REG1_U_CXRH_NID264",
        .addr = A_POR_CXG_RA_RND_LDID_TO_RAID_REG1_U_CXRH_NID264,
        .rsvd = 0xc0,
        .ro = 0xc0c0c0c0c0c0c0c0L,
    },{ .name = "POR_CXG_RA_RND_LDID_TO_RAID_REG2_U_CXRH_NID264",
        .addr = A_POR_CXG_RA_RND_LDID_TO_RAID_REG2_U_CXRH_NID264,
        .rsvd = 0xc0,
        .ro = 0xc0c0c0c0c0c0c0c0L,
    },{ .name = "POR_CXG_RA_RND_LDID_TO_RAID_REG3_U_CXRH_NID264",
        .addr = A_POR_CXG_RA_RND_LDID_TO_RAID_REG3_U_CXRH_NID264,
        .rsvd = 0xc0,
        .ro = 0xc0c0c0c0c0c0c0c0L,
    },{ .name = "POR_CXG_RA_AGENTID_TO_LINKID_VAL_U_CXRH_NID264",
        .addr = A_POR_CXG_RA_AGENTID_TO_LINKID_VAL_U_CXRH_NID264,
    },{ .name = "POR_CXG_RA_RNF_LDID_TO_RAID_VAL_U_CXRH_NID264",
        .addr = A_POR_CXG_RA_RNF_LDID_TO_RAID_VAL_U_CXRH_NID264,
    },{ .name = "POR_CXG_RA_RNI_LDID_TO_RAID_VAL_U_CXRH_NID264",
        .addr = A_POR_CXG_RA_RNI_LDID_TO_RAID_VAL_U_CXRH_NID264,
        .ro = 0xffffffff00000000L,
    },{ .name = "POR_CXG_RA_RND_LDID_TO_RAID_VAL_U_CXRH_NID264",
        .addr = A_POR_CXG_RA_RND_LDID_TO_RAID_VAL_U_CXRH_NID264,
        .ro = 0xffffffff00000000L,
    },{ .name = "POR_CXG_RA_CXPRTCL_LINK0_CTL_U_CXRH_NID264",
        .addr = A_POR_CXG_RA_CXPRTCL_LINK0_CTL_U_CXRH_NID264,
        .ro = 0xfffffffffffffe00L,
    },{ .name = "POR_CXG_RA_CXPRTCL_LINK0_STATUS_U_CXRH_NID264",
        .addr = A_POR_CXG_RA_CXPRTCL_LINK0_STATUS_U_CXRH_NID264,
        .reset = 0x2,
        .rsvd = 0xfffffffffffffff0L,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CXG_RA_CXPRTCL_LINK1_CTL_U_CXRH_NID264",
        .addr = A_POR_CXG_RA_CXPRTCL_LINK1_CTL_U_CXRH_NID264,
        .ro = 0xfffffffffffffe00L,
    },{ .name = "POR_CXG_RA_CXPRTCL_LINK1_STATUS_U_CXRH_NID264",
        .addr = A_POR_CXG_RA_CXPRTCL_LINK1_STATUS_U_CXRH_NID264,
        .reset = 0x2,
        .rsvd = 0xfffffffffffffff0L,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CXG_RA_CXPRTCL_LINK2_CTL_U_CXRH_NID264",
        .addr = A_POR_CXG_RA_CXPRTCL_LINK2_CTL_U_CXRH_NID264,
        .ro = 0xfffffffffffffe00L,
    },{ .name = "POR_CXG_RA_CXPRTCL_LINK2_STATUS_U_CXRH_NID264",
        .addr = A_POR_CXG_RA_CXPRTCL_LINK2_STATUS_U_CXRH_NID264,
        .reset = 0x2,
        .rsvd = 0xfffffffffffffff0L,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CXG_RA_PMU_EVENT_SEL_U_CXRH_NID264",
        .addr = A_POR_CXG_RA_PMU_EVENT_SEL_U_CXRH_NID264,
        .rsvd = 0xc0,
        .ro = 0xfffffff0c0c0c0c0L,
    },{ .name = "POR_MXP_NODE_INFO_U_SMXP_4_1",
        .addr = A_POR_MXP_NODE_INFO_U_SMXP_4_1,
        .reset = 0x1080006,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_DEVICE_PORT_CONNECT_INFO_P0_U_SMXP_4_1",
        .addr = A_POR_MXP_DEVICE_PORT_CONNECT_INFO_P0_U_SMXP_4_1,
        .reset = 0xd,
        .rsvd = 0xffe0,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_DEVICE_PORT_CONNECT_INFO_P1_U_SMXP_4_1",
        .addr = A_POR_MXP_DEVICE_PORT_CONNECT_INFO_P1_U_SMXP_4_1,
        .reset = 0x1,
        .rsvd = 0xffe0,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_MESH_PORT_CONNECT_INFO_EAST_U_SMXP_4_1",
        .addr = A_POR_MXP_MESH_PORT_CONNECT_INFO_EAST_U_SMXP_4_1,
        .rsvd = 0xfffffffffffffff0L,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_MESH_PORT_CONNECT_INFO_NORTH_U_SMXP_4_1",
        .addr = A_POR_MXP_MESH_PORT_CONNECT_INFO_NORTH_U_SMXP_4_1,
        .rsvd = 0xfffffffffffffff0L,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_INFO_U_SMXP_4_1",
        .addr = A_POR_MXP_CHILD_INFO_U_SMXP_4_1,
        .reset = 0x1000006,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_POINTER_0_U_SMXP_4_1",
        .addr = A_POR_MXP_CHILD_POINTER_0_U_SMXP_4_1,
        .reset = 0x8212c000,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_POINTER_1_U_SMXP_4_1",
        .addr = A_POR_MXP_CHILD_POINTER_1_U_SMXP_4_1,
        .reset = 0x8213c000,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_POINTER_2_U_SMXP_4_1",
        .addr = A_POR_MXP_CHILD_POINTER_2_U_SMXP_4_1,
        .reset = 0x2168000,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_POINTER_3_U_SMXP_4_1",
        .addr = A_POR_MXP_CHILD_POINTER_3_U_SMXP_4_1,
        .reset = 0x821d0000,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_POINTER_4_U_SMXP_4_1",
        .addr = A_POR_MXP_CHILD_POINTER_4_U_SMXP_4_1,
        .reset = 0x82120000,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_POINTER_5_U_SMXP_4_1",
        .addr = A_POR_MXP_CHILD_POINTER_5_U_SMXP_4_1,
        .reset = 0x2150000,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_POINTER_6_U_SMXP_4_1",
        .addr = A_POR_MXP_CHILD_POINTER_6_U_SMXP_4_1,
        .reset = 0x2110000,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_POINTER_7_U_SMXP_4_1",
        .addr = A_POR_MXP_CHILD_POINTER_7_U_SMXP_4_1,
        .reset = 0x2100000,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_POINTER_8_U_SMXP_4_1",
        .addr = A_POR_MXP_CHILD_POINTER_8_U_SMXP_4_1,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_POINTER_9_U_SMXP_4_1",
        .addr = A_POR_MXP_CHILD_POINTER_9_U_SMXP_4_1,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_POINTER_10_U_SMXP_4_1",
        .addr = A_POR_MXP_CHILD_POINTER_10_U_SMXP_4_1,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_POINTER_11_U_SMXP_4_1",
        .addr = A_POR_MXP_CHILD_POINTER_11_U_SMXP_4_1,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_POINTER_12_U_SMXP_4_1",
        .addr = A_POR_MXP_CHILD_POINTER_12_U_SMXP_4_1,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_POINTER_13_U_SMXP_4_1",
        .addr = A_POR_MXP_CHILD_POINTER_13_U_SMXP_4_1,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_POINTER_14_U_SMXP_4_1",
        .addr = A_POR_MXP_CHILD_POINTER_14_U_SMXP_4_1,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_CHILD_POINTER_15_U_SMXP_4_1",
        .addr = A_POR_MXP_CHILD_POINTER_15_U_SMXP_4_1,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_P0_INFO_U_SMXP_4_1",
        .addr = A_POR_MXP_P0_INFO_U_SMXP_4_1,
        .reset = 0x211,
        .rsvd = 0x48,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_P1_INFO_U_SMXP_4_1",
        .addr = A_POR_MXP_P1_INFO_U_SMXP_4_1,
        .reset = 0x211,
        .rsvd = 0x48,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_SECURE_REGISTER_GROUPS_OVERRIDE_U_SMXP_4_1",
        .addr = A_POR_MXP_SECURE_REGISTER_GROUPS_OVERRIDE_U_SMXP_4_1,
        .rsvd = 0xfffffffffffffffcL,
        .ro = 0xfffffffffffffffcL,
    },{ .name = "POR_MXP_AUX_CTL_U_SMXP_4_1",
        .addr = A_POR_MXP_AUX_CTL_U_SMXP_4_1,
        .rsvd = 0xfffffffffffffffeL,
        .ro = 0xfffffffffffffffeL,
    },{ .name = "POR_MXP_P0_QOS_CONTROL_U_SMXP_4_1",
        .addr = A_POR_MXP_P0_QOS_CONTROL_U_SMXP_4_1,
        .rsvd = 0xffaa,
        .ro = 0xfffffffffff0ffaaL,
    },{ .name = "POR_MXP_P0_QOS_LAT_TGT_U_SMXP_4_1",
        .addr = A_POR_MXP_P0_QOS_LAT_TGT_U_SMXP_4_1,
        .ro = 0xfffffffffffff000L,
    },{ .name = "POR_MXP_P0_QOS_LAT_SCALE_U_SMXP_4_1",
        .addr = A_POR_MXP_P0_QOS_LAT_SCALE_U_SMXP_4_1,
        .rsvd = 0xfffffffffffffff8L,
        .ro = 0xfffffffffffffff8L,
    },{ .name = "POR_MXP_P0_QOS_LAT_RANGE_U_SMXP_4_1",
        .addr = A_POR_MXP_P0_QOS_LAT_RANGE_U_SMXP_4_1,
        .rsvd = 0xf0,
        .ro = 0xfffffffffffff0f0L,
    },{ .name = "POR_MXP_P1_QOS_CONTROL_U_SMXP_4_1",
        .addr = A_POR_MXP_P1_QOS_CONTROL_U_SMXP_4_1,
        .rsvd = 0xffaa,
        .ro = 0xfffffffffff0ffaaL,
    },{ .name = "POR_MXP_P1_QOS_LAT_TGT_U_SMXP_4_1",
        .addr = A_POR_MXP_P1_QOS_LAT_TGT_U_SMXP_4_1,
        .ro = 0xfffffffffffff000L,
    },{ .name = "POR_MXP_P1_QOS_LAT_SCALE_U_SMXP_4_1",
        .addr = A_POR_MXP_P1_QOS_LAT_SCALE_U_SMXP_4_1,
        .rsvd = 0xfffffffffffffff8L,
        .ro = 0xfffffffffffffff8L,
    },{ .name = "POR_MXP_P1_QOS_LAT_RANGE_U_SMXP_4_1",
        .addr = A_POR_MXP_P1_QOS_LAT_RANGE_U_SMXP_4_1,
        .rsvd = 0xf0,
        .ro = 0xfffffffffffff0f0L,
    },{ .name = "POR_MXP_P0_SYSCOREQ_CTL_U_SMXP_4_1",
        .addr = A_POR_MXP_P0_SYSCOREQ_CTL_U_SMXP_4_1,
        .rsvd = 0xfffffffffffffff0L,
        .ro = 0xfffffffffffffff0L,
    },{ .name = "POR_MXP_P1_SYSCOREQ_CTL_U_SMXP_4_1",
        .addr = A_POR_MXP_P1_SYSCOREQ_CTL_U_SMXP_4_1,
        .rsvd = 0xfffffffffffffff0L,
        .ro = 0xfffffffffffffff0L,
    },{ .name = "POR_MXP_P0_SYSCOACK_STATUS_U_SMXP_4_1",
        .addr = A_POR_MXP_P0_SYSCOACK_STATUS_U_SMXP_4_1,
        .rsvd = 0xfffffffffffffff0L,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_P1_SYSCOACK_STATUS_U_SMXP_4_1",
        .addr = A_POR_MXP_P1_SYSCOACK_STATUS_U_SMXP_4_1,
        .rsvd = 0xfffffffffffffff0L,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_PMU_EVENT_SEL_U_SMXP_4_1",
        .addr = A_POR_MXP_PMU_EVENT_SEL_U_SMXP_4_1,
        .ro = 0xffffffff00000000L,
    },{ .name = "POR_DTM_CONTROL_U_SMXP_4_1",
        .addr = A_POR_DTM_CONTROL_U_SMXP_4_1,
        .rsvd = 0xfffffffffffffff0L,
        .ro = 0xfffffffffffffff0L,
    },{ .name = "POR_DTM_FIFO_ENTRY_READY_U_SMXP_4_1",
        .addr = A_POR_DTM_FIFO_ENTRY_READY_U_SMXP_4_1,
        .rsvd = 0xfffffffffffffff0L,
        .ro = 0xfffffffffffffff0L,
    },{ .name = "POR_DTM_FIFO_ENTRY0_0_U_SMXP_4_1",
        .addr = A_POR_DTM_FIFO_ENTRY0_0_U_SMXP_4_1,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_DTM_FIFO_ENTRY0_1_U_SMXP_4_1",
        .addr = A_POR_DTM_FIFO_ENTRY0_1_U_SMXP_4_1,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_DTM_FIFO_ENTRY0_2_U_SMXP_4_1",
        .addr = A_POR_DTM_FIFO_ENTRY0_2_U_SMXP_4_1,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_DTM_FIFO_ENTRY1_0_U_SMXP_4_1",
        .addr = A_POR_DTM_FIFO_ENTRY1_0_U_SMXP_4_1,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_DTM_FIFO_ENTRY1_1_U_SMXP_4_1",
        .addr = A_POR_DTM_FIFO_ENTRY1_1_U_SMXP_4_1,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_DTM_FIFO_ENTRY1_2_U_SMXP_4_1",
        .addr = A_POR_DTM_FIFO_ENTRY1_2_U_SMXP_4_1,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_DTM_FIFO_ENTRY2_0_U_SMXP_4_1",
        .addr = A_POR_DTM_FIFO_ENTRY2_0_U_SMXP_4_1,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_DTM_FIFO_ENTRY2_1_U_SMXP_4_1",
        .addr = A_POR_DTM_FIFO_ENTRY2_1_U_SMXP_4_1,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_DTM_FIFO_ENTRY2_2_U_SMXP_4_1",
        .addr = A_POR_DTM_FIFO_ENTRY2_2_U_SMXP_4_1,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_DTM_FIFO_ENTRY3_0_U_SMXP_4_1",
        .addr = A_POR_DTM_FIFO_ENTRY3_0_U_SMXP_4_1,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_DTM_FIFO_ENTRY3_1_U_SMXP_4_1",
        .addr = A_POR_DTM_FIFO_ENTRY3_1_U_SMXP_4_1,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_DTM_FIFO_ENTRY3_2_U_SMXP_4_1",
        .addr = A_POR_DTM_FIFO_ENTRY3_2_U_SMXP_4_1,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_DTM_WP0_CONFIG_U_SMXP_4_1",
        .addr = A_POR_DTM_WP0_CONFIG_U_SMXP_4_1,
        .rsvd = 0x80,
        .ro = 0xffffffffffff8080L,
    },{ .name = "POR_DTM_WP0_VAL_U_SMXP_4_1",
        .addr = A_POR_DTM_WP0_VAL_U_SMXP_4_1,
    },{ .name = "POR_DTM_WP0_MASK_U_SMXP_4_1",
        .addr = A_POR_DTM_WP0_MASK_U_SMXP_4_1,
    },{ .name = "POR_DTM_WP1_CONFIG_U_SMXP_4_1",
        .addr = A_POR_DTM_WP1_CONFIG_U_SMXP_4_1,
        .rsvd = 0xc0,
        .ro = 0xffffffffffff80c0L,
    },{ .name = "POR_DTM_WP1_VAL_U_SMXP_4_1",
        .addr = A_POR_DTM_WP1_VAL_U_SMXP_4_1,
    },{ .name = "POR_DTM_WP1_MASK_U_SMXP_4_1",
        .addr = A_POR_DTM_WP1_MASK_U_SMXP_4_1,
    },{ .name = "POR_DTM_WP2_CONFIG_U_SMXP_4_1",
        .addr = A_POR_DTM_WP2_CONFIG_U_SMXP_4_1,
        .rsvd = 0x80,
        .ro = 0xffffffffffff8080L,
    },{ .name = "POR_DTM_WP2_VAL_U_SMXP_4_1",
        .addr = A_POR_DTM_WP2_VAL_U_SMXP_4_1,
    },{ .name = "POR_DTM_WP2_MASK_U_SMXP_4_1",
        .addr = A_POR_DTM_WP2_MASK_U_SMXP_4_1,
    },{ .name = "POR_DTM_WP3_CONFIG_U_SMXP_4_1",
        .addr = A_POR_DTM_WP3_CONFIG_U_SMXP_4_1,
        .rsvd = 0xc0,
        .ro = 0xffffffffffff80c0L,
    },{ .name = "POR_DTM_WP3_VAL_U_SMXP_4_1",
        .addr = A_POR_DTM_WP3_VAL_U_SMXP_4_1,
    },{ .name = "POR_DTM_WP3_MASK_U_SMXP_4_1",
        .addr = A_POR_DTM_WP3_MASK_U_SMXP_4_1,
    },{ .name = "POR_DTM_PMSICR_U_SMXP_4_1",
        .addr = A_POR_DTM_PMSICR_U_SMXP_4_1,
        .ro = 0xffffffff00000000L,
    },{ .name = "POR_DTM_PMSIRR_U_SMXP_4_1",
        .addr = A_POR_DTM_PMSIRR_U_SMXP_4_1,
        .ro = 0xffffffff000000ffL,
    },{ .name = "POR_DTM_PMU_CONFIG_U_SMXP_4_1",
        .addr = A_POR_DTM_PMU_CONFIG_U_SMXP_4_1,
        .ro = 0xc0c0c0c08888fe00L,
    },{ .name = "POR_DTM_PMEVCNT_U_SMXP_4_1",
        .addr = A_POR_DTM_PMEVCNT_U_SMXP_4_1,
    },{ .name = "POR_DTM_PMEVCNTSR_U_SMXP_4_1",
        .addr = A_POR_DTM_PMEVCNTSR_U_SMXP_4_1,
    },{ .name = "POR_MXP_ERRFR_U_SMXP_4_1",  .addr = A_POR_MXP_ERRFR_U_SMXP_4_1,
        .rsvd = 0x300,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_ERRCTLR_U_SMXP_4_1",
        .addr = A_POR_MXP_ERRCTLR_U_SMXP_4_1,
        .rsvd = 0xf0,
        .ro = 0xfffffffffffffef0L,
    },{ .name = "POR_MXP_ERRSTATUS_U_SMXP_4_1",
        .addr = A_POR_MXP_ERRSTATUS_U_SMXP_4_1,
        .ro = 0xffffffff127fffffL,
    },{ .name = "POR_MXP_ERRMISC_U_SMXP_4_1",
        .addr = A_POR_MXP_ERRMISC_U_SMXP_4_1,
        .rsvd = 0x8,
        .ro = 0xf800ffffffc08008L,
    },{ .name = "POR_MXP_P0_BYTE_PAR_ERR_INJ_U_SMXP_4_1",
        .addr = A_POR_MXP_P0_BYTE_PAR_ERR_INJ_U_SMXP_4_1,
        .rsvd = 0xffffffffffffffe0L,
        .ro = 0xffffffffffffffe0L,
    },{ .name = "POR_MXP_P1_BYTE_PAR_ERR_INJ_U_SMXP_4_1",
        .addr = A_POR_MXP_P1_BYTE_PAR_ERR_INJ_U_SMXP_4_1,
        .rsvd = 0xffffffffffffffe0L,
        .ro = 0xffffffffffffffe0L,
    },{ .name = "POR_MXP_ERRFR_NS_U_SMXP_4_1",
        .addr = A_POR_MXP_ERRFR_NS_U_SMXP_4_1,
        .rsvd = 0x300,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MXP_ERRCTLR_NS_U_SMXP_4_1",
        .addr = A_POR_MXP_ERRCTLR_NS_U_SMXP_4_1,
        .rsvd = 0xf0,
        .ro = 0xfffffffffffffef0L,
    },{ .name = "POR_MXP_ERRSTATUS_NS_U_SMXP_4_1",
        .addr = A_POR_MXP_ERRSTATUS_NS_U_SMXP_4_1,
        .ro = 0xffffffff127fffffL,
    },{ .name = "POR_MXP_ERRMISC_NS_U_SMXP_4_1",
        .addr = A_POR_MXP_ERRMISC_NS_U_SMXP_4_1,
        .rsvd = 0x8,
        .ro = 0xf800ffffffc08008L,
    },{ .name = "POR_CXG_HA_NODE_INFO_U_CXRH_NID264",
        .addr = A_POR_CXG_HA_NODE_INFO_U_CXRH_NID264,
        .reset = 0x1080101,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CXG_HA_ID_U_CXRH_NID264",
        .addr = A_POR_CXG_HA_ID_U_CXRH_NID264,
        .rsvd = 0xffffffffffffffc0L,
        .ro = 0xffffffffffffffc0L,
    },{ .name = "POR_CXG_HA_CHILD_INFO_U_CXRH_NID264",
        .addr = A_POR_CXG_HA_CHILD_INFO_U_CXRH_NID264,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CXG_HA_UNIT_INFO_U_CXRH_NID264",
        .addr = A_POR_CXG_HA_UNIT_INFO_U_CXRH_NID264,
        .reset = 0x8402060301810080L,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CXG_HA_SECURE_REGISTER_GROUPS_OVERRIDE_U_CXRH_NID264",
        .addr = A_POR_CXG_HA_SECURE_REGISTER_GROUPS_OVERRIDE_U_CXRH_NID264,
        .rsvd = 0xfffffffffffffffcL,
        .ro = 0xfffffffffffffffcL,
    },{ .name = "POR_CXG_HA_AUX_CTL_U_CXRH_NID264",
        .addr = A_POR_CXG_HA_AUX_CTL_U_CXRH_NID264,
        .reset = 0x8,
        .rsvd = 0xffffffffffffffc0L,
        .ro = 0xffffffffffffffc0L,
    },{ .name = "POR_CXG_HA_RNF_RAID_TO_LDID_REG0_U_CXRH_NID264",
        .addr = A_POR_CXG_HA_RNF_RAID_TO_LDID_REG0_U_CXRH_NID264,
        .rsvd = 0x40,
        .ro = 0x4040404040404040,
    },{ .name = "POR_CXG_HA_RNF_RAID_TO_LDID_REG1_U_CXRH_NID264",
        .addr = A_POR_CXG_HA_RNF_RAID_TO_LDID_REG1_U_CXRH_NID264,
        .rsvd = 0x40,
        .ro = 0x4040404040404040,
    },{ .name = "POR_CXG_HA_RNF_RAID_TO_LDID_REG2_U_CXRH_NID264",
        .addr = A_POR_CXG_HA_RNF_RAID_TO_LDID_REG2_U_CXRH_NID264,
        .rsvd = 0x40,
        .ro = 0x4040404040404040,
    },{ .name = "POR_CXG_HA_RNF_RAID_TO_LDID_REG3_U_CXRH_NID264",
        .addr = A_POR_CXG_HA_RNF_RAID_TO_LDID_REG3_U_CXRH_NID264,
        .rsvd = 0x40,
        .ro = 0x4040404040404040,
    },{ .name = "POR_CXG_HA_RNF_RAID_TO_LDID_REG4_U_CXRH_NID264",
        .addr = A_POR_CXG_HA_RNF_RAID_TO_LDID_REG4_U_CXRH_NID264,
        .rsvd = 0x40,
        .ro = 0x4040404040404040,
    },{ .name = "POR_CXG_HA_RNF_RAID_TO_LDID_REG5_U_CXRH_NID264",
        .addr = A_POR_CXG_HA_RNF_RAID_TO_LDID_REG5_U_CXRH_NID264,
        .rsvd = 0x40,
        .ro = 0x4040404040404040,
    },{ .name = "POR_CXG_HA_RNF_RAID_TO_LDID_REG6_U_CXRH_NID264",
        .addr = A_POR_CXG_HA_RNF_RAID_TO_LDID_REG6_U_CXRH_NID264,
        .rsvd = 0x40,
        .ro = 0x4040404040404040,
    },{ .name = "POR_CXG_HA_RNF_RAID_TO_LDID_REG7_U_CXRH_NID264",
        .addr = A_POR_CXG_HA_RNF_RAID_TO_LDID_REG7_U_CXRH_NID264,
        .rsvd = 0x40,
        .ro = 0x4040404040404040,
    },{ .name = "POR_CXG_HA_AGENTID_TO_LINKID_REG0_U_CXRH_NID264",
        .addr = A_POR_CXG_HA_AGENTID_TO_LINKID_REG0_U_CXRH_NID264,
        .rsvd = 0xfc,
        .ro = 0xfcfcfcfcfcfcfcfcL,
    },{ .name = "POR_CXG_HA_AGENTID_TO_LINKID_REG1_U_CXRH_NID264",
        .addr = A_POR_CXG_HA_AGENTID_TO_LINKID_REG1_U_CXRH_NID264,
        .rsvd = 0xfc,
        .ro = 0xfcfcfcfcfcfcfcfcL,
    },{ .name = "POR_CXG_HA_AGENTID_TO_LINKID_REG2_U_CXRH_NID264",
        .addr = A_POR_CXG_HA_AGENTID_TO_LINKID_REG2_U_CXRH_NID264,
        .rsvd = 0xfc,
        .ro = 0xfcfcfcfcfcfcfcfcL,
    },{ .name = "POR_CXG_HA_AGENTID_TO_LINKID_REG3_U_CXRH_NID264",
        .addr = A_POR_CXG_HA_AGENTID_TO_LINKID_REG3_U_CXRH_NID264,
        .rsvd = 0xfc,
        .ro = 0xfcfcfcfcfcfcfcfcL,
    },{ .name = "POR_CXG_HA_AGENTID_TO_LINKID_REG4_U_CXRH_NID264",
        .addr = A_POR_CXG_HA_AGENTID_TO_LINKID_REG4_U_CXRH_NID264,
        .rsvd = 0xfc,
        .ro = 0xfcfcfcfcfcfcfcfcL,
    },{ .name = "POR_CXG_HA_AGENTID_TO_LINKID_REG5_U_CXRH_NID264",
        .addr = A_POR_CXG_HA_AGENTID_TO_LINKID_REG5_U_CXRH_NID264,
        .rsvd = 0xfc,
        .ro = 0xfcfcfcfcfcfcfcfcL,
    },{ .name = "POR_CXG_HA_AGENTID_TO_LINKID_REG6_U_CXRH_NID264",
        .addr = A_POR_CXG_HA_AGENTID_TO_LINKID_REG6_U_CXRH_NID264,
        .rsvd = 0xfc,
        .ro = 0xfcfcfcfcfcfcfcfcL,
    },{ .name = "POR_CXG_HA_AGENTID_TO_LINKID_REG7_U_CXRH_NID264",
        .addr = A_POR_CXG_HA_AGENTID_TO_LINKID_REG7_U_CXRH_NID264,
        .rsvd = 0xfc,
        .ro = 0xfcfcfcfcfcfcfcfcL,
    },{ .name = "POR_CXG_HA_AGENTID_TO_LINKID_VAL_U_CXRH_NID264",
        .addr = A_POR_CXG_HA_AGENTID_TO_LINKID_VAL_U_CXRH_NID264,
    },{ .name = "POR_CXG_HA_RNF_RAID_TO_LDID_VAL_U_CXRH_NID264",
        .addr = A_POR_CXG_HA_RNF_RAID_TO_LDID_VAL_U_CXRH_NID264,
    },{ .name = "POR_CXG_HA_CXPRTCL_LINK0_CTL_U_CXRH_NID264",
        .addr = A_POR_CXG_HA_CXPRTCL_LINK0_CTL_U_CXRH_NID264,
        .ro = 0xfffffffffffff000L,
    },{ .name = "POR_CXG_HA_CXPRTCL_LINK0_STATUS_U_CXRH_NID264",
        .addr = A_POR_CXG_HA_CXPRTCL_LINK0_STATUS_U_CXRH_NID264,
        .reset = 0x2,
        .rsvd = 0xfffffffffffffff8L,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CXG_HA_CXPRTCL_LINK1_CTL_U_CXRH_NID264",
        .addr = A_POR_CXG_HA_CXPRTCL_LINK1_CTL_U_CXRH_NID264,
        .ro = 0xfffffffffffff000L,
    },{ .name = "POR_CXG_HA_CXPRTCL_LINK1_STATUS_U_CXRH_NID264",
        .addr = A_POR_CXG_HA_CXPRTCL_LINK1_STATUS_U_CXRH_NID264,
        .reset = 0x2,
        .rsvd = 0xfffffffffffffff8L,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CXG_HA_CXPRTCL_LINK2_CTL_U_CXRH_NID264",
        .addr = A_POR_CXG_HA_CXPRTCL_LINK2_CTL_U_CXRH_NID264,
        .ro = 0xfffffffffffff000L,
    },{ .name = "POR_CXG_HA_CXPRTCL_LINK2_STATUS_U_CXRH_NID264",
        .addr = A_POR_CXG_HA_CXPRTCL_LINK2_STATUS_U_CXRH_NID264,
        .reset = 0x2,
        .rsvd = 0xfffffffffffffff8L,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CXG_HA_PMU_EVENT_SEL_U_CXRH_NID264",
        .addr = A_POR_CXG_HA_PMU_EVENT_SEL_U_CXRH_NID264,
        .rsvd = 0xc0,
        .ro = 0xfffffff0c0c0c0c0L,
    },{ .name = "POR_CXG_HA_ERRFR_U_CXRH_NID264",
        .addr = A_POR_CXG_HA_ERRFR_U_CXRH_NID264,
        .reset = 0xa5,
        .rsvd = 0x300,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CXG_HA_ERRCTLR_U_CXRH_NID264",
        .addr = A_POR_CXG_HA_ERRCTLR_U_CXRH_NID264,
        .rsvd = 0xf0,
        .ro = 0xfffffffffffffef0L,
    },{ .name = "POR_CXG_HA_ERRSTATUS_U_CXRH_NID264",
        .addr = A_POR_CXG_HA_ERRSTATUS_U_CXRH_NID264,
        .ro = 0xffffffff127fffffL,
    },{ .name = "POR_CXG_HA_ERRADDR_U_CXRH_NID264",
        .addr = A_POR_CXG_HA_ERRADDR_U_CXRH_NID264,
        .ro = 0x7fff000000000000,
    },{ .name = "POR_CXG_HA_ERRMISC_U_CXRH_NID264",
        .addr = A_POR_CXG_HA_ERRMISC_U_CXRH_NID264,
        .rsvd = 0xc,
        .ro = 0xff00fffffffffc0cL,
    },{ .name = "POR_CXG_HA_ERRFR_NS_U_CXRH_NID264",
        .addr = A_POR_CXG_HA_ERRFR_NS_U_CXRH_NID264,
        .reset = 0xa5,
        .rsvd = 0x300,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CXG_HA_ERRCTLR_NS_U_CXRH_NID264",
        .addr = A_POR_CXG_HA_ERRCTLR_NS_U_CXRH_NID264,
        .rsvd = 0xf0,
        .ro = 0xfffffffffffffef0L,
    },{ .name = "POR_CXG_HA_ERRSTATUS_NS_U_CXRH_NID264",
        .addr = A_POR_CXG_HA_ERRSTATUS_NS_U_CXRH_NID264,
        .ro = 0xffffffff127fffffL,
    },{ .name = "POR_CXG_HA_ERRADDR_NS_U_CXRH_NID264",
        .addr = A_POR_CXG_HA_ERRADDR_NS_U_CXRH_NID264,
        .ro = 0x7fff000000000000,
    },{ .name = "POR_CXG_HA_ERRMISC_NS_U_CXRH_NID264",
        .addr = A_POR_CXG_HA_ERRMISC_NS_U_CXRH_NID264,
        .rsvd = 0xc,
        .ro = 0xff00fffffffffc0cL,
    },{ .name = "POR_CXLA_NODE_INFO_U_CXRH_NID264",
        .addr = A_POR_CXLA_NODE_INFO_U_CXRH_NID264,
        .reset = 0x1080102,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CXLA_CHILD_INFO_U_CXRH_NID264",
        .addr = A_POR_CXLA_CHILD_INFO_U_CXRH_NID264,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CXLA_UNIT_INFO_U_CXRH_NID264",
        .addr = A_POR_CXLA_UNIT_INFO_U_CXRH_NID264,
        .reset = 0x82207,
        .rsvd = 0xe0,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CXLA_SECURE_REGISTER_GROUPS_OVERRIDE_U_CXRH_NID264",
        .addr = A_POR_CXLA_SECURE_REGISTER_GROUPS_OVERRIDE_U_CXRH_NID264,
        .rsvd = 0xfffffffffffffffaL,
        .ro = 0xfffffffffffffffaL,
    },{ .name = "POR_CXLA_AUX_CTL_U_CXRH_NID264",
        .addr = A_POR_CXLA_AUX_CTL_U_CXRH_NID264,
        .reset = 0x220000000180,
        .rsvd = 0x7e,
        .ro = 0xffff88888888887eL,
    },{ .name = "POR_CXLA_CCIX_PROP_CAPABILITIES_U_CXRH_NID264",
        .addr = A_POR_CXLA_CCIX_PROP_CAPABILITIES_U_CXRH_NID264,
        .reset = 0x100,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CXLA_CCIX_PROP_CONFIGURED_U_CXRH_NID264",
        .addr = A_POR_CXLA_CCIX_PROP_CONFIGURED_U_CXRH_NID264,
        .reset = 0x400,
        .ro = 0xfffffffffffff800L,
    },{ .name = "POR_CXLA_TX_CXS_ATTR_CAPABILITIES_U_CXRH_NID264",
        .addr = A_POR_CXLA_TX_CXS_ATTR_CAPABILITIES_U_CXRH_NID264,
        .reset = 0x30,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CXLA_RX_CXS_ATTR_CAPABILITIES_U_CXRH_NID264",
        .addr = A_POR_CXLA_RX_CXS_ATTR_CAPABILITIES_U_CXRH_NID264,
        .reset = 0x20,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_CXLA_AGENTID_TO_LINKID_REG0_U_CXRH_NID264",
        .addr = A_POR_CXLA_AGENTID_TO_LINKID_REG0_U_CXRH_NID264,
        .rsvd = 0xfc,
        .ro = 0xfcfcfcfcfcfcfcfcL,
    },{ .name = "POR_CXLA_AGENTID_TO_LINKID_REG1_U_CXRH_NID264",
        .addr = A_POR_CXLA_AGENTID_TO_LINKID_REG1_U_CXRH_NID264,
        .rsvd = 0xfc,
        .ro = 0xfcfcfcfcfcfcfcfcL,
    },{ .name = "POR_CXLA_AGENTID_TO_LINKID_REG2_U_CXRH_NID264",
        .addr = A_POR_CXLA_AGENTID_TO_LINKID_REG2_U_CXRH_NID264,
        .rsvd = 0xfc,
        .ro = 0xfcfcfcfcfcfcfcfcL,
    },{ .name = "POR_CXLA_AGENTID_TO_LINKID_REG3_U_CXRH_NID264",
        .addr = A_POR_CXLA_AGENTID_TO_LINKID_REG3_U_CXRH_NID264,
        .rsvd = 0xfc,
        .ro = 0xfcfcfcfcfcfcfcfcL,
    },{ .name = "POR_CXLA_AGENTID_TO_LINKID_REG4_U_CXRH_NID264",
        .addr = A_POR_CXLA_AGENTID_TO_LINKID_REG4_U_CXRH_NID264,
        .rsvd = 0xfc,
        .ro = 0xfcfcfcfcfcfcfcfcL,
    },{ .name = "POR_CXLA_AGENTID_TO_LINKID_REG5_U_CXRH_NID264",
        .addr = A_POR_CXLA_AGENTID_TO_LINKID_REG5_U_CXRH_NID264,
        .rsvd = 0xfc,
        .ro = 0xfcfcfcfcfcfcfcfcL,
    },{ .name = "POR_CXLA_AGENTID_TO_LINKID_REG6_U_CXRH_NID264",
        .addr = A_POR_CXLA_AGENTID_TO_LINKID_REG6_U_CXRH_NID264,
        .rsvd = 0xfc,
        .ro = 0xfcfcfcfcfcfcfcfcL,
    },{ .name = "POR_CXLA_AGENTID_TO_LINKID_REG7_U_CXRH_NID264",
        .addr = A_POR_CXLA_AGENTID_TO_LINKID_REG7_U_CXRH_NID264,
        .rsvd = 0xfc,
        .ro = 0xfcfcfcfcfcfcfcfcL,
    },{ .name = "POR_CXLA_AGENTID_TO_LINKID_VAL_U_CXRH_NID264",
        .addr = A_POR_CXLA_AGENTID_TO_LINKID_VAL_U_CXRH_NID264,
    },{ .name = "POR_CXLA_LINKID_TO_PCIE_BUS_NUM_U_CXRH_NID264",
        .addr = A_POR_CXLA_LINKID_TO_PCIE_BUS_NUM_U_CXRH_NID264,
        .ro = 0xffff000000000000L,
    },{ .name = "POR_CXLA_TLP_HDR_FIELDS_U_CXRH_NID264",
        .addr = A_POR_CXLA_TLP_HDR_FIELDS_U_CXRH_NID264,
        .reset = 0x7f000072,
        .ro = 0xffff000000f80000L,
    },{ .name = "POR_CXLA_PERMSG_PYLD_0_63_U_CXRH_NID264",
        .addr = A_POR_CXLA_PERMSG_PYLD_0_63_U_CXRH_NID264,
    },{ .name = "POR_CXLA_PERMSG_PYLD_64_127_U_CXRH_NID264",
        .addr = A_POR_CXLA_PERMSG_PYLD_64_127_U_CXRH_NID264,
    },{ .name = "POR_CXLA_PERMSG_PYLD_128_191_U_CXRH_NID264",
        .addr = A_POR_CXLA_PERMSG_PYLD_128_191_U_CXRH_NID264,
    },{ .name = "POR_CXLA_PERMSG_PYLD_192_255_U_CXRH_NID264",
        .addr = A_POR_CXLA_PERMSG_PYLD_192_255_U_CXRH_NID264,
    },{ .name = "POR_CXLA_PERMSG_CTL_U_CXRH_NID264",
        .addr = A_POR_CXLA_PERMSG_CTL_U_CXRH_NID264,
        .rsvd = 0xfc,
        .ro = 0xffffffffffffc0fcL,
    },{ .name = "POR_CXLA_ERR_AGENT_ID_U_CXRH_NID264",
        .addr = A_POR_CXLA_ERR_AGENT_ID_U_CXRH_NID264,
        .rsvd = 0xffffffffffffffc0L,
        .ro = 0xffffffffffffffc0L,
    },{ .name = "POR_CXLA_PMU_EVENT_SEL_U_CXRH_NID264",
        .addr = A_POR_CXLA_PMU_EVENT_SEL_U_CXRH_NID264,
        .rsvd = 0xe0,
        .ro = 0xffffffffe0e0e0e0L,
    },{ .name = "POR_CXLA_PMU_CONFIG_U_CXRH_NID264",
        .addr = A_POR_CXLA_PMU_CONFIG_U_CXRH_NID264,
        .ro = 0xffffffff8888fe00L,
    },{ .name = "POR_CXLA_PMEVCNT_U_CXRH_NID264",
        .addr = A_POR_CXLA_PMEVCNT_U_CXRH_NID264,
    },{ .name = "POR_CXLA_PMEVCNTSR_U_CXRH_NID264",
        .addr = A_POR_CXLA_PMEVCNTSR_U_CXRH_NID264,
    },{ .name = "POR_FDC_NODE_INFO_U_SMXP_4_1",
        .addr = A_POR_FDC_NODE_INFO_U_SMXP_4_1,
        .reset = 0x201,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_FDC_CHILD_INFO_U_SMXP_4_1",
        .addr = A_POR_FDC_CHILD_INFO_U_SMXP_4_1,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_ERRFR_MXP_U_SMXP_4_1",  .addr = A_POR_ERRFR_MXP_U_SMXP_4_1,
        .reset = 0xa1,
        .rsvd = 0xffffffffffffff0cL,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_ERRCTLR_MXP_U_SMXP_4_1",
        .addr = A_POR_ERRCTLR_MXP_U_SMXP_4_1,
        .reset = 0xd,
        .rsvd = 0x3ff2,
        .ro = 0xffffffff00003ff2L,
    },{ .name = "POR_ERRSTATUS_MXP_U_SMXP_4_1",
        .addr = A_POR_ERRSTATUS_MXP_U_SMXP_4_1,
        .ro = 0xffffffff977f003fL,
    },{ .name = "POR_FDC_AUX_CTL_MXP_U_SMXP_4_1",
        .addr = A_POR_FDC_AUX_CTL_MXP_U_SMXP_4_1,
        .rsvd = 0xffffffffffffffe0L,
        .ro = 0xffffffffffffffefL,
    },{ .name = "POR_ERRFR_P0_D0_U_SMXP_4_1",
        .addr = A_POR_ERRFR_P0_D0_U_SMXP_4_1,
        .reset = 0xa1,
        .rsvd = 0xffffffffffffff0cL,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_ERRCTLR_P0_D0_U_SMXP_4_1",
        .addr = A_POR_ERRCTLR_P0_D0_U_SMXP_4_1,
        .reset = 0xd,
        .rsvd = 0x3ff2,
        .ro = 0xffffffff00003ff2L,
    },{ .name = "POR_ERRSTATUS_P0_D0_U_SMXP_4_1",
        .addr = A_POR_ERRSTATUS_P0_D0_U_SMXP_4_1,
        .ro = 0xffffffff977f003fL,
    },{ .name = "POR_FDC_AUX_CTL_P0_D0_U_SMXP_4_1",
        .addr = A_POR_FDC_AUX_CTL_P0_D0_U_SMXP_4_1,
        .rsvd = 0xffffffffffffffe0L,
        .ro = 0xffffffffffffffe0L,
    },{ .name = "POR_ERRFR_P0_D1_U_SMXP_4_1",
        .addr = A_POR_ERRFR_P0_D1_U_SMXP_4_1,
        .reset = 0xa1,
        .rsvd = 0xffffffffffffff0cL,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_ERRCTLR_P0_D1_U_SMXP_4_1",
        .addr = A_POR_ERRCTLR_P0_D1_U_SMXP_4_1,
        .reset = 0xd,
        .rsvd = 0x3ff2,
        .ro = 0xffffffff00003ff2L,
    },{ .name = "POR_ERRSTATUS_P0_D1_U_SMXP_4_1",
        .addr = A_POR_ERRSTATUS_P0_D1_U_SMXP_4_1,
        .ro = 0xffffffff977f003fL,
    },{ .name = "POR_FDC_AUX_CTL_P0_D1_U_SMXP_4_1",
        .addr = A_POR_FDC_AUX_CTL_P0_D1_U_SMXP_4_1,
        .rsvd = 0xffffffffffffffe0L,
        .ro = 0xffffffffffffffe0L,
    },{ .name = "POR_ERRFR_P0_D2_U_SMXP_4_1",
        .addr = A_POR_ERRFR_P0_D2_U_SMXP_4_1,
        .reset = 0xa1,
        .rsvd = 0xffffffffffffff0cL,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_ERRCTLR_P0_D2_U_SMXP_4_1",
        .addr = A_POR_ERRCTLR_P0_D2_U_SMXP_4_1,
        .reset = 0xd,
        .rsvd = 0x3ff2,
        .ro = 0xffffffff00003ff2L,
    },{ .name = "POR_ERRSTATUS_P0_D2_U_SMXP_4_1",
        .addr = A_POR_ERRSTATUS_P0_D2_U_SMXP_4_1,
        .ro = 0xffffffff977f003fL,
    },{ .name = "POR_FDC_AUX_CTL_P0_D2_U_SMXP_4_1",
        .addr = A_POR_FDC_AUX_CTL_P0_D2_U_SMXP_4_1,
        .rsvd = 0xffffffffffffffe0L,
        .ro = 0xffffffffffffffe0L,
    },{ .name = "POR_ERRFR_P0_D3_U_SMXP_4_1",
        .addr = A_POR_ERRFR_P0_D3_U_SMXP_4_1,
        .reset = 0xa1,
        .rsvd = 0xffffffffffffff0cL,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_ERRCTLR_P0_D3_U_SMXP_4_1",
        .addr = A_POR_ERRCTLR_P0_D3_U_SMXP_4_1,
        .reset = 0xd,
        .rsvd = 0x3ff2,
        .ro = 0xffffffff00003ff2L,
    },{ .name = "POR_ERRSTATUS_P0_D3_U_SMXP_4_1",
        .addr = A_POR_ERRSTATUS_P0_D3_U_SMXP_4_1,
        .ro = 0xffffffff977f003fL,
    },{ .name = "POR_FDC_AUX_CTL_P0_D3_U_SMXP_4_1",
        .addr = A_POR_FDC_AUX_CTL_P0_D3_U_SMXP_4_1,
        .rsvd = 0xffffffffffffffe0L,
        .ro = 0xffffffffffffffe0L,
    },{ .name = "POR_ERRFR_P1_D0_U_SMXP_4_1",
        .addr = A_POR_ERRFR_P1_D0_U_SMXP_4_1,
        .reset = 0xa1,
        .rsvd = 0xffffffffffffff0cL,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_ERRCTLR_P1_D0_U_SMXP_4_1",
        .addr = A_POR_ERRCTLR_P1_D0_U_SMXP_4_1,
        .reset = 0xd,
        .rsvd = 0x3ff2,
        .ro = 0xffffffff00003ff2L,
    },{ .name = "POR_ERRSTATUS_P1_D0_U_SMXP_4_1",
        .addr = A_POR_ERRSTATUS_P1_D0_U_SMXP_4_1,
        .ro = 0xffffffff977f003fL,
    },{ .name = "POR_FDC_AUX_CTL_P1_D0_U_SMXP_4_1",
        .addr = A_POR_FDC_AUX_CTL_P1_D0_U_SMXP_4_1,
        .rsvd = 0xffffffffffffffe0L,
        .ro = 0xffffffffffffffe0L,
    },{ .name = "POR_ERRFR_P1_D1_U_SMXP_4_1",
        .addr = A_POR_ERRFR_P1_D1_U_SMXP_4_1,
        .reset = 0xa1,
        .rsvd = 0xffffffffffffff0cL,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_ERRCTLR_P1_D1_U_SMXP_4_1",
        .addr = A_POR_ERRCTLR_P1_D1_U_SMXP_4_1,
        .reset = 0xd,
        .rsvd = 0x3ff2,
        .ro = 0xffffffff00003ff2L,
    },{ .name = "POR_ERRSTATUS_P1_D1_U_SMXP_4_1",
        .addr = A_POR_ERRSTATUS_P1_D1_U_SMXP_4_1,
        .ro = 0xffffffff977f003fL,
    },{ .name = "POR_FDC_AUX_CTL_P1_D1_U_SMXP_4_1",
        .addr = A_POR_FDC_AUX_CTL_P1_D1_U_SMXP_4_1,
        .rsvd = 0xffffffffffffffe0L,
        .ro = 0xffffffffffffffe0L,
    },{ .name = "POR_ERRFR_P1_D2_U_SMXP_4_1",
        .addr = A_POR_ERRFR_P1_D2_U_SMXP_4_1,
        .reset = 0xa1,
        .rsvd = 0xffffffffffffff0cL,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_ERRCTLR_P1_D2_U_SMXP_4_1",
        .addr = A_POR_ERRCTLR_P1_D2_U_SMXP_4_1,
        .reset = 0xd,
        .rsvd = 0x3ff2,
        .ro = 0xffffffff00003ff2L,
    },{ .name = "POR_ERRSTATUS_P1_D2_U_SMXP_4_1",
        .addr = A_POR_ERRSTATUS_P1_D2_U_SMXP_4_1,
        .ro = 0xffffffff977f003fL,
    },{ .name = "POR_FDC_AUX_CTL_P1_D2_U_SMXP_4_1",
        .addr = A_POR_FDC_AUX_CTL_P1_D2_U_SMXP_4_1,
        .rsvd = 0xffffffffffffffe0L,
        .ro = 0xffffffffffffffe0L,
    },{ .name = "POR_ERRFR_P1_D3_U_SMXP_4_1",
        .addr = A_POR_ERRFR_P1_D3_U_SMXP_4_1,
        .reset = 0xa1,
        .rsvd = 0xffffffffffffff0cL,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_ERRCTLR_P1_D3_U_SMXP_4_1",
        .addr = A_POR_ERRCTLR_P1_D3_U_SMXP_4_1,
        .reset = 0xd,
        .rsvd = 0x3ff2,
        .ro = 0xffffffff00003ff2L,
    },{ .name = "POR_ERRSTATUS_P1_D3_U_SMXP_4_1",
        .addr = A_POR_ERRSTATUS_P1_D3_U_SMXP_4_1,
        .ro = 0xffffffff977f003fL,
    },{ .name = "POR_FDC_AUX_CTL_P1_D3_U_SMXP_4_1",
        .addr = A_POR_FDC_AUX_CTL_P1_D3_U_SMXP_4_1,
        .rsvd = 0xffffffffffffffe0L,
        .ro = 0xffffffffffffffe0L,
    },{ .name = "POR_ERRINJECT_U_SMXP_4_1",  .addr = A_POR_ERRINJECT_U_SMXP_4_1,
        .rsvd = 0xffffffffffffff00L,
        .ro = 0xffffffffffffff00L,
    },{ .name = "POR_FDC_KEY_U_SMXP_4_1",  .addr = A_POR_FDC_KEY_U_SMXP_4_1,
        .reset = 0xbe,
        .rsvd = 0xffffffffffffff00L,
        .ro = 0xffffffffffffff00L,
    },{ .name = "POR_MPU_NODE_INFO_U_SMXP_4_1",
        .addr = A_POR_MPU_NODE_INFO_U_SMXP_4_1,
        .reset = 0x202,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MPU_CHILD_INFO_U_SMXP_4_1",
        .addr = A_POR_MPU_CHILD_INFO_U_SMXP_4_1,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MPU_UNIT_INFO_U_SMXP_4_1",
        .addr = A_POR_MPU_UNIT_INFO_U_SMXP_4_1,
        .reset = 0x20,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MPU_M0_CTL_U_SMXP_4_1",
        .addr = A_POR_MPU_M0_CTL_U_SMXP_4_1,
        .reset = 0x2,
        .rsvd = 0xfffffffffffffff8L,
        .ro = 0xfffffffffffffff8L,
    },{ .name = "POR_MPU_M0_PRBAR0_U_SMXP_4_1",
        .addr = A_POR_MPU_M0_PRBAR0_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR0_U_SMXP_4_1",
        .addr = A_POR_MPU_M0_PRLAR0_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR1_U_SMXP_4_1",
        .addr = A_POR_MPU_M0_PRBAR1_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR1_U_SMXP_4_1",
        .addr = A_POR_MPU_M0_PRLAR1_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR2_U_SMXP_4_1",
        .addr = A_POR_MPU_M0_PRBAR2_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR2_U_SMXP_4_1",
        .addr = A_POR_MPU_M0_PRLAR2_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR3_U_SMXP_4_1",
        .addr = A_POR_MPU_M0_PRBAR3_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR3_U_SMXP_4_1",
        .addr = A_POR_MPU_M0_PRLAR3_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR4_U_SMXP_4_1",
        .addr = A_POR_MPU_M0_PRBAR4_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR4_U_SMXP_4_1",
        .addr = A_POR_MPU_M0_PRLAR4_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR5_U_SMXP_4_1",
        .addr = A_POR_MPU_M0_PRBAR5_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR5_U_SMXP_4_1",
        .addr = A_POR_MPU_M0_PRLAR5_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR6_U_SMXP_4_1",
        .addr = A_POR_MPU_M0_PRBAR6_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR6_U_SMXP_4_1",
        .addr = A_POR_MPU_M0_PRLAR6_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR7_U_SMXP_4_1",
        .addr = A_POR_MPU_M0_PRBAR7_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR7_U_SMXP_4_1",
        .addr = A_POR_MPU_M0_PRLAR7_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR8_U_SMXP_4_1",
        .addr = A_POR_MPU_M0_PRBAR8_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR8_U_SMXP_4_1",
        .addr = A_POR_MPU_M0_PRLAR8_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR9_U_SMXP_4_1",
        .addr = A_POR_MPU_M0_PRBAR9_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR9_U_SMXP_4_1",
        .addr = A_POR_MPU_M0_PRLAR9_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR10_U_SMXP_4_1",
        .addr = A_POR_MPU_M0_PRBAR10_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR10_U_SMXP_4_1",
        .addr = A_POR_MPU_M0_PRLAR10_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR11_U_SMXP_4_1",
        .addr = A_POR_MPU_M0_PRBAR11_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR11_U_SMXP_4_1",
        .addr = A_POR_MPU_M0_PRLAR11_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR12_U_SMXP_4_1",
        .addr = A_POR_MPU_M0_PRBAR12_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR12_U_SMXP_4_1",
        .addr = A_POR_MPU_M0_PRLAR12_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR13_U_SMXP_4_1",
        .addr = A_POR_MPU_M0_PRBAR13_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR13_U_SMXP_4_1",
        .addr = A_POR_MPU_M0_PRLAR13_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR14_U_SMXP_4_1",
        .addr = A_POR_MPU_M0_PRBAR14_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR14_U_SMXP_4_1",
        .addr = A_POR_MPU_M0_PRLAR14_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR15_U_SMXP_4_1",
        .addr = A_POR_MPU_M0_PRBAR15_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR15_U_SMXP_4_1",
        .addr = A_POR_MPU_M0_PRLAR15_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR16_U_SMXP_4_1",
        .addr = A_POR_MPU_M0_PRBAR16_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR16_U_SMXP_4_1",
        .addr = A_POR_MPU_M0_PRLAR16_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR17_U_SMXP_4_1",
        .addr = A_POR_MPU_M0_PRBAR17_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR17_U_SMXP_4_1",
        .addr = A_POR_MPU_M0_PRLAR17_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR18_U_SMXP_4_1",
        .addr = A_POR_MPU_M0_PRBAR18_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR18_U_SMXP_4_1",
        .addr = A_POR_MPU_M0_PRLAR18_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR19_U_SMXP_4_1",
        .addr = A_POR_MPU_M0_PRBAR19_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR19_U_SMXP_4_1",
        .addr = A_POR_MPU_M0_PRLAR19_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR20_U_SMXP_4_1",
        .addr = A_POR_MPU_M0_PRBAR20_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR20_U_SMXP_4_1",
        .addr = A_POR_MPU_M0_PRLAR20_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR21_U_SMXP_4_1",
        .addr = A_POR_MPU_M0_PRBAR21_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR21_U_SMXP_4_1",
        .addr = A_POR_MPU_M0_PRLAR21_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR22_U_SMXP_4_1",
        .addr = A_POR_MPU_M0_PRBAR22_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR22_U_SMXP_4_1",
        .addr = A_POR_MPU_M0_PRLAR22_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR23_U_SMXP_4_1",
        .addr = A_POR_MPU_M0_PRBAR23_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR23_U_SMXP_4_1",
        .addr = A_POR_MPU_M0_PRLAR23_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR24_U_SMXP_4_1",
        .addr = A_POR_MPU_M0_PRBAR24_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR24_U_SMXP_4_1",
        .addr = A_POR_MPU_M0_PRLAR24_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR25_U_SMXP_4_1",
        .addr = A_POR_MPU_M0_PRBAR25_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR25_U_SMXP_4_1",
        .addr = A_POR_MPU_M0_PRLAR25_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR26_U_SMXP_4_1",
        .addr = A_POR_MPU_M0_PRBAR26_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR26_U_SMXP_4_1",
        .addr = A_POR_MPU_M0_PRLAR26_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR27_U_SMXP_4_1",
        .addr = A_POR_MPU_M0_PRBAR27_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR27_U_SMXP_4_1",
        .addr = A_POR_MPU_M0_PRLAR27_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR28_U_SMXP_4_1",
        .addr = A_POR_MPU_M0_PRBAR28_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR28_U_SMXP_4_1",
        .addr = A_POR_MPU_M0_PRLAR28_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR29_U_SMXP_4_1",
        .addr = A_POR_MPU_M0_PRBAR29_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR29_U_SMXP_4_1",
        .addr = A_POR_MPU_M0_PRLAR29_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR30_U_SMXP_4_1",
        .addr = A_POR_MPU_M0_PRBAR30_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR30_U_SMXP_4_1",
        .addr = A_POR_MPU_M0_PRLAR30_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR31_U_SMXP_4_1",
        .addr = A_POR_MPU_M0_PRBAR31_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR31_U_SMXP_4_1",
        .addr = A_POR_MPU_M0_PRLAR31_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_CTL_U_SMXP_4_1",
        .addr = A_POR_MPU_M1_CTL_U_SMXP_4_1,
        .reset = 0x2,
        .rsvd = 0xfffffffffffffff8L,
        .ro = 0xfffffffffffffff8L,
    },{ .name = "POR_MPU_M1_PRBAR0_U_SMXP_4_1",
        .addr = A_POR_MPU_M1_PRBAR0_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR0_U_SMXP_4_1",
        .addr = A_POR_MPU_M1_PRLAR0_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR1_U_SMXP_4_1",
        .addr = A_POR_MPU_M1_PRBAR1_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR1_U_SMXP_4_1",
        .addr = A_POR_MPU_M1_PRLAR1_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR2_U_SMXP_4_1",
        .addr = A_POR_MPU_M1_PRBAR2_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR2_U_SMXP_4_1",
        .addr = A_POR_MPU_M1_PRLAR2_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR3_U_SMXP_4_1",
        .addr = A_POR_MPU_M1_PRBAR3_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR3_U_SMXP_4_1",
        .addr = A_POR_MPU_M1_PRLAR3_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR4_U_SMXP_4_1",
        .addr = A_POR_MPU_M1_PRBAR4_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR4_U_SMXP_4_1",
        .addr = A_POR_MPU_M1_PRLAR4_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR5_U_SMXP_4_1",
        .addr = A_POR_MPU_M1_PRBAR5_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR5_U_SMXP_4_1",
        .addr = A_POR_MPU_M1_PRLAR5_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR6_U_SMXP_4_1",
        .addr = A_POR_MPU_M1_PRBAR6_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR6_U_SMXP_4_1",
        .addr = A_POR_MPU_M1_PRLAR6_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR7_U_SMXP_4_1",
        .addr = A_POR_MPU_M1_PRBAR7_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR7_U_SMXP_4_1",
        .addr = A_POR_MPU_M1_PRLAR7_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR8_U_SMXP_4_1",
        .addr = A_POR_MPU_M1_PRBAR8_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR8_U_SMXP_4_1",
        .addr = A_POR_MPU_M1_PRLAR8_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR9_U_SMXP_4_1",
        .addr = A_POR_MPU_M1_PRBAR9_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR9_U_SMXP_4_1",
        .addr = A_POR_MPU_M1_PRLAR9_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR10_U_SMXP_4_1",
        .addr = A_POR_MPU_M1_PRBAR10_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR10_U_SMXP_4_1",
        .addr = A_POR_MPU_M1_PRLAR10_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR11_U_SMXP_4_1",
        .addr = A_POR_MPU_M1_PRBAR11_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR11_U_SMXP_4_1",
        .addr = A_POR_MPU_M1_PRLAR11_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR12_U_SMXP_4_1",
        .addr = A_POR_MPU_M1_PRBAR12_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR12_U_SMXP_4_1",
        .addr = A_POR_MPU_M1_PRLAR12_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR13_U_SMXP_4_1",
        .addr = A_POR_MPU_M1_PRBAR13_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR13_U_SMXP_4_1",
        .addr = A_POR_MPU_M1_PRLAR13_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR14_U_SMXP_4_1",
        .addr = A_POR_MPU_M1_PRBAR14_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR14_U_SMXP_4_1",
        .addr = A_POR_MPU_M1_PRLAR14_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR15_U_SMXP_4_1",
        .addr = A_POR_MPU_M1_PRBAR15_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR15_U_SMXP_4_1",
        .addr = A_POR_MPU_M1_PRLAR15_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR16_U_SMXP_4_1",
        .addr = A_POR_MPU_M1_PRBAR16_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR16_U_SMXP_4_1",
        .addr = A_POR_MPU_M1_PRLAR16_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR17_U_SMXP_4_1",
        .addr = A_POR_MPU_M1_PRBAR17_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR17_U_SMXP_4_1",
        .addr = A_POR_MPU_M1_PRLAR17_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR18_U_SMXP_4_1",
        .addr = A_POR_MPU_M1_PRBAR18_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR18_U_SMXP_4_1",
        .addr = A_POR_MPU_M1_PRLAR18_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR19_U_SMXP_4_1",
        .addr = A_POR_MPU_M1_PRBAR19_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR19_U_SMXP_4_1",
        .addr = A_POR_MPU_M1_PRLAR19_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR20_U_SMXP_4_1",
        .addr = A_POR_MPU_M1_PRBAR20_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR20_U_SMXP_4_1",
        .addr = A_POR_MPU_M1_PRLAR20_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR21_U_SMXP_4_1",
        .addr = A_POR_MPU_M1_PRBAR21_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR21_U_SMXP_4_1",
        .addr = A_POR_MPU_M1_PRLAR21_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR22_U_SMXP_4_1",
        .addr = A_POR_MPU_M1_PRBAR22_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR22_U_SMXP_4_1",
        .addr = A_POR_MPU_M1_PRLAR22_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR23_U_SMXP_4_1",
        .addr = A_POR_MPU_M1_PRBAR23_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR23_U_SMXP_4_1",
        .addr = A_POR_MPU_M1_PRLAR23_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR24_U_SMXP_4_1",
        .addr = A_POR_MPU_M1_PRBAR24_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR24_U_SMXP_4_1",
        .addr = A_POR_MPU_M1_PRLAR24_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR25_U_SMXP_4_1",
        .addr = A_POR_MPU_M1_PRBAR25_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR25_U_SMXP_4_1",
        .addr = A_POR_MPU_M1_PRLAR25_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR26_U_SMXP_4_1",
        .addr = A_POR_MPU_M1_PRBAR26_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR26_U_SMXP_4_1",
        .addr = A_POR_MPU_M1_PRLAR26_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR27_U_SMXP_4_1",
        .addr = A_POR_MPU_M1_PRBAR27_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR27_U_SMXP_4_1",
        .addr = A_POR_MPU_M1_PRLAR27_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR28_U_SMXP_4_1",
        .addr = A_POR_MPU_M1_PRBAR28_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR28_U_SMXP_4_1",
        .addr = A_POR_MPU_M1_PRLAR28_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR29_U_SMXP_4_1",
        .addr = A_POR_MPU_M1_PRBAR29_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR29_U_SMXP_4_1",
        .addr = A_POR_MPU_M1_PRLAR29_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR30_U_SMXP_4_1",
        .addr = A_POR_MPU_M1_PRBAR30_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR30_U_SMXP_4_1",
        .addr = A_POR_MPU_M1_PRLAR30_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR31_U_SMXP_4_1",
        .addr = A_POR_MPU_M1_PRBAR31_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR31_U_SMXP_4_1",
        .addr = A_POR_MPU_M1_PRLAR31_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_CTL_U_SMXP_4_1",
        .addr = A_POR_MPU_M2_CTL_U_SMXP_4_1,
        .reset = 0x2,
        .rsvd = 0xfffffffffffffff8L,
        .ro = 0xfffffffffffffff8L,
    },{ .name = "POR_MPU_M2_PRBAR0_U_SMXP_4_1",
        .addr = A_POR_MPU_M2_PRBAR0_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR0_U_SMXP_4_1",
        .addr = A_POR_MPU_M2_PRLAR0_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR1_U_SMXP_4_1",
        .addr = A_POR_MPU_M2_PRBAR1_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR1_U_SMXP_4_1",
        .addr = A_POR_MPU_M2_PRLAR1_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR2_U_SMXP_4_1",
        .addr = A_POR_MPU_M2_PRBAR2_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR2_U_SMXP_4_1",
        .addr = A_POR_MPU_M2_PRLAR2_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR3_U_SMXP_4_1",
        .addr = A_POR_MPU_M2_PRBAR3_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR3_U_SMXP_4_1",
        .addr = A_POR_MPU_M2_PRLAR3_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR4_U_SMXP_4_1",
        .addr = A_POR_MPU_M2_PRBAR4_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR4_U_SMXP_4_1",
        .addr = A_POR_MPU_M2_PRLAR4_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR5_U_SMXP_4_1",
        .addr = A_POR_MPU_M2_PRBAR5_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR5_U_SMXP_4_1",
        .addr = A_POR_MPU_M2_PRLAR5_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR6_U_SMXP_4_1",
        .addr = A_POR_MPU_M2_PRBAR6_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR6_U_SMXP_4_1",
        .addr = A_POR_MPU_M2_PRLAR6_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR7_U_SMXP_4_1",
        .addr = A_POR_MPU_M2_PRBAR7_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR7_U_SMXP_4_1",
        .addr = A_POR_MPU_M2_PRLAR7_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR8_U_SMXP_4_1",
        .addr = A_POR_MPU_M2_PRBAR8_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR8_U_SMXP_4_1",
        .addr = A_POR_MPU_M2_PRLAR8_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR9_U_SMXP_4_1",
        .addr = A_POR_MPU_M2_PRBAR9_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR9_U_SMXP_4_1",
        .addr = A_POR_MPU_M2_PRLAR9_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR10_U_SMXP_4_1",
        .addr = A_POR_MPU_M2_PRBAR10_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR10_U_SMXP_4_1",
        .addr = A_POR_MPU_M2_PRLAR10_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR11_U_SMXP_4_1",
        .addr = A_POR_MPU_M2_PRBAR11_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR11_U_SMXP_4_1",
        .addr = A_POR_MPU_M2_PRLAR11_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR12_U_SMXP_4_1",
        .addr = A_POR_MPU_M2_PRBAR12_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR12_U_SMXP_4_1",
        .addr = A_POR_MPU_M2_PRLAR12_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR13_U_SMXP_4_1",
        .addr = A_POR_MPU_M2_PRBAR13_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR13_U_SMXP_4_1",
        .addr = A_POR_MPU_M2_PRLAR13_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR14_U_SMXP_4_1",
        .addr = A_POR_MPU_M2_PRBAR14_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR14_U_SMXP_4_1",
        .addr = A_POR_MPU_M2_PRLAR14_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR15_U_SMXP_4_1",
        .addr = A_POR_MPU_M2_PRBAR15_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR15_U_SMXP_4_1",
        .addr = A_POR_MPU_M2_PRLAR15_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR16_U_SMXP_4_1",
        .addr = A_POR_MPU_M2_PRBAR16_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR16_U_SMXP_4_1",
        .addr = A_POR_MPU_M2_PRLAR16_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR17_U_SMXP_4_1",
        .addr = A_POR_MPU_M2_PRBAR17_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR17_U_SMXP_4_1",
        .addr = A_POR_MPU_M2_PRLAR17_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR18_U_SMXP_4_1",
        .addr = A_POR_MPU_M2_PRBAR18_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR18_U_SMXP_4_1",
        .addr = A_POR_MPU_M2_PRLAR18_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR19_U_SMXP_4_1",
        .addr = A_POR_MPU_M2_PRBAR19_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR19_U_SMXP_4_1",
        .addr = A_POR_MPU_M2_PRLAR19_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR20_U_SMXP_4_1",
        .addr = A_POR_MPU_M2_PRBAR20_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR20_U_SMXP_4_1",
        .addr = A_POR_MPU_M2_PRLAR20_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR21_U_SMXP_4_1",
        .addr = A_POR_MPU_M2_PRBAR21_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR21_U_SMXP_4_1",
        .addr = A_POR_MPU_M2_PRLAR21_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR22_U_SMXP_4_1",
        .addr = A_POR_MPU_M2_PRBAR22_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR22_U_SMXP_4_1",
        .addr = A_POR_MPU_M2_PRLAR22_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR23_U_SMXP_4_1",
        .addr = A_POR_MPU_M2_PRBAR23_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR23_U_SMXP_4_1",
        .addr = A_POR_MPU_M2_PRLAR23_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR24_U_SMXP_4_1",
        .addr = A_POR_MPU_M2_PRBAR24_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR24_U_SMXP_4_1",
        .addr = A_POR_MPU_M2_PRLAR24_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR25_U_SMXP_4_1",
        .addr = A_POR_MPU_M2_PRBAR25_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR25_U_SMXP_4_1",
        .addr = A_POR_MPU_M2_PRLAR25_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR26_U_SMXP_4_1",
        .addr = A_POR_MPU_M2_PRBAR26_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR26_U_SMXP_4_1",
        .addr = A_POR_MPU_M2_PRLAR26_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR27_U_SMXP_4_1",
        .addr = A_POR_MPU_M2_PRBAR27_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR27_U_SMXP_4_1",
        .addr = A_POR_MPU_M2_PRLAR27_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR28_U_SMXP_4_1",
        .addr = A_POR_MPU_M2_PRBAR28_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR28_U_SMXP_4_1",
        .addr = A_POR_MPU_M2_PRLAR28_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR29_U_SMXP_4_1",
        .addr = A_POR_MPU_M2_PRBAR29_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR29_U_SMXP_4_1",
        .addr = A_POR_MPU_M2_PRLAR29_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR30_U_SMXP_4_1",
        .addr = A_POR_MPU_M2_PRBAR30_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR30_U_SMXP_4_1",
        .addr = A_POR_MPU_M2_PRLAR30_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR31_U_SMXP_4_1",
        .addr = A_POR_MPU_M2_PRBAR31_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR31_U_SMXP_4_1",
        .addr = A_POR_MPU_M2_PRLAR31_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_CTL_U_SMXP_4_1",
        .addr = A_POR_MPU_M3_CTL_U_SMXP_4_1,
        .reset = 0x2,
        .rsvd = 0xfffffffffffffff8L,
        .ro = 0xfffffffffffffff8L,
    },{ .name = "POR_MPU_M3_PRBAR0_U_SMXP_4_1",
        .addr = A_POR_MPU_M3_PRBAR0_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR0_U_SMXP_4_1",
        .addr = A_POR_MPU_M3_PRLAR0_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR1_U_SMXP_4_1",
        .addr = A_POR_MPU_M3_PRBAR1_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR1_U_SMXP_4_1",
        .addr = A_POR_MPU_M3_PRLAR1_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR2_U_SMXP_4_1",
        .addr = A_POR_MPU_M3_PRBAR2_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR2_U_SMXP_4_1",
        .addr = A_POR_MPU_M3_PRLAR2_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR3_U_SMXP_4_1",
        .addr = A_POR_MPU_M3_PRBAR3_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR3_U_SMXP_4_1",
        .addr = A_POR_MPU_M3_PRLAR3_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR4_U_SMXP_4_1",
        .addr = A_POR_MPU_M3_PRBAR4_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR4_U_SMXP_4_1",
        .addr = A_POR_MPU_M3_PRLAR4_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR5_U_SMXP_4_1",
        .addr = A_POR_MPU_M3_PRBAR5_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR5_U_SMXP_4_1",
        .addr = A_POR_MPU_M3_PRLAR5_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR6_U_SMXP_4_1",
        .addr = A_POR_MPU_M3_PRBAR6_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR6_U_SMXP_4_1",
        .addr = A_POR_MPU_M3_PRLAR6_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR7_U_SMXP_4_1",
        .addr = A_POR_MPU_M3_PRBAR7_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR7_U_SMXP_4_1",
        .addr = A_POR_MPU_M3_PRLAR7_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR8_U_SMXP_4_1",
        .addr = A_POR_MPU_M3_PRBAR8_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR8_U_SMXP_4_1",
        .addr = A_POR_MPU_M3_PRLAR8_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR9_U_SMXP_4_1",
        .addr = A_POR_MPU_M3_PRBAR9_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR9_U_SMXP_4_1",
        .addr = A_POR_MPU_M3_PRLAR9_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR10_U_SMXP_4_1",
        .addr = A_POR_MPU_M3_PRBAR10_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR10_U_SMXP_4_1",
        .addr = A_POR_MPU_M3_PRLAR10_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR11_U_SMXP_4_1",
        .addr = A_POR_MPU_M3_PRBAR11_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR11_U_SMXP_4_1",
        .addr = A_POR_MPU_M3_PRLAR11_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR12_U_SMXP_4_1",
        .addr = A_POR_MPU_M3_PRBAR12_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR12_U_SMXP_4_1",
        .addr = A_POR_MPU_M3_PRLAR12_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR13_U_SMXP_4_1",
        .addr = A_POR_MPU_M3_PRBAR13_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR13_U_SMXP_4_1",
        .addr = A_POR_MPU_M3_PRLAR13_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR14_U_SMXP_4_1",
        .addr = A_POR_MPU_M3_PRBAR14_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR14_U_SMXP_4_1",
        .addr = A_POR_MPU_M3_PRLAR14_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR15_U_SMXP_4_1",
        .addr = A_POR_MPU_M3_PRBAR15_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR15_U_SMXP_4_1",
        .addr = A_POR_MPU_M3_PRLAR15_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR16_U_SMXP_4_1",
        .addr = A_POR_MPU_M3_PRBAR16_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR16_U_SMXP_4_1",
        .addr = A_POR_MPU_M3_PRLAR16_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR17_U_SMXP_4_1",
        .addr = A_POR_MPU_M3_PRBAR17_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR17_U_SMXP_4_1",
        .addr = A_POR_MPU_M3_PRLAR17_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR18_U_SMXP_4_1",
        .addr = A_POR_MPU_M3_PRBAR18_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR18_U_SMXP_4_1",
        .addr = A_POR_MPU_M3_PRLAR18_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR19_U_SMXP_4_1",
        .addr = A_POR_MPU_M3_PRBAR19_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR19_U_SMXP_4_1",
        .addr = A_POR_MPU_M3_PRLAR19_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR20_U_SMXP_4_1",
        .addr = A_POR_MPU_M3_PRBAR20_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR20_U_SMXP_4_1",
        .addr = A_POR_MPU_M3_PRLAR20_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR21_U_SMXP_4_1",
        .addr = A_POR_MPU_M3_PRBAR21_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR21_U_SMXP_4_1",
        .addr = A_POR_MPU_M3_PRLAR21_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR22_U_SMXP_4_1",
        .addr = A_POR_MPU_M3_PRBAR22_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR22_U_SMXP_4_1",
        .addr = A_POR_MPU_M3_PRLAR22_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR23_U_SMXP_4_1",
        .addr = A_POR_MPU_M3_PRBAR23_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR23_U_SMXP_4_1",
        .addr = A_POR_MPU_M3_PRLAR23_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR24_U_SMXP_4_1",
        .addr = A_POR_MPU_M3_PRBAR24_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR24_U_SMXP_4_1",
        .addr = A_POR_MPU_M3_PRLAR24_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR25_U_SMXP_4_1",
        .addr = A_POR_MPU_M3_PRBAR25_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR25_U_SMXP_4_1",
        .addr = A_POR_MPU_M3_PRLAR25_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR26_U_SMXP_4_1",
        .addr = A_POR_MPU_M3_PRBAR26_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR26_U_SMXP_4_1",
        .addr = A_POR_MPU_M3_PRLAR26_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR27_U_SMXP_4_1",
        .addr = A_POR_MPU_M3_PRBAR27_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR27_U_SMXP_4_1",
        .addr = A_POR_MPU_M3_PRLAR27_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR28_U_SMXP_4_1",
        .addr = A_POR_MPU_M3_PRBAR28_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR28_U_SMXP_4_1",
        .addr = A_POR_MPU_M3_PRLAR28_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR29_U_SMXP_4_1",
        .addr = A_POR_MPU_M3_PRBAR29_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR29_U_SMXP_4_1",
        .addr = A_POR_MPU_M3_PRLAR29_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR30_U_SMXP_4_1",
        .addr = A_POR_MPU_M3_PRBAR30_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR30_U_SMXP_4_1",
        .addr = A_POR_MPU_M3_PRLAR30_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR31_U_SMXP_4_1",
        .addr = A_POR_MPU_M3_PRBAR31_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR31_U_SMXP_4_1",
        .addr = A_POR_MPU_M3_PRLAR31_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_CTL_U_SMXP_4_1",
        .addr = A_POR_MPU_M4_CTL_U_SMXP_4_1,
        .reset = 0x2,
        .rsvd = 0xfffffffffffffff8L,
        .ro = 0xfffffffffffffff8L,
    },{ .name = "POR_MPU_M4_PRBAR0_U_SMXP_4_1",
        .addr = A_POR_MPU_M4_PRBAR0_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR0_U_SMXP_4_1",
        .addr = A_POR_MPU_M4_PRLAR0_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR1_U_SMXP_4_1",
        .addr = A_POR_MPU_M4_PRBAR1_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR1_U_SMXP_4_1",
        .addr = A_POR_MPU_M4_PRLAR1_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR2_U_SMXP_4_1",
        .addr = A_POR_MPU_M4_PRBAR2_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR2_U_SMXP_4_1",
        .addr = A_POR_MPU_M4_PRLAR2_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR3_U_SMXP_4_1",
        .addr = A_POR_MPU_M4_PRBAR3_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR3_U_SMXP_4_1",
        .addr = A_POR_MPU_M4_PRLAR3_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR4_U_SMXP_4_1",
        .addr = A_POR_MPU_M4_PRBAR4_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR4_U_SMXP_4_1",
        .addr = A_POR_MPU_M4_PRLAR4_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR5_U_SMXP_4_1",
        .addr = A_POR_MPU_M4_PRBAR5_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR5_U_SMXP_4_1",
        .addr = A_POR_MPU_M4_PRLAR5_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR6_U_SMXP_4_1",
        .addr = A_POR_MPU_M4_PRBAR6_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR6_U_SMXP_4_1",
        .addr = A_POR_MPU_M4_PRLAR6_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR7_U_SMXP_4_1",
        .addr = A_POR_MPU_M4_PRBAR7_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR7_U_SMXP_4_1",
        .addr = A_POR_MPU_M4_PRLAR7_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR8_U_SMXP_4_1",
        .addr = A_POR_MPU_M4_PRBAR8_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR8_U_SMXP_4_1",
        .addr = A_POR_MPU_M4_PRLAR8_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR9_U_SMXP_4_1",
        .addr = A_POR_MPU_M4_PRBAR9_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR9_U_SMXP_4_1",
        .addr = A_POR_MPU_M4_PRLAR9_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR10_U_SMXP_4_1",
        .addr = A_POR_MPU_M4_PRBAR10_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR10_U_SMXP_4_1",
        .addr = A_POR_MPU_M4_PRLAR10_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR11_U_SMXP_4_1",
        .addr = A_POR_MPU_M4_PRBAR11_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR11_U_SMXP_4_1",
        .addr = A_POR_MPU_M4_PRLAR11_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR12_U_SMXP_4_1",
        .addr = A_POR_MPU_M4_PRBAR12_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR12_U_SMXP_4_1",
        .addr = A_POR_MPU_M4_PRLAR12_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR13_U_SMXP_4_1",
        .addr = A_POR_MPU_M4_PRBAR13_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR13_U_SMXP_4_1",
        .addr = A_POR_MPU_M4_PRLAR13_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR14_U_SMXP_4_1",
        .addr = A_POR_MPU_M4_PRBAR14_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR14_U_SMXP_4_1",
        .addr = A_POR_MPU_M4_PRLAR14_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR15_U_SMXP_4_1",
        .addr = A_POR_MPU_M4_PRBAR15_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR15_U_SMXP_4_1",
        .addr = A_POR_MPU_M4_PRLAR15_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR16_U_SMXP_4_1",
        .addr = A_POR_MPU_M4_PRBAR16_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR16_U_SMXP_4_1",
        .addr = A_POR_MPU_M4_PRLAR16_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR17_U_SMXP_4_1",
        .addr = A_POR_MPU_M4_PRBAR17_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR17_U_SMXP_4_1",
        .addr = A_POR_MPU_M4_PRLAR17_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR18_U_SMXP_4_1",
        .addr = A_POR_MPU_M4_PRBAR18_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR18_U_SMXP_4_1",
        .addr = A_POR_MPU_M4_PRLAR18_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR19_U_SMXP_4_1",
        .addr = A_POR_MPU_M4_PRBAR19_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR19_U_SMXP_4_1",
        .addr = A_POR_MPU_M4_PRLAR19_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR20_U_SMXP_4_1",
        .addr = A_POR_MPU_M4_PRBAR20_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR20_U_SMXP_4_1",
        .addr = A_POR_MPU_M4_PRLAR20_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR21_U_SMXP_4_1",
        .addr = A_POR_MPU_M4_PRBAR21_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR21_U_SMXP_4_1",
        .addr = A_POR_MPU_M4_PRLAR21_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR22_U_SMXP_4_1",
        .addr = A_POR_MPU_M4_PRBAR22_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR22_U_SMXP_4_1",
        .addr = A_POR_MPU_M4_PRLAR22_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR23_U_SMXP_4_1",
        .addr = A_POR_MPU_M4_PRBAR23_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR23_U_SMXP_4_1",
        .addr = A_POR_MPU_M4_PRLAR23_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR24_U_SMXP_4_1",
        .addr = A_POR_MPU_M4_PRBAR24_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR24_U_SMXP_4_1",
        .addr = A_POR_MPU_M4_PRLAR24_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR25_U_SMXP_4_1",
        .addr = A_POR_MPU_M4_PRBAR25_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR25_U_SMXP_4_1",
        .addr = A_POR_MPU_M4_PRLAR25_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR26_U_SMXP_4_1",
        .addr = A_POR_MPU_M4_PRBAR26_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR26_U_SMXP_4_1",
        .addr = A_POR_MPU_M4_PRLAR26_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR27_U_SMXP_4_1",
        .addr = A_POR_MPU_M4_PRBAR27_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR27_U_SMXP_4_1",
        .addr = A_POR_MPU_M4_PRLAR27_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR28_U_SMXP_4_1",
        .addr = A_POR_MPU_M4_PRBAR28_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR28_U_SMXP_4_1",
        .addr = A_POR_MPU_M4_PRLAR28_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR29_U_SMXP_4_1",
        .addr = A_POR_MPU_M4_PRBAR29_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR29_U_SMXP_4_1",
        .addr = A_POR_MPU_M4_PRLAR29_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR30_U_SMXP_4_1",
        .addr = A_POR_MPU_M4_PRBAR30_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR30_U_SMXP_4_1",
        .addr = A_POR_MPU_M4_PRLAR30_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR31_U_SMXP_4_1",
        .addr = A_POR_MPU_M4_PRBAR31_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR31_U_SMXP_4_1",
        .addr = A_POR_MPU_M4_PRLAR31_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_CTL_U_SMXP_4_1",
        .addr = A_POR_MPU_M5_CTL_U_SMXP_4_1,
        .reset = 0x2,
        .rsvd = 0xfffffffffffffff8L,
        .ro = 0xfffffffffffffff8L,
    },{ .name = "POR_MPU_M5_PRBAR0_U_SMXP_4_1",
        .addr = A_POR_MPU_M5_PRBAR0_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR0_U_SMXP_4_1",
        .addr = A_POR_MPU_M5_PRLAR0_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR1_U_SMXP_4_1",
        .addr = A_POR_MPU_M5_PRBAR1_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR1_U_SMXP_4_1",
        .addr = A_POR_MPU_M5_PRLAR1_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR2_U_SMXP_4_1",
        .addr = A_POR_MPU_M5_PRBAR2_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR2_U_SMXP_4_1",
        .addr = A_POR_MPU_M5_PRLAR2_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR3_U_SMXP_4_1",
        .addr = A_POR_MPU_M5_PRBAR3_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR3_U_SMXP_4_1",
        .addr = A_POR_MPU_M5_PRLAR3_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR4_U_SMXP_4_1",
        .addr = A_POR_MPU_M5_PRBAR4_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR4_U_SMXP_4_1",
        .addr = A_POR_MPU_M5_PRLAR4_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR5_U_SMXP_4_1",
        .addr = A_POR_MPU_M5_PRBAR5_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR5_U_SMXP_4_1",
        .addr = A_POR_MPU_M5_PRLAR5_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR6_U_SMXP_4_1",
        .addr = A_POR_MPU_M5_PRBAR6_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR6_U_SMXP_4_1",
        .addr = A_POR_MPU_M5_PRLAR6_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR7_U_SMXP_4_1",
        .addr = A_POR_MPU_M5_PRBAR7_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR7_U_SMXP_4_1",
        .addr = A_POR_MPU_M5_PRLAR7_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR8_U_SMXP_4_1",
        .addr = A_POR_MPU_M5_PRBAR8_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR8_U_SMXP_4_1",
        .addr = A_POR_MPU_M5_PRLAR8_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR9_U_SMXP_4_1",
        .addr = A_POR_MPU_M5_PRBAR9_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR9_U_SMXP_4_1",
        .addr = A_POR_MPU_M5_PRLAR9_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR10_U_SMXP_4_1",
        .addr = A_POR_MPU_M5_PRBAR10_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR10_U_SMXP_4_1",
        .addr = A_POR_MPU_M5_PRLAR10_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR11_U_SMXP_4_1",
        .addr = A_POR_MPU_M5_PRBAR11_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR11_U_SMXP_4_1",
        .addr = A_POR_MPU_M5_PRLAR11_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR12_U_SMXP_4_1",
        .addr = A_POR_MPU_M5_PRBAR12_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR12_U_SMXP_4_1",
        .addr = A_POR_MPU_M5_PRLAR12_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR13_U_SMXP_4_1",
        .addr = A_POR_MPU_M5_PRBAR13_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR13_U_SMXP_4_1",
        .addr = A_POR_MPU_M5_PRLAR13_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR14_U_SMXP_4_1",
        .addr = A_POR_MPU_M5_PRBAR14_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR14_U_SMXP_4_1",
        .addr = A_POR_MPU_M5_PRLAR14_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR15_U_SMXP_4_1",
        .addr = A_POR_MPU_M5_PRBAR15_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR15_U_SMXP_4_1",
        .addr = A_POR_MPU_M5_PRLAR15_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR16_U_SMXP_4_1",
        .addr = A_POR_MPU_M5_PRBAR16_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR16_U_SMXP_4_1",
        .addr = A_POR_MPU_M5_PRLAR16_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR17_U_SMXP_4_1",
        .addr = A_POR_MPU_M5_PRBAR17_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR17_U_SMXP_4_1",
        .addr = A_POR_MPU_M5_PRLAR17_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR18_U_SMXP_4_1",
        .addr = A_POR_MPU_M5_PRBAR18_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR18_U_SMXP_4_1",
        .addr = A_POR_MPU_M5_PRLAR18_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR19_U_SMXP_4_1",
        .addr = A_POR_MPU_M5_PRBAR19_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR19_U_SMXP_4_1",
        .addr = A_POR_MPU_M5_PRLAR19_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR20_U_SMXP_4_1",
        .addr = A_POR_MPU_M5_PRBAR20_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR20_U_SMXP_4_1",
        .addr = A_POR_MPU_M5_PRLAR20_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR21_U_SMXP_4_1",
        .addr = A_POR_MPU_M5_PRBAR21_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR21_U_SMXP_4_1",
        .addr = A_POR_MPU_M5_PRLAR21_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR22_U_SMXP_4_1",
        .addr = A_POR_MPU_M5_PRBAR22_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR22_U_SMXP_4_1",
        .addr = A_POR_MPU_M5_PRLAR22_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR23_U_SMXP_4_1",
        .addr = A_POR_MPU_M5_PRBAR23_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR23_U_SMXP_4_1",
        .addr = A_POR_MPU_M5_PRLAR23_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR24_U_SMXP_4_1",
        .addr = A_POR_MPU_M5_PRBAR24_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR24_U_SMXP_4_1",
        .addr = A_POR_MPU_M5_PRLAR24_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR25_U_SMXP_4_1",
        .addr = A_POR_MPU_M5_PRBAR25_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR25_U_SMXP_4_1",
        .addr = A_POR_MPU_M5_PRLAR25_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR26_U_SMXP_4_1",
        .addr = A_POR_MPU_M5_PRBAR26_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR26_U_SMXP_4_1",
        .addr = A_POR_MPU_M5_PRLAR26_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR27_U_SMXP_4_1",
        .addr = A_POR_MPU_M5_PRBAR27_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR27_U_SMXP_4_1",
        .addr = A_POR_MPU_M5_PRLAR27_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR28_U_SMXP_4_1",
        .addr = A_POR_MPU_M5_PRBAR28_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR28_U_SMXP_4_1",
        .addr = A_POR_MPU_M5_PRLAR28_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR29_U_SMXP_4_1",
        .addr = A_POR_MPU_M5_PRBAR29_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR29_U_SMXP_4_1",
        .addr = A_POR_MPU_M5_PRLAR29_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR30_U_SMXP_4_1",
        .addr = A_POR_MPU_M5_PRBAR30_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR30_U_SMXP_4_1",
        .addr = A_POR_MPU_M5_PRLAR30_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR31_U_SMXP_4_1",
        .addr = A_POR_MPU_M5_PRBAR31_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR31_U_SMXP_4_1",
        .addr = A_POR_MPU_M5_PRLAR31_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_CTL_U_SMXP_4_1",
        .addr = A_POR_MPU_M6_CTL_U_SMXP_4_1,
        .reset = 0x2,
        .rsvd = 0xfffffffffffffff8L,
        .ro = 0xfffffffffffffff8L,
    },{ .name = "POR_MPU_M6_PRBAR0_U_SMXP_4_1",
        .addr = A_POR_MPU_M6_PRBAR0_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR0_U_SMXP_4_1",
        .addr = A_POR_MPU_M6_PRLAR0_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR1_U_SMXP_4_1",
        .addr = A_POR_MPU_M6_PRBAR1_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR1_U_SMXP_4_1",
        .addr = A_POR_MPU_M6_PRLAR1_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR2_U_SMXP_4_1",
        .addr = A_POR_MPU_M6_PRBAR2_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR2_U_SMXP_4_1",
        .addr = A_POR_MPU_M6_PRLAR2_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR3_U_SMXP_4_1",
        .addr = A_POR_MPU_M6_PRBAR3_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR3_U_SMXP_4_1",
        .addr = A_POR_MPU_M6_PRLAR3_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR4_U_SMXP_4_1",
        .addr = A_POR_MPU_M6_PRBAR4_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR4_U_SMXP_4_1",
        .addr = A_POR_MPU_M6_PRLAR4_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR5_U_SMXP_4_1",
        .addr = A_POR_MPU_M6_PRBAR5_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR5_U_SMXP_4_1",
        .addr = A_POR_MPU_M6_PRLAR5_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR6_U_SMXP_4_1",
        .addr = A_POR_MPU_M6_PRBAR6_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR6_U_SMXP_4_1",
        .addr = A_POR_MPU_M6_PRLAR6_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR7_U_SMXP_4_1",
        .addr = A_POR_MPU_M6_PRBAR7_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR7_U_SMXP_4_1",
        .addr = A_POR_MPU_M6_PRLAR7_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR8_U_SMXP_4_1",
        .addr = A_POR_MPU_M6_PRBAR8_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR8_U_SMXP_4_1",
        .addr = A_POR_MPU_M6_PRLAR8_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR9_U_SMXP_4_1",
        .addr = A_POR_MPU_M6_PRBAR9_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR9_U_SMXP_4_1",
        .addr = A_POR_MPU_M6_PRLAR9_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR10_U_SMXP_4_1",
        .addr = A_POR_MPU_M6_PRBAR10_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR10_U_SMXP_4_1",
        .addr = A_POR_MPU_M6_PRLAR10_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR11_U_SMXP_4_1",
        .addr = A_POR_MPU_M6_PRBAR11_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR11_U_SMXP_4_1",
        .addr = A_POR_MPU_M6_PRLAR11_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR12_U_SMXP_4_1",
        .addr = A_POR_MPU_M6_PRBAR12_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR12_U_SMXP_4_1",
        .addr = A_POR_MPU_M6_PRLAR12_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR13_U_SMXP_4_1",
        .addr = A_POR_MPU_M6_PRBAR13_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR13_U_SMXP_4_1",
        .addr = A_POR_MPU_M6_PRLAR13_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR14_U_SMXP_4_1",
        .addr = A_POR_MPU_M6_PRBAR14_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR14_U_SMXP_4_1",
        .addr = A_POR_MPU_M6_PRLAR14_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR15_U_SMXP_4_1",
        .addr = A_POR_MPU_M6_PRBAR15_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR15_U_SMXP_4_1",
        .addr = A_POR_MPU_M6_PRLAR15_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR16_U_SMXP_4_1",
        .addr = A_POR_MPU_M6_PRBAR16_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR16_U_SMXP_4_1",
        .addr = A_POR_MPU_M6_PRLAR16_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR17_U_SMXP_4_1",
        .addr = A_POR_MPU_M6_PRBAR17_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR17_U_SMXP_4_1",
        .addr = A_POR_MPU_M6_PRLAR17_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR18_U_SMXP_4_1",
        .addr = A_POR_MPU_M6_PRBAR18_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR18_U_SMXP_4_1",
        .addr = A_POR_MPU_M6_PRLAR18_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR19_U_SMXP_4_1",
        .addr = A_POR_MPU_M6_PRBAR19_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR19_U_SMXP_4_1",
        .addr = A_POR_MPU_M6_PRLAR19_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR20_U_SMXP_4_1",
        .addr = A_POR_MPU_M6_PRBAR20_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR20_U_SMXP_4_1",
        .addr = A_POR_MPU_M6_PRLAR20_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR21_U_SMXP_4_1",
        .addr = A_POR_MPU_M6_PRBAR21_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR21_U_SMXP_4_1",
        .addr = A_POR_MPU_M6_PRLAR21_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR22_U_SMXP_4_1",
        .addr = A_POR_MPU_M6_PRBAR22_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR22_U_SMXP_4_1",
        .addr = A_POR_MPU_M6_PRLAR22_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR23_U_SMXP_4_1",
        .addr = A_POR_MPU_M6_PRBAR23_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR23_U_SMXP_4_1",
        .addr = A_POR_MPU_M6_PRLAR23_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR24_U_SMXP_4_1",
        .addr = A_POR_MPU_M6_PRBAR24_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR24_U_SMXP_4_1",
        .addr = A_POR_MPU_M6_PRLAR24_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR25_U_SMXP_4_1",
        .addr = A_POR_MPU_M6_PRBAR25_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR25_U_SMXP_4_1",
        .addr = A_POR_MPU_M6_PRLAR25_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR26_U_SMXP_4_1",
        .addr = A_POR_MPU_M6_PRBAR26_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR26_U_SMXP_4_1",
        .addr = A_POR_MPU_M6_PRLAR26_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR27_U_SMXP_4_1",
        .addr = A_POR_MPU_M6_PRBAR27_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR27_U_SMXP_4_1",
        .addr = A_POR_MPU_M6_PRLAR27_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR28_U_SMXP_4_1",
        .addr = A_POR_MPU_M6_PRBAR28_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR28_U_SMXP_4_1",
        .addr = A_POR_MPU_M6_PRLAR28_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR29_U_SMXP_4_1",
        .addr = A_POR_MPU_M6_PRBAR29_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR29_U_SMXP_4_1",
        .addr = A_POR_MPU_M6_PRLAR29_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR30_U_SMXP_4_1",
        .addr = A_POR_MPU_M6_PRBAR30_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR30_U_SMXP_4_1",
        .addr = A_POR_MPU_M6_PRLAR30_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR31_U_SMXP_4_1",
        .addr = A_POR_MPU_M6_PRBAR31_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR31_U_SMXP_4_1",
        .addr = A_POR_MPU_M6_PRLAR31_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_CTL_U_SMXP_4_1",
        .addr = A_POR_MPU_M7_CTL_U_SMXP_4_1,
        .reset = 0x2,
        .rsvd = 0xfffffffffffffff8L,
        .ro = 0xfffffffffffffff8L,
    },{ .name = "POR_MPU_M7_PRBAR0_U_SMXP_4_1",
        .addr = A_POR_MPU_M7_PRBAR0_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR0_U_SMXP_4_1",
        .addr = A_POR_MPU_M7_PRLAR0_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR1_U_SMXP_4_1",
        .addr = A_POR_MPU_M7_PRBAR1_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR1_U_SMXP_4_1",
        .addr = A_POR_MPU_M7_PRLAR1_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR2_U_SMXP_4_1",
        .addr = A_POR_MPU_M7_PRBAR2_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR2_U_SMXP_4_1",
        .addr = A_POR_MPU_M7_PRLAR2_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR3_U_SMXP_4_1",
        .addr = A_POR_MPU_M7_PRBAR3_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR3_U_SMXP_4_1",
        .addr = A_POR_MPU_M7_PRLAR3_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR4_U_SMXP_4_1",
        .addr = A_POR_MPU_M7_PRBAR4_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR4_U_SMXP_4_1",
        .addr = A_POR_MPU_M7_PRLAR4_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR5_U_SMXP_4_1",
        .addr = A_POR_MPU_M7_PRBAR5_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR5_U_SMXP_4_1",
        .addr = A_POR_MPU_M7_PRLAR5_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR6_U_SMXP_4_1",
        .addr = A_POR_MPU_M7_PRBAR6_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR6_U_SMXP_4_1",
        .addr = A_POR_MPU_M7_PRLAR6_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR7_U_SMXP_4_1",
        .addr = A_POR_MPU_M7_PRBAR7_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR7_U_SMXP_4_1",
        .addr = A_POR_MPU_M7_PRLAR7_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR8_U_SMXP_4_1",
        .addr = A_POR_MPU_M7_PRBAR8_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR8_U_SMXP_4_1",
        .addr = A_POR_MPU_M7_PRLAR8_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR9_U_SMXP_4_1",
        .addr = A_POR_MPU_M7_PRBAR9_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR9_U_SMXP_4_1",
        .addr = A_POR_MPU_M7_PRLAR9_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR10_U_SMXP_4_1",
        .addr = A_POR_MPU_M7_PRBAR10_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR10_U_SMXP_4_1",
        .addr = A_POR_MPU_M7_PRLAR10_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR11_U_SMXP_4_1",
        .addr = A_POR_MPU_M7_PRBAR11_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR11_U_SMXP_4_1",
        .addr = A_POR_MPU_M7_PRLAR11_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR12_U_SMXP_4_1",
        .addr = A_POR_MPU_M7_PRBAR12_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR12_U_SMXP_4_1",
        .addr = A_POR_MPU_M7_PRLAR12_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR13_U_SMXP_4_1",
        .addr = A_POR_MPU_M7_PRBAR13_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR13_U_SMXP_4_1",
        .addr = A_POR_MPU_M7_PRLAR13_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR14_U_SMXP_4_1",
        .addr = A_POR_MPU_M7_PRBAR14_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR14_U_SMXP_4_1",
        .addr = A_POR_MPU_M7_PRLAR14_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR15_U_SMXP_4_1",
        .addr = A_POR_MPU_M7_PRBAR15_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR15_U_SMXP_4_1",
        .addr = A_POR_MPU_M7_PRLAR15_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR16_U_SMXP_4_1",
        .addr = A_POR_MPU_M7_PRBAR16_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR16_U_SMXP_4_1",
        .addr = A_POR_MPU_M7_PRLAR16_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR17_U_SMXP_4_1",
        .addr = A_POR_MPU_M7_PRBAR17_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR17_U_SMXP_4_1",
        .addr = A_POR_MPU_M7_PRLAR17_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR18_U_SMXP_4_1",
        .addr = A_POR_MPU_M7_PRBAR18_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR18_U_SMXP_4_1",
        .addr = A_POR_MPU_M7_PRLAR18_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR19_U_SMXP_4_1",
        .addr = A_POR_MPU_M7_PRBAR19_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR19_U_SMXP_4_1",
        .addr = A_POR_MPU_M7_PRLAR19_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR20_U_SMXP_4_1",
        .addr = A_POR_MPU_M7_PRBAR20_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR20_U_SMXP_4_1",
        .addr = A_POR_MPU_M7_PRLAR20_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR21_U_SMXP_4_1",
        .addr = A_POR_MPU_M7_PRBAR21_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR21_U_SMXP_4_1",
        .addr = A_POR_MPU_M7_PRLAR21_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR22_U_SMXP_4_1",
        .addr = A_POR_MPU_M7_PRBAR22_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR22_U_SMXP_4_1",
        .addr = A_POR_MPU_M7_PRLAR22_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR23_U_SMXP_4_1",
        .addr = A_POR_MPU_M7_PRBAR23_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR23_U_SMXP_4_1",
        .addr = A_POR_MPU_M7_PRLAR23_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR24_U_SMXP_4_1",
        .addr = A_POR_MPU_M7_PRBAR24_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR24_U_SMXP_4_1",
        .addr = A_POR_MPU_M7_PRLAR24_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR25_U_SMXP_4_1",
        .addr = A_POR_MPU_M7_PRBAR25_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR25_U_SMXP_4_1",
        .addr = A_POR_MPU_M7_PRLAR25_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR26_U_SMXP_4_1",
        .addr = A_POR_MPU_M7_PRBAR26_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR26_U_SMXP_4_1",
        .addr = A_POR_MPU_M7_PRLAR26_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR27_U_SMXP_4_1",
        .addr = A_POR_MPU_M7_PRBAR27_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR27_U_SMXP_4_1",
        .addr = A_POR_MPU_M7_PRLAR27_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR28_U_SMXP_4_1",
        .addr = A_POR_MPU_M7_PRBAR28_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR28_U_SMXP_4_1",
        .addr = A_POR_MPU_M7_PRLAR28_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR29_U_SMXP_4_1",
        .addr = A_POR_MPU_M7_PRBAR29_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR29_U_SMXP_4_1",
        .addr = A_POR_MPU_M7_PRLAR29_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR30_U_SMXP_4_1",
        .addr = A_POR_MPU_M7_PRBAR30_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR30_U_SMXP_4_1",
        .addr = A_POR_MPU_M7_PRLAR30_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR31_U_SMXP_4_1",
        .addr = A_POR_MPU_M7_PRBAR31_U_SMXP_4_1,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR31_U_SMXP_4_1",
        .addr = A_POR_MPU_M7_PRLAR31_U_SMXP_4_1,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_RNSAM_NODE_INFO_U_CXRH_NID264",
        .addr = A_POR_RNSAM_NODE_INFO_U_CXRH_NID264,
        .reset = 0x4000f,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_RNSAM_CHILD_INFO_U_CXRH_NID264",
        .addr = A_POR_RNSAM_CHILD_INFO_U_CXRH_NID264,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_RNSAM_UNIT_INFO_U_CXRH_NID264",
        .addr = A_POR_RNSAM_UNIT_INFO_U_CXRH_NID264,
        .reset = 0x800040004,
        .rsvd = 0xff00,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_RNSAM_SECURE_REGISTER_GROUPS_OVERRIDE_U_CXRH_NID264",
        .addr = A_POR_RNSAM_SECURE_REGISTER_GROUPS_OVERRIDE_U_CXRH_NID264,
        .rsvd = 0xfffffffffffffffeL,
        .ro = 0xfffffffffffffffeL,
    },{ .name = "RNSAM_STATUS_U_CXRH_NID264",
        .addr = A_RNSAM_STATUS_U_CXRH_NID264,
        .reset = 0x1,
        .rsvd = 0xfffffffffffffffcL,
        .ro = 0xfffffffffffffffcL,
    },{ .name = "NON_HASH_MEM_REGION_REG0_U_CXRH_NID264",
        .addr = A_NON_HASH_MEM_REGION_REG0_U_CXRH_NID264,
        .rsvd = 0x2,
        .ro = 0x8000000280000002L,
    },{ .name = "NON_HASH_MEM_REGION_REG1_U_CXRH_NID264",
        .addr = A_NON_HASH_MEM_REGION_REG1_U_CXRH_NID264,
        .rsvd = 0x2,
        .ro = 0x8000000280000002L,
    },{ .name = "NON_HASH_MEM_REGION_REG2_U_CXRH_NID264",
        .addr = A_NON_HASH_MEM_REGION_REG2_U_CXRH_NID264,
        .rsvd = 0x2,
        .ro = 0x8000000280000002L,
    },{ .name = "NON_HASH_MEM_REGION_REG3_U_CXRH_NID264",
        .addr = A_NON_HASH_MEM_REGION_REG3_U_CXRH_NID264,
        .rsvd = 0x2,
        .ro = 0x8000000280000002L,
    },{ .name = "NON_HASH_TGT_NODEID0_U_CXRH_NID264",
        .addr = A_NON_HASH_TGT_NODEID0_U_CXRH_NID264,
        .ro = 0xffff800800800800L,
    },{ .name = "NON_HASH_TGT_NODEID1_U_CXRH_NID264",
        .addr = A_NON_HASH_TGT_NODEID1_U_CXRH_NID264,
        .ro = 0xffff800800800800L,
    },{ .name = "NON_HASH_TGT_NODEID2_U_CXRH_NID264",
        .addr = A_NON_HASH_TGT_NODEID2_U_CXRH_NID264,
        .ro = 0xffffffffff800800L,
    },{ .name = "SYS_CACHE_GRP_REGION0_U_CXRH_NID264",
        .addr = A_SYS_CACHE_GRP_REGION0_U_CXRH_NID264,
        .rsvd = 0x2,
        .ro = 0x8000000080000002L,
    },{ .name = "SYS_CACHE_GRP_REGION1_U_CXRH_NID264",
        .addr = A_SYS_CACHE_GRP_REGION1_U_CXRH_NID264,
        .ro = 0x8000000080000000L,
    },{ .name = "SYS_CACHE_GRP_HN_NODEID_REG0_U_CXRH_NID264",
        .addr = A_SYS_CACHE_GRP_HN_NODEID_REG0_U_CXRH_NID264,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_HN_NODEID_REG1_U_CXRH_NID264",
        .addr = A_SYS_CACHE_GRP_HN_NODEID_REG1_U_CXRH_NID264,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_HN_NODEID_REG2_U_CXRH_NID264",
        .addr = A_SYS_CACHE_GRP_HN_NODEID_REG2_U_CXRH_NID264,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_HN_NODEID_REG3_U_CXRH_NID264",
        .addr = A_SYS_CACHE_GRP_HN_NODEID_REG3_U_CXRH_NID264,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_HN_NODEID_REG4_U_CXRH_NID264",
        .addr = A_SYS_CACHE_GRP_HN_NODEID_REG4_U_CXRH_NID264,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_HN_NODEID_REG5_U_CXRH_NID264",
        .addr = A_SYS_CACHE_GRP_HN_NODEID_REG5_U_CXRH_NID264,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_HN_NODEID_REG6_U_CXRH_NID264",
        .addr = A_SYS_CACHE_GRP_HN_NODEID_REG6_U_CXRH_NID264,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_HN_NODEID_REG7_U_CXRH_NID264",
        .addr = A_SYS_CACHE_GRP_HN_NODEID_REG7_U_CXRH_NID264,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_NONHASH_NODEID_U_CXRH_NID264",
        .addr = A_SYS_CACHE_GRP_NONHASH_NODEID_U_CXRH_NID264,
        .ro = 0xfffffff800800800L,
    },{ .name = "SYS_CACHE_GROUP_HN_COUNT_U_CXRH_NID264",
        .addr = A_SYS_CACHE_GROUP_HN_COUNT_U_CXRH_NID264,
        .rsvd = 0x80,
        .ro = 0xffffffff80808080L,
    },{ .name = "SYS_CACHE_GRP_SN_NODEID_REG0_U_CXRH_NID264",
        .addr = A_SYS_CACHE_GRP_SN_NODEID_REG0_U_CXRH_NID264,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_SN_NODEID_REG1_U_CXRH_NID264",
        .addr = A_SYS_CACHE_GRP_SN_NODEID_REG1_U_CXRH_NID264,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_SN_NODEID_REG2_U_CXRH_NID264",
        .addr = A_SYS_CACHE_GRP_SN_NODEID_REG2_U_CXRH_NID264,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_SN_NODEID_REG3_U_CXRH_NID264",
        .addr = A_SYS_CACHE_GRP_SN_NODEID_REG3_U_CXRH_NID264,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_SN_NODEID_REG4_U_CXRH_NID264",
        .addr = A_SYS_CACHE_GRP_SN_NODEID_REG4_U_CXRH_NID264,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_SN_NODEID_REG5_U_CXRH_NID264",
        .addr = A_SYS_CACHE_GRP_SN_NODEID_REG5_U_CXRH_NID264,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_SN_NODEID_REG6_U_CXRH_NID264",
        .addr = A_SYS_CACHE_GRP_SN_NODEID_REG6_U_CXRH_NID264,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_SN_NODEID_REG7_U_CXRH_NID264",
        .addr = A_SYS_CACHE_GRP_SN_NODEID_REG7_U_CXRH_NID264,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_SN_SAM_CFG0_U_CXRH_NID264",
        .addr = A_SYS_CACHE_GRP_SN_SAM_CFG0_U_CXRH_NID264,
        .rsvd = 0xc0,
        .ro = 0xffffc0c0c0c0c0c0L,
    },{ .name = "SYS_CACHE_GRP_SN_SAM_CFG1_U_CXRH_NID264",
        .addr = A_SYS_CACHE_GRP_SN_SAM_CFG1_U_CXRH_NID264,
        .rsvd = 0xc0,
        .ro = 0xffffc0c0c0c0c0c0L,
    },{ .name = "GIC_MEM_REGION_REG_U_CXRH_NID264",
        .addr = A_GIC_MEM_REGION_REG_U_CXRH_NID264,
        .rsvd = 0xff82,
        .ro = 0x800f00000000ff82L,
    },{ .name = "SYS_CACHE_GRP_SN_ATTR_U_CXRH_NID264",
        .addr = A_SYS_CACHE_GRP_SN_ATTR_U_CXRH_NID264,
        .rsvd = 0xffce,
        .ro = 0xffceffceffceffceL,
    },{ .name = "SYS_CACHE_GRP_HN_CPA_EN_REG_U_CXRH_NID264",
        .addr = A_SYS_CACHE_GRP_HN_CPA_EN_REG_U_CXRH_NID264,
    },{ .name = "SYS_CACHE_GRP_HN_CPA_GRP_REG_U_CXRH_NID264",
        .addr = A_SYS_CACHE_GRP_HN_CPA_GRP_REG_U_CXRH_NID264,
        .rsvd = 0xfffc,
        .ro = 0xfffcfffcfffcfffcL,
    },{ .name = "CML_PORT_AGGR_MODE_CTRL_REG_U_CXRH_NID264",
        .addr = A_CML_PORT_AGGR_MODE_CTRL_REG_U_CXRH_NID264,
        .rsvd = 0x88,
        .ro = 0xffffffff28888888L,
    },{ .name = "CML_PORT_AGGR_GRP0_ADD_MASK_U_CXRH_NID264",
        .addr = A_CML_PORT_AGGR_GRP0_ADD_MASK_U_CXRH_NID264,
        .reset = 0x40,
        .ro = 0xffff00000000003fL,
    },{ .name = "CML_PORT_AGGR_GRP1_ADD_MASK_U_CXRH_NID264",
        .addr = A_CML_PORT_AGGR_GRP1_ADD_MASK_U_CXRH_NID264,
        .reset = 0x40,
        .ro = 0xffff00000000003fL,
    },{ .name = "CML_PORT_AGGR_GRP0_REG_U_CXRH_NID264",
        .addr = A_CML_PORT_AGGR_GRP0_REG_U_CXRH_NID264,
        .ro = 0xfffc800800800800L,
    },{ .name = "CML_PORT_AGGR_GRP1_REG_U_CXRH_NID264",
        .addr = A_CML_PORT_AGGR_GRP1_REG_U_CXRH_NID264,
        .ro = 0xfffc800800800800L,
    },{ .name = "SYS_CACHE_GRP_SECONDARY_REG0_U_CXRH_NID264",
        .addr = A_SYS_CACHE_GRP_SECONDARY_REG0_U_CXRH_NID264,
        .rsvd = 0x2,
        .ro = 0x8000000280000002L,
    },{ .name = "SYS_CACHE_GRP_SECONDARY_REG1_U_CXRH_NID264",
        .addr = A_SYS_CACHE_GRP_SECONDARY_REG1_U_CXRH_NID264,
        .rsvd = 0x2,
        .ro = 0x8000000280000002L,
    },{ .name = "SYS_CACHE_GRP_CAL_MODE_REG_U_CXRH_NID264",
        .addr = A_SYS_CACHE_GRP_CAL_MODE_REG_U_CXRH_NID264,
        .rsvd = 0xfffe,
        .ro = 0xfffefffefffefffeL,
    },{ .name = "RNSAM_HASH_ADDR_MASK_REG_U_CXRH_NID264",
        .addr = A_RNSAM_HASH_ADDR_MASK_REG_U_CXRH_NID264,
        .reset = 0xffffffffffc0,
        .ro = 0xffff00000000003fL,
    },{ .name = "RNSAM_REGION_CMP_ADDR_MASK_REG_U_CXRH_NID264",
        .addr = A_RNSAM_REGION_CMP_ADDR_MASK_REG_U_CXRH_NID264,
        .reset = 0xffffffff0000,
        .ro = 0xffff00000000ffffL,
    },{ .name = "SYS_CACHE_GRP_HN_NODEID_REG8_U_CXRH_NID264",
        .addr = A_SYS_CACHE_GRP_HN_NODEID_REG8_U_CXRH_NID264,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_HN_NODEID_REG9_U_CXRH_NID264",
        .addr = A_SYS_CACHE_GRP_HN_NODEID_REG9_U_CXRH_NID264,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_HN_NODEID_REG10_U_CXRH_NID264",
        .addr = A_SYS_CACHE_GRP_HN_NODEID_REG10_U_CXRH_NID264,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_HN_NODEID_REG11_U_CXRH_NID264",
        .addr = A_SYS_CACHE_GRP_HN_NODEID_REG11_U_CXRH_NID264,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_HN_NODEID_REG12_U_CXRH_NID264",
        .addr = A_SYS_CACHE_GRP_HN_NODEID_REG12_U_CXRH_NID264,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_HN_NODEID_REG13_U_CXRH_NID264",
        .addr = A_SYS_CACHE_GRP_HN_NODEID_REG13_U_CXRH_NID264,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_HN_NODEID_REG14_U_CXRH_NID264",
        .addr = A_SYS_CACHE_GRP_HN_NODEID_REG14_U_CXRH_NID264,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_HN_NODEID_REG15_U_CXRH_NID264",
        .addr = A_SYS_CACHE_GRP_HN_NODEID_REG15_U_CXRH_NID264,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_SN_NODEID_REG8_U_CXRH_NID264",
        .addr = A_SYS_CACHE_GRP_SN_NODEID_REG8_U_CXRH_NID264,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_SN_NODEID_REG9_U_CXRH_NID264",
        .addr = A_SYS_CACHE_GRP_SN_NODEID_REG9_U_CXRH_NID264,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_SN_NODEID_REG10_U_CXRH_NID264",
        .addr = A_SYS_CACHE_GRP_SN_NODEID_REG10_U_CXRH_NID264,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_SN_NODEID_REG11_U_CXRH_NID264",
        .addr = A_SYS_CACHE_GRP_SN_NODEID_REG11_U_CXRH_NID264,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_SN_NODEID_REG12_U_CXRH_NID264",
        .addr = A_SYS_CACHE_GRP_SN_NODEID_REG12_U_CXRH_NID264,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_SN_NODEID_REG13_U_CXRH_NID264",
        .addr = A_SYS_CACHE_GRP_SN_NODEID_REG13_U_CXRH_NID264,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_SN_NODEID_REG14_U_CXRH_NID264",
        .addr = A_SYS_CACHE_GRP_SN_NODEID_REG14_U_CXRH_NID264,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_SN_NODEID_REG15_U_CXRH_NID264",
        .addr = A_SYS_CACHE_GRP_SN_NODEID_REG15_U_CXRH_NID264,
        .ro = 0xffff800800800800L,
    },{ .name = "POR_RNSAM_NODE_INFO_U_RNFBESAM_NID268",
        .addr = A_POR_RNSAM_NODE_INFO_U_RNFBESAM_NID268,
        .reset = 0x4000f,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_RNSAM_CHILD_INFO_U_RNFBESAM_NID268",
        .addr = A_POR_RNSAM_CHILD_INFO_U_RNFBESAM_NID268,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_RNSAM_UNIT_INFO_U_RNFBESAM_NID268",
        .addr = A_POR_RNSAM_UNIT_INFO_U_RNFBESAM_NID268,
        .reset = 0x800040004,
        .rsvd = 0xff00,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_RNSAM_SECURE_REGISTER_GROUPS_OVERRIDE_U_RNFBESAM_NID268",
        .addr = A_POR_RNSAM_SECURE_REGISTER_GROUPS_OVERRIDE_U_RNFBESAM_NID268,
        .rsvd = 0xfffffffffffffffeL,
        .ro = 0xfffffffffffffffeL,
    },{ .name = "RNSAM_STATUS_U_RNFBESAM_NID268",
        .addr = A_RNSAM_STATUS_U_RNFBESAM_NID268,
        .reset = 0x1,
        .rsvd = 0xfffffffffffffffcL,
        .ro = 0xfffffffffffffffcL,
    },{ .name = "NON_HASH_MEM_REGION_REG0_U_RNFBESAM_NID268",
        .addr = A_NON_HASH_MEM_REGION_REG0_U_RNFBESAM_NID268,
        .rsvd = 0x2,
        .ro = 0x8000000280000002L,
    },{ .name = "NON_HASH_MEM_REGION_REG1_U_RNFBESAM_NID268",
        .addr = A_NON_HASH_MEM_REGION_REG1_U_RNFBESAM_NID268,
        .rsvd = 0x2,
        .ro = 0x8000000280000002L,
    },{ .name = "NON_HASH_MEM_REGION_REG2_U_RNFBESAM_NID268",
        .addr = A_NON_HASH_MEM_REGION_REG2_U_RNFBESAM_NID268,
        .rsvd = 0x2,
        .ro = 0x8000000280000002L,
    },{ .name = "NON_HASH_MEM_REGION_REG3_U_RNFBESAM_NID268",
        .addr = A_NON_HASH_MEM_REGION_REG3_U_RNFBESAM_NID268,
        .rsvd = 0x2,
        .ro = 0x8000000280000002L,
    },{ .name = "NON_HASH_TGT_NODEID0_U_RNFBESAM_NID268",
        .addr = A_NON_HASH_TGT_NODEID0_U_RNFBESAM_NID268,
        .ro = 0xffff800800800800L,
    },{ .name = "NON_HASH_TGT_NODEID1_U_RNFBESAM_NID268",
        .addr = A_NON_HASH_TGT_NODEID1_U_RNFBESAM_NID268,
        .ro = 0xffff800800800800L,
    },{ .name = "NON_HASH_TGT_NODEID2_U_RNFBESAM_NID268",
        .addr = A_NON_HASH_TGT_NODEID2_U_RNFBESAM_NID268,
        .ro = 0xffffffffff800800L,
    },{ .name = "SYS_CACHE_GRP_REGION0_U_RNFBESAM_NID268",
        .addr = A_SYS_CACHE_GRP_REGION0_U_RNFBESAM_NID268,
        .rsvd = 0x2,
        .ro = 0x8000000080000002L,
    },{ .name = "SYS_CACHE_GRP_REGION1_U_RNFBESAM_NID268",
        .addr = A_SYS_CACHE_GRP_REGION1_U_RNFBESAM_NID268,
        .ro = 0x8000000080000000L,
    },{ .name = "SYS_CACHE_GRP_HN_NODEID_REG0_U_RNFBESAM_NID268",
        .addr = A_SYS_CACHE_GRP_HN_NODEID_REG0_U_RNFBESAM_NID268,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_HN_NODEID_REG1_U_RNFBESAM_NID268",
        .addr = A_SYS_CACHE_GRP_HN_NODEID_REG1_U_RNFBESAM_NID268,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_HN_NODEID_REG2_U_RNFBESAM_NID268",
        .addr = A_SYS_CACHE_GRP_HN_NODEID_REG2_U_RNFBESAM_NID268,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_HN_NODEID_REG3_U_RNFBESAM_NID268",
        .addr = A_SYS_CACHE_GRP_HN_NODEID_REG3_U_RNFBESAM_NID268,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_HN_NODEID_REG4_U_RNFBESAM_NID268",
        .addr = A_SYS_CACHE_GRP_HN_NODEID_REG4_U_RNFBESAM_NID268,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_HN_NODEID_REG5_U_RNFBESAM_NID268",
        .addr = A_SYS_CACHE_GRP_HN_NODEID_REG5_U_RNFBESAM_NID268,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_HN_NODEID_REG6_U_RNFBESAM_NID268",
        .addr = A_SYS_CACHE_GRP_HN_NODEID_REG6_U_RNFBESAM_NID268,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_HN_NODEID_REG7_U_RNFBESAM_NID268",
        .addr = A_SYS_CACHE_GRP_HN_NODEID_REG7_U_RNFBESAM_NID268,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_NONHASH_NODEID_U_RNFBESAM_NID268",
        .addr = A_SYS_CACHE_GRP_NONHASH_NODEID_U_RNFBESAM_NID268,
        .ro = 0xfffffff800800800L,
    },{ .name = "SYS_CACHE_GROUP_HN_COUNT_U_RNFBESAM_NID268",
        .addr = A_SYS_CACHE_GROUP_HN_COUNT_U_RNFBESAM_NID268,
        .rsvd = 0x80,
        .ro = 0xffffffff80808080L,
    },{ .name = "SYS_CACHE_GRP_SN_NODEID_REG0_U_RNFBESAM_NID268",
        .addr = A_SYS_CACHE_GRP_SN_NODEID_REG0_U_RNFBESAM_NID268,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_SN_NODEID_REG1_U_RNFBESAM_NID268",
        .addr = A_SYS_CACHE_GRP_SN_NODEID_REG1_U_RNFBESAM_NID268,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_SN_NODEID_REG2_U_RNFBESAM_NID268",
        .addr = A_SYS_CACHE_GRP_SN_NODEID_REG2_U_RNFBESAM_NID268,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_SN_NODEID_REG3_U_RNFBESAM_NID268",
        .addr = A_SYS_CACHE_GRP_SN_NODEID_REG3_U_RNFBESAM_NID268,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_SN_NODEID_REG4_U_RNFBESAM_NID268",
        .addr = A_SYS_CACHE_GRP_SN_NODEID_REG4_U_RNFBESAM_NID268,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_SN_NODEID_REG5_U_RNFBESAM_NID268",
        .addr = A_SYS_CACHE_GRP_SN_NODEID_REG5_U_RNFBESAM_NID268,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_SN_NODEID_REG6_U_RNFBESAM_NID268",
        .addr = A_SYS_CACHE_GRP_SN_NODEID_REG6_U_RNFBESAM_NID268,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_SN_NODEID_REG7_U_RNFBESAM_NID268",
        .addr = A_SYS_CACHE_GRP_SN_NODEID_REG7_U_RNFBESAM_NID268,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_SN_SAM_CFG0_U_RNFBESAM_NID268",
        .addr = A_SYS_CACHE_GRP_SN_SAM_CFG0_U_RNFBESAM_NID268,
        .rsvd = 0xc0,
        .ro = 0xffffc0c0c0c0c0c0L,
    },{ .name = "SYS_CACHE_GRP_SN_SAM_CFG1_U_RNFBESAM_NID268",
        .addr = A_SYS_CACHE_GRP_SN_SAM_CFG1_U_RNFBESAM_NID268,
        .rsvd = 0xc0,
        .ro = 0xffffc0c0c0c0c0c0L,
    },{ .name = "GIC_MEM_REGION_REG_U_RNFBESAM_NID268",
        .addr = A_GIC_MEM_REGION_REG_U_RNFBESAM_NID268,
        .rsvd = 0xff82,
        .ro = 0x800f00000000ff82L,
    },{ .name = "SYS_CACHE_GRP_SN_ATTR_U_RNFBESAM_NID268",
        .addr = A_SYS_CACHE_GRP_SN_ATTR_U_RNFBESAM_NID268,
        .rsvd = 0xffce,
        .ro = 0xffceffceffceffceL,
    },{ .name = "SYS_CACHE_GRP_HN_CPA_EN_REG_U_RNFBESAM_NID268",
        .addr = A_SYS_CACHE_GRP_HN_CPA_EN_REG_U_RNFBESAM_NID268,
    },{ .name = "SYS_CACHE_GRP_HN_CPA_GRP_REG_U_RNFBESAM_NID268",
        .addr = A_SYS_CACHE_GRP_HN_CPA_GRP_REG_U_RNFBESAM_NID268,
        .rsvd = 0xfffc,
        .ro = 0xfffcfffcfffcfffcL,
    },{ .name = "CML_PORT_AGGR_MODE_CTRL_REG_U_RNFBESAM_NID268",
        .addr = A_CML_PORT_AGGR_MODE_CTRL_REG_U_RNFBESAM_NID268,
        .rsvd = 0x88,
        .ro = 0xffffffff28888888L,
    },{ .name = "CML_PORT_AGGR_GRP0_ADD_MASK_U_RNFBESAM_NID268",
        .addr = A_CML_PORT_AGGR_GRP0_ADD_MASK_U_RNFBESAM_NID268,
        .reset = 0x40,
        .ro = 0xffff00000000003fL,
    },{ .name = "CML_PORT_AGGR_GRP1_ADD_MASK_U_RNFBESAM_NID268",
        .addr = A_CML_PORT_AGGR_GRP1_ADD_MASK_U_RNFBESAM_NID268,
        .reset = 0x40,
        .ro = 0xffff00000000003fL,
    },{ .name = "CML_PORT_AGGR_GRP0_REG_U_RNFBESAM_NID268",
        .addr = A_CML_PORT_AGGR_GRP0_REG_U_RNFBESAM_NID268,
        .ro = 0xfffc800800800800L,
    },{ .name = "CML_PORT_AGGR_GRP1_REG_U_RNFBESAM_NID268",
        .addr = A_CML_PORT_AGGR_GRP1_REG_U_RNFBESAM_NID268,
        .ro = 0xfffc800800800800L,
    },{ .name = "SYS_CACHE_GRP_SECONDARY_REG0_U_RNFBESAM_NID268",
        .addr = A_SYS_CACHE_GRP_SECONDARY_REG0_U_RNFBESAM_NID268,
        .rsvd = 0x2,
        .ro = 0x8000000280000002L,
    },{ .name = "SYS_CACHE_GRP_SECONDARY_REG1_U_RNFBESAM_NID268",
        .addr = A_SYS_CACHE_GRP_SECONDARY_REG1_U_RNFBESAM_NID268,
        .rsvd = 0x2,
        .ro = 0x8000000280000002L,
    },{ .name = "SYS_CACHE_GRP_CAL_MODE_REG_U_RNFBESAM_NID268",
        .addr = A_SYS_CACHE_GRP_CAL_MODE_REG_U_RNFBESAM_NID268,
        .rsvd = 0xfffe,
        .ro = 0xfffefffefffefffeL,
    },{ .name = "RNSAM_HASH_ADDR_MASK_REG_U_RNFBESAM_NID268",
        .addr = A_RNSAM_HASH_ADDR_MASK_REG_U_RNFBESAM_NID268,
        .reset = 0xffffffffffc0,
        .ro = 0xffff00000000003fL,
    },{ .name = "RNSAM_REGION_CMP_ADDR_MASK_REG_U_RNFBESAM_NID268",
        .addr = A_RNSAM_REGION_CMP_ADDR_MASK_REG_U_RNFBESAM_NID268,
        .reset = 0xffffffff0000,
        .ro = 0xffff00000000ffffL,
    },{ .name = "SYS_CACHE_GRP_HN_NODEID_REG8_U_RNFBESAM_NID268",
        .addr = A_SYS_CACHE_GRP_HN_NODEID_REG8_U_RNFBESAM_NID268,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_HN_NODEID_REG9_U_RNFBESAM_NID268",
        .addr = A_SYS_CACHE_GRP_HN_NODEID_REG9_U_RNFBESAM_NID268,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_HN_NODEID_REG10_U_RNFBESAM_NID268",
        .addr = A_SYS_CACHE_GRP_HN_NODEID_REG10_U_RNFBESAM_NID268,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_HN_NODEID_REG11_U_RNFBESAM_NID268",
        .addr = A_SYS_CACHE_GRP_HN_NODEID_REG11_U_RNFBESAM_NID268,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_HN_NODEID_REG12_U_RNFBESAM_NID268",
        .addr = A_SYS_CACHE_GRP_HN_NODEID_REG12_U_RNFBESAM_NID268,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_HN_NODEID_REG13_U_RNFBESAM_NID268",
        .addr = A_SYS_CACHE_GRP_HN_NODEID_REG13_U_RNFBESAM_NID268,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_HN_NODEID_REG14_U_RNFBESAM_NID268",
        .addr = A_SYS_CACHE_GRP_HN_NODEID_REG14_U_RNFBESAM_NID268,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_HN_NODEID_REG15_U_RNFBESAM_NID268",
        .addr = A_SYS_CACHE_GRP_HN_NODEID_REG15_U_RNFBESAM_NID268,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_SN_NODEID_REG8_U_RNFBESAM_NID268",
        .addr = A_SYS_CACHE_GRP_SN_NODEID_REG8_U_RNFBESAM_NID268,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_SN_NODEID_REG9_U_RNFBESAM_NID268",
        .addr = A_SYS_CACHE_GRP_SN_NODEID_REG9_U_RNFBESAM_NID268,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_SN_NODEID_REG10_U_RNFBESAM_NID268",
        .addr = A_SYS_CACHE_GRP_SN_NODEID_REG10_U_RNFBESAM_NID268,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_SN_NODEID_REG11_U_RNFBESAM_NID268",
        .addr = A_SYS_CACHE_GRP_SN_NODEID_REG11_U_RNFBESAM_NID268,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_SN_NODEID_REG12_U_RNFBESAM_NID268",
        .addr = A_SYS_CACHE_GRP_SN_NODEID_REG12_U_RNFBESAM_NID268,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_SN_NODEID_REG13_U_RNFBESAM_NID268",
        .addr = A_SYS_CACHE_GRP_SN_NODEID_REG13_U_RNFBESAM_NID268,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_SN_NODEID_REG14_U_RNFBESAM_NID268",
        .addr = A_SYS_CACHE_GRP_SN_NODEID_REG14_U_RNFBESAM_NID268,
        .ro = 0xffff800800800800L,
    },{ .name = "SYS_CACHE_GRP_SN_NODEID_REG15_U_RNFBESAM_NID268",
        .addr = A_SYS_CACHE_GRP_SN_NODEID_REG15_U_RNFBESAM_NID268,
        .ro = 0xffff800800800800L,
    },{ .name = "POR_MPU_NODE_INFO_U_CXRH_NID264",
        .addr = A_POR_MPU_NODE_INFO_U_CXRH_NID264,
        .reset = 0x202,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MPU_CHILD_INFO_U_CXRH_NID264",
        .addr = A_POR_MPU_CHILD_INFO_U_CXRH_NID264,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MPU_UNIT_INFO_U_CXRH_NID264",
        .addr = A_POR_MPU_UNIT_INFO_U_CXRH_NID264,
        .reset = 0x20,
        .ro = 0xffffffffffffffffL,
    },{ .name = "POR_MPU_M0_CTL_U_CXRH_NID264",
        .addr = A_POR_MPU_M0_CTL_U_CXRH_NID264,
        .reset = 0x2,
        .rsvd = 0xfffffffffffffff8L,
        .ro = 0xfffffffffffffff8L,
    },{ .name = "POR_MPU_M0_PRBAR0_U_CXRH_NID264",
        .addr = A_POR_MPU_M0_PRBAR0_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR0_U_CXRH_NID264",
        .addr = A_POR_MPU_M0_PRLAR0_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR1_U_CXRH_NID264",
        .addr = A_POR_MPU_M0_PRBAR1_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR1_U_CXRH_NID264",
        .addr = A_POR_MPU_M0_PRLAR1_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR2_U_CXRH_NID264",
        .addr = A_POR_MPU_M0_PRBAR2_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR2_U_CXRH_NID264",
        .addr = A_POR_MPU_M0_PRLAR2_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR3_U_CXRH_NID264",
        .addr = A_POR_MPU_M0_PRBAR3_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR3_U_CXRH_NID264",
        .addr = A_POR_MPU_M0_PRLAR3_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR4_U_CXRH_NID264",
        .addr = A_POR_MPU_M0_PRBAR4_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR4_U_CXRH_NID264",
        .addr = A_POR_MPU_M0_PRLAR4_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR5_U_CXRH_NID264",
        .addr = A_POR_MPU_M0_PRBAR5_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR5_U_CXRH_NID264",
        .addr = A_POR_MPU_M0_PRLAR5_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR6_U_CXRH_NID264",
        .addr = A_POR_MPU_M0_PRBAR6_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR6_U_CXRH_NID264",
        .addr = A_POR_MPU_M0_PRLAR6_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR7_U_CXRH_NID264",
        .addr = A_POR_MPU_M0_PRBAR7_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR7_U_CXRH_NID264",
        .addr = A_POR_MPU_M0_PRLAR7_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR8_U_CXRH_NID264",
        .addr = A_POR_MPU_M0_PRBAR8_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR8_U_CXRH_NID264",
        .addr = A_POR_MPU_M0_PRLAR8_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR9_U_CXRH_NID264",
        .addr = A_POR_MPU_M0_PRBAR9_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR9_U_CXRH_NID264",
        .addr = A_POR_MPU_M0_PRLAR9_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR10_U_CXRH_NID264",
        .addr = A_POR_MPU_M0_PRBAR10_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR10_U_CXRH_NID264",
        .addr = A_POR_MPU_M0_PRLAR10_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR11_U_CXRH_NID264",
        .addr = A_POR_MPU_M0_PRBAR11_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR11_U_CXRH_NID264",
        .addr = A_POR_MPU_M0_PRLAR11_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR12_U_CXRH_NID264",
        .addr = A_POR_MPU_M0_PRBAR12_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR12_U_CXRH_NID264",
        .addr = A_POR_MPU_M0_PRLAR12_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR13_U_CXRH_NID264",
        .addr = A_POR_MPU_M0_PRBAR13_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR13_U_CXRH_NID264",
        .addr = A_POR_MPU_M0_PRLAR13_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR14_U_CXRH_NID264",
        .addr = A_POR_MPU_M0_PRBAR14_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR14_U_CXRH_NID264",
        .addr = A_POR_MPU_M0_PRLAR14_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR15_U_CXRH_NID264",
        .addr = A_POR_MPU_M0_PRBAR15_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR15_U_CXRH_NID264",
        .addr = A_POR_MPU_M0_PRLAR15_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR16_U_CXRH_NID264",
        .addr = A_POR_MPU_M0_PRBAR16_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR16_U_CXRH_NID264",
        .addr = A_POR_MPU_M0_PRLAR16_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR17_U_CXRH_NID264",
        .addr = A_POR_MPU_M0_PRBAR17_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR17_U_CXRH_NID264",
        .addr = A_POR_MPU_M0_PRLAR17_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR18_U_CXRH_NID264",
        .addr = A_POR_MPU_M0_PRBAR18_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR18_U_CXRH_NID264",
        .addr = A_POR_MPU_M0_PRLAR18_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR19_U_CXRH_NID264",
        .addr = A_POR_MPU_M0_PRBAR19_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR19_U_CXRH_NID264",
        .addr = A_POR_MPU_M0_PRLAR19_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR20_U_CXRH_NID264",
        .addr = A_POR_MPU_M0_PRBAR20_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR20_U_CXRH_NID264",
        .addr = A_POR_MPU_M0_PRLAR20_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR21_U_CXRH_NID264",
        .addr = A_POR_MPU_M0_PRBAR21_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR21_U_CXRH_NID264",
        .addr = A_POR_MPU_M0_PRLAR21_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR22_U_CXRH_NID264",
        .addr = A_POR_MPU_M0_PRBAR22_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR22_U_CXRH_NID264",
        .addr = A_POR_MPU_M0_PRLAR22_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR23_U_CXRH_NID264",
        .addr = A_POR_MPU_M0_PRBAR23_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR23_U_CXRH_NID264",
        .addr = A_POR_MPU_M0_PRLAR23_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR24_U_CXRH_NID264",
        .addr = A_POR_MPU_M0_PRBAR24_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR24_U_CXRH_NID264",
        .addr = A_POR_MPU_M0_PRLAR24_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR25_U_CXRH_NID264",
        .addr = A_POR_MPU_M0_PRBAR25_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR25_U_CXRH_NID264",
        .addr = A_POR_MPU_M0_PRLAR25_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR26_U_CXRH_NID264",
        .addr = A_POR_MPU_M0_PRBAR26_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR26_U_CXRH_NID264",
        .addr = A_POR_MPU_M0_PRLAR26_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR27_U_CXRH_NID264",
        .addr = A_POR_MPU_M0_PRBAR27_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR27_U_CXRH_NID264",
        .addr = A_POR_MPU_M0_PRLAR27_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR28_U_CXRH_NID264",
        .addr = A_POR_MPU_M0_PRBAR28_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR28_U_CXRH_NID264",
        .addr = A_POR_MPU_M0_PRLAR28_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR29_U_CXRH_NID264",
        .addr = A_POR_MPU_M0_PRBAR29_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR29_U_CXRH_NID264",
        .addr = A_POR_MPU_M0_PRLAR29_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR30_U_CXRH_NID264",
        .addr = A_POR_MPU_M0_PRBAR30_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR30_U_CXRH_NID264",
        .addr = A_POR_MPU_M0_PRLAR30_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M0_PRBAR31_U_CXRH_NID264",
        .addr = A_POR_MPU_M0_PRBAR31_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M0_PRLAR31_U_CXRH_NID264",
        .addr = A_POR_MPU_M0_PRLAR31_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_CTL_U_CXRH_NID264",
        .addr = A_POR_MPU_M1_CTL_U_CXRH_NID264,
        .reset = 0x2,
        .rsvd = 0xfffffffffffffff8L,
        .ro = 0xfffffffffffffff8L,
    },{ .name = "POR_MPU_M1_PRBAR0_U_CXRH_NID264",
        .addr = A_POR_MPU_M1_PRBAR0_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR0_U_CXRH_NID264",
        .addr = A_POR_MPU_M1_PRLAR0_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR1_U_CXRH_NID264",
        .addr = A_POR_MPU_M1_PRBAR1_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR1_U_CXRH_NID264",
        .addr = A_POR_MPU_M1_PRLAR1_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR2_U_CXRH_NID264",
        .addr = A_POR_MPU_M1_PRBAR2_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR2_U_CXRH_NID264",
        .addr = A_POR_MPU_M1_PRLAR2_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR3_U_CXRH_NID264",
        .addr = A_POR_MPU_M1_PRBAR3_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR3_U_CXRH_NID264",
        .addr = A_POR_MPU_M1_PRLAR3_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR4_U_CXRH_NID264",
        .addr = A_POR_MPU_M1_PRBAR4_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR4_U_CXRH_NID264",
        .addr = A_POR_MPU_M1_PRLAR4_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR5_U_CXRH_NID264",
        .addr = A_POR_MPU_M1_PRBAR5_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR5_U_CXRH_NID264",
        .addr = A_POR_MPU_M1_PRLAR5_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR6_U_CXRH_NID264",
        .addr = A_POR_MPU_M1_PRBAR6_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR6_U_CXRH_NID264",
        .addr = A_POR_MPU_M1_PRLAR6_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR7_U_CXRH_NID264",
        .addr = A_POR_MPU_M1_PRBAR7_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR7_U_CXRH_NID264",
        .addr = A_POR_MPU_M1_PRLAR7_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR8_U_CXRH_NID264",
        .addr = A_POR_MPU_M1_PRBAR8_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR8_U_CXRH_NID264",
        .addr = A_POR_MPU_M1_PRLAR8_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR9_U_CXRH_NID264",
        .addr = A_POR_MPU_M1_PRBAR9_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR9_U_CXRH_NID264",
        .addr = A_POR_MPU_M1_PRLAR9_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR10_U_CXRH_NID264",
        .addr = A_POR_MPU_M1_PRBAR10_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR10_U_CXRH_NID264",
        .addr = A_POR_MPU_M1_PRLAR10_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR11_U_CXRH_NID264",
        .addr = A_POR_MPU_M1_PRBAR11_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR11_U_CXRH_NID264",
        .addr = A_POR_MPU_M1_PRLAR11_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR12_U_CXRH_NID264",
        .addr = A_POR_MPU_M1_PRBAR12_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR12_U_CXRH_NID264",
        .addr = A_POR_MPU_M1_PRLAR12_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR13_U_CXRH_NID264",
        .addr = A_POR_MPU_M1_PRBAR13_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR13_U_CXRH_NID264",
        .addr = A_POR_MPU_M1_PRLAR13_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR14_U_CXRH_NID264",
        .addr = A_POR_MPU_M1_PRBAR14_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR14_U_CXRH_NID264",
        .addr = A_POR_MPU_M1_PRLAR14_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR15_U_CXRH_NID264",
        .addr = A_POR_MPU_M1_PRBAR15_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR15_U_CXRH_NID264",
        .addr = A_POR_MPU_M1_PRLAR15_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR16_U_CXRH_NID264",
        .addr = A_POR_MPU_M1_PRBAR16_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR16_U_CXRH_NID264",
        .addr = A_POR_MPU_M1_PRLAR16_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR17_U_CXRH_NID264",
        .addr = A_POR_MPU_M1_PRBAR17_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR17_U_CXRH_NID264",
        .addr = A_POR_MPU_M1_PRLAR17_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR18_U_CXRH_NID264",
        .addr = A_POR_MPU_M1_PRBAR18_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR18_U_CXRH_NID264",
        .addr = A_POR_MPU_M1_PRLAR18_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR19_U_CXRH_NID264",
        .addr = A_POR_MPU_M1_PRBAR19_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR19_U_CXRH_NID264",
        .addr = A_POR_MPU_M1_PRLAR19_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR20_U_CXRH_NID264",
        .addr = A_POR_MPU_M1_PRBAR20_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR20_U_CXRH_NID264",
        .addr = A_POR_MPU_M1_PRLAR20_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR21_U_CXRH_NID264",
        .addr = A_POR_MPU_M1_PRBAR21_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR21_U_CXRH_NID264",
        .addr = A_POR_MPU_M1_PRLAR21_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR22_U_CXRH_NID264",
        .addr = A_POR_MPU_M1_PRBAR22_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR22_U_CXRH_NID264",
        .addr = A_POR_MPU_M1_PRLAR22_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR23_U_CXRH_NID264",
        .addr = A_POR_MPU_M1_PRBAR23_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR23_U_CXRH_NID264",
        .addr = A_POR_MPU_M1_PRLAR23_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR24_U_CXRH_NID264",
        .addr = A_POR_MPU_M1_PRBAR24_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR24_U_CXRH_NID264",
        .addr = A_POR_MPU_M1_PRLAR24_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR25_U_CXRH_NID264",
        .addr = A_POR_MPU_M1_PRBAR25_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR25_U_CXRH_NID264",
        .addr = A_POR_MPU_M1_PRLAR25_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR26_U_CXRH_NID264",
        .addr = A_POR_MPU_M1_PRBAR26_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR26_U_CXRH_NID264",
        .addr = A_POR_MPU_M1_PRLAR26_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR27_U_CXRH_NID264",
        .addr = A_POR_MPU_M1_PRBAR27_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR27_U_CXRH_NID264",
        .addr = A_POR_MPU_M1_PRLAR27_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR28_U_CXRH_NID264",
        .addr = A_POR_MPU_M1_PRBAR28_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR28_U_CXRH_NID264",
        .addr = A_POR_MPU_M1_PRLAR28_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR29_U_CXRH_NID264",
        .addr = A_POR_MPU_M1_PRBAR29_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR29_U_CXRH_NID264",
        .addr = A_POR_MPU_M1_PRLAR29_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR30_U_CXRH_NID264",
        .addr = A_POR_MPU_M1_PRBAR30_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR30_U_CXRH_NID264",
        .addr = A_POR_MPU_M1_PRLAR30_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M1_PRBAR31_U_CXRH_NID264",
        .addr = A_POR_MPU_M1_PRBAR31_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M1_PRLAR31_U_CXRH_NID264",
        .addr = A_POR_MPU_M1_PRLAR31_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_CTL_U_CXRH_NID264",
        .addr = A_POR_MPU_M2_CTL_U_CXRH_NID264,
        .reset = 0x2,
        .rsvd = 0xfffffffffffffff8L,
        .ro = 0xfffffffffffffff8L,
    },{ .name = "POR_MPU_M2_PRBAR0_U_CXRH_NID264",
        .addr = A_POR_MPU_M2_PRBAR0_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR0_U_CXRH_NID264",
        .addr = A_POR_MPU_M2_PRLAR0_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR1_U_CXRH_NID264",
        .addr = A_POR_MPU_M2_PRBAR1_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR1_U_CXRH_NID264",
        .addr = A_POR_MPU_M2_PRLAR1_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR2_U_CXRH_NID264",
        .addr = A_POR_MPU_M2_PRBAR2_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR2_U_CXRH_NID264",
        .addr = A_POR_MPU_M2_PRLAR2_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR3_U_CXRH_NID264",
        .addr = A_POR_MPU_M2_PRBAR3_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR3_U_CXRH_NID264",
        .addr = A_POR_MPU_M2_PRLAR3_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR4_U_CXRH_NID264",
        .addr = A_POR_MPU_M2_PRBAR4_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR4_U_CXRH_NID264",
        .addr = A_POR_MPU_M2_PRLAR4_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR5_U_CXRH_NID264",
        .addr = A_POR_MPU_M2_PRBAR5_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR5_U_CXRH_NID264",
        .addr = A_POR_MPU_M2_PRLAR5_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR6_U_CXRH_NID264",
        .addr = A_POR_MPU_M2_PRBAR6_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR6_U_CXRH_NID264",
        .addr = A_POR_MPU_M2_PRLAR6_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR7_U_CXRH_NID264",
        .addr = A_POR_MPU_M2_PRBAR7_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR7_U_CXRH_NID264",
        .addr = A_POR_MPU_M2_PRLAR7_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR8_U_CXRH_NID264",
        .addr = A_POR_MPU_M2_PRBAR8_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR8_U_CXRH_NID264",
        .addr = A_POR_MPU_M2_PRLAR8_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR9_U_CXRH_NID264",
        .addr = A_POR_MPU_M2_PRBAR9_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR9_U_CXRH_NID264",
        .addr = A_POR_MPU_M2_PRLAR9_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR10_U_CXRH_NID264",
        .addr = A_POR_MPU_M2_PRBAR10_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR10_U_CXRH_NID264",
        .addr = A_POR_MPU_M2_PRLAR10_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR11_U_CXRH_NID264",
        .addr = A_POR_MPU_M2_PRBAR11_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR11_U_CXRH_NID264",
        .addr = A_POR_MPU_M2_PRLAR11_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR12_U_CXRH_NID264",
        .addr = A_POR_MPU_M2_PRBAR12_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR12_U_CXRH_NID264",
        .addr = A_POR_MPU_M2_PRLAR12_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR13_U_CXRH_NID264",
        .addr = A_POR_MPU_M2_PRBAR13_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR13_U_CXRH_NID264",
        .addr = A_POR_MPU_M2_PRLAR13_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR14_U_CXRH_NID264",
        .addr = A_POR_MPU_M2_PRBAR14_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR14_U_CXRH_NID264",
        .addr = A_POR_MPU_M2_PRLAR14_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR15_U_CXRH_NID264",
        .addr = A_POR_MPU_M2_PRBAR15_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR15_U_CXRH_NID264",
        .addr = A_POR_MPU_M2_PRLAR15_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR16_U_CXRH_NID264",
        .addr = A_POR_MPU_M2_PRBAR16_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR16_U_CXRH_NID264",
        .addr = A_POR_MPU_M2_PRLAR16_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR17_U_CXRH_NID264",
        .addr = A_POR_MPU_M2_PRBAR17_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR17_U_CXRH_NID264",
        .addr = A_POR_MPU_M2_PRLAR17_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR18_U_CXRH_NID264",
        .addr = A_POR_MPU_M2_PRBAR18_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR18_U_CXRH_NID264",
        .addr = A_POR_MPU_M2_PRLAR18_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR19_U_CXRH_NID264",
        .addr = A_POR_MPU_M2_PRBAR19_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR19_U_CXRH_NID264",
        .addr = A_POR_MPU_M2_PRLAR19_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR20_U_CXRH_NID264",
        .addr = A_POR_MPU_M2_PRBAR20_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR20_U_CXRH_NID264",
        .addr = A_POR_MPU_M2_PRLAR20_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR21_U_CXRH_NID264",
        .addr = A_POR_MPU_M2_PRBAR21_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR21_U_CXRH_NID264",
        .addr = A_POR_MPU_M2_PRLAR21_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR22_U_CXRH_NID264",
        .addr = A_POR_MPU_M2_PRBAR22_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR22_U_CXRH_NID264",
        .addr = A_POR_MPU_M2_PRLAR22_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR23_U_CXRH_NID264",
        .addr = A_POR_MPU_M2_PRBAR23_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR23_U_CXRH_NID264",
        .addr = A_POR_MPU_M2_PRLAR23_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR24_U_CXRH_NID264",
        .addr = A_POR_MPU_M2_PRBAR24_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR24_U_CXRH_NID264",
        .addr = A_POR_MPU_M2_PRLAR24_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR25_U_CXRH_NID264",
        .addr = A_POR_MPU_M2_PRBAR25_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR25_U_CXRH_NID264",
        .addr = A_POR_MPU_M2_PRLAR25_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR26_U_CXRH_NID264",
        .addr = A_POR_MPU_M2_PRBAR26_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR26_U_CXRH_NID264",
        .addr = A_POR_MPU_M2_PRLAR26_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR27_U_CXRH_NID264",
        .addr = A_POR_MPU_M2_PRBAR27_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR27_U_CXRH_NID264",
        .addr = A_POR_MPU_M2_PRLAR27_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR28_U_CXRH_NID264",
        .addr = A_POR_MPU_M2_PRBAR28_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR28_U_CXRH_NID264",
        .addr = A_POR_MPU_M2_PRLAR28_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR29_U_CXRH_NID264",
        .addr = A_POR_MPU_M2_PRBAR29_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR29_U_CXRH_NID264",
        .addr = A_POR_MPU_M2_PRLAR29_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR30_U_CXRH_NID264",
        .addr = A_POR_MPU_M2_PRBAR30_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR30_U_CXRH_NID264",
        .addr = A_POR_MPU_M2_PRLAR30_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M2_PRBAR31_U_CXRH_NID264",
        .addr = A_POR_MPU_M2_PRBAR31_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M2_PRLAR31_U_CXRH_NID264",
        .addr = A_POR_MPU_M2_PRLAR31_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_CTL_U_CXRH_NID264",
        .addr = A_POR_MPU_M3_CTL_U_CXRH_NID264,
        .reset = 0x2,
        .rsvd = 0xfffffffffffffff8L,
        .ro = 0xfffffffffffffff8L,
    },{ .name = "POR_MPU_M3_PRBAR0_U_CXRH_NID264",
        .addr = A_POR_MPU_M3_PRBAR0_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR0_U_CXRH_NID264",
        .addr = A_POR_MPU_M3_PRLAR0_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR1_U_CXRH_NID264",
        .addr = A_POR_MPU_M3_PRBAR1_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR1_U_CXRH_NID264",
        .addr = A_POR_MPU_M3_PRLAR1_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR2_U_CXRH_NID264",
        .addr = A_POR_MPU_M3_PRBAR2_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR2_U_CXRH_NID264",
        .addr = A_POR_MPU_M3_PRLAR2_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR3_U_CXRH_NID264",
        .addr = A_POR_MPU_M3_PRBAR3_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR3_U_CXRH_NID264",
        .addr = A_POR_MPU_M3_PRLAR3_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR4_U_CXRH_NID264",
        .addr = A_POR_MPU_M3_PRBAR4_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR4_U_CXRH_NID264",
        .addr = A_POR_MPU_M3_PRLAR4_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR5_U_CXRH_NID264",
        .addr = A_POR_MPU_M3_PRBAR5_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR5_U_CXRH_NID264",
        .addr = A_POR_MPU_M3_PRLAR5_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR6_U_CXRH_NID264",
        .addr = A_POR_MPU_M3_PRBAR6_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR6_U_CXRH_NID264",
        .addr = A_POR_MPU_M3_PRLAR6_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR7_U_CXRH_NID264",
        .addr = A_POR_MPU_M3_PRBAR7_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR7_U_CXRH_NID264",
        .addr = A_POR_MPU_M3_PRLAR7_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR8_U_CXRH_NID264",
        .addr = A_POR_MPU_M3_PRBAR8_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR8_U_CXRH_NID264",
        .addr = A_POR_MPU_M3_PRLAR8_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR9_U_CXRH_NID264",
        .addr = A_POR_MPU_M3_PRBAR9_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR9_U_CXRH_NID264",
        .addr = A_POR_MPU_M3_PRLAR9_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR10_U_CXRH_NID264",
        .addr = A_POR_MPU_M3_PRBAR10_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR10_U_CXRH_NID264",
        .addr = A_POR_MPU_M3_PRLAR10_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR11_U_CXRH_NID264",
        .addr = A_POR_MPU_M3_PRBAR11_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR11_U_CXRH_NID264",
        .addr = A_POR_MPU_M3_PRLAR11_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR12_U_CXRH_NID264",
        .addr = A_POR_MPU_M3_PRBAR12_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR12_U_CXRH_NID264",
        .addr = A_POR_MPU_M3_PRLAR12_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR13_U_CXRH_NID264",
        .addr = A_POR_MPU_M3_PRBAR13_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR13_U_CXRH_NID264",
        .addr = A_POR_MPU_M3_PRLAR13_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR14_U_CXRH_NID264",
        .addr = A_POR_MPU_M3_PRBAR14_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR14_U_CXRH_NID264",
        .addr = A_POR_MPU_M3_PRLAR14_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR15_U_CXRH_NID264",
        .addr = A_POR_MPU_M3_PRBAR15_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR15_U_CXRH_NID264",
        .addr = A_POR_MPU_M3_PRLAR15_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR16_U_CXRH_NID264",
        .addr = A_POR_MPU_M3_PRBAR16_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR16_U_CXRH_NID264",
        .addr = A_POR_MPU_M3_PRLAR16_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR17_U_CXRH_NID264",
        .addr = A_POR_MPU_M3_PRBAR17_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR17_U_CXRH_NID264",
        .addr = A_POR_MPU_M3_PRLAR17_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR18_U_CXRH_NID264",
        .addr = A_POR_MPU_M3_PRBAR18_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR18_U_CXRH_NID264",
        .addr = A_POR_MPU_M3_PRLAR18_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR19_U_CXRH_NID264",
        .addr = A_POR_MPU_M3_PRBAR19_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR19_U_CXRH_NID264",
        .addr = A_POR_MPU_M3_PRLAR19_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR20_U_CXRH_NID264",
        .addr = A_POR_MPU_M3_PRBAR20_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR20_U_CXRH_NID264",
        .addr = A_POR_MPU_M3_PRLAR20_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR21_U_CXRH_NID264",
        .addr = A_POR_MPU_M3_PRBAR21_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR21_U_CXRH_NID264",
        .addr = A_POR_MPU_M3_PRLAR21_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR22_U_CXRH_NID264",
        .addr = A_POR_MPU_M3_PRBAR22_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR22_U_CXRH_NID264",
        .addr = A_POR_MPU_M3_PRLAR22_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR23_U_CXRH_NID264",
        .addr = A_POR_MPU_M3_PRBAR23_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR23_U_CXRH_NID264",
        .addr = A_POR_MPU_M3_PRLAR23_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR24_U_CXRH_NID264",
        .addr = A_POR_MPU_M3_PRBAR24_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR24_U_CXRH_NID264",
        .addr = A_POR_MPU_M3_PRLAR24_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR25_U_CXRH_NID264",
        .addr = A_POR_MPU_M3_PRBAR25_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR25_U_CXRH_NID264",
        .addr = A_POR_MPU_M3_PRLAR25_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR26_U_CXRH_NID264",
        .addr = A_POR_MPU_M3_PRBAR26_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR26_U_CXRH_NID264",
        .addr = A_POR_MPU_M3_PRLAR26_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR27_U_CXRH_NID264",
        .addr = A_POR_MPU_M3_PRBAR27_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR27_U_CXRH_NID264",
        .addr = A_POR_MPU_M3_PRLAR27_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR28_U_CXRH_NID264",
        .addr = A_POR_MPU_M3_PRBAR28_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR28_U_CXRH_NID264",
        .addr = A_POR_MPU_M3_PRLAR28_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR29_U_CXRH_NID264",
        .addr = A_POR_MPU_M3_PRBAR29_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR29_U_CXRH_NID264",
        .addr = A_POR_MPU_M3_PRLAR29_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR30_U_CXRH_NID264",
        .addr = A_POR_MPU_M3_PRBAR30_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR30_U_CXRH_NID264",
        .addr = A_POR_MPU_M3_PRLAR30_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M3_PRBAR31_U_CXRH_NID264",
        .addr = A_POR_MPU_M3_PRBAR31_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M3_PRLAR31_U_CXRH_NID264",
        .addr = A_POR_MPU_M3_PRLAR31_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_CTL_U_CXRH_NID264",
        .addr = A_POR_MPU_M4_CTL_U_CXRH_NID264,
        .reset = 0x2,
        .rsvd = 0xfffffffffffffff8L,
        .ro = 0xfffffffffffffff8L,
    },{ .name = "POR_MPU_M4_PRBAR0_U_CXRH_NID264",
        .addr = A_POR_MPU_M4_PRBAR0_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR0_U_CXRH_NID264",
        .addr = A_POR_MPU_M4_PRLAR0_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR1_U_CXRH_NID264",
        .addr = A_POR_MPU_M4_PRBAR1_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR1_U_CXRH_NID264",
        .addr = A_POR_MPU_M4_PRLAR1_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR2_U_CXRH_NID264",
        .addr = A_POR_MPU_M4_PRBAR2_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR2_U_CXRH_NID264",
        .addr = A_POR_MPU_M4_PRLAR2_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR3_U_CXRH_NID264",
        .addr = A_POR_MPU_M4_PRBAR3_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR3_U_CXRH_NID264",
        .addr = A_POR_MPU_M4_PRLAR3_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR4_U_CXRH_NID264",
        .addr = A_POR_MPU_M4_PRBAR4_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR4_U_CXRH_NID264",
        .addr = A_POR_MPU_M4_PRLAR4_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR5_U_CXRH_NID264",
        .addr = A_POR_MPU_M4_PRBAR5_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR5_U_CXRH_NID264",
        .addr = A_POR_MPU_M4_PRLAR5_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR6_U_CXRH_NID264",
        .addr = A_POR_MPU_M4_PRBAR6_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR6_U_CXRH_NID264",
        .addr = A_POR_MPU_M4_PRLAR6_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR7_U_CXRH_NID264",
        .addr = A_POR_MPU_M4_PRBAR7_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR7_U_CXRH_NID264",
        .addr = A_POR_MPU_M4_PRLAR7_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR8_U_CXRH_NID264",
        .addr = A_POR_MPU_M4_PRBAR8_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR8_U_CXRH_NID264",
        .addr = A_POR_MPU_M4_PRLAR8_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR9_U_CXRH_NID264",
        .addr = A_POR_MPU_M4_PRBAR9_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR9_U_CXRH_NID264",
        .addr = A_POR_MPU_M4_PRLAR9_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR10_U_CXRH_NID264",
        .addr = A_POR_MPU_M4_PRBAR10_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR10_U_CXRH_NID264",
        .addr = A_POR_MPU_M4_PRLAR10_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR11_U_CXRH_NID264",
        .addr = A_POR_MPU_M4_PRBAR11_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR11_U_CXRH_NID264",
        .addr = A_POR_MPU_M4_PRLAR11_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR12_U_CXRH_NID264",
        .addr = A_POR_MPU_M4_PRBAR12_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR12_U_CXRH_NID264",
        .addr = A_POR_MPU_M4_PRLAR12_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR13_U_CXRH_NID264",
        .addr = A_POR_MPU_M4_PRBAR13_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR13_U_CXRH_NID264",
        .addr = A_POR_MPU_M4_PRLAR13_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR14_U_CXRH_NID264",
        .addr = A_POR_MPU_M4_PRBAR14_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR14_U_CXRH_NID264",
        .addr = A_POR_MPU_M4_PRLAR14_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR15_U_CXRH_NID264",
        .addr = A_POR_MPU_M4_PRBAR15_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR15_U_CXRH_NID264",
        .addr = A_POR_MPU_M4_PRLAR15_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR16_U_CXRH_NID264",
        .addr = A_POR_MPU_M4_PRBAR16_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR16_U_CXRH_NID264",
        .addr = A_POR_MPU_M4_PRLAR16_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR17_U_CXRH_NID264",
        .addr = A_POR_MPU_M4_PRBAR17_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR17_U_CXRH_NID264",
        .addr = A_POR_MPU_M4_PRLAR17_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR18_U_CXRH_NID264",
        .addr = A_POR_MPU_M4_PRBAR18_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR18_U_CXRH_NID264",
        .addr = A_POR_MPU_M4_PRLAR18_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR19_U_CXRH_NID264",
        .addr = A_POR_MPU_M4_PRBAR19_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR19_U_CXRH_NID264",
        .addr = A_POR_MPU_M4_PRLAR19_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR20_U_CXRH_NID264",
        .addr = A_POR_MPU_M4_PRBAR20_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR20_U_CXRH_NID264",
        .addr = A_POR_MPU_M4_PRLAR20_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR21_U_CXRH_NID264",
        .addr = A_POR_MPU_M4_PRBAR21_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR21_U_CXRH_NID264",
        .addr = A_POR_MPU_M4_PRLAR21_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR22_U_CXRH_NID264",
        .addr = A_POR_MPU_M4_PRBAR22_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR22_U_CXRH_NID264",
        .addr = A_POR_MPU_M4_PRLAR22_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR23_U_CXRH_NID264",
        .addr = A_POR_MPU_M4_PRBAR23_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR23_U_CXRH_NID264",
        .addr = A_POR_MPU_M4_PRLAR23_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR24_U_CXRH_NID264",
        .addr = A_POR_MPU_M4_PRBAR24_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR24_U_CXRH_NID264",
        .addr = A_POR_MPU_M4_PRLAR24_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR25_U_CXRH_NID264",
        .addr = A_POR_MPU_M4_PRBAR25_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR25_U_CXRH_NID264",
        .addr = A_POR_MPU_M4_PRLAR25_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR26_U_CXRH_NID264",
        .addr = A_POR_MPU_M4_PRBAR26_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR26_U_CXRH_NID264",
        .addr = A_POR_MPU_M4_PRLAR26_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR27_U_CXRH_NID264",
        .addr = A_POR_MPU_M4_PRBAR27_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR27_U_CXRH_NID264",
        .addr = A_POR_MPU_M4_PRLAR27_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR28_U_CXRH_NID264",
        .addr = A_POR_MPU_M4_PRBAR28_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR28_U_CXRH_NID264",
        .addr = A_POR_MPU_M4_PRLAR28_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR29_U_CXRH_NID264",
        .addr = A_POR_MPU_M4_PRBAR29_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR29_U_CXRH_NID264",
        .addr = A_POR_MPU_M4_PRLAR29_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR30_U_CXRH_NID264",
        .addr = A_POR_MPU_M4_PRBAR30_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR30_U_CXRH_NID264",
        .addr = A_POR_MPU_M4_PRLAR30_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M4_PRBAR31_U_CXRH_NID264",
        .addr = A_POR_MPU_M4_PRBAR31_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M4_PRLAR31_U_CXRH_NID264",
        .addr = A_POR_MPU_M4_PRLAR31_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_CTL_U_CXRH_NID264",
        .addr = A_POR_MPU_M5_CTL_U_CXRH_NID264,
        .reset = 0x2,
        .rsvd = 0xfffffffffffffff8L,
        .ro = 0xfffffffffffffff8L,
    },{ .name = "POR_MPU_M5_PRBAR0_U_CXRH_NID264",
        .addr = A_POR_MPU_M5_PRBAR0_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR0_U_CXRH_NID264",
        .addr = A_POR_MPU_M5_PRLAR0_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR1_U_CXRH_NID264",
        .addr = A_POR_MPU_M5_PRBAR1_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR1_U_CXRH_NID264",
        .addr = A_POR_MPU_M5_PRLAR1_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR2_U_CXRH_NID264",
        .addr = A_POR_MPU_M5_PRBAR2_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR2_U_CXRH_NID264",
        .addr = A_POR_MPU_M5_PRLAR2_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR3_U_CXRH_NID264",
        .addr = A_POR_MPU_M5_PRBAR3_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR3_U_CXRH_NID264",
        .addr = A_POR_MPU_M5_PRLAR3_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR4_U_CXRH_NID264",
        .addr = A_POR_MPU_M5_PRBAR4_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR4_U_CXRH_NID264",
        .addr = A_POR_MPU_M5_PRLAR4_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR5_U_CXRH_NID264",
        .addr = A_POR_MPU_M5_PRBAR5_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR5_U_CXRH_NID264",
        .addr = A_POR_MPU_M5_PRLAR5_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR6_U_CXRH_NID264",
        .addr = A_POR_MPU_M5_PRBAR6_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR6_U_CXRH_NID264",
        .addr = A_POR_MPU_M5_PRLAR6_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR7_U_CXRH_NID264",
        .addr = A_POR_MPU_M5_PRBAR7_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR7_U_CXRH_NID264",
        .addr = A_POR_MPU_M5_PRLAR7_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR8_U_CXRH_NID264",
        .addr = A_POR_MPU_M5_PRBAR8_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR8_U_CXRH_NID264",
        .addr = A_POR_MPU_M5_PRLAR8_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR9_U_CXRH_NID264",
        .addr = A_POR_MPU_M5_PRBAR9_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR9_U_CXRH_NID264",
        .addr = A_POR_MPU_M5_PRLAR9_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR10_U_CXRH_NID264",
        .addr = A_POR_MPU_M5_PRBAR10_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR10_U_CXRH_NID264",
        .addr = A_POR_MPU_M5_PRLAR10_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR11_U_CXRH_NID264",
        .addr = A_POR_MPU_M5_PRBAR11_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR11_U_CXRH_NID264",
        .addr = A_POR_MPU_M5_PRLAR11_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR12_U_CXRH_NID264",
        .addr = A_POR_MPU_M5_PRBAR12_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR12_U_CXRH_NID264",
        .addr = A_POR_MPU_M5_PRLAR12_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR13_U_CXRH_NID264",
        .addr = A_POR_MPU_M5_PRBAR13_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR13_U_CXRH_NID264",
        .addr = A_POR_MPU_M5_PRLAR13_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR14_U_CXRH_NID264",
        .addr = A_POR_MPU_M5_PRBAR14_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR14_U_CXRH_NID264",
        .addr = A_POR_MPU_M5_PRLAR14_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR15_U_CXRH_NID264",
        .addr = A_POR_MPU_M5_PRBAR15_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR15_U_CXRH_NID264",
        .addr = A_POR_MPU_M5_PRLAR15_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR16_U_CXRH_NID264",
        .addr = A_POR_MPU_M5_PRBAR16_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR16_U_CXRH_NID264",
        .addr = A_POR_MPU_M5_PRLAR16_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR17_U_CXRH_NID264",
        .addr = A_POR_MPU_M5_PRBAR17_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR17_U_CXRH_NID264",
        .addr = A_POR_MPU_M5_PRLAR17_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR18_U_CXRH_NID264",
        .addr = A_POR_MPU_M5_PRBAR18_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR18_U_CXRH_NID264",
        .addr = A_POR_MPU_M5_PRLAR18_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR19_U_CXRH_NID264",
        .addr = A_POR_MPU_M5_PRBAR19_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR19_U_CXRH_NID264",
        .addr = A_POR_MPU_M5_PRLAR19_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR20_U_CXRH_NID264",
        .addr = A_POR_MPU_M5_PRBAR20_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR20_U_CXRH_NID264",
        .addr = A_POR_MPU_M5_PRLAR20_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR21_U_CXRH_NID264",
        .addr = A_POR_MPU_M5_PRBAR21_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR21_U_CXRH_NID264",
        .addr = A_POR_MPU_M5_PRLAR21_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR22_U_CXRH_NID264",
        .addr = A_POR_MPU_M5_PRBAR22_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR22_U_CXRH_NID264",
        .addr = A_POR_MPU_M5_PRLAR22_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR23_U_CXRH_NID264",
        .addr = A_POR_MPU_M5_PRBAR23_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR23_U_CXRH_NID264",
        .addr = A_POR_MPU_M5_PRLAR23_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR24_U_CXRH_NID264",
        .addr = A_POR_MPU_M5_PRBAR24_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR24_U_CXRH_NID264",
        .addr = A_POR_MPU_M5_PRLAR24_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR25_U_CXRH_NID264",
        .addr = A_POR_MPU_M5_PRBAR25_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR25_U_CXRH_NID264",
        .addr = A_POR_MPU_M5_PRLAR25_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR26_U_CXRH_NID264",
        .addr = A_POR_MPU_M5_PRBAR26_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR26_U_CXRH_NID264",
        .addr = A_POR_MPU_M5_PRLAR26_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR27_U_CXRH_NID264",
        .addr = A_POR_MPU_M5_PRBAR27_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR27_U_CXRH_NID264",
        .addr = A_POR_MPU_M5_PRLAR27_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR28_U_CXRH_NID264",
        .addr = A_POR_MPU_M5_PRBAR28_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR28_U_CXRH_NID264",
        .addr = A_POR_MPU_M5_PRLAR28_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR29_U_CXRH_NID264",
        .addr = A_POR_MPU_M5_PRBAR29_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR29_U_CXRH_NID264",
        .addr = A_POR_MPU_M5_PRLAR29_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR30_U_CXRH_NID264",
        .addr = A_POR_MPU_M5_PRBAR30_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR30_U_CXRH_NID264",
        .addr = A_POR_MPU_M5_PRLAR30_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M5_PRBAR31_U_CXRH_NID264",
        .addr = A_POR_MPU_M5_PRBAR31_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M5_PRLAR31_U_CXRH_NID264",
        .addr = A_POR_MPU_M5_PRLAR31_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_CTL_U_CXRH_NID264",
        .addr = A_POR_MPU_M6_CTL_U_CXRH_NID264,
        .reset = 0x2,
        .rsvd = 0xfffffffffffffff8L,
        .ro = 0xfffffffffffffff8L,
    },{ .name = "POR_MPU_M6_PRBAR0_U_CXRH_NID264",
        .addr = A_POR_MPU_M6_PRBAR0_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR0_U_CXRH_NID264",
        .addr = A_POR_MPU_M6_PRLAR0_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR1_U_CXRH_NID264",
        .addr = A_POR_MPU_M6_PRBAR1_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR1_U_CXRH_NID264",
        .addr = A_POR_MPU_M6_PRLAR1_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR2_U_CXRH_NID264",
        .addr = A_POR_MPU_M6_PRBAR2_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR2_U_CXRH_NID264",
        .addr = A_POR_MPU_M6_PRLAR2_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR3_U_CXRH_NID264",
        .addr = A_POR_MPU_M6_PRBAR3_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR3_U_CXRH_NID264",
        .addr = A_POR_MPU_M6_PRLAR3_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR4_U_CXRH_NID264",
        .addr = A_POR_MPU_M6_PRBAR4_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR4_U_CXRH_NID264",
        .addr = A_POR_MPU_M6_PRLAR4_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR5_U_CXRH_NID264",
        .addr = A_POR_MPU_M6_PRBAR5_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR5_U_CXRH_NID264",
        .addr = A_POR_MPU_M6_PRLAR5_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR6_U_CXRH_NID264",
        .addr = A_POR_MPU_M6_PRBAR6_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR6_U_CXRH_NID264",
        .addr = A_POR_MPU_M6_PRLAR6_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR7_U_CXRH_NID264",
        .addr = A_POR_MPU_M6_PRBAR7_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR7_U_CXRH_NID264",
        .addr = A_POR_MPU_M6_PRLAR7_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR8_U_CXRH_NID264",
        .addr = A_POR_MPU_M6_PRBAR8_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR8_U_CXRH_NID264",
        .addr = A_POR_MPU_M6_PRLAR8_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR9_U_CXRH_NID264",
        .addr = A_POR_MPU_M6_PRBAR9_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR9_U_CXRH_NID264",
        .addr = A_POR_MPU_M6_PRLAR9_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR10_U_CXRH_NID264",
        .addr = A_POR_MPU_M6_PRBAR10_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR10_U_CXRH_NID264",
        .addr = A_POR_MPU_M6_PRLAR10_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR11_U_CXRH_NID264",
        .addr = A_POR_MPU_M6_PRBAR11_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR11_U_CXRH_NID264",
        .addr = A_POR_MPU_M6_PRLAR11_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR12_U_CXRH_NID264",
        .addr = A_POR_MPU_M6_PRBAR12_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR12_U_CXRH_NID264",
        .addr = A_POR_MPU_M6_PRLAR12_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR13_U_CXRH_NID264",
        .addr = A_POR_MPU_M6_PRBAR13_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR13_U_CXRH_NID264",
        .addr = A_POR_MPU_M6_PRLAR13_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR14_U_CXRH_NID264",
        .addr = A_POR_MPU_M6_PRBAR14_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR14_U_CXRH_NID264",
        .addr = A_POR_MPU_M6_PRLAR14_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR15_U_CXRH_NID264",
        .addr = A_POR_MPU_M6_PRBAR15_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR15_U_CXRH_NID264",
        .addr = A_POR_MPU_M6_PRLAR15_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR16_U_CXRH_NID264",
        .addr = A_POR_MPU_M6_PRBAR16_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR16_U_CXRH_NID264",
        .addr = A_POR_MPU_M6_PRLAR16_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR17_U_CXRH_NID264",
        .addr = A_POR_MPU_M6_PRBAR17_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR17_U_CXRH_NID264",
        .addr = A_POR_MPU_M6_PRLAR17_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR18_U_CXRH_NID264",
        .addr = A_POR_MPU_M6_PRBAR18_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR18_U_CXRH_NID264",
        .addr = A_POR_MPU_M6_PRLAR18_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR19_U_CXRH_NID264",
        .addr = A_POR_MPU_M6_PRBAR19_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR19_U_CXRH_NID264",
        .addr = A_POR_MPU_M6_PRLAR19_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR20_U_CXRH_NID264",
        .addr = A_POR_MPU_M6_PRBAR20_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR20_U_CXRH_NID264",
        .addr = A_POR_MPU_M6_PRLAR20_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR21_U_CXRH_NID264",
        .addr = A_POR_MPU_M6_PRBAR21_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR21_U_CXRH_NID264",
        .addr = A_POR_MPU_M6_PRLAR21_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR22_U_CXRH_NID264",
        .addr = A_POR_MPU_M6_PRBAR22_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR22_U_CXRH_NID264",
        .addr = A_POR_MPU_M6_PRLAR22_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR23_U_CXRH_NID264",
        .addr = A_POR_MPU_M6_PRBAR23_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR23_U_CXRH_NID264",
        .addr = A_POR_MPU_M6_PRLAR23_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR24_U_CXRH_NID264",
        .addr = A_POR_MPU_M6_PRBAR24_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR24_U_CXRH_NID264",
        .addr = A_POR_MPU_M6_PRLAR24_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR25_U_CXRH_NID264",
        .addr = A_POR_MPU_M6_PRBAR25_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR25_U_CXRH_NID264",
        .addr = A_POR_MPU_M6_PRLAR25_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR26_U_CXRH_NID264",
        .addr = A_POR_MPU_M6_PRBAR26_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR26_U_CXRH_NID264",
        .addr = A_POR_MPU_M6_PRLAR26_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR27_U_CXRH_NID264",
        .addr = A_POR_MPU_M6_PRBAR27_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR27_U_CXRH_NID264",
        .addr = A_POR_MPU_M6_PRLAR27_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR28_U_CXRH_NID264",
        .addr = A_POR_MPU_M6_PRBAR28_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR28_U_CXRH_NID264",
        .addr = A_POR_MPU_M6_PRLAR28_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR29_U_CXRH_NID264",
        .addr = A_POR_MPU_M6_PRBAR29_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR29_U_CXRH_NID264",
        .addr = A_POR_MPU_M6_PRLAR29_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR30_U_CXRH_NID264",
        .addr = A_POR_MPU_M6_PRBAR30_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR30_U_CXRH_NID264",
        .addr = A_POR_MPU_M6_PRLAR30_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M6_PRBAR31_U_CXRH_NID264",
        .addr = A_POR_MPU_M6_PRBAR31_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M6_PRLAR31_U_CXRH_NID264",
        .addr = A_POR_MPU_M6_PRLAR31_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_CTL_U_CXRH_NID264",
        .addr = A_POR_MPU_M7_CTL_U_CXRH_NID264,
        .reset = 0x2,
        .rsvd = 0xfffffffffffffff8L,
        .ro = 0xfffffffffffffff8L,
    },{ .name = "POR_MPU_M7_PRBAR0_U_CXRH_NID264",
        .addr = A_POR_MPU_M7_PRBAR0_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR0_U_CXRH_NID264",
        .addr = A_POR_MPU_M7_PRLAR0_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR1_U_CXRH_NID264",
        .addr = A_POR_MPU_M7_PRBAR1_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR1_U_CXRH_NID264",
        .addr = A_POR_MPU_M7_PRLAR1_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR2_U_CXRH_NID264",
        .addr = A_POR_MPU_M7_PRBAR2_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR2_U_CXRH_NID264",
        .addr = A_POR_MPU_M7_PRLAR2_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR3_U_CXRH_NID264",
        .addr = A_POR_MPU_M7_PRBAR3_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR3_U_CXRH_NID264",
        .addr = A_POR_MPU_M7_PRLAR3_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR4_U_CXRH_NID264",
        .addr = A_POR_MPU_M7_PRBAR4_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR4_U_CXRH_NID264",
        .addr = A_POR_MPU_M7_PRLAR4_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR5_U_CXRH_NID264",
        .addr = A_POR_MPU_M7_PRBAR5_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR5_U_CXRH_NID264",
        .addr = A_POR_MPU_M7_PRLAR5_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR6_U_CXRH_NID264",
        .addr = A_POR_MPU_M7_PRBAR6_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR6_U_CXRH_NID264",
        .addr = A_POR_MPU_M7_PRLAR6_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR7_U_CXRH_NID264",
        .addr = A_POR_MPU_M7_PRBAR7_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR7_U_CXRH_NID264",
        .addr = A_POR_MPU_M7_PRLAR7_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR8_U_CXRH_NID264",
        .addr = A_POR_MPU_M7_PRBAR8_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR8_U_CXRH_NID264",
        .addr = A_POR_MPU_M7_PRLAR8_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR9_U_CXRH_NID264",
        .addr = A_POR_MPU_M7_PRBAR9_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR9_U_CXRH_NID264",
        .addr = A_POR_MPU_M7_PRLAR9_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR10_U_CXRH_NID264",
        .addr = A_POR_MPU_M7_PRBAR10_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR10_U_CXRH_NID264",
        .addr = A_POR_MPU_M7_PRLAR10_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR11_U_CXRH_NID264",
        .addr = A_POR_MPU_M7_PRBAR11_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR11_U_CXRH_NID264",
        .addr = A_POR_MPU_M7_PRLAR11_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR12_U_CXRH_NID264",
        .addr = A_POR_MPU_M7_PRBAR12_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR12_U_CXRH_NID264",
        .addr = A_POR_MPU_M7_PRLAR12_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR13_U_CXRH_NID264",
        .addr = A_POR_MPU_M7_PRBAR13_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR13_U_CXRH_NID264",
        .addr = A_POR_MPU_M7_PRLAR13_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR14_U_CXRH_NID264",
        .addr = A_POR_MPU_M7_PRBAR14_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR14_U_CXRH_NID264",
        .addr = A_POR_MPU_M7_PRLAR14_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR15_U_CXRH_NID264",
        .addr = A_POR_MPU_M7_PRBAR15_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR15_U_CXRH_NID264",
        .addr = A_POR_MPU_M7_PRLAR15_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR16_U_CXRH_NID264",
        .addr = A_POR_MPU_M7_PRBAR16_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR16_U_CXRH_NID264",
        .addr = A_POR_MPU_M7_PRLAR16_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR17_U_CXRH_NID264",
        .addr = A_POR_MPU_M7_PRBAR17_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR17_U_CXRH_NID264",
        .addr = A_POR_MPU_M7_PRLAR17_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR18_U_CXRH_NID264",
        .addr = A_POR_MPU_M7_PRBAR18_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR18_U_CXRH_NID264",
        .addr = A_POR_MPU_M7_PRLAR18_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR19_U_CXRH_NID264",
        .addr = A_POR_MPU_M7_PRBAR19_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR19_U_CXRH_NID264",
        .addr = A_POR_MPU_M7_PRLAR19_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR20_U_CXRH_NID264",
        .addr = A_POR_MPU_M7_PRBAR20_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR20_U_CXRH_NID264",
        .addr = A_POR_MPU_M7_PRLAR20_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR21_U_CXRH_NID264",
        .addr = A_POR_MPU_M7_PRBAR21_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR21_U_CXRH_NID264",
        .addr = A_POR_MPU_M7_PRLAR21_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR22_U_CXRH_NID264",
        .addr = A_POR_MPU_M7_PRBAR22_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR22_U_CXRH_NID264",
        .addr = A_POR_MPU_M7_PRLAR22_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR23_U_CXRH_NID264",
        .addr = A_POR_MPU_M7_PRBAR23_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR23_U_CXRH_NID264",
        .addr = A_POR_MPU_M7_PRLAR23_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR24_U_CXRH_NID264",
        .addr = A_POR_MPU_M7_PRBAR24_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR24_U_CXRH_NID264",
        .addr = A_POR_MPU_M7_PRLAR24_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR25_U_CXRH_NID264",
        .addr = A_POR_MPU_M7_PRBAR25_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR25_U_CXRH_NID264",
        .addr = A_POR_MPU_M7_PRLAR25_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR26_U_CXRH_NID264",
        .addr = A_POR_MPU_M7_PRBAR26_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR26_U_CXRH_NID264",
        .addr = A_POR_MPU_M7_PRLAR26_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR27_U_CXRH_NID264",
        .addr = A_POR_MPU_M7_PRBAR27_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR27_U_CXRH_NID264",
        .addr = A_POR_MPU_M7_PRLAR27_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR28_U_CXRH_NID264",
        .addr = A_POR_MPU_M7_PRBAR28_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR28_U_CXRH_NID264",
        .addr = A_POR_MPU_M7_PRLAR28_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR29_U_CXRH_NID264",
        .addr = A_POR_MPU_M7_PRBAR29_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR29_U_CXRH_NID264",
        .addr = A_POR_MPU_M7_PRLAR29_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR30_U_CXRH_NID264",
        .addr = A_POR_MPU_M7_PRBAR30_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR30_U_CXRH_NID264",
        .addr = A_POR_MPU_M7_PRLAR30_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    },{ .name = "POR_MPU_M7_PRBAR31_U_CXRH_NID264",
        .addr = A_POR_MPU_M7_PRBAR31_U_CXRH_NID264,
        .rsvd = 0x1c0,
        .ro = 0xffff000000000dc3L,
    },{ .name = "POR_MPU_M7_PRLAR31_U_CXRH_NID264",
        .addr = A_POR_MPU_M7_PRLAR31_U_CXRH_NID264,
        .rsvd = 0xffe,
        .ro = 0xffff000000000ffeL,
    }
};

/*
 * Hashed and non-hashed regions cannot overlap with a region of the same type.
 * Warn the user if a see a region overlap with a region of the same type.
 */
static void cmn_sam_region_overlap_check(CMN600AE *s, const sam_mr *mr,
                                         size_t num_mr, uint32_t sam_base)
{
    uint64_t mr_min;
    uint64_t mr_max;
    uint64_t mr2_min;
    uint64_t mr2_max;
    uint64_t base;
    uint64_t base2;
    const sam_mr *mr2;
    size_t i, j;

    for (i = 0; i < num_mr; ++i) {
        if (!mr->valid) {
            continue;
        }

        base = mr->base ? mr->base : 1;
        mr_min = mr->base << mr->base_shift;
        mr_max = ((base << mr->base_shift) << mr->size) - 1;
        for (j = i + 1; j < num_mr; ++j) {
            mr2 = &mr[j];
            if (!mr2->valid) {
                continue;
            }

            base2 = mr2->base ? mr2->base : 1;
            mr2_min = mr2->base << mr2->base_shift;
            mr2_max = ((base2 << mr2->base_shift) << mr2->size) - 1;

            if (((mr_min <= mr2_min) && (mr_max > mr2_min)) ||
                ((mr_min > mr2_min) && (mr_min < mr2_max))) {
                qemu_log_mask(LOG_GUEST_ERROR,
                              "%s SAM base 0x%" PRIx32 ": region range "
                              "0x%" PRIx64 "->0x%" PRIx64
                              " overlaps with region range 0x%" PRIx64
                              "->0x%" PRIx64 ".\n",
                              object_get_canonical_path(OBJECT(s)), sam_base,
                              mr_min, mr_max, mr2_min, mr2_max);
            }
        }
    }
}

static void cmn_sam_limit_check(CMN600AE *s, const sam_mr *mr, size_t num_mr,
                                uint32_t sam_base)
{
    size_t i;
    uint64_t base;

    for (i = 0; i < num_mr; ++i) {
        if (mr[i].valid) {
            continue;
        }

        base = mr[i].base ? mr[i].base : 1;
        base <<= mr[i].base_shift;
        /*
         * The CMN size field bit width prevents this shift from potentially
         * overflowing.
         */
        if ((base  << mr[i].size) > mr[i].limit) {
            qemu_log_mask(LOG_GUEST_ERROR, "%s SAM base 0x%" PRIx32
                          ": Address range 0x%" PRIx64 "->0x%" PRIx64
                          " is out of range of limit of 0x%" PRIx64 "\n",
                          object_get_canonical_path(OBJECT(s)), sam_base, base,
                          base << mr[i].size, mr[i].limit);
        }
    }
}

static MemTxResult cmn_read_common(CMN600AE *s, hwaddr addr, uint64_t *value,
                                   unsigned size, MemTxAttrs attr)
{
    bool aligned = true;

    /*
     * Our registers are 64-bit aligned, but the CMN allows for 32-bit accesses.
     * To deal with this, we'll align the access and remove extra bits.
     */
    if (addr & 0x4 && size == 4) {
        aligned = false;
        addr &= ~0x4;
        size += 4;
    }

    *value = register_read_memory(s->reg_array, addr, size);

    if (!aligned) {
        *value >>= 32;
    }

    return MEMTX_OK;
}

static MemTxResult cmn_write_common(CMN600AE *s, hwaddr addr, uint64_t value,
                                    unsigned size, MemTxAttrs attr)
{
    union {
        uint64_t v;
        uint32_t v32[2];
    } val64;

    /*
     * Our registers are 64-bit aligned, but the CMN allows for 32-bit accesses.
     * To deal with this, we'll align the access and ensure the lower 32-bits
     * are unchanged.
     */
    if (addr & 0x4 && size == 4) {
        addr &= ~0x4;
        size += 4;
        val64.v32[1] = value;
        val64.v32[0] = register_read_memory(s->reg_array, addr, 4);
    } else {
        val64.v = value;
    }

    register_write_memory(s->reg_array, addr, val64.v, size);
    return MEMTX_OK;
}

static bool cmn_rn_sam_non_sec_okay(CMNRNSAMNode *rn_sam, hwaddr addr)
{
    bool mem_range;
    CMN600AE *s = rn_sam->parent;
    uint32_t offset =
      CMN_RN_SAM_OFFSET(A_POR_RNSAM_SECURE_REGISTER_GROUPS_OVERRIDE_U_RNI_NID4);

    /* 64-bit align the access to make comparisons easier */
    addr &= ~0x7;
    addr += rn_sam->base;

    mem_range = s->regs[(rn_sam->base + offset) / 8] &
          R_POR_RNSAM_SECURE_REGISTER_GROUPS_OVERRIDE_U_RNI_NID4_MEM_RANGE_MASK;

    if (addr == R_POR_RNSAM_SECURE_REGISTER_GROUPS_OVERRIDE_U_RNI_NID4 ||
        addr == A_RNSAM_STATUS_U_RNI_NID4 ||
        (addr >= A_SYS_CACHE_GRP_HN_NODEID_REG0_U_RNI_NID4 &&
         addr <= A_SYS_CACHE_GRP_SN_SAM_CFG1_U_RNI_NID4) ||
        (addr >= A_SYS_CACHE_GRP_SN_ATTR_U_RNI_NID4 &&
         addr <= A_CML_PORT_AGGR_GRP1_REG_U_RNI_NID4) ||
        (addr >= A_RNSAM_HASH_ADDR_MASK_REG_U_RNI_NID4 &&
         addr <= A_SYS_CACHE_GRP_SN_NODEID_REG15_U_RNI_NID4)) {
        return false;
    } else if ((addr >= A_NON_HASH_MEM_REGION_REG0_U_RNI_NID4 &&
                addr <= A_NON_HASH_MEM_REGION_REG3_U_RNI_NID4) ||
               (addr >= A_SYS_CACHE_GRP_REGION0_U_RNI_NID4 &&
                addr <= A_SYS_CACHE_GRP_REGION1_U_RNI_NID4) ||
               addr == A_GIC_MEM_REGION_REG_U_RNI_NID4 ||
               (addr >= A_SYS_CACHE_GRP_SECONDARY_REG0_U_RNI_NID4 &&
                addr <= A_SYS_CACHE_GRP_CAL_MODE_REG_U_RNI_NID4)) {
        return mem_range;
    } else {
        return true;
    }
}

static void cmn_rn_sam_region_check(CMNRNSAMNode *rn_sam)
{
    cmn_sam_region_overlap_check(rn_sam->parent, rn_sam->non_hash_regions,
                                 ARRAY_SIZE(rn_sam->non_hash_regions),
                                 rn_sam->base);
    cmn_sam_region_overlap_check(rn_sam->parent, rn_sam->cache_grps,
                                 ARRAY_SIZE(rn_sam->cache_grps), rn_sam->base);
    cmn_sam_region_overlap_check(rn_sam->parent, rn_sam->cache_grp_scndry,
                                 ARRAY_SIZE(rn_sam->cache_grp_scndry),
                                 rn_sam->base);

    cmn_sam_limit_check(rn_sam->parent, rn_sam->non_hash_regions,
                        ARRAY_SIZE(rn_sam->non_hash_regions), rn_sam->base);
    cmn_sam_limit_check(rn_sam->parent, rn_sam->cache_grps,
                        ARRAY_SIZE(rn_sam->cache_grps), rn_sam->base);
    cmn_sam_limit_check(rn_sam->parent, rn_sam->cache_grp_scndry,
                        ARRAY_SIZE(rn_sam->cache_grp_scndry), rn_sam->base);
}

static void cmn_rn_sam_non_hash_region_update(sam_mr *mr, uint32_t reg)
{
    mr->size = FIELD_EX32(reg, NON_HASH_MEM_REGION_REG0_U_RNI_NID4,
                          REGION0_SIZE);
    mr->base = FIELD_EX32(reg, NON_HASH_MEM_REGION_REG0_U_RNI_NID4,
                          REGION0_BASE_ADDR);
    mr->valid = FIELD_EX32(reg, NON_HASH_MEM_REGION_REG0_U_RNI_NID4,
                           REGION0_VALID);
}

static void cmn_rn_sam_sys_cache_region_update(sam_mr *mr, uint32_t reg)
{
    mr->size = FIELD_EX32(reg, SYS_CACHE_GRP_REGION0_U_RNI_NID4,
                          REGION0_SIZE);
    mr->base = FIELD_EX32(reg, SYS_CACHE_GRP_REGION0_U_RNI_NID4,
                          REGION0_BASE_ADDR);
    mr->valid = FIELD_EX32(reg, SYS_CACHE_GRP_REGION0_U_RNI_NID4,
                           REGION0_VALID);
}

static void cmn_rn_sam_sys_cache_scndry_region_update(sam_mr *mr, uint32_t reg)
{
    mr->size = FIELD_EX32(reg, SYS_CACHE_GRP_SECONDARY_REG0_U_RNI_NID4,
                          REGION0_SCNDRY_SIZE);
    mr->base = FIELD_EX32(reg, SYS_CACHE_GRP_SECONDARY_REG0_U_RNI_NID4,
                          REGION0_SCNDRY_BASE_ADDR);
    mr->valid = FIELD_EX32(reg, SYS_CACHE_GRP_SECONDARY_REG0_U_RNI_NID4,
                           REGION0_SCNDRY_VALID);
}

static void cmn_rn_sam_region_update(CMNRNSAMNode *rn_sam)
{
    size_t i;
    uint64_t reg;
    CMN600AE *s = rn_sam->parent;
    const uint32_t non_hash_region_offsets[] = {
        CMN_RN_SAM_OFFSET(A_NON_HASH_MEM_REGION_REG0_U_RNI_NID4),
        CMN_RN_SAM_OFFSET(A_NON_HASH_MEM_REGION_REG1_U_RNI_NID4),
        CMN_RN_SAM_OFFSET(A_NON_HASH_MEM_REGION_REG2_U_RNI_NID4),
        CMN_RN_SAM_OFFSET(A_NON_HASH_MEM_REGION_REG3_U_RNI_NID4)
    };
    const uint32_t cache_grp_region_offsets[] = {
        CMN_RN_SAM_OFFSET(A_SYS_CACHE_GRP_REGION0_U_RNI_NID4),
        CMN_RN_SAM_OFFSET(A_SYS_CACHE_GRP_REGION1_U_RNI_NID4)
    };
    const uint32_t cache_grp_scndry_region_offsets[] = {
        CMN_RN_SAM_OFFSET(A_SYS_CACHE_GRP_SECONDARY_REG0_U_RNI_NID4),
        CMN_RN_SAM_OFFSET(A_SYS_CACHE_GRP_SECONDARY_REG1_U_RNI_NID4)
    };
    const uint32_t gic_region_offsets[] = {
        CMN_RN_SAM_OFFSET(A_GIC_MEM_REGION_REG_U_RNI_NID4)
    };

    for (i = 0; i < ARRAY_SIZE(non_hash_region_offsets); i++) {
        reg = s->regs[(rn_sam->base + non_hash_region_offsets[i]) / 8];
        cmn_rn_sam_non_hash_region_update(&rn_sam->non_hash_regions[(i * 2)],
                                          reg & 0xffffffff);
        cmn_rn_sam_non_hash_region_update(&rn_sam->non_hash_regions[(i * 2) + 1],
                                          reg >> 32);
    }

    for (i = 0; i < ARRAY_SIZE(cache_grp_region_offsets); i++) {
        reg = s->regs[(rn_sam->base + cache_grp_region_offsets[i]) / 8];
        cmn_rn_sam_sys_cache_region_update(&rn_sam->cache_grps[(i * 2)],
                                           reg & 0xffffffff);
        cmn_rn_sam_sys_cache_region_update(&rn_sam->cache_grps[(i * 2) + 1],
                                           reg >> 32);
    }

    for (i = 0; i < ARRAY_SIZE(cache_grp_scndry_region_offsets); i++) {
        reg = s->regs[(rn_sam->base + cache_grp_scndry_region_offsets[i]) / 8];
        cmn_rn_sam_sys_cache_scndry_region_update(&rn_sam->cache_grp_scndry[(i * 2)],
                                                  reg & 0xffffffff);
        cmn_rn_sam_sys_cache_scndry_region_update(&rn_sam->cache_grp_scndry[(i * 2) + 1],
                                                  reg >> 32);
    }

    reg = s->regs[(rn_sam->base + gic_region_offsets[0]) / 8];
    rn_sam->gic_region.size = FIELD_EX64(reg, GIC_MEM_REGION_REG_U_RNI_NID4,
                                         GIC_REGION_SIZE);
    rn_sam->gic_region.base = FIELD_EX64(reg, GIC_MEM_REGION_REG_U_RNI_NID4,
                                         GIC_REGION_BASE_ADDR);
    rn_sam->gic_region.valid = FIELD_EX64(reg, GIC_MEM_REGION_REG_U_RNI_NID4,
                                         GIC_REGION_VALID);
}

static MemTxResult cmn_rn_sam_read(void *opaque, hwaddr addr, uint64_t *value,
                                  unsigned size, MemTxAttrs attr)
{
    CMNRNSAMNode *rn_sam = opaque;
    bool non_sec_okay = cmn_rn_sam_non_sec_okay(rn_sam, addr);

    if (!non_sec_okay && !attr.secure) {
        return MEMTX_ERROR;
    }

    addr += rn_sam->base;
    return cmn_read_common(rn_sam->parent, addr, value, size, attr);
}

static MemTxResult cmn_rn_sam_write(void *opaque, hwaddr addr, uint64_t value,
                                   unsigned size, MemTxAttrs attr)
{
    MemTxResult res;
    CMNRNSAMNode *rn_sam = opaque;
    bool non_sec_okay = cmn_rn_sam_non_sec_okay(rn_sam, addr);

    if (!non_sec_okay && !attr.secure) {
        return MEMTX_ERROR;
    }

    addr += rn_sam->base;
    res = cmn_write_common(rn_sam->parent, addr, value, size, attr);

    cmn_rn_sam_region_update(rn_sam);
    cmn_rn_sam_region_check(rn_sam);

    return res;
}

static const MemoryRegionOps cmn_rn_sam_ops = {
    .read_with_attrs = cmn_rn_sam_read,
    .write_with_attrs = cmn_rn_sam_write,
    .endianness = DEVICE_LITTLE_ENDIAN,
    .valid = {
        .min_access_size = 4,
        .max_access_size = 8,
    },
    .impl = {
        .min_access_size = 4,
        .max_access_size = 8,
    },
};

static void cmn_rn_sam_region_init(CMNRNSAMNode *rn_sam)
{
    size_t i;

    for (i = 0; i < ARRAY_SIZE(rn_sam->non_hash_regions); i++) {
        rn_sam->non_hash_regions[i].limit = 1ull << ADDRESS_WIDTH;
        rn_sam->non_hash_regions[i].base_shift = 26;
    }
    for (i = 0; i < ARRAY_SIZE(rn_sam->cache_grps); i++) {
        rn_sam->cache_grps[i].limit = 1ull << ADDRESS_WIDTH;
        rn_sam->cache_grps[i].base_shift = 26;
    }
    for (i = 0; i < ARRAY_SIZE(rn_sam->cache_grp_scndry); i++) {
        rn_sam->cache_grp_scndry[i].limit = 1ull << ADDRESS_WIDTH;
        rn_sam->cache_grp_scndry[i].base_shift = 26;
    }
    rn_sam->gic_region.limit = 1ull << ADDRESS_WIDTH;
    rn_sam->gic_region.base_shift = 16;
}

static void cmn_rn_sam_init(CMN600AE *s)
{
    size_t i;
    const uint32_t rn_sam_bases[] = {
        A_POR_RNSAM_NODE_INFO_U_RNI_NID4,
        A_POR_RNSAM_NODE_INFO_U_RNFBESAM_NID12,
        A_POR_RNSAM_NODE_INFO_U_RND_NID68,
        A_POR_RNSAM_NODE_INFO_U_RNFBESAM_NID76,
        A_POR_RNSAM_NODE_INFO_U_RNI_NID132,
        A_POR_RNSAM_NODE_INFO_U_RNFBESAM_NID140,
        A_POR_RNSAM_NODE_INFO_U_RNFBESAM_NID204,
        A_POR_RNSAM_NODE_INFO_U_RNI_NID260,
        A_POR_RNSAM_NODE_INFO_U_CXRH_NID264,
        A_POR_RNSAM_NODE_INFO_U_RNFBESAM_NID268
    };
    const char *names[] = {
        "rn-sam-rni-nid4",
        "rn-sam-rnfbesam-nid12",
        "rn-sam-rnd-nid68",
        "rn-sam-rnfbesam-nid76",
        "rn-sam-rni-nid132",
        "rn-sam-rnfbesam-nid140",
        "rn-sam-rnfbesam-nid204",
        "rn-sam-rni-nid260",
        "rn-sam-cxrh-nid264",
        "rn-sam-rnfbesam-nid268"
    };

    assert(ARRAY_SIZE(rn_sam_bases) == ARRAY_SIZE(names));
    assert(ARRAY_SIZE(s->rn_sam_nodes) == ARRAY_SIZE(rn_sam_bases));

    for (i = 0; i < ARRAY_SIZE(s->rn_sam_nodes); i++) {
        s->rn_sam_nodes[i].base = rn_sam_bases[i];
        s->rn_sam_nodes[i].parent = s;

        memory_region_init_io(&s->rn_sam_nodes[i].iomem, OBJECT(s),
                              &cmn_rn_sam_ops, &s->rn_sam_nodes[i], names[i],
                              CMN_NODE_SIZE);
        memory_region_add_subregion_overlap(&s->iomem, s->rn_sam_nodes[i].base,
                                            &s->rn_sam_nodes[i].iomem, 1);
        sysbus_init_mmio(SYS_BUS_DEVICE(s), &s->rn_sam_nodes[i].iomem);

        cmn_rn_sam_region_init(&s->rn_sam_nodes[i]);
    }
}

static void cmn_hni_sam_region_check(CMNHNISAMNode *hni_sam)
{
    cmn_sam_region_overlap_check(hni_sam->parent, hni_sam->regions,
                                 ARRAY_SIZE(hni_sam->regions), hni_sam->base);

    cmn_sam_limit_check(hni_sam->parent, hni_sam->regions,
                        ARRAY_SIZE(hni_sam->regions), hni_sam->base);
}

static void cmn_hni_sam_region_update(CMNHNISAMNode *hni_sam)
{
    size_t i;
    uint64_t reg;
    CMN600AE *s = hni_sam->parent;
    const uint32_t region_offsets[] = {
        CMN_HNI_SAM_OFFSET(A_POR_HNI_SAM_ADDRREGION0_CFG_U_HNI_NID196),
        CMN_HNI_SAM_OFFSET(A_POR_HNI_SAM_ADDRREGION1_CFG_U_HNI_NID196),
        CMN_HNI_SAM_OFFSET(A_POR_HNI_SAM_ADDRREGION2_CFG_U_HNI_NID196)
    };

    for (i = 0; i < ARRAY_SIZE(region_offsets); i++) {
        reg = s->regs[(hni_sam->base + region_offsets[i]) / 8];
        hni_sam->regions[i].size = FIELD_EX64(reg,
                                   POR_HNI_SAM_ADDRREGION1_CFG_U_HNI_NID196,
                                   ADDR_REGION_SIZE);
        hni_sam->regions[i].base = FIELD_EX64(reg,
                                   POR_HNI_SAM_ADDRREGION1_CFG_U_HNI_NID196,
                                   BASE_ADDR);
        hni_sam->regions[i].valid = FIELD_EX64(reg,
                                    POR_HNI_SAM_ADDRREGION1_CFG_U_HNI_NID196,
                                    VALID);
    }
}

static void cmn_hni_sam_region_init(CMNHNISAMNode *hni_sam)
{
    size_t i;

    for (i = 0; i < ARRAY_SIZE(hni_sam->regions); i++) {
        hni_sam->regions[i].limit = 1ull << ADDRESS_WIDTH;
        hni_sam->regions[i].base_shift = 12;
    }
}

static bool cmn_hni_sam_non_sec_okay(CMNHNISAMNode *hni_sam, hwaddr addr)
{
    bool sam;
    bool cfg_ctl;
    uint32_t offset;
    uint64_t reg;
    CMN600AE *s = hni_sam->parent;

    /* 64-bit align the access to make comparisons easier */
    addr &= ~0x7;
    addr += hni_sam->base;

    offset =
     CMN_HNI_SAM_OFFSET(A_POR_HNI_SECURE_REGISTER_GROUPS_OVERRIDE_U_HNI_NID196);
    reg = s->regs[(hni_sam->base + offset) / 8];

    sam = FIELD_EX64(reg, POR_HNI_SECURE_REGISTER_GROUPS_OVERRIDE_U_HNI_NID196,
                     SAM);
    cfg_ctl = FIELD_EX64(reg,
                         POR_HNI_SECURE_REGISTER_GROUPS_OVERRIDE_U_HNI_NID196,
                         CFG_CTL);

    if (addr == A_POR_HNI_SECURE_REGISTER_GROUPS_OVERRIDE_U_HNI_NID196 ||
        addr == A_POR_HNI_AUX_CTL_U_HNI_NID196 ||
        (addr >= A_POR_HNI_ERRFR_U_HNI_NID196 &&
         addr <= A_POR_HNI_ERRMISC_NS_U_HNI_NID196)) {
        return false;
    } else if (addr == A_POR_HNI_CFG_CTL_U_HNI_NID196) {
        return cfg_ctl;
    } else if (addr >= A_POR_HNI_SAM_ADDRREGION0_CFG_U_HNI_NID196 &&
                addr <= A_POR_HNI_SAM_ADDRREGION3_CFG_U_HNI_NID196) {
        return sam;
    } else {
        return true;
    }
}

static MemTxResult cmn_hni_sam_read(void *opaque, hwaddr addr, uint64_t *value,
                                  unsigned size, MemTxAttrs attr)
{
    MemTxResult res;
    CMNHNISAMNode *hni_sam = opaque;
    bool non_sec_okay = cmn_hni_sam_non_sec_okay(hni_sam, addr);

    if (!non_sec_okay && !attr.secure) {
        return MEMTX_ERROR;
    }

    addr += hni_sam->base;
    res = cmn_read_common(hni_sam->parent, addr, value, size, attr);

    return res;
}

static MemTxResult cmn_hni_sam_write(void *opaque, hwaddr addr, uint64_t value,
                                     unsigned size, MemTxAttrs attr)
{
    MemTxResult res;
    CMNHNISAMNode *hni_sam = opaque;
    bool non_sec_okay = cmn_hni_sam_non_sec_okay(hni_sam, addr);

    if (!non_sec_okay && !attr.secure) {
        return MEMTX_ERROR;
    }

    addr += hni_sam->base;
    res = cmn_write_common(hni_sam->parent, addr, value, size, attr);
    if (res != MEMTX_OK) {
        return res;
    }

    cmn_hni_sam_region_update(hni_sam);
    cmn_hni_sam_region_check(hni_sam);

    return res;
}

static const MemoryRegionOps cmn_hni_sam_ops = {
    .read_with_attrs = cmn_hni_sam_read,
    .write_with_attrs = cmn_hni_sam_write,
    .endianness = DEVICE_LITTLE_ENDIAN,
    .valid = {
        .min_access_size = 4,
        .max_access_size = 8,
    },
    .impl = {
        .min_access_size = 4,
        .max_access_size = 8,
    },
};

static void cmn_hni_sam_init(CMN600AE *s)
{
    size_t i;
    const uint32_t hni_sam_bases[] = {
        A_POR_HNI_NODE_INFO_U_HNI_NID196,
        A_POR_HNI_NODE_INFO_U_HND_NID256
    };
    const char *names[] = {
        "hni-sam-nid196",
        "hni-sam-nid256"
    };

    assert(ARRAY_SIZE(hni_sam_bases) == ARRAY_SIZE(names));
    assert(ARRAY_SIZE(s->hni_sam_nodes) == ARRAY_SIZE(hni_sam_bases));

    for (i = 0; i < ARRAY_SIZE(s->hni_sam_nodes); i++) {
        s->hni_sam_nodes[i].base = hni_sam_bases[i];
        s->hni_sam_nodes[i].parent = s;

        memory_region_init_io(&s->hni_sam_nodes[i].iomem, OBJECT(s),
                              &cmn_hni_sam_ops, &s->hni_sam_nodes[i], names[i],
                              CMN_NODE_SIZE);
        memory_region_add_subregion_overlap(&s->iomem, s->hni_sam_nodes[i].base,
                                            &s->hni_sam_nodes[i].iomem, 1);
        sysbus_init_mmio(SYS_BUS_DEVICE(s), &s->hni_sam_nodes[i].iomem);

        cmn_hni_sam_region_init(&s->hni_sam_nodes[i]);
    }
}

static void cmn_hnf_sam_region_check(CMNHNFSAMNode *hnf_sam)
{
    cmn_sam_region_overlap_check(hnf_sam->parent, hnf_sam->regions,
                                 ARRAY_SIZE(hnf_sam->regions), hnf_sam->base);
    cmn_sam_limit_check(hnf_sam->parent, hnf_sam->regions,
                        ARRAY_SIZE(hnf_sam->regions), hnf_sam->base);
}

static void cmn_hnf_sam_region_update(CMNHNFSAMNode *hnf_sam)
{
    size_t i;
    uint64_t reg;
    CMN600AE *s = hnf_sam->parent;
    const uint32_t region_offsets[] = {
       CMN_HNF_SAM_OFFSET(A_POR_HNF_SAM_MEMREGION0_U_HNF_NID8),
       CMN_HNF_SAM_OFFSET(A_POR_HNF_SAM_MEMREGION0_U_HNF_NID8)
    };

    for (i = 0; i < ARRAY_SIZE(region_offsets); i++) {
        reg = s->regs[(hnf_sam->base + region_offsets[i]) / 8];
        hnf_sam->regions[i].size = FIELD_EX64(reg,
                                              POR_HNF_SAM_MEMREGION0_U_HNF_NID8,
                                              SIZE);
        hnf_sam->regions[i].base = FIELD_EX64(reg,
                                              POR_HNF_SAM_MEMREGION0_U_HNF_NID8,
                                              BASE_ADDR);
        hnf_sam->regions[i].valid = FIELD_EX64(reg,
                                              POR_HNF_SAM_MEMREGION0_U_HNF_NID8,
                                              VALID);
    }
}

static void cmn_hnf_sam_region_init(CMNHNFSAMNode *hnf_sam)
{
    size_t i;

    for (i = 0; i < ARRAY_SIZE(hnf_sam->regions); i++) {
        hnf_sam->regions[i].limit = 1ull << ADDRESS_WIDTH;
        hnf_sam->regions[i].base_shift = 26;
    }
}

static bool cmn_hnf_sam_non_sec_okay(CMNHNFSAMNode *hnf_sam, hwaddr addr)
{
    bool sam_ctl;
    bool slc_lock_ways;
    bool ppu;
    bool cfg_ctl;
    bool qos;
    bool dbgrd;
    uint32_t offset;
    uint64_t reg;
    CMN600AE *s = hnf_sam->parent;

    /* 64-bit align the access to make comparisons easier */
    addr &= ~0x7;
    addr += hnf_sam->base;
    offset =
       CMN_HNF_SAM_OFFSET(A_POR_HNF_SECURE_REGISTER_GROUPS_OVERRIDE_U_HNF_NID8);
    reg = s->regs[(hnf_sam->base + offset) / 8];

    dbgrd = FIELD_EX64(reg, POR_HNF_SECURE_REGISTER_GROUPS_OVERRIDE_U_HNF_NID8,
                       SLCSF_DBGRD);
    sam_ctl = FIELD_EX64(reg,
                         POR_HNF_SECURE_REGISTER_GROUPS_OVERRIDE_U_HNF_NID8,
                         SAM_CONTROL);
    slc_lock_ways = FIELD_EX64(reg,
                             POR_HNF_SECURE_REGISTER_GROUPS_OVERRIDE_U_HNF_NID8,
                             SLC_LOCK_WAYS);
    ppu = FIELD_EX64(reg, POR_HNF_SECURE_REGISTER_GROUPS_OVERRIDE_U_HNF_NID8,
                     PPU);
    cfg_ctl = FIELD_EX64(reg,
                         POR_HNF_SECURE_REGISTER_GROUPS_OVERRIDE_U_HNF_NID8,
                         CFG_CTL);
    qos = FIELD_EX64(reg, POR_HNF_SECURE_REGISTER_GROUPS_OVERRIDE_U_HNF_NID8,
                     QOS);

    if (addr >= A_POR_HNF_CFG_SLCSF_DBGRD_U_HNF_NID8 &&
        addr <= A_POR_HNF_SLC_CACHE_ACCESS_SF_TAG2_U_HNF_NID8) {
        return dbgrd;
    } else if ((addr >= A_POR_HNF_SAM_CONTROL_U_HNF_NID8 &&
              addr <= A_HN_SAM_REGION_CMP_ADDR_MASK_REG_U_HNF_NID8) ||
             (addr >= A_POR_HNF_RN_PHYS_ID59_U_HNF_NID8 &&
              addr <= A_POR_HNF_LDID_MAP_TABLE_REG3_U_HNF_NID8)) {
        return sam_ctl;
    } else if ((addr >= A_POR_HNF_PPU_PWPR_U_HNF_NID8 &&
                addr <= A_POR_HNF_PMU_EVENT_SEL_U_HNF_NID8) ||
                addr == A_POR_HNF_ABF_PR_U_HNF_NID8) {
        return ppu;
    } else if (addr >= A_POR_HNF_SLCWAY_PARTITION0_RNF_VEC_U_HNF_NID8 &&
               addr <= A_POR_HNF_SLCWAY_PARTITION3_RNF_VEC1_U_HNF_NID8) {
        return slc_lock_ways;
    } else if (addr >= A_POR_HNF_QOS_BAND_U_HNF_NID8 &&
               addr <= A_POR_HNF_RN_STARVATION_U_HNF_NID8) {
        return qos;
    } else if (addr == A_POR_HNF_CFG_CTL_U_HNF_NID8) {
        return cfg_ctl;
    } else if (addr == A_RDF_HNF_AUX_CTL_U_HNF_NID8 ||
               addr == A_POR_HNF_SECURE_REGISTER_GROUPS_OVERRIDE_U_HNF_NID8 ||
               (addr >= A_POR_HNF_ERRFR_U_HNF_NID8 &&
                addr <= A_POR_HNF_ERR_INJ_U_HNF_NID8)) {
        return false;
    } else {
        return true;
    }
}

static MemTxResult cmn_hnf_sam_read(void *opaque, hwaddr addr, uint64_t *value,
                                    unsigned size, MemTxAttrs attr)
{
    MemTxResult res;
    CMNHNFSAMNode *hnf_sam = opaque;
    bool non_sec_okay = cmn_hnf_sam_non_sec_okay(hnf_sam, addr);

    if (!non_sec_okay && !attr.secure) {
        return MEMTX_ERROR;
    }

    addr += hnf_sam->base;
    res = cmn_read_common(hnf_sam->parent, addr, value, size, attr);

    return res;
}

static MemTxResult cmn_hnf_sam_write(void *opaque, hwaddr addr, uint64_t value,
                                     unsigned size, MemTxAttrs attr)
{
    MemTxResult res;
    CMNHNFSAMNode *hnf_sam = opaque;
    bool non_sec_okay = cmn_hnf_sam_non_sec_okay(hnf_sam, addr);

    if (!non_sec_okay && !attr.secure) {
        return MEMTX_ERROR;
    }

    addr += hnf_sam->base;
    res = cmn_write_common(hnf_sam->parent, addr, value, size, attr);
    if (res != MEMTX_OK) {
        return res;
    }

    cmn_hnf_sam_region_update(hnf_sam);
    cmn_hnf_sam_region_check(hnf_sam);

    return res;
}

static const MemoryRegionOps cmn_hnf_sam_ops = {
    .read_with_attrs = cmn_hnf_sam_read,
    .write_with_attrs = cmn_hnf_sam_write,
    .endianness = DEVICE_LITTLE_ENDIAN,
    .valid = {
        .min_access_size = 4,
        .max_access_size = 8,
    },
    .impl = {
        .min_access_size = 4,
        .max_access_size = 8,
    },
};

static void cmn_hnf_sam_init(CMN600AE *s)
{
    size_t i;
    const uint32_t hnf_sam_bases[] = {
        A_POR_HNF_NODE_INFO_U_HNF_NID8,
        A_POR_HNF_NODE_INFO_U_HNF_NID72,
        A_POR_HNF_NODE_INFO_U_HNF_NID136,
        A_POR_HNF_NODE_INFO_U_HNF_NID200
    };
    const char *names[] = {
        "hnf-sam-nid8",
        "hnf-sam-nid72",
        "hnf-sam-nid136",
        "hnf-sam-nid200"
    };

    assert(ARRAY_SIZE(hnf_sam_bases) == ARRAY_SIZE(names));
    assert(ARRAY_SIZE(s->hnf_sam_nodes) == ARRAY_SIZE(hnf_sam_bases));

    for (i = 0; i < ARRAY_SIZE(s->hnf_sam_nodes); ++i) {
        s->hnf_sam_nodes[i].base = hnf_sam_bases[i];
        s->hnf_sam_nodes[i].parent = s;

        memory_region_init_io(&s->hnf_sam_nodes[i].iomem, OBJECT(s),
                              &cmn_hnf_sam_ops, &s->hnf_sam_nodes[i], names[i],
                              CMN_NODE_SIZE);
        memory_region_add_subregion_overlap(&s->iomem, s->hnf_sam_nodes[i].base,
                                            &s->hnf_sam_nodes[i].iomem, 1);
        sysbus_init_mmio(SYS_BUS_DEVICE(s), &s->hnf_sam_nodes[i].iomem);

        cmn_hnf_sam_region_init(&s->hnf_sam_nodes[i]);
    }
}

static void cmn_reset_enter(Object *obj, ResetType type)
{
    CMN600AE *s = ARM_CMN(obj);
    unsigned int i;

    for (i = 0; i < ARRAY_SIZE(s->regs_info); ++i) {
        register_reset(&s->regs_info[i]);
    }
}

static const MemoryRegionOps cmn_ops = {
    .read = register_read_memory,
    .write = register_write_memory,
    .endianness = DEVICE_LITTLE_ENDIAN,
    .valid = {
        .min_access_size = 4,
        .max_access_size = 8,
    },
    .impl = {
        .min_access_size = 4,
        .max_access_size = 8,
    },
};

static void cmn_init(Object *obj)
{
    CMN600AE *s = ARM_CMN(obj);
    SysBusDevice *sbd = SYS_BUS_DEVICE(obj);

    memory_region_init(&s->iomem, obj, TYPE_ARM_CMN, CMN_R_MAX * 8);
    s->reg_array =
        register_init_block64(DEVICE(obj), cmn_regs_info,
                              ARRAY_SIZE(cmn_regs_info),
                              s->regs_info, s->regs,
                              &cmn_ops,
                              ARM_CMN_ERR_DEBUG,
                              CMN_R_MAX * 8);
    memory_region_add_subregion(&s->iomem,
                                0x0,
                                &s->reg_array->mem);
    sysbus_init_mmio(sbd, &s->iomem);

    cmn_rn_sam_init(s);
    cmn_hni_sam_init(s);
    cmn_hnf_sam_init(s);
}

static const VMStateDescription vmstate_cmn = {
    .name = TYPE_ARM_CMN,
    .version_id = 1,
    .minimum_version_id = 1,
    .fields = (VMStateField[]) {
        VMSTATE_UINT64_ARRAY(regs, CMN600AE, CMN_R_MAX),
        VMSTATE_END_OF_LIST(),
    }
};

static void cmn_class_init(ObjectClass *klass, void *data)
{
    ResettableClass *rc = RESETTABLE_CLASS(klass);
    DeviceClass *dc = DEVICE_CLASS(klass);

    dc->vmsd = &vmstate_cmn;
    rc->phases.enter = cmn_reset_enter;
}

static const TypeInfo cmn_info = {
    .name          = TYPE_ARM_CMN,
    .parent        = TYPE_SYS_BUS_DEVICE,
    .instance_size = sizeof(CMN600AE),
    .class_init    = cmn_class_init,
    .instance_init = cmn_init,
};

static void cmn_register_types(void)
{
    type_register_static(&cmn_info);
}

type_init(cmn_register_types)
